/**
 * @license
 * Copyright 2019 The Emscripten Authors
 * SPDX-License-Identifier: MIT
 */

// wasm2js.js - enough of a polyfill for the WebAssembly object so that we can load
// wasm2js code that way.

// Emit "var WebAssembly" if definitely using wasm2js. Otherwise, in MAYBE_WASM2JS
// mode, we can't use a "var" since it would prevent normal wasm from working.
/** @suppress{duplicate, const} */
var
WebAssembly = {
  // Note that we do not use closure quoting (this['buffer'], etc.) on these
  // functions, as they are just meant for internal use. In other words, this is
  // not a fully general polyfill.
  /** @constructor */
  Memory: function(opts) {
    this.buffer = new ArrayBuffer(opts['initial'] * 65536);
  },

  Module: function(binary) {
    // TODO: use the binary and info somehow - right now the wasm2js output is embedded in
    // the main JS
  },

  /** @constructor */
  Instance: function(module, info) {
    // TODO: use the module and info somehow - right now the wasm2js output is embedded in
    // the main JS
    // This will be replaced by the actual wasm2js code.
    this.exports = (
// EMSCRIPTEN_START_ASM
function instantiate(yb){function c(d){d.set=function(a,b){this[a]=b};d.get=function(a){return this[a]};return d}var e;var f=new ArrayBuffer(16);var g=new Int32Array(f);var h=new Float32Array(f);var i=new Float64Array(f);function j(k){return g[k]}function l(k,m){g[k]=m}function n(){return i[0]}function o(m){i[0]=m}function p(m){h[2]=m}function q(){return h[2]}function wb(xb){var r=xb.a;var s=r.buffer;r.grow=ub;var t=new Int8Array(s);var u=new Int16Array(s);var v=new Int32Array(s);var w=new Uint8Array(s);var x=new Uint16Array(s);var y=new Uint32Array(s);var z=new Float32Array(s);var A=new Float64Array(s);var B=Math.imul;var C=Math.fround;var D=Math.abs;var E=Math.clz32;var F=Math.min;var G=Math.max;var H=Math.floor;var I=Math.ceil;var J=Math.trunc;var K=Math.sqrt;var L=xb.abort;var M=NaN;var N=Infinity;var O=xb.b;var P=xb.c;var Q=xb.d;var R=xb.e;var S=xb.f;var T=xb.g;var U=xb.h;var V=xb.i;var W=xb.j;var X=xb.k;var Y=xb.l;var Z=xb.m;var _=xb.n;var $=xb.o;var aa=xb.p;var ba=xb.q;var ca=xb.r;var da=xb.s;var ea=xb.t;var fa=xb.u;var ga=xb.v;var ha=xb.w;var ia=xb.x;var ja=xb.y;var ka=xb.z;var la=xb.A;var ma=xb.B;var na=xb.C;var oa=xb.D;var pa=xb.E;var qa=xb.F;var ra=xb.G;var sa=xb.H;var ta=xb.I;var ua=xb.J;var va=xb.K;var wa=xb.L;var xa=xb.M;var ya=xb.N;var za=xb.O;var Aa=xb.P;var Ba=xb.Q;var Ca=xb.R;var Da=xb.S;var Ea=xb.T;var Fa=xb.U;var Ga=xb.V;var Ha=xb.W;var Ia=xb.X;var Ja=xb.Y;var Ka=xb.Z;var La=xb._;var Ma=xb.$;var Na=xb.aa;var Oa=xb.ba;var Pa=xb.ca;var Qa=xb.da;var Ra=xb.ea;var Sa=xb.fa;var Ta=xb.ga;var Ua=xb.ha;var Va=xb.ia;var Wa=xb.ja;var Xa=xb.ka;var Ya=xb.la;var Za=xb.ma;var _a=xb.na;var $a=xb.oa;var ab=xb.pa;var bb=xb.qa;var cb=xb.ra;var db=xb.sa;var eb=xb.ta;var fb=xb.ua;var gb=xb.va;var hb=xb.wa;var ib=xb.xa;var jb=xb.ya;var kb=5712816;var lb=0;var mb=0;var nb=0;
// EMSCRIPTEN_START_FUNCS
function zJ(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,A=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,M=0,N=0,Q=0,R=0,S=0,V=0,W=C(0),X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=C(0),Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=C(0),_a=0;da=kb-32|0;kb=da;e=da+24|0;v[e>>2]=49596;v[e>>2]=49496;g=yJ(da+16|0);h=yJ(da+8|0);fa=b;la=c;ma=e;na=v[g>>2];Ea=w[g+4|0];oa=v[h>>2];Fa=w[h+4|0];c=0;M=kb-112|0;kb=M;d=a;pa=a+24604|0;a=pa;a:{if(!v[a+16>>2]){break a}b=v[a+20>>2];if(b>>>0>4|!(1<<b&22)){break a}a=v[a+28>>2];if(a>>>0>4){break a}c=23>>>a&1}if(!c){c=M+96|0;OM(c,9162,12991,220,45);a=kb-48|0;kb=a;b=yc(a+16|0,17787);v[23540]=0;U(5,a|0,1,17450);e=v[23540];v[23540]=0;b:{c:{d:{e:{if((e|0)!=1){v[23540]=0;U(2,a+32|0,b|0,a|0);e=v[23540];v[23540]=0;if((e|0)==1){break e}v[23540]=0;U(843,c|0,1,a+32|0);c=v[23540];v[23540]=0;if((c|0)!=1){break b}c=P()|0;O()|0;Ab(a+32|0);break d}c=P()|0;O()|0;break c}c=P()|0;O()|0}Ab(a)}Ab(b);T(c|0);L()}Ab(a+32|0);Ab(a);Ab(b);kb=a+48|0}qa=d+8204|0;ra=d+397452|0;sa=d+397448|0;aa=d+393352|0;H=d+397456|0;_=d+12|0;Ga=d+1074376|0;Ha=d+1298420|0;Ia=d+1074365|0;while(1){f:{g:{a=v[d+480208>>2];if(!(!fa|a&512)){h:{if(v[d+1074380>>2]){break h}b=a|512;i:{if(a&256){break i}j=kb-48|0;kb=j;F=kb-32|0;kb=F;k=d+1074312|0;e=d+1074992|0;h=d+1298264|0;s=d+1074424|0;o=d+484360|0;n=d+1074448|0;m=d+1074376|0;b=v[d+1074392>>2];r=d+480188|0;A=d+480180|0;q=d+484376|0;p=d+484348|0;G=d+480210|0;E=d+484364|0;j:{k:{l:while(1){m:{a=b+1|0;v[d+1074392>>2]=a;if(il(m)>>>0>a>>>0){break m}cO(F+24|0,v[A>>2],x[r>>1],m,(v[d+480208>>2]&524288)>>>19|0);n:{o:{p:{q:{r:{if(w[d+480208|0]&32){l=v[p>>2];c=v[d+484344>>2];b=x[d+1074446>>1];break r}b=65535;J=v[d+484360>>2];i=w[q|0];a=Wb(J,i);c=v[a>>2];a=Rc(c,v[a+4>>2]);f=x[d+1074448>>1];if(a>>>0>f>>>0){b=x[cc(c,f)>>1]}u[d+1074446>>1]=b;s:{t:{c=v[d+484344>>2];l=v[p>>2];a=b&65535;if(Af(c,l)>>>0<=a>>>0){break t}a=_b(c,a);if(Pb(v[a>>2],v[a+4>>2])){break t}a=0;break s}a=1}while(1){u:{v:{if(!a){b=65534;u[d+1074446>>1]=65534;break v}w:{x:{y:{a=b&65535;if(Af(c,l)>>>0<=a>>>0){z:{A:{if((a|0)==65535){g=Wb(J,i);break A}g=Wb(J,i);if(Rc(v[g>>2],v[g+4>>2])>>>0>(f&65535)>>>0){break z}}b=x[g+28>>1];if(b){c=v[g>>2];l=Rc(c,v[g+4>>2]);break x}a=f&65535;c=v[g>>2];l=Rc(c,v[g+4>>2]);if(!a|l>>>0<a>>>0){break y}while(1){b=a;a=a-1|0;if(!a){break y}if(x[cc(c,a)>>1]!=65535){continue}break}break x}f=f+1|0;u[n>>1]=f;break w}u[d+1074450>>1]=f;break r}b=0}u[d+1074448>>1]=b;v[d+480208>>2]=v[d+480208>>2]&-524289;while(1){a=b&65535;if(a>>>0>=l>>>0){break q}if(x[cc(c,a)>>1]==65534){b=b+1|0;u[n>>1]=b;continue}break}if(!Jq(g,a)){break q}f=x[d+1074448>>1];J=v[d+484360>>2];i=w[q|0];g=Wb(J,i)}b=65535;a=f&65535;if(Rc(v[g>>2],v[g+4>>2])>>>0>a>>>0){b=x[cc(v[Wb(J,i)>>2],a)>>1]}u[d+1074446>>1]=b;c=v[d+484344>>2];l=v[p>>2];a=b&65535;if(Af(c,l)>>>0<=a>>>0){break v}a=_b(c,a);if(!Pb(v[a>>2],v[a+4>>2])){break u}}a=1;continue}a=0;continue}}a=b&65535;if(!xe(c,l,a)){break k}b=v[s>>2];if(b>>>0>=y[_b(c,a)+12>>2]){v[s>>2]=0;b=0}if(v[d+480208>>2]&32?v[d+480272>>2]!=-1:0){break n}if(!qt(h,x[n>>1],b,Yp(F+16|0,e),w[F+24|0])){break n}a=v[d+480272>>2];if(a){if((a|0)>0){v[d+480272>>2]=a-1}bo(h,1);qt(h,x[n>>1],v[s>>2],Yp(F+16|0,e),w[F+24|0]);break n}if(!(w[G|0]&64)){break q}b=0;if(oO(h,n,s)){break o}v[d+1074424>>2]=0;v[d+1074428>>2]=0;v[d+1074448>>2]=0;c=sj(v[d+484360>>2],v[E>>2])-1|0;a=w[q|0];if((c|0)>(a|0)){break p}Gj(o,0)}bo(h,1);break k}Gj(o,a+1&255);bo(h,1)}while(1){if((b|0)==256){EM(d);v[d+1074416>>2]=v[d+480196>>2];v[d+1074420>>2]=v[d+480204>>2];v[d+1074456>>2]=v[d+480200>>2];a=x[d+1074448>>1];u[d+1074450>>1]=a;b=v[d+1074424>>2];v[d+1074428>>2]=b;c=Wb(v[d+484360>>2],w[q|0]);g=v[c>>2];if(Rc(g,v[c+4>>2])>>>0>a>>>0){Xa=d,Ya=x[cc(g,a)>>1],u[Xa+1074446>>1]=Ya}qt(h,a,b,Yp(F+16|0,e),w[F+24|0]);if(!xe(v[d+484344>>2],v[p>>2],x[d+1074446>>1])){break k}}else{go((B(b,872)+d|0)+1074992|0,d,b&65535,134217728);b=b+1|0;continue}break}}bO(d,m,(v[d+480208>>2]&32)>>>5|0);a=_b(v[d+484344>>2],x[d+1074446>>1]);a=jd(v[a>>2],v[v[a+48>>2]+12>>2],v[d+1074424>>2],0);g=e+B(x[r>>1],872)|0;b=e;while(1){if((b|0)==(g|0)){B:{C:{a=v[d+484344>>2];b=x[d+1074446>>1];if(Sm(a,v[d+484348>>2],b)){a=_b(a,b);b=v[a+16>>2];a=v[a+20>>2];if(_N(b,a)){break C}}v[d+1074408>>2]=v[d+480216>>2];a=v[d+480220>>2];break B}v[d+1074408>>2]=b}v[d+1074412>>2]=a;if(!w[F+24|0]){break m}b=v[d+1074416>>2];v[d+1074392>>2]=b;continue l}Db(F+16|0,k,82);D:{if(!Cb(v[v[F+16>>2]>>2],v[F+20>>2])|w[b+805|0]!=1){break D}c=w[a+3|0];if((c|0)!=2&(c|0)!=3){break D}Xa=b,Ya=eh(d,w[b+800|0],u[b+772>>1],v[b+704>>2]),v[Xa+700>>2]=Ya}Db(F+16|0,k,91);E:{if(!Cb(v[v[F+16>>2]>>2],v[F+20>>2])){break E}if($c(w[a|0])){break E}c=w[b+788|0];if(!$c(c)|w[b+791|0]!=19){break E}f=w[b+793|0];if((f&240)!=208|y[d+1074416>>2]>(f&15)>>>0){break E}Xa=b,Ya=eh(d,c,u[b+772>>1],0),v[Xa+700>>2]=Ya}Db(F+16|0,k,92);F:{if(!Cb(v[v[F+16>>2]>>2],v[F+20>>2])){break F}Db(F+8|0,k,5);if(Cb(v[v[F+8>>2]>>2],v[F+12>>2])|v[d+1074416>>2]!=1|w[b+791|0]!=17){break F}v[d+1074420>>2]=B(w[b+793|0],1e4)}c=w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24);t[b+788|0]=c;t[b+789|0]=c>>>8;t[b+790|0]=c>>>16;t[b+791|0]=c>>>24;c=w[a+4|0]|w[a+5|0]<<8;t[b+792|0]=c;t[b+793|0]=c>>>8;c=v[b+676>>2];v[b+20>>2]=v[b+672>>2];v[b+24>>2]=c;v[b+88>>2]=v[b+88>>2]&-393217;Db(F+16|0,k,21);if(!Cb(v[v[F+16>>2]>>2],v[F+20>>2])){t[b+831|0]=0}v[b+860>>2]=0;t[b+805|0]=0;a=a+6|0;b=b+872|0;continue}}break}a=v[d+1074416>>2];if(!a){v[d+1074416>>2]=1;a=1}b=v[d+480208>>2];e=v[d+1074392>>2];G:{H:{if(e){c=b&-4097;v[d+480208>>2]=c;g=v[d+480180>>2];if(g&1048580|(b&2097152?0:(g|0)==1)){break G}if(il(m)>>>0<=e>>>0){break G}if(!((e>>>0)%(v[d+1074400>>2]+a>>>0)|0)){break H}break G}c=b&-528385}v[d+480208>>2]=c|4096}q=0;i=kb-16|0;kb=i;u[d+1074444>>1]=65535;a=d+1074436|0;v[a>>2]=-1;v[a+4>>2]=-1;A=d+480180|0;$=d+1075809|0;o=d+1074312|0;Z=d+906300|0;G=d+480208|0;I=d+1074376|0;Y=d+480188|0;ba=d+480210|0;V=d+480190|0;Q=d+480192|0;while(1){I:{if(x[Y>>1]<=q>>>0){J:{if(!(w[G+1|0]&16)){break J}if(!TN(d,I,Wb(v[d+484360>>2],w[d+484376|0]),1)){break J}v[G>>2]=v[G>>2]|524288}kb=i+16|0;break I}p=B(q,872)+d|0;k=p+1075785|0;c=w[k|0];l=p+1075784|0;r=w[l|0];R=p+1075781|0;e=w[R|0];a=v[d+1074392>>2];b=v[d+1074400>>2];h=v[d+1074416>>2];X=p+1075782|0;f=w[X|0];s=p+1075783|0;J=w[s|0];g=vm(f,J);n=p+1075843|0;t[n|0]=v[G>>2]>>>12&1|w[n|0]&254;h=(a>>>0)%(b+h>>>0)|0;N=p+1075780|0;a=w[N|0];K:{L:{M:{if((a|0)==252){m=ik(f,r);E=ik(J,c);a=252;b=e-1|0;if((b&255)>>>0>249){break M}b=v[Md(Z,b)>>2];if(!b){break M}ob[v[v[b>>2]+44>>2]](b,m,C(C(E>>>0)/C(999)));a=w[N|0]}if((a&255)==251){break L}}if(z[p+1075852>>2]==C(0)|J){break K}}m=v[G>>2]&4096;N:{if(!m){b=w[p+1075862|0];break N}b=w[R|0];t[p+1075862|0]=b}if((b-1&255)>>>0>249){break K}E=Md(Z,(b&255)-1|0);b=v[E>>2];if(!b){break K}O:{if(!m){a=x[p+1075860>>1];break O}a=Wy(w[X|0],w[l|0]);u[p+1075860>>1]=a;W=C(C(Wy(w[s|0],w[k|0])>>>0)/C(999));z[p+1075856>>2]=W;Xa=p+1075852|0,Za=C(C(W-C(ob[v[v[b>>2]+48>>2]](b,a)))/C(il(I)>>>0)),z[Xa>>2]=Za;b=v[E>>2]}k=a;a=(v[d+1074392>>2]+1|0)==(il(I)|0);ob[v[v[b>>2]+(a?44:108)>>2]](b,k,z[(a?p+1075856|0:p+1075852|0)>>2]);a=w[N|0]}k=p+1074992|0;if(JN(a&255)){b=kb-16|0;kb=b;u[b+12>>1]=0;v[b+8>>2]=0;a=ug(b+8|0);c=w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24);t[k+788|0]=c;t[k+789|0]=c>>>8;t[k+790|0]=c>>>16;t[k+791|0]=c>>>24;a=w[a+4|0]|w[a+5|0]<<8;t[k+792|0]=a;t[k+793|0]=a>>>8;kb=b+16|0;g=0;J=0;r=0;f=0;e=0;c=0}P:{if(!(w[G+1|0]&16)){iN(d,k);break P}if(!e){break P}v[p+1075752>>2]=0}Q:{R:{if((J|0)==33){Db(i+8|0,o,30);a=c>>>4|0;Hy(d,q&65535,a+(c&15)|0,Cb(v[v[i+8>>2]>>2],v[i+12>>2]));break R}a=0;if((J-19&255)>>>0>1){break R}S:{if(!(!(v[A>>2]&16777250)|c)){c=w[p+1075825|0];break S}t[p+1075825|0]=c}b=c&240;if((b|0)==208){b=c&15;if(!b){b=v[A>>2];if(b&16777248){a=1;break R}if((b|0)==2){break Q}break R}if(b>>>0>=v[d+1074400>>2]+v[d+1074416>>2]>>>0){Db(i+8|0,o,14);a=b;if(!Cb(v[v[i+8>>2]>>2],v[i+12>>2])){break R}if(!e){break Q}t[p+1075795|0]=e;break Q}a=b;break R}if(!(w[G+1|0]&16)|(b|0)!=224){break R}b=v[A>>2];if(v[d+1074396>>2]?b&16777250:0){break R}m=b&2;b=c&15;if(b?0:m){break R}v[d+1074396>>2]=b+1}b=v[A>>2]==16&(J|0)==19&(c&240)==208;E=b?0:a;T:{if(!E|w[N|0]!=255|w[X|0]!=2){break T}Db(i+8|0,o,74);if(!Cb(v[v[i+8>>2]>>2],v[i+12>>2])){break T}t[X|0]=0}K=c&15;a=v[d+1074392>>2];Db(i+8|0,o,72);U:{if(Cb(v[v[i+8>>2]>>2],v[i+12>>2])){s=0;if(E>>>0>=y[d+1074416>>2]){break U}}Db(i+8|0,o,88);s=(h|0)==(E|0)|(a|0)==(E|0);if(!(!Cb(v[v[i+8>>2]>>2],v[i+12>>2])|!E)){break U}s=(a|0)==(E|0)}Db(i+8|0,o,44);b=b?K|144:c;V:{if(!Cb(v[v[i+8>>2]>>2],v[i+12>>2])){a=w[n|0];break V}a=w[n|0]&-2|(h|0)==(E|0)}t[n|0]=a&253|(s?2:0);Db(i+8|0,o,66);g=(!E|Cb(v[v[i+8>>2]>>2],v[i+12>>2])^1)&g;W:{X:{if(!(v[d+1074392>>2]|(!(w[ba|0]&32)|!e))){v[p+1075652>>2]=0;if(s){break X}if(!Ai(v[k+8>>2],v[k+12>>2])){break W}t[p+1075795|0]=e;if(x[V>>1]<e>>>0){break W}a=B(e,104)+d|0;v[p+1075680>>2]=x[a+484410>>1];u[p+1075764>>1]=t[a+484417|0];break W}if(!s){break W}}c=w[N|0];if(e){t[p+1075795|0]=e}Y:{Z:{if(!$c(c)){break Z}Db(i+8|0,o,67);if(!Cb(v[v[i+8>>2]>>2],v[i+12>>2])){break Z}a=u[p+1075762>>1];_:{if(!e|g){break _}h=xq(d,c,e);if(!h){break _}a=t[Hi(d,h)+36|0]}c=(a+c|0)-132>>>0<4294967176?0:c;break Y}if(!(v[A>>2]&25165856)){break Y}l=x[Q>>1];if(!l){break Y}if(c){a=$c(c)}else{a=1}if(!a){break Y}h=e;$:{if(!e){h=w[p+1075796|0];if(!h){break $}}if(v[((h<<2)+d|0)+900380>>2]?h>>>0<=l>>>0:0){break Y}c=0}e=0}if(!((J|0)!=25|b)){Db(i+8|0,o,55);a=Cb(v[v[i+8>>2]>>2],v[i+12>>2]);e=a?0:e;c=a?0:c}Db(i+8|0,o,65);a=(e|0)!=0;l=Cb(v[v[i+8>>2]>>2],v[i+12>>2]);ca=!c;S=1;aa:{if(v[A>>2]&16777248){break aa}Db(i+8|0,o,107);if(Cb(v[v[i+8>>2]>>2],v[i+12>>2])){break aa}Db(i,o,85);S=0;if(!Cb(v[v[i>>2]>>2],v[i+4>>2])){break aa}if(Ai(v[k+8>>2],v[k+12>>2])){break aa}S=1;h=v[p+1075096>>2];if(!h){break aa}S=_d(v[h>>2],v[h+20>>2])^1}m=a&l;a=a&ca;ba:{ca:{da:{ea:{fa:{ga:{ha:{if(!(v[A>>2]&1048580)){break ha}ia:{if((c|0)!=255){break ia}if(!(!((f|0)==1|e)&(J|0)!=13)){Db(i+8|0,o,55);if(Cb(v[v[i+8>>2]>>2],v[i+12>>2])){break ia}}h=v[p+1075648>>2];if(t[h+60|0]&1?h:0){break ia}v[p+1075680>>2]=0;a=p+1075080|0;v[a>>2]=v[a>>2]|2097152;ja:{if(!(v[G>>2]&4096)){break ja}Db(i+8|0,o,86);if(!Cb(v[v[i+8>>2]>>2],v[i+12>>2])){break ja}v[a>>2]=v[a>>2]|4096}e=0;c=0;a=0;h=0;l=1;if(m){break ca}break ba}Db(i+8|0,o,59);if(!Cb(v[v[i+8>>2]>>2],v[i+12>>2])|v[G>>2]&4096){break ha}if(!c){c=w[p+1075789|0]-w[p+1075762|0]|0;break ga}if(c>>>0>250){S=0;m=1;c=0;break ga}if(!e){Db(i+8|0,o,98);if(Cb(v[v[i+8>>2]>>2],v[i+12>>2])){break ga}}S=1;m=1;break ga}h=0;if(!a){break ea}break fa}h=c;g=0}Db(i+8|0,o,65);if(!Cb(v[v[i+8>>2]>>2],v[i+12>>2])){break da}c=h;h=1}a=c;l=1;if(m){break ca}break ba}c=h;h=1;l=m}ka:{la:{if(!x[Q>>1]){if(x[V>>1]<e>>>0){break ka}a=(B(e,104)+d|0)+484380|0;break la}a=v[p+1075096>>2];if(!a){break ka}}ma:{if(u[a+34>>1]<0){break ma}if(v[A>>2]==2){if(!_d(v[a>>2],v[a+20>>2])){break ma}}v[p+1075680>>2]=x[a+30>>1]}if(!l){break ka}eq(k,x[a+28>>1],d)}a=c}Db(i+8|0,o,71);if(!(!Cb(v[v[i+8>>2]>>2],v[i+12>>2])|!e)){t[p+1075831|0]=32}na:{if(!x[Q>>1]){break na}Db(i+8|0,o,100);if(!Cb(v[v[i+8>>2]>>2],v[i+12>>2])|!e){break na}if($c(a&255)){break na}c=v[G>>2];oa:{if(g){if(c&8){break oa}break na}if(!(c&4)){break na}}tm(k);v[p+1075688>>2]=65536;c=p+1075080|0;v[c>>2]=v[c>>2]|2097152}if(h){Db(i+8|0,o,11);pa:{qa:{ra:{if(!(Cb(v[v[i+8>>2]>>2],v[i+12>>2])|v[A>>2]==268435456)){c=x[Q>>1];break ra}Db(i+8|0,o,87);h=0;if(Cb(v[v[i+8>>2]>>2],v[i+12>>2])){h=Ai(v[k+8>>2],v[k+12>>2])^1}c=x[Q>>1];sa:{if(c){if(c>>>0<e>>>0){break qa}if(v[p+1075648>>2]!=v[((e<<2)+d|0)+900380>>2]|h){break sa}break qa}if((h^-1)&v[p+1075096>>2]==((B(e,104)+d|0)+484380|0)){break pa}}a=w[p+1075789|0]}if(!(c&65535)){break pa}}if(!(v[A>>2]&1048588)){break pa}tm(k);t[p+1075810|0]=0;v[p+1075748>>2]=0;v[p+1075688>>2]=65536;c=p+1075080|0;v[c>>2]=v[c>>2]&-2101249|2097152;Db(i+8|0,o,86);if(!Cb(v[v[i+8>>2]>>2],v[i+12>>2])){break pa}v[c>>2]=v[c>>2]&-2049}e=S?e:0}l=a&255;ta:{if(l>>>0<251){break ta}Db(i+8|0,o,50);ua:{if(!Cb(v[v[i+8>>2]>>2],v[i+12>>2])|!e){break ua}c=xq(d,w[p+1075791|0],e);if(!c){break ua}c=B(c,104)+d|0;if(u[c+484414>>1]<0){break ua}v[p+1075680>>2]=x[c+484410>>1]}Db(i+8|0,o,100);if(Xa=Cb(v[v[i+8>>2]>>2],v[i+12>>2]),Ya=0,_a=v[G>>2]&4,_a?Xa:Ya){break ta}e=0}c=$c(l);if(c){t[p+1075794|0]=a;t[p+1075791|0]=a;if(!g){jN(d,q&65535,e,l,0)}zP(k)}va:{wa:{xa:{ya:{za:{if(e){h=p+1075096|0;m=v[h>>2];Xp(d,k,e,g,1,1);a=v[h>>2];Aa:{if(!a|!(w[a+35|0]&2)){break Aa}S=v[d+1298300>>2];if(!zd(S)){break Aa}sz(S,q&65535,a+68|0)}Ba:{Ca:{if(v[A>>2]==1){if(!g){break Ca}Db(i+8|0,o,85);if(!Cb(v[v[i+8>>2]>>2],v[i+12>>2])){break Ca}break Ba}Db(i+8|0,o,50);if((c|Cb(v[v[i+8>>2]>>2],v[i+12>>2])^1)!=1){break Ba}}t[p+1075795|0]=0}Db(i+8|0,o,42);if(Cb(v[v[i+8>>2]>>2],v[i+12>>2])){if(!c|(m|0)==v[h>>2]){break ya}break za}if(v[A>>2]&16777248){a=0;if(c&(m|0)!=v[h>>2]){break xa}}Db(i+8|0,o,107);Da:{if(!Cb(v[v[i+8>>2]>>2],v[i+12>>2])|(m|0)==v[h>>2]){break Da}if((c^1|g)==1){a=p+1075068|0;if(y[a>>2]>=y[k+4>>2]){break Da}v[a>>2]=0;break ya}g=0}Db(i+8|0,o,85);if(!Cb(v[v[i+8>>2]>>2],v[i+12>>2])){break ya}if(!Ai(v[k+8>>2],v[k+12>>2])){break za}break ya}if(!l){a=g;break va}h=0;m=p+1075795|0;a=w[m|0];if(!(!a|c^1)){Xp(d,k,a,g,!(v[p+1075096>>2]?1:v[p+1075648>>2]),!(v[A>>2]&1048580));t[m|0]=0;h=1}a=g;break wa}v[k>>2]=0;v[k+4>>2]=0}a=g}h=0;if(!l){break va}}c=v[p+1075096>>2];Ea:{if(!c|!(w[c+35|0]&2)){break Ea}g=v[d+1298300>>2];if(!zd(g)){break Ea}if(!h){if(kN(g,q&65535)){break Ea}}sz(g,q&65535,c+68|0)}c=q&65535;lt(d,k,l,a,!(v[A>>2]&1048580),0,c);YN(v[A>>2],x[Y>>1],I,c);if(!(!a|(!(v[A>>2]&1048580)|!e))){e=p+1075080|0;v[e>>2]=v[e>>2]|2097152;tm(k);t[p+1075810|0]=0;v[p+1075748>>2]=0}if(!(v[p+1075080>>2]&512)){break va}if(!zd(v[d+1298300>>2])){break va}if(l>>>0<=253){if((l|0)!=253){break va}Db(i+8|0,o,99);if(Cb(v[v[i+8>>2]>>2],v[i+12>>2])){break va}}Db(i+8|0,o,110);if(Cb(v[v[i+8>>2]>>2],v[i+12>>2])){tz(v[d+1298300>>2],c,0,1,0)}jk(v[d+1298300>>2],c)}Fa:{Ga:{switch(f-1|0){case 0:r=r>>>0<64?r:64;v[p+1075680>>2]=r<<2;c=p+1075080|0;v[c>>2]=v[c>>2]|2097152;break Fa;case 1:break Ga;default:break Fa}}um(d,k,r,6)}if(x[Q>>1]){hN(d,q&65535)}g=a}Db(i+8|0,o,77);if(Xa=Cb(v[v[i+8>>2]>>2],v[i+12>>2]),Ya=0,_a=v[((q<<5)+d|0)+480280>>2]&1024,_a?Xa:Ya){break Q}a=v[d+1074392>>2];Db(i+8|0,o,75);e=a>>>0>=E>>>0;Ha:{Ia:{Ja:{Ka:{if(!Cb(v[v[i+8>>2]>>2],v[i+12>>2])|!E){break Ka}c=v[d+1074392>>2];if(!c){break Ja}e=1;if((c|0)!=(E|0)){break Ka}e=!w[R|0]&(f|0)!=11}a=f;if(!e|a>>>0<3){break Ja}if((a|0)==11){a=i+8|0;_y(a,d,w[N+3|0],w[N+4|0],E);a=w[Te(a)|0];Gy(d,q&65535,x[i+8>>1]);if(a){break Ia}f=11;break Ja}Db(i+8|0,o,62);La:{Ma:{Na:{Oa:{Pa:{Qa:{Ra:{if(!(!Cb(v[v[i+8>>2]>>2],v[i+12>>2])|r)){r=0;f=0;Sa:{switch(a-8|0){case 0:break Ra;case 1:break Sa;default:break Ja}}if(w[G+1|0]&16){break Ja}v[p+1075684>>2]=0;break Ja}Db(i+8|0,o,41);Ta:{if(Cb(v[v[i+8>>2]>>2],v[i+12>>2])){break Ta}if(r){t[p+1075826|0]=r;break Ta}r=w[p+1075826|0]}Ua:{switch(a-3|0){case 0:case 1:Va:{Wa:{if(r){break Wa}Db(i+8|0,o,41);if(!Cb(v[v[i+8>>2]>>2],v[i+12>>2])){break Wa}r=w[p+1075826|0];if(r){break Va}r=0;break Ja}t[p+1075826|0]=r}_n(d,k,((a|0)==3?r<<4:r)&255);break Ja;case 2:if((E|0)!=v[d+1074392>>2]){Db(i+8|0,o,41);f=5;if(Cb(v[v[i+8>>2]>>2],v[i+12>>2])){break Ja}}Db(i+8|0,o,41);Zn(d,k,r,Cb(v[v[i+8>>2]>>2],v[i+12>>2]));f=5;break Ja;case 3:if((E|0)!=v[d+1074392>>2]){Db(i+8|0,o,41);f=6;if(Cb(v[v[i+8>>2]>>2],v[i+12>>2])){break Ja}}Db(i+8|0,o,41);Yn(d,k,r,Cb(v[v[i+8>>2]>>2],v[i+12>>2]));f=6;break Ja;case 11:break La;case 12:break Ma;case 10:break Na;case 9:break Oa;case 7:break Pa;case 6:break Qa;case 5:break Ra;case 4:break Ua;default:break Ja}}Db(i+8|0,o,53);if(Cb(v[v[i+8>>2]>>2],v[i+12>>2])){t[p+1075815|0]=r&15;f=7;break Ja}hl(k,r<<4);f=7;break Ja}hl(k,r);f=8;break Ja}Db(i+8|0,o,62);Fy(d,k,r,Cb(v[v[i+8>>2]>>2],v[i+12>>2])^1);f=9;break Ja}Db(i+8|0,o,62);Fy(d,k,r<<4&240,Cb(v[v[i+8>>2]>>2],v[i+12>>2])^1);f=10;break Ja}f=12;Db(i+8|0,o,12);gN(d,q&65535,r<<2&252,Cb(v[v[i+8>>2]>>2],v[i+12>>2]));break Ja}Db(i+8|0,o,12);fN(d,q&65535,r<<2&252,Cb(v[v[i+8>>2]>>2],v[i+12>>2]));f=13;break Ja}f=15;if(!s){break Ja}a=v[p+1075096>>2];if(!a|r>>>0>9){break Ja}Xa:{if(!r){e=v[p+1075656>>2];break Xa}e=v[Eb(a+68|0,r-1|0)>>2];v[p+1075656>>2]=e}$n(d,k,e);break Ja}f=14;if(r>>>0>1){break Ja}t[n|0]=w[n|0]&247|!r<<3}e=b;Ya:{Za:{_a:{switch(J-1|0){case 12:if(!(w[G+1|0]&16)){break Ia}a=B(q,872)+d|0;v[a+1075680>>2]=b>>>0<64?b<<2:256;a=a+1075080|0;v[a>>2]=v[a>>2]|2097152;break Ia;case 1:if(!b){e=0;if(t[A|0]&1){break Ha}}gN(d,q&65535,b,0);break Ia;case 2:if(!b){e=0;if(t[A|0]&1){break Ha}}fN(d,q&65535,b,0);break Ia;case 10:if(!b){e=0;if(v[A>>2]==1){break Ha}}_n(d,k,b);break Ia;case 3:Gy(d,q&65535,b);break Ia;case 5:if(!(!b&v[A>>2]==1)){_n(d,k,b)}Gy(d,q&65535,0);break Ia;case 4:hl(k,b);break Ia;case 6:if(!(!b&v[A>>2]==1)){_n(d,k,b)}hl(k,0);break Ia;case 15:if(!(w[G+1|0]&16)){break Ia}break Ya;case 16:Db(i+8|0,o,5);if(Cb(v[v[i+8>>2]>>2],v[i+12>>2])){if(!(w[G+1|0]&16)|!b){break Ia}break Ya}e=Xn(d,x[d+1074446>>1],v[d+1074424>>2],q&65535,0);$a:{if(!(v[d+480180>>2]&16777250)){break $a}if(e){t[(B(q,872)+d|0)+1075827|0]=e;break $a}e=w[(B(q,872)+d|0)+1075827|0]}v[i+8>>2]=B(e,1e4);xc(i+8|0,B(v[v[d+8>>2]+24>>2],1e4));a=kb-16|0;kb=a;c=v[i+8>>2];v[a+8>>2]=c;b=v[d+8>>2];ab:{if(c>>>0>=(v[d+480180>>2]&16393?1e4:32e4)>>>0){c=v[d+480208>>2];Db(a,d+1074312|0,92);if((Cb(v[v[a>>2]>>2],v[a+4>>2])|0)==((c&4096)>>>12|0)){break ab}v[a>>2]=B(v[b+24>>2],1e4);Xa=d+1074420|0,Ya=v[Kb(a+8|0,a)>>2],v[Xa>>2]=Ya;break ab}if(w[d+480209|0]&16){break ab}g=d+1074420|0;c=(c>>>0)/1e4|0;h=B(c&15,1e4);v[g>>2]=v[g>>2]+((c&240)==16?h:0-h|0);c=v[b+20>>2];b=v[b+24>>2];Db(a,d+1074312|0,8);So(g,B(c,1e4),Cb(v[v[a>>2]>>2],v[a+4>>2])?255e4:B(b,1e4))}kb=a+16|0;break Ha;case 9:if(!s|v[A>>2]==4&g){break Ia}XN(d,k,q&65535,v[d+1074424>>2],x[d+1074446>>1]);break Ia;case 43:if(!s){break Ia}c=Jka(v[(B(q,872)+d|0)+1075068>>2],0,b,0);a=nb;f=a>>>8|0;$n(d,k,Ec((a&255)<<24|c>>>8,f));break Ia;case 0:if(v[d+1074392>>2]){break Ia}a=B(q,872)+d|0;bb:{if(w[a+1075789|0]?v[a+1075692>>2]:0){break bb}a=v[a+1075648>>2];if(a){if(vj(w[a+31|0])){break bb}}Db(i+8|0,o,13);if(Cb(v[v[i+8>>2]>>2],v[i+12>>2])){break bb}if(v[A>>2]&16777248){break Ia}}if(!b){e=0;if(w[A|0]&5){break Ha}t[(B(q,872)+d|0)+1075797|0]=1;break Ha}a=B(q,872)+d|0;t[a+1075798|0]=b;t[a+1075797|0]=1;break Ia;case 14:if(v[A>>2]&1048580){b=b&240?b:w[(B(q,872)+d|0)+1075799|0]&240|b;if(!(b&15)){b=w[(B(q,872)+d|0)+1075799|0]&15|b}b=b|256}e=b;Db(i+8|0,o,23);if(Cb(v[v[i+8>>2]>>2],v[i+12>>2])){b=d;c=q&65535;if(e){t[(B(q,872)+d|0)+1075799|0]=e;a=e}else{a=w[(B(q,872)+d|0)+1075799|0]}Ey(b,c,a&255,(f|0)==15?r+1|0:0);break Ha}cb:{if(e){t[(B(q,872)+d|0)+1075799|0]=e;break cb}e=w[(B(q,872)+d|0)+1075799|0]}Ey(d,q&65535,e,(f|0)==15?r+1|0:0);break Ha;case 17:if(!(w[G+1|0]&16)){break Ia}Db(i+8|0,o,22);db:{eb:{if(Cb(v[v[i+8>>2]>>2],v[i+12>>2])){if(!b){b=0;break eb}if(w[G|0]&4){break eb}a=b&240?b-16|0:b;b=a-((a&15)!=0)|0;t[(B(q,872)+d|0)+1075832|0]=b;break eb}Db(i+8|0,o,71);if(!Cb(v[v[i+8>>2]>>2],v[i+12>>2])){break db}}a=(B(q,872)+d|0)+1075831|0;t[a|0]=w[a|0]|128}a=B(q,872)+d|0;t[a+1075797|0]=18;if(!b){e=0;break Ha}t[a+1075832|0]=b;break Ia;case 22:if(!(w[G+1|0]&16)){break Ia}a=v[A>>2];e=b<<!(a&59593760);if(e>>>0<=128){v[d+1074456>>2]=e<<1;break Ha}if(a&16777250){break Ha}v[d+1074456>>2]=256;break Ha;case 23:Db(i+8|0,o,9);if(Cb(v[v[i+8>>2]>>2],v[i+12>>2])){eN(d,b,(B(q,872)+d|0)+1075809|0);break Ia}eN(d,b,$);break Ia;case 8:if(!(w[G+1|0]&16)){break Ia}um(d,k,b,8);break Ia;case 28:Fy(d,k,b,1);break Ia;case 7:PN(k,b);break Ia;case 25:QN(d,k,b);break Ia;case 18:e=kb-16|0;kb=e;h=d+1074376|0;a=q&65535;g=B(a,872);c=(h+g|0)+616|0;f=b&15;fb:{gb:{switch(b>>>4|0){case 0:a=(b&1)<<14;c=x[d+480188>>1];g=0;while(1){if((c|0)==(g|0)){break fb}h=(B(g,872)+d|0)+1075080|0;v[h>>2]=(a|v[h>>2]&-16385)^16384;g=g+1|0;continue};case 1:if(!f){f=0;if(!(v[d+480180>>2]&1048580)){break fb}}Sy(d,c,f);Db(e+8|0,d+1074312|0,117);if(Cb(v[v[e+8>>2]>>2],v[e+12>>2])){break fb}Rn(d,a,b|240,1);break fb;case 2:if(!f){f=0;if(!(v[d+480180>>2]&1048580)){break fb}}Ry(d,c,f);Db(e+8|0,d+1074312|0,117);if(Cb(v[v[e+8>>2]>>2],v[e+12>>2])){break fb}Rn(d,a,0-(b|240)|0,1);break fb;case 3:a=(d+g|0)+1075080|0;v[a>>2]=v[a>>2]&-1048577|((f|0)!=0)<<20;break fb;case 4:t[(d+g|0)+1075814|0]=b&7;break fb;case 5:if(!(w[d+480209|0]&16)){break fb}g=v[d+480180>>2];if(g&69206025){c=B(a,872)+d|0;u[c+1075764>>1]=f<<28>>24;g=c+1075692|0;if(!v[g>>2]){break fb}if(!$c(w[c+1075780|0])){break fb}a=B(a,872)+d|0;Xa=g,Ya=eh(d,w[a+1075789|0],f<<28>>24,v[a+1075696>>2]),v[Xa>>2]=Ya;break fb}c=$c(w[(B(a,872)+d|0)+1075780|0]);if((g|0)==16){if(!c){break fb}c=B(a,872)+d|0;g=v[c+1075096>>2];if(!g){break fb}t[g+37|0]=f;u[c+1075764>>1]=f;c=c+1075692|0;if(!v[c>>2]){break fb}a=B(a,872)+d|0;Xa=c,Ya=eh(d,w[a+1075789|0],f,v[a+1075696>>2]),v[Xa>>2]=Ya;break fb}if(!c){break fb}a=B(a,872)+d|0;c=(b<<4^-128)<<24>>24;u[a+1075764>>1]=c;g=a+1075692|0;if(!v[g>>2]){break fb}Xa=g,Ya=eh(d,w[a+1075789|0],c,v[a+1075696>>2]),v[Xa>>2]=Ya;break fb;case 6:if(!(w[d+480209|0]&16)){break fb}Zy(d,h,c,f);break fb;case 7:t[(d+g|0)+1075817|0]=b&7;break fb;case 8:if(!(w[d+480209|0]&16)){break fb}um(d,c,f,4);break fb;case 9:Ey(d,a,f,0);break fb;case 10:if(f){Zn(d,c,f,0);break fb}if(!(v[d+480180>>2]&1048580)){break fb}Zn(d,c,0,0);break fb;case 11:if(f){Yn(d,c,f,0);break fb}if(!(v[d+480180>>2]&1048580)){break fb}Yn(d,c,0,0);break fb;case 12:Hy(d,a,f,0);break fb;case 15:break gb;default:break fb}}if(v[d+480180>>2]==1){t[(B(a,872)+d|0)+1075838|0]=f;if(!(w[d+480209|0]&16)){break fb}iN(d,c);break fb}t[(B(a,872)+d|0)+1075836|0]=f}kb=e+16|0;break Ia;case 19:dN(d,q&65535,b);break Ia;case 24:Db(i+8|0,o,55);if(Cb(v[v[i+8>>2]>>2],v[i+12>>2])){if(v[d+1074392>>2]!=(b|0)){break Ia}a=v[(B(q,872)+d|0)+1075648>>2];if(t[a+60|0]&1?a:0){break Za}if(!(!(w[X|0]?1:w[R|0])|b)){a=(B(q,872)+d|0)+1075080|0;v[a>>2]=v[a>>2]|4096;break Za}a=B(q,872)+d|0;v[a+1075680>>2]=0;a=a+1075080|0;v[a>>2]=v[a>>2]|2097152;break Za}if(!(w[G+1|0]&16)){break Ia}break Za;case 27:a=(b&240)-16>>>4|0;if(a>>>0>9){break Ia}if(!(1<<a&880)){if(a){if((a|0)!=1){break Ia}Qy(d,k,K);Db(i+8|0,o,117);if(Cb(v[v[i+8>>2]>>2],v[i+12>>2])){break Ia}Rn(d,q&65535,-224-K|0,1);break Ia}Ty(d,k,K);Db(i+8|0,o,117);if(Cb(v[v[i+8>>2]>>2],v[i+12>>2])){break Ia}Rn(d,q&65535,K|224,1);break Ia}Db(i+8|0,o,58);if(Cb(v[v[i+8>>2]>>2],v[i+12>>2])){break Ia}dN(d,q&65535,b);break Ia;case 34:case 35:if(!(w[G+1|0]&16)&(J|0)!=36){break Ia}c=q&65535;UN(d,c,I,(J|0)==36);a=Sp(d,v[k+88>>2],v[k+656>>2]);if(!a){break Ia}ob[v[v[a>>2]+80>>2]](a,(x[k+774>>1]&65532)>>>2^8192,c);break Ia;case 20:if(!(w[G+1|0]&16)|b>>>0>64){break Ia}a=B(q,872)+d|0;v[a+1075740>>2]=b;a=a+1075080|0;v[a>>2]=v[a>>2]|2097152;break Ia;case 21:f=v[A>>2];e=v[G>>2];a=b;hb:{if(a){t[k+816|0]=a;break hb}a=w[k+816|0]}g=a&255;h=a&240;c=a&15;ib:{jb:{if(!(!h|(c|0)!=15)){if(!(e&4096)){break ib}a=g>>>4|0;break jb}e=e&4096;if(!(!c|(h|0)!=240)){if(!e){break ib}a=0-c|0;break jb}if(e){break ib}if(c){a=0-c|0;if(!(f&25690144)|!h){break jb}break ib}if((a&255)>>>0<16){break ib}a=g>>>4|0}Xa=k,Ya=Zb(a+v[k+748>>2]|0,0,64),v[Xa+748>>2]=Ya}break Ia;case 26:ON(k,b);break Ia;case 29:if(!(w[G+1|0]&16)){break Ia}a=B(q,872)+d|0;v[a+1075716>>2]=b;Db(i+8|0,o,60);if(Xa=0,Ya=Cb(v[v[i+8>>2]>>2],v[i+12>>2]),_a=w[a+1075722|0]&4,_a?Xa:Ya){break Ia}a=B(q,872)+d|0;v[a+1075732>>2]=b;v[a+1075724>>2]=b;break Ia;case 11:SN(d,I,q&65535);break Ia;case 13:a=RN(d,I,q&65535,b);if((a|0)==-1){break Ia}v[d+1074436>>2]=a;if(!(w[d+480208|0]&32)){break Ia}u[d+1074444>>1]=x[d+1074448>>1];break Ia;case 37:case 38:case 39:case 40:FN(d,k,b,(J|0)==38|(J|0)==40,(J&254)==40);break Ia;case 41:WN(k,b);break Ia;case 42:if(v[d+1074392>>2]|K>>>0>1|b>>>0>47){break Ia}a=(b&240)==16;g=a?x[d+480188>>1]-1|0:q;e=a?0:q;a=((K|0)==1)<<26;while(1){c=e&65535;if(c>>>0>(g&65535)>>>0){break Ia}h=((c<<5)+d|0)+480280|0;v[h>>2]=a|v[h>>2]&-67108865;c=(B(c,872)+d|0)+1075080|0;v[c>>2]=a|v[c>>2]&-67108865;e=e+1|0;continue};case 44:break _a;default:break Ha}}VN(k,b);break Ia}Wn(d,k);break Ia}$N(d,I,b)}e=b}Db(i+8|0,o,78);if(!(!Cb(v[v[i+8>>2]>>2],v[i+12>>2])|!e)){LN(k,e&255)}a=w[R|0];if(!a){break Q}t[p+1075796|0]=a}q=q+1|0;continue}break}a=1;break j}a=0}kb=F+32|0;N=!v[d+1074420>>2]|a^1;kb:{if(N){break kb}a=ZN(d,d+1074376|0);v[d+1074380>>2]=a;v[d+1074404>>2]=a;b=Ed(x[d+480188>>1],1,31);lb:{if(Qd(w[d+1074366|0])){a=v[d+24628>>2];if((a|0)>=129){a=((B(a-128|0,b+4|0)|0)/16|0)+128|0}s=((B(v[d+480228>>2],a)<<1&-128)>>>0)/w[(b>>>1|0)+32224|0]|0;break lb}s=v[d+480228>>2]}u[d+480212>>1]=0;o=d+1074312|0;S=d+1074365|0;F=d+480180|0;I=d+480210|0;K=d+480209|0;R=d+1074366|0;X=d+1074364|0;Z=d+1074360|0;q=0;while(1){if((q|0)==256){b=v[d+24608>>2];g=x[d+480212>>1];if(b>>>0>g>>>0){break kb}e=kb-16|0;kb=e;v[e+8>>2]=d;a=d+1074478|0;c=a;g=a+(g<<1)|0;mb:{a=a+(b<<1)|0;if((c|0)==(a|0)){break mb}nb:{b=a-c|0;if((b|0)<3){break nb}h=b>>1;b=(h-2|0)/2|0;while(1){if((b|0)<0){break nb}ly(c,v[e+8>>2],h,c+(b<<1)|0);b=b-1|0;continue}}h=a-c>>1;b=a;while(1){if((b|0)==(g|0)){b=a-c>>1;while(1){if((b|0)>1){a=a-2|0;my(c,a);b=b-1|0;ly(c,v[e+8>>2],b,c);continue}break}break mb}if(Np(v[e+8>>2],x[b>>1],x[c>>1])){my(b,c);ly(c,v[e+8>>2],h,c)}b=b+2|0;continue}}kb=e+16|0}else{m=B(q,872)+d|0;p=m+1075080|0;ob:{if(!(v[p>>2]&4096)|(v[m+1075016>>2]|(v[m+1075012>>2]|v[m+1075688>>2]))){break ob}Db(j+16|0,o,64);if(Cb(v[v[j+16>>2]>>2],v[j+20>>2])){break ob}v[m+1075068>>2]=0;a=m+1075084|0;v[a>>2]=0;v[a+4>>2]=0}a=x[d+480188>>1];b=v[p>>2];pb:{if(v[m+1075068>>2]|a>>>0>q>>>0?b&1024:1){if(a>>>0>q>>>0){uM(d,q&65535)}u[m+1075834>>1]=0;break pb}c=0;Q=m+1075712|0;v[Q>>2]=0;G=m+1075672|0;v[G>>2]=0;A=m+1075e3|0;e=A;v[e>>2]=0;v[e+4>>2]=0;v[m+1075092>>2]=0;v[j+44>>2]=1065353216;u[j+42>>1]=0;J=m+1075648|0;E=v[J>>2];v[j+36>>2]=0;f=0;l=m+1075692|0;f=v[l>>2]?v[m+1075068>>2]!=0:f;g=m+1074992|0;qb:{rb:{sb:{if(a>>>0<=q>>>0){break sb}if(w[((q<<5)+d|0)+480288|0]){break rb}if(!E){break sb}c=w[E+34|0]!=0}if((c|f)!=1){break qb}}v[j+8>>2]=v[m+1075680>>2];v[j+32>>2]=v[m+1075744>>2];Db(j+16|0,o,28);b=j+8|0;a=Cb(v[v[j+16>>2]>>2],v[j+20>>2])?j+32|0:b;c=kb-16|0;kb=c;e=d+1074312|0;Db(c+8|0,e,28);tb:{if(Cb(v[v[c+8>>2]>>2],v[c+12>>2])){v[a>>2]=v[a>>2]+u[g+776>>1];oe(a,0,64);break tb}Db(c+8|0,e,1);e=u[g+776>>1];if(Cb(v[v[c+8>>2]>>2],v[c+12>>2])){v[a>>2]=e+v[a>>2];oe(a,0,256);break tb}v[g+688>>2]=e+v[g+688>>2];oe(g+688|0,0,256);v[a>>2]=v[g+688>>2];u[g+776>>1]=0}kb=c+16|0;a=kb-16|0;kb=a;c=d+1074312|0;Db(a+8|0,c,28);ub:{vb:{if(!Cb(v[v[a+8>>2]>>2],v[a+12>>2])){Db(a,c,1);if(!Cb(v[v[a>>2]>>2],v[a+4>>2])){break vb}}v[g+684>>2]=v[g+692>>2]+u[g+778>>1];oe(g+684|0,0,256);break ub}v[g+692>>2]=v[g+692>>2]+u[g+778>>1];oe(g+692|0,0,256);u[g+778>>1]=0;v[g+684>>2]=v[g+692>>2]}kb=a+16|0;e=kb-16|0;kb=e;wb:{if(!(w[g+90|0]&4)|(v[d+480208>>2]&2101248)==2101248){break wb}xb:{if(v[b>>2]<=0){Db(e+8|0,d+1074312|0,21);if(!Cb(v[v[e+8>>2]>>2],v[e+12>>2])){break xb}}c=5;if(!(v[d+480180>>2]&5)){Db(e+8|0,d+1074312|0,21);c=Cb(v[v[e+8>>2]>>2],v[e+12>>2])?5:6}a=py(d,w[g+825|0],w[g+820|0]);yb:{if((w[g+825|0]&3)!=1){break yb}Db(e+8|0,d+1074312|0,89);if(!Cb(v[v[e+8>>2]>>2],v[e+12>>2])){break yb}a=w[g+819|0];k=w[g+820|0];h=k<<2&124;a=(!(w[g+90|0]&2)|w[d+480209|0]&16?a:w[g+823|0]+a|0)&32?h^127:h;a=k&32?0-a|0:a}if(v[d+480180>>2]!=131072){a=v[b>>2]+((B(w[g+827|0],a)|0)/(1<<c)|0)|0}else{c=64-a|0;a=v[b>>2];a=((B(w[g+827|0],B(c,a))|0)/-8192|0)+a|0}v[b>>2]=a}a=v[d+480208>>2];if(!(v[d+480180>>2]&16777248)|a&4?a&4096:0){break wb}Db(e+8|0,d+1074312|0,21);a=w[g+826|0];c=w[g+820|0];h=Cb(v[v[e+8>>2]>>2],v[e+12>>2]);t[g+820|0]=(h?a<<2:c)+(h?c:a)}kb=e+16|0;e=q&65535;h=kb-16|0;kb=h;a=d+1074312|0;Db(h+8|0,a,71);zb:{if(Cb(v[v[h+8>>2]>>2],v[h+12>>2])){a=(B(e,872)+d|0)+1075831|0;c=t[a|0];if((c|0)>=0){break zb}if(!(w[d+480209|0]&16|w[(B(e,872)+d|0)+1075797|0]!=18)){k=c&-33;t[a|0]=k;Ab:{Bb:{if((k|0)!=-64){c=c&223;if((c|0)!=128){break Bb}c=w[(B(e,872)+d|0)+1075832|0]>>>4|-64;break Ab}c=w[(B(e,872)+d|0)+1075832|0]&15|-128;break Ab}c=c-1|0}t[a|0]=c;a=(B(e,872)+d|0)+1075080|0;v[a>>2]=v[a>>2]|2097152}if((c&224)!=128){break zb}v[b>>2]=0;break zb}if(w[(B(e,872)+d|0)+1075797|0]!=18){break zb}Db(h+8|0,a,22);Cb:{if(Cb(v[v[h+8>>2]>>2],v[h+12>>2])){n=B(e,872)+d|0;a=n+1075831|0;k=w[a|0];c=k<<24>>24;if(!((c|0)>=0|!v[n+1075068>>2])){Db:{Eb:{if((k|0)!=192){if((k|0)!=128){break Eb}c=w[(B(e,872)+d|0)+1075832|0]>>>4|-64;break Db}c=w[(B(e,872)+d|0)+1075832|0]&15|-128;break Db}c=c-1|0}t[a|0]=c}if((c&192)!=128){break Cb}v[b>>2]=0;break Cb}a=w[(B(e,872)+d|0)+1075832|0];r=a>>>4|0;i=r+(a&15)|0;k=v[d+480180>>2];if(!(w[d+480208|0]&4?0:k&16777248)){r=r+1|0;i=i+2|0}a=(B(e,872)+d|0)+1075831|0;c=w[a|0];if(!(k&4)){c=(c&255)>>>0<i>>>0?c:0;if((c&255)>>>0>=r>>>0){v[b>>2]=0}t[a|0]=c+1;break Cb}Fb:{if(w[d+480209|0]&16){c=c&255?c-1|0:0;break Fb}t[a|0]=c+1}if(((c&255)>>>0)%(i>>>0)>>>0<r>>>0){break Cb}v[b>>2]=0}a=(B(e,872)+d|0)+1075080|0;v[a>>2]=v[a>>2]|2097152}a=B(e,872)+d|0;Gb:{if(w[a+1075797|0]!=18){break Gb}c=v[a+1075648>>2];if(!c){break Gb}a=w[c+34|0];if(!a|w[c+15|0]&2){break Gb}k=B(e,872)+d|0;if(v[k+1075080>>2]&134218752){break Gb}k=k+1075791|0;n=w[k|0];if(!$c(n)){break Gb}a=v[Md(d+906300|0,a-1|0)>>2];if(!a){break Gb}n=ob[v[v[a>>2]+104>>2]](a,n,e)|0;i=v[b>>2];if(!(!n|i)){ob[v[v[a>>2]+96>>2]](a,c,w[k|0]|256,0,e);break Gb}if(n|!i){break Gb}ob[v[v[a>>2]+96>>2]](a,c,w[k|0],x[(B(e,872)+d|0)+1075680>>1],e)}kb=h+16|0;oe(b,0,256);v[j+8>>2]=v[j+8>>2]<<6;Hb:{if(E){Db(j+16|0,o,31);if(Cb(v[v[j+16>>2]>>2],v[j+20>>2])){ht(d,g)}c=j+8|0;a=kb-16|0;kb=a;Ib:{if(!ny(d,g,0)){break Ib}h=v[g+656>>2];k=d+1074312|0;Db(a+8|0,k,31);Jb:{if(Cb(v[v[a+8>>2]>>2],v[a+12>>2])){b=v[g+724>>2];if(b){break Jb}break Ib}b=v[g+724>>2]}Db(a+8|0,k,31);i=b-Cb(v[v[a+8>>2]>>2],v[a+12>>2])|0;b=dq(h+48|0,i,256,64);r=w[h+65|0];Kb:{if((r|0)==255){break Kb}n=u[g+728>>1];if((n|0)==-1){break Kb}r=Eb(v[h+48>>2],r);h=w[r+2|0];r=x[r>>1];Db(a+8|0,k,94);k=h<<2;b=(i|0)==(r|0)?k:b;if(Cb(v[v[a+8>>2]>>2],v[a+12>>2])){b=n+(b-k<<1)|0;break Kb}if(!h){b=0;break Kb}b=(B(b,n)|0)/(k|0)|0}Xa=c,Ya=(B(Zb(b,0,512),v[c>>2])|0)/256|0,v[Xa>>2]=Ya}kb=a+16|0;DN(g,c);a=kb-16|0;kb=a;Lb:{if(!ny(d,g,1)){break Lb}c=v[g+656>>2];h=d+1074312|0;Db(a+8|0,h,31);Mb:{if(Cb(v[v[a+8>>2]>>2],v[a+12>>2])){b=v[g+732>>2];if(b){break Mb}break Lb}b=v[g+732>>2]}Db(a+8|0,h,31);c=dq(c+68|0,b-Cb(v[v[a+8>>2]>>2],v[a+12>>2])|0,64,64)-32|0;b=v[g+684>>2];Xa=g,Ya=Zb(((B(c,(b|0)>127?256-b|0:b)|0)/32|0)+b|0,0,256),v[Xa+684>>2]=Ya}kb=a+16|0;Db(j+16|0,o,115);if(Cb(v[v[j+16>>2]>>2],v[j+20>>2])){break Hb}b=w[m+1075789|0];if(!b){break Hb}a=v[J>>2];if(!a|!w[a+26|0]){break Hb}HN(m+1075676|0,b,w[a+26|0],w[a+27|0]);break Hb}if(!(w[p+1|0]&16)){break Hb}v[m+1075688>>2]=0;v[j+8>>2]=0}Nb:{if(w[m+1075843|0]&8){c=0;v[j+8>>2]=0;break Nb}c=v[j+8>>2];if(!c){c=0;break Nb}if(w[p+3|0]&8){v[G>>2]=0;break Nb}if(Qd(w[S|0])){a=B(v[j+32>>2],v[m+1075740>>2]);b=a;h=a>>31;a=c<<8;Xa=G,Ya=Hc(Kka(Jka(b,h,a,a>>31),nb,1048576,0),nb),v[Xa>>2]=Ya;break Nb}a=B(v[j+32>>2],v[m+1075740>>2]);b=a;h=a>>31;a=B(v[d+1074456>>2],c);Xa=G,Ya=Hc(Kka(Jka(b,h,a,a>>31),nb,1048576,0),nb),v[Xa>>2]=Ya}v[Q>>2]=c;Ob:{Pb:{c=v[l>>2];if(!(v[F>>2]==2|(c|0)>=v[d+480260>>2])){if(!mj(d)){break Pb}c=v[l>>2]}if((c|0)<v[d+480264>>2]){break Ob}Db(j+16|0,o,113);if(!Cb(v[v[j+16>>2]>>2],v[j+20>>2])){break Ob}if(mj(d)){break Ob}v[l>>2]=v[d+480264>>2];break Ob}v[l>>2]=v[d+480260>>2]}Db(j+16|0,o,73);a=v[l>>2];v[j+36>>2]=a;Qb:{if((v[p>>2]&1572864)!=1572864){break Qb}b=v[d+480208>>2];if(b&2097152){if(!vm(w[m+1075782|0],w[m+1075783|0])|b&4096){break Qb}}b=m+1075704|0;Rb:{if((a|0)==v[b>>2]){c=v[m+1075708>>2];break Rb}v[b>>2]=a;c=a;a=m+1075764|0;b=m+1075696|0;c=eh(d,et(d,c,u[a>>1],v[b>>2]),u[a>>1],v[b>>2]);v[m+1075708>>2]=c}v[j+36>>2]=c}k=kb-16|0;kb=k;i=B(e,872)+d|0;r=i+1075648|0;a=v[r>>2];Sb:{if(!a){break Sb}b=w[a+34|0];if(v[(B(e,872)+d|0)+1075080>>2]&134218752|(!b|w[a+15|0]&2)){break Sb}if(!v[Md(d+906300|0,b-1|0)>>2]){break Sb}b=B(e,872)+d|0;h=b+1075780|0;a=w[b+1075793|0];Y=b+1075783|0;n=w[Y|0];Tb:{Ub:{if((n|0)==1){b=a;Vb:{Wb:{switch(((y[d+1074392>>2]%(v[d+1074400>>2]+v[d+1074416>>2]>>>0)>>>0)%3|0)-1|0){case 0:b=a+(w[(B(e,872)+d|0)+1075798|0]>>>4|0)|0;break Vb;case 1:break Wb;default:break Vb}}b=a+(w[(B(e,872)+d|0)+1075798|0]&15)|0}c=B(e,872)+d|0;if(w[c+1075792|0]==(b&255)){break Tb}if(!(t[c+1075843|0]&1)){break Ub}if(!$c(w[h|0])){break Ub}if(vm(w[h+2|0],1)){break Ub}break Tb}if(w[h|0]){b=a;if(!vm(w[h+2|0],n)){break Tb}}b=a;if(!w[(B(e,872)+d|0)+1075792|0]){break Tb}}sm(d,e,b&255|512,x[(B(e,872)+d|0)+1075680>>1])}V=(B(e,872)+d|0)+1075792|0;c=w[V|0];Xb:{Yb:{if(c){if((n|0)!=1|(b&255)!=(c|0)){break Yb}break Xb}if(!(t[(B(e,872)+d|0)+1075843|0]&1)|(n|0)!=1){break Xb}if($c(w[h|0])){break Xb}c=a;if(!$c(a)){break Xb}}sm(d,e,c&255|256,0)}t[V|0]=w[Y|0]==1?b:0}Zb:{if(w[i+1075797|0]!=1){break Zb}if(xj(v[r>>2])){b=0;_b:{$b:{ac:{switch(y[d+1074392>>2]%3|0){case 1:b=w[(B(e,872)+d|0)+1075798|0]>>>4|0;break $b;case 0:break $b;case 2:break ac;default:break _b}}b=w[(B(e,872)+d|0)+1075798|0]&15}u[j+42>>1]=b}a=(B(e,872)+d|0)+1075843|0;t[a|0]=w[a|0]|96;break Zb}if(!(!(w[d+480209|0]&16)|v[d+480180>>2]!=1048576)){a=B(e,872)+d|0;b=eh(d,w[a+1075789|0],u[a+1075764>>1],v[a+1075696>>2]);v[j+36>>2]=b;v[a+1075692>>2]=b}b=d+1074312|0;Db(k+8|0,b,13);if(Cb(v[v[k+8>>2]>>2],v[k+12>>2])){b=w[(B(e,872)+d|0)+1075798|0];if(!b){break Zb}a=65536;bc:{switch(((y[d+1074392>>2]%(v[d+1074400>>2]+v[d+1074416>>2]>>>0)>>>0)%3|0)-1|0){case 1:b=b<<4;case 0:a=v[((b&240)<<2)+37200>>2];break;default:break bc}}e=mj(d);b=v[j+36>>2];c=b;b=b>>31;if(e){a=Jka(c,b,a,a>>31)+32768|0;h=nb;a=Kka(a,a>>>0<32768?h+1|0:h,65536,0)}else{e=(a|0)/2|0;h=e>>31;n=b<<16|c>>>16;c=c<<16;b=c+e|0;n=h+n|0;a=Kka(b,b>>>0<c>>>0?n+1|0:n,a,a>>31)}b=nb;Xa=j,Ya=Hc(a,b),v[Xa+36>>2]=Ya;break Zb}Db(k+8|0,b,51);if(Cb(v[v[k+8>>2]>>2],v[k+12>>2])){if(w[d+480209|0]&16){break Zb}cc:{dc:{a=v[d+1074416>>2];b=a-(y[d+1074392>>2]%(a>>>0)|0)|0;if((b|0)>16){break dc}if((b|0)==16){break Zb}a=0;ec:{switch((b|0)%3|0){case 0:break Zb;case 2:break dc;case 1:break ec;default:break cc}}a=w[(B(e,872)+d|0)+1075798|0]>>>4|0;break cc}a=w[(B(e,872)+d|0)+1075798|0]&15}c=a;a=B(e,872)+d|0;b=a+1075764|0;a=a+1075696|0;c=c+et(d,v[j+36>>2],u[b>>1],v[a>>2])|0;b=eh(d,c,u[b>>1],v[a>>2]);v[j+36>>2]=b;if(c>>>0<109){break Zb}v[k+8>>2]=b;Xa=k,Ya=eh(d,109,0,v[a>>2]),v[Xa+4>>2]=Ya;Xa=j,Ya=v[_c(k+8|0,k+4|0)>>2],v[Xa+36>>2]=Ya;break Zb}h=v[d+1074392>>2];n=d+480180|0;c=v[n>>2];fc:{if((c|0)!=1){a=w[(B(e,872)+d|0)+1075789|0];break fc}a=B(e,872)+d|0;a=et(d,v[j+36>>2],u[a+1075764>>1],v[a+1075696>>2]);c=v[n>>2]}gc:{hc:{switch((((c&67633152?h+2|0:h)>>>0)%3|0)-1|0){case 0:a=(w[(B(e,872)+d|0)+1075798|0]>>>4|0)+a|0;break gc;case 1:break hc;default:break gc}}a=(w[(B(e,872)+d|0)+1075798|0]&15)+a|0}if(!(c&67633408|w[(B(e,872)+d|0)+1075789|0]!=(a&255))){Db(k+8|0,b,82);if(!Cb(v[v[k+8>>2]>>2],v[k+12>>2])){break Zb}}if(w[d+480210|0]&32){c=a&255;if((c|0)==85){v[j+36>>2]=2147483647;break Zb}a=c>>>0>85?a-37|0:a}c=B(e,872)+d|0;h=eh(d,a&255,u[c+1075764>>1],v[c+1075696>>2]);v[j+36>>2]=h;if(v[d+480180>>2]&71860480){v[c+1075692>>2]=h;break Zb}Db(k+8|0,b,82);if(!Cb(v[v[k+8>>2]>>2],v[k+12>>2])){break Zb}t[(B(e,872)+d|0)+1075792|0]=a}kb=k+16|0;if(!(!(w[I|0]&33)|v[j+36>>2]==2147483647)){ic:{if(v[F>>2]==2){c=452;a=3424;break ic}a=B(x[m+1075764>>1]>>>4&15,24);b=x[a+32934>>1]>>>1|0;c=b>>>0>452?b:452;a=x[a+32912>>1]<<1}oe(j+36|0,c,a);oe(l,c,a)}MN(d,g);b=v[p>>2]}jc:{if(!(b&256)|w[K|0]&64){break jc}Db(j+16|0,o,37);if(!Cb(v[v[j+16>>2]>>2],v[j+20>>2])){break jc}v[m+1075676>>2]=128}l=q&65535;uM(d,l);kc:{if(!f){break kc}a=EN(d,g,j+36|0);if((a|0)<0|!(w[p+1|0]&2)){break kc}b=v[d+1298300>>2];if(!zd(b)){break kc}cq(b,l,a>>>2&255,1)}lc:{if(w[m+1075782|0]!=8){break lc}mc:{nc:{a=w[m+1075783|0];switch(a-5|0){case 1:break lc;case 0:case 2:break mc;default:break nc}}if((a|0)!=26){break lc}}a=v[F>>2];if((a|0)==4){if(w[K|0]&16){break lc}a=m+1075811|0;t[a|0]=w[a|0]+w[m+1075815|0];break lc}if(!(a&16777248)){break lc}hl(g,w[m+1075784|0]);tM(d,l,j+36|0,j+44|0)}tM(d,l,j+36|0,j+44|0);oc:{if(!f){break oc}v[j+32>>2]=0;b=j+36|0;n=kb-16|0;kb=n;e=v[g+104>>2];pc:{if(!e|!w[e+40|0]){break pc}i=xj(v[g+656>>2]);f=mj(d);Db(n+8|0,d+1074312|0,21);a=f?38224:37200;k=f?37200:38224;if(!(i|!Cb(v[v[n+8>>2]>>2],v[n+12>>2])|v[d+480180>>2]==1048576)){i=w[e+41|0];if(!i){break pc}c=w[g+818|0];v[n+4>>2]=v[g+756>>2]+w[e+39|0];ci(n+4|0,w[e+40|0]<<8);h=v[n+4>>2];t[g+818|0]=c+i;v[g+756>>2]=h;h=(h|0)/256|0;qc:{rc:{switch(w[e+38|0]-1|0){case 3:c=rM(Vn(d))+-64|0;break qc;case 2:c=64-(c+1>>>1|0)|0;break qc;case 1:c=(c+1>>>1|0)+-64|0;break qc;case 0:c=(c>>>1^-1)&64;break qc;default:break rc}}c=t[c+33504|0]}ci(b,8388607);e=v[b>>2]<<8;v[b>>2]=e;h=B(c,h);i=(h|0)/64|0;c=i>>31;i=(c^i)-c|0;r=i>>>2|0;c=e;sc:{tc:{if((h|0)<=-64){h=e>>31;a=v[(r<<2)+a>>2];a=Hc(Kka(Jka(e,h,a,a>>31),nb,65536,0),nb)-e|0;k=i&3;if(!k){break sc}f=(k<<2)+(f?37136:37072)|0;break tc}h=e>>31;a=v[k+(r<<2)>>2];a=Hc(Kka(Jka(e,h,a,a>>31),nb,65536,0),nb)-e|0;k=i&3;if(!k){break sc}f=(k<<2)+(f?37072:37136)|0}k=a;a=v[f>>2];a=(k+Hc(Kka(Jka(a,a>>31,e,h),nb,65536,0),nb)|0)-e|0}v[b>>2]=(a+c|0)/256;v[j+32>>2]=a&255;break pc}h=v[d+480180>>2]&16777248;c=w[e+39|0];uc:{if(!(h|c)){v[g+756>>2]=w[e+40|0]<<8;break uc}vc:{wc:{if(h){r=c<<1;f=v[g+756>>2];c=g+756|0;break wc}if(w[g+89|0]&8){break vc}f=((w[e+40|0]<<8&65280)>>>0)/(c>>>0)|0;r=v[g+756>>2];c=g+756|0}v[c>>2]=f+r}ci(g+756|0,w[e+40|0]<<8)}c=w[g+818|0]+w[e+41|0]|0;t[g+818|0]=c;c=c<<24>>24;xc:{yc:{switch(w[e+38|0]-1|0){case 3:t[g+818|0]=c+1;h=t[(c&63)+33440|0];break xc;case 2:h=(64-(c>>>1|0)&127)+-64|0;break xc;case 1:h=((c>>>1|0)- -64&127)+-64|0;break xc;case 0:h=(c|0)>=0?-64:64;break xc;default:break yc}}h=0-t[(c&255)+33504|0]|0;if(v[d+480180>>2]!=1048576){break xc}h=(64-t[(c+-64&255)+33504|0]|0)/2<<16>>16}c=h;h=B(c,v[g+756>>2]);f=(h|0)/256|0;if(i){z[j+44>>2]=z[j+44>>2]+C(C(C(C(w[e+40|0])*C(.05000000074505806))*C(c|0))*C(.000244140625));t[g+851|0]=w[g+851|0]|64;break pc}if(v[d+480180>>2]!=4){zc:{if((h|0)<=-256){f=0-f|0;c=0-h>>>16|0;e=(c<<2)+a|0;break zc}a=k;c=(h|0)/65536|0;e=a+(c<<2)|0}h=v[b>>2];c=v[((c<<2)+a|0)+4>>2];a=v[e>>2];a=((B(c-a|0,(f|0)/4&63)|0)/64|0)+a|0;a=Hc(Kka(Jka(h,h>>31,a,a>>31),nb,256,0),nb);v[b>>2]=a;v[j+32>>2]=a&255;v[b>>2]=v[b>>2]/256;break pc}v[b>>2]=v[b>>2]+((h|0)/16384|0)}kb=n+16|0;f=v[j+36>>2];if((f|0)<=v[d+480260>>2]){Db(j+16|0,o,81);if(Cb(v[v[j+16>>2]>>2],v[j+20>>2])){v[m+1075068>>2]=0}f=v[d+480260>>2];v[j+36>>2]=f}Ac:{if(!xj(v[g+656>>2])){break Ac}a=m+1075843|0;b=w[a|0];if(!(v[d+1074392>>2]|!(b&32)?b&64:1)){break Ac}yP(g,z[j+44>>2],u[j+42>>1],d);b=a;a=w[a|0];t[b|0]=(a&64?-65:-33)&a}a=j+16|0;$y(a,d,g,f,v[j+32>>2]);b=Gb(a);a=Jka(v[j+16>>2],v[j+20>>2],v[d+480240>>2],0);f=nb;c=Kka(a,f,65536,0);e=nb;a=a+65535|0;f=a>>>0<65535?f+1|0:f;a=!f&a>>>0<131071;c=a?1:c;v[j+16>>2]=c;a=a?0:e;v[j+20>>2]=a;v[A>>2]=c;v[A+4>>2]=a;if((v[p>>2]&134219264)!=512){break oc}if(!zd(v[d+1298300>>2])){break oc}Db(j+8|0,o,99);Bc:{Cc:{if(Xa=Cb(v[v[j+8>>2]>>2],v[j+12>>2]),Ya=1,_a=w[p+1|0]&16,_a?Xa:Ya){a=v[F>>2];break Cc}a=v[F>>2];if((a|0)!=2){break Bc}}c=v[p>>2];e=c&2048;Dc:{if(e?(a|0)==2:0){break Dc}a=Jka(v[b>>2],0,261625,0)+66904|0;b=nb;b=Ec(Mka(a,a>>>0<66904?b+1|0:b,133808,0),nb);a=1;Ec:{if(e){break Ec}a=0;if(!(c&4096)){break Ec}a=!v[m+1075688>>2]}Db(j+8|0,o,110);if(Xa=Cb(v[v[j+8>>2]>>2],v[j+12>>2]),Ya=0,_a=a,_a?Xa:Ya){break Dc}c=v[d+1298300>>2];Db(j+8|0,o,95);tz(c,l,b,a,Cb(v[v[j+8>>2]>>2],v[j+12>>2]))}b=v[d+1298300>>2];a=Jka(B(v[m+1075744>>2],B(v[m+1075740>>2],v[Q>>2])),0,63,0)+33554432|0;f=nb;f=a>>>0<33554432?f+1|0:f;cq(b,l,Ec((f&67108863)<<6|a>>>26,f>>>26|0)&255,0);a=m+1075676|0;h=a;b=v[a>>2];c=0;a=v[d+1298300>>2];e=pl(a,l);Fc:{if((e|0)==255){break Fc}f=v[a>>2];if(kk(f)){break Fc}c=Lb(Nd(a+318|0,e),10);n=v[a+4>>2];e=wt(e)|192;a=w[c|0]&-49;a=(b|0)<171?a|16:a;a=(b|0)>84?a|32:a;b=a&255;gh(f,n,l,e,b);c=(b>>>5&1)+(a<<27>>31)|0}v[h>>2]=(c<<7)+128}Gc:{a=v[J>>2];if(!a|(w[a+60|0]&7)!=1){break Gc}b=v[a+48>>2];a=v[a+52>>2];if(pc(b,a)){break Gc}b=v[sM(g,0)>>2];a=Bj(a);if(b>>>0<x[a>>1]|w[a+2|0]){break Gc}rj(v[d+1298300>>2],l,1);Db(j+8|0,o,109);a=v[p>>2];Xa=p,Ya=(Cb(v[v[j+8>>2]>>2],v[j+12>>2])?a:a&-4609)|4096,v[Xa>>2]=Ya;v[m+1075688>>2]=0;break oc}Db(j+8|0,o,99);if(!Cb(v[v[j+8>>2]>>2],v[j+12>>2])|!(w[p+1|0]&16)|v[m+1075688>>2]){break oc}rj(v[d+1298300>>2],l,1);v[p>>2]=v[p>>2]&-513}Hc:{if(!E){break Hc}Db(j+16|0,o,31);if(Cb(v[v[j+16>>2]>>2],v[j+20>>2])){break Hc}ht(d,g)}b=v[p>>2];a=b&-65537;n=m+1075012|0;k=v[G>>2];i=m+1075016|0;c=v[n>>2]|(k|v[i>>2])?(a|b<<7&65536)^65536:a;v[p>>2]=c;r=m+1075664|0;a=r;v[a>>2]=0;v[a+4>>2]=0;h=m+1075834|0;a=w[h|0];b=a-4|0;b=a>>>0<b>>>0?0:b;t[h|0]=b;l=m+1075835|0;a=w[l|0];e=a-4|0;a=a>>>0<e>>>0?0:e;t[l|0]=a;Ic:{Jc:{Kc:{Lc:{Mc:{Nc:{Oc:{Pc:{Qc:{e=v[m+1075096>>2];Rc:{if(!e){break Rc}f=v[e+20>>2];if(!_d(v[e>>2],f)|!v[m+1075068>>2]){break Rc}if(Ai(v[g+8>>2],v[g+12>>2])){break Qc}}v[m+1075008>>2]=0;break Pc}v[m+1075008>>2]=f;if(f){break Oc}}if(!oj(v[g+656>>2])){break Nc}f=0;if(c&6144){break Nc}}G=v[m+1075676>>2];e=(B(k,256-G|0)|0)/16384|0;e=e>>>0<127?e:127;if(b<<24>>24<0){t[h|0]=e;V=e}else{V=b}b=e>>>1|0;if((V&255)>>>0<b>>>0){t[h|0]=b}b=(B(k,G)|0)/16384|0;b=b>>>0<127?b:127;if(a<<24>>24<0){t[l|0]=b;a=b}b=b>>>1|0;if(b>>>0>(a&255)>>>0){break Mc}break Lc}if((b&255)>>>0>=129){t[h|0]=0}f=0;b=0;if((a&255)>>>0<129){break Kc}}t[l|0]=b}if(!f){break Kc}f=128;h=v[d+24624>>2];if(h>>>0>=2){f=Zb(v[m+1075676>>2],0,256)}v[j+16>>2]=f;b=B(k,s)>>>(Qd(w[R|0])?7:8)|0;Sc:{Tc:{Uc:{switch(w[X|0]){case 0:if(!(w[d+24616|0]&16)){break Tc}case 1:if((f|0)<=127){a=b>>>1|0;b=(B(b,f)|0)/256|0;break Sc}a=(B(b,256-f|0)|0)/256|0;b=b>>>1|0;break Sc;case 3:break Uc;default:break Tc}}ci(j+16|0,255);e=v[j+16>>2];if((e|0)<=0){a=65536}else{a=x[(0-e<<1)+39760>>1]}a=B(a,b)>>>16|0;b=B(b,x[(e<<1)+39248>>1])>>>16|0;break Sc}a=(B(b,256-f|0)|0)/256|0;b=(B(b,f)|0)/256|0}e=v[J>>2];Vc:{if(e){f=w[e+14|0];if(Ko(f)){break Vc}}f=w[d+480268|0];if(Ko(f)){break Vc}e=w[d+24648|0];f=w[I|0]&128?v[d+24668>>2]?-1:e:e}k=m+1075668|0;l=m+1075786|0;t[l|0]=f;e=v[A>>2];n=v[A+4>>2];if(!(c&131072|((e|0)!=0|(n|0)!=1)|(v[m+1075748>>2]|(f&255)==255))){t[l|0]=0}f=a;a=1<<v[Z>>2];v[r>>2]=(f|0)/(a|0);a=(b|0)/(a|0)|0;v[k>>2]=(c&256)>>>8|0?(h|0)==2?0-a|0:a:a;if(c&128){v[A>>2]=0-e;v[A+4>>2]=0-(((e|0)!=0)+n|0)}f=0;k=kb-16|0;kb=k;v[g+28>>2]=0;v[g+32>>2]=0;ci(g+672|0,524287);ci(g+676|0,524287);Wc:{Xc:{e=v[g+88>>2];if(!(e&65536)){b=v[g+676>>2];a=v[g+672>>2];break Xc}a=v[g+20>>2];h=v[g+672>>2];Yc:{if((a|0)!=(h|0)){b=v[g+24>>2];c=v[g+676>>2];break Yc}b=v[g+24>>2];c=v[g+676>>2];if((b|0)==(c|0)){break Xc}}e=v[d+24620>>2];c=(a|0)<(h|0)|(b|0)<(c|0);Zc:{if(c){a=yt(e,v[d+24636>>2]);break Zc}a=yt(e,v[d+24640>>2])}Db(k,d+1074312|0,4);if(!(!Cb(v[v[k>>2]>>2],v[k+4>>2])|!(v[d+480180>>2]&4))){a=v[d+24620>>2];a=Jka(a,a>>31,5,0)+500|0;h=nb;a=Hc(Kka(a,a>>>0<500?h+1|0:h,1e3,0),nb)}e=v[g+656>>2];_c:{if(!e){b=a;break _c}b=a;if(!c){break _c}c=x[e+12>>1];if(c){b=(B(c,v[d+24620>>2])>>>0)/1e5|0}f=(c|0)!=0}l=b?b:1;e=v[g+672>>2];n=v[g+20>>2];i=e-n<<12;r=g;c=v[g+676>>2];b=v[g+24>>2];h=c-b<<12;if(!(w[g+90|0]&32|(!(c|e)|(!(b|n)|f)))){v[k+12>>2]=v[d+1074380>>2];oe(k+12|0,a,2048);l=v[k+12>>2]}h=(h|0)/(l|0)|0;v[r+32>>2]=h;f=(i|0)/(l|0)|0;v[g+28>>2]=f;b=c+((B(h,l)|0)/-4096|0)|0;v[g+24>>2]=b;a=e+((B(f,l)|0)/-4096|0)|0;v[g+20>>2]=a;if(f|h){v[g+100>>2]=l;c=v[g+88>>2];break Wc}v[g+24>>2]=c;v[g+20>>2]=e;b=c;a=e;c=v[g+88>>2]&-65537;break Wc}v[g+24>>2]=b;v[g+20>>2]=a;c=e&-65537}v[g+88>>2]=c&-2097153;v[g+40>>2]=b<<12;v[g+36>>2]=a<<12;kb=k+16|0;c=v[p>>2];if(!(c&512)){break Jc}break Ic}v[n>>2]=0;v[i>>2]=0;v[m+1075068>>2]=0;if(v[m+1075088>>2]){break Jc}if(!v[m+1075084>>2]){break Ic}}a=x[d+480212>>1];u[d+480212>>1]=a+1;u[((a<<1)+d|0)+1074478>>1]=q}v[m+1075660>>2]=c}q=q+1|0;continue}break}}kb=j+48|0;if(N^1){a=v[d+480208>>2];break h}if(Qd(w[Ha|0])){b=v[d+480208>>2]|512;break i}l=0;$c:{a=v[d+24620>>2]/10|0;c=Hc(a,a>>31);if(!c){break $c}b=c>>>0<1048576?c:1048576;v[d+1074380>>2]=b;g=x[d+480212>>1];e=d+1074376|0;while(1){if((g|0)==(l|0)){break $c}a=e+B(x[(e+(l<<1)|0)+102>>1],872)|0;h=a+1288|0;v[h>>2]=0;v[h+4>>2]=0;v[a+716>>2]=b;h=v[a+640>>2]<<12;v[a+656>>2]=h;f=v[a+636>>2]<<12;v[a+652>>2]=f;v[a+704>>2]=v[a+704>>2]|65536;v[a+644>>2]=(0-f|0)/(b|0);v[a+648>>2]=(0-h|0)/(b|0);l=l+1|0;continue}}a=v[d+480208>>2];b=a|256;if(c){break i}b=a|512}a=b;v[d+480208>>2]=a}if(!(a&512)){break g}Xa=d+1074392|0,Ya=il(Ga),v[Xa>>2]=Ya}kb=M+112|0;break f}v[M+96>>2]=512;a=v[d+1074380>>2];v[M+104>>2]=fa;v[M+100>>2]=a;k=MB(M+96|0);if(v[d+24632>>2]){a=0;b=kb-48|0;kb=b;c=k<<2;while(1){if((a|0)==4){ad:{a=0;while(1){if((a|0)==4){break ad}v[(b+32|0)+(a<<2)>>2]=((a<<11)+d|0)+16396;a=a+1|0;continue}}}else{v[b+32>>2]=0;e=((a<<11)+d|0)+16396|0;$z(e,c+e|0,b+32|0);a=a+1|0;continue}break}a=v[d+24632>>2];v[b+24>>2]=k;v[b+20>>2]=a;v[b+16>>2]=b+32;a=v[v[ma>>2]+8>>2];v[b+8>>2]=k;c=v[b+20>>2];v[b>>2]=v[b+16>>2];v[b+4>>2]=c;ob[a|0](ma,b);kb=b+48|0}if(Qd(Fa)){a=0;while(1){if((a|0)==4){a=v[d+24632>>2];v[M+88>>2]=k;v[M+84>>2]=a;v[M+80>>2]=M+96;a=v[v[oa>>2]+8>>2];v[M+40>>2]=k;b=v[M+84>>2];v[M+32>>2]=v[M+80>>2];v[M+36>>2]=b;ob[a|0](oa,M+32|0)}else{v[(M+96|0)+(a<<2)>>2]=((a<<11)+d|0)+16396;a=a+1|0;continue}break}}$=0;ga=0;E=kb-48|0;kb=E;if(k){o=d+12|0;r=d+24592|0;A=d+24588|0;an(o,k,r,A);if(y[d+24624>>2]>=3){an(d+8204|0,k,d+24600|0,d+24596|0)}u[E+42>>1]=0;ta=d+1074312|0;Ja=d+24648|0;ua=d+906300|0;Ka=d+24596|0;La=d+24600|0;Ma=d+8204|0;F=d+397452|0;G=d+397448|0;p=d+393352|0;va=d+397456|0;ia=d+1074376|0;Na=d+480190|0;while(1){if(x[d+480212>>1]<=$>>>0){Xa=d,Ya=x[ke(d+480214|0,E+42|0)>>1],u[Xa+480214>>1]=Ya}else{l=ia+($<<1)|0;h=x[l+102>>1];a=B(h,872);Q=a+ia|0;bd:{cd:{if(v[Q+632>>2]){break cd}b=a+d|0;if(v[b+1075088>>2]){break cd}if(!v[b+1075084>>2]){break bd}}j=a+d|0;a=w[j+1075786|0]+1|0;if((a&255)>>>0<=5){f=v[(a<<24>>24<<2)+27840>>2]}else{f=0}I=j+1075080|0;g=v[I>>2];dd:{if(!(!(g&16777216)&w[d+24612|0]>>>5)){a=r;b=A;c=g;e=o;if(!(c&8388608)){break dd}}a=G;b=F;if(!w[va+12|0]){an(p,k,a,b)}t[va+12|0]=1;h=x[l+102>>1];c=v[I>>2];e=p}n=b;b=c>>>8&y[d+24624>>2]>2;S=b?Ka:n;J=b?La:a;c=b?Ma:e;ja=Ml(d,ia,h,2,1)-1|0;wa=(ja&255)>>>0>249;ed:{if(wa){break ed}b=v[Md(ua,ja)>>2];if(!b){break ed}a=v[b+24>>2];if(!a){break ed}S=b+36|0;J=b+40|0;if(!(t[b+28|0]&1)){an(a,k,J,S);v[b+28>>2]=v[b+28>>2]|1}c=a}l=Q+616|0;if(w[j+1075843|0]&8){mD(l,c,k);a=j+1075084|0;v[J>>2]=v[J>>2]+v[a>>2];v[S>>2]=v[S>>2]+v[j+1075088>>2];v[a>>2]=0;v[a+4>>2]=0;break bd}ba=0;e=kb-16|0;kb=e;a=E+16|0;v[a>>2]=0;v[a+4>>2]=0;v[a+8>>2]=0;v[a+12>>2]=0;b=e+8|0;h=d+1074312|0;Db(b,h,33);Xa=a,Ya=Cb(v[v[e+8>>2]>>2],v[e+12>>2]),t[Xa+16|0]=Ya;Db(b,h,116);Xa=a,Ya=Cb(v[v[e+8>>2]>>2],v[e+12>>2])^1,t[Xa+17|0]=Ya;if(v[l+16>>2]){kD(a,l);s=v[l+8>>2];n=v[l+12>>2];b=n>>31;n=(b^n)-((b>>>0>(b^s)>>>0)+b|0)|0;b=n;v[a+12>>2]=b>>>0>8191?2:16384/(b+1>>>0)|0}Oa=g>>>12&8|(g>>>5&2|(f|g&1));Pa=ga&65535;Qa=j+1075795|0;Ra=j+1075778|0;Sa=j+1075688|0;Ta=j+1075024|0;Ua=j+1075020|0;Va=j+1075668|0;Wa=j+1075664|0;R=j+1075088|0;X=j+1075084|0;xa=j+1075016|0;ya=j+1075012|0;ca=j+1075096|0;Z=j+1075076|0;N=j+1075068|0;K=j+1075e3|0;ha=j+1075072|0;Y=j+1075092|0;kb=e+16|0;q=a;a=k;while(1){fd:{b=v[Y>>2];ea=b?a>>>0>b>>>0?b:a:a;v[E+8>>2]=ea;gd:{hd:{if(!ea){break hd}j=v[K>>2];g=v[K+4>>2];if(!(j|g)){break hd}f=v[N>>2];if(!f){break hd}e=v[q>>2];if(!e){break hd}b=v[I>>2];n=v[ha>>2];v[Q+632>>2]=e;e=v[l>>2];id:{jd:{s=n&b<<30>>31;h=v[l+4>>2];m=h;if((s|0)>(h|0)){if((g|0)<0){e=Sg(0,s<<1,e,h);v[l>>2]=e;h=nb;v[l+4>>2]=h;if(!((h|0)>=(s|0)&h>>>0<f+s>>>1>>>0)){e=0;v[l>>2]=e;h=s;v[l+4>>2]=h}kd:{if(b&4){b=b&-129;v[I>>2]=b;g=0-(((j|0)!=0)+g|0)|0;j=0-j|0;v[K>>2]=j;v[K+4>>2]=g;break kd}v[l>>2]=e;h=f-1|0;v[l+4>>2]=h}if(!(b&2)){break hd}if(f>>>0>h>>>0){break id}break hd}if((h|0)>0|(h|0)>=0){break id}h=0;break jd}if(f>>>0>m>>>0){break id}if(!(b&2)){break hd}if(b&4){if(!!j&(g|0)>=0|(g|0)>0){g=0-(((j|0)!=0)+g|0)|0;j=0-j|0;v[K>>2]=j;v[K+4>>2]=g}b=b|128;v[I>>2]=b;if(w[E+33|0]){m=w[E+32|0];i=v[Z>>2]-(m+n|0)|0;e=Sg(e,h,0,f);h=nb;if(h>>>0<i>>>0){e=Sg(0,f-m|0,e,h);h=nb;break jd}h=n;e=0;break jd}h=1-((e|0)!=0)|0;e=0-e|0;i=(f<<1)-(h+m|0)|0;m=e;v[l>>2]=e;V=0;h=V|i;v[l+4>>2]=h;if(i>>>0>n>>>0&f>>>0>i>>>0){break id}v[E+44>>2]=w[E+32|0]+1;e=m;h=V|f-v[Kb(N,E+44|0)>>2];break jd}if((g|0)<0){g=0-(((j|0)!=0)+g|0)|0;j=0-j|0;v[K>>2]=j;v[K+4>>2]=g}Rb(l,0,s-f|0);b=v[I>>2]|8192;v[I>>2]=b;e=v[l>>2];h=v[l+4>>2];break id}v[l>>2]=e;v[l+4>>2]=h}V=h;ld:{if((h|0)<(s|0)){if((g|h)<0){break hd}v[E+44>>2]=ea;f=j;n=g;break ld}f=v[N>>2];if(f>>>0<V>>>0|(!!j&(g|0)>=0|(g|0)>0)&(f|0)==(V|0)){break hd}v[E+44>>2]=ea;f=g>>31;i=f^j;m=f;f=i-f|0;n=(g^m)-((i>>>0<m>>>0)+m|0)|0}m=f;i=n;xc(E+8|0,v[E+28>>2]);f=v[ha>>2];za=f+16|0;Aa=v[E+8>>2];Qf(e,h,qf(j,g,Aa-1|0),nb);n=nb;Ba=f>>>0>V>>>0;if(!(!Ba&V>>>0<za>>>0)){b=b&-8193;v[I>>2]=b}md:{nd:{ka=v[E+20>>2];od:{if(ka){f=v[E+24>>2];if(f>>>0<=V>>>0){pd:{if((g|0)<0){j=0;g=f;break pd}j=e;g=h;e=0;h=v[Z>>2]}Xa=E,Ya=To(Sg(Sg(e,h,j,g),nb,1,0),nb,m,i)+1|0,v[Xa+44>>2]=Ya;v[Q+632>>2]=ka;break md}if(!(!(b&8192)|Ba|V>>>0>=za>>>0)){Xa=E,Ya=To(Sg(Sg(0,s+16|0,e,h),nb,1,0),nb,m,i)+1|0,v[Xa+44>>2]=Ya;Xa=Q,Ya=B(v[Z>>2]-s|0,Fk(x[v[ca>>2]+34>>1]))+ka|0,v[Xa+632>>2]=Ya;break md}if(!j&(g|0)<=0|(g|0)<0){break od}if(ea>>>0<2|f>>>0>n>>>0){break nd}Xa=E,Ya=To(Sg(Sg(0,f,e,h),nb,1,0),nb,m,i)+1|0,v[Xa+44>>2]=Ya;break md}if((g|0)>0|(g|0)>=0){break nd}}if((n|0)>=(s|0)){break md}Xa=E,Ya=To(Sg(Sg(e,h,0,s),nb,1,0),nb,m,i)+1|0,v[Xa+44>>2]=Ya;break md}b=v[N>>2];if((b|0)>(n|0)){break md}Xa=E,Ya=To(Sg(Sg(0,b,e,h),nb,1,0),nb,m,i)+1|0,v[Xa+44>>2]=Ya}So(E+44|0,1,Aa);g=v[E+44>>2];if((g|0)>0){break gd}}v[Q+632>>2]=0;v[N>>2]=0;v[l>>2]=0;v[l+4>>2]=0;v[Y>>2]=0;mD(l,c,a);v[J>>2]=v[J>>2]+v[X>>2];v[S>>2]=v[S>>2]+v[R>>2];v[R>>2]=0;v[X>>2]=0;v[I>>2]=v[I>>2]&-129;break fd}qd:{rd:{if(y[d+24608>>2]>Pa>>>0){b=4;if(v[Y>>2]){break rd}b=0;if(v[xa>>2]|v[ya>>2]){break rd}}Rb(l,Jka(v[K>>2],v[K+4>>2],g,g>>31),nb);ba=0;v[R>>2]=0;v[X>>2]=0;c=(g<<3)+c|0;break qd}e=(g<<3)+c|0;h=e-8|0;v[X>>2]=0-v[h>>2];f=e-4|0;v[R>>2]=0-v[f>>2];ob[v[((b|Oa)<<2)+27456>>2]](l,Ja,c,g);v[X>>2]=v[X>>2]+v[h>>2];v[R>>2]=v[R>>2]+v[f>>2];ba=1;c=e}b=v[Y>>2];sd:{if(!b){break sd}if(b>>>0<=g>>>0){v[Y>>2]=0;v[ya>>2]=v[Wa>>2];v[xa>>2]=v[Va>>2];v[Ua>>2]=0;v[Ta>>2]=0;if(v[Sa>>2]|!(w[I+1|0]&16)){break sd}v[N>>2]=0;v[Q+632>>2]=0;break sd}v[Y>>2]=b-g}e=0;h=0;b=v[l+4>>2];h=b>>>0>=y[Z>>2]?(w[I|0]&2)>>>1|0:h;f=b;b=v[N>>2];e=f>>>0<b>>>0|(!b|w[I|0]&2)?e:!x[Ra>>1];a=a-g|0;Db(E+8|0,ta,85);td:{ud:{vd:{wd:{if(!Cb(v[v[E+8>>2]>>2],v[E+12>>2])){break wd}b=w[Qa|0];if(!b|b>>>0>x[Na>>1]){break wd}b=B(b,104)+d|0;g=b+484380|0;f=v[ca>>2];if((g|0)==(f|0)|(e|h)!=1){break vd}v[ca>>2]=g;v[Q+632>>2]=v[b+484400>>2];e=x[b+484414>>1];v[I>>2]=e|v[I>>2]&-768;h=e<<30>>31;e=v[b+484388>>2];v[N>>2]=h&e;b=v[b+484384>>2];v[ha>>2]=b;v[Z>>2]=e;v[l+4>>2]=b;kD(q,l);if(!v[Q+632>>2]){break fd}if((a|0)>0){continue}break fd}if(h){break ud}break td}if(!h|(g|0)!=(f|0)){break td}}Db(E+8|0,ta,83);if(!Cb(v[v[E+8>>2]>>2],v[E+12>>2])|v[ha>>2]){break td}v[l>>2]=v[l>>2];v[l+4>>2]=0;b=v[v[ca>>2]+8>>2];v[N>>2]=b;v[Z>>2]=b}if((a|0)>0){continue}}break}v[Q+632>>2]=v[q>>2];ga=ba+ga|0;u[E+42>>1]=ga;if(!ba|wa){break bd}a=v[Md(ua,ja)>>2];if(!a){break bd}ob[v[v[a>>2]+152>>2]](a)}$=$+1|0;continue}break}}kb=E+48|0;i=v[d+1298300>>2];if(zd(i)){a=_;b=k;c=(B(v[d+480232>>2],v[d+480236>>2])>>>0)/48|0;l=kb-16|0;kb=l;xd:{if(!w[i+534|0]){break xd}e=Jka(c,0,6169,0);c=nb;f=c>>>16|0;p=Ec((c&65535)<<16|e>>>16,f);while(1){if(!b){break xd}f=v[i>>2];h=v[f>>2];c=v[f+4>>2];while(1){if((c|0)>=(h|0)){v[f+8>>2]=v[f+12>>2];h=0;j=0;q=0;c=kb-16|0;kb=c;while(1){if((q|0)==18){e=(h|0)<32767?h:32767;u[f+12>>1]=(e|0)>-32768?e:-32768;e=(j|0)<32767?j:32767;u[f+14>>1]=(e|0)>-32768?e:-32768;u[f+3832>>1]=x[f+3832>>1]+1;e=(x[f+3834>>1]+1>>>0)%13440|0;u[f+3834>>1]=e;e=e>>>0<6720?e:13440-e|0;u[f+3836>>1]=(e&65280)>>>8;if(!w[f+3843|0]){u[f+3836>>1]=(e&64512)>>>10}e=x[f+3838>>1]+1|0;u[f+3838>>1]=e;if((e&65535)>>>0>=1024){u[f+3838>>1]=0;u[f+3840>>1]=x[f+3840>>1]+1&7}kb=c+16|0}else{g=f+B(q,44)|0;yd:{if(!w[g+56|0]){u[c+12>>1]=0;u[c+14>>1]=0;break yd}n=v[g+32>>2];e=x[n+3840>>1];if(e&3){n=(x[g+36>>1]>>>7&7)>>>(w[n+3844|0]^1)>>>(e&1)<<x[g+38>>1];e=e&4?0-n|0:n}else{e=0}n=v[g+52>>2];zd:{if(n){r=x[n+32>>1];o=x[g+48>>1];n=ig(v[g+16>>2],v[g+40>>2],e<<16>>16,0,u[g+46>>1]);s=v[g+40>>2];m=v[g+20>>2];if(!r){if(!o){e=e<<16>>16;n=ig(m,s,e,n,0);n=ig(v[g+24>>2],v[g+40>>2],e,n,0);e=ig(v[g+28>>2],v[g+40>>2],e,n,0);break zd}e=e<<16>>16;s=ig(m,s,e,0,0);s=ig(v[g+24>>2],v[g+40>>2],e,s,0);e=ig(v[g+28>>2],v[g+40>>2],e,s,0)+n|0;break zd}if(!o){e=e<<16>>16;n=ig(m,s,e,n,0);s=ig(v[g+24>>2],v[g+40>>2],e,0,0);e=ig(v[g+28>>2],v[g+40>>2],e,s,0)+n|0;break zd}e=e<<16>>16;s=ig(m,s,e,0,0);e=(ig(v[g+24>>2],v[g+40>>2],e,s,0)+n|0)+ig(v[g+28>>2],v[g+40>>2],e,0,0)|0;break zd}o=x[g+48>>1];e=e<<16>>16;n=ig(v[g+16>>2],v[g+40>>2],e,0,u[g+46>>1]);s=v[g+40>>2];m=v[g+20>>2];if(!o){e=ig(m,s,e,n,0);break zd}e=ig(m,s,e,0,0)+n|0}u[c+14>>1]=w[g+57|0]?e:0;u[c+12>>1]=w[g+58|0]?e:0}q=q+1|0;j=u[c+12>>1]+j|0;h=u[c+14>>1]+h|0;continue}break}h=v[f>>2];c=v[f+4>>2]-h|0;v[f+4>>2]=c;continue}break}e=h-c|0;u[l+14>>1]=(B(u[f+12>>1],c)+B(e,u[f+8>>1])|0)/(h|0);u[l+12>>1]=(B(u[f+14>>1],c)+B(e,u[f+10>>1])|0)/(h|0);v[f+4>>2]=c+49716;v[a>>2]=v[a>>2]+B(p,u[l+14>>1]);v[a+4>>2]=v[a+4>>2]+B(p,u[l+12>>1]);a=a+8|0;b=b-1|0;continue}}kb=l+16|0}a=w[H+12|0];if(v[H+16>>2]?1:a){if(!a){an(aa,k,sa,ra)}a=v[H>>2];b=v[H+80>>2];c=B(a,b)>>>4|0;c=c>>>0<32767?c:32767;u[H+98>>1]=c;u[H+96>>1]=c;c=v[H+49948>>2];e=B(c,a)>>>4|0;e=e>>>0<65536?e:65536;g=e+127>>>3|0;u[H+49946>>1]=g;e=e+255>>>4|0;u[H+49944>>1]=e;u[H+49942>>1]=e;u[H+49940>>1]=g;b=(b|0)>(c|0)?b:c;a=36-a>>>1|0;a=16-(a>>>0>8?a:8)|0;a=16-(B((b|0)<32768?b:32768,a>>>0>16?0:a)>>15)|0;q=0;while(1){if((k|0)!=(q|0)){b=q<<3;c=b+_|0;v[c>>2]=v[c>>2]+B(a,v[b+aa>>2]>>4);b=b|4;c=b+_|0;v[c>>2]=v[c>>2]+B(a,v[b+aa>>2]>>4);q=q+1|0;continue}break}n=H+68|0;l=0;b=u[H+84>>1];c=v[H+40>>2];h=v[H+36>>2];while(1){if((k|0)==(l|0)){v[H+40>>2]=c;v[H+36>>2]=h;g=k}else{a=(l<<3)+aa|0;e=v[a>>2]>>12;h=(B(b,e-h|0)>>15)+e|0;v[a>>2]=h;e=a;a=v[a+4>>2]>>12;c=(B(b,a-c|0)>>15)+a|0;v[e+4>>2]=c;l=l+1|0;continue}break}if(g){b=aa;a=g;r=v[n>>2]-1|0;i=x[n+22>>1];e=u[n+26>>1];s=u[n+18>>1];c=x[n+20>>1];h=u[n+24>>1];m=u[n+16>>1];q=v[n+4>>2];f=n+32928|0;while(1){if(a){j=kd(v[b>>2]);l=kd(v[b+4>>2]);c=kd((c<<16>>16)-j|0);i=kd((i<<16>>16)-l|0);c=ed(kd((B(c,m)|0)/65536<<1)+j|0);i=ed(kd((B(i,s)|0)/65536<<1)+l|0);l=f+(q<<2)|0;p=u[l>>1];j=ed(((B(p,h)|0)/-65536|0)+c|0);q=q+1&127;o=f+(q<<2)|0;l=u[l+2>>1];A=ed(((B(l,e)|0)/-65536|0)+i|0);u[o+2>>1]=A;u[o>>1]=j;r=r+1&8191;o=n+(r<<2)|0;Xa=o,Ya=ed(p+((B(h,j)|0)/65536|0)|0),u[Xa+160>>1]=Ya;Xa=o,Ya=ed(l+((B(e,A)|0)/65536|0)|0),u[Xa+162>>1]=Ya;b=b+8|0;a=a-1|0;continue}break}u[n+22>>1]=i;u[n+20>>1]=c;v[n+4>>2]=q}j=H+49892|0;G=H+33508|0;b=g;a=aa;while(1){if(b){e=v[H+76>>2];h=e&4095;i=G+(h<<2)|0;c=a;h=4096-h|0;A=e-v[H+49892>>2]&4095;e=4096-A|0;e=e>>>0>h>>>0?h:e;e=b>>>0<e>>>0?b:e;h=e>>>0<64?e:64;q=h;e=0;s=kb-32|0;kb=s;f=v[n>>2];while(1){if((e|0)==7){Ad:{p=u[n+28>>1]/8<<16>>16;Bd:while(1){if(!q){break Ad}q=q-1|0;e=0;l=0;f=0;while(1)if((e|0)==4){e=4;r=0;o=ed((f|0)/32768|0);F=ed((l|0)/32768|0);l=0;while(1)if((e|0)==7){e=ed(o+((l|0)/32768|0)|0);u[i>>1]=e;v[c>>2]=B(e,p);e=ed(F+((r|0)/32768|0)|0);u[i+2>>1]=e;v[c+4>>2]=B(e,p);c=c+8|0;i=i+4|0;continue Bd}else{f=s+(e<<2)|0;m=v[f>>2]+1&8191;v[f>>2]=m;m=n+(m<<2)|0;E=u[m+160>>1];f=n+(e<<4)|0;m=u[m+162>>1];r=(B(E,u[f+44>>1])+r|0)+B(m,u[f+46>>1])|0;l=(B(E,u[f+40>>1])+l|0)+B(m,u[f+42>>1])|0;e=e+1|0;continue}}else{m=s+(e<<2)|0;o=v[m>>2]+1&8191;v[m>>2]=o;V=l;l=n+(o<<2)|0;o=u[l+160>>1];m=n+(e<<4)|0;r=u[l+162>>1];l=(V+B(o,u[m+44>>1])|0)+B(r,u[m+46>>1])|0;f=(B(o,u[m+40>>1])+f|0)+B(r,u[m+42>>1])|0;e=e+1|0;continue}}}}else{v[s+(e<<2)>>2]=f+(v[(n+(e<<4)|0)+32>>2]^-1);e=e+1|0;continue}break}kb=s+32|0;q=G+(A<<2)|0;e=a;c=h;f=v[j+4>>2];l=j+8256|0;s=j- -64|0;m=j+24640|0;i=j+16448|0;while(1){p=f&2047;if(c){E=u[l+((f+1206&2047)<<2)>>1];J=u[(l+((f+754&2047)<<2)|0)+2>>1];F=u[(s+((f+1602&2047)<<2)|0)+2>>1];I=u[s+((f+1750&2047)<<2)>>1];o=u[q>>1];r=u[q+2>>1];A=m+((f+502&2047)<<2)|0;K=u[A>>1];Q=kd(u[j+32>>1]-K|0);A=u[A+2>>1];N=kd(u[j+34>>1]-A|0);S=u[j+26>>1];R=m+((f+22&2047)<<2)|0;X=u[R>>1];Z=kd(u[j+36>>1]-X|0);Y=u[j+28>>1];R=u[R+2>>1];V=kd(u[j+38>>1]-R|0);$=u[j+30>>1];K=ed(kd((B(Q,u[j+24>>1])|0)/65536<<1)+K|0);u[j+32>>1]=K;Xa=j,Ya=ed(kd((B(N,S)|0)/65536<<1)+A|0),u[Xa+34>>1]=Ya;Xa=j,Ya=ed(kd((B(Z,Y)|0)/65536<<1)+X|0),u[Xa+36>>1]=Ya;A=ed(kd((B(V,$)|0)/65536<<1)+R|0);u[j+38>>1]=A;K=kd((B(K,u[j+16>>1])|0)/32768|0);A=kd((B(A,u[j+22>>1])|0)/32768|0);K=kd(K+((o|0)/4<<16>>16)|0);Q=kd(A+((r|0)/4<<16>>16)|0);o=u[j+8>>1];N=kd(K+((B(o,I)|0)/-65536|0)|0);r=p<<2;S=r+s|0;A=u[j+10>>1];R=kd(Q+((B(A,F)|0)/-65536|0)|0);u[S+2>>1]=R;u[S>>1]=N;I=kd(I+((B(o,N)|0)/65536|0)|0);N=i+r|0;F=kd(F+((B(A,R)|0)/65536|0)|0);u[N+2>>1]=F;u[N>>1]=I;I=kd(I+K|0);K=kd(F+Q|0);F=i+((f+682&2047)<<2)|0;Q=u[F+2>>1];N=u[F>>1];F=kd((B(Q,u[j+42>>1])+B(N,u[j+40>>1])|0)/32768|0);f=i+((f+426&2047)<<2)|0;S=u[f+2>>1];R=u[f>>1];f=kd((B(S,u[j+46>>1])+B(R,u[j+44>>1])|0)/32768|0);N=kd(kd(I+N|0)-F|0);Q=kd(kd(K+Q|0)-f|0);I=kd(kd(I+R|0)-F|0);K=kd(kd(K+S|0)-f|0);F=kd(F+((B(o,E)|0)/-65536|0)|0);S=l+r|0;R=kd(f+((B(A,J)|0)/-65536|0)|0);u[S+2>>1]=R;u[S>>1]=F;o=(B(o,F)|0)/65536|0;f=kd(o+E|0);r=m+r|0;A=(B(A,R)|0)/65536|0;F=kd(A+J|0);u[r+2>>1]=F;u[r>>1]=f;Xa=e,Ya=(v[e>>2]+B(kd(f+N|0),u[j+48>>1])|0)+B(kd(F+Q|0),u[j+50>>1])|0,v[Xa>>2]=Ya;Xa=e,Ya=(v[e+4>>2]+B(kd(kd(o)+I|0),u[j+52>>1])|0)+B(kd(kd(A)+K|0),u[j+54>>1])|0,v[Xa+4>>2]=Ya;e=e+8|0;f=p+1|0;q=q+4|0;c=c-1|0;continue}break}v[j+4>>2]=p;v[H+76>>2]=h+v[H+76>>2]&4095;v[H+68>>2]=h+v[H+68>>2]&8191;b=b-h|0;a=(h<<3)+a|0;continue}break}v[H+68>>2]=v[H+68>>2]&8191;l=aa;e=_;c=g;h=0;f=0;j=v[H+56>>2];b=v[H- -64>>2];q=v[H+52>>2];a=v[H+60>>2];while(1){if(c){h=v[l>>2];f=v[l+4>>2];b=b-f|0;b=(((b|0)/1024|0)-b|0)+j|0;v[e+4>>2]=b+v[e+4>>2];a=a-h|0;a=(((a|0)/1024|0)-a|0)+q|0;v[e>>2]=a+v[e>>2];j=b+((b|0)/-512|0)|0;q=a+((a|0)/-512|0)|0;e=e+8|0;l=l+8|0;c=c-1|0;a=h;b=f;continue}break}v[H+64>>2]=f;v[H+60>>2]=h;v[H+56>>2]=j;v[H+52>>2]=q;a=v[H+20>>2];Cd:{if(w[H+12|0]){break Cd}a=v[H+16>>2];if(a>>>0>g>>>0){a=a-g|0;break Cd}AK(H,sa,ra);a=0}t[H+12|0]=0;v[H+16>>2]=a}if(v[d+946300>>2]){Dd:{f=0;e=0;g=k<<2;q=d+906300|0;i=x[d+480214>>1]!=0;Ca=z[d+1074336>>2];W=z[d+1074332>>2];while(1)if((f|0)==250){h=d+12|0;n=d+12300|0;s=d+14348|0;sv(h,n,s,k,W);a=d+1074476|0;A=w[a|0];t[a|0]=0;a=s;c=n;while(1){Ed:{Fd:{Gd:{if((e|0)!=250){m=Md(q,e);l=v[m>>2];if(!l|!v[l+24>>2]){break Ed}if(!bi(l+44|0)){break Ed}j=l;Hd:{if(rv(w[m+24|0])){break Hd}b=ob[v[v[l>>2]+148>>2]](l)|0;j=v[m>>2];if(b){break Hd}f=0;if(w[j+28|0]&2){break Hd}while(1){if((e|0)==(f|0)){break Ed}b=Md(q,f);f=f+1|0;if((_m(v[b+28>>2])|0)!=(e|0)){continue}break}}b=v[l+44>>2];p=Jc(b,0);r=Jc(b,1);o=(c|0)==(p|0);c=o?n:c;b=c;a=o?s:a;f=v[m+28>>2];g=a;Id:{if(!f){break Id}b=c;f=_m(f);g=a;if(f>>>0<=e>>>0){break Id}g=a;if(f>>>0>249){break Id}f=v[Md(q,f)>>2];g=a;if(!f){break Id}if(!(w[j+28|0]&4)){ob[v[v[f>>2]+152>>2]](f)}g=a;if(!bi(f+44|0)){break Id}g=v[f+44>>2];b=Jc(g,0);g=Jc(g,1)}if(!rv(w[m+24|0])){break Fd}f=0;Jd:{if(o){break Jd}while(1){if((f|0)==(k|0)){break Jd}o=f<<2;F=o+p|0;G=c+o|0;z[F>>2]=z[G>>2]+z[F>>2];F=o+r|0;o=a+o|0;z[F>>2]=z[o>>2]+z[F>>2];v[G>>2]=0;v[o>>2]=0;f=f+1|0;continue}}a=g;c=b;if(!(i&1)){break Fd}a=v[m>>2];if(a){ob[v[v[a>>2]+152>>2]](a)}f=_m(v[m+28>>2]);a=e;while(1){c=f;f=c&255;if(f>>>0>249|f>>>0<=(a&255)>>>0){break Gd}o=Md(q,f);f=_m(v[o+28>>2]);a=c;c=v[o>>2];if(!c){continue}ob[v[v[c>>2]+152>>2]](c);continue}}b=0;while(1){if((b|0)!=(k|0)){W=C(z[c>>2]*Ca);Kd:{if(C(D(W))<C(2147483648)){e=~~W;break Kd}e=-2147483648}v[h>>2]=e;W=C(z[a>>2]*Ca);Ld:{if(C(D(W))<C(2147483648)){e=~~W;break Ld}e=-2147483648}v[h+4>>2]=e;b=b+1|0;h=h+8|0;a=a+4|0;c=c+4|0;continue}break}break Dd}a=g;c=b}f=0;Md:{Nd:{o=w[m+24|0];if(!((o&2)>>>1|0)){if(!hD(o)|!(w[j+28|0]&4)){break Nd}}while(1){if((f|0)==(k|0)){break Md}l=f<<2;m=l+b|0;z[m>>2]=z[l+p>>2]+z[m>>2];m=g+l|0;z[m>>2]=z[l+r>>2]+z[m>>2];f=f+1|0;continue}}if(A){ob[v[v[l>>2]+132>>2]](l)}ob[v[v[l>>2]+60>>2]](l,b,g,k);v[j+32>>2]=k+v[j+32>>2];if(!hD(w[m+24|0])){break Md}if((ob[v[v[l>>2]+160>>2]](l)|0)<=0|y[j+32>>2]<v[d+24620>>2]<<2>>>0){break Md}Od:{while(1){if((f|0)==(k|0)){break Od}l=f<<2;W=z[l+b>>2];Pd:{if(W>=C(1.1920928955078125e-7)|W<=C(-1.1920928955078125e-7)){break Pd}W=z[g+l>>2];if(W>=C(1.1920928955078125e-7)){break Pd}f=f+1|0;if(!(W<=C(-1.1920928955078125e-7))){continue}}break}v[j+32>>2]=0;break Md}v[j+28>>2]=v[j+28>>2]|4}v[j+28>>2]=v[j+28>>2]&-3}e=e+1|0;continue}}else{h=Md(q,f);a=v[h>>2];Qd:{if(!a|!v[a+24>>2]){break Qd}if(!bi(a+44|0)){break Qd}if(!(ob[v[v[a>>2]+116>>2]](a)|0)){ob[v[v[a>>2]+112>>2]](a,1);ob[v[v[a>>2]+124>>2]](a)}c=v[a+44>>2];b=Jc(c,0);c=Jc(c,1);Rd:{if(t[a+28|0]&1){sv(v[a+24>>2],b,c,k,W);break Rd}j=a+40|0;if(v[a+36>>2]?1:v[j>>2]){an(v[a+24>>2],k,j,a+36|0);sv(v[a+24>>2],b,c,k,W);break Rd}Ub(b,0,g);Ub(c,0,g)}b=a;a=v[a+28>>2];v[b+28>>2]=a&-2;if(rv(w[h+24|0])){break Qd}i=!(a&4)|i}f=f+1|0;continue}}}if(v[d+24624>>2]==1){b=0;while(1){if((b|0)!=(k|0)){a=(b<<3)+_|0;v[(b<<2)+_>>2]=(v[a+4>>2]+v[a>>2]|0)/2;b=b+1|0;continue}break}}if(Qd(w[Ia|0])){c=0;g=kb-16|0;kb=g;Sd:{if(!v[d+1074376>>2]){l=d+1074460|0;a=l;v[a>>2]=0;v[a+4>>2]=0;a=v[d+1074456>>2];v[d+1074468>>2]=a;break Sd}a=v[d+1074456>>2];b=v[d+1074468>>2];Td:{if((a|0)==(b|0)){e=v[d+1074460>>2];break Td}v[d+1074468>>2]=a;e=v[d+24620>>2];h=d+1074460|0;Ud:{if((a|0)>(b|0)){e=yt(e,v[d+24636>>2]);break Ud}e=yt(e,v[d+24640>>2])}v[h>>2]=e;v[d+1074464>>2]=e;b=a}l=d+1074460|0;if((e|0)<=0){break Sd}b=(b<<12)-v[d+1074472>>2]|0;c=(b|0)/(e|0)|0;if(w[d+1074368|0]!=2){break Sd}v[g+12>>2]=50;h=v[d+1074464>>2];v[g+8>>2]=1e4/(h+1|0);f=v[Pe(g+12|0,g+8|0)>>2];while(1){j=c>>31;if((f|0)>=((j^c)-j|0)){break Sd}e=e+h|0;v[l>>2]=e;c=(b|0)/(e|0)|0;continue}}Vd:{Wd:{switch(v[d+24624>>2]-1|0){case 0:b=0;f=(k|0)>0?k:0;j=a<<12;e=d+12|0;n=a>>31;while(1){if((b|0)==(f|0)){break Vd}Xd:{if(v[l>>2]>0){h=v[d+1074472>>2]+c|0;v[d+1074472>>2]=h;s=v[e>>2];Xa=e,Ya=Hc(Kka(Jka(s,s>>31,h,h>>31),nb,1048576,0),nb),v[Xa>>2]=Ya;v[d+1074460>>2]=v[d+1074460>>2]-1;break Xd}h=v[e>>2];Xa=e,Ya=Hc(Kka(Jka(h,h>>31,a,n),nb,256,0),nb),v[Xa>>2]=Ya;v[d+1074472>>2]=j}b=b+1|0;e=e+4|0;continue};case 1:b=0;j=(k|0)>0?k:0;n=a<<12;e=d+12|0;h=a>>31;while(1){if((b|0)==(j|0)){break Vd}Yd:{if(v[l>>2]>0){f=v[d+1074472>>2]+c|0;v[d+1074472>>2]=f;s=v[e>>2];Xa=e,Ya=Hc(Kka(Jka(s,s>>31,f,f>>31),nb,1048576,0),nb),v[Xa>>2]=Ya;f=v[d+1074472>>2];m=f;s=f>>31;f=v[e+4>>2];Xa=e,Ya=Hc(Kka(Jka(m,s,f,f>>31),nb,1048576,0),nb),v[Xa+4>>2]=Ya;v[d+1074460>>2]=v[d+1074460>>2]-1;break Yd}f=v[e>>2];Xa=e,Ya=Hc(Kka(Jka(f,f>>31,a,h),nb,256,0),nb),v[Xa>>2]=Ya;f=v[e+4>>2];Xa=e,Ya=Hc(Kka(Jka(f,f>>31,a,h),nb,256,0),nb),v[Xa+4>>2]=Ya;v[d+1074472>>2]=n}b=b+1|0;e=e+8|0;continue};case 3:break Wd;default:break Vd}}f=0;n=(k|0)>0?k:0;s=a<<12;e=d+8204|0;b=d+12|0;h=a>>31;while(1){if((f|0)==(n|0)){break Vd}Zd:{if(v[l>>2]>0){j=v[d+1074472>>2]+c|0;v[d+1074472>>2]=j;m=v[b>>2];Xa=b,Ya=Hc(Kka(Jka(m,m>>31,j,j>>31),nb,1048576,0),nb),v[Xa>>2]=Ya;j=v[d+1074472>>2];m=j;i=j>>31;j=v[b+4>>2];Xa=b,Ya=Hc(Kka(Jka(m,i,j,j>>31),nb,1048576,0),nb),v[Xa+4>>2]=Ya;j=v[d+1074472>>2];m=j;i=j>>31;j=v[e>>2];Xa=e,Ya=Hc(Kka(Jka(m,i,j,j>>31),nb,1048576,0),nb),v[Xa>>2]=Ya;j=v[d+1074472>>2];m=j;i=j>>31;j=v[e+4>>2];Xa=e,Ya=Hc(Kka(Jka(m,i,j,j>>31),nb,1048576,0),nb),v[Xa+4>>2]=Ya;v[d+1074460>>2]=v[d+1074460>>2]-1;break Zd}j=v[b>>2];Xa=b,Ya=Hc(Kka(Jka(j,j>>31,a,h),nb,256,0),nb),v[Xa>>2]=Ya;j=v[b+4>>2];Xa=b,Ya=Hc(Kka(Jka(j,j>>31,a,h),nb,256,0),nb),v[Xa+4>>2]=Ya;j=v[e>>2];Xa=e,Ya=Hc(Kka(Jka(j,j>>31,a,h),nb,256,0),nb),v[Xa>>2]=Ya;j=v[e+4>>2];Xa=e,Ya=Hc(Kka(Jka(j,j>>31,a,h),nb,256,0),nb),v[Xa+4>>2]=Ya;v[d+1074472>>2]=s}f=f+1|0;e=e+8|0;b=b+8|0;continue}}kb=g+16|0}if(v[pa>>2]!=128){b=d+12|0;c=d+8204|0;a=v[d+24604>>2];e=v[d+24624>>2];_d:{if((a|0)==128|e>>>0<2){break _d}pM(b,k,a);if(e>>>0<4){break _d}pM(c,k,a)}}if(v[d+24624>>2]==4){a=k;while(1){a=a-1|0;if((a|0)>=0){b=(a<<4)+_|0;c=a<<3;e=c|4;v[b+12>>2]=v[e+qa>>2];v[b+8>>2]=v[c+qa>>2];v[b+4>>2]=v[e+_>>2];v[b>>2]=v[c+_>>2];continue}break}}if(Qd(Ea)){a=v[d+24624>>2];v[M+72>>2]=k;v[M+68>>2]=a;v[M+64>>2]=_;a=v[v[na>>2]+8>>2];v[M+24>>2]=k;b=v[M+68>>2];v[M+16>>2]=v[M+64>>2];v[M+20>>2]=b;ob[a|0](na,M+16|0)}a=v[d+24624>>2];v[M+56>>2]=k;v[M+52>>2]=a;v[M+48>>2]=_;a=v[v[la>>2]+8>>2];v[M+8>>2]=k;b=v[M+52>>2];v[M>>2]=v[M+48>>2];v[M+4>>2]=b;ob[a|0](la,M);v[d+1074380>>2]=v[d+1074380>>2]-k;v[d+1074376>>2]=k+v[d+1074376>>2];fa=fa-k|0;Da=k+Da|0;continue}break}kb=da+32|0;return Da}function wg(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=C(0),k=0,m=0,o=0,p=0,r=0,s=0,E=C(0),F=0,G=0,H=C(0),I=0,J=0,K=0,M=0,N=0;k=kb-2288|0;kb=k;a:{b:{c:{d:{e:{f:{if(uv(v[c>>2])){xc(b,268435456);J=v[c+8>>2];G=k+2264|0;e=G;v[e>>2]=0;v[e+4>>2]=0;Tb(e+8|0);v[k+2260>>2]=0;g:{h:{i:{j:{k:{l:{e=w[a+3|0];m:{n:{if((e-4&255)>>>0<=4){v[23540]=0;d=S(202,c|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break l}v[k+2260>>2]=d;break n}if(e>>>0>17){break m}o:{g=1<<e;if(!(g&63503)){if(!(g&198144)){break m}break o}if(w[a|0]){break o}break n}e=0;f=SA(a,v[b>>2]);v[23540]=0;U(203,k+96|0,c|0,f|0);f=v[23540];v[23540]=0;if((f|0)==1){break k}d=k+96|0;f=v[d+4>>2];v[G>>2]=v[d>>2];v[G+4>>2]=f;Lm(G+8|0,d+8|0);Uc(d);f=Ie(G);d=v[G>>2];v[k+2260>>2]=d;if(!f){break g}}e=w[a+3|0]}h=1;p:{q:{switch(e&255){case 0:case 1:case 2:case 3:case 11:case 12:case 13:case 14:case 15:h=!w[a|0];break p;case 9:case 10:case 16:case 17:break q;default:break p}}h=0}g=v[b>>2];if(!(g>>>0<262145|h)){e=e&255;v[k+96>>2]=((e|0)==10)<<4;h=d-v[Kb(k+96|0,k+2260|0)>>2]|0;if(e>>>0>15){break j}r:{if(!(1<<e&63503)){if((e|0)==10){break r}break j}if(!(w[a|0]&7)){break j}}e=(h|0)>=0?h<<1:-1;break i}e=e&255;if(e>>>0>8){break h}if(!(1<<e&432)){if((e|0)!=6){break h}e=0;if(d>>>0<10){break g}v[23540]=0;Q(188,c|0,4)|0;d=v[23540];v[23540]=0;if((d|0)==1){break l}v[23540]=0;e=S(157,c|0)|0;d=v[23540];v[23540]=0;if((d|0)!=1){v[k+96>>2]=e;v[k+72>>2]=v[k+2260>>2];d=v[Kb(k+96|0,k+72|0)>>2];yg(c,8);e=((d>>>0>50529027?-1:B(d,85))>>>0)/(w[a|0]>>>3>>>0)|0;break i}a=P()|0;O()|0;break a}e=8/(qq(w[a+1|0])>>>0)|0;Jka(e,0,d,0);e=nb?-1:B(e,d);break i}a=P()|0;O()|0;break a}a=P()|0;O()|0;break a}g=0;d=qq(w[a+1|0]);s:{t:{switch(e|0){case 0:case 1:case 2:case 3:case 11:case 12:case 13:case 14:case 15:g=w[a|0];break s;case 9:g=16;break s;case 10:g=4;break s;case 16:case 17:break t;default:break s}}g=8}e=B(d,g&255)>>>3|0;d=(e+h|0)-1|0;e=((d>>>0<h>>>0?-1:d)>>>0)/(e>>>0)|0}xc(b,e);g=v[b>>2]}if(!g){e=0;break g}u[b+34>>1]=x[b+34>>1]&65470|w[a|0]>15|(w[a+1|0]!=1)<<6;if(!Mg(b)){e=0;v[b>>2]=0;break g}u:{if(ne(a,Zc(k+96|0,8,1,0,10))){v[23540]=0;d=Q(204,c|0,k+96|0)|0;a=v[23540];v[23540]=0;if((a|0)!=1){e=0;if(!d){break u}a=v[b>>2];d=0;v[23540]=0;v[k+72>>2]=a+1>>>1;e=S(202,c|0)|0;a=v[23540];v[23540]=0;if((a|0)==1){break b}xc(k+72|0,e);a=f+16|0;b=v[b+20>>2];h=v[k+72>>2];e=h;while(1)if(e){g=k+96|0;f=d+w[g|w[a|0]&15]|0;t[b|0]=f;d=w[g|w[a|0]>>>4]+(f&255)|0;t[b+1|0]=d;e=e-1|0;a=a+1|0;b=b+2|0;continue}else{e=h+16|0;break u}}a=P()|0;O()|0;break a}v:{w:{x:{y:{z:{A:{B:{C:{D:{E:{F:{G:{H:{g=w[a+3|0];switch(g-4|0){case 3:break D;case 4:break E;case 5:break F;case 2:break G;case 0:case 1:break H;default:break B}}v[23540]=0;b=fa(205,k+1168|0,c|0,b|0,(g|0)==5|0)|0;a=v[23540];v[23540]=0;if((a|0)==1){break f}Bb(b);e=v[c+8>>2]-J|0;break u}if(w[a+1|0]!=1){break C}v[23540]=0;Q(188,c|0,4)|0;a=v[23540];v[23540]=0;if((a|0)==1){break f}v[23540]=0;f=S(157,c|0)|0;a=v[23540];v[23540]=0;I:{J:{K:{if((a|0)!=1){v[23540]=0;v[k+72>>2]=f;h=S(206,c|0)|0;a=v[23540];v[23540]=0;if((a|0)==1){break K}v[23540]=0;U(207,k+96|0,c|0,f|0);a=v[23540];v[23540]=0;if((a|0)==1){break J}xc(k+72|0,v[k+96>>2]);g=v[k+72>>2];e=Ie(k+96|0);d=x[b+34>>1];f=v[b+20>>2];b=v[b>>2];a=v[k+96>>2];v[23540]=0;da(208,e|0,a|0,f|0,Ij(b,d)|0,h<<24>>24);a=v[23540];v[23540]=0;if((a|0)==1){break I}e=g+9|0;Uc(k+96|0);break u}a=P()|0;O()|0;break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;Uc(k+96|0);break a}if(w[a+1|0]!=1|w[a|0]!=16){break C}e=v[k+2260>>2];d=Ak(k+1160|0);a=v[b>>2];b=v[b+20>>2];g=x[d>>1];h=kb-16|0;kb=h;v[h+12>>2]=e>>>1;v[h+8>>2]=a;d=v[Kb(h+12|0,h+8|0)>>2];e=d;while(1){if(e){a=w[f|0]+g|0;g=a+w[f+1|0]|0;u[b>>1]=g<<8|a&255;b=b+2|0;f=f+2|0;e=e-1|0;continue}break}kb=h+16|0;e=d<<1;break u}if(w[a+1|0]!=1|w[a|0]>16){break C}d=v[c+8>>2];f=v[c>>2];e=0;v[23540]=0;d=W(156,f|0,d|0,8)|0;f=v[23540];v[23540]=0;if((f|0)==1){break f}if(!d){break u}v[23540]=0;d=S(157,c|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break f}v[k+2260>>2]=d;if(d>>>0<4){break u}v[23540]=0;U(190,k+72|0,c|0,d|0);f=v[23540];v[23540]=0;if((f|0)==1){break c}f=k+72|0;s=rr(k+96|0,f);Bb(f);f=v[s>>2];v[23540]=0;d=S(209,f|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break e}e=d+4|0;p=w[a|0];m=(p|0)!=16;g=0;h=0;while(1){if(y[b>>2]<=h>>>0){break w}L:{if(m){break L}v[23540]=0;r=Q(164,s|0,8)|0;a=v[23540];v[23540]=0;if((a|0)!=1){break L}a=V(30544)|0;break x}v[23540]=0;i=Q(164,s|0,1)|0;a=v[23540];v[23540]=0;if((a|0)==1){break y}v[23540]=0;f=Q(164,s|0,1)|0;a=v[23540];v[23540]=0;if((a|0)==1){break y}M:{N:{O:{if(!f){f=8;while(1){v[23540]=0;d=Q(164,s|0,1)|0;a=v[23540];v[23540]=0;if((a|0)==1){break M}if(d){break O}f=f+16|0;continue}}v[23540]=0;a=Q(164,s|0,3)|0;f=v[23540];v[23540]=0;if((f|0)!=1){break N}break y}v[23540]=0;d=Q(164,s|0,4)|0;a=v[23540];v[23540]=0;if((a|0)==1){break y}a=f+d|0}g=(g&255)+(((i?-1:0)^a)&255)|0;P:{if((p|0)!=16){t[v[b+20>>2]+h|0]=g;break P}u[v[b+20>>2]+(h<<1)>>1]=r&255|g<<8}h=h+1|0;continue}break}a=V(30544)|0;break x}if(w[a+1|0]!=1){break B}break A}if((g|0)!=7){break B}if(w[a+1|0]==1){break A}}e=w[a|0];break z}e=w[a|0];if(e>>>0>16){break z}e=0;if(y[k+2260>>2]<5){break u}d=x[b+34>>1];f=v[b+20>>2];a=v[b>>2];v[23540]=0;e=W(210,c|0,f|0,Ij(a,d)|0)|0;a=v[23540];v[23540]=0;if((a|0)!=1){break u}break f}Q:{if((g&254)!=16|(e&255)!=16){break Q}d=w[a+1|0];if((d-1&255)>>>0>1){break Q}K=k,M=B(v[b>>2],qq(d)),v[K+96>>2]=M;xc(k+96|0,v[k+2260>>2]);a=v[b+20>>2];e=v[k+96>>2];if((g|0)==16){b=e;while(1){if(!b){break u}K=a,M=x[cc(30576,w[f|0])>>1],u[K>>1]=M;a=a+2|0;f=f+1|0;b=b-1|0;continue}}b=e;while(1){if(!b){break u}K=a,M=x[cc(31088,w[f|0])>>1],u[K>>1]=M;a=a+2|0;f=f+1|0;b=b-1|0;continue}}d=(e&255)!=8;if(!(d|w[a+1|0]!=1)){R:{switch(g|0){case 0:a=v[b>>2];b=v[b+20>>2];d=kb-16|0;kb=d;v[d+12>>2]=v[k+2260>>2];v[d+8>>2]=a;a=v[Kb(d+12|0,d+8|0)>>2];e=a;while(1){if(e){t[b|0]=w[f|0];b=b+1|0;f=f+1|0;e=e-1|0;continue}break};kb=d+16|0;e=a;break u;case 1:a=v[b>>2];b=v[b+20>>2];d=kb-16|0;kb=d;v[d+12>>2]=v[k+2260>>2];v[d+8>>2]=a;a=v[Kb(d+12|0,d+8|0)>>2];e=a;while(1){if(e){t[b|0]=w[f|0]^128;b=b+1|0;f=f+1|0;e=e-1|0;continue}break};kb=d+16|0;e=a;break u;default:e=0;if((g|0)!=11){break u}break;case 2:break R}}e=v[k+2260>>2];d=Cr(k- -64|0);a=v[b>>2];b=v[b+20>>2];g=w[d|0];d=kb-16|0;kb=d;v[d+12>>2]=e;v[d+8>>2]=a;a=v[Kb(d+12|0,d+8|0)>>2];e=a;while(1){if(e){g=w[f|0]+g|0;t[b|0]=g;b=b+1|0;f=f+1|0;e=e-1|0;continue}break}kb=d+16|0;e=a;break u}if(!(w[a+1|0]!=3|d)){S:{switch(g|0){case 0:i=kb-16|0;kb=i;e=v[k+2260>>2];v[i+12>>2]=e;d=v[b>>2];v[i+8>>2]=d;a=i+8|0;g=v[Kb(a,i+12|0)>>2];v[i+8>>2]=d;v[i+4>>2]=e-g;e=v[Kb(a,i+4|0)>>2];h=v[b+20>>2];a=g;d=f;while(1){if(a){t[h|0]=w[d|0];h=h+2|0;d=d+1|0;a=a-1|0;continue}break};h=v[b+20>>2]+1|0;d=v[b>>2]+f|0;a=e;while(1){if(a){t[h|0]=w[d|0];h=h+2|0;d=d+1|0;a=a-1|0;continue}break};kb=i+16|0;e=e+g|0;break u;case 1:i=kb-16|0;kb=i;e=v[k+2260>>2];v[i+12>>2]=e;d=v[b>>2];v[i+8>>2]=d;a=i+8|0;g=v[Kb(a,i+12|0)>>2];v[i+8>>2]=d;v[i+4>>2]=e-g;e=v[Kb(a,i+4|0)>>2];h=v[b+20>>2];a=g;d=f;while(1){if(a){t[h|0]=w[d|0]^128;h=h+2|0;d=d+1|0;a=a-1|0;continue}break};h=v[b+20>>2]+1|0;d=v[b>>2]+f|0;a=e;while(1){if(a){t[h|0]=w[d|0]^128;h=h+2|0;d=d+1|0;a=a-1|0;continue}break};kb=i+16|0;e=e+g|0;break u;default:e=0;if((g|0)!=11){break u}break;case 2:break S}}h=v[k+2260>>2];e=w[Cr(k+56|0)|0];p=kb-16|0;kb=p;v[p+12>>2]=h;g=v[b>>2];v[p+8>>2]=g;d=p+8|0;i=v[Kb(d,p+12|0)>>2];v[p+8>>2]=g;v[p+4>>2]=h-i;h=v[Kb(d,p+4|0)>>2];m=b;r=v[b+20>>2];d=e;b=i;g=f;while(1){if(b){d=w[g|0]+d|0;t[r|0]=d;r=r+2|0;g=g+1|0;b=b-1|0;continue}break}r=v[m+20>>2]+1|0;g=v[m>>2]+f|0;b=h;while(1){if(b){e=w[g|0]+e|0;t[r|0]=e;r=r+2|0;g=g+1|0;b=b-1|0;continue}break}kb=p+16|0;e=h+i|0;if(w[a+3|0]!=11){break u}a=v[m+20>>2];b=a+(v[m>>2]<<1)|0;while(1){if(a>>>0>=b>>>0){break u}t[a+1|0]=w[a+1|0]+w[a|0];a=a+2|0;continue}}d=e&255;if(!((d|0)!=8|w[a+1|0]!=2)){e=0;T:{switch(g|0){case 0:a=v[b>>2];b=v[b+20>>2];d=kb-16|0;kb=d;v[d+12>>2]=v[k+2260>>2]>>>1;v[d+8>>2]=a;a=v[Kb(d+12|0,d+8|0)>>2];e=a;while(1){if(e){t[b|0]=w[f|0];t[b+1|0]=w[f+1|0];b=b+2|0;f=f+2|0;e=e-1|0;continue}break};kb=d+16|0;e=a<<1;break u;case 1:a=v[b>>2];b=v[b+20>>2];d=kb-16|0;kb=d;v[d+12>>2]=v[k+2260>>2]>>>1;v[d+8>>2]=a;a=v[Kb(d+12|0,d+8|0)>>2];e=a;while(1){if(e){t[b|0]=w[f|0]^128;t[b+1|0]=w[f+1|0]^128;b=b+2|0;f=f+2|0;e=e-1|0;continue}break};kb=d+16|0;e=a<<1;break u;case 2:break T;default:break u}}e=v[k+2260>>2];a=Cr(k+48|0);d=v[b>>2];g=v[b+20>>2];a=w[a|0];h=kb-16|0;kb=h;v[h+12>>2]=e>>>1;v[h+8>>2]=d;b=a;e=v[Kb(h+12|0,h+8|0)>>2];d=e;while(1){if(d){a=w[f|0]+a|0;t[g|0]=a;b=w[f+1|0]+b|0;t[g+1|0]=b;g=g+2|0;f=f+2|0;d=d-1|0;continue}break}kb=h+16|0;e=e<<1;break u}if(!(w[a+2|0]|((d|0)!=16|w[a+1|0]!=1))){U:{switch(g|0){case 0:a=v[b>>2];b=v[b+20>>2];d=kb-16|0;kb=d;v[d+12>>2]=v[k+2260>>2]>>>1;v[d+8>>2]=a;a=v[Kb(d+12|0,d+8|0)>>2];e=a;while(1){if(e){u[b>>1]=w[f|0]|w[f+1|0]<<8;b=b+2|0;f=f+2|0;e=e-1|0;continue}break};kb=d+16|0;e=a<<1;break u;case 1:a=v[b>>2];b=v[b+20>>2];d=kb-16|0;kb=d;v[d+12>>2]=v[k+2260>>2]>>>1;v[d+8>>2]=a;a=v[Kb(d+12|0,d+8|0)>>2];e=a;while(1){if(e){u[b>>1]=(w[f|0]|w[f+1|0]<<8)^32768;b=b+2|0;f=f+2|0;e=e-1|0;continue}break};kb=d+16|0;e=a<<1;break u;default:e=0;if((g|0)!=11){break u}break;case 2:break U}}e=v[k+2260>>2];d=Ak(k+40|0);a=v[b>>2];b=v[b+20>>2];g=x[d>>1];d=kb-16|0;kb=d;v[d+12>>2]=e>>>1;v[d+8>>2]=a;a=v[Kb(d+12|0,d+8|0)>>2];e=a;while(1){if(e){g=(w[f|0]+g|0)+(w[f+1|0]<<8)|0;u[b>>1]=g;b=b+2|0;f=f+2|0;e=e-1|0;continue}break}kb=d+16|0;e=a<<1;break u}d=e&255;if(!((d|0)!=16|w[a+1|0]!=1|w[a+2|0]!=1)){e=0;V:{switch(g|0){case 0:a=v[b>>2];b=v[b+20>>2];g=kb-16|0;kb=g;v[g+12>>2]=v[k+2260>>2]>>>1;v[g+8>>2]=a;d=v[Kb(g+12|0,g+8|0)>>2];e=d;while(1){if(e){a=w[f|0]|w[f+1|0]<<8;u[b>>1]=a<<8|a>>>8;b=b+2|0;f=f+2|0;e=e-1|0;continue}break};kb=g+16|0;e=d<<1;break u;case 1:a=v[b>>2];b=v[b+20>>2];g=kb-16|0;kb=g;v[g+12>>2]=v[k+2260>>2]>>>1;v[g+8>>2]=a;d=v[Kb(g+12|0,g+8|0)>>2];e=d;while(1){if(e){a=w[f|0]|w[f+1|0]<<8;u[b>>1]=(a<<8|a>>>8)^32768;b=b+2|0;f=f+2|0;e=e-1|0;continue}break};kb=g+16|0;e=d<<1;break u;case 2:break V;default:break u}}e=v[k+2260>>2];d=Ak(k+32|0);a=v[b>>2];b=v[b+20>>2];g=x[d>>1];d=kb-16|0;kb=d;v[d+12>>2]=e>>>1;v[d+8>>2]=a;a=v[Kb(d+12|0,d+8|0)>>2];e=a;while(1){if(e){g=(w[f+1|0]+g|0)+(w[f|0]<<8)|0;u[b>>1]=g;b=b+2|0;f=f+2|0;e=e-1|0;continue}break}kb=d+16|0;e=a<<1;break u}h=a;if(!(w[a+2|0]|((d|0)!=16|w[a+1|0]!=3))){W:{switch(g|0){case 0:m=kb-16|0;kb=m;d=v[k+2260>>2];v[m+12>>2]=d;i=v[b>>2]<<1;v[m+8>>2]=i;a=m+8|0;g=v[Kb(a,m+12|0)>>2];v[m+8>>2]=i;v[m+4>>2]=d-g;a=v[Kb(a,m+4|0)>>2];e=v[b+20>>2];h=g>>>1|0;g=h;d=f;while(1){if(g){u[e>>1]=w[d|0]|w[d+1|0]<<8;e=e+4|0;d=d+2|0;g=g-1|0;continue}break};e=f+i|0;d=v[b+20>>2]+2|0;a=a>>>1|0;g=a;while(1){if(g){u[d>>1]=w[e|0]|w[e+1|0]<<8;d=d+4|0;e=e+2|0;g=g-1|0;continue}break};kb=m+16|0;e=a+h<<1;break u;case 1:m=kb-16|0;kb=m;d=v[k+2260>>2];v[m+12>>2]=d;i=v[b>>2]<<1;v[m+8>>2]=i;a=m+8|0;g=v[Kb(a,m+12|0)>>2];v[m+8>>2]=i;v[m+4>>2]=d-g;a=v[Kb(a,m+4|0)>>2];e=v[b+20>>2];h=g>>>1|0;g=h;d=f;while(1){if(g){u[e>>1]=(w[d|0]|w[d+1|0]<<8)^32768;e=e+4|0;d=d+2|0;g=g-1|0;continue}break};e=f+i|0;d=v[b+20>>2]+2|0;a=a>>>1|0;g=a;while(1){if(g){u[d>>1]=(w[e|0]|w[e+1|0]<<8)^32768;d=d+4|0;e=e+2|0;g=g-1|0;continue}break};kb=m+16|0;e=a+h<<1;break u;default:e=0;if((g|0)!=11){break u}break;case 2:break W}}g=v[k+2260>>2];a=x[Ak(k+24|0)>>1];s=kb-16|0;kb=s;v[s+12>>2]=g;p=v[b>>2]<<1;v[s+8>>2]=p;d=s+8|0;e=v[Kb(d,s+12|0)>>2];v[s+8>>2]=p;v[s+4>>2]=g-e;m=v[Kb(d,s+4|0)>>2];g=b;d=v[g+20>>2];b=a;i=e>>>1|0;r=i;e=f;while(1){if(r){b=(w[e|0]+b|0)+(w[e+1|0]<<8)|0;u[d>>1]=b;d=d+4|0;e=e+2|0;r=r-1|0;continue}break}e=f+p|0;d=v[g+20>>2]+2|0;b=m>>>1|0;r=b;while(1){if(r){a=(w[e|0]+a|0)+(w[e+1|0]<<8)|0;u[d>>1]=a;d=d+4|0;e=e+2|0;r=r-1|0;continue}break}kb=s+16|0;e=b+i<<1;if(w[h+3|0]!=11){break u}a=v[g+20>>2];b=a+(v[g>>2]<<2)|0;while(1){if(a>>>0>=b>>>0){break u}u[a+2>>1]=x[a+2>>1]+x[a>>1];a=a+4|0;continue}}a=e&255;if(!((a|0)!=16|w[h+1|0]!=3|w[h+2|0]!=1)){e=0;X:{switch(g|0){case 0:p=kb-16|0;kb=p;d=v[k+2260>>2];v[p+12>>2]=d;m=v[b>>2]<<1;v[p+8>>2]=m;a=p+8|0;g=v[Kb(a,p+12|0)>>2];v[p+8>>2]=m;v[p+4>>2]=d-g;i=v[Kb(a,p+4|0)>>2];e=v[b+20>>2];h=g>>>1|0;g=h;d=f;while(1){if(g){a=w[d|0]|w[d+1|0]<<8;u[e>>1]=a<<8|a>>>8;e=e+4|0;d=d+2|0;g=g-1|0;continue}break};e=f+m|0;d=v[b+20>>2]+2|0;b=i>>>1|0;g=b;while(1){if(g){a=w[e|0]|w[e+1|0]<<8;u[d>>1]=a<<8|a>>>8;d=d+4|0;e=e+2|0;g=g-1|0;continue}break};kb=p+16|0;e=b+h<<1;break u;case 1:p=kb-16|0;kb=p;d=v[k+2260>>2];v[p+12>>2]=d;m=v[b>>2]<<1;v[p+8>>2]=m;a=p+8|0;g=v[Kb(a,p+12|0)>>2];v[p+8>>2]=m;v[p+4>>2]=d-g;i=v[Kb(a,p+4|0)>>2];e=v[b+20>>2];h=g>>>1|0;g=h;d=f;while(1){if(g){a=w[d|0]|w[d+1|0]<<8;u[e>>1]=(a<<8|a>>>8)^32768;e=e+4|0;d=d+2|0;g=g-1|0;continue}break};e=f+m|0;d=v[b+20>>2]+2|0;b=i>>>1|0;g=b;while(1){if(g){a=w[e|0]|w[e+1|0]<<8;u[d>>1]=(a<<8|a>>>8)^32768;d=d+4|0;e=e+2|0;g=g-1|0;continue}break};kb=p+16|0;e=b+h<<1;break u;case 2:break X;default:break u}}e=v[k+2260>>2];a=x[Ak(k+16|0)>>1];r=kb-16|0;kb=r;v[r+12>>2]=e;p=v[b>>2]<<1;v[r+8>>2]=p;d=r+8|0;g=v[Kb(d,r+12|0)>>2];v[r+8>>2]=p;v[r+4>>2]=e-g;m=v[Kb(d,r+4|0)>>2];e=b;h=v[b+20>>2];b=a;i=g>>>1|0;d=i;g=f;while(1){if(d){b=(w[g+1|0]+b|0)+(w[g|0]<<8)|0;u[h>>1]=b;h=h+4|0;g=g+2|0;d=d-1|0;continue}break}g=f+p|0;h=v[e+20>>2]+2|0;b=m>>>1|0;d=b;while(1){if(d){a=(w[g+1|0]+a|0)+(w[g|0]<<8)|0;u[h>>1]=a;h=h+4|0;g=g+2|0;d=d-1|0;continue}break}kb=r+16|0;e=b+i<<1;break u}if(!(w[h+2|0]|((a|0)!=16|w[h+1|0]!=2))){e=0;Y:{switch(g|0){case 0:a=v[b>>2];b=v[b+20>>2];d=kb-16|0;kb=d;v[d+12>>2]=v[k+2260>>2]>>>2;v[d+8>>2]=a;a=v[Kb(d+12|0,d+8|0)>>2];e=a;while(1){if(e){u[b>>1]=w[f|0]|w[f+1|0]<<8;u[b+2>>1]=w[f+2|0]|w[f+3|0]<<8;b=b+4|0;f=f+4|0;e=e-1|0;continue}break};kb=d+16|0;e=a<<2;break u;case 1:a=v[b>>2];b=v[b+20>>2];d=kb-16|0;kb=d;v[d+12>>2]=v[k+2260>>2]>>>2;v[d+8>>2]=a;a=v[Kb(d+12|0,d+8|0)>>2];e=a;while(1){if(e){u[b>>1]=(w[f|0]|w[f+1|0]<<8)^32768;u[b+2>>1]=(w[f+2|0]|w[f+3|0]<<8)^32768;b=b+4|0;f=f+4|0;e=e-1|0;continue}break};kb=d+16|0;e=a<<2;break u;case 2:break Y;default:break u}}e=v[k+2260>>2];a=Ak(k+8|0);d=v[b>>2];g=v[b+20>>2];a=x[a>>1];h=kb-16|0;kb=h;v[h+12>>2]=e>>>2;v[h+8>>2]=d;b=a;e=v[Kb(h+12|0,h+8|0)>>2];d=e;while(1){if(d){a=(w[f|0]+a|0)+(w[f+1|0]<<8)|0;u[g>>1]=a;b=(w[f+2|0]+b|0)+(w[f+3|0]<<8)|0;u[g+2>>1]=b;g=g+4|0;f=f+4|0;d=d-1|0;continue}break}kb=h+16|0;e=e<<2;break u}a=e&255;if(!((a|0)!=16|w[h+1|0]!=2|w[h+2|0]!=1)){e=0;Z:{switch(g|0){case 0:a=v[b>>2];b=v[b+20>>2];g=kb-16|0;kb=g;v[g+12>>2]=v[k+2260>>2]>>>2;v[g+8>>2]=a;d=v[Kb(g+12|0,g+8|0)>>2];e=d;while(1){if(e){a=w[f|0]|w[f+1|0]<<8;u[b>>1]=a<<8|a>>>8;a=w[f+2|0]|w[f+3|0]<<8;u[b+2>>1]=a<<8|a>>>8;b=b+4|0;f=f+4|0;e=e-1|0;continue}break};kb=g+16|0;e=d<<2;break u;case 1:a=v[b>>2];b=v[b+20>>2];g=kb-16|0;kb=g;v[g+12>>2]=v[k+2260>>2]>>>2;v[g+8>>2]=a;d=v[Kb(g+12|0,g+8|0)>>2];e=d;while(1){if(e){a=w[f|0]|w[f+1|0]<<8;u[b>>1]=(a<<8|a>>>8)^32768;a=w[f+2|0]|w[f+3|0]<<8;u[b+2>>1]=(a<<8|a>>>8)^32768;b=b+4|0;f=f+4|0;e=e-1|0;continue}break};kb=g+16|0;e=d<<2;break u;case 2:break Z;default:break u}}e=v[k+2260>>2];a=Ak(k);d=v[b>>2];g=v[b+20>>2];a=x[a>>1];h=kb-16|0;kb=h;v[h+12>>2]=e>>>2;v[h+8>>2]=d;b=a;e=v[Kb(h+12|0,h+8|0)>>2];d=e;while(1){if(d){a=(w[f+1|0]+a|0)+(w[f|0]<<8)|0;u[g>>1]=a;b=(w[f+3|0]+b|0)+(w[f+2|0]<<8)|0;u[g+2>>1]=b;g=g+4|0;f=f+4|0;d=d-1|0;continue}break}kb=h+16|0;e=e<<2;break u}if(!(g|w[h+1|0]!=1|(a|0)!=24)){a=v[b+20>>2];d=v[b>>2];b=v[k+2260>>2];if(!w[h+2|0]){g=kb-16|0;kb=g;v[g+12>>2]=(b>>>0)/3;v[g+8>>2]=d;b=v[Kb(g+12|0,g+8|0)>>2];e=b;while(1){if(e){K=a,M=ld(w[f+1|0]<<16|w[f|0]<<8|w[f+2|0]<<24,16),u[K>>1]=M;a=a+2|0;f=f+3|0;e=e-1|0;continue}break}kb=g+16|0;e=B(b,3);break u}g=kb-16|0;kb=g;v[g+12>>2]=(b>>>0)/3;v[g+8>>2]=d;b=v[Kb(g+12|0,g+8|0)>>2];e=b;while(1){if(e){K=a,M=ld(w[f+1|0]<<16|w[f+2|0]<<8|w[f|0]<<24,16),u[K>>1]=M;a=a+2|0;f=f+3|0;e=e-1|0;continue}break}kb=g+16|0;e=B(b,3);break u}a=e&255;if(!(g|w[h+1|0]!=2|(a|0)!=24)){a=v[b+20>>2];d=v[b>>2];b=v[k+2260>>2];if(!w[h+2|0]){g=kb-16|0;kb=g;v[g+12>>2]=(b>>>0)/6;v[g+8>>2]=d;b=v[Kb(g+12|0,g+8|0)>>2];e=b;while(1){if(e){K=a,M=ld(w[f+1|0]<<16|w[f|0]<<8|w[f+2|0]<<24,16),u[K>>1]=M;K=a,M=ld(w[f+4|0]<<16|w[f+3|0]<<8|w[f+5|0]<<24,16),u[K+2>>1]=M;a=a+4|0;f=f+6|0;e=e-1|0;continue}break}kb=g+16|0;e=B(b,6);break u}g=kb-16|0;kb=g;v[g+12>>2]=(b>>>0)/6;v[g+8>>2]=d;b=v[Kb(g+12|0,g+8|0)>>2];e=b;while(1){if(e){K=a,M=ld(w[f+1|0]<<16|w[f+2|0]<<8|w[f|0]<<24,16),u[K>>1]=M;K=a,M=ld(w[f+4|0]<<16|w[f+5|0]<<8|w[f+3|0]<<24,16),u[K+2>>1]=M;a=a+4|0;f=f+6|0;e=e-1|0;continue}break}kb=g+16|0;e=B(b,6);break u}if(!(g|w[h+1|0]!=1|(a|0)!=32)){a=v[b+20>>2];d=v[b>>2];b=v[k+2260>>2];if(!w[h+2|0]){g=kb-16|0;kb=g;v[g+12>>2]=b>>>2;v[g+8>>2]=d;b=v[Kb(g+12|0,g+8|0)>>2];e=b;while(1){if(e){K=a,M=ld(w[f|0]|w[f+1|0]<<8|(w[f+2|0]<<16|w[f+3|0]<<24),16),u[K>>1]=M;a=a+2|0;f=f+4|0;e=e-1|0;continue}break}kb=g+16|0;e=b<<2;break u}g=kb-16|0;kb=g;v[g+12>>2]=b>>>2;v[g+8>>2]=d;b=v[Kb(g+12|0,g+8|0)>>2];e=b;while(1){if(e){d=w[f|0]|w[f+1|0]<<8|(w[f+2|0]<<16|w[f+3|0]<<24);K=a,M=ld(d<<24|d<<8&16711680|(d>>>8&65280|d>>>24),16),u[K>>1]=M;a=a+2|0;f=f+4|0;e=e-1|0;continue}break}kb=g+16|0;e=b<<2;break u}a=e&255;if(!(g|w[h+1|0]!=2|(a|0)!=32)){a=v[b+20>>2];d=v[b>>2];b=v[k+2260>>2];if(!w[h+2|0]){g=kb-16|0;kb=g;v[g+12>>2]=b>>>3;v[g+8>>2]=d;b=v[Kb(g+12|0,g+8|0)>>2];e=b;while(1){if(e){K=a,M=ld(w[f|0]|w[f+1|0]<<8|(w[f+2|0]<<16|w[f+3|0]<<24),16),u[K>>1]=M;K=a,M=ld(w[f+4|0]|w[f+5|0]<<8|(w[f+6|0]<<16|w[f+7|0]<<24),16),u[K+2>>1]=M;a=a+4|0;f=f+8|0;e=e-1|0;continue}break}kb=g+16|0;e=b<<3;break u}g=kb-16|0;kb=g;v[g+12>>2]=b>>>3;v[g+8>>2]=d;b=v[Kb(g+12|0,g+8|0)>>2];e=b;while(1){if(e){d=w[f|0]|w[f+1|0]<<8|(w[f+2|0]<<16|w[f+3|0]<<24);K=a,M=ld(d<<24|d<<8&16711680|(d>>>8&65280|d>>>24),16),u[K>>1]=M;d=w[f+4|0]|w[f+5|0]<<8|(w[f+6|0]<<16|w[f+7|0]<<24);K=a,M=ld(d<<24|d<<8&16711680|(d>>>8&65280|d>>>24),16),u[K+2>>1]=M;a=a+4|0;f=f+8|0;e=e-1|0;continue}break}kb=g+16|0;e=b<<3;break u}if(!(g|w[h+1|0]!=1|(a|0)!=64)){a=v[b+20>>2];d=v[b>>2];b=v[k+2260>>2];if(!w[h+2|0]){g=kb-16|0;kb=g;v[g+12>>2]=b>>>3;v[g+8>>2]=d;b=v[Kb(g+12|0,g+8|0)>>2];e=b;while(1){if(e){K=a,M=Yc(w[f|0]|w[f+1|0]<<8|(w[f+2|0]<<16|w[f+3|0]<<24),w[f+4|0]|w[f+5|0]<<8|(w[f+6|0]<<16|w[f+7|0]<<24),48),u[K>>1]=M;a=a+2|0;f=f+8|0;e=e-1|0;continue}break}kb=g+16|0;e=b<<3;break u}i=kb-16|0;kb=i;v[i+12>>2]=b>>>3;v[i+8>>2]=d;d=v[Kb(i+12|0,i+8|0)>>2];e=d;while(1){if(e){h=w[f|0]|w[f+1|0]<<8|(w[f+2|0]<<16|w[f+3|0]<<24);b=h<<24|h<<8&16711680;m=h>>>8|0;g=w[f+4|0]|w[f+5|0]<<8|(w[f+6|0]<<16|w[f+7|0]<<24);h=h>>>24|0;b=b|((m|g<<24)&65280|(h|g<<8)&255);K=a,M=Yc((m|(g&255)<<24)&-16777216|(h|(g&16777215)<<8)&16711680|(g>>>8&65280|g>>>24),b,48),u[K>>1]=M;a=a+2|0;f=f+8|0;e=e-1|0;continue}break}kb=i+16|0;e=d<<3;break u}a=e&255;if(!(g|w[h+1|0]!=2|(a|0)!=64)){a=v[b+20>>2];d=v[b>>2];b=v[k+2260>>2];if(!w[h+2|0]){g=kb-16|0;kb=g;v[g+12>>2]=b>>>4;v[g+8>>2]=d;b=v[Kb(g+12|0,g+8|0)>>2];e=b;while(1){if(e){K=a,M=Yc(w[f|0]|w[f+1|0]<<8|(w[f+2|0]<<16|w[f+3|0]<<24),w[f+4|0]|w[f+5|0]<<8|(w[f+6|0]<<16|w[f+7|0]<<24),48),u[K>>1]=M;K=a,M=Yc(w[f+8|0]|w[f+9|0]<<8|(w[f+10|0]<<16|w[f+11|0]<<24),w[f+12|0]|w[f+13|0]<<8|(w[f+14|0]<<16|w[f+15|0]<<24),48),u[K+2>>1]=M;a=a+4|0;f=f+16|0;e=e-1|0;continue}break}kb=g+16|0;e=b<<4;break u}i=kb-16|0;kb=i;v[i+12>>2]=b>>>4;v[i+8>>2]=d;d=v[Kb(i+12|0,i+8|0)>>2];e=d;while(1){if(e){h=w[f|0]|w[f+1|0]<<8|(w[f+2|0]<<16|w[f+3|0]<<24);b=h<<24|h<<8&16711680;m=h>>>8|0;g=w[f+4|0]|w[f+5|0]<<8|(w[f+6|0]<<16|w[f+7|0]<<24);h=h>>>24|0;b=b|((m|g<<24)&65280|(h|g<<8)&255);K=a,M=Yc((m|(g&255)<<24)&-16777216|(h|(g&16777215)<<8)&16711680|(g>>>8&65280|g>>>24),b,48),u[K>>1]=M;h=w[f+8|0]|w[f+9|0]<<8|(w[f+10|0]<<16|w[f+11|0]<<24);g=w[f+12|0]|w[f+13|0]<<8|(w[f+14|0]<<16|w[f+15|0]<<24);b=h<<24|h<<8&16711680|((g<<24|h>>>8)&65280|(g<<8|h>>>24)&255);K=a,M=Yc(((g&255)<<24|h>>>8)&-16777216|((g&16777215)<<8|h>>>24)&16711680|(g>>>8&65280|g>>>24),b,48),u[K+2>>1]=M;a=a+4|0;f=f+16|0;e=e-1|0;continue}break}kb=i+16|0;e=d<<4;break u}if(!(w[h+1|0]!=1|(g|0)!=3|(a|0)!=32)){a=v[b+20>>2];d=v[b>>2];b=v[k+2260>>2];if(!w[h+2|0]){g=kb-16|0;kb=g;v[g+12>>2]=b>>>2;v[g+8>>2]=d;b=v[Kb(g+12|0,g+8|0)>>2];e=b;while(1){if(e){j=Jf((l(2,w[f|0]|w[f+1|0]<<8|(w[f+2|0]<<16|w[f+3|0]<<24)),q()));j=Xh(C(Yd(og(j)?j>=C(0)?C(1):C(-1):j,C(-1))*C(32768)));_:{if(C(D(j))<C(2147483648)){d=~~j;break _}d=-2147483648}K=a,M=ed(d),u[K>>1]=M;a=a+2|0;f=f+4|0;e=e-1|0;continue}break}kb=g+16|0;e=b<<2;break u}g=kb-16|0;kb=g;v[g+12>>2]=b>>>2;v[g+8>>2]=d;b=v[Kb(g+12|0,g+8|0)>>2];e=b;while(1){if(e){d=w[f|0]|w[f+1|0]<<8|(w[f+2|0]<<16|w[f+3|0]<<24);j=Jf((l(2,d<<24|d<<8&16711680|(d>>>8&65280|d>>>24)),q()));j=Xh(C(Yd(og(j)?j>=C(0)?C(1):C(-1):j,C(-1))*C(32768)));$:{if(C(D(j))<C(2147483648)){d=~~j;break $}d=-2147483648}K=a,M=ed(d),u[K>>1]=M;a=a+2|0;f=f+4|0;e=e-1|0;continue}break}kb=g+16|0;e=b<<2;break u}a=e&255;if(!(w[h+1|0]!=2|(g|0)!=3|(a|0)!=32)){a=v[b+20>>2];d=v[b>>2];b=v[k+2260>>2];if(!w[h+2|0]){g=kb-16|0;kb=g;v[g+12>>2]=b>>>3;v[g+8>>2]=d;b=v[Kb(g+12|0,g+8|0)>>2];e=b;while(1){if(e){j=Jf((l(2,w[f|0]|w[f+1|0]<<8|(w[f+2|0]<<16|w[f+3|0]<<24)),q()));j=Xh(C(Yd(og(j)?j>=C(0)?C(1):C(-1):j,C(-1))*C(32768)));aa:{if(C(D(j))<C(2147483648)){d=~~j;break aa}d=-2147483648}K=a,M=ed(d),u[K>>1]=M;j=Jf((l(2,w[f+4|0]|w[f+5|0]<<8|(w[f+6|0]<<16|w[f+7|0]<<24)),q()));j=Xh(C(Yd(og(j)?j>=C(0)?C(1):C(-1):j,C(-1))*C(32768)));ba:{if(C(D(j))<C(2147483648)){d=~~j;break ba}d=-2147483648}K=a,M=ed(d),u[K+2>>1]=M;a=a+4|0;f=f+8|0;e=e-1|0;continue}break}kb=g+16|0;e=b<<3;break u}g=kb-16|0;kb=g;v[g+12>>2]=b>>>3;v[g+8>>2]=d;b=v[Kb(g+12|0,g+8|0)>>2];e=b;while(1){if(e){d=w[f|0]|w[f+1|0]<<8|(w[f+2|0]<<16|w[f+3|0]<<24);j=Jf((l(2,d<<24|d<<8&16711680|(d>>>8&65280|d>>>24)),q()));j=Xh(C(Yd(og(j)?j>=C(0)?C(1):C(-1):j,C(-1))*C(32768)));ca:{if(C(D(j))<C(2147483648)){d=~~j;break ca}d=-2147483648}K=a,M=ed(d),u[K>>1]=M;d=w[f+4|0]|w[f+5|0]<<8|(w[f+6|0]<<16|w[f+7|0]<<24);j=Jf((l(2,d<<24|d<<8&16711680|(d>>>8&65280|d>>>24)),q()));j=Xh(C(Yd(og(j)?j>=C(0)?C(1):C(-1):j,C(-1))*C(32768)));da:{if(C(D(j))<C(2147483648)){d=~~j;break da}d=-2147483648}K=a,M=ed(d),u[K+2>>1]=M;a=a+4|0;f=f+8|0;e=e-1|0;continue}break}kb=g+16|0;e=b<<3;break u}if(!(w[h+1|0]!=1|(g|0)!=3|(a|0)!=64)){a=v[b+20>>2];d=v[b>>2];b=v[k+2260>>2];if(!w[h+2|0]){g=kb-32|0;kb=g;v[g+24>>2]=b>>>3;v[g+16>>2]=d;d=v[Kb(g+24|0,g+16|0)>>2];e=d;while(1){if(e){b=w[f+4|0]|w[f+5|0]<<8|(w[f+6|0]<<16|w[f+7|0]<<24);l(0,w[f|0]|w[f+1|0]<<8|(w[f+2|0]<<16|w[f+3|0]<<24));l(1,b|0);o=ng(+n());K=g,N=mf(o)?o>=0?1:-1:o,A[K+24>>3]=N;v[g+16>>2]=0;v[g+20>>2]=-1074790400;v[g+8>>2]=0;v[g+12>>2]=1072693248;o=ve(A[Gg(g+24|0,g+16|0,g+8|0)>>3]*32768);ea:{if(D(o)<2147483648){b=~~o;break ea}b=-2147483648}K=a,M=ed(b),u[K>>1]=M;a=a+2|0;f=f+8|0;e=e-1|0;continue}break}kb=g+32|0;e=d<<3;break u}m=kb-32|0;kb=m;v[m+24>>2]=b>>>3;v[m+16>>2]=d;h=v[Kb(m+24|0,m+16|0)>>2];e=h;while(1){if(e){b=w[f|0]|w[f+1|0]<<8|(w[f+2|0]<<16|w[f+3|0]<<24);g=b<<24|b<<8&16711680;r=b>>>8|0;i=w[f+4|0]|w[f+5|0]<<8|(w[f+6|0]<<16|w[f+7|0]<<24);d=r|i<<24;b=b>>>24|0;l(0,(r|(i&255)<<24)&-16777216|(b|(i&16777215)<<8)&16711680|(i>>>8&65280|i>>>24));l(1,g|(d&65280|(b|i<<8)&255));o=ng(+n());K=m,N=mf(o)?o>=0?1:-1:o,A[K+24>>3]=N;v[m+16>>2]=0;v[m+20>>2]=-1074790400;v[m+8>>2]=0;v[m+12>>2]=1072693248;o=ve(A[Gg(m+24|0,m+16|0,m+8|0)>>3]*32768);fa:{if(D(o)<2147483648){b=~~o;break fa}b=-2147483648}K=a,M=ed(b),u[K>>1]=M;a=a+2|0;f=f+8|0;e=e-1|0;continue}break}kb=m+32|0;e=h<<3;break u}a=e&255;if(!(w[h+1|0]!=2|(g|0)!=3|(a|0)!=64)){a=v[b+20>>2];d=v[b>>2];b=v[k+2260>>2];if(!w[h+2|0]){g=kb-32|0;kb=g;v[g+24>>2]=b>>>4;v[g+16>>2]=d;d=v[Kb(g+24|0,g+16|0)>>2];e=d;while(1){if(e){b=w[f+4|0]|w[f+5|0]<<8|(w[f+6|0]<<16|w[f+7|0]<<24);l(0,w[f|0]|w[f+1|0]<<8|(w[f+2|0]<<16|w[f+3|0]<<24));l(1,b|0);o=ng(+n());K=g,N=mf(o)?o>=0?1:-1:o,A[K+24>>3]=N;v[g+16>>2]=0;v[g+20>>2]=-1074790400;v[g+8>>2]=0;v[g+12>>2]=1072693248;o=ve(A[Gg(g+24|0,g+16|0,g+8|0)>>3]*32768);ga:{if(D(o)<2147483648){b=~~o;break ga}b=-2147483648}K=a,M=ed(b),u[K>>1]=M;b=w[f+12|0]|w[f+13|0]<<8|(w[f+14|0]<<16|w[f+15|0]<<24);l(0,w[f+8|0]|w[f+9|0]<<8|(w[f+10|0]<<16|w[f+11|0]<<24));l(1,b|0);o=ng(+n());K=g,N=mf(o)?o>=0?1:-1:o,A[K+24>>3]=N;v[g+16>>2]=0;v[g+20>>2]=-1074790400;v[g+8>>2]=0;v[g+12>>2]=1072693248;o=ve(A[Gg(g+24|0,g+16|0,g+8|0)>>3]*32768);ha:{if(D(o)<2147483648){b=~~o;break ha}b=-2147483648}K=a,M=ed(b),u[K+2>>1]=M;a=a+4|0;f=f+16|0;e=e-1|0;continue}break}kb=g+32|0;e=d<<4;break u}m=kb-32|0;kb=m;v[m+24>>2]=b>>>4;v[m+16>>2]=d;h=v[Kb(m+24|0,m+16|0)>>2];e=h;while(1){if(e){b=w[f|0]|w[f+1|0]<<8|(w[f+2|0]<<16|w[f+3|0]<<24);d=b<<24|b<<8&16711680;i=b>>>8|0;g=w[f+4|0]|w[f+5|0]<<8|(w[f+6|0]<<16|w[f+7|0]<<24);b=b>>>24|0;d=d|((i|g<<24)&65280|(b|g<<8)&255);l(0,(i|(g&255)<<24)&-16777216|(b|(g&16777215)<<8)&16711680|(g>>>8&65280|g>>>24));l(1,d|0);o=ng(+n());K=m,N=mf(o)?o>=0?1:-1:o,A[K+24>>3]=N;v[m+16>>2]=0;v[m+20>>2]=-1074790400;v[m+8>>2]=0;v[m+12>>2]=1072693248;o=ve(A[Gg(m+24|0,m+16|0,m+8|0)>>3]*32768);ia:{if(D(o)<2147483648){b=~~o;break ia}b=-2147483648}K=a,M=ed(b),u[K>>1]=M;b=w[f+8|0]|w[f+9|0]<<8|(w[f+10|0]<<16|w[f+11|0]<<24);g=b<<24|b<<8&16711680;r=b>>>8|0;i=w[f+12|0]|w[f+13|0]<<8|(w[f+14|0]<<16|w[f+15|0]<<24);d=r|i<<24;b=b>>>24|0;l(0,(r|(i&255)<<24)&-16777216|(b|(i&16777215)<<8)&16711680|(i>>>8&65280|i>>>24));l(1,g|(d&65280|(b|i<<8)&255));o=ng(+n());K=m,N=mf(o)?o>=0?1:-1:o,A[K+24>>3]=N;v[m+16>>2]=0;v[m+20>>2]=-1074790400;v[m+8>>2]=0;v[m+12>>2]=1072693248;o=ve(A[Gg(m+24|0,m+16|0,m+8|0)>>3]*32768);ja:{if(D(o)<2147483648){b=~~o;break ja}b=-2147483648}K=a,M=ed(b),u[K+2>>1]=M;a=a+4|0;f=f+16|0;e=e-1|0;continue}break}kb=m+32|0;e=h<<4;break u}if(!((g|0)!=15|(w[h+1|0]-1&255)>>>0>1|(a|0)!=24)){v[k+96>>2]=-2147483648;a=v[k+2260>>2];ka:{if(!w[h+2|0]){r=k+96|0;e=0;s=kb-16|0;kb=s;K=s,M=B(v[b>>2],Ld(x[b+34>>1])),v[K+12>>2]=M;xc(s+12|0,(a>>>0)/3|0);a=f;g=v[s+12>>2];h=g;while(1){if(h){i=w[a+1|0]<<16|w[a|0]<<8|w[a+2|0]<<24;la:{ma:{na:{if((i|0)>=0){d=i;break na}d=-2147483648;if((i|0)==-2147483648){break ma}d=0-i|0}if(d>>>0<=e>>>0){break la}}e=d}h=h-1|0;a=a+3|0;continue}else{oa:{if(!e){break oa}p=e-1|0;m=e>>>1|0;h=v[b+20>>2];a=g;while(1){if(!a){break oa}d=w[f+1|0]<<16|w[f|0]<<8|w[f+2|0]<<24;i=d>>31<<31|d>>>1;d=m|d<<31;pa:{if((i|0)>0|(i|0)>=0){d=Mka(d,i,e,0);i=nb;break pa}i=Mka(p-d|0,0-((d>>>0>p>>>0)+i|0)|0,e,0);d=0-i|0;i=0-(nb+((i|0)!=0)|0)|0}K=h,M=ld(Hc(d,i),16),u[K>>1]=M;a=a-1|0;f=f+3|0;h=h+2|0;continue}}}break}if(r){v[r>>2]=e}kb=s+16|0;e=B(g,3);break ka}r=k+96|0;e=0;s=kb-16|0;kb=s;K=s,M=B(v[b>>2],Ld(x[b+34>>1])),v[K+12>>2]=M;xc(s+12|0,(a>>>0)/3|0);a=f;g=v[s+12>>2];h=g;while(1){if(h){i=w[a+1|0]<<16|w[a+2|0]<<8|w[a|0]<<24;qa:{ra:{sa:{if((i|0)>=0){d=i;break sa}d=-2147483648;if((i|0)==-2147483648){break ra}d=0-i|0}if(d>>>0<=e>>>0){break qa}}e=d}h=h-1|0;a=a+3|0;continue}else{ta:{if(!e){break ta}p=e-1|0;m=e>>>1|0;h=v[b+20>>2];a=g;while(1){if(!a){break ta}d=w[f+1|0]<<16|w[f+2|0]<<8|w[f|0]<<24;i=d>>31<<31|d>>>1;d=m|d<<31;ua:{if((i|0)>0|(i|0)>=0){d=Mka(d,i,e,0);i=nb;break ua}i=Mka(p-d|0,0-((d>>>0>p>>>0)+i|0)|0,e,0);d=0-i|0;i=0-(nb+((i|0)!=0)|0)|0}K=h,M=ld(Hc(d,i),16),u[K>>1]=M;a=a-1|0;f=f+3|0;h=h+2|0;continue}}}break}if(r){v[r>>2]=e}kb=s+16|0;e=B(g,3)}if(!e){break u}a=v[k+96>>2];if((a|0)==-2147483648){break u}f=Jka(x[b+32>>1],0,a,0)+1073741824|0;a=nb;a=f>>>0<1073741824?a+1|0:a;K=b,M=Ed(Ec((a&2147483647)<<1|f>>>31,a>>>31|0),1,64),u[K+32>>1]=M;u[b+34>>1]=x[b+34>>1]|8192;break u}va:{a=e&255;if((a|0)!=32){break va}if(!((g|0)!=15|(w[h+1|0]-1&255)>>>0>1)){v[k+96>>2]=-2147483648;d=v[k+2260>>2];wa:{if(!w[h+2|0]){r=k+96|0;a=0;s=kb-16|0;kb=s;K=s,M=B(v[b>>2],Ld(x[b+34>>1])),v[K+12>>2]=M;xc(s+12|0,d>>>2|0);e=f;h=f;g=v[s+12>>2];f=g;while(1){if(f){i=w[h|0]|w[h+1|0]<<8|(w[h+2|0]<<16|w[h+3|0]<<24);xa:{ya:{za:{if((i|0)>=0){d=i;break za}d=-2147483648;if((i|0)==-2147483648){break ya}d=0-i|0}if(d>>>0<=a>>>0){break xa}}a=d}f=f-1|0;h=h+4|0;continue}else{Aa:{if(!a){break Aa}p=a-1|0;m=a>>>1|0;h=v[b+20>>2];f=g;while(1){if(!f){break Aa}d=w[e|0]|w[e+1|0]<<8|(w[e+2|0]<<16|w[e+3|0]<<24);i=d>>31<<31|d>>>1;d=m|d<<31;Ba:{if((i|0)>0|(i|0)>=0){d=Mka(d,i,a,0);i=nb;break Ba}i=Mka(p-d|0,0-((d>>>0>p>>>0)+i|0)|0,a,0);d=0-i|0;i=0-(nb+((i|0)!=0)|0)|0}K=h,M=ld(Hc(d,i),16),u[K>>1]=M;f=f-1|0;e=e+4|0;h=h+2|0;continue}}}break}if(r){v[r>>2]=a}kb=s+16|0;e=g<<2;break wa}r=k+96|0;a=0;s=kb-16|0;kb=s;K=s,M=B(v[b>>2],Ld(x[b+34>>1])),v[K+12>>2]=M;xc(s+12|0,d>>>2|0);e=f;h=f;g=v[s+12>>2];f=g;while(1){if(f){d=w[h|0]|w[h+1|0]<<8|(w[h+2|0]<<16|w[h+3|0]<<24);i=d<<24|d<<8&16711680|(d>>>8&65280|d>>>24);Ca:{Da:{Ea:{if((i|0)>=0){d=i;break Ea}d=-2147483648;if((i|0)==-2147483648){break Da}d=0-i|0}if(a>>>0>=d>>>0){break Ca}}a=d}f=f-1|0;h=h+4|0;continue}else{Fa:{if(!a){break Fa}p=a-1|0;m=a>>>1|0;h=v[b+20>>2];f=g;while(1){if(!f){break Fa}d=w[e|0]|w[e+1|0]<<8|(w[e+2|0]<<16|w[e+3|0]<<24);d=d<<24|d<<8&16711680|(d>>>8&65280|d>>>24);i=d>>31<<31|d>>>1;d=m|d<<31;Ga:{if((i|0)>0|(i|0)>=0){d=Mka(d,i,a,0);i=nb;break Ga}i=Mka(p-d|0,0-((d>>>0>p>>>0)+i|0)|0,a,0);d=0-i|0;i=0-(nb+((i|0)!=0)|0)|0}K=h,M=ld(Hc(d,i),16),u[K>>1]=M;f=f-1|0;e=e+4|0;h=h+2|0;continue}}}break}if(r){v[r>>2]=a}kb=s+16|0;e=g<<2}if(!e){break u}a=v[k+96>>2];if((a|0)==-2147483648){break u}f=Jka(x[b+32>>1],0,a,0)+1073741824|0;a=nb;a=f>>>0<1073741824?a+1|0:a;K=b,M=Ed(Ec((a&2147483647)<<1|f>>>31,a>>>31|0),1,64),u[K+32>>1]=M;u[b+34>>1]=x[b+34>>1]|8192;break u}if((g|0)!=14|(w[h+1|0]-1&255)>>>0>1){break va}v[k+96>>2]=1065353216;a=v[k+2260>>2];Ha:{if(!w[h+2|0]){e=k+96|0;h=kb-16|0;kb=h;K=h,M=B(v[b>>2],Ld(x[b+34>>1])),v[K+12>>2]=M;xc(h+12|0,a>>>2|0);g=f;d=v[h+12>>2];a=d;while(1){if(a){j=Jf((l(2,w[g|0]|w[g+1|0]<<8|(w[g+2|0]<<16|w[g+3|0]<<24)),q()));j=C(D(og(j)?j>=C(0)?C(1):C(-1):j));E=j>E?j:E;a=a-1|0;g=g+4|0;continue}else{Ia:{a=E==C(0);if(a){break Ia}H=a?C(1):C(C(1)/E);g=v[b+20>>2];a=d;while(1){if(!a){break Ia}j=Jf((l(2,w[f|0]|w[f+1|0]<<8|(w[f+2|0]<<16|w[f+3|0]<<24)),q()));j=Xh(C(Yd(C(H*(og(j)?j>=C(0)?C(1):C(-1):j)),C(-1))*C(32768)));Ja:{if(C(D(j))<C(2147483648)){i=~~j;break Ja}i=-2147483648}K=g,M=ed(i),u[K>>1]=M;a=a-1|0;f=f+4|0;g=g+2|0;continue}}if(e){z[e>>2]=E}kb=h+16|0;e=d<<2}break}break Ha}e=k+96|0;i=kb-16|0;kb=i;K=i,M=B(v[b>>2],Ld(x[b+34>>1])),v[K+12>>2]=M;xc(i+12|0,a>>>2|0);g=f;d=v[i+12>>2];a=d;while(1){if(a){h=w[g|0]|w[g+1|0]<<8|(w[g+2|0]<<16|w[g+3|0]<<24);j=Jf((l(2,h<<24|h<<8&16711680|(h>>>8&65280|h>>>24)),q()));j=C(D(og(j)?j>=C(0)?C(1):C(-1):j));E=j>E?j:E;a=a-1|0;g=g+4|0;continue}else{Ka:{a=E==C(0);if(a){break Ka}H=a?C(1):C(C(1)/E);g=v[b+20>>2];a=d;while(1){if(!a){break Ka}h=w[f|0]|w[f+1|0]<<8|(w[f+2|0]<<16|w[f+3|0]<<24);j=Jf((l(2,h<<24|h<<8&16711680|(h>>>8&65280|h>>>24)),q()));j=Xh(C(Yd(C(H*(og(j)?j>=C(0)?C(1):C(-1):j)),C(-1))*C(32768)));La:{if(C(D(j))<C(2147483648)){h=~~j;break La}h=-2147483648}K=g,M=ed(h),u[K>>1]=M;a=a-1|0;f=f+4|0;g=g+2|0;continue}}if(e){z[e>>2]=E}kb=i+16|0;e=d<<2}break}}if(!e){break u}j=z[k+96>>2];if(j==C(1)){break u}j=Xh(bz(C(j*C(x[b+32>>1])),C(1),C(64)));a=65535;Ma:{if(j>=C(65535)){break Ma}a=0;if(j<=C(0)){break Ma}a=~~j>>>0;if(j<C(4294967296)&j>=C(0)){break Ma}a=0}u[b+32>>1]=a;u[b+34>>1]=x[b+34>>1]|8192;break u}if(!((g|0)!=14|(w[h+1|0]-1&255)>>>0>1|(a|0)!=64)){v[k+96>>2]=0;v[k+100>>2]=1072693248;a=v[k+2260>>2];Na:{if(!w[h+2|0]){h=k+96|0;i=kb-32|0;kb=i;K=i,M=B(v[b>>2],Ld(x[b+34>>1])),v[K+4>>2]=M;xc(i+4|0,a>>>3|0);d=f;e=v[i+4>>2];a=e;while(1){if(a){g=w[d+4|0]|w[d+5|0]<<8|(w[d+6|0]<<16|w[d+7|0]<<24);l(0,w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24));l(1,g|0);o=ng(+n());o=D(mf(o)?o>=0?1:-1:o);F=o>F?o:F;a=a-1|0;d=d+8|0;continue}else{Oa:{a=F==0;if(a){break Oa}I=a?1:1/F;d=v[b+20>>2];a=e;while(1){if(!a){break Oa}g=w[f+4|0]|w[f+5|0]<<8|(w[f+6|0]<<16|w[f+7|0]<<24);l(0,w[f|0]|w[f+1|0]<<8|(w[f+2|0]<<16|w[f+3|0]<<24));l(1,g|0);o=ng(+n());K=i,N=I*(mf(o)?o>=0?1:-1:o),A[K+24>>3]=N;v[i+16>>2]=0;v[i+20>>2]=-1074790400;v[i+8>>2]=0;v[i+12>>2]=1072693248;o=ve(A[Gg(i+24|0,i+16|0,i+8|0)>>3]*32768);Pa:{if(D(o)<2147483648){g=~~o;break Pa}g=-2147483648}K=d,M=ed(g),u[K>>1]=M;a=a-1|0;f=f+8|0;d=d+2|0;continue}}if(h){A[h>>3]=F}kb=i+32|0;e=e<<3}break}break Na}i=k+96|0;p=kb-32|0;kb=p;K=p,M=B(v[b>>2],Ld(x[b+34>>1])),v[K+4>>2]=M;xc(p+4|0,a>>>3|0);d=f;g=v[p+4>>2];a=g;while(1){if(a){e=w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24);h=e<<24|e<<8&16711680;r=e>>>8|0;m=w[d+4|0]|w[d+5|0]<<8|(w[d+6|0]<<16|w[d+7|0]<<24);e=e>>>24|0;h=h|((r|m<<24)&65280|(e|m<<8)&255);l(0,(r|(m&255)<<24)&-16777216|(e|(m&16777215)<<8)&16711680|(m>>>8&65280|m>>>24));l(1,h|0);o=ng(+n());o=D(mf(o)?o>=0?1:-1:o);F=o>F?o:F;a=a-1|0;d=d+8|0;continue}else{Qa:{a=F==0;if(a){break Qa}I=a?1:1/F;d=v[b+20>>2];a=g;while(1){if(!a){break Qa}m=w[f|0]|w[f+1|0]<<8|(w[f+2|0]<<16|w[f+3|0]<<24);e=m<<24|m<<8&16711680;r=m>>>8|0;h=w[f+4|0]|w[f+5|0]<<8|(w[f+6|0]<<16|w[f+7|0]<<24);m=m>>>24|0;e=e|((r|h<<24)&65280|(m|h<<8)&255);l(0,(r|(h&255)<<24)&-16777216|(m|(h&16777215)<<8)&16711680|(h>>>8&65280|h>>>24));l(1,e|0);o=ng(+n());K=p,N=I*(mf(o)?o>=0?1:-1:o),A[K+24>>3]=N;v[p+16>>2]=0;v[p+20>>2]=-1074790400;v[p+8>>2]=0;v[p+12>>2]=1072693248;o=ve(A[Gg(p+24|0,p+16|0,p+8|0)>>3]*32768);Ra:{if(D(o)<2147483648){e=~~o;break Ra}e=-2147483648}K=d,M=ed(e),u[K>>1]=M;a=a-1|0;f=f+8|0;d=d+2|0;continue}}if(i){A[i>>3]=F}kb=p+32|0;e=g<<3}break}}if(!e){break u}o=A[k+96>>3];if(o==1){break u}K=b,M=$T(su(o*+x[b+32>>1],1,64)),u[K+32>>1]=M;u[b+34>>1]=x[b+34>>1]|8192;break u}Sa:{Ta:{Ua:{Va:{a=(e&255)!=32;Wa:{if(!(a|(w[h+1|0]!=1|(g|0)!=12))){E=C(30517578125e-15);e=v[k+2260>>2];if(!w[h+2|0]){break Wa}break Sa}if(!(w[h+1|0]!=2|(g|0)!=12|a)){E=C(30517578125e-15);e=v[k+2260>>2];if(!w[h+2|0]){break Ua}break Ta}a=(e&255)!=32;if(a|(w[h+1|0]!=1|(g|0)!=13)){break Va}E=C(1.1920928955078125e-7);e=v[k+2260>>2];if(w[h+2|0]){break Sa}}a=v[b>>2];b=v[b+20>>2];d=kb-16|0;kb=d;v[d+12>>2]=e>>>2;v[d+8>>2]=a;a=v[Kb(d+12|0,d+8|0)>>2];e=a;while(1){if(e){j=Jf((l(2,w[f|0]|w[f+1|0]<<8|(w[f+2|0]<<16|w[f+3|0]<<24)),q()));j=Xh(C(Yd(C((og(j)?j>=C(0)?C(1):C(-1):j)*E),C(-1))*C(32768)));Xa:{if(C(D(j))<C(2147483648)){g=~~j;break Xa}g=-2147483648}K=b,M=ed(g),u[K>>1]=M;b=b+2|0;f=f+4|0;e=e-1|0;continue}break}kb=d+16|0;e=a<<2;break u}e=0;if(w[h+1|0]!=2|(g|0)!=13|a){break u}E=C(1.1920928955078125e-7);e=v[k+2260>>2];if(w[h+2|0]){break Ta}}a=v[b>>2];b=v[b+20>>2];d=kb-16|0;kb=d;v[d+12>>2]=e>>>3;v[d+8>>2]=a;a=v[Kb(d+12|0,d+8|0)>>2];e=a;while(1){if(e){j=Jf((l(2,w[f|0]|w[f+1|0]<<8|(w[f+2|0]<<16|w[f+3|0]<<24)),q()));j=Xh(C(Yd(C((og(j)?j>=C(0)?C(1):C(-1):j)*E),C(-1))*C(32768)));Ya:{if(C(D(j))<C(2147483648)){g=~~j;break Ya}g=-2147483648}K=b,M=ed(g),u[K>>1]=M;j=Jf((l(2,w[f+4|0]|w[f+5|0]<<8|(w[f+6|0]<<16|w[f+7|0]<<24)),q()));j=Xh(C(Yd(C((og(j)?j>=C(0)?C(1):C(-1):j)*E),C(-1))*C(32768)));Za:{if(C(D(j))<C(2147483648)){g=~~j;break Za}g=-2147483648}K=b,M=ed(g),u[K+2>>1]=M;b=b+4|0;f=f+8|0;e=e-1|0;continue}break}kb=d+16|0;e=a<<3;break u}a=v[b>>2];b=v[b+20>>2];g=kb-16|0;kb=g;v[g+12>>2]=e>>>3;v[g+8>>2]=a;a=v[Kb(g+12|0,g+8|0)>>2];e=a;while(1){if(e){d=w[f|0]|w[f+1|0]<<8|(w[f+2|0]<<16|w[f+3|0]<<24);j=Jf((l(2,d<<24|d<<8&16711680|(d>>>8&65280|d>>>24)),q()));j=Xh(C(Yd(C((og(j)?j>=C(0)?C(1):C(-1):j)*E),C(-1))*C(32768)));_a:{if(C(D(j))<C(2147483648)){d=~~j;break _a}d=-2147483648}K=b,M=ed(d),u[K>>1]=M;d=w[f+4|0]|w[f+5|0]<<8|(w[f+6|0]<<16|w[f+7|0]<<24);j=Jf((l(2,d<<24|d<<8&16711680|(d>>>8&65280|d>>>24)),q()));j=Xh(C(Yd(C((og(j)?j>=C(0)?C(1):C(-1):j)*E),C(-1))*C(32768)));$a:{if(C(D(j))<C(2147483648)){d=~~j;break $a}d=-2147483648}K=b,M=ed(d),u[K+2>>1]=M;b=b+4|0;f=f+8|0;e=e-1|0;continue}break}kb=g+16|0;e=a<<3;break u}a=v[b>>2];b=v[b+20>>2];g=kb-16|0;kb=g;v[g+12>>2]=e>>>2;v[g+8>>2]=a;a=v[Kb(g+12|0,g+8|0)>>2];e=a;while(1){if(e){d=w[f|0]|w[f+1|0]<<8|(w[f+2|0]<<16|w[f+3|0]<<24);j=Jf((l(2,d<<24|d<<8&16711680|(d>>>8&65280|d>>>24)),q()));j=Xh(C(Yd(C((og(j)?j>=C(0)?C(1):C(-1):j)*E),C(-1))*C(32768)));ab:{if(C(D(j))<C(2147483648)){d=~~j;break ab}d=-2147483648}K=b,M=ed(d),u[K>>1]=M;b=b+2|0;f=f+4|0;e=e-1|0;continue}break}kb=g+16|0;e=a<<2;break u}a=V(30544)|0}if((O()|0)!=(ea(30544)|0)){break d}_(a|0)|0;v[23540]=0;Z(18);a=v[23540];v[23540]=0;if((a|0)==1){break v}}Bb(s);break u}a=P()|0;O()|0;break d}v[23540]=0;Q(155,c|0,e+J|0)|0;a=v[23540];v[23540]=0;if((a|0)==1){break f}}Uc(G)}kb=k+2288|0;return e|0}a=P()|0;O()|0;break a}a=P()|0;O()|0}Bb(s);break a}a=P()|0;O()|0;break a}a=P()|0;O()|0}Uc(G);T(a|0);L()}function Iia(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,z=0,A=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=kb-640|0;kb=d;zc(b);f=kb-16|0;kb=f;h=d+448|0;Nq(f+8|0,h);j=v[f+12>>2];g=b;nc(f,v[b>>2],v[b+8>>2],v[f+8>>2],v[f+12>>2]);b=v[f+4>>2];if((b|0)==(j|0)){$b(g,v[f+12>>2])}kb=f+16|0;b=(b|0)==(j|0);if(!b){xT(h)}a:{b:{c:{if(!b){break c}if(!zT(d+448|0)){break c}if(!Qb(v[g>>2],v[g+8>>2],Ec(yT(d+448|0),nb))){break c}if(!c){e=1;break c}Cd(a,32);t[d+447|0]=0;j=Nb(d+432|0);d:{e:{f:{g:{h:{i:{j:{k:{if(!Sb(d+448|0,16314,4)){v[23540]=0;R(406,a|0,16777216);b=v[23540];v[23540]=0;if((b|0)==1){break b}b=v[g>>2];v[23540]=0;b=S(160,b|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break b}v[23540]=0;Q(155,g|0,b-4|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break b}v[23540]=0;A=S(157,g|0)|0;b=v[23540];v[23540]=0;if((b|0)!=1){break k}break b}l:{m:{n:{o:{p:{q:{if((x[d+488>>1]-2185&65535)>>>0>1910){break q}b=v[g>>2];v[23540]=0;b=S(160,b|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break b}v[23540]=0;Q(155,g|0,b-4|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break b}v[23540]=0;A=S(157,g|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break b}if(A>>>0<256){break q}b=v[g>>2];v[23540]=0;b=S(160,b|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break b}if(b>>>0<=A>>>0){break q}v[23540]=0;b=Q(155,g|0,A|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break b}if(!b){break q}v[23540]=0;b=S(407,g|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break b}if(!b){break q}v[23540]=0;R(406,a|0,16777216);b=v[23540];v[23540]=0;if((b|0)==1){break b}b=x[d+488>>1];if(b>>>0>=4096){v[23540]=0;c=Q(1,d+168|0,16529)|0;b=v[23540];v[23540]=0;if((b|0)==1){break j}a=v[a+1298464>>2];v[23540]=0;U(376,a|0,1,c|0);a=v[23540];v[23540]=0;if((a|0)!=1){Ab(c);e=0;break d}b=P()|0;O()|0;Ab(c);break a}if(b>>>0<2194){break q}v[23540]=0;e=Q(1,d+416|0,16053)|0;b=v[23540];v[23540]=0;if((b|0)==1){break p}b=v[a+1298464>>2];v[23540]=0;U(376,b|0,4,e|0);b=v[23540];v[23540]=0;if((b|0)==1){break o}Ab(e)}if(v[a+480180>>2]!=32){break k}b=x[d+488>>1];if((b&61440)!=20480){break l}b=b&4095;e=b<<16;if(Sb(d+508|0,13637,4)){break n}t[d+447|0]=1;break m}b=P()|0;O()|0;break a}b=P()|0;O()|0;Ab(e);break a}if(b>>>0<297){break m}e=x[d+508>>1]|e}v[a+1074308>>2]=e;break k}e=x[d+490>>1];if(!((e|0)!=2184&(b|0)!=2184)){t[d+447|0]=1;v[a+1074308>>2]=18284544;break k}r:{switch(b-532|0){default:if(v[d+508>>2]|((b|0)!=768|(e|0)!=768)|(x[d+480>>1]!=256|w[d+500|0]!=128)){break k}if(w[d+501|0]){break k}v[a+1074308>>2]=18285088;t[d+447|0]=1;break k;case 3:if(v[d+508>>2]|(e|0)!=512){break k}s:{if(XA(d+512|0,255,64)){v[a+1074308>>2]=18219008;v[23540]=0;b=Q(1,d+400|0,14848)|0;e=v[23540];v[23540]=0;if((e|0)!=1){break s}b=P()|0;O()|0;break a}v[a+1074308>>2]=18284544;v[23540]=0;b=Q(1,d+400|0,16903)|0;e=v[23540];v[23540]=0;if((e|0)==1){break i}}Jb(j,b);Ab(b);t[d+447|0]=1;break k;case 1:case 2:break k;case 0:break r}}if(v[d+508>>2]|(e|0)!=514){break k}v[a+1074308>>2]=17367040;v[23540]=0;b=Q(1,d+400|0,14740)|0;e=v[23540];v[23540]=0;if((e|0)==1){break f}Jb(j,b);Ab(b);t[d+447|0]=1}b=x[d+492>>1];e=b>>>2|0;v[a+480208>>2]=b<<3&32768|(e&8|(e&4|(v[a+480208>>2]&-32797|b<<1&16)));b=d+280|0;dr(b,d+448|4);v[23540]=0;R(222,d+168|0,b|0);b=v[23540];v[23540]=0;if((b|0)==1){break h}b=d+168|0;Bc(a+1298308|0,b);zb(b);if(!(!(w[d+494|0]&4)|v[a+1074308>>2]-18285314>>>0>4276681982)){v[a+480216>>2]=w[d+478|0];v[a+480220>>2]=w[d+479|0]}b=w[d+496|0];v[a+480200>>2]=b>>>0>128?256:b<<1;b=w[d+498|0];if(b){v[a+480196>>2]=b}t[d+168|0]=31;t[d+280|0]=w[d+499|0];b=d+168|0;e=d+280|0;I=a,J=B(w[jf(b,e)|0],1e4),v[I+480204>>2]=J;t[d+168|0]=w[d+497|0];t[d+280|0]=128;I=a,J=w[Yb(b,e)|0],v[I+480228>>2]=J;e=0;while(1){if((e|0)==64){t:{v[23540]=0;Q(155,g|0,192)|0;b=v[23540];v[23540]=0;if((b|0)==1){break b}if(v[a+480180>>2]==16777216&(x[d+488>>1]-2187&65535)>>>0<=2){break t}b=w[a+484376|0];e=v[a+484360>>2];v[23540]=0;da(340,Wb(e,b)|0,g|0,x[d+480>>1],255,254);b=v[23540];v[23540]=0;if((b|0)==1){break b}break e}}else{h=(d+448|0)+e|0;i=h- -64|0;u:{if(w[i|0]==255){break u}f=(e<<5)+a|0;b=f+480280|0;df(b);I=f+480286|0,J=Ed(w[h+128|0],0,64),u[I>>1]=J;h=t[i|0];if((h|0)<0){v[b>>2]=v[b>>2]|1024}h=h&127;if(h>>>0<=64){u[f+480284>>1]=h<<2;break u}if((h|0)!=100){break u}v[b>>2]=v[b>>2]|256}e=e+1|0;continue}break}e=0;v[23540]=0;b=S(194,g|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break g}if(b){break d}v[23540]=0;b=S(157,g|0)|0;f=v[23540];v[23540]=0;v:{if((f|0)==1){break v}if(b>>>0>4e3){break d}f=w[a+484376|0];h=v[a+484360>>2];v[23540]=0;b=W(408,Wb(h,f)|0,g|0,b|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break v}if(!b){break d}break e}b=P()|0;O()|0;break a}b=P()|0;O()|0;break a}b=P()|0;O()|0;break a}b=P()|0;O()|0;break a}b=P()|0;O()|0;break a}b=P()|0;O()|0;break a}s=Tb(d+384|0);p=Tb(d+368|0);e=0;n=Tb(d+352|0);v[23540]=0;b=W(409,g|0,s|0,x[d+482>>1])|0;f=v[23540];v[23540]=0;w:{x:{y:{if((f|0)==1){break y}if(!b){break w}v[23540]=0;b=W(409,g|0,p|0,x[d+484>>1])|0;f=v[23540];v[23540]=0;if((f|0)==1){break y}if(!b){break w}v[23540]=0;b=W(409,g|0,n|0,x[d+486>>1])|0;f=v[23540];v[23540]=0;if((f|0)==1){break y}if(!b){break w}v[d+348>>2]=-1;I=d,J=Fb(v[s>>2]),v[I+168>>2]=J;e=Fb(v[s+4>>2]);while(1){b=v[d+168>>2];if(Pb(b,e)){b=w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24);if(!(!b|b>>>0>=y[d+348>>2])){v[d+348>>2]=b}Le(d+168|0);continue}else{I=d,J=Fb(v[p>>2]),v[I+168>>2]=J;e=Fb(v[p+4>>2]);while(1){b=v[d+168>>2];if(Pb(b,e)){b=w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24);if(!(!b|b>>>0>=y[d+348>>2])){v[d+348>>2]=b}Le(d+168|0);continue}else{I=d,J=Fb(v[n>>2]),v[I+168>>2]=J;e=Fb(v[n+4>>2]);z:{A:{B:{C:{D:{E:{F:{G:{H:{I:{while(1){b=v[d+168>>2];if(Pb(b,e)){b=w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24);if(!(!b|b>>>0>=y[d+348>>2])){v[d+348>>2]=b}Le(d+168|0);continue}else{if(t[d+494|0]&1){v[d+168>>2]=v[d+504>>2];I=d,J=v[Kb(d+348|0,d+168|0)>>2],v[I+348>>2]=J}e=0;if(x[d+490>>1]!=532){break H}b=x[d+488>>1];if(w[d+479|0]|(b?(b|0)!=532:0)|(w[d+478|0]|w[d+501|0])){break H}if(v[d+508>>2]|w[d+492|0]&192){break H}if(x[d+482>>1]){break I}f=x[d+484>>1];if(!f){break I}if((v[g+8>>2]+(uc(v[p>>2],v[p+4>>2])<<2)|0)+2>>>0>y[d+348>>2]){break I}}break}while(1){if((e&65535)>>>0<(f&65535)>>>0){v[23540]=0;b=S(157,g|0)|0;f=v[23540];v[23540]=0;J:{if((f|0)!=1){if(!b){break J}yg(g,((e&65535)<<2)+4|0);break I}b=P()|0;O()|0;break x}e=e+1|0;f=x[d+484>>1];continue}break}v[23540]=0;b=Q(1,d+336|0,15005)|0;e=v[23540];v[23540]=0;if((e|0)==1){break G}Jb(j,b);Ab(b)}e=1;if(x[d+488>>1]){break H}v[23540]=0;b=Q(1,d+320|0,15462)|0;f=v[23540];v[23540]=0;if((f|0)==1){break F}Jb(j,b);Ab(b)}b=x[d+494>>1];K:{if(b&2){v[23540]=0;f=S(194,g|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break A}b=v[g+8>>2];h=v[g>>2];v[23540]=0;i=b;b=f<<3;h=W(156,h|0,i|0,b|0)|0;i=v[23540];v[23540]=0;if((i|0)==1){break A}if(!(!h|y[d+348>>2]<b+v[g+8>>2]>>>0)){v[23540]=0;b=a+1298408|0;R(410,b|0,f|0);h=v[23540];v[23540]=0;if((h|0)==1){break A}I=d,J=Fb(v[b>>2]),v[I+280>>2]=J;h=Fb(v[a+1298412>>2]);L:{M:{while(1){b=v[d+280>>2];if(!Pb(b,h)){if(!(!f&e)){break K}if(!(w[d+494|0]&4)){break L}v[23540]=0;b=Q(1,d+304|0,15495)|0;e=v[23540];v[23540]=0;if((e|0)==1){break M}Jb(j,b);Ab(b);break K}v[23540]=0;R(411,g|0,d+168|0);i=v[23540];v[23540]=0;if((i|0)!=1){Ub(b,0,44);i=w[d+168|0]|w[d+169|0]<<8;if(i|(w[d+170|0]|w[d+171|0]<<8)){v[b+20>>2]=((i&65024)>>>9|0)+80;I=b,J=Zb((w[d+168|0]|w[d+169|0]<<8)>>>5&15,1,12)-1|0,v[I+16>>2]=J;I=b,J=Zb((w[d+168|0]|w[d+169|0]<<8)&31,1,31),v[I+12>>2]=J;I=b,J=Zb((w[d+170|0]|w[d+171|0]<<8)>>>11|0,0,23),v[I+8>>2]=J;I=b,J=Zb((w[d+170|0]|w[d+171|0]<<8)>>>5&63,0,59),v[I+4>>2]=J;I=b,J=Zb((w[d+170|0]|w[d+171|0]<<8)<<1&62,0,59),v[I>>2]=J}v[b+44>>2]=w[d+172|0]|w[d+173|0]<<8|(w[d+174|0]<<16|w[d+175|0]<<24);v[d+280>>2]=v[d+280>>2]+48;continue}break}b=P()|0;O()|0;break x}b=P()|0;O()|0;break x}v[23540]=0;b=Q(1,d+304|0,15045)|0;e=v[23540];v[23540]=0;if((e|0)!=1){Jb(j,b);Ab(b);break K}b=P()|0;O()|0;break x}yg(g,2);break K}if(!(b>>>0<2&e)){break K}v[23540]=0;b=S(194,g|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break z}if(!b){v[23540]=0;b=Q(1,d+304|0,15005)|0;e=v[23540];v[23540]=0;if((e|0)!=1){Jb(j,b);Ab(b);break K}b=P()|0;O()|0;break x}yg(g,2)}N:{if(!(w[d+494|0]&8?1:w[d+492|0]&128)){break N}v[23540]=0;b=a+901404|0;e=Q(412,g|0,b|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break E}if(!e){break N}WA(b)}if(x[d+488>>1]<=531){sq(a+901404|0)}v[23540]=0;C=S(174,d+280|0)|0;b=v[23540];v[23540]=0;O:{P:{Q:{if((b|0)!=1){v[23540]=0;b=Q(402,g|0,13874)|0;e=v[23540];v[23540]=0;if((e|0)==1){break Q}if(b){v[23540]=0;b=S(157,g|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break P}v[23540]=0;U(190,d+256|0,g|0,b|0);b=v[23540];v[23540]=0;if((b|0)==1){break P}b=d+256|0;e=kc(d+168|0,b);hd(C,e);Bb(e);Bb(b)}u[a+480188>>1]=1;v[23540]=0;b=Q(402,g|0,13879)|0;e=v[23540];v[23540]=0;if((e|0)==1){break Q}if(!b){break C}v[23540]=0;b=S(157,g|0)|0;e=v[23540];v[23540]=0;if((e|0)!=1){v[23540]=0;U(190,d+256|0,g|0,b|0);b=v[23540];v[23540]=0;if((b|0)!=1){break O}}b=P()|0;O()|0;break B}b=P()|0;O()|0;break x}b=P()|0;O()|0;break B}b=P()|0;O()|0;break B}b=d+256|0;f=kc(d+168|0,b);Bb(b);b=v[f>>2];v[23540]=0;b=S(160,b|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break D}u[d+256>>1]=(b>>>0)/20;b=x[Wc(26708,d+256|0)>>1];u[a+480188>>1]=b;e=0;while(1){if((b|0)==(e|0)){Bb(f);break C}v[23540]=0;U(413,f|0,((e<<5)+a|0)+480289|0,20);h=v[23540];v[23540]=0;if((h|0)!=1){e=e+1|0;continue}break}break D}b=P()|0;O()|0;break x}b=P()|0;O()|0;break x}b=P()|0;O()|0;break x}b=P()|0;O()|0;Bb(f);break B}R:{b=v[d+348>>2];e=v[g+8>>2];S:{if(b>>>0>=e>>>0){e=b-e|0;break S}v[23540]=0;e=S(202,g|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break R}}v[23540]=0;U(190,d+168|0,g|0,e|0);b=v[23540];v[23540]=0;if((b|0)==1){break R}b=d+168|0;D=kc(d+256|0,b);Bb(b);v[23540]=0;E=Q(414,a|0,D|0)|0;b=v[23540];v[23540]=0;T:{U:{V:{if((b|0)==1){break V}if(!(t[d+494|0]&1)|!x[d+502>>1]){break U}v[23540]=0;b=Q(155,g|0,v[d+504>>2])|0;e=v[23540];v[23540]=0;if((e|0)==1){break V}if(!b){break U}v[23540]=0;X(331,a+1298332|0,g|0,x[d+502>>1],4);b=v[23540];v[23540]=0;if((b|0)!=1){break U}}b=P()|0;O()|0;break T}h=a+480192|0;u[h>>1]=0;f=0;if(w[d+492|0]&4){u[d+168>>1]=x[d+482>>1];u[d+96>>1]=255;f=x[Wc(d+168|0,d+96|0)>>1];u[h>>1]=f}e=0;W:{while(1){if((f&65535)>>>0<=e>>>0){v[d+252>>2]=0;e=x[d+484>>1];if(e){b=Eb(v[p>>2],e-1|0);v[d+252>>2]=(w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24))+80}u[d+168>>1]=e;u[d+96>>1]=3999;q=a+480190|0;f=x[Wc(d+168|0,d+96|0)>>1];u[q>>1]=f;m=c&2;o=d+188|0;z=a+1298464|0;e=0;b=0;while(1){X:{Y:{Z:{_:{$:{aa:{ba:{ca:{if((f&65535)>>>0>e>>>0){f=Eb(v[p>>2],e);f=w[f|0]|w[f+1|0]<<8|(w[f+2|0]<<16|w[f+3|0]<<24);if(!f){break Y}v[23540]=0;f=Q(155,g|0,f|0)|0;h=v[23540];v[23540]=0;da:{ea:{fa:{ga:{ha:{if((h|0)==1){break ha}if(!f){break Y}v[23540]=0;f=Q(415,g|0,d+168|0)|0;h=v[23540];v[23540]=0;if((h|0)==1){break ha}if(!f){break Y}v[23540]=0;i=e+1|0;f=B(i,104)+a|0;h=f+484380|0;k=Q(416,d+168|0,h|0)|0;l=v[23540];v[23540]=0;if((l|0)==1){break ga}l=d+152|0;dr(l,o);v[23540]=0;R(222,d+96|0,l|0);l=v[23540];v[23540]=0;if((l|0)==1){break fa}l=d+96|0;Dc(((i<<5)+a|0)+946304|0,l);zb(l);v[23540]=0;k=Q(155,g|0,k|0)|0;l=v[23540];v[23540]=0;if((l|0)==1){break ga}if(!k){break Y}f=x[f+484414>>1];if(!(f&512)){break ea}v[23540]=0;f=Q(417,g|0,d+96|0)|0;i=v[23540];v[23540]=0;if((i|0)==1){break ca}if(!f){break da}v[d+8>>2]=v[d+104>>2];f=v[d+100>>2];v[d>>2]=v[d+96>>2];v[d+4>>2]=f;Dl(h,1,d);break da}b=P()|0;O()|0;break T}b=P()|0;O()|0;break T}b=P()|0;O()|0;break T}if(!(f&16384)){r=x[d+488>>1];k=w[d+186|0];l=k&2;f=w[d+214|0];i=Zc(d+96|0,l?16:8,1,0,(f^-1)&1);if(!(!(k&4)|r>>>0<532)){Mo(i,3)}ia:{ja:{if(k&8){k=f&4?5:4;break ja}if(!l){k=10;if((f|0)==255){break ja}}if(f&2){t[i+2|0]=1}if(f&4){dg(i,2)}if(!(f&8)){break ia}k=9;if(!l){break ia}}dg(i,k)}if(m){f=0;v[23540]=0;W(219,d+96|0,h|0,g|0)|0;i=v[23540];v[23540]=0;if((i|0)!=1){break _}break X}f=1;i=w[d+99|0];if(i>>>0>17){break Z}i=1<<i;if(!(i&63503)){if(!(i&198144)){break Z}break $}if(w[d+96|0]){break $}break _}v[23540]=0;R(418,g|0,d+80|0);f=v[23540];v[23540]=0;if((f|0)==1){break aa}h=v[d+80>>2];if(!(!m|!h)){f=Nb(d+96|0);v[23540]=0;U(268,g|0,f|0,h|0);h=v[23540];v[23540]=0;ka:{la:{ma:{na:{oa:{pa:{qa:{if((h|0)!=1){v[23540]=0;R(374,d+136|0,16451);h=v[23540];v[23540]=0;if((h|0)==1){break qa}v[d+64>>2]=i;v[23540]=0;U(11,d+120|0,0,f|0);h=v[23540];v[23540]=0;if((h|0)==1){break pa}v[23540]=0;X(419,d+152|0,d+136|0,d- -64|0,d+120|0);h=v[23540];v[23540]=0;if((h|0)==1){break oa}h=v[z>>2];v[23540]=0;U(376,h|0,2,d+152|0);h=v[23540];v[23540]=0;if((h|0)==1){break na}Ab(d+152|0);Ab(d+120|0);dc(d+136|0);zb(f);break da}b=P()|0;O()|0;break ka}b=P()|0;O()|0;break ka}b=P()|0;O()|0;break la}b=P()|0;O()|0;break ma}b=P()|0;O()|0;Ab(d+152|0)}Ab(d+120|0)}dc(d+136|0)}zb(f);break T}v[23540]=0;Q(188,g|0,h|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break aa}}f=0;break Z}u[d+168>>1]=1;u[d+96>>1]=f;I=a+480190|0,J=x[ke(d+168|0,d+96|0)>>1],u[I>>1]=J;if(!(x[d+488>>1]==516&b)|x[d+490>>1]!=512|(x[d+494>>1]|v[d+508>>2])){break ba}if((x[d+492>>1]&65527)!=21|w[d+496|0]!=128|(w[d+497|0]!=48|w[d+500|0]!=128)){break ba}if(w[d+501|0]|x[d+502>>1]){break ba}f=d+576|0;b=d+512|0;e=1;while(1)if((b|0)==(f|0)){b=d+640|0;while(1)if((b|0)==(f|0)){f=20;while(1){if((f|0)==26){ra:{if(!(e&1)){break ba}v[23540]=0;b=Q(1,d+152|0,9898)|0;e=v[23540];v[23540]=0;if((e|0)==1){break ra}Jb(j,b);Ab(b);break ba}}else{e=!w[(d+f|0)+452|0]&e;f=f+1|0;continue}break}b=P()|0;O()|0;break T}else{e=w[f|0]==64&e;f=f+1|0;continue}}else{e=(w[b|0]&127)==32&e;b=b+1|0;continue}}b=P()|0;O()|0;break T}v[a+480260>>2]=0;v[a+480264>>2]=2147483647;b=uc(v[n>>2],v[n+4>>2]);u[d+168>>1]=b;q=x[Wc(d+168|0,v[a+8>>2]+10|0)>>1];u[d+118>>1]=q;sa:{ta:{ua:{va:{if((b|0)!=(q|0)){v[23540]=0;Y(420,d+96|0);b=v[23540];v[23540]=0;if((b|0)==1){break sa}b=v[n+4>>2];e=v[n>>2];v[23540]=0;I=d,J=uc(e,b),v[I+136>>2]=J;X(421,d+168|0,d+96|0,d+136|0,d+118|0);b=v[23540];v[23540]=0;if((b|0)==1){break ua}b=v[a+1298464>>2];v[23540]=0;U(376,b|0,2,d+168|0);b=v[23540];v[23540]=0;if((b|0)==1){break va}Ab(d+168|0);dc(d+96|0)}if(!(c&1)){u[d+118>>1]=0;q=0}m=a+480188|0;h=0;wa:{xa:{ya:{za:{Aa:{Ba:{while(1){Ca:{if((h|0)==(q|0)){Da:{Ea:{b=v[d+252>>2];if(!b){break Ea}v[23540]=0;Q(155,g|0,b|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break Da}if(!(r&1)){break Ea}while(1){Fa:{b=v[g+8>>2];c=v[g>>2];v[23540]=0;b=W(156,c|0,b|0,4)|0;c=v[23540];v[23540]=0;if((c|0)==1){break Fa}if(!b){break Ea}v[23540]=0;b=Q(402,g|0,13848)|0;c=v[23540];v[23540]=0;if((c|0)==1){break Fa}Ga:{if(!b){v[23540]=0;b=Q(402,g|0,13853)|0;c=v[23540];v[23540]=0;if((c|0)==1){break Fa}if(!b){break Ga}}v[23540]=0;b=S(157,g|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){yg(g,8);if(!(b&1616928864)|b&-2139062144){break Ga}break Ea}b=P()|0;O()|0;break T}v[23540]=0;b=S(194,g|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break Fa}v[23540]=0;Q(188,g|0,b|0)|0;b=v[23540];v[23540]=0;if((b|0)!=1){continue}}break}b=P()|0;O()|0;break T}v[23540]=0;b=Q(422,a|0,g|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break Da}b=b|w[d+447|0];t[d+447|0]=b;if(!(!b|E)){mu(a+1074312|0);t[a+1074368|0]=0}v[23540]=0;X(423,a|0,g|0,0,d+447|0);b=v[23540];v[23540]=0;if((b|0)==1){break Da}v[23540]=0;o=a+484344|0;R(225,o|0,q|0);b=v[23540];v[23540]=0;if((b|0)==1){break Da}z=a+480188|0;H=a+480183|0;h=0;Ha:{Ia:{Ja:{Ka:{La:{Ma:{Na:{while(1){Oa:{Pa:{Qa:{Ra:{Sa:{Ta:{Ua:{Va:{Wa:{Xa:{Ya:{Za:{_a:{$a:{ab:{bb:{cb:{db:{eb:{fb:{if((h|0)!=(q|0)){b=Eb(v[n>>2],h);b=w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24);if(b){v[23540]=0;b=Q(155,g|0,b|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break ab}if(b){break $a}}v[23540]=0;b=W(226,o|0,h&65535,64)|0;c=v[23540];v[23540]=0;if((c|0)==1){break ab}if(b){break bb}u[d+48>>1]=h;v[23540]=0;Y(424,d+96|0);b=v[23540];v[23540]=0;if((b|0)==1){break fb}v[23540]=0;U(425,d+168|0,d+96|0,d+48|0);b=v[23540];v[23540]=0;if((b|0)==1){break eb}b=v[a+1298464>>2];v[23540]=0;U(376,b|0,2,d+168|0);b=v[23540];v[23540]=0;if((b|0)==1){break db}Ab(d+168|0);dc(d+96|0)}if(!v[a+1074308>>2]){e=x[d+488>>1];if((e|0)!=2184){break Za}v[a+1074308>>2]=18284544}if(!sh(v[j+4>>2],w[j+11|0])){break _a}v[23540]=0;c=Q(1,d+96|0,17648)|0;b=v[23540];v[23540]=0;if((b|0)==1){break Ra}b=v[a+1074308>>2];v[23540]=0;R(140,d- -64|0,b|0);b=v[23540];v[23540]=0;if((b|0)==1){break Ta}v[23540]=0;U(2,d+168|0,c|0,d- -64|0);b=v[23540];v[23540]=0;if((b|0)==1){break Ua}e=d+168|0;b=Jb(j,e);Ab(e);Ab(d- -64|0);Ab(c);if(!Sb(d+508|0,13637,4)|(x[d+488>>1]&61440)!=20480){break Ya}v[23540]=0;c=Q(1,d+168|0,16915)|0;e=v[23540];v[23540]=0;if((e|0)==1){break Va}v[23540]=0;Q(98,b|0,c|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break Wa}Ab(c);break Xa}b=P()|0;O()|0;break T}b=P()|0;O()|0;break cb}b=P()|0;O()|0;Ab(d+168|0)}dc(d+96|0);break T}b=v[o>>2];v[23540]=0;R(426,_b(b,h)|0,C|0);b=v[23540];v[23540]=0;if((b|0)!=1){break Pa}}b=P()|0;O()|0;break T}v[23540]=0;b=S(194,g|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break Ha}v[23540]=0;F=S(194,g|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break Ia}v[23540]=0;c=Q(188,g|0,4)|0;e=v[23540];v[23540]=0;if((e|0)==1){break Ia}if(!c){break Pa}v[23540]=0;c=W(226,o|0,h&65535,F|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break Ia}if(!c){break Pa}v[23540]=0;U(190,d+96|0,g|0,b|0);b=v[23540];v[23540]=0;if((b|0)==1){break Ja}b=d+96|0;m=kc(d+168|0,b);Bb(b);b=v[o>>2];v[23540]=0;R(426,_b(b,h)|0,C|0);b=v[23540];v[23540]=0;if((b|0)==1){break La}b=x[z>>1];v[23540]=0;l=Q(427,d+120|0,b|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break Ma}b=x[z>>1];c=d+96|0;Fj(c);v[23540]=0;k=W(428,d+80|0,b|0,c|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break Oa}I=d,J=Fb(v[_b(v[o>>2],h)>>2]),v[I+64>>2]=J;r=0;while(1){gb:{hb:{ib:{jb:{if(r>>>0>=F>>>0){break jb}b=v[m>>2];v[23540]=0;b=W(156,b|0,v[d+176>>2],1)|0;c=v[23540];v[23540]=0;if((c|0)==1){break Qa}if(!b){break jb}v[23540]=0;b=S(206,m|0)|0;c=v[23540];v[23540]=0;kb:{if((c|0)!=1){b=b<<24>>24;if(b){break kb}jU(d- -64|0,x[z>>1]);r=r+1|0;continue}break Qa}lb:{c=b&127;i=c?c-1&65535:0;if(fd(v[l>>2],v[d+124>>2])>>>0>i>>>0){break lb}v[23540]=0;t[d+96|0]=0;c=i+1|0;U(429,l|0,c|0,d+96|0);e=v[23540];v[23540]=0;if((e|0)==1){break Qa}e=d+96|0;Fj(e);v[23540]=0;U(430,k|0,c|0,e|0);c=v[23540];v[23540]=0;if((c|0)!=1){break lb}break Qa}if((b|0)<0){v[23540]=0;b=S(206,m|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break Qa}I=Lb(v[l>>2],i),J=b,t[I|0]=J}f=d+96|0;Fj(f);if(i>>>0<x[z>>1]){f=Id(v[d+64>>2],i)}b=Lb(v[l>>2],i);e=w[b|0];if(e&16){I=f,J=w[Id(v[k>>2],i)|0],t[I|0]=J;e=w[b|0]}if(e&32){I=f,J=w[Id(v[k>>2],i)+1|0],t[I+1|0]=J;e=w[b|0]}if(e&64){c=Id(v[k>>2],i);t[f+2|0]=w[c+2|0];t[f+4|0]=w[c+4|0];e=w[b|0]}if(e<<24>>24<0){c=Id(v[k>>2],i);t[f+3|0]=w[c+3|0];t[f+5|0]=w[c+5|0];e=w[b|0]}if(e&1){v[23540]=0;b=S(206,m|0)|0;c=v[23540];v[23540]=0;mb:{nb:{if((c|0)!=1){b=b<<24>>24;b=(((b^-1)&128)>>>7|0)+b|0;if(!(t[H|0]&1)){break nb}c=b;break mb}break Qa}c=253;if((b-121&255)>>>0<132){break mb}c=(b&255)==253?0:b}t[f|0]=c;I=Id(v[k>>2],i),J=c,t[I|0]=J;b=Lb(v[l>>2],i)}if(w[b|0]&2){v[23540]=0;b=S(206,m|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break Qa}t[f+1|0]=b;I=Id(v[k>>2],i),J=b,t[I+1|0]=J;b=Lb(v[l>>2],i)}if(!(w[b|0]&4)){break gb}v[23540]=0;b=S(206,m|0)|0;c=v[23540];v[23540]=0;ob:{pb:{if((c|0)!=1){if(b>>>0>64){break pb}t[f+4|0]=b;e=1;break ob}break Qa}if(b<<24>>24<=-64){e=2;t[f+2|0]=2;b=b^-128;t[f+4|0]=b;break hb}if(b>>>0<=74){e=5;t[f+2|0]=5;b=b-65|0;t[f+4|0]=b;break hb}if(b>>>0<=84){e=6;t[f+2|0]=6;b=b-75|0;t[f+4|0]=b;break hb}if(b>>>0<=94){e=3;t[f+2|0]=3;b=b-85|0;t[f+4|0]=b;break hb}if(b>>>0<=104){e=4;t[f+2|0]=4;b=b-95|0;t[f+4|0]=b;break hb}if(b>>>0<=114){e=13;t[f+2|0]=13;b=b-105|0;t[f+4|0]=b;break hb}if(b>>>0<=124){e=12;t[f+2|0]=12;b=b-115|0;t[f+4|0]=b;break hb}c=b+63|0;if((c&255)>>>0<=9){t[f+4|0]=c;e=11;t[f+2|0]=11;b=c;break hb}c=b+53|0;G=c&255;if(G>>>0<=9){t[f+4|0]=c;e=8;t[f+2|0]=8;if(!G){b=0;break hb}if(v[a+1074308>>2]-1>>>0>18285139){break ib}e=7;t[f+2|0]=7;break ib}b=b+33|0;if((b&255)>>>0>=10){b=w[f+4|0];e=w[f+2|0];break hb}t[f+4|0]=b;e=15}t[f+2|0]=e;break hb}vk(k);ic(l);Bb(m);break Pa}b=c}c=Id(v[k>>2],i);t[c+4|0]=b;t[c+2|0]=e;b=Lb(v[l>>2],i)}if(!(w[b|0]&8)){continue}v[23540]=0;R(260,d+32|0,m|0);b=v[23540];v[23540]=0;if((b|0)!=1){TA(f,w[d+32|0],w[Oc(d+32|0)|0],1);b=Id(v[k>>2],i);t[b+3|0]=w[f+3|0];t[b+5|0]=w[f+5|0];continue}break}break Qa}e=x[d+488>>1]}qb:{rb:{sb:{tb:{ub:{vb:{wb:{xb:{b=e&65535;switch(b>>>12|0){case 13:break rb;case 7:break sb;case 6:break tb;case 4:break ub;case 1:break wb;case 0:break xb;default:break Xa}}if(E){v[23540]=0;b=Q(1,d+168|0,8369)|0;c=v[23540];v[23540]=0;if((c|0)!=1){Jb(j,b);Ab(b);break Xa}b=P()|0;O()|0;break T}yb:{zb:{Ab:{Bb:{Cb:{Db:{Eb:{Fb:{Gb:{Hb:{Ib:{Jb:{Kb:{Lb:{if((e&65535)==532){f=x[d+490>>1];if((f|0)!=532){if((f|0)!=512){e=532;break Kb}Mb:{if(x[d+494>>1]|x[d+492>>1]!=9|(w[d+479|0]|w[d+478|0])){break Mb}if(x[d+482>>1]|x[d+480>>1]!=(x[d+486>>1]+1|0)|(w[d+496|0]!=128|w[d+497|0]!=100)){break Mb}if(w[d+498|0]!=1|w[d+500|0]!=128|(w[d+501|0]|x[d+502>>1])){break Mb}if(v[d+504>>2]|v[d+508>>2]){break Mb}v[23540]=0;b=Q(1,d+168|0,9879)|0;c=v[23540];v[23540]=0;if((c|0)!=1){Jb(j,b);Ab(b);break Xa}b=P()|0;O()|0;break T}e=532;if(v[d+508>>2]|(w[d+479|0]|w[d+478|0])){break Jb}v[a+1074308>>2]=16777381;v[23540]=0;b=Q(1,d+168|0,14936)|0;c=v[23540];v[23540]=0;if((c|0)!=1){Jb(j,b);Ab(b);t[d+447|0]=1;break Xa}b=P()|0;O()|0;break T}if(!Sb(d+508|0,14117,4)){v[23540]=0;b=Q(1,d+168|0,8407)|0;c=v[23540];v[23540]=0;if((c|0)!=1){Jb(j,b);Ab(b);e=a+1074312|0;f=38;break vb}b=P()|0;O()|0;break T}e=532;if(w[d+501|0]|x[d+494>>1]>1|(v[d+508>>2]|(x[d+492>>1]&4294)!=4)){break Lb}if(!x[a+480190>>1]){break Lb}v[23540]=0;e=Q(55,d+96|0,13457)|0;b=v[23540];v[23540]=0;if((b|0)==1){break Hb}b=kb-16|0;kb=b;c=kb-16|0;kb=c;nv(c+8|0,a+484527|0);kT(b+8|0,v[c+8>>2],v[c+12>>2]);kb=c+16|0;Fe(b,e);c=Qc(v[b+8>>2],v[b+12>>2],v[b>>2],v[b+4>>2]);kb=b+16|0;zb(e);if(c){break Ib}e=x[d+488>>1]}if(e&65535){break Lb}if(sh(v[j+4>>2],w[j+11|0])){break Fb}}f=x[d+490>>1]}if((f&65535)>>>0>767){break Xa}}if(!sh(v[j+4>>2],w[j+11|0])){break Xa}if((f&65535)>>>0<533){break Db}v[23540]=0;b=Q(1,d- -64|0,14969)|0;c=v[23540];v[23540]=0;if((c|0)==1){break Eb}Jb(j,b);Ab(b);break Cb}v[23540]=0;b=Q(1,d+168|0,8433)|0;c=v[23540];v[23540]=0;if((c|0)==1){break Gb}Jb(j,b);Ab(b);break Xa}b=P()|0;O()|0;break T}b=P()|0;O()|0;break T}v[23540]=0;b=Q(1,d+168|0,9769)|0;c=v[23540];v[23540]=0;if((c|0)!=1){Jb(j,b);Ab(b);break Xa}b=P()|0;O()|0;break T}b=P()|0;O()|0;break T}if((e&65535)>>>0>=533){v[23540]=0;R(431,d- -64|0,4018);b=v[23540];v[23540]=0;Nb:{if((b|0)!=1){v[23540]=0;v[d+48>>2]=x[d+488>>1]-532;U(432,d+168|0,d- -64|0,d+48|0);b=v[23540];v[23540]=0;if((b|0)==1){break Nb}b=d+168|0;Jb(j,b);Ab(b);dc(d- -64|0);break Cb}b=P()|0;O()|0;break T}b=P()|0;O()|0;dc(d- -64|0);break T}v[23540]=0;R(266,d- -64|0,4317);b=v[23540];v[23540]=0;if((b|0)==1){break Bb}b=x[d+488>>1];v[d+32>>2]=b>>>8&15;v[23540]=0;v[d+16>>2]=b&255;R(433,d+48|0,d+16|0);b=v[23540];v[23540]=0;if((b|0)==1){break Ab}v[23540]=0;X(419,d+168|0,d- -64|0,d+32|0,d+48|0);b=v[23540];v[23540]=0;if((b|0)==1){break zb}b=d+168|0;Jb(j,b);Ab(b);Ab(d+48|0);dc(d- -64|0)}b=a+1298408|0;if(!pc(v[b>>2],v[a+1298412>>2])){break Xa}c=v[d+508>>2];if(!c){break Xa}c=ZC(x[d+488>>1],c);e=zo(d+168|0);v[e+44>>2]=c;v[23540]=0;R(434,b|0,e|0);b=v[23540];v[23540]=0;if((b|0)!=1){break Xa}b=P()|0;O()|0;break T}b=P()|0;O()|0;break T}b=P()|0;O()|0;break yb}b=P()|0;O()|0;Ab(d+48|0)}dc(d- -64|0);break T}c=v[d+508>>2];v[23540]=0;U(435,d+168|0,b|0,v[d+508>>2]);e=v[23540];v[23540]=0;Ob:{Pb:{Qb:{Rb:{Sb:{Tb:{Ub:{Vb:{if((e|0)!=1){e=d+168|0;Jb(j,e);Ab(e);b=(b|0)==8191?c:b-4176|0;if((b|0)>1915){break Vb}f=v[a+480208>>2];if(!(f&16)){break Ub}v[23540]=0;Q(265,a+1074312|0,7)|0;b=v[23540];v[23540]=0;if((b|0)!=1){break Tb}break qb}b=P()|0;O()|0;break T}if(b>>>0>4200){break Rb}f=v[a+480208>>2]}if(!(f&16)){v[23540]=0;Q(265,a+1074312|0,7)|0;c=v[23540];v[23540]=0;if((c|0)==1){break qb}}if((b|0)>2385){break Sb}}v[23540]=0;Q(265,a+1074312|0,38)|0;b=v[23540];v[23540]=0;if((b|0)==1){break qb}}v[23540]=0;b=Q(265,a+1074312|0,102)|0;c=v[23540];v[23540]=0;if((c|0)==1){break qb}v[23540]=0;Q(265,b|0,48)|0;b=v[23540];v[23540]=0;if((b|0)==1){break qb}break Qb}if(b>>>0>4383){break Pb}}v[23540]=0;b=W(264,a+1074312|0,116,1)|0;c=v[23540];v[23540]=0;if((c|0)==1){break qb}v[23540]=0;Q(265,b|0,115)|0;b=v[23540];v[23540]=0;if((b|0)==1){break qb}break Ob}if(b>>>0>4563){break Xa}}v[23540]=0;b=Q(265,a+1074312|0,43)|0;c=v[23540];v[23540]=0;if((c|0)==1){break qb}v[23540]=0;e=Q(265,b|0,42)|0;b=v[23540];v[23540]=0;f=87;if((b|0)==1){break qb}}v[23540]=0;Q(265,e|0,f|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break qb}break Xa}v[23540]=0;Y(436,d+96|0);b=v[23540];v[23540]=0;Wb:{Xb:{Yb:{if((b|0)!=1){b=x[d+488>>1];v[d+48>>2]=b>>>8&15;v[23540]=0;v[d+32>>2]=b&255;R(433,d- -64|0,d+32|0);b=v[23540];v[23540]=0;if((b|0)==1){break Yb}v[23540]=0;X(419,d+168|0,d+96|0,d+48|0,d- -64|0);b=v[23540];v[23540]=0;if((b|0)==1){break Xb}b=d+168|0;Jb(j,b);Ab(b);Ab(d- -64|0);dc(d+96|0);break Xa}b=P()|0;O()|0;break T}b=P()|0;O()|0;break Wb}b=P()|0;O()|0;Ab(d- -64|0)}dc(d+96|0);break T}v[23540]=0;b=Q(1,d+168|0,8369)|0;c=v[23540];v[23540]=0;if((c|0)!=1){Jb(j,b);Ab(b);break Xa}b=P()|0;O()|0;break T}if(!((b|0)!=32767|x[d+490>>1]!=533)){v[23540]=0;b=Q(1,d+168|0,5045)|0;c=v[23540];v[23540]=0;if((c|0)!=1){Jb(j,b);Ab(b);break Xa}b=P()|0;O()|0;break T}v[23540]=0;R(137,d+96|0,4153);b=v[23540];v[23540]=0;Zb:{if((b|0)!=1){b=x[d+488>>1];v[d+64>>2]=b>>>8&15;v[d+48>>2]=b>>>4&15;v[23540]=0;v[d+32>>2]=b&15;da(138,d+168|0,d+96|0,d- -64|0,d+48|0,d+32|0);b=v[23540];v[23540]=0;if((b|0)==1){break Zb}b=d+168|0;Jb(j,b);Ab(b);dc(d+96|0);break Xa}b=P()|0;O()|0;break T}b=P()|0;O()|0;dc(d+96|0);break T}v[23540]=0;b=Q(1,d+168|0,6126)|0;c=v[23540];v[23540]=0;if((c|0)!=1){Jb(j,b);Ab(b);break Xa}b=P()|0;O()|0;break T}b=P()|0;O()|0;break T}if(!fE(v[a+1074308>>2])){break Xa}v[23540]=0;c=Q(1,d+168|0,17151)|0;e=v[23540];v[23540]=0;_b:{if((e|0)!=1){v[23540]=0;Q(98,b|0,c|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break _b}Ab(c);break Xa}b=P()|0;O()|0;break T}b=P()|0;O()|0;Ab(c);break T}$b:{ac:{bc:{cc:{dc:{ec:{e=v[a+480180>>2];if(!((e|0)!=16777216|x[d+488>>1]<2186)){v[23540]=0;b=Q(155,g|0,A|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break Da}if(b){v[23540]=0;U(437,a|0,g|0,x[d+488>>1]);b=v[23540];v[23540]=0;if((b|0)==1){break Da}}e=v[a+480180>>2]}fc:{if((e|0)==16777216){v[23540]=0;b=Q(1,d+48|0,13821)|0;c=v[23540];v[23540]=0;if((c|0)==1){break ec}Jb(a+1298344|0,b);Ab(b);break fc}v[23540]=0;R(266,d+32|0,4317);b=v[23540];v[23540]=0;if((b|0)==1){break dc}b=x[d+490>>1];v[d+28>>2]=b>>>8;v[23540]=0;v[d+12>>2]=b&255;R(433,d+16|0,d+12|0);b=v[23540];v[23540]=0;if((b|0)==1){break cc}v[23540]=0;X(419,d+48|0,d+32|0,d+28|0,d+16|0);b=v[23540];v[23540]=0;if((b|0)==1){break bc}b=d+48|0;Jb(a+1298344|0,b);Ab(b);Ab(d+16|0);dc(d+32|0)}b=v[a+480180>>2];v[23540]=0;b=Q(1,d+48|0,((b|0)==16777216?10143:6130)|0)|0;c=v[23540];v[23540]=0;e=1;if((c|0)==1){break $b}Jb(a+1298356|0,b);Ab(b);Jb(a+1298368|0,j);v[a+1298404>>2]=v[a+1074308>>2]?8:5;Bb(D);Bb(C);break w}b=P()|0;O()|0;break T}b=P()|0;O()|0;break T}b=P()|0;O()|0;break ac}b=P()|0;O()|0;Ab(d+16|0)}dc(d+32|0);break T}b=P()|0;O()|0;break T}b=P()|0;O()|0;Ab(c);break T}b=P()|0;O()|0;break T}b=P()|0;O()|0;Ab(d- -64|0);break Sa}b=P()|0;O()|0}Ab(c);break T}b=P()|0;O()|0;break T}b=P()|0;O()|0;u[d+48>>1]=h;vk(k);break Na}h=h+1|0;continue}break}b=P()|0;O()|0;u[d+48>>1]=h}ic(l);break Ka}b=P()|0;O()|0;u[d+48>>1]=h;break Ka}b=P()|0;O()|0;u[d+48>>1]=h}Bb(m);break T}b=P()|0;O()|0;u[d+48>>1]=h;break T}b=P()|0;O()|0;break T}b=P()|0;O()|0;break T}b=P()|0;O()|0;break T}gc:{b=Eb(v[n>>2],h);b=w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24);hc:{if(!b){break hc}v[23540]=0;b=Q(155,g|0,b|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break Ba}if(!b){break hc}v[23540]=0;b=S(194,g|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break wa}v[23540]=0;l=S(194,g|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break xa}if((l-1025&65535)>>>0<64512){break hc}v[23540]=0;c=Q(188,g|0,4)|0;e=v[23540];v[23540]=0;if((e|0)==1){break xa}if(!c){break hc}v[23540]=0;U(190,d+96|0,g|0,b|0);b=v[23540];v[23540]=0;if((b|0)==1){break ya}b=d+96|0;f=kc(d+168|0,b);Bb(b);c=x[m>>1];b=0;v[23540]=0;i=Q(427,d+136|0,c|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break Aa}ic:{while(1){if(b>>>0>=l>>>0){break ic}c=v[f>>2];v[23540]=0;c=W(156,c|0,v[d+176>>2],1)|0;e=v[23540];v[23540]=0;if((e|0)==1){break gc}if(!c){break ic}v[23540]=0;c=S(206,f|0)|0;e=v[23540];v[23540]=0;jc:{if((e|0)!=1){c=c<<24>>24;if(c){break jc}b=b+1|0;continue}break Ca}kc:{e=c&127;o=e?e-1|0:0;k=o&65535;if(fd(v[i>>2],v[d+140>>2])>>>0>k>>>0){break kc}v[23540]=0;t[d+96|0]=0;U(429,i|0,k+1|0,d+96|0);e=v[23540];v[23540]=0;if((e|0)!=1){break kc}break Ca}lc:{if((c|0)<0){v[23540]=0;c=S(206,f|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break lc}I=Lb(v[i>>2],k),J=c,t[I|0]=J}e=Lb(v[i>>2],k);c=w[e|0];if(!(!(c&15)|k>>>0<x[m>>1])){u[m>>1]=o+1;c=w[e|0]}if(c&1){v[23540]=0;Q(188,f|0,1)|0;c=v[23540];v[23540]=0;if((c|0)==1){break lc}e=Lb(v[i>>2],k)}if(w[e|0]&2){v[23540]=0;Q(188,f|0,1)|0;c=v[23540];v[23540]=0;if((c|0)==1){break lc}e=Lb(v[i>>2],k)}if(w[e|0]&4){v[23540]=0;Q(188,f|0,1)|0;c=v[23540];v[23540]=0;if((c|0)==1){break lc}e=Lb(v[i>>2],k)}if(!(w[e|0]&8)){continue}v[23540]=0;Q(188,f|0,2)|0;c=v[23540];v[23540]=0;if((c|0)!=1){continue}}break}break Ca}v[d+96>>2]=v[g+8>>2];I=d,J=v[_c(d+252|0,d+96|0)>>2],v[I+252>>2]=J;ic(i);Bb(f)}h=h+1|0;continue}}break}b=P()|0;O()|0;ic(i);break za}b=P()|0;O()|0;break T}b=P()|0;O()|0}Bb(f);break T}b=P()|0;O()|0;break T}b=P()|0;O()|0;break T}b=P()|0;O()|0;break T}b=P()|0;O()|0;Ab(d+168|0);break ta}b=P()|0;O()|0}dc(d+96|0);break T}b=P()|0;O()|0;break T}b=P()|0;O()|0;break T}f=0;i=SA(d+96|0,v[h>>2]);v[23540]=0;Q(188,g|0,i|0)|0;i=v[23540];v[23540]=0;if((i|0)==1){break X}}if(w[d+99|0]!=1){break Z}b=v[h>>2]!=0|b}v[d+96>>2]=v[g+8>>2];I=d,J=v[_c(d+252|0,d+96|0)>>2],v[I+252>>2]=J;r=(f|0)!=0}e=e+1|0;f=x[q>>1];continue}break}b=P()|0;O()|0;break T}mc:{b=Eb(v[s>>2],e);b=w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24);nc:{if(!b){break nc}v[23540]=0;b=Q(155,g|0,b|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break mc}if(!b){break nc}b=v[g+8>>2];f=v[g>>2];v[23540]=0;b=W(156,f|0,b|0,554)|0;f=v[23540];v[23540]=0;if((f|0)==1){break mc}if(!b){break nc}v[23540]=0;b=W(251,a|0,e+1&65535,0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break W}if(!b){break nc}v[23540]=0;X(438,a|0,g|0,b|0,x[d+490>>1]);f=v[23540];v[23540]=0;if((f|0)==1){break W}t[b+33|0]=w[d+501|0]}e=e+1|0;f=x[h>>1];continue}break}b=P()|0;O()|0;break T}b=P()|0;O()|0}Bb(D);break B}b=P()|0;O()|0}Bb(C);break x}b=P()|0;O()|0;break x}b=P()|0;O()|0;break x}}}}}b=P()|0;O()|0}wc(n);wc(p);wc(s);break a}wc(n);wc(p);wc(s)}Ab(j)}kb=d+640|0;return e|0}b=P()|0;O()|0}Ab(j);T(b|0);L()}function gha(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,z=0,A=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,M=0,N=0,V=0;e=kb-1744|0;kb=e;zc(b);a:{if(!ei(b,e+1736|0)){break a}if(!yS(e+1736|0)){break a}if(!c){g=1;break a}p=w[e+1739|0];t[e+1735|0]=p;v[e+1728>>2]=-1;v[e+1724>>2]=1048576;if(p>>>0>=5){d=Bg(b);v[e+1728>>2]=d;if(!Qb(v[b>>2],v[b+8>>2],d)){break a}v[e+304>>2]=134217727;N=e,V=v[Kb(e+304|0,e+1728|0)>>2]<<5,v[N+1724>>2]=V}C=Tb(e+1712|0);v[e+304>>2]=v[e+1740>>2];d=v[Kb(e+1724|0,e+304|0)>>2];v[23540]=0;R(538,C|0,d|0);d=v[23540];v[23540]=0;b:{c:{d:{e:{f:{if((d|0)!=1){v[23540]=0;d=W(539,b|0,C|0,v[e+1740>>2])|0;f=v[23540];v[23540]=0;g:{if((f|0)==1){break g}if(!d){break b}if(p>>>0>=5){v[23540]=0;Q(155,b|0,v[e+1728>>2]+12|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break g}}v[23540]=0;R(246,a|0,0);d=v[23540];v[23540]=0;if((d|0)==1){break g}ag(a);re(e+1680|0,v[C>>2],v[C+4>>2]);d=ee(e+1672|0);f=v[d+4>>2];d=v[d>>2];v[23540]=0;m=Eg(540,e+1688|0,v[e+1680>>2],v[e+1684>>2],d,f);d=v[23540];v[23540]=0;h:{i:{j:{if((d|0)!=1){v[23540]=0;U(350,m|0,a+1298308|0,-1);d=v[23540];v[23540]=0;if((d|0)==1){break j}v[23540]=0;U(350,m|0,a+1298332|0,-1);d=v[23540];v[23540]=0;if((d|0)==1){break j}v[23540]=0;d=Q(541,m|0,e+1248|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break f}if(!d){break c}d=t[e+1248|0];if((d|0)<=0|(w[e+1257|0]|w[e+1258|0]<<8)>>>0>255|(w[e+1259|0]|w[e+1260|0]<<8)>>>0>3999){break c}D=a+480188|0;u[D>>1]=d&255;Ve(Wb(v[a+484360>>2],w[a+484376|0]),w[e+1251|0]|w[e+1252|0]<<8);u[a+480192>>1]=w[e+1257|0]|w[e+1258|0]<<8;u[a+480190>>1]=w[e+1259|0]|w[e+1260|0]<<8;d=w[e+1261|0];v[a+480196>>2]=d?d:6;d=w[e+1262|0];v[a+480204>>2]=B(d?d:125,1e4);f=w[e+1263|0]|w[e+1264|0]<<8|(w[e+1265|0]<<16|w[e+1266|0]<<24);d=32;k:{if(f&256){break k}d=2;if(f&2){break k}d=1;if(f&128){break k}d=f&8?16:4}v[23540]=0;R(406,a|0,d|0);d=v[23540];v[23540]=0;if((d|0)==1){break f}h=v[a+480208>>2];f=h|16777216;v[a+480208>>2]=f;d=w[e+1263|0]|w[e+1264|0]<<8|(w[e+1265|0]<<16|w[e+1266|0]<<24);if(d&1){f=h|16777232;v[a+480208>>2]=f}h=v[a+480180>>2];i=(h|0)==32;g=i&!(d&1024);j=(h|0)==2;n=j&d>>>2;j=j&d>>>4;i=i&!(d&2048);r=d&2097152;if(r?1:n|j|(i|g)){f=j?f|65536:f;f=n?f|2:f;f=i?f|4:f;v[a+480208>>2]=r>>>6|(g?f|8:f)}if(d&524288){v[23540]=0;W(264,a+1074312|0,5,1)|0;d=v[23540];v[23540]=0;if((d|0)==1){break f}h=v[a+480180>>2]}if((h|0)==2){break i}if((h|0)!=32){break h}t[e+304|0]=w[e+1267|0];t[e+224|0]=128;N=a,V=w[Yb(e+304|0,e+224|0)|0]<<1,v[N+480200>>2]=V;break h}d=P()|0;O()|0;break d}d=P()|0;O()|0;break e}t[e+304|0]=w[e+1267|0];t[e+224|0]=64;N=a,V=w[Yb(e+304|0,e+224|0)|0]<<2,v[N+480200>>2]=V}d=t[e+1269|0];l:{if((d|0)<0){d=d+52|0;break l}F=Ds(+(d|0)*3.1/20);m:{if(F<4294967296&F>=0){d=~~F>>>0;break m}d=0}d=d+51|0}v[a+480228>>2]=d;u[e+304>>1]=64;i=x[Wc(D,e+304|0)>>1];f=0;j=(h|0)!=32;n=(h|0)==4;g=0;while(1)if((g|0)==(i|0)){g=0;i=0;while(1){if((f|0)!=16){i=w[(e+f|0)+1398|0]!=0|i;f=f+1|0;continue}break}while(1){if((g|0)!=128){i=w[((g<<1)+e|0)+1415|0]!=0|i;g=g+1|0;continue}break}n:{if(!(i&1)){break n}d=a+901692|0;g=0;while(1){if((g|0)==16){d=a+902204|0;g=0;while(1){if((g|0)!=128){f=(e+1248|0)+(g<<1)|0;o:{if(w[f+167|0]){v[23540]=0;Y(542,e+224|0);h=v[23540];v[23540]=0;p:{q:{r:{s:{t:{if((h|0)!=1){h=w[f+167|0];v[23540]=0;v[e+248>>2]=h-1;R(543,e+1192|0,e+248|0);h=v[23540];v[23540]=0;if((h|0)==1){break t}f=w[f+166|0];v[23540]=0;t[e+192|0]=f;R(544,e+1168|0,e+192|0);f=v[23540];v[23540]=0;if((f|0)==1){break s}v[23540]=0;X(545,e+304|0,e+224|0,e+1192|0,e+1168|0);f=v[23540];v[23540]=0;if((f|0)==1){break r}f=e+304|0;Fe(e+1224|0,f);gf(ye(d,g),v[e+1224>>2],v[e+1228>>2]);zb(f);zb(e+1168|0);zb(e+1192|0);Xb(e+224|0);break o}d=P()|0;O()|0;break e}d=P()|0;O()|0;break p}d=P()|0;O()|0;break q}d=P()|0;O()|0;zb(e+1168|0)}zb(e+1192|0)}Xb(e+224|0);break e}f=rc(e+1216|0,21688);gf(ye(d,g),v[f>>2],v[e+1220>>2])}g=g+1|0;continue}break}h=v[a+480180>>2];break n}f=(e+g|0)+1398|0;u:{if(w[f|0]){v[23540]=0;Y(546,e+224|0);h=v[23540];v[23540]=0;v:{w:{x:{if((h|0)!=1){f=w[f|0];v[23540]=0;v[e+1168>>2]=f-1;R(543,e+1192|0,e+1168|0);f=v[23540];v[23540]=0;if((f|0)==1){break x}v[23540]=0;U(288,e+304|0,e+224|0,e+1192|0);f=v[23540];v[23540]=0;if((f|0)==1){break w}f=e+304|0;Fe(e+1240|0,f);gf(ye(d,g),v[e+1240>>2],v[e+1244>>2]);zb(f);zb(e+1192|0);Xb(e+224|0);break u}d=P()|0;O()|0;break e}d=P()|0;O()|0;break v}d=P()|0;O()|0;zb(e+1192|0)}Xb(e+224|0);break e}f=rc(e+1232|0,21688);gf(ye(d,g),v[f>>2],v[e+1236>>2])}g=g+1|0;continue}}d=w[a+484376|0];f=v[a+484360>>2];v[23540]=0;f=Wb(f,d);d=h&5;da(340,f|0,m|0,w[e+1249|0]|w[e+1250|0]<<8,(d?65535:255)|0,(d?65535:254)|0);d=v[23540];v[23540]=0;if((d|0)!=1){v[23540]=0;U(190,e+304|0,m|0,B(w[e+1248|0],w[e+1253|0]|w[e+1254|0]<<8)<<1);d=v[23540];v[23540]=0;if((d|0)!=1){d=e+304|0;G=kc(e+1192|0,d);Bb(d);v[23540]=0;U(190,d|0,m|0,(w[e+1253|0]|w[e+1254|0]<<8)<<1);d=v[23540];v[23540]=0;y:{if((d|0)!=1){d=e+304|0;H=kc(e+1168|0,d);Bb(d);v[23540]=0;r=Q(218,e+1152|0,w[e+1255|0]|w[e+1256|0]<<8)|0;d=v[23540];v[23540]=0;z:{if((d|0)!=1){N=e,V=Fb(v[r>>2]),v[N+248>>2]=V;d=Fb(v[r+4>>2]);A:{B:{C:{while(1){f=v[e+248>>2];if(!Pb(f,d)){j=a+480180|0;d=v[j>>2];A=c&1;if(!A){break B}v[23540]=0;R(225,a+484344|0,w[e+1253|0]|w[e+1254|0]<<8);f=v[23540];v[23540]=0;if((f|0)!=1){break B}d=P()|0;O()|0;break A}v[23540]=0;h=S(157,m|0)|0;g=v[23540];v[23540]=0;if((g|0)!=1){v[23540]=0;U(190,e+224|0,m|0,h|0);h=v[23540];v[23540]=0;if((h|0)==1){break C}g=f;f=e+224|0;h=kc(e+304|0,f);hd(g,h);Bb(h);Bb(f);Nf(e+248|0);continue}break}d=P()|0;O()|0;break A}d=P()|0;O()|0;break A}s=(d|0)==16?14:(d|0)==32?1:13;I=a+484344|0;n=1;while(1){D:{E:{F:{G:{H:{I:{if((w[e+1253|0]|w[e+1254|0]<<8)>>>0<=q>>>0){switch(v[a+480180>>2]-1|0){case 0:break G;case 3:break I;default:break F}}v[23540]=0;d=S(194,H|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break H}v[e+224>>2]=d;if(!A){break D}v[23540]=0;d=W(226,I|0,q&65535,d|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break H}l=0;if(!d){break D}while(1){h=l&65535;if(h>>>0>=w[e+1248|0]){break D}v[23540]=0;d=S(194,G|0)|0;f=v[23540];v[23540]=0;J:{if((f|0)!=1){f=v[r>>2];if(Bf(f,v[r+4>>2])>>>0<=d>>>0){break J}k=Ng(f,d);zc(k);f=0;d=_b(v[I>>2],q);g=jd(v[d>>2],v[v[d+48>>2]+12>>2],0,h);K:while(1){if(y[e+224>>2]<=f>>>0){break J}v[23540]=0;d=S(206,k|0)|0;h=v[23540];v[23540]=0;if((h|0)!=1){if(!d){break J}z=d>>>4|0;J=d&15;i=0;h=ug(e+304|0);while(1){L:{M:{N:{if(J>>>0>(i&255)>>>0){v[23540]=0;R(260,e+248|0,k|0);d=v[23540];v[23540]=0;if((d|0)==1){break N}O:{P:{Q:{R:{S:{T:{U:{V:{W:{X:{Y:{Z:{_:{$:{aa:{ba:{ca:{da:{ea:{d=w[Lb(e+248|0,0)|0];switch(d-1|0){case 2:case 3:case 4:case 7:case 8:case 9:case 11:case 12:case 13:case 16:case 18:case 21:case 22:case 23:case 24:case 25:case 27:case 32:break O;case 33:break S;case 30:case 31:break T;case 29:break U;case 28:break V;case 26:break W;case 19:case 20:break X;case 17:break Y;case 15:break Z;case 14:break _;case 10:break $;case 6:break aa;case 5:break ba;case 1:break ca;case 0:break da;default:break ea}}switch(d-48|0){case 4:break P;case 1:case 2:break Q;case 0:break R;default:break O}}d=w[Lb(e+248|0,1)|0];fa:{if(d>>>0<=119){d=d+s|0;break fa}ga:{switch(d-254|0){case 1:d=255;break fa;case 0:d=254;break fa;default:break ga}}d=253}t[h|0]=d;n=iB(d)&n;break L}N=e,V=w[Lb(e+248|0,1)|0]+1|0,t[N+305|0]=V;break L}ha:{if(w[e+306|0]){break ha}d=v[j>>2];if((d|0)!=32){if((d|0)!=4){break ha}d=w[Lb(e+248|0,1)|0];if(d&15){break ha}t[e+306|0]=11;t[e+308|0]=d>>>4;break L}o=w[Lb(e+248|0,1)|0];d=0;while(1){if((d|0)==10){break ha}if((o|0)==w[d+43808|0]){t[e+308|0]=d;t[e+306|0]=11;break L}else{d=d+1|0;continue}}}N=e,V=w[Lb(e+248|0,1)|0],t[N+309|0]=V;t[e+307|0]=4;break L}d=Lb(e+248|0,1);ia:{if(w[e+306|0]){break ia}o=w[d|0];if(v[j>>2]!=32|o>>>0>9){break ia}t[e+308|0]=o;t[e+306|0]=8;break L}t[e+309|0]=w[d|0];t[e+307|0]=5;break L}ja:{if(w[e+306|0]){break ja}ka:{d=v[j>>2];if((d|0)!=4){if((d|0)!=32){break ja}d=Lb(e+248|0,1);o=w[d|0];if((o|0)!=255){break ka}t[e+308|0]=64;t[e+306|0]=2;break L}d=Lb(e+248|0,1);if(w[d|0]&15){break ja}break M}if(!(o&3)){break M}}N=e,V=w[Lb(e+248|0,1)|0],t[N+309|0]=V;t[e+307|0]=9;break L}o=w[e+306|0];d=Lb(e+248|0,1);la:{if(o|v[j>>2]==1){break la}o=w[d|0];if(o>>>0>64){break la}t[e+308|0]=o;t[e+306|0]=1;break L}t[e+309|0]=w[d|0];t[e+307|0]=13;break L}d=w[Lb(e+248|0,1)|0];t[e+309|0]=d;t[e+307|0]=14;if(v[j>>2]==32){break L}t[e+309|0]=B((d&240)>>>4|0,10)+(d&15);break L}d=w[Lb(e+248|0,1)|0];t[e+309|0]=d;t[e+307|0]=d>>>0<32?16:17;break L}o=w[Lb(e+248|0,1)|0];if(o>>>0>=16){t[e+308|0]=o>>>4;t[e+306|0]=(d|0)==20?3:5;break L}t[e+308|0]=o&15;t[e+306|0]=(d|0)==20?4:6;break L}d=w[Lb(e+248|0,1)|0];if(d>>>0>=16){t[e+306|0]=10;t[e+308|0]=d>>>4;break L}t[e+306|0]=9;t[e+308|0]=d&15;break L}d=w[Lb(e+248|0,1)|0];t[e+307|0]=28;t[e+309|0]=d|16;break L}d=w[Lb(e+248|0,1)|0];t[e+307|0]=28;t[e+309|0]=d|32;break L}N=e,V=w[Lb(e+248|0,1)|0],t[N+308|0]=V;t[e+306|0]=(d|0)==31?7:8;break L}d=w[e+307|0];t[e+307|0]=(d|0)==4?6:(d|0)==5?7:11;N=e,V=w[Lb(e+248|0,1)|0],t[N+309|0]=V;break L}d=Lb(e+248|0,1);t[e+308|0]=w[d|0]%10;d=w[d|0];if(d>>>0<=9){t[e+306|0]=5;break L}if(d>>>0<=19){t[e+306|0]=6;break L}if(d>>>0<=29){t[e+306|0]=3;break L}if(d>>>0>39){break L}t[e+306|0]=4;break L}N=e,V=w[Lb(e+248|0,1)|0],t[N+308|0]=V;t[e+306|0]=(d|0)==49?13:12;break L}d=w[Lb(e+248|0,1)|0]+33|0;if((d&255)>>>0>9){break L}t[e+306|0]=15;t[e+308|0]=d;break L}if(d>>>0>57){break L}N=e,V=w[Lb(e+248|0,1)|0],t[N+309|0]=V;t[e+307|0]=w[d+26880|0];break L}v[e+248>>2]=f+z;d=v[Kb(e+248|0,e+224|0)>>2];d=d>>>0<f>>>0?f:d;while(1){if((d|0)!=(f|0)){i=w[h|0]|w[h+1|0]<<8|(w[h+2|0]<<16|w[h+3|0]<<24);t[g|0]=i;t[g+1|0]=i>>>8;t[g+2|0]=i>>>16;t[g+3|0]=i>>>24;i=w[h+4|0]|w[h+5|0]<<8;t[g+4|0]=i;t[g+5|0]=i>>>8;f=f+1|0;g=B(w[e+1248|0],6)+g|0;continue}break}f=d;continue K}d=P()|0;O()|0;break A}d=w[d|0];t[e+306|0]=2;t[e+308|0]=d>>>2}i=i+1|0;continue}}break}d=P()|0;O()|0;break A}d=P()|0;O()|0;break A}l=l+1|0;continue}}g=x[a+480192>>1];d=0;break E}d=P()|0;O()|0;break A}if((n^1)&1|x[D>>1]!=4){break F}v[a+480208>>2]=v[a+480208>>2]|8454144}g=0;d=!((w[e+1263|0]|w[e+1264|0]<<8|(w[e+1265|0]<<16|w[e+1266|0]<<24))&512)}v[23540]=0;o=Q(547,e+1136|0,g|0)|0;f=v[23540];v[23540]=0;ma:{na:{oa:{pa:{qa:{if((f|0)!=1){q=a+480192|0;j=p>>>0<5;n=a+480180|0;i=1;ra:{while(1){g=i&65535;if(g>>>0>x[q>>1]){break ra}sa:{ta:{ua:{va:{if(!d){v[23540]=0;h=W(251,a|0,g|0,0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break va}if(h){break ua}}while(1){v[23540]=0;f=S(206,m|0)|0;h=v[23540];v[23540]=0;if((h|0)==1){break na}if(f){continue}break}if(!j){while(1){v[23540]=0;f=S(206,m|0)|0;h=v[23540];v[23540]=0;if((h|0)==1){d=P()|0;O()|0;break ma}if(f){continue}break}}v[23540]=0;Q(188,m|0,826)|0;f=v[23540];v[23540]=0;if((f|0)!=1){break ta}}d=P()|0;O()|0;break ma}f=Nb(e+224|0);v[23540]=0;U(350,m|0,f|0,-1);l=v[23540];v[23540]=0;if((l|0)==1){break sa}Dc(h+492|0,f);if(!j){v[23540]=0;U(350,m|0,f|0,-1);l=v[23540];v[23540]=0;if((l|0)==1){break sa}Dc(h+524|0,f)}v[23540]=0;l=Q(548,m|0,e+304|0)|0;k=v[23540];v[23540]=0;if((k|0)==1){break oa}if(!l){break qa}l=v[n>>2];v[23540]=0;U(549,e+304|0,h|0,l|0);h=v[23540];v[23540]=0;if((h|0)==1){break oa}if(v[n>>2]==4){h=Eb(v[o>>2],g-1|0);g=x[e+1106>>1]|x[e+1108>>1]<<16;t[h|0]=g;t[h+1|0]=g>>>8;t[h+2|0]=g>>>16;t[h+3|0]=g>>>24}zb(f)}i=i+1|0;continue}break}break oa}if(!d){break pa}u[a+480192>>1]=0;break pa}d=P()|0;O()|0;break A}zb(f)}d=x[a+480190>>1];v[23540]=0;q=Q(550,e+288|0,d|0)|0;d=v[23540];v[23540]=0;if((d|0)!=1){J=!(t[e+1263|0]&1)|p>>>0>4;A=c&2;M=a+480180|0;i=1;d=0;while(1){c=d;wa:{xa:{ya:{za:{Aa:{Ba:{Ca:{Da:{Ea:{Fa:{Ga:{Ha:{Ia:{Ja:{Ka:{La:{Ma:{Na:{Oa:{Pa:{Qa:{Ra:{n=i&65535;if(n>>>0<=x[a+480190>>1]){g=Nb(e+272|0);v[23540]=0;U(350,m|0,g|0,-1);d=v[23540];v[23540]=0;if((d|0)==1){break Ra}j=B(n,104)+a|0;Dc(((n<<5)+a|0)+946304|0,g);d=p>>>0<5;if(!d){v[23540]=0;U(350,m|0,g|0,-1);f=v[23540];v[23540]=0;if((f|0)==1){break Ra}Be(j+484423|0,g)}v[23540]=0;f=Q(551,m|0,e+304|0)|0;h=v[23540];v[23540]=0;Sa:{Ta:{if((h|0)==1){break Ta}if(!f){break Sa}h=v[M>>2];v[23540]=0;f=j+484380|0;X(552,e+304|0,f|0,h|0,J|0);h=v[23540];v[23540]=0;if((h|0)==1){break Ta}s=0;Ua:{if((x[e+324>>1]&61440)!=28672|d){break Ua}v[23540]=0;s=S(553,m|0)|0;d=v[23540];v[23540]=0;if((d|0)!=1){break Ua}d=P()|0;O()|0;break za}if(!A){break xa}h=w[e+339|0]|w[e+340|0]<<8|(w[e+341|0]<<16|w[e+342|0]<<24);d=x[e+324>>1];l=d&61440;if(!(h|l)){d=Zc(e+224|0,d&1?16:8,d&1024?3:1,0,0);v[23540]=0;W(219,d|0,f|0,b|0)|0;d=v[23540];v[23540]=0;if((d|0)!=1){break xa}d=P()|0;O()|0;break za}if((h|0)<0){d=h+n|0;if((d|0)<=0){break xa}xS(f,(B(d,104)+a|0)+484380|0);break xa}if((h|0)<=0){break xa}if(d&1){k=j+484414|0;u[k>>1]=x[k>>1]|1}if(d&1024){k=j+484414|0;u[k>>1]=x[k>>1]|64}v[23540]=0;U(190,e+224|0,b|0,h|0);h=v[23540];v[23540]=0;Va:{Wa:{Xa:{Ya:{Za:{_a:{if((h|0)!=1){k=e+224|0;h=kc(e+248|0,k);Bb(k);k=Ld(x[f+34>>1]);K=(l|0)==16384;if(!K&(l|0)!=8192){break Ya}z=v[h>>2];v[23540]=0;z=S(160,z|0)|0;E=v[23540];v[23540]=0;if((E|0)==1){break Va}E=4/(k>>>0)|0;Jka(E,0,z,0);xc(f,nb?-1:B(E,z));if((l|0)==8192){break _a}if(!K){break Ya}if(!Mg(f)){break Xa}d=v[j+484400>>2];f=v[f>>2];if(!(t[e+324|0]&1)){break Za}v[23540]=0;X(554,h|0,d|0,f|0,k|0);f=v[23540];v[23540]=0;d=c;if((f|0)==1){break Ba}break Wa}d=P()|0;O()|0;break za}if(!Mg(f)){break Xa}d=v[j+484400>>2];f=v[f>>2];if(t[e+324|0]&1){v[23540]=0;X(555,h|0,d|0,f|0,k|0);f=v[23540];v[23540]=0;d=c;if((f|0)!=1){break Wa}break Ba}v[23540]=0;X(556,h|0,d|0,f|0,k|0);f=v[23540];v[23540]=0;d=c;if((f|0)==1){break Ba}break Wa}v[23540]=0;X(557,h|0,d|0,f|0,k|0);f=v[23540];v[23540]=0;d=c;if((f|0)==1){break Ba}break Wa}if((d&45056)==12288){d=wS(e+224|0,h,w[e+343|0]|w[e+344|0]<<8,s);N=hd(lf(v[q>>2],n-1|0),d),V=v[d+20>>2],v[N+20>>2]=V;Bb(d);break Xa}if((l|0)!=32768){d=1;if((l|0)!=4096){break Wa}l=je(e+224|0,h);v[23540]=0;d=Q(558,e+216|0,h|0)|0;k=v[23540];v[23540]=0;if((k|0)!=1){$a:{ab:{if(!w[e+221|0]){break ab}s=w[e+343|0]|w[e+344|0]<<8;k=x[e+218>>1]<<1;if(s>>>0<(k&65535)>>>0){break ab}k=s-k|0;t[e+343|0]=k;t[e+344|0]=k>>>8;d=x[d>>1];v[23540]=0;Q(155,h|0,d|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break $a}v[23540]=0;d=S(202,h|0)|0;k=v[23540];v[23540]=0;if((k|0)==1){break $a}v[23540]=0;U(190,e+168|0,h|0,d|0);d=v[23540];v[23540]=0;if((d|0)==1){break $a}d=e+168|0;k=kc(e+192|0,d);hd(l,k);Bb(k);Bb(d)}v[23540]=0;n=W(559,a|0,n|0,l|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break $a}d=1;if(n){d=w[e+343|0]|w[e+344|0]<<8;bb:{if(!d){break bb}n=x[f+34>>1];k=Ij(v[f>>2],n);if(k>>>0<=d>>>0){break bb}n=Fk(n);j=v[j+484400>>2];fj(j,d+j|0,k-d|0);v[f>>2]=v[f>>2]-((d>>>0)/(n>>>0)|0)}xc(f,v[e+312>>2]);d=c}Bb(l);break Wa}}d=P()|0;O()|0;Bb(l);break Aa}v[23540]=0;d=Q(417,h|0,e+224|0)|0;j=v[23540];v[23540]=0;if((j|0)==1){break Qa}if(!d){break Xa}v[e+80>>2]=v[e+232>>2];d=v[e+228>>2];v[e+72>>2]=v[e+224>>2];v[e+76>>2]=d;Dl(f,1,e+72|0)}d=c}Bb(h);break wa}d=P()|0;O()|0;break Aa}d=P()|0;O()|0;break za}zb(g)}cb:{if(!A){break cb}n=1;while(1){g=n&65535;if(g>>>0>x[a+480190>>1]){break cb}b=lf(v[q>>2],g-1|0);d=v[b>>2];v[23540]=0;d=S(178,d|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break Pa}db:{eb:{if(!d){break eb}f=x[b+22>>1];d=f+n&65535;i=x[b+20>>1];j=(f|0)!=0&(d|0)!=0&d>>>0<=x[a+480190>>1]&(i|0)!=0;fb:{if(j){f=lf(v[q>>2],d-1|0);break fb}d=v[b>>2];v[23540]=0;i=S(160,d|0)|0;d=v[23540];v[23540]=0;f=b;if((d|0)==1){break Oa}}zc(f);gb:{if(j){d=v[f+8>>2];h=v[f>>2];p=x[b+20>>1];v[23540]=0;d=W(156,h|0,d|0,p|0)|0;h=v[23540];v[23540]=0;if((h|0)==1){break Oa}if(!d){break eb}v[e+224>>2]=0;v[e+248>>2]=0;v[23540]=0;U(203,e+304|0,f|0,i|0);d=v[23540];v[23540]=0;hb:{if((d|0)!=1){h=tA(Ie(e+304|0),Fi(v[e+304>>2]),e+224|0,e+248|0);v[23540]=0;Q(188,f|0,v[e+224>>2])|0;d=v[23540];v[23540]=0;if((d|0)==1){break hb}Uc(e+304|0);break gb}d=P()|0;O()|0;break ya}d=P()|0;O()|0;Uc(e+304|0);break ya}h=0;v[e+224>>2]=0;v[e+248>>2]=0}v[23540]=0;R(560,e+304|0,b|0);d=v[23540];v[23540]=0;ib:{jb:{if((d|0)!=1){d=Ie(e+304|0);i=v[e+304>>2];if(!j){h=tA(d,Fi(i),e+224|0,e+248|0);v[23540]=0;f=v[e+224>>2];Q(188,b|0,f|0)|0;j=v[23540];v[23540]=0;if((j|0)==1){break db}i=i-f|0;d=d+f|0}if(h){break jb}c=1;break ib}d=P()|0;O()|0;break ya}f=B(g,104)+a|0;p=f+484380|0;Mg(p);s=f+484400|0;f=0;g=v[e+248>>2];while(1){kb:{if(!i|(g|0)!=1?g:0){break kb}g=v[p>>2];if(g>>>0<=f>>>0){break kb}if(!_d(g,v[p+20>>2])){break kb}v[e+192>>2]=0;v[e+168>>2]=0;l=vS(h,d,Fi(i),e+192|0,e+272|0,e+168|0);v[23540]=0;v[e+224>>2]=l;Q(188,b|0,l|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break Ca}ci(e+168|0,Fi(v[p>>2]-f|0));j=v[e+168>>2];lb:{if((j|0)<=0){break lb}g=v[e+192>>2];z=x[p+34>>1];if((Ld(z)|0)!=(g|0)){break lb}k=B(f,g);A=v[s>>2];if(z&1){v[e+160>>2]=j;v[e+144>>2]=j;v[e- -64>>2]=j;v[e+48>>2]=j;v[e+140>>2]=g;v[e+136>>2]=v[e+272>>2];v[e+156>>2]=g;v[e+152>>2]=A+(k<<1);v[23540]=0;g=v[e+140>>2];v[e+40>>2]=v[e+136>>2];v[e+44>>2]=g;g=v[e+156>>2];v[e+56>>2]=v[e+152>>2];v[e+60>>2]=g;R(561,e+56|0,e+40|0);g=v[23540];v[23540]=0;if((g|0)!=1){break lb}break Ca}v[e+128>>2]=j;v[e+112>>2]=j;v[e+32>>2]=j;v[e+16>>2]=j;v[e+108>>2]=g;v[e+104>>2]=v[e+272>>2];v[e+124>>2]=g;v[e+120>>2]=k+A;v[23540]=0;g=v[e+108>>2];v[e+8>>2]=v[e+104>>2];v[e+12>>2]=g;g=v[e+124>>2];v[e+24>>2]=v[e+120>>2];v[e+28>>2]=g;R(562,e+24|0,e+8|0);g=v[23540];v[23540]=0;if((g|0)==1){break Ca}}i=i-l|0;d=d+l|0;g=uS(h);v[e+248>>2]=g;f=f+j|0;continue}break}tS(h)}Uc(e+304|0)}n=n+1|0;continue}break}break Ca}mb:{if(v[a+480180>>2]!=4){break mb}g=0;d=a+480192|0;while(1){if(x[d>>1]<=g>>>0){break mb}b=Eb(v[o>>2],g);f=w[b+3|0];h=w[b+2|0];i=w[b+1|0];b=w[b|0];v[23540]=0;g=g+1|0;ma(391,a|0,g&65535,b|0,i|0,h|0,f|0);b=v[23540];v[23540]=0;if((b|0)!=1){continue}break}d=P()|0;O()|0;break ya}if(!(w[e+1265|0]&16)){break Ka}b=v[m+8>>2];d=v[m>>2];v[23540]=0;b=W(156,d|0,b|0,1)|0;d=v[23540];v[23540]=0;if((d|0)==1){break Ma}if(!b){break Ka}g=0;v[23540]=0;b=S(206,m|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break Na}if(!(b&1)){break La}while(1){if(x[D>>1]<=g>>>0){break La}v[23540]=0;b=S(157,m|0)|0;d=v[23540];v[23540]=0;if((d|0)!=1){t[((g<<5)+a|0)+480288|0]=b;g=g+1|0;continue}break}d=P()|0;O()|0;break ya}d=P()|0;O()|0;break za}d=P()|0;O()|0;break Aa}d=P()|0;O()|0;break ya}d=P()|0;O()|0;break ya}d=P()|0;O()|0;break ya}d=P()|0;O()|0;break ya}d=a+906300|0;while(1){b=v[m+8>>2];f=v[m>>2];v[23540]=0;b=W(156,f|0,b|0,1)|0;f=v[23540];v[23540]=0;if((f|0)==1){break Da}if(!b){break Ka}v[23540]=0;b=S(206,m|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break Ia}if(!b){break Ka}v[23540]=0;f=S(157,m|0)|0;h=v[23540];v[23540]=0;if((h|0)==1){break Ja}v[23540]=0;U(190,e+224|0,m|0,f|0);f=v[23540];v[23540]=0;if((f|0)==1){break Ja}h=e+224|0;f=kc(e+304|0,h);Bb(h);nb:{if(b>>>0<=250){v[23540]=0;R(439,f|0,Md(d,b-1|0)|0);b=v[23540];v[23540]=0;if((b|0)==1){break nb}}Bb(f);continue}break}d=P()|0;O()|0;Bb(f);break ya}j=a+901404|0;i=Nb(e+192|0);n=a+480180|0;p=a+484348|0;d=0;h=0;while(1){b=v[m+8>>2];f=v[m>>2];v[23540]=0;b=W(156,f|0,b|0,8)|0;f=v[23540];v[23540]=0;ob:{pb:{qb:{rb:{sb:{if((f|0)!=1){if(b){v[23540]=0;f=S(157,m|0)|0;b=v[23540];v[23540]=0;tb:{ub:{vb:{wb:{xb:{yb:{zb:{Ab:{if((b|0)!=1){v[23540]=0;b=S(157,m|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break Ab}v[23540]=0;U(190,e+304|0,m|0,b|0);b=v[23540];v[23540]=0;if((b|0)==1){break zb}g=e+304|0;b=kc(e+224|0,g);Bb(g);if((f|0)==1229211981){break wb}if((f|0)==1229476432){break xb}if((f|0)==1397900630){break yb}if((f|0)!=1414548815){break ob}v[23540]=0;f=Q(402,b|0,13874)|0;g=v[23540];v[23540]=0;if((g|0)==1){break Ha}if(!f){break pb}v[23540]=0;f=S(157,b|0)|0;g=v[23540];v[23540]=0;if((g|0)!=1){v[23540]=0;U(190,e+304|0,b|0,f|0);f=v[23540];v[23540]=0;if((f|0)!=1){break vb}}d=P()|0;O()|0;break Ga}d=P()|0;O()|0;break Ea}d=P()|0;O()|0;break Ea}d=P()|0;O()|0;break Ea}Bb:{Cb:{Db:{f=v[n>>2];switch(f-2|0){case 1:break ob;case 0:break ub;case 2:break Cb;default:break Db}}if((f|0)==16){break Bb}if((f|0)!=32){break ob}v[23540]=0;d=S(194,b|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break Ha}v[23540]=0;h=S(194,b|0)|0;f=v[23540];v[23540]=0;if((f|0)!=1){break ob}break Ha}v[e+304>>2]=32;f=v[b>>2];v[23540]=0;f=S(160,f|0)|0;g=v[23540];v[23540]=0;if((g|0)!=1){v[e+248>>2]=f;f=v[Kb(e+304|0,e+248|0)>>2];v[23540]=0;U(563,b|0,i|0,f|0);f=v[23540];v[23540]=0;if((f|0)!=1){break ob}}d=P()|0;O()|0;break Ga}v[23540]=0;f=S(206,b|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break tb}v[23540]=0;R(564,e+248|0,4214);g=v[23540];v[23540]=0;Eb:{if((g|0)!=1){v[e+272>>2]=f>>>4;v[23540]=0;v[e+88>>2]=f&15;X(302,e+304|0,e+248|0,e+272|0,e+88|0);f=v[23540];v[23540]=0;if((f|0)==1){break Eb}f=e+304|0;Jb(i,f);Ab(f);dc(e+248|0);break ob}d=P()|0;O()|0;break Ga}d=P()|0;O()|0;dc(e+248|0);break Ga}v[23540]=0;f=S(206,b|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break Ha}v[a+480216>>2]=f;v[23540]=0;f=S(206,b|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break Ha}v[a+480220>>2]=f;break ob}v[23540]=0;Q(412,b|0,j|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break Ha}WA(j);break ob}g=e+304|0;f=kc(e+248|0,g);Bb(g);g=v[f>>2];v[23540]=0;g=S(160,g|0)|0;l=v[23540];v[23540]=0;if((l|0)==1){break qb}u[e+304>>1]=g>>>5;N=e,V=Af(v[a+484344>>2],v[p>>2]),u[N+272>>1]=V;l=x[Wc(e+304|0,e+272|0)>>1];g=0;while(1){if((g|0)==(l|0)){Bb(f);break pb}v[23540]=0;R(565,f|0,e+304|0);k=v[23540];v[23540]=0;Fb:{if((k|0)==1){break Fb}k=v[I>>2];v[23540]=0;R(566,_b(k,g)|0,e+304|0);k=v[23540];v[23540]=0;if((k|0)==1){break Fb}g=g+1|0;continue}break}break qb}v[23540]=0;d=S(194,b|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break Ha}break ob}d=P()|0;O()|0;break Ga}b=v[a+480180>>2];Gb:{Hb:{Ib:{if((b|0)!=32){break Ib}f=d&65535;if(f>>>0<256){break Ib}if(f>>>0<532){break Hb}}b=(b|0)!=2;Jb:{if(b){break Jb}f=d&65535;if(f>>>0<12544){break Jb}if(f>>>0<12820){break Hb}}if(b){break Gb}b=d&65535;if(b>>>0<4864|b>>>0>4895){break Gb}}sq(j)}g=1;Kb:{if(!(t[e+1265|0]&1)){break Kb}f=v[a+1074308>>2];if(!f){d=a+480192|0;f=a+480180|0;while(1){b=g&65535;if(b>>>0<=x[d>>1]){b=v[((b<<2)+a|0)+900380>>2];if(b){j=v[f>>2];v[23540]=0;R(567,Ih(b,2)|0,j|0);j=v[23540];v[23540]=0;if((j|0)==1){break sb}t[b+19|0]=w[b+19|0]+3>>>2}g=g+1|0;continue}break}f=v[a+1074308>>2]}if(f>>>0<=18350079){v[23540]=0;b=Q(265,a+1074312|0,27)|0;d=v[23540];v[23540]=0;if((d|0)==1){break Fa}v[23540]=0;Q(265,b|0,57)|0;b=v[23540];v[23540]=0;if((b|0)==1){break Fa}f=v[a+1074308>>2]}if(f>>>0<=19070975){v[23540]=0;Q(265,a+1074312|0,73)|0;b=v[23540];v[23540]=0;if((b|0)==1){break Fa}f=v[a+1074308>>2]}if(f>>>0>19267583){break Kb}v[23540]=0;Q(265,a+1074312|0,50)|0;b=v[23540];v[23540]=0;if((b|0)==1){break Fa}}Lb:{Mb:{Nb:{Ob:{Pb:{Qb:{Rb:{Sb:{Tb:{Ub:{Vb:{Wb:{Xb:{Yb:{if(sh(v[i+4>>2],w[i+11|0])){v[23540]=0;Y(568,e+224|0);b=v[23540];v[23540]=0;Zb:{if((b|0)!=1){v[23540]=0;U(536,e+304|0,e+224|0,e+1735|0);b=v[23540];v[23540]=0;if((b|0)==1){break Zb}break Yb}d=P()|0;O()|0;break Ea}d=P()|0;O()|0;dc(e+224|0);break Ea}v[23540]=0;Y(569,e+224|0);b=v[23540];v[23540]=0;if((b|0)==1){break Xb}v[23540]=0;X(570,e+304|0,e+224|0,e+1735|0,i|0);b=v[23540];v[23540]=0;if((b|0)==1){break Wb}}b=e+304|0;Jb(i,b);Ab(b);b=e+224|0;dc(b);v[23540]=0;R(535,b|0,3980);b=v[23540];v[23540]=0;if((b|0)==1){break Ub}v[23540]=0;U(536,e+304|0,e+224|0,e+1735|0);b=v[23540];v[23540]=0;if((b|0)==1){break Tb}b=e+304|0;Jb(a+1298344|0,b);Ab(b);dc(e+224|0);v[23540]=0;b=Q(1,b|0,15023)|0;d=v[23540];v[23540]=0;if((d|0)==1){break Sb}Jb(a+1298356|0,b);Ab(b);b=v[a+480180>>2];switch(b-1|0){case 2:break rb;case 1:break Ob;case 3:break Pb;case 0:break Qb;default:break Vb}}d=P()|0;O()|0;break Ea}d=P()|0;O()|0;dc(e+224|0);break Ea}if((b|0)==16){break Rb}if((b|0)==32){break Nb}if((b|0)!=16777216){break rb}v[23540]=0;b=Q(1,e+224|0,10143)|0;d=v[23540];v[23540]=0;if((d|0)==1){break Mb}Jb(a+1298392|0,b);Ab(b);v[23540]=0;b=Q(1,e+248|0,13821)|0;d=v[23540];v[23540]=0;if((d|0)==1){break Lb}Jb(a+1298380|0,b);Ab(b);break rb}d=P()|0;O()|0;break Ea}d=P()|0;O()|0;dc(e+224|0);break Ea}d=P()|0;O()|0;break Ea}v[23540]=0;b=Q(1,e+224|0,10148)|0;d=v[23540];v[23540]=0;_b:{if((d|0)!=1){Jb(a+1298392|0,b);Ab(b);v[23540]=0;b=Q(1,e+248|0,8394)|0;d=v[23540];v[23540]=0;if((d|0)==1){break _b}Jb(a+1298380|0,b);Ab(b);break rb}d=P()|0;O()|0;break Ea}d=P()|0;O()|0;break Ea}v[23540]=0;b=Q(1,e+224|0,12307)|0;d=v[23540];v[23540]=0;$b:{if((d|0)!=1){Jb(a+1298392|0,b);Ab(b);v[23540]=0;b=Q(1,e+248|0,14288)|0;d=v[23540];v[23540]=0;if((d|0)==1){break $b}Jb(a+1298380|0,b);Ab(b);break rb}d=P()|0;O()|0;break Ea}d=P()|0;O()|0;break Ea}v[23540]=0;b=Q(1,e+224|0,10121)|0;d=v[23540];v[23540]=0;ac:{if((d|0)!=1){Jb(a+1298392|0,b);Ab(b);v[23540]=0;b=Q(1,e+248|0,15326)|0;d=v[23540];v[23540]=0;if((d|0)==1){break ac}Jb(a+1298380|0,b);Ab(b);break rb}d=P()|0;O()|0;break Ea}d=P()|0;O()|0;break Ea}v[23540]=0;b=Q(1,e+224|0,10493)|0;d=v[23540];v[23540]=0;bc:{if((d|0)!=1){Jb(a+1298392|0,b);Ab(b);v[23540]=0;b=Q(1,e+248|0,15076)|0;d=v[23540];v[23540]=0;if((d|0)==1){break bc}Jb(a+1298380|0,b);Ab(b);break rb}d=P()|0;O()|0;break Ea}d=P()|0;O()|0;break Ea}v[23540]=0;b=Q(1,e+224|0,6130)|0;d=v[23540];v[23540]=0;cc:{dc:{ec:{fc:{gc:{if((d|0)!=1){Jb(a+1298392|0,b);Ab(b);if(!(h&65535)){break cc}v[23540]=0;R(266,e+272|0,4317);b=v[23540];v[23540]=0;if((b|0)==1){break gc}v[e+100>>2]=(h&65280)>>>8;v[23540]=0;v[e+84>>2]=h&255;R(433,e+88|0,e+84|0);b=v[23540];v[23540]=0;if((b|0)==1){break fc}v[23540]=0;X(419,e+248|0,e+272|0,e+100|0,e+88|0);b=v[23540];v[23540]=0;if((b|0)==1){break ec}b=e+248|0;Jb(a+1298380|0,b);Ab(b);Ab(e+88|0);dc(e+272|0);break rb}d=P()|0;O()|0;break Ea}d=P()|0;O()|0;break Ea}d=P()|0;O()|0;break dc}d=P()|0;O()|0;Ab(e+88|0)}dc(e+272|0);break Ea}v[23540]=0;b=Q(1,e+248|0,8586)|0;d=v[23540];v[23540]=0;if((d|0)!=1){Jb(a+1298380|0,b);Ab(b);break rb}d=P()|0;O()|0;break Ea}d=P()|0;O()|0;break Ea}d=P()|0;O()|0;break Ea}d=P()|0;O()|0;break Ea}d=P()|0;O()|0;break Ea}Jb(a+1298368|0,i);hc:{if(v[a+1074308>>2]){v[a+1298404>>2]=8;break hc}if(v[a+480180>>2]==1){v[a+1298404>>2]=14;break hc}v[a+1298404>>2]=5}g=1;ic:{jc:{if(c&1){v[23540]=0;b=Q(1,e+272|0,16663)|0;c=v[23540];v[23540]=0;if((c|0)==1){break jc}a=v[a+1298464>>2];v[23540]=0;U(376,a|0,2,b|0);a=v[23540];v[23540]=0;if((a|0)==1){break ic}Ab(b)}Ab(i);sS(q);wc(o);Vc(r);Bb(H);Bb(G);break c}d=P()|0;O()|0;break Ea}d=P()|0;O()|0;Ab(b);break Ea}d=P()|0;O()|0;Bb(f);break Ga}v[23540]=0;f=Q(402,b|0,13879)|0;g=v[23540];v[23540]=0;if((g|0)==1){break Ha}kc:{if(!f){break kc}v[23540]=0;f=S(157,b|0)|0;g=v[23540];v[23540]=0;lc:{if((g|0)!=1){v[23540]=0;U(190,e+248|0,b|0,f|0);f=v[23540];v[23540]=0;if((f|0)!=1){break lc}}d=P()|0;O()|0;break Ga}g=e+248|0;f=kc(e+304|0,g);Bb(g);g=v[f>>2];v[23540]=0;g=S(160,g|0)|0;l=v[23540];v[23540]=0;if((l|0)!=1){u[e+248>>1]=(g>>>0)/20;u[e+272>>1]=x[D>>1];l=x[Wc(e+248|0,e+272|0)>>1];g=0;while(1){if((g|0)==(l|0)){Bb(f);break kc}v[23540]=0;U(413,f|0,((g<<5)+a|0)+480289|0,20);k=v[23540];v[23540]=0;if((k|0)!=1){g=g+1|0;continue}break}}d=P()|0;O()|0;Bb(f);break Ga}v[23540]=0;Q(422,a|0,b|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break Ha}v[23540]=0;X(423,a|0,b|0,1,0);f=v[23540];v[23540]=0;if((f|0)==1){break Ha}if((d-2186&65535)>>>0<=117){v[n>>2]=16777216;v[23540]=0;U(437,a|0,b|0,d&65535);f=v[23540];v[23540]=0;if((f|0)==1){break Ha}}if(!v[a+1074308>>2]){break ob}v[23540]=0;f=Q(1,e+168|0,17648)|0;g=v[23540];v[23540]=0;mc:{nc:{oc:{if((g|0)!=1){g=v[a+1074308>>2];v[23540]=0;R(140,e+248|0,g|0);g=v[23540];v[23540]=0;if((g|0)==1){break oc}v[23540]=0;U(2,e+304|0,f|0,e+248|0);g=v[23540];v[23540]=0;if((g|0)==1){break nc}g=e+304|0;Jb(i,g);Ab(g);Ab(e+248|0);Ab(f);break ob}d=P()|0;O()|0;break Ga}d=P()|0;O()|0;break mc}d=P()|0;O()|0;Ab(e+248|0)}Ab(f);break Ga}Bb(b);continue}}d=P()|0;O()|0;break ya}d=P()|0;O()|0;break ya}d=P()|0;O()|0}Bb(b);break Ea}d=P()|0;O()|0}Ab(i);break ya}d=P()|0;O()|0;break ya}d=P()|0;O()|0;Uc(e+304|0);break ya}d=P()|0;O()|0}Bb(h)}zb(g)}sS(q);break ma}d=c}zb(g);i=i+1|0;continue}}d=P()|0;O()|0;break ma}d=P()|0;O()|0;zb(f);break ma}d=P()|0;O()|0}wc(o);break A}q=q+1|0;continue}}Vc(r);break z}d=P()|0;O()|0}Bb(H);break y}d=P()|0;O()|0}Bb(G);break e}d=P()|0;O()|0;break e}d=P()|0;O()|0;break e}else{pc:{qc:{if(!j){t[e+304|0]=w[(e+g|0)+1270|0];t[e+224|0]=64;N=((g<<5)+a|0)+480286|0,V=w[Yb(e+304|0,e+224|0)|0],u[N>>1]=V;break qc}if(n){break pc}}rc:{d=w[(e+g|0)+1334|0];if((d|0)!=255){if((d|0)!=127){break rc}v[((g<<5)+a|0)+480280>>2]=256;break pc}u[((g<<5)+a|0)+480284>>1]=256;break pc}u[((g<<5)+a|0)+480284>>1]=d}g=g+1|0;continue}}d=P()|0;O()|0;break d}d=P()|0;O()|0;break d}d=P()|0;O()|0}Bb(m)}ic(C);T(d|0);L()}Bb(m)}ic(C)}kb=e+1744|0;return g|0}function rha(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,y=0,z=0,A=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,M=0,N=0,V=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0;e=kb-976|0;kb=e;zc(b);a:{if(!GS(b,e+920|0)){break a}if(!KS(e+920|0)){break a}if(!Qb(v[b>>2],v[b+8>>2],Ec(JS(e+920|0),nb))){break a}if(!c){d=1;break a}Cd(a,8);ag(a);aa=w[e+923|0];K=aa-48|0;t[e+919|0]=K;dd(b,bc(v[e+928>>2]));f=e+608|0;ae(f,b,504);_=kc(e+896|0,f);Bb(f);v[23540]=0;R(509,b|0,f|0);f=v[23540];v[23540]=0;b:{c:{d:{e:{f:{g:{if((f|0)!=1){if(w[e+891|0]>63){break b}if(Ib(x[e+608>>1])<<16>>16<0){break b}Ub(e+528|0,0,80);h:{d=bc(v[e+952>>2]);if(!d){break h}v[23540]=0;f=Q(155,b|0,d|0)|0;d=v[23540];v[23540]=0;if((d|0)!=1){if(!f){break h}v[23540]=0;R(510,b|0,e+528|0);d=v[23540];v[23540]=0;if((d|0)!=1){break h}}i=P()|0;O()|0;break e}v[23540]=0;U(511,e+520|0,b|0,K&255);d=v[23540];v[23540]=0;if((d|0)!=1){ba=Te(e+520|0);d=0;f=x[e+520>>1];if((f-128&65535)>>>0<65409){break b}u[a+480188>>1]=f;M=Tb(e+504|0);d=bc(v[e+944>>2]);i:{if(d){v[23540]=0;Q(155,b|0,d|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break g}v[23540]=0;U(512,b|0,M|0,w[e+891|0]);d=v[23540];v[23540]=0;if((d|0)==1){break g}j=w[e+891|0];break i}j=w[e+891|0];d=0;if(j){break c}}j=j&255;u[a+480192>>1]=j;u[a+480190>>1]=j;ca=(K&255)>>>0<2|t[e+872|0]>=0;r=!ca;p=c&2;s=1;C=1;while(1){j:{k:{l:{m:{n:{o:{g=C&65535;if(g>>>0<=(j&65535)>>>0){v[23540]=0;y=s&65535;f=W(251,a|0,g|0,y|0)|0;d=v[23540];v[23540]=0;p:{if((d|0)!=1){if(f){break p}break d}i=P()|0;O()|0;break f}z=v[((g<<2)+a|0)+900380>>2];u[e+84>>1]=0;v[e+80>>2]=0;v[23540]=0;D=S(174,e+480|0)|0;d=v[23540];v[23540]=0;q:{if((d|0)!=1){d=Eb(v[M>>2],g-1|0);d=bc(w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24));r:{if(!d){break r}v[23540]=0;f=Q(155,b|0,d|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break k}if(!f){break r}v[23540]=0;R(513,b|0,e+80|0);d=v[23540];v[23540]=0;if((d|0)==1){break k}f=v[e+80>>2];d=u[e+84>>1];v[23540]=0;f=bc(f);d=pe(d);U(190,e+120|0,b|0,f<<(d>>>5&1&(d|0)>0));d=v[23540];v[23540]=0;if((d|0)==1){break k}f=e+120|0;d=kc(e+192|0,f);hd(D,d);Bb(d);Bb(f)}q=pe(u[e+84>>1]);d=q&15;if((q|0)>=0){break q}cu(z,0);ea=1;break o}i=P()|0;O()|0;break f}if(d>>>0>6){break o}A=w[d+26758|0];if(!d){break m}u[a+480190>>1]=(x[a+480190>>1]+A|0)-1;l=z+108|0;m=z+236|0;n=A-2|0;j=4;s:while(1){g=1;if((j|0)==10){break n}k=B(j,12);d=(n<<3)+j|0;h=w[d+26764|0]+s|0;g=w[d+26812|0];d=0;while(1)if((d|0)==12){j=j+1|0;continue s}else{f=d+k|0;fa=cc(m,f),ga=h,u[fa>>1]=ga;f=Lb(l,f);t[f|0]=g+w[f|0];d=d+1|0;continue}}}t:{u:{v:{w:{x:{y:{z:{A:{B:{C:{D:{d=bc(v[e+532>>2]);if(!d){break D}if(!Ib(x[e+536>>1])){break D}v[23540]=0;f=Q(155,b|0,d|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break C}if(!f){break D}fa=e,ga=Ib(x[e+536>>1]),u[fa+192>>1]=ga;u[e+120>>1]=w[e+891|0];f=e+120|0;p=x[Wc(e+192|0,f)>>1];d=e+128|0;l=f|4;y=Ib(x[e+538>>1]);m=y>>>0<19;n=y>>>0<21;k=y>>>0<15;h=y>>>0<6;j=0;while(1){if((j|0)==(p|0)){break D}v[23540]=0;U(514,b|0,e+192|0,y|0);f=v[23540];v[23540]=0;E:{F:{G:{if((f|0)!=1){j=j+1|0;q=v[((j<<2)+a|0)+900380>>2];r=w[e+192|0];if(r){g=yl(e+120|0,0,64);yl(l,r-1&65535,64);f=w[e+193|0];if(f){f=64/(f>>>0)|0}else{f=0}yl(d,f+r|0,0);v[23540]=0;r=q+48|0;U(515,r|0,g|0,3);f=v[23540];v[23540]=0;if((f|0)==1){break G}if(w[e+192|0]==1){g=v[fc(e+472|0,Fb(v[r>>2]))>>2];f=Fb(v[r>>2]);f=v[r>>2]+(au(g,f)<<2)|0;Od(r,Oi(f+4|0,v[r+4>>2],f));Fb(f)}f=w[e+193|0];v[q>>2]=f?f<<9:32767;t[q+60|0]=w[q+60|0]|1;F=1}H:{if(m){break H}v[q+4>>2]=w[e+210|0]+1>>>1;if(n){break H}u[q+28>>1]=x[e+212>>1]}g=B(x[cc(q+236|0,61)>>1],104)+a|0;t[g+484417|0]=w[e+195|0]<<4;if(k){break F}f=bc(x[e+202>>1]|x[e+204>>1]<<16);v[g+484384>>2]=f;fa=g+484388|0,ga=bc(x[e+206>>1]|x[e+208>>1]<<16)+f|0,v[fa>>2]=ga;break E}i=P()|0;O()|0;break f}i=P()|0;O()|0;break f}if(h){continue}}f=g+484414|0;i=f;o=x[f>>1]&65529;f=w[e+197|0];u[i>>1]=o|f<<1&2|f>>>1&4;if(!(f&4)){continue}u[g+484412>>1]=0;continue}}I:{d=bc(v[e+548>>2]);if(!d){break I}if(!Ib(x[e+552>>1])){break I}v[23540]=0;f=Q(155,b|0,d|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break C}if(!f){break I}fa=e,ga=Ib(x[e+552>>1]),u[fa+192>>1]=ga;u[e+120>>1]=w[e+891|0];n=x[Wc(e+192|0,e+120|0)>>1];k=Ib(x[e+554>>1]);d=0;J:while(1){if((d|0)==(n|0)){break I}v[23540]=0;U(516,b|0,e+192|0,k|0);f=v[23540];v[23540]=0;if((f|0)==1){break t}f=e+80|0;qU(f,e+192|0);v[23540]=0;R(222,e+120|0,f|0);f=v[23540];v[23540]=0;if((f|0)==1){break u}d=d+1|0;m=((d<<2)+a|0)+900380|0;g=e+120|0;Dc(v[m>>2]+492|0,g);zb(g);f=v[m>>2];v[23540]=0;R(380,g|0,f|0);f=v[23540];v[23540]=0;if((f|0)==1){break v}fa=e,ga=Gi(v[e+120>>2]),v[fa+80>>2]=ga;h=xf(e+120|0);while(1){f=v[e+80>>2];if(Pb(f,h)){l=(x[so(f)>>1]<<5)+a|0;g=l+946328|0;p=v[m>>2];f=v[p+520>>2];v[g>>2]=v[p+516>>2];v[g+4>>2]=f;f=v[p+512>>2];g=l+946320|0;v[g>>2]=v[p+508>>2];v[g+4>>2]=f;f=v[p+504>>2];g=l+946312|0;v[g>>2]=v[p+500>>2];v[g+4>>2]=f;f=v[p+496>>2];g=l+946304|0;v[g>>2]=v[p+492>>2];v[g+4>>2]=f;Kg(e+80|0);continue}else{qu(e+120|0);continue J}}}}sq(a+901404|0);d=rc(e+464|0,4943);gf(ye(a+901692|0,0),v[d>>2],v[d+4>>2]);zc(b);D=c&1;G=a+484344|0;H=a+1298332|0;da=a+1298308|0;$=a+484360|0;c=0;while(1){K:{f=c&255;if(f>>>0<w[ba|0]){v[23540]=0;X(517,b|0,e+920|0,e+528|0,e+608|0);d=v[23540];v[23540]=0;L:{M:{N:{O:{P:{if((d|0)==1){break P}Q:{if(!f){d=0;break Q}v[23540]=0;f=S(272,$|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break P}d=c;if((f|0)==255){break d}}o=zj(v[$>>2],d&255);E=Yf(e+448|0);Lc(o);I=K&255;if(I>>>0>1){break N}i=0;f=Ib(x[e+610>>1]);if(f>>>0>256|x[a+480188>>1]>16){break L}d=e+192|0;ES(d,e+608|0);v[23540]=0;U(518,o|0,d|0,f|0);d=v[23540];v[23540]=0;if((d|0)==1){break O}fa=e,ga=Fb(v[o>>2]),v[fa+192>>2]=ga;d=Fb(v[o+4>>2]);while(1){f=v[e+192>>2];if(Pb(f,d)){u[f>>1]=x[f>>1]+J;Se(e+192|0);continue}else{oh(a,1);f=x[a+480188>>1];d=0;while(1)if((d|0)==(f|0)){d=32;break M}else{t[e+192|0]=w[(d+e|0)+874|0];t[e+120|0]=64;fa=((d<<5)+a|0)+480286|0,ga=w[Yb(e+192|0,e+120|0)|0],u[fa>>1]=ga;d=d+1|0;continue}}}}i=P()|0;O()|0;break f}i=P()|0;O()|0;break w}ES(e+192|0,e+608|0);R:{S:{T:{U:{d=Ib(x[e+204>>1]);if(!(!d|d>>>0>64|x[a+480188>>1]>64)){l=bc(v[e+212>>2]);d=Ib(x[e+216>>1]);if(d){u[e+120>>1]=d;u[e+80>>1]=800;f=Ec(((x[Wc(e+120|0,e+80|0)>>1]<<5)+50>>>0)/100|0,0)}else{f=32}d=v[e+200>>2];v[23540]=0;g=Q(155,b|0,bc(d)|0)|0;d=v[23540];v[23540]=0;V:{if((d|0)==1){break V}d=0;W:{if(!g){break W}while(1){if(x[a+480188>>1]<=d>>>0){break W}v[23540]=0;h=S(206,b|0)|0;g=v[23540];v[23540]=0;if((g|0)!=1){t[e+120|0]=h;t[e+80|0]=64;fa=((d<<5)+a|0)+480286|0,ga=w[Yb(e+120|0,e+80|0)|0],u[fa>>1]=ga;d=d+1|0;continue}break}i=P()|0;O()|0;break w}X:{Y:{d=bc(v[e+208>>2]);if(!d){break Y}v[23540]=0;g=Q(155,b|0,d|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break V}d=0;if(!g){break Y}while(1){if(x[a+480188>>1]<=d>>>0){break X}v[23540]=0;h=S(519,b|0)|0;g=v[23540];v[23540]=0;if((g|0)!=1){fa=((d<<5)+a|0)+480284|0,ga=(Zb(h,-16,16)<<3)+128|0,u[fa>>1]=ga;d=d+1|0;continue}break}i=P()|0;O()|0;break w}oh(a,1)}p=Tb(e+176|0);d=v[e+196>>2];v[23540]=0;g=Q(155,b|0,bc(d)|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break U}i=1;d=0;if(!g){break R}k=x[e+610>>1];h=v[b+8>>2];g=v[b>>2];v[23540]=0;h=W(156,g|0,h|0,Ib(k)<<1)|0;g=v[23540];v[23540]=0;if((g|0)==1){break U}if(!h){break R}g=x[e+610>>1];v[23540]=0;h=W(520,b|0,p|0,Ib(g)|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break U}if(!h){break R}fa=e,ga=Fb(v[p>>2]),v[fa+168>>2]=ga;m=Fb(v[e+180>>2]);while(1){d=v[e+168>>2];if(!Pb(d,m)){i=0;d=1;break R}g=Ib(w[d|0]|w[d+1|0]<<8);Z:{if(Ib(x[e+206>>1])>>>0<g>>>0){break Z}d=v[e+192>>2];v[23540]=0;Q(155,b|0,bc(d)+(g<<2)|0)|0;d=v[23540];v[23540]=0;_:{$:{aa:{ba:{ca:{if((d|0)==1){break ca}v[23540]=0;g=S(279,b|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break ca}v[23540]=0;g=Q(155,b|0,g|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break ca}if(!g){break Z}g=v[b+8>>2];d=v[b>>2];v[23540]=0;g=W(156,d|0,g|0,42)|0;d=v[23540];v[23540]=0;if((d|0)==1){break ca}if(!g){break Z}v[23540]=0;R(521,b|0,e+120|0);d=v[23540];v[23540]=0;da:{if((d|0)!=1){if(pc(v[o>>2],v[o+4>>2])){break da}v[23540]=0;R(522,o|0,65534);d=v[23540];v[23540]=0;if((d|0)!=1){break da}}i=P()|0;O()|0;break S}h=Ib(x[e+160>>1]);v[e+116>>2]=h;g=v[b+8>>2];d=v[b>>2];v[23540]=0;g=W(156,d|0,g|0,h|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break ba}if(!g){v[23540]=0;g=S(202,b|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break ba}xc(e+116|0,g)}xc(e+116|0,65534);h=v[o+4>>2];g=v[o>>2];d=0;v[23540]=0;n=v[e+116>>2];k=Rc(g,h);R(523,o|0,n+k|0);g=v[23540];v[23540]=0;if((g|0)==1){break $}while(1){ea:{if((d|0)==(n|0)){if(w[e+120|0]){break ea}break aa}v[23540]=0;h=S(271,b|0)|0;g=v[23540];v[23540]=0;fa:{if((g|0)!=1){g=h<<16>>16;if((g|0)<0){break fa}v[23540]=0;R(522,o|0,g+J&65535);g=v[23540];v[23540]=0;if((g|0)!=1){break fa}}i=P()|0;O()|0;break S}d=d+1|0;continue}break}Wm(e+104|0,e+120|0);v[23540]=0;U(524,e+56|0,v[e+104>>2],v[e+108>>2]);d=v[23540];v[23540]=0;ga:{ha:{ia:{if((d|0)!=1){v[23540]=0;U(11,e+80|0,14,e+56|0);d=v[23540];v[23540]=0;if((d|0)==1){break ia}v[23540]=0;R(273,o|0,e+80|0);d=v[23540];v[23540]=0;if((d|0)==1){break ha}Ab(e+80|0);zb(e+56|0);break aa}i=P()|0;O()|0;break S}i=P()|0;O()|0;break ga}i=P()|0;O()|0;Ab(e+80|0)}zb(e+56|0);break S}i=P()|0;O()|0;break S}i=P()|0;O()|0;break S}d=bc(v[e+152>>2]);if(!d){break Z}v[23540]=0;g=Q(155,b|0,d|0)|0;d=v[23540];v[23540]=0;if((d|0)!=1){break _}}i=P()|0;O()|0;break S}if(!g){break Z}while(1){ja:{v[23540]=0;g=Q(525,b|0,e+104|0)|0;d=v[23540];v[23540]=0;ka:{la:{ma:{if((d|0)!=1){if(!g){break Z}v[23540]=0;U(190,e+56|0,b|0,w[e+107|0]);d=v[23540];v[23540]=0;if((d|0)==1){break ma}d=e+56|0;n=kc(e+80|0,d);Bb(d);d=Ib(x[e+104>>1]);g=Al(d+k|0);u[e+56>>1]=g;if((d|0)==65535){break ja}d=v[o>>2];if(Rc(d,v[o+4>>2])>>>0<=g>>>0){break ja}na:{switch(w[e+106|0]-1|0){case 1:break ka;case 0:break la;default:break na}}Bb(n);continue}i=P()|0;O()|0;break S}i=P()|0;O()|0;break S}fa=cc(d,g),ga=65535,u[fa>>1]=ga;Bb(n);continue}v[23540]=0;h=S(271,n|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break T}v[23540]=0;g=Q(526,E|0,e+56|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break T}u[g>>1]=h;fa=cc(v[o>>2],x[e+56>>1]),ga=65534,u[fa>>1]=ga;Bb(n);continue}break}Bb(n)}Se(e+168|0);continue}}i=P()|0;O()|0;break w}i=0;break L}i=P()|0;O()|0;break S}i=P()|0;O()|0;Bb(n)}od(p);break w}od(p);if(d){d=f>>>(l>>>1&1)|0;break M}$t(E);if(!i){break d}break K}g=Ib(x[e+868>>1]);h=w[e+871|0];q=h&64;f=w[e+872|0];z=f&32;N=(f&31)+1|0;fa=a,ga=BS(g,q>>>6|0,z>>>5|0,N),v[fa+480204>>2]=ga;fa=a,ga=Ed(w[e+873|0],1,32),v[fa+480196>>2]=ga;if(z){v[a+480216>>2]=N;v[a+480220>>2]=N<<2}f=w[e+890|0];if(f){t[e+192|0]=f;t[e+120|0]=64;fa=a,ga=w[Yb(e+192|0,e+120|0)|0]<<2,v[fa+480200>>2]=ga}v[a+480228>>2]=d;v[a+480232>>2]=d;v[a+480208>>2]=v[a+480208>>2]&-3|(h>>>4^-1)&2;oa:{pa:{qa:{ra:{sa:{ta:{ua:{va:{wa:{xa:{ya:{d=bc(v[e+572>>2]);if(!d){break ya}v[23540]=0;f=Q(155,b|0,d|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break xa}if(!f){break ya}d=v[e+576>>2];v[23540]=0;U(268,b|0,da|0,bc(d)|0);d=v[23540];v[23540]=0;if((d|0)==1){break xa}if(w[ba|0]<2){break ya}v[23540]=0;U(11,e+192|0,14,da|0);d=v[23540];v[23540]=0;za:{if((d|0)!=1){v[23540]=0;R(273,o|0,e+192|0);d=v[23540];v[23540]=0;if((d|0)==1){break za}Ab(e+192|0);break ya}i=P()|0;O()|0;break w}i=P()|0;O()|0;Ab(e+192|0);break w}Aa:{if(bc(v[e+544>>2])>>>0<2){break Aa}d=v[e+540>>2];v[23540]=0;f=Q(155,b|0,bc(d)|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break xa}if(!f){break Aa}d=v[e+544>>2];v[23540]=0;X(331,H|0,b|0,bc(d)-1|0,4);d=v[23540];v[23540]=0;if((d|0)==1){break xa}}d=bc(v[e+584>>2]);if(!d){break oa}v[23540]=0;f=Q(155,b|0,d|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break xa}if(!f){break oa}f=v[b+8>>2];d=v[b>>2];v[23540]=0;f=W(156,d|0,f|0,12)|0;d=v[23540];v[23540]=0;if((d|0)==1){break xa}if(!f){break oa}v[23540]=0;Q(188,b|0,6)|0;d=v[23540];v[23540]=0;if((d|0)==1){break xa}v[23540]=0;f=S(271,b|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break xa}if((f|0)!=1){break oa}v[23540]=0;g=S(279,b|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break va}if(!g){break oa}f=v[b+8>>2];d=v[b>>2];v[23540]=0;f=W(156,d|0,f|0,g|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break va}if(f){break wa}break oa}i=P()|0;O()|0;break w}k=hE(e+192|0,H);v[23540]=0;X(331,H|0,b|0,g|0,4);d=v[23540];v[23540]=0;if((d|0)==1){break qa}if(!Re(k)){v[23540]=0;f=W(527,e+24|0,2,13)|0;d=v[23540];v[23540]=0;if((d|0)==1){break ua}v[23540]=0;U(528,e+120|0,k|0,f|0);d=v[23540];v[23540]=0;if((d|0)==1){break ta}v[23540]=0;U(529,e+40|0,e+120|0,H|0);d=v[23540];v[23540]=0;if((d|0)==1){break sa}d=e+40|0;Bc(H,d);zb(d);zb(e+120|0);zb(f)}zb(k);break oa}i=P()|0;O()|0;break w}i=P()|0;O()|0;break pa}i=P()|0;O()|0;break ra}i=P()|0;O()|0;zb(e+120|0)}zb(f);break pa}i=P()|0;O()|0}zb(k);break w}Ba:{if(I>>>0<2){break Ba}i=0;if(!bc(v[e+596>>2])){break Ba}while(1){if(x[a+480188>>1]<=i>>>0){break Ba}d=v[e+596>>2];v[23540]=0;f=Q(155,b|0,bc(d)+(i<<2)|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break x}Ca:{if(!f){break Ca}v[23540]=0;f=S(279,b|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break x}v[23540]=0;f=Q(155,b|0,f|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break x}m=0;d=0;if(!f){break Ca}while(1){Da:{g=v[b+8>>2];f=v[b>>2];v[23540]=0;g=W(156,f|0,g|0,8)|0;f=v[23540];v[23540]=0;Ea:{Fa:{Ga:{if((f|0)!=1){if(!g){break Da}v[23540]=0;R(530,b|0,e+192|0);f=v[23540];v[23540]=0;if((f|0)==1){break Ga}f=bc(v[e+192>>2]);if(!f){break Da}switch((f&536870911)-1|0){case 1:break Ea;case 0:break Fa;default:continue}}i=P()|0;O()|0;break w}i=P()|0;O()|0;break w}m=bc(v[e+196>>2]);continue}d=bc(v[e+196>>2]);continue}break}if(!m|!d){break Ca}v[23540]=0;g=Q(155,b|0,m|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break y}if(!g){break Ca}v[23540]=0;U(413,b|0,((i<<5)+a|0)+480289|0,d|0);d=v[23540];v[23540]=0;if((d|0)==1){break y}}i=i+1|0;continue}}d=x[e+608>>1];v[23540]=0;s=Ib(d);R(225,G|0,J+s&65535);d=v[23540];v[23540]=0;if((d|0)==1){break z}y=h&16;r=J&65535;g=0;Ha:{Ia:{while(1){if((g|0)==(s|0)){fa=e,ga=Gi(v[E>>2]),v[fa+120>>2]=ga;g=xf(E);while(1){d=v[e+120>>2];if(!Hg(d,g)){i=1;d=bc(v[e+528>>2]);if(!d){break L}v[23540]=0;f=Q(155,b|0,d|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break z}if(!f){break L}J=s+J|0;$t(E);break K}k=so(d);h=Te(k);Ja:{Ka:{La:{Ma:{d=x[k>>1];if(!d){j=0;break Ma}v[23540]=0;f=Q(311,o|0,d-1&65535)|0;d=v[23540];v[23540]=0;if((d|0)==1){break Ja}j=x[k>>1];if(!f){break Ma}v[23540]=0;j=Q(360,o|0,j-1&65535)|0;d=v[23540];v[23540]=0;if((d|0)==1){break Ja}break La}if(x[h>>1]==((j&65535)+1|0)){break Ka}v[23540]=0;j=Q(359,G|0,1)|0;d=v[23540];v[23540]=0;if((d|0)==1){break Ja}if((j|0)==65535){break Ka}fa=cc(v[o>>2],x[k>>1]),ga=j,u[fa>>1]=ga}d=_b(v[G>>2],j);ze(d,Nm(Ue(Oe(e+192|0,12,zu(x[h>>1])),v[d+12>>2]-1|0)));s=(s&65535)>>>0>j>>>0?s:j+1|0}Kg(e+120|0);continue}break}i=P()|0;O()|0;break w}Na:{Oa:{if(!D){break Oa}d=v[e+936>>2];v[23540]=0;f=Q(155,b|0,bc(d)+(g<<2)|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break Ia}if(!f){break Oa}v[23540]=0;f=S(279,b|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break Ia}v[23540]=0;f=Q(155,b|0,f|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break Ia}if(!f){break Oa}V=Nb(e+56|0);v[23540]=0;Y=S(174,e|0)|0;d=v[23540];v[23540]=0;Pa:{Qa:{if((d|0)!=1){if(I){break Qa}v[23540]=0;R(531,b|0,e+192|0);d=v[23540];v[23540]=0;if((d|0)==1){break Na}u[e+104>>1]=w[e+192|0];Z=w[e+193|0]+1|0;f=48;break Pa}i=P()|0;O()|0;break A}v[23540]=0;n=t[e+870|0];R(532,b|0,e+176|0);d=v[23540];v[23540]=0;Ra:{Sa:{if((d|0)!=1){k=Ib(x[e+176>>1]);u[e+104>>1]=k;Z=Ib(x[e+178>>1])+1|0;d=bc(v[e+180>>2]);if(!d){break Ra}h=v[b+8>>2];v[23540]=0;Q(155,b|0,d|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break B}v[23540]=0;R(533,b|0,e+192|0);d=v[23540];v[23540]=0;if((d|0)==1){break B}d=v[e+196>>2];v[23540]=0;f=Q(155,b|0,bc(d)|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break B}if(!f){break Sa}d=v[e+200>>2];v[23540]=0;U(268,b|0,V|0,bc(d)|0);d=v[23540];v[23540]=0;if((d|0)!=1){break Sa}break B}break B}d=bc(v[e+208>>2]);Ta:{if(!d){break Ta}v[23540]=0;f=Q(155,b|0,d|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break B}if(!f){break Ta}v[23540]=0;f=S(279,b|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break B}v[23540]=0;f=Q(155,b|0,f|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break B}if(!f){break Ta}v[23540]=0;U(190,e+80|0,b|0,B(k,Z)|0);d=v[23540];v[23540]=0;if((d|0)==1){break B}f=e+80|0;d=kc(e+120|0,f);hd(Y,d);Bb(d);Bb(f)}v[23540]=0;Q(155,b|0,h|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break B}}f=n+(I>>>0<3?48:24)|0}v[23540]=0;k=g+r|0;h=W(226,G|0,k&65535,Z|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break B}Ua:{if(!h){break Ua}d=v[G>>2];v[23540]=0;A=_b(d,k);R(281,A|0,V|0);d=v[23540];v[23540]=0;if((d|0)==1){break Ha}Ef(e+104|0,x[a+480188>>1]);C=0;p=x[e+104>>1];Va:while(1){if((C|0)==(Z|0)){break Ua}i=0;d=jd(v[A>>2],v[v[A+48>>2]+12>>2],C,0);while(1){if((i&65535)>>>0>=p>>>0){C=C+1|0;continue Va}Wa:{if(!I){v[23540]=0;R(534,e+192|0,b|0);h=v[23540];v[23540]=0;if((h|0)!=1){m=w[e+192|0];n=e+192|0;h=Oc(n);t[d+1|0]=m>>>3&16|w[h|0]>>>4|m>>>1&32;k=w[h|0];fa=d,ga=w[Te(n)|0],t[fa+5|0]=ga;h=m&63;j=h?h+f|0:0;m=k&15;break Wa}break B}v[23540]=0;R(349,e+192|0,b|0);h=v[23540];v[23540]=0;Xa:{Ya:{if((h|0)!=1){h=e+192|0;l=Oc(h);m=Te(h);n=Li(h);v[23540]=0;k=S(206,Y|0)|0;h=v[23540];v[23540]=0;if((h|0)==1){break B}t[d+4|0]=k;k=w[e+192|0];h=k&127;if(!h){break Ya}j=f+h|0;break Xa}break B}j=0;if((k|0)!=128){break Xa}t[d|0]=254}t[d+1|0]=w[l|0]&63;m=w[m|0];t[d+5|0]=w[n|0]}if(j-1>>>0<=119){t[d|0]=j}F=(j|0)>84&ca|F;n=(q|0)!=0;k=(z|0)!=0;h=(y|0)!=0;l=kb-16|0;kb=l;t[d+3|0]=0;Za:{_a:{$a:{ab:{bb:{cb:{db:{eb:{fb:{gb:{hb:{ib:{jb:{kb:{lb:{mb:{nb:{ob:{pb:{qb:{rb:{sb:{tb:{ub:{m=m&255;switch(m-4|0){case 4:case 10:break Za;case 42:break $a;case 37:break ab;case 28:break bb;case 27:break cb;case 26:break db;case 25:break eb;case 24:break fb;case 23:break gb;case 22:break hb;case 21:break ib;case 20:break jb;case 18:break kb;case 17:break lb;case 16:break mb;case 14:break nb;case 13:break ob;case 12:break pb;case 11:break qb;case 9:break rb;case 8:break sb;case 5:break tb;case 0:break ub;default:break _a}}t[d+3|0]=5;k=w[d+5|0];t[l+15|0]=k>>>3;t[l+14|0]=15;h=w[Yb(l+15|0,l+14|0)|0];t[l+13|0]=k<<1&30;t[l+12|0]=15;fa=d,ga=w[Yb(l+13|0,l+12|0)|0]|h<<4,t[fa+5|0]=ga;break Za}if((w[d+5|0]-1&255)>>>0>19){break Za}t[d+3|0]=16;break Za}t[d+3|0]=13;k=w[d+5|0];vb:{if(!h){if(k>>>0>152){break vb}t[d+5|0]=B((k&240)>>>4|0,10)+(k&15);break Za}t[d+5|0]=(k&127)+1>>>1;break Za}t[d+3|0]=0;break Za}t[d+3|0]=11;break Za}h=w[d+5|0];if(!h){t[d+3|0]=14;break Za}if(h>>>0>240){break Za}t[d+3|0]=17;if(h>>>0<=2){t[d+5|0]=112;break Za}fa=d,ga=tk(+(BS(h,n,k,N)>>>0)/1e4),t[fa+5|0]=ga;break Za}t[d+3|0]=31;t[d+5|0]=w[d+5|0]|128;break Za}t[d+3|0]=19;t[l+11|0]=15;fa=d,ga=w[Yb(d+5|0,l+11|0)|0]|16,t[fa+5|0]=ga;break Za}t[d+3|0]=19;t[l+10|0]=15;fa=d,ga=w[Yb(d+5|0,l+10|0)|0]|32,t[fa+5|0]=ga;break Za}t[d+3|0]=5;h=w[d+5|0];t[l+9|0]=(h>>>4|0)+1;t[l+8|0]=15;fa=d,ga=h&15|w[Yb(l+9|0,l+8|0)|0]<<4,t[fa+5|0]=ga;break Za}t[d+3|0]=19;t[d+5|0]=w[d+5|0]&15|80;break Za}t[d+3|0]=19;t[l+7|0]=15;fa=d,ga=w[Yb(d+5|0,l+7|0)|0]|96,t[fa+5|0]=ga;break Za}t[d+3|0]=19;t[l+6|0]=15;fa=d,ga=w[Yb(d+5|0,l+6|0)|0]|192,t[fa+5|0]=ga;break Za}t[d+3|0]=10;break Za}t[d+3|0]=19;t[l+5|0]=15;fa=d,ga=w[Yb(d+5|0,l+5|0)|0]|160,t[fa+5|0]=ga;break Za}t[d+3|0]=19;t[l+4|0]=15;fa=d,ga=w[Yb(d+5|0,l+4|0)|0]|176,t[fa+5|0]=ga;break Za}h=(w[d+5|0]<<24)-16777216>>24;if((h|0)<0){break Za}t[d+5|0]=h;t[d+3|0]=31;break Za}t[d+3|0]=14;break Za}t[d+3|0]=19;t[l+3|0]=15;fa=d,ga=w[Yb(d+5|0,l+3|0)|0]|224,t[fa+5|0]=ga;break Za}h=w[d+5|0];if(h&240){t[d+3|0]=19;t[d+5|0]=h>>>4|208;break Za}if(!(h&15)){break Za}t[d+3|0]=19;t[d+5|0]=h|144;break Za}if(w[d+5|0]|w[d+4|0]){break Za}if(!$c(w[d|0])){break Za}t[d+5|0]=159;t[d+3|0]=20;break Za}h=w[d+4|0];if(!h){break Za}t[d+3|0]=44;fa=d,ga=Jl(Ec(((w[d+5|0]<<8&65280)>>>0)/(h>>>0)|0,0)),t[fa+5|0]=ga;break Za}h=w[d+5|0];if((h+16&255)>>>0>32){break Za}t[d+3|0]=9;fa=d,ga=tg(((h^128)<<3)-896|0),t[fa+5|0]=ga;break Za}if(m>>>0>15){break Za}Pf(d,m,w[d+5|0])}kb=l+16|0;d=d+6|0;i=i+1|0;continue}}}Bb(Y);zb(V)}g=g+1|0;continue}break}break B}i=P()|0;O()|0;break w}break B}$t(E);d=0;if(!i){break c}}Gj($,0);d=1;wb:{if(F&1){break wb}while(1){b=d&65535;if(b>>>0>x[a+480192>>1]){u[a+480192>>1]=0;break wb}c=((b<<2)+a|0)+900380|0;b=v[c>>2];if(b){Mb(bu(b))}v[c>>2]=0;d=d+1|0;continue}}xb:{if(!ea){break xb}v[23540]=0;c=Q(1,e+192|0,16404)|0;b=v[23540];v[23540]=0;yb:{if((b|0)!=1){b=v[a+1298464>>2];v[23540]=0;U(376,b|0,2,c|0);b=v[23540];v[23540]=0;if((b|0)==1){break yb}Ab(c);break xb}i=P()|0;O()|0;break f}i=P()|0;O()|0;Ab(c);break f}j=21688;zb:{Ab:{switch(aa-48|0){case 0:j=x[a+480188>>1]>4?17299:17285;break zb;case 1:j=17267;break zb;case 2:j=17249;break zb;case 3:break Ab;default:break zb}}j=17222}v[23540]=0;R(535,e+80|0,16837);b=v[23540];v[23540]=0;Bb:{Cb:{Db:{if((b|0)!=1){v[23540]=0;U(536,e+120|0,e+80|0,e+919|0);b=v[23540];v[23540]=0;if((b|0)==1){break Db}b=e+120|0;Jb(a+1298344|0,b);Ab(b);dc(e+80|0);v[23540]=0;c=Q(1,b|0,12627)|0;b=v[23540];v[23540]=0;if((b|0)==1){break Cb}Jb(a+1298356|0,c);Ab(c);v[23540]=0;R(136,a+1298368|0,j|0);b=v[23540];v[23540]=0;if((b|0)==1){break Bb}v[a+1298404>>2]=14;d=1;break c}i=P()|0;O()|0;break f}i=P()|0;O()|0;dc(e+80|0);break f}i=P()|0;O()|0;break f}i=P()|0;O()|0;break f}c=c+1|0;continue}}i=P()|0;O()|0;break f}i=P()|0;O()|0;Bb(Y)}zb(V);break w}i=P()|0;O()|0;break w}i=P()|0;O()|0;break w}i=P()|0;O()|0}$t(E);break f}i=P()|0;O()|0;break f}i=P()|0;O()|0;break f}i=P()|0;O()|0;break f}A=1;if((d|0)!=7){break m}d=z+108|0;f=gA(d);while(1){if((d|0)!=(f|0)){fa=d,ga=Mm(w[d|0]-24|0),t[fa|0]=ga;d=d+1|0;continue}break}g=0}F=1;break l}g=0;Eb:{if(r|(q|0)<0){break Eb}n=z+108|0;j=7;Fb:while(1){if((j|0)==10){break Eb}k=B(j,12);h=B(j,-12)+72|0;d=0;while(1)if((d|0)==12){j=j+1|0;continue Fb}else{f=Lb(n,d+k|0);t[f|0]=h+w[f|0];d=d+1|0;continue}}}}v[23540]=0;R(537,_|0,e+192|0);d=v[23540];v[23540]=0;if((d|0)!=1){Gb:{d=w[e+196|0];if((d-1&255)>>>0<=15){t[z+31|0]=d;F=1}d=w[e+197|0];if((d<<24)-16777216>>24>=0){t[z+30|0]=d}d=0;Hb:{while(1){if((d|0)==(A|0)){if(!p){break j}if((q|0)>=0){break Hb}break j}v[23540]=0;h=B(d+y|0,104)+a|0;R(277,h+484380|0,8);f=v[23540];v[23540]=0;if((f|0)!=1){t[e+120|0]=w[e+198|0];t[e+56|0]=64;fa=h+484410|0,ga=w[Yb(e+120|0,e+56|0)|0]<<2,u[fa>>1]=ga;t[h+484416|0]=w[e+199|0];d=d+1|0;continue}break}break k}k=Zc(e+120|0,8,1,1,0);h=Ib(x[e+194>>1]);i=Ib(x[e+192>>1]);d=v[D>>2];v[23540]=0;j=S(160,d|0)|0;d=v[23540];v[23540]=0;if((d|0)!=1){d=pe(u[e+84>>1]);if(d&16){xd(k,16);j=j>>>1|0}if(d&32){Mo(k,3);j=j>>>1|0}if(d&64){dg(k,2)}j=g?(j>>>0)/((-1<<A^-1)>>>0)|0:j;m=h+i|0;d=0;while(1){if((d|0)==(A|0)){break j}g=B(d+y|0,104)+a|0;f=g+484380|0;v[f>>2]=j;v[23540]=0;W(219,k|0,f|0,D|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break Gb}i=i<<1;m=m<<1;if(h>>>0>=2){v[g+484388>>2]=m;v[g+484384>>2]=i;f=g+484414|0;u[f>>1]=x[f>>1]|2}d=d+1|0;j=j<<1;continue}}}}}i=P()|0;O()|0;Bb(D);break f}Bb(D);C=C+1|0;s=s+A|0;j=x[a+480192>>1];continue}}i=P()|0;O()|0;break e}i=P()|0;O()|0;break e}i=P()|0;O()|0}wc(M)}Bb(_);T(i|0);L()}d=0}wc(M)}Bb(_)}kb=e+976|0;return d|0}function afa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=C(0),k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,A=0,D=C(0),E=0,F=0,G=0,H=0,I=0,J=0,K=0,M=0,N=0,V=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=C(0),ga=0,ha=0,ia=0,ka=0,la=0,ma=0;e=kb-672|0;kb=e;zc(b);a:{b:{c:{if(!ei(b,e+664|0)){break c}if(!AQ(e+664|0)){break c}if((Do(b)|0)>=0){break c}if(!c){d=1;break c}Cd(a,16777216);d=a+480208|0;v[d>>2]=v[d>>2]|1681e4;yq(e+272|0,32);h=v[e+284>>2];d=a+1074320|0;v[d>>2]=v[e+280>>2];v[d+4>>2]=h;d=v[e+276>>2];v[a+1074312>>2]=v[e+272>>2];v[a+1074316>>2]=d;_f(a+1074312|0,38);p=Tb(e+648|0);q=Tb(e+632|0);A=Tb(e+616|0);l=Tb(e+600|0);yg(b,4);i=a+480190|0;J=c&1;I=a+1298332|0;r=2500;H=!(c&2);F=a+1298464|0;d:{e:{f:{while(1){c=v[b+8>>2];d=v[b>>2];v[23540]=0;c=W(156,d|0,c|0,4)|0;d=v[23540];v[23540]=0;g:{h:{i:{j:{k:{l:{m:{if((d|0)!=1){n:{if(c){v[23540]=0;c=S(682,b|0)|0;d=v[23540];v[23540]=0;o:{if((d|0)==1){break o}n=4;d=0;p:{q:{r:{switch(c+21|0){case 20:v[23540]=0;c=S(279,b|0)|0;d=v[23540];v[23540]=0;if((d|0)!=1){d=c&65535;if(x[a+480188>>1]|d-1>>>0>126){continue}u[a+480188>>1]=c;la=a,ma=Zb(512/(d>>>0)|0,16,128),v[la+480228>>2]=ma;continue}c=P()|0;O()|0;break a;case 19:v[23540]=0;M=S(279,b|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break o}if(M>>>0<=1024){continue}break m;case 16:v[23540]=0;c=S(279,b|0)|0;h=v[23540];v[23540]=0;if((h|0)!=1){if((c&65535)==4){continue}break m}c=P()|0;O()|0;break a;case 15:v[23540]=0;c=S(279,b|0)|0;d=v[23540];v[23540]=0;if((d|0)!=1){v[e+272>>2]=c;v[e+168>>2]=800;la=a,ma=Qe(+y[Kb(e+272|0,e+168|0)>>2]*1.24*1e4),v[la+480204>>2]=ma;continue}c=P()|0;O()|0;break a;case 31:v[23540]=0;c=S(279,b|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break o}_=1;r=Ed(c,0,1e4);continue;case 32:case 33:v[23540]=0;c=S(279,b|0)|0;d=v[23540];v[23540]=0;s:{t:{if((d|0)!=1){_=1;if(!c){continue}v[23540]=0;d=Q(1,e+584|0,12536)|0;c=v[23540];v[23540]=0;if((c|0)==1){break t}c=v[F>>2];v[23540]=0;U(376,c|0,2,d|0);c=v[23540];v[23540]=0;if((c|0)==1){break s}Ab(d);continue}c=P()|0;O()|0;break a}c=P()|0;O()|0;break a}c=P()|0;O()|0;Ab(d);break a;case 14:v[23540]=0;Q(188,b|0,4)|0;c=v[23540];v[23540]=0;if((c|0)==1){break o}g=!x[i>>1]|g;continue;case 11:if(!J){break q}if(!pc(v[p>>2],v[p+4>>2])){break q}v[23540]=0;R(683,e+272|0,b|0);c=v[23540];v[23540]=0;if((c|0)!=1){if(v[p>>2]){Lc(p);c=v[p>>2];mo(p);Mb(c);la=Gb(p),ma=0,v[la>>2]=ma;v[p>>2]=0;v[p+4>>2]=0}c=e+272|0;v[p>>2]=v[c>>2];v[p+4>>2]=v[c+4>>2];d=Gb(c);la=Gb(p),ma=v[d>>2],v[la>>2]=ma;v[d>>2]=0;v[c>>2]=0;v[c+4>>2]=0;Ei(c);continue}c=P()|0;O()|0;break a;case 3:case 4:case 10:h=zh(v[l>>2],v[l+4>>2]);d=x[i>>1];if(h>>>0<=d>>>0){continue}if((g|H)&1){break q}if(!Zh(d)){break q}d=d+1|0;u[i>>1]=d;s=Tb(e+568|0);v[23540]=0;n=S(174,e+544|0)|0;g=v[23540];v[23540]=0;u:{v:{w:{if((g|0)!=1){if((c|0)==-17){break w}if((c|0)!=-11){break v}v[23540]=0;c=S(279,b|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break u}v[23540]=0;U(190,e+168|0,b|0,c|0);c=v[23540];v[23540]=0;if((c|0)==1){break u}c=e+168|0;g=kc(e+272|0,c);hd(n,g);Bb(g);break g}c=P()|0;O()|0;break d}v[23540]=0;R(684,e+272|0,b|0);c=v[23540];v[23540]=0;x:{if((c|0)!=1){c=e+272|0;g=Lm(s,c);ic(c);re(e+512|0,v[g>>2],v[e+572>>2]);c=v[ee(e+504|0)>>2];v[23540]=0;c=Eg(328,e+520|0,v[e+512>>2],v[e+516>>2],c,v[e+508>>2]);g=v[23540];v[23540]=0;if((g|0)==1){break x}hd(n,c);break g}c=P()|0;O()|0;break e}c=P()|0;O()|0;break e}v[23540]=0;R(685,e+272|0,b|0);c=v[23540];v[23540]=0;y:{if((c|0)!=1){c=e+272|0;g=Lm(s,c);ic(c);re(e+472|0,v[g>>2],v[e+572>>2]);c=v[ee(e+464|0)>>2];v[23540]=0;c=Eg(328,e+480|0,v[e+472>>2],v[e+476>>2],c,v[e+468>>2]);g=v[23540];v[23540]=0;if((g|0)==1){break y}hd(n,c);break g}c=P()|0;O()|0;break e}c=P()|0;O()|0;break e}c=P()|0;O()|0;break e;case 9:c=x[i>>1];if(!Zh(c)){continue}u[i>>1]=c+1;continue;case 8:if(!J){break q}if(!pc(v[A>>2],v[A+4>>2])){break q}v[23540]=0;R(686,e+272|0,b|0);c=v[23540];v[23540]=0;if((c|0)!=1){c=e+272|0;zQ(A,c);wc(c);continue}c=P()|0;O()|0;break a;case 7:if(!pc(v[l>>2],v[l+4>>2])){break q}v[23540]=0;R(687,e+272|0,b|0);c=v[23540];v[23540]=0;if((c|0)!=1){if(v[l>>2]){Lc(l);c=v[l>>2];Uz(l);Mb(c);la=Gb(l),ma=0,v[la>>2]=ma;v[l>>2]=0;v[l+4>>2]=0}c=e+272|0;v[l>>2]=v[c>>2];v[l+4>>2]=v[c+4>>2];d=Gb(c);la=Gb(l),ma=v[d>>2],v[la>>2]=ma;v[d>>2]=0;v[c>>2]=0;v[c+4>>2]=0;Nt(c);continue}c=P()|0;O()|0;break a;case 6:if(!J){break q}if(!pc(v[q>>2],v[q+4>>2])){break q}v[23540]=0;R(688,e+272|0,b|0);c=v[23540];v[23540]=0;if((c|0)!=1){if(v[q>>2]){Lc(q);c=v[q>>2];Lt(q);Mb(c);la=Gb(q),ma=0,v[la>>2]=ma;v[q>>2]=0;v[q+4>>2]=0}c=e+272|0;v[q>>2]=v[c>>2];v[q+4>>2]=v[c+4>>2];d=Gb(c);la=Gb(q),ma=v[d>>2],v[la>>2]=ma;v[d>>2]=0;v[c>>2]=0;v[c+4>>2]=0;Bm(c);continue}c=P()|0;O()|0;break a;case 17:case 18:break p;case 0:case 1:case 2:break q;case 5:break r;default:break m}}v[23540]=0;R(689,e+272|0,b|0);c=v[23540];v[23540]=0;if((c|0)==1){break n}z:{c=v[e+272>>2];d=v[e+276>>2];if(pc(c,d)){break z}v[23540]=0;X(337,I|0,c|0,fd(c,d)|0,1);c=v[23540];v[23540]=0;if((c|0)!=1){break z}c=P()|0;O()|0;ic(e+272|0);break a}ic(e+272|0);continue}v[23540]=0;n=S(279,b|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break o}}v[23540]=0;Q(188,b|0,n|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){continue}}c=P()|0;O()|0;break a}d=0;if(!x[a+480188>>1]|!M){break m}b=v[l>>2];c=v[l+4>>2];if(pc(b,c)){break m}if(J){if(pc(v[p>>2],v[p+4>>2])){break m}if(pc(v[A>>2],v[A+4>>2])){break m}if(pc(v[q>>2],v[q+4>>2])){break m}}b=zh(b,c);if(b>>>0>=256){v[23540]=0;R(690,l|0,255);b=v[23540];v[23540]=0;if((b|0)==1){break b}b=zh(v[l>>2],v[l+4>>2])}u[a+480192>>1]=b;m=a+480190|0;n=a+480192|0;la=m,ma=x[ke(i,n)>>1],u[la>>1]=ma;if(g&1){v[23540]=0;b=Q(1,e+568|0,16493)|0;c=v[23540];v[23540]=0;if((c|0)==1){break h}c=v[a+1298464>>2];v[23540]=0;U(376,c|0,2,b|0);c=v[23540];v[23540]=0;if((c|0)==1){break i}Ab(b)}g=0;A:while(1){if((g|0)!=2){d=1;while(1){f=d&65535;if(f>>>0>x[n>>1]){g=g+1|0;continue A}B:{h=zm(v[l>>2],f-1|0);if(!w[h|0]|t[h+128|0]<0){break B}if((Jt(h)|0)==((g|0)!=1|0)){break B}C:{D:{E:{c=0;F:{if(!Jt(h)){break F}if(Ib(w[h+6|0]|w[h+7|0]<<8)){break F}if(Ib(w[h+14|0]|w[h+15|0]<<8)>>>0>20){break F}c=(Ib(w[h+18|0]|w[h+19|0]<<8)|0)==4}G:{H:{if(c){c=w[h+23|0];b=w[h+140|0];v[23540]=0;b=ja(691,h|0,a|0,(b&2)>>>1|0,(B(f,104)+a|0)+484380|0,r&65535)|0;k=v[23540];v[23540]=0;I:{J:{if((k|0)!=1){if(!b){break I}v[23540]=0;b=Q(55,e+400|0,10745)|0;k=v[23540];v[23540]=0;if((k|0)==1){break J}Dc(((f<<5)+a|0)+946304|0,b);zb(b);k=v[l>>2];b=d;if(zh(k,v[l+4>>2])>>>0<=c>>>0){break G}la=h,ma=w[h+143|0]+w[zm(k,c)+143|0]|0,t[la+143|0]=ma;break H}c=P()|0;O()|0;break a}c=P()|0;O()|0;break a}b=c+1|0;break G}c=0;K:{if(!Jt(h)){break K}if((Ib(w[h+6|0]|w[h+7|0]<<8)|0)!=1){break K}if((Ib(w[h+14|0]|w[h+15|0]<<8)|0)!=2){break K}c=(Ib(w[h+18|0]|w[h+19|0]<<8)|0)==10}b=d;if(!c){break G}rQ(e+272|0,h);b=Ib(x[e+292>>1]);if(b>>>0>=x[i>>1]){break H}v[23540]=0;c=S(681,e+168|0)|0;k=v[23540];v[23540]=0;if((k|0)==1){break E}k=x[e+308>>1];o=x[m>>1];v[23540]=0;s=B(b,104);b=a+484380|0;k=Ib(k);b=fa(692,e+272|0,(s+b|0)+104|0,(k>>>0<o>>>0?(b+B(k,104)|0)+104|0:c)|0,b+B(f,104)|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break D}if(!b){break H}v[23540]=0;b=Q(55,e+152|0,11242)|0;c=v[23540];v[23540]=0;if((c|0)==1){break C}Dc(((f<<5)+a|0)+946304|0,b);zb(b);t[h+139|0]=w[h+139|0]+12}b=d}v[23540]=0;b=b&65535;c=W(251,a|0,f|0,b|0)|0;f=v[23540];v[23540]=0;if((f|0)!=1){if(!c|b>>>0>x[i>>1]){break B}v[23540]=0;X(693,h|0,c|0,(B(b,104)+a|0)+484380|0,a|0);b=v[23540];v[23540]=0;if((b|0)!=1){break B}}c=P()|0;O()|0;break a}c=P()|0;O()|0;break a}c=P()|0;O()|0;break a}c=P()|0;O()|0;break a}d=d+1|0;continue}}break}I=Yf(e+136|0);s=Yf(e+120|0);b=uc(v[A>>2],v[A+4>>2]);$=B(x[a+480188>>1],M);aa=Al((b>>>0)/($>>>0)|0);v[23540]=0;V=a+484344|0;R(225,V|0,aa|0);b=v[23540];v[23540]=0;if((b|0)==1){break k}ba=a+484376|0;Lc(Wb(v[a+484360>>2],w[ba|0]));b=x[a+480188>>1];v[23540]=0;F=Q(694,e+104|0,b|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break l}la=e,ma=Fb(v[q>>2]),v[la+48>>2]=ma;ga=a+902204|0;ha=Fb(v[q+4>>2]);ia=a+480208|0;while(1){L:{M:{N:{k=v[e+48>>2];if(!Pb(k,ha)){break N}b=pe((w[k+6|0]|w[k+7|0]<<8)<<16>>16);if((b|0)==1){break L}if((b&65535)==65535){break N}g=Ib(w[k|0]|w[k+1|0]<<8);b=v[p>>2];h=v[p+4>>2];c=rg(b,h);if(g>>>0>=c>>>0){break L}d=Ib(w[k+2|0]|w[k+3|0]<<8);if(d>>>0>c>>>0|!d|g>>>0>c-d>>>0){break L}c=b+(rg(b,h)<<5)|0;v[e+272>>2]=b;v[e+276>>2]=c-b>>5;b=v[e+272>>2];hc(e+80|0,b+(Ib(w[k|0]|w[k+1|0]<<8)<<5)|0,Ib(w[k+2|0]|w[k+3|0]<<8));O:{H=Wb(v[a+484360>>2],w[ba|0]);if(pc(v[H>>2],v[H+4>>2])){break O}v[23540]=0;R(522,H|0,65534);b=v[23540];v[23540]=0;if((b|0)!=1){break O}break M}b=v[e+80>>2];ka=ye(b,v[e+84>>2]);while(1){if((b|0)==(ka|0)){break L}c=pe(pe((w[k+8|0]|w[k+9|0]<<8)<<16>>16)+pe((w[b+16|0]|w[b+17|0]<<8)<<16>>16)<<16>>16);t[b+16|0]=c;t[b+17|0]=c>>>8;h=b;b=Td(I);while(1){P:{c=0;if(!b){break P}d=b+14|0;if(!Ft(h,d)){c=1;if(!Ft(d,h)){break P}b=b+4|0}b=v[b>>2];continue}break}Q:{R:{S:{if(c){v[23540]=0;b=Q(695,I|0,h|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break M}E=x[b>>1];break S}E=0;if(!J){break S}b=w[h+12|0]|w[h+13|0]<<8;v[23540]=0;E=Q(359,V|0,Ib(b)|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break M}if((E|0)==65535){break L}v[23540]=0;b=Q(695,I|0,h|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break M}u[b>>1]=E;if(Ib(w[h+8|0]|w[h+9|0]<<8)>>>0>=aa>>>0){break R}if(Ib(w[h+10|0]|w[h+11|0]<<8)>>>0>=M>>>0){break R}m=Ib(w[h+14|0]|w[h+15|0]<<8);c=ym(Fb(v[A>>2]),B(Ib(w[h+8|0]|w[h+9|0]<<8),$));b=x[a+480188>>1];la=e,ma=ym(c,B(b,Ib(w[h+10|0]|w[h+11|0]<<8))),v[la+32>>2]=ma;N=0;v[e+16>>2]=0;o=ug(e- -64|0);T:while(1){U:{d=Ib(w[h+12|0]|w[h+13|0]<<8);c=_b(v[V>>2],E);if(d>>>0<=N>>>0){break U}n=0;Z=jd(v[c>>2],v[v[c+48>>2]+12>>2],N,0);c=0;while(1){if((b&65535)>>>0<=n>>>0){N=N+1|0;continue T}b=Fb(v[A+4>>2]);d=v[e+32>>2];i=Pb(d,b)?d:e+16|0;b=Fb(v[A+4>>2]);if(Pb(v[e+32>>2],b)){xQ(e+32|0)}d=B(n,6)+Z|0;g=w[i+1|0];b=(g>>>0<85?g+25|0:-1)<<24>>24;r=0;f=v[l>>2];K=zh(f,v[l+4>>2]);G=w[i+3|0];V:{if(K>>>0<=G>>>0){break V}r=G+1|0;if(t[zm(f,G)+142|0]&1|(b|0)<0){break V}b=pe((w[h+16|0]|w[h+17|0]<<8)<<16>>16)+b<<24>>24;b=(b|0)<120?b:120;b=((b|0)>1?b:1)&255}W:{if(!w[d|0]|!(w[i+2|0]?1:G|(w[i|0]|(g|0)!=255))){break W}g=w[d+1|0];if(!g|g>>>0>K>>>0){break W}if(w[zm(f,g-1|0)+132|0]!=2){break W}ko(d)}f=Mt(v[F>>2],n);X:{Y:{if(!(c&1)){g=w[i|0];break Y}c=w[o|0]|w[o+1|0]<<8|(w[o+2|0]<<16|w[o+3|0]<<24);t[d|0]=c;t[d+1|0]=c>>>8;t[d+2|0]=c>>>16;t[d+3|0]=c>>>24;c=w[o+4|0]|w[o+5|0]<<8;t[d+4|0]=c;t[d+5|0]=c>>>8;Z:{if(w[d+3|0]){break Z}g=w[f+21|0];c=w[Mt(v[F>>2],n-1|0)+21|0];if((g|0)==(c|0)){break Z}t[d+3|0]=21;t[f+21|0]=c;t[d+5|0]=c}c=0;g=w[i|0];if(!(g-24>>>0<2|(g|0)==9|!g&(w[i+2|0]+7&255)>>>0<2)){break X}}_:{$:{aa:{ba:{ca:{da:{switch(g|0){case 5:c=w[f+17|0];break ca;case 0:ea:{c=w[i+2|0];if(c>>>0>=201){g=0;fa:{switch(c-242|0){case 11:t[d+4|0]=1;t[d+2|0]=14;t[f+16|0]=0;break $;case 9:if(!w[d|0]){t[d|0]=w[f+17|0]}t[d+4|0]=1;t[d+2|0]=15;break $;case 8:if((m&255)>>>0<2){break $}m=m-1|0;break aa;case 7:if((m&255)==255){m=255;break $}m=m+1|0;break aa;case 6:t[f+17|0]=b;if(w[f+18|0]!=(r&255)){break $}t[d|0]=b;t[d+5|0]=255;t[d+3|0]=4;u[f+32>>1]=0;v[f+8>>2]=0;break $;case 5:t[d+5|0]=242;t[d+3|0]=2;break $;case 4:t[d+5|0]=242;t[d+3|0]=3;break $;case 3:t[d+5|0]=244;t[d+3|0]=2;break $;case 2:t[d+5|0]=244;t[d+3|0]=3;break $;case 1:t[d+5|0]=248;t[d+3|0]=2;break $;case 12:break ea;case 0:break fa;default:break $}}t[d+5|0]=248;t[d+3|0]=3;break $}g=0;K=t[i+1|0];if((K|0)<0&c>>>0>99){break $}if((K|0)>=0){t[f+17|0]=b;t[d|0]=b;t[f+18|0]=r;t[d+1|0]=r;u[f+32>>1]=0;v[f+8>>2]=0;c=w[i+2|0]}b=c&255;if(!b){break $}la=f,ma=tk(+(b>>>0)*.64),t[la+19|0]=ma;j=z[f>>2];v[f>>2]=0;g=j!=C(0);break $}t[d+4|0]=0;t[d+2|0]=14;t[f+16|0]=1;break $;case 1:v[f+4>>2]=0;z[f>>2]=C(w[i+2|0])*C(.0333000011742115);break _;case 2:v[f+4>>2]=0;z[f>>2]=C(w[i+2|0])*C(-.0333000011742115);break _;case 12:t[e+272|0]=15;t[e+100|0]=w[i+3|0]>>>3;b=w[Yb(e+272|0,e+100|0)|0];t[e+272|0]=15;t[e+100|0]=w[i+2|0]>>>3;la=f,ma=w[Yb(e+272|0,e+100|0)|0]|b<<4,t[la+24|0]=ma;break _;case 3:v[f+12>>2]=0;b=w[i+2|0];u[f+32>>1]=0;z[f+8>>2]=C(b>>>0)*C(.0333000011742115);break _;case 4:v[f+12>>2]=0;b=w[i+2|0];u[f+32>>1]=0;z[f+8>>2]=C(b>>>0)*C(-.0333000011742115);break _;case 15:if(!w[i+2|0]|(b|0)<0){break _}g=b-w[f+17|0]|0;c=g>>31;c=(c^g<<5)-c|0;v[e+272>>2]=c;t[f+17|0]=b;v[f+8>>2]=0;t[d|0]=b;t[d+3|0]=4;b=tg((c>>>0)/(w[i+2|0]<<1>>>0)|0);t[d+5|0]=b;t[f+27|0]=b;v[e+100>>2]=B(b,(m&255)-1|0);la=f,ma=c-v[td(e+272|0,e+100|0)>>2]|0,u[la+32>>1]=ma;break _;case 13:t[e+272|0]=15;t[e+100|0]=w[i+3|0]>>>3;b=w[Yb(e+272|0,e+100|0)|0];t[e+272|0]=15;t[e+100|0]=w[i+2|0];la=f,ma=w[Yb(e+272|0,e+100|0)|0]|b<<4,t[la+23|0]=ma;break _;case 18:b=w[i+2|0]+w[f+17|0]&255;b=b?b>>>0<120?b:120:1;t[f+17|0]=b;t[d|0]=b;t[d+5|0]=255;t[d+3|0]=4;break ba;case 23:case 24:case 25:b=Td(s);while(1){ga:{c=0;if(!b){break ga}g=b+13|0;if(!Ht(i,g)){c=1;if(!Ht(g,i)){break ga}b=b+4|0}b=v[b>>2];continue}break};if(c){t[d+3|0]=31;v[23540]=0;b=Q(696,s|0,i|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break M}t[d+5|0]=w[b|0];break _}b=v[Gb(s)>>2];if(b>>>0>127){break _}v[e+96>>2]=w[i|0]|w[i+1|0]<<8|(w[i+2|0]<<16|w[i+3|0]<<24);c=v[ia>>2];v[23540]=0;v[e+12>>2]=v[e+96>>2];c=W(697,e+12|0,ye(ga,b&255)|0,c|0)|0;g=v[23540];v[23540]=0;ha:{if((g|0)==1){break ha}if(!c){break _}t[d+3|0]=31;v[23540]=0;c=Q(696,s|0,i|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break ha}b=b|-128;t[c|0]=b;t[d+5|0]=b;ca=(w[i|0]&254)==24|ca;break _}break M;case 16:if(!w[i+2|0]){break _}t[d+3|0]=15;v[e+272>>2]=15;v[e+100>>2]=w[i+3|0]+1;la=d,ma=v[td(e+272|0,e+100|0)>>2],t[la+5|0]=ma;u[f+30>>1]=B(w[i+2|0],w[i+3|0]+1|0);break _;case 9:t[d+3|0]=16;b=w[i+2|0];m=b?b:4;t[d+5|0]=m;break _;case 19:ia:{b=w[i+1|0];switch(b|0){case 0:case 4:break ia;default:break _}}g=128;g=(b|0)==4?w[i+3|0]:g;t[e+95|0]=g;t[e+272|0]=w[i+2|0];t[e+100|0]=100;b=e+272|0;r=e+100|0;c=w[Yb(b,r)|0];v[e+272>>2]=128;v[e+100>>2]=256-(g&255);g=v[td(b,r)>>2];t[e+272|0]=128;b=w[Yb(b,e+95|0)|0];g=(B(c,g)|0)/128|0;r=g&255;if((r|0)!=w[f+20|0]){t[f+20|0]=g;t[d+3|0]=21;g=Ec(((B(r,w[f+19|0])+50&65535)>>>0)/100|0,0);t[f+21|0]=g;t[d+5|0]=g}if(w[i+1|0]!=4|(x[a+480188>>1]-1|0)<=(n|0)){break _}g=n+1|0;i=Mt(v[F>>2],g);b=B(b,c)>>>7|0;if(w[i+20|0]==(b&255)){break _}t[i+20|0]=b;b=B(g,6)+Z|0;t[b+3|0]=21;c=Ec(((B(w[f+20|0],w[f+19|0])+50&65535)>>>0)/100|0,0);t[f+21|0]=c;t[b+5|0]=c;break _;case 10:case 11:case 17:case 20:t[d+3|0]=0;break _;case 7:b=w[i+2|0];t[f+25|0]=0;t[f+26|0]=0;t[f+22|0]=b;break _;case 8:t[f+22|0]=w[f+22|0]+w[i+2|0];break _;case 14:t[f+25|0]=w[i+3|0];t[f+26|0]=w[i+2|0];break _;case 6:break da;default:break _}}t[f+18|0]=r;t[f+17|0]=b;t[d+1|0]=r;c=b}t[d|0]=c;if((b|0)>=0){t[f+18|0]=r;t[d+1|0]=r}if(w[i|0]==5){t[d+4|0]=1;t[d+2|0]=11}c=w[f+22|0];b=w[f+26|0];if(!(b?1:c|w[i+2|0])){break ba}if(b){da=(Di(+x[f+28>>1]*.006135923151542565+4.71238898038469)+-1)*+(b>>>0)*.25}else{da=0}t[d+3|0]=44;la=d,ma=tk(da+ +(c+w[i+2|0]|0)),t[la+5|0]=ma}u[f+32>>1]=0;break _}t[d+5|0]=m;t[d+3|0]=16}b=Ec(((B(w[f+20|0],w[f+19|0])+50&65535)>>>0)/100|0,0);if(!(!g&w[f+21|0]==(b&255))){t[f+21|0]=b;t[d+5|0]=b;t[d+3|0]=21}if(n&1|t[i+1|0]<=0|(x[a+480188>>1]-1|0)<=(n|0)){break _}b=v[l>>2];if(zh(b,v[l+4>>2])>>>0<=G>>>0){break _}if(w[zm(b,G)+132|0]!=1){break _}g=n+1|0;b=B(g,6)+Z|0;c=w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24);t[b|0]=c;t[b+1|0]=c>>>8;t[b+2|0]=c>>>16;t[b+3|0]=c>>>24;c=w[d+4|0]|w[d+5|0]<<8;t[b+4|0]=c;t[b+5|0]=c>>>8;t[b+1|0]=w[b+1|0]+1;b=Mt(v[F>>2],g);t[b+19|0]=w[f+19|0];z[b>>2]=z[f>>2];z[b+4>>2]=z[f+4>>2];z[b+8>>2]=z[f+8>>2];z[b+12>>2]=z[f+12>>2];u[b+30>>1]=x[f+30>>1]}ja:{if(w[d|0]){t[f+16|0]=0;break ja}c=0;if(w[f+16|0]){break X}}ka:{if(!x[f+30>>1]){break ka}b=m&255;u[e+272>>1]=b;c=f+30|0;la=c,ma=x[ke(c,e+272|0)>>1]-b|0,u[la>>1]=ma;if(w[d+3|0]){break ka}t[d+3|0]=15;t[d+5|0]=0}j=z[f>>2];la:{if(j==C(0)){break la}b=m&255;j=C(C(j*C(b>>>0))+z[f+4>>2]);z[f+4>>2]=j;if(w[d+3|0]){break la}ma:{na:{oa:{pa:{if(b>>>0>=2){g=b-1|0;D=C(g|0);if(!(D<=j)){break pa}t[e+272|0]=15;la=e,ma=jh(C(j/D)),t[la+100|0]=ma;b=w[Yb(e+272|0,e+100|0)|0];z[f+4>>2]=j-C(B(b,g)|0);t[d+3|0]=22;c=b<<4;break ma}if(!(j>=C(1))){break oa}break na}if(j>=C(1)){break na}if(!(j<=C(1-b|0))){break oa}t[e+272|0]=15;la=e,ma=jh(C(C(-j)/D)),t[la+100|0]=ma;c=w[Yb(e+272|0,e+100|0)|0];z[f+4>>2]=j+C(B(g,c)|0);t[d+3|0]=22;break ma}if(!(j<=C(-1))){break la}t[e+272|0]=14;la=e,ma=jh(C(-j)),t[la+100|0]=ma;b=w[Yb(e+272|0,e+100|0)|0];z[f+4>>2]=j+C(b>>>0);t[d+3|0]=22;c=b|-16;break ma}t[e+272|0]=15;la=e,ma=jh(j),t[la+100|0]=ma;b=w[Yb(e+272|0,e+100|0)|0];z[f+4>>2]=j-C(b>>>0);t[d+3|0]=22;c=b<<4|15}t[d+5|0]=c}j=z[f+8>>2];qa:{if(j==C(0)){break qa}b=m&255;j=C(C(j*C(b>>>0))+z[f+12>>2]);z[f+12>>2]=j;ra:{if(!w[d+3|0]){sa:{ta:{if(b>>>0>=2){c=b-1|0;D=C(c|0);if(!(D<=j)){break ta}t[e+272|0]=223;la=e,ma=jh(C(j/D)),t[la+100|0]=ma;b=w[Yb(e+272|0,e+100|0)|0];z[f+12>>2]=j-C(B(b,c)|0);t[d+3|0]=2;t[d+5|0]=b;break qa}if(!(j>=C(1))){break sa}break ra}if(j>=C(1)){break ra}if(!(j<=C(1-b|0))){break sa}t[e+272|0]=223;la=e,ma=jh(C(C(-j)/D)),t[la+100|0]=ma;b=w[Yb(e+272|0,e+100|0)|0];z[f+12>>2]=j+C(B(b,c)|0);t[d+3|0]=3;t[d+5|0]=b;break qa}if(!(j<=C(-1))){break qa}t[e+272|0]=14;la=e,ma=jh(C(-j)),t[la+100|0]=ma;b=w[Yb(e+272|0,e+100|0)|0];z[f+12>>2]=j+C(b>>>0);t[d+3|0]=3;t[d+5|0]=b|240;break qa}if(w[d+2|0]|b>>>0<2){break qa}ea=C(j*C(.25));c=b-1|0;D=C(c|0);if(ea>=D){t[e+272|0]=9;la=e,ma=jh(C(j/D))>>>2|0,t[la+100|0]=ma;b=w[Yb(e+272|0,e+100|0)|0];z[f+12>>2]=j-C(B(b,c)<<2);t[d+2|0]=12;t[d+4|0]=b;break qa}if(!(C(1-b|0)>=ea)){break qa}t[e+272|0]=9;la=e,ma=jh(C(C(-j)/D))>>>2|0,t[la+100|0]=ma;b=w[Yb(e+272|0,e+100|0)|0];z[f+12>>2]=j+C(B(b,c)<<2);t[d+2|0]=13;t[d+4|0]=b;break qa}t[e+272|0]=15;la=e,ma=jh(j),t[la+100|0]=ma;b=w[Yb(e+272|0,e+100|0)|0];z[f+12>>2]=j-C(b>>>0);t[d+3|0]=2;t[d+5|0]=b|240}ua:{va:{wa:{xa:{ya:{za:{Aa:{b=w[d+3|0];switch(b|0){case 4:break ua;case 0:break Aa;default:break za}}Ba:{b=w[f+23|0];if(!b){b=w[f+24|0];if(b){break Ba}if(!x[f+32>>1]){break ua}c=f+32|0;break ya}t[d+3|0]=5;t[d+5|0]=b;if(!x[f+32>>1]){break ua}break xa}t[d+3|0]=8;t[d+5|0]=b;if(x[f+32>>1]){break xa}break ua}if(!x[f+32>>1]){break ua}c=f+32|0;if(b){break wa}}t[d+3|0]=4;break va}c=f+32|0}t[d+2|0]=11}u[e+272>>1]=B(w[f+27|0],(m&255)-1|0);la=f,ma=x[f+32>>1]-x[Wc(c,e+272|0)>>1]|0,u[la+32>>1]=ma}u[f+28>>1]=x[f+28>>1]+B(w[f+25|0],m&255)&1023;c=0;if(n&1){break X}b=w[f+18|0];if(!b){break X}g=v[l>>2];if(zh(g,v[l+4>>2])>>>0<b>>>0){break X}g=zm(g,b-1|0);if(!(w[g+142|0]&4)){break X}b=w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24);t[o|0]=b;t[o+1|0]=b>>>8;t[o+2|0]=b>>>16;t[o+3|0]=b>>>24;b=w[d+4|0]|w[d+5|0]<<8;t[o+4|0]=b;t[o+5|0]=b>>>8;c=1;b=w[e+65|0];if(!b|w[g+132|0]!=1){break X}t[e+65|0]=b+1}n=n+1|0;b=x[a+480188>>1];continue}}break}ze(c,Gh(Ue(Oe(e+272|0,16,Ib(w[h+14|0]|w[h+15|0]<<8)&255),0)))}b=Bl(v[H>>2],v[H+4>>2]);la=e,ma=Ib(w[h+4|0]|w[h+5|0]<<8),u[la+272>>1]=ma;u[e+64>>1]=1;c=x[ke(e+272|0,e- -64|0)>>1];v[23540]=0;X(698,H|0,b|0,c|0,E&65535);b=v[23540];v[23540]=0;if((b|0)==1){break Q}b=pe((w[k+8|0]|w[k+9|0]<<8)<<16>>16);b=pe(pe((w[h+16|0]|w[h+17|0]<<8)<<16>>16)-b<<16>>16);t[h+16|0]=b;t[h+17|0]=b>>>8}b=h+32|0;continue}break}break M}d=ca&1;if(d){v[23540]=0;g=a+906300|0;b=Md(g,0);Y(284,b|0);c=v[23540];v[23540]=0;if((c|0)==1){break M}v[b+16>>2]=1299020115;v[b+20>>2]=1869112133;v[b+24>>2]=655376;v[b+28>>2]=0;v[e+272>>2]=0;h=b+48|0;c=e+272|0;vV(b+32|0,h,c);v[23540]=0;c=Q(55,c|0,9585)|0;f=v[23540];v[23540]=0;if((f|0)==1){break M}NB(h,c);zb(c);v[23540]=0;c=Q(55,e+80|0,9578)|0;h=v[23540];v[23540]=0;if((h|0)==1){break M}Ju(b+80|0,c);zb(c);v[23540]=0;b=Q(55,e- -64|0,9570)|0;c=v[23540];v[23540]=0;if((c|0)==1){break M}NB(Md(g,1)+48|0,b);zb(b)}b=0;while(1){if(x[a+480188>>1]>b>>>0){wB(a,b&65535);c=(b<<5)+a|0;t[c+480288|0]=d;u[c+480284>>1]=b<<8&256;b=b+1|0;continue}break}v[23540]=0;b=Q(1,e+48|0,12086)|0;c=v[23540];v[23540]=0;Ca:{Da:{Ea:{if((c|0)!=1){Jb(a+1298344|0,b);Ab(b);v[23540]=0;b=Q(1,e+32|0,12304)|0;c=v[23540];v[23540]=0;if((c|0)==1){break M}Jb(a+1298356|0,b);Ab(b);if(_){break Ea}v[23540]=0;b=Q(1,e+16|0,12086)|0;c=v[23540];v[23540]=0;if((c|0)==1){break M}break Da}break M}if(zh(v[l>>2],v[l+4>>2])>>>0<=128){v[23540]=0;b=Q(1,e+16|0,9327)|0;c=v[23540];v[23540]=0;if((c|0)!=1){break Da}break M}v[23540]=0;b=Q(1,e+16|0,14820)|0;c=v[23540];v[23540]=0;if((c|0)==1){break Ca}}Jb(a+1298368|0,b);Ab(b);v[a+1298404>>2]=14;wQ(F);nQ(s);mQ(I);d=1;break m}}c=P()|0;O()|0;wQ(F);break j}iq(e+48|0);continue}}c=P()|0;O()|0;break a}c=P()|0;O()|0;break a}Nt(l);wc(A);Bm(q);Ei(p);break c}c=P()|0;O()|0;break j}c=P()|0;O()|0}nQ(s);mQ(I);break a}c=P()|0;O()|0;Ab(b);break a}c=P()|0;O()|0;break a}Bb(c);v[23540]=0;c=d&65535;d=W(699,a|0,c|0,n|0)|0;g=v[23540];v[23540]=0;Fa:{Ga:{Ha:{Ia:{if((g|0)==1){break Ia}if(d){break Fa}v[23540]=0;d=W(700,a|0,c|0,n|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break Ia}if(d){break Fa}v[23540]=0;d=W(701,a|0,c|0,n|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break Ia}if(d){break Fa}v[23540]=0;d=Q(702,(B(c,104)+a|0)+484380|0,n|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break Ia}if(d){break Fa}v[23540]=0;d=Q(1,e+448|0,16199)|0;g=v[23540];v[23540]=0;if((g|0)==1){break Ha}g=v[F>>2];v[23540]=0;U(376,g|0,2,d|0);g=v[23540];v[23540]=0;if((g|0)==1){break Ga}Ab(d);break Fa}c=P()|0;O()|0;break e}c=P()|0;O()|0;break e}c=P()|0;O()|0;Ab(d);break e}Ja:{Ka:{La:{E=B(c,104)+a|0;if(w[E+484414|0]&64){d=x[i>>1];if(Zh(d)){break La}}d=v[l>>2];if(zh(d,v[l+4>>2])>>>0<=c>>>0){break Ka}if(w[zm(d,c)+132|0]!=2){break Ka}c=x[i>>1];if(!Zh(c)){break Ka}u[i>>1]=c+1;break Ka}c=d+1|0;u[i>>1]=c;G=B(c&65535,104)+a|0;o=G+484380|0;f=E+484380|0;d=v[f>>2];g=v[f+20>>2];Ma:{if(!_d(d,g)){break Ma}h=x[f+34>>1];if((f|0)==(o|0)|(Ld(h)|0)!=2){break Ma}c=(f|0)==(o|0);if(!(_d(v[o>>2],v[o+20>>2])?c:1)){break Ma}_d(v[f>>2],v[f+20>>2]);if(!c){g=It(d,$m(h))}h=v[f+20>>2];if(!(h?g:0)){if(!c){Ez(g)}break Ma}Na:{Oa:{switch($m(x[f+34>>1])-1|0){case 1:d=g;c=h;m=v[f+20>>2];k=v[f>>2];while(1){if(k){u[d>>1]=x[m>>1];u[c>>1]=x[m+2>>1];m=m+4|0;c=c+2|0;d=d+2|0;k=k-1|0;continue}break};break Na;case 0:break Oa;default:break Na}}d=g;c=h;m=v[f+20>>2];k=v[f>>2];while(1){if(k){t[d|0]=w[m|0];t[c|0]=w[m+1|0];m=m+2|0;c=c+1|0;d=d+1|0;k=k-1|0;continue}break}}d=lo(o,f);u[d+34>>1]=x[d+34>>1]&65471;v[o+20>>2]=g;g=lo(f,f);u[g+34>>1]=x[g+34>>1]&65471;v[f+20>>2]=h;h=a+1298224|0;c=a+1074992|0;while(1){if((c|0)!=(h|0)){f=v[c+104>>2];if(!((f|0)!=(d|0)&(f|0)!=(g|0))){v[c+88>>2]=v[c+88>>2]&-65}c=c+872|0;continue}break}uj(d,a);uj(g,a)}v[23540]=0;c=Q(55,e+432|0,6323)|0;d=v[23540];v[23540]=0;if((d|0)==1){break Ja}Be(G+484423|0,c);zb(c);v[23540]=0;c=Q(55,e+416|0,6226)|0;d=v[23540];v[23540]=0;if((d|0)==1){break f}Be(E+484423|0,c);zb(c)}Bb(n);ic(s);g=0;continue}break}c=P()|0;O()|0;break e}c=P()|0;O()|0}Bb(n)}ic(s);break a}kb=e+672|0;return d|0}c=P()|0;O()|0}Nt(l);wc(A);Bm(q);Ei(p);T(c|0);L()}function Yt(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,M=0,N=0,S=0,V=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ka=0,la=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ca=0,Da=0,Ea=C(0),Fa=0,Ga=0,Ha=0,Ia=C(0);i=kb-192|0;kb=i;$=Tb(a);q=i+160|0;t[q+26|0]=0;u[q+24>>1]=0;v[q+16>>2]=0;v[q+20>>2]=-1;v[q+8>>2]=-1;v[q+12>>2]=-1;v[q>>2]=0;v[q+4>>2]=0;M=v[d+16>>2];a=w[d+6|0];na=b+484360|0;e=v[na>>2];oa=(Fa=a,Ga=w[b+484376|0],Ha=sj(e,v[b+484364>>2])>>>0>a>>>0,Ha?Fa:Ga);a=oa&255;I=zj(e,a);v[23540]=0;r=Q(580,i+128|0,b|0)|0;e=v[23540];v[23540]=0;a:{b:{c:{d:{e:{f:{g:{h:{i:{if((e|0)!=1){l=v[r+4>>2];v[23540]=0;J=W(581,i+88|0,b|0,a|0)|0;a=v[23540];v[23540]=0;if((a|0)==1){break i}ca=c&7;h=v[d>>2];a=x[d+4>>1];while(1){e=a&65535;if(Rc(v[I>>2],v[I+4>>2])>>>0<=e>>>0){break g}v[23540]=0;e=Q(311,I|0,e|0)|0;n=v[23540];v[23540]=0;if((n|0)==1){break h}if(e){break g}a=a+1|0;h=0;continue}}k=P()|0;O()|0;break d}k=P()|0;O()|0;break e}k=P()|0;O()|0;v[d>>2]=h;u[d+4>>1]=a;break f}v[d>>2]=h;u[d+4>>1]=a;v[l+52>>2]=h;K=l+48|0;v[K>>2]=h;v[q+16>>2]=h;u[l+74>>1]=a;u[l+72>>1]=a;u[q+24>>1]=a;pa=ee(i+80|0);j:{if((ca|0)!=7){break j}a=kb-16|0;kb=a;e=a+8|0;Db(e,pa,1);qo(e);kb=a+16|0;if((M|0)!=2){break j}a=v[I>>2];n=Rc(a,v[I+4>>2]);e=x[d+12>>1];if(n>>>0<=e>>>0){break j}n=v[b+484344>>2];f=v[b+484348>>2];a=x[cc(a,e)>>1];if(!xe(n,f,a)){break j}e=_b(n,a);n=v[d+8>>2];if(y[e+12>>2]<=n>>>0){break j}a=0;k=jd(v[e>>2],v[v[e+48>>2]+12>>2],n,0);e=x[b+480188>>1];n=v[r+8>>2];f=x[b+480192>>1];while(1){if((a|0)==(e|0)){break j}k:{l:{m:{n:{g=w[k|0];switch(g-253|0){case 1:case 2:break l;case 0:break n;default:break m}}if(f){break l}}if(!$c(g)){break k}if(vm(w[k+2|0],w[k+3|0])){break k}}Fa=bf(n,a),Ga=-1,v[Fa>>2]=Ga}k=k+6|0;a=a+1|0;continue}}aa=c&1;if(aa){dO(l+223860|0)}V=l+74|0;wa=l+223872|0;xa=(M|0)!=3;N=l+80|0;ya=b+901692|0;za=b+902204|0;ga=l+44|0;ha=l+223860|0;ba=l+20|0;H=b+1074312|0;qa=l+616|0;ea=32768;ra=A[d+8>>3];o(+ra);a=j(1)|0;Aa=j(0)|0;ka=a;_=b+480188|0;G=b+480180|0;la=b+484348|0;sa=(M|0)!=2;Ca=l+223884|0;ta=b+480192|0;Da=(ca|0)!=7;d=0;o:{p:{q:{r:{s:{t:while(1){n=ka;while(1){cO(i+16|0,v[G>>2],x[_>>1],l,p&1);if(!(!(A[r+24>>3]>=ra)|xa)){break p}g=w[i+16|0];a=65535;f=v[I>>2];h=Rc(f,v[I+4>>2]);e=x[l+72>>1];if(h>>>0>e>>>0){a=x[cc(f,e)>>1]}u[l+70>>1]=a;f=v[b+484344>>2];h=v[la>>2];k=a&65535;if(!(xe(f,h,k)|(k|0)==65535|sa)&(e|0)==(n&65535)){break p}u:{v:{while(1){a=a&65535;if(Af(f,h)>>>0>a>>>0){break u}k=x[l+72>>1];w:{x:{if((a|0)!=65535){e=v[I>>2];m=Rc(e,v[I+4>>2]);if(k>>>0<m>>>0){break x}}a=x[I+28>>1];if((k|0)==(a|0)){break u}e=v[I>>2];m=Rc(e,v[I+4>>2]);break w}a=k+1|0}u[l+72>>1]=a;k=65535;s=m;m=a&65535;if(s>>>0>m>>>0){k=x[cc(e,m)>>1]}u[l+74>>1]=a;u[l+70>>1]=k;y:{if(!xe(f,h,k&65535)){e=Yp(i+16|0,qa);v[23540]=0;a=ja(582,J|0,a&65535,0,e|0,(g|0)!=0|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break y}if(a){break v}h=v[la>>2];f=v[b+484344>>2]}a=x[l+70>>1];continue}break}k=P()|0;O()|0;break f}if(M>>>0<=1){a=x[l+72>>1];v[q+8>>2]=0;u[q+20>>1]=a;if(!M){break u}}v[23540]=0;a=W(583,J|0,V|0,K|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break q}if(!a){break u}A[q>>3]=A[r+24>>3];v[23540]=0;R(584,$|0,q|0);a=v[23540];v[23540]=0;if((a|0)==1){break q}v[q+16>>2]=v[K>>2];u[q+24>>1]=x[V>>1];v[23540]=0;Y(585,r|0);a=v[23540];v[23540]=0;if((a|0)==1){break q}a=x[l+74>>1];u[l+72>>1]=a;Fa=l,Ga=x[cc(v[I>>2],a)>>1],u[Fa+70>>1]=Ga;v[l+52>>2]=v[l+48>>2]}if(x[V>>1]==65535){break o}a=v[b+484344>>2];e=x[l+70>>1];if(!xe(a,v[la>>2],e)){a=x[l+72>>1];if((a|0)==x[I+28>>1]){if(!M){break o}v[23540]=0;a=W(583,J|0,V|0,K|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break q}if(!a){break o}A[q>>3]=A[r+24>>3];v[23540]=0;R(584,$|0,q|0);a=v[23540];v[23540]=0;if((a|0)==1){break q}v[q+16>>2]=v[K>>2];u[q+24>>1]=x[V>>1];v[23540]=0;Y(585,r|0);a=v[23540];v[23540]=0;if((a|0)==1){break q}v[l+52>>2]=v[l+48>>2];continue}u[V>>1]=a+1;continue}f=v[K>>2];if(f>>>0>=y[_b(a,e)+12>>2]){v[K>>2]=0;f=0}if(!(x[l+72>>1]!=(n&65535)|sa)&(f|0)==(Aa|0)){break p}a=0;if(!((M|0)==3|y[J+28>>2]<ea>>>0)){v[r+24>>2]=0;v[r+28>>2]=2146435072;v[J+28>>2]=0;ea=ea>>>(ea>>>0>256)|0;f=v[K>>2];a=1}e=x[l+72>>1];h=Yp(i+16|0,qa);v[23540]=0;e=ja(582,J|0,e|0,f|0,h|0,(g|0)!=0|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break s}if((a|e)==1){if(M>>>0<=1){u[q+20>>1]=x[l+72>>1];v[q+8>>2]=v[l+48>>2];if(!M){break o}}v[23540]=0;a=W(583,J|0,V|0,K|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break r}if(!a){break o}A[q>>3]=A[r+24>>3];v[23540]=0;R(584,$|0,q|0);a=v[23540];v[23540]=0;if((a|0)==1){break r}v[q+16>>2]=v[K>>2];u[q+24>>1]=x[V>>1];v[23540]=0;Y(585,r|0);a=v[23540];v[23540]=0;if((a|0)==1){break r}v[l+52>>2]=v[l+48>>2];continue}u[q+22>>1]=x[l+72>>1];v[q+12>>2]=v[l+48>>2];bO(b,l,0);k=v[l+48>>2];e=_b(v[b+484344>>2],x[l+70>>1]);if(k>>>0>=y[e+12>>2]){v[K>>2]=0;k=0}if(g){continue}break}a=0;k=jd(v[e>>2],v[v[e+48>>2]+12>>2],k,0);Db(i+16|0,H,77);g=Cb(v[v[i+16>>2]>>2],v[i+20>>2]);z:{while(1){if(x[_>>1]>a>>>0){A:{if(!(!az(k)&(!g|!(w[((a<<5)+b|0)+480281|0]&4)))){ko((l+B(a,872)|0)+1404|0);break A}if(fh(w[k|0])){B:{if(!Qd(w[Ca|0])){break B}e=w[k+1|0];if(e-251>>>0<5|!e){break B}f=w[k+5|0];p=w[k+3|0];h=ik(w[k+2|0],w[k+4|0]);n=i+16|0;t[n|0]=e-1;v[n+4>>2]=h&65535;v[23540]=0;e=Q(586,wa|0,n|0)|0;n=v[23540];v[23540]=0;if((n|0)==1){break z}Fa=e,Ia=C(C(ik(p,f)>>>0)/C(999)),z[Fa>>2]=Ia}ko((l+B(a,872)|0)+1404|0);break A}e=l+B(a,872)|0;n=e+1408|0;f=w[k+4|0]|w[k+5|0]<<8;t[n|0]=f;t[n+1|0]=f>>>8;n=e+1404|0;f=w[k|0]|w[k+1|0]<<8|(w[k+2|0]<<16|w[k+3|0]<<24);t[n|0]=f;t[n+1|0]=f>>>8;t[n+2|0]=f>>>16;t[n+3|0]=f>>>24;C:{D:{E:{F:{switch(w[k+3|0]-16|0){case 0:h=w[k+5|0];break E;case 3:break C;case 4:break D;case 1:break F;default:break A}}Db(i+16|0,H,5);if(!Cb(v[v[i+16>>2]>>2],v[i+20>>2])){break A}h=w[k+5|0];if(!h){break A}}$N(b,l,h&255);break A}n=e+1409|0;f=w[n|0];G:{if(!(f|!(v[G>>2]&16777250))){t[n|0]=w[e+1449|0];break G}t[e+1449|0]=f}e=w[k+5|0];n=e&240;if((n|0)!=224){if((n|0)!=96){break A}v[l+24>>2]=v[l+24>>2]+(e&15);break A}if(v[ba>>2]){break A}e=e&15;if(e?0:w[G|0]&2){break A}v[ba>>2]=e+1;break A}e=w[k+5|0];if((e&240)!=224){break A}v[ba>>2]=(e&15)+1}k=k+6|0;a=a+1|0;continue}break}n=il(l);v[i+16>>2]=1;a=v[_c(ba,i+16|0)>>2];u[l+68>>1]=65535;v[l+60>>2]=-1;v[l+64>>2]=-1;D=n-1|0;a=n-a|0;F=B(a,1e4);k=0;while(1){if(x[_>>1]<=k>>>0){if(v[G>>2]==4&v[l+40>>2]==65535){break o}v[l+32>>2]=v[b+480216>>2];a=_b(v[b+484344>>2],x[l+70>>1]);e=v[a+16>>2];if(_N(e,v[a+20>>2])){v[l+32>>2]=e}f=ZN(b,l);a=B(f,n);A[r+24>>3]=A[r+24>>3]+ +(a>>>0)/+y[b+24620>>2];v[l>>2]=a+v[l>>2];H:{I:{J:{if(Da){break J}k=0;fa=(d|0)!=0&(d|0)!=(f|0);while(1){if(x[_>>1]<=k>>>0){break J}F=bf(v[r+8>>2],k);K:{if(v[F>>2]==-1){break K}m=l+B(k,872)|0;s=m+1404|0;S=v[m+1316>>2];if(!S){if(az(s)){break K}}a=m+1409|0;e=1;L:{M:{E=m+1407|0;switch(w[E|0]-4|0){case 0:case 2:break L;default:break M}}e=w[m+1406|0]==11}D=w[a|0];if(w[m+1405|0]){v[m+1276>>2]=0}g=m+616|0;h=D&15;p=0;N:{if(!$c(w[s|0])){break N}if(!(!e|!w[F+4|0])){$y(i+16|0,b,g,S,0);p=v[i+20>>2];v[m+624>>2]=v[i+16>>2];v[m+628>>2]=p}t[m+1418|0]=w[m+1415|0];S=m+1308|0;Z=v[S>>2];p=w[m+1419|0];if(p){Xp(b,g,p,e,1,1)}p=w[s|0];v[23540]=0;ia(587,b|0,g|0,p|0,e|0,1,0,65535);p=v[23540];v[23540]=0;if((p|0)==1){break I}D=D>>>4|0;YN(v[G>>2],x[_>>1],l,k&65535);ua=bf(v[r+8>>2],k);t[ua+4|0]=1;F=w[E|0];O:{if(!((w[a|0]&240)!=208|(F-19&255)>>>0>1)){p=h;if(h>>>0<n>>>0){break O}}p=(F|0)==33?n>>>0>D>>>0?D:0:0}va=v[ba>>2];if(!(!(v[G>>2]&16777250)|(!p|va>>>0<2))){p=B(va-1|0,v[l+24>>2]+v[l+40>>2]|0)+p|0}if(!e){v[ua>>2]=0}P:{if((F|0)==9){break P}Q:{if((F|0)!=19){if((F|0)!=20|(D|0)!=8){break Q}break P}if((D|0)==8){break P}}if(w[m+1406|0]!=2){break N}}v[S>>2]=Z}R:{if(!$c(w[s|0])){Db(i+16|0,H,114);if(!Cb(v[v[i+16>>2]>>2],v[i+20>>2])){break R}}S:{T:{U:{V:{e=w[E|0];switch(e-42|0){case 1:break S;case 0:break T;case 2:break U;default:break V}}if((e|0)!=10){break S}e=x[l+70>>1];D=v[l+48>>2];v[23540]=0;da(588,b|0,g|0,k&65535,D|0,e|0);e=v[23540];v[23540]=0;if((e|0)!=1){break R}break H}F=Jka(w[a|0],0,v[m+692>>2],0);D=nb;e=D>>>8|0;$n(b,g,Ec((D&255)<<24|F>>>8,e));break R}if(!v[m+720>>2]){break S}v[23540]=0;X(589,r|0,k&65535,d|0,-1);e=v[23540];v[23540]=0;if((e|0)==1){break H}WN(g,w[a|0]);p=v[l+40>>2]-1|0;break R}if(w[m+1406|0]!=15){break R}D=v[m+720>>2];if(!D){break R}e=w[m+1408|0];if(e>>>0>9){break R}W:{if(!e){e=v[m+1280>>2];break W}e=v[Eb(D+68|0,e-1|0)>>2];v[m+1280>>2]=e}$n(b,g,e)}X:{Y:{Z:{switch(w[s|0]-253|0){case 0:if(x[ta>>1]){break Y}break;case 1:case 2:break Y;default:break Z}}e=w[E|0];if(!((w[a|0]&240)!=192|(e-19&255)>>>0>1)&h>>>0<n>>>0){break Y}D=0;F=e&255;if((F|0)==33&(h|0)!=0&n>>>0>h+p>>>0){break Y}if((F|0)!=25){break X}}e=w[E|0];D=1}S=m+1304|0;F=e&255;_:{if((F|0)!=13){if(w[m+1406|0]!=1){break _}h=m+1408|0}else{h=a}v[S>>2]=w[h|0]<<2}$:{aa:{ba:{if(!v[m+720>>2]|D|F>>>0>45){break ba}Db(i+16|0,pa,F);if(Cb(v[v[i+16>>2]>>2],v[i+20>>2])){break aa}e=w[E|0];if((e|0)!=19){break ba}h=w[a|0]&240;if((h|0)==16){break aa}e=19;if((h|0)==32){break aa}}if(!D){break $}}AP(g);Fa=bf(v[r+8>>2],k),Ga=0,v[Fa>>2]=Ga;break K}if(fa){v[23540]=0;X(589,r|0,k&65535,d|0,-1);e=v[23540];v[23540]=0;if((e|0)==1){break H}e=w[E|0]}ca:{da:{ea:{fa:{ga:{e=e&255;if(e-6>>>0>=2){ha:{switch(e-19|0){case 1:break fa;case 0:break ga;default:break ha}}if(e-35>>>0<2){break da}if((e|0)==45){break ea}if((e|0)!=11){break ca}}if(!w[a|0]&v[G>>2]==1){break ca}e=m+1467|0;h=0;while(1){if((h|0)==(n|0)){break ca}t[e|0]=!h|w[e|0]&254;_n(b,g,w[a|0]);h=h+1|0;continue}}e=w[a|0];a=e&15;if(!(v[G>>2]&1048580?1:a)){break ca}h=m+1467|0;t[h|0]=w[h|0]|1;e=e&240;if((e|0)!=176){if((e|0)!=160){break ca}Zn(b,g,a,0);break ca}Yn(b,g,a,0);break ca}ia:{ja:{ka:{a=w[a|0];switch(a-158|0){case 1:break ja;case 0:break ka;default:break ia}}v[23540]=0;X(589,r|0,k&65535,d|0,-1);a=v[23540];v[23540]=0;if((a|0)==1){break H}v[m+704>>2]=v[m+704>>2]&-129;break ca}v[23540]=0;X(589,r|0,k&65535,d|0,-1);a=v[23540];v[23540]=0;if((a|0)==1){break H}a=v[m+704>>2];v[m+704>>2]=a|128;if(v[g+4>>2]){break ca}e=v[m+692>>2];if(!e){break ca}if(!(Fa=$c(w[s|0]),Ga=1,Ha=a&2,Ha?Fa:Ga)){break ca}v[g>>2]=-1;v[g+4>>2]=e-1;break ca}if((a&240)!=112|a>>>0<115){break ca}xP(g,a,v[G>>2]);break ca}VN(g,w[a|0]);break ca}v[23540]=0;a=k&65535;X(589,r|0,a|0,d|0,-1);e=v[23540];v[23540]=0;if((e|0)==1){break H}UN(b,a,l,0)}h=m+1467|0;a=w[h|0]|1;t[h|0]=a;la:{ma:{na:{oa:{pa:{E=m+1406|0;switch(w[E|0]-3|0){case 11:break ma;case 0:case 1:break na;case 3:break oa;case 2:break pa;default:break la}}a=w[m+1408|0];Db(i+16|0,H,41);Zn(b,g,a,Cb(v[v[i+16>>2]>>2],v[i+20>>2]));break la}a=w[m+1408|0];Db(i+16|0,H,41);Yn(b,g,a,Cb(v[v[i+16>>2]>>2],v[i+20>>2]));break la}e=w[m+1408|0];qa:{if(e){break qa}Db(i+16|0,H,41);e=0;if(!Cb(v[v[i+16>>2]>>2],v[i+20>>2])){break qa}e=w[m+1450|0];if(!e){break la}}e=w[E|0]==3?e<<4:e;a=0;while(1){if((a|0)==(n|0)){break la}t[h|0]=!a|w[h|0]&254;_n(b,g,e&255);a=a+1|0;continue}}e=w[m+1408|0];if(e>>>0>1){break la}t[h|0]=a&247|!e<<3}if(w[h|0]&8){break K}a=1;ra:{sa:{ta:{e=w[s+3|0];if(e>>>0>28){break ta}g=1<<e;if(g&92){break ra}if(!(g&268959744)){break ta}if((w[s+5|0]-16&255)>>>0<32){break ra}break sa}if(e-38>>>0<4){break ra}}a=(w[s+2|0]-11&255)>>>0<3}if(a){e=bf(v[r+8>>2],k);a=v[e>>2];v[e>>2]=a+n;v[23540]=0;X(589,r|0,k&65535,f|0,a+p|0);a=v[23540];v[23540]=0;if((a|0)!=1){break K}k=P()|0;O()|0;break f}a=bf(v[r+8>>2],k);v[a>>2]=v[a>>2]+(n-p|0)}k=k+1|0;continue}}p=TN(b,l,I,0);d=f;continue t}k=P()|0;O()|0;break f}k=P()|0;O()|0;break f}g=l+B(k,872)|0;h=g+1404|0;ua:{if(az(h)){break ua}p=g+616|0;fa=g+1409|0;f=w[fa|0];S=g+1407|0;m=w[S|0];va:{wa:{if(!aa){break wa}s=w[h|0];e=s;E=g+1405|0;Z=w[E|0];if(Z){t[g+1415|0]=0;t[g+1419|0]=Z;Fa=bf(v[r+8>>2],k),Ga=255,t[Fa+5|0]=Ga;e=w[h|0]}if($c(e)){t[g+1415|0]=s;zP(p);e=w[h|0]}xa:{if(!(Fa=1,Ga=$c(e),Ha=w[E|0],Ha?Fa:Ga)){break xa}Z=g+1419|0;e=w[Z|0];ya:{if(!e){e=0;break ya}if(x[ta>>1]<e>>>0){break ya}E=v[((e<<2)+b|0)+900380>>2];if(!E|!(t[E+15|0]&1)){break ya}eq(p,v[E+8>>2],b);e=w[Z|0]}e=xq(b,s,e&255);if(!e){break xa}e=B(e,104)+b|0;if(!(w[e+484414|0]&32)){break xa}eq(p,x[e+484408>>1],b)}za:{Aa:{Ba:{e=w[g+1406|0];switch(e-1|0){case 1:break wa;case 2:case 3:break Aa;case 0:break Ba;default:break za}}Fa=bf(v[r+8>>2],k),Ga=w[g+1408|0],t[Fa+5|0]=Ga;break wa}e=w[g+1408|0];if(!e){break wa}t[g+1450|0]=e;break wa}if((e|0)!=11){break wa}e=w[g+1408|0];if(!e){break wa}s=i+16|0;_y(s,b,w[h+3|0],e,0);u[g+1384>>1]=x[i+16>>1];if(w[Te(s)|0]){break va}}Ca:{Da:{Ea:{Fa:{Ga:{switch(m-12|0){case 0:SN(b,l,k&65535);break Ca;case 2:e=RN(b,l,k&65535,f);if((e|0)==-1){break Ca}v[l+60>>2]=e;break Ca;case 5:Db(i+16|0,H,5);if(Cb(v[v[i+16>>2]>>2],v[i+20>>2])){break Ca}h=B(Xn(b,x[l+70>>1],v[l+48>>2],k&65535,0),1e4);Ha:{if(!aa|!(v[G>>2]&16777250)){break Ha}if(h>>>0>=1e4){t[g+1451|0]=(h>>>0)/1e4;break Ha}h=B(w[g+1451|0],1e4)}Ia:{if(h>>>0>319999){break Ia}s=(h>>>0)/1e4|0;h=B(F,s&15);e=v[ga>>2];if((s&240)==16){h=e+h|0;break Ia}h=e-h|0;h=e>>>0<h>>>0?0:h}v[ga>>2]=h;e=v[b+8>>2];h=v[e+20>>2];e=v[e+24>>2];Db(i+16|0,H,8);So(ga,B(h,1e4),Cb(v[v[i+16>>2]>>2],v[i+20>>2])?255e4:B(e,1e4));break Ca;case 8:Ja:{switch((f&240)-144>>>4|0){case 0:if(f>>>0>145){break Ca}v[g+704>>2]=v[g+704>>2]&-257|((f|0)==145)<<8;break Ca;case 1:t[g+1452|0]=f&15;break Ca;case 2:break Fa;case 6:break Ja;default:break Ca}}t[g+1460|0]=f&15;break Ca;case 1:case 3:case 4:case 6:break Ca;case 7:break Ga;default:break Da}}e=f&240;if((e|0)==240){break Ea}if((e|0)!=96){break Ca}}Zy(b,l,p,f&15);break Ca}t[g+1460|0]=f&15;break Ca}if((m|0)!=28|(f&240)!=160){break Ca}Db(i+16|0,H,58);if(Cb(v[v[i+16>>2]>>2],v[i+20>>2])){break Ca}t[g+1452|0]=f&15}if(!aa){break ua}Ka:{La:{Ma:{Na:{Oa:{Pa:{Qa:{Ra:{Sa:{switch(m-2|0){case 0:if(!f){break Ka}Db(i+16|0,H,90);if(!Cb(v[v[i+16>>2]>>2],v[i+20>>2])){t[g+1428|0]=f}t[g+1427|0]=f;break va;case 1:if(!f){break Ka}Db(i+16|0,H,90);if(!Cb(v[v[i+16>>2]>>2],v[i+20>>2])){t[g+1427|0]=f}t[g+1428|0]=f;break va;case 2:if(!f){break Ka}u[g+1384>>1]=f;break va;case 8:if(!f){break Ka}v[g+1280>>2]=f<<8;break va;case 4:case 9:if(!f){break Ka}t[g+1425|0]=f;break va;case 11:Fa=bf(v[r+8>>2],k),Ga=f,t[Fa+5|0]=Ga;break va;case 21:e=v[G>>2];f=f<<(!(e&59593760)&f<<24>>24>=0);h=f&255;if(h>>>0<=128){v[N>>2]=h<<1;break va}if(e&16777250){break va}v[N>>2]=256;break va;case 22:Db(i+16|0,H,9);Ta:{if(Cb(v[v[i+16>>2]>>2],v[i+20>>2])){e=g+1433|0;if(f){t[e|0]=f;break Ta}f=w[e|0];break Ta}if(f){t[l+1433|0]=f;break Ta}f=w[l+1433|0]}e=f&240;h=f&15;Ua:{if(!(!e|(h|0)!=15)){f=e>>>4<<!(v[G>>2]&59593760);e=v[N>>2]+(f<<1)|0;break Ua}if(!(!h|(e|0)!=240)){f=h<<(v[G>>2]&59593760?1:2);e=v[N>>2]-f|0;break Ua}if(e){f=(f>>>3&30)<<!(v[G>>2]&59593760);e=v[N>>2]+B(a,f)|0;break Ua}f=h<<(v[G>>2]&59593760?1:2);e=v[N>>2]-B(a,f)|0}v[N>>2]=e;oe(N,0,256);break va;case 19:if(f>>>0>64){break va}v[g+1364>>2]=f;break va;case 20:e=g+1432|0;Va:{if(f){t[e|0]=f;break Va}f=w[e|0]}m=f&255;s=g+1364|0;e=v[s>>2];E=f&240;h=f&15;Wa:{if(!(!E|(h|0)!=15)){v[i+16>>2]=e+(m>>>4|0);break Wa}if(!(!h|(E|0)!=240)){v[i+16>>2]=e-h;break Wa}if(h){v[i+16>>2]=e-B(a,h);break Wa}v[i+16>>2]=e+B(a,m>>>4|0)}oe(i+16|0,0,64);v[s>>2]=v[i+16>>2];break va;case 7:um(b,p,f,8);break va;case 29:case 30:break La;case 25:break Ma;case 6:break Na;case 24:break Oa;case 3:break Pa;case 5:break Qa;case 18:break Ra;case 17:break Sa;default:break va}}if(f>>>0>15){break Ra}e=(f&1)<<14;m=x[_>>1];h=0;while(1){if((h|0)==(m|0)){break Ra}s=l+B(h,872)|0;v[s+704>>2]=(e|v[s+704>>2]&-16385)^16384;h=h+1|0;continue}}if((f&240)!=128){break va}um(b,p,f&15,4);break va}if(f){t[g+1425|0]=f}f=0}hl(p,f);break va}QN(b,p,f);break va}PN(p,f);break va}ON(p,f);break va}Xa:{if(f<<24>>24>=0){e=ye(ya,w[g+1460|0]);break Xa}e=ye(za,f&127)}h=w[fa|0];v[23540]=0;ma(590,b|0,l|0,k&65535,0,e|0,h|0);e=v[23540];v[23540]=0;if((e|0)!=1){break va}k=P()|0;O()|0;break f}f=0}Ya:{Za:{switch(w[g+1406|0]-2|0){case 0:um(b,p,w[g+1408|0],6);break Ya;case 5:Db(i+16|0,H,53);e=w[g+1408|0];if(Cb(v[v[i+16>>2]>>2],v[i+20>>2])){t[g+1439|0]=e&15;break Ya}hl(p,e<<4);break Ya;case 6:break Za;default:break Ya}}hl(p,w[g+1408|0])}_a:{$a:{ab:{bb:{cb:{e=w[S|0];switch(e-5|0){case 1:break _a;case 3:break ab;case 0:case 2:break bb;default:break cb}}switch(e-26|0){case 1:break $a;case 0:break bb;default:break _a}}db:{if(v[G>>2]&16777248){e=n;if(!(w[b+480208|0]&4)){break db}}e=a}h=w[g+1439|0];Db(i+16|0,H,21);g=g+1435|0;m=w[g|0];e=B(e,h);Fa=g,Ga=(Cb(v[v[i+16>>2]>>2],v[i+20>>2])?e<<2:e)+m|0,t[Fa|0]=Ga;break _a}eb:{if(v[G>>2]&16777248){e=n;if(!(w[b+480208|0]&4)){break eb}}e=a}h=w[g+1442|0];Db(i+16|0,H,21);g=g+1436|0;m=w[g|0];e=B(e,h);Fa=g,Ga=(Cb(v[v[i+16>>2]>>2],v[i+20>>2])?e<<2:e)+m|0,t[Fa|0]=Ga;break _a}e=g+1437|0;t[e|0]=w[e|0]+B(D,w[g+1445|0]);MN(b,p)}Db(i+16|0,H,78);if(!Cb(v[v[i+16>>2]>>2],v[i+20>>2])){break ua}e=f&255;if(!e){break ua}LN(p,e)}k=k+1|0;continue}}break}k=P()|0;O()|0;break f}k=P()|0;O()|0;break f}k=P()|0;O()|0;break f}k=P()|0;O()|0;break f}t[q+26|0]=1}fb:{if((ca|0)!=7){break fb}a=0;e=b+480188|0;while(1){if(x[e>>1]<=a>>>0){break fb}gb:{if(v[bf(v[r+8>>2],a)>>2]==-1){break gb}v[23540]=0;X(589,r|0,a&65535,d|0,-1);n=v[23540];v[23540]=0;if((n|0)!=1){break gb}k=P()|0;O()|0;break f}a=a+1|0;continue}}if(w[q+26|0]){u[q+20>>1]=x[l+72>>1];v[q+8>>2]=v[l+48>>2]}A[q>>3]=A[r+24>>3];v[23540]=0;R(584,$|0,q|0);a=v[23540];v[23540]=0;if((a|0)!=1){if(!aa){break a}if(!(M?w[q+26|0]:1)){break c}n=Ny(i+48|0);if(Qd(w[ha+24|0])){yN(n,ha)}Yy(ha);a=sc(b+1074376|0,l,614);f=0;while(1){if((f|0)==256){Lm(a+223848|0,l+223848|0);d=a+223860|0;f=w[d+24|0];e=l+223860|0;hb:{if((Qd(w[e+24|0])|0)==(f|0)){if(!f){break hb}f=jc(d);gt(d,v[f>>2]);v[d>>2]=v[e>>2];v[d+4>>2]=v[e+4>>2];v[d+8>>2]=v[e+8>>2];ib:{if(!v[Gb(d)>>2]){v[d>>2]=f;break ib}v[v[f>>2]+8>>2]=f;f=jc(e);v[e>>2]=f;v[f>>2]=0;Fa=Gb(e),Ga=0,v[Fa>>2]=Ga}d=d+12|0;f=jc(d);ft(d,v[f>>2]);e=e+12|0;v[d>>2]=v[e>>2];v[d+4>>2]=v[e+4>>2];v[d+8>>2]=v[e+8>>2];jb:{if(!v[Gb(d)>>2]){v[d>>2]=f;break jb}v[v[f>>2]+8>>2]=f;d=jc(e);v[e>>2]=d;v[d>>2]=0;Fa=Gb(e),Ga=0,v[Fa>>2]=Ga}break hb}if(f){Yy(d);break hb}yN(d,e)}}else{d=B(f,872);Vp((d+a|0)+616|0,(d+l|0)+616|0);f=f+1|0;continue}break}Xy(a);a=0;v[b+1074400>>2]=0;t[b+1074476|0]=1;d=b+1074392|0;v[d>>2]=-2;v[d+4>>2]=0;v[b+1074428>>2]=v[b+1074424>>2];kb:{lb:{d=v[b+1298300>>2];if(!zd(d)){break lb}v[23540]=0;Y(591,d|0);d=v[23540];v[23540]=0;if((d|0)!=1){break lb}break kb}while(1){if(x[b+480188>>1]<=a>>>0){a=bA(i+16|0);Fa=i,Ga=Gi(v[n+12>>2]),v[Fa+8>>2]=Ga;e=b+906300|0;p=xf(n+12|0);while(1){d=v[i+8>>2];if(!Hg(d,p)){mb:{p=250;d=a;nb:{while(1){if(p>>>0>=32){if(v[a>>2]){a=1;break nb}else{p=p-32|0;a=a+4|0;continue}}break}a=(v[d+28>>2]&67108863)!=0}if(!a){break mb}a=0;while(1){if((a|0)==250){break mb}Db(i,d,a);ob:{if(!Cb(v[v[i>>2]>>2],v[i+4>>2])){break ob}f=v[Md(e,a)>>2];g=v[v[f>>2]+180>>2];v[23540]=0;Y(g|0,f|0);f=v[23540];v[23540]=0;if((f|0)!=1){break ob}break kb}a=a+1|0;continue}}Fa=i,Ga=Gi(v[n>>2]),v[Fa>>2]=Ga;a=xf(n);while(1){d=v[i>>2];if(Hg(d,a)){d=vd(d);f=jc(d);Fa=Md(e,w[d|0]),Ia=z[f>>2],z[Fa+144>>2]=Ia;Kg(i);continue}else{Wp(n);break b}}}f=vd(d);N=Gb(f);pb:{g=w[f|0];d=v[Md(e,g)>>2];if(d){Db(i,a,g);if(!Cb(v[v[i>>2]>>2],v[i+4>>2])){v[23540]=0;Q(592,a|0,g|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break pb}g=v[v[d>>2]+176>>2];v[23540]=0;R(g|0,d|0,-1);g=v[23540];v[23540]=0;if((g|0)==1){break pb}}Ea=z[N>>2];f=v[f+4>>2];g=v[v[d>>2]+44>>2];v[23540]=0;Ba(g|0,d|0,f|0,C(Ea));d=v[23540];v[23540]=0;if((d|0)==1){break pb}}Kg(i+8|0);continue}break}break kb}d=B(a,872)+b|0;e=w[d+1075791|0];if(e){t[d+1075794|0]=e}d=bf(v[r+8>>2],a);if(!((ca|0)==7|w[d+5|0]==255)){t[i+16|0]=64;Fa=(B(a,872)+b|0)+1075680|0,Ga=w[Yb(d+5|0,i+16|0)|0]<<2,v[Fa>>2]=Ga}qb:{e=B(a,872)+b|0;d=v[e+1075096>>2];rb:{if(!d|!(w[d+35|0]&2)){break rb}f=v[b+1298300>>2];if(!zd(f)){break rb}v[23540]=0;ka=f;f=a&65535;U(593,ka|0,f|0,d+68|0);d=v[23540];v[23540]=0;if((d|0)==1){break qb}d=v[b+1298300>>2];v[23540]=0;U(594,d|0,f|0,1);d=v[23540];v[23540]=0;if((d|0)==1){break qb}}v[e+1075008>>2]=0;a=a+1|0;continue}break}}k=P()|0;O()|0;Wp(n);break f}k=P()|0;O()|0}kt(J)}KN(r)}Ei($);T(k|0);L()}if((c|0)==3){break b}v[b+1074416>>2]=v[b+480196>>2];v[b+1074420>>2]=v[b+480204>>2];v[b+1074456>>2]=v[b+480200>>2]}a=oa&255;if((a|0)==w[b+484376|0]){break a}Gj(na,a)}if(c&9){a=b+1298264|0;if(v[a>>2]){AO(a);b=v[a>>2];Xj(a);Mb(b);Fa=Gb(a),Ga=0,v[Fa>>2]=Ga;v[a>>2]=0;v[a+4>>2]=0}v[a>>2]=v[J>>2];v[a+4>>2]=v[J+4>>2];b=Gb(J);Fa=Gb(a),Ga=v[b>>2],v[Fa>>2]=Ga;v[b>>2]=0;v[J>>2]=0;v[J+4>>2]=0;a=a+12|0;c=jc(a);_p(a,v[c>>2]);b=J+12|0;v[a>>2]=v[b>>2];v[a+4>>2]=v[b+4>>2];v[a+8>>2]=v[b+8>>2];sb:{if(!v[Gb(a)>>2]){v[a>>2]=c;break sb}v[v[c>>2]+8>>2]=c;a=jc(b);v[b>>2]=a;v[a>>2]=0;Fa=Gb(b),Ga=0,v[Fa>>2]=Ga}}kt(J);KN(r);kb=i+192|0}function vS(a,b,c,d,e,f){var g=0,h=0,i=0,j=0,k=0,l=0,m=C(0),n=0,o=0,p=0,q=0,r=0,s=0,A=C(0),D=C(0),E=0,F=0,G=0,H=0,I=C(0),J=C(0),K=0,M=C(0),N=C(0),O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=C(0),_=C(0),$=0,ba=C(0),ca=C(0),da=0,ea=0,fa=C(0),ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0;U=kb-16|0;kb=U;a:{if(v[a+1420>>2]>=0){v[f>>2]=0;Q=v[a+1420>>2];d=(Q|0)>0?Q:0;while(1){if((d|0)!=(E|0)){v[(B(E,20)+a|0)+1436>>2]=0;E=E+1|0;continue}break}b:{c:{d:{if((Q|0)>3){break d}E=0;if((c|0)<4){break c}c=c-3|0;d=0;while(1){if((c|0)==(d|0)){break d}e:{f:{h=b+d|0;if(w[h|0]!=79){break f}if(Sb(h,93680,4)){break f}g=d+26|0;if((g|0)>=(c|0)){break e}j=d+27|0;i=b+g|0;f=w[i|0];if((j+f|0)>=(c|0)){break e}k=f+27|0;E=0;e=0;while(1)if((e|0)==(f|0)){e=0;while(1){f=22;if((E|0)!=22){e=jx(e,w[(d+E|0)+b|0]);E=E+1|0;continue}break}while(1){if((f|0)!=26){f=f+1|0;e=jx(e,0);continue}break}v[a+1420>>2]=Q+1;f=B(Q,20)+a|0;v[f+1432>>2]=e;v[f+1428>>2]=k-26;v[f+1424>>2]=w[h+22|0]|w[h+23|0]<<8|(w[h+24|0]<<16|w[h+25|0]<<24);e=w[(g+w[i|0]|0)+b|0]==255?-1:w[h+6|0]|w[h+7|0]<<8|(w[h+8|0]<<16|w[h+9|0]<<24);v[f+1436>>2]=g;v[f+1440>>2]=e;Q=v[a+1420>>2];if((Q|0)!=4){break f}Q=4;break d}else{k=w[(e+j|0)+b|0]+k|0;e=e+1|0;continue}}d=d+1|0;continue}break}c=d}d=0;g:while(1){i=(d|0)>(Q|0)?d:Q;while(1){if((d|0)==(i|0)){break b}E=0;f=B(d,20)+a|0;n=f+1428|0;h=v[n>>2];k=v[f+1436>>2];j=c-k|0;g=(h|0)<(j|0)?h:j;l=(g|0)>0?g:0;da=f+1432|0;e=v[da>>2];while(1){if((l|0)!=(E|0)){e=jx(e,w[(k+E|0)+b|0]);E=E+1|0;continue}break}v[n>>2]=h-g;v[da>>2]=e;if((h|0)<=(j|0)){h=e;e=f+1424|0;if((h|0)==v[e>>2]){v[a+1380>>2]=-1;v[a+992>>2]=0;v[a+1420>>2]=-1;b=v[(B(d,20)+a|0)+1440>>2];v[a+1060>>2]=b;v[a+1064>>2]=(b|0)!=-1;E=g+k|0;break c}f=Q-1|0;v[a+1420>>2]=f;f=B(f,20)+a|0;v[e+16>>2]=v[f+1440>>2];h=f+1432|0;g=v[h+4>>2];v[e+8>>2]=v[h>>2];v[e+12>>2]=g;f=f+1424|0;h=v[f+4>>2];v[e>>2]=v[f>>2];v[e+4>>2]=h;Q=v[a+1420>>2];continue g}else{d=d+1|0;continue}}}}c=E}break a}v[a+100>>2]=0;v[a+32>>2]=b;v[a+40>>2]=b+c;if(!mI(a)){v[f>>2]=0;c=0;break a}qa=U+12|0;da=kb-16|0;kb=da;v[a+1504>>2]=0;v[a+1508>>2]=0;h:{if(v[a+96>>2]){break h}i:{j:{k:{if(v[a+1380>>2]!=-1){break k}c=$e(a);if(v[a+96>>2]){break i}if((c|0)!=79){break j}if(($e(a)|0)!=103){break j}if(($e(a)|0)!=103){break j}if(($e(a)|0)!=83){break j}if(!lI(a)){break i}if(!(t[a+1375|0]&1)){break k}t[a+1376|0]=0;v[a+1384>>2]=0;ec(a,32);break i}k=gx(a);break i}ec(a,30)}if(!k){break h}if(oc(a,1)){ec(a,35);break h}s=da;l:{m:{if(!(v[a+84>>2]!=v[a+92>>2]?v[a+80>>2]:0)){c=oc(a,im(v[a+408>>2]-1|0));if((c|0)==-1|(c|0)>=v[a+408>>2]){break h}v[da+12>>2]=c;k=B(c,6)+a|0;if(!w[k+412|0]){h=v[a+112>>2];g=h>>1;break m}h=v[a+116>>2];g=h>>1;c=oc(a,1);j=oc(a,1);if(c|!w[k+412|0]){break m}v[U+4>>2]=h-v[a+112>>2]>>2;c=v[a+112>>2]+h>>2;break l}aa(6328,13179,3152,10753);L()}v[U+4>>2]=0;c=g}v[s+8>>2]=c;n:{if(!(!w[k+412|0]|j)){c=B(h,3);v[U+8>>2]=c-v[a+112>>2]>>2;h=c+v[a+112>>2]>>2;break n}v[U+8>>2]=g}v[da+4>>2]=h;h=1}if(h){E=v[U+4>>2];la=v[U+8>>2];ka=v[da+4>>2];O=kb-2368|0;kb=O;F=v[a+404>>2];oa=B(v[da+12>>2],6)+a|0;G=w[oa+413|0];R=F+B(G,40)|0;V=v[((w[oa+412|0]<<2)+a|0)+104>>2];ha=V>>1;sa=0-ha|0;o:{while(1){c=v[a+4>>2];if((c|0)>(n|0)){c=w[(v[R+4>>2]+B(n,3)|0)+2|0];P=(O+1344|0)+(n<<2)|0;v[P>>2]=0;h=w[(c+R|0)+9|0];if(!x[((h<<1)+a|0)+132>>1]){ec(a,21);c=0;break o}g=v[a+260>>2];p:{q:{if(!oc(a,1)){break q}c=2;k=v[((n<<2)+a|0)+996>>2];g=g+B(h,1596)|0;r=v[(w[g+1588|0]<<2)+72764>>2];h=im(r)-1|0;ta=k,ua=oc(a,h),u[ta>>1]=ua;ta=k,ua=oc(a,h),u[ta+2>>1]=ua;H=g+82|0;W=g+65|0;S=g+49|0;T=g+33|0;K=g+1|0;o=0;while(1){if(w[g|0]>o>>>0){p=w[o+K|0];q=w[p+S|0];l=-1<<q;X=w[p+T|0];r:{if(!q){i=0;break r}h=v[a+124>>2]+B(w[p+W|0],2096)|0;if(v[a+1396>>2]<=9){$k(a)}j=v[a+1392>>2];i=u[(h+((j&1023)<<1)|0)+36>>1];s:{if((i|0)>=0){s=j;i=i&65535;j=w[i+v[h+8>>2]|0];v[a+1392>>2]=s>>>j;j=v[a+1396>>2]-j|0;v[a+1396>>2]=(j|0)>0?j:0;i=(j|0)>=0?i:-1;break s}i=hm(a,h)}if(!w[h+23|0]){break r}i=v[v[h+2088>>2]+(i<<2)>>2]}ea=l^-1;h=c+X|0;while(1){if((c|0)!=(h|0)){l=0;j=u[(H+(p<<4)|0)+((i&ea)<<1)>>1];t:{if((j|0)<0){break t}j=v[a+124>>2]+B(j&65535,2096)|0;if(v[a+1396>>2]<=9){$k(a)}l=v[a+1392>>2];X=u[(j+((l&1023)<<1)|0)+36>>1];u:{if((X|0)>=0){s=l;X=X&65535;l=w[X+v[j+8>>2]|0];v[a+1392>>2]=s>>>l;l=v[a+1396>>2]-l|0;v[a+1396>>2]=(l|0)>0?l:0;l=(l|0)>=0?X:-1;break u}l=hm(a,j)}if(!w[j+23|0]){break t}l=v[v[j+2088>>2]+(l<<2)>>2]}i=i>>q;u[k+(c<<1)>>1]=l;c=c+1|0;continue}break}o=o+1|0;c=h;continue}break}if(v[a+1396>>2]==-1){break q}u[O+320>>1]=257;h=g+338|0;o=g+1088|0;c=2;while(1){l=v[g+1592>>2];if((l|0)<=(c|0)){c=0;while(1){if((c|0)>=(l|0)){break p}if(!w[(O+320|0)+c|0]){u[k+(c<<1)>>1]=65535;l=v[g+1592>>2]}c=c+1|0;continue}}else{j=c<<1;l=j+o|0;q=w[l|0];p=q<<1;i=x[p+h>>1];P=w[l+1|0];H=P<<1;W=u[k+p>>1];l=u[H+k>>1]-W|0;p=l>>31;i=(B((l^p)-p|0,x[h+j>>1]-i|0)|0)/(x[h+H>>1]-i|0)|0;l=W+((l|0)<0?0-i|0:i)|0;H=k+j|0;i=x[H>>1];v:{w:{if(i){j=O+320|0;t[j+P|0]=1;t[j+q|0]=1;t[c+j|0]=1;j=i<<16>>16;p=r-l|0;if((j|0)>=((l|0)>(p|0)?p:l)<<1){if((l|0)<(p|0)){break v}l=r+(i^-1)|0;break w}if(j&1){l=l-(j+1>>>1|0)|0;break w}l=(j>>1)+l|0;break w}t[(O+320|0)+c|0]=0}u[H>>1]=l}c=c+1|0;continue}}}v[P>>2]=1}n=n+1|0;continue}break}if(!(v[a+84>>2]!=v[a+92>>2]?v[a+80>>2]:0)){sc(O+320|0,O+1344|0,c<<2);g=x[R>>1];c=0;while(1){if((c|0)==(g|0)){c=F+B(G,40)|0}else{k=v[R+4>>2]+B(c,3)|0;h=w[k+1|0];l=O+1344|0;k=l+(w[k|0]<<2)|0;if(!(v[(h<<2)+l>>2]?v[k>>2]:0)){v[(O+1344|0)+(h<<2)>>2]=0;v[k>>2]=0}c=c+1|0;continue}break}X=c;i=0;while(1){x:{if(w[X+8|0]>i>>>0){l=0;c=v[a+4>>2];k=(c|0)>0?c:0;c=0;while(1){if((c|0)==(k|0)){break x}if(w[(v[R+4>>2]+B(c,3)|0)+2|0]==(i|0)){h=l+O|0;g=c<<2;y:{if(v[g+(O+1344|0)>>2]){g=0;n=1;break y}g=v[(a+g|0)+800>>2];n=0}t[h|0]=n;v[(O+256|0)+(l<<2)>>2]=g;l=l+1|0}c=c+1|0;continue}}if(!(v[a+84>>2]!=v[a+92>>2]?v[a+80>>2]:0)){k=(ha|0)>0?ha:0;h=x[R>>1];g=a+800|0;z:while(1){if((h|0)<=0){P=ha<<2;l=0;c=0;while(1){i=v[a+4>>2];if((i|0)<=(c|0)){while(1){if((i|0)>(l|0)){P=w[oa+412|0];R=V>>1;h=R<<2;X=v[a+92>>2];p=V>>3;W=V>>2;k=v[((l<<2)+a|0)+800>>2];c=R<<2;G=k+c|0;A:{if(v[a+80>>2]){j=Hn(a,h);break A}j=Pd(h)}h=(j+c|0)-8|0;g=v[((P<<2)+a|0)+1068>>2];i=g;c=k;while(1){if((c|0)!=(G|0)){z[h+4>>2]=C(z[c>>2]*z[i>>2])-C(z[i+4>>2]*z[c+8>>2]);z[h>>2]=C(z[c>>2]*z[i+4>>2])+C(z[c+8>>2]*z[i>>2]);c=c+16|0;i=i+8|0;h=h-8|0;continue}break}c=((R<<2)+k|0)-12|0;while(1){if(h>>>0>=j>>>0){z[h+4>>2]=C(z[c>>2]*z[i+4>>2])-C(z[c+8>>2]*z[i>>2]);z[h>>2]=C(C(-z[c+8>>2])*z[i+4>>2])-C(z[i>>2]*z[c>>2]);c=c-16|0;i=i+8|0;h=h-8|0;continue}break}c=W<<2;o=c+k|0;h=c+j|0;i=(g+(R<<2)|0)-32|0;c=j;n=k;while(1){if(g>>>0<=i>>>0){m=z[c>>2];A=z[h>>2];D=z[h+4>>2];I=z[c+4>>2];z[o+4>>2]=D+I;z[o>>2]=z[h>>2]+z[c>>2];D=C(D-I);m=C(A-m);z[n+4>>2]=C(D*z[i+16>>2])-C(z[i+20>>2]*m);z[n>>2]=C(m*z[i+16>>2])+C(D*z[i+20>>2]);m=z[c+8>>2];A=z[h+8>>2];D=z[h+12>>2];I=z[c+12>>2];z[o+12>>2]=D+I;z[o+8>>2]=z[h+8>>2]+z[c+8>>2];D=C(D-I);m=C(A-m);z[n+12>>2]=C(D*z[i>>2])-C(z[i+4>>2]*m);z[n+8>>2]=C(m*z[i>>2])+C(D*z[i+4>>2]);c=c+16|0;h=h+16|0;n=n+16|0;o=o+16|0;i=i-32|0;continue}break}h=im(V);c=V>>4;n=R-1|0;i=0-p|0;hI(c,k,n,i,g);hI(c,k,n-W|0,i,g);H=V>>5;c=0-c|0;up(H,k,n,c,g,16);up(H,k,n-p|0,c,g,16);up(H,k,n-(p<<1)|0,c,g,16);up(H,k,n+B(p,-3)|0,c,g,16);c=h-4>>1;o=(c|0)>2?c:2;c=2;while(1){B:{C:{D:{if((c|0)==(o|0)){c=h-7|0;ea=(c|0)<(o|0)?o:c;break D}i=0;p=2<<c;p=(p|0)>0?p:0;r=8<<c;q=V>>c+4;F=V>>c+2;S=0-(F>>1)|0;while(1){if((i|0)==(p|0)){break C}up(q,k,n-B(i,F)|0,S,g,r);i=i+1|0;continue}}while(1){E:{if((o|0)!=(ea|0)){r=2<<o;S=8<<o;ma=S<<2;i=V>>o+6;Y=V>>o+2;$=0-(Y>>1)|0;h=n;c=g;while(1){if((i|0)<=0){break E}p=r;F=(h<<2)+k|0;q=F+($<<2)|0;T=B(S,12)+c|0;m=z[T>>2];K=(S<<3)+c|0;A=z[K>>2];s=(S<<2)+c|0;D=z[s>>2];I=z[T+4>>2];M=z[K+4>>2];Z=z[s+4>>2];_=z[c+4>>2];fa=z[c>>2];T=0-Y<<2;while(1){if((p|0)>0){K=q-4|0;N=z[K>>2];ba=z[F>>2];ca=z[q>>2];z[F>>2]=ba+ca;s=F-4|0;J=z[s>>2];z[s>>2]=J+z[K>>2];J=C(J-N);N=C(ba-ca);z[K>>2]=C(J*fa)+C(_*N);z[q>>2]=C(N*fa)-C(_*J);K=q-12|0;ba=z[K>>2];s=F-8|0;J=z[s>>2];ia=s;s=q-8|0;ca=z[s>>2];z[ia>>2]=J+ca;ga=F-12|0;N=z[ga>>2];z[ga>>2]=N+z[K>>2];N=C(N-ba);J=C(J-ca);z[K>>2]=C(N*D)+C(Z*J);z[s>>2]=C(J*D)-C(Z*N);K=q-20|0;ba=z[K>>2];s=F-16|0;J=z[s>>2];ia=s;s=q-16|0;ca=z[s>>2];z[ia>>2]=J+ca;ga=F-20|0;N=z[ga>>2];z[ga>>2]=N+z[K>>2];N=C(N-ba);J=C(J-ca);z[K>>2]=C(N*A)+C(M*J);z[s>>2]=C(J*A)-C(M*N);K=q-28|0;ba=z[K>>2];s=F-24|0;J=z[s>>2];ia=s;s=q-24|0;ca=z[s>>2];z[ia>>2]=J+ca;ga=F-28|0;N=z[ga>>2];z[ga>>2]=N+z[K>>2];N=C(N-ba);J=C(J-ca);z[K>>2]=C(N*m)+C(I*J);z[s>>2]=C(J*m)-C(I*N);p=p-1|0;q=q+T|0;F=F+T|0;continue}break}i=i-1|0;h=h-8|0;c=(ma<<2)+c|0;continue}}c=(n<<2)+k|0;i=c-(H<<6)|0;m=z[g+(V>>3<<2)>>2];fa=C(-m);while(1){if(c>>>0>i>>>0){M=z[c>>2];h=c-32|0;Z=z[h>>2];z[c>>2]=M+Z;g=c-4|0;A=z[g>>2];n=g;g=c-36|0;_=z[g>>2];z[n>>2]=A+_;n=c-8|0;D=z[n>>2];s=n;n=c-40|0;J=z[n>>2];z[s>>2]=D+J;p=c-12|0;I=z[p>>2];s=p;p=c-44|0;N=z[p>>2];z[s>>2]=I+N;z[h>>2]=M-Z;z[g>>2]=A-_;g=c-16|0;A=z[g>>2];s=g;g=c-48|0;ba=z[g>>2];z[s>>2]=A+ba;D=C(D-J);I=C(I-N);z[n>>2]=m*C(D+I);z[p>>2]=m*C(I-D);n=c-28|0;D=z[n>>2];p=c-60|0;I=z[p>>2];r=c-24|0;M=z[r>>2];o=c-56|0;Z=z[o>>2];q=c-20|0;_=z[q>>2];s=q;q=c-52|0;J=z[q>>2];z[s>>2]=_+J;z[r>>2]=M+Z;z[n>>2]=D+I;z[g>>2]=_-J;z[q>>2]=-C(A-ba);A=C(D-I);D=C(M-Z);z[o>>2]=m*C(A-D);z[p>>2]=C(D+A)*fa;gI(c);gI(h);c=c+-64|0;continue}break}p=R-4|0;h=j+(p<<2)|0;i=(j+(W<<2)|0)-16|0;c=v[((P<<2)+a|0)+1100>>2];while(1){if(i>>>0>=j>>>0){g=(x[c>>1]<<2)+k|0;z[h+12>>2]=z[g>>2];z[h+8>>2]=z[g+4>>2];z[i+12>>2]=z[g+8>>2];z[i+8>>2]=z[g+12>>2];g=(x[c+2>>1]<<2)+k|0;z[h+4>>2]=z[g>>2];z[h>>2]=z[g+4>>2];z[i+4>>2]=z[g+8>>2];z[i>>2]=z[g+12>>2];c=c+4|0;h=h-16|0;i=i-16|0;continue}break}c=v[((P<<2)+a|0)+1084>>2];i=j;h=i+(R<<2)|0;g=h;while(1){n=g-16|0;if(n>>>0>i>>>0){m=z[i+4>>2];r=g-4|0;A=z[r>>2];D=C(m-A);I=z[c+4>>2];m=C(m+A);A=z[i>>2];o=g-8|0;M=z[o>>2];Z=C(A-M);_=z[c>>2];fa=C(C(I*m)-C(Z*_));z[i+4>>2]=D+fa;A=C(A+M);m=C(C(I*Z)+C(m*_));z[i>>2]=A+m;z[r>>2]=fa-D;z[o>>2]=A-m;m=z[i+8>>2];A=z[n>>2];D=C(m+A);I=z[c+12>>2];m=C(m-A);A=z[i+12>>2];g=g-12|0;M=z[g>>2];Z=C(A+M);_=z[c+8>>2];fa=C(C(I*m)+C(Z*_));z[i+8>>2]=D+fa;A=C(A-M);m=C(C(I*Z)-C(m*_));z[i+12>>2]=A+m;z[n>>2]=D-fa;z[g>>2]=m-A;i=i+16|0;c=c+16|0;g=n;continue}break}i=v[((P<<2)+a|0)+1076>>2]+(R<<2)|0;c=(p<<2)+k|0;g=((V<<2)+k|0)-16|0;while(1){n=h-32|0;if(n>>>0>=j>>>0){m=z[h-8>>2];A=z[i-4>>2];D=z[i-8>>2];I=z[h-4>>2];M=C(C(m*A)-C(D*I));z[k>>2]=M;z[c+12>>2]=-M;m=C(C(D*C(-m))-C(A*I));z[G>>2]=m;z[g+12>>2]=m;m=z[h-16>>2];A=z[i-12>>2];D=z[i-16>>2];I=z[h-12>>2];M=C(C(m*A)-C(D*I));z[k+4>>2]=M;z[c+8>>2]=-M;m=C(C(D*C(-m))-C(A*I));z[G+4>>2]=m;z[g+8>>2]=m;m=z[h-24>>2];A=z[i-20>>2];D=z[i-24>>2];I=z[h-20>>2];M=C(C(m*A)-C(D*I));z[k+8>>2]=M;z[c+4>>2]=-M;m=C(C(D*C(-m))-C(A*I));z[G+8>>2]=m;z[g+4>>2]=m;m=z[n>>2];A=z[i-28>>2];i=i-32|0;D=z[i>>2];I=z[h-28>>2];M=C(C(m*A)-C(D*I));z[k+12>>2]=M;z[c>>2]=-M;m=C(C(D*C(-m))-C(A*I));z[G+12>>2]=m;z[g>>2]=m;g=g-16|0;c=c-16|0;G=G+16|0;k=k+16|0;h=n;continue}break}if(!v[a+80>>2]){Mb(j)}v[a+92>>2]=X;break B}o=o+1|0;continue}}c=c+1|0;continue}break}l=l+1|0;i=v[a+4>>2];continue}break}}else{h=c<<2;g=h+a|0;i=v[g+800>>2];F:{if(v[h+(O+320|0)>>2]){Ub(i,0,P);break F}F=v[g+996>>2];G:{h=w[(R+w[(v[R+4>>2]+B(c,3)|0)+2|0]|0)+9|0];if(!x[((h<<1)+a|0)+132>>1]){ec(a,21);break G}n=V>>1;p=v[a+260>>2]+B(h,1596)|0;H=p+338|0;W=p+838|0;k=B(w[p+1588|0],u[F>>1]);o=1;h=0;while(1){if(v[p+1592>>2]>(o|0)){g=w[o+W|0]<<1;j=u[g+F>>1];if((j|0)>=0){j=B(w[p+1588|0],j&65535);g=x[g+H>>1];if((g|0)!=(h|0)){q=j-k|0;r=g-h|0;G=(q|0)/(r|0)|0;H:{S=(g|0)<(n|0)?g:n;if((S|0)<=(h|0)){break H}s=q;q=q>>31;T=G>>31;T=((s^q)-q|0)-B(r,(T^G)-T|0)|0;K=q|1;q=i+(h<<2)|0;z[q>>2]=z[((k&255)<<2)+72784>>2]*z[q>>2];S=S-1|0;q=0;while(1){if((h|0)==(S|0)){break H}h=h+1|0;X=i+(h<<2)|0;q=q+T|0;ea=(q|0)<(r|0);k=(k+G|0)+(ea?0:K)|0;z[X>>2]=z[((k&255)<<2)+72784>>2]*z[X>>2];q=q-(ea?0:r)|0;continue}}h=g}k=j}o=o+1|0;continue}break}if((h|0)>=(n|0)){break G}g=(k<<2)+72784|0;while(1){if((h|0)==(n|0)){break G}k=i+(h<<2)|0;z[k>>2]=z[g>>2]*z[k>>2];h=h+1|0;continue}}}c=c+1|0;continue}break}kI(a);I:{if(w[a+1377|0]){v[a+1060>>2]=sa;t[a+1377|0]=0;v[a+1064>>2]=1;v[a+1412>>2]=V-ka;break I}c=v[a+1412>>2];if(!c){break I}h=la-E|0;if((h|0)<=(c|0)){v[a+1412>>2]=c-h;v[U+4>>2]=la;E=la;break I}E=c+E|0;v[U+4>>2]=E;v[a+1412>>2]=0}c=v[a+1064>>2];J:{K:{L:{M:{if(v[a+1388>>2]==v[a+1404>>2]){N:{if(!c|!(w[a+1375|0]&4)){break N}c=v[a+1408>>2];h=v[a+1060>>2];if(c>>>0>=h+(ka-E|0)>>>0){break N}h=c-h|0;c=(c>>>0<h>>>0?0:h)+E|0;c=(c|0)<(ka|0)?c:ka;v[qa>>2]=c;v[a+1060>>2]=c+v[a+1060>>2];break K}v[a+1064>>2]=1;c=v[a+1408>>2]+(E-ha|0)|0;break M}if(!c){break L}c=v[a+1060>>2]}v[a+1060>>2]=c+(la-E|0)}if(v[a+84>>2]!=v[a+92>>2]?v[a+80>>2]:0){break J}v[qa>>2]=ka}c=1;break o}aa(6328,13179,3451,5637);L()}h=h-1|0;c=v[R+4>>2]+B(h,3)|0;j=v[g+(w[c+1|0]<<2)>>2];i=v[g+(w[c|0]<<2)>>2];c=0;while(1){if((c|0)==(k|0)){continue z}n=c<<2;l=n+j|0;D=z[l>>2];n=i+n|0;m=z[n>>2];O:{if(m>C(0)){if(D>C(0)){A=C(m-D);break O}A=m;m=C(m+D);break O}if(D>C(0)){A=C(m+D);break O}A=m;m=C(m-D)}z[n>>2]=m;z[l>>2]=A;c=c+1|0;continue}}}aa(6328,13179,3335,5637);L()}W=O+256|0;n=0;q=kb-16|0;kb=q;G=v[a+4>>2];F=v[a+396>>2];o=w[(i+X|0)+24|0];p=F+B(o,24)|0;h=v[p+4>>2];ea=x[((o<<1)+a|0)+268>>1];c=ha<<((ea|0)==2);g=c>>>0>h>>>0?h:c;h=v[p>>2];P=(g-(c>>>0>h>>>0?h:c)>>>0)/y[p+8>>2]|0;k=P<<2;c=B(G,k+4|0);K=v[v[a+124>>2]+B(w[p+13|0],2096)>>2];ga=v[a+92>>2];P:{if(v[a+80>>2]){h=Hn(a,c);G=v[a+4>>2];break P}h=Pd(c)}j=(l|0)>0?l:0;H=ha<<2;g=0;c=(G|0)>0?G:0;r=(G<<2)+h|0;while(1){if((c|0)!=(g|0)){v[(g<<2)+h>>2]=r;g=g+1|0;r=k+r|0;continue}break}k=h;c=0;while(1){if((c|0)!=(j|0)){if(!w[c+O|0]){Ub(v[W+(c<<2)>>2],0,H)}c=c+1|0;continue}break}Q:{if(!((l|0)==1|(ea|0)!=2)){c=0;while(1){R:{if((c|0)!=(j|0)){if(w[c+O|0]){break R}}else{c=j}if((c|0)==(l|0)){break Q}r=F+B(o,24)|0;G=(l|0)!=2;F=(l|0)<3;while(1){if((n|0)==8){break Q}S:{if(!G){h=0;o=0;while(1){if((o|0)>=(P|0)){break S}c=v[p>>2]+B(v[p+8>>2],o)|0;v[q+12>>2]=c&1;v[q+8>>2]=c>>1;c=0;if(!n){j=v[a+124>>2]+B(w[p+13|0],2096)|0;if(v[a+1396>>2]<=9){$k(a)}g=v[a+1392>>2];H=u[(j+((g&1023)<<1)|0)+36>>1];T:{if((H|0)>=0){s=g;H=H&65535;g=w[H+v[j+8>>2]|0];v[a+1392>>2]=s>>>g;g=v[a+1396>>2]-g|0;v[a+1396>>2]=(g|0)>0?g:0;g=(g|0)>=0?H:-1;break T}g=hm(a,j)}g=w[j+23|0]?v[v[j+2088>>2]+(g<<2)>>2]:g;if((g|0)==-1){break Q}v[v[k>>2]+(h<<2)>>2]=v[v[r+16>>2]+(g<<2)>>2]}while(1){if(!((c|0)>=(K|0)|(o|0)>=(P|0))){g=v[p+8>>2];j=u[(v[r+20>>2]+(w[v[v[k>>2]+(h<<2)>>2]+c|0]<<4)|0)+(n<<1)>>1];U:{if((j|0)>=0){if(iI(a,v[a+124>>2]+B(j&65535,2096)|0,W,2,q+12|0,q+8|0,ha,g)){break U}break Q}g=v[p>>2]+(g+B(g,o)|0)|0;v[q+8>>2]=g>>1;v[q+12>>2]=g&1}o=o+1|0;c=c+1|0;continue}break}h=h+1|0;continue}}if(F){break S}h=0;o=0;while(1){if((o|0)>=(P|0)){break S}g=v[p>>2]+B(v[p+8>>2],o)|0;c=(g|0)/(l|0)|0;v[q+12>>2]=g-B(c,l);v[q+8>>2]=c;c=0;if(!n){j=v[a+124>>2]+B(w[p+13|0],2096)|0;if(v[a+1396>>2]<=9){$k(a)}g=v[a+1392>>2];H=u[(j+((g&1023)<<1)|0)+36>>1];V:{if((H|0)>=0){s=g;H=H&65535;g=w[H+v[j+8>>2]|0];v[a+1392>>2]=s>>>g;g=v[a+1396>>2]-g|0;v[a+1396>>2]=(g|0)>0?g:0;g=(g|0)>=0?H:-1;break V}g=hm(a,j)}g=w[j+23|0]?v[v[j+2088>>2]+(g<<2)>>2]:g;if((g|0)==-1){break Q}v[v[k>>2]+(h<<2)>>2]=v[v[r+16>>2]+(g<<2)>>2]}while(1){if(!((c|0)>=(K|0)|(o|0)>=(P|0))){g=v[p+8>>2];j=u[(v[r+20>>2]+(w[v[v[k>>2]+(h<<2)>>2]+c|0]<<4)|0)+(n<<1)>>1];W:{if((j|0)>=0){if(!iI(a,v[a+124>>2]+B(j&65535,2096)|0,W,l,q+12|0,q+8|0,ha,g)){break Q}break W}g=v[p>>2]+(g+B(g,o)|0)|0;j=(g|0)/(l|0)|0;v[q+8>>2]=j;v[q+12>>2]=g-B(j,l)}o=o+1|0;c=c+1|0;continue}break}h=h+1|0;continue}}n=n+1|0;continue}}c=c+1|0;continue}}ma=F+B(o,24)|0;l=0;while(1){if((l|0)==8){break Q}n=0;S=0;X:while(1){if((n|0)<(P|0)){h=0;c=0;Y:{if(l){break Y}while(1){if((c|0)==(j|0)){break Y}if(!w[c+O|0]){r=v[a+124>>2]+B(w[p+13|0],2096)|0;if(v[a+1396>>2]<=9){$k(a)}g=v[a+1392>>2];o=u[(r+((g&1023)<<1)|0)+36>>1];Z:{if((o|0)>=0){s=g;o=o&65535;g=w[o+v[r+8>>2]|0];v[a+1392>>2]=s>>>g;g=v[a+1396>>2]-g|0;v[a+1396>>2]=(g|0)>0?g:0;g=(g|0)>=0?o:-1;break Z}g=hm(a,r)}g=w[r+23|0]?v[v[r+2088>>2]+(g<<2)>>2]:g;if((g|0)==-1){break Q}v[v[k+(c<<2)>>2]+(S<<2)>>2]=v[v[ma+16>>2]+(g<<2)>>2]}c=c+1|0;continue}}while(1){_:{$:{if((h|0)>=(K|0)){break $}c=0;if((n|0)>=(P|0)){break $}while(1){if((c|0)==(j|0)){break _}aa:{if(w[c+O|0]){break aa}g=c<<2;r=u[(v[ma+20>>2]+(w[v[v[g+k>>2]+(S<<2)>>2]+h|0]<<4)|0)+(l<<1)>>1];if((r|0)<0){break aa}G=v[a+124>>2]+B(r&65535,2096)|0;Y=v[g+W>>2];T=v[p+8>>2];H=v[p>>2]+B(T,n)|0;ba:{ca:{if(ea){F=0;while(1){g=1;if((F|0)>=(T|0)){break ba}$=Y+(H<<2)|0;g=T-F|0;o=0;m=C(0);da:{s=fI(a,G);if((s|0)<0){break da}r=v[G>>2];g=(g|0)>(r|0)?r:g;s=B(r,s);if(w[G+22|0]){r=0;g=(g|0)>0?g:0;o=1;while(1){if((g|0)==(r|0)){break da}ja=$+(r<<2)|0;m=C(m+z[v[G+28>>2]+(r+s<<2)>>2]);z[ja>>2]=z[ja>>2]+m;r=r+1|0;m=C(m+z[G+12>>2]);continue}}r=0;g=(g|0)>0?g:0;o=1;while(1){if((g|0)==(r|0)){break da}ja=$+(r<<2)|0;z[ja>>2]=z[ja>>2]+C(z[v[G+28>>2]+(r+s<<2)>>2]+C(0));r=r+1|0;continue}}if(!o){break ca}g=v[G>>2];H=g+H|0;F=g+F|0;continue}}F=0;r=(T|0)/v[G>>2]|0;s=(r|0)>0?r:0;ja=Y+(H<<2)|0;g=1;while(1){if((F|0)==(s|0)){break ba}o=F+H|0;Y=F<<2;F=F+1|0;ia=Y+ja|0;Y=T-o|0;$=0;m=C(0);ea:{na=fI(a,G);if((na|0)<0){break ea}o=0;$=v[G>>2];Y=(Y|0)>($|0)?$:Y;Y=(Y|0)>0?Y:0;na=B($,na);$=1;while(1){if((o|0)==(Y|0)){break ea}ra=(B(o,r)<<2)+ia|0;A=C(m+z[v[G+28>>2]+(o+na<<2)>>2]);z[ra>>2]=z[ra>>2]+A;m=w[G+22|0]?A:m;o=o+1|0;continue}}if($){continue}break}}g=0}if(!g){break Q}}c=c+1|0;continue}}S=S+1|0;continue X}n=n+1|0;h=h+1|0;continue}}break}l=l+1|0;continue}}if(!v[a+80>>2]){Mb(k)}v[a+92>>2]=ga;kb=q+16|0;i=i+1|0;continue}}aa(6328,13179,3302,5637);L()}kb=O+2368|0}else{c=0}kb=da+16|0;if(!c){fa:{ga:{ha:{c=v[a+100>>2];switch(c-32|0){case 0:break ga;case 3:break ha;default:break fa}}v[a+100>>2]=0;while(1){if(ta=0,ua=(wh(a)|0)!=-1,va=v[a+96>>2],va?ta:ua){continue}break}v[f>>2]=0;c=v[a+32>>2]-b|0;break a}if(v[a+992>>2]){break fa}v[a+100>>2]=0;while(1){if(ta=0,ua=(wh(a)|0)!=-1,va=v[a+96>>2],va?ta:ua){continue}break}v[f>>2]=0;c=v[a+32>>2]-b|0;break a}v[a+1420>>2]=0;v[a+992>>2]=0;v[a+1504>>2]=0;v[a+1508>>2]=0;v[a+1412>>2]=0;v[a+1416>>2]=0;t[a+1377|0]=0;v[a+1064>>2]=0;v[a+100>>2]=c;v[f>>2]=0;c=1;break a}g=v[U+12>>2];j=v[U+4>>2];h=v[U+8>>2];ia:{ja:{k=v[a+992>>2];if(k){i=k<<1;ka:{if((i|0)==v[a+112>>2]){c=a+1092|0}else{c=0;if((i|0)!=v[a+116>>2]){break ka}c=a+1096|0}c=v[c>>2]}if(!c){break ja}n=(k|0)>0?k:0;while(1){if(v[a+4>>2]>(Q|0)){i=(Q<<2)+a|0;E=0;while(1){if((n|0)!=(E|0)){l=v[i+800>>2]+(j+E<<2)|0;s=l;A=z[l>>2];l=E<<2;z[s>>2]=C(A*z[l+c>>2])+C(z[l+v[i+928>>2]>>2]*z[c+(k+(E^-1)<<2)>>2]);E=E+1|0;continue}break}Q=Q+1|0;continue}break}Q=v[a+992>>2]}v[a+992>>2]=g-h;k=(g|0)<(h|0);i=(k?h:g)-h|0;while(1){if(v[a+4>>2]>(pa|0)){c=(pa<<2)+a|0;E=0;while(1){if((i|0)!=(E|0)){z[v[c+928>>2]+(E<<2)>>2]=z[v[c+800>>2]+(h+E<<2)>>2];E=E+1|0;continue}break}pa=pa+1|0;continue}break}if(!Q){break ja}c=(k?g:h)-j|0;v[a+1416>>2]=c+v[a+1416>>2];break ia}c=0}h=c;v[U+12>>2]=c;c=0;g=v[a+4>>2];k=(g|0)>0?g:0;while(1){if((c|0)!=(k|0)){i=(c<<2)+a|0;v[i+864>>2]=v[i+800>>2]+(j<<2);c=c+1|0;continue}break}if(d){v[d>>2]=g}v[f>>2]=h;v[e>>2]=a+864;c=v[a+32>>2]-b|0}kb=U+16|0;return c}function tga(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,z=0,A=0,C=0,D=0,E=0,F=0,G=0,H=0;d=kb-1760|0;kb=d;zc(b);f=kb-16|0;kb=f;h=d+1632|0;RR(f+8|0,h);g=v[f+12>>2];k=b;nc(f,v[b>>2],v[b+8>>2],v[f+8>>2],v[f+12>>2]);b=v[f+4>>2];if((b|0)==(g|0)){$b(k,v[f+12>>2])}kb=f+16|0;b=(b|0)==(g|0);if(!b){QR(h)}a:{if(!b){break a}if(!SR(d+1632|0)){break a}if(!Qb(v[k>>2],v[k+8>>2],Ec(256,0))){break a}b:{if(!c){break b}Cd(a,1048576);ag(a);b=kb-16|0;kb=b;e=yc(b,4233);ad(d+1376|0,e);Ab(e);kb=b+16|0;b=x[d+1640>>1];v[d+160>>2]=b>>>8;v[23540]=0;v[d+16>>2]=b&255;R(433,d+88|0,d+16|0);b=v[23540];v[23540]=0;c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{if((b|0)!=1){v[23540]=0;X(419,d+272|0,d+1376|0,d+160|0,d+88|0);b=v[23540];v[23540]=0;if((b|0)==1){break m}b=d+272|0;Jb(a+1298344|0,b);Ab(b);e=d+88|0;Ab(e);f=d+1376|0;dc(f);g=yc(b,15165);Jb(a+1298356|0,g);Ab(g);Ne(e,2,d+1642|0);Fc(f,e);v[23540]=0;U(11,b|0,8,f|0);b=v[23540];v[23540]=0;if((b|0)==1){break i}b=d+272|0;Jb(a+1298368|0,b);Ab(b);e=d+1376|0;zb(e);v[a+1298404>>2]=8;cA(e,2,d+1674|0);Fc(b,e);Bc(a+1298308|0,b);zb(b);u[a+480188>>1]=x[d+1744>>1];f=w[d+1748|0];v[a+480204>>2]=125e4;v[a+480208>>2]=32792;G=a,H=Ed(f,1,31),v[G+480196>>2]=H;u[a+480192>>1]=x[d+1754>>1];u[a+480190>>1]=x[d+1756>>1];f=Ed(w[d+1749|0],1,32);v[a+480216>>2]=f;v[a+480228>>2]=96;v[a+480232>>2]=48;v[a+480220>>2]=f<<2;dv(k,e);f=a+484360|0;g=a+484376|0;Xq(Wb(v[f>>2],w[g|0]),e,x[d+1738>>1],65535,65535);Ve(Wb(v[f>>2],w[g|0]),x[d+1740>>1]);p=Rg(k);ae(b,k,p?274:0);A=kc(d+1352|0,b);Bb(b);v[23540]=0;b=S(157,k|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break k}v[23540]=0;U(190,d+272|0,k|0,b|0);b=v[23540];v[23540]=0;if((b|0)==1){break k}b=d+272|0;s=kc(d+1328|0,b);Bb(b);b=a+480188|0;o=x[b>>1];if(p){u[b>>1]=o+8}z=c&1;if(!z){break j}v[23540]=0;R(225,a+484344|0,x[d+1742>>1]);b=v[23540];v[23540]=0;if((b|0)!=1){break j}g=P()|0;O()|0;break e}g=P()|0;O()|0;break l}g=P()|0;O()|0;Ab(d+88|0)}dc(d+1376|0);break c}g=P()|0;O()|0;break d}q=a+484344|0;C=a+480188|0;g=0;while(1){n:{o:{p:{q:{r:{s:{if(x[d+1742>>1]<=r>>>0){b=x[d+1746>>1];if((b-2&65535)>>>0>=4998){break q}if(!(g&1)){break s}i=0;b=Hc(((b>>>1|0)+11025e5>>>0)/(b>>>0)|0,0);break r}v[23540]=0;b=S(194,k|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break f}v[d+160>>2]=b;v[23540]=0;b=S(157,k|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break g}v[23540]=0;U(190,d+88|0,k|0,b+1&-2);b=v[23540];v[23540]=0;if((b|0)==1){break g}b=d+88|0;m=kc(d+272|0,b);Bb(b);xc(d+160|0,1024);if(!z){break o}l=v[d+160>>2];if(!l){break o}v[23540]=0;b=W(226,q|0,r&65535,l|0)|0;e=v[23540];v[23540]=0;if((e|0)!=1){if(!b){break o}h=0;e=0;if(t[d+1750|0]&1){break p}t:while(1){if((h|0)==(l|0)){break o}e=0;b=_b(v[q>>2],r);b=Cf(v[b>>2],v[v[b+48>>2]+12>>2],h);while(1){if((e|0)==(o|0)){h=h+1|0;continue t}v[23540]=0;R(601,m|0,d+88|0);f=v[23540];v[23540]=0;if((f|0)!=1){g=PR(b+B(e,6)|0,d+88|0)|g;e=e+1|0;continue}break}break}break h}break h}i=2;b=Qe(2646e3/+(B(b,B(v[a+480216>>2],v[a+480196>>2]))>>>0)*1e4)}t[a+480224|0]=i;v[a+480204>>2]=b}h=a+480188|0;b=x[h>>1];v[23540]=0;t[d+272|0]=0;r=W(602,d+1312|0,b|0,d+272|0)|0;b=v[23540];v[23540]=0;if((b|0)!=1){i=a+1298320|0;l=a+1298332|0;n=a+484348|0;m=0;u:{v:{w:{x:{y:{z:{while(1){b=v[s+8>>2];e=v[s>>2];v[23540]=0;b=W(156,e|0,b|0,8)|0;e=v[23540];v[23540]=0;A:{if((e|0)!=1){if(b){break A}f=a+906300|0;g=v[r>>2];h=0;i=a+480188|0;while(1){e=x[i>>1];if(e>>>0<=h>>>0){v[d+264>>2]=0;v[d+268>>2]=0;v[d+256>>2]=0;v[d+260>>2]=0;v[d+248>>2]=0;v[d+252>>2]=0;v[d+240>>2]=0;v[d+244>>2]=0;B:{C:{if(!p){break C}e=0;v[23540]=0;R(603,A|0,d+272|0);b=v[23540];v[23540]=0;if((b|0)==1){break B}while(1){if((e|0)==8){e=0;v[23540]=0;h=Q(218,d+224|0,x[d+272>>1])|0;b=v[23540];v[23540]=0;if((b|0)!=1){D:{E:{F:{G:{while(1){if(x[d+272>>1]<=e>>>0){v[23540]=0;l=W(604,d+208|0,x[d+1742>>1],26988)|0;b=v[23540];v[23540]=0;if((b|0)==1){break E}j=a+484376|0;z=a+484348|0;C=a+480188|0;f=0;break F}v[23540]=0;b=S(194,k|0)|0;f=v[23540];v[23540]=0;if((f|0)!=1){v[23540]=0;U(190,d+160|0,k|0,b<<5);b=v[23540];v[23540]=0;if((b|0)==1){break G}f=d+160|0;b=kc(d+88|0,f);hd(Ng(v[h>>2],e),b);Bb(b);e=e+1|0;Bb(f);continue}break}g=P()|0;O()|0;break D}g=P()|0;O()|0;break D}while(1){if(x[d+1738>>1]<=f>>>0){od(l);Vc(h);break C}H:{g=d+f|0;e=w[g+290|0];if(e>>>0>=x[d+272>>1]){break H}b=x[cc(v[Wb(v[a+484360>>2],w[j|0])>>2],f)>>1];if(b>>>0>=x[d+1742>>1]){break H}I:{i=cc(v[l>>2],b);n=x[i>>1];J:{if((n|0)==65535){u[i>>1]=e;break J}if((e|0)==(n|0)){break J}v[23540]=0;e=Q(605,q|0,b|0)|0;i=v[23540];v[23540]=0;if((i|0)==1){break I}if((e|0)==65535){break J}G=cc(v[Wb(v[a+484360>>2],w[j|0])>>2],f),H=e,u[G>>1]=H;b=e}if(!xe(v[a+484344>>2],v[z>>2],b)){break H}p=Ng(v[h>>2],w[g+290|0]);zc(p);e=v[p>>2];v[23540]=0;e=S(160,e|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break I}D=e>>>5|0;i=0;K:while(1){e=_b(v[q>>2],b);if(y[e+12>>2]<=i>>>0){break H}g=0;e=jd(v[e>>2],v[v[e+48>>2]+12>>2],i,x[C>>1]-8&65535);while(1){if((g|0)==8){i=i+1|0;continue K}Fj(d+88|0);n=x[d+92>>1];t[e+4|0]=n;t[e+5|0]=n>>>8;n=v[d+88>>2];t[e|0]=n;t[e+1|0]=n>>>8;t[e+2|0]=n>>>16;t[e+3|0]=n>>>24;L:{if(i>>>0>=D>>>0){break L}v[23540]=0;Q(606,p|0,d+88|0)|0;n=v[23540];v[23540]=0;if((n|0)==1){break I}if(t[d+88|0]>=0){break L}t[e|0]=61;t[e+1|0]=w[(d+256|0)+(g<<1)|0];n=w[d+88|0]&31;t[d+160|0]=n;if(n){wf(d+160|0,15);t[e+3|0]=20;t[e+5|0]=w[d+160|0]|208}t[e+2|0]=1;t[e+4|0]=w[d+89|0]+3>>>2}e=e+6|0;g=g+1|0;continue}}}g=P()|0;O()|0;od(l);break D}f=f+1|0;continue}}g=P()|0;O()|0}Vc(h);break u}g=P()|0;O()|0;break u}f=e<<1;g=f+(d+256|0)|0;b=x[a+480192>>1]+1&65535;h=x[v[a+8>>2]+58>>1];while(1){M:{N:{i=b&65535;if(i>>>0<=h>>>0){if(v[((i<<2)+a|0)+900380>>2]){break N}}else{b=65535}b=b&65535;break M}b=b+1|0;continue}break}u[g>>1]=b;h=f+(d+240|0)|0;f=x[(d+f|0)+274>>1];u[h>>1]=f;O:{if((b|0)!=65535){v[23540]=0;b=W(251,a|0,b|0,f+1&65535)|0;f=v[23540];v[23540]=0;P:{Q:{if((f|0)!=1){if(!b){break O}v[23540]=0;R(286,d+160|0,4478);f=v[23540];v[23540]=0;if((f|0)==1){break Q}v[23540]=0;v[d+16>>2]=e+1;U(607,d+88|0,d+160|0,d+16|0);f=v[23540];v[23540]=0;if((f|0)==1){break P}f=b+492|0;b=d+88|0;Dc(f,b);zb(b);Xb(d+160|0);break O}g=P()|0;O()|0;break u}g=P()|0;O()|0;break u}g=P()|0;O()|0;Xb(d+160|0);break u}u[g>>1]=0}e=e+1|0;continue}}R:{S:{b=x[d+1750>>1]|x[d+1752>>1]<<16;if(!(b&2)){break S}b=(((b&8?x[a+480188>>1]:o)&65535)+(x[d+1640>>1]>591?m:0)|0)+(b>>>4&1)|0;f=0;T:while(1){e=0;if(x[d+1742>>1]<=f>>>0){break S}while(1){U:{if((b|0)!=(e|0)){g=v[k+8>>2];h=v[k>>2];v[23540]=0;g=W(156,h|0,g|0,4)|0;h=v[23540];v[23540]=0;if((h|0)==1){break R}if(g){break U}}f=f+1|0;continue T}v[23540]=0;R(608,x[d+1640>>1],k|0);g=v[23540];v[23540]=0;if((g|0)==1){break R}e=e+1|0;continue}}}v[23540]=0;q=Q(218,d+192|0,255)|0;b=v[23540];v[23540]=0;if((b|0)!=1){n=a+480208|0;f=0;while(1){V:{b=f;W:{if((b|0)==255){m=bA(d+88|0);l=bA(d+160|0);g=0;while(1){X:{Y:{Z:{if((g|0)==256){h=0;break Z}v[23540]=0;R(609,k|0,d+272|0);b=v[23540];v[23540]=0;if((b|0)==1){break Y}v[23540]=0;b=S(157,k|0)|0;e=v[23540];v[23540]=0;_:{$:{aa:{if((e|0)!=1){v[23540]=0;U(190,d+16|0,k|0,b|0);e=v[23540];v[23540]=0;if((e|0)==1){break aa}e=d+16|0;h=kc(d- -64|0,e);Bb(e);if(x[d+1756>>1]>g>>>0){e=d+48|0;Ne(e,2,d+272|0);v[23540]=0;R(222,d+16|0,e|0);e=v[23540];v[23540]=0;if((e|0)==1){break _}e=d+16|0;Dc(((g<<5)+a|0)+946336|0,e);zb(e)}if(!b){break X}if(x[d+1756>>1]>g>>>0){break $}break X}g=P()|0;O()|0;break W}g=P()|0;O()|0;break W}v[23540]=0;b=B(g+1|0,104)+a|0;e=b+484380|0;R(277,e|0,32);f=v[23540];v[23540]=0;ba:{ca:{da:{if((f|0)!=1){No(e);v[23540]=0;R(610,h|0,d+16|0);f=v[23540];v[23540]=0;if((f|0)==1){break _}f=v[d+16>>2];v[e>>2]=f;v[b+484404>>2]=v[d+20>>2];if(w[d+24|0]>=2){i=b+484414|0;u[i>>1]=x[i>>1]|1;f=f>>>1|0;v[e>>2]=f}if(w[d+25|0]>=2){i=b+484414|0;u[i>>1]=x[i>>1]|64;v[e>>2]=f>>>1}i=2;switch(w[d+27|0]-1|0){case 0:break ca;case 1:break da;default:break ba}}break _}i=6}e=b+484414|0;u[e>>1]=x[e>>1]|i}v[b+484384>>2]=v[d+28>>2];v[b+484388>>2]=v[d+32>>2];u[b+484410>>1]=x[d+36>>1]>>>7;e=w[d+38|0];ea:{if((e|0)==128){e=b+484414|0;f=x[e>>1]|256;u[e>>1]=f;break ea}u[b+484408>>1]=(e<<24>>24)+128;f=x[b+484414>>1]}i=b+484414|0;u[i>>1]=f|32;t[b+484416|0]=w[d+39|0];e=w[d+26|0];if(e&2){b=d+48|0;Db(b,l,g);qo(b);e=w[d+26|0]}if(e&5){u[i>>1]=x[i>>1]|16384}if(!(e&8)){break X}b=d+48|0;Db(b,m,g);qo(b);e=0;while(1){if((e|0)==8){break X}b=e<<1;fa:{if(x[b+(d+240|0)>>1]!=(g|0)){break fa}b=v[((x[b+(d+256|0)>>1]<<2)+a|0)+900380>>2];if(!b){break fa}t[b+14|0]=0}e=e+1|0;continue}}g=P()|0;O()|0;Bb(h);break W}while(1){ga:{ha:{if(x[d+1754>>1]<=h>>>0){if(!(c&2)){break ha}e=a+1298404|0;f=a+1298464|0;g=0;ia:{ja:{ka:{la:{ma:{na:{oa:{pa:{while(1){if(x[a+480190>>1]<=g>>>0){break ha}g=g+1|0;c=B(g,104)+a|0;h=c+484380|0;b=c+484416|0;zl(h,(+(t[b|0]-49|0)+ +t[c+484417|0]*-.0078125)/-12);u[b>>1]=0;b=x[c+484414>>1];if(!(b&16384)){b=Zc(d+272|0,b&1?16:8,b&64?3:1,0,11);v[23540]=0;W(219,b|0,h|0,k|0)|0;b=v[23540];v[23540]=0;if((b|0)!=1){continue}g=P()|0;O()|0;break W}v[23540]=0;h=S(157,k|0)|0;b=v[23540];v[23540]=0;qa:{if((b|0)==1){break qa}v[23540]=0;Q(188,k|0,12)|0;b=v[23540];v[23540]=0;if((b|0)==1){break qa}b=Nb(d+272|0);v[23540]=0;U(268,k|0,b|0,h|0);h=v[23540];v[23540]=0;if((h|0)==1){break pa}Be(c+484423|0,b);v[23540]=0;R(374,d- -64|0,16451);c=v[23540];v[23540]=0;if((c|0)==1){break oa}v[d+12>>2]=g;c=v[e>>2];v[23540]=0;U(11,d+48|0,c|0,b|0);c=v[23540];v[23540]=0;if((c|0)==1){break na}v[23540]=0;X(419,d+16|0,d- -64|0,d+12|0,d+48|0);c=v[23540];v[23540]=0;if((c|0)==1){break ma}c=v[f>>2];v[23540]=0;U(376,c|0,2,d+16|0);c=v[23540];v[23540]=0;if((c|0)==1){break la}Ab(d+16|0);Ab(d+48|0);dc(d- -64|0);zb(b);continue}break}g=P()|0;O()|0;break W}g=P()|0;O()|0;break ia}g=P()|0;O()|0;break ia}g=P()|0;O()|0;break ja}g=P()|0;O()|0;break ka}g=P()|0;O()|0;Ab(d+16|0)}Ab(d+48|0)}dc(d- -64|0)}zb(b);break W}b=v[Ng(v[q>>2],h)>>2];v[23540]=0;b=S(160,b|0)|0;e=v[23540];v[23540]=0;ra:{sa:{if((e|0)!=1){if(!b){h=h+1|0;continue}b=Ng(v[q>>2],h);zc(b);v[23540]=0;R(611,b|0,d+272|0);b=v[23540];v[23540]=0;if((b|0)==1){break sa}i=Tb(d+16|0);v[23540]=0;U(612,k|0,i|0,x[d+272>>1]);b=v[23540];v[23540]=0;if((b|0)==1){break ra}h=h+1|0;b=v[((h<<2)+a|0)+900380>>2];if(!b|w[b+34|0]){break ga}v[b+4>>2]=32;e=0;cu(b,0);n=b+108|0;j=b+236|0;while(1){if((e|0)==96){break ga}f=w[(d+e|0)+274|0];ta:{if(f>>>0>=x[d+272>>1]){break ta}g=bf(v[i>>2],f);p=e+12|0;z=cc(j,p);f=w[g|0];o=f+1|0;u[z>>1]=o;if(f>>>0>=x[a+480190>>1]){break ta}f=B(o,104)+a|0;t[f+484418|0]=w[d+370|0]&3;t[f+484419|0]=w[d+371|0];t[f+484420|0]=w[d+372|0];t[f+484421|0]=w[d+373|0];u[f+484412>>1]=w[g+1|0]<<1;t[f+484417|0]=w[g+2|0];f=o-1|0;Db(d- -64|0,m,f);if(Cb(v[v[d+64>>2]>>2],v[d+68>>2])){t[b+14|0]=0}Db(d- -64|0,l,f);if(!Cb(v[v[d+64>>2]>>2],v[d+68>>2])){break ta}G=Lb(n,p),H=61,t[G|0]=H}e=e+1|0;continue}}g=P()|0;O()|0;break W}g=P()|0;O()|0;break W}g=P()|0;O()|0;qe(i);break W}Vc(q);ic(r);Bb(s);Bb(A);break b}qe(i);continue}}g=P()|0;O()|0;break W}Bb(h);g=g+1|0;continue}}v[23540]=0;R(609,k|0,d+160|0);e=v[23540];v[23540]=0;ua:{va:{wa:{xa:{if((e|0)!=1){v[23540]=0;e=S(157,k|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break xa}v[23540]=0;e=(e|0)==32?428:e;h=e?x[d+1640>>1]>513?e+4|0:e:e;U(190,d+88|0,k|0,h|0);e=v[23540];v[23540]=0;if((e|0)==1){break wa}g=d+88|0;e=kc(d+272|0,g);i=je(d+16|0,hd(Ng(v[q>>2],b),e));Bb(e);f=b+1|0;Bb(g);if(b>>>0>=x[d+1754>>1]){break V}v[23540]=0;b=f&65535;g=W(251,a|0,b|0,b|0)|0;b=v[23540];v[23540]=0;if((b|0)!=1){break va}break ua}g=P()|0;O()|0;break W}g=P()|0;O()|0;break W}g=P()|0;O()|0;break W}if(!g){break V}b=d+88|0;Ne(b,2,d+160|0);v[23540]=0;R(222,d+272|0,b|0);b=v[23540];v[23540]=0;ya:{if((b|0)!=1){b=d+272|0;Dc(g+492|0,b);zb(b);if(!h){break V}v[23540]=0;R(611,i|0,d+272|0);b=v[23540];v[23540]=0;if((b|0)!=1){m=3;h=0;if(x[d+1640>>1]<513){l=0;break ya}v[23540]=0;l=S(194,i|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break ua}if(x[d+1640>>1]<514){break ya}v[23540]=0;m=S(157,i|0)|0;b=v[23540];v[23540]=0;if((b|0)!=1){break ya}break ua}break ua}break ua}v[g>>2]=x[d+374>>1];t[g+16|0]=w[(x[d+376>>1]&3)+26990|0];t[g+17|0]=w[(w[d+377|0]&3)+26990|0];t[g+18|0]=w[(x[d+376>>1]>>>12&3)+26994|0];while(1){za:{Aa:{if((h|0)==4){if(!(t[g+60|0]&1|w[g+16|0]==3)){v[g>>2]=32767}Mj(g,127,1);Lj(g,0,1);if(!l){break V}v[23540]=0;R(613,i|0,d+88|0);b=v[23540];v[23540]=0;if((b|0)==1){break ua}if(l&2){Mj(g,cB(v[n>>2],+x[d+90>>1]),1);Lj(g,w[d+92|0],1)}t[g+25|0]=w[d+89|0]==1;if(!(l&4)){break V}t[g+31|0]=w[d+95|0]+1;b=t[d+96|0];t[g+34|0]=b+1;if((b|0)<0){t[g+30|0]=w[d+103|0]+1}if(!w[d+100|0]){break Aa}h=g+108|0;e=0;while(1){if((e|0)==128){break Aa}b=e+1|0;v[d+64>>2]=b+t[d+100|0];MR(d- -64|0);G=Lb(h,e),H=v[d+64>>2],t[G|0]=H;e=b;continue}}if(!(m&1)){break za}v[23540]=0;R(614,i|0,d+88|0);b=v[23540];v[23540]=0;Ba:{if((b|0)!=1){b=Ih(g,w[h+26998|0]);Ca:{if((h|0)!=3){e=w[d+88|0];o=w[b+12|0]&-17;break Ca}e=w[d+88|0];o=e<<4&16|w[b+12|0]&-17}t[b+12|0]=e>>>1&2|(e<<1&4|(o&248|e&1));t[d+64|0]=w[d+89|0];t[d+48|0]=16;e=w[Yb(d- -64|0,d+48|0)|0];v[23540]=0;R(291,b|0,e|0);e=v[23540];v[23540]=0;if((e|0)==1){break Ba}e=w[d+90|0];t[b+15|0]=e;t[b+16|0]=e;t[b+13|0]=w[d+91|0];t[b+14|0]=w[d+92|0];e=0;o=v[b>>2];j=$d(o,v[b+4>>2]);while(1){if((e|0)==(j|0)){break za}p=Eb(o,e);b=(d+88|0)+(e<<2)|0;u[p>>1]=w[b+8|0]|w[b+9|0]<<8;G=p,H=Ed(w[b+10|0]|w[b+11|0]<<8,0,64),t[G+2|0]=H;e=e+1|0;continue}}break ua}break ua}cu(g,0);break V}h=h+1|0;m=m>>>1|0;continue}}g=P()|0;O()|0;Bb(i)}Vc(q);break u}Bb(i);continue}}g=P()|0;O()|0;break u}g=P()|0;O()|0;break u}g=P()|0;O()|0;break u}else{b=t[Lb(g,h)|0];Da:{if((b|0)<=(h|0)|(b|0)>=(e|0)){break Da}b=w[((b<<5)+a|0)+480288|0];if(!b){break Da}e=((h<<5)+a|0)+480288|0;l=w[e|0];if(!l){t[e|0]=b;break Da}e=l-1|0;while(1){l=Md(f,e&255);e=_m(v[l+28>>2]);if((e|0)!=255){continue}break}b=b-1&255;v[l+28>>2]=b>>>0<250?b+128|0:0}h=h+1|0;continue}}}g=P()|0;O()|0;break u}v[23540]=0;f=S(157,s|0)|0;b=v[23540];v[23540]=0;Ea:{Fa:{Ga:{Ha:{Ia:{Ja:{Ka:{La:{Ma:{if((b|0)!=1){v[23540]=0;b=S(157,s|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break Ma}v[23540]=0;U(190,d+272|0,s|0,b|0);b=v[23540];v[23540]=0;if((b|0)==1){break Ma}e=d+272|0;b=kc(d+88|0,e);Bb(e);if((f|0)==4674381){break Ia}if((f|0)==5068115){break Ha}if((f|0)==726487106){break La}if((f|0)==844387158){break Ga}e=0;if((f|0)==1280004692){break Ka}if((f|0)==1314144592){break Ja}if((f|0)!=1397445204){break Fa}v[23540]=0;e=S(194,b|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break w}e=e>>>0<256?48:e>>>8|0;v[a+480228>>2]=e;v[a+480232>>2]=e>>>1;e=0;while(1){if(x[h>>1]<=e>>>0){break Fa}v[23540]=0;f=Q(615,b|0,d+272|0)|0;j=v[23540];v[23540]=0;if((j|0)==1){break z}if(f){u[((e<<5)+a|0)+480286>>1]=x[d+272>>1]>>>10;G=Lb(v[r>>2],e),H=w[d+275|0],t[G|0]=H}e=e+1|0;continue}}g=P()|0;O()|0;break u}g=P()|0;O()|0;break u}if(g&1){break Fa}t[a+480224|0]=2;v[23540]=0;E=+la(616,b|0);e=v[23540];v[23540]=0;if((e|0)==1){break Ea}if(!(E>1e-8)){break Fa}G=a,H=Qe(2646e3/(E*+(B(v[a+480216>>2],v[a+480196>>2])>>>0))*1e4),v[G+480204>>2]=H;break Fa}while(1){Na:{if(x[h>>1]<=e>>>0){break Fa}f=v[b>>2];v[23540]=0;f=W(156,f|0,v[d+96>>2],1)|0;j=v[23540];v[23540]=0;if((j|0)==1){break y}if(!f){break Fa}f=Nb(d+272|0);v[23540]=0;U(350,b|0,f|0,-1);j=v[23540];v[23540]=0;if((j|0)!=1){j=d+16|0;cg(j,3,Mc(f),Hb(f));v[23540]=0;R(222,d+160|0,j|0);j=v[23540];v[23540]=0;if((j|0)==1){break Na}j=d+160|0;El(((e<<5)+a|0)+480289|0,j);zb(j);zb(f);e=e+1|0;continue}}break}g=P()|0;O()|0;zb(f);break v}while(1){if(x[d+1742>>1]<=e>>>0){break Fa}f=v[b>>2];v[23540]=0;f=W(156,f|0,v[d+96>>2],1)|0;j=v[23540];v[23540]=0;if((j|0)==1){break x}if(!f){break Fa}if(!Sm(v[a+484344>>2],v[n>>2],e&65535)){break Fa}f=Nb(d+272|0);v[23540]=0;U(350,b|0,f|0,-1);j=v[23540];v[23540]=0;Oa:{if((j|0)==1){break Oa}j=v[q>>2];v[23540]=0;R(281,_b(j,e)|0,f|0);j=v[23540];v[23540]=0;if((j|0)==1){break Oa}zb(f);e=e+1|0;continue}break}g=P()|0;O()|0;zb(f);break v}v[23540]=0;Q(188,b|0,1)|0;e=v[23540];v[23540]=0;if((e|0)==1){break w}v[23540]=0;e=S(202,b|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break w}v[23540]=0;X(331,l|0,b|0,e|0,2);e=v[23540];v[23540]=0;if((e|0)!=1){break Fa}break w}v[23540]=0;Q(617,b|0,d+16|0)|0;e=v[23540];v[23540]=0;Pa:{if((e|0)!=1){e=Nb(d+272|0);v[23540]=0;U(350,b|0,e|0,-1);f=v[23540];v[23540]=0;if((f|0)==1){break Pa}if(Aq(e,12603)){v[23540]=0;U(11,d+160|0,8,e|0);f=v[23540];v[23540]=0;if((f|0)==1){break Pa}f=d+160|0;Jb(i,f);Ab(f)}zb(e);break Fa}g=P()|0;O()|0;break v}g=P()|0;O()|0;zb(e);break v}v[23540]=0;m=S(157,b|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break w}}Bb(b);continue}break}g=P()|0;O()|0;break v}g=P()|0;O()|0;break v}g=P()|0;O()|0;break v}g=P()|0;O()|0;break v}g=P()|0;O()|0}Bb(b)}ic(r);break e}g=P()|0;O()|0;break e}while(1){b=v[m>>2];v[23540]=0;b=W(156,b|0,v[d+280>>2],1)|0;f=v[23540];v[23540]=0;Qa:{if((f|0)!=1){if(!b){break o}v[23540]=0;i=S(206,m|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break h}n=0;if((i|0)!=255){break Qa}v[23540]=0;n=S(206,m|0)|0;b=v[23540];v[23540]=0;if((b|0)!=1){v[23540]=0;i=S(206,m|0)|0;b=v[23540];v[23540]=0;if((b|0)!=1){break Qa}}break h}break h}if(i&127){b=_b(v[q>>2],r);f=jd(v[b>>2],v[v[b+48>>2]+12>>2],e,h&65535);Qu(d+88|0);if(i&1){v[23540]=0;b=S(206,m|0)|0;j=v[23540];v[23540]=0;if((j|0)==1){break n}t[d+88|0]=b}if(i&2){v[23540]=0;b=S(206,m|0)|0;j=v[23540];v[23540]=0;if((j|0)==1){break n}t[d+89|0]=b}if(i&4){v[23540]=0;b=S(206,m|0)|0;j=v[23540];v[23540]=0;if((j|0)==1){break n}t[d+90|0]=b}if(i&8){v[23540]=0;b=S(206,m|0)|0;j=v[23540];v[23540]=0;if((j|0)==1){break n}t[d+91|0]=b}if(i&16){v[23540]=0;b=S(206,m|0)|0;j=v[23540];v[23540]=0;if((j|0)==1){break n}t[d+92|0]=b}if(i&32){v[23540]=0;b=S(206,m|0)|0;j=v[23540];v[23540]=0;if((j|0)==1){break n}t[d+93|0]=b}if(i&64){v[23540]=0;b=S(206,m|0)|0;i=v[23540];v[23540]=0;if((i|0)==1){break n}t[d+94|0]=b}D=PR(f,d+88|0);v[d+16>>2]=n;v[d+64>>2]=l+(e^-1);F=v[Kb(d+16|0,d- -64|0)>>2];i=0;b=f;while(1){if((i|0)!=(F|0)){b=B(x[C>>1],6)+b|0;j=w[f|0]|w[f+1|0]<<8|(w[f+2|0]<<16|w[f+3|0]<<24);t[b|0]=j;t[b+1|0]=j>>>8;t[b+2|0]=j>>>16;t[b+3|0]=j>>>24;j=w[f+4|0]|w[f+5|0]<<8;t[b+4|0]=j;t[b+5|0]=j>>>8;i=i+1|0;continue}break}g=g|D}e=(e+n|0)+1|0;while(1){if(e>>>0>=l>>>0){h=h+1|0;e=e-l|0;continue}break}if(o>>>0>(h&65535)>>>0){continue}break}}Bb(m);r=r+1|0;continue}break}break h}g=P()|0;O()|0;zb(d+1376|0);break c}g=P()|0;O()|0;Bb(m);break e}g=P()|0;O()|0;break e}g=P()|0;O()|0}Bb(s)}Bb(A)}T(g|0);L()}e=1}kb=d+1760|0;return e|0}function lja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,z=0,A=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=kb-1184|0;kb=d;zc(b);e=kb-16|0;kb=e;g=d+944|0;YT(e+8|0,g);m=v[e+12>>2];nc(e,v[b>>2],v[b+8>>2],v[e+8>>2],v[e+12>>2]);j=v[e+4>>2];if((j|0)==(m|0)){$b(b,v[e+12>>2])}kb=e+16|0;e=(j|0)==(m|0);if(!e){XT(g)}a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{if(!e){break o}if(!_T(d+944|0)){break o}if(!Qb(v[b>>2],v[b+8>>2],Ec(ZT(v[d+948>>2]),nb))){break o}if(!c){f=1;break o}Cd(a,16777216);ag(a);e=a+480208|0;v[e>>2]=v[e>>2]|16809984;f=d+480|0;yq(f,32);m=v[d+492>>2];e=a+1074320|0;v[e>>2]=v[d+488>>2];v[e+4>>2]=m;e=v[d+484>>2];v[a+1074312>>2]=v[d+480>>2];v[a+1074316>>2]=e;Ob(Ob(a+1074312|0,57,w[d+947|0]>5),114,1);e=zo(d+896|0);H=e,I=Ed(w[d+1144|0],1,31),v[H+12>>2]=I;H=e,I=Ed(w[d+1145|0],1,12)-1|0,v[H+16>>2]=I;H=e,I=Ib(x[d+1146>>1])-1900|0,v[H+20>>2]=I;GB(a+1298408|0,e);u[a+480188>>1]=32;e=d+376|0;WT(e,3,d+1148|0);m=d+56|0;Fc(m,e);v[23540]=0;U(11,f|0,1,m|0);e=v[23540];v[23540]=0;p:{q:{if((e|0)!=1){e=d+480|0;Jb(a+1298368|0,e);Ab(e);zb(d+56|0);r:{if(w[d+947|0]<=5){Sf(d+56|0,3927);break r}e=kb-16|0;kb=e;f=yc(e,3996);ad(d+56|0,f);Ab(f);kb=e+16|0}v[23540]=0;U(362,d+480|0,d+56|0,w[d+947|0]);e=v[23540];v[23540]=0;if((e|0)==1){break q}e=d+480|0;Jb(a+1298344|0,e);Ab(e);f=d+56|0;dc(f);m=yc(e,15169);Jb(a+1298356|0,m);Ab(m);v[a+1298404>>2]=12;Ne(f,3,d+952|0);Fc(e,f);Bc(a+1298308|0,e);zb(e);v[a+480228>>2]=256;v[a+480200>>2]=384/(x[a+480188>>1]+3>>>0);if(w[d+947|0]>5){break p}H=d,I=Ib(x[d+1172>>1]),u[H+480>>1]=I;u[d+56>>1]=1;e=d+480|0;f=d+56|0;H=a,I=x[ke(e,f)>>1],v[H+480196>>2]=I;H=d,I=Ib(x[d+1174>>1]),u[H+480>>1]=I;u[d+56>>1]=1;H=a,I=B(x[ke(e,f)>>1],1e4),v[H+480204>>2]=I;H=d,I=Ec(((Ib(x[d+1176>>1])<<8)+2047>>>0)/4095|0,0),v[H+480>>2]=I;v[d+56>>2]=256;H=a,I=v[Kb(e,f)>>2],v[H+480200>>2]=I;H=d,I=Ib(x[d+1178>>1]),u[H+480>>1]=I;Ef(e,127);f=0;e=x[d+480>>1];while(1){if((e|0)==(f|0)){break p}H=d,I=Ec(((Hj(b)<<8)+2047>>>0)/4095|0,0),u[H+56>>1]=I;u[d+376>>1]=256;H=((f<<5)+a|0)+480284|0,I=x[Wc(d+56|0,d+376|0)>>1],u[H>>1]=I;f=f+1|0;continue}}a=P()|0;O()|0;zb(d+56|0);break a}a=P()|0;O()|0;dc(d+56|0);break a}dd(b,bc(v[d+948>>2]));m=je(d+872|0,b);v[23540]=0;R(366,d+856|0,m|0);b=v[23540];v[23540]=0;s:{t:{u:{v:{w:{x:{y:{z:{A:{B:{C:{D:{E:{F:{G:{H:{I:{J:{K:{L:{if((b|0)!=1){v[23540]=0;U(367,d+480|0,d+856|0,1346458707);b=v[23540];v[23540]=0;if((b|0)==1){break H}v[23540]=0;b=W(156,v[d+480>>2],v[d+488>>2],2)|0;e=v[23540];v[23540]=0;if((e|0)==1){break K}if(!b){break I}v[23540]=0;b=S(271,d+480|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break K}if((b-1&65535)>>>0>126){break I}u[a+480188>>1]=b;b=d+480|0;Bb(b);v[23540]=0;U(367,b|0,d+856|0,1397706311);b=v[23540];v[23540]=0;if((b|0)!=1){break L}a=P()|0;O()|0;break c}a=P()|0;O()|0;break b}v[23540]=0;b=W(156,v[d+480>>2],v[d+488>>2],2)|0;e=v[23540];v[23540]=0;if((e|0)==1){break G}if(!b){break I}v[23540]=0;b=S(271,d+480|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break G}u[d+56>>1]=b;b=w[a+484376|0];e=v[a+484360>>2];v[23540]=0;f=S(271,d+480|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break G}Ve(Wb(e,b),f);v[23540]=0;b=S(202,d+480|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break G}Ef(d+56|0,Al(b>>>1|0));b=w[a+484376|0];e=v[a+484360>>2];v[23540]=0;U(274,Wb(e,b)|0,d+480|0,x[d+56>>1]);b=v[23540];v[23540]=0;if((b|0)==1){break G}b=d+480|0;Bb(b);v[23540]=0;U(367,b|0,d+856|0,1480806221);b=v[23540];v[23540]=0;if((b|0)!=1){break J}a=P()|0;O()|0;break c}a=P()|0;O()|0;Bb(d+480|0);break c}v[23540]=0;b=W(156,v[d+480>>2],v[d+488>>2],3)|0;e=v[23540];v[23540]=0;if((e|0)!=1){if(b){break F}b=160;while(1){M:{f=b;if(!b){f=0;break M}b=f-1|0;if(w[(d+b|0)+984|0]==32){continue}}break}v[23540]=0;X(337,a+1298332|0,d+984|0,f|0,4);b=v[23540];v[23540]=0;if((b|0)!=1){break E}break D}break D}Bb(d+480|0);f=0;break s}a=P()|0;O()|0;break c}a=P()|0;O()|0;Bb(d+480|0);break c}v[23540]=0;b=S(271,d+480|0)|0;e=v[23540];v[23540]=0;if((e|0)!=1){v[23540]=0;X(331,a+1298332|0,d+480|0,b|0,4);b=v[23540];v[23540]=0;if((b|0)!=1){break E}}break D}b=d+480|0;Bb(b);v[23540]=0;U(367,b|0,d+856|0,1413697073);b=v[23540];v[23540]=0;if((b|0)==1){break C}v[23540]=0;b=S(206,d+480|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break A}if(b){break B}v[23540]=0;b=Q(155,d+480|0,2648)|0;e=v[23540];v[23540]=0;if((e|0)==1){break A}if(!b){break B}f=0;v[23540]=0;b=S(279,d+480|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break A}while(1){if((f|0)==32){break B}e=((f<<5)+a|0)+480280|0;v[e>>2]=v[e>>2]&-1025|!(b>>>f&1)<<10;f=f+1|0;continue}}a=P()|0;O()|0;Bb(d+480|0);break c}a=P()|0;O()|0;break c}b=d+480|0;Bb(b);v[23540]=0;U(367,b|0,d+856|0,1413697074);b=v[23540];v[23540]=0;if((b|0)==1){break z}v[23540]=0;b=W(156,v[d+480>>2],v[d+488>>2],12)|0;e=v[23540];v[23540]=0;if((e|0)==1){break y}N:{if(!b){break N}v[23540]=0;R(368,d+56|0,d+480|0);b=v[23540];v[23540]=0;if((b|0)==1){break y}b=d+56|0;e=Te(b);f=jc(b);g=VT(b);j=Gb(b);n=UT(b);e=B(Ed(Ib(w[e|0]|w[e+1|0]<<8),32,999),1e4);b=Jka(Ib(w[f|0]|w[f+1|0]<<8),0,1e4,0)+32768|0;f=nb;f=b>>>0<32768?f+1|0:f;H=a,I=e+((Ec((f&65535)<<16|b>>>16,f>>>16|0)>>>0)%1e4|0)|0,v[H+480204>>2]=I;H=a,I=Ed(Ib(w[g|0]|w[g+1|0]<<8),1,255),v[H+480196>>2]=I;b=16/(Ed(Ib(w[n|0]|w[n+1|0]<<8),1,16)>>>0)|0;v[a+480216>>2]=b;H=a,I=B(Ed(Ib(w[j|0]|w[j+1|0]<<8),1,16),b),v[H+480220>>2]=I;if(!Ib(x[d+56>>1])){break N}v[23540]=0;b=S(271,d+480|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break y}e=a+480208|0;v[e>>2]=v[e>>2]&-17|!b<<4}b=d+480|0;Bb(b);v[23540]=0;U(367,b|0,d+856|0,1414942540);b=v[23540];v[23540]=0;if((b|0)==1){break x}v[23540]=0;b=W(156,v[d+480>>2],v[d+488>>2],2)|0;e=v[23540];v[23540]=0;if((e|0)==1){break v}if(!b){break w}v[23540]=0;b=S(271,d+480|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break v}u[d+56>>1]=b;u[d+376>>1]=x[a+480188>>1];b=x[Wc(d+56|0,d+376|0)>>1];f=0;while(1){if((b|0)==(f|0)){break w}v[23540]=0;e=S(271,d+480|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break v}u[d+56>>1]=e;u[d+376>>1]=4096;H=((f<<5)+a|0)+480286|0,I=x[Wc(d+56|0,d+376|0)>>1]>>>6&255,u[H>>1]=I;f=f+1|0;continue}}a=P()|0;O()|0;Bb(d+480|0);break c}a=P()|0;O()|0;break c}a=P()|0;O()|0;Bb(d+480|0);break c}a=P()|0;O()|0;break c}Bb(d+480|0);v[23540]=0;U(367,d+56|0,d+856|0,1296652368);b=v[23540];v[23540]=0;if((b|0)==1){break u}v[23540]=0;b=W(156,v[d+56>>2],v[d+64>>2],56)|0;e=v[23540];v[23540]=0;if((e|0)==1){break d}if(!b){break t}v[23540]=0;R(369,d+56|0,d+480|0);b=v[23540];v[23540]=0;if((b|0)==1){break d}if((Ib(x[d+514>>1])|0)!=4){break t}if((Ib(x[d+528>>1])|0)!=257){break t}H=d,I=Ib(x[d+520>>1]),u[H+376>>1]=I;u[d+840>>1]=16384;e=x[Wc(d+376|0,d+840|0)>>1];b=e>>>24|0;e=(e<<8)+2048|0;b=e>>>0<2048?b+1|0:b;H=a,I=Ec((b&4095)<<20|e>>>12,b>>>12|0),v[H+480200>>2]=I;g=a+480188|0;f=0;while(1){if(Ib(x[d+518>>1])>>>0<=(f&65535)>>>0){break t}v[23540]=0;R(370,d+56|0,d+376|0);b=v[23540];v[23540]=0;if((b|0)==1){break d}O:{if(w[d+376|0]){break O}b=Ib(x[d+378>>1]);if(b>>>0>=x[g>>1]){break O}b=(b<<5)+a|0;H=b+480284|0,I=Ec(((Ib(x[d+382>>1])<<8)+2047>>>0)/4095|0,0),u[H>>1]=I;h=b+480286|0;e=Ib(x[d+380>>1]);b=e>>>26|0;e=(e<<6)+2048|0;b=e>>>0<2048?b+1|0:b;H=h,I=Ec((b&4095)<<20|e>>>12,b>>>12|0)&255,u[H>>1]=I}f=f+1|0;continue}}a=P()|0;O()|0;Bb(d+480|0);break c}a=P()|0;O()|0;break c}b=d+56|0;Bb(b);v[23540]=0;U(371,b|0,d+856|0,1396788530);b=v[23540];v[23540]=0;if((b|0)==1){break e}H=d,I=Fb(v[d+56>>2]),v[H+792>>2]=I;f=c&2;j=d+480|2;n=Fb(v[d+60>>2]);g=a+480190|0;l=a+1298464|0;P:{Q:{R:{S:{T:{U:{V:{W:{X:{Y:{while(1){e=v[d+792>>2];if(!Pb(e,n)){b=d+56|0;Vc(b);v[23540]=0;U(371,b|0,d+856|0,1396788560);b=v[23540];v[23540]=0;if((b|0)==1){break f}H=d,I=Fb(v[d+56>>2]),v[H+824>>2]=I;j=d+480|2;n=Fb(v[d+60>>2]);e=a+480190|0;break P}v[23540]=0;b=Q(372,e|0,d+480|0)|0;k=v[23540];v[23540]=0;if((k|0)==1){break R}Z:{_:{if(!b){break _}b=Ib(x[d+480>>1]);if(!b|b>>>0>3999){break _}if(Ib(x[d+528>>1])>>>0>1){break _}if(Ib(x[d+510>>1])>>>0>1){break _}if(b>>>0>x[g>>1]){u[g>>1]=b}v[23540]=0;k=B(b,104)+a|0;b=k+484380|0;R(373,d+480|0,b|0);h=v[23540];v[23540]=0;$:{aa:{ba:{if((h|0)==1){break ba}h=d+840|0;Ii(h,3,j);v[23540]=0;R(222,d+376|0,h|0);h=v[23540];v[23540]=0;if((h|0)==1){break aa}h=d+376|0;Dc(((Ib(x[d+480>>1])<<5)+a|0)+946304|0,h);zb(h);if(!f){break _}h=x[d+554>>1]|x[d+556>>1]<<16;v[23540]=0;h=Q(155,e|0,bc(h)-8|0)|0;p=v[23540];v[23540]=0;if((p|0)==1){break ba}if(!h){break _}if(Ib(x[d+510>>1])){break $}h=d+376|0;Zc(h,(Ib(w[d+512|0]|w[d+513|0]<<8)|0)==8?8:16,(Ib(w[d+516|0]|w[d+517|0]<<8)|0)==1?1:2,!Ib(w[d+514|0]|w[d+515|0]<<8),0);v[23540]=0;W(219,h|0,b|0,e|0)|0;b=v[23540];v[23540]=0;if((b|0)!=1){break $}a=P()|0;O()|0;break Q}a=P()|0;O()|0;break Q}a=P()|0;O()|0;break Q}b=Nb(d+376|0);h=x[d+530>>1];v[23540]=0;U(268,e|0,b|0,Ib(h)|0);e=v[23540];v[23540]=0;if((e|0)==1){break T}Be(k+484423|0,b);if((Ib(x[d+510>>1])|0)==1){v[23540]=0;R(374,d+824|0,16451);e=v[23540];v[23540]=0;if((e|0)==1){break Z}v[23540]=0;U(11,d+808|0,0,b|0);e=v[23540];v[23540]=0;if((e|0)==1){break Y}v[23540]=0;X(375,d+840|0,d+824|0,x[d+480>>1],d+808|0);e=v[23540];v[23540]=0;if((e|0)==1){break X}e=v[l>>2];v[23540]=0;U(376,e|0,2,d+840|0);e=v[23540];v[23540]=0;if((e|0)==1){break W}Ab(d+840|0);Ab(d+808|0);dc(d+824|0)}zb(b)}Nf(d+792|0);continue}break}a=P()|0;O()|0;break S}a=P()|0;O()|0;break U}a=P()|0;O()|0;break V}a=P()|0;O()|0;Ab(d+840|0)}Ab(d+808|0)}dc(d+824|0);break S}a=P()|0;O()|0}zb(b);break Q}a=P()|0;O()|0}Vc(d+56|0);break c}ca:{while(1){da:{g=v[d+824>>2];if(!Pb(g,n)){Vc(d+56|0);v[23540]=0;U(371,d+840|0,d+856|0,1447382614);b=v[23540];v[23540]=0;if((b|0)!=1){break ca}a=P()|0;O()|0;break c}v[23540]=0;b=Q(377,g|0,d+480|0)|0;l=v[23540];v[23540]=0;if((l|0)==1){break da}ea:{fa:{if(!b){break fa}b=Ib(x[d+480>>1]);if(!b|b>>>0>3999){break fa}if(Ib(x[d+534>>1])){break fa}if(b>>>0>x[e>>1]){u[e>>1]=b}v[23540]=0;b=(B(b,104)+a|0)+484380|0;R(378,d+480|0,b|0);l=v[23540];v[23540]=0;if((l|0)==1){break da}l=d+840|0;Ii(l,3,j);v[23540]=0;R(222,d+376|0,l|0);l=v[23540];v[23540]=0;if((l|0)==1){break da}l=d+376|0;Dc(((Ib(x[d+480>>1])<<5)+a|0)+946304|0,l);zb(l);if(!f){break fa}l=x[d+510>>1];k=d+376|0;Zc(k,(Ib(x[d+514>>1])|0)==8?8:16,Ib(l)&1?2:1,1,0);v[23540]=0;W(219,k|0,b|0,g|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break ea}}Nf(d+824|0);continue}}break}a=P()|0;O()|0;Vc(d+56|0);break c}v[23540]=0;U(371,d+824|0,d+856|0,1413828182);b=v[23540];v[23540]=0;if((b|0)==1){break h}v[23540]=0;U(371,d+808|0,d+856|0,1346719318);b=v[23540];v[23540]=0;if((b|0)==1){break j}v[23540]=0;U(371,d+792|0,d+856|0,1229869908);b=v[23540];v[23540]=0;if((b|0)==1){break l}H=d,I=Fb(v[d+792>>2]),v[H+24>>2]=I;n=d+426|0;l=d+376|2;k=d+480|2;h=Fb(v[d+796>>2]);p=a+480190|0;q=a+480208|0;while(1){ga:{ha:{ia:{ja:{g=v[d+24>>2];if(!Pb(g,h)){Vc(d+792|0);v[23540]=0;U(371,d+376|0,d+856|0,1346458692);b=v[23540];v[23540]=0;if((b|0)!=1){break ja}a=P()|0;O()|0;break k}v[23540]=0;b=Q(379,g|0,d+480|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break n}if(!b){break ga}if(Ib(x[d+510>>1])){break ga}b=x[d+480>>1];v[23540]=0;e=W(251,a|0,Ib(b)|0,0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break n}if(!e){break ga}b=Ib(x[d+480>>1]);if(b>>>0>x[a+480192>>1]){u[a+480192>>1]=b}b=d+376|0;Ii(b,3,k);v[23540]=0;R(222,d+56|0,b|0);b=v[23540];v[23540]=0;if((b|0)==1){break ia}b=d+56|0;Dc(e+492|0,b);zb(b);t[e+33|0]=2;if((pe(u[d+514>>1])|0)>0){t[e+15|0]=w[e+15|0]|1;f=pe(u[d+514>>1]);b=f>>>24|0;j=(f<<8&-256)+2047|0;f=b&255;H=e,I=Ec(Mka(j,j>>>0<2047?f+1|0:f,4095,0),nb),v[H+8>>2]=I}j=e+108|0;i=e+236|0;b=0;while(1){ka:{v[d+56>>2]=128;v[d+376>>2]=128;f=b&255;if(f>>>0>=y[Kb(d+56|0,d+376|0)>>2]){v[23540]=0;R(380,d+56|0,e|0);b=v[23540];v[23540]=0;if((b|0)==1){break ka}H=d,I=Gi(v[d+56>>2]),v[H+376>>2]=I;f=xf(d+56|0);while(1){b=v[d+376>>2];if(Pb(b,f)){b=x[so(b)>>1];if(!(!b|b>>>0>x[p>>1])){H=(B(b,104)+a|0)+484410|0,I=Ib(x[d+512>>1]),u[H>>1]=I}Kg(d+376|0);continue}break}qu(d+56|0);Mj(e,127,1);Lj(e,0,1);b=Ib(x[d+530>>1]);if(!b){v[e>>2]=0;b=x[d+516>>1];v[23540]=0;X(381,e|0,0,Ib(b)|0,d+840|0);b=v[23540];v[23540]=0;if((b|0)==1){break n}b=x[d+520>>1];v[23540]=0;X(381,e|0,1,Ib(b)|0,d+808|0);b=v[23540];v[23540]=0;if((b|0)==1){break n}b=x[d+518>>1];v[23540]=0;X(381,e|0,2,Ib(b)|0,d+824|0);b=v[23540];v[23540]=0;if((b|0)!=1){break ga}break n}v[23540]=0;U(382,g|0,d+376|0,((b|0)==1?98:102)|0);b=v[23540];v[23540]=0;la:{ma:{na:{if((b|0)!=1){b=Ib(x[d+376>>1]);j=b&1;if(!j){break ha}f=b&24;if(f){break na}f=0;break ma}a=P()|0;O()|0;break m}if((f|0)!=8){break la}f=1}t[e+25|0]=f}oa:{pa:{qa:{ra:{if(!(b&2)){break ra}v[23540]=0;b=W(383,d+360|0,l|0,24)|0;f=v[23540];v[23540]=0;if((f|0)==1){break qa}v[23540]=0;z=+la(384,b|0);f=v[23540];v[23540]=0;if((f|0)==1){break pa}zb(b);if(!(z>20)){break ra}Mj(e,cB(v[q>>2],z),1)}if(Ib(x[d+376>>1])&4){break oa}break ha}a=P()|0;O()|0;break m}a=P()|0;O()|0;zb(b);break m}v[23540]=0;b=W(383,d+344|0,n|0,24)|0;f=v[23540];v[23540]=0;sa:{if((f|0)!=1){v[23540]=0;z=+la(384,b|0);f=v[23540];v[23540]=0;if((f|0)==1){break sa}zb(b);Lj(e,tk(z*127/24),1);break ha}a=P()|0;O()|0;break m}a=P()|0;O()|0;zb(b);break m}else{o=(d+480|0)+(f<<1)|0;H=cc(i,f),I=w[o+52|0],u[H>>1]=I;f=Lb(j,f);H=f,I=Mm(t[o+53|0]+w[f|0]|0),t[H|0]=I;b=b+1|0;continue}}break}a=P()|0;O()|0;break m}b=v[d+380>>2];e=v[d+376>>2];v[23540]=0;g=a+484344|0;R(225,g|0,Bf(e,b)&65535);b=v[23540];v[23540]=0;ta:{if((b|0)!=1){v[d+48>>2]=v[a+480204>>2];v[d+40>>2]=v[a+480196>>2];H=d,I=Fb(v[d+376>>2]),v[H+8>>2]=I;o=c&1;b=d+56|0;r=b|4;A=b|2;C=b|1;D=Fb(v[d+380>>2]);E=a+480188|0;while(1){ua:{va:{wa:{xa:{ya:{za:{b=v[d+8>>2];if(!Pb(b,D)){v[23540]=0;U(367,d+56|0,d+856|0,1414414669);b=v[23540];v[23540]=0;if((b|0)!=1){break za}a=P()|0;O()|0;break ta}if(!o){break ua}c=v[b+8>>2];e=v[b>>2];v[23540]=0;c=W(156,e|0,c|0,24)|0;e=v[23540];v[23540]=0;if((e|0)==1){break ya}if(!c){break ua}v[23540]=0;j=S(271,b|0)|0;c=v[23540];v[23540]=0;Aa:{Ba:{Ca:{Da:{if((c|0)!=1){t[d+496|0]=0;v[d+488>>2]=0;v[d+492>>2]=0;v[d+480>>2]=0;v[d+484>>2]=0;v[23540]=0;R(385,b|0,d+480|0);c=v[23540];v[23540]=0;if((c|0)==1){break Da}v[23540]=0;p=S(271,b|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break Ca}v[23540]=0;n=S(271,b|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break Ba}v[23540]=0;l=S(271,b|0)|0;c=v[23540];v[23540]=0;Ea:{if((c|0)==1){break Ea}c=v[b+8>>2];e=v[b>>2];v[23540]=0;c=W(156,e|0,c|0,B(B(l,n),5)|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break Ea}if(!(c&p>>>0<2)){break ua}v[23540]=0;c=W(226,g|0,j|0,n|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break Ea}if(!c){break ua}c=v[g>>2];v[23540]=0;R(386,_b(c,j)|0,d+480|0);c=v[23540];v[23540]=0;if((c|0)!=1){break Aa}}a=P()|0;O()|0;break ta}a=P()|0;O()|0;break ta}a=P()|0;O()|0;break ta}a=P()|0;O()|0;break ta}a=P()|0;O()|0;break ta}t[d+24|0]=0;c=de(d+56|0,0,d+24|0);v[23540]=0;c=W(363,d+792|0,l|0,c|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break va}e=0;Fa:while(1){if((e|0)==(n|0)){od(c);break ua}f=0;k=_b(v[g>>2],j);F=Cf(v[k>>2],v[v[k+48>>2]+12>>2],e);while(1){if((f|0)==(l|0)){e=e+1|0;continue Fa}h=ug(d+56|0);q=x[E>>1];v[23540]=0;R(387,b|0,d+24|0);k=v[23540];v[23540]=0;Ga:{if((k|0)==1){break Ga}k=B(f,6)+F|0;i=h;h=f>>>0<q>>>0;q=h?k:i;i=w[d+24|0];if((i-1&255)>>>0<=119){i=i+1|0;t[q|0]=i;H=cc(v[c>>2],f),I=i,t[H|0]=I}i=w[d+25|0];if(i){t[(h?k+1|0:C)|0]=i;H=cc(v[c>>2],f),I=i,t[H+1|0]=I}i=w[d+28|0];if(i){t[(h?k+2|0:A)|0]=1;t[(h?k+4|0:r)|0]=p?i-16|0:i>>>2|0}k=w[d+947|0];h=w[d+27|0];i=w[d+26|0];s=cc(v[c>>2],f);G=w[s+1|0];s=w[s|0];v[23540]=0;Da(365,a|0,q|0,i|0,h|0,k|0,s|0,G|0,d+48|0,d+40|0);k=v[23540];v[23540]=0;if((k|0)==1){break Ga}f=f+1|0;continue}break}break}a=P()|0;O()|0;od(c);break ta}v[23540]=0;b=W(156,v[d+56>>2],v[d+64>>2],38)|0;c=v[23540];v[23540]=0;if((c|0)!=1){if(!b){break wa}v[23540]=0;b=S(271,d+56|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break xa}c=d+480|4;e=a+480188|0;f=0;Ha:{while(1){if(b>>>0<=(f&65535)>>>0){break wa}v[23540]=0;g=W(156,v[d+56>>2],v[d+64>>2],36)|0;j=v[23540];v[23540]=0;Ia:{if((j|0)!=1){if(g){break Ia}break wa}break xa}v[23540]=0;R(388,d+56|0,d+480|0);g=v[23540];v[23540]=0;if((g|0)!=1){Ja:{if(Ib(x[d+480>>1])){break Ja}if(Ib(x[d+482>>1])>>>0>=x[e>>1]){break Ja}g=d+8|0;Ne(g,3,c);v[23540]=0;R(222,d+24|0,g|0);g=v[23540];v[23540]=0;if((g|0)==1){break Ha}g=d+24|0;El(((Ib(x[d+482>>1])<<5)+a|0)+480289|0,g);zb(g)}f=f+1|0;continue}break}break xa}break xa}break xa}a=P()|0;O()|0;break ta}a=P()|0;O()|0;Bb(d+56|0);break ta}Bb(d+56|0);Vc(d+376|0);Vc(d+808|0);Vc(d+824|0);Vc(d+840|0);f=1;break s}a=P()|0;O()|0;break ta}Nf(d+8|0);continue}}a=P()|0;O()|0}Vc(d+376|0);break k}a=P()|0;O()|0;break m}f=0;while(1){if(w[d+477|0]<=f>>>0){break ga}v[23540]=0;R(389,g|0,d+56|0);b=v[23540];v[23540]=0;Ka:{La:{if((b|0)!=1){v[d+8>>2]=33620480;H=d,I=(Ib(x[d+516>>1])|0)!=0,t[H+48|0]=I;H=d,I=(Ib(x[d+518>>1])|0)!=0,t[H+49|0]=I;H=d,I=(Ib(x[d+520>>1])|0)!=0,t[H+50|0]=I;H=d,I=j&(Ib(x[d+522>>1])|0)!=0,t[H+51|0]=I;if(!w[(d+48|0)+f|0]|f>>>0>3){break Ka}b=(f|0)!=3;if(!b&(t[e+100|0]&1)){break Ka}v[23540]=0;i=w[(d+8|0)+f|0];U(390,d+56|0,e|0,i|0);o=v[23540];v[23540]=0;if((o|0)==1){break La}if(!b){t[e+100|0]=w[e+100|0]|16}Ma:{switch(i|0){case 0:if(Ib(x[d+68>>1])&1){b=Ib(x[d+66>>1])&32767}else{b=0}v[e>>2]=b;break Ka;case 2:break Ma;default:break Ka}}if(!(Ib(x[d+68>>1])&2)){break Ka}H=d,I=Ib(x[d+62>>1]),u[H+40>>1]=I;u[d+46>>1]=1;b=x[ke(d+40|0,d+46|0)>>1];i=Jl(Ec(((Ib(x[d+58>>1])<<6|48)>>>0)/100|0,0));H=d,I=Ib(x[d+60>>1]),u[H+40>>1]=I;u[d+46>>1]=1;o=tg(256/x[ke(d+40|0,d+46|0)>>1]|0);r=x[d+480>>1];A=x[d+64>>1];v[23540]=0;s=Ib(r);r=Ib(A);ma(391,a|0,s|0,w[(r>>>0<6?r:0)+26656|0],255/(b>>>0)|0,i|0,o|0);b=v[23540];v[23540]=0;if((b|0)!=1){break Ka}a=P()|0;O()|0;break m}a=P()|0;O()|0;break m}a=P()|0;O()|0;break m}f=f+1|0;continue}}Nf(d+24|0);continue}}Zd(d+856|0);Bb(m)}kb=d+1184|0;return f|0}a=P()|0;O()|0}Vc(d+792|0);break k}a=P()|0;O()|0}Vc(d+808|0);break i}a=P()|0;O()|0}Vc(d+824|0);break g}a=P()|0;O()|0}Vc(d+840|0);break c}a=P()|0;O()|0;break c}a=P()|0;O()|0;break c}a=P()|0;O()|0;Bb(d+56|0)}Zd(d+856|0)}Bb(m)}T(a|0);L()}function kaa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,z=0,A=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,M=0,N=0,Q=0,R=0,S=0,U=0,V=0,X=0,Y=0,Z=0,_=0,$=0,ba=0;n=kb-1152|0;kb=n;zc(b);a:{if(!ur(b,n+1128|0)){break a}if(!aM(n+1128|0)){break a}if(v[n+1136>>2]!=(Vg(v[b>>2])|0)){break a}if(v[n+1144>>2]!=(cf(b)|0)){break a}if(!c){h=1;break a}e=n+1072|0;Ub(e,0,56);j=-2;b:{if(!e){break b}v[e+44>>2]=0;v[e+48>>2]=0;v[e+52>>2]=0;v[e+20>>2]=0;v[e+24>>2]=0;v[e+8>>2]=0;d=v[e+32>>2];if(!d){v[e+32>>2]=1084;d=1084}if(!v[e+36>>2]){v[e+36>>2]=1085}d=ob[d|0](v[e+40>>2],1,43784)|0;j=-4;if(!d){break b}v[e+28>>2]=d;v[d+43780>>2]=1;v[d+10992>>2]=0;v[d+10996>>2]=0;v[d>>2]=0;v[d+11008>>2]=15;v[d+11e3>>2]=1;v[d+11004>>2]=0;j=0}if(j){break a}h=v[n+1144>>2];v[n+1068>>2]=h;I=v[n+1148>>2];R=vB(n+1056|0,I);c:{d:{while(1){if(!(!h|!I|(f|0)==1)){v[n+16>>2]=1024;f=n+16|0;S=v[Kb(f,n+1068|0)>>2];d=hc(n+24|0,n+32|0,S);e=v[d+4>>2];d=v[d>>2];v[23540]=0;Nk(165,f,b,d,e);f=v[23540];v[23540]=0;if((f|0)==1){break d}d=n+32|0;f=d;h=S;e=Z^-1;while(1){if(h>>>0<4){while(1){if(h){e=v[((w[f|0]^e&255)<<2)+63200>>2]^e>>>8;h=h-1|0;f=f+1|0;continue}break}Z=e^-1}else{e=v[((w[f|0]^e&255)<<2)+63200>>2]^e>>>8;e=e>>>8^v[((w[f+1|0]^e&255)<<2)+63200>>2];e=e>>>8^v[((w[f+2|0]^e&255)<<2)+63200>>2];e=e>>>8^v[((w[f+3|0]^e&255)<<2)+63200>>2];h=h-4|0;f=f+4|0;continue}break}v[n+1076>>2]=S;v[n+1072>>2]=d;v[n+1088>>2]=I;v[n+1084>>2]=v[R>>2]+_;D=kb-16|0;kb=D;f=-2;o=n+1072|0;e:{if(!o){break e}i=v[o+28>>2];if(!i){break e}ba=v[o+4>>2];v[i+11e3>>2]=0;f:{if(v[i+43780>>2]<0){break f}if(v[i+11004>>2]){break e}e=v[i+11008>>2];f=0;v[i+11004>>2]=0;d=v[i+10996>>2];if(!d){V=(e|0)>0?11:10;J=i+11012|0;h=v[o+4>>2];j=v[i+10992>>2];while(1){v[D+12>>2]=h;v[D+8>>2]=32768-j;d=0;e=0;r=0;H=0;K=0;M=0;X=0;Y=kb-144|0;kb=Y;f=v[D+8>>2];A=j+J|0;U=f+(A+(J^-1)|0)|0;F=U+1|0;N=f+A|0;C=v[o>>2];E=v[D+12>>2];z=C+E|0;g:{if(!(F&U?0:A>>>0>=J>>>0)){v[D+8>>2]=0;v[D+12>>2]=0;l=-3;break g}Q=v[i+60>>2];s=v[i+40>>2];f=v[i+36>>2];q=v[i+32>>2];j=v[i+56>>2];g=v[i+4>>2];l=-1;k=C;m=A;p=-1;h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{z:{A:{B:{C:{D:{E:{F:{G:{H:{I:{J:{K:{L:{M:{N:{O:{P:{Q:{R:{S:{T:{U:{h=v[i>>2];switch(h|0){case 36:break j;case 39:break n;case 10:break o;case 35:break p;case 17:break q;case 21:break r;case 34:break s;case 42:break w;case 41:break x;case 53:break y;case 52:break z;case 51:break A;case 38:break B;case 27:break C;case 26:break D;case 25:break E;case 24:break F;case 23:break G;case 18:break H;case 16:break I;case 14:break J;case 11:break K;case 9:break L;case 7:break M;case 6:break N;case 3:break O;case 37:break P;case 32:break Q;case 5:break R;case 2:break S;case 1:break T;case 0:break U;default:break i}}v[i+28>>2]=1;j=0;v[i+8>>2]=0;v[i+12>>2]=0;v[i+16>>2]=1;s=0;f=0;q=0;g=0;if(V&1){break T}break v}if((E|0)<=0){v[i>>2]=1;break m}v[i+8>>2]=w[C|0];k=C+1|0}if(k>>>0>=z>>>0){v[i>>2]=2;l=1;break h}f=w[k|0];v[i+12>>2]=f;k=k+1|0;l=1;e=v[i+8>>2];if(!(((f|e<<8)>>>0)%31|f&32)){l=(e&15)!=8}f=0;h=36;e=256<<(e>>>4);if(e>>>0>32768|e>>>0>F>>>0|l){break l}break v}if((E|0)<=0){v[i>>2]=5;break m}M=g+8|0;k=C+1|0;j=w[C|0]<<g|j;d=2;break v}if((E|0)<=0){v[i>>2]=32;break m}g=g+8|0;k=C+1|0;h=f;break u}h=37;break k}d=1;break v}d=4;break v}d=3;break v}d=7;break v}d=9;break v}d=10;break v}d=11;break v}d=12;break v}d=13;break v}d=14;break v}d=15;break v}d=16;break v}d=17;break v}d=8;break v}d=5;break v}d=6;break v}d=18;break v}h=2;break t}h=1;break t}V:while(1){W:{X:{Y:{Z:{_:{$:{aa:{ba:{ca:{da:{ea:{fa:{ga:{ha:{ia:{ja:{ka:{la:{ma:{na:{oa:{pa:{qa:{ra:{sa:{ta:{ua:{va:{wa:{xa:{ya:{za:{Aa:{switch(d|0){case 0:if(g>>>0>2){break za}d=1;continue;case 1:break Aa;case 9:break ea;case 10:break fa;case 11:break ga;case 12:break ha;case 13:break ia;case 14:break ja;case 15:break ka;case 16:break la;case 17:break ma;case 8:break ra;case 7:break sa;case 6:break ta;case 5:break ua;case 4:break wa;case 3:break xa;case 2:break ya;default:break na}}while(1){if(k>>>0>=z>>>0){v[i>>2]=3;l=1;break h}j=w[k|0]<<g|j;k=k+1|0;g=g+8|0;if(g>>>0<3){continue}break}}d=j&7;v[i+20>>2]=d;e=d>>>1|0;v[i+24>>2]=e;g=g-3|0;j=j>>>3|0;if(d>>>0>=2){break qa}M=g;break oa}g=M&-8;j=j>>>(M&7)|0;f=0;d=0;break pa}if(k>>>0<z>>>0){break va}v[i>>2]=7;l=1;break h}while(1){if(k>>>0>=z>>>0){v[i>>2]=6;l=1;break h}j=w[k|0]<<g|j;d=g>>>0>4294967287;k=k+1|0;g=g+8|0;if(d){continue}break}d=1;break pa}t[(f+i|0)+10528|0]=w[k|0];k=k+1|0;d=2;break pa}while(1){if(k>>>0>=z>>>0){v[i>>2]=51;l=1;break h}j=w[k|0]<<g|j;d=g>>>0>4294967287;k=k+1|0;g=g+8|0;if(d){continue}break}break Y}p=2;h=52;if(m>>>0>=N>>>0){break j}t[m|0]=q;f=f-1|0;m=m+1|0;break Z}p=2;h=9;if(m>>>0>=N>>>0){break j}d=8;continue}if(k>>>0<z>>>0){d=N-m|0;e=z-k|0;d=d>>>0<e>>>0?d:e;d=d>>>0<f>>>0?d:f;f=f-d|0;m=sc(m,k,d)+d|0;k=d+k|0;break X}v[i>>2]=38;l=1;break h}h=0;Ba:{switch(e-1|0){case 0:v[i+44>>2]=288;v[i+48>>2]=32;d=i+3552|0;v[d>>2]=84215045;v[d+4>>2]=84215045;d=i+3560|0;v[d>>2]=84215045;v[d+4>>2]=84215045;d=i+3568|0;v[d>>2]=84215045;v[d+4>>2]=84215045;d=i+3576|0;v[d>>2]=84215045;v[d+4>>2]=84215045;d=i- -64|0;e=0;while(1){h=144;if((e|0)==144){while(1){e=256;if((h|0)==256){while(1){h=280;if((e|0)==280){while(1){if((h|0)==288){break ba}t[d|0]=8;h=h+1|0;d=d+1|0;continue}}else{t[d|0]=7;e=e+1|0;d=d+1|0;continue}}}else{t[d|0]=9;h=h+1|0;d=d+1|0;continue}}}else{t[d|0]=8;e=e+1|0;d=d+1|0;continue}};case 2:break o;default:break Ba}}d=0;break da}while(1){Ca:{Da:{Ea:{Fa:{Ga:{switch(d|0){case 0:if(f>>>0>3){break Fa}if(!g){g=0;d=3;continue V}if(g>>>0>7){break Da}d=4;continue V;case 1:t[(f+i|0)+10528|0]=j;g=g-8|0;j=j>>>8|0;break Ca;default:break Ga}}f=f+1|0;break Ea}f=x[i+10528>>1];if((f|0)==(x[i+10530>>1]^65535)){break Z}break n}d=0;continue}d=1;continue}d=2;continue}}d=2;continue}p=2;h=53;if(m>>>0>=N>>>0){break j}t[m|0]=w[(Q-q&U)+J|0];m=m+1|0;Q=Q+1|0;d=7;break _}while(1){if(k>>>0>=z>>>0){v[i>>2]=27;l=1;break h}j=w[k|0]<<g|j;k=k+1|0;g=g+8|0;if(s>>>0>g>>>0){continue}break}d=6;break _}if(k>>>0>=z>>>0){v[i>>2]=26;l=1;break h}j=w[k|0]<<g|j;k=k+1|0;g=g+8|0;d=4;if(g>>>0<15){break _}d=5;break _}while(1){if(k>>>0>=z>>>0){v[i>>2]=25;l=1;break h}j=w[k|0]<<g|j;k=k+1|0;g=g+8|0;if(s>>>0>g>>>0){continue}break}d=3;break _}p=2;h=24;if(m>>>0>=N>>>0){break j}t[m|0]=f;m=m+1|0;break $}if(k>>>0>=z>>>0){v[i>>2]=23;l=1;break h}j=w[k|0]<<g|j;k=k+1|0;g=g+8|0;d=0;if(g>>>0<15){break _}d=1;break _}while(1){if(k>>>0>=z>>>0){v[i>>2]=18;l=1;break h}j=w[k|0]<<g|j;k=k+1|0;g=g+8|0;if(s>>>0>g>>>0){continue}break}X=q-16|0;d=3;break aa}if(k>>>0>=z>>>0){v[i>>2]=16;l=1;break h}j=w[k|0]<<g|j;k=k+1|0;g=g+8|0;d=1;if(g>>>0<15){break aa}d=2;break aa}while(1){if(k>>>0>=z>>>0){v[i>>2]=14;l=1;break h}j=w[k|0]<<g|j;k=k+1|0;g=g+8|0;if(g>>>0<3){continue}break}d=1;break ca}d=f+21669|0;while(1){if(k>>>0>=z>>>0){v[i>>2]=11;l=1;break h}j=w[k|0]<<g|j;k=k+1|0;g=g+8|0;K=t[d|0];if(g>>>0<K>>>0){continue}break}h=f;d=1}while(1){Ha:{Ia:{Ja:{if(!d){if(h>>>0>2){break Ja}f=h;K=t[f+21669|0];if(K>>>0<=g>>>0){break Ha}d=9;continue V}f=h<<2;v[(f+i|0)+44>>2]=v[f+64736>>2]+((-1<<K^-1)&j);h=h+1|0;g=g-K|0;j=j>>>K|0;break Ia}f=0;Ub(i+7040|0,0,288);d=0;break ca}d=0;continue}d=1;continue}}while(1){Ka:{La:{Ma:{if(!d){if(y[i+52>>2]<=f>>>0){break Ma}if(g>>>0>2){break Ka}d=10;continue V}t[(w[f+64752|0]+i|0)+7040|0]=j&7;f=f+1|0;g=g-3|0;j=j>>>3|0;break La}v[i+52>>2]=19;break ba}d=0;continue}d=1;continue}}H=v[i+24>>2];d=0}while(1){Na:{Oa:{Pa:{Qa:{Ra:{Sa:{Ta:{Ua:{Va:{switch(d|0){case 0:d=0;if((H|0)<0){break $}E=Ub(Y,0,64);e=B(H,3488)+i|0;Ub(e+352|0,0,3200);$=e- -64|0;G=v[i+24>>2];h=v[((G<<2)+i|0)+44>>2];while(1){if((d|0)!=(h|0)){e=(w[d+$|0]<<2)+E|0;v[e>>2]=v[e>>2]+1;d=d+1|0;continue}break};v[E+64>>2]=0;v[E+68>>2]=0;l=0;d=1;e=0;while(1){if((d|0)!=16){p=d<<2;d=d+1|0;p=v[p+E>>2];e=p+e<<1;v[(E- -64|0)+(d<<2)>>2]=e;l=l+p|0;continue}break};F=0;p=-1;if((e|0)!=65536&l>>>0>=2){break p}while(1){if(h>>>0>F>>>0){l=w[F+$|0];Wa:{if(!l){break Wa}d=(E- -64|0)+(l<<2)|0;e=v[d>>2];v[d>>2]=e+1;d=0;h=l;while(1){if(h){d=e&1|d<<1;e=e>>>1|0;h=h-1|0;continue}break}if(l>>>0<=10){e=1<<l;h=l<<9|F;l=B(H,3488)+i|0;while(1){if(d>>>0>1023){break Wa}u[(l+(d<<1)|0)+352>>1]=h;d=d+e|0;continue}}G=B(H,3488)+i|0;e=G+((d&1023)<<1)|0;h=u[e+352>>1];Xa:{if(h){e=p;p=h;break Xa}u[e+352>>1]=p;e=p-2|0}d=d>>>9|0;while(1){d=d>>>1|0;h=d&1;if(l>>>0>=12){h=(G+(h+(p^-1)<<1)|0)+2400|0;p=u[h>>1];if(!p){u[h>>1]=e;p=e;e=e-2|0}l=l-1|0;continue}break}u[((B(H,3488)+i|0)+(h+(p^-1)<<1)|0)+2400>>1]=F;p=e}F=F+1|0;G=v[i+24>>2];h=v[((G<<2)+i|0)+44>>2];continue}break};d=0;if((G|0)!=2){break Oa}break Sa;case 1:d=u[(((j&1023)<<1)+i|0)+7328>>1];Ya:{if((d|0)>=0){if(d>>>0<512|d>>9>>>0>g>>>0){break Ya}break Ra}h=10;if(g>>>0<11){break Ya}while(1){Za:{e=j>>>h|0;l=h+2|0;h=h+1|0;d=u[(((e&1)+(d^-1)<<1)+i|0)+9376>>1];if((d|0)>=0){break Za}if(g>>>0>=l>>>0){continue}}break}if((d|0)>=0){break Ra}}d=11;continue V;case 2:d=10;q=u[(((j&1023)<<1)+i|0)+7328>>1];if((q|0)>=0){break Ua}while(1){e=j>>>d|0;d=d+1|0;q=u[(((e&1)+(q^-1)<<1)+i|0)+9376>>1];if((q|0)<0){continue}break};break Ta;default:break Va}}d=t[X+17878|0]+((-1<<s^-1)&j)|0;g=g-s|0;j=j>>>s|0;e=f+i|0;Ub(e+10532|0,(q|0)==16?w[e+10531|0]:0,d);d=d+f|0;break Sa}d=q>>9;q=q&511}g=g-d|0;j=j>>>d|0;if(q>>>0>15){break Qa}t[(f+i|0)+10532|0]=q;d=f+1|0}e=v[i+48>>2];f=v[i+44>>2];h=e+f|0;if(h>>>0<=d>>>0){break Pa}if(g>>>0<=14){if((z-k|0)<=1){f=d;d=1;continue}j=w[k|0]<<g|j|w[k+1|0]<<g+8;k=k+2|0;g=g+16|0}f=d}d=2;continue}if(!((q|0)!=16|f)){f=0;q=16;break q}X=q-16|0;s=t[q+21644|0];if(s>>>0<=g>>>0){break Na}d=12;continue V}if((d|0)!=(h|0)){f=d;break r}h=i+10532|0;sc(i- -64|0,h,f);sc(i+3552|0,f+h|0,e);G=v[i+24>>2];f=d}H=G-1|0;v[i+24>>2]=H;d=0;continue}d=3;continue}}r=f;d=2}_a:while(1){$a:{ab:{bb:{cb:{db:{eb:{fb:{gb:{hb:{ib:{jb:{kb:{lb:{switch(d|0){case 0:d=u[(((j&1023)<<1)+i|0)+352>>1];mb:{if((d|0)>=0){if(d>>>0<512|d>>9>>>0>g>>>0){break mb}break $a}h=10;if(g>>>0<11){break mb}while(1){nb:{e=j>>>h|0;l=h+2|0;h=h+1|0;d=u[(((e&1)+(d^-1)<<1)+i|0)+2400>>1];if((d|0)>=0){break nb}if(g>>>0>=l>>>0){continue}}break}if((d|0)>=0){break $a}}d=13;continue V;case 1:d=10;f=u[(((j&1023)<<1)+i|0)+352>>1];if((f|0)>=0){break kb}while(1){e=j>>>d|0;d=d+1|0;f=u[(((e&1)+(f^-1)<<1)+i|0)+2400>>1];if((f|0)<0){continue}break};break jb;case 2:while(1){d=z-k|0;if(!((N-m|0)>1&(d|0)>=4)){if(g>>>0>14){break $a}if((d|0)<=1){f=r;d=0;continue _a}j=w[k|0]<<g|j|w[k+1|0]<<g+8;g=g+16|0;k=k+2|0;break $a}if(g>>>0>14){e=k}else{j=(w[k|0]|w[k+1|0]<<8)<<g|j;g=g+16|0;e=k+2|0}d=10;r=u[(((j&1023)<<1)+i|0)+352>>1];ob:{if((r|0)>=0){d=r>>9;break ob}while(1){f=j>>>d|0;d=d+1|0;r=u[(((f&1)+(r^-1)<<1)+i|0)+2400>>1];if((r|0)<0){continue}break}}g=g-d|0;j=j>>>d|0;if(r&256){k=e;f=r;break ib}if(!(g>>>0>14)){j=(w[e|0]|w[e+1|0]<<8)<<g|j;e=e+2|0;g=g+16|0}l=g;k=e;d=10;f=u[(((j&1023)<<1)+i|0)+352>>1];pb:{if((f|0)>=0){d=f>>9;break pb}while(1){e=j>>>d|0;d=d+1|0;f=u[(((e&1)+(f^-1)<<1)+i|0)+2400>>1];if((f|0)<0){continue}break}}t[m|0]=r;g=l-d|0;j=j>>>d|0;if(!(f&256)){t[m+1|0]=f;m=m+2|0;continue}break};m=m+1|0;break ib;case 3:g=g-s|0;d=j>>>s|0;f=((-1<<s^-1)&j)+f|0;break hb;case 4:d=u[(((j&1023)<<1)+i|0)+3840>>1];qb:{if((d|0)>=0){if(d>>>0<512|d>>9>>>0>g>>>0){break qb}break gb}h=10;if(g>>>0<11){break qb}while(1){rb:{e=j>>>h|0;l=h+2|0;h=h+1|0;d=u[(((e&1)+(d^-1)<<1)+i|0)+5888>>1];if((d|0)>=0){break rb}if(g>>>0>=l>>>0){continue}}break}if((d|0)>=0){break gb}}d=16;continue V;case 5:h=10;d=u[(((j&1023)<<1)+i|0)+3840>>1];if((d|0)>=0){break fb}while(1){e=j>>>h|0;h=h+1|0;d=u[(((e&1)+(d^-1)<<1)+i|0)+5888>>1];if((d|0)<0){continue}break};break eb;case 6:g=g-s|0;h=j>>>s|0;q=((-1<<s^-1)&j)+q|0;break db;default:break lb}}r=-1;d=f;f=d-1|0;if(!d){break cb}d=18;continue V}d=f>>9;f=f&511}g=g-d|0;j=j>>>d|0;if(f>>>0>255){break ib}d=14;continue V}h=256;d=f&511;if((d|0)==256){break W}e=d-257<<2;f=v[e+64224>>2];s=0;if(d-285>>>0<4294967276){d=j;break hb}s=v[e+64352>>2];if(s>>>0<=g>>>0){break bb}d=15;continue V}if(g>>>0>14){j=d;break gb}if((z-k|0)<=1){j=d;d=4;continue}j=w[k|0]<<g|d|w[k+1|0]<<g+8;g=g+16|0;k=k+2|0}d=5;continue}h=d>>9;d=d&511}g=g-h|0;j=j>>>h|0;e=d<<2;q=v[e+64480>>2];s=0;if(d-30>>>0<4294967270){h=j;break db}s=v[e+64608>>2];if(s>>>0<=g>>>0){break ab}d=17;continue V}Q=m-J|0;d=(Q-q&U)+J|0;if((d>>>0<m>>>0?m:d)+f>>>0>N>>>0){j=h;d=7;continue}r=f;while(1){if(r>>>0>=3){t[m|0]=w[d|0];t[m+1|0]=w[d+1|0];t[m+2|0]=w[d+2|0];r=r-3|0;d=d+3|0;m=m+3|0;continue}break}if(!r){j=h;r=0;break cb}t[m|0]=w[d|0];if((r|0)!=1){t[m+1|0]=w[d+1|0]}m=m+r|0;j=h}d=2;continue}d=3;continue}d=6;continue}d=1;continue}}if(!f|!g){break X}if(g>>>0>7){break Y}d=5;continue}g=g-8|0;q=j&255;j=j>>>8|0;d=6;continue}h=0;if(!f){break W}d=7;continue}f=h;if(t[i+20|0]&1){break u}d=0;continue}}j=0;f=g>>>3|0;d=k-C|0;d=d>>>0>k>>>0?0:d;f=d>>>0>f>>>0?f:d;if((g&-8)==f<<3){k=k-f|0;e=0;d=0;f=h;g=0;if(!(V&1)){break s}h=0;break t}aa(6842,13157,2797,6852);L()}while(1){sb:{tb:{ub:{vb:{wb:{xb:{switch(h|0){case 0:if(e>>>0>3){f=e;g=d;break s}g=0;if(d){break wb}f=e;h=1;continue;case 1:break xb;default:break vb}}if(k>>>0<z>>>0){break tb}v[i>>2]=42;l=1;break h}f=e;g=d;if(d>>>0>7){break ub}h=2;continue}while(1){if(k>>>0>=z>>>0){v[i>>2]=41;l=1;break h}j=w[k|0]<<g|j;e=g>>>0>4294967287;k=k+1|0;d=g+8|0;g=d;if(e){continue}break}e=f}h=j&255;j=j>>>8|0;d=d-8|0;break sb}h=w[k|0];k=k+1|0;e=f;d=g}v[i+16>>2]=v[i+16>>2]<<8|h;e=e+1|0;h=0;continue}}p=0;h=34;break j}h=21;break k}h=17;break k}h=35;break k}h=10;break k}h=39;break k}l=1;break h}f=1}p=-1}v[i>>2]=h;l=p}d=g>>>3|0;e=k-C|0;e=e>>>0>k>>>0?0:e;d=d>>>0<e>>>0?d:e;k=k-d|0;g=g-(d<<3)|0}v[i+4>>2]=g;v[i+60>>2]=Q;v[i+40>>2]=s;v[i+36>>2]=f;v[i+32>>2]=q;v[i+56>>2]=(((g&63)>>>0>=32?0:-1<<g)^-1)&j;v[D+12>>2]=k-C;g=m-A|0;v[D+8>>2]=g;if((l|0)<0){break g}k=(g>>>0)%5552|0;f=v[i+28>>2];d=f>>>16|0;j=f&65535;while(1){h=0;if(g){while(1){if((h|7)>>>0<k>>>0){f=w[A|0]+j|0;e=f+w[A+1|0]|0;p=e+w[A+2|0]|0;r=p+w[A+3|0]|0;m=r+w[A+4|0]|0;C=m+w[A+5|0]|0;M=C+w[A+6|0]|0;j=M+w[A+7|0]|0;d=j+(M+(C+(m+(r+(p+(e+(d+f|0)|0)|0)|0)|0)|0)|0)|0;A=A+8|0;h=h+8|0;continue}break}f=k&7;h=k&8184;e=A;while(1){if((h|0)!=(k|0)){h=h+1|0;j=w[e|0]+j|0;d=j+d|0;e=e+1|0;continue}break}g=g-k|0;d=(d>>>0)%65521|0;j=(j>>>0)%65521|0;A=f+A|0;k=5552;continue}else{f=d<<16|j;v[i+28>>2]=f;if(l){break g}l=0;if(!(V&1)){break g}l=(f|0)==v[i+16>>2]?0:-2}break}}kb=Y+144|0;v[i+43780>>2]=l;f=v[D+12>>2];v[o>>2]=f+v[o>>2];v[o+4>>2]=v[o+4>>2]-f;v[o+8>>2]=f+v[o+8>>2];v[o+48>>2]=v[i+28>>2];f=v[D+8>>2];v[i+10996>>2]=f;d=v[o+16>>2];d=d>>>0>f>>>0?f:d;sc(v[o+12>>2],v[i+10992>>2]+J|0,d);v[o+12>>2]=d+v[o+12>>2];v[o+16>>2]=v[o+16>>2]-d;v[o+20>>2]=d+v[o+20>>2];e=v[i+10996>>2];v[i+10996>>2]=e-d;j=d+v[i+10992>>2]&32767;v[i+10992>>2]=j;if((l|0)<0){break f}if(!((l|0)!=1|ba)){f=-5;break e}if(l){f=0;h=v[o+4>>2];if(!h|!v[o+16>>2]){break e}if((d|0)==(e|0)){continue}break e}break}f=(d|0)==(e|0);break e}e=v[o+16>>2];d=d>>>0<e>>>0?d:e;sc(v[o+12>>2],(v[i+10992>>2]+i|0)+11012|0,d);v[o+12>>2]=d+v[o+12>>2];v[o+16>>2]=v[o+16>>2]-d;v[o+20>>2]=d+v[o+20>>2];e=v[i+10996>>2];v[i+10996>>2]=e-d;v[i+10992>>2]=d+v[i+10992>>2]&32767;if(v[i+43780>>2]){break e}f=(d|0)==(e|0);break e}f=-3}kb=D+16|0;h=v[n+1068>>2]-S|0;v[n+1068>>2]=h;d=I+_|0;I=v[n+1088>>2];_=d-I|0;continue}break}b=n+1072|0;yb:{if(!b){break yb}d=v[b+28>>2];if(!d){break yb}ob[v[b+36>>2]](v[b+40>>2],d);v[b+28>>2]=0}h=0;zb:{Ab:{if(!(v[n+1140>>2]!=(Z|0)|I|(f|0)!=1)){re(n+8|0,v[R>>2],v[R+4>>2]);b=ee(n);f=v[b+4>>2];b=v[b>>2];v[23540]=0;b=Eg(540,n+32|0,v[n+8>>2],v[n+12>>2],b,f);f=v[23540];v[23540]=0;if((f|0)==1){break Ab}v[23540]=0;h=W(870,a|0,b|0,c|0)|0;a=v[23540];v[23540]=0;if((a|0)==1){break zb}Bb(b)}ic(R);break a}a=P()|0;O()|0;break c}a=P()|0;O()|0;Bb(b);break c}a=P()|0;O()|0}ic(R);T(a|0);L()}kb=n+1152|0;return h|0}function Pga(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=C(0),y=0,A=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,M=0,N=C(0),Q=0,R=C(0),S=0,U=0,X=0,Y=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=C(0),ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=C(0);p=kb-11360|0;kb=p;zc(c);a:{while(1){b:{if(!Qb(v[c>>2],v[c+8>>2],4)){break b}e=p+16|0;d=kb-16|0;kb=d;c:{if(!Qb(v[c>>2],v[c+8>>2],3)){f=0;while(1){if((f|0)!=3){Eh(e+f|0);f=f+1|0;continue}break}break c}xv(d+8|0,e);ud(d,c,v[d+8>>2],v[d+12>>2])}kb=d+16|0;d:{e:{if(!Sb(e,15068,3)){e=p+4648|0;d=kb-16|0;kb=d;f:{if(!Qb(v[c>>2],v[c+8>>2],7)){f=0;while(1){if((f|0)!=7){Eh(e+f|0);f=f+1|0;continue}break}break f}Ho(d+8|0,e);ud(d,c,v[d+8>>2],v[d+12>>2])}kb=d+16|0;H=0;i=3;while(1){if((i|0)==7){break d}e=w[(p+4648|0)+i|0];if(e&128){break e}i=i+1|0;H=e|H<<7;continue}}g:{if(Sb(p+16|0,14221,3)){break g}if(!dS(c,13543)){break g}$b(c,Bg(c)+16|0);continue}if(!Sb(p+16|0,30286,3)){continue}if(!Sb(p+16|0,30290,3)){continue}if(!w[p+16|0]){yg(c,2);continue}if(LP(p+16|0)){break b}}i=0;break a}$b(c,H);continue}break}zc(c);e=p+11336|0;OA(e,c);ca=v[p+11336>>2];Y=Ie(e);X=Tb(p+11320|0);c=p+4648|0;Ub(c,0,6668);hz(c);c=p+4640|0;v[c>>2]=0;v[c+4>>2]=0;c=p+4632|0;v[c>>2]=0;v[c+4>>2]=0;v[p+4624>>2]=0;v[p+4628>>2]=0;H=0;c=0;h:{while(1){d=Hc(ca,da);aa=p+16|0;I=p+4624|0;e=0;n=kb-17168|0;kb=n;v[n+17164>>2]=0;i:{j:{E=p+4648|0;k:{if(w[E+6152|0]!=255|(d|0)<5){break k}if(!wp(E+6152|0,Y)){break k}i=ox(w[Y+1|0],w[Y+2|0],v[E+6148>>2])+vp(Y)|0;v[n+17164>>2]=i;if((d|0)==(i|0)){i=d;break j}l:{if((d|0)>=(i+4|0)){if(wp(Y,i+Y|0)){break l}}v[n+17164>>2]=0;break k}if(i){break j}}f=Y;J=Ub(E,0,6668)+6148|0;$=n+17164|0;i=0;j=0;D=d-4|0;q=(D|0)>0?D:0;while(1){m:{n:{o:{p:{if((i|0)==(q|0)){i=d;break p}if(!sI(f)){break n}h=ox(w[f+1|0],w[f+2|0],v[J>>2]);e=h+vp(f)|0;g=4;o=i+4|0;q:{while(1){if(!(g>>>0>2303|h)){if((D|0)<=((g<<1)+i|0)){break q}h=0;m=f+g|0;r:{if(!wp(f,m)){break r}k=g-vp(f)|0;y=vp(m)+k|0;if((d|0)<(y+(g+o|0)|0)){break r}if(!wp(f,m+y|0)){break r}v[J>>2]=k;h=k;e=g}g=g+1|0;continue}break}if(!h|(d|0)<(e+i|0)){break q}y=d-i|0;g=0;A=0;while(1){s:{t:{if((A|0)!=10){k=(A|0)!=0;F=g;g=f+g|0;g=(F+ox(w[g+1|0],w[g+2|0],h)|0)+vp(g)|0;if((y|0)<(g+4|0)){break s}if(wp(f,f+g|0)){break t}k=0}else{k=1}break s}A=A+1|0;continue}break}if(!k){break q}j=e;break p}if((d|0)!=(e|0)|i){break o}i=0;j=d}v[$>>2]=j;e=i;break m}v[J>>2]=0}f=f+1|0;i=i+1|0;continue}break}i=v[n+17164>>2];if((d|0)>=(e+i|0)?i:0){break j}v[I>>2]=e;A=0;break i}d=e+Y|0;v[E+6152>>2]=w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24);v[I+4>>2]=e;v[I>>2]=e+i;v[I+8>>2]=w[d+3|0]>191?1:2;qa=I,ra=vI(w[d+1|0],w[d+2|0]),v[qa+12>>2]=ra;v[I+16>>2]=4-(w[d+1|0]>>>1&3);qa=I,ra=nx(w[d+1|0],w[d+2|0]),v[qa+20>>2]=ra;if(!aa){A=mx(w[d+1|0]);break i}uI(n+17152|0,d+4|0,i-4|0);if(!(t[d+1|0]&1)){ge(n+17152|0,16)}u:{if(v[I+16>>2]==3){A=0;m=n+17152|0;ja=n+3740|0;e=ja;f=0;g=w[d+1|0];i=B((g>>>3&1)+(g>>>4&1)|0,3)+(w[d+2|0]>>>2&3)|0;j=i-((i|0)!=0)|0;$=d;d=w[d+3|0]>191?1:2;v:{if(g&8){i=ge(m,9);d=d<<1;f=ge(m,d+7|0);break v}i=ge(m,d|8)>>>d|0}g=B(j,40);q=g+65072|0;o=g+65392|0;y=B(j,23)+64880|0;l=-1;h=0;w:{while(1){j=w[$+3|0];k=ge(m,12);u[e+4>>1]=k;g=ge(m,9);u[e+6>>1]=g;if((g&65535)>>>0>288){break w}g=j>>>0>191?f<<4:f;qa=e,ra=ge(m,8),t[qa+10|0]=ra;f=ge(m,w[$+1|0]&8?4:9);t[e+13|0]=22;t[e+14|0]=0;v[e>>2]=y;u[e+8>>1]=f;x:{if(ge(m,1)){f=ge(m,2);t[e+11|0]=f;if(!(f&255)){break w}f=ge(m,1);u[e+18>>1]=65287;t[e+12|0]=f;if(w[e+11|0]==2){y:{if(!(f&255)){v[e>>2]=q;t[e+18|0]=8;j=39;f=0;break y}v[e>>2]=o;j=30;f=w[$+1|0]&8?8:6}t[e+14|0]=j;t[e+13|0]=f;g=g&3855}f=ge(m,10);qa=e,ra=ge(m,3),t[qa+21|0]=ra;qa=e,ra=ge(m,3),t[qa+22|0]=ra;qa=e,ra=ge(m,3),t[qa+23|0]=ra;f=f<<5;break x}t[e+11|0]=0;t[e+12|0]=0;f=ge(m,15);qa=e,ra=ge(m,4),t[qa+18|0]=ra;j=ge(m,3);t[e+20|0]=255;t[e+19|0]=j}t[e+17|0]=f&31;t[e+15|0]=f>>>10;t[e+16|0]=f>>>5&31;h=(k&65535)+h|0;z:{if(w[$+1|0]&8){f=ge(m,1);break z}f=x[e+8>>1]>499}t[e+24|0]=f;qa=e,ra=ge(m,1),t[qa+25|0]=ra;f=ge(m,1);t[e+27|0]=g>>>12&15;t[e+26|0]=f;e=e+28|0;f=g<<4;d=d-1|0;if(d){continue}break}l=(v[m+4>>2]+h|0)>(v[m+8>>2]+(i<<3)|0)?-1:i}if(!((l|0)<0|v[n+17156>>2]>v[n+17160>>2])){h=n+17152|0;i=v[h+4>>2];f=v[h+8>>2];d=n+912|0;g=v[E+6144>>2];e=g-l|0;j=(g|0)<(l|0)?g:l;g=sc(d+12|0,(((e|0)>0?e:0)+E|0)+6156|0,j);e=(f-i|0)/8|0;sc(g+j|0,v[h>>2]+(v[h+4>>2]/8|0)|0,e);uI(d,g,e+j|0);A:{i=v[E+6144>>2]>=(l|0);if(!i){break A}ma=E+2304|0;na=n+8620|0;oa=n+3852|0;while(1){if((w[$+1|0]&8?2:1)>>>0<=A>>>0){break A}pa=Ub(oa,0,4608);d=v[I+8>>2];K=B(B(d,A),28)+ja|0;e=0;ka=(d|0)>0?d:0;G=n+912|0;y=G+7548|0;ba=E+6152|0;while(1){if((e|0)!=(ka|0)){o=B(e,28)+K|0;J=x[o+4>>1];D=v[G+4>>2];d=(G+B(e,39)|0)+16156|0;h=y;q=e;j=kb-48|0;kb=j;ia=w[o+25|0];l=B(!w[o+13|0]+(w[o+14|0]!=0)|0,28)+65712|0;B:{if(w[ba+1|0]&8){e=w[o+27|0];g=w[x[o+8>>1]+65808|0];f=g&3;t[j+47|0]=f;t[j+46|0]=f;f=g>>>2|0;t[j+45|0]=f;t[j+44|0]=f;break B}e=(w[ba+3|0]&16)>>>4&(q|0)!=0;g=e?12:0;r=x[o+8>>1]>>>e|0;while(1){if((r|0)>=0){e=3;f=1;while(1){if((e|0)>=0){k=w[(e+g|0)+65824|0];t[(j+44|0)+e|0]=((r|0)/(f|0)|0)%(k|0);e=e-1|0;f=B(f,k);continue}break}g=g+4|0;r=r-f|0;continue}break}l=g+l|0;e=-16}g=d;f=j;m=f+44|0;r=0;while(1){C:{D:{E:{if((r|0)==4){break E}Q=w[l+r|0];if(!Q){break E}if(e&8){sc(f,g,Q);break D}fa=w[m+r|0];if(!fa){Ub(f,0,Q);Ub(g,0,Q);break D}d=(e|0)>=0?-1:-1<<fa^-1;k=0;while(1){if((k|0)==(Q|0)){break D}M=ge(G,fa);t[g+k|0]=(d|0)==(M|0)?-1:M;t[f+k|0]=M;k=k+1|0;continue}}t[f+2|0]=0;t[f|0]=0;t[f+1|0]=0;break C}e=e<<1;r=r+1|0;f=f+Q|0;g=g+Q|0;continue}break}F:{f=w[o+14|0];if(f){e=2-ia|0;m=w[o+23|0]<<e;k=w[o+22|0]<<e;g=w[o+21|0]<<e;d=w[o+13|0];e=0;while(1){if(e>>>0>=f>>>0){break F}M=j+(d+e|0)|0;t[M|0]=g+w[M|0];t[M+1|0]=k+w[M+1|0];t[M+2|0]=m+w[M+2|0];e=e+3|0;continue}}if(!w[o+24|0]){break F}e=0;while(1){if((e|0)==10){break F}d=e+j|0;t[d+11|0]=w[d+11|0]+w[e+65848|0];e=e+1|0;continue}}d=ia+1|0;e=0;s=lx(C(2048),((((w[ba+3|0]&224)==96)<<1)-w[o+10|0]|0)+258|0);while(1){if(w[o+13|0]+(f&255)>>>0>e>>>0){qa=(e<<2)+h|0,sa=lx(s,w[e+j|0]<<d),z[qa>>2]=sa;e=e+1|0;f=w[o+14|0];continue}break}kb=j+48|0;k=(G+B(q,2304)|0)+2940|0;ia=D+J|0;s=C(0);e=v[G+4>>2];f=v[G>>2]+((e|0)/8|0)|0;d=w[f|0]|w[f+1|0]<<8|(w[f+2|0]<<16|w[f+3|0]<<24);g=(d<<24|d<<8&16711680|(d>>>8&65280|d>>>24))<<(e&7);l=e|-8;r=f+4|0;S=v[o>>2];U=x[o+6>>1];e=0;while(1){G:{H:{if((U|0)>0){j=e+1|0;e=e+o|0;d=w[e+15|0];fa=(u[(d<<1)+70272>>1]<<1)+65888|0;ga=w[e+18|0];if(d>>>0>=16){M=w[d+70336|0];m=32-M|0;while(1){J=w[S|0]>>>1|0;D=(J|0)>(U|0)?U:J;s=z[h>>2];while(1){e=g>>>27|0;d=5;while(1){e=u[fa+(e<<1)>>1];if((e|0)<0){g=g<<d;f=e&7;e=(g>>>32-f|0)-(e>>3)|0;l=d+l|0;d=f;continue}break}f=e&65535;e=f>>>8|0;l=e+l|0;g=g<<e;d=0;while(1){if((d|0)!=2){F=f&15;I:{if((F|0)==15){l=l+M|0;e=g<<M;while(1){if((l|0)>=0){e=w[r|0]<<l|e;r=r+1|0;l=l-8|0;continue}break}F=(g>>>m|0)+15|0;g=F;J:{if((g|0)<=128){N=z[(g<<2)+70432>>2];break J}ha=g<<3;Q=g;g=g>>>0<1024;ha=g?ha:Q;Q=ha<<1&64;R=C(C((ha&63)-Q|0)/C(Q+(ha&-64)|0));N=C((g?C(16):C(256))*C(C(C(R*C(C(R*C(.2222222238779068))+C(1.3333333730697632)))+C(1))*z[(Q+ha>>6<<2)+70432>>2]))}N=C(C(s*N)*C(e>>31|1));break I}e=g;N=C(s*z[(((e>>>27&16|F)^16)<<2)+70368>>2])}z[k>>2]=N;f=f>>>4|0;k=k+4|0;d=d+1|0;g=(F|0)!=0;l=g+l|0;g=e<<g;continue}break}while(1){if((l|0)>=0){g=w[r|0]<<l|g;r=r+1|0;l=l-8|0;continue}break}D=D-1|0;if(D){continue}break}h=h+4|0;S=S+1|0;U=U-J|0;if((U|0)<=0){break H}e=(ga|0)>0;ga=ga-1|0;if(e){continue}break}break H}while(1){m=w[S|0]>>>1|0;F=(m|0)>(U|0)?U:m;s=z[h>>2];while(1){e=g>>>27|0;d=5;while(1){e=u[fa+(e<<1)>>1];if((e|0)<0){g=g<<d;f=e&7;e=(g>>>32-f|0)-(e>>3)|0;l=d+l|0;d=f;continue}break}d=e&65535;e=d>>>8|0;l=e+l|0;g=g<<e;e=0;while(1){if((e|0)!=2){f=d&15;z[k>>2]=s*z[(((f|g>>>27&16)^16)<<2)+70368>>2];d=d>>>4|0;k=k+4|0;e=e+1|0;f=(f|0)!=0;l=f+l|0;g=g<<f;continue}break}while(1){if((l|0)>=0){g=w[r|0]<<l|g;r=r+1|0;l=l-8|0;continue}break}F=F-1|0;if(F){continue}break}h=h+4|0;S=S+1|0;U=U-m|0;if((U|0)<=0){break H}e=(ga|0)>0;ga=ga-1|0;if(e){continue}break}break H}d=1-U|0;while(1){K:{f=w[o+26|0]?70256:70224;e=w[f+(g>>>28|0)|0];if(!(e&8)){e=w[f+((g<<4>>>32-(e&3))+(e>>>3)|0)|0]}f=e&7;l=f+l|0;if((ia|0)<((l+(r-v[G>>2]<<3)|0)-24|0)){break K}d=d-1|0;if(!d){d=w[S|0];if(d>>>0<2){break K}S=S+1|0;s=z[h>>2];h=h+4|0;d=d>>>1|0}g=g<<f;if(e&128){z[k>>2]=(g|0)<0?C(-s):s;l=l+1|0;g=g<<1}if(e&64){z[k+4>>2]=(g|0)<0?C(-s):s;l=l+1|0;g=g<<1}d=d-1|0;if(!d){d=w[S|0];if(d>>>0<2){break K}S=S+1|0;s=z[h>>2];h=h+4|0;d=d>>>1|0}if(e&32){z[k+8>>2]=(g|0)<0?C(-s):s;l=l+1|0;g=g<<1}if(e&16){z[k+12>>2]=(g|0)<0?C(-s):s;l=l+1|0;g=g<<1}while(1){if((l|0)>=0){g=w[r|0]<<l|g;r=r+1|0;l=l-8|0;continue}break}k=k+16|0;continue}break}v[G+4>>2]=ia;break G}e=j;continue}break}e=q+1|0;continue}break}e=w[E+6155|0];L:{if(e&16){D=kb-16|0;kb=D;e=G+2940|0;g=e+2304|0;q=v[K>>2];o=w[K+14|0];f=o+w[K+13|0]|0;d=0;m=D+4|0;v[m+8>>2]=-1;v[m>>2]=-1;v[m+4>>2]=-1;while(1){if((d|0)!=(f|0)){y=d+q|0;j=w[y|0];h=0;M:{while(1){if(h>>>0>=j>>>0){break M}k=h<<2;if(z[k+g>>2]==C(0)){h=h+2|0;if(z[(k|4)+g>>2]==C(0)){continue}}break}v[m+((d>>>0)%3<<2)>>2]=d;j=w[y|0]}d=d+1|0;g=(j<<2)+g|0;continue}break}if(w[K+13|0]){g=v[D+4>>2];d=v[D+8>>2];g=(d|0)<(g|0)?g:d;d=v[D+12>>2];d=(d|0)<(g|0)?g:d;v[D+12>>2]=d;v[D+8>>2]=d;v[D+4>>2]=d}m=G+16195|0;j=o?3:1;g=f-j|0;h=0;while(1){if((h|0)!=(j|0)){f=g+h|0;d=f-j|0;if((d|0)<=v[(D+4|0)+(h<<2)>>2]){d=w[ba+1|0]<<28>>31&3}else{d=w[d+m|0]}t[f+m|0]=d;h=h+1|0;continue}break}q=v[K>>2];o=D+4|0;y=u[K+36>>1]&1;g=0;k=w[ba+1|0]&8?7:64;while(1){j=g+q|0;d=w[j|0];if(d){f=w[ba+3|0]&32;N:{O:{if(v[o+((g>>>0)%3<<2)>>2]>=(g|0)){break O}h=w[g+m|0];if(h>>>0>=k>>>0){break O}N=f?C(1.4142135381698608):C(1);P:{if(w[ba+1|0]&8){f=h<<3;s=z[f+70964>>2];R=z[f+70960>>2];break P}R=lx(C(1),h+1>>>1<<y);f=h&1;s=f?C(1):R;R=f?R:C(1)}R=C(N*R);s=C(N*s);h=0;while(1){if((d|0)!=(h|0)){f=(h<<2)+e|0;N=z[f>>2];z[f+2304>>2]=N*s;z[f>>2]=N*R;h=h+1|0;continue}break}break N}if(!f){break N}rI(e,d)}g=g+1|0;e=(w[j|0]<<2)+e|0;continue}break}kb=D+16|0;break L}if((e&224)!=96){break L}rI(G+2940|0,576)}k=G+7708|0;e=0;while(1){if((e|0)!=(ka|0)){d=w[E+6153|0];q=(w[K+12|0]!=0)<<1<<((B((d>>>3&1)+(d>>>4&1)|0,3)+(w[E+6154|0]>>>2&3)|0)==2);j=(G+B(e,2304)|0)+2940|0;g=j;if(w[K+14|0]){r=v[K>>2]+w[K+13|0]|0;h=((G+B(e,2304)|0)+B(q,72)|0)+2940|0;d=h;f=k;while(1){o=w[r|0];if(o){y=o<<1;l=0;while(1){if((l|0)!=(o|0)){z[f>>2]=z[d>>2];z[f+4>>2]=z[(o<<2)+d>>2];z[f+8>>2]=z[(y<<2)+d>>2];d=d+4|0;l=l+1|0;f=f+12|0;continue}break}r=r+3|0;d=(y<<2)+d|0;continue}break}sc(h,k,f-k|0);f=q-1|0}else{f=31}while(1){d=0;if((f|0)>0){while(1){if((d|0)!=8){y=d<<2;h=y+g|0;la=z[h+72>>2];F=h;N=z[y+71024>>2];R=z[y+71056>>2];h=(17-d<<2)+g|0;s=z[h>>2];z[F+72>>2]=C(la*N)-C(R*s);z[h>>2]=C(la*R)+C(s*N);d=d+1|0;continue}break}g=g+72|0;f=f-1|0;continue}break}d=j;f=B(e,1152)+E|0;g=w[K+11|0];if(q){qI(d,f,71088,q);f=B(q,36)+f|0;d=B(q,72)+d|0}Q:{if((g|0)==2){h=32-q|0;m=kb-80|0;kb=m;q=m|8;o=m|4;while(1){if((h|0)>0){y=sc(m,d,72);g=v[f+20>>2];v[d+16>>2]=v[f+16>>2];v[d+20>>2]=g;g=v[f+12>>2];v[d+8>>2]=v[f+8>>2];v[d+12>>2]=g;g=v[f+4>>2];v[d>>2]=v[f>>2];v[d+4>>2]=g;g=f+24|0;kx(y,d+24|0,g);kx(o,d+48|0,g);kx(q,f,g);d=d+72|0;f=f+36|0;h=h-1|0;continue}break}kb=m+80|0;break Q}qI(d,f,B((g|0)==3,72)+71088|0,32-q|0)}h=0;f=j+72|0;while(1){d=1;if(h>>>0<=31){while(1){if(d>>>0<=17){g=(d<<2)+f|0;z[g>>2]=-z[g>>2];d=d+2|0;continue}break}f=f+144|0;h=h+2|0;continue}break}K=K+28|0;e=e+1|0;continue}break}tI(ma,pa,18,v[I+8>>2],aa,na);A=A+1|0;aa=B(v[I+8>>2],1152)+aa|0;continue}}g=n+912|0;d=v[g+8>>2]>>>3|0;e=v[g+4>>2]+7>>>3|0;j=d-e|0;f=(j|0)<511?j:511;if((j|0)>0){fj(E+6156|0,(g+(j>>>0>511?d-511|0:e)|0)+12|0,f)}v[E+6144>>2]=f;break u}hz(E);break i}q=n+17152|0;f=0;g=0;h=0;A=0;e=d;R:{S:{T:{d=w[d+3|0];i=d>>>6|0;switch(i-1|0){case 2:break R;case 0:break T;default:break S}}g=(d>>>2&12)+4|0;break R}g=32}k=w[e+1|0];U:{if((k&6)==6){i=72492;d=32;break U}if(!(k&8)){i=72495;d=30;break U}d=w[e+2|0];j=d>>>2&3;d=nx(k,d)>>>((i|0)!=3)|0;d=d?d:192;if(d>>>0<=55){i=72516;d=(j|0)==2?12:8;break U}i=72504;d=d>>>0>95?(j|0)!=1?30:27:27}t[n+768|0]=d;t[n+769|0]=(d|0)>(g|0)?g:d;d=i;j=72400;while(1){g=w[n+768|0];if(g>>>0<=f>>>0){f=0;while(1){j=g<<1&510;if(j>>>0>f>>>0){i=f+n|0;V:{if(!w[i+770|0]){d=6;break V}d=2;if((w[e+1|0]&6)==6){break V}d=ge(q,2);g=w[n+768|0]}t[i+834|0]=d;f=f+1|0;continue}break}g=n+770|0;o=n+834|0;e=n;f=0;while(1){if((f|0)!=(j|0)){d=w[g|0];i=d?19>>>w[f+o|0]&3|4:0;g=g+1|0;y=B(d,3)-6|0;s=C(0);d=4;while(1){if(d){if(d&i){k=ge(q,6);h=(k|0)/3|0;s=C(z[(y+(B(h,-3)+k|0)<<2)+72528>>2]*C(2097152>>>h|0))}z[e>>2]=s;d=d>>>1|0;e=e+4|0;continue}break}f=f+1|0;continue}break}f=w[n+769|0];e=w[n+768|0];e=e>>>0<f>>>0?f:e;while(1){if((e|0)!=(f|0)){t[((f<<1)+n|0)+771|0]=0;f=f+1|0;continue}break}}else{if((f|0)==(A|0)){j=w[d|0]+72400|0;A=w[d+2|0]+f|0;h=w[d+1|0];d=d+3|0}k=f<<1;g=w[ge(q,h)+j|0];t[(k+n|0)+770|0]=g;i=w[n+769|0];if(i>>>0>f>>>0){g=w[ge(q,h)+j|0];i=w[n+769|0]}t[((k|1)+n|0)+770|0]=i?g:0;f=f+1|0;continue}break}i=0;d=Ub(n+3852|0,0,4608);q=E+2304|0;o=n+8620|0;A=0;W:{while(1){if((A|0)==3){break W}y=d+(i<<2)|0;D=n+17152|0;j=0;J=v[I+16>>2]|1;m=(J|0)>0?J:0;l=576;while(1){if((j|0)!=4){f=y+(B(j,J)<<2)|0;g=0;while(1){if(w[n+768|0]<<1>>>0>g>>>0){X:{k=w[(g+n|0)+770|0];if(!k){break X}if(k>>>0<=16){h=(-1<<k-1)+1|0;e=0;while(1){if((e|0)==(m|0)){break X}qa=(e<<2)+f|0,sa=C(ge(D,k)+h|0),z[qa>>2]=sa;e=e+1|0;continue}}h=2<<k-17;k=h>>>1|0;$=h|1;e=0;h=ge(D,(h-(h>>>3|0)|0)+3|0);while(1){if((e|0)==(m|0)){break X}F=h;h=(h>>>0)/($>>>0)|0;z[(e<<2)+f>>2]=F-(k+B($,h)|0)|0;e=e+1|0;continue}}g=g+1|0;f=(l<<2)+f|0;l=18-l|0;continue}break}j=j+1|0;continue}break}i=(J<<2)+i|0;if((i|0)==12){j=(A<<2)+n|0;e=d;i=w[n+769|0];f=d+B(i,72)|0;sc(f+2304|0,f,B(w[n+768|0]-i|0,72));g=0;while(1){if(w[n+768|0]>g>>>0){f=0;while(1){if((f|0)!=12){i=(f<<2)+e|0;z[i>>2]=z[j>>2]*z[i>>2];i=i+2304|0;z[i>>2]=z[j+12>>2]*z[i>>2];f=f+1|0;continue}break}j=j+24|0;e=e+72|0;g=g+1|0;continue}break}tI(q,d,12,v[I+8>>2],aa,o);Ub(d,0,4608);aa=B(v[I+8>>2],768)+aa|0;i=0}A=A+1|0;if(v[n+17156>>2]<=v[n+17160>>2]){continue}break}hz(E);A=0;break i}i=1}A=B(mx(w[E+6153|0]),i)}kb=n+17168|0;e=v[p+4624>>2];if((e|0)<0|!e&(A|0)!=0|!(e|A)){break h}Y:{if(e){e=v[p+4636>>2];if((e|0)!=(H|0)?H:0){break h}d=v[p+4632>>2];if((d|0)!=(c|0)?c:0){break h}if(d-3>>>0<4294967294|(e|0)<=0){break Y}v[p+12>>2]=0;qa=p,ra=Hc(ca,da),v[qa+8>>2]=ra;c=v[Jj(p+4624|0,p+12|0,p+8|0)>>2];v[p+12>>2]=0;qa=p,ra=Hc(ca,da),v[qa+8>>2]=ra;Y=c+Y|0;c=ca;f=v[Jj(p+4624|0,p+12|0,p+8|0)>>2];ca=c-f|0;da=da-((f>>31)+(c>>>0<f>>>0)|0)|0;Z:{if(!A){break Z}v[23540]=0;c=p+16|0;W(574,X|0,c|0,c+(B(d,A)<<1)|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){break Z}H=V(92756)|0;if((O()|0)==(ea(92756)|0)){_(H|0)|0;v[23540]=0;Z(18);f=v[23540];v[23540]=0;H=e;c=d;if((f|0)!=1){break h}H=P()|0;O()|0}od(X);Uc(p+11336|0);T(H|0);L()}H=e;c=d}if((Rc(v[X>>2],v[X+4>>2])>>>0)/(c>>>0)>>>0>268435456){break h}if(!!ca&(da|0)>=0|(da|0)>0){continue}break h}break}H=e;c=d}i=0;_:{if(!H|!c){break _}d=v[X>>2];e=v[X+4>>2];if(pc(d,e)){break _}if((Rc(d,e)>>>0)/(c>>>0)>>>0>268435456){break _}pt(a,b);e=B(b,104)+a|0;d=e+484380|0;qa=d,ra=(Rc(v[X>>2],v[X+4>>2])>>>0)/(c>>>0)|0,v[qa>>2]=ra;a=e+484414|0;b=x[a>>1];u[a>>1]=(c|0)==2?b|65:b&65470|1;Mg(d);a=e+484400|0;i=_d(v[d>>2],v[a>>2]);if(!i){break _}ao(Fb(v[X>>2]),Fb(v[X+4>>2]),v[a>>2]);i=_d(v[d>>2],v[d+20>>2])}od(X);Uc(p+11336|0)}kb=p+11360|0;return i|0}function tA(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=C(0),A=0,E=0,F=0,G=0,I=C(0),J=0,K=0,M=0,N=0,O=C(0);r=kb-1520|0;kb=r;e=r+8|0;M=Ub(e,0,1512),N=-1,v[M+1420>>2]=N;t[r+56|0]=1;v[r+48>>2]=a+b;v[r+40>>2]=a;l=kb-1024|0;kb=l;t[e+1377|0]=1;a:{if(!os(e)){break a}b=w[e+1375|0];if(!(b&2)){ec(e,34);break a}if(b&4){ec(e,34);break a}if(b&1){ec(e,34);break a}if(v[e+1116>>2]!=1){ec(e,34);break a}b=w[e+1120|0];if((b|0)!=30){b:{if((b|0)!=64){break b}if(!hx(e,l+1018|0,6)|w[l+1018|0]!=102|(w[l+1019|0]!=105|w[l+1020|0]!=115)){break b}if(w[l+1021|0]!=104|w[l+1022|0]!=101|w[l+1023|0]!=97){break b}if(($e(e)|0)!=100){break b}if($e(e)){break b}ec(e,38);break a}ec(e,34);break a}if(($e(e)|0)!=1){ec(e,34);break a}if(!hx(e,l+1018|0,6)){ec(e,10);break a}if(!fx(l+1018|0)){ec(e,34);break a}if(ej(e)){ec(e,34);break a}b=$e(e);v[e+4>>2]=b;if(!b){ec(e,34);break a}if(b>>>0>=17){ec(e,5);break a}b=ej(e);v[e>>2]=b;if(!b){ec(e,34);break a}ej(e);ej(e);ej(e);b=$e(e);j=b>>>4|0;v[e+116>>2]=1<<j;g=b&15;v[e+112>>2]=1<<g;if(g-14>>>0<=4294967287){ec(e,20);break a}if((b<<24)+536870912>>24>=0){ec(e,20);break a}c:{if(g>>>0>j>>>0){ec(e,20);break c}if(!($e(e)&1)){ec(e,34);break c}if(!os(e)){break a}if(!gx(e)){break a}if(!ix(e)){break a}if((wh(e)|0)==3){while(1){if((f|0)!=6){M=(l+1018|0)+f|0,N=wh(e),t[M|0]=N;f=f+1|0;continue}break}if(!fx(l+1018|0)){ec(e,20);break c}b=ex(e);f=fe(e,b+1|0);v[e+20>>2]=f;if(f){f=0;g=(b|0)>0?b:0;while(1){if((f|0)!=(g|0)){j=wh(e);t[v[e+20>>2]+f|0]=j;f=f+1|0;continue}break}t[b+v[e+20>>2]|0]=0;b=ex(e);v[e+28>>2]=0;v[e+24>>2]=b;d:{if((b|0)<=0){break d}b=fe(e,b<<2);v[e+28>>2]=b;if(b){break d}ec(e,3);break c}while(1){e:{f:{if(v[e+24>>2]>(h|0)){b=ex(e);f=fe(e,b+1|0);g=h<<2;v[g+v[e+28>>2]>>2]=f;if(!v[g+v[e+28>>2]>>2]){break f}f=0;j=(b|0)>0?b:0;while(1){if((f|0)==(j|0)){break e}i=wh(e);t[v[g+v[e+28>>2]>>2]+f|0]=i;f=f+1|0;continue}}if(!(wh(e)&1)){ec(e,20);break c}eI(e,w[e+1376|0]);t[e+1376|0]=0;while(1){b=ix(e);eI(e,b);t[e+1376|0]=0;if(b){continue}break}f=0;if(!gx(e)){break a}if(!mI(e)){if(v[e+100>>2]!=21){break a}v[e+100>>2]=20;break a}b=0;while(1){if((b|0)!=256){j=b<<24;g=0;while(1){if((g|0)!=8){j=j>>31&79764919^j<<1;g=g+1|0;continue}break}v[(b<<2)+463040>>2]=j;b=b+1|0;continue}break}if((wh(e)|0)==5){while(1){if((f|0)!=6){M=(l+1018|0)+f|0,N=wh(e),t[M|0]=N;f=f+1|0;continue}break}if(!fx(l+1018|0)){ec(e,20);break c}b=oc(e,8)+1|0;v[e+120>>2]=b;b=fe(e,B(b,2096));v[e+124>>2]=b;if(!b){ec(e,3);break c}Ub(b,0,B(v[e+120>>2],2096));g:{h:{while(1){i:{if(v[e+120>>2]>(E|0)){b=v[e+124>>2];if((oc(e,8)&255)!=66){ec(e,20);break c}if((oc(e,8)&255)!=67){ec(e,20);break c}if((oc(e,8)&255)!=86){ec(e,20);break c}g=b+B(E,2096)|0;M=g,N=oc(e,8)&255|oc(e,8)<<8,v[M>>2]=N;M=g,N=oc(e,8)&255|(oc(e,8)<<8&65280|oc(e,8)<<16),v[M+4>>2]=N;k=g+4|0;f=0;m=oc(e,1);if(!m){f=oc(e,1)}t[g+23|0]=f;h=v[k>>2];if(v[g>>2]){b=h;break i}b=0;if(!h){break i}ec(e,20);break c}b=oc(e,6)+1&255;f=0;j:{while(1){if((b|0)==(f|0)){break j}f=f+1|0;if(!oc(e,16)){continue}break}ec(e,20);break c}b=oc(e,6)+1|0;v[e+128>>2]=b;b=fe(e,B(b,1596));v[e+260>>2]=b;k:{if(b){E=0;k=0;l:while(1){if(v[e+128>>2]<=(k|0)){break k}b=oc(e,16);u[((k<<1)+e|0)+132>>1]=b;b=b&65535;if(b>>>0>=2){ec(e,20);break c}if(!b){b=v[e+260>>2]+B(k,1596)|0;M=b,N=oc(e,8),t[M|0]=N;M=b,N=oc(e,16),u[M+2>>1]=N;M=b,N=oc(e,16),u[M+4>>1]=N;M=b,N=oc(e,6),t[M+6|0]=N;M=b,N=oc(e,8),t[M+7|0]=N;j=oc(e,4)+1|0;t[b+8|0]=j;h=b+9|0;f=0;while(1){if((j&255)>>>0>f>>>0){M=f+h|0,N=oc(e,8),t[M|0]=N;f=f+1|0;j=w[b+8|0];continue}break}ec(e,4);break c}f=v[e+260>>2]+B(k,1596)|0;b=oc(e,5);t[f|0]=b;m=f+1|0;j=0;g=-1;while(1)if((b&255)>>>0<=j>>>0){h=g+1|0;g=f+82|0;i=f+65|0;o=f+49|0;n=f+33|0;b=0;while(1){if((b|0)!=(h|0)){M=b+n|0,N=oc(e,3)+1|0,t[M|0]=N;q=b+o|0;p=oc(e,2);t[q|0]=p;j=0;m:{if(!(p&255)){break m}p=oc(e,8);t[b+i|0]=p;if(v[e+120>>2]>(p&255)){break m}ec(e,20);break c}n:{while(1){if(1<<w[q|0]<=(j|0)){break n}p=oc(e,8)-1|0;u[(g+(b<<4)|0)+(j<<1)>>1]=p;j=j+1|0;if(v[e+120>>2]>p<<16>>16){continue}break}ec(e,20);break c}b=b+1|0;continue}break}g=2;M=f,N=oc(e,2)+1|0,t[M+1588|0]=N;b=oc(e,4);v[f+1592>>2]=2;h=0;u[f+338>>1]=0;t[f+1589|0]=b;u[f+340>>1]=1<<b;b=f+338|0;i=0;while(1){if(w[f|0]>i>>>0){o=n+w[i+m|0]|0;j=0;while(1){if(w[o|0]>j>>>0){g=oc(e,w[f+1589|0]);u[b+(v[f+1592>>2]<<1)>>1]=g;g=v[f+1592>>2]+1|0;v[f+1592>>2]=g;j=j+1|0;continue}break}i=i+1|0;continue}break}while(1){if((g|0)>(h|0)){g=x[b+(h<<1)>>1];j=(l+16|0)+(h<<2)|0;u[j+2>>1]=h;u[j>>1]=g;h=h+1|0;g=v[f+1592>>2];continue}break}dI(l+16|0,g,1086);j=0;g=v[f+1592>>2];h=g-1|0;h=(h|0)>0?h:0;o:{while(1){if((h|0)==(j|0)){h=f+838|0;j=0;break o}i=l+16|0;n=x[i+(j<<2)>>1];j=j+1|0;if((n|0)!=x[i+(j<<2)>>1]){continue}break}ec(e,20);break c}while(1){if((g|0)>(j|0)){t[h+j|0]=w[((l+16|0)+(j<<2)|0)+2|0];j=j+1|0;g=v[f+1592>>2];continue}break}q=f+1088|0;j=2;while(1){if((g|0)>(j|0)){v[l+12>>2]=0;v[l+8>>2]=0;g=0;p=(j|0)>0?j:0;i=b+(j<<1)|0;m=65536;n=-1;while(1){if((g|0)!=(p|0)){o=b+(g<<1)|0;h=x[o>>1];if(!((n|0)>=(h|0)|x[i>>1]<=h>>>0)){v[l+12>>2]=g;h=x[o>>1];n=h}if(!((h|0)>=(m|0)|x[i>>1]>=h>>>0)){v[l+8>>2]=g;m=x[o>>1]}g=g+1|0;continue}break}h=q+(j<<1)|0;t[h|0]=v[l+12>>2];t[h+1|0]=v[l+8>>2];j=j+1|0;g=v[f+1592>>2];continue}break}E=(g|0)>(E|0)?g:E;k=k+1|0;continue l}else{b=oc(e,4);t[j+m|0]=b;b=b&255;g=(b|0)>(g|0)?b:g;j=j+1|0;b=w[f|0];continue}}}ec(e,3);break c}b=oc(e,6)+1|0;v[e+264>>2]=b;b=fe(e,B(b,24));v[e+396>>2]=b;if(!b){ec(e,3);break c}k=0;Ub(b,0,B(v[e+264>>2],24));p:{q:{r:{while(1){if(v[e+264>>2]>(k|0)){b=v[e+396>>2];h=oc(e,16);u[((k<<1)+e|0)+268>>1]=h;if((h&65535)>>>0>=3){ec(e,20);break c}g=b+B(k,24)|0;M=g,N=oc(e,24),v[M>>2]=N;b=oc(e,24);v[g+4>>2]=b;if(b>>>0<y[g>>2]){ec(e,20);break c}M=g,N=oc(e,24)+1|0,v[M+8>>2]=N;M=g,N=oc(e,6)+1|0,t[M+12|0]=N;b=oc(e,8);t[g+13|0]=b;if(v[e+120>>2]<=(b&255)){break r}f=0;while(1){b=w[g+12|0];if(b>>>0>f>>>0){h=(l+16|0)+f|0;b=oc(e,3);if(oc(e,1)){i=oc(e,5)}else{i=0}t[h|0]=b+(i<<3);f=f+1|0;continue}break}b=fe(e,b<<4);v[g+20>>2]=b;if(!b){break q}h=0;while(1){if(w[g+12|0]>h>>>0){b=w[(l+16|0)+h|0];f=0;while(1){if((f|0)!=8){s:{if(b>>>f&1){j=oc(e,8);m=f<<1;i=h<<4;u[m+(i+v[g+20>>2]|0)>>1]=j;if(v[e+120>>2]>u[m+(i+v[g+20>>2]|0)>>1]){break s}ec(e,20);break c}u[(v[g+20>>2]+(h<<4)|0)+(f<<1)>>1]=65535}f=f+1|0;continue}break}h=h+1|0;continue}break}h=fe(e,v[(v[e+124>>2]+B(w[g+13|0],2096)|0)+4>>2]<<2);v[g+16>>2]=h;if(!h){ec(e,3);break c}b=0;Ub(h,0,v[(v[e+124>>2]+B(w[g+13|0],2096)|0)+4>>2]<<2);while(1){h=v[e+124>>2]+B(w[g+13|0],2096)|0;if(v[h+4>>2]>(b|0)){f=v[h>>2];j=fe(e,f);h=b<<2;v[h+v[g+16>>2]>>2]=j;j=b;if(v[h+v[g+16>>2]>>2]){while(1){if((f|0)>0){f=f-1|0;t[f+v[h+v[g+16>>2]>>2]|0]=(j|0)%w[g+12|0];j=(j|0)/w[g+12|0]|0;continue}break}b=b+1|0;continue}else{ec(e,3);break c}}break}k=k+1|0;continue}break}b=oc(e,6)+1|0;v[e+400>>2]=b;b=fe(e,B(b,40));v[e+404>>2]=b;if(!b){ec(e,3);break c}Ub(b,0,B(v[e+400>>2],40));i=0;while(1){if(v[e+400>>2]>(i|0)){b=v[e+404>>2];if(oc(e,16)){ec(e,20);break c}h=b+B(i,40)|0;b=fe(e,B(v[e+4>>2],3));v[h+4>>2]=b;if(!b){ec(e,3);break c}if(oc(e,1)){b=oc(e,4)+1|0}else{b=1}t[h+8|0]=b;t:{if(oc(e,1)){b=oc(e,8)+1|0;u[h>>1]=b;f=0;g=v[e+4>>2];if((g|0)<(b&65535)){ec(e,20);break c}while(1){if((b&65535)>>>0<=f>>>0){break t}g=oc(e,im(g-1|0));b=B(f,3);t[b+v[h+4>>2]|0]=g;g=oc(e,im(v[e+4>>2]-1|0));t[(b+v[h+4>>2]|0)+1|0]=g;g=v[e+4>>2];b=b+v[h+4>>2]|0;j=w[b|0];if((g|0)<=(j|0)){ec(e,20);break c}b=w[b+1|0];if((b|0)>=(g|0)){ec(e,20);break c}if((b|0)!=(j|0)){f=f+1|0;b=x[h>>1];continue}break}ec(e,20);break c}u[h>>1]=0}if(oc(e,2)){ec(e,20);break c}g=0;b=0;f=0;u:{if(w[h+8|0]>=2){while(1){if(v[e+4>>2]<=(b|0)){break u}f=oc(e,4);j=B(b,3);t[(j+v[h+4>>2]|0)+2|0]=f;b=b+1|0;if(w[(j+v[h+4>>2]|0)+2|0]<w[h+8|0]){continue}break}ec(e,20);break c}while(1){if(v[e+4>>2]<=(f|0)){break u}t[(v[h+4>>2]+B(f,3)|0)+2|0]=0;f=f+1|0;continue}}v:{while(1){if(w[h+8|0]<=g>>>0){break v}oc(e,8);b=g+h|0;M=b,N=oc(e,8),t[M+9|0]=N;f=oc(e,8);t[b+24|0]=f;if(v[e+128>>2]<=w[b+9|0]){ec(e,20);break c}g=g+1|0;if(v[e+264>>2]>(f&255)){continue}break}ec(e,20);break c}i=i+1|0;continue}break}f=oc(e,6)+1|0;v[e+408>>2]=f;h=e+412|0;j=0;w:{while(1){if((f|0)<=(j|0)){break w}b=h+B(j,6)|0;M=b,N=oc(e,1),t[M|0]=N;M=b,N=oc(e,16),u[M+2>>1]=N;M=b,N=oc(e,16),u[M+4>>1]=N;f=oc(e,8);t[b+1|0]=f;if(x[b+2>>1]){ec(e,20);break c}if(x[b+4>>1]){ec(e,20);break c}if(v[e+400>>2]>(f&255)){j=j+1|0;f=v[e+408>>2];continue}break}ec(e,20);break c}kI(e);v[e+992>>2]=0;h=E<<1;f=0;while(1){if(v[e+4>>2]>(f|0)){b=(f<<2)+e|0;M=b,N=fe(e,v[e+116>>2]<<2),v[M+800>>2]=N;M=b,N=fe(e,v[e+116>>2]<<1&2147483646),v[M+928>>2]=N;g=fe(e,h);v[b+996>>2]=g;j=v[b+800>>2];if(g?!j|!v[b+928>>2]:1){ec(e,3);break c}Ub(j,0,v[e+116>>2]<<2);f=f+1|0;continue}break}f=0;if(!cI(e,0,v[e+112>>2])){break a}if(!cI(e,1,v[e+116>>2])){break a}v[e+104>>2]=v[e+112>>2];h=v[e+116>>2];v[e+108>>2]=h;b=v[e+264>>2];i=(b|0)>0?b:0;b=(h|0)/2|0;g=0;while(1){if((f|0)!=(i|0)){j=v[e+396>>2]+B(f,24)|0;k=v[j+4>>2];n=b>>>0>k>>>0?k:b;k=v[j>>2];j=(n-(b>>>0>k>>>0?k:b)>>>0)/y[j+8>>2]|0;g=(g|0)<(j|0)?j:g;f=f+1|0;continue}break}b=h<<1&2147483646;h=B(v[e+4>>2],(g<<2)+4|0);b=b>>>0>h>>>0?b:h;v[e+12>>2]=b;x:{if(!v[e+80>>2]){break x}h=v[e+92>>2];if((h|0)!=v[e+84>>2]){break p}if(h>>>0>=(b+v[e+88>>2]|0)+1512>>>0){break x}ec(e,3);break c}y:{if(v[e+1380>>2]==-1){v[e+52>>2]=w[e+48|0]?0:v[e+32>>2]-v[e+36>>2]|0;break y}v[e+52>>2]=0}f=1;break a}ec(e,20);break c}ec(e,3);break c}aa(7304,13179,4196,8858);L()}z:{if(f&255){j=Hn(e,b);break z}j=fe(e,b);v[g+8>>2]=j}if(!j){ec(e,3);break c}i=0;A:{if(!m){f=0;while(1){b=v[k>>2];if((f|0)>=(b|0)){break A}B:{C:{if(w[g+23|0]){if(!oc(e,1)){break C}}b=oc(e,5)+1|0;t[f+j|0]=b;if((b&255)!=32){i=i+1|0;break B}ec(e,20);break c}t[f+j|0]=255}f=f+1|0;continue}}h=oc(e,5);f=0;while(1){b=v[k>>2];if((f|0)>=(b|0)){break A}m=oc(e,im(b-f|0));h=h+1|0;if((h|0)>=32){ec(e,20);break c}b=f+m|0;if((b|0)>v[k>>2]){ec(e,20);break c}else{Ub(f+j|0,h,m);f=b;continue}}}D:{E:{F:{if(w[g+23|0]){if(b>>2>(i|0)){break F}if(v[e+16>>2]<(b|0)){v[e+16>>2]=b;b=v[k>>2]}b=fe(e,b);v[g+8>>2]=b;if(!b){ec(e,3);break c}sc(b,j,v[k>>2]);dj(e,j,v[k>>2]);j=v[g+8>>2];t[g+23|0]=0;b=v[k>>2]}h=0;i=(b|0)>0?b:0;f=0;while(1){if((f|0)!=(i|0)){h=((w[f+j|0]-11&255)>>>0<244)+h|0;f=f+1|0;continue}break}v[g+2092>>2]=h;b=fe(e,b<<2);v[g+32>>2]=b;if(b){m=g+2092|0;f=0;break E}ec(e,3);break c}v[g+2092>>2]=i;m=g+2092|0;G:{if(!i){f=0;h=0;break G}b=fe(e,i);v[g+8>>2]=b;if(!b){ec(e,3);break c}b=Hn(e,v[m>>2]<<2);v[g+32>>2]=b;if(!b){ec(e,3);break c}f=Hn(e,v[m>>2]<<2);if(!f){break D}b=v[k>>2];h=v[m>>2]}b=(h<<3)+b|0;if(b>>>0<=y[e+16>>2]){break E}v[e+16>>2]=b}n=v[k>>2];b=0;h=kb-128|0;kb=h;o=Ub(h,0,128);h=(n|0)>0?n:0;while(1){H:{I:{if((b|0)!=(h|0)){if(w[b+j|0]==255){break I}h=b}if((h|0)==(n|0)){b=1;if(!v[g+2092>>2]){break H}aa(15767,13179,1103,7548);L()}b=h+j|0;i=w[b|0];if(i>>>0<32){aI(g,0,h,0,i,f);q=1;i=w[b|0]+1|0;b=1;J:{while(1){if((b|0)==(i|0)){K:while(1){L:{b=1;h=h+1|0;if((n|0)<=(h|0)){break H}F=h+j|0;i=w[F|0];if((i|0)==255){continue}b=i;if(b>>>0>=32){break L}while(1){if((b|0)<=0){b=0;break H}G=o+(b<<2)|0;p=v[G>>2];if(!p){b=b-1|0;continue}break}v[G>>2]=0;aI(g,gm(p),h,q,i,f);q=q+1|0;i=w[F|0];if((i|0)==(b|0)){continue}while(1){if((b|0)>=(i|0)){continue K}F=o+(i<<2)|0;if(v[F>>2]){break J}v[F>>2]=p+(1<<32-i);i=i-1|0;continue}}break}}else{v[o+(b<<2)>>2]=1<<32-b;b=b+1|0;continue}break}aa(15271,13179,1118,7548);L()}aa(15811,13179,1133,7548);L()}aa(15278,13179,1104,7548);L()}b=b+1|0;continue}break}kb=o+128|0;if(!b){if(w[g+23|0]){dj(e,f,0)}ec(e,20);break c}b=v[m>>2];if(b){b=fe(e,(b<<2)+4|0);v[g+2084>>2]=b;if(!b){ec(e,3);break c}b=fe(e,(v[m>>2]<<2)+4|0);v[g+2088>>2]=b;if(!b){ec(e,3);break c}v[g+2088>>2]=b+4;v[b>>2]=-1;b=0;i=0;M:{N:{O:{if(w[g+23|0]){while(1){i=v[g+2092>>2];if((i|0)<=(b|0)){break O}h=b<<2;M=h+v[g+2084>>2]|0,N=gm(v[h+v[g+32>>2]>>2]),v[M>>2]=N;b=b+1|0;continue}}while(1){if(v[g+4>>2]>(b|0)){if($H(w[g+23|0],w[b+j|0])){M=v[g+2084>>2]+(i<<2)|0,N=gm(v[v[g+32>>2]+(b<<2)>>2]),v[M>>2]=N;i=i+1|0}b=b+1|0;continue}break}if(v[g+2092>>2]!=(i|0)){break N}}dI(v[g+2084>>2],i,1087);v[v[g+2084>>2]+(v[g+2092>>2]<<2)>>2]=-1;h=0;b=v[g+(w[g+23|0]?2092:4)>>2];p=(b|0)>0?b:0;P:{while(1){if((h|0)!=(p|0)){b=h;i=w[g+23|0];b=i?v[(b<<2)+f>>2]:b;F=w[b+j|0];Q:{if(!$H(i,F)){break Q}G=h<<2;n=gm(v[G+v[g+32>>2]>>2]);b=v[g+2092>>2];i=0;while(1){if((b|0)>=2){o=b>>>1|0;J=o+i|0;q=n>>>0<y[v[g+2084>>2]+(J<<2)>>2];b=q?o:b-o|0;i=q?i:J;continue}break}b=i<<2;if((n|0)!=v[b+v[g+2084>>2]>>2]){break P}if(w[g+23|0]){v[b+v[g+2088>>2]>>2]=v[f+G>>2];t[v[g+8>>2]+i|0]=F;break Q}v[b+v[g+2088>>2]>>2]=h}h=h+1|0;continue}break}break M}aa(12220,13179,1230,10001);L()}aa(7489,13179,1200,10001);L()}}if(w[g+23|0]){dj(e,f,v[m>>2]<<2);dj(e,v[g+32>>2],v[m>>2]<<2);dj(e,j,v[k>>2]);v[g+32>>2]=0}i=g;b=0;f=0;while(1){if((b|0)!=1024){u[(i+(b<<1)|0)+36>>1]=65535;b=b+1|0;continue}break}b=v[i+(w[i+23|0]?2092:4)>>2];b=(b|0)<32767?b:32767;h=(b|0)>0?b:0;while(1){if((f|0)!=(h|0)){R:{if(w[v[i+8>>2]+f|0]>10){break R}S:{if(w[i+23|0]){b=gm(v[v[i+2084>>2]+(f<<2)>>2]);break S}b=v[v[i+32>>2]+(f<<2)>>2]}while(1){if(b>>>0>1023){break R}u[(i+(b<<1)|0)+36>>1]=f;b=(1<<w[v[i+8>>2]+f|0])+b|0;continue}}f=f+1|0;continue}break}b=oc(e,4);t[i+21|0]=b;b=b&255;if(b>>>0>=3){ec(e,20);break c}if(b){M=i,O=bI(oc(e,32)),z[M+12>>2]=O;M=i,O=bI(oc(e,32)),z[M+16>>2]=O;M=i,N=oc(e,4)+1|0,t[M+20|0]=N;M=i,N=oc(e,1),t[M+22|0]=N;f=v[i>>2];h=v[k>>2];T:{if(w[i+21|0]==1){A=H(Ds(+C(C(Ep(+C(h|0)))/C(f|0))));U:{if(D(A)<2147483648){b=~~A;break U}b=-2147483648}A=+(f|0);K=H(ck(+C(C(b|0)+C(1)),A));V:{if(D(K)<2147483648){f=~~K;break V}f=-2147483648}b=((f|0)<=(h|0))+b|0;s=C(b|0);if(ck(+C(s+C(1)),A)<=+(h|0)){f=-1}else{A=H(ck(+s,A));W:{if(D(A)<2147483648){f=~~A;break W}f=-2147483648}f=(f|0)>(h|0)?-1:b}if((f|0)>=0){break T}ec(e,20);break c}f=B(f,h)}v[i+24>>2]=f;if(!f){ec(e,20);break c}n=Hn(e,f<<1);if(!n){break h}f=0;while(1){j=v[i+24>>2];if((j|0)>(f|0)){b=oc(e,w[i+20|0]);if((b|0)==-1){dj(e,n,v[i+24>>2]<<1);ec(e,20);break c}else{u[n+(f<<1)>>1]=b;f=f+1|0;continue}}break}X:{Y:{if(w[i+21|0]==1){o=w[i+23|0];Z:{if(o){f=v[m>>2];if(f){break Z}break X}f=v[k>>2]}b=fe(e,B(v[i>>2],f)<<2);v[i+28>>2]=b;if(!b){dj(e,n,v[i+24>>2]<<1);ec(e,3);break c}h=0;b=v[(o?m:k)>>2];m=(b|0)>0?b:0;q=i+2088|0;s=C(0);while(1){if((h|0)==(m|0)){break Y}g=h;g=o?v[v[q>>2]+(g<<2)>>2]:g;j=v[i>>2];f=0;b=1;while(1){if((f|0)<(j|0)){I=C(s+C(C(C(x[n+(((g>>>0)/(b>>>0)>>>0)%y[i+24>>2]<<1)>>1])*z[i+16>>2])+z[i+12>>2]));z[v[i+28>>2]+(B(h,j)+f<<2)>>2]=I;s=w[i+22|0]?I:s;f=f+1|0;j=v[i>>2];if((f|0)>=(j|0)){continue}k=v[i+24>>2];Jka(k,0,b,0);if(nb){dj(e,n,k<<1);ec(e,20);break c}else{b=B(b,k);continue}}break}h=h+1|0;continue}}b=fe(e,j<<2);v[i+28>>2]=b;if(!b){break g}f=0;s=C(0);while(1){j=v[i+24>>2];if((j|0)<=(f|0)){break X}I=C(s+C(C(C(x[n+(f<<1)>>1])*z[i+16>>2])+z[i+12>>2]));z[v[i+28>>2]+(f<<2)>>2]=I;s=w[i+22|0]?I:s;f=f+1|0;continue}}t[i+21|0]=2;j=v[i+24>>2]}dj(e,n,j<<1)}E=E+1|0;continue}break}ec(e,3);break c}ec(e,3);break c}dj(e,n,v[i+24>>2]<<1);ec(e,3);break c}ec(e,20);break c}ec(e,3);break c}t[b+v[v[e+28>>2]+(h<<2)>>2]|0]=0;h=h+1|0;continue}}ec(e,3);break c}ec(e,20)}f=0}kb=l+1024|0;_:{$:{if(!f){v[d>>2]=v[r+104>>2]?1:v[r+108>>2];break $}b=fe(r+8|0,1512);if(b){M=c,N=v[sc(b,r+8|0,1512)+32>>2]-a|0,v[M>>2]=N;v[d>>2]=0;break _}}nI(r+8|0);b=0}kb=r+1520|0;return b}function WG(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,u=0,x=0,z=0,A=0,D=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0;s=kb-48|0;kb=s;a:{if(c>>>0<=2){c=c<<2;I=v[c+79596>>2];J=v[c+79584>>2];while(1){c=v[b+4>>2];b:{if((c|0)!=v[b+104>>2]){v[b+4>>2]=c+1;c=w[c|0];break b}c=rd(b)}if(Vk(c)){continue}break}o=1;c:{d:{switch(c-43|0){case 0:case 2:break d;default:break c}}o=(c|0)==45?-1:1;c=v[b+4>>2];if((c|0)!=v[b+104>>2]){v[b+4>>2]=c+1;c=w[c|0];break c}c=rd(b)}e:{f:{while(1){if(t[g+4955|0]==(c|32)){g:{if(g>>>0>6){break g}c=v[b+4>>2];if((c|0)!=v[b+104>>2]){v[b+4>>2]=c+1;c=w[c|0];break g}c=rd(b)}g=g+1|0;if((g|0)!=8){continue}break f}break}if((g|0)!=3){if((g|0)==8){break f}if(!d|g>>>0<4){break e}if((g|0)==8){break f}}c=v[b+116>>2];if((c|0)>0|(c|0)>=0){v[b+4>>2]=v[b+4>>2]-1}if(!d|g>>>0<4){break f}c=(c|0)<0;while(1){if(!c){v[b+4>>2]=v[b+4>>2]-1}g=g-1|0;if(g>>>0>3){continue}break}}i=kb-16|0;kb=i;l=(p(C(C(o|0)*C(N))),j(2));b=l&2147483647;h:{if(b-8388608>>>0<=2130706431){r=b<<25;c=(b>>>7|0)+1065353216|0;break h}r=l<<25;c=l>>>7|2147418112;if(b>>>0>=2139095040){break h}r=0;c=0;if(!b){break h}c=b;b=E(b);Kf(i,c,0,0,0,b+81|0);k=v[i>>2];h=v[i+4>>2];r=v[i+8>>2];c=v[i+12>>2]^65536|16265-b<<16}v[s>>2]=k;v[s+4>>2]=h;v[s+8>>2]=r;v[s+12>>2]=l&-2147483648|c;kb=i+16|0;k=v[s+8>>2];h=v[s+12>>2];i=v[s>>2];l=v[s+4>>2];break a}i:{j:{k:{if(g){break k}g=0;while(1){if(t[g+9997|0]!=(c|32)){break k}l:{if(g>>>0>1){break l}c=v[b+4>>2];if((c|0)!=v[b+104>>2]){v[b+4>>2]=c+1;c=w[c|0];break l}c=rd(b)}g=g+1|0;if((g|0)!=3){continue}break}break j}m:{switch(g|0){case 0:n:{if((c|0)!=48){break n}g=v[b+4>>2];o:{if((g|0)!=v[b+104>>2]){v[b+4>>2]=g+1;g=w[g|0];break o}g=rd(b)}if((g&-33)==88){g=d;c=0;f=kb-432|0;kb=f;p:{q:{d=v[b+4>>2];if((d|0)!=v[b+104>>2]){v[b+4>>2]=d+1;c=w[d|0];break q}d=0;break p}d=1}while(1){r:{s:{t:{u:{v:{w:{x:{y:{if(!d){c=rd(b);break y}if((c|0)!=48){l=1073676288;if((c|0)==46){break w}break v}d=v[b+4>>2];if((d|0)==v[b+104>>2]){break x}n=1;v[b+4>>2]=d+1;c=w[d|0]}d=1;continue}n=1;break s}c=v[b+4>>2];z:{if((c|0)!=v[b+104>>2]){v[b+4>>2]=c+1;c=w[c|0];break z}c=rd(b)}if((c|0)==48){break u}F=1}break t}while(1){c=r;r=c-1|0;u=u-!c|0;F=1;c=v[b+4>>2];A:{if((c|0)!=v[b+104>>2]){v[b+4>>2]=c+1;c=w[c|0];break A}c=rd(b)}if((c|0)==48){continue}break}n=1}while(1){e=c|32;B:{C:{M=c-48|0;if(M>>>0<10){break C}if(!((c|0)==46|e-97>>>0<6)){d=c;break r}d=46;if((c|0)!=46){break C}if(F){break r}F=1;r=k;u=h;break B}c=(c|0)>57?e-87|0:M;D:{if((h|0)<=0&k>>>0<=7|(h|0)<0){x=c+(x<<4)|0;break D}if(!h&k>>>0<=28){ah(f+48|0,c);Jd(f+32|0,G,H,i,l,0,0,0,1073414144);G=v[f+32>>2];H=v[f+36>>2];i=v[f+40>>2];l=v[f+44>>2];Jd(f+16|0,v[f+48>>2],v[f+52>>2],v[f+56>>2],v[f+60>>2],G,H,i,l);Fg(f,v[f+16>>2],v[f+20>>2],v[f+24>>2],v[f+28>>2],m,q,A,D);A=v[f+8>>2];D=v[f+12>>2];m=v[f>>2];q=v[f+4>>2];break D}if(!c|z){break D}Jd(f+80|0,G,H,i,l,0,0,0,1073610752);Fg(f- -64|0,v[f+80>>2],v[f+84>>2],v[f+88>>2],v[f+92>>2],m,q,A,D);A=v[f+72>>2];D=v[f+76>>2];z=1;m=v[f+64>>2];q=v[f+68>>2]}c=k+1|0;h=c?h:h+1|0;k=c;n=1}c=v[b+4>>2];if((c|0)!=v[b+104>>2]){v[b+4>>2]=c+1;c=w[c|0]}else{c=rd(b)}continue}}d=0;continue}break}E:{if(!n){c=v[b+116>>2];F:{G:{if((c|0)>0|(c|0)>=0){c=v[b+4>>2];v[b+4>>2]=c-1;if(!g){break G}v[b+4>>2]=c-2;if(!F){break F}v[b+4>>2]=c-3;break F}if(g){break F}}mi(b,0,0)}Ti(f+96|0,+(o|0)*0);m=v[f+96>>2];q=v[f+100>>2];c=v[f+108>>2];b=v[f+104>>2];break E}if((h|0)<=0&k>>>0<=7|(h|0)<0){i=k;l=h;while(1){x=x<<4;c=i+1|0;l=c?l:l+1|0;i=c;if((c|0)!=8|l){continue}break}}H:{I:{J:{if((d&-33)==80){i=VG(b,g);c=nb;l=c;if(i|(c|0)!=-2147483648){break H}if(g){c=v[b+116>>2];if((c|0)>0|(c|0)>=0){break J}break I}m=0;q=0;mi(b,0,0);c=0;b=0;break E}i=0;l=0;if(v[b+116>>2]<0){break H}}v[b+4>>2]=v[b+4>>2]-1}i=0;l=0}if(!x){Ti(f+112|0,+(o|0)*0);m=v[f+112>>2];q=v[f+116>>2];c=v[f+124>>2];b=v[f+120>>2];break E}b=F?r:k;h=(F?u:h)<<2|b>>>30;b=i+(b<<2)|0;d=h+l|0;d=b>>>0<i>>>0?d+1|0:d;k=b-32|0;h=d-(b>>>0<32)|0;b=h;if(k>>>0>0-I>>>0&(b|0)>=0|(b|0)>0){v[116016]=68;ah(f+160|0,o);Jd(f+144|0,v[f+160>>2],v[f+164>>2],v[f+168>>2],v[f+172>>2],-1,-1,-1,2147418111);Jd(f+128|0,v[f+144>>2],v[f+148>>2],v[f+152>>2],v[f+156>>2],-1,-1,-1,2147418111);m=v[f+128>>2];q=v[f+132>>2];c=v[f+140>>2];b=v[f+136>>2];break E}b=I-226|0;c=b>>31;if((h|0)>=(c|0)&b>>>0<=k>>>0|(c|0)<(h|0)){if((x|0)>=0){while(1){Fg(f+416|0,m,q,A,D,0,0,0,-1073807360);c=US(m,q,A,D,1073610752);b=(c|0)<0;Fg(f+400|0,m,q,A,D,b?m:v[f+416>>2],b?q:v[f+420>>2],b?A:v[f+424>>2],b?D:v[f+428>>2]);b=k;k=b-1|0;h=h-!b|0;A=v[f+408>>2];D=v[f+412>>2];m=v[f+400>>2];q=v[f+404>>2];x=x<<1|(c|0)>=0;if((x|0)>=0){continue}break}}d=h-((I>>31)+(k>>>0<I>>>0)|0)|0;b=(k-I|0)+32|0;d=b>>>0<32?d+1|0:d;c=b>>>0<J>>>0&(d|0)<=0|(d|0)<0?(b|0)>0?b:0:J;K:{if((c|0)>=113){ah(f+384|0,o);r=v[f+392>>2];u=v[f+396>>2];G=v[f+384>>2];H=v[f+388>>2];h=0;b=0;break K}Ti(f+352|0,Wj(1,144-c|0));ah(f+336|0,o);G=v[f+336>>2];H=v[f+340>>2];r=v[f+344>>2];u=v[f+348>>2];YG(f+368|0,v[f+352>>2],v[f+356>>2],v[f+360>>2],v[f+364>>2],G,H,r,u);K=v[f+376>>2];L=v[f+380>>2];h=v[f+372>>2];b=v[f+368>>2]}c=!(x&1)&((Hm(m,q,A,D,0,0,0,0)|0)!=0&(c|0)<32);qn(f+320|0,c+x|0);Jd(f+304|0,G,H,r,u,v[f+320>>2],v[f+324>>2],v[f+328>>2],v[f+332>>2]);d=b;Fg(f+272|0,v[f+304>>2],v[f+308>>2],v[f+312>>2],v[f+316>>2],b,h,K,L);b=c;Jd(f+288|0,G,H,r,u,b?0:m,b?0:q,b?0:A,b?0:D);Fg(f+256|0,v[f+288>>2],v[f+292>>2],v[f+296>>2],v[f+300>>2],v[f+272>>2],v[f+276>>2],v[f+280>>2],v[f+284>>2]);Mx(f+240|0,v[f+256>>2],v[f+260>>2],v[f+264>>2],v[f+268>>2],d,h,K,L);b=v[f+240>>2];c=v[f+244>>2];d=v[f+248>>2];h=v[f+252>>2];if(!Hm(b,c,d,h,0,0,0,0)){v[116016]=68}XG(f+224|0,b,c,d,h,k);m=v[f+224>>2];q=v[f+228>>2];c=v[f+236>>2];b=v[f+232>>2];break E}v[116016]=68;ah(f+208|0,o);Jd(f+192|0,v[f+208>>2],v[f+212>>2],v[f+216>>2],v[f+220>>2],0,0,0,65536);Jd(f+176|0,v[f+192>>2],v[f+196>>2],v[f+200>>2],v[f+204>>2],0,0,0,65536);m=v[f+176>>2];q=v[f+180>>2];c=v[f+188>>2];b=v[f+184>>2]}v[s+16>>2]=m;v[s+20>>2]=q;v[s+24>>2]=b;v[s+28>>2]=c;kb=f+432|0;k=v[s+24>>2];h=v[s+28>>2];i=v[s+16>>2];l=v[s+20>>2];break a}if(v[b+116>>2]<0){break n}v[b+4>>2]=v[b+4>>2]-1}g=b;f=o;x=d;d=0;o=0;e=kb-8976|0;kb=e;K=I+J|0;L=0-K|0;L:{M:{while(1){if((c|0)!=48){N:{if((c|0)!=46){break L}b=v[g+4>>2];if((b|0)==v[g+104>>2]){break N}v[g+4>>2]=b+1;c=w[b|0];break M}}else{b=v[g+4>>2];if((b|0)!=v[g+104>>2]){d=1;v[g+4>>2]=b+1;c=w[b|0]}else{d=1;c=rd(g)}continue}break}c=rd(g)}n=1;if((c|0)!=48){break L}while(1){b=k;k=b-1|0;h=h-!b|0;b=v[g+4>>2];O:{if((b|0)!=v[g+104>>2]){v[g+4>>2]=b+1;c=w[b|0];break O}c=rd(g)}if((c|0)==48){continue}break}d=1}v[e+784>>2]=0;P:{Q:{b=(c|0)==46;m=c-48|0;R:{S:{T:{U:{if(b|m>>>0<=9){while(1){V:{if(b&1){if(!n){k=i;h=l;n=1;break V}b=!d;break U}b=i+1|0;l=b?l:l+1|0;i=b;if((o|0)<=2044){F=(c|0)==48?F:i;b=(e+784|0)+(o<<2)|0;if(z){m=(B(v[b>>2],10)+c|0)-48|0}v[b>>2]=m;d=1;c=z+1|0;b=(c|0)==9;z=b?0:c;o=b+o|0;break V}if((c|0)==48){break V}v[e+8960>>2]=v[e+8960>>2]|1;F=18396}b=v[g+4>>2];W:{if((b|0)!=v[g+104>>2]){v[g+4>>2]=b+1;c=w[b|0];break W}c=rd(g)}b=(c|0)==46;m=c-48|0;if(b|m>>>0<10){continue}break}}k=n?k:i;h=n?h:l;if(!(!d|(c&-33)!=69)){m=VG(g,x);b=nb;q=b;X:{if(m|(b|0)!=-2147483648){break X}if(!x){break R}m=0;q=0;if(v[g+116>>2]<0){break X}v[g+4>>2]=v[g+4>>2]-1}if(!d){break S}h=h+q|0;b=k+m|0;h=b>>>0<m>>>0?h+1|0:h;k=b;break Q}b=!d;if((c|0)<0){break T}}if(v[g+116>>2]<0){break T}v[g+4>>2]=v[g+4>>2]-1}if(!b){break Q}}v[116016]=28}i=0;l=0;mi(g,0,0);c=0;b=0;break P}b=v[e+784>>2];if(!b){Ti(e,+(f|0)*0);i=v[e>>2];l=v[e+4>>2];c=v[e+12>>2];b=v[e+8>>2];break P}if(!((k|0)!=(i|0)|(h|0)!=(l|0)|(i>>>0>9&(l|0)>=0|(l|0)>0)|(b>>>J|0?(J|0)<=30:0))){ah(e+48|0,f);qn(e+32|0,b);Jd(e+16|0,v[e+48>>2],v[e+52>>2],v[e+56>>2],v[e+60>>2],v[e+32>>2],v[e+36>>2],v[e+40>>2],v[e+44>>2]);i=v[e+16>>2];l=v[e+20>>2];c=v[e+28>>2];b=v[e+24>>2];break P}if(k>>>0>(I|0)/-2>>>0&(h|0)>=0|(h|0)>0){v[116016]=68;ah(e+96|0,f);Jd(e+80|0,v[e+96>>2],v[e+100>>2],v[e+104>>2],v[e+108>>2],-1,-1,-1,2147418111);Jd(e- -64|0,v[e+80>>2],v[e+84>>2],v[e+88>>2],v[e+92>>2],-1,-1,-1,2147418111);i=v[e+64>>2];l=v[e+68>>2];c=v[e+76>>2];b=v[e+72>>2];break P}b=I-226|0;c=k>>>0<b>>>0;b=b>>31;if(c&(h|0)<=(b|0)|(b|0)>(h|0)){v[116016]=68;ah(e+144|0,f);Jd(e+128|0,v[e+144>>2],v[e+148>>2],v[e+152>>2],v[e+156>>2],0,0,0,65536);Jd(e+112|0,v[e+128>>2],v[e+132>>2],v[e+136>>2],v[e+140>>2],0,0,0,65536);i=v[e+112>>2];l=v[e+116>>2];c=v[e+124>>2];b=v[e+120>>2];break P}if(z){if((z|0)<=8){b=(e+784|0)+(o<<2)|0;g=v[b>>2];while(1){g=B(g,10);z=z+1|0;if((z|0)!=9){continue}break}v[b>>2]=g}o=o+1|0}Y:{n=k;if((F|0)>(k|0)|(F|0)>8|(k|0)>17){break Y}if((n|0)==9){ah(e+192|0,f);qn(e+176|0,v[e+784>>2]);Jd(e+160|0,v[e+192>>2],v[e+196>>2],v[e+200>>2],v[e+204>>2],v[e+176>>2],v[e+180>>2],v[e+184>>2],v[e+188>>2]);i=v[e+160>>2];l=v[e+164>>2];c=v[e+172>>2];b=v[e+168>>2];break P}if((n|0)<=8){ah(e+272|0,f);qn(e+256|0,v[e+784>>2]);Jd(e+240|0,v[e+272>>2],v[e+276>>2],v[e+280>>2],v[e+284>>2],v[e+256>>2],v[e+260>>2],v[e+264>>2],v[e+268>>2]);ah(e+224|0,v[(0-n<<2)+79584>>2]);IP(e+208|0,v[e+240>>2],v[e+244>>2],v[e+248>>2],v[e+252>>2],v[e+224>>2],v[e+228>>2],v[e+232>>2],v[e+236>>2]);i=v[e+208>>2];l=v[e+212>>2];c=v[e+220>>2];b=v[e+216>>2];break P}b=(J+B(n,-3)|0)+27|0;c=v[e+784>>2];if(c>>>b|0?(b|0)<=30:0){break Y}ah(e+352|0,f);qn(e+336|0,c);Jd(e+320|0,v[e+352>>2],v[e+356>>2],v[e+360>>2],v[e+364>>2],v[e+336>>2],v[e+340>>2],v[e+344>>2],v[e+348>>2]);ah(e+304|0,v[(n<<2)+79512>>2]);Jd(e+288|0,v[e+320>>2],v[e+324>>2],v[e+328>>2],v[e+332>>2],v[e+304>>2],v[e+308>>2],v[e+312>>2],v[e+316>>2]);i=v[e+288>>2];l=v[e+292>>2];c=v[e+300>>2];b=v[e+296>>2];break P}while(1){c=o;o=c-1|0;if(!v[(e+784|0)+(o<<2)>>2]){continue}break}b=(n|0)%9|0;Z:{if(!b){z=0;b=0;break Z}z=0;d=(n|0)<0?b+9|0:b;_:{if(!c){b=0;c=0;break _}k=v[(0-d<<2)+79584>>2];l=1e9/(k|0)|0;m=0;g=0;b=0;while(1){h=m;i=(e+784|0)+(g<<2)|0;o=v[i>>2];m=(o>>>0)/(k>>>0)|0;h=h+m|0;v[i>>2]=h;h=!h&(b|0)==(g|0);b=h?b+1&2047:b;n=h?n-9|0:n;m=B(l,o-B(k,m)|0);g=g+1|0;if((g|0)!=(c|0)){continue}break}if(!m){break _}v[(e+784|0)+(c<<2)>>2]=m;c=c+1|0}n=(n-d|0)+9|0}while(1){o=(e+784|0)+(b<<2)|0;g=(n|0)<36;$:{while(1){aa:{if(g){break aa}if((n|0)!=36){break $}if(y[o>>2]<=10384592){break aa}n=36;break $}d=c+2047|0;m=0;while(1){i=d&2047;x=(e+784|0)+(i<<2)|0;d=v[x>>2];l=d>>>3|0;h=d<<29;k=h+m|0;d=l;d=h>>>0>k>>>0?d+1|0:d;h=d;if(!h&k>>>0<1000000001){m=0}else{m=Mka(k,h,1e9,0);d=Jka(m,nb,-1e9,-1)+k|0;k=d}v[x>>2]=k;c=(i|0)!=(c-1&2047)?c:(b|0)==(i|0)?c:k?c:i;d=i-1|0;if((b|0)!=(i|0)){continue}break}z=z-29|0;if(!m){continue}break}b=b-1&2047;if((c|0)==(b|0)){d=e+784|0;k=d+((c+2046&2047)<<2)|0;c=c-1&2047;v[k>>2]=v[k>>2]|v[d+(c<<2)>>2]}n=n+9|0;v[(e+784|0)+(b<<2)>>2]=m;continue}break}ba:{ca:while(1){k=c+1&2047;l=(e+784|0)+((c-1&2047)<<2)|0;while(1){h=(n|0)>45?9:1;da:{while(1){d=b;g=0;ea:{while(1){fa:{b=d+g&2047;if((b|0)==(c|0)){break fa}b=v[(e+784|0)+(b<<2)>>2];i=v[(g<<2)+79536>>2];if(b>>>0<i>>>0){break fa}if(b>>>0>i>>>0){break ea}g=g+1|0;if((g|0)!=4){continue}}break}if((n|0)!=36){break ea}k=0;h=0;g=0;i=0;l=0;while(1){b=d+g&2047;if((b|0)==(c|0)){c=c+1&2047;v[((c<<2)+e|0)+780>>2]=0}qn(e+768|0,v[(e+784|0)+(b<<2)>>2]);Jd(e+752|0,k,h,i,l,0,0,1342177280,1075633366);Fg(e+736|0,v[e+752>>2],v[e+756>>2],v[e+760>>2],v[e+764>>2],v[e+768>>2],v[e+772>>2],v[e+776>>2],v[e+780>>2]);i=v[e+744>>2];l=v[e+748>>2];k=v[e+736>>2];h=v[e+740>>2];g=g+1|0;if((g|0)!=4){continue}break}ah(e+720|0,f);Jd(e+704|0,k,h,i,l,v[e+720>>2],v[e+724>>2],v[e+728>>2],v[e+732>>2]);i=v[e+712>>2];l=v[e+716>>2];k=0;h=0;m=v[e+704>>2];q=v[e+708>>2];x=z+113|0;o=x-I|0;n=(o|0)<(J|0);b=n?(o|0)>0?o:0:J;if((b|0)<=112){break da}break ba}z=h+z|0;b=c;if((d|0)==(b|0)){continue}break}o=1e9>>>h|0;m=-1<<h^-1;g=0;b=d;while(1){i=g;g=(e+784|0)+(d<<2)|0;x=v[g>>2];i=i+(x>>>h|0)|0;v[g>>2]=i;i=!i&(b|0)==(d|0);b=i?b+1&2047:b;n=i?n-9|0:n;g=B(o,m&x);d=d+1&2047;if((d|0)!=(c|0)){continue}break}if(!g){continue}if((b|0)!=(k|0)){v[(e+784|0)+(c<<2)>>2]=g;c=k;continue ca}v[l>>2]=v[l>>2]|1;continue}break}break}Ti(e+656|0,Wj(1,225-b|0));YG(e+688|0,v[e+656>>2],v[e+660>>2],v[e+664>>2],v[e+668>>2],m,q,i,l);G=v[e+696>>2];H=v[e+700>>2];A=v[e+688>>2];D=v[e+692>>2];Ti(e+640|0,Wj(1,113-b|0));tP(e+672|0,m,q,i,l,v[e+640>>2],v[e+644>>2],v[e+648>>2],v[e+652>>2]);k=v[e+672>>2];h=v[e+676>>2];r=v[e+680>>2];u=v[e+684>>2];Mx(e+624|0,m,q,i,l,k,h,r,u);Fg(e+608|0,A,D,G,H,v[e+624>>2],v[e+628>>2],v[e+632>>2],v[e+636>>2]);i=v[e+616>>2];l=v[e+620>>2];m=v[e+608>>2];q=v[e+612>>2]}g=d+4&2047;ga:{if((g|0)==(c|0)){break ga}g=v[(e+784|0)+(g<<2)>>2];ha:{if(g>>>0<=499999999){if(!g&(d+5&2047)==(c|0)){break ha}Ti(e+496|0,+(f|0)*.25);Fg(e+480|0,k,h,r,u,v[e+496>>2],v[e+500>>2],v[e+504>>2],v[e+508>>2]);r=v[e+488>>2];u=v[e+492>>2];k=v[e+480>>2];h=v[e+484>>2];break ha}if((g|0)!=5e8){Ti(e+592|0,+(f|0)*.75);Fg(e+576|0,k,h,r,u,v[e+592>>2],v[e+596>>2],v[e+600>>2],v[e+604>>2]);r=v[e+584>>2];u=v[e+588>>2];k=v[e+576>>2];h=v[e+580>>2];break ha}O=+(f|0);if((d+5&2047)==(c|0)){Ti(e+528|0,O*.5);Fg(e+512|0,k,h,r,u,v[e+528>>2],v[e+532>>2],v[e+536>>2],v[e+540>>2]);r=v[e+520>>2];u=v[e+524>>2];k=v[e+512>>2];h=v[e+516>>2];break ha}Ti(e+560|0,O*.75);Fg(e+544|0,k,h,r,u,v[e+560>>2],v[e+564>>2],v[e+568>>2],v[e+572>>2]);r=v[e+552>>2];u=v[e+556>>2];k=v[e+544>>2];h=v[e+548>>2]}if((b|0)>111){break ga}tP(e+464|0,k,h,r,u,0,0,0,1073676288);if(Hm(v[e+464>>2],v[e+468>>2],v[e+472>>2],v[e+476>>2],0,0,0,0)){break ga}Fg(e+448|0,k,h,r,u,0,0,0,1073676288);r=v[e+456>>2];u=v[e+460>>2];k=v[e+448>>2];h=v[e+452>>2]}Fg(e+432|0,m,q,i,l,k,h,r,u);Mx(e+416|0,v[e+432>>2],v[e+436>>2],v[e+440>>2],v[e+444>>2],A,D,G,H);i=v[e+424>>2];l=v[e+428>>2];m=v[e+416>>2];q=v[e+420>>2];ia:{if((-2-K|0)>=(x&2147483647)){break ia}v[e+408>>2]=i;v[e+412>>2]=l&2147483647;v[e+400>>2]=m;v[e+404>>2]=q;Jd(e+384|0,m,q,i,l,0,0,0,1073610752);d=US(v[e+400>>2],v[e+404>>2],v[e+408>>2],v[e+412>>2],1081081856);c=(d|0)<0;i=c?i:v[e+392>>2];l=c?l:v[e+396>>2];m=c?m:v[e+384>>2];q=c?q:v[e+388>>2];z=((d|0)>=0)+z|0;if((Hm(k,h,r,u,0,0,0,0)|0)!=0&(c?n:n&(b|0)!=(o|0))?0:(L|0)>=(z+110|0)){break ia}v[116016]=68}XG(e+368|0,m,q,i,l,z);i=v[e+368>>2];l=v[e+372>>2];c=v[e+380>>2];b=v[e+376>>2]}v[s+40>>2]=b;v[s+44>>2]=c;v[s+32>>2]=i;v[s+36>>2]=l;kb=e+8976|0;k=v[s+40>>2];h=v[s+44>>2];i=v[s+32>>2];l=v[s+36>>2];break a;case 3:break j;default:break m}}c=v[b+116>>2];if((c|0)>0|(c|0)>=0){v[b+4>>2]=v[b+4>>2]-1}break i}ja:{c=v[b+4>>2];ka:{if((c|0)!=v[b+104>>2]){v[b+4>>2]=c+1;c=w[c|0];break ka}c=rd(b)}if((c|0)==40){g=1;break ja}h=2147450880;if(v[b+116>>2]<0){break a}v[b+4>>2]=v[b+4>>2]-1;break a}while(1){c=v[b+4>>2];la:{if((c|0)!=v[b+104>>2]){v[b+4>>2]=c+1;c=w[c|0];break la}c=rd(b)}if(!(!(c-48>>>0<10|c-65>>>0<26|(c|0)==95)&c-97>>>0>=26)){g=g+1|0;continue}break}h=2147450880;if((c|0)==41){break a}c=v[b+116>>2];if((c|0)>0|(c|0)>=0){v[b+4>>2]=v[b+4>>2]-1}ma:{if(d){if(g){break ma}break a}break i}while(1){g=g-1|0;if((c|0)>0|(c|0)>=0){v[b+4>>2]=v[b+4>>2]-1}if(g){continue}break}break a}v[116016]=28;mi(b,0,0)}h=0}v[a>>2]=i;v[a+4>>2]=l;v[a+8>>2]=k;v[a+12>>2]=h;kb=s+48|0}function Nfa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,z=0,A=0,C=0;d=kb-384|0;kb=d;zc(b);a:{if(!wo(b,d+368|0)){break a}if(!vR(d+368|0)){break a}q=je(d+344|0,b);o=Tb(d+328|0);b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{z:{A:{B:{if(!c){v[23540]=0;R(637,d+40|0,q|0);b=v[23540];v[23540]=0;if((b|0)==1){break z}break B}v[23540]=0;R(638,d+40|0,q|0);b=v[23540];v[23540]=0;if((b|0)==1){break A}}b=d+40|0;Tt(o,b);Zd(b);v[23540]=0;U(639,b|0,o|0,1413891155);b=v[23540];v[23540]=0;C:{D:{if((b|0)!=1){v[23540]=0;e=Q(640,d+40|0,14150)|0;b=v[23540];v[23540]=0;if((b|0)==1){break D}Bb(d+40|0);if(!c){break b}if(!(e^1)){break C}break b}b=P()|0;O()|0;break c}b=P()|0;O()|0;Bb(d+40|0);break c}v[23540]=0;R(246,a|0,4194304);b=v[23540];v[23540]=0;if((b|0)==1){break d}v[a+480208>>2]=12;v[23540]=0;U(639,d+304|0,o|0,1280592212);b=v[23540];v[23540]=0;if((b|0)==1){break e}v[23540]=0;b=S(160,v[d+304>>2])|0;e=v[23540];v[23540]=0;if((e|0)==1){break g}v[23540]=0;U(444,d+304|0,a+1298308|0,b|0);b=v[23540];v[23540]=0;if((b|0)==1){break g}i=a+484360|0;j=a+484376|0;Lc(Wb(v[i>>2],w[j|0]));k=Tb(d+288|0);t[d+287|0]=0;v[23540]=0;U(641,d+272|0,o|0,1196314451);b=v[23540];v[23540]=0;if((b|0)==1){break i}A=d,C=Fb(v[d+272>>2]),v[A+264>>2]=C;p=d+252|0;r=Fb(v[d+276>>2]);E:{F:{while(1){b=v[d+264>>2];if(!Pb(b,r)){break F}l=je(d+40|0,b);v[23540]=0;e=Q(642,l|0,d+24|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break E}b=1;if(!(!e|w[d+33|0]!=1)){A=a,C=Ed(w[d+34|0],x[a+480188>>1],127),u[A+480188>>1]=C;v[23540]=0;h=S(643,d+208|0)|0;b=v[23540];v[23540]=0;G:{H:{I:{J:{K:{if((b|0)!=1){b=d+192|0;pf(b,d+24|0,9,1);v[23540]=0;R(222,d+160|0,b|0);b=v[23540];v[23540]=0;if((b|0)==1){break K}b=d+8|0;hc(b,p,10);e=b;b=d+160|0;Kl(e,b);zb(b);b=Wb(v[a+484360>>2],w[j|0]);if(pc(v[b>>2],v[b+4>>2])){break H}v[23540]=0;b=S(272,i|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break J}if((b|0)!=255){break I}b=2;break G}b=P()|0;O()|0;break k}b=P()|0;O()|0;break l}b=P()|0;O()|0;break l}b=Wb(v[a+484360>>2],w[j|0])}v[23540]=0;U(5,d+160|0,5,p|0);e=v[23540];v[23540]=0;if((e|0)==1){break n}v[23540]=0;R(273,b|0,d+160|0);b=v[23540];v[23540]=0;if((b|0)==1){break o}Ab(d+160|0);v[23540]=0;R(638,d+192|0,l|0);b=v[23540];v[23540]=0;if((b|0)==1){break p}A=d,C=Fb(v[d+192>>2]),v[A+184>>2]=C;n=Fb(v[d+196>>2]);L:{M:{while(1){b=v[d+184>>2];if(!Pb(b,n)){b=0;if(x[d+244>>1]==65535|x[d+246>>1]==65535){break L}b=w[j|0];e=v[a+484360>>2];v[23540]=0;Y(644,Wb(e,b)|0);b=v[23540];v[23540]=0;if((b|0)!=1){v[23540]=0;R(645,k|0,h|0);e=v[23540];v[23540]=0;b=0;if((e|0)!=1){break L}}b=P()|0;O()|0;break m}Bo(d+160|0,b);_h(d+8|0,v[b>>2],v[b+4>>2]);e=1;N:{g=v[d+8>>2];O:{if((g|0)!=1212960847){b=0;if((g|0)!=1312903248){break O}while(1){if(x[a+480188>>1]<=b>>>0){break O}v[23540]=0;g=W(156,v[d+160>>2],v[d+168>>2],2)|0;f=v[23540];v[23540]=0;if((f|0)!=1){if(!g){break O}v[23540]=0;R(260,d+136|0,d+160|0);g=v[23540];v[23540]=0;P:{Q:{R:{S:{if((g|0)!=1){switch(w[d+136|0]){case 4:break Q;case 2:break R;case 0:break S;default:break P}}break q}g=Oc(d+136|0);A=Lb(v[h>>2],b),C=w[g|0]^128,t[A|0]=C;g=d+144|0;Db(g,v[d+232>>2],b);Ze(g,0);break P}A=Lb(v[h>>2],b),C=128,t[A|0]=C;g=d+144|0;Db(g,v[d+232>>2],b);Ze(g,1);break P}A=Lb(v[h>>2],b),C=128,t[A|0]=C;g=d+144|0;Db(g,v[d+232>>2],b);Ze(g,0)}b=b+1|0;continue}break}break q}if(y[d+12>>2]<9){break O}b=0;v[23540]=0;Q(188,d+160|0,2)|0;e=v[23540];v[23540]=0;g=65535;if((e|0)==1){break N}while(1){T:{v[23540]=0;e=W(156,v[d+160>>2],v[d+168>>2],1)|0;f=v[23540];v[23540]=0;U:{V:{W:{X:{Y:{Z:{_:{$:{if((f|0)!=1){if(!e){break T}v[23540]=0;f=S(206,d+160|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break q}e=0;switch(f|0){case 0:break T;case 14:break V;case 13:break W;case 12:break X;case 8:break Y;case 7:break Z;case 4:break _;case 1:break $;default:break O}}break q}e=Wb(v[a+484360>>2],w[j|0]);if(x[d+244>>1]==65535){A=d,C=Bl(v[e>>2],v[e+4>>2]),u[A+244>>1]=C}e=Bl(v[e>>2],v[e+4>>2]);v[23540]=0;u[d+246>>1]=e;e=Q(646,d+160|0,d+287|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break q}aa:{ba:{switch(e-254|0){case 1:e=65535;break aa;case 0:break ba;default:break aa}}e=65534}f=w[j|0];m=v[a+484360>>2];v[23540]=0;R(522,Wb(m,f)|0,e|0);e=v[23540];v[23540]=0;if((e|0)==1){break q}g=(g&65535)==65535?b:g;break U}v[23540]=0;e=S(194,d+160|0)|0;f=v[23540];v[23540]=0;ca:{da:{if((f|0)!=1){if(e>>>0>=(g&65535)>>>0){break da}e=x[d+248>>1];break ca}break q}e=e-g|0;u[d+248>>1]=e}Ve(Wb(v[a+484360>>2],w[j|0]),e&65535);break U}v[23540]=0;e=S(206,d+160|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break q}t[d+251|0]=e;break U}v[23540]=0;e=S(206,d+160|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break q}t[d+250|0]=e;break U}v[23540]=0;f=Q(617,d+160|0,d+144|0)|0;m=v[23540];v[23540]=0;if((m|0)!=1){if(w[d+144|0]|!f|(w[d+146|0]|w[d+145|0]!=255)){break O}if(w[d+147|0]|w[d+148|0]!=1){break O}if(!w[d+149|0]){break U}break O}break q}v[23540]=0;R(534,d+152|0,d+160|0);e=v[23540];v[23540]=0;ea:{fa:{ga:{ha:{if((e|0)!=1){m=Oc(d+152|0);e=v[h>>2];z=fd(e,v[d+212>>2]);f=w[d+152|0];if(z>>>0<=f>>>0){break U}switch(w[Te(d+152|0)|0]){case 4:break fa;case 2:break ga;case 0:break ha;default:break ea}}break q}A=Lb(e,f),C=w[m|0]^128,t[A|0]=C;e=d+144|0;Db(e,v[d+232>>2],w[d+152|0]);Ze(e,0);break ea}A=Lb(e,f),C=128,t[A|0]=C;e=d+144|0;Db(e,v[d+232>>2],w[d+152|0]);Ze(e,1);break ea}A=Lb(e,f),C=128,t[A|0]=C;e=d+144|0;Db(e,v[d+232>>2],w[d+152|0]);Ze(e,0)}ia:{if(s){break ia}s=0;e=v[k+4>>2];if(!kq(v[k>>2],e)){break U}f=e-56|0;e=w[d+152|0];if(w[Lb(v[f>>2],e)|0]!=w[Lb(v[h>>2],e)|0]){break ia}Db(d+144|0,v[f+24>>2],e);e=Cb(v[v[d+144>>2]>>2],v[d+148>>2]);Db(d+136|0,v[d+232>>2],w[d+152|0]);if((Cb(v[v[d+136>>2]>>2],v[d+140>>2])|0)==(e|0)){break U}}s=1;break U}v[23540]=0;R(260,d+144|0,d+160|0);e=v[23540];v[23540]=0;if((e|0)==1){break q}e=v[d+220>>2];m=fd(e,v[d+224>>2]);f=w[d+144|0];if(m>>>0<=f>>>0){break U}m=Oc(d+144|0);A=Lb(e,f),C=(w[m|0]>>>2|0)+1|0,t[A|0]=C}b=b+1|0;continue}break}e=1}Bb(d+160|0);if(!e){break M}Om(d+184|0);continue}break}break q}b=1}Zd(d+192|0)}St(h)}Bb(l);if(!b){Nf(d+264|0);continue}break}e=0;if((b|0)!=2){break w}}e=0;Gj(i,0);b=v[k>>2];if(pc(b,v[k+4>>2])){break w}if(!(c&2)){break x}v[23540]=0;U(641,d+160|0,o|0,1347244868);b=v[23540];v[23540]=0;if((b|0)!=1){A=d,C=Fb(v[d+160>>2]),v[A+8>>2]=C;e=a+480190|0;g=d+53|0;h=d+57|0;j=Fb(v[d+164>>2]);l=w[d+287|0];while(1){b=v[d+8>>2];if(!Pb(b,j)){Vc(d+160|0);b=v[k>>2];break x}ja:{ka:{la:{if(!l){v[23540]=0;f=Q(647,b|0,d+40|0)|0;i=v[23540];v[23540]=0;if((i|0)==1){break ja}if(!f){break ka}f=x[d+92>>1];i=f+1|0;u[d+144>>1]=i;if(f>>>0>3998){break la}A=a,C=x[ke(e,d+144|0)>>1],u[A+480190>>1]=C;v[23540]=0;R(648,d+40|0,(B(i&65535,104)+a|0)+484380|0);f=v[23540];v[23540]=0;if((f|0)==1){break ja}f=d+24|0;tR(f,g);v[23540]=0;R(222,d+192|0,f|0);f=v[23540];v[23540]=0;if((f|0)==1){break y}f=d+192|0;Dc(((x[d+144>>1]<<5)+a|0)+946304|0,f);zb(f);break la}v[23540]=0;f=Q(649,b|0,d+40|0)|0;i=v[23540];v[23540]=0;if((i|0)==1){break y}if(!f){break ka}f=x[d+96>>1];i=f+1|0;u[d+144>>1]=i;if(f>>>0>3998){break la}A=a,C=x[ke(e,d+144|0)>>1],u[A+480190>>1]=C;v[23540]=0;R(650,d+40|0,(B(i&65535,104)+a|0)+484380|0);f=v[23540];v[23540]=0;if((f|0)==1){break y}f=d+24|0;tR(f,h);v[23540]=0;R(222,d+192|0,f|0);f=v[23540];v[23540]=0;if((f|0)==1){break y}f=d+192|0;Dc(((x[d+144>>1]<<5)+a|0)+946304|0,f);zb(f)}f=x[d+144>>1];if((f-1&65535)>>>0>3998){break ka}i=Zc(d+40|0,8,1,0,2);v[23540]=0;W(219,i|0,(B(f,104)+a|0)+484380|0,b|0)|0;b=v[23540];v[23540]=0;if((b|0)!=1){break ka}break y}Nf(d+8|0);continue}break}break y}b=P()|0;O()|0;break j}b=P()|0;O()|0;break k}b=P()|0;O()|0;break c}b=P()|0;O()|0;break c}b=P()|0;O()|0;Vc(d+160|0);break j}b=_z(b,0);v[a+480196>>2]=w[b+43|0];v[a+480204>>2]=B(w[b+42|0],1e4);Ve(Wb(v[a+484360>>2],w[a+484376|0]),x[b+40>>1]);b=0;while(1){if(x[a+480188>>1]>b>>>0){e=(b<<5)+a|0;g=e+480280|0;df(g);h=_z(v[k>>2],0);A=e+480286|0,C=w[Lb(v[h+12>>2],b)|0],u[A>>1]=C;A=e+480284|0,C=w[Lb(v[h>>2],b)|0],u[A>>1]=C;Db(d+40|0,v[h+24>>2],b);A=g,C=v[g>>2]&-257|(Cb(v[v[d+40>>2]>>2],v[d+44>>2])?256:0),v[A>>2]=C;b=b+1|0;continue}break}v[23540]=0;b=Q(1,d+192|0,(w[d+287|0]?17165:17038)|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break r}Jb(a+1298344|0,b);Ab(b);v[23540]=0;b=Q(1,d+24|0,10156)|0;e=v[23540];v[23540]=0;if((e|0)==1){break s}Jb(a+1298356|0,b);Ab(b);v[a+1298404>>2]=5;e=1;if(!(c&1)|!x[a+480188>>1]){break w}v[23540]=0;U(641,d+8|0,o|0,1146045008);b=v[23540];v[23540]=0;if((b|0)==1){break t}b=v[d+12>>2];c=v[d+8>>2];v[23540]=0;l=a+484344|0;R(225,l|0,Bf(c,b)&65535);b=v[23540];v[23540]=0;if((b|0)==1){break v}A=d,C=Fb(v[d+8>>2]),v[A+144>>2]=C;r=Fb(v[d+12>>2]);while(1){j=v[d+144>>2];if(!Pb(j,r)){ma:{na:{b=v[k>>2];e=v[k+4>>2];if(kq(b,e)>>>0<2){break na}j=a+484348|0;g=0;while(1){if(kq(b,e)>>>0<=g>>>0){break na}i=v[a+484344>>2];n=v[j>>2];h=zj(v[a+484360>>2],g&255);m=v[h>>2];c=_z(b,g);f=x[c+36>>1];if(xe(i,n,x[cc(m,f)>>1])){v[23540]=0;e=Q(360,h|0,f|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break ma}oa:{if(!s){break oa}b=0;while(1){if(x[a+480188>>1]<=b>>>0){break oa}Db(d+40|0,v[c+24>>2],b);f=Cb(v[v[d+40>>2]>>2],v[d+44>>2]);h=_b(v[l>>2],e);pa:{if(f){ze(h,Gh(xo(Ue(Oe(d+40|0,20,145),0),b&65535)));break pa}ze(h,Gh(xo(Ue(Oe(d+40|0,9,w[Lb(v[c>>2],b)|0]),0),b&65535)))}b=b+1|0;continue}}b=d+40|0;ze(_b(v[l>>2],e),Gh(Ue(Oe(b,16,w[c+43|0]),0)));ze(_b(v[l>>2],e),Gh(Ue(Oe(b,17,w[c+42|0]),0)));e=v[k+4>>2];b=v[k>>2]}g=g+1|0;continue}}Vc(d+8|0);e=1;break w}b=P()|0;O()|0;break u}b=v[j>>2];v[23540]=0;b=S(160,b|0)|0;c=v[23540];v[23540]=0;qa:{ra:{sa:{ta:{ua:{va:{wa:{if((c|0)==1){break wa}v[23540]=0;c=S(157,j|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break wa}if((b|0)!=(c|0)){break qa}b=v[j>>2];v[23540]=0;b=Q(651,b|0,8)|0;c=v[23540];v[23540]=0;if((c|0)==1){break wa}if(!b){break qa}v[23540]=0;i=Q(646,j|0,d+287|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break ra}v[23540]=0;p=S(194,j|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break sa}v[23540]=0;b=W(226,l|0,i|0,p|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break sa}if(!b){break qa}f=0;while(1){if((f|0)==(p|0)){break qa}b=_b(v[l>>2],i);c=Cf(v[b>>2],v[v[b+48>>2]+12>>2],f);v[23540]=0;b=S(194,j|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break va}xa:{if(b>>>0>=3){v[23540]=0;U(190,d+160|0,j|0,b-2|0);b=v[23540];v[23540]=0;if((b|0)==1){break ta}b=d+160|0;h=kc(d+40|0,b);Bb(b);while(1){b=v[h>>2];v[23540]=0;b=W(156,b|0,v[d+48>>2],3)|0;e=v[23540];v[23540]=0;if((e|0)==1){break xa}if(b){v[23540]=0;R(260,d+160|0,h|0);b=v[23540];v[23540]=0;ya:{za:{Aa:{Ba:{if((b|0)!=1){u[d+136>>1]=x[a+480188>>1]-1;A=d,C=w[Oc(d+160|0)|0],u[A+264>>1]=C;e=x[Wc(d+136|0,d+264|0)>>1];g=c+B(e,6)|0;b=t[d+160|0];if((b|0)>=0){break ya}v[23540]=0;b=S(206,h|0)|0;n=v[23540];v[23540]=0;if((n|0)==1){break ua}if(w[d+287|0]){break Aa}if((b|0)!=255){break Ba}b=254;break za}break ua}if(b>>>0>128){break za}b=(B(b>>>4|0,12)+(b&15)|0)+13|0;break za}b=b>>>0<85?b+36|0:b}t[g|0]=b;b=w[d+160|0]}if(b&64){v[23540]=0;b=S(206,h|0)|0;n=v[23540];v[23540]=0;if((n|0)==1){break ua}t[g+1|0]=b+1;b=w[d+160|0]}if(b&32){v[23540]=0;b=S(206,h|0)|0;n=v[23540];v[23540]=0;if((n|0)==1){break ua}t[d+136|0]=b;t[g+2|0]=1;t[d+264|0]=127;A=g,C=w[Yb(d+136|0,d+264|0)|0]+1>>>1|0,t[A+4|0]=C;b=w[d+160|0]}if(!(b&16)){continue}v[23540]=0;R(260,d+136|0,h|0);b=v[23540];v[23540]=0;Ca:{Da:{Ea:{Fa:{Ga:{Ha:{Ia:{Ja:{Ka:{La:{Ma:{Na:{Oa:{Pa:{Qa:{Ra:{Sa:{Ta:{Ua:{Va:{Wa:{Xa:{Ya:{Za:{_a:{$a:{ab:{bb:{cb:{db:{eb:{fb:{gb:{hb:{if((b|0)!=1){b=w[Oc(d+136|0)|0];t[g+5|0]=b;switch(w[d+136|0]-1|0){case 72:break Da;case 71:break Ea;case 70:break Fa;case 61:break Ga;case 60:break Ha;case 53:break Ia;case 52:break Ja;case 51:break Ka;case 50:break Ma;case 43:break Na;case 42:break Oa;case 41:break Pa;case 40:break Qa;case 31:break Ra;case 30:break Sa;case 23:break Ta;case 22:break Ua;case 21:break Va;case 20:break Wa;case 18:break Xa;case 17:break Ya;case 15:break Za;case 16:break _a;case 14:break $a;case 13:break ab;case 12:break bb;case 11:break cb;case 10:break db;case 3:break eb;case 2:break fb;case 1:break gb;case 0:break hb;default:break Ca}}break ua}t[(c+B(e,6)|0)+3|0]=11;if(w[d+287|0]){t[g+5|0]=b<<4|15;continue}t[g+5|0]=b<<3|15;continue}t[(c+B(e,6)|0)+3|0]=11;if(w[d+287|0]){t[g+5|0]=b<<4;continue}t[g+5|0]=b<<3&240;continue}t[(c+B(e,6)|0)+3|0]=11;if(w[d+287|0]){t[g+5|0]=b|240;continue}t[g+5|0]=b>>>1|240;continue}t[(c+B(e,6)|0)+3|0]=11;if(w[d+287|0]){t[g+5|0]=b&15;continue}if(b>>>0<=1){t[g+5|0]=b|240;continue}t[g+5|0]=b>>>1&15;continue}t[(c+B(e,6)|0)+3|0]=2;A=g,C=Rt(b,w[d+287|0])|240,t[A+5|0]=C;continue}t[(c+B(e,6)|0)+3|0]=2;A=g,C=Rt(b,w[d+287|0]),t[A+5|0]=C;continue}t[(c+B(e,6)|0)+3|0]=3;A=g,C=Rt(b,w[d+287|0])|240,t[A+5|0]=C;continue}t[(c+B(e,6)|0)+3|0]=3;A=g,C=Rt(b,w[d+287|0]),t[A+5|0]=C;continue}t[(c+B(e,6)|0)+3|0]=4;if(w[d+287|0]){continue}t[g+5|0]=(b&252)>>>2;continue}t[(c+B(e,6)|0)+3|0]=20;t[g+5|0]=b&1|16;continue}t[(c+B(e,6)|0)+3|0]=6;t[g+5|0]=b&240;continue}t[(c+B(e,6)|0)+3|0]=6;t[g+5|0]=(b&240)>>>4;continue}t[(c+B(e,6)|0)+3|0]=20;continue}t[(c+B(e,6)|0)+3|0]=5;continue}t[(c+B(e,6)|0)+3|0]=20;t[g+5|0]=b&15|48;continue}t[(c+B(e,6)|0)+3|0]=7;t[g+5|0]=b|240;continue}t[(c+B(e,6)|0)+3|0]=7;continue}t[(c+B(e,6)|0)+3|0]=8;continue}t[(c+B(e,6)|0)+3|0]=20;t[g+5|0]=b&15|64;continue}t[(c+B(e,6)|0)+3|0]=10;v[23540]=0;b=S(206,h|0)|0;e=v[23540];v[23540]=0;if((e|0)!=1){break La}break ua}t[(c+B(e,6)|0)+3|0]=15;continue}t[(c+B(e,6)|0)+3|0]=20;t[g+5|0]=b&15|192;continue}t[(c+B(e,6)|0)+3|0]=20;t[g+5|0]=b&15|208;continue}t[(c+B(e,6)|0)+3|0]=12;b=(b&254)>>>1|0}t[g+5|0]=b;v[23540]=0;Q(188,h|0,1)|0;b=v[23540];v[23540]=0;if((b|0)!=1){continue}break ua}t[(c+B(e,6)|0)+3|0]=14;t[g+5|0]=0;continue}t[(c+B(e,6)|0)+3|0]=20;t[g+5|0]=b&15|176;continue}t[(c+B(e,6)|0)+3|0]=20;t[g+5|0]=b&15|224;continue}t[(c+B(e,6)|0)+3|0]=16;continue}t[(c+B(e,6)|0)+3|0]=17;continue}t[(c+B(e,6)|0)+3|0]=1;continue}t[(c+B(e,6)|0)+3|0]=20;t[g+5|0]=b&15|32;continue}t[(c+B(e,6)|0)+3|0]=20;t[g+5|0]=b&15|128;continue}t[(c+B(e,6)|0)+3|0]=0;continue}break}Bb(h)}f=f+1|0;continue}break}break ua}b=P()|0;O()|0;break u}b=P()|0;O()|0;break u}b=P()|0;O()|0;Bb(h);break u}b=P()|0;O()|0;break u}b=P()|0;O()|0;break u}b=P()|0;O()|0;break u}Nf(d+144|0);continue}}Vc(d+272|0);sR(k);Bb(d+304|0);break b}b=P()|0;O()|0}Vc(d+8|0);break j}b=P()|0;O()|0;break j}b=P()|0;O()|0;break j}b=P()|0;O()|0;break j}b=P()|0;O()|0;Bb(d+160|0);break m}b=P()|0;O()|0;break l}b=P()|0;O()|0;Ab(d+160|0);break l}b=P()|0;O()|0;break l}Zd(d+192|0)}St(h)}Bb(l)}Vc(d+272|0);break h}b=P()|0;O()|0}sR(k);break f}b=P()|0;O()|0}Bb(d+304|0);break c}b=P()|0;O()|0;break c}b=P()|0;O()|0}Zd(o);Bb(q);T(b|0);L()}Zd(o);Bb(q)}kb=d+384|0;return e|0}function Iha(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,y=0,z=0,A=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=kb-480|0;kb=d;zc(b);h=d+472|0;e=Mu(b,h);if(!e){VS(h)}a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{if(!e){break k}if(!WS(d+472|0)){break k}if(!c){D=1;break k}H=je(d+448|0,b);v[23540]=0;R(493,d+432|0,H|0);b=v[23540];v[23540]=0;l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{if((b|0)!=1){v[23540]=0;U(494,d+408|0,d+432|0,20041);b=v[23540];v[23540]=0;if((b|0)==1){break u}v[23540]=0;e=S(178,v[d+408>>2])|0;b=v[23540];v[23540]=0;if((b|0)==1){break m}if(!e){break l}v[23540]=0;e=Q(495,d+408|0,d+312|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break m}if(!e){break l}v[23540]=0;R(246,a|0,16384);b=v[23540];v[23540]=0;if((b|0)==1){break m}v[a+480208>>2]=8;v[23540]=0;e=W(264,a+1074312|0,9,1)|0;b=v[23540];v[23540]=0;if((b|0)==1){break m}v[23540]=0;e=W(264,e|0,114,1)|0;b=v[23540];v[23540]=0;if((b|0)==1){break m}v[23540]=0;e=Q(265,e|0,21)|0;b=v[23540];v[23540]=0;if((b|0)==1){break m}v[23540]=0;Q(265,e|0,30)|0;b=v[23540];v[23540]=0;if((b|0)==1){break m}v[23540]=0;e=Q(1,d+296|0,8309)|0;b=v[23540];v[23540]=0;if((b|0)==1){break r}Jb(a+1298344|0,e);Ab(e);v[23540]=0;e=Q(1,d+280|0,10741)|0;b=v[23540];v[23540]=0;if((b|0)==1){break q}Jb(a+1298356|0,e);Ab(e);v[23540]=0;g=Q(1,d+264|0,17535)|0;b=v[23540];v[23540]=0;if((b|0)==1){break p}e=15091;b=w[d+476|0];switch(b-16|0){case 1:break n;case 0:break t;default:break s}}f=P()|0;O()|0;break a}f=P()|0;O()|0;break b}e=15072;break n}if(!b){break o}e=21688;break n}f=P()|0;O()|0;break c}f=P()|0;O()|0;break c}f=P()|0;O()|0;break c}e=13243}v[23540]=0;h=Q(1,d+248|0,e|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break e}v[23540]=0;U(2,d+208|0,g|0,h|0);b=v[23540];v[23540]=0;if((b|0)==1){break f}e=d+208|0;Jb(a+1298368|0,e);Ab(e);Ab(h);Ab(g);v[a+1298404>>2]=5;b=d+96|0;Ne(b,3,d+312|0);v[23540]=0;R(222,e|0,b|0);b=v[23540];v[23540]=0;if((b|0)==1){break g}b=d+208|0;Bc(a+1298308|0,b);zb(b);b=d+232|0;Dj(b,3,d+344|0);v[23540]=0;R(222,d+96|0,b|0);b=v[23540];v[23540]=0;if((b|0)==1){break h}v[23540]=0;U(11,d+208|0,5,d+96|0);b=v[23540];v[23540]=0;if((b|0)==1){break i}b=d+208|0;Jb(a+1298320|0,b);Ab(b);zb(d+96|0);v[a+480200>>2]=w[d+368|0]+1;I=a,J=Ed(w[d+369|0],1,255),v[I+480196>>2]=J;I=a,J=B(Ed(w[d+370|0],4,255),1e4),v[I+480204>>2]=J;h=v[a+484360>>2];e=a+484376|0;b=w[e|0];v[23540]=0;da(340,Wb(h,b)|0,d+408|0,x[d+364>>1],65535,65535);b=v[23540];v[23540]=0;if((b|0)==1){break m}Ve(Wb(v[a+484360>>2],w[e|0]),x[d+366>>1]);u[a+480188>>1]=0;b=0;while(1){if((b|0)==32){v[23540]=0;U(494,d+208|0,d+432|0,17741);b=v[23540];v[23540]=0;if((b|0)!=1){b=d+208|0;h=hd(d+408|0,b);Bb(b);b=v[h>>2];v[23540]=0;e=S(160,b|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break m}v[23540]=0;X(331,a+1298332|0,h|0,e|0,0);b=v[23540];v[23540]=0;if((b|0)==1){break m}v[23540]=0;U(494,d+208|0,d+432|0,21321);b=v[23540];v[23540]=0;if((b|0)!=1){b=d+208|0;j=hd(h,b);Bb(b);b=v[j>>2];v[23540]=0;e=S(178,b|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break m}v:{w:{if(e){v[23540]=0;U(494,d+208|0,d+432|0,16723);b=v[23540];v[23540]=0;if((b|0)==1){break v}v[23540]=0;g=S(206,j|0)|0;b=v[23540];v[23540]=0;x:{if((b|0)!=1){h=c&2;i=a+480190|0;while(1){if(g>>>0<=(n&255)>>>0){break x}v[23540]=0;p=S(206,j|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break w}if(!p){break x}e=v[j+8>>2];b=v[j>>2];v[23540]=0;e=W(156,b|0,e|0,56)|0;b=v[23540];v[23540]=0;if((b|0)==1){break w}if(!e){break x}if(p>>>0>x[i>>1]){u[i>>1]=p}v[23540]=0;o=B(p,104)+a|0;s=o+484380|0;R(277,s|0,0);b=v[23540];v[23540]=0;if((b|0)==1){break w}vo(s);v[23540]=0;U(314,j|0,((p<<5)+a|0)+946304|0,32);b=v[23540];v[23540]=0;if((b|0)==1){break w}v[23540]=0;R(317,j|0,o+484423|0);b=v[23540];v[23540]=0;if((b|0)==1){break w}y:{if(w[d+476|0]<=15){v[23540]=0;f=S(194,j|0)|0;b=v[23540];v[23540]=0;if((b|0)!=1){break y}break w}v[23540]=0;f=S(157,j|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break w}}v[o+484404>>2]=f<<1;v[23540]=0;e=S(157,j|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break w}v[s>>2]=e;v[23540]=0;e=S(157,j|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break w}D=o+484384|0;v[D>>2]=e;v[23540]=0;e=S(157,j|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break w}F=o+484388|0;v[F>>2]=e;if(e){b=o+484414|0;u[b>>1]=x[b>>1]|2;v[F>>2]=e+v[D>>2]}v[23540]=0;e=S(206,j|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break w}if(w[d+476|0]<=15){u[o+484410>>1]=e}v[23540]=0;p=S(206,j|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break w}b=o+484414|0;e=x[b>>1];k=8;if(p&1){e=e|1;u[b>>1]=e;v[s>>2]=v[s>>2]>>>1;v[D>>2]=v[D>>2]>>>1;v[F>>2]=v[F>>2]>>>1;k=16}u[b>>1]=e&65531|p<<1&4;b=Zc(d+96|0,k,1,0,((p&12)!=0)<<3);z:{if(!h){break z}v[23540]=0;W(219,b|0,s|0,d+208|0)|0;b=v[23540];v[23540]=0;if((b|0)!=1){break z}break w}n=n+1|0;continue}}break w}Bb(d+208|0)}v[23540]=0;U(494,d+208|0,d+432|0,18761);b=v[23540];v[23540]=0;A:{if((b|0)!=1){b=d+208|0;m=hd(j,b);Bb(b);b=v[m>>2];v[23540]=0;e=S(178,b|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break m}if(!e){break A}y=Tb(d+96|0);q=Tb(d+232|0);z=Tb(d+192|0);v[23540]=0;U(494,d+168|0,d+432|0,17750);b=v[23540];v[23540]=0;B:{if((b|0)==1){break B}b=v[d+180>>2];e=d- -64|0;v[e>>2]=v[d+176>>2];v[e+4>>2]=b;v[d+72>>2]=v[d+184>>2];v[23540]=0;b=v[d+172>>2];v[d+56>>2]=v[d+168>>2];v[d+60>>2]=b;R(496,d+56|0,y|0);b=v[23540];v[23540]=0;if((b|0)==1){break B}v[23540]=0;U(494,d+144|0,d+432|0,17744);b=v[23540];v[23540]=0;if((b|0)==1){break B}b=v[d+156>>2];v[d+40>>2]=v[d+152>>2];v[d+44>>2]=b;v[d+48>>2]=v[d+160>>2];v[23540]=0;b=v[d+148>>2];v[d+32>>2]=v[d+144>>2];v[d+36>>2]=b;R(496,d+32|0,q|0);b=v[23540];v[23540]=0;if((b|0)==1){break B}v[23540]=0;U(494,d+120|0,d+432|0,17734);b=v[23540];v[23540]=0;if((b|0)==1){break B}b=v[d+132>>2];v[d+16>>2]=v[d+128>>2];v[d+20>>2]=b;v[d+24>>2]=v[d+136>>2];v[23540]=0;b=v[d+124>>2];v[d+8>>2]=v[d+120>>2];v[d+12>>2]=b;R(496,d+8|0,z|0);b=v[23540];v[23540]=0;if((b|0)==1){break B}v[23540]=0;o=S(206,m|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break B}j=d+208|1;s=a+480190|0;k=0;while(1){if(o>>>0<=(k&255)>>>0){no(z);no(q);no(y);break A}v[23540]=0;R(260,d+80|0,m|0);b=v[23540];v[23540]=0;C:{if((b|0)!=1){G=Oc(d+80|0);D:{E:{if(!w[d+80|0]){break E}h=v[m+8>>2];e=v[m>>2];b=w[G|0];v[23540]=0;e=W(156,e|0,h|0,B(b,14)+32|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break B}if(!e){break E}v[23540]=0;f=W(251,a|0,w[d+80|0],0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break B}if(f){break D}}b=w[G|0];v[23540]=0;Q(188,m|0,B(b,14)+32|0)|0;b=v[23540];v[23540]=0;if((b|0)!=1){break C}break B}v[23540]=0;U(314,m|0,f+492|0,32);b=v[23540];v[23540]=0;if((b|0)==1){break B}D=f+88|0;F=f+68|0;p=f+48|0;i=f+236|0;b=0;n=0;while(1){if(w[G|0]<=(n&255)>>>0){break C}v[23540]=0;R(497,m|0,d+208|0);e=v[23540];v[23540]=0;if((e|0)==1){break B}e=w[d+208|0];F:{if(!e|e>>>0>x[s>>1]){break F}if(w[j|0]>=129){t[j|0]=128}while(1){e=b&255;g=w[d+209|0];if(e>>>0>g>>>0){e=v[y+4>>2];b=v[y>>2];v[23540]=0;X(498,p|0,w[d+211|0],b|0,e|0);b=v[23540];v[23540]=0;if((b|0)==1){break B}e=v[q+4>>2];b=v[q>>2];v[23540]=0;X(498,F|0,w[d+213|0],b|0,e|0);b=v[23540];v[23540]=0;if((b|0)==1){break B}e=v[z+4>>2];b=v[z>>2];v[23540]=0;X(498,D|0,w[d+221|0],b|0,e|0);b=v[23540];v[23540]=0;if((b|0)==1){break B}v[f>>2]=x[d+214>>1]+1>>>1;e=w[d+208|0];G:{if(w[d+211|0]&64){u[(B(e,104)+a|0)+484410>>1]=w[d+210|0];break G}b=(B(e,104)+a|0)+484414|0;u[b>>1]=x[b>>1]|32768}u[d+118>>1]=w[d+212|0]<<1;u[d+116>>1]=254;r=B(e,104)+a|0;I=r+484408|0,J=x[Wc(d+118|0,d+116|0)>>1],u[I>>1]=J;t[r+484418|0]=w[(w[d+219|0]&3)+26724|0];e=r+484419|0;A=w[d+218|0];t[e|0]=A;h=w[d+217|0]+3>>>2|0;t[r+484420|0]=h;t[r+484421|0]=w[d+216|0];b=g+1|0;if(A){h=Jl(Ec(((h<<8|A>>>1)>>>0)/(A>>>0)|0,0))}else{h=255}t[e|0]=h;if(!(w[d+213|0]&64)){break F}e=r+484414|0;u[e>>1]=x[e>>1]|32}else{I=cc(i,e),J=w[d+208|0],u[I>>1]=J;b=b+1|0;continue}break}}n=n+1|0;continue}}break B}k=k+1|0;continue}}f=P()|0;O()|0;no(z);no(q);no(y);break c}f=P()|0;O()|0;break c}D=1;y=Tb(d+232|0);H:{if(!(c&1)){break H}v[23540]=0;U(494,d+208|0,d+432|0,21076);b=v[23540];v[23540]=0;I:{J:{K:{L:{M:{N:{if((b|0)!=1){g=hd(m,d+208|0);b=v[g>>2];v[23540]=0;c=S(178,b|0)|0;b=v[23540];v[23540]=0;O:{P:{Q:{if((b|0)!=1){Bb(d+208|0);if(!c){break O}v[23540]=0;e=S(194,g|0)|0;c=v[23540];v[23540]=0;b=1;if((c|0)==1){break Q}v[23540]=0;h=e+1|0;R(499,y|0,h|0);c=v[23540];v[23540]=0;if((c|0)==1){break Q}while(1){if((b|0)==(h|0)){break O}v[23540]=0;e=S(194,g|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break P}v[23540]=0;U(190,d+96|0,g|0,e|0);c=v[23540];v[23540]=0;if((c|0)==1){break P}c=d+96|0;e=kc(d+208|0,c);hd(Ng(v[y>>2],b),e);Bb(e);b=b+1|0;Bb(c);continue}}f=P()|0;O()|0;Bb(d+208|0);break I}f=P()|0;O()|0;break I}f=P()|0;O()|0;break I}v[23540]=0;U(494,d+208|0,d+432|0,16720);b=v[23540];v[23540]=0;if((b|0)==1){break K}E=hd(g,d+208|0);b=v[E>>2];v[23540]=0;c=S(178,b|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break L}Bb(d+208|0);if(!c){break N}v[23540]=0;j=S(206,E|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break J}k=0;R:{S:{T:while(1){U:{if(j>>>0<=(k&65535)>>>0){v[23540]=0;Q(155,E|0,1)|0;b=v[23540];v[23540]=0;if((b|0)!=1){break U}break J}n=32;V:{if(w[d+476|0]<16){break V}v[23540]=0;R(500,E|0,d+208|0);b=v[23540];v[23540]=0;if((b|0)==1){break R}n=w[d+208|0];if(n>>>0<=x[a+480188>>1]|n>>>0>32){break V}u[a+480188>>1]=n}b=0;while(1){h=b&65535;if(h>>>0>=n>>>0){k=k+1|0;continue T}v[23540]=0;e=S(194,E|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break S}if(!(!e|h>>>0>31|h>>>0<x[a+480188>>1])){u[a+480188>>1]=b+1}b=b+1|0;continue}}break}v[23540]=0;r=a+484344|0;R(225,r|0,j|0);b=v[23540];v[23540]=0;if((b|0)==1){break J}F=d+208|2;m=0;while(1){if((j|0)==(m|0)){break N}G=Nb(d+96|0);W:{if(w[d+476|0]<16){o=32;h=64;break W}v[23540]=0;R(500,E|0,d+208|0);b=v[23540];v[23540]=0;if((b|0)==1){break M}c=w[d+209|0];o=w[d+208|0];b=d+80|0;pf(b,F,16,3);v[23540]=0;R(222,d+192|0,b|0);b=v[23540];v[23540]=0;if((b|0)==1){break M}b=d+192|0;Bc(G,b);zb(b);h=c+1|0}v[23540]=0;c=W(226,r|0,m&65535,h|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break M}X:{if(!c){v[23540]=0;Q(188,E|0,o<<1)|0;b=v[23540];v[23540]=0;if((b|0)!=1){break X}break M}b=v[r>>2];v[23540]=0;R(281,_b(b,m)|0,G|0);b=v[23540];v[23540]=0;if((b|0)==1){break M}p=h-1|0;s=0;while(1){A=s&65535;if(A>>>0>=o>>>0){break X}v[23540]=0;c=S(194,E|0)|0;b=v[23540];v[23540]=0;Y:{if((b|0)!=1){if(!c){break Y}b=v[y>>2];if(Bf(b,v[y+4>>2])>>>0<=c>>>0|A>>>0>=x[a+480188>>1]){break Y}C=Ng(b,c);zc(C);c=0;Z:while(1){e=c;if(h>>>0<=e>>>0){break Y}c=v[C+8>>2];b=v[C>>2];v[23540]=0;c=W(156,b|0,c|0,1)|0;b=v[23540];v[23540]=0;_:{$:{aa:{ba:{ca:{if((b|0)!=1){if(!c){break Y}b=_b(v[r>>2],m);b=jd(v[b>>2],v[v[b+48>>2]+12>>2],e,A);v[23540]=0;g=S(206,C|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break M}f=g>>>2|0;switch((g&3)-1|0){case 2:break $;case 1:break aa;case 0:break ba;default:break ca}}break M}c=(e+f|0)+1|0;continue}c=0;if(!e){continue}c=_b(v[r>>2],m);i=jd(v[c>>2],v[v[c+48>>2]+12>>2],e-1|0,A);while(1){c=w[i|0]|w[i+1|0]<<8|(w[i+2|0]<<16|w[i+3|0]<<24);t[b|0]=c;t[b+1|0]=c>>>8;t[b+2|0]=c>>>16;t[b+3|0]=c>>>24;c=w[i+4|0]|w[i+5|0]<<8;t[b+4|0]=c;t[b+5|0]=c>>>8;c=e+1|0;if((e|0)==(p|0)){continue Z}b=B(x[a+480188>>1],6)+b|0;g=f&255;e=c;f=f-1|0;if(g){continue}break}continue}if(e>>>0<=f>>>0){break _}c=_b(v[r>>2],m);g=jd(v[c>>2],v[v[c+48>>2]+12>>2],f,A);c=w[g|0]|w[g+1|0]<<8|(w[g+2|0]<<16|w[g+3|0]<<24);t[b|0]=c;t[b+1|0]=c>>>8;t[b+2|0]=c>>>16;t[b+3|0]=c>>>24;c=w[g+4|0]|w[g+5|0]<<8;t[b+4|0]=c;t[b+5|0]=c>>>8;break _}if(f&1){v[23540]=0;g=S(206,C|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break M}t[b|0]=g>>>0>120?-1:g}if(f&2){v[23540]=0;g=S(206,C|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break M}t[b+1|0]=g}n=0;c=0;da:{if(f&4){v[23540]=0;c=S(206,C|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break da}}k=0;if(f&8){v[23540]=0;i=S(206,C|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break da}k=i>>>4|0;n=i&15}q=0;i=0;if(f&16){v[23540]=0;i=S(206,C|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break da}}if(f&32){v[23540]=0;q=S(206,C|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break da}}l=kb-32|0;kb=l;g=l+24|0;RS(g,n,i);z=Oc(g);g=l+16|0;RS(g,((k-1&255)>>>0<6?k+15|0:k)&255,q);f=Oc(g);ea:{fa:{ga:{if(w[l+24|0]==10){i=w[f|0];g=w[z|0]&15;t[z|0]=g?-1:i;k=i|g<<8;q=w[l+16|0];if((q|0)!=10){break ga}q=0;t[l+16|0]=0;break ga}if(w[l+16|0]!=10){break fa}g=w[f|0]&15;t[f|0]=g?-1:0;k=g<<8;q=w[l+24|0]}if(k-256>>>0>4294967038){break fa}if(Ji(q)>>>0>=Ji(10)>>>0){break fa}t[b+5|0]=k;t[b+2|0]=15;t[b+3|0]=10;t[b+4|0]=k>>>8;break ea}if(c){t[b+2|0]=1;t[b+4|0]=c+2>>>2}Tu(l+24|0,z,l+16|0,f);i=w[l+24|0];ha:{if(!i){break ha}g=w[l+16|0];if(!g){t[l+16|0]=i;t[f|0]=w[z|0];t[l+24|0]=0;break ha}if(!((i|0)==20|(g|0)!=(i|0))){t[l+24|0]=0;break ha}if(!c){Co(l+8|0,b,i,w[z|0],g,w[f|0]);break ea}if(Ji(i)>>>0<=Ji(g)>>>0){break ha}Dh(l+24|0,l+16|0);Dh(z,f)}c=w[l+16|0];t[b+5|0]=w[f|0];t[b+3|0]=c}kb=l+32|0;break _}break M}c=e+1|0;continue}}break M}s=s+1|0;continue}}zb(G);m=m+1|0;continue}}f=P()|0;O()|0;break I}f=P()|0;O()|0;break I}f=P()|0;O()|0;break I}v[23540]=0;U(494,d+208|0,d+432|0,20048);b=v[23540];v[23540]=0;ia:{ja:{if((b|0)!=1){h=hd(E,d+208|0);b=v[h>>2];v[23540]=0;c=S(178,b|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break ja}Bb(d+208|0);if(!c){break H}e=a+484348|0;while(1){if(!Af(v[a+484344>>2],v[e>>2])){break H}c=v[h+8>>2];b=v[h>>2];v[23540]=0;c=W(156,b|0,c|0,16)|0;b=v[23540];v[23540]=0;if((b|0)==1){break ia}if(!c){break H}v[23540]=0;R(385,h|0,d+208|0);b=v[23540];v[23540]=0;if((b|0)!=1){b=v[a+484344>>2];v[23540]=0;R(386,_b(b,0)|0,d+208|0);b=v[23540];v[23540]=0;if((b|0)!=1){continue}}break}f=P()|0;O()|0;break I}f=P()|0;O()|0;break I}f=P()|0;O()|0;Bb(d+208|0);break I}f=P()|0;O()|0;break I}f=P()|0;O()|0;zb(G);break I}f=P()|0;O()|0;Bb(d+208|0);break I}f=P()|0;O()|0;break I}f=P()|0;O()|0}Vc(y);break c}Vc(y);break l}f=P()|0;O()|0;Bb(d+208|0);break c}f=P()|0;O()|0;break c}f=P()|0;O()|0;break c}f=P()|0;O()|0;break c}i=(b<<5)+a|0;g=i+480280|0;df(g);h=t[(b+d|0)+371|0];e=h<<1&254;u[i+480284>>1]=(e|0)==254?256:e;ka:{if((h|0)<0){v[g>>2]=v[g>>2]|1024;break ka}u[a+480188>>1]=b+1}v[23540]=0;R(501,d+408|0,i+480289|0);e=v[23540];v[23540]=0;if((e|0)==1){break j}b=b+1|0;continue}}f=P()|0;O()|0;break c}Bb(d+408|0);Zd(d+432|0);Bb(H)}kb=d+480|0;return D|0}f=P()|0;O()|0;break c}f=P()|0;O()|0;zb(d+96|0);break c}f=P()|0;O()|0;break c}f=P()|0;O()|0;break c}f=P()|0;O()|0;Ab(h);break d}f=P()|0;O()|0}Ab(g)}Bb(d+408|0)}Zd(d+432|0)}Bb(H);T(f|0);L()}function Nja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,z=0,A=0,C=0,D=0,E=0,F=0,G=0,H=0;d=kb-240|0;kb=d;zc(b);e=kb-16|0;kb=e;h=d+216|0;yu(e+8|0,h);g=v[e+12>>2];nc(e,v[b>>2],v[b+8>>2],v[e+8>>2],v[e+12>>2]);j=v[e+4>>2];if((j|0)==(g|0)){$b(b,v[e+12>>2])}kb=e+16|0;e=(g|0)==(j|0);if(!e){yU(h)}a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{if(!e){break n}if(!zU(d+216|0)){break n}if(!c){f=1;break n}Cd(a,1024);ag(a);v[a+480208>>2]=v[a+480208>>2]|12;_f(a+1074312|0,21);e=Ib(x[d+232>>1]);if(e){v[a+480204>>2]=B(e,1e4)}e=Ib(x[d+230>>1]);if(e){v[a+480196>>2]=e}if(!w[d+226|0]){oh(a,1)}PB(b,a+1298308|0,bc(v[d+220>>2])-14|0);b=je(d+112|0,b);v[23540]=0;R(338,d+200|0,b|0);e=v[23540];v[23540]=0;o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{if((e|0)!=1){Bb(b);v[23540]=0;U(339,d+112|0,d+200|0,1395544366);b=v[23540];v[23540]=0;if((b|0)==1){break s}v[23540]=0;b=S(275,v[d+112>>2])|0;e=v[23540];v[23540]=0;if((e|0)==1){break y}if(!b){break r}v[23540]=0;b=S(271,d+112|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break y}v[23540]=0;e=S(271,d+112|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break y}v[23540]=0;Q(188,d+112|0,4)|0;f=v[23540];v[23540]=0;if((f|0)==1){break y}f=a+484376|0;g=w[f|0];h=v[a+484360>>2];v[23540]=0;da(340,Wb(h,g)|0,d+112|0,b|0,65535,65535);b=v[23540];v[23540]=0;if((b|0)==1){break y}Ve(Wb(v[a+484360>>2],w[f|0]),e);b=d+112|0;Bb(b);v[23540]=0;U(339,b|0,d+200|0,1346458708);b=v[23540];v[23540]=0;if((b|0)==1){break x}v[23540]=0;e=S(275,v[d+112>>2])|0;b=v[23540];v[23540]=0;if((b|0)==1){break w}f=0;b=0;if(!e){break t}v[23540]=0;e=S(271,d+112|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break w}u[a+480188>>1]=e;if((e-33&65535)>>>0<65504){break t}v[23540]=0;b=S(271,d+112|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break w}v[23540]=0;R(225,a+484344|0,b|0);b=v[23540];v[23540]=0;if((b|0)==1){break w}b=0;v[23540]=0;o=S(279,d+112|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break w}switch(o-841887796|0){case 1:break t;case 0:case 2:break u;default:break v}}e=P()|0;O()|0;Bb(b);break a}e=P()|0;O()|0;Bb(d+112|0);break b}e=P()|0;O()|0;break b}e=P()|0;O()|0;Bb(d+112|0);break b}if(o){break t}}b=1}Bb(d+112|0);if(!b){break o}v[23540]=0;U(339,d+176|0,d+200|0,1398157625);b=v[23540];v[23540]=0;if((b|0)==1){break d}v[23540]=0;b=S(275,v[d+176>>2])|0;e=v[23540];v[23540]=0;if((e|0)==1){break c}if(!b){break q}v[23540]=0;Q(188,d+176|0,2)|0;b=v[23540];v[23540]=0;if((b|0)==1){break c}v[23540]=0;b=S(279,d+176|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break c}G=a,H=Qe((+(b>>>0)*2.3283064365386963e-10+ +(y[a+480204>>2]/1e4>>>0))*1e4),v[G+480204>>2]=H;b=0;v[23540]=0;Q(341,d+176|0,d+112|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break c}f=x[a+480188>>1];while(1){if((b|0)!=32&(b|0)!=(f|0)){G=d,H=Ib(x[(d+112|0)+(b<<1)>>1]),v[G+48>>2]=H;v[d+32>>2]=180;e=v[td(d+48|0,d+32|0)>>2]-90|0;g=e>>31;G=((b<<5)+a|0)+480284|0,H=Hc(Kka(e<<7|45,g<<7|e>>>25,90,0),nb)+128|0,u[G>>1]=H;b=b+1|0;continue}else{z:{v[23540]=0;Q(188,d+176|0,16)|0;b=v[23540];v[23540]=0;if((b|0)!=1){break z}break c}}break}v[23540]=0;b=W(156,v[d+176>>2],v[d+184>>2],2)|0;e=v[23540];v[23540]=0;if((e|0)==1){break c}A:{if(b){v[23540]=0;b=S(271,d+176|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break A}u[d+48>>1]=b;u[d+32>>1]=256;G=a,H=x[Wc(d+48|0,d+32|0)>>1],v[G+480200>>2]=H}v[23540]=0;Q(188,d+176|0,128)|0;b=v[23540];v[23540]=0;if((b|0)==1){break c}v[23540]=0;b=Q(341,d+176|0,d+48|0)|0;e=v[23540];v[23540]=0;if((e|0)!=1){if(!b){break q}e=x[a+480188>>1];b=0;while(1)if((b|0)!=32&(b|0)!=(e|0)){G=d,H=Ib(x[(d+48|0)+(b<<1)>>1]),v[G+32>>2]=H;v[d+16>>2]=128;G=((b<<5)+a|0)+480286|0,H=v[td(d+32|0,d+16|0)>>2]/2&255,u[G>>1]=H;b=b+1|0;continue}else{v[a+480228>>2]=v[a+480228>>2]<<1;break q}}break c}break c}e=P()|0;O()|0;break b}Bb(d+112|0);break p}Bb(d+176|0);v[23540]=0;U(339,d+112|0,d+200|0,1413830740);b=v[23540];v[23540]=0;B:{C:{if((b|0)!=1){v[23540]=0;b=S(275,v[d+112>>2])|0;e=v[23540];v[23540]=0;if((e|0)==1){break e}if(!b){break B}v[23540]=0;R(342,d+112|0,d+48|0);b=v[23540];v[23540]=0;if((b|0)==1){break e}if((Ib(x[d+58>>1])|0)!=65535){break C}v[23540]=0;Q(188,d+112|0,1)|0;b=v[23540];v[23540]=0;if((b|0)!=1){break C}break e}e=P()|0;O()|0;break b}v[23540]=0;b=S(202,d+112|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break e}v[23540]=0;X(331,a+1298332|0,d+112|0,b|0,2);b=v[23540];v[23540]=0;if((b|0)==1){break e}}Bb(d+112|0);v[23540]=0;U(339,d+48|0,d+200|0,1229869908);b=v[23540];v[23540]=0;if((b|0)==1){break h}v[23540]=0;b=S(275,v[d+48>>2])|0;e=v[23540];v[23540]=0;if((e|0)==1){break l}if(b){D:{v[23540]=0;b=S(271,d+48|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break i}E:{F:{b=b<<16>>16;f=b&32767;if(f>>>0>3999){break F}v[23540]=0;e=W(156,v[d+48>>2],v[d+56>>2],B(f,(b>>>14&2)+50|0)|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break g}if(!e){break F}u[a+480190>>1]=f;g=a+480190|0;h=d+130|0;j=(b|0)>=0;b=1;G:{H:{I:{J:{while(1){if(f>>>0<(b&65535)>>>0){v[23540]=0;b=S(271,d+48|0)|0;e=v[23540];v[23540]=0;if((e|0)!=1){break G}break g}K:{if(j){p=b}else{v[23540]=0;e=S(271,d+48|0)|0;m=v[23540];v[23540]=0;if((m|0)==1){break K}p=e+1|0}u[d+16>>1]=p;v[23540]=0;R(343,d+48|0,d+112|0);e=v[23540];v[23540]=0;if((e|0)==1){break J}e=x[d+16>>1];if((e-4e3&65535)>>>0>=61537){G=a,H=x[ke(g,d+16|0)>>1],u[G+480190>>1]=H;m=x[d+234>>1]|x[d+236>>1]<<16;v[23540]=0;X(344,d+112|0,(B(e,104)+a|0)+484380|0,bc(m)|0,o|0);e=v[23540];v[23540]=0;if((e|0)==1){break I}e=d+32|0;Fl(e,2,h);v[23540]=0;R(222,d+176|0,e|0);e=v[23540];v[23540]=0;if((e|0)==1){break H}e=d+176|0;Dc(((x[d+16>>1]<<5)+a|0)+946304|0,e);zb(e)}b=b+1|0;continue}break}e=P()|0;O()|0;break f}e=P()|0;O()|0;break f}e=P()|0;O()|0;break f}e=P()|0;O()|0;break f}if((b|0)!=4){break E}u[d+112>>1]=x[a+480190>>1];u[d+176>>1]=255;h=a+480192|0;b=d+176|0;G=h,H=x[Wc(d+112|0,b)>>1],u[G>>1]=H;v[23540]=0;U(339,b|0,d+200|0,1229278806);b=v[23540];v[23540]=0;if((b|0)==1){break j}L:{M:while(1){v[23540]=0;b=W(156,v[d+48>>2],v[d+56>>2],15)|0;e=v[23540];v[23540]=0;if((e|0)==1){break L}if(b){v[23540]=0;R(345,d+48|0,d+32|0);b=v[23540];v[23540]=0;if((b|0)==1){break k}b=Ib(x[d+32>>1]);if(b>>>0>=x[h>>1]){continue}e=B(b,104)+a|0;t[e+484524|0]=w[d+40|0];f=w[d+39|0];t[e+484523|0]=255;t[e+484525|0]=f;v[23540]=0;b=b+1&65535;e=W(251,a|0,b|0,b|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break k}if(!e){continue}G=d,H=Ib(w[d+37|0]|w[d+38|0]<<8),u[G+112>>1]=H;u[d+16>>1]=4095;G=e,H=x[Wc(d+112|0,d+16|0)>>1],v[G>>2]=H;b=w[d+35|0];if((b|0)==255){continue}v[23540]=0;b=Q(155,d+176|0,B(b,34)+2|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break k}if(!b){continue}v[23540]=0;R(346,d+176|0,d+112|0);b=v[23540];v[23540]=0;if((b|0)==1){break k}t[e+60|0]=w[e+60|0]|1;b=x[d+112>>1];v[d+20>>2]=16;v[d+24>>2]=240;G=d,H=Ib(b),v[G+16>>2]=H;b=MB(d+16|0);v[23540]=0;R(291,e+48|0,b|0);b=v[23540];v[23540]=0;if((b|0)==1){break k}g=v[e+52>>2];f=v[e+48>>2];b=0;while(1){j=$d(f,g);if(j>>>0<=b>>>0){b=w[d+36|0];if((b|0)!=255){t[e- -64|0]=b;t[e+63|0]=b;t[e+60|0]=w[e+60|0]|4}if(pc(f,g)){continue M}b=j-1|0;t[e+62|0]=b;t[e+61|0]=b;t[e+60|0]=w[e+60|0]|2;continue M}else{t[d+16|0]=64;j=(d+112|0)+(b<<1)|0;t[d+12|0]=w[j+2|0];m=Yb(d+16|0,d+12|0);i=Eb(f,b);t[i+2|0]=w[m|0];u[i>>1]=w[j+3|0];b=b+1|0;continue}}}break}Bb(d+176|0);break D}break k}Bb(d+48|0);break p}}}Bb(d+48|0);v[23540]=0;U(347,d+176|0,d+200|0,1145131092);b=v[23540];v[23540]=0;if((b|0)==1){break m}G=d,H=Fb(v[d+176>>2]),v[G+16>>2]=H;m=a+484344|0;A=c&1;q=d+48|4;C=Fb(v[d+180>>2]);r=(o|0)!=841887798;s=a+480188|0;D=(o|0)!=841887796;while(1){N:{O:{P:{Q:{R:{S:{T:{U:{V:{W:{X:{Y:{Z:{_:{g=v[d+16>>2];if(!Pb(g,C)){Vc(d+176|0);v[23540]=0;U(339,d+112|0,d+200|0,1346458702);b=v[23540];v[23540]=0;if((b|0)!=1){break _}e=P()|0;O()|0;break b}v[23540]=0;Q(188,g|0,4)|0;b=v[23540];v[23540]=0;if((b|0)!=1){v[23540]=0;i=S(271,g|0)|0;b=v[23540];v[23540]=0;$:{if((b|0)!=1){v[23540]=0;j=S(271,g|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break P}j=r?j:(j>>>0)/y[a+480196>>2]|0;if(!A|i>>>0>255){break N}v[23540]=0;b=W(226,m|0,i|0,j|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break P}if(b){break $}break N}e=P()|0;O()|0;break O}if(!r){h=0;v[23540]=0;Q(188,g|0,4)|0;b=v[23540];v[23540]=0;if((b|0)==1){break P}while(1){z=h&65535;if(z>>>0>=x[s>>1]){break N}v[23540]=0;b=S(271,g|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break Z}v[23540]=0;U(190,d+48|0,g|0,b+(b&1)&65535);b=v[23540];v[23540]=0;if((b|0)==1){break Q}b=d+48|0;f=kc(d+112|0,b);Bb(b);v[d+48>>2]=0;v[d+52>>2]=0;e=0;aa:{while(1){b=v[f>>2];v[23540]=0;b=W(156,b|0,v[d+120>>2],6)|0;k=v[23540];v[23540]=0;if((k|0)==1){break aa}k=v[d+48>>2];if(b&k>>>0<j>>>0){b=_b(v[m>>2],i);b=jd(v[b>>2],v[v[b+48>>2]+12>>2],k,z);v[23540]=0;R(348,d+32|0,f|0);k=v[23540];v[23540]=0;ba:{ca:{if((k|0)!=1){k=d+32|0;l=Oc(k);E=Te(k);F=Li(k);p=jc(k);n=t[d+32|0];if((n-1&255)>>>0>95){break ca}t[b|0]=n+13;if(!v[d+52>>2]){break ba}t[b+3|0]=19;v[d+12>>2]=15;G=b,H=w[td(q,d+12|0)|0]|208,t[G+5|0]=H;break ba}break R}if((n|0)>=0){break ba}if(v[d+52>>2]){t[b+3|0]=19;v[d+12>>2]=15;G=b,H=w[td(q,d+12|0)|0]|192,t[G+5|0]=H;break ba}t[b|0]=254}if(w[l|0]){t[b+2|0]=1;t[d+12|0]=64;G=b,H=w[Yb(l,d+12|0)|0],t[G+4|0]=H}l=w[E|0];if(l){t[b+1|0]=l}l=w[F|0];n=w[p|0];if(l|n){Pf(b,l,n)}l=d+48|0;b=w[k+5|0];if(b&128){v[23540]=0;k=S(206,f|0)|0;n=v[23540];v[23540]=0;if((n|0)==1){break R}b=k|b<<8&32512}e=b+e|0;CB(l,e,v[a+480196>>2]);continue}break}Bb(f);h=h+1|0;continue}break}break R}h=0;b=_b(v[m>>2],i);b=jd(v[b>>2],v[v[b+48>>2]+12>>2],0,0);da:while(1){f=0;if((h|0)==(j|0)){break N}while(1){if(x[s>>1]<=(f&65535)>>>0){h=h+1|0;continue da}v[23540]=0;R(349,d+48|0,g|0);e=v[23540];v[23540]=0;if((e|0)!=1){t[d+12|0]=0;ea:{if(!D){e=v[d+48>>2];v[d+112>>2]=e;i=d+112|0;k=Oc(i);l=Te(i);n=Li(i);if(e<<24>>24>0){t[b|0]=(B((e&240)>>>4|0,12)+(e&15)|0)+12}e=w[k|0];if(e>>>0>=4){t[b+2|0]=1;t[b+4|0]=(e>>>2|0)-1;e=w[k|0]}t[b+1|0]=e<<4&48|w[l|0]>>>4;i=w[l|0]&15;t[d+12|0]=i;e=w[n|0];t[b+5|0]=e;break ea}e=v[d+48>>2];v[d+8>>2]=e;v[d+4>>2]=e;e=d+32|0;wu(e,d+4|0,b);i=d+112|0;tB(i,d+12|0,b+5|0);sB(i,e);G=b,H=w[b+1|0]|w[Lb(d+48|0,0)|0]&48,t[G+1|0]=H;e=w[b+5|0];i=w[d+12|0]}Pf(b,i,e&255);e=w[b+3|0];fa:{if(e>>>0>11){break fa}e=1<<e;ga:{if(!(e&2240)){if(!(e&12)){break fa}if(!w[b+5|0]){break ga}break fa}e=w[b+5|0];i=e&240;if(i){t[b+5|0]=i;break fa}if(e){break fa}}t[b+3|0]=0}b=b+6|0;f=f+1|0;continue}break}break}e=P()|0;O()|0;break O}e=P()|0;O()|0;break O}v[23540]=0;b=S(275,v[d+112>>2])|0;e=v[23540];v[23540]=0;ha:{ia:{ja:{ka:{la:{if((e|0)!=1){if(b){f=Nb(d+48|0);e=a+484348|0;b=0;ma:{while(1){na:{v[23540]=0;g=W(156,v[d+112>>2],v[d+120>>2],1)|0;h=v[23540];v[23540]=0;if((h|0)==1){break na}if(!g){break ma}if(Af(v[a+484344>>2],v[e>>2])>>>0<=b>>>0){break ma}v[23540]=0;U(350,d+112|0,f|0,32);g=v[23540];v[23540]=0;if((g|0)==1){break na}g=v[m>>2];v[23540]=0;R(281,_b(g,b)|0,f|0);g=v[23540];v[23540]=0;if((g|0)==1){break na}b=b+1|0;continue}break}e=P()|0;O()|0;zb(f);break la}zb(f)}b=d+112|0;Bb(b);v[23540]=0;U(339,b|0,d+200|0,1414679374);b=v[23540];v[23540]=0;if((b|0)==1){break ka}v[23540]=0;b=S(275,v[d+112>>2])|0;e=v[23540];v[23540]=0;if((e|0)==1){break T}if(!b){break ha}f=Nb(d+48|0);e=a+480188|0;b=0;while(1){v[23540]=0;g=W(156,v[d+112>>2],v[d+120>>2],1)|0;h=v[23540];v[23540]=0;if((h|0)==1){break ja}if(!(g&x[e>>1]>b>>>0)){break ia}v[23540]=0;U(350,d+112|0,f|0,32);g=v[23540];v[23540]=0;if((g|0)==1){break ja}El(((b<<5)+a|0)+480289|0,f);b=b+1|0;continue}}e=P()|0;O()|0}Bb(d+112|0);break b}e=P()|0;O()|0;break b}e=P()|0;O()|0;zb(f);break S}zb(f)}b=d+112|0;Bb(b);v[23540]=0;U(347,b|0,d+200|0,1145129300);b=v[23540];v[23540]=0;if((b|0)==1){break U}G=d,H=Fb(v[d+112>>2]),v[G+48>>2]=H;e=c&2;f=Fb(v[d+116>>2]);g=a+480190|0;oa:{pa:{qa:{ra:{sa:{ta:{while(1){b=v[d+48>>2];if(!Pb(b,f)){Vc(d+112|0);b=Nb(d+48|0);if((o|0)!=841887798){break sa}v[23540]=0;c=Q(1,d+112|0,9519)|0;e=v[23540];v[23540]=0;if((e|0)==1){break ta}Jb(b,c);Ab(c);break ra}v[23540]=0;c=S(271,b|0)|0;h=v[23540];v[23540]=0;if((h|0)==1){break V}ua:{if(!(!e|c>>>0>=x[g>>1])){c=B(c,104)+a|0;h=x[c+484518>>1];h=Zc(d+176|0,h&1?16:8,h&64?2:1,1,0);v[23540]=0;W(219,h|0,c+484484|0,b|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break ua}}Nf(d+48|0);continue}break}break V}e=P()|0;O()|0;break W}v[23540]=0;U(339,d+112|0,d+200|0,1447383635);c=v[23540];v[23540]=0;va:{wa:{xa:{ya:{za:{if((c|0)!=1){v[23540]=0;c=S(275,v[d+112>>2])|0;e=v[23540];v[23540]=0;if((e|0)==1){break qa}if(!c){break wa}v[23540]=0;c=S(279,d+112|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break za}v[23540]=0;R(266,d+32|0,4295);e=v[23540];v[23540]=0;if((e|0)==1){break ya}v[d+16>>2]=c>>>4;v[23540]=0;v[d+12>>2]=c&15;X(351,d+176|0,d+32|0,d+16|0,d+12|0);c=v[23540];v[23540]=0;if((c|0)==1){break xa}c=d+176|0;Jb(b,c);Ab(c);dc(d+32|0);break va}e=P()|0;O()|0;break W}e=P()|0;O()|0;break X}e=P()|0;O()|0;break X}e=P()|0;O()|0;dc(d+32|0);break X}v[23540]=0;c=Q(1,d+176|0,8538)|0;e=v[23540];v[23540]=0;if((e|0)==1){break Y}Jb(b,c);Ab(c)}Bb(d+112|0)}v[23540]=0;c=Q(1,d+32|0,8538)|0;e=v[23540];v[23540]=0;if((e|0)==1){break pa}Jb(a+1298344|0,c);Ab(c);v[23540]=0;c=Q(1,d+16|0,10152)|0;e=v[23540];v[23540]=0;if((e|0)==1){break oa}Jb(a+1298356|0,c);Ab(c);Jb(a+1298368|0,b);v[a+1298404>>2]=14;Ab(b);f=1;break o}e=P()|0;O()|0;break X}e=P()|0;O()|0;break W}e=P()|0;O()|0;break W}e=P()|0;O()|0;break O}e=P()|0;O()|0}Bb(d+112|0)}Ab(b);break b}e=P()|0;O()|0;Vc(d+112|0);break b}e=P()|0;O()|0;break b}e=P()|0;O()|0}Bb(d+112|0);break b}e=P()|0;O()|0;Bb(f);break O}e=P()|0;O()|0;break O}e=P()|0;O()|0}Vc(d+176|0);break b}Nf(d+16|0);continue}}f=0}Zd(d+200|0)}kb=d+240|0;return f|0}e=P()|0;O()|0;break b}e=P()|0;O()|0;break f}e=P()|0;O()|0;Bb(d+176|0);break f}e=P()|0;O()|0;break f}e=P()|0;O()|0;break f}e=P()|0;O()|0;break b}e=P()|0;O()|0}Bb(d+48|0);break b}e=P()|0;O()|0;Bb(d+112|0);break b}e=P()|0;O()|0;break b}e=P()|0;O()|0;Bb(d+176|0)}Zd(d+200|0)}T(e|0);L()}function IV(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,y=0,z=0,A=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=kb-464|0;kb=d;zc(b);a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{z:{A:{B:{C:{D:{E:{F:{if(!ei(b,d+456|0)){break F}if(!RB(d+456|0)){break F}if(!c){p=1;break F}q=je(d+432|0,b);v[23540]=0;R(261,d+416|0,q|0);b=v[23540];v[23540]=0;G:{H:{I:{J:{K:{L:{M:{N:{O:{P:{Q:{R:{S:{T:{U:{V:{W:{X:{Y:{Z:{_:{$:{aa:{ba:{ca:{da:{ea:{fa:{if((b|0)!=1){v[23540]=0;U(262,d+240|0,d+416|0,1229866575);b=v[23540];v[23540]=0;if((b|0)==1){break da}v[23540]=0;p=Q(263,d+240|0,d+400|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break fa}Bb(d+240|0);if(!p){break G}v[23540]=0;R(246,a|0,524288);b=v[23540];v[23540]=0;ga:{if((b|0)==1){break ga}ag(a);v[a+480208>>2]=12;H=a+480188|0,I=Ed(Ib(x[d+408>>1]),1,127),u[H>>1]=I;H=d,I=Ib(x[d+400>>1]),u[H+240>>1]=I;u[d+344>>1]=255;H=a+480192|0,I=x[Wc(d+240|0,d+344|0)>>1],u[H>>1]=I;H=d,I=Ib(x[d+402>>1]),u[H+240>>1]=I;u[d+344>>1]=3999;H=a+480190|0,I=x[Wc(d+240|0,d+344|0)>>1],u[H>>1]=I;v[23540]=0;b=W(264,a+1074312|0,6,1)|0;e=v[23540];v[23540]=0;if((e|0)==1){break ga}v[23540]=0;b=Q(265,b|0,21)|0;e=v[23540];v[23540]=0;if((e|0)==1){break ga}v[23540]=0;Q(265,b|0,13)|0;b=v[23540];v[23540]=0;if((b|0)!=1){break ea}}b=P()|0;O()|0;break b}b=P()|0;O()|0;break a}b=P()|0;O()|0;Bb(d+240|0);break b}v[23540]=0;b=Q(1,d+384|0,9311)|0;e=v[23540];v[23540]=0;if((e|0)==1){break c}Jb(a+1298344|0,b);Ab(b);v[23540]=0;b=Q(1,d+368|0,10336)|0;e=v[23540];v[23540]=0;if((e|0)==1){break d}Jb(a+1298356|0,b);Ab(b);v[23540]=0;R(266,d+344|0,4339);b=v[23540];v[23540]=0;if((b|0)==1){break e}v[23540]=0;R(267,d+320|0,d+456|4);b=v[23540];v[23540]=0;if((b|0)==1){break g}v[23540]=0;R(267,d+296|0,d+456|5);b=v[23540];v[23540]=0;if((b|0)==1){break i}v[23540]=0;X(111,d+240|0,d+344|0,d+320|0,d+296|0);b=v[23540];v[23540]=0;if((b|0)==1){break j}b=d+240|0;Jb(a+1298368|0,b);Ab(b);Ab(d+296|0);Ab(d+320|0);b=d+344|0;dc(b);v[a+1298404>>2]=14;v[23540]=0;U(262,b|0,d+416|0,1312902469);b=v[23540];v[23540]=0;if((b|0)==1){break k}v[23540]=0;b=S(160,v[d+344>>2])|0;e=v[23540];v[23540]=0;if((e|0)==1){break m}v[23540]=0;g=a+1298308|0;U(268,d+344|0,g|0,b|0);b=v[23540];v[23540]=0;if((b|0)==1){break m}v[23540]=0;U(262,d+320|0,d+416|0,1397706311);b=v[23540];v[23540]=0;if((b|0)==1){break n}h=a+484360|0;e=a+484376|0;Lc(Wb(v[h>>2],w[e|0]));k=Ib(x[d+404>>1]);ha:{ia:{while(1){if(k>>>0<=(f&65535)>>>0){break ha}v[23540]=0;b=W(156,v[d+320>>2],v[d+328>>2],46)|0;j=v[23540];v[23540]=0;ja:{if((j|0)!=1){if(!b){break ha}v[23540]=0;R(269,d+320|0,d+240|0);b=v[23540];v[23540]=0;if((b|0)!=1){if(!Re(g)){break ja}v[23540]=0;R(270,g|0,d+240|0);b=v[23540];v[23540]=0;if((b|0)!=1){break ja}}b=P()|0;O()|0;break o}b=P()|0;O()|0;break o}v[23540]=0;j=S(271,d+320|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break ca}b=Wb(v[a+484360>>2],w[e|0]);if(!pc(v[b>>2],v[b+4>>2])){v[23540]=0;b=S(272,h|0)|0;i=v[23540];v[23540]=0;if((i|0)==1){break ca}if((b|0)==255){break ha}b=Wb(v[a+484360>>2],w[e|0])}v[23540]=0;U(5,d+296|0,14,d+240|0);i=v[23540];v[23540]=0;if((i|0)!=1){v[23540]=0;R(273,b|0,d+296|0);b=v[23540];v[23540]=0;if((b|0)==1){break ia}Ab(d+296|0);b=w[e|0];i=v[a+484360>>2];v[23540]=0;U(274,Wb(i,b)|0,d+320|0,j|0);b=v[23540];v[23540]=0;if((b|0)==1){break ca}f=f+1|0;continue}break}b=P()|0;O()|0;break o}b=P()|0;O()|0;Ab(d+296|0);break o}Gj(h,0);v[23540]=0;U(262,d+296|0,d+416|0,1229869908);b=v[23540];v[23540]=0;if((b|0)==1){break ba}v[23540]=0;b=S(275,v[d+296>>2])|0;f=v[23540];v[23540]=0;if((f|0)==1){break p}ka:{if(!b){break ka}g=a+480192|0;f=1;la:{while(1){b=f&65535;if(b>>>0>x[g>>1]){v[23540]=0;U(262,d+216|0,d+416|0,1447382614);b=v[23540];v[23540]=0;if((b|0)!=1){break la}break p}v[23540]=0;R(276,d+296|0,d+240|0);e=v[23540];v[23540]=0;if((e|0)==1){break p}e=x[d+270>>1];v[23540]=0;b=W(251,a|0,b|0,Ib(e)|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break p}ma:{na:{if(!b){break na}if(Ib(x[d+270>>1])>>>0>3999){break na}e=d+128|0;OB(e,2,d+240|0);v[23540]=0;R(222,d+152|0,e|0);e=v[23540];v[23540]=0;if((e|0)==1){break ma}e=d+152|0;Dc(b+492|0,e);zb(e);h=d+128|0;OB(h,2,d+240|0);v[23540]=0;R(222,e|0,h|0);e=v[23540];v[23540]=0;if((e|0)==1){break p}e=d+152|0;Dc(((Ib(x[d+270>>1])<<5)+a|0)+946304|0,e);zb(e);v[b>>2]=0;H=b,I=pe(u[d+286>>1])+128&65535,v[H+8>>2]=I;xc(b+8|0,256);t[b+15|0]=w[b+15|0]|1;b=x[d+270>>1];v[23540]=0;b=B(Ib(b),104)+a|0;R(277,b+484380|0,0);e=v[23540];v[23540]=0;if((e|0)==1){break p}H=d,I=Ib(x[d+272>>1]),u[H+152>>1]=I;u[d+128>>1]=64;H=b+484410|0,I=x[Wc(d+152|0,d+128|0)>>1]<<2,u[H>>1]=I;H=b+484404|0,I=bc(x[d+274>>1]|x[d+276>>1]<<16),v[H>>2]=I;e=bc(x[d+282>>1]|x[d+284>>1]<<16);if(!e){break na}h=Ib(x[d+288>>1]);if(!(h&3)){break na}k=e;e=bc(x[d+278>>1]|x[d+280>>1]<<16);v[b+484388>>2]=k+e;v[b+484384>>2]=e;b=b+484414|0;e=x[b>>1];u[b>>1]=e|2;if(!(h&2)){break na}u[b>>1]=e|6}f=f+1|0;continue}break}break p}b=v[d+228>>2];v[d+32>>2]=v[d+224>>2];v[d+36>>2]=b;v[d+40>>2]=v[d+232>>2];v[23540]=0;b=v[d+220>>2];v[d+24>>2]=v[d+216>>2];v[d+28>>2]=b;X(278,d+24|0,0,a|0,0);b=v[23540];v[23540]=0;if((b|0)==1){break p}v[23540]=0;U(262,d+192|0,d+416|0,1346719318);b=v[23540];v[23540]=0;if((b|0)==1){break p}b=v[d+204>>2];v[d+8>>2]=v[d+200>>2];v[d+12>>2]=b;v[d+16>>2]=v[d+208>>2];v[23540]=0;b=v[d+196>>2];v[d>>2]=v[d+192>>2];v[d+4>>2]=b;X(278,d|0,1,a|0,w[d+460|0]>2|0);b=v[23540];v[23540]=0;if((b|0)==1){break p}e=x[a+480192>>1]+1&65535;b=1;while(1){if((b|0)==(e|0)){break ka}f=v[((b<<2)+a|0)+900380>>2];if(!(!f|t[f+60|0]&1)){v[f>>2]=32767}b=b+1|0;continue}}Bb(d+296|0);v[23540]=0;U(262,d+240|0,d+416|0,1346458708);b=v[23540];v[23540]=0;if((b|0)==1){break q}v[23540]=0;b=S(178,v[d+240>>2])|0;f=v[23540];v[23540]=0;if((f|0)==1){break s}if(!(!(c&1)|b^1)){v[23540]=0;U(262,d+296|0,d+416|0,1347305805);b=v[23540];v[23540]=0;if((b|0)==1){break t}v[23540]=0;Q(188,d+296|0,1)|0;b=v[23540];v[23540]=0;if((b|0)==1){break v}b=x[d+406>>1];v[23540]=0;m=a+484344|0;R(225,m|0,Ib(b)|0);b=v[23540];v[23540]=0;if((b|0)==1){break v}b=d+128|0;A=b|3;C=b|1;i=Tb(d+176|0);D=a+480188|0;h=0;while(1){if(Ib(x[d+406>>1])>>>0<=l>>>0){od(i);e=h;Bb(d+296|0);if(!(c&4)){break $}f=0;if(!E){break aa}g=x[a+480188>>1];b=0;f=1;while(1){if((b|0)==(g|0)){break aa}h=(b<<5)+a|0;t[h+480288|0]=1;h=h+480280|0;v[h>>2]=v[h>>2]|67108864;b=b+1|0;continue}}v[23540]=0;b=S(271,d+240|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break x}v[23540]=0;f=S(279,d+240|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break y}v[23540]=0;U(190,d+128|0,d+240|0,f|0);f=v[23540];v[23540]=0;if((f|0)==1){break z}f=d+128|0;j=kc(d+152|0,f);Bb(f);v[23540]=0;f=W(226,m|0,l&65535,b|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break B}oa:{if(f){o=Nb(d+112|0);v[23540]=0;R(280,d+296|0,o|0);f=v[23540];v[23540]=0;if((f|0)==1){break oa}f=v[m>>2];v[23540]=0;R(281,_b(f,l)|0,o|0);f=v[23540];v[23540]=0;if((f|0)==1){break oa}n=0;f=_b(v[m>>2],l);y=Cf(v[f>>2],v[v[f+48>>2]+12>>2],0);Lc(i);F=(b>>>0>1?b:1)-1|0;pa:while(1){b=v[j>>2];v[23540]=0;b=W(156,b|0,v[d+160>>2],1)|0;f=v[23540];v[23540]=0;if((f|0)==1){break C}qa:{if(!b){break qa}v[23540]=0;f=S(206,j|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break C}if(!f){H=d,I=Fb(v[i>>2]),v[H+104>>2]=I;f=Fb(v[i+4>>2]);while(1){b=v[d+104>>2];if(Pb(b,f)){ze(_b(v[m>>2],l),Ue(Oe(d+128|0,w[b|0],w[b+1|0]),n));Se(d+104|0);continue}else{Lc(i);if((n|0)==(F|0)){break qa}b=_b(v[m>>2],l);n=n+1|0;y=Cf(v[b>>2],v[v[b+48>>2]+12>>2],n);continue pa}}}Fj(d+128|0);e=x[D>>1];v[23540]=0;b=S(206,j|0)|0;g=v[23540];v[23540]=0;ra:{sa:{if((g|0)!=1){r=B(f-1|0,6)+y|0;s=e>>>0<f>>>0;k=s?d+128|0:r;ta:{if(!(b&1)){break ta}v[23540]=0;f=S(206,j|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break C}if((f|0)!=31){if((f-1&255)>>>0>252){break ta}e=(B(f>>>4|0,12)+(f&15)|0)+13|0}else{e=255}t[k|0]=e}if(!(b&2)){break ra}v[23540]=0;f=S(206,j|0)|0;e=v[23540];v[23540]=0;if((e|0)!=1){break sa}}break C}t[(s?C:r+1|0)|0]=f}if(!(b&60)){continue}f=0;e=0;if(b&4){v[23540]=0;e=S(206,j|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break C}}if(b&8){v[23540]=0;f=S(206,j|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break C}}g=0;z=0;if(b&16){v[23540]=0;z=S(206,j|0)|0;G=v[23540];v[23540]=0;if((G|0)==1){break C}}if(b&32){v[23540]=0;g=S(206,j|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break C}}b=d+104|0;zV(b,z,g);g=Oc(b);b=d+96|0;zV(b,e,f);f=Oc(b);b=w[d+96|0];ua:{if((b|0)!=13){if(b){break ua}b=0;if(w[d+104|0]==13){break ua}}Dh(d+104|0,d+96|0);Dh(g,f);b=w[d+96|0]}Co(d+88|0,k,w[d+104|0],w[g|0],b&255,w[f|0]);if(yV(w[d+88|0],w[d+89|0])){b=v[fc(d+80|0,Fb(v[i>>2]))>>2];v[23540]=0;U(282,i|0,b|0,d+88|0);b=v[23540];v[23540]=0;if((b|0)==1){break C}}b=w[(s?A:r+3|0)|0];if((b|0)==43){E=1;continue}if((b|0)!=31){continue}h=1;continue}break}zb(o)}Bb(j);l=l+1|0;continue}break}break C}e=0;f=0;if(c&4){break aa}break H}b=P()|0;O()|0;break b}b=P()|0;O()|0;break o}b=P()|0;O()|0;break o}v[d+176>>2]=-1778364416;v[d+180>>2]=-16756736;v[23540]=0;U(262,d+296|0,d+416|0,1146310725);b=v[23540];v[23540]=0;if((b|0)==1){break E}v[23540]=0;b=S(275,v[d+296>>2])|0;g=v[23540];v[23540]=0;if((g|0)==1){break D}if(b){v[23540]=0;k=S(271,d+296|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break D}j=a+480188|0;b=0;g=f;while(1){va:{if((b|0)==(k|0)){v[23540]=0;R(283,d+296|0,d+176|0);b=v[23540];v[23540]=0;if((b|0)!=1){break va}break D}v[23540]=0;h=S(206,d+296|0)|0;i=v[23540];v[23540]=0;wa:{xa:{if((i|0)!=1){if(x[j>>1]<=b>>>0){break wa}if(!f){break xa}i=((b<<5)+a|0)+480280|0;v[i>>2]=v[i>>2]&-67108865|((h|0)!=0)<<26;break wa}break D}if(h){break wa}g=1;t[((b<<5)+a|0)+480288|0]=1}b=b+1|0;continue}break}f=g&1}Bb(d+296|0);if(!f){break $}v[23540]=0;b=Md(a+906300|0,0);Y(284,b|0);f=v[23540];v[23540]=0;if((f|0)==1){break _}v[b+16>>2]=810369604;v[b+20>>2]=1869112133;v[b+24>>2]=655376;v[b+28>>2]=0;v[d+296>>2]=0;g=b+48|0;vV(b+32|0,g,d+296|0);v[23540]=0;f=Q(55,d+152|0,9585)|0;h=v[23540];v[23540]=0;if((h|0)==1){break Z}NB(g,f);zb(f);v[23540]=0;f=Q(55,d+128|0,9549)|0;g=v[23540];v[23540]=0;if((g|0)==1){break Y}Ju(b+80|0,f);zb(f);v[23540]=0;R(285,b+4|0,8);f=v[23540];v[23540]=0;if((f|0)==1){break _}uV(d+296|0,w[d+177|0],w[d+179|0],w[d+181|0],w[d+183|0]);f=v[d+300>>2];b=v[b+4>>2];g=v[d+296>>2];t[b|0]=g;t[b+1|0]=g>>>8;t[b+2|0]=g>>>16;t[b+3|0]=g>>>24;t[b+4|0]=f;t[b+5|0]=f>>>8;t[b+6|0]=f>>>16;t[b+7|0]=f>>>24}if(!e){break H}f=a+902204|0;b=0;while(1){if((b|0)==32){break H}v[d+104>>2]=B(b,127)>>>5;v[23540]=0;R(286,d+176|0,4096);e=v[23540];v[23540]=0;if((e|0)==1){break X}v[23540]=0;R(287,d+112|0,d+104|0);e=v[23540];v[23540]=0;if((e|0)==1){break W}v[23540]=0;U(288,d+296|0,d+176|0,d+112|0);e=v[23540];v[23540]=0;if((e|0)==1){break V}e=d+296|0;Fe(d+72|0,e);gf(ye(f,b),v[d+72>>2],v[d+76>>2]);zb(e);zb(d+112|0);e=d+176|0;Xb(e);v[23540]=0;R(286,e|0,4078);e=v[23540];v[23540]=0;if((e|0)==1){break T}v[23540]=0;R(287,d+112|0,d+104|0);e=v[23540];v[23540]=0;if((e|0)==1){break S}v[23540]=0;U(288,d+296|0,d+176|0,d+112|0);e=v[23540];v[23540]=0;if((e|0)==1){break R}e=d+296|0;Fe(d- -64|0,e);gf(ye(f,b+32|0),v[d+64>>2],v[d+68>>2]);zb(e);zb(d+112|0);e=d+176|0;Xb(e);v[23540]=0;R(286,e|0,4069);e=v[23540];v[23540]=0;if((e|0)==1){break P}v[23540]=0;R(287,d+112|0,d+104|0);e=v[23540];v[23540]=0;if((e|0)==1){break O}v[23540]=0;U(288,d+296|0,d+176|0,d+112|0);e=v[23540];v[23540]=0;if((e|0)==1){break N}e=d+296|0;Fe(d+56|0,e);gf(ye(f,b- -64|0),v[d+56>>2],v[d+60>>2]);zb(e);zb(d+112|0);e=d+176|0;Xb(e);v[23540]=0;R(286,e|0,4042);e=v[23540];v[23540]=0;if((e|0)==1){break L}v[23540]=0;R(287,d+112|0,d+104|0);e=v[23540];v[23540]=0;if((e|0)==1){break K}v[23540]=0;U(288,d+296|0,d+176|0,d+112|0);e=v[23540];v[23540]=0;if((e|0)==1){break J}e=d+296|0;Fe(d+48|0,e);gf(ye(f,b+96|0),v[d+48>>2],v[d+52>>2]);b=b+1|0;zb(e);zb(d+112|0);Xb(d+176|0);continue}}b=P()|0;O()|0;break r}b=P()|0;O()|0;break r}b=P()|0;O()|0;break r}b=P()|0;O()|0;break r}b=P()|0;O()|0;break U}b=P()|0;O()|0;zb(d+112|0)}Xb(d+176|0);break r}b=P()|0;O()|0;break r}b=P()|0;O()|0;break Q}b=P()|0;O()|0;zb(d+112|0)}Xb(d+176|0);break r}b=P()|0;O()|0;break r}b=P()|0;O()|0;break M}b=P()|0;O()|0;zb(d+112|0)}Xb(d+176|0);break r}b=P()|0;O()|0;break r}b=P()|0;O()|0;break I}b=P()|0;O()|0;zb(d+112|0)}Xb(d+176|0);break r}v[23540]=0;U(262,d+296|0,d+416|0,1397575756);b=v[23540];v[23540]=0;ya:{if((b|0)!=1){v[23540]=0;b=S(178,v[d+296>>2])|0;f=v[23540];v[23540]=0;if((f|0)!=1){za:{f=1;if(!(c&2)|b^1){break ya}c=a+480190|0;while(1){e=f&65535;if(e>>>0>x[c>>1]){break ya}v[23540]=0;b=S(279,d+296|0)|0;g=v[23540];v[23540]=0;Aa:{if((g|0)!=1){v[23540]=0;g=S(279,d+296|0)|0;h=v[23540];v[23540]=0;if((h|0)==1){break za}if(!(b&7)){break Aa}e=(B(e,104)+a|0)+484380|0;v[e>>2]=g;b=Zc(d+176|0,b&4?32:b&2?16:8,1,1,0);v[23540]=0;W(219,b|0,e|0,d+296|0)|0;b=v[23540];v[23540]=0;if((b|0)!=1){break Aa}break za}break za}f=f+1|0;continue}}}b=P()|0;O()|0;Bb(d+296|0);break r}b=P()|0;O()|0;break r}Bb(d+296|0);Bb(d+240|0);Bb(d+320|0);Bb(d+344|0)}Zd(d+416|0);Bb(q)}kb=d+464|0;return p|0}b=P()|0;O()|0;break r}b=P()|0;O()|0;Bb(d+296|0);break r}b=P()|0;O()|0;zb(o);break A}b=P()|0;O()|0}Bb(j);break w}b=P()|0;O()|0;break w}b=P()|0;O()|0;break w}b=P()|0;O()|0}od(i);break u}b=P()|0;O()|0}Bb(d+296|0);break r}b=P()|0;O()|0;break r}b=P()|0;O()|0}Bb(d+240|0);break o}b=P()|0;O()|0;break o}b=P()|0;O()|0;Bb(d+296|0)}Bb(d+320|0);break l}b=P()|0;O()|0;break l}b=P()|0;O()|0}Bb(d+344|0);break b}b=P()|0;O()|0;break b}b=P()|0;O()|0;Ab(d+296|0);break h}b=P()|0;O()|0}Ab(d+320|0);break f}b=P()|0;O()|0}dc(d+344|0);break b}b=P()|0;O()|0;break b}b=P()|0;O()|0;break b}b=P()|0;O()|0}Zd(d+416|0)}Bb(q);T(b|0);L()}function ifa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,z=0,A=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,M=0,N=0,V=0,X=0;f=kb-496|0;kb=f;zc(b);i=kb-16|0;kb=i;g=f+288|0;LQ(i+8|0,g);e=v[i+12>>2];n=b;nc(i,v[b>>2],v[b+8>>2],v[i+8>>2],v[i+12>>2]);b=v[i+4>>2];if((b|0)==(e|0)){$b(n,v[i+12>>2])}kb=i+16|0;b=(b|0)==(e|0);if(!b){KQ(g)}a:{if(!b){break a}if(!MQ(f+288|0)){break a}if(!c){d=1;break a}Cd(a,134217728);b=f+8|0;Sf(b,3956);v[23540]=0;U(674,f+120|0,b|0,x[f+292>>1]);b=v[23540];v[23540]=0;b:{c:{d:{e:{f:{g:{if((b|0)!=1){b=f+120|0;Jb(a+1298344|0,b);Ab(b);dc(f+8|0);b=yc(b,9003);Jb(a+1298356|0,b);Ab(b);v[a+480188>>2]=4;v[a+1298404>>2]=14;V=a,X=Ib(x[f+424>>1]),v[V+480196>>2]=X;b=x[f+428>>1];v[a+480260>>2]=56;v[a+480264>>2]=13696;V=a,X=JQ(Ib(b)),v[V+480204>>2]=X;Kq(Wb(v[a+484360>>2],w[a+484376|0]),f+296|0,w[f+294|0]);q=a+480190|0;m=a+480188|0;o=Tb(f+272|0);z=Tb(f+256|0);h:{i:{j:{k:{while(1){if(Ib(x[f+488>>1])>>>0<=(l&65535)>>>0){break k}v[23540]=0;b=S(271,n|0)|0;i=v[23540];v[23540]=0;if((i|0)==1){break g}u[f+232>>1]=b;if((b-4e3&65535)>>>0<=61536){break c}d=Ib(x[f+490>>1]);if((Ib(x[f+292>>1])|0)==2){v[23540]=0;b=S(279,n|0)|0;i=v[23540];v[23540]=0;if((i|0)==1){break h}d=b-2|0}v[23540]=0;U(190,f+8|0,n|0,d|0);b=v[23540];v[23540]=0;if((b|0)==1){break i}b=f+8|0;h=kc(f+120|0,b);Bb(b);C=x[ke(q,f+232|0)>>1];u[q>>1]=C;v[23540]=0;j=B(x[f+232>>1],104)+a|0;e=j+484380|0;R(277,e|0,1);b=v[23540];v[23540]=0;l:{m:{n:{if((b|0)==1){break n}if(Ib(x[f+292>>1])>>>0>1){break m}v[23540]=0;R(675,h|0,j+484423|0);b=v[23540];v[23540]=0;if((b|0)==1){break n}v[23540]=0;Q(188,h|0,1)|0;b=v[23540];v[23540]=0;if((b|0)==1){break n}v[23540]=0;U(325,h|0,((x[f+232>>1]<<5)+a|0)+946304|0,30);b=v[23540];v[23540]=0;if((b|0)!=1){break l}}e=P()|0;O()|0;break f}b=Nb(f+8|0);v[23540]=0;U(350,h|0,b|0,257);i=v[23540];v[23540]=0;o:{p:{if((i|0)==1){break p}Be(j+484423|0,b);v[23540]=0;Q(188,h|0,1)|0;i=v[23540];v[23540]=0;if((i|0)==1){break p}v[23540]=0;U(350,h|0,b|0,31);i=v[23540];v[23540]=0;if((i|0)==1){break p}Dc(((x[f+232>>1]<<5)+a|0)+946304|0,b);if(!(t[f+128|0]&1)){break o}v[23540]=0;Q(188,h|0,1)|0;i=v[23540];v[23540]=0;if((i|0)!=1){break o}}e=P()|0;O()|0;zb(b);break f}zb(b)}v[23540]=0;R(676,h|0,f+8|0);b=v[23540];v[23540]=0;q:{if((b|0)==1){break q}d=kb-16|0;kb=d;i=bc(w[f+8|0]|w[f+9|0]<<8|(w[f+10|0]<<16|w[f+11|0]<<24));v[e>>2]=i;t[d+15|0]=w[f+12|0];t[d+14|0]=64;V=e,X=w[Yb(d+15|0,d+14|0)|0]<<2,u[V+30>>1]=X;g=bc(w[f+14|0]|w[f+15|0]<<8|(w[f+16|0]<<16|w[f+17|0]<<24));v[e+4>>2]=g;b=bc(w[f+14|0]|w[f+15|0]<<8|(w[f+16|0]<<16|w[f+17|0]<<24))+bc(w[f+18|0]|w[f+19|0]<<8|(w[f+20|0]<<16|w[f+21|0]<<24))|0;v[e+8>>2]=b;if(g>>>0>=i>>>0){g=i-1|0;v[e+4>>2]=g}if(b>>>0>i>>>0){v[e+8>>2]=i;b=i}r:{if(b>>>0<g>>>0){v[e+4>>2]=0;v[e+8>>2]=0;break r}if(b>>>0<=g>>>0){break r}u[e+34>>1]=x[e+34>>1]|2;V=Eb(e+68|0,0),X=g,v[V>>2]=X}kb=d+16|0;s:{t:{switch(Ib(x[f+292>>1])|0){case 2:t[j+484417|0]=w[f+26|0]<<3;break;case 0:break s;default:break t}}v[23540]=0;R(214,z|0,C|0);b=v[23540];v[23540]=0;if((b|0)==1){break q}v[23540]=0;R(677,o|0,C|0);b=v[23540];v[23540]=0;if((b|0)==1){break q}i=Nd(v[o>>2],x[f+232>>1]-1|0);Lc(i);v[23540]=0;b=S(271,n|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break j}e=v[n+8>>2];d=v[n>>2];v[23540]=0;e=W(156,d|0,e|0,b<<3)|0;d=v[23540];v[23540]=0;if((d|0)==1){break j}if(e){v[23540]=0;R(678,i|0,b|0);e=v[23540];v[23540]=0;if((e|0)==1){break j}d=0;v[f+248>>2]=0;if(!(!(w[j+484414|0]&2)|b)){b=v[j+484384>>2];v[f+240>>2]=b;e=v[j+484388>>2];v[23540]=0;v[f+244>>2]=e-b;R(679,i|0,f+240|0);b=v[23540];v[23540]=0;if((b|0)!=1){break s}e=P()|0;O()|0;break f}while(1){if(b>>>0<=(d&65535)>>>0){break s}v[23540]=0;e=S(279,n|0)|0;g=v[23540];v[23540]=0;u:{if((g|0)==1){break u}v[23540]=0;v[f+240>>2]=e;e=S(279,n|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break u}v[23540]=0;v[f+244>>2]=e;R(679,i|0,f+240|0);e=v[23540];v[23540]=0;if((e|0)==1){break u}d=d+1|0;continue}break}e=P()|0;O()|0;break f}Bb(h);break c}Bb(h);l=l+1|0;continue}break}e=P()|0;O()|0;break f}v:{w:{x:{y:{if(Ib(x[f+292>>1])){A=w[f+295|0];u[f+238>>1]=4;D=128;break y}v[23540]=0;D=S(271,n|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){e=P()|0;O()|0;break e}b=x[f+292>>1];A=w[f+295|0];u[f+238>>1]=4;if(!Ib(b)){break x}}i=v[n+8>>2];e=0;while(1){z:{if((e&65535)>>>0>=D>>>0){break z}v[23540]=0;b=S(271,n|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break w}if((b|0)==65535){break z}v[23540]=0;A=S(271,n|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break w}v[23540]=0;b=S(271,n|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break w}u[f+238>>1]=b;if(b>>>0>127){break c}V=m,X=x[ke(m,f+238|0)>>1],u[V>>1]=X;v[23540]=0;Q(188,n|0,B(b,A)<<2)|0;b=v[23540];v[23540]=0;if((b|0)==1){break w}e=e+1|0;continue}break}v[23540]=0;Q(155,n|0,i|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break v}}b=x[m>>1];v[23540]=0;E=Q(680,f+240|0,b|0)|0;b=v[23540];v[23540]=0;if((b|0)!=1){J=a+484344|0;N=c&1;F=Ib(x[f+426>>1]);b=0;i=0;while(1){A:{B:{C:{D:{if((b&65535)>>>0>=D>>>0){break D}E:{if(!Ib(x[f+292>>1])){d=x[f+238>>1];e=b;break E}v[23540]=0;e=S(271,n|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break A}if((e|0)==65535){break D}v[23540]=0;A=S(271,n|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break A}v[23540]=0;d=S(271,n|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break A}u[f+238>>1]=d}g=v[n+8>>2];h=v[n>>2];v[23540]=0;r=g;G=A&65535;g=G<<2;d=W(156,h|0,r|0,B(g,d&65535)|0)|0;h=v[23540];v[23540]=0;if((h|0)==1){break A}if(!d){break D}if(!N){break C}v[23540]=0;K=e&65535;e=W(226,J|0,K|0,G|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break A}if(!e){break C}s=0;F:while(1){if((s|0)==(G|0)){break B}e=0;d=_b(v[J>>2],K);j=Cf(v[d>>2],v[v[d+48>>2]+12>>2],s);H=0;r=0;G:{H:{I:{switch((F&3)-1|0){case 0:r=!(s&3);break H;case 1:r=!(s&1);break H;case 2:break I;default:break G}}r=(s&3)!=3}}while(1){if(x[f+238>>1]<=e>>>0){s=s+1|0;continue F}d=v[E>>2];v[23540]=0;R(349,f+232|0,n|0);g=v[23540];v[23540]=0;if((g|0)==1){break A}h=B(e,9)+d|0;d=f+232|0;g=Oc(d);p=Te(d);m=j+B(e,6)|0;t[m+1|0]=w[f+232|0];k=w[g|0];t[m|0]=k;g=w[Li(d)|0];t[m+5|0]=g;l=m+5|0;if(k){t[m|0]=k+25;t[h+8|0]=0;t[h|0]=0;t[h+1|0]=0;t[h+2|0]=0;t[h+3|0]=0;t[h+4|0]=0;t[h+5|0]=0;t[h+6|0]=0;t[h+7|0]=0;g=w[l|0]}k=g&255;p=w[p|0];J:{if(p>>>0>=240){d=k|(p&15)<<8;if(d){V=l,X=tk(+(JQ(d)>>>0)/1e4),t[V|0]=X;t[m+3|0]=17;break J}t[m+3|0]=0;break J}I=k>>>4|0;M=k<<4;d=I|M;K:{switch(p|0){case 0:d=j+B(e,6)|0;if(g&255){t[d+3|0]=1;break J}t[d+3|0]=0;break J;case 1:t[(j+B(e,6)|0)+3|0]=2;break J;case 2:t[(j+B(e,6)|0)+3|0]=3;break J;case 3:t[f+228|0]=15;V=h,X=w[Yb(l,f+228|0)|0]|16,t[V|0]=X;t[h+7|0]=0;t[h+1|0]=0;t[h+2|0]=0;t[(j+B(e,6)|0)+3|0]=0;break J;case 4:t[f+228|0]=15;V=h,X=w[Yb(l,f+228|0)|0]|32,t[V|0]=X;t[h+7|0]=0;t[h+1|0]=0;t[h+2|0]=0;t[(j+B(e,6)|0)+3|0]=0;break J;case 5:t[h+7|0]=0;t[h+2|0]=0;t[h+1|0]=g;t[h|0]=0;t[(j+B(e,6)|0)+3|0]=0;break J;case 6:t[h+7|0]=0;t[h+2|0]=g;t[h|0]=0;t[h+1|0]=0;t[(j+B(e,6)|0)+3|0]=0;break J;case 7:t[(j+B(e,6)|0)+3|0]=23;i=0;break J;case 8:t[(j+B(e,6)|0)+3|0]=0;i=d;break J;case 9:t[(j+B(e,6)|0)+3|0]=19;t[f+228|0]=15;V=l,X=w[Yb(l,f+228|0)|0]|16,t[V|0]=X;break J;case 10:t[(j+B(e,6)|0)+3|0]=19;t[f+228|0]=15;V=l,X=w[Yb(l,f+228|0)|0]|32,t[V|0]=X;break J;case 11:t[h+3|0]=d;t[(j+B(e,6)|0)+3|0]=0;break J;case 12:d=j+B(e,6)|0;t[d+4|0]=g;t[d+2|0]=1;t[h+3|0]=0;t[d+3|0]=0;break J;case 13:p=j+B(e,6)|0;L:{M:{if(k&240){t[(j+B(e,6)|0)+2|0]=4;d=(g&240)>>>4|0;break M}if(!(k&15)){break L}t[(j+B(e,6)|0)+2|0]=3;d=g&15}t[p+4|0]=d}t[h+3|0]=0;t[(j+B(e,6)|0)+3|0]=0;break J;case 14:t[(j+B(e,6)|0)+3|0]=19;t[l|0]=!(g&255);break J;case 15:t[(j+B(e,6)|0)+3|0]=16;t[l|0]=(g&240)>>>4;F=g&15;break J;case 16:t[h+5|0]=0;t[h+4|0]=g;t[(j+B(e,6)|0)+3|0]=0;break J;case 17:t[h+6|0]=k&15?g:0;t[(j+B(e,6)|0)+3|0]=0;break J;case 18:t[(j+B(e,6)|0)+3|0]=14;break J;case 19:t[h+8|0]=0;t[h+7|0]=g;t[h+2|0]=0;t[h|0]=0;t[h+1|0]=0;t[(j+B(e,6)|0)+3|0]=0;break J;case 20:t[(j+B(e,6)|0)+3|0]=12;break J;case 22:d=w[m+1|0];N:{if(!d){break N}k=v[o>>2];if(yd(k,v[o+4>>2])>>>0<d>>>0){break N}g=g-1|0;t[l|0]=g;v[23540]=0;S(681,f+120|0)|0;p=v[23540];v[23540]=0;if((p|0)==1){break A}v[f+228>>2]=9;d=Nd(k,d-1|0);V=f,X=yd(v[d>>2],v[d+4>>2]),v[V+116>>2]=X;if(y[Kb(f+228|0,f+116|0)>>2]<=(g&255)>>>0){break N}d=j+B(e,6)|0;t[d+2|0]=15;t[d+4|0]=w[l|0]}t[(j+B(e,6)|0)+3|0]=0;break J;case 23:d=w[m+1|0];O:{if(!d){break O}k=v[o>>2];if(yd(k,v[o+4>>2])>>>0<d>>>0){break O}g=g-1|0;t[l|0]=g;d=Nd(k,d-1|0);k=v[d>>2];p=yd(k,v[d+4>>2]);d=g&255;if(p>>>0<=d>>>0){break O}d=Nd(k,d);g=x[d+8>>1];P:{if(g){break P}g=0;k=x[q>>1];if(!Zh(k)){break P}g=k+1|0;u[q>>1]=g;u[d+8>>1]=g}t[m+1|0]=g}t[(j+B(e,6)|0)+3|0]=0;break J;case 24:d=w[m+1|0];Q:{if(!d){break Q}k=v[o>>2];if(yd(k,v[o+4>>2])>>>0<d>>>0){break Q}g=g-1|0;t[l|0]=g;v[23540]=0;S(681,f+8|0)|0;p=v[23540];v[23540]=0;if((p|0)==1){break A}v[f+228>>2]=9;d=Nd(k,d-1|0);V=f,X=yd(v[d>>2],v[d+4>>2]),v[V+116>>2]=X;if(y[Kb(f+228|0,f+116|0)>>2]>(g&255)>>>0){d=j+B(e,6)|0;t[d+2|0]=15;t[d+4|0]=w[l|0]}d=cc(v[z>>2],w[m+1|0]-1|0);g=x[d>>1];R:{if(g){break R}g=0;k=x[q>>1];if(!Zh(k)){break R}g=k+1|0;u[q>>1]=g;u[d>>1]=g}t[m+1|0]=g}t[(j+B(e,6)|0)+3|0]=0;break J;case 25:d=w[m+1|0];S:{if(!d){break S}k=v[o>>2];if(yd(k,v[o+4>>2])>>>0<d>>>0){break S}g=g-1|0;t[l|0]=g;d=Nd(k,d-1|0);k=v[d>>2];p=yd(k,v[d+4>>2]);d=g&255;if(p>>>0<=d>>>0){break S}d=Nd(k,d);g=x[d+10>>1];T:{if(g){break T}g=0;k=x[q>>1];if(!Zh(k)){break T}g=k+1|0;u[q>>1]=g;u[d+10>>1]=g}t[m+1|0]=g}t[(j+B(e,6)|0)+3|0]=0;break J;case 29:t[(j+B(e,6)|0)+3|0]=11;t[l|0]=d;if(k&15){t[l|0]=M|15;break J}if((g&255)>>>0<16){break J}t[l|0]=I|240;break J;case 32:if(k&240){t[h+3|0]=I;t[(j+B(e,6)|0)+3|0]=0;break J}t[(j+B(e,6)|0)+3|0]=19;t[l|0]=g&15|192;break J;case 33:t[(j+B(e,6)|0)+3|0]=19;t[f+228|0]=15;V=l,X=w[Yb(l,f+228|0)|0]|208,t[V|0]=X;break J;case 34:t[(j+B(e,6)|0)+3|0]=19;t[f+228|0]=15;V=l,X=w[Yb(l,f+228|0)|0]|144,t[V|0]=X;break J;case 73:t[(j+B(e,6)|0)+3|0]=10;break J;case 78:if((g&112|128)==224){t[(j+B(e,6)|0)+3|0]=19;break J}t[(j+B(e,6)|0)+3|0]=0;break J;case 79:d=j+B(e,6)|0;if((g&255)>>>0<=31){t[d+3|0]=16;F=0;break J}t[d+3|0]=17;break J;default:break K}}t[(j+B(e,6)|0)+3|0]=0}k=0;g=w[h+3|0];if(!(w[m+2|0]|!g)){U:{if(g>>>0>=16){t[m+2|0]=5;g=g>>>4|0;break U}t[m+2|0]=6}t[m+4|0]=g;k=1}V:{if(w[m+3|0]){break V}d=w[h+1|0];W:{if(d){t[m+3|0]=2;break W}d=w[h+2|0];if(d){t[m+3|0]=3;break W}d=w[h|0];if(d){t[m+3|0]=19;break W}d=w[h+7|0];if(d){t[m+3|0]=4;t[h+8|0]=d;break W}d=w[h+4|0];if(d){t[m+3|0]=5;t[h+5|0]=d;break W}d=w[h+3|0];if(!(!d|k)){t[m+3|0]=11;t[l|0]=d;if(d&15){d=d|-16;break W}if(!(d&240)){break V}d=d|15;break W}d=w[h+6|0];if(d){t[m+3|0]=8;break W}if(r){t[m+3|0]=20;r=0;d=97;break W}r=0;if(H){break V}d=i&255;if(!d){break V}t[m+3|0]=24;t[l|0]=i;if(i&15){d=i|-16}else{if(!(d&240)){H=1;break V}d=i|15}H=1}t[l|0]=d}e=e+1|0;continue}}}v[a+480228>>2]=256/x[a+480188>>1];k=1;oh(a,1);if(Ib(x[f+292>>1])){X:{while(1){b=v[n+8>>2];i=v[n>>2];v[23540]=0;b=W(156,i|0,b|0,2)|0;i=v[23540];v[23540]=0;if((i|0)==1){break A}if(!b){break X}v[23540]=0;b=S(271,n|0)|0;i=v[23540];v[23540]=0;if((i|0)==1){break A}if((b|0)==65535){break X}v[23540]=0;Q(188,n|0,2)|0;b=v[23540];v[23540]=0;if((b|0)==1){break A}v[23540]=0;b=S(279,n|0)|0;i=v[23540];v[23540]=0;if((i|0)!=1){v[23540]=0;Q(188,n|0,b|0)|0;b=v[23540];v[23540]=0;if((b|0)!=1){continue}}break}break A}v[23540]=0;Q(188,n|0,34)|0;b=v[23540];v[23540]=0;if((b|0)==1){break A}}Y:{if(!(c&2)){break Y}while(1){b=k&65535;if(b>>>0>C>>>0){break Y}Z:{e=(B(b,104)+a|0)+484380|0;if(!v[e>>2]){break Z}c=Zc(f+232|0,8,1,0,0);v[23540]=0;W(219,c|0,e|0,n|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break A}c=v[o>>2];if(yd(c,v[o+4>>2])>>>0<b>>>0){break Z}j=b-1|0;g=Nd(c,j);c=0;b=0;m=kb-112|0;kb=m;_:{h=v[e>>2];if(!_d(h,v[e+20>>2])){break _}q=v[g>>2];i=yd(q,v[g+4>>2]);if(i>>>0<2){break _}d=lo(m+8|0,e);v[d+20>>2]=0;v[d>>2]=0;$:{while(1){if((c|0)==(i|0)){break $}aa:{l=Nd(q,c);s=v[l>>2];if(s>>>0>=h>>>0){break aa}l=v[l+4>>2];if(l>>>0>h-s>>>0|268435456-l>>>0<b>>>0){break aa}b=b+l|0;v[d>>2]=b;c=c+1|0;continue}break}i=c}if(!Mg(d)){break _}l=d+68|0;b=0;c=0;while(1){if((c|0)==(i|0)){Dm(e);b=lo(e,d);v[b+4>>2]=0;v[b+8>>2]=v[b>>2];u[b+34>>1]=x[b+34>>1]|2;break _}r=v[d+20>>2]+b|0;q=v[e+20>>2];h=Nd(v[g>>2],c);sc(r,q+v[h>>2]|0,v[h+4>>2]);v[h>>2]=b;if(c-10>>>0>=4294967287){V=Eb(l,c-1|0),X=b,v[V>>2]=X}c=c+1|0;b=v[h+4>>2]+b|0;continue}}kb=m+112|0;b=x[cc(v[z>>2],j)>>1];if(b){Wz(e,(B(b,104)+a|0)+484380|0,0,v[e>>2],0)}b=Nd(v[o>>2],j);V=f,X=Fb(v[b>>2]),v[V+232>>2]=X;c=Fb(v[b+4>>2]);while(1){b=v[f+232>>2];if(!Pb(b,c)){break Z}i=x[b+8>>1];if(i){Wz(e,(B(i,104)+a|0)+484380|0,v[b>>2],v[b+4>>2],1)}i=x[b+10>>1];if(i){Wz(e,(B(i,104)+a|0)+484380|0,v[b>>2],v[b+4>>2],0)}oq(f+232|0);continue}}k=k+1|0;continue}}Pt(E);d=1;break b}v[23540]=0;Q(188,n|0,B(g,x[f+238>>1])|0)|0;e=v[23540];v[23540]=0;if((e|0)!=1){break B}break A}b=b+1|0;continue}break}e=P()|0;O()|0;Pt(E);break e}e=P()|0;O()|0;break e}e=P()|0;O()|0;break e}e=P()|0;O()|0;break e}e=P()|0;O()|0;break f}e=P()|0;O()|0;break e}e=P()|0;O()|0;break e}e=P()|0;O()|0;dc(f+8|0);break d}e=P()|0;O()|0;break e}Bb(h)}od(z);IQ(o)}T(e|0);L()}d=0}od(z);IQ(o)}kb=f+496|0;return d|0}function tea(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,z=0,A=0,C=0,D=0,E=0,F=0,G=0;d=kb-592|0;kb=d;zc(b);a:{if(!UA(b,d+512|0)){break a}if(!SP(d+512|0)){break a}if(!Qb(v[b>>2],v[b+8>>2],Ec(RP(d+512|0),nb))){break a}b:{if(!c){break b}Cd(a,4);ag(a);t[a+1074368|0]=4;k=Nb(d+496|0);c:{d:{e:{f:{l=d+550|0;g:{if(!(Sb(l,17831,20)|v[d+572>>2]!=276)){if(x[d+570>>1]<260){break g}e=XA(d+529|0,0,20)?1154:34;break e}if(!Sb(l,17810,20)){e=1;break e}g=d- -64|0;Dj(g,3,l);v[23540]=0;R(222,d+104|0,g|0);g=v[23540];v[23540]=0;h:{i:{if((g|0)!=1){v[23540]=0;U(11,d+208|0,5,d+104|0);g=v[23540];v[23540]=0;if((g|0)==1){break i}g=d+208|0;Jb(k,g);Ab(g);zb(d+104|0);if(Sb(l,17648,8)){break h}e=1048;break e}f=P()|0;O()|0;break c}f=P()|0;O()|0;zb(d+104|0);break c}if(!Sb(l,17548,12)){e=16;if(!Sb(d+562|0,17852,8)){break e}t[a+1074368|0]=5;break e}if(Sb(l,11646,20)){break f}}e=48;break e}if(!Sb(l,27152,15)){v[23540]=0;g=Q(265,a+1074312|0,54)|0;e=v[23540];v[23540]=0;C=1;if((e|0)==1){break d}v[23540]=0;Q(265,g|0,51)|0;g=v[23540];v[23540]=0;e=16;if((g|0)==1){break d}break e}j:{if(Sb(l,27168,14)){if(Sb(l,27183,14)){break j}}v[23540]=0;g=Q(265,a+1074312|0,57)|0;e=v[23540];v[23540]=0;if((e|0)==1){break d}v[23540]=0;Q(265,g|0,51)|0;g=v[23540];v[23540]=0;e=16;if((g|0)!=1){break e}break d}e=Sb(l,17636,11)?16:256}g=d+104|0;s=d+529|0;Dj(g,3,s);v[23540]=0;R(222,d+208|0,g|0);g=v[23540];v[23540]=0;k:{l:{m:{n:{o:{p:{q:{if((g|0)!=1){g=d+208|0;Bc(a+1298308|0,g);zb(g);v[a+480260>>2]=1;v[a+480264>>2]=31999;Ve(Wb(v[a+484360>>2],w[a+484376|0]),x[d+578>>1]);u[a+480188>>1]=x[d+580>>1];u[d+208>>1]=x[d+584>>1];u[d+104>>1]=255;F=a+480192|0,G=x[Wc(g,d+104|0)>>1],u[F>>1]=G;g=x[d+588>>1];if(g){v[a+480196>>2]=g}g=x[d+590>>1];if(g){g=B(g,1e4);g=g>>>0<1e7?g:1e7;v[a+480204>>2]=g>>>0>32e4?g:32e4}g=x[d+586>>1];v[a+480208>>2]=g<<4&16|g<<3&32768;f=w[a+484376|0];n=v[a+484360>>2];v[23540]=0;da(340,Wb(n,f)|0,b|0,x[d+576>>1],65535,65535);f=v[23540];v[23540]=0;if((f|0)==1){break d}f=g>>>12&1?(e|0)==34?146:e:e;if(!(x[d+576>>1]|f&1024)){g=w[a+484376|0];e=v[a+484360>>2];v[23540]=0;Y(731,Wb(e,g)|0);g=v[23540];v[23540]=0;if((g|0)==1){break d}}v[23540]=0;Q(155,b|0,v[d+572>>2]+60|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break d}if(x[d+570>>1]>=260){v[23540]=0;U(732,b|0,d+512|0,a|0);g=v[23540];v[23540]=0;if((g|0)==1){break d}}t[d+495|0]=0;z=c&2;D=d+122|0;o=d+241|0;n=Tb(d+480|0);E=a+480192|0;g=-1;p=1;while(1){e=p&65535;if(e>>>0>x[E>>1]){if(!(!(f&2)|q&255)){f=XA(s,0,20)?f|16:f}if(x[d+570>>1]>259){break o}if(c&3){v[23540]=0;U(732,b|0,d+512|0,a|0);c=v[23540];v[23540]=0;if((c|0)==1){break n}}if(!z){break o}o=a+480190|0;e=1;while(1){c=e&65535;if(c>>>0>x[o>>1]){break o}i=v[n>>2];v[23540]=0;W(219,Eb(i,c-1|0)|0,(B(c,104)+a|0)+484380|0,b|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){e=e+1|0;continue}break}f=P()|0;O()|0;break k}v[23540]=0;i=S(157,b|0)|0;h=v[23540];v[23540]=0;r:{s:{if((h|0)!=1){yg(b,4);v[23540]=0;U(733,b|0,d+208|0,(i?i:263)|0);i=v[23540];v[23540]=0;if((i|0)==1){break p}t:{if((f|0)==1){i=v[d+208>>2];if((i|0)!=263){f=16;if((i|0)!=245){break t}v[a+1074308>>2]=16777381;v[23540]=0;f=Q(1,d+192|0,13339)|0;i=v[23540];v[23540]=0;if((i|0)!=1){Jb(k,f);Ab(f);f=17;break t}f=P()|0;O()|0;break k}v[a+1074308>>2]=16777395;v[23540]=0;f=Q(1,d+176|0,13254)|0;i=v[23540];v[23540]=0;if((i|0)!=1){Jb(k,f);Ab(f);f=17;break t}f=P()|0;O()|0;break k}if(w[d+235|0]|w[d+236|0]<<8){break t}i=v[d+208>>2];if(!(!(f&2)|(w[d+237|0]|w[d+238|0]<<8|(w[d+239|0]<<16|w[d+240|0]<<24))|(i|0)!=263)){f=f|16;break t}if(!(!(f&256)|(i|0)==29)){f=f&-257;break t}if(!(f&160)){break t}f=(i|0)==33?f:0}v[23540]=0;i=W(251,a|0,e|0,0)|0;h=v[23540];v[23540]=0;if((h|0)==1){break p}if(!i){break r}i=((e<<2)+a|0)+900380|0;e=v[i>>2];v[23540]=0;R(734,d+208|0,e|0);e=v[23540];v[23540]=0;if((e|0)==1){break p}e=w[d+234|0];u:{if((g|0)==-1){g=e;break u}if(!(f&32)|(e|0)==(g|0)){break u}f=f&-161|128}e=w[d+235|0]|w[d+236|0]<<8;if(!e){break r}v[23540]=0;h=w[d+455|0];j=w[d+451|0]|w[d+452|0]<<8;m=w[d+450|0];r=w[d+449|0];U(735,d+160|0,a|0,e|0);e=v[23540];v[23540]=0;if((e|0)==1){break q}f=h|(j|(m|r))?f&-4:f;i=v[i>>2]+236|0;e=12;h=v[d+160>>2];j=Rc(h,v[d+164>>2]);v:{while(1){w:{if((e|0)==108){if(x[d+570>>1]>259){Lc(n)}e=0;v[23540]=0;i=Q(736,d+144|0,w[d+235|0]|w[d+236|0]<<8)|0;h=v[23540];v[23540]=0;if((h|0)!=1){break w}f=P()|0;O()|0;break v}m=cc(i,e);if(j>>>0>x[m>>1]){F=m,G=x[cc(h,x[cc(i,e)>>1])>>1],u[F>>1]=G}e=e+1|0;continue}break}x:{y:{z:{A:{while(1){h=w[d+235|0]|w[d+236|0]<<8;if(e>>>0>=h>>>0){e=0;if(x[d+570>>1]<=259){break s}B:{while(1){if(e>>>0>=h>>>0){break s}j=w[Eb(v[n>>2],e)+3|0];h=v[Eb(v[i>>2],e)>>2];v[23540]=0;U(190,d- -64|0,b|0,((j|0)==10?(h+1>>>1|0)+16|0:h)|0);h=v[23540];v[23540]=0;if((h|0)!=1){j=d- -64|0;h=kc(d+104|0,j);Bb(j);j=v[d+160>>2];if(!(!z|Rc(j,v[d+164>>2])>>>0<=e>>>0)){m=x[cc(j,e)>>1];j=Eb(v[n>>2],e);j=w[j|0]|w[j+1|0]<<8|(w[j+2|0]<<16|w[j+3|0]<<24);v[23540]=0;v[d+56>>2]=j;v[d>>2]=j;j=fa(737,(B(m,104)+a|0)+484380|0,d|0,h|0,d+495|0)|0;m=v[23540];v[23540]=0;if((m|0)==1){break B}A=j^1|A}Bb(h);e=e+1|0;h=w[d+235|0]|w[d+236|0]<<8;continue}break}f=P()|0;O()|0;break x}f=P()|0;O()|0;Bb(h);break x}v[23540]=0;R(738,b|0,d+104|0);h=v[23540];v[23540]=0;if((h|0)==1){break y}h=d- -64|0;j=w[d+118|0];C:{if(!(j&48|w[d+121|0]!=173)){Zc(h,8,1,0,10);break C}Zc(h,j&16?16:8,j&32?3:1,0,2)}v[23540]=0;R(739,n|0,h|0);h=v[23540];v[23540]=0;if((h|0)!=1){F=Eb(v[i>>2],e),G=v[d+104>>2],v[F>>2]=G;m=w[d+121|0];h=v[d+160>>2];if(Rc(h,v[d+164>>2])>>>0>e>>>0){j=x[cc(h,e)>>1];v[23540]=0;h=(B(j,104)+a|0)+484380|0;R(740,d+104|0,h|0);r=v[23540];v[23540]=0;if((r|0)==1){break A}t[h+38|0]=w[o+202|0];t[h+39|0]=w[o+203|0];t[h+40|0]=w[o+204|0];t[h+41|0]=w[o+205|0];h=d+88|0;Fl(h,3,D);v[23540]=0;R(222,d- -64|0,h|0);h=v[23540];v[23540]=0;if((h|0)==1){break z}h=d- -64|0;Dc(((j<<5)+a|0)+946304|0,h);zb(h);f=(w[d+118|0]&3)==3?(f&2)>>>1|0?f|4:f:f}q=m|q;e=e+1|0;continue}break}f=P()|0;O()|0;break x}f=P()|0;O()|0;break x}f=P()|0;O()|0;break x}f=P()|0;O()|0}wc(i)}od(d+160|0);break k}f=P()|0;O()|0;break k}wc(i);od(d+160|0)}p=p+1|0;continue}}f=P()|0;O()|0;break c}f=P()|0;O()|0;break k}f=P()|0;O()|0;break k}D:{if(!(A&1)){break D}v[23540]=0;c=Q(1,d+104|0,16663)|0;e=v[23540];v[23540]=0;E:{if((e|0)!=1){e=v[a+1298464>>2];v[23540]=0;U(376,e|0,2,c|0);e=v[23540];v[23540]=0;if((e|0)==1){break E}Ab(c);break D}f=P()|0;O()|0;break k}f=P()|0;O()|0;Ab(c);break k}v[23540]=0;c=Q(402,b|0,5561)|0;e=v[23540];v[23540]=0;if((e|0)==1){break n}if(c){v[23540]=0;c=S(157,b|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break n}v[23540]=0;X(331,a+1298332|0,b|0,c|0,0);c=v[23540];v[23540]=0;if((c|0)==1){break n}f=f|16}v[23540]=0;o=Q(402,b|0,14112)|0;c=v[23540];v[23540]=0;if((c|0)==1){break l}if(o){v[23540]=0;c=S(157,b|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break l}v[23540]=0;e=a+901404|0;U(741,b|0,e|0,c|0);c=v[23540];v[23540]=0;if((c|0)==1){break l}WA(e);f=f|16}v[23540]=0;c=Q(402,b|0,13874)|0;e=v[23540];v[23540]=0;if((e|0)==1){break l}if(!c){break m}v[23540]=0;c=S(157,b|0)|0;e=v[23540];v[23540]=0;if((e|0)!=1){u[d+208>>1]=c>>>5;F=d,G=Af(v[a+484344>>2],v[a+484348>>2]),u[F+64>>1]=G;c=x[Wc(d+208|0,d- -64|0)>>1];e=0;while(1){if((c|0)==(e|0)){f=f|16;break m}v[23540]=0;R(565,b|0,d+208|0);i=v[23540];v[23540]=0;F:{if((i|0)==1){break F}i=v[a+484344>>2];v[23540]=0;R(566,_b(i,e)|0,d+208|0);i=v[23540];v[23540]=0;if((i|0)==1){break F}e=e+1|0;continue}break}f=P()|0;O()|0;break k}f=P()|0;O()|0;break k}f=P()|0;O()|0;break k}v[23540]=0;c=Q(402,b|0,13879)|0;e=v[23540];v[23540]=0;if((e|0)==1){break l}G:{if(!c){break G}v[23540]=0;c=S(157,b|0)|0;e=v[23540];v[23540]=0;if((e|0)!=1){u[d+208>>1]=(c>>>0)/20;u[d+64>>1]=x[a+480188>>1];c=x[Wc(d+208|0,d- -64|0)>>1];e=0;while(1){if((c|0)==(e|0)){f=f|16;break G}v[23540]=0;U(413,b|0,((e<<5)+a|0)+480289|0,20);i=v[23540];v[23540]=0;if((i|0)!=1){e=e+1|0;continue}break}f=P()|0;O()|0;break k}f=P()|0;O()|0;break k}c=v[b+8>>2];e=v[b>>2];v[23540]=0;c=W(156,e|0,c|0,8)|0;e=v[23540];v[23540]=0;if((e|0)==1){break l}H:{I:{J:{K:{if(c){c=v[b+8>>2];v[23540]=0;Q(414,a|0,b|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break K}f=(c|0)==v[b+8>>2]?f:f|16}L:{if(!(f&16)){break L}if(f&4){v[a+1074308>>2]=17367040;v[23540]=0;c=Q(1,d+208|0,14719)|0;e=v[23540];v[23540]=0;if((e|0)!=1){Jb(k,c);Ab(c);break L}f=P()|0;O()|0;break k}if(!(f&2)){break L}v[a+1074308>>2]=18219008;v[23540]=0;c=Q(1,d+208|0,14876)|0;e=v[23540];v[23540]=0;if((e|0)==1){break J}Jb(k,c);Ab(c)}M:{N:{O:{P:{Q:{R:{S:{if(!Sb(l,17648,8)){v[23540]=0;c=W(383,d- -64|0,d+558|0,12)|0;e=v[23540];v[23540]=0;if((e|0)==1){break S}v[23540]=0;U(11,d+160|0,1,c|0);e=v[23540];v[23540]=0;if((e|0)==1){break R}v[23540]=0;e=S(742,d+160|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break Q}v[a+1074308>>2]=e;Ab(d+160|0);t[a+1074368|0]=y[a+1074308>>2]<19007257?4:5;zb(c);f=24}if(!(!v[a+1074308>>2]|f&8)){t[a+1074368|0]=0;mu(a+1074312|0)}c=f&32;T:{if(!c){break T}t[a+1074368|0]=5;if(!o){sq(a+901404|0)}if(x[d+570>>1]<260){break T}v[23540]=0;W(264,a+1074312|0,4,1)|0;e=v[23540];v[23540]=0;if((e|0)==1){break l}}if(!sh(v[k+4>>2],w[k+11|0])){break M}if(!(f&256)|q&255|g+1>>>0>1){break N}v[23540]=0;c=Q(1,d+160|0,8321)|0;g=v[23540];v[23540]=0;if((g|0)==1){break O}Jb(k,c);Ab(c);break M}f=P()|0;O()|0;break k}f=P()|0;O()|0;break P}f=P()|0;O()|0;Ab(d+160|0)}zb(c);break k}f=P()|0;O()|0;break k}if(c){v[23540]=0;c=Q(1,d+160|0,12058)|0;g=v[23540];v[23540]=0;if((g|0)!=1){Jb(k,c);Ab(c);break M}f=P()|0;O()|0;break k}v[23540]=0;c=Q(1,d+160|0,9769)|0;g=v[23540];v[23540]=0;if((g|0)==1){break I}Jb(k,c);Ab(c)}t[d+55|0]=0;U:{if(x[a+480192>>1]){v[23540]=0;c=Q(422,a|0,b|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break U}t[d+55|0]=c}v[23540]=0;X(423,a|0,b|0,1,d+55|0);b=v[23540];v[23540]=0;if((b|0)==1){break U}e=v[a+1074308>>2];V:{W:{X:{Y:{Z:{_:{$:{aa:{ba:{ca:{da:{ea:{fa:{ga:{ha:{if(w[d+55|0]){if(e>>>0>18284543){break ha}v[a+1074308>>2]=18284544;break ha}if(e>>>0<18284544){break ga}}v[23540]=0;b=Q(1,d+40|0,17648)|0;c=v[23540];v[23540]=0;if((c|0)==1){break fa}c=v[a+1074308>>2];v[23540]=0;R(743,d+24|0,c|0);c=v[23540];v[23540]=0;if((c|0)==1){break ea}v[23540]=0;U(2,d+88|0,b|0,d+24|0);c=v[23540];v[23540]=0;if((c|0)==1){break da}c=d+88|0;Jb(k,c);Ab(c);Ab(d+24|0);Ab(b);e=v[a+1074308>>2]}ia:{if(e-1>>>0>19005952){break ia}b=v[a+484344>>2];f=v[a+484348>>2];if(!xe(b,f,254)){b=w[a+484376|0];c=v[a+484360>>2];v[23540]=0;Y(744,Wb(c,b)|0);b=v[23540];v[23540]=0;if((b|0)==1){break U}f=v[a+484348>>2];b=v[a+484344>>2]}if(xe(b,f,255)){break ia}kA(Wb(v[a+484360>>2],w[a+484376|0]),255,65535)}v[23540]=0;R(745,d+24|0,4105);b=v[23540];v[23540]=0;if((b|0)==1){break ba}b=x[d+570>>1];v[d+20>>2]=b>>>8;v[23540]=0;v[d+4>>2]=b&255;R(433,d+8|0,d+4|0);b=v[23540];v[23540]=0;if((b|0)==1){break aa}v[23540]=0;X(419,d+88|0,d+24|0,d+20|0,d+8|0);b=v[23540];v[23540]=0;if((b|0)==1){break $}c=d+88|0;b=Jb(a+1298344|0,c);Ab(c);Ab(d+8|0);dc(d+24|0);Jb(a+1298368|0,k);v[a+1298404>>2]=C?8:v[a+1074308>>2]?8:5;if(!w[d+495|0]){break W}Jb(a+1298380|0,b);v[23540]=0;c=Q(1,d+88|0,15319)|0;g=v[23540];v[23540]=0;if((g|0)==1){break Z}Jb(b,c);Ab(c);v[23540]=0;b=Q(1,d+24|0,10120)|0;c=v[23540];v[23540]=0;if((c|0)==1){break Y}Jb(a+1298356|0,b);Ab(b);v[23540]=0;b=Q(1,d+8|0,10121)|0;c=v[23540];v[23540]=0;if((c|0)==1){break X}Jb(a+1298392|0,b);break V}f=P()|0;O()|0;break k}f=P()|0;O()|0;break ca}f=P()|0;O()|0;Ab(d+24|0)}Ab(b);break k}f=P()|0;O()|0;break k}f=P()|0;O()|0;break _}f=P()|0;O()|0;Ab(d+8|0)}dc(d+24|0);break k}f=P()|0;O()|0;break k}f=P()|0;O()|0;break k}f=P()|0;O()|0;break k}v[23540]=0;b=Q(1,d+88|0,10121)|0;c=v[23540];v[23540]=0;if((c|0)==1){break H}Jb(a+1298356|0,b)}Ab(b);wc(n);Ab(k);break b}f=P()|0;O()|0;break k}f=P()|0;O()|0;break k}f=P()|0;O()|0;break k}f=P()|0;O()|0;break k}f=P()|0;O()|0;break k}f=P()|0;O()|0}wc(n);break c}f=P()|0;O()|0}Ab(k);T(f|0);L()}e=1}kb=d+592|0;return e|0}function tfa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,y=0,z=0,A=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;e=kb-336|0;kb=e;zc(b);a:{b:{c:{if(!Ut(b,e+240|0)){break c}if(!eR(e+240|0)){break c}if(!Qb(v[b>>2],v[b+8>>2],Ec(dR(e+240|0),nb))){break c}if(!c){s=1;break c}Cd(a,2);v[a+480260>>2]=64;v[a+480264>>2]=32767;i=Nb(e+224|0);d=x[e+280>>1];j=(d|0)==20479?x[e+294>>1]:d-16464|0;d:{e:{f:{g:{h:{i:{switch(d>>>12|0){case 0:if((d|0)!=520){break d}v[23540]=0;d=Q(1,e+208|0,12298)|0;g=v[23540];v[23540]=0;if((g|0)!=1){Jb(i,d);break e}b=P()|0;O()|0;break a;case 1:j:{if(x[e+302>>1]|(d|0)!=4896){break j}if(!(x[e+278>>1]&65455|(w[e+292|0]|w[e+272|0]&15))){k:{if(t[e+291|0]<0){v[a+1074308>>2]=18219008;v[23540]=0;d=Q(1,e+208|0,14789)|0;f=v[23540];v[23540]=0;if((f|0)!=1){break k}b=P()|0;O()|0;break a}v[a+1074308>>2]=16777216;v[23540]=0;d=Q(1,e+208|0,13339)|0;f=v[23540];v[23540]=0;if((f|0)==1){break h}}Jb(i,d);Ab(d);v[23540]=0;f=1;W(264,a+1074312|0,81,1)|0;d=v[23540];v[23540]=0;g=1;if((d|0)!=1){break d}break b}if(w[e+293|0]|(w[e+292|0]|x[e+278>>1])){break j}v[23540]=0;d=Q(1,e+208|0,9505)|0;g=v[23540];v[23540]=0;if((g|0)!=1){Jb(i,d);break e}b=P()|0;O()|0;break a}v[23540]=0;d=Q(1,e+208|0,8523)|0;f=v[23540];v[23540]=0;k=1;if((f|0)!=1){Jb(i,d);Ab(d);break f}b=P()|0;O()|0;break a;case 2:v[23540]=0;d=Q(1,e+208|0,6776)|0;f=v[23540];v[23540]=0;g=1;if((f|0)!=1){Jb(i,d);Ab(d);break f}b=P()|0;O()|0;break a;case 3:l:{m:{n:{o:{if(d>>>0<=12820){v[23540]=0;f=Q(1,e+208|0,8586)|0;g=v[23540];v[23540]=0;if((g|0)!=1){Jb(i,f);Ab(f);break o}b=P()|0;O()|0;break a}v[23540]=0;R(431,e+208|0,4018);f=v[23540];v[23540]=0;if((f|0)==1){break n}v[23540]=0;v[e+192>>2]=x[e+280>>1]-12820;U(432,e+48|0,e+208|0,e+192|0);f=v[23540];v[23540]=0;if((f|0)==1){break m}f=e+48|0;Jb(i,f);Ab(f);dc(e+208|0)}f=x[e+280>>1];if(f>>>0<12807){break g}g=v[e+296>>2];if(g){break l}break g}b=P()|0;O()|0;break a}b=P()|0;O()|0;dc(e+208|0);break a}f=ZC(f,g);g=zo(e+48|0);v[g+44>>2]=f;v[23540]=0;R(434,a+1298408|0,g|0);f=v[23540];v[23540]=0;if((f|0)!=1){break g}b=P()|0;O()|0;break a;case 4:p:{q:{if((d|0)==16640){v[23540]=0;f=Q(1,e+208|0,8369)|0;g=v[23540];v[23540]=0;if((g|0)!=1){Jb(i,f);Ab(f);f=81;break q}b=P()|0;O()|0;break a}v[23540]=0;U(435,e+48|0,d|0,x[e+294>>1]);f=v[23540];v[23540]=0;r:{if((f|0)!=1){f=e+48|0;Jb(i,f);Ab(f);v[a+480260>>2]=1;if((j|0)<4201){break r}v[23540]=0;W(264,a+1074312|0,7,1)|0;g=v[23540];v[23540]=0;f=38;if((g|0)==1){break b}break q}b=P()|0;O()|0;break a}f=38;if((j|0)<2386){break p}}v[23540]=0;W(264,a+1074312|0,f|0,1)|0;f=v[23540];v[23540]=0;if((f|0)==1){break b}}h=(d|0)!=16640;g=1;f=0;break d;case 5:d=d&4095;v[a+1074308>>2]=d<<16|(d>>>0>296?x[e+294>>1]:0)&65535;v[23540]=0;d=Q(1,e+208|0,17648)|0;f=v[23540];v[23540]=0;s:{t:{u:{if((f|0)!=1){f=v[a+1074308>>2];v[23540]=0;R(140,e+192|0,f|0);f=v[23540];v[23540]=0;if((f|0)==1){break u}f=0;v[23540]=0;U(2,e+48|0,d|0,e+192|0);g=v[23540];v[23540]=0;if((g|0)==1){break t}g=e+48|0;Jb(i,g);Ab(g);Ab(e+192|0);break e}b=P()|0;O()|0;break a}b=P()|0;O()|0;break s}b=P()|0;O()|0;Ab(e+192|0)}Ab(d);break a;case 6:v[23540]=0;d=Q(1,e+208|0,8369)|0;h=v[23540];v[23540]=0;if((h|0)!=1){Jb(i,d);Ab(d);v[23540]=0;W(264,a+1074312|0,81,1)|0;d=v[23540];v[23540]=0;h=0;if((d|0)==1){break b}break d}b=P()|0;O()|0;break a;case 7:v[23540]=0;d=Q(1,e+208|0,8381)|0;g=v[23540];v[23540]=0;if((g|0)!=1){Jb(i,d);break e}b=P()|0;O()|0;break a;default:break i}}if((d|0)!=51712){break d}v[23540]=0;d=Q(1,e+208|0,9304)|0;g=v[23540];v[23540]=0;if((g|0)!=1){Jb(i,d);break e}b=P()|0;O()|0;break a}b=P()|0;O()|0;break a}v[23540]=0;f=W(264,a+1074312|0,7,1)|0;g=v[23540];v[23540]=0;if((g|0)==1){break b}v[23540]=0;f=W(264,f|0,23,1)|0;g=v[23540];v[23540]=0;if((g|0)==1){break b}v[23540]=0;f=W(264,f|0,38,1)|0;g=v[23540];v[23540]=0;if((g|0)==1){break b}v[23540]=0;W(264,f|0,107,1)|0;f=v[23540];v[23540]=0;if((f|0)==1){break b}g=1;v[a+480260>>2]=1;f=0;if(d>>>0>12820){break d}}v[23540]=0;Y(666,e+192|0);d=v[23540];v[23540]=0;v:{w:{x:{if((d|0)!=1){d=x[e+280>>1];v[e+160>>2]=d>>>8&15;v[23540]=0;v[e+136>>2]=d&255;R(433,e+176|0,e+136|0);d=v[23540];v[23540]=0;if((d|0)==1){break x}f=0;v[23540]=0;da(667,e+48|0,e+192|0,i|0,e+160|0,e+176|0);d=v[23540];v[23540]=0;if((d|0)==1){break w}d=e+48|0;Jb(i,d);Ab(d);Ab(e+176|0);dc(e+192|0);break d}b=P()|0;O()|0;break a}b=P()|0;O()|0;break v}b=P()|0;O()|0;Ab(e+176|0)}dc(e+192|0);break a}Ab(d);g=0}v[23540]=0;d=Q(1,e+192|0,15076)|0;l=v[23540];v[23540]=0;y:{z:{A:{B:{C:{D:{E:{F:{G:{H:{if((l|0)!=1){Jb(a+1298344|0,d);Ab(d);v[23540]=0;d=Q(1,e+176|0,10493)|0;l=v[23540];v[23540]=0;if((l|0)==1){break H}Jb(a+1298356|0,d);Ab(d);l=Jb(a+1298368|0,i);v[a+1298404>>2]=v[a+1074308>>2]?8:5;if(g){v[23540]=0;d=Q(265,a+1074312|0,77)|0;g=v[23540];v[23540]=0;if((g|0)==1){break b}v[23540]=0;d=Q(265,d|0,78)|0;g=v[23540];v[23540]=0;if((g|0)==1){break b}v[23540]=0;d=Q(265,d|0,79)|0;g=v[23540];v[23540]=0;if((g|0)==1){break b}v[23540]=0;d=Q(265,d|0,80)|0;g=v[23540];v[23540]=0;if((g|0)==1){break b}v[23540]=0;d=Q(265,d|0,82)|0;g=v[23540];v[23540]=0;if((g|0)==1){break b}v[23540]=0;d=Q(265,d|0,96)|0;g=v[23540];v[23540]=0;if((g|0)==1){break b}v[23540]=0;Q(265,d|0,113)|0;d=v[23540];v[23540]=0;if((d|0)==1){break b}}d=x[e+280>>1];g=d&61440;if(g>>>0>=4097){f=(g|0)!=12288|d>>>0>12819|f}v[23540]=0;d=a+901404|0;Y(668,d|0);g=v[23540];v[23540]=0;if((g|0)==1){break b}if(!f){sq(d)}d=e+160|0;Ii(d,1,e+240|0);v[23540]=0;R(222,e+48|0,d|0);d=v[23540];v[23540]=0;if((d|0)==1){break C}d=e+48|0;Bc(a+1298308|0,d);zb(d);d=x[e+278>>1];if(d&16){v[a+480208>>2]=v[a+480208>>2]|65536}if(d&1){v[a+480208>>2]=v[a+480208>>2]|131072}o=x[e+280>>1];if(!(d&64?0:(o|0)!=4864)){v[a+480208>>2]=v[a+480208>>2]|2}d=w[e+289|0];v[a+480196>>2]=d;if(!d){break G}if((d|0)!=255){break F}if(k){break G}d=w[e+290|0];f=d>>>0<33;g=B(d,1e4);k=0;d=32e4;break D}b=P()|0;O()|0;break a}b=P()|0;O()|0;break a}v[a+480196>>2]=6;d=w[e+290|0];f=d>>>0<33;g=B(d,1e4);break E}d=w[e+290|0];f=d>>>0<33;g=B(d,1e4)}d=32e4;if(!k){break D}d=125e4}v[a+480204>>2]=f?d:g;t[e+48|0]=w[e+288|0];t[e+160|0]=64;d=w[Yb(e+48|0,e+160|0)|0];v[a+480200>>2]=d<<2;if(!(d|o>>>0>4895)){v[a+480200>>2]=256}g=w[e+291|0];I:{if(!(x[e+282>>1]!=1|g>>>0>7)){v[e+48>>2]=(g<<4)+16;v[e+160>>2]=127;f=v[td(e+48|0,e+160|0)>>2];break I}f=32;if((g|16)==18){break I}d=g&127;f=48;if(!d){break I}v[e+48>>2]=d;v[e+160>>2]=16;f=v[Pe(e+48|0,e+160|0)>>2]}v[a+480228>>2]=f;d=0;o=v[a+1074308>>2]!=0|g<<24>>24<0;if(!o){H=a,I=Ec(Mka(f<<3|5,f>>>29|0,11,0),nb),v[H+480228>>2]=I}r=a+480188|0;u[r>>1]=4;v[a+480232>>2]=h?(j|0)<3299?64:36:36;f=Gc(e+152|0);while(1){if((d|0)==32){d=a+480188|0;if(!x[d>>1]){u[d>>1]=1}d=w[a+484376|0];g=v[a+484360>>2];v[23540]=0;da(340,Wb(g,d)|0,b|0,x[e+272>>1],255,254);d=v[23540];v[23540]=0;if((d|0)!=1){o=Tb(e+160|0);v[23540]=0;W(217,b|0,o|0,x[e+274>>1])|0;d=v[23540];v[23540]=0;if((d|0)!=1){r=Tb(e+136|0);v[23540]=0;W(217,b|0,r|0,x[e+276>>1])|0;d=v[23540];v[23540]=0;J:{if((d|0)!=1){if(w[e+293|0]!=252){break B}d=0;v[23540]=0;R(669,b|0,e+48|0);g=v[23540];v[23540]=0;if((g|0)==1){break J}while(1){if((d|0)==32){break B}g=w[(e+48|0)+d|0];K:{if(!(g&32)){break K}if(k){Sc(e+32|0,f,d);if(Cb(v[v[e+32>>2]>>2],v[e+36>>2])){break K}}u[((d<<5)+a|0)+480284>>1]=(((g&15)<<8|8)>>>0)/15}d=d+1|0;continue}}break A}break A}b=P()|0;O()|0;break z}b=P()|0;O()|0;break a}g=(d<<5)+a|0;j=g+480280|0;df(j);h=w[(d+e|0)+304|0];p=h&127;L:{if((h|0)!=255){h=h<<24>>24;u[r>>1]=d+1;if(o){u[g+480284>>1]=h&8?204:51}if((h|0)>=0){break L}}v[j>>2]=1024}if((p-16&255)>>>0<=13){u[g+480284>>1]=128;g=e+48|0;Sc(g,f,d);qo(g)}d=d+1|0;continue}}b=P()|0;O()|0;break a}u[e+48>>1]=x[e+274>>1];u[e+32>>1]=3999;f=x[Wc(e+48|0,e+32|0)>>1];u[a+480190>>1]=f;j=c&2;p=e+96|0;d=0;g=0;h=0;M:{N:{O:{while(1){if((f&65535)>>>0<=d>>>0){if(!k){break N}if(!(!(g&1)|h&65535)&x[e+280>>1]!=4864){break O}v[23540]=0;d=h&65535;f=W(264,a+1074312|0,79,d>>>0>1|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break A}v[23540]=0;d=d>>>0<2;f=W(264,f|0,107,d|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break A}v[23540]=0;W(264,f|0,38,d|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break A}v[23540]=0;d=h&65535;Q(133,l|0,(d>>>0>1?17209:17216)|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break A}if(d>>>0<2){break N}v[a+480228>>2]=48;break N}f=cc(v[o>>2],d);f=w[f|0]|w[f+1|0]<<8;v[23540]=0;f=Q(155,b|0,f<<4)|0;n=v[23540];v[23540]=0;if((n|0)==1){break M}P:{Q:{if(!f){break Q}v[23540]=0;f=Q(670,b|0,e+48|0)|0;n=v[23540];v[23540]=0;if((n|0)==1){break M}if(!f){break Q}v[23540]=0;f=d+1|0;n=(B(f,104)+a|0)+484380|0;U(671,e+48|0,n|0,k|0);m=v[23540];v[23540]=0;if((m|0)==1){break M}m=e+16|0;Ii(m,1,p);v[23540]=0;R(222,e+32|0,m|0);m=v[23540];v[23540]=0;if((m|0)==1){break P}m=((f<<5)+a|0)+946304|0;f=e+32|0;Dc(m,f);zb(f);if(w[e+48|0]>1){break Q}R:{if(!j|!v[e+64>>2]){break R}f=bR(e+48|0);v[23540]=0;f=Q(155,b|0,f|0)|0;m=v[23540];v[23540]=0;if((m|0)==1){break A}if(!f){break R}f=e+32|0;aR(f,w[e+78|0],w[e+79|0],x[e+282>>1]==1);v[23540]=0;W(219,f|0,n|0,b|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break A}g=1}h=x[e+88>>1]|h}d=d+1|0;f=x[a+480190>>1];continue}break}break A}v[23540]=0;d=Q(1,e+48|0,9769)|0;f=v[23540];v[23540]=0;if((f|0)==1){break A}Jb(l,d);Ab(d)}s=1;if(!(c&1)){break y}c=x[e+280>>1];u[e+32>>1]=x[e+276>>1];u[e+16>>1]=255;y=x[Wc(e+32|0,e+16|0)>>1];v[23540]=0;k=a+484344|0;R(225,k|0,y|0);d=v[23540];v[23540]=0;if((d|0)==1){break M}z=c>>>0<4896;c=e+32|0;m=c|5;D=c|3;A=c|4;E=c|2;F=c|1;G=a+480188|0;h=0;p=0;n=0;while(1){if((h|0)==(y|0)){if(!z){break y}a=x[a+480188>>1];if((a|0)>(n+p|0)|(a|0)<=(p-n|0)){break y}d=Af(v[k>>2],v[k+4>>2])-1&65535;b=0;S:{if(Af(v[k>>2],v[k+4>>2])>>>0<=d>>>0){break S}while(1){c=b&65535;if(c>>>0>d>>>0){break S}a=bg(v[k>>2],c);f=v[a>>2];if(Pb(f,v[a+4>>2])){a=Fb(f);f=Fb(v[bg(v[k>>2],c)+4>>2]);c=kb-16|0;kb=c;v[c+8>>2]=a;while(1){if(Pb(a,f)){if(w[a+3|0]==31){t[a+3|0]=20;t[a+5|0]=w[a+5|0]|128}a=v[Ck(c+8|0)>>2];continue}break}kb=c+16|0}b=b+1|0;continue}}break y}v[23540]=0;c=W(226,k|0,h&65535,64)|0;d=v[23540];v[23540]=0;if((d|0)==1){break M}T:{if(!c){break T}c=cc(v[r>>2],h);c=w[c|0]|w[c+1|0]<<8;if(!c){break T}v[23540]=0;c=Q(155,b|0,c<<4)|0;d=v[23540];v[23540]=0;if((d|0)==1){break M}if(!c){break T}v[23540]=0;Q(188,b|0,2)|0;c=v[23540];v[23540]=0;if((c|0)==1){break M}d=0;c=_b(v[k>>2],h);c=Cf(v[c>>2],v[v[c+48>>2]+12>>2],0);while(1){if(d>>>0>63){break T}f=d;v[23540]=0;l=S(206,b|0)|0;d=v[23540];v[23540]=0;U:{if((d|0)!=1){if(l){break U}d=64;if(f>>>0>62){continue}c=_b(v[k>>2],h);d=f+1|0;c=Cf(v[c>>2],v[v[c+48>>2]+12>>2],d);continue}break A}g=l&31;d=B(g,6)+c|0;q=ug(e+32|0);j=g>>>0<x[G>>1];C=j?d:q;if(l&32){v[23540]=0;R(260,e+16|0,b|0);g=v[23540];v[23540]=0;V:{W:{X:{if((g|0)!=1){q=Oc(e+16|0);g=w[e+16|0];if(g>>>0>239){break X}g=$Q((B(g>>>4|0,12)+(g&15)|0)+13|0);break W}break A}Y:{switch(g-254|0){case 0:break W;case 1:break Y;default:break V}}g=0}t[C|0]=g}t[(j?d+1|0:F)|0]=w[q|0]}Z:{if(!(l&64)){break Z}v[23540]=0;q=S(206,b|0)|0;g=v[23540];v[23540]=0;_:{if((g|0)!=1){g=j?d+2|0:E;q=q<<24>>24;t[e+16|0]=q;if((q|0)>-64){break _}t[g|0]=2;t[(j?d+4|0:A)|0]=w[e+16|0]^128;break Z}break A}t[g|0]=1;t[e+15|0]=64;H=j?d+4|0:A,I=w[Yb(e+16|0,e+15|0)|0],t[H|0]=I}$:{if(!(l&128)){break $}v[23540]=0;R(260,e+16|0,b|0);g=v[23540];v[23540]=0;aa:{ba:{if((g|0)!=1){TA(C,w[e+16|0],w[Oc(e+16|0)|0],0);l=j?d+3|0:D;g=w[l|0];if((g|0)==10){break aa}if((g|0)==31){break ba}if((g|0)!=20){break $}d=j?d+5|0:m;g=w[d|0];if((g&240)!=160|x[e+280>>1]>4895){break $}t[d|0]=g&15^136;break $}break A}d=w[(j?d+5|0:m)|0];if(d>>>0>15){z=0;break $}if(d>>>0<=7){n=n+1|0;break $}p=((d|0)!=8)+p|0;break $}if(w[(j?d+5|0:m)|0]|x[e+280>>1]>4865){break $}t[l|0]=37}d=f;continue}}h=h+1|0;continue}}}b=P()|0;O()|0;od(r)}od(o);break a}od(r);od(o);Ab(i)}kb=e+336|0;return s|0}b=P()|0;O()|0}Ab(i);T(b|0);L()}function Pd(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;l=kb-16|0;kb=l;a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{if(a>>>0<=244){f=v[116048];h=a>>>0<11?16:a+11&-8;c=h>>>3|0;b=f>>>c|0;if(b&3){c=c+((b^-1)&1)|0;a=c<<3;b=a+464232|0;d=v[a+464240>>2];a=v[d+8>>2];l:{if((b|0)==(a|0)){m=464192,n=Nka(-2,c)&f,v[m>>2]=n;break l}v[a+12>>2]=b;v[b+8>>2]=a}a=d+8|0;b=c<<3;v[d+4>>2]=b|3;b=b+d|0;v[b+4>>2]=v[b+4>>2]|1;break a}k=v[116050];if(k>>>0>=h>>>0){break k}if(b){a=2<<c;a=(0-a|a)&b<<c;b=(0-a&a)-1|0;a=b>>>12&16;c=a;b=b>>>a|0;a=b>>>5&8;c=c|a;b=b>>>a|0;a=b>>>2&4;c=c|a;b=b>>>a|0;a=b>>>1&2;c=c|a;b=b>>>a|0;a=b>>>1&1;d=(c|a)+(b>>>a|0)|0;a=d<<3;b=a+464232|0;g=v[a+464240>>2];a=v[g+8>>2];m:{if((b|0)==(a|0)){f=Nka(-2,d)&f;v[116048]=f;break m}v[a+12>>2]=b;v[b+8>>2]=a}v[g+4>>2]=h|3;c=g+h|0;a=d<<3;d=a-h|0;v[c+4>>2]=d|1;v[a+g>>2]=d;if(k){b=(k&-8)+464232|0;e=v[116053];a=1<<(k>>>3);n:{if(!(a&f)){v[116048]=a|f;a=b;break n}a=v[b+8>>2]}v[b+8>>2]=e;v[a+12>>2]=e;v[e+12>>2]=b;v[e+8>>2]=a}a=g+8|0;v[116053]=c;v[116050]=d;break a}j=v[116049];if(!j){break k}b=(0-j&j)-1|0;a=b>>>12&16;c=a;b=b>>>a|0;a=b>>>5&8;c=c|a;b=b>>>a|0;a=b>>>2&4;c=c|a;b=b>>>a|0;a=b>>>1&2;c=c|a;b=b>>>a|0;a=b>>>1&1;b=v[((c|a)+(b>>>a|0)<<2)+464496>>2];e=(v[b+4>>2]&-8)-h|0;c=b;while(1){o:{a=v[c+16>>2];if(!a){a=v[c+20>>2];if(!a){break o}}c=(v[a+4>>2]&-8)-h|0;d=c>>>0<e>>>0;e=d?c:e;b=d?a:b;c=a;continue}break}i=v[b+24>>2];d=v[b+12>>2];if((d|0)!=(b|0)){a=v[b+8>>2];v[a+12>>2]=d;v[d+8>>2]=a;break b}c=b+20|0;a=v[c>>2];if(!a){a=v[b+16>>2];if(!a){break j}c=b+16|0}while(1){g=c;d=a;c=a+20|0;a=v[c>>2];if(a){continue}c=d+16|0;a=v[d+16>>2];if(a){continue}break}v[g>>2]=0;break b}h=-1;if(a>>>0>4294967231){break k}a=a+11|0;h=a&-8;j=v[116049];if(!j){break k}e=0-h|0;f=0;p:{if(h>>>0<256){break p}f=31;if(h>>>0>16777215){break p}a=a>>>8|0;g=a+1048320>>>16&8;a=a<<g;c=a+520192>>>16&4;a=a<<c;b=a+245760>>>16&2;a=(a<<b>>>15|0)-(b|(c|g))|0;f=(a<<1|h>>>a+21&1)+28|0}c=v[(f<<2)+464496>>2];q:{r:{s:{if(!c){a=0;break s}a=0;b=h<<((f|0)==31?0:25-(f>>>1|0)|0);while(1){t:{g=(v[c+4>>2]&-8)-h|0;if(g>>>0>=e>>>0){break t}d=c;e=g;if(e){break t}e=0;a=c;break r}g=v[c+20>>2];c=v[((b>>>29&4)+c|0)+16>>2];a=g?(g|0)==(c|0)?a:g:a;b=b<<1;if(c){continue}break}}if(!(a|d)){d=0;a=2<<f;a=(0-a|a)&j;if(!a){break k}b=(a&0-a)-1|0;a=b>>>12&16;c=a;b=b>>>a|0;a=b>>>5&8;c=c|a;b=b>>>a|0;a=b>>>2&4;c=c|a;b=b>>>a|0;a=b>>>1&2;c=c|a;b=b>>>a|0;a=b>>>1&1;a=v[((c|a)+(b>>>a|0)<<2)+464496>>2]}if(!a){break q}}while(1){b=(v[a+4>>2]&-8)-h|0;c=b>>>0<e>>>0;e=c?b:e;d=c?a:d;b=v[a+16>>2];if(b){a=b}else{a=v[a+20>>2]}if(a){continue}break}}if(!d|v[116050]-h>>>0<=e>>>0){break k}f=v[d+24>>2];b=v[d+12>>2];if((d|0)!=(b|0)){a=v[d+8>>2];v[a+12>>2]=b;v[b+8>>2]=a;break c}c=d+20|0;a=v[c>>2];if(!a){a=v[d+16>>2];if(!a){break i}c=d+16|0}while(1){g=c;b=a;c=a+20|0;a=v[c>>2];if(a){continue}c=b+16|0;a=v[b+16>>2];if(a){continue}break}v[g>>2]=0;break c}c=v[116050];if(c>>>0>=h>>>0){d=v[116053];b=c-h|0;u:{if(b>>>0>=16){v[116050]=b;a=d+h|0;v[116053]=a;v[a+4>>2]=b|1;v[c+d>>2]=b;v[d+4>>2]=h|3;break u}v[116053]=0;v[116050]=0;v[d+4>>2]=c|3;a=c+d|0;v[a+4>>2]=v[a+4>>2]|1}a=d+8|0;break a}i=v[116051];if(i>>>0>h>>>0){b=i-h|0;v[116051]=b;c=v[116054];a=c+h|0;v[116054]=a;v[a+4>>2]=b|1;v[c+4>>2]=h|3;a=c+8|0;break a}a=0;j=h+47|0;b=j;if(v[116166]){c=v[116168]}else{v[116169]=-1;v[116170]=-1;v[116167]=4096;v[116168]=4096;v[116166]=l+12&-16^1431655768;v[116171]=0;v[116159]=0;c=4096}g=b+c|0;e=0-c|0;c=g&e;if(c>>>0<=h>>>0){break a}d=v[116158];if(d){b=v[116156];f=b+c|0;if(d>>>0<f>>>0|b>>>0>=f>>>0){break a}}if(w[464636]&4){break f}v:{w:{d=v[116054];if(d){a=464640;while(1){b=v[a>>2];if(b>>>0<=d>>>0&d>>>0<b+v[a+4>>2]>>>0){break w}a=v[a+8>>2];if(a){continue}break}}b=tp(0);if((b|0)==-1){break g}f=c;d=v[116167];a=d-1|0;if(a&b){f=(c-b|0)+(a+b&0-d)|0}if(f>>>0<=h>>>0|f>>>0>2147483646){break g}d=v[116158];if(d){a=v[116156];e=a+f|0;if(d>>>0<e>>>0|a>>>0>=e>>>0){break g}}a=tp(f);if((b|0)!=(a|0)){break v}break e}f=e&g-i;if(f>>>0>2147483646){break g}b=tp(f);if((b|0)==(v[a>>2]+v[a+4>>2]|0)){break h}a=b}if(!((a|0)==-1|h+48>>>0<=f>>>0)){b=v[116168];b=b+(j-f|0)&0-b;if(b>>>0>2147483646){b=a;break e}if((tp(b)|0)!=-1){f=b+f|0;b=a;break e}tp(0-f|0);break g}b=a;if((a|0)!=-1){break e}break g}d=0;break b}b=0;break c}if((b|0)!=-1){break e}}v[116159]=v[116159]|4}if(c>>>0>2147483646){break d}b=v[23461];c=c+3&-4;a=b+c|0;x:{y:{if(!c|a>>>0>b>>>0){if(_w()>>>0>=a>>>0){break y}if(xa(a|0)|0){break y}a=v[23461]}else{a=b}v[116016]=48;b=-1;break x}v[23461]=a}if(_w()>>>0<a>>>0){if(!(xa(a|0)|0)){break d}}v[23461]=a;if((b|0)==-1|(a|0)==-1|a>>>0<=b>>>0){break d}f=a-b|0;if(f>>>0<=h+40>>>0){break d}}a=v[116156]+f|0;v[116156]=a;if(a>>>0>y[116157]){v[116157]=a}z:{A:{B:{g=v[116054];if(g){a=464640;while(1){d=v[a>>2];c=v[a+4>>2];if((d+c|0)==(b|0)){break B}a=v[a+8>>2];if(a){continue}break}break A}a=v[116052];if(!(a>>>0<=b>>>0?a:0)){v[116052]=b}a=0;v[116161]=f;v[116160]=b;v[116056]=-1;v[116057]=v[116166];v[116163]=0;while(1){d=a<<3;c=d+464232|0;v[d+464240>>2]=c;v[d+464244>>2]=c;a=a+1|0;if((a|0)!=32){continue}break}d=f-40|0;a=b+8&7?-8-b&7:0;c=d-a|0;v[116051]=c;a=a+b|0;v[116054]=a;v[a+4>>2]=c|1;v[(b+d|0)+4>>2]=40;v[116055]=v[116170];break z}if(w[a+12|0]&8|d>>>0>g>>>0|b>>>0<=g>>>0){break A}v[a+4>>2]=c+f;a=g+8&7?-8-g&7:0;c=a+g|0;v[116054]=c;b=v[116051]+f|0;a=b-a|0;v[116051]=a;v[c+4>>2]=a|1;v[(b+g|0)+4>>2]=40;v[116055]=v[116170];break z}if(y[116052]>b>>>0){v[116052]=b}d=b+f|0;c=464640;C:{while(1){if((d|0)!=v[c>>2]){a=464640;c=v[c+8>>2];if(c){continue}break C}break}a=464640;if(w[c+12|0]&8){break C}v[c>>2]=b;v[c+4>>2]=v[c+4>>2]+f;j=(b+8&7?-8-b&7:0)+b|0;v[j+4>>2]=h|3;d=d+(d+8&7?-8-d&7:0)|0;i=h+j|0;a=d-i|0;D:{if((d|0)==(g|0)){v[116054]=i;a=v[116051]+a|0;v[116051]=a;v[i+4>>2]=a|1;break D}if(v[116053]==(d|0)){v[116053]=i;a=v[116050]+a|0;v[116050]=a;v[i+4>>2]=a|1;v[a+i>>2]=a;break D}e=v[d+4>>2];if((e&3)==1){f=e&-8;E:{if(e>>>0<=255){b=e>>>3|0;e=v[d+8>>2];c=v[d+12>>2];if((c|0)==(e|0)){m=464192,n=v[116048]&Nka(-2,b),v[m>>2]=n;break E}v[e+12>>2]=c;v[c+8>>2]=e;break E}h=v[d+24>>2];b=v[d+12>>2];F:{if((d|0)!=(b|0)){c=v[d+8>>2];v[c+12>>2]=b;v[b+8>>2]=c;break F}G:{e=d+20|0;c=v[e>>2];if(c){break G}e=d+16|0;c=v[e>>2];if(c){break G}b=0;break F}while(1){g=e;b=c;e=b+20|0;c=v[e>>2];if(c){continue}e=b+16|0;c=v[b+16>>2];if(c){continue}break}v[g>>2]=0}if(!h){break E}e=v[d+28>>2];c=(e<<2)+464496|0;H:{if(v[c>>2]==(d|0)){v[c>>2]=b;if(b){break H}m=464196,n=v[116049]&Nka(-2,e),v[m>>2]=n;break E}v[h+(v[h+16>>2]==(d|0)?16:20)>>2]=b;if(!b){break E}}v[b+24>>2]=h;c=v[d+16>>2];if(c){v[b+16>>2]=c;v[c+24>>2]=b}c=v[d+20>>2];if(!c){break E}v[b+20>>2]=c;v[c+24>>2]=b}d=d+f|0;e=v[d+4>>2];a=a+f|0}v[d+4>>2]=e&-2;v[i+4>>2]=a|1;v[a+i>>2]=a;if(a>>>0<=255){b=(a&-8)+464232|0;c=v[116048];a=1<<(a>>>3);I:{if(!(c&a)){v[116048]=a|c;a=b;break I}a=v[b+8>>2]}v[b+8>>2]=i;v[a+12>>2]=i;v[i+12>>2]=b;v[i+8>>2]=a;break D}e=31;if(a>>>0<=16777215){b=a>>>8|0;e=b+1048320>>>16&8;b=b<<e;d=b+520192>>>16&4;b=b<<d;c=b+245760>>>16&2;b=(b<<c>>>15|0)-(c|(d|e))|0;e=(b<<1|a>>>b+21&1)+28|0}v[i+28>>2]=e;v[i+16>>2]=0;v[i+20>>2]=0;d=(e<<2)+464496|0;J:{c=v[116049];b=1<<e;K:{if(!(c&b)){v[116049]=b|c;v[d>>2]=i;v[i+24>>2]=d;break K}e=a<<((e|0)==31?0:25-(e>>>1|0)|0);b=v[d>>2];while(1){c=b;if((v[b+4>>2]&-8)==(a|0)){break J}b=e>>>29|0;e=e<<1;d=c+(b&4)|0;b=v[d+16>>2];if(b){continue}break}v[d+16>>2]=i;v[i+24>>2]=c}v[i+12>>2]=i;v[i+8>>2]=i;break D}a=v[c+8>>2];v[a+12>>2]=i;v[c+8>>2]=i;v[i+24>>2]=0;v[i+12>>2]=c;v[i+8>>2]=a}a=j+8|0;break a}while(1){L:{c=v[a>>2];if(c>>>0<=g>>>0){e=c+v[a+4>>2]|0;if(e>>>0>g>>>0){break L}}a=v[a+8>>2];continue}break}d=f-40|0;a=b+8&7?-8-b&7:0;c=d-a|0;v[116051]=c;a=a+b|0;v[116054]=a;v[a+4>>2]=c|1;v[(b+d|0)+4>>2]=40;v[116055]=v[116170];a=(e+(e-39&7?39-e&7:0)|0)-47|0;c=a>>>0<g+16>>>0?g:a;v[c+4>>2]=27;a=v[116163];v[c+16>>2]=v[116162];v[c+20>>2]=a;a=v[116161];v[c+8>>2]=v[116160];v[c+12>>2]=a;v[116162]=c+8;v[116161]=f;v[116160]=b;v[116163]=0;a=c+24|0;while(1){v[a+4>>2]=7;b=a+8|0;a=a+4|0;if(b>>>0<e>>>0){continue}break}if((c|0)==(g|0)){break z}v[c+4>>2]=v[c+4>>2]&-2;e=c-g|0;v[g+4>>2]=e|1;v[c>>2]=e;if(e>>>0<=255){b=(e&-8)+464232|0;c=v[116048];a=1<<(e>>>3);M:{if(!(c&a)){v[116048]=a|c;a=b;break M}a=v[b+8>>2]}v[b+8>>2]=g;v[a+12>>2]=g;v[g+12>>2]=b;v[g+8>>2]=a;break z}a=31;if(e>>>0<=16777215){a=e>>>8|0;d=a+1048320>>>16&8;a=a<<d;c=a+520192>>>16&4;a=a<<c;b=a+245760>>>16&2;a=(a<<b>>>15|0)-(b|(c|d))|0;a=(a<<1|e>>>a+21&1)+28|0}v[g+28>>2]=a;v[g+16>>2]=0;v[g+20>>2]=0;b=(a<<2)+464496|0;N:{d=v[116049];c=1<<a;O:{if(!(d&c)){v[116049]=c|d;v[b>>2]=g;break O}a=e<<((a|0)==31?0:25-(a>>>1|0)|0);d=v[b>>2];while(1){b=d;if((e|0)==(v[b+4>>2]&-8)){break N}c=a>>>29|0;a=a<<1;c=(c&4)+b|0;d=v[c+16>>2];if(d){continue}break}v[c+16>>2]=g}v[g+24>>2]=b;v[g+12>>2]=g;v[g+8>>2]=g;break z}a=v[b+8>>2];v[a+12>>2]=g;v[b+8>>2]=g;v[g+24>>2]=0;v[g+12>>2]=b;v[g+8>>2]=a}a=v[116051];if(a>>>0<=h>>>0){break d}b=a-h|0;v[116051]=b;c=v[116054];a=c+h|0;v[116054]=a;v[a+4>>2]=b|1;v[c+4>>2]=h|3;a=c+8|0;break a}a=0;v[116016]=48;break a}P:{if(!f){break P}c=v[d+28>>2];a=(c<<2)+464496|0;Q:{if(v[a>>2]==(d|0)){v[a>>2]=b;if(b){break Q}j=Nka(-2,c)&j;v[116049]=j;break P}v[f+(v[f+16>>2]==(d|0)?16:20)>>2]=b;if(!b){break P}}v[b+24>>2]=f;a=v[d+16>>2];if(a){v[b+16>>2]=a;v[a+24>>2]=b}a=v[d+20>>2];if(!a){break P}v[b+20>>2]=a;v[a+24>>2]=b}R:{if(e>>>0<=15){a=e+h|0;v[d+4>>2]=a|3;a=a+d|0;v[a+4>>2]=v[a+4>>2]|1;break R}v[d+4>>2]=h|3;f=d+h|0;v[f+4>>2]=e|1;v[e+f>>2]=e;if(e>>>0<=255){b=(e&-8)+464232|0;c=v[116048];a=1<<(e>>>3);S:{if(!(c&a)){v[116048]=a|c;a=b;break S}a=v[b+8>>2]}v[b+8>>2]=f;v[a+12>>2]=f;v[f+12>>2]=b;v[f+8>>2]=a;break R}a=31;if(e>>>0<=16777215){a=e>>>8|0;g=a+1048320>>>16&8;a=a<<g;c=a+520192>>>16&4;a=a<<c;b=a+245760>>>16&2;a=(a<<b>>>15|0)-(b|(c|g))|0;a=(a<<1|e>>>a+21&1)+28|0}v[f+28>>2]=a;v[f+16>>2]=0;v[f+20>>2]=0;b=(a<<2)+464496|0;T:{c=1<<a;U:{if(!(c&j)){v[116049]=c|j;v[b>>2]=f;break U}a=e<<((a|0)==31?0:25-(a>>>1|0)|0);h=v[b>>2];while(1){b=h;if((v[b+4>>2]&-8)==(e|0)){break T}c=a>>>29|0;a=a<<1;c=(c&4)+b|0;h=v[c+16>>2];if(h){continue}break}v[c+16>>2]=f}v[f+24>>2]=b;v[f+12>>2]=f;v[f+8>>2]=f;break R}a=v[b+8>>2];v[a+12>>2]=f;v[b+8>>2]=f;v[f+24>>2]=0;v[f+12>>2]=b;v[f+8>>2]=a}a=d+8|0;break a}V:{if(!i){break V}c=v[b+28>>2];a=(c<<2)+464496|0;W:{if(v[a>>2]==(b|0)){v[a>>2]=d;if(d){break W}m=464196,n=Nka(-2,c)&j,v[m>>2]=n;break V}v[i+(v[i+16>>2]==(b|0)?16:20)>>2]=d;if(!d){break V}}v[d+24>>2]=i;a=v[b+16>>2];if(a){v[d+16>>2]=a;v[a+24>>2]=d}a=v[b+20>>2];if(!a){break V}v[d+20>>2]=a;v[a+24>>2]=d}X:{if(e>>>0<=15){a=e+h|0;v[b+4>>2]=a|3;a=a+b|0;v[a+4>>2]=v[a+4>>2]|1;break X}v[b+4>>2]=h|3;d=b+h|0;v[d+4>>2]=e|1;v[d+e>>2]=e;if(k){c=(k&-8)+464232|0;g=v[116053];a=1<<(k>>>3);Y:{if(!(a&f)){v[116048]=a|f;a=c;break Y}a=v[c+8>>2]}v[c+8>>2]=g;v[a+12>>2]=g;v[g+12>>2]=c;v[g+8>>2]=a}v[116053]=d;v[116050]=e}a=b+8|0}kb=l+16|0;return a|0}function U6(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;g=kb-32|0;kb=g;a:{b:{c:{d:{e:{if(ue(b,21688)){Nb(a);break e}if(ue(b,9912)){b=kb-128|0;kb=b;f=Nb(a);v[23540]=0;Y(134,b+96|0);a=v[23540];v[23540]=0;f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{if((a|0)!=1){v[23540]=0;v[b+64>>2]=0;R(1048,b+80|0,b- -64|0);a=v[23540];v[23540]=0;if((a|0)==1){break p}v[23540]=0;a=Q(800,f|0,b+80|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break o}zb(b+80|0);v[23540]=0;a=Q(935,a|0,16805)|0;c=v[23540];v[23540]=0;q:{if((c|0)==1){break q}v[23540]=0;v[b+64>>2]=7;R(1048,b+80|0,b- -64|0);c=v[23540];v[23540]=0;if((c|0)==1){break n}v[23540]=0;a=Q(800,a|0,b+80|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break m}zb(b+80|0);v[23540]=0;a=Q(935,a|0,16805)|0;c=v[23540];v[23540]=0;if((c|0)==1){break q}v[23540]=0;v[b+64>>2]=0;R(1048,b+80|0,b- -64|0);c=v[23540];v[23540]=0;if((c|0)==1){break l}v[23540]=0;a=Q(800,a|0,b+80|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break k}c=b+80|0;zb(c);v[23540]=0;c=Q(55,c|0,14904)|0;d=v[23540];v[23540]=0;if((d|0)==1){break j}d=Hb(c);zb(c);if(!d){break i}v[23540]=0;Q(935,a|0,14904)|0;c=v[23540];v[23540]=0;if((c|0)!=1){break i}}a=P()|0;O()|0;break h}a=P()|0;O()|0;break g}a=P()|0;O()|0;break h}a=P()|0;O()|0;zb(b+80|0);break h}a=P()|0;O()|0;break h}a=P()|0;O()|0;zb(b+80|0);break h}a=P()|0;O()|0;break h}a=P()|0;O()|0;zb(b+80|0);break h}a=P()|0;O()|0;break h}c=Tb(b- -64|0);r:{s:{t:{u:{v:{w:{x:{y:{z:{A:{B:{C:{D:{d=v[b+108>>2];if(d){v[23540]=0;v[b+16>>2]=d;R(1048,b+32|0,b+16|0);d=v[23540];v[23540]=0;if((d|0)==1){break D}v[23540]=0;U(961,b+48|0,8993,b+32|0);d=v[23540];v[23540]=0;if((d|0)==1){break C}v[23540]=0;R(183,c|0,b+48|0);d=v[23540];v[23540]=0;if((d|0)==1){break B}zb(b+48|0);zb(b+32|0)}if(!Qd(w[b+112|0])){break x}v[23540]=0;d=Q(55,b+48|0,12759)|0;e=v[23540];v[23540]=0;if((e|0)==1){break z}v[23540]=0;R(183,c|0,d|0);e=v[23540];v[23540]=0;if((e|0)==1){break y}zb(d);break w}a=P()|0;O()|0;break r}a=P()|0;O()|0;break A}a=P()|0;O()|0;zb(b+48|0)}zb(b+32|0);break r}a=P()|0;O()|0;break r}a=P()|0;O()|0;zb(d);break r}if(!Qd(w[b+113|0])){break w}v[23540]=0;d=Q(55,b+48|0,12530)|0;e=v[23540];v[23540]=0;if((e|0)==1){break v}v[23540]=0;R(183,c|0,d|0);e=v[23540];v[23540]=0;if((e|0)==1){break u}zb(d)}if(Qd(w[b+114|0])){break t}break s}a=P()|0;O()|0;break r}a=P()|0;O()|0;zb(d);break r}v[23540]=0;d=Q(55,b+32|0,11123)|0;e=v[23540];v[23540]=0;E:{if((e|0)!=1){v[23540]=0;R(183,c|0,d|0);e=v[23540];v[23540]=0;if((e|0)==1){break E}zb(d);break s}a=P()|0;O()|0;break r}a=P()|0;O()|0;zb(d);break r}if(pc(v[c>>2],v[c+4>>2])){break f}v[23540]=0;a=Q(935,a|0,16835)|0;d=v[23540];v[23540]=0;if((d|0)!=1){v[23540]=0;d=Q(55,b|0,16805)|0;e=v[23540];v[23540]=0;F:{G:{H:{if((e|0)!=1){v[23540]=0;U(1049,b+16|0,c|0,d|0);e=v[23540];v[23540]=0;if((e|0)==1){break H}v[23540]=0;Q(800,a|0,b+16|0)|0;a=v[23540];v[23540]=0;if((a|0)==1){break G}zb(b+16|0);zb(d);break f}a=P()|0;O()|0;break r}a=P()|0;O()|0;break F}a=P()|0;O()|0;zb(b+16|0)}zb(d);break r}a=P()|0;O()|0}Xe(c)}Df(b+96|0)}zb(f);break a}Xe(c);Df(b+96|0);kb=b+128|0;break e}if(ue(b,8161)){v[g>>2]=0;Dp(a,g);break e}if(ue(b,8139)){v[g>>2]=7;Dp(a,g);break e}if(ue(b,10843)){v[g>>2]=0;Dp(a,g);break e}if(ue(b,10615)){Kc(a,14904);break e}if(ue(b,11392)){b=Kc(g,14904);c=Hb(b);v[23540]=0;Q(55,a|0,(c?15840:15510)|0)|0;a=v[23540];v[23540]=0;if((a|0)==1){break d}zb(b);break e}if(ue(b,7372)){b=kb-48|0;kb=b;cE(b+16|0);v[23540]=0;Y(151,b|0);c=v[23540];v[23540]=0;I:{J:{K:{L:{if((c|0)!=1){v[23540]=0;U(152,b+32|0,b+16|0,b|0);c=v[23540];v[23540]=0;if((c|0)==1){break L}v[23540]=0;R(1009,a|0,b+32|0);a=v[23540];v[23540]=0;if((a|0)==1){break K}Ab(b+32|0);Ab(b);Ab(b+16|0);kb=b+48|0;break e}a=P()|0;O()|0;break I}a=P()|0;O()|0;break J}a=P()|0;O()|0;Ab(b+32|0)}Ab(b)}Ab(b+16|0);break a}if(ue(b,9928)){b=kb-16|0;kb=b;e=kb-16|0;kb=e;v[e+8>>2]=101;c=kb-112|0;kb=c;f=Tb(c+96|0);M:{N:{O:{P:{Q:{R:{S:{T:{U:{V:{W:{X:{Y:{Z:{_:{$:{d=v[e+8>>2];if(d&1){v[23540]=0;R(140,c- -64|0,19988497);d=v[23540];v[23540]=0;if((d|0)==1){break $}v[23540]=0;R(124,f|0,c- -64|0);d=v[23540];v[23540]=0;if((d|0)==1){break _}Ab(c- -64|0);d=v[e+8>>2]}if(!(d&4)){break Y}v[23540]=0;d=ga(141)|0;h=v[23540];v[23540]=0;if((h|0)==1){break X}if(!d){break Z}break Y}d=P()|0;O()|0;break N}d=P()|0;O()|0;Ab(c- -64|0);break N}v[23540]=0;Y(142,c- -64|0);d=v[23540];v[23540]=0;aa:{if((d|0)!=1){v[23540]=0;R(124,f|0,c- -64|0);d=v[23540];v[23540]=0;if((d|0)==1){break aa}Ab(c- -64|0);break Y}d=P()|0;O()|0;break N}d=P()|0;O()|0;Ab(c- -64|0);break N}ba:{d=v[e+8>>2];if(!(d&32)){break ba}v[23540]=0;Y(134,c- -64|0);d=v[23540];v[23540]=0;ca:{da:{ea:{fa:{ga:{ha:{ia:{ja:{ka:{la:{ma:{na:{oa:{pa:{qa:{ra:{sa:{ta:{ua:{if((d|0)!=1){v[23540]=0;R(143,c+48|0,c- -64|0);d=v[23540];v[23540]=0;if((d|0)==1){break da}d=sh(v[c+52>>2],w[c+59|0]);Ab(c+48|0);if(!d){v[23540]=0;Y(144,c+32|0);d=v[23540];v[23540]=0;if((d|0)==1){break ua}v[23540]=0;R(143,c+16|0,c- -64|0);d=v[23540];v[23540]=0;if((d|0)==1){break ta}v[23540]=0;U(145,c+48|0,c+32|0,c+16|0);d=v[23540];v[23540]=0;if((d|0)==1){break sa}v[23540]=0;R(124,f|0,c+48|0);d=v[23540];v[23540]=0;if((d|0)==1){break ra}Ab(c+48|0);Ab(c+16|0);dc(c+32|0)}d=_o(c- -64|0);if(!sh(v[d+4>>2],w[d+11|0])){v[23540]=0;Y(146,c+32|0);h=v[23540];v[23540]=0;if((h|0)==1){break oa}v[23540]=0;U(147,c+48|0,c+32|0,d|0);d=v[23540];v[23540]=0;if((d|0)==1){break na}v[23540]=0;R(124,f|0,c+48|0);d=v[23540];v[23540]=0;if((d|0)==1){break ma}Ab(c+48|0);dc(c+32|0)}v[23540]=0;R(148,c+48|0,c- -64|0);d=v[23540];v[23540]=0;if((d|0)==1){break ka}d=sh(v[c+52>>2],w[c+59|0]);Ab(c+48|0);if(!d){v[23540]=0;Y(144,c+32|0);d=v[23540];v[23540]=0;if((d|0)==1){break ja}v[23540]=0;R(148,c+16|0,c- -64|0);d=v[23540];v[23540]=0;if((d|0)==1){break ia}v[23540]=0;U(145,c+48|0,c+32|0,c+16|0);d=v[23540];v[23540]=0;if((d|0)==1){break ha}v[23540]=0;R(124,f|0,c+48|0);d=v[23540];v[23540]=0;if((d|0)==1){break ga}Ab(c+48|0);Ab(c+16|0);dc(c+32|0)}Df(c- -64|0);d=v[e+8>>2];break ba}d=P()|0;O()|0;break N}d=P()|0;O()|0;break ca}d=P()|0;O()|0;break pa}d=P()|0;O()|0;break qa}d=P()|0;O()|0;Ab(c+48|0)}Ab(c+16|0)}dc(c+32|0);break ca}d=P()|0;O()|0;break ca}d=P()|0;O()|0;break la}d=P()|0;O()|0;Ab(c+48|0)}dc(c+32|0);break ca}d=P()|0;O()|0;break ca}d=P()|0;O()|0;break ca}d=P()|0;O()|0;break ea}d=P()|0;O()|0;break fa}d=P()|0;O()|0;Ab(c+48|0)}Ab(c+16|0)}dc(c+32|0);break ca}d=P()|0;O()|0}Df(c- -64|0);break N}va:{if(!(d&64)){break va}v[23540]=0;d=ga(141)|0;h=v[23540];v[23540]=0;if((h|0)==1){break X}if(d){break va}d=c- -64|0;Nb(d);v[23540]=0;R(124,f|0,d|0);d=v[23540];v[23540]=0;if((d|0)==1){break O}Ab(c- -64|0)}if(w[e+8|0]&128){v[23540]=0;Y(149,c- -64|0);d=v[23540];v[23540]=0;if((d|0)==1){break W}v[23540]=0;R(124,f|0,c- -64|0);d=v[23540];v[23540]=0;if((d|0)==1){break V}Ab(c- -64|0)}v[23540]=0;h=Q(1,c- -64|0,21688)|0;d=v[23540];v[23540]=0;if((d|0)==1){break U}v[23540]=0;U(150,c|0,f|0,h|0);d=v[23540];v[23540]=0;if((d|0)==1){break T}v[23540]=0;Y(151,c+48|0);d=v[23540];v[23540]=0;if((d|0)==1){break S}v[23540]=0;U(152,b|0,c|0,c+48|0);d=v[23540];v[23540]=0;if((d|0)==1){break R}Ab(c+48|0);Ab(c);Ab(h);Ql(f);kb=c+112|0;break M}d=P()|0;O()|0;break N}d=P()|0;O()|0;break N}d=P()|0;O()|0;Ab(c- -64|0);break N}d=P()|0;O()|0;break N}d=P()|0;O()|0;break P}d=P()|0;O()|0;break Q}d=P()|0;O()|0;Ab(c+48|0)}Ab(c)}Ab(h);break N}d=P()|0;O()|0;Ab(c- -64|0)}Ql(f);T(d|0);L()}kb=e+16|0;v[23540]=0;R(1009,a|0,b|0);a=v[23540];v[23540]=0;if((a|0)!=1){Ab(b);kb=b+16|0;break e}break b}if(ue(b,10544)){b=kb-48|0;kb=b;yr(b);v[23540]=0;R(143,b+32|0,b|0);c=v[23540];v[23540]=0;wa:{xa:{if((c|0)!=1){v[23540]=0;R(1009,a|0,b+32|0);a=v[23540];v[23540]=0;if((a|0)==1){break xa}Ab(b+32|0);Df(b);kb=b+48|0;break e}a=P()|0;O()|0;break wa}a=P()|0;O()|0;Ab(b+32|0)}Df(b);break a}if(ue(b,11355)){b=kb-32|0;kb=b;yr(b);v[23540]=0;R(1009,a|0,_o(b)|0);a=v[23540];v[23540]=0;if((a|0)!=1){Df(b);kb=b+32|0;break e}a=P()|0;O()|0;Df(b);break a}if(ue(b,9941)){b=kb-48|0;kb=b;yr(b+16|0);c=v[b+28>>2];ya:{if(c){v[23540]=0;v[b+12>>2]=c;R(1048,a|0,b+12|0);a=v[23540];v[23540]=0;if((a|0)!=1){break ya}a=P()|0;O()|0;Df(b+16|0);break a}Nb(a)}Df(b+16|0);kb=b+48|0;break e}if(ue(b,12749)){yr(g);b=w[g+16|0];v[23540]=0;Q(55,a|0,(Qd(b)?15510:15840)|0)|0;a=v[23540];v[23540]=0;if((a|0)!=1){Df(g);break e}a=P()|0;O()|0;Df(g);break a}if(ue(b,9957)){yr(g);b=w[g+17|0];v[23540]=0;Q(55,a|0,(Qd(b)?15510:15840)|0)|0;a=v[23540];v[23540]=0;if((a|0)!=1){Df(g);break e}a=P()|0;O()|0;Df(g);break a}if(ue(b,12202)){yr(g);b=w[g+18|0];v[23540]=0;Q(55,a|0,(Qd(b)?15510:15840)|0)|0;a=v[23540];v[23540]=0;if((a|0)!=1){Df(g);break e}a=P()|0;O()|0;Df(g);break a}if(ue(b,12504)){b=kb-16|0;kb=b;c=kb-32|0;kb=c;d=Nb(b);v[23540]=0;Y(134,c|0);f=v[23540];v[23540]=0;za:{Aa:{Ba:{if((f|0)!=1){v[23540]=0;R(135,d|0,_o(c)|0);f=v[23540];v[23540]=0;if((f|0)==1){break Ba}Df(c);kb=c+32|0;break za}a=P()|0;O()|0;break Aa}a=P()|0;O()|0;Df(c)}Ab(d);break a}v[23540]=0;R(1009,a|0,b|0);a=v[23540];v[23540]=0;if((a|0)!=1){Ab(b);kb=b+16|0;break e}break b}if(ue(b,8282)){b=kb-16|0;kb=b;c=kb-48|0;kb=c;d=Nb(b);v[23540]=0;R(137,c+16|0,4138);f=v[23540];v[23540]=0;Ca:{Da:{Ea:{Fa:{Ga:{if((f|0)!=1){v[c+12>>2]=15;v[c+8>>2]=0;v[23540]=0;v[c+4>>2]=0;da(138,c+32|0,c+16|0,c+12|0,c+8|0,c+4|0);f=v[23540];v[23540]=0;if((f|0)==1){break Ga}v[23540]=0;Q(98,d|0,c+32|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break Fa}Ab(c+32|0);dc(c+16|0);kb=c+48|0;break Ca}a=P()|0;O()|0;break Da}a=P()|0;O()|0;break Ea}a=P()|0;O()|0;Ab(c+32|0)}dc(c+16|0)}Ab(d);T(a|0);L()}v[23540]=0;R(1009,a|0,b|0);a=v[23540];v[23540]=0;if((a|0)!=1){Ab(b);kb=b+16|0;break e}break b}if(ue(b,6825)){b=kb-16|0;kb=b;kn(b,0,19634);v[23540]=0;R(1009,a|0,b|0);a=v[23540];v[23540]=0;if((a|0)!=1){Ab(b);kb=b+16|0;break e}break b}if(ue(b,6458)){b=kb-48|0;kb=b;c=yc(b+16|0,17695);v[23540]=0;R(1050,b|0,2);d=v[23540];v[23540]=0;Ha:{Ia:{Ja:{Ka:{if((d|0)!=1){v[23540]=0;U(2,b+32|0,c|0,b|0);d=v[23540];v[23540]=0;if((d|0)==1){break Ka}v[23540]=0;R(1009,a|0,b+32|0);a=v[23540];v[23540]=0;if((a|0)==1){break Ja}Ab(b+32|0);Ab(b);Ab(c);kb=b+48|0;break e}a=P()|0;O()|0;break Ha}a=P()|0;O()|0;break Ia}a=P()|0;O()|0;Ab(b+32|0)}Ab(b)}Ab(c);break a}if(ue(b,11378)){b=kb-16|0;kb=b;kn(b,0,18034);v[23540]=0;R(1009,a|0,b|0);a=v[23540];v[23540]=0;if((a|0)!=1){Ab(b);kb=b+16|0;break e}break b}if(ue(b,10551)){b=kb-16|0;kb=b;vr(b,0);v[23540]=0;R(1009,a|0,b|0);a=v[23540];v[23540]=0;if((a|0)!=1){Ab(b);kb=b+16|0;break e}break b}if(ue(b,10526)){b=kb-16|0;kb=b;vr(b,2);v[23540]=0;R(1009,a|0,b|0);a=v[23540];v[23540]=0;if((a|0)!=1){Ab(b);kb=b+16|0;break e}break b}if(ue(b,10511)){b=kb-16|0;kb=b;vr(b,3);v[23540]=0;R(1009,a|0,b|0);a=v[23540];v[23540]=0;if((a|0)!=1){Ab(b);kb=b+16|0;break e}break b}Nb(a)}kb=g+32|0;break c}a=P()|0;O()|0;zb(b);break a}return}a=P()|0;O()|0;Ab(b)}T(a|0);L()}function Yaa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,z=0,A=0,C=0,D=0,E=0,F=0,G=0;g=kb-48|0;kb=g;b=v[a+1074308>>2];if(!(b>>>0>18285125|(b|0)==18284544)){_f(a+1074312|0,0)}i=a+1074308|0;b=g+32|0;h=a+1074312|0;Db(b,h,0);d=Cb(v[v[g+32>>2]>>2],v[g+36>>2]);e=a+480180|0;c=v[e>>2];Db(b,h,0);o=d&(c&16777248)!=0;C=Cb(v[v[g+32>>2]>>2],v[g+36>>2]);D=v[e>>2];a:{d=v[a+1074308>>2];if(d>>>0>18874367){break a}d=!o;f=a+480192|0;c=1;while(1){b:{b=c&65535;if(b>>>0<=x[f>>1]){b=v[((b<<2)+a|0)+900380>>2];if(!b){break b}v[g+32>>2]=B(w[b+20|0],100)>>>6;v[g+16>>2]=100;F=b,G=v[Kb(g+32|0,g+16|0)>>2],t[F+20|0]=G;if(!(d|y[i>>2]<18350080)){break b}j=t[b+26|0];t[b+26|0]=((j>>31|1)+j|0)/2;if(!(d|y[i>>2]<18285314)){break b}YA(Ih(b,2),v[e>>2]);j=v[a+1074308>>2];c:{if(j>>>0<18284544){break c}if(j>>>0>18285135){break b}if(!w[b+34|0]){break c}if(!vj(w[b+31|0])){break c}Ob(h,2,1);if(y[i>>2]>18285135){break b}}if(!(w[b+24|0]|(w[b+23|0]|(w[b+19|0]|w[b+20|0])))){break b}Ob(h,1,1)}d:{if(!(v[a+480180>>2]&16777248)|y[i>>2]>18285313&o){break d}c=x[a+480190>>1]+1&65535;b=1;while(1){if((b|0)==(c|0)){break d}d=B(b,104)+a|0;e=d+484419|0;if(!(w[e|0]|!(w[d+484421|0]|w[d+484420|0]))){t[e|0]=255}b=b+1|0;continue}}d=a+901404|0;f=Jz(d);while(1){if((d|0)!=(f|0)){b=d;j=ho(b);while(1){if((b|0)!=(j|0)){c=w[b|0];e:{f:{if((c-97&255)>>>0<=5){k=c-32|0;break f}if(!(c-88>>>0<2|c-120>>>0<2)){k=99;if((c|0)==75|(c|0)==107){break f}break e}k=122}t[b|0]=k}b=b+1|0;continue}break}d=d+32|0;continue}break}d=v[a+1074308>>2];break a}c=c+1|0;continue}}g:{h:{i:{if((d|0)==18874368|d>>>0>18874895){break i}if(!(v[a+480180>>2]&16777252)){break h}f=x[a+480192>>1]+1&65535;c=0;b=1;while(1){if((b|0)==(f|0)){if(!c){break i}Ob(h,3,1);d=v[i>>2]}else{e=v[((b<<2)+a|0)+900380>>2];if(!(!e|!w[e+31|0])){t[e+33|0]=13;c=1}b=b+1|0;continue}break}}if((d|0)==19005440|d>>>0>19006225){break g}}if(!(v[a+480180>>2]&16777248)){break g}Db(g+32|0,h,0);if(!Cb(v[v[g+32>>2]>>2],v[g+36>>2])){Db(g+16|0,h,1);if(!Cb(v[v[g+16>>2]>>2],v[g+20>>2])){break g}}c=x[a+480192>>1]+1&65535;b=1;while(1){if((b|0)==(c|0)){break g}d=v[((b<<2)+a|0)+900380>>2];if(!(!d|!w[d+19|0]|!(t[d+80|0]&1))){t[d+19|0]=0}b=b+1|0;continue}}j:{k:{l:{m:{n:{if(y[i>>2]>19007232){break n}b=a+906300|0;d=gk(b);while(1){if((b|0)==(d|0)){break n}c=g+16|0;e=b+80|0;HM(c,e);v[23540]=0;X(235,g+32|0,0,8,c|0);c=v[23540];v[23540]=0;if((c|0)==1){break m}zb(g+16|0);c=g+32|0;Ju(e,c);b=b+160|0;zb(c);continue}}o:{p:{q:{if(v[a+480180>>2]!=4){break q}c=v[i>>2];if(c>>>0<19007257){break o}if(c>>>0>19071235){break p}if(w[a+1074368|0]!=4){break q}xy(a,5)}c=v[i>>2]}if(c>>>0>19202054){break l}d=19202048;if((c|0)==19202048){break k}}f=x[a+480192>>1]+1&65535;d=1;while(1){if((d|0)==(f|0)){break l}e=v[((d<<2)+a|0)+900380>>2];r:{if(!e|!w[e+20|0]|!w[e+31|0]){break r}b=e+236|0;j=Bq(b);while(1){if((b|0)!=(j|0)){l=x[b>>1];b=b+2|0;if(!l){continue}break r}break}t[e+20|0]=0}d=d+1|0;continue}}a=P()|0;O()|0;zb(g+16|0);T(a|0);L()}d=c;if(c>>>0>19267583){break j}}e=!o;f=x[a+480192>>1]+1&65535;b=1;while(1){if((b|0)==(f|0)){break j}c=v[((b<<2)+a|0)+900380>>2];s:{if(!c){break s}d=t[c+26|0];t[c+26|0]=((d>>31|1)+d|0)/2;d=v[i>>2];if(!(e|d>>>0<18350080)){break s}t[c+19|0]=w[c+19|0]+3>>>2}b=b+1|0;continue}}t:{if(d>>>0>19398673){break t}c=x[a+480192>>1];b=1;while(1){e=b&65535;if(e>>>0>c>>>0){break t}e=v[((e<<2)+a|0)+900380>>2];if(!e|w[e+65|0]==255){b=b+1|0;continue}else{Ob(h,94,1);d=v[i>>2]}break}}u:{if(d>>>0>19399427){break u}c=x[a+480192>>1];b=1;while(1){e=b&65535;if(e>>>0>c>>>0){break u}e=v[((e<<2)+a|0)+900380>>2];if(!e|w[e+36|0]>1){b=b+1|0;continue}else{Ob(h,101,1);d=v[i>>2]}break}}v:{if(d>>>0>19923027){break v}c=x[a+480190>>1];b=1;while(1){d=b&65535;if(d>>>0>c>>>0){break v}d=B(d,104)+a|0;if(!_d(v[d+484380>>2],v[d+484400>>2])|!(w[d+484414|0]&20)){b=b+1|0;continue}else{Ob(h,116,1)}break}}b=kb-16|0;kb=b;u[g+12>>1]=0;v[g+8>>2]=a;Db(b+8|0,a+1074312|0,0);F=g,G=Cb(v[v[b+8>>2]>>2],v[b+12>>2]),t[F+14|0]=G;kb=b+16|0;q=v[g+8>>2];r=v[g+12>>2];b=a+484344|0;k=b;z=Af(v[b>>2],v[b+4>>2])-1&65535;d=kb-32|0;kb=d;w:{if(Af(v[b>>2],v[b+4>>2])>>>0<=z>>>0){break w}while(1){b=A&65535;if(b>>>0>z>>>0){break w}c=bg(v[k>>2],b);e=v[c>>2];if(Pb(e,v[c+4>>2])){c=Fb(e);E=Fb(v[bg(v[k>>2],b)+4>>2]);v[d+24>>2]=q;v[d+28>>2]=r;v[d+8>>2]=q;v[d+12>>2]=r;j=d+8|0;p=kb-16|0;kb=p;v[p+8>>2]=c;while(1){if(Pb(c,E)){l=kb-16|0;kb=l;s=x[j+4>>1];b=s+1|0;u[j+4>>1]=b;f=v[j>>2];u[j+4>>1]=x[f+480188>>1]>(b&65535)>>>0?b:0;x:{if(fh(w[c|0])){break x}e=v[f+1074308>>2];y:{n=v[f+480180>>2];z:{A:{if((n|0)==2){if(e>>>0>18415615){break A}if(w[c+3|0]!=23){break z}wf(c+5|0,64);break z}if(n&16777248){B:{C:{if(e>>>0>=18285314){if(w[j+6|0]){break C}f=0;b=0;if(e>>>0>18874367){break B}}D:{switch(w[c+3|0]-20|0){case 3:wf(c+5|0,128);break C;case 0:break D;default:break C}}b=w[c+5|0];if((b|0)!=208){if((b|0)!=192){break C}t[c|0]=254;t[c+3|0]=0;break C}t[c+3|0]=0}E:{F:{G:{if(e>>>0>=18350080){if(w[j+6|0]){break G}f=0;b=0;if(e>>>0>18874367){break B}}b=w[c+3|0];if(b>>>0>29){break F}f=1;if(!(1<<b&536873152)){break F}break E}f=0;b=0;if(e>>>0>18874367){break B}b=w[c+3|0]}f=0}b=(b|0)==24|(b|0)==22}H:{if(!(b?1:f)){break H}f=w[c+5|0];b=f&15;if(!b|(b|0)==15){break H}f=f&240;if(!f|(f|0)==240){break H}t[c+5|0]=w[c+3|0]==24?f:b}I:{if((e|0)==19005440|e>>>0>19005699){break I}b=x[v[j>>2]+480192>>1];if(w[j+6|0]|(!b|b>>>0>=w[c+1|0])){break I}t[c+4|0]=0;t[c+2|0]=1}if(w[c+3|0]!=18|w[c+5|0]!=17){break A}if(e>>>0>19468801){break y}Db(l+8|0,v[j>>2]+1074312|0,22);if(!Cb(v[v[l+8>>2]>>2],v[l+12>>2])|v[v[j>>2]+480208>>2]&4){break A}t[c+5|0]=0;break A}if((n|0)!=4){break A}b=!w[j+6|0];J:{if((b|e>>>0<18285314)&e>>>0<18874368){break J}if(e>>>0>19137025){break y}if(w[c+3|0]!=23|w[c+5|0]<65){break J}t[c+3|0]=0}K:{L:{M:{if(!(b&e>>>0<18874368?0:e>>>0>=18415616)){f=w[c+3|0];b=w[c+2|0];if((f|0)!=10|(b|0)!=11){break M}f=0;t[c+3|0]=0;break K}if(e>>>0>18874639){break L}f=w[c+3|0];b=w[c+2|0]}if((b|0)!=11|(f|0)!=4){break K}b=w[c+4|0];if(!(b|w[j+6|0])){f=4;break K}f=4;m=w[c+5|0];if(!m){break K}t[c+2|0]=0;F=c,G=zu(m+(b<<4)|0),t[F+5|0]=G;break K}if(e>>>0>19007240){break y}f=w[c+3|0]}if(w[c+5|0]|(f|0)!=16){break A}t[c+3|0]=0}if(e>>>0>18874367){break y}}f=w[c+3|0];m=w[c+5|0]&240;N:{O:{if((f|0)!=28|(m|0)!=96){b=0}else{if(!w[j+6|0]|(n|0)!=4){break O}b=e>>>0<18350080}if(!(b|(f|0)==20&(m|0)==96)){break N}}b=B(s,-6)+c|0;while(1){if(b>>>0<c>>>0){if(!((w[b+3|0]|8)!=28|(w[b+5|0]&240)!=96)){t[b+3|0]=0}b=b+6|0;continue}break}f=w[c+3|0]}if((f|0)!=20|(m|0)!=224){break y}b=B(s,-6)+c|0;while(1){if(b>>>0>=c>>>0){break y}if(!(w[b+3|0]!=20|(w[b+5|0]&240)!=224)){t[b+3|0]=0}b=b+6|0;continue}}b=w[c+2|0];if(!((b|0)!=8|e>>>0>19333174|(e|0)==19333120)){e=w[c+4|0];b=w[c+3|0];if(!(!e|(b|0)!=7)){t[c+3|0]=11;break x}P:{Q:{switch(b-5|0){default:if((b|0)!=26){break x}break;case 1:break x;case 2:break P;case 0:break Q}}f=w[c+5|0];if(!(f&15)){t[c+2|0]=0;t[c+3|0]=5;t[c+5|0]=f|e&15;break x}R:{switch(b-5|0){case 1:break x;case 0:case 2:break P;default:break R}}if((b|0)!=26){break x}}t[c+2|0]=0;break x}if(!(w[c+3|0]|((n|0)==16777216|(b|0)!=15))){t[c+2|0]=0;t[c+3|0]=10;t[c+5|0]=w[c+4|0]<<3;break x}if(w[c+3|0]!=10|e>>>0>19922963|(b|0)!=15){break x}if(w[c+4|0]?w[c+5|0]:1){t[c+2|0]=0;break x}t[c+3|0]=0}kb=l+16|0;c=v[Ck(p+8|0)>>2];continue}break}b=v[j+4>>2];v[d+16>>2]=v[j>>2];v[d+20>>2]=b;kb=p+16|0}A=A+1|0;continue}}v[g+32>>2]=q;v[g+36>>2]=r;kb=d+32|0;S:{b=y[a+1074308>>2]<19267584;if(b&o){b=41936;while(1){if((b|0)==42280){break S}d=v[i>>2];c=v[b+4>>2];Ob(h,v[b>>2],d>>>0>=c>>>0|(d|0)==(c&-65536));b=b+8|0;continue}}if(!(b&((D|0)==4&C))){break S}b=42288;while(1){if((b|0)==42528){break S}Ob(h,v[b>>2],y[i>>2]>=y[b+4>>2]);b=b+8|0;continue}}T:{U:{d=v[a+480180>>2];if(d&16777248){b=42528;while(1){if((b|0)==42584){break U}d=v[i>>2];c=v[b+4>>2];e=c&-65536;if(!(d>>>0>=e>>>0&(c>>>0<=d>>>0|d>>>0<=e>>>0))){_f(h,v[b>>2])}b=b+8|0;continue}}b=42656;c=42592;V:{switch(d-2|0){case 2:while(1){if((c|0)==42656){break U}if(y[i>>2]<y[c+4>>2]){_f(h,v[c>>2])}c=c+8|0;continue};case 0:break V;default:break T}}while(1){if((b|0)==42744){break U}if(y[i>>2]<y[b+4>>2]){_f(h,v[b>>2])}b=b+8|0;continue}}d=v[a+480180>>2]}W:{if((d|0)==4){b=v[i>>2];if(b>>>0>18415615){break W}Ob(h,98,1)}b=v[i>>2]}c=8;if(b-19333159>>>0<=33){b=0;while(1){if((b|0)!=5){d=b+77|0;Db(g+32|0,h,d);_f(Ob(h,b+86|0,Cb(v[v[g+32>>2]>>2],v[g+36>>2])),d);b=b+1|0;continue}break}b=v[i>>2]}X:{if(b>>>0>=18284544){if(b>>>0>18874627){break X}c=6;if((b|0)==18874368){break X}}Ob(h,c,1)}b=v[a+1074308>>2];Y:{if(w[a+480208|0]&16){if(b>>>0<=19136511){_f(h,7);break Y}if(!(v[a+480180>>2]&16777248)|b>>>0>19267583){break Y}Ob(h,7,1);break Y}if((b|0)==19922944|b>>>0>19922997){break Y}_f(h,7)}Db(g+32|0,h,31);Z:{if(!Cb(v[v[g+32>>2]>>2],v[g+36>>2])){break Z}b=v[i>>2];if(b>>>0<19071234|b>>>0>19398722){break Z}c=x[a+480192>>1];b=1;while(1){d=b&65535;if(d>>>0>c>>>0){break Z}_:{d=v[((d<<2)+a|0)+900380>>2];if(!d){break _}e=w[d+65|0];if(!(w[d+60|0]&4)|(e|0)==255|e>>>0<=w[d- -64|0]){break _}Ob(h,97,1);break Z}b=b+1|0;continue}}d=v[a+480180>>2];$:{if(!(d&16777218)){break $}c=x[a+480190>>1];b=1;while(1){e=b&65535;if(e>>>0>c>>>0){break $}b=b+1|0;if(!(w[(B(e,104)+a|0)+484415|0]&2)){continue}break}aa:{ba:{ca:{if(!(!x[a+480192>>1]|(d|0)!=16777216)){b=v[i>>2];if(b>>>0<19398688){break ba}if(b>>>0>19464277){break ca}Ob(h,109,1)}b=v[i>>2]}if((b|0)==19922944|b>>>0>19922996){break aa}}_f(h,111);b=v[i>>2]}d=v[a+480180>>2];if(!((d|0)!=2|b>>>0>19464191)){Ob(h,108,1);break $}if((d|0)==2){break $}_f(h,108)}b=v[i>>2];da:{ea:{if(b>>>0<19333186){break ea}if(b>>>0<=19923013){if(!(v[a+480180>>2]&16777252)){break ea}b=a+906300|0;d=gk(b);while(1){if((b|0)!=(d|0)){fa:{if((w[b+16|0]|w[b+17|0]<<8|(w[b+18|0]<<16|w[b+19|0]<<24))!=1146637647|(w[b+20|0]|w[b+21|0]<<8|(w[b+22|0]<<16|w[b+23|0]<<24))!=-271958638){break fa}if((fd(v[b+4>>2],v[b+8>>2])|0)!=32){break fa}c=Kc(g+32|0,16886);Ju(b+80|0,c);zb(c)}b=b+160|0;continue}break}b=v[i>>2]}if(b>>>0>19988488){break da}}if(!(v[a+480180>>2]&16777252)){break da}b=a+906300|0;d=gk(b);while(1){if((b|0)==(d|0)){break da}a=b;b=b+160|0;if(!Ai(v[a+16>>2],v[a+20>>2])){continue}break}Ob(h,117,1)}kb=g+48|0}function zW(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;a:{n=Hh(b,13848);if(!n){break a}o=a+480192|0;b:while(1){if(!Qb(v[b>>2],v[b+8>>2],6)){break a}c:{f=Bg(b);d:{if((f|0)==(Vm(13667)|0)){break d}c=w[21664]|w[21665]<<8|(w[21666]<<16|w[21667]<<24);if(!(f&1616928864)|f&-2139062144){break d}if((c|0)!=(f|0)){break c}}yg(b,4);break a}l=1;c=Rg(b);while(1){d=l&65535;if(d>>>0>x[o>>1]){continue b}d=v[((d<<2)+a|0)+900380>>2];if(d){e:{g=0;if((Vm(16789)|0)==(f|0)){$b(b,c);break e}e=kb-48|0;kb=e;f:{if(!d){break f}g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{z:{A:{B:{C:{D:{E:{F:{G:{H:{I:{J:{K:{L:{M:{N:{O:{P:{Q:{R:{S:{T:{U:{V:{W:{X:{Y:{Z:{_:{switch(f-1349079874|0){default:if((f|0)==1095062094){break v}if((f|0)==1095126087){break s}if((f|0)==1129524782){break B}if((f|0)==1145263150){break Y}if((f|0)==1145979182){break X}if((f|0)==1179463214){break z}if((f|0)==1851469358){break F}if((f|0)==1179931728){break n}$:{aa:{ba:{ca:{da:{ea:{fa:{ga:{ha:{ia:{ja:{if((f|0)!=1196830254){if((f|0)==1229341486){break U}if((f|0)==1229345326){break T}if((f|0)==1264266798){break G}if((f|0)==1296182830){break S}if((f|0)==1296248366){break Q}if((f|0)==1297100334){break R}if((f|0)==1297110852){break q}if((f|0)==1298747438){break D}if((f|0)==1313692462){break H}if((f|0)==1313751342){break Z}if((f|0)==1345203758){break ja}if((f|0)==1346711086){break l}if((f|0)==1346720334){break w}if((f|0)==1346722606){break J}if((f|0)==1346784327){break t}if((f|0)==1347175726){break da}if((f|0)==1347179310){break ea}if((f|0)==1347437358){break O}if((f|0)==1347441454){break P}if((f|0)==1347443502){break M}if((f|0)==1347628590){break W}if((f|0)==1347633710){break ca}if((f|0)==1347634478){break ba}if((f|0)==1347703884){break o}if((f|0)==1347831112){break y}if((f|0)==1347833672){break x}if((f|0)==1349076270){break k}if((f|0)==1349076315){break I}if((f|0)==1349078085){break $}if((f|0)==1349078099){break aa}if((f|0)==1349079131){break L}if((f|0)==1378758190){break p}if((f|0)==1381183022){break A}if((f|0)==1447374382){break m}if((f|0)==1447383630){break u}if((f|0)==1447385902){break K}if((f|0)==1447447623){break r}if((f|0)==1447839022){break ha}if((f|0)==1447842606){break ia}if((f|0)==1448106798){break N}if((f|0)==1448226350){break C}if((f|0)==1448291886){break V}if((f|0)==1448297006){break ga}if((f|0)==1448297774){break fa}if((f|0)!=1682320942){if((f|0)==1718508334){break E}if((f|0)!=1179594286|c>>>0>4){break f}if(!Qb(v[b>>2],v[b+8>>2],c)){break f}p=d,q=kv(b,c),v[p>>2]=q;break g}if(c>>>0>1){break f}if(!Qb(v[b>>2],v[b+8>>2],c)){break f}p=d,q=Dd(b,c),t[p+15|0]=q;break g}if(c>>>0>4){break f}if(!Qb(v[b>>2],v[b+8>>2],c)){break f}p=d,q=kv(b,c),v[p+4>>2]=q;break g}if(c>>>0>4){break f}if(!Qb(v[b>>2],v[b+8>>2],c)){break f}p=d,q=kv(b,c),v[p+8>>2]=q;break g}if(c>>>0>1){break f}if(!Qb(v[b>>2],v[b+8>>2],c)){break f}p=d,q=Dd(b,c),t[p+61|0]=q;break g}if(c>>>0>1){break f}if(!Qb(v[b>>2],v[b+8>>2],c)){break f}p=d,q=Dd(b,c),t[p+62|0]=q;break g}if(c>>>0>1){break f}if(!Qb(v[b>>2],v[b+8>>2],c)){break f}p=d,q=Dd(b,c),t[p+63|0]=q;break g}if(c>>>0>1){break f}if(!Qb(v[b>>2],v[b+8>>2],c)){break f}p=d- -64|0,q=Dd(b,c),t[p|0]=q;break g}if(c>>>0>1){break f}if(!Qb(v[b>>2],v[b+8>>2],c)){break f}p=d,q=Dd(b,c),t[p+81|0]=q;break g}if(c>>>0>1){break f}if(!Qb(v[b>>2],v[b+8>>2],c)){break f}p=d,q=Dd(b,c),t[p+82|0]=q;break g}if(c>>>0>1){break f}if(!Qb(v[b>>2],v[b+8>>2],c)){break f}p=d,q=Dd(b,c),t[p+83|0]=q;break g}if(c>>>0>1){break f}if(!Qb(v[b>>2],v[b+8>>2],c)){break f}p=d,q=Dd(b,c),t[p+84|0]=q;break g}if(c>>>0>1){break f}if(!Qb(v[b>>2],v[b+8>>2],c)){break f}p=d,q=Dd(b,c),t[p+101|0]=q;break g}if(c>>>0>1){break f}if(!Qb(v[b>>2],v[b+8>>2],c)){break f}p=d,q=Dd(b,c),t[p+102|0]=q;break g;case 0:if(c>>>0>1){break f}if(!Qb(v[b>>2],v[b+8>>2],c)){break f}p=d,q=Dd(b,c),t[p+103|0]=q;break g;case 3:break _;case 1:case 2:break f}}if(c>>>0>1){break f}if(!Qb(v[b>>2],v[b+8>>2],c)){break f}p=d,q=Dd(b,c),t[p+104|0]=q;break g}if(c>>>0>1){break f}if(!Qb(v[b>>2],v[b+8>>2],c)){break f}p=d,q=Dd(b,c),t[p+16|0]=q;break g}if(c>>>0>1){break f}if(!Qb(v[b>>2],v[b+8>>2],c)){break f}p=d,q=Dd(b,c),t[p+17|0]=q;break g}if(c>>>0>1){break f}if(!Qb(v[b>>2],v[b+8>>2],c)){break f}p=d,q=Dd(b,c),t[p+18|0]=q;break g}if(c>>>0>1){break f}if(!Qb(v[b>>2],v[b+8>>2],c)){break f}p=d,q=Dd(b,c),t[p+19|0]=q;break g}if(c>>>0>1){break f}if(!Qb(v[b>>2],v[b+8>>2],c)){break f}p=d,q=Dd(b,c),t[p+20|0]=q;break g}if(c>>>0>1){break f}if(!Qb(v[b>>2],v[b+8>>2],c)){break f}p=d,q=Dd(b,c),t[p+21|0]=q;break g}if(c>>>0>1){break f}if(!Qb(v[b>>2],v[b+8>>2],c)){break f}p=d,q=Dd(b,c),t[p+22|0]=q;break g}if(c>>>0>2){break f}if(!Qb(v[b>>2],v[b+8>>2],c)){break f}p=d,q=XC(b,c),u[p+28>>1]=q;break g}if(c>>>0>1){break f}if(!Qb(v[b>>2],v[b+8>>2],c)){break f}p=d,q=Dd(b,c),t[p+30|0]=q;break g}if(c>>>0>1){break f}if(!Qb(v[b>>2],v[b+8>>2],c)){break f}p=d,q=Dd(b,c),t[p+31|0]=q;break g}if(c>>>0>1){break f}if(!Qb(v[b>>2],v[b+8>>2],c)){break f}p=d,q=WC(b,c),t[p+26|0]=q;break g}if(c>>>0>1){break f}if(!Qb(v[b>>2],v[b+8>>2],c)){break f}p=d,q=Dd(b,c),t[p+27|0]=q;break g}ae(e,b,c);i=kc(e+24|0,e);Bb(e);j=Ih(d,0);h=v[j>>2];while(1){if($d(h,v[j+4>>2])>>>0<=g>>>0){Bb(i);break g}v[23540]=0;k=S(197,i|0)|0;h=v[23540];v[23540]=0;if((h|0)==1){break j}h=v[j>>2];p=Eb(h,g),q=k,u[p>>1]=q;g=g+1|0;continue}}ae(e,b,c);i=kc(e+24|0,e);Bb(e);j=Ih(d,1);h=v[j>>2];while(1){if($d(h,v[j+4>>2])>>>0<=g>>>0){Bb(i);break g}v[23540]=0;k=S(197,i|0)|0;h=v[23540];v[23540]=0;if((h|0)!=1){h=v[j>>2];p=Eb(h,g),q=k,u[p>>1]=q;g=g+1|0;continue}break}g=P()|0;O()|0;break i}ae(e,b,c);i=kc(e+24|0,e);Bb(e);j=Ih(d,2);h=v[j>>2];while(1){if($d(h,v[j+4>>2])>>>0<=g>>>0){Bb(i);break g}v[23540]=0;k=S(197,i|0)|0;h=v[23540];v[23540]=0;if((h|0)!=1){h=v[j>>2];p=Eb(h,g),q=k,u[p>>1]=q;g=g+1|0;continue}break}g=P()|0;O()|0;break i}ae(e,b,c);i=kc(e+24|0,e);Bb(e);j=Ih(d,0);h=v[j>>2];while(1){if($d(h,v[j+4>>2])>>>0<=g>>>0){Bb(i);break g}v[23540]=0;k=S(198,i|0)|0;h=v[23540];v[23540]=0;if((h|0)!=1){h=v[j>>2];p=Eb(h,g),q=k,t[p+2|0]=q;g=g+1|0;continue}break}g=P()|0;O()|0;break i}ae(e,b,c);i=kc(e+24|0,e);Bb(e);j=Ih(d,1);h=v[j>>2];while(1){if($d(h,v[j+4>>2])>>>0<=g>>>0){Bb(i);break g}v[23540]=0;k=S(198,i|0)|0;h=v[23540];v[23540]=0;if((h|0)!=1){h=v[j>>2];p=Eb(h,g),q=k,t[p+2|0]=q;g=g+1|0;continue}break}g=P()|0;O()|0;break i}ae(e,b,c);i=kc(e+24|0,e);Bb(e);j=Ih(d,2);h=v[j>>2];while(1){if($d(h,v[j+4>>2])>>>0<=g>>>0){Bb(i);break g}v[23540]=0;k=S(198,i|0)|0;h=v[23540];v[23540]=0;if((h|0)!=1){h=v[j>>2];p=Eb(h,g),q=k,t[p+2|0]=q;g=g+1|0;continue}break}g=P()|0;O()|0;break i}if(c>>>0>128){break f}h=d+108|0;ae(e,b,c);i=kc(e+24|0,e);Bb(e);while(1){if((g|0)==128){Bb(i);break g}v[23540]=0;j=S(198,i|0)|0;k=v[23540];v[23540]=0;if((k|0)!=1){p=Lb(h,g),q=j,t[p|0]=q;g=g+1|0;continue}break}g=P()|0;O()|0;break i}if(c>>>0>256){break f}h=d+236|0;ae(e,b,c);i=kc(e+24|0,e);Bb(e);while(1){if((g|0)==128){Bb(i);break g}v[23540]=0;j=S(197,i|0)|0;k=v[23540];v[23540]=0;if((k|0)!=1){p=cc(h,g),q=j,u[p>>1]=q;g=g+1|0;continue}break}g=P()|0;O()|0;break i}if(c>>>0>32){break f}j=d+492|0;ae(e,b,c);i=kc(e+24|0,e);Bb(e);h=Nb(e);while(1){if((c|0)==(g|0)){break h}v[23540]=0;k=S(199,i|0)|0;m=v[23540];v[23540]=0;ka:{if((m|0)==1){break ka}v[23540]=0;Q(200,h|0,k|0)|0;k=v[23540];v[23540]=0;if((k|0)==1){break ka}g=g+1|0;continue}break}g=P()|0;O()|0;zb(h);break i}if(c>>>0>32){break f}j=d+524|0;ae(e,b,c);i=kc(e+24|0,e);Bb(e);h=Nb(e);la:{while(1){if((c|0)!=(g|0)){v[23540]=0;k=S(199,i|0)|0;m=v[23540];v[23540]=0;if((m|0)==1){break la}v[23540]=0;Q(200,h|0,k|0)|0;k=v[23540];v[23540]=0;if((k|0)==1){break la}g=g+1|0;continue}break}Dc(j,h);zb(h);Bb(i);break g}g=P()|0;O()|0;zb(h);break i}if(c>>>0>1){break f}if(!Qb(v[b>>2],v[b+8>>2],c)){break f}p=d,q=Dd(b,c),t[p+34|0]=q;break g}if(c>>>0>2){break f}if(!Qb(v[b>>2],v[b+8>>2],c)){break f}p=d,q=XC(b,c),u[p+12>>1]=q;break g}if(c>>>0>1){break f}if(!Qb(v[b>>2],v[b+8>>2],c)){break f}p=d,q=Dd(b,c),t[p+23|0]=q;break g}if(c>>>0>1){break f}if(!Qb(v[b>>2],v[b+8>>2],c)){break f}p=d,q=Dd(b,c),t[p+24|0]=q;break g}if(c>>>0>1){break f}if(!Qb(v[b>>2],v[b+8>>2],c)){break f}p=d,q=Dd(b,c),t[p+25|0]=q;break g}if(c>>>0>1){break f}if(!Qb(v[b>>2],v[b+8>>2],c)){break f}p=d,q=Dd(b,c),t[p+35|0]=q;break g}if(c>>>0>1){break f}if(!Qb(v[b>>2],v[b+8>>2],c)){break f}p=d,q=Dd(b,c),t[p+36|0]=q;break g}if(c>>>0>1){break f}if(!Qb(v[b>>2],v[b+8>>2],c)){break f}p=d,q=Dd(b,c),t[p+105|0]=q;break g}if(c>>>0>1){break f}if(!Qb(v[b>>2],v[b+8>>2],c)){break f}p=d,q=Dd(b,c),t[p+85|0]=q;break g}if(c>>>0>1){break f}if(!Qb(v[b>>2],v[b+8>>2],c)){break f}p=d,q=Dd(b,c),t[p+65|0]=q;break g}if(c>>>0>1){break f}if(!Qb(v[b>>2],v[b+8>>2],c)){break f}p=d,q=Dd(b,c),t[p+100|0]=q;break g}if(c>>>0>1){break f}if(!Qb(v[b>>2],v[b+8>>2],c)){break f}p=d,q=Dd(b,c),t[p+80|0]=q;break g}if(c>>>0>1){break f}if(!Qb(v[b>>2],v[b+8>>2],c)){break f}p=d,q=Dd(b,c),t[p+60|0]=q;break g}if(c>>>0>1){break f}if(!Qb(v[b>>2],v[b+8>>2],c)){break f}p=d,q=WC(b,c),t[p+33|0]=q;break g}g=1;i=Lo(b,c);if(!Ko(i)){break f}t[d+14|0]=i;break f}p=d,q=B(iv(b,c),1e4)+(y[d+40>>2]%1e4|0)|0,v[p+40>>2]=q;break g}h=(iv(b,c)>>>0)%1e4|0;g=v[d+40>>2];v[d+40>>2]=h+g-(g>>>0)%1e4;break g}v[e+24>>2]=240;p=e,q=Lo(b,c),v[p>>2]=q;Qg(d+48|0,v[Kb(e+24|0,e)>>2]);break g}v[e+24>>2]=240;p=e,q=Lo(b,c),v[p>>2]=q;Qg(d+68|0,v[Kb(e+24|0,e)>>2]);break g}v[e+24>>2]=240;p=e,q=Lo(b,c),v[p>>2]=q;Qg(d+88|0,v[Kb(e+24|0,e)>>2]);break g}g=P()|0;O()|0}Bb(i);T(g|0);L()}Dc(j,h);zb(h);Bb(i)}g=1}kb=e+48|0;if(!g){$b(b,c);break e}if((Vm(16794)|0)==(f|0)){e=w[d+15|0];t[d+15|0]=0;t[d+100|0]=w[d+100|0]&224|(e>>>5&4|e>>>6&1);t[d+60|0]=e>>>1&2|(e<<1&4|(w[d+60|0]&240|e&1));t[d+80|0]=w[d+80|0]&240|(e>>>4&2|(e>>>2&4|e>>>3&1))}}}l=l+1|0;continue}}}return n|0}function VV(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=kb-304|0;kb=e;zc(b);if(Uq(b,17861)){o=Nb(e+288|0);v[23540]=0;f=Q(230,b|0,o|0)|0;g=v[23540];v[23540]=0;a:{b:{c:{d:{e:{f:{if((g|0)!=1){if(!f){break a}v[23540]=0;f=Q(245,b|0,e+280|0)|0;g=v[23540];v[23540]=0;g:{if((g|0)==1){break g}if(!f){break a}if(!dC(w[e+280|0],w[e+281|0])){break a}f=Ec(cC(e+280|0),nb);g=v[b+8>>2];m=v[b>>2];v[23540]=0;f=W(156,m|0,g|0,f|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break g}if(!f){break a}if(!c){break b}v[23540]=0;R(246,a|0,4096);d=v[23540];v[23540]=0;if((d|0)==1){break g}v[23540]=0;R(247,a+1298308|0,o|0);d=v[23540];v[23540]=0;if((d|0)==1){break g}d=w[e+282|0];u[a+480188>>1]=32;u[a+480192>>1]=d;oh(a,1);v[23540]=0;d=Q(1,e+264|0,9505)|0;f=v[23540];v[23540]=0;h:{i:{j:{k:{l:{m:{n:{o:{p:{if((f|0)!=1){Jb(a+1298344|0,d);Ab(d);v[23540]=0;d=Q(1,e+248|0,7053)|0;f=v[23540];v[23540]=0;if((f|0)==1){break p}Jb(a+1298356|0,d);Ab(d);v[23540]=0;Y(248,e+48|0);d=v[23540];v[23540]=0;if((d|0)==1){break o}t[e+216|0]=w[e+281|0];v[23540]=0;t[e+8|0]=w[e+280|0];R(249,e+232|0,e+8|0);d=v[23540];v[23540]=0;if((d|0)==1){break n}v[23540]=0;X(250,e+96|0,e+48|0,e+216|0,e+232|0);d=v[23540];v[23540]=0;if((d|0)==1){break m}d=e+96|0;Jb(a+1298368|0,d);Ab(d);Ab(e+232|0);dc(e+48|0);v[a+1298404>>2]=5;if(w[e+280|0]<2){break i}u[e+96>>1]=8192;v[23540]=0;d=S(194,b|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break k}u[e+48>>1]=d;r=a,s=B(x[ke(e+96|0,e+48|0)>>1],1e4)>>>8|0,v[r+480204>>2]=s;v[23540]=0;t[e+96|0]=1;d=S(206,b|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break j}t[e+48|0]=d;r=a,s=w[jf(e+96|0,e+48|0)|0],v[r+480196>>2]=s;v[23540]=0;Q(188,b|0,3)|0;d=v[23540];v[23540]=0;if((d|0)!=1){v[23540]=0;d=S(194,b|0)|0;f=v[23540];v[23540]=0;if((f|0)!=1){break h}}b=P()|0;O()|0;break c}b=P()|0;O()|0;break c}b=P()|0;O()|0;break c}b=P()|0;O()|0;break c}b=P()|0;O()|0;break l}b=P()|0;O()|0;Ab(e+232|0)}dc(e+48|0);break c}b=P()|0;O()|0;break c}b=P()|0;O()|0;break c}t[e+96|0]=32;v[23540]=0;d=S(206,b|0)|0;f=v[23540];v[23540]=0;q:{if((f|0)!=1){t[e+48|0]=d;r=a,s=B(w[jf(e+96|0,e+48|0)|0],1e4),v[r+480204>>2]=s;v[23540]=0;t[e+96|0]=1;d=S(206,b|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break q}t[e+48|0]=d;r=a,s=w[jf(e+96|0,e+48|0)|0],v[r+480196>>2]=s;v[23540]=0;d=S(206,b|0)|0;f=v[23540];v[23540]=0;if((f|0)!=1){break h}b=P()|0;O()|0;break c}b=P()|0;O()|0;break c}b=P()|0;O()|0;break c}v[a+480208>>2]=d>>>2&16|12;m=Tb(e+232|0);p=e+96|12;n=Tb(e+216|0);h=a+480190|0;i=1;while(1){r:{s:{d=i&65535;if(d>>>0>x[a+480192>>1]){break s}v[23540]=0;f=W(251,a|0,d|0,0)|0;d=v[23540];v[23540]=0;t:{if((d|0)==1){break t}if(!f){break s}v[23540]=0;d=Q(240,b|0,f+492|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break t}if(!d){break s}v[23540]=0;k=S(206,b|0)|0;d=v[23540];v[23540]=0;u:{v:{w:{if((d|0)!=1){Ub(e+96|0,0,120);if(!k){break r}x:{if(w[e+280|0]){v[23540]=0;d=Q(252,b|0,e+96|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break w}if(!d){break r}if(w[e+280|0]){break x}}d=hc(e+88|0,p,96);g=v[d+4>>2];d=v[d>>2];v[23540]=0;Nk(165,e+48|0,b,d,g);d=v[23540];v[23540]=0;if((d|0)==1){break v}if(!v[e+52>>2]){break r}}g=f+236|0;d=0;break u}b=P()|0;O()|0;break d}b=P()|0;O()|0;break d}b=P()|0;O()|0;break d}while(1){if((d|0)!=120){r=cc(g,d),s=(w[(e+96|0)+d|0]+x[h>>1]|0)+1|0,u[r>>1]=s;d=d+1|0;continue}break}v[23540]=0;d=f+48|0;U(253,e+8|0,d|0,b|0);g=v[23540];v[23540]=0;if((g|0)==1){break e}v[23540]=0;g=f+68|0;U(253,e+32|0,g|0,b|0);j=v[23540];v[23540]=0;if((j|0)==1){break e}v[23540]=0;j=f+88|0;U(253,e+80|0,j|0,b|0);l=v[23540];v[23540]=0;if((l|0)==1){break e}v[23540]=0;R(254,b|0,e+72|0);l=v[23540];v[23540]=0;if((l|0)==1){break f}v[f>>2]=(w[e+73|0]|w[e+74|0]<<8)&4095;l=w[e+73|0]|w[e+74|0]<<8;Nu(w[e+75|0]|w[e+76|0]<<8,d,0);Nu(w[e+75|0]|w[e+76|0]<<8,g,1);Nu(w[e+75|0]|w[e+76|0]<<8,j,2);r=e,s=Fb(v[d>>2]),v[r+48>>2]=s;l=l>>>12&3;q=Fb(v[f+52>>2]);while(1){d=v[e+48>>2];if(Pb(d,q)){t[e+44|0]=64;t[e+70|0]=((w[d+2|0]<<6)- -64>>>0)/127;r=d,s=w[Yb(e+44|0,e+70|0)|0],t[r+2|0]=s;Le(e+48|0);continue}else{r=e,s=Fb(v[g>>2]),v[r+48>>2]=s;d=Fb(v[f+72>>2])}break}while(1){g=v[e+48>>2];if(Pb(g,d)){t[e+44|0]=64;t[e+70|0]=((w[g+2|0]<<6)+128>>>0)/255;r=g,s=w[Yb(e+44|0,e+70|0)|0],t[r+2|0]=s;Le(e+48|0);continue}break}r=e,s=Fb(v[j>>2]),v[r+48>>2]=s;j=1<<l;l=Fb(v[f+92>>2]);while(1){d=v[e+48>>2];if(Pb(d,l)){g=d;d=t[d+2|0];d=Jka(d^-128,d>>31^-1,j,0);f=nb;y:{if((f|0)>=-1&d>>>0>=4294967292|(f|0)>=0){d=d+4|0;f=d>>>0<4?f+1|0:f;d=((f&7)<<29|d>>>3)&536870911;f=0;break y}f=0-((d>>>0>3)+f|0)|0;d=3-d|0;f=((f&7)<<29|d>>>3)&536870911;d=0-f|0;f=0-((f|0)!=0)|0}r=g,s=Hc(d,f)^128,t[r+2|0]=s;Le(e+48|0);continue}else{f=x[h>>1]+1|0;u[e+70>>1]=f;d=0;f=f&65535;g=4e3-f|0;g=g>>>0>4e3?0:g;z:{A:{B:{while(1){if((d|0)==(k|0)){break A}if((d|0)==(g|0)){v[23540]=0;Q(188,b|0,20)|0;d=v[23540];v[23540]=0;if((d|0)!=1){break A}b=P()|0;O()|0;break d}v[23540]=0;j=d+f|0;Q(240,b|0,((j<<5)+a|0)+946304|0)|0;l=v[23540];v[23540]=0;if((l|0)==1){break z}v[23540]=0;R(255,b|0,e+48|0);l=v[23540];v[23540]=0;C:{if((l|0)==1){break C}v[23540]=0;R(256,e+48|0,(B(j,104)+a|0)+484380|0);j=v[23540];v[23540]=0;if((j|0)==1){break C}v[23540]=0;u[e+44>>1]=w[e+72|0]|d<<8&32512|((w[e+67|0]&3)!=0)<<15;R(257,n|0,e+44|0);j=v[23540];v[23540]=0;if((j|0)==1){break B}d=d+1|0;continue}break}b=P()|0;O()|0;break d}b=P()|0;O()|0;break d}v[23540]=0;R(257,m|0,e+70|0);d=v[23540];v[23540]=0;if((d|0)!=1){v[e+48>>2]=3999;v[e+44>>2]=k+x[h>>1];r=h,s=v[td(e+48|0,e+44|0)>>2],u[r>>1]=s;break r}b=P()|0;O()|0;break d}b=P()|0;O()|0;break d}}}b=P()|0;O()|0;break d}d=Nb(e+96|0);v[23540]=0;f=Q(230,b|0,d|0)|0;g=v[23540];v[23540]=0;D:{E:{F:{G:{H:{if((g|0)!=1){I:{if(f){v[23540]=0;U(11,e+48|0,7,d|0);f=v[23540];v[23540]=0;if((f|0)==1){break I}f=e+48|0;Jb(a+1298320|0,f);Ab(f)}zb(d);d=0;J:{while(1){if((d|0)==32){v[23540]=0;d=Q(258,b|0,e+32|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break G}if(!d){break F}d=v[e+32>>2];if(d>>>0<12){break H}f=v[b+8>>2];g=v[b>>2];v[23540]=0;d=W(156,g|0,f|0,d-11|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break G}if(d){break J}break H}f=(d<<5)+a|0;df(f+480280|0);v[23540]=0;R(231,b|0,f+480289|0);f=v[23540];v[23540]=0;if((f|0)!=1){d=d+1|0;continue}break}b=P()|0;O()|0;break d}d=v[e+32>>2]-11|0;v[e+80>>2]=d;h=Tb(e+96|0);v[23540]=0;U(234,b|0,h|0,d|0);d=v[23540];v[23540]=0;K:{if((d|0)!=1){v[e+48>>2]=50529027;d=e+48|0;r=e,s=B(v[Kb(e+80|0,d)>>2],85),v[r+72>>2]=s;g=Nb(d);v[e+8>>2]=v[e+36>>2];d=v[Kb(e+72|0,e+8|0)>>2];v[23540]=0;R(46,g|0,d|0);d=v[23540];v[23540]=0;L:{if((d|0)==1){break L}d=0;M:{while(1){f=v[e+80>>2];if(f>>>0<=d>>>0){break M}i=v[h>>2];k=w[Lb(i,d)|0];j=f;f=d+1|0;if(!((k|0)!=255|j-f>>>0<2)){f=t[Lb(i,f)|0];i=w[Lb(i,d+2|0)|0];r=e,s=yh(g),v[r+8>>2]=s;k=v[kj(e+24|0,e+8|0)>>2];v[23540]=0;X(237,g|0,k|0,i|0,f|0);f=v[23540];v[23540]=0;if((f|0)!=1){d=d+3|0;continue}break L}v[23540]=0;R(47,g|0,k<<24>>24);i=v[23540];v[23540]=0;d=f;if((i|0)!=1){continue}break}break L}v[23540]=0;X(235,e+8|0,5,7,g|0);d=v[23540];v[23540]=0;if((d|0)!=1){N:{f=e+8|0;d=Bc(g,f);zb(f);f=Mc(d);i=Hb(d);v[23540]=0;da(236,a+1298332|0,f|0,i|0,74,0);f=v[23540];v[23540]=0;if((f|0)==1){break N}zb(d);ic(h);break H}}}b=P()|0;O()|0;zb(g);break K}b=P()|0;O()|0}ic(h);break d}}b=P()|0;O()|0;zb(d);break d}d=w[a+484376|0];f=v[a+484360>>2];v[23540]=0;U(238,Wb(f,d)|0,b|0,w[e+285|0]|w[e+286|0]<<8);d=v[23540];v[23540]=0;if((d|0)==1){break G}i=c&1;if(i){v[23540]=0;R(225,a+484344|0,w[e+283|0]|w[e+284|0]<<8);d=v[23540];v[23540]=0;if((d|0)==1){break G}}h=a+484344|0;f=b;d=0;while(1){O:{if((w[e+283|0]|w[e+284|0]<<8)>>>0>d>>>0){b=v[f+8>>2];g=v[f>>2];v[23540]=0;b=W(156,g|0,b|0,4)|0;g=v[23540];v[23540]=0;if((g|0)==1){break D}if(b){break O}}if(!(c&2)){break F}d=0;c=a+480190|0;while(1){b=x[c>>1];if(d>>>0>=b>>>0){d=0;f=a+480190|0;while(1){if(b>>>0<=d>>>0){break F}c=x[cc(v[n>>2],d)>>1];g=c&255;P:{if(!g){break P}h=v[m>>2];g=g-1&65535;if(Rc(h,v[m+4>>2])>>>0<=g>>>0){break P}j=b;b=x[cc(h,g)>>1]+(c>>>8&127)&65535;if(j>>>0<b>>>0){break P}b=B(b,104);g=b+a|0;c=g+484380|0;h=v[c>>2];if(!_d(h,v[g+484400>>2])){break P}g=b;b=a+484380|0;g=g+b|0;i=x[g+34>>1];b=b+B(d+1|0,104)|0;v[b>>2]=h;u[b+34>>1]=x[b+34>>1]&65534|i&1;if(!Mg(b)){break P}sc(v[b+20>>2],v[g+20>>2],Ij(v[c>>2],x[c+34>>1]))}d=d+1|0;b=x[f>>1];continue}}b=x[cc(v[n>>2],d)>>1];if(b&255){d=d+1|0;continue}d=d+1|0;g=B(d,104)+a|0;b=Zc(e+96|0,u[g+484414>>1]&1?16:8,1,0,b<<16>>16>=0?0:6);v[23540]=0;W(219,b|0,g+484380|0,f|0)|0;b=v[23540];v[23540]=0;if((b|0)!=1){continue}break}b=P()|0;O()|0;break d}v[23540]=0;b=S(157,f|0)|0;g=v[23540];v[23540]=0;Q:{R:{S:{T:{if((g|0)!=1){v[23540]=0;U(190,e+48|0,f|0,b|0);b=v[23540];v[23540]=0;if((b|0)==1){break T}b=e+48|0;g=kc(e+96|0,b);Bb(b);if(!i){break R}v[23540]=0;b=S(206,g|0)|0;k=v[23540];v[23540]=0;if((k|0)==1){break Q}v[23540]=0;Q(188,g|0,1)|0;k=v[23540];v[23540]=0;if((k|0)==1){break Q}v[23540]=0;b=W(226,h|0,d&65535,b+1|0)|0;k=v[23540];v[23540]=0;if((k|0)==1){break Q}if(!b){break R}v[23540]=0;b=Q(232,g|0,e+48|0)|0;k=v[23540];v[23540]=0;if((k|0)==1){break E}if(!b){break S}b=v[h>>2];v[23540]=0;R(233,_b(b,d)|0,e+48|0);b=v[23540];v[23540]=0;if((b|0)!=1){break S}break E}b=P()|0;O()|0;break d}b=P()|0;O()|0;break d}b=v[h>>2];v[23540]=0;U(239,_b(b,d)|0,1,g|0);b=v[23540];v[23540]=0;if((b|0)==1){break E}}Bb(g);d=d+1|0;continue}break}break E}b=P()|0;O()|0;break d}od(n);od(m);break b}b=P()|0;O()|0;Bb(g);break d}b=P()|0;O()|0;break d}i=i+1|0;continue}}b=P()|0;O()|0;break c}b=P()|0;O()|0;break c}b=P()|0;O()|0;break d}b=P()|0;O()|0}od(n);od(m)}zb(o);T(b|0);L()}d=1}zb(o)}kb=e+304|0;return d|0}function Xja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,y=0,z=0,A=0,C=0;e=kb-368|0;kb=e;zc(b);g=e+344|0;f=gC(b,g);if(!f){Ru(g)}a:{b:{c:{d:{e:{if(!f){break e}if(!FU(e+344|0)){break e}if(!Qb(v[b>>2],v[b+8>>2],Ec(72,0))){break e}if(!c){d=1;break e}Cd(a,1);v[a+480208>>2]=v[a+480208>>2]&-25231361|16842752;g=w[e+353|0];u[a+480190>>1]=63;u[a+480188>>1]=g;f:{g:{while(1){if((g&65535)>>>0<=d>>>0){h:{d=1;i:{while(1){j:{g=d&65535;if(g>>>0>x[a+480190>>1]){lC(b,a+1298308|0);g=e+264|0;d=kb-16|0;kb=d;k:{if(!Qb(v[b>>2],v[b+8>>2],8)){t[d|0]=0;di(g,8,d);break k}cn(d+8|0,g);ud(d,b,v[d+8>>2],v[d+12>>2])}kb=d+16|0;n=Tb(e+248|0);g=x[e+354>>1];if(!g){break i}d=0;v[23540]=0;g=W(321,b|0,n|0,B(g,w[e+353|0])<<1)|0;f=v[23540];v[23540]=0;if((f|0)!=1){break j}g=P()|0;O()|0;break a}f=(B(g,104)+a|0)+484380|0;nd(f,1);i=g+(e+272|0)|0;g=Me(b);t[i|0]=g;if(g<<24>>24>=0){A=f,C=DU(b)<<1,v[A>>2]=C}d=d+1|0;continue}break}if(!g){break f}}d=v[n>>2];gc(e+240|0,d,fd(d,v[n+4>>2])>>>1|0);l=Tb(e+224|0);v[23540]=0;R(322,l|0,x[e+356>>1]<<8);d=v[23540];v[23540]=0;if((d|0)==1){break h}d=0;l:{m:{n:{while(1){g=d&65535;d=x[e+356>>1];if(g>>>0>=d>>>0){break m}v[e+176>>2]=d-g;v[e+120>>2]=2e3;d=e+176|0;f=v[td(d,e+120|0)>>2];d=Tb(d);v[23540]=0;f=W(321,b|0,d|0,f<<8)|0;h=v[23540];v[23540]=0;if((h|0)==1){break l}if(!f){break n}f=fc(e+216|0,Fb(v[l+4>>2]));h=Fb(v[d>>2]);j=Fb(v[e+180>>2]);f=v[f>>2];v[23540]=0;X(323,l|0,f|0,h|0,j|0);f=v[23540];v[23540]=0;if((f|0)!=1){ic(d);d=g+2e3|0;continue}break}break c}ic(d);d=0;break g}re(e+200|0,v[l>>2],v[l+4>>2]);_g(e+208|0,v[e+200>>2],v[e+204>>2]);p=a+484376|0;d=w[p|0];g=v[a+484360>>2];v[23540]=0;R(324,Wb(g,d)|0,x[e+354>>1]);d=v[23540];v[23540]=0;if((d|0)==1){break d}q=a+484344|0;s=c&1;j=0;while(1){if(x[e+354>>1]<=j>>>0){h=c&2;g=1;o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{z:{while(1){c=g&65535;if(c>>>0>x[a+480190>>1]){break v}v[23540]=0;d=w[c+(e+272|0)|0];U(325,b|0,((c<<5)+a|0)+946304|0,d&63);f=v[23540];v[23540]=0;if((f|0)==1){break t}A:{B:{if(d<<24>>24<0){break B}v[23540]=0;d=S(326,b|0)|0;f=v[23540];v[23540]=0;C:{D:{E:{F:{G:{H:{I:{J:{if((f|0)==1){break J}c=B(c,104)+a|0;f=c+484392|0;v[f>>2]=d<<1;v[23540]=0;d=S(326,b|0)|0;j=v[23540];v[23540]=0;if((j|0)==1){break I}if(d>>>0>=2){v[c+484396>>2]=v[f>>2]+(d<<1);d=c+484414|0;u[d>>1]=x[d>>1]|8}v[23540]=0;d=S(206,b|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break s}t[e+40|0]=d;t[e+144|0]=64;A=c+484410|0,C=w[Yb(e+40|0,e+144|0)|0]<<2,u[A>>1]=C;v[23540]=0;d=S(206,b|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break J}t[c+484417|0]=d<<4;c=c+484380|0;vo(c);if(!v[c>>2]){break B}v[23540]=0;f=S(206,b|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break D}d=0;switch(f|0){case 4:case 5:break C;case 2:case 3:break F;case 1:break G;case 0:break H;default:break g}}g=P()|0;O()|0;break b}g=P()|0;O()|0;break b}if(h){f=Tb(e+40|0);j=v[b+8>>2];i=v[b>>2];k=v[c>>2];v[23540]=0;j=W(156,i|0,j|0,k|0)|0;i=v[23540];v[23540]=0;if((i|0)==1){break r}if(!j){break w}d=v[c>>2];v[23540]=0;U(327,b|0,f|0,d|0);d=v[23540];v[23540]=0;if((d|0)==1){break r}A=e,C=Fb(v[f>>2]),v[A+144>>2]=C;j=Fb(v[e+44>>2]);while(1){d=v[e+144>>2];if(Pb(d,j)){i=d;d=w[d|0];t[i|0]=d<<7|(d^-1)<<24>>>25;Ke(e+144|0);continue}break}re(e+168|0,v[f>>2],v[e+44>>2]);d=v[ee(e+160|0)>>2];v[23540]=0;d=Eg(328,e+176|0,v[e+168>>2],v[e+172>>2],d,v[e+164>>2]);j=v[23540];v[23540]=0;K:{if((j|0)!=1){j=Zc(e+144|0,16,1,0,16);v[23540]=0;W(219,j|0,c|0,d|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break K}Bb(d);ic(f);break B}g=P()|0;O()|0;break o}g=P()|0;O()|0;Bb(d);break o}c=v[c>>2];break E}f=Tb(e+40|0);d=v[c>>2];v[23540]=0;U(329,e+144|0,b|0,d|0);d=v[23540];v[23540]=0;L:{M:{N:{if((d|0)!=1){d=e+144|0;j=Lm(f,d);ic(d);if(h){re(e+112|0,v[j>>2],v[e+44>>2]);d=v[ee(e+104|0)>>2];v[23540]=0;d=Eg(328,e+120|0,v[e+112>>2],v[e+116>>2],d,v[e+108>>2]);i=v[23540];v[23540]=0;if((i|0)==1){break N}i=Zc(e+144|0,8,1,0,2);v[23540]=0;W(219,i|0,c|0,d|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break M}Bb(d)}ic(j);break B}g=V(30544)|0;if((O()|0)!=(ea(30544)|0)){break L}_(g|0)|0;d=0;v[23540]=0;Z(18);a=v[23540];v[23540]=0;if((a|0)!=1){break u}g=P()|0;O()|0;break L}g=P()|0;O()|0;break L}g=P()|0;O()|0;Bb(d)}ic(f);break b}if(h){d=Zc(e+40|0,(f|0)==2?8:16,1,0,0);v[23540]=0;W(219,d|0,c|0,b|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){break B}g=P()|0;O()|0;break b}c=B(v[c>>2],f-1|0)}v[23540]=0;Q(188,b|0,c|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){break B}}g=P()|0;O()|0;break b}j=Tb(e+40|0);d=v[c>>2];v[23540]=0;U(330,e+144|0,b|0,d|0);d=v[23540];v[23540]=0;O:{P:{if((d|0)!=1){i=e+144|0;d=Lm(j,i);ic(i);if(!h){break O}if((f|0)!=5){break P}A=e,C=Fb(v[d>>2]),v[A+144>>2]=C;k=Fb(v[e+44>>2]);while(1){i=v[e+144>>2];if(!Pb(i,k)){break P}m=i;i=w[i|0];t[m|0]=w[(i>>>7|0)+26417|0]^i;Ke(e+144|0);continue}}g=V(30544)|0;if((O()|0)!=(ea(30544)|0)){break x}_(g|0)|0;d=0;v[23540]=0;Z(18);a=v[23540];v[23540]=0;if((a|0)!=1){break A}g=P()|0;O()|0;break x}re(e+72|0,v[d>>2],v[e+44>>2]);i=v[ee(e- -64|0)>>2];v[23540]=0;i=Eg(328,e+80|0,v[e+72>>2],v[e+76>>2],i,v[e+68>>2]);k=v[23540];v[23540]=0;if((k|0)==1){break z}f=(f|0)==5;f=Zc(e+144|0,f?16:8,1,0,f?16:1);v[23540]=0;W(219,f|0,c|0,i|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break y}Bb(i)}ic(d)}g=g+1|0;continue}break}ic(j);break g}g=P()|0;O()|0;break x}g=P()|0;O()|0;Bb(i)}ic(j);break b}ic(f);break g}Q:{R:{S:{T:{U:{V:{W:{d=x[e+358>>1]|w[e+360|0]<<16;if(d){c=Tb(e+144|0);v[23540]=0;b=W(321,b|0,c|0,d|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break q}if(!b){break U}re(e+32|0,v[c>>2],v[c+4>>2]);b=ee(e+24|0);g=v[b+4>>2];b=v[b>>2];v[23540]=0;b=Eg(328,e+40|0,v[e+32>>2],v[e+36>>2],b,g);g=v[23540];v[23540]=0;if((g|0)==1){break W}v[23540]=0;X(331,a+1298332|0,b|0,d|0,1);d=v[23540];v[23540]=0;if((d|0)==1){break V}Bb(b);ic(c)}v[23540]=0;Y(332,e+8|0);b=v[23540];v[23540]=0;if((b|0)==1){break T}v[23540]=0;U(213,e+144|0,e+8|0,w[e+352|0]);b=v[23540];v[23540]=0;if((b|0)==1){break S}b=e+144|0;Jb(a+1298344|0,b);Ab(b);dc(e+8|0);v[23540]=0;b=Q(1,b|0,10115)|0;c=v[23540];v[23540]=0;if((c|0)==1){break R}Jb(a+1298356|0,b);Ab(b);v[23540]=0;b=Q(1,e+8|0,5104)|0;c=v[23540];v[23540]=0;if((c|0)==1){break Q}Jb(a+1298368|0,b);Ab(b);v[a+1298404>>2]=10;d=1;break g}g=P()|0;O()|0;break p}g=P()|0;O()|0;Bb(b);break p}ic(c);d=0;break g}g=P()|0;O()|0;break b}g=P()|0;O()|0;dc(e+8|0);break b}g=P()|0;O()|0;break b}g=P()|0;O()|0;break b}ic(f);break g}g=P()|0;O()|0;break b}g=P()|0;O()|0;break b}g=P()|0;O()|0;break o}g=P()|0;O()|0}ic(c);break b}ic(f);break b}A=cc(v[Wb(v[a+484360>>2],w[p|0])>>2],j),C=j,u[A>>1]=C;X:{Y:{if(!s){break Y}v[23540]=0;r=j&65535;d=W(226,q|0,r|0,64)|0;g=v[23540];v[23540]=0;if((g|0)==1){break X}if(!d){break Y}f=x[a+480188>>1];i=0;while(1){d=f&65535;if(d>>>0<=i>>>0){break Y}d=cc(v[e+240>>2],B(d,j)+i|0);d=w[d|0]|w[d+1|0]<<8;Z:{if(d>>>0>=x[e+356>>1]){break Z}g=0;y=0-i|0;z=d<<8;d=_b(v[q>>2],j);d=jd(v[d>>2],v[v[d+48>>2]+12>>2],0,i&65535);while(1){if((g|0)==64){break Z}Eq(e+176|0,v[e+208>>2],v[e+212>>2],(g<<2)+z|0,4);f=v[e+176>>2];h=Lb(f,0);m=w[h|0]&63;t[d|0]=m?m+48|0:0;k=Lb(f,1);t[d+1|0]=w[k|0]<<2&60|w[h|0]>>>6;o=w[k|0];h=Lb(f,2);k=w[Lb(f,3)|0];f=w[h|0];h=k<<4|f>>>4;u[e+40>>1]=h;f=f<<2&60|o>>>6;_:{if(!(w[Lb(e+264|0,f>>>3|0)|0]>>>(f&7)&1)|!(h?1:f)){break _}t[d+5|0]=h;o=k>>>4|0;t[d+4|0]=o;$:{aa:{ba:{ca:{da:{ea:{fa:{ga:{ha:{ia:{ja:{ka:{switch(f|0){case 0:case 1:case 2:case 32:case 33:case 34:Pf(d,f&15,h&255);if(!w[d+4|0]){break _}t[d+2|0]=f>>>0<32?3:4;break _;case 9:t[d+3|0]=10;t[d+5|0]=h>>>1;if(h>>>0<512){break _}t[d+2|0]=15;t[d+4|0]=k>>>5;break _;case 10:case 42:if(h>>>0>254){break ja}f=f&15;break;case 50:break aa;case 48:break ba;case 43:break ca;case 47:break da;case 17:case 18:case 26:case 27:break ea;case 22:case 25:case 28:case 29:case 30:break fa;case 16:case 19:case 20:case 21:case 23:case 31:break ga;case 13:break ha;case 11:case 15:break ia;case 3:case 4:case 5:case 6:case 7:case 12:break ka;default:break $}}Pf(d,f,h&255);break _}t[d+3|0]=19;t[d+5|0]=o|(f>>>0<32?16:32);if(k&15){t[d+2|0]=3;t[d+4|0]=(h&240)>>>4;break _}t[d+2|0]=4;t[d+4|0]=h&15;break _}t[d+3|0]=(f|0)==11?12:16;A=d,C=zu(h),t[A+5|0]=C;break _}t[d+3|0]=14;if((h&255)>>>0<64){break _}t[d+5|0]=0;break _}t[d+3|0]=19;t[d+5|0]=h&15|f<<4;break _}t[d+3|0]=19;u[e+120>>1]=15;A=d,C=w[Wc(e+40|0,e+120|0)|0]|f<<4,t[A+5|0]=C;break _}t[d+3|0]=19;if(h&255){t[d+5|0]=h&15|((f|0)==17?16:(f|0)==26?16:32);if(!(k&240)){break _}t[d+2|0]=f>>>0>25?6:5;break _}t[d+5|0]=o|(f>>>0>25?-80:-96);break _}if(!h){break $}t[d+3|0]=17;v[e+120>>2]=8;v[e+80>>2]=h+4;A=d,C=tg(v[Pe(e+120|0,e+80|0)>>2]/8|0),t[A+5|0]=C;break _}t[d+3|0]=14;k=B(y,6)+d|0;m=x[a+480188>>1];f=0;while(1){if((f|0)==(m|0)){break _}h=k+B(f,6)|0;if(!w[h+3|0]){t[h+3|0]=12;A=h,C=zu(r),t[A+5|0]=C}f=f+1|0;continue}}t[d+3|0]=9;f=h&7;if(f){t[d+5|0]=w[f+26409|0];break _}f=h>>>4|0;if((f|0)==128){break $}t[d+5|0]=f;if(!(h&2048)){t[d+5|0]=f^128;break _}t[d+5|0]=f^-1;break _}t[d+5|0]=0;t[d+3|0]=0;if(!m){t[d|0]=255;break _}t[d+3|0]=25;break _}t[d+3|0]=0}g=g+1|0;f=x[a+480188>>1];d=B(f,6)+d|0;continue}}i=i+1|0;continue}}j=j+1|0;continue}break}g=P()|0;O()|0;break b}break c}}else{wB(a,d&65535);u[((d<<5)+a|0)+480284>>1]=(d&3)-1>>>0<2?64:192;d=d+1|0;g=x[a+480188>>1];continue}break}g=P()|0;O()|0;break b}ic(l)}ic(n)}kb=e+368|0;return d|0}g=P()|0;O()|0;break b}g=P()|0;O()|0;ic(d)}ic(l)}ic(n);T(g|0);L()}function l5(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=kb-32|0;kb=g;d=Kc(g+16|0,11589);h=dh(c,d);zb(d);a:{b:{c:{d:{e:{if(h){el(a,v[b+24>>2]+1298356|0);break e}d=Kc(g+16|0,10995);h=dh(c,d);zb(d);if(h){el(a,v[b+24>>2]+1298344|0);break e}d=Kc(g+16|0,11419);h=dh(c,d);zb(d);if(h){el(a,v[b+24>>2]+1298392|0);break e}d=Kc(g+16|0,10987);h=dh(c,d);zb(d);if(h){el(a,v[b+24>>2]+1298380|0);break e}d=Kc(g+16|0,8272);h=dh(c,d);zb(d);if(h){c=g+16|0;d=v[v[b+24>>2]+480184>>2];b=32688;f:{g:{while(1){if((b|0)==32736){break g}if((d|0)!=v[b>>2]){b=b+12|0;continue}break}kn(c,0,v[b+8>>2]);break f}Nb(c)}v[23540]=0;R(1009,a|0,c|0);a=v[23540];v[23540]=0;if((a|0)==1){break d}Ab(g+16|0);break e}d=Kc(g+16|0,10972);h=dh(c,d);zb(d);if(h){f=v[v[b+24>>2]+480184>>2];c=kb+-64|0;kb=c;b=32688;e=Yf(c+48|0);j=g+16|0;d=Nb(j);while(1){if((b|0)!=32736){if((f|0)==v[b>>2]){h=v[b+4>>2];v[23540]=0;h=Q(1,c+32|0,h|0)|0;i=v[23540];v[23540]=0;h:{i:{j:{k:{l:{m:{if((i|0)!=1){v[23540]=0;U(845,c+24|0,e|0,h|0);i=v[23540];v[23540]=0;if((i|0)==1){break k}if(!w[c+28|0]){break h}if(!sh(v[d+4>>2],w[d+11|0])){v[23540]=0;i=Q(1,c+8|0,17806)|0;k=v[23540];v[23540]=0;if((k|0)==1){break m}v[23540]=0;Q(98,d|0,i|0)|0;k=v[23540];v[23540]=0;if((k|0)==1){break l}Ab(i)}v[23540]=0;Q(98,d|0,h|0)|0;i=v[23540];v[23540]=0;if((i|0)!=1){break h}b=P()|0;O()|0;break j}b=P()|0;O()|0;break i}b=P()|0;O()|0;break j}b=P()|0;O()|0;Ab(i);break j}b=P()|0;O()|0}Ab(h)}Ab(d);nM(e);T(b|0);L()}Ab(h)}b=b+12|0;continue}break}nM(e);kb=c- -64|0;v[23540]=0;R(1009,a|0,j|0);a=v[23540];v[23540]=0;if((a|0)!=1){Ab(g+16|0);break e}c=P()|0;O()|0;Ab(g+16|0);break a}d=Kc(g+16|0,8338);h=dh(c,d);zb(d);if(h){el(a,v[b+24>>2]+1298368|0);break e}d=Kc(g+16|0,5623);h=dh(c,d);zb(d);if(h){el(a,v[b+24>>2]+1298320|0);break e}d=Kc(g+16|0,11993);h=dh(c,d);zb(d);if(h){c=g+16|0;Bh(c,v[b+24>>2]+1298308|0);b=v[b+24>>2];v[23540]=0;U(1003,a|0,b|0,c|0);a=v[23540];v[23540]=0;if((a|0)!=1){zb(g+16|0);break e}c=P()|0;O()|0;zb(g+16|0);break a}d=Kc(g+16|0,11362);h=dh(c,d);zb(d);if(h){c=v[b+24>>2]+1298408|0;b=v[c+4>>2];n:{if(!pc(v[c>>2],b)){b=b-48|0;if(zd(v[b+12>>2])){break n}}Nb(a);break e}o=g+16|0;j=kb-144|0;kb=j;sc(j+96|0,b,44);e=v[b+44>>2];if(e){sc(j+44|0,b,44);h=kb-16|0;kb=h;b=Hw(v[j+64>>2]+1900|0,v[j+60>>2]+1|0,v[j+56>>2])-Hw(1970,1,1)|0;b=Jka(b,b>>31,86400,0);c=B(v[j+52>>2],3600);b=b+c|0;d=nb+(c>>31)|0;d=b>>>0<c>>>0?d+1|0:d;c=B(v[j+48>>2],60);i=c;b=c+b|0;c=(c>>31)+d|0;c=b>>>0<i>>>0?c+1|0:c;d=v[j+44>>2];i=d;b=d+b|0;d=(d>>31)+c|0;c=cm(h+8|0,b,b>>>0<i>>>0?d+1|0:d);b=v[c>>2];i=v[c+4>>2];kb=h+16|0;h=j+88|0;d=2147483647;m=ve(+(e>>>0)/18.2);c=-1;o:{if(m>=0x8000000000000000){break o}d=-2147483648;c=0;if(m<=-0x8000000000000000){break o}if(D(m)<0x8000000000000000){d=D(m)>=1?~~(m>0?F(H(m*2.3283064365386963e-10),4294967295):I((m-+(~~m>>>0>>>0))*2.3283064365386963e-10))>>>0:0;c=~~m>>>0;break o}c=0}d=d+i|0;c=b+c|0;d=c>>>0<b>>>0?d+1|0:d;b=cm(h,c,d);i=v[b+4>>2];h=v[b>>2];k=kb-16|0;kb=k;v[k+12>>2]=0;v[k+8>>2]=0;v[k+4>>2]=0;b=Hw(1970,1,1)+Kka(h,i,86400,0)|0;f=b>>31;d=Jka(b,f,1e4,0)+14780|0;c=nb;e=d;c=d>>>0<14780?c+1|0:c;l=Kka(d,c,-14609700,-1)+b|0;d=f+nb|0;d=b>>>0>l>>>0?d+1|0:d;n=Kka(e,c,365242500,0);l=n+l|0;d=nb+d|0;d=l>>>0<n>>>0?d+1|0:d;n=Kka(e,c,-146097e4,-1);l=n+l|0;d=nb+d|0;d=l>>>0<n>>>0?d+1|0:d;c=Kka(e,c,3652425,0);e=nb;n=e;p=l;l=Jka(c,e,-365,-1);e=p+l|0;d=nb+d|0;d=e>>>0<l>>>0?d+1|0:d;if(!((d|0)>0|(d|0)>=0)){d=n-!c|0;c=c-1|0;e=Jka(c,d,-365,-1)+b|0;d=f+nb|0;d=b>>>0>e>>>0?d+1|0:d;b=e;e=(c|0)/-4|0;b=b+e|0;d=(e>>31)+d|0;d=b>>>0<e>>>0?d+1|0:d;e=b;b=(c|0)/100|0;f=b;e=e+b|0;b=(b>>31)+d|0;b=e>>>0<f>>>0?b+1|0:b;d=(c|0)/-400|0;f=d;e=d+e|0;d=(d>>31)+b|0;d=e>>>0<f>>>0?d+1|0:d}f=c;b=Jka(e,d,100,0)+52|0;c=nb;b=Kka(b,b>>>0<52?c+1|0:c,3060,0);c=b+2|0;d=(c|0)/12|0;v[k+12>>2]=f+d;v[k+8>>2]=(c+B(d,-12)|0)+1;b=Jka(b,nb,306,0)+5|0;d=nb;b=Kka(b,b>>>0<5?d+1|0:d,-10,-1)+e|0;v[k+4>>2]=b+1;v[j+136>>2]=0;v[j+128>>2]=0;v[j+132>>2]=0;v[j+120>>2]=0;v[j+124>>2]=0;v[j+116>>2]=v[k+12>>2]-1900;v[j+112>>2]=v[k+8>>2]-1;b=v[k+4>>2];q=j,r=Lka(Kka(h,i,3600,0),nb,24),v[q+104>>2]=r;v[j+108>>2]=b;b=Kka(h,i,60,0);c=nb;q=j,r=Lka(b,c,60),v[q+100>>2]=r;b=Jka(b,c,-60,0)+h|0;v[j+96>>2]=b;kb=k+16|0}c=sc(j,j+96|0,44);b=kb-176|0;kb=b;h=Nb(b+160|0);v[23540]=0;d=Q(1,b+144|0,13455)|0;e=v[23540];v[23540]=0;p:{q:{r:{s:{t:{if((e|0)!=1){e=v[c+20>>2];if(!e){break q}v[23540]=0;v[b+112>>2]=e+1900;R(97,b+128|0,b+112|0);e=v[23540];v[23540]=0;if((e|0)!=1){v[23540]=0;i=Q(98,h|0,b+128|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break t}Ab(b+128|0);f=v[c+16>>2];if(f>>>0>11){break q}v[23540]=0;e=Q(1,b+112|0,16833)|0;j=v[23540];v[23540]=0;u:{v:{w:{x:{y:{z:{if((j|0)!=1){v[23540]=0;v[b+80>>2]=f+1;R(99,b+96|0,b+80|0);f=v[23540];v[23540]=0;if((f|0)==1){break z}v[23540]=0;U(2,b+128|0,e|0,b+96|0);f=v[23540];v[23540]=0;if((f|0)==1){break y}v[23540]=0;i=Q(98,i|0,b+128|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break x}Ab(b+128|0);Ab(b+96|0);Ab(e);if(v[c+12>>2]-32>>>0>=4294967265){break u}break q}a=P()|0;O()|0;break s}a=P()|0;O()|0;break v}a=P()|0;O()|0;break w}a=P()|0;O()|0;Ab(b+128|0)}Ab(b+96|0)}Ab(e);break s}v[23540]=0;e=Q(1,b+96|0,16833)|0;f=v[23540];v[23540]=0;A:{B:{C:{D:{E:{F:{G:{H:{I:{J:{K:{L:{M:{N:{O:{P:{Q:{R:{S:{T:{U:{V:{W:{X:{Y:{Z:{if((f|0)!=1){v[23540]=0;R(99,b+80|0,c+12|0);f=v[23540];v[23540]=0;if((f|0)==1){break Z}v[23540]=0;U(2,b+128|0,e|0,b+80|0);f=v[23540];v[23540]=0;if((f|0)==1){break Y}v[23540]=0;i=Q(98,i|0,b+128|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break X}Ab(b+128|0);Ab(b+80|0);Ab(e);j=v[c>>2];e=v[c+8>>2];f=v[c+4>>2];if(!(j|(e|f))|e>>>0>23|f>>>0>59){break q}v[23540]=0;e=Q(1,b+128|0,13660)|0;f=v[23540];v[23540]=0;if((f|0)==1){break U}v[23540]=0;i=Q(98,i|0,e|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break T}Ab(e);if(v[c+32>>2]>0){v[23540]=0;e=Q(1,b+80|0,15623)|0;f=v[23540];v[23540]=0;if((f|0)==1){break S}Jb(d,e);Ab(e)}v[23540]=0;R(99,b+32|0,c+8|0);e=v[23540];v[23540]=0;if((e|0)==1){break R}v[23540]=0;e=Q(1,b+16|0,14669)|0;f=v[23540];v[23540]=0;if((f|0)==1){break Q}v[23540]=0;U(2,b+48|0,b+32|0,e|0);f=v[23540];v[23540]=0;if((f|0)==1){break P}v[23540]=0;R(99,b|0,c+4|0);f=v[23540];v[23540]=0;if((f|0)==1){break O}v[23540]=0;U(2,b- -64|0,b+48|0,b|0);f=v[23540];v[23540]=0;if((f|0)==1){break N}v[23540]=0;i=Q(98,i|0,b- -64|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break M}Ab(b- -64|0);Ab(b);Ab(b+48|0);Ab(e);Ab(b+32|0);if(j>>>0<62){break H}v[23540]=0;U(100,o|0,i|0,d|0);e=v[23540];v[23540]=0;if((e|0)==1){break G}break p}a=P()|0;O()|0;break s}a=P()|0;O()|0;break V}a=P()|0;O()|0;break W}a=P()|0;O()|0;Ab(b+128|0)}Ab(b+80|0)}Ab(e);break s}a=P()|0;O()|0;break s}a=P()|0;O()|0;Ab(e);break s}a=P()|0;O()|0;break s}a=P()|0;O()|0;break s}a=P()|0;O()|0;break I}a=P()|0;O()|0;break J}a=P()|0;O()|0;break K}a=P()|0;O()|0;break L}a=P()|0;O()|0;Ab(b- -64|0)}Ab(b)}Ab(b+48|0)}Ab(e)}Ab(b+32|0);break s}v[23540]=0;e=Q(1,b+48|0,14669)|0;f=v[23540];v[23540]=0;if((f|0)==1){break F}v[23540]=0;R(99,b+32|0,c|0);f=v[23540];v[23540]=0;if((f|0)==1){break E}v[23540]=0;U(2,b- -64|0,e|0,b+32|0);f=v[23540];v[23540]=0;if((f|0)==1){break D}v[23540]=0;i=Q(98,i|0,b- -64|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break C}Ab(b- -64|0);Ab(b+32|0);Ab(e);v[23540]=0;Q(98,i|0,d|0)|0;e=v[23540];v[23540]=0;if((e|0)!=1){break q}}a=P()|0;O()|0;break s}a=P()|0;O()|0;break s}a=P()|0;O()|0;break A}a=P()|0;O()|0;break B}a=P()|0;O()|0;Ab(b- -64|0)}Ab(b+32|0)}Ab(e);break s}a=P()|0;O()|0;break s}a=P()|0;O()|0;break r}a=P()|0;O()|0;Ab(b+128|0)}Ab(d)}Ab(h);T(a|0);L()}ad(o,h)}Ab(d);Ab(h);kb=b+176|0;kb=c+144|0;v[23540]=0;R(1009,a|0,o|0);a=v[23540];v[23540]=0;if((a|0)!=1){Ab(g+16|0);break e}c=P()|0;O()|0;Ab(g+16|0);break a}d=Kc(g+16|0,12194);h=dh(c,d);zb(d);if(h){c=g+16|0;KP(c,v[b+24>>2]+1298332|0);_:{if(!Re(c)){break _}d=v[v[b+24>>2]+480180>>2];$:{aa:{if((d|0)==33554432){break aa}c=1;if((d|0)==32){break $}if((d|0)==16384){break aa}if((d|0)==16777216){break $}}c=2}ba:{switch(c-1|0){case 0:v[23540]=0;R(1010,g|0,b|0);c=v[23540];v[23540]=0;if((c|0)!=1){Bc(g+16|0,g);zb(g);break _}break b;case 1:break ba;default:break _}}if(Re(g+16|0)){v[23540]=0;R(1011,g|0,b|0);c=v[23540];v[23540]=0;if((c|0)==1){break b}Bc(g+16|0,g);zb(g)}if(!Re(g+16|0)){break _}v[23540]=0;R(1010,g|0,b|0);c=v[23540];v[23540]=0;if((c|0)==1){break b}Bc(g+16|0,g);zb(g)}b=v[b+24>>2];v[23540]=0;U(1003,a|0,b|0,g+16|0);a=v[23540];v[23540]=0;if((a|0)!=1){zb(g+16|0);break e}break b}d=Kc(g+16|0,5475);h=dh(c,d);zb(d);if(h){c=g+16|0;KP(c,v[b+24>>2]+1298332|0);b=v[b+24>>2];v[23540]=0;U(1003,a|0,b|0,c|0);a=v[23540];v[23540]=0;if((a|0)!=1){zb(g+16|0);break e}c=P()|0;O()|0;zb(g+16|0);break a}e=c;c=Kc(g+16|0,7295);d=dh(e,c);zb(c);if(d){a=Nb(a);q=g,r=Fb(v[b+68>>2]),v[q+16>>2]=r;b=Fb(v[b+72>>2]);c=1;while(1){d=v[g+16>>2];if(!Pb(d,b)){break e}if(!(c&1)){v[23540]=0;Q(935,a|0,21658)|0;c=v[23540];v[23540]=0;if((c|0)==1){break c}}v[23540]=0;Q(800,a|0,d|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break c}oq(g+16|0);c=0;continue}}Kc(a,21688)}kb=g+32|0;return}c=P()|0;O()|0;Ab(g+16|0);break a}c=P()|0;O()|0;zb(a);break a}c=P()|0;O()|0;zb(g+16|0)}T(c|0);L()}function TG(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,x=0,y=0,D=0,E=0,F=0,G=0,H=C(0),I=0;e=kb-144|0;kb=e;d=Ub(e,0,144);v[d+76>>2]=-1;v[d+44>>2]=a;v[d+32>>2]=1113;v[d+84>>2]=a;x=c;a=0;h=kb-304|0;kb=h;a:{b:{c:{d:{if(v[d+4>>2]){break d}Xw(d);if(v[d+4>>2]){break d}break c}g=w[b|0];if(!g){break a}e:{f:{g:{h:{while(1){i:{c=g&255;j:{if(Vk(c)){while(1){g=b;b=b+1|0;if(Vk(w[g+1|0])){continue}break}mi(d,0,0);while(1){b=v[d+4>>2];k:{if((b|0)!=v[d+104>>2]){v[d+4>>2]=b+1;b=w[b|0];break k}b=rd(d)}if(Vk(b)){continue}break}b=v[d+4>>2];c=v[d+116>>2];if((c|0)>0|(c|0)>=0){b=b-1|0;v[d+4>>2]=b}b=b-v[d+44>>2]|0;c=b>>31;i=b;e=n+v[d+124>>2]|0;b=m+v[d+120>>2]|0;e=b>>>0<m>>>0?e+1|0:e;f=b;b=i+b|0;i=c+e|0;m=b;n=b>>>0<f>>>0?i+1|0:i;break j}l:{m:{n:{if((c|0)==37){c=w[b+1|0];if((c|0)==42){break n}if((c|0)!=37){break m}}mi(d,0,0);o:{if(w[b|0]==37){while(1){c=v[d+4>>2];p:{if((c|0)!=v[d+104>>2]){v[d+4>>2]=c+1;g=w[c|0];break p}g=rd(d)}if(Vk(g)){continue}break}b=b+1|0;break o}c=v[d+4>>2];if((c|0)!=v[d+104>>2]){v[d+4>>2]=c+1;g=w[c|0];break o}g=rd(d)}if(w[b|0]!=(g|0)){b=v[d+116>>2];if((b|0)>0|(b|0)>=0){v[d+4>>2]=v[d+4>>2]-1}if((g|0)>=0){break a}f=0;if(y){break a}break c}c=v[d+4>>2]-v[d+44>>2]|0;g=c>>31;f=c;c=n+v[d+124>>2]|0;e=m+v[d+120>>2]|0;c=e>>>0<m>>>0?c+1|0:c;i=e;e=f+e|0;f=c+g|0;m=e;n=e>>>0<i>>>0?f+1|0:f;g=b;break j}l=0;b=b+2|0;break l}if(!(!bk(c)|w[b+2|0]!=36)){e=kb-16|0;v[e+12>>2]=x;c=c-48|0;c=(c>>>0>1?(c<<2)-4|0:0)+x|0;v[e+8>>2]=c+4;l=v[c>>2];b=b+3|0;break l}l=v[x>>2];x=x+4|0;b=b+1|0}c=0;while(1){e=w[b|0];if(bk(e)){b=b+1|0;c=(B(c,10)+e|0)-48|0;continue}break}r=0;if((e|0)==109){o=0;r=(l|0)!=0;e=w[b+1|0];b=b+1|0;a=0}g=b+1|0;k=3;f=r;q:{r:{switch((e&255)-65|0){case 39:e=b+2|0;b=w[b+1|0]==104;g=b?e:g;k=b?-2:-1;break q;case 43:e=b+2|0;b=w[b+1|0]==108;g=b?e:g;k=b?3:1;break q;case 51:case 57:k=1;break q;case 11:k=2;break q;case 41:break q;case 0:case 2:case 4:case 5:case 6:case 18:case 23:case 26:case 32:case 34:case 35:case 36:case 37:case 38:case 40:case 45:case 46:case 47:case 50:case 52:case 55:break r;default:break e}}k=0;g=b}b=w[g|0];e=(b&47)==3;D=e?1:k;p=e?b|32:b;s:{if((p|0)==91){break s}t:{if((p|0)!=110){if((p|0)!=99){break t}c=(c|0)>1?c:1;break s}UG(l,D,m,n);break j}mi(d,0,0);while(1){b=v[d+4>>2];u:{if((b|0)!=v[d+104>>2]){v[d+4>>2]=b+1;b=w[b|0];break u}b=rd(d)}if(Vk(b)){continue}break}b=v[d+4>>2];e=v[d+116>>2];if((e|0)>0|(e|0)>=0){b=b-1|0;v[d+4>>2]=b}b=b-v[d+44>>2]|0;f=b>>31;j=b;e=n+v[d+124>>2]|0;b=m+v[d+120>>2]|0;e=b>>>0<m>>>0?e+1|0:e;i=b;b=j+b|0;n=e+f|0;n=b>>>0<i>>>0?n+1|0:n;m=b}j=c;s=c>>31;mi(d,c,s);b=v[d+4>>2];v:{if((b|0)!=v[d+104>>2]){v[d+4>>2]=b+1;break v}if((rd(d)|0)<0){break f}}b=v[d+116>>2];if((b|0)>0|(b|0)>=0){v[d+4>>2]=v[d+4>>2]-1}b=16;w:{x:{y:{z:{A:{switch(p-88|0){default:b=p-65|0;if(b>>>0>6|!(1<<b&113)){break w}case 9:case 13:case 14:case 15:WG(h+8|0,d,D,0);b=v[d+4>>2]-v[d+44>>2]|0;if(v[d+120>>2]!=(0-b|0)|v[d+124>>2]!=(0-((b>>31)+((b|0)!=0)|0)|0)){break y}break g;case 3:case 11:case 27:if((p|16)==115){Ub(h+32|0,-1,257);t[h+32|0]=0;if((p|0)!=115){break x}t[h+65|0]=0;t[h+46|0]=0;u[h+42>>1]=0;u[h+44>>1]=0;break x}e=w[g+1|0];f=(e|0)==94;Ub(h+32|0,f,257);t[h+32|0]=0;b=f?g+2|0:g+1|0;B:{C:{D:{g=w[(f?2:1)+g|0];if((g|0)!=45){if((g|0)==93){break D}k=(e|0)!=94;break B}k=(e|0)!=94;t[h+78|0]=k;break C}k=(e|0)!=94;t[h+126|0]=k}b=b+1|0}g=b;while(1){e=w[g|0];E:{if((e|0)!=45){if(!e){break f}if((e|0)==93){break x}break E}e=45;f=w[g+1|0];if(!f|(f|0)==93){break E}i=g+1|0;b=w[g-1|0];F:{if(f>>>0<=b>>>0){e=f;break F}while(1){b=b+1|0;t[b+(h+32|0)|0]=k;e=w[i|0];if(e>>>0>b>>>0){continue}break}}g=i}t[(e+h|0)+33|0]=k;g=g+1|0;continue};case 23:b=8;break z;case 12:case 29:b=10;break z;case 1:case 2:case 4:case 5:case 6:case 7:case 8:case 10:case 16:case 18:case 19:case 20:case 21:case 22:case 25:case 26:case 28:case 30:case 31:break w;case 0:case 24:case 32:break z;case 17:break A}}b=0}j=0;i=0;e=0;f=0;s=0;E=kb-16|0;kb=E;G:{if((b|0)==1){v[116016]=28;break G}while(1){c=v[d+4>>2];H:{if((c|0)!=v[d+104>>2]){v[d+4>>2]=c+1;c=w[c|0];break H}c=rd(d)}if(Vk(c)){continue}break}I:{J:{switch(c-43|0){case 0:case 2:break J;default:break I}}s=(c|0)==45?-1:0;c=v[d+4>>2];if((c|0)!=v[d+104>>2]){v[d+4>>2]=c+1;c=w[c|0];break I}c=rd(d)}K:{L:{M:{N:{if(!((b|0)!=0&(b|0)!=16|(c|0)!=48)){c=v[d+4>>2];O:{if((c|0)!=v[d+104>>2]){v[d+4>>2]=c+1;c=w[c|0];break O}c=rd(d)}if((c&-33)==88){b=16;c=v[d+4>>2];P:{if((c|0)!=v[d+104>>2]){v[d+4>>2]=c+1;c=w[c|0];break P}c=rd(d)}if(w[c+79265|0]<16){break M}b=v[d+116>>2];if((b|0)>0|(b|0)>=0){v[d+4>>2]=v[d+4>>2]-1}mi(d,0,0);break G}if(b){break N}b=8;break M}b=b?b:10;if(b>>>0>w[c+79265|0]){break N}b=v[d+116>>2];if((b|0)>0|(b|0)>=0){v[d+4>>2]=v[d+4>>2]-1}mi(d,0,0);v[116016]=28;break G}if((b|0)!=10){break M}e=c-48|0;if(e>>>0<=9){b=0;while(1){b=B(b,10)+e|0;f=b>>>0<429496729;c=v[d+4>>2];Q:{if((c|0)!=v[d+104>>2]){v[d+4>>2]=c+1;c=w[c|0];break Q}c=rd(d)}e=c-48|0;if(f&e>>>0<=9){continue}break}j=b}R:{if(e>>>0>9){break R}k=Jka(j,0,10,0);f=nb;b=e;while(1){c=v[d+4>>2];S:{if((c|0)!=v[d+104>>2]){v[d+4>>2]=c+1;c=w[c|0];break S}c=rd(d)}e=c-48|0;q=e>>>0>9;j=b+k|0;i=j>>>0<b>>>0?f+1|0:f;if((i|0)==429496729&j>>>0>=2576980378|i>>>0>429496729|q){break R}k=Jka(j,i,10,0);f=nb;b=e;if((f|0)==-1&k>>>0<=(b^-1)>>>0|(f|0)!=-1){continue}break}b=10;break L}b=10;if(e>>>0<=9){break L}break K}if(b-1&b){f=w[c+79265|0];if(f>>>0<b>>>0){while(1){e=B(b,e)+f|0;j=e>>>0<119304647;c=v[d+4>>2];T:{if((c|0)!=v[d+104>>2]){v[d+4>>2]=c+1;c=w[c|0];break T}c=rd(d)}f=w[c+79265|0];if(j&f>>>0<b>>>0){continue}break}j=e}if(b>>>0<=f>>>0){break L}while(1){k=Jka(j,i,b,0);e=nb;f=f&255;if((e|0)==-1&(f^-1)>>>0<k>>>0){break L}c=f+k|0;e=c>>>0<f>>>0?e+1|0:e;j=c;i=e;c=v[d+4>>2];U:{if((c|0)!=v[d+104>>2]){v[d+4>>2]=c+1;c=w[c|0];break U}c=rd(d)}f=w[c+79265|0];if(b>>>0<=f>>>0){break L}vf(E,b,0,0,0,j,i,0,0);if(!(v[E+8>>2]|v[E+12>>2])){continue}break}break L}k=t[(B(b,23)>>>5&7)+79521|0];e=w[c+79265|0];if(e>>>0<b>>>0){while(1){f=f<<k|e;j=f>>>0<134217728;c=v[d+4>>2];V:{if((c|0)!=v[d+104>>2]){v[d+4>>2]=c+1;c=w[c|0];break V}c=rd(d)}e=w[c+79265|0];if(j&e>>>0<b>>>0){continue}break}j=f}if(b>>>0<=e>>>0){break L}f=k;q=f&31;if((f&63)>>>0>=32){f=0;q=-1>>>q|0}else{f=-1>>>q|0;q=f|(1<<q)-1<<32-q}if(!f&j>>>0>q>>>0){break L}while(1){c=k&31;F=e&255;if((k&63)>>>0>=32){e=j<<c;c=0}else{e=(1<<c)-1&j>>>32-c|i<<c;c=j<<c}j=F|c;i=e;c=v[d+4>>2];W:{if((c|0)!=v[d+104>>2]){v[d+4>>2]=c+1;c=w[c|0];break W}c=rd(d)}e=w[c+79265|0];if(b>>>0<=e>>>0){break L}if((f|0)==(i|0)&j>>>0<=q>>>0|f>>>0>i>>>0){continue}break}}if(w[c+79265|0]>=b>>>0){break K}while(1){c=v[d+4>>2];X:{if((c|0)!=v[d+104>>2]){v[d+4>>2]=c+1;c=w[c|0];break X}c=rd(d)}if(w[c+79265|0]<b>>>0){continue}break}v[116016]=68;j=-1;i=-1;s=0}b=v[d+116>>2];if((b|0)>0|(b|0)>=0){v[d+4>>2]=v[d+4>>2]-1}b=s;c=b^j;j=c-b|0;e=b>>31;i=(e^i)-((b>>>0>c>>>0)+e|0)|0}kb=E+16|0;b=v[d+4>>2]-v[d+44>>2]|0;if(v[d+120>>2]==(0-b|0)&v[d+124>>2]==(0-((b>>31)+((b|0)!=0)|0)|0)){break g}if(!(!l|(p|0)!=112)){v[l>>2]=j;break w}UG(l,D,j,i);break w}if(!l){break w}b=v[h+16>>2];c=v[h+20>>2];e=v[h+8>>2];f=v[h+12>>2];Y:{switch(D|0){case 0:G=l,H=rF(e,f,b,c),z[G>>2]=H;break w;case 1:G=l,I=Gw(e,f,b,c),A[G>>3]=I;break w;case 2:break Y;default:break w}}v[l>>2]=e;v[l+4>>2]=f;v[l+8>>2]=b;v[l+12>>2]=c;break w}i=(p|0)==99;c=i?c+1|0:31;Z:{if((D|0)==1){e=l;if(r){e=Pd(c<<2);if(!e){break h}}v[h+296>>2]=0;v[h+300>>2]=0;b=0;while(1){a=e;_:{while(1){e=v[d+4>>2];$:{if((e|0)!=v[d+104>>2]){v[d+4>>2]=e+1;e=w[e|0];break $}e=rd(d)}if(!w[(e+h|0)+33|0]){break _}t[h+27|0]=e;e=Xr(h+28|0,h+27|0,1,h+296|0);if((e|0)==-2){continue}o=0;if((e|0)==-1){break f}if(a){v[(b<<2)+a>>2]=v[h+28>>2];b=b+1|0}if(!((b|0)==(c|0)&r)){continue}break}f=1;b=c;c=b<<1|1;e=ks(a,c<<2);if(e){continue}break e}break}o=0;c=a;if(h+296|0?v[h+296>>2]:0){break f}break Z}if(r){b=0;e=Pd(c);if(!e){break h}while(1){a=e;while(1){e=v[d+4>>2];aa:{if((e|0)!=v[d+104>>2]){v[d+4>>2]=e+1;e=w[e|0];break aa}e=rd(d)}if(!w[(e+h|0)+33|0]){c=0;o=a;break Z}t[a+b|0]=e;b=b+1|0;if((c|0)!=(b|0)){continue}break}f=1;b=c;c=b<<1|1;e=ks(a,c);if(e){continue}break}o=a;a=0;break e}b=0;if(l){while(1){a=v[d+4>>2];ba:{if((a|0)!=v[d+104>>2]){v[d+4>>2]=a+1;a=w[a|0];break ba}a=rd(d)}if(w[(a+h|0)+33|0]){t[b+l|0]=a;b=b+1|0;continue}else{c=0;a=l;o=a;break Z}}}while(1){a=v[d+4>>2];ca:{if((a|0)!=v[d+104>>2]){v[d+4>>2]=a+1;a=w[a|0];break ca}a=rd(d)}if(w[(a+h|0)+33|0]){continue}break}a=0;o=0;c=0}e=v[d+4>>2];f=v[d+116>>2];if((f|0)>0|(f|0)>=0){e=e-1|0;v[d+4>>2]=e}f=e-v[d+44>>2]|0;k=f;e=f+v[d+120>>2]|0;f=v[d+124>>2]+(f>>31)|0;f=e>>>0<k>>>0?f+1|0:f;if(!(f|e)|((e|0)!=(j|0)|(f|0)!=(s|0))&(p|0)==99){break i}if(r){v[l>>2]=a}da:{if(i){break da}if(c){v[(b<<2)+c>>2]=0}if(!o){o=0;break da}t[b+o|0]=0}a=c}b=v[d+4>>2]-v[d+44>>2]|0;e=b>>31;i=b;c=n+v[d+124>>2]|0;b=m+v[d+120>>2]|0;c=b>>>0<m>>>0?c+1|0:c;f=b;b=i+b|0;e=c+e|0;m=b;n=b>>>0<f>>>0?e+1|0:e;y=((l|0)!=0)+y|0}b=g+1|0;g=w[g+1|0];if(g){continue}break a}break}a=c;break g}f=1;o=0;a=0;break e}f=r;break b}f=r}if(y){break b}}y=-1}if(!f){break a}Mb(o);Mb(a)}kb=h+304|0;kb=d+144|0;return y}function Tea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,y=0;k=kb-208|0;kb=k;if(!Jt(a)){e=k+48|0;rQ(e,a);f=k+176|0;pf(f,e,128,2);e=k+192|0;Fc(e,f);Dc(b+492|0,e);zb(e)}u[c+34>>1]=x[c+34>>1]&65489;h=k+192|0;f=kb-32|0;kb=f;a:{b:{switch(w[a+128|0]-4|0){default:v[f+28>>2]=0;jo(h,0,f+28|0);break a;case 0:case 4:break b}}t[f+28|0]=w[a+129|0];t[f+24|0]=100;e=f+24|0;g=w[Yb(f+28|0,e)|0];t[f+24|0]=w[a+130|0];t[f+20|0]=100;e=w[Yb(e,f+20|0)|0];v[f+28>>2]=e;c:{if(w[a+140|0]&16){j=Ib(w[a+150|0]|w[a+151|0]<<8);o=Ib(w[a+152|0]|w[a+153|0]<<8);l=v[c>>2];r=+(l>>>0)/6553600;g=Cq(r*+((j|g<<16)>>>0));v[f+24>>2]=l-g;s=f,y=Cq(r*+((o|e<<16)>>>0)),v[s+20>>2]=y;s=f,y=v[Kb(f+24|0,f+20|0)>>2],v[s+28>>2]=y;break c}j=v[c>>2];o=v[c+20>>2];if(!_d(j,o)){break c}l=j>>>7|0;g=B(l,(g<<7>>>0)/100|0);v[f+24>>2]=j-g;v[f+20>>2]=B(l,(e<<7>>>0)/100|0);e=v[Kb(f+24|0,f+20|0)>>2];l=x[c+34>>1];j=B(Ld(l),j);d:{if(l&1){gc(f+8|0,o,j);o=v[f+8>>2];l=Ld(x[c+34>>1]);j=o+(B(l,e+g|0)<<1)|0;n=u[o+(B(g,l)<<1)>>1];l=0-l<<1;while(1){e:{f:{if(e){p=u[j>>1]-n|0;o=p>>31;if((o^p)-o>>>0>=1536){break f}}else{e=0}break e}e=e-1|0;j=j+l|0;continue}break}break d}gc(f,o,j);o=v[f>>2];l=Ld(x[c+34>>1]);n=0-l|0;j=o+B(l,e+g|0)|0;l=t[o+B(g,l)|0];while(1){g:{h:{if(e){p=t[j|0]-l|0;o=p>>31;if((o^p)-o>>>0>=6){break h}}else{e=0}break g}e=e-1|0;j=j+n|0;continue}break}}v[f+28>>2]=e}jo(h,g,f+28|0)}kb=f+32|0;o=jc(h);if(!(!v[o>>2]|w[a+128|0]!=4)){u[c+34>>1]=x[c+34>>1]|2;e=v[k+192>>2];v[c+4>>2]=e;v[c+8>>2]=e+v[o>>2]}e=w[a+134|0];if((e-1&255)>>>0<=198){t[k+48|0]=e;t[k+176|0]=100;e=(w[Yb(k+48|0,k+176|0)|0]<<7>>>0)/100|0}else{e=128}t[k+47|0]=e;t[k+48|0]=64;e=k+47|0;f=k+48|0;s=c,y=w[jf(e,f)|0]>>>1|0,u[s+32>>1]=y;t[k+48|0]=64;s=b,y=w[Yb(e,f)|0],v[s+4>>2]=y;v[c+24>>2]=40460;zl(c,+t[a+139|0]/12+ +(0-w[a+143|0]|0)+ +t[a+138|0]/1536);t[b+34|0]=w[a+142|0]&2?2:1;if(w[a+142|0]&2){Mj(b,127,1);Lj(b,0,1)}i:{if(!_d(v[c>>2],v[c+20>>2])){break i}b=w[a+140|0];if(b&1){b=v[c>>2];e=v[c+20>>2];j:{if(!_d(b,e)|b>>>0<2){break j}k:{l:{switch(Fk(x[c+34>>1])-1|0){case 3:f=0;h=b>>>1|0;while(1){if((f|0)!=(h|0)){qc(e+(f<<2)|0,e+(b+(f^-1)<<2)|0);f=f+1|0;continue}break};break k;case 1:f=0;h=b>>>1|0;while(1){if((f|0)!=(h|0)){my(e+(f<<1)|0,e+(b+(f^-1)<<1)|0);f=f+1|0;continue}break};break k;case 0:break l;default:break j}}f=0;h=b>>>1|0;while(1){if((f|0)!=(h|0)){Dh(e+f|0,e+(b+(f^-1)|0)|0);f=f+1|0;continue}break}}uj(c,d)}b=w[a+140|0]}if(b&4){m:{e=v[c>>2];b=v[c+20>>2];if(!_d(e,b)){break m}f=x[c+34>>1];e=B(Ld(f),e);n:{o:{switch($m(f)-1|0){case 1:f=0;while(1){if((e|0)!=(f|0)){h=b+(f<<1)|0;u[h>>1]=x[h>>1]^-1;f=f+1|0;continue}break};break n;case 0:break o;default:break m}}f=0;while(1){if((e|0)!=(f|0)){h=b+f|0;t[h|0]=w[h|0]^-1;f=f+1|0;continue}break}}uj(c,d)}}i=w[a+170|0]!=2|w[a+171|0]>100?i:w[a+172|0]<101;b=x[c+34>>1];if(!(!(w[a+141|0]?1:i|w[a+160|0]!=0)|b&1)){e=It(v[c>>2],Ld(b)<<1&254);if(!e){break i}b=e;h=v[c>>2];g=x[c+34>>1];j=B(Ld(g),h);f=v[c+20>>2];g=Ij(h,g);h=kb-16|0;kb=h;v[h+12>>2]=j;xc(h+12|0,g);j=v[h+12>>2];while(1){if(j){u[b>>1]=t[f|0]<<8;f=f+1|0;b=b+2|0;j=j-1|0;continue}break}kb=h+16|0;u[c+34>>1]=x[c+34>>1]|1;pQ(c,e,v[c>>2],d)}p:{if(t[a+141|0]>=0){break p}gc(k+48|0,v[c+20>>2],B(v[c>>2],Ld(x[c+34>>1])));f=v[k+52>>2];e=v[k+48>>2];q:while(1){if((0-t[a+141|0]|0)<=(m|0)){break p}g=u[e>>1];h=cc(e,f);b=e;while(1)if((b|0)==(h|0)){m=m+1|0;continue q}else{g=ld(u[b>>1]-ld(g,1)|0,1);u[b>>1]=g;b=b+2|0;continue}}}r:{if(!i){break r}gc(k+48|0,v[c+20>>2],B(v[c>>2],Ld(x[c+34>>1])));i=v[k+52>>2];b=(i|0)/2|0;h=b>>31;n=b;b=w[a+172|0];g=w[a+171|0];e=g;f=0-(b>>>0<e>>>0)|0;b=b-e|0;e=f<<24|b>>>8;j=b<<24;f=n+j|0;b=e+h|0;b=Hc(Kka(f,f>>>0<j>>>0?b+1|0:b,i,i>>31),nb);f=b;j=b>>31;b=g<<24;g=b;e=b>>31;b=v[k+48>>2];m=cc(b,i);while(1){if((b|0)==(m|0)){break r}i=u[b>>1];i=Jka(g,e,i,i>>31)+838860800|0;h=nb;s=b,y=Hc(Kka(i,i>>>0<838860800?h+1|0:h,1677721600,0),nb),u[s>>1]=y;b=b+2|0;e=e+j|0;i=f+g|0;e=i>>>0<f>>>0?e+1|0:e;g=i;continue}}s:{if(!w[a+160|0]){break s}gc(k+176|0,v[c+20>>2],B(v[c>>2],Ld(x[c+34>>1])));b=w[a+163|0];i=w[a+162|0];t:{if(w[a+161|0]<=1){f=0;e=v[k+180>>2];h=0;break t}f=v[k+180>>2];e=(f|0)/2|0;j=e>>31;g=e;e=w[a+164|0];h=0-(i>>>0>e>>>0)|0;e=e-i|0;m=e<<23;g=g+m|0;e=(h<<23|e>>>9)+j|0;f=Hc(Kka(g,g>>>0<m>>>0?e+1|0:e,f,f>>31),nb);e=v[k+180>>2];h=(e|0)/2|0;j=h>>31;n=h;h=w[a+165|0];m=0-(b>>>0>h>>>0)|0;g=h-b|0;h=m<<23|g>>>9;m=g<<23;g=n+m|0;h=h+j|0;h=Hc(Kka(g,g>>>0<m>>>0?h+1|0:h,e,e>>31),nb)}g=b<<23;i=i<<23;j=(k+48|0)+((w[a+160|0]&2)<<2)|0;m=0;b=v[k+176>>2];l=cc(b,e);e=0;while(1){if((b|0)==(l|0)){break s}n=(u[b>>1]>>1)-e|0;v[k+56>>2]=n;p=n;n=(i|0)/8388608|0;m=ld(B(p,n),8)+m|0;v[k+52>>2]=m;e=ld(B(m,n),6)+e|0;e=ld(ld(B(e,(g|0)/8388608|0),6)+e|0,2);v[k+48>>2]=e;s=b,y=ed(v[j>>2]),u[s>>1]=y;b=b+2|0;g=h+g|0;i=f+i|0;continue}}u:{if(t[a+141|0]<=0){break u}gc(k+48|0,v[c+20>>2],B(v[c>>2],Ld(x[c+34>>1])));m=0;f=v[k+52>>2];e=v[k+48>>2];v:while(1){if(t[a+141|0]<=(m|0)){break u}g=u[e>>1];i=cc(e,f);b=e;while(1)if((b|0)==(i|0)){m=m+1|0;continue v}else{g=((u[b>>1]<<1)+g|0)/3|0;u[b>>1]=g;b=b+2|0;continue}}}b=v[c+20>>2];f=x[c+34>>1];e=B(v[c>>2],Ld(f));w:{if(f&1){gc(k+32|0,b,e);j=kb-16|0;kb=j;b=v[k+32>>2];m=cc(b,v[k+36>>2]);l=kb-16|0;kb=l;v[l+12>>2]=b;q=j+8|0;f=jo(q,b,l+12|0);x:{if((b|0)==(m|0)){break x}e=b+2|0;if((m|0)==(e|0)){break x}s=(nk(x[e>>1],x[v[f>>2]>>1])?0:4)+f|0,y=e,v[s>>2]=y;h=f+4|0;while(1){g=e;i=e+2|0;if((m|0)!=(i|0)){e=g+4|0;if((m|0)==(e|0)){v[l+12>>2]=m;e=x[g+2>>1];if(!nk(e,x[v[f>>2]>>1])){f=h;if(nk(e,x[v[f>>2]>>1])){break x}}v[f>>2]=i;break x}n=x[v[f>>2]>>1];p=x[e>>1];g=x[g+2>>1];y:{if(nk(p,g)){if(nk(p,n)){v[f>>2]=e}if(nk(g,x[v[h>>2]>>1])){continue}break y}if(nk(g,n)){v[f>>2]=i}i=e;if(nk(p,x[v[h>>2]>>1])){continue}}v[h>>2]=i;continue}break}v[l+12>>2]=g}kb=l+16|0;v[j+4>>2]=0-u[v[j+8>>2]>>1];s=j,y=u[v[jc(q)>>2]>>1],v[s>>2]=y;z:{e=v[Pe(j+4|0,j)>>2];if((e|0)>32766|!e){break z}while(1){if((b|0)==(m|0)){break z}u[b>>1]=(B(u[b>>1],32767)|0)/(e|0);b=b+2|0;continue}}break w}gc(k+24|0,b,e);j=kb-16|0;kb=j;b=v[k+24>>2];m=Lb(b,v[k+28>>2]);l=kb-16|0;kb=l;v[l+12>>2]=b;q=j+8|0;f=jo(q,b,l+12|0);A:{if((b|0)==(m|0)){break A}e=b+1|0;if((m|0)==(e|0)){break A}s=(rl(w[e|0],w[v[f>>2]])?0:4)+f|0,y=e,v[s>>2]=y;h=f+4|0;while(1){g=e;i=e+1|0;if((m|0)!=(i|0)){e=g+2|0;if((m|0)==(e|0)){v[l+12>>2]=m;e=w[g+1|0];if(!rl(e,w[v[f>>2]])){f=h;if(rl(e,w[v[f>>2]])){break A}}v[f>>2]=i;break A}n=w[v[f>>2]];p=w[e|0];g=w[g+1|0];B:{if(rl(p,g)){if(rl(p,n)){v[f>>2]=e}if(rl(g,w[v[h>>2]])){continue}break B}if(rl(g,n)){v[f>>2]=i}i=e;if(rl(p,w[v[h>>2]])){continue}}v[h>>2]=i;continue}break}v[l+12>>2]=g}kb=l+16|0;v[j+4>>2]=0-t[v[j+8>>2]];s=j,y=t[v[jc(q)>>2]],v[s>>2]=y;C:{e=v[Pe(j+4|0,j)>>2];if((e|0)>126|!e){break C}while(1){if((b|0)==(m|0)){break C}t[b|0]=(B(t[b|0],127)|0)/(e|0);b=b+1|0;continue}}}kb=j+16|0;D:{if((w[a+134|0]-101&255)>>>0>98){break D}f=x[c+34>>1];e=B(v[c>>2],Ld(f));b=v[c+20>>2];if(f&1){i=k+16|0;v[i>>2]=b;v[i+4>>2]=(b+(e<<1)|0)-b>>1;b=(3276800-(w[a+134|0]<<14)|0)/100|0;h=0-b|0;f=32768-b|0;e=v[i>>2];g=cc(e,v[i+4>>2]);while(1){if((e|0)!=(g|0)){i=u[e>>1];E:{if((i|0)>(b|0)){n=f+((B(b,i-b|0)|0)/(f|0)|0)|0;break E}n=((B(b,b+i|0)|0)/(f|0)|0)-f|0;if((h|0)>(i|0)){break E}n=(B(f,i)|0)/(b|0)|0}s=e,y=ed(n),u[s>>1]=y;e=e+2|0;continue}break}break D}i=un(k+8|0,b,b+e|0);e=v[i>>2];b=(3276800-(w[a+134|0]<<14)|0)/100|0;h=0-b|0;f=32768-b|0;g=Lb(e,v[i+4>>2]);while(1){if((e|0)!=(g|0)){i=t[e|0]<<8;F:{if((i|0)>(b|0)){n=f+((B(b,i-b|0)|0)/(f|0)|0)|0;break F}n=((B(b,b+i|0)|0)/(f|0)|0)-f|0;if((h|0)>(i|0)){break F}n=(B(f,i)|0)/(b|0)|0}s=e,y=nS((n|0)/256|0),t[s|0]=y;e=e+1|0;continue}break}}oQ(c);if(w[a+128|0]!=8){break i}b=w[a+131|0];if(!b){break i}e=v[o>>2];if(!e){break i}s=Eb(c+68|0,0),y=v[k+192>>2]+B(e,b+1|0)|0,v[s>>2]=y;b=v[k+192>>2];v[c+12>>2]=b;v[c+16>>2]=b+v[o>>2];h=v[o>>2];i=w[a+131|0];if(h>>>0>268435456/(i>>>0)>>>0){break i}f=v[c>>2];e=B(h,i);if(f>>>0>268435456-e>>>0){break i}f=e+f|0;e=Fk(x[c+34>>1]);j=It(f,e);if(!j){break i}g=b+B(h,i+1|0)|0;v[c>>2]=f;b=j;j=v[c+20>>2];i=v[k+192>>2];h=sc(b,j,B(e,i+v[o>>2]|0));m=j+B(e,i)|0;a=w[a+131|0];b=0;while(1){if((a|0)==(b|0)){sc(h+B(e,g)|0,j+B(e,i+v[o>>2]|0)|0,B(e,f-g|0));pQ(c,h,f,d)}else{b=b+1|0;l=v[o>>2];sc(h+B(e,i+B(b,l)|0)|0,m,B(e,l));continue}break}}kb=k+208|0}function yaa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=kb-784|0;kb=d;zc(b);a:{b:{c:{d:{e:{f:{if(!ei(b,d+776|0)){break f}if(!eM(v[d+776>>2],v[d+780>>2])){break f}if(!zA(b,d+768|0)){break f}g=v[d+768>>2];if(!dM(g)){break f}f=1313423693;if((g|0)!=1179012417){f=1414090313;if((g|0)!=538987841){break f}}m=je(d+744|0,b);j=Tb(d+728|0);g:{h:{i:{j:{k:{l:{m:{if(!c){v[23540]=0;X(851,d+136|0,m|0,((g|0)==1179012417?1:2)|0,f|0);b=v[23540];v[23540]=0;if((b|0)!=1){break m}a=P()|0;O()|0;break a}v[23540]=0;U(852,d+136|0,m|0,((g|0)==1179012417?1:2)|0);b=v[23540];v[23540]=0;if((b|0)==1){break l}}b=d+136|0;Tt(j,b);Zd(b);v[23540]=0;U(853,d+704|0,j|0,f|0);b=v[23540];v[23540]=0;if((b|0)!=1){v[23540]=0;b=S(178,v[d+704>>2])|0;e=v[23540];v[23540]=0;if((e|0)==1){break k}e=0;if(!b){break g}v[23540]=0;b=Q(854,d+704|0,d+624|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break k}if(!b){break g}b=w[d+689|0];if(!b){break g}v[23540]=0;e=W(156,v[d+704>>2],v[d+712>>2],b|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break k}if(!c|e^1){break g}v[23540]=0;R(246,a|0,8388608);b=v[23540];v[23540]=0;if((b|0)==1){break k}v[a+480208>>2]=w[d+688|0]<<4&16^28;u[d+136>>1]=w[d+689|0];u[d+496>>1]=127;p=a,q=x[Wc(d+136|0,d+496|0)>>1],u[p+480188>>1]=q;v[a+480196>>2]=w[d+690|0];v[a+480204>>2]=B(w[d+691|0],1e4);v[a+480200>>2]=w[d+696|0]<<1;v[23540]=0;R(136,a+1298344|0,((g|0)==1179012417?17004:16970)|0);b=v[23540];v[23540]=0;if((b|0)==1){break k}v[23540]=0;b=Q(1,d+608|0,13239)|0;e=v[23540];v[23540]=0;if((e|0)==1){break i}Jb(a+1298356|0,b);Ab(b);v[a+1298404>>2]=5;b=d+496|0;cA(b,2,d+624|0);v[23540]=0;R(222,d+136|0,b|0);b=v[23540];v[23540]=0;if((b|0)==1){break j}k=(g|0)!=1179012417;b=d+136|0;Bc(a+1298308|0,b);zb(b);l=(g|0)==1179012417;b=0;while(1){n:{o:{p:{if(x[a+480188>>1]<=b>>>0){b=Fb(v[j>>2]);f=Fb(v[j+4>>2]);e=kb-16|0;kb=e;v[e+8>>2]=b;while(1){q:{if(!Pb(b,f)){break q}if(UU(1380209231,v[b>>2],v[b+4>>2])){break q}b=v[Om(e+8|0)>>2];continue}break}kb=e+16|0;if(Pb(b,Fb(v[j+4>>2]))){break p}break h}f=(b<<5)+a|0;h=f+480280|0;df(h);v[23540]=0;e=S(206,d+704|0)|0;n=v[23540];v[23540]=0;r:{s:{if((n|0)!=1){if(l){break r}if(e>>>0<129){break s}break o}a=P()|0;O()|0;break b}u[f+480284>>1]=e<<1;break n}if(e<<24>>24<0){break o}v[d+136>>2]=e<<2;v[d+496>>2]=256;p=f+480284|0,q=v[td(d+136|0,d+496|0)>>2],u[p>>1]=q;break n}v[23540]=0;U(853,d+136|0,j|0,1380209231);b=v[23540];v[23540]=0;t:{if((b|0)!=1){v[23540]=0;b=S(206,d+136|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break t}e=w[a+484376|0];f=v[a+484360>>2];v[23540]=0;da(340,Wb(f,e)|0,d+136|0,b+1&255,255,254);b=v[23540];v[23540]=0;if((b|0)==1){break t}Bb(d+136|0);break h}a=P()|0;O()|0;break b}a=P()|0;O()|0;Bb(d+136|0);break b}v[h>>2]=1024}b=b+1|0;continue}}a=P()|0;O()|0;break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;break b}a=P()|0;O()|0;break b}a=P()|0;O()|0;break b}u:{if(!(c&1)){break u}u[d+56>>1]=0;v[23540]=0;U(855,d+560|0,j|0,1414807888);b=v[23540];v[23540]=0;if((b|0)==1){break c}b=v[d+564>>2];e=v[d+560>>2];v[23540]=0;f=a+484344|0;R(225,f|0,Bf(e,b)&65535);b=v[23540];v[23540]=0;v:{if((b|0)!=1){p=d,q=Fb(v[d+560>>2]),v[p+88>>2]=q;l=Fb(v[d+564>>2]);w:{x:{y:{z:{A:{while(1){b=v[d+88>>2];if(!Pb(b,l)){k=a+484348|0;b=0;break w}b=je(d+136|0,b);v[23540]=0;e=S(206,b|0)|0;h=v[23540];v[23540]=0;if((h|0)!=1){v[23540]=0;u[d+480>>1]=e;e=S(157,b|0)|0;h=v[23540];v[23540]=0;if((h|0)==1){break A}v[23540]=0;U(190,d+496|0,b|0,e|0);e=v[23540];v[23540]=0;if((e|0)==1){break z}e=kc(d+584|0,d+496|0);v[23540]=0;h=v[e+12>>2];v[d+8>>2]=v[e+8>>2];v[d+12>>2]=h;v[d+16>>2]=v[e+16>>2];h=v[e+4>>2];v[d>>2]=v[e>>2];v[d+4>>2]=h;X(856,d|0,x[d+480>>1],k|0,a|0);e=v[23540];v[23540]=0;if((e|0)==1){break y}Bb(d+496|0);p=d,q=x[ke(d+56|0,d+480|0)>>1],u[p+56>>1]=q;Bb(b);Nf(d+88|0);continue}break}a=P()|0;O()|0;break x}a=P()|0;O()|0;break x}a=P()|0;O()|0;break x}a=P()|0;O()|0;Bb(d+496|0)}Bb(b);break v}while(1){e=b&65535;if(e>>>0>=x[d+56>>1]){Vc(d+560|0);break u}B:{if(!xe(v[a+484344>>2],v[k>>2],e)){v[23540]=0;W(226,f|0,e|0,64)|0;e=v[23540];v[23540]=0;if((e|0)==1){break B}}b=b+1|0;continue}break}a=P()|0;O()|0;break v}a=P()|0;O()|0}Vc(d+560|0);break b}C:{if((g|0)==1179012417){v[23540]=0;U(855,d+88|0,j|0,1414745673);b=v[23540];v[23540]=0;if((b|0)==1){break d}p=d,q=Fb(v[d+88>>2]),v[p+120>>2]=q;f=c&2;k=d+504|0;l=Fb(v[d+92>>2]);g=a+480190|0;while(1){b=v[d+120>>2];if(!Pb(b,l)){Vc(d+88|0);break C}c=je(d+560|0,b);v[23540]=0;b=Q(857,c|0,d+136|0)|0;e=v[23540];v[23540]=0;if((e|0)!=1){D:{if(!b){break D}b=w[d+137|0];if((b|0)==255){break D}v[23540]=0;e=W(251,a|0,b+1|0,0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break e}if(!e){break D}h=x[g>>1];b=0;v[23540]=0;U(858,d+136|0,e|0,h|0);e=v[23540];v[23540]=0;if((e|0)==1){break e}while(1){if(w[d+166|0]<=b>>>0){break D}E:{if(!Zh(x[g>>1])){break E}v[23540]=0;e=Q(859,c|0,d+496|0)|0;h=v[23540];v[23540]=0;if((h|0)==1){break e}if(!e){break E}e=x[g>>1]+1|0;u[g>>1]=e;if(v[d+496>>2]!=1347240275){break E}h=d+480|0;Ii(h,2,k);v[23540]=0;R(222,d+56|0,h|0);h=v[23540];v[23540]=0;F:{if((h|0)!=1){e=e&65535;h=d+56|0;Dc(((e<<5)+a|0)+946304|0,h);zb(h);v[23540]=0;e=(B(e,104)+a|0)+484380|0;U(860,d+496|0,d+136|0,e|0);h=v[23540];v[23540]=0;if((h|0)==1){break e}if(!f){break F}h=d+56|0;cM(h,x[d+534>>1]);v[23540]=0;W(219,h|0,e|0,c|0)|0;e=v[23540];v[23540]=0;if((e|0)!=1){break E}break e}break e}h=x[e+34>>1];e=v[e>>2];v[23540]=0;Q(188,c|0,Ij(e,h)|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break e}}b=b+1|0;continue}}Bb(c);Nf(d+120|0);continue}break}break e}v[23540]=0;U(855,d+480|0,j|0,1179011410);b=v[23540];v[23540]=0;if((b|0)!=1){p=d,q=Fb(v[d+480>>2]),v[p+472>>2]=q;k=c&2;l=d+496|4;h=Fb(v[d+484>>2]);e=a+480190|0;G:{H:{I:{J:{K:{L:{M:{N:{O:{P:{while(1){b=v[d+472>>2];if(!Pb(b,h)){Vc(d+480|0);break C}c=je(d+560|0,b);v[23540]=0;b=S(157,c|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break P}Q:{R:{if((b|0)!=538986817){break R}v[23540]=0;b=Q(861,c|0,d+464|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break O}if(!(b&v[d+464>>2]==1414745673)){break R}v[23540]=0;b=Q(862,c|0,d+136|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break N}if(!b){break R}b=w[d+141|0];if((b|0)==255){break R}v[23540]=0;b=W(251,a|0,b+1|0,0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break M}if(!b){break R}g=x[e>>1];v[23540]=0;U(863,d+136|0,b|0,g|0);b=v[23540];v[23540]=0;if((b|0)==1){break M}v[23540]=0;U(852,d+496|0,c|0,2);b=v[23540];v[23540]=0;if((b|0)==1){break Q}v[23540]=0;U(855,d+120|0,d+496|0,1179011410);b=v[23540];v[23540]=0;if((b|0)==1){break L}Zd(d+496|0);p=d,q=Fb(v[d+120>>2]),v[p+112>>2]=q;n=Fb(v[d+124>>2]);S:{T:{while(1){b=v[d+112>>2];if(!Pb(b,n)){break S}b=je(d+88|0,b);v[23540]=0;g=S(157,b|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break K}U:{V:{if((g|0)!=538989377){break V}g=x[e>>1];if(!Zh(g)){break V}f=x[d+460>>1];u[d+460>>1]=f-1;if(!f){Bb(b);break S}i=g+1|0;u[e>>1]=i;v[23540]=0;g=Q(861,b|0,d+80|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break J}if(!(g&v[d+80>>2]==1347240275)){break T}v[23540]=0;U(190,d+496|0,b|0,v[d+84>>2]);g=v[23540];v[23540]=0;W:{if((g|0)!=1){f=d+496|0;g=kc(d+56|0,f);Bb(f);v[23540]=0;f=Q(864,g|0,f|0)|0;o=v[23540];v[23540]=0;if((o|0)==1){break U}if(f){break W}Bb(g);Bb(b);break S}a=P()|0;O()|0;break H}f=d+24|0;Ne(f,2,l);v[23540]=0;R(222,d+40|0,f|0);f=v[23540];v[23540]=0;if((f|0)==1){break I}f=i&65535;i=d+40|0;Dc(((f<<5)+a|0)+946304|0,i);zb(i);v[23540]=0;f=(B(f,104)+a|0)+484380|0;U(865,d+496|0,d+136|0,f|0);i=v[23540];v[23540]=0;if((i|0)==1){break U}X:{if(!k){break X}v[23540]=0;Q(155,g|0,v[d+496>>2]+4|0)|0;i=v[23540];v[23540]=0;if((i|0)==1){break U}i=d+40|0;cM(i,x[d+536>>1]);v[23540]=0;W(219,i|0,f|0,g|0)|0;f=v[23540];v[23540]=0;if((f|0)!=1){break X}break I}Bb(g)}Bb(b);Nf(d+112|0);continue}break}break I}Bb(b)}Vc(d+120|0)}Bb(c);Nf(d+472|0);continue}break}a=P()|0;O()|0;break G}a=P()|0;O()|0;break G}a=P()|0;O()|0;break G}a=P()|0;O()|0;break G}a=P()|0;O()|0;break G}a=P()|0;O()|0;Zd(d+496|0);break G}a=P()|0;O()|0;break H}a=P()|0;O()|0;break H}a=P()|0;O()|0;Bb(g)}Bb(b);Vc(d+120|0)}Bb(c);Vc(d+480|0);break b}a=P()|0;O()|0;break b}e=1}Bb(d+704|0);Zd(j);Bb(m)}kb=d+784|0;return e|0}a=P()|0;O()|0;Bb(c);Vc(d+88|0);break b}a=P()|0;O()|0;break b}a=P()|0;O()|0}Bb(d+704|0)}Zd(j);Bb(m);T(a|0);L()}function lt(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=kb-32|0;kb=h;v[h+28>>2]=c;a:{if((c|0)<=0){break a}k=v[b+656>>2];if(!(!k|v[a+480180>>2]!=16777216)){m=v[k+44>>2]!=0}i=v[b+104>>2];b:{c:{d:{if(!k){j=c;break d}if((c|0)>128){break c}j=c-1|0;l=x[cc(k+236|0,j)>>1];e:{if((l-1&65535)>>>0<=3998){i=(B(l,104)+a|0)+484380|0;break e}Db(h+16|0,a+1074312|0,43);if(!Cb(v[v[h+16>>2]>>2],v[h+20>>2])){break e}if(!oj(v[b+656>>2])){break a}}j=w[Lb(k+108|0,j)|0];v[h+28>>2]=j}if(j>>>0<121){break b}c=j}f:{if(!(v[a+480180>>2]&16777248?(c|0)!=255:0)){Wn(a,b);if(d){break f}Db(h+16|0,a+1074312|0,100);if(!Cb(v[v[h+16>>2]>>2],v[h+20>>2])|!(w[a+480208|0]&4)|!w[b+789|0]){break f}v[b+88>>2]=v[b+88>>2]&-6145;break f}if(!x[a+480192>>1]){break f}v[b+88>>2]=v[b+88>>2]|4096}g:{if((c|0)!=254){break g}d=v[b+88>>2];c=a+480180|0;if(!(!(d&512)|v[c>>2]!=2)){v[b+88>>2]=d|2048;break g}v[b+88>>2]=d|2101248;h:{if(v[c>>2]&16777248){if(!x[a+480192>>1]){break h}Db(h+16|0,a+1074312|0,50);if(Cb(v[v[h+16>>2]>>2],v[h+20>>2])){break h}}v[b+688>>2]=0}Db(h+16|0,a+1074312|0,50);if(Cb(v[v[h+16>>2]>>2],v[h+20>>2])){v[b+8>>2]=0;v[b+12>>2]=0}v[b+696>>2]=0}Db(h+16|0,a+1074312|0,20);if(!Cb(v[v[h+16>>2]>>2],v[h+20>>2])){break a}t[b+797|0]=0;t[b+802|0]=0;break a}i:{j:{k:{if(m){if(d){l=w[b+797|0];if(l){break k}}v[b+708>>2]=0}if(d){break j}if(!(!(v[a+480180>>2]&1048588)|!i)){u[b+770>>1]=t[i+36|0];u[b+772>>1]=t[i+37|0]}if(i){Db(h+16|0,a+1074312|0,24);l=0;o=1;if(!Cb(v[v[h+16>>2]>>2],v[h+20>>2])){break i}v[b+704>>2]=v[i+24>>2];break i}i=0;l=0;break i}l=B((v[v[k+44>>2]+36>>2]<<16>>16)+1|0,(j<<16>>16)-(l<<16>>16)|0)-v[b+852>>2]|0;v[b+708>>2]=l;v[b+852>>2]=0-l}o=(i|0)!=0;l=1;if(Ai(v[b+8>>2],v[b+12>>2])){break i}l=a+1074312|0;Db(h+16|0,l,54);l:{if(!Cb(v[v[h+16>>2]>>2],v[h+20>>2])){break l}if(oj(v[b+656>>2])){Db(h+8|0,l,117);if(!Cb(v[v[h+8>>2]>>2],v[h+12>>2])){break l}}v[b+700>>2]=0;break a}Db(h+16|0,l,39);l=(Cb(v[v[h+16>>2]>>2],v[h+20>>2])^-1)&d}m:{if(Km(v[a+480180>>2])){v[h+28>>2]=u[b+770>>1]+j;oe(h+28|0,12,131);break m}MR(h+28|0)}j=a+1074312|0;Db(h+16|0,j,34);n:{if(Cb(v[v[h+16>>2]>>2],v[h+20>>2])){d=Mm(c);break n}d=v[h+28>>2]}t[b+797|0]=d;t[b+851|0]=w[b+851|0]&183|64;if(!(v[a+480180>>2]&16777250?0:l)){t[b+803|0]=0}d=eh(a,v[h+28>>2],u[b+772>>1],v[b+704>>2]);t[b+831|0]=0;Db(h+16|0,j,48);if(Cb(v[v[h+16>>2]>>2],v[h+20>>2])){IN(a,b,k,i)}Db(h+16|0,j,115);if(!(!Cb(v[v[h+16>>2]>>2],v[h+20>>2])|!k|!w[k+26|0])){if(!x[b+784>>1]){u[b+784>>1]=x[b+692>>1]+1}HN(b+692|0,c,w[k+26|0],w[k+27|0])}o:{if(e^1|l){break o}v[b+776>>2]=0;v[b+780>>2]=0;if(!k){break o}Db(h+16|0,j,29);if(Cb(v[v[h+16>>2]>>2],v[h+20>>2])){t[b+798|0]=w[k+16|0]}if(!(w[k+60|0]&8)){nj(b+724|0)}if(!(w[k+80|0]&8)){nj(b+732|0)}if(!(w[k+100|0]&8)){nj(b+740|0)}if(w[k+20|0]){c=jt(Vn(a));n=w[k+20|0];Db(h+16|0,j,28);n=((B(c,n)<<16>>16)/64<<16)+65536>>16;p:{if(Cb(v[v[h+16>>2]>>2],v[h+20>>2])){c=v[b+752>>2];break p}c=(v[b+688>>2]+1|0)/2|0}u[b+776>>1]=(B(c,n)|0)/199}q:{if(!w[k+19|0]){break q}q=b,r=(B(jt(Vn(a)),w[k+19|0])<<16>>16)/32|0,u[q+778>>1]=r;Db(h+16|0,j,28);if(Cb(v[v[h+16>>2]>>2],v[h+20>>2])|x[b+784>>1]){break q}u[b+784>>1]=x[b+692>>1]+1}c=w[k+23|0];if(c){n=jt(Vn(a));p=w[b+837|0];t[b+796|0]=p+1;u[b+780>>1]=(B(p,(B(c,n+1|0)<<16>>16)/128<<16>>16)+1|0)/128}c=w[k+24|0];if(!c){break o}n=jt(Vn(a));p=w[b+838|0];t[b+795|0]=p+1;u[b+782>>1]=(B(p,(B(c,n+1|0)<<16>>16)/128<<16>>16)+1|0)/128}if(!o){break a}c=0;r:{s:{if(!d){break s}if(!(v[b+700>>2]?l:0)){v[b+700>>2]=d}t:{u:{if(!m){if(!l){Db(h+16|0,j,69);if(Cb(v[v[h+16>>2]>>2],v[h+20>>2])){break u}Db(h+8|0,j,46);if(Cb(v[v[h+8>>2]>>2],v[h+12>>2])|v[a+480180>>2]==1){break u}}v[b+708>>2]=d;t[b+851|0]=w[b+851|0]&239}if(!l){break u}if(v[b+76>>2]|w[a+480180|0]&2){break t}}v[b+104>>2]=i;d=v[i>>2];v[b+84>>2]=d;v[b+76>>2]=d;v[b+80>>2]=0;v[b>>2]=0;v[b+4>>2]=0;v:{w:{if(!(v[a+480208>>2]&2097152)){Db(h+16|0,j,96);if(!Cb(v[v[h+16>>2]>>2],v[h+20>>2])){break w}}if(w[b+789|0]){break w}v[h+16>>2]=v[b+76>>2]-1;q=b,r=v[Kb(b+660|0,h+16|0)>>2],v[q+4>>2]=r;break v}v[b+660>>2]=0}m=x[i+34>>1];d=m&1023;o=d|v[b+88>>2]&-525056;v[b+88>>2]=o;x:{y:{if(m&8){v[b+80>>2]=v[i+12>>2];m=v[i+16>>2];v[b+88>>2]=(d&16?o|4:o&-524295)|2;v[b+84>>2]=m;if(y[b+76>>2]>m>>>0){break y}break x}if(!(d&2)){break x}v[b+80>>2]=v[i+4>>2];m=v[i+8>>2];v[b+84>>2]=m;if(y[b+76>>2]<=m>>>0){break x}}v[b+76>>2]=m}Db(h+16|0,j,83);if(!(!Cb(v[v[h+16>>2]>>2],v[h+20>>2])|v[b+80>>2])){d=v[i>>2];v[b+84>>2]=d;v[b+76>>2]=d}d=v[b+88>>2];z:{if(!(d&128)){break z}i=v[b+76>>2];if(!i){break z}v[b+4>>2]=i-1;v[b+88>>2]=d|128}A:{if(w[b+822|0]>3){break A}Db(h+16|0,j,21);B:{C:{D:{if(!Cb(v[v[h+16>>2]>>2],v[h+20>>2])){i=v[a+480180>>2];if(!(i&16777248)){break D}m=16;if(v[a+480208>>2]&4){break C}break B}i=v[a+480180>>2]}m=32;if((i|0)==16){break B}}if(i&67633152){break A}m=0}t[b+819|0]=m}Db(h+16|0,j,21);if(Cb(v[v[h+16>>2]>>2],v[h+20>>2])|w[b+825|0]>3){break t}t[b+820|0]=0}i=v[b>>2];if(y[b+76>>2]<=y[b+4>>2]){d=v[b+80>>2];v[b>>2]=i;v[b+4>>2]=d}if(!l){break s}c=1;if(!(v[a+480180>>2]&17301536)|(v[b+696>>2]?0:w[b+89|0]&16)){break s}d=1;if(!(w[a+480208|0]&8)){break r}d=1;if(!w[b+789|0]){break r}}if(!(v[b+696>>2]|(!(v[a+480180>>2]&17301536)|!(w[b+89|0]&16)))){tm(b);Db(h+16|0,j,21);if(!Cb(v[v[h+16>>2]>>2],v[h+20>>2])){t[b+818|0]=0;v[b+756>>2]=0}v[b+696>>2]=65536;v[b+88>>2]=v[b+88>>2]&-4097}E:{if(!c){i=w[b+789|0];break E}i=w[b+789|0];if(!(w[a+480208|0]&8)){break E}d=1;if(!(i&255)){break r}}if(!(i&255?0:v[a+480180>>2]&1048580)){v[b+696>>2]=65536;v[b+88>>2]=v[b+88>>2]&-4097}d=c}Db(h+16|0,j,40);F:{G:{if(Cb(v[v[h+16>>2]>>2],v[h+20>>2])){if(d){if(!(!(w[a+480208|0]&8)|!w[b+789|0])){v[b+88>>2]=v[b+88>>2]&-4196353;i=1;break F}v[b+88>>2]=v[b+88>>2]&-4194305;i=1;break F}c=v[b+88>>2]&-4196353;break G}c=v[b+88>>2]&-4196353;v[b+88>>2]=c;i=1;if(d){break F}}u[b+842>>1]=65535;v[b+88>>2]=c&-6326273|2097152;Db(h+16|0,j,23);H:{if(Cb(v[v[h+16>>2]>>2],v[h+20>>2])){break H}Db(h+8|0,j,22);if(Cb(v[v[h+8>>2]>>2],v[h+12>>2])){break H}Db(h+16|0,j,52);if(Cb(v[v[h+16>>2]>>2],v[h+20>>2])){break H}Db(h+8|0,j,71);if(Cb(v[v[h+8>>2]>>2],v[h+12>>2])){break H}t[b+839|0]=0;t[b+808|0]=0}if(e){t[b+818|0]=0;v[b+756>>2]=0}v[b+20>>2]=0;v[b+24>>2]=0;c=v[a+480208>>2]&8192;I:{J:{if(k){i=1;d=w[k+22|0];K:{if(!kf(d)){i=!(c>>>13|0);break K}q=b,r=br(d),t[q+838|0]=r}c=w[k+21|0];if(kf(c)){q=b,r=br(c),t[q+837|0]=r;break J}if(i){break J}c=(i|0)!=0;break I}v[b+776>>2]=0;v[b+780>>2]=0;c=!c;break I}c=1;d=w[k+25|0];if((d|0)==255){break I}t[b+845|0]=d}L:{if(w[b+837|0]>=127){Db(h+16|0,j,36);if(!Cb(v[v[h+16>>2]>>2],v[h+20>>2])){break L}}if(!c){break L}if((Zp(a,b,1,256)|0)<0|!(w[b+89|0]&2)){break L}c=v[a+1298300>>2];if(!zd(c)|(g|0)==65535){break L}cq(c,g,w[b+837|0]>>>1|0,1)}i=0;if(!(w[b+89|0]&2)){break F}if(!zd(v[a+1298300>>2])|(g|0)==65535){break F}Db(h+16|0,j,111);if(Cb(v[v[h+16>>2]>>2],v[h+20>>2])){jk(v[a+1298300>>2],g);break F}Db(h+16|0,j,110);if(!Cb(v[v[h+16>>2]>>2],v[h+20>>2])){break F}tz(v[a+1298300>>2],g,0,1,0)}c=v[b+88>>2];if(f){c=c&-1025;v[b+88>>2]=c}M:{N:{if(w[a+24618|0]&16?c&1024:0){break N}a=v[b+104>>2];if(!(f?1:!a|!(w[a+35|0]&4))){break N}a=v[b+656>>2];if(!a|!(w[a+15|0]&2)){break M}}if(f){break M}v[b+700>>2]=0}if(i){break a}u[b+136>>1]=0;v[b+132>>2]=4194304;v[b+112>>2]=0;v[b+116>>2]=0}kb=h+32|0}function xX(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,z=0,A=0;e=kb-1456|0;kb=e;zc(b);Zo(a);a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{if(!ur(b,e+1432|0)){break n}if(!$D(e+1432|0)){break n}if(!c){j=1;break n}if(!tr(v[b>>2],x[e+1450>>1]|x[e+1452>>1]<<16)){break n}if(!tr(v[b>>2],(x[e+1450>>1]|x[e+1452>>1]<<16)+(x[e+1444>>1]<<2)|0)){break n}Lv(a);z=e,A=Kv(),v[z+56>>2]=A;c=e+56|0;Jv(Vj(v[a+4>>2])+32|0,c);sr(c);l=v[Vj(v[a+4>>2])+32>>2];v[e+1428>>2]=x[e+1446>>1]|x[e+1448>>1]<<16;z=e,A=Vg(v[b>>2]),v[z+1168>>2]=A;v[e+1128>>2]=214748364;d=e+1168|0;z=e,A=B(v[Kb(d,e+1128|0)>>2],20),v[z+56>>2]=A;tn(l,v[Kb(e+1428|0,c)>>2]);Ub(d,0,256);r=Tb(e+1152|0);o:{while(1){j=x[e+1444>>1]<=s>>>0;if(!j){v[23540]=0;c=Q(155,b|0,(x[e+1450>>1]|x[e+1452>>1]<<16)+(s<<2)|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break m}if(!c){break o}c=v[b+8>>2];d=v[b>>2];v[23540]=0;c=W(156,d|0,c|0,4)|0;d=v[23540];v[23540]=0;if((d|0)==1){break m}if(!c){break o}v[23540]=0;c=S(157,b|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break l}v[23540]=0;d=Q(155,b|0,c|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break l}if(!d){break o}v[23540]=0;d=Q(158,b|0,e+1128|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break k}if(!d){break o}v[23540]=0;d=W(159,b|0,r|0,x[e+1140>>1])|0;f=v[23540];v[23540]=0;if((f|0)==1){break k}if(!d){break o}f=v[r>>2];g=v[b>>2];v[23540]=0;d=x[e+1140>>1];g=S(160,g|0)|0;h=v[23540];v[23540]=0;if((h|0)==1){break j}h=c+20|0;if(g>>>0<=h+(d<<3)>>>0){break o}c=d?f:0;f=x[e+1140>>1];g=h+(f<<3)|0;d=0;h=x[e+1142>>1];p:{if(!(h&1)){while(1){if(d>>>0>=f>>>0){break p}if(!c){break o}f=w[c+4|0]|w[c+5|0]<<8|(w[c+6|0]<<16|w[c+7|0]<<24);h=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);v[23540]=0;f=fa(161,h|0,f|0,l|0,v[e+1428>>2])|0;h=v[23540];v[23540]=0;if((h|0)==1){break i}if(!f){break o}v[23540]=0;f=Q(155,b|0,g|0)|0;h=v[23540];v[23540]=0;if((h|0)==1){break i}if(!f){break o}f=hc(e+1120|0,Lb(v[l>>2],w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24)),w[c+4|0]|w[c+5|0]<<8|(w[c+6|0]<<16|w[c+7|0]<<24));h=v[f+4>>2];f=v[f>>2];v[23540]=0;Nk(162,e+56|0,b,f,h);f=v[23540];v[23540]=0;if((f|0)==1){break h}if(v[e+60>>2]!=(w[c+4|0]|w[c+5|0]<<8|(w[c+6|0]<<16|w[c+7|0]<<24))){break o}d=d+1|0;c=c+8|0;f=x[e+1140>>1];continue}}q:{r:{s:{t:{u:{if(h&4){if(!c){break o}d=w[c+4|0]|w[c+5|0]<<8|(w[c+6|0]<<16|w[c+7|0]<<24);f=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);v[23540]=0;d=fa(161,f|0,d|0,l|0,v[e+1428>>2])|0;f=v[23540];v[23540]=0;if((f|0)==1){break g}if(!d){break o}m=Lb(v[l>>2],w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24));k=(w[c+4|0]|w[c+5|0]<<8|(w[c+6|0]<<16|w[c+7|0]<<24))&-2;if(!k){break o}v[23540]=0;f=x[e+1146>>1];d=Q(155,b|0,g+x[e+1144>>1]|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break f}if(!d){break o}d=v[b+8>>2];g=v[b>>2];v[23540]=0;d=W(156,g|0,d|0,v[e+1132>>2]-x[e+1144>>1]|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break f}if(!d){break o}v[23540]=0;U(163,e+32|0,b|0,v[e+1132>>2]-x[e+1144>>1]|0);d=v[23540];v[23540]=0;if((d|0)==1){break b}d=e+32|0;g=rr(e+56|0,d);Bb(d);q=0;n=0;v:{w:{x:{while(1){h=0;y:{while(1){if(x[e+1140>>1]<=(n&65535)>>>0){break x}v[23540]=0;d=Q(164,g|0,f+1|0)|0;i=v[23540];v[23540]=0;if((i|0)==1){break y}i=f&15;o=x[(i<<1)+26032>>1];z:{A:{if(o>>>0<=d>>>0){v[23540]=0;i=w[i+26080|0];p=Q(164,g|0,i|0)|0;u=v[23540];v[23540]=0;if((u|0)==1){break y}d=p+(d-o<<i)|0;if((d|0)!=(f|0)){f=d&15;break z}v[23540]=0;d=Q(164,g|0,4)|0;i=v[23540];v[23540]=0;if((i|0)==1){break y}if((d|0)==15){v[23540]=0;i=Q(164,g|0,1)|0;d=v[23540];v[23540]=0;if((d|0)==1){break y}d=65535;if(!i){break A}Bb(g);break p}d=d+65520|0}if(d>>>0>65535){break z}}d=d&1?0-(d+1>>>1|0)|0:d>>>1|0;p=h+m|0;i=x[e+1142>>1];B:{if(i&2){q=d+q|0;d=q;break B}d=i&512?d:d^32768}o=d>>>8|0;i=i&1024;t[p+1|0]=i?d:o;t[p|0]=i?o:d;h=h+2|0}if(h>>>0<k>>>0){continue}break}n=n+1|0;if(n>>>0>=x[e+1140>>1]){break r}d=(n<<3)+c|0;h=w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24);k=w[d+4|0]|w[d+5|0]<<8|(w[d+6|0]<<16|w[d+7|0]<<24);v[23540]=0;h=fa(161,h|0,k|0,l|0,v[e+1428>>2])|0;k=v[23540];v[23540]=0;if((k|0)==1){break y}if(!h){break t}k=(w[d+4|0]|w[d+5|0]<<8|(w[d+6|0]<<16|w[d+7|0]<<24))&-2;if(!k){break u}m=Lb(v[l>>2],w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24));continue}break}j=V(30544)|0;if((O()|0)!=(ea(30544)|0)){break v}_(j|0)|0;v[23540]=0;Z(18);c=v[23540];v[23540]=0;if((c|0)==1){break w}}Bb(g);break p}j=P()|0;O()|0}Bb(g);break a}if(!c){break o}d=w[c+4|0]|w[c+5|0]<<8|(w[c+6|0]<<16|w[c+7|0]<<24);f=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);v[23540]=0;d=fa(161,f|0,d|0,l|0,v[e+1428>>2])|0;f=v[23540];v[23540]=0;if((f|0)==1){break e}if(!d){break o}q=Lb(v[l>>2],w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24));if(x[e+1144>>1]>256){break o}m=w[c+4|0]|w[c+5|0]<<8|(w[c+6|0]<<16|w[c+7|0]<<24);f=x[e+1146>>1];v[23540]=0;d=Q(155,b|0,g|0)|0;g=v[23540];v[23540]=0;C:{D:{if((g|0)!=1){if(!d){break o}d=hc(e+24|0,e+1168|0,x[e+1144>>1]);g=v[d+4>>2];d=v[d>>2];v[23540]=0;Nk(165,e+56|0,b,d,g);d=v[23540];v[23540]=0;if((d|0)==1){break D}d=x[e+1144>>1];if(d>>>0>y[e+60>>2]){break o}g=v[b+8>>2];h=v[b>>2];v[23540]=0;d=W(156,h|0,g|0,v[e+1132>>2]-d|0)|0;g=v[23540];v[23540]=0;if((g|0)!=1){break C}}j=P()|0;O()|0;break a}j=P()|0;O()|0;break a}if(!d){break o}v[23540]=0;U(163,e+32|0,b|0,v[e+1132>>2]-x[e+1144>>1]|0);d=v[23540];v[23540]=0;if((d|0)==1){break c}d=e+32|0;g=rr(e+56|0,d);Bb(d);k=0;n=0;E:{F:{G:{while(1){h=0;H:{while(1){if(x[e+1140>>1]<=(k&65535)>>>0){break G}v[23540]=0;d=Q(164,g|0,f+1|0)|0;i=v[23540];v[23540]=0;if((i|0)==1){break H}i=f&7;o=w[i+26064|0];I:{J:{if(o>>>0<=d>>>0){v[23540]=0;i=w[i+26072|0];p=Q(164,g|0,i|0)|0;u=v[23540];v[23540]=0;if((u|0)==1){break H}d=p+(d-o<<i)|0;if((d|0)!=(f|0)){f=d&7;break I}v[23540]=0;d=Q(164,g|0,3)|0;i=v[23540];v[23540]=0;if((i|0)==1){break H}if((d|0)==7){v[23540]=0;i=Q(164,g|0,1)|0;d=v[23540];v[23540]=0;if((d|0)==1){break H}d=255;if(!i){break J}Bb(g);break p}d=d+248|0}if(d>>>0>255){break I}}d=w[(e+1168|0)+d|0];i=d+n|0;p=d;d=x[e+1142>>1]&2;t[h+q|0]=d?i:p;n=d?i:n;h=h+1|0}if(h>>>0<m>>>0){continue}break}k=k+1|0;if(k>>>0>=x[e+1140>>1]){break q}d=(k<<3)+c|0;h=w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24);m=w[d+4|0]|w[d+5|0]<<8|(w[d+6|0]<<16|w[d+7|0]<<24);v[23540]=0;h=fa(161,h|0,m|0,l|0,v[e+1428>>2])|0;m=v[23540];v[23540]=0;if((m|0)==1){break H}if(!h){break s}m=w[d+4|0]|w[d+5|0]<<8|(w[d+6|0]<<16|w[d+7|0]<<24);q=Lb(v[l>>2],w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24));continue}break}j=V(30544)|0;if((O()|0)!=(ea(30544)|0)){break E}_(j|0)|0;v[23540]=0;Z(18);c=v[23540];v[23540]=0;if((c|0)==1){break F}}Bb(g);break p}j=P()|0;O()|0}Bb(g);break a}Bb(g);break o}Bb(g);break o}Bb(g);break o}Bb(g);break p}Bb(g)}s=s+1|0;continue}break}re(e+8|0,v[l>>2],v[l+4>>2]);_g(e+16|0,v[e+8>>2],v[e+12>>2]);b=ee(e);c=v[b+4>>2];b=v[b>>2];v[23540]=0;b=Eg(166,e+56|0,v[e+16>>2],v[e+20>>2],b,c);c=v[23540];v[23540]=0;if((c|0)==1){break d}hd(Vj(v[a+4>>2])+12|0,b);Bb(b)}qe(r)}kb=e+1456|0;return j|0}j=P()|0;O()|0;break a}j=P()|0;O()|0;break a}j=P()|0;O()|0;break a}j=P()|0;O()|0;break a}j=P()|0;O()|0;break a}j=P()|0;O()|0;break a}j=P()|0;O()|0;break a}j=P()|0;O()|0;break a}j=P()|0;O()|0;break a}j=P()|0;O()|0;break a}j=P()|0;O()|0;break a}j=P()|0;O()|0}qe(r);T(j|0);L()}function IP(a,b,c,d,e,f,g,h,i){var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,w=0,x=0,z=0,A=0,B=0,C=0,D=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;l=kb-336|0;kb=l;m=i&65535;p=d;q=e&65535;s=(e^i)&-2147483648;k=h;z=i>>>16&32767;A=e>>>16&32767;a:{b:{if(z-32767>>>0>4294934529&A-32767>>>0>=4294934530){break b}j=e&2147483647;if(!(!d&(j|0)==2147418112?!(b|c):j>>>0<2147418112)){o=d;s=e|32768;break a}e=i&2147483647;if(!(!h&(e|0)==2147418112?!(f|g):e>>>0<2147418112)){o=h;s=i|32768;b=f;c=g;break a}if(!(b|d|(j^2147418112|c))){if(!(f|h|(e^2147418112|g))){b=0;c=0;s=2147450880;break a}s=s|2147418112;b=0;c=0;break a}if(!(f|h|(e^2147418112|g))){b=0;c=0;break a}if(!(b|d|(c|j))){b=!(f|h|(e|g));o=b?0:o;s=b?2147450880:s;b=0;c=0;break a}if(!(f|h|(e|g))){s=s|2147418112;b=0;c=0;break a}if((j|0)==65535|j>>>0<65535){i=b;d=!(p|q);h=d<<6;j=E(d?b:p)+32|0;b=E(d?c:q);b=h+((b|0)==32?j:b)|0;Kf(l+320|0,i,c,p,q,b-15|0);n=16-b|0;p=v[l+328>>2];q=v[l+332>>2];c=v[l+324>>2];b=v[l+320>>2]}if(e>>>0>65535){break b}d=!(k|m);e=d<<6;h=E(d?f:k)+32|0;d=E(d?g:m);d=e+((d|0)==32?h:d)|0;Kf(l+304|0,f,g,k,m,d-15|0);n=(d+n|0)-16|0;k=v[l+312>>2];m=v[l+316>>2];f=v[l+304>>2];g=v[l+308>>2]}e=m|65536;B=e;C=k;d=k;k=e<<15|d>>>17;d=d<<15|g>>>17;h=0-d|0;e=k;i=1963258675-(e+((d|0)!=0)|0)|0;vf(l+288|0,d,e,0,0,h,i,0,0);j=v[l+296>>2];vf(l+272|0,0-j|0,0-(v[l+300>>2]+((j|0)!=0)|0)|0,0,0,h,i,0,0);h=v[l+280>>2];i=h<<1|v[l+276>>2]>>>31;h=v[l+284>>2]<<1|h>>>31;vf(l+256|0,i,h,0,0,d,e,0,0);j=h;h=v[l+264>>2];vf(l+240|0,i,j,0,0,0-h|0,0-(v[l+268>>2]+((h|0)!=0)|0)|0,0,0);h=v[l+248>>2];i=h<<1|v[l+244>>2]>>>31;h=v[l+252>>2]<<1|h>>>31;vf(l+224|0,i,h,0,0,d,e,0,0);j=h;h=v[l+232>>2];vf(l+208|0,i,j,0,0,0-h|0,0-(v[l+236>>2]+((h|0)!=0)|0)|0,0,0);h=v[l+216>>2];i=h<<1|v[l+212>>2]>>>31;h=v[l+220>>2]<<1|h>>>31;vf(l+192|0,i,h,0,0,d,e,0,0);e=h;h=v[l+200>>2];vf(l+176|0,i,e,0,0,0-h|0,0-(v[l+204>>2]+((h|0)!=0)|0)|0,0,0);i=d;h=v[l+184>>2];d=h<<1|v[l+180>>2]>>>31;e=d-1|0;h=(v[l+188>>2]<<1|h>>>31)-!d|0;vf(l+160|0,i,k,0,0,e,h,0,0);d=f;j=g<<15|d>>>17;vf(l+144|0,d<<15,j,0,0,e,h,0,0);k=v[l+172>>2];m=v[l+160>>2];D=v[l+152>>2];d=m+D|0;i=v[l+164>>2];j=i+v[l+156>>2]|0;j=d>>>0<D>>>0?j+1|0:j;m=(i|0)==(j|0)&d>>>0<m>>>0|i>>>0>j>>>0;i=m+v[l+168>>2]|0;k=i>>>0<m>>>0?k+1|0:k;m=!j&d>>>0>1|(j|0)!=0;i=m+i|0;k=i>>>0<m>>>0?k+1|0:k;vf(l+112|0,e,h,0,0,0-i|0,0-(((i|0)!=0)+k|0)|0,0,0);vf(l+128|0,1-d|0,0-((d>>>0>1)+j|0)|0,0,0,e,h,0,0);J=(A-z|0)+n|0;e=v[l+116>>2];x=e;d=v[l+112>>2];j=e<<1|d>>>31;m=d<<1;n=j;d=j;h=v[l+140>>2];u=h;e=v[l+136>>2];j=h<<1|e>>>31;i=e<<1|v[l+132>>2]>>>31;h=i+m|0;j=d+j|0;j=h>>>0<i>>>0?j+1|0:j;i=h;e=j;j=j-(h>>>0<13927)|0;r=j;k=q|65536;M=k;D=p;j=p;k=k<<1|j>>>31;p=j<<1|c>>>31;d=0;j=d|k;q=j;w=Jka(r,d,j,0);d=nb;t=d;j=b;d=c<<1|j>>>31;z=j<<1;A=d;h=h-13927|0;j=(e|0)==(r|0)&h>>>0<i>>>0|e>>>0>r>>>0;e=(e|0)==(n|0)&i>>>0<m>>>0|e>>>0<n>>>0;d=v[l+120>>2];k=v[l+124>>2]<<1|d>>>31;i=d<<1;m=j;n=e;e=u>>>31|0;d=e+(x>>>31|i)|0;j=k;j=d>>>0<e>>>0?j+1|0:j;e=d;d=n+d|0;j=d>>>0<e>>>0?j+1|0:j;e=d;d=m+d|0;k=d>>>0<e>>>0?j+1|0:j;e=d;d=d-1|0;F=k-!e|0;G=0;i=Jka(A,o,F,G);e=i+w|0;k=nb+t|0;k=e>>>0<i>>>0?k+1|0:k;m=(k|0)==(t|0)&e>>>0<w>>>0|k>>>0<t>>>0;w=d;i=Jka(d,0,p,0);d=i+e|0;j=nb+k|0;j=d>>>0<i>>>0?j+1|0:j;n=d;i=j;e=(j|0)==(k|0)&d>>>0<e>>>0|j>>>0<k>>>0;d=m+e|0;k=0;k=d>>>0<e>>>0?1:k;e=Jka(q,o,F,G);d=e+d|0;j=nb+k|0;u=d;d=d>>>0<e>>>0?j+1|0:j;m=Jka(q,o,w,o);k=nb;x=Jka(F,G,p,o);e=x+m|0;j=nb+k|0;j=e>>>0<x>>>0?j+1|0:j;x=e;e=j;j=(k|0)==(j|0)&m>>>0>x>>>0|j>>>0<k>>>0;m=u+e|0;d=d+j|0;j=m;m=j>>>0<e>>>0?d+1|0:d;u=j;e=0;d=e+n|0;j=i+x|0;j=d>>>0<e>>>0?j+1|0:j;e=j;k=(j|0)==(i|0)&d>>>0<n>>>0|i>>>0>j>>>0;i=u+k|0;j=m;u=i;i=i>>>0<k>>>0?j+1|0:j;n=d;m=e;x=h;h=Jka(h,0,p,o);e=nb;t=Jka(r,o,A,o);d=t+h|0;j=nb+e|0;j=d>>>0<t>>>0?j+1|0:j;e=(e|0)==(j|0)&d>>>0<h>>>0|e>>>0>j>>>0;h=j;H=u;t=e;I=z&-2;k=Jka(w,o,I,0);e=k+d|0;j=nb+j|0;j=e>>>0<k>>>0?j+1|0:j;u=e;k=e;e=j;h=(j|0)==(h|0)&d>>>0>k>>>0|h>>>0>j>>>0;d=t+h|0;k=0;k=d>>>0<h>>>0?1:k;j=d;h=n+d|0;d=k+m|0;d=h>>>0<j>>>0?d+1|0:d;t=h;j=h;h=d;k=(d|0)==(m|0)&j>>>0<n>>>0|d>>>0<m>>>0;d=H+k|0;j=i;N=d;n=d>>>0<k>>>0?j+1|0:j;K=Jka(q,o,x,o);H=nb;i=Jka(F,G,I,o);d=i+K|0;j=nb+H|0;j=d>>>0<i>>>0?j+1|0:j;F=d;k=Jka(r,o,p,o);i=d+k|0;m=j;d=j+nb|0;d=i>>>0<k>>>0?d+1|0:d;L=i;j=Jka(A,o,w,o);i=i+j|0;k=nb+d|0;G=i;k=i>>>0<j>>>0?k+1|0:k;i=k;w=0;O=(d|0)==(k|0)&G>>>0<L>>>0|d>>>0>k>>>0;j=(d|0)==(m|0)&F>>>0>L>>>0|d>>>0<m>>>0;d=j+((m|0)==(H|0)&F>>>0<K>>>0|m>>>0<H>>>0)|0;k=0;d=O+d|0;m=i|0;k=m+t|0;j=(d|w)+h|0;w=k;d=k;j=d>>>0<m>>>0?j+1|0:j;m=j;h=(h|0)==(j|0)&d>>>0<t>>>0|h>>>0>j>>>0;d=h+N|0;j=n;H=d;h=d>>>0<h>>>0?j+1|0:j;t=Jka(r,o,I,o);r=nb;k=Jka(A,o,x,o);d=k+t|0;j=nb+r|0;j=d>>>0<k>>>0?j+1|0:j;n=0;k=(j|0)==(r|0)&d>>>0<t>>>0|j>>>0<r>>>0;r=j;d=j+u|0;j=(k|n)+e|0;n=d;j=d>>>0<r>>>0?j+1|0:j;u=(e|0)==(j|0)&d>>>0<u>>>0|e>>>0>j>>>0;i=0;e=i+d|0;d=j;k=G+d|0;k=e>>>0<i>>>0?k+1|0:k;e=(d|0)==(k|0)&e>>>0<n>>>0|d>>>0>k>>>0;d=u+e|0;j=0;j=d>>>0<e>>>0?1:j;e=d;d=d+w|0;j=j+m|0;j=d>>>0<e>>>0?j+1|0:j;e=j;j=(m|0)==(j|0)&d>>>0<w>>>0|j>>>0<m>>>0;i=j+H|0;k=h;h=i;k=h>>>0<j>>>0?k+1|0:k;i=k;c:{if((k|0)==131071|k>>>0<131071){vf(l+80|0,d,e,h,i,f,g,C,B);j=b<<17;b=0;c=v[l+88>>2];n=b-c|0;k=v[l+80>>2];m=v[l+84>>2];D=(k|m)!=0;r=n-D|0;n=(j-(v[l+92>>2]+(b>>>0<c>>>0)|0)|0)-(n>>>0<D>>>0)|0;b=k;k=0-k|0;m=0-(((b|0)!=0)+m|0)|0;b=J+16382|0;break c}k=h<<31;d=(e&1)<<31|d>>>1;e=e>>>1|k;h=(i&1)<<31|h>>>1;i=i>>>1|0;vf(l+96|0,d,e,h,i,f,g,C,B);q=0;m=v[l+104>>2];n=q-m|0;k=v[l+96>>2];p=v[l+100>>2];z=(k|p)!=0;r=n-z|0;n=((b<<16)-(v[l+108>>2]+(m>>>0>q>>>0)|0)|0)-(n>>>0<z>>>0)|0;j=k;k=0-j|0;m=0-(((j|0)!=0)+p|0)|0;z=b;A=c;p=D;q=M;b=J+16383|0}if((b|0)>=32767){s=s|2147418112;b=0;c=0;break a}d:{if((b|0)>0){c=r;j=n<<1|c>>>31;r=c<<1|m>>>31;n=j;p=h;q=i&65535|b<<16;j=m<<1|k>>>31;b=k<<1;break d}if((b|0)<=-113){b=0;c=0;break a}Em(l- -64|0,d,e,h,i,1-b|0);Kf(l+48|0,z,A,p,q,b+112|0);d=v[l+64>>2];e=v[l+68>>2];p=v[l+72>>2];q=v[l+76>>2];vf(l+32|0,f,g,C,B,d,e,p,q);c=v[l+40>>2];i=c<<1;c=v[l+44>>2]<<1|c>>>31;b=v[l+56>>2];h=v[l+36>>2];n=h>>>31|i;i=b-n|0;n=v[l+60>>2]-((b>>>0<n>>>0)+c|0)|0;c=v[l+32>>2];k=h<<1|c>>>31;c=c<<1;j=v[l+52>>2];b=v[l+48>>2];h=(k|0)==(j|0)&c>>>0>b>>>0|j>>>0<k>>>0;r=i-h|0;n=n-(h>>>0>i>>>0)|0;h=b;b=h-c|0;j=j-((c>>>0>h>>>0)+k|0)|0}vf(l+16|0,f,g,C,B,3,0,0,0);vf(l,f,g,C,B,5,0,0,0);h=d;m=p;p=d&1;c=b+p|0;d=0;k=j+d|0;k=b>>>0>c>>>0?k+1|0:k;i=c;c=k;g=(k|0)==(g|0)&i>>>0>f>>>0|g>>>0<k>>>0;d=(d|0)==(k|0)&i>>>0<p>>>0|d>>>0>k>>>0;b=d+r|0;j=n;j=b>>>0<d>>>0?j+1|0:j;f=b;d=b;b=j;g=(d|0)==(C|0)&(j|0)==(B|0)?g:(B|0)==(j|0)&d>>>0>C>>>0|j>>>0>B>>>0;d=h+g|0;k=e;k=d>>>0<g>>>0?k+1|0:k;g=(e|0)==(k|0)&d>>>0<h>>>0|e>>>0>k>>>0;e=m+g|0;j=q;j=e>>>0<g>>>0?j+1|0:j;g=e;e=d;m=g;d=v[l+20>>2];h=(d|0)==(c|0)&y[l+16>>2]<i>>>0|c>>>0>d>>>0;d=v[l+28>>2];g=v[l+24>>2];h=j>>>0<2147418112&((f|0)==(g|0)&(b|0)==(d|0)?h:(d|0)==(b|0)&g>>>0<f>>>0|b>>>0>d>>>0);g=e+h|0;d=k;d=g>>>0<h>>>0?d+1|0:d;h=(d|0)==(k|0)&e>>>0>g>>>0|d>>>0<k>>>0;e=m+h|0;k=e>>>0<h>>>0?j+1|0:j;h=e;e=v[l+4>>2];i=(e|0)==(c|0)&y[l>>2]<i>>>0|c>>>0>e>>>0;c=v[l+12>>2];e=v[l+8>>2];c=k>>>0<2147418112&((e|0)==(f|0)&(b|0)==(c|0)?i:(c|0)==(b|0)&e>>>0<f>>>0|b>>>0>c>>>0);b=c+g|0;j=b>>>0<c>>>0?d+1|0:d;c=j;f=(d|0)==(j|0)&b>>>0<g>>>0|d>>>0>j>>>0;e=h+f|0;d=k;o=e|o;s=s|(e>>>0<f>>>0?d+1|0:d)}v[a>>2]=b;v[a+4>>2]=c;v[a+8>>2]=o;v[a+12>>2]=s;kb=l+336|0}function eka(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,y=0,z=0,A=0,C=0,D=0,E=0,F=0,G=0,H=0;e=kb+-64|0;kb=e;zc(a);a:{b:{if(b>>>0<=2){G=e,H=Me(a),t[G+56|0]=H;$b(a,2);G=e,H=Rg(a),u[G+58>>1]=H;G=e,H=Bg(a),v[G+60>>2]=H;break b}yo(a,e+56|0);if(b>>>0>5){break a}}t[e+57|0]=0}c:{m=d+484344|0;A=Ed(x[e+58>>1],1,1024);l=DB(m,A);if((l|0)==65535){break c}b=_b(v[d+484344>>2],l);g=Cf(v[b>>2],v[v[b+48>>2]+12>>2],0);f=x[d+480188>>1];u[e>>1]=f-1;u[e+40>>1]=w[e+56|0];C=x[Wc(e,e+40|0)>>1];j=C+1|0;b=j&65535;f=b>>>0<f>>>0?f:b;while(1)if((b|0)==(f|0)){t[c+13|0]=w[e+57|0]>>>4;b=w[c+12|0];t[e|0]=0;b=(b|0)!=0;p=Qm(e+40|0,j,e);D=d+480188|0;d:while(1){if((k|0)==(A|0)){ic(p);break c}e:{d=Lb(v[p>>2],0);f=w[d|0];f:{g:{if(!f){v[23540]=0;d=S(206,a|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break e}d=d<<24>>24;if((d|0)<0){v[23540]=0;f=S(206,a|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break e}G=Lb(v[p>>2],0),H=f,t[G|0]=H}t[e|0]=0;h:{i:{d=d&63;if(!d){break i}v[23540]=0;j=S(206,a|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break h}t[e|0]=j;j:{k:{switch(d-1|0){case 0:t[c+12|0]=0;t[e+36|0]=1;G=c,H=w[jf(e+36|0,e)|0],t[G+14|0]=H;t[c+15|0]=0;break j;case 1:if(!j){break i}t[c+15|0]=j;t[c+12|0]=1;b=w[c+13|0];if(!b){break j}t[c+14|0]=B(B(b,j),15);break j;case 2:t[c+13|0]=j>>>4;if(j>>>0>=16){b=w[c+12|0];j=0;v[e+36>>2]=0;v[e+32>>2]=0;n=0;if(!b){break f}break g}j=0;t[c+12|0]=0;v[e+36>>2]=0;v[e+32>>2]=0;n=0;if(!(b&1)){break f}break g;case 3:n=0;v[e+36>>2]=0;v[e+32>>2]=0;if(b&1){break g}break f;case 5:if(!j){break i}d=(w[c+12|0]?15:14)+c|0;b=w[d|0];t[d|0]=b>>>0<256-j>>>0?b+j|0:-1;break j;case 6:break k;default:break i}}if(!j){break i}d=(w[c+12|0]?15:14)+c|0;b=w[d|0];t[d|0]=b>>>0>j+1>>>0?b-j|0:1}j=0;v[e+36>>2]=0;v[e+32>>2]=0;break g}j=0;v[e+36>>2]=0;v[e+32>>2]=0;n=0;if(!(b&1)){break f}break g}break e}t[d|0]=f-1;j=0;v[e+36>>2]=0;v[e+32>>2]=0;n=0;if(!(b&1)){break f}}b=w[c+13|0];d=w[c+12|0];if(d){n=0;if(!b){break f}}l:{if(d){v[e>>2]=1;v[e+24>>2]=B(b,w[c+15|0])<<1;d=v[Pe(e,e+24|0)>>2];break l}d=B(w[c+14|0],30)+30|0}b=255;h=0;while(1){m:{if(!b){b=0;break m}f=B(b,d);h=(f|0)/48|0;if(f-1536>>>0<10752){break m}b=b-1|0;continue}break}v[e+36>>2]=b;v[e+32>>2]=h;oe(e+32|0,32,255);n=1;v[e>>2]=1;G=c,H=v[Pe(e,e+36|0)>>2],t[G+16|0]=H}s=k-1|0;y=1;b=_b(v[m>>2],l);b=jd(v[b>>2],v[v[b+48>>2]+12>>2],k,1);while(1){g=y&65535;if(g>>>0>C>>>0){if(n){ze(_b(v[m>>2],l),Gh(xo(Ue(Oe(e,17,w[e+32|0]),k),0)));ze(_b(v[m>>2],l),Gh(Ue(Oe(e,16,w[e+36|0]),k)))}if(j&240){ze(_b(v[m>>2],l),$U(Ue(Oe(e,20,j>>>4|224),k)))}b=j&15;if(b){ze(_b(v[m>>2],l),$U(Ue(Oe(e,20,Ed((B(b,w[c+16|0])>>>0)/15&255,1,15)|96),k)))}k=k+1|0;b=0;continue d}n:{o:{p:{q:{r:{d=Lb(v[p>>2],g);f=w[d|0];if(!f){v[23540]=0;h=S(206,a|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break e}if(h&128){v[23540]=0;d=S(206,a|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break e}G=Lb(v[p>>2],g),H=d,t[G|0]=H}E=1;if(h&64){v[23540]=0;d=S(206,a|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break e}t[b+1|0]=d;E=!d}if(!(h&32)){f=w[b|0];break r}v[23540]=0;f=S(206,a|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break e}t[b|0]=f;if((f-1&255)>>>0<=107){d=Mm(f+24|0);t[b|0]=d;G=Id(v[c>>2],g),H=d,t[G+1|0]=H;f=w[b|0];break o}if((f+127&255)>>>0<=107){d=Mm((f&127)+24|0);G=Id(v[c>>2],g),H=d,t[G|0]=H;t[b|0]=0;break q}if((f|0)!=255){break r}f=254;break p}t[d|0]=f-1;break n}if(f&255){break o}}if(!w[b+1|0]){f=0;break o}f=w[Id(v[c>>2],g)+1|0];t[b+1|0]=0}t[b|0]=f}if($c(f)){G=Id(v[c>>2],g),H=0,t[G+5|0]=H}t[e+23|0]=0;t[e+22|0]=0;if(h&16){t[b+2|0]=1;v[23540]=0;d=S(206,a|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break e}t[b+4|0]=d+2>>>2}f=0;q=0;o=0;s:{if(!(h&8)){break s}v[23540]=0;d=S(206,a|0)|0;i=v[23540];v[23540]=0;if((i|0)==1){break e}v[23540]=0;o=S(206,a|0)|0;i=v[23540];v[23540]=0;if((i|0)==1){break e}t:{switch(d-1|0){case 0:t[b|0]=254;break s;case 1:t[b|0]=255;break s;case 2:d=Id(v[c>>2],g);t[b|0]=w[d+1|0];t[d+5|0]=0;break s;case 3:d=Du(o,w[c+16|0]);o=d?d|-48:0;q=d?20:0;if(w[b|0]){break s}d=Id(v[c>>2],g);t[b|0]=w[d+1|0];t[d+5|0]=0;break s;case 4:t[e|0]=1;G=e,H=Du(o,w[c+16|0]),t[G+24|0]=H;o=w[jf(e,e+24|0)|0];G=Id(v[c>>2],g),H=0,t[G+5|0]=H;q=15;break s;case 5:case 6:case 7:case 8:u:{if(!k){break u}if((d|0)==w[Id(v[c>>2],g)+4|0]){break u}if(!ze(_b(v[m>>2],l),Nm(xo(Ue(Oe(e,20,(d+122|160)&255),s),g)))){break u}G=Id(v[c>>2],g),H=d,t[G+4|0]=H}d=Id(v[c>>2],g);if(!w[b|0]){t[b|0]=w[d+1|0]}t[d+5|0]=0;q=10;break s;case 9:break t;default:break s}}i=Id(v[c>>2],g);d=w[i+5|0];t[i+5|0]=d^1;o=d?-98:-97;q=20}v:{w:{x:{if(!(h&4)){break x}v[23540]=0;i=S(206,a|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break e}v[23540]=0;d=S(206,a|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break e}t[e+23|0]=d;F=1;f=1;y:{switch(i-1|0){case 0:CB(e,d<<24>>24<<3,128);d=w[b|0];if($c(d)){G=b,H=Mm(d+v[e>>2]|0),t[G|0]=H}t[e+23|0]=w[e+4|0]^128;f=35;break x;case 1:d=Du(d,w[c+16|0]);t[e+23|0]=d;if(!d){break w}t[e+23|0]=d|208;f=20;break v;case 3:case 4:G=e,H=_U(d,w[c+16|0],1),t[G+23|0]=H;f=(i|0)==4?2:3;break v;case 5:if(!w[b|0]){G=b,H=w[Id(v[c>>2],g)|0],t[G|0]=H;d=w[e+23|0]}G=e,H=_U(d&255,w[c+16|0],0),t[G+23|0]=H;f=4;break v;case 6:G=b,H=Mm(d+25|0),t[G|0]=H;t[e+23|0]=255;f=4;break v;case 7:case 8:case 9:z:{if(!k){break z}if((i|0)==w[Id(v[c>>2],g)+2|0]){break z}if(!ze(_b(v[m>>2],l),Nm(xo(Ue(Oe(e,20,(i-8|48)&255),s),g)))){break z}G=Id(v[c>>2],g),H=i,t[G+2|0]=H}G=e,H=AB(w[e+23|0],w[c+16|0]),t[G+23|0]=H;f=5;break v;case 10:G=e,H=ZU(d,w[c+16|0]),t[G+23|0]=H;f=18;break v;case 11:d=Du(d,w[c+16|0]);t[e+23|0]=d;if(d){t[e+23|0]=d|192;f=20;break v}t[b|0]=254;break w;case 2:break v;default:break y}}f=0}F=0;break v}f=0}i=0;z=1;A:{if(h&2){v[23540]=0;d=S(206,a|0)|0;h=v[23540];v[23540]=0;if((h|0)==1){break e}v[23540]=0;r=S(206,a|0)|0;h=v[23540];v[23540]=0;if((h|0)==1){break e}t[e+22|0]=r;i=9;z=0;h=0;B:{switch(d-1|0){case 0:case 1:h=1;G=e,H=YU(r,w[c+16|0],(d|0)==1),t[G+22|0]=H;i=11;break A;case 2:G=e,H=ZU(r,w[c+16|0]),t[G+22|0]=H;h=1;i=18;break A;case 3:case 4:case 5:C:{if(!k){break C}if((d|0)==w[Id(v[c>>2],g)+3|0]){break C}if(!ze(_b(v[m>>2],l),Nm(xo(Ue(Oe(e,20,(d-4|64)&255),s),g)))){break C}G=Id(v[c>>2],g),H=d,t[G+3|0]=H}G=e,H=AB(r,w[c+16|0]),t[G+22|0]=H;h=1;i=8;break A;case 7:case 8:G=e,H=YU(r,w[c+16|0],(d|0)==8),t[G+22|0]=H;h=1;i=29;break A;case 9:G=e,H=AB(r,w[c+16|0]),t[G+22|0]=H;h=1;i=27;break A;case 6:break A;default:break B}}z=1;i=0}h=0}if(F){XU(b,k,x[D>>1],f,e+23|0)}if(h){XU(b,k,x[D>>1],i,e+22|0)}D:{E:{F:{G:{H:{if(!E){break H}if(!$c(w[b|0])){break H}if(!f){break G}if(!z|(f|0)==4){break H}t[e+22|0]=255;i=4}d=b+2|0;if(w[b+2|0]!=1){break D}if(f){break F}t[e+23|0]=w[b+4|0];f=13;break E}t[e+23|0]=255;d=b+2|0;f=4;if(w[b+2|0]!=1){break D}}if(i){break D}t[e+22|0]=w[b+4|0];i=13}t[d|0]=0}g=ug(e);Co(e+24|0,g,f,w[e+23|0],i,w[e+22|0]);I:{if(w[d|0]){break I}f=w[e+2|0];if(!f){break I}t[b+2|0]=f;t[b+4|0]=w[e+4|0]}h=w[e+3|0];J:{if(q){Co(e+24|0,g,h&255,w[e+5|0],q,o&255);K:{if(w[d|0]){break K}d=w[e+2|0];if(!d){break K}t[b+2|0]=d;t[b+4|0]=w[e+4|0]}h=w[e+3|0];break J}if(!(h&255)){break n}}t[b+3|0]=h;t[b+5|0]=w[e+5|0]}b=b+6|0;y=y+1|0;continue}}break}a=P()|0;O()|0;ic(p);T(a|0);L()}else{t[g+B(b,6)|0]=254;b=b+1|0;continue}}kb=e- -64|0;return l|0}function ika(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=kb-304|0;kb=e;zc(b);a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{if(!cV(b,e+232|0)){break p}if(!dV(e+232|0)){break p}if(!c){d=1;break p}Cd(a,131072);d=kb-16|0;kb=d;i=e+136|0;f=yc(d,3913);ad(i,f);Ab(f);kb=d+16|0;v[23540]=0;U(305,e+184|0,i|0,e+232|4);d=v[23540];v[23540]=0;q:{if((d|0)!=1){d=e+184|0;Jb(a+1298344|0,d);Ab(d);i=e+136|0;dc(i);f=yc(d,11135);Jb(a+1298356|0,f);Ab(f);v[a+1298404>>2]=5;OB(i,3,e+245|0);Fc(d,i);Bc(a+1298308|0,d);zb(d);f=e+112|0;Dj(f,3,e+275|0);Fc(i,f);v[23540]=0;U(11,d|0,5,i|0);d=v[23540];v[23540]=0;if((d|0)==1){break b}d=e+184|0;Jb(a+1298320|0,d);Ab(d);zb(e+136|0);d=zo(d);o=d,p=Ed(w[e+295|0],1,31),v[o+12>>2]=p;o=d,p=Ed(w[e+296|0],1,12)-1|0,v[o+16>>2]=p;v[d+20>>2]=w[e+297|0];i=a+1298408|0;Lc(i);GB(i,d);g=e+144|0;i=Tb(e+168|0);r:{s:{t:{while(1){d=v[b+8>>2];f=v[b>>2];v[23540]=0;d=W(156,f|0,d|0,8)|0;f=v[23540];v[23540]=0;u:{v:{w:{x:{y:{if((f|0)!=1){if(!d){break r}v[23540]=0;R(306,b|0,e+72|0);d=v[23540];v[23540]=0;if((d|0)==1){break y}d=v[e+76>>2];z:{l=w[e+236|0];switch(l-3|0){case 1:break x;case 0:break z;default:break w}}f=2;if(v[e+72>>2]!=1431389523){break v}break u}b=P()|0;O()|0;break c}b=P()|0;O()|0;break c}f=4;if(v[e+72>>2]!=1431389523){break v}break u}f=0;if(l>>>0>7){break u}}d=v[e+72>>2]==1146113363?-1:d;f=0}l=v[e+76>>2];v[e+136>>2]=v[e+72>>2];v[e+140>>2]=l;v[23540]=0;U(190,e+112|0,b|0,d|0);d=v[23540];v[23540]=0;if((d|0)==1){break t}kc(g,e+112|0);v[23540]=0;R(307,i|0,e+136|0);d=v[23540];v[23540]=0;if((d|0)==1){break s}Bd(e+136|0);Bb(e+112|0);v[23540]=0;Q(188,b|0,f|0)|0;d=v[23540];v[23540]=0;if((d|0)!=1){continue}break}b=P()|0;O()|0;break c}b=P()|0;O()|0;break c}b=P()|0;O()|0;Bd(e+136|0);Bb(e+112|0);break c}v[23540]=0;l=S(174,e+136|0)|0;b=v[23540];v[23540]=0;A:{B:{C:{if((b|0)!=1){v[23540]=0;U(308,e+112|0,i|0,1431389523);b=v[23540];v[23540]=0;if((b|0)==1){break C}d=e+112|0;b=hd(l,d);Bb(d);u[e+110>>1]=0;u[e+108>>1]=65534;if(w[e+236|0]<3){break A}v[23540]=0;d=S(194,b|0)|0;f=v[23540];v[23540]=0;if((f|0)!=1){break B}break e}b=P()|0;O()|0;break c}b=P()|0;O()|0;break d}u[e+110>>1]=d;if(w[e+236|0]<4){break A}v[23540]=0;d=S(194,b|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break e}u[e+108>>1]=w[e+236|0]==4?d?d:-2:d}d=w[a+484376|0];f=v[a+484360>>2];v[23540]=0;g=S(202,b|0)|0;h=v[23540];v[23540]=0;if((h|0)==1){break e}v[23540]=0;U(238,Wb(f,d)|0,b|0,g>>>1|0);d=v[23540];v[23540]=0;if((d|0)==1){break e}d=Wb(v[a+484360>>2],w[a+484376|0]);d=FB(v[d>>2],v[d+4>>2]);Ef(e+110|0,d);Ef(e+108|0,d);v[23540]=0;U(308,e+112|0,i|0,1414807888);d=v[23540];v[23540]=0;if((d|0)==1){break h}d=e+112|0;b=hd(b,d);Bb(d);d=v[b>>2];v[23540]=0;d=S(178,d|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break e}if(!(c&1)|d^1){break q}v[23540]=0;R(309,b|0,e+8|0);d=v[23540];v[23540]=0;if((d|0)==1){break i}o=a+480188|0,p=Ed(w[e+10|0],1,32)+1|0,u[o>>1]=p;v[23540]=0;d=Q(218,e+96|0,x[e+8>>1])|0;f=v[23540];v[23540]=0;if((f|0)==1){break j}o=e,p=Fb(v[d>>2]),v[o+48>>2]=p;g=Fb(v[d+4>>2]);D:{E:{while(1){h=v[e+48>>2];if(!Pb(h,g)){f=x[a+480188>>1];v[23540]=0;f=Q(310,e+112|0,f|0)|0;g=v[23540];v[23540]=0;if((g|0)!=1){g=a+484376|0;h=Wb(v[a+484360>>2],w[g|0]);h=Bl(v[h>>2],v[h+4>>2]);v[23540]=0;k=a+484344|0;R(225,k|0,h|0);h=v[23540];v[23540]=0;if((h|0)==1){break g}g=Wb(v[a+484360>>2],w[g|0]);o=e,p=Fb(v[g>>2]),v[o+72>>2]=p;h=Fb(v[g+4>>2]);F:{while(1){G:{g=v[e+72>>2];if(!Pb(g,h)){g=w[a+484376|0];h=v[a+484360>>2];v[23540]=0;j=Wb(h,g);h=x[e+108>>1];g=Q(311,j|0,h|0)|0;j=v[23540];v[23540]=0;if((j|0)!=1){break G}break g}j=v[d>>2];n=Bf(j,v[d+4>>2]);m=x[g>>1];if(n>>>0>m>>>0){v[23540]=0;j=fa(312,Ng(j,m)|0,w[e+236|0],f|0,a|0)|0;m=v[23540];v[23540]=0;if((m|0)==1){break F}u[g>>1]=j}Se(e+72|0);continue}break}H:{if(!g){break H}g=Wb(v[a+484360>>2],w[a+484376|0]);j=x[e+110>>1];if(!j){if(FB(v[g>>2],v[g+4>>2])>>>0<=h>>>0){break H}}g=_b(v[k>>2],x[cc(v[g>>2],h)>>1]);ze(g,Nm(Ue(Oe(e+72|0,12,j&255),v[g+12>>2]-1|0)))}vk(f);Vc(d);break q}break g}b=P()|0;O()|0;break f}v[23540]=0;f=w[e+236|0]<3?9:8;Q(188,b|0,f-4|0)|0;k=v[23540];v[23540]=0;if((k|0)!=1){v[23540]=0;k=S(157,b|0)|0;j=v[23540];v[23540]=0;if((j|0)==1){break E}yg(b,f);v[23540]=0;U(190,e+72|0,b|0,f+k|0);f=v[23540];v[23540]=0;if((f|0)==1){break D}j=h;f=e+72|0;h=kc(e+112|0,f);hd(j,h);Bb(h);Bb(f);Nf(e+48|0);continue}break}b=P()|0;O()|0;break f}b=P()|0;O()|0;break f}b=P()|0;O()|0;break f}b=P()|0;O()|0;dc(e+136|0);break a}v[23540]=0;U(308,e+72|0,i|0,1196641603);d=v[23540];v[23540]=0;if((d|0)==1){break n}d=e+72|0;b=hd(b,d);Bb(d);d=v[b>>2];v[23540]=0;d=S(178,d|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break e}if(d){v[23540]=0;Q(188,b|0,1)|0;d=v[23540];v[23540]=0;if((d|0)==1){break e}v[23540]=0;d=S(202,b|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break e}v[23540]=0;da(313,a+1298332|0,b|0,d|0,40,0);d=v[23540];v[23540]=0;if((d|0)==1){break e}}v[23540]=0;U(308,e+72|0,i|0,1146113363);d=v[23540];v[23540]=0;if((d|0)==1){break k}v[23540]=0;U(308,e+48|0,i|0,1229999443);d=v[23540];v[23540]=0;if((d|0)==1){break o}d=e+48|0;b=hd(b,d);Bb(d);v[23540]=0;d=S(206,b|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break m}h=a+480190|0;u[h>>1]=d;k=!(c&2);f=1;I:{while(1){J:{c=f&65535;if(c>>>0>(d&65535)>>>0){break I}d=30;K:{L:{M:{if(w[e+236|0]>=2){v[23540]=0;d=S(206,b|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break M}}v[23540]=0;U(314,b|0,((c<<5)+a|0)+946304|0,d|0);d=v[23540];v[23540]=0;if((d|0)==1){break M}v[23540]=0;R(315,b|0,e+32|0);d=v[23540];v[23540]=0;if((d|0)==1){break L}v[23540]=0;g=B(c,104)+a|0;j=g+484380|0;R(316,e+32|0,j|0);c=v[23540];v[23540]=0;if((c|0)==1){break L}d=w[e+236|0];if(d>>>0>=8){v[23540]=0;R(317,b|0,g+484423|0);c=v[23540];v[23540]=0;if((c|0)==1){break L}d=w[e+236|0]}v[23540]=0;Q(188,b|0,((d&255)>>>0>1?6:2)|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break L}v[23540]=0;c=S(157,e+72|0)|0;d=v[23540];v[23540]=0;if((d|0)!=1){v[23540]=0;U(190,e+8|0,e+72|0,c|0);c=v[23540];v[23540]=0;if((c|0)!=1){break K}}b=P()|0;O()|0;break l}b=P()|0;O()|0;break l}b=P()|0;O()|0;break l}d=e+8|0;c=kc(e+48|0,d);Bb(d);d=v[c>>2];v[23540]=0;d=S(178,d|0)|0;m=v[23540];v[23540]=0;if((m|0)!=1){N:{if(k|d^1){break N}d=Zc(e+8|0,u[g+484414>>1]&1?16:8,1,0,(w[e+47|0]&12)==4?7:0);v[23540]=0;W(219,d|0,j|0,c|0)|0;d=v[23540];v[23540]=0;if((d|0)!=1){break N}break J}Bb(c);f=f+1|0;d=x[h>>1];continue}}break}b=P()|0;O()|0;Bb(c);break l}ag(a);v[a+480204>>2]=12e5;v[a+480208>>2]=24;v[a+480196>>2]=6;v[a+480200>>2]=256;v[a+480228>>2]=48;v[a+480232>>2]=48;v[23540]=0;d=1;W(264,a+1074312|0,114,1)|0;a=v[23540];v[23540]=0;if((a|0)==1){break m}Bb(e+72|0);Bb(b);Zd(i)}kb=e+304|0;return d|0}b=P()|0;O()|0;break l}b=P()|0;O()|0;break d}b=P()|0;O()|0}Bb(e+72|0);break d}b=P()|0;O()|0;break d}b=P()|0;O()|0;break d}b=P()|0;O()|0;break d}b=P()|0;O()|0;break d}b=P()|0;O()|0;vk(f)}Vc(d);break d}b=P()|0;O()|0}Bb(l)}Zd(i);break a}b=P()|0;O()|0;zb(e+136|0)}T(b|0);L()}function cga(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,y=0,z=0,A=0,C=0,D=0,E=0;d=kb-1344|0;kb=d;zc(b);f=kb-16|0;kb=f;GR(f+8|0,d+232|0);e=v[f+12>>2];nc(f,v[b>>2],v[b+8>>2],v[f+8>>2],v[f+12>>2]);j=v[f+4>>2];if((j|0)==(e|0)){$b(b,v[f+12>>2])}kb=f+16|0;a:{if((e|0)!=(j|0)){break a}if(!IR(d+232|0)){break a}if(!Qb(v[b>>2],v[b+8>>2],Ec(HR(v[d+1336>>2]),nb))){break a}if(!c){m=1;break a}zc(b);b=je(d+232|0,b);v[23540]=0;R(618,d+216|0,b|0);f=v[23540];v[23540]=0;b:{c:{d:{e:{f:{g:{h:{i:{if((f|0)!=1){Bb(b);v[23540]=0;U(619,d+200|0,d+216|0,1196314451);b=v[23540];v[23540]=0;if((b|0)==1){break i}v[23540]=0;U(619,d+184|0,d+216|0,1280331091);b=v[23540];v[23540]=0;if((b|0)==1){break h}if(pc(v[d+200>>2],v[d+204>>2])){break b}if(!pc(v[d+184>>2],v[d+188>>2])){break g}break b}c=P()|0;O()|0;Bb(b);break d}c=P()|0;O()|0;break e}c=P()|0;O()|0;break f}v[23540]=0;R(246,a|0,1);b=v[23540];v[23540]=0;j:{k:{l:{m:{n:{if((b|0)!=1){ag(a);v[a+480188>>2]=4;v[a+480208>>2]=25231360;D=d,E=Fb(v[d+184>>2]),v[D+48>>2]=E;g=c&2;m=Fb(v[d+188>>2]);f=a+480190|0;o:{p:{while(1){e=v[d+48>>2];if(!Pb(e,m)){break p}b=x[f>>1];if(!Zh(b)){break p}b=b+1|0;u[f>>1]=b;v[23540]=0;b=B(b&65535,104)+a|0;j=b+484380|0;R(277,j|0,1);i=v[23540];v[23540]=0;q:{r:{if((i|0)!=1){v[23540]=0;i=Q(620,e|0,d+232|0)|0;l=v[23540];v[23540]=0;if((l|0)==1){break r}if(!i){break c}if(Vt(d+232|0)){break q}break c}c=P()|0;O()|0;break j}c=P()|0;O()|0;break j}v[23540]=0;i=Q(55,d+168|0,d+232|0)|0;l=v[23540];v[23540]=0;if((l|0)==1){break o}Dc(((x[f>>1]<<5)+a|0)+946304|0,i);zb(i);i=v[d+268>>2];v[j>>2]=i;v[b+484388>>2]=i;v[b+484384>>2]=v[d+264>>2];i=b+484414|0;u[i>>1]=x[i>>1]|2;u[b+484410>>1]=255;s:{if(g){b=Zc(d+16|0,8,1,0,0);v[23540]=0;W(219,b|0,j|0,e|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break s}}Nf(d+48|0);continue}break}c=P()|0;O()|0;break j}D=d,E=Fb(v[d+200>>2]),v[D+160>>2]=E;q=a+484344|0;A=c&1;s=a+484360|0;C=Fb(v[d+204>>2]);l=a+484376|0;p=a+480190|0;y=a+484380|0;z=a+946304|0;c=1;m=1;while(1){t:{u:{v:{w:{x:{y:{b=v[d+160>>2];if(!Pb(b,C)){break y}if(!(c&1)){v[23540]=0;c=S(272,s|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break x}if(!c){break y}}Lc(Wb(v[a+484360>>2],w[l|0]));v[23540]=0;c=Q(621,b|0,d+232|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break w}if(!(c&!x[d+1318>>1])|v[d+1320>>2]-5>>>0<4294967292){break c}c=w[l|0];f=v[a+484360>>2];v[23540]=0;U(5,d+48|0,5,d+232|0);e=v[23540];v[23540]=0;if((e|0)==1){break k}v[23540]=0;R(273,Wb(f,c)|0,d+48|0);c=v[23540];v[23540]=0;if((c|0)==1){break l}Ab(d+48|0);z:{if(A){v[23540]=0;U(190,d+48|0,b|0,v[d+1328>>2]);b=v[23540];v[23540]=0;if((b|0)==1){break m}b=d+48|0;kc(d+136|0,b);break z}v[23540]=0;b=S(174,d+112|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break n}c=MD(d+48|0,b);kc(d+136|0,c);Bb(c)}Bb(b);Ub(d+48|0,0,64);c=1;A:{B:{C:{while(1){if((c|0)==32){break C}b=(B(c,34)+d|0)+198|0;f=b+32|0;Wm(d,f);D:{E:{if(yj(w[v[d>>2]])){break E}e=w[b- -64|0];if(e>>>0>15){break B}b=w[b+65|0];if(b>>>0>64){break B}if(!Vt(f)){break B}j=b<<2;i=e<<4;f=0;b=1;F:{while(1){g=b&65535;e=x[p>>1];if(g>>>0>e>>>0){break F}v[23540]=0;U(524,d+16|0,v[d>>2],v[d+4>>2]);e=v[23540];v[23540]=0;if((e|0)==1){break D}e=kb-16|0;kb=e;k=d+16|0;Fe(e+8|0,k);DR(e,((g<<5)+a|0)+946304|0);h=v[e+8>>2];r=v[e>>2];n=v[e+12>>2];o=v[e+4>>2];if((n|0)==(o|0)){h=(jT(h,n,r,o)|0)!=0}else{h=1}kb=e+16|0;zb(k);G:{H:{if(h){break H}D=cc(d+48|0,c),E=b,u[D>>1]=E;e=B(g,104)+a|0;g=e+484410|0;h=x[g>>1];if((h|0)==255){break G}f=b;if(w[e+484417|0]!=(i&255)){break H}if((h|0)==(j|0)){break G}}b=b+1|0;continue}break}t[e+484417|0]=i;u[g>>1]=j;break E}f=f&65535;if(!f){break E}if(!Zh(e)){break E}b=e+1|0;u[p>>1]=b;D=cc(d+48|0,c),E=b,u[D>>1]=E;b=B(x[p>>1],104)+y|0;Dm(b);e=B(f,104)+y|0;g=lo(b,e);u[b+30>>1]=j;t[b+37|0]=i;xS(g,e);f=(f<<5)+z|0;e=v[f+4>>2];b=(x[p>>1]<<5)+z|0;v[b>>2]=v[f>>2];v[b+4>>2]=e;e=v[f+28>>2];v[b+24>>2]=v[f+24>>2];v[b+28>>2]=e;e=v[f+20>>2];v[b+16>>2]=v[f+16>>2];v[b+20>>2]=e;e=v[f+12>>2];v[b+8>>2]=v[f+8>>2];v[b+12>>2]=e}c=c+1|0;continue}break}break v}i=0;v[d+40>>2]=0;v[d+32>>2]=0;v[d+36>>2]=0;v[d+24>>2]=0;v[d+28>>2]=0;v[d+16>>2]=0;v[d+20>>2]=0;e=64;j=65535;r=x[d+1320>>1];f=0;I:while(1){J:{if(f){break J}v[23540]=0;b=W(156,v[d+136>>2],v[d+144>>2],1)|0;c=v[23540];v[23540]=0;if((c|0)==1){break A}if(b){break J}b=j;break u}e=e+1|0;if(e>>>0>=64){v[23540]=0;j=Q(359,q|0,64)|0;b=v[23540];v[23540]=0;if((b|0)==1){break A}b=65535;if((j|0)==65535){break u}b=w[l|0];c=v[a+484360>>2];e=0;v[23540]=0;R(522,Wb(c,b)|0,j|0);b=v[23540];v[23540]=0;if((b|0)==1){break A}}b=0;c=_b(v[q>>2],j&65535);c=jd(v[c>>2],v[v[c+48>>2]+12>>2],e,0);while(1){if((b|0)==(r|0)){continue I}g=(d+16|0)+B(b,7)|0;h=w[g+6|0];K:{if(h){t[g+6|0]=h-1;h=w[g+4|0]|w[g+5|0]<<8;t[c+4|0]=h;t[c+5|0]=h>>>8;g=w[g|0]|w[g+1|0]<<8|(w[g+2|0]<<16|w[g+3|0]<<24);t[c|0]=g;t[c+1|0]=g>>>8;t[c+2|0]=g>>>16;t[c+3|0]=g>>>24;f=f-1|0;break K}v[23540]=0;h=W(156,v[d+136>>2],v[d+144>>2],1)|0;k=v[23540];v[23540]=0;if((k|0)==1){break v}if(!h){break K}if(v[d+144>>2]==v[d+1324>>2]){i=Wb(v[a+484360>>2],w[l|0]);Ve(i,FB(v[i>>2],v[i+4>>2]));i=e}v[23540]=0;h=S(206,d+136|0)|0;k=v[23540];v[23540]=0;L:{if((k|0)!=1){h=h<<24>>24;if((h|0)>=0){break L}h=h&127;t[g+6|0]=h;k=w[g+4|0]|w[g+5|0]<<8;t[c+4|0]=k;t[c+5|0]=k>>>8;g=w[g|0]|w[g+1|0]<<8|(w[g+2|0]<<16|w[g+3|0]<<24);t[c|0]=g;t[c+1|0]=g>>>8;t[c+2|0]=g>>>16;t[c+3|0]=g>>>24;f=f+h|0;break K}break v}if((h-1&255)>>>0<=35){t[c|0]=h+48}v[23540]=0;h=S(206,d+136|0)|0;k=v[23540];v[23540]=0;M:{N:{if((k|0)!=1){D=c,E=w[cc(d+48|0,h&31)|0],t[D+1|0]=E;if(!(h&128)){break N}t[c+3|0]=w[g+3|0];t[c+5|0]=w[g+5|0];break M}break v}v[23540]=0;R(260,d|0,d+136|0);h=v[23540];v[23540]=0;O:{if((h|0)!=1){h=w[d|0];if(h>>>0>19){break M}n=h<<1;o=w[n+27008|0];t[c+3|0]=o;k=w[Oc(d)|0];t[c+5|0]=k;if((o|0)!=16|k>>>0<32){break O}t[c+3|0]=17;break M}break v}if(819137>>>h&1){break M}t[c+5|0]=w[n+27009|0]|k&15}h=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);t[g|0]=h;t[g+1|0]=h>>>8;t[g+2|0]=h>>>16;t[g+3|0]=h>>>24;h=w[c+4|0]|w[c+5|0]<<8;t[g+4|0]=h;t[g+5|0]=h>>>8}c=c+6|0;b=b+1|0;continue}}}m=0;break t}break v}Gj(s,0);v[23540]=0;b=Q(1,d+232|0,6470)|0;c=v[23540];v[23540]=0;P:{if((c|0)!=1){Jb(a+1298344|0,b);Ab(b);v[23540]=0;b=Q(1,d+48|0,6772)|0;c=v[23540];v[23540]=0;if((c|0)==1){break P}Jb(a+1298356|0,b);Ab(b);v[a+1298404>>2]=5;m=1;break b}c=P()|0;O()|0;break j}c=P()|0;O()|0;break j}c=P()|0;O()|0;break j}c=P()|0;O()|0;break j}c=P()|0;O()|0;Bb(d+136|0);break j}Q:{if(!i&e>>>0>62){break Q}b=b&65535;if((b|0)==65535){break Q}ze(_b(v[q>>2],b),Gh(Ue(Oe(d,14,i&255),e)))}c=32}Bb(d+136|0);if(c>>>0<32){break b}Nf(d+160|0);c=0;continue}}c=P()|0;O()|0;break j}c=P()|0;O()|0;break j}c=P()|0;O()|0;break j}c=P()|0;O()|0;break j}c=P()|0;O()|0;Ab(d+48|0);break j}c=P()|0;O()|0}Vc(d+184|0)}Vc(d+200|0)}Zd(d+216|0)}T(c|0);L()}m=0}Vc(d+184|0);Vc(d+200|0);Zd(d+216|0)}kb=d+1344|0;return m|0}function Dga(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,y=0,z=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,M=0,N=0,Q=0,R=0,S=0,V=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0;d=kb-336|0;kb=d;a:{if(!dd(b,1080)){break a}if(!po(b,d+332|0)){break a}Cd(a,1);m=kS(d+312|0);if(!jS(d+332|0,m)){break a}f=x[m+10>>1];if(!f|f>>>0>127){break a}if(!c){g=1;break a}r=a+480188|0;u[r>>1]=f;p=w[m+14|0];E=w[m+13|0];h=w[m+12|0];F=1;if(!ne(d+332|0,26938)){F=ne(d+332|0,26943)}if(w[m+15|0]){Ob(a+1074312|0,5,1);f=x[a+480188>>1]}g=d+332|0;s=ne(g,16761);e=1;if(!ne(g,17525)){e=ne(d+332|0,13569)}z=(f&65535)==8&(E|0)!=0;dd(b,0);QA(b,a+1298308|0,20);u[a+480190>>1]=31;l=(h|0)!=0;q=a+480188|0;g=1;f=s;while(1)if((g|0)==32){b:{c:{d:{e:{f:{g:{N=v[m+4>>2];if(N>>>0>=G>>>0){h=d+176|0;fS(b,h);dd(b,x[m+8>>1]);g=w[d+177|0];e=128;j=a+484376|0;Kq(Wb(v[a+484360>>2],w[j|0]),h|2,128);h=!g&f;k=h?k:0;f=w[d+176|0];h:{if(f>>>0>128){break h}e=f;if(f){break h}f=v[Wb(v[a+484360>>2],w[a+484376|0])>>2];g=128;while(1){e=g;if(e>>>0<2){e=1;break h}g=e-1|0;if(!x[cc(f,g)>>1]){continue}break}}o=eS(b,Wb(v[a+484360>>2],w[j|0]),e&65535,i,r,k,0);H=1;i:{if(!(h&x[a+480188>>1]==8)){H=(p|0)!=0;break i}v[m>>2]=11252}j:{if(!z){break j}f=Wb(v[a+484360>>2],w[a+484376|0]);aa=d,ba=Fb(v[f>>2]),v[aa+160>>2]=ba;h=Fb(v[f+4>>2]);while(1){f=v[d+160>>2];if(!Pb(f,h)){break j}u[f>>1]=x[f>>1]>>>1;Se(d+160|0);continue}}f=a+484376|0;Ve(Wb(v[a+484360>>2],w[f|0]),w[d+177|0]);Q=e-1|0;e=w[d+177|0];k:{if((Q&65535)>>>0>=e>>>0){g=x[r>>1];if((e|0)!=120|(g|0)!=4){break k}}Ve(Wb(v[a+484360>>2],w[f|0]),0);g=x[a+480188>>1]}v[a+480260>>2]=56;v[a+480264>>2]=13696;v[a+480204>>2]=125e4;v[a+480196>>2]=6;k=0;v[a+480208>>2]=0;aa=a,ba=Zb(256/((g&65535)>>>0)|0,32,128),v[aa+480228>>2]=ba;oh(a,0);t[d+175|0]=0;l:{if(l&1){p=1;e=1;break l}p=1;e=0;l=0;h=s;m:while(1){n:{q=0;if(o>>>0<=(l&65535)>>>0){break n}g=0;while(1)if((g|0)==256){l=l+1|0;continue m}else{f=d+144|0;j=ug(d+160|0);Gu(f,b,j);i=Oc(f);n=iB(w[j|0]);o:{p:{q:{r:{j=w[d+144|0];if((j-7&255)>>>0<3){h=0;break r}f=w[i|0];if(!((j|0)!=14|f>>>0<=1)){h=0;break q}if(!((j|0)==15&(f&255)>>>0>31)){h=n?h:0;if((j|0)!=13){break r}q=q+1|0;if((q&65535)>>>0<2){break o}}h=0;break o}if((j|0)==8){break p}if((j|0)!=14){break o}f=w[i|0]}if((f&240)!=128){break o}t[d+80|0]=f<<4;aa=d,ba=w[jf(d+175|0,d+80|0)|0],t[aa+175|0]=ba;break o}aa=d,ba=w[jf(d+175|0,i)|0],t[aa+175|0]=ba;f=t[i|0];if((f|0)>=0){k=1;break o}e=(f|0)!=-92&f>>>0>4294967183|e}p=n&p;g=g+1|0;continue}}break}f=k^-1;k=0;k=(e|f)&1?k:w[d+175|0]>47;e=h&1}j=e;dd(b,x[m+8>>1]);e=x[a+480188>>1];n=a+484344|0;I=o+z&65535;xg(n,I);R=z?4:e;o=a+1074312|0;_=k^1;$=c&1;l=0;k=0;s:{t:{u:{while(1){if((l|0)==(I|0)){break t}v:{if(z){e=(l&65534)>>>1|0;f=l&1;if(!f){if(!ph(n,e,64)){break t}}g=_b(v[n>>2],e);e=f<<2;break v}if(!ph(n,l&65535,64)){break t}g=_b(v[n>>2],l);e=0}h=0;q=jd(v[g>>2],v[v[g+48>>2]+12>>2],0,e);if(!$){J=0;K=0;break s}e=x[r>>1];t[d+80|0]=0;f=e;e=d+80|0;C=Qm(d+160|0,f,e);f=x[r>>1];v[23540]=0;t[d+80|0]=0;D=W(577,d+144|0,f|0,e|0)|0;e=v[23540];v[23540]=0;if((e|0)!=1){M=0;w:{x:while(1){y:{if((M|0)==64){break w}g=0;f=0;S=0;while(1){if((g|0)==(R|0)){M=M+1|0;J=f&S|J;q=B(x[r>>1],6)+q|0;continue x}v[23540]=0;h=B(g,6)+q|0;U(578,d+80|0,b|0,h|0);e=v[23540];v[23540]=0;if((e|0)!=1){e=w[d+80|0];y=Oc(d+80|0);i=w[y|0];if(e|i){z:{if(!(!E|(e&255)!=14)){e=0;t[y|0]=0;t[d+80|0]=0;i=w[y|0];break z}if(!E|(e&255)!=15|(i&255)>>>0<32){break z}i=31;t[y|0]=31;e=w[d+80|0]}Pf(h,e&255,i&255)}e=1;A:{B:{C:{D:{E:{i=w[h+3|0];switch(i-14|0){case 2:break A;case 0:break D;case 3:break E;default:break C}}k=w[h+5|0]<100|k;S=1;break B}if(!j){break B}t[h+5|0]=0;break B}if(!((i|0)!=9|_)){e=w[h+5|0];if((e|0)==164){t[h+3|0]=20;t[h+5|0]=145;break B}aa=h,ba=tg(e<<1),t[aa+5|0]=ba;break B}if((i|0)!=19){break B}e=w[h+5|0];if(e>>>0>15){break B}i=e&1;e=!i;y=!i;i=V&1;V=(i|0)==(e|0)?V:y;K=((e|0)!=(i|0))+K|0}e=f}F:{if(!w[h|0]){f=w[h+1|0];if(!f|z){break F}i=w[Lb(v[C>>2],g)|0];if(!i|(f|0)==(i|0)){break F}i=Lb(v[D>>2],g);f=w[i|0]+1|0;t[i|0]=f;if((f&255)>>>0<4){break F}v[23540]=0;W(264,o|0,85,1)|0;f=v[23540];v[23540]=0;if((f|0)!=1){break F}break y}aa=Lb(v[D>>2],g),ba=0,t[aa|0]=ba}f=w[h+1|0];if(f){aa=Lb(v[C>>2],g),ba=f,t[aa|0]=ba}g=g+1|0;f=e;continue}break}}break}f=P()|0;O()|0;ic(D);break u}ic(D);ic(C);l=l+1|0;continue}break}f=P()|0;O()|0}ic(C);break b}h=k}G:{H:{I:{if((p^-1|X)&1){break I}J:{if(ne(d+332|0,16761)){break J}if(ne(d+332|0,17530)){break J}if(!ne(d+332|0,13559)){break I}}v[a+480208>>2]=v[a+480208>>2]|2162688;e=Ob(Ob(Ob(o,85,1),91,1),92,1);K:{if(w[d+175|0]>47){break K}e=Ob(e,84,1);if(w[d+177|0]==127){break K}Ob(e,83,1)}if(!(p&1)){break G}break H}if(p&1){break H}if(s^1|w[d+177|0]!=127|(Q&65535)>>>0>128){break G}v[m>>2]=8523;break G}if((K|0)>6|H){break G}v[a+480208>>2]=v[a+480208>>2]|8388608}if((s|H)==1){Ob(o,89,1)}if(F){Ob(o,84,1)}L:{if(!(c&2)){break L}dd(b,x[m+8>>1]+(B(I,R)<<8)|0);f=(p&s^1|Y)&1;g=1;while(1){if((g|0)==32){break L}k=B(g,104)+a|0;c=k+484380|0;e=v[c>>2];if(e){i=2;if(!F){i=dS(b,13868)?10:0;e=v[c>>2]}j=Zc(d+160|0,8,1,0,i);e=SA(j,e)+v[b+8>>2]|0;if(!f){aa=c,ba=v[_c(c,k+484388|0)>>2],v[aa>>2]=ba}wg(j,c,b);dd(b,e)}g=g+1|0;continue}}M:{if((h&s^-1|J)&1){break M}b=cS(d+120|0,0);c=v[b+20>>2];v[d+40>>2]=v[b+16>>2];v[d+44>>2]=c;c=v[b+12>>2];v[d+32>>2]=v[b+8>>2];v[d+36>>2]=c;c=v[b+4>>2];v[d+24>>2]=v[b>>2];v[d+28>>2]=c;b=d+160|0;Yt(b,a,0,d+24|0);Z=A[v[d+160>>2]>>3];Ei(b);if(!(Z>=480)){break M}c=Ob(o,5,1);b=bS(d+96|0,Z);e=v[b+20>>2];v[d+16>>2]=v[b+16>>2];v[d+20>>2]=e;e=v[b+12>>2];v[d+8>>2]=v[b+8>>2];v[d+12>>2]=e;e=v[b+4>>2];v[d>>2]=v[b>>2];v[d+4>>2]=e;b=d+160|0;Yt(b,a,0,d);e=w[v[d+160>>2]+26|0];Ei(b);if(e){_f(c,5);break M}v[m>>2]=17113}b=d+332|0;e=b;f=jc(b);c=b;while(1){if((e|0)!=(f|0)){h=w[e|0];t[c|0]=h>>>0>32?h:32;c=c+1|0;e=e+1|0;continue}break}Sf(d+80|0,16866);v[23540]=0;b=W(579,d+48|0,b|0,f|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break g}v[23540]=0;U(11,d- -64|0,1,b|0);c=v[23540];v[23540]=0;if((c|0)==1){break f}v[23540]=0;U(145,d+160|0,d+80|0,d- -64|0);c=v[23540];v[23540]=0;if((c|0)==1){break e}c=d+160|0;Jb(a+1298344|0,c);Ab(c);Ab(d- -64|0);zb(b);dc(d+80|0);b=yc(c,12307);Jb(a+1298356|0,b);Ab(b);b=v[m>>2];if(b){Ol(a+1298368|0,b)}v[a+1298404>>2]=14}g=G>>>0<=N>>>0;break a}f=P()|0;O()|0;break c}f=P()|0;O()|0;break d}f=P()|0;O()|0;Ab(d- -64|0)}zb(b)}dc(d+80|0)}T(f|0);L()}else{j=B(g,104)+a|0;h=j+484380|0;o=mA(b,d+176|0,h,((g<<5)+a|0)+946304|0,x[q>>1]==4);h=v[h>>2];N:{if(e){t[j+484417|0]=0-(w[d+200|0]<<3);break N}l=h>>>0<65536&l}j=Ib(x[d+198>>1]);O:{if(j){X=!Ib(x[d+204>>1])|X;break O}Y=w[d+201|0]==64|Y}n=f&1;f=0;P:{if(!n){break P}k=(j<<1)+k|0;n=w[d+200|0];f=!n;if(n|!j){break P}f=w[d+201|0]==64}G=o+G|0;i=h+i|0;g=g+1|0;continue}}kb=d+336|0;return g|0}function w7(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=C(0),f=C(0),g=C(0),h=C(0),i=0,j=C(0),k=C(0),l=0,m=0,n=0,o=C(0),p=0,q=0,r=0,s=0,u=0,x=C(0),y=C(0),A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=C(0),Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=C(0),Z=0,_=0,$=C(0);a:{if(!w[a+5046|0]){break a}g=z[a+4268>>2];JK(a);if(g==z[a+4268>>2]){break a}Ex(a)}b:{if(!w[a+5045|0]){break b}if(!bi(a+44|0)){break b}i=v[a+44>>2];p=Jc(i,0);q=Jc(i,1);i=v[a+56>>2];l=Jc(i,0);m=Jc(i,1);c:{if(!(!w[a+5044|0]|(!d|w[a+4264|0]&2))){z[l>>2]=z[a+5036>>2];z[m>>2]=z[a+5040>>2];t[a+5044|0]=0;q=q+4|0;p=p+4|0;m=m+4|0;l=l+4|0;n=d-1|0;break c}n=d}r=n;s=a+4888|0;u=a+4864|0;U=a+4504|0;V=a+4960|0;W=a+4868|0;X=a+4892|0;D=a+4628|0;E=a+4604|0;Q=a+4916|0;F=a+4532|0;G=a+4508|0;H=a+4772|0;I=a+4748|0;R=a+4940|0;J=a+4676|0;K=a+4652|0;L=a+4724|0;M=a+4700|0;S=a+4844|0;N=a+4580|0;O=a+4556|0;T=a+4820|0;d:{while(1){if(!r){break d}g=z[p>>2];g=C(C(C(z[a+5008>>2]-g)*z[a+4276>>2])+g);z[a+5008>>2]=g;_=Pc(v[a+4864>>2],v[W>>2],v[a+4880>>2]),$=g,z[_>>2]=$;g=z[q>>2];g=C(C(C(z[a+5012>>2]-g)*z[a+4276>>2])+g);z[a+5012>>2]=g;_=Pc(v[a+4888>>2],v[X>>2],v[a+4904>>2]),$=g,z[_>>2]=$;g=C(C(C(C(C(Rh(u,v[a+4356>>2])*C(.6800000071525574))+C(Rh(u,v[a+4360>>2])*C(-.5)))-C(Rh(u,v[a+4364>>2])*C(.6200000047683716)))+C(Rh(u,v[a+4368>>2])*C(-.5)))-C(Rh(u,v[a+4372>>2])*C(.6200000047683716)));if(t[a+4264|0]&1){e=g;g=C(z[Pc(v[a+4816>>2],v[T>>2],v[a+4836>>2])>>2]+C(e*C(.6180340051651001)));_=Pc(v[a+4816>>2],v[T>>2],v[a+4832>>2]),$=C(e-C(g*C(.6180340051651001))),z[_>>2]=$}x=z[a+4280>>2];_=a,$=C(Rh(u,v[a+4352>>2])+z[a+5020>>2]),z[_+5020>>2]=$;e=C(Rh(s,v[a+4376>>2])+z[a+5024>>2]);z[a+5024>>2]=e;f=z[a+5020>>2];h=C(C(C(z[a+4980>>2]-z[Pc(v[a+4624>>2],v[D>>2],v[a+4644>>2])>>2])*z[a+4444>>2])+z[Pc(v[a+4624>>2],v[D>>2],v[a+4644>>2])>>2]);z[a+4980>>2]=h;P=C(h*z[a+4440>>2]);k=C(e*C(.7070000171661377));j=C(f*C(-.7070000171661377));f=C(k+j);h=z[a+4272>>2];e=C(P+C(f*h));_=Pc(v[a+4624>>2],v[D>>2],v[a+4640>>2]),$=C(f-C(h*e)),z[_>>2]=$;f=C(C(C(z[a+4976>>2]-z[Pc(v[a+4600>>2],v[E>>2],v[a+4620>>2])>>2])*z[a+4436>>2])+z[Pc(v[a+4600>>2],v[E>>2],v[a+4620>>2])>>2]);z[a+4976>>2]=f;h=z[a+4272>>2];f=C(C(f*z[a+4432>>2])+C(e*h));_=Pc(v[a+4600>>2],v[E>>2],v[a+4616>>2]),$=C(e-C(h*f)),z[_>>2]=$;y=C(C(e*C(-.15000000596046448))+C(f*C(-.20000000298023224)));if(t[a+4264|0]&1){e=C(C(C(z[a+4972>>2]-z[Pc(v[a+4576>>2],v[N>>2],v[a+4596>>2])>>2])*z[a+4428>>2])+z[Pc(v[a+4576>>2],v[N>>2],v[a+4596>>2])>>2]);z[a+4972>>2]=e;h=z[a+4272>>2];e=C(C(e*z[a+4424>>2])+C(f*h));_=Pc(v[a+4576>>2],v[N>>2],v[a+4592>>2]),$=C(f-C(h*e)),z[_>>2]=$;f=C(C(C(z[a+4968>>2]-z[Pc(v[a+4552>>2],v[O>>2],v[a+4572>>2])>>2])*z[a+4420>>2])+z[Pc(v[a+4552>>2],v[O>>2],v[a+4572>>2])>>2]);z[a+4968>>2]=f;h=z[a+4272>>2];f=C(C(f*z[a+4416>>2])+C(e*h));_=Pc(v[a+4552>>2],v[O>>2],v[a+4568>>2]),$=C(e-C(h*f)),z[_>>2]=$;y=C(C(C(e*C(.3499999940395355))+y)+C(f*C(-.3799999952316284)))}_=Pc(v[a+4912>>2],v[Q>>2],v[a+4928>>2]),$=f,z[_>>2]=$;e=C(z[Pc(v[a+4912>>2],v[Q>>2],v[a+4932>>2])>>2]*z[a+4496>>2]);z[a+5028>>2]=C(C(z[a+5028>>2]-e)*z[a+4500>>2])+e;e=C(C(C(z[a+4964>>2]-z[Pc(v[a+4528>>2],v[F>>2],v[a+4548>>2])>>2])*z[a+4412>>2])+z[Pc(v[a+4528>>2],v[F>>2],v[a+4548>>2])>>2]);z[a+4964>>2]=e;f=z[a+5028>>2];o=z[a+4272>>2];h=C(C(f*o)+C(e*z[a+4408>>2]));_=Pc(v[a+4528>>2],v[F>>2],v[a+4544>>2]),$=C(f-C(o*h)),z[_>>2]=$;e=C(C(C(z[a+4960>>2]-z[Pc(v[a+4504>>2],v[G>>2],v[a+4524>>2])>>2])*z[a+4404>>2])+z[Pc(v[a+4504>>2],v[G>>2],v[a+4524>>2])>>2]);z[a+4960>>2]=e;f=C(e*z[a+4400>>2]);e=z[a+4272>>2];o=C(f+C(h*e));_=Pc(v[a+4504>>2],v[G>>2],v[a+4520>>2]),$=C(h-C(e*o)),z[_>>2]=$;z[a+5020>>2]=o;e=C(C(C(C(C(Rh(s,v[a+4380>>2])*C(.7070000171661377))+C(Rh(s,v[a+4384>>2])*C(-.6000000238418579)))-C(Rh(s,v[a+4388>>2])*C(.5)))+C(Rh(s,v[a+4392>>2])*C(-.6000000238418579)))-C(Rh(s,v[a+4396>>2])*C(.5)));if(t[a+4264|0]&1){f=e;e=C(z[Pc(v[a+4840>>2],v[S>>2],v[a+4860>>2])>>2]+C(e*C(.6180340051651001)));_=Pc(v[a+4840>>2],v[S>>2],v[a+4856>>2]),$=C(f-C(e*C(.6180340051651001))),z[_>>2]=$}Y=z[a+4280>>2];f=C(C(C(z[a+5004>>2]-z[Pc(v[a+4768>>2],v[H>>2],v[a+4788>>2])>>2])*z[a+4492>>2])+z[Pc(v[a+4768>>2],v[H>>2],v[a+4788>>2])>>2]);z[a+5004>>2]=f;P=C(f*z[a+4488>>2]);f=C(j-k);j=z[a+4272>>2];k=C(P+C(f*j));_=Pc(v[a+4768>>2],v[H>>2],v[a+4784>>2]),$=C(f-C(j*k)),z[_>>2]=$;f=C(C(C(z[a+5e3>>2]-z[Pc(v[a+4744>>2],v[I>>2],v[a+4764>>2])>>2])*z[a+4484>>2])+z[Pc(v[a+4744>>2],v[I>>2],v[a+4764>>2])>>2]);z[a+5e3>>2]=f;j=z[a+4272>>2];f=C(C(f*z[a+4480>>2])+C(k*j));_=Pc(v[a+4744>>2],v[I>>2],v[a+4760>>2]),$=C(k-C(j*f)),z[_>>2]=$;k=C(C(C(h*C(.3799999952316284))+C(k*C(-.15000000596046448)))+C(f*C(-.20000000298023224)));if(t[a+4264|0]&1){h=C(C(C(z[a+4996>>2]-z[Pc(v[a+4720>>2],v[L>>2],v[a+4740>>2])>>2])*z[a+4476>>2])+z[Pc(v[a+4720>>2],v[L>>2],v[a+4740>>2])>>2]);z[a+4996>>2]=h;j=z[a+4272>>2];h=C(C(h*z[a+4472>>2])+C(f*j));_=Pc(v[a+4720>>2],v[L>>2],v[a+4736>>2]),$=C(f-C(j*h)),z[_>>2]=$;f=C(C(C(z[a+4992>>2]-z[Pc(v[a+4696>>2],v[M>>2],v[a+4716>>2])>>2])*z[a+4468>>2])+z[Pc(v[a+4696>>2],v[M>>2],v[a+4716>>2])>>2]);z[a+4992>>2]=f;j=z[a+4272>>2];f=C(C(f*z[a+4464>>2])+C(h*j));_=Pc(v[a+4696>>2],v[M>>2],v[a+4712>>2]),$=C(h-C(j*f)),z[_>>2]=$;k=C(C(C(h*C(.3499999940395355))+k)+C(f*C(-.3799999952316284)))}Z=q+4|0;n=p+4|0;h=C(g*x);y=C(y-C(o*C(.3799999952316284)));o=C(e*Y);_=Pc(v[a+4936>>2],v[R>>2],v[a+4952>>2]),$=f,z[_>>2]=$;g=C(z[Pc(v[a+4936>>2],v[R>>2],v[a+4956>>2])>>2]*z[a+4496>>2]);z[a+5032>>2]=C(C(z[a+5032>>2]-g)*z[a+4500>>2])+g;g=C(C(C(z[a+4988>>2]-z[Pc(v[a+4672>>2],v[J>>2],v[a+4692>>2])>>2])*z[a+4460>>2])+z[Pc(v[a+4672>>2],v[J>>2],v[a+4692>>2])>>2]);z[a+4988>>2]=g;e=z[a+5032>>2];f=z[a+4272>>2];g=C(C(e*f)+C(g*z[a+4456>>2]));_=Pc(v[a+4672>>2],v[J>>2],v[a+4688>>2]),$=C(e-C(f*g)),z[_>>2]=$;f=z[a+4284>>2];e=C(C(C(z[a+4984>>2]-z[Pc(v[a+4648>>2],v[K>>2],v[a+4668>>2])>>2])*z[a+4452>>2])+z[Pc(v[a+4648>>2],v[K>>2],v[a+4668>>2])>>2]);z[a+4984>>2]=e;x=z[a+4272>>2];e=C(C(e*z[a+4448>>2])+C(g*x));_=Pc(v[a+4648>>2],v[K>>2],v[a+4664>>2]),$=C(g-C(x*e)),z[_>>2]=$;z[a+5024>>2]=e;e=C(-e);x=z[a+4288>>2];i=U;e:{f:{while(1){if((i|0)==(V|0)){g:{e=C(o+C(C(C(e*C(.3799999952316284))+k)*x));g=C(h+C(C(C(g*C(.3799999952316284))+y)*f));if(!(w[a+4264|0]&2)){break g}p=n;n=Z;break f}}else{A=v[i+16>>2];B=A-1|0;v[i+16>>2]=B;if((A|0)<=0){v[i+16>>2]=B+v[i+12>>2]}A=v[i+20>>2];B=A-1|0;v[i+20>>2]=B;if((A|0)<=0){v[i+20>>2]=B+v[i+12>>2]}i=i+24|0;continue}break}z[l>>2]=C(g+z[a+5036>>2])*C(.5);z[m>>2]=C(e+z[a+5040>>2])*C(.5);z[a+5040>>2]=e;z[a+5036>>2]=g;if((r|0)==1){break e}r=r-1|0;p=p+8|0;m=m+4|0;l=l+4|0;n=q+8|0}q=n;z[l>>2]=g;z[m>>2]=e;r=r-1|0;m=m+4|0;l=l+4|0;continue}break}t[a+5044|0]=1}n=a;a=v[a+56>>2];ti(n,b,c,Jc(a,0),Jc(a,1),d)}}function Mea(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=kb-288|0;kb=g;e=kb-128|0;kb=e;f=je(g+104|0,c);v[23540]=0;n=S(174,f+20|0)|0;c=v[23540];v[23540]=0;a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{z:{A:{B:{if((c|0)!=1){v[23540]=0;p=S(174,f+40|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break B}v[23540]=0;q=S(174,f+60|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break A}v[23540]=0;i=S(174,f+80|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break z}v[23540]=0;o=S(174,f+100|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break y}v[23540]=0;k=S(174,f+120|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break x}j=Tb(f+140|0);zc(f);v[f+172>>2]=1873739776;u[f+176>>1]=0;v[23540]=0;d=Q(769,f|0,e+112|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break w}if(!d){break n}d=v[e+112>>2];if((d|0)!=1414744396&(d|0)!=1179011410){break n}c=v[e+120>>2];if((c|0)!=1163280727&(c|0)!=1702257015){break n}t[f+176|0]=(d|0)==1414744396;v[23540]=0;U(770,e+96|0,f|0,2);c=v[23540];v[23540]=0;if((c|0)==1){break v}h=v[e+96>>2];C:{if(Mq(h,v[e+100>>2])>>>0<4){break C}c=cy(h,1);d=v[c+4>>2];c=v[c>>2];_h(e+40|0,c,d);if(v[e+40>>2]!=1635017060){break C}_h(e- -64|0,c,d);if(!(t[e+68|0]&1)){break C}c=cy(h,2);_h(e+24|0,v[c>>2],v[c+4>>2]);if(v[e+28>>2]){break C}c=cy(h,3);_h(e+88|0,v[c>>2],v[c+4>>2]);if(v[e+88>>2]){break C}v[23540]=0;Q(155,f|0,12)|0;c=v[23540];v[23540]=0;if((c|0)==1){break u}v[23540]=0;U(770,e+40|0,f|0,1);c=v[23540];v[23540]=0;if((c|0)==1){break t}c=e+40|0;Tt(e+96|0,c);Zd(c)}v[23540]=0;U(771,e- -64|0,e+96|0,544501094);c=v[23540];v[23540]=0;if((c|0)==1){break s}v[23540]=0;d=Q(772,e- -64|0,f+156|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break k}if(!d){break o}d=x[f+156>>1];if((d|0)!=1){break q}v[23540]=0;d=S(202,e- -64|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){break r}break k}d=P()|0;O()|0;break b}d=P()|0;O()|0;break c}d=P()|0;O()|0;break d}d=P()|0;O()|0;break e}d=P()|0;O()|0;break f}d=P()|0;O()|0;break g}d=P()|0;O()|0;break h}d=P()|0;O()|0;break h}d=P()|0;O()|0;break i}d=P()|0;O()|0;break i}d=P()|0;O()|0;break i}if((d|0)==4){v[23540]=0;h=S(197,e- -64|0)|0;c=v[23540];v[23540]=0;D:{if((c|0)!=1){v[23540]=0;d=S(197,e- -64|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break D}if((h|0)!=2|(d|0)!=1){break p}t[f+177|0]=1;break p}d=P()|0;O()|0;break j}d=P()|0;O()|0;break j}d=x[f+156>>1]}if((d&65535)!=65534){break p}v[23540]=0;d=Q(773,e- -64|0,e+40|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break l}if(!d){break o}c=v[e+60>>2];v[e+16>>2]=v[e+56>>2];v[e+20>>2]=c;c=v[e+52>>2];v[e+8>>2]=v[e+48>>2];v[e+12>>2]=c;c=e+24|0;v[c>>2]=w[e+8|0]|w[e+9|0]<<8|(w[e+10|0]<<16|w[e+11|0]<<24);u[c+4>>1]=w[e+12|0]|w[e+13|0]<<8;u[c+6>>1]=w[e+14|0]|w[e+15|0]<<8;r=c,s=nA(w[e+16|0]|w[e+17|0]<<8|(w[e+18|0]<<16|w[e+19|0]<<24),w[e+20|0]|w[e+21|0]<<8|(w[e+22|0]<<16|w[e+23|0]<<24)),v[r+8>>2]=s;v[c+12>>2]=nb;u[f+172>>1]=v[c>>2]}v[23540]=0;U(771,e+40|0,e+96|0,1635017060);c=v[23540];v[23540]=0;E:{F:{G:{H:{I:{J:{if((c|0)!=1){c=e+40|0;m=hd(n,c);Bb(c);c=v[m>>2];v[23540]=0;d=S(178,c|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break k}if(!d){v[23540]=0;U(771,e+40|0,e+96|0,544039792);c=v[23540];v[23540]=0;if((c|0)==1){break J}c=e+40|0;hd(m,c);Bb(c)}v[23540]=0;U(771,e+40|0,e+96|0,1952670054);c=v[23540];v[23540]=0;if((c|0)==1){break I}v[23540]=0;d=S(157,e+40|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break H}v[f+152>>2]=d;Bb(e+40|0);if(v[f+152>>2]?x[f+156>>1]==17:0){break E}h=x[f+158>>1];d=hM(h,x[f+170>>1]);if(!d){break E}c=x[f+168>>1];if((c>>>0)/(h>>>0)>>>0<d<<1>>>0?c:0){break G}c=v[m>>2];v[23540]=0;d=S(160,c|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break k}c=hM(x[f+158>>1],x[f+170>>1]);break F}d=P()|0;O()|0;break j}d=P()|0;O()|0;break j}d=P()|0;O()|0;break j}d=P()|0;O()|0;Bb(e+40|0);break j}c=v[m>>2];v[23540]=0;d=S(160,c|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break k}c=x[f+168>>1]}v[f+152>>2]=(d>>>0)/((c&65535)>>>0)}v[23540]=0;d=Q(774,f|0,e+96|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break k}u[f+174>>1]=d;v[23540]=0;R(775,f|0,e+96|0);c=v[23540];v[23540]=0;if((c|0)==1){break k}v[23540]=0;U(771,e+40|0,e+96|0,1886221175);c=v[23540];v[23540]=0;if((c|0)==1){break m}c=e+40|0;hd(o,c);Bb(c)}Bb(e- -64|0);Zd(e+96|0)}kb=e+128|0;break a}d=P()|0;O()|0;break j}d=P()|0;O()|0;break j}d=P()|0;O()|0}Bb(e- -64|0)}Zd(e+96|0)}Zd(j);Bb(k)}Bb(o)}Bb(i)}Bb(q)}Bb(p)}Bb(n)}Bb(f);T(d|0);L()}c=v[f+20>>2];v[23540]=0;d=S(714,c|0)|0;c=v[23540];v[23540]=0;K:{L:{if((c|0)!=1){M:{if(!d|(x[f+158>>1]-3&65535)>>>0<65534){break M}N:{O:{c=x[f+170>>1];P:{if(!c){if((lk(f)|0)==85){break P}break M}if(c>>>0>31){break O}}if((lk(f)|0)!=3){break N}break M}if(c>>>0>64){break M}}d=lk(f);c=30304;while(1){Q:{R:{if((c|0)!=30328){if((d|0)!=v[c>>2]){break R}}else{c=30328}break Q}c=c+4|0;continue}break}if((c|0)==30328){break M}pt(a,b);v[23540]=0;d=Q(55,g+88|0,21688)|0;c=v[23540];v[23540]=0;S:{T:{U:{V:{W:{if((c|0)!=1){h=Dc(((b<<5)+a|0)+946304|0,d);zb(d);v[23540]=0;d=B(b,104)+a|0;i=d+484380|0;R(277,i|0,0);c=v[23540];v[23540]=0;if((c|0)==1){break W}v[i>>2]=v[f+152>>2];v[d+484404>>2]=v[f+160>>2];c=v[a+1298404>>2];v[23540]=0;X(715,f|0,i|0,c|0,h|0);c=v[23540];v[23540]=0;if((c|0)==1){break W}je(g- -64|0,f+20|0);d=x[f+158>>1];j=Zc(g+56|0,8,d>>>0>1?2:1,0,0);c=lk(f);if((c|0)!=17|d>>>0>2){break U}xc(i,268435456);c=B(b,104)+a|0;b=c+484414|0;u[b>>1]=x[b>>1]&65470|((d|0)==2)<<6|1;if(Mg(i)){break V}break S}l=P()|0;O()|0;break K}l=P()|0;O()|0;break K}j=v[c+484400>>2];h=v[i>>2];k=je(g+32|0,g- -64|0);d=x[f+158>>1];c=x[f+168>>1];v[23540]=0;b=v[k+12>>2];v[g+16>>2]=v[k+8>>2];v[g+20>>2]=b;v[g+24>>2]=v[k+16>>2];b=v[k+4>>2];v[g+8>>2]=v[k>>2];v[g+12>>2]=b;da(716,j|0,h|0,g+8|0,c|0,d|0);b=v[23540];v[23540]=0;if((b|0)==1){break L}uj(i,a);break T}if((c|0)==85){v[23540]=0;c=W(559,a|0,b|0,g- -64|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break L}if(c){break T}break S}X:{Y:{Z:{if(VP(x[f+156>>1])){break Z}_:{if(!Qd(w[f+177|0])){break _}if((lk(f)|0)!=1|x[f+170>>1]!=32|x[f+168>>1]!=d<<2){break _}xd(j,32);b=12;break Y}if((lk(f)|0)!=1|x[f+170>>1]!=24|x[f+168>>1]!=d<<2){break Z}xd(j,32);b=13;break Y}if((lk(f)&65534)!=6){break X}xd(j,16);b=(lk(f)|0)==6?17:16}dg(j,b);v[23540]=0;W(219,j|0,i|0,g- -64|0)|0;b=v[23540];v[23540]=0;if((b|0)!=1){break T}break L}d=x[f+170>>1];c=(d-1>>>3|0)-1|0;b=c<<3;h=b&31;xd(j,(c>>>0<7?(b&63)>>>0>=32?4196360>>>h|0:((1<<h)-1&4196360)<<32-h|136321040>>>h:8)&255);if(d>>>0<9){dg(j,1)}if((lk(f)|0)==3){dg(j,3)}v[23540]=0;W(219,j|0,i|0,g- -64|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break L}}Fz(i,v[a+480180>>2]);uj(i,a);l=1}Bb(g- -64|0)}UP(f);kb=g+288|0;return l|0}l=P()|0;O()|0;break K}l=P()|0;O()|0;Bb(g- -64|0)}UP(f);T(l|0);L()}
function YI(a,b,c,d,e,f,g){var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=kb-272|0;kb=h;a:{b:{if(g){of(h+256|0,f,32);v[23540]=0;W(527,h+240|0,f|0,32)|0;k=v[23540];v[23540]=0;if((k|0)!=1){break b}f=P()|0;O()|0;break a}Nb(h+256|0);Nb(h+240|0)}c:{d:{e:{f:{g:{h:{i:{j:{if(ss(c)){k=v[b+24>>2];i=v[k+484344>>2];if(xe(i,v[k+484348>>2],c&65535)){break j}}v[23540]=0;U(1081,a|0,h+256|0,h+240|0);a=v[23540];v[23540]=0;if((a|0)!=1){break i}f=P()|0;O()|0;break c}c=_b(i,c);if(!(!((e|0)<0|v[c+12>>2]<=(d|0)|(d|0)<0)&x[k+480188>>1]>e>>>0)){v[23540]=0;U(1081,a|0,h+256|0,h+240|0);a=v[23540];v[23540]=0;if((a|0)!=1){break i}f=P()|0;O()|0;break c}c=jd(v[c>>2],v[v[c+48>>2]+12>>2],d,e&65535);$f(h+256|0);$f(h+240|0);k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{z:{A:{d=w[c|0];if(!$c(d)){if(!Pp(d)){break A}}e=w[c+1|0];k=v[b+24>>2];v[23540]=0;X(1082,h+208|0,k|0,d|0,e|0);d=v[23540];v[23540]=0;e=1;if((d|0)==1){break y}v[23540]=0;R(1009,h+224|0,h+208|0);d=v[23540];v[23540]=0;if((d|0)!=1){break z}f=P()|0;O()|0;break v}e=0;v[23540]=0;Q(55,h+224|0,16799)|0;d=v[23540];v[23540]=0;if((d|0)==1){break x}}v[23540]=0;k=Q(800,h+256|0,h+224|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break w}zb(h+224|0);if(e){Ab(h+208|0)}e=9987;d=w[c|0];if(!$c(d)){e=Pp(d)?10297:16799}v[23540]=0;d=Q(55,h+224|0,e|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break u}v[23540]=0;e=Q(800,h+240|0,d|0)|0;i=v[23540];v[23540]=0;if((i|0)==1){break t}zb(d);if(f-6>>>0>4294967290){break l}v[23540]=0;d=Q(55,h+192|0,17859)|0;i=v[23540];v[23540]=0;if((i|0)==1){break s}v[23540]=0;i=Q(800,k|0,d|0)|0;l=v[23540];v[23540]=0;if((l|0)==1){break r}zb(d);v[23540]=0;d=Q(55,h+176|0,17859)|0;l=v[23540];v[23540]=0;if((l|0)==1){break q}v[23540]=0;l=Q(800,e|0,d|0)|0;j=v[23540];v[23540]=0;if((j|0)==1){break p}zb(d);d=c+1|0;B:{if(w[c+1|0]){v[23540]=0;R(544,h+160|0,d|0);j=v[23540];v[23540]=0;if((j|0)!=1){break B}break d}v[23540]=0;Q(55,h+160|0,16804)|0;j=v[23540];v[23540]=0;if((j|0)==1){break d}}v[23540]=0;j=Q(800,i|0,h+160|0)|0;i=v[23540];v[23540]=0;if((i|0)==1){break o}i=h+160|0;zb(i);d=w[d|0];v[23540]=0;d=Q(55,i|0,(d?10791:16804)|0)|0;i=v[23540];v[23540]=0;if((i|0)==1){break n}v[23540]=0;l=Q(800,l|0,d|0)|0;i=v[23540];v[23540]=0;if((i|0)!=1){break m}f=P()|0;O()|0;zb(d);break c}f=P()|0;O()|0;break c}f=P()|0;O()|0;break c}f=P()|0;O()|0;zb(h+224|0);if(!e){break c}}Ab(h+208|0);break c}f=P()|0;O()|0;break c}f=P()|0;O()|0;zb(d);break c}f=P()|0;O()|0;break c}f=P()|0;O()|0;zb(d);break c}f=P()|0;O()|0;break c}f=P()|0;O()|0;zb(d);break c}f=P()|0;O()|0;zb(h+160|0);break c}f=P()|0;O()|0;break c}zb(d);if(f-9>>>0>4294967287){break l}C:{D:{E:{F:{G:{H:{I:{J:{K:{L:{M:{N:{i=fh(w[c|0]);O:{if(i){v[23540]=0;m=Q(55,h+128|0,17859)|0;d=v[23540];v[23540]=0;if((d|0)==1){break N}d=w[c+4|0];n=w[c+2|0];v[23540]=0;o=h,p=ik(n,d)&255,v[o+96>>2]=p;R(543,h+112|0,h+96|0);d=v[23540];v[23540]=0;if((d|0)==1){break M}d=0;v[23540]=0;U(965,h+144|0,m|0,h+112|0);m=v[23540];v[23540]=0;if((m|0)!=1){break O}f=P()|0;O()|0;break G}d=w[c+2|0];if(d){d=$L(v[v[v[b+24>>2]+8>>2]+88>>2],d);v[23540]=0;d=W(527,h+128|0,1,d|0)|0;m=v[23540];v[23540]=0;if((m|0)==1){break E}v[23540]=0;R(544,h+112|0,c+4|0);m=v[23540];v[23540]=0;if((m|0)==1){break L}v[23540]=0;U(965,h+144|0,d|0,h+112|0);m=v[23540];v[23540]=0;d=1;if((m|0)!=1){break O}f=P()|0;O()|0;break J}d=0;v[23540]=0;Q(55,h+144|0,16803)|0;m=v[23540];v[23540]=0;if((m|0)==1){break e}}v[23540]=0;j=Q(800,j|0,h+144|0)|0;m=v[23540];v[23540]=0;if((m|0)==1){break K}zb(h+144|0);if(d){zb(h+112|0);zb(h+128|0)}if(i){zb(h+112|0);zb(h+128|0)}d=5491;if(!fh(w[c|0])){d=w[c+2|0]?5487:16803}v[23540]=0;d=Q(55,h+144|0,d|0)|0;i=v[23540];v[23540]=0;if((i|0)==1){break D}v[23540]=0;i=Q(800,l|0,d|0)|0;l=v[23540];v[23540]=0;if((l|0)!=1){break C}f=P()|0;O()|0;zb(d);break c}f=P()|0;O()|0;break c}f=P()|0;O()|0;break F}f=P()|0;O()|0;break I}f=P()|0;O()|0;zb(h+144|0);if(!d){break H}}zb(h+112|0)}zb(h+128|0)}if(!i){break c}}zb(h+112|0)}zb(h+128|0);break c}f=P()|0;O()|0;break c}f=P()|0;O()|0;break c}zb(d);if(f-13>>>0>4294967283){break l}v[23540]=0;d=Q(55,h+96|0,17859)|0;l=v[23540];v[23540]=0;P:{Q:{R:{S:{T:{U:{V:{W:{X:{Y:{Z:{if((l|0)!=1){v[23540]=0;l=Q(800,j|0,d|0)|0;j=v[23540];v[23540]=0;if((j|0)==1){break Z}zb(d);v[23540]=0;d=Q(55,h+80|0,17859)|0;j=v[23540];v[23540]=0;if((j|0)==1){break Y}v[23540]=0;i=Q(800,i|0,d|0)|0;j=v[23540];v[23540]=0;if((j|0)==1){break X}zb(d);_:{if(fh(w[c|0])){d=w[c+5|0];j=w[c+3|0];b=0;v[23540]=0;o=h,p=ik(j,d)&4095,v[o+16>>2]=p;R(1083,h- -64|0,h+16|0);d=v[23540];v[23540]=0;if((d|0)!=1){break _}f=P()|0;O()|0;break c}d=w[c+3|0];if(d){b=_L(v[v[v[b+24>>2]+8>>2]+84>>2],d);v[23540]=0;b=W(527,h+48|0,1,b|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break W}v[23540]=0;R(544,h+32|0,c+5|0);d=v[23540];v[23540]=0;if((d|0)==1){break V}v[23540]=0;U(965,h- -64|0,b|0,h+32|0);d=v[23540];v[23540]=0;b=1;if((d|0)!=1){break _}f=P()|0;O()|0;break S}b=0;v[23540]=0;Q(55,h- -64|0,16799)|0;d=v[23540];v[23540]=0;if((d|0)==1){break U}}v[23540]=0;Q(800,l|0,h- -64|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break T}zb(h- -64|0);if(b){zb(h+32|0);zb(h+48|0)}b=11155;if(!fh(w[c|0])){b=w[c+3|0]?11155:16799}v[23540]=0;b=Q(55,h- -64|0,b|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break Q}v[23540]=0;Q(800,i|0,b|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){break P}f=P()|0;O()|0;zb(b);break c}f=P()|0;O()|0;break c}f=P()|0;O()|0;zb(d);break c}f=P()|0;O()|0;break c}f=P()|0;O()|0;zb(d);break c}f=P()|0;O()|0;break c}f=P()|0;O()|0;break R}f=P()|0;O()|0;break c}f=P()|0;O()|0;zb(h- -64|0);if(!b){break c}}zb(h+32|0)}zb(h+48|0);break c}f=P()|0;O()|0;break c}zb(b);if(!f){break k}}$:{aa:{ba:{ca:{b=Hb(k);da:{if(b>>>0>f>>>0){v[23540]=0;X(130,h+16|0,k|0,0,f|0);b=v[23540];v[23540]=0;if((b|0)!=1){b=h+16|0;Bc(k,b);zb(b);break da}f=P()|0;O()|0;break c}if(!g){break da}v[23540]=0;b=W(527,h+16|0,f-b|0,32)|0;c=v[23540];v[23540]=0;if((c|0)==1){break ca}v[23540]=0;Q(800,k|0,b|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break ba}zb(b)}b=Hb(e);if(b>>>0<=f>>>0){break $}v[23540]=0;X(130,h|0,e|0,0,f|0);b=v[23540];v[23540]=0;if((b|0)==1){break aa}Bc(e,h);zb(h);break k}f=P()|0;O()|0;break c}f=P()|0;O()|0;zb(b);break c}f=P()|0;O()|0;break c}if(!g){break k}v[23540]=0;b=W(527,h|0,f-b|0,32)|0;c=v[23540];v[23540]=0;if((c|0)==1){break h}v[23540]=0;Q(800,e|0,b|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break g}zb(b)}v[23540]=0;U(1081,a|0,k|0,e|0);a=v[23540];v[23540]=0;if((a|0)==1){break f}}zb(h+240|0);zb(h+256|0);kb=h+272|0;return}f=P()|0;O()|0;break c}f=P()|0;O()|0;zb(b);break c}f=P()|0;O()|0;break c}f=P()|0;O()|0;break c}f=P()|0;O()|0}zb(h+240|0)}zb(h+256|0);T(f|0);L()}function Sfa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,y=0,z=0,A=0,C=0,D=0,E=0,F=0,G=0;d=kb-304|0;kb=d;zc(b);a:{b:{c:{d:{if(!Ut(b,d+208|0)){break d}if(!zR(d+208|0)){break d}if(!Qb(v[b>>2],v[b+8>>2],Ec(yR(d+208|0),nb))){break d}if(!c){g=1;break d}if(!dd(b,w[d+212|0])){break d}Cd(a,268435456);ag(a);v[a+480208>>2]=4;Ob(a+1074312|0,114,1);f=d+88|0;i=yc(f,15353);Jb(a+1298344|0,i);Ab(i);i=yc(f,10301);Jb(a+1298356|0,i);Ab(i);v[a+1298404>>2]=5;i=d+16|0;pf(i,d+208|6,48,3);Fc(f,i);Bc(a+1298308|0,f);zb(f);f=w[d+262|0];u[a+480188>>1]=f+1;v[a+480228>>2]=w[d+265|0];v[a+480204>>2]=B(w[d+266|0],1e4);v[a+480196>>2]=w[d+267|0];while(1){if((e|0)==(f|0)){e:{u[a+480190>>1]=w[d+300|0];f=x[d+302>>1];i=d+192|0;v[i>>2]=0;v[i+4>>2]=0;Gc(i+8|0);if(f){Bk(i,f);FA(i,f)}v[23540]=0;U(631,b|0,i|0,x[d+302>>1]);f=v[23540];v[23540]=0;if((f|0)==1){break b}z=Tb(d+176|0);r=Tb(d+160|0);v[23540]=0;W(409,b|0,z|0,w[d+301|0])|0;f=v[23540];v[23540]=0;if((f|0)==1){break c}v[23540]=0;W(409,b|0,r|0,w[d+300|0])|0;f=v[23540];v[23540]=0;if((f|0)==1){break c}p=c&2;s=d+126|0;n=d+88|6;f=0;f:{while(1){e=f;if(e>>>0>=w[d+300|0]){g=1;if(!(c&1)){break e}v[d+68>>2]=0;q=a+484376|0;Lc(Wb(v[a+484360>>2],w[q|0]));F=d,G=Fb(v[i>>2]),v[F+64>>2]=G;y=a+484344|0;C=Fb(v[i+4>>2]);D=a+484348|0;break f}v[23540]=0;f=e+1|0;h=B(f,104)+a|0;k=h+484380|0;R(277,k|0,0);g=v[23540];v[23540]=0;g:{if((g|0)!=1){g=Eb(v[r>>2],e);g=w[g|0]|w[g+1|0]<<8|(w[g+2|0]<<16|w[g+3|0]<<24);if(!g){continue}v[23540]=0;g=Q(155,b|0,g|0)|0;j=v[23540];v[23540]=0;h:{if((j|0)==1){break h}if(!g){continue}v[23540]=0;g=Q(632,b|0,d+88|0)|0;j=v[23540];v[23540]=0;if((j|0)==1){break h}if(!g){continue}g=d+72|0;Ne(g,2,n);v[23540]=0;R(222,d+16|0,g|0);g=v[23540];v[23540]=0;if((g|0)==1){break c}g=d+16|0;Dc(((f<<5)+a|0)+946304|0,g);zb(g);j=d+72|0;uk(j,2,s);v[23540]=0;R(222,g|0,j|0);g=v[23540];v[23540]=0;if((g|0)==1){break c}g=d+16|0;Be(h+484423|0,g);zb(g);g=w[d+138|0];if(g>>>0<=15){u[h+484408>>1]=B(g,17);g=h+484414|0;u[g>>1]=x[g>>1]|32}t[d+16|0]=w[d+139|0];t[d+72|0]=64;F=h+484412|0,G=w[Yb(d+16|0,d+72|0)|0],u[F>>1]=G;v[h+484404>>2]=w[d+141|0]|w[d+142|0]<<8;m=h+484384|0;g=w[d+147|0]|w[d+148|0]<<8|(w[d+149|0]<<16|w[d+150|0]<<24);v[m>>2]=g;q=h+484388|0;j=w[d+151|0]|w[d+152|0]<<8|(w[d+153|0]<<16|w[d+154|0]<<24);v[q>>2]=j;y=w[d+155|0]|w[d+156|0]<<8|(w[d+157|0]<<16|w[d+158|0]<<24);v[k>>2]=y;l=w[d+140|0];if(l&1){g=g>>>1|0;v[m>>2]=g;j=j>>>1|0;v[q>>2]=j;v[k>>2]=y>>>1}i:{if(g>>>0>=j>>>0){break i}h=h+484414|0;g=x[h>>1];u[h>>1]=g|2;if(!(l&2)){break i}u[h>>1]=g|6}Dk(k);if(!p){continue}e=Eb(v[r>>2],e);e=w[e|0]|w[e+1|0]<<8|(w[e+2|0]<<16|w[e+3|0]<<24);v[23540]=0;Q(155,b|0,e+w[d+92|0]|0)|0;e=v[23540];v[23540]=0;if((e|0)!=1){break g}}break c}break c}e=Zc(d+16|0,t[d+140|0]&1?16:8,1,0,1);v[23540]=0;W(219,e|0,k|0,b|0)|0;e=v[23540];v[23540]=0;if((e|0)!=1){continue}break}break c}while(1){j:{k:{k=v[d+64>>2];if(!Pb(k,C)){b=v[d+68>>2];c=b&63;if(!c){break k}f=w[a+484376|0];e=v[a+484360>>2];v[23540]=0;b=b>>>6|0;f=Q(311,Wb(e,f)|0,b&65535)|0;e=v[23540];v[23540]=0;if((e|0)!=1){if(!f){break k}b=x[cc(v[Wb(v[a+484360>>2],w[a+484376|0])>>2],b&65535)>>1];f=v[a+484344>>2];v[23540]=0;R(633,_b(f,b)|0,c|0);b=v[23540];v[23540]=0;if((b|0)!=1){break k}}break c}c=w[k+3|0];if(w[k+2|0]>w[d+262|0]|c>>>0>=w[d+301|0]){break j}c=Eb(v[z>>2],c);c=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);v[23540]=0;c=Q(155,b|0,c|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break c}if(!c){break j}v[23540]=0;R(634,b|0,d+88|0);c=v[23540];v[23540]=0;if((c|0)==1){break c}e=w[d+92|0];if(!e){break j}f=w[k|0]|w[k+1|0]<<8;t[d+16|0]=w[d+93|0];t[d+72|0]=w[d+262|0]-w[k+2|0];j=w[Yb(d+16|0,d+72|0)|0];v[d+60>>2]=e+f;F=d,G=v[_c(d+68|0,d+60|0)>>2],v[F+68>>2]=G;v[d+40>>2]=0;v[d+44>>2]=0;v[d+32>>2]=0;v[d+36>>2]=0;v[d+24>>2]=0;v[d+28>>2]=0;v[d+16>>2]=0;v[d+20>>2]=0;c=f&63;p=f>>>6|0;s=0;while(1){if((e&255)>>>0<=s>>>0){break j}e=Wb(v[a+484360>>2],w[q|0]);h=c>>>0>63;p=h+p|0;f=p&65535;if(Rc(v[e>>2],v[e+4>>2])>>>0<=f>>>0){v[23540]=0;R(324,e|0,p+1&65535);e=v[23540];v[23540]=0;if((e|0)==1){break c}v[23540]=0;n=Q(359,y|0,64)|0;e=v[23540];v[23540]=0;if((e|0)==1){break c}e=Wb(v[a+484360>>2],w[q|0]);F=cc(v[e>>2],f),G=n,u[F>>1]=G}m=v[a+484344>>2];o=v[D>>2];n=x[cc(v[e>>2],f)>>1];if(!xe(m,o,n)){break j}f=0;e=_b(m,n);m=h?0:c;e=jd(v[e>>2],v[v[e+48>>2]+12>>2],m,w[k+2|0]);l:{while(1){if((f|0)==(j|0)){c=w[d+93|0];if(c>>>0<=j>>>0){break l}v[23540]=0;Q(188,b|0,B(c-j|0,5)|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){break l}break c}v[23540]=0;R(635,d+72|0,b|0);c=v[23540];v[23540]=0;if((c|0)!=1){c=d+72|0;h=Oc(c);E=Te(c);l=Li(c);o=jc(c);c=w[d+72|0];A=c-1&255;m:{if(A>>>0<=142){c=(B((c&240)>>>4|0,12)+(c&15)|0)+13|0;t[e|0]=c;t[(d+16|0)+f|0]=c;break m}t[e|0]=0}c=w[h|0];t[e+2|0]=1;t[e+1|0]=c;c=w[E|0];n:{if((c|0)!=255){t[e+4|0]=c;break n}t[e+2|0]=0}c=w[l|0];o:{if(c>>>0>22){break o}t[e+3|0]=w[c+27056|0];h=w[o|0];t[e+5|0]=h;c=e+5|0;p:{switch(w[l|0]-4|0){case 3:t[c|0]=h&3|64;break o;case 4:t[c|0]=h&3|48;break o;case 7:l=v[i>>2];if(uc(l,v[i+4>>2])>>>0<=h>>>0){break o}o=c;c=Eb(l,h);c=w[c|0]|w[c+1|0]<<8;t[o|0]=c>>>6;h=_b(v[a+484344>>2],n);h=jd(v[h>>2],v[v[h+48>>2]+12>>2],m,x[a+480188>>1]-1&65535);t[h+5|0]=c&63;t[h+3|0]=14;break o;case 8:o=c;c=v[d+60>>2];t[o|0]=c>>>6;h=_b(v[a+484344>>2],n);h=jd(v[h>>2],v[v[h+48>>2]+12>>2],m,x[a+480188>>1]-1&65535);t[h+5|0]=c&63;t[h+3|0]=14;break o;case 10:t[c|0]=h&15|128;break o;case 12:t[d+15|0]=15;F=c,G=w[Yb(c,d+15|0)|0]|208,t[F|0]=G;break o;case 13:t[d+15|0]=15;F=c,G=w[Yb(c,d+15|0)|0]|192,t[F|0]=G;break o;case 14:t[d+15|0]=15;F=c,G=w[Yb(c,d+15|0)|0]|224,t[F|0]=G;break o;case 0:case 16:case 17:if(!(h&15)){break o}l=h&240;if(!l|(l|0)==240){break o}t[c|0]=h|15;break o;case 9:case 18:break p;default:break o}}if(A>>>0<143){break o}t[e|0]=w[(d+16|0)+f|0]}e=e+6|0;f=f+1|0;continue}break}break c}c=m+1|0;s=s+1|0;e=w[d+92|0];continue}}a=Wb(v[a+484360>>2],w[a+484376|0]);F=d,G=Fb(v[a>>2]),v[F+88>>2]=G;b=Fb(v[a+4>>2]);c=65535;while(1){a=v[d+88>>2];if(!Pb(a,b)){break e}if(x[a>>1]==65535){q:{if((c&65535)!=65535){break q}v[23540]=0;c=Q(359,y|0,64)|0;f=v[23540];v[23540]=0;if((f|0)!=1){break q}break c}u[a>>1]=c}Se(d+88|0);continue}}Le(d- -64|0);continue}}}else{u[((e<<5)+a|0)+480284>>1]=B(w[(d+e|0)+268|0],17);e=e+1|0;continue}break}wc(r);wc(z);wc(i)}kb=d+304|0;return g|0}a=P()|0;O()|0;wc(r);wc(z);break a}a=P()|0;O()|0}wc(i);T(a|0);L()}function NN(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=C(0),r=0,s=0,A=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=C(0),S=C(0),T=0,U=0,V=0,W=C(0),X=0;m=kb-48|0;kb=m;t[m+40|0]=0;h=b+223848|0;j=m+40|0;Qi(h,Th(e,zi(e,ho(e),j))+1|0);re(j,v[h>>2],v[b+223852>>2]);h=kb-16|0;kb=h;t[h+15|0]=0;hc(m+32|0,e,Th(e,zi(e,ho(e),h+15|0)));kb=h+16|0;G=v[m+32>>2];H=v[m+36>>2];i=kb-16|0;kb=i;I=a+906300|0;r=a+1074312|0;n=B(c,872)+b|0;J=n+1415|0;K=n+1304|0;L=n+1392|0;D=n+1368|0;E=n+1364|0;M=n+1336|0;N=n+1308|0;O=n+1300|0;P=n+1280|0;Q=n+1402|0;p=n+1466|0;R=C(w[p|0]);S=C(f>>>0);F=n+616|0;l=v[n+1272>>2];T=a+480188|0;k=1;o=255;while(1){if((s|0)!=(H|0)&y[j+4>>2]>g>>>0){e=w[Lb(G,s)|0];h=e-48|0;a:{b:{c:{if((h&255)>>>0<=9){break c}if((e-65&255)>>>0<=5){h=e-55|0;break c}d:{e:{f:{switch(e-97|0){case 2:g:{e=Ml(a,b,c,3,0)-1|0;if((e&255)>>>0>249){break g}e=v[Md(I,e)>>2];if(!e){break g}e=Ly(e,47560,44616);if(!e){break g}h=ob[v[v[e>>2]+192>>2]](e,F,c)|0;e=(h|0)!=255;h=e?h:0;if(e|!l){break c}break d}if(l){break d}h=0;break c;case 21:Db(i+8|0,r,28);h:{if(!Cb(v[v[i+8>>2]>>2],v[i+12>>2])){Db(i,r,1);e=0;if(!Cb(v[v[i>>2]>>2],v[i+4>>2])){break h}}e=u[L>>1]}h=B(v[D>>2],v[E>>2]);e=B(v[a+1074456>>2],e+v[K>>2]|0);e=Zb((Hc(Kka(Jka(h,h>>31,e,e>>31),nb,1048576,0),nb)|0)/2|0,1,127);break e;case 20:e=B(v[D>>2],v[E>>2]);h=e;A=e>>31;e=B(v[a+1074456>>2],v[M>>2]);e=Zb((Hc(Kka(Jka(h,A,e,e>>31),nb,67108864,0),nb)|0)/2|0,1,127);break e;case 23:v[i+8>>2]=v[N>>2]/2;v[i>>2]=127;e=v[td(i+8|0,i)>>2];break e;case 24:v[i+8>>2]=v[O>>2]/2;v[i>>2]=127;e=v[td(i+8|0,i)>>2];break e;case 0:e=0;if(!l){break e}h=x[l+28>>1];if(!h){break e}e=h-1>>>7&127;break e;case 1:e=0;if(!l){break e}h=x[l+28>>1];if(!h){break e}e=h-1&127;break e;case 14:e=v[P>>2]>>>8|0;break e;case 7:e=(x[T>>1]<=c>>>0?w[Q|0]-1|0:c)&127;break e;case 12:e=w[n+704|0]>>>7|0;break e;case 15:e=0;if(!l){break e}h=w[l+30|0];if(!h){break e}e=h-1&127;break e;case 25:i:{if(!d|t[p|0]<0){break i}j:{if(g>>>0<3){break j}e=v[j>>2];if(w[Lb(e,g-3|0)|0]!=240){break j}if(w[Lb(e,g-2|0)|0]>239){break i}}q=Up(b,R,S);k:{if(q<C(4294967296)&q>=C(0)){e=~~q>>>0;break k}e=0}t[p|0]=e;o=128;break e}o=(o&255)==255?f:o;e=f;break e;case 18:l:{if(!g){h=0;break l}e=v[j>>2];h=g;while(1){h=h-1|0;A=Lb(e,h);if(!h){break l}if(w[A|0]!=240){continue}break}}if(g-h>>>0<5){break a}A=v[j>>2];if(w[Lb(A,h)|0]!=240){break a}h=h+5|0;e=0;while(1){if((g|0)!=(h|0)){e=w[Lb(A,h)|0]+e|0;h=h+1|0;continue}break};e=0-e&127;break e;case 13:break f;default:break a}}e=w[J|0];e=$c(e)?e-1|0:0}h=((k^-1)&1)+g|0;U=Lb(v[j>>2],h),V=e,t[U|0]=V;g=h+1|0;k=1;break b}e=x[F+786>>1];h=(e?e-1|0:c)&15;e=w[l+31|0];if((e|0)!=17){h=vj(e)?e-1&15:0}}e=Lb(v[j>>2],g);m:{if(k){t[e|0]=h;break m}t[e|0]=w[e|0]<<4|h;g=g+1|0}k=(k^-1)&1}}s=s+1|0;continue}else{if(o<<24>>24>=0){t[p|0]=o}gc(i+8|0,v[j>>2],((k^-1)&1)+g|0);e=v[i+12>>2];v[j>>2]=v[i+8>>2];v[j+4>>2]=e;kb=i+16|0}break}p=v[m+44>>2];h=0;n:while(1){n=0;while(1){e=h;o:{p:{q:{r:{while(1){if(y[m+44>>2]<=e>>>0){break o}f=v[m+40>>2];k=Lb(f,e);g=t[k|0];if((g|0)==-16){g=e;if(p-g>>>0>=4){h=4;if((w[Lb(f,e+1|0)|0]&254)==240){break p}}s:{while(1){g=g+1|0;if(p>>>0<=g>>>0){break s}if(w[Lb(f,g)|0]!=247){continue}break}h=(g-e|0)+1|0;if(h){break p}}U=Lb(f,p),V=247,t[U|0]=V;p=p+1|0;h=p-e|0;break q}if((g|0)<0){break r}if(n&255){e=e-1|0;U=Lb(f,e),V=n,t[U|0]=V;continue}break}h=h+1|0;continue n}U=m,V=MP(g&255),v[U+16>>2]=V;v[m+28>>2]=p-e;h=v[Kb(m+16|0,m+28|0)>>2]}if(!h){break o}f=v[m+40>>2];k=Lb(f,e)}s=w[k|0];Eq(m+16|0,f,v[m+44>>2],e,h);i=v[hc(m+8|0,v[m+16>>2],v[m+20>>2])>>2];k=kb-32|0;kb=k;f=v[m+12>>2];t:{if(!f){break t}j=Qd(w[b+223884|0]);u:{l=Lb(i,0);g=w[l|0]-250|0;if(g>>>0>5|!(1<<g&37)){break u}o=x[a+480188>>1];g=0;while(1){if((g|0)==(o|0)){break u}r=(B(g,872)+b|0)+1453|0;t[r|0]=127;t[r+1|0]=0;g=g+1|0;continue}}v:{if((f|0)!=4|w[l|0]!=240){break v}g=w[Lb(i,1)|0];if((g&254)!=240){break v}l=(B(c,872)+b|0)+616|0;o=Lb(i,2);i=w[Lb(i,3)|0];f=i<<24>>24;w:{x:{y:{z:{A:{B:{o=w[o|0];switch(o|0){case 3:break y;case 2:break z;case 1:break A;case 0:break B;default:break x}}if((g|0)==241|(f|0)<0){break x}g=B(c,872)+b|0;i=g+1453|0;if(d){f=jh(Up(b,C(w[i|0]),C((f&255)>>>0)))}t[i|0]=f;t[g+1412|0]=0;f=Zp(a,l,!(v[g+704>>2]&32768),256);if((f|0)<0|!(w[g+705|0]&2)){break t}g=v[a+1298300>>2];if(j|zd(g)^1){break t}cq(g,c,f>>>2&255,1);break t}if((g|0)==241|(f|0)<0){break x}g=B(c,872)+b|0;i=g+1454|0;if(d){f=jh(Up(b,C(w[i|0]),C((f&255)>>>0)))}t[i|0]=f;t[g+1411|0]=0;Zp(a,l,!(v[g+704>>2]&32768),256);break t}if((g|0)==241){break w}if(f>>>0>31){break t}g=B(c,872)+b|0;t[g+1461|0]=(f&240)>>>4;Zp(a,l,!(v[g+704>>2]&32768),256);break t}if((g|0)==241){break w}g=(f|0)<0;f=Ml(a,b,c,3,0)-1|0;if(g|(f&255)>>>0>249){break t}t[k+24|0]=f;g=Md(a+906300|0,f&255);f=v[g>>2];if(!f){break t}q=C(C(127-i|0)/C(127));if(j){j=0;i=kb-16|0;kb=i;U=i,V=Aj(k+24|0),v[U>>2]=V;f=kb-16|0;kb=f;l=b+223860|0;o=Ky(l,f+12|0,w[k+24|0]);g=v[o>>2];if(!g){g=kb-16|0;kb=g;j=jc(l);r=lh(f,vc(24),mh(g+8|0,j));j=v[r>>2];D=w[v[i>>2]];v[j+20>>2]=0;t[j+16|0]=D;U=jc(r),V=1,t[U+4|0]=V;kb=g+16|0;Jg(l,v[f+12>>2],o,v[f>>2]);g=ce(f);rk(f);j=1}Ig(i+8|0,v[fc(f,g)>>2],j);kb=f+16|0;f=vd(v[i+8>>2]);kb=i+16|0;z[f+4>>2]=q;break t}if(!d){ct(v[f+20>>2],q);break t}ct(v[f+20>>2],Up(b,z[g+144>>2],q));break t}if(o&128){break w}if((g|0)!=241){break t}}l=Ml(a,b,c,3,0)-1|0;if((f|0)<0|(l&255)>>>0>249){break t}i=v[Md(a+906300|0,l&255)>>2];if(!i){break t}g=(g|0)==241?o+128|0:o&127;q=C(C((f&255)>>>0)/C(127));if(j){U=aO(b+223872|0,rN(k+24|0,l,g)),W=q,z[U>>2]=W;break t}f=v[i>>2];if(!d){ob[v[f+44>>2]](i,g,q);break t}V=i,X=g,W=Up(b,C(ob[v[f+48>>2]](i,g)),q),U=v[v[i>>2]+44>>2],ob[U](V|0,X|0,C(W));break t}if(j){break t}j=x[a+480188>>1];C:{if(j>>>0>c>>>0){g=c+1|0;break C}g=x[(B(c,872)+b|0)+1402>>1];if(!g){break t}}if(w[(B(c,872)+b|0)+707|0]&4|j>>>0<(g&65535)>>>0){break t}g=Ml(a,b,c,3,0)-1|0;if((g&255)>>>0>249){break t}g=v[Md(a+906300|0,g)>>2];if(!g){break t}j=w[l|0];if((j|0)==240){_g(k+16|0,i,f);f=v[v[g>>2]+72>>2];i=v[k+20>>2];v[k>>2]=v[k+16>>2];v[k+4>>2]=i;ob[f|0](g,k)|0;break t}U=k,X=MP(j),v[U+24>>2]=X;v[k+12>>2]=f;f=k+24|0;j=v[Kb(f,k+12|0)>>2];v[k+24>>2]=0;sc(f,i,j);ob[v[v[g>>2]+68>>2]](g,v[k+24>>2])|0}kb=k+32|0;n=s>>>0<240?s:n;h=e+h|0;continue}break}break}kb=m+48|0}function f$(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,x=0,y=0,z=0,A=0,B=0,C=0;l=kb-560|0;kb=l;v[l+548>>2]=k;v[l+552>>2]=b;a:{b:{c:{d:{if(ak(a,l+552|0)){v[f>>2]=v[f>>2]|4;a=0;break d}v[l+96>>2]=1154;b=l+96|0;s=se(l+136|0,l+144|0,b);m=v[s>>2];v[l+132>>2]=m;v[l+128>>2]=m+400;y=Nb(b);o=Nb(l+80|0);q=Nb(l- -64|0);p=Nb(l+48|0);u=Nb(l+32|0);v[23540]=0;na(1163,c|0,d|0,l+120|0,l+116|0,l+112|0,y|0,o|0,q|0,p|0,l+28|0);b=v[23540];v[23540]=0;if((b|0)!=1){v[j>>2]=v[i>>2];z=e&512;A=z>>>9|0;k=v[l+28>>2];e=0;while(1){e:{f:{g:{h:{i:{j:{k:{l:{if((e|0)==4){break l}v[23540]=0;b=Q(1137,a|0,l+552|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break c}if(!b){break l}m:{n:{o:{p:{q:{switch(t[(l+120|0)+e|0]){case 1:if((e|0)==3){break e}b=v[a>>2];v[23540]=0;b=S(1139,b|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break c}v[23540]=0;b=W(1164,h|0,8192,b|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break c}if(b){v[23540]=0;R(1165,l+16|0,a|0);b=v[23540];v[23540]=0;if((b|0)!=1){v[23540]=0;R(49,u|0,v[l+16>>2]);b=v[23540];v[23540]=0;if((b|0)!=1){break p}}a=P()|0;O()|0;break a}v[f>>2]=v[f>>2]|4;a=0;break i;case 4:break m;case 2:break n;case 3:break o;case 0:break q;default:break e}}if((e|0)==3){break e}}while(1){v[23540]=0;b=Q(1137,a|0,l+552|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break b}if(!b){break e}b=v[a>>2];v[23540]=0;b=S(1139,b|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break b}v[23540]=0;b=W(1164,h|0,8192,b|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break b}if(!b){break e}v[23540]=0;R(1165,l+16|0,a|0);b=v[23540];v[23540]=0;if((b|0)!=1){v[23540]=0;R(49,u|0,v[l+16>>2]);b=v[23540];v[23540]=0;if((b|0)!=1){continue}}break}a=P()|0;O()|0;break a}r:{if(!Hb(q)){break r}b=v[a>>2];v[23540]=0;b=S(1139,b|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break c}if((b|0)!=v[Ac(q)>>2]){break r}v[23540]=0;S(1141,a|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break c}t[g|0]=0;r=Hb(q)>>>0>1?q:r;break e}s:{if(!Hb(p)){break s}b=v[a>>2];v[23540]=0;b=S(1139,b|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break c}if((b|0)!=v[Ac(p)>>2]){break s}v[23540]=0;S(1141,a|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break c}t[g|0]=1;r=Hb(p)>>>0>1?p:r;break e}c=Hb(q);b=Hb(p);t:{if(c){if(!b){break t}v[f>>2]=v[f>>2]|4;a=0;break i}if(!b){break e}}B=g,C=!Hb(p),t[B|0]=C;break e}if(!(e>>>0<2|r|((e|0)==2&w[l+123|0]!=0|A))){r=0;break e}c=fc(l+16|0,he(o));u:{v:{if(!e|w[(e+l|0)+119|0]>1){break v}while(1){w:{b=Tk(o);d=v[c>>2];if(!Pb(d,b)){break w}b=v[d>>2];v[23540]=0;b=W(1164,h|0,8192,b|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break u}if(!b){break w}Le(c);continue}break}b=he(o);b=au(v[c>>2],b);if(Hb(u)>>>0>=b>>>0){d=ym(Tk(u),0-b|0);n=Tk(u);x=he(o);b=kb-16|0;kb=b;v[b>>2]=x;v[b+8>>2]=d;while(1){x:{x=Pb(d,n);if(!x){break x}if(!pc(v[d>>2],v[v[b>>2]>>2])){break x}d=Le(b+8|0);Le(b);d=v[d>>2];continue}break}kb=b+16|0;if(x^1){break v}}B=c,C=v[fc(l+8|0,he(o))>>2],v[B>>2]=C}v[l+8>>2]=v[c>>2];y:{while(1){b=Tk(o);if(!Pb(v[l+8>>2],b)){break y}v[23540]=0;b=Q(1137,a|0,l+552|0)|0;c=v[23540];v[23540]=0;z:{if((c|0)==1){break z}if(!b){break y}b=v[a>>2];v[23540]=0;b=S(1139,b|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break z}if((b|0)!=v[v[l+8>>2]>>2]){break y}v[23540]=0;S(1141,a|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break f}Le(l+8|0);continue}break}break f}if(!z){break e}b=Tk(o);if(!Pb(v[l+8>>2],b)){break e}v[f>>2]=v[f>>2]|4;a=0;break i}break f}b=0;n=v[l+112>>2];A:{while(1){B:{v[23540]=0;c=Q(1137,a|0,l+552|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break B}if(!c){break A}c=v[a>>2];v[23540]=0;c=S(1139,c|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break h}v[23540]=0;d=W(1164,h|0,2048,c|0)|0;x=v[23540];v[23540]=0;if((x|0)==1){break h}C:{if(d){d=v[j>>2];if((d|0)==v[l+548>>2]){v[23540]=0;U(1166,i|0,j|0,l+548|0);d=v[23540];v[23540]=0;if((d|0)==1){break h}d=v[j>>2]}v[j>>2]=d+4;v[d>>2]=c;b=b+1|0;break C}if(!Hb(y)|!b|(c|0)!=(n|0)){break A}if(v[l+128>>2]==(m|0)){v[23540]=0;U(1160,s|0,l+132|0,l+128|0);c=v[23540];v[23540]=0;if((c|0)==1){break h}m=v[l+132>>2]}c=m+4|0;v[l+132>>2]=c;v[m>>2]=b;m=c;b=0}v[23540]=0;S(1141,a|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){continue}}break}a=P()|0;O()|0;break a}if(!b|v[s>>2]==(m|0)){break k}if(v[l+128>>2]==(m|0)){v[23540]=0;U(1160,s|0,l+132|0,l+128|0);c=v[23540];v[23540]=0;if((c|0)==1){break g}m=v[l+132>>2]}c=m+4|0;v[l+132>>2]=c;v[m>>2]=b;break j}v[l+28>>2]=k;D:{if(!r){break D}k=1;while(1){if(Hb(r)>>>0<=k>>>0){break D}v[23540]=0;b=Q(1138,a|0,l+552|0)|0;c=v[23540];v[23540]=0;E:{if((c|0)==1){break E}F:{if(!b){b=v[a>>2];v[23540]=0;b=S(1139,b|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break E}if((b|0)==v[qj(r,k)>>2]){break F}}v[f>>2]=v[f>>2]|4;a=0;break i}v[23540]=0;S(1141,a|0)|0;b=v[23540];v[23540]=0;k=k+1|0;if((b|0)!=1){continue}}break}a=P()|0;O()|0;break a}a=1;b=v[s>>2];if((b|0)==(m|0)){break i}a=0;v[l+16>>2]=0;Ff(y,b,m,l+16|0);if(v[l+16>>2]){v[f>>2]=v[f>>2]|4;break i}a=1;break i}c=m}G:{if((k|0)<=0){break G}v[23540]=0;b=Q(1138,a|0,l+552|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break g}H:{if(!b){b=v[a>>2];v[23540]=0;b=S(1139,b|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break g}if((b|0)==v[l+116>>2]){break H}}v[l+28>>2]=k;v[f>>2]=v[f>>2]|4;a=0;break i}v[23540]=0;d=S(1141,a|0)|0;m=v[23540];v[23540]=0;b=k;if((m|0)==1){break g}while(1){if((b|0)<=0){k=0;break G}v[23540]=0;m=Q(1138,d|0,l+552|0)|0;n=v[23540];v[23540]=0;I:{if((n|0)==1){break I}J:{if(!m){m=v[d>>2];v[23540]=0;m=S(1139,m|0)|0;n=v[23540];v[23540]=0;if((n|0)==1){break I}v[23540]=0;m=W(1164,h|0,2048,m|0)|0;n=v[23540];v[23540]=0;if((n|0)==1){break I}if(m){break J}}v[l+28>>2]=b;v[f>>2]=v[f>>2]|4;a=0;break i}if(v[j>>2]==v[l+548>>2]){v[23540]=0;U(1166,i|0,j|0,l+548|0);m=v[23540];v[23540]=0;if((m|0)==1){break I}}m=v[d>>2];v[23540]=0;m=S(1139,m|0)|0;n=v[23540];v[23540]=0;if((n|0)==1){break I}n=v[j>>2];v[j>>2]=n+4;v[n>>2]=m;v[23540]=0;S(1141,d|0)|0;m=v[23540];v[23540]=0;b=b-1|0;if((m|0)!=1){continue}}break}break f}if(v[j>>2]!=v[i>>2]){m=c;break e}v[l+28>>2]=k;v[f>>2]=v[f>>2]|4;a=0}Nc(u);Nc(p);Nc(q);Nc(o);zb(y);Xc(s);break d}a=P()|0;O()|0;break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;v[l+28>>2]=k;break a}e=e+1|0;continue}}a=P()|0;O()|0;break a}kb=l+560|0;return a|0}a=P()|0;O()|0;break a}a=P()|0;O()|0}Nc(u);Nc(p);Nc(q);Nc(o);zb(y);Xc(s);T(a|0);L()}function tW(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,y=0;e=kb-224|0;kb=e;zc(b);a:{b:{c:{d:{if(!EC(b,e+176|0)){break d}if(!HC(e+176|0)){break d}if(!c){n=1;break d}Cd(a,2048);ag(a);d=kb-16|0;kb=d;f=e+8|0;h=yc(d,3947);ad(f,h);Ab(h);kb=d+16|0;v[23540]=0;U(213,e+80|0,f|0,w[e+179|0]);d=v[23540];v[23540]=0;e:{f:{g:{h:{i:{j:{k:{if((d|0)!=1){d=e+80|0;Jb(a+1298344|0,d);Ab(d);f=e+8|0;dc(f);h=yc(d,11139);Jb(a+1298356|0,h);Ab(h);v[a+1298404>>2]=5;h=a+480188|0;u[h>>1]=w[e+216|0];u[a+480190>>1]=w[e+212|0];Ne(f,2,e+176|4);Fc(d,f);Bc(a+1298308|0,d);zb(d);d=w[e+179|0];l:{if(d>>>0>=9){if(d>>>0>=11){f=(d|0)==11?16:32;d=0;while(1){if((d|0)==(f|0)){break l}h=jv(b);m:{if((h|0)==100){v[((d<<5)+a|0)+480280>>2]=256;break m}v[e+80>>2]=(h<<1)+128;v[e+8>>2]=0;v[e+160>>2]=256;s=((d<<5)+a|0)+480284|0,y=v[Jj(e+80|0,e+8|0,e+160|0)>>2],u[s>>1]=y}d=d+1|0;continue}}f=e+80|0;d=kb-16|0;kb=d;n:{if(!Qb(v[b>>2],v[b+8>>2],16)){sC(f);break n}$u(d+8|0,f);ud(d,b,v[d+8>>2],v[d+12>>2])}kb=d+16|0;d=0;while(1){if((d|0)==16){break l}u[((d<<5)+a|0)+480284>>1]=t[(e+80|0)+d|0]&1?64:192;d=d+1|0;continue}}u[h>>1]=4;yg(b,1);oh(a,1)}o:{if(w[e+179|0]>=13){d=e+80|0;cv(d,b);f=Oc(d);d=w[e+80|0];if(d>>>0<=31){t[e+80|0]=125;d=125}v[a+480204>>2]=B(d,1e4);v[a+480196>>2]=w[f|0];break o}v[a+480196>>2]=6;v[a+480204>>2]=125e4}vg(Wb(v[a+484360>>2],w[a+484376|0]),w[e+213|0]);l=Tb(e+160|0);f=w[e+179|0];q=v[b+8>>2]+((f>>>0>13)<<1)|0;d=0;p:{if(f>>>0<14){break p}v[23540]=0;R(214,l|0,w[e+213|0]);f=v[23540];v[23540]=0;if((f|0)!=1){break p}d=P()|0;O()|0;break b}q:{r:{s:{while(1){t:{if(w[e+213|0]<=d>>>0){d=0;if(w[e+179|0]!=10){break s}m=v[b+8>>2];k=a+480190|0;d=1;while(1){j=x[k>>1];if(j>>>0<(d&65535)>>>0){break t}v[23540]=0;f=Q(215,b|0,e+80|0)|0;h=v[23540];v[23540]=0;if((h|0)==1){break r}if(f){f=0;u:{if(w[e+212|0]<(w[e+126|0]|w[e+127|0]<<8|(w[e+128|0]<<16|w[e+129|0]<<24))>>>0|w[e+80|0]>1){break u}h=w[e+130|0]|w[e+131|0]<<8|(w[e+132|0]<<16|w[e+133|0]<<24);if(h>>>0>1048576|w[e+136|0]>64|h>>>0<(w[e+137|0]|w[e+138|0]<<8|(w[e+139|0]<<16|w[e+140|0]<<24))>>>0){break u}f=h>>>0>=(w[e+141|0]|w[e+142|0]<<8|(w[e+143|0]<<16|w[e+144|0]<<24))>>>0}if(!f){break t}}d=d+1|0;continue}}s=cc(v[Wb(v[a+484360>>2],w[a+484376|0])>>2],d),y=d,u[s>>1]=y;if(w[e+179|0]>=14){v[23540]=0;f=S(194,b|0)|0;h=v[23540];v[23540]=0;if((h|0)==1){break q}s=cc(v[l>>2],d),y=f,u[s>>1]=y}f=x[a+480188>>1];v[23540]=0;Q(188,b|0,f<<1)|0;f=v[23540];v[23540]=0;if((f|0)==1){break q}d=d+1|0;continue}break}v[23540]=0;Q(155,b|0,m|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break c}d=j>>>0>=(d&65535)>>>0}j=a+480190|0;f=x[j>>1];v[23540]=0;v[e+80>>2]=0;m=W(216,e- -64|0,f|0,e+80|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break k}n=d?59:65;k=e+80|1;f=1;v:{while(1){h=f&65535;if(h>>>0>x[j>>1]){h=Tb(e+48|0);v[23540]=0;n=W(217,b|0,h|0,x[e+214>>1])|0;d=v[23540];v[23540]=0;w:{if((d|0)!=1){if(!n){break e}d=0;k=0;f=v[h>>2];if(!pc(f,v[h+4>>2])){f=Fb(f);g=Fb(v[h+4>>2]);k=kb-16|0;kb=k;x:{if(!Pb(f,g)){break x}v[k+8>>2]=f;while(1){j=v[Se(k+8|0)>>2];if(!Pb(j,g)){break x}f=Ek(w[f|0]|w[f+1|0]<<8,w[j|0]|w[j+1|0]<<8)?j:f;continue}}kb=k+16|0;k=w[f|0]|w[f+1|0]<<8}v[23540]=0;j=Q(218,e+32|0,k|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break w}y:{while(1){if((d|0)==(k|0)){if(!(c&2)){break j}i=Zc(e+80|0,8,1,0,1);o=a+480190|0;f=x[o>>1];g=1;z:{A:while(1){p=g&65535;if(p>>>0>(f&65535)>>>0){break j}d=v[b+8>>2];f=v[b>>2];v[23540]=0;d=W(156,f|0,d|0,1)|0;f=v[23540];v[23540]=0;if((f|0)==1){break z}if(!d){break j}r=v[b+8>>2];d=0;while(1){f=x[o>>1];if(f>>>0<=d>>>0){g=g+1|0;continue A}if((p|0)!=v[Eb(v[m>>2],d)>>2]){d=d+1|0;continue}v[23540]=0;Q(155,b|0,r|0)|0;f=v[23540];v[23540]=0;if((f|0)!=1){v[23540]=0;d=d+1|0;W(219,i|0,(B(d,104)+a|0)+484380|0,b|0)|0;f=v[23540];v[23540]=0;if((f|0)!=1){continue}}break}break}d=P()|0;O()|0;break i}d=P()|0;O()|0;break i}v[23540]=0;f=S(194,b|0)|0;g=v[23540];v[23540]=0;B:{if((g|0)==1){break B}v[23540]=0;Q(188,b|0,1)|0;g=v[23540];v[23540]=0;if((g|0)==1){break B}if(f){v[23540]=0;U(190,e+8|0,b|0,B(f,3)+(w[e+179|0]==1?3:0)|0);f=v[23540];v[23540]=0;if((f|0)==1){break y}g=e+8|0;f=kc(e+80|0,g);hd(Ng(v[j>>2],d),f);Bb(f);Bb(g)}d=d+1|0;continue}break}d=P()|0;O()|0;break i}d=P()|0;O()|0;break i}d=P()|0;O()|0;break h}d=P()|0;O()|0;break h}C:{D:{if(w[e+179|0]<=9){v[23540]=0;R(220,b|0,e+80|0);g=v[23540];v[23540]=0;E:{F:{if((g|0)==1){break F}v[23540]=0;R(221,e+80|0,(B(h,104)+a|0)+484380|0);g=v[23540];v[23540]=0;if((g|0)==1){break F}g=e+48|0;Ne(g,2,k);v[23540]=0;R(222,e+8|0,g|0);g=v[23540];v[23540]=0;if((g|0)==1){break E}break D}d=P()|0;O()|0;break g}d=P()|0;O()|0;break g}v[23540]=0;U(223,b|0,e+80|0,n|0);g=v[23540];v[23540]=0;if((g|0)==1){break C}v[23540]=0;U(224,e+80|0,(B(h,104)+a|0)+484380|0,d|0);g=v[23540];v[23540]=0;if((g|0)==1){break C}g=e+48|0;Ne(g,2,k);v[23540]=0;R(222,e+8|0,g|0);g=v[23540];v[23540]=0;if((g|0)==1){break v}}g=e+8|0;Dc(((h<<5)+a|0)+946304|0,g);zb(g);s=Eb(v[m>>2],h-1|0),y=x[e+126>>1]|x[e+128>>1]<<16,v[s>>2]=y;f=f+1|0;continue}break}d=P()|0;O()|0;break g}d=P()|0;O()|0;break g}d=P()|0;O()|0;break b}d=P()|0;O()|0;break b}d=P()|0;O()|0;dc(e+8|0);break a}d=P()|0;O()|0;break b}if(!(c&1)){break f}v[23540]=0;g=a+484344|0;R(225,g|0,w[e+213|0]);c=v[23540];v[23540]=0;G:{if((c|0)!=1){f=a+480188|0;a=0;while(1){H:{if(w[e+213|0]<=a>>>0){break f}d=64;c=v[l>>2];if(Rc(c,v[l+4>>2])>>>0>a>>>0){d=x[cc(c,a)>>1]}v[23540]=0;c=W(226,g|0,a&65535,d&65535)|0;d=v[23540];v[23540]=0;if((d|0)==1){break G}I:{if(c){c=x[f>>1];v[23540]=0;Q(155,b|0,B(((w[e+179|0]>13)<<1)+(c<<1)|0,a)+q|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break G}c=Tb(e+80|0);d=x[f>>1];v[23540]=0;i=W(217,b|0,c|0,d|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break I}d=0;J:{if(!i){break J}while(1){if(x[f>>1]<=d>>>0){break J}K:{i=cc(v[c>>2],d);i=w[i|0]|w[i+1|0]<<8;if(!i|i>>>0>x[e+214>>1]){break K}i=cc(v[h>>2],i-1|0);i=(w[i|0]|w[i+1|0]<<8)-1&65535;if(i>>>0>=k>>>0){break K}o=v[g>>2];p=v[j>>2];v[23540]=0;U(227,_b(o,a)|0,d&65535,Ng(p,i)|0);i=v[23540];v[23540]=0;if((i|0)!=1){break K}break H}d=d+1|0;continue}}od(c)}a=a+1|0;continue}}break}d=P()|0;O()|0;od(c);break i}d=P()|0;O()|0;break i}d=P()|0;O()|0}Vc(j)}od(h)}wc(m);break b}Vc(j)}od(h);wc(m);od(l)}kb=e+224|0;return n|0}d=P()|0;O()|0}od(l)}T(d|0);L()}function Xp(a,b,c,d,e,f){var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,z=0,A=0,C=0;g=kb-16|0;kb=g;i=x[a+480192>>1]>=c>>>0?v[((c<<2)+a|0)+900380>>2]:i;s=v[b+752>>2];k=w[b+802|0];a:{if(!k){Db(g+8|0,a+1074312|0,11);if(Cb(v[v[g+8>>2]>>2],v[g+12>>2])){break a}}b:{c:{if(!i){break c}if(!$c(k)){break c}d:{l=k-1|0;k=cc(i+236|0,l);if(x[k>>1]){break d}Db(g+8|0,a+1074312|0,43);if(!Cb(v[v[g+8>>2]>>2],v[g+12>>2])){break d}if(vj(w[i+31|0])){break d}v[b+656>>2]=i;break a}if(w[Lb(i+108|0,l)|0]>120){break a}k=x[k>>1];l=(k-1&65535)>>>0<3999?(B(k,104)+a|0)+484380|0:0;break b}l=(B(c,104)+a|0)+484380|0;if(!x[a+480192>>1]){break b}if(k>>>0>250){break a}Db(g+8|0,a+1074312|0,43);if(Cb(v[v[g+8>>2]>>2],v[g+12>>2])){if(i){l=0;if(vj(w[i+31|0])){break b}}t[b+803|0]=0;v[b+656>>2]=0;break a}l=0}k=v[b+104>>2];n=(k|0)!=0&(k|0)!=(l|0);j=v[b+656>>2];p=!i|v[a+480180>>2]!=16777216?p:v[i+44>>2]!=0;q=d^1;h=(j|0)!=(i|0);if((q|h|n)==1){u[b+774>>1]=0}r=!n;if(!(r|(h|!(d&p)))){break a}e:{if(!(d&n)){break e}k=a+1074312|0;Db(g+8|0,k,32);if(!(!Cb(v[v[g+8>>2]>>2],v[g+12>>2])|!(w[a+480208|0]&8))){l=v[b+8>>2]|v[b+12>>2]?v[b+104>>2]:l}m=v[a+480180>>2];f:{if(!(i?h|!(m&1048580):1)|(m|0)==268435456){break f}if((m|0)==1){if(Ai(v[b+8>>2],v[b+12>>2])){break f}}Db(g+8|0,k,79);if(!Cb(v[v[g+8>>2]>>2],v[g+12>>2])){break e}if(!Ai(v[b+8>>2],v[b+12>>2])){break e}}o=1}g:{if(!v[b+16>>2]|(!n|(h|!x[a+480192>>1]))){break g}Db(g+8|0,a+1074312|0,87);if(!Cb(v[v[g+8>>2]>>2],v[g+12>>2])){break g}o=$c(w[b+788|0])^1|o}h:{i:{j:{k:{l:{if(Ai(v[b+8>>2],v[b+12>>2])|!(v[a+480180>>2]&16777248)){break l}if(i){if(vj(w[i+31|0])){break l}}k=1;break k}if(!(h|n)){break j}k=(j|0)!=(i|0)}if(!d){break i}Db(g+8|0,a+1074312|0,61);if(!Cb(v[v[g+8>>2]>>2],v[g+12>>2])){break i}j=v[b+656>>2];if(!j){j=0;m=0;h=v[b+104>>2];if(!h){break i}break h}h=v[b+104>>2];m=0;break h}k=0}v[b+656>>2]=i;j=i;m=k;h=l}m:{n:{o:{if(!e){break o}p:{if(w[a+480180|0]&3){if(h){if(_d(v[h>>2],v[h+20>>2])){break p}}if(!oj(j)){break o}}if(!h){break n}}if(u[h+34>>1]<0){break o}v[b+688>>2]=x[h+30>>1]}i=(h|0)!=0;if(!(n&o)|!h){break m}Db(g+8|0,a+1074312|0,85);if(Cb(v[v[g+8>>2]>>2],v[g+12>>2])){u[b+772>>1]=t[h+37|0]}i=1;if(v[a+480180>>2]!=2){break m}if(!_d(v[h>>2],v[h+20>>2])){break m}v[b+704>>2]=v[h+24>>2];break m}if(!(!j|!w[j+34|0])){k=v[b+688>>2];if(j){k=v[j+4>>2]<<2}v[b+688>>2]=k;i=0;break m}i=0;v[b+688>>2]=0}if(o){break a}t[b+803|0]=0;q:{if(!j){break q}Db(g+8|0,a+1074312|0,29);if(!(z=1,A=(Cb(v[v[g+8>>2]>>2],v[g+12>>2])^-1)&i,C=w[j+34|0]|m,C?z:A)){break q}t[b+798|0]=w[j+16|0]}l=64;v[b+752>>2]=64;if(h){l=x[h+32>>1];v[b+752>>2]=l}if(j){v[b+752>>2]=B(v[j+4>>2],l)>>>6}r:{if(!(v[a+480180>>2]&1048580?e:1)){break r}Db(g+8|0,a+1074312|0,48);if(Cb(v[v[g+8>>2]>>2],v[g+12>>2])){break r}IN(a,b,j,h)}s:{t:{u:{if(!f){break u}f=a+1074312|0;Db(g+8|0,f,19);v:{w:{x:{y:{z:{A:{B:{C:{if(Cb(v[v[g+8>>2]>>2],v[g+12>>2])){if(!v[b+76>>2]){e=1;break B}if(!(!c|q)){e=(w[a+480208|0]&8)>>>3|0;if(e){break B}break C}e=0;if(c){break C}break B}c=v[a+480180>>2]&17301536;e=1;D:{if(!d|!c){break D}c=1;e=1;if(w[a+480208|0]&8){break D}e=1;if(!v[b+76>>2]){break D}e=0;if(!(w[b+89|0]&16)){break D}e=!v[b+696>>2]}if(!j|(!c|m)){break z}if(!e){break y}c=v[b+88>>2];e=c&6144;break A}if(d){break B}if(!(w[b+89|0]&24)){e=0;break B}e=(w[a+480208|0]&4)>>>2|0}if(!v[b+696>>2]|m){break z}if(!e){break y}c=v[b+88>>2];e=c&2048}v[b+88>>2]=c|2097152;if(!j){break v}if(e){break w}if(!(w[j+60|0]&8)){nj(b+724|0)}if(!(w[j+80|0]&8)){nj(b+732|0)}if(w[j+100|0]&8){break v}nj(b+740|0);break v}if(e){break x}}if(j){if(t[j+60|0]&1){break u}Db(g+8|0,f,32);if(Cb(v[v[g+8>>2]>>2],v[g+12>>2])){nj(b+724|0);break u}tm(b);break u}c=0;if(!h){break t}break s}v[b+88>>2]=v[b+88>>2]|2097152;if(!j){break v}}tm(b)}Db(g+8|0,f,21);if(Cb(v[v[g+8>>2]>>2],v[g+12>>2])){break u}t[b+818|0]=0;v[b+756>>2]=0}c=0;if(h){break s}if(!j){break t}c=1;if(vj(w[j+31|0])){break s}}v[b+752>>2]=0;v[b+104>>2]=0;break a}E:{F:{G:{H:{I:{if(!(!d|(i^1|v[b+104>>2]!=(h|0)))){d=v[a+480180>>2];if(v[b+76>>2]?d&16777250:0){break a}if((d|0)!=4){break I}Db(g+8|0,a+1074312|0,40);if(!Cb(v[v[g+8>>2]>>2],v[g+12>>2])|w[b+789|0]){break I}d=v[b+88>>2];break H}v[b+88>>2]=v[b+88>>2]&-6145;e=a+1074312|0;Db(g+8|0,e,18);J:{if(z=Cb(v[v[g+8>>2]>>2],v[g+12>>2]),A=1,C=v[a+480180>>2]&16777248,C?z:A){f=-640;if(!(v[b+104>>2]!=(h|0)|m)){break J}}f=-768}v[b+88>>2]=f&v[b+88>>2];K:{if(!j){break K}t[b+730|0]=w[j+60|0];t[b+738|0]=w[j+80|0];t[b+746|0]=w[j+100|0];L:{if((w[j+100|0]&17)!=17){break L}Db(g+8|0,e,36);if(Cb(v[v[g+8>>2]>>2],v[g+12>>2])|w[b+837|0]){break L}t[b+837|0]=127}e=w[j+21|0];if(kf(e)){z=b,A=br(e),t[z+837|0]=A}e=w[j+22|0];if(!kf(e)){break K}z=b,A=br(e),t[z+838|0]=A}if(c){break G}if(!d){break E}break F}d=v[b+88>>2]&-6145}v[b+88>>2]=d&-640;if(!c){break F}}v[b+76>>2]=0;v[b+104>>2]=0;break a}if(v[b+76>>2]){break E}c=a+1074312|0;Db(g+8|0,c,54);if(!Cb(v[v[g+8>>2]>>2],v[g+12>>2])){Db(g,c,39);if(!Cb(v[v[g>>2]>>2],v[g+4>>2])){break E}}v[b+8>>2]=0;v[b+12>>2]=0}M:{if(w[b+788|0]!=255){break M}Db(g+8|0,a+1074312|0,100);if(!Cb(v[v[g+8>>2]>>2],v[g+12>>2])|(!(v[a+480208>>2]&4)|r)){break M}c=v[b+104>>2];if(c){v[b+88>>2]=v[b+88>>2]|x[c+34>>1]&1023}v[b+752>>2]=s;v[b+688>>2]=x[h+30>>1];if(!(w[h+34|0]&32)){break a}eq(b,x[h+28>>1],a);break a}v[b+104>>2]=h;v[b+76>>2]=v[h>>2];v[b+80>>2]=v[h+4>>2];v[b+84>>2]=v[h+8>>2];e=a+1074312|0;Db(g+8|0,e,83);if(!(!Cb(v[v[g+8>>2]>>2],v[g+12>>2])|v[b+80>>2])){v[b+84>>2]=v[h>>2]}v[b+88>>2]=v[b+88>>2]|x[h+34>>1]&1023;Db(g+8|0,e,21);if(Cb(v[v[g+8>>2]>>2],v[g+12>>2])){t[b+818|0]=0;v[b+756>>2]=0}N:{O:{if(p){v[b+704>>2]=v[h+24>>2];t[b+851|0]=w[b+851|0]|64;c=0;break O}if(!(n|q)){d=v[a+480180>>2];if(d&5){break N}}v[b+704>>2]=v[h+24>>2];c=t[h+37|0]}u[b+772>>1]=c;d=v[a+480180>>2]}if(Km(d)){c=t[h+36|0]}else{c=0}u[b+770>>1]=c;Db(g+8|0,e,69);if(!(Cb(v[v[g+8>>2]>>2],v[g+12>>2])|v[a+480180>>2]==1)){v[b+708>>2]=0}v[b+852>>2]=0;i=v[b+88>>2];if(i&8){v[b+80>>2]=v[h+12>>2];v[b+84>>2]=v[h+16>>2];i=i>>>2&4|i|2;v[b+88>>2]=i}P:{if(!(i&2)){i=v[b+76>>2];break P}i=v[b+76>>2];c=v[b+84>>2];if(i>>>0<=c>>>0){break P}v[b+76>>2]=c;i=c}if(!(v[a+480180>>2]&16777248)|y[b+4>>2]<i>>>0){break a}v[b>>2]=0;v[b+4>>2]=0}kb=g+16|0}function m$(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,x=0,y=0,z=0,A=0,B=0,C=0;l=kb-560|0;kb=l;v[l+548>>2]=k;v[l+552>>2]=b;a:{b:{c:{d:{if(bj(a,l+552|0)){v[f>>2]=v[f>>2]|4;a=0;break d}v[l+104>>2]=1154;b=l+104|0;s=se(l+136|0,l+144|0,b);m=v[s>>2];v[l+132>>2]=m;v[l+128>>2]=m+400;x=Nb(b);o=Nb(l+88|0);q=Nb(l+72|0);p=Nb(l+56|0);u=Nb(l+40|0);v[23540]=0;na(1157,c|0,d|0,l+120|0,l+119|0,l+118|0,x|0,o|0,q|0,p|0,l+36|0);b=v[23540];v[23540]=0;if((b|0)!=1){v[j>>2]=v[i>>2];y=e&512;z=y>>>9|0;d=v[l+36>>2];k=h;h=0;while(1){e:{f:{g:{h:{i:{j:{k:{if((h|0)==4){break k}v[23540]=0;b=Q(1121,a|0,l+552|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break c}if(!b){break k}l:{m:{n:{o:{p:{switch(t[(l+120|0)+h|0]){case 1:if((h|0)==3){break e}b=v[a>>2];v[23540]=0;b=S(1123,b|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break c}if(vh(v[k+8>>2],8192,b)){v[23540]=0;R(1158,l+24|0,a|0);b=v[23540];v[23540]=0;if((b|0)!=1){v[23540]=0;R(47,u|0,t[l+24|0]);b=v[23540];v[23540]=0;if((b|0)!=1){break o}}a=P()|0;O()|0;break a}v[f>>2]=v[f>>2]|4;a=0;break h;case 4:break l;case 2:break m;case 3:break n;case 0:break p;default:break e}}if((h|0)==3){break e}}while(1){v[23540]=0;b=Q(1121,a|0,l+552|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break b}if(!b){break e}b=v[a>>2];v[23540]=0;b=S(1123,b|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break b}if(!vh(v[k+8>>2],8192,b)){break e}v[23540]=0;R(1158,l+24|0,a|0);b=v[23540];v[23540]=0;if((b|0)!=1){v[23540]=0;R(47,u|0,t[l+24|0]);b=v[23540];v[23540]=0;if((b|0)!=1){continue}}break}a=P()|0;O()|0;break a}q:{if(!Hb(q)){break q}b=v[a>>2];v[23540]=0;b=S(1123,b|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break c}if(w[Tc(q,0)|0]!=(b&255)){break q}v[23540]=0;S(1125,a|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break c}t[g|0]=0;r=Hb(q)>>>0>1?q:r;break e}r:{if(!Hb(p)){break r}b=v[a>>2];v[23540]=0;b=S(1123,b|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break c}if(w[Tc(p,0)|0]!=(b&255)){break r}v[23540]=0;S(1125,a|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break c}t[g|0]=1;r=Hb(p)>>>0>1?p:r;break e}c=Hb(q);b=Hb(p);s:{if(c){if(!b){break s}v[f>>2]=v[f>>2]|4;a=0;break h}if(!b){break e}}B=g,C=!Hb(p),t[B|0]=C;break e}if(!(h>>>0<2|r|((h|0)==2&w[l+123|0]!=0|z))){r=0;break e}B=l,C=he(o),v[B+16>>2]=C;c=kj(l+24|0,l+16|0);t:{if(!h|w[(h+l|0)+119|0]>1){break t}while(1){u:{B=l,C=yh(o),v[B+16>>2]=C;if(!pj(c,l+16|0)){break u}if(!vh(v[k+8>>2],8192,t[v[c>>2]])){break u}Ke(c);continue}break}B=l,C=he(o),v[B+16>>2]=C;b=Pn(c,l+16|0);if(Hb(u)>>>0>=b>>>0){B=l,C=yh(u),v[B+16>>2]=C;e=Jp(l+16|0,0-b|0);n=yh(u);A=he(o);b=kb-32|0;kb=b;v[b+16>>2]=n;v[b+24>>2]=e;v[b+8>>2]=A;while(1){e=pj(b+24|0,b+16|0);if(!(!e|w[v[b+24>>2]]!=w[v[b+8>>2]])){Ke(b+24|0);Ke(b+8|0);continue}break}kb=b+32|0;if(e^1){break t}}B=l,C=he(o),v[B+8>>2]=C;B=c,C=v[kj(l+16|0,l+8|0)>>2],v[B>>2]=C}v[l+16>>2]=v[c>>2];v:{w:{while(1){B=l,C=yh(o),v[B+8>>2]=C;if(!pj(l+16|0,l+8|0)){break v}v[23540]=0;b=Q(1121,a|0,l+552|0)|0;c=v[23540];v[23540]=0;x:{if((c|0)==1){break x}if(!b){break v}b=v[a>>2];v[23540]=0;b=S(1123,b|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break x}if(w[v[l+16>>2]]!=(b&255)){break v}v[23540]=0;S(1125,a|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break w}Ke(l+16|0);continue}break}a=P()|0;O()|0;v[l+36>>2]=d;break a}a=P()|0;O()|0;v[l+36>>2]=d;break a}if(!y){break e}B=l,C=yh(o),v[B+8>>2]=C;if(!pj(l+16|0,l+8|0)){break e}v[f>>2]=v[f>>2]|4;a=0;break h}b=0;n=w[l+118|0];y:{while(1){z:{v[23540]=0;c=Q(1121,a|0,l+552|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break z}if(!c){break y}c=v[a>>2];v[23540]=0;e=S(1123,c|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break g}A:{if(vh(v[k+8>>2],2048,e)){c=v[j>>2];if((c|0)==v[l+548>>2]){v[23540]=0;U(1159,i|0,j|0,l+548|0);c=v[23540];v[23540]=0;if((c|0)==1){break g}c=v[j>>2]}v[j>>2]=c+1;t[c|0]=e;b=b+1|0;break A}if(!Hb(x)|!b|(n|0)!=(e&255)){break y}if(v[l+128>>2]==(m|0)){v[23540]=0;U(1160,s|0,l+132|0,l+128|0);c=v[23540];v[23540]=0;if((c|0)==1){break g}m=v[l+132>>2]}c=m+4|0;v[l+132>>2]=c;v[m>>2]=b;m=c;b=0}v[23540]=0;S(1125,a|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){continue}}break}a=P()|0;O()|0;break a}if(!b|v[s>>2]==(m|0)){break j}if(v[l+128>>2]==(m|0)){v[23540]=0;U(1160,s|0,l+132|0,l+128|0);c=v[23540];v[23540]=0;if((c|0)==1){break f}m=v[l+132>>2]}e=m+4|0;v[l+132>>2]=e;v[m>>2]=b;break i}v[l+36>>2]=d;B:{if(!r){break B}k=1;while(1){if(Hb(r)>>>0<=k>>>0){break B}v[23540]=0;b=Q(1122,a|0,l+552|0)|0;c=v[23540];v[23540]=0;C:{if((c|0)==1){break C}D:{if(!b){b=v[a>>2];v[23540]=0;b=S(1123,b|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break C}if(w[hg(r,k)|0]==(b&255)){break D}}v[f>>2]=v[f>>2]|4;a=0;break h}v[23540]=0;S(1125,a|0)|0;b=v[23540];v[23540]=0;k=k+1|0;if((b|0)!=1){continue}}break}a=P()|0;O()|0;break a}a=1;b=v[s>>2];if((b|0)==(m|0)){break h}a=0;v[l+24>>2]=0;Ff(x,b,m,l+24|0);if(v[l+24>>2]){v[f>>2]=v[f>>2]|4;break h}a=1;break h}e=m}E:{if((d|0)<=0){break E}v[23540]=0;b=Q(1122,a|0,l+552|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break f}F:{if(!b){b=v[a>>2];v[23540]=0;b=S(1123,b|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break f}if(w[l+119|0]==(b&255)){break F}}v[l+36>>2]=d;v[f>>2]=v[f>>2]|4;a=0;break h}v[23540]=0;c=S(1125,a|0)|0;m=v[23540];v[23540]=0;b=d;if((m|0)==1){break f}while(1){if((b|0)<=0){d=0;break E}v[23540]=0;m=Q(1122,c|0,l+552|0)|0;n=v[23540];v[23540]=0;G:{if((n|0)==1){break G}H:{if(!m){m=v[c>>2];v[23540]=0;m=S(1123,m|0)|0;n=v[23540];v[23540]=0;if((n|0)==1){break G}if(vh(v[k+8>>2],2048,m)){break H}}v[l+36>>2]=b;v[f>>2]=v[f>>2]|4;a=0;break h}if(v[j>>2]==v[l+548>>2]){v[23540]=0;U(1159,i|0,j|0,l+548|0);m=v[23540];v[23540]=0;if((m|0)==1){break G}}m=v[c>>2];v[23540]=0;m=S(1123,m|0)|0;n=v[23540];v[23540]=0;if((n|0)==1){break G}n=v[j>>2];v[j>>2]=n+1;t[n|0]=m;v[23540]=0;S(1125,c|0)|0;m=v[23540];v[23540]=0;b=b-1|0;if((m|0)!=1){continue}}break}a=P()|0;O()|0;v[l+36>>2]=d;break a}if(v[j>>2]!=v[i>>2]){m=e;break e}v[l+36>>2]=d;v[f>>2]=v[f>>2]|4;a=0}zb(u);zb(p);zb(q);zb(o);zb(x);Xc(s);break d}a=P()|0;O()|0;break a}a=P()|0;O()|0;break a}h=h+1|0;continue}}a=P()|0;O()|0;break a}kb=l+560|0;return a|0}a=P()|0;O()|0;break a}a=P()|0;O()|0}zb(u);zb(p);zb(q);zb(o);zb(x);Xc(s);T(a|0);L()}function uja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,y=0,z=0;e=kb-272|0;kb=e;zc(b);d=kb-16|0;kb=d;i=e+112|0;hU(d+8|0,i);g=v[d+12>>2];nc(d,v[b>>2],v[b+8>>2],v[d+8>>2],v[d+12>>2]);h=v[d+4>>2];if((h|0)==(g|0)){$b(b,v[d+12>>2])}kb=d+16|0;d=(g|0)==(h|0);if(!d){gU(i)}a:{if(!d){break a}if(!iU(e+112|0)){break a}if(!c){f=1;break a}Cd(a,v[(x[e+228>>1]<<2)+26448>>2]);v[a+480208>>2]=v[a+480208>>2]|16777216;d=e+48|0;f=yc(d,13092);Jb(a+1298344|0,f);Ab(f);f=yc(d,10332);Jb(a+1298356|0,f);Ab(f);f=kb-16|0;kb=f;g=e+8|0;i=yc(f,4392);ad(g,i);Ab(i);kb=f+16|0;v[23540]=0;X(229,d|0,g|0,w[e+191|0],e+188|0);d=v[23540];v[23540]=0;b:{if((d|0)!=1){d=e+48|0;Jb(a+1298368|0,d);Ab(d);f=e+8|0;dc(f);Ol(a+1298392|0,(x[e+228>>1]<<2)+26496|0);Ol(a+1298380|0,v[(x[e+228>>1]<<2)+26544>>2]);v[a+1298404>>2]=5;Ne(f,2,e+112|4);Fc(d,f);Bc(a+1298308|0,d);zb(d);Ne(f,2,e+148|0);Fc(d,f);c:{if(Aq(d,9769)){v[23540]=0;U(11,e+8|0,5,e+48|0);d=v[23540];v[23540]=0;if((d|0)==1){break c}d=e+8|0;Jb(a+1298320|0,d);Ab(d)}zb(e+48|0);u[a+480188>>1]=32;d=0;d:{while(1){if((d|0)!=32){g=(d<<5)+a|0;i=g+480280|0;df(i);f=w[(d+e|0)+193|0];e:{if(f>>>0<=15){v[e+48>>2]=f<<4|8;v[e+8>>2]=256;y=g+480284|0,z=v[td(e+48|0,e+8|0)>>2],u[y>>1]=z;break e}if((f|0)!=16){if((f|0)!=255){break e}u[a+480188>>1]=d;break d}u[g+480284>>1]=128;v[i>>2]=256}d=d+1|0;continue}break}d=x[a+480188>>1]}f=0;if(!(d&65535)){break a}v[e+48>>2]=w[e+225|0]<<2;v[e+8>>2]=256;y=a,z=v[Kb(e+48|0,e+8|0)>>2],v[y+480200>>2]=z;v[a+480196>>2]=w[e+226|0];v[a+480204>>2]=B(w[e+227|0],1e4);if(dd(b,x[e+230>>1]|x[e+232>>1]<<16)){uo(Wb(v[a+484360>>2],w[a+484376|0]),b,w[e+234|0]+1|0,255,254)}if(!dd(b,v[e+240>>2])){break a}l=a+480190|0;d=w[e+248|0]+1|0;u[l>>1]=d;m=e+80|0;n=a+480180|0;i=1;while(1){f:{g:{j=i&65535;if(j>>>0>(d&65535)>>>0){break g}d=kb-16|0;kb=d;g=e+48|0;gc(d+8|0,g,62);f=v[d+12>>2];nc(d,v[b>>2],v[b+8>>2],v[d+8>>2],v[d+12>>2]);h=v[d+4>>2];if((h|0)==(f|0)){$b(b,v[d+12>>2])}kb=d+16|0;d=(f|0)==(h|0);if(!d){Ub(g,0,62)}if(!d){break g}d=0;f=B(j,104)+a|0;k=f+484380|0;nd(k,0);h=e+32|0;Ne(h,2,e+48|0);g=e+8|0;Fc(g,h);Dc(((j<<5)+a|0)+946304|0,g);zb(g);uk(h,2,m);Fc(g,h);Be(f+484423|0,g);zb(g);g=x[e+106>>1];v[f+484404>>2]=g;if(!Km(v[n>>2])){break f}while(1){if((d|0)==16){break f}if((g|0)==x[(d<<1)+26592>>1]){t[f+484417|0]=d<<4;break f}else{d=d+1|0;continue}}}h:{if(!(c&2)){break h}if(!dd(b,v[e+244>>2])){break h}d=1;f=a+480190|0;while(1){g=d&65535;if(g>>>0>x[f>>1]){break h}g=B(g,104)+a|0;wg(Zc(e+48|0,u[g+484414>>1]&1?16:8,1,0,1),g+484380|0,b);d=d+1|0;continue}}n=a+484344|0;xg(n,w[e+239|0]+1|0);f=zq(a);d=kb-16|0;kb=d;v[d+12>>2]=0;$s(d+12|0,f);k=v[d+12>>2];kb=d+16|0;dd(b,w[e+235|0]|w[e+236|0]<<8|(w[e+237|0]<<16|w[e+238|0]<<24));p=c&1;q=a+480188|0;r=a+480180|0;j=0;m=1;i:{j:{k:{while(1){if(w[e+239|0]<j>>>0){if(v[a+480180>>2]==1){break k}c=v[a+480208>>2]&-8454145;break j}l:{d=Rg(b);if(d>>>0>=3){c=e+8|0;ae(c,b,d-2|0);h=kc(e+48|0,c);Bb(c);m:{if(!p){break m}c=v[h>>2];v[23540]=0;c=S(178,c|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break l}if(!c){break m}v[23540]=0;c=W(226,n|0,j&65535,64)|0;d=v[23540];v[23540]=0;if((d|0)==1){break l}l=0;if(!c){break m}while(1){if((l|0)==64){break m}c=_b(v[n>>2],j);s=Cf(v[c>>2],v[v[c+48>>2]+12>>2],l);n:{o:while(1){v[23540]=0;c=S(206,h|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break i}if(!c){break n}d=c&31;if(d>>>0>=x[q>>1]){break n}f=B(d,6)+s|0;if(c&32){v[23540]=0;R(260,e+8|0,h|0);d=v[23540];v[23540]=0;if((d|0)==1){break i}g=Oc(e+8|0);d=w[e+8|0];if(d){d=(d&127)-1|0;t[e+8|0]=d;d=(B((d&240)>>>4|0,12)+(d&15)|0)+13|0;t[f|0]=d;m=iB(d)&m}t[f+1|0]=w[g|0]}if(!(c&64)){continue}t[f+2|0]=0;t[f+3|0]=0;g=f+5|0;while(1){c=v[h>>2];v[23540]=0;c=W(156,c|0,v[e+56>>2],2)|0;d=v[23540];v[23540]=0;if((d|0)==1){break i}if(!c){continue o}o=w[f+5|0];c=w[f+3|0];v[23540]=0;R(260,e+8|0,h|0);d=v[23540];v[23540]=0;if((d|0)!=1){i=w[Oc(e+8|0)|0];t[g|0]=i;d=w[(w[e+8|0]&31)+26624|0];t[f+3|0]=d;p:{q:{r:{s:{t:{switch(d-2|0){case 0:case 1:if(i>>>0<224){break r}d=223;if(v[r>>2]!=1){break s}break r;case 11:t[e+32|0]=64;y=g,z=w[Yb(g,e+32|0)|0],t[y|0]=z;if(!fU(v[k+88>>2])){break r}t[f+2|0]=1;t[f+4|0]=w[g|0];t[f+3|0]=c;t[g|0]=o;d=c;break q;case 17:u:{switch(((i&240)>>>4|0)-8|0){case 0:t[f+3|0]=2;t[g|0]=i&15|224;break p;case 1:t[f+3|0]=3;t[g|0]=i&15|224;break p;default:break u}}if(tu(v[k+84>>2],19)){break r}Uu(f);break r;case 13:d=v[k+84>>2];if(tu(d,15)){break r}if(!tu(d,19)){break r}t[f+3|0]=19;t[g|0]=i&15|144;break p;case 18:d=145;if((i|0)==1){break s}if((i&240)==128){if(tu(v[k+84>>2],20)){break r}t[f+3|0]=19;break p}t[f+3|0]=0;break p;case 4:case 5:break t;default:break q}}d=i&240;if(!d){break r}}t[g|0]=d}d=w[f+3|0]}if((d&255)!=20){break p}d=w[g|0];if(w[f+2|0]|(d&240)!=128){break p}t[f+2|0]=2;t[f+4|0]=(((d&15)<<6|8)>>>0)/15;t[f+3|0]=c;t[g|0]=o}if(!(w[e+8|0]&32)){continue o}continue}break}break}break i}l=l+1|0;continue}}Bb(h)}j=j+1|0;continue}break}break i}c=v[a+480208>>2]&-8454145|(m&1?x[a+480188>>1]==4?8454144:0:0)}v[a+480208>>2]=c;f=1;if(!(w[e+253|0]|w[e+254|0]<<8|(w[e+255|0]<<16|w[e+256|0]<<24))){break a}if(!dd(b,w[e+249|0]|w[e+250|0]<<8|(w[e+251|0]<<16|w[e+252|0]<<24))){break a}xB(a+1298332|0,b,w[e+253|0]|w[e+254|0]<<8|(w[e+255|0]<<16|w[e+256|0]<<24),4);break a}d=P()|0;O()|0;Bb(h);break b}u[f+484412>>1]=64;g=w[e+93|0]|w[e+94|0]<<8|(w[e+95|0]<<16|w[e+96|0]<<24);v[k>>2]=g;d=w[e+105|0];if(d&2){h=f+484414|0;u[h>>1]=x[h>>1]|1;v[k>>2]=g>>>1}v[f+484384>>2]=w[e+97|0]|w[e+98|0]<<8|(w[e+99|0]<<16|w[e+100|0]<<24);v[f+484388>>2]=(w[e+101|0]|w[e+102|0]<<8|(w[e+103|0]<<16|w[e+104|0]<<24))-1;if(d&1){g=f+484414|0;u[g>>1]=x[g>>1]|2}v:{w:{if(!(d&4)){break w}g=w[e+108|0];if((g|0)==255){break w}t[e+8|0]=g;t[e+32|0]=64;y=f+484410|0,z=w[Yb(e+8|0,e+32|0)|0]<<2,u[y>>1]=z;break v}g=f+484414|0;u[g>>1]=x[g>>1]|32768}x:{if(d&8){d=f+484414|0;g=x[d>>1]|32;u[d>>1]=g;j=f+484408|0;f=w[e+109|0];if(f>>>0<=15){v[e+32>>2]=256;v[e+8>>2]=f<<4|8;h=v[td(e+8|0,e+32|0)>>2]}else{h=128}u[j>>1]=h;u[d>>1]=g&65279|((f|0)==16)<<8;break x}u[f+484408>>1]=128}i=i+1|0;d=x[l>>1];continue}}d=P()|0;O()|0;zb(e+48|0);break b}d=P()|0;O()|0;dc(e+8|0)}T(d|0);L()}kb=e+272|0;return f|0}function Zaa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=kb+-64|0;kb=g;d=v[b>>2];v[23540]=0;f=S(178,d|0)|0;d=v[23540];v[23540]=0;a:{b:{c:{d:{if((d|0)==1){break d}e:{f:{if(f){l=Tb(g+48|0);v[23540]=0;e=(c|0)!=0;f=W(822,l|0,b|0,e|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break e}d=4;g:{h:{i:{j:{if(f){break j}v[23540]=0;f=W(823,l|0,b|0,e|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break e}d=5;if(f){break j}v[23540]=0;f=W(824,l|0,b|0,e|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break e}d=6;if(f){break j}f=0;v[23540]=0;e=W(825,l|0,b|0,e|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break e}d=3;if(!e){break i}}if(!c){d=1;f=0;break h}f=v[l>>2];if(!pc(f,v[l+4>>2])){tv(b,f+12|0)}f=d}d=31616;k:{while(1){e=d;if((e|0)!=32156){h=v[e+8>>2];i=(h>>1)+a|0;d=v[e+4>>2];d=h&1?v[v[i>>2]+d>>2]:d;v[23540]=0;h=W(d|0,i|0,b|0,c|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break c}d=e+12|0;if(!h){continue}break k}break}v[a+480180>>2]=0;v[a+480184>>2]=0}if(!c){d=(e|0)!=32156;f=0;break h}if(!(v[a+480184>>2]|!f)){v[a+480184>>2]=f}v[23540]=0;f=1;R(765,a+1298264|0,1);e=v[23540];v[23540]=0;d=1;if((e|0)==1){break g}}LM(l);if(f){break f}break a}break c}v[23540]=0;R(246,a|0,0);d=v[23540];v[23540]=0;if((d|0)==1){break d}v[23540]=0;R(765,a+1298264|0,1);d=v[23540];v[23540]=0;if((d|0)==1){break d}v[a+1074304>>2]=19988497}d=0;while(1){if((d|0)==127){d=1;while(1){f=d&65535;if(f>>>0>x[a+480190>>1]){f=0;i=a+480180|0;d=0;l:{while(1){e=d&65535;if(e>>>0>x[a+480192>>1]){m:{u[a+480192>>1]=f;d=a+480204|0;if(y[a+480204>>2]>=1e4){break m}v[d>>2]=125e4;break l}}else{e=v[((e<<2)+a|0)+900380>>2];if(e){h=v[i>>2];xc(e,65536);xc(e+4|0,64);xc(e+8|0,256);Ef(e+28|0,16384);wf(e+30|0,128);wf(e+31|0,17);if(w[e+16|0]>=4){t[e+16|0]=0}if(w[e+17|0]>=5){t[e+17|0]=0}if(w[e+18|0]>=3){t[e+18|0]=0}wf(e+19|0,64);wf(e+20|0,100);j=224;f=t[e+26|0];n:{if((f|0)>=-32){j=32;if((f|0)<33){break n}}t[e+26|0]=j}wf(e+23|0,64);wf(e+24|0,64);Hz(e+48|0,64);Hz(e+68|0,64);Hz(e+88|0,(h|0)==4096?255:64);h=e+108|0;j=0;while(1){o:{if((j|0)==128){if(!Ko(w[e+14|0])){t[e+14|0]=5}if(w[e+34|0]>=251){t[e+34|0]=0}break o}f=Lb(h,j);if((w[f|0]-121&255)>>>0<=135){t[f|0]=j+1}j=j+1|0;continue}break}f=d}d=d+1|0;continue}break}xc(d,65535e4)}if(!v[a+480196>>2]){v[a+480196>>2]=6}e=a+480216|0;f=a+480220|0;d=v[a+480216>>2];if(!(d|w[a+480224|0]!=2)){v[e>>2]=1;d=1}if(y[a+480220>>2]<d>>>0){v[f>>2]=d}xc(e,65536);xc(f,65536);xc(a+480200|0,256);p:{f=a+480248|0;if(!pc(v[f>>2],v[a+480252>>2])){d=v[e>>2];v[23540]=0;R(826,f|0,d|0);d=v[23540];v[23540]=0;if((d|0)==1){break p}}v[a+1074416>>2]=v[a+480196>>2];v[a+1074420>>2]=v[a+480204>>2];d=v[a+480220>>2];f=a+1074408|0;v[f>>2]=v[a+480216>>2];v[f+4>>2]=d;v[a+1074456>>2]=v[a+480200>>2];Xy(a+1074376|0);d=a+1074446|0;u[d>>1]=0;u[d+2>>1]=0;u[d+4>>1]=0;u[d+6>>1]=65535;v[a+1074392>>2]=-2;d=a+1074384|0;v[d>>2]=0;v[d+4>>2]=0;v[a+1074380>>2]=0;d=a+1074424|0;v[d>>2]=0;v[d+4>>2]=0;v[a+1074432>>2]=0;d=a+1074396|0;v[d>>2]=0;v[d+4>>2]=0;if(Km(v[a+480180>>2])){v[23540]=0;Q(265,a+1074312|0,7)|0;d=v[23540];v[23540]=0;if((d|0)==1){break p}}u[a+480276>>1]=0;Qp(a);o=g,p=Fb(v[a+484360>>2]),v[o+48>>2]=p;f=Fb(v[a+484364>>2]);while(1){e=v[g+48>>2];if(!Pb(e,f)){q:{r:{l=v[a+480180>>2];if(l){$s(a+8|0,zq(a));if(v[a+1074308>>2]){v[23540]=0;Y(827,a|0);d=v[23540];v[23540]=0;if((d|0)==1){break p}}n=Tb(g+48|0);s:{if((c&12)!=12){break s}i=a+906300|0;h=a+1298464|0;d=0;t:{u:{v:{w:{x:{y:{while(1){if((d|0)==250){break s}z:{k=Md(i,d);e=k+16|0;A:{if(!Ai(v[e>>2],v[k+20>>2])){break A}v[23540]=0;R(828,k|0,a|0);c=v[23540];v[23540]=0;B:{if((c|0)!=1){m=v[k>>2];if(!m){break B}f=v[k+148>>2];c=v[v[m>>2]+56>>2];v[23540]=0;R(c|0,m|0,f|0);c=v[23540];v[23540]=0;if((c|0)!=1){break A}}a=P()|0;O()|0;break q}j=Fb(v[n>>2]);f=Fb(v[n+4>>2]);m=kb-16|0;kb=m;v[m+8>>2]=j;while(1){C:{if(!Pb(j,f)){break C}c=v[j>>2];if((w[c+4|0]|w[c+5|0]<<8|(w[c+6|0]<<16|w[c+7|0]<<24))==(w[k+20|0]|w[k+21|0]<<8|(w[k+22|0]<<16|w[k+23|0]<<24))){c=(w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24))==(w[k+16|0]|w[k+17|0]<<8|(w[k+18|0]<<16|w[k+19|0]<<24))}else{c=0}if(c){break C}j=v[Le(m+8|0)>>2];continue}break}kb=m+16|0;if(Pb(j,Fb(v[n+4>>2]))){break A}v[23540]=0;v[g+32>>2]=e;R(829,n|0,g+32|0);c=v[23540];v[23540]=0;if((c|0)==1){break z}v[23540]=0;f=Q(1,g+16|0,17735)|0;c=v[23540];v[23540]=0;if((c|0)==1){break y}v[23540]=0;R(830,g|0,k|0);c=v[23540];v[23540]=0;if((c|0)==1){break x}v[23540]=0;U(2,g+32|0,f|0,g|0);c=v[23540];v[23540]=0;if((c|0)==1){break w}c=v[h>>2];v[23540]=0;U(376,c|0,2,g+32|0);c=v[23540];v[23540]=0;if((c|0)==1){break v}Ab(g+32|0);Ab(g);Ab(f)}d=d+1|0;continue}break}a=P()|0;O()|0;break q}a=P()|0;O()|0;break q}a=P()|0;O()|0;break t}a=P()|0;O()|0;break u}a=P()|0;O()|0;Ab(g+32|0)}Ab(g)}Ab(f);break q}c=w[a+1074368|0];v[23540]=0;R(831,a|0,c|0);a=v[23540];v[23540]=0;if((a|0)==1){break r}wc(n)}d=(l|0)!=0;break a}a=P()|0;O()|0}wc(n);break b}v[23540]=0;Y(832,e|0);d=v[23540];v[23540]=0;if((d|0)!=1){if(Rc(v[e>>2],v[e+4>>2])>>>0<=x[e+28>>1]){Ve(e,0)}Cz(g+48|0);continue}break}a=P()|0;O()|0;break b}a=P()|0;O()|0;break b}h=B(f,104)+a|0;i=h+484380|0;D:{if(_d(v[i>>2],v[h+484400>>2])){uj(i,a);break D}e=h+484414|0;f=x[e>>1];if(f&16384){break D}v[i>>2]=0;v[i+4>>2]=0;v[i+16>>2]=0;v[i+8>>2]=0;v[i+12>>2]=0;u[e>>1]=f&65505}f=h+484412|0;if(x[f>>1]>=65){u[f>>1]=64}E:{F:{if(!(w[h+484415|0]&2)){break F}if(!kk(v[a+1298300>>2])){break F}v[23540]=0;Y(833,a|0);f=v[23540];v[23540]=0;if((f|0)==1){break E}}d=d+1|0;continue}break}a=P()|0;O()|0;break b}e=(d<<5)+a|0;Ef(e+480286|0,64);f=e+480284|0;if(x[f>>1]>=257){u[f>>1]=128}f=e+480288|0;if(w[f|0]>=251){t[f|0]=0}go((B(d,872)+a|0)+1074992|0,a,d&65535,134217728);d=d+1|0;continue}}break c}a=P()|0;O()|0;break b}a=P()|0;O()|0;LM(l)}Bb(b);T(a|0);L()}Bb(b);kb=g- -64|0;return d|0}function G1(a,b,c,d,e,f){a=a|0;b=+b;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,u=0,x=0,y=0,z=0,A=0,C=0,E=0,F=0;n=kb-560|0;kb=n;v[n+44>>2]=0;o(+b);g=j(1)|0;j(0)|0;a:{if((g|0)<0){x=1;A=5299;b=-b;o(+b);g=j(1)|0;j(0)|0;break a}if(e&2048){x=1;A=5302;break a}x=e&1;A=x?5305:5300;F=!x}b:{if((g&2146435072)==2146435072){d=x+3|0;Gf(a,32,c,d,e&-65537);tf(a,A,x);f=f&32;tf(a,b!=b?f?9997:13812:f?11127:14178,3);Gf(a,32,c,d,e^8192);i=(c|0)<(d|0)?d:c;break b}z=n+16|0;c:{d:{e:{b=RH(b,n+44|0);b=b+b;if(b!=0){g=v[n+44>>2];v[n+44>>2]=g-1;u=f|32;if((u|0)!=97){break e}break c}u=f|32;if((u|0)==97){break c}l=v[n+44>>2];m=(d|0)<0?6:d;break d}l=g-29|0;v[n+44>>2]=l;b=b*268435456;m=(d|0)<0?6:d}r=(n+48|0)+((l|0)<0?0:288)|0;h=r;while(1){if(b<4294967296&b>=0){d=~~b>>>0}else{d=0}v[h>>2]=d;h=h+4|0;b=(b-+(d>>>0))*1e9;if(b!=0){continue}break}f:{if((l|0)<=0){d=l;g=h;k=r;break f}k=r;d=l;while(1){d=(d|0)<29?d:29;g=h-4|0;g:{if(k>>>0>g>>>0){break g}i=0;while(1){q=v[g>>2];p=d&31;C=i;if((d&63)>>>0>=32){i=q<<p;q=0}else{i=(1<<p)-1&q>>>32-p;q=q<<p}p=C+q|0;i=i+E|0;i=p>>>0<q>>>0?i+1|0:i;i=Mka(p,i,1e9,0);q=Jka(i,nb,-1e9,0)+p|0;v[g>>2]=q;g=g-4|0;if(k>>>0<=g>>>0){continue}break}if(!i){break g}k=k-4|0;v[k>>2]=i}while(1){g=h;if(k>>>0<g>>>0){h=g-4|0;if(!v[h>>2]){continue}}break}d=v[n+44>>2]-d|0;v[n+44>>2]=d;h=g;if((d|0)>0){continue}break}}if((d|0)<0){y=((m+25>>>0)/9|0)+1|0;p=(u|0)==102;while(1){d=0-d|0;i=(d|0)<9?d:9;h:{if(g>>>0<=k>>>0){h=v[k>>2];break h}q=1e9>>>i|0;E=-1<<i^-1;d=0;h=k;while(1){C=d;d=v[h>>2];v[h>>2]=C+(d>>>i|0);d=B(q,d&E);h=h+4|0;if(h>>>0<g>>>0){continue}break}h=v[k>>2];if(!d){break h}v[g>>2]=d;g=g+4|0}d=i+v[n+44>>2]|0;v[n+44>>2]=d;k=(!h<<2)+k|0;h=p?r:k;g=g-h>>2>(y|0)?h+(y<<2)|0:g;if((d|0)<0){continue}break}}d=0;i:{if(g>>>0<=k>>>0){break i}d=B(r-k>>2,9);h=10;i=v[k>>2];if(i>>>0<10){break i}while(1){d=d+1|0;h=B(h,10);if(i>>>0>=h>>>0){continue}break}}h=(m-((u|0)==102?0:d)|0)-((u|0)==103&(m|0)!=0)|0;if((h|0)<(B(g-r>>2,9)-9|0)){i=h+9216|0;p=(i|0)/9|0;l=((((l|0)<0?4:292)+n|0)+(p<<2)|0)-4048|0;h=10;i=i+B(p,-9)|0;if((i|0)<=7){while(1){h=B(h,10);i=i+1|0;if((i|0)!=8){continue}break}}p=v[l>>2];y=(p>>>0)/(h>>>0)|0;i=B(y,h);q=l+4|0;j:{if((i|0)==(p|0)&(q|0)==(g|0)){break j}p=p-i|0;k:{if(!(y&1)){b=9007199254740992;if(!(t[l-4|0]&1)|((h|0)!=1e9|k>>>0>=l>>>0)){break k}}b=9007199254740994}s=(g|0)==(q|0)?1:1.5;q=h>>>1|0;s=p>>>0<q>>>0?.5:(q|0)==(p|0)?s:1.5;if(!(w[A|0]!=45|F)){s=-s;b=-b}v[l>>2]=i;if(b+s==b){break j}d=h+i|0;v[l>>2]=d;if(d>>>0>=1e9){while(1){v[l>>2]=0;l=l-4|0;if(l>>>0<k>>>0){k=k-4|0;v[k>>2]=0}d=v[l>>2]+1|0;v[l>>2]=d;if(d>>>0>999999999){continue}break}}d=B(r-k>>2,9);h=10;i=v[k>>2];if(i>>>0<10){break j}while(1){d=d+1|0;h=B(h,10);if(i>>>0>=h>>>0){continue}break}}h=l+4|0;g=g>>>0>h>>>0?h:g}while(1){h=g;i=g>>>0<=k>>>0;if(!i){g=h-4|0;if(!v[g>>2]){continue}}break}l:{if((u|0)!=103){l=e&8;break l}g=m?m:1;l=(g|0)>(d|0)&(d|0)>-5;m=(l?d^-1:-1)+g|0;f=(l?-1:-2)+f|0;l=e&8;if(l){break l}g=-9;m:{if(i){break m}p=v[h-4>>2];if(!p){break m}i=10;g=0;if((p>>>0)%10|0){break m}while(1){l=g;g=g+1|0;i=B(i,10);if(!((p>>>0)%(i>>>0)|0)){continue}break}g=l^-1}i=B(h-r>>2,9);if((f&-33)==70){l=0;g=(g+i|0)-9|0;g=(g|0)>0?g:0;m=(g|0)>(m|0)?m:g;break l}l=0;g=((d+i|0)+g|0)-9|0;g=(g|0)>0?g:0;m=(g|0)>(m|0)?m:g}i=-1;u=l|m;if(((u?2147483645:2147483646)|0)<(m|0)){break b}p=(((u|0)!=0)+m|0)+1|0;q=f&-33;n:{if((q|0)==70){if((2147483647-p|0)<(d|0)){break b}g=(d|0)>0?d:0;break n}g=d>>31;g=Fn((g^d)-g|0,0,z);if((z-g|0)<=1){while(1){g=g-1|0;t[g|0]=48;if((z-g|0)<2){continue}break}}y=g-2|0;t[y|0]=f;t[g-1|0]=(d|0)<0?45:43;g=z-y|0;if((g|0)>(2147483647-p|0)){break b}}d=g+p|0;if((d|0)>(x^2147483647)){break b}f=d+x|0;Gf(a,32,c,f,e);tf(a,A,x);Gf(a,48,c,f,e^65536);o:{p:{q:{if((q|0)==70){g=n+16|0;d=g|8;l=g|9;i=k>>>0>r>>>0?r:k;k=i;while(1){g=Fn(v[k>>2],0,l);r:{if((i|0)!=(k|0)){if(n+16>>>0>=g>>>0){break r}while(1){g=g-1|0;t[g|0]=48;if(n+16>>>0<g>>>0){continue}break}break r}if((g|0)!=(l|0)){break r}t[n+24|0]=48;g=d}tf(a,g,l-g|0);k=k+4|0;if(r>>>0>=k>>>0){continue}break}if(u){tf(a,16805,1)}if((m|0)<=0|h>>>0<=k>>>0){break q}while(1){g=Fn(v[k>>2],0,l);if(g>>>0>n+16>>>0){while(1){g=g-1|0;t[g|0]=48;if(n+16>>>0<g>>>0){continue}break}}tf(a,g,(m|0)<9?m:9);g=m-9|0;k=k+4|0;if(h>>>0<=k>>>0){break p}d=(m|0)>9;m=g;if(d){continue}break}break p}s:{if((m|0)<0){break s}i=h>>>0>k>>>0?h:k+4|0;g=n+16|0;d=g|8;r=g|9;h=k;while(1){g=Fn(v[h>>2],0,r);if((r|0)==(g|0)){t[n+24|0]=48;g=d}t:{if((h|0)!=(k|0)){if(n+16>>>0>=g>>>0){break t}while(1){g=g-1|0;t[g|0]=48;if(n+16>>>0<g>>>0){continue}break}break t}tf(a,g,1);g=g+1|0;if(!(l|m)){break t}tf(a,16805,1)}C=g;g=r-g|0;tf(a,C,(g|0)>(m|0)?m:g);m=m-g|0;h=h+4|0;if(i>>>0<=h>>>0){break s}if((m|0)>=0){continue}break}}Gf(a,48,m+18|0,18,0);tf(a,y,z-y|0);break o}g=m}Gf(a,48,g+9|0,9,0)}Gf(a,32,c,f,e^8192);i=(c|0)<(f|0)?f:c;break b}m=(f<<26>>31&9)+A|0;u:{if(d>>>0>11){break u}g=12-d|0;s=16;while(1){s=s*16;g=g-1|0;if(g){continue}break}if(w[m|0]==45){b=-(s+(-b-s));break u}b=b+s-s}l=x|2;k=f&32;h=v[n+44>>2];g=h>>31;g=Fn((g^h)-g|0,0,z);if((z|0)==(g|0)){t[n+15|0]=48;g=n+15|0}r=g-2|0;t[r|0]=f+15;t[g-1|0]=(h|0)<0?45:43;i=e&8;h=n+16|0;while(1){f=h;if(D(b)<2147483648){g=~~b}else{g=-2147483648}t[h|0]=k|w[g+77152|0];b=(b-+(g|0))*16;h=f+1|0;if(!(!(i|(d|0)>0)&b==0|(h-(n+16|0)|0)!=1)){t[f+1|0]=46;h=f+2|0}if(b!=0){continue}break}i=-1;p=z-r|0;f=p+l|0;if((2147483645-f|0)<(d|0)){break b}v:{w:{if(!d){break w}k=h-(n+16|0)|0;if((k-2|0)>=(d|0)){break w}g=d+2|0;break v}k=h-(n+16|0)|0;g=k}d=g+f|0;Gf(a,32,c,d,e);tf(a,m,l);Gf(a,48,c,d,e^65536);tf(a,n+16|0,k);Gf(a,48,g-k|0,0,0);tf(a,r,p);Gf(a,32,c,d,e^8192);i=(c|0)<(d|0)?d:c}kb=n+560|0;return i|0}function Afa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=kb-272|0;kb=e;zc(b);d=kb-16|0;kb=d;f=e+120|0;kR(d+8|0,f);g=v[d+12>>2];nc(d,v[b>>2],v[b+8>>2],v[d+8>>2],v[d+12>>2]);h=v[d+4>>2];if((h|0)==(g|0)){$b(b,v[d+12>>2])}kb=d+16|0;d=(g|0)==(h|0);if(!d){jR(f)}a:{b:{if(!d){break b}if(!lR(e+120|0)){break b}if(!c){i=1;break b}Cd(a,4194304);d=e+32|0;g=yc(d,17072);Jb(a+1298344|0,g);Ab(g);g=yc(d,10156);Jb(a+1298356|0,g);Ab(g);v[a+1298404>>2]=5;n=a,o=Ed(x[e+198>>1],x[e+200>>1],127),u[n+480188>>1]=o;g=w[e+189|0];v[a+480228>>2]=(g|0)==255?48:g;v[a+480196>>2]=w[e+187|0];v[a+480204>>2]=B(w[e+188|0],1e4);g=e+96|0;pf(g,e+120|4,59,3);Fc(d,g);Bc(a+1298308|0,d);zb(d);d=x[e+202>>1]|x[e+204>>1]<<16;c:{if(d>>>0<5){break c}if(!dd(b,d-4|0)){break c}if(!Hh(b,14278)){break c}uo(Wb(v[a+484360>>2],w[a+484376|0]),b,x[e+192>>1],65535,65535)}d:{d=x[e+206>>1]|x[e+208>>1]<<16;if(d>>>0<5){break d}if(!dd(b,d-4|0)){break d}if(!Hh(b,13807)){break d}d=0;while(1){if((d|0)==32){break d}g=(d<<5)+a|0;df(g+480280|0);n=g+480284|0,o=((((Me(b)^-1)&15)<<8|8)>>>0)/15|0,u[n>>1]=o;d=d+1|0;continue}}d=x[e+214>>1]|x[e+216>>1]<<16;e:{if(d>>>0<5){break e}if(!dd(b,d-4|0)){break e}if(!Hh(b,14135)){break e}d=e+32|0;ae(d,b,x[e+196>>1]<<6);k=c&2;h=a+480190|0;g=kc(e+96|0,d);Bb(d);j=e+45|0;d=0;f:{while(1){if(x[e+196>>1]<=(d&65535)>>>0){break f}v[23540]=0;f=Q(661,g|0,e+32|0)|0;i=v[23540];v[23540]=0;if((i|0)==1){break a}if(!f){break f}f=w[e+77|0]|w[e+78|0]<<8;u[e+30>>1]=f;g:{h:{if((f-1&65535)>>>0>3998){break h}f=B(f,104)+a|0;i=f+484380|0;if(_d(v[i>>2],v[f+484400>>2])){break h}n=h,o=x[ke(h,e+30|0)>>1],u[n>>1]=o;v[23540]=0;R(662,e+32|0,i|0);f=v[23540];v[23540]=0;if((f|0)==1){break g}WT(e,1,j);v[23540]=0;R(222,e+16|0,e|0);f=v[23540];v[23540]=0;if((f|0)==1){break a}f=e+16|0;Dc(((x[e+30>>1]<<5)+a|0)+946304|0,f);zb(f);if(!k){break h}v[23540]=0;Q(155,b|0,w[e+69|0]|w[e+70|0]<<8|(w[e+71|0]<<16|w[e+72|0]<<24))|0;f=v[23540];v[23540]=0;if((f|0)==1){break g}i=1;l=e+16|0;f=w[e+79|0];m=Zc(l,f&4?16:8,1,0,0);i:{j:{if(f&8){break j}i=2;if(f&16){break j}if(f&127){break i}}dg(m,i)}v[23540]=0;W(219,l|0,(B(x[e+30>>1],104)+a|0)+484380|0,b|0)|0;f=v[23540];v[23540]=0;if((f|0)!=1){break h}break a}d=d+1|0;continue}break}break a}Bb(g)}i=1;if(!(c&1)){break b}k:{c=x[e+210>>1]|x[e+212>>1]<<16;if(c>>>0<5){break k}if(!dd(b,c-4|0)){break k}if(!Hh(b,13657)){break k}k=a+484344|0;xg(k,x[e+194>>1]);f=0;while(1){if(x[e+194>>1]<=f>>>0){break k}if(!zA(b,e+16|0)){break k}l:{d=x[e+16>>1];if(d>>>0>3){c=e+96|0;ae(c,b,(d+15&131056)-4|0);g=kc(e+32|0,c);Bb(c);v[23540]=0;c=W(226,k|0,f&65535,w[e+18|0])|0;d=v[23540];v[23540]=0;if((d|0)==1){break l}h=0;m:{if(!c){break m}while(1){n:{c=v[g>>2];v[23540]=0;d=W(156,c|0,v[e+40>>2],1)|0;c=v[23540];v[23540]=0;o:{if((c|0)!=1){c=w[e+18|0];if(!(d&c>>>0>(h&255)>>>0)){break n}v[23540]=0;d=S(206,g|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break a}if(d){break o}h=h+1|0;continue}break a}c=v[a+484344>>2];u[e+96>>1]=d&31;u[e>>1]=x[a+480188>>1]-1;c=_b(c,f);c=jd(v[c>>2],v[v[c+48>>2]+12>>2],h,x[Wc(e+96|0,e)>>1]);if(d&128){v[23540]=0;R(260,e+96|0,g|0);j=v[23540];v[23540]=0;if((j|0)==1){break a}t[c|0]=w[e+96|0]+36;n=c,o=w[Oc(e+96|0)|0],t[n+1|0]=o}if(d&64){t[c+2|0]=1;v[23540]=0;j=S(206,g|0)|0;l=v[23540];v[23540]=0;if((l|0)==1){break a}t[e+96|0]=j;t[e|0]=64;n=c,o=w[Yb(e+96|0,e)|0],t[n+4|0]=o}if(!(d&32)){continue}v[23540]=0;R(260,e+96|0,g|0);d=v[23540];v[23540]=0;p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{z:{A:{B:{C:{D:{E:{F:{G:{H:{I:{J:{K:{L:{M:{N:{O:{P:{Q:{R:{S:{T:{U:{if((d|0)!=1){d=w[Oc(e+96|0)|0];t[c+5|0]=d;switch(w[e+96|0]-1|0){case 71:break q;case 70:break r;case 69:break s;case 60:break t;case 59:break u;case 52:break v;case 51:break w;case 50:break x;case 49:break y;case 42:break z;case 41:break A;case 40:break B;case 39:break C;case 30:break D;case 29:break E;case 22:break F;case 21:break G;case 20:break H;case 19:break I;case 16:break J;case 15:break K;case 14:break L;case 13:break M;case 12:break N;case 11:break O;case 10:break P;case 9:break Q;case 3:break R;case 2:break S;case 1:break T;case 0:break U;default:break p}}break a}t[c+3|0]=11;t[c+5|0]=d<<4|15;continue}t[c+3|0]=11;t[c+5|0]=d<<4;continue}t[c+3|0]=11;t[c+5|0]=d|240;continue}t[c+3|0]=11;t[c+5|0]=d&15;continue}t[c+3|0]=2;t[c+5|0]=d|240;continue}t[c+3|0]=2;continue}t[c+3|0]=3;t[c+5|0]=d|240;continue}t[c+3|0]=3;continue}t[c+3|0]=4;continue}t[c+3|0]=20;t[c+5|0]=d|16;continue}t[c+3|0]=6;t[c+5|0]=d<<4;continue}t[c+3|0]=6;t[c+5|0]=d&15;continue}t[c+3|0]=5;continue}t[c+3|0]=20;t[c+5|0]=d|48;continue}t[c+3|0]=7;t[c+5|0]=d<<4;continue}t[c+3|0]=7;t[c+5|0]=d&15;continue}t[c+3|0]=8;continue}t[c+3|0]=20;t[c+5|0]=d|64;continue}t[c+3|0]=10;v[23540]=0;d=S(206,g|0)|0;j=v[23540];v[23540]=0;if((j|0)!=1){t[c+5|0]=d;v[23540]=0;Q(188,g|0,1)|0;c=v[23540];v[23540]=0;if((c|0)!=1){continue}}break a}t[c+3|0]=15;t[c+5|0]=d&15;continue}t[c+3|0]=20;t[c+5|0]=d|192;continue}t[c+3|0]=20;t[c+5|0]=d|208;continue}t[c+3|0]=12;continue}t[c+3|0]=14;continue}t[c+3|0]=20;t[c+5|0]=d|176;continue}t[c+3|0]=20;t[c+5|0]=d|224;continue}t[c+3|0]=16;continue}t[c+3|0]=17;continue}t[c+3|0]=1;continue}t[c+3|0]=20;t[c+5|0]=d&15|32;continue}t[c+3|0]=20;t[c+5|0]=d&15|128;continue}t[c+3|0]=0;continue}break}if((c|0)==64){break m}ze(_b(v[k>>2],f),Gh(Ue(Oe(e+96|0,14,0),c-1|0)))}Bb(g)}f=f+1|0;continue}break}break a}c=x[e+218>>1]|x[e+220>>1]<<16;if(!c){break b}dd(b,c);xB(a+1298332|0,b,Rg(b),4)}kb=e+272|0;return i|0}a=P()|0;O()|0;Bb(g);T(a|0);L()}function nja(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,y=0;k=kb-128|0;kb=k;t[k+127|0]=d;a:{if(!c|(e|0)<0&c>>>0>=176){break a}t[b+5|0]=d;t[k+8|0]=15;l=k+127|0;p=k+8|0;j=p;o=w[Yb(l,j)|0];t[k+8|0]=14;l=w[Yb(l,j)|0];v[k+8>>2]=d+31>>>5;v[k+120>>2]=14;r=k+120|0;n=v[td(j,r)>>2];v[k+8>>2]=d+127>>>7;v[k+120>>2]=14;q=c&15;j=q<<8|d;p=td(p,r);b:{switch((c>>>4|0)-2|0){case 0:t[b+2|0]=1;t[b+4|0]=j>>>2;break a;case 1:t[b+2|0]=1;if(!j){t[b+4|0]=0;break a}s=b,y=tg(fB(j)>>>2|0),t[s+4|0]=y;break a;case 2:t[b+3|0]=9;t[b+5|0]=j>>>4;break a;case 3:t[b+3|0]=23;t[b+5|0]=j+1>>>5;break a;case 4:t[b+3|0]=23;if(j){a=tg(fB(j)>>>5|0)}else{a=0}t[b+5|0]=a;break a;case 5:t[b+5|0]=q;t[b+3|0]=15;break a;case 6:t[b+3|0]=15;if((e|0)>=0){if(w[b+2|0]){break a}t[b+2|0]=2;s=b,y=Hc(((q<<6|7)>>>0)/15|0,0),t[s+4|0]=y;break a}t[b+2|0]=1;t[b+5|0]=q;t[b+4|0]=d+3>>>2;break a;case 7:t[b+3|0]=10;c:{if((e|0)>5){break c}if(!j){t[b+5|0]=1;break a}c=xq(a,f,g);if(!c){break c}a=Hi(a,c);c=x[a+34>>1];if(c&1){j=j>>>1|0;v[k+120>>2]=j}if(!(c&2)){break c}c=v[a>>2];if(c>>>0>=j<<8>>>0){break c}v[k+120>>2]=v[a+4>>2]+8>>>8;xc(k+120|0,c-1>>>8|0);j=v[k+120>>2]}t[b+5|0]=j;if(w[b+2|0]|j>>>0<256){break a}t[b+2|0]=15;v[k+116>>2]=j>>>8;eB(k+8|0);v[k+112>>2]=9;s=b,y=v[Kb(k+116|0,k+112|0)>>2],t[s+4|0]=y;break a;default:break b}}j=v[p>>2];d:{switch(c-160|0){default:e:{switch(c-1|0){case 0:case 1:case 2:case 3:case 6:case 10:case 14:Pf(b,c,d);f:{switch(w[b+3|0]-16|0){case 1:v[h>>2]=B(w[b+5|0],1e4);break a;case 0:break f;default:break a}}a=w[b+5|0];if(!a){break a}v[i>>2]=a;break a;case 4:t[b+3|0]=4;if(w[b+2|0]){break a}t[b+4|0]=0;t[b+2|0]=8;break a;case 5:t[b+3|0]=5;if(w[b+2|0]){break a}t[b+4|0]=0;t[b+2|0]=11;break a;case 7:if(!$c(w[b|0])|!d){break a}t[b+3|0]=35;t[b+5|0]=(d>>>1&120|128)-(d<<3&120);e=a+480192|0;if(x[e>>1]){break a}u[k+8>>1]=255;c=x[Wc(a+480190|0,k+8|0)>>1];u[e>>1]=c;b=1;while(1){d=b&65535;if(d>>>0>(c&65535)>>>0){break a}c=Ou(a,d,d);if(c){t[c+33|0]=2;d=(d<<5)+a|0;f=d+946304|0;g=v[f+4>>2];v[c+492>>2]=v[f>>2];v[c+496>>2]=g;f=d+946312|0;g=v[f+4>>2];v[c+500>>2]=v[f>>2];v[c+504>>2]=g;f=d+946320|0;g=v[f+4>>2];v[c+508>>2]=v[f>>2];v[c+512>>2]=g;d=d+946328|0;f=v[d+4>>2];v[c+516>>2]=v[d>>2];v[c+520>>2]=f;Mj(c,127,1);Lj(c,0,1)}b=b+1|0;c=x[e>>1];continue};case 8:t[b+3|0]=19;t[b+5|0]=o|208;break a;case 9:t[b+3|0]=25;break a;case 11:if(d>>>0>2){break a}t[b+3|0]=19;t[b+5|0]=d|64;break a;case 12:t[b+3|0]=14;break a;case 13:if(d>>>0>2){break a}t[b+3|0]=19;t[b+5|0]=d|112;break a;case 15:t[b+3|0]=1;break a;case 16:case 17:t[b+3|0]=19;t[b+5|0]=l|c<<4;break a;case 18:t[b+3|0]=15;break a;case 19:t[b+3|0]=11;t[b+5|0]=l<<4;break a;case 20:t[b+5|0]=l;t[b+3|0]=11;break a;case 23:t[b+3|0]=6;t[b+5|0]=l<<4;break a;case 24:t[b+5|0]=l;t[b+3|0]=6;break a;case 27:t[b+3|0]=7;t[b+5|0]=l<<4;break a;case 28:break e;default:break a}}t[b+5|0]=l;t[b+3|0]=7;break a;case 0:if(!d){break a}t[b+3|0]=24;t[b+5|0]=n<<4;break a;case 1:if(!d){break a}t[b+5|0]=n;t[b+3|0]=24;break a;case 4:t[b+3|0]=11;t[b+5|0]=l<<4|15;break a;case 5:t[b+3|0]=11;t[b+5|0]=l|240;break a;case 6:if(!d){break a}t[b+3|0]=24;t[b+5|0]=n<<4|15;break a;case 7:if(!d){break a}t[b+3|0]=24;t[b+5|0]=n|240;break a;case 8:if(!d){break a}t[b+3|0]=16;v[i>>2]=d;break a;case 9:if((e|0)>5){break a}a=v[h>>2];if(a>>>0<1e4){break a}t[b+3|0]=17;m=122925/(+(a>>>0)/1e4)+ +((d<<1)-256|0);s=b,y=tk(245850/(m+m)),t[s+5|0]=y;break a;case 10:t[b+3|0]=19;t[b+5|0]=o|224;break a;case 12:t[b+3|0]=28;t[b+5|0]=o|16;break a;case 13:t[b+3|0]=28;t[b+5|0]=o|32;break a;case 14:t[b+3|0]=29;t[b+5|0]=l<<3&240;break a;case 15:t[b+3|0]=29;t[b+5|0]=(l&254)>>>1;break a;case 16:t[b+3|0]=18;break a;case 17:t[b+3|0]=19;t[b+5|0]=o|176;break a;case 18:case 19:t[b+3|0]=20;t[b+5|0]=d?120:119;break a;case 20:t[b+3|0]=20;t[b+5|0]=d?125:123;break a;case 21:t[b+3|0]=20;t[b+5|0]=d?122:121;break a;case 22:t[b+3|0]=20;t[b+5|0]=d?126:123;break a;case 26:t[b+3|0]=10;t[b+5|0]=d+15>>>4;break a;case 27:t[b+5|0]=1;t[b+3|0]=10;break a;case 30:case 31:if(!d|(!g|!f)){break a}o=v[h>>2];if(o>>>0<1e4){break a}l=v[i>>2];if(!l){break a}i=xq(a,f,g);if(!i){break a}j=Hi(a,i);n=x[j+34>>1];g:{if(!(n&2)){i=v[j>>2];break g}i=v[j+8>>2]-((e|0)<6?v[j+4>>2]:0)|0;if(!(n&4)){break g}i=i<<((e|0)>5)}if(!i|(e|0)<6&i>>>0<1024){break a}n=v[j+24>>2];if(!n){break a}h:{if(x[a+480192>>1]<g>>>0){break h}a=v[((g<<2)+a|0)+900380>>2];if(!a){break h}m=+(w[Lb(a+108|0,f-1|0)|0]-f|0)}a=(c|0)==190;m=oi(m/12+(a?(e|0)<6?+t[j+37|0]/-1536:-0:-0))*+(n>>>0);if(a){t[b+3|0]=17;a=tk(m*.5*(+(B(d,l)>>>0)*2.5)/+(i>>>0));t[b+5|0]=a;v[h>>2]=B(a,1e4);break a}m=su(mK(+(i>>>0)/m/(+(B(d,l)>>>0)*2.5/(+(o>>>0)/1e4)))*12+61,1,120);i:{if(m<4294967296&m>=0){a=~~m>>>0;break i}a=0}c=$c(w[b|0]);t[b|0]=a;m=(m-H(m))*64+128;j:{if(m<4294967296&m>=0){a=~~m>>>0;break j}a=0}t[b+5|0]=a;if((a|0)!=128){t[b+3|0]=35}if(c){break a}if(!w[b+2|0]){t[b+4|0]=9;t[b+2|0]=11;break a}t[b+5|0]=255;t[b+3|0]=4;break a;case 32:a=d>>>4|0;if(a-1>>>0>1){break a}t[b+3|0]=20;t[b+5|0]=a-99;break a;case 34:t[b+3|0]=21;t[b+5|0]=d<<2;break a;case 35:t[b+3|0]=21;s=b,y=tg(fB(d<<4)>>>6|0),t[s+5|0]=y;break a;case 36:case 38:t[b+3|0]=22;t[b+5|0]=j<<4;break a;case 37:case 39:t[b+5|0]=j;t[b+3|0]=22;break a;case 40:t[b+3|0]=22;t[b+5|0]=l<<4|15;break a;case 2:case 3:case 11:case 23:case 24:case 25:case 28:case 29:case 33:break a;case 41:break d}}t[b+3|0]=22;t[b+5|0]=l|240}kb=k+128|0}function Lea(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=kb-208|0;kb=d;zc(c);a:{if(!wo(c,d+192|0)){break a}if(Sb(d+192|0,13838,4)){break a}f=d+200|0;if(Sb(f,14211,4)){if(Sb(f,14315,4)){break a}}e=kb-32|0;kb=e;i=d+176|0;g=Tb(i);b:{c:{d:{e:{f:{while(1){h=v[c+8>>2];j=v[c>>2];v[23540]=0;h=W(156,j|0,h|0,8)|0;j=v[23540];v[23540]=0;if((j|0)==1){break d}if(!h){break e}v[23540]=0;R(787,e|0,c|0);h=v[23540];v[23540]=0;if((h|0)!=1){v[23540]=0;R(788,g|0,e|0);h=v[23540];v[23540]=0;if((h|0)==1){break f}Bd(e);continue}break}a=P()|0;O()|0;break c}a=P()|0;O()|0;Bd(e);break c}kb=e+32|0;break b}a=P()|0;O()|0}Zd(g);T(a|0);L()}v[23540]=0;U(717,d+152|0,i|0,1129270605);c=v[23540];v[23540]=0;g:{h:{i:{j:{k:{l:{m:{if((c|0)!=1){v[23540]=0;c=Q(718,d+152|0,d+128|0)|0;e=v[23540];v[23540]=0;n:{o:{if((e|0)!=1){if(!c){break g}if(!bc(x[d+130>>1]|x[d+132>>1]<<16)){break g}if((Ib(x[d+128>>1])-3&65535)>>>0<65534){break g}if((Ib(x[d+134>>1])-65&65535)>>>0<65472){break g}v[d+124>>2]=1162760014;c=1;if(!Sb(f,14315,4)){v[23540]=0;c=Q(606,d+152|0,d+124|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break o}if(!c){break g}c=v[d+124>>2]!=1936684916}v[23540]=0;U(717,d+104|0,d+176|0,1397968452);e=v[23540];v[23540]=0;p:{q:{if((e|0)!=1){v[23540]=0;k=Q(719,d+104|0,d+96|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break p}if(k){break q}break h}c=P()|0;O()|0;break j}f=((Ib(x[d+134>>1])-1|0)/8|0)-1|0;g=f<<3;e=g&31;g=Zc(d+88|0,(f>>>0<7?(g&63)>>>0>=32?4196360>>>e|0:((1<<e)-1&4196360)<<32-e|136321040>>>e:8)&255,(Ib(x[d+128>>1])|0)==2?2:1,c,0);c=v[d+124>>2];r:{if((c|0)!=544694642){s:{t:{if(!((c|0)==842222662|(c|0)==842230886|(c|0)==875973702)){if((c|0)==2002873461){break s}if((c|0)==1463897153){break t}if((c|0)==1463897173){break s}if((c|0)==2002873441){break t}if((c|0)!=875981926){break r}}dg(g,3);break r}dg(g,17);xd(g,16);break r}dg(g,16);xd(g,16);break r}dg(g,1)}c=v[d+96>>2];v[23540]=0;c=W(156,v[d+104>>2],v[d+112>>2],bc(c)|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break l}if(c){c=v[d+96>>2];v[23540]=0;Q(188,d+104|0,bc(c)|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break l}}pt(a,b);v[23540]=0;c=B(b,104)+a|0;i=c+484380|0;R(277,i|0,0);e=v[23540];v[23540]=0;u:{v:{w:{x:{y:{z:{A:{B:{C:{D:{if((e|0)==1){break D}r=i,s=bc(x[d+130>>1]|x[d+132>>1]<<16),v[r>>2]=s;j=c+484404|0;c=w[d+138|0]|w[d+139|0]<<8|(w[d+140|0]<<16|w[d+141|0]<<24);f=c<<24|c<<8&16711680|(c>>>8&65280|c>>>24);h=30-w[d+137|0]|0;e=0;while(1){c=f;if(h&255){f=c>>>1|0;h=h-1|0;e=c;continue}break}v[j>>2]=c+(e&1);v[23540]=0;W(219,g|0,i|0,d+104|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break D}v[23540]=0;U(717,d- -64|0,d+176|0,1296126539);c=v[23540];v[23540]=0;if((c|0)==1){break C}v[23540]=0;c=S(178,v[d+64>>2])|0;e=v[23540];v[23540]=0;if((e|0)==1){break B}if(!c){break u}v[23540]=0;U(717,d+16|0,d+176|0,1229869908);c=v[23540];v[23540]=0;if((c|0)==1){break A}v[23540]=0;c=Q(720,d+16|0,d+40|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break z}Bb(d+16|0);if(!c){break u}v[23540]=0;f=S(271,d- -64|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break y}e=Tb(d+16|0);v[23540]=0;R(721,e|0,f|0);c=v[23540];v[23540]=0;if((c|0)==1){break w}c=0;while(1){if((c|0)==(f|0)){break x}v[23540]=0;g=Q(722,d- -64|0,d|0)|0;h=v[23540];v[23540]=0;if((h|0)==1){break w}if(!g){break x}v[23540]=0;R(723,e|0,d|0);g=v[23540];v[23540]=0;if((g|0)==1){break w}v[23540]=0;Q(188,d- -64|0,w[d+6|0]|1)|0;g=v[23540];v[23540]=0;if((g|0)==1){break w}c=c+1|0;continue}}c=P()|0;O()|0;break k}c=P()|0;O()|0;break k}c=P()|0;O()|0;break m}c=P()|0;O()|0;break m}c=P()|0;O()|0;Bb(d+16|0);break m}c=P()|0;O()|0;break m}c=Ib(x[d+48>>1]);if(c){f=(B(b,104)+a|0)+484414|0;u[f>>1]=x[f>>1]&65511|((c|0)==2)<<4|8}c=Ib(x[d+54>>1]);if(c){f=(B(b,104)+a|0)+484414|0;u[f>>1]=x[f>>1]&65529|((c|0)==2?4:2)|2}r=d,s=Fb(v[e>>2]),v[r>>2]=s;c=B(b,104)+a|0;g=c+484388|0;h=c+484384|0;j=c+484396|0;l=c+484392|0;m=Fb(v[e+4>>2]);n=x[d+50>>1];o=x[d+52>>1];p=x[d+56>>1];q=x[d+58>>1];while(1){c=v[d>>2];if(!Pb(c,m)){break v}f=Ib(w[c|0]|w[c+1|0]<<8);if((f|0)==(Ib(n)|0)){r=l,s=bc(w[c+2|0]|w[c+3|0]<<8|(w[c+4|0]<<16|w[c+5|0]<<24)),v[r>>2]=s;f=Ib(w[c|0]|w[c+1|0]<<8)}if((Ib(o)|0)==(f|0)){r=j,s=bc(w[c+2|0]|w[c+3|0]<<8|(w[c+4|0]<<16|w[c+5|0]<<24)),v[r>>2]=s;f=Ib(w[c|0]|w[c+1|0]<<8)}if((Ib(p)|0)==(f|0)){r=h,s=bc(w[c+2|0]|w[c+3|0]<<8|(w[c+4|0]<<16|w[c+5|0]<<24)),v[r>>2]=s;f=Ib(w[c|0]|w[c+1|0]<<8)}if((f|0)==(Ib(q)|0)){r=g,s=bc(w[c+2|0]|w[c+3|0]<<8|(w[c+4|0]<<16|w[c+5|0]<<24)),v[r>>2]=s}v[d>>2]=v[d>>2]+7;continue}}c=P()|0;O()|0;nO(e);break m}Dk(i);nO(e)}v[23540]=0;U(717,d+16|0,d+176|0,1312902469);c=v[23540];v[23540]=0;if((c|0)==1){break n}v[23540]=0;c=S(178,v[d+16>>2])|0;e=v[23540];v[23540]=0;E:{if((e|0)==1){break E}F:{if(c){v[23540]=0;c=S(160,v[d+16>>2])|0;e=v[23540];v[23540]=0;if((e|0)==1){break E}v[23540]=0;U(314,d+16|0,((b<<5)+a|0)+946304|0,c|0);b=v[23540];v[23540]=0;if((b|0)!=1){break F}break E}v[23540]=0;c=Q(55,d|0,21688)|0;e=v[23540];v[23540]=0;if((e|0)==1){break E}Dc(((b<<5)+a|0)+946304|0,c);zb(c)}Fz(i,v[a+480180>>2]);uj(i,a);Bb(d+16|0);Bb(d- -64|0);break h}c=P()|0;O()|0;Bb(d+16|0);break m}c=P()|0;O()|0;break k}c=P()|0;O()|0;break j}c=P()|0;O()|0;break j}c=P()|0;O()|0;break m}c=P()|0;O()|0;break i}Bb(d- -64|0);break k}c=P()|0;O()|0}Bb(d+104|0)}Bb(d+152|0)}Zd(d+176|0);T(c|0);L()}Bb(d+104|0)}Bb(d+152|0);Zd(d+176|0)}kb=d+208|0;return k|0}function kfa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,y=0,z=0,A=0,C=0;e=kb-224|0;kb=e;zc(b);a:{if(!Xt(b,e+160|0)){break a}if(!OQ(e+160|0)){break a}if(!Qb(v[b>>2],v[b+8>>2],Ec(NQ(e+160|0),nb))){break a}if(!c){d=1;break a}Cd(a,256);f=e+144|0;Dj(f,2,e+160|0);d=e+48|0;Fc(d,f);Bc(a+1298308|0,d);zb(d);f=x[e+210>>1];v[a+480260>>2]=64;v[a+480264>>2]=32767;u[a+480188>>1]=4;u[a+480190>>1]=f;Ob(a+1074312|0,107,1);f=w[e+203|0];f=f?f:96;k=Xz(f);v[a+480196>>2]=f>>>4;v[a+480204>>2]=k;t[e+48|0]=64;A=a,C=w[Yb(e+202|0,d)|0]<<2,v[A+480200>>2]=C;d=0;b:{c:{d:{e:{f:{g:{while(1){if((d|0)==4){h:{k=Tb(e+144|0);m=Tb(e+128|0);v[23540]=0;Q(155,b|0,x[e+192>>1]<<4)|0;d=v[23540];v[23540]=0;i:{if((d|0)==1){break i}v[23540]=0;W(217,b|0,k|0,x[e+208>>1])|0;d=v[23540];v[23540]=0;if((d|0)==1){break i}v[23540]=0;Q(155,b|0,x[e+194>>1]<<4)|0;d=v[23540];v[23540]=0;if((d|0)==1){break i}v[23540]=0;W(217,b|0,m|0,x[e+210>>1])|0;d=v[23540];v[23540]=0;if((d|0)==1){break i}v[23540]=0;Q(155,b|0,(x[e+196>>1]<<4)+32|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break i}d=a+484376|0;f=w[d|0];i=v[a+484360>>2];v[23540]=0;R(324,Wb(i,f)|0,x[e+212>>1]);f=v[23540];v[23540]=0;if((f|0)==1){break i}d=Wb(v[a+484360>>2],w[d|0]);A=e,C=Fb(v[d>>2]),v[A+48>>2]=C;d=Fb(v[d+4>>2]);j:{while(1){f=v[e+48>>2];if(!Pb(f,d)){d=0;if(!QQ(Wb(v[a+484360>>2],w[a+484376|0]))){break b}i=c&2;j=e+48|1;d=1;break j}v[23540]=0;i=S(206,b|0)|0;j=v[23540];v[23540]=0;k:{if((j|0)==1){break k}u[f>>1]=i;v[23540]=0;Q(188,b|0,4)|0;f=v[23540];v[23540]=0;if((f|0)==1){break k}Se(e+48|0);continue}break}d=P()|0;O()|0;break c}l:{m:{n:{o:{while(1){f=d&65535;if(f>>>0>x[e+210>>1]){break l}g=cc(v[m>>2],f-1|0);g=w[g|0]|w[g+1|0]<<8;v[23540]=0;g=Q(155,b|0,g<<4)|0;h=v[23540];v[23540]=0;p:{if((h|0)!=1){if(g){break p}d=0;break b}d=P()|0;O()|0;break c}v[23540]=0;Q(670,b|0,e+48|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break o}v[23540]=0;g=(B(f,104)+a|0)+484380|0;U(671,e+48|0,g|0,0);h=v[23540];v[23540]=0;if((h|0)==1){break o}h=e+16|0;uk(h,2,j);v[23540]=0;R(222,e+32|0,h|0);h=v[23540];v[23540]=0;if((h|0)==1){break n}h=((f<<5)+a|0)+946304|0;f=e+32|0;Dc(h,f);zb(f);q:{r:{if(!i|!v[e+64>>2]){break r}f=bR(e+48|0);v[23540]=0;f=Q(155,b|0,f|0)|0;h=v[23540];v[23540]=0;if((h|0)==1){break m}if(!f){break r}f=e+32|0;aR(f,w[e+78|0],w[e+79|0],1);v[23540]=0;W(219,f|0,g|0,b|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break q}}d=d+1|0;continue}break}d=P()|0;O()|0;break c}d=P()|0;O()|0;break c}d=P()|0;O()|0;break c}d=P()|0;O()|0;break c}t[e+15|0]=1;d=v[k>>2];s:{if(pc(d,v[k+4>>2])|x[e+188>>1]==26){break s}f=w[d|0]|w[d+1|0]<<8;d=0;v[23540]=0;f=Q(155,b|0,f<<4)|0;i=v[23540];v[23540]=0;if((i|0)==1){break h}if(!f){break b}v[23540]=0;d=S(194,b|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break h}if((d|0)!=x[e+188>>1]){break s}t[e+15|0]=0}n=c&1;if(n){v[23540]=0;R(225,a+484344|0,x[e+208>>1]);c=v[23540];v[23540]=0;if((c|0)==1){break h}}h=a+484344|0;c=e+48|0;p=c|5;q=c|4;r=c|2;s=c|1;y=a+480188|0;f=0;while(1){t:{if(!n|x[e+208>>1]<=f>>>0){break t}v[23540]=0;c=W(226,h|0,f&65535,64)|0;d=v[23540];v[23540]=0;if((d|0)==1){break g}if(!c){break t}c=cc(v[k>>2],f);c=w[c|0]|w[c+1|0]<<8;v[23540]=0;c=Q(155,b|0,c<<4)|0;d=v[23540];v[23540]=0;if((d|0)==1){break g}d=0;if(!c){break b}if(!w[e+15|0]){v[23540]=0;c=S(194,b|0)|0;i=v[23540];v[23540]=0;if((i|0)==1){break g}if(c>>>0>2112){break b}}u[e+16>>1]=65535;v[e+32>>2]=63;u:while(1){c=_b(v[h>>2],f);z=Cf(v[c>>2],v[v[c+48>>2]+12>>2],d);v:while(1){c=d;while(1){if(c>>>0<=63){v[23540]=0;i=S(206,b|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break f}if(!i){d=64;if(c>>>0>62){continue v}d=c+1|0;continue u}d=i&31;j=B(d,6)+z|0;l=ug(e+48|0);g=d>>>0<x[y>>1];o=g?j:l;if(i&32){v[23540]=0;R(260,e|0,b|0);d=v[23540];v[23540]=0;w:{x:{y:{if((d|0)!=1){l=Oc(e);d=w[e|0];if(d>>>0>239){break y}d=$Q((B(d>>>4|0,12)+(d&15)|0)+37|0);break x}d=P()|0;O()|0;break c}z:{switch(d-254|0){case 0:break x;case 1:break z;default:break w}}d=0}t[o|0]=d}t[(g?j+1|0:s)|0]=w[l|0]}if(i&64){v[23540]=0;d=S(206,b|0)|0;l=v[23540];v[23540]=0;if((l|0)==1){break e}t[e|0]=d;t[(g?j+2|0:r)|0]=1;t[e+14|0]=64;A=g?j+4|0:q,C=w[Yb(e,e+14|0)|0],t[A|0]=C}if(!(i&128)){continue}v[23540]=0;R(260,e|0,b|0);d=v[23540];v[23540]=0;if((d|0)==1){break d}A=g?j+5|0:p,C=w[Oc(e)|0],t[A|0]=C;PQ(o,w[e|0],c,255,e+16|0,e+32|0);continue}break}break}break}c=x[e+16>>1];if((c|0)!=65535){ze(_b(v[h>>2],f),Nm(Ue(Oe(e+48|0,12,c&255),v[e+32>>2])))}f=f+1|0;continue}break}v[23540]=0;b=Q(1,e+48|0,6091)|0;c=v[23540];v[23540]=0;A:{B:{C:{if((c|0)!=1){Jb(a+1298344|0,b);Ab(b);v[23540]=0;b=Q(1,e+32|0,5277)|0;c=v[23540];v[23540]=0;if((c|0)==1){break C}Jb(a+1298356|0,b);Ab(b);v[a+1298404>>2]=5;v[23540]=0;R(673,e|0,4408);b=v[23540];v[23540]=0;if((b|0)==1){break B}v[23540]=0;U(305,e+16|0,e|0,e+15|0);b=v[23540];v[23540]=0;if((b|0)==1){break A}b=a+1298368|0;a=e+16|0;Jb(b,a);Ab(a);dc(e);d=1;break b}d=P()|0;O()|0;break c}d=P()|0;O()|0;break c}d=P()|0;O()|0;break c}d=P()|0;O()|0;dc(e);break c}d=P()|0;O()|0;break c}}else{f=(d<<5)+a|0;df(f+480280|0);u[f+480284>>1]=d&1?64:192;d=d+1|0;continue}break}d=P()|0;O()|0;break c}d=P()|0;O()|0;break c}d=P()|0;O()|0;break c}d=P()|0;O()|0;break c}d=P()|0;O()|0}od(m);od(k);T(d|0);L()}od(m);od(k)}kb=e+224|0;return d|0}function PH(a,b,c,d,e,f,g){var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,x=0,y=0,z=0,C=0,D=0,E=0,F=0;i=kb-80|0;kb=i;v[i+76>>2]=b;D=i+55|0;s=i+56|0;b=0;a:{b:{c:{d:{e:while(1){if((2147483647-o|0)<(b|0)){break d}o=b+o|0;f:{g:{h:{k=v[i+76>>2];b=k;h=w[b|0];if(h){while(1){i:{h=h&255;j:{if(!h){h=b;break j}if((h|0)!=37){break i}h=b;while(1){if(w[b+1|0]!=37){break j}j=b+2|0;v[i+76>>2]=j;h=h+1|0;l=w[b+2|0];b=j;if((l|0)==37){continue}break}}b=h-k|0;C=2147483647-o|0;if((b|0)>(C|0)){break d}if(a){tf(a,k,b)}if(b){continue e}r=-1;h=1;b=v[i+76>>2];j=t[b+1|0];if(!(!bk(j)|w[b+2|0]!=36)){r=j-48|0;y=1;h=3}b=h+b|0;v[i+76>>2]=b;p=0;m=t[b|0];j=m-32|0;k:{if(j>>>0>31){h=b;break k}h=b;j=1<<j;if(!(j&75913)){break k}while(1){h=b+1|0;v[i+76>>2]=h;p=j|p;m=t[b+1|0];j=m-32|0;if(j>>>0>=32){break k}b=h;j=1<<j;if(j&75913){continue}break}}l:{if((m|0)==42){b=t[h+1|0];m:{if(!(!bk(b)|w[h+2|0]!=36)){v[((b<<2)+e|0)-192>>2]=10;m=h+3|0;q=v[((t[h+1|0]<<3)+d|0)-384>>2];y=1;break m}if(y){break h}m=h+1|0;if(!a){v[i+76>>2]=m;y=0;q=0;break l}b=v[c>>2];v[c>>2]=b+4;q=v[b>>2];y=0}v[i+76>>2]=m;if((q|0)>=0){break l}q=0-q|0;p=p|8192;break l}q=OH(i+76|0);if((q|0)<0){break d}m=v[i+76>>2]}b=0;l=-1;n:{if(w[m|0]!=46){j=m;h=0;break n}if(w[m+1|0]==42){h=t[m+2|0];o:{if(!(!bk(h)|w[m+3|0]!=36)){v[((h<<2)+e|0)-192>>2]=10;j=m+4|0;l=v[((t[m+2|0]<<3)+d|0)-384>>2];break o}if(y){break h}j=m+2|0;l=0;if(!a){break o}h=v[c>>2];v[c>>2]=h+4;l=v[h>>2]}v[i+76>>2]=j;h=(l^-1)>>>31|0;break n}v[i+76>>2]=m+1;l=OH(i+76|0);j=v[i+76>>2];h=1}z=h;while(1){n=b;h=28;x=j;if(t[j|0]-123>>>0<4294967238){break c}j=x+1|0;v[i+76>>2]=j;b=w[(t[x|0]+B(n,58)|0)+76623|0];if(b-1>>>0<8){continue}break}p:{q:{if((b|0)!=27){if(!b){break c}if((r|0)>=0){v[(r<<2)+e>>2]=b;b=(r<<3)+d|0;h=v[b+4>>2];v[i+64>>2]=v[b>>2];v[i+68>>2]=h;break q}if(!a){break f}NH(i- -64|0,b,c,g);break p}if((r|0)>=0){break c}}b=0;if(!a){continue e}}m=p&-65537;j=p&8192?m:p;p=0;r=5289;h=s;r:{s:{t:{u:{v:{w:{x:{y:{z:{A:{B:{C:{D:{E:{F:{G:{b=t[x|0];b=n?(b&15)==3?b&-33:b:b;switch(b-88|0){case 11:break r;case 9:case 13:case 14:case 15:break s;case 27:break x;case 12:case 17:break A;case 23:break B;case 0:case 32:break C;case 24:break D;case 22:break E;case 29:break F;case 1:case 2:case 3:case 4:case 5:case 6:case 7:case 8:case 10:case 16:case 18:case 19:case 20:case 21:case 25:case 26:case 28:case 30:case 31:break g;default:break G}}H:{switch(b-65|0){case 0:case 4:case 5:case 6:break s;case 2:break v;case 1:case 3:break g;default:break H}}if((b|0)==83){break w}break g}n=v[i+64>>2];k=v[i+68>>2];r=5289;break z}b=0;I:{switch(n&255){case 0:v[v[i+64>>2]>>2]=o;continue e;case 1:v[v[i+64>>2]>>2]=o;continue e;case 2:h=v[i+64>>2];v[h>>2]=o;v[h+4>>2]=o>>31;continue e;case 3:u[v[i+64>>2]>>1]=o;continue e;case 4:t[v[i+64>>2]]=o;continue e;case 6:v[v[i+64>>2]>>2]=o;continue e;case 7:break I;default:continue e}}h=v[i+64>>2];v[h>>2]=o;v[h+4>>2]=o>>31;continue e}l=l>>>0>8?l:8;j=j|8;b=120}m=s;E=b&32;n=v[i+64>>2];k=v[i+68>>2];if(n|k){while(1){m=m-1|0;t[m|0]=E|w[(n&15)+77152|0];F=!k&n>>>0>15|(k|0)!=0;x=k;k=k>>>4|0;n=(x&15)<<28|n>>>4;if(F){continue}break}}k=m;if(!(j&8)|!(v[i+64>>2]|v[i+68>>2])){break y}r=(b>>>4|0)+5289|0;p=2;break y}b=s;n=v[i+64>>2];k=v[i+68>>2];if(n|k){while(1){b=b-1|0;t[b|0]=n&7|48;x=!k&n>>>0>7|(k|0)!=0;m=k;k=m>>>3|0;n=(m&7)<<29|n>>>3;if(x){continue}break}}k=b;if(!(j&8)){break y}b=s-k|0;l=(b|0)<(l|0)?l:b+1|0;break y}b=v[i+68>>2];k=b;n=v[i+64>>2];if((b|0)<0){k=0-(k+((n|0)!=0)|0)|0;n=0-n|0;v[i+64>>2]=n;v[i+68>>2]=k;p=1;r=5289;break z}if(j&2048){p=1;r=5290;break z}p=j&1;r=p?5291:5289}k=Fn(n,k,s)}if((l|0)<0?z:0){break d}j=z?j&-65537:j;m=v[i+64>>2];b=v[i+68>>2];if(!((m|b)!=0|l)){k=s;h=k;l=0;break g}b=!(b|m)+(s-k|0)|0;l=(b|0)<(l|0)?l:b;break g}b=v[i+64>>2];k=b?b:17106;b=k;h=l>>>0<2147483647?l:2147483647;j=Ss(b,0,h);b=j?j-b|0:h;h=b+k|0;if((l|0)>=0){j=m;l=b;break g}j=m;l=b;if(w[h|0]){break d}break g}if(l){h=v[i+64>>2];break u}b=0;Gf(a,32,q,0,j);break t}v[i+12>>2]=0;v[i+8>>2]=v[i+64>>2];h=i+8|0;v[i+64>>2]=h;l=-1}b=0;J:{while(1){k=v[h>>2];if(!k){break J}k=MH(i+4|0,k);m=(k|0)<0;if(!(m|k>>>0>l-b>>>0)){h=h+4|0;b=b+k|0;if(l>>>0>b>>>0){continue}break J}break}if(m){break b}}h=61;if((b|0)<0){break c}Gf(a,32,q,b,j);if(!b){b=0;break t}k=0;h=v[i+64>>2];while(1){l=v[h>>2];if(!l){break t}l=MH(i+4|0,l);k=l+k|0;if(k>>>0>b>>>0){break t}tf(a,i+4|0,l);h=h+4|0;if(b>>>0>k>>>0){continue}break}}Gf(a,32,q,b,j^8192);b=(b|0)<(q|0)?q:b;continue e}if((l|0)<0?z:0){break d}h=61;b=ob[f|0](a,A[i+64>>3],q,l,j,b)|0;if((b|0)>=0){continue e}break c}t[i+55|0]=v[i+64>>2];l=1;k=D;j=m;break g}j=b+1|0;v[i+76>>2]=j;h=w[b+1|0];b=j;continue}}if(a){break a}if(!y){break f}b=1;while(1){a=v[(b<<2)+e>>2];if(a){NH((b<<3)+d|0,a,c,g);o=1;b=b+1|0;if((b|0)!=10){continue}break a}break}o=1;if(b>>>0>=10){break a}h=0;while(1){if(h){break h}b=b+1|0;if((b|0)==10){break a}h=v[(b<<2)+e>>2];continue}}h=28;break c}m=h-k|0;n=(l|0)>(m|0)?l:m;if((n|0)>(2147483647-p|0)){break d}h=61;l=n+p|0;b=(l|0)<(q|0)?q:l;if((C|0)<(b|0)){break c}Gf(a,32,b,l,j);tf(a,r,p);Gf(a,48,b,l,j^65536);Gf(a,48,n,m,0);tf(a,k,m);Gf(a,32,b,l,j^8192);continue}break}o=0;break a}h=61}v[116016]=h}o=-1}kb=i+80|0;return o}function uia(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,z=0,A=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;f=kb-224|0;kb=f;if(Hh(b,13853)){if(d){t[d|0]=1}k=a+480204|0;n=a+480216|0;o=a+480220|0;p=a+480224|0;l=a+1074368|0;s=a+480228|0;z=a+480232|0;q=a+480200|0;m=a+480268|0;A=a+1298320|0;C=a+480248|0;D=mu(a+1074312|0);E=a+480180|0;F=a+484376|0;G=a+480190|0;a:{b:{c:{d:{e:{f:{g:{h:{while(1){if(!Qb(v[b>>2],v[b+8>>2],7)){break a}e=Bg(b);g=Rg(b);if((e|0)==(w[21664]|w[21665]<<8|(w[21666]<<16|w[21667]<<24))){yg(b,6);break a}if(!(e&1616928864)|e&-2139062144){break a}if(!Qb(v[b>>2],v[b+8>>2],g)){break a}d=f+176|0;ae(d,b,g);h=kc(f+200|0,d);Bb(d);i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{if((e|0)!=1127099950){if((e|0)==1129797166){break v}if((e|0)==1130917459){break o}if((e|0)==1145525806){break t}d=z;if((e|0)==1448301654){break s}if((e|0)==1196316499){break m}if((e|0)==1213486401){break p}if((e|0)==1280530262){break u}if((e|0)==1297303086){break l}if((e|0)==1347243310){break w}if((e|0)==1347244882){break q}if((e|0)!=1380340804){if((e|0)==1380986414){break r}d=n;if((e|0)==1380991534){break s}d=o;if((e|0)==1380994350){break s}if((e|0)==1397052739){break n}d=s;if((e|0)==1397768494){break s}if((e|0)==1414344238){break k}if((e|0)!=1146367534){break j}v[23540]=0;U(440,h|0,g|0,f+176|0);d=v[23540];v[23540]=0;if((d|0)==1){break i}v[k>>2]=B(v[f+176>>2],1e4)+(y[k>>2]%1e4|0);break j}v[23540]=0;U(440,h|0,g|0,f+176|0);d=v[23540];v[23540]=0;if((d|0)!=1){d=v[k>>2];v[k>>2]=d-((d>>>0)%1e4|0)+y[f+176>>2]%1e4;break j}e=P()|0;O()|0;break b}if(c){break j}v[23540]=0;u[f+176>>1]=0;U(441,h|0,g|0,f+176|0);d=v[23540];v[23540]=0;if((d|0)!=1){H=a,I=Ed(x[f+176>>1],x[a+480188>>1],127),u[H+480188>>1]=I;break j}e=P()|0;O()|0;break b}v[23540]=0;U(442,h|0,g|0,l|0);d=v[23540];v[23540]=0;if((d|0)!=1){break j}break c}v[23540]=0;v[f+176>>2]=0;U(440,h|0,g|0,f+176|0);d=v[23540];v[23540]=0;if((d|0)!=1){v[a+1074304>>2]=v[f+176>>2];break j}e=P()|0;O()|0;break b}v[23540]=0;v[f+176>>2]=0;U(440,h|0,g|0,f+176|0);d=v[23540];v[23540]=0;if((d|0)==1){break h}d=v[f+176>>2];if(!d){break j}v[a+1074308>>2]=d;break j}d=q}v[23540]=0;U(440,h|0,g|0,d|0);d=v[23540];v[23540]=0;if((d|0)==1){break c}break j}if(v[E>>2]==4){break j}v[23540]=0;U(441,h|0,g|0,f+176|0);d=v[23540];v[23540]=0;if((d|0)!=1){Ve(Wb(v[a+484360>>2],w[F|0]),x[f+176>>1]);break j}e=P()|0;O()|0;break b}v[23540]=0;U(443,h|0,g|0,m|0);d=v[23540];v[23540]=0;if((d|0)==1){break c}if(Ko(w[m|0])){break j}t[m|0]=5;break j}d=Nb(f+176|0);e=v[h>>2];v[23540]=0;e=S(160,e|0)|0;g=v[23540];v[23540]=0;x:{if((g|0)==1){break x}v[23540]=0;U(444,h|0,d|0,e|0);e=v[23540];v[23540]=0;if((e|0)==1){break x}v[23540]=0;U(11,f+160|0,0,d|0);e=v[23540];v[23540]=0;if((e|0)==1){break x}e=f+160|0;Jb(A,e);Ab(e);zb(d);break j}e=P()|0;O()|0;zb(d);break b}if(g&1|g>>>0>126){break j}d=64;u[f+176>>1]=(g>>>1|0)- -64;u[f+160>>1]=127;e=x[Wc(f+176|0,f+160|0)>>1];i=e>>>0>64?e:64;while(1){if((d|0)==(i|0)){break j}v[23540]=0;R(260,f+176|0,h|0);e=v[23540];v[23540]=0;if((e|0)==1){break g}e=w[f+176|0];y:{if((e|0)==255){break y}j=w[Oc(f+176|0)|0];g=(d<<5)+a|0;r=g+480284|0;u[r>>1]=128;u[g+480286>>1]=j;g=g+480280|0;j=(e&128)<<3;v[g>>2]=j;e=e&127;if(e>>>0<65){u[r>>1]=e<<2;break y}if((e|0)!=100){break y}v[g>>2]=j|256}d=d+1|0;continue}}if(g>>>0<3){break j}v[23540]=0;d=S(194,h|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break f}if(!d|d>>>0>x[G>>1]){break j}d=(B(d,104)+a|0)+484448|0;g=vT(d);while(1){if((d|0)==(g|0)){break j}e=v[h>>2];v[23540]=0;i=W(156,e|0,v[f+208>>2],4)|0;e=v[23540];v[23540]=0;z:{if((e|0)!=1){e=268435456;if(!i){break z}v[23540]=0;e=S(157,h|0)|0;i=v[23540];v[23540]=0;if((i|0)!=1){break z}}e=P()|0;O()|0;break b}v[d>>2]=e;d=d+4|0;continue}}if(g>>>0<3){break j}v[23540]=0;R(445,f|0,h|0);d=v[23540];v[23540]=0;A:{B:{C:{D:{if((d|0)!=1){v[23540]=0;U(446,f+176|0,v[f>>2],v[f+4>>2]);d=v[23540];v[23540]=0;if((d|0)==1){break D}v[23540]=0;d=Q(89,f+16|0,f+176|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break C}zb(f+176|0);ic(f);e=v[h>>2];v[23540]=0;S(160,e|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break A}v[23540]=0;U(447,d|0,C|0,d|0);e=v[23540];v[23540]=0;if((e|0)==1){break A}sf(d);break j}e=P()|0;O()|0;break b}e=P()|0;O()|0;break B}e=P()|0;O()|0;zb(f+176|0)}ic(f);break b}e=P()|0;O()|0;sf(d);break b}e=0;g=mu(D);E:while(1){d=v[h>>2];v[23540]=0;d=W(156,d|0,v[f+208>>2],1)|0;i=v[23540];v[23540]=0;if((i|0)==1){break d}if(!(d&e>>>0<118)){break j}v[23540]=0;i=S(206,h|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break e}d=0;while(1){if((d|0)==8){continue E}F:{if(!(i>>>d&1)|e>>>0>117){break F}v[23540]=0;W(264,g|0,e|0,1)|0;j=v[23540];v[23540]=0;if((j|0)!=1){break F}e=P()|0;O()|0;break b}e=e+1|0;d=d+1|0;continue}}}v[23540]=0;U(448,h|0,g|0,p|0);d=v[23540];v[23540]=0;if((d|0)==1){break c}}Bb(h);continue}break}e=P()|0;O()|0;break b}e=P()|0;O()|0;break b}e=P()|0;O()|0;break b}e=P()|0;O()|0;break b}e=P()|0;O()|0;break b}e=P()|0;O()|0;break b}e=P()|0;O()|0}Bb(h);T(e|0);L()}b=v[a+8>>2];So(k,B(v[b+20>>2],1e4),B(v[b+24>>2],1e4));if(w[a+480224|0]>=3){t[p|0]=0}if(w[l|0]>=6){t[l|0]=0}xc(q,256);xc(n,65536);xc(o,65536)}kb=f+224|0}function Qia(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,z=0,A=0;e=kb-1360|0;kb=e;zc(b);g=kb-16|0;kb=g;j=e+784|0;DT(g+8|0,j);i=v[g+12>>2];nc(g,v[b>>2],v[b+8>>2],v[g+8>>2],v[g+12>>2]);l=v[g+4>>2];if((l|0)==(i|0)){$b(b,v[g+12>>2])}kb=g+16|0;g=(i|0)==(l|0);if(!g){CT(j)}a:{if(!g){break a}if(!FT(e+784|0)){break a}if(!Qb(v[b>>2],v[b+8>>2],Ec(ET(x[e+818>>1],x[e+820>>1]),nb))){break a}if(!c){d=1;break a}q=Gc(e+776|0);b:{while(1){if((d|0)!=32){g=(d<<5)+a|0;i=g+480280|0;df(i);j=(e+784|0)+(d<<4)|0;u[g+480284>>1]=((w[j+78|0]<<8&65280)>>>0)/255;m=e+512|0;uk(m,1,j- -64|0);l=e+112|0;Fc(l,m);El(g+480289|0,l);zb(l);c:{d:{switch(w[j+79|0]){case 0:k=f+1|0;break c;case 1:v[i>>2]=1024;k=d+1|0;break c;case 2:break d;default:break b}}v[i>>2]=1024;g=e+112|0;Sc(g,q,d);qo(g)}f=f+1|0;d=d+1|0;continue}break}Cd(a,33554432);u[a+480188>>1]=k&255;d=e+112|0;f=yc(d,6776);Jb(a+1298344|0,f);Ab(f);d=yc(d,11131);Jb(a+1298356|0,d);Ab(d);v[a+1298404>>2]=5;e:{if(w[e+863|0]){break e}d=1;f=1;while(1){if((d|0)==16){while(1){if((f|0)==16){break e}d=((f<<5)+a|0)+480280|0;v[d>>2]=v[d>>2]&-1025;f=f+1|0;continue}}g=d<<4;d=d+1|0;if(w[(e+g|0)+863|0]==1){continue}break}}d=e+512|0;Ne(d,1,e+784|0);f=e+112|0;Fc(f,d);Bc(a+1298308|0,f);zb(f);v[a+480208>>2]=v[a+480208>>2]&-17|x[e+822>>1]<<4&16;v[a+480196>>2]=w[e+832|0];v[a+480204>>2]=B(w[e+833|0],1e4);v[a+480200>>2]=w[e+834|0]<<2;v[a+480228>>2]=w[e+835|0];f=x[e+820>>1];u[a+480190>>1]=0;u[a+480192>>1]=f;dv(b,d);Xq(Wb(v[a+484360>>2],w[a+484376|0]),d,x[e+816>>1],65535,255);o=c&1;if(o){xg(a+484344|0,x[e+818>>1])}m=a+484344|0;s=a+480188|0;f:{while(1){g:{if(x[e+818>>1]<=h>>>0){l=c&2;q=e+108|0;m=a+480192|0;g=1;c=0;h:while(1){if(x[m>>1]<=(c&65535)>>>0){d=32;break b}c=c+1|0;f=Ou(a,c&65535,0);i=!f;d=kb-16|0;kb=d;k=e+112|0;gc(d+8|0,k,384);h=v[d+12>>2];nc(d,v[b>>2],v[b+8>>2],v[d+8>>2],v[d+12>>2]);j=v[d+4>>2];if((j|0)==(h|0)){$b(b,v[d+12>>2])}kb=d+16|0;d=(h|0)==(j|0);if(!d){Ub(k,0,384)}if(!d|i){continue}k=g&65535;h=kb-32|0;kb=h;i=e+112|0;Ne(h,1,i);d=h+16|0;Fc(d,h);Dc(f+492|0,d);zb(d);i:{if(!(w[i+378|0]|w[i+379|0]<<8)){break i}j=f+236|0;d=0;while(1){v[h+16>>2]=120;v[h>>2]=116;if(y[Kb(h+16|0,h)>>2]<=d>>>0){break i}z=cc(j,d+12|0),A=k+w[(d+i|0)+32|0]|0,u[z>>1]=A;d=d+1|0;continue}}d=w[i+376|0]|w[i+377|0]<<8;t[f+33|0]=1;v[f>>2]=d;ZA(i,f+48|0,0);ZA(i,f+68|0,1);ZA(i,f+88|0,2);d=w[f+100|0];if(d&1){t[f+100|0]=d|16}if(!(v[f>>2]|t[f+60|0]&1)){v[f>>2]=32767}kb=h+32|0;d=0;while(1){f=x[e+490>>1];if(f>>>0<=d>>>0){g=f+g|0;continue h}IU(b,e+48|0);j:{k:{if(Sb(q,15571,4)){break k}f=d+g|0;k=f&65535;if(k>>>0>3999){break k}u[a+480190>>1]=f;i=kb-32|0;kb=i;j=B(k,104)+a|0;f=j+484380|0;nd(f,0);$h(i,1,e+48|0);h=i+16|0;Fc(h,i);Be(f+43|0,h);zb(h);p=w[e+64|0]|w[e+65|0]<<8|(w[e+66|0]<<16|w[e+67|0]<<24);v[f>>2]=p;n=w[e+68|0]|w[e+69|0]<<8|(w[e+70|0]<<16|w[e+71|0]<<24);v[f+4>>2]=n;o=w[e+72|0]|w[e+73|0]<<8|(w[e+74|0]<<16|w[e+75|0]<<24);v[f+8>>2]=o;v[f+24>>2]=w[e+76|0]|w[e+77|0]<<8|(w[e+78|0]<<16|w[e+79|0]<<24);u[f+30>>1]=w[e+80|0]<<2;u[f+28>>1]=w[e+81|0];h=w[e+96|0];if(h&1){u[f+34>>1]=x[f+34>>1]|2;h=w[e+96|0]}if(h&2){u[f+34>>1]=x[f+34>>1]|4;h=w[e+96|0]}if(h&4){v[f+8>>2]=o>>>1;v[f+4>>2]=n>>>1;v[f>>2]=p>>>1;u[f+34>>1]=x[f+34>>1]|1;h=w[e+96|0]}if(h&8){u[f+34>>1]=x[f+34>>1]|32}kb=i+32|0;h=kb-16|0;kb=h;nv(h+8|0,j+484423|0);i=e+24|0;cr(i,v[h+8>>2],v[h+12>>2]);kb=h+16|0;Dc(((k<<5)+a|0)+946304|0,i);zb(i);h=v[e+64>>2];if(!h){break k}ae(e,b,h);h=kc(e+24|0,e);Bb(e);if(l){i=Zc(e,u[j+484414>>1]&1?16:8,1,0,0);v[23540]=0;W(219,i|0,f|0,h|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break j}}Bb(h)}d=d+1|0;continue}break}break}a=P()|0;O()|0;Bb(h);break f}f=Rg(b);p=Rg(b);d=e+48|0;ae(d,b,f-4|0);j=kc(e+112|0,d);Bb(d);l:{m:{if(!o){break m}v[23540]=0;d=W(226,m|0,h&65535,p|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break l}if(!d){break m}k=0;i=ug(e+24|0);while(1){if(k>>>0>=p>>>0){break m}v[23540]=0;l=S(206,j|0)|0;d=v[23540];v[23540]=0;n:{if((d|0)!=1){if(l){break n}k=k+1|0;continue}break g}f=i;n=l&31;if(n>>>0<x[s>>1]){d=_b(v[m>>2],h);f=jd(v[d>>2],v[v[d+48>>2]+12>>2],k,n)}if(l&32){v[23540]=0;R(260,e+48|0,j|0);d=v[23540];v[23540]=0;if((d|0)==1){break g}g=w[e+48|0];t[f|0]=g;z=f,A=w[Oc(e+48|0)|0],t[z+1|0]=A;o:{p:{if((g|0)==160){d=255;break p}if((g|0)==255){d=0;break p}d=0;g=(B(g>>>4|0,12)+(g&15)|0)+13|0;if(BT(g)){break o}}g=d}t[f|0]=g}d=l&192;q:{if(!d){break q}if((d|0)==192){v[23540]=0;R(349,e+48|0,j|0);d=v[23540];v[23540]=0;if((d|0)!=1){d=e+48|0;g=Oc(d);l=Te(d);d=Li(d);_A(e,w[e+48|0],w[g|0]);g=Oc(e);r=e+504|0;_A(r,w[l|0],w[d|0]);Co(e+496|0,f,w[e|0],w[g|0],w[e+504|0],w[Oc(r)|0]);break q}break g}v[23540]=0;R(260,e+48|0,j|0);d=v[23540];v[23540]=0;r:{s:{if((d|0)!=1){_A(e,w[e+48|0],w[Oc(e+48|0)|0]);g=w[Oc(e)|0];d=w[e|0];if((d|0)!=13){break s}t[f+2|0]=1;d=f+4|0;break r}break g}t[f+3|0]=d;d=f+5|0}t[d|0]=g}Sc(e+48|0,q,n);if(!Cb(v[v[e+48>>2]>>2],v[e+52>>2])){continue}if(!yV(w[f+3|0],w[f+5|0])){continue}t[f+3|0]=0;continue}}Bb(j);h=h+1|0;continue}}break}a=P()|0;O()|0;Bb(j)}T(a|0);L()}d=d>>>0>31}kb=e+1360|0;return d|0}function Bga(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,y=0,z=0,A=0;e=kb-1824|0;kb=e;zc(b);d=kb-16|0;kb=d;j=e+1224|0;XR(d+8|0,j);f=v[d+12>>2];nc(d,v[b>>2],v[b+8>>2],v[d+8>>2],v[d+12>>2]);i=v[d+4>>2];if((i|0)==(f|0)){$b(b,v[d+12>>2])}kb=d+16|0;d=(f|0)==(i|0);if(!d){WR(j)}a:{if(!d){break a}if(!YR(e+1224|0)){break a}if(!lA(b,16,0)){break a}v[e+1216>>2]=v[e+1240>>2];d=v[e+1228>>2];v[e+1200>>2]=v[e+1224>>2];v[e+1204>>2]=d;d=e+1232|0;f=v[d+4>>2];v[e+1208>>2]=v[d>>2];v[e+1212>>2]=f;Cd(a,1);Ob(Ob(_f(a+1074312|0,83),84,1),85,1);u[a+480188>>1]=4;v[e+1196>>2]=0;u[a+480190>>1]=15;dd(b,20);i=a+480188|0;g=1;n=1;while(1){b:{if((g|0)==16){d=e+1064|0;fS(b,d);f=a+484360|0;j=a+484376|0;Kq(Wb(v[f>>2],w[j|0]),d|2,128);g=0;m=eS(b,Wb(v[f>>2],w[j|0]),w[e+1064|0],k,i,0,1);if(!(w[e+1064|0]?1:w[e+1065|0]|m>>>0>1)){break a}if(cf(b)+65536>>>0<(m<<10)+k>>>0){break a}if(c){break b}g=1;break a}f=B(g,104)+a|0;j=f+484380|0;d=((g<<5)+a|0)+946304|0;mA(b,e+24|0,j,d,1);m=v[j>>2];c:{if(!w[Lb(d,0)|0]){break c}d:{if(Sb(d,16807,3)){if(Sb(d,16811,3)){break d}}if(w[Lb(d,5)|0]==58){break c}}n=0}d=Ib(x[e+52>>1]);if(d>>>0>=2){l=d<<1;d=Ib(x[e+50>>1]);v[f+484388>>2]=l+d;v[f+484384>>2]=d;Dk(j)}e:{if(Ib(x[e+46>>1])>>>0<=4999){if(Ib(x[e+50>>1])>>>0<1e4){break e}}v[e+1064>>2]=5;z=e,A=v[Pe(e+1196|0,e+1064|0)>>2],v[z+1196>>2]=A}k=k+m|0;g=g+1|0;continue}break}g=w[e+1065|0];if(!g){t[e+1065|0]=120;g=120}f:{if(!Sb(e+1200|0,14959,6)){t[e+1065|0]=120;v[a+480204>>2]=125e4;break f}v[a+480204>>2]=125e4;if((g|0)==120){break f}z=a,A=Qe(1773447.5/(+(240-g|0)*122)*1e4),v[z+480204>>2]=A;if(v[e+1196>>2]>=2){v[e+24>>2]=n?4:5;z=e,A=v[Pe(e+1196|0,e+24|0)>>2],v[z+1196>>2]=A;break f}v[e+24>>2]=n?1:2;z=e,A=v[Pe(e+1196|0,e+24|0)>>2],v[z+1196>>2]=A}v[a+480228>>2]=64;v[a+480260>>2]=452;v[a+480264>>2]=3424;v[a+480208>>2]=v[a+480208>>2]|2097152;f=e+1048|0;Dj(f,3,e+1200|0);d=e+24|0;Fc(d,f);Bc(a+1298308|0,d);zb(d);oh(a,0);r=v[b+8>>2];s=a+484376|0;while(1){g:{h:{if((p&65535)>>>0<m>>>0){d=Wb(v[a+484360>>2],w[s|0]);d=Pb(fA(Fb(v[d>>2]),Fb(v[d+4>>2]),p),Fb(v[d+4>>2]));VR(b,e+24|0);if(d){h=jA(e+24|0,0)+h|0;if(h>>>0>512){break h}}k=0;d=0;j=0;i:while(1){if((j|0)==64){break g}g=0;y=Kd(e+24|0,j);while(1){f=d;if((g|0)==4){j=j+1|0;continue i}else{o=Eb(y,g);l=w[Lb(o,2)|0]&15;i=w[Lb(o,3)|0];d=0;j:{if(!(f&255)){break j}if(Sb(o,26948,4)){break j}d=f+1|0;if((d&255)>>>0<33){break j}v[e+1196>>2]=6}k:{l:{m:{switch(l-1|0){case 0:case 1:f=v[e+1196>>2];if((f|0)==1&i>>>0>=32){break l}l=(l|0)!=1;if(!(l|!i|i>>>0>2)){v[e+1048>>2]=2;z=e,A=v[Pe(e+1196|0,e+1048|0)>>2],v[z+1196>>2]=A;break k}if(l|(i|0)!=55&(i|0)!=71){break k}if((f|0)<=2){break l}break k;case 10:v[e+1196>>2]=6;break k;case 11:case 12:case 13:v[e+1048>>2]=2;z=e,A=v[Pe(e+1196|0,e+1048|0)>>2],v[z+1196>>2]=A;if((l|0)!=13){break k}k=((i|j)!=0)+k|0;d=1;break k;case 14:break m;default:break k}}v[e+1048>>2]=3;z=e,A=v[Pe(e+1196|0,e+1048|0)>>2],v[z+1196>>2]=A;break k}v[e+1196>>2]=n}g=g+1|0;continue}}}}if(!(v[e+1196>>2]!=6|m+32>>>0>=q>>>0)){v[e+1196>>2]=5}dd(b,r);o=c&1;if(o){xg(a+484344|0,m)}l=a+484344|0;k=0;while(1){if((k|0)==(m|0)){g=21688;d=v[e+1196>>2];if(d>>>0<7){g=v[(d<<2)+26960>>2]}d=e+24|0;f=yc(d,8333);Jb(a+1298344|0,f);Ab(f);d=yc(d,10775);Jb(a+1298356|0,d);Ab(d);Ol(a+1298368|0,g);v[a+1298404>>2]=14;if(!(c&2)){break h}g=1;while(1){if((g|0)==16){break h}c=B(g,104)+a|0;d=c+484384|0;$b(b,v[d>>2]);f=v[d>>2];v[d>>2]=0;d=c+484380|0;v[d>>2]=v[d>>2]-f;c=c+484388|0;v[c>>2]=v[c>>2]-f;c=e+24|0;Zc(c,8,1,1,0);wg(c,d,b);g=g+1|0;continue}}VR(b,e+24|0);n:{if(!o){break n}if(!ph(l,k&65535,64)){break n}j=0;v[e+1048>>2]=0;o:while(1){if((j|0)==64){break n}g=0;d=_b(v[l>>2],k);q=jd(v[d>>2],v[v[d+48>>2]+12>>2],j,0);r=Kd(e+24|0,j);while(1)if((g|0)==4){j=j+1|0;continue o}else{d=Eb(r,g);d=w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24);v[e+4>>2]=d;v[e+8>>2]=d;h=e+16|0;d=q+B(g,6)|0;wu(h,e+4|0,d);f=w[e+16|0];i=Oc(h);h=w[i|0];if(!((f|0)!=14?h:0)){t[(e+1048|0)+g|0]=0}n=(e+1048|0)+g|0;p:{if(f|h){q:{h=w[n|0];if(h){r:{if(h>>>0>=16){t[d+2|0]=3;h=h>>>4|0;break r}t[d+2|0]=4}t[d+4|0]=h;f=w[e+16|0]}s:{t:{u:{v:{switch((f&255)-12|0){case 1:h=v[e+1196>>2];if((h|0)!=6){t[e+16|0]=10;break t}t[i|0]=0;break u;case 0:t[i|0]=w[i|0]&127;break u;case 2:h=w[i|0];if(h>>>0<=1){f=14;if(v[e+1196>>2]>3){break s}}t[e+16|0]=10;t[n|0]=w[i|0];break u;case 3:break v;default:break u}}t[i|0]=w[i|0]&15}h=v[e+1196>>2]}if((h|0)<2){break q}h=w[i|0];f=w[e+16|0]}Pf(d,f,h&255);break p}f=w[i|0];t[d+5|0]=f;w:{switch(w[e+16|0]){case 0:if(w[i|0]<=2){t[d+3|0]=0;break p}t[d+3|0]=1;break p;case 1:t[d+3|0]=1;break p;case 2:h=f&15;if(h){t[d+3|0]=2;t[d+5|0]=h;break p}if(f>>>0<16){break p}t[d+3|0]=3;t[d+5|0]=(f&240)>>>4;break p;default:break w}}t[d+3|0]=0;break p}t[n|0]=0}g=g+1|0;continue}}}k=k+1|0;continue}}g=(p&65535)>>>0>=m>>>0;break a}if((k-1&255)>>>0<2){v[e+1196>>2]=6}p=p+1|0;q=(k&255)+q|0;continue}}kb=e+1824|0;return g|0}function ofa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=kb-352|0;kb=d;dd(b,60);f=15;a:{if(!Hh(b,14163)){dd(b,124);f=31;if(!Hh(b,15426)){break a}}Cd(a,536870912);u[a+480190>>1]=f;zc(b);b:{while(1){if(x[a+480190>>1]>g>>>0){e=Do(b);v[(d+224|0)+(g<<2)>>2]=e;g=g+1|0;if(e>>>0<=131072){continue}break b}break}v[a+480260>>2]=56;v[a+480264>>2]=13696;v[a+480196>>2]=6;g=0;u[a+480192>>1]=0;u[a+480188>>1]=4;v[a+480228>>2]=64;oh(a,1);$b(b,4);e=Hj(b);if(e>>>0<178){break a}p=a,q=Qe(1776930/+(e>>>0)*1e4),v[p+480204>>2]=q;$b(b,14);f=0;n=1;c:while(1){m=n&65535;if(m>>>0<=x[a+480190>>1]){aS(b,d+56|0);g=v[((m<<2)+d|0)+220>>2];l=kb-16|0;kb=l;h=(B(m,104)+a|0)+484380|0;nd(h,1);v[h>>2]=g;t[h+37|0]=w[d+80|0]<<4;t[l+15|0]=w[d+81|0];t[l+14|0]=64;p=h,q=w[Yb(l+15|0,l+14|0)|0]<<2,u[p+30>>1]=q;d:{if(!g){break d}e=Ib(w[d+84|0]|w[d+85|0]<<8);j=Ib(w[d+82|0]|w[d+83|0]<<8);v[h+4>>2]=j;e=(e<<1)+j|0;v[h+8>>2]=e;if(g>>>0<=j>>>0){j=g-1|0;v[h+4>>2]=j}if(e>>>0>g>>>0){v[h+8>>2]=g;e=g}if(!(!(e>>>0<4|e>>>0<j>>>0)&e-j>>>0>3)){v[h+4>>2]=0;v[h+8>>2]=0;break d}if(e>>>0<=j>>>0){break d}u[h+34>>1]=x[h+34>>1]|2}kb=l+16|0;g=0;while(1)if((g|0)==22){if(f>>>0>127){break b}e=d+192|0;Fl(e,3,d+56|0);g=d+208|0;Fc(g,e);Dc(((m<<5)+a|0)+946304|0,g);n=n+1|0;zb(g);continue c}else{e=(d+56|0)+g|0;if((w[e|0]-1&255)>>>0<=30){t[e|0]=32;f=f+1|0}g=g+1|0;continue}}break}l=1;e:{f:{g:{f=a+946336|0;g=Kc(d+56|0,14030);if(!WQ(f,g)){v[23540]=0;e=Q(55,d+208|0,14041)|0;h=v[23540];v[23540]=0;if((h|0)==1){break g}l=WQ(f,e);zb(e)}zb(g);g=0;e=d+56|0;f=$R(b,e);if(!f){hA(e)}if(!f){break a}e=w[d+56|0];if(!ZQ(e)){break a}if(!c){break e}u[d+54>>1]=0;while(1)if((e|0)==(g|0)){g=a+484360|0;f=a+484376|0;i=Wb(v[g>>2],w[f|0]);h=w[d+57|0];Ve(i,e>>>0>h>>>0?h:0);Kq(Wb(v[g>>2],w[f|0]),d+56|2,w[d+56|0]);if(x[a+480190>>1]==31){$b(b,4)}v[d+48>>2]=0;v[d+44>>2]=0;v[d+40>>2]=0;t[d+39|0]=0;m=c&1;if(m){xg(a+484344|0,x[d+54>>1])}n=a+484344|0;h=0;while(1){h:{i:{j:{if(x[d+54>>1]<=h>>>0){if(!(c&2)){break j}g=1;while(1){f=x[a+480190>>1];c=g&65535;if(f>>>0<c>>>0){break i}c=(B(c,104)+a|0)+484380|0;if(v[c>>2]){wg(Zc(d+192|0,8,1,0,0),c,b)}g=g+1|0;continue}}k:{if(m){j=0;if(ph(n,h&65535,64)){break k}}$b(b,1024);break h}l:while(1){if((j|0)==64){break h}g=0;e=_b(v[n>>2],h);o=jd(v[e>>2],v[v[e+48>>2]+12>>2],j,0);while(1)if((g|0)==4){j=j+1|0;continue l}else{f=d+192|0;Um(f,b);e=B(g,6)+o|0;m:{n:{o:{p:{if(w[Lb(f,0)|0]!=255){break p}t[(d+48|0)+g|0]=0;t[(d+40|0)+g|0]=0;f=Lb(d+192|0,1);i=w[f|0];if((i|0)==252&l){t[f|0]=254;break n}switch(i-252|0){case 1:break m;case 2:break n;case 0:break o;default:break p}}f=v[d+192>>2];v[d+32>>2]=f;v[d+12>>2]=f;f=d+16|0;wu(f,d+12|0,e);i=Oc(f);f=w[e|0];q:{if(!f){break q}t[(d+40|0)+g|0]=0;t[(d+48|0)+g|0]=f;if(f>>>0>48){break q}t[d+31|0]=8;p=d,q=w[jf(d+39|0,d+31|0)|0],t[p+39|0]=q}f=w[i|0];r:{if(!(f|w[d+16|0])){break r}t[e+5|0]=f;s:{t:{switch(w[d+16|0]-1|0){case 0:t[e+3|0]=1;break r;case 1:if(f&240){t[e+3|0]=3;t[e+5|0]=f>>>4;break r}f=f&15;if(f){t[e+3|0]=2;t[e+5|0]=f;break r}t[e+3|0]=0;break r;case 2:if(w[(d+40|0)+g|0]){t[e+3|0]=0;break r}t[e+3|0]=19;t[e+5|0]=0;break r;case 3:if(w[(d+40|0)+g|0]){t[e+3|0]=0;break r}t[e+3|0]=19;t[e+5|0]=1;break r;case 4:if(!w[e+1|0]){break s}t[d+31|0]=63;t[d+30|0]=w[e+5|0]+(x[(B(w[e+1|0],104)+a|0)+484410>>1]>>>2|0);f=w[Yb(d+31|0,d+30|0)|0];t[e+3|0]=13;t[e+5|0]=f;if(!w[(d+40|0)+g|0]){break r}t[e+4|0]=w[e+5|0];t[e+2|0]=1;t[e+3|0]=0;break r;case 5:i=w[e+1|0];if(i){t[e+3|0]=13;i=x[(B(i,104)+a|0)+484410>>1]>>>2|0;f=f>>>0>i>>>0?0:i-f|0;t[e+5|0]=f;if(!w[(d+40|0)+g|0]){break r}t[e+4|0]=f;t[e+2|0]=1}t[e+3|0]=0;break r;case 6:i=f&15;t[(d+40|0)+g|0]=i;k=w[(d+48|0)+g|0];f=k-(f>>>4|0)|0;t[(d+44|0)+g|0]=f;f=VQ(i,f&255,k);t[e+3|0]=3;t[e+5|0]=f;break r;case 7:i=f&15;t[(d+40|0)+g|0]=i;k=f>>>4|0;f=w[(d+48|0)+g|0];k=k+f|0;t[(d+44|0)+g|0]=k;f=VQ(i,f,k&255);t[e+3|0]=2;t[e+5|0]=f;break r;case 8:break t;default:break s}}t[d+31|0]=8;p=d,q=w[jf(d+39|0,d+31|0)|0],t[p+39|0]=q}t[e+3|0]=0}if(w[e+3|0]){break m}i=w[(d+40|0)+g|0];if(!i){break m}k=(d+44|0)+g|0;f=w[k|0];if(f){t[(d+48|0)+g|0]=f;t[e|0]=f;t[e+5|0]=i;t[k|0]=0}t[e+3|0]=4;break m}t[e+3|0]=14;t[d+39|0]=9;break m}t[e+3|0]=13}g=g+1|0;continue}}}f=x[a+480190>>1]}u:{v:{w:{if((f&65535)==15){b=d+16|0;Sf(b,4421);v[23540]=0;U(305,d+192|0,b|0,d+39|0);b=v[23540];v[23540]=0;if((b|0)==1){break u}b=d+192|0;Jb(a+1298344|0,b);Ab(b);dc(d+16|0);break w}v[23540]=0;b=Q(1,d+192|0,12311)|0;c=v[23540];v[23540]=0;if((c|0)==1){break v}Jb(a+1298344|0,b);Ab(b)}Ol(a+1298356|0,x[a+480190>>1]==15?5285:15160);v[a+1298404>>2]=14;break e}f=P()|0;O()|0;break f}f=P()|0;O()|0;dc(d+16|0);break f}h=h+1|0;continue}}else{u[d+192>>1]=w[(d+g|0)+58|0]+1;p=d,q=x[ke(d+54|0,d+192|0)>>1],u[p+54>>1]=q;g=g+1|0;continue}}f=P()|0;O()|0;zb(g)}T(f|0);L()}g=1;break a}g=0}kb=d+352|0;return g|0}function tI(a,b,c,d,e,f){var g=0,h=C(0),i=0,j=0,k=C(0),l=C(0),m=C(0),n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,A=C(0),D=C(0),E=0,F=0,G=0,H=C(0),I=C(0),J=C(0),K=C(0),L=C(0),M=C(0),N=C(0),O=C(0),P=0,Q=0;F=(d|0)>0?d:0;while(1){if((s|0)!=(F|0)){G=B(s,2304)+b|0;v=0;q=(c|0)>0?c:0;n=kb-128|0;x=n+96|0;y=n- -64|0;E=n+32|0;while(1){if((q|0)!=(v|0)){o=G+(v<<2)|0;w=0;i=n;p=i;j=0;while(1){if((j|0)!=8){k=z[B(15-j|0,72)+o>>2];g=B(j,72)+o|0;h=z[g+1152>>2];l=C(k+h);m=z[g>>2];A=z[B(31-j|0,72)+o>>2];D=C(m+A);z[p>>2]=l+D;g=B(j,12);k=C(C(k-h)*z[g+71344>>2]);h=C(C(m-A)*z[g+71348>>2]);z[p+64>>2]=k+h;m=C(D-l);l=z[g+71352>>2];z[p+32>>2]=m*l;z[p+96>>2]=C(h-k)*l;p=p+4|0;j=j+1|0;continue}break}while(1){if((w|0)!=4){l=z[i+8>>2];m=z[i+20>>2];h=C(l+m);A=z[i+4>>2];D=z[i+24>>2];H=C(A+D);k=C(h+H);I=z[i+12>>2];J=z[i+16>>2];K=C(I+J);L=z[i>>2];M=z[i+28>>2];N=C(L+M);O=C(K+N);z[i>>2]=k+O;z[i+16>>2]=C(O-k)*C(.7071067690849304);k=C(N-K);h=C(C(k+C(H-h))*C(.7071067690849304));z[i+24>>2]=C(k-h)*C(1.3065630197525024);z[i+8>>2]=C(k+h)*C(.5411961078643799);k=C(L-M);h=C(l-m);l=C(A-D);m=C(C(h+l)*C(.7071067690849304));A=C(k+m);D=C(C(I-J)+h);h=C(l+k);l=C(D-C(h*C(.1989123672246933)));h=C(C(l*C(.3826834261417389))+h);z[i+28>>2]=C(A-h)*C(2.562915563583374);z[i+4>>2]=C(A+h)*C(.509795606136322);k=C(k-m);h=C(l-C(h*C(.1989123672246933)));z[i+20>>2]=C(k+h)*C(.8999761939048767);z[i+12>>2]=C(k-h)*C(.601344883441925);i=i+32|0;w=w+1|0;continue}break}i=0;while(1){if((i|0)!=7){p=i<<2;z[o>>2]=z[p+n>>2];k=z[p+x>>2];i=i+1|0;j=i<<2;h=z[j+x>>2];z[o+72>>2]=C(z[p+y>>2]+k)+h;z[o+144>>2]=z[p+E>>2]+z[j+E>>2];z[o+216>>2]=h+C(k+z[j+y>>2]);o=o+288|0;continue}break}z[o>>2]=z[n+28>>2];k=z[n+124>>2];z[o+72>>2]=z[n+92>>2]+k;h=z[n+60>>2];z[o+216>>2]=k;z[o+144>>2]=h;v=v+1|0;continue}break}s=s+1|0;continue}break}E=sc(f,a,3840);G=d<<5;s=0;while(1){if((c|0)>(s|0)){i=kb-32|0;kb=i;o=E+(s<<8)|0;v=(s<<2)+b|0;z[o+4080>>2]=z[v+1152>>2];f=d-1|0;w=v+B(f,2304)|0;z[o+4084>>2]=z[w+1152>>2];z[o+4088>>2]=z[v>>2];z[o+4092>>2]=z[w>>2];z[o+4336>>2]=z[v+1156>>2];z[o+4340>>2]=z[w+1156>>2];z[o+4344>>2]=z[v+4>>2];z[o+4348>>2]=z[w+4>>2];x=(B(s,G)<<1)+e|0;y=x+(f<<1)|0;qs(y,d,o+244|0);f=d<<6;qs(f+y|0,d,o+500|0);qs(x,d,o+240|0);qs(f+x|0,d,o+496|0);F=o+3840|0;p=14;n=71440;while(1){if((p|0)>=0){g=p<<4;j=g+F|0;f=B(31-p|0,72);z[j>>2]=z[f+v>>2];z[j+4>>2]=z[f+w>>2];f=f|4;z[j+8>>2]=z[f+v>>2];z[j+12>>2]=z[f+w>>2];f=B(p,72);q=f+76|0;z[j+256>>2]=z[q+v>>2];z[j+260>>2]=z[q+w>>2];f=f+72|0;z[j-248>>2]=z[f+v>>2];z[j-244>>2]=z[f+w>>2];q=p<<2;t=g+o|0;k=z[n+4>>2];h=z[n>>2];f=0;while(1){if((f|0)!=4){g=f<<2;l=z[g+j>>2];m=z[g+t>>2];z[g+(i+16|0)>>2]=C(l*h)-C(k*m);z[i+g>>2]=C(l*k)+C(h*m);f=f+1|0;continue}break}j=F+(q<<2)|0;q=j-3584|0;t=j-256|0;k=z[n+12>>2];h=z[n+8>>2];f=0;while(1){if((f|0)!=4){g=f<<2;r=g+i|0;l=z[g+t>>2];m=z[g+q>>2];z[r>>2]=z[r>>2]+C(C(l*k)+C(h*m));g=g+(i+16|0)|0;z[g>>2]=C(C(m*k)-C(h*l))+z[g>>2];f=f+1|0;continue}break}q=j-3328|0;t=j-512|0;k=z[n+20>>2];h=z[n+16>>2];f=0;while(1){if((f|0)!=4){g=f<<2;r=g+i|0;l=z[g+t>>2];m=z[g+q>>2];z[r>>2]=z[r>>2]+C(C(l*k)+C(h*m));g=g+(i+16|0)|0;z[g>>2]=C(C(l*h)-C(k*m))+z[g>>2];f=f+1|0;continue}break}q=j-3072|0;t=j-768|0;k=z[n+28>>2];h=z[n+24>>2];f=0;while(1){if((f|0)!=4){g=f<<2;r=g+i|0;l=z[g+t>>2];m=z[g+q>>2];z[r>>2]=z[r>>2]+C(C(l*k)+C(h*m));g=g+(i+16|0)|0;z[g>>2]=C(C(m*k)-C(h*l))+z[g>>2];f=f+1|0;continue}break}q=j-2816|0;t=j-1024|0;k=z[n+36>>2];h=z[n+32>>2];f=0;while(1){if((f|0)!=4){g=f<<2;r=g+i|0;l=z[g+t>>2];m=z[g+q>>2];z[r>>2]=z[r>>2]+C(C(l*k)+C(h*m));g=g+(i+16|0)|0;z[g>>2]=C(C(l*h)-C(k*m))+z[g>>2];f=f+1|0;continue}break}q=j-2560|0;t=j-1280|0;k=z[n+44>>2];h=z[n+40>>2];f=0;while(1){if((f|0)!=4){g=f<<2;r=g+i|0;l=z[g+t>>2];m=z[g+q>>2];z[r>>2]=z[r>>2]+C(C(l*k)+C(h*m));g=g+(i+16|0)|0;z[g>>2]=C(C(m*k)-C(h*l))+z[g>>2];f=f+1|0;continue}break}q=j-2304|0;t=j-1536|0;k=z[n+52>>2];h=z[n+48>>2];f=0;while(1){if((f|0)!=4){g=f<<2;r=g+i|0;l=z[g+t>>2];m=z[g+q>>2];z[r>>2]=z[r>>2]+C(C(l*k)+C(h*m));g=g+(i+16|0)|0;z[g>>2]=C(C(l*h)-C(k*m))+z[g>>2];f=f+1|0;continue}break}g=j-2048|0;q=j-1792|0;k=z[n+60>>2];h=z[n+56>>2];f=0;while(1){if((f|0)!=4){j=f<<2;t=j+i|0;l=z[j+q>>2];m=z[g+j>>2];z[t>>2]=z[t>>2]+C(C(l*k)+C(h*m));j=j+(i+16|0)|0;z[j>>2]=C(C(m*k)-C(h*l))+z[j>>2];f=f+1|0;continue}break}f=B(15-p|0,d)<<1;P=f+y|0,Q=gj(z[i+20>>2]),u[P>>1]=Q;j=B(p+17|0,d)<<1;P=j+y|0,Q=gj(z[i+4>>2]),u[P>>1]=Q;P=f+x|0,Q=gj(z[i+16>>2]),u[P>>1]=Q;P=j+x|0,Q=gj(z[i>>2]),u[P>>1]=Q;f=B(47-p|0,d)<<1;P=f+y|0,Q=gj(z[i+28>>2]),u[P>>1]=Q;j=B(p+49|0,d)<<1;P=j+y|0,Q=gj(z[i+12>>2]),u[P>>1]=Q;P=f+x|0,Q=gj(z[i+24>>2]),u[P>>1]=Q;P=j+x|0,Q=gj(z[i+8>>2]),u[P>>1]=Q;p=p-1|0;n=n- -64|0;continue}break}kb=i+32|0;s=s+2|0;continue}break}b=c<<6;a:{if((d|0)==1){s=0;while(1){if(s>>>0>959){break a}z[(s<<2)+a>>2]=z[E+(b+s<<2)>>2];s=s+2|0;continue}}sc(a,E+(b<<2)|0,3840)}}function rja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,y=0;g=kb-288|0;kb=g;zc(b);e=kb-16|0;kb=e;h=g+80|0;cU(e+8|0,h);f=v[e+12>>2];nc(e,v[b>>2],v[b+8>>2],v[e+8>>2],v[e+12>>2]);i=v[e+4>>2];if((i|0)==(f|0)){$b(b,v[e+12>>2])}kb=e+16|0;e=(f|0)==(i|0);if(!e){bU(h)}a:{if(!e){break a}if(!eU(g+80|0)){break a}if(!Qb(v[b>>2],v[b+8>>2],Ec(dU(g+80|0),nb))){break a}b:{if(!c){break b}Cd(a,16777216);ag(a);v[a+480208>>2]=v[a+480208>>2]|16777216;d=g+56|0;yq(d,32);f=g- -64|0;h=v[f+4>>2];e=a+1074320|0;v[e>>2]=v[f>>2];v[e+4>>2]=h;e=v[g+60>>2];v[a+1074312>>2]=v[g+56>>2];v[a+1074316>>2]=e;Ob(a+1074312|0,114,1);s=a+480188|0,y=Ib(x[g+280>>1]),u[s>>1]=y;oh(a,1);e=yc(d,8570);Jb(a+1298368|0,e);Ab(e);e=g+32|0;Sf(e,3927);v[23540]=0;U(362,d|0,e|0,w[g+83|0]);d=v[23540];v[23540]=0;c:{if((d|0)!=1){d=g+56|0;Jb(a+1298344|0,d);Ab(d);e=g+32|0;dc(e);f=yc(d,10779);Jb(a+1298356|0,f);Ab(f);v[a+1298404>>2]=12;Ne(e,3,g+80|4);Fc(d,e);Bc(a+1298308|0,d);zb(d);f=160;while(1){d:{d=f;if(!d){d=0;break d}f=d-1|0;if(w[(g+f|0)+116|0]==32){continue}}break}aU(a+1298332|0,g+116|0,d,4);o=a+480190|0;d=Ib(x[g+276>>1]);u[o>>1]=d;l=1;while(1){e:{f:{g:{h:{i:{e=d&65535;d=l&65535;if(e>>>0<d>>>0){f=a+484360|0;e=a+484376|0;Ve(Wb(v[f>>2],w[e|0]),Ib(x[g+284>>1]));d=g+32|0;ae(d,b,512);j=kc(g+56|0,d);Bb(d);d=w[e|0];f=v[f>>2];h=x[g+282>>1];v[23540]=0;U(274,Wb(f,d)|0,j|0,Ib(h)|0);d=v[23540];v[23540]=0;if((d|0)!=1){break i}d=P()|0;O()|0;break h}h=B(d,104)+a|0;i=h+484380|0;nd(i,1);vo(i);aV(b,((d<<5)+a|0)+946304|0,w[g+83|0]==1?32:28);n=1;d=w[g+83|0];if(d>>>0>=3){$b(b,14);d=gB(b);if((d|0)>=0){e=h+484414|0;u[e>>1]=x[e>>1]|32;s=h+484408|0,y=Ec((((d&65535)<<8)+2047>>>0)/4095|0,0),u[s>>1]=y}d=w[g+83|0]}if((d&255)>>>0>=2){n=Hj(b);s=h+484404|0,y=Hj(b),v[s>>2]=y}d=g+56|0;f=kb-16|0;kb=f;j:{if(!Qb(v[b>>2],v[b+8>>2],12)){v[f>>2]=0;e=d;j=3;while(1){if(j){k=w[f|0]|w[f+1|0]<<8|(w[f+2|0]<<16|w[f+3|0]<<24);t[e|0]=k;t[e+1|0]=k>>>8;t[e+2|0]=k>>>16;t[e+3|0]=k>>>24;j=j-1|0;e=e+4|0;continue}break}break j}Fq(f+8|0,d);ud(f,b,v[f+8>>2],v[f+12>>2])}kb=f+16|0;e=jc(d);d=Gb(d);k=bc(v[g+56>>2]);v[i>>2]=k;m=h+484384|0;j=bc(w[e|0]|w[e+1|0]<<8|(w[e+2|0]<<16|w[e+3|0]<<24));v[m>>2]=j;p=h+484388|0;q=bc(w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24))+j|0;v[p>>2]=q;f=h+484414|0;if(j){e=x[f>>1];break f}e=x[f>>1];if(bc(w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24))>>>0>=3){break f}d=e&-3;break e}d=Fb(v[Wb(v[a+484360>>2],w[e|0])>>2]);f=Fb(v[Wb(v[a+484360>>2],w[e|0])+4>>2]);e=kb-16|0;kb=e;k:{if(!Pb(d,f)){break k}v[e+8>>2]=d;while(1){h=v[Se(e+8|0)>>2];if(!Pb(h,f)){break k}d=Ek(x[d>>1],x[h>>1])?h:d;continue}}kb=e+16|0;d=x[d>>1];v[23540]=0;n=a+484344|0;p=d+1&65535;R(225,n|0,p|0);d=v[23540];v[23540]=0;if((d|0)!=1){d=w[g+83|0];v[g+24>>2]=v[a+480204>>2];v[g+20>>2]=v[a+480196>>2];o=d>>>0<4?4:5;q=c&1;k=a+480188|0;h=0;while(1){if((h|0)==(p|0)){if(!(c&2)){break g}d=1;c=a+480190|0;while(1){e=d&65535;if(e>>>0>x[c>>1]){break g}e=B(e,104)+a|0;f=Zc(g+8|0,u[e+484414>>1]&1?16:8,1,1,0);v[23540]=0;W(219,f|0,e+484380|0,b|0)|0;e=v[23540];v[23540]=0;if((e|0)!=1){d=d+1|0;continue}break}d=P()|0;O()|0;break h}l:{if(!q){break l}d=x[g+278>>1];e=v[b+8>>2];f=x[k>>1];i=v[b>>2];v[23540]=0;d=W(156,i|0,e|0,B(f,B(Ib(d),o))|0)|0;e=v[23540];v[23540]=0;m:{n:{if((e|0)==1){break n}if(!d){break l}d=x[g+278>>1];v[23540]=0;d=W(226,n|0,h&65535,Ib(d)|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break n}if(!d){break l}d=x[k>>1];t[g+19|0]=0;e=de(g+8|0,0,g+19|0);v[23540]=0;i=W(363,g+32|0,d|0,e|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break m}e=0;o:while(1){if(Ib(x[g+278>>1])>>>0<=e>>>0){od(i);break l}d=0;f=_b(v[n>>2],h);r=Cf(v[f>>2],v[v[f+48>>2]+12>>2],e);while(1){if(x[k>>1]<=d>>>0){e=e+1|0;continue o}t[g+12|0]=0;v[g+8>>2]=0;v[23540]=0;U(364,b|0,g+8|0,o|0);f=v[23540];v[23540]=0;p:{if((f|0)==1){break p}l=B(d,6)+r|0;f=w[g+8|0];if((f-24&255)>>>0<=59){f=f+13|0;t[l|0]=f;s=cc(v[i>>2],d),y=f,t[s|0]=y}m=w[g+9|0];q:{if(!m){f=cc(v[i>>2],d);break q}t[l+1|0]=m;f=cc(v[i>>2],d);t[f+1|0]=m}m=w[f+1|0];f=w[f|0];v[23540]=0;Da(365,a|0,l|0,w[g+10|0],w[g+11|0],0-w[g+83|0]|0,f|0,m|0,g+24|0,g+20|0);f=v[23540];v[23540]=0;if((f|0)==1){break p}if(w[g+12|0]){t[l+2|0]=1;t[l+4|0]=w[g+12|0]+1>>>2}d=d+1|0;continue}break}break}d=P()|0;O()|0;od(i);break h}d=P()|0;O()|0;break h}d=P()|0;O()|0;break h}h=h+1|0;continue}}d=P()|0;O()|0}Bb(j);break c}Bb(j);break b}d=e|2}u[f>>1]=d;if((n|0)==2){u[f>>1]=d|1;v[i>>2]=k>>>1;v[m>>2]=j>>>1;v[p>>2]=q>>>1}s=h+484410|0,y=Hj(b),u[s>>1]=y;d=gB(b);if(d){zl(i,+(d|0)/96)}t[h+484417|0]=d<<4;l=l+1|0;d=x[o>>1];continue}}d=P()|0;O()|0;dc(g+32|0)}T(d|0);L()}d=1}kb=g+288|0;return d|0}function Bea(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,y=0,z=0,A=0;i=kb-208|0;kb=i;zc(b);a:{if(!mB(b,i+160|0)){break a}if(!$P(i+160|0)){break a}b:{if(!c){break b}if(!Qb(v[b>>2],v[b+8>>2],Ec(_P(w[i+207|0]),nb))){break a}Cd(a,128);d=i+144|0;Ne(d,2,i+175|0);h=i+72|0;Fc(h,d);Bc(a+1298308|0,h);zb(h);e=yc(h,8482);Jb(a+1298344|0,e);Ab(e);e=yc(h,6059);Jb(a+1298356|0,e);Ab(e);e=yc(d,17574);v[23540]=0;U(724,h|0,e|0,v[(w[i+174|0]<<2)+26924>>2]);h=v[23540];v[23540]=0;c:{if((h|0)!=1){h=i+72|0;Jb(a+1298368|0,h);Ab(h);Ab(e);v[a+480208>>2]=12;v[a+1298404>>2]=5;EB(a+1298332|0,b,w[i+207|0]<<5,32,0);l=a+480190|0;d=Me(b);u[l>>1]=d;h=1;while(1){j=h&65535;if(j>>>0>(d&65535)>>>0){uo(Wb(v[a+484360>>2],w[a+484376|0]),b,256,255,254);h=0;d=Me(b);if(d>>>0>=127){break a}g=a+480188|0;u[g>>1]=d+1;e=Me(b);while(1)if(x[g>>1]<=h>>>0){o=a+484344|0;q=e+1|0;xg(o,q);d=0;while(1){d:{g=d&65535;if(g>>>0>e>>>0){r=a+480188|0;e:while(1){y=s&65535;h=x[r>>1];if(y>>>0>=h>>>0){e=io(i+8|0);t[e+16|0]=0;u[e+14>>1]=0;u[e+12>>1]=h;v[23540]=0;R(726,e|0,h|0);h=v[23540];v[23540]=0;if((h|0)==1){a=P()|0;O()|0;We(e);T(a|0);L()}v[23540]=0;U(725,i+32|0,o|0,e|0);d=v[23540];v[23540]=0;h=1;if((d|0)==1){break d}We(i+32|0);We(e);if(!(c&2)){break a}c=a+480190|0;while(1){d=h&65535;if(d>>>0>x[c>>1]){break b}d=B(d,104)+a|0;wg(Zc(i+72|0,u[d+484414>>1]&1?16:8,1,0,0),d+484380|0,b);h=h+1|0;continue}}n=0;e=ug(i+72|0);f:while(1){g:{if((n|0)!=(q|0)){if(Qb(v[b>>2],v[b+8>>2],5)){break g}}s=s+1|0;continue e}d=0;h=_b(v[o>>2],n);h=jd(v[h>>2],v[v[h+48>>2]+12>>2],0,y);while(1){h:{i:{if(d>>>0>63){break i}l=w[i+174|0];g=kb-32|0;kb=g;p=1;f=Me(b);if((f|0)==252){p=Me(b);f=Me(b)}t[e|0]=(f-1&255)>>>0<60?f+36|0:0;f=g+24|0;Um(f,b);k=Oc(f);j=Te(f);f=Li(f);t[e+1|0]=w[g+24|0];m=g+16|0;YP(m,w[k|0]&15,w[j|0],l);j=Oc(m);m=g+8|0;YP(m,w[k|0]>>>4|0,w[f|0],l);l=Oc(m);f=w[g+16|0];m=(f|0)!=10;k=w[g+8|0];j:{if(!(m|(k|0)!=10)){j=w[j|0];f=w[l|0];t[e+3|0]=10;j=j|f<<8;t[e+5|0]=j>>>6;if(j>>>0<16384){break j}t[e+2|0]=15;t[e+4|0]=f>>>6;break j}k:{l:{m:{n:{o:{if(!m){k=w[j|0];m=k<<2;z=j,A=Jl(m),t[z|0]=A;if(k>>>0<64){break o}f=w[g+8|0];if(Ji(f)>>>0>=Mz(10)>>>0){break n}t[e+5|0]=m;t[e+2|0]=15;t[e+3|0]=10;t[e+4|0]=k>>>6;break j}if((k|0)==10){f=w[l|0];k=f<<2;z=l,A=Jl(k),t[z|0]=A;if(f>>>0<64){break o}if(Ji(w[g+16|0])>>>0>=Mz(10)>>>0){break o}t[e+5|0]=k;t[e+2|0]=15;t[e+3|0]=10;t[e+4|0]=f>>>6;break j}if((f|0)!=(k|0)){break o}t[g+8|0]=0;break m}f=w[g+8|0]}if((f|0)==13){break l}if(f){break k}f=w[g+16|0]}if((f|0)==13){break k}}Dh(g+16|0,g+8|0);Dh(j,l)}Tu(g+8|0,l,g+16|0,j);Co(g,e,w[g+16|0],w[j|0],w[g+8|0],w[l|0])}kb=g+32|0;f=d+p|0;d=f>>>0>64?64-d|0:p;if(!d){break i}while(1){if(!d){break h}g=w[e|0]|w[e+1|0]<<8|(w[e+2|0]<<16|w[e+3|0]<<24);t[h|0]=g;t[h+1|0]=g>>>8;t[h+2|0]=g>>>16;t[h+3|0]=g>>>24;g=w[e+4|0]|w[e+5|0]<<8;t[h+4|0]=g;t[h+5|0]=g>>>8;d=d-1|0;h=B(x[r>>1],6)+h|0;continue}}n=n+1|0;continue f}d=f>>>0<64?f:64;continue}}}}d=d+1|0;h=0;if(ph(o,g,64)){continue}break a}break}d=P()|0;O()|0;We(e);break c}else{d=(h<<5)+a|0;df(d+480280|0);d=d+480284|0;p:{if(w[i+174|0]>=51){f=(Me(b)<<4|8)&248;break p}f=h&1?192:64}u[d>>1]=f;h=h+1|0;continue}}else{q:{if(w[i+174|0]>=52){d=i+72|0;if(!MU(b,d)){HB(d)}break q}e=kb-32|0;kb=e;v[e+28>>2]=64;v[e+8>>2]=66;f=v[b>>2];g=v[b+8>>2];d=v[Kb(e+28|0,e+8|0)>>2];if(!Qb(f,g,d)){d=cf(b)}f=e+8|0;n=i+72|0;Eu(f,n);g=hc(e+16|0,v[e+8>>2],d);nc(e,v[b>>2],v[b+8>>2],v[g>>2],v[g+4>>2]);Eu(f,n);Ub(v[e+8>>2]+d|0,0,66-d|0);$b(b,v[e+28>>2]);kb=e+32|0;u[i+136>>1]=x[i+134>>1];u[i+134>>1]=8363}g=kb-32|0;kb=g;e=(B(j,104)+a|0)+484380|0;nd(e,0);vo(e);d=i+72|0;uk(g,2,d+32|0);f=g+16|0;Fc(f,g);Be(e+43|0,f);zb(f);f=w[d+56|0]|w[d+57|0]<<8|(w[d+58|0]<<16|w[d+59|0]<<24);n=w[d+52|0]|w[d+53|0]<<8|(w[d+54|0]<<16|w[d+55|0]<<24);r:{if(f>>>0<=n>>>0){break r}v[e>>2]=f-n;v[e+12>>2]=w[d+44|0]|w[d+45|0]<<8|(w[d+46|0]<<16|w[d+47|0]<<24);v[g+16>>2]=w[d+48|0]|w[d+49|0]<<8|(w[d+50|0]<<16|w[d+51|0]<<24);z=e,A=v[Kb(g+16|0,e)>>2],v[z+16>>2]=A;u[e+30>>1]=w[d+60|0];v[e+24>>2]=w[d+62|0]|w[d+63|0]<<8;f=w[d+64|0]|w[d+65|0]<<8;if(f){zl(e,+(f<<16>>16)/393216)}f=w[d+61|0];if(f&8){u[e+34>>1]=x[e+34>>1]|8;f=w[d+61|0]}if(f&16){u[e+34>>1]=x[e+34>>1]|16;f=w[d+61|0]}if(!(f&4)){break r}u[e+34>>1]=x[e+34>>1]|1;v[e+12>>2]=v[e+12>>2]>>>1;v[e+16>>2]=v[e+16>>2]>>>1}kb=g+32|0;e=i+56|0;Ne(e,2,d);d=i+144|0;Fc(d,e);Dc(((j<<5)+a|0)+946304|0,d);h=h+1|0;zb(d);d=x[l>>1];continue}}}d=P()|0;O()|0;Ab(e)}T(d|0);L()}h=1}kb=i+208|0;return h|0}function Nea(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=kb-144|0;kb=d;zc(c);a:{b:{c:{d:{if(!wo(c,d+128|0)){break d}if(Sb(d+128|0,13838,4)){break d}g=d+136|0;e:{if(!Sb(g,13491,4)){break e}if(!Sb(g,13549,4)){break e}if(Sb(g,14273,4)){break d}}e=kb-32|0;kb=e;l=Tb(d+112|0);f:{g:{h:{i:{j:{while(1){k=v[c+8>>2];h=v[c>>2];v[23540]=0;k=W(156,h|0,k|0,8)|0;h=v[23540];v[23540]=0;if((h|0)==1){break h}if(!k){break i}v[23540]=0;R(791,e|0,c|0);k=v[23540];v[23540]=0;if((k|0)!=1){v[23540]=0;R(792,l|0,e|0);k=v[23540];v[23540]=0;if((k|0)==1){break j}Bd(e);continue}break}a=P()|0;O()|0;break g}a=P()|0;O()|0;Bd(e);break g}kb=e+32|0;break f}a=P()|0;O()|0}Zd(l);T(a|0);L()}v[23540]=0;k=S(174,d+88|0)|0;c=v[23540];v[23540]=0;k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{if((c|0)!=1){l=Zc(d+80|0,8,1,1,0);if(Sb(g,14273,4)){break t}v[23540]=0;U(711,d+56|0,d+112|0,1296581714);c=v[23540];v[23540]=0;if((c|0)==1){break q}v[23540]=0;U(711,d+32|0,d+112|0,1296318804);c=v[23540];v[23540]=0;if((c|0)==1){break c}c=d+32|0;e=hd(k,c);Bb(c);c=0;v[23540]=0;g=S(712,d+56|0)|0;i=v[23540];v[23540]=0;f=1;if((i|0)==1){break c}i=0;if(!g){break u}e=v[e>>2];v[23540]=0;e=S(178,e|0)|0;i=v[23540];v[23540]=0;if((i|0)==1){break c}i=0;if(!e){break u}v[23540]=0;i=S(279,d+56|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break c}v[23540]=0;g=S(271,d+56|0)|0;c=v[23540];v[23540]=0;w:{if((c|0)==1){break w}v[23540]=0;Q(188,d+56|0,2)|0;c=v[23540];v[23540]=0;if((c|0)==1){break w}v[23540]=0;c=S(279,d+56|0)|0;e=v[23540];v[23540]=0;if((e|0)!=1){break v}}break c}f=P()|0;O()|0;break a}v[23540]=0;R(627,d+32|0,d+56|0);e=v[23540];v[23540]=0;if((e|0)==1){break c}e=VT(d+32|0);j=Ib(x[d+32>>1]);if(!j){break u}c=(c>>>0)/(j>>>0)|0;f=d+32|0;j=jc(f);h=Te(f);f=1;j=Ib(w[j|0]|w[j+1|0]<<8);if((j|0)!=(Ib(w[h|0]|w[h+1|0]<<8)+1|0)){break u}if((j|0)==2){Mo(l,2)}x:{if((g|0)!=16){if((g|0)!=8){break u}y:{switch(Ib(w[e|0]|w[e+1|0]<<8)|0){case 0:dg(l,1);break x;case 2:dg(l,17);break x;case 3:break y;default:break u}}dg(l,16);break x}if(Ib(w[e|0]|w[e+1|0]<<8)){break u}xd(l,16)}f=0}Bb(d+56|0);j=0;if(!f){break s}f=0;break k}v[23540]=0;U(711,d+56|0,d+112|0,1447576658);c=v[23540];v[23540]=0;z:{A:{if((c|0)!=1){v[23540]=0;U(711,d+32|0,d+112|0,1128808782);c=v[23540];v[23540]=0;if((c|0)==1){break A}v[23540]=0;U(711,d+8|0,d+112|0,1112491097);c=v[23540];v[23540]=0;if((c|0)==1){break m}c=d+8|0;h=hd(k,c);Bb(c);c=v[h>>2];v[23540]=0;m=S(178,c|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break z}c=0;e=0;B:{if(!m){break B}v[23540]=0;m=S(178,v[d+56>>2])|0;c=v[23540];v[23540]=0;if((c|0)==1){break z}c=0;e=0;if(!m){break B}v[23540]=0;m=Q(713,d+56|0,d+8|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break z}c=0;e=0;if(!m){break B}c=Sb(g,13491,4);v[23540]=0;e=S(279,d+32|0)|0;i=v[23540];v[23540]=0;if((i|0)==1){break m}if(c){p=l,q=v[Zc(d,16,1,0,0)>>2],v[p>>2]=q}if((e|0)==6){Mo(l,3)}i=v[h>>2];v[23540]=0;g=v[d+24>>2];h=x[d+20>>1];n=v[d+12>>2];m=v[d+8>>2];i=S(160,i|0)|0;j=v[23540];v[23540]=0;o=1;if((j|0)==1){break m}e=B((e|0)==6?2:1,c?2:1);i=(i>>>0)/(e>>>0)|0;j=bc(g);c=Ib(h);n=(bc(n)>>>0)/(e>>>0)|0;e=(bc(m)>>>0)/(e>>>0)|0}Bb(d+32|0);Bb(d+56|0);if(o){break r}break k}f=P()|0;O()|0;break b}f=P()|0;O()|0;break l}break m}e=0}pt(a,b);v[23540]=0;f=B(b,104)+a|0;g=f+484380|0;R(277,g|0,0);h=v[23540];v[23540]=0;if((h|0)==1){break p}v[g>>2]=i;h=e+n|0;v[f+484388>>2]=h;v[f+484384>>2]=e;if(!(h>>>0<=e+4>>>0|h>>>0>i>>>0)){e=(B(b,104)+a|0)+484414|0;u[e>>1]=x[e>>1]|2}e=B(b,104)+a|0;v[e+484404>>2]=c?c:22050;c=j>>>8|0;u[e+484410>>1]=(j&16776960)>>>0>65536?256:c&65535?c:256;Fz(g,v[a+480180>>2]);v[23540]=0;U(711,d+56|0,d+112|0,1312902469);c=v[23540];v[23540]=0;if((c|0)==1){break o}v[23540]=0;c=S(178,v[d+56>>2])|0;e=v[23540];v[23540]=0;if((e|0)==1){break n}C:{D:{if(c){v[23540]=0;c=S(160,v[d+56>>2])|0;e=v[23540];v[23540]=0;if((e|0)==1){break n}v[23540]=0;U(325,d+56|0,((b<<5)+a|0)+946304|0,c|0);b=v[23540];v[23540]=0;if((b|0)!=1){break D}break n}v[23540]=0;c=Q(55,d+32|0,21688)|0;e=v[23540];v[23540]=0;if((e|0)==1){break C}Dc(((b<<5)+a|0)+946304|0,c);zb(c)}v[23540]=0;W(219,l|0,g|0,k|0)|0;b=v[23540];v[23540]=0;f=1;if((b|0)==1){break n}uj(g,a);Bb(d+56|0);break k}break n}f=P()|0;O()|0;break b}f=P()|0;O()|0;break b}f=P()|0;O()|0;break b}f=P()|0;O()|0;Bb(d+56|0);break b}f=P()|0;O()|0;Bb(d+32|0)}Bb(d+56|0);break b}Bb(k);Zd(d+112|0)}kb=d+144|0;return f|0}f=P()|0;O()|0;Bb(d+56|0)}Bb(k)}Zd(d+112|0);T(f|0);L()}function Jd(a,b,c,d,e,f,g,h,i){var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;k=kb-96|0;kb=k;t=h;u=i&65535;m=(e^i)&-2147483648;l=e&65535;p=l;A=l;K=i>>>16&32767;L=e>>>16&32767;a:{b:{if(K-32767>>>0>4294934529&L-32767>>>0>=4294934530){break b}l=e&2147483647;j=d;if(!(!d&(l|0)==2147418112?!(b|c):l>>>0<2147418112)){o=d;m=e|32768;break a}e=i&2147483647;if(!(!h&(e|0)==2147418112?!(f|g):e>>>0<2147418112)){o=h;m=i|32768;b=f;c=g;break a}if(!(b|j|(l^2147418112|c))){if(!(f|h|(e|g))){m=2147450880;b=0;c=0;break a}m=m|2147418112;b=0;c=0;break a}if(!(f|h|(e^2147418112|g))){d=b|j;e=c|l;b=0;c=0;if(!(d|e)){m=2147450880;break a}m=m|2147418112;break a}if(!(b|j|(c|l))){b=0;c=0;break a}if(!(f|h|(e|g))){b=0;c=0;break a}if((l|0)==65535|l>>>0<65535){j=b;h=!(d|p);i=h<<6;l=E(h?b:d)+32|0;b=E(h?c:p);b=i+((b|0)==32?l:b)|0;Kf(k+80|0,j,c,d,p,b-15|0);s=16-b|0;d=v[k+88>>2];A=v[k+92>>2];c=v[k+84>>2];b=v[k+80>>2]}if(e>>>0>65535){break b}e=!(t|u);h=e<<6;i=E(e?f:t)+32|0;e=E(e?g:u);e=h+((e|0)==32?i:e)|0;Kf(k- -64|0,f,g,t,u,e-15|0);s=(s-e|0)+16|0;t=v[k+72>>2];u=v[k+76>>2];f=v[k+64>>2];g=v[k+68>>2]}e=f;j=g<<15|e>>>17;h=e<<15;e=j;p=h&-32768;q=c;B=Jka(p,0,c,0);c=nb;x=c;C=e;i=0;j=Jka(e,0,b,i);e=j+B|0;h=nb+c|0;h=e>>>0<j>>>0?h+1|0:h;c=e;j=e;n=Jka(b,i,p,i);l=0+n|0;e=nb+e|0;e=l>>>0<n>>>0?e+1|0:e;y=l;n=l;l=e;D=(j|0)==(e|0)&r>>>0>n>>>0|e>>>0<j>>>0;r=d;M=Jka(p,i,d,0);H=nb;e=Jka(q,i,C,i);d=e+M|0;j=nb+H|0;n=d;d=d>>>0<e>>>0?j+1|0:j;e=t;j=u<<15|e>>>17;z=e<<15|g>>>17;g=j;j=Jka(z,0,b,i);e=j+n|0;f=nb+d|0;I=e;f=e>>>0<j>>>0?f+1|0:f;u=f;e=f;f=(h|0)==(x|0)&c>>>0<B>>>0|h>>>0<x>>>0;c=h+I|0;f=e+f|0;B=c;f=c>>>0<h>>>0?f+1|0:f;t=f;c=f;F=A|65536;A=w;N=Jka(p,i,F,w);J=nb;h=Jka(r,o,C,i);f=h+N|0;e=nb+J|0;O=f;e=f>>>0<h>>>0?e+1|0:e;w=e;G=g|-2147483648;x=0;g=Jka(G,x,b,i);b=g+f|0;f=nb+e|0;f=b>>>0<g>>>0?f+1|0:f;P=b;e=Jka(z,o,q,i);b=b+e|0;p=f;j=f+nb|0;Q=b;g=b>>>0<e>>>0?j+1|0:j;f=0;b=f+B|0;e=c+Q|0;e=b>>>0<f>>>0?e+1|0:e;R=b;c=b;b=b+D|0;D=e;f=b>>>0<c>>>0?e+1|0:e;c=f;s=((L+K|0)+s|0)-16383|0;j=Jka(G,x,q,i);h=nb;i=Jka(F,A,C,i);e=i+j|0;f=nb+h|0;f=e>>>0<i>>>0?f+1|0:f;i=(f|0)==(h|0)&e>>>0<j>>>0|f>>>0<h>>>0;h=e;q=i;i=Jka(z,o,r,o);e=i+e|0;j=nb+f|0;j=e>>>0<i>>>0?j+1|0:j;i=(f|0)==(j|0)&e>>>0<h>>>0|f>>>0>j>>>0;f=q+i|0;h=0;h=f>>>0<i>>>0?1:h;q=Jka(G,x,F,A);i=q+f|0;f=nb+h|0;f=i>>>0<q>>>0?f+1|0:f;q=e;h=j;C=i;e=(d|0)==(u|0)&n>>>0>I>>>0|d>>>0>u>>>0;d=e+((d|0)==(H|0)&n>>>0<M>>>0|d>>>0<H>>>0)|0;j=0;j=d>>>0<e>>>0?1:j;i=d;d=q+d|0;e=h+j|0;e=d>>>0<i>>>0?e+1|0:e;n=d;i=e;e=(e|0)==(h|0)&d>>>0<q>>>0|e>>>0<h>>>0;d=C+e|0;h=d>>>0<e>>>0?f+1|0:f;q=d;j=Jka(z,o,F,A);e=nb;r=Jka(G,x,r,o);d=r+j|0;f=nb+e|0;f=d>>>0<r>>>0?f+1|0:f;r=d;d=f;f=(e|0)==(f|0)&j>>>0>r>>>0|e>>>0>f>>>0;z=d+q|0;e=f+h|0;e=d>>>0>z>>>0?e+1|0:e;h=0;d=h+n|0;f=i+r|0;f=d>>>0<h>>>0?f+1|0:f;h=f;j=(i|0)==(f|0)&d>>>0<n>>>0|f>>>0<i>>>0;i=j+z|0;n=i;i=i>>>0<j>>>0?e+1|0:e;r=d;e=d;d=h;j=(p|0)==(w|0)&O>>>0>P>>>0|p>>>0<w>>>0;f=j+((w|0)==(J|0)&O>>>0<N>>>0|w>>>0<J>>>0)|0;h=0;j=f+((g|0)==(p|0)&P>>>0>Q>>>0|g>>>0<p>>>0)|0;f=g+e|0;e=d+j|0;e=f>>>0<g>>>0?e+1|0:e;g=f;h=(d|0)==(e|0)&f>>>0<r>>>0|d>>>0>e>>>0;d=h+n|0;f=i;f=d>>>0<h>>>0?f+1|0:f;h=e;n=d;i=(t|0)==(D|0)&B>>>0>R>>>0|t>>>0>D>>>0;d=i+((t|0)==(u|0)&B>>>0<I>>>0|t>>>0<u>>>0)|0;j=0;j=d>>>0<i>>>0?1:j;i=d;d=d+g|0;e=e+j|0;e=d>>>0<i>>>0?e+1|0:e;h=(e|0)==(h|0)&d>>>0<g>>>0|e>>>0<h>>>0;g=n+h|0;f=g>>>0<h>>>0?f+1|0:f;h=g;i=f;c:{if(f&65536){s=s+1|0;break c}w=l>>>31|0;f=i<<1|h>>>31;h=g<<1|e>>>31;i=f;f=e<<1|d>>>31;d=d<<1|c>>>31;e=f;g=y;f=l<<1|g>>>31;y=g<<1;l=f;f=c<<1|b>>>31;b=b<<1|w;c=f}if((s|0)>=32767){m=m|2147418112;b=0;c=0;break a}d:{if((s|0)<=0){f=1-s|0;if(f>>>0>=128){b=0;c=0;break a}g=s+127|0;Kf(k+48|0,y,l,b,c,g);Kf(k+32|0,d,e,h,i,g);Em(k+16|0,y,l,b,c,f);Em(k,d,e,h,i,f);y=v[k+32>>2]|v[k+16>>2]|(v[k+48>>2]|v[k+56>>2]|(v[k+52>>2]|v[k+60>>2]))!=0;l=v[k+36>>2]|v[k+20>>2];b=v[k+40>>2]|v[k+24>>2];c=v[k+44>>2]|v[k+28>>2];d=v[k>>2];e=v[k+4>>2];f=v[k+8>>2];g=v[k+12>>2];break d}f=h;g=i&65535|s<<16}o=f|o;m=g|m;if(!(!b&(c|0)==-2147483648?!(l|y):(c|0)>0|(c|0)>=0)){b=d+1|0;j=b?e:e+1|0;c=j;f=(e|0)==(j|0)&b>>>0<d>>>0|e>>>0>j>>>0;d=f+o|0;e=m;o=d;m=d>>>0<f>>>0?e+1|0:e;break a}if(b|y|(c^-2147483648|l)){b=d;c=e;break a}j=m;c=d&1;b=c+d|0;f=b>>>0<c>>>0?e+1|0:e;c=f;e=(e|0)==(f|0)&b>>>0<d>>>0|e>>>0>f>>>0;d=e+o|0;o=d;m=d>>>0<e>>>0?j+1|0:j}v[a>>2]=b;v[a+4>>2]=c;v[a+8>>2]=o;v[a+12>>2]=m;kb=k+96|0}function Yfa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=kb-144|0;kb=g;zc(b);a:{b:{c:{d:{e:{if(!CR(b,14159)){break e}k=Tb(g+128|0);j=Tb(g+112|0);v[23540]=0;v[g+104>>2]=0;v[g+108>>2]=0;R(246,a|0,32768);d=v[23540];v[23540]=0;if((d|0)==1){break b}v[23540]=0;d=Q(1,g+88|0,8198)|0;i=v[23540];v[23540]=0;if((i|0)==1){break c}Jb(a+1298344|0,d);Ab(d);v[23540]=0;d=Q(1,g+72|0,6063)|0;i=v[23540];v[23540]=0;if((i|0)==1){break d}Jb(a+1298356|0,d);Ab(d);v[a+1298404>>2]=14;m=a+484376|0;i=a+480280|0;while(1){d=v[b+8>>2];f=v[b>>2];v[23540]=0;d=W(156,f|0,d|0,8)|0;f=v[23540];v[23540]=0;f:{g:{h:{if((f|0)!=1){i:{j:{k:{l:{m:{n:{if(!d){break n}v[23540]=0;d=Q(626,b|0,g- -64|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break m}if(!d){break n}d=v[g+68>>2];v[23540]=0;U(190,g+16|0,b|0,bc(d)|0);d=v[23540];v[23540]=0;if((d|0)==1){break l}d=g+16|0;f=kc(g+40|0,d);Bb(d);d=v[f>>2];v[23540]=0;d=S(178,d|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break j}if(d){break k}Bb(f)}if(x[a+480188>>1]){break i}i=0;break g}a=P()|0;O()|0;break a}a=P()|0;O()|0;break a}o:{p:{q:{r:{s:{t:{u:{d=bc(v[g+64>>2]);if((d|0)!=1397769541){if((d|0)==1346458708){break t}if((d|0)==1346522948){break s}if((d|0)==1347175758){break u}if((d|0)!=1396788560){if((d|0)==1396854596){break r}if((d|0)==1397507406){break f}if((d|0)!=1129140036){break p}if(x[a+480188>>1]){break f}d=v[f>>2];v[23540]=0;d=S(160,d|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break j}if(d>>>0<8){break f}d=0;v[23540]=0;R(627,g+16|0,f|0);e=v[23540];v[23540]=0;if((e|0)==1){break j}while(1)if((d|0)==4){if(c){break f}i=1;break o}else{e=x[a+480188>>1];h=cc(g+16|0,d);v:{if(!Ib(w[h|0]|w[h+1|0]<<8)){h=(d&3)-1|0;break v}h=g+104|0;o=Lb(h,e),p=1,t[o|0]=p;o=Lb(h,x[a+480188>>1]+1|0),p=255,t[o|0]=p;df(i+(x[a+480188>>1]<<5)|0);h=x[a+480188>>1];e=h+1|0;u[a+480188>>1]=e;l=i+(h<<5)|0;h=(d&3)-1|0;u[l+4>>1]=h>>>0<2?192:64}df(i+((e&65535)<<5)|0);e=x[a+480188>>1];u[a+480188>>1]=e+1;u[(i+(e<<5)|0)+4>>1]=h>>>0<2?192:64;d=d+1|0;continue}}if(x[a+480190>>1]){break f}v[23540]=0;R(628,f|0,a|0);d=v[23540];v[23540]=0;if((d|0)!=1){break f}break j}d=v[f>>2];v[23540]=0;d=S(160,d|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break j}if(d>>>0<2){break f}v[23540]=0;d=S(271,f|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break j}o=a,p=Ed(d,1,255),v[o+480196>>2]=p;break f}d=v[f>>2];v[23540]=0;d=S(160,d|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break j}if(d>>>0<2){break f}v[23540]=0;n=S(271,f|0)|0;d=v[23540];v[23540]=0;if((d|0)!=1){break f}break j}d=w[m|0];e=v[a+484360>>2];h=v[f>>2];v[23540]=0;h=S(160,h|0)|0;l=v[23540];v[23540]=0;if((l|0)==1){break j}v[23540]=0;da(340,Wb(e,d)|0,f|0,h|0,255,254);d=v[23540];v[23540]=0;if((d|0)==1){break j}break f}d=k;if(Bf(v[d>>2],v[d+4>>2])>>>0>=256){break f}break q}if(Bf(v[j>>2],v[j+4>>2])>>>0>3998){break f}d=v[f>>2];v[23540]=0;e=S(160,d|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break j}d=j;if(!e){break f}}v[23540]=0;R(629,d|0,f|0);d=v[23540];v[23540]=0;if((d|0)!=1){break f}break j}if(!(d&-2139062144)){break f}i=0}Bb(f);break g}a=P()|0;O()|0;Bb(f);break a}v[a+480200>>2]=256;v[a+480204>>2]=125e4;v[a+480260>>2]=452;v[a+480264>>2]=3424;v[a+480228>>2]=48;v[a+480232>>2]=48;b=w[a+484376|0];d=v[a+484360>>2];v[23540]=0;R(324,Wb(d,b)|0,n&65535);b=v[23540];v[23540]=0;if((b|0)==1){break b}w:{if(!(c&1)){break w}b=v[k+4>>2];i=v[k>>2];d=0;v[23540]=0;R(225,a+484344|0,Bf(i,b)&65535);b=v[23540];v[23540]=0;if((b|0)==1){break b}while(1){f=v[k>>2];b=d&65535;if(Bf(f,v[k+4>>2])>>>0<=b>>>0){break w}v[23540]=0;i=v[g+108>>2];e=v[g+104>>2];v[g+8>>2]=e;v[g+12>>2]=i;v[g>>2]=e;v[g+4>>2]=i;X(630,Ng(f,b)|0,b|0,a|0,g|0);b=v[23540];v[23540]=0;if((b|0)!=1){d=d+1|0;continue}break}a=P()|0;O()|0;break a}f=c&2;i=1;d=1;b=0;while(1){if(x[a+480190>>1]<=d>>>0){break g}if(!f|Bf(v[j>>2],v[j+4>>2])>>>0<=b>>>0){break g}c=(B(d,104)+a|0)+484380|0;No(c);x:{if(v[c>>2]){e=v[Ng(v[j>>2],b)>>2];v[23540]=0;e=S(160,e|0)|0;h=v[23540];v[23540]=0;if((h|0)==1){break h}xc(c,e);e=Zc(g+40|0,8,1,1,0);h=v[j>>2];v[23540]=0;W(219,e|0,c|0,Ng(h,b)|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break x}b=b+1|0}d=d+1|0;continue}break}a=P()|0;O()|0;break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;break a}Vc(j);Vc(k);break e}Bb(f);continue}}kb=g+144|0;return i|0}a=P()|0;O()|0;break a}a=P()|0;O()|0;break a}a=P()|0;O()|0}Vc(j);Vc(k);T(a|0);L()}function jN(a,b,c,d,e){var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=kb-16|0;kb=h;a:{if(!$c(d&255)){break a}m=a+1074376|0;j=(m+B(b,872)|0)+616|0;b:{g=x[a+480192>>1];if(!(e?1:!(v[a+480180>>2]&17825824)|!g)){break b}if(oj(v[j+656>>2])){break b}c=B(b,872)+a|0;d=c+1075068|0;if(!v[d>>2]){break a}c=v[c+1075080>>2];if(c&1024){break a}e=B(b,872)+a|0;g=e+1075012|0;e=e+1075016|0;if(!(v[g>>2]|v[e>>2])){break a}c:{if(!(c&512)){break c}c=v[a+1298300>>2];if(!zd(c)){break c}rj(c,b,0);break a}c=Iy(a,b);if((c|0)==65535){break a}i=B(c,872);c=a+1074992|0;a=i+c|0;Vp(a,j);t[a+831|0]=0;t[a+805|0]=0;u[a+786>>1]=b+1;v[a+88>>2]=v[a+88>>2]&-918529;ko(a+788|0);v[a+696>>2]=0;v[a+88>>2]=v[a+88>>2]|2101248;v[d>>2]=0;v[j>>2]=0;v[j+4>>2]=0;a=c+B(b,872)|0;v[a+92>>2]=0;v[a+96>>2]=0;v[g>>2]=0;v[e>>2]=0;break a}e=B(b,872)+a|0;k=v[e+1075096>>2];c=c>>>0>g>>>0?0:c;g=v[(c?((c<<2)+a|0)+900380|0:e+1075648|0)>>2];d:{if(!g){break d}l=d-1|0;c=x[cc(g+236|0,l)>>1];f=a+1074312|0;Db(h+8|0,f,104);e:{if(Cb(v[v[h+8>>2]>>2],v[h+12>>2])){Db(h,f,34);if(Cb(v[v[h>>2]>>2],v[h+4>>2])){break e}}d=w[Lb(g+108|0,l)|0]}if((c-1&65535)>>>0<=3998){k=(B(c,104)+a|0)+484380|0;break d}Db(h+8|0,f,43);if(!Cb(v[v[h+8>>2]>>2],v[h+12>>2])){break d}if(!vj(w[g+31|0])){break a}}if(w[e+1075081|0]&4){break a}o=b>>>0>256?b:256;l=a+1074312|0;p=b+1|0;q=a+480188|0;c=b;f:{while(1){if((c|0)==(o|0)){g:{e=0;c=0;if(!oj(v[j+656>>2])){break f}c=0;if(!$c(w[(B(b,872)+a|0)+1075789|0])){break f}d=Ml(a,m,b,2,1)-1|0;c=0;if((d&255)>>>0>249){break f}e=v[Md(a+906300|0,d)>>2];if(e){break g}e=0;c=0;break f}}else{h:{if((b|0)!=(c|0)&x[q>>1]>c>>>0){break h}e=B(c,872)+a|0;if(x[e+1075778>>1]!=(p|0)&(b|0)!=(c|0)){break h}n=e+1075648|0;f=v[n>>2];if(!f){break h}i:{j:{k:{l:{m:{n:{o:{switch(w[f+17|0]-1|0){case 0:if(!d){break h}i=w[e+1075789|0]==(d|0)&(f|0)==(g|0);if(!g){break n}if(i){break k}break h;case 1:if(!k|v[e+1075096>>2]!=(k|0)){break h}if((f|0)==(g|0)){break i}Db(h+8|0,l,104);if(!Cb(v[v[h+8>>2]>>2],v[h+12>>2])){break i}break h;case 3:break m;case 2:break o;default:break h}}if(g){break l}i=(f|0)==(g|0)}if(i){break i}break h}if(!g){break h}i=w[g+34|0];if(!i){break h}if((i|0)==w[f+34|0]){break j}break h}if((f|0)!=(g|0)){break h}}if(!w[g+34|0]){break i}}if(!w[e+1075789|0]|w[f+18|0]>2){break i}sm(a,c&65535,w[e+1075793|0]|256,0)}f=e+1074992|0;p:{q:{switch(w[v[n>>2]+18|0]){case 0:Wn(a,f);v[e+1075680>>2]=0;if(!(w[e+1075081|0]&2)){break p}f=v[a+1298300>>2];if(!zd(f)){break p}rj(f,c&65535,1);break p;case 1:Wn(a,f);if(!(w[e+1075081|0]&2)){break p}f=v[a+1298300>>2];if(!zd(f)){break p}jk(f,c&65535);break p;case 2:break q;default:break p}}i=e+1075080|0;f=v[i>>2];v[i>>2]=f|4096;if(!(f&512)){break p}if(!zd(v[a+1298300>>2])){break p}Db(h+8|0,l,105);if(Cb(v[v[h+8>>2]>>2],v[h+12>>2])){break p}jk(v[a+1298300>>2],c&65535)}if(v[e+1075680>>2]){break h}v[e+1075688>>2]=0;e=e+1075080|0;v[e>>2]=v[e>>2]|2101248}c=c+1|0;continue}break}c=ob[v[v[e>>2]+104>>2]](e,w[(B(b,872)+a|0)+1075793|0],b)|0}if(!(Ai(v[j+8>>2],v[j+12>>2])?1:c)){break a}g=Iy(a,b);if((g|0)==65535){break a}f=B(g,872)+a|0;d=f+1075080|0;k=f+1074992|0;r:{if(!(w[f+1075081|0]&2)){break r}i=v[a+1298300>>2];if(!zd(i)){break r}rj(i,g,1)}k=Vp(k,j);v[d>>2]=v[d>>2]&-917505;t[f+1075823|0]=0;i=x[a+480188>>1];t[f+1075797|0]=0;u[f+1075778>>1]=b>>>0<i>>>0?b+1|0:0;s:{if(!(c&(e|0)!=0)){break s}c=w[(B(b,872)+a|0)+1075790|0];if(c>>>0>3|(c|0)==1){break s}sm(a,b,255,0);t[(B(b,872)+a|0)+1075792|0]=0}t:{u:{switch(w[(B(b,872)+a|0)+1075790|0]){case 2:Wn(a,k);if(!(w[d+1|0]&2)){break t}c=v[a+1298300>>2];if(!zd(c)){break t}jk(c,b);Db(h+8|0,l,105);if(!Cb(v[v[h+8>>2]>>2],v[h+12>>2])){break t}uz(v[a+1298300>>2],b,g);break t;case 0:v[(B(g,872)+a|0)+1075688>>2]=0;c=v[d>>2];v[d>>2]=c|4096;if(!(c&512)){break t}c=v[a+1298300>>2];if(!zd(c)){break t}rj(c,b,1);break t;case 3:c=v[d>>2];v[d>>2]=c|4096;if(!(c&512)){break t}if(!zd(v[a+1298300>>2])){break t}Db(h+8|0,l,105);c=v[a+1298300>>2];if(Cb(v[v[h+8>>2]>>2],v[h+12>>2])){uz(c,b,g);break t}jk(c,b);break t;case 1:break u;default:break t}}if(!(w[d+1|0]&2)){break t}c=v[a+1298300>>2];if(!zd(c)){break t}uz(c,b,g)}if(!v[(B(g,872)+a|0)+1075680>>2]){v[(B(g,872)+a|0)+1075688>>2]=0;v[d>>2]=v[d>>2]|2101248}a=B(b,872)+a|0;v[a+1075068>>2]=0;v[j>>2]=0;v[j+4>>2]=0;a=a+1075084|0;v[a>>2]=0;v[a+4>>2]=0}kb=h+16|0}function gW(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;f=kb-112|0;kb=f;zc(b);a:{if(!Uq(b,11763)){break a}if(!Yu(b,f+96|0)){break a}if(!qC(w[f+97|0])){break a}if(!Qb(v[b>>2],v[b+8>>2],Ec(oC(f+96|0),nb))){break a}if(!$b(b,w[f+105|0]|w[f+106|0]<<8)){break a}b:{if(!c){break b}Cd(a,4096);v[a+480208>>2]=12;u[a+480188>>1]=(w[f+98|0]&31)+1;e=a+480190|0;u[e>>1]=w[f+99|0];oh(a,1);d=f+24|0;i=yc(d,8505);Jb(a+1298344|0,i);Ab(i);i=yc(d,7053);Jb(a+1298356|0,i);Ab(i);i=kb-16|0;kb=i;g=yc(i,4250);ad(f,g);Ab(g);kb=i+16|0;v[23540]=0;X(229,d|0,f|0,w[f+97|0],f+96|0);d=v[23540];v[23540]=0;c:{if((d|0)!=1){d=f+24|0;Jb(a+1298368|0,d);Ab(d);dc(f);v[a+1298404>>2]=5;d=w[f+99|0];i=f+80|0;v[i>>2]=0;v[i+4>>2]=0;ok(i+8|0,0);if(d){$q(i,d);$C(i,d,0)}d=1;d:{while(1){g=d&65535;if(g>>>0>x[e>>1]){v[23540]=0;Q(230,b|0,a+1298308|0)|0;g=v[23540];v[23540]=0;d=1;e:{if((g|0)==1){break e}g=a+480190|0;while(1){e=d&65535;if(e>>>0>x[g>>1]){d=0;g=a+480188|0;f:{while(1){if(x[g>>1]<=d>>>0){d=0;v[23540]=0;g=a+484344|0;R(225,g|0,x[f+100>>1]);e=v[23540];v[23540]=0;if((e|0)==1){break e}break f}e=(d<<5)+a|0;df(e+480280|0);v[23540]=0;R(231,b|0,e+480289|0);e=v[23540];v[23540]=0;if((e|0)!=1){d=d+1|0;continue}break}b=P()|0;O()|0;break d}g:{h:{i:{j:{while(1){if(x[f+100>>1]<=d>>>0){v[23540]=0;e=S(194,b|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break h}if(!e){break i}d=v[b+8>>2];g=v[b>>2];v[23540]=0;d=W(156,g|0,d|0,e|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break h}if(d){break j}break i}v[23540]=0;e=Q(232,b|0,f+24|0)|0;h=v[23540];v[23540]=0;k:{if((h|0)==1){break k}v[23540]=0;h=W(226,g|0,d&65535,64)|0;j=v[23540];v[23540]=0;if((j|0)==1){break k}if((e&h)==1){e=v[g>>2];v[23540]=0;R(233,_b(e,d)|0,f+24|0);e=v[23540];v[23540]=0;if((e|0)==1){break k}}d=d+1|0;continue}break}b=P()|0;O()|0;break d}g=Tb(f+24|0);v[23540]=0;U(234,b|0,g|0,e|0);d=v[23540];v[23540]=0;l:{if((d|0)!=1){d=Nb(f);v[23540]=0;R(46,d|0,e|0);e=v[23540];v[23540]=0;m:{if((e|0)==1){break m}k=f,l=Fb(v[g>>2]),v[k+48>>2]=l;h=Fb(v[g+4>>2]);while(1){n:{e=v[f+48>>2];if(!Pb(e,h)){v[23540]=0;X(235,f+48|0,5,6,d|0);e=v[23540];v[23540]=0;if((e|0)==1){break n}h=f+48|0;e=Bc(d,h);zb(h);h=Mc(e);j=Hb(e);v[23540]=0;da(236,a+1298332|0,h|0,j|0,76,0);h=v[23540];v[23540]=0;if((h|0)==1){break m}zb(e);ic(g);break i}o:{e=w[e|0];if(e&128){k=f,l=yh(d),v[k+64>>2]=l;j=v[kj(f+72|0,f- -64|0)>>2];v[23540]=0;X(237,d|0,j|0,e&127,32);e=v[23540];v[23540]=0;if((e|0)!=1){break o}break m}v[23540]=0;R(47,d|0,e<<24>>24);e=v[23540];v[23540]=0;if((e|0)!=1){break o}break m}Ke(f+48|0);continue}break}}b=P()|0;O()|0;zb(d);break l}b=P()|0;O()|0}ic(g);break d}d=w[a+484376|0];g=v[a+484360>>2];v[23540]=0;U(238,Wb(g,d)|0,b|0,x[f+102>>1]);d=v[23540];v[23540]=0;if((d|0)==1){break h}e=c&1;h=a+484348|0;d=0;while(1){p:{q:{if(x[f+100>>1]>d>>>0){g=v[b+8>>2];j=v[b>>2];v[23540]=0;g=W(156,j|0,g|0,4)|0;j=v[23540];v[23540]=0;if((j|0)==1){break p}if(g){break q}}if(!(c&2)){break g}g=a+480190|0;d=1;while(1){c=d&65535;if(c>>>0>x[g>>1]){break g}e=B(c,104)+a|0;h=x[e+484414>>1];Db(f+24|0,v[i>>2],c-1|0);c=Zc(f,h&1?16:8,1,0,Cb(v[v[f+24>>2]>>2],v[f+28>>2])?6:0);v[23540]=0;W(219,c|0,e+484380|0,b|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){d=d+1|0;continue}break}b=P()|0;O()|0;break d}v[23540]=0;g=S(157,b|0)|0;j=v[23540];v[23540]=0;r:{s:{if((j|0)!=1){v[23540]=0;U(190,f|0,b|0,g|0);g=v[23540];v[23540]=0;if((g|0)==1){break s}g=kc(f+24|0,f);Bb(f);if(!e){break r}j=v[a+484344>>2];if(!xe(j,v[h>>2],d&65535)){break r}v[23540]=0;U(239,_b(j,d)|0,0,g|0);j=v[23540];v[23540]=0;if((j|0)!=1){break r}b=P()|0;O()|0;Bb(g);break d}b=P()|0;O()|0;break d}b=P()|0;O()|0;break d}Bb(g);d=d+1|0;continue}break}b=P()|0;O()|0;break d}b=P()|0;O()|0;break d}We(i);break b}v[23540]=0;Q(240,b|0,((e<<5)+a|0)+946304|0)|0;e=v[23540];v[23540]=0;if((e|0)!=1){d=d+1|0;continue}break}b=P()|0;O()|0;break d}b=P()|0;O()|0;break d}v[23540]=0;R(241,b|0,f+24|0);h=v[23540];v[23540]=0;t:{if((h|0)==1){break t}v[23540]=0;R(242,f+24|0,(B(g,104)+a|0)+484380|0);h=v[23540];v[23540]=0;if((h|0)==1){break t}h=w[f+40|0];Db(f,v[i>>2],g-1|0);Ze(f,(h&3)!=0);d=d+1|0;continue}break}b=P()|0;O()|0}We(i);break c}b=P()|0;O()|0;dc(f)}T(b|0);L()}d=1}kb=f+112|0;return d|0}function S9(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=C(0),j=0,k=0,l=0;e=kb-336|0;kb=e;d=-1;a:{b:{c:{if(!Yk(v[(v[v[b>>2]-12>>2]+b|0)+16>>2])){b=Yl(e+224|0,b);v[23540]=0;d=Q(449,e+208|0,13990)|0;f=v[23540];v[23540]=0;d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{z:{A:{if((f|0)!=1){v[23540]=0;v[e+192>>2]=83886084;v[e+196>>2]=0;U(450,b|0,d|0,e+192|0);f=v[23540];v[23540]=0;if((f|0)==1){break A}Xb(d);t[e+207|0]=0;v[23540]=0;d=Q(449,e+192|0,14768)|0;f=v[23540];v[23540]=0;if((f|0)==1){break z}v[23540]=0;U(451,b|0,e+207|0,d|0);f=v[23540];v[23540]=0;if((f|0)==1){break y}Xb(d);v[23540]=0;f=w[e+207|0];d=Q(449,e+176|0,15840)|0;g=v[23540];v[23540]=0;if((g|0)==1){break x}v[23540]=0;f=f?0:c;X(880,b|0,a+40|0,d|0,f|0);c=v[23540];v[23540]=0;if((c|0)==1){break w}Xb(d);u[e+174>>1]=65535;v[23540]=0;c=Q(449,e+160|0,15510)|0;d=v[23540];v[23540]=0;if((d|0)==1){break v}v[23540]=0;W(479,b|0,e+174|0,c|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break u}Xb(c);u[e+158>>1]=0;v[23540]=0;c=Q(449,e+144|0,15409)|0;d=v[23540];v[23540]=0;if((d|0)==1){break t}v[23540]=0;W(479,b|0,e+158|0,c|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break s}Xb(c);u[a>>1]=x[e+158>>1];v[23540]=0;c=Q(449,e+128|0,15091)|0;d=v[23540];v[23540]=0;if((d|0)==1){break r}v[23540]=0;X(881,b|0,a+52|0,c|0,f|0);d=v[23540];v[23540]=0;if((d|0)==1){break q}Xb(c);v[23540]=0;c=Q(449,e+112|0,15021)|0;d=v[23540];v[23540]=0;if((d|0)==1){break p}v[23540]=0;U(872,b|0,a+36|0,c|0);d=v[23540];v[23540]=0;if((d|0)==1){break o}Xb(c);v[23540]=0;c=Q(449,e+96|0,15517)|0;d=v[23540];v[23540]=0;if((d|0)==1){break n}v[23540]=0;h=a+4|0;U(882,b|0,h|0,c|0);d=v[23540];v[23540]=0;if((d|0)==1){break m}Xb(c);v[23540]=0;c=Q(449,e+80|0,15411)|0;d=v[23540];v[23540]=0;if((d|0)==1){break l}v[23540]=0;f=a+28|0;U(883,b|0,f|0,c|0);d=v[23540];v[23540]=0;if((d|0)==1){break k}Xb(c);v[23540]=0;c=Q(449,e- -64|0,15266)|0;d=v[23540];v[23540]=0;if((d|0)==1){break j}v[23540]=0;U(883,b|0,a+30|0,c|0);d=v[23540];v[23540]=0;if((d|0)==1){break i}Xb(c);v[23540]=0;c=Q(449,e+48|0,15063)|0;d=v[23540];v[23540]=0;if((d|0)==1){break h}v[23540]=0;U(884,b|0,a+32|0,c|0);d=v[23540];v[23540]=0;if((d|0)==1){break g}Xb(c);u[e+46>>1]=0;v[23540]=0;c=Q(449,e+32|0,14994)|0;d=v[23540];v[23540]=0;if((d|0)==1){break c}v[23540]=0;W(479,b|0,e+46|0,c|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break f}Xb(c);i=IL(z[a+32>>2]);z[a+32>>2]=i;d=-1;if(!pm(i)){break d}k=e,l=Fb(v[a+4>>2]),v[k+24>>2]=l;c=Fb(v[a+8>>2]);while(1){g=v[e+24>>2];if(!Pb(g,c)){break e}if(!pm(z[g>>2])){break d}Le(e+24|0);continue}}a=P()|0;O()|0;break a}a=P()|0;O()|0;Xb(d);break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;Xb(d);break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;Xb(d);break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;Xb(c);break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;Xb(c);break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;Xb(c);break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;Xb(c);break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;Xb(c);break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;Xb(c);break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;Xb(c);break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;Xb(c);break a}a=P()|0;O()|0;Xb(c);break a}if(Kk(w[b|0])){break d}c=x[f>>1];if((c-301&65535)>>>0<64935){break d}g=x[a>>1];if(g>>>0>3|(g|0)==2){break d}j=u[a+30>>1];if((j|0)<0){break d}k=e,l=Fi(v[a+36>>2]),v[k+24>>2]=l;v[e+16>>2]=0;k=a,l=v[Jj(e+24|0,e+16|0,43888)>>2],v[k+36>>2]=l;if(uc(v[a+4>>2],v[a+8>>2])>>>0>32767){break d}B:{C:{switch(g-1|0){case 2:f=u[e+46>>1];if((f|0)<=0){break d}u[e+14>>1]=j;z[e+24>>2]=z[a+32>>2];v[23540]=0;u[e+16>>1]=c;u[e+18>>1]=(c+f|0)-1;a=fa(885,a|0,e+14|0,e+24|0,e+16|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){if(a){break B}break d}a=P()|0;O()|0;break a;case 0:g=u[e+46>>1];if((g|0)<=0){break d}z[e+24>>2]=z[a+32>>2];v[23540]=0;u[e+16>>1]=c;u[e+18>>1]=(c+g|0)-1;a=ja(886,a|0,h|0,e+24|0,e+16|0,f|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){if(a){break B}break d}a=P()|0;O()|0;break a;default:break C}}v[23540]=0;Y(887,a|0);a=v[23540];v[23540]=0;if((a|0)==1){break b}}d=1}kh(b)}kb=e+336|0;return d|0}a=P()|0;O()|0;break a}a=P()|0;O()|0}kh(b);T(a|0);L()}function Bx(a,b,c,d,e,f,g,h,i){var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;l=kb-48|0;kb=l;v[l+44>>2]=0;if(i?1:d|g|h){j=g?l+44|0:0;a:{if(!j){break a}k=v[j>>2];if(!k){break a}Mb(k);v[j>>2]=0}v[23540]=0;Z(105);k=v[23540];v[23540]=0;b:{c:{if((k|0)==1){m=Ya(92756,49008,49064,62752,92944,93048,92996,92888,92876,93192,93160,93128,93116,93340,0)|0;d:{e:{n=O()|0;if((n|0)==(ea(92756)|0)){k=_(m|0)|0;v[23540]=0;R(1047,j|0,k|0);j=v[23540];v[23540]=0;k=277;if((j|0)==1){break e}break b}if((ea(49008)|0)==(n|0)){k=_(m|0)|0;v[23540]=0;R(1047,j|0,k|0);j=v[23540];v[23540]=0;k=358;if((j|0)!=1){break b}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){break c}break d}if((ea(49064)|0)==(n|0)){k=_(m|0)|0;v[23540]=0;R(1047,j|0,k|0);j=v[23540];v[23540]=0;k=359;if((j|0)!=1){break b}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){break c}break d}if((ea(62752)|0)==(n|0)){k=_(m|0)|0;v[23540]=0;R(1047,j|0,k|0);j=v[23540];v[23540]=0;k=357;if((j|0)!=1){break b}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){break c}break d}if((ea(92944)|0)==(n|0)){k=_(m|0)|0;v[23540]=0;R(1047,j|0,k|0);j=v[23540];v[23540]=0;k=300;if((j|0)!=1){break b}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){break c}break d}if((ea(93048)|0)==(n|0)){k=_(m|0)|0;v[23540]=0;R(1047,j|0,k|0);j=v[23540];v[23540]=0;k=299;if((j|0)!=1){break b}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){break c}break d}if((ea(92996)|0)==(n|0)){k=_(m|0)|0;v[23540]=0;R(1047,j|0,k|0);j=v[23540];v[23540]=0;k=298;if((j|0)!=1){break b}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){break c}break d}if((ea(92888)|0)==(n|0)){k=_(m|0)|0;v[23540]=0;R(1047,j|0,k|0);j=v[23540];v[23540]=0;k=297;if((j|0)!=1){break b}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){break c}break d}if((ea(92876)|0)==(n|0)){k=_(m|0)|0;v[23540]=0;R(1047,j|0,k|0);j=v[23540];v[23540]=0;k=296;if((j|0)!=1){break b}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){break c}break d}if((ea(93192)|0)==(n|0)){k=_(m|0)|0;v[23540]=0;R(1047,j|0,k|0);j=v[23540];v[23540]=0;k=289;if((j|0)!=1){break b}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){break c}break d}if((ea(93160)|0)==(n|0)){k=_(m|0)|0;v[23540]=0;R(1047,j|0,k|0);j=v[23540];v[23540]=0;k=288;if((j|0)!=1){break b}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){break c}break d}if((ea(93128)|0)==(n|0)){k=_(m|0)|0;v[23540]=0;R(1047,j|0,k|0);j=v[23540];v[23540]=0;k=287;if((j|0)!=1){break b}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){break c}break d}if((ea(93116)|0)==(n|0)){k=_(m|0)|0;v[23540]=0;R(1047,j|0,k|0);j=v[23540];v[23540]=0;k=286;if((j|0)!=1){break b}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){break c}break d}o=ea(93340)|0;k=257;m=_(m|0)|0;if((n|0)!=(o|0)){break b}v[23540]=0;R(1047,j|0,m|0);j=v[23540];v[23540]=0;k=267;if((j|0)!=1){break b}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)==1){break d}break c}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){break c}}V(0)|0;O()|0;Vb()}L()}T(a|0);L()}$()}m=!g;if(d){j=ob[d|0](k,e)|0}else{j=3}if(!(m|!(j&2))){v[g+16>>2]=k;m=g;g=v[l+44>>2];p=m,q=gg(g?g:21688),v[p+20>>2]=q}if(h){v[h>>2]=k}if(i){g=v[l+44>>2];p=i,q=gg(g?g:21688),v[p>>2]=q}g=v[l+44>>2];if(g){Mb(g);v[l+44>>2]=0}f:{if(!(j&1)){break f}v[23540]=0;R(1045,l+32|0,a|0);g=v[23540];v[23540]=0;g:{h:{if((g|0)!=1){i:{if(f){g=v[f+24>>2];v[23540]=0;R(1046,g|0,l+32|0);g=v[23540];v[23540]=0;if((g|0)!=1){break i}break h}g=Mc(l+32|0);if(b){v[23540]=0;R(b|0,g|0,c|0);g=v[23540];v[23540]=0;if((g|0)==1){break h}break i}Ms(g,l)}zb(l+32|0);break f}g=V(0)|0;O()|0;break g}g=V(0)|0;O()|0;zb(l+32|0)}_(g|0)|0;v[l+28>>2]=f;v[l+24>>2]=e;v[l+20>>2]=d;v[l+16>>2]=c;v[l+12>>2]=b;v[l+8>>2]=a?a:21688;v[l+4>>2]=250;v[l>>2]=9203;qK(17904,l);Ls(93696);$()}kb=l+48|0}function xja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,z=0;e=kb-352|0;kb=e;zc(b);f=kb-16|0;kb=f;kU(f+8|0,e+128|0);h=v[f+12>>2];nc(f,v[b>>2],v[b+8>>2],v[f+8>>2],v[f+12>>2]);i=v[f+4>>2];if((i|0)==(h|0)){$b(b,v[f+12>>2])}kb=f+16|0;a:{b:{c:{d:{e:{f:{g:{if((h|0)!=(i|0)){break g}if(!mU(e+128|0)){break g}if(!Qb(v[b>>2],v[b+8>>2],Ec(lU(w[e+344|0],w[e+345|0]),nb))){break g}if(!c){d=1;break g}Cd(a,2);ag(a);v[a+480188>>2]=524296;s=a,z=Qe(455e3),v[s+480204>>2]=z;Ob(a+1074312|0,110,1);v[a+480208>>2]=v[a+480208>>2]|16777216;f=e+96|0;Ne(f,2,e+159|0);d=e+112|0;Fc(d,f);Bc(a+1298308|0,d);zb(d);d=0;h:{i:{while(1){if((d|0)==8){j:{d=Wb(v[a+484360>>2],w[a+484376|0]);o=w[e+344|0];n=o+1|0;uo(d,b,n,65535,65535);f=Tb(e+112|0);v[23540]=0;U(234,b|0,f|0,n|0);d=v[23540];v[23540]=0;if((d|0)==1){break j}s=e,z=Fb(v[f>>2]),v[s+96>>2]=z;d=Fb(v[f+4>>2]);while(1){h=v[e+96>>2];p=Pb(h,d);if(p){if((w[h|0]-9&255)>>>0<248){break h}Ke(e+96|0);continue}break}s=a,z=w[Lb(v[f>>2],0)|0],v[s+480196>>2]=z;d=w[e+343|0];i=w[e+345|0];h=Tb(e+96|0);v[23540]=0;m=i+1|0;U(234,b|0,h|0,m|0);i=v[23540];v[23540]=0;k:{if((i|0)==1){break k}v[23540]=0;i=a+484344|0;R(225,i|0,m|0);g=v[23540];v[23540]=0;if((g|0)==1){break k}q=d+1|0;if(!(c&1)){break i}c=0;while(1){if((c|0)==(m|0)){break i}d=w[Lb(v[h>>2],c)|0];v[23540]=0;d=W(226,i|0,d|0,q|0)|0;g=v[23540];v[23540]=0;l:{if((g|0)!=1){if(!d){break i}j=0;k=_b(v[i>>2],w[Lb(v[h>>2],c)|0]);m:while(1){r=j&65535;if(r>>>0>7){break l}j=j+1|0;d=0;while(1){if(y[k+12>>2]<=d>>>0){continue m}v[23540]=0;g=S(206,b|0)|0;l=v[23540];v[23540]=0;n:{o:{if((l|0)!=1){if(!(g&128)){break o}d=(g&127)+d|0;break n}d=P()|0;O()|0;break b}l=jd(v[k>>2],v[v[k+48>>2]+12>>2],d,r);if((g|0)==1){t[l|0]=254;break n}if((g-1&255)>>>0>96){break n}t[l+1|0]=j;t[l|0]=g+12}d=d+1|0;continue}}}d=P()|0;O()|0;break b}c=c+1|0;continue}}d=P()|0;O()|0;break b}}else{i=e+112|0;f=(e+128|0)+B(d,19)|0;kB(i,f+63|0);h=e+96|0;Fc(h,i);El(((d<<5)+a|0)+480289|0,h);zb(h);d=d+1|0;g=B(d,104)+a|0;j=g+484380|0;nd(j,2);t[e+107|0]=0;h=w[f+78|0]|w[f+79|0]<<8|(w[f+80|0]<<16|w[f+81|0]<<24);t[e+103|0]=h;t[e+104|0]=h>>>8;t[e+105|0]=h>>>16;t[e+106|0]=h>>>24;h=w[f+75|0]|w[f+76|0]<<8|(w[f+77|0]<<16|w[f+78|0]<<24);f=w[f+71|0]|w[f+72|0]<<8|(w[f+73|0]<<16|w[f+74|0]<<24);v[e+8>>2]=v[e+104>>2];v[e+96>>2]=f;v[e+100>>2]=h;f=v[e+100>>2];v[e>>2]=v[e+96>>2];v[e+4>>2]=f;Dl(j,1,e);v[g+484404>>2]=8215;f=e+80|0;Fc(f,i);Dc(((d<<5)+a|0)+946304|0,f);zb(f);continue}break}d=P()|0;O()|0;break a}j=o+1|0;c=a+484376|0;d=0;p:{q:{while(1){if((d|0)==(j|0)){v[23540]=0;b=Q(1,e+80|0,8645)|0;c=v[23540];v[23540]=0;if((c|0)!=1){break p}d=P()|0;O()|0;break b}b=w[c|0];g=v[a+484360>>2];v[23540]=0;k=d&65535;b=Q(311,Wb(g,b)|0,k|0)|0;g=v[23540];v[23540]=0;if((g|0)!=1){r:{s:{if(b){b=Wb(v[a+484360>>2],w[c|0]);break s}v[23540]=0;g=Q(359,i|0,q|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break q}if((g|0)==65535){break r}b=Wb(v[a+484360>>2],w[c|0]);s=cc(v[b>>2],d),z=g,u[s>>1]=z}b=jB(Fb(v[_b(v[i>>2],x[cc(v[b>>2],d)>>1])+4>>2]),1);g=w[b+5|0];l=w[Lb(v[f>>2],(d+1>>>0)%(n>>>0)|0)|0];if((g|0)==(l|0)){break r}t:{if(w[b+3|0]!=16){break t}g=w[c|0];m=v[a+484360>>2];v[23540]=0;g=Q(360,Wb(m,g)|0,k|0)|0;k=v[23540];v[23540]=0;if((k|0)==1){break c}if((g|0)==65535){break t}b=jB(Fb(v[_b(v[i>>2],g)+4>>2]),1)}t[b+5|0]=l;t[b+3|0]=16}d=d+1|0;continue}break}d=P()|0;O()|0;break b}d=P()|0;O()|0;break b}Jb(a+1298344|0,b);Ab(b);v[23540]=0;b=Q(1,e- -64|0,6052)|0;c=v[23540];v[23540]=0;if((c|0)==1){break f}Jb(a+1298356|0,b);Ab(b);b=e+16|0;Dj(b,2,e+139|0);v[23540]=0;R(222,e+32|0,b|0);b=v[23540];v[23540]=0;if((b|0)==1){break e}v[23540]=0;U(11,e+48|0,5,e+32|0);b=v[23540];v[23540]=0;if((b|0)==1){break d}b=e+48|0;Jb(a+1298368|0,b);Ab(b);zb(e+32|0);v[a+1298404>>2]=5;ic(h)}ic(f);d=p^1}kb=e+352|0;return d|0}d=P()|0;O()|0;break b}d=P()|0;O()|0;break b}d=P()|0;O()|0;zb(e+32|0);break b}d=P()|0;O()|0}ic(h)}ic(f);T(d|0);L()}function TH(a,b,c,d,e){var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,w=0,x=0,y=0,z=0,C=0;i=kb-560|0;kb=i;g=c;c=(c-3|0)/24|0;s=(c|0)>0?c:0;k=g+B(s,-24)|0;o=v[(e<<2)+73840>>2];j=d-1|0;if((o+j|0)>=0){g=d+o|0;c=s-j|0;while(1){A[(i+320|0)+(h<<3)>>3]=(c|0)<0?0:+v[(c<<2)+73856>>2];c=c+1|0;h=h+1|0;if((g|0)!=(h|0)){continue}break}}q=k-24|0;g=0;t=(o|0)>0?o:0;h=(d|0)<=0;while(1){a:{if(h){f=0;break a}n=g+j|0;c=0;f=0;while(1){f=A[(c<<3)+a>>3]*A[(i+320|0)+(n-c<<3)>>3]+f;c=c+1|0;if((d|0)!=(c|0)){continue}break}}A[(g<<3)+i>>3]=f;c=(g|0)==(t|0);g=g+1|0;if(!c){continue}break}z=47-k|0;u=48-k|0;C=k-25|0;g=o;b:{while(1){f=A[(g<<3)+i>>3];c=0;h=g;l=(g|0)<=0;if(!l){while(1){n=(i+480|0)+(c<<2)|0;m=f*5.960464477539063e-8;c:{if(D(m)<2147483648){j=~~m;break c}j=-2147483648}m=+(j|0);f=m*-16777216+f;d:{if(D(f)<2147483648){j=~~f;break d}j=-2147483648}v[n>>2]=j;h=h-1|0;f=A[(h<<3)+i>>3]+m;c=c+1|0;if((g|0)!=(c|0)){continue}break}}f=Wj(f,q);f=f+H(f*.125)*-8;e:{if(D(f)<2147483648){n=~~f;break e}n=-2147483648}f=f-+(n|0);f:{g:{h:{w=(q|0)<=0;i:{if(!w){h=(g<<2)+i|0;j=v[h+476>>2];c=j>>u;r=h;h=j-(c<<u)|0;v[r+476>>2]=h;n=c+n|0;j=h>>z;break i}if(q){break h}j=v[((g<<2)+i|0)+476>>2]>>23}if((j|0)<=0){break f}break g}j=2;if(f>=.5){break g}j=0;break f}c=0;h=0;if(!l){while(1){r=(i+480|0)+(c<<2)|0;x=v[r>>2];l=16777215;j:{k:{if(h){break k}l=16777216;if(x){break k}h=0;break j}v[r>>2]=l-x;h=1}c=c+1|0;if((g|0)!=(c|0)){continue}break}}l:{if(w){break l}c=8388607;m:{switch(C|0){case 1:c=4194303;break;case 0:break m;default:break l}}l=(g<<2)+i|0;v[l+476>>2]=v[l+476>>2]&c}n=n+1|0;if((j|0)!=2){break f}f=1-f;j=2;if(!h){break f}f=f-Wj(1,q)}if(f==0){c=1;l=0;h=g;n:{if((g|0)<=(o|0)){break n}while(1){h=h-1|0;l=v[(i+480|0)+(h<<2)>>2]|l;if((h|0)>(o|0)){continue}break}if(!l){break n}k=q;while(1){k=k-24|0;g=g-1|0;if(!v[(i+480|0)+(g<<2)>>2]){continue}break}break b}while(1){h=c;c=c+1|0;if(!v[(i+480|0)+(o-h<<2)>>2]){continue}break}h=g+h|0;while(1){j=d+g|0;g=g+1|0;A[(i+320|0)+(j<<3)>>3]=v[(s+g<<2)+73856>>2];c=0;f=0;if((d|0)>0){while(1){f=A[(c<<3)+a>>3]*A[(i+320|0)+(j-c<<3)>>3]+f;c=c+1|0;if((d|0)!=(c|0)){continue}break}}A[(g<<3)+i>>3]=f;if((g|0)<(h|0)){continue}break}g=h;continue}break}f=Wj(f,24-k|0);o:{if(f>=16777216){d=(i+480|0)+(g<<2)|0;m=f*5.960464477539063e-8;p:{if(D(m)<2147483648){c=~~m;break p}c=-2147483648}f=+(c|0)*-16777216+f;q:{if(D(f)<2147483648){a=~~f;break q}a=-2147483648}v[d>>2]=a;g=g+1|0;break o}if(D(f)<2147483648){c=~~f}else{c=-2147483648}k=q}v[(i+480|0)+(g<<2)>>2]=c}f=Wj(1,k);if((g|0)>=0){d=g;while(1){a=d;A[(a<<3)+i>>3]=f*+v[(i+480|0)+(a<<2)>>2];d=a-1|0;f=f*5.960464477539063e-8;if(a){continue}break}a=0;h=g;while(1){d=a>>>0>t>>>0?t:a;c=0;f=0;while(1){f=A[(c<<3)+76624>>3]*A[(c+h<<3)+i>>3]+f;k=(c|0)!=(d|0);c=c+1|0;if(k){continue}break}A[(i+160|0)+(g-h<<3)>>3]=f;h=h-1|0;c=(a|0)!=(g|0);a=a+1|0;if(c){continue}break}}r:{s:{t:{switch(e|0){case 3:u:{if((g|0)<=0){break u}d=(i+160|0)+(g<<3)|0;f=A[d>>3];c=g;while(1){m=f;e=i+160|0;a=c-1|0;h=e+(a<<3)|0;y=A[h>>3];f=y+f;A[e+(c<<3)>>3]=m+(y-f);A[h>>3]=f;e=c>>>0>1;c=a;if(e){continue}break}if((g|0)<2){break u}f=A[d>>3];c=g;while(1){m=f;d=i+160|0;a=c-1|0;e=d+(a<<3)|0;p=A[e>>3];f=p+f;A[d+(c<<3)>>3]=m+(p-f);A[e>>3]=f;d=c>>>0>2;c=a;if(d){continue}break}p=0;while(1){p=p+A[(i+160|0)+(g<<3)>>3];a=(g|0)>2;g=g-1|0;if(a){continue}break}}f=A[i+160>>3];if(j){break s}A[b>>3]=f;f=A[i+168>>3];A[b+16>>3]=p;A[b+8>>3]=f;break r;case 0:f=0;if((g|0)>=0){while(1){a=g;g=g-1|0;f=f+A[(i+160|0)+(a<<3)>>3];if(a){continue}break}}A[b>>3]=j?-f:f;break r;case 1:case 2:break t;default:break r}}f=0;if((g|0)>=0){d=g;while(1){a=d;d=a-1|0;f=f+A[(i+160|0)+(a<<3)>>3];if(a){continue}break}}A[b>>3]=j?-f:f;f=A[i+160>>3]-f;c=1;if((g|0)>0){while(1){f=f+A[(i+160|0)+(c<<3)>>3];a=(c|0)!=(g|0);c=c+1|0;if(a){continue}break}}A[b+8>>3]=j?-f:f;break r}A[b>>3]=-f;f=A[i+168>>3];A[b+16>>3]=-p;A[b+8>>3]=-f}kb=i+560|0;return n&7}function q$(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0;h=kb+-64|0;kb=h;v[h+56>>2]=b;v[e>>2]=0;gd(h,d);v[23540]=0;b=S(1132,h|0)|0;i=v[23540];v[23540]=0;a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{z:{A:{if((i|0)!=1){ac(h);switch(g-65|0){case 54:break j;case 19:break k;case 18:break l;case 17:break m;case 49:break n;case 47:break o;case 45:case 51:break p;case 12:break q;case 44:break r;case 41:break s;case 8:break t;case 7:break u;case 5:break v;case 3:break w;case 35:case 36:break x;case 34:break y;case 1:case 33:case 39:break z;case 0:case 32:break A;case 2:case 4:case 6:case 9:case 10:case 11:case 13:case 14:case 15:case 16:case 20:case 21:case 22:case 25:case 26:case 27:case 28:case 29:case 30:case 31:case 37:case 38:case 40:case 42:case 43:case 46:case 48:case 50:case 52:case 53:break d;case 24:break f;case 56:break g;case 23:break h;case 55:break i;default:break e}}a=P()|0;O()|0;ac(h);T(a|0);L()}mG(a,f+24|0,h+56|0,c,e,b);break b}lG(a,f+16|0,h+56|0,c,e,b);break b}b=ob[v[v[a+8>>2]+12>>2]](a+8|0)|0;g=a;i=v[h+56>>2];a=Ac(b);j=h,k=_j(g,i,c,d,e,f,a,a+(Hb(b)<<2)|0),v[j+56>>2]=k;break b}a=Vi(h+56|0,c,e,b,2);b=v[e>>2];B:{if(!(b&4|a-1>>>0>30)){v[f+12>>2]=a;break B}v[e>>2]=b|4}break b}b=v[20975];v[h+24>>2]=v[20974];v[h+28>>2]=b;b=v[20973];v[h+16>>2]=v[20972];v[h+20>>2]=b;b=v[20971];v[h+8>>2]=v[20970];v[h+12>>2]=b;b=v[20969];v[h>>2]=v[20968];v[h+4>>2]=b;j=h,k=_j(a,v[h+56>>2],c,d,e,f,h,h+32|0),v[j+56>>2]=k;break b}b=v[20983];v[h+24>>2]=v[20982];v[h+28>>2]=b;b=v[20981];v[h+16>>2]=v[20980];v[h+20>>2]=b;b=v[20979];v[h+8>>2]=v[20978];v[h+12>>2]=b;b=v[20977];v[h>>2]=v[20976];v[h+4>>2]=b;j=h,k=_j(a,v[h+56>>2],c,d,e,f,h,h+32|0),v[j+56>>2]=k;break b}a=Vi(h+56|0,c,e,b,2);b=v[e>>2];C:{if(!(b&4|(a|0)>23)){v[f+8>>2]=a;break C}v[e>>2]=b|4}break b}a=Vi(h+56|0,c,e,b,2);b=v[e>>2];D:{if(!(b&4|a-1>>>0>11)){v[f+8>>2]=a;break D}v[e>>2]=b|4}break b}a=Vi(h+56|0,c,e,b,3);b=v[e>>2];E:{if(!(b&4|(a|0)>365)){v[f+28>>2]=a;break E}v[e>>2]=b|4}break b}a=Vi(h+56|0,c,e,b,2);b=v[e>>2];F:{if(!(b&4|(a|0)>12)){v[f+16>>2]=a-1;break F}v[e>>2]=b|4}break b}a=Vi(h+56|0,c,e,b,2);b=v[e>>2];G:{if(!(b&4|(a|0)>59)){v[f+4>>2]=a;break G}v[e>>2]=b|4}break b}a=h+56|0;d=kb-16|0;kb=d;v[d+8>>2]=c;while(1){H:{if(!cs(a,d+8|0)){break H}if(!Wk(b,8192,Xk(v[a>>2]))){break H}Dn(a);continue}break}if(ak(a,d+8|0)){v[e>>2]=v[e>>2]|2}kb=d+16|0;break b}d=h+56|0;a=ob[v[v[a+8>>2]+8>>2]](a+8|0)|0;I:{if((Hb(a)|0)==(0-Hb(a+12|0)|0)){v[e>>2]=v[e>>2]|4;break I}c=Sr(d,c,a,a+24|0,b,e,0);b=v[f+8>>2];if(!((c|0)!=(a|0)|(b|0)!=12)){v[f+8>>2]=0;break I}if(!((c-a|0)!=12|(b|0)>11)){v[f+8>>2]=b+12}}break b}b=sc(h,83936,44);j=b,k=_j(a,v[b+56>>2],c,d,e,f,b,b+44|0),v[j+56>>2]=k;break b}v[h+16>>2]=v[21e3];b=v[20999];v[h+8>>2]=v[20998];v[h+12>>2]=b;b=v[20997];v[h>>2]=v[20996];v[h+4>>2]=b;j=h,k=_j(a,v[h+56>>2],c,d,e,f,h,h+20|0),v[j+56>>2]=k;break b}a=Vi(h+56|0,c,e,b,2);b=v[e>>2];J:{if(!(b&4|(a|0)>60)){v[f>>2]=a;break J}v[e>>2]=b|4}break b}b=v[21011];v[h+24>>2]=v[21010];v[h+28>>2]=b;b=v[21009];v[h+16>>2]=v[21008];v[h+20>>2]=b;b=v[21007];v[h+8>>2]=v[21006];v[h+12>>2]=b;b=v[21005];v[h>>2]=v[21004];v[h+4>>2]=b;j=h,k=_j(a,v[h+56>>2],c,d,e,f,h,h+32|0),v[j+56>>2]=k;break b}a=Vi(h+56|0,c,e,b,1);b=v[e>>2];K:{if(!(b&4|(a|0)>6)){v[f+24>>2]=a;break K}v[e>>2]=b|4}break b}a=ob[v[v[a>>2]+20>>2]](a,v[h+56>>2],c,d,e,f)|0;break a}b=ob[v[v[a+8>>2]+24>>2]](a+8|0)|0;g=a;i=v[h+56>>2];a=Ac(b);j=h,k=_j(g,i,c,d,e,f,a,a+(Hb(b)<<2)|0),v[j+56>>2]=k;break b}jG(f+20|0,h+56|0,c,e,b);break b}a=Vi(h+56|0,c,e,b,4);if(!(w[e|0]&4)){v[f+20>>2]=a-1900}break b}if((g|0)==37){break c}}v[e>>2]=v[e>>2]|4;break b}a=kb-16|0;kb=a;v[a+8>>2]=c;c=6;d=h+56|0;L:{M:{if(ak(d,a+8|0)){break M}c=4;if((wn(b,Xk(v[d>>2]))|0)!=37){break M}c=2;if(!ak(Dn(d),a+8|0)){break L}}v[e>>2]=v[e>>2]|c}kb=a+16|0}a=v[h+56>>2]}kb=h- -64|0;return a|0}function zM(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;k=kb-16|0;kb=k;a:{b:{c:{if(!$c(c)|!d|v[b+480180>>2]!=16777216|x[b+480192>>1]<d>>>0){break c}d=v[((d<<2)+b|0)+900380>>2];if(!d){break c}e=v[d+44>>2];if(!e){break c}u[k+14>>1]=c-61;c=kb+-64|0;kb=c;d:{e:{d=u[e+28>>1];h=k+14|0;b=u[h>>1];if((d|0)<=(b|0)){if((b|0)<=(uc(v[e+4>>2],v[e+8>>2])+d<<16)-65536>>16){break e}}Nb(a);break d}f:{d=x[e+30>>1];if(!d){b=e+52|0;d=Yx(b,h);if(!Hg(d,xf(b))){break f}Pl(a,vd(d)+4|0);break d}b=Qn(b,d<<16>>16);u[c+62>>1]=b;d=Nb(a);g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{a=e+52|0;f=Yx(a,c+62|0);t:{if(Hg(f,xf(a))){v[23540]=0;R(135,d|0,vd(f)+4|0);a=v[23540];v[23540]=0;if((a|0)==1){break t}a=u[e+30>>1];b=u[h>>1];v[23540]=0;l=c,m=Xx(b,a)+5|0,v[l+32>>2]=m;R(132,c+48|0,c+32|0);a=v[23540];v[23540]=0;u:{if((a|0)!=1){v[23540]=0;Q(98,d|0,c+48|0)|0;a=v[23540];v[23540]=0;if((a|0)==1){break u}Ab(c+48|0);break d}a=P()|0;O()|0;break g}a=P()|0;O()|0;Ab(c+48|0);break g}if(u[e+30>>1]>26){break q}v[23540]=0;b=W(527,c+32|0,1,(b<<24)+1090519040>>24)|0;a=v[23540];v[23540]=0;if((a|0)==1){break s}v[23540]=0;U(11,c+48|0,0,b|0);a=v[23540];v[23540]=0;if((a|0)==1){break r}a=c+48|0;f=Jb(d,a);Ab(a);zb(b);v[23540]=0;Q(133,f|0,14669)|0;a=v[23540];v[23540]=0;if((a|0)!=1){break p}}a=P()|0;O()|0;break g}a=P()|0;O()|0;break g}a=P()|0;O()|0;zb(b);break g}v[23540]=0;a=b<<16>>16;v[c+28>>2]=(a|0)%16;R(840,c+32|0,c+28|0);f=v[23540];v[23540]=0;if((f|0)==1){break o}v[23540]=0;v[c+12>>2]=((a|0)/16<<16>>16)%16;R(840,c+16|0,c+12|0);a=v[23540];v[23540]=0;if((a|0)==1){break n}v[23540]=0;U(2,c+48|0,c+32|0,c+16|0);a=v[23540];v[23540]=0;if((a|0)==1){break m}a=c+48|0;f=Jb(d,a);Ab(a);Ab(c+16|0);Ab(c+32|0);if(b<<16>>16<256){break p}v[23540]=0;U(8,c|0,0,f|0);a=v[23540];v[23540]=0;if((a|0)==1){break k}b=c+32|0;g=he(c);j=yh(c);i=he(c);a=kb-32|0;kb=a;v[a+16>>2]=j;v[a+24>>2]=g;v[a+8>>2]=i;while(1){if(pj(a+24|0,a+16|0)){g=a+24|0;j=Tp(t[v[g>>2]]);i=a+8|0;t[v[i>>2]]=j;Ke(g);Ke(i);continue}break}kb=a+32|0;ad(b,c);v[23540]=0;U(11,c+48|0,0,b|0);a=v[23540];v[23540]=0;if((a|0)==1){break j}a=c+48|0;Jb(f,a);Ab(a);zb(c+32|0);zb(c)}a=u[e+30>>1];b=u[h>>1];v[23540]=0;l=c,m=Xx(b,a)+5|0,v[l+16>>2]=m;R(132,c+48|0,c+16|0);a=v[23540];v[23540]=0;if((a|0)==1){break i}v[23540]=0;Q(98,d|0,c+48|0)|0;a=v[23540];v[23540]=0;if((a|0)==1){break h}Ab(c+48|0);break d}a=P()|0;O()|0;break g}a=P()|0;O()|0;break l}a=P()|0;O()|0;Ab(c+16|0)}Ab(c+32|0);break g}a=P()|0;O()|0;break g}a=P()|0;O()|0;zb(c+32|0);zb(c);break g}a=P()|0;O()|0;break g}a=P()|0;O()|0;Ab(c+48|0)}break a}d=kb-16|0;kb=d;f=kb-32|0;kb=f;e=of(f+16|0,1,0);v:{w:{x:{while(1){j=f+8|0;b=Ac(e);i=Hb(e)+b|0;g=u[h>>1];if(!((b|0)==(i|0)|(g|0)>=0)){t[b|0]=45;g=0-(g&65535)&65535;b=b+1|0}zx(j,b,i,g&65535);if(!v[f+12>>2]){break x}b=ch(Hb(e));v[23540]=0;R(59,e|0,b|0);b=v[23540];v[23540]=0;if((b|0)!=1){continue}break}break w}b=v[f+8>>2];h=Ac(e);v[23540]=0;R(60,e|0,b-h|0);b=v[23540];v[23540]=0;y:{if((b|0)!=1){v[23540]=0;R(72,d|0,e|0);b=v[23540];v[23540]=0;if((b|0)!=1){break y}break w}break w}zb(e);kb=f+32|0;break v}a=P()|0;O()|0;zb(e);T(a|0);L()}v[23540]=0;R(71,a|0,d|0);a=v[23540];v[23540]=0;z:{if((a|0)!=1){Ab(d);kb=d+16|0;break z}a=P()|0;O()|0;break a}}kb=c- -64|0;break b}e=v[b>>2];b=kb-32|0;kb=b;A:{if(Pp(c)){v[b+16>>2]=v[8044];d=v[8043];v[b+8>>2]=v[8042];v[b+12>>2]=d;d=v[8041];v[b>>2]=v[8040];v[b+4>>2]=d;yc(a,(b+(c<<2)|0)-1004|0);break A}if($c(c)){d=Nb(b);v[23540]=0;c=c-1|0;f=(c|0)/12|0;c=Q(841,d|0,e+(B(f,-12)+c<<16>>16<<2)|0)|0;e=v[23540];v[23540]=0;B:{if((e|0)==1){break B}v[23540]=0;c=Q(842,c|0,f+48&255)|0;e=v[23540];v[23540]=0;if((e|0)==1){break B}v[23540]=0;Q(3,a|0,c|0)|0;a=v[23540];v[23540]=0;if((a|0)==1){break B}Ab(c);break A}a=P()|0;O()|0;break a}if(!c){yc(a,16799);break A}yc(a,14640)}kb=b+32|0}kb=k+16|0;return}Ab(d);T(a|0);L()}function M9(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=C(0),n=0,o=0,p=0;d=kb-128|0;kb=d;g=-1;a:{b:{c:{d:{e:{f:{if(!Yg(v[v[b>>2]-12>>2]+b|0)){break f}e=d+112|0;me(e,b);f=v[e+8>>2];i=v[e+12>>2];e=d+104|0;Uj(e);b=Uk(b,e,8);if(Sb(e,16775,8)){a=Xg(d+88|0,f,i);c=v[a+12>>2];v[d+16>>2]=v[a+8>>2];v[d+20>>2]=c;c=v[a+4>>2];v[d+8>>2]=v[a>>2];v[d+12>>2]=c;Zj(b,d+8|0);break f}u[d+86>>1]=0;Wf(b,d+86|0);l=u[d+86>>1];if((l-4&65535)>>>0<65534){break f}e=d+78|0;Uj(e);b=Uk(b,e,8);if(Sb(e,14320,8)){break f}u[d+76>>1]=0;Wf(b,d+76|0);i=u[d+76>>1];if((i-5&65535)>>>0<65534){break f}g:{h:{i:{if(i>>>0<=3){e=Nb(d+112|0);v[23540]=0;f=W(483,b|0,e|0,65535)|0;k=v[23540];v[23540]=0;if((k|0)==1){break b}if(!f){break h}v[23540]=0;U(11,d- -64|0,c|0,e|0);f=v[23540];v[23540]=0;if((f|0)!=1){break i}break b}e=Nb(d+112|0);v[23540]=0;f=Q(485,b|0,e|0)|0;k=v[23540];v[23540]=0;if((k|0)==1){break c}if(!f){break g}v[23540]=0;U(11,d- -64|0,c|0,e|0);f=v[23540];v[23540]=0;if((f|0)==1){break c}}f=d- -64|0;Jb(a+40|0,f);Ab(f);zb(e);u[d+62>>1]=0;Wf(b,d+62|0);u[d+60>>1]=0;Wf(b,d+60|0);u[a>>1]=x[d+60>>1];u[d+58>>1]=0;j:{if((i|0)<=3){v[d+112>>2]=0;pk(b,d+112|0);e=v[d+112>>2];if(e>>>0>65535){break f}f=Al(e);u[d+58>>1]=f;break j}Wf(b,d+58|0);f=x[d+58>>1]}k=a+52|0;n=f&65535;i=(i|0)>3;f=0;k:{l:{m:{while(1){if((f&65535)>>>0>=n>>>0){break l}e=Nb(d+112|0);v[23540]=0;u[d+40>>1]=0;R(891,b|0,d+40|0);h=v[23540];v[23540]=0;if((h|0)==1){break e}n:{if(!i){v[23540]=0;h=W(483,b|0,e|0,65535)|0;j=v[23540];v[23540]=0;if((j|0)==1){break e}if(h){break n}zb(e);break f}v[23540]=0;h=Q(485,b|0,e|0)|0;j=v[23540];v[23540]=0;if((j|0)==1){break e}if(!h){break k}}v[23540]=0;U(11,d- -64|0,c|0,e|0);h=v[23540];v[23540]=0;if((h|0)!=1){v[23540]=0;h=Q(888,k|0,d+40|0)|0;j=v[23540];v[23540]=0;if((j|0)==1){break m}j=h;h=d- -64|0;Jb(j,h);Ab(h);zb(e);f=f+1|0;continue}break}g=P()|0;O()|0;break d}g=P()|0;O()|0;Ab(d- -64|0);break d}c=d- -64|0;Uj(c);b=Uk(b,c,8);if(Sb(c,14264,8)){break f}c=x[a>>1];if(c>>>0>3|(c|0)==2){break f}c=a+4|0;o:{if((l|0)<=2){if(GL(b,c)){break o}break f}if(!FL(b,c)){break f}}o=d,p=Fb(v[a+4>>2]),v[o+112>>2]=p;c=Fb(v[a+8>>2]);while(1){e=v[d+112>>2];if(Pb(e,c)){if(!pm(z[e>>2])){break f}Le(d+112|0);continue}break}c=a+16|0;p:{if((l|0)<=2){if(GL(b,c)){break p}break f}if(!FL(b,c)){break f}}o=d,p=Fb(v[a+16>>2]),v[o+112>>2]=p;c=Fb(v[a+20>>2]);while(1){e=v[d+112>>2];if(Pb(e,c)){if(!pm(z[e>>2])){break f}Le(d+112|0);continue}break}o=a,p=uc(v[a+16>>2],v[a+20>>2]),v[o+36>>2]=p;u[d+56>>1]=0;Wf(b,d+56|0);c=x[d+56>>1];u[a+28>>1]=c;if((c-201&65535)>>>0<65135){break f}u[d+54>>1]=0;Wf(b,d+54|0);c=u[d+54>>1];u[a+30>>1]=c;if((c|0)<0){break f}v[d+48>>2]=0;Hp(b,d+48|0);m=IL(z[d+48>>2]);z[a+32>>2]=m;if(!pm(m)){break f}c=d+40|0;Uj(c);Uk(b,c,8);if(Sb(c,16766,8)){break f}b=uc(v[a+4>>2],v[a+8>>2]);if(b>>>0>32767){break f}c=u[a+30>>1];e=x[a>>1];if(!(e?!(z[a+32>>2]<=C(0))&(c|0)>0:1)){break f}q:{switch(e-1|0){case 0:case 2:if(b>>>0<c>>>0){break f}break;default:break q}}b=0;c=v[a+36>>2];if(c){b=c-1|0;v[a+36>>2]=b}o=d,p=Fi(b),v[o+112>>2]=p;v[d+32>>2]=0;o=a,p=v[Jj(d+112|0,d+32|0,43888)>>2],v[o+36>>2]=p;Ip(a);g=1;if(x[a>>1]!=3){break f}c=u[a+30>>1];if((c-u[a+28>>1]|0)>(QL(uc(v[a+4>>2],v[a+8>>2]))|0)){break f}g=a+32|0;e=Tb(d+112|0);b=0;while(1){r:{if(c<<16>>16<=(b|0)){b=x[a+28>>1];u[d+32>>1]=b;o=d,p=(uc(v[a+4>>2],v[a+8>>2])+b|0)-1|0,u[o+34>>1]=p;v[23540]=0;u[d+30>>1]=0;ja(886,a|0,e|0,g|0,d+32|0,d+30|0)|0;a=v[23540];v[23540]=0;g=1;if((a|0)==1){break r}wc(e);break f}c=u[a+28>>1];f=v[a+4>>2];v[23540]=0;R(892,e|0,Eb(f,b-c|0)|0);c=v[23540];v[23540]=0;if((c|0)!=1){b=b+1|0;c=x[a+30>>1];continue}}break}g=P()|0;O()|0;wc(e);break a}zb(e);break f}zb(e);break f}zb(e)}kb=d+128|0;return g|0}g=P()|0;O()|0}zb(e);break a}g=P()|0;O()|0;zb(e);break a}g=P()|0;O()|0;zb(e)}T(g|0);L()}function xfa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,y=0,z=0,A=0,C=0;e=kb-752|0;kb=e;zc(b);d=kb-16|0;kb=d;h=e+144|0;gR(d+8|0,h);f=v[d+12>>2];nc(d,v[b>>2],v[b+8>>2],v[d+8>>2],v[d+12>>2]);g=v[d+4>>2];if((g|0)==(f|0)){$b(b,v[d+12>>2])}kb=d+16|0;d=(f|0)==(g|0);if(!d){fR(h)}a:{if(!d){break a}if(!iR(e+144|0)){break a}if(!Qb(v[b>>2],v[b+8>>2],Ec(hR(x[e+178>>1]),nb))){break a}if(!c){n=1;break a}Cd(a,262144);f=e+104|0;Ii(f,2,e+144|0);d=e+24|0;Fc(d,f);Bc(a+1298308|0,d);zb(d);h=yc(d,8346);Jb(a+1298344|0,h);Ab(h);d=yc(d,10144);Jb(a+1298356|0,d);Ab(d);d=kb-16|0;kb=d;i=f;f=yc(d,4196);ad(i,f);Ab(f);kb=d+16|0;t[e+8|0]=w[e+174|0];v[23540]=0;t[e+127|0]=w[e+173|0];R(663,e+128|0,e+127|0);d=v[23540];v[23540]=0;b:{c:{d:{if((d|0)!=1){v[23540]=0;X(250,e+24|0,e+104|0,e+8|0,e+128|0);d=v[23540];v[23540]=0;if((d|0)!=1){d=e+24|0;Jb(a+1298368|0,d);Ab(d);Ab(e+128|0);f=e+104|0;dc(f);v[a+480208>>2]=12;v[a+1298404>>2]=5;h=a+480188|0;u[h>>1]=x[e+182>>1];u[e+24>>1]=x[e+178>>1];u[e+104>>1]=3999;A=a,C=x[Wc(d,f)>>1],u[A+480190>>1]=C;pU(Wb(v[a+484360>>2],w[a+484376|0]),e+240|0,x[e+176>>1]);d=0;while(1)if(x[h>>1]<=d>>>0){d=e+24|0;ae(d,b,B(x[e+178>>1],80));h=c&2;l=kc(e+104|0,d);Bb(d);g=e+72|0;d=0;e:{f:{while(1){if(x[a+480190>>1]<=d>>>0){n=1;if(c&1){break f}break b}v[23540]=0;R(664,l|0,e+24|0);f=v[23540];v[23540]=0;if((f|0)==1){break e}f=e+8|0;Ii(f,2,g);v[23540]=0;R(222,e+128|0,f|0);f=v[23540];v[23540]=0;if((f|0)==1){break e}d=d+1|0;f=e+128|0;Dc(((d<<5)+a|0)+946304|0,f);zb(f);v[23540]=0;i=f;f=(B(d,104)+a|0)+484380|0;U(665,i|0,e+24|0,f|0);j=v[23540];v[23540]=0;g:{if((j|0)==1){break g}if(!h|!v[f>>2]){continue}v[23540]=0;j=Q(155,b|0,x[e+42>>1]|x[e+44>>1]<<16)|0;i=v[23540];v[23540]=0;if((i|0)==1){break g}if(!j){continue}v[23540]=0;W(219,e+128|0,f|0,b|0)|0;f=v[23540];v[23540]=0;if((f|0)!=1){continue}}break}break e}v[23540]=0;m=a+484344|0;R(225,m|0,x[e+180>>1]);c=v[23540];v[23540]=0;if((c|0)==1){break e}c=e+24|0;r=c|4;s=c|2;o=c|3;y=c|5;z=c|1;p=a+480188|0;a=0;while(1){if(x[e+180>>1]<=a>>>0){break b}v[23540]=0;c=W(226,m|0,a&65535,64)|0;d=v[23540];v[23540]=0;if((d|0)==1){break e}h:{if(!c){break h}c=(a<<1)+e|0;c=w[c+496|0]|w[c+497|0]<<8;if(!c){break h}v[23540]=0;c=Q(155,b|0,c<<4)|0;d=v[23540];v[23540]=0;if((d|0)==1){break e}if(!c){break h}j=0;c=_b(v[m>>2],a);c=jd(v[c>>2],v[v[c+48>>2]+12>>2],0,0);while(1){if(j>>>0>63){break h}d=v[b+8>>2];f=v[b>>2];v[23540]=0;d=W(156,f|0,d|0,1)|0;f=v[23540];v[23540]=0;i:{if((f|0)!=1){if(!d){break h}v[23540]=0;h=S(206,b|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break e}if(h){break i}j=j+1|0;c=B(x[p>>1],6)+c|0;continue}break e}u[e+28>>1]=0;v[e+24>>2]=0;f=h&31;d=B(f,6)+c|0;i=ug(e+24|0);f=f>>>0<x[p>>1];i=f?d:i;j:{if(!(h&32)){break j}v[23540]=0;R(260,e+128|0,b|0);g=v[23540];v[23540]=0;if((g|0)==1){break e}g=w[e+128|0];t[i|0]=g;A=f?d+1|0:z,C=w[Oc(e+128|0)|0],t[A|0]=C;k:{if(g){if((g|0)==254){break k}if(g>>>0<121){break j}}g=0}t[i|0]=g}l:{if(!(h&64)){break l}v[23540]=0;R(260,e+128|0,b|0);g=v[23540];v[23540]=0;if((g|0)==1){break e}g=f?d+5|0:y;q=Oc(e+128|0);t[g|0]=w[q|0];k=w[e+128|0];m:{if(k>>>0<=15){Pf(i,k,w[q|0]);break m}t[(f?d+3|0:o)|0]=k>>>0<=23?w[k+27063|0]:0}i=f?d+3|0:o;k=w[i|0];if((k|0)!=23){if((k|0)!=9){break l}t[i|0]=20;t[e+8|0]=w[g|0]>>>3;t[e+127|0]=1;A=g,C=w[jf(e+8|0,e+127|0)|0]-1&15|128,t[A|0]=C;break l}t[e+8|0]=64;A=g,C=w[Yb(g,e+8|0)|0]<<1,t[A|0]=C}if(!(h&128)){continue}t[(f?d+2|0:s)|0]=1;v[23540]=0;h=S(206,b|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break e}t[(f?d+4|0:r)|0]=h;continue}}a=a+1|0;continue}}d=P()|0;O()|0;Bb(l);break c}else{f=(d<<5)+a|0;df(f+480280|0);u[f+480284>>1]=(w[(d+e|0)+208|0]<<4|4)&244;d=d+1|0;continue}}d=P()|0;O()|0;Ab(e+128|0);break d}d=P()|0;O()|0}dc(e+104|0)}T(d|0);L()}Bb(l)}kb=e+752|0;return n|0}function aja(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,y=0,z=0;g=kb-48|0;kb=g;a:{b:{if(!c){break b}f=Ih(a,b);a=Fb(v[d>>2]);v[g+40>>2]=a;d=Fb(v[d+4>>2]);while(1){if(!Pb(a,d)){break b}zc(a);c:{if((Hj(a)|0)==(c|0)){$b(a,20);d=Hj(a);k=Yf(g+24|0);c=yl(g+16|0,0,b?32:64);v[23540]=0;R(393,f|0,c|0);c=v[23540];v[23540]=0;if((c|0)==1){break c}o=(b|0)==2?4096:(b|0)==1?2048:16384;c=24;d=d+24|0;p=1;l=1;d:{while(1){h=o;while(1){e=v[a+8>>2];i=v[a>>2];v[23540]=0;e=W(156,i|0,e|0,1)|0;i=v[23540];v[23540]=0;e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{if((i|0)!=1){if(!e){break d}e=v[f+4>>2];i=v[f>>2];m=v[a+8>>2];v[23540]=0;v[g+16>>2]=m;m=Q(394,k|0,g+16|0)|0;q=v[23540];v[23540]=0;if((q|0)==1){break a}y=m,z=$d(i,e),v[y>>2]=z;v[23540]=0;e=S(206,a|0)|0;i=v[23540];v[23540]=0;if((i|0)==1){break a}q:{switch(e-128|0){case 3:case 4:case 7:case 8:break e;case 5:case 6:case 9:case 10:break h;case 2:break i;case 1:break j;case 0:break k;default:break q}}r:{switch(e|0){case 0:break g;case 5:break l;case 4:break m;case 3:break n;case 2:break o;case 1:break p;default:break r}}s:{switch(e-160|0){case 3:case 4:break e;case 5:case 6:break h;case 2:break i;case 1:break j;case 0:break k;default:break s}}switch(e-192|0){case 2:break i;case 1:break j;case 0:break k;default:break e}}break a}if(w[f+12|0]&4){break e}v[23540]=0;e=S(271,a|0)|0;i=v[23540];v[23540]=0;t:{if((i|0)==1){break t}v[23540]=0;v[g+16>>2]=e;e=Q(394,k|0,g+16|0)|0;i=v[23540];v[23540]=0;if((i|0)==1){break t}t[f+15|0]=v[e>>2];y=f,z=$d(v[f>>2],v[f+4>>2])-1|0,t[y+16|0]=z;t[f+12|0]=w[f+12|0]|4;break e}break a}v[23540]=0;e=S(271,a|0)|0;i=v[23540];v[23540]=0;if((i|0)==1){break a}u[g+16>>1]=e;u[g+14>>1]=1;e=x[ke(g+16|0,g+14|0)>>1];h=B(e,B(r<<16>>16,l))+h|0;u:{if(e>>>0<2){break u}y=g,z=Al((e+x[Bj(v[f+4>>2])>>1]|0)-1|0),u[y+16>>1]=z;e=pu(b,h);v[23540]=0;t[g+14|0]=e;U(395,f|0,g+16|0,g+14|0);e=v[23540];v[23540]=0;if((e|0)!=1){break u}break a}y=g,z=Al(x[Bj(v[f+4>>2])>>1]+1|0),u[y+16>>1]=z;e=pu(b,h);v[23540]=0;t[g+14|0]=e;U(395,f|0,g+16|0,g+14|0);e=v[23540];v[23540]=0;if((e|0)!=1){break e}break a}v[23540]=0;j=S(206,a|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break a}s=v[a+8>>2];break e}v[23540]=0;e=S(271,a|0)|0;i=v[23540];v[23540]=0;if((i|0)==1){break a}e=c+e|0;v[g+16>>2]=e;if(!(!(j&255)|e>>>0<s>>>0)){j=j-1|0;if(!(j&255)){break f}v[23540]=0;Q(155,a|0,e|0)|0;e=v[23540];v[23540]=0;if((e|0)!=1){break e}break a}if(!(j&255)){break f}v[23540]=0;e=Q(396,k|0,g+16|0)|0;i=v[23540];v[23540]=0;if((i|0)==1){break a}t[f+13|0]=v[e>>2];y=f,z=$d(v[f>>2],v[f+4>>2])-1|0,t[y+14|0]=z;t[f+12|0]=w[f+12|0]|2;break e}p=0;n=1;break e}v[23540]=0;h=S(271,a|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break a}e=pu(b,h);y=Bj(v[f+4>>2]),z=e,t[y+2|0]=z;break e}v[23540]=0;r=S(397,a|0)|0;e=v[23540];v[23540]=0;if((e|0)!=1){break e}break a}v[23540]=0;e=S(206,a|0)|0;l=v[23540];v[23540]=0;if((l|0)!=1){t[g+16|0]=e;t[g+14|0]=1;l=w[jf(g+16|0,g+14|0)|0];break e}break a}v[23540]=0;Q(188,a|0,1)|0;e=v[23540];v[23540]=0;if((e|0)==1){break a}break e}n=1;if(c>>>0<d>>>0){break e}break d}j=0}if(!n|c>>>0>=d>>>0){continue}break}v[23540]=0;c=Q(155,a|0,d|0)|0;h=v[23540];v[23540]=0;if((h|0)==1){break a}if(!c){break d}c=v[a+8>>2];h=v[a>>2];v[23540]=0;c=W(156,h|0,c|0,2)|0;h=v[23540];v[23540]=0;if((h|0)==1){break a}if(!c){break d}h=w[f+12|0];v:{if(!(!(h&4)&p)){c=v[f+4>>2];break v}c=v[f+4>>2];e=v[f>>2];t[f+12|0]=h|4;h=$d(e,c)-1|0;t[f+15|0]=h;t[f+16|0]=h}y=g,z=Al(x[Bj(c)>>1]+1|0),u[y+16>>1]=z;c=pu(b,o);v[23540]=0;t[g+14|0]=c;U(395,f|0,g+16|0,g+14|0);c=v[23540];v[23540]=0;if((c|0)!=1){n=1;t[f+17|0]=w[f+16|0]+1;c=d;continue}break}break a}t[f+12|0]=w[f+12|0]|1;OT(k);break b}a=v[Nf(g+40|0)>>2];continue}break}break a}kb=g+48|0;return}a=P()|0;O()|0;OT(k);T(a|0);L()}function xga(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=kb-224|0;kb=d;zc(b);a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{if(!wo(b,d+208|0)){break l}if(!TR(d+208|0)){break l}g=Kh(d+184|0);h=Nb(d+168|0);Au(d+104|0);v[23540]=0;f=Q(595,b|0,d+96|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break h}m:{if(!f){break m}f=bc(bc(v[d+100>>2])-4|0);while(1){f=bc(bc(f)-8|0);v[d+100>>2]=f;n:{if(c){break n}if((bc(v[d+96>>2])|0)!=1347699796){break n}j=1;break m}v[23540]=0;U(190,d+72|0,b|0,bc(f)|0);f=v[23540];v[23540]=0;if((f|0)==1){break d}e=d+72|0;f=kc(d+8|0,e);Bb(e);e=v[f>>2];v[23540]=0;i=S(178,e|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break b}o:{if(!i){break o}p:{e=bc(v[d+96>>2]);if((e|0)!=1129139796){if((e|0)!=1229866575){if((e|0)==1347699796){break p}if((e|0)!=1447383635){break o}v[23540]=0;Q(188,f|0,4)|0;e=v[23540];v[23540]=0;if((e|0)==1){break b}v[23540]=0;e=S(596,f|0)|0;k=v[23540];v[23540]=0;if((k|0)==1){break b}if(!e){break o}e=bc(v[d+100>>2]);if(e>>>0<7){break o}v[23540]=0;U(597,f|0,h|0,e-6|0);e=v[23540];v[23540]=0;if((e|0)==1){break b}break o}v[23540]=0;l=Q(598,f|0,d+104|0)|0;e=v[23540];v[23540]=0;if((e|0)!=1){break o}break b}tv(g,f);break o}v[23540]=0;j=W(599,a|0,f|0,c|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break b}}Bb(f);q:{if(!i){break q}v[23540]=0;f=Q(595,b|0,d+96|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break i}if(!f){break q}f=v[d+100>>2];continue}break}if(sh(v[h+4>>2],w[h+11|0])){v[23540]=0;b=Q(1,d+72|0,14911)|0;c=v[23540];v[23540]=0;if((c|0)==1){break g}Jb(h,b);Ab(b)}r:{if(!(j&l&1)){break r}b=x[d+146>>1];v[23540]=0;b=Ib(b)&256;W(264,a+1074312|0,5,!b|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break f}c=Ib(x[d+142>>1]);if(c){u[d+8>>1]=64;u[d+56>>1]=c;m=a,n=x[Wc(d+8|0,d+56|0)>>1],v[m+480228>>2]=n}c=!b;b=Ib(x[d+144>>1]);if(!(c|!b)){v[a+480204>>2]=B(b,1e4)}if(w[d+104|0]){b=d+56|0;Ne(b,2,d+104|0);v[23540]=0;R(222,d+8|0,b|0);b=v[23540];v[23540]=0;if((b|0)==1){break e}b=d+8|0;Bc(a+1298308|0,b);zb(b)}c=x[d+150>>1];if(!mq(c,1,12)){break r}f=x[d+148>>1];if(!mq(f,1,31)){break r}e=x[d+154>>1];if(!mq(e,0,23)){break r}i=x[d+156>>1];if(!mq(i,0,59)){break r}k=x[d+158>>1];if(!mq(k,0,59)){break r}b=zo(d+8|0);m=b,n=Ib(x[d+152>>1]),v[m+20>>2]=n;m=b,n=Ib(c)-1|0,v[m+16>>2]=n;m=b,n=Ib(f),v[m+12>>2]=n;m=b,n=Ib(e),v[m+8>>2]=n;m=b,n=Ib(i),v[m+4>>2]=n;m=b,n=Ib(k),v[m>>2]=n;v[23540]=0;R(434,a+1298408|0,b|0);b=v[23540];v[23540]=0;if((b|0)!=1){break r}a=P()|0;O()|0;break a}if(j&1){b=v[g>>2];v[23540]=0;b=S(178,b|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break h}if(b){b=Nb(d+8|0);v[23540]=0;U(268,g|0,b|0,32);c=v[23540];v[23540]=0;if((c|0)==1){break c}if(Aq(b,13756)){v[23540]=0;U(11,d+56|0,14,b|0);c=v[23540];v[23540]=0;if((c|0)==1){break c}c=d+56|0;Jb(a+1298320|0,c);Ab(c)}c=v[g+8>>2];f=v[g>>2];v[23540]=0;c=Q(600,f|0,c|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break c}if(!c){v[23540]=0;c=S(202,g|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break c}v[23540]=0;da(313,a+1298332|0,g|0,c|0,40,0);c=v[23540];v[23540]=0;if((c|0)==1){break c}}zb(b)}v[23540]=0;b=Q(1,d+56|0,17562)|0;c=v[23540];v[23540]=0;if((c|0)==1){break k}v[23540]=0;U(477,d+8|0,b|0,h|0);c=v[23540];v[23540]=0;if((c|0)==1){break j}c=d+8|0;Jb(a+1298368|0,c);Ab(c);Ab(b)}v[a+480208>>2]=v[a+480208>>2]|2097152;v[23540]=0;a=W(264,a+1074312|0,84,1)|0;b=v[23540];v[23540]=0;if((b|0)==1){break h}v[23540]=0;a=W(264,a|0,83,1)|0;b=v[23540];v[23540]=0;if((b|0)==1){break h}v[23540]=0;Q(265,a|0,85)|0;a=v[23540];v[23540]=0;if((a|0)==1){break h}}Ab(h);Bb(g)}kb=d+224|0;return j&1}a=P()|0;O()|0;break a}a=P()|0;O()|0;Ab(b);break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;zb(b);break a}a=P()|0;O()|0;Bb(f)}Ab(h);Bb(g);T(a|0);L()}function KV(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=kb-3056|0;kb=e;zc(b);f=kb-16|0;kb=f;h=e+1096|0;VB(f+8|0,h);i=v[f+12>>2];j=b;nc(f,v[b>>2],v[b+8>>2],v[f+8>>2],v[f+12>>2]);b=v[f+4>>2];if((b|0)==(i|0)){$b(j,v[f+12>>2])}kb=f+16|0;b=(b|0)==(i|0);if(!b){UB(h)}a:{if(!b){break a}if(!WB(e+1096|0)){break a}b:{if(!c){break b}if(!Qb(v[j>>2],v[j+8>>2],Ec(1024,0))){break a}TB(j,e+576|0);TB(j,e- -64|0);while(1){if((g|0)!=128){b=g<<2;f=v[b+(e+576|0)>>2];if(f>>>0>16777215){break a}b=v[b+(e- -64|0)>>2];if(b-4097>>>0<4294963202){break a}g=g+1|0;if(tr(v[j>>2],(b+f|0)+2978|0)){continue}break a}break}Cd(a,2);ag(a);b=e+40|0;d=yc(b,13863);Jb(a+1298344|0,d);Ab(d);d=yc(b,14785);Jb(a+1298356|0,d);Ab(d);b=yc(b,15533);Jb(a+1298368|0,b);Ab(b);v[a+1298404>>2]=5;b=w[e+1096|0];v[a+480204>>2]=143e4;v[a+480196>>2]=b;Ve(Wb(v[a+484360>>2],w[a+484376|0]),w[e+1097|0]);v[a+480188>>2]=4194317;Ob(a+1074312|0,95,1);v[a+480208>>2]=v[a+480208>>2]|16777216;d=0;g=0;while(1){if((g|0)==4){c:{while(1){d:{if((d|0)==32){g=0;break d}b=d+1|0;g=B(b,104)+a|0;i=g+484380|0;nd(i,2);h=e+16|0;$h(h,1,(B(d,13)+e|0)+1098|0);f=e+40|0;Fc(f,h);Dc(((b<<5)+a|0)+946304|0,f);zb(f);d=(e+1096|0)+(d<<4)|0;f=w[d+422|0]|w[d+423|0]<<8|(w[d+424|0]<<16|w[d+425|0]<<24);v[i>>2]=f;h=f;f=w[d+430|0]|w[d+431|0]<<8|(w[d+432|0]<<16|w[d+433|0]<<24);if(h>>>0>=f>>>0){d=w[d+426|0]|w[d+427|0]<<8|(w[d+428|0]<<16|w[d+429|0]<<24);u[g+484414>>1]=2;v[g+484388>>2]=f;v[g+484384>>2]=d}v[g+484404>>2]=8287;d=b;continue}break}while(1){if((g|0)!=32){d=g+33|0;f=(B(d,104)+a|0)+484380|0;nd(f,2);i=e+16|0;$h(i,1,(B(g,13)+e|0)+2026|0);b=e+40|0;Fc(b,i);Dc(((d<<5)+a|0)+946304|0,b);zb(b);v[e+48>>2]=0;v[e+40>>2]=0;v[e+44>>2]=0;d=(e+1096|0)+B(g,11)|0;o=Lb(b,0),p=w[d+1347|0],t[o|0]=p;o=Lb(b,1),p=w[d+1352|0],t[o|0]=p;o=Lb(b,2),p=w[d+1348|0],t[o|0]=p;o=Lb(b,3),p=w[d+1353|0],t[o|0]=p;o=Lb(b,4),p=w[d+1349|0],t[o|0]=p;o=Lb(b,5),p=w[d+1354|0],t[o|0]=p;o=Lb(b,6),p=w[d+1350|0],t[o|0]=p;o=Lb(b,7),p=w[d+1355|0],t[o|0]=p;o=Lb(b,8),p=w[d+1351|0],t[o|0]=p;o=Lb(b,9),p=w[d+1356|0],t[o|0]=p;o=Lb(b,10),p=w[d+1346|0],t[o|0]=p;v[e+8>>2]=v[e+48>>2];b=v[e+44>>2];v[e>>2]=v[e+40>>2];v[e+4>>2]=b;Dl(f,1,e);g=g+1|0;continue}break}Xq(Wb(v[a+484360>>2],w[a+484376|0]),e+2794|0,256,255,65535);l=a+484344|0;xg(l,128);m=c&1;f=0;while(1){e:{f:{if((f|0)!=128){b=f<<2;dd(j,v[b+(e+576|0)>>2]+2978|0);d=e+16|0;ae(d,j,v[b+(e- -64|0)>>2]);b=kc(e+40|0,d);Bb(d);if(!m){break e}v[23540]=0;d=W(226,l|0,f&65535,64)|0;g=v[23540];v[23540]=0;if((g|0)==1){break c}if(!d){break e}g=0;i=_b(v[l>>2],f);while(1){if(g>>>0>63){break e}g:{while(1){h:{d=v[b>>2];v[23540]=0;d=W(156,d|0,v[e+48>>2],1)|0;h=v[23540];v[23540]=0;if((h|0)==1){break h}if(!d){break e}v[23540]=0;d=S(206,b|0)|0;h=v[23540];v[23540]=0;if((h|0)==1){break c}if(d>>>0>12){break g}h=jd(v[i>>2],v[v[i+48>>2]+12>>2],g,d);v[23540]=0;R(260,e+16|0,b|0);k=v[23540];v[23540]=0;if((k|0)==1){break c}k=w[e+16|0];d=d>>>0>3;t[h|0]=((k&15)+(d?13:37)|0)+B(k>>>4&7,12);k=Oc(e+16|0);t[h+1|0]=((w[k|0]>>>4|0)+(d?33:1)|0)+(w[e+16|0]>>>3&16);SB(h,w[k|0],d);continue}break}break c}h=d-32|0;if((h&255)>>>0<=12){h=jd(v[i>>2],v[v[i+48>>2]+12>>2],g,h&65535);v[23540]=0;k=S(206,b|0)|0;n=v[23540];v[23540]=0;if((n|0)==1){break c}SB(h,k,d>>>0>35);continue}if((d|0)!=64){if((d|0)!=96){break f}if(!g){break e}o=jd(v[i>>2],v[v[i+48>>2]+12>>2],g-1|0,0),p=14,t[o+3|0]=p;break e}v[23540]=0;d=S(206,b|0)|0;h=v[23540];v[23540]=0;if((h|0)==1){break c}g=d+g|0;continue}}d=1;if(!(c&2)){break a}while(1){if((d|0)==33){break b}wg(Zc(e+40|0,8,1,0,1),(B(d,104)+a|0)+484380|0,j);d=d+1|0;continue}}Bb(b);d=0;break a}Bb(b);f=f+1|0;continue}}}else{u[((g<<5)+a|0)+480284>>1]=g&1?192:64;g=g+1|0;continue}break}a=P()|0;O()|0;Bb(b);T(a|0);L()}d=1}kb=e+3056|0;return d|0}function w$(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0;h=kb-32|0;kb=h;v[h+24>>2]=b;v[e>>2]=0;b=h+8|0;gd(b,d);v[23540]=0;b=S(19,b|0)|0;i=v[23540];v[23540]=0;a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{z:{A:{if((i|0)!=1){ac(h+8|0);switch(g-65|0){case 54:break j;case 19:break k;case 18:break l;case 17:break m;case 49:break n;case 47:break o;case 45:case 51:break p;case 12:break q;case 44:break r;case 41:break s;case 8:break t;case 7:break u;case 5:break v;case 3:break w;case 35:case 36:break x;case 34:break y;case 1:case 33:case 39:break z;case 0:case 32:break A;case 2:case 4:case 6:case 9:case 10:case 11:case 13:case 14:case 15:case 16:case 20:case 21:case 22:case 25:case 26:case 27:case 28:case 29:case 30:case 31:case 37:case 38:case 40:case 42:case 43:case 46:case 48:case 50:case 52:case 53:break d;case 24:break f;case 56:break g;case 23:break h;case 55:break i;default:break e}}a=P()|0;O()|0;ac(h+8|0);T(a|0);L()}qG(a,f+24|0,h+24|0,c,e,b);break b}pG(a,f+16|0,h+24|0,c,e,b);break b}b=ob[v[v[a+8>>2]+12>>2]](a+8|0)|0;g=a;i=v[h+24>>2];a=Mc(b);j=h,k=$j(g,i,c,d,e,f,a,Hb(b)+a|0),v[j+24>>2]=k;break b}a=Wi(h+24|0,c,e,b,2);b=v[e>>2];B:{if(!(b&4|a-1>>>0>30)){v[f+12>>2]=a;break B}v[e>>2]=b|4}break b}v[h+8>>2]=623865125;v[h+12>>2]=2032480100;j=h,k=$j(a,v[h+24>>2],c,d,e,f,h+8|0,h+16|0),v[j+24>>2]=k;break b}v[h+8>>2]=623728933;v[h+12>>2]=1680158061;j=h,k=$j(a,v[h+24>>2],c,d,e,f,h+8|0,h+16|0),v[j+24>>2]=k;break b}a=Wi(h+24|0,c,e,b,2);b=v[e>>2];C:{if(!(b&4|(a|0)>23)){v[f+8>>2]=a;break C}v[e>>2]=b|4}break b}a=Wi(h+24|0,c,e,b,2);b=v[e>>2];D:{if(!(b&4|a-1>>>0>11)){v[f+8>>2]=a;break D}v[e>>2]=b|4}break b}a=Wi(h+24|0,c,e,b,3);b=v[e>>2];E:{if(!(b&4|(a|0)>365)){v[f+28>>2]=a;break E}v[e>>2]=b|4}break b}a=Wi(h+24|0,c,e,b,2);b=v[e>>2];F:{if(!(b&4|(a|0)>12)){v[f+16>>2]=a-1;break F}v[e>>2]=b|4}break b}a=Wi(h+24|0,c,e,b,2);b=v[e>>2];G:{if(!(b&4|(a|0)>59)){v[f+4>>2]=a;break G}v[e>>2]=b|4}break b}a=h+24|0;d=kb-16|0;kb=d;v[d+8>>2]=c;while(1){H:{if(!rp(a,d+8|0)){break H}c=Zk(v[a>>2]);if(!vh(v[b+8>>2],8192,c)){break H}em(a);continue}break}if(bj(a,d+8|0)){v[e>>2]=v[e>>2]|2}kb=d+16|0;break b}d=h+24|0;a=ob[v[v[a+8>>2]+8>>2]](a+8|0)|0;I:{if((Hb(a)|0)==(0-Hb(a+12|0)|0)){v[e>>2]=v[e>>2]|4;break I}c=Ur(d,c,a,a+24|0,b,e,0);b=v[f+8>>2];if(!((c|0)!=(a|0)|(b|0)!=12)){v[f+8>>2]=0;break I}if(!((c-a|0)!=12|(b|0)>11)){v[f+8>>2]=b+12}}break b}b=w[83848]|w[83849]<<8|(w[83850]<<16|w[83851]<<24);t[h+15|0]=b;t[h+16|0]=b>>>8;t[h+17|0]=b>>>16;t[h+18|0]=b>>>24;b=w[83845]|w[83846]<<8|(w[83847]<<16|w[83848]<<24);v[h+8>>2]=w[83841]|w[83842]<<8|(w[83843]<<16|w[83844]<<24);v[h+12>>2]=b;j=h,k=$j(a,v[h+24>>2],c,d,e,f,h+8|0,h+19|0),v[j+24>>2]=k;break b}t[h+12|0]=w[83856];v[h+8>>2]=w[83852]|w[83853]<<8|(w[83854]<<16|w[83855]<<24);j=h,k=$j(a,v[h+24>>2],c,d,e,f,h+8|0,h+13|0),v[j+24>>2]=k;break b}a=Wi(h+24|0,c,e,b,2);b=v[e>>2];J:{if(!(b&4|(a|0)>60)){v[f>>2]=a;break J}v[e>>2]=b|4}break b}v[h+8>>2]=624576549;v[h+12>>2]=1394948685;j=h,k=$j(a,v[h+24>>2],c,d,e,f,h+8|0,h+16|0),v[j+24>>2]=k;break b}a=Wi(h+24|0,c,e,b,1);b=v[e>>2];K:{if(!(b&4|(a|0)>6)){v[f+24>>2]=a;break K}v[e>>2]=b|4}break b}a=ob[v[v[a>>2]+20>>2]](a,v[h+24>>2],c,d,e,f)|0;break a}b=ob[v[v[a+8>>2]+24>>2]](a+8|0)|0;g=a;i=v[h+24>>2];a=Mc(b);j=h,k=$j(g,i,c,d,e,f,a,Hb(b)+a|0),v[j+24>>2]=k;break b}oG(f+20|0,h+24|0,c,e,b);break b}a=Wi(h+24|0,c,e,b,4);if(!(w[e|0]&4)){v[f+20>>2]=a-1900}break b}if((g|0)==37){break c}}v[e>>2]=v[e>>2]|4;break b}a=kb-16|0;kb=a;v[a+8>>2]=c;c=6;d=h+24|0;L:{M:{if(bj(d,a+8|0)){break M}c=4;if((xn(b,Zk(v[d>>2]))|0)!=37){break M}c=2;if(!bj(em(d),a+8|0)){break L}}v[e>>2]=v[e>>2]|c}kb=a+16|0}a=v[h+24>>2]}kb=h+32|0;return a|0}function ega(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,y=0;e=kb-256|0;kb=e;zc(b);a:{if(!cV(b,e+184|0)){break a}if(!KR(e+184|0)){break a}if(!Qb(v[b>>2],v[b+8>>2],Ec(JR(e+184|0),nb))){break a}b:{if(!c){break b}Cd(a,16);f=e+24|0;Dj(f,2,e+184|4);d=e+48|0;Fc(d,f);Bc(a+1298308|0,d);zb(d);l=a+480190|0;u[l>>1]=w[e+214|0];u[a+480188>>1]=w[e+217|0];g=yc(d,8394);Jb(a+1298344|0,g);Ab(g);g=yc(d,10148);Jb(a+1298356|0,g);Ab(g);Sf(f,4214);g=w[e+187|0];v[e>>2]=g>>>4;v[23540]=0;v[e+180>>2]=g&15;X(302,d|0,f|0,e|0,e+180|0);d=v[23540];v[23540]=0;c:{d:{e:{if((d|0)!=1){d=e+48|0;Jb(a+1298368|0,d);Ab(d);dc(e+24|0);v[a+1298404>>2]=5;g=1;while(1){j=g&65535;if(j>>>0>x[l>>1]){g=0;d=a+480188|0;while(1)if(x[d>>1]<=g>>>0){f=e+48|0;d=kb-16|0;kb=d;h=b;f:{if(!Qb(v[b>>2],v[b+8>>2],128)){b=0;while(1){if((b|0)!=128){Eh(b+f|0);b=b+1|0;continue}break}break f}$S(d+8|0,f);ud(d,h,v[d+8>>2],v[d+12>>2])}kb=d+16|0;fv(Wb(v[a+484360>>2],w[a+484376|0]),f,w[e+211|0]+1|0);b=w[e+216|0];ae(e,h,B(x[e+208>>1],192));i=kc(e+24|0,e);Bb(e);n=c&1;if(n){v[23540]=0;R(225,a+484344|0,w[e+210|0]+1|0);d=v[23540];v[23540]=0;if((d|0)==1){break d}}o=b?b:64;p=a+484344|0;q=a+480188|0;while(1){if(w[e+210|0]<m>>>0){b=x[e+212>>1];if(b){v[23540]=0;da(313,a+1298332|0,h|0,b|0,39,1);b=v[23540];v[23540]=0;if((b|0)==1){break d}}if(!(c&2)){break e}g=1;b=a+480190|0;while(1){c=g&65535;if(c>>>0>x[b>>1]){break e}c=B(c,104)+a|0;d=Zc(e,u[c+484414>>1]&1?16:8,1,0,1);v[23540]=0;W(219,d|0,c+484380|0,h|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){g=g+1|0;continue}break}break d}g:{h:{if(n){v[23540]=0;b=W(226,p|0,m&65535,o|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break d}k=0;if(b){break h}}v[23540]=0;Q(188,h|0,64)|0;b=v[23540];v[23540]=0;if((b|0)!=1){break g}break d}while(1){d=k&65535;if(d>>>0>31){break g}v[23540]=0;b=S(194,h|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break d}i:{if(!b|b>>>0>x[e+208>>1]|d>>>0>=x[q>>1]){break i}v[23540]=0;Q(155,i|0,B(b,192)-192|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break d}l=0;b=_b(v[p>>2],m);g=jd(v[b>>2],v[v[b+48>>2]+12>>2],0,d);while(1){if((l|0)==(o|0)){break i}v[23540]=0;R(534,e|0,i|0);b=v[23540];v[23540]=0;if((b|0)!=1){j=Oc(e);d=Te(e);b=w[e|0];if(b>>>0>=4){t[g|0]=(b>>>2|0)+37;b=w[e|0]}t[g+1|0]=b<<4&48|w[j|0]>>>4;b=w[d|0];d=0;f=0;j:{k:{l:{m:{n:{o:{j=w[j|0]&15;switch(j-8|0){case 0:break l;case 6:break n;case 2:break o;default:break m}}b=(b&240?-16:15)&b;j=10;break k}j=14;r=(b+16&240)>>>4|0;if(r>>>0>8){break k}if(1<<r&435){break l}break k}d=j;f=b}j=d;b=f;if(!((d|b)&255)){break j}}Pf(g,j,b&255)}l=l+1|0;g=B(x[q>>1],6)+g|0;continue}break}break d}k=k+1|0;continue}}m=m+1|0;continue}}else{f=(g<<5)+a|0;df(f+480280|0);u[f+480284>>1]=(w[(e+g|0)+218|0]<<4|8)&248;g=g+1|0;continue}}else{f=e+48|0;IC(b,f);h=kb-16|0;kb=h;d=(B(j,104)+a|0)+484380|0;nd(d,0);u[h+14>>1]=w[f+35|0]<<2;u[h+12>>1]=256;s=d,y=x[Wc(h+14|0,h+12|0)>>1],u[s+30>>1]=y;i=w[f+22|0]|w[f+23|0]<<8|(w[f+24|0]<<16|w[f+25|0]<<24);p:{if(i>>>0<3){break p}v[d>>2]=i;v[d+4>>2]=w[f+26|0]|w[f+27|0]<<8|(w[f+28|0]<<16|w[f+29|0]<<24);v[h+8>>2]=w[f+30|0]|w[f+31|0]<<8|(w[f+32|0]<<16|w[f+33|0]<<24);v[h+4>>2]=1;s=d,y=v[_c(h+8|0,h+4|0)>>2]-1|0,v[s+8>>2]=y;xc(d+8|0,i);k=v[d+8>>2];i=v[d+4>>2];q:{if(k>>>0<=i+4>>>0){v[d+4>>2]=0;v[d+8>>2]=0;k=0;i=0;break q}u[d+34>>1]=x[d+34>>1]|2;k=k>>>1|0;i=i>>>1|0}t[d+37|0]=w[f+34|0];s=d,y=Wu(0,t[f+34|0]<<4),v[s+24>>2]=y;if(!(t[f+36|0]&1)){break p}v[d+8>>2]=k;v[d+4>>2]=i;u[d+34>>1]=x[d+34>>1]|1;v[d>>2]=v[d>>2]>>>1}kb=h+16|0;Fl(e,2,f);d=e+24|0;Fc(d,e);Dc(((j<<5)+a|0)+946304|0,d);g=g+1|0;zb(d);continue}}}g=P()|0;O()|0;dc(e+24|0);break c}v[a+480260>>2]=64;v[a+480264>>2]=32767;Bb(i);break b}g=P()|0;O()|0;Bb(i)}T(g|0);L()}g=1}kb=e+256|0;return g|0}function ck(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,k=0,m=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;k=1;o(+b);f=j(1)|0;d=j(0)|0;a:{b:{m=f&2147483647;g=d;c:{if(!(m|d)){break c}o(+a);d=j(1)|0;t=j(0)|0;if(!t&(d|0)==1072693248){break c}q=d&2147483647;if(!(!(q>>>0>2146435072|(q|0)==2146435072&(t|0)!=0|m>>>0>2146435072)&(!g|(m|0)!=2146435072))){return a+b}d:{e:{f:{r=0;g:{if((d|0)>0|(d|0)>=0){break g}r=2;if(m>>>0>1128267775){break g}r=0;if(m>>>0<1072693248){break g}h=m>>>20|0;if(m>>>0<1094713344){break f}e=1075-h|0;h=g>>>e|0;r=0;if((g|0)!=h<<e){break g}r=2-(h&1)|0}e=r;if(!g){break e}break d}if(g){break d}g=1043-h|0;h=m>>>g|0;e=0;if((m|0)!=h<<g){break e}e=2-(h&1)|0}if((m|0)==2146435072){if(!(q-1072693248|t)){break c}if(q>>>0>=1072693248){return(f|0)>0|(f|0)>=0?b:0}return(f|0)>0|(f|0)>=0?0:-b}if((m|0)==1072693248){if((f|0)>0|(f|0)>=0){return a}return 1/a}if((f|0)==1073741824){return a*a}if((f|0)!=1071644672|(d|0)<0){break d}return K(a)}c=D(a);h:{if(t){break h}i:{if((d|0)<0){if((d|0)==-2147483648|(d|0)==-1074790400){break i}if((d|0)!=-1048576){break h}break i}if(!d|(d|0)==2146435072){break i}if((d|0)!=1072693248){break h}}k=(f|0)<0?1/c:c;if((d|0)>0|(d|0)>=0){break c}if(!(q-1072693248|e)){a=k-k;return a/a}return(e|0)==1?-k:k}j:{if((d|0)>0|(d|0)>=0){break j}k:{switch(e|0){case 0:a=a-a;return a/a;case 1:break k;default:break j}}k=-1}l:{if(m>>>0>=1105199105){if(m>>>0>=1139802113){if(q>>>0<=1072693247){return(f|0)<0?N:0}return(f|0)>0?N:0}if(q>>>0<=1072693246){return(f|0)<0?k*1e300*1e300:k*1e-300*1e-300}if(q>>>0>=1072693249){return(f|0)>0?k*1e300*1e300:k*1e-300*1e-300}a=c+-1;c=a*1.9259629911266175e-8+a*a*(.5-a*(a*-.25+.3333333333333333))*-1.4426950408889634;i=c;c=a*1.4426950216293335;o(+(i+c));e=j(1)|0;j(0)|0;l(0,0);l(1,e|0);a=+n();c=i-(a-c);break l}a=c*9007199254740992;g=q>>>0<1048576;c=g?a:c;o(+a);e=j(1)|0;j(0)|0;h=g?e:q;d=h&1048575;e=d|1072693248;h=(h>>20)+(g?-1076:-1023)|0;g=0;m:{if(d>>>0<235663){break m}if(d>>>0<767610){g=1;break m}e=d|1071644672;h=h+1|0}d=g<<3;w=A[d+3536>>3];o(+c);j(1)|0;q=0;l(0,j(0)|q);l(1,e|0);p=+n();s=A[d+3520>>3];i=p-s;u=1/(s+p);c=i*u;o(+c);m=j(1)|0;j(0)|0;l(0,0);l(1,m|0);a=+n();x=a;l(0,q|0);l(1,((g<<18)+(e>>>1|0)|0)+537395200|0);v=a*a;y=i;i=+n();p=u*(y-a*i-a*(p-(i-s)));i=p*(c+a);a=c*c;s=i+a*a*(a*(a*(a*(a*(a*.20697501780033842+.23066074577556175)+.272728123808534)+.33333332981837743)+.4285714285785502)+.5999999999999946);o(+(v+3+s));e=j(1)|0;j(0)|0;l(0,0);l(1,e|0);a=+n();i=x*a;c=p*a+c*(s-(a+-3-v));o(+(i+c));e=j(1)|0;j(0)|0;l(0,0);l(1,e|0);a=+n();c=w+(a*-7.028461650952758e-9+(c-(a-i))*.9617966939259756);i=c;p=A[d+3552>>3];c=a*.9617967009544373;s=+(h|0);o(+(p+(i+c)+s));e=j(1)|0;j(0)|0;l(0,0);l(1,e|0);a=+n();c=i-(a-s-p-c)}l(0,0);l(1,f|0);p=+n();c=(b-p)*a+c*b;b=a*p;a=c+b;o(+a);d=j(1)|0;e=j(0)|0;n:{f=d;if((d|0)>=1083179008){if(e|f-1083179008){break b}if(!(c+8.008566259537294e-17>a-b)){break n}break b}if((f&2147482624)>>>0<1083231232){break n}if(e|f+1064252416){break a}if(!(c<=a-b)){break n}break a}g=0;h=f&2147483647;if(h>>>0>=1071644673){e=f+(1048576>>>(h>>>20|0)-1022|0)|0;f=e>>>20&2047;g=(e&1048575|1048576)>>>1043-f|0;g=(d|0)<0?0-g|0:g;l(0,0);l(1,e&-1048576>>f-1023);b=b-+n();o(+(c+b));d=j(1)|0;j(0)|0}l(0,0);l(1,d|0);a=+n();p=a*.6931471824645996;c=(c-(a-b))*.6931471805599453+a*-1.904654299957768e-9;a=p+c;b=a*a;b=a-b*(b*(b*(b*(b*4.1381367970572385e-8+-16533902205465252e-22)+6613756321437934e-20)+-.0027777777777015593)+.16666666666666602);i=a*b/(b+-2);b=a;a=c-(a-p);a=b-(i-(b*a+a))+1;o(+a);e=j(1)|0;d=j(0)|0;e=(g<<20)+e|0;o:{if((e|0)<=1048575){a=Wj(a,g);break o}l(0,d|0);l(1,e|0);a=+n()}k=k*a}return k}return k*1e300*1e300}return k*1e-300*1e-300}function Pia(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=kb-736|0;kb=h;a:{b:{if(d>>>0<=511){a=kb-16|0;kb=a;e=h+56|0;gc(a+8|0,e,554);d=v[a+12>>2];nc(a,v[b>>2],v[b+8>>2],v[a+8>>2],v[a+12>>2]);f=v[a+4>>2];if((f|0)==(d|0)){$b(b,v[a+12>>2])}kb=a+16|0;a=(d|0)==(f|0);if(!a){Ub(e,0,554)}if(!a){break b}d=kb-32|0;kb=d;c:{a=h+56|0;if(Sb(a,14020,4)){break c}dr(d,a+32|0);b=d+16|0;Fc(b,d);Dc(c+492|0,b);zb(b);$h(d,1,a+4|0);Fc(b,d);Dc(c+524|0,b);zb(b);b=w[a+24|0]|w[a+25|0]<<8;v[c+4>>2]=64;v[c+8>>2]=128;v[c>>2]=b<<6;t[c+16|0]=w[a+26|0];t[c+17|0]=w[a+27|0];f=c+108|0;g=c+236|0;b=0;while(1)if((b|0)==120){b=w[c+60|0]&-2|t[a+17|0]&1;t[c+60|0]=b;b=b&-3|w[a+17|0]&2;t[c+60|0]=b;t[c+60|0]=b&251|w[a+17|0]&4;g=c+61|0;t[g|0]=w[a+18|0];i=c+62|0;t[i|0]=w[a+19|0];j=c+63|0;t[j|0]=w[a+20|0];k=c- -64|0;t[k|0]=w[a+21|0];f=c+48|0;Qg(f,25);e=v[c+48>>2];b=0;while(1){d:{if((b|0)!=25){l=Eb(e,b);m=b<<1;n=w[(a+m|0)+504|0];u[l>>1]=n;if((n|0)!=255){break d}Qg(f,b);e=v[f>>2]}b=jf(g,i);a=$d(e,v[c+52>>2]);if(a>>>0<=w[b|0]){t[c+60|0]=w[c+60|0]&253}if(a>>>0>w[jf(j,k)|0]){break c}t[c+60|0]=w[c+60|0]&251;break c}t[l+2|0]=w[(a+(m|1)|0)+504|0];b=b+1|0;continue}}else{i=a+(b<<1)|0;e=w[i- -64|0];o=cc(g,b),p=w[i+65|0],u[o>>1]=p;o=Lb(f,b),p=(e>>>0<120?e:b)+1|0,t[o|0]=p;b=b+1|0;continue}}kb=d+32|0;break b}i=v[b+8>>2];d=kb-32|0;kb=d;v[d+28>>2]=674;v[d+8>>2]=674;e=v[b>>2];g=v[b+8>>2];f=v[Kb(d+28|0,d+8|0)>>2];if(!Qb(e,g,f)){f=cf(b)}j=d+8|0;e=h+56|0;AT(j,e);g=hc(d+16|0,v[d+8>>2],f);nc(d,v[b>>2],v[b+8>>2],v[g>>2],v[g+4>>2]);AT(j,e);Ub(v[d+8>>2]+f|0,0,674-f|0);$b(b,v[d+28>>2]);kb=d+32|0;f=v[a+480180>>2];a=0;d=kb-32|0;kb=d;if(!Sb(e,14020,4)){dr(d,e+32|0);a=d+16|0;Fc(a,d);Dc(c+492|0,a);zb(a);$h(d,1,e+4|0);Fc(a,d);Dc(c+524|0,a);zb(a);v[c>>2]=(w[e+20|0]|w[e+21|0]<<8)<<5;v[c+4>>2]=w[e+24|0]>>>1;xc(c+4|0,64);g=w[e+25|0]&127;v[c+8>>2]=g>>>0>64?128:g<<2;t[c+15|0]=w[c+15|0]&254|((w[e+25|0]^-1)&128)>>>7;t[d+16|0]=w[e+26|0];t[d|0]=100;o=c,p=w[Yb(a,d)|0],t[o+20|0]=p;t[d+16|0]=w[e+27|0];t[d|0]=64;o=c,p=w[Yb(a,d)|0],t[o+19|0]=p;t[c+16|0]=w[e+17|0];t[c+17|0]=w[e+18|0];t[c+18|0]=w[e+19|0];t[c+26|0]=w[e+22|0];t[c+27|0]=w[e+23|0];a=w[e+58|0];Mj(c,a&127,a>>>7|0);a=w[e+59|0];Lj(c,a&127,a>>>7|0);e:{f:{g:{h:{i:{j:{a=w[e+28|0]|w[e+29|0]<<8;switch(a-529|0){case 1:case 2:break h;case 0:case 3:break i;default:break j}}if((a|0)==544){break i}if((a|0)!=514){break h}}a=w[e+61|0];if((a|0)==255){break g}if(a>>>0<=128){t[c+30|0]=a}a=w[e+62|0]|w[e+63|0]<<8;if(a>>>0<129){break f}break e}a=t[e+61|0];if((a|0)<0){break g}t[c+30|0]=a+1}a=w[e+62|0];a=a<<24>>24>=0?a+1|0:0;g=t[e+63|0];if((g|0)<0){break f}a=((g&255)<<7)+a|0}u[c+28>>1]=a}a=t[e+60|0];t[c+31|0]=a;if((a|0)<0){t[c+31|0]=0;t[c+34|0]=a^128}a=0;f=f&16777216?240:25;qv(e+304|0,c+48|0,0,f);qv(e+386|0,c+68|0,32,f);qv(e+468|0,c+88|0,32,f);t[c+100|0]=w[c+100|0]&239|w[e+468|0]>>>3&16;g=c+108|0;j=c+236|0;while(1){if((a|0)!=120){k=e+(a<<1)|0;f=w[k- -64|0];o=cc(j,a),p=w[k+65|0],u[o>>1]=p;o=Lb(g,a),p=(f>>>0<120?f:a)+1|0,t[o|0]=p;a=a+1|0;continue}break}a=554}kb=d+32|0;d=0;k:{if(!a){break k}d=e+550|0;l:{if(Sb(d,13496,4)){if(Sb(d,13848,4)){break l}}d=c+236|0;a=0;while(1){if((a|0)!=120){f=cc(d,a);u[f>>1]=x[f>>1]|w[(a+e|0)+554|0]<<8;a=a+1|0;continue}break}a=674}d=a}dd(b,d+i|0);if(!Hh(b,14025)){break b}d=h+8|0;ae(d,b,Bg(b));a=kc(h+32|0,d);Bb(d);b=v[a>>2];v[23540]=0;S(160,b|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break a}v[23540]=0;b=Q(402,a|0,13771)|0;d=v[23540];v[23540]=0;if((d|0)==1){break a}if(b){v[23540]=0;b=S(206,a|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break a}t[c+34|0]=b>>>0>250?0:b}Bb(a)}kb=h+736|0;return}b=P()|0;O()|0;Bb(a);T(b|0);L()}function FK(){var a=0,b=0,c=0,d=0,e=0,f=0;if(w[468112]){return v[117027]}b=Vd(469752);v[b>>2]=84056;c=b+8|0;v[c>>2]=0;v[c+4>>2]=0;e=Gc(c+8|0),f=0,t[e+128|0]=f;if(th(1073741823)>>>0<=29){cd();L()}a=UF(rw(c),30);v[c>>2]=a;v[c+4>>2]=a;e=Gb(c),f=a+120|0,v[e>>2]=f;At(c,30);v[23540]=0;d=Q(55,b+152|0,14318)|0;a=v[23540];v[23540]=0;a:{b:{c:{if((a|0)!=1){Lc(c);Vd(469424);v[117356]=85612;v[23540]=0;Y(1173,b|0);a=v[23540];v[23540]=0;if((a|0)==1){break c}Vd(469432);v[117358]=85644;v[23540]=0;Y(1174,b|0);a=v[23540];v[23540]=0;if((a|0)==1){break c}a=Vd(469440);t[a+12|0]=0;v[a+8>>2]=0;v[a>>2]=84076;v[a+8>>2]=80016;v[23540]=0;Y(1175,b|0);a=v[23540];v[23540]=0;if((a|0)==1){break c}Vd(469456);v[117364]=84560;v[23540]=0;Y(1176,b|0);a=v[23540];v[23540]=0;if((a|0)==1){break c}Vd(469464);v[117366]=84708;v[23540]=0;Y(1177,b|0);a=v[23540];v[23540]=0;if((a|0)==1){break c}v[23540]=0;Z(1178);a=v[23540];v[23540]=0;if((a|0)==1){break c}v[23540]=0;Y(1179,b|0);a=v[23540];v[23540]=0;if((a|0)==1){break c}Vd(469488);v[117372]=84856;v[23540]=0;Y(1180,b|0);a=v[23540];v[23540]=0;if((a|0)==1){break c}Vd(469496);v[117374]=85088;v[23540]=0;Y(1181,b|0);a=v[23540];v[23540]=0;if((a|0)==1){break c}Vd(469504);v[117376]=84972;v[23540]=0;Y(1182,b|0);a=v[23540];v[23540]=0;if((a|0)==1){break c}Vd(469512);v[117378]=85204;v[23540]=0;Y(1183,b|0);a=v[23540];v[23540]=0;if((a|0)==1){break c}a=Vd(469520);u[a+8>>1]=11310;v[a>>2]=84176;Nb(a+12|0);v[23540]=0;Y(1184,b|0);a=v[23540];v[23540]=0;if((a|0)==1){break c}a=Vd(469544);v[a+8>>2]=46;v[a+12>>2]=44;v[a>>2]=84216;Nb(a+16|0);v[23540]=0;Y(1185,b|0);a=v[23540];v[23540]=0;if((a|0)==1){break c}Vd(469576);v[117394]=85676;v[23540]=0;Y(1186,b|0);a=v[23540];v[23540]=0;if((a|0)==1){break c}Vd(469584);v[117396]=85920;v[23540]=0;Y(1187,b|0);a=v[23540];v[23540]=0;if((a|0)==1){break c}Vd(469592);v[117398]=86132;v[23540]=0;Y(1188,b|0);a=v[23540];v[23540]=0;if((a|0)==1){break c}Vd(469600);v[117400]=86364;v[23540]=0;Y(1189,b|0);a=v[23540];v[23540]=0;if((a|0)==1){break c}Vd(469608);v[117402]=87348;v[23540]=0;Y(1190,b|0);a=v[23540];v[23540]=0;if((a|0)==1){break c}Vd(469616);v[117404]=87496;v[23540]=0;Y(1191,b|0);a=v[23540];v[23540]=0;if((a|0)==1){break c}Vd(469624);v[117406]=87612;v[23540]=0;Y(1192,b|0);a=v[23540];v[23540]=0;if((a|0)==1){break c}Vd(469632);v[117408]=87728;v[23540]=0;Y(1193,b|0);a=v[23540];v[23540]=0;if((a|0)==1){break c}Vd(469640);v[117410]=87844;v[23540]=0;Y(1194,b|0);a=v[23540];v[23540]=0;if((a|0)==1){break c}Vd(469648);v[117412]=88008;v[23540]=0;Y(1195,b|0);a=v[23540];v[23540]=0;if((a|0)==1){break c}Vd(469656);v[117414]=88172;v[23540]=0;Y(1196,b|0);a=v[23540];v[23540]=0;if((a|0)==1){break c}Vd(469664);v[117416]=88336;v[23540]=0;Y(1197,b|0);a=v[23540];v[23540]=0;if((a|0)==1){break c}Vd(469672);v[117420]=89592;v[117420]=86612;v[117418]=86564;v[23540]=0;Y(1198,b|0);a=v[23540];v[23540]=0;if((a|0)==1){break c}Vd(469688);v[117424]=89628;v[117424]=86876;v[117422]=86828;v[23540]=0;Y(1199,b|0);a=v[23540];v[23540]=0;if((a|0)==1){break c}v[23540]=0;Z(1200);a=v[23540];v[23540]=0;if((a|0)==1){break c}v[23540]=0;Y(1201,b|0);a=v[23540];v[23540]=0;if((a|0)==1){break c}v[23540]=0;Z(1202);a=v[23540];v[23540]=0;if((a|0)==1){break c}v[23540]=0;Y(1203,b|0);a=v[23540];v[23540]=0;if((a|0)==1){break c}Vd(469736);v[117434]=88500;v[23540]=0;Y(1204,b|0);a=v[23540];v[23540]=0;if((a|0)==1){break c}Vd(469744);v[117436]=88620;v[23540]=0;Y(1205,b|0);b=v[23540];v[23540]=0;if((b|0)==1){break c}break a}b=P()|0;O()|0;break b}b=P()|0;O()|0;zb(d)}XF(c);T(b|0);L()}v[117026]=469752;t[468112]=1;v[117027]=468104;return 468104}function dN(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;f=kb-16|0;kb=f;g=a+1074376|0;h=B(b,872);e=(g+h|0)+616|0;d=c&15;a:{b:{switch((c&240)-16>>>4|0){case 0:a=(a+h|0)+1075080|0;v[a>>2]=v[a>>2]&-1048577|((d|0)!=0)<<20;break a;case 1:if(!(w[a+480209|0]&16)){break a}if(xj(v[e+656>>2])){a=B(b,872)+a|0;u[a+1075764>>1]=d-8;a=a+1075843|0;t[a|0]=w[a|0]|64;break a}if(v[a+480180>>2]!=64){b=B(b,872)+a|0;u[b+1075764>>1]=d<<28>>24;c=x[(d<<1)+33344>>1];v[b+1075696>>2]=c;e=b+1075692|0;if(!v[e>>2]){break a}l=e,m=eh(a,w[b+1075789|0],d<<28>>24,c),v[l>>2]=m;break a}a=B(b,872)+a|0;b=v[a+1075096>>2];if(!b){break a}v[a+1075696>>2]=v[b+24>>2]+B(d,80);break a;case 2:if(v[a+480180>>2]==2){t[(B(b,872)+a|0)+1075814|0]=c&3;break a}Db(f+8|0,a+1074312|0,21);if(Cb(v[v[f+8>>2]>>2],v[f+12>>2])){t[(B(b,872)+a|0)+1075814|0]=d>>>0<4?d:0;break a}t[(B(b,872)+a|0)+1075814|0]=c&7;break a;case 3:if(v[a+480180>>2]==2){t[(B(b,872)+a|0)+1075817|0]=c&3;break a}Db(f+8|0,a+1074312|0,21);if(Cb(v[v[f+8>>2]>>2],v[f+12>>2])){t[(B(b,872)+a|0)+1075817|0]=d>>>0<4?d:0;break a}t[(B(b,872)+a|0)+1075817|0]=c&7;break a;case 4:Db(f+8|0,a+1074312|0,21);if(Cb(v[v[f+8>>2]>>2],v[f+12>>2])){a=B(b,872)+a|0;t[a+1075813|0]=0;t[a+1075820|0]=d>>>0<4?d:0;break a}t[(B(b,872)+a|0)+1075820|0]=c&7;break a;case 5:if(v[a+1074392>>2]|!(w[a+480209|0]&16)){break a}a=a+1074400|0;v[a>>2]=v[a>>2]+d;break a;case 6:if(!(w[a+480209|0]&16)){break a}if(d>>>0<=2){d=x[a+480188>>1];h=d>>>0>256?d:256;i=a+906300|0;j=b+1|0;k=(c&15)-1|0;while(1){if((d|0)==(h|0)){break a}c=B(d,872)+a|0;c:{if(x[c+1075778>>1]!=(j|0)){break c}d:{e:{switch(k|0){case 0:Wn(a,c+1074992|0);if(!(w[c+1075081|0]&2)){break d}e=v[a+1298300>>2];if(!zd(e)){break d}jk(e,d&65535);break d;case 1:g=c+1075080|0;e=v[g>>2];v[g>>2]=e|4096;if(!(e&512)){break d}e=v[a+1298300>>2];if(!zd(e)){break d}jk(e,d&65535);break d;default:break e}}v[c+1075688>>2]=0;g=c+1075080|0;e=v[g>>2];v[g>>2]=e|4096;if(!(e&512)){break d}e=v[a+1298300>>2];if(!zd(e)){break d}rj(e,d&65535,1)}e=v[c+1075648>>2];if(!e){break c}g=w[e+34|0];if(!g){break c}g=v[Md(i,g-1|0)>>2];if(!g){break c}ob[v[v[g>>2]+96>>2]](g,e,w[c+1075789|0]|256,0,b)}d=d+1|0;continue}}xP(e,d,v[a+480180>>2]);break a;case 7:if(!(w[a+480209|0]&16)){break a}um(a,e,d,4);break a;case 8:b=e;c=v[a+480208>>2];f:{if(!(c&4096)){break f}g:{switch(d&15){case 0:v[b+88>>2]=v[b+88>>2]&-257;break f;case 1:v[b+692>>2]=128;v[b+88>>2]=v[b+88>>2]|256;break f;case 8:v[b+88>>2]=v[b+88>>2]&-25165825|16777216;break f;case 9:v[b+88>>2]=v[b+88>>2]&-25165825|8388608;break f;case 10:v[a+480208>>2]=c&-16385;break f;case 11:v[a+480208>>2]=c|16384;break f;case 12:v[a+480208>>2]=c&-8193;break f;case 13:v[a+480208>>2]=c|8192;break f;case 14:v[b+88>>2]=v[b+88>>2]&-129;break f;case 15:break g;default:break f}}h:{if(v[b>>2]|v[b+4>>2]){break h}a=v[b+76>>2];if(!a){break h}if(!(l=$c(w[b+788|0]),m=1,n=w[b+88|0]&2,n?l:m)){break h}v[b>>2]=-1;v[b+4>>2]=a-1}v[b+88>>2]=v[b+88>>2]|128}break a;case 9:if(!(w[a+480209|0]&16)){break a}c=B(b,872)+a|0;t[c+1075828|0]=d;Db(f+8|0,a+1074312|0,35);if(Cb(v[v[f+8>>2]>>2],v[f+12>>2])){break a}if(!$c(w[c+1075780|0])){break a}b=v[(B(b,872)+a|0)+1075068>>2];a=d<<16;if(b>>>0<=a>>>0){break a}v[e+4>>2]=a;break a;case 10:if(!(w[a+480209|0]&16)){break a}Zy(a,g,e,d);break a;case 11:i:{if(d){break i}d=1;c=v[a+480180>>2];if(c&16777248){break i}d=0;if((c|0)==2){break a}}Db(f+8|0,a+1074312|0,30);Hy(a,b,d,Cb(v[v[f+8>>2]>>2],v[f+12>>2])|v[a+480180>>2]==2);break a;case 14:break b;default:break a}}if(v[a+480180>>2]==2){break a}t[(B(b,872)+a|0)+1075836|0]=d}kb=f+16|0}function iK(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;g=kb-192|0;kb=g;v[g+188>>2]=c;v[g+184>>2]=b;a:{if(!c){break a}h=w[cl(b,c)|0];if((h|0)==33){f=1}else{if((h|0)!=63){break a}f=0}jl(g+8|0,b,c,c-1|0);b=v[g+12>>2];v[g+184>>2]=v[g+8>>2];v[g+188>>2]=b}b=g+8|0;Xd(b);c=v[g+8>>2];Xd(g+160|0);h=bl(c,v[g+164>>2],g+184|0);Xd(b);b=v[g+188>>2];c=v[g+184>>2];b:{c:{d:{e:{if((h|0)==v[g+12>>2]){a=rc(g+176|0,21688);if(Qc(c,b,v[a>>2],v[a+4>>2])){a=ba(8)|0;v[23540]=0;b=Mh(g+160|0,d,e);c=v[23540];v[23540]=0;f:{g:{h:{if((c|0)!=1){v[23540]=0;U(961,g+8|0,17667,b|0);c=v[23540];v[23540]=0;if((c|0)==1){break h}f=0;c=tc(a,g+8|0);v[23540]=0;U(119,c|0,62752,950);c=v[23540];v[23540]=0;if((c|0)!=1){break b}c=P()|0;O()|0;zb(g+8|0);break g}c=P()|0;O()|0;break f}c=P()|0;f=1;O()|0}zb(b);if(!f){break c}}ca(a|0);break c}if(!f){break e}a=ba(8)|0;v[23540]=0;b=Mh(g+128|0,v[g+184>>2],v[g+188>>2]);c=v[23540];v[23540]=0;i:{j:{k:{l:{m:{n:{o:{p:{q:{if((c|0)!=1){v[23540]=0;U(961,g+144|0,17703,b|0);c=v[23540];v[23540]=0;if((c|0)==1){break q}v[23540]=0;R(963,g+160|0,g+144|0);c=v[23540];v[23540]=0;f=1;if((c|0)==1){break p}v[23540]=0;d=Mh(g+112|0,d,e);c=v[23540];v[23540]=0;if((c|0)==1){break o}v[23540]=0;U(965,g+8|0,g+160|0,d|0);c=v[23540];v[23540]=0;if((c|0)==1){break n}c=tc(a,g+8|0);v[23540]=0;U(119,c|0,62752,950);c=v[23540];v[23540]=0;if((c|0)!=1){break b}c=P()|0;O()|0;zb(g+8|0);f=0;break m}c=P()|0;O()|0;break i}c=P()|0;f=1;O()|0;break j}c=P()|0;O()|0;break k}c=P()|0;O()|0;break l}c=P()|0;O()|0}zb(d)}zb(g+160|0)}zb(g+144|0)}zb(b);if(!f){break c}}ca(a|0);break c}f=rc(g+104|0,21688);if(Qc(c,b,v[f>>2],v[f+4>>2])){a=ba(8)|0;v[23540]=0;b=Mh(g+160|0,d,e);c=v[23540];v[23540]=0;r:{s:{t:{if((c|0)!=1){v[23540]=0;U(961,g+8|0,17667,b|0);c=v[23540];v[23540]=0;if((c|0)==1){break t}f=0;c=tc(a,g+8|0);v[23540]=0;U(119,c|0,62752,950);c=v[23540];v[23540]=0;if((c|0)!=1){break b}c=P()|0;O()|0;zb(g+8|0);break s}c=P()|0;O()|0;break r}c=P()|0;f=1;O()|0}zb(b);if(!f){break c}}ca(a|0);break c}f=rc(g+96|0,12342);if(Qc(c,b,v[f>>2],v[f+4>>2])){b=d;c=e;f=rc(g+88|0,5604);if(Qc(b,c,v[f>>2],v[f+4>>2])){v[a+52>>2]=0;break e}f=rc(g+80|0,11274);if(Qc(b,c,v[f>>2],v[f+4>>2])){v[a+52>>2]=1;break e}f=b;b=rc(g+72|0,9235);if(Qc(f,c,v[b>>2],v[b+4>>2])){v[a+52>>2]=2;break e}a=ba(8)|0;v[23540]=0;b=Mh(g+160|0,d,e);c=v[23540];v[23540]=0;u:{v:{w:{if((c|0)!=1){v[23540]=0;U(961,g+8|0,14646,b|0);c=v[23540];v[23540]=0;if((c|0)==1){break w}f=0;c=tc(a,g+8|0);v[23540]=0;U(119,c|0,62752,950);c=v[23540];v[23540]=0;if((c|0)!=1){break b}c=P()|0;O()|0;zb(g+8|0);break v}c=P()|0;O()|0;break u}c=P()|0;f=1;O()|0}zb(b);if(!f){break c}}ca(a|0);break c}f=b;b=rc(g- -64|0,11511);if(!Qc(c,f,v[b>>2],v[b+4>>2])){break e}b=0;x:{c=d;d=e;e=rc(g+56|0,15630);if(Qc(c,d,v[e>>2],v[e+4>>2])){break x}b=1;e=rc(g+48|0,15635);if(Qc(c,d,v[e>>2],v[e+4>>2])){break x}b=2;e=rc(g+40|0,12616);if(Qc(c,d,v[e>>2],v[e+4>>2])){break x}b=3;e=c;c=rc(g+32|0,9299);if(Qc(e,d,v[c>>2],v[c+4>>2])){break x}a=ba(8)|0;v[23540]=0;b=Q(55,g+8|0,11547)|0;c=v[23540];v[23540]=0;if((c|0)==1){break d}a=tc(a,b);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break b}c=P()|0;O()|0;zb(b);break c}v[a+56>>2]=b;a=v[a+24>>2];if(!v[a+24668>>2]){break e}c=a+24664|0;d=v[c+4>>2];v[g+24>>2]=v[c>>2];v[g+28>>2]=d;c=a+24656|0;d=v[c+4>>2];v[g+16>>2]=v[c>>2];v[g+20>>2]=d;c=v[a+24652>>2];v[g+8>>2]=v[a+24648>>2];v[g+12>>2]=c;i=g,j=MJ(b),v[i+28>>2]=j;if(!xx(g+8|0,a+24648|0)){break e}qy(a,g+8|0)}kb=g+192|0;return}c=P()|0;O()|0;ca(a|0)}T(c|0)}L()}function mea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=kb-192|0;kb=e;a:{b:{if(Qb(v[c>>2],v[c+8>>2],8)){$b(c,4);while(1){if(hu(v[c>>2],v[c+8>>2])){break b}m=kb-288|0;kb=m;f=TO(m);h=kb-384|0;kb=h;i=sc(f,TO(h+96|0),282);f=0;c:{d:{e:{f:{g:{if(Hh(c,13662)){yg(c,4);l=je(h+72|0,c);v[23540]=0;j=Q(759,l|0,i|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break g}h:{if(!j){break h}j=v[l+8>>2];g=v[l>>2];k=w[i+26|0];v[23540]=0;j=W(156,g|0,j|0,k|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break g}if(!j){break h}j=0;i:{while(1){if(w[i+26|0]<=f>>>0){g=v[l+8>>2];k=v[l>>2];f=0;v[23540]=0;j=j&65535;g=W(156,k|0,g|0,j|0)|0;k=v[23540];v[23540]=0;if((k|0)==1){break e}if(!g){break h}v[23540]=0;Q(188,l|0,j|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break e}yg(l,UO(i));f=Gc(h- -64|0);g=h+96|0;pz(g);v[23540]=0;R(760,l|0,g|0);g=v[23540];v[23540]=0;if((g|0)!=1){u[h+118>>1]=0;u[h+120>>1]=0;f=qz(f,h+96|0,h+123|0);g=w[i+26|0];v[23540]=0;Q(188,l|0,g|0)|0;g=v[23540];v[23540]=0;if((g|0)!=1){break i}}f=P()|0;O()|0;break d}v[23540]=0;g=S(198,l|0)|0;k=v[23540];v[23540]=0;if((k|0)!=1){t[(f+i|0)+27|0]=g;f=f+1|0;j=g+j|0;continue}break}f=P()|0;O()|0;break d}k=f;f=i+27|0;k=qz(k,f,f+w[i+26|0]|0);v[23540]=0;U(190,h+16|0,l|0,j|0);f=v[23540];v[23540]=0;if((f|0)==1){break f}g=h+16|0;j=kc(h+40|0,g);Bb(g);f=0;v[23540]=0;R(560,g|0,j|0);g=v[23540];v[23540]=0;if((g|0)==1){f=P()|0;O()|0;Bb(j);break d}g=h+16|0;kC(h+8|0,g);n=k;k=v[h+8>>2];k=qz(n,k,Lb(k,v[h+12>>2]));Uc(g);Bb(j);if(v[k>>2]!=(w[i+22|0]|w[i+23|0]<<8|(w[i+24|0]<<16|w[i+25|0]<<24))){break h}f=UO(i);v[23540]=0;Q(188,c|0,f|0)|0;i=v[23540];v[23540]=0;f=1;if((i|0)==1){break e}}Bb(l)}kb=h+384|0;break c}f=P()|0;O()|0;break d}f=P()|0;O()|0;break d}f=P()|0;O()|0}Bb(l);T(f|0);L()}kb=m+288|0;if(f){continue}break}}zc(c);wg(b,a,c);a=1;break a}t[d|0]=1;zc(c);f=Bg(c);d=e+144|0;ae(d,c,cf(c));h=kc(e+168|0,d);Bb(d);b=x[a+34>>1]&-66|w[b|0]>15|(w[b+1|0]!=1)<<6;u[a+34>>1]=b;v[a>>2]=f>>>(b&1)>>>(b>>>6&1);v[e+140>>2]=0;v[e+136>>2]=0;v[23540]=0;R(560,d|0,h|0);b=v[23540];v[23540]=0;j:{k:{l:{m:{if((b|0)!=1){c=Ie(e+144|0);d=v[e+144>>2];i=tA(c,Fi(d),e+140|0,e+136|0);v[23540]=0;b=v[e+140>>2];Q(188,h|0,b|0)|0;f=v[23540];v[23540]=0;if((f|0)!=1){if(!i){break j}Mg(a);l=b+c|0;b=d-b|0;d=v[e+136>>2];c=0;while(1){n:{if(d){if(!b|(d|0)!=1){break k}d=v[a>>2];if(d>>>0>c>>>0){break n}break k}d=v[a>>2];if(d>>>0<=c>>>0){break k}}if(!_d(d,v[a+20>>2])){break k}v[e+132>>2]=0;v[e+128>>2]=0;j=vS(i,l,Fi(b),e+132|0,e+124|0,e+128|0);v[23540]=0;Q(188,h|0,j|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break m}ci(e+128|0,Fi(v[a>>2]-c|0));d=v[e+128>>2];o:{if((d|0)<=0){break o}f=v[e+132>>2];k=x[a+34>>1];if((Ld(k)|0)!=(f|0)){break o}m=B(c,f);g=v[a+20>>2];if(k&1){v[e+120>>2]=d;v[e+104>>2]=d;v[e+56>>2]=d;v[e+40>>2]=d;v[e+100>>2]=f;v[e+96>>2]=v[e+124>>2];v[e+116>>2]=f;v[e+112>>2]=g+(m<<1);v[23540]=0;f=v[e+100>>2];v[e+32>>2]=v[e+96>>2];v[e+36>>2]=f;f=v[e+116>>2];v[e+48>>2]=v[e+112>>2];v[e+52>>2]=f;R(561,e+48|0,e+32|0);f=v[23540];v[23540]=0;if((f|0)!=1){break o}break m}v[e+88>>2]=d;v[e+72>>2]=d;v[e+24>>2]=d;v[e+8>>2]=d;v[e+68>>2]=f;v[e+64>>2]=v[e+124>>2];v[e+84>>2]=f;v[e+80>>2]=g+m;v[23540]=0;f=v[e+68>>2];v[e>>2]=v[e+64>>2];v[e+4>>2]=f;f=v[e+84>>2];v[e+16>>2]=v[e+80>>2];v[e+20>>2]=f;R(562,e+16|0,e|0);f=v[23540];v[23540]=0;if((f|0)==1){break m}}b=b-j|0;l=j+l|0;c=c+d|0;d=uS(i);continue}}break m}c=P()|0;O()|0;break l}c=P()|0;O()|0;Uc(e+144|0)}Bb(h);T(c|0);L()}tS(i)}Uc(e+144|0);Bb(h);a=(i|0)!=0}kb=e+192|0;return a|0}function pba(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,y=0,z=0,A=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;i=kb-32|0;kb=i;s=v[a+4>>2];e=bf(v[a+8>>2],b);y=v[e>>2];a:{if(y+1>>>0<2){break a}j=(B(b,872)+s|0)+616|0;if(!(I=1,J=Ai(v[j+8>>2],v[j+12>>2]),K=w[e+4|0],K?I:J)){break a}h=B(b,872)+s|0;if(!v[h+720>>2]){break a}g=v[h+704>>2]&2;e=v[(g?h+700|0:h+692|0)>>2];k=v[h+700>>2];f=v[h+696>>2];Db(i+8|0,v[a>>2]+1074312|0,31);z=Cb(v[v[i+8>>2]>>2],v[i+12>>2]);m=qf(v[h+624>>2],v[h+628>>2],c);q=m;l=w[h+704|0]&128;m=l?0-m|0:m;n=nb;l=l?0-(n+((q|0)!=0)|0)|0:n;q=e;D=g?A:0;e=f;r=g?e:0;n=k-e|0;F=n<<1;G=h+1316|0;o=h+1467|0;E=h+1362|0;A=(w[E|0]&17)!=1;b:{c:{while(1){if((p|0)!=(y|0)){d:{if(d>>>0>p>>>0){f=(w[E|0]&17)==1;break d}v[v[a+4>>2]+16>>2]=p-d;t[o|0]=w[o|0]&254|(d|0)==(p|0);f=v[a>>2];k=v[a+4>>2];e=_b(v[f+484344>>2],x[k+70>>1]);e=jd(v[e>>2],v[v[e+48>>2]+12>>2],v[k+48>>2],b);g=w[e+3|0];e:{f:{switch(w[e+2|0]-11|0){case 0:k=i+8|0;_y(k,f,g,w[e+4|0],0);k=Te(k);it(v[a>>2],v[a+4>>2],b,x[i+8>>1]);f=1;if(!w[k|0]){break e}break d;case 1:u=w[e+4|0];Db(i+8|0,f+1074312|0,12);Vy(f,k,b,u<<2&252,Cb(v[v[i+8>>2]>>2],v[i+12>>2]));break e;case 2:break f;default:break e}}u=w[e+4|0];Db(i+8|0,f+1074312|0,12);Uy(f,k,b,u<<2&252,Cb(v[v[i+8>>2]>>2],v[i+12>>2]))}f=1;g:{h:{i:{j:{k:{switch(g-2|0){default:if(g-38>>>0<4){break h}if((g|0)==19){break j}if((g|0)!=28){break g}e=w[e+5|0];f=e&240;if((f|0)==32){break i}if((f|0)!=16){break g}Ty(v[a>>2],j,e&15);break g;case 2:it(v[a>>2],v[a+4>>2],b,w[e+5|0]);break g;case 4:it(v[a>>2],v[a+4>>2],b,0);break g;case 0:e=w[e+5|0];g=v[a>>2];if(!e&(t[g+480180|0]&1)){break d}Vy(g,v[a+4>>2],b,e,0);break g;case 1:break k;case 3:break d}}e=w[e+5|0];g=v[a>>2];if(!e&(t[g+480180|0]&1)){break d}Uy(g,v[a+4>>2],b,e,0);break g}f=w[e+5|0];e=f&15;if(!(v[v[a>>2]+480180>>2]&1048580?1:e)){break g}f=f&240;if((f|0)!=32){if((f|0)!=16){break g}Sy(v[a>>2],j,e);break g}Ry(v[a>>2],j,e);break g}Qy(v[a>>2],j,e&15);break g}FN(v[a>>2],j,w[e+5|0],(g|0)==38|(g|0)==40,(g&254)==40)}f=1}v[i+28>>2]=v[G>>2];if(z){ht(v[a>>2],j)}if(!A){EN(v[a>>2],j,i+28|0);f=1}if(!z){ht(v[a>>2],j)}v[i+24>>2]=0;DN(j,i+24|0);l:{if(w[h+705|0]&2){break l}m:{if(!f){if(!w[bf(v[a+8>>2],b)+4|0]){break m}}if(w[o|0]&96){yP(j,C(1),0,v[a>>2]);e=w[o|0];t[o|0]=(e&64?-65:-33)&e}$y(i+8|0,v[a>>2],j,v[i+28>>2],0);e=v[i+12>>2];v[h+624>>2]=v[i+8>>2];v[h+628>>2]=e;I=bf(v[a+8>>2],b),J=0,t[I+4|0]=J;e=qf(v[h+624>>2],v[h+628>>2],c);f=w[h+704|0]&128;m=f?0-e|0:e;g=nb;l=f?0-(g+((e|0)!=0)|0)|0:g}Rb(j,m,l);k=v[j>>2];e=v[j+4>>2];if((k>>>0<H>>>0&(e|0)<=(q|0)|(e|0)<(q|0))&((e|0)>=(r|0)&k>>>0>=D>>>0|(e|0)>(r|0)|((l|0)>0|(l|0)>=0))){break l}g=v[h+704>>2];if(!(g&2)){break c}if(g&4){f=v[h+696>>2];if(k>>>0<D>>>0&(e|0)<=(r|0)|(e|0)<(r|0)){I=j,J=Sg(0,f<<1,k,e),v[I>>2]=J;e=nb;v[j+4>>2]=e;v[h+704>>2]=g^128;g=m;m=0-g|0;l=0-(((g|0)!=0)+l|0)|0}Db(i+8|0,v[a>>2]+1074312|0,33);e=(e-f>>>0)%(F-Cb(v[v[i+8>>2]>>2],v[i+12>>2])>>>0)|0;n:{if(e>>>0<n>>>0){f=e+v[h+696>>2]|0;break n}f=v[h+700>>2]+(n-e|0)|0}v[j+4>>2]=f;f=v[h+704>>2];if((f&128)>>>7^e>>>0<n>>>0){break l}v[h+704>>2]=f^128;e=m;m=0-e|0;l=0-(((e|0)!=0)+l|0)|0;break l}f=e;g=v[h+700>>2];if(e>>>0>=g+n>>>0){f=g+((f-g>>>0)%(n>>>0)|0)|0}while(1){e=f;f=e-n|0;if(e>>>0>=g>>>0){continue}break}v[j>>2]=k;v[j+4>>2]=e}p=p+1|0;continue}break}v[v[a+4>>2]+16>>2]=0;break b}v[v[a+4>>2]+16>>2]=0;AP(j);v[(B(b,872)+s|0)+1324>>2]=0}I=bf(v[a+8>>2],b),J=0,v[I>>2]=J}kb=i+32|0}function zja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,y=0;e=kb-976|0;kb=e;zc(b);d=kb-16|0;kb=d;h=e+872|0;sU(d+8|0,h);f=v[d+12>>2];nc(d,v[b>>2],v[b+8>>2],v[d+8>>2],v[d+12>>2]);g=v[d+4>>2];if((g|0)==(f|0)){$b(b,v[d+12>>2])}kb=d+16|0;d=(f|0)==(g|0);if(!d){rU(h)}a:{if(!d){break a}if(!uU(e+872|0)){break a}if(!Qb(v[b>>2],v[b+8>>2],Ec(tU(w[e+919|0]|w[e+920|0]<<8),nb))){break a}if(!c){l=1;break a}Cd(a,512);v[a+480228>>2]=32;u[a+480188>>1]=16;v[a+480196>>2]=w[e+947|0];v[a+480208>>2]=16;v[a+480200>>2]=256;v[a+480204>>2]=8e5;Ob(a+1074312|0,7,1);d=e+96|0;f=yc(d,8253);Jb(a+1298344|0,f);Ab(f);f=yc(d,8941);Jb(a+1298356|0,f);Ab(f);v[a+1298404>>2]=5;f=e+16|0;qU(f,e+872|4);Fc(d,f);Bc(a+1298308|0,d);zb(d);d=0;while(1){if((d|0)==16){b:{d=x[e+968>>1];if(d){EB(a+1298332|0,b,d,132,0)}d=kb-16|0;kb=d;h=e+96|0;gc(d+8|0,h,771);f=v[d+12>>2];nc(d,v[b>>2],v[b+8>>2],v[d+8>>2],v[d+12>>2]);g=v[d+4>>2];if((g|0)==(f|0)){$b(b,v[d+12>>2])}kb=d+16|0;l=(f|0)==(g|0);if(!l){Ub(h,0,771)}if(!l){break a}d=a+484360|0;f=a+484376|0;pU(Wb(v[d>>2],w[f|0]),e+96|0,w[e+353|0]);Ve(Wb(v[d>>2],w[f|0]),w[e+354|0]);dd(b,w[e+919|0]|w[e+920|0]<<8);o=a+484344|0;p=c&1;h=0;while(1){c:{if((h|0)==256){if(!(c&2)){break a}xV(b,e- -64|0);d=0;while(1){if((d|0)==64){break a}if(!(w[e- -64+(d>>>3)|0]>>>(d&7)&1)){d=d+1|0;continue}if(!mB(b,e+16|0)){break a}d=d+1|0;u[a+480190>>1]=d;Ne(e,1,e+16|0);h=e+72|0;Fc(h,e);Dc(((x[a+480190>>1]<<5)+a|0)+946304|0,h);zb(h);c=(B(d,104)+a|0)+484380|0;nd(c,0);i=w[e+48|0]|w[e+49|0]<<8|(w[e+50|0]<<16|w[e+51|0]<<24);v[c>>2]=i;f=w[e+54|0]|w[e+55|0]<<8|(w[e+56|0]<<16|w[e+57|0]<<24);v[c+4>>2]=f;g=w[e+58|0]|w[e+59|0]<<8|(w[e+60|0]<<16|w[e+61|0]<<24);v[c+24>>2]=16726;v[c+8>>2]=g;u[c+30>>1]=w[e+53|0]<<4;if(t[e+62|0]&1){g=g>>>1|0;v[c+8>>2]=g;f=f>>>1|0;v[c+4>>2]=f;v[c>>2]=i>>>1}if(!(!(w[e+63|0]&8)|f>>>0>=g>>>0)){u[c+34>>1]=x[c+34>>1]|2}Zc(h,t[e+62|0]&1?16:8,1,0,0);wg(h,c,b);continue}}d:{d=(h<<1)+e|0;g=w[d+355|0]|w[d+356|0]<<8;if(g){f=e+72|0;ae(f,b,g);i=kc(e+16|0,f);Bb(f);n=((w[d+355|0]|w[d+356|0]<<8)-2|0)/64|0;e:{if(!p){break e}v[23540]=0;d=W(226,o|0,h&65535,n|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break d}if(!d){break e}v[23540]=0;d=S(206,i|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break b}v[23540]=0;Q(188,i|0,1)|0;f=v[23540];v[23540]=0;if((f|0)==1){break b}q=d?d>>>0<n-2>>>0?d+1|0:-1:-1;f=0;f:while(1){g:{d=_b(v[o>>2],h);if((f|0)==(n|0)){break g}m=0;r=Cf(v[d>>2],v[v[d+48>>2]+12>>2],f);while(1){if((m|0)==16){f=f+1|0;continue f}v[23540]=0;R(349,e+72|0,i|0);d=v[23540];v[23540]=0;if((d|0)==1){break c}d=B(m,6)+r|0;j=e+72|0;g=Te(j);j=Li(j);k=w[e+72|0];if((k-1&255)>>>0<=71){t[d|0]=k+36;s=d,y=w[Oc(e+72|0)|0]+1|0,t[s+1|0]=y}if((w[g|0]-1&255)>>>0<=15){t[d+2|0]=1;t[d+4|0]=((w[g|0]<<6)+-64>>>0)/15}k=w[j|0];g=k&15;t[d+5|0]=g;h:{i:{switch((w[j|0]>>>4|0)-1|0){case 0:case 1:t[d+5|0]=k|240;break h;case 2:t[d+5|0]=g<<2;break h;case 3:t[d+5|0]=(6/(g+1>>>0)|0)+1;break h;case 5:case 6:t[d+5|0]=g<<3;break h;case 9:t[d+4|0]=(g<<2)+4;t[d+2|0]=1;break h;case 10:t[d+5|0]=g|128;break h;case 11:break i;default:break h}}t[d+5|0]=(6/(g+1>>>0)|0)+1|13}t[d+3|0]=w[(w[j|0]>>>4|0)+26432|0];m=m+1|0;continue}}break}ze(d,Gh(Ue(Oe(e+72|0,14,0),q)))}Bb(i)}h=h+1|0;continue}}break}}}else{f=(d<<5)+a|0;h=f+480280|0;df(h);g=h;h=(e+872|0)+d|0;v[g>>2]=!w[h+50|0]<<10;u[f+480284>>1]=(w[h+76|0]<<4|8)&248;d=d+1|0;continue}break}a=P()|0;O()|0;Bb(i);T(a|0);L()}kb=e+976|0;return l|0}function xW(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=kb-576|0;kb=e;zc(b);d=kb-16|0;kb=d;f=e+72|0;RC(d+8|0,f);g=v[d+12>>2];nc(d,v[b>>2],v[b+8>>2],v[d+8>>2],v[d+12>>2]);j=v[d+4>>2];if((j|0)==(g|0)){$b(b,v[d+12>>2])}kb=d+16|0;d=(g|0)==(j|0);if(!d){QC(f)}a:{if(!d){break a}if(!TC(e+72|0)){break a}b:{if(!c){break b}if(!Qb(v[b>>2],v[b+8>>2],Ec(SC(w[e+182|0],w[e+183|0]),nb))){break a}Cd(a,64);v[a+480204>>2]=78e4;v[a+480260>>2]=112;v[a+480264>>2]=13696;v[a+480196>>2]=4;u[a+480188>>1]=8;Ob(a+1074312|0,7,1);d=e+40|0;g=yc(d,14682);Jb(a+1298344|0,g);Ab(g);d=yc(d,14715);Jb(a+1298356|0,d);Ab(d);Ol(a+1298368|0,Sb(e+72|0,11143,2)?14710:14682);v[a+1298404>>2]=5;f=w[e+182|0];u[a+480190>>1]=f;g=1;while(1){j=g&65535;if(j>>>0<=f>>>0){f=kb-16|0;kb=f;d=e+40|0;gc(f+8|0,d,25);l=v[f+12>>2];nc(f,v[b>>2],v[b+8>>2],v[f+8>>2],v[f+12>>2]);i=v[f+4>>2];if((i|0)==(l|0)){$b(b,v[f+12>>2])}kb=f+16|0;if((i|0)!=(l|0)){t[d|0]=0;t[d+1|0]=0;t[d+2|0]=0;t[d+3|0]=0;t[d+4|0]=0;t[d+5|0]=0;t[d+6|0]=0;t[d+7|0]=0;t[d+24|0]=0;t[d+16|0]=0;t[d+17|0]=0;t[d+18|0]=0;t[d+19|0]=0;t[d+20|0]=0;t[d+21|0]=0;t[d+22|0]=0;t[d+23|0]=0;t[d+8|0]=0;t[d+9|0]=0;t[d+10|0]=0;t[d+11|0]=0;t[d+12|0]=0;t[d+13|0]=0;t[d+14|0]=0;t[d+15|0]=0}if((w[e+53|0]|w[e+54|0]<<8|(w[e+55|0]<<16|w[e+56|0]<<24))>>>0>67108863){break a}f=(B(j,104)+a|0)+484380|0;nd(f,0);v[f+24>>2]=8363;l=e+40|0;d=l;i=w[d+13|0]|w[d+14|0]<<8|(w[d+15|0]<<16|w[d+16|0]<<24);v[f>>2]=i;k=w[d+17|0]|w[d+18|0]<<8|(w[d+19|0]<<16|w[d+20|0]<<24);v[f+4>>2]=k;d=w[d+21|0]|w[d+22|0]<<8|(w[d+23|0]<<16|w[d+24|0]<<24);d=d>>>0>i>>>0?k?d:0:d;v[f+8>>2]=d;if(d){u[f+34>>1]=2;Dk(f)}f=e+8|0;$h(f,2,l);d=e+24|0;Fc(d,f);Dc(((j<<5)+a|0)+946304|0,d);g=g+1|0;zb(d);f=x[a+480190>>1];continue}break}g=e+24|0;h=e+72|2;cg(g,3,h,36);d=e+40|0;Fc(d,g);Bc(a+1298308|0,d);zb(d);g=0;PC(a+1298332|0,h,108,36,0);d=a+484360|0;h=a+484376|0;fv(Wb(v[d>>2],w[h|0]),e+185|0,128);d=Wb(v[d>>2],w[h|0]);h=w[e+184|0];if(x[cc(v[d>>2],h)>>1]<w[e+183|0]){Ve(d,h)}while(1)if((g|0)==8){j=a+484344|0;xg(j,w[e+183|0]);n=c&1;f=0;while(1){if(w[e+183|0]<=f>>>0){h=1;if(!(c&2)){break a}c=Zc(e+40|0,8,1,0,1);g=1;while(1){d=g&65535;if(d>>>0>x[a+480190>>1]){break b}wg(c,(B(d,104)+a|0)+484380|0,b);g=g+1|0;continue}}c:{d:{if(n){if(ph(j,f&65535,64)){break d}}$b(b,1536);break c}v[e+24>>2]=-1;v[e+28>>2]=-1;l=0;e:while(1){if((l|0)==64){d=(e+72|0)+f|0;g=w[d+369|0];if(g>>>0<63){ze(_b(v[j>>2],f),Gh(Ue(Oe(e+40|0,14,0),g)))}ze(_b(v[j>>2],f),Gh(Oe(e+40|0,16,w[d+241|0])));break c}g=0;d=_b(v[j>>2],f);h=Cf(v[d>>2],v[v[d+48>>2]+12>>2],l);while(1){if((g|0)==8){l=l+1|0;continue e}d=e+40|0;Yq(d,b);i=Oc(d);k=Te(d);i=w[i|0];d=w[e+40|0];if(d>>>0<=253){t[h|0]=(d>>>2|0)+37;t[h+1|0]=(d<<4&48|i>>>4)+1;t[(e+24|0)+g|0]=255;d=w[e+40|0]}if((d&255)!=255){t[h+2|0]=1;t[h+4|0]=(((i&15)<<6|8)>>>0)/15}d=w[k|0];if((d|0)!=255){t[(e+24|0)+g|0]=d}i=(e+24|0)+g|0;f:{g:{if(d&15?0:(d|0)!=48){break g}k=w[i|0];if((k|0)==255){break f}m=k<<24>>24;d=m&15;t[h+5|0]=d;h:{if((m|0)<0){break h}k=k>>>4|0;t[h+3|0]=w[k+26216|0];i:{switch(k-3|0){case 0:t[h+5|0]=d|32;break g;case 1:t[h+5|0]=d|m<<4;break f;case 2:break g;case 3:break i;default:break f}}j:{switch(d|0){case 0:t[h+5|0]=79;break f;case 1:break j;default:break h}}t[h+5|0]=244;break f}t[h+3|0]=0;break f}t[i|0]=255}h=h+6|0;g=g+1|0;continue}}}f=f+1|0;continue}}else{d=(g<<5)+a|0;df(d+480280|0);u[d+480284>>1]=g&1?208:48;g=g+1|0;continue}}h=1}kb=e+576|0;return h|0}function bo(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,y=0,z=0,A=0;f=kb-96|0;kb=f;q=mz(v[a+24>>2],w[a+32|0]);s=tj(q);c=s;e=v[a>>2];d=yd(e,v[a+4>>2]);a:{if(c>>>0>d>>>0){i=kb-32|0;kb=i;c=c-d|0;d=v[Gb(a)>>2];e=v[a+4>>2];b:{if(c>>>0<=(d-e|0)/12>>>0){e=kb-16|0;kb=e;c=Ot(e,a,c);d=v[c+4>>2];h=v[c+8>>2];while(1){if((d|0)==(h|0)){lc(c);kb=e+16|0}else{tO(d);d=d+12|0;v[c+4>>2]=d;continue}break}break b}d=Gb(a);d=Ik(i+8|0,ln(a,yd(v[a>>2],e)+c|0),yd(v[a>>2],v[a+4>>2]),d);h=kb-16|0;kb=h;e=CQ(h,d+8|0,c);c=v[e>>2];while(1){if(v[e+4>>2]!=(c|0)){tO(c);c=v[e>>2]+12|0;v[e>>2]=c;continue}break}Ud(e);kb=h+16|0;h=v[a>>2];c=v[a+4>>2];e=d+4|0;while(1){if((c|0)!=(h|0)){c=c-12|0;Zz(v[e>>2]-12|0,c);v[e>>2]=v[e>>2]-12;continue}break}qc(a,e);qc(a+4|0,d+8|0);qc(Gb(a),Cc(d));v[d>>2]=v[d+4>>2];c=v[d+4>>2];while(1){e=v[d+8>>2];if((e|0)!=(c|0)){e=e-12|0;v[d+8>>2]=e;We(e);continue}break}c=v[d>>2];if(c){bp(d);Mb(c)}}kb=i+32|0;break a}if(d>>>0>c>>>0){zO(a,e+B(c,12)|0)}}if(b){c=a+12|0;_p(c,Td(c));z=Gb(c),A=0,v[z>>2]=A;d=c;c=jc(c);v[d>>2]=c;v[c>>2]=0;v[a+28>>2]=0}i=Tb(f+80|0);c=v[a+24>>2];c=rt(v[c+484344>>2],v[c+484348>>2]);v[23540]=0;h=W(604,f- -64|0,c|0,30284)|0;c=v[23540];v[23540]=0;c:{if((c|0)!=1){e=a+12|0;d:{while(1){if((k|0)==(s|0)){od(h);ic(i);kb=f+96|0;return}c=v[a+24>>2];m=x[cc(v[q>>2],k)>>1];d=EO(c,m);v[f+60>>2]=d;c=Nd(v[a>>2],k);e:{f:{if(b){v[23540]=0;t[f+40|0]=0;U(766,c|0,d|0,f+40|0);d=v[23540];v[23540]=0;if((d|0)!=1){break f}d=P()|0;O()|0;break d}v[23540]=0;R(726,c|0,d|0);d=v[23540];v[23540]=0;if((d|0)==1){break e}}v[23540]=0;d=Q(311,q|0,k&65535)|0;g=v[23540];v[23540]=0;if((g|0)==1){break e}g:{if(!d){break g}v[f+40>>2]=b?0:v[c+4>>2];r=v[Kb(f+40|0,f+60|0)>>2];o=xf(e);c=x[cc(v[h>>2],m)>>1];if((c|0)!=65535){d=CO(e,x[xm(f+40|0,c,r)>>1],v[f+44>>2]);h:{if(Hg(d,xf(e))){c=CO(e,x[xm(f+40|0,x[cc(v[h>>2],m)>>1],v[f+60>>2])>>1],v[f+44>>2]);break h}c=xf(e)}v[f+56>>2]=d;while(1){i:{if(!Hg(d,c)){break g}g=Tb(f+40|0);d=jn(vd(d)+8|0);v[23540]=0;R(767,g|0,d|0);d=v[23540];v[23540]=0;if((d|0)!=1){d=ok(f+24|0,o);j=xm(f+16|0,k,v[vd(v[f+56>>2])+4>>2]);d=v[d>>2];v[23540]=0;d=fa(768,e|0,d|0,j|0,g|0)|0;j=v[23540];v[23540]=0;if((j|0)==1){break i}v[f+32>>2]=d;o=v[Kg(f+32|0)>>2];qe(g);d=v[Kg(f+56|0)>>2];continue}}break}d=P()|0;O()|0;qe(g);break d}p=_b(v[v[a+24>>2]+484344>>2],m);c=Og(v[v[p+48>>2]+12>>2]);v[23540]=0;t[f+40|0]=0;U(749,i|0,c|0,f+40|0);c=v[23540];v[23540]=0;if((c|0)!=1){n=v[f+60>>2];j:while(1){k:{if((n|0)==(r|0)){if(r){break g}z=cc(v[h>>2],m),A=k,u[z>>1]=A;break g}g=1;j=0;c=v[v[p+48>>2]+12>>2];n=n-1|0;d=Cf(v[p>>2],c,n);while(1){if(g>>>0<16&Og(c)>>>0>j>>>0){y=Lb(v[i>>2],j);c=w[y|0];l:{m:{n:{switch(w[d+3|0]-19|0){case 1:l=w[d+5|0];if((l&240)==176){break m}break l;case 0:break n;default:break l}}l=w[d+5|0];if((l&240)!=96){break l}}t[y|0]=l&15;l=w[Lb(v[i>>2],j)|0];c=l?l:c}c=c&255;g=B(c?c+1|0:1,g);d=d+6|0;j=j+1|0;c=v[v[p+48>>2]+12>>2];continue}else{o:{if(g>>>0<=1){continue j}c=Tb(f+40|0);v[23540]=0;R(767,c|0,g|0);d=v[23540];v[23540]=0;if((d|0)==1){break o}d=ok(f+8|0,o);g=xm(f+16|0,k,n);d=v[d>>2];v[23540]=0;o=fa(768,e|0,d|0,g|0,c|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break k}qe(c);continue j}}break}}break}d=P()|0;O()|0;qe(c);break d}d=P()|0;O()|0;break d}k=k+1|0;continue}break}d=P()|0;O()|0}od(h);break c}d=P()|0;O()|0}ic(i);T(d|0);L()}function _ja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,y=0;d=kb-336|0;kb=d;zc(b);a:{if(!wo(b,d+320|0)){break a}if(!KU(d+320|0)){break a}if(!Sb(d+320|0,14187,4)){$b(b,4)}if(!ei(b,d+312|0)){break a}if(Sb(d+312|0,14163,4)){break a}if(!c){n=1;break a}ZB(b,d+120|0,v[d+316>>2]);if(x[d+156>>1]>128|x[d+162>>1]>16|(x[d+160>>1]>256|x[d+154>>1]>128)){break a}Cd(a,8192);f=d+32|0;e=yc(f,6542);Jb(a+1298344|0,e);Ab(e);e=yc(f,10160);Jb(a+1298356|0,e);Ab(e);v[a+1298404>>2]=5;e=d+96|0;Ii(e,2,d+120|0);Fc(f,e);Bc(a+1298308|0,f);zb(f);u[d+32>>1]=x[d+162>>1];u[d+96>>1]=1;g=x[ke(f,e)>>1];u[a+480188>>1]=g;v[a+480196>>2]=w[d+166|0];v[a+480204>>2]=B(w[d+167|0],1e4);t[d+32|0]=w[d+164|0];t[d+96|0]=64;e=w[Yb(f,e)|0];v[a+480200>>2]=e<<2;if(!e){v[a+480200>>2]=256}e=w[d+165|0];b:{if((e|0)==128){v[d+32>>2]=256/(g>>>0);v[d+96>>2]=128;l=v[Kb(d+32|0,d+96|0)>>2];break b}l=e&127}v[a+480228>>2]=l;f=0;while(1){if((f|0)==16){g=a+484376|0;fv(Wb(v[a+484360>>2],w[g|0]),d+184|0,x[d+156>>1]);e=x[d+154>>1];if(e>>>0<x[d+156>>1]){Ve(Wb(v[a+484360>>2],w[g|0]),e)}q=c&2;o=a+484344|0;n=1;r=c&1;l=d+68|0;m=a+480190|0;f=a+480188|0;while(1){if(!ei(b,d+312|0)){break a}c=d+32|0;ae(c,b,v[d+316>>2]);h=kc(d+96|0,c);Bb(c);c:{d:{if(!(Sb(d+312|0,13559,4)|!r)){v[23540]=0;g=p&65535;e=W(226,o|0,g|0,64)|0;c=v[23540];v[23540]=0;if((c|0)==1){break d}if(!e){break c}v[23540]=0;Q(188,h|0,2)|0;c=v[23540];v[23540]=0;if((c|0)==1){break d}Fj(d+32|0);j=0;e:{while(1){c=v[h>>2];v[23540]=0;e=W(156,c|0,v[d+104>>2],1)|0;c=v[23540];v[23540]=0;f:{if((c|0)!=1){if(!(e&j>>>0<64)){break e}v[23540]=0;k=S(206,h|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break d}if(k){break f}j=j+1|0;continue}break d}i=d+32|0;e=k&15;if(e>>>0<x[f>>1]){c=_b(v[o>>2],g);i=jd(v[c>>2],v[v[c+48>>2]+12>>2],j,e)}g:{if(!(k&128)){break g}v[23540]=0;e=S(206,h|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break d}if(!e){break g}t[i|0]=e>>>0<109?e+12|0:e}if(k&64){v[23540]=0;e=S(206,h|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break d}t[i+1|0]=e}if(k&32){t[i+2|0]=1;v[23540]=0;e=S(206,h|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break d}t[d+16|0]=e;t[d|0]=64;s=i,y=w[Yb(d+16|0,d)|0],t[s+4|0]=y}if(!(k&16)){continue}v[23540]=0;R(260,d+16|0,h|0);c=v[23540];v[23540]=0;if((c|0)!=1){e=Oc(d+16|0);h:{i:{j:{k:{l:{c=w[d+16|0];switch(c-17|0){case 2:break k;case 0:case 1:break l;default:break j}}c=c&15;break i}t[d+16|0]=33;t[e|0]=145;c=w[d+16|0];break h}if(c>>>0<17){break h}c=(c&240)==32?9:-1}t[d+16|0]=c}Pf(i,c&255,w[e|0]);continue}break}break d}p=p+1|0;break c}if(Sb(d+312|0,13564,4)){break c}c=x[m>>1];if(!Zh(c)){break c}e=c+1|0;u[m>>1]=e;v[23540]=0;R(319,h|0,d+32|0);c=v[23540];v[23540]=0;m:{if((c|0)==1){break m}v[23540]=0;e=(B(e&65535,104)+a|0)+484380|0;R(320,d+32|0,e|0);c=v[23540];v[23540]=0;if((c|0)==1){break m}Ii(d,2,l);v[23540]=0;R(222,d+16|0,d|0);c=v[23540];v[23540]=0;if((c|0)==1){break m}c=d+16|0;Dc(((x[m>>1]<<5)+a|0)+946304|0,c);zb(c);if(!q){break c}j=w[d+45|0]|w[d+46|0]<<8;i=2;c=d+16|0;g=Zc(c,8,1,0,1);n:{if(!(j&64)){i=0;if(!(j&2)){break n}}dg(g,i)}if(j&4){xd(g,16)}v[23540]=0;W(219,c|0,e|0,h|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){break c}}}a=P()|0;O()|0;Bb(h);T(a|0);L()}Bb(h);continue}}g=(f<<5)+a|0;df(g+480280|0);e=w[(d+f|0)+168|0];if(e>>>0<=128){u[g+480284>>1]=e<<1}f=f+1|0;continue}}kb=d+336|0;return n|0}function mfa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=kb-192|0;kb=e;zc(b);a:{if(!mB(b,e+144|0)){break a}if(!TQ(e+144|0)){break a}if(!Qb(v[b>>2],v[b+8>>2],Ec(SQ(w[e+175|0],w[e+177|0]),nb))){break a}b:{if(!c){break b}Cd(a,256);g=e+32|0;Dj(g,2,e+144|0);d=e- -64|0;Fc(d,g);Bc(a+1298308|0,d);zb(d);f=yc(d,15372);Jb(a+1298344|0,f);Ab(f);d=yc(d,10139);Jb(a+1298356|0,d);Ab(d);Sf(g,4274);v[23540]=0;R(249,e+128|0,e+175|0);d=v[23540];v[23540]=0;c:{d:{if((d|0)!=1){v[23540]=0;X(672,e- -64|0,e+32|0,e+174|0,e+128|0);d=v[23540];v[23540]=0;if((d|0)!=1){d=e- -64|0;Jb(a+1298368|0,d);Ab(d);Ab(e+128|0);dc(e+32|0);v[a+1298404>>2]=5;d=Ob(a+1074312|0,107,1);v[a+480260>>2]=64;v[a+480264>>2]=32767;v[a+480188>>2]=2031620;Ob(d,107,1);f=w[e+176|0];d=w[e+175|0];if(d>>>0<=20){g=((f&255)>>>0)/10|0;f=g<<4|B(g,-10)+f}g=(f&255?f:96)&255;f=Xz(g);v[a+480196>>2]=g>>>4;v[a+480204>>2]=f;f=0;if(d>>>0>=11){t[e+64|0]=64;o=a,p=w[Yb(e+178|0,e- -64|0)|0]<<2,v[o+480200>>2]=p}while(1)if((f|0)==4){f=1;while(1){if((f|0)!=32){Wt(b,e+32|0);d=w[e+44|0];if(d?(d|0)!=46:0){break c}h=kb-32|0;kb=h;d=(B(f,104)+a|0)+484380|0;nd(d,0);k=e+32|0;g=k;uk(h,2,g);i=h+16|0;Fc(i,h);Be(d+43|0,i);zb(i);v[d+24>>2]=w[g+24|0]|w[g+25|0]<<8;t[h+16|0]=w[g+22|0];t[h|0]=64;o=d,p=w[Yb(i,h)|0]<<2,u[o+30>>1]=p;i=w[g+16|0]|w[g+17|0]<<8;v[d>>2]=i;j=w[g+18|0]|w[g+19|0]<<8;v[d+4>>2]=j;g=w[g+20|0]|w[g+21|0]<<8;v[d+8>>2]=g;e:{if(i>>>0<=1){v[d>>2]=0;break e}if((g|0)==65535|i>>>0<=j>>>0|g>>>0<=j>>>0){break e}u[d+34>>1]=2;o=d,p=v[Kb(d+8|0,d)>>2],v[o+8>>2]=p}kb=h+32|0;g=e+16|0;uk(g,2,k);d=e+128|0;Fc(d,g);Dc(((f<<5)+a|0)+946304|0,d);zb(d);u[((f<<1)+e|0)+62>>1]=x[e+46>>1];f=f+1|0;continue}break}d=a+484360|0;g=a+484376|0;uo(Wb(v[d>>2],w[g|0]),b,w[e+175|0]?128:64,65535,65535);f=0;if(!QQ(Wb(v[d>>2],w[g|0]))){break a}m=c&1;if(m){xg(a+484344|0,w[e+177|0])}i=a+484344|0;while(1){if(w[e+177|0]<=l>>>0){f=1;if(!(c&2)){break a}c=Zc(e+32|0,8,1,0,0);while(1){if((f|0)==32){break b}d=B(f,104)+a|0;g=d+484380|0;f:{if(!v[g>>2]|!x[d+484410>>1]){break f}d=x[((f<<1)+e|0)+62>>1];if(d>>>0<4){break f}if(!dd(b,d<<4)){break f}wg(c,g,b)}f=f+1|0;continue}}f=0;g:{h:{if(m){if(ph(i,l&65535,64)){break h}}while(1){if((f|0)==256){break g}if((Me(b)+2&255)>>>0<=252){$b(b,3)}f=f+1|0;continue}}o=e,p=Fb(v[_b(v[i>>2],l)>>2]),v[o+128>>2]=p;u[e+14>>1]=65535;v[e+16>>2]=63;h=0;i:while(1){f=0;if((h|0)==64){d=x[e+14>>1];if((d|0)==65535){break g}ze(_b(v[i>>2],l),Nm(Ue(Oe(e+32|0,12,d&255),v[e+16>>2])));break g}while(1){j:{k:{l:{if((f&65535)>>>0<=3){d=0;j=0;k=0;n=0;m:{n:{o:{p:{g=Me(b);switch(g-251|0){case 1:break j;case 0:break n;case 2:break p;default:break o}}t[v[e+128>>2]]=254;break j}d=e+32|0;Yq(d,b);j=w[Lb(d,0)|0];k=w[Lb(d,1)|0];n=w[Lb(d,2)|0];d=254;if((g|0)==254){break m}if(g>>>0>=96){break l}d=g}d=(B(d>>>4|0,12)+(d&15)|0)+37|0}g=d;d=v[e+128>>2];t[d|0]=g;break k}h=h+1|0;continue i}d=v[e+128>>2]}t[d+1|0]=(j&248)>>>3;g=k>>>1&120|j&7;if(g>>>0<=64){t[d+4|0]=g;t[d+2|0]=1}t[d+5|0]=n;PQ(d,k&15,h,w[e+175|0],e+14|0,e+16|0)}f=f+1|0;dA(e+128|0);continue}}}l=l+1|0;continue}}else{d=(f<<5)+a|0;df(d+480280|0);u[d+480284>>1]=f&1?64:192;f=f+1|0;continue}}f=P()|0;O()|0;Ab(e+128|0);break d}f=P()|0;O()|0}dc(e+32|0);T(f|0);L()}f=0;break a}f=1}kb=e+192|0;return f|0}function Ey(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,z=0,A=0,C=0,D=0,E=0;f=kb-16|0;kb=f;k=B(b,872)+a|0;m=k+1075800|0;i=w[m|0];l=a+1074312|0;Db(f+8|0,l,23);h=c&15;a:{b:{c:{if(Cb(v[v[f+8>>2]>>2],v[f+12>>2])){if(!(v[a+1074392>>2]|!w[(B(b,872)+a|0)+1075780|0])){t[m|0]=h;break c}e=w[m|0];if(e){g=e-1|0;t[m|0]=g;e=0;if(g&255){break c}}t[m|0]=h;e=1;break c}Db(f+8|0,l,52);d:{e:{g=c&256;if(!(!g|!Cb(v[v[f+8>>2]>>2],v[f+12>>2]))){g=v[a+480208>>2]&4096;if(!g){break e}e=B(b,872)+a|0;if(w[e+1075781|0]){i=BT(w[e+1075780|0])?1:i}if(w[(B(b,872)+a|0)+1075784|0]?w[e+1075782|0]==1:0){break b}e=0;if(h>>>0>i>>>0){break c}if(!g){break d}if($c(w[(B(b,872)+a|0)+1075780|0])){break c}break d}j=v[a+480180>>2];if(j&16777250){e=!(i?(i>>>0)%((h?h:1)>>>0)|0:1);i=i+1|0;break c}f:{if((j|0)!=16){if((j|0)!=1){break f}g=y[a+1074392>>2]%y[a+1074416>>2]|0;if(!g){if($c(w[(B(b,872)+a|0)+1075780|0])){break a}}e=h?!((g>>>0)%(h>>>0)|0):e;break c}e=v[a+1074392>>2]==(h|0)&(h|0)!=0;break c}g:{if(!g){break g}e=B(b,872)+a|0;if(w[e+1075782|0]!=1){break g}h=(w[e+1075785|0]>15)+h|0}h:{if(v[a+480208>>2]&4096?g:1){h=h?h:1;e=0;e=!v[a+1074416>>2]|g?e:!(y[a+1074392>>2]%(h>>>0)|0);i=i+1|0;break h}e=0;i=j&1048580?0:i}if(!(!(w[(B(b,872)+a|0)+1075780|0]|!g?v[a+1074392>>2]:1)|(i&255)>>>0<h>>>0)){e=1}Db(f+8|0,l,52);if(!Cb(v[v[f+8>>2]>>2],v[f+12>>2])|c){break c}e=!v[a+1074392>>2];break c}if(h>>>0>i>>>0){break c}}i=0;e=1}h=k+1074992|0;n=(B(b,872)+a|0)+1075068|0;i:{if(v[n>>2]){break i}Db(f+8|0,l,38);if(!Cb(v[v[f+8>>2]>>2],v[f+12>>2])){break i}if(!oj(v[h+656>>2])){break a}}Db(f+8|0,l,106);if(C=0,D=Cb(v[v[f+8>>2]>>2],v[f+12>>2]),E=v[(B(b,872)+a|0)+1075688>>2],E?C:D){break a}if(e){j=B(b,872)+a|0;q=j+1075680|0;g=v[q>>2];v[f+4>>2]=g;e=c>>>4&15;j:{if(!e){e=v[j+1075080>>2];break j}Db(f+8|0,l,52);k:{if(C=Cb(v[v[f+8>>2]>>2],v[f+12>>2]),D=0,E=w[(B(b,872)+a|0)+1075782|0]==1,E?C:D){break k}if(!(16191>>>e&1)){v[f+4>>2]=(B(g,t[e+33760|0])|0)/16;break k}v[f+4>>2]=g+(t[e+33776|0]<<2)}oe(f+4|0,0,256);g=(B(b,872)+a|0)+1075080|0;e=v[g>>2]|2097152;v[g>>2]=e}k=B(b,872)+a|0;r=k+1075692|0;s=v[r>>2];g=w[k+1075794|0];j=0;if(e&512){Db(f+8|0,l,108);j=Cb(v[v[f+8>>2]>>2],v[f+12>>2])}if(!((j^-1)&v[a+480180>>2]==2|(!v[n>>2]|(g-1&255)>>>0>119))){jN(a,b,0,g,1)}k=k+1075080|0;l:{if(!(v[a+480180>>2]&1048580)){break l}u=(c|0)<256;if((c|0)>255){break l}e=w[(B(b,872)+a|0)+1075781|0];if(!e){break l}u=1;Xp(a,h,e,0,0,1)}o=B(b,872)+a|0;p=o+1075652|0;z=v[p>>2];A=v[k>>2];v[p>>2]=0;Db(f+8|0,l,23);e=1;m:{if(Cb(v[v[f+8>>2]>>2],v[f+12>>2])){break m}e=0;if(v[a+480180>>2]!=2){break m}e=(j^1)&v[n>>2]!=0}lt(a,h,g,e,u,0,b);if(!w[o+1075781|0]){v[p>>2]=z}if(!(!(A&4096)|v[a+480180>>2]!=4)){v[k>>2]=v[k>>2]|4096}j=o+1075780|0;v[q>>2]=v[f+4>>2];if(x[a+480192>>1]){t[j|0]=g;hN(a,b)}g=v[a+480180>>2];if(!(!(g&16777248)|(w[j|0]|!s))){v[r>>2]=s}if(e){v[h>>2]=0;v[h+4>>2]=0}e=g&16777250;n:{if(d-11>>>0<4294967286){break n}g=v[(B(b,872)+a|0)+1075096>>2];if(!g){break n}o:{if((d|0)==1){b=v[(B(b,872)+a|0)+1075656>>2];break o}j=(B(b,872)+a|0)+1075656|0;b=v[Eb(g+68|0,d-2|0)>>2];v[j>>2]=b}$n(a,h,b)}i=e?i:0}a=f+8|0;Db(a,l,52);b=v[v[f+8>>2]>>2];d=v[f+12>>2];Db(a,l,23);if(Cb(v[v[f+8>>2]>>2],v[f+12>>2])){break a}i=(Cb(b,d)&c>>>8)+i|0}t[m|0]=i}kb=f+16|0}function Mba(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;e=kb-112|0;kb=e;g=a+140|0;Cj(e+88|0,g,1296125513);v[23540]=0;f=S(178,v[e+88>>2])|0;h=v[23540];v[23540]=0;a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{if((h|0)!=1){if(f){f=Nb(e+32|0);v[23540]=0;h=S(160,v[e+88>>2])|0;i=v[23540];v[23540]=0;if((i|0)==1){break p}v[23540]=0;U(776,e+88|0,f|0,h|0);h=v[23540];v[23540]=0;if((h|0)==1){break p}h=x[a+174>>1];v[23540]=0;U(777,e+72|0,h|0,f|0);h=v[23540];v[23540]=0;if((h|0)==1){break o}v[23540]=0;U(8,e+8|0,c|0,e+72|0);c=v[23540];v[23540]=0;if((c|0)==1){break n}c=e+8|0;Dc(d,c);zb(c);Ab(e+72|0);zb(f)}if(w[a+176|0]){v[23540]=0;R(778,e+32|0,d|0);c=v[23540];v[23540]=0;if((c|0)==1){break e}c=e+32|0;Be(b+43|0,c);zb(c)}v[23540]=0;U(771,e+32|0,g|0,1413894985);c=v[23540];v[23540]=0;if((c|0)==1){break l}v[23540]=0;f=S(779,e+32|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break k}g=e+32|0;Bb(g);c=a+40|0;zc(c);v[23540]=0;g=Q(780,c|0,g|0)|0;h=v[23540];v[23540]=0;if((h|0)==1){break j}if(g){q:{if(y[e+60>>2]<2){break q}v[23540]=0;g=Q(781,c|0,e+8|0)|0;h=v[23540];v[23540]=0;if((h|0)==1){break i}if(!g){break q}gM(e+8|0,b+12|0,b+16|0,v[b>>2],b+34|0,8,16,f)}v[23540]=0;c=Q(781,c|0,e+8|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break i}if(c){gM(e+8|0,b+4|0,b+8|0,v[b>>2],b+34|0,2,4,f)}c=v[e+44>>2];t[b+42|0]=c&128?0:c+1|0;Dk(b)}r:{if(w[b+42|0]){break r}c=v[a+60>>2];v[23540]=0;c=Q(651,c|0,7)|0;f=v[23540];v[23540]=0;if((f|0)==1){break j}if(!c){break r}c=a+60|0;zc(c);v[23540]=0;c=Q(782,c|0,e+8|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break d}if(!c){break r}c=t[e+8|0];t[b+42|0]=(c|0)<0?0:c+1|0}c=v[a+120>>2];v[23540]=0;c=S(178,c|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break j}if(!c){break f}v[23540]=0;h=a+120|0;c=S(157,h|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break c}v[e+72>>2]=c;xc(e+72|0,9);f=b+68|0;g=v[e+72>>2];c=0;while(1){if((c|0)==(g|0)){break g}v[23540]=0;R(783,h|0,e+8|0);i=v[23540];v[23540]=0;if((i|0)==1){break h}j=Eb(f,c),k=v[e+12>>2],v[j>>2]=k;c=c+1|0;continue}}a=P()|0;O()|0;break a}a=P()|0;O()|0;break m}a=P()|0;O()|0;break m}a=P()|0;O()|0;Ab(e+72|0)}zb(f);break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;Bb(e+32|0);break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;break a}$z(f+(g<<2)|0,vT(f),42744)}c=a+80|0;zc(c);v[23540]=0;f=Q(784,c|0,e+8|0)|0;g=v[23540];v[23540]=0;s:{if((g|0)==1){break s}if(!f){break b}if(w[e+8|0]&32){u[b+34>>1]=x[b+34>>1]|32}u[e+72>>1]=x[e+12>>1];u[e+6>>1]=256;j=b,k=x[Wc(e+72|0,e+6|0)>>1],u[j+28>>1]=k;u[e+72>>1]=x[e+14>>1];u[e+6>>1]=256;j=b,k=x[Wc(e+72|0,e+6|0)>>1],u[j+30>>1]=k;u[e+72>>1]=x[e+16>>1];u[e+6>>1]=64;j=b,k=x[Wc(e+72|0,e+6|0)>>1],u[j+32>>1]=k;t[b+38|0]=w[e+20|0];t[b+39|0]=w[e+21|0];t[b+40|0]=w[e+22|0];t[b+41|0]=w[e+23|0];f=v[a+88>>2];a=v[a+80>>2];v[23540]=0;a=W(156,a|0,f|0,32)|0;f=v[23540];v[23540]=0;if((f|0)==1){break s}if(!a){break b}v[23540]=0;R(785,c|0,d|0);a=v[23540];v[23540]=0;if((a|0)==1){break s}v[23540]=0;a=S(202,c|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break s}v[23540]=0;U(786,c|0,b+43|0,a|0);a=v[23540];v[23540]=0;if((a|0)!=1){break b}}a=P()|0;O()|0;break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;break a}Bb(e+88|0);kb=e+112|0;return}Bb(e+88|0);T(a|0);L()}function Xv(a){var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=kb-96|0;kb=c;i=a+32|0;Sc(c+56|0,i,11);a:{if(k=1,l=Cb(v[v[c+56>>2]>>2],v[c+60>>2]),m=v[a+8>>2],m?k:l){d=v[a+36>>2];b=v[a+76>>2]+v[a+20>>2]|0;f=v[a+16>>2];e=f+v[a+72>>2]|0;b=Xg(c+80|0,e,e>>>0<f>>>0?b+1|0:b);e=v[b+12>>2];v[c+24>>2]=v[b+8>>2];v[c+28>>2]=e;e=v[b+4>>2];v[c+16>>2]=v[b>>2];v[c+20>>2]=e;Zj(d,c+16|0);b=v[a+36>>2];if(Yk(v[(v[v[b>>2]-12>>2]+b|0)+16>>2])){uh(a,2,256);break a}b=v[a+104>>2];e=a+52|0;f=v[e>>2];d=Pi(f,v[e+4>>2]);b:{if(b>>>0>d>>>0){h=kb-32|0;kb=h;f=b-d|0;d=v[Gb(e)>>2];g=v[e+4>>2];c:{if(f>>>0<=(d-g|0)/24>>>0){d=kb-16|0;kb=d;b=oE(d,e,f);e=v[b+4>>2];f=v[b+8>>2];while(1){if((e|0)==(f|0)){lc(b);kb=d+16|0}else{nE(e);e=e+24|0;v[b+4>>2]=e;continue}break}break c}b=Gb(e);d=sE(h+8|0,tE(e,Pi(v[e>>2],g)+f|0),Pi(v[e>>2],v[e+4>>2]),b);b=kb-16|0;kb=b;v[b>>2]=v[d+8>>2];g=v[d+8>>2];v[b+8>>2]=d+8;v[b+4>>2]=g+B(f,24);f=v[b>>2];while(1){if(v[b+4>>2]!=(f|0)){nE(f);f=v[b>>2]+24|0;v[b>>2]=f;continue}break}Ud(b);kb=b+16|0;rE(e,d);pE(d)}kb=h+32|0;break b}if(b>>>0<d>>>0){Od(e,f+B(b,24)|0)}}h=a+40|0;tn(h,v[a+104>>2]<<2);e=0;while(1){if(y[a+104>>2]>e>>>0){d=v[a+36>>2];if(Yk(v[(v[v[d>>2]-12>>2]+d|0)+16>>2])){uh(a,2,1024);break a}b=x[a+24>>1];u[c+32>>1]=b;if((b|0)==65535){Zv(d,c+32|0);b=x[c+32>>1]}d=fd(v[a+40>>2],v[a+44>>2]);f=b&65535;d:{if(!f){b=0;break d}if(f>>>0>(d^-1)>>>0){break d}Qi(h,d+f|0);Uk(v[a+36>>2],Lb(v[a+40>>2],d),f)}f=lf(v[a+52>>2],e);v[f>>2]=d;u[f+20>>1]=b;Sc(c+56|0,i,6);if(Cb(v[v[c+56>>2]>>2],v[c+60>>2])){Jk(v[a+36>>2],c+56|0);d=v[c+56>>2];b=v[c+60>>2];if(!Yv(d,b)){uh(a,2,2048);break a}f=lf(v[a+52>>2],e);v[f+8>>2]=d;v[f+12>>2]=b}d=v[a+8>>2];e:{if(d){b=lf(v[a+52>>2],e);v[b+16>>2]=d;break e}Sc(c+56|0,i,7);if(!Cb(v[v[c+56>>2]>>2],v[c+60>>2])){b=lf(v[a+52>>2],e);break e}Jk(v[a+36>>2],c+56|0);d=v[c+56>>2];if(!Yv(d,v[c+60>>2])){uh(a,2,2048);break a}b=lf(v[a+52>>2],e);v[b+16>>2]=d}f:{if(v[b+16>>2]==-1){break f}Sc(c+56|0,i,6);if(Cb(v[v[c+56>>2]>>2],v[c+60>>2])){break f}g:{if(!e){f=0;b=0;d=lf(v[a+52>>2],0);break g}g=v[a+52>>2];b=lf(g,e-1|0);f=v[b+16>>2];d=v[b+8>>2]+f|0;b=v[b+12>>2];b=d>>>0<f>>>0?b+1|0:b;f=d;d=lf(g,e)}v[d+8>>2]=f;v[d+12>>2]=b}Sc(c+56|0,i,8);if(Cb(v[v[c+56>>2]>>2],v[c+60>>2])){u[c+78>>1]=0;Zv(v[a+36>>2],c+78|0);Sc(c+56|0,i,9);$l(v[a+36>>2],x[c+78>>1]<<Cb(v[v[c+56>>2]>>2],v[c+60>>2]))}e=e+1|0;continue}break}me(c+56|0,v[a+36>>2]);b=v[c+68>>2];v[a+80>>2]=v[c+64>>2];v[a+84>>2]=b}e=c+56|0;Sc(e,i,4);Ze(e,1);f=v[a+84>>2];h=v[a+96>>2];g=v[a+16>>2];d=h+g|0;j=v[a+100>>2];b=j+v[a+20>>2]|0;b=d>>>0<g>>>0?b+1|0:b;g=d;d=(h|0)==v[a+72>>2]&(j|0)==v[a+76>>2];h=d?v[a+80>>2]:g;v[a+88>>2]=h;b=d?f:b;v[a+92>>2]=b;d=v[a+36>>2];b=Xg(c+40|0,h,b);f=v[b+12>>2];v[c+8>>2]=v[b+8>>2];v[c+12>>2]=f;f=v[b+4>>2];v[c>>2]=v[b>>2];v[c+4>>2]=f;Zj(d,c);Sc(e,i,6);if(Cb(v[v[c+56>>2]>>2],v[c+60>>2])){break a}Sc(c+32|0,i,7);if(!(k=1,l=Cb(v[v[c+32>>2]>>2],v[c+36>>2]),m=v[a+8>>2],m?k:l)){break a}b=v[a+88>>2];e=v[a+16>>2];i=b-e|0;d=v[a+92>>2]-(v[a+20>>2]+(b>>>0<e>>>0)|0)|0;f=v[a+52>>2];h=v[a+104>>2];a=0;while(1){if((a|0)==(h|0)){break a}b=lf(f,a);g=b;j=v[b+8>>2];e=j+i|0;b=v[b+12>>2]+d|0;v[g+8>>2]=e;v[g+12>>2]=e>>>0<j>>>0?b+1|0:b;a=a+1|0;continue}}kb=c+96|0}function JK(a){var b=0,c=C(0),d=C(0),e=C(0),f=C(0),g=C(0),h=0,i=0,j=0,k=0,l=C(0),m=C(0),n=0,o=C(0),p=0,q=C(0),r=C(0),s=C(0),u=0,w=C(0);j=kb-16|0;kb=j;b=a+4208|0;i=wj(C(z[Eb(b,12)>>2]*C(3)));v[a+4264>>2]=i;d=C(v[v[a+16>>2]+24620>>2]>>>((i>>>1^-1)&1)>>>0);z[a+4268>>2]=d;u=a,w=C(C(z[Eb(b,9)>>2]*C(100))*C(.0061803399585187435)),z[u+4272>>2]=w;u=j,w=te(C(10),C(C(IK(a)+C(C(z[Eb(b,5)>>2]*C(11e3))+C(-1e4)))/C(2e3))),z[u+12>>2]=w;v[j+8>>2]=1065353216;u=a,w=C(z[nm(j+12|0,j+8|0)>>2]*C(.7609999775886536)),z[u+4280>>2]=w;c=te(C(10),C(C(C(C(z[Eb(b,1)>>2]*C(1e4))+C(-1e4))/C(100))/C(10)));if(c!=C(1)){d=Fp(C(C(HK(a)*C(6.2831854820251465))/d));f=C(c+c);e=C(c*c);c=bz(C(C(C(C(d*f)+C(-2))+C(K(C(C(C(C(d*C(C(d*e)*C(4)))+C(c*C(8)))-C(e*C(4)))-C(C(d*c)*C(8))))))/C(f+C(-2))),C(0),C(1))}else{c=C(0)}z[a+4276>>2]=c;i=kb-16|0;kb=i;c=z[a+4268>>2];b=a+4208|0;d=C(z[Eb(b,6)>>2]*C(.30000001192092896));u=i,w=C(z[Eb(b,8)>>2]*C(.10000000149011612)),z[u+12>>2]=w;v[i+8>>2]=1000593162;f=z[Lx(i+12|0,i+8|0)>>2];e=C(c*C(C(d+f)+C(.007000000216066837)));a:{if(C(D(e))<C(2147483648)){b=~~e;break a}b=-2147483648}v[a+4352>>2]=b;b=1;while(1){if((b|0)==12){u=i,w=C(C(C(C(z[Eb(a+4208|0,10)>>2]*C(100))/C(100))+C(.10000000149011612))*C(.9090999960899353)),z[u+12>>2]=w;v[i+8>>2]=1065353216;d=z[nm(i+12|0,i+8|0)>>2];f=C(c*C(C(d*C(75))/C(1e3)));d=C(c*C(C(d*C(67))/C(1e3)));b=0;while(1){if((b|0)==6){h=a+4348|0;d=C(c*C(.0035299998708069324));b:{if(C(D(d))<C(2147483648)){b=~~d;break b}b=-2147483648}v[h>>2]=b;h=a+4344|0;d=C(c*C(.0032500000670552254));c:{if(C(D(d))<C(2147483648)){b=~~d;break c}b=-2147483648}v[h>>2]=b;h=a+4340|0;c=C(c*C(.009999999776482582));d:{if(C(D(c))<C(2147483648)){b=~~c;break d}b=-2147483648}v[h>>2]=b}else{h=(b<<2)+a|0;p=h+4316|0;n=b+n|0;e=te(C(.9300000071525574),C(n|0));g=C(f*e);e:{if(C(D(g))<C(2147483648)){k=~~g;break e}k=-2147483648}v[p>>2]=k;k=h+4292|0;e=C(d*e);f:{if(C(D(e))<C(2147483648)){h=~~e;break f}h=-2147483648}v[k>>2]=h;b=b+1|0;continue}break}b=0;while(1){if((b|0)!=15){LK((B(b,24)+a|0)+4504|0,v[((b<<2)+a|0)+4292>>2]);b=b+1|0;continue}break}kb=i+16|0}else{k=((B(b&1,24)+a|0)+(b<<1&-4)|0)+4352|0;e=C(c*C(C(f*z[(b<<2)+47008>>2])+d));g:{if(C(D(e))<C(2147483648)){h=~~e;break g}h=-2147483648}v[k>>2]=h;b=b+1|0;continue}break}b=kb-16|0;kb=b;d=xh(a,5);e=xh(a,11);c=C(d*xh(a,4));d=C(C(c*C(.03999999910593033))+C(C(d*C(.02250000089406967))+C(0)));f=C(e*xh(a,10));e=C(C(f*C(.03999999910593033))+C(C(e*C(.02250000089406967))+C(0)));if(t[a+4264|0]&1){g=xh(a,3);l=xh(a,9);g=C(c*g);c=C(g*xh(a,2));d=C(C(c*C(.1444000005722046))+C(C(g*C(.12250000238418579))+d));g=C(f*l);f=C(g*xh(a,8));e=C(C(f*C(.1444000005722046))+C(C(g*C(.12250000238418579))+e))}xh(a,12);g=z[a+4496>>2];l=xh(a,1);m=xh(a,7);q=xh(a,0);r=xh(a,6);u=b,w=te(C(10),C(C(IK(a)+C(C(z[Eb(a+4208|0,7)>>2]*C(12e3))+C(-1e4)))/C(2e3))),z[u+12>>2]=w;v[b+8>>2]=1065353216;o=z[nm(b+12|0,b+8|0)>>2];s=c;c=C(g*g);g=C(l*C(s*c));l=C(q*g);c=C(m*C(f*c));f=C(r*c);m=C(C(C(l+f)*C(-.5))+C(1));z[a+4284>>2]=o*C(K(C(m/C(C(l*C(.1444000005722046))+C(C(c*C(.1444000005722046))+d)))));z[a+4288>>2]=o*C(K(C(m/C(C(f*C(.1444000005722046))+C(C(g*C(.1444000005722046))+e)))));kb=b+16|0;t[a+5046|0]=0;kb=j+16|0}function ZM(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,x=0,y=0;if(b){h=a+327720|0;c=kb-400|0;kb=c;RO(c+384|0,8);v[23540]=0;oa(761,c+368|0,9);i=v[23540];v[23540]=0;a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{if((i|0)!=1){v[23540]=0;i=Q(762,c+352|0,14)|0;e=v[23540];v[23540]=0;if((e|0)==1){break l}v[23540]=0;R(763,c+384|0,i|0);e=v[23540];v[23540]=0;if((e|0)==1){break k}v[23540]=0;R(763,c+368|0,i|0);e=v[23540];v[23540]=0;if((e|0)==1){break k}QO(c+280|0,4900);QO(c+208|0,32e3);IO(c+136|0,8377175819504598e-21,16754351639009197e-21,8377175819504598e-21,-1.991112714669597,.9911462233728751);v[23540]=0;e=Q(764,c+104|0,c+384|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break j}vt(c+120|0,c+280|0,e);qe(e);v[23540]=0;e=Q(764,c+72|0,c+368|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break i}vt(c+88|0,c+208|0,e);qe(e);v[23540]=0;e=Q(764,c+40|0,c+120|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break h}vt(c+56|0,c+136|0,e);qe(e);v[23540]=0;e=Q(764,c+8|0,c+88|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break g}g=c+24|0;vt(g,c+136|0,e);qe(e);e=c+120|0;bq(e);l=c+56|0;bq(l);m=c+88|0;bq(m);bq(g);p=c+368|0;bq(p);aq(v[c+120>>2],v[c+124>>2],co(h,0));aq(v[c+56>>2],v[c+60>>2],co(h,1));aq(v[c+88>>2],v[c+92>>2],co(h,2));aq(v[c+24>>2],v[c+28>>2],co(h,3));aq(v[c+368>>2],v[c+372>>2],co(h,4));qe(g);qe(l);qe(m);qe(e);Bm(i);qe(p);qe(c+384|0);kb=c+400|0;break a}a=P()|0;O()|0;break b}a=P()|0;O()|0;break c}a=P()|0;O()|0;break d}a=P()|0;O()|0;break d}a=P()|0;O()|0;break e}a=P()|0;O()|0;break f}a=P()|0;O()|0;qe(c+56|0)}qe(c+88|0)}qe(c+120|0)}Bm(i)}qe(c+368|0)}qe(c+384|0);T(a|0);L()}fy(a+131112|0,9.6377,.97);fy(a+196648|0,8.5,.5);fy(a+262184|0,2.7625,.425)}c=a+368680|0;if(!(t=0,x=jM(c,a),y=b,y?t:x)){e=a+24|0;r=A[a+8>>3];g=w[a+16|0];h=kb+-64|0;kb=h;m:while(1){if((n|0)!=8193){s=+(n-4096|0)*.0001220703125;b=0;o=0;while(1)if((b|0)==8){j=1/o;l=n<<3;b=0;while(1)if((b|0)==8){n=n+1|0;continue m}else{m=e+(b+l<<1)|0;d=H(A[h+(b<<3)>>3]*32768*j+.5);d=d<-32768?-32768:F(d,32768);n:{if(D(d)<2147483648){i=~~d;break n}i=-2147483648}u[m>>1]=i;b=b+1|0;continue}}else{j=r;f=1;d=+(b|0)-s;q=d+-3.5;if(!(D(q)<1e-8)){o:{p:{switch(g|0){case 0:f=af(d*.8975979010256552)*-.5+.5;break o;case 1:f=af(d*.8975979010256552)*-.46+.54;break o;case 2:f=af(d*1.7951958020513104)*.08+(af(d*.8975979010256552)*-.5+.42);break o;case 3:f=af(d*1.7951958020513104)*.05677+(af(d*.8975979010256552)*-.49364+.44959);break o;case 4:f=af(d*1.7951958020513104)*.07922+(af(d*.8975979010256552)*-.49755+.42323);break o;case 5:f=af(d*1.7951958020513104);k=af(d*.8975979010256552);f=af(d*2.6927937030769655)*-.01168+(f*.14128+(k*-.48829+.35875));break o;case 6:f=af(d*1.7951958020513104);k=af(d*.8975979010256552);f=af(d*2.6927937030769655)*-.00183+(f*.09392+(k*-.49703+.40217));break o;case 7:break p;default:break o}}f=af(d*1.7951958020513104);k=af(d*.8975979010256552);f=af(d*2.6927937030769655)*-.00122+(f*.09831+(k*-.49804+.40243))}d=q*3.141592653589793;j=Di(d*j)/d}j=f*j;A[h+(b<<3)>>3]=j;o=o+j;b=b+1|0;continue}}break}kb=h- -64|0;b=v[a+20>>2];v[c+16>>2]=v[a+16>>2];v[c+20>>2]=b;b=v[a+12>>2];v[c+8>>2]=v[a+8>>2];v[c+12>>2]=b;b=v[a+4>>2];v[c>>2]=v[a>>2];v[c+4>>2]=b}}function _ha(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;f=kb-240|0;kb=f;me(f+224|0,b);g=kb-48|0;kb=g;v[g+44>>2]=0;pk(b,g+44|0);a:{b:{c:{if(v[g+44>>2]!=(Vm(14127)|0)){break c}v[g+40>>2]=0;e=kb-32|0;kb=e;v[e+24>>2]=0;Uv(e+8|0,e+24|0);yn(e+16|0,b,v[e+8>>2],v[e+12>>2]);Zl(g+40|0,v[e+24>>2]);kb=e+32|0;e=-1;i=v[g+40>>2];if(i-3>>>0<4294967294){break c}d:{e:{f:{if(i>>>0<=1){i=Nb(g+24|0);v[23540]=0;h=W(483,b|0,i|0,256)|0;j=v[23540];v[23540]=0;if((j|0)==1){break b}if(!h){break e}v[23540]=0;U(11,g+8|0,d|0,i|0);h=v[23540];v[23540]=0;if((h|0)!=1){break f}break b}i=Nb(g+24|0);v[23540]=0;h=Q(485,b|0,i|0)|0;j=v[23540];v[23540]=0;if((j|0)==1){break b}if(!h){break d}v[23540]=0;U(11,g+8|0,d|0,i|0);h=v[23540];v[23540]=0;if((h|0)==1){break b}}h=g+8|0;Jb(c,h);Ab(h);zb(i);Wf(b,h);i=0;v[g+24>>2]=0;pk(b,g+24|0);h=v[g+24>>2];if(h>>>0>50){break c}while(1){if((h|0)!=(i|0)){if(!EL(a,b,d)){break c}i=i+1|0;continue}break}v[g+24>>2]=0;pk(b,g+24|0);e=v[g+24>>2]==(Vm(14173)|0)?1:-1;break c}zb(i);break c}zb(i)}kb=g+48|0;break a}a=P()|0;O()|0;zb(i);T(a|0);L()}g:{if(e){break g}Rl(v[v[b>>2]-12>>2]+b|0,0);e=v[f+236>>2];v[f+16>>2]=v[f+232>>2];v[f+20>>2]=e;e=v[f+228>>2];v[f+8>>2]=v[f+224>>2];v[f+12>>2]=e;b=Yl(f+112|0,Zj(b,f+8|0));v[23540]=0;e=Q(449,f+96|0,14312)|0;g=v[23540];v[23540]=0;h:{if((g|0)!=1){v[23540]=0;v[f+80>>2]=3;v[f+84>>2]=0;U(450,b|0,e|0,f+80|0);g=v[23540];v[23540]=0;if((g|0)!=1){Xb(e);t[f+95|0]=0;v[23540]=0;e=Q(449,f+80|0,14768)|0;g=v[23540];v[23540]=0;if((g|0)!=1){v[23540]=0;U(451,b|0,f+95|0,e|0);g=v[23540];v[23540]=0;if((g|0)!=1){Xb(e);v[23540]=0;g=w[f+95|0];e=S(464,b|0)|0;i=v[23540];v[23540]=0;if((i|0)!=1){v[23540]=0;i=S(465,b|0)|0;h=v[23540];v[23540]=0;if((h|0)!=1){g=g?0:d;v[f+72>>2]=e;i:{j:{k:{l:{while(1){if(!Pb(e,i)){a=Kk(w[b|0]);kh(b);e=a?-1:1;break g}v[23540]=0;d=Q(449,f+56|0,15840)|0;e=v[23540];v[23540]=0;if((e|0)==1){break k}e=v[b+44>>2];h=v[b+40>>2];v[23540]=0;e=fa(466,h|0,e|0,v[f+72>>2],d|0)|0;h=v[23540];v[23540]=0;if((h|0)==1){break j}Xb(d);m:{n:{if(e){v[23540]=0;X(467,b|0,f+72|0,c|0,g|0);d=v[23540];v[23540]=0;if((d|0)!=1){break n}break i}v[23540]=0;d=Q(449,f+40|0,15510)|0;e=v[23540];v[23540]=0;o:{p:{if((e|0)!=1){e=v[b+44>>2];h=v[b+40>>2];v[23540]=0;e=fa(466,h|0,e|0,v[f+72>>2],d|0)|0;h=v[23540];v[23540]=0;if((h|0)==1){break p}Xb(d);if(!e){break o}v[23540]=0;U(468,b|0,f+72|0,f+70|0);d=v[23540];v[23540]=0;if((d|0)==1){break i}break n}a=P()|0;O()|0;break h}a=P()|0;O()|0;Xb(d);break h}v[23540]=0;d=Q(449,f+24|0,15409)|0;e=v[23540];v[23540]=0;if((e|0)==1){break m}e=v[b+44>>2];h=v[b+40>>2];v[23540]=0;e=fa(466,h|0,e|0,v[f+72>>2],d|0)|0;h=v[23540];v[23540]=0;if((h|0)==1){break l}Xb(d);if(!e){break n}v[23540]=0;X(469,b|0,f+72|0,a|0,g|0);d=v[23540];v[23540]=0;if((d|0)==1){break i}}Wx(f+72|0);e=v[f+72>>2];continue}break}a=P()|0;O()|0;break h}a=P()|0;O()|0;Xb(d);break h}a=P()|0;O()|0;break h}a=P()|0;O()|0;Xb(d);break h}a=P()|0;O()|0;break h}a=P()|0;O()|0;break h}a=P()|0;O()|0;break h}a=P()|0;O()|0;Xb(e);break h}a=P()|0;O()|0;break h}a=P()|0;O()|0;Xb(e);break h}a=P()|0;O()|0}kh(b);T(a|0);L()}kb=f+240|0;return e|0}function lia(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;e=kb-400|0;kb=e;g=kb-32|0;kb=g;d=g+8|0;OA(d,b);Su(g,d);v[23540]=0;U(463,e+240|0,v[g>>2],v[g+4>>2]);b=v[23540];v[23540]=0;a:{if((b|0)!=1){Uc(g+8|0);kb=g+32|0;break a}a=P()|0;O()|0;Uc(g+8|0);T(a|0);L()}v[23540]=0;U(446,e+128|0,v[e+240>>2],v[e+244>>2]);b=v[23540];v[23540]=0;b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{z:{if((b|0)!=1){v[23540]=0;g=Q(89,e+256|0,e+128|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break z}zb(e+128|0);ic(e+240|0);if(c>>>0<2189){break g}b=Yl(e+128|0,g);v[23540]=0;c=Q(449,e+112|0,10143)|0;d=v[23540];v[23540]=0;if((d|0)==1){break x}v[23540]=0;v[e+96>>2]=19988497;v[e+100>>2]=0;U(450,b|0,c|0,e+96|0);d=v[23540];v[23540]=0;if((d|0)==1){break w}Xb(c);t[e+111|0]=0;v[23540]=0;c=Q(449,e+96|0,11037)|0;d=v[23540];v[23540]=0;if((d|0)==1){break i}v[23540]=0;U(451,b|0,e+111|0,c|0);d=v[23540];v[23540]=0;if((d|0)==1){break v}Xb(c);c=0;c=w[e+111|0]?c:v[a+1298404>>2];f=v[a+4>>2];v[23540]=0;d=Q(449,e+80|0,15840)|0;h=v[23540];v[23540]=0;if((h|0)==1){break u}v[23540]=0;X(452,b|0,f|0,d|0,c|0);f=v[23540];v[23540]=0;if((f|0)==1){break t}Xb(d);v[23540]=0;d=Q(449,e- -64|0,15510)|0;f=v[23540];v[23540]=0;if((f|0)==1){break s}v[23540]=0;X(453,b|0,a|0,d|0,c|0);c=v[23540];v[23540]=0;if((c|0)==1){break r}Xb(d);v[23540]=0;c=Q(449,e+48|0,15409)|0;d=v[23540];v[23540]=0;if((d|0)==1){break q}v[23540]=0;d=a+484360|0;U(454,b|0,d|0,c|0);f=v[23540];v[23540]=0;if((f|0)==1){break p}Xb(c);v[23540]=0;c=Q(449,e+32|0,26710)|0;f=v[23540];v[23540]=0;if((f|0)==1){break o}v[23540]=0;U(455,b|0,a+484344|0,c|0);f=v[23540];v[23540]=0;if((f|0)==1){break n}Xb(c);f=v[a+1298404>>2];v[23540]=0;c=Q(449,e+16|0,26716)|0;h=v[23540];v[23540]=0;if((h|0)==1){break m}v[23540]=0;X(456,b|0,d|0,c|0,f|0);d=v[23540];v[23540]=0;if((d|0)==1){break l}Xb(c);if(Kk(w[b|0])){v[23540]=0;c=Q(1,e|0,16319)|0;d=v[23540];v[23540]=0;if((d|0)==1){break k}a=v[a+1298464>>2];v[23540]=0;U(376,a|0,1,c|0);a=v[23540];v[23540]=0;if((a|0)==1){break j}Ab(c)}kh(b);break f}a=P()|0;O()|0;break y}a=P()|0;O()|0;zb(e+128|0)}ic(e+240|0);break b}a=P()|0;O()|0;break h}a=P()|0;O()|0;Xb(c);break h}a=P()|0;O()|0;Xb(c);break h}a=P()|0;O()|0;break h}a=P()|0;O()|0;Xb(d);break h}a=P()|0;O()|0;break h}a=P()|0;O()|0;Xb(d);break h}a=P()|0;O()|0;break h}a=P()|0;O()|0;Xb(c);break h}a=P()|0;O()|0;break h}a=P()|0;O()|0;Xb(c);break h}a=P()|0;O()|0;break h}a=P()|0;O()|0;Xb(c);break h}a=P()|0;O()|0;break h}a=P()|0;O()|0;Ab(c);break h}a=P()|0;O()|0}kh(b);break c}b=Nb(e+128|0);d=v[a+1298404>>2];f=v[a+4>>2];v[23540]=0;d=fa(457,f|0,g|0,b|0,d|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break e}A:{if((d|0)!=1){v[23540]=0;c=Q(1,e+112|0,16625)|0;d=v[23540];v[23540]=0;B:{if((d|0)!=1){a=v[a+1298464>>2];v[23540]=0;U(376,a|0,1,c|0);a=v[23540];v[23540]=0;if((a|0)==1){break B}Ab(c);break A}a=P()|0;O()|0;break d}a=P()|0;O()|0;Ab(c);break d}d=v[a+1298404>>2];v[23540]=0;X(458,g|0,a|0,d|0,c>>>0<2188|0);a=v[23540];v[23540]=0;if((a|0)==1){break e}}Ab(b)}sf(g);kb=e+400|0;return}a=P()|0;O()|0}Ab(b)}sf(g)}T(a|0);L()}function Mb(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;a:{if(!a){break a}d=a-8|0;b=v[a-4>>2];a=b&-8;f=d+a|0;b:{if(b&1){break b}if(!(b&3)){break a}b=v[d>>2];d=d-b|0;if(d>>>0<y[116052]){break a}a=a+b|0;if(v[116053]!=(d|0)){if(b>>>0<=255){e=v[d+8>>2];b=b>>>3|0;c=v[d+12>>2];if((c|0)==(e|0)){i=464192,j=v[116048]&Nka(-2,b),v[i>>2]=j;break b}v[e+12>>2]=c;v[c+8>>2]=e;break b}h=v[d+24>>2];b=v[d+12>>2];c:{if((d|0)!=(b|0)){c=v[d+8>>2];v[c+12>>2]=b;v[b+8>>2]=c;break c}d:{e=d+20|0;c=v[e>>2];if(c){break d}e=d+16|0;c=v[e>>2];if(c){break d}b=0;break c}while(1){g=e;b=c;e=b+20|0;c=v[e>>2];if(c){continue}e=b+16|0;c=v[b+16>>2];if(c){continue}break}v[g>>2]=0}if(!h){break b}e=v[d+28>>2];c=(e<<2)+464496|0;e:{if(v[c>>2]==(d|0)){v[c>>2]=b;if(b){break e}i=464196,j=v[116049]&Nka(-2,e),v[i>>2]=j;break b}v[h+(v[h+16>>2]==(d|0)?16:20)>>2]=b;if(!b){break b}}v[b+24>>2]=h;c=v[d+16>>2];if(c){v[b+16>>2]=c;v[c+24>>2]=b}c=v[d+20>>2];if(!c){break b}v[b+20>>2]=c;v[c+24>>2]=b;break b}b=v[f+4>>2];if((b&3)!=3){break b}v[116050]=a;v[f+4>>2]=b&-2;v[d+4>>2]=a|1;v[a+d>>2]=a;return}if(d>>>0>=f>>>0){break a}b=v[f+4>>2];if(!(b&1)){break a}f:{if(!(b&2)){if(v[116054]==(f|0)){v[116054]=d;a=v[116051]+a|0;v[116051]=a;v[d+4>>2]=a|1;if(v[116053]!=(d|0)){break a}v[116050]=0;v[116053]=0;return}if(v[116053]==(f|0)){v[116053]=d;a=v[116050]+a|0;v[116050]=a;v[d+4>>2]=a|1;v[a+d>>2]=a;return}a=(b&-8)+a|0;g:{if(b>>>0<=255){e=v[f+8>>2];b=b>>>3|0;c=v[f+12>>2];if((c|0)==(e|0)){i=464192,j=v[116048]&Nka(-2,b),v[i>>2]=j;break g}v[e+12>>2]=c;v[c+8>>2]=e;break g}h=v[f+24>>2];b=v[f+12>>2];h:{if((f|0)!=(b|0)){c=v[f+8>>2];v[c+12>>2]=b;v[b+8>>2]=c;break h}i:{e=f+20|0;c=v[e>>2];if(c){break i}e=f+16|0;c=v[e>>2];if(c){break i}b=0;break h}while(1){g=e;b=c;e=b+20|0;c=v[e>>2];if(c){continue}e=b+16|0;c=v[b+16>>2];if(c){continue}break}v[g>>2]=0}if(!h){break g}e=v[f+28>>2];c=(e<<2)+464496|0;j:{if(v[c>>2]==(f|0)){v[c>>2]=b;if(b){break j}i=464196,j=v[116049]&Nka(-2,e),v[i>>2]=j;break g}v[h+(v[h+16>>2]==(f|0)?16:20)>>2]=b;if(!b){break g}}v[b+24>>2]=h;c=v[f+16>>2];if(c){v[b+16>>2]=c;v[c+24>>2]=b}c=v[f+20>>2];if(!c){break g}v[b+20>>2]=c;v[c+24>>2]=b}v[d+4>>2]=a|1;v[a+d>>2]=a;if(v[116053]!=(d|0)){break f}v[116050]=a;return}v[f+4>>2]=b&-2;v[d+4>>2]=a|1;v[a+d>>2]=a}if(a>>>0<=255){b=(a&-8)+464232|0;c=v[116048];a=1<<(a>>>3);k:{if(!(c&a)){v[116048]=a|c;a=b;break k}a=v[b+8>>2]}v[b+8>>2]=d;v[a+12>>2]=d;v[d+12>>2]=b;v[d+8>>2]=a;return}e=31;if(a>>>0<=16777215){b=a>>>8|0;g=b+1048320>>>16&8;b=b<<g;e=b+520192>>>16&4;b=b<<e;c=b+245760>>>16&2;b=(b<<c>>>15|0)-(c|(e|g))|0;e=(b<<1|a>>>b+21&1)+28|0}v[d+28>>2]=e;v[d+16>>2]=0;v[d+20>>2]=0;g=(e<<2)+464496|0;l:{m:{c=v[116049];b=1<<e;n:{if(!(c&b)){v[116049]=b|c;v[g>>2]=d;v[d+24>>2]=g;break n}e=a<<((e|0)==31?0:25-(e>>>1|0)|0);b=v[g>>2];while(1){c=b;if((v[b+4>>2]&-8)==(a|0)){break m}b=e>>>29|0;e=e<<1;g=c+(b&4)|0;b=v[g+16>>2];if(b){continue}break}v[g+16>>2]=d;v[d+24>>2]=c}v[d+12>>2]=d;v[d+8>>2]=d;break l}a=v[c+8>>2];v[a+12>>2]=d;v[c+8>>2]=d;v[d+24>>2]=0;v[d+12>>2]=c;v[d+8>>2]=a}a=v[116056]-1|0;v[116056]=a?a:-1}}function ZI(a,b,c,d,e,f){var g=0,h=0,i=0,j=0;g=kb-48|0;kb=g;a:{b:{if(ss(c)){h=v[b+484344>>2];if(xe(h,v[b+484348>>2],c&65535)){break b}}c=a;a=Nb(g+32|0);b=Nb(g+16|0);pi(c,a,b);zb(b);zb(a);break a}c=_b(h,c);if(!(v[c+12>>2]>(d|0)&(d|0)>=0)){c=a;a=Nb(g+32|0);b=Nb(g+16|0);pi(c,a,b);zb(b);zb(a);break a}if(!(x[b+480188>>1]>e>>>0&(e|0)>=0)){c=a;a=Nb(g+32|0);b=Nb(g+16|0);pi(c,a,b);zb(b);zb(a);break a}if(f>>>0>=6){c=a;a=Nb(g+32|0);b=Nb(g+16|0);pi(c,a,b);zb(b);zb(a);break a}c=jd(v[c>>2],v[v[c+48>>2]+12>>2],d,e&65535);c:{d:{e:{f:{switch(f|0){case 0:g:{h:{i:{j:{k:{d=w[c|0];if(!$c(d)){if(!Pp(d)){break k}}e=g+16|0;zM(e,b,d,w[c+1|0]);v[23540]=0;R(1009,g+32|0,e|0);b=v[23540];v[23540]=0;d=1;if((b|0)!=1){break j}c=P()|0;O()|0;break g}d=0;v[23540]=0;Q(55,g+32|0,16799)|0;b=v[23540];v[23540]=0;if((b|0)==1){break i}}b=9987;c=w[c|0];if(!$c(c)){b=Pp(c)?10297:16799}v[23540]=0;b=Q(55,g|0,b|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break h}c=a;a=g+32|0;pi(c,a,b);zb(b);zb(a);if(!d){break a}Ab(g+16|0);break a}c=P()|0;O()|0;break d}c=P()|0;O()|0;zb(g+32|0);if(!d){break d}}Ab(g+16|0);break d;case 1:b=c+1|0;l:{if(w[c+1|0]){Zt(g+32|0,b);break l}Kc(g+32|0,16804)}b=w[b|0];v[23540]=0;b=Q(55,g+16|0,(b?10791:16804)|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break e}c=a;a=g+32|0;pi(c,a,b);zb(b);zb(a);break a;case 2:m:{if(fh(w[c|0])){Kc(g+32|0,17859);break m}d=w[c+2|0];if(d){of(g+32|0,1,$L(v[v[b+8>>2]+88>>2],d));break m}Kc(g+32|0,17859)}b=17859;if(!fh(w[c|0])){b=w[c+2|0]?5508:17859}v[23540]=0;b=Q(55,g+16|0,b|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){c=a;a=g+32|0;pi(c,a,b);zb(b);zb(a);break a}c=P()|0;O()|0;zb(g+32|0);break d;case 4:n:{if(fh(w[c|0])){i=g,j=ik(w[c+2|0],w[c+4|0])&255,v[i>>2]=j;uA(g+32|0,g);break n}if(w[c+2|0]){Zt(g+32|0,c+4|0);break n}Kc(g+32|0,16804)}b=5492;if(!fh(w[c|0])){b=w[c+2|0]?5492:16804}v[23540]=0;b=Q(55,g+16|0,b|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){c=a;a=g+32|0;pi(c,a,b);zb(b);zb(a);break a}c=P()|0;O()|0;zb(g+32|0);break d;case 3:o:{if(fh(w[c|0])){i=g,j=(ik(w[c+3|0],w[c+5|0])&3840)!=0,t[i|0]=j;b=kb-32|0;kb=b;v[b+8>>2]=-1;v[b+12>>2]=0;v[b>>2]=0;Nb(b+16|0);v[23540]=0;v[b>>2]=v[b>>2]&-1332|1058;v[b+4>>2]=1;U(1080,g+32|0,g|0,b|0);d=v[23540];v[23540]=0;p:{if((d|0)!=1){jm(b);kb=b+32|0;break p}a=P()|0;O()|0;jm(b);T(a|0);L()}break o}d=w[c+3|0];if(d){of(g+32|0,1,_L(v[v[b+8>>2]+84>>2],d));break o}Kc(g+32|0,16805)}b=12296;if(!fh(w[c|0])){b=w[c+3|0]?12296:16805}v[23540]=0;b=Q(55,g+16|0,b|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){c=a;a=g+32|0;pi(c,a,b);zb(b);zb(a);break a}c=P()|0;O()|0;zb(g+32|0);break d;case 5:break f;default:break c}}q:{if(fh(w[c|0])){i=g,j=ik(w[c+3|0],w[c+5|0])&255,v[i>>2]=j;uA(g+32|0,g);break q}if(w[c+3|0]){Zt(g+32|0,c+5|0);break q}Kc(g+32|0,16804)}b=11156;if(!fh(w[c|0])){b=w[c+3|0]?11156:16804}v[23540]=0;b=Q(55,g+16|0,b|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){c=a;a=g+32|0;pi(c,a,b);zb(b);zb(a);break a}c=P()|0;O()|0;zb(g+32|0);break d}c=P()|0;O()|0;zb(g+32|0)}T(c|0);L()}c=a;a=Nb(g+32|0);b=Nb(g+16|0);pi(c,a,b);zb(b);zb(a)}kb=g+48|0}function Fg(a,b,c,d,e,f,g,h,i){var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=kb-112|0;kb=j;k=i&2147483647;l=e&2147483647;m=l;a:{b:{p=!(b|c);if(!(d|l?l-2147418112>>>0<2147549184:p)){n=k-2147418112|0;if(!h&(n|0)==-2147418112?f|g:(n|0)==-2147418112&(h|0)!=0|n>>>0>2147549184){break b}}if(!(!d&(m|0)==2147418112?p:m>>>0<2147418112)){h=d;i=e|32768;f=b;g=c;break a}if(!(!h&(k|0)==2147418112?!(f|g):k>>>0<2147418112)){i=i|32768;break a}if(!(b|d|(m^2147418112|c))){m=d;d=!(b^f|d^h|(c^g|e^i^-2147483648));h=d?0:m;i=d?2147450880:e;f=d?0:b;g=d?0:c;break a}if(!(f|h|(k^2147418112|g))){break a}if(!(b|d|(c|m))){if(f|h|(g|k)){break a}f=b&f;g=c&g;h=d&h;i=e&i;break a}if(f|h|(g|k)){break b}f=b;g=c;h=d;i=e;break a}l=(k|0)==(m|0);k=l&(d|0)==(h|0)?(c|0)==(g|0)&b>>>0<f>>>0|c>>>0<g>>>0:l&d>>>0<h>>>0|k>>>0>m>>>0;o=k?f:b;l=k?g:c;m=k?i:e;r=m;q=k?h:d;n=m&65535;e=k?e:i;s=e;h=k?d:h;m=e>>>16&32767;p=r>>>16&32767;if(!p){d=!(n|q);e=d<<6;i=E(d?o:q)+32|0;d=E(d?l:n);d=e+((d|0)==32?i:d)|0;Kf(j+96|0,o,l,q,n,d-15|0);q=v[j+104>>2];n=v[j+108>>2];o=v[j+96>>2];p=16-d|0;l=v[j+100>>2]}f=k?b:f;g=k?c:g;i=s&65535;if(!m){b=!(h|i);c=b<<6;d=E(b?f:h)+32|0;b=E(b?g:i);b=c+((b|0)==32?d:b)|0;Kf(j+80|0,f,g,h,i,b-15|0);m=16-b|0;h=v[j+88>>2];i=v[j+92>>2];g=v[j+84>>2];f=v[j+80>>2]}b=h;k=i<<3|b>>>29;d=b<<3|g>>>29;e=k|524288;b=q;c=n<<3|b>>>29;h=b<<3|l>>>29;i=c;b=f;c=g<<3|b>>>29;b=b<<3;g=r^s;c:{if((m|0)==(p|0)){break c}f=p-m|0;if(f>>>0>127){d=0;e=0;b=1;c=0;break c}Kf(j- -64|0,b,c,d,e,128-f|0);Em(j+48|0,b,c,d,e,f);b=v[j+48>>2]|(v[j+64>>2]|v[j+72>>2]|(v[j+68>>2]|v[j+76>>2]))!=0;c=v[j+52>>2];d=v[j+56>>2];e=v[j+60>>2]}m=h;q=i|524288;f=o;k=l<<3|f>>>29;n=f<<3;d:{if((g|0)<0){f=0;g=0;h=0;i=0;if(!(b^n|d^m|(c^k|e^q))){break a}o=n-b|0;l=k-((b>>>0>n>>>0)+c|0)|0;f=m-d|0;b=(c|0)==(k|0)&b>>>0>n>>>0|c>>>0>k>>>0;i=(q-((d>>>0>m>>>0)+e|0)|0)-(f>>>0<b>>>0)|0;h=f-b|0;if(i>>>0>524287){break d}b=!(h|i);c=b<<6;d=E(b?o:h)+32|0;b=E(b?l:i);b=c+((b|0)==32?d:b)|0;b=b-12|0;Kf(j+32|0,o,l,h,i,b);p=p-b|0;h=v[j+40>>2];i=v[j+44>>2];o=v[j+32>>2];l=v[j+36>>2];break d}k=c+k|0;f=b+n|0;k=f>>>0<n>>>0?k+1|0:k;o=f;l=k;f=(c|0)==(k|0)&b>>>0>f>>>0|c>>>0>k>>>0;c=e+q|0;b=d+m|0;c=b>>>0<m>>>0?c+1|0:c;d=b;b=f+b|0;h=b;i=b>>>0<d>>>0?c+1|0:c;if(!(i&1048576)){break d}o=o&1|((l&1)<<31|o>>>1);c=h;l=c<<31|l>>>1;p=p+1|0;h=(i&1)<<31|c>>>1;i=i>>>1|0}d=0;e=r&-2147483648;if((p|0)>=32767){h=d;i=e|2147418112;f=0;g=0;break a}m=0;e:{if((p|0)>0){m=p;break e}Kf(j+16|0,o,l,h,i,p+127|0);Em(j,o,l,h,i,1-p|0);o=v[j>>2]|(v[j+16>>2]|v[j+24>>2]|(v[j+20>>2]|v[j+28>>2]))!=0;l=v[j+4>>2];h=v[j+8>>2];i=v[j+12>>2]}c=h<<29;b=l>>>3|0;n=(l&7)<<29|o>>>3;l=o&7;g=l>>>0>4;f=n+g|0;b=b|c;k=f>>>0<g>>>0?b+1|0:b;c=f;g=k;b=(b|0)==(k|0)&c>>>0<n>>>0|b>>>0>k>>>0;c=d|((i&7)<<29|h>>>3);b=b+c|0;i=e|(i>>>3&65535|m<<16);i=b>>>0<c>>>0?i+1|0:i;h=b;f:{if((l|0)==4){c=g+0|0;e=f&1;b=f+e|0;c=b>>>0<f>>>0?c+1|0:c;f=b;g=c;c=(d|0)==(c|0)&b>>>0<e>>>0|c>>>0<d>>>0;b=c+h|0;i=b>>>0<c>>>0?i+1|0:i;h=b;break f}if(!l){break a}}}v[a>>2]=f;v[a+4>>2]=g;v[a+8>>2]=h;v[a+12>>2]=i;kb=j+112|0}function kK(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;var f=0,g=0,h=0,i=0;f=kb-144|0;kb=f;v[f+140>>2]=c;v[f+136>>2]=b;A[f+128>>3]=d;a:{if(!c){break a}g=w[cl(b,c)|0];if((g|0)==33){e=1}else{if((g|0)!=63){break a}e=0}jl(f+104|0,b,c,c-1|0);b=v[f+108>>2];v[f+136>>2]=v[f+104>>2];v[f+140>>2]=b}b=f+104|0;Xd(b);c=v[f+104>>2];Xd(f+88|0);g=bl(c,v[f+92>>2],f+136|0);Xd(b);b=v[f+140>>2];c=v[f+136>>2];b:{c:{d:{e:{if((g|0)==v[f+108>>2]){a=rc(f+120|0,21688);if(Qc(c,b,v[a>>2],v[a+4>>2])){b=ba(8)|0;v[23540]=0;R(958,f+88|0,f+128|0);a=v[23540];v[23540]=0;f:{g:{h:{if((a|0)!=1){v[23540]=0;U(961,f+104|0,17667,f+88|0);a=v[23540];v[23540]=0;if((a|0)==1){break h}a=0;c=tc(b,f+104|0);v[23540]=0;U(119,c|0,62752,950);c=v[23540];v[23540]=0;if((c|0)!=1){break b}c=P()|0;O()|0;zb(f+104|0);break g}c=P()|0;O()|0;break f}c=P()|0;a=1;O()|0}zb(f+88|0);if(!a){break c}}ca(b|0);break c}if(!e){break e}b=ba(8)|0;v[23540]=0;e=Mh(f+56|0,v[f+136>>2],v[f+140>>2]);a=v[23540];v[23540]=0;i:{j:{k:{l:{m:{n:{o:{p:{q:{if((a|0)!=1){v[23540]=0;U(961,f+72|0,17703,e|0);a=v[23540];v[23540]=0;if((a|0)==1){break q}v[23540]=0;R(963,f+88|0,f+72|0);c=v[23540];v[23540]=0;a=1;if((c|0)==1){break p}v[23540]=0;R(958,f+40|0,f+128|0);a=v[23540];v[23540]=0;if((a|0)==1){break o}v[23540]=0;U(965,f+104|0,f+88|0,f+40|0);c=v[23540];v[23540]=0;a=1;if((c|0)==1){break n}a=tc(b,f+104|0);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break b}c=P()|0;O()|0;zb(f+104|0);a=0;break m}c=P()|0;O()|0;break i}c=P()|0;a=1;O()|0;break j}c=P()|0;O()|0;break k}c=P()|0;a=1;O()|0;break l}c=P()|0;O()|0}zb(f+40|0)}zb(f+88|0)}zb(f+72|0)}zb(e);if(!a){break c}}ca(b|0);break c}e=rc(f+32|0,21688);if(Qc(c,b,v[e>>2],v[e+4>>2])){b=ba(8)|0;v[23540]=0;R(958,f+88|0,f+128|0);a=v[23540];v[23540]=0;r:{s:{t:{if((a|0)!=1){v[23540]=0;U(961,f+104|0,17667,f+88|0);a=v[23540];v[23540]=0;if((a|0)==1){break t}a=0;c=tc(b,f+104|0);v[23540]=0;U(119,c|0,62752,950);c=v[23540];v[23540]=0;if((c|0)!=1){break b}c=P()|0;O()|0;zb(f+104|0);break s}c=P()|0;O()|0;break r}c=P()|0;a=1;O()|0}zb(f+88|0);if(!a){break c}}ca(b|0);break c}e=rc(f+24|0,7719);if(Qc(c,b,v[e>>2],v[e+4>>2])){if(!Qd(w[a+28|0])){break e}if(d<=0|d>4){a=ba(8)|0;v[23540]=0;b=Q(55,f+104|0,7814)|0;c=v[23540];v[23540]=0;if((c|0)==1){break d}a=tc(a,b);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break b}c=P()|0;O()|0;zb(b);break c}a=v[a+24>>2];h=a,i=Qe(65536/d),v[h+480244>>2]=i;Qp(a);break e}e=rc(f+16|0,7771);if(Qc(c,b,v[e>>2],v[e+4>>2])){if(!Qd(w[a+28|0])){break e}if(d<=0|d>4){a=ba(8)|0;v[23540]=0;b=Q(55,f+104|0,7835)|0;c=v[23540];v[23540]=0;if((c|0)!=1){a=tc(a,b);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break b}c=P()|0;O()|0;zb(b);break c}c=P()|0;O()|0;ca(a|0);break c}a=v[a+24>>2];h=a,i=Qe(d*65536),v[h+480240>>2]=i;Qp(a);break e}e=b;b=rc(f+8|0,7789);if(!Qc(c,e,v[b>>2],v[b+4>>2])){break e}h=v[a+24>>2],i=xl(d*65536),v[h+480236>>2]=i}kb=f+144|0;return}c=P()|0;O()|0;ca(a|0)}T(c|0)}L()}function Vea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,z=0,A=0,C=0,D=0;h=kb-4144|0;kb=h;g=Ib(w[a+14|0]|w[a+15|0]<<8);a:{if(!g|g>>>0>20){break a}j=b+480190|0;if(x[j>>1]<=w[a+23|0]){break a}nd(d,32);u[d+34>>1]=1;f=h+24|0;g=a+20|0;v[f>>2]=g;v[f+4>>2]=(g+80|0)-g>>2;uQ(h+4136|0,v[h+24>>2],v[h+28>>2],Ib(w[a+14|0]|w[a+15|0]<<8));g=v[h+4136>>2];k=w[Eb(g,0)+3|0];v[h+24>>2]=1;k=v[_c(Hi(b,k+1|0)+24|0,f)>>2];i=f;f=v[h+4140>>2];uQ(i,g,f,c?f:1);q=1/+(k>>>0);f=v[h+24>>2];g=Eb(f,v[h+28>>2]);k=v[h+4136>>2];j=x[j>>1];while(1){if((f|0)==(g|0)){b:{r=Mg(d);if(!r){break b}g=v[h+4140>>2];k=h+4120|0;v[k>>2]=0;v[k+4>>2]=0;Gc(k+8|0);if(g){f=kb-16|0;kb=f;v[f+12>>2]=4925421;v[f+8>>2]=2147483647;j=v[Kb(f+12|0,f+8|0)>>2];kb=f+16|0;if(g>>>0>j>>>0){cd();L()}if(g>>>0>=4925422){Lg();L()}g=B(g,872);f=vc(g);v[k>>2]=f;v[k+4>>2]=f;C=Gb(k),D=f+g|0,v[C>>2]=D;f=kb-16|0;kb=f;v[f>>2]=k;j=v[k+4>>2];v[f+4>>2]=j;v[f+8>>2]=g+j;i=v[f+4>>2];g=v[f+8>>2];while(1){if((g|0)==(i|0)){lc(f);kb=f+16|0}else{iQ(Ub(i,0,872));i=i+872|0;v[f+4>>2]=i;continue}break}}j=(e<<12>>>0)/1e4|0;s=v[k>>2];n=v[h+4136>>2];z=v[h+4140>>2];A=b+480190|0;f=0;i=0;while(1){if((f|0)==(z|0)){g=b+24648|0}else{g=Eb(n,f);e=tQ(s,f);l=w[g+3|0];c:{if(l>>>0>=x[A>>1]){break c}o=t[g+1|0];if((o|0)<0){break c}m=0;g=w[g+2|0];if((g+14&255)>>>0<=5){m=t[g+26862|0]}g=Hi(b,l+1|0);l=v[g+24>>2];p=q*(oi(+(m<<24>>24)/96+ +(o-t[Eb(n,0)+1|0]|0)/12)*+(l>>>0));if(p<=0){break c}m=sQ(p);v[e+8>>2]=m;l=nb;v[e+12>>2]=l;v[e+16>>2]=v[g+20>>2];o=v[g>>2];v[e+76>>2]=o;v[e+88>>2]=x[g+34>>1]&1023;d:{if(c){v[e+664>>2]=i;i=Qe(+(o>>>0)/Tz(m,l))+i|0;g=j;break d}g=(j>>>0)/(Ib(w[a+14|0]|w[a+15|0]<<8)>>>0)|0}v[e+20>>2]=g;v[e+24>>2]=g}f=f+1|0;continue}break}b=0;while(1){e:{a=v[d>>2];if(a>>>0>b>>>0){Ub(h+24|0,0,4096);v[h+16>>2]=512;v[h+12>>2]=a-b;c=v[Kb(h+16|0,h+12|0)>>2];C=h,D=Fb(v[k>>2]),v[C+16>>2]=D;j=Fb(v[k+4>>2]);while(1){a=v[h+16>>2];if(!Pb(a,j)){break e}f:{g:{if(!v[a+16>>2]){break g}e=v[a+664>>2];if(e>>>0>=c>>>0){v[a+664>>2]=e-c;break g}f=v[a+88>>2];v[h+12>>2]=c-e;C=h,D=Qe((+y[a+76>>2]-Tz(v[a>>2],v[a+4>>2]))/Tz(v[a+8>>2],v[a+12>>2])),v[C+8>>2]=D;i=v[Kb(h+12|0,h+8|0)>>2];v[23540]=0;X(v[((f&1|(f&64?18:16))<<2)+27456>>2],a|0,g|0,(h+24|0)+(e<<3)|0,i|0);e=v[23540];v[23540]=0;if((e|0)==1){break f}v[a+664>>2]=0;if(y[a+76>>2]>y[a+4>>2]){break g}v[a+16>>2]=0}v[h+16>>2]=v[h+16>>2]+872;continue}break}a=P()|0;O()|0;Pt(k);T(a|0);L()}Pt(k);break b}e=v[d+20>>2]+(b<<1)|0;f=h+24|0;a=kb-16|0;kb=a;v[a+12>>2]=c;xc(a+12|0,512);i=v[a+12>>2];while(1){if(i){j=ld(v[f>>2]+2048|0,12);j=(j|0)<32767?j:32767;u[e>>1]=(j|0)>-32768?j:-32768;f=f+8|0;e=e+2|0;i=i-1|0;continue}break}kb=a+16|0;b=b+c|0;continue}}f=(r|0)!=0}else{i=w[f+3|0];h:{if(i>>>0>=j>>>0){break h}n=t[f+1|0];if((n|0)<0){break h}i=Hi(b,i+1|0);m=v[i>>2];p=oi(+(n-t[Eb(k,0)+1|0]|0)/-12);C=d,D=v[d>>2]+Qe(q*(p*+(m>>>0)*+y[i+24>>2]))|0,v[C>>2]=D}f=f+4|0;continue}break}}kb=h+4144|0;return f|0}function LH(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;f=a+b|0;c=v[a+4>>2];a:{b:{if(c&1){break b}if(!(c&3)){break a}c=v[a>>2];b=c+b|0;c:{a=a-c|0;if((a|0)!=v[116053]){if(c>>>0<=255){e=v[a+8>>2];c=c>>>3|0;d=v[a+12>>2];if((d|0)!=(e|0)){break c}i=464192,j=v[116048]&Nka(-2,c),v[i>>2]=j;break b}h=v[a+24>>2];c=v[a+12>>2];d:{if((c|0)!=(a|0)){d=v[a+8>>2];v[d+12>>2]=c;v[c+8>>2]=d;break d}e:{e=a+20|0;d=v[e>>2];if(d){break e}e=a+16|0;d=v[e>>2];if(d){break e}c=0;break d}while(1){g=e;c=d;e=c+20|0;d=v[e>>2];if(d){continue}e=c+16|0;d=v[c+16>>2];if(d){continue}break}v[g>>2]=0}if(!h){break b}e=v[a+28>>2];d=(e<<2)+464496|0;f:{if(v[d>>2]==(a|0)){v[d>>2]=c;if(c){break f}i=464196,j=v[116049]&Nka(-2,e),v[i>>2]=j;break b}v[h+(v[h+16>>2]==(a|0)?16:20)>>2]=c;if(!c){break b}}v[c+24>>2]=h;d=v[a+16>>2];if(d){v[c+16>>2]=d;v[d+24>>2]=c}d=v[a+20>>2];if(!d){break b}v[c+20>>2]=d;v[d+24>>2]=c;break b}c=v[f+4>>2];if((c&3)!=3){break b}v[116050]=b;v[f+4>>2]=c&-2;v[a+4>>2]=b|1;v[f>>2]=b;return}v[e+12>>2]=d;v[d+8>>2]=e}c=v[f+4>>2];g:{if(!(c&2)){if(v[116054]==(f|0)){v[116054]=a;b=v[116051]+b|0;v[116051]=b;v[a+4>>2]=b|1;if(v[116053]!=(a|0)){break a}v[116050]=0;v[116053]=0;return}if(v[116053]==(f|0)){v[116053]=a;b=v[116050]+b|0;v[116050]=b;v[a+4>>2]=b|1;v[a+b>>2]=b;return}b=(c&-8)+b|0;h:{if(c>>>0<=255){e=v[f+8>>2];c=c>>>3|0;d=v[f+12>>2];if((d|0)==(e|0)){i=464192,j=v[116048]&Nka(-2,c),v[i>>2]=j;break h}v[e+12>>2]=d;v[d+8>>2]=e;break h}h=v[f+24>>2];c=v[f+12>>2];i:{if((f|0)!=(c|0)){d=v[f+8>>2];v[d+12>>2]=c;v[c+8>>2]=d;break i}j:{d=f+20|0;e=v[d>>2];if(e){break j}d=f+16|0;e=v[d>>2];if(e){break j}c=0;break i}while(1){g=d;c=e;d=c+20|0;e=v[d>>2];if(e){continue}d=c+16|0;e=v[c+16>>2];if(e){continue}break}v[g>>2]=0}if(!h){break h}e=v[f+28>>2];d=(e<<2)+464496|0;k:{if(v[d>>2]==(f|0)){v[d>>2]=c;if(c){break k}i=464196,j=v[116049]&Nka(-2,e),v[i>>2]=j;break h}v[h+(v[h+16>>2]==(f|0)?16:20)>>2]=c;if(!c){break h}}v[c+24>>2]=h;d=v[f+16>>2];if(d){v[c+16>>2]=d;v[d+24>>2]=c}d=v[f+20>>2];if(!d){break h}v[c+20>>2]=d;v[d+24>>2]=c}v[a+4>>2]=b|1;v[a+b>>2]=b;if(v[116053]!=(a|0)){break g}v[116050]=b;return}v[f+4>>2]=c&-2;v[a+4>>2]=b|1;v[a+b>>2]=b}if(b>>>0<=255){c=(b&-8)+464232|0;d=v[116048];b=1<<(b>>>3);l:{if(!(d&b)){v[116048]=b|d;b=c;break l}b=v[c+8>>2]}v[c+8>>2]=a;v[b+12>>2]=a;v[a+12>>2]=c;v[a+8>>2]=b;return}e=31;if(b>>>0<=16777215){c=b>>>8|0;g=c+1048320>>>16&8;c=c<<g;e=c+520192>>>16&4;c=c<<e;d=c+245760>>>16&2;c=(c<<d>>>15|0)-(d|(e|g))|0;e=(c<<1|b>>>c+21&1)+28|0}v[a+28>>2]=e;v[a+16>>2]=0;v[a+20>>2]=0;g=(e<<2)+464496|0;m:{d=v[116049];c=1<<e;n:{if(!(d&c)){v[116049]=c|d;v[g>>2]=a;v[a+24>>2]=g;break n}e=b<<((e|0)==31?0:25-(e>>>1|0)|0);c=v[g>>2];while(1){d=c;if((v[c+4>>2]&-8)==(b|0)){break m}c=e>>>29|0;e=e<<1;g=d+(c&4)|0;c=v[g+16>>2];if(c){continue}break}v[g+16>>2]=a;v[a+24>>2]=d}v[a+12>>2]=a;v[a+8>>2]=a;return}b=v[d+8>>2];v[b+12>>2]=a;v[d+8>>2]=a;v[a+24>>2]=0;v[a+12>>2]=d;v[a+8>>2]=b}}function lK(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;f=kb-192|0;kb=f;v[f+188>>2]=c;v[f+184>>2]=b;t[f+183|0]=d;a:{if(!c){break a}g=w[cl(b,c)|0];if((g|0)==33){e=1}else{if((g|0)!=63){break a}e=0}jl(f+8|0,b,c,c-1|0);b=v[f+12>>2];v[f+184>>2]=v[f+8>>2];v[f+188>>2]=b}b=f+8|0;Xd(b);c=v[f+8>>2];Xd(f+152|0);g=bl(c,v[f+156>>2],f+184|0);Xd(b);b=v[f+188>>2];c=v[f+184>>2];b:{c:{d:{e:{f:{g:{h:{if((g|0)==v[f+12>>2]){a=rc(f+168|0,21688);if(Qc(c,b,v[a>>2],v[a+4>>2])){b=ba(8)|0;v[23540]=0;R(954,f+152|0,f+183|0);a=v[23540];v[23540]=0;if((a|0)==1){break g}v[23540]=0;U(961,f+8|0,17667,f+152|0);a=v[23540];v[23540]=0;if((a|0)==1){break f}d=0;a=tc(b,f+8|0);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break b}c=P()|0;O()|0;zb(f+8|0);break e}if(!e){break h}b=ba(8)|0;v[23540]=0;d=Mh(f+120|0,v[f+184>>2],v[f+188>>2]);a=v[23540];v[23540]=0;i:{j:{k:{l:{m:{n:{o:{p:{if((a|0)!=1){v[23540]=0;U(961,f+136|0,17703,d|0);a=v[23540];v[23540]=0;if((a|0)==1){break p}v[23540]=0;R(963,f+152|0,f+136|0);c=v[23540];v[23540]=0;a=1;if((c|0)==1){break o}v[23540]=0;R(954,f+104|0,f+183|0);a=v[23540];v[23540]=0;if((a|0)==1){break n}v[23540]=0;U(965,f+8|0,f+152|0,f+104|0);c=v[23540];v[23540]=0;a=1;if((c|0)==1){break m}a=tc(b,f+8|0);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break b}c=P()|0;O()|0;zb(f+8|0);a=0;break l}c=P()|0;O()|0;break d}c=P()|0;a=1;O()|0;break i}c=P()|0;O()|0;break j}c=P()|0;a=1;O()|0;break k}c=P()|0;O()|0}zb(f+104|0)}zb(f+152|0)}zb(f+136|0)}zb(d);if(a){break d}break c}e=rc(f+96|0,21688);if(Qc(c,b,v[e>>2],v[e+4>>2])){b=ba(8)|0;v[23540]=0;R(954,f+152|0,f+183|0);a=v[23540];v[23540]=0;q:{r:{if((a|0)!=1){v[23540]=0;U(961,f+8|0,17667,f+152|0);a=v[23540];v[23540]=0;if((a|0)==1){break r}d=0;a=tc(b,f+8|0);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break b}c=P()|0;O()|0;zb(f+8|0);break q}c=P()|0;O()|0;break d}c=P()|0;d=1;O()|0}zb(f+152|0);if(d){break d}break c}s:{e=rc(f+88|0,7422);if(!Qc(c,b,v[e>>2],v[e+4>>2])){e=rc(f+80|0,7404);if(!Qc(c,b,v[e>>2],v[e+4>>2])){break s}}t[a+60|0]=d;break h}t:{e=rc(f+72|0,6937);if(!Qc(c,b,v[e>>2],v[e+4>>2])){e=rc(f- -64|0,6918);if(!Qc(c,b,v[e>>2],v[e+4>>2])){break t}}t[a+61|0]=d;break h}e=rc(f+56|0,7021);if(Qc(c,b,v[e>>2],v[e+4>>2])){t[a+62|0]=d;break h}e=rc(f+48|0,6067);if(Qc(c,b,v[e>>2],v[e+4>>2])){t[a+63|0]=d;break h}e=rc(f+40|0,7471);if(Qc(c,b,v[e>>2],v[e+4>>2])){t[a+64|0]=d;break h}e=b;b=rc(f+32|0,13365);if(!Qc(c,e,v[b>>2],v[b+4>>2])){break h}b=v[a+24>>2];c=b+24664|0;e=v[c+4>>2];v[f+24>>2]=v[c>>2];v[f+28>>2]=e;c=b+24656|0;e=v[c+4>>2];v[f+16>>2]=v[c>>2];v[f+20>>2]=e;c=v[b+24652>>2];v[f+8>>2]=v[b+24648>>2];v[f+12>>2]=c;if(d){a=MJ(v[a+56>>2])}else{a=0}v[f+28>>2]=a;if(!xx(f+8|0,b+24648|0)){break h}qy(b,f+8|0)}kb=f+192|0;return}c=P()|0;O()|0;break d}c=P()|0;d=1;O()|0}zb(f+152|0);if(!d){break c}}ca(b|0)}T(c|0)}L()}function nka(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=kb-736|0;kb=e;zc(b);f=kb-16|0;kb=f;h=e+120|0;hV(f+8|0,h);g=v[f+12>>2];j=b;nc(f,v[b>>2],v[b+8>>2],v[f+8>>2],v[f+12>>2]);b=v[f+4>>2];if((b|0)==(g|0)){$b(j,v[f+12>>2])}kb=f+16|0;b=(b|0)==(g|0);if(!b){gV(h)}a:{if(!b){break a}if(!iV(e+120|0)){break a}b:{if(!c){break b}Cd(a,67108864);ag(a);b=w[e+145|0];u[a+480190>>1]=31;u[a+480188>>1]=b;v[a+480228>>2]=256/(b>>>0);b=yc(e,8208);Jb(a+1298344|0,b);Ab(b);b=yc(e,10794);Jb(a+1298356|0,b);Ab(b);d=e+96|0;Sf(d,4177);f=w[e+144|0];v[e+72>>2]=f>>>4;b=0;v[23540]=0;v[e+116>>2]=f&15;X(302,e|0,d|0,e+72|0,e+116|0);d=v[23540];v[23540]=0;c:{d:{if((d|0)!=1){Jb(a+1298368|0,e);Ab(e);dc(e+96|0);v[a+1298404>>2]=14;Kq(Wb(v[a+484360>>2],w[a+484376|0]),e+168|0,w[e+167|0]+1|0);while(1){e:{if((b|0)==31){PB(j,a+1298308|0,32);d=1;break e}d=b+1|0;g=B(d,104)+a|0;h=g+484380|0;nd(h,1);f=(e+120|0)+(b<<2)|0;p=h,q=bc(w[f+176|0]|w[f+177|0]<<8|(w[f+178|0]<<16|w[f+179|0]<<24)),v[p>>2]=q;k=bc(w[f+300|0]|w[f+301|0]<<8|(w[f+302|0]<<16|w[f+303|0]<<24));v[g+484384>>2]=k;f=bc(w[f+424|0]|w[f+425|0]<<8|(w[f+426|0]<<16|w[f+427|0]<<24));v[g+484388>>2]=f+k;if(f){f=g+484414|0;u[f>>1]=x[f>>1]|2}Dk(h);b=(e+120|0)+b|0;t[e|0]=w[b+548|0];t[e+96|0]=64;p=g+484410|0,q=w[Yb(e,e+96|0)|0]<<2,u[p>>1]=q;t[g+484417|0]=w[b+579|0]<<4;b=d;continue}break}while(1){if((d|0)!=32){fV(j,((d<<5)+a|0)+946304|0,30);d=d+1|0;continue}break}n=c&1;if(n){xg(a+484344|0,w[e+166|0]+1|0)}k=a+484344|0;m=a+480188|0;f=0;while(1){if(w[e+166|0]<f>>>0){d=1;if(!(c&2)){break a}b=Zc(e,8,1,1,0);while(1){if((d|0)==32){break b}wg(b,(B(d,104)+a|0)+484380|0,j);d=d+1|0;continue}}g=Kh(e+96|0);f:{g:{if(w[e+146|0]){v[23540]=0;b=S(271,j|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break f}v[23540]=0;U(190,e+72|0,j|0,b|0);b=v[23540];v[23540]=0;if((b|0)==1){break f}break g}b=x[m>>1];v[23540]=0;U(190,e+72|0,j|0,b<<8);b=v[23540];v[23540]=0;if((b|0)==1){break d}}b=e+72|0;d=kc(e,b);hd(g,d);Bb(d);Bb(b);h:{if(!n){break h}v[23540]=0;b=W(226,k|0,f&65535,64)|0;d=v[23540];v[23540]=0;if((d|0)==1){break d}if(!b){break h}b=0;if(w[e+146|0]){h=0;v[23540]=0;R(303,g|0,e|0);b=v[23540];v[23540]=0;if((b|0)==1){break d}i:while(1){if((h|0)==64){break h}i=e+h|0;b=128;d=0;l=_b(v[k>>2],f);l=Cf(v[l>>2],v[v[l+48>>2]+12>>2],h);while(1){if(x[m>>1]<=d>>>0){h=h+1|0;continue i}j:{if(!(w[i|0]&b)){break j}v[23540]=0;R(304,g|0,l+B(d,6)|0);o=v[23540];v[23540]=0;if((o|0)!=1){break j}break d}b=b>>>1|0;d=d+1|0;continue}}}k:while(1){d=0;h=b&65535;if(h>>>0>=x[m>>1]){break h}while(1){if((d|0)==64){b=b+1|0;continue k}i=_b(v[k>>2],f);i=jd(v[i>>2],v[v[i+48>>2]+12>>2],d,h);v[23540]=0;R(304,g|0,i|0);i=v[23540];v[23540]=0;if((i|0)!=1){d=d+1|0;continue}break}break}break d}Bb(g);f=f+1|0;continue}break}break d}d=P()|0;O()|0;dc(e+96|0);break c}d=P()|0;O()|0;Bb(g)}T(d|0);L()}d=1}kb=e+736|0;return d|0}function rT(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=kb-176|0;kb=g;i=Yf(g+160|0);a:{b:{c:{if(d){v[23540]=0;U(470,a|0,i|0,c|0);c=v[23540];v[23540]=0;if((c|0)!=1){break c}break b}v[23540]=0;U(471,a|0,i|0,c|0);c=v[23540];v[23540]=0;if((c|0)==1){break b}}k=Tb(g+144|0);m=b+480192|0;n=b+1298464|0;c=1;while(1){d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{h=c&65535;if(h>>>0<=x[m>>1]){v[23540]=0;u[g+142>>1]=0;R(472,a|0,g+142|0);d=v[23540];v[23540]=0;t:{u:{v:{w:{if((d|0)!=1){j=kb-16|0;kb=j;o=x[g+142>>1];d=Td(i);e=jc(i);f=kb-16|0;kb=f;while(1){if(d){l=oo(x[d+16>>1],o);e=l?e:d;d=v[(l?d+4|0:d)>>2];continue}break}d=v[fc(f+8|0,e)>>2];kb=f+16|0;x:{if(Pb(d,Zf(i))){if(!oo(x[g+142>>1],x[vd(d)>>1])){break x}}d=Zf(i)}d=fc(j+8|0,d);kb=j+16|0;j=((h<<2)+b|0)+900380|0;if(!v[j>>2]){break d}d=v[d>>2];if(!Hg(d,xf(i))){break u}v[23540]=0;d=Q(3,g+128|0,vd(d)+4|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break t}v[23540]=0;e=Q(1,g+112|0,16815)|0;f=v[23540];v[23540]=0;if((f|0)==1){break v}f=pq(d,e);Ab(e);if(f){break p}e=v[b+4>>2];v[23540]=0;e=Q(473,e|0,d|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break r}v[v[j>>2]+44>>2]=e;if(!v[v[j>>2]+44>>2]){break w}break e}c=P()|0;O()|0;break f}v[23540]=0;e=Q(1,g+96|0,13396)|0;f=v[23540];v[23540]=0;y:{z:{A:{if((f|0)!=1){B:{if(!pq(d,e)){v[23540]=0;f=Q(1,g+80|0,13646)|0;h=v[23540];v[23540]=0;if((h|0)==1){break A}h=pq(d,f);Ab(f);Ab(e);if(h){break B}break s}Ab(e)}v[23540]=0;e=S(474,d|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break z}v[g+56>>2]=e;e=v[b+4>>2];f=v[eg(g+72|0,g+56|0)>>2];v[23540]=0;e=Q(475,e|0,f|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break y}sg(g+56|0);if(e){break e}break s}c=P()|0;O()|0;break g}c=P()|0;O()|0;Ab(e);break g}c=P()|0;O()|0;break g}c=P()|0;O()|0;sg(g+56|0);break g}c=P()|0;O()|0;break g}d=v[j>>2];if(!d){break d}v[d+44>>2]=0;break d}c=P()|0;O()|0;break f}Ql(k);qT(i);kb=g+176|0;return}e=Fb(v[k>>2]);h=Fb(v[k+4>>2]);f=kb-16|0;kb=f;v[f+8>>2]=e;while(1){C:{if(!Pb(e,h)){break C}if(pq(e,d)){break C}e=v[oq(f+8|0)>>2];continue}break}kb=f+16|0;if(Pb(e,Fb(v[k+4>>2]))){break p}v[23540]=0;R(476,k|0,d|0);e=v[23540];v[23540]=0;if((e|0)!=1){break q}}c=P()|0;O()|0;break g}v[23540]=0;e=Q(1,g+24|0,17516)|0;f=v[23540];v[23540]=0;if((f|0)==1){break o}v[23540]=0;U(477,g+40|0,e|0,d|0);f=v[23540];v[23540]=0;if((f|0)==1){break n}v[23540]=0;f=Q(1,g+8|0,16368)|0;h=v[23540];v[23540]=0;if((h|0)==1){break m}v[23540]=0;U(2,g+56|0,g+40|0,f|0);h=v[23540];v[23540]=0;if((h|0)==1){break l}h=v[n>>2];v[23540]=0;U(376,h|0,2,g+56|0);h=v[23540];v[23540]=0;if((h|0)==1){break k}Ab(g+56|0);Ab(f);Ab(g+40|0);Ab(e)}v[v[j>>2]+44>>2]=0;break e}c=P()|0;O()|0;break g}c=P()|0;O()|0;break h}c=P()|0;O()|0;break i}c=P()|0;O()|0;break j}c=P()|0;O()|0;Ab(g+56|0)}Ab(f)}Ab(g+40|0)}Ab(e)}Ab(d)}Ql(k);break a}Ab(d)}c=c+1|0;continue}}c=P()|0;O()|0}qT(i);T(c|0);L()}function KW(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=kb-32|0;kb=e;v[e+28>>2]=b;a:{if((d|0)<=0){b=0;break a}v[e+8>>2]=d;v[e+16>>2]=214748364;r=e,s=B(v[Kb(e+28|0,e+16|0)>>2],20),v[r+20>>2]=s;tn(c,v[Kb(e+8|0,e+20|0)>>2]);v[e+12>>2]=b;v[e+8>>2]=a;b=0;while(1){b:{c:{d:{e:{if((d|0)<=0){break e}a=v[e+8>>2];g=v[e+12>>2];f=rh(a,g,b);k=rh(a,g,b+4|0);o=rh(a,g,b+5|0);r=e,s=rh(a,g,b+6|0)<<8|rh(a,g,b+7|0),v[r+24>>2]=s;k=o|k<<8;q=b+8|0;f:{g:{switch(f|0){case 0:b=0;if(d>>>0<k>>>0){b=ba(8)|0;v[23540]=0;a=S(193,b|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){break f}break d}while(1){if((b|0)!=(k|0)){r=e,s=rh(v[e+8>>2],v[e+12>>2],b+q|0),t[r+20|0]=s;rn(c,e+20|0);b=b+1|0;continue}break};o=k;break b;case 1:break g;default:break e}}ci(e+24|0,d);o=v[e+24>>2];m=rh(a,g,b+10|0);t[e+20|0]=m;rn(c,e+20|0);h=b+11|0;k=k+3&65532;b=o-1|0;g=0;j=0;n=0;l=0;while(1){if((b|0)<=0){break c}f=Ag(h,g,1,e+8|0);h:{i:{j:{k:{l:{if((j|0)<=7){if(f){a=g;break i}a=g+1|0;l=8;break l}a=g+1|0;m:{if(!f){if(!Ag(h,a,1,e+8|0)){break i}i=2;n:{o:{f=g+2|0;if(!Ag(h,f,1,e+8|0)){break o}i=3;f=g+3|0;if(!Ag(h,f,1,e+8|0)){break o}i=Ag(h,f,3,e+8|0);a=g+6|0;break n}a=f+1|0}f=4;p:{q:{r:{g=((l<<3)+i|0)-17|0;s:{if((g|0)<0){a=ba(8)|0;v[23540]=0;b=S(193,a|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){break r}break s}if(g>>>0<56){break p}a=ba(8)|0;v[23540]=0;b=S(193,a|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){break q}}b=P()|0;O()|0;ca(a|0);T(b|0);L()}ha(b|0,26120,168);L()}ha(b|0,26120,168);L()}l=w[g+26160|0];if((l|0)!=8){break k}break m}f=4;if((l|0)!=8){break k}}l=8;f=1;if((n|0)>19){break k}}f=0;break j}n=n+8|0}while(1){if(!((f|0)<0|(b|0)<=0)){i=(a|0)/8|0;g=i+h|0;p=rh(v[e+8>>2],v[e+12>>2],g);m=m-ld((rh(v[e+8>>2],v[e+12>>2],g+1|0)<<8|p<<16|rh(v[e+8>>2],v[e+12>>2],g+2|0))<<(a-(i<<3)|0)+8,32-l|0)|0;t[e+20|0]=m;rn(c,e+20|0);f=f-1|0;b=b-1|0;a=a+l|0;continue}break}j=(j|0)==31?31:j+1|0;g=a;break h}t:{u:{v:{f=a+1|0;if(!Ag(h,f,1,e+8|0)){g=2;break v}f=a+2|0;if(!Ag(h,f,1,e+8|0)){g=4;break v}f=a+3|0;if(!Ag(h,f,1,e+8|0)){g=6;break v}f=a+5|0;if(!Ag(h,a+4|0,1,e+8|0)){a=a+8|0;f=Ag(h,f,3,e+8|0)+8|0;break t}a=a+10|0;g=16;f=Ag(h,f,5,e+8|0);break u}a=f+2|0;f=Ag(h,f+1|0,1,e+8|0)}f=g+f|0}w:{if(Ag(h,a,1,e+8|0)){i=-256;g=12;break w}a=a+1|0;g=Ag(h,a,1,e+8|0);i=g?-4352:0;g=g?14:8}p=a+1|0;a=Ag(h,p,g,e+8|0);if(f>>>0>=3){j=j-((f|0)!=3)|0;j=((j|0)>1?j:1)-1|0}i=(a^-1)+i|0;a=fd(v[c>>2],v[c+4>>2])+i|0;if(a>>>0<i>>>0){g=g+p|0;while(1){if((f|0)<=0|(b|0)<=0){break h}m=w[Lb(v[c>>2],a)|0];t[e+20|0]=m;rn(c,e+20|0);b=b-1|0;a=a+1|0;f=f-1|0;continue}}b=ba(8)|0;v[23540]=0;a=S(193,b|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break d}ha(a|0,26120,168);L()}n=n-(n>>3)|0;continue}}ha(a|0,26120,168);L()}b=pc(v[c>>2],v[c+4>>2])^1;break a}a=P()|0;O()|0;ca(b|0);T(a|0);L()}v[e+24>>2]=b}d=d-o|0;b=k+q|0;continue}}kb=e+32|0;return b|0}function gY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;d=kb-352|0;kb=d;e=kb-16|0;kb=e;v[a+4>>2]=0;t[a|0]=0;f=a+40|0;tn(f,32);t[e+15|0]=0;rn(f,e+15|0);kb=e+16|0;e=v[a+36>>2];a:{if(!Yg(v[v[e>>2]-12>>2]+e|0)){uh(a,2,16777216);break a}f=d+88|0;me(f,e);e=v[f+12>>2];v[a+16>>2]=v[f+8>>2];v[a+20>>2]=e;v[f>>2]=3;h=v[a+36>>2];g=d+24|0;e=0;while(1){if(y[f>>2]>e>>>0){li(h,e+g|0);e=e+1|0;continue}break}if(Sb(g,26016,3)){uh(a,2,512);break a}t[d+351|0]=0;li(v[a+36>>2],d+351|0);Ub(d+88|0,0,256);e=w[d+351|0];if(e){Uk(v[a+36>>2],d+88|0,e)}g=b;b=Lk(d+24|0,d+88|0,e);e=dw(g,b);Xb(b);if(!e){uh(a,2,4096)}if(Kk(w[a|0])){break a}li(v[a+36>>2],d+87|0);g=w[d+87|0];b=g&3;u[a+24>>1]=(b|0)==3?4:b;if(Si(g,6)){b=d+24|0;Sc(b,a+32|0,9);Ze(b,1)}v[d+80>>2]=0;yE(v[a+36>>2],d+80|0);b=v[d+80>>2];t[d+79|0]=0;if(b>>>0>=2){li(v[a+36>>2],d+87|0);e=-1;if(!w[d+87|0]){li(v[a+36>>2],d+79|0);e=-2}$l(v[a+36>>2],b+e|0)}v[d+64>>2]=0;v[d+68>>2]=0;b:{if(!Si(g,4)){break b}Jk(v[a+36>>2],d- -64|0);b=v[d+68>>2];e=v[d+64>>2];v[a+64>>2]=e;v[a+68>>2]=b;f=v[c+4>>2];if((f|0)==(b|0)&y[c>>2]>=e>>>0|b>>>0<f>>>0){break b}uh(a,1,4)}if(Si(g,5)){li(v[a+36>>2],d+87|0);$l(v[a+36>>2],w[d+87|0])}c=w[d+79|0];c:{if(!Si(c,0)){break c}li(v[a+36>>2],d+87|0);b=w[d+87|0];b=b&1?-1:b>>>1|0;u[a+24>>1]=b;if(b){break c}uh(a,1,2)}v[a+8>>2]=0;e=1;if(Si(c,1)){yE(v[a+36>>2],a+8|0)}h=Si(g,2);b=d+24|0;f=a+32|0;Sc(b,f,6);Ze(b,h);h=Si(g,3);Sc(b,f,7);Ze(b,h);h=x[a+24>>1];Sc(b,f,5);Ze(b,(h|0)!=0);g=Si(g,7);Sc(b,f,8);Ze(b,g);Sc(b,f,5);d:{if(Cb(v[v[d+24>>2]>>2],v[d+28>>2])){break d}Sc(d+8|0,f,6);if(Cb(v[v[d+8>>2]>>2],v[d+12>>2])){break d}Sc(d+56|0,f,7);if(Cb(v[v[d+56>>2]>>2],v[d+60>>2])){break d}Sc(d+48|0,f,8);e=Cb(v[v[d+48>>2]>>2],v[d+52>>2])}b=d+40|0;Sc(b,f,11);Ze(b,e);Sc(d+24|0,f,11);if(Si(c,2)){u[d+8>>1]=0;Zv(v[a+36>>2],d+8|0);b=v[a+36>>2];e=x[d+8>>1];Sc(d+24|0,f,9);$l(b,B(e,Cb(v[v[d+24>>2]>>2],v[d+28>>2])?2:1))}if(Si(c,3)){$l(v[a+36>>2],5)}Jk(v[a+36>>2],d- -64|0);c=v[d+68>>2];g=c;b=v[d+64>>2];if(!c&b>>>0>=16001|c){uh(a,2,8192);break a}v[a+104>>2]=b;if(!b){uh(a,1,1)}Sc(d+24|0,f,11);e:{if(!Cb(v[v[d+24>>2]>>2],v[d+28>>2])){break e}Jk(v[a+36>>2],d- -64|0);c=v[d+68>>2];g=c;b=v[d+64>>2];if(Yv(b,c)){break e}uh(a,2,2048);break a}c=d+8|0;me(c,v[a+36>>2]);e=v[a+16>>2];h=v[a+20>>2];i=v[c+4>>2];v[d+24>>2]=v[c>>2];v[d+28>>2]=i;i=v[c+12>>2];v[d+32>>2]=v[c+8>>2];v[d+36>>2]=i;c=v[d+32>>2];h=v[d+36>>2]-(h+(e>>>0>c>>>0)|0)|0;v[d+32>>2]=c-e;v[d+36>>2]=h;e=v[d+32>>2];c=v[d+36>>2];if((c|0)<0){uh(a,2,16384);break a}v[a+96>>2]=e;v[a+100>>2]=c;c=d+24|0;Sc(c,f,11);e=v[a+100>>2];h=b;i=v[a+96>>2];b=Cb(v[v[d+24>>2]>>2],v[d+28>>2]);v[a+72>>2]=b?h:i;v[a+76>>2]=b?g:e;Sc(c,f,11);if(!Cb(v[v[d+24>>2]>>2],v[d+28>>2])){b=v[a+100>>2]+v[a+20>>2]|0;e=v[a+16>>2];c=e+v[a+96>>2]|0;v[a+80>>2]=c;v[a+84>>2]=c>>>0<e>>>0?b+1|0:b}a=d+24|0;Sc(a,f,10);Ze(a,1)}kb=d+352|0}function wM(a,b){var c=0,d=0,e=0,f=0,g=C(0),h=0,i=0,j=0,k=0,l=C(0),m=C(0),n=0,o=0,p=0,q=0,r=0,s=C(0),t=0;if(b){ry(a);c=a+24596|0;v[c>>2]=0;v[c+4>>2]=0;v[a+24588>>2]=0;v[a+24592>>2]=0;BM(a)}vM(a+24648|0);o=v[a+24620>>2];f=kb-144|0;kb=f;e=a+397456|0;c=v[e+4>>2];if(c>>>0>=29){v[e+4>>2]=0;c=0}h=B(c,44)+47584|0;if(!(b?0:(h|0)==v[e+8>>2])){v[e+8>>2]=h;m=C(o>>>0);c=f+8|0;d=v[h+24>>2];v[c>>2]=d;j=v[h+16>>2];v[c+4>>2]=j;v[c+8>>2]=v[h+4>>2];k=(d|0)>(j|0)?d:j;if((k|0)<=-601){i=j;j=k+600|0;v[c+4>>2]=i-j;v[c>>2]=d-j}g=C(z[h+36>>2]*C(79.30999755859375));a:{if(C(D(g))<C(2147483648)){d=~~g;break a}d=-2147483648}v[c+16>>2]=d- -8192;g=C(C(C(z[h+32>>2]*C(.0036000001709908247))+C(.15000000596046448))*C(32767));b:{if(C(D(g))<C(2147483648)){d=~~g;break b}d=-2147483648}v[c+20>>2]=(d|0)<32512?d:32512;j=0;g=z[h+8>>2];l=C(C(F(z[h+20>>2],C(.10000000149011612)))*m);c:{if(C(D(l))<C(2147483648)){d=~~l;break c}d=-2147483648}k=(d|0)>96?d:96;i=k-7500|0;n=k>>>0<i>>>0?0:i;l=C(z[h+28>>2]*m);d:{if(C(D(l))<C(2147483648)){i=~~l;break d}i=-2147483648}d=n+(i+((d|0)<96?d-96|0:0)|0)|0;i=(d|0)>128?d:128;p=i>>>0<3800?i:3800;v[c+24>>2]=p;n=(d|0)<128?d-128|0:0;g=C(g*m);e:{if(C(D(g))<C(2147483648)){q=~~g;break e}q=-2147483648}d=i-3800|0;i=(q+n|0)+(d>>>0>i>>>0?0:d)|0;v[c+32>>2]=i;n=k>>>0<7500?k:7500;while(1){if((j|0)==8){g=C(i|0);l=C(te(C(.0010000000474974513),(i|0)<4721?C(1):C(C(4720)/g))*C(32768));f:{if(C(D(l))<C(2147483648)){d=~~l;break f}d=-2147483648}v[c+12>>2]=d;g=C(z[h+12>>2]*g);r=c,s=te(C(.0010000000474974513),g<=C(4720)?C(1):C(C(4720)/g)),z[r+28>>2]=s}else{d=B(j,12);k=d+c|0;u[k+42>>1]=x[d+48874>>1];u[k+36>>1]=x[d+48868>>1];u[k+40>>1]=x[d+48872>>1];u[k+38>>1]=x[d+48870>>1];v[k+44>>2]=n+((B(v[d+48864>>2],p)+50|0)/100|0);j=j+1|0;continue}break}v[e+20>>2]=v[f+40>>2];c=xK(yK(v[f+16>>2]),m);u[e+86>>1]=c;u[e+84>>1]=c;c=x[f+24>>1]<<1;u[e+94>>1]=c;u[e+92>>1]=c;c=0;while(1){if((c|0)==8){v[e+49892>>2]=v[f+32>>2];c=v[f+12>>2];if((c|0)>-9e3){c=wK(c)}else{c=0}v[e+80>>2]=c;d=e+49948|0;c=v[f+8>>2];if((c|0)>=-8999){c=wK(c)}else{c=0}v[d>>2]=c;c=v[f+28>>2];d=e+49932|0;v[d>>2]=268464128;v[d+4>>2]=1879052288;c=c>>>0<32512?c:32512;u[e+49906>>1]=c;u[e+49904>>1]=c;u[e+49902>>1]=c;u[e+49900>>1]=c;v[f+4>>2]=v[f+20>>2];oe(f+4|0,0,32752);c=x[f+4>>1];u[e+49914>>1]=c;d=e+49910|0;u[d>>1]=0;u[d+2>>1]=0;u[e+49908>>1]=c;g=z[f+36>>2];r=f,t=xK(C(g*g),m),v[r>>2]=t;oe(f,256,32512);c=x[f>>1];u[e+49922>>1]=c;d=e+49918|0;u[d>>1]=0;u[d+2>>1]=0;u[e+49916>>1]=c}else{d=(c<<4)+e|0;h=(f+8|0)+B(c,12)|0;j=v[h+44>>2];v[d+100>>2]=j;v[d+104>>2]=j;u[d+108>>1]=x[h+36>>1];u[d+110>>1]=x[h+42>>1];u[d+112>>1]=x[h+40>>1];u[d+114>>1]=x[h+38>>1];c=c+1|0;continue}break}}c=a+397448|0;d=a+397452|0;if(b){v[e+16>>2]=0;AK(e,c,d)}b=B(o,5);if(b>>>0>y[e+20>>2]){v[e+20>>2]=b}kb=f+144|0;b=v[a+1298300>>2];if(zd(b)){YO(b,v[a+24620>>2])}}function z6(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;f=kb-96|0;kb=f;a:{if(Re(b)){break a}e=w[PJ(b)|0];if((e|0)==33){d=1}else{if((e|0)!=63){break a}d=0}e=f+80|0;Pv(e,b,0,Hb(b)-1|0);Bc(b,e);zb(e)}g=f+80|0;Xd(g);e=v[f+80>>2];Xd(f- -64|0);e=OJ(e,v[f+68>>2],b);Xd(g);b:{c:{d:{e:{if((e|0)==v[f+84>>2]){if(ue(b,21688)){a=ba(8)|0;v[23540]=0;U(952,f+80|0,17667,c|0);b=v[23540];v[23540]=0;if((b|0)==1){break d}a=tc(a,f+80|0);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break b}b=P()|0;O()|0;zb(f+80|0);break c}if(!d){break e}a=ba(8)|0;v[23540]=0;U(952,f+48|0,17703,b|0);b=v[23540];v[23540]=0;f:{g:{h:{i:{j:{if((b|0)!=1){v[23540]=0;R(963,f- -64|0,f+48|0);b=v[23540];v[23540]=0;if((b|0)==1){break j}v[23540]=0;U(529,f+80|0,f- -64|0,c|0);b=v[23540];v[23540]=0;d=1;if((b|0)==1){break i}b=tc(a,f+80|0);v[23540]=0;U(119,b|0,62752,950);b=v[23540];v[23540]=0;if((b|0)!=1){break b}b=P()|0;O()|0;zb(f+80|0);d=0;break h}b=P()|0;O()|0;break f}b=P()|0;d=1;O()|0;break g}b=P()|0;O()|0}zb(f- -64|0)}zb(f+48|0);if(!d){break c}}ca(a|0);break c}k:{switch(v[e+4>>2]){case 0:Fe(f+40|0,b);b=kb-192|0;kb=b;e=b+16|0;qi(e,c);v[23540]=0;R(88,b+32|0,e|0);c=v[23540];v[23540]=0;l:{m:{n:{o:{p:{if((c|0)!=1){v[23540]=0;c=Q(89,b+48|0,b+32|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break p}zb(b+32|0);zb(b+16|0);e=v[v[c>>2]-12>>2];v[23540]=0;g=ga(62)|0;h=v[23540];v[23540]=0;if((h|0)==1){break n}v[23540]=0;U(63,b+8|0,c+e|0,g|0);e=v[23540];v[23540]=0;if((e|0)==1){break n}ac(b+8|0);v[23540]=0;e=Q(1062,c|0,b+32|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break n}c=Yk(v[(e+v[v[e>>2]-12>>2]|0)+16>>2]);g=w[b+32|0];sf(e);kb=b+192|0;b=(c^-1)&(g|0)!=0;break l}a=P()|0;O()|0;break o}a=P()|0;O()|0;zb(b+32|0)}zb(b+16|0);break m}a=P()|0;O()|0;sf(c)}T(a|0);L()}lK(a,v[f+40>>2],v[f+44>>2],b,d);break e;case 1:Fe(f+32|0,b);b=kb-192|0;kb=b;e=b+16|0;qi(e,c);v[23540]=0;R(88,b+32|0,e|0);c=v[23540];v[23540]=0;q:{r:{s:{t:{u:{if((c|0)!=1){v[23540]=0;c=Q(89,b+48|0,b+32|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break u}zb(b+32|0);zb(b+16|0);e=v[v[c>>2]-12>>2];v[23540]=0;g=ga(62)|0;h=v[23540];v[23540]=0;if((h|0)==1){break s}v[23540]=0;U(63,b+8|0,c+e|0,g|0);e=v[23540];v[23540]=0;if((e|0)==1){break s}ac(b+8|0);v[23540]=0;e=Q(96,c|0,b+32|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break s}c=Yk(v[(e+v[v[e>>2]-12>>2]|0)+16>>2]);g=v[b+32>>2];h=v[b+36>>2];sf(e);kb=b+192|0;b=c?0:g;c=c?0:h;break q}a=P()|0;O()|0;break t}a=P()|0;O()|0;zb(b+32|0)}zb(b+16|0);break r}a=P()|0;O()|0;sf(c)}T(a|0);L()}jK(a,v[f+32>>2],v[f+36>>2],b,c,d);break e;case 2:Fe(f+24|0,b);i=oH(c);kK(a,v[f+24>>2],v[f+28>>2],i,d);break e;case 3:break k;default:break e}}Fe(f+16|0,b);Fe(f+8|0,c);iK(a,v[f+16>>2],v[f+20>>2],v[f+8>>2],v[f+12>>2],d)}kb=f+96|0;return}b=P()|0;O()|0;ca(a|0)}T(b|0)}L()}function vea(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=kb-32|0;kb=j;a:{b:{if(Bt(a)>>>0<b>>>0){if((b|0)<0){break b}n=io(j+16|0);v[23540]=0;R(730,n|0,b|0);b=v[23540];v[23540]=0;if((b|0)==1){break a}tl(j+8|0,v[a>>2]);Cm(j,v[a>>2],v[a+4>>2]);m=kb-48|0;kb=m;c=v[n+4>>2];e=hc(m+40|0,v[j+8>>2],v[j+12>>2]);f=hc(m+32|0,v[j>>2],v[j+4>>2]);b=kb-16|0;kb=b;e=hc(b+8|0,v[e>>2],v[e+4>>2]);f=hc(b,v[f>>2],v[f+4>>2]);e=mR(v[e>>2],v[e+4>>2],v[f>>2],v[f+4>>2]);kb=b+16|0;e=c+e|0;v[n+4>>2]=e;c:{d:{if(!c){b=e-1|0;break d}b=e-1|0;if((b^c-1)>>>0<32){break c}}v[v[n>>2]+((e>>>0<33?0:b>>>5|0)<<2)>>2]=0}f=hc(m+24|0,v[j+8>>2],v[j+12>>2]);e=hc(m+16|0,v[j>>2],v[j+4>>2]);b=m+8|0;Oo(b,v[n>>2],c);c=v[f>>2];o=kb-48|0;kb=o;f=v[f+4>>2];e:{if((f|0)==v[b+4>>2]){f=hc(o+40|0,c,f);c=hc(o+32|0,v[e>>2],v[e+4>>2]);b=hc(o+24|0,v[b>>2],v[b+4>>2]);e=kb-16|0;kb=e;g=v[f>>2];d=v[f+4>>2];c=sl(v[c>>2],v[c+4>>2],g,d);v[e+12>>2]=c;f:{if((c|0)<=0){c=v[b>>2];break f}if(d){i=32-d|0;v[e+8>>2]=i;k=c;c=v[td(e+8|0,e+12|0)>>2];v[e+12>>2]=k-c;h=v[b>>2];d=-1<<d&-1>>>i-c;v[h>>2]=v[h>>2]&(d^-1)|d&v[g>>2];c=c+v[b+4>>2]|0;v[b+4>>2]=c&31;v[b>>2]=h+(c>>>3&536870908);g=v[f>>2]+4|0;v[f>>2]=g;c=v[e+12>>2]}k=g;d=(c|0)/32|0;g=d<<2;fj(v[b>>2],k,g);d=c-(d<<5)|0;v[e+12>>2]=d;c=g+v[b>>2]|0;v[b>>2]=c;if((d|0)<=0){break f}c=f;f=g+v[f>>2]|0;v[c>>2]=f;c=v[b>>2];g=-1>>>32-d|0;v[c>>2]=v[c>>2]&(g^-1)|g&v[f>>2];v[b+4>>2]=v[e+12>>2]}hc(m,c,v[b+4>>2]);break e}g=hc(o+16|0,c,f);c=hc(o+8|0,v[e>>2],v[e+4>>2]);f=hc(o,v[b>>2],v[b+4>>2]);e=kb-16|0;kb=e;k=v[c>>2];d=v[c+4>>2];b=v[g>>2];c=v[g+4>>2];d=sl(k,d,b,c);v[e+12>>2]=d;g:{if((d|0)<=0){c=v[f+4>>2];break g}h:{if(!c){c=v[f+4>>2];break h}l=32-c|0;v[e+8>>2]=l;i=e+8|0;h=v[td(i,e+12|0)>>2];v[e+12>>2]=d-h;d=v[f+4>>2];p=v[b>>2];v[e+8>>2]=h;k=32-d|0;v[e+4>>2]=k;b=v[f>>2];q=v[b>>2];i=v[Kb(i,e+4|0)>>2];l=p&(-1<<c&-1>>>l-h);v[b>>2]=(-1<<d&-1>>>k-i^-1)&q|(c>>>0<d>>>0?l<<d-c:l>>>c-d|0);d=d+i|0;c=d&31;v[f+4>>2]=c;d=b+(d>>>3&536870908)|0;v[f>>2]=d;b=h-i|0;if((b|0)>0){v[d>>2]=v[d>>2]&(-1>>>32-b^-1)|l>>>i+v[g+4>>2];v[f+4>>2]=b;c=b}b=v[g>>2]+4|0;v[g>>2]=b;d=v[e+12>>2]}h=32-c|0;i=-1<<c;l=i^-1;while(1){if((d|0)>=32){d=v[f>>2];b=v[b>>2];v[d>>2]=l&v[d>>2]|b<<c;v[f>>2]=d+4;v[d+4>>2]=i&v[d+4>>2]|b>>>h;d=v[e+12>>2]-32|0;v[e+12>>2]=d;b=v[g>>2]+4|0;v[g>>2]=b;continue}break}if((d|0)<=0){break g}l=v[b>>2];v[e+8>>2]=h;g=v[f>>2];b=v[g>>2];k=b;b=v[td(e+12|0,e+8|0)>>2];k=k&(i&-1>>>h-b^-1);h=l&-1>>>32-d;v[g>>2]=k|h<<c;d=b+c|0;c=d&31;v[f+4>>2]=c;g=g+(d>>>3&536870908)|0;v[f>>2]=g;d=v[e+12>>2]-b|0;v[e+12>>2]=d;if((d|0)<=0){break g}v[g>>2]=v[g>>2]&(-1>>>32-d^-1)|h>>>b;c=v[e+12>>2];v[f+4>>2]=c}hc(m,v[f>>2],c)}kb=e+16|0;kb=o+48|0;kb=m+48|0;Kt(a,n);We(n)}kb=j+32|0;return}cd();L()}a=P()|0;O()|0;We(n);T(a|0);L()}function qE(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=kb-176|0;kb=d;a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{z:{A:{B:{C:{D:{E:{if((b|0)<=5){Vv(d+128|0,b);v[23540]=0;b=Q(1,d+112|0,17803)|0;e=v[23540];v[23540]=0;if((e|0)==1){break E}v[23540]=0;U(2,d+144|0,d+128|0,b|0);e=v[23540];v[23540]=0;if((e|0)==1){break D}v[23540]=0;c=Q(3,d+80|0,c|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break C}v[23540]=0;e=Q(1,d- -64|0,19631)|0;f=v[23540];v[23540]=0;if((f|0)==1){break B}v[23540]=0;U(4,d+96|0,c|0,e|0);f=v[23540];v[23540]=0;if((f|0)==1){break A}v[23540]=0;U(2,d+160|0,d+144|0,d+96|0);f=v[23540];v[23540]=0;if((f|0)==1){break z}Ab(d+96|0);Ab(e);Ab(c);c=d+144|0;Ab(c);Ab(b);Ab(d+128|0);b=v[a>>2];v[23540]=0;U(5,c|0,1,(b?b:21688)|0);b=v[23540];v[23540]=0;if((b|0)==1){break t}b=v[a+4>>2];v[23540]=0;U(5,d+128|0,1,(b?b:21688)|0);b=v[23540];v[23540]=0;if((b|0)==1){break s}a=v[a+8>>2];v[23540]=0;v[d+48>>2]=a;R(6,d+96|0,d+48|0);a=v[23540];v[23540]=0;if((a|0)==1){break r}v[23540]=0;Y(7,17682);a=v[23540];v[23540]=0;if((a|0)==1){break q}v[23540]=0;U(8,d+48|0,0,d+144|0);a=v[23540];v[23540]=0;if((a|0)==1){break p}v[23540]=0;Y(9,d+48|0);a=v[23540];v[23540]=0;if((a|0)==1){break o}v[23540]=0;Y(7,17476);a=v[23540];v[23540]=0;if((a|0)==1){break o}v[23540]=0;U(8,d+32|0,0,d+96|0);a=v[23540];v[23540]=0;if((a|0)==1){break n}v[23540]=0;Y(9,d+32|0);a=v[23540];v[23540]=0;if((a|0)==1){break m}v[23540]=0;Y(7,17474);a=v[23540];v[23540]=0;if((a|0)==1){break m}v[23540]=0;Y(7,17803);a=v[23540];v[23540]=0;if((a|0)==1){break m}v[23540]=0;U(8,d+16|0,0,d+160|0);a=v[23540];v[23540]=0;if((a|0)==1){break l}v[23540]=0;Y(9,d+16|0);a=v[23540];v[23540]=0;if((a|0)==1){break k}v[23540]=0;Y(7,13422);a=v[23540];v[23540]=0;if((a|0)==1){break k}v[23540]=0;U(8,d|0,0,d+128|0);a=v[23540];v[23540]=0;if((a|0)==1){break j}v[23540]=0;Y(9,d|0);a=v[23540];v[23540]=0;if((a|0)==1){break i}v[23540]=0;Y(7,13420);a=v[23540];v[23540]=0;if((a|0)==1){break i}v[23540]=0;Z(10);a=v[23540];v[23540]=0;if((a|0)==1){break i}zb(d);zb(d+16|0);zb(d+32|0);zb(d+48|0);Ab(d+96|0);Ab(d+128|0);Ab(d+144|0);Ab(d+160|0)}kb=d+176|0;return}a=P()|0;O()|0;break u}a=P()|0;O()|0;break v}a=P()|0;O()|0;break w}a=P()|0;O()|0;break x}a=P()|0;O()|0;break y}a=P()|0;O()|0;Ab(d+96|0)}Ab(e)}Ab(c)}Ab(d+144|0)}Ab(b)}Ab(d+128|0);break a}a=P()|0;O()|0;break b}a=P()|0;O()|0;break c}a=P()|0;O()|0;break d}a=P()|0;O()|0;break e}a=P()|0;O()|0;break e}a=P()|0;O()|0;break f}a=P()|0;O()|0;break f}a=P()|0;O()|0;break g}a=P()|0;O()|0;break g}a=P()|0;O()|0;break h}a=P()|0;O()|0;break h}a=P()|0;O()|0;zb(d)}zb(d+16|0)}zb(d+32|0)}zb(d+48|0)}Ab(d+96|0)}Ab(d+128|0)}Ab(d+144|0)}Ab(d+160|0)}T(a|0);L()}function QW(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=kb-160|0;kb=d;zc(b);Zo(a);a:{if(!vv(b,d+120|0)){break a}if(!tD(d+120|0)){break a}j=v[b+8>>2];b:{if(!dd(b,w[d+136|0]|w[d+137|0]<<8|(w[d+138|0]<<16|w[d+139|0]<<24))){break b}while(1){c:{if((w[d+132|0]|w[d+133|0]<<8|(w[d+134|0]<<16|w[d+135|0]<<24))>>>0>h>>>0){if(Qb(v[b>>2],v[b+8>>2],5)){break c}}f=i&1;break b}f=0;g=1;d:{if((w[d+124|0]|w[d+125|0]<<8)>>>0>=64){if((wi(b)|0)<=0){break d}}while(1){l=Me(b);if(l){m=f>>>0>4;e=m&g;if(!((g^1)&1|m)){e=(Tp(l<<24>>24)&255)==w[f+13086|0]}g=e;f=f+1|0;continue}break}$b(b,4);i=(f|0)==5?g&1?1:i:i}h=h+1|0;continue}}dd(b,j);if(!f){break a}if(!Qb(v[b>>2],v[b+8>>2],sD(d+120|0))){break a}if(!c){k=1;break a}g=kb-16|0;kb=g;e=d+120|0;dd(b,w[e+16|0]|w[e+17|0]<<8|(w[e+18|0]<<16|w[e+19|0]<<24));i=d+104|0;f=Tb(i);c=w[e+12|0]|w[e+13|0]<<8|(w[e+14|0]<<16|w[e+15|0]<<24);v[23540]=0;R(181,f|0,c|0);c=v[23540];v[23540]=0;e:{f:{g:{if((c|0)!=1){c=0;h:{i:{while(1){if((w[e+12|0]|w[e+13|0]<<8|(w[e+14|0]<<16|w[e+15|0]<<24))>>>0<=c>>>0){break h}h=v[b+8>>2];j=v[b>>2];v[23540]=0;h=W(156,j|0,h|0,5)|0;j=v[23540];v[23540]=0;if((j|0)==1){break g}if(!h){break h}h=w[e+4|0]|w[e+5|0]<<8;v[23540]=0;U(182,g|0,b|0,h|0);h=v[23540];v[23540]=0;if((h|0)!=1){v[23540]=0;R(183,f|0,g|0);h=v[23540];v[23540]=0;if((h|0)==1){break i}c=c+1|0;zb(g);continue}break}c=P()|0;O()|0;break f}c=P()|0;O()|0;zb(g);break f}kb=g+16|0;break e}c=P()|0;O()|0;break f}c=P()|0;O()|0}Xe(f);T(c|0);L()}v[23540]=0;X(176,d+88|0,b|0,e|0,i|0);c=v[23540];v[23540]=0;j:{if((c|0)!=1){v[23540]=0;Q(155,b|0,v[d+144>>2])|0;c=v[23540];v[23540]=0;k:{if((c|0)!=1){g=d+36|0;l:{m:{n:{o:{while(1){p:{q:{if(y[d+140>>2]>k>>>0){c=v[b+8>>2];e=v[b>>2];v[23540]=0;c=W(156,e|0,c|0,8)|0;e=v[23540];v[23540]=0;if((e|0)==1){break q}if(c){break p}}k=pc(v[a>>2],v[a+4>>2])^1;wc(d+88|0);Xe(d+104|0);break a}b=P()|0;O()|0;break k}v[23540]=0;da(177,d- -64|0,b|0,d+120|0,d+88|0,d+104|0);c=v[23540];v[23540]=0;if((c|0)!=1){e=_o(d- -64|0);v[23540]=0;c=S(178,v[d+64>>2])|0;f=v[23540];v[23540]=0;if((f|0)==1){break o}if(c){v[23540]=0;c=S(179,d+24|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break n}e=v[e>>2];r:{if((e|0)<0){break r}f=v[d+104>>2];if(yd(f,v[d+108>>2])>>>0<=e>>>0){break r}v[23540]=0;U(11,d+8|0,8,Nd(f,e)|0);e=v[23540];v[23540]=0;if((e|0)==1){break m}e=d+8|0;Jb(c,e);Ab(e)}tv(g,d- -64|0);v[23540]=0;R(180,a|0,c|0);e=v[23540];v[23540]=0;if((e|0)==1){break m}jr(c)}k=k+1|0;Bb(d- -64|0);continue}break}b=P()|0;O()|0;break k}b=P()|0;O()|0;break l}b=P()|0;O()|0;break l}b=P()|0;O()|0;jr(c)}Bb(d- -64|0);break k}b=P()|0;O()|0}wc(d+88|0);break j}b=P()|0;O()|0}Xe(d+104|0);T(b|0);L()}kb=d+160|0;return k|0}function GK(a){var b=C(0),c=C(0),d=0,e=C(0),f=C(0),g=0,h=0,i=C(0),k=0,m=C(0),r=C(0),s=0,t=C(0),u=0,w=C(0),x=C(0);d=a+4208|0;eO(Eb(d,0),z[a+4272>>2]);b=C(C(z[Eb(d,0)>>2]*C(15920))+C(80));t=te(C(10),C(C(C(z[Eb(d,2)>>2]+C(-.5))*C(30))/C(40)));c=C(C(b/C(y[v[a+16>>2]+24620>>2]))*C(6.2831854820251465));b=XK(c);w=Fp(c);x=b;f=C(C(c*C(C(C(z[Eb(d,1)>>2]*C(35))+C(1))*C(.02888113260269165)))/b);m=(l(2,(p(f),j(2))&-2147483648|1056964608),q());g=(p(f),j(2))&2147483647;c=(l(2,g),q());a:{if(g>>>0<=1118925334){b:{c:{d:{e:{f:{g:{h=(p(c),j(2));d=h&2147483647;if(d>>>0>=1100331076){if(d>>>0>2139095040){break c}b=C(-1);if((h|0)<0){break b}if(!(c>C(88.7216796875))){break g}b=C(c*C(1.7014118346046923e38));break b}if(d>>>0<1051816473){break e}if(d>>>0>1065686417){break g}if((h|0)>=0){d=1;e=C(905800061445916e-20);b=C(c+C(-.6931381225585938));break f}d=-1;e=C(-905800061445916e-20);b=C(c+C(.6931381225585938));break f}b=C(C(c*C(1.4426950216293335))+(l(2,(p(c),j(2))&-2147483648|1056964608),q()));h:{if(C(D(b))<C(2147483648)){d=~~b;break h}d=-2147483648}b=C(d|0);e=C(b*C(905800061445916e-20));b=C(c+C(b*C(-.6931381225585938)))}c=C(b-e);e=C(C(b-c)-e);break d}if(d>>>0<855638016){break c}d=0}b=C(c*C(.5));i=C(c*b);r=C(C(i*C(C(i*C(.0015807170420885086))+C(-.03333321213722229)))+C(1));b=C(C(3)-C(r*b));r=C(i*C(C(r-b)/C(C(6)-C(c*b))));b=C(c-C(C(c*r)-i));if(!d){break b}e=C(C(C(c*C(r-e))-e)-i);i:{switch(d+1|0){case 0:b=C(C(C(c-e)*C(.5))+C(-.5));break b;case 2:b=C(C(e-C(c+C(.5)))*C(-2));if(c<C(-.25)){break b}b=C(c-e);b=C(C(b+b)+C(1));break b;default:break i}}h=d<<23;b=(l(2,h+1065353216|0),q());if(d>>>0>=57){c=C(C(c-e)+C(1));b=C(((d|0)==128?C(C(c+c)*C(1.7014118346046923e38)):C(c*b))+C(-1));break b}i=(l(2,1065353216-h|0),q());c=C((d>>>0<=22?C(C(C(1)-i)+C(c-e)):C(C(c-C(e+i))+C(1)))*b)}b=c}if(g>>>0<=1065353215){if(g>>>0<964689920){break a}f=C(m*C(C(b+b)-C(C(b*b)/C(b+C(1)))));break a}f=C(m*C(b+C(b/C(b+C(1)))));break a}m=C(C(m+m)*C(1.661534994731145e35));b=C(c+C(-162.88958740234375));d=cx(b)&2047;j:{k:{if(cx(C(88))>>>0>d>>>0){break k}c=C(0);if(((p(b),j(2))|0)==-8388608){break j}c=C(b+b);if(cx(C(N))>>>0<=d>>>0){break j}if(b>C(88.72283172607422)){c=JD(0);break j}if(!(b<C(-103.97207641601562))){break k}c=iD(0);break j}k=A[165]*+b;s=A[164];u=k+s;k=k-(u-s);s=(A[166]*k+A[167])*(k*k)+(A[168]*k+1);o(+u);j(1)|0;d=j(0)|0;h=d<<15;d=((d&31)<<3)+1024|0;g=v[d>>2];d=v[d+4>>2]+h|0;l(0,g|0);l(1,(g>>>0<g>>>0?d+1|0:d)|0);c=C(s*+n())}f=C(C(m*c)*C(1.661534994731145e35))}c=C(x*f);f=C(c/t);b=C(f+C(1));z[a+4236>>2]=C(C(1)-f)/b;f=C(C(w*C(-2))/b);z[a+4232>>2]=f;c=C(c*t);z[a+4228>>2]=C(C(1)-c)/b;z[a+4224>>2]=f;z[a+4220>>2]=C(c+C(1))/b}function uF(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,k=0,m=0,p=0;i=kb-48|0;kb=i;o(+a);e=j(1)|0;d=j(0)|0;a:{b:{h=e;k=e&2147483647;c:{if(k>>>0<=1074752122){if((h&1048575)==598523){break c}if(k>>>0<=1073928572){if((e|0)>0|(e|0)>=0){a=a+-1.5707963267341256;c=a+-6.077100506506192e-11;A[b>>3]=c;A[b+8>>3]=a-c+-6.077100506506192e-11;d=1;break a}a=a+1.5707963267341256;c=a+6.077100506506192e-11;A[b>>3]=c;A[b+8>>3]=a-c+6.077100506506192e-11;d=-1;break a}if((e|0)>0|(e|0)>=0){a=a+-3.1415926534682512;c=a+-1.2154201013012384e-10;A[b>>3]=c;A[b+8>>3]=a-c+-1.2154201013012384e-10;d=2;break a}a=a+3.1415926534682512;c=a+1.2154201013012384e-10;A[b>>3]=c;A[b+8>>3]=a-c+1.2154201013012384e-10;d=-2;break a}if(k>>>0<=1075594811){if(k>>>0<=1075183036){if((k|0)==1074977148){break c}if((e|0)>0|(e|0)>=0){a=a+-4.712388980202377;c=a+-1.8231301519518578e-10;A[b>>3]=c;A[b+8>>3]=a-c+-1.8231301519518578e-10;d=3;break a}a=a+4.712388980202377;c=a+1.8231301519518578e-10;A[b>>3]=c;A[b+8>>3]=a-c+1.8231301519518578e-10;d=-3;break a}if((k|0)==1075388923){break c}if((e|0)>0|(e|0)>=0){a=a+-6.2831853069365025;c=a+-2.430840202602477e-10;A[b>>3]=c;A[b+8>>3]=a-c+-2.430840202602477e-10;d=4;break a}a=a+6.2831853069365025;c=a+2.430840202602477e-10;A[b>>3]=c;A[b+8>>3]=a-c+2.430840202602477e-10;d=-4;break a}if(k>>>0>1094263290){break b}}f=a*.6366197723675814+6755399441055744+-6755399441055744;c=a+f*-1.5707963267341256;g=f*6.077100506506192e-11;p=c-g;e=p<-.7853981633974483;if(D(f)<2147483648){d=~~f}else{d=-2147483648}d:{if(e){d=d-1|0;f=f+-1;g=f*6.077100506506192e-11;c=a+f*-1.5707963267341256;break d}if(!(p>.7853981633974483)){break d}d=d+1|0;f=f+1;g=f*6.077100506506192e-11;c=a+f*-1.5707963267341256}a=c-g;A[b>>3]=a;o(+a);h=j(1)|0;j(0)|0;e=k>>>20|0;e:{if((e-(h>>>20&2047)|0)<17){break e}g=c;a=f*6.077100506303966e-11;c=c-a;g=f*2.0222662487959506e-21-(g-c-a);a=c-g;A[b>>3]=a;h=e;o(+a);e=j(1)|0;j(0)|0;if((h-(e>>>20&2047)|0)<50){break e}g=c;a=f*2.0222662487111665e-21;c=c-a;g=f*8.4784276603689e-32-(g-c-a);a=c-g;A[b>>3]=a}A[b+8>>3]=c-a-g;break a}if(k>>>0>=2146435072){a=a-a;A[b>>3]=a;A[b+8>>3]=a;d=0;break a}l(0,d|0);l(1,e&1048575|1096810496);a=+n();d=0;h=1;while(1){m=(i+16|0)+(d<<3)|0;if(D(a)<2147483648){d=~~a}else{d=-2147483648}c=+(d|0);A[m>>3]=c;a=(a-c)*16777216;d=1;m=h&1;h=0;if(m){continue}break}A[i+32>>3]=a;f:{if(a!=0){h=3;break f}d=2;while(1){h=d;d=d-1|0;if(A[(i+16|0)+(d<<3)>>3]==0){continue}break}}d=TH(i+16|0,i,(k>>>20|0)-1046|0,h,1);a=A[i>>3];if((e|0)<0){A[b>>3]=-a;A[b+8>>3]=-A[i+8>>3];d=0-d|0;break a}A[b>>3]=a;A[b+8>>3]=A[i+8>>3]}kb=i+48|0;return d}function jK(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=kb-128|0;kb=g;v[g+124>>2]=c;v[g+120>>2]=b;v[g+112>>2]=d;v[g+116>>2]=e;a:{if(!c){break a}h=w[cl(b,c)|0];if((h|0)==33){f=1}else{if((h|0)!=63){break a}f=0}jl(g+88|0,b,c,c-1|0);b=v[g+92>>2];v[g+120>>2]=v[g+88>>2];v[g+124>>2]=b}b=g+88|0;Xd(b);c=v[g+88>>2];Xd(g+72|0);h=bl(c,v[g+76>>2],g+120|0);Xd(b);b=v[g+124>>2];c=v[g+120>>2];b:{c:{d:{e:{f:{g:{h:{if((h|0)==v[g+92>>2]){a=rc(g+104|0,21688);if(Qc(c,b,v[a>>2],v[a+4>>2])){b=ba(8)|0;v[23540]=0;R(956,g+72|0,g+112|0);a=v[23540];v[23540]=0;if((a|0)==1){break g}v[23540]=0;U(961,g+88|0,17667,g+72|0);a=v[23540];v[23540]=0;if((a|0)==1){break f}a=0;c=tc(b,g+88|0);v[23540]=0;U(119,c|0,62752,950);c=v[23540];v[23540]=0;if((c|0)!=1){break b}c=P()|0;O()|0;zb(g+88|0);break e}if(!f){break h}b=ba(8)|0;v[23540]=0;a=Mh(g+40|0,v[g+120>>2],v[g+124>>2]);c=v[23540];v[23540]=0;i:{j:{k:{l:{m:{n:{o:{p:{if((c|0)!=1){v[23540]=0;U(961,g+56|0,17703,a|0);c=v[23540];v[23540]=0;if((c|0)==1){break p}v[23540]=0;R(963,g+72|0,g+56|0);c=v[23540];v[23540]=0;f=1;if((c|0)==1){break o}v[23540]=0;R(956,g+24|0,g+112|0);c=v[23540];v[23540]=0;if((c|0)==1){break n}v[23540]=0;U(965,g+88|0,g+72|0,g+24|0);c=v[23540];v[23540]=0;if((c|0)==1){break m}c=tc(b,g+88|0);v[23540]=0;U(119,c|0,62752,950);c=v[23540];v[23540]=0;if((c|0)!=1){break b}c=P()|0;O()|0;zb(g+88|0);f=0;break l}c=P()|0;O()|0;break d}c=P()|0;f=1;O()|0;break i}c=P()|0;O()|0;break j}c=P()|0;O()|0;break k}c=P()|0;O()|0}zb(g+24|0)}zb(g+72|0)}zb(g+56|0)}zb(a);if(f){break d}break c}f=rc(g+16|0,21688);if(Qc(c,b,v[f>>2],v[f+4>>2])){b=ba(8)|0;v[23540]=0;R(956,g+72|0,g+112|0);a=v[23540];v[23540]=0;q:{r:{if((a|0)!=1){v[23540]=0;U(961,g+88|0,17667,g+72|0);a=v[23540];v[23540]=0;if((a|0)==1){break r}a=0;c=tc(b,g+88|0);v[23540]=0;U(119,c|0,62752,950);c=v[23540];v[23540]=0;if((c|0)!=1){break b}c=P()|0;O()|0;zb(g+88|0);break q}c=P()|0;O()|0;break d}c=P()|0;a=1;O()|0}zb(g+72|0);if(a){break d}break c}f=rc(g+8|0,10964);if(Qc(c,b,v[f>>2],v[f+4>>2])){cK(a,Hc(d,e));break h}f=b;b=rc(g,8656);if(!Qc(c,f,v[b>>2],v[b+4>>2])){break h}a=v[a+32>>2];b=cz(d,e);b=b>>>0<4?b:1;c=kb-16|0;kb=c;s:{if((dk(w[a+140|0])|0)==(b|0)){d=a+120|0;zs(w[d+20|0]);b=kb-16|0;kb=b;v[b+8>>2]=c+8;a=kb-16|0;kb=a;e=v[15611];v[a+8>>2]=v[15610];v[a+12>>2]=e;e=v[15609];v[a>>2]=v[15608];v[a+4>>2]=e;ob[v[yp(a,dk(w[d+20|0]))>>2]](b+8|0,d);kb=a+16|0;kb=b+16|0;break s}KJ(a,b,LJ(a))}kb=c+16|0}kb=g+128|0;return}c=P()|0;O()|0;break d}c=P()|0;a=1;O()|0}zb(g+72|0);if(!a){break c}}ca(b|0)}T(c|0)}L()}function Am(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;e=kb-80|0;kb=e;h=Tb(a);v[23540]=0;a=S(279,b|0)|0;c=v[23540];v[23540]=0;a:{b:{c:{d:{e:{if((c|0)==1){break e}c=v[b+8>>2];d=v[b>>2];v[23540]=0;c=W(156,d|0,c|0,a|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break e}if(c){break d}v[23540]=0;a=S(202,b|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break e}v[23540]=0;Q(188,b|0,a|0)|0;a=v[23540];v[23540]=0;if((a|0)!=1){break c}}a=P()|0;O()|0;break a}v[23540]=0;U(190,e+32|0,b|0,a|0);b=v[23540];v[23540]=0;f:{g:{h:{if((b|0)!=1){b=e+32|0;c=kc(e+56|0,b);Bb(b);if(a>>>0<10){break g}v[23540]=0;b=S(707,c|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break b}if(!b){break g}v[23540]=0;b=S(279,c|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break b}v[e+28>>2]=b;a=a-10|0;xc(e+28|0,a>>>0>25264513?-1:B(a,170));v[23540]=0;d=v[e+28>>2];R(285,h|0,d|0);a=v[23540];v[23540]=0;if((a|0)!=1){break h}break b}a=P()|0;O()|0;break a}b=0;i:while(1){f=0;j:{k:{while(1){if(f){break j}a=v[c+8>>2];f=v[c>>2];v[23540]=0;a=Q(708,f|0,a|0)|0;f=v[23540];v[23540]=0;l:{m:{n:{o:{if((f|0)!=1){if(a){break j}v[23540]=0;a=S(519,c|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break b}f=1;switch(a|0){case 3:break l;case 2:break m;case 1:break n;case 0:break o;default:continue}}break b}v[23540]=0;a=S(206,c|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break b}if(a>>>0>d>>>0){continue}g=v[c+8>>2];i=v[c>>2];v[23540]=0;g=W(156,i|0,g|0,a|0)|0;i=v[23540];v[23540]=0;if((i|0)==1){break b}if(!g){continue}re(e+32|0,v[h>>2],v[h+4>>2]);Eq(e+16|0,v[e+32>>2],v[e+36>>2],b,a);v[23540]=0;Nk(459,e+8|0,c,v[e+16>>2],v[e+20>>2]);f=v[23540];v[23540]=0;if((f|0)!=1){d=d-a|0;b=a+b|0;continue i}break b}v[23540]=0;a=S(206,c|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break b}g=a<<2;if(g>>>0>d>>>0){continue}v[23540]=0;i=Q(709,c|0,e+24|0)|0;j=v[23540];v[23540]=0;if((j|0)==1){break b}if(!i){continue}while(1){if(!(a&255)){break k}f=e+24|0;i=jc(f);qh(f,i,Rf(Fb(v[h>>2]),b));b=b+4|0;a=a-1|0;continue}}if(d>>>0<8){continue}v[23540]=0;a=Q(709,c|0,e+24|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break b}if(!a){continue}a=e+24|0;f=jc(a);qh(a,f,Rf(Fb(v[h>>2]),b));qh(a,f,Rf(Rf(Fb(v[h>>2]),b),4));d=d-8|0;b=b+8|0;continue i}v[23540]=0;a=S(206,c|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break b}if(a>>>0>d>>>0){continue}break}d=d-a|0;b=a+b|0;continue}d=d-g|0;continue}break}if(!d){break f}a=Tb(e+32|0);Kt(a,h);ic(a);break f}v[23540]=0;U(327,c|0,h|0,a|0);a=v[23540];v[23540]=0;if((a|0)==1){break b}}Bb(c)}kb=e+80|0;return}a=P()|0;O()|0;Bb(c)}ic(h);T(a|0);L()}function cba(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;v[a+24588>>2]=0;v[a+24592>>2]=0;v[a+8>>2]=43632;v[a+4>>2]=0;v[a>>2]=32240;b=a+24596|0;v[b>>2]=0;v[b+4>>2]=0;fq(a+24604|0);cN(a+24648|0,0);v[a+397448>>2]=0;v[a+397452>>2]=0;b=a+397456|0;v[b>>2]=8;v[b+4>>2]=0;v[b+16>>2]=0;v[b+20>>2]=0;t[b+12|0]=0;v[b+8>>2]=0;u[b+24>>1]=0;Ub(b+28|0,0,40);Ub(b+68|0,0,49824);Ub(b+49892|0,0,32832);t[a+480224|0]=0;u[a+480212>>1]=0;v[a+480204>>2]=0;v[a+480208>>2]=0;v[a+480180>>2]=0;v[a+480184>>2]=0;b=a+480186|0;u[b>>1]=0;u[b+2>>1]=0;u[b+4>>1]=0;u[b+6>>1]=0;v[a+480240>>2]=65536;v[a+480244>>2]=65536;h=Tb(a+480248|0);v[a+480272>>2]=0;c=a+484344|0;b=a+480280|0;while(1){t[b+8|0]=0;v[b>>2]=0;v[b+4>>2]=4194432;OC(b+9|0);b=b+32|0;if((c|0)!=(b|0)){continue}break}f=Tb(c);v[f+12>>2]=a;v[23540]=0;i=Q(808,a+484360|0,a|0)|0;b=v[23540];v[23540]=0;a:{b:{c:{d:{e:{f:{g:{h:{i:{if((b|0)!=1){c=a+900380|0;b=a+484380|0;while(1){v[23540]=0;b=S(681,b|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break i}b=b+104|0;if((c|0)!=(b|0)){continue}break}v[23540]=0;S(809,a+901404|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break h}d=a+906300|0;b=0;while(1){YM(d+B(b,160)|0);b=b+1|0;if((b|0)!=250){continue}break}v[a+946300>>2]=0;e=a+1074304|0;g=a+946304|0;b=g;while(1){b=xt(b)+32|0;if((e|0)!=(b|0)){continue}break}v[a+1074304>>2]=0;v[a+1074308>>2]=0;ir(a+1074312|0);v[23540]=0;Z(810);b=v[23540];v[23540]=0;if((b|0)==1){break g}r=a,s=XM(),v[r+1074328>>2]=s;b=a+1074332|0;v[b+12>>2]=1065353216;MM(b,4);v[23540]=0;e=S(811,a+1074376|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break g}v[23540]=0;j=W(581,a+1298264|0,a|0,255)|0;b=v[23540];v[23540]=0;if((b|0)==1){break f}k=Gc(a+1298300|0);l=Gc(a+1298304|0);m=Nb(a+1298308|0);n=Nb(a+1298320|0);o=Nb(a+1298332|0);p=bN(a+1298344|0);q=Tb(a+1298408|0);t[a+1298420|0]=0;b=a+1298424|0;v[b>>2]=0;v[b+4>>2]=0;v[b+32>>2]=0;v[b+36>>2]=1072693248;v[b+24>>2]=0;v[b+28>>2]=0;v[b+16>>2]=0;v[b+20>>2]=0;v[b+8>>2]=0;v[b+12>>2]=0;v[a+1298464>>2]=0;Rp(a+12|0);Ay(a+8204|0);Ay(a+12300|0);b=a+1074408|0;v[b>>2]=4;v[b+4>>2]=16;v[a+480216>>2]=4;v[a+480220>>2]=16;Ub(c,0,1024);WM(g);v[23540]=0;b=S(812,12)|0;c=v[23540];v[23540]=0;if((c|0)==1){break e}v[b>>2]=0;v[b+4>>2]=0;v[b+8>>2]=0;r=a,s=Tb(b),v[r+4>>2]=s;return a|0}b=P()|0;O()|0;break a}b=P()|0;O()|0;break b}b=P()|0;O()|0;break b}b=P()|0;O()|0;break c}b=P()|0;O()|0;break d}b=P()|0;O()|0;aN(q);Dy(p);zb(o);Ab(n);zb(m);Cy(l);By(k);kt(j)}Py(e)}$M(d)}Bz(i)}TM(f);wc(h);T(b|0);L()}function zga(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,x=0;f=kb-560|0;kb=f;a:{if(!dd(b,1464)){break a}if(!po(b,f+556|0)){break a}Cd(a,1);Ob(Ob(_f(a+1074312|0,83),84,1),85,1);b:{if(ne(f+556|0,26953)){d=f+32|0;e=yc(d,8459);Jb(a+1298344|0,e);Ab(e);e=yc(d,14843);Jb(a+1298356|0,e);Ab(e);d=yc(d,14915);Jb(a+1298368|0,d);break b}if(!ne(f+556|0,15566)){break a}d=f+32|0;e=yc(d,8633);Jb(a+1298344|0,e);Ab(e);e=yc(d,12261);Jb(a+1298356|0,e);Ab(e);d=yc(d,15473);Jb(a+1298368|0,d)}Ab(d);v[a+1298404>>2]=14;dd(b,0);QA(b,a+1298308|0,20);u[a+480190>>1]=31;d=1;while(1)if((d|0)==32){if(g>>>0>40){break a}d=f+552|0;cv(d,b);m=Oc(d);if(w[f+552|0]>128){break a}e=f+32|0;d=kb-16|0;kb=d;c:{if(!Qb(v[b>>2],v[b+8>>2],512)){UR(e);break c}Ku(d+8|0,e);ud(d,b,v[d+8>>2],v[d+12>>2])}kb=d+16|0;d=0;e=w[m|0];while(1){n=(d|0)==512;if(!n){g=(f+32|0)+d|0;d=d+1|0;if(e>>>0>=w[g|0]){continue}break a}break}if(!c){break a}v[a+480260>>2]=56;v[a+480264>>2]=13696;v[a+480204>>2]=125e4;v[a+480196>>2]=6;u[a+480192>>1]=0;u[a+480188>>1]=4;v[a+480228>>2]=64;v[a+480208>>2]=v[a+480208>>2]|18874368;oh(a,0);o=a+484376|0;vg(Wb(v[a+484360>>2],w[o|0]),w[f+552|0]);l=a+484344|0;xg(l,w[f+552|0]);while(1){if(w[f+552|0]<=i>>>0){if(!(c&2)){break a}dd(b,(w[m|0]<<8)+1468|0);d=1;while(1){if((d|0)==32){break a}c=(B(d,104)+a|0)+484380|0;if(v[c>>2]){wg(Zc(f+8|0,8,1,0,0),c,b)}d=d+1|0;continue}}s=cc(v[Wb(v[a+484360>>2],w[o|0])>>2],i),x=i,u[s>>1]=x;d:{if(!ph(l,i&65535,64)){break d}r=i<<2;e=0;e:while(1){if((e|0)==4){s=f,x=Fb(v[_b(v[l>>2],i)>>2]),v[s+24>>2]=x;e=0;while(1){if((e|0)==64){break d}d=0;f:{while(1){if((d&65535)>>>0>=4){g:{t[f+31|0]=p;t[f+30|0]=q;d=h&255;if(d){break g}h=0;break f}}else{g=v[f+24>>2];h:{if((w[g+3|0]&254)!=16){break h}t[g+3|0]=16;h=0;k=w[g+5|0];if(k>>>0<16){break h}h=k>>>4|0;t[g+5|0]=h;j=h;h=k&15;g=(j|0)==(h|0)|!h;q=g?q:j;p=g?p:h;h=!g}d=d+1|0;dA(f+24|0);continue}break}ze(_b(v[l>>2],i),Ue(Oe(f+8|0,16,w[(d+f|0)+29|0]),e));h=h+1|0;h=(h&255)==3?1:h}e=e+1|0;continue}}dd(b,(w[f+32+(e+r)|0]<<8)+1468|0);g=0;d=_b(v[l>>2],i);d=jd(v[d>>2],v[v[d+48>>2]+12>>2],0,e&65535);while(1)if((g|0)==64){e=e+1|0;continue e}else{j=f+8|0;Gu(j,b,d);k=w[f+8|0];j=w[Oc(j)|0];i:{if(!(!(k|j)|(k-5&255)>>>0<5|(k|0)==14&j>>>0>15)){Pf(d,k,j);break i}t[d+3|0]=0}d=d+24|0;g=g+1|0;continue}}}i=i+1|0;continue}}else{g=mA(b,f+32|0,(B(d,104)+a|0)+484380|0,((d<<5)+a|0)+946304|0,1)+g|0;d=d+1|0;continue}}kb=f+560|0;return n|0}function d3(a,b,c){a=a|0;b=+b;c=c|0;var d=0,e=0,f=0,g=0;d=kb-192|0;kb=d;v[d+184>>2]=c;a:{b:{c:{if(b>=.8){v[23540]=0;e=ga(1072)|0;f=v[23540];v[23540]=0;d:{e:{f:{if((f|0)!=1){v[d+80>>2]=e;v[23540]=0;c=S(1073,c|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break e}v[d+176>>2]=c;Jn(e,c);a=je(d+152|0,a);v[23540]=0;f=v[a+12>>2];c=d- -64|0;v[c>>2]=v[a+8>>2];v[c+4>>2]=f;v[d+72>>2]=v[a+16>>2];c=v[a+4>>2];v[d+56>>2]=v[a>>2];v[d+60>>2]=c;a=W(1065,e|0,d+56|0,15)|0;c=v[23540];v[23540]=0;if((c|0)==1){break f}if(a){v[23540]=0;Y(813,e|0);a=v[23540];v[23540]=0;g=1;if((a|0)==1){break f}}hj(d+176|0);ij(d+80|0);break b}c=V(0)|0;O()|0;break c}c=V(0)|0;O()|0;hj(d+176|0);break d}c=V(0)|0;O()|0}ij(d+80|0);break c}if(b>=.6){v[23540]=0;e=ga(1072)|0;f=v[23540];v[23540]=0;g:{h:{i:{if((f|0)!=1){v[d+80>>2]=e;v[23540]=0;c=S(1073,c|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break h}v[d+176>>2]=c;Jn(e,c);a=je(d+128|0,a);v[23540]=0;c=v[a+12>>2];v[d+40>>2]=v[a+8>>2];v[d+44>>2]=c;v[d+48>>2]=v[a+16>>2];c=v[a+4>>2];v[d+32>>2]=v[a>>2];v[d+36>>2]=c;a=W(1065,e|0,d+32|0,2)|0;c=v[23540];v[23540]=0;if((c|0)==1){break i}if(a){v[23540]=0;Y(813,e|0);a=v[23540];v[23540]=0;g=.8;if((a|0)==1){break i}}hj(d+176|0);ij(d+80|0);break b}c=V(0)|0;O()|0;break c}c=V(0)|0;O()|0;hj(d+176|0);break g}c=V(0)|0;O()|0}ij(d+80|0);break c}g=.2;if(b>=.2){v[23540]=0;e=ga(1072)|0;f=v[23540];v[23540]=0;j:{k:{l:{if((f|0)!=1){v[d+80>>2]=e;v[23540]=0;c=S(1073,c|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break k}v[d+176>>2]=c;Jn(e,c);a=je(d+104|0,a);v[23540]=0;c=v[a+12>>2];v[d+16>>2]=v[a+8>>2];v[d+20>>2]=c;v[d+24>>2]=v[a+16>>2];c=v[a+4>>2];v[d+8>>2]=v[a>>2];v[d+12>>2]=c;a=W(1065,e|0,d+8|0,0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break l}g=0;if(a){v[23540]=0;Y(813,e|0);a=v[23540];v[23540]=0;g=.6;if((a|0)==1){break l}}hj(d+176|0);ij(d+80|0);break b}c=V(0)|0;O()|0;break c}c=V(0)|0;O()|0;hj(d+176|0);break j}c=V(0)|0;O()|0}ij(d+80|0);break c}if(!(b>=.1)){break b}v[23540]=0;U(203,d+80|0,a|0,2048);c=v[23540];v[23540]=0;if((c|0)!=1){c=Ie(d+80|0);a=v[a>>2];v[23540]=0;e=v[d+80>>2];a=S(160,a|0)|0;f=v[23540];v[23540]=0;m:{if((f|0)==1){break m}v[23540]=0;a=oF(1074,c,e,a,0);c=v[23540];v[23540]=0;if((c|0)==1){break m}g=A[(a<<3)+62456>>3];Uc(d+80|0);break b}c=V(0)|0;O()|0;Uc(d+80|0);break c}c=V(0)|0;O()|0}_(c|0)|0;v[23540]=0;Z(18);a=v[23540];v[23540]=0;g=0;if((a|0)==1){break a}}De(d+184|0);kb=d+192|0;return+g}a=P()|0;O()|0;De(d+184|0);T(a|0);L()}function faa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;c=kb-48|0;kb=c;a:{b:{if(!Pb(v[b>>2],v[b+4>>2])){break b}l=v[b+12>>2];k=Og(v[v[b+48>>2]+12>>2]);d=k;f=c+32|0;v[f>>2]=0;v[f+4>>2]=0;Gc(f+8|0);if(d){lu(f,d);g=kb-16|0;kb=g;e=Iq(g,f,d);d=v[e+4>>2];h=v[e+8>>2];while(1){if((d|0)==(h|0)){lc(e);kb=g+16|0}else{t[d|0]=0;t[d+1|0]=0;t[d+2|0]=0;t[d+3|0]=0;t[d+4|0]=0;t[d+5|0]=0;ug(d);d=d+6|0;v[e+4>>2]=d;continue}break}}while(1){c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{if(j>>>0>=l>>>0){break r}if(!Yg(v[v[a>>2]-12>>2]+a|0)){break r}v[23540]=0;t[c+31|0]=0;Q(875,a|0,c+31|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break a}d=t[c+31|0];if(!d){j=j+1|0;continue}t[c+30|0]=0;s:{if((d|0)>=0){break s}v[23540]=0;Q(875,a|0,c+30|0)|0;e=v[23540];v[23540]=0;if((e|0)!=1){break s}break a}t[c+29|0]=0;Fj(c+16|0);t:{d=d&127;g=(d?d-1|0:0)&65535;i=g>>>0>=k>>>0;u:{v:{if(!i){h=jd(v[b>>2],v[v[b+48>>2]+12>>2],j,g);d=w[c+30|0];if(d&1){break v}e=Id(v[f>>2],g);break u}h=c+16|0;d=w[c+30|0];if(!(d&1)){break t}}v[23540]=0;Q(875,a|0,c+29|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break a}if(i){break t}e=Id(v[f>>2],g);t[e|0]=w[c+29|0]}t[h|0]=w[e|0];d=w[c+30|0];if(!(d&2)){break p}break q}if(d&2){break q}break o}vk(f);break b}v[23540]=0;Q(875,a|0,c+29|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break a}if(i){break o}e=Id(v[f>>2],g);t[e+1|0]=w[c+29|0]}t[h+1|0]=w[e+1|0];if(d&4){break n}break m}if(!(d&4)){break l}}v[23540]=0;Q(875,a|0,c+29|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break a}if(i){break l}e=Id(v[f>>2],g);t[e+2|0]=w[c+29|0]}t[h+2|0]=w[e+2|0];if(!(d&8)){break j}break k}if(!(d&8)){break i}}v[23540]=0;Q(875,a|0,c+29|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break a}if(i){break i}e=Id(v[f>>2],g);t[e+4|0]=w[c+29|0]}t[h+4|0]=w[e+4|0];if(d&16){break h}break g}if(!(d&16)){break f}}v[23540]=0;Q(875,a|0,c+29|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break a}if(i){break f}e=Id(v[f>>2],g);t[e+3|0]=w[c+29|0]}t[h+3|0]=w[e+3|0];if(!(d&32)){break d}break e}if(!(d&32)){break c}}v[23540]=0;Q(875,a|0,c+29|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break a}if(i){break c}e=Id(v[f>>2],g);t[e+5|0]=w[c+29|0]}t[h+5|0]=w[e+5|0]}if(!(d&64)){continue}v[23540]=0;Q(875,a|0,c+15|0)|0;d=v[23540];v[23540]=0;if((d|0)!=1){v[23540]=0;Q(876,a|0,w[c+15|0])|0;d=v[23540];v[23540]=0;if((d|0)!=1){continue}}break}break a}kb=c+48|0;return}a=P()|0;O()|0;vk(f);T(a|0);L()}function Ufa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0;g=kb-32|0;kb=g;a:{if(!Qb(v[a>>2],v[a+8>>2],2)){ph(c+484344|0,b,64);break a}l=c+484344|0;m=Ed(Hj(a),1,1024);if(!ph(l,b,m)){break a}p=x[c+480188>>1];q=c+480190|0;b:while(1){if((k|0)==(m|0)){break a}i=0;e=_b(v[l>>2],b);n=Cf(v[e>>2],v[v[e+48>>2]+12>>2],k);while(1)if((i|0)==(p|0)){k=k+1|0;continue b}else{f=g+24|0;Um(f,a);e=B(i,6)+n|0;r=Te(f);f=Li(f);h=w[g+24|0];c:{if((h-1&255)>>>0>35){break c}t[e|0]=h+48;o=w[Oc(g+24|0)|0];h=o+1|0;t[e+1|0]=h;j=h;h=h&255;if((j|0)!=(h|0)|h>>>0>x[q>>1]){break c}h=Hi(c,h);j=Lb(d,i);if(!(!w[j|0]|x[h+30>>1]>255)){t[e+4|0]=64;t[e+2|0]=1}h=v[Eb(h+68|0,0)>>2];if(!(w[j|0]|h?w[j|0]?(h|0)==1:0:1)){break c}t[e+1|0]=o+101}d:{e:{switch(w[r|0]){case 1:if(!w[f|0]){break d}t[e+3|0]=2;t[e+5|0]=w[f|0];break d;case 2:if(!w[f|0]){break d}t[e+3|0]=3;t[e+5|0]=w[f|0];break d;case 12:if(!w[f|0]){break d}t[e+3|0]=1;t[e+5|0]=w[f|0];break d;case 13:if(!w[f|0]){break d}t[e+3|0]=39;t[g+23|0]=15;s=e,u=w[Yb(g+23|0,f)|0]|16,t[s+5|0]=u;break d;case 30:if(!w[f|0]){break d}t[e+3|0]=38;t[g+22|0]=15;s=e,u=w[Yb(g+22|0,f)|0]|16,t[s+5|0]=u;break d;case 21:if(!w[f|0]){break d}t[e+3|0]=39;t[g+21|0]=15;s=e,u=w[Yb(g+21|0,f)|0]|80,t[s+5|0]=u;break d;case 17:if(!w[f|0]){break d}t[e+3|0]=38;t[g+20|0]=15;s=e,u=w[Yb(g+20|0,f)|0]|80,t[s+5|0]=u;break d;case 15:t[e+3|0]=19;t[e+5|0]=w[f|0]!=0;break d;case 25:t[e+3|0]=12;t[e+5|0]=w[f|0];break d;case 27:ko(e);t[e|0]=255;break d;case 28:if(w[f|0]>31){break d}t[e+3|0]=16;t[e+5|0]=w[f|0];break d;case 31:h=w[f|0];if(h&15){s=e,u=w[Lb(d,i)|0]?22:11,t[s+3|0]=u;t[e+5|0]=w[f|0]&15;h=w[f|0]}f:{g:{switch(h>>>4|0){case 4:if((h|0)!=64){break f}case 0:case 1:case 2:case 3:if(w[Lb(d,i)|0]){t[e+3|0]=21;t[e+5|0]=w[f|0];break f}t[e+2|0]=1;f=w[f|0];t[e+3|0]=0;t[e+4|0]=f;break f;case 5:t[e+5|0]=w[e+5|0]<<4;break f;case 6:t[g+19|0]=w[e+5|0];t[g+18|0]=14;s=e,u=w[Yb(g+19|0,g+18|0)|0]|240,t[s+5|0]=u;break f;case 7:t[g+17|0]=w[e+5|0];t[g+16|0]=14;s=e,u=w[Yb(g+17|0,g+16|0)|0]<<4|15,t[s+5|0]=u;break f;default:break g}}t[e+3|0]=0}if((w[e+3|0]-21&255)>>>0>1){break d}f=B(t[Lb(d,i)|0]+i|0,6)+n|0;Qq(g+8|0,w[f+3|0],w[f+5|0],1);if(w[g+8|0]){h=x[g+8>>1];t[f+4|0]=h>>>8;t[f+2|0]=h}t[f+3|0]=w[e+3|0];t[f+5|0]=w[e+5|0];break d;case 0:break d;default:break e}}t[e+3|0]=0}i=i+1|0;continue}}}kb=g+32|0}function oea(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=kb+-64|0;kb=d;u[d+62>>1]=c;Ef(d+62|0,32);j=Tb(a);v[23540]=0;o=x[d+62>>1];R(523,j|0,o|0);a=v[23540];v[23540]=0;a:{b:{if((a|0)!=1){k=b+480190|0;p=b+480192|0;c:{d:{while(1){if((q&65535)>>>0>=o>>>0){break d}e=1;c=x[k>>1];a=c+1|0;u[d+60>>1]=a;e:{f:{g:{if((a&65535)>>>0<4e3){break g}h:{while(1){f=e&65535;if(f>>>0>c>>>0){break h}i:{g=Hi(b,f);if(!_d(v[g>>2],v[g+20>>2])){if(!Pb(fA(Fb(v[j>>2]),Fb(v[j+4>>2]),e),Fb(v[j+4>>2]))){break i}c=x[k>>1]}e=e+1|0;continue}break}u[d+60>>1]=e;a=1;while(1){if(x[p>>1]<a>>>0){a=e;break h}j:{c=v[((a<<2)+b|0)+900380>>2];if(!c){break j}c=c+236|0;g=Bq(c);while(1){if((c|0)==(g|0)){break j}if((f|0)==x[c>>1]){u[c>>1]=0}c=c+2|0;continue}}a=a+1|0;continue}}if((a&65535)>>>0<4e3){break g}e=io(d+48|0);v[23540]=0;a=Q(746,b|0,e|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break b}if(!a){break e}v[23540]=0;R(747,b|0,e|0);c=v[23540];v[23540]=0;a=1;if((c|0)==1){break b}while(1){c=a&65535;if(c>>>0<=x[p>>1]){k:{c=v[((c<<2)+b|0)+900380>>2];if(!c){break k}c=c+236|0;f=Bq(c);while(1){if((c|0)==(f|0)){break k}g=x[c>>1];l:{if(g>>>0>=y[d+52>>2]){break l}Db(d+40|0,v[e>>2],g);if(Cb(v[v[d+40>>2]>>2],v[d+44>>2])){break l}u[c>>1]=0}c=c+2|0;continue}}a=a+1|0;continue}break}tl(d+24|0,v[e>>2]);QP(d+32|0,v[d+24>>2],v[d+28>>2],1);Cm(d+16|0,v[e>>2],v[d+52>>2]);m=kb-16|0;kb=m;g=d+40|0;c=hc(m,v[d+32>>2],v[d+36>>2]);a=sl(v[d+16>>2],v[d+20>>2],v[d+32>>2],v[d+36>>2]);f=kb-16|0;kb=f;v[f+12>>2]=a;h=v[c+4>>2];m:{if(h){i=32-h|0;v[f+8>>2]=i;n=v[Kb(f+8|0,f+12|0)>>2];l=-1<<h&-1>>>i-n;i=v[c>>2];l=l&(v[i>>2]^-1);if(l){hc(g,i,Ika(l));break m}if((a|0)==(n|0)){QP(g,i,h,a);break m}a=a-n|0;v[f+12>>2]=a;v[c>>2]=i+4}while(1){if(a>>>0>=32){h=v[c>>2];i=v[h>>2];if((i|0)!=-1){hc(g,h,Ika(i^-1));break m}else{v[c>>2]=h+4;a=a-32|0;v[f+12>>2]=a;continue}}break}if(!a){hc(g,v[c>>2],0);break m}c=v[c>>2];h=(v[c>>2]^-1)&-1>>>32-a;if(!h){hc(g,c,a);break m}hc(g,c,Ika(h))}kb=f+16|0;kb=m+16|0;tl(d+8|0,v[e>>2]);a=sl(v[d+40>>2],v[d+44>>2],v[d+8>>2],v[d+12>>2]);u[d+60>>1]=a;We(e);if((a&65535)>>>0>3999){break f}}v[23540]=0;R(257,j|0,d+60|0);c=v[23540];v[23540]=0;if((c|0)==1){break c}if(x[k>>1]>=(a&65535)>>>0){break f}u[k>>1]=a}q=q+1|0;continue}break}We(e)}kb=d- -64|0;return}c=P()|0;O()|0;break a}c=P()|0;O()|0;break a}c=P()|0;O()|0;We(e)}od(j);T(c|0);L()}function B3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;d=kb-192|0;kb=d;h=CJ(d+176|0);v[h>>2]=49396;Tb(h+4|0);Jn(v[a+24>>2],h);e=v[a+24>>2];i=w[a+62|0];f=w[a+61|0];g=w[a+60|0];b=je(d+152|0,b);v[23540]=0;j=v[b+12>>2];v[d+16>>2]=v[b+8>>2];v[d+20>>2]=j;v[d+24>>2]=v[b+16>>2];j=v[b+4>>2];v[d+8>>2]=v[b>>2];v[d+12>>2]=j;b=g?13:15;b=f?b&14:b;b=W(1065,e|0,d+8|0,(i?b&3:b)|0)|0;e=v[23540];v[23540]=0;a:{b:{c:{d:{e:{if((e|0)==1){break e}if(!b){b=ba(8)|0;v[23540]=0;c=Q(55,d+136|0,11999)|0;a=v[23540];v[23540]=0;if((a|0)!=1){a=tc(b,c);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break a}a=P()|0;O()|0;zb(c);break b}a=P()|0;O()|0;ca(b|0);break b}if(!w[a+63|0]){v[23540]=0;R(1066,a|0,a+36|0);b=v[23540];v[23540]=0;if((b|0)==1){break e}}t[a+28|0]=1;Jn(v[a+24>>2],v[a+4>>2]);v[23540]=0;R(1067,d+136|0,h|0);b=v[23540];v[23540]=0;if((b|0)==1){break c}k=d,l=Fb(v[d+136>>2]),v[k+128>>2]=l;e=a+68|0;i=Fb(v[d+140>>2]);f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{while(1){b=v[d+128>>2];if(!Pb(b,i)){k=d,l=Gi(v[c>>2]),v[k+112>>2]=l;c=xf(c);while(1){b=v[d+112>>2];if(!Hg(b,c)){break d}v[23540]=0;e=vd(b);b=Q(54,d+32|0,e|0)|0;i=v[23540];v[23540]=0;if((i|0)==1){break h}v[23540]=0;X(962,a|0,b|0,e+12|0,0);e=v[23540];v[23540]=0;if((e|0)==1){break g}zb(b);Kg(d+112|0);continue}}f=v[a+24>>2];g=v[b>>2];v[23540]=0;j=f;f=b+4|0;U(1068,j|0,g|0,f|0);g=v[23540];v[23540]=0;if((g|0)!=1){b=v[b>>2];v[23540]=0;R(1069,d- -64|0,b|0);b=v[23540];v[23540]=0;if((b|0)==1){break r}v[23540]=0;R(1009,d+80|0,d- -64|0);b=v[23540];v[23540]=0;if((b|0)==1){break q}v[23540]=0;b=Q(55,d+48|0,17803)|0;g=v[23540];v[23540]=0;if((g|0)==1){break p}v[23540]=0;U(965,d+96|0,d+80|0,b|0);g=v[23540];v[23540]=0;if((g|0)==1){break o}v[23540]=0;U(529,d+112|0,d+96|0,f|0);f=v[23540];v[23540]=0;if((f|0)==1){break n}v[23540]=0;R(183,e|0,d+112|0);f=v[23540];v[23540]=0;if((f|0)==1){break m}zb(d+112|0);zb(d+96|0);zb(b);zb(d+80|0);Ab(d- -64|0);iq(d+128|0);continue}break}a=P()|0;O()|0;break f}a=P()|0;O()|0;break f}a=P()|0;O()|0;break i}a=P()|0;O()|0;break j}a=P()|0;O()|0;break k}a=P()|0;O()|0;break l}a=P()|0;O()|0;zb(d+112|0)}zb(d+96|0)}zb(b)}zb(d+80|0)}Ab(d- -64|0);break f}a=P()|0;O()|0;break f}a=P()|0;O()|0;zb(b)}vx(d+136|0);break b}a=P()|0;O()|0;break b}vx(d+136|0);xs(h);kb=d+192|0;return}a=P()|0;O()|0}xs(h);T(a|0)}L()}function fha(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0;e=kb-32|0;kb=e;a:{b:{if(!c){break b}s=e,u=Me(a),t[s+16|0]=u;rn(b,e+16|0);k=c-1|0;c=0;while(1){g=1;if(!k){break a}c:{d:{d=c<<1;c=d&254;if(!c){if(!nf(a,e+16|0)){break b}i=1;d=w[e+16|0]<<1|1;c=d&255;if(d>>>0<=255){break d}break c}if((d&65535)>>>0<=255){break d}i=1;break c}if(!nf(a,e+16|0)){break b}AU(b,e+16|0);k=k-1|0;continue}while(1){e:{f:{g:{d=c<<1&254;if(d){c=(c&65535)>>>0>127}else{if(!nf(a,e+16|0)){break g}c=w[e+16|0]<<1|1;d=c&255;c=c>>>0>255}i=nq(i,1)+c|0;c=d<<1&254;if(c){break f}if(!nf(a,e+16|0)){break g}d=w[e+16|0]<<1|1;c=d&255;if(d>>>0>255){continue}break e}c=0;break e}if(d>>>0>127){continue}}break}h:{if((i|0)<=2){j=0;h=i-2|0;break h}if(!nf(a,e+16|0)){break b}d=nq(i-3|0,8)|w[e+16|0];j=((d|0)>1279?2:1)+((d|0)>31999)|0;n=d^-1;h=0}d=c<<1&254;if(d){f=c>>>0>127}else{if(!nf(a,e+16|0)){break b}c=w[e+16|0]<<1|1;d=c&255;f=c>>>0>255}g=nq(h,1);c=d<<1&254;if(c){d=d>>>0>127}else{if(!nf(a,e+16|0)){break b}d=w[e+16|0]<<1|1;c=d&255;d=d>>>0>255}i=1;h=k;d=nq(f+g|0,1)+d|0;if(!d){while(1){i:{j:{k:{d=c<<1&254;if(d){c=(c&65535)>>>0>127}else{if(!nf(a,e+16|0)){break k}c=w[e+16|0]<<1|1;d=c&255;c=c>>>0>255}i=nq(i,1)+c|0;c=d<<1&254;if(c){break j}if(!nf(a,e+16|0)){break k}d=w[e+16|0]<<1|1;c=d&255;if(d>>>0>255){continue}break i}c=0;break i}if(d>>>0>127){continue}}break}d=i+2|0}f=h;h=d+j|0;g=0;if(f>>>0<h>>>0|(h|0)<=0|(n|0)>=0){break a}d=v[b+4>>2];g=0;if((0-fd(v[b>>2],d)|0)>(n|0)){break a}d=fc(e+24|0,Fb(d));t[e+16|0]=0;l=e+16|0;o=kb-32|0;kb=o;f=v[d>>2];d=v[b>>2];j=to(f,Fb(d))+d|0;f=v[Gb(b)>>2];g=v[b+4>>2];l:{if(h>>>0<=f-g>>>0){d=h;f=g-j|0;if(d>>>0>f>>>0){Po(b,h-f|0,l);d=f;if(!d){break l}}p=kb-16|0;kb=p;f=g;r=v[b+4>>2];g=(r-(h+j|0)|0)+j|0;q=Ok(p,b,f-g|0);m=v[q+4>>2];i=g;while(1){if(i>>>0>=f>>>0){lc(q);Dq(j,g,r);kb=p+16|0}else{xd(m,w[i|0]);m=m+1|0;v[q+4>>2]=m;i=i+1|0;continue}break}di(j,d,(j>>>0<=l>>>0?y[b+4>>2]>l>>>0?h:0:0)+l|0);break l}d=Gb(b);d=Xl(o+8|0,Vl(b,fd(v[b>>2],g)+h|0),j-v[b>>2]|0,d);dT(d,h,l);j=BU(b,d,j);Wl(d)}Fb(j);kb=o+32|0;s=e,u=Rf(rS(Fb(v[b+4>>2]),h),n),v[s+16>>2]=u;s=e,u=rS(Fb(v[b+4>>2]),h),v[s+8>>2]=u;d=h;while(1){f=w[qS(e+16|0)|0];s=qS(e+8|0),u=f,t[s|0]=u;f=d>>>0>1;d=d-1|0;if(f){continue}break}k=k-h|0;continue}}g=0}f=g;kb=e+32|0;return f|0}function G6(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=kb-128|0;kb=e;v[e+124>>2]=c;v[e+120>>2]=b;a:{if(!c){break a}f=w[cl(b,c)|0];if((f|0)==33){d=1}else{if((f|0)!=63){break a}d=0}jl(e+96|0,b,c,c-1|0);b=v[e+100>>2];v[e+120>>2]=v[e+96>>2];v[e+124>>2]=b}c=e+96|0;Xd(c);b=v[e+96>>2];Xd(e+80|0);b=bl(b,v[e+84>>2],e+120|0);Xd(c);b:{c:{d:{e:{if((b|0)==v[e+100>>2]){b=v[e+120>>2];c=v[e+124>>2];a=rc(e+112|0,21688);if(Qc(b,c,v[a>>2],v[a+4>>2])){a=ba(8)|0;v[23540]=0;b=Q(55,e+96|0,10501)|0;c=v[23540];v[23540]=0;if((c|0)==1){break d}a=tc(a,b);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break b}c=P()|0;O()|0;zb(b);break c}b=0;if(!d){break e}b=ba(8)|0;v[23540]=0;d=Mh(e+80|0,v[e+120>>2],v[e+124>>2]);a=v[23540];v[23540]=0;f:{g:{h:{if((a|0)!=1){v[23540]=0;U(961,e+96|0,17703,d|0);a=v[23540];v[23540]=0;if((a|0)==1){break h}a=0;c=tc(b,e+96|0);v[23540]=0;U(119,c|0,62752,950);c=v[23540];v[23540]=0;if((c|0)!=1){break b}c=P()|0;O()|0;zb(e+96|0);break g}c=P()|0;O()|0;break f}c=P()|0;a=1;O()|0}zb(d);if(!a){break c}}ca(b|0);break c}if(v[b+4>>2]){a=ba(8)|0;v[23540]=0;b=Q(55,e+96|0,11573)|0;c=v[23540];v[23540]=0;if((c|0)!=1){a=tc(a,b);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break b}c=P()|0;O()|0;zb(b);break c}c=P()|0;O()|0;ca(a|0);break c}c=v[e+120>>2];d=v[e+124>>2];b=rc(e+72|0,21688);if(Qc(c,d,v[b>>2],v[b+4>>2])){a=ba(8)|0;v[23540]=0;b=Q(55,e+96|0,10501)|0;c=v[23540];v[23540]=0;if((c|0)!=1){a=tc(a,b);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break b}c=P()|0;O()|0;zb(b);break c}c=P()|0;O()|0;ca(a|0);break c}i:{b=rc(e- -64|0,7422);if(!Qc(c,d,v[b>>2],v[b+4>>2])){b=rc(e+56|0,7404);if(!Qc(c,d,v[b>>2],v[b+4>>2])){break i}}b=w[a+60|0]!=0;break e}j:{b=rc(e+48|0,6937);if(!Qc(c,d,v[b>>2],v[b+4>>2])){b=rc(e+40|0,6918);if(!Qc(c,d,v[b>>2],v[b+4>>2])){break j}}b=w[a+61|0]!=0;break e}b=rc(e+32|0,7021);if(Qc(c,d,v[b>>2],v[b+4>>2])){b=w[a+62|0]!=0;break e}b=rc(e+24|0,6067);if(Qc(c,d,v[b>>2],v[b+4>>2])){b=w[a+63|0]!=0;break e}b=rc(e+16|0,7471);if(Qc(c,d,v[b>>2],v[b+4>>2])){b=w[a+64|0]!=0;break e}f=c;c=rc(e+8|0,13365);b=0;if(!Qc(f,d,v[c>>2],v[c+4>>2])){break e}b=v[v[a+24>>2]+24668>>2]!=0}kb=e+128|0;return b|0}c=P()|0;O()|0;ca(a|0)}T(c|0)}L()}function uaa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;h=kb-16|0;kb=h;f=v[a+8>>2];e=v[a>>2];v[23540]=0;f=Q(600,e|0,f|0)|0;e=v[23540];v[23540]=0;a:{b:{if((e|0)!=1){if(f){break b}v[23540]=0;f=S(206,a|0)|0;e=v[23540];v[23540]=0;c:{if((e|0)==1){break c}v[23540]=0;j=d+484344|0;k=Ed(f+1|0,1,1024);f=W(226,j|0,b|0,k|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break c}if(!f){break b}d=x[d+480188>>1];if(!d){break b}l=d-1|0;d=0;d:while(1){if(d>>>0>=k>>>0){break b}while(1){f=v[a+8>>2];e=v[a>>2];v[23540]=0;f=W(156,e|0,f|0,1)|0;e=v[23540];v[23540]=0;e:{if((e|0)!=1){if(!f){break b}v[23540]=0;i=S(206,a|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break a}if(i){break e}d=d+1|0;continue d}break a}e=v[j>>2];u[h+14>>1]=i&31;u[h+12>>1]=l;e=_b(e,b);e=jd(v[e>>2],v[v[e+48>>2]+12>>2],d,x[Wc(h+14|0,h+12|0)>>1]);if(!(i&224)){continue}break}f:{if(!(i&128)){break f}v[23540]=0;g=S(206,a|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break a}t[e+5|0]=g;v[23540]=0;g=S(206,a|0)|0;f=v[23540];v[23540]=0;g:{h:{if((f|0)!=1){if(g>>>0<26){break h}break g}break a}f=w[g+42752|0];t[e+3|0]=f;i:{switch(f-1|0){case 0:if(!w[e+5|0]){break g}break f;case 12:if(w[e+2|0]){break f}t[e+2|0]=1;f=w[e+5|0];t[e+5|0]=0;t[e+3|0]=0;m=e,n=Ed(f,0,64),t[m+4|0]=n;break f;case 5:case 6:case 10:case 23:case 28:f=w[e+5|0]&240;if(!f){break f}t[e+5|0]=f;break f;case 8:f=w[e+5|0];if(f>>>0<=128){m=e,n=tg(f<<1),t[m+5|0]=n;break f}if((f|0)!=164){break f}t[e+5|0]=145;t[e+3|0]=20;break f;case 13:f=w[e+5|0];t[e+5|0]=B(f>>>4|0,10)+(f&15);break f;case 18:Uu(e);break f;case 16:if(w[e+5|0]>31){break f}t[e+3|0]=16;break f;case 27:break i;default:break f}}g=w[e+5|0];f=g&240;j:{if((f|0)==16){f=2}else{if((f|0)!=32){break j}f=3}t[e+3|0]=f}t[e+5|0]=g&15|224;break f}t[e+3|0]=0}k:{l:{if(!(i&64)){break l}v[23540]=0;R(260,h+8|0,a|0);f=v[23540];v[23540]=0;if((f|0)==1){break k}t[e+1|0]=w[h+8|0];g=w[Oc(h+8|0)|0];t[e|0]=g;f=255;if((g|0)!=128){f=253;if(g>>>0<129){break l}}t[e|0]=f}if(!(i&32)){continue}t[e+2|0]=1;v[23540]=0;g=S(206,a|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break a}t[e+4|0]=g;if(!c){continue}t[e+4|0]=(g<<6>>>0)/127;continue}break}break a}break a}break a}Bb(a);kb=h+16|0;return}b=P()|0;O()|0;Bb(a);T(b|0);L()}function b4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;a=Nb(a);v[23540]=0;Z(105);c=v[23540];v[23540]=0;a:{b:{if((c|0)==1){c=Xa(62752,92756,93340,0)|0;d=O()|0;c:{d:{e:{if((ea(62752)|0)==(d|0)){c=_(c|0)|0;v[23540]=0;b=Q(935,a|0,b|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break e}v[23540]=0;b=Q(935,b|0,17803)|0;d=v[23540];v[23540]=0;if((d|0)==1){break e}v[23540]=0;d=Q(935,b|0,17779)|0;b=v[23540];v[23540]=0;if((b|0)==1){break e}b=ob[v[v[c>>2]+8>>2]](c)|0;v[23540]=0;Q(935,d|0,(b?b:21688)|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break e}v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){break b}b=P()|0;O()|0;break a}f:{if((ea(92756)|0)==(d|0)){c=_(c|0)|0;v[23540]=0;b=Q(935,a|0,b|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break f}v[23540]=0;b=Q(935,b|0,17803)|0;d=v[23540];v[23540]=0;if((d|0)==1){break f}v[23540]=0;d=Q(935,b|0,17754)|0;b=v[23540];v[23540]=0;if((b|0)==1){break f}b=ob[v[v[c>>2]+8>>2]](c)|0;v[23540]=0;Q(935,d|0,(b?b:21688)|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break f}v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){break b}b=P()|0;O()|0;break a}e=ea(93340)|0;c=_(c|0)|0;g:{if((d|0)==(e|0)){v[23540]=0;b=Q(935,a|0,b|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break g}v[23540]=0;b=Q(935,b|0,17803)|0;d=v[23540];v[23540]=0;if((d|0)==1){break g}v[23540]=0;d=Q(935,b|0,17770)|0;b=v[23540];v[23540]=0;if((b|0)==1){break g}b=ob[v[v[c>>2]+8>>2]](c)|0;v[23540]=0;Q(935,d|0,(b?b:21688)|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break g}v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){break b}b=P()|0;O()|0;break a}v[23540]=0;b=Q(935,a|0,b|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break d}v[23540]=0;b=Q(935,b|0,17803)|0;c=v[23540];v[23540]=0;if((c|0)==1){break d}v[23540]=0;Q(935,b|0,13733)|0;b=v[23540];v[23540]=0;if((b|0)==1){break d}v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){break b}b=P()|0;O()|0;break a}b=P()|0;O()|0;v[23540]=0;Z(18);c=v[23540];v[23540]=0;if((c|0)!=1){break a}break c}b=P()|0;O()|0;v[23540]=0;Z(18);c=v[23540];v[23540]=0;if((c|0)!=1){break a}break c}b=P()|0;O()|0;v[23540]=0;Z(18);c=v[23540];v[23540]=0;if((c|0)==1){break c}break a}b=P()|0;O()|0;v[23540]=0;Z(18);c=v[23540];v[23540]=0;if((c|0)!=1){break a}}V(0)|0;O()|0;Vb()}L()}return}zb(a);T(b|0);L()}function vW(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;f=kb-384|0;kb=f;zc(b);d=kb-16|0;kb=d;h=f+344|0;KC(d+8|0,h);e=v[d+12>>2];nc(d,v[b>>2],v[b+8>>2],v[d+8>>2],v[d+12>>2]);i=v[d+4>>2];if((i|0)==(e|0)){$b(b,v[d+12>>2])}kb=d+16|0;d=(e|0)==(i|0);if(!d){JC(h)}a:{if(!d){break a}if(!MC(f+344|0)){break a}if(!Qb(v[b>>2],v[b+8>>2],Ec(LC(w[f+379|0]),nb))){break a}b:{if(!c){break b}Cd(a,2097152);ag(a);oh(a,1);u[a+480188>>1]=8;v[a+480196>>2]=w[f+376|0];v[a+480204>>2]=B(w[f+377|0],1e4);j=a+480190|0;u[j>>1]=w[f+378|0];d=w[f+381|0];if(d>>>0<w[f+380|0]){Ve(Wb(v[a+484360>>2],w[a+484376|0]),d)}d=f+80|0;g=yc(d,6522);Jb(a+1298344|0,g);Ab(g);g=yc(d,11139);Jb(a+1298356|0,g);Ab(g);v[a+1298404>>2]=5;dv(b,d);Xq(Wb(v[a+484360>>2],w[a+484376|0]),d,w[f+380|0],65535,65535);g=1;while(1){i=g&65535;if(i>>>0>x[j>>1]){$b(b,B(64-w[f+378|0]|0,37));h=a+484344|0;xg(h,w[f+379|0]);i=c&1;g=0;while(1){if(w[f+379|0]<=g>>>0){if(!(c&2)){break b}c=Zc(f+40|0,8,1,0,0);d=a+480190|0;g=1;while(1){e=g&65535;if(e>>>0>x[d>>1]){break b}wg(c,(B(e,104)+a|0)+484380|0,b);g=g+1|0;continue}}c:{d:{if(i){if(ph(h,g&65535,64)){break d}}$b(b,2048);break c}d=_b(v[h>>2],g);n=f,o=Fb(v[d>>2]),v[n+40>>2]=o;j=Fb(v[d+4>>2]);while(1){d=v[f+40>>2];if(!Pb(d,j)){break c}e=f+24|0;Um(e,b);k=Oc(e);m=Te(e);e=Li(e);l=w[f+24|0];if((l-1&255)>>>0<=106){t[d|0]=l+13}t[d+1|0]=w[k|0];Pf(d,w[m|0],w[e|0]);Ck(f+40|0);continue}}g=g+1|0;continue}}else{d=f+40|0;IC(b,d);h=kb-16|0;kb=h;e=(B(i,104)+a|0)+484380|0;nd(e,0);t[e+37|0]=w[d+22|0]<<4;t[h+15|0]=w[d+23|0];t[h+14|0]=64;n=e,o=w[Yb(h+15|0,h+14|0)|0]<<2,u[n+30>>1]=o;t[e+36|0]=w[d+24|0];v[e>>2]=w[d+25|0]|w[d+26|0]<<8|(w[d+27|0]<<16|w[d+28|0]<<24);k=w[d+33|0]|w[d+34|0]<<8|(w[d+35|0]<<16|w[d+36|0]<<24);if(!(k>>>0<3|k+(w[d+29|0]|w[d+30|0]<<8|(w[d+31|0]<<16|w[d+32|0]<<24))>>>0>(w[d+25|0]|w[d+26|0]<<8|(w[d+27|0]<<16|w[d+28|0]<<24))>>>0)){u[e+34>>1]=x[e+34>>1]|2;v[e+4>>2]=w[d+29|0]|w[d+30|0]<<8|(w[d+31|0]<<16|w[d+32|0]<<24);v[e+8>>2]=(w[d+33|0]|w[d+34|0]<<8|(w[d+35|0]<<16|w[d+36|0]<<24))+(w[d+29|0]|w[d+30|0]<<8|(w[d+31|0]<<16|w[d+32|0]<<24))}kb=h+16|0;e=f+8|0;Fl(e,2,d);d=f+24|0;Fc(d,e);Dc(((i<<5)+a|0)+946304|0,d);g=g+1|0;zb(d);continue}}}g=1}kb=f+384|0;return g|0}function oca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,w=0,x=0,y=0,z=0,A=0,C=0,D=0,E=0,F=0,G=0,H=0;f=kb-48|0;kb=f;s=v[a+16>>2];u=kg(b+327720|0,v[b+20>>2],(v[a+88>>2]&16384)>>>14|0);b=0;o=v[a+128>>2];if(o){e=v[a+8>>2];k=v[a+12>>2];p=lg(e,k,o);q=nb;i=v[a+76>>2];Qf(v[a>>2],v[a+4>>2],qf(e,k,d),nb);k=i>>>0<nb>>>0?d:0}else{k=0}j=a+112|0;while(1){if((b|0)!=2){e=b<<3;h=e+(f+16|0)|0;e=a+e|0;v[h+4>>2]=v[e+44>>2];v[h+8>>2]=v[e+48>>2];b=b+1|0;continue}break}l=v[a+40>>2];m=v[a+36>>2];b=v[a+4>>2];v[f+8>>2]=v[a>>2];v[f+12>>2]=b;w=v[a+8>>2];x=v[a+12>>2];while(1){if(d){d=d-1|0;b=v[f+12>>2];e=v[f+8>>2];v[f+40>>2]=e;v[f+44>>2]=0;k=k-1|0;p=k?p:0;q=k?q:0;n=(((b&2147483647)<<1|e>>>31)&-2)+s|0;e=o;a:{b:while(1){c:{if((e|0)<=0){Rb(j,v[a+120>>2],v[a+124>>2]);h=v[a+116>>2];if(!h){break a}e=((v[f+44>>2]&2147483647)<<1|v[f+40>>2]>>>31)&-2;g=0;b=0;break c}h=((v[f+44>>2]&2147483647)<<1|v[f+40>>2]>>>31)&-2;b=0;g=0;while(1)if((b|0)==2){Sd(j,(g|0)/8<<16>>16);Rd(j,4);Rb(f+40|0,p,q);e=e-1|0;continue b}else{g=(t[n+(b+h|0)|0]<<8)+g|0;b=b+1|0;continue}}break}while(1){if((b|0)!=2){g=(t[n+(b+e|0)|0]<<8)+g|0;b=b+1|0;continue}break}Sd(j,(g|0)/8<<16>>16);Rd(j,h);v[j>>2]=v[j>>2];v[j+4>>2]=0}b=jg(j,u);v[f+4>>2]=b;v[f>>2]=b;y=v[a+72>>2];b=v[a+68>>2];z=b;A=b>>31;b=v[a+64>>2];C=b;D=b>>31;b=v[a+60>>2];E=b;F=b>>31;b=0;while(1){if((b|0)!=2){r=(b<<2)+f|0;e=v[r>>2];i=(f+16|0)+(b<<3)|0;G=v[i+8>>2];g=v[i+4>>2];v[i+8>>2]=g;n=e<<8;e=n;e=Jka(E,F,e,e>>31);h=nb;H=i;i=e;e=Zb(g,-16777216,16776704);e=Jka(C,D,e,e>>31);g=i+e|0;i=nb+h|0;i=e>>>0>g>>>0?i+1|0:i;e=Zb(G,-16777216,16776704);h=Jka(z,A,e,e>>31);g=h+g|0;e=nb+i|0;e=g>>>0<h>>>0?e+1|0:e;h=g+8388608|0;e=h>>>0<8388608?e+1|0:e;e=Yc(h,e,24);v[H+4>>2]=e-(n&y);v[r>>2]=(e|0)/256;b=b+1|0;continue}break}b=v[a+32>>2];m=v[a+28>>2]+m|0;v[c>>2]=v[c>>2]+B(v[f>>2],m>>12);l=b+l|0;v[c+4>>2]=v[c+4>>2]+B(v[f+4>>2],l>>12);Rb(f+8|0,w,x);c=c+8|0;continue}break}b=v[f+12>>2];v[a>>2]=v[f+8>>2];v[a+4>>2]=b;v[a+40>>2]=l;v[a+20>>2]=m>>12;v[a+36>>2]=m;v[a+24>>2]=l>>12;b=0;while(1){if((b|0)!=2){c=b<<3;d=c+a|0;c=c+(f+16|0)|0;v[d+44>>2]=v[c+4>>2];v[d+48>>2]=v[c+8>>2];b=b+1|0;continue}break}kb=f+48|0}function aW(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,x=0,z=0,A=0,C=0,D=0,E=0,F=0;f=kb-32|0;kb=f;k=ug(f+24|0);p=k+3|0;q=k+5|0;r=k+4|0;s=k+2|0;x=k+1|0;d=f+16|0;z=d|5;A=d|3;while(1){a:{if(y[a+12>>2]>m>>>0){C=Cf(v[a>>2],v[v[a+48>>2]+12>>2],m);b:while(1){if(!Qb(v[c>>2],v[c+8>>2],1)){break a}l=Me(c);if((l|0)==255){break a}d=l&31;g=B(d,6)+C|0;i=Og(v[v[a+48>>2]+12>>2])>>>0>d>>>0;j=i?g:k;e=1;if(!(l&64)){d=Me(c);h=d<<24>>24;e=255;d=d&127;c:{d:{if((d|0)==1){break d}e=d-1|0;if(b?e>>>0<=120:0){break d}if((d-109&255)>>>0<159|b){break c}e=d+13|0}t[j|0]=e}E=i?g+1|0:x,F=Me(c),t[E|0]=F;e=(h|0)<0}h=i?g+3|0:p;d=i?g+5|0:q;n=i?g+4|0:r;i=i?g+2|0:s;while(1){e:{f:{g:{if(e&1){v[f+16>>2]=w[j|0]|w[j+1|0]<<8|(w[j+2|0]<<16|w[j+3|0]<<24);u[f+20>>1]=w[j+4|0]|w[j+5|0]<<8;o=Me(c);g=o&63;if(o&64){t[i|0]=1;t[n|0]=g;break e}e=Me(c);t[d|0]=e;if(g>>>0<=15){Pf(j,g,e);h:{i:{j:{e=w[h|0];switch(e-9|0){case 1:case 2:case 3:break f;case 4:break i;case 0:break j;default:break h}}t[h|0]=9;t[d|0]=B(w[d|0]&15,17);break f}t[h|0]=0;t[i|0]=1;v[f+12>>2]=w[d|0]+1>>>1;v[f+8>>2]=64;E=n,F=v[td(f+12|0,f+8|0)>>2],t[E|0]=F;break f}if((e|0)!=19){break f}if(w[d|0]==128){break g}Uu(j);break f}if(g>>>0>44){break f}t[h|0]=w[g+26272|0];k:{switch(g-16|0){case 0:if(e>>>0>1){break g}t[d|0]=e|158;break f;case 1:case 2:t[f+12|0]=15;E=d,F=w[Yb(f+12|0,d)|0]|224,t[E|0]=F;break f;case 5:case 6:v[f+12>>2]=16;v[f+8>>2]=e+1;E=d,F=v[td(f+12|0,f+8|0)>>2]/2|240,t[E|0]=F;break f;case 14:l:{m:{n:{o:{p:{g=e>>>4|0;switch(g-1|0){case 1:break n;case 0:break o;default:break p}}switch(g-10|0){case 1:break l;case 0:break m;default:break g}}t[h|0]=2;t[d|0]=e|240;break f}t[h|0]=3;t[d|0]=e|240;break f}t[h|0]=11;t[d|0]=(e<<3&120)+8|15;break f}t[h|0]=11;t[d|0]=(e&15)+1>>>1|240;break f;case 12:break k;default:break f}}v[f+12>>2]=e+1>>>1;v[f+8>>2]=64;E=d,F=v[td(f+12|0,f+8|0)>>2],t[E|0]=F;break f}if(!(l&128)){continue b}break a}t[h|0]=0}Tu(h,d,A,z);e=w[f+19|0];D=Ji(e);g=w[h|0];if(D>>>0<=Ji(g)>>>0){break e}if(!w[i|0]){Qq(f,g,w[d|0],1);g=w[f+1|0];t[i|0]=w[f|0];t[n|0]=g}t[h|0]=e;t[d|0]=w[f+21|0]}e=o>>>7|0;continue}}}kb=f+32|0;return}m=m+1|0;continue}}function qt(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;i=kb-16|0;kb=i;f=v[a+24>>2];h=mz(f,w[a+32|0]);j=v[h>>2];a:{if(Rc(j,v[h+4>>2])>>>0<=b>>>0){break a}if(EO(f,x[cc(j,b)>>1])>>>0<=c>>>0){break a}h=v[a>>2];b:{if(yd(h,v[a+4>>2])>>>0>b>>>0){if(y[Nd(h,b)+4>>2]>c>>>0){break b}}bo(a,0);if(yd(v[a>>2],v[a+4>>2])>>>0<=b>>>0){break a}f=v[a+24>>2]}gc(i,v[d>>2],x[f+480188>>1]);d=i+8|0;h=v[i>>2];f=e?-2046629010:-2078137563;e=e?-1352371636:-873292572;j=v[i+4>>2];while(1){if(!g&(k|0)==(j|0)){v[d>>2]=f;v[d+4>>2]=e}else{l=w[tQ(h,k)+841|0];m=l^Jka(f^k,e^g,435,256);l=!l;f=(q=f,r=Jka(m,nb,435,256),s=l,s?q:r);e=l?e:nb;k=k+1|0;g=k?g:g+1|0;continue}break}e=d;d=0;f=xm(i,b,c);h=kb-16|0;kb=h;k=a+12|0;g=uO(x[f>>1],v[f+4>>2],Td(k),jc(k));c:{if(Pb(g,Zf(k))){j=x[f>>1];l=v[f+4>>2];f=vd(g);if(!ml(j,l,x[f>>1],v[f+4>>2])){break c}}g=Zf(k)}f=v[fc(h+8|0,g)>>2];kb=h+16|0;if(Hg(f,xf(k))){d=vd(f);d=pc(v[d+8>>2],v[d+12>>2])^1}h=v[e>>2]!=-2078137563|v[e+4>>2]!=-873292572;Db(i,v[Nd(v[a>>2],b)>>2],c);g=1;j=d|h;m=Cb(v[v[i>>2]>>2],v[i+4>>2])^1;if(!(m?1:j)){break a}d:{e:{f:{g:{if(d){l=vd(f);f=Fb(v[l+8>>2]);n=Fb(v[l+12>>2]);o=v[e>>2];p=v[e+4>>2];j=kb-16|0;kb=j;v[j+8>>2]=f;while(1){if(!(!Pb(f,n)|v[f>>2]==(o|0)&v[f+4>>2]==(p|0))){f=v[st(j+8|0)>>2];continue}break}kb=j+16|0;if(Pb(f,Fb(v[l+12>>2]))){break a}if(!h){break e}break g}if(h){break g}if(!j){break d}break f}v[a+28>>2]=v[a+28>>2]+1}if(d|m){break e}d=sO(k,xm(i,b,c));h:{if(y[d+4>>2]<y[Gb(d)>>2]){g=kb-16|0;kb=g;d=rO(g,d);pO(v[d+4>>2]);v[d+4>>2]=v[d+4>>2]+8;lc(d);kb=g+16|0;break h}f=kb-32|0;kb=f;g=Gb(d);g=nr(f+8|0,or(d,Ug(v[d>>2],v[d+4>>2])+1|0),Ug(v[d>>2],v[d+4>>2]),g);pO(v[g+8>>2]);v[g+8>>2]=v[g+8>>2]+8;Fd(d,g);mr(g);kb=f+32|0}}d=sO(k,xm(i,b,c));i:{if(y[d+4>>2]<y[Gb(d)>>2]){g=kb-16|0;kb=g;d=rO(g,d);qO(v[d+4>>2],v[e>>2],v[e+4>>2]);v[d+4>>2]=v[d+4>>2]+8;lc(d);kb=g+16|0;break i}f=kb-32|0;kb=f;g=Gb(d);g=nr(f+8|0,or(d,Ug(v[d>>2],v[d+4>>2])+1|0),Ug(v[d>>2],v[d+4>>2]),g);qO(v[g+8>>2],v[e>>2],v[e+4>>2]);v[g+8>>2]=v[g+8>>2]+8;Fd(d,g);mr(g);kb=f+32|0}}Db(i,v[Nd(v[a>>2],b)>>2],c);Ze(i,1);g=0}kb=i+16|0;return g|0}function Ex(a){a=a|0;var b=0,c=0,d=C(0),e=0;Ub(a+4960|0,0,76);t[a+5044|0]=0;v[a+5036>>2]=0;v[a+5040>>2]=0;b=v[a+4292>>2];d=z[a+4268>>2];v[23540]=0;e=a+4504|0;if(d<C(4294967296)&d>=C(0)){c=~~d>>>0}else{c=0}da(923,e|0,67,5,c|0,b|0);b=v[23540];v[23540]=0;a:{if((b|0)==1){break a}b=v[a+4296>>2];v[23540]=0;da(923,a+4528|0,62,5,c|0,b|0);b=v[23540];v[23540]=0;if((b|0)==1){break a}b=v[a+4300>>2];v[23540]=0;da(923,a+4552|0,53,5,c|0,b|0);b=v[23540];v[23540]=0;if((b|0)==1){break a}b=v[a+4304>>2];v[23540]=0;da(923,a+4576|0,43,5,c|0,b|0);b=v[23540];v[23540]=0;if((b|0)==1){break a}b=v[a+4308>>2];v[23540]=0;da(923,a+4600|0,32,5,c|0,b|0);b=v[23540];v[23540]=0;if((b|0)==1){break a}b=v[a+4312>>2];v[23540]=0;da(923,a+4624|0,22,5,c|0,b|0);b=v[23540];v[23540]=0;if((b|0)==1){break a}b=v[a+4316>>2];v[23540]=0;da(923,a+4648|0,75,5,c|0,b|0);b=v[23540];v[23540]=0;if((b|0)==1){break a}b=v[a+4320>>2];v[23540]=0;da(923,a+4672|0,69,5,c|0,b|0);b=v[23540];v[23540]=0;if((b|0)==1){break a}b=v[a+4324>>2];v[23540]=0;da(923,a+4696|0,60,5,c|0,b|0);b=v[23540];v[23540]=0;if((b|0)==1){break a}b=v[a+4328>>2];v[23540]=0;da(923,a+4720|0,48,5,c|0,b|0);b=v[23540];v[23540]=0;if((b|0)==1){break a}b=v[a+4332>>2];v[23540]=0;da(923,a+4744|0,36,5,c|0,b|0);b=v[23540];v[23540]=0;if((b|0)==1){break a}b=v[a+4336>>2];v[23540]=0;da(923,a+4768|0,25,5,c|0,b|0);b=v[23540];v[23540]=0;if((b|0)==1){break a}v[23540]=0;da(923,a+4792|0,0,0,0,0);b=v[23540];v[23540]=0;if((b|0)==1){break a}b=v[a+4344>>2];v[23540]=0;da(923,a+4816|0,3,0,c|0,b|0);b=v[23540];v[23540]=0;if((b|0)==1){break a}b=v[a+4348>>2];v[23540]=0;da(923,a+4840|0,3,0,c|0,b|0);b=v[23540];v[23540]=0;if((b|0)==1){break a}v[23540]=0;da(923,a+4864|0,407,1,c|0,0);b=v[23540];v[23540]=0;if((b|0)==1){break a}v[23540]=0;da(923,a+4888|0,400,1,c|0,0);b=v[23540];v[23540]=0;if((b|0)==1){break a}v[23540]=0;da(923,a+4912|0,10,0,c|0,-1);b=v[23540];v[23540]=0;if((b|0)==1){break a}v[23540]=0;da(923,a+4936|0,10,0,c|0,-1);c=v[23540];v[23540]=0;if((c|0)==1){break a}t[a+5045|0]=1;return}c=V(92756)|0;if((O()|0)==(ea(92756)|0)){_(c|0)|0;t[a+5045|0]=0;$();return}T(c|0);L()}function Pea(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=kb-128|0;kb=d;a:{b:{c:{d:{switch(w[a|0]-23|0){case 0:e=t[a+1|0];f=d,g=cB(c,+w[a+2|0]*1e4/240),t[f|0]=g;v[d+96>>2]=127;v[d+80>>2]=(B(w[a+3|0],127)>>>0)/185;f=d,g=v[td(d+96|0,d+80|0)>>2],t[f+127|0]=g;e:{switch(((e>>>0)%5|0)-1|0){case 0:Iu(d+80|0,15641);v[23540]=0;R(544,d- -64|0,d|0);a=v[23540];v[23540]=0;f:{g:{h:{i:{if((a|0)!=1){v[23540]=0;R(544,d+48|0,d+127|0);a=v[23540];v[23540]=0;if((a|0)==1){break i}v[23540]=0;X(545,d+96|0,d+80|0,d- -64|0,d+48|0);a=v[23540];v[23540]=0;if((a|0)==1){break h}a=d+96|0;Fe(d+112|0,a);gf(b,v[d+112>>2],v[d+116>>2]);zb(a);zb(d+48|0);zb(d- -64|0);Xb(d+80|0);break b}a=P()|0;O()|0;break f}a=P()|0;O()|0;break g}a=P()|0;O()|0;zb(d+48|0)}zb(d- -64|0)}break c;case 1:Iu(d+80|0,15581);v[23540]=0;R(544,d- -64|0,d|0);a=v[23540];v[23540]=0;j:{k:{l:{m:{if((a|0)!=1){v[23540]=0;R(544,d+48|0,d+127|0);a=v[23540];v[23540]=0;if((a|0)==1){break m}v[23540]=0;X(545,d+96|0,d+80|0,d- -64|0,d+48|0);a=v[23540];v[23540]=0;if((a|0)==1){break l}a=d+96|0;Fe(d+40|0,a);gf(b,v[d+40>>2],v[d+44>>2]);zb(a);zb(d+48|0);zb(d- -64|0);Xb(d+80|0);break b}a=P()|0;O()|0;break j}a=P()|0;O()|0;break k}a=P()|0;O()|0;zb(d+48|0)}zb(d- -64|0)}break c;default:break e}}a=rc(d+32|0,15668);gf(b,v[a>>2],v[a+4>>2]);break b;case 1:break d;default:break a}}c=t[a+1|0];t[d+127|0]=(c|0)<5?c:0;c=t[a+2|0];t[d+31|0]=(c|0)>=0?c:127;a=t[a+3|0];t[d+30|0]=(a|0)>=0?a:127;a=kb-16|0;kb=a;c=Kc(a,4051);ad(d+80|0,c);zb(c);kb=a+16|0;v[23540]=0;R(544,d- -64|0,d+127|0);a=v[23540];v[23540]=0;n:{o:{p:{q:{r:{s:{if((a|0)!=1){v[23540]=0;R(544,d+48|0,d+31|0);a=v[23540];v[23540]=0;if((a|0)==1){break s}v[23540]=0;R(544,d|0,d+30|0);a=v[23540];v[23540]=0;if((a|0)==1){break r}v[23540]=0;da(710,d+96|0,d+80|0,d- -64|0,d+48|0,d|0);a=v[23540];v[23540]=0;if((a|0)==1){break q}a=d+96|0;Fe(d+16|0,a);gf(b,v[d+16>>2],v[d+20>>2]);zb(a);zb(d);zb(d+48|0);zb(d- -64|0);Xb(d+80|0);break b}a=P()|0;O()|0;break n}a=P()|0;O()|0;break o}a=P()|0;O()|0;break p}a=P()|0;O()|0;zb(d)}zb(d+48|0)}zb(d- -64|0)}}Xb(d+80|0);T(a|0);L()}e=1}kb=d+128|0;return e|0}function nca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,C=0,D=0,E=0,F=0,G=0,H=0;f=kb-48|0;kb=f;s=v[a+16>>2];t=kg(b+327720|0,v[b+20>>2],(v[a+88>>2]&16384)>>>14|0);b=0;o=v[a+128>>2];if(o){e=v[a+8>>2];j=v[a+12>>2];p=lg(e,j,o);q=nb;g=v[a+76>>2];Qf(v[a>>2],v[a+4>>2],qf(e,j,d),nb);j=g>>>0<nb>>>0?d:0}else{j=0}i=a+112|0;while(1){if((b|0)!=2){e=b<<3;h=e+(f+16|0)|0;e=a+e|0;v[h+4>>2]=v[e+44>>2];v[h+8>>2]=v[e+48>>2];b=b+1|0;continue}break}m=v[a+40>>2];n=v[a+36>>2];b=v[a+4>>2];v[f+8>>2]=v[a>>2];v[f+12>>2]=b;w=v[a+8>>2];x=v[a+12>>2];a:while(1){if(d){d=d-1|0;b=v[f+12>>2];e=v[f+8>>2];v[f+40>>2]=e;v[f+44>>2]=0;j=j-1|0;p=j?p:0;q=j?q:0;l=((((b&2147483647)<<1|e>>>31)&2147483646)<<1)+s|0;b=o;while(1)if((b|0)<=0){Rb(i,v[a+120>>2],v[a+124>>2]);h=v[a+116>>2];if(h){b=(v[f+44>>2]&2147483647)<<1|v[f+40>>2]>>>31;Sd(i,(u[(b<<1|2)+l>>1]+u[l+((b&2147483646)<<1)>>1]|0)/8<<16>>16);Rd(i,h);v[i>>2]=v[i>>2];v[i+4>>2]=0}b=jg(i,t);v[f+4>>2]=b;v[f>>2]=b;y=v[a+72>>2];b=v[a+68>>2];z=b;A=b>>31;b=v[a+64>>2];C=b;D=b>>31;b=v[a+60>>2];E=b;F=b>>31;b=0;while(1){if((b|0)!=2){r=(b<<2)+f|0;e=v[r>>2];g=(f+16|0)+(b<<3)|0;G=v[g+8>>2];k=v[g+4>>2];v[g+8>>2]=k;l=e<<8;e=l;e=Jka(E,F,e,e>>31);h=nb;H=g;g=e;e=Zb(k,-16777216,16776704);e=Jka(C,D,e,e>>31);k=g+e|0;g=nb+h|0;g=e>>>0>k>>>0?g+1|0:g;e=Zb(G,-16777216,16776704);h=Jka(z,A,e,e>>31);k=h+k|0;e=nb+g|0;e=h>>>0>k>>>0?e+1|0:e;h=k+8388608|0;e=h>>>0<8388608?e+1|0:e;e=Yc(h,e,24);v[H+4>>2]=e-(l&y);v[r>>2]=(e|0)/256;b=b+1|0;continue}break}b=v[a+32>>2];n=v[a+28>>2]+n|0;v[c>>2]=v[c>>2]+B(v[f>>2],n>>12);m=b+m|0;v[c+4>>2]=v[c+4>>2]+B(v[f+4>>2],m>>12);Rb(f+8|0,w,x);c=c+8|0;continue a}else{e=(v[f+44>>2]&2147483647)<<1|v[f+40>>2]>>>31;Sd(i,(u[(e<<1|2)+l>>1]+u[l+((e&2147483646)<<1)>>1]|0)/8<<16>>16);Rd(i,4);Rb(f+40|0,p,q);b=b-1|0;continue}}break}b=v[f+12>>2];v[a>>2]=v[f+8>>2];v[a+4>>2]=b;v[a+40>>2]=m;v[a+20>>2]=n>>12;v[a+36>>2]=n;v[a+24>>2]=m>>12;b=0;while(1){if((b|0)!=2){c=b<<3;d=c+a|0;c=c+(f+16|0)|0;v[d+44>>2]=v[c+4>>2];v[d+48>>2]=v[c+8>>2];b=b+1|0;continue}break}kb=f+48|0}function x8(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=C(0),g=C(0),h=C(0),i=0,j=0,k=0,l=C(0),m=0,n=C(0),o=0,p=0,q=0,r=0,s=0,t=0,u=0,x=0,y=C(0),A=0,B=0,E=0,F=0,G=0,H=0,I=C(0),J=0,K=0,L=0,M=0,N=0,O=C(0),P=0,Q=C(0);a:{if(!v[a+4316>>2]){break a}if(!bi(a+44|0)){break a}G=a+4300|0;H=a+4288|0;J=a+4264|0;K=a+4276|0;e=v[a+44>>2];s=Jc(e,0);t=Jc(e,1);e=v[a+56>>2];u=Jc(e,0);x=Jc(e,1);L=ob[v[v[a>>2]+196>>2]](a)|0;y=C(C(ob[v[v[a>>2]+204>>2]](a))/C(100));I=C(ob[v[v[a>>2]+192>>2]](a));A=ob[v[v[a>>2]+216>>2]](a)|0;M=A&1;o=v[a+4324>>2];i=v[a+4320>>2];m=v[a+4328>>2];k=v[a+4312>>2];N=v[a+4276>>2];p=v[a+4264>>2];B=v[a+4256>>2];E=w[a+4260|0];r=a+4316|0;F=d;while(1){if(F){h=z[t>>2];l=z[s>>2];j=v[r>>2];e=Nn(j,k+B|0);j=Nn(j,k);b:{if(E){P=Eb(H,m),Q=l,z[P>>2]=Q;P=Eb(G,m),Q=h,z[P>>2]=Q;q=Eb(p,e);P=Eb(p,j),Q=C(C(z[q>>2]*y)+l),z[P>>2]=Q;g=C(C(z[Eb(N,e)>>2]*y)+h);e=K;break b}g=C(C(z[Eb(p,e)>>2]*y)+C(C(l+h)*C(.5)));e=J}P=Eb(v[e>>2],j),Q=g,z[P>>2]=Q;c:{if(L){f=z[a+4244>>2];g=C(f+z[a+4236>>2]);z[a+4236>>2]=g;f=C(f+z[a+4240>>2]);z[a+4240>>2]=f;if(g>C(1)){g=C(g+C(-2));z[a+4236>>2]=g}if(f>C(1)){f=C(f+C(-2));z[a+4240>>2]=f}g=C(D(g));g=C(C(g+g)+C(-1));f=C(D(f));f=C(C(f+f)+C(-1));break c}f=z[a+4240>>2];n=z[a+4244>>2];g=C(C(f*n)+z[a+4236>>2]);z[a+4236>>2]=g;f=C(f-C(g*n));z[a+4240>>2]=f}if(E){e=(m+2|0)%3|0;l=z[Eb(H,e)>>2];h=z[Eb(G,e)>>2]}e=v[r>>2];j=Eb(p,Nn(e,i+k|0));q=e;e=k+4096|0;O=z[Eb(p,Nn(q,e+i|0))>>2];n=z[j>>2];z[u>>2]=C(C(C(C(C(O-n)*C(C(i&4095)*C(.000244140625)))+n)-l)*I)+l;i=v[(E?4276:4264)+a>>2];j=v[r>>2];q=Eb(i,Nn(j,k+o|0));n=z[Eb(i,Nn(j,e+o|0))>>2];l=z[q>>2];z[x>>2]=C(C(C(C(C(n-l)*C(C(o&4095)*C(.000244140625)))+l)-h)*I)+h;m=((m|0)<=0?m+3|0:m)-1|0;v[a+4328>>2]=m;k=(((k|0)>0?0:v[r>>2]<<12)+k|0)-4096|0;v[a+4312>>2]=k;h=M?f:g;f=z[a+4248>>2];h=C(h*f);d:{if(C(D(h))<C(2147483648)){e=~~h;break d}e=-2147483648}o=(A>>>0>1?e:0-e|0)+B|0;v[a+4324>>2]=o;i=A>>>0<4;t=t+4|0;s=s+4|0;g=C(g*f);e:{if(C(D(g))<C(2147483648)){e=~~g;break e}e=-2147483648}i=(i?e:0-e|0)+B|0;v[a+4320>>2]=i;F=F-1|0;x=x+4|0;u=u+4|0;continue}else{e=a;a=v[a+56>>2];ti(e,b,c,Jc(a,0),Jc(a,1),d)}break}}}function g7(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=C(0),f=0,g=0,h=0,i=0,j=0,k=C(0),l=0,m=C(0),n=0,o=C(0),p=C(0),q=0,r=0,s=0,t=0,u=0,w=0,x=0,y=0,A=C(0),B=0,D=0,E=0,F=0,G=C(0),H=0,I=0,J=0,K=0,L=C(0),M=C(0),N=C(0),O=C(0),P=C(0),Q=0,R=C(0);if(bi(a+44|0)){f=v[a+44>>2];B=Jc(f,0);D=Jc(f,1);f=v[a+56>>2];E=Jc(f,0);F=Jc(f,1);s=v[a+4296>>2];g=s+1|0;l=a+4304|0;f=a+4272|0;u=g+v[Eb(f,0)>>2]&4095;q=l+(u<<4)|0;w=g+v[Eb(f,1)>>2]&4095;n=((w<<4)+l|0)+4|0;x=g+v[Eb(f,2)>>2]&4095;j=((x<<4)+l|0)+8|0;h=Eb(f,3);i=v[Eb(f,4)>>2];r=v[a+4300>>2];i=i+r|0;y=g+v[h>>2]&4095;h=((y<<4)+l|0)+12|0;t=v[Eb(f,5)>>2]+r|0;g=a+4232|0;H=a+69840|0;I=a+78032|0;f=d;while(1){if(f){L=z[h>>2];M=z[j>>2];N=z[n>>2];O=z[q>>2];A=z[D>>2];P=z[B>>2];J=i&1023;j=(J<<3)+H|0;k=z[j+4>>2];u=u-1&4095;q=(u<<4)+l|0;e=z[q>>2];h=r<<3;i=h+H|0;w=w-1&4095;n=(w<<4)+l|0;m=z[n+4>>2];o=m;p=C(m*C(.6180340051651001));G=z[j>>2];m=z[Eb(g,0)>>2];p=C(p+C(G*m));z[i+4>>2]=o+C(p*C(-.6180340051651001));o=e;e=C(C(k*m)+C(e*C(-.6180340051651001)));z[i>>2]=o+C(e*C(.6180340051651001));z[q>>2]=p;z[n+4>>2]=e;t=t&1023;K=(t<<3)+I|0;m=z[K+4>>2];x=x-1&4095;i=(x<<4)+l|0;e=z[i+8>>2];h=h+I|0;y=y-1&4095;j=(y<<4)+l|0;k=z[j+12>>2];o=k;G=z[K>>2];p=z[Eb(g,1)>>2];k=C(C(k*C(.6180340051651001))+C(G*p));z[h+4>>2]=o+C(k*C(-.6180340051651001));o=e;e=C(C(m*p)+C(e*C(-.6180340051651001)));z[h>>2]=o+C(e*C(.6180340051651001));z[i+8>>2]=k;z[j+12>>2]=e;e=C(P+C(1.0000000031710769e-30));z[E>>2]=k+C(C(e*z[a+4224>>2])+z[q>>2]);k=C(A+C(1.0000000031710769e-30));z[F>>2]=C(C(k*z[a+4224>>2])+z[n+4>>2])+z[j+12>>2];h=(s<<4)+l|0;m=e;e=z[a+4228>>2];A=C(m*e);Q=h,R=C(A+C(C(z[q>>2]*z[Eb(g,2)>>2])+C(O*z[Eb(g,3)>>2]))),z[Q>>2]=R;e=C(k*e);Q=h,R=C(e+C(C(z[n+4>>2]*z[Eb(g,4)>>2])+C(N*z[Eb(g,5)>>2]))),z[Q+4>>2]=R;Q=h,R=C(C(C(z[i+8>>2]*z[Eb(g,6)>>2])+C(M*z[Eb(g,7)>>2]))-e),z[Q+8>>2]=R;Q=h,R=C(A+C(C(z[j+12>>2]*z[Eb(g,8)>>2])+C(L*z[Eb(g,9)>>2]))),z[Q+12>>2]=R;h=j+12|0;j=i+8|0;n=n+4|0;f=f-1|0;F=F+4|0;E=E+4|0;D=D+4|0;B=B+4|0;t=t-1|0;i=J-1|0;r=r-1&1023;s=s-1&4095;continue}else{v[a+4300>>2]=r;v[a+4296>>2]=s;f=a;a=v[a+56>>2];ti(f,b,c,Jc(a,0),Jc(a,1),d)}break}}}function sca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,w=0,x=0,y=0,z=0,A=0,C=0,D=0,E=0,F=0,G=0,H=0;f=kb-48|0;kb=f;q=v[a+16>>2];r=kg(b+327720|0,v[b+20>>2],(v[a+88>>2]&16384)>>>14|0);b=0;m=v[a+128>>2];if(m){e=v[a+8>>2];k=v[a+12>>2];n=lg(e,k,m);o=nb;i=v[a+76>>2];Qf(v[a>>2],v[a+4>>2],qf(e,k,d),nb);k=i>>>0<nb>>>0?d:0}else{k=0}j=a+112|0;while(1){if((b|0)!=2){e=b<<3;h=e+(f+16|0)|0;e=a+e|0;v[h+4>>2]=v[e+44>>2];v[h+8>>2]=v[e+48>>2];b=b+1|0;continue}break}s=v[a+24>>2];u=v[a+20>>2];b=v[a+4>>2];v[f+8>>2]=v[a>>2];v[f+12>>2]=b;w=v[a+8>>2];x=v[a+12>>2];while(1){if(d){d=d-1|0;b=v[f+12>>2];e=v[f+8>>2];v[f+40>>2]=e;v[f+44>>2]=0;k=k-1|0;n=k?n:0;o=k?o:0;l=(((b&2147483647)<<1|e>>>31)&-2)+q|0;e=m;a:{b:while(1){c:{if((e|0)<=0){Rb(j,v[a+120>>2],v[a+124>>2]);h=v[a+116>>2];if(!h){break a}e=((v[f+44>>2]&2147483647)<<1|v[f+40>>2]>>>31)&-2;g=0;b=0;break c}h=((v[f+44>>2]&2147483647)<<1|v[f+40>>2]>>>31)&-2;b=0;g=0;while(1)if((b|0)==2){Sd(j,(g|0)/8<<16>>16);Rd(j,4);Rb(f+40|0,n,o);e=e-1|0;continue b}else{g=(t[l+(b+h|0)|0]<<8)+g|0;b=b+1|0;continue}}break}while(1){if((b|0)!=2){g=(t[l+(b+e|0)|0]<<8)+g|0;b=b+1|0;continue}break}Sd(j,(g|0)/8<<16>>16);Rd(j,h);v[j>>2]=v[j>>2];v[j+4>>2]=0}b=jg(j,r);v[f+4>>2]=b;v[f>>2]=b;y=v[a+72>>2];b=v[a+68>>2];z=b;A=b>>31;b=v[a+64>>2];C=b;D=b>>31;b=v[a+60>>2];E=b;F=b>>31;b=0;while(1){if((b|0)!=2){p=(b<<2)+f|0;e=v[p>>2];i=(f+16|0)+(b<<3)|0;G=v[i+8>>2];g=v[i+4>>2];v[i+8>>2]=g;l=e<<8;e=l;e=Jka(E,F,e,e>>31);h=nb;H=i;i=e;e=Zb(g,-16777216,16776704);e=Jka(C,D,e,e>>31);g=i+e|0;i=nb+h|0;i=e>>>0>g>>>0?i+1|0:i;e=Zb(G,-16777216,16776704);h=Jka(z,A,e,e>>31);g=h+g|0;e=nb+i|0;e=g>>>0<h>>>0?e+1|0:e;h=g+8388608|0;e=h>>>0<8388608?e+1|0:e;e=Yc(h,e,24);v[H+4>>2]=e-(l&y);v[p>>2]=(e|0)/256;b=b+1|0;continue}break}v[c>>2]=v[c>>2]+B(v[f>>2],u);v[c+4>>2]=v[c+4>>2]+B(v[f+4>>2],s);Rb(f+8|0,w,x);c=c+8|0;continue}break}b=v[f+12>>2];v[a>>2]=v[f+8>>2];v[a+4>>2]=b;b=0;while(1){if((b|0)!=2){c=b<<3;d=c+a|0;c=c+(f+16|0)|0;v[d+44>>2]=v[c+4>>2];v[d+48>>2]=v[c+8>>2];b=b+1|0;continue}break}kb=f+48|0}function tP(a,b,c,d,e,f,g,h,i){var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;j=kb-128|0;kb=j;a:{b:{c:{if(!Hm(f,g,h,i,0,0,0,0)){break c}m=i&65535;n=i>>>16&32767;d:{e:{if((n|0)!=32767){l=4;if(n){break e}l=f|h|(g|m)?3:2;break d}l=!(f|h|(g|m))}}r=e>>>16|0;o=r&32767;if((o|0)==32767){break c}if(l){break b}}Jd(j+16|0,b,c,d,e,f,g,h,i);e=v[j+16>>2];d=v[j+20>>2];c=v[j+24>>2];b=v[j+28>>2];IP(j,e,d,c,b,e,d,c,b);d=v[j+8>>2];e=v[j+12>>2];h=v[j>>2];i=v[j+4>>2];break a}m=e&65535|o<<16;p=m;l=d;m=h;q=i>>>16&32767;k=i&65535|q<<16;if((Hm(b,c,l,p,f,g,h,k)|0)<=0){if(Hm(b,c,l,p,f,g,m,k)){h=b;i=c;break a}Jd(j+112|0,b,c,d,e,0,0,0,0);d=v[j+120>>2];e=v[j+124>>2];h=v[j+112>>2];i=v[j+116>>2];break a}if(o){i=c;h=b}else{Jd(j+96|0,b,c,l,p,0,0,0,1081540608);h=v[j+108>>2];p=h;l=v[j+104>>2];o=(h>>>16|0)-120|0;i=v[j+100>>2];h=v[j+96>>2]}if(!q){Jd(j+80|0,f,g,m,k,0,0,0,1081540608);f=v[j+92>>2];k=f;m=v[j+88>>2];q=(k>>>16|0)-120|0;g=v[j+84>>2];f=v[j+80>>2]}s=k&65535|65536;p=p&65535|65536;if((o|0)>(q|0)){while(1){t=l-m|0;k=(g|0)==(i|0)&f>>>0>h>>>0|g>>>0>i>>>0;n=(p-((l>>>0<m>>>0)+s|0)|0)-(t>>>0<k>>>0)|0;k=t-k|0;f:{if((n|0)>0|(n|0)>=0){l=h;h=h-f|0;i=i-((f>>>0>l>>>0)+g|0)|0;if(!(h|k|(i|n))){Jd(j+32|0,b,c,d,e,0,0,0,0);d=v[j+40>>2];e=v[j+44>>2];h=v[j+32>>2];i=v[j+36>>2];break a}n=n<<1|k>>>31;l=k<<1|i>>>31;p=n;break f}n=p<<1|l>>>31;l=l<<1|i>>>31;p=n}n=i<<1|h>>>31;h=h<<1;i=n;o=o-1|0;if((q|0)<(o|0)){continue}break}o=q}q=l-m|0;n=(g|0)==(i|0)&f>>>0>h>>>0|g>>>0>i>>>0;k=(p-((l>>>0<m>>>0)+s|0)|0)-(q>>>0<n>>>0)|0;m=q-n|0;g:{if((k|0)<0){m=l;k=p;break g}l=h;h=h-f|0;i=i-((f>>>0>l>>>0)+g|0)|0;if(h|m|(i|k)){break g}Jd(j+48|0,b,c,d,e,0,0,0,0);d=v[j+56>>2];e=v[j+60>>2];h=v[j+48>>2];i=v[j+52>>2];break a}if((k|0)==65535|k>>>0<65535){while(1){b=i>>>31|0;o=o-1|0;p=i<<1|h>>>31;h=h<<1;i=p;c=b;b=m;k=k<<1|b>>>31;m=c|b<<1;if(k>>>0<65536){continue}break}}b=r&32768;if((o|0)<=0){Jd(j- -64|0,h,i,m,k&65535|(b|o+120)<<16,0,0,0,1065811968);d=v[j+72>>2];e=v[j+76>>2];h=v[j+64>>2];i=v[j+68>>2];break a}d=m;e=k&65535|(b|o)<<16}v[a>>2]=h;v[a+4>>2]=i;v[a+8>>2]=d;v[a+12>>2]=e;kb=j+128|0}function _ba(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;h=kb-16|0;kb=h;c=rf(a,c);me(h,v[a+36>>2]);j=a;a:{if(!c){Sc(h,a+32|0,5);e=0;if(Cb(v[v[h>>2]>>2],v[h+4>>2])){break a}}e=kb-240|0;kb=e;g=Yl(e+128|0,v[a+36>>2]);v[23540]=0;f=Q(449,e+112|0,27864)|0;a=v[23540];v[23540]=0;b:{c:{d:{e:{if((a|0)!=1){v[23540]=0;v[e+96>>2]=19988497;v[e+100>>2]=0;U(450,g|0,f|0,e+96|0);a=v[23540];v[23540]=0;if((a|0)==1){break e}Xb(f);if(!Kk(w[g|0])){break d}break b}b=P()|0;O()|0;break c}b=P()|0;O()|0;Xb(f);break c}t[e+111|0]=0;v[23540]=0;f=Q(449,e+96|0,5508)|0;a=v[23540];v[23540]=0;f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{if((a|0)!=1){v[23540]=0;U(451,g|0,e+111|0,f|0);a=v[23540];v[23540]=0;if((a|0)==1){break q}Xb(f);f=Nb(e+80|0);v[23540]=0;a=Q(449,e- -64|0,10113)|0;i=v[23540];v[23540]=0;if((i|0)==1){break p}v[23540]=0;U(755,g|0,f|0,a|0);i=v[23540];v[23540]=0;if((i|0)==1){break o}Xb(a);v[23540]=0;U(11,e+48|0,(w[e+111|0]?0:d)|0,f|0);d=v[23540];v[23540]=0;if((d|0)==1){break n}v[23540]=0;R(273,b|0,e+48|0);d=v[23540];v[23540]=0;if((d|0)==1){break m}d=e+48|0;Ab(d);u[e+46>>1]=0;v[23540]=0;d=Q(449,d|0,10773)|0;a=v[23540];v[23540]=0;if((a|0)==1){break g}v[23540]=0;W(479,g|0,e+46|0,d|0)|0;a=v[23540];v[23540]=0;if((a|0)==1){break l}Xb(d);Ef(e+46|0,4e3);v[23540]=0;d=Q(449,e+32|0,13394)|0;a=v[23540];v[23540]=0;if((a|0)==1){break k}i=x[e+46>>1];a=v[fc(e+24|0,i)>>2];v[23540]=0;X(756,g|0,b|0,d|0,a|0);a=v[23540];v[23540]=0;if((a|0)==1){break j}Xb(d);u[e+22>>1]=65535;v[23540]=0;d=Q(449,e+8|0,8993)|0;a=v[23540];v[23540]=0;if((a|0)==1){break i}v[23540]=0;k=W(479,g|0,e+22|0,d|0)|0;a=v[23540];v[23540]=0;if((a|0)==1){break h}a=x[e+22>>1];Xb(d);if(a>>>0<i>>>0&k){Ve(b,a)}zb(f);break b}b=P()|0;O()|0;break c}b=P()|0;O()|0;Xb(f);break c}b=P()|0;O()|0;break f}b=P()|0;O()|0;Xb(a);break f}b=P()|0;O()|0;break f}b=P()|0;O()|0;Ab(e+48|0);break f}b=P()|0;O()|0;Xb(d);break f}b=P()|0;O()|0;break f}b=P()|0;O()|0;Xb(d);break f}b=P()|0;O()|0;break f}b=P()|0;O()|0;Xb(d);break f}b=P()|0;O()|0}zb(f)}kh(g);T(b|0);L()}kh(g);kb=e+240|0;e=c}Ye(j,e);kb=h+16|0}function Uca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,C=0,D=0,E=0,F=0,G=0,H=0;e=kb-48|0;kb=e;a:{b:{c:{j=v[a+12>>2];l=v[a+8>>2];d:{if((j|0)<=1&l>>>0<=805306368|(j|0)<=0){if((j|0)>=-2&l>>>0>=3489660928|(j|0)>-2){break c}if((j|0)==-2&l>>>0>2147483647|j>>>0>4294967294){break d}break b}if((j|0)==1&l>>>0>2147483648|j>>>0>1){break b}}b=b+196648|0;break a}b=b+131112|0;break a}b=b+262184|0}s=b;t=v[a+16>>2];b=0;while(1){if((b|0)!=2){f=b<<3;k=f+(e+24|0)|0;f=a+f|0;v[k+4>>2]=v[f+44>>2];v[k+8>>2]=v[f+48>>2];b=b+1|0;continue}break}m=v[a+40>>2];n=v[a+36>>2];b=v[a+4>>2];v[e+16>>2]=v[a>>2];v[e+20>>2]=b;w=v[a+32>>2];x=v[a+28>>2];y=v[a+72>>2];b=v[a+68>>2];z=b;A=b>>31;b=v[a+64>>2];C=b;D=b>>31;b=v[a+60>>2];E=b;F=b>>31;while(1){if(d){b=v[e+16>>2];G=((((v[e+20>>2]&2147483647)<<1|b>>>31)&2147483646)<<1)+t|0;b=(b>>>16&65520)+s|0;H=u[b+14>>1];g=u[b+12>>1];q=u[b+10>>1];r=u[b+8>>1];h=u[b+6>>1];k=u[b+4>>1];f=u[b+2>>1];b=u[b>>1];o=0;p=0;while(1){if((p|0)!=2){i=G+(p<<1)|0;v[(e+8|0)+(p<<2)>>2]=(((((((B(u[i-8>>1],f)+B(u[i-12>>1],b)|0)+B(u[i-4>>1],k)|0)+B(u[i>>1],h)|0)+B(u[i+4>>1],r)|0)+B(u[i+8>>1],q)|0)+B(g,u[i+12>>1])|0)+B(H,u[i+16>>1])|0)/32768;p=p+1|0;continue}break}while(1){if((o|0)!=2){q=(e+8|0)+(o<<2)|0;b=v[q>>2];g=(e+24|0)+(o<<3)|0;r=v[g+8>>2];h=v[g+4>>2];v[g+8>>2]=h;k=b<<8;b=k;b=Jka(E,F,b,b>>31);f=nb;i=g;g=b;b=Zb(h,-16777216,16776704);b=Jka(C,D,b,b>>31);h=g+b|0;g=nb+f|0;g=b>>>0>h>>>0?g+1|0:g;b=Zb(r,-16777216,16776704);f=Jka(z,A,b,b>>31);h=f+h|0;b=nb+g|0;b=f>>>0>h>>>0?b+1|0:b;f=h+8388608|0;b=f>>>0<8388608?b+1|0:b;b=Yc(f,b,24);v[i+4>>2]=b-(k&y);v[q>>2]=(b|0)/256;o=o+1|0;continue}break}n=n+x|0;v[c>>2]=v[c>>2]+B(v[e+8>>2],n>>12);m=m+w|0;v[c+4>>2]=v[c+4>>2]+B(v[e+12>>2],m>>12);Rb(e+16|0,l,j);c=c+8|0;d=d-1|0;continue}break}b=v[e+20>>2];v[a>>2]=v[e+16>>2];v[a+4>>2]=b;v[a+40>>2]=m;v[a+20>>2]=n>>12;v[a+36>>2]=n;v[a+24>>2]=m>>12;b=0;while(1){if((b|0)!=2){c=b<<3;d=c+a|0;c=c+(e+24|0)|0;v[d+44>>2]=v[c+4>>2];v[d+48>>2]=v[c+8>>2];b=b+1|0;continue}break}kb=e+48|0}function kia(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=C(0),h=0,i=C(0);d=kb-112|0;kb=d;c=kb-16|0;kb=c;e=b+16|0;$S(c+8|0,e);f=v[c+12>>2];nc(c,v[a>>2],v[a+8>>2],v[c+8>>2],v[c+12>>2]);h=v[c+4>>2];if((h|0)==(f|0)){$b(a,v[c+12>>2])}kb=c+16|0;if((f|0)!=(h|0)){Ub(e,0,128)}t[b+79|0]=0;t[b+143|0]=0;v[b+152>>2]=-2147483648;v[b+156>>2]=-2147483648;c=d- -64|0;ae(c,a,Bg(a));f=kc(d+88|0,c);Bb(c);v[23540]=0;c=S(202,f|0)|0;e=v[23540];v[23540]=0;a:{b:{if((e|0)==1){break b}v[23540]=0;R(285,b+4|0,c|0);c=v[23540];v[23540]=0;if((c|0)==1){break b}re(d+56|0,v[b+4>>2],v[b+8>>2]);v[23540]=0;Nk(459,d- -64|0,f,v[d+56>>2],v[d+60>>2]);c=v[23540];v[23540]=0;if((c|0)!=1){v[23540]=0;c=S(157,a|0)|0;e=v[23540];v[23540]=0;c:{if((e|0)==1){break c}v[23540]=0;U(190,d+32|0,a|0,c|0);a=v[23540];v[23540]=0;if((a|0)==1){break c}a=d+32|0;c=kc(d- -64|0,a);Bb(a);a=v[c>>2];v[23540]=0;a=S(178,a|0)|0;e=v[23540];v[23540]=0;d:{if((e|0)!=1){e:{f:{if(!a){break f}while(1){g:{a=v[c+8>>2];e=v[c>>2];v[23540]=0;a=W(156,e|0,a|0,5)|0;e=v[23540];v[23540]=0;if((e|0)==1){break e}if(!a){break f}v[23540]=0;Q(460,c|0,d+28|0)|0;a=v[23540];v[23540]=0;h:{if((a|0)!=1){a=4;if(!Sb(d+28|0,13579,4)){break h}if(!Sb(d+28|0,14140,4)){break h}v[23540]=0;a=S(157,c|0)|0;e=v[23540];v[23540]=0;if((e|0)!=1){break h}a=P()|0;O()|0;break d}a=P()|0;O()|0;break d}v[23540]=0;U(190,d+8|0,c|0,a|0);a=v[23540];v[23540]=0;i:{j:{k:{if((a|0)!=1){a=d+8|0;e=kc(d+32|0,a);Bb(a);if(Sb(d+28|0,13579,4)){break k}v[23540]=0;g=C(Ca(461,e|0));a=v[23540];v[23540]=0;if((a|0)==1){break g}z[d+8>>2]=g;v[d+4>>2]=0;v[d>>2]=1065353216;g=z[gu(d+8|0,d+4|0,d)>>2];z[b+144>>2]=g;i=C(D(g));if((i<C(1.1754943508222875e-38)^-1)&(!(i>=C(N))&g==g)){break j}v[b+144>>2]=0;break j}a=P()|0;O()|0;break d}if(Sb(d+28|0,14140,4)){break j}v[23540]=0;a=S(157,e|0)|0;h=v[23540];v[23540]=0;if((h|0)==1){break i}v[b+148>>2]=a}Bb(e);continue}}break}a=P()|0;O()|0;Bb(e);break d}Bb(c);Bb(f);kb=d+112|0;return}a=P()|0;O()|0;break d}a=P()|0;O()|0}Bb(c);break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;break a}a=P()|0;O()|0}Bb(f);T(a|0);L()}function Vca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,w=0,x=0,y=0,z=0,A=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;e=kb-48|0;kb=e;a:{b:{c:{j=v[a+12>>2];l=v[a+8>>2];d:{if((j|0)<=1&l>>>0<=805306368|(j|0)<=0){if((j|0)>=-2&l>>>0>=3489660928|(j|0)>-2){break c}if((j|0)==-2&l>>>0>2147483647|j>>>0>4294967294){break d}break b}if((j|0)==1&l>>>0>2147483648|j>>>0>1){break b}}b=b+196648|0;break a}b=b+131112|0;break a}b=b+262184|0}s=b;w=v[a+16>>2];b=0;while(1){if((b|0)!=2){f=b<<3;k=f+(e+24|0)|0;f=a+f|0;v[k+4>>2]=v[f+44>>2];v[k+8>>2]=v[f+48>>2];b=b+1|0;continue}break}m=v[a+40>>2];n=v[a+36>>2];b=v[a+4>>2];v[e+16>>2]=v[a>>2];v[e+20>>2]=b;x=v[a+32>>2];y=v[a+28>>2];z=v[a+72>>2];b=v[a+68>>2];A=b;C=b>>31;b=v[a+64>>2];D=b;E=b>>31;b=v[a+60>>2];F=b;G=b>>31;while(1){if(d){b=v[e+16>>2];H=(((v[e+20>>2]&2147483647)<<1|b>>>31)&-2)+w|0;b=(b>>>16&65520)+s|0;I=u[b+14>>1];g=u[b+12>>1];q=u[b+10>>1];r=u[b+8>>1];h=u[b+6>>1];k=u[b+4>>1];f=u[b+2>>1];b=u[b>>1];o=0;p=0;while(1){if((p|0)!=2){i=p+H|0;v[(e+8|0)+(p<<2)>>2]=(((((((B(t[i-4|0],f)+B(t[i-6|0],b)|0)+B(t[i-2|0],k)|0)+B(t[i|0],h)|0)+B(t[i+2|0],r)|0)+B(t[i+4|0],q)|0)+B(g,t[i+6|0])|0)+B(I,t[i+8|0])<<8)/32768;p=p+1|0;continue}break}while(1){if((o|0)!=2){q=(e+8|0)+(o<<2)|0;b=v[q>>2];g=(e+24|0)+(o<<3)|0;r=v[g+8>>2];h=v[g+4>>2];v[g+8>>2]=h;k=b<<8;b=k;b=Jka(F,G,b,b>>31);f=nb;i=g;g=b;b=Zb(h,-16777216,16776704);b=Jka(D,E,b,b>>31);h=g+b|0;g=nb+f|0;g=b>>>0>h>>>0?g+1|0:g;b=Zb(r,-16777216,16776704);f=Jka(A,C,b,b>>31);h=f+h|0;b=nb+g|0;b=f>>>0>h>>>0?b+1|0:b;f=h+8388608|0;b=f>>>0<8388608?b+1|0:b;b=Yc(f,b,24);v[i+4>>2]=b-(k&z);v[q>>2]=(b|0)/256;o=o+1|0;continue}break}n=n+y|0;v[c>>2]=v[c>>2]+B(v[e+8>>2],n>>12);m=m+x|0;v[c+4>>2]=v[c+4>>2]+B(v[e+12>>2],m>>12);Rb(e+16|0,l,j);c=c+8|0;d=d-1|0;continue}break}b=v[e+20>>2];v[a>>2]=v[e+16>>2];v[a+4>>2]=b;v[a+40>>2]=m;v[a+20>>2]=n>>12;v[a+36>>2]=n;v[a+24>>2]=m>>12;b=0;while(1){if((b|0)!=2){c=b<<3;d=c+a|0;c=c+(e+24|0)|0;v[d+44>>2]=v[c+4>>2];v[d+48>>2]=v[c+8>>2];b=b+1|0;continue}break}kb=e+48|0}function p6(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0;j=kb-96|0;kb=j;a:{b:{c:{k=Bp(1,32);d:{e:{if(!k){a=mm(ba(4)|0);v[23540]=0;U(119,a|0,92756,26);a=v[23540];v[23540]=0;if((a|0)!=1){break a}i=V(0)|0;O()|0;break e}v[k+12>>2]=f;v[k+8>>2]=e;v[k+4>>2]=d;v[k>>2]=c?c:927;c=Yf(j+80|0);f:{g:{h:{if(!i){break h}while(1){d=v[i>>2];if(!d){break h}e=v[i+4>>2];i:{if(e){v[23540]=0;d=Q(55,j- -64|0,d|0)|0;f=v[23540];v[23540]=0;j:{if((f|0)!=1){v[23540]=0;f=Q(938,c|0,d|0)|0;l=v[23540];v[23540]=0;if((l|0)==1){break j}v[23540]=0;R(270,f|0,e|0);e=v[23540];v[23540]=0;if((e|0)==1){break j}break i}i=V(0)|0;O()|0;break f}i=V(0)|0;O()|0;zb(d);break f}v[23540]=0;d=Q(55,j+48|0,d|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break g}Js(c,d)}zb(d);i=i+8|0;continue}}d=v[a+8>>2];e=v[a+4>>2];f=v[a>>2];v[23540]=0;a=S(812,104)|0;i=v[23540];v[23540]=0;k:{l:{m:{if((i|0)!=1){v[j+44>>2]=d;v[j+40>>2]=e;v[j+36>>2]=f;v[j+32>>2]=b;b=v[k+4>>2];d=v[k>>2];v[23540]=0;b=Q(939,d|0,b|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break m}v[j+16>>2]=b;b=v[eg(j+24|0,j+16|0)>>2];d=v[j+44>>2];v[j+8>>2]=v[j+40>>2];v[j+12>>2]=d;v[23540]=0;d=v[j+36>>2];v[j>>2]=v[j+32>>2];v[j+4>>2]=d;b=fa(969,a|0,j|0,b|0,c|0)|0;d=v[23540];v[23540]=0;if((d|0)!=1){break k}i=V(0)|0;O()|0;De(j+16|0);break l}i=V(0)|0;O()|0;break f}i=V(0)|0;O()|0}Mb(a);break f}v[k+28>>2]=b;De(j+16|0);a=v[k+28>>2];v[k+24>>2]=a?a+8|0:0;kl(c);break d}i=V(0)|0;O()|0}kl(c);_(i|0)|0;v[23540]=0;X(933,11329,k|0,g|0,h|0);a=v[23540];v[23540]=0;if((a|0)!=1){v[23540]=0;Z(18);a=v[23540];v[23540]=0;if((a|0)!=1){a=v[k+28>>2];if(a){ob[v[v[a>>2]+4>>2]](a)}v[k+24>>2]=0;v[k+28>>2]=0;a=v[k+20>>2];if(a){Mb(a);v[k+20>>2]=0}Mb(k);k=0;break d}i=V(0)|0;O()|0;break e}i=V(0)|0;O()|0;v[23540]=0;Z(18);a=v[23540];v[23540]=0;if((a|0)==1){break b}}_(i|0)|0;k=0;v[23540]=0;X(933,11329,0,g|0,h|0);a=v[23540];v[23540]=0;if((a|0)==1){break c}$()}kb=j+96|0;return k|0}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)==1){break b}T(a|0);L()}V(0)|0;O()|0;Vb()}L()}function E6(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=kb-80|0;kb=e;v[e+76>>2]=c;v[e+72>>2]=b;a:{if(!c){break a}g=w[cl(b,c)|0];if((g|0)==33){d=1}else{if((g|0)!=63){break a}d=0}jl(e+48|0,b,c,c-1|0);b=v[e+52>>2];v[e+72>>2]=v[e+48>>2];v[e+76>>2]=b}c=e+48|0;Xd(c);b=v[e+48>>2];Xd(e+32|0);b=bl(b,v[e+36>>2],e+72|0);Xd(c);b:{c:{d:{e:{if((b|0)==v[e+52>>2]){b=v[e+72>>2];c=v[e+76>>2];a=rc(e- -64|0,21688);if(Qc(b,c,v[a>>2],v[a+4>>2])){a=ba(8)|0;v[23540]=0;b=Q(55,e+48|0,10501)|0;c=v[23540];v[23540]=0;if((c|0)==1){break d}a=tc(a,b);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break b}c=P()|0;O()|0;zb(b);break c}f=0;if(!d){break e}a=ba(8)|0;v[23540]=0;b=Mh(e+32|0,v[e+72>>2],v[e+76>>2]);c=v[23540];v[23540]=0;f:{g:{h:{if((c|0)!=1){v[23540]=0;U(961,e+48|0,17703,b|0);c=v[23540];v[23540]=0;if((c|0)==1){break h}d=0;c=tc(a,e+48|0);v[23540]=0;U(119,c|0,62752,950);c=v[23540];v[23540]=0;if((c|0)!=1){break b}c=P()|0;O()|0;zb(e+48|0);break g}c=P()|0;O()|0;break f}c=P()|0;d=1;O()|0}zb(b);if(!d){break c}}ca(a|0);break c}if(v[b+4>>2]!=2){a=ba(8)|0;v[23540]=0;b=Q(55,e+48|0,11573)|0;c=v[23540];v[23540]=0;if((c|0)!=1){a=tc(a,b);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break b}c=P()|0;O()|0;zb(b);break c}c=P()|0;O()|0;ca(a|0);break c}b=v[e+72>>2];c=v[e+76>>2];d=rc(e+24|0,21688);if(Qc(b,c,v[d>>2],v[d+4>>2])){a=ba(8)|0;v[23540]=0;b=Q(55,e+48|0,10501)|0;c=v[23540];v[23540]=0;if((c|0)!=1){a=tc(a,b);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break b}c=P()|0;O()|0;zb(b);break c}c=P()|0;O()|0;ca(a|0);break c}d=rc(e+16|0,7719);if(Qc(b,c,v[d>>2],v[d+4>>2])){f=1;if(!Qd(w[a+28|0])){break e}f=65536/+y[v[a+24>>2]+480244>>2];break e}d=rc(e+8|0,7771);if(Qc(b,c,v[d>>2],v[d+4>>2])){f=1;if(!Qd(w[a+28|0])){break e}f=+y[v[a+24>>2]+480240>>2]*152587890625e-16;break e}d=b;b=rc(e,7789);f=0;if(!Qc(d,c,v[b>>2],v[b+4>>2])){break e}f=+y[v[a+24>>2]+480236>>2]*152587890625e-16}kb=e+80|0;return+f}c=P()|0;O()|0;ca(a|0)}T(c|0)}L()}function LO(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,w=0,x=0,y=0;c=kb-176|0;kb=c;i=1;p=2;d=v[a+12>>2];q=1<<d;m=q;a:while(1){if(d>>>0>=p>>>0){m=m>>>2|0;w=B(i,3);x=i<<1;h=0;b:while(1){if((h|0)==(m|0)){p=p+2|0;i=i<<2;d=v[a+12>>2];continue a}d=v[a>>2];e=Kd(d,h<<1);iM(c+160|0,A[e>>3],A[e+8>>3]);d=Kd(d,h);iM(c+144|0,A[d>>3],A[d+8>>3]);xi(c+128|0,A[c+144>>3],A[c+152>>3],A[c+160>>3],A[c+168>>3]);d=h<<p;e=i+d|0;y=d>>>0>e>>>0?d:e;while(1)if((d|0)==(y|0)){h=h+1|0;continue b}else{f=v[b>>2];e=Kd(f,d);g=e+8|0;j=v[g+4>>2];v[c+120>>2]=v[g>>2];v[c+124>>2]=j;g=v[e+4>>2];v[c+112>>2]=v[e>>2];v[c+116>>2]=g;k=d+i|0;g=Kd(f,k);n=A[g+8>>3];o=A[g>>3];r=d+x|0;g=Kd(f,r);j=v[g+12>>2];v[c+104>>2]=v[g+8>>2];v[c+108>>2]=j;j=v[g+4>>2];v[c+96>>2]=v[g>>2];v[c+100>>2]=j;s=d+w|0;f=Kd(f,s);t=A[f+8>>3];u=A[f>>3];g=c+80|0;f=c+112|0;fl(g,f,o,n);j=c- -64|0;lj(j,f,o,n);l=c+96|0;fl(c+48|0,l,u,t);f=c+16|0;lj(f,l,u,t);xi(c+32|0,0,1,A[c+16>>3],A[c+24>>3]);fl(f,g,A[c+48>>3],A[c+56>>3]);l=v[c+28>>2];v[e+8>>2]=v[c+24>>2];v[e+12>>2]=l;l=v[c+20>>2];v[e>>2]=v[c+16>>2];v[e+4>>2]=l;fl(c,j,A[c+32>>3],A[c+40>>3]);xi(f,A[c+160>>3],A[c+168>>3],A[c>>3],A[c+8>>3]);e=Kd(v[b>>2],k);k=v[c+28>>2];v[e+8>>2]=v[c+24>>2];v[e+12>>2]=k;k=v[c+20>>2];v[e>>2]=v[c+16>>2];v[e+4>>2]=k;lj(c,g,A[c+48>>3],A[c+56>>3]);xi(f,A[c+144>>3],A[c+152>>3],A[c>>3],A[c+8>>3]);e=Kd(v[b>>2],r);g=v[c+28>>2];v[e+8>>2]=v[c+24>>2];v[e+12>>2]=g;g=v[c+20>>2];v[e>>2]=v[c+16>>2];v[e+4>>2]=g;lj(c,j,A[c+32>>3],A[c+40>>3]);xi(f,A[c+128>>3],A[c+136>>3],A[c>>3],A[c+8>>3]);e=Kd(v[b>>2],s);f=v[c+28>>2];v[e+8>>2]=v[c+24>>2];v[e+12>>2]=f;f=v[c+20>>2];v[e>>2]=v[c+16>>2];v[e+4>>2]=f;d=d+1|0;continue}}}break}c:{if(!(d&1)){break c}i=q>>>1|0;d=0;while(1){if((d|0)==(i|0)){break c}h=v[b>>2];a=Kd(h,d+i|0);m=Kd(h,d);n=A[a>>3];o=A[a+8>>3];lj(c+160|0,m,n,o);h=v[c+172>>2];v[a+8>>2]=v[c+168>>2];v[a+12>>2]=h;h=v[c+164>>2];v[a>>2]=v[c+160>>2];v[a+4>>2]=h;dy(Kd(v[b>>2],d),n,o);d=d+1|0;continue}}kb=c+176|0}function it(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;f=kb-16|0;kb=f;e=B(c,872)+b|0;h=e+704|0;v[h>>2]=v[h>>2]|524288;a:{b:{if(!(v[a+480208>>2]&8)){Db(f+8|0,a+1074312|0,15);if(Cb(v[v[f+8>>2]>>2],v[f+12>>2])){break b}}if(v[a+480180>>2]!=268435456){break a}}g=B(c,872)+b|0;d=d?d:w[(B(c,872)+b|0)+1427|0];t[g+1427|0]=d;t[g+1428|0]=d}if(d){u[(B(c,872)+b|0)+1384>>1]=d}c:{d:{g=e+616|0;j=v[g+656>>2];if(xj(j)){a=x[(B(c,872)+b|0)+1384>>1];if(!a){break d}e=0;d=v[b+16>>2];e=d?v[(B(c,872)+b|0)+1472>>2]:e;k=0-a|0;l=a;i=B(c,872)+b|0;g=i+1324|0;a=v[g>>2];m=(+(d>>>0)+1)*+(((a|0)<0?k:l)|0)/+y[b+40>>2];e:{if(D(m)<2147483648){d=~~m;break e}d=-2147483648}i=i+1472|0;v[i>>2]=d;if(w[h+2|0]&16){d=B(v[v[j+44>>2]+36>>2]+1|0,d);v[i>>2]=d}d=d-e|0;h=d>>31;e=a>>31;if((e^a)-e>>>0<=(d^h)-h>>>0){if(!a){break d}b=B(c,872)+b|0;c=b+1468|0;v[c>>2]=a+v[c>>2];v[g>>2]=0;a=b+1467|0;t[a|0]=w[a|0]|64;a=0;break c}b=B(c,872)+b|0;c=b+1468|0;v[c>>2]=d+v[c>>2];v[g>>2]=a-d;a=b+1467|0;t[a|0]=w[a|0]|64;break d}h=1;j=B(c,872)+b|0;e=j+1467|0;f:{if(!(t[e|0]&1)){break f}d=v[a+480180>>2];if(d&524352){break f}if(v[b+40>>2]==1){Db(f+8|0,a+1074312|0,6);if(Cb(v[v[f+8>>2]>>2],v[f+12>>2])){break f}d=v[a+480180>>2]}h=0;if((d|0)!=8){break f}h=(w[a+480208|0]&2)>>>1|0}i=v[a+480180>>2];d=x[j+1384>>1];if(!((i|0)!=268435456|d>>>0<240)){h=t[e|0]&1;d=d-240|0}d=B((i|0)==64?2:4,d);j=B(c,872)+b|0;b=j+1316|0;g:{if(!v[b>>2]){break g}c=j+1324|0;if(!v[c>>2]|!h){break g}i=mj(a)?d:0-d|0;l=v[b>>2];k=v[c>>2];if(!(w[e|0]&16?0:(l|0)>=(k|0))){hk(a,g,b,i,1);c=v[c>>2];if((c|0)>=v[b>>2]){break g}v[b>>2]=c;break g}if((l|0)<=(k|0)){break g}hk(a,g,b,0-i|0,1);g=v[b>>2];c=v[c>>2];h:{if((g|0)<(c|0)){v[b>>2]=c;break h}if((c|0)!=(g|0)){break g}}Db(f+8|0,a+1074312|0,112);if(!Cb(v[v[f+8>>2]>>2],v[f+12>>2])){break g}t[e|0]=w[e|0]|16}c=v[b>>2];b=j+1324|0;i:{if((c|0)!=v[b>>2]){break i}Db(f+8|0,a+1074312|0,25);if(!Cb(v[v[f+8>>2]>>2],v[f+12>>2])&v[a+480180>>2]!=1){break i}v[b>>2]=0}a=h?d:0;break c}a=0}kb=f+16|0;return a}function ze(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;h=kb-16|0;kb=h;e=v[a>>2];a:{if(pc(e,v[a+4>>2])){break a}g=v[b+4>>2];if(g>>>0>=y[a+12>>2]){break a}c=x[b+8>>1];i=v[v[a+48>>2]+12>>2];f=Og(i);if(c>>>0>=f>>>0&(c|0)!=65535){break a}d=(c|0)==65535;l=d?f-1|0:c;f=g;g=d?0:c;c=jd(e,i,f,g);f=w[b+12|0];j=f&4;b:{c:{if(f&2){break c}k=w[b+10|0];e=c;d=g;while(1){if((d&65535)>>>0>(l&65535)>>>0){break c}d:{if(!j){if((k|0)!=w[e+3|0]){break d}break b}if((k|0)==w[e+2|0]){break b}}e=e+6|0;d=d+1|0;continue}}k=l&65535;d=c;e=g;while(1){if(k>>>0>=(e&65535)>>>0){e:{if(!j){if(w[d+3|0]){break e}t[d+3|0]=w[b+10|0];t[d+5|0]=w[b+11|0];break b}if(w[d+2|0]){break e}t[d+2|0]=w[b+10|0];t[d+4|0]=w[b+11|0];break b}d=d+6|0;e=e+1|0;continue}break}f:{if(!(f&1)){break f}d=v[i+480180>>2]&2;g:{h:{i:{if(!j){while(1){if((g&65535)>>>0<=(l&65535)>>>0){j:{k:{switch(w[c+3|0]-9|0){case 4:if(!fU(v[v[i+8>>2]+88>>2])){break j}d=1;t[c+2|0]=1;t[c+4|0]=w[c+5|0];t[c+3|0]=w[b+10|0];t[c+5|0]=w[b+11|0];break a;case 0:break k;default:break j}}l:{if(d){e=w[c+5|0];if(e>>>0>128){break j}t[c+2|0]=2;t[c+3|0]=w[b+10|0];a=1;break l}t[c+2|0]=2;t[c+3|0]=w[b+10|0];e=w[c+5|0];a=2}t[c+4|0]=a+e>>>a;t[c+5|0]=w[b+11|0];break b}c=c+6|0;g=g+1|0;continue}break}if(!j){break i}}e=w[b+11|0];g=13;m:{switch(w[b+10|0]-1|0){case 1:g=9;e=Jl(B(d?2:4,e));break;case 0:break m;default:break g}}t[b+11|0]=e;t[b+10|0]=g;f=f&254;break h}t[h+15|0]=0;t[h+14|0]=0;g=b;c=!d;d=w[b+10|0];n:{if(!(c|(d|0)!=9)){e=w[b+11|0];if(e>>>0>128){break g}d=2;c=e>>>1|0;break n}e=h+8|0;Qq(e,d,w[b+11|0],1);tB(h,h+15|0,h+14|0);sB(h,e);d=w[h+15|0];if(!d){f=w[b+12|0];break g}f=w[b+12|0];c=w[h+14|0]}t[g+11|0]=c;t[b+10|0]=d;f=f&254}t[b+12|0]=f}d=1;if(f&1){break f}t[b+12|0]=f^4;if(ze(a,b)){break a}}d=0;o:{p:{switch(v[b>>2]-1|0){case 0:c=v[b+4>>2]+1|0;if(c>>>0>=y[a+12>>2]){break a}v[b+4>>2]=c;break o;case 1:break p;default:break a}}c=v[b+4>>2];if(!c){break a}v[b+4>>2]=c-1}t[b+12|0]=w[b+12|0]|1;d=ze(a,b);break a}d=1}kb=h+16|0;return d}function rca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,C=0,D=0,E=0,F=0,G=0,H=0;f=kb-48|0;kb=f;q=v[a+16>>2];r=kg(b+327720|0,v[b+20>>2],(v[a+88>>2]&16384)>>>14|0);b=0;m=v[a+128>>2];if(m){e=v[a+8>>2];j=v[a+12>>2];n=lg(e,j,m);o=nb;g=v[a+76>>2];Qf(v[a>>2],v[a+4>>2],qf(e,j,d),nb);j=g>>>0<nb>>>0?d:0}else{j=0}i=a+112|0;while(1){if((b|0)!=2){e=b<<3;h=e+(f+16|0)|0;e=a+e|0;v[h+4>>2]=v[e+44>>2];v[h+8>>2]=v[e+48>>2];b=b+1|0;continue}break}s=v[a+24>>2];t=v[a+20>>2];b=v[a+4>>2];v[f+8>>2]=v[a>>2];v[f+12>>2]=b;w=v[a+8>>2];x=v[a+12>>2];a:while(1){if(d){d=d-1|0;b=v[f+12>>2];e=v[f+8>>2];v[f+40>>2]=e;v[f+44>>2]=0;j=j-1|0;n=j?n:0;o=j?o:0;l=((((b&2147483647)<<1|e>>>31)&2147483646)<<1)+q|0;b=m;while(1)if((b|0)<=0){Rb(i,v[a+120>>2],v[a+124>>2]);h=v[a+116>>2];if(h){b=(v[f+44>>2]&2147483647)<<1|v[f+40>>2]>>>31;Sd(i,(u[(b<<1|2)+l>>1]+u[l+((b&2147483646)<<1)>>1]|0)/8<<16>>16);Rd(i,h);v[i>>2]=v[i>>2];v[i+4>>2]=0}b=jg(i,r);v[f+4>>2]=b;v[f>>2]=b;y=v[a+72>>2];b=v[a+68>>2];z=b;A=b>>31;b=v[a+64>>2];C=b;D=b>>31;b=v[a+60>>2];E=b;F=b>>31;b=0;while(1){if((b|0)!=2){p=(b<<2)+f|0;e=v[p>>2];g=(f+16|0)+(b<<3)|0;G=v[g+8>>2];k=v[g+4>>2];v[g+8>>2]=k;l=e<<8;e=l;e=Jka(E,F,e,e>>31);h=nb;H=g;g=e;e=Zb(k,-16777216,16776704);e=Jka(C,D,e,e>>31);k=g+e|0;g=nb+h|0;g=e>>>0>k>>>0?g+1|0:g;e=Zb(G,-16777216,16776704);h=Jka(z,A,e,e>>31);k=h+k|0;e=nb+g|0;e=h>>>0>k>>>0?e+1|0:e;h=k+8388608|0;e=h>>>0<8388608?e+1|0:e;e=Yc(h,e,24);v[H+4>>2]=e-(l&y);v[p>>2]=(e|0)/256;b=b+1|0;continue}break}v[c>>2]=v[c>>2]+B(v[f>>2],t);v[c+4>>2]=v[c+4>>2]+B(s,v[f+4>>2]);Rb(f+8|0,w,x);c=c+8|0;continue a}else{e=(v[f+44>>2]&2147483647)<<1|v[f+40>>2]>>>31;Sd(i,(u[(e<<1|2)+l>>1]+u[l+((e&2147483646)<<1)>>1]|0)/8<<16>>16);Rd(i,4);Rb(f+40|0,n,o);b=b-1|0;continue}}break}b=v[f+12>>2];v[a>>2]=v[f+8>>2];v[a+4>>2]=b;b=0;while(1){if((b|0)!=2){c=b<<3;d=c+a|0;c=c+(f+16|0)|0;v[d+44>>2]=v[c+4>>2];v[d+48>>2]=v[c+8>>2];b=b+1|0;continue}break}kb=f+48|0}function pK(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0;j=kb-96|0;kb=j;a:{b:{c:{d:{e:{f:{k=Bp(1,28);if(!k){a=mm(ba(4)|0);v[23540]=0;U(119,a|0,92756,26);a=v[23540];v[23540]=0;if((a|0)!=1){break a}break f}v[k+12>>2]=f;v[k+8>>2]=e;v[k+4>>2]=d;v[k>>2]=c?c:927;c=Yf(j+80|0);g:{h:{i:{if(!i){break i}while(1){d=v[i>>2];if(!d){break i}e=v[i+4>>2];j:{if(e){v[23540]=0;d=Q(55,j- -64|0,d|0)|0;f=v[23540];v[23540]=0;k:{if((f|0)!=1){v[23540]=0;f=Q(938,c|0,d|0)|0;l=v[23540];v[23540]=0;if((l|0)==1){break k}v[23540]=0;R(270,f|0,e|0);e=v[23540];v[23540]=0;if((e|0)==1){break k}break j}i=V(0)|0;O()|0;break g}i=V(0)|0;O()|0;zb(d);break g}v[23540]=0;d=Q(55,j+48|0,d|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break h}Js(c,d)}zb(d);i=i+8|0;continue}}d=v[a+8>>2];e=v[a+4>>2];f=v[a>>2];v[23540]=0;a=S(812,80)|0;i=v[23540];v[23540]=0;l:{m:{n:{if((i|0)!=1){v[j+44>>2]=d;v[j+40>>2]=e;v[j+36>>2]=f;v[j+32>>2]=b;b=v[k+4>>2];d=v[k>>2];v[23540]=0;b=Q(939,d|0,b|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break n}v[j+16>>2]=b;b=v[eg(j+24|0,j+16|0)>>2];d=v[j+44>>2];v[j+8>>2]=v[j+40>>2];v[j+12>>2]=d;v[23540]=0;d=v[j+36>>2];v[j>>2]=v[j+32>>2];v[j+4>>2]=d;b=fa(940,a|0,j|0,b|0,c|0)|0;d=v[23540];v[23540]=0;if((d|0)!=1){break l}i=V(0)|0;O()|0;De(j+16|0);break m}i=V(0)|0;O()|0;break g}i=V(0)|0;O()|0}Mb(a);break g}v[k+24>>2]=b;De(j+16|0);kl(c);i=k;break d}i=V(0)|0;O()|0}kl(c);_(i|0)|0;v[23540]=0;X(933,15239,k|0,g|0,h|0);a=v[23540];v[23540]=0;if((a|0)!=1){v[23540]=0;Z(18);a=v[23540];v[23540]=0;if((a|0)==1){break f}a=v[k+24>>2];if(a){Mb(Is(a))}i=0;v[k+24>>2]=0;a=v[k+20>>2];if(a){Mb(a);v[k+20>>2]=0}Mb(k);break d}i=V(0)|0;O()|0;v[23540]=0;Z(18);a=v[23540];v[23540]=0;if((a|0)!=1){break e}break b}i=V(0)|0;O()|0}_(i|0)|0;i=0;v[23540]=0;X(933,15239,0,g|0,h|0);a=v[23540];v[23540]=0;if((a|0)==1){break c}$()}kb=j+96|0;return i|0}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)==1){break b}T(a|0);L()}V(0)|0;O()|0;Vb()}L()}function MG(a,b,c,d){var e=0,f=0,g=0,h=0,i=0;e=v[b>>2];a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{if(!d){break k}h=v[d>>2];if(!h){break k}if(!a){g=c;break j}v[d>>2]=0;g=c;break i}l:{if(!v[v[116042]>>2]){if(!a){break l}if(!c){break a}d=c;while(1){g=t[e|0];if(g){v[a>>2]=g&57343;a=a+4|0;e=e+1|0;d=d-1|0;if(d){continue}break a}break}v[a>>2]=0;v[b>>2]=0;return c-d|0}if(!a){g=c;d=0;break g}g=c;d=0;break h}return Pg(e)}d=1;break g}d=1}while(1){if(!d){if(!g){break a}while(1){m:{f=w[e|0];h=f-1|0;n:{o:{if(h>>>0>126){d=f;break o}if(e&3|g>>>0<5){break n}p:{while(1){d=v[e>>2];if((d|d-16843009)&-2139062144){break p}v[a>>2]=d&255;v[a+4>>2]=w[e+1|0];v[a+8>>2]=w[e+2|0];v[a+12>>2]=w[e+3|0];a=a+16|0;e=e+4|0;g=g-4|0;if(g>>>0>4){continue}break}d=w[e|0]}f=d&255;h=f-1|0}if(h>>>0>126){break m}}v[a>>2]=f;a=a+4|0;e=e+1|0;g=g-1|0;if(g){continue}break a}break}f=f-194|0;if(f>>>0>50){break e}e=e+1|0;h=v[(f<<2)+83600>>2];d=1;continue}d=w[e|0];f=d>>>3|0;if((f-16|f+(h>>26))>>>0>7){break f}q:{r:{f=e+1|0;d=d-128|h<<6;s:{if((d|0)>=0){break s}i=w[f|0]-128|0;if(i>>>0>63){break r}f=e+2|0;d=i|d<<6;if((d|0)>=0){break s}f=w[f|0]-128|0;if(f>>>0>63){break r}d=f|d<<6;f=e+3|0}e=f;v[a>>2]=d;g=g-1|0;a=a+4|0;break q}v[116016]=25;e=e-1|0;break c}d=0;continue}}while(1){t:{if(!d){u:{v:{d=w[e|0];if(!(e&3|d-1>>>0>126)){d=v[e>>2];if(!((d|d-16843009)&-2139062144)){break v}}f=e;break u}while(1){g=g-4|0;d=v[e+4>>2];f=e+4|0;e=f;if(!((d-16843009|d)&-2139062144)){continue}break}}e=d&255;if(e-1>>>0<=126){e=f+1|0;g=g-1|0;break t}h=e-194|0;if(h>>>0>50){e=f;break e}e=f+1|0;h=v[(h<<2)+83600>>2];d=1;continue}d=w[e|0]>>>3|0;if((d-16|d+(h>>26))>>>0>7){break f}d=e+1|0;w:{if(!(h&33554432)){break w}if((w[d|0]&192)!=128){e=e-1|0;break d}d=e+2|0;if(!(h&524288)){break w}if((w[d|0]&192)!=128){e=e-1|0;break d}d=e+3|0}e=d;g=g-1|0}d=0;continue}}e=e-1|0;if(h){break d}d=w[e|0]}if(d&255){break d}if(a){v[a>>2]=0;v[b>>2]=0}return c-g|0}v[116016]=25;if(!a){break b}}v[b>>2]=e}return-1}v[b>>2]=e;return c}function ti(a,b,c,d,e,f){var g=0,h=0,i=0,j=C(0),k=C(0),l=0,m=0,n=C(0),o=C(0),p=C(0),q=0,r=C(0);m=ob[v[v[a>>2]+140>>2]](a)|0;g=v[a+20>>2];h=m?h:w[g+25|0];j=z[g+144>>2];k=C(1);if(!(ob[v[v[a>>2]+140>>2]](a)|0)){k=z[v[a+20>>2]+144>>2]}j=C(C(1)-j);a:{if((ob[v[v[a>>2]+156>>2]](a)|0)<=0){break a}if(!jL(w[v[a+20>>2]+24|0])){break a}j=C(C(j+j)+C(-1));k=C(-j)}n=z[a+4196>>2];k=C(k*n);j=C(j*n);g=0;l=v[a+44>>2];m=Jc(l,0);l=Jc(l,1);b:{c:{d:{e:{f:{g:{h:{h=h&255;switch(h|0){case 0:break h;case 5:break c;case 4:break d;case 3:break e;case 2:break f;case 1:break g;default:break b}}while(1){if((f|0)==(h|0)){break b}g=h<<2;i=g+b|0;z[i>>2]=z[i>>2]+C(C(z[d+g>>2]*j)+C(k*z[g+m>>2]));i=c+g|0;z[i>>2]=z[i>>2]+C(C(z[e+g>>2]*j)+C(k*z[g+l>>2]));h=h+1|0;continue}}while(1){if((f|0)==(g|0)){break b}h=g<<2;i=h+b|0;z[i>>2]=z[i>>2]+C(z[h+m>>2]-C(z[d+h>>2]*j));i=c+h|0;z[i>>2]=z[i>>2]+C(z[h+l>>2]-C(z[e+h>>2]*j));g=g+1|0;continue}}while(1){if((f|0)==(g|0)){break b}h=g<<2;i=h+b|0;z[i>>2]=z[i>>2]+C(z[d+h>>2]-C(z[h+m>>2]*k));i=c+h|0;z[i>>2]=z[i>>2]+C(z[e+h>>2]-C(z[h+l>>2]*k));g=g+1|0;continue}}while(1){if((f|0)==(g|0)){break b}h=g<<2;i=h+b|0;z[i>>2]=z[i>>2]-C(z[d+h>>2]-C(z[h+m>>2]*j));i=c+h|0;z[i>>2]=z[i>>2]-C(z[e+h>>2]-C(z[h+l>>2]*j));g=g+1|0;continue}}while(1){if((f|0)==(g|0)){break b}h=g<<2;i=h+b|0;k=z[i>>2];q=i;r=k;n=z[h+m>>2];i=c+h|0;o=z[i>>2];p=z[h+l>>2];k=C(C(C(C(k+n)+o)+p)*C(.5));z[q>>2]=r-C(C(k+C(k-C(z[d+h>>2]*j)))-n);z[i>>2]=o-C(C(k+C(k-C(z[e+h>>2]*j)))-p);g=g+1|0;continue}}g=jL(w[v[a+20>>2]+24|0]);j=g?C(j*C(.5)):j;k=g?C(k*C(.5)):k;h=0;while(1){if((f|0)==(h|0)){break b}g=h<<2;i=g+b|0;n=C(z[d+g>>2]-z[g+m>>2]);o=C(z[g+l>>2]-z[e+g>>2]);z[i>>2]=z[i>>2]+C(C(j*n)+C(k*o));g=c+g|0;z[g>>2]=z[g>>2]+C(C(k*n)+C(j*o));h=h+1|0;continue}}i:{if(!((w[v[a+20>>2]+24|0]&4)>>>2|0)){break i}if(ob[v[v[a>>2]+140>>2]](a)|0){break i}g=0;while(1){if((f|0)==(g|0)){break i}a=g<<2;d=a+b|0;z[d>>2]=z[a+m>>2]+z[d>>2];d=a+c|0;z[d>>2]=z[a+l>>2]+z[d>>2];g=g+1|0;continue}}}function hh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;a:{b:{c:{switch(b|0){case 1:b=0;a=Nb(a);d=Hb(c);v[23540]=0;R(46,a|0,d|0);d=v[23540];v[23540]=0;d:{if((d|0)!=1){e:{while(1){if(Hb(c)>>>0>b>>>0){d=v[qj(c,b)>>2];v[23540]=0;R(47,a|0,(d>>>0<128?d:63)<<24>>24);d=v[23540];v[23540]=0;if((d|0)==1){break e}b=b+1|0;continue}break}break d}}break a}return;case 2:b=0;a=Nb(a);d=Hb(c);v[23540]=0;R(46,a|0,d|0);d=v[23540];v[23540]=0;f:{if((d|0)!=1){g:{while(1){if(Hb(c)>>>0>b>>>0){d=v[qj(c,b)>>2];v[23540]=0;R(47,a|0,(d>>>0<256?d:63)<<24>>24);d=v[23540];v[23540]=0;if((d|0)==1){break g}b=b+1|0;continue}break}break f}}break a}return;case 3:ol(a,c,49616);return;case 5:ol(a,c,50640);return;case 4:ol(a,c,51664);return;case 6:ol(a,c,52688);return;case 7:ol(a,c,53712);return;case 8:ol(a,c,54736);return;case 9:ol(a,c,55760);return;case 10:rz(a,c,56784);return;case 11:rz(a,c,49616);return;case 12:rz(a,c,53712);return;default:a=ba(8)|0;v[23540]=0;b=Q(45,a|0,11096)|0;c=v[23540];v[23540]=0;if((c|0)!=1){break b}b=P()|0;O()|0;ca(a|0);T(b|0);L();case 0:break c}}e=kb-16|0;kb=e;f=Nb(a);h:{while(1){i:{j:{k:{if(Hb(c)>>>0>g>>>0){b=v[qj(c,g)>>2];if(b>>>0>=2097152){v[23540]=0;R(47,f|0,63);a=v[23540];v[23540]=0;if((a|0)!=1){break j}break i}a=0;while(1){if((a|0)==6){b=7;a=6;break k}d=b&63;t[(e+10|0)+a|0]=d;if(b>>>0>=64){a=a+1|0;b=b>>>6|0;continue}break}if(a){b=a+1|0;if((b|0)!=2){break k}a=1;b=2;if((d|0)!=1){break k}a=w[e+10|0]|64}else{a=w[e+10|0]}v[23540]=0;R(47,f|0,a<<24>>24);a=v[23540];v[23540]=0;if((a|0)!=1){break j}break i}kb=e+16|0;break h}i=(-1<<b^-1)<<7-a;d=b-1|0;j=d+(e+10|0)|0;a=b;while(1){if(!a){break j}l:{if((a|0)==(b|0)){a=w[j|0];v[23540]=0;R(47,f|0,(a|i)<<24>>24);h=v[23540];v[23540]=0;a=d;break l}v[23540]=0;a=a-1|0;R(47,f|0,t[a+(e+10|0)|0]|-128);h=v[23540];v[23540]=0}if((h|0)!=1){continue}break}break i}g=g+1|0;continue}break}a=P()|0;O()|0;zb(f);T(a|0);L()}return}ha(b|0,92888,25);L()}b=P()|0;O()|0;zb(a);T(b|0);L()}function Yca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,C=0,D=0,E=0,F=0;e=kb-48|0;kb=e;a:{b:{c:{j=v[a+12>>2];l=v[a+8>>2];d:{if((j|0)<=1&l>>>0<=805306368|(j|0)<=0){if((j|0)>=-2&l>>>0>=3489660928|(j|0)>-2){break c}if((j|0)==-2&l>>>0>2147483647|j>>>0>4294967294){break d}break b}if((j|0)==1&l>>>0>2147483648|j>>>0>1){break b}}b=b+196648|0;break a}b=b+131112|0;break a}b=b+262184|0}q=b;r=v[a+16>>2];b=0;while(1){if((b|0)!=2){f=b<<3;k=f+(e+24|0)|0;f=a+f|0;v[k+4>>2]=v[f+44>>2];v[k+8>>2]=v[f+48>>2];b=b+1|0;continue}break}s=v[a+24>>2];t=v[a+20>>2];b=v[a+4>>2];v[e+16>>2]=v[a>>2];v[e+20>>2]=b;w=v[a+72>>2];b=v[a+68>>2];x=b;y=b>>31;b=v[a+64>>2];z=b;A=b>>31;b=v[a+60>>2];C=b;D=b>>31;while(1){if(d){b=v[e+16>>2];E=((((v[e+20>>2]&2147483647)<<1|b>>>31)&2147483646)<<1)+r|0;b=(b>>>16&65520)+q|0;F=u[b+14>>1];g=u[b+12>>1];o=u[b+10>>1];p=u[b+8>>1];h=u[b+6>>1];k=u[b+4>>1];f=u[b+2>>1];b=u[b>>1];m=0;n=0;while(1){if((n|0)!=2){i=E+(n<<1)|0;v[(e+8|0)+(n<<2)>>2]=(((((((B(u[i-8>>1],f)+B(u[i-12>>1],b)|0)+B(u[i-4>>1],k)|0)+B(u[i>>1],h)|0)+B(u[i+4>>1],p)|0)+B(u[i+8>>1],o)|0)+B(g,u[i+12>>1])|0)+B(F,u[i+16>>1])|0)/32768;n=n+1|0;continue}break}while(1){if((m|0)!=2){o=(e+8|0)+(m<<2)|0;b=v[o>>2];g=(e+24|0)+(m<<3)|0;p=v[g+8>>2];h=v[g+4>>2];v[g+8>>2]=h;k=b<<8;b=k;b=Jka(C,D,b,b>>31);f=nb;i=g;g=b;b=Zb(h,-16777216,16776704);b=Jka(z,A,b,b>>31);h=g+b|0;g=nb+f|0;g=b>>>0>h>>>0?g+1|0:g;b=Zb(p,-16777216,16776704);f=Jka(x,y,b,b>>31);h=f+h|0;b=nb+g|0;b=f>>>0>h>>>0?b+1|0:b;f=h+8388608|0;b=f>>>0<8388608?b+1|0:b;b=Yc(f,b,24);v[i+4>>2]=b-(k&w);v[o>>2]=(b|0)/256;m=m+1|0;continue}break}v[c>>2]=v[c>>2]+B(v[e+8>>2],t);v[c+4>>2]=v[c+4>>2]+B(v[e+12>>2],s);Rb(e+16|0,l,j);c=c+8|0;d=d-1|0;continue}break}b=v[e+20>>2];v[a>>2]=v[e+16>>2];v[a+4>>2]=b;b=0;while(1){if((b|0)!=2){c=b<<3;d=c+a|0;c=c+(e+24|0)|0;v[d+44>>2]=v[c+4>>2];v[d+48>>2]=v[c+8>>2];b=b+1|0;continue}break}kb=e+48|0}function Zca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,w=0,x=0,y=0,z=0,A=0,C=0,D=0,E=0,F=0,G=0;e=kb-48|0;kb=e;a:{b:{c:{j=v[a+12>>2];l=v[a+8>>2];d:{if((j|0)<=1&l>>>0<=805306368|(j|0)<=0){if((j|0)>=-2&l>>>0>=3489660928|(j|0)>-2){break c}if((j|0)==-2&l>>>0>2147483647|j>>>0>4294967294){break d}break b}if((j|0)==1&l>>>0>2147483648|j>>>0>1){break b}}b=b+196648|0;break a}b=b+131112|0;break a}b=b+262184|0}q=b;r=v[a+16>>2];b=0;while(1){if((b|0)!=2){f=b<<3;k=f+(e+24|0)|0;f=a+f|0;v[k+4>>2]=v[f+44>>2];v[k+8>>2]=v[f+48>>2];b=b+1|0;continue}break}s=v[a+24>>2];w=v[a+20>>2];b=v[a+4>>2];v[e+16>>2]=v[a>>2];v[e+20>>2]=b;x=v[a+72>>2];b=v[a+68>>2];y=b;z=b>>31;b=v[a+64>>2];A=b;C=b>>31;b=v[a+60>>2];D=b;E=b>>31;while(1){if(d){b=v[e+16>>2];F=(((v[e+20>>2]&2147483647)<<1|b>>>31)&-2)+r|0;b=(b>>>16&65520)+q|0;G=u[b+14>>1];g=u[b+12>>1];o=u[b+10>>1];p=u[b+8>>1];h=u[b+6>>1];k=u[b+4>>1];f=u[b+2>>1];b=u[b>>1];m=0;n=0;while(1){if((n|0)!=2){i=n+F|0;v[(e+8|0)+(n<<2)>>2]=(((((((B(t[i-4|0],f)+B(t[i-6|0],b)|0)+B(t[i-2|0],k)|0)+B(t[i|0],h)|0)+B(t[i+2|0],p)|0)+B(t[i+4|0],o)|0)+B(g,t[i+6|0])|0)+B(G,t[i+8|0])<<8)/32768;n=n+1|0;continue}break}while(1){if((m|0)!=2){o=(e+8|0)+(m<<2)|0;b=v[o>>2];g=(e+24|0)+(m<<3)|0;p=v[g+8>>2];h=v[g+4>>2];v[g+8>>2]=h;k=b<<8;b=k;b=Jka(D,E,b,b>>31);f=nb;i=g;g=b;b=Zb(h,-16777216,16776704);b=Jka(A,C,b,b>>31);h=g+b|0;g=nb+f|0;g=b>>>0>h>>>0?g+1|0:g;b=Zb(p,-16777216,16776704);f=Jka(y,z,b,b>>31);h=f+h|0;b=nb+g|0;b=f>>>0>h>>>0?b+1|0:b;f=h+8388608|0;b=f>>>0<8388608?b+1|0:b;b=Yc(f,b,24);v[i+4>>2]=b-(k&x);v[o>>2]=(b|0)/256;m=m+1|0;continue}break}v[c>>2]=v[c>>2]+B(v[e+8>>2],w);v[c+4>>2]=v[c+4>>2]+B(v[e+12>>2],s);Rb(e+16|0,l,j);c=c+8|0;d=d-1|0;continue}break}b=v[e+20>>2];v[a>>2]=v[e+16>>2];v[a+4>>2]=b;b=0;while(1){if((b|0)!=2){c=b<<3;d=c+a|0;c=c+(e+24|0)|0;v[d+44>>2]=v[c+4>>2];v[d+48>>2]=v[c+8>>2];b=b+1|0;continue}break}kb=e+48|0}function E$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=kb-16|0;kb=j;k=Qw(g);o=ww(g);bh(j,o);v[f>>2]=d;a:{b:{c:{i=a;g=w[i|0];switch(g-43|0){case 0:case 2:break c;default:break b}}v[23540]=0;g=Q(1150,k|0,g<<24>>24)|0;i=v[23540];v[23540]=0;if((i|0)==1){break a}i=v[f>>2];v[f>>2]=i+4;v[i>>2]=g;i=a+1|0}d:{g=i;if(!((c-g|0)<2|w[g|0]!=48|(w[g+1|0]|32)!=120)){v[23540]=0;g=Q(1150,k|0,48)|0;h=v[23540];v[23540]=0;if((h|0)==1){break a}h=v[f>>2];v[f>>2]=h+4;v[h>>2]=g;g=t[i+1|0];v[23540]=0;g=Q(1150,k|0,g|0)|0;h=v[23540];v[23540]=0;if((h|0)==1){break a}h=v[f>>2];v[f>>2]=h+4;v[h>>2]=g;i=i+2|0;g=i;while(1){if(c>>>0<=g>>>0){break d}h=t[g|0];Gd();if(!_G(h)){break d}g=g+1|0;continue}}while(1){if(c>>>0<=g>>>0){break d}h=t[g|0];Gd();if(!bk(h)){break d}g=g+1|0;continue}}e:{if(Re(j)){h=v[f>>2];v[23540]=0;X(1144,k|0,i|0,g|0,h|0);h=v[23540];v[23540]=0;if((h|0)==1){break a}v[f>>2]=v[f>>2]+(g-i<<2);break e}_l(i,g);v[23540]=0;q=S(1142,o|0)|0;h=v[23540];v[23540]=0;if((h|0)==1){break a}h=i;while(1){if(g>>>0<=h>>>0){Tr((i-a<<2)+d|0,v[f>>2]);break e}f:{if(t[Tc(j,l)|0]<=0){break f}if(t[Tc(j,l)|0]!=(m|0)){break f}m=v[f>>2];v[f>>2]=m+4;v[m>>2]=q;l=(Hb(j)-1>>>0>l>>>0)+l|0;m=0}p=t[h|0];v[23540]=0;p=Q(1150,k|0,p|0)|0;n=v[23540];v[23540]=0;if((n|0)!=1){n=v[f>>2];v[f>>2]=n+4;v[n>>2]=p;h=h+1|0;m=m+1|0;continue}break}break a}g:{while(1){if(c>>>0>g>>>0){i=w[g|0];if((i|0)==46){v[23540]=0;i=S(1145,o|0)|0;h=v[23540];v[23540]=0;if((h|0)==1){break a}l=v[f>>2];h=l+4|0;v[f>>2]=h;v[l>>2]=i;g=g+1|0;break g}v[23540]=0;i=Q(1150,k|0,i<<24>>24)|0;h=v[23540];v[23540]=0;if((h|0)==1){break a}h=v[f>>2];v[f>>2]=h+4;v[h>>2]=i;g=g+1|0;continue}break}h=v[f>>2]}v[23540]=0;X(1144,k|0,g|0,c|0,h|0);i=v[23540];v[23540]=0;if((i|0)==1){break a}i=f;f=v[f>>2]+(c-g<<2)|0;v[i>>2]=f;v[e>>2]=(b|0)==(c|0)?f:(b-a<<2)+d|0;zb(j);kb=j+16|0;return}a=P()|0;O()|0;zb(j);T(a|0);L()}function ks(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;if(!a){return Pd(b)}if(b>>>0>=4294967232){v[116016]=48;return 0}e=b>>>0<11?16:b+11&-8;h=a-4|0;i=v[h>>2];c=i&-8;a:{b:{if(!(i&3)){if(e>>>0<256|c>>>0<(e|4)>>>0){break b}if(c-e>>>0<=v[116168]<<1>>>0){break a}break b}g=a-8|0;f=c+g|0;if(c>>>0>=e>>>0){b=c-e|0;if(b>>>0<16){break a}v[h>>2]=i&1|e|2;c=e+g|0;v[c+4>>2]=b|3;v[f+4>>2]=v[f+4>>2]|1;LH(c,b);return a}if(v[116054]==(f|0)){c=c+v[116051]|0;if(c>>>0<=e>>>0){break b}v[h>>2]=i&1|e|2;b=e+g|0;c=c-e|0;v[b+4>>2]=c|1;v[116051]=c;v[116054]=b;return a}if(v[116053]==(f|0)){c=c+v[116050]|0;if(c>>>0<e>>>0){break b}b=c-e|0;c:{if(b>>>0>=16){v[h>>2]=i&1|e|2;d=e+g|0;v[d+4>>2]=b|1;c=c+g|0;v[c>>2]=b;v[c+4>>2]=v[c+4>>2]&-2;break c}v[h>>2]=c|i&1|2;b=c+g|0;v[b+4>>2]=v[b+4>>2]|1;b=0}v[116053]=d;v[116050]=b;return a}d=v[f+4>>2];if(d&2){break b}j=c+(d&-8)|0;if(j>>>0<e>>>0){break b}l=j-e|0;d:{if(d>>>0<=255){b=v[f+8>>2];d=d>>>3|0;c=v[f+12>>2];if((c|0)==(b|0)){n=464192,o=v[116048]&Nka(-2,d),v[n>>2]=o;break d}v[b+12>>2]=c;v[c+8>>2]=b;break d}k=v[f+24>>2];c=v[f+12>>2];e:{if((f|0)!=(c|0)){b=v[f+8>>2];v[b+12>>2]=c;v[c+8>>2]=b;break e}f:{b=f+20|0;d=v[b>>2];if(d){break f}b=f+16|0;d=v[b>>2];if(d){break f}c=0;break e}while(1){m=b;c=d;b=c+20|0;d=v[b>>2];if(d){continue}b=c+16|0;d=v[c+16>>2];if(d){continue}break}v[m>>2]=0}if(!k){break d}b=v[f+28>>2];d=(b<<2)+464496|0;g:{if(v[d>>2]==(f|0)){v[d>>2]=c;if(c){break g}n=464196,o=v[116049]&Nka(-2,b),v[n>>2]=o;break d}v[(v[k+16>>2]==(f|0)?16:20)+k>>2]=c;if(!c){break d}}v[c+24>>2]=k;b=v[f+16>>2];if(b){v[c+16>>2]=b;v[b+24>>2]=c}b=v[f+20>>2];if(!b){break d}v[c+20>>2]=b;v[b+24>>2]=c}if(l>>>0<=15){v[h>>2]=i&1|j|2;b=g+j|0;v[b+4>>2]=v[b+4>>2]|1;return a}v[h>>2]=i&1|e|2;b=e+g|0;v[b+4>>2]=l|3;c=g+j|0;v[c+4>>2]=v[c+4>>2]|1;LH(b,l);return a}c=Pd(b);if(!c){return 0}d=v[h>>2];d=(d&3?-4:-8)+(d&-8)|0;sc(c,a,b>>>0>d>>>0?d:b);Mb(a);a=c}return a}function Tja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,z=0;d=kb-1104|0;kb=d;v[d+1100>>2]=c;i=zB(d+40|0,b);q=Gq(i);e=Tb(a);v[23540]=0;a=S(202,b|0)|0;c=v[23540];v[23540]=0;a:{if((c|0)!=1){v[d+8>>2]=a;v[d+36>>2]=85899345;s=d,z=B(v[Kb(d+8|0,d+36|0)>>2],50),v[s+24>>2]=z;a=v[Kb(d+1100|0,d+24|0)>>2];v[23540]=0;R(322,e|0,a|0);a=v[23540];v[23540]=0;if((a|0)!=1){v[23540]=0;h=S(334,d+24|0)|0;a=v[23540];v[23540]=0;if((a|0)!=1){v[23540]=0;f=Q(335,d+8|0,8192)|0;a=v[23540];v[23540]=0;b:{if((a|0)!=1){a=v[h>>2];c=0;while(1){if((c|0)!=256){g=Eb(a,c);t[g+2|0]=c;u[g>>1]=8192;c=c+1|0;continue}break}m=9;c:{d:while(1){g=0;n=257;while(1){r=m&255;e:{while(1){j=n&65535;while(1){v[23540]=0;o=Q(164,i|0,r|0)|0;a=v[23540];v[23540]=0;if((a|0)==1){break c}k=o&65535;if((k|0)==257|j>>>0<k>>>0){break e}if(fd(v[e>>2],v[e+4>>2])>>>0>=y[d+1100>>2]){break e}if((k|0)==256){m=9;continue d}c=j>>>0>k>>>0?o:g;a=v[h>>2];l=8192;while(1){c=c&65535;a=Eb(a,c);l=l-1|0;p=l&65535;s=Lb(v[f>>2],p),z=w[a+2|0],t[s|0]=z;a=v[h>>2];c=x[Eb(a,c)>>1];if(c>>>0<8192){continue}break}a=fc(d,Fb(v[e+4>>2]));c=Rf(Fb(v[f>>2]),p);l=Fb(v[f+4>>2]);a=v[a>>2];v[23540]=0;X(323,e|0,a|0,c|0,l|0);a=v[23540];v[23540]=0;if((a|0)==1){break c}f:{if((j|0)!=(k|0)){break f}a=v[f>>2];v[23540]=0;R(336,e|0,Lb(a,p)|0);a=v[23540];v[23540]=0;if((a|0)!=1){break f}break c}if(j>>>0>=8192){g=o;continue}if(fd(v[e>>2],v[e+4>>2])>>>0>=y[d+1100>>2]){continue}break}a=w[Lb(v[f>>2],p)|0];c=Eb(v[h>>2],j);u[c>>1]=g;t[c+2|0]=a;a=n+1|0;n=8192;g=o;c=a&65535;if((c|0)==8192){continue}break}m=((c|0)==1<<r)+m|0;n=a;continue}break}break}a=Gq(i);v[23540]=0;Q(155,b|0,((a-q|0)+3&-4)+q|0)|0;a=v[23540];v[23540]=0;if((a|0)==1){break c}ic(f);wc(h);Bb(i);kb=d+1104|0;return}c=P()|0;O()|0;ic(f);break b}c=P()|0;O()|0}wc(h);break a}c=P()|0;O()|0;break a}c=P()|0;O()|0;break a}c=P()|0;O()|0}ic(e);Bb(i);T(c|0);L()}function U4(a,b,c){a=a|0;b=C(b);c=c|0;var d=0,e=C(0),f=C(0),g=C(0),h=C(0),i=C(0),k=C(0),m=0,n=0,o=0;d=kb-16|0;kb=d;a:{b:{c:{d:{switch(c-1|0){case 0:a=(p(b),j(2));e:{f:{g:{if((a|0)<=8388607){e=C(C(-1)/C(b*b));if(!(a&2147483647)){break e}e=C(C(b-b)/C(0));if((a|0)<0){break e}a=(p(C(b*C(33554432))),j(2));c=-152;break g}if(a>>>0>2139095039){break f}c=-127;b=C(0);if((a|0)==1065353216){break f}}a=a+4913933|0;k=C((a>>>23|0)+c|0);b=C((l(2,(a&8388607)+1060439283|0),q())+C(-1));f=C(b*C(b*C(.5)));g=C(b/C(b+C(2)));h=C(g*g);i=C(h*h);e=b;b=(l(2,(p(C(b-f)),j(2))&-4096),q());f=C(C(g*C(f+C(C(h*C(C(i*C(.2849878668785095))+C(.6666666269302368)))+C(i*C(C(i*C(.24279078841209412))+C(.40000972151756287))))))+C(C(e-b)-f));b=C(C(k*C(.3010292053222656))+C(C(b*C(.434326171875))+C(C(f*C(.434326171875))+C(C(k*C(7.903415166765626e-7))+C(C(f+b)*C(-3168997136526741e-20))))))}e=b}b=C(e*C(2e3));if(!(C(D(b))<C(2147483648))){break c}a=~~b;break b;case 1:a=(B(v[a+24604>>2],100)|0)/128|0;break b;case 2:c=kb-16|0;kb=c;h:{i:{j:{k:{a=w[a+24648|0];if(a>>>0>=6){a=ba(8)|0;v[23540]=0;c=Q(55,c|0,5126)|0;d=v[23540];v[23540]=0;if((d|0)==1){break k}a=tc(a,c);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break i}d=P()|0;O()|0;zb(c);break j}kb=c+16|0;a=v[(a<<24>>24<<2)+62472>>2];break h}d=P()|0;O()|0;ca(a|0)}T(d|0)}L()}break b;case 3:v[d>>2]=0;m=v[a+24640>>2];c=kb-80|0;kb=c;a=v[a+24636>>2];v[c+40>>2]=a;v[c>>2]=m;n=c+40|0;o=v[Pe(n,c)>>2];l:{if((a|0)==v[fq(n)+32>>2]){a=-1;if(v[fq(c)+36>>2]==(m|0)){break l}}a=0;if((o|0)<=0){break l}a=(o+500>>>0)/1e3|0}v[d>>2]=a;kb=c+80|0;a=v[d>>2];break b;default:break d}}c=ba(8)|0;v[23540]=0;d=Q(55,d|0,10404)|0;a=v[23540];v[23540]=0;m:{if((a|0)!=1){a=tc(c,d);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break a}a=P()|0;O()|0;zb(d);break m}a=P()|0;O()|0;ca(c|0)}T(a|0);L()}a=-2147483648}kb=d+16|0;return a|0}L()}function Lha(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=kb-48|0;kb=c;a:{b:{c:{d:{e:{f:{g:{if(zd(v[a+24>>2])){break g}h=a+4|0;k=Hb(h);e=kb-32|0;kb=e;d=e+24|0;b=d;v[b>>2]=-1;v[b+4>>2]=-1;v[23540]=0;f=nF(39);b=v[23540];v[23540]=0;if((b|0)==1){break a}v[e+8>>2]=f;v[e+12>>2]=nb;g=kb-16|0;kb=g;i=e+8|0;b=i;l=g,m=Jka(v[b>>2],v[b+4>>2],1e3,0),v[l>>2]=m;v[g+4>>2]=nb;f=zt(g+8|0,g);b=v[f+4>>2];kb=g+16|0;v[e+16>>2]=v[f>>2];v[e+20>>2]=b;b=e+16|0;l=e,m=nA(v[b>>2],v[b+4>>2]),v[l+16>>2]=m;v[e+20>>2]=nb;g=ZR(d,b,Gb(b));v[23540]=0;d=nF(40);f=v[23540];v[23540]=0;if((f|0)==1){break a}j=a+24|0;v[e+8>>2]=d;v[e+12>>2]=nb;d=kb-16|0;kb=d;a=v[i+4>>2];v[d>>2]=v[i>>2];v[d+4>>2]=a;f=zt(d+8|0,d);a=v[f+4>>2];kb=d+16|0;v[e+16>>2]=v[f>>2];v[e+20>>2]=a;l=e,m=nA(v[b>>2],v[b+4>>2]),v[l+16>>2]=m;v[e+20>>2]=nb;a=ZR(g,b,Gb(b));b=v[a>>2];a=v[a+4>>2];kb=e+32|0;if(k){d=Tb(c+32|0);v[23540]=0;v[c+16>>2]=a;R(33,d|0,c+16|0);a=v[23540];v[23540]=0;if((a|0)==1){break d}v[23540]=0;v[c+16>>2]=b;R(33,d|0,c+16|0);a=v[23540];v[23540]=0;if((a|0)==1){break e}a=0;h:{while(1){if(Hb(h)>>>0<=a>>>0){b=Fb(v[d>>2]);a=Fb(v[d+4>>2]);v[23540]=0;f=W(34,c+16|0,b|0,a|0)|0;a=v[23540];v[23540]=0;if((a|0)!=1){break h}a=P()|0;O()|0;break c}b=w[Tc(h,a)|0];v[23540]=0;v[c+16>>2]=b;R(33,d|0,c+16|0);b=v[23540];v[23540]=0;if((b|0)!=1){a=a+1|0;continue}break}a=P()|0;O()|0;break c}v[23540]=0;b=S(35,f|0)|0;a=v[23540];v[23540]=0;if((a|0)!=1){v[c+8>>2]=b;a=c+8|0;sA(j,a);Gm(a);Fm(f);wc(d);break g}a=P()|0;O()|0;Fm(f);break c}nb=b;v[c+16>>2]=a;v[c+20>>2]=nb;b=Tb(c+32|0);v[23540]=0;U(38,b|0,c+16|0,c+24|0);a=v[23540];v[23540]=0;if((a|0)==1){a=P()|0;O()|0;wc(b);T(a|0);L()}v[23540]=0;f=S(35,b|0)|0;a=v[23540];v[23540]=0;if((a|0)==1){break f}v[c+8>>2]=f;a=c+8|0;sA(j,a);Gm(a);Fm(b)}kb=c+48|0;return}a=P()|0;O()|0;Fm(b);break b}a=P()|0;O()|0;break c}a=P()|0;O()|0}wc(d)}T(a|0);L()}V(0)|0;O()|0;Vb();L()}function O$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=kb-16|0;kb=j;k=gv(g);o=Bw(g);bh(j,o);v[f>>2]=d;a:{b:{c:{i=a;g=w[i|0];switch(g-43|0){case 0:case 2:break c;default:break b}}v[23540]=0;g=Q(20,k|0,g<<24>>24)|0;i=v[23540];v[23540]=0;if((i|0)==1){break a}i=v[f>>2];v[f>>2]=i+1;t[i|0]=g;i=a+1|0}d:{g=i;if(!((c-g|0)<2|w[g|0]!=48|(w[g+1|0]|32)!=120)){v[23540]=0;g=Q(20,k|0,48)|0;h=v[23540];v[23540]=0;if((h|0)==1){break a}h=v[f>>2];v[f>>2]=h+1;t[h|0]=g;g=t[i+1|0];v[23540]=0;g=Q(20,k|0,g|0)|0;h=v[23540];v[23540]=0;if((h|0)==1){break a}h=v[f>>2];v[f>>2]=h+1;t[h|0]=g;i=i+2|0;g=i;while(1){if(c>>>0<=g>>>0){break d}h=t[g|0];Gd();if(!_G(h)){break d}g=g+1|0;continue}}while(1){if(c>>>0<=g>>>0){break d}h=t[g|0];Gd();if(!bk(h)){break d}g=g+1|0;continue}}e:{if(Re(j)){h=v[f>>2];v[23540]=0;X(1130,k|0,i|0,g|0,h|0);h=v[23540];v[23540]=0;if((h|0)==1){break a}v[f>>2]=v[f>>2]+(g-i|0);break e}_l(i,g);v[23540]=0;q=S(1128,o|0)|0;h=v[23540];v[23540]=0;if((h|0)==1){break a}h=i;while(1){if(g>>>0<=h>>>0){_l((i-a|0)+d|0,v[f>>2]);break e}f:{if(t[Tc(j,m)|0]<=0){break f}if(t[Tc(j,m)|0]!=(l|0)){break f}l=v[f>>2];v[f>>2]=l+1;t[l|0]=q;m=(Hb(j)-1>>>0>m>>>0)+m|0;l=0}p=t[h|0];v[23540]=0;p=Q(20,k|0,p|0)|0;n=v[23540];v[23540]=0;if((n|0)!=1){n=v[f>>2];v[f>>2]=n+1;t[n|0]=p;h=h+1|0;l=l+1|0;continue}break}break a}while(1){g:{if(c>>>0>g>>>0){i=w[g|0];if((i|0)!=46){break g}v[23540]=0;i=S(1131,o|0)|0;h=v[23540];v[23540]=0;if((h|0)==1){break a}h=v[f>>2];v[f>>2]=h+1;t[h|0]=i;g=g+1|0}i=v[f>>2];v[23540]=0;X(1130,k|0,g|0,c|0,i|0);i=v[23540];v[23540]=0;if((i|0)==1){break a}i=f;f=v[f>>2]+(c-g|0)|0;v[i>>2]=f;v[e>>2]=(b|0)==(c|0)?f:(b-a|0)+d|0;zb(j);kb=j+16|0;return}v[23540]=0;i=Q(20,k|0,i<<24>>24)|0;h=v[23540];v[23540]=0;if((h|0)==1){break a}h=v[f>>2];v[f>>2]=h+1;t[h|0]=i;g=g+1|0;continue}}a=P()|0;O()|0;zb(j);T(a|0);L()}function MO(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,w=0,x=0,y=0,z=0;c=kb-176|0;kb=c;e=v[a+12>>2];j=1<<e;a:{if(!(e&1)){h=j>>>2|0;l=1;break a}l=j>>>1|0;e=0;while(1){if((e|0)==(l|0)){h=j>>>3|0;l=2;e=v[a+12>>2]}else{i=v[b>>2];h=Kd(i,e+l|0);d=Kd(i,e);o=A[h>>3];p=A[h+8>>3];lj(c+160|0,d,o,p);i=v[c+172>>2];v[h+8>>2]=v[c+168>>2];v[h+12>>2]=i;i=v[c+164>>2];v[h>>2]=v[c+160>>2];v[h+4>>2]=i;dy(Kd(v[b>>2],e),o,p);e=e+1|0;continue}break}}i=e&-2;b:while(1){if(i){x=B(h,3);y=h<<1;j=0;c:while(1){if((j|0)==(l|0)){i=i-2|0;h=h>>>2|0;l=l<<2;continue b}d=v[a>>2];e=Kd(d,j<<1);d=Kd(d,j);o=A[d>>3];p=A[d+8>>3];r=A[e>>3];s=A[e+8>>3];xi(c+160|0,o,p,r,s);e=j<<i;d=h+e|0;z=d>>>0<e>>>0?e:d;while(1)if((e|0)==(z|0)){j=j+1|0;continue c}else{f=v[b>>2];d=Kd(f,e);g=v[d+12>>2];v[c+152>>2]=v[d+8>>2];v[c+156>>2]=g;g=v[d+4>>2];v[c+144>>2]=v[d>>2];v[c+148>>2]=g;g=c+128|0;t=e+h|0;k=Kd(f,t);xi(g,r,s,A[k>>3],A[k+8>>3]);u=e+y|0;k=Kd(f,u);xi(c+112|0,o,p,A[k>>3],A[k+8>>3]);m=A[c+160>>3];n=A[c+168>>3];w=e+x|0;f=Kd(f,w);xi(c+96|0,m,n,A[f>>3],A[f+8>>3]);k=c+80|0;f=c+144|0;m=A[c+112>>3];n=A[c+120>>3];fl(k,f,m,n);q=c- -64|0;lj(q,f,m,n);m=A[c+96>>3];n=A[c+104>>3];fl(c+48|0,g,m,n);f=c+16|0;nl(f,-0,-1);lj(c,g,m,n);xi(c+32|0,A[c+16>>3],A[c+24>>3],A[c>>3],A[c+8>>3]);fl(f,k,A[c+48>>3],A[c+56>>3]);g=v[c+28>>2];v[d+8>>2]=v[c+24>>2];v[d+12>>2]=g;g=v[c+20>>2];v[d>>2]=v[c+16>>2];v[d+4>>2]=g;lj(f,k,A[c+48>>3],A[c+56>>3]);d=Kd(v[b>>2],t);g=v[c+28>>2];v[d+8>>2]=v[c+24>>2];v[d+12>>2]=g;g=v[c+20>>2];v[d>>2]=v[c+16>>2];v[d+4>>2]=g;fl(f,q,A[c+32>>3],A[c+40>>3]);d=Kd(v[b>>2],u);g=v[c+28>>2];v[d+8>>2]=v[c+24>>2];v[d+12>>2]=g;g=v[c+20>>2];v[d>>2]=v[c+16>>2];v[d+4>>2]=g;lj(f,q,A[c+32>>3],A[c+40>>3]);d=Kd(v[b>>2],w);f=v[c+28>>2];v[d+8>>2]=v[c+24>>2];v[d+12>>2]=f;f=v[c+20>>2];v[d>>2]=v[c+16>>2];v[d+4>>2]=f;e=e+1|0;continue}}}break}kb=c+176|0}function D6(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=kb-80|0;kb=e;v[e+76>>2]=c;v[e+72>>2]=b;a:{if(!c){break a}f=w[cl(b,c)|0];if((f|0)==33){d=1}else{if((f|0)!=63){break a}d=0}jl(e+48|0,b,c,c-1|0);b=v[e+52>>2];v[e+72>>2]=v[e+48>>2];v[e+76>>2]=b}c=e+48|0;Xd(c);b=v[e+48>>2];Xd(e+32|0);b=bl(b,v[e+36>>2],e+72|0);Xd(c);b:{c:{d:{e:{if((b|0)==v[e+52>>2]){b=v[e+72>>2];c=v[e+76>>2];a=rc(e- -64|0,21688);if(Qc(b,c,v[a>>2],v[a+4>>2])){a=ba(8)|0;v[23540]=0;b=Q(55,e+48|0,10501)|0;c=v[23540];v[23540]=0;if((c|0)==1){break d}a=tc(a,b);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break b}c=P()|0;O()|0;zb(b);break c}b=0;c=0;if(!d){break e}b=ba(8)|0;v[23540]=0;d=Mh(e+32|0,v[e+72>>2],v[e+76>>2]);a=v[23540];v[23540]=0;f:{g:{h:{if((a|0)!=1){v[23540]=0;U(961,e+48|0,17703,d|0);a=v[23540];v[23540]=0;if((a|0)==1){break h}a=0;c=tc(b,e+48|0);v[23540]=0;U(119,c|0,62752,950);c=v[23540];v[23540]=0;if((c|0)!=1){break b}c=P()|0;O()|0;zb(e+48|0);break g}c=P()|0;O()|0;break f}c=P()|0;a=1;O()|0}zb(d);if(!a){break c}}ca(b|0);break c}if(v[b+4>>2]!=1){a=ba(8)|0;v[23540]=0;b=Q(55,e+48|0,11573)|0;c=v[23540];v[23540]=0;if((c|0)!=1){a=tc(a,b);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break b}c=P()|0;O()|0;zb(b);break c}c=P()|0;O()|0;ca(a|0);break c}d=v[e+72>>2];f=v[e+76>>2];b=rc(e+24|0,21688);if(Qc(d,f,v[b>>2],v[b+4>>2])){a=ba(8)|0;v[23540]=0;b=Q(55,e+48|0,10501)|0;c=v[23540];v[23540]=0;if((c|0)!=1){a=tc(a,b);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break b}c=P()|0;O()|0;zb(b);break c}c=P()|0;O()|0;ca(a|0);break c}b=rc(e+16|0,10964);if(Qc(d,f,v[b>>2],v[b+4>>2])){a=v[a+8>>2];b=a;c=a>>31;break e}b=0;g=d;d=rc(e+8|0,8656);c=0;if(!Qc(g,f,v[d>>2],v[d+4>>2])){break e}b=dk(w[v[a+32>>2]+140|0]);c=0}kb=e+80|0;nb=c;return b|0}c=P()|0;O()|0;ca(a|0)}T(c|0)}L()}function n6(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0;k=kb+-64|0;kb=k;a:{b:{c:{j=Bp(1,32);d:{e:{if(!j){a=mm(ba(4)|0);v[23540]=0;U(119,a|0,92756,26);a=v[23540];v[23540]=0;if((a|0)!=1){break a}i=V(0)|0;O()|0;break e}v[j+12>>2]=f;v[j+8>>2]=e;v[j+4>>2]=d;v[j>>2]=c?c:927;c=Yf(k+48|0);f:{g:{h:{if(!i){break h}while(1){d=v[i>>2];if(!d){break h}e=v[i+4>>2];i:{if(e){v[23540]=0;d=Q(55,k+32|0,d|0)|0;f=v[23540];v[23540]=0;j:{if((f|0)!=1){v[23540]=0;f=Q(938,c|0,d|0)|0;l=v[23540];v[23540]=0;if((l|0)==1){break j}v[23540]=0;R(270,f|0,e|0);e=v[23540];v[23540]=0;if((e|0)==1){break j}break i}i=V(0)|0;O()|0;break f}i=V(0)|0;O()|0;zb(d);break f}v[23540]=0;d=Q(55,k+16|0,d|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break g}Js(c,d)}zb(d);i=i+8|0;continue}}v[23540]=0;d=S(812,104)|0;e=v[23540];v[23540]=0;k:{l:{m:{if((e|0)!=1){e=v[j+4>>2];f=v[j>>2];v[23540]=0;e=Q(939,f|0,e|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break m}v[k>>2]=e;e=v[eg(k+8|0,k)>>2];v[23540]=0;a=ja(970,d|0,a|0,b|0,e|0,c|0)|0;b=v[23540];v[23540]=0;if((b|0)!=1){break k}i=V(0)|0;O()|0;De(k);break l}i=V(0)|0;O()|0;break f}i=V(0)|0;O()|0}Mb(d);break f}v[j+28>>2]=a;De(k);a=v[j+28>>2];v[j+24>>2]=a?a+8|0:0;kl(c);break d}i=V(0)|0;O()|0}kl(c);_(i|0)|0;v[23540]=0;X(933,4976,j|0,g|0,h|0);a=v[23540];v[23540]=0;if((a|0)!=1){v[23540]=0;Z(18);a=v[23540];v[23540]=0;if((a|0)!=1){a=v[j+28>>2];if(a){ob[v[v[a>>2]+4>>2]](a)}v[j+24>>2]=0;v[j+28>>2]=0;a=v[j+20>>2];if(a){Mb(a);v[j+20>>2]=0}Mb(j);j=0;break d}i=V(0)|0;O()|0;break e}i=V(0)|0;O()|0;v[23540]=0;Z(18);a=v[23540];v[23540]=0;if((a|0)==1){break b}}_(i|0)|0;j=0;v[23540]=0;X(933,4976,0,g|0,h|0);a=v[23540];v[23540]=0;if((a|0)==1){break c}$()}kb=k- -64|0;return j|0}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)==1){break b}T(a|0);L()}V(0)|0;O()|0;Vb()}L()}function ih(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;a:{b:{c:{switch(b|0){case 1:b=0;a=Nb(a);d=Hb(c);v[23540]=0;R(48,a|0,d|0);d=v[23540];v[23540]=0;d:{if((d|0)!=1){e:{while(1){if(Hb(c)>>>0>b>>>0){d=t[hg(c,b)|0];v[23540]=0;R(49,a|0,((d|0)<0?65533:d&255)|0);d=v[23540];v[23540]=0;if((d|0)==1){break e}b=b+1|0;continue}break}break d}}break a}return;case 2:b=0;a=Nb(a);d=Hb(c);v[23540]=0;R(48,a|0,d|0);d=v[23540];v[23540]=0;f:{if((d|0)!=1){while(1){if(Hb(c)>>>0<=b>>>0){break f}d=w[hg(c,b)|0];v[23540]=0;R(49,a|0,d|0);d=v[23540];v[23540]=0;if((d|0)!=1){b=b+1|0;continue}break}}break a}return;case 3:ll(a,c,49616);return;case 5:ll(a,c,50640);return;case 4:ll(a,c,51664);return;case 6:ll(a,c,52688);return;case 7:ll(a,c,53712);return;case 8:ll(a,c,54736);return;case 9:ll(a,c,55760);return;case 10:iz(a,c,56784);return;case 11:iz(a,c,49616);return;case 12:iz(a,c,53712);return;default:a=ba(8)|0;v[23540]=0;b=Q(45,a|0,11096)|0;c=v[23540];v[23540]=0;if((c|0)!=1){break b}b=P()|0;O()|0;ca(a|0);T(b|0);L();case 0:break c}}e=kb-16|0;kb=e;f=Nb(a);g=e,h=nt(c),v[g+8>>2]=h;g=e,h=mt(c),v[g>>2]=h;a=0;g:{h:{while(1){i:{if(!pj(e+8|0,e)){if(!a){break i}v[23540]=0;R(49,f|0,65533);a=v[23540];v[23540]=0;if((a|0)!=1){break i}break h}b=w[v[e+8>>2]];j:{k:{if(!a){if(!(b&128)){a=0;v[23540]=0;R(49,f|0,b|0);b=v[23540];v[23540]=0;if((b|0)!=1){break j}break h}if((b&224)==192){d=b&31;a=1;break j}if((b&240)==224){d=b&15;a=2;break j}d=65533;if((b&248)!=240){break k}d=b&7;a=3;break j}if((b&192)!=128){d=0;v[23540]=0;R(49,f|0,65533);c=v[23540];v[23540]=0;a=0;if((c|0)==1){break h}}d=b&63|d<<6;a=a-1|0;if(a){break j}}a=0;v[23540]=0;R(49,f|0,d|0);b=v[23540];v[23540]=0;d=0;if((b|0)==1){break h}}Ke(e+8|0);continue}break}kb=e+16|0;break g}a=P()|0;O()|0;Nc(f);T(a|0);L()}return}ha(b|0,92888,25);L()}b=P()|0;O()|0;Nc(a);T(b|0);L()}function Eca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,C=0,D=0,E=0,F=0,G=0,H=0;g=kb-48|0;kb=g;p=v[a+16>>2];while(1){if((f|0)!=2){e=f<<3;i=e+(g+24|0)|0;e=a+e|0;v[i+4>>2]=v[e+44>>2];v[i+8>>2]=v[e+48>>2];f=f+1|0;continue}break}i=v[a+40>>2];k=v[a+36>>2];f=v[a+4>>2];v[g+16>>2]=v[a>>2];v[g+20>>2]=f;q=b+24|0;r=v[a+32>>2];s=v[a+28>>2];t=v[a+72>>2];b=v[a+68>>2];w=b;x=b>>31;b=v[a+64>>2];y=b;z=b>>31;b=v[a+60>>2];A=b;C=b>>31;D=v[a+8>>2];E=v[a+12>>2];while(1){if(d){f=v[g+16>>2];l=((((v[g+20>>2]&2147483647)<<1|f>>>31)&2147483646)<<1)+p|0;b=(((f>>>16|0)+4&131064)<<1)+q|0;j=u[b+14>>1];h=u[b+12>>1];m=u[b+10>>1];n=u[b+8>>1];o=u[b+6>>1];F=u[b+4>>1];G=u[b+2>>1];H=u[b>>1];f=0;e=0;while(1){if((e|0)!=2){b=l+(e<<1)|0;v[(g+8|0)+(e<<2)>>2]=(((((B(u[b+8>>1],m)+B(u[b+4>>1],n)|0)+B(h,u[b+12>>1])|0)+B(j,u[b+16>>1])|0)/2|0)+((((B(u[b-8>>1],G)+B(u[b-12>>1],H)|0)+B(u[b-4>>1],F)|0)+B(u[b>>1],o)|0)/2|0)|0)/16384;e=e+1|0;continue}break}while(1){if((f|0)!=2){l=(g+8|0)+(f<<2)|0;e=v[l>>2];b=(g+24|0)+(f<<3)|0;j=v[b+8>>2];h=v[b+4>>2];v[b+8>>2]=h;m=e<<8;e=m;e=Jka(A,C,e,e>>31);n=nb;o=b;b=Zb(h,-16777216,16776704);h=Jka(y,z,b,b>>31);e=h+e|0;b=nb+n|0;b=e>>>0<h>>>0?b+1|0:b;h=e;e=Zb(j,-16777216,16776704);j=Jka(w,x,e,e>>31);e=h+j|0;b=nb+b|0;b=e>>>0<j>>>0?b+1|0:b;e=e+8388608|0;b=e>>>0<8388608?b+1|0:b;b=Yc(e,b,24);v[o+4>>2]=b-(m&t);v[l>>2]=(b|0)/256;f=f+1|0;continue}break}k=k+s|0;v[c>>2]=v[c>>2]+B(v[g+8>>2],k>>12);i=i+r|0;v[c+4>>2]=v[c+4>>2]+B(v[g+12>>2],i>>12);Rb(g+16|0,D,E);c=c+8|0;d=d-1|0;continue}break}b=v[g+20>>2];v[a>>2]=v[g+16>>2];v[a+4>>2]=b;v[a+40>>2]=i;v[a+20>>2]=k>>12;v[a+36>>2]=k;v[a+24>>2]=i>>12;f=0;while(1){if((f|0)!=2){b=f<<3;c=b+a|0;b=b+(g+24|0)|0;v[c+44>>2]=v[b+4>>2];v[c+48>>2]=v[b+8>>2];f=f+1|0;continue}break}kb=g+48|0}function hk(a,b,c,d,e){var f=0,g=0,h=0,i=0,j=0;i=kb-16|0;kb=i;a:{if(!d){break a}g=v[c>>2];if(!g){break a}b:{c:{d:{e:{f=v[a+480180>>2];if((f|0)!=512){if((f|0)!=64){break e}f=B(d,20)+g|0;break d}f=((B(d,36318)|0)/1024|0)+g|0;break d}f:{g:{h:{if(w[a+480208|0]&16){if((f|0)==4){break h}f=d>>31;v[i+12>>2]=(f^d)-f;xc(i+12|0,1020);h=v[i+12>>2];i:{if((d|0)>0){if(h>>>0<=15){f=kb-16|0;kb=f;Db(f+8|0,a+1074312|0,7);j=Cb(v[v[f+8>>2]>>2],v[f+12>>2]);kb=f+16|0;h=v[(h<<2)+(j?37072:37136)>>2];break i}f=kb-16|0;kb=f;Db(f+8|0,a+1074312|0,7);j=Cb(v[v[f+8>>2]>>2],v[f+12>>2]);kb=f+16|0;h=v[(h>>>2<<2)+(j?37200:38224)>>2];break i}if(h>>>0<=15){f=kb-16|0;kb=f;Db(f+8|0,a+1074312|0,7);j=Cb(v[v[f+8>>2]>>2],v[f+12>>2]);kb=f+16|0;h=v[(h<<2)+(j?37136:37072)>>2];break i}f=kb-16|0;kb=f;Db(f+8|0,a+1074312|0,7);j=Cb(v[v[f+8>>2]>>2],v[f+12>>2]);kb=f+16|0;h=v[(h>>>2<<2)+(j?38224:37200)>>2]}h=Jka(h,h>>31,g,g>>31)+32768|0;f=nb;f=Hc(Kka(h,h>>>0<32768?f+1|0:f,65536,0),nb);v[c>>2]=f;if((f|0)!=(g|0)){break c}Db(i,a+1074312|0,7);g=v[c>>2];if(!(Cb(v[v[i>>2]>>2],v[i+4>>2])^(d|0)>0)){f=2147483647;d=1;if((g|0)==2147483647){break c}break f}d=-1;if((g|0)>=2){break f}f=g;break c}Db(i,a+1074312|0,7);if(Cb(v[v[i>>2]>>2],v[i+4>>2])){break g}g=v[c>>2]}f=g-d|0;break d}f=v[c>>2];if((d|0)<0){g=Jka(f,0,14317456,0);h=nb;f=Jka(f,0,0-d|0,0)+14317456|0;d=nb;f=sN(Mka(g,h,f,f>>>0<14317456?d+1|0:d),nb);break d}d=Jka(f,f>>31,d,0);g=nb;if((g|0)>=0&d>>>0>=14317456|(g|0)>0){if(e){v[c>>2]=2147483647;break a}v[c>>2]=0;v[b+696>>2]=0;v[b+88>>2]=v[b+88>>2]|2101248;break a}d=sN(Mka(Jka(f,0,14317456,0),nb,14317456-d|0,0-(g+(d>>>0>14317456)|0)|0),nb);v[c>>2]=d;if((d|0)>0){break a}break b}f=d+g|0}v[c>>2]=f}if((f|0)>0){break a}}v[c>>2]=1;if(v[a+480180>>2]!=2|e){break a}v[b+696>>2]=0;v[b+88>>2]=v[b+88>>2]|2101248}kb=i+16|0}function Fca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,w=0,x=0,y=0,z=0,A=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=kb-48|0;kb=g;p=v[a+16>>2];while(1){if((f|0)!=2){e=f<<3;i=e+(g+24|0)|0;e=a+e|0;v[i+4>>2]=v[e+44>>2];v[i+8>>2]=v[e+48>>2];f=f+1|0;continue}break}i=v[a+40>>2];k=v[a+36>>2];f=v[a+4>>2];v[g+16>>2]=v[a>>2];v[g+20>>2]=f;q=b+24|0;r=v[a+32>>2];s=v[a+28>>2];w=v[a+72>>2];b=v[a+68>>2];x=b;y=b>>31;b=v[a+64>>2];z=b;A=b>>31;b=v[a+60>>2];C=b;D=b>>31;E=v[a+8>>2];F=v[a+12>>2];while(1){if(d){f=v[g+16>>2];l=(((v[g+20>>2]&2147483647)<<1|f>>>31)&-2)+p|0;b=(((f>>>16|0)+4&131064)<<1)+q|0;j=u[b+14>>1];h=u[b+12>>1];m=u[b+10>>1];n=u[b+8>>1];o=u[b+6>>1];G=u[b+4>>1];H=u[b+2>>1];I=u[b>>1];f=0;e=0;while(1){if((e|0)!=2){b=e+l|0;v[(g+8|0)+(e<<2)>>2]=(((((B(t[b+4|0],m)+B(t[b+2|0],n)|0)+B(h,t[b+6|0])|0)+B(j,t[b+8|0])<<8)/2|0)+((((B(t[b-4|0],H)+B(t[b-6|0],I)|0)+B(t[b-2|0],G)|0)+B(t[b|0],o)<<8)/2|0)|0)/16384;e=e+1|0;continue}break}while(1){if((f|0)!=2){l=(g+8|0)+(f<<2)|0;e=v[l>>2];b=(g+24|0)+(f<<3)|0;j=v[b+8>>2];h=v[b+4>>2];v[b+8>>2]=h;m=e<<8;e=m;e=Jka(C,D,e,e>>31);n=nb;o=b;b=Zb(h,-16777216,16776704);h=Jka(z,A,b,b>>31);e=h+e|0;b=nb+n|0;b=e>>>0<h>>>0?b+1|0:b;h=e;e=Zb(j,-16777216,16776704);j=Jka(x,y,e,e>>31);e=h+j|0;b=nb+b|0;b=e>>>0<j>>>0?b+1|0:b;e=e+8388608|0;b=e>>>0<8388608?b+1|0:b;b=Yc(e,b,24);v[o+4>>2]=b-(m&w);v[l>>2]=(b|0)/256;f=f+1|0;continue}break}k=k+s|0;v[c>>2]=v[c>>2]+B(v[g+8>>2],k>>12);i=i+r|0;v[c+4>>2]=v[c+4>>2]+B(v[g+12>>2],i>>12);Rb(g+16|0,E,F);c=c+8|0;d=d-1|0;continue}break}b=v[g+20>>2];v[a>>2]=v[g+16>>2];v[a+4>>2]=b;v[a+40>>2]=i;v[a+20>>2]=k>>12;v[a+36>>2]=k;v[a+24>>2]=i>>12;f=0;while(1){if((f|0)!=2){b=f<<3;c=b+a|0;b=b+(g+24|0)|0;v[c+44>>2]=v[b+4>>2];v[c+48>>2]=v[b+8>>2];f=f+1|0;continue}break}kb=g+48|0}function B6(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;f=kb-80|0;kb=f;v[f+76>>2]=d;v[f+72>>2]=c;a:{if(!d){break a}g=w[cl(c,d)|0];if((g|0)==33){e=1}else{if((g|0)!=63){break a}e=0}jl(f+48|0,c,d,d-1|0);c=v[f+52>>2];v[f+72>>2]=v[f+48>>2];v[f+76>>2]=c}c=f+48|0;Xd(c);d=v[f+48>>2];Xd(f+32|0);g=bl(d,v[f+36>>2],f+72|0);Xd(c);c=v[f+76>>2];d=v[f+72>>2];b:{c:{d:{e:{if((g|0)==v[f+52>>2]){b=rc(f- -64|0,21688);if(Qc(d,c,v[b>>2],v[b+4>>2])){a=ba(8)|0;v[23540]=0;b=Q(55,f+48|0,10501)|0;c=v[23540];v[23540]=0;if((c|0)==1){break d}a=tc(a,b);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break b}d=P()|0;O()|0;zb(b);break c}if(e){b=ba(8)|0;v[23540]=0;c=Mh(f+32|0,v[f+72>>2],v[f+76>>2]);a=v[23540];v[23540]=0;f:{g:{h:{if((a|0)!=1){v[23540]=0;U(961,f+48|0,17703,c|0);a=v[23540];v[23540]=0;if((a|0)==1){break h}a=0;d=tc(b,f+48|0);v[23540]=0;U(119,d|0,62752,950);d=v[23540];v[23540]=0;if((d|0)!=1){break b}d=P()|0;O()|0;zb(f+48|0);break g}d=P()|0;O()|0;break f}d=P()|0;a=1;O()|0}zb(c);if(!a){break c}}ca(b|0);break c}Nb(a);break e}e=rc(f+24|0,21688);if(Qc(d,c,v[e>>2],v[e+4>>2])){a=ba(8)|0;v[23540]=0;b=Q(55,f+48|0,10501)|0;c=v[23540];v[23540]=0;if((c|0)!=1){a=tc(a,b);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break b}d=P()|0;O()|0;zb(b);break c}d=P()|0;O()|0;ca(a|0);break c}e=rc(f+16|0,12342);if(Qc(d,c,v[e>>2],v[e+4>>2])){i:{switch(v[b+52>>2]){case 0:Kc(a,5604);break e;case 1:Kc(a,11274);break e;case 2:Kc(a,9235);break e;default:break i}}Nb(a);break e}e=c;c=rc(f+8|0,11511);if(Qc(d,e,v[c>>2],v[c+4>>2])){j:{switch(v[b+56>>2]){case 0:Kc(a,15630);break e;case 1:Kc(a,15635);break e;case 2:Kc(a,12616);break e;case 3:Kc(a,9299);break e;default:break j}}Nb(a);break e}Nb(a)}kb=f+80|0;return}d=P()|0;O()|0;ca(a|0)}T(d|0)}L()}function oK(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0;k=kb+-64|0;kb=k;a:{b:{c:{d:{e:{f:{j=Bp(1,28);if(!j){a=mm(ba(4)|0);v[23540]=0;U(119,a|0,92756,26);a=v[23540];v[23540]=0;if((a|0)!=1){break a}break f}v[j+12>>2]=f;v[j+8>>2]=e;v[j+4>>2]=d;v[j>>2]=c?c:927;c=Yf(k+48|0);g:{h:{i:{if(!i){break i}while(1){d=v[i>>2];if(!d){break i}e=v[i+4>>2];j:{if(e){v[23540]=0;d=Q(55,k+32|0,d|0)|0;f=v[23540];v[23540]=0;k:{if((f|0)!=1){v[23540]=0;f=Q(938,c|0,d|0)|0;l=v[23540];v[23540]=0;if((l|0)==1){break k}v[23540]=0;R(270,f|0,e|0);e=v[23540];v[23540]=0;if((e|0)==1){break k}break j}i=V(0)|0;O()|0;break g}i=V(0)|0;O()|0;zb(d);break g}v[23540]=0;d=Q(55,k+16|0,d|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break h}Js(c,d)}zb(d);i=i+8|0;continue}}v[23540]=0;d=S(812,80)|0;e=v[23540];v[23540]=0;l:{m:{n:{if((e|0)!=1){e=v[j+4>>2];f=v[j>>2];v[23540]=0;e=Q(939,f|0,e|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break n}v[k>>2]=e;e=v[eg(k+8|0,k)>>2];v[23540]=0;a=ja(944,d|0,a|0,b|0,e|0,c|0)|0;b=v[23540];v[23540]=0;if((b|0)!=1){break l}i=V(0)|0;O()|0;De(k);break m}i=V(0)|0;O()|0;break g}i=V(0)|0;O()|0}Mb(d);break g}v[j+24>>2]=a;De(k);kl(c);i=j;break d}i=V(0)|0;O()|0}kl(c);_(i|0)|0;v[23540]=0;X(933,15125,j|0,g|0,h|0);a=v[23540];v[23540]=0;if((a|0)!=1){v[23540]=0;Z(18);a=v[23540];v[23540]=0;if((a|0)==1){break f}a=v[j+24>>2];if(a){Mb(Is(a))}i=0;v[j+24>>2]=0;a=v[j+20>>2];if(a){Mb(a);v[j+20>>2]=0}Mb(j);break d}i=V(0)|0;O()|0;v[23540]=0;Z(18);a=v[23540];v[23540]=0;if((a|0)!=1){break e}break b}i=V(0)|0;O()|0}_(i|0)|0;i=0;v[23540]=0;X(933,15125,0,g|0,h|0);a=v[23540];v[23540]=0;if((a|0)==1){break c}$()}kb=k- -64|0;return i|0}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)==1){break b}T(a|0);L()}V(0)|0;O()|0;Vb()}L()}function X_(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;a=kb-1072|0;kb=a;v[a+16>>2]=f;v[a+20>>2]=g;v[a+24>>2]=h;v[a+28>>2]=i;j=a+960|0;v[a+956>>2]=j;j=Fw(j,100,11159,a+16|0);v[a+48>>2]=1119;k=a+48|0;o=se(a+536|0,0,k);v[a+48>>2]=1119;k=se(a+528|0,0,k);a:{b:{c:{d:{if(j>>>0<100){h=a+544|0;f=a+960|0;break d}j=Gd();v[a>>2]=f;v[a+4>>2]=g;v[a+8>>2]=h;v[a+12>>2]=i;j=Xi(a+956|0,j,11159,a);if((j|0)!=-1){f=v[a+956>>2];_e(o,f);_e(k,Pd(j<<2));h=v[k>>2];if(!kk(h)){break d}}v[23540]=0;Z(1120);a=v[23540];v[23540]=0;if((a|0)!=1){break a}j=P()|0;O()|0;break c}g=a+520|0;gd(g,d);v[23540]=0;q=S(1132,g|0)|0;g=v[23540];v[23540]=0;e:{f:{g:{h:{i:{j:{if((g|0)==1){break j}v[23540]=0;X(1144,q|0,f|0,f+j|0,h|0);g=v[23540];v[23540]=0;if((g|0)==1){break j}p=(j|0)>0?w[f|0]==45:p;i=Nb(a+488|0);f=Nb(a+472|0);g=Nb(a+456|0);v[23540]=0;na(1171,c|0,p|0,a+520|0,a+512|0,a+508|0,a+504|0,i|0,f|0,g|0,a+452|0);c=v[23540];v[23540]=0;if((c|0)==1){break i}v[a+36>>2]=1119;c=se(a+40|0,0,a+36|0);m=a+48|0;n=v[a+452>>2];k:{if((n|0)<(j|0)){l=((Hb(g)+(j-n<<1)|0)+Hb(f)|0)+1|0;break k}l=(Hb(g)+Hb(f)|0)+2|0}l=l+n|0;if(l>>>0<101){break h}_e(c,Pd(l<<2));m=v[c>>2];if(m){break h}v[23540]=0;Z(1120);b=v[23540];v[23540]=0;if((b|0)!=1){break a}break g}j=P()|0;O()|0;break e}j=P()|0;O()|0;break f}l=v[d+4>>2];v[23540]=0;pa(1172,m|0,a+36|0,a+32|0,l|0,h|0,(j<<2)+h|0,q|0,p|0,a+512|0,v[a+508>>2],v[a+504>>2],i|0,f|0,g|0,n|0);h=v[23540];v[23540]=0;if((h|0)!=1){v[23540]=0;b=ka(1153,b|0,m|0,v[a+36>>2],v[a+32>>2],d|0,e|0)|0;d=v[23540];v[23540]=0;if((d|0)!=1){break b}}}j=P()|0;O()|0;Xc(c)}Nc(g);Nc(f);zb(i)}ac(a+520|0)}Xc(k);Xc(o);T(j|0);L()}Xc(c);Nc(g);Nc(f);zb(i);ac(a+520|0);Xc(k);Xc(o);kb=a+1072|0;return b|0}L()}function ig(a,b,c,d,e){var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;j=v[a+8>>2]+(B(x[a+14>>1],(w[a+80|0]?c:0)+b|0)>>>1|0)|0;v[a+8>>2]=j;i=w[a+79|0]?x[v[a>>2]+3836>>1]:i;c=x[a+20>>1];l=x[a+22>>1];m=x[a+70>>1];a:{b:{c:{d:{switch(v[a+16>>2]){case 1:b=x[v[a>>2]+3832>>1];f=x[a+26>>1]?x[a+48>>1]>>>x[v[a+52>>2]+((b>>>x[a+44>>1]&7)<<1)>>1]|0:0;g=b;b=x[a+46>>1];f=c+(b?g&b?0:f:f)|0;u[a+20>>1]=f;b=2;h=x[a+28>>1];if((h|0)<=f<<16>>16){break c}break b;case 2:if(w[a+78|0]){break b}case 3:b=0;f=x[v[a>>2]+3832>>1];h=x[a+30>>1]?x[a+60>>1]>>>x[v[a+64>>2]+((f>>>x[a+56>>1]&7)<<1)>>1]|0:0;g=f;f=x[a+58>>1];f=c+(f?g&f?0:h:h)|0;u[a+20>>1]=f;if(f<<16>>16<511){break b}v[a+16>>2]=-1;u[a+20>>1]=511;v[a+72>>2]=0;break a;default:b=0;v[a+72>>2]=0;break a;case 0:break d}}b=1;f=x[v[a>>2]+3832>>1];k=x[a+24>>1]?B((c^-1)<<16>>16,x[a+36>>1]>>>x[v[a+40>>2]+((f>>>x[a+32>>1]&7)<<1)>>1]|0)>>>3|0:0;g=f;f=x[a+34>>1];f=c+(f?g&f?0:k:k)|0;u[a+20>>1]=f;if(f<<16>>16>0){break b}}v[a+16>>2]=b;u[a+20>>1]=h}i=((c+l|0)+m|0)+i<<3;if(e){d=(u[a+74>>1]+u[a+72>>1]>>e)+d|0}d=(j>>>10|0)+d|0;c=d&255;b=d&65535;e:{f:{switch(x[a+12>>1]){case 0:d=(b&512)>>>9|0;b=x[((b&256?c^255:c)<<1)+28464>>1];break e;case 1:d=0;b=x[((b&512?0:b&256?c^255:c)<<1)+28464>>1];break e;case 2:d=0;b=x[((b&256?c^255:c)<<1)+28464>>1];break e;case 3:d=0;b=x[((b&256?0:c)<<1)+28464>>1];break e;case 4:e=0;d=0;if(!(b&512)){e=(c<<1^b<<24>>31)&254;d=(b&256)>>>8|0}b=x[(e<<1)+28464>>1];break e;case 5:d=0;if(b&512){b=0}else{c=c<<1&254;b=b&128?c^255:c}b=x[(b<<1)+28464>>1];break e;case 6:d=(d&512)>>>9|0;b=0;break e;default:break f}}c=d<<3&4088;d=(b&512)>>>9|0;b=d?c^4088:c}u[a+74>>1]=x[a+72>>1];c=a;a=b+i&65535;a=a>>>0<8191?a:8191;b=0-(d&1)^x[((a&255)<<1)+27952>>1]+1024>>>(a>>>8)<<1;u[c+72>>1]=b}return b<<16>>16}function PR(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0;f=kb-16|0;kb=f;t[a|0]=0;c=w[b|0];if(c){t[a|0]=c>>>0>96?-1:c+12|0}t[a+1|0]=w[b+1|0];c=w[b+2|0];d=c-16|0;a:{b:{if((d&255)>>>0<=128){t[a+2|0]=1;c=(d&254)>>>1|0;break b}c:{switch((c+96&240)>>>4|0){case 0:t[a+2|0]=4;c=c&15;break b;case 1:t[a+2|0]=3;c=c&15;break b;case 2:t[a+2|0]=6;c=c&15;break b;case 3:break c;default:break a}}t[a+2|0]=5;c=c&15}t[a+4|0]=c}e=w[b+4|0];d=w[b+5|0];c=w[b+6|0];d:{if(!(c?1:e|d)){break d}e:{f:{g:{h:{i:{j:{switch(e|0){default:k:{switch(e-29|0){case 7:break f;case 5:break g;case 3:break h;case 0:break i;case 1:case 2:case 4:case 6:break d;default:break k}}if((e|0)==128){break e}if((e|0)!=157){break d}t[a+2|0]=15;t[a+3|0]=20;t[a+4|0]=c>>>3;t[f+15|0]=15;h=a,i=w[Yb(b+5|0,f+15|0)|0]|208,t[h+5|0]=i;break d;case 0:Pf(a,c,d);g=w[b+6|0]==15;break d;case 1:t[a+3|0]=2;h=a,i=tg(c<<4|(d&240)>>>4),t[h+5|0]=i;break d;case 2:t[a+3|0]=3;h=a,i=tg(c<<4|(d&240)>>>4),t[h+5|0]=i;break d;case 3:t[a+3|0]=4;h=a,i=tg(c<<4|(d&240)>>>4),t[h+5|0]=i;break d;case 4:t[a+3|0]=5;t[a+5|0]=c&240|(d&240)>>>4;break d;case 8:if(d){t[a+5|0]=d;t[a+3|0]=9;break d}if((c-1&255)>>>0>1){break d}t[a+5|0]=145;t[a+3|0]=20;break d;case 12:t[a+3|0]=13;t[a+5|0]=c>>>1;break d;case 15:if(c){t[a+5|0]=c;t[a+3|0]=17;break d}t[a+3|0]=16;t[a+5|0]=d&15;break d;case 16:break j;case 5:case 6:case 7:case 9:case 10:case 11:case 13:case 14:break d}}TA(a,c,d,1);g=(w[a+3|0]&254)==16;break d}t[a+5|0]=d;t[a+3|0]=18;break d}t[a+3|0]=31;t[a+5|0]=c>>>1;break d}t[a+3|0]=31;t[a+5|0]=c>>>1&120;break d}t[a+5|0]=159;t[a+3|0]=20;break d}t[a+3|0]=21;t[a+5|0]=c>>>2}b=w[b+3|0];l:{if(!b){break l}if(!w[a+3|0]){t[a+5|0]=b;t[a+3|0]=9;break l}if(w[a+2|0]){break l}t[a+2|0]=2;t[a+4|0]=b>>>2}kb=f+16|0;return g}function Zp(a,b,c,d){var e=0,f=C(0),g=C(0),h=C(0),i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=kb-16|0;kb=e;v[e+12>>2]=u[b+780>>1]+w[b+837|0];v[e+8>>2]=u[b+782>>1]+(w[b+838|0]&127);oe(e+12|0,0,127);oe(e+8|0,0,127);k=a+1074312|0;Db(e,k,1);j=v[e+12>>2];a:{if(Cb(v[v[e>>2]>>2],v[e+4>>2])){i=v[e+8>>2];break a}u[b+780>>1]=0;t[b+837|0]=j;i=v[e+8>>2];u[b+782>>1]=0;t[b+838|0]=i}Db(e,k,36);l=B(j,d+256|0);m=(l|0)/256|0;b:{if(!(!Cb(v[v[e>>2]>>2],v[e+4>>2])|i|(l|0)<65024)){m=-1;if(!$c(w[b+788|0])){break b}if(vm(w[b+790|0],w[b+791|0])|x[b+786>>1]|!(w[b+851|0]&2)){break b}v[b+88>>2]=v[b+88>>2]&-32769;break b}v[b+88>>2]=v[b+88>>2]|32768;f=te(C(10),C(C(0-i|0)*C(.00937500037252903)));i=kb-16|0;kb=i;g=C(B(j,d+256|0)>>>0);c:{if(v[a+480180>>2]!=33554432){h=C(110);g=C(C(g/(w[a+480209|0]&128?C(10240):C(12288)))+C(.25));break c}h=C(125);g=C(C(g*C(6))/C(65024))}n=i,o=Uh(C(te(C(2),g)*h)),v[n+12>>2]=o;oe(i+12|0,120,2e4);d=v[i+12>>2];j=v[a+24620>>2];kb=i+16|0;Db(e,k,36);g=C(C(((j|0)<d<<1?j>>>1|0:d)>>>0)*C(6.2831854820251465));d:{if(!(!Cb(v[v[e>>2]>>2],v[e+4>>2])|v[a+480208>>2]&32768)){h=C(C(y[a+24620>>2])/g);g=C(C(C(f*h)+f)+C(-1));z[e>>2]=g;f=C(h*h);break d}h=C(f+f);f=C(g/C(y[a+24620>>2]));z[e>>2]=C(C(1)-h)*f;eO(e,C(2));g=C(C(h-z[e>>2])/f);z[e>>2]=g;f=C(C(1)/C(f*f))}h=C(f+C(g+C(1)));g=C(C(f+C(f+g))/h);f=C(C(-f)/h);h=C(C(1)/h);e:{if(w[b+845|0]==1){n=b,o=Uh(C(C(C(1)-h)*C(16777216))),v[n+60>>2]=o;n=b,o=Uh(C(g*C(16777216))),v[n+64>>2]=o;n=b,o=Uh(C(f*C(16777216))),v[n+68>>2]=o;a=-1;break e}d=Uh(C(h*C(16777216)));v[b+60>>2]=d;n=b,o=Uh(C(g*C(16777216))),v[n+64>>2]=o;n=b,o=Uh(C(f*C(16777216))),v[n+68>>2]=o;a=0;if(d){break e}v[b+60>>2]=1}v[b+72>>2]=a;if(!c){break b}v[b+44>>2]=0;v[b+48>>2]=0;v[b+52>>2]=0;v[b+56>>2]=0}kb=e+16|0;return m}function $_(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;a=kb-464|0;kb=a;v[a+16>>2]=f;v[a+20>>2]=g;v[a+24>>2]=h;v[a+28>>2]=i;j=a+352|0;v[a+348>>2]=j;j=Fw(j,100,11159,a+16|0);v[a+48>>2]=1119;k=a+48|0;o=se(a+232|0,0,k);v[a+48>>2]=1119;k=se(a+224|0,0,k);a:{b:{c:{d:{if(j>>>0<100){h=a+240|0;f=a+352|0;break d}j=Gd();v[a>>2]=f;v[a+4>>2]=g;v[a+8>>2]=h;v[a+12>>2]=i;j=Xi(a+348|0,j,11159,a);if((j|0)!=-1){f=v[a+348>>2];_e(o,f);_e(k,Pd(j));h=v[k>>2];if(!kk(h)){break d}}v[23540]=0;Z(1120);a=v[23540];v[23540]=0;if((a|0)!=1){break a}j=P()|0;O()|0;break c}g=a+216|0;gd(g,d);v[23540]=0;q=S(19,g|0)|0;g=v[23540];v[23540]=0;e:{f:{g:{h:{i:{j:{if((g|0)==1){break j}v[23540]=0;X(1130,q|0,f|0,f+j|0,h|0);g=v[23540];v[23540]=0;if((g|0)==1){break j}p=(j|0)>0?w[f|0]==45:p;i=Nb(a+192|0);f=Nb(a+176|0);g=Nb(a+160|0);v[23540]=0;na(1169,c|0,p|0,a+216|0,a+208|0,a+207|0,a+206|0,i|0,f|0,g|0,a+156|0);c=v[23540];v[23540]=0;if((c|0)==1){break i}v[a+36>>2]=1119;c=se(a+40|0,0,a+36|0);m=a+48|0;n=v[a+156>>2];k:{if((n|0)<(j|0)){l=((Hb(g)+(j-n<<1)|0)+Hb(f)|0)+1|0;break k}l=(Hb(g)+Hb(f)|0)+2|0}l=l+n|0;if(l>>>0<101){break h}_e(c,Pd(l));m=v[c>>2];if(m){break h}v[23540]=0;Z(1120);b=v[23540];v[23540]=0;if((b|0)!=1){break a}break g}j=P()|0;O()|0;break e}j=P()|0;O()|0;break f}l=v[d+4>>2];v[23540]=0;pa(1170,m|0,a+36|0,a+32|0,l|0,h|0,h+j|0,q|0,p|0,a+208|0,t[a+207|0],t[a+206|0],i|0,f|0,g|0,n|0);h=v[23540];v[23540]=0;if((h|0)!=1){v[23540]=0;b=ka(15,b|0,m|0,v[a+36>>2],v[a+32>>2],d|0,e|0)|0;d=v[23540];v[23540]=0;if((d|0)!=1){break b}}}j=P()|0;O()|0;Xc(c)}zb(g);zb(f);zb(i)}ac(a+216|0)}Xc(k);Xc(o);T(j|0);L()}Xc(c);zb(g);zb(f);zb(i);ac(a+216|0);Xc(k);Xc(o);kb=a+464|0;return b|0}L()}function tM(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;g=kb-16|0;kb=g;e=B(b,872)+a|0;j=e+1074992|0;a:{b:{i=v[e+1075080>>2];if(i&131072){h=a+480180|0;e=v[h>>2];i=1;c:{d:{e:{f=v[a+480208>>2];if(f&4096){if(!(e&16777248)){break e}i=!(f&4)}if((e|0)!=64){break d}break b}if((e|0)==64){break b}h=a+480180|0;i=0;break c}if(!i){break c}Db(g+8|0,a+1074312|0,21);if(!Cb(v[v[g+8>>2]>>2],v[g+12>>2])){break c}e=B(b,872)+a|0;f=e+1075811|0;t[f|0]=w[f|0]+(w[e+1075815|0]<<2)}f=B(b,872)+a|0;k=f+1075814|0;l=f+1075811|0;e=py(a,w[k|0],w[l|0]);f:{if(xj(v[j+656>>2])){z[d>>2]=z[d>>2]+C(C(C(B(w[f+1075816|0],e)|0)*C(.05000000074505806))/C(7680));c=f+1075843|0;d=w[c|0];t[c|0]=d&159|64;if(v[a+1074416>>2]!=(v[a+1074392>>2]+1|0)){break f}t[c|0]=d|96;break f}d=v[a+480208>>2];if((d&2101248)==2101248){break a}f=v[h>>2];if(d&4096?f&67633152:0){break a}e=f&5?(w[k|0]&3)==1?0-e|0:e:e;k=a+1074312|0;Db(g+8|0,k,21);f=v[a+480208>>2];g:{if(Cb(v[v[g+8>>2]>>2],v[g+12>>2])){d=f&4;e=d?e:0-e|0;d=d?5:6;break g}d=5;h:{if(f&131072){break h}h=v[h>>2];d=8;if((h|0)==1024){break h}d=7;if(h&524304){break h}d=h&16777248?f&4?6:7:6}Db(g+8|0,k,80);if(!Cb(v[v[g+8>>2]>>2],v[g+12>>2])){break g}d=w[(B(b,872)+a|0)+1075783|0]==26?d+2|0:d}d=(0-B(w[(B(b,872)+a|0)+1075816|0],e)|0)/(1<<d)|0;hk(a,j,c,d,0);e=v[j+656>>2];c=Sp(a,v[j+88>>2],e);if(!c){break f}ob[v[v[c>>2]+92>>2]](c,d,(e?t[e+33|0]:2)<<24>>24,b)}if(!i){break a}Db(g+8|0,a+1074312|0,21);if(Cb(v[v[g+8>>2]>>2],v[g+12>>2])){break a}t[l|0]=w[l|0]+w[(B(b,872)+a|0)+1075815|0];break a}if(!(w[e+1075662|0]&2)){break a}a=Sp(a,i,v[j+656>>2]);if(!a){break a}ob[v[v[a>>2]+92>>2]](a,0,0,b);break a}a=B(b,872)+a|0;b=a+1075811|0;d=w[b|0];if(d&1){v[c>>2]=v[c>>2]+B(w[a+1075816|0],167)}t[b|0]=d+1}kb=g+16|0}function xZ(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;r=kb-16|0;kb=r;j=c;while(1){a:{if((d|0)==(j|0)){j=d;break a}if(!w[j|0]){break a}j=j+1|0;continue}break}v[h>>2]=f;v[e>>2]=c;while(1){b:{c:{d:{if((c|0)==(d|0)|(f|0)==(g|0)){break d}i=v[b+4>>2];v[r+8>>2]=v[b>>2];v[r+12>>2]=i;s=kb-16|0;kb=s;u=ki(s+8|0,v[a+8>>2]);m=j-c|0;k=0;o=0;n=kb-1040|0;kb=n;i=v[e>>2];v[n+12>>2]=i;p=f?f:n+16|0;l=f?g-f>>2:256;e:{f:{if(!(!i|!l)){while(1){g:{q=m>>>2|0;if(q>>>0<l>>>0&m>>>0<=131){break f}q=MG(p,n+12|0,l>>>0>q>>>0?q:l,b);if((q|0)==-1){k=-1;l=0;i=v[n+12>>2];break g}t=(n+16|0)==(p|0)?0:q;l=l-t|0;p=(t<<2)+p|0;m=i+m|0;i=v[n+12>>2];m=i?m-i|0:0;k=k+q|0;if(!i){break g}if(l){continue}}break}}if(!i){break e}}if(!(!l|!m)){o=i;i=k;while(1){h:{k=Xr(p,o,m,b);i:{if(k+2>>>0<=2){j:{switch(k+1|0){case 1:o=0;break i;case 0:break e;default:break j}}v[b>>2]=0;break i}i=i+1|0;o=k+o|0;l=l-1|0;if(l){break h}}k=i;break e}p=p+4|0;m=m-k|0;k=i;if(m){continue}break}break e}o=i}if(f){v[e>>2]=o}kb=n+1040|0;ji(u);kb=s+16|0;k:{l:{m:{n:{if((k|0)==-1){while(1){o:{v[h>>2]=f;if(v[e>>2]==(c|0)){break o}g=1;p:{q:{r:{b=IF(f,c,j-c|0,r+8|0,v[a+8>>2]);switch(b+2|0){case 0:break l;case 2:break p;case 1:break r;default:break q}}v[e>>2]=c;break n}g=b}c=c+g|0;f=v[h>>2]+4|0;continue}break}v[e>>2]=c;break d}f=v[h>>2]+(k<<2)|0;v[h>>2]=f;if((f|0)==(g|0)){break k}c=v[e>>2];if((d|0)==(j|0)){j=d;continue}if(!IF(f,c,1,b,v[a+8>>2])){break m}}a=2;break c}v[h>>2]=v[h>>2]+4;c=v[e>>2]+1|0;v[e>>2]=c;j=c;while(1){if((d|0)==(j|0)){j=d;break b}if(!w[j|0]){break b}j=j+1|0;continue}}v[e>>2]=c;a=1;break c}c=v[e>>2]}a=(c|0)!=(d|0)}kb=r+16|0;return a|0}f=v[h>>2];continue}}function nR(a,b,c,d,e,f,g){var h=0,i=0,j=0,k=0,l=0,m=0,n=0;l=kb-16|0;kb=l;a:{if((c|0)==(g|0)){f=hc(l+8|0,f,c);i=kb-16|0;kb=i;g=sl(d,e,b,c);v[i+12>>2]=g;b:{if((g|0)<=0){g=v[f>>2];break b}c:{if(!c){c=v[f>>2];break c}h=32-c|0;v[i+8>>2]=h;d=v[td(i+8|0,i+12|0)>>2];v[i+12>>2]=g-d;e=v[f>>2];c=-1<<c&-1>>>h-d;v[e>>2]=v[e>>2]&(c^-1)|c&v[b>>2];c=d+v[f+4>>2]|0;v[f+4>>2]=c&31;c=e+(c>>>3&536870908)|0;v[f>>2]=c;b=b+4|0;g=v[i+12>>2]}e=c;d=(g|0)/32|0;c=d<<2;fj(e,b,c);d=g-(d<<5)|0;v[i+12>>2]=d;g=c+v[f>>2]|0;v[f>>2]=g;if((d|0)<=0){break b}d=-1>>>32-d|0;v[g>>2]=v[g>>2]&(d^-1)|d&v[b+c>>2];v[f+4>>2]=v[i+12>>2]}hc(a,g,v[f+4>>2]);kb=i+16|0;break a}i=a;h=hc(l,f,g);g=kb-16|0;kb=g;f=sl(d,e,b,c);v[g+12>>2]=f;d:{if((f|0)<=0){a=v[h+4>>2];break d}e:{if(!c){a=v[h+4>>2];break e}j=32-c|0;v[g+8>>2]=j;e=g+8|0;d=v[td(e,g+12|0)>>2];v[g+12>>2]=f-d;a=v[h+4>>2];k=v[b>>2];v[g+8>>2]=d;m=32-a|0;v[g+4>>2]=m;f=v[h>>2];n=v[f>>2];e=v[Kb(e,g+4|0)>>2];j=k&(-1<<c&-1>>>j-d);v[f>>2]=(-1<<a&-1>>>m-e^-1)&n|(a>>>0>c>>>0?j<<a-c:j>>>c-a|0);k=a+e|0;a=k&31;v[h+4>>2]=a;f=f+(k>>>3&536870908)|0;v[h>>2]=f;d=d-e|0;if((d|0)>0){v[f>>2]=v[f>>2]&(-1>>>32-d^-1)|j>>>c+e;v[h+4>>2]=d;a=d}b=b+4|0;f=v[g+12>>2]}d=32-a|0;e=-1<<a;j=e^-1;while(1){if((f|0)>=32){c=v[h>>2];f=v[b>>2];v[c>>2]=j&v[c>>2]|f<<a;v[h>>2]=c+4;v[c+4>>2]=e&v[c+4>>2]|f>>>d;f=v[g+12>>2]-32|0;v[g+12>>2]=f;b=b+4|0;continue}break}if((f|0)<=0){break d}j=v[b>>2];v[g+8>>2]=d;c=v[h>>2];b=v[c>>2];k=b;b=v[td(g+12|0,g+8|0)>>2];d=k&(e&-1>>>d-b^-1);e=j&-1>>>32-f;v[c>>2]=d|e<<a;d=a+b|0;a=d&31;v[h+4>>2]=a;c=c+(d>>>3&536870908)|0;v[h>>2]=c;d=v[g+12>>2]-b|0;v[g+12>>2]=d;if((d|0)<=0){break d}v[c>>2]=v[c>>2]&(-1>>>32-d^-1)|e>>>b;a=v[g+12>>2];v[h+4>>2]=a}hc(i,v[h>>2],a);kb=g+16|0}kb=l+16|0}function Ur(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;i=kb-128|0;kb=i;v[i+120>>2]=b;k=IG(c,d);v[i+4>>2]=1119;m=HG(i+8|0,i+4|0);j=i+16|0;a:{b:{if(k>>>0>=101){j=Pd(k);if(!j){v[23540]=0;Z(1120);a=v[23540];v[23540]=0;if((a|0)!=1){break a}b=P()|0;O()|0;break b}_e(m,j)}h=j;b=c;while(1){if((b|0)==(d|0)){c:{d:{e:while(1){f:{v[23540]=0;h=Q(1121,a|0,i+120|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break f}if(!(h&(k|0)!=0)){v[23540]=0;b=Q(1122,a|0,i+120|0)|0;a=v[23540];v[23540]=0;if((a|0)==1){break c}if(!b){break d}v[f>>2]=v[f>>2]|2;break d}b=v[a>>2];v[23540]=0;n=S(1123,b|0)|0;b=v[23540];v[23540]=0;g:{if((b|0)!=1){if(g){break g}v[23540]=0;n=Q(1124,e|0,n|0)|0;b=v[23540];v[23540]=0;if((b|0)!=1){break g}}b=P()|0;O()|0;break b}q=o+1|0;r=0;h=j;b=c;while(1){if((b|0)==(d|0)){o=q;if(!r){continue e}v[23540]=0;S(1125,a|0)|0;b=v[23540];v[23540]=0;if((b|0)!=1){h=j;b=c;if(k+l>>>0<2){continue e}while(1){if((b|0)==(d|0)){continue e}h:{if(w[h|0]!=2){break h}if((Hb(b)|0)==(o|0)){break h}t[h|0]=0;l=l-1|0}h=h+1|0;b=b+12|0;continue}}b=P()|0;O()|0;break b}i:{if(w[h|0]!=1){break i}p=t[hg(b,o)|0];j:{if(g){break j}v[23540]=0;p=Q(1124,e|0,p<<24>>24)|0;s=v[23540];v[23540]=0;if((s|0)!=1){break j}b=P()|0;O()|0;break b}k:{if((n&255)==(p&255)){r=1;if((Hb(b)|0)!=(q|0)){break i}t[h|0]=2;l=l+1|0;break k}t[h|0]=0}k=k-1|0}h=h+1|0;b=b+12|0;continue}}break}b=P()|0;O()|0;break b}l:{m:{while(1){if((c|0)==(d|0)){break m}if(w[j|0]!=2){j=j+1|0;c=c+12|0;continue}break}d=c;break l}v[f>>2]=v[f>>2]|4}Xc(m);kb=i+128|0;return d|0}b=P()|0;O()|0}else{n:{if(!Re(b)){t[h|0]=1;break n}t[h|0]=2;l=l+1|0;k=k-1|0}h=h+1|0;b=b+12|0;continue}break}}Xc(m);T(b|0)}L()}function xi(a,b,c,d,e){var f=0,g=0,h=0,i=0,k=0,m=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;q=c*d;r=b*e;m=q+r;s=b*d;t=c*e;p=s-t;a:{if(!Ci(p)){break a}if(!Ci(m)){break a}h=mf(b);f=mf(c);k=h|f;if((k|0)==1){o(+(f?1:0));f=j(1)|0;i=j(0)|0;o(+c);g=j(1)|0;j(0)|0;l(0,i|0);l(1,f&2147483647|g&-2147483648);c=+n();o(0);f=j(1)|0;i=j(0)|0;o(+d);g=j(1)|0;j(0)|0;l(0,i|0);l(1,f&2147483647|g&-2147483648);d=(u=+n(),v=d,w=Ci(d),w?u:v);o(0);f=j(1)|0;i=j(0)|0;o(+e);g=j(1)|0;j(0)|0;l(0,i|0);l(1,f&2147483647|g&-2147483648);e=(u=+n(),v=e,w=Ci(e),w?u:v);o(+(h?1:0));h=j(1)|0;g=j(0)|0;o(+b);f=j(1)|0;j(0)|0;l(0,g|0);l(1,h&2147483647|f&-2147483648);b=+n()}h=mf(d);f=mf(e);b:{if(f?1:h){o(+(f?1:0));f=j(1)|0;g=j(0)|0;o(+e);k=j(1)|0;j(0)|0;l(0,g|0);l(1,f&2147483647|k&-2147483648);e=+n();o(+(h?1:0));h=j(1)|0;g=j(0)|0;o(+d);f=j(1)|0;j(0)|0;l(0,g|0);l(1,h&2147483647|f&-2147483648);d=+n();o(0);h=j(1)|0;g=j(0)|0;o(+b);f=j(1)|0;j(0)|0;l(0,g|0);l(1,h&2147483647|f&-2147483648);b=(u=+n(),v=b,w=Ci(b),w?u:v);o(0);h=j(1)|0;g=j(0)|0;o(+c);f=j(1)|0;j(0)|0;l(0,g|0);l(1,h&2147483647|f&-2147483648);c=(u=+n(),v=c,w=Ci(c),w?u:v);break b}if(k){break b}c:{if(mf(s)){break c}if(mf(t)){break c}if(mf(r)){break c}if(!mf(q)){break a}}o(0);h=j(1)|0;g=j(0)|0;o(+b);f=j(1)|0;j(0)|0;l(0,g|0);l(1,h&2147483647|f&-2147483648);b=(u=+n(),v=b,w=Ci(b),w?u:v);o(0);h=j(1)|0;g=j(0)|0;o(+c);f=j(1)|0;j(0)|0;l(0,g|0);l(1,h&2147483647|f&-2147483648);c=(u=+n(),v=c,w=Ci(c),w?u:v);o(0);h=j(1)|0;g=j(0)|0;o(+d);f=j(1)|0;j(0)|0;l(0,g|0);l(1,h&2147483647|f&-2147483648);d=(u=+n(),v=d,w=Ci(d),w?u:v);o(0);h=j(1)|0;g=j(0)|0;o(+e);f=j(1)|0;j(0)|0;l(0,g|0);l(1,h&2147483647|f&-2147483648);e=(u=+n(),v=e,w=Ci(e),w?u:v)}m=(b*e+d*c)*N;p=(b*d-e*c)*N}nl(a,p,m)}function haa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;c=kb-224|0;kb=c;e=Yl(c+112|0,a);v[23540]=0;d=Q(449,c+96|0,43870)|0;a=v[23540];v[23540]=0;a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{if((a|0)!=1){v[23540]=0;v[c+80>>2]=19988497;v[c+84>>2]=0;U(450,e|0,d|0,c+80|0);a=v[23540];v[23540]=0;if((a|0)==1){break n}Xb(d);if(Kk(w[e|0])){break e}v[23540]=0;d=Q(449,c+80|0,13319)|0;a=v[23540];v[23540]=0;if((a|0)==1){break m}v[23540]=0;X(481,e|0,b|0,d|0,871);a=v[23540];v[23540]=0;if((a|0)==1){break l}Xb(d);v[c+76>>2]=0;v[c+72>>2]=0;v[23540]=0;d=Q(449,c+56|0,16784)|0;a=v[23540];v[23540]=0;if((a|0)==1){break k}v[23540]=0;U(872,e|0,c+76|0,d|0);a=v[23540];v[23540]=0;if((a|0)==1){break j}Xb(d);v[23540]=0;d=Q(449,c+40|0,16756)|0;a=v[23540];v[23540]=0;if((a|0)==1){break i}v[23540]=0;U(872,e|0,c+72|0,d|0);a=v[23540];v[23540]=0;if((a|0)==1){break h}Xb(d);a=v[c+76>>2];d=v[c+72>>2];o:{if(!a|d>>>0<a>>>0){break o}f=v[v[v[v[b+48>>2]+12>>2]+8>>2]+40>>2];if(f>>>0<a>>>0|d>>>0>f>>>0){break o}v[b+20>>2]=d;v[b+16>>2]=a}d=Tb(c+24|0);v[23540]=0;f=Q(449,c+8|0,14145)|0;a=v[23540];v[23540]=0;if((a|0)==1){break d}v[23540]=0;U(873,e|0,d|0,f|0);a=v[23540];v[23540]=0;if((a|0)==1){break g}Xb(f);if(pc(v[d>>2],v[d+4>>2])){break f}a=v[b+16>>2];v[23540]=0;R(826,d|0,a|0);a=v[23540];v[23540]=0;if((a|0)!=1){break f}break c}a=P()|0;O()|0;break a}a=P()|0;O()|0;Xb(d);break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;Xb(d);break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;Xb(d);break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;Xb(d);break a}a=P()|0;O()|0;Xb(f);break b}v[23540]=0;R(874,b|0,d|0);a=v[23540];v[23540]=0;if((a|0)==1){break c}wc(d)}kh(e);kb=c+224|0;return}a=P()|0;O()|0;break b}a=P()|0;O()|0}wc(d)}kh(e);T(a|0);L()}function Sr(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;i=kb-128|0;kb=i;v[i+120>>2]=b;k=IG(c,d);v[i+4>>2]=1119;m=HG(i+8|0,i+4|0);j=i+16|0;a:{b:{if(k>>>0>=101){j=Pd(k);if(!j){v[23540]=0;Z(1120);a=v[23540];v[23540]=0;if((a|0)!=1){break a}b=P()|0;O()|0;break b}_e(m,j)}h=j;b=c;while(1){if((b|0)==(d|0)){c:{d:{e:while(1){f:{v[23540]=0;h=Q(1137,a|0,i+120|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break f}if(!(h&(k|0)!=0)){v[23540]=0;b=Q(1138,a|0,i+120|0)|0;a=v[23540];v[23540]=0;if((a|0)==1){break c}if(!b){break d}v[f>>2]=v[f>>2]|2;break d}b=v[a>>2];v[23540]=0;n=S(1139,b|0)|0;b=v[23540];v[23540]=0;g:{if((b|0)!=1){if(g){break g}v[23540]=0;n=Q(1140,e|0,n|0)|0;b=v[23540];v[23540]=0;if((b|0)!=1){break g}}b=P()|0;O()|0;break b}q=o+1|0;r=0;h=j;b=c;while(1){if((b|0)==(d|0)){o=q;if(!r){continue e}v[23540]=0;S(1141,a|0)|0;b=v[23540];v[23540]=0;if((b|0)!=1){h=j;b=c;if(k+l>>>0<2){continue e}while(1){if((b|0)==(d|0)){continue e}h:{if(w[h|0]!=2){break h}if((Hb(b)|0)==(o|0)){break h}t[h|0]=0;l=l-1|0}h=h+1|0;b=b+12|0;continue}}b=P()|0;O()|0;break b}i:{if(w[h|0]!=1){break i}p=v[qj(b,o)>>2];j:{if(g){break j}v[23540]=0;p=Q(1140,e|0,p|0)|0;s=v[23540];v[23540]=0;if((s|0)!=1){break j}b=P()|0;O()|0;break b}k:{if((n|0)==(p|0)){r=1;if((Hb(b)|0)!=(q|0)){break i}t[h|0]=2;l=l+1|0;break k}t[h|0]=0}k=k-1|0}h=h+1|0;b=b+12|0;continue}}break}b=P()|0;O()|0;break b}l:{m:{while(1){if((c|0)==(d|0)){break m}if(w[j|0]!=2){j=j+1|0;c=c+12|0;continue}break}d=c;break l}v[f>>2]=v[f>>2]|4}Xc(m);kb=i+128|0;return d|0}b=P()|0;O()|0}else{n:{if(!Re(b)){t[h|0]=1;break n}t[h|0]=2;l=l+1|0;k=k-1|0}h=h+1|0;b=b+12|0;continue}break}}Xc(m);T(b|0)}L()}function Ica(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,C=0,D=0,E=0,F=0;g=kb-48|0;kb=g;o=v[a+16>>2];while(1){if((f|0)!=2){e=f<<3;j=e+(g+24|0)|0;e=a+e|0;v[j+4>>2]=v[e+44>>2];v[j+8>>2]=v[e+48>>2];f=f+1|0;continue}break}j=v[a+24>>2];p=v[a+20>>2];f=v[a+4>>2];v[g+16>>2]=v[a>>2];v[g+20>>2]=f;q=b+24|0;r=v[a+72>>2];b=v[a+68>>2];s=b;t=b>>31;b=v[a+64>>2];w=b;x=b>>31;b=v[a+60>>2];y=b;z=b>>31;A=v[a+8>>2];C=v[a+12>>2];while(1){if(d){f=v[g+16>>2];k=((((v[g+20>>2]&2147483647)<<1|f>>>31)&2147483646)<<1)+o|0;b=(((f>>>16|0)+4&131064)<<1)+q|0;i=u[b+14>>1];h=u[b+12>>1];l=u[b+10>>1];m=u[b+8>>1];n=u[b+6>>1];D=u[b+4>>1];E=u[b+2>>1];F=u[b>>1];f=0;e=0;while(1){if((e|0)!=2){b=k+(e<<1)|0;v[(g+8|0)+(e<<2)>>2]=(((((B(u[b+8>>1],l)+B(u[b+4>>1],m)|0)+B(h,u[b+12>>1])|0)+B(i,u[b+16>>1])|0)/2|0)+((((B(u[b-8>>1],E)+B(u[b-12>>1],F)|0)+B(u[b-4>>1],D)|0)+B(u[b>>1],n)|0)/2|0)|0)/16384;e=e+1|0;continue}break}while(1){if((f|0)!=2){k=(g+8|0)+(f<<2)|0;e=v[k>>2];b=(g+24|0)+(f<<3)|0;i=v[b+8>>2];h=v[b+4>>2];v[b+8>>2]=h;l=e<<8;e=l;e=Jka(y,z,e,e>>31);m=nb;n=b;b=Zb(h,-16777216,16776704);h=Jka(w,x,b,b>>31);e=h+e|0;b=nb+m|0;b=e>>>0<h>>>0?b+1|0:b;h=e;e=Zb(i,-16777216,16776704);i=Jka(s,t,e,e>>31);e=h+i|0;b=nb+b|0;b=e>>>0<i>>>0?b+1|0:b;e=e+8388608|0;b=e>>>0<8388608?b+1|0:b;b=Yc(e,b,24);v[n+4>>2]=b-(l&r);v[k>>2]=(b|0)/256;f=f+1|0;continue}break}v[c>>2]=v[c>>2]+B(v[g+8>>2],p);v[c+4>>2]=v[c+4>>2]+B(j,v[g+12>>2]);Rb(g+16|0,A,C);c=c+8|0;d=d-1|0;continue}break}b=v[g+20>>2];v[a>>2]=v[g+16>>2];v[a+4>>2]=b;f=0;while(1){if((f|0)!=2){b=f<<3;c=b+a|0;b=b+(g+24|0)|0;v[c+44>>2]=v[b+4>>2];v[c+48>>2]=v[b+8>>2];f=f+1|0;continue}break}kb=g+48|0}function J6(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=kb+-64|0;kb=d;f=1;a:{if(Re(c)){break a}e=w[PJ(c)|0];if((e|0)!=33){if((e|0)!=63){break a}f=0}e=d+48|0;Pv(e,c,0,Hb(c)-1|0);Bc(c,e);zb(e)}e=d+48|0;Xd(e);g=v[d+48>>2];Xd(d+40|0);g=OJ(g,v[d+44>>2],c);Xd(e);b:{c:{d:{e:{f:{if((g|0)==v[d+52>>2]){if(ue(c,21688)){a=ba(8)|0;v[23540]=0;b=Q(55,d+48|0,10501)|0;c=v[23540];v[23540]=0;if((c|0)==1){break d}a=tc(a,b);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break b}c=P()|0;O()|0;zb(b);break c}if(!f){break f}a=ba(8)|0;v[23540]=0;U(952,d+48|0,17703,c|0);b=v[23540];v[23540]=0;if((b|0)!=1){a=tc(a,d+48|0);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break b}c=P()|0;O()|0;zb(d+48|0);break c}c=P()|0;O()|0;ca(a|0);break c}e=Nb(d+48|0);g:{h:{i:{j:{switch(v[g+4>>2]){case 0:Fe(d+32|0,c);v[23540]=0;b=fa(953,b|0,v[d+32>>2],v[d+36>>2],f|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){v[23540]=0;t[d+40|0]=b;R(954,a|0,d+40|0);a=v[23540];v[23540]=0;if((a|0)!=1){break g}}break i;case 1:Fe(d+24|0,c);v[23540]=0;b=qF(b,v[d+24>>2],v[d+28>>2],f);c=nb;f=v[23540];v[23540]=0;if((f|0)!=1){v[23540]=0;v[d+40>>2]=b;v[d+44>>2]=c;R(956,a|0,d+40|0);a=v[23540];v[23540]=0;if((a|0)!=1){break g}}break i;case 2:Fe(d+16|0,c);v[23540]=0;h=+za(957,b|0,v[d+16>>2],v[d+20>>2],f|0);b=v[23540];v[23540]=0;if((b|0)!=1){v[23540]=0;A[d+40>>3]=h;R(958,a|0,d+40|0);a=v[23540];v[23540]=0;if((a|0)!=1){break g}}break i;case 3:break j;default:break h}}Fe(d+8|0,c);v[23540]=0;da(959,a|0,b|0,v[d+8>>2],v[d+12>>2],f|0);a=v[23540];v[23540]=0;if((a|0)!=1){break g}}c=P()|0;O()|0;zb(e);break c}ad(a,e)}zb(e);break e}Nb(a)}kb=d- -64|0;return}c=P()|0;O()|0;ca(a|0)}T(c|0)}L()}function Uba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,k=0,m=0,p=0,q=0,r=0,s=0,t=0,u=0,w=0,x=0,y=0,z=0;h=kb-48|0;kb=h;f=OO(h+32|0,1<<v[b+12>>2]);g=v[f>>2];while(1){c=v[a>>2];if(Ug(c,v[a+4>>2])>>>0>d>>>0){c=bf(c,d);NO(Kd(g,d),A[c>>3]);d=d+1|0;continue}break}MO(b,f);x=h,y=Fb(v[f>>2]),v[x+8>>2]=y;w=Fb(v[f+4>>2]);while(1){g=v[h+8>>2];if(Pb(g,w)){m=A[g+8>>3];k=kb-32|0;kb=k;o(+A[g>>3]);e=j(1)|0;r=j(0)|0;o(+m);c=j(1)|0;s=j(0)|0;q=e&2147483647;t=c&2147483647;d=t;c=(q|0)==(d|0)&r>>>0<s>>>0|d>>>0>q>>>0;e=c?r:s;c=c?q:d;d=c;l(0,e|0);l(1,c|0);p=+n();u=c>>>20|0;i=p;a:{if((u|0)==2047){break a}c=(q|0)==(t|0)&r>>>0>s>>>0|q>>>0>t>>>0;l(0,(c?r:s)|0);c=c?q:t;l(1,c|0);m=+n();b:{if(!(d|e)){break b}c=c>>>20|0;if((c|0)==2047){break b}i=m+p;if((c-u|0)>=65){break a}c:{if(c>>>0>=1534){p=p*1.90109156629516e-211;m=m*1.90109156629516e-211;i=5.260135901548374e210;break c}i=1;if(u>>>0>572){break c}p=p*5.260135901548374e210;m=m*5.260135901548374e210;i=1.90109156629516e-211}ZH(k+24|0,k+16|0,m);ZH(k+8|0,k,p);i=i*K(A[k>>3]+A[k+16>>3]+A[k+8>>3]+A[k+24>>3]);break a}i=m}p=i;kb=k+32|0;NO(g,Ep(p));iq(h+8|0);continue}break}LO(b,f);KO(f);e=v[f>>2];g=mk(e,v[f+4>>2])>>>1|0;c=g>>>0>1?g:1;d=1;while(1){if((c|0)!=(d|0)){oz(Kd(e,d),2);oz(Kd(e,d+g|0),0);d=d+1|0;continue}break}MO(b,f);x=h,y=Fb(v[f>>2]),v[x+24>>2]=y;g=Fb(v[f+4>>2]);while(1){e=v[h+24>>2];if(Pb(e,g)){JO(h+8|0,A[e>>3],A[e+8>>3]);c=v[h+20>>2];v[e+8>>2]=v[h+16>>2];v[e+12>>2]=c;c=v[h+12>>2];v[e>>2]=v[h+8>>2];v[e+4>>2]=c;iq(h+24|0);continue}break}LO(b,f);KO(f);g=v[a>>2];c=Ug(g,v[a+4>>2]);b=v[f>>2];d=0;while(1){if((c|0)==(d|0)){Bm(f);kb=h+48|0}else{a=Kd(b,d);x=bf(g,d),z=A[a>>3],A[x>>3]=z;d=d+1|0;continue}break}}function Jca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,w=0,x=0,y=0,z=0,A=0,C=0,D=0,E=0,F=0,G=0;g=kb-48|0;kb=g;o=v[a+16>>2];while(1){if((f|0)!=2){e=f<<3;j=e+(g+24|0)|0;e=a+e|0;v[j+4>>2]=v[e+44>>2];v[j+8>>2]=v[e+48>>2];f=f+1|0;continue}break}j=v[a+24>>2];p=v[a+20>>2];f=v[a+4>>2];v[g+16>>2]=v[a>>2];v[g+20>>2]=f;q=b+24|0;r=v[a+72>>2];b=v[a+68>>2];s=b;w=b>>31;b=v[a+64>>2];x=b;y=b>>31;b=v[a+60>>2];z=b;A=b>>31;C=v[a+8>>2];D=v[a+12>>2];while(1){if(d){f=v[g+16>>2];k=(((v[g+20>>2]&2147483647)<<1|f>>>31)&-2)+o|0;b=(((f>>>16|0)+4&131064)<<1)+q|0;i=u[b+14>>1];h=u[b+12>>1];l=u[b+10>>1];m=u[b+8>>1];n=u[b+6>>1];E=u[b+4>>1];F=u[b+2>>1];G=u[b>>1];f=0;e=0;while(1){if((e|0)!=2){b=e+k|0;v[(g+8|0)+(e<<2)>>2]=(((((B(t[b+4|0],l)+B(t[b+2|0],m)|0)+B(h,t[b+6|0])|0)+B(i,t[b+8|0])<<8)/2|0)+((((B(t[b-4|0],F)+B(t[b-6|0],G)|0)+B(t[b-2|0],E)|0)+B(t[b|0],n)<<8)/2|0)|0)/16384;e=e+1|0;continue}break}while(1){if((f|0)!=2){k=(g+8|0)+(f<<2)|0;e=v[k>>2];b=(g+24|0)+(f<<3)|0;i=v[b+8>>2];h=v[b+4>>2];v[b+8>>2]=h;l=e<<8;e=l;e=Jka(z,A,e,e>>31);m=nb;n=b;b=Zb(h,-16777216,16776704);h=Jka(x,y,b,b>>31);e=h+e|0;b=nb+m|0;b=e>>>0<h>>>0?b+1|0:b;h=e;e=Zb(i,-16777216,16776704);i=Jka(s,w,e,e>>31);e=h+i|0;b=nb+b|0;b=e>>>0<i>>>0?b+1|0:b;e=e+8388608|0;b=e>>>0<8388608?b+1|0:b;b=Yc(e,b,24);v[n+4>>2]=b-(l&r);v[k>>2]=(b|0)/256;f=f+1|0;continue}break}v[c>>2]=v[c>>2]+B(v[g+8>>2],p);v[c+4>>2]=v[c+4>>2]+B(j,v[g+12>>2]);Rb(g+16|0,C,D);c=c+8|0;d=d-1|0;continue}break}b=v[g+20>>2];v[a>>2]=v[g+16>>2];v[a+4>>2]=b;f=0;while(1){if((f|0)!=2){b=f<<3;c=b+a|0;b=b+(g+24|0)|0;v[c+44>>2]=v[b+4>>2];v[c+48>>2]=v[b+8>>2];f=f+1|0;continue}break}kb=g+48|0}function SW(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=kb+-64|0;kb=f;zc(b);Zo(a);a:{if(!ei(b,f+56|0)){break a}if(!wD(f+56|0)){break a}if(!c){l=1;break a}if(!Qb(v[b>>2],v[b+8>>2],4)){break a}Lv(a);p=f,q=Kv(),v[p+32>>2]=q;c=f+32|0;Jv(Vj(v[a+4>>2])+32|0,c);sr(c);k=v[Vj(v[a+4>>2])+32>>2];c=Vg(v[b>>2]);if(c&1){break a}d=c-4|0;dd(b,d);h=kb-16|0;kb=h;c=h+8|0;yv(c,b);e=w[Lb(c,0)|0];i=w[Lb(c,1)|0];c=w[Lb(c,2)|0];kb=h+16|0;h=c|(i<<8|e<<16);if(!h){break a}v[23540]=0;R(175,k|0,h|0);c=v[23540];v[23540]=0;l=1;if((c|0)==1){a=V(92756)|0;if((O()|0)==(ea(92756)|0)){_(a|0)|0;$();l=0;break a}T(a|0);L()}dd(b,4);m=f+32|0;vD(m,b);i=v[k>>2];e=kb-32|0;kb=e;b=v[f+32>>2];t[e+24|0]=w[b|0];t[e+25|0]=w[b+1|0];t[e+26|0]=w[b+2|0];t[e+27|0]=w[b+3|0];c=ir(e+8|0);d=b+d|0;v[c+12>>2]=d-4;v[c+8>>2]=b;Sj(c,w[d-1|0]);b=h;b:while(1){c:{d:{e:{if(!b){break e}if(Sj(c,1)){break d}d=1;while(1){g=Sj(c,2);d=g+d|0;if((g|0)==3){continue}break}v[e+4>>2]=d;xc(e+4|0,b);d=0;g=v[e+4>>2];while(1)if((d|0)==(g|0)){if(!b){break e}break d}else{b=b-1|0;p=i+b|0,q=Sj(c,8),t[p|0]=q;d=d+1|0;continue}}kb=e+32|0;break c}g=Sj(c,2);d=g+2|0;v[e+4>>2]=d;f:{if((g|0)==3){if(Sj(c,1)){g=w[Lb(e+24|0,3)|0]}else{g=7}g=Sj(c,g);while(1){j=Sj(c,3);d=j+d|0;if((j|0)==7){continue}break}v[e+4>>2]=d;break f}g=Sj(c,w[Lb(e+24|0,g)|0])}xc(e+4|0,b);d=0;o=v[e+4>>2];while(1){if((d|0)==(o|0)){continue b}j=0;n=b+g|0;if(h>>>0>n>>>0){j=w[i+n|0]}b=b-1|0;t[i+b|0]=j;d=d+1|0;continue}}break}re(f+16|0,v[k>>2],v[k+4>>2]);_g(f+24|0,v[f+16>>2],v[f+20>>2]);b=ee(f+8|0);b=qr(m,v[f+24>>2],v[f+28>>2],v[b>>2],v[b+4>>2]);hd(Vj(v[a+4>>2])+12|0,b);Bb(b)}kb=f- -64|0;return l|0}function $ha(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=kb-16|0;kb=g;i=rf(a,c);me(g,v[a+36>>2]);j=a;a:{if(!i){Sc(g,a+32|0,5);c=0;if(Cb(v[v[g>>2]>>2],v[g+4>>2])){break a}}e=kb-192|0;kb=e;f=Yl(e+80|0,v[a+36>>2]);v[23540]=0;a=Q(449,e- -64|0,27871)|0;c=v[23540];v[23540]=0;b:{c:{d:{e:{if((c|0)!=1){v[23540]=0;v[e>>2]=19988497;v[e+4>>2]=0;U(450,f|0,a|0,e|0);c=v[23540];v[23540]=0;if((c|0)==1){break e}Xb(a);if(!Kk(w[f|0])){break d}break b}c=P()|0;O()|0;break c}c=P()|0;O()|0;Xb(a);break c}t[e+63|0]=0;t[e+62|0]=0;v[23540]=0;a=Q(449,e+48|0,10113)|0;c=v[23540];v[23540]=0;f:{g:{h:{i:{if((c|0)!=1){v[23540]=0;U(489,f|0,e+63|0,a|0);c=v[23540];v[23540]=0;if((c|0)==1){break i}Xb(a);if(!w[e+63|0]){break b}wf(e+63|0,50);v[23540]=0;a=Q(449,e+32|0,13209)|0;c=v[23540];v[23540]=0;if((c|0)==1){break f}v[23540]=0;U(489,f|0,e+62|0,a|0);c=v[23540];v[23540]=0;if((c|0)==1){break g}Xb(a);a=v[b>>2];c=sj(a,v[b+4>>2]);h=w[e+63|0];if(c>>>0<h>>>0){a=Dz(e,v[b+12>>2]);v[23540]=0;U(490,b|0,h|0,a|0);c=v[23540];v[23540]=0;if((c|0)==1){break h}ql(a);a=v[b>>2]}k=x[zj(a,0)+28>>1];c=0;j:{while(1){a=c&255;if(a>>>0>=h>>>0){a=w[e+62|0];n=b,o=sj(v[b>>2],v[b+4>>2])>>>0>a>>>0?a:0,t[n+16|0]=o;break b}Ve(zj(v[b>>2],a),k);l=v[b>>2];v[23540]=0;R(491,e|0,c|0);m=v[23540];v[23540]=0;if((m|0)!=1){v[23540]=0;X(492,f|0,zj(l,a)|0,e|0,d|0);a=v[23540];v[23540]=0;if((a|0)==1){break j}c=c+1|0;Xb(e);continue}break}c=P()|0;O()|0;break c}c=P()|0;O()|0;Xb(e);break c}c=P()|0;O()|0;break c}c=P()|0;O()|0;Xb(a);break c}c=P()|0;O()|0;ql(a);break c}c=P()|0;O()|0;Xb(a);break c}c=P()|0;O()|0}kh(f);T(c|0);L()}kh(f);kb=e+192|0;c=i}Ye(j,c);kb=g+16|0}function ida(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,C=0,D=0;g=kb-48|0;kb=g;o=v[a+16>>2];b=0;while(1){if((b|0)!=2){e=b<<3;h=e+(g+24|0)|0;e=a+e|0;v[h+4>>2]=v[e+44>>2];v[h+8>>2]=v[e+48>>2];b=b+1|0;continue}break}h=v[a+40>>2];k=v[a+36>>2];b=v[a+4>>2];v[g+16>>2]=v[a>>2];v[g+20>>2]=b;p=v[a+32>>2];q=v[a+28>>2];r=v[a+72>>2];b=v[a+68>>2];s=b;t=b>>31;b=v[a+64>>2];w=b;x=b>>31;b=v[a+60>>2];y=b;z=b>>31;A=v[a+8>>2];C=v[a+12>>2];while(1){if(d){e=v[g+16>>2];m=((((v[g+20>>2]&2147483647)<<1|e>>>31)&2147483646)<<1)+o|0;b=e>>>21&2040;j=u[b+39782>>1];i=u[b+39780>>1];n=u[b+39778>>1];l=u[b+39776>>1];b=0;e=0;while(1){if((e|0)!=2){f=m+(e<<1)|0;v[(g+8|0)+(e<<2)>>2]=(((B(u[f>>1],n)+B(u[f-4>>1],l)|0)+B(i,u[f+4>>1])|0)+B(j,u[f+8>>1])|0)/16384;e=e+1|0;continue}break}while(1){if((b|0)!=2){m=(g+8|0)+(b<<2)|0;f=v[m>>2];e=(g+24|0)+(b<<3)|0;j=v[e+8>>2];i=v[e+4>>2];v[e+8>>2]=i;n=f<<8;f=n;f=Jka(y,z,f,f>>31);l=nb;D=e;e=Zb(i,-16777216,16776704);i=Jka(w,x,e,e>>31);f=i+f|0;e=nb+l|0;e=f>>>0<i>>>0?e+1|0:e;l=f;f=Zb(j,-16777216,16776704);j=Jka(s,t,f,f>>31);f=l+j|0;e=nb+e|0;e=f>>>0<j>>>0?e+1|0:e;f=f+8388608|0;e=f>>>0<8388608?e+1|0:e;e=Yc(f,e,24);v[D+4>>2]=e-(n&r);v[m>>2]=(e|0)/256;b=b+1|0;continue}break}k=k+q|0;v[c>>2]=v[c>>2]+B(v[g+8>>2],k>>12);h=h+p|0;v[c+4>>2]=v[c+4>>2]+B(v[g+12>>2],h>>12);Rb(g+16|0,A,C);c=c+8|0;d=d-1|0;continue}break}b=v[g+20>>2];v[a>>2]=v[g+16>>2];v[a+4>>2]=b;v[a+40>>2]=h;v[a+20>>2]=k>>12;v[a+36>>2]=k;v[a+24>>2]=h>>12;b=0;while(1){if((b|0)!=2){c=b<<3;d=c+a|0;c=c+(g+24|0)|0;v[d+44>>2]=v[c+4>>2];v[d+48>>2]=v[c+8>>2];b=b+1|0;continue}break}kb=g+48|0}function hN(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=kb-16|0;kb=c;d=a+1074376|0;e=B(b,872);a:{if(v[(d+e|0)+704>>2]&134218752){break a}h=v[(a+e|0)+1075648>>2];if(!oj(h)|w[h+15|0]&2){break a}d=Ml(a,d,b,2,1)-1|0;if((d&255)>>>0>249){break a}g=v[Md(a+906300|0,d)>>2];if(!g){break a}f=B(b,872)+a|0;j=f+1075780|0;d=w[j|0];b:{if(w[f+1075782|0]==1){t[c+8|0]=64;e=w[Yb(f+1075784|0,c+8|0)|0];break b}e=255;if(w[f+1075783|0]!=13){break b}t[c+8|0]=64;e=w[Yb((B(b,872)+a|0)+1075785|0,c+8|0)|0]}i=a+1074312|0;Db(c+8|0,i,2);if(Cb(v[v[c+8>>2]>>2],v[c+12>>2])){if(d){if($c(d)){d=w[Lb(h+108|0,d-1|0)|0]}sm(a,b,d,x[(B(b,872)+a|0)+1075680>>1]);break a}if((e|0)==255){break a}ob[v[v[g>>2]+76>>2]](g,39,e,b);break a}k=v[h+4>>2];c:{if(!d){break c}f=w[h+35|0]?k<<2:v[(B(b,872)+a|0)+1075680>>2];l=u[(B(b,872)+a|0)+1075768>>1];Db(c+8|0,i,28);m=c,n=f+(Cb(v[v[c+8>>2]>>2],v[c+12>>2])?l<<2:l)|0,v[m+4>>2]=n;oe(c+4|0,0,256);f=d;if($c(d)){f=w[Lb(h+108|0,d-1|0)|0]}Db(c+8|0,i,117);if(!Cb(v[v[c+8>>2]>>2],v[c+12>>2])){if(vm(w[j+2|0],w[j+3|0])){break c}}sm(a,b,f&255,x[c+4>>1])}f=w[h+35|0];Db(c+8|0,i,101);if(Cb(v[v[c+8>>2]>>2],v[c+12>>2])){a=(d|0)!=0}else{a=$c(d)}if(a^1|(f|0)!=1?(a|(e|0)==255)==1:0){break a}d:{switch(w[h+36|0]){case 1:if((e|0)!=255){ct(v[g+20>>2],C(C(C(e<<1)/C(-127))+C(1)));break a}ct(v[g+20>>2],C(C(C(k<<1>>>0)/C(-127))+C(1)));break a;case 0:break d;default:break a}}if((e|0)!=255){t[c+8|0]=127;t[c+4|0]=e<<1;n=g,o=7,p=w[Yb(c+8|0,c+4|0)|0],q=b,m=v[v[g>>2]+76>>2],ob[m](n|0,o|0,p|0,q|0);break a}v[c+8>>2]=127;v[c+4>>2]=k<<1;q=g,p=7,o=w[Kb(c+8|0,c+4|0)|0],n=b,m=v[v[g>>2]+76>>2],ob[m](q|0,p|0,o|0,n|0)}kb=c+16|0}function jda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,w=0,x=0,y=0,z=0,A=0,C=0,D=0,E=0;g=kb-48|0;kb=g;o=v[a+16>>2];b=0;while(1){if((b|0)!=2){e=b<<3;h=e+(g+24|0)|0;e=a+e|0;v[h+4>>2]=v[e+44>>2];v[h+8>>2]=v[e+48>>2];b=b+1|0;continue}break}h=v[a+40>>2];k=v[a+36>>2];b=v[a+4>>2];v[g+16>>2]=v[a>>2];v[g+20>>2]=b;p=v[a+32>>2];q=v[a+28>>2];r=v[a+72>>2];b=v[a+68>>2];s=b;w=b>>31;b=v[a+64>>2];x=b;y=b>>31;b=v[a+60>>2];z=b;A=b>>31;C=v[a+8>>2];D=v[a+12>>2];while(1){if(d){e=v[g+16>>2];m=(((v[g+20>>2]&2147483647)<<1|e>>>31)&-2)+o|0;b=e>>>21&2040;j=u[b+39782>>1];i=u[b+39780>>1];n=u[b+39778>>1];l=u[b+39776>>1];b=0;e=0;while(1){if((e|0)!=2){f=e+m|0;v[(g+8|0)+(e<<2)>>2]=(((B(t[f|0],n)+B(t[f-2|0],l)|0)+B(i,t[f+2|0])|0)+B(j,t[f+4|0])<<8)/16384;e=e+1|0;continue}break}while(1){if((b|0)!=2){m=(g+8|0)+(b<<2)|0;f=v[m>>2];e=(g+24|0)+(b<<3)|0;j=v[e+8>>2];i=v[e+4>>2];v[e+8>>2]=i;n=f<<8;f=n;f=Jka(z,A,f,f>>31);l=nb;E=e;e=Zb(i,-16777216,16776704);i=Jka(x,y,e,e>>31);f=i+f|0;e=nb+l|0;e=f>>>0<i>>>0?e+1|0:e;l=f;f=Zb(j,-16777216,16776704);j=Jka(s,w,f,f>>31);f=l+j|0;e=nb+e|0;e=f>>>0<j>>>0?e+1|0:e;f=f+8388608|0;e=f>>>0<8388608?e+1|0:e;e=Yc(f,e,24);v[E+4>>2]=e-(n&r);v[m>>2]=(e|0)/256;b=b+1|0;continue}break}k=k+q|0;v[c>>2]=v[c>>2]+B(v[g+8>>2],k>>12);h=h+p|0;v[c+4>>2]=v[c+4>>2]+B(v[g+12>>2],h>>12);Rb(g+16|0,C,D);c=c+8|0;d=d-1|0;continue}break}b=v[g+20>>2];v[a>>2]=v[g+16>>2];v[a+4>>2]=b;v[a+40>>2]=h;v[a+20>>2]=k>>12;v[a+36>>2]=k;v[a+24>>2]=h>>12;b=0;while(1){if((b|0)!=2){c=b<<3;d=c+a|0;c=c+(g+24|0)|0;v[d+44>>2]=v[c+4>>2];v[d+48>>2]=v[c+8>>2];b=b+1|0;continue}break}kb=g+48|0}function rea(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;h=kb-48|0;kb=h;k=c+484344|0;xg(k,w[b+70|0]|w[b+71|0]<<8);a:{b:{while(1){if((w[b+70|0]|w[b+71|0]<<8)>>>0<=j>>>0){break b}f=v[a+8>>2];e=Bg(a);$b(a,1);c:{if((w[b+58|0]|w[b+59|0]<<8)==258){c=Me(a)+1|0;break c}c=Rg(a)}d=Rg(a);dd(a,e+f|0);ae(h,a,d);f=kc(h+24|0,h);Bb(h);v[23540]=0;c=W(226,k|0,j&65535,(c?c>>>0<1024?c:1024:64)|0)|0;e=v[23540];v[23540]=0;if((e|0)!=1){d:{if(!(c&(d|0)!=0)){break d}c=_b(v[k>>2],j);m=h,n=Fb(v[c>>2]),v[m>>2]=n;l=Fb(v[c+4>>2]);while(1){c=v[h>>2];if(!Pb(c,l)){break d}v[23540]=0;d=S(206,f|0)|0;e=v[23540];v[23540]=0;e:{f:{g:{if((e|0)!=1){if(!(d&128)){break g}if(d&1){v[23540]=0;e=S(206,f|0)|0;i=v[23540];v[23540]=0;if((i|0)==1){break a}t[c|0]=e}if(d&2){break f}break e}break a}t[c|0]=d;d=255}v[23540]=0;e=S(206,f|0)|0;i=v[23540];v[23540]=0;if((i|0)==1){break a}t[c+1|0]=e}i=0;e=0;if(d&4){v[23540]=0;e=S(206,f|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break a}}if(d&8){v[23540]=0;i=S(206,f|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break a}}if(d&16){v[23540]=0;d=S(206,f|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break a}t[c+5|0]=d}h:{i:{d=w[c|0];if(!d){break i}g=255;if((d|0)==97){break h}if(d>>>0>96){break i}g=d+12|0;break h}g=0}t[c|0]=g;d=w[c+5|0];j:{if((d|i)&255){Pf(c,i,d);break j}t[c+3|0]=0}if(w[c+1|0]==255){t[c+1|0]=0}d=e-16|0;k:{if((d&255)>>>0<=64){t[c+4|0]=d;t[c+2|0]=1;break k}if(e>>>0<96){break k}d=e&15;t[c+4|0]=d;e=e-96>>4;t[c+2|0]=w[e+27198|0];if((e|0)!=6){break k}t[c+4|0]=d<<2}Ck(h);continue}}Bb(f);j=j+1|0;continue}break}break a}kb=h+48|0;return}a=P()|0;O()|0;Bb(f);T(a|0);L()}function gh(a,b,c,d,e){var f=0,g=0,h=0;if(!b){c=kb-16|0;kb=c;a:{if((d|0)==189){t[a+3843|0]=e>>>7;t[a+3844|0]=e>>>6&1;break a}b=d&224;if(!b){if((d|0)!=8){if((d|0)!=260){break a}b=0;d=1;while(1){if((b|0)==6){break a}f=B(b>>>0<3?b:b+6|0,44)+a|0;g=f+148|0;f=f+16|0;h=d&e;b:{if(h){eo(f,g);break b}eo(f,0)}t[g+40|0]=!h;b=b+1|0;d=d<<1&510;continue}}t[a+3842|0]=e>>>6&1;b=0;while(1){if((b|0)==18){break a}wz((B(b,44)+a|0)+16|0);b=b+1|0;continue}}if(b-160>>>0<=32){b=d&15;if(b>>>0>8){break a}a=B(d&256?b+9|0:b,44)+a|0;v[c+8>>2]=a+16;b=v[a+52>>2];v[c+12>>2]=b;g=b?2:1;c:{b=d&240;if((b|0)!=160){if((b|0)==192){break c}if((b|0)!=176){break a}f=e&3;h=e>>>2&7;b=0;d=(e&32)!=0;while(1){if((b|0)==(g|0)){break a}a=v[(c+8|0)+(b<<2)>>2];_O(v[a>>2],d);_O(v[a+4>>2],d);u[a+22>>1]=h;vz(a);wz(a);t[a+21|0]=f;vz(a);wz(a);b=b+1|0;continue}}b=0;while(1){if((b|0)==(g|0)){break a}a=v[(c+8|0)+(b<<2)>>2];u[a+20>>1]=x[a+20>>1]&768|e&255;vz(a);b=b+1|0;continue}}t[a+58|0]=(e&32)>>>5;t[a+57|0]=(e&16)>>>4;b=e>>>1&7;u[a+46>>1]=b?9-b|0:0;u[a+48>>1]=e&1;break a}if((b|0)!=224&b>>>0>=129|-4144960>>>d&1){break a}f=a;a=t[(d&31)+29056|0];a=(f+B(d&256?a+18|0:a,84)|0)+808|0;d:{switch(b-32>>>5|0){case 0:t[a+79|0]=e>>>7;t[a+80|0]=(e&64)>>>6;t[a+78|0]=(e&32)>>>5;t[a+77|0]=(e&16)>>>4;fo(a);u[a+14>>1]=x[((e&15)<<1)+29088>>1];break a;case 1:u[a+68>>1]=w[(e>>>6|0)+21673|0];$O(a);u[a+22>>1]=(e&63)<<2;break a;case 2:u[a+24>>1]=e>>>4;fo(a);u[a+26>>1]=e&15;fo(a);break a;case 3:b=e>>>4|0;u[a+28>>1]=b>>>0<15?b<<4:496;u[a+30>>1]=e&15;fo(a);break a;case 6:break d;default:break a}}u[a+12>>1]=e&7}kb=c+16|0;return}ob[v[v[b>>2]>>2]](b,c,d,e)}function ML(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;a:{b:{d=b;e=v[b>>2];if(e){if(!v[b+4>>2]){break b}g=v[b+4>>2];c:{if(!g){while(1){g=Ch(d);d=v[d+8>>2];if(!g){continue}break}break c}d=KT(g)}e=v[d>>2];if(e){break b}}e=v[d+4>>2];if(e){break b}e=0;g=1;break a}v[e+8>>2]=v[d+8>>2];g=0}d:{e:{if(Ch(d)){c=v[d+8>>2];v[c>>2]=e;if((a|0)==(d|0)){a=e;c=0;break d}c=c+4|0;break e}c=v[d+8>>2];v[c+4>>2]=e}c=v[c>>2]}h=!w[d+12|0];if((b|0)!=(d|0)){f=v[b+8>>2];v[d+8>>2]=f;i=f+(Ch(b)?0:4)|0,j=d,v[i>>2]=j;f=v[b>>2];v[d>>2]=f;lm(f,d);f=v[b+4>>2];v[d+4>>2]=f;if(f){lm(f,d)}t[d+12|0]=w[b+12|0];a=(a|0)==(b|0)?d:a}if(!(h|!a)){if(g){while(1){b=w[c+12|0];f:{g:{if(!Ch(c)){if(!b){t[c+12|0]=1;b=v[c+8>>2];t[b+12|0]=0;uq(b);b=v[c>>2];a=(b|0)==(a|0)?c:a;c=v[b+4>>2]}b=v[c>>2];h:{if(!(w[b+12|0]?0:b)){d=v[c+4>>2];if(w[d+12|0]?0:d){break h}t[c+12|0]=0;i:{b=v[c+8>>2];if((b|0)!=(a|0)){if(w[b+12|0]){break i}a=b}t[a+12|0]=1;return}if(!Ch(b)){break g}b=v[b+8>>2]+4|0;break f}d=v[c+4>>2];if(w[d+12|0]?0:d){break h}t[b+12|0]=1;t[c+12|0]=0;tq(c);c=v[c+8>>2];d=v[c+4>>2]}a=v[c+8>>2];t[c+12|0]=w[a+12|0];t[a+12|0]=1;t[d+12|0]=1;uq(a);return}if(!b){t[c+12|0]=1;b=v[c+8>>2];t[b+12|0]=0;tq(b);b=v[c+4>>2];a=(b|0)==(a|0)?c:a;c=v[b>>2]}d=v[c>>2];j:{if(w[d+12|0]?0:d){break j}b=v[c+4>>2];if(!(w[b+12|0]?0:b)){t[c+12|0]=0;b=v[c+8>>2];if(!((a|0)!=(b|0)?w[b+12|0]:0)){t[b+12|0]=1;return}if(Ch(b)){b=v[b+8>>2]+4|0;break f}b=v[b+8>>2];break f}if(w[d+12|0]?0:d){break j}t[b+12|0]=1;t[c+12|0]=0;uq(c);c=v[c+8>>2];d=v[c>>2]}a=v[c+8>>2];t[c+12|0]=w[a+12|0];t[a+12|0]=1;t[d+12|0]=1;tq(a);return}b=v[b+8>>2]}c=v[b>>2];continue}}t[e+12|0]=1}}function g$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0;a=kb-624|0;kb=a;v[a+608>>2]=c;v[a+616>>2]=b;v[a+16>>2]=1154;h=se(a+200|0,a+208|0,a+16|0);b=a+192|0;gd(b,e);v[23540]=0;i=S(1132,b|0)|0;b=v[23540];v[23540]=0;a:{b:{c:{d:{e:{f:{g:{if((b|0)!=1){t[a+191|0]=0;b=v[e+4>>2];v[23540]=0;b=qa(1162,a+616|0,c|0,d|0,a+192|0,b|0,f|0,a+191|0,i|0,h|0,a+196|0,a+608|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break d}if(!b){break e}b=w[14678]|w[14679]<<8|(w[14680]<<16|w[14681]<<24);t[a+183|0]=b;t[a+184|0]=b>>>8;t[a+185|0]=b>>>16;t[a+186|0]=b>>>24;b=w[14675]|w[14676]<<8|(w[14677]<<16|w[14678]<<24);v[a+176>>2]=w[14671]|w[14672]<<8|(w[14673]<<16|w[14674]<<24);v[a+180>>2]=b;v[23540]=0;X(1144,i|0,a+176|0,a+186|0,a+128|0);b=v[23540];v[23540]=0;if((b|0)==1){break g}v[a+4>>2]=1119;d=se(a+8|0,0,a+4|0);e=a+16|0;b=v[a+196>>2];c=b-v[h>>2]|0;if((c|0)<393){break f}_e(d,Pd((c>>2)+2|0));e=v[d>>2];if(e){break f}v[23540]=0;Z(1120);b=v[23540];v[23540]=0;if((b|0)==1){break c}break a}c=P()|0;O()|0;break b}c=P()|0;O()|0;break b}if(w[a+191|0]){t[e|0]=45;e=e+1|0}c=v[h>>2];while(1){if(b>>>0<=c>>>0){t[e|0]=0;v[a>>2]=g;if((SG(a+16|0,a)|0)!=1){v[23540]=0;Y(1156,8029);b=v[23540];v[23540]=0;if((b|0)!=1){break a}break c}Xc(d)}else{b=a+128|0;j=e,k=w[(a+176|0)+(vw(b,b+40|0,v[c>>2])-b>>2)|0],t[j|0]=k;e=e+1|0;c=c+4|0;b=v[a+196>>2];continue}break}}v[23540]=0;b=Q(1138,a+616|0,a+608|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break d}if(b){v[f>>2]=v[f>>2]|2}b=v[a+616>>2];ac(a+192|0);Xc(h);kb=a+624|0;return b|0}c=P()|0;O()|0;break b}c=P()|0;O()|0;Xc(d)}ac(a+192|0);Xc(h);T(c|0);L()}L()}function n$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0;a=kb-288|0;kb=a;v[a+272>>2]=c;v[a+280>>2]=b;v[a+16>>2]=1154;h=se(a+152|0,a+160|0,a+16|0);b=a+144|0;gd(b,e);v[23540]=0;i=S(19,b|0)|0;b=v[23540];v[23540]=0;a:{b:{c:{d:{e:{f:{g:{if((b|0)!=1){t[a+143|0]=0;b=v[e+4>>2];v[23540]=0;b=qa(1155,a+280|0,c|0,d|0,a+144|0,b|0,f|0,a+143|0,i|0,h|0,a+148|0,a+260|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break d}if(!b){break e}b=w[14678]|w[14679]<<8|(w[14680]<<16|w[14681]<<24);t[a+135|0]=b;t[a+136|0]=b>>>8;t[a+137|0]=b>>>16;t[a+138|0]=b>>>24;b=w[14675]|w[14676]<<8|(w[14677]<<16|w[14678]<<24);v[a+128>>2]=w[14671]|w[14672]<<8|(w[14673]<<16|w[14674]<<24);v[a+132>>2]=b;v[23540]=0;X(1130,i|0,a+128|0,a+138|0,a+118|0);b=v[23540];v[23540]=0;if((b|0)==1){break g}v[a+4>>2]=1119;d=se(a+8|0,0,a+4|0);e=a+16|0;b=v[a+148>>2];c=b-v[h>>2]|0;if((c|0)<99){break f}_e(d,Pd(c+2|0));e=v[d>>2];if(e){break f}v[23540]=0;Z(1120);b=v[23540];v[23540]=0;if((b|0)==1){break c}break a}c=P()|0;O()|0;break b}c=P()|0;O()|0;break b}if(w[a+143|0]){t[e|0]=45;e=e+1|0}c=v[h>>2];while(1){if(b>>>0<=c>>>0){t[e|0]=0;v[a>>2]=g;if((SG(a+16|0,a)|0)!=1){v[23540]=0;Y(1156,8029);b=v[23540];v[23540]=0;if((b|0)!=1){break a}break c}Xc(d)}else{b=a+118|0;j=e,k=w[((zi(b,UT(b),c)-a|0)+a|0)+10|0],t[j|0]=k;e=e+1|0;c=c+1|0;b=v[a+148>>2];continue}break}}v[23540]=0;b=Q(1122,a+280|0,a+272|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break d}if(b){v[f>>2]=v[f>>2]|2}b=v[a+280>>2];ac(a+144|0);Xc(h);kb=a+288|0;return b|0}c=P()|0;O()|0;break b}c=P()|0;O()|0;Xc(d)}ac(a+144|0);Xc(h);T(c|0);L()}L()}function O4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;c=kb-48|0;kb=c;g=Tb(a);a:{b:{c:{d=b+36|0;a=v[d>>2];f=v[b+40>>2];d:{if(Pb(a,f)){Gc(c+40|0);break d}v[23540]=0;R(1022,c+24|0,b|0);a=v[23540];v[23540]=0;if((a|0)==1){break b}v[23540]=0;a=S(1006,c+24|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break c}v[c+40>>2]=a;Xf(c+24|0);f=v[b+40>>2];a=v[b+36>>2]}if(!Pb(a,f)){d=v[c+40>>2];a=v[d>>2]}f=v[d+4>>2];v[23540]=0;R(181,g|0,Pi(a,f)|0);a=v[23540];v[23540]=0;e:{if((a|0)!=1){i=c,j=Fb(v[d>>2]),v[i+16>>2]=j;f=Fb(v[d+4>>2]);f:{g:{h:{i:{j:{k:{while(1){a=v[c+16>>2];if(!Pb(a,f)){al(c+40|0);kb=c+48|0;return}d=w[a+16|0];e=v[v[b+24>>2]+484360>>2];v[23540]=0;d=zj(e,d);R(1023,c|0,d|0);e=v[23540];v[23540]=0;if((e|0)!=1){v[23540]=0;R(1009,c+24|0,c|0);e=v[23540];v[23540]=0;if((e|0)==1){break k}v[23540]=0;R(183,g|0,c+24|0);e=v[23540];v[23540]=0;if((e|0)==1){break j}zb(c+24|0);Ab(c);l:{if(!Re(px(v[g+4>>2]))){break l}e=w[a+12|0];v[23540]=0;e=Q(311,d|0,e|0)|0;h=v[23540];v[23540]=0;if((h|0)==1){break f}if(!e){break l}e=v[b+24>>2];h=v[e+1298404>>2];a=x[cc(v[d>>2],v[a+12>>2])>>1];d=v[e+484344>>2];v[23540]=0;R(1016,c|0,_b(d,a)|0);a=v[23540];v[23540]=0;if((a|0)==1){break h}v[23540]=0;X(235,c+24|0,0,h|0,c|0);a=v[23540];v[23540]=0;if((a|0)==1){break g}a=c+24|0;Bc(px(v[g+4>>2]),a);zb(a);zb(c)}Wx(c+16|0);continue}break}a=P()|0;O()|0;break e}a=P()|0;O()|0;break i}a=P()|0;O()|0;zb(c+24|0)}Ab(c);break e}a=P()|0;O()|0;break e}a=P()|0;O()|0;zb(c);break e}a=P()|0;O()|0;break e}a=P()|0;O()|0}al(c+40|0);break a}a=P()|0;O()|0;Xf(c+24|0);break a}a=P()|0;O()|0}Xe(g);T(a|0);L()}function oy(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=kb-16|0;kb=e;i=sM(b,c);a:{if(!v[b+656>>2]|!(t[i+6|0]&1)){break a}f=v[i>>2];j=a+1074312|0;Db(e+8|0,j,31);g=Cb(v[v[e+8>>2]>>2],v[e+12>>2]);d=hv(v[b+656>>2],c);if(pc(v[d>>2],v[d+4>>2])){break a}g=f+(g^1)|0;Db(e+8|0,j,31);f=w[d+12|0];b:{c:{if(!Cb(v[v[e+8>>2]>>2],v[e+12>>2])){d:{if(!(f&2)){break d}h=w[d+14|0];k=!(v[a+480180>>2]&1048580)+x[Eb(v[d>>2],h)>>1]|0;if(!(w[b+89|0]&8)|(!(f&4)|(h|0)!=w[d+16|0])){f=l}else{Db(e+8|0,j,70);f=Cb(v[v[e+8>>2]>>2],v[e+12>>2])}if(f|(g|0)!=(k|0)){break d}g=x[Eb(v[d>>2],w[d+13|0])>>1]}if(!(!(w[d+12|0]&4)|w[b+89|0]&8)){a=v[d>>2];if((x[Eb(a,w[d+16|0])>>1]+1|0)!=(g|0)){break b}g=x[Eb(a,w[d+15|0])>>1];Db(e+8|0,j,93);if(!Cb(v[v[e+8>>2]>>2],v[e+12>>2])|(c|0)!=1|v[b+88>>2]&2048){break b}t[i+6|0]=w[i+6|0]&254;break b}k=1;f=x[Bj(v[d+4>>2])>>1];if(g>>>0>f>>>0){break c}break b}e:{f:{if(!(!(f&4)|w[b+669|0]&8)){if(x[i+4>>1]==65535){break f}Db(e+8|0,j,97);if(Cb(v[v[e+8>>2]>>2],v[e+12>>2])){break f}f=w[d+12|0]}if(f&2){h=v[d>>2];f=x[Eb(h,w[d+13|0])>>1];h=x[Eb(h,w[d+14|0])>>1]+1|0;break e}f=x[Bj(v[d+4>>2])>>1];k=g>>>0>f>>>0;h=f;break e}h=v[d>>2];f=x[Eb(h,w[d+15|0])>>1];h=x[Eb(h,w[d+16|0])>>1]+1|0}f=g>>>0<h>>>0?g:f}g:{if(!k|c){break g}g=v[a+480180>>2];c=v[b+88>>2];if(!(!(g&16777248)&(!(c&2048)|(g|0)==16384))){c=c|4096;v[b+88>>2]=c}if(w[Bj(v[d+4>>2])+2|0]|!(v[a+480180>>2]&16777248?1:x[b+786>>1])){break g}v[b+696>>2]=0;v[b+720>>2]=0;v[b+680>>2]=0;v[b+88>>2]=c|4096}g=f}Db(e+8|0,j,31);m=i,n=Cb(v[v[e+8>>2]>>2],v[e+12>>2])+g|0,v[m>>2]=n}kb=e+16|0}function _s(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;g=kb-144|0;kb=g;a:{b:{c:{d:{e:{f:{g:{h:{if(!d){break h}e=v[d+4>>2];if(!e&c>>>0<=y[d>>2]|e){break h}a=ba(8)|0;v[23540]=0;b=Q(27,a|0,21688)|0;c=v[23540];v[23540]=0;if((c|0)!=1){break g}b=P()|0;O()|0;ca(a|0);break a}if(!b){a=ba(8)|0;v[23540]=0;b=S(815,a|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){break f}b=P()|0;O()|0;ca(a|0);break a}e=kb-16|0;kb=e;_g(e+8|0,b,c);h=g+120|0;TD(h,v[e+8>>2],v[e+12>>2]);v[h+12>>2]=0;kb=e+16|0;i:{j:{if(a&2){b=bn(g+96|0,h);v[23540]=0;b=S(816,b|0)|0;f=v[23540];v[23540]=0;e=1;if((f|0)==1){break i}if((b|0)==1){break j}e=bn(g+72|0,h);v[23540]=0;f=S(817,e|0)|0;i=v[23540];v[23540]=0;e=1;if((i|0)==1){break e}k=(f|0)==1;if(k){break j}e=bn(g+48|0,h);v[23540]=0;i=Q(818,e|0,d|0)|0;j=v[23540];v[23540]=0;e=1;if((j|0)==1){break d}l=(i|0)==1;if(l){break j}e=bn(g+24|0,h);v[23540]=0;j=Q(819,e|0,d|0)|0;m=v[23540];v[23540]=0;e=1;if((m|0)==1){break c}if((j|0)==1){break j}b=(b|0)==-1?-1:0;b=k?b:(f|0)==-1?-1:b;f=(j|0)==-1?-1:l?b:(i|0)==-1?-1:b}k:{if(!(a&1)){break k}b=31616;while(1){if((b|0)==32156){break k}a=v[b>>2];if(a){e=bn(g,h);v[23540]=0;a=Q(a|0,e|0,d|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break b}e=1;if((a|0)==1){break j}f=(a|0)==-1?-1:f}b=b+12|0;continue}}if(d){e=0;if((f|0)!=-1){break j}e=Ec(v[d>>2],v[d+4>>2])>>>0>c>>>0?-1:0;break j}e=0;if((f|0)!=-1){break j}e=c>>>0>2047?1:-1}kb=g+144|0;return e}b=P()|0;O()|0;break a}ha(b|0,93048,25);L()}ha(b|0,92944,25);L()}b=P()|0;O()|0;break a}b=P()|0;O()|0;break a}b=P()|0;O()|0;break a}b=P()|0;O()|0}T(b|0);L()}function yda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,C=0,D=0;g=kb-48|0;kb=g;o=v[a+16>>2];b=0;while(1){if((b|0)!=2){e=b<<3;h=e+(g+24|0)|0;e=a+e|0;v[h+4>>2]=v[e+44>>2];v[h+8>>2]=v[e+48>>2];b=b+1|0;continue}break}h=v[a+40>>2];k=v[a+36>>2];b=v[a+4>>2];v[g+16>>2]=v[a>>2];v[g+20>>2]=b;p=v[a+32>>2];q=v[a+28>>2];r=v[a+72>>2];b=v[a+68>>2];s=b;t=b>>31;b=v[a+64>>2];w=b;x=b>>31;b=v[a+60>>2];y=b;z=b>>31;A=v[a+8>>2];C=v[a+12>>2];while(1){if(d){b=v[g+16>>2];l=b>>>18|0;j=((((v[g+20>>2]&2147483647)<<1|b>>>31)&2147483646)<<1)+o|0;b=0;e=0;while(1){if((e|0)!=2){i=j+(e<<1)|0;f=u[i>>1];v[(g+8|0)+(e<<2)>>2]=f+((B(l,u[i+4>>1]-f|0)|0)/16384|0);e=e+1|0;continue}break}while(1){if((b|0)!=2){l=(g+8|0)+(b<<2)|0;f=v[l>>2];e=(g+24|0)+(b<<3)|0;j=v[e+8>>2];i=v[e+4>>2];v[e+8>>2]=i;n=f<<8;f=n;f=Jka(y,z,f,f>>31);m=nb;D=e;e=Zb(i,-16777216,16776704);i=Jka(w,x,e,e>>31);f=i+f|0;e=nb+m|0;e=f>>>0<i>>>0?e+1|0:e;m=f;f=Zb(j,-16777216,16776704);j=Jka(s,t,f,f>>31);f=m+j|0;e=nb+e|0;e=f>>>0<j>>>0?e+1|0:e;f=f+8388608|0;e=f>>>0<8388608?e+1|0:e;e=Yc(f,e,24);v[D+4>>2]=e-(r&n);v[l>>2]=(e|0)/256;b=b+1|0;continue}break}k=k+q|0;v[c>>2]=v[c>>2]+B(v[g+8>>2],k>>12);h=h+p|0;v[c+4>>2]=v[c+4>>2]+B(v[g+12>>2],h>>12);Rb(g+16|0,A,C);c=c+8|0;d=d-1|0;continue}break}b=v[g+20>>2];v[a>>2]=v[g+16>>2];v[a+4>>2]=b;v[a+40>>2]=h;v[a+20>>2]=k>>12;v[a+36>>2]=k;v[a+24>>2]=h>>12;b=0;while(1){if((b|0)!=2){c=b<<3;d=c+a|0;c=c+(g+24|0)|0;v[d+44>>2]=v[c+4>>2];v[d+48>>2]=v[c+8>>2];b=b+1|0;continue}break}kb=g+48|0}function zda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,w=0,x=0,y=0,z=0,A=0,C=0,D=0;g=kb-48|0;kb=g;o=v[a+16>>2];b=0;while(1){if((b|0)!=2){e=b<<3;h=e+(g+24|0)|0;e=a+e|0;v[h+4>>2]=v[e+44>>2];v[h+8>>2]=v[e+48>>2];b=b+1|0;continue}break}h=v[a+40>>2];k=v[a+36>>2];b=v[a+4>>2];v[g+16>>2]=v[a>>2];v[g+20>>2]=b;p=v[a+32>>2];q=v[a+28>>2];r=v[a+72>>2];b=v[a+68>>2];s=b;u=b>>31;b=v[a+64>>2];w=b;x=b>>31;b=v[a+60>>2];y=b;z=b>>31;A=v[a+8>>2];C=v[a+12>>2];while(1){if(d){b=v[g+16>>2];l=b>>>10&4194048;j=(((v[g+20>>2]&2147483647)<<1|b>>>31)&-2)+o|0;b=0;e=0;while(1){if((e|0)!=2){i=e+j|0;f=t[i|0];v[(g+8|0)+(e<<2)>>2]=((B(l,t[i+2|0]-f|0)|0)/16384|0)+(f<<8);e=e+1|0;continue}break}while(1){if((b|0)!=2){l=(g+8|0)+(b<<2)|0;f=v[l>>2];e=(g+24|0)+(b<<3)|0;j=v[e+8>>2];i=v[e+4>>2];v[e+8>>2]=i;n=f<<8;f=n;f=Jka(y,z,f,f>>31);m=nb;D=e;e=Zb(i,-16777216,16776704);i=Jka(w,x,e,e>>31);f=i+f|0;e=nb+m|0;e=f>>>0<i>>>0?e+1|0:e;m=f;f=Zb(j,-16777216,16776704);j=Jka(s,u,f,f>>31);f=m+j|0;e=nb+e|0;e=f>>>0<j>>>0?e+1|0:e;f=f+8388608|0;e=f>>>0<8388608?e+1|0:e;e=Yc(f,e,24);v[D+4>>2]=e-(r&n);v[l>>2]=(e|0)/256;b=b+1|0;continue}break}k=k+q|0;v[c>>2]=v[c>>2]+B(v[g+8>>2],k>>12);h=h+p|0;v[c+4>>2]=v[c+4>>2]+B(v[g+12>>2],h>>12);Rb(g+16|0,A,C);c=c+8|0;d=d-1|0;continue}break}b=v[g+20>>2];v[a>>2]=v[g+16>>2];v[a+4>>2]=b;v[a+40>>2]=h;v[a+20>>2]=k>>12;v[a+36>>2]=k;v[a+24>>2]=h>>12;b=0;while(1){if((b|0)!=2){c=b<<3;d=c+a|0;c=c+(g+24|0)|0;v[d+44>>2]=v[c+4>>2];v[d+48>>2]=v[c+8>>2];b=b+1|0;continue}break}kb=g+48|0}function Oda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,C=0,D=0,E=0,F=0;g=kb-48|0;kb=g;p=v[a+16>>2];m=Tf(1,2);b=nb;q=b;Rb(a,m,b);b=0;while(1){if((b|0)!=2){e=b<<3;h=e+(g+24|0)|0;e=a+e|0;v[h+4>>2]=v[e+44>>2];v[h+8>>2]=v[e+48>>2];b=b+1|0;continue}break}h=v[a+40>>2];i=v[a+36>>2];b=v[a+4>>2];v[g+16>>2]=v[a>>2];v[g+20>>2]=b;r=v[a+32>>2];s=v[a+28>>2];t=v[a+72>>2];b=v[a+68>>2];w=b;x=b>>31;b=v[a+64>>2];y=b;z=b>>31;b=v[a+60>>2];A=b;C=b>>31;D=v[a+8>>2];E=v[a+12>>2];while(1){if(d){d=d-1|0;f=((((v[g+20>>2]&2147483647)<<1|v[g+16>>2]>>>31)&2147483646)<<1)+p|0;b=0;e=0;while(1){if((e|0)!=2){v[(g+8|0)+(e<<2)>>2]=u[f+(e<<1)>>1];e=e+1|0;continue}break}while(1){if((b|0)!=2){n=(g+8|0)+(b<<2)|0;f=v[n>>2];e=(g+24|0)+(b<<3)|0;k=v[e+8>>2];j=v[e+4>>2];v[e+8>>2]=j;o=f<<8;f=o;f=Jka(A,C,f,f>>31);l=nb;F=e;e=Zb(j,-16777216,16776704);j=Jka(y,z,e,e>>31);f=j+f|0;e=nb+l|0;e=f>>>0<j>>>0?e+1|0:e;l=f;f=Zb(k,-16777216,16776704);k=Jka(w,x,f,f>>31);f=l+k|0;e=nb+e|0;e=f>>>0<k>>>0?e+1|0:e;f=f+8388608|0;e=f>>>0<8388608?e+1|0:e;e=Yc(f,e,24);v[F+4>>2]=e-(t&o);v[n>>2]=(e|0)/256;b=b+1|0;continue}break}i=i+s|0;v[c>>2]=v[c>>2]+B(v[g+8>>2],i>>12);h=h+r|0;v[c+4>>2]=v[c+4>>2]+B(v[g+12>>2],h>>12);Rb(g+16|0,D,E);c=c+8|0;continue}break}b=v[g+20>>2];v[a>>2]=v[g+16>>2];v[a+4>>2]=b;v[a+40>>2]=h;v[a+20>>2]=i>>12;v[a+36>>2]=i;v[a+24>>2]=h>>12;b=0;while(1){if((b|0)!=2){c=b<<3;d=c+a|0;c=c+(g+24|0)|0;v[d+44>>2]=v[c+4>>2];v[d+48>>2]=v[c+8>>2];b=b+1|0;continue}break}mg(a,m,q);kb=g+48|0}function V_(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,u=0,x=0,y=0,z=0,A=0,B=0,C=0;v[c>>2]=a;y=d&512;z=h<<2;while(1){if((x|0)==4){if(Hb(n)>>>0>1){f=he(n);e=kb-16|0;kb=e;v[e+8>>2]=f;f=v[Le(e+8|0)>>2];kb=e+16|0;B=c,C=Oi(f,Tk(n),v[c>>2]),v[B>>2]=C}d=d&176;if((d|0)!=16){if((d|0)==32){a=v[c>>2]}v[b>>2]=a}}else{a:{b:{switch(t[i+x|0]){case 0:v[b>>2]=v[c>>2];break a;case 1:v[b>>2]=v[c>>2];h=_r(g,32);p=v[c>>2];v[c>>2]=p+4;v[p>>2]=h;break a;case 3:if(Re(n)){break a}h=v[qj(n,0)>>2];p=v[c>>2];v[c>>2]=p+4;v[p>>2]=h;break a;case 2:if(Re(m)|!y){break a}B=c,C=Oi(he(m),Tk(m),v[c>>2]),v[B>>2]=C;break a;case 4:break b;default:break a}}A=v[c>>2];e=e+z|0;h=e;while(1){c:{if(f>>>0<=h>>>0){break c}if(!Wk(g,2048,v[h>>2])){break c}h=h+4|0;continue}break}if((o|0)>0){p=v[c>>2];q=o;while(1){if(!(!q|e>>>0>=h>>>0)){h=h-4|0;s=v[h>>2];r=p+4|0;v[c>>2]=r;v[p>>2]=s;q=q-1|0;p=r;continue}break}d:{if(!q){s=0;break d}s=_r(g,48);p=v[c>>2]}while(1){r=p+4|0;if((q|0)>0){v[p>>2]=s;q=q-1|0;p=r;continue}break}v[c>>2]=r;v[p>>2]=j}e:{if((e|0)==(h|0)){p=_r(g,48);q=v[c>>2];h=q+4|0;v[c>>2]=h;v[q>>2]=p;break e}if(Re(l)){s=-1}else{s=t[hg(l,0)|0]}q=0;u=0;while(1){if((e|0)!=(h|0)){r=v[c>>2];f:{if((q|0)!=(s|0)){p=r;r=q;break f}p=r+4|0;v[c>>2]=p;v[r>>2]=k;r=0;u=u+1|0;if(Hb(l)>>>0<=u>>>0){s=q;break f}s=-1;if(w[hg(l,u)|0]==127){break f}s=t[hg(l,u)|0]}h=h-4|0;q=v[h>>2];v[c>>2]=p+4;v[p>>2]=q;q=r+1|0;continue}break}h=v[c>>2]}Tr(A,h)}x=x+1|0;continue}break}}function mda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0;g=kb-48|0;kb=g;m=v[a+16>>2];b=0;while(1){if((b|0)!=2){e=b<<3;f=e+(g+24|0)|0;e=a+e|0;v[f+4>>2]=v[e+44>>2];v[f+8>>2]=v[e+48>>2];b=b+1|0;continue}break}n=v[a+24>>2];o=v[a+20>>2];b=v[a+4>>2];v[g+16>>2]=v[a>>2];v[g+20>>2]=b;p=v[a+72>>2];b=v[a+68>>2];q=b;r=b>>31;b=v[a+64>>2];s=b;t=b>>31;b=v[a+60>>2];w=b;x=b>>31;y=v[a+8>>2];z=v[a+12>>2];while(1){if(d){e=v[g+16>>2];k=((((v[g+20>>2]&2147483647)<<1|e>>>31)&2147483646)<<1)+m|0;b=e>>>21&2040;i=u[b+39782>>1];h=u[b+39780>>1];l=u[b+39778>>1];j=u[b+39776>>1];b=0;e=0;while(1){if((e|0)!=2){f=k+(e<<1)|0;v[(g+8|0)+(e<<2)>>2]=(((B(u[f>>1],l)+B(u[f-4>>1],j)|0)+B(h,u[f+4>>1])|0)+B(i,u[f+8>>1])|0)/16384;e=e+1|0;continue}break}while(1){if((b|0)!=2){k=(g+8|0)+(b<<2)|0;f=v[k>>2];e=(g+24|0)+(b<<3)|0;i=v[e+8>>2];h=v[e+4>>2];v[e+8>>2]=h;l=f<<8;f=l;f=Jka(w,x,f,f>>31);j=nb;A=e;e=Zb(h,-16777216,16776704);h=Jka(s,t,e,e>>31);f=h+f|0;e=nb+j|0;e=f>>>0<h>>>0?e+1|0:e;j=f;f=Zb(i,-16777216,16776704);i=Jka(q,r,f,f>>31);f=j+i|0;e=nb+e|0;e=f>>>0<i>>>0?e+1|0:e;f=f+8388608|0;e=f>>>0<8388608?e+1|0:e;e=Yc(f,e,24);v[A+4>>2]=e-(l&p);v[k>>2]=(e|0)/256;b=b+1|0;continue}break}v[c>>2]=v[c>>2]+B(v[g+8>>2],o);v[c+4>>2]=v[c+4>>2]+B(v[g+12>>2],n);Rb(g+16|0,y,z);c=c+8|0;d=d-1|0;continue}break}b=v[g+20>>2];v[a>>2]=v[g+16>>2];v[a+4>>2]=b;b=0;while(1){if((b|0)!=2){c=b<<3;d=c+a|0;c=c+(g+24|0)|0;v[d+44>>2]=v[c+4>>2];v[d+48>>2]=v[c+8>>2];b=b+1|0;continue}break}kb=g+48|0}function QK(a){var b=C(0),c=0,d=0,e=0,f=0,g=C(0),h=0,i=0,k=0,l=C(0),m=0,n=C(0);c=kb-16|0;kb=c;e=a+4208|0;b=Fx(z[Eb(e,2)>>2]);f=v[a+16>>2]+24620|0;z[c+12>>2]=b/C(y[f>>2]);v[c+8>>2]=1056964608;b=Fp(C(z[nm(c+12|0,c+8|0)>>2]*C(6.2831854820251465)));b=C(K(C(C(C(b+b)+C(3))/C(5))));z[a+4236>>2]=b;z[a+4240>>2]=K(C(C(1)-C(b*b)));b=C(C(z[Eb(e,1)>>2]*C(29))+C(2));a:{if(b<C(4294967296)&b>=C(0)){i=~~b>>>0;break a}i=0}t[a+4272|0]=i;d=i;while(1){if(d&255){k=k+1|0;d=(d&254)>>>1|0;continue}break}t[a+4273|0]=k;l=te(C(10),C(C(C(z[e>>2]*C(60))+C(-60))/C(20)));m=c,n=C(Fx(z[Eb(e,3)>>2])/C(y[f>>2])),z[m+12>>2]=n;v[c+8>>2]=1056964608;g=z[nm(c+12|0,c+8|0)>>2];m=c,n=C(Fx(z[Eb(e,4)>>2])/C(y[f>>2])),z[m+12>>2]=n;v[c+8>>2]=1056964608;b=C(C(z[nm(c+12|0,c+8|0)>>2]*C(6.2831854820251465))*C(.5));f=kb-16|0;kb=f;e=(p(b),j(2));d=e&2147483647;b:{if(d>>>0<=1061752794){if(d>>>0<964689920){break b}b=Gn(+b,0);break b}if(d>>>0<=1081824209){h=+b;if(d>>>0<=1075235811){b=Gn(((e|0)<0?1.5707963267948966:-1.5707963267948966)+h,1);break b}b=Gn(((e|0)<0?3.141592653589793:-3.141592653589793)+h,0);break b}if(d>>>0<=1088565717){h=+b;if(d>>>0<=1085271519){b=Gn(((e|0)<0?4.71238898038469:-4.71238898038469)+h,1);break b}b=Gn(((e|0)<0?6.283185307179586:-6.283185307179586)+h,0);break b}if(d>>>0>=2139095040){b=C(b-b);break b}d=ax(b,f+8|0);b=Gn(A[f+8>>3],d&1)}kb=f+16|0;b=C(C(C(1)-b)/C(b+C(1)));z[a+4268>>2]=b;g=Fp(C(g*C(6.2831854820251465)));z[a+4264>>2]=-g;z[a+4260>>2]=C(C(l*C(K(C(C(1)-C(g*g)))))*C(K(C(C(1)-C(b*b)))))*z[(i<<2)+45664>>2];kb=c+16|0}function Pda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,w=0,x=0,y=0,z=0,A=0,C=0,D=0,E=0,F=0;g=kb-48|0;kb=g;p=v[a+16>>2];m=Tf(1,2);b=nb;q=b;Rb(a,m,b);b=0;while(1){if((b|0)!=2){e=b<<3;h=e+(g+24|0)|0;e=a+e|0;v[h+4>>2]=v[e+44>>2];v[h+8>>2]=v[e+48>>2];b=b+1|0;continue}break}h=v[a+40>>2];i=v[a+36>>2];b=v[a+4>>2];v[g+16>>2]=v[a>>2];v[g+20>>2]=b;r=v[a+32>>2];s=v[a+28>>2];u=v[a+72>>2];b=v[a+68>>2];w=b;x=b>>31;b=v[a+64>>2];y=b;z=b>>31;b=v[a+60>>2];A=b;C=b>>31;D=v[a+8>>2];E=v[a+12>>2];while(1){if(d){d=d-1|0;f=(((v[g+20>>2]&2147483647)<<1|v[g+16>>2]>>>31)&-2)+p|0;b=0;e=0;while(1){if((e|0)!=2){v[(g+8|0)+(e<<2)>>2]=t[e+f|0]<<8;e=e+1|0;continue}break}while(1){if((b|0)!=2){n=(g+8|0)+(b<<2)|0;f=v[n>>2];e=(g+24|0)+(b<<3)|0;k=v[e+8>>2];j=v[e+4>>2];v[e+8>>2]=j;o=f<<8;f=o;f=Jka(A,C,f,f>>31);l=nb;F=e;e=Zb(j,-16777216,16776704);j=Jka(y,z,e,e>>31);f=j+f|0;e=nb+l|0;e=f>>>0<j>>>0?e+1|0:e;l=f;f=Zb(k,-16777216,16776704);k=Jka(w,x,f,f>>31);f=l+k|0;e=nb+e|0;e=f>>>0<k>>>0?e+1|0:e;f=f+8388608|0;e=f>>>0<8388608?e+1|0:e;e=Yc(f,e,24);v[F+4>>2]=e-(u&o);v[n>>2]=(e|0)/256;b=b+1|0;continue}break}i=i+s|0;v[c>>2]=v[c>>2]+B(v[g+8>>2],i>>12);h=h+r|0;v[c+4>>2]=v[c+4>>2]+B(v[g+12>>2],h>>12);Rb(g+16|0,D,E);c=c+8|0;continue}break}b=v[g+20>>2];v[a>>2]=v[g+16>>2];v[a+4>>2]=b;v[a+40>>2]=h;v[a+20>>2]=i>>12;v[a+36>>2]=i;v[a+24>>2]=h>>12;b=0;while(1){if((b|0)!=2){c=b<<3;d=c+a|0;c=c+(g+24|0)|0;v[d+44>>2]=v[c+4>>2];v[d+48>>2]=v[c+8>>2];b=b+1|0;continue}break}mg(a,m,q);kb=g+48|0}function bK(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=C(0);e=kb-48|0;kb=e;a:{b:{c:{d:{e:{switch(b-1|0){case 1:b=(c<<7)/100|0;d=v[a+24>>2];if((b|0)==v[d+24604>>2]){break d}a=e+8|0;sc(a,d+24604|0,40);v[e+8>>2]=b;sy(d,a);break d;case 2:f=v[a+24>>2];d=f+24664|0;b=v[d+4>>2];v[e+24>>2]=v[d>>2];v[e+28>>2]=b;d=f+24656|0;b=v[d+4>>2];v[e+16>>2]=v[d>>2];v[e+20>>2]=b;b=v[f+24652>>2];v[e+8>>2]=v[f+24648>>2];v[e+12>>2]=b;d=kb-16|0;kb=d;b=3;f:{g:{h:{if(!c|(c|0)>7){break h}b=2;if((c|0)>2){break h}b=1;if((c|0)==2){break h}b=0;if((c|0)>0){break h}c=ba(8)|0;v[23540]=0;b=Q(55,d|0,10820)|0;a=v[23540];v[23540]=0;i:{if((a|0)!=1){a=tc(c,b);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break g}a=P()|0;O()|0;zb(b);break i}a=P()|0;O()|0;ca(c|0)}T(a|0);L()}kb=d+16|0;break f}L()}t[e+8|0]=b;a=v[a+24>>2];if(!xx(e+8|0,a+24648|0)){break d}qy(a,e+8|0);break d;case 3:f=e+8|0;d=v[a+24>>2];sc(f,d+24604|0,40);b=kb-48|0;kb=b;j:{if((c|0)==-1){Bs(f,v[fq(b+8|0)+32>>2]);eo(f,v[fq(b+8|0)+36>>2]);break j}if((c|0)<=0){Bs(f,0);eo(f,0);break j}a=B(c,1e3);Bs(f,a);eo(f,a)}kb=b+48|0;if(v[d+24636>>2]==v[e+40>>2]&v[d+24640>>2]==v[e+44>>2]){break d}sy(d,e+8|0);break d;default:d=ba(8)|0;v[23540]=0;c=Q(55,e+8|0,10404)|0;a=v[23540];v[23540]=0;if((a|0)==1){break c}a=tc(d,c);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break a}b=P()|0;O()|0;zb(c);break b;case 0:break e}}g=a,h=te(C(10),C(C(C(c|0)*C(.0010000000474974513))*C(.5))),z[g+48>>2]=h}kb=e+48|0;return}b=P()|0;O()|0;ca(d|0)}T(b|0)}L()}function Faa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=kb-112|0;kb=c;Cj(c+88|0,b,1413829443);v[23540]=0;b=S(178,v[c+88>>2])|0;d=v[23540];v[23540]=0;a:{b:{c:{if((d|0)==1){break c}if(!b){v[23540]=0;U(771,c- -64|0,a+140|0,1413894985);a=v[23540];v[23540]=0;d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{if((a|0)!=1){v[23540]=0;a=Q(848,c- -64|0,13629)|0;b=v[23540];v[23540]=0;if((b|0)==1){break e}b=28591;if(a){b=Nb(c+48|0);v[23540]=0;a=S(202,c- -64|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break m}v[23540]=0;U(268,c- -64|0,b|0,a|0);a=v[23540];v[23540]=0;if((a|0)==1){break m}v[23540]=0;d=Q(54,c+16|0,b|0)|0;a=v[23540];v[23540]=0;if((a|0)==1){break l}v[23540]=0;Y(849,c|0);a=v[23540];v[23540]=0;if((a|0)==1){break k}v[23540]=0;U(850,c+32|0,d|0,c|0);a=v[23540];v[23540]=0;if((a|0)==1){break j}a=c+32|0;e=Bc(b,a);zb(a);zb(c);zb(d);v[23540]=0;U(11,a|0,2,e|0);a=v[23540];v[23540]=0;if((a|0)==1){break h}v[23540]=0;a=S(742,c+32|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break g}Ab(c+32|0);zb(e);b=a-1>>>0<19398657?1252:28591}Bb(c- -64|0);break a}a=P()|0;O()|0;break b}a=P()|0;O()|0;break f}a=P()|0;O()|0;break f}a=P()|0;O()|0;break i}a=P()|0;O()|0;zb(c)}zb(d);break f}a=P()|0;O()|0;break f}a=P()|0;O()|0;Ab(c+32|0)}zb(b);break d}a=P()|0;O()|0}Bb(c- -64|0);break b}v[23540]=0;a=W(156,v[c+88>>2],v[c+96>>2],2)|0;b=v[23540];v[23540]=0;if((b|0)==1){break c}b=28591;if(!a){break a}v[23540]=0;b=S(194,c+88|0)|0;a=v[23540];v[23540]=0;if((a|0)!=1){break a}a=P()|0;O()|0;break b}a=P()|0;O()|0}Bb(c+88|0);T(a|0);L()}Bb(c+88|0);kb=c+112|0;return b|0}function Wca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,C=0;h=kb-16|0;kb=h;a:{b:{c:{i=v[a+12>>2];j=v[a+8>>2];d:{if((i|0)<=1&j>>>0<=805306368|(i|0)<=0){if((i|0)>=-2&j>>>0>=3489660928|(i|0)>-2){break c}if((i|0)==-2&j>>>0>2147483647|i>>>0>4294967294){break d}break b}if((i|0)==1&j>>>0>2147483648|i>>>0>1){break b}}p=b+196648|0;break a}p=b+131112|0;break a}p=b+262184|0}q=v[a+16>>2];f=v[a+48>>2];k=v[a+40>>2];l=v[a+36>>2];b=v[a+44>>2];e=v[a+4>>2];v[h+8>>2]=v[a>>2];v[h+12>>2]=e;r=v[a+32>>2];s=v[a+28>>2];t=v[a+72>>2];e=v[a+68>>2];w=e;x=e>>31;e=v[a+64>>2];y=e;z=e>>31;e=v[a+60>>2];A=e;C=e>>31;while(1){e=b;if(d){b=Zb(e,-16777216,16776704);b=Jka(y,z,b,b>>31);m=nb;n=b;g=(v[h+12>>2]<<1)+q|0;b=(v[h+8>>2]>>>16&65520)+p|0;g=(((((((B(u[g-4>>1],u[b+2>>1])+B(u[g-6>>1],u[b>>1])|0)+B(u[g-2>>1],u[b+4>>1])|0)+B(u[g>>1],u[b+6>>1])|0)+B(u[g+2>>1],u[b+8>>1])|0)+B(u[g+4>>1],u[b+10>>1])|0)+B(u[g+6>>1],u[b+12>>1])|0)+B(u[g+8>>1],u[b+14>>1])|0)/32768<<8;b=g;b=Jka(b,b>>31,A,C);n=n+b|0;o=nb+m|0;o=b>>>0>n>>>0?o+1|0:o;b=Zb(f,-16777216,16776704);f=Jka(w,x,b,b>>31);m=f+n|0;b=nb+o|0;b=f>>>0>m>>>0?b+1|0:b;f=m+8388608|0;b=f>>>0<8388608?b+1|0:b;f=Yc(f,b,24);b=(f|0)/256|0;l=l+s|0;v[c>>2]=B(b,l>>12)+v[c>>2];k=k+r|0;v[c+4>>2]=v[c+4>>2]+B(b,k>>12);Rb(h+8|0,j,i);b=f-(g&t)|0;c=c+8|0;d=d-1|0;f=e;continue}break}b=v[h+12>>2];v[a>>2]=v[h+8>>2];v[a+4>>2]=b;v[a+40>>2]=k;v[a+20>>2]=l>>12;v[a+36>>2]=l;v[a+48>>2]=f;v[a+44>>2]=e;v[a+24>>2]=k>>12;kb=h+16|0}function Rea(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;f=kb-16|0;kb=f;k=f,l=Aj(b),v[k>>2]=l;e=kb-16|0;kb=e;h=a;c=Td(a);a:{if(c){g=jc(h);while(1){a=c;c=a+14|0;if(Ft(b,c)){g=a;c=v[a>>2];if(c){continue}break a}if(!Ft(c,b)){break a}g=a+4|0;c=v[a+4>>2];if(c){continue}break}break a}a=jc(h);g=a}v[e+12>>2]=a;b=v[g>>2];if(!b){i=kb-16|0;kb=i;a=jc(h);j=lh(e,vc(48),mh(i+8|0,a));a=v[j>>2];b=v[f>>2];c=w[b+4|0]|w[b+5|0]<<8|(w[b+6|0]<<16|w[b+7|0]<<24);d=w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24);t[a+14|0]=d;t[a+15|0]=d>>>8;t[a+16|0]=d>>>16;t[a+17|0]=d>>>24;t[a+18|0]=c;t[a+19|0]=c>>>8;t[a+20|0]=c>>>16;t[a+21|0]=c>>>24;c=w[b+28|0]|w[b+29|0]<<8|(w[b+30|0]<<16|w[b+31|0]<<24);d=w[b+24|0]|w[b+25|0]<<8|(w[b+26|0]<<16|w[b+27|0]<<24);t[a+38|0]=d;t[a+39|0]=d>>>8;t[a+40|0]=d>>>16;t[a+41|0]=d>>>24;t[a+42|0]=c;t[a+43|0]=c>>>8;t[a+44|0]=c>>>16;t[a+45|0]=c>>>24;c=w[b+20|0]|w[b+21|0]<<8|(w[b+22|0]<<16|w[b+23|0]<<24);d=w[b+16|0]|w[b+17|0]<<8|(w[b+18|0]<<16|w[b+19|0]<<24);t[a+30|0]=d;t[a+31|0]=d>>>8;t[a+32|0]=d>>>16;t[a+33|0]=d>>>24;t[a+34|0]=c;t[a+35|0]=c>>>8;t[a+36|0]=c>>>16;t[a+37|0]=c>>>24;c=w[b+12|0]|w[b+13|0]<<8|(w[b+14|0]<<16|w[b+15|0]<<24);b=w[b+8|0]|w[b+9|0]<<8|(w[b+10|0]<<16|w[b+11|0]<<24);t[a+22|0]=b;t[a+23|0]=b>>>8;t[a+24|0]=b>>>16;t[a+25|0]=b>>>24;t[a+26|0]=c;t[a+27|0]=c>>>8;t[a+28|0]=c>>>16;t[a+29|0]=c>>>24;u[a+46>>1]=0;k=jc(j),l=1,t[k+4|0]=l;kb=i+16|0;Jg(h,v[e+12>>2],g,v[e>>2]);b=ce(e);rk(e);d=1}Ig(f+8|0,v[fc(e,b)>>2],d);kb=e+16|0;a=so(v[f+8>>2]);kb=f+16|0;return a+32|0}function pca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0;g=kb-16|0;kb=g;w=v[a+16>>2];x=kg(b+327720|0,v[b+20>>2],(v[a+88>>2]&16384)>>>14|0);p=v[a+128>>2];a:{if(!p){n=v[a+8>>2];s=v[a+12>>2];i=v[a>>2];e=v[a+4>>2];o=0;break a}b=v[a+12>>2];s=b;n=v[a+8>>2];q=lg(n,b,p);r=nb;k=v[a+76>>2];i=v[a>>2];e=v[a+4>>2];Qf(i,e,qf(n,b,d),nb);o=k>>>0<nb>>>0?d:0}h=a+112|0;f=v[a+48>>2];l=v[a+40>>2];m=v[a+36>>2];b=v[a+44>>2];v[g>>2]=i;v[g+4>>2]=e;b:while(1){c:{k=b;if(!d){break c}d=d-1|0;v[g+8>>2]=i;v[g+12>>2]=0;o=o-1|0;b=o;q=b?q:0;r=b?r:0;e=(e<<1)+w|0;b=p;while(1)if((b|0)<=0){Rb(h,v[a+120>>2],v[a+124>>2]);b=v[a+116>>2];if(b){Sd(h,u[e+(v[g+12>>2]<<1)>>1]/4<<16>>16);Rd(h,b);v[h>>2]=v[h>>2];v[h+4>>2]=0}i=v[a+72>>2];y=v[a+32>>2];m=v[a+28>>2]+m|0;b=v[a+60>>2];e=b;j=b>>31;t=jg(h,x)<<8;b=t;b=Jka(e,j,b,b>>31);z=nb;e=b;b=v[a+64>>2];j=b;A=b>>31;b=Zb(k,-16777216,16776704);j=Jka(j,A,b,b>>31);e=e+j|0;b=nb+z|0;b=e>>>0<j>>>0?b+1|0:b;j=e;e=v[a+68>>2];f=Zb(f,-16777216,16776704);e=Jka(e,e>>31,f,f>>31);f=j+e|0;b=nb+b|0;b=e>>>0>f>>>0?b+1|0:b;f=f+8388608|0;b=f>>>0<8388608?b+1|0:b;b=Yc(f,b,24);f=(b|0)/256|0;v[c>>2]=B(m>>12,f)+v[c>>2];l=l+y|0;v[c+4>>2]=v[c+4>>2]+B(l>>12,f);Rb(g,n,s);b=b-(i&t)|0;c=c+8|0;i=v[g>>2];e=v[g+4>>2];f=k;continue b}else{Sd(h,u[e+(v[g+12>>2]<<1)>>1]/4<<16>>16);Rd(h,4);Rb(g+8|0,q,r);b=b-1|0;continue}}break}v[a>>2]=i;v[a+4>>2]=e;v[a+40>>2]=l;v[a+20>>2]=m>>12;v[a+36>>2]=m;v[a+48>>2]=f;v[a+44>>2]=k;v[a+24>>2]=l>>12;kb=g+16|0}function nda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,w=0,x=0,y=0,z=0,A=0,C=0;g=kb-48|0;kb=g;m=v[a+16>>2];b=0;while(1){if((b|0)!=2){e=b<<3;f=e+(g+24|0)|0;e=a+e|0;v[f+4>>2]=v[e+44>>2];v[f+8>>2]=v[e+48>>2];b=b+1|0;continue}break}n=v[a+24>>2];o=v[a+20>>2];b=v[a+4>>2];v[g+16>>2]=v[a>>2];v[g+20>>2]=b;p=v[a+72>>2];b=v[a+68>>2];q=b;r=b>>31;b=v[a+64>>2];s=b;w=b>>31;b=v[a+60>>2];x=b;y=b>>31;z=v[a+8>>2];A=v[a+12>>2];while(1){if(d){e=v[g+16>>2];k=(((v[g+20>>2]&2147483647)<<1|e>>>31)&-2)+m|0;b=e>>>21&2040;i=u[b+39782>>1];h=u[b+39780>>1];l=u[b+39778>>1];j=u[b+39776>>1];b=0;e=0;while(1){if((e|0)!=2){f=e+k|0;v[(g+8|0)+(e<<2)>>2]=(((B(t[f|0],l)+B(t[f-2|0],j)|0)+B(h,t[f+2|0])|0)+B(i,t[f+4|0])<<8)/16384;e=e+1|0;continue}break}while(1){if((b|0)!=2){k=(g+8|0)+(b<<2)|0;f=v[k>>2];e=(g+24|0)+(b<<3)|0;i=v[e+8>>2];h=v[e+4>>2];v[e+8>>2]=h;l=f<<8;f=l;f=Jka(x,y,f,f>>31);j=nb;C=e;e=Zb(h,-16777216,16776704);h=Jka(s,w,e,e>>31);f=h+f|0;e=nb+j|0;e=f>>>0<h>>>0?e+1|0:e;j=f;f=Zb(i,-16777216,16776704);i=Jka(q,r,f,f>>31);f=j+i|0;e=nb+e|0;e=f>>>0<i>>>0?e+1|0:e;f=f+8388608|0;e=f>>>0<8388608?e+1|0:e;e=Yc(f,e,24);v[C+4>>2]=e-(l&p);v[k>>2]=(e|0)/256;b=b+1|0;continue}break}v[c>>2]=v[c>>2]+B(v[g+8>>2],o);v[c+4>>2]=v[c+4>>2]+B(v[g+12>>2],n);Rb(g+16|0,z,A);c=c+8|0;d=d-1|0;continue}break}b=v[g+20>>2];v[a>>2]=v[g+16>>2];v[a+4>>2]=b;b=0;while(1){if((b|0)!=2){c=b<<3;d=c+a|0;c=c+(g+24|0)|0;v[d+44>>2]=v[c+4>>2];v[d+48>>2]=v[c+8>>2];b=b+1|0;continue}break}kb=g+48|0}function Lba(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,x=0,y=0,z=0,A=0;f=kb+-64|0;kb=f;a:{b:{c:{d:{e:{f:{g:{if(!a){break g}l=e<<2;if(l>>>0>d>>>0){break g}s=l-4|0;o=B(b,e);x=o-8|0;h:while(1){b=v[c+8>>2];h=v[c>>2];v[23540]=0;b=W(156,h|0,b|0,l|0)|0;h=v[23540];v[23540]=0;if((h|0)==1){break b}if(!(b&n>>>0<o>>>0)){break g}v[23540]=0;U(190,f+16|0,c|0,d|0);b=v[23540];v[23540]=0;if((b|0)==1){break c}b=f+16|0;h=kc(f+40|0,b);Bb(b);v[23540]=0;R(560,b|0,h|0);b=v[23540];v[23540]=0;if((b|0)==1){break e}y=Ie(f+16|0);p=v[f+16>>2];z=p-4|0;k=0;while(1){if((e|0)==(k|0)){Uc(f+16|0);Bb(h);n=(p-l<<1)+n|0;continue h}v[23540]=0;g=S(553,h|0)|0;b=v[23540];v[23540]=0;if((b|0)!=1){v[23540]=0;b=S(206,h|0)|0;j=v[23540];v[23540]=0;if((j|0)==1){break f}v[f+8>>2]=b;oe(f+8|0,0,89);v[23540]=0;Q(188,h|0,1)|0;b=v[23540];v[23540]=0;if((b|0)==1){break f}j=k+n|0;b=e+k<<2;i:while(1){j:{if(j>>>0>x>>>0){break j}m=0;if(b>>>0>z>>>0){break j}while(1)if((m|0)==8){b=b+s|0;continue i}else{q=v[f+8>>2];i=w[b+y|0];r=m&1;i=r?i>>>4|0:i&15;v[f+8>>2]=q+t[(i&7)+30328|0];A=g;g=u[(q<<1)+30336>>1];g=(((0-(i&1)&g>>2)+(g>>3)|0)+(i<<30>>31&g>>1)|0)+(g&i<<29>>31)|0;v[f+12>>2]=A+(i&8?0-g|0:g);oe(f+8|0,0,88);oe(f+12|0,-32768,32767);g=v[f+12>>2];u[(j<<1)+a>>1]=g;m=m+1|0;j=e+j|0;b=b+r|0;continue}}break}k=k+1|0;continue}break}break}break f}Bb(c);kb=f- -64|0;return}b=P()|0;O()|0;Uc(f+16|0);break d}b=P()|0;O()|0}Bb(h);break a}b=P()|0;O()|0;break a}b=P()|0;O()|0}Bb(c);T(b|0);L()}function OW(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;f=kb-48|0;kb=f;g=wi(b)^-1;a:{if(uc(v[d>>2],v[d+4>>2])>>>0<=g>>>0){Ys(a);break a}wi(b);if((w[c+4|0]|w[c+5|0]<<8)>>>0>=60){$b(b,4)}j=f,k=wi(b),v[j+44>>2]=k;$b(b,4);h=wi(b);i=wi(b);if(!((h|0)>0&(i|0)>36)){Ys(a);break a}if(Aq(Nd(v[e>>2],v[Eb(v[d>>2],g)>>2]),13086)){Ys(a);break a}Hv(f,b,i,h);d=kc(f+24|0,f);Bb(f);b=v[d>>2];v[23540]=0;b=S(178,b|0)|0;e=v[23540];v[23540]=0;b:{if((e|0)==1){break b}c:{d:{if(!b){v[23540]=0;S(187,a|0)|0;a=v[23540];v[23540]=0;if((a|0)!=1){break d}break b}b=w[c+4|0]|w[c+5|0]<<8;if(b>>>0<=39){v[23540]=0;Q(188,d|0,8)|0;b=v[23540];v[23540]=0;if((b|0)==1){break b}b=w[c+4|0]|w[c+5|0]<<8}if((b&65535)>>>0<=59){v[23540]=0;Q(188,d|0,16)|0;b=v[23540];v[23540]=0;if((b|0)==1){break b}}v[23540]=0;S(189,d|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break b}e:{f:{b=w[c+4|0]|w[c+5|0]<<8;g:{if(b>>>0>=120){v[23540]=0;S(189,d|0)|0;c=v[23540];v[23540]=0;b=8;break g}h:{if(b>>>0>=100){v[23540]=0;Q(188,d|0,4)|0;b=v[23540];v[23540]=0;if((b|0)==1){break b}break h}if(b>>>0<62){break f}}v[23540]=0;S(189,d|0)|0;c=v[23540];v[23540]=0;b=4}if((c|0)==1){break b}v[23540]=0;Q(188,d|0,b|0)|0;break e}v[23540]=0;S(189,d|0)|0}b=v[23540];v[23540]=0;if((b|0)==1){break b}v[23540]=0;b=S(189,d|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break c}v[23540]=0;U(190,f|0,d|0,b|0);b=v[23540];v[23540]=0;if((b|0)==1){break c}j=kc(a,f),k=v[f+44>>2],v[j+20>>2]=k;Bb(f)}Bb(d);break a}}a=P()|0;O()|0;Bb(d);T(a|0);L()}kb=f+48|0}function Xca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,w=0,x=0,y=0,z=0,A=0;h=kb-16|0;kb=h;a:{b:{c:{i=v[a+12>>2];k=v[a+8>>2];d:{if((i|0)<=1&k>>>0<=805306368|(i|0)<=0){if((i|0)>=-2&k>>>0>=3489660928|(i|0)>-2){break c}if((i|0)==-2&k>>>0>2147483647|i>>>0>4294967294){break d}break b}if((i|0)==1&k>>>0>2147483648|i>>>0>1){break b}}n=b+196648|0;break a}n=b+131112|0;break a}n=b+262184|0}o=v[a+16>>2];b=v[a+48>>2];l=v[a+40>>2];m=v[a+36>>2];e=v[a+44>>2];f=v[a+4>>2];v[h+8>>2]=v[a>>2];v[h+12>>2]=f;p=v[a+32>>2];q=v[a+28>>2];r=v[a+72>>2];f=v[a+68>>2];s=f;w=f>>31;f=v[a+64>>2];x=f;y=f>>31;f=v[a+60>>2];z=f;A=f>>31;while(1){f=e;if(d){e=Zb(f,-16777216,16776704);e=Jka(x,y,e,e>>31);g=nb;j=e;b=Zb(b,-16777216,16776704);e=Jka(s,w,b,b>>31);j=j+e|0;b=nb+g|0;b=e>>>0>j>>>0?b+1|0:b;g=v[h+12>>2]+o|0;e=(v[h+8>>2]>>>16&65520)+n|0;g=(((((((B(t[g-2|0],u[e+2>>1])+B(t[g-3|0],u[e>>1])|0)+B(t[g-1|0],u[e+4>>1])|0)+B(t[g|0],u[e+6>>1])|0)+B(t[g+1|0],u[e+8>>1])|0)+B(t[g+2|0],u[e+10>>1])|0)+B(t[g+3|0],u[e+12>>1])|0)+B(t[g+4|0],u[e+14>>1])<<8)/32768<<8;e=g;e=Jka(e,e>>31,z,A);j=e+j|0;b=nb+b|0;b=e>>>0>j>>>0?b+1|0:b;e=j+8388608|0;b=e>>>0<8388608?b+1|0:b;e=Yc(e,b,24);b=(e|0)/256|0;m=m+q|0;v[c>>2]=B(b,m>>12)+v[c>>2];l=l+p|0;v[c+4>>2]=v[c+4>>2]+B(l>>12,b);Rb(h+8|0,k,i);e=e-(g&r)|0;c=c+8|0;d=d-1|0;b=f;continue}break}c=v[h+12>>2];v[a>>2]=v[h+8>>2];v[a+4>>2]=c;v[a+40>>2]=l;v[a+20>>2]=m>>12;v[a+36>>2]=m;v[a+48>>2]=b;v[a+44>>2]=f;v[a+24>>2]=l>>12;kb=h+16|0}function Z_(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,u=0,x=0,y=0,z=0,A=0,B=0,C=0;v[c>>2]=a;z=d&512;while(1){if((x|0)==4){if(Hb(n)>>>0>1){f=nt(n);e=kb-16|0;kb=e;v[e+8>>2]=f;f=v[Ke(e+8|0)>>2];kb=e+16|0;B=c,C=_F(f,mt(n),v[c>>2]),v[B>>2]=C}d=d&176;if((d|0)!=16){if((d|0)==32){a=v[c>>2]}v[b>>2]=a}return}a:{b:{switch(t[i+x|0]){case 0:v[b>>2]=v[c>>2];break a;case 1:v[b>>2]=v[c>>2];p=Hl(g,32);q=v[c>>2];v[c>>2]=q+1;t[q|0]=p;break a;case 3:if(Re(n)){break a}p=w[hg(n,0)|0];q=v[c>>2];v[c>>2]=q+1;t[q|0]=p;break a;case 2:if(Re(m)|!z){break a}B=c,C=_F(nt(m),mt(m),v[c>>2]),v[B>>2]=C;break a;case 4:break b;default:break a}}p=v[g+8>>2];A=v[c>>2];e=e+h|0;r=e;while(1){c:{if(f>>>0<=r>>>0){break c}if(!vh(p,2048,t[r|0])){break c}r=r+1|0;continue}break}p=o;if((p|0)>0){while(1){if(!(!p|e>>>0>=r>>>0)){r=r-1|0;q=w[r|0];s=v[c>>2];v[c>>2]=s+1;t[s|0]=q;p=p-1|0;continue}break}if(p){q=Hl(g,48)}else{q=0}while(1){s=v[c>>2];v[c>>2]=s+1;if((p|0)>0){t[s|0]=q;p=p-1|0;continue}break}t[s|0]=j}d:{if((e|0)==(r|0)){p=Hl(g,48);q=v[c>>2];v[c>>2]=q+1;t[q|0]=p;break d}if(Re(l)){q=-1}else{q=t[hg(l,0)|0]}p=0;u=0;while(1){if((e|0)==(r|0)){break d}e:{if((p|0)!=(q|0)){s=p;break e}q=v[c>>2];v[c>>2]=q+1;t[q|0]=k;s=0;u=u+1|0;if(Hb(l)>>>0<=u>>>0){q=p;break e}q=-1;if(w[hg(l,u)|0]==127){break e}q=t[hg(l,u)|0]}r=r-1|0;p=w[r|0];y=v[c>>2];v[c>>2]=y+1;t[y|0]=p;p=s+1|0;continue}}_l(A,v[c>>2])}x=x+1|0;continue}}function FV(){var a=0,b=0,c=0;if(!w[467808]){a=kb-16|0;kb=a;Es(467456);v[116876]=-1;v[116874]=467512;v[116872]=93856;v[116864]=78500;t[467508]=0;b=a+8|0;as(b,467456);c=v[v[116864]+8>>2];v[23540]=0;R(c|0,467456,b|0);b=v[23540];v[23540]=0;a:{if((b|0)!=1){ac(a+8|0);kb=a+16|0;break a}b=P()|0;O()|0;ac(a+8|0);Mn(467456);T(b|0);L()}Ks(466784);v[116696]=78632;v[116694]=78612;v[116695]=0;Ln(466784,467456);gH(467520,94e3,467568);Kw(466952,467520);gH(467576,93696,467624);Kw(467120,467576);Kw(467288,v[(v[v[116780]-12>>2]+467120|0)+24>>2]);fH(v[v[116694]-12>>2]+466776|0);SH(v[v[116780]-12>>2]+467120|0);fH(v[v[116780]-12>>2]+467120|0);a=kb-16|0;kb=a;tH(467632);v[116920]=-1;v[116918]=467688;v[116916]=93856;v[116908]=78892;t[467684]=0;b=a+8|0;as(b,467632);c=v[v[116908]+8>>2];v[23540]=0;R(c|0,467632,b|0);b=v[23540];v[23540]=0;b:{if((b|0)!=1){ac(a+8|0);kb=a+16|0;break b}b=P()|0;O()|0;ac(a+8|0);ds(467632);T(b|0);L()}cH(466872);v[116718]=79024;v[116716]=79004;v[116717]=0;Ln(466872,467632);eH(467696,94e3,467744);Jw(467036,467696);eH(467752,93696,467800);Jw(467204,467752);Jw(467372,v[(v[v[116801]-12>>2]+467204|0)+24>>2]);dH(v[v[116716]-12>>2]+466864|0);SH(v[v[116801]-12>>2]+467204|0);dH(v[v[116801]-12>>2]+467204|0);t[467808]=1}a=kb-16|0;kb=a;c:{if(fb(a+12|0,a+8|0)|0){break c}b=Pd((v[a+12>>2]<<2)+4|0);v[116954]=b;if(!b){break c}b=Pd(v[a+8>>2]);if(b){c=v[116954];v[c+(v[a+12>>2]<<2)>>2]=0;if(!(eb(c|0,b|0)|0)){break c}}v[116954]=0}kb=a+16|0;v[116024]=42;v[116042]=467908}function qca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,w=0,x=0,y=0,z=0,A=0;g=kb-16|0;kb=g;w=v[a+16>>2];x=kg(b+327720|0,v[b+20>>2],(v[a+88>>2]&16384)>>>14|0);p=v[a+128>>2];a:{if(!p){n=v[a+8>>2];s=v[a+12>>2];i=v[a>>2];e=v[a+4>>2];o=0;break a}b=v[a+12>>2];s=b;n=v[a+8>>2];q=lg(n,b,p);r=nb;k=v[a+76>>2];i=v[a>>2];e=v[a+4>>2];Qf(i,e,qf(n,b,d),nb);o=k>>>0<nb>>>0?d:0}h=a+112|0;f=v[a+48>>2];l=v[a+40>>2];m=v[a+36>>2];b=v[a+44>>2];v[g>>2]=i;v[g+4>>2]=e;b:while(1){c:{k=b;if(!d){break c}d=d-1|0;v[g+8>>2]=i;v[g+12>>2]=0;o=o-1|0;b=o;q=b?q:0;r=b?r:0;e=e+w|0;b=p;while(1)if((b|0)<=0){Rb(h,v[a+120>>2],v[a+124>>2]);b=v[a+116>>2];if(b){Sd(h,t[e+v[g+12>>2]|0]<<6);Rd(h,b);v[h>>2]=v[h>>2];v[h+4>>2]=0}i=v[a+72>>2];y=v[a+32>>2];m=v[a+28>>2]+m|0;b=v[a+60>>2];e=b;j=b>>31;u=jg(h,x)<<8;b=u;b=Jka(e,j,b,b>>31);z=nb;e=b;b=v[a+64>>2];j=b;A=b>>31;b=Zb(k,-16777216,16776704);j=Jka(j,A,b,b>>31);e=e+j|0;b=nb+z|0;b=e>>>0<j>>>0?b+1|0:b;j=e;e=v[a+68>>2];f=Zb(f,-16777216,16776704);e=Jka(e,e>>31,f,f>>31);f=j+e|0;b=nb+b|0;b=e>>>0>f>>>0?b+1|0:b;f=f+8388608|0;b=f>>>0<8388608?b+1|0:b;b=Yc(f,b,24);f=(b|0)/256|0;v[c>>2]=B(m>>12,f)+v[c>>2];l=l+y|0;v[c+4>>2]=v[c+4>>2]+B(l>>12,f);Rb(g,n,s);b=b-(i&u)|0;c=c+8|0;i=v[g>>2];e=v[g+4>>2];f=k;continue b}else{Sd(h,t[e+v[g+12>>2]|0]<<6);Rd(h,4);Rb(g+8|0,q,r);b=b-1|0;continue}}break}v[a>>2]=i;v[a+4>>2]=e;v[a+40>>2]=l;v[a+20>>2]=m>>12;v[a+36>>2]=m;v[a+48>>2]=f;v[a+44>>2]=k;v[a+24>>2]=l>>12;kb=g+16|0}function a5(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;e=kb-80|0;kb=e;f=Tb(a);a=0;c=v[b+24>>2];g=tj(Wb(v[c+484360>>2],w[c+484376|0]));v[23540]=0;R(181,f|0,g|0);c=v[23540];v[23540]=0;a:{if((c|0)!=1){while(1){b:{if((a|0)!=(g|0)){c=v[b+24>>2];d=v[c+484344>>2];h=v[c+484348>>2];c=x[cc(v[Wb(v[c+484360>>2],w[c+484376|0])>>2],a)>>1];if(Sm(d,h,c)){v[23540]=0;R(1016,e+48|0,_b(d,c)|0);c=v[23540];v[23540]=0;c:{d:{e:{if((c|0)!=1){c=v[b+24>>2];v[23540]=0;U(1003,e- -64|0,c|0,e+48|0);c=v[23540];v[23540]=0;if((c|0)==1){break e}v[23540]=0;R(183,f|0,e- -64|0);c=v[23540];v[23540]=0;if((c|0)==1){break d}zb(e- -64|0);zb(e+48|0);break b}a=P()|0;O()|0;break a}a=P()|0;O()|0;break c}a=P()|0;O()|0;zb(e- -64|0)}zb(e+48|0);break a}f:{switch(c-65534|0){case 0:v[23540]=0;c=Q(55,e+32|0,9269)|0;d=v[23540];v[23540]=0;g:{if((d|0)!=1){v[23540]=0;R(183,f|0,c|0);d=v[23540];v[23540]=0;if((d|0)==1){break g}zb(c);break b}a=P()|0;O()|0;break a}a=P()|0;O()|0;zb(c);break a;case 1:v[23540]=0;c=Q(55,e+16|0,9231)|0;d=v[23540];v[23540]=0;h:{if((d|0)!=1){v[23540]=0;R(183,f|0,c|0);d=v[23540];v[23540]=0;if((d|0)==1){break h}zb(c);break b}a=P()|0;O()|0;break a}a=P()|0;O()|0;zb(c);break a;default:break f}}v[23540]=0;c=Q(55,e|0,14640)|0;d=v[23540];v[23540]=0;i:{if((d|0)!=1){v[23540]=0;R(183,f|0,c|0);d=v[23540];v[23540]=0;if((d|0)==1){break i}zb(c);break b}a=P()|0;O()|0;break a}a=P()|0;O()|0;zb(c);break a}kb=e+80|0;return}a=a+1|0;continue}}a=P()|0;O()|0}Xe(f);T(a|0);L()}function Cda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0;g=kb-48|0;kb=g;m=v[a+16>>2];b=0;while(1){if((b|0)!=2){e=b<<3;f=e+(g+24|0)|0;e=a+e|0;v[f+4>>2]=v[e+44>>2];v[f+8>>2]=v[e+48>>2];b=b+1|0;continue}break}n=v[a+24>>2];o=v[a+20>>2];b=v[a+4>>2];v[g+16>>2]=v[a>>2];v[g+20>>2]=b;p=v[a+72>>2];b=v[a+68>>2];q=b;r=b>>31;b=v[a+64>>2];s=b;t=b>>31;b=v[a+60>>2];w=b;x=b>>31;y=v[a+8>>2];z=v[a+12>>2];while(1){if(d){b=v[g+16>>2];j=b>>>18|0;i=((((v[g+20>>2]&2147483647)<<1|b>>>31)&2147483646)<<1)+m|0;b=0;e=0;while(1){if((e|0)!=2){h=i+(e<<1)|0;f=u[h>>1];v[(g+8|0)+(e<<2)>>2]=f+((B(j,u[h+4>>1]-f|0)|0)/16384|0);e=e+1|0;continue}break}while(1){if((b|0)!=2){j=(g+8|0)+(b<<2)|0;f=v[j>>2];e=(g+24|0)+(b<<3)|0;i=v[e+8>>2];h=v[e+4>>2];v[e+8>>2]=h;l=f<<8;f=l;f=Jka(w,x,f,f>>31);k=nb;A=e;e=Zb(h,-16777216,16776704);h=Jka(s,t,e,e>>31);f=h+f|0;e=nb+k|0;e=f>>>0<h>>>0?e+1|0:e;k=f;f=Zb(i,-16777216,16776704);i=Jka(q,r,f,f>>31);f=k+i|0;e=nb+e|0;e=f>>>0<i>>>0?e+1|0:e;f=f+8388608|0;e=f>>>0<8388608?e+1|0:e;e=Yc(f,e,24);v[A+4>>2]=e-(p&l);v[j>>2]=(e|0)/256;b=b+1|0;continue}break}v[c>>2]=v[c>>2]+B(v[g+8>>2],o);v[c+4>>2]=v[c+4>>2]+B(n,v[g+12>>2]);Rb(g+16|0,y,z);c=c+8|0;d=d-1|0;continue}break}b=v[g+20>>2];v[a>>2]=v[g+16>>2];v[a+4>>2]=b;b=0;while(1){if((b|0)!=2){c=b<<3;d=c+a|0;c=c+(g+24|0)|0;v[d+44>>2]=v[c+4>>2];v[d+48>>2]=v[c+8>>2];b=b+1|0;continue}break}kb=g+48|0}function D$(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;m=b;i=kb-432|0;kb=i;v[i+424>>2]=37;v[i+428>>2]=0;l=Qr(i+424|1,13899,v[c+4>>2]);v[i+380>>2]=i+384;a=Gd();a:{if(l){b=v[c+8>>2];j=i- -64|0;v[j>>2]=g;v[j+4>>2]=h;v[i+56>>2]=e;v[i+60>>2]=f;v[i+48>>2]=b;j=$g(i+384|0,30,a,i+424|0,i+48|0);break a}v[i+80>>2]=e;v[i+84>>2]=f;v[i+88>>2]=g;v[i+92>>2]=h;j=$g(i+384|0,30,a,i+424|0,i+80|0)}v[i+128>>2]=1119;k=se(i+368|0,0,i+128|0);b=i+384|0;a=b;b:{c:{d:{e:{if((j|0)>=30){a=Gd();f:{if(l){j=v[c+8>>2];v[i+16>>2]=g;v[i+20>>2]=h;v[i+8>>2]=e;v[i+12>>2]=f;v[i>>2]=j;j=Xi(i+380|0,a,i+424|0,i);break f}v[i+32>>2]=e;v[i+36>>2]=f;v[i+40>>2]=g;v[i+44>>2]=h;j=Xi(i+380|0,a,i+424|0,i+32|0)}if((j|0)==-1){v[23540]=0;Z(1120);a=v[23540];v[23540]=0;if((a|0)==1){break d}break e}a=v[i+380>>2];_e(k,a)}f=a+j|0;g=Zi(a,f,c);v[i+116>>2]=1119;e=se(i+120|0,0,i+116|0);g:{h:{if((i+384|0)==(a|0)){j=i+128|0;break h}j=Pd(j<<3);if(!j){v[23540]=0;Z(1120);a=v[23540];v[23540]=0;if((a|0)!=1){break e}a=P()|0;O()|0;break g}_e(e,j);b=a}a=i+104|0;gd(a,c);v[23540]=0;ia(1152,b|0,g|0,f|0,j|0,i+116|0,i+112|0,a|0);a=v[23540];v[23540]=0;i:{if((a|0)!=1){ac(i+104|0);v[23540]=0;a=ka(1153,m|0,j|0,v[i+116>>2],v[i+112>>2],c|0,d|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break i}Xc(e);Xc(k);kb=i+432|0;break b}a=P()|0;O()|0;ac(i+104|0);break g}a=P()|0;O()|0}Xc(e);break c}L()}a=P()|0;O()|0}Xc(k);T(a|0);L()}return a|0}function N$(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;m=b;i=kb-256|0;kb=i;v[i+248>>2]=37;v[i+252>>2]=0;l=Qr(i+248|1,13899,v[c+4>>2]);v[i+204>>2]=i+208;a=Gd();a:{if(l){b=v[c+8>>2];j=i- -64|0;v[j>>2]=g;v[j+4>>2]=h;v[i+56>>2]=e;v[i+60>>2]=f;v[i+48>>2]=b;j=$g(i+208|0,30,a,i+248|0,i+48|0);break a}v[i+80>>2]=e;v[i+84>>2]=f;v[i+88>>2]=g;v[i+92>>2]=h;j=$g(i+208|0,30,a,i+248|0,i+80|0)}v[i+128>>2]=1119;k=se(i+192|0,0,i+128|0);b=i+208|0;a=b;b:{c:{d:{e:{if((j|0)>=30){a=Gd();f:{if(l){j=v[c+8>>2];v[i+16>>2]=g;v[i+20>>2]=h;v[i+8>>2]=e;v[i+12>>2]=f;v[i>>2]=j;j=Xi(i+204|0,a,i+248|0,i);break f}v[i+32>>2]=e;v[i+36>>2]=f;v[i+40>>2]=g;v[i+44>>2]=h;j=Xi(i+204|0,a,i+248|0,i+32|0)}if((j|0)==-1){v[23540]=0;Z(1120);a=v[23540];v[23540]=0;if((a|0)==1){break d}break e}a=v[i+204>>2];_e(k,a)}f=a+j|0;g=Zi(a,f,c);v[i+116>>2]=1119;e=se(i+120|0,0,i+116|0);g:{h:{if((i+208|0)==(a|0)){j=i+128|0;break h}j=Pd(j<<1);if(!j){v[23540]=0;Z(1120);a=v[23540];v[23540]=0;if((a|0)!=1){break e}a=P()|0;O()|0;break g}_e(e,j);b=a}a=i+104|0;gd(a,c);v[23540]=0;ia(1147,b|0,g|0,f|0,j|0,i+116|0,i+112|0,a|0);a=v[23540];v[23540]=0;i:{if((a|0)!=1){ac(i+104|0);v[23540]=0;a=ka(15,m|0,j|0,v[i+116>>2],v[i+112>>2],c|0,d|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break i}Xc(e);Xc(k);kb=i+256|0;break b}a=P()|0;O()|0;ac(i+104|0);break g}a=P()|0;O()|0}Xc(e);break c}L()}a=P()|0;O()|0}Xc(k);T(a|0);L()}return a|0}function Dda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,w=0,x=0,y=0,z=0,A=0;g=kb-48|0;kb=g;m=v[a+16>>2];b=0;while(1){if((b|0)!=2){e=b<<3;f=e+(g+24|0)|0;e=a+e|0;v[f+4>>2]=v[e+44>>2];v[f+8>>2]=v[e+48>>2];b=b+1|0;continue}break}n=v[a+24>>2];o=v[a+20>>2];b=v[a+4>>2];v[g+16>>2]=v[a>>2];v[g+20>>2]=b;p=v[a+72>>2];b=v[a+68>>2];q=b;r=b>>31;b=v[a+64>>2];s=b;u=b>>31;b=v[a+60>>2];w=b;x=b>>31;y=v[a+8>>2];z=v[a+12>>2];while(1){if(d){b=v[g+16>>2];j=b>>>10&4194048;i=(((v[g+20>>2]&2147483647)<<1|b>>>31)&-2)+m|0;b=0;e=0;while(1){if((e|0)!=2){h=e+i|0;f=t[h|0];v[(g+8|0)+(e<<2)>>2]=((B(j,t[h+2|0]-f|0)|0)/16384|0)+(f<<8);e=e+1|0;continue}break}while(1){if((b|0)!=2){j=(g+8|0)+(b<<2)|0;f=v[j>>2];e=(g+24|0)+(b<<3)|0;i=v[e+8>>2];h=v[e+4>>2];v[e+8>>2]=h;l=f<<8;f=l;f=Jka(w,x,f,f>>31);k=nb;A=e;e=Zb(h,-16777216,16776704);h=Jka(s,u,e,e>>31);f=h+f|0;e=nb+k|0;e=f>>>0<h>>>0?e+1|0:e;k=f;f=Zb(i,-16777216,16776704);i=Jka(q,r,f,f>>31);f=k+i|0;e=nb+e|0;e=f>>>0<i>>>0?e+1|0:e;f=f+8388608|0;e=f>>>0<8388608?e+1|0:e;e=Yc(f,e,24);v[A+4>>2]=e-(p&l);v[j>>2]=(e|0)/256;b=b+1|0;continue}break}v[c>>2]=v[c>>2]+B(v[g+8>>2],o);v[c+4>>2]=v[c+4>>2]+B(n,v[g+12>>2]);Rb(g+16|0,y,z);c=c+8|0;d=d-1|0;continue}break}b=v[g+20>>2];v[a>>2]=v[g+16>>2];v[a+4>>2]=b;b=0;while(1){if((b|0)!=2){c=b<<3;d=c+a|0;c=c+(g+24|0)|0;v[d+44>>2]=v[c+4>>2];v[d+48>>2]=v[c+8>>2];b=b+1|0;continue}break}kb=g+48|0}function Sda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,C=0,D=0;g=kb-48|0;kb=g;n=v[a+16>>2];k=Tf(1,2);b=nb;o=b;Rb(a,k,b);b=0;while(1){if((b|0)!=2){e=b<<3;f=e+(g+24|0)|0;e=a+e|0;v[f+4>>2]=v[e+44>>2];v[f+8>>2]=v[e+48>>2];b=b+1|0;continue}break}p=v[a+24>>2];q=v[a+20>>2];b=v[a+4>>2];v[g+16>>2]=v[a>>2];v[g+20>>2]=b;r=v[a+72>>2];b=v[a+68>>2];s=b;t=b>>31;b=v[a+64>>2];w=b;x=b>>31;b=v[a+60>>2];y=b;z=b>>31;A=v[a+8>>2];C=v[a+12>>2];while(1){if(d){d=d-1|0;f=((((v[g+20>>2]&2147483647)<<1|v[g+16>>2]>>>31)&2147483646)<<1)+n|0;b=0;e=0;while(1){if((e|0)!=2){v[(g+8|0)+(e<<2)>>2]=u[f+(e<<1)>>1];e=e+1|0;continue}break}while(1){if((b|0)!=2){l=(g+8|0)+(b<<2)|0;f=v[l>>2];e=(g+24|0)+(b<<3)|0;i=v[e+8>>2];h=v[e+4>>2];v[e+8>>2]=h;m=f<<8;f=m;f=Jka(y,z,f,f>>31);j=nb;D=e;e=Zb(h,-16777216,16776704);h=Jka(w,x,e,e>>31);f=h+f|0;e=nb+j|0;e=f>>>0<h>>>0?e+1|0:e;j=f;f=Zb(i,-16777216,16776704);i=Jka(s,t,f,f>>31);f=j+i|0;e=nb+e|0;e=f>>>0<i>>>0?e+1|0:e;f=f+8388608|0;e=f>>>0<8388608?e+1|0:e;e=Yc(f,e,24);v[D+4>>2]=e-(r&m);v[l>>2]=(e|0)/256;b=b+1|0;continue}break}v[c>>2]=v[c>>2]+B(v[g+8>>2],q);v[c+4>>2]=v[c+4>>2]+B(p,v[g+12>>2]);Rb(g+16|0,A,C);c=c+8|0;continue}break}b=v[g+20>>2];v[a>>2]=v[g+16>>2];v[a+4>>2]=b;b=0;while(1){if((b|0)!=2){c=b<<3;d=c+a|0;c=c+(g+24|0)|0;v[d+44>>2]=v[c+4>>2];v[d+48>>2]=v[c+8>>2];b=b+1|0;continue}break}mg(a,k,o);kb=g+48|0}function X$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;a=kb-384|0;kb=a;v[a+368>>2]=c;v[a+376>>2]=b;uw(a+216|0,d,a+240|0,a+236|0,a+232|0);d=Nb(a+200|0);b=bd(d);v[23540]=0;R(60,d|0,b|0);b=v[23540];v[23540]=0;a:{b:{c:{if((b|0)!=1){c=Tc(d,0);v[a+196>>2]=c;v[a+28>>2]=a+32;v[a+24>>2]=0;t[a+23|0]=1;t[a+22|0]=69;h=v[a+232>>2];i=v[a+236>>2];while(1){d:{v[23540]=0;b=Q(1137,a+376|0,a+368|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break d}if(!b){break c}g=v[a+196>>2];b=Hb(d);if((g|0)==(b+c|0)){v[23540]=0;R(60,d|0,b<<1);c=v[23540];v[23540]=0;if((c|0)==1){break b}c=bd(d);v[23540]=0;R(60,d|0,c|0);c=v[23540];v[23540]=0;if((c|0)==1){break b}c=Tc(d,0);v[a+196>>2]=b+c}v[23540]=0;b=S(1139,v[a+376>>2])|0;g=v[23540];v[23540]=0;if((g|0)==1){break d}if(tw(b,a+23|0,a+22|0,c,a+196|0,i,h,a+216|0,a+32|0,a+28|0,a+24|0,a+240|0)){break c}v[23540]=0;S(1141,a+376|0)|0;b=v[23540];v[23540]=0;if((b|0)!=1){continue}}break}break b}break b}e:{if(!Hb(a+216|0)|!w[a+23|0]){break e}b=v[a+28>>2];if((b-(a+32|0)|0)>159){break e}v[a+28>>2]=b+4;v[b>>2]=v[a+24>>2]}vG(a,c,v[a+196>>2],e);b=v[a>>2];c=v[a+4>>2];h=v[a+12>>2];v[f+8>>2]=v[a+8>>2];v[f+12>>2]=h;v[f>>2]=b;v[f+4>>2]=c;Ff(a+216|0,a+32|0,v[a+28>>2],e);v[23540]=0;b=Q(1138,a+376|0,a+368|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){if(b){v[e>>2]=v[e>>2]|2}b=v[a+376>>2];zb(d);zb(a+216|0);kb=a+384|0;break a}}b=P()|0;O()|0;zb(d);zb(a+216|0);T(b|0);L()}return b|0}function e0(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;a=kb-288|0;kb=a;v[a+272>>2]=c;v[a+280>>2]=b;yw(a+224|0,d,a+240|0,a+239|0,a+238|0);d=Nb(a+208|0);b=bd(d);v[23540]=0;R(60,d|0,b|0);b=v[23540];v[23540]=0;a:{b:{c:{if((b|0)!=1){c=Tc(d,0);v[a+204>>2]=c;v[a+28>>2]=a+32;v[a+24>>2]=0;t[a+23|0]=1;t[a+22|0]=69;h=t[a+238|0];i=t[a+239|0];while(1){d:{v[23540]=0;b=Q(1121,a+280|0,a+272|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break d}if(!b){break c}g=v[a+204>>2];b=Hb(d);if((g|0)==(b+c|0)){v[23540]=0;R(60,d|0,b<<1);c=v[23540];v[23540]=0;if((c|0)==1){break b}c=bd(d);v[23540]=0;R(60,d|0,c|0);c=v[23540];v[23540]=0;if((c|0)==1){break b}c=Tc(d,0);v[a+204>>2]=b+c}v[23540]=0;b=S(1123,v[a+280>>2])|0;g=v[23540];v[23540]=0;if((g|0)==1){break d}if(xw(b,a+23|0,a+22|0,c,a+204|0,i,h,a+224|0,a+32|0,a+28|0,a+24|0,a+240|0)){break c}v[23540]=0;S(1125,a+280|0)|0;b=v[23540];v[23540]=0;if((b|0)!=1){continue}}break}break b}break b}e:{if(!Hb(a+224|0)|!w[a+23|0]){break e}b=v[a+28>>2];if((b-(a+32|0)|0)>159){break e}v[a+28>>2]=b+4;v[b>>2]=v[a+24>>2]}vG(a,c,v[a+204>>2],e);b=v[a>>2];c=v[a+4>>2];h=v[a+12>>2];v[f+8>>2]=v[a+8>>2];v[f+12>>2]=h;v[f>>2]=b;v[f+4>>2]=c;Ff(a+224|0,a+32|0,v[a+28>>2],e);v[23540]=0;b=Q(1122,a+280|0,a+272|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){if(b){v[e>>2]=v[e>>2]|2}b=v[a+280>>2];zb(d);zb(a+224|0);kb=a+288|0;break a}}b=P()|0;O()|0;zb(d);zb(a+224|0);T(b|0);L()}return b|0}function E7(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;j=kb-16|0;kb=j;i=kb-32|0;kb=i;h=of(i+16|0,1,0);a:{b:{c:{while(1){g=Ac(h);d=g+Hb(h)|0;c=v[b>>2];f=v[b+4>>2];if(!((f|0)>0|(f|0)>=0|(d|0)==(g|0))){t[g|0]=45;e=c;c=0-c|0;g=g+1|0;f=0-(f+((e|0)!=0)|0)|0}k=d-g|0;d:{if((k|0)<=19){e=E(f);e=B(64-((e|0)==32?E(c|1)+32|0:e)|0,1233)>>12;n=(e<<3)+25856|0;l=k;k=v[n+4>>2];m=61;if((l|0)<(((f|0)==(k|0)&c>>>0>=y[n>>2]|f>>>0>k>>>0)+e|0)){break d}}e:{if(!f&c>>>0<=99999999){d=Zw(g,c);break e}if((f|0)==2328306&c>>>0<=1874919423|f>>>0<2328306){d=Mka(c,f,1e8,0);e=nb;l=Zw(g,d);d=Jka(d,e,-1e8,0)+c|0;c=d;d=(c>>>0)/1e4|0;d=cj(cj(l,d),c+B(d,-1e4)|0);break e}d=Mka(c,f,1874919424,2328306);e=nb;g=Yw(g,d);d=Jka(d,e,-1874919424,-2328307)+c|0;e=f+nb|0;e=c>>>0>d>>>0?e+1|0:e;c=Mka(d,e,1e8,0);e=nb;f=(c>>>0)/1e4|0;l=cj(cj(g,f),c+B(f,-1e4)|0);c=Jka(c,e,-1e8,0)+d|0;d=(c>>>0)/1e4|0;d=cj(cj(l,d),c+B(d,-1e4)|0)}m=0}v[i+12>>2]=m;v[i+8>>2]=d;if(!v[i+12>>2]){break c}c=ch(Hb(h));v[23540]=0;R(59,h|0,c|0);c=v[23540];v[23540]=0;if((c|0)!=1){continue}break}break b}b=v[i+8>>2];c=Ac(h);v[23540]=0;R(60,h|0,b-c|0);b=v[23540];v[23540]=0;f:{if((b|0)!=1){v[23540]=0;R(61,j|0,h|0);b=v[23540];v[23540]=0;if((b|0)!=1){break f}break b}break b}zb(h);kb=i+32|0;break a}a=P()|0;O()|0;zb(h);T(a|0);L()}v[23540]=0;R(58,a|0,j|0);a=v[23540];v[23540]=0;if((a|0)!=1){zb(j);kb=j+16|0;return}a=P()|0;O()|0;zb(j);T(a|0);L()}function uj(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;a:{if(!_d(v[a>>2],v[a+20>>2])){break a}Dk(a);b:{switch($m(x[a+34>>1])-1|0){case 1:e=kb+-64|0;kb=e;h=v[a+20>>2];c=v[a>>2];d=Ld(x[a+34>>1]);f=h+(B(c,d)<<1)|0;while(1){c:{d:{if((g|0)!=16){i=B(d,g);j=B(d,g^-1);c=0;break d}g=f+(d<<5)|0;c=x[a+34>>1];if(c&2){i=v[a+8>>2];f=v[a+4>>2];Db(e+32|0,b+1074312|0,33);sP(e+40|0,g,h+(B(d,f)<<1)|0,i-f|0,d,(c&4)>>>2|0,Cb(v[v[e+32>>2]>>2],v[e+36>>2]));c=x[a+34>>1]}if(c&8){f=v[a+16>>2];a=v[a+12>>2];Db(e+32|0,b+1074312|0,33);sP(e+8|0,g+(d<<7)|0,h+(B(a,d)<<1)|0,f-a|0,d,(c&16)>>>4|0,Cb(v[v[e+32>>2]>>2],v[e+36>>2]))}kb=e- -64|0;break c}while(1){if((c|0)!=(d|0)){u[f+(c+i<<1)>>1]=x[f+(c-d<<1)>>1];u[h+(c+j<<1)>>1]=x[h+(c<<1)>>1];c=c+1|0;continue}break}g=g+1|0;continue}break};return;case 0:break b;default:break a}}e=kb+-64|0;kb=e;h=v[a+20>>2];c=v[a>>2];d=Ld(x[a+34>>1]);f=h+B(c,d)|0;while(1){e:{f:{if((g|0)!=16){i=B(d,g);j=B(d,g^-1);c=0;break f}g=f+(d<<4)|0;c=x[a+34>>1];if(c&2){i=v[a+8>>2];f=v[a+4>>2];Db(e+32|0,b+1074312|0,33);rP(e+40|0,g,h+B(d,f)|0,i-f|0,d,(c&4)>>>2|0,Cb(v[v[e+32>>2]>>2],v[e+36>>2]));c=x[a+34>>1]}if(c&8){f=v[a+16>>2];a=v[a+12>>2];Db(e+32|0,b+1074312|0,33);rP(e+8|0,g+(d<<6)|0,h+B(a,d)|0,f-a|0,d,(c&16)>>>4|0,Cb(v[v[e+32>>2]>>2],v[e+36>>2]))}kb=e- -64|0;break e}while(1){if((c|0)!=(d|0)){t[f+(c+i|0)|0]=w[f+(c-d|0)|0];t[h+(c+j|0)|0]=w[c+h|0];c=c+1|0;continue}break}g=g+1|0;continue}break}}}function kW(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;f=kb-32|0;kb=f;zc(c);while(1){a:{if(!Qb(v[c>>2],v[c+8>>2],3)){break a}d=f+24|0;Yq(d,c);i=Oc(d);h=Te(d);d=w[f+24|0];if(d>>>0>=y[a+12>>2]){break a}g=jd(v[a>>2],v[v[a+48>>2]+12>>2],d,b);d=w[i|0];if(d>>>0<=126){if(!(d|w[h|0])){t[g|0]=254;continue}t[g|0]=d+1;if(w[h|0]==255){continue}t[g+2|0]=1;t[g+4|0]=w[h|0];continue}b:{switch(d-127|0){case 1:t[g+1|0]=w[h|0]+1;continue;case 0:continue;default:break b}}e=t[h|0];t[f+23|0]=e;h=0;j=w[i|0];d=j&127;if(d>>>0<=23){h=w[d+26256|0]}c:{d:{e:{f:{g:{switch(d-2|0){case 0:case 8:case 9:if((e|0)>=0){break f}d=0-e&15;break e;case 1:t[f+16|0]=64;e=w[Yb(f+23|0,f+16|0)|0];if(w[g+2|0]>1){break d}t[g+4|0]=e;t[g+2|0]=1;continue;case 2:d=3;if((e|0)>=0){break c}d=0-e&127;break e;case 15:if(!e){continue}d=0-e|-16;if((e|0)<0){break e}d=e<<4|15;break e;case 16:case 20:if(!e){continue}d=(e|0)>=0;if(!d){e=0-e&15;t[f+23|0]=e;j=w[i|0]}d=d?3:2;e=((j|0)==22?-32:-16)|e;t[f+23|0]=e;break c;case 17:d=e&15|-48;break e;case 18:d=e&15|-64;break e;case 21:break g;default:break d}}d=164;if((e|0)==100){break e}v[f+16>>2]=e- -64;v[f+12>>2]=0;v[f+8>>2]=128;e=v[Jj(f+16|0,f+12|0,f+8|0)>>2];if(!w[g+3|0]){break d}h:{switch(w[g+2|0]){case 0:case 2:break h;default:continue}}t[g+2|0]=2;t[g+4|0]=(e&254)>>>1;continue}d=e<<4}e=d;t[f+23|0]=e}d=h;if(!d){continue}}t[g+5|0]=e;t[g+3|0]=d;continue}break}kb=f+32|0}function Tda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,w=0,x=0,y=0,z=0,A=0,C=0,D=0;g=kb-48|0;kb=g;n=v[a+16>>2];k=Tf(1,2);b=nb;o=b;Rb(a,k,b);b=0;while(1){if((b|0)!=2){e=b<<3;f=e+(g+24|0)|0;e=a+e|0;v[f+4>>2]=v[e+44>>2];v[f+8>>2]=v[e+48>>2];b=b+1|0;continue}break}p=v[a+24>>2];q=v[a+20>>2];b=v[a+4>>2];v[g+16>>2]=v[a>>2];v[g+20>>2]=b;r=v[a+72>>2];b=v[a+68>>2];s=b;u=b>>31;b=v[a+64>>2];w=b;x=b>>31;b=v[a+60>>2];y=b;z=b>>31;A=v[a+8>>2];C=v[a+12>>2];while(1){if(d){d=d-1|0;f=(((v[g+20>>2]&2147483647)<<1|v[g+16>>2]>>>31)&-2)+n|0;b=0;e=0;while(1){if((e|0)!=2){v[(g+8|0)+(e<<2)>>2]=t[e+f|0]<<8;e=e+1|0;continue}break}while(1){if((b|0)!=2){l=(g+8|0)+(b<<2)|0;f=v[l>>2];e=(g+24|0)+(b<<3)|0;i=v[e+8>>2];h=v[e+4>>2];v[e+8>>2]=h;m=f<<8;f=m;f=Jka(y,z,f,f>>31);j=nb;D=e;e=Zb(h,-16777216,16776704);h=Jka(w,x,e,e>>31);f=h+f|0;e=nb+j|0;e=f>>>0<h>>>0?e+1|0:e;j=f;f=Zb(i,-16777216,16776704);i=Jka(s,u,f,f>>31);f=j+i|0;e=nb+e|0;e=f>>>0<i>>>0?e+1|0:e;f=f+8388608|0;e=f>>>0<8388608?e+1|0:e;e=Yc(f,e,24);v[D+4>>2]=e-(r&m);v[l>>2]=(e|0)/256;b=b+1|0;continue}break}v[c>>2]=v[c>>2]+B(v[g+8>>2],q);v[c+4>>2]=v[c+4>>2]+B(p,v[g+12>>2]);Rb(g+16|0,A,C);c=c+8|0;continue}break}b=v[g+20>>2];v[a>>2]=v[g+16>>2];v[a+4>>2]=b;b=0;while(1){if((b|0)!=2){c=b<<3;d=c+a|0;c=c+(g+24|0)|0;v[d+44>>2]=v[c+4>>2];v[d+48>>2]=v[c+8>>2];b=b+1|0;continue}break}mg(a,k,o);kb=g+48|0}function Qq(a,b,c,d){var e=0,f=0;e=kb-16|0;kb=e;t[e+15|0]=c;a:{b:{c:{d:{switch(b-2|0){case 11:t[e+14|0]=64;de(a,1,Yb(e+15|0,e+14|0));break a;case 0:if(!(c&3|c>>>0>223?d:1)){break c}t[e+14|0]=c>>>2;de(a,12,e+14|0);break a;case 1:if(!(c&3|c>>>0>223?d:1)){break c}t[e+14|0]=c>>>2;de(a,13,e+14|0);break a;case 2:if(c>>>0>=240){t[e+14|0]=9;de(a,11,e+14|0);break a}b=0;while(1){if((b|0)==10){break c}f=w[b+43808|0];e:{if(d){if(c>>>0>f>>>0){break e}break b}if((c|0)==(f|0)){break b}}b=b+1|0;continue};case 3:f:{if(d){t[e+14|0]=c&15;t[e+13|0]=9;c=w[Yb(e+14|0,e+13|0)|0];t[e+15|0]=c;break f}if(c&240|(c&14)>>>0>9){break c}}t[e+14|0]=c&15;de(a,8,e+14|0);break a;case 24:g:{if(d){t[e+15|0]=0;break g}if(c){break c}}de(a,8,e+15|0);break a;case 7:t[e+15|0]=(c|0)==255?64:c>>>2|0;de(a,2,e+15|0);break a;case 9:if(!c){break c}b=c&15;if(!b){t[e+14|0]=c>>>4;de(a,3,e+14|0);break a}d=c&240;if(!d){de(a,4,e+15|0);break a}if((b|0)==15){t[e+14|0]=c>>>4;de(a,5,e+14|0);break a}if((d|0)!=240){break c}t[e+14|0]=c&15;de(a,6,e+14|0);break a;case 18:if((c&240)!=128){break c}t[e+14|0]=c<<2&60|2;de(a,2,e+14|0);break a;case 17:break d;default:break c}}h:{switch((c>>>4|0)-8|0){case 0:t[e+14|0]=c<<2&60|2;de(a,2,e+14|0);break a;case 2:t[e+14|0]=c&15;de(a,5,e+14|0);break a;case 3:break h;default:break c}}t[e+14|0]=c&15;de(a,6,e+14|0);break a}t[e+14|0]=0;de(a,0,e+14|0);break a}t[e+14|0]=b;de(a,11,e+14|0)}kb=e+16|0}function tca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0;g=kb-16|0;kb=g;s=v[a+16>>2];t=kg(b+327720|0,v[b+20>>2],(v[a+88>>2]&16384)>>>14|0);n=v[a+128>>2];a:{if(!n){k=v[a+8>>2];l=v[a+12>>2];i=v[a>>2];e=v[a+4>>2];m=0;break a}k=v[a+8>>2];l=v[a+12>>2];o=lg(k,l,n);p=nb;b=v[a+76>>2];i=v[a>>2];e=v[a+4>>2];Qf(i,e,qf(k,l,d),nb);m=b>>>0<nb>>>0?d:0}h=a+112|0;f=v[a+48>>2];w=v[a+24>>2];x=v[a+20>>2];b=v[a+44>>2];v[g>>2]=i;v[g+4>>2]=e;b:while(1){c:{q=b;if(!d){break c}d=d-1|0;v[g+8>>2]=i;v[g+12>>2]=0;m=m-1|0;b=m;o=b?o:0;p=b?p:0;e=(e<<1)+s|0;b=n;while(1)if((b|0)<=0){Rb(h,v[a+120>>2],v[a+124>>2]);b=v[a+116>>2];if(b){Sd(h,u[e+(v[g+12>>2]<<1)>>1]/4<<16>>16);Rd(h,b);v[h>>2]=v[h>>2];v[h+4>>2]=0}i=v[a+72>>2];b=v[a+60>>2];e=b;j=b>>31;r=jg(h,t)<<8;b=r;b=Jka(e,j,b,b>>31);y=nb;e=b;b=v[a+64>>2];j=b;z=b>>31;b=Zb(q,-16777216,16776704);j=Jka(j,z,b,b>>31);e=e+j|0;b=nb+y|0;b=e>>>0<j>>>0?b+1|0:b;j=e;e=v[a+68>>2];f=Zb(f,-16777216,16776704);e=Jka(e,e>>31,f,f>>31);f=j+e|0;b=nb+b|0;b=e>>>0>f>>>0?b+1|0:b;f=f+8388608|0;b=f>>>0<8388608?b+1|0:b;b=Yc(f,b,24);f=(b|0)/256|0;v[c>>2]=B(f,x)+v[c>>2];v[c+4>>2]=v[c+4>>2]+B(f,w);Rb(g,k,l);b=b-(i&r)|0;c=c+8|0;i=v[g>>2];e=v[g+4>>2];f=q;continue b}else{Sd(h,u[e+(v[g+12>>2]<<1)>>1]/4<<16>>16);Rd(h,4);Rb(g+8|0,o,p);b=b-1|0;continue}}break}v[a>>2]=i;v[a+4>>2]=e;v[a+48>>2]=f;v[a+44>>2]=q;kb=g+16|0}function W$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;a=kb-352|0;kb=a;v[a+336>>2]=c;v[a+344>>2]=b;h=Nb(a+208|0);b=a+16|0;gd(b,d);v[23540]=0;b=S(1132,b|0)|0;c=v[23540];v[23540]=0;a:{b:{c:{d:{if((c|0)==1){break d}v[23540]=0;X(1144,b|0,83808,83834,a+224|0);b=v[23540];v[23540]=0;if((b|0)==1){break d}ac(a+16|0);c=Nb(a+192|0);b=bd(c);v[23540]=0;R(60,c|0,b|0);b=v[23540];v[23540]=0;if((b|0)==1){break b}b=Tc(c,0);v[a+188>>2]=b;v[a+12>>2]=a+16;v[a+8>>2]=0;while(1){e:{v[23540]=0;d=Q(1137,a+344|0,a+336|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break e}if(!d){break c}g=v[a+188>>2];d=Hb(c);if((g|0)==(d+b|0)){v[23540]=0;R(60,c|0,d<<1);b=v[23540];v[23540]=0;if((b|0)==1){break b}b=bd(c);v[23540]=0;R(60,c|0,b|0);b=v[23540];v[23540]=0;if((b|0)==1){break b}b=Tc(c,0);v[a+188>>2]=d+b}v[23540]=0;d=S(1139,v[a+344>>2])|0;g=v[23540];v[23540]=0;if((g|0)==1){break e}if(zn(d,16,b,a+188|0,a+8|0,0,h,a+16|0,a+12|0,a+224|0)){break c}v[23540]=0;S(1141,a+344|0)|0;d=v[23540];v[23540]=0;if((d|0)!=1){continue}}break}break b}b=P()|0;O()|0;ac(a+16|0);break a}v[23540]=0;R(60,c|0,v[a+188>>2]-b|0);b=v[23540];v[23540]=0;f:{if((b|0)==1){break f}b=Mc(c);d=Gd();v[a>>2]=f;if((uG(b,d,a)|0)!=1){v[e>>2]=4}v[23540]=0;b=Q(1138,a+344|0,a+336|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break f}if(b){v[e>>2]=v[e>>2]|2}b=v[a+344>>2];zb(c);zb(h);kb=a+352|0;return b|0}}b=P()|0;O()|0;zb(c)}zb(h);T(b|0);L()}function lE(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=kb-96|0;kb=c;a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{if(!b){yc(a,9769);break j}if(!(b&65535)){d=kb-16|0;kb=d;e=yc(d,4402);ad(c+80|0,e);Ab(e);kb=d+16|0;v[23540]=0;v[c+24>>2]=b>>>24;R(109,c- -64|0,c+24|0);d=v[23540];v[23540]=0;k:{l:{m:{n:{if((d|0)!=1){v[23540]=0;v[c+8>>2]=b>>>16&255;R(110,c+48|0,c+8|0);b=v[23540];v[23540]=0;if((b|0)==1){break n}v[23540]=0;X(111,a|0,c+80|0,c- -64|0,c+48|0);a=v[23540];v[23540]=0;if((a|0)==1){break m}Ab(c+48|0);Ab(c- -64|0);dc(c+80|0);break j}b=P()|0;O()|0;break k}b=P()|0;O()|0;break l}b=P()|0;O()|0;Ab(c+48|0)}Ab(c- -64|0)}break a}d=kb-16|0;kb=d;e=yc(d,4126);ad(c+80|0,e);Ab(e);kb=d+16|0;v[23540]=0;v[c+44>>2]=b>>>24;R(109,c- -64|0,c+44|0);d=v[23540];v[23540]=0;if((d|0)==1){break i}v[23540]=0;v[c+40>>2]=b>>>16&255;R(110,c+48|0,c+40|0);d=v[23540];v[23540]=0;if((d|0)==1){break h}v[23540]=0;v[c+20>>2]=b>>>8&255;R(110,c+24|0,c+20|0);d=v[23540];v[23540]=0;if((d|0)==1){break g}v[23540]=0;v[c+4>>2]=b&255;R(110,c+8|0,c+4|0);b=v[23540];v[23540]=0;if((b|0)==1){break f}v[23540]=0;ma(112,a|0,c+80|0,c- -64|0,c+48|0,c+24|0,c+8|0);a=v[23540];v[23540]=0;if((a|0)==1){break e}Ab(c+8|0);Ab(c+24|0);Ab(c+48|0);Ab(c- -64|0);dc(c+80|0)}kb=c+96|0;return}b=P()|0;O()|0;break a}b=P()|0;O()|0;break b}b=P()|0;O()|0;break c}b=P()|0;O()|0;break d}b=P()|0;O()|0;Ab(c+8|0)}Ab(c+24|0)}Ab(c+48|0)}Ab(c- -64|0)}dc(c+80|0);T(b|0);L()}function d0(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;a=kb-272|0;kb=a;v[a+256>>2]=c;v[a+264>>2]=b;h=Nb(a+208|0);b=a+16|0;gd(b,d);v[23540]=0;b=S(19,b|0)|0;c=v[23540];v[23540]=0;a:{b:{c:{d:{if((c|0)==1){break d}v[23540]=0;X(1130,b|0,83808,83834,a+224|0);b=v[23540];v[23540]=0;if((b|0)==1){break d}ac(a+16|0);c=Nb(a+192|0);b=bd(c);v[23540]=0;R(60,c|0,b|0);b=v[23540];v[23540]=0;if((b|0)==1){break b}b=Tc(c,0);v[a+188>>2]=b;v[a+12>>2]=a+16;v[a+8>>2]=0;while(1){e:{v[23540]=0;d=Q(1121,a+264|0,a+256|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break e}if(!d){break c}g=v[a+188>>2];d=Hb(c);if((g|0)==(d+b|0)){v[23540]=0;R(60,c|0,d<<1);b=v[23540];v[23540]=0;if((b|0)==1){break b}b=bd(c);v[23540]=0;R(60,c|0,b|0);b=v[23540];v[23540]=0;if((b|0)==1){break b}b=Tc(c,0);v[a+188>>2]=d+b}v[23540]=0;d=S(1123,v[a+264>>2])|0;g=v[23540];v[23540]=0;if((g|0)==1){break e}if(An(d,16,b,a+188|0,a+8|0,0,h,a+16|0,a+12|0,a+224|0)){break c}v[23540]=0;S(1125,a+264|0)|0;d=v[23540];v[23540]=0;if((d|0)!=1){continue}}break}break b}b=P()|0;O()|0;ac(a+16|0);break a}v[23540]=0;R(60,c|0,v[a+188>>2]-b|0);b=v[23540];v[23540]=0;f:{if((b|0)==1){break f}b=Mc(c);d=Gd();v[a>>2]=f;if((uG(b,d,a)|0)!=1){v[e>>2]=4}v[23540]=0;b=Q(1122,a+264|0,a+256|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break f}if(b){v[e>>2]=v[e>>2]|2}b=v[a+264>>2];zb(c);zb(h);kb=a+272|0;return b|0}}b=P()|0;O()|0;zb(c)}zb(h);T(b|0);L()}function _ca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0;h=kb-16|0;kb=h;a:{b:{c:{i=v[a+12>>2];j=v[a+8>>2];d:{if((i|0)<=1&j>>>0<=805306368|(i|0)<=0){if((i|0)>=-2&j>>>0>=3489660928|(i|0)>-2){break c}if((i|0)==-2&j>>>0>2147483647|i>>>0>4294967294){break d}break b}if((i|0)==1&j>>>0>2147483648|i>>>0>1){break b}}n=b+196648|0;break a}n=b+131112|0;break a}n=b+262184|0}o=v[a+16>>2];f=v[a+48>>2];p=v[a+24>>2];q=v[a+20>>2];b=v[a+44>>2];e=v[a+4>>2];v[h+8>>2]=v[a>>2];v[h+12>>2]=e;r=v[a+72>>2];e=v[a+68>>2];s=e;t=e>>31;e=v[a+64>>2];w=e;x=e>>31;e=v[a+60>>2];y=e;z=e>>31;while(1){e=b;if(d){b=Zb(e,-16777216,16776704);b=Jka(w,x,b,b>>31);k=nb;l=b;g=(v[h+12>>2]<<1)+o|0;b=(v[h+8>>2]>>>16&65520)+n|0;g=(((((((B(u[g-4>>1],u[b+2>>1])+B(u[g-6>>1],u[b>>1])|0)+B(u[g-2>>1],u[b+4>>1])|0)+B(u[g>>1],u[b+6>>1])|0)+B(u[g+2>>1],u[b+8>>1])|0)+B(u[g+4>>1],u[b+10>>1])|0)+B(u[g+6>>1],u[b+12>>1])|0)+B(u[g+8>>1],u[b+14>>1])|0)/32768<<8;b=g;b=Jka(b,b>>31,y,z);l=l+b|0;m=nb+k|0;m=b>>>0>l>>>0?m+1|0:m;b=Zb(f,-16777216,16776704);f=Jka(s,t,b,b>>31);k=f+l|0;b=nb+m|0;b=f>>>0>k>>>0?b+1|0:b;f=k+8388608|0;b=f>>>0<8388608?b+1|0:b;f=Yc(f,b,24);b=(f|0)/256|0;v[c>>2]=B(b,q)+v[c>>2];v[c+4>>2]=v[c+4>>2]+B(b,p);Rb(h+8|0,j,i);b=f-(g&r)|0;c=c+8|0;d=d-1|0;f=e;continue}break}b=v[h+12>>2];v[a>>2]=v[h+8>>2];v[a+4>>2]=b;v[a+48>>2]=f;v[a+44>>2]=e;kb=h+16|0}function $X(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;h=Nb(a);a=w[b+11|0];g=v[b+4>>2];v[23540]=0;k=Gk(g,a);R(115,h|0,k|0);a=v[23540];v[23540]=0;a:{b:{if((a|0)!=1){g=0;a=0;while(1){c:{if((a|0)==(k|0)){a=!f;if(!(l?a&(m^-1):a)){break c}return}e=w[sd(b)+a|0];d:{e:{f:{g:{switch(f+1|0){case 1:f=1;h:{switch(e-123|0){case 2:break h;case 0:break d;default:break f}}f=3;break d;case 2:i:{switch(e-123|0){case 2:m=1;e=g+1|0;f=0;if(d>>>0<=g>>>0){g=e;break d}v[23540]=0;Q(116,h|0,Nd(c,g)|0)|0;j=v[23540];v[23540]=0;g=e;if((j|0)!=1){break d}a=P()|0;O()|0;break b;case 0:break f;default:break i}}f=-1;e=e-48|0;if((e&255)>>>0>9){break d}l=1;f=2;i=e;break d;case 3:f=-1;j:{switch(e-123|0){case 2:f=0;if(d>>>0<=i>>>0){break d}v[23540]=0;Q(116,h|0,Nd(c,i)|0)|0;e=v[23540];v[23540]=0;if((e|0)!=1){break d}a=P()|0;O()|0;break b;case 0:break d;default:break j}}if((e-48&255)>>>0>9){break d}i=(B(i,10)+e|0)-48|0;l=1;f=2;break d;case 4:break g;case 0:break e;default:break d}}j=(e|0)!=125;f=-1;e=125;if(j){break d}}f=0;v[23540]=0;Q(117,h|0,e|0)|0;e=v[23540];v[23540]=0;if((e|0)!=1){break d}a=P()|0;O()|0;break b}f=-1}a=a+1|0;continue}break}b=ba(8)|0;v[23540]=0;a=S(118,b|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){v[23540]=0;U(119,a|0,41876,25);a=v[23540];v[23540]=0;if((a|0)!=1){break a}a=P()|0;O()|0;break b}a=P()|0;O()|0;ca(b|0);break b}a=P()|0;O()|0}Ab(h);T(a|0)}L()}function hea(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=kb-48|0;kb=e;u[e+46>>1]=254;c=tj(a);f=e+32|0;v[f>>2]=0;v[f+4>>2]=0;Gc(f+8|0);if(c){lq(f,c);vC(f,c)}a:{b:{while(1){c:{if((b|0)==(c|0)){if(!(d&65535)){break a}c=Fb(v[a>>2]);d=Fb(v[a+4>>2]);b=kb-16|0;kb=b;c=fA(c,d,x[e+46>>1]);v[b+8>>2]=c;if(Pb(c,d)){v[b>>2]=c;while(1){c=v[Se(b)>>2];if(Pb(c,d)){c=x[c>>1];if((c|0)==x[e+46>>1]){continue}u[v[b+8>>2]>>1]=c;Se(b+8|0);continue}break}c=v[b+8>>2]}kb=b+16|0;b=fc(e+24|0,c);c=v[fc(e+16|0,Fb(v[a+4>>2]))>>2];d=v[b>>2];b=v[a>>2];b=(Ao(d,Fb(b))<<1)+b|0;if(Pb(d,c)){Od(a,Oi(b+(Ao(c,d)<<1)|0,v[a+4>>2],b))}Fb(b);k=e,l=Fb(v[a>>2]),v[k+8>>2]=l;d=Fb(v[a+4>>2]);break c}k=cc(v[f>>2],b),l=b-d|0,u[k>>1]=l;g=v[a+4>>2];h=v[a>>2];v[23540]=0;g=W(748,h|0,g|0,b|0)|0;h=v[23540];v[23540]=0;if((h|0)==1){break b}b=b+1|0;d=(x[g>>1]==254)+d|0;continue}break}while(1){b=v[e+8>>2];if(!Pb(b,d)){b=v[f>>2];d=Rc(b,v[f+4>>2]);c=x[a+28>>1];if(d>>>0<=c>>>0){break a}k=a,l=x[cc(b,c)>>1],u[k+28>>1]=l;break a}d:{c=v[a+24>>2];g=v[c+484344>>2];b=x[b>>1];if(!xe(g,v[c+484348>>2],b)){break d}b=_b(g,b);k=e,l=Fb(v[b>>2]),v[k>>2]=l;g=Fb(v[b+4>>2]);h=v[f+4>>2];c=v[f>>2];while(1){b=v[e>>2];if(!Pb(b,g)){break d}e:{if(w[b+3|0]!=12){break e}j=Rc(c,h);i=w[b+5|0];if(j>>>0<=i>>>0){break e}k=b,l=w[cc(c,i)|0],t[k+5|0]=l}Ck(e);continue}}Se(e+8|0);continue}}a=P()|0;O()|0;od(f);T(a|0);L()}od(f);kb=e+48|0}function $y(a,b,c,d,e){var f=0,g=0,h=0,i=0,j=0,k=0,l=0;h=kb-16|0;kb=h;f=v[c+656>>2];a:{if(!xj(f)){i=v[c+704>>2];f=kb-16|0;kb=f;v[f+12>>2]=d;g=0;b:{if(!d){break b}j=v[b+480180>>2];if(j&20){e=b+1074312|0;Db(f,e,73);d=Cb(v[v[f>>2]>>2],v[f+4>>2])?d&65535:d;if(w[b+480208|0]&16){Db(f,e,73);e=Cb(v[v[f>>2]>>2],v[f+4>>2])?14-((9983-d>>>0)/768|0)&31:((d>>>0)/768|0)+2|0;g=v[((d>>>0)%768<<2)+34e3>>2]<<6>>>e|0;break b}if(!d){v[f+12>>2]=1;d=1}g=229079296/(d>>>0)|0;break b}g=227001280/(d>>>0)|0;if(Km(j)){break b}g=(d+i<<4)-133808|0;if((j|0)==64){break b}xc(f+12|0,16777215);if(j&17408){g=Ec(Mka(Jka(i?i:8363,0,3506176,0),nb,(v[f+12>>2]<<8)+e|0,0),nb);break b}if(mj(b)){d=v[f+12>>2];i=d>>>24|0;j=d<<8;d=j+e|0;e=i+(e>>31)|0;g=((d>>>0<j>>>0?e+1|0:e)&15)<<28|d>>>4;break b}if(w[b+480208|0]&16){g=Ec(Mka(Jka(i?i:8363,0,7012352,0),nb,(v[f+12>>2]<<8)+e|0,0),nb);break b}g=Ec(Mka(-1485242368,13,(v[f+12>>2]<<8)+e|0,0),nb)}e=g;kb=f+16|0;f=v[c+656>>2];break a}e=v[c+700>>2]}v[h+12>>2]=e;c=u[c+774>>1];c:{if(!c){break c}c=f?B(t[f+33|0],c):c;if(!c){break c}e=Qe(oi(+(c|0)/393216)*+(e>>>0));v[h+12>>2]=e}d:{if(!f){break d}c=v[f+40>>2];if(!c){break d}d=(c|0)/2|0;f=v[b+1074420>>2];e=Jka(f,f>>31,e,e>>31);f=d+e|0;d=nb+(d>>31)|0;k=h,l=Hc(Kka(f,e>>>0>f>>>0?d+1|0:d,c,c>>31),nb),v[k+12>>2]=l}xc(h+12|0,2147483647);c=v[h+12>>2];b=Tf(c,v[b+24620>>2]<<4);v[a+8>>2]=c;v[a>>2]=b;v[a+4>>2]=nb;kb=h+16|0}function uR(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;j=kb-16|0;kb=j;a:{if((b|0)==(c|0)){break a}v[j+12>>2]=-1953789045;$z(b,c,j+12|0);c=c-b|0;e=c>>2;v[j+8>>2]=e;f=uc(v[a>>2],v[a+4>>2]);g=11;b:{if(c>>>0>2488){break b}g=7;if(c>>>0>268){break b}g=5;if(c>>>0>152){break b}g=3;if(c>>>0>24){break b}g=e-1>>>1|0}c=f+1|0;v[j+4>>2]=c;n=v[_c(j+4|0,j+8|0)>>2];k=e-g>>>1|0;d=(k<<2)+b|0;h=v[d>>2];i=B(Qt(v[((e<<2)+b|0)-4>>2]^(h^v[b>>2])),1664525);v[d>>2]=i+h;g=g+k|0;d=(g<<2)+b|0;f=f+i|0;v[d>>2]=f+v[d>>2];v[b>>2]=f;i=v[a>>2];a=1;while(1)if((a|0)==(c|0)){while(1)if(c>>>0>=n>>>0){c=n;while(1){if(e+n>>>0<=c>>>0){break a}d=((c+k>>>0)%(e>>>0)<<2)+b|0;h=v[d>>2];f=(c>>>0)%(e>>>0)|0;i=(f<<2)+b|0;a=B(Qt(v[((c-1>>>0)%(e>>>0)<<2)+b>>2]+(h+v[i>>2]|0)|0),1566083941);v[d>>2]=a^h;d=((c+g>>>0)%(e>>>0)<<2)+b|0;a=a-f|0;v[d>>2]=a^v[d>>2];v[i>>2]=a;c=c+1|0;continue}}else{d=((c+k>>>0)%(e>>>0)<<2)+b|0;h=v[d>>2];f=(c>>>0)%(e>>>0)|0;i=(f<<2)+b|0;a=B(Qt(v[((c-1>>>0)%(e>>>0)<<2)+b>>2]^(h^v[i>>2])),1664525);v[d>>2]=a+h;d=((c+g>>>0)%(e>>>0)<<2)+b|0;a=a+f|0;v[d>>2]=a+v[d>>2];v[i>>2]=a;c=c+1|0;continue}}else{d=a-1|0;l=((a+k>>>0)%(e>>>0)<<2)+b|0;m=v[l>>2];h=(a>>>0)%(e>>>0)|0;o=(h<<2)+b|0;f=B(Qt(v[((d>>>0)%(e>>>0)<<2)+b>>2]^(m^v[o>>2])),1664525);v[l>>2]=f+m;l=((a+g>>>0)%(e>>>0)<<2)+b|0;m=v[l>>2];f=v[Eb(i,d)>>2]+(f+h|0)|0;v[l>>2]=f+m;v[o>>2]=f;a=a+1|0;continue}}kb=j+16|0}function $ca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,w=0,x=0,y=0;h=kb-16|0;kb=h;a:{b:{c:{i=v[a+12>>2];k=v[a+8>>2];d:{if((i|0)<=1&k>>>0<=805306368|(i|0)<=0){if((i|0)>=-2&k>>>0>=3489660928|(i|0)>-2){break c}if((i|0)==-2&k>>>0>2147483647|i>>>0>4294967294){break d}break b}if((i|0)==1&k>>>0>2147483648|i>>>0>1){break b}}l=b+196648|0;break a}l=b+131112|0;break a}l=b+262184|0}m=v[a+16>>2];b=v[a+48>>2];n=v[a+24>>2];o=v[a+20>>2];e=v[a+44>>2];f=v[a+4>>2];v[h+8>>2]=v[a>>2];v[h+12>>2]=f;p=v[a+72>>2];f=v[a+68>>2];q=f;r=f>>31;f=v[a+64>>2];s=f;w=f>>31;f=v[a+60>>2];x=f;y=f>>31;while(1){f=e;if(d){e=Zb(f,-16777216,16776704);e=Jka(s,w,e,e>>31);g=nb;j=e;b=Zb(b,-16777216,16776704);e=Jka(q,r,b,b>>31);j=j+e|0;b=nb+g|0;b=e>>>0>j>>>0?b+1|0:b;g=v[h+12>>2]+m|0;e=(v[h+8>>2]>>>16&65520)+l|0;g=(((((((B(t[g-2|0],u[e+2>>1])+B(t[g-3|0],u[e>>1])|0)+B(t[g-1|0],u[e+4>>1])|0)+B(t[g|0],u[e+6>>1])|0)+B(t[g+1|0],u[e+8>>1])|0)+B(t[g+2|0],u[e+10>>1])|0)+B(t[g+3|0],u[e+12>>1])|0)+B(t[g+4|0],u[e+14>>1])<<8)/32768<<8;e=g;e=Jka(e,e>>31,x,y);j=e+j|0;b=nb+b|0;b=e>>>0>j>>>0?b+1|0:b;e=j+8388608|0;b=e>>>0<8388608?b+1|0:b;e=Yc(e,b,24);b=(e|0)/256|0;v[c>>2]=B(b,o)+v[c>>2];v[c+4>>2]=v[c+4>>2]+B(b,n);Rb(h+8|0,k,i);e=e-(g&p)|0;c=c+8|0;d=d-1|0;b=f;continue}break}c=v[h+12>>2];v[a>>2]=v[h+8>>2];v[a+4>>2]=c;v[a+48>>2]=b;v[a+44>>2]=f;kb=h+16|0}function ska(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;h=Nb(a);k=Hb(b);v[23540]=0;R(297,h|0,k|0);a=v[23540];v[23540]=0;a:{b:{if((a|0)!=1){a=0;while(1){c:{if((a|0)==(k|0)){a=!f;if(!(l?a&(m^-1):a)){break c}return}e=t[hg(b,a)|0];g=e&255;d:{e:{f:{g:{switch(f+1|0){case 1:f=1;h:{switch(g-123|0){case 2:break h;case 0:break d;default:break f}}f=3;break d;case 2:i:{switch(g-123|0){case 2:m=1;e=i+1|0;f=0;if(d>>>0<=i>>>0){i=e;break d}v[23540]=0;Q(298,h|0,Nd(c,i)|0)|0;g=v[23540];v[23540]=0;i=e;if((g|0)!=1){break d}a=P()|0;O()|0;break b;case 0:break f;default:break i}}f=-1;e=e-48|0;if((e&255)>>>0>9){break d}l=1;f=2;j=e;break d;case 3:f=-1;j:{switch(g-123|0){case 2:f=0;if(d>>>0<=j>>>0){break d}v[23540]=0;Q(298,h|0,Nd(c,j)|0)|0;e=v[23540];v[23540]=0;if((e|0)!=1){break d}a=P()|0;O()|0;break b;case 0:break d;default:break j}}if((e-48&255)>>>0>9){break d}j=(B(j,10)+e|0)-48|0;l=1;f=2;break d;case 4:break g;case 0:break e;default:break d}}g=(e|0)!=125;f=-1;e=125;if(g){break d}}f=0;v[23540]=0;Q(299,h|0,e|0)|0;e=v[23540];v[23540]=0;if((e|0)!=1){break d}a=P()|0;O()|0;break b}f=-1}a=a+1|0;continue}break}b=ba(8)|0;v[23540]=0;a=S(118,b|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){v[23540]=0;U(119,a|0,41876,25);a=v[23540];v[23540]=0;if((a|0)!=1){break a}a=P()|0;O()|0;break b}a=P()|0;O()|0;ca(b|0);break b}a=P()|0;O()|0}zb(h);T(a|0)}L()}function yZ(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;n=kb-16|0;kb=n;b=c;while(1){a:{if((b|0)==(d|0)){b=d;break a}if(!v[b>>2]){break a}b=b+4|0;continue}break}v[h>>2]=f;v[e>>2]=c;while(1){b:{c:{if(!((c|0)==(d|0)|(f|0)==(g|0))){q=1;r=kb-16|0;kb=r;s=ki(r+8|0,v[a+8>>2]);i=f;j=g-f|0;m=0;o=kb-16|0;kb=o;k=v[e>>2];p=b-c>>2;d:{if(!k|!p){break d}j=i?j:0;while(1){l=$w(j>>>0<4?o+12|0:i,v[k>>2]);if((l|0)==-1){m=-1;break d}if(i){if(j>>>0<=3){if(j>>>0<l>>>0){break d}sc(i,o+12|0,l)}j=j-l|0;i=i+l|0}else{i=0}if(!v[k>>2]){k=0;break d}m=m+l|0;k=k+4|0;p=p-1|0;if(p){continue}break}}if(i){v[e>>2]=k}kb=o+16|0;ji(s);kb=r+16|0;e:{f:{g:{h:{switch(m+1|0){case 0:v[h>>2]=f;while(1){i:{if(v[e>>2]==(c|0)){break i}b=pw(f,v[c>>2],v[a+8>>2]);if((b|0)==-1){break i}f=b+v[h>>2]|0;v[h>>2]=f;c=c+4|0;continue}break};v[e>>2]=c;break g;case 1:break c;default:break h}}f=m+v[h>>2]|0;v[h>>2]=f;if((f|0)==(g|0)){break e}if((b|0)==(d|0)){c=v[e>>2];b=d;continue}b=pw(n+12|0,0,v[a+8>>2]);if((b|0)!=-1){break f}}q=2;break c}c=n+12|0;if(g-v[h>>2]>>>0<b>>>0){break c}while(1){if(b){f=w[c|0];i=v[h>>2];v[h>>2]=i+1;t[i|0]=f;b=b-1|0;c=c+1|0;continue}break}c=v[e>>2]+4|0;v[e>>2]=c;b=c;while(1){if((b|0)==(d|0)){b=d;break b}if(!v[b>>2]){break b}b=b+4|0;continue}}c=v[e>>2]}q=(c|0)!=(d|0)}kb=n+16|0;return q|0}f=v[h>>2];continue}}function TN(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0,k=0;e=kb-32|0;kb=e;f=v[b+64>>2];a:{b:{h=v[b+60>>2];g=x[b+68>>1];if(!((h|0)==-1&(g|0)==65535)){c:{if((f|0)==-1){break c}f=a+1074312|0;Db(e+24|0,f,68);if(Cb(v[v[e+24>>2]>>2],v[e+28>>2])){break c}Db(e+16|0,f,103);if(i=Cb(v[v[e+16>>2]>>2],v[e+20>>2]),j=0,k=(g|0)!=65535,k?i:j){break c}Db(e+8|0,f,49);if(i=Cb(v[v[e+8>>2]>>2],v[e+12>>2]),j=0,k=(g|0)!=65535,k?i:j){break c}f=v[b+64>>2];break b}if((g|0)==65535){u[b+68>>1]=x[b+72>>1]+1}if((h|0)==-1){v[b+60>>2]=0}g=Rc(v[c>>2],v[c+4>>2]);f=x[b+68>>1];if(g>>>0<=f>>>0){f=x[c+28>>1];u[b+68>>1]=f}d:{if(x[b+72>>1]==(f&65535)){break d}c=a+1074312|0;Db(e+24|0,c,26);if(Cb(v[v[e+24>>2]>>2],v[e+28>>2])){break d}Db(e+16|0,c,68);if(Cb(v[v[e+16>>2]>>2],v[e+20>>2])|v[a+480180>>2]==1){break d}c=x[a+480188>>1];f=0;while(1){if((c|0)==(f|0)){break d}t[(B(f,872)+b|0)+1457|0]=0;f=f+1|0;continue}}v[b+52>>2]=v[b+60>>2];if(d){c=1;if(w[a+480208|0]&32){break a}}u[b+74>>1]=x[b+68>>1];c=1;break a}if((f|0)!=-1){break b}c=0;break a}v[b+52>>2]=f;u[b+74>>1]=x[b+72>>1];e:{if(!v[b+20>>2]){break e}c=v[a+480180>>2];if((c|0)==32){Db(e+24|0,a+1074312|0,103);if(Cb(v[v[e+24>>2]>>2],v[e+28>>2])){break e}c=v[a+480180>>2]}if((c|0)==2){break e}v[b+52>>2]=v[b+52>>2]+1}c=0;if(y[b+64>>2]<y[_b(v[a+484344>>2],x[b+70>>1])+12>>2]){break a}v[b+52>>2]=0;u[b+74>>1]=x[b+74>>1]+1;c=0}kb=e+32|0;return c}function uca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,w=0,x=0,y=0,z=0;g=kb-16|0;kb=g;s=v[a+16>>2];u=kg(b+327720|0,v[b+20>>2],(v[a+88>>2]&16384)>>>14|0);n=v[a+128>>2];a:{if(!n){k=v[a+8>>2];l=v[a+12>>2];i=v[a>>2];e=v[a+4>>2];m=0;break a}k=v[a+8>>2];l=v[a+12>>2];o=lg(k,l,n);p=nb;b=v[a+76>>2];i=v[a>>2];e=v[a+4>>2];Qf(i,e,qf(k,l,d),nb);m=b>>>0<nb>>>0?d:0}h=a+112|0;f=v[a+48>>2];w=v[a+24>>2];x=v[a+20>>2];b=v[a+44>>2];v[g>>2]=i;v[g+4>>2]=e;b:while(1){c:{q=b;if(!d){break c}d=d-1|0;v[g+8>>2]=i;v[g+12>>2]=0;m=m-1|0;b=m;o=b?o:0;p=b?p:0;e=e+s|0;b=n;while(1)if((b|0)<=0){Rb(h,v[a+120>>2],v[a+124>>2]);b=v[a+116>>2];if(b){Sd(h,t[e+v[g+12>>2]|0]<<6);Rd(h,b);v[h>>2]=v[h>>2];v[h+4>>2]=0}i=v[a+72>>2];b=v[a+60>>2];e=b;j=b>>31;r=jg(h,u)<<8;b=r;b=Jka(e,j,b,b>>31);y=nb;e=b;b=v[a+64>>2];j=b;z=b>>31;b=Zb(q,-16777216,16776704);j=Jka(j,z,b,b>>31);e=e+j|0;b=nb+y|0;b=e>>>0<j>>>0?b+1|0:b;j=e;e=v[a+68>>2];f=Zb(f,-16777216,16776704);e=Jka(e,e>>31,f,f>>31);f=j+e|0;b=nb+b|0;b=e>>>0>f>>>0?b+1|0:b;f=f+8388608|0;b=f>>>0<8388608?b+1|0:b;b=Yc(f,b,24);f=(b|0)/256|0;v[c>>2]=B(f,x)+v[c>>2];v[c+4>>2]=v[c+4>>2]+B(f,w);Rb(g,k,l);b=b-(i&r)|0;c=c+8|0;i=v[g>>2];e=v[g+4>>2];f=q;continue b}else{Sd(h,t[e+v[g+12>>2]|0]<<6);Rd(h,4);Rb(g+8|0,o,p);b=b-1|0;continue}}break}v[a>>2]=i;v[a+4>>2]=e;v[a+48>>2]=f;v[a+44>>2]=q;kb=g+16|0}function wy(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;h=89;i=88;j=92;k=91;l=85;m=84;n=83;o=5;p=113;q=111;r=107;s=106;t=96;u=82;v=80;w=78;x=79;y=77;z=57;A=47;d=10;e=8;f=7;c=ir(a);a:{b:{c:{d:{switch(b-1|0){default:a=(b|0)==16777216;if(!a&(b|0)!=32){break c}Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(c,0,1),7,1),8,1),9,1),10,1),11,1),12,1),13,1),14,1),15,1),16,1),17,1),18,1),19,1),20,1),21,1),22,1),23,1),24,1),25,1),26,1),27,1),28,1),29,1),30,1),31,1),32,1),33,1),34,1),35,1),36,1),37,1),38,1),39,1),40,1),41,1),42,1),43,1),44,1),45,1),46,1),47,1),48,1),103,1),50,1),87,1),88,1),100,1),102,1),104,1),115,1);if(!a){break a}d=111;e=105;f=99;break b;case 3:Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(c,0,1),4,1),8,1),9,1),10,1),17,1),40,1),51,1),52,1),53,1),54,1),55,1),56,1),57,1),58,1),59,1),60,1),61,1),62,1),63,1),64,1),65,1),66,1),67,1);p=112;q=98;r=93;s=90;t=89;u=86;v=76;w=75;x=74;y=73;z=72;A=71;d=70;e=69;g=68;case 1:Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(c,g,1),e,1),d,1),A,1),z,1),y,1),x,1),w,1);m=88;o=v;n=u;l=t;k=s;j=r;i=q;h=p;break;case 2:break c;case 0:break d}}Ob(Ob(Ob(Ob(c,o,1),n,1),m,1),l,1);g=k;f=j;e=i;d=h}Ob(c,g,1)}Ob(Ob(Ob(c,f,1),e,1),d,1)}}function EI(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;h=kb-16|0;kb=h;g=v[a+32>>2];f=Gs(g);if(!f){f=Fs(g)}a:{b:{c:{if(b>>>0>=f>>>0){b=ba(8)|0;v[23540]=0;c=Q(55,h|0,6003)|0;a=v[23540];v[23540]=0;if((a|0)==1){break c}a=tc(b,c);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break a}a=P()|0;O()|0;zb(c);break b}if(c>>>0>=120){b=ba(8)|0;v[23540]=0;c=Q(55,h|0,11307)|0;a=v[23540];v[23540]=0;if((a|0)!=1){a=tc(b,c);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break a}a=P()|0;O()|0;zb(c);break b}a=P()|0;O()|0;ca(b|0);break b}f=Iy(g,65535);j=(f|0)==65535?255:f;u[h>>1]=j;f=g+B(j,872)|0;i=f+1074992|0;go(i,g,65535,1024);c=c+1|0;t[f+1075794|0]=c;t[f+1075791|0]=c;u[f+1075778>>1]=0;tm(i);Xp(v[a+32>>2],i,b+1|0,0,1,1);v[f+1075688>>2]=65536;lt(v[a+32>>2],i,c,0,1,1,65535);l=f+1075684|0,m=xl(su(e*128,-128,128)+128),v[l>>2]=m;l=f+1075680|0,m=xl(su(d*256,0,256)),v[l>>2]=m;c=v[a+32>>2];i=c+1074478|0;b=i;c=b+(x[c+480212>>1]<<1)|0;g=x[h>>1];f=g;while(1){d:{e:{if((b|0)!=(c|0)){if((f|0)!=x[b>>1]){break e}}else{b=c}break d}b=b+2|0;continue}break}f:{if((b|0)==(c|0)){break f}f=b;while(1){f=f+2|0;if((f|0)==(c|0)){c=b;break f}k=x[f>>1];if((k|0)==(g|0)){continue}u[b>>1]=k;b=b+2|0;g=x[h>>1];continue}}l=v[a+32>>2],m=gz(i,c),u[l+480212>>1]=m;kb=h+16|0;return j|0}a=P()|0;O()|0;ca(b|0)}T(a|0)}L()}function Nia(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=kb-80|0;kb=d;b=b&4095;u[d+78>>1]=b;a:{b:{c:{d:{if(b>>>0>=81){e=kb-16|0;kb=e;f=yc(e,4454);ad(d- -64|0,f);Ab(f);kb=e+16|0;v[23540]=0;e=((b|0)==4095?c:b-80|0)+734016|0;c=Jka(e,e>>31,1e4,0)+14780|0;b=nb;b=Kka(c,c>>>0<14780?b+1|0:b,3652425,0);c=(((e+((b|0)/-4|0)|0)+B(b,-365)|0)+((b|0)/100|0)|0)+((b|0)/-400|0)|0;if((c|0)<0){b=b-1|0;c=(((e+((b|0)/-4|0)|0)+B(b,-365)|0)+((b|0)/100|0)|0)+((b|0)/-400|0)|0}g=b;b=(B(c,100)+52|0)/3060|0;e=b+2|0;f=(e|0)/12|0;v[d+44>>2]=g+f;R(97,d+48|0,d+44|0);g=v[23540];v[23540]=0;e:{f:{g:{h:{i:{j:{if((g|0)!=1){v[23540]=0;v[d+28>>2]=(e+B(f,-12)|0)+1;R(99,d+32|0,d+28|0);e=v[23540];v[23540]=0;if((e|0)==1){break j}v[23540]=0;v[d+12>>2]=(((B(b,306)+5|0)/-10|0)+c|0)+1;R(99,d+16|0,d+12|0);b=v[23540];v[23540]=0;if((b|0)==1){break i}v[23540]=0;da(403,a|0,d- -64|0,d+48|0,d+32|0,d+16|0);a=v[23540];v[23540]=0;if((a|0)==1){break h}Ab(d+16|0);Ab(d+32|0);break d}b=P()|0;O()|0;break e}b=P()|0;O()|0;break f}b=P()|0;O()|0;break g}b=P()|0;O()|0;Ab(d+16|0)}Ab(d+32|0)}Ab(d+48|0)}break a}Sf(d- -64|0,4434);v[23540]=0;R(404,d+48|0,d+78|0);b=v[23540];v[23540]=0;if((b|0)==1){break c}v[23540]=0;U(145,a|0,d- -64|0,d+48|0);a=v[23540];v[23540]=0;if((a|0)==1){break b}}Ab(d+48|0);dc(d- -64|0);kb=d+80|0;return}b=P()|0;O()|0;break a}b=P()|0;O()|0;Ab(d+48|0)}dc(d- -64|0);T(b|0);L()}
function Uea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,z=0,A=0,C=0;i=kb-16|0;kb=i;nd(d,32);g=i+8|0;qQ(g,w[a+24|0]|w[a+25|0]<<8|(w[a+26|0]<<16|w[a+27|0]<<24),w[a+28|0]|w[a+29|0]<<8|(w[a+30|0]<<16|w[a+31|0]<<24),v[b>>2]);g=jc(g);qQ(i,w[a+40|0]|w[a+41|0]<<8|(w[a+42|0]<<16|w[a+43|0]<<24),w[a+44|0]|w[a+45|0]<<8|(w[a+46|0]<<16|w[a+47|0]<<24),v[c>>2]);a=0;g=v[g>>2];if(g-838861>>>0>=4294128436){a=v[jc(i)>>2];v[d>>2]=B(g,320);u[d+34>>1]=1;a:{m=Mg(d);if(!m){break a}l=g<<2;e=+(l>>>0);q=+(a>>>0)/e;r=+(g>>>0)/e;s=1/+y[d>>2];t=+y[i>>2];z=+y[i+8>>2];g=0;b:while(1){if((g|0)==(l|0)){break a}n=+(g>>>0);o=0;p=0;a=v[b+20>>2];if(_d(v[b>>2],a)){e=n*r+z;c:{if(e<4294967296&e>=0){f=~~e>>>0;break c}f=0}k=x[b+34>>1];j=Ld(k);h=B(f,j);e=e-+(f>>>0);d:{if(k&1){f=x[a+(h<<1)>>1];a=x[a+(h+j<<1)>>1];break d}f=w[a+h|0]<<8;a=w[a+(h+j|0)|0]<<8}p=+(f<<16>>16)*(1-e)+e*+(a<<16>>16)}a=v[c+20>>2];if(_d(v[c>>2],a)){e=n*q+t;e:{if(e<4294967296&e>=0){f=~~e>>>0;break e}f=0}k=x[c+34>>1];j=Ld(k);h=B(f,j);e=e-+(f>>>0);f:{if(k&1){f=x[a+(h<<1)>>1];a=x[a+(h+j<<1)>>1];break f}f=w[a+h|0]<<8;a=w[a+(h+j|0)|0]<<8}o=+(f<<16>>16)*(1-e)+e*+(a<<16>>16)}f=0;a=g;while(1)if((f|0)==80){g=g+1|0;continue b}else{e=s*+(a>>>0);A=v[d+20>>2]+(a<<1)|0,C=Sz(p*(1-e)+o*e),u[A>>1]=C;a=a+l|0;f=f+1|0;continue}}}a=(m|0)!=0}kb=i+16|0;return a|0}function YA(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;j=kb-16|0;kb=j;a:{if(b&4){break a}c=w[a+14|0];b:{if(c>>>0>=w[a+15|0]){break b}d=w[a+12|0];if(!(d&2)){break b}t[a+12|0]=d&251}if(!(w[a+12|0]&2)|c>>>0<=w[a+13|0]){break a}e=v[a>>2];d=v[a+4>>2];if($d(e,d)>>>0<=c>>>0){break a}e=x[Pc(e,d,c)>>1];d=Pc(v[a>>2],v[a+4>>2],w[a+14|0]-1|0);c=w[a+14|0];if(x[d>>1]<(e-1|0)){c=x[Pc(v[a>>2],v[a+4>>2],c)>>1]-1&65535;e=dq(a,c,64,64);d=fc(j+8|0,ym(Fb(v[a>>2]),w[a+14|0]));k=yl(j,c,e&255);m=kb-32|0;kb=m;c=v[d>>2];d=v[a>>2];c=(au(c,Fb(d))<<2)+d|0;h=v[a+4>>2];c:{d:{if(h>>>0<y[Gb(a)>>2]){if((c|0)!=(h|0)){break d}OS(a,k);break c}d=Gb(a);f=Vf(m+8|0,qg(a,uc(v[a>>2],h)+1|0),c-v[a>>2]>>2,d);v[23540]=0;R(750,f|0,k|0);d=v[23540];v[23540]=0;if((d|0)!=1){d=v[f+4>>2];i=f+4|0;hq(v[a>>2],c,i);e=v[a+4>>2];g=f+8|0;while(1){if((c|0)!=(e|0)){Im(v[g>>2],x[c>>1]|x[c+2>>1]<<16);v[g>>2]=v[g>>2]+4;c=c+4|0;continue}break}qc(a,i);qc(a+4|0,g);qc(Gb(a),Cc(f));v[f>>2]=v[f+4>>2];c=d;Uf(f);break c}a=P()|0;O()|0;Uf(f);T(a|0);L()}f=kb-16|0;kb=f;i=v[a+4>>2];d=(i-(c+4|0)|0)+c|0;g=Ah(f,a,h-d>>2);l=v[g+4>>2];e=d;while(1){if(e>>>0>=h>>>0){lc(g);Dq(c,d,i);kb=f+16|0}else{Im(l,x[e>>1]|x[e+2>>1]<<16);l=l+4|0;v[g+4>>2]=l;e=e+4|0;continue}break}t[c+2|0]=w[k+2|0];u[c>>1]=x[k>>1]}Fb(c);kb=m+32|0;break a}t[a+14|0]=c-1}if((b|0)!=16777216){t[a+17|0]=255}kb=j+16|0}function Zga(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;e=kb-16|0;kb=e;a:{if((c|0)!=4){g=b+236|0;h=b+108|0;while(1){if((d|0)==120){break a}f=(d<<2)+a|0;i=Lb(h,d),j=w[f+4|0]+1|0,t[i|0]=j;i=cc(g,d),j=(w[f+6|0]|w[f+7|0]<<8)+1|0,u[i>>1]=j;d=d+1|0;continue}}f=b+236|0;while(1){if((d|0)==96){break a}g=(d<<2)+a|0;i=cc(f,d+12|0),j=(w[g+6|0]|w[g+7|0]<<8)+1|0,u[i>>1]=j;d=d+1|0;continue}}rA(a+484|0,b+48|0,0);rA(a+590|0,b+68|0,0);rA(a+696|0,b+88|0,5);v[b>>2]=w[a+806|0]|w[a+807|0]<<8;d=t[a+808|0];b:{if((d|0)<0){t[b+34|0]=d-127;break b}if(d>>>0>16){break b}if(t[a|0]&1){t[b+31|0]=d+1;break b}if(!d){break b}t[b+31|0]=d+1}if(w[b+31|0]){c:{d:{if((c|0)==4){d=w[a+810|0];break d}d=t[a+809|0];if((d|0)>=0){u[b+28>>1]=(d&255)+1}d=t[a+810|0];if((d|0)<0){break c}}t[b+30|0]=d+1}t[b+33|0]=w[a+811|0]}if((c|0)==32){t[e+15|0]=w[a+812|0];t[e+14|0]=128;i=b,j=w[Yb(e+15|0,e+14|0)|0]>>>1|0,v[i+4>>2]=j}c=w[a+813|0]|w[a+814|0]<<8;if(c>>>0<=256){v[b+8>>2]=c;t[b+15|0]=w[b+15|0]|1}t[b+16|0]=w[a+815|0];t[b+26|0]=w[a+816|0];t[b+27|0]=w[a+817|0];t[b+17|0]=w[a+818|0];t[b+18|0]=w[a+819|0];u[e+12>>1]=w[a+820|0]|w[a+821|0]<<8;u[e+10>>1]=100;i=b,j=w[Wc(e+12|0,e+10|0)|0],t[i+20|0]=j;u[e+8>>1]=w[a+822|0]|w[a+823|0]<<8;u[e+6>>1]=256;i=b,j=x[Wc(e+8|0,e+6|0)>>1]>>>2|0,t[i+19|0]=j;c=w[a+824|0];Mj(b,c&127,c>>>7|0);a=w[a+825|0];Lj(b,a&127,a>>>7|0);kb=e+16|0}function LF(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0;a=kb-16|0;kb=a;v[a+12>>2]=c;v[a+8>>2]=f;v[a+12>>2]=c;v[a+8>>2]=f;a:{b:{c:{while(1){c=v[a+12>>2];if(!(c>>>0>=d>>>0|f>>>0>=g>>>0)){i=t[c|0];j=i&255;d:{if((i|0)>=0){u[f>>1]=j;b=c+1|0;break d}b=2;if(i>>>0<4294967234){break b}if(i>>>0<=4294967263){if((d-c|0)<2){break c}i=w[c+1|0];if((i&192)!=128){break a}u[f>>1]=i&63|j<<6&1984;b=c+2|0;break d}if(i>>>0<=4294967279){if((d-c|0)<3){break c}k=w[c+2|0];i=w[c+1|0];e:{f:{if((j|0)!=237){if((j|0)!=224){break f}if((i&224)==160){break e}break a}if((i&224)==128){break e}break a}if((i&192)!=128){break a}}if((k&192)!=128){break a}u[f>>1]=k&63|((i&63)<<6|j<<12);b=c+3|0;break d}if(i>>>0>4294967284){break b}b=1;if((d-c|0)<4){break a}k=w[c+3|0];i=w[c+2|0];c=w[c+1|0];g:{h:{switch(j-240|0){case 0:if((c+112&255)>>>0>=48){break b}break g;case 4:if((c&240)!=128){break b}break g;default:break h}}if((c&192)!=128){break b}}if((i&192)!=128|(k&192)!=128){break b}if((g-f|0)<4){break a}b=2;j=j&7;if((c<<12&196608|j<<18)>>>0>1114111){break a}b=c<<2;u[f>>1]=(i>>>4&3|(b&192|j<<8|b&60))+16320|55296;v[a+8>>2]=f+2;u[f+2>>1]=i<<6&960|k&63|56320;b=v[a+12>>2]+4|0}v[a+12>>2]=b;f=v[a+8>>2]+2|0;v[a+8>>2]=f;continue}break}b=c>>>0<d>>>0;break a}b=1;break a}b=2}v[e>>2]=v[a+12>>2];v[h>>2]=v[a+8>>2];kb=a+16|0;return b|0}function $n(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=kb-16|0;kb=d;h=a+1074312|0;Db(d+8|0,h,96);i=b,j=(k=0,l=v[b+660>>2],m=Cb(v[v[d+8>>2]>>2],v[d+12>>2]),m?k:l)+c|0,v[i+660>>2]=j;g=v[a+480180>>2];e=v[b+84>>2];if(!(!(g&18)|e>>>0>c>>>0|(!(w[b+88|0]&2)|!e))){f=c;c=v[b+80>>2];c=((f-c>>>0)%(e-c>>>0)|0)+c|0}c=c>>>(v[b+88>>2]&1&(g|0)==16384)|0;a:{b:{if(!$c(w[b+788|0])){Db(d+8|0,h,114);if(!Cb(v[v[d+8>>2]>>2],v[d+12>>2])){break b}}e=v[b+656>>2];c:{if(!e){break c}g=w[b+788|0];if(!$c(g)){break c}e=x[cc(e+236|0,g-1|0)>>1];if(!e|e>>>0>x[a+480190>>1]){break a}}d:{if(w[a+480210|0]&32){f=c;c=v[b+660>>2];v[b+660>>2]=f+c;f=0;break d}f=0}v[b>>2]=f;v[b+4>>2]=c;if((!(w[b+88|0]&2)|c>>>0<y[b+84>>2])&c>>>0<y[b+76>>2]){break a}Db(d+8|0,h,57);e:{if(!Cb(v[v[d+8>>2]>>2],v[d+12>>2])){c=v[a+480180>>2];if((c|0)!=16){break e}}v[b+700>>2]=0;v[b+88>>2]=v[b+88>>2]|2097152;break a}if(!(c&1048581)){Db(d+8|0,h,27);if(Cb(v[v[d+8>>2]>>2],v[d+12>>2])){if(w[a+480208|0]&4){c=v[b+76>>2];v[b>>2]=0;v[b+4>>2]=c;break a}v[b>>2]=0;v[b+4>>2]=0;break a}c=v[b+80>>2];v[b>>2]=0;v[b+4>>2]=c;if(!(w[a+480208|0]&4)){break a}a=v[b+76>>2];if(a>>>0<5){break a}v[b>>2]=0;v[b+4>>2]=a-2;break a}if(!(w[b+88|0]&2)|(c|0)!=1){break a}c=v[b+80>>2];v[b>>2]=0;v[b+4>>2]=c;break a}if(!(v[a+480180>>2]&268582928)|c>>>0>=y[b+76>>2]){break a}v[b>>2]=0;v[b+4>>2]=c}kb=d+16|0}function sz(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;a:{e=a;b:{c:{h=a+62|0;f=Lb(h,b);a=t[f|0];if((a|0)==-1){break c}if((a|0)>=0){break b}a=a&127;d=cc(e+26|0,a);g=x[d>>1];if((g|0)!=65535&(b|0)!=(g|0)){break c}u[d>>1]=b;t[f|0]=a;break b}l=e+8|0;i=e+26|0;d=255;a=0;g=255;while(1){if((a|0)!=18){j=cc(i,a);k=x[j>>1];if((k|0)==65535){u[j>>1]=b;t[f|0]=a;break b}else{if(!(w[Lb(l,a)|0]&32)){g=t[Lb(h,k)|0]<0?a:g;d=a}a=a+1|0;continue}}break}if((d&255)!=255){a=(g&255)==255?d:g;d=cc(i,a&255);m=Lb(h,x[d>>1]),n=255,t[m|0]=n;u[d>>1]=b;t[f|0]=a}a=pl(e,b)}g=a&255;if((g|0)==255){break a}if(kk(v[e>>2])){break a}d=Nd(e+318|0,g);a=w[c+8|0]|w[c+9|0]<<8|(w[c+10|0]<<16|w[c+11|0]<<24);t[d+8|0]=a;t[d+9|0]=a>>>8;t[d+10|0]=a>>>16;t[d+11|0]=a>>>24;a=w[c+4|0]|w[c+5|0]<<8|(w[c+6|0]<<16|w[c+7|0]<<24);f=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);t[d|0]=f;t[d+1|0]=f>>>8;t[d+2|0]=f>>>16;t[d+3|0]=f>>>24;t[d+4|0]=a;t[d+5|0]=a>>>8;t[d+6|0]=a>>>16;t[d+7|0]=a>>>24;f=WO(g);h=f+3|0;a=0;while(1){if((a|0)==2){gh(v[e>>2],v[e+4>>2],b,wt(g)|192,w[Lb(c,10)|0])}else{d=a?h:f;gh(v[e>>2],v[e+4>>2],b,d|32,w[Lb(c,a)|0]);gh(v[e>>2],v[e+4>>2],b,d|64,w[Lb(c,a+2|0)|0]);gh(v[e>>2],v[e+4>>2],b,d|96,w[Lb(c,a+4|0)|0]);gh(v[e>>2],v[e+4>>2],b,d|128,w[Lb(c,a+6|0)|0]);gh(v[e>>2],v[e+4>>2],b,d|224,w[Lb(c,a+8|0)|0]);a=a+1|0;continue}break}}}function Z$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=C(0);a=kb-368|0;kb=a;v[a+352>>2]=c;v[a+360>>2]=b;uw(a+200|0,d,a+224|0,a+220|0,a+216|0);d=Nb(a+184|0);b=bd(d);v[23540]=0;R(60,d|0,b|0);b=v[23540];v[23540]=0;a:{b:{c:{if((b|0)!=1){c=Tc(d,0);v[a+180>>2]=c;v[a+12>>2]=a+16;v[a+8>>2]=0;t[a+7|0]=1;t[a+6|0]=69;h=v[a+216>>2];i=v[a+220>>2];while(1){d:{v[23540]=0;b=Q(1137,a+360|0,a+352|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break d}if(!b){break c}g=v[a+180>>2];b=Hb(d);if((g|0)==(b+c|0)){v[23540]=0;R(60,d|0,b<<1);c=v[23540];v[23540]=0;if((c|0)==1){break b}c=bd(d);v[23540]=0;R(60,d|0,c|0);c=v[23540];v[23540]=0;if((c|0)==1){break b}c=Tc(d,0);v[a+180>>2]=b+c}v[23540]=0;b=S(1139,v[a+360>>2])|0;g=v[23540];v[23540]=0;if((g|0)==1){break d}if(tw(b,a+7|0,a+6|0,c,a+180|0,i,h,a+200|0,a+16|0,a+12|0,a+8|0,a+224|0)){break c}v[23540]=0;S(1141,a+360|0)|0;b=v[23540];v[23540]=0;if((b|0)!=1){continue}}break}break b}break b}e:{if(!Hb(a+200|0)|!w[a+7|0]){break e}b=v[a+12>>2];if((b-(a+16|0)|0)>159){break e}v[a+12>>2]=b+4;v[b>>2]=v[a+8>>2]}j=f,k=yG(c,v[a+180>>2],e),z[j>>2]=k;Ff(a+200|0,a+16|0,v[a+12>>2],e);v[23540]=0;b=Q(1138,a+360|0,a+352|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){if(b){v[e>>2]=v[e>>2]|2}b=v[a+360>>2];zb(d);zb(a+200|0);kb=a+368|0;break a}}b=P()|0;O()|0;zb(d);zb(a+200|0);T(b|0);L()}return b|0}function qfa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;e=kb-48|0;kb=e;nd(b,2);f=e+16|0;uk(f,2,a+1|0);d=e+32|0;Fc(d,f);Be(b+43|0,d);zb(d);a:{b:{c:{d:{switch(w[a|0]){case 0:f=v[b+4>>2];d=v[b+8>>2];break c;case 2:break b;case 1:break d;default:break a}}d=w[a+16|0]|w[a+17|0]<<8|(w[a+18|0]<<16|w[a+19|0]<<24);v[b>>2]=d;v[e+32>>2]=w[a+20|0]|w[a+21|0]<<8|(w[a+22|0]<<16|w[a+23|0]<<24);v[e+16>>2]=d-1;d=e+32|0;f=v[Kb(d,e+16|0)>>2];v[b+4>>2]=f;v[e+32>>2]=w[a+24|0]|w[a+25|0]<<8|(w[a+26|0]<<16|w[a+27|0]<<24);d=v[Kb(d,b)>>2];v[b+8>>2]=d;u[b+34>>1]=x[b+34>>1]&65533|w[a+31|0]<<1&2}if(d>>>0>f>>>0&d>>>0>=2){break a}u[b+34>>1]=0;v[b+4>>2]=0;v[b+8>>2]=0;break a}f=e+16|0;Lh(f,a+16|0);d=v[e+16>>2];v[e+32>>2]=w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24);Lh(f,a+20|0);d=v[e+16>>2];v[e+36>>2]=w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24);Lh(f,a+24|0);d=v[e+16>>2];d=w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24);v[e+40>>2]=d;v[e+8>>2]=d;d=v[e+36>>2];v[e>>2]=v[e+32>>2];v[e+4>>2]=d;Dl(b,1,e)}t[e+32|0]=w[a+28|0];t[e+16|0]=64;g=b,h=w[Yb(e+32|0,e+16|0)|0]<<2,u[g+30>>1]=h;d=w[a+32|0]|w[a+33|0]<<8|(w[a+34|0]<<16|w[a+35|0]<<24);v[b+24>>2]=d;b=b+24|0;e:{if(!c){break e}if(w[a|0]==2){d=d&65535;v[b>>2]=d;break e}if(y[b>>2]>=65536){v[b>>2]=65535}d=v[b>>2]}f:{g:{if(!d){a=8363;break g}a=1024;if(d>>>0>1023){break f}}v[b>>2]=a}kb=e+48|0}function g0(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=C(0);a=kb-272|0;kb=a;v[a+256>>2]=c;v[a+264>>2]=b;yw(a+208|0,d,a+224|0,a+223|0,a+222|0);d=Nb(a+192|0);b=bd(d);v[23540]=0;R(60,d|0,b|0);b=v[23540];v[23540]=0;a:{b:{c:{if((b|0)!=1){c=Tc(d,0);v[a+188>>2]=c;v[a+12>>2]=a+16;v[a+8>>2]=0;t[a+7|0]=1;t[a+6|0]=69;h=t[a+222|0];i=t[a+223|0];while(1){d:{v[23540]=0;b=Q(1121,a+264|0,a+256|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break d}if(!b){break c}g=v[a+188>>2];b=Hb(d);if((g|0)==(b+c|0)){v[23540]=0;R(60,d|0,b<<1);c=v[23540];v[23540]=0;if((c|0)==1){break b}c=bd(d);v[23540]=0;R(60,d|0,c|0);c=v[23540];v[23540]=0;if((c|0)==1){break b}c=Tc(d,0);v[a+188>>2]=b+c}v[23540]=0;b=S(1123,v[a+264>>2])|0;g=v[23540];v[23540]=0;if((g|0)==1){break d}if(xw(b,a+7|0,a+6|0,c,a+188|0,i,h,a+208|0,a+16|0,a+12|0,a+8|0,a+224|0)){break c}v[23540]=0;S(1125,a+264|0)|0;b=v[23540];v[23540]=0;if((b|0)!=1){continue}}break}break b}break b}e:{if(!Hb(a+208|0)|!w[a+7|0]){break e}b=v[a+12>>2];if((b-(a+16|0)|0)>159){break e}v[a+12>>2]=b+4;v[b>>2]=v[a+8>>2]}j=f,k=yG(c,v[a+188>>2],e),z[j>>2]=k;Ff(a+208|0,a+16|0,v[a+12>>2],e);v[23540]=0;b=Q(1122,a+264|0,a+256|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){if(b){v[e>>2]=v[e>>2]|2}b=v[a+264>>2];zb(d);zb(a+208|0);kb=a+272|0;break a}}b=P()|0;O()|0;zb(d);zb(a+208|0);T(b|0);L()}return b|0}function Y$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0;a=kb-368|0;kb=a;v[a+352>>2]=c;v[a+360>>2]=b;uw(a+200|0,d,a+224|0,a+220|0,a+216|0);d=Nb(a+184|0);b=bd(d);v[23540]=0;R(60,d|0,b|0);b=v[23540];v[23540]=0;a:{b:{c:{if((b|0)!=1){c=Tc(d,0);v[a+180>>2]=c;v[a+12>>2]=a+16;v[a+8>>2]=0;t[a+7|0]=1;t[a+6|0]=69;h=v[a+216>>2];i=v[a+220>>2];while(1){d:{v[23540]=0;b=Q(1137,a+360|0,a+352|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break d}if(!b){break c}g=v[a+180>>2];b=Hb(d);if((g|0)==(b+c|0)){v[23540]=0;R(60,d|0,b<<1);c=v[23540];v[23540]=0;if((c|0)==1){break b}c=bd(d);v[23540]=0;R(60,d|0,c|0);c=v[23540];v[23540]=0;if((c|0)==1){break b}c=Tc(d,0);v[a+180>>2]=b+c}v[23540]=0;b=S(1139,v[a+360>>2])|0;g=v[23540];v[23540]=0;if((g|0)==1){break d}if(tw(b,a+7|0,a+6|0,c,a+180|0,i,h,a+200|0,a+16|0,a+12|0,a+8|0,a+224|0)){break c}v[23540]=0;S(1141,a+360|0)|0;b=v[23540];v[23540]=0;if((b|0)!=1){continue}}break}break b}break b}e:{if(!Hb(a+200|0)|!w[a+7|0]){break e}b=v[a+12>>2];if((b-(a+16|0)|0)>159){break e}v[a+12>>2]=b+4;v[b>>2]=v[a+8>>2]}j=f,k=wG(c,v[a+180>>2],e),A[j>>3]=k;Ff(a+200|0,a+16|0,v[a+12>>2],e);v[23540]=0;b=Q(1138,a+360|0,a+352|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){if(b){v[e>>2]=v[e>>2]|2}b=v[a+360>>2];zb(d);zb(a+200|0);kb=a+368|0;break a}}b=P()|0;O()|0;zb(d);zb(a+200|0);T(b|0);L()}return b|0}function yha(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=v[a>>2];b=du(c,v[a+4>>2]);if(b>>>0<=63){g=kb-32|0;kb=g;f=64-b|0;c=v[Gb(a)>>2];d=v[a+4>>2];a:{if(f>>>0<=(c-d|0)/33>>>0){b=kb-16|0;kb=b;v[b>>2]=a;a=v[a+4>>2];v[b+4>>2]=a;v[b+8>>2]=a+B(f,33);a=v[b+4>>2];c=v[b+8>>2];while(1){if((a|0)==(c|0)){lc(b);kb=b+16|0}else{NS(a);a=a+33|0;v[b+4>>2]=a;continue}break}break a}i=Gb(a);c=g+8|0;h=du(v[a>>2],d)+f|0;d=kb-16|0;kb=d;v[d+12>>2]=h;e=kb-16|0;kb=e;v[e+12>>2]=130150524;v[e+8>>2]=2147483647;b=v[Kb(e+12|0,e+8|0)>>2];kb=e+16|0;b:{if(b>>>0>=h>>>0){e=SS(a);if(e>>>0<b>>>1>>>0){v[d+8>>2]=e<<1;b=v[_c(d+8|0,d+12|0)>>2]}kb=d+16|0;break b}cd();L()}e=du(v[a>>2],v[a+4>>2]);pg(c+12|0,i);if(b){if(b>>>0>=130150525){Lg();L()}d=vc(B(b,33))}else{d=0}v[c>>2]=d;e=d+B(e,33)|0;v[c+8>>2]=e;v[c+4>>2]=e;j=Cc(c),k=d+B(b,33)|0,v[j>>2]=k;b=kb-16|0;kb=b;v[b>>2]=v[c+8>>2];d=v[c+8>>2];v[b+8>>2]=c+8;v[b+4>>2]=d+B(f,33);d=v[b>>2];while(1){if(v[b+4>>2]!=(d|0)){NS(d);d=v[b>>2]+33|0;v[b>>2]=d;continue}break}Ud(b);kb=b+16|0;b=c+4|0;f=v[a>>2];d=v[a+4>>2]-f|0;e=v[b>>2]+B((d|0)/-33|0,33)|0;v[b>>2]=e;if((d|0)>0){sc(e,f,d)}qc(a,b);qc(a+4|0,c+8|0);qc(Gb(a),Cc(c));v[c>>2]=v[c+4>>2];b=v[c+4>>2];a=v[c+8>>2];while(1){if((a|0)!=(b|0)){a=a-33|0;v[c+8>>2]=a;continue}break}a=v[c>>2];if(a){Cc(c);Mb(a)}}kb=g+32|0;return}if((b|0)!=64){Od(a,c+2112|0)}}function f0(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0;a=kb-272|0;kb=a;v[a+256>>2]=c;v[a+264>>2]=b;yw(a+208|0,d,a+224|0,a+223|0,a+222|0);d=Nb(a+192|0);b=bd(d);v[23540]=0;R(60,d|0,b|0);b=v[23540];v[23540]=0;a:{b:{c:{if((b|0)!=1){c=Tc(d,0);v[a+188>>2]=c;v[a+12>>2]=a+16;v[a+8>>2]=0;t[a+7|0]=1;t[a+6|0]=69;h=t[a+222|0];i=t[a+223|0];while(1){d:{v[23540]=0;b=Q(1121,a+264|0,a+256|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break d}if(!b){break c}g=v[a+188>>2];b=Hb(d);if((g|0)==(b+c|0)){v[23540]=0;R(60,d|0,b<<1);c=v[23540];v[23540]=0;if((c|0)==1){break b}c=bd(d);v[23540]=0;R(60,d|0,c|0);c=v[23540];v[23540]=0;if((c|0)==1){break b}c=Tc(d,0);v[a+188>>2]=b+c}v[23540]=0;b=S(1123,v[a+264>>2])|0;g=v[23540];v[23540]=0;if((g|0)==1){break d}if(xw(b,a+7|0,a+6|0,c,a+188|0,i,h,a+208|0,a+16|0,a+12|0,a+8|0,a+224|0)){break c}v[23540]=0;S(1125,a+264|0)|0;b=v[23540];v[23540]=0;if((b|0)!=1){continue}}break}break b}break b}e:{if(!Hb(a+208|0)|!w[a+7|0]){break e}b=v[a+12>>2];if((b-(a+16|0)|0)>159){break e}v[a+12>>2]=b+4;v[b>>2]=v[a+8>>2]}j=f,k=wG(c,v[a+188>>2],e),A[j>>3]=k;Ff(a+208|0,a+16|0,v[a+12>>2],e);v[23540]=0;b=Q(1122,a+264|0,a+256|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){if(b){v[e>>2]=v[e>>2]|2}b=v[a+264>>2];zb(d);zb(a+208|0);kb=a+272|0;break a}}b=P()|0;O()|0;zb(d);zb(a+208|0);T(b|0);L()}return b|0}function nI(a){var b=0,c=0,d=0,e=0;Ce(v[a+80>>2],v[a+20>>2]);while(1){c=v[a+28>>2];if((b|0)<v[a+24>>2]){Ce(v[a+80>>2],v[c+(b<<2)>>2]);b=b+1|0;continue}break}Ce(v[a+80>>2],c);a:{if(!v[a+396>>2]){break a}c=0;while(1){if(v[a+264>>2]<=(c|0)){break a}e=v[a+396>>2]+B(c,24)|0;d=v[e+16>>2];if(d){b=0;while(1){if((b|0)<v[(v[a+124>>2]+B(w[e+13|0],2096)|0)+4>>2]){Ce(v[a+80>>2],v[(b<<2)+d>>2]);b=b+1|0;d=v[e+16>>2];continue}break}Ce(v[a+80>>2],d)}Ce(v[a+80>>2],v[e+20>>2]);c=c+1|0;continue}}d=v[a+124>>2];if(d){c=0;while(1){if((c|0)<v[a+120>>2]){b=B(c,2096)+d|0;Ce(v[a+80>>2],v[b+8>>2]);Ce(v[a+80>>2],v[b+28>>2]);Ce(v[a+80>>2],v[b+32>>2]);Ce(v[a+80>>2],v[b+2084>>2]);b=v[b+2088>>2];Ce(v[a+80>>2],b?b-4|0:0);c=c+1|0;d=v[a+124>>2];continue}break}Ce(v[a+80>>2],d)}Ce(v[a+80>>2],v[a+260>>2]);Ce(v[a+80>>2],v[a+396>>2]);c=v[a+404>>2];if(c){b=0;while(1){if((b|0)<v[a+400>>2]){Ce(v[a+80>>2],v[(B(b,40)+c|0)+4>>2]);b=b+1|0;c=v[a+404>>2];continue}break}Ce(v[a+80>>2],c)}c=0;b=0;while(1){if(!(v[a+4>>2]<=(b|0)|b>>>0>15)){d=(b<<2)+a|0;Ce(v[a+80>>2],v[d+800>>2]);Ce(v[a+80>>2],v[d+928>>2]);Ce(v[a+80>>2],v[d+996>>2]);b=b+1|0;continue}break}while(1){if((c|0)!=2){b=(c<<2)+a|0;Ce(v[a+80>>2],v[b+1068>>2]);Ce(v[a+80>>2],v[b+1076>>2]);Ce(v[a+80>>2],v[b+1084>>2]);Ce(v[a+80>>2],v[b+1092>>2]);Ce(v[a+80>>2],v[b+1100>>2]);c=c+1|0;continue}break}}function YO(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;h=kb-16|0;kb=h;c=v[a>>2];a:{if(kk(c)){i=kb-16|0;kb=i;e=vc(3848);d=e+808|0;c=e+16|0;while(1){v[c+16>>2]=0;v[c+20>>2]=0;v[c+36>>2]=0;t[c+42|0]=1;u[c+40>>1]=257;v[c+24>>2]=0;v[c+28>>2]=0;u[c+32>>1]=0;c=c+44|0;if((c|0)!=(d|0)){continue}break}c=e+3832|0;while(1){v[d>>2]=0;v[d+4>>2]=0;v[d+68>>2]=0;v[d+72>>2]=0;v[d+24>>2]=0;v[d+28>>2]=0;u[d+20>>1]=511;v[d+16>>2]=-1;u[d+14>>1]=1;u[d+6>>1]=0;u[d+8>>1]=0;u[d+10>>1]=0;u[d+12>>1]=0;t[d+73|0]=0;t[d+74|0]=0;t[d+75|0]=0;t[d+76|0]=0;t[d+77|0]=0;t[d+78|0]=0;t[d+79|0]=0;t[d+80|0]=0;d=d+84|0;if((c|0)!=(d|0)){continue}break}v[e+3832>>2]=0;v[e+3836>>2]=0;c=e+3837|0;t[c|0]=0;t[c+1|0]=0;t[c+2|0]=0;t[c+3|0]=0;t[c+4|0]=0;t[c+5|0]=0;t[c+6|0]=0;t[c+7|0]=0;while(1){if((g|0)==36){while(1){if((f|0)==18){b:{f=0;g=0;while(1)if((f|0)==18){while(1){if((g|0)==36){break b}fo((e+B(g,84)|0)+808|0);g=g+1|0;continue}}else{d=(e+B(f,44)|0)+16|0;c=v[(f<<2)+28976>>2];c:{if(!(!(1<<f&3591)|f>>>0>11)){c=e+B(c,84)|0;bP(d,c+808|0,c+1060|0,c+1312|0,c+1564|0);break c}c=e+B(c,84)|0;bP(d,c+808|0,c+1060|0,0,0)}f=f+1|0;continue}}}else{v[(e+B(f,44)|0)+32>>2]=e;f=f+1|0;continue}break}aP(e,b)}else{wd((e+B(g,84)|0)+808|0,e);g=g+1|0;continue}break}b=v[Lf(i+8|0,e)>>2];kb=i+16|0;v[h+8>>2]=b;b=h+8|0;sA(a,b);Gm(b);break a}aP(c,b)}XO(a);kb=h+16|0}function Fz(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0;e=kb-32|0;kb=e;if(b&5){if((b|0)==1){d=Jka(v[a+24>>2],0,8363,0)+4136|0;c=nb;h=a,i=Ec(Mka(d,d>>>0<4136?c+1|0:c,8272,0),nb),v[h+24>>2]=i}d=kb-16|0;kb=d;g=d+8|0;c=kb-16|0;kb=c;f=v[a+24>>2];a:{if(!f){Io(g);break a}CB(c+8|0,Zb(xl(Ep(+(f>>>0)*.00011957431543704412)*2215.9795828054475),-16384,16383),128);f=v[c+8>>2];t[c+7|0]=v[c+12>>2];de(g,f,c+7|0)}kb=c+16|0;tB(d,a+36|0,a+37|0);sB(d,g);kb=d+16|0}if(b&3){u[a+38>>1]=0;u[a+40>>1]=0;t[a+36|0]=0;u[a+34>>1]=x[a+34>>1]&65499}if(b&7){u[a+32>>1]=64;c=x[a+34>>1];if(c&8){d=v[a+16>>2];v[a+4>>2]=v[a+12>>2];v[a+8>>2]=d;c=c&16?c|6:c&65529|2}v[a+12>>2]=0;v[a+16>>2]=0;u[a+34>>1]=c&65511}b:{if(!(b&4)){break b}c=x[a+34>>1];if(!(c&32)){u[a+28>>1]=128;u[a+34>>1]=c|32}wf(a+40|0,15);wf(a+41|0,63);if(!w[a+41|0]){break b}d=w[a+40|0];if(!d){break b}c=w[a+39|0];if(c){c=Jl(Ec(((d<<8|c>>>1)>>>0)/(c>>>0)|0,0))}else{c=255}t[a+39|0]=c}c:{d:{if((b|0)!=4){if((b|0)==16777216){break c}if((b|0)!=32|w[a+38|0]!=2){break d}t[a+38|0]=3;break d}if(w[a+38|0]!=4){break d}t[a+38|0]=0}u[a+34>>1]=x[a+34>>1]&49151}e:{if(!(!(w[a+35|0]&2)|b&16777218)){v[e+24>>2]=0;v[e+8>>2]=0;v[e+16>>2]=0;v[e+20>>2]=0;v[e>>2]=0;v[e+4>>2]=0;Dl(a,0,e);break e}if(!(w[a+35|0]&2)|(b|0)!=2){break e}a=a+68|0;b=Lb(a,8);t[b|0]=w[b|0]&3;a=Lb(a,9);t[a|0]=w[a|0]&3}kb=e+32|0}function wca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0;f=kb-16|0;kb=f;s=v[a+16>>2];u=kg(b+327720|0,v[b+20>>2],(v[a+88>>2]&16384)>>>14|0);n=v[a+128>>2];a:{if(!n){k=v[a+8>>2];l=v[a+12>>2];e=v[a>>2];b=v[a+4>>2];m=0;break a}k=v[a+8>>2];l=v[a+12>>2];o=lg(k,l,n);p=nb;g=v[a+76>>2];e=v[a>>2];b=v[a+4>>2];Qf(e,b,qf(k,l,d),nb);m=g>>>0<nb>>>0?d:0}h=a+112|0;i=v[a+40>>2];j=v[a+36>>2];v[f>>2]=e;v[f+4>>2]=b;while(1){if(d){d=d-1|0;v[f+8>>2]=e;v[f+12>>2]=0;m=m-1|0;g=m;o=g?o:0;p=g?p:0;r=(((b&2147483647)<<1|e>>>31)&-2)+s|0;g=n;b:{c:while(1){d:{if((g|0)<=0){Rb(h,v[a+120>>2],v[a+124>>2]);g=v[a+116>>2];if(!g){break b}q=((v[f+12>>2]&2147483647)<<1|v[f+8>>2]>>>31)&-2;e=0;b=0;break d}q=((v[f+12>>2]&2147483647)<<1|v[f+8>>2]>>>31)&-2;b=0;e=0;while(1)if((b|0)==2){Sd(h,(e|0)/8<<16>>16);Rd(h,4);Rb(f+8|0,o,p);g=g-1|0;continue c}else{e=(t[(b+q|0)+r|0]<<8)+e|0;b=b+1|0;continue}}break}while(1){if((b|0)!=2){e=(t[(b+q|0)+r|0]<<8)+e|0;b=b+1|0;continue}break}Sd(h,(e|0)/8<<16>>16);Rd(h,g);v[h>>2]=v[h>>2];v[h+4>>2]=0}b=v[a+32>>2];j=v[a+28>>2]+j|0;g=jg(h,u);v[c>>2]=B(j>>12,g)+v[c>>2];i=b+i|0;v[c+4>>2]=v[c+4>>2]+B(g,i>>12);Rb(f,k,l);c=c+8|0;e=v[f>>2];b=v[f+4>>2];continue}break}v[a>>2]=e;v[a+4>>2]=b;v[a+40>>2]=i;v[a+20>>2]=j>>12;v[a+36>>2]=j;v[a+24>>2]=i>>12;kb=f+16|0}function JP(){var a=0,b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=kb-240|0;kb=e;if(!w[94320]){if(!w[94196]){c=kb-16|0;kb=c;Nb(94172);v[23546]=0;t[94188]=0;v[23548]=0;v[23540]=0;b=ga(29)|0;a=v[23540];v[23540]=0;a:{b:{c:{d:{e:{f:{if((a|0)!=1){v[c+8>>2]=b;b=c+8|0;eu(94184,ce(b));KA(b);t[94188]=0;break f}a=Ea(92756,93340)|0;b=O()|0;if((ea(92756)|0)==(b|0)){_(a|0)|0;v[23540]=0;Z(30);c=v[23540];v[23540]=0;if((c|0)==1){break d}L()}if((ea(93340)|0)!=(b|0)){break c}_(a|0)|0;v[23540]=0;t[94188]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)==1){a=P()|0;O()|0;break c}if(w[94188]){break e}}v[23540]=0;Y(31,94168);b=v[23540];v[23540]=0;if((b|0)!=1){break e}a=P()|0;O()|0;break c}kb=c+16|0;break a}a=P()|0;O()|0;v[23540]=0;Z(18);c=v[23540];v[23540]=0;if((c|0)==1){break b}}Gm(94192);KA(94184);zb(94172);T(a|0);L()}V(0)|0;O()|0;Vb();L()}t[94196]=1}c=kb+-64|0;kb=c;b=c+16|0;g=kb-16|0;kb=g;h=EP(g+8|0);j=e+120|0;while(1){if((i|0)==12){kb=g+16|0}else{f=kb-48|0;kb=f;a=v[h+4>>2];d=v[h>>2];g:{if((a|0)==(d|0)){break g}a=(a-d|0)+1|0;if(!a){a=CP(DP(f+8|0,32));break g}d=E(a);d=DP(f+8|0,(a<<d+1?32:31)-d|0);while(1){k=CP(d);if(a>>>0<=k>>>0){continue}break}a=v[h>>2]+k|0}kb=f+48|0;l=Eb(b,i),m=a,v[l>>2]=m;i=i+1|0;continue}break}b=GP(c,b,HP(b));FP(j,b);Fm(b);kb=c- -64|0;sc(94200,sc(e,j,120),116);t[94320]=1}kb=e+240|0}function aia(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=kb-16|0;kb=e;h=rf(a,c);me(e,v[a+36>>2]);i=a;a:{if(!h){Sc(e,a+32|0,5);c=0;if(Cb(v[v[e>>2]>>2],v[e+4>>2])){break a}}d=kb-160|0;kb=d;f=Yl(d+48|0,v[a+36>>2]);v[23540]=0;a=Q(449,d+32|0,43875)|0;c=v[23540];v[23540]=0;b:{c:{d:{e:{if((c|0)!=1){v[23540]=0;v[d+16>>2]=19988497;v[d+20>>2]=0;U(450,f|0,a|0,d+16|0);c=v[23540];v[23540]=0;if((c|0)==1){break e}Xb(a);if(!Kk(w[f|0])){break d}break b}c=P()|0;O()|0;break c}c=P()|0;O()|0;Xb(a);break c}k=d,l=Af(v[b>>2],v[b+4>>2]),u[k+30>>1]=l;u[d+28>>1]=65535;v[23540]=0;a=Q(449,d+16|0,10124)|0;c=v[23540];v[23540]=0;f:{if((c|0)!=1){v[23540]=0;c=W(479,f|0,d+28|0,a|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break f}Xb(a);if(c){u[d+30>>1]=x[d+28>>1]}Ef(d+30|0,4e3);a=x[d+30>>1];g:{if(Af(v[b>>2],v[b+4>>2])>>>0>=a>>>0){break g}v[23540]=0;R(225,b|0,a|0);c=v[23540];v[23540]=0;if((c|0)!=1){break g}c=P()|0;O()|0;break c}c=0;h:{while(1){if((a|0)==(c|0)){break b}g=v[b>>2];v[23540]=0;R(480,d|0,c|0);j=v[23540];v[23540]=0;if((j|0)!=1){v[23540]=0;X(481,f|0,_b(g,c)|0,d|0,482);g=v[23540];v[23540]=0;if((g|0)==1){break h}c=c+1|0;Xb(d);continue}break}c=P()|0;O()|0;break c}c=P()|0;O()|0;Xb(d);break c}c=P()|0;O()|0;break c}c=P()|0;O()|0;Xb(a)}kh(f);T(c|0);L()}kh(f);kb=d+160|0;c=h}Ye(i,c);kb=e+16|0}function j5(a){a=a|0;var b=0,c=0,d=0,e=0;e=kb-160|0;kb=e;d=Kc(e,11589);v[23540]=0;b=d+12|0;Q(55,b|0,10995)|0;c=v[23540];v[23540]=0;a:{b:{if((c|0)==1){break a}v[23540]=0;b=d+24|0;Q(55,b|0,11419)|0;c=v[23540];v[23540]=0;if((c|0)==1){break a}v[23540]=0;b=d+36|0;Q(55,b|0,10987)|0;c=v[23540];v[23540]=0;if((c|0)==1){break a}v[23540]=0;b=d+48|0;Q(55,b|0,8272)|0;c=v[23540];v[23540]=0;if((c|0)==1){break a}v[23540]=0;b=d+60|0;Q(55,b|0,10972)|0;c=v[23540];v[23540]=0;if((c|0)==1){break a}v[23540]=0;b=d+72|0;Q(55,b|0,8338)|0;c=v[23540];v[23540]=0;if((c|0)==1){break a}v[23540]=0;b=d+84|0;Q(55,b|0,5623)|0;c=v[23540];v[23540]=0;if((c|0)==1){break a}v[23540]=0;b=d+96|0;Q(55,b|0,11993)|0;c=v[23540];v[23540]=0;if((c|0)==1){break a}v[23540]=0;b=d+108|0;Q(55,b|0,11362)|0;c=v[23540];v[23540]=0;if((c|0)==1){break a}v[23540]=0;b=d+120|0;Q(55,b|0,12194)|0;c=v[23540];v[23540]=0;if((c|0)==1){break a}v[23540]=0;b=d+132|0;Q(55,b|0,5475)|0;c=v[23540];v[23540]=0;if((c|0)==1){break a}v[23540]=0;b=d+144|0;Q(55,b|0,7295)|0;c=v[23540];v[23540]=0;if((c|0)==1){break a}v[23540]=0;W(1013,a|0,d|0,13)|0;a=v[23540];v[23540]=0;if((a|0)==1){break b}b=d+156|0;while(1){b=zb(b-12|0);if((d|0)!=(b|0)){continue}break}kb=e+160|0;return}b=d+156|0}a=P()|0;O()|0;while(1){b=zb(b-12|0);if((d|0)!=(b|0)){continue}break}T(a|0);L()}function a0(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0;a=kb-352|0;kb=a;v[a+336>>2]=c;v[a+344>>2]=b;b=aj(d);i=pp(d,a+224|0);op(a+208|0,d,a+332|0);d=Nb(a+192|0);c=bd(d);v[23540]=0;R(60,d|0,c|0);c=v[23540];v[23540]=0;a:{b:{c:{if((c|0)!=1){c=Tc(d,0);v[a+188>>2]=c;v[a+12>>2]=a+16;v[a+8>>2]=0;j=v[a+332>>2];while(1){d:{v[23540]=0;g=Q(1137,a+344|0,a+336|0)|0;h=v[23540];v[23540]=0;if((h|0)==1){break d}if(!g){break c}h=v[a+188>>2];g=Hb(d);if((h|0)==(g+c|0)){v[23540]=0;R(60,d|0,g<<1);c=v[23540];v[23540]=0;if((c|0)==1){break b}c=bd(d);v[23540]=0;R(60,d|0,c|0);c=v[23540];v[23540]=0;if((c|0)==1){break b}c=Tc(d,0);v[a+188>>2]=g+c}v[23540]=0;g=S(1139,v[a+344>>2])|0;h=v[23540];v[23540]=0;if((h|0)==1){break d}if(zn(g,b,c,a+188|0,a+8|0,j,a+208|0,a+16|0,a+12|0,i)){break c}v[23540]=0;S(1141,a+344|0)|0;g=v[23540];v[23540]=0;if((g|0)!=1){continue}}break}break b}break b}e:{if(!Hb(a+208|0)){break e}g=v[a+12>>2];if((g-(a+16|0)|0)>159){break e}v[a+12>>2]=g+4;v[g>>2]=v[a+8>>2]}k=f,l=DG(c,v[a+188>>2],e,b),v[k>>2]=l;v[f+4>>2]=nb;Ff(a+208|0,a+16|0,v[a+12>>2],e);v[23540]=0;b=Q(1138,a+344|0,a+336|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){if(b){v[e>>2]=v[e>>2]|2}b=v[a+344>>2];zb(d);zb(a+208|0);kb=a+352|0;break a}}b=P()|0;O()|0;zb(d);zb(a+208|0);T(b|0);L()}return b|0}function _$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0;a=kb-352|0;kb=a;v[a+336>>2]=c;v[a+344>>2]=b;b=aj(d);i=pp(d,a+224|0);op(a+208|0,d,a+332|0);d=Nb(a+192|0);c=bd(d);v[23540]=0;R(60,d|0,c|0);c=v[23540];v[23540]=0;a:{b:{c:{if((c|0)!=1){c=Tc(d,0);v[a+188>>2]=c;v[a+12>>2]=a+16;v[a+8>>2]=0;j=v[a+332>>2];while(1){d:{v[23540]=0;g=Q(1137,a+344|0,a+336|0)|0;h=v[23540];v[23540]=0;if((h|0)==1){break d}if(!g){break c}h=v[a+188>>2];g=Hb(d);if((h|0)==(g+c|0)){v[23540]=0;R(60,d|0,g<<1);c=v[23540];v[23540]=0;if((c|0)==1){break b}c=bd(d);v[23540]=0;R(60,d|0,c|0);c=v[23540];v[23540]=0;if((c|0)==1){break b}c=Tc(d,0);v[a+188>>2]=g+c}v[23540]=0;g=S(1139,v[a+344>>2])|0;h=v[23540];v[23540]=0;if((h|0)==1){break d}if(zn(g,b,c,a+188|0,a+8|0,j,a+208|0,a+16|0,a+12|0,i)){break c}v[23540]=0;S(1141,a+344|0)|0;g=v[23540];v[23540]=0;if((g|0)!=1){continue}}break}break b}break b}e:{if(!Hb(a+208|0)){break e}g=v[a+12>>2];if((g-(a+16|0)|0)>159){break e}v[a+12>>2]=g+4;v[g>>2]=v[a+8>>2]}k=f,l=zG(c,v[a+188>>2],e,b),v[k>>2]=l;v[f+4>>2]=nb;Ff(a+208|0,a+16|0,v[a+12>>2],e);v[23540]=0;b=Q(1138,a+344|0,a+336|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){if(b){v[e>>2]=v[e>>2]|2}b=v[a+344>>2];zb(d);zb(a+208|0);kb=a+352|0;break a}}b=P()|0;O()|0;zb(d);zb(a+208|0);T(b|0);L()}return b|0}function gea(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=kb-48|0;kb=d;l=a+480190|0;c=x[l>>1];t[d+32|0]=0;DO(b,c+1|0,d+32|0);a:{j=a+480192|0;if(!x[j>>1]){break a}h=Tb(d+32|0);p=d,q=Fb(v[a+484344>>2]),v[p+24>>2]=q;o=Fb(v[a+484348>>2]);m=a+480188|0;while(1){i=v[d+24>>2];if(!Pb(i,o)){c=x[a+480190>>1];while(1)if(c){Db(d+8|0,v[b>>2],c);if(!Cb(v[v[d+8>>2]>>2],v[d+12>>2])){e=f;f=B(c,104)+a|0;f=e+_d(v[f+484380>>2],v[f+484400>>2])|0}c=c-1|0;continue}else{ic(h);break a}}b:{if(!Pb(v[i>>2],v[i+4>>2])){break b}c=x[m>>1];v[23540]=0;t[d+8|0]=0;U(749,h|0,c|0,d+8|0);c=v[23540];v[23540]=0;if((c|0)!=1){p=d,q=Fb(v[i>>2]),v[p+16>>2]=q;k=0;c:while(1){f=0;if(y[i+12>>2]<=k>>>0){break b}while(1){if(x[m>>1]<=f>>>0){k=k+1|0;continue c}d:{c=v[d+16>>2];if(!$c(w[c|0])){break d}e:{f:{c=w[c+1|0];if(c){g=x[j>>1];break f}g=x[j>>1];c=w[Lb(v[h>>2],f)|0];if(c){break f}c=1;break e}p=Lb(v[h>>2],f),q=c,t[p|0]=q;g=g&65535;e=g>>>0<c>>>0;g=e?g:c;c=e?1:c}while(1){e=c&65535;if(e>>>0>(g&65535)>>>0){break d}e=v[((e<<2)+a|0)+900380>>2];g:{if(!e){break g}e=x[cc(e+236|0,w[v[d+16>>2]]-1|0)>>1];if(e>>>0>x[l>>1]){break g}n=d+8|0;Db(n,v[b>>2],e);Ze(n,1)}c=c+1|0;continue}}f=f+1|0;dA(d+16|0);continue}}}a=P()|0;O()|0;ic(h);T(a|0);L()}NM(d+24|0);continue}}kb=d+48|0;return f&65535}function Ifa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;if(v[a+4>>2]!=v[Gb(a)>>2]){c=kb-16|0;kb=c;v[c>>2]=a;a=v[a+4>>2];v[c+4>>2]=a;v[c+8>>2]=a+56;a=v[c+4>>2];v[23540]=0;R(656,a|0,b|0);a=v[23540];v[23540]=0;a:{if((a|0)!=1){v[c+4>>2]=v[c+4>>2]+56;lc(c);kb=c+16|0;break a}a=P()|0;O()|0;lc(c);T(a|0);L()}return}h=kb-32|0;kb=h;i=Gb(a);f=h+8|0;g=kq(v[a>>2],v[a+4>>2])+1|0;d=kb-16|0;kb=d;v[d+12>>2]=g;e=kb-16|0;kb=e;v[e+12>>2]=76695844;v[e+8>>2]=2147483647;c=v[Kb(e+12|0,e+8|0)>>2];kb=e+16|0;b:{if(c>>>0>=g>>>0){e=qR(a);if(e>>>0<c>>>1>>>0){v[d+8>>2]=e<<1;c=v[_c(d+8|0,d+12|0)>>2]}kb=d+16|0;break b}cd();L()}e=kq(v[a>>2],v[a+4>>2]);pg(f+12|0,i);if(c){if(c>>>0>=76695845){Lg();L()}d=vc(B(c,56))}else{d=0}v[f>>2]=d;e=d+B(e,56)|0;v[f+8>>2]=e;v[f+4>>2]=e;j=Cc(f),k=d+B(c,56)|0,v[j>>2]=k;c=v[f+8>>2];v[23540]=0;R(656,c|0,b|0);b=v[23540];v[23540]=0;c:{if((b|0)!=1){v[f+8>>2]=v[f+8>>2]+56;e=v[a>>2];b=v[a+4>>2];d=f+4|0;while(1){if((b|0)!=(e|0)){b=b-56|0;c=ul(v[d>>2]-56|0,b);ul(c+12|0,b+12|0);Zz(c+24|0,b+24|0);u[c+52>>1]=x[b+52>>1];g=v[b+48>>2];v[c+44>>2]=v[b+44>>2];v[c+48>>2]=g;g=v[b+40>>2];v[c+36>>2]=v[b+36>>2];v[c+40>>2]=g;v[d>>2]=v[d>>2]-56;continue}break}qc(a,d);qc(a+4|0,f+8|0);qc(Gb(a),Cc(f));v[f>>2]=v[f+4>>2];pR(f);kb=h+32|0;break c}a=P()|0;O()|0;pR(f);T(a|0);L()}}function sG(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0;a=kb-352|0;kb=a;v[a+336>>2]=c;v[a+344>>2]=b;b=aj(d);i=pp(d,a+224|0);op(a+208|0,d,a+332|0);d=Nb(a+192|0);c=bd(d);v[23540]=0;R(60,d|0,c|0);c=v[23540];v[23540]=0;a:{b:{c:{if((c|0)!=1){c=Tc(d,0);v[a+188>>2]=c;v[a+12>>2]=a+16;v[a+8>>2]=0;j=v[a+332>>2];while(1){d:{v[23540]=0;g=Q(1137,a+344|0,a+336|0)|0;h=v[23540];v[23540]=0;if((h|0)==1){break d}if(!g){break c}h=v[a+188>>2];g=Hb(d);if((h|0)==(g+c|0)){v[23540]=0;R(60,d|0,g<<1);c=v[23540];v[23540]=0;if((c|0)==1){break b}c=bd(d);v[23540]=0;R(60,d|0,c|0);c=v[23540];v[23540]=0;if((c|0)==1){break b}c=Tc(d,0);v[a+188>>2]=g+c}v[23540]=0;g=S(1139,v[a+344>>2])|0;h=v[23540];v[23540]=0;if((h|0)==1){break d}if(zn(g,b,c,a+188|0,a+8|0,j,a+208|0,a+16|0,a+12|0,i)){break c}v[23540]=0;S(1141,a+344|0)|0;g=v[23540];v[23540]=0;if((g|0)!=1){continue}}break}break b}break b}e:{if(!Hb(a+208|0)){break e}g=v[a+12>>2];if((g-(a+16|0)|0)>159){break e}v[a+12>>2]=g+4;v[g>>2]=v[a+8>>2]}k=f,l=AG(c,v[a+188>>2],e,b),v[k>>2]=l;Ff(a+208|0,a+16|0,v[a+12>>2],e);v[23540]=0;b=Q(1138,a+344|0,a+336|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){if(b){v[e>>2]=v[e>>2]|2}b=v[a+344>>2];zb(d);zb(a+208|0);kb=a+352|0;break a}}b=P()|0;O()|0;zb(d);zb(a+208|0);T(b|0);L()}return b|0}function b0(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0;a=kb-352|0;kb=a;v[a+336>>2]=c;v[a+344>>2]=b;b=aj(d);i=pp(d,a+224|0);op(a+208|0,d,a+332|0);d=Nb(a+192|0);c=bd(d);v[23540]=0;R(60,d|0,c|0);c=v[23540];v[23540]=0;a:{b:{c:{if((c|0)!=1){c=Tc(d,0);v[a+188>>2]=c;v[a+12>>2]=a+16;v[a+8>>2]=0;j=v[a+332>>2];while(1){d:{v[23540]=0;g=Q(1137,a+344|0,a+336|0)|0;h=v[23540];v[23540]=0;if((h|0)==1){break d}if(!g){break c}h=v[a+188>>2];g=Hb(d);if((h|0)==(g+c|0)){v[23540]=0;R(60,d|0,g<<1);c=v[23540];v[23540]=0;if((c|0)==1){break b}c=bd(d);v[23540]=0;R(60,d|0,c|0);c=v[23540];v[23540]=0;if((c|0)==1){break b}c=Tc(d,0);v[a+188>>2]=g+c}v[23540]=0;g=S(1139,v[a+344>>2])|0;h=v[23540];v[23540]=0;if((h|0)==1){break d}if(zn(g,b,c,a+188|0,a+8|0,j,a+208|0,a+16|0,a+12|0,i)){break c}v[23540]=0;S(1141,a+344|0)|0;g=v[23540];v[23540]=0;if((g|0)!=1){continue}}break}break b}break b}e:{if(!Hb(a+208|0)){break e}g=v[a+12>>2];if((g-(a+16|0)|0)>159){break e}v[a+12>>2]=g+4;v[g>>2]=v[a+8>>2]}k=f,l=EG(c,v[a+188>>2],e,b),v[k>>2]=l;Ff(a+208|0,a+16|0,v[a+12>>2],e);v[23540]=0;b=Q(1138,a+344|0,a+336|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){if(b){v[e>>2]=v[e>>2]|2}b=v[a+344>>2];zb(d);zb(a+208|0);kb=a+352|0;break a}}b=P()|0;O()|0;zb(d);zb(a+208|0);T(b|0);L()}return b|0}function $$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0;a=kb-352|0;kb=a;v[a+336>>2]=c;v[a+344>>2]=b;b=aj(d);i=pp(d,a+224|0);op(a+208|0,d,a+332|0);d=Nb(a+192|0);c=bd(d);v[23540]=0;R(60,d|0,c|0);c=v[23540];v[23540]=0;a:{b:{c:{if((c|0)!=1){c=Tc(d,0);v[a+188>>2]=c;v[a+12>>2]=a+16;v[a+8>>2]=0;j=v[a+332>>2];while(1){d:{v[23540]=0;g=Q(1137,a+344|0,a+336|0)|0;h=v[23540];v[23540]=0;if((h|0)==1){break d}if(!g){break c}h=v[a+188>>2];g=Hb(d);if((h|0)==(g+c|0)){v[23540]=0;R(60,d|0,g<<1);c=v[23540];v[23540]=0;if((c|0)==1){break b}c=bd(d);v[23540]=0;R(60,d|0,c|0);c=v[23540];v[23540]=0;if((c|0)==1){break b}c=Tc(d,0);v[a+188>>2]=g+c}v[23540]=0;g=S(1139,v[a+344>>2])|0;h=v[23540];v[23540]=0;if((h|0)==1){break d}if(zn(g,b,c,a+188|0,a+8|0,j,a+208|0,a+16|0,a+12|0,i)){break c}v[23540]=0;S(1141,a+344|0)|0;g=v[23540];v[23540]=0;if((g|0)!=1){continue}}break}break b}break b}e:{if(!Hb(a+208|0)){break e}g=v[a+12>>2];if((g-(a+16|0)|0)>159){break e}v[a+12>>2]=g+4;v[g>>2]=v[a+8>>2]}k=f,l=CG(c,v[a+188>>2],e,b),u[k>>1]=l;Ff(a+208|0,a+16|0,v[a+12>>2],e);v[23540]=0;b=Q(1138,a+344|0,a+336|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){if(b){v[e>>2]=v[e>>2]|2}b=v[a+344>>2];zb(d);zb(a+208|0);kb=a+352|0;break a}}b=P()|0;O()|0;zb(d);zb(a+208|0);T(b|0);L()}return b|0}function MF(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0;a=kb-16|0;kb=a;v[a+12>>2]=c;v[a+8>>2]=f;v[a+12>>2]=c;v[a+8>>2]=f;c=v[a+12>>2];a:{while(1){if(c>>>0>=d>>>0){f=0;break a}b:{b=x[c>>1];c:{if(b>>>0<=127){f=1;c=v[a+8>>2];if((g-c|0)<=0){break a}v[a+8>>2]=c+1;t[c|0]=b;break c}if(b>>>0<=2047){c=v[a+8>>2];if((g-c|0)<2){break b}v[a+8>>2]=c+1;t[c|0]=b>>>6|192;c=v[a+8>>2];v[a+8>>2]=c+1;t[c|0]=b&63|128;break c}if(b>>>0<=55295){c=v[a+8>>2];if((g-c|0)<3){break b}v[a+8>>2]=c+1;t[c|0]=b>>>12|224;c=v[a+8>>2];v[a+8>>2]=c+1;t[c|0]=b>>>6&63|128;c=v[a+8>>2];v[a+8>>2]=c+1;t[c|0]=b&63|128;break c}d:{e:{if(b>>>0<=56319){f=1;if((d-c|0)<4){break a}i=x[c+2>>1];if((i&64512)!=56320){break e}if((g-v[a+8>>2]|0)<4){break a}v[a+12>>2]=c+2;c=v[a+8>>2];v[a+8>>2]=c+1;f=c;c=(b>>>6&15)+1|0;t[f|0]=c>>>2|240;f=v[a+8>>2];v[a+8>>2]=f+1;t[f|0]=c<<4&48|b>>>2&15|128;c=v[a+8>>2];v[a+8>>2]=c+1;t[c|0]=i>>>6&15|b<<4&48|128;b=v[a+8>>2];v[a+8>>2]=b+1;t[b|0]=i&63|128;break c}if(b>>>0>=57344){break d}}f=2;break a}c=v[a+8>>2];if((g-c|0)<3){break b}v[a+8>>2]=c+1;t[c|0]=b>>>12|224;c=v[a+8>>2];v[a+8>>2]=c+1;t[c|0]=b>>>6&63|128;c=v[a+8>>2];v[a+8>>2]=c+1;t[c|0]=b&63|128}c=v[a+12>>2]+2|0;v[a+12>>2]=c;continue}break}f=1}v[e>>2]=v[a+12>>2];v[h>>2]=v[a+8>>2];kb=a+16|0;return f|0}function j0(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0;a=kb-240|0;kb=a;v[a+224>>2]=c;v[a+232>>2]=b;b=aj(d);qp(a+208|0,d,a+223|0);d=Nb(a+192|0);c=bd(d);v[23540]=0;R(60,d|0,c|0);c=v[23540];v[23540]=0;a:{b:{c:{if((c|0)!=1){c=Tc(d,0);v[a+188>>2]=c;v[a+12>>2]=a+16;v[a+8>>2]=0;i=t[a+223|0];while(1){d:{v[23540]=0;g=Q(1121,a+232|0,a+224|0)|0;h=v[23540];v[23540]=0;if((h|0)==1){break d}if(!g){break c}h=v[a+188>>2];g=Hb(d);if((h|0)==(g+c|0)){v[23540]=0;R(60,d|0,g<<1);c=v[23540];v[23540]=0;if((c|0)==1){break b}c=bd(d);v[23540]=0;R(60,d|0,c|0);c=v[23540];v[23540]=0;if((c|0)==1){break b}c=Tc(d,0);v[a+188>>2]=g+c}v[23540]=0;g=S(1123,v[a+232>>2])|0;h=v[23540];v[23540]=0;if((h|0)==1){break d}if(An(g,b,c,a+188|0,a+8|0,i,a+208|0,a+16|0,a+12|0,83808)){break c}v[23540]=0;S(1125,a+232|0)|0;g=v[23540];v[23540]=0;if((g|0)!=1){continue}}break}break b}break b}e:{if(!Hb(a+208|0)){break e}g=v[a+12>>2];if((g-(a+16|0)|0)>159){break e}v[a+12>>2]=g+4;v[g>>2]=v[a+8>>2]}j=f,k=DG(c,v[a+188>>2],e,b),v[j>>2]=k;v[f+4>>2]=nb;Ff(a+208|0,a+16|0,v[a+12>>2],e);v[23540]=0;b=Q(1122,a+232|0,a+224|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){if(b){v[e>>2]=v[e>>2]|2}b=v[a+232>>2];zb(d);zb(a+208|0);kb=a+240|0;break a}}b=P()|0;O()|0;zb(d);zb(a+208|0);T(b|0);L()}return b|0}function h0(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0;a=kb-240|0;kb=a;v[a+224>>2]=c;v[a+232>>2]=b;b=aj(d);qp(a+208|0,d,a+223|0);d=Nb(a+192|0);c=bd(d);v[23540]=0;R(60,d|0,c|0);c=v[23540];v[23540]=0;a:{b:{c:{if((c|0)!=1){c=Tc(d,0);v[a+188>>2]=c;v[a+12>>2]=a+16;v[a+8>>2]=0;i=t[a+223|0];while(1){d:{v[23540]=0;g=Q(1121,a+232|0,a+224|0)|0;h=v[23540];v[23540]=0;if((h|0)==1){break d}if(!g){break c}h=v[a+188>>2];g=Hb(d);if((h|0)==(g+c|0)){v[23540]=0;R(60,d|0,g<<1);c=v[23540];v[23540]=0;if((c|0)==1){break b}c=bd(d);v[23540]=0;R(60,d|0,c|0);c=v[23540];v[23540]=0;if((c|0)==1){break b}c=Tc(d,0);v[a+188>>2]=g+c}v[23540]=0;g=S(1123,v[a+232>>2])|0;h=v[23540];v[23540]=0;if((h|0)==1){break d}if(An(g,b,c,a+188|0,a+8|0,i,a+208|0,a+16|0,a+12|0,83808)){break c}v[23540]=0;S(1125,a+232|0)|0;g=v[23540];v[23540]=0;if((g|0)!=1){continue}}break}break b}break b}e:{if(!Hb(a+208|0)){break e}g=v[a+12>>2];if((g-(a+16|0)|0)>159){break e}v[a+12>>2]=g+4;v[g>>2]=v[a+8>>2]}j=f,k=zG(c,v[a+188>>2],e,b),v[j>>2]=k;v[f+4>>2]=nb;Ff(a+208|0,a+16|0,v[a+12>>2],e);v[23540]=0;b=Q(1122,a+232|0,a+224|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){if(b){v[e>>2]=v[e>>2]|2}b=v[a+232>>2];zb(d);zb(a+208|0);kb=a+240|0;break a}}b=P()|0;O()|0;zb(d);zb(a+208|0);T(b|0);L()}return b|0}function HW(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;g=kb-1088|0;kb=g;e=Kh(a);Ub(e+20|0,0,1040);v[e+1064>>2]=0;v[e+1068>>2]=0;v[e+1060>>2]=c;t[e+1084|0]=d;a=e+1072|0;v[a>>2]=0;v[a+4>>2]=0;v[e+1080>>2]=0;i=e+1064|0;a=c;d=0;a:{b:{c:while(1){if(Ld(x[a+34>>1])>>>0<=d>>>0){break a}v[e+1064>>2]=0;v[e+1068>>2]=0;a=0;while(1){d:{e:{f:{g:{h:{i:{j:{if(y[c>>2]<=a>>>0){break j}a=v[b+8>>2];f=v[b>>2];v[23540]=0;a=W(156,f|0,a|0,2)|0;f=v[23540];v[23540]=0;if((f|0)==1){break i}if(!a){break j}v[23540]=0;a=S(194,b|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break h}if(!a){break e}v[23540]=0;U(190,g|0,b|0,a|0);a=v[23540];v[23540]=0;if((a|0)==1){break g}a=rr(g+24|0,g);f=hd(e,a);sc(f+20|0,a+20|0,1040);Bb(a);Bb(g);v[e+1076>>2]=0;v[e+1080>>2]=0;h=v[e+1060>>2];a=v[h+20>>2];if($m(x[h+34>>1])>>>0>=2){v[23540]=0;R(195,f|0,a+(d<<1)|0);a=v[23540];v[23540]=0;if((a|0)!=1){break e}break f}v[23540]=0;R(196,f|0,a+d|0);a=v[23540];v[23540]=0;if((a|0)==1){break f}break e}d=d+1|0;a=v[e+1060>>2];continue c}a=P()|0;O()|0;break b}a=P()|0;O()|0;break b}a=P()|0;O()|0;break b}a=V(30544)|0;if((O()|0)!=(ea(30544)|0)){break b}_(a|0)|0;v[23540]=0;Z(18);a=v[23540];v[23540]=0;if((a|0)==1){break d}}a=v[i>>2];continue}break}break}a=P()|0;O()|0}Bb(e);T(a|0);L()}kb=g+1088|0;return e|0}function Gca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0;h=kb-16|0;kb=h;f=v[a+48>>2];i=v[a+40>>2];j=v[a+36>>2];e=v[a+44>>2];l=v[a+16>>2];g=v[a+4>>2];v[h+8>>2]=v[a>>2];v[h+12>>2]=g;m=b+24|0;n=v[a+32>>2];o=v[a+28>>2];p=v[a+72>>2];b=v[a+68>>2];q=b;r=b>>31;b=v[a+64>>2];s=b;t=b>>31;b=v[a+60>>2];w=b;x=b>>31;y=v[a+8>>2];z=v[a+12>>2];while(1){b=e;if(d){e=Zb(b,-16777216,16776704);e=Jka(s,t,e,e>>31);g=nb;f=Zb(f,-16777216,16776704);k=Jka(q,r,f,f>>31);e=k+e|0;f=nb+g|0;f=e>>>0<k>>>0?f+1|0:f;A=e;e=(v[h+12>>2]<<1)+l|0;g=(((v[h+8>>2]>>>16|0)+4&131064)<<1)+m|0;g=(((((B(u[e+4>>1],u[g+10>>1])+B(u[e+2>>1],u[g+8>>1])|0)+B(u[e+6>>1],u[g+12>>1])|0)+B(u[e+8>>1],u[g+14>>1])|0)/2|0)+((((B(u[e-4>>1],u[g+2>>1])+B(u[e-6>>1],u[g>>1])|0)+B(u[e-2>>1],u[g+4>>1])|0)+B(u[e>>1],u[g+6>>1])|0)/2|0)|0)/16384<<8;e=g;k=Jka(e,e>>31,w,x);e=A+k|0;f=nb+f|0;f=e>>>0<k>>>0?f+1|0:f;e=e+8388608|0;f=e>>>0<8388608?f+1|0:f;f=Yc(e,f,24);e=(f|0)/256|0;j=j+o|0;v[c>>2]=B(e,j>>12)+v[c>>2];i=i+n|0;v[c+4>>2]=v[c+4>>2]+B(i>>12,e);Rb(h+8|0,y,z);e=f-(g&p)|0;c=c+8|0;d=d-1|0;f=b;continue}break}c=v[h+12>>2];v[a>>2]=v[h+8>>2];v[a+4>>2]=c;v[a+40>>2]=i;v[a+20>>2]=j>>12;v[a+36>>2]=j;v[a+48>>2]=f;v[a+44>>2]=b;v[a+24>>2]=i>>12;kb=h+16|0}function UK(a){var b=0,c=C(0),d=0,e=0,f=0,g=C(0),h=0,i=0,k=C(0),m=0,n=0,o=C(0);d=kb-16|0;kb=d;b=v[v[a+16>>2]+24620>>2];e=a+4208|0;n=a,o=te(C(10),C(C(C(z[Eb(e,0)>>2]*C(120))+C(-60))/C(20))),z[n+4232>>2]=o;k=C(C(b>>>0)/C(1e3));n=a,o=te(C(10),C(C(-1)/C(k*C(C(z[Eb(e,1)>>2]*C(499.989990234375))+C(.009999999776482582))))),z[n+4236>>2]=o;n=a,o=te(C(10),C(C(-1)/C(k*C(C(z[Eb(e,2)>>2]*C(2950))+C(50))))),z[n+4240>>2]=o;v[d+12>>2]=1325400064;c=C(te(C(10),C(C(C(z[Eb(e,3)>>2]*C(60))+C(-60))/C(20)))*C(2147483648));b=(p(c),j(2));g=C(0);a:{if((b|0)==1065353216){break a}b:{if(b-2139095040>>>0<=2164260863){f=b<<1;if(!f){b=kb-16|0;z[b+12>>2]=-1;g=C(z[b+12>>2]/C(0));break a}if((b|0)==2139095040){break b}if(!(f>>>0<4278190080&(b|0)>=0)){g=IJ(c);break a}b=(p(C(c*C(8388608))),j(2))-192937984|0}f=b-1060306944|0;h=f>>>15&240;i=+(l(2,b-(f&-8388608)|0),q())*A[h+3568>>3]+-1;m=i*i;c=C((A[479]*m+(A[480]*i+A[481]))*m+(+(f>>23)*A[478]+A[h+3576>>3]+i))}g=c}z[d+8>>2]=C(C(g*C(67108864))/C(.6931471824645996))+C(67108864);n=a,o=C(z[nm(d+12|0,d+8|0)>>2]*C(4.656612873077393e-10)),z[n+4244>>2]=o;n=a,o=C(C(C(-1)/C(C(z[Eb(e,4)>>2]*C(99))+C(1)))+C(1)),z[n+4248>>2]=o;c=C(C(C(z[Eb(e,5)>>2]*C(4))*k)+C(2));c:{if(C(D(c))<C(2147483648)){h=~~c;break c}h=-2147483648}v[a+4252>>2]=h;kb=d+16|0}function te(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=C(0),k=0;f=(p(b),j(2));d=tF(f);a:{b:{c:{d:{c=(p(a),j(2));e:{if(c-2139095040>>>0>=2164260864){if(d){break e}break c}if(!d){break d}}i=C(1);if((c|0)==1065353216){break b}e=f<<1;if(!e){break b}d=e>>>0<4278190081;e=c<<1;a=C(a+b);if(!(d&e>>>0<=4278190080)){break a}if((e|0)==2130706432){break b}a=e>>>0>2130706431^(f|0)>=0?C(0):C(b*b);break a}if(tF(c)){i=C(a*a);if((c|0)<0){i=(sF(f)|0)==1?C(-i):i}if((f|0)>=0){break b}a=UH(C(C(1)/i));break a}if((c|0)<0){e=sF(f);if(!e){a=IJ(a);break a}c=c&2147483647;e=((e|0)==1)<<16}if(c>>>0>8388607){break c}c=((p(C(a*C(8388608))),j(2))&2147483647)-192937984|0}f=c-1060306944|0;d=f>>>15&240;g=+(l(2,c-(f&-8388608)|0),q())*A[d+93384>>3]+-1;h=g*g;h=((g*.288457581109214+-.36092606229713164)*(h*h)+((g*.480898481472577+-.7213474675006291)*h+(g*1.4426950408774342+(A[d+93392>>3]+ +(f>>23)))))*+b;o(+h);d=j(1)|0;j(0)|0;f:{d=d&2147450880;if((d|0)==1079967744|d>>>0<1079967744){break f}if(h>127.99999995700433){a=JD(e);break a}if(!(h<=-150)){break f}a=iD(e);break a}k=h;g=A[160];h=g+h;g=k-(h-g);k=(A[161]*g+A[162])*(g*g)+(A[163]*g+1);o(+h);j(1)|0;c=j(0)|0;f=e+c|0;f=f<<15;d=((c&31)<<3)+1024|0;e=v[d>>2];c=e;d=v[d+4>>2]+f|0;l(0,c|0);l(1,(c>>>0<c>>>0?d+1|0:d)|0);i=C(k*+n())}a=i}return a}function k0(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0;a=kb-240|0;kb=a;v[a+224>>2]=c;v[a+232>>2]=b;b=aj(d);qp(a+208|0,d,a+223|0);d=Nb(a+192|0);c=bd(d);v[23540]=0;R(60,d|0,c|0);c=v[23540];v[23540]=0;a:{b:{c:{if((c|0)!=1){c=Tc(d,0);v[a+188>>2]=c;v[a+12>>2]=a+16;v[a+8>>2]=0;i=t[a+223|0];while(1){d:{v[23540]=0;g=Q(1121,a+232|0,a+224|0)|0;h=v[23540];v[23540]=0;if((h|0)==1){break d}if(!g){break c}h=v[a+188>>2];g=Hb(d);if((h|0)==(g+c|0)){v[23540]=0;R(60,d|0,g<<1);c=v[23540];v[23540]=0;if((c|0)==1){break b}c=bd(d);v[23540]=0;R(60,d|0,c|0);c=v[23540];v[23540]=0;if((c|0)==1){break b}c=Tc(d,0);v[a+188>>2]=g+c}v[23540]=0;g=S(1123,v[a+232>>2])|0;h=v[23540];v[23540]=0;if((h|0)==1){break d}if(An(g,b,c,a+188|0,a+8|0,i,a+208|0,a+16|0,a+12|0,83808)){break c}v[23540]=0;S(1125,a+232|0)|0;g=v[23540];v[23540]=0;if((g|0)!=1){continue}}break}break b}break b}e:{if(!Hb(a+208|0)){break e}g=v[a+12>>2];if((g-(a+16|0)|0)>159){break e}v[a+12>>2]=g+4;v[g>>2]=v[a+8>>2]}j=f,k=EG(c,v[a+188>>2],e,b),v[j>>2]=k;Ff(a+208|0,a+16|0,v[a+12>>2],e);v[23540]=0;b=Q(1122,a+232|0,a+224|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){if(b){v[e>>2]=v[e>>2]|2}b=v[a+232>>2];zb(d);zb(a+208|0);kb=a+240|0;break a}}b=P()|0;O()|0;zb(d);zb(a+208|0);T(b|0);L()}return b|0}function i0(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0;a=kb-240|0;kb=a;v[a+224>>2]=c;v[a+232>>2]=b;b=aj(d);qp(a+208|0,d,a+223|0);d=Nb(a+192|0);c=bd(d);v[23540]=0;R(60,d|0,c|0);c=v[23540];v[23540]=0;a:{b:{c:{if((c|0)!=1){c=Tc(d,0);v[a+188>>2]=c;v[a+12>>2]=a+16;v[a+8>>2]=0;i=t[a+223|0];while(1){d:{v[23540]=0;g=Q(1121,a+232|0,a+224|0)|0;h=v[23540];v[23540]=0;if((h|0)==1){break d}if(!g){break c}h=v[a+188>>2];g=Hb(d);if((h|0)==(g+c|0)){v[23540]=0;R(60,d|0,g<<1);c=v[23540];v[23540]=0;if((c|0)==1){break b}c=bd(d);v[23540]=0;R(60,d|0,c|0);c=v[23540];v[23540]=0;if((c|0)==1){break b}c=Tc(d,0);v[a+188>>2]=g+c}v[23540]=0;g=S(1123,v[a+232>>2])|0;h=v[23540];v[23540]=0;if((h|0)==1){break d}if(An(g,b,c,a+188|0,a+8|0,i,a+208|0,a+16|0,a+12|0,83808)){break c}v[23540]=0;S(1125,a+232|0)|0;g=v[23540];v[23540]=0;if((g|0)!=1){continue}}break}break b}break b}e:{if(!Hb(a+208|0)){break e}g=v[a+12>>2];if((g-(a+16|0)|0)>159){break e}v[a+12>>2]=g+4;v[g>>2]=v[a+8>>2]}j=f,k=CG(c,v[a+188>>2],e,b),u[j>>1]=k;Ff(a+208|0,a+16|0,v[a+12>>2],e);v[23540]=0;b=Q(1122,a+232|0,a+224|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){if(b){v[e>>2]=v[e>>2]|2}b=v[a+232>>2];zb(d);zb(a+208|0);kb=a+240|0;break a}}b=P()|0;O()|0;zb(d);zb(a+208|0);T(b|0);L()}return b|0}function J$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;k=kb-16|0;kb=k;l=Qw(g);g=ww(g);bh(k,g);a:{b:{if(Re(k)){v[23540]=0;X(1144,l|0,a|0,c|0,d|0);g=v[23540];v[23540]=0;if((g|0)==1){break b}g=(c-a<<2)+d|0;v[f>>2]=g;break a}v[f>>2]=d;c:{d:{j=a;h=w[j|0];switch(h-43|0){case 0:case 2:break d;default:break c}}v[23540]=0;j=Q(1150,l|0,h<<24>>24)|0;h=v[23540];v[23540]=0;if((h|0)==1){break b}h=v[f>>2];v[f>>2]=h+4;v[h>>2]=j;j=a+1|0}if(!(w[j|0]!=48|(c-j|0)<2|(w[j+1|0]|32)!=120)){v[23540]=0;h=Q(1150,l|0,48)|0;i=v[23540];v[23540]=0;if((i|0)==1){break b}i=v[f>>2];v[f>>2]=i+4;v[i>>2]=h;h=t[j+1|0];v[23540]=0;h=Q(1150,l|0,h|0)|0;i=v[23540];v[23540]=0;if((i|0)==1){break b}i=v[f>>2];v[f>>2]=i+4;v[i>>2]=h;j=j+2|0}_l(j,c);i=0;v[23540]=0;o=S(1142,g|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break b}h=0;g=j;while(1){if(c>>>0<=g>>>0){Tr((j-a<<2)+d|0,v[f>>2]);g=v[f>>2];break a}e:{if(!w[Tc(k,h)|0]){break e}if(t[Tc(k,h)|0]!=(i|0)){break e}i=v[f>>2];v[f>>2]=i+4;v[i>>2]=o;h=(Hb(k)-1>>>0>h>>>0)+h|0;i=0}n=t[g|0];v[23540]=0;n=Q(1150,l|0,n|0)|0;m=v[23540];v[23540]=0;if((m|0)!=1){m=v[f>>2];v[f>>2]=m+4;v[m>>2]=n;g=g+1|0;i=i+1|0;continue}break}}a=P()|0;O()|0;zb(k);T(a|0);L()}v[e>>2]=(b|0)==(c|0)?g:(b-a<<2)+d|0;zb(k);kb=k+16|0}function BG(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0;a=kb-240|0;kb=a;v[a+224>>2]=c;v[a+232>>2]=b;b=aj(d);qp(a+208|0,d,a+223|0);d=Nb(a+192|0);c=bd(d);v[23540]=0;R(60,d|0,c|0);c=v[23540];v[23540]=0;a:{b:{c:{if((c|0)!=1){c=Tc(d,0);v[a+188>>2]=c;v[a+12>>2]=a+16;v[a+8>>2]=0;i=t[a+223|0];while(1){d:{v[23540]=0;g=Q(1121,a+232|0,a+224|0)|0;h=v[23540];v[23540]=0;if((h|0)==1){break d}if(!g){break c}h=v[a+188>>2];g=Hb(d);if((h|0)==(g+c|0)){v[23540]=0;R(60,d|0,g<<1);c=v[23540];v[23540]=0;if((c|0)==1){break b}c=bd(d);v[23540]=0;R(60,d|0,c|0);c=v[23540];v[23540]=0;if((c|0)==1){break b}c=Tc(d,0);v[a+188>>2]=g+c}v[23540]=0;g=S(1123,v[a+232>>2])|0;h=v[23540];v[23540]=0;if((h|0)==1){break d}if(An(g,b,c,a+188|0,a+8|0,i,a+208|0,a+16|0,a+12|0,83808)){break c}v[23540]=0;S(1125,a+232|0)|0;g=v[23540];v[23540]=0;if((g|0)!=1){continue}}break}break b}break b}e:{if(!Hb(a+208|0)){break e}g=v[a+12>>2];if((g-(a+16|0)|0)>159){break e}v[a+12>>2]=g+4;v[g>>2]=v[a+8>>2]}j=f,k=AG(c,v[a+188>>2],e,b),v[j>>2]=k;Ff(a+208|0,a+16|0,v[a+12>>2],e);v[23540]=0;b=Q(1122,a+232|0,a+224|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){if(b){v[e>>2]=v[e>>2]|2}b=v[a+232>>2];zb(d);zb(a+208|0);kb=a+240|0;break a}}b=P()|0;O()|0;zb(d);zb(a+208|0);T(b|0);L()}return b|0}function cI(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,j=C(0),k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=C(0);d=(b<<2)+a|0;h=d+1068|0;k=c<<1&-4;p=h,q=fe(a,k),v[p>>2]=q;g=d+1076|0;p=g,q=fe(a,k),v[p>>2]=q;i=fe(a,c&-4);v[d+1084>>2]=i;a:{h=v[h>>2];if(!h){break a}g=v[g>>2];if(!g|!i){break a}d=c>>2;o=(d|0)>0?d:0;j=C(c|0);d=0;while(1){if((e|0)==(o|0)){d=0;e=c>>3;h=(e|0)>0?e:0;e=0;while(1){if((d|0)!=(h|0)){g=e|1;f=+C(C(C(g<<1)*C(3.1415927410125732))/j);p=i+(e<<2)|0,r=C(af(f)),z[p>>2]=r;p=i+(g<<2)|0,r=C(-C(Di(f))),z[p>>2]=r;e=e+2|0;d=d+1|0;continue}break}}else{l=d<<2;f=+C(C(C(e<<2)*C(3.1415927410125732))/j);p=h+l|0,r=C(af(f)),z[p>>2]=r;m=d|1;n=m<<2;p=h+n|0,r=C(-C(Di(f))),z[p>>2]=r;f=+C(C(C(C(m|0)*C(3.1415927410125732))/j)*C(.5));p=g+l|0,r=C(C(af(f))*C(.5)),z[p>>2]=r;p=g+n|0,r=C(C(Di(f))*C(.5)),z[p>>2]=r;d=d+2|0;e=e+1|0;continue}break}i=(b<<2)+a|0;d=fe(a,k);v[i+1092>>2]=d;if(!d){break a}b=0;e=c>>1;k=(e|0)>0?e:0;f=+(e|0);while(1){if((b|0)!=(k|0)){j=C(Di((+(b|0)+.5)/f*.5*3.1415927410125732));p=d+(b<<2)|0,r=C(Di(+C(j*j)*1.5707963705062866)),z[p>>2]=r;b=b+1|0;continue}break}b=fe(a,c>>2&-2);v[i+1100>>2]=b;if(!b){break a}a=0;d=c>>3;d=(d|0)>0?d:0;c=36-im(c)|0;while(1){if((a|0)!=(d|0)){p=b+(a<<1)|0,q=gm(a)>>>c<<2,u[p>>1]=q;a=a+1|0;continue}break}return 1}ec(a,3);return 0}function i4(a,b){a=a|0;b=+b;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=kb-80|0;kb=e;a:{b:{c:{d:{f=a+36|0;d=v[f>>2];c=v[a+40>>2];e:{if(Pb(d,c)){Gc(e+72|0);break e}c=e+32|0;Kn(c,a);v[23540]=0;c=S(1006,c|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break d}v[e+72>>2]=c;Xf(e+32|0);c=v[a+40>>2];d=v[a+36>>2]}c=(k=f,l=v[e+72>>2],m=Pb(d,c),m?k:l);f=v[a+8>>2];if((f|0)==-1){d=v[c+4>>2];f=d-24|0;g=v[c>>2];i=Pi(g,d);j=A[f>>3];d=0;while(1){if((d|0)==(i|0)){c=f;break c}c=lf(g,d);if(h+A[c>>3]>b){break c}d=d+1|0;h=h+j;continue}}c=lf(v[c>>2],f);break b}d=P()|0;O()|0;Xf(e+32|0);break a}b=b-h}f=x[c+12>>1];d=v[a+24>>2];v[23540]=0;R(1039,d|0,f|0);f=v[23540];v[23540]=0;if((f|0)!=1){f:{f=v[a+24>>2];d=w[a+64|0];c=xM(bS(e+32|0,b),w[c+16|0],x[c+12>>1],v[c+8>>2]);v[23540]=0;g=v[c+12>>2];v[e+16>>2]=v[c+8>>2];v[e+20>>2]=g;g=v[c+20>>2];v[e+24>>2]=v[c+16>>2];v[e+28>>2]=g;g=v[c+4>>2];v[e+8>>2]=v[c>>2];v[e+12>>2]=g;X(1040,e+56|0,f|0,(d?7:1)|0,e+8|0);c=v[23540];v[23540]=0;if((c|0)==1){break f}c=yM(v[e+60>>2]);f=t[c+26|0]&1;d=v[(f?c+8|0:c+12|0)>>2];f=x[(f?c+20|0:c+22|0)>>1];b=A[c>>3];Ei(e+56|0);c=v[a+24>>2];u[c+1074450>>1]=f;u[c+1074448>>1]=f;v[c+1074428>>2]=d;v[c+1074392>>2]=-2;b=h+b;A[a+16>>3]=b;al(e+72|0);kb=e+80|0;return+b}}d=P()|0;O()|0;al(e+72|0)}T(d|0);L()}function Hca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,w=0,x=0,y=0,z=0,A=0,C=0;h=kb-16|0;kb=h;f=v[a+48>>2];i=v[a+40>>2];j=v[a+36>>2];e=v[a+44>>2];l=v[a+16>>2];g=v[a+4>>2];v[h+8>>2]=v[a>>2];v[h+12>>2]=g;m=b+24|0;n=v[a+32>>2];o=v[a+28>>2];p=v[a+72>>2];b=v[a+68>>2];q=b;r=b>>31;b=v[a+64>>2];s=b;w=b>>31;b=v[a+60>>2];x=b;y=b>>31;z=v[a+8>>2];A=v[a+12>>2];while(1){b=e;if(d){e=Zb(b,-16777216,16776704);e=Jka(s,w,e,e>>31);g=nb;f=Zb(f,-16777216,16776704);k=Jka(q,r,f,f>>31);e=k+e|0;f=nb+g|0;f=e>>>0<k>>>0?f+1|0:f;C=e;e=v[h+12>>2]+l|0;g=(((v[h+8>>2]>>>16|0)+4&131064)<<1)+m|0;g=(((((B(t[e+2|0],u[g+10>>1])+B(t[e+1|0],u[g+8>>1])|0)+B(t[e+3|0],u[g+12>>1])|0)+B(t[e+4|0],u[g+14>>1])<<8)/2|0)+((((B(t[e-2|0],u[g+2>>1])+B(t[e-3|0],u[g>>1])|0)+B(t[e-1|0],u[g+4>>1])|0)+B(t[e|0],u[g+6>>1])<<8)/2|0)|0)/16384<<8;e=g;k=Jka(e,e>>31,x,y);e=C+k|0;f=nb+f|0;f=e>>>0<k>>>0?f+1|0:f;e=e+8388608|0;f=e>>>0<8388608?f+1|0:f;f=Yc(e,f,24);e=(f|0)/256|0;j=j+o|0;v[c>>2]=B(e,j>>12)+v[c>>2];i=i+n|0;v[c+4>>2]=v[c+4>>2]+B(i>>12,e);Rb(h+8|0,z,A);e=f-(g&p)|0;c=c+8|0;d=d-1|0;f=b;continue}break}c=v[h+12>>2];v[a>>2]=v[h+8>>2];v[a+4>>2]=c;v[a+40>>2]=i;v[a+20>>2]=j>>12;v[a+36>>2]=j;v[a+48>>2]=f;v[a+44>>2]=b;v[a+24>>2]=i>>12;kb=h+16|0}function eh(a,b,c,d){var e=0,f=0,g=0,h=0,i=0;f=kb-16|0;kb=f;v[f+12>>2]=d;e=0;a:{if(b-251>>>0<4294967046){break a}e=b-1|0;g=v[a+480180>>2];if(!Km(g)){if(g&17408){a=((e&255)>>>0)/12|0;e=x[((B(a,-12)+e&255)<<1)+33312>>1]<<4>>>a|0;break a}if(!d){v[f+12>>2]=8363;d=8363}if(mj(a)){a=((e&255)>>>0)/12|0;b=Jka(v[(B(a,-12)+e<<6&960)+37200>>2]<<a,0,d,0);a=nb;c=a>>>21|0;h=f,i=Ec((a&2097151)<<11|b>>>21,c),v[h>>2]=i;xc(f,2147483647);e=v[f>>2];break a}if(w[a+480208|0]&16){a=e&255;e=x[((a>>>0)%12<<1)+33312>>1]<<5>>>(a>>>0)/12|0;break a}a=((e&255)>>>0)/12|0;xc(f+12|0,-1>>>a|0);e=Ec(Mka(Jka(x[((B(a,-12)+e&255)<<1)+33312>>1],0,267616,0),nb,v[f+12>>2]<<a,0),nb);break a}if(g&20){d=e>>>0>12;if((g|0)==16){b=c<<4}else{Db(f,a+1074312|0,76);b=Cb(v[v[f>>2]>>2],v[f+4>>2])?c&-8:c}c=d?e:12;if(w[a+480208|0]&16){a=(((b|0)/-2|0)-(c<<6)|0)+8448|0;e=(a|0)>1?a:1;break a}a=c-12|0;c=((a&255)>>>0)/12|0;d=((b|0)/16|0)+(B(c,-12)+a<<3&248)|0;v[f>>2]=d+8;oe(f,0,103);a=b>>31;b=(a^b)-a&15;a=d+(a|1)|0;a=(a|0)>-8?a:-8;e=B(b,x[(((a|0)<95?a:95)<<1)+33808>>1])+B(x[(v[f>>2]<<1)+33792>>1],16-b|0)<<1>>>c|0;break a}if(!((c&255)>>>0<16&b-25>>>0<=83)){a=((e&255)>>>0)/12|0;e=x[(B((c&240)>>>4|0,12)+(B(a,-12)+e&255)<<1)+32912>>1]<<5>>>a|0;break a}e=x[(b<<1)+32686>>1]<<2}kb=f+16|0;return e}function lJ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0;c=kb+-64|0;kb=c;d=v[a>>2];a=v[d>>2];f=v[a+4>>2];v[c+40>>2]=v[a+20>>2];g=v[a+16>>2];v[c+32>>2]=v[a+12>>2];v[c+36>>2]=g;Hf(c+48|0,c+32|0,f);a=v[d+4>>2];f=v[a+8>>2];g=v[a+4>>2];d=v[c+60>>2];v[c+24>>2]=v[c+56>>2];v[c+28>>2]=d;d=v[c+52>>2];v[c+16>>2]=v[c+48>>2];v[c+20>>2]=d;v[c+8>>2]=v[a+8>>2];d=v[a+4>>2];v[c>>2]=v[a>>2];v[c+4>>2]=d;a=kb-32|0;kb=a;a:{b:{c:{d:{k=v[c+4>>2];if(k>>>0>=g>>>0){l=v[c+20>>2];if(l>>>0<g>>>0){break d}if(f>>>0>y[c+8>>2]){break c}m=v[c+28>>2];if(f>>>0>v[c+24>>2]-m>>>0){break b}n=b+12|0;o=v[c+16>>2];p=v[c>>2];e:while(1){if((f|0)==(h|0)){break a}q=B(h,k);r=B(h+m|0,l);d=0;while(1)if((d|0)==(g|0)){h=h+1|0;continue e}else{e=Eb(v[b>>2],d);i=ve(ng(A[(d+q<<3)+p>>3])*134217728);j=e;e=(v[e>>2]>>1)+Jm(i)|0;s=e;e=ws(n)+e&-4096;v[j>>2]=s-e;A[a+24>>3]=+(e|0)*7.450580596923828e-9;v[a+16>>2]=0;v[a+20>>2]=-1074790400;v[a+8>>2]=0;v[a+12>>2]=1072693248;j=(d+r<<1)+o|0;i=ve(A[Gg(a+24|0,a+16|0,a+8|0)>>3]*32768);f:{if(D(i)<2147483648){e=~~i;break f}e=-2147483648}t=j,w=ed(e),u[t>>1]=w;d=d+1|0;continue}}}aa(7192,9074,77,8754);L()}aa(7157,9074,78,8754);L()}aa(5900,9074,79,8754);L()}aa(5870,9074,80,8754);L()}kb=a+32|0;kb=c- -64|0}function tJ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=kb+-64|0;kb=c;d=v[a>>2];a=v[d>>2];f=v[a+4>>2];v[c+40>>2]=v[a+20>>2];g=v[a+16>>2];v[c+32>>2]=v[a+12>>2];v[c+36>>2]=g;Hf(c+48|0,c+32|0,f);a=v[d+4>>2];f=v[a+8>>2];g=v[a+4>>2];d=v[c+60>>2];v[c+24>>2]=v[c+56>>2];v[c+28>>2]=d;d=v[c+52>>2];v[c+16>>2]=v[c+48>>2];v[c+20>>2]=d;v[c+8>>2]=v[a+8>>2];d=v[a+4>>2];v[c>>2]=v[a>>2];v[c+4>>2]=d;a=kb-32|0;kb=a;a:{b:{c:{d:{l=v[c+4>>2];if(l>>>0>=g>>>0){if(y[c+20>>2]<g>>>0){break d}if(f>>>0>y[c+8>>2]){break c}m=v[c+28>>2];if(f>>>0>v[c+24>>2]-m>>>0){break b}n=b+12|0;o=v[c+16>>2];p=v[c>>2];e:while(1){if((f|0)==(h|0)){break a}q=h+m|0;r=B(h,l);d=0;while(1)if((d|0)==(g|0)){h=h+1|0;continue e}else{e=Eb(v[b>>2],d);i=ve(ng(A[(d+r<<3)+p>>3])*134217728);j=e;e=(v[e>>2]>>1)+Jm(i)|0;k=e;e=ws(n)+e&-4096;v[j>>2]=k-e;A[a+24>>3]=+(e|0)*7.450580596923828e-9;v[a+16>>2]=0;v[a+20>>2]=-1074790400;v[a+8>>2]=0;v[a+12>>2]=1072693248;j=q<<1;k=(d<<2)+o|0;i=ve(A[Gg(a+24|0,a+16|0,a+8|0)>>3]*32768);f:{if(D(i)<2147483648){e=~~i;break f}e=-2147483648}s=j+v[k>>2]|0,t=ed(e),u[s>>1]=t;d=d+1|0;continue}}}aa(7192,9074,77,8754);L()}aa(7157,9074,78,8754);L()}aa(5900,9074,79,8754);L()}aa(5870,9074,80,8754);L()}kb=a+32|0;kb=c- -64|0}function jS(a,b){var c=0;a:{b:{c:{d:{if(ne(a,16761)){break d}if(ne(a,17530)){break d}if(ne(a,13559)){break d}if(ne(a,13714)){break d}if(!ne(a,14283)){break c}}u[b+10>>1]=4;v[b>>2]=12025;break b}e:{f:{if(ne(a,17525)){break f}if(ne(a,13569)){break f}if(!ne(a,16746)){break e}}t[b+12|0]=1;v[b>>2]=8420;u[b+10>>1]=4;return 1}g:{if(!ne(a,14329)){if(!ne(a,14334)){break g}}u[b+10>>1]=8;v[b>>2]=8198;break b}h:{if(!ne(a,15416)){if(!ne(a,15421)){break h}}v[b>>2]=17133;u[b+10>>1]=t[a+2|0]-48;break b}i:{if(!ne(a,26938)){if(!ne(a,26943)){break i}}v[b+4>>2]=1;v[b>>2]=16939;u[b+10>>1]=w[a|0]==56?8:4;return 1}if(!(Sb(a,15522,3)|(w[a+3|0]-52&255)>>>0>4)){v[b>>2]=8538;a=t[a+3|0];u[b+8>>1]=1088;u[b+10>>1]=a-48;break b}j:{if(Sb(a,13642,3)){if(Sb(a,13776,3)){break j}}if((w[a+3|0]-52&255)>>>0>5){break j}t[b+15|0]=1;t[b+13|0]=1;v[b>>2]=8297;u[b+10>>1]=t[a+3|0]-48;return 1}k:{if((w[a|0]-49&255)>>>0>8){break k}if(!Sb(a+1|0,13800,3)){t[b+14|0]=1;v[b>>2]=8602;u[b+10>>1]=t[a|0]-48;return 1}if((w[a+1|0]-48&255)>>>0>9){break k}c=a+2|0;if(Sb(c,14132,2)){if(Sb(c,13804,2)){break k}}t[b+14|0]=1;v[b>>2]=8602;u[b+10>>1]=(t[a+1|0]+B(t[a|0],10)|0)-528;return 1}c=0;if(Sb(a,13425,3)|(w[a+3|0]-49&255)>>>0>8){break a}v[b>>2]=8447;u[b+10>>1]=t[a+3|0]-48}c=1}return c}function U_(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;a=kb-496|0;kb=a;g=a+488|0;gd(g,d);v[23540]=0;m=S(1132,g|0)|0;g=v[23540];v[23540]=0;a:{b:{c:{d:{e:{f:{g:{if((g|0)!=1){if(Hb(f)){g=v[qj(f,0)>>2];v[23540]=0;h=Q(1150,m|0,45)|0;k=v[23540];v[23540]=0;if((k|0)==1){break g}n=(g|0)==(h|0)}k=Nb(a+456|0);g=Nb(a+440|0);h=Nb(a+424|0);v[23540]=0;na(1171,c|0,n|0,a+488|0,a+480|0,a+476|0,a+472|0,k|0,g|0,h|0,a+420|0);c=v[23540];v[23540]=0;if((c|0)==1){break f}v[a+4>>2]=1119;c=se(a+8|0,0,a+4|0);j=Hb(f);l=v[a+420>>2];h:{if((j|0)>(l|0)){i=((Hb(h)+(j-l<<1)|0)+Hb(g)|0)+1|0;break h}i=(Hb(h)+Hb(g)|0)+2|0}j=a+16|0;i=i+l|0;if(i>>>0<101){break e}_e(c,Pd(i<<2));j=v[c>>2];if(j){break e}v[23540]=0;Z(1120);b=v[23540];v[23540]=0;if((b|0)==1){break d}L()}f=P()|0;O()|0;break b}f=P()|0;O()|0;break b}f=P()|0;O()|0;break c}o=v[d+4>>2];i=Ac(f);f=Hb(f);v[23540]=0;pa(1172,j|0,a+4|0,a|0,o|0,i|0,i+(f<<2)|0,m|0,n|0,a+480|0,v[a+476>>2],v[a+472>>2],k|0,g|0,h|0,l|0);f=v[23540];v[23540]=0;if((f|0)!=1){v[23540]=0;b=ka(1153,b|0,j|0,v[a+4>>2],v[a>>2],d|0,e|0)|0;d=v[23540];v[23540]=0;if((d|0)!=1){break a}}}f=P()|0;O()|0;Xc(c)}Nc(h);Nc(g);zb(k)}ac(a+488|0);T(f|0);L()}Xc(c);Nc(h);Nc(g);zb(k);ac(a+488|0);kb=a+496|0;return b|0}function FM(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=kb-16|0;kb=d;f=a+484376|0;while(1){a:{c=Wb(v[a+484360>>2],w[f|0]);e=b&65535;if(Rc(v[c>>2],v[c+4>>2])>>>0>e>>>0){if(!Jq(c,e)){break a}c=Wb(v[a+484360>>2],w[a+484376|0])}if(Rc(v[c>>2],v[c+4>>2])>>>0>e>>>0){e=a+1074312|0;f=a+1298224|0;c=a+1074992|0;b:{while(1){c:{if((c|0)==(f|0)){EM(a);if(b&65535){break c}b=0;while(1){if((b|0)==256){bo(a+1298264|0,1);v[a+1074456>>2]=v[a+480200>>2];v[a+1074416>>2]=v[a+480196>>2];v[a+1074420>>2]=v[a+480204>>2];v[a+480208>>2]=v[a+480208>>2]&-769;Xy(a+1074376|0);u[a+1074450>>1]=0;v[a+1074392>>2]=-2;b=a+1074428|0;v[b>>2]=0;v[b+4>>2]=0;b=a+1074396|0;v[b>>2]=0;v[b+4>>2]=0;v[a+1074376>>2]=0;v[a+1074380>>2]=0}else{go((B(b,872)+a|0)+1074992|0,a,b&65535,134217728);b=b+1|0;continue}break}break b}t[c+797|0]=0;v[c+700>>2]=0;t[c+841|0]=0;t[c+805|0]=0;v[c+708>>2]=0;t[c+821|0]=0;v[c+764>>2]=0;t[c+819|0]=0;t[c+820|0]=0;Db(d+8|0,e,23);if(Cb(v[v[d+8>>2]>>2],v[d+12>>2])){t[c+807|0]=1;t[c+808|0]=0}t[c+839|0]=0;c=c+872|0;continue}break}u[a+1074450>>1]=b;u[a+1074446>>1]=0;b=a+1074424|0;v[b>>2]=0;v[b+4>>2]=0;v[a+1074392>>2]=-2;v[a+1074432>>2]=0;b=a+1074396|0;v[b>>2]=0;v[b+4>>2]=0;v[a+1074380>>2]=0}v[a+480208>>2]=v[a+480208>>2]&-769}kb=d+16|0;return}b=b+1|0;continue}}function T$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;k=kb-16|0;kb=k;l=gv(g);g=Bw(g);bh(k,g);a:{b:{if(Re(k)){v[23540]=0;X(1130,l|0,a|0,c|0,d|0);g=v[23540];v[23540]=0;if((g|0)==1){break b}g=(c-a|0)+d|0;v[f>>2]=g;break a}v[f>>2]=d;c:{d:{j=a;h=w[j|0];switch(h-43|0){case 0:case 2:break d;default:break c}}v[23540]=0;j=Q(20,l|0,h<<24>>24)|0;h=v[23540];v[23540]=0;if((h|0)==1){break b}h=v[f>>2];v[f>>2]=h+1;t[h|0]=j;j=a+1|0}if(!(w[j|0]!=48|(c-j|0)<2|(w[j+1|0]|32)!=120)){v[23540]=0;h=Q(20,l|0,48)|0;i=v[23540];v[23540]=0;if((i|0)==1){break b}i=v[f>>2];v[f>>2]=i+1;t[i|0]=h;h=t[j+1|0];v[23540]=0;h=Q(20,l|0,h|0)|0;i=v[23540];v[23540]=0;if((i|0)==1){break b}i=v[f>>2];v[f>>2]=i+1;t[i|0]=h;j=j+2|0}_l(j,c);i=0;v[23540]=0;o=S(1128,g|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break b}h=0;g=j;while(1){if(c>>>0<=g>>>0){_l((j-a|0)+d|0,v[f>>2]);g=v[f>>2];break a}e:{if(!w[Tc(k,h)|0]){break e}if(t[Tc(k,h)|0]!=(i|0)){break e}i=v[f>>2];v[f>>2]=i+1;t[i|0]=o;h=(Hb(k)-1>>>0>h>>>0)+h|0;i=0}n=t[g|0];v[23540]=0;n=Q(20,l|0,n|0)|0;m=v[23540];v[23540]=0;if((m|0)!=1){m=v[f>>2];v[f>>2]=m+1;t[m|0]=n;g=g+1|0;i=i+1|0;continue}break}}a=P()|0;O()|0;zb(k);T(a|0);L()}v[e>>2]=(b|0)==(c|0)?g:(b-a|0)+d|0;zb(k);kb=k+16|0}function Fr(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;a:{e=kb-96|0;kb=e;i=v[c>>2];g=kb-32|0;kb=g;f=e- -64|0;j=Nb(f+16|0);v[f>>2]=v[c>>2];v[f+4>>2]=v[c+4>>2];v[f+8>>2]=v[c+8>>2];v[f+12>>2]=v[c+12>>2];v[23540]=0;c=Q(54,g|0,c+16|0)|0;h=v[23540];v[23540]=0;b:{c:{d:{if((h|0)!=1){v[23540]=0;R(58,g+16|0,c|0);h=v[23540];v[23540]=0;if((h|0)==1){break d}f=g+16|0;Bc(j,f);zb(f);zb(c);kb=g+32|0;break b}a=P()|0;O()|0;break c}a=P()|0;O()|0;zb(c)}jm(f);T(a|0);L()}v[23540]=0;U(d|0,e|0,b|0,(i&2?16:10)|0);b=v[23540];v[23540]=0;e:{f:{g:{h:{i:{j:{if((b|0)!=1){c=e+16|0;b=kb-16|0;kb=b;k:{if(!(v[e+64>>2]&32)){break k}k=b,l=he(e),v[k+8>>2]=l;k=b,l=yh(e),v[k>>2]=l;while(1){if(!pj(b+8|0,b)){break k}d=v[b+8>>2];f=w[d|0];if((f-97&255)>>>0<=25){t[d|0]=f-32}Ke(b+8|0);continue}}ad(c,e);kb=b+16|0;v[23540]=0;X(75,e+32|0,c|0,v[e+64>>2],v[e+68>>2]);b=v[23540];v[23540]=0;if((b|0)==1){break j}v[23540]=0;U(76,e+48|0,e+32|0,e- -64|0);b=v[23540];v[23540]=0;if((b|0)==1){break i}v[23540]=0;R(58,a|0,e+48|0);a=v[23540];v[23540]=0;if((a|0)==1){break h}zb(e+48|0);zb(e+32|0);zb(e+16|0);zb(e);jm(e- -64|0);kb=e+96|0;break a}a=P()|0;O()|0;break e}a=P()|0;O()|0;break f}a=P()|0;O()|0;break g}a=P()|0;O()|0;zb(e+48|0)}zb(e+32|0)}zb(e+16|0);zb(e)}jm(e- -64|0);T(a|0);L()}}function VG(a,b){var c=0,d=0,e=0,f=0,g=0;a:{b:{c:{d:{e:{f:{g:{c=v[a+4>>2];h:{if((c|0)!=v[a+104>>2]){v[a+4>>2]=c+1;c=w[c|0];break h}c=rd(a)}switch(c-43|0){case 0:case 2:break g;default:break f}}f=(c|0)==45;g=!b;c=v[a+4>>2];i:{if((c|0)!=v[a+104>>2]){v[a+4>>2]=c+1;c=w[c|0];break i}c=rd(a)}b=c-58|0;if(g|b>>>0>4294967285){break e}b=v[a+116>>2];if((b|0)>0|(b|0)>=0){break d}break a}b=c-58|0}if(b>>>0<4294967286){break c}b=c-48|0;if(b>>>0<10){while(1){e=(B(e,10)+c|0)-48|0;d=(e|0)<214748364;c=v[a+4>>2];j:{if((c|0)!=v[a+104>>2]){v[a+4>>2]=c+1;c=w[c|0];break j}c=rd(a)}b=c-48|0;if(d&b>>>0<=9){continue}break}d=e>>31}k:{if(b>>>0>=10){break k}while(1){b=Jka(e,d,10,0);c=b+c|0;d=nb;d=b>>>0>c>>>0?d+1|0:d;b=c;e=b-48|0;d=d-(b>>>0<48)|0;b=v[a+4>>2];l:{if((b|0)!=v[a+104>>2]){v[a+4>>2]=b+1;c=w[b|0];break l}c=rd(a)}b=c-48|0;if(b>>>0>9){break k}if(e>>>0<2061584302&(d|0)<=21474836|(d|0)<21474836){continue}break}}if(b>>>0<10){while(1){b=v[a+4>>2];m:{if((b|0)!=v[a+104>>2]){v[a+4>>2]=b+1;b=w[b|0];break m}b=rd(a)}if(b-48>>>0<10){continue}break}}b=v[a+116>>2];if((b|0)>0|(b|0)>=0){v[a+4>>2]=v[a+4>>2]-1}nb=f?0-(((e|0)!=0)+d|0)|0:d;return f?0-e|0:e}v[a+4>>2]=v[a+4>>2]-1;break b}if(v[a+116>>2]<0){break a}}v[a+4>>2]=v[a+4>>2]-1}nb=-2147483648;return 0}function Y_(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;a=kb-192|0;kb=a;g=a+184|0;gd(g,d);v[23540]=0;m=S(19,g|0)|0;g=v[23540];v[23540]=0;a:{b:{c:{d:{e:{f:{g:{if((g|0)!=1){if(Hb(f)){g=w[hg(f,0)|0];v[23540]=0;h=Q(20,m|0,45)|0;k=v[23540];v[23540]=0;if((k|0)==1){break g}n=(g|0)==(h&255)}k=Nb(a+160|0);g=Nb(a+144|0);h=Nb(a+128|0);v[23540]=0;na(1169,c|0,n|0,a+184|0,a+176|0,a+175|0,a+174|0,k|0,g|0,h|0,a+124|0);c=v[23540];v[23540]=0;if((c|0)==1){break f}v[a+4>>2]=1119;c=se(a+8|0,0,a+4|0);j=Hb(f);l=v[a+124>>2];h:{if((j|0)>(l|0)){i=((Hb(h)+(j-l<<1)|0)+Hb(g)|0)+1|0;break h}i=(Hb(h)+Hb(g)|0)+2|0}j=a+16|0;i=i+l|0;if(i>>>0<101){break e}_e(c,Pd(i));j=v[c>>2];if(j){break e}v[23540]=0;Z(1120);b=v[23540];v[23540]=0;if((b|0)==1){break d}L()}f=P()|0;O()|0;break b}f=P()|0;O()|0;break b}f=P()|0;O()|0;break c}o=v[d+4>>2];i=Mc(f);f=Hb(f);v[23540]=0;pa(1170,j|0,a+4|0,a|0,o|0,i|0,f+i|0,m|0,n|0,a+176|0,t[a+175|0],t[a+174|0],k|0,g|0,h|0,l|0);f=v[23540];v[23540]=0;if((f|0)!=1){v[23540]=0;b=ka(15,b|0,j|0,v[a+4>>2],v[a>>2],d|0,e|0)|0;d=v[23540];v[23540]=0;if((d|0)!=1){break a}}}f=P()|0;O()|0;Xc(c)}zb(h);zb(g);zb(k)}ac(a+184|0);T(f|0);L()}Xc(c);zb(h);zb(g);zb(k);ac(a+184|0);kb=a+192|0;return b|0}function ada(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0;f=kb-16|0;kb=f;a:{b:{c:{g=v[a+12>>2];i=v[a+8>>2];d:{if((g|0)<=1&i>>>0<=805306368|(g|0)<=0){if((g|0)>=-2&i>>>0>=3489660928|(g|0)>-2){break c}if((g|0)==-2&i>>>0>2147483647|g>>>0>4294967294){break d}break b}if((g|0)==1&i>>>0>2147483648|g>>>0>1){break b}}b=b+196648|0;break a}b=b+131112|0;break a}b=b+262184|0}l=v[a+16>>2];j=v[a+40>>2];k=v[a+36>>2];e=v[a+4>>2];v[f+8>>2]=v[a>>2];v[f+12>>2]=e;m=v[a+32>>2];n=v[a+28>>2];while(1){if(d){h=v[f+8>>2];o=((((v[f+12>>2]&2147483647)<<1|h>>>31)&2147483646)<<1)+l|0;e=(h>>>16&65520)+b|0;p=u[e+14>>1];q=u[e+12>>1];r=u[e+10>>1];s=u[e+8>>1];t=u[e+6>>1];w=u[e+4>>1];x=u[e+2>>1];y=u[e>>1];h=0;while(1){if((h|0)!=2){e=(h<<1)+o|0;v[(h<<2)+f>>2]=(((((((B(u[e-8>>1],x)+B(u[e-12>>1],y)|0)+B(u[e-4>>1],w)|0)+B(u[e>>1],t)|0)+B(u[e+4>>1],s)|0)+B(u[e+8>>1],r)|0)+B(u[e+12>>1],q)|0)+B(u[e+16>>1],p)|0)/32768;h=h+1|0;continue}break}k=k+n|0;v[c>>2]=v[c>>2]+B(v[f>>2],k>>12);j=j+m|0;v[c+4>>2]=v[c+4>>2]+B(v[f+4>>2],j>>12);Rb(f+8|0,i,g);c=c+8|0;d=d-1|0;continue}break}b=v[f+12>>2];v[a>>2]=v[f+8>>2];v[a+4>>2]=b;v[a+40>>2]=j;v[a+20>>2]=k>>12;v[a+36>>2]=k;v[a+24>>2]=j>>12;kb=f+16|0}function Pba(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;l=kb-16|0;kb=l;k=kb-32|0;kb=k;h=k+28|0;f=k+24|0;g=kb-16|0;kb=g;a:{b:{if(!pc(b,v[fc(g+8|0,Zf(a))>>2])){e=x[c>>1];i=v[c+4>>2];j=vd(b);m=x[j>>1];j=v[j+4>>2];if(!ml(e,i,m,j)){break b}}v[g+8>>2]=b;e=fc(g,Fb(v[a>>2]));c:{f=v[g+8>>2];if(!pc(f,v[e>>2])){f=v[lz(g+8|0)>>2];e=vd(f);j=x[e>>1];m=v[e+4>>2];e=x[c>>1];i=v[c+4>>2];if(!ml(j,m,e,i)){break c}}if(!v[b>>2]){v[h>>2]=b;break a}v[h>>2]=f;b=f+4|0;break a}b=kz(a,h,e,i);break a}if(ml(m,j,e,i)){d:{f=jz(b);if(!pc(f,v[fc(g+8|0,Zf(a))>>2])){e=x[c>>1];i=v[c+4>>2];j=vd(f);if(!ml(e,i,x[j>>1],v[j+4>>2])){break d}}if(!v[b+4>>2]){v[h>>2]=b;b=b+4|0;break a}v[h>>2]=f;b=f;break a}b=kz(a,h,e,i);break a}v[h>>2]=b;v[f>>2]=b;b=f}kb=g+16|0;f=b;b=v[b>>2];if(!b){b=kb-16|0;kb=b;g=jc(a);h=k+8|0;e=lh(h,vc(36),mh(b+8|0,g));g=v[e>>2]+16|0;i=v[c+4>>2];v[g>>2]=v[c>>2];v[g+4>>2]=i;ul(g+8|0,d);o=jc(e),p=1,t[o+4|0]=p;kb=b+16|0;Jg(a,v[k+28>>2],f,v[k+8>>2]);b=ce(h);xO(h);n=1}Ig(l,v[fc(k+8|0,b)>>2],n);kb=k+32|0;if(!w[jc(l)|0]){a=vd(v[l>>2])+8|0;wO(a);v[a>>2]=v[d>>2];v[a+4>>2]=v[d+4>>2];b=Gb(d);o=Gb(a),p=v[b>>2],v[o>>2]=p;v[b>>2]=0;v[d>>2]=0;v[d+4>>2]=0}a=v[fc(l+8|0,v[l>>2])>>2];kb=l+16|0;return a|0}function Hka(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{e=b;if(e){if(!c){break j}f=d;if(!f){break i}e=E(f)-E(e)|0;if(e>>>0<=31){break h}break b}if((d|0)==1|d>>>0>1){break b}b=(a>>>0)/(c>>>0)|0;lb=a-B(b,c)|0;mb=0;nb=0;return b}f=d;if(!a){break g}if(!f){break f}g=f-1|0;if(g&f){break f}lb=a;mb=e&g;a=e>>>Ika(f)|0;nb=0;return a}f=c-1|0;if(!(f&c)){break e}h=(E(c)+33|0)-E(e)|0;g=0-h|0;break c}h=e+1|0;g=63-e|0;break c}lb=0;a=(e>>>0)/(f>>>0)|0;mb=e-B(a,f)|0;nb=0;return a}e=E(f)-E(e)|0;if(e>>>0<31){break d}break b}lb=a&f;mb=0;if((c|0)==1){break a}d=a;c=Ika(c);a=c&31;if((c&63)>>>0>=32){e=0;a=b>>>a|0}else{e=b>>>a|0;a=((1<<a)-1&b)<<32-a|d>>>a}nb=e;return a}h=e+1|0;g=63-e|0}i=a;e=h&63;f=e&31;if((e&63)>>>0>=32){e=0;k=b>>>f|0}else{e=b>>>f|0;k=((1<<f)-1&b)<<32-f|i>>>f}f=e;e=g&63;a=e&31;if((e&63)>>>0>=32){e=i<<a;a=0}else{e=(1<<a)-1&i>>>32-a|b<<a;a=i<<a}b=e;if(h){e=d-1|0;g=c-1|0;e=(g|0)!=-1?e+1|0:e;i=e;while(1){j=k;e=f<<1|j>>>31;f=j<<1;j=e;f=b>>>31|f;e=i-((f>>>0>g>>>0)+e|0)>>31;l=e;m=c&e;k=f-m|0;f=j-((d&e)+(f>>>0<m>>>0)|0)|0;e=b<<1|a>>>31;a=n|a<<1;b=e|o;j=0;l=l&1;n=l;h=h-1|0;if(h){continue}break}}lb=k;mb=f;e=b<<1|a>>>31;a=l|a<<1;nb=e|j;return a}lb=a;mb=b;a=0;b=0}nb=b;return a}function F$(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var f=0,g=0,h=0,i=0,j=0,k=0,l=0;k=b;f=kb-384|0;kb=f;v[f+376>>2]=37;v[f+380>>2]=0;h=Qr(f+376|1,21688,v[c+4>>2]);v[f+332>>2]=f+336;a=Gd();a:{if(h){b=v[c+8>>2];A[f+40>>3]=e;v[f+32>>2]=b;g=$g(f+336|0,30,a,f+376|0,f+32|0);break a}A[f+48>>3]=e;g=$g(f+336|0,30,a,f+376|0,f+48|0)}v[f+80>>2]=1119;i=se(f+320|0,0,f+80|0);b=f+336|0;a=b;b:{c:{d:{e:{if((g|0)>=30){a=Gd();f:{if(h){g=v[c+8>>2];A[f+8>>3]=e;v[f>>2]=g;g=Xi(f+332|0,a,f+376|0,f);break f}A[f+16>>3]=e;g=Xi(f+332|0,a,f+376|0,f+16|0)}if((g|0)==-1){v[23540]=0;Z(1120);a=v[23540];v[23540]=0;if((a|0)==1){break d}break e}a=v[f+332>>2];_e(i,a)}j=a+g|0;l=Zi(a,j,c);v[f+68>>2]=1119;h=se(f+72|0,0,f+68|0);g:{h:{if((f+336|0)==(a|0)){g=f+80|0;break h}g=Pd(g<<3);if(!g){v[23540]=0;Z(1120);a=v[23540];v[23540]=0;if((a|0)!=1){break e}a=P()|0;O()|0;break g}_e(h,g);b=a}a=f+56|0;gd(a,c);v[23540]=0;ia(1152,b|0,l|0,j|0,g|0,f+68|0,f- -64|0,a|0);a=v[23540];v[23540]=0;i:{if((a|0)!=1){ac(f+56|0);v[23540]=0;a=ka(1153,k|0,g|0,v[f+68>>2],v[f+64>>2],c|0,d|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break i}Xc(h);Xc(i);kb=f+384|0;break b}a=P()|0;O()|0;ac(f+56|0);break g}a=P()|0;O()|0}Xc(h);break c}L()}a=P()|0;O()|0}Xc(i);T(a|0);L()}return a|0}function P$(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var f=0,g=0,h=0,i=0,j=0,k=0,l=0;k=b;f=kb-208|0;kb=f;v[f+200>>2]=37;v[f+204>>2]=0;h=Qr(f+200|1,21688,v[c+4>>2]);v[f+156>>2]=f+160;a=Gd();a:{if(h){b=v[c+8>>2];A[f+40>>3]=e;v[f+32>>2]=b;g=$g(f+160|0,30,a,f+200|0,f+32|0);break a}A[f+48>>3]=e;g=$g(f+160|0,30,a,f+200|0,f+48|0)}v[f+80>>2]=1119;i=se(f+144|0,0,f+80|0);b=f+160|0;a=b;b:{c:{d:{e:{if((g|0)>=30){a=Gd();f:{if(h){g=v[c+8>>2];A[f+8>>3]=e;v[f>>2]=g;g=Xi(f+156|0,a,f+200|0,f);break f}A[f+16>>3]=e;g=Xi(f+156|0,a,f+200|0,f+16|0)}if((g|0)==-1){v[23540]=0;Z(1120);a=v[23540];v[23540]=0;if((a|0)==1){break d}break e}a=v[f+156>>2];_e(i,a)}j=a+g|0;l=Zi(a,j,c);v[f+68>>2]=1119;h=se(f+72|0,0,f+68|0);g:{h:{if((f+160|0)==(a|0)){g=f+80|0;break h}g=Pd(g<<1);if(!g){v[23540]=0;Z(1120);a=v[23540];v[23540]=0;if((a|0)!=1){break e}a=P()|0;O()|0;break g}_e(h,g);b=a}a=f+56|0;gd(a,c);v[23540]=0;ia(1147,b|0,l|0,j|0,g|0,f+68|0,f- -64|0,a|0);a=v[23540];v[23540]=0;i:{if((a|0)!=1){ac(f+56|0);v[23540]=0;a=ka(15,k|0,g|0,v[f+68>>2],v[f+64>>2],c|0,d|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break i}Xc(h);Xc(i);kb=f+208|0;break b}a=P()|0;O()|0;ac(f+56|0);break g}a=P()|0;O()|0}Xc(h);break c}L()}a=P()|0;O()|0}Xc(i);T(a|0);L()}return a|0}function Aca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0;e=kb-16|0;kb=e;q=v[a+16>>2];r=kg(b+327720|0,v[b+20>>2],(v[a+88>>2]&16384)>>>14|0);l=v[a+128>>2];a:{if(!l){j=v[a+8>>2];k=v[a+12>>2];f=v[a>>2];g=v[a+4>>2];i=0;break a}j=v[a+8>>2];k=v[a+12>>2];m=lg(j,k,l);n=nb;b=v[a+76>>2];f=v[a>>2];g=v[a+4>>2];Qf(f,g,qf(j,k,d),nb);i=b>>>0<nb>>>0?d:0}h=a+112|0;s=v[a+24>>2];u=v[a+20>>2];v[e>>2]=f;v[e+4>>2]=g;while(1){if(d){b=v[e+4>>2];f=v[e>>2];v[e+8>>2]=f;v[e+12>>2]=0;i=i-1|0;m=i?m:0;n=i?n:0;d=d-1|0;p=(((b&2147483647)<<1|f>>>31)&-2)+q|0;f=l;b:{c:while(1){d:{if((f|0)<=0){Rb(h,v[a+120>>2],v[a+124>>2]);f=v[a+116>>2];if(!f){break b}o=((v[e+12>>2]&2147483647)<<1|v[e+8>>2]>>>31)&-2;g=0;b=0;break d}o=((v[e+12>>2]&2147483647)<<1|v[e+8>>2]>>>31)&-2;b=0;g=0;while(1)if((b|0)==2){Sd(h,(g|0)/8<<16>>16);Rd(h,4);Rb(e+8|0,m,n);f=f-1|0;continue c}else{g=(t[(b+o|0)+p|0]<<8)+g|0;b=b+1|0;continue}}break}while(1){if((b|0)!=2){g=(t[(b+o|0)+p|0]<<8)+g|0;b=b+1|0;continue}break}Sd(h,(g|0)/8<<16>>16);Rd(h,f);v[h>>2]=v[h>>2];v[h+4>>2]=0}f=v[c>>2];b=jg(h,r);v[c>>2]=f+B(b,u);v[c+4>>2]=v[c+4>>2]+B(b,s);Rb(e,j,k);c=c+8|0;continue}break}b=v[e+4>>2];v[a>>2]=v[e>>2];v[a+4>>2]=b;kb=e+16|0}function FY(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;if(Zg(a,v[b+8>>2],e)){mw(b,c,d);return}a:{if(Zg(a,v[b>>2],e)){if(!(v[b+16>>2]!=(c|0)&v[b+20>>2]!=(c|0))){if((d|0)!=1){break a}v[b+32>>2]=1;return}v[b+32>>2]=d;if(v[b+44>>2]!=4){f=a+16|0;h=f+(v[a+12>>2]<<3)|0;d=0;b:{c:{while(1){d:{if(f>>>0>=h>>>0){break d}u[b+52>>1]=0;jw(v[f>>2],v[f+4>>2],b,c,c,1,e);if(w[b+54|0]){break d}e:{if(!w[b+53|0]){break e}if(w[b+52|0]){d=1;if(v[b+24>>2]==1){break c}g=1;if(w[a+8|0]&2){break e}break c}g=1;if(!(t[a+8|0]&1)){break c}}f=f+8|0;continue}break}a=4;if(!g){break b}}a=3}v[b+44>>2]=a;if(d&1){break a}}v[b+20>>2]=c;v[b+40>>2]=v[b+40>>2]+1;if(v[b+36>>2]!=1|v[b+24>>2]!=2){break a}t[b+54|0]=1;return}g=v[a+12>>2];h=a+16|0;Kr(v[h>>2],v[a+20>>2],b,c,d,e);f=a+24|0;g=h+(g<<3)|0;if(f>>>0>=g>>>0){break a}a=v[a+8>>2];if(!(!(a&2)&v[b+36>>2]!=1)){while(1){if(w[b+54|0]){break a}Kr(v[f>>2],v[f+4>>2],b,c,d,e);f=f+8|0;if(g>>>0>f>>>0){continue}break}break a}if(!(a&1)){while(1){if(w[b+54|0]|v[b+36>>2]==1){break a}Kr(v[f>>2],v[f+4>>2],b,c,d,e);f=f+8|0;if(g>>>0>f>>>0){continue}break a}}while(1){if(w[b+54|0]|v[b+36>>2]==1&v[b+24>>2]==1){break a}Kr(v[f>>2],v[f+4>>2],b,c,d,e);f=f+8|0;if(g>>>0>f>>>0){continue}break}}}function Dr(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0;a:{e=kb-96|0;kb=e;i=v[c>>2];g=kb-32|0;kb=g;f=e- -64|0;j=Nb(f+16|0);v[f>>2]=v[c>>2];v[f+4>>2]=v[c+4>>2];v[f+8>>2]=v[c+8>>2];v[f+12>>2]=v[c+12>>2];v[23540]=0;c=Q(3,g|0,c+16|0)|0;h=v[23540];v[23540]=0;b:{c:{d:{if((h|0)!=1){v[23540]=0;R(71,g+16|0,c|0);h=v[23540];v[23540]=0;if((h|0)==1){break d}f=g+16|0;Jb(j,f);Ab(f);Ab(c);kb=g+32|0;break b}a=P()|0;O()|0;break c}a=P()|0;O()|0;Ab(c)}Pj(f);T(a|0);L()}v[23540]=0;U(d|0,e|0,b|0,(i&2?16:10)|0);b=v[23540];v[23540]=0;e:{f:{g:{h:{i:{j:{if((b|0)!=1){d=e+16|0;c=kb-16|0;kb=c;k:{if(!(v[e+64>>2]&32)){break k}b=Tj(e);v[c+8>>2]=b;f=wv(e);while(1){if(!Pb(b,f)){break k}g=w[b|0];if((g-97&255)>>>0<=25){t[b|0]=g-32}b=v[Ke(c+8|0)>>2];continue}}ad(d,e);kb=c+16|0;v[23540]=0;X(82,e+32|0,d|0,v[e+64>>2],v[e+68>>2]);b=v[23540];v[23540]=0;if((b|0)==1){break j}v[23540]=0;U(83,e+48|0,e+32|0,e- -64|0);b=v[23540];v[23540]=0;if((b|0)==1){break i}v[23540]=0;R(71,a|0,e+48|0);a=v[23540];v[23540]=0;if((a|0)==1){break h}Ab(e+48|0);Ab(e+32|0);Ab(e+16|0);Ab(e);Pj(e- -64|0);kb=e+96|0;break a}a=P()|0;O()|0;break e}a=P()|0;O()|0;break f}a=P()|0;O()|0;break g}a=P()|0;O()|0;Ab(e+48|0)}Ab(e+32|0)}Ab(e+16|0);Ab(e)}Pj(e- -64|0);T(a|0);L()}}function vca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=kb-16|0;kb=f;q=v[a+16>>2];r=kg(b+327720|0,v[b+20>>2],(v[a+88>>2]&16384)>>>14|0);n=v[a+128>>2];a:{if(!n){l=v[a+8>>2];m=v[a+12>>2];e=v[a>>2];b=v[a+4>>2];h=0;break a}l=v[a+8>>2];m=v[a+12>>2];o=lg(l,m,n);p=nb;h=v[a+76>>2];e=v[a>>2];b=v[a+4>>2];Qf(e,b,qf(l,m,d),nb);h=h>>>0<nb>>>0?d:0}g=a+112|0;i=v[a+40>>2];j=v[a+36>>2];v[f>>2]=e;v[f+4>>2]=b;b:while(1){if(d){d=d-1|0;v[f+8>>2]=e;v[f+12>>2]=0;h=h-1|0;o=h?o:0;p=h?p:0;e=((((b&2147483647)<<1|e>>>31)&2147483646)<<1)+q|0;b=n;while(1)if((b|0)<=0){Rb(g,v[a+120>>2],v[a+124>>2]);b=v[a+116>>2];if(b){k=(v[f+12>>2]&2147483647)<<1|v[f+8>>2]>>>31;Sd(g,(u[(k<<1|2)+e>>1]+u[e+((k&2147483646)<<1)>>1]|0)/8<<16>>16);Rd(g,b);v[g>>2]=v[g>>2];v[g+4>>2]=0}b=v[a+32>>2];j=v[a+28>>2]+j|0;e=jg(g,r);v[c>>2]=B(j>>12,e)+v[c>>2];i=b+i|0;v[c+4>>2]=v[c+4>>2]+B(e,i>>12);Rb(f,l,m);c=c+8|0;e=v[f>>2];b=v[f+4>>2];continue b}else{k=(v[f+12>>2]&2147483647)<<1|v[f+8>>2]>>>31;Sd(g,(u[(k<<1|2)+e>>1]+u[e+((k&2147483646)<<1)>>1]|0)/8<<16>>16);Rd(g,4);Rb(f+8|0,o,p);b=b-1|0;continue}}break}v[a>>2]=e;v[a+4>>2]=b;v[a+40>>2]=i;v[a+20>>2]=j>>12;v[a+36>>2]=j;v[a+24>>2]=i>>12;kb=f+16|0}function u3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=kb+-64|0;kb=c;d=v[a>>2];a=v[d>>2];e=v[a+4>>2];v[c+40>>2]=v[a+20>>2];f=v[a+16>>2];v[c+32>>2]=v[a+12>>2];v[c+36>>2]=f;Hf(c+48|0,c+32|0,e);a=v[d+4>>2];e=v[a+8>>2];f=v[a+4>>2];d=v[c+60>>2];v[c+24>>2]=v[c+56>>2];v[c+28>>2]=d;d=v[c+52>>2];v[c+16>>2]=v[c+48>>2];v[c+20>>2]=d;v[c+8>>2]=v[a+8>>2];d=v[a+4>>2];v[c>>2]=v[a>>2];v[c+4>>2]=d;a=kb-32|0;kb=a;a:{b:{c:{d:{g=v[c+4>>2];if(f>>>0<=g>>>0){if(f>>>0>y[c+20>>2]){break d}if(y[c+8>>2]<e>>>0){break c}h=v[c+28>>2];if(v[c+24>>2]-h>>>0<e>>>0){break b}k=b+12|0;l=v[c+16>>2];m=v[c>>2];b=0;e:while(1){if((b|0)==(e|0)){break a}n=b+h|0;o=B(b,g);d=0;while(1)if((d|0)==(f|0)){b=b+1|0;continue e}else{r=a,s=+(Jm(ve(ng(A[(d+o<<3)+m>>3])*134217728))+ld(vs(k),21)|0)*7.450580596923828e-9,A[r+24>>3]=s;v[a+16>>2]=0;v[a+20>>2]=-1074790400;v[a+8>>2]=0;v[a+12>>2]=1072693248;p=n<<1;q=(d<<2)+l|0;i=ve(A[Gg(a+24|0,a+16|0,a+8|0)>>3]*32768);f:{if(D(i)<2147483648){j=~~i;break f}j=-2147483648}r=v[q>>2]+p|0,t=ed(j),u[r>>1]=t;d=d+1|0;continue}}}aa(7192,9074,77,8754);L()}aa(7157,9074,78,8754);L()}aa(5900,9074,79,8754);L()}aa(5870,9074,80,8754);L()}kb=a+32|0;kb=c- -64|0}function bda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,w=0,x=0,y=0,z=0;f=kb-16|0;kb=f;a:{b:{c:{g=v[a+12>>2];i=v[a+8>>2];d:{if((g|0)<=1&i>>>0<=805306368|(g|0)<=0){if((g|0)>=-2&i>>>0>=3489660928|(g|0)>-2){break c}if((g|0)==-2&i>>>0>2147483647|g>>>0>4294967294){break d}break b}if((g|0)==1&i>>>0>2147483648|g>>>0>1){break b}}b=b+196648|0;break a}b=b+131112|0;break a}b=b+262184|0}l=v[a+16>>2];j=v[a+40>>2];k=v[a+36>>2];e=v[a+4>>2];v[f+8>>2]=v[a>>2];v[f+12>>2]=e;m=v[a+32>>2];n=v[a+28>>2];while(1){if(d){h=v[f+8>>2];o=(((v[f+12>>2]&2147483647)<<1|h>>>31)&-2)+l|0;e=(h>>>16&65520)+b|0;p=u[e+14>>1];q=u[e+12>>1];r=u[e+10>>1];s=u[e+8>>1];w=u[e+6>>1];x=u[e+4>>1];y=u[e+2>>1];z=u[e>>1];h=0;while(1){if((h|0)!=2){e=h+o|0;v[(h<<2)+f>>2]=(((((((B(t[e-4|0],y)+B(t[e-6|0],z)|0)+B(t[e-2|0],x)|0)+B(t[e|0],w)|0)+B(t[e+2|0],s)|0)+B(t[e+4|0],r)|0)+B(t[e+6|0],q)|0)+B(t[e+8|0],p)<<8)/32768;h=h+1|0;continue}break}k=k+n|0;v[c>>2]=v[c>>2]+B(v[f>>2],k>>12);j=j+m|0;v[c+4>>2]=v[c+4>>2]+B(v[f+4>>2],j>>12);Rb(f+8|0,i,g);c=c+8|0;d=d-1|0;continue}break}b=v[f+12>>2];v[a>>2]=v[f+8>>2];v[a+4>>2]=b;v[a+40>>2]=j;v[a+20>>2]=k>>12;v[a+36>>2]=k;v[a+24>>2]=j>>12;kb=f+16|0}function l3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=kb+-64|0;kb=c;d=v[a>>2];a=v[d>>2];e=v[a+4>>2];v[c+40>>2]=v[a+20>>2];f=v[a+16>>2];v[c+32>>2]=v[a+12>>2];v[c+36>>2]=f;Hf(c+48|0,c+32|0,e);a=v[d+4>>2];e=v[a+8>>2];f=v[a+4>>2];d=v[c+60>>2];v[c+24>>2]=v[c+56>>2];v[c+28>>2]=d;d=v[c+52>>2];v[c+16>>2]=v[c+48>>2];v[c+20>>2]=d;v[c+8>>2]=v[a+8>>2];d=v[a+4>>2];v[c>>2]=v[a>>2];v[c+4>>2]=d;a=kb-32|0;kb=a;a:{b:{c:{d:{g=v[c+4>>2];if(f>>>0<=g>>>0){h=v[c+20>>2];if(f>>>0>h>>>0){break d}if(y[c+8>>2]<e>>>0){break c}i=v[c+28>>2];if(v[c+24>>2]-i>>>0<e>>>0){break b}l=b+12|0;m=v[c+16>>2];n=v[c>>2];b=0;e:while(1){if((b|0)==(e|0)){break a}o=B(b,g);p=B(b+i|0,h);d=0;while(1)if((d|0)==(f|0)){b=b+1|0;continue e}else{r=a,s=+(Jm(ve(ng(A[(d+o<<3)+n>>3])*134217728))+ld(vs(l),21)|0)*7.450580596923828e-9,A[r+24>>3]=s;v[a+16>>2]=0;v[a+20>>2]=-1074790400;v[a+8>>2]=0;v[a+12>>2]=1072693248;q=(d+p<<1)+m|0;j=ve(A[Gg(a+24|0,a+16|0,a+8|0)>>3]*32768);f:{if(D(j)<2147483648){k=~~j;break f}k=-2147483648}r=q,t=ed(k),u[r>>1]=t;d=d+1|0;continue}}}aa(7192,9074,77,8754);L()}aa(7157,9074,78,8754);L()}aa(5900,9074,79,8754);L()}aa(5870,9074,80,8754);L()}kb=a+32|0;kb=c- -64|0}function rf(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;c=kb-96|0;kb=c;d=v[a+36>>2];Rl(v[v[d>>2]-12>>2]+d|0,0);d=a+32|0;Sc(c+56|0,d,4);if(!Cb(v[v[c+56>>2]>>2],v[c+60>>2])){Xv(a)}a:{if(!v[a+8>>2]){break a}Sc(c+56|0,d,6);if(Cb(v[v[c+56>>2]>>2],v[c+60>>2])){break a}Sc(c+88|0,d,7);if(Cb(v[v[c+88>>2]>>2],v[c+92>>2])){break a}h=v[a+36>>2];e=v[a+92>>2];g=B(v[a+28>>2],v[a+8>>2]);f=g+v[a+88>>2]|0;e=Xg(c+72|0,f,f>>>0<g>>>0?e+1|0:e);f=v[e+12>>2];v[c+32>>2]=v[e+8>>2];v[c+36>>2]=f;f=v[e+4>>2];v[c+24>>2]=v[e>>2];v[c+28>>2]=f;Zj(h,c+24|0)}Sc(c+56|0,d,5);e=0;b:{if(!Cb(v[v[c+56>>2]>>2],v[c+60>>2])){break b}f=Pi(v[a+52>>2],v[a+56>>2]);d=0;while(1){if((d|0)==(f|0)){break b}h=(v[a+108>>2]+d>>>0)%(f>>>0)|0;i=lf(v[a+52>>2],h);g=v[i>>2];c:{j=v[a+40>>2];if(fd(j,v[a+44>>2])>>>0<=g>>>0){break c}g=Lk(c+56|0,Lb(j,g),x[i+20>>1]);i=dw(b,g);Xb(g);if(!i){break c}v[a+108>>2]=(h+1>>>0)%(f>>>0);e=lf(v[a+52>>2],h);d=e;b=v[d+12>>2];d=v[d+8>>2];if(!(b|d)){break b}e=v[a+36>>2];b=v[a+20>>2]+b|0;f=v[a+16>>2];d=f+d|0;b=Xg(c+40|0,d,d>>>0<f>>>0?b+1|0:b);d=v[b+12>>2];v[c+16>>2]=v[b+8>>2];v[c+20>>2]=d;d=v[b+4>>2];v[c+8>>2]=v[b>>2];v[c+12>>2]=d;Zj(e,c+8|0);e=lf(v[a+52>>2],h);break b}d=d+1|0;continue}}kb=c+96|0;return e}function Fja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=kb-288|0;kb=f;$f(b);a:{if(!Qb(v[a>>2],v[a+8>>2],1)){break a}while(1){d=f+32|0;un(f+8|0,d,Bq(d));k=v[a>>2];g=v[a+8>>2];d=kb-32|0;kb=d;_g(d+16|0,v[f+8>>2],v[f+12>>2]);e=v[v[k>>2]+28>>2];l=v[d+20>>2];v[d+8>>2]=v[d+16>>2];v[d+12>>2]=l;ob[e|0](d+24|0,k,g,d+8|0);_g(f+16|0,v[d+24>>2],v[d+28>>2]);kb=d+32|0;v[f+28>>2]=v[f+20>>2];o=f,p=c-Hb(b)|0,v[o+4>>2]=p;d=v[Kb(f+28|0,f+4|0)>>2];if(!d){break a}t[f+16|0]=0;k=f+32|0;m=k+d|0;d=f+16|0;l=zi(k,m,d);o=f,p=yh(b),v[o+16>>2]=p;e=v[kj(f,d)>>2];g=kb-32|0;kb=g;v[g+24>>2]=e;o=g,p=he(b),v[o+8>>2]=p;h=Pn(g+24|0,g+8|0);b:{c:{d=k;i=Th(d,l);if(!i){break c}if(!Xs(b,d)){e=Hb(b);j=bd(b);d:{if(i>>>0<=j-e>>>0){j=Ac(b);if((e|0)==(h|0)){break d}n=h+j|0;Yh(i+n|0,n,e-h|0);break d}rm(b,j,(e+i|0)-j|0,e,h,0,i);j=v[b>>2]}e=e+i|0;Sh(b,e);t[g+8|0]=0;we(e+j|0,g+8|0);e=h+j|0;while(1){if((d|0)==(l|0)){break c}we(e,d);d=d+1|0;e=e+1|0;continue}}d=Vh(g+8|0,d,l);h=Mc(d);i=Hb(d);v[23540]=0;fa(356,b|0,e|0,h|0,h+i|0)|0;e=v[23540];v[23540]=0;if((e|0)!=1){zb(d);break b}a=P()|0;O()|0;zb(d);T(a|0);L()}he(b)}kb=g+32|0;$b(a,l-k|0);if(l>>>0>=m>>>0){continue}break}$b(a,1)}kb=f+288|0}function OF(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;a=kb-16|0;kb=a;v[a+12>>2]=c;v[a+8>>2]=f;v[a+12>>2]=c;v[a+8>>2]=f;a:{b:{while(1){j=v[a+12>>2];if(!(j>>>0>=d>>>0|f>>>0>=g>>>0)){i=t[j|0];c=i&255;c:{if((i|0)>=0){i=1;break c}b=2;if(i>>>0<4294967234){break a}if(i>>>0<=4294967263){if((d-j|0)<2){break b}i=w[j+1|0];if((i&192)!=128){break a}c=i&63|c<<6&1984;i=2;break c}if(i>>>0<=4294967279){if((d-j|0)<3){break b}k=w[j+2|0];i=w[j+1|0];d:{e:{if((c|0)!=237){if((c|0)!=224){break e}if((i&224)==160){break d}break a}if((i&224)==128){break d}break a}if((i&192)!=128){break a}}if((k&192)!=128){break a}c=k&63|(c<<12&61440|(i&63)<<6);i=3;break c}if(i>>>0>4294967284){break a}if((d-j|0)<4){break b}l=w[j+3|0];m=w[j+2|0];k=w[j+1|0];f:{g:{switch(c-240|0){case 0:if((k+112&255)>>>0<48){break f}break a;case 4:if((k&240)==128){break f}break a;default:break g}}if((k&192)!=128){break a}}if((m&192)!=128|(l&192)!=128){break a}i=4;c=l&63|(m<<6&4032|(c<<18&1835008|(k&63)<<12));if(c>>>0>1114111){break a}}v[f>>2]=c;v[a+12>>2]=i+j;f=v[a+8>>2]+4|0;v[a+8>>2]=f;continue}break}b=d>>>0>j>>>0;break a}b=1}v[e>>2]=v[a+12>>2];v[h>>2]=v[a+8>>2];kb=a+16|0;return b|0}function J7(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=C(0),q=C(0),r=0,s=0,t=0,u=C(0),w=0;i=kb-16|0;kb=i;a:{if(!bi(a+44|0)){break a}n=v[a+44>>2];j=Jc(n,0);k=Jc(n,1);n=v[a+56>>2];t=Jc(n,0);n=Jc(n,1);u=z[Eb(a+4208|0,1)>>2];v[i+12>>2]=d;s=v[a+4220>>2];q=C(C(1)/C(s>>>0));w=v[a+4216>>2];o=d;f=n;g=t;while(1){if(!o){ti(a,b,c,t,n,d);break a}h=v[a+4224>>2];b:{if(s>>>0>h>>>0){v[i+8>>2]=s-h;r=v[Kb(i+12|0,i+8|0)>>2];m=0;c:{if(u<C(1)){l=h+r|0;e=h>>>0>l>>>0?h:l;while(1){if((h|0)==(e|0)){break c}p=C(h>>>0);z[g>>2]=q*C(z[j>>2]*p);z[f>>2]=q*C(z[k>>2]*p);h=h+1|0;f=f+4|0;k=k+4|0;g=g+4|0;j=j+4|0;continue}}while(1){if((m|0)!=(r|0)){z[g>>2]=z[j>>2];z[f>>2]=z[k>>2];m=m+1|0;f=f+4|0;k=k+4|0;g=g+4|0;j=j+4|0;continue}break}l=h+r|0}o=o-r|0;v[i+12>>2]=o;break b}m=w-h|0;v[i+4>>2]=m;l=v[Kb(i+12|0,i+4|0)>>2];e=0;d:{if(u<C(1)){e=m-l|0;while(1){if(e>>>0>=m>>>0){break d}p=C(m>>>0);z[g>>2]=q*C(z[j>>2]*p);z[f>>2]=q*C(z[k>>2]*p);m=m-1|0;f=f+4|0;k=k+4|0;g=g+4|0;j=j+4|0;continue}}while(1){if((e|0)!=(l|0)){v[g>>2]=0;v[f>>2]=0;e=e+1|0;f=f+4|0;g=g+4|0;continue}break}e=l<<2;k=e+k|0;j=j+e|0}o=o-l|0;v[i+12>>2]=o;e=h+l|0;l=e>>>0<w>>>0?e:0}v[a+4224>>2]=l;continue}}kb=i+16|0}function fba(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;l=kb-16|0;kb=l;v[l+8>>2]=b;q=xf(a);while(1){if(Hg(b,c)){b=v[fc(l,q)>>2];k=vd(v[l+8>>2]);o=kb-16|0;kb=o;p=0;m=kb-16|0;kb=m;i=kb-32|0;kb=i;g=i+28|0;d=i+24|0;e=kb-16|0;kb=e;a:{b:{if(!pc(b,v[fc(e+8|0,Zf(a))>>2])){f=w[k|0];j=v[k+4>>2];h=vd(b);n=w[h|0];h=v[h+4>>2];if(!Sn(f,j,n,h)){break b}}v[e+8>>2]=b;f=fc(e,Fb(v[a>>2]));c:{d=v[e+8>>2];if(!pc(d,v[f>>2])){d=v[lz(e+8|0)>>2];f=vd(d);h=w[f|0];n=v[f+4>>2];f=w[k|0];j=v[k+4>>2];if(!Sn(h,n,f,j)){break c}}if(!v[b>>2]){v[g>>2]=b;break a}v[g>>2]=d;b=d+4|0;break a}b=Jy(a,g,f,j);break a}if(Sn(n,h,f,j)){d:{d=jz(b);if(!pc(d,v[fc(e+8|0,Zf(a))>>2])){f=w[k|0];j=v[k+4>>2];h=vd(d);if(!Sn(f,j,w[h|0],v[h+4>>2])){break d}}if(!v[b+4>>2]){v[g>>2]=b;b=b+4|0;break a}v[g>>2]=d;b=d;break a}b=Jy(a,g,f,j);break a}v[g>>2]=b;v[d>>2]=b;b=d}kb=e+16|0;d=b;b=v[b>>2];if(!b){b=kb-16|0;kb=b;e=jc(a);g=i+8|0;e=lh(g,vc(28),mh(b+8|0,e));Vz(v[e>>2]+16|0,k);r=jc(e),s=1,t[r+4|0]=s;kb=b+16|0;Jg(a,v[i+28>>2],d,v[i+8>>2]);b=ce(g);rk(g);p=1}Ig(m+8|0,v[fc(i+8|0,b)>>2],p);kb=i+32|0;kb=m+16|0;fc(o+8|0,v[m+8>>2]);kb=o+16|0;b=v[Kg(l+8|0)>>2];continue}else{kb=l+16|0}break}}function Xga(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=kb-16|0;kb=e;nd(b,0);No(b);f=w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24);a:{if(c&34){if(d){v[b+24>>2]=f;break a}g=b,h=Qe(oi(+(f+1408|0)/1536)*8363),v[g+24>>2]=h;break a}t[b+37|0]=(c|0)==16?f:f^128;t[b+36|0]=w[a+4|0]}t[e+15|0]=w[a+5|0];t[e+14|0]=64;g=b,h=w[Yb(e+15|0,e+14|0)|0]<<2,u[g+30>>1]=h;d=w[a+6|0]|w[a+7|0]<<8;if(d>>>0<=256){u[b+28>>1]=d;u[b+34>>1]=x[b+34>>1]|32}v[b>>2]=w[a+8|0]|w[a+9|0]<<8|(w[a+10|0]<<16|w[a+11|0]<<24);v[b+4>>2]=w[a+12|0]|w[a+13|0]<<8|(w[a+14|0]<<16|w[a+15|0]<<24);v[b+8>>2]=w[a+16|0]|w[a+17|0]<<8|(w[a+18|0]<<16|w[a+19|0]<<24);d=w[a+20|0]|w[a+21|0]<<8;if(d&16){u[b+34>>1]=x[b+34>>1]|2;d=w[a+20|0]|w[a+21|0]<<8}if(d&32){u[b+34>>1]=x[b+34>>1]|4;d=w[a+20|0]|w[a+21|0]<<8}if(d&256){u[b+34>>1]=x[b+34>>1]|8;d=w[a+20|0]|w[a+21|0]<<8}if(d&512){u[b+34>>1]=x[b+34>>1]|16}t[b+38|0]=w[(w[a+22|0]&7)+39760|0];t[b+39|0]=w[a+23|0];t[b+40|0]=w[a+24|0];t[b+41|0]=w[a+25|0];if((c|0)==32){t[e+13|0]=w[a+26|0];t[e+12|0]=64;g=b,h=w[Yb(e+13|0,e+12|0)|0],u[g+32>>1]=h}v[b+12>>2]=w[a+27|0]|w[a+28|0]<<8|(w[a+29|0]<<16|w[a+30|0]<<24);v[b+16>>2]=w[a+31|0]|w[a+32|0]<<8|(w[a+33|0]<<16|w[a+34|0]<<24);kb=e+16|0}function yQ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=v[a>>2];e=zh(c,v[a+4>>2]);if(e>>>0<b>>>0){g=kb-32|0;kb=g;f=b-e|0;b=v[Gb(a)>>2];c=v[a+4>>2];a:{if(f>>>0<=b-c>>8>>>0){b=kb-16|0;kb=b;v[b>>2]=a;a=v[a+4>>2];v[b+4>>2]=a;v[b+8>>2]=a+(f<<8);a=v[b+4>>2];e=v[b+8>>2];while(1){if((a|0)==(e|0)){lc(b);kb=b+16|0}else{hQ(a);a=a+256|0;v[b+4>>2]=a;continue}break}break a}i=Gb(a);b=g+8|0;e=a;h=zh(v[a>>2],c)+f|0;c=kb-16|0;kb=c;v[c+12>>2]=h;d=kb-16|0;kb=d;v[d+12>>2]=16777215;v[d+8>>2]=2147483647;a=v[Kb(d+12|0,d+8|0)>>2];kb=d+16|0;b:{if(a>>>0>=h>>>0){d=Uz(e);if(d>>>0<a>>>1>>>0){v[c+8>>2]=d<<1;a=v[_c(c+8|0,c+12|0)>>2]}kb=c+16|0;break b}cd();L()}d=zh(v[e>>2],v[e+4>>2]);pg(b+12|0,i);if(a){if(a>>>0>=16777216){Lg();L()}c=vc(a<<8)}else{c=0}v[b>>2]=c;d=c+(d<<8)|0;v[b+8>>2]=d;v[b+4>>2]=d;j=Cc(b),k=c+(a<<8)|0,v[j>>2]=k;a=kb-16|0;kb=a;v[a>>2]=v[b+8>>2];c=v[b+8>>2];v[a+8>>2]=b+8;v[a+4>>2]=c+(f<<8);c=v[a>>2];while(1){if(v[a+4>>2]!=(c|0)){hQ(c);c=v[a>>2]+256|0;v[a>>2]=c;continue}break}Ud(a);kb=a+16|0;Fd(e,b);e=v[b+4>>2];a=v[b+8>>2];while(1){if((a|0)!=(e|0)){a=a-256|0;v[b+8>>2]=a;continue}break}a=v[b>>2];if(a){Cc(b);Mb(a)}}kb=g+32|0;return}if(b>>>0<e>>>0){Od(a,c+(b<<8)|0)}}function Xaa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;i=kb-16|0;kb=i;e=v[b+1298304>>2];if(!zd(e)){d=kb-16|0;kb=d;c=vc(12);v[23540]=0;e=S(907,c|0)|0;f=v[23540];v[23540]=0;a:{if((f|0)!=1){c=v[Lf(d+8|0,e)>>2];kb=d+16|0;break a}a=P()|0;O()|0;Mb(c);T(a|0);L()}v[i+8>>2]=c;c=b+1298304|0;d=i+8|0;VM(c,ce(d));Cy(d);e=v[c>>2]}f=kb-48|0;kb=f;c=f+16|0;JM(c,a);v[23540]=0;U(8,f+32|0,0,c|0);c=v[23540];v[23540]=0;b:{c:{if((c|0)!=1){Ab(f+16|0);m=f,n=Fb(v[e>>2]),v[m+8>>2]=n;l=Fb(v[e+4>>2]);c=0;e=0;d:{while(1){e:{h=v[f+8>>2];if(!Pb(h,l)){if(!e){break e}c=v[e+4>>2];if(!c){break e}v[23540]=0;W(c|0,e|0,b|0,a|0)|0;a=v[23540];v[23540]=0;if((a|0)!=1){break e}break d}j=0;d=v[h>>2];if(v[d+32>>2]==v[a+16>>2]){j=v[d+36>>2]==v[a+20>>2]}v[23540]=0;R(908,f+16|0,d+8|0);d=v[23540];v[23540]=0;if((d|0)==1){break d}g=kb-16|0;kb=g;k=f+16|0;Fe(g+8|0,k);Fe(g,f+32|0);d=RM(v[g+8>>2],v[g+12>>2],v[g>>2],v[g+4>>2]);kb=g+16|0;zb(k);f:{if(!(!j|(d|0)!=0)){e=v[h>>2];c=3;break f}if((c|0)<2&j){e=v[h>>2];c=2;break f}d=!d&(c|0)<=0;e=d?v[h>>2]:e;c=d?1:c}Le(f+8|0);continue}break}zb(f+32|0);kb=f+48|0;break b}e=P()|0;O()|0;zb(f+32|0);break c}e=P()|0;O()|0;Ab(f+16|0)}T(e|0);L()}kb=i+16|0}function CW(a,b){a=a|0;b=b|0;var c=0,d=0;d=kb-32|0;kb=d;if(!Sb(a,13672,4)){nd(b,32);No(b);$h(d,1,a+4|0);c=d+16|0;Fc(c,d);Be(b+43|0,c);zb(c);u[b+30>>1]=w[a+19|0]<<2;Ef(b+30|0,256);u[b+32>>1]=w[a+17|0];Ef(b+32|0,64);u[b+28>>1]=(w[a+47|0]&127)<<2;Ef(b+28|0,256);if(t[a+47|0]<0){u[b+34>>1]=x[b+34>>1]|32}c=w[a+18|0];if(c&16){u[b+34>>1]=x[b+34>>1]|2;c=w[a+18|0]}if(c&32){u[b+34>>1]=x[b+34>>1]|8;c=w[a+18|0]}if(c&64){u[b+34>>1]=x[b+34>>1]|4;c=w[a+18|0]}if(c<<24>>24<0){u[b+34>>1]=x[b+34>>1]|16}c=w[a+60|0]|w[a+61|0]<<8|(w[a+62|0]<<16|w[a+63|0]<<24);v[b+24>>2]=c?c>>>0>256?c:256:8363;v[b>>2]=w[a+48|0]|w[a+49|0]<<8|(w[a+50|0]<<16|w[a+51|0]<<24);v[b+4>>2]=w[a+52|0]|w[a+53|0]<<8|(w[a+54|0]<<16|w[a+55|0]<<24);v[b+8>>2]=w[a+56|0]|w[a+57|0]<<8|(w[a+58|0]<<16|w[a+59|0]<<24);v[b+12>>2]=w[a+64|0]|w[a+65|0]<<8|(w[a+66|0]<<16|w[a+67|0]<<24);v[b+16>>2]=w[a+68|0]|w[a+69|0]<<8|(w[a+70|0]<<16|w[a+71|0]<<24);Dk(b);t[b+38|0]=w[(w[a+79|0]&7)+39760|0];t[b+41|0]=w[a+76|0];t[b+40|0]=w[a+77|0]&127;t[b+39|0]=w[a+78|0];c=w[a+46|0];a:{if((c|0)==64){c=512}else{if((c|0)!=128){break a}c=16384}u[b+34>>1]=c|x[b+34>>1]}c=w[a+72|0]|w[a+73|0]<<8|(w[a+74|0]<<16|w[a+75|0]<<24)}kb=d+32|0;return c|0}function LG(a,b,c,d,e){var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;l=kb-16|0;kb=l;f=w[a|0];a:{if(!f){g=a;break a}g=a;b:{while(1){if(!Vk(f<<24>>24)){break b}f=w[g+1|0];g=g+1|0;if(f){continue}break}break a}c:{f=f&255;switch(f-43|0){case 0:case 2:break c;default:break a}}m=(f|0)==45?-1:0;g=g+1|0}d:{if(!((c|16)!=16|w[g|0]!=48)){o=1;if((w[g+1|0]&223)==88){g=g+2|0;j=16;break d}g=g+1|0;j=c?c:8;break d}j=c?c:10}p=j>>31;c=0;while(1){e:{f=-48;i=t[g|0];f:{if((i-48&255)>>>0<10){break f}f=-87;if((i-97&255)>>>0<26){break f}f=-55;if((i-65&255)>>>0>25){break e}}i=f+i|0;if((i|0)>=(j|0)){break e}vf(l,j,p,0,0,k,h,0,0);f=1;g:{if(v[l+8>>2]|v[l+12>>2]){break g}q=Jka(k,h,j,p);n=nb;r=i>>31;s=r^-1;if((n|0)==(s|0)&(i^-1)>>>0<q>>>0|n>>>0>s>>>0){break g}h=n+r|0;f=i+q|0;h=f>>>0<i>>>0?h+1|0:h;k=f;o=1;f=c}g=g+1|0;c=f;continue}break}if(b){v[b>>2]=o?g:a}h:{i:{j:{if(c){v[116016]=68;a=d&1;m=a?0:m;k=d;h=e;break j}if((e|0)==(h|0)&d>>>0>k>>>0|e>>>0>h>>>0){break i}a=d&1}if(!(a|m)){v[116016]=68;a=d;d=a-1|0;e=e-!a|0;break h}if((e|0)==(h|0)&d>>>0>=k>>>0|e>>>0>h>>>0){break i}v[116016]=68;break h}a=m;b=a^k;d=b-a|0;c=a>>31;e=(c^h)-((a>>>0>b>>>0)+c|0)|0}kb=l+16|0;nb=e;return d}function xea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;k=kb-48|0;kb=k;if(Af(v[b>>2],v[b+4>>2])>>>0>c>>>0){while(1){i=m&65535;if(i>>>0<=c>>>0){g=bg(v[b>>2],i);e=v[g>>2];if(Pb(e,v[g+4>>2])){n=k+24|0;e=Fb(e);o=Fb(v[bg(v[b>>2],i)+4>>2]);f=ZP(k,d);l=kb-16|0;kb=l;v[l+8>>2]=e;while(1){if(Pb(e,o)){j=kb-16|0;kb=j;if(!(w[e+5|0]|w[e+3|0]!=4)){g=j+8|0;Db(g,v[f>>2],x[f+14>>1]);Ze(g,0);t[e+3|0]=0}h=w[e+2|0];if(!(w[e+4|0]|(h|0)!=11)){g=j+8|0;Db(g,v[f>>2],x[f+14>>1]);Ze(g,0);t[e+2|0]=0;h=0}a:{b:{if(!w[e|0]){Db(j+8|0,v[f>>2],x[f+14>>1]);if(Cb(v[v[j+8>>2]>>2],v[j+12>>2])){break b}h=w[e+2|0]}i=w[e+3|0];g=j+8|0;Db(g,v[f>>2],x[f+14>>1]);Ze(g,(i|0)==4|(h|0)==11);h=w[e+3|0];break a}h=w[e+3|0];g=w[e+2|0];if(!(h|(g|0)==11)){t[e+5|0]=0;h=4;t[e+3|0]=4;break a}if(g|(h|0)==4){break a}t[e+4|0]=0;t[e+2|0]=11}c:{d:{e:{if(!(!w[f+16|0]|h)){t[e+3|0]=17;i=0;h=125;break e}i=0;f:{switch(h-16|0){case 1:break d;case 0:break f;default:break c}}if(w[e+5|0]){break c}i=1;h=6}t[e+5|0]=h}t[f+16|0]=i}u[f+14>>1]=(x[f+14>>1]+1>>>0)%x[f+12>>1];kb=j+16|0;e=v[Ck(l+8|0)>>2];continue}break}WP(n,f);kb=l+16|0;We(n);We(f)}m=m+1|0;continue}break}}WP(a,d);kb=k+48|0}function e4(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;b=kb-2144|0;kb=b;Ub(b+96|0,0,2048);a:{b:{c:{f=v[c+4>>2];if(!f){a=ba(8)|0;v[23540]=0;b=Q(55,b+80|0,10472)|0;c=v[23540];v[23540]=0;if((c|0)==1){break c}a=tc(a,b);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break a}c=P()|0;O()|0;zb(b);break b}g=v[c>>2];d=v[c+12>>2];c=v[c+8>>2];v[b+72>>2]=c;v[b+76>>2]=d;e=v[b+76>>2];v[b+24>>2]=v[b+72>>2];v[b+28>>2]=e;v[b+68>>2]=f;v[b+64>>2]=g;e=v[b+68>>2];v[b+16>>2]=v[b+64>>2];v[b+20>>2]=e;h=fJ(b+16|0);if(h){v[b+48>>2]=c;v[b+52>>2]=d;c=v[b+52>>2];v[b+8>>2]=v[b+48>>2];v[b+12>>2]=c;v[b+44>>2]=f;v[b+40>>2]=g;c=v[b+44>>2];v[b>>2]=v[b+40>>2];v[b+4>>2]=c;c=$I(b)}else{c=0}v[b+56>>2]=c;v[b+60>>2]=0;d=0;c=2048;while(1){if(c){e=ob[f|0](g,(b+96|0)+d|0,c)|0;c=c-e|0;d=d+e|0;if(e){continue}}break}c=a;a=hc(b+32|0,b+96|0,d);a=_s(c,v[a>>2],v[a+4>>2],h?b+56|0:0);if(a+1>>>0>=3){a=ba(8)|0;v[23540]=0;b=Q(55,b+80|0,8086)|0;c=v[23540];v[23540]=0;if((c|0)!=1){a=tc(a,b);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break a}c=P()|0;O()|0;zb(b);break b}c=P()|0;O()|0;ca(a|0);break b}kb=b+2144|0;return a|0}c=P()|0;O()|0;ca(a|0)}T(c|0)}L()}function Cd(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=kb+-64|0;kb=d;v[a+480180>>2]=b;b=zq(a);yq(d,b);e=v[d+12>>2];c=a+1074320|0;v[c>>2]=v[d+8>>2];v[c+4>>2]=e;c=v[d+4>>2];v[a+1074312>>2]=v[d>>2];v[a+1074316>>2]=c;$s(a+8|0,b);b=1;while(1){c=b&65535;if(c>>>0>x[a+480192>>1]){v[a+480184>>2]=0;v[a+480188>>2]=0;v[a+480236>>2]=65536;v[a+480228>>2]=48;v[a+480232>>2]=48;t[a+480268|0]=5;v[a+480260>>2]=16;v[a+480264>>2]=32767;v[a+480204>>2]=125e4;v[a+480208>>2]=0;v[a+480196>>2]=6;v[a+480200>>2]=256;v[a+1074304>>2]=0;v[a+1074308>>2]=0;u[a+480192>>1]=0;xy(a,4);e=kb+-64|0;kb=e;b=a+484344|0;bt(b);f=yk(v[b>>2],v[b+4>>2]);c=$x(e+8|0,b);v[23540]=0;U(814,b|0,f|0,c|0);b=v[23540];v[23540]=0;a:{if((b|0)!=1){gl(c);kb=e- -64|0;break a}a=P()|0;O()|0;gl(c);T(a|0);L()}jP(a+484360|0);$f(a+1298308|0);qA(a+1298320|0);$f(a+1298332|0);c=Ub(d,0,64);b=bN(c);d=Jb(a+1298344|0,b);Jb(d+12|0,b+12|0);Jb(d+24|0,b+24|0);Jb(d+36|0,b+36|0);Jb(d+48|0,b+48|0);v[d+60>>2]=v[b+60>>2];Dy(b);Lc(a+1298408|0);Lc(a+480248|0);if(v[a+480180>>2]&738230281){v[a+480208>>2]=v[a+480208>>2]|8388608}kb=c- -64|0;return}c=((c<<2)+a|0)+900380|0;e=v[c>>2];if(e){Mb(bu(e))}v[c>>2]=0;b=b+1|0;continue}}function Kca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0;h=kb-16|0;kb=h;f=v[a+48>>2];j=v[a+24>>2];k=v[a+20>>2];e=v[a+44>>2];l=v[a+16>>2];g=v[a+4>>2];v[h+8>>2]=v[a>>2];v[h+12>>2]=g;m=b+24|0;n=v[a+72>>2];b=v[a+68>>2];o=b;p=b>>31;b=v[a+64>>2];q=b;r=b>>31;b=v[a+60>>2];s=b;t=b>>31;w=v[a+8>>2];x=v[a+12>>2];while(1){b=e;if(d){e=Zb(b,-16777216,16776704);e=Jka(q,r,e,e>>31);g=nb;f=Zb(f,-16777216,16776704);i=Jka(o,p,f,f>>31);e=i+e|0;f=nb+g|0;f=e>>>0<i>>>0?f+1|0:f;y=e;e=(v[h+12>>2]<<1)+l|0;g=(((v[h+8>>2]>>>16|0)+4&131064)<<1)+m|0;g=(((((B(u[e+4>>1],u[g+10>>1])+B(u[e+2>>1],u[g+8>>1])|0)+B(u[e+6>>1],u[g+12>>1])|0)+B(u[e+8>>1],u[g+14>>1])|0)/2|0)+((((B(u[e-4>>1],u[g+2>>1])+B(u[e-6>>1],u[g>>1])|0)+B(u[e-2>>1],u[g+4>>1])|0)+B(u[e>>1],u[g+6>>1])|0)/2|0)|0)/16384<<8;e=g;i=Jka(e,e>>31,s,t);e=y+i|0;f=nb+f|0;f=e>>>0<i>>>0?f+1|0:f;e=e+8388608|0;f=e>>>0<8388608?f+1|0:f;f=Yc(e,f,24);e=(f|0)/256|0;v[c>>2]=B(e,k)+v[c>>2];v[c+4>>2]=v[c+4>>2]+B(e,j);Rb(h+8|0,w,x);e=f-(g&n)|0;c=c+8|0;d=d-1|0;f=b;continue}break}c=v[h+12>>2];v[a>>2]=v[h+8>>2];v[a+4>>2]=c;v[a+48>>2]=f;v[a+44>>2]=b;kb=h+16|0}function kda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,C=0;h=kb-16|0;kb=h;f=v[a+48>>2];i=v[a+40>>2];j=v[a+36>>2];e=v[a+44>>2];n=v[a+16>>2];b=v[a+4>>2];v[h+8>>2]=v[a>>2];v[h+12>>2]=b;o=v[a+32>>2];p=v[a+28>>2];q=v[a+72>>2];b=v[a+68>>2];r=b;s=b>>31;b=v[a+64>>2];t=b;w=b>>31;b=v[a+60>>2];x=b;y=b>>31;z=v[a+8>>2];A=v[a+12>>2];while(1){b=e;if(d){e=Zb(b,-16777216,16776704);e=Jka(t,w,e,e>>31);k=nb;C=e;e=(v[h+12>>2]<<1)+n|0;g=v[h+8>>2]>>>21&2040;l=(((B(u[e>>1],u[g+39778>>1])+B(u[e-2>>1],u[g+39776>>1])|0)+B(u[e+2>>1],u[g+39780>>1])|0)+B(u[e+4>>1],u[g+39782>>1])|0)/16384<<8;e=l;m=Jka(e,e>>31,x,y);g=C+m|0;e=nb+k|0;e=g>>>0<m>>>0?e+1|0:e;f=Zb(f,-16777216,16776704);k=Jka(r,s,f,f>>31);g=k+g|0;f=nb+e|0;f=g>>>0<k>>>0?f+1|0:f;e=g+8388608|0;f=e>>>0<8388608?f+1|0:f;f=Yc(e,f,24);e=(f|0)/256|0;j=j+p|0;v[c>>2]=B(e,j>>12)+v[c>>2];i=i+o|0;v[c+4>>2]=v[c+4>>2]+B(e,i>>12);Rb(h+8|0,z,A);e=f-(q&l)|0;c=c+8|0;d=d-1|0;f=b;continue}break}c=v[h+12>>2];v[a>>2]=v[h+8>>2];v[a+4>>2]=c;v[a+40>>2]=i;v[a+20>>2]=j>>12;v[a+36>>2]=j;v[a+48>>2]=f;v[a+44>>2]=b;v[a+24>>2]=i>>12;kb=h+16|0}function Lca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,w=0,x=0,y=0,z=0;h=kb-16|0;kb=h;f=v[a+48>>2];j=v[a+24>>2];k=v[a+20>>2];e=v[a+44>>2];l=v[a+16>>2];g=v[a+4>>2];v[h+8>>2]=v[a>>2];v[h+12>>2]=g;m=b+24|0;n=v[a+72>>2];b=v[a+68>>2];o=b;p=b>>31;b=v[a+64>>2];q=b;r=b>>31;b=v[a+60>>2];s=b;w=b>>31;x=v[a+8>>2];y=v[a+12>>2];while(1){b=e;if(d){e=Zb(b,-16777216,16776704);e=Jka(q,r,e,e>>31);g=nb;f=Zb(f,-16777216,16776704);i=Jka(o,p,f,f>>31);e=i+e|0;f=nb+g|0;f=e>>>0<i>>>0?f+1|0:f;z=e;e=v[h+12>>2]+l|0;g=(((v[h+8>>2]>>>16|0)+4&131064)<<1)+m|0;g=(((((B(t[e+2|0],u[g+10>>1])+B(t[e+1|0],u[g+8>>1])|0)+B(t[e+3|0],u[g+12>>1])|0)+B(t[e+4|0],u[g+14>>1])<<8)/2|0)+((((B(t[e-2|0],u[g+2>>1])+B(t[e-3|0],u[g>>1])|0)+B(t[e-1|0],u[g+4>>1])|0)+B(t[e|0],u[g+6>>1])<<8)/2|0)|0)/16384<<8;e=g;i=Jka(e,e>>31,s,w);e=z+i|0;f=nb+f|0;f=e>>>0<i>>>0?f+1|0:f;e=e+8388608|0;f=e>>>0<8388608?f+1|0:f;f=Yc(e,f,24);e=(f|0)/256|0;v[c>>2]=B(e,k)+v[c>>2];v[c+4>>2]=v[c+4>>2]+B(e,j);Rb(h+8|0,x,y);e=f-(g&n)|0;c=c+8|0;d=d-1|0;f=b;continue}break}c=v[h+12>>2];v[a>>2]=v[h+8>>2];v[a+4>>2]=c;v[a+48>>2]=f;v[a+44>>2]=b;kb=h+16|0}function Oea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=kb-16|0;kb=f;u[f+12>>1]=c;u[f+14>>1]=b;u[f+10>>1]=d;h=x[v[v[a+24>>2]+8>>2]+12>>1];a:{if(h>>>0<=b>>>0){break a}if(!c|tj(a)>>>0>=h>>>0){break a}Ef(f+12|0,h-b&65535);p=f,q=Bl(v[a>>2],v[a+4>>2]),u[p+8>>1]=q;g=x[f+12>>1];CS(a,g+x[ke(f+14|0,f+8|0)>>1]|0);c=v[a>>2];e=a;if(Rc(c,v[a+4>>2])>>>0<b>>>0){vg(e,b);c=v[e>>2]}a=Fb(c);c=kb-16|0;kb=c;v[c+8>>2]=a;a=v[mP(c+8|0,b)>>2];kb=c+16|0;a=v[fc(f,a)>>2];i=f+10|0;l=kb-32|0;kb=l;b=a;a=v[e>>2];d=(Ao(b,Fb(a))<<1)+a|0;a=g;b:{if(!a){break b}b=v[Gb(e)>>2];g=v[e+4>>2];if(a>>>0<=b-g>>1>>>0){b=a;c=g-d>>1;if(c>>>0<a>>>0){Jo(e,a-c|0,i);b=c;if((d|0)==(g|0)){break b}}m=kb-16|0;kb=m;c=g;o=v[e+4>>2];g=(o-((a<<1)+d|0)|0)+d|0;n=ai(m,e,c-g>>1);j=v[n+4>>2];k=g;while(1){if(c>>>0<=k>>>0){lc(n);Dq(d,g,o);kb=m+16|0}else{Mi(j,x[k>>1]);j=j+2|0;v[n+4>>2]=j;k=k+2|0;continue}break}_t(d,b,((d>>>0<=i>>>0?y[e+4>>2]>i>>>0?a:0:0)<<1)+i|0);break b}b=Gb(e);b=Nj(l+8|0,Oj(e,Rc(v[e>>2],g)+a|0),d-v[e>>2]>>1,b);NC(b,a,i);d=kP(e,b,d);Ni(b)}Fb(d);kb=l+32|0;if(Rc(v[e>>2],v[e+4>>2])>>>0<=h>>>0){break a}vg(e,h)}kb=f+16|0}function cja(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;nd(b,32);vo(b);f=b,g=pe((w[a+50|0]|w[a+51|0]<<8)<<16>>16)>>>2|0,u[f+32>>1]=g;if((pe((w[a+32|0]|w[a+33|0]<<8)<<16>>16)|0)>0){u[b+34>>1]=x[b+34>>1]|32;c=pe((w[a+32|0]|w[a+33|0]<<8)<<16>>16);e=c>>>24|0;d=(c<<8&-256)+2047|0;c=e&255;f=b,g=Ec(Mka(d,d>>>0<2047?c+1|0:c,4095,0),nb),u[f+28>>1]=g}c=bc(w[a+38|0]|w[a+39|0]<<8|(w[a+40|0]<<16|w[a+41|0]<<24));v[b>>2]=c;d=bc(w[a+42|0]|w[a+43|0]<<8|(w[a+44|0]<<16|w[a+45|0]<<24));v[b+4>>2]=d;e=bc(w[a+42|0]|w[a+43|0]<<8|(w[a+44|0]<<16|w[a+45|0]<<24))+bc(w[a+46|0]|w[a+47|0]<<8|(w[a+48|0]<<16|w[a+49|0]<<24))|0;v[b+8>>2]=e;if((Ib(w[a+34|0]|w[a+35|0]<<8)|0)==16){v[b+8>>2]=e>>>1;v[b+4>>2]=d>>>1;v[b>>2]=c>>>1}a:{b:{if(bc(w[a+42|0]|w[a+43|0]<<8|(w[a+44|0]<<16|w[a+45|0]<<24))){c=x[b+34>>1];break b}c=x[b+34>>1];if(bc(w[a+46|0]|w[a+47|0]<<8|(w[a+48|0]<<16|w[a+49|0]<<24))>>>0>=3){break b}c=c&-3;break a}c=c|2}u[b+34>>1]=c;f=b,g=c&65531|Ib(w[a+30|0]|w[a+31|0]<<8)<<1&4,u[f+34>>1]=g;f=b,g=Ib(w[a+36|0]|w[a+37|0]<<8)<<1,v[f+24>>2]=g;c=pe((w[a+52|0]|w[a+53|0]<<8)<<16>>16);if(c){zl(b,+(c|0)/96);c=pe((w[a+52|0]|w[a+53|0]<<8)<<16>>16)}t[b+37|0]=c<<4}function e9(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;h=kb-16|0;kb=h;if(!w[a+4242|0]){Ox(a);a:{if(!w[a+4240|0]){break a}e=GM(v[a+16>>2]);if(e==A[a+4288>>3]){break a}A[a+4288>>3]=e;Qs(a)}f=a+4256|0;b:{if(w[a+4244|0]){if(A[f>>3]>1){v[f>>2]=0;v[f+4>>2]=1072693248}break b}i=(v[a+4232>>2]&-2)!=4;e=A[f>>3];c:{if(D(e)<2147483648){g=~~e;break c}g=-2147483648}if(!(i|(g|0)<=0)){Nx(a);e=A[a+4256>>3]}A[f>>3]=e-+(g|0)}e=0;d:{e:{switch(v[a+4232>>2]){case 0:e=Di(A[f>>3]*6.283185307179586);break d;case 1:e=D(A[f>>3]+-.5)*-4+1;break d;case 2:e=A[f>>3];e=e+e+-1;break d;case 3:e=A[f>>3]<.5?-1:1;break d;case 4:e=A[a+4272>>3];break d;case 5:break e;default:break d}}e=A[a+4256>>3];e=e*(e*e)*(e*(e*6+-15)+10);e=A[a+4280>>3]*e+A[a+4272>>3]*(1-e)}A[h+8>>3]=(w[a+4241|0]?-e:e)*+z[a+4220>>2]+ +z[a+4224>>2];fO(h+8|0,1);g=jj(a);f:{if(!g){break f}f=v[a+4236>>2];if(w[a+4243|0]){k=g,l=(f>>>8&15|176)&191|(f&127)<<8|tk(A[h+8>>3]*127)<<16,j=v[v[g>>2]+68>>2],ob[j](k|0,l|0)|0;break f}ob[v[v[g>>2]+44>>2]](g,f,C(A[h+8>>3]))}A[a+4256>>3]=A[a+4264>>3]*+(d>>>0)+A[a+4256>>3]}g=a;a=v[a+44>>2];ti(g,b,c,Jc(a,0),Jc(a,1),d);kb=h+16|0}function RS(a,b,c){var d=0,e=0,f=0,g=0;d=kb-16|0;kb=d;t[d+15|0]=c;a:{if(b>>>0>=22){t[d+14|0]=0;de(a,0,d+14|0);break a}e=w[b+26736|0];b:{c:{switch(b-8|0){case 0:t[d+15|0]=c<<1;break b;case 4:t[d+15|0]=c+1>>>1;break b;case 5:t[d+15|0]=B(c>>>4|0,10)+(c&15);break b;case 6:d:{switch((c>>>4|0)-1|0){default:e=0;break b;case 0:t[d+13|0]=c&15;t[d+12|0]=14;f=d,g=w[Yb(d+13|0,d+12|0)|0]<<4|15,t[f+15|0]=g;e=29;break b;case 1:t[d+11|0]=c&15;t[d+10|0]=14;f=d,g=w[Yb(d+11|0,d+10|0)|0]|240,t[f+15|0]=g;e=29;break b;case 3:t[d+15|0]=c&15|48;break b;case 4:t[d+15|0]=c<<4^128;e=35;break b;case 5:t[d+15|0]=c&15|176;break b;case 6:t[d+15|0]=c&15|64;break b;case 8:e=15;t[d+15|0]=c&15;break b;case 9:t[d+15|0]=(c<<3&120)+8&240;e=24;break b;case 10:t[d+15|0]=(c&15)+1>>>1;e=24;break b;case 14:break d;case 11:case 12:case 13:break b}}e=10;break b;case 8:if(c>>>0<=223){b=c>>>2|0;t[d+15|0]=(b>>>0<15?b:15)<<4;break b}if(c>>>0<=239){t[d+15|0]=c<<2&48|15;break b}t[d+15|0]=c<<4|15;break b;case 9:break c;default:break b}}if(c>>>0<=223){b=c>>>2|0;t[d+15|0]=b>>>0<15?b:15;break b}if(c>>>0>239){break b}t[d+15|0]=c>>>2&3|240}de(a,e,d+15|0)}kb=d+16|0}function lda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,w=0,x=0,y=0,z=0,A=0;g=kb-16|0;kb=g;f=v[a+48>>2];i=v[a+40>>2];j=v[a+36>>2];e=v[a+44>>2];l=v[a+16>>2];b=v[a+4>>2];v[g+8>>2]=v[a>>2];v[g+12>>2]=b;m=v[a+32>>2];n=v[a+28>>2];o=v[a+72>>2];b=v[a+68>>2];p=b;q=b>>31;b=v[a+64>>2];r=b;s=b>>31;b=v[a+60>>2];w=b;x=b>>31;y=v[a+8>>2];z=v[a+12>>2];while(1){b=e;if(d){e=Zb(b,-16777216,16776704);e=Jka(r,s,e,e>>31);h=nb;f=Zb(f,-16777216,16776704);k=Jka(p,q,f,f>>31);e=k+e|0;f=nb+h|0;f=e>>>0<k>>>0?f+1|0:f;A=e;e=v[g+12>>2]+l|0;h=v[g+8>>2]>>>21&2040;h=(((B(t[e|0],u[h+39778>>1])+B(t[e-1|0],u[h+39776>>1])|0)+B(t[e+1|0],u[h+39780>>1])|0)+B(t[e+2|0],u[h+39782>>1])<<8)/16384<<8;e=h;k=Jka(e,e>>31,w,x);e=A+k|0;f=nb+f|0;f=e>>>0<k>>>0?f+1|0:f;e=e+8388608|0;f=e>>>0<8388608?f+1|0:f;f=Yc(e,f,24);e=(f|0)/256|0;j=j+n|0;v[c>>2]=B(e,j>>12)+v[c>>2];i=i+m|0;v[c+4>>2]=v[c+4>>2]+B(i>>12,e);Rb(g+8|0,y,z);e=f-(h&o)|0;c=c+8|0;d=d-1|0;f=b;continue}break}c=v[g+12>>2];v[a>>2]=v[g+8>>2];v[a+4>>2]=c;v[a+40>>2]=i;v[a+20>>2]=j>>12;v[a+36>>2]=j;v[a+48>>2]=f;v[a+44>>2]=b;v[a+24>>2]=i>>12;kb=g+16|0}function zca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=kb-16|0;kb=e;o=v[a+16>>2];p=kg(b+327720|0,v[b+20>>2],(v[a+88>>2]&16384)>>>14|0);l=v[a+128>>2];a:{if(!l){j=v[a+8>>2];k=v[a+12>>2];f=v[a>>2];g=v[a+4>>2];i=0;break a}j=v[a+8>>2];k=v[a+12>>2];m=lg(j,k,l);n=nb;b=v[a+76>>2];f=v[a>>2];g=v[a+4>>2];Qf(f,g,qf(j,k,d),nb);i=b>>>0<nb>>>0?d:0}h=a+112|0;q=v[a+24>>2];r=v[a+20>>2];v[e>>2]=f;v[e+4>>2]=g;b:while(1){if(d){b=v[e+4>>2];f=v[e>>2];v[e+8>>2]=f;v[e+12>>2]=0;i=i-1|0;m=i?m:0;n=i?n:0;d=d-1|0;f=((((b&2147483647)<<1|f>>>31)&2147483646)<<1)+o|0;b=l;while(1)if((b|0)<=0){Rb(h,v[a+120>>2],v[a+124>>2]);b=v[a+116>>2];if(b){g=(v[e+12>>2]&2147483647)<<1|v[e+8>>2]>>>31;Sd(h,(u[(g<<1|2)+f>>1]+u[((g&2147483646)<<1)+f>>1]|0)/8<<16>>16);Rd(h,b);v[h>>2]=v[h>>2];v[h+4>>2]=0}f=v[c>>2];b=jg(h,p);v[c>>2]=f+B(b,r);v[c+4>>2]=v[c+4>>2]+B(b,q);Rb(e,j,k);c=c+8|0;continue b}else{g=(v[e+12>>2]&2147483647)<<1|v[e+8>>2]>>>31;Sd(h,(u[(g<<1|2)+f>>1]+u[((g&2147483646)<<1)+f>>1]|0)/8<<16>>16);Rd(h,4);Rb(e+8|0,m,n);b=b-1|0;continue}}break}b=v[e+4>>2];v[a>>2]=v[e>>2];v[a+4>>2]=b;kb=e+16|0}function N9(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;j=kb-16|0;kb=j;c=rf(a,c);me(j,v[a+36>>2]);a:{b:{if(!c){Sc(j,a+32|0,5);d=-1;if(!Cb(v[v[j>>2]>>2],v[j+4>>2])){break b}break a}d=v[c+16>>2]}e=v[a+36>>2];c:{if(!((d|0)!=4&(d|0)!=-1)){d=kb-16|0;kb=d;v[d+8>>2]=0;Hp(e,d+8|0);z[b>>2]=z[d+8>>2];kb=d+16|0;break c}f=kb-16|0;kb=f;v[f+12>>2]=d;v[f+8>>2]=4;h=v[Kb(f+12|0,f+8|0)>>2];k=kb-16|0;kb=k;kG(k+8|0,e);d=v[k+12>>2];if(Ar(-1,2147483647,h,0)^1){i=Ar(h,0,0,-2147483648)^1}else{i=0}if(i){d:{e=kb-48|0;kb=e;i=d+v[v[d>>2]-12>>2]|0;g=v[i+16>>2]&-3;Rl(i,g);e:{f:{if(Qd(w[fm(e+40|0,d,1)|0])){i=v[(d+v[v[d>>2]-12>>2]|0)+24>>2];v[23540]=0;Nk(107,e+24|0,i,h,0);h=v[23540];v[23540]=0;g:{if((h|0)!=1){g=mE(e+24|0,Xg(e+8|0,-1,-1))?g|4:g;break g}h=V(0)|0;O()|0;_(h|0)|0;g=g|1;dm(d+v[v[d>>2]-12>>2]|0,g);if(v[(d+v[v[d>>2]-12>>2]|0)+20>>2]&1){v[23540]=0;Z(105);a=v[23540];v[23540]=0;if((a|0)!=1){break e}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)==1){break f}T(a|0);L()}$()}Ki(d+v[v[d>>2]-12>>2]|0,g)}kb=e+48|0;break d}V(0)|0;O()|0;Vb()}L()}}kb=k+16|0;v[b>>2]=0;kb=f+16|0}f=c}Ye(a,f);kb=j+16|0}function v3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=kb+-64|0;kb=b;c=v[a>>2];a=v[c>>2];d=v[a+4>>2];v[b+40>>2]=v[a+20>>2];e=v[a+16>>2];v[b+32>>2]=v[a+12>>2];v[b+36>>2]=e;Hf(b+48|0,b+32|0,d);a=v[c+4>>2];d=v[a+8>>2];e=v[a+4>>2];c=v[b+60>>2];v[b+24>>2]=v[b+56>>2];v[b+28>>2]=c;c=v[b+52>>2];v[b+16>>2]=v[b+48>>2];v[b+20>>2]=c;v[b+8>>2]=v[a+8>>2];c=v[a+4>>2];v[b>>2]=v[a>>2];v[b+4>>2]=c;a=kb-32|0;kb=a;a:{b:{c:{d:{g=v[b+4>>2];if(g>>>0>=e>>>0){if(y[b+20>>2]<e>>>0){break d}if(d>>>0>y[b+8>>2]){break c}h=v[b+28>>2];if(d>>>0>v[b+24>>2]-h>>>0){break b}k=v[b+16>>2];l=v[b>>2];e:while(1){if((d|0)==(f|0)){break a}m=f+h|0;n=B(f,g);c=0;while(1)if((c|0)==(e|0)){f=f+1|0;continue e}else{A[a+24>>3]=A[(c+n<<3)+l>>3];v[a+16>>2]=0;v[a+20>>2]=-1074790400;v[a+8>>2]=0;v[a+12>>2]=1072693248;o=m<<1;p=(c<<2)+k|0;i=ve(A[Gg(a+24|0,a+16|0,a+8|0)>>3]*32768);f:{if(D(i)<2147483648){j=~~i;break f}j=-2147483648}q=v[p>>2]+o|0,r=ed(j),u[q>>1]=r;c=c+1|0;continue}}}aa(7192,9074,77,8754);L()}aa(7157,9074,78,8754);L()}aa(5900,9074,79,8754);L()}aa(5870,9074,80,8754);L()}kb=a+32|0;kb=b- -64|0}function eda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0;f=kb-16|0;kb=f;a:{b:{c:{g=v[a+12>>2];i=v[a+8>>2];d:{if((g|0)<=1&i>>>0<=805306368|(g|0)<=0){if((g|0)>=-2&i>>>0>=3489660928|(g|0)>-2){break c}if((g|0)==-2&i>>>0>2147483647|g>>>0>4294967294){break d}break b}if((g|0)==1&i>>>0>2147483648|g>>>0>1){break b}}b=b+196648|0;break a}b=b+131112|0;break a}b=b+262184|0}j=v[a+16>>2];k=v[a+24>>2];l=v[a+20>>2];e=v[a+4>>2];v[f+8>>2]=v[a>>2];v[f+12>>2]=e;while(1){if(d){h=v[f+8>>2];m=((((v[f+12>>2]&2147483647)<<1|h>>>31)&2147483646)<<1)+j|0;e=(h>>>16&65520)+b|0;n=u[e+14>>1];o=u[e+12>>1];p=u[e+10>>1];q=u[e+8>>1];r=u[e+6>>1];s=u[e+4>>1];t=u[e+2>>1];w=u[e>>1];h=0;while(1){if((h|0)!=2){e=(h<<1)+m|0;v[(h<<2)+f>>2]=(((((((B(u[e-8>>1],t)+B(u[e-12>>1],w)|0)+B(u[e-4>>1],s)|0)+B(u[e>>1],r)|0)+B(u[e+4>>1],q)|0)+B(u[e+8>>1],p)|0)+B(u[e+12>>1],o)|0)+B(u[e+16>>1],n)|0)/32768;h=h+1|0;continue}break}v[c>>2]=v[c>>2]+B(v[f>>2],l);v[c+4>>2]=v[c+4>>2]+B(v[f+4>>2],k);Rb(f+8|0,i,g);c=c+8|0;d=d-1|0;continue}break}b=v[f+12>>2];v[a>>2]=v[f+8>>2];v[a+4>>2]=b;kb=f+16|0}function m3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=kb+-64|0;kb=b;c=v[a>>2];a=v[c>>2];d=v[a+4>>2];v[b+40>>2]=v[a+20>>2];e=v[a+16>>2];v[b+32>>2]=v[a+12>>2];v[b+36>>2]=e;Hf(b+48|0,b+32|0,d);a=v[c+4>>2];d=v[a+8>>2];e=v[a+4>>2];c=v[b+60>>2];v[b+24>>2]=v[b+56>>2];v[b+28>>2]=c;c=v[b+52>>2];v[b+16>>2]=v[b+48>>2];v[b+20>>2]=c;v[b+8>>2]=v[a+8>>2];c=v[a+4>>2];v[b>>2]=v[a>>2];v[b+4>>2]=c;a=kb-32|0;kb=a;a:{b:{c:{d:{g=v[b+4>>2];if(g>>>0>=e>>>0){h=v[b+20>>2];if(h>>>0<e>>>0){break d}if(d>>>0>y[b+8>>2]){break c}i=v[b+28>>2];if(d>>>0>v[b+24>>2]-i>>>0){break b}l=v[b+16>>2];m=v[b>>2];e:while(1){if((d|0)==(f|0)){break a}n=B(f,g);o=B(f+i|0,h);c=0;while(1)if((c|0)==(e|0)){f=f+1|0;continue e}else{A[a+24>>3]=A[(c+n<<3)+m>>3];v[a+16>>2]=0;v[a+20>>2]=-1074790400;v[a+8>>2]=0;v[a+12>>2]=1072693248;p=(c+o<<1)+l|0;j=ve(A[Gg(a+24|0,a+16|0,a+8|0)>>3]*32768);f:{if(D(j)<2147483648){k=~~j;break f}k=-2147483648}q=p,r=ed(k),u[q>>1]=r;c=c+1|0;continue}}}aa(7192,9074,77,8754);L()}aa(7157,9074,78,8754);L()}aa(5900,9074,79,8754);L()}aa(5870,9074,80,8754);L()}kb=a+32|0;kb=b- -64|0}function O8(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0;b=kb+-64|0;kb=b;g=Tb(a);v[23540]=0;Y(909,g|0);a=v[23540];v[23540]=0;a:{if((a|0)!=1){a=44640;b:{c:{d:{e:{f:{g:{h:{i:{j:{while(1){if((a|0)==44952){kb=b- -64|0;return g|0}k:{h=Zs(44);if(h){d=v[a>>2];e=v[a+4>>2];v[23540]=0;e=Q(55,b+32|0,e|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break k}v[23540]=0;R(910,b+48|0,e|0);c=v[23540];v[23540]=0;if((c|0)==1){break j}c=v[a+8>>2];v[23540]=0;c=Q(55,b|0,c|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break i}v[23540]=0;R(910,b+16|0,c|0);f=v[23540];v[23540]=0;if((f|0)==1){break h}v[23540]=0;d=fa(911,h|0,d|0,b+48|0,b+16|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break g}Xb(b+16|0);zb(c);Xb(b+48|0);zb(e);v[b+60>>2]=d;v[23540]=0;R(912,g|0,b+60|0);e=v[23540];v[23540]=0;if((e|0)==1){break b}v[d+32>>2]=v[a+12>>2];v[d+36>>2]=v[a+16>>2];t[d+40|0]=w[a+20|0];t[d+41|0]=w[d+41|0]&253|w[a+21|0]<<1}a=a+24|0;continue}break}a=P()|0;O()|0;break c}a=P()|0;O()|0;break d}a=P()|0;O()|0;break e}a=P()|0;O()|0;break f}a=P()|0;O()|0;Xb(b+16|0)}zb(c)}Xb(b+48|0)}zb(e)}Mb(h);break a}a=P()|0;O()|0;break a}a=P()|0;O()|0}wc(g);T(a|0);L()}function Sja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=kb-1072|0;kb=d;v[d+1068>>2]=c;o=d,p=Me(b),t[o+8|0]=p;t[d+4|0]=1;c=d+8|0;g=w[jf(c,d+4|0)|0];f=zB(c,b);l=Gq(f);v[23540]=0;c=S(202,b|0)|0;e=v[23540];v[23540]=0;a:{if((e|0)!=1){v[d+4>>2]=c;v[d>>2]=536870911;xc(d+1068|0,v[Kb(d+4|0,d)>>2]<<3);v[23540]=0;m=v[d+1068>>2];k=Q(335,a|0,m|0)|0;a=v[23540];v[23540]=0;if((a|0)!=1){v[23540]=0;c=8;h=Q(164,f|0,8)|0;a=v[23540];v[23540]=0;b:{if((a|0)!=1){c:{o=Lb(v[k>>2],0),p=h,t[o|0]=p;i=1;a=g;while(1){c=c&255;n=c>>>0>9?c:9;e=a;d:{e:{while(1){if(i>>>0>=m>>>0){break d}v[23540]=0;j=Q(164,f|0,c|0)|0;a=v[23540];v[23540]=0;if((a|0)!=1){if(j){break e}if((c|0)==(n|0)){break d}c=c+1|0;e=g;continue}break}break c}a=j>>>1|0;h=(j&1?0-a|0:a)+h|0;o=Lb(v[k>>2],i),p=h,t[o|0]=p;i=i+1|0;a=g;if(j>>>c-1|0){continue}a=e-1|0;e=a&255;a=e?a:g;c=c-(!e&(c&255)>>>0>1)|0;continue}break}a=Gq(f);v[23540]=0;Q(155,b|0,((a-l|0)+3&-4)+l|0)|0;a=v[23540];v[23540]=0;if((a|0)!=1){break b}}}c=P()|0;O()|0;ic(k);break a}Bb(f);kb=d+1072|0;return}c=P()|0;O()|0;break a}c=P()|0;O()|0}Bb(f);T(c|0);L()}function c$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;a=kb-448|0;kb=a;v[a+432>>2]=c;v[a+440>>2]=b;v[a+20>>2]=1154;b=se(a+24|0,a+32|0,a+20|0);h=a+16|0;gd(h,e);v[23540]=0;h=S(1132,h|0)|0;i=v[23540];v[23540]=0;if((i|0)!=1){a:{t[a+15|0]=0;e=v[e+4>>2];v[23540]=0;c=qa(1162,a+440|0,c|0,d|0,a+16|0,e|0,f|0,a+15|0,h|0,b|0,a+20|0,a+432|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break a}b:{c:{if(!c){break c}d:{if(ef(g)){wd(v[g>>2],0);Hd(g,0);break d}wd(g,0);ie(g,0)}if(w[a+15|0]){v[23540]=0;c=Q(1150,h|0,45)|0;d=v[23540];v[23540]=0;if((d|0)==1){break a}v[23540]=0;R(49,g|0,c|0);c=v[23540];v[23540]=0;if((c|0)==1){break a}}v[23540]=0;d=Q(1150,h|0,48)|0;c=v[23540];v[23540]=0;if((c|0)==1){break b}e=v[a+20>>2];h=e-4|0;c=v[b>>2];while(1){if(!((d|0)!=v[c>>2]|c>>>0>=h>>>0)){c=c+4|0;continue}break}v[23540]=0;W(1167,g|0,c|0,e|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){break c}break a}v[23540]=0;c=Q(1138,a+440|0,a+432|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break a}if(c){v[f>>2]=v[f>>2]|2}c=v[a+440>>2];ac(a+16|0);Xc(b);kb=a+448|0;return c|0}}}c=P()|0;O()|0;ac(a+16|0);Xc(b);T(c|0);L()}function Kn(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=kb-80|0;kb=c;g=Tb(a);a=v[b+24>>2];a:{b:{if(sj(v[a+484360>>2],v[a+484364>>2])){c:{d:{e:while(1){if(sj(v[a+484360>>2],v[a+484364>>2])>>>0<=f>>>0){break d}d=xM(cS(c+40|0,1),f&255,0,0);v[23540]=0;e=v[d+12>>2];v[c+16>>2]=v[d+8>>2];v[c+20>>2]=e;e=v[d+20>>2];v[c+24>>2]=v[d+16>>2];v[c+28>>2]=e;e=v[d+4>>2];v[c+8>>2]=v[d>>2];v[c+12>>2]=e;X(1040,c- -64|0,a|0,0,c+8|0);a=v[23540];v[23540]=0;if((a|0)==1){break c}j=c,k=Fb(v[c+64>>2]),v[j+32>>2]=k;d=Fb(v[c+68>>2]);while(1){a=v[c+32>>2];if(!Pb(a,d)){f=f+1|0;Ei(c- -64|0);a=v[b+24>>2];continue e}h=A[a>>3];e=v[a+16>>2];i=x[a+24>>1];a=c+40|0;v[a+16>>2]=f;v[a+12>>2]=i;v[a+8>>2]=e;A[a>>3]=h;v[23540]=0;R(1057,g|0,a|0);a=v[23540];v[23540]=0;if((a|0)!=1){Cz(c+32|0);continue}break}break}a=P()|0;O()|0;Ei(c- -64|0);break b}kb=c+80|0;return}a=P()|0;O()|0;break b}b=ba(8)|0;v[23540]=0;d=Q(55,c+40|0,7270)|0;a=v[23540];v[23540]=0;if((a|0)!=1){a=tc(b,d);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break a}a=P()|0;O()|0;zb(d);break b}a=P()|0;O()|0;ca(b|0)}Xf(g);T(a|0)}L()}function gba(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;i=kb-16|0;kb=i;v[i+8>>2]=b;o=xf(a);while(1){if(Hg(b,c)){b=v[fc(i,o)>>2];j=vd(v[i+8>>2]);m=kb-16|0;kb=m;n=0;k=kb-16|0;kb=k;h=kb-32|0;kb=h;f=h+28|0;d=h+24|0;e=kb-16|0;kb=e;a:{b:{if(!pc(b,v[fc(e+8|0,Zf(a))>>2])){g=w[j|0];l=w[vd(b)|0];if(!Tn(g,l)){break b}}v[e+8>>2]=b;g=fc(e,Fb(v[a>>2]));c:{d=v[e+8>>2];if(!pc(d,v[g>>2])){d=v[lz(e+8|0)>>2];l=w[vd(d)|0];g=w[j|0];if(!Tn(l,g)){break c}}if(!v[b>>2]){v[f>>2]=b;break a}v[f>>2]=d;b=d+4|0;break a}b=Ky(a,f,g);break a}if(Tn(l,g)){d:{d=jz(b);if(!pc(d,v[fc(e+8|0,Zf(a))>>2])){g=w[j|0];if(!Tn(g,w[vd(d)|0])){break d}}if(!v[b+4>>2]){v[f>>2]=b;b=b+4|0;break a}v[f>>2]=d;b=d;break a}b=Ky(a,f,g);break a}v[f>>2]=b;v[d>>2]=b;b=d}kb=e+16|0;d=b;b=v[b>>2];if(!b){b=kb-16|0;kb=b;e=jc(a);f=h+8|0;e=lh(f,vc(24),mh(b+8|0,e));mN(v[e>>2]+16|0,v[j>>2],v[j+4>>2]);p=jc(e),q=1,t[p+4|0]=q;kb=b+16|0;Jg(a,v[h+28>>2],d,v[h+8>>2]);b=ce(f);rk(f);n=1}Ig(k+8|0,v[fc(h+8|0,b)>>2],n);kb=h+32|0;kb=k+16|0;fc(m+8|0,v[k+8>>2]);kb=m+16|0;b=v[Kg(i+8|0)>>2];continue}else{kb=i+16|0}break}}function pS(a,b,c,d,e){var f=0,g=0;f=kb-16|0;kb=f;a:{if((d&255)>>>0<=4){while(1){d=x[c>>1]<<1;u[c>>1]=d;t[b|0]=(d&65534)>>>0>255;d=w[c|0];u[c>>1]=d;if(!d){if(!nf(a,f+15|0)){break a}d=w[f+15|0];u[c>>1]=d<<1|1;t[b|0]=d>>>7;u[c>>1]=w[c|0]}u[e>>1]=t[b|0]+(x[e>>1]<<1);d=x[c>>1]<<1;u[c>>1]=d;t[b|0]=(d&65534)>>>0>255;d=w[c|0];u[c>>1]=d;if(!d){if(!nf(a,f+14|0)){break a}d=w[f+14|0];u[c>>1]=d<<1|1;t[b|0]=d>>>7;u[c>>1]=w[c|0]}u[e>>1]=t[b|0]+(x[e>>1]<<1);d=x[c>>1]<<1;u[c>>1]=d;t[b|0]=(d&65534)>>>0>255;d=w[c|0];u[c>>1]=d;if(!d){d=nf(a,f+13|0);if(d){g=w[f+13|0];u[c>>1]=g<<1|1;t[b|0]=g>>>7;u[c>>1]=w[c|0]}if(!d){break a}if(w[b|0]){continue}break a}if(w[b|0]){continue}break a}}while(1){d=x[c>>1]<<1;u[c>>1]=d;t[b|0]=(d&65534)>>>0>255;d=w[c|0];u[c>>1]=d;if(!d){if(!nf(a,f+12|0)){break a}d=w[f+12|0];u[c>>1]=d<<1|1;t[b|0]=d>>>7;u[c>>1]=w[c|0]}u[e>>1]=t[b|0]+(x[e>>1]<<1);d=x[c>>1]<<1;u[c>>1]=d;t[b|0]=(d&65534)>>>0>255;d=w[c|0];u[c>>1]=d;if(!d){d=nf(a,f+11|0);if(d){g=w[f+11|0];u[c>>1]=g<<1|1;t[b|0]=g>>>7;u[c>>1]=w[c|0]}if(!d){break a}if(w[b|0]){continue}break a}if(w[b|0]){continue}break}}kb=f+16|0}function MV(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=kb-32|0;kb=g;t[g+12|0]=0;m=Qm(g+16|0,d,g+12|0);f=v[m>>2];v[g+12>>2]=d;h=d;while(1){if(!(!b|!h)){a:{i=b-1|0;k=w[a|0];if(!(!i|(k|0)!=(e&255))){v[g+8>>2]=w[a+1|0];i=a+2|0;j=Kb(g+8|0,g+12|0);b:{k=b-2|0;if(!k){break b}j=v[j>>2];if(!(j&255)){break b}i=w[i|0];while(1){if(!(j&255)){break a}t[f|0]=i;h=v[g+12>>2]-1|0;v[g+12>>2]=h;f=f+1|0;j=j-1|0;continue}}t[f|0]=e;h=v[g+12>>2]-1|0;v[g+12>>2]=h;f=f+1|0;b=k;a=i;continue}a=a+1|0;t[f|0]=k;h=v[g+12>>2]-1|0;v[g+12>>2]=h;f=f+1|0;b=i;continue}b=b-3|0;a=a+3|0;continue}break}e=d-h|0;a=v[m>>2];k=0;f=128;b=0;i=0;c:while(1){if((e|0)==(i|0)){while(1){if(e){d=k<<24>>24;b=t[c|0];a=128;d:{if((b|0)==-128){break d}a=b;if((b|0)>=0){break d}a=0-(b&127)|0}k=d-(a&255)|0;t[c|0]=k;e=e-1|0;c=c+1|0;continue}break}ic(m);kb=g+32|0;return}n=w[a|0];h=0;j=0;while(1)if((j&65535)>>>0>=8){f=f&65535;f=(f<<8|f)>>>h&255;i=i+1|0;a=a+1|0;continue c}else{l=b+c|0;t[l|0]=w[l|0]|B(f&n,257)>>>(h-j&7);l=b+1|0;b=d>>>0>l>>>0?l:0;j=j+1|0;h=(d>>>0<=l>>>0)+h|0;f=(f<<8|f)>>>1&255;continue}}}function jaa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;j=kb-32|0;kb=j;e=b;b=v[a>>2];f=B(Ws(e,Fb(b)),6)+b|0;a:{if(!c){break a}b=v[Gb(a)>>2];g=v[a+4>>2];if((b-g|0)/6>>>0>=c>>>0){b=c;e=(g-f|0)/6|0;if(e>>>0<c>>>0){PA(a,c-e|0,d);b=e;if((f|0)==(g|0)){break a}}k=kb-16|0;kb=k;m=v[a+4>>2];h=B((m-(B(c,6)+f|0)|0)/6|0,6)+f|0;l=Iq(k,a,(g-h|0)/6|0);i=v[l+4>>2];e=h;while(1){if(e>>>0>=g>>>0){lc(l);if((f|0)!=(h|0)){e=h-f|0;fj(m+B((e|0)/-6|0,6)|0,f,e)}kb=k+16|0}else{iu(i,e);i=i+6|0;v[l+4>>2]=i;e=e+6|0;continue}break}e=f;a=B(e>>>0<=d>>>0?y[a+4>>2]>d>>>0?c:0:0,6)+d|0;while(1){if(b){c=w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24);t[e|0]=c;t[e+1|0]=c>>>8;t[e+2|0]=c>>>16;t[e+3|0]=c>>>24;c=w[a+4|0]|w[a+5|0]<<8;t[e+4|0]=c;t[e+5|0]=c>>>8;b=b-1|0;e=e+6|0;continue}break}break a}b=Gb(a);e=iT(j+8|0,JA(a,qk(v[a>>2],g)+c|0),(f-v[a>>2]|0)/6|0,b);hT(e,c,d);b=v[e+4>>2];d=e+4|0;fT(v[a>>2],f,d);h=v[a+4>>2];c=e+8|0;while(1){if((f|0)!=(h|0)){iu(v[c>>2],f);v[c>>2]=v[c>>2]+6;f=f+6|0;continue}break}qc(a,d);qc(a+4|0,c);qc(Gb(a),Cc(e));v[e>>2]=v[e+4>>2];f=b;gT(e)}Fb(f);kb=j+32|0}function fda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,w=0,x=0;f=kb-16|0;kb=f;a:{b:{c:{g=v[a+12>>2];i=v[a+8>>2];d:{if((g|0)<=1&i>>>0<=805306368|(g|0)<=0){if((g|0)>=-2&i>>>0>=3489660928|(g|0)>-2){break c}if((g|0)==-2&i>>>0>2147483647|g>>>0>4294967294){break d}break b}if((g|0)==1&i>>>0>2147483648|g>>>0>1){break b}}b=b+196648|0;break a}b=b+131112|0;break a}b=b+262184|0}j=v[a+16>>2];k=v[a+24>>2];l=v[a+20>>2];e=v[a+4>>2];v[f+8>>2]=v[a>>2];v[f+12>>2]=e;while(1){if(d){h=v[f+8>>2];m=(((v[f+12>>2]&2147483647)<<1|h>>>31)&-2)+j|0;e=(h>>>16&65520)+b|0;n=u[e+14>>1];o=u[e+12>>1];p=u[e+10>>1];q=u[e+8>>1];r=u[e+6>>1];s=u[e+4>>1];w=u[e+2>>1];x=u[e>>1];h=0;while(1){if((h|0)!=2){e=h+m|0;v[(h<<2)+f>>2]=(((((((B(t[e-4|0],w)+B(t[e-6|0],x)|0)+B(t[e-2|0],s)|0)+B(t[e|0],r)|0)+B(t[e+2|0],q)|0)+B(t[e+4|0],p)|0)+B(t[e+6|0],o)|0)+B(t[e+8|0],n)<<8)/32768;h=h+1|0;continue}break}v[c>>2]=v[c>>2]+B(v[f>>2],l);v[c+4>>2]=v[c+4>>2]+B(v[f+4>>2],k);Rb(f+8|0,i,g);c=c+8|0;d=d-1|0;continue}break}b=v[f+12>>2];v[a>>2]=v[f+8>>2];v[a+4>>2]=b;kb=f+16|0}function F8(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=C(0),g=0,h=0,i=0,j=0,k=0,l=0,m=C(0),n=0,o=0,p=C(0),q=C(0),r=C(0),s=C(0),t=C(0),u=0,x=0,y=0,A=C(0);i=v[a+44>>2];h=Jc(i,0);i=Jc(i,1);j=v[a+56>>2];n=Jc(j,0);j=Jc(j,1);k=a+4208|0;g=uc(v[k>>2],v[a+4212>>2]);o=B(v[v[a+16>>2]+1074404>>2],w[a+4233|0]);e=o<<1;if(g>>>0<e>>>0){ek(k,e)}l=w[a+4232|0];a:{if(l){e=v[a+4220>>2];k=v[a+4208>>2];u=l-1|0;l=0;while(1){if((d|0)==(l|0)){break a}r=z[i>>2];e=e>>>0<o>>>0?e:0;g=e-o|0;g=((g|0)<0?e:g)<<1;x=Eb(k,g);f=z[Eb(k,g|1)>>2];s=z[h>>2];t=z[x>>2];p=C(s+t);z[n>>2]=p;q=C(r+f);z[j>>2]=q;f=C(0);m=C(0);b:{c:{switch(u|0){case 0:f=z[a+4224>>2];m=C(q*f);f=C(p*f);break b;case 1:case 2:f=z[a+4224>>2];m=C(p*f);f=C(q*f);break b;case 3:break c;default:break b}}f=C(C(C(C(s+r)*C(.5))+t)*z[a+4224>>2]);m=f}j=j+4|0;n=n+4|0;i=i+4|0;h=h+4|0;g=e<<1;y=Eb(k,g),A=C(D(f))<C(1.0000000195414814e-24)?C(0):f,z[y>>2]=A;y=Eb(k,g|1),A=C(D(m))<C(1.0000000195414814e-24)?C(0):m,z[y>>2]=A;e=e+1|0;v[a+4220>>2]=e;l=l+1|0;continue}}e=h;h=d<<2;qh(e,e+h|0,n);qh(i,i+h|0,j)}h=a;a=v[a+56>>2];ti(h,b,c,Jc(a,0),Jc(a,1),d)}function TA(a,b,c,d){t[a+5|0]=c;a:{b:{switch((b|64)+-64|0){case 0:t[a+3|0]=c?37:0;return;case 1:t[a+3|0]=16;return;case 2:t[a+3|0]=12;return;case 3:t[a+3|0]=14;if(d){break a}t[a+5|0]=B(c>>>4|0,10)+(c&15);return;case 4:t[a+3|0]=11;return;case 5:t[a+3|0]=3;return;case 6:t[a+3|0]=2;return;case 7:t[a+3|0]=4;return;case 8:t[a+3|0]=5;return;case 9:t[a+3|0]=18;return;case 10:t[a+3|0]=1;return;case 11:t[a+3|0]=7;return;case 12:t[a+3|0]=6;return;case 13:t[a+3|0]=21;return;case 14:t[a+3|0]=22;return;case 15:t[a+3|0]=10;return;case 16:t[a+3|0]=29;return;case 17:t[a+3|0]=15;return;case 18:t[a+3|0]=8;return;case 19:t[a+3|0]=20;return;case 20:t[a+3|0]=17;return;case 21:t[a+3|0]=26;return;case 22:t[a+3|0]=23;return;case 23:t[a+3|0]=24;return;case 24:t[a+3|0]=9;return;case 25:t[a+3|0]=27;return;case 26:t[a+3|0]=31;return;case 28:t[a+3|0]=d?32:31;return;case 29:t[a+3|0]=d?33:0;return;case 27:t[a+3|0]=d?34:0;return;case 30:t[a+3|0]=d?35:0;return;case 31:t[a+3|0]=d?36:0;return;case 50:t[a+3|0]=d?25:0;return;case 51:t[a+3|0]=d?30:0;return;default:break b}}t[a+3|0]=0}}function k8(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=C(0),f=0,g=C(0),h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=C(0),t=0,u=0,w=0,x=0,y=0,A=C(0);a:{j=v[a+4272>>2];if(!j){break a}if(!bi(a+44|0)){break a}f=v[a+44>>2];l=Jc(f,0);m=Jc(f,1);u=v[a+4252>>2]-1|0;i=v[a+4268>>2];k=v[a+4256>>2];n=d;f=v[a+56>>2];q=Jc(f,0);o=q;r=Jc(f,1);p=r;while(1){if(n){e=z[m>>2];f=i<<1;h=Eb(k,f);g=z[l>>2];z[h>>2]=g;y=Eb(k,f|1),A=e,z[y>>2]=A;s=z[a+4276>>2];e=C(C(D(TK(C(C(C(D(g))+C(D(e)))*C(536870912)),31,5)))*C(4.656612873077393e-10));e=C(C(C(s-e)*z[(e>=s?4236:4240)+a>>2])+e);z[a+4276>>2]=e;g=z[a+4244>>2];e=C(C(C(C(g-(e<g?g:e))*z[a+4248>>2])+C(.9999998807907104))*C(2147483648));b:{if(e<C(4294967296)&e>=C(0)){f=~~e>>>0;break b}f=0}t=((((i<<12)+u|0)+j|0)/4096|0)%(j|0)<<1;g=z[Eb(k,t)>>2];h=f<<5;w=h;x=h|-2147483648;h=f>>>0<67108864;e=C(z[a+4232>>2]*C(C((h?w:x)>>>(h?31:32-(f>>>26|0)|0)>>>0)*C(4.656612873077393e-10)));z[o>>2]=g*e;y=p,A=C(z[Eb(k,t|1)>>2]*e),z[y>>2]=A;i=((i?0:j)+i|0)-1|0;v[a+4268>>2]=i;n=n-1|0;p=p+4|0;o=o+4|0;m=m+4|0;l=l+4|0;continue}else{ti(a,b,c,q,r,d)}break}}}function WX(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=kb-32|0;kb=d;f=Tb(a);a=0;a:{b:{c:{d:{e:{while(1){if((Tv(b,c,a)|0)==-1){break b}e=Tv(b,c,a);v[23540]=0;X(122,d|0,b|0,a|0,e-a|0);e=v[23540];v[23540]=0;if((e|0)!=1){v[23540]=0;R(123,d+16|0,d|0);e=v[23540];v[23540]=0;if((e|0)==1){break e}v[23540]=0;R(124,f|0,d+16|0);e=v[23540];v[23540]=0;if((e|0)==1){break d}Ab(d+16|0);Ab(d);a=Tv(b,c,a)+Gk(v[c+4>>2],w[c+11|0])|0;continue}break}a=P()|0;O()|0;break a}a=P()|0;O()|0;break c}a=P()|0;O()|0;Ab(d+16|0)}Ab(d);break a}f:{g:{h:{i:{j:{k:{if(pc(v[f>>2],v[f+4>>2])){v[23540]=0;X(122,d+16|0,b|0,a|0,-1);c=v[23540];v[23540]=0;if((c|0)==1){break j}c=Gk(v[d+20>>2],w[d+27|0]);Ab(d+16|0);if(!c){break k}}v[23540]=0;X(122,d|0,b|0,a|0,-1);a=v[23540];v[23540]=0;if((a|0)==1){break i}v[23540]=0;R(123,d+16|0,d|0);a=v[23540];v[23540]=0;if((a|0)==1){break h}v[23540]=0;R(124,f|0,d+16|0);a=v[23540];v[23540]=0;if((a|0)==1){break g}Ab(d+16|0);Ab(d)}kb=d+32|0;return}a=P()|0;O()|0;break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;break f}a=P()|0;O()|0;Ab(d+16|0)}Ab(d)}Ql(f);T(a|0);L()}function Aia(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;d=kb-48|0;kb=d;i=a+484344|0;j=a+480280|0;k=a+906300|0;while(1){a:{if(Qb(v[b>>2],v[b+8>>2],9)){e=d+44|0;po(b,e);c=Bg(b);b:{if(!Sb(e,14020,4)){break b}if(!Sb(d+44|0,13672,4)){break b}if(!Sb(d+44|0,13848,4)){break b}if(!Sb(d+44|0,13853,4)){break b}if(Qb(v[b>>2],v[b+8>>2],c)){break a}}yg(b,8)}kb=d+48|0;return l|0}ae(d,b,c);e=kc(d+24|0,d);Bb(d);c=j;c:{d:{e:{if(!Sb(d+44|0,13538,4)){while(1){if((c|0)==(i|0)){break c}v[23540]=0;f=S(157,e|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break e}t[c+8|0]=f;c=c+32|0;continue}}if(w[d+44|0]!=70){break d}f=w[d+45|0];h=(f|0)==88;f:{if(!h){if((f-48&255)>>>0>9){break d}c=t[d+46|0];if((c|0)>47){break f}break d}c=t[d+46|0];if((c|0)<48){break d}}if(c>>>0>57){break d}g=t[d+47|0];if((g|0)<48|(g|0)>57){break d}c=(g+(h?-16:B(f,100)+48|0)|0)+B(c,10)&255;if(c>>>0>249){break c}v[23540]=0;R(439,e|0,Md(k,c)|0);c=v[23540];v[23540]=0;if((c|0)!=1){break c}}a=P()|0;O()|0;Bb(e);T(a|0);L()}if(Sb(d+44|0,13554,4)){break c}v[a+1074308>>2]=0;l=1}Bb(e);continue}}function WM(a){var b=0,c=0,d=0,e=0,f=0,g=0;while(1){if((f|0)!=4e3){g=kb-32|0;kb=g;b=xt(g);d=w[b+4|0]|w[b+5|0]<<8|(w[b+6|0]<<16|w[b+7|0]<<24);c=(f<<5)+a|0;e=w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24);t[c|0]=e;t[c+1|0]=e>>>8;t[c+2|0]=e>>>16;t[c+3|0]=e>>>24;t[c+4|0]=d;t[c+5|0]=d>>>8;t[c+6|0]=d>>>16;t[c+7|0]=d>>>24;d=w[b+28|0]|w[b+29|0]<<8|(w[b+30|0]<<16|w[b+31|0]<<24);e=w[b+24|0]|w[b+25|0]<<8|(w[b+26|0]<<16|w[b+27|0]<<24);t[c+24|0]=e;t[c+25|0]=e>>>8;t[c+26|0]=e>>>16;t[c+27|0]=e>>>24;t[c+28|0]=d;t[c+29|0]=d>>>8;t[c+30|0]=d>>>16;t[c+31|0]=d>>>24;d=w[b+20|0]|w[b+21|0]<<8|(w[b+22|0]<<16|w[b+23|0]<<24);e=w[b+16|0]|w[b+17|0]<<8|(w[b+18|0]<<16|w[b+19|0]<<24);t[c+16|0]=e;t[c+17|0]=e>>>8;t[c+18|0]=e>>>16;t[c+19|0]=e>>>24;t[c+20|0]=d;t[c+21|0]=d>>>8;t[c+22|0]=d>>>16;t[c+23|0]=d>>>24;d=w[b+12|0]|w[b+13|0]<<8|(w[b+14|0]<<16|w[b+15|0]<<24);b=w[b+8|0]|w[b+9|0]<<8|(w[b+10|0]<<16|w[b+11|0]<<24);t[c+8|0]=b;t[c+9|0]=b>>>8;t[c+10|0]=b>>>16;t[c+11|0]=b>>>24;t[c+12|0]=d;t[c+13|0]=d>>>8;t[c+14|0]=d>>>16;t[c+15|0]=d>>>24;kb=g+32|0;f=f+1|0;continue}break}}function iI(a,b,c,d,e,f,g,h){var i=0,j=0,k=0,l=0,m=0,n=0,o=C(0),p=0;a:{if(w[b+21|0]){p=B(d,g);j=v[e>>2];l=v[f>>2];m=v[b>>2];b:{while(1){if((h|0)>0){if(v[a+1396>>2]<=9){$k(a)}g=v[a+1392>>2];k=u[(((g&1023)<<1)+b|0)+36>>1];c:{if((k|0)>=0){i=g;k=k&65535;g=w[k+v[b+8>>2]|0];v[a+1392>>2]=i>>>g;g=v[a+1396>>2]-g|0;v[a+1396>>2]=(g|0)>0?g:0;k=(g|0)>=0?k:-1;break c}k=hm(a,b)}if((k|0)>=v[b+2092>>2]?w[b+23|0]:0){break a}if((k|0)<0){if(!w[a+1376|0]){b=0;if(v[a+1384>>2]){break b}}ec(a,21);return 0}g=0;n=B(d,l);m=((m+n|0)+j|0)>(p|0)?(p-n|0)+j|0:m;n=(m|0)>0?m:0;k=B(k,v[b>>2]);o=C(0);d:{if(w[b+22|0]){while(1){if((g|0)==(n|0)){break d}o=C(o+z[v[b+28>>2]+(g+k<<2)>>2]);i=v[(j<<2)+c>>2];if(i){i=i+(l<<2)|0;z[i>>2]=o+z[i>>2]}j=j+1|0;i=(j|0)==(d|0);j=i?0:j;g=g+1|0;l=i+l|0;continue}}while(1){if((g|0)==(n|0)){break d}i=v[(j<<2)+c>>2];if(i){i=i+(l<<2)|0;z[i>>2]=z[i>>2]+C(z[v[b+28>>2]+(g+k<<2)>>2]+C(0))}j=j+1|0;i=(j|0)==(d|0);j=i?0:j;g=g+1|0;l=i+l|0;continue}}h=h-m|0;continue}break}v[e>>2]=j;v[f>>2]=l;b=1}return b}ec(a,21);return 0}aa(7512,13179,1887,6554);L()}function Bda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,w=0,x=0,y=0,z=0;g=kb-16|0;kb=g;f=v[a+48>>2];j=v[a+40>>2];k=v[a+36>>2];e=v[a+44>>2];l=v[a+16>>2];b=v[a+4>>2];v[g+8>>2]=v[a>>2];v[g+12>>2]=b;m=v[a+32>>2];n=v[a+28>>2];o=v[a+72>>2];b=v[a+68>>2];p=b;q=b>>31;b=v[a+64>>2];r=b;s=b>>31;b=v[a+60>>2];u=b;w=b>>31;x=v[a+8>>2];y=v[a+12>>2];while(1){b=e;if(d){e=Zb(b,-16777216,16776704);e=Jka(r,s,e,e>>31);i=nb;f=Zb(f,-16777216,16776704);h=Jka(p,q,f,f>>31);e=h+e|0;f=nb+i|0;f=e>>>0<h>>>0?f+1|0:f;i=e;h=v[g+12>>2]+l|0;e=t[h|0];z=i;i=((B(t[h+1|0]-e|0,v[g+8>>2]>>>10&4194048)|0)/16384|0)+(e<<8)<<8;e=i;h=Jka(e,e>>31,u,w);e=z+h|0;f=nb+f|0;f=e>>>0<h>>>0?f+1|0:f;e=e+8388608|0;f=e>>>0<8388608?f+1|0:f;f=Yc(e,f,24);e=(f|0)/256|0;k=k+n|0;v[c>>2]=B(e,k>>12)+v[c>>2];j=j+m|0;v[c+4>>2]=v[c+4>>2]+B(j>>12,e);Rb(g+8|0,x,y);e=f-(i&o)|0;c=c+8|0;d=d-1|0;f=b;continue}break}c=v[g+12>>2];v[a>>2]=v[g+8>>2];v[a+4>>2]=c;v[a+40>>2]=j;v[a+20>>2]=k>>12;v[a+36>>2]=k;v[a+48>>2]=f;v[a+44>>2]=b;v[a+24>>2]=j>>12;kb=g+16|0}function ZN(a,b){var c=0,d=0,e=0,f=0;d=kb-16|0;kb=d;a:{b:{switch(w[a+480224|0]-1|0){default:c=v[a+24620>>2];v[d+12>>2]=1;v[d+8>>2]=v[b+44>>2]<<1;c=Jka(c,c>>31,5e4,0);e=nb;b=v[_c(d+12|0,d+8|0)>>2];c=Hc(Kka(c,e,b,b>>31),nb);break a;case 0:c=v[a+24620>>2];v[d+12>>2]=1;v[d+8>>2]=v[b+44>>2];c=Jka(c,c>>31,1e4,0);e=nb;b=v[_c(d+12|0,d+8|0)>>2];c=Hc(Kka(c,e,b,b>>31),nb);break a;case 1:break b}}f=60/(+y[b+44>>2]/1e4*(+(Jka(v[b+32>>2],0,v[b+40>>2],0)>>>0)+ +(nb>>>0)*4294967296))*+y[a+24620>>2];c:{d:{c=v[a+484344>>2];e=x[b+70>>1];if(!xe(c,v[a+484348>>2],e)){break d}c=_b(c,e);if(!Pb(v[c+24>>2],v[c+28>>2])){break d}c=c+24|0;break c}c=a+480248|0}e=v[c>>2];c=v[c+4>>2];if(!pc(e,c)){f=f*+y[Eb(e,y[b+48>>2]%(uc(e,c)>>>0)|0)>>2]*5.960464477539063e-8}e:{if(D(f)<2147483648){c=~~f;break e}c=-2147483648}f=A[b+8>>3]+(f-+(c>>>0));A[b+8>>3]=f;if(f>=1){A[b+8>>3]=f+-1;c=c+1|0;break a}if(!(A[a+1074384>>3]<=-1)){break a}A[b+8>>3]=f+1;c=c-1|0}b=Jka(v[a+480244>>2],0,c,0)+32768|0;a=nb;a=b>>>0<32768?a+1|0:a;a=Ec((a&65535)<<16|b>>>16,a>>>16|0);kb=d+16|0;return a?a:1}function U9(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=C(0),m=0,n=0,o=C(0);h=u[d>>1];j=u[d+2>>1];a:{if((h|0)>(j|0)){break a}k=v[b>>2];g=uc(k,v[b+4>>2]);if(!g){break a}i=u[e>>1];if((i|0)<(h|0)|(i|0)>(j|0)|(g-1&65535)>>>0>(j-i&65535)>>>0|y[a+36>>2]>65535){break a}b:{while(1){if((f|0)==(g|0)){break b}i=Eb(k,f);f=f+1|0;if(!(z[i>>2]<C(0))){continue}break}return 0}i=(f|0)!=(g|0);f=0;if(i){break a}l=z[c>>2];if(l<=C(0)){break a}u[a+28>>1]=h;u[a>>1]=1;m=a,n=QL(g),u[m+30>>1]=n;z[a+32>>2]=D(l);ek(a+4|0,(j-h|0)+1|0);qh(Fb(v[b>>2]),Fb(v[b+4>>2]),ym(Fb(v[a+4>>2]),u[e>>1]-u[d>>1]|0));c=v[a+4>>2];g=u[a+30>>1];h=u[a+28>>1];b=u[e>>1];f=b;while(1){if((b&65535)!=32768&(f|0)>(h|0)){f=f-1|0;b=f-h|0;j=Eb(c,b+g|0);m=Eb(c,b),o=C(z[j>>2]/z[a+32>>2]),z[m>>2]=o;b=u[e>>1];continue}else{c=u[a+30>>1];e=u[a+28>>1];h=c+e|0;f=g;g=b<<16>>16;f=f+g|0;b=v[a+4>>2];d=u[d+2>>1];c=(g|0)<=(32767-c|0);while(1){if(c&(d|0)>=(f|0)){g=Eb(b,f-h|0);m=Eb(b,f-e|0),o=C(z[a+32>>2]*z[g>>2]),z[m>>2]=o;f=f+1|0;continue}else{Ip(a)}break}}break}f=1}return f|0}function i$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;a=kb-160|0;kb=a;v[a+144>>2]=c;v[a+152>>2]=b;v[a+20>>2]=1154;b=se(a+24|0,a+32|0,a+20|0);h=a+16|0;gd(h,e);v[23540]=0;h=S(19,h|0)|0;i=v[23540];v[23540]=0;if((i|0)!=1){a:{t[a+15|0]=0;e=v[e+4>>2];v[23540]=0;c=qa(1155,a+152|0,c|0,d|0,a+16|0,e|0,f|0,a+15|0,h|0,b|0,a+20|0,a+132|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break a}b:{c:{if(!c){break c}$f(g);if(w[a+15|0]){v[23540]=0;c=Q(20,h|0,45)|0;d=v[23540];v[23540]=0;if((d|0)==1){break a}v[23540]=0;R(47,g|0,c|0);c=v[23540];v[23540]=0;if((c|0)==1){break a}}v[23540]=0;d=Q(20,h|0,48)|0;c=v[23540];v[23540]=0;if((c|0)==1){break b}e=v[a+20>>2];h=e-1|0;c=v[b>>2];d=d&255;while(1){if(!((d|0)!=w[c|0]|c>>>0>=h>>>0)){c=c+1|0;continue}break}v[23540]=0;W(1161,g|0,c|0,e|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){break c}break a}v[23540]=0;c=Q(1122,a+152|0,a+144|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break a}if(c){v[f>>2]=v[f>>2]|2}c=v[a+152>>2];ac(a+16|0);Xc(b);kb=a+160|0;return c|0}}}c=P()|0;O()|0;ac(a+16|0);Xc(b);T(c|0);L()}function Ada(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0;g=kb-16|0;kb=g;f=v[a+48>>2];j=v[a+40>>2];k=v[a+36>>2];e=v[a+44>>2];l=v[a+16>>2];b=v[a+4>>2];v[g+8>>2]=v[a>>2];v[g+12>>2]=b;m=v[a+32>>2];n=v[a+28>>2];o=v[a+72>>2];b=v[a+68>>2];p=b;q=b>>31;b=v[a+64>>2];r=b;s=b>>31;b=v[a+60>>2];t=b;w=b>>31;x=v[a+8>>2];y=v[a+12>>2];while(1){b=e;if(d){e=Zb(b,-16777216,16776704);e=Jka(r,s,e,e>>31);i=nb;f=Zb(f,-16777216,16776704);h=Jka(p,q,f,f>>31);e=h+e|0;f=nb+i|0;f=e>>>0<h>>>0?f+1|0:f;i=e;h=(v[g+12>>2]<<1)+l|0;e=u[h>>1];z=i;i=e+((B(u[h+2>>1]-e|0,v[g+8>>2]>>>18|0)|0)/16384|0)<<8;e=i;h=Jka(e,e>>31,t,w);e=z+h|0;f=nb+f|0;f=e>>>0<h>>>0?f+1|0:f;e=e+8388608|0;f=e>>>0<8388608?f+1|0:f;f=Yc(e,f,24);e=(f|0)/256|0;k=k+n|0;v[c>>2]=B(e,k>>12)+v[c>>2];j=j+m|0;v[c+4>>2]=v[c+4>>2]+B(j>>12,e);Rb(g+8|0,x,y);e=f-(i&o)|0;c=c+8|0;d=d-1|0;f=b;continue}break}c=v[g+12>>2];v[a>>2]=v[g+8>>2];v[a+4>>2]=c;v[a+40>>2]=j;v[a+20>>2]=k>>12;v[a+36>>2]=k;v[a+48>>2]=f;v[a+44>>2]=b;v[a+24>>2]=j>>12;kb=g+16|0}function Zy(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=kb-16|0;kb=e;f=a+1074312|0;Db(e+8|0,f,77);a:{if(j=Cb(v[v[e+8>>2]>>2],v[e+12>>2]),k=0,l=v[c+88>>2]&134218752,l?j:k){break a}b:{c:{if(d){g=w[c+841|0];if(!g){break c}d=g-1|0;t[c+841|0]=d;if(d&255){break b}Db(e+8|0,f,16);if(!Cb(v[v[e+8>>2]>>2],v[e+12>>2])&v[a+480180>>2]!=2){break a}a=v[b+48>>2]+1|0}else{a=v[b+48>>2]}v[c+764>>2]=a;break a}Db(e+8|0,f,17);d:{if(Cb(v[v[e+8>>2]>>2],v[e+12>>2])|v[a+480180>>2]&3){break d}g=b+616|0;i=x[a+480188>>1];while(1){if((h&65535)>>>0>=i>>>0){break d}if(w[g+841|0]?(c|0)!=(g|0):0){break a}g=g+872|0;h=h+1|0;continue}}t[c+841|0]=d}d=v[c+764>>2];v[b+56>>2]=d;e:{if((d|0)==-1){break e}f:{if(v[b+60>>2]==-1){break f}Db(e+8|0,f,68);if(!Cb(v[v[e+8>>2]>>2],v[e+12>>2])){break f}v[b+60>>2]=d}v[b+64>>2]=d;Db(e+8|0,f,103);if(!Cb(v[v[e+8>>2]>>2],v[e+12>>2])){break e}u[b+68>>1]=65535}if(v[a+480180>>2]!=2){break a}d=x[a+480188>>1];a=0;while(1){if((a|0)==(d|0)){break a}f=B(a,872)+b|0;v[f+1380>>2]=v[c+764>>2];t[f+1457|0]=w[c+841|0];a=a+1|0;continue}}kb=e+16|0}function cR(a){a=a|0;var b=0,c=0,d=0,e=0;c=kb-80|0;kb=c;v[c+72>>2]=0;v[c+76>>2]=0;b=c- -64|0;v[b>>2]=0;v[b+4>>2]=0;v[c+56>>2]=0;v[c+60>>2]=0;v[c+48>>2]=0;v[c+52>>2]=0;Iz(a,Jz(a),c+48|0);b=rc(c+40|0,14213);gf(ye(a,0),v[b>>2],v[b+4>>2]);b=rc(c+32|0,14317);gf(ye(a,1),v[b>>2],v[b+4>>2]);b=rc(c+24|0,5499);gf(ye(a,3),v[b>>2],v[b+4>>2]);b=rc(c+16|0,15740);gf(ye(a,4),v[b>>2],v[b+4>>2]);b=rc(c+8|0,9294);gf(ye(a,8),v[b>>2],v[b+4>>2]);e=ye(a+288|0,0);b=kb-16|0;kb=b;d=e;e=rc(b+8|0,4935);gf(d,v[e>>2],v[e+4>>2]);kb=b+16|0;e=a+800|0;b=0;a=kb-80|0;kb=a;a:{b:{while(1){if((b|0)==128){break a}v[a+76>>2]=b<<3;c:{d:{if(b>>>0<=15){Iu(a+32|0,4087);v[23540]=0;R(287,a+16|0,a+76|0);d=v[23540];v[23540]=0;if((d|0)==1){break c}v[23540]=0;U(288,a+48|0,a+32|0,a+16|0);d=v[23540];v[23540]=0;if((d|0)!=1){d=a+48|0;Fe(a- -64|0,d);gf(ye(e,b),v[a+64>>2],v[a+68>>2]);zb(d);zb(a+16|0);Xb(a+32|0);break d}b=P()|0;O()|0;zb(a+16|0);break b}d=rc(a+8|0,21688);gf(ye(e,b),v[d>>2],v[a+12>>2])}b=b+1|0;continue}break}b=P()|0;O()|0}Xb(a+32|0);T(b|0);L()}kb=a+80|0;kb=c+80|0}function k6(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;v[23540]=0;Y(971,a|0);e=v[23540];v[23540]=0;a:{b:{c:{d:{e:{if((e|0)==1){break e}v[23540]=0;Y(947,b|0);e=v[23540];v[23540]=0;if((e|0)==1){break e}e=0;v[23540]=0;Y(972,c|0);f=v[23540];v[23540]=0;if((f|0)==1){break e}a=Ub(c,0,d);if(!w[b|0]){break b}if(yi(b,7226)|(d|0)!=8){break d}v[a+4>>2]=973;v[a>>2]=974;break c}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,12265,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)==1){break a}$();return 0}if(!(yi(b,11230)|(d|0)!=64)){v[a+60>>2]=975;v[a+56>>2]=976;v[a+52>>2]=977;v[a+48>>2]=978;v[a+44>>2]=979;v[a+40>>2]=980;v[a+36>>2]=981;v[a+32>>2]=982;v[a+28>>2]=983;v[a+24>>2]=984;v[a+20>>2]=985;v[a+16>>2]=986;v[a+12>>2]=987;v[a+8>>2]=988;v[a+4>>2]=989;v[a>>2]=990;break c}if(!(yi(b,15226)|(d|0)!=24)){v[a+20>>2]=991;v[a+16>>2]=992;v[a+12>>2]=993;v[a+8>>2]=994;v[a+4>>2]=995;v[a>>2]=996;break c}if(yi(b,15027)|(d|0)!=4){break b}v[a>>2]=997}e=1}return e|0}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function go(a,b,c,d){var e=0;e=kb-16|0;kb=e;t[a+841|0]=0;v[a+708>>2]=0;t[a+797|0]=0;v[a+764>>2]=0;v[a+800>>2]=0;v[a+696>>2]=0;v[a+668>>2]=0;u[a+804>>1]=0;v[a+88>>2]=v[a+88>>2]|6144;Db(e+8|0,b+1074312|0,23);if(Cb(v[v[e+8>>2]>>2],v[e+12>>2])){t[a+807|0]=1;t[a+808|0]=0}t[a+846|0]=0;t[a+839|0]=0;u[a+774>>1]=0;t[a+850|0]=255;v[a+660>>2]=0;t[a+851|0]=w[a+851|0]&224;ko(a+788|0);v[a+84>>2]=0;v[a+76>>2]=0;v[a+80>>2]=0;v[a+700>>2]=0;v[a+656>>2]=0;v[a+104>>2]=0;v[a+92>>2]=0;v[a+96>>2]=0;v[a>>2]=0;v[a+4>>2]=0;v[a+8>>2]=0;v[a+12>>2]=0;t[a+845|0]=0;t[a+838|0]=0;t[a+821|0]=0;v[a+688>>2]=0;v[a+672>>2]=0;v[a+676>>2]=0;u[a+836>>1]=32512;t[a+819|0]=0;t[a+820|0]=0;u[a+842>>1]=0;v[a+28>>2]=0;v[a+32>>2]=0;v[a+20>>2]=0;v[a+24>>2]=0;v[a+852>>2]=0;v[a+856>>2]=0;t[a+851|0]=w[a+851|0]&159;a:{if(c>>>0<=126){b=(c<<5)+b|0;c=v[b+480280>>2];v[a+88>>2]=c;v[a+692>>2]=x[b+480284>>1];v[a+748>>2]=x[b+480286>>1];if(!(c&1024)){break a}v[a+88>>2]=c&-1025|d;break a}v[a+748>>2]=64;v[a+692>>2]=128;v[a+88>>2]=0}u[a+784>>1]=0;t[a+795|0]=0;t[a+796|0]=0;kb=e+16|0}function dI(a,b,c){var d=0,e=0,f=0,g=0,h=0;d=kb-208|0;kb=d;v[d+8>>2]=1;v[d+12>>2]=0;h=b<<2;a:{if(!h){break a}v[d+16>>2]=4;v[d+20>>2]=4;b=4;g=4;e=2;while(1){f=b;b=(b+g|0)+4|0;v[(d+16|0)+(e<<2)>>2]=b;e=e+1|0;g=f;if(b>>>0<h>>>0){continue}break}f=(a+h|0)-4|0;b:{if(f>>>0<=a>>>0){e=1;b=1;f=0;break b}e=1;b=1;while(1){c:{if((e&3)==3){dx(a,c,b,d+16|0);ns(d+8|0,2);b=b+2|0;break c}g=b-1|0;d:{if(y[(d+16|0)+(g<<2)>>2]>=f-a>>>0){ms(a,c,e,v[d+12>>2],b,0,d+16|0);break d}dx(a,c,b,d+16|0)}if((b|0)==1){ls(d+8|0,1);b=0;break c}ls(d+8|0,g);b=1}e=v[d+8>>2]|1;v[d+8>>2]=e;a=a+4|0;if(f>>>0>a>>>0){continue}break}f=v[d+12>>2]}ms(a,c,e,f,b,0,d+16|0);e=v[d+8>>2];g=v[d+12>>2];if(!(g?1:(b|0)!=1|(e|0)!=1)){break a}while(1){e:{if((b|0)<=1){f=YH(e,g);ns(d+8|0,f);b=b+f|0;break e}g=d+8|0;ls(g,2);v[d+8>>2]=v[d+8>>2]^7;ns(g,1);h=a-4|0;e=d+16|0;f=b-2|0;ms(h-v[e+(f<<2)>>2]|0,c,v[d+8>>2],v[d+12>>2],b-1|0,1,e);ls(g,1);b=v[d+8>>2]|1;v[d+8>>2]=b;ms(h,c,b,v[d+12>>2],f,1,e);b=f}a=a-4|0;g=v[d+12>>2];e=v[d+8>>2];if(g|((b|0)!=1|(e|0)!=1)){continue}break}}kb=d+208|0}function Qda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,C=0,D=0;g=kb-16|0;kb=g;o=v[a+16>>2];l=Tf(1,2);b=nb;p=b;Rb(a,l,b);f=v[a+48>>2];i=v[a+40>>2];j=v[a+36>>2];e=v[a+44>>2];b=v[a+4>>2];v[g+8>>2]=v[a>>2];v[g+12>>2]=b;q=v[a+32>>2];r=v[a+28>>2];s=v[a+72>>2];b=v[a+68>>2];t=b;w=b>>31;b=v[a+64>>2];x=b;y=b>>31;b=v[a+60>>2];z=b;A=b>>31;C=v[a+8>>2];D=v[a+12>>2];while(1){b=e;if(d){m=u[(v[g+12>>2]<<1)+o>>1]<<8;e=m;e=Jka(e,e>>31,z,A);k=nb;h=e;e=Zb(b,-16777216,16776704);n=Jka(x,y,e,e>>31);h=h+n|0;e=nb+k|0;e=h>>>0<n>>>0?e+1|0:e;f=Zb(f,-16777216,16776704);k=Jka(t,w,f,f>>31);h=k+h|0;f=nb+e|0;f=h>>>0<k>>>0?f+1|0:f;e=h+8388608|0;f=e>>>0<8388608?f+1|0:f;f=Yc(e,f,24);e=(f|0)/256|0;j=j+r|0;v[c>>2]=B(e,j>>12)+v[c>>2];i=i+q|0;v[c+4>>2]=v[c+4>>2]+B(i>>12,e);Rb(g+8|0,C,D);e=f-(s&m)|0;c=c+8|0;d=d-1|0;f=b;continue}break}c=v[g+12>>2];v[a>>2]=v[g+8>>2];v[a+4>>2]=c;v[a+40>>2]=i;v[a+20>>2]=j>>12;v[a+36>>2]=j;v[a+48>>2]=f;v[a+44>>2]=b;v[a+24>>2]=i>>12;mg(a,l,p);kb=g+16|0}function oO(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;f=kb-32|0;kb=f;n=mz(v[a+24>>2],w[a+32|0]);o=tj(n);a:{while(1){b:{u[b>>1]=m;d=m&65535;if(d>>>0>=o>>>0){break b}c:{if(!Jq(n,d)){break c}d=v[a>>2];h=yd(d,v[a+4>>2]);e=x[b>>1];if(h>>>0<=e>>>0){v[c>>2]=0;break a}k=Nd(d,e);tl(f+16|0,v[k>>2]);Cm(f+8|0,v[k>>2],v[k+4>>2]);i=f+24|0;d=v[f+16>>2];g=v[f+20>>2];e=sl(v[f+8>>2],v[f+12>>2],d,g);j=kb-16|0;kb=j;v[j+12>>2]=e;d:{if(g){h=32-g|0;v[j+8>>2]=h;l=h;h=v[Kb(j+8|0,j+12|0)>>2];l=-1<<g&-1>>>l-h&v[d>>2];if(l){hc(i,d,Ika(l));break d}if((e|0)==(h|0)){v[i>>2]=d;v[i+4>>2]=g;OP(i,e);break d}e=e-h|0;d=d+4|0}while(1){if(e>>>0>=32){g=v[d>>2];if(g){hc(i,d,Ika(g));break d}else{e=e-32|0;v[j+12>>2]=e;d=d+4|0;continue}}break}if(!e){hc(i,d,0);break d}g=v[d>>2]&-1>>>32-e;if(!g){hc(i,d,e);break d}hc(i,d,Ika(g))}kb=j+16|0;Cm(f,v[k>>2],v[k+4>>2]);if(!(v[f+24>>2]==v[f>>2]&v[f+28>>2]==v[f+4>>2])){break c}v[c>>2]=0;break a}m=x[b>>1]+1|0;continue}break}u[b>>1]=65535;v[c>>2]=-1}kb=f+32|0;return(m&65535)>>>0<o>>>0|0}function S8(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=C(0),h=0,i=0;c=kb-32|0;kb=c;a:{d=v[a+20>>2];b:{if(!d){break b}v[d+148>>2]=-1;h=c,i=ob[v[v[a>>2]+40>>2]](a)|0,v[h+16>>2]=i;v[c+8>>2]=1073741822;f=v[Kb(c+16|0,c+8|0)>>2];b=f<<2;if(!b){break b}e=v[a+20>>2];d=0;v[23540]=0;R(285,e+4|0,b+4|0);b=v[23540];v[23540]=0;c:{d:{if((b|0)!=1){b=v[a+20>>2];re(c+8|0,v[b+4>>2],v[b+8>>2]);v[c>>2]=0;v[c+4>>2]=0;e=v[c+12>>2];b=c+16|0;v[b>>2]=v[c+8>>2];v[b+4>>2]=e;e=v[c+4>>2];v[b+8>>2]=v[c>>2];v[b+12>>2]=e;e=kb-16|0;kb=e;v[e+8>>2]=0;kL(b,e+8|0);kb=e+16|0;b=v[v[a>>2]+184>>2];v[23540]=0;R(b|0,a|0,-1);b=v[23540];v[23540]=0;if((b|0)==1){break d}while(1){if((d|0)==(f|0)){d=v[v[a>>2]+188>>2];v[23540]=0;Y(d|0,a|0);d=v[23540];v[23540]=0;if((d|0)!=1){break b}break d}b=v[v[a>>2]+48>>2];v[23540]=0;g=C(ab(b|0,a|0,d|0));b=v[23540];v[23540]=0;if((b|0)!=1){z[c+8>>2]=g;d=d+1|0;kL(c+16|0,c+8|0);continue}break}d=V(92756)|0;break c}d=V(92756)|0;break c}d=V(92756)|0}if((O()|0)!=(ea(92756)|0)){break a}_(d|0)|0;Lc(v[a+20>>2]+4|0);$()}kb=c+32|0;return}T(d|0);L()}function Rda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,w=0,x=0,y=0,z=0,A=0,C=0,D=0;g=kb-16|0;kb=g;o=v[a+16>>2];l=Tf(1,2);b=nb;p=b;Rb(a,l,b);f=v[a+48>>2];i=v[a+40>>2];j=v[a+36>>2];e=v[a+44>>2];b=v[a+4>>2];v[g+8>>2]=v[a>>2];v[g+12>>2]=b;q=v[a+32>>2];r=v[a+28>>2];s=v[a+72>>2];b=v[a+68>>2];u=b;w=b>>31;b=v[a+64>>2];x=b;y=b>>31;b=v[a+60>>2];z=b;A=b>>31;C=v[a+8>>2];D=v[a+12>>2];while(1){b=e;if(d){m=t[v[g+12>>2]+o|0]<<16;e=m;e=Jka(e,e>>31,z,A);k=nb;h=e;e=Zb(b,-16777216,16776704);n=Jka(x,y,e,e>>31);h=h+n|0;e=nb+k|0;e=h>>>0<n>>>0?e+1|0:e;f=Zb(f,-16777216,16776704);k=Jka(u,w,f,f>>31);h=k+h|0;f=nb+e|0;f=h>>>0<k>>>0?f+1|0:f;e=h+8388608|0;f=e>>>0<8388608?f+1|0:f;f=Yc(e,f,24);e=(f|0)/256|0;j=j+r|0;v[c>>2]=B(e,j>>12)+v[c>>2];i=i+q|0;v[c+4>>2]=v[c+4>>2]+B(i>>12,e);Rb(g+8|0,C,D);e=f-(s&m)|0;c=c+8|0;d=d-1|0;f=b;continue}break}c=v[g+12>>2];v[a>>2]=v[g+8>>2];v[a+4>>2]=c;v[a+40>>2]=i;v[a+20>>2]=j>>12;v[a+36>>2]=j;v[a+48>>2]=f;v[a+44>>2]=b;v[a+24>>2]=i>>12;mg(a,l,p);kb=g+16|0}function yka(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;h=kb-32|0;kb=h;e=b;b=v[a>>2];b=(Ao(e,Fb(b))<<1)+b|0;a:{b:{f=v[a+4>>2];if(f>>>0<y[Gb(a)>>2]){if((b|0)!=(f|0)){break b}d=kb-16|0;kb=d;a=ai(d,a,1);Kj(v[a+4>>2],w[c|0]|w[c+1|0]<<8);v[a+4>>2]=v[a+4>>2]+2;lc(a);kb=d+16|0;break a}d=Gb(a);d=Nj(h+8|0,Oj(a,Rc(v[a>>2],f)+1|0),b-v[a>>2]>>1,d);v[23540]=0;R(292,d|0,c|0);c=v[23540];v[23540]=0;if((c|0)!=1){c=v[d+4>>2];f=d+4|0;hq(v[a>>2],b,f);g=v[a+4>>2];e=d+8|0;while(1){if((b|0)!=(g|0)){Kj(v[e>>2],w[b|0]|w[b+1|0]<<8);v[e>>2]=v[e>>2]+2;b=b+2|0;continue}break}qc(a,f);qc(a+4|0,e);qc(Gb(a),Cc(d));v[d>>2]=v[d+4>>2];b=c;Ni(d);break a}a=P()|0;O()|0;Ni(d);T(a|0);L()}i=kb-16|0;kb=i;j=v[a+4>>2];e=(j-(b+2|0)|0)+b|0;k=ai(i,a,f-e>>1);g=v[k+4>>2];d=e;while(1){if(d>>>0>=f>>>0){lc(k);while(1){if((b|0)!=(e|0)){e=e-2|0;j=nV(j-2|0,e);continue}break}kb=i+16|0}else{Kj(g,w[d|0]|w[d+1|0]<<8);g=g+2|0;v[k+4>>2]=g;d=d+2|0;continue}break}a=((b>>>0<=c>>>0&y[a+4>>2]>c>>>0)<<1)+c|0;c=w[a|0];t[b+1|0]=w[a+1|0];t[b|0]=c}Fb(b);kb=h+32|0}function xca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=kb-16|0;kb=e;p=v[a+16>>2];q=kg(b+327720|0,v[b+20>>2],(v[a+88>>2]&16384)>>>14|0);l=v[a+128>>2];a:{if(!l){k=v[a+8>>2];m=v[a+12>>2];f=v[a>>2];b=v[a+4>>2];h=0;break a}b=v[a+12>>2];m=b;k=v[a+8>>2];n=lg(k,b,l);o=nb;h=v[a+76>>2];f=v[a>>2];b=v[a+4>>2];Qf(f,b,qf(k,m,d),nb);h=h>>>0<nb>>>0?d:0}g=a+112|0;i=v[a+40>>2];j=v[a+36>>2];v[e>>2]=f;v[e+4>>2]=b;b:while(1){if(d){d=d-1|0;v[e+8>>2]=f;v[e+12>>2]=0;h=h-1|0;n=h?n:0;o=h?o:0;f=(b<<1)+p|0;b=l;while(1)if((b|0)<=0){Rb(g,v[a+120>>2],v[a+124>>2]);b=v[a+116>>2];if(b){Sd(g,u[f+(v[e+12>>2]<<1)>>1]/4<<16>>16);Rd(g,b);v[g>>2]=v[g>>2];v[g+4>>2]=0}b=v[a+32>>2];j=v[a+28>>2]+j|0;f=jg(g,q);v[c>>2]=B(j>>12,f)+v[c>>2];i=b+i|0;v[c+4>>2]=v[c+4>>2]+B(f,i>>12);Rb(e,k,m);c=c+8|0;f=v[e>>2];b=v[e+4>>2];continue b}else{Sd(g,u[f+(v[e+12>>2]<<1)>>1]/4<<16>>16);Rd(g,4);Rb(e+8|0,n,o);b=b-1|0;continue}}break}v[a>>2]=f;v[a+4>>2]=b;v[a+40>>2]=i;v[a+20>>2]=j>>12;v[a+36>>2]=j;v[a+24>>2]=i>>12;kb=e+16|0}function cda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;f=kb-16|0;kb=f;a:{b:{c:{g=v[a+12>>2];i=v[a+8>>2];d:{if((g|0)<=1&i>>>0<=805306368|(g|0)<=0){if((g|0)>=-2&i>>>0>=3489660928|(g|0)>-2){break c}if((g|0)==-2&i>>>0>2147483647|g>>>0>4294967294){break d}break b}if((g|0)==1&i>>>0>2147483648|g>>>0>1){break b}}b=b+196648|0;break a}b=b+131112|0;break a}b=b+262184|0}l=v[a+16>>2];j=v[a+40>>2];k=v[a+36>>2];e=v[a+4>>2];v[f+8>>2]=v[a>>2];v[f+12>>2]=e;m=v[a+32>>2];n=v[a+28>>2];while(1){if(d){e=(v[f+12>>2]<<1)+l|0;h=(v[f+8>>2]>>>16&65520)+b|0;e=(((((((B(u[e-4>>1],u[h+2>>1])+B(u[e-6>>1],u[h>>1])|0)+B(u[e-2>>1],u[h+4>>1])|0)+B(u[e>>1],u[h+6>>1])|0)+B(u[e+2>>1],u[h+8>>1])|0)+B(u[e+4>>1],u[h+10>>1])|0)+B(u[e+6>>1],u[h+12>>1])|0)+B(u[e+8>>1],u[h+14>>1])|0)/32768|0;k=k+n|0;v[c>>2]=v[c>>2]+B(e,k>>12);j=j+m|0;v[c+4>>2]=v[c+4>>2]+B(e,j>>12);Rb(f+8|0,i,g);c=c+8|0;d=d-1|0;continue}break}b=v[f+12>>2];v[a>>2]=v[f+8>>2];v[a+4>>2]=b;v[a+40>>2]=j;v[a+20>>2]=k>>12;v[a+36>>2]=k;v[a+24>>2]=j>>12;kb=f+16|0}function yP(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=C(0),m=0,n=0;i=kb-16|0;kb=i;if(xj(v[a+656>>2])){e=w[a+797|0];g=$c(e);f=w[a+799|0];Db(i+8|0,d+1074312|0,34);d=g?e:f;a:{if(!Cb(v[v[i+8>>2]>>2],v[i+12>>2])){break a}e=d&255;if(!e|e>>>0>120){break a}d=w[Lb(v[a+656>>2]+108|0,e-1|0)|0]}l=C(C(v[a+704>>2])*b);e=v[v[a+656>>2]+44>>2];f=((d&255)+c<<16)-3997696>>16;b:{c:{c=v[a+852>>2]+u[a+772>>1]|0;if(c){h=v[e+36>>2];if(h){break c}}b=qm(e,c+f<<16>>16);break b}k=h+1|0;j=Xx(c,k);d=Qn(c,k);b=C(1);g=u[e+28>>1];c=f+j<<16>>16;d:{if((g|0)>(c|0)){break d}f=v[e+4>>2];if((c|0)>(uc(f,v[e+8>>2])+g<<16)-65536>>16){break d}if(!d){b=z[Eb(f,c-g|0)>>2];break b}e:{f:{g:{switch(x[e>>1]-1|0){case 2:h=v[e+16>>2];if(!uc(h,v[e+20>>2])){break f}b=z[Eb(h,d-1|0)>>2];break e;case 0:break g;default:break f}}j=v[e+16>>2];if(!uc(j,v[e+20>>2])){break f}b=z[Eb(j,(d+B(h,Qn(c,x[e+30>>1])<<16>>16)|0)-1|0)>>2];break e}b=te(C(qm(e,(c<<16)+65536>>16)/qm(e,c)),C(C(d|0)/C(k|0)))}b=C(b*z[Eb(f,c-g|0)>>2])}}m=a,n=wj(C(C(l*b)*C(16))),v[m+700>>2]=n}kb=i+16|0}function naa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=kb-16|0;kb=d;nd(c,0);u[d+14>>1]=w[a+36|0]|w[a+37|0]<<8;u[d+12>>1]=32767;g=c,h=(x[Wc(d+14|0,d+12|0)>>1]<<8>>>0)/32767|0,u[g+28>>1]=h;u[d+10>>1]=w[a+38|0]|w[a+39|0]<<8;u[d+8>>1]=32767;g=c,h=(x[Wc(d+10|0,d+8|0)>>1]<<8>>>0)/32767|0,u[g+30>>1]=h;u[c+32>>1]=64;v[c>>2]=w[a+44|0]|w[a+45|0]<<8|(w[a+46|0]<<16|w[a+47|0]<<24);v[c+4>>2]=w[a+48|0]|w[a+49|0]<<8|(w[a+50|0]<<16|w[a+51|0]<<24);v[c+8>>2]=w[a+52|0]|w[a+53|0]<<8|(w[a+54|0]<<16|w[a+55|0]<<24);v[c+24>>2]=w[a+56|0]|w[a+57|0]<<8|(w[a+58|0]<<16|w[a+59|0]<<24);e=w[b+166|0];if(e>>>0<=4){t[c+38|0]=w[e+42778|0]}e=w[b+167|0]|w[b+168|0]<<8;t[c+39|0]=e;f=(w[b+171|0]|w[b+172|0]<<8)>>>4|0;t[c+41|0]=f;b=(w[b+169|0]|w[b+170|0]<<8)>>>2|0;t[c+40|0]=b;if((b|f)&255){t[c+39|0]=e^-1}b=w[a+40|0]|w[a+41|0]<<8;if(b&4){u[c+34>>1]=x[c+34>>1]|1;b=w[a+40|0]|w[a+41|0]<<8}if(b&8){u[c+34>>1]=x[c+34>>1]|2;b=w[a+40|0]|w[a+41|0]<<8}if(b&16){u[c+34>>1]=x[c+34>>1]|4;b=w[a+40|0]|w[a+41|0]<<8}if(b&32){u[c+34>>1]=x[c+34>>1]|32}kb=d+16|0}function sJ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=kb+-64|0;kb=c;f=v[a>>2];a=v[f>>2];g=v[a+4>>2];v[c+40>>2]=v[a+20>>2];e=v[a+16>>2];v[c+32>>2]=v[a+12>>2];v[c+36>>2]=e;Hf(c+48|0,c+32|0,g);a=v[f+4>>2];f=v[a+8>>2];g=v[a+4>>2];e=v[c+60>>2];v[c+24>>2]=v[c+56>>2];v[c+28>>2]=e;e=v[c+52>>2];v[c+16>>2]=v[c+48>>2];v[c+20>>2]=e;v[c+8>>2]=v[a+8>>2];e=v[a+4>>2];v[c>>2]=v[a>>2];v[c+4>>2]=e;a:{b:{c:{d:{e=v[c+4>>2];if(g>>>0<=e>>>0){if(g>>>0>y[c+20>>2]){break d}if(f>>>0>y[c+8>>2]){break c}j=v[c+28>>2];if(f>>>0>v[c+24>>2]-j>>>0){break b}k=b+12|0;l=v[c+16>>2];m=v[c>>2];e:while(1){if((f|0)==(h|0)){break a}n=h+j|0;o=B(e,h);a=0;while(1)if((a|0)==(g|0)){h=h+1|0;continue e}else{d=Eb(v[b>>2],a);i=d;d=v[(a+o<<2)+m>>2]+(v[d>>2]>>1)|0;p=d;d=ws(k)+d&-4096;v[i>>2]=p-d;i=v[(a<<2)+l>>2]+(n<<1)|0;d=ld(d|2048,12);d=(d|0)<32767?d:32767;u[i>>1]=(d|0)>-32768?d:-32768;a=a+1|0;continue}}}aa(7192,9074,33,8787);L()}aa(7157,9074,34,8787);L()}aa(5900,9074,35,8787);L()}aa(5870,9074,36,8787);L()}kb=c- -64|0}function kJ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=kb+-64|0;kb=c;f=v[a>>2];a=v[f>>2];g=v[a+4>>2];v[c+40>>2]=v[a+20>>2];e=v[a+16>>2];v[c+32>>2]=v[a+12>>2];v[c+36>>2]=e;Hf(c+48|0,c+32|0,g);a=v[f+4>>2];f=v[a+8>>2];g=v[a+4>>2];e=v[c+60>>2];v[c+24>>2]=v[c+56>>2];v[c+28>>2]=e;e=v[c+52>>2];v[c+16>>2]=v[c+48>>2];v[c+20>>2]=e;v[c+8>>2]=v[a+8>>2];e=v[a+4>>2];v[c>>2]=v[a>>2];v[c+4>>2]=e;a:{b:{c:{d:{e=v[c+4>>2];if(g>>>0<=e>>>0){i=v[c+20>>2];if(g>>>0>i>>>0){break d}if(f>>>0>y[c+8>>2]){break c}j=v[c+28>>2];if(f>>>0>v[c+24>>2]-j>>>0){break b}k=b+12|0;l=v[c+16>>2];m=v[c>>2];e:while(1){if((f|0)==(h|0)){break a}n=B(e,h);o=B(h+j|0,i);a=0;while(1)if((a|0)==(g|0)){h=h+1|0;continue e}else{d=Eb(v[b>>2],a);p=d;d=v[(a+n<<2)+m>>2]+(v[d>>2]>>1)|0;q=d;d=ws(k)+d&-4096;v[p>>2]=q-d;d=ld(d|2048,12);d=(d|0)<32767?d:32767;u[(a+o<<1)+l>>1]=(d|0)>-32768?d:-32768;a=a+1|0;continue}}}aa(7192,9074,33,8787);L()}aa(7157,9074,34,8787);L()}aa(5900,9074,35,8787);L()}aa(5870,9074,36,8787);L()}kb=c- -64|0}function Wia(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=kb-16|0;kb=e;d=Ih(b,c);n=e,o=Ib(w[a|0]|w[a+1|0]<<8),u[n+14>>1]=o;u[e+12>>1]=64;Qg(d,x[Wc(e+14|0,e+12|0)>>1]);n=d,o=Ib(w[a+14|0]|w[a+15|0]<<8),t[n+13|0]=o;n=d,o=Ib(w[a+16|0]|w[a+17|0]<<8),t[n+14|0]=o;n=d,o=Ib(w[a+20|0]|w[a+21|0]<<8),t[n+15|0]=o;n=d,o=Ib(w[a+22|0]|w[a+23|0]<<8),t[n+16|0]=o;h=v[d>>2];j=v[d+4>>2];b=w[d+12|0]&-2|pc(h,j)^1;t[d+12|0]=b;b=Ib(w[a+12|0]|w[a+13|0]<<8)>>>3&2|b&-3;t[d+12|0]=b;n=d,o=Ib(w[a+12|0]|w[a+13|0]<<8)>>>3&4|b&251,t[n+12|0]=o;b=4096;a:{b:{switch(c-1|0){case 0:i=-128;b=127;break a;case 1:break b;default:break a}}i=-1616;b=1616}b=b-i|0;l=b;c=b>>>1&32767;b=0;while(1){if($d(h,j)>>>0<=b>>>0){kb=e+16|0}else{d=Eb(h,b);u[d>>1]=k;m=d;g=(b<<2)+a|0;f=pe((w[g+28|0]|w[g+29|0]<<8)<<16>>16)+i|0;d=f>>31;d=d<<6|f>>>26;f=c+(f<<6)|0;d=f>>>0<c>>>0?d+1|0:d;n=m,o=tg(Hc(Kka(f,d,l,0),nb)),t[n+2|0]=o;n=e,o=Ib(w[g+26|0]|w[g+27|0]<<8),u[n+10>>1]=o;u[e+8>>1]=1;b=b+1|0;k=x[ke(e+10|0,e+8|0)>>1]+k|0;continue}break}}function hI(a,b,c,d,e){var f=C(0),g=0,h=C(0),i=0,j=C(0),k=C(0);if(!(a&3)){c=(c<<2)+b|0;d=c+(d<<2)|0;a=a>>2;while(1){if((a|0)>0){b=d-4|0;h=z[b>>2];j=z[c>>2];k=z[d>>2];z[c>>2]=j+k;g=c-4|0;f=z[g>>2];z[g>>2]=f+z[b>>2];j=C(j-k);f=C(f-h);z[d>>2]=C(j*z[e>>2])-C(z[e+4>>2]*f);z[b>>2]=C(f*z[e>>2])+C(j*z[e+4>>2]);b=d-12|0;j=z[b>>2];g=c-8|0;f=z[g>>2];i=g;g=d-8|0;k=z[g>>2];z[i>>2]=f+k;i=c-12|0;h=z[i>>2];z[i>>2]=h+z[b>>2];f=C(f-k);h=C(h-j);z[g>>2]=C(f*z[e+32>>2])-C(z[e+36>>2]*h);z[b>>2]=C(h*z[e+32>>2])+C(f*z[e+36>>2]);b=d-20|0;j=z[b>>2];g=c-16|0;f=z[g>>2];i=g;g=d-16|0;k=z[g>>2];z[i>>2]=f+k;i=c-20|0;h=z[i>>2];z[i>>2]=h+z[b>>2];f=C(f-k);h=C(h-j);z[g>>2]=C(f*z[e+64>>2])-C(z[e+68>>2]*h);z[b>>2]=C(h*z[e+64>>2])+C(f*z[e+68>>2]);b=d-28|0;j=z[b>>2];g=c-24|0;f=z[g>>2];i=g;g=d-24|0;k=z[g>>2];z[i>>2]=f+k;i=c-28|0;h=z[i>>2];z[i>>2]=h+z[b>>2];f=C(f-k);h=C(h-j);z[g>>2]=C(f*z[e+96>>2])-C(z[e+100>>2]*h);z[b>>2]=C(h*z[e+96>>2])+C(f*z[e+100>>2]);a=a-1|0;d=d-32|0;c=c-32|0;e=e+128|0;continue}break}return}aa(15829,13179,2423,9240);L()}function oda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0;h=kb-16|0;kb=h;f=v[a+48>>2];l=v[a+24>>2];m=v[a+20>>2];e=v[a+44>>2];n=v[a+16>>2];b=v[a+4>>2];v[h+8>>2]=v[a>>2];v[h+12>>2]=b;o=v[a+72>>2];b=v[a+68>>2];p=b;q=b>>31;b=v[a+64>>2];r=b;s=b>>31;b=v[a+60>>2];t=b;w=b>>31;x=v[a+8>>2];y=v[a+12>>2];while(1){b=e;if(d){e=Zb(b,-16777216,16776704);e=Jka(r,s,e,e>>31);i=nb;z=e;e=(v[h+12>>2]<<1)+n|0;g=v[h+8>>2]>>>21&2040;j=(((B(u[e>>1],u[g+39778>>1])+B(u[e-2>>1],u[g+39776>>1])|0)+B(u[e+2>>1],u[g+39780>>1])|0)+B(u[e+4>>1],u[g+39782>>1])|0)/16384<<8;e=j;k=Jka(e,e>>31,t,w);g=z+k|0;e=nb+i|0;e=g>>>0<k>>>0?e+1|0:e;f=Zb(f,-16777216,16776704);i=Jka(p,q,f,f>>31);g=i+g|0;f=nb+e|0;f=g>>>0<i>>>0?f+1|0:f;e=g+8388608|0;f=e>>>0<8388608?f+1|0:f;f=Yc(e,f,24);e=(f|0)/256|0;v[c>>2]=B(e,m)+v[c>>2];v[c+4>>2]=v[c+4>>2]+B(e,l);Rb(h+8|0,x,y);e=f-(o&j)|0;c=c+8|0;d=d-1|0;f=b;continue}break}c=v[h+12>>2];v[a>>2]=v[h+8>>2];v[a+4>>2]=c;v[a+48>>2]=f;v[a+44>>2]=b;kb=h+16|0}function v7(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;g=kb-16|0;kb=g;e=kb-160|0;kb=e;d=e+24|0;f=d+56|0;c=Ks(f);v[d>>2]=78020;v[c>>2]=78040;v[d+56>>2]=78080;v[d>>2]=78060;h=f;f=d+4|0;Ln(h,f);v[d>>2]=78020;v[c>>2]=78040;c=Es(f);v[c>>2]=77504;Nb(c+32|0);v[c+44>>2]=0;v[c+48>>2]=16;c=v[v[d>>2]-12>>2];v[23540]=0;f=ga(62)|0;h=v[23540];v[23540]=0;a:{b:{c:{d:{e:{f:{if((h|0)==1){break f}v[23540]=0;U(63,e+16|0,c+d|0,f|0);c=v[23540];v[23540]=0;if((c|0)==1){break f}ac(e+16|0);c=kb-16|0;kb=c;v[c+8>>2]=17;kb=c+16|0;lm(v[v[d>>2]-12>>2]+d|0,v[c+8>>2]);i=A[b>>3];v[23540]=0;b=bb(64,d|0,+i)|0;c=v[23540];v[23540]=0;if((c|0)==1){break e}v[23540]=0;R(65,e|0,b|0);c=v[23540];v[23540]=0;if((c|0)==1){break d}v[23540]=0;R(61,g|0,e|0);c=v[23540];v[23540]=0;if((c|0)==1){break c}zb(e);Cp(b);kb=e+160|0;break a}a=P()|0;O()|0;break b}a=P()|0;O()|0;break b}a=P()|0;O()|0;break b}a=P()|0;O()|0;zb(e)}Cp(d);T(a|0);L()}v[23540]=0;R(58,a|0,g|0);a=v[23540];v[23540]=0;if((a|0)!=1){zb(g);kb=g+16|0;return}a=P()|0;O()|0;zb(g);T(a|0);L()}function dda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;f=kb-16|0;kb=f;a:{b:{c:{g=v[a+12>>2];i=v[a+8>>2];d:{if((g|0)<=1&i>>>0<=805306368|(g|0)<=0){if((g|0)>=-2&i>>>0>=3489660928|(g|0)>-2){break c}if((g|0)==-2&i>>>0>2147483647|g>>>0>4294967294){break d}break b}if((g|0)==1&i>>>0>2147483648|g>>>0>1){break b}}b=b+196648|0;break a}b=b+131112|0;break a}b=b+262184|0}l=v[a+16>>2];j=v[a+40>>2];k=v[a+36>>2];e=v[a+4>>2];v[f+8>>2]=v[a>>2];v[f+12>>2]=e;m=v[a+32>>2];n=v[a+28>>2];while(1){if(d){e=v[f+12>>2]+l|0;h=(v[f+8>>2]>>>16&65520)+b|0;e=(((((((B(t[e-2|0],u[h+2>>1])+B(t[e-3|0],u[h>>1])|0)+B(t[e-1|0],u[h+4>>1])|0)+B(t[e|0],u[h+6>>1])|0)+B(t[e+1|0],u[h+8>>1])|0)+B(t[e+2|0],u[h+10>>1])|0)+B(t[e+3|0],u[h+12>>1])|0)+B(t[e+4|0],u[h+14>>1])<<8)/32768|0;k=k+n|0;v[c>>2]=v[c>>2]+B(e,k>>12);j=j+m|0;v[c+4>>2]=v[c+4>>2]+B(e,j>>12);Rb(f+8|0,i,g);c=c+8|0;d=d-1|0;continue}break}b=v[f+12>>2];v[a>>2]=v[f+8>>2];v[a+4>>2]=b;v[a+40>>2]=j;v[a+20>>2]=k>>12;v[a+36>>2]=k;v[a+24>>2]=j>>12;kb=f+16|0}function cK(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;d=kb-32|0;kb=d;a:{b:{c:{d:{e:{f:{g:{f=a+36|0;e=v[f>>2];c=v[a+40>>2];h:{if(Pb(e,c)){Gc(d+24|0);break h}c=d+8|0;Kn(c,a);v[23540]=0;c=S(1006,c|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break g}v[d+24>>2]=c;Xf(d+8|0);c=v[a+40>>2];e=v[a+36>>2]}e=(h=f,i=v[d+24>>2],j=Pb(e,c),j?h:i);if((b|0)==-1){f=v[e>>2];g=4194304;c=0;break e}if((b|0)>=0){c=b;f=v[e>>2];if((Pi(f,v[e+4>>2])|0)>(b|0)){break e}}b=ba(8)|0;v[23540]=0;c=Q(55,d+8|0,10956)|0;a=v[23540];v[23540]=0;if((a|0)==1){break f}a=tc(b,c);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break b}a=P()|0;O()|0;zb(c);break d}a=P()|0;O()|0;Xf(d+8|0);break c}a=P()|0;O()|0;ca(b|0);break d}v[a+8>>2]=b;b=v[a+24>>2];v[b+480208>>2]=v[b+480208>>2]&-4194305|g;Gj(b+484360|0,w[lf(f,c)+16|0]);b=lf(v[e>>2],c);c=v[b+8>>2];b=v[b+12>>2];v[23540]=0;+ya(1037,a|0,b|0,c|0);b=v[23540];v[23540]=0;if((b|0)!=1){break a}a=P()|0;O()|0}al(d+24|0)}T(a|0)}L()}v[a+16>>2]=0;v[a+20>>2]=0;al(d+24|0);kb=d+32|0}function Iz(a,b,c){var d=0,e=0;b=b-a>>5;while(1){if((b|0)>0){d=w[c+4|0]|w[c+5|0]<<8|(w[c+6|0]<<16|w[c+7|0]<<24);e=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);t[a|0]=e;t[a+1|0]=e>>>8;t[a+2|0]=e>>>16;t[a+3|0]=e>>>24;t[a+4|0]=d;t[a+5|0]=d>>>8;t[a+6|0]=d>>>16;t[a+7|0]=d>>>24;d=w[c+28|0]|w[c+29|0]<<8|(w[c+30|0]<<16|w[c+31|0]<<24);e=w[c+24|0]|w[c+25|0]<<8|(w[c+26|0]<<16|w[c+27|0]<<24);t[a+24|0]=e;t[a+25|0]=e>>>8;t[a+26|0]=e>>>16;t[a+27|0]=e>>>24;t[a+28|0]=d;t[a+29|0]=d>>>8;t[a+30|0]=d>>>16;t[a+31|0]=d>>>24;d=w[c+20|0]|w[c+21|0]<<8|(w[c+22|0]<<16|w[c+23|0]<<24);e=w[c+16|0]|w[c+17|0]<<8|(w[c+18|0]<<16|w[c+19|0]<<24);t[a+16|0]=e;t[a+17|0]=e>>>8;t[a+18|0]=e>>>16;t[a+19|0]=e>>>24;t[a+20|0]=d;t[a+21|0]=d>>>8;t[a+22|0]=d>>>16;t[a+23|0]=d>>>24;d=w[c+12|0]|w[c+13|0]<<8|(w[c+14|0]<<16|w[c+15|0]<<24);e=w[c+8|0]|w[c+9|0]<<8|(w[c+10|0]<<16|w[c+11|0]<<24);t[a+8|0]=e;t[a+9|0]=e>>>8;t[a+10|0]=e>>>16;t[a+11|0]=e>>>24;t[a+12|0]=d;t[a+13|0]=d>>>8;t[a+14|0]=d>>>16;t[a+15|0]=d>>>24;b=b-1|0;a=a+32|0;continue}break}}function Fc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;a:{c=v[b>>2];e=kb-48|0;kb=e;f=v[b+4>>2];b=w[b+8|0];d=f-(((b|0)==1|(b|0)==4)&(f|0)!=0)|0;f=Nb(a);b:{c:{d:{e:{f:{g:{h:{if((b-1&255)>>>0<=1){t[e+32|0]=0;a=zi(c,c+d|0,e+32|0);v[23540]=0;W(53,f|0,c|0,a|0)|0;a=v[23540];v[23540]=0;if((a|0)!=1){break h}a=P()|0;O()|0;break b}if((b-3&255)>>>0>1){break h}v[23540]=0;b=W(53,f|0,c|0,c+d|0)|0;a=v[23540];v[23540]=0;if((a|0)==1){break g}c=he(b);d=yh(b);g=he(b);a=kb-32|0;kb=a;v[a+16>>2]=d;v[a+24>>2]=c;v[a+8>>2]=g;while(1){if(pj(a+24|0,a+16|0)){c=a+8|0;d=a+24|0;g=t[v[d>>2]];t[v[c>>2]]=g?g:32;Ke(d);Ke(c);continue}break}kb=a+32|0;v[23540]=0;c=Q(54,e+16|0,b|0)|0;a=v[23540];v[23540]=0;if((a|0)==1){break f}v[23540]=0;d=Q(55,e|0,17859)|0;a=v[23540];v[23540]=0;if((a|0)==1){break e}v[23540]=0;U(56,e+32|0,c|0,d|0);a=v[23540];v[23540]=0;if((a|0)==1){break d}a=e+32|0;Bc(b,a);zb(a);zb(d);zb(c)}kb=e+48|0;break a}a=P()|0;O()|0;break b}a=P()|0;O()|0;break b}a=P()|0;O()|0;break c}a=P()|0;O()|0;zb(d)}zb(c)}zb(f);T(a|0);L()}}function $j(a,b,c,d,e,f,g,h){var i=0,j=0,k=0,l=0,m=0;i=kb-32|0;kb=i;v[i+16>>2]=c;v[i+24>>2]=b;b=i+8|0;gd(b,d);c=0;v[23540]=0;j=S(19,b|0)|0;b=v[23540];v[23540]=0;if((b|0)!=1){ac(i+8|0);v[e>>2]=0;a:{while(1){if((g|0)==(h|0)|c){break a}b:{if(bj(i+24|0,i+16|0)){break b}c:{if((xn(j,t[g|0])|0)==37){c=g+1|0;if((h|0)==(c|0)){break b}d:{e:{b=xn(j,t[c|0]);if((b|0)==69){break e}k=0;if((b&255)==48){break e}c=g;break d}if((g+2|0)==(h|0)){break b}k=b;b=xn(j,t[g+2|0])}l=i,m=ob[v[v[a>>2]+36>>2]](a,v[i+24>>2],v[i+16>>2],d,e,f,b,k)|0,v[l+24>>2]=m;g=c+2|0;break c}b=v[j+8>>2];if(vh(b,8192,t[g|0])){while(1){f:{g=g+1|0;if((h|0)==(g|0)){g=h;break f}if(vh(b,8192,t[g|0])){continue}}break}while(1){if(!rp(i+24|0,i+16|0)){break c}b=Zk(v[i+24>>2]);if(!vh(v[j+8>>2],8192,b)){break c}em(i+24|0);continue}}if((zw(j,Zk(v[i+24>>2]))|0)==(zw(j,t[g|0])|0)){g=g+1|0;em(i+24|0);break c}v[e>>2]=4}c=v[e>>2];continue}break}v[e>>2]=4}if(bj(i+24|0,i+16|0)){v[e>>2]=v[e>>2]|2}kb=i+32|0;return v[i+24>>2]}a=P()|0;O()|0;ac(i+8|0);T(a|0);L()}function c0(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;g=kb-32|0;kb=g;v[g+24>>2]=b;a:{b:{if(!(v[d+4>>2]&1)){v[g>>2]=-1;b=ob[v[v[a>>2]+16>>2]](a,b,c,d,e,g)|0;v[g+24>>2]=b;c:{switch(v[g>>2]){case 1:t[f|0]=1;break a;case 0:break b;default:break c}}t[f|0]=1;v[e>>2]=4;break a}gd(g,d);v[23540]=0;b=S(1132,g|0)|0;a=v[23540];v[23540]=0;d:{e:{f:{g:{if((a|0)!=1){ac(g);gd(g,d);v[23540]=0;a=S(1133,g|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break g}ac(g);v[23540]=0;R(1134,g|0,a|0);d=v[23540];v[23540]=0;if((d|0)==1){b=P()|0;O()|0;break d}v[23540]=0;R(1135,g|12,a|0);a=v[23540];v[23540]=0;if((a|0)==1){break f}v[23540]=0;d=g+24|0;a=ua(1136,d|0,c|0,g|0,d|0,b|0,e|0,1)|0;b=v[23540];v[23540]=0;if((b|0)==1){break e}t[f|0]=(a|0)==(g|0);b=v[g+24>>2];while(1){d=Nc(d-12|0);if((g|0)!=(d|0)){continue}break}break a}b=P()|0;O()|0;ac(g);break d}b=P()|0;O()|0;ac(g);break d}b=P()|0;O()|0;Nc(g);break d}b=P()|0;O()|0;while(1){d=Nc(d-12|0);if((g|0)!=(d|0)){continue}break}}T(b|0);L()}t[f|0]=0}kb=g+32|0;return b|0}function o0(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;g=kb-32|0;kb=g;v[g+24>>2]=b;a:{b:{if(!(v[d+4>>2]&1)){v[g>>2]=-1;b=ob[v[v[a>>2]+16>>2]](a,b,c,d,e,g)|0;v[g+24>>2]=b;c:{switch(v[g>>2]){case 1:t[f|0]=1;break a;case 0:break b;default:break c}}t[f|0]=1;v[e>>2]=4;break a}gd(g,d);v[23540]=0;b=S(19,g|0)|0;a=v[23540];v[23540]=0;d:{e:{f:{g:{if((a|0)!=1){ac(g);gd(g,d);v[23540]=0;a=S(1115,g|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break g}ac(g);v[23540]=0;R(1116,g|0,a|0);d=v[23540];v[23540]=0;if((d|0)==1){b=P()|0;O()|0;break d}v[23540]=0;R(1117,g|12,a|0);a=v[23540];v[23540]=0;if((a|0)==1){break f}v[23540]=0;d=g+24|0;a=ua(1118,d|0,c|0,g|0,d|0,b|0,e|0,1)|0;b=v[23540];v[23540]=0;if((b|0)==1){break e}t[f|0]=(a|0)==(g|0);b=v[g+24>>2];while(1){d=zb(d-12|0);if((g|0)!=(d|0)){continue}break}break a}b=P()|0;O()|0;ac(g);break d}b=P()|0;O()|0;ac(g);break d}b=P()|0;O()|0;zb(g);break d}b=P()|0;O()|0;while(1){d=zb(d-12|0);if((g|0)!=(d|0)){continue}break}}T(b|0);L()}t[f|0]=0}kb=g+32|0;return b|0}function oi(a){var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0;o(+a);b=j(1)|0;e=j(0)|0;f=b>>>20&2047;a:{if(f-969>>>0>=63){if(f>>>0<=968){return a+1}b:{if(f>>>0<1033){break b}c=0;if(!e&(b|0)==-1048576){break a}if((f|0)==2047){return a+1}if((b|0)>0|(b|0)>=0){return Jr(3.105036184601418e231)}if(b>>>0<3230714880){break b}return Jr(1.2882297539194267e-231)}b=b<<1|e>>>31;e=e<<1;f=(b|0)==-2129002496&(e|0)!=0|b>>>0>2165964800?0:f}c=A[177];g=c+a;a=a-(g-c);c=a*a;h=c*c*(a*A[182]+A[181]);c=c*(a*A[180]+A[179]);a=a*A[178];o(+g);j(1)|0;e=j(0)|0;d=e<<4&2032;a=h+(c+(a+A[d+1464>>3]));d=d+1472|0;i=v[d>>2];b=v[d+4>>2];d=i;i=0;d=d+i|0;b=(e<<13)+b|0;b=d>>>0<i>>>0?b+1|0:b;if(!f){c:{if(!(e&-2147483648)){l(0,d|0);l(1,b+-1048576|0);c=+n();a=c*a+c;a=a+a;break c}e=kb-16|0;l(0,d|0);l(1,b+1071644672|0);c=+n();g=c*a;a=g+c;if(a<1){b=e;v[b+8>>2]=0;v[b+12>>2]=1048576;A[b+8>>3]=A[b+8>>3]*2.2250738585072014e-308;h=a+1;a=h+(g+(c-a)+(a+(1-h)))+-1;a=a==0?0:a}a=a*2.2250738585072014e-308}return a}l(0,d|0);l(1,b|0);c=+n();c=c*a+c}return c}function Bka(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;f=kb-144|0;kb=f;v[23540]=0;l=S(271,a|0)|0;e=v[23540];v[23540]=0;if((e|0)!=1){m=c+480192|0;while(1){a:{if((j&65535)>>>0>=l>>>0){Bb(a);kb=f+144|0;return}v[23540]=0;R(290,a|0,f+8|0);e=v[23540];v[23540]=0;if((e|0)!=1){b:{e=Ib(x[f+8>>1]);if(!e|e>>>0>x[m>>1]){break b}e=v[((e<<2)+c|0)+900380>>2];if(!e){break b}e=Ih(e,b);g=w[f+11|0];c:{if(!g){break c}h=w[f+10|0];if(h&1){t[e+12|0]=w[e+12|0]|1}if(h&2){t[e+12|0]=w[e+12|0]|4}if(!(h&4)){break c}t[e+12|0]=w[e+12|0]|2}t[f+4|0]=g;t[f+7|0]=31;h=w[Yb(f+4|0,f+7|0)|0];v[23540]=0;h=h+1&255;R(291,e|0,h|0);g=v[23540];v[23540]=0;if((g|0)==1){break a}t[e+13|0]=w[f+13|0];t[e+14|0]=w[f+14|0];g=w[f+12|0];t[e+15|0]=g;t[e+16|0]=g;g=v[e>>2];e=0;while(1){if((e|0)==(h|0)){break b}i=(f+8|0)+(e<<2)|0;n=Ib(x[i+8>>1]);k=Eb(g,e);u[k>>1]=n;i=Ib(x[i+10>>1]);u[f+4>>1]=d?i+128>>>2|0:i;Ef(f+4|0,64);t[k+2|0]=w[f+4|0];e=e+1|0;continue}}j=j+1|0;continue}}break}}b=P()|0;O()|0;Bb(a);T(b|0);L()}function pda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,w=0,x=0,y=0;g=kb-16|0;kb=g;f=v[a+48>>2];j=v[a+24>>2];k=v[a+20>>2];e=v[a+44>>2];l=v[a+16>>2];b=v[a+4>>2];v[g+8>>2]=v[a>>2];v[g+12>>2]=b;m=v[a+72>>2];b=v[a+68>>2];n=b;o=b>>31;b=v[a+64>>2];p=b;q=b>>31;b=v[a+60>>2];r=b;s=b>>31;w=v[a+8>>2];x=v[a+12>>2];while(1){b=e;if(d){e=Zb(b,-16777216,16776704);e=Jka(p,q,e,e>>31);h=nb;f=Zb(f,-16777216,16776704);i=Jka(n,o,f,f>>31);e=i+e|0;f=nb+h|0;f=e>>>0<i>>>0?f+1|0:f;y=e;e=v[g+12>>2]+l|0;h=v[g+8>>2]>>>21&2040;h=(((B(t[e|0],u[h+39778>>1])+B(t[e-1|0],u[h+39776>>1])|0)+B(t[e+1|0],u[h+39780>>1])|0)+B(t[e+2|0],u[h+39782>>1])<<8)/16384<<8;e=h;i=Jka(e,e>>31,r,s);e=y+i|0;f=nb+f|0;f=e>>>0<i>>>0?f+1|0:f;e=e+8388608|0;f=e>>>0<8388608?f+1|0:f;f=Yc(e,f,24);e=(f|0)/256|0;v[c>>2]=B(e,k)+v[c>>2];v[c+4>>2]=v[c+4>>2]+B(e,j);Rb(g+8|0,w,x);e=f-(h&m)|0;c=c+8|0;d=d-1|0;f=b;continue}break}c=v[g+12>>2];v[a>>2]=v[g+8>>2];v[a+4>>2]=c;v[a+48>>2]=f;v[a+44>>2]=b;kb=g+16|0}function Uy(a,b,c,d,e){var f=0,g=0,h=0,i=0;g=kb-16|0;kb=g;h=B(c,872)+b|0;a:{if(d){Db(g+8|0,a+1074312|0,90);if(!Cb(v[v[g+8>>2]>>2],v[g+12>>2])){t[(B(c,872)+b|0)+1427|0]=d}t[(B(c,872)+b|0)+1428|0]=d;break a}d=w[h+1428|0]}f=v[a+480180>>2];if(!e){i=dt(f)}h=h+616|0;b:{c:{if((f|0)!=268435456){if((f|0)!=16777216){break c}f=v[(B(c,872)+b|0)+1272>>2];if(!f|!v[f+44>>2]){break c}a=d&255;if(!(a>>>0<240|e)){vN(b,c,240-a|0);break b}if(!(a>>>0<224|e)){uN(h,224-a|0);break b}tN(h,0-a|0);break b}v[(B(c,872)+b|0)+1324>>2]=65535}e=d&255;d:{if(!(e>>>0>223&i)){break d}e:{f=e&15;if(!f){break e}d=d&240;if((d|0)!=224){if((d|0)!=240){break e}Ry(a,h,f);break b}if(v[a+480180>>2]==524288){break d}Qy(a,h,f);break b}if(v[a+480180>>2]!=524288){break b}}f:{if(!(t[(B(c,872)+b|0)+1467|0]&1)){break f}if(v[a+1074416>>2]==1){Db(g+8|0,a+1074312|0,6);if(Cb(v[v[g+8>>2]>>2],v[g+12>>2])){break f}}d=v[a+480180>>2];if(d&32832){break f}if(!(v[a+480208>>2]&2)|(d|0)!=8){break b}}hk(a,h,(B(c,872)+b|0)+1316|0,0-(e<<2)|0,0)}kb=g+16|0}function _A(a,b,c){var d=0,e=0,f=0,g=0;d=kb-16|0;kb=d;t[d+15|0]=c;e=a;a:{b:{c:{switch(b-14|0){case 0:b=14;if(!c){break b}d:{if((c|0)!=15){if((c|0)!=240){break d}t[d+15|0]=239;break b}t[d+15|0]=254;break b}if(c>>>0>=16){t[d+15|0]=c|15;break b}t[d+15|0]=c|240;break b;case 1:t[d+15|0]=c^128;b=15;break b;case 6:case 7:if(c>>>0>=16){t[d+15|0]=c>>>4|240;break b}t[d+15|0]=c|224;break b;case 8:t[d+15|0]=((c^-1)&254)>>>1;b=22;break b;case 9:t[d+15|0]=c&15|128;b=23;break b;case 17:f=d,g=tg(c<<1),t[f+15|0]=g;b=31;break b;case 19:a=32;b=33;e:{f:{switch(c>>>4|0){default:b=0;break b;case 8:a=64;break e;case 10:a=176;break e;case 11:a=224;break e;case 12:case 13:b=c?33:0;break b;case 14:g:{switch(c&15){case 0:t[d+15|0]=119;break b;case 1:t[d+15|0]=119;break b;case 2:t[d+15|0]=121;break b;case 3:break g;default:break b}}t[d+15|0]=123;break b;case 3:break e;case 5:break f;case 0:break b}}a=48}t[d+15|0]=c&15|a;break b;default:break c}}a=0;if(b>>>0>35){break a}}a=w[b+26672|0]}de(e,a,d+15|0);kb=d+16|0}function Mw(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;p=a;i=kb-1040|0;kb=i;q=v[116016];a:{b:{a=i+16|0;l=x[((b>>>0>149?0:b)<<1)+91648>>1]+89816|0;c=v[v[116042]+20>>2];if(c){j=v[c+4>>2];c=v[c>>2];e=v[c>>2]+1794895138|0;h=bm(v[c+8>>2],e);f=bm(v[c+12>>2],e);d=bm(v[c+16>>2],e);c:{if(j>>>2>>>0<=h>>>0){break c}k=j-(h<<2)|0;if((d|f)&3|(k>>>0<=f>>>0|d>>>0>=k>>>0)){break c}r=d>>>2|0;s=f>>>2|0;f=0;while(1){k=h>>>1|0;m=k+f|0;n=m<<1;d=c+(n+s<<2)|0;o=bm(v[d>>2],e);d=bm(v[d+4>>2],e);if(d>>>0>=j>>>0|j-d>>>0<=o>>>0|w[c+(d+o|0)|0]){break c}d=yi(l,c+d|0);if(!d){f=c+(r+n<<2)|0;h=bm(v[f>>2],e);e=bm(v[f+4>>2],e);if(e>>>0>=j>>>0|h>>>0>=j-e>>>0){break c}g=w[c+(e+h|0)|0]?0:c+e|0;break c}if((h|0)==1){break c}d=(d|0)<0;h=d?k:h-k|0;f=d?f:m;continue}}}g=g?g:l;c=Pg(g);d:{if(c>>>0>=1024){sc(a,g,1023);t[a+1023|0]=0;g=68;break d}sc(a,g,c+1|0);g=0}if(g){if((g|0)!=28){break b}a=21688}break a}wa();L()}if(!w[a|0]){v[i>>2]=b;a=i+16|0;Fw(a,1024,12996,i)}v[116016]=q;Kc(p,a);kb=i+1040|0}function yca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=kb-16|0;kb=e;p=v[a+16>>2];q=kg(b+327720|0,v[b+20>>2],(v[a+88>>2]&16384)>>>14|0);l=v[a+128>>2];a:{if(!l){k=v[a+8>>2];m=v[a+12>>2];f=v[a>>2];b=v[a+4>>2];h=0;break a}b=v[a+12>>2];m=b;k=v[a+8>>2];n=lg(k,b,l);o=nb;h=v[a+76>>2];f=v[a>>2];b=v[a+4>>2];Qf(f,b,qf(k,m,d),nb);h=h>>>0<nb>>>0?d:0}g=a+112|0;i=v[a+40>>2];j=v[a+36>>2];v[e>>2]=f;v[e+4>>2]=b;b:while(1){if(d){d=d-1|0;v[e+8>>2]=f;v[e+12>>2]=0;h=h-1|0;n=h?n:0;o=h?o:0;f=b+p|0;b=l;while(1)if((b|0)<=0){Rb(g,v[a+120>>2],v[a+124>>2]);b=v[a+116>>2];if(b){Sd(g,t[f+v[e+12>>2]|0]<<6);Rd(g,b);v[g>>2]=v[g>>2];v[g+4>>2]=0}b=v[a+32>>2];j=v[a+28>>2]+j|0;f=jg(g,q);v[c>>2]=B(j>>12,f)+v[c>>2];i=b+i|0;v[c+4>>2]=v[c+4>>2]+B(f,i>>12);Rb(e,k,m);c=c+8|0;f=v[e>>2];b=v[e+4>>2];continue b}else{Sd(g,t[f+v[e+12>>2]|0]<<6);Rd(g,4);Rb(e+8|0,n,o);b=b-1|0;continue}}break}v[a>>2]=f;v[a+4>>2]=b;v[a+40>>2]=i;v[a+20>>2]=j>>12;v[a+36>>2]=j;v[a+24>>2]=i>>12;kb=e+16|0}function _j(a,b,c,d,e,f,g,h){var i=0,j=0,k=0,l=0,m=0;i=kb-32|0;kb=i;v[i+16>>2]=c;v[i+24>>2]=b;c=i+8|0;gd(c,d);b=0;v[23540]=0;j=S(1132,c|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){ac(i+8|0);v[e>>2]=0;a:{while(1){if((g|0)==(h|0)|b){break a}b:{if(ak(i+24|0,i+16|0)){break b}c:{if((wn(j,v[g>>2])|0)==37){b=g+4|0;if((h|0)==(b|0)){break b}d:{e:{c=wn(j,v[b>>2]);if((c|0)==69){break e}k=0;if((c&255)==48){break e}b=g;break d}if((g+8|0)==(h|0)){break b}k=c;c=wn(j,v[g+8>>2])}l=i,m=ob[v[v[a>>2]+36>>2]](a,v[i+24>>2],v[i+16>>2],d,e,f,c,k)|0,v[l+24>>2]=m;g=b+8|0;break c}if(Wk(j,8192,v[g>>2])){while(1){f:{g=g+4|0;if((h|0)==(g|0)){g=h;break f}if(Wk(j,8192,v[g>>2])){continue}}break}while(1){if(!cs(i+24|0,i+16|0)){break c}if(!Wk(j,8192,Xk(v[i+24>>2]))){break c}Dn(i+24|0);continue}}if((Hl(j,Xk(v[i+24>>2]))|0)==(Hl(j,v[g>>2])|0)){g=g+4|0;Dn(i+24|0);break c}v[e>>2]=4}b=v[e>>2];continue}break}v[e>>2]=4}if(ak(i+24|0,i+16|0)){v[e>>2]=v[e>>2]|2}kb=i+32|0;return v[i+24>>2]}a=P()|0;O()|0;ac(i+8|0);T(a|0);L()}function Mca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0;e=kb-16|0;kb=e;g=v[a+40>>2];h=v[a+36>>2];i=v[a+16>>2];f=v[a+4>>2];v[e+8>>2]=v[a>>2];v[e+12>>2]=f;j=b+24|0;k=v[a+32>>2];l=v[a+28>>2];m=v[a+8>>2];n=v[a+12>>2];while(1){if(d){f=v[e+8>>2];o=((((v[e+12>>2]&2147483647)<<1|f>>>31)&2147483646)<<1)+i|0;b=(((f>>>16|0)+4&131064)<<1)+j|0;p=u[b+14>>1];q=u[b+12>>1];r=u[b+10>>1];s=u[b+8>>1];t=u[b+6>>1];w=u[b+4>>1];x=u[b+2>>1];y=u[b>>1];f=0;while(1){if((f|0)!=2){b=(f<<1)+o|0;v[(f<<2)+e>>2]=(((((B(u[b+8>>1],r)+B(u[b+4>>1],s)|0)+B(u[b+12>>1],q)|0)+B(u[b+16>>1],p)|0)/2|0)+((((B(u[b-8>>1],x)+B(u[b-12>>1],y)|0)+B(u[b-4>>1],w)|0)+B(u[b>>1],t)|0)/2|0)|0)/16384;f=f+1|0;continue}break}h=h+l|0;v[c>>2]=v[c>>2]+B(v[e>>2],h>>12);g=g+k|0;v[c+4>>2]=v[c+4>>2]+B(v[e+4>>2],g>>12);Rb(e+8|0,m,n);c=c+8|0;d=d-1|0;continue}break}b=v[e+12>>2];v[a>>2]=v[e+8>>2];v[a+4>>2]=b;v[a+40>>2]=g;v[a+20>>2]=h>>12;v[a+36>>2]=h;v[a+24>>2]=g>>12;kb=e+16|0}function Gw(a,b,c,d){var e=0,f=0,g=0,h=0;g=kb-32|0;kb=g;e=d&2147483647;h=e;f=e-1006698496|0;e=e-1140785152|0;a:{if((f|0)==(e|0)&0|e>>>0>f>>>0){e=d<<4|c>>>28;f=c<<4|b>>>28;c=e;b=b&268435455;if((b|0)==134217728&(a|0)!=0|b>>>0>134217728){e=c+1073741824|0;a=f+1|0;e=a?e:e+1|0;f=a;break a}e=c+1073741824|0;if(a|(b|0)!=134217728){break a}b=f&1;a=b+f|0;e=a>>>0<b>>>0?e+1|0:e;f=a;break a}if(!(!c&(h|0)==2147418112?!(a|b):h>>>0<2147418112)){e=c;c=d<<4|e>>>28;f=e<<4|b>>>28;e=c&524287|2146959360;break a}f=0;e=2146435072;if(h>>>0>1140785151){break a}e=0;h=h>>>16|0;if(h>>>0<15249){break a}e=d&65535|65536;Kf(g+16|0,a,b,c,e,h-15233|0);Em(g,a,b,c,e,15361-h|0);e=v[g+4>>2];h=e;a=v[g+8>>2];c=v[g+12>>2]<<4|a>>>28;f=a<<4|e>>>28;e=c;a=h&268435455;b=v[g>>2]|(v[g+16>>2]|v[g+24>>2]|(v[g+20>>2]|v[g+28>>2]))!=0;if((a|0)==134217728&(b|0)!=0|a>>>0>134217728){a=f+1|0;e=a?e:e+1|0;f=a;break a}if(b|(a|0)!=134217728){break a}a=f+(f&1)|0;e=a>>>0<f>>>0?e+1|0:e;f=a}kb=g+32|0;l(0,f|0);l(1,d&-2147483648|e);return+n()}function Vy(a,b,c,d,e){var f=0,g=0,h=0,i=0;g=kb-16|0;kb=g;h=B(c,872)+b|0;a:{if(d){Db(g+8|0,a+1074312|0,90);if(!Cb(v[v[g+8>>2]>>2],v[g+12>>2])){t[(B(c,872)+b|0)+1428|0]=d}t[(B(c,872)+b|0)+1427|0]=d;break a}d=w[h+1427|0]}f=v[a+480180>>2];if(!e){i=dt(f)}h=h+616|0;b:{c:{if((f|0)!=268435456){if((f|0)!=16777216){break c}f=v[(B(c,872)+b|0)+1272>>2];if(!f|!v[f+44>>2]){break c}a=d&255;if(!(a>>>0<240|e)){vN(b,c,a-240|0);break b}if(!(a>>>0<224|e)){uN(h,a-224|0);break b}tN(h,a);break b}v[(B(c,872)+b|0)+1324>>2]=1}e=d&255;d:{if(!(e>>>0>223&i)){break d}e:{f=e&15;if(!f){break e}d=d&240;if((d|0)!=224){if((d|0)!=240){break e}Sy(a,h,f);break b}if(v[a+480180>>2]==524288){break d}Ty(a,h,f);break b}if(v[a+480180>>2]!=524288){break b}}f:{if(!(t[(B(c,872)+b|0)+1467|0]&1)){break f}if(v[a+1074416>>2]==1){Db(g+8|0,a+1074312|0,6);if(Cb(v[v[g+8>>2]>>2],v[g+12>>2])){break f}}d=v[a+480180>>2];if(d&32832){break f}if(!(v[a+480208>>2]&2)|(d|0)!=8){break b}}hk(a,h,(B(c,872)+b|0)+1316|0,e<<2,0)}kb=g+16|0}function Jja(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=kb-16|0;kb=e;nd(b,32);g=b,h=bc(w[a+4|0]|w[a+5|0]<<8|(w[a+6|0]<<16|w[a+7|0]<<24)),v[g>>2]=h;f=bc(w[a+10|0]|w[a+11|0]<<8|(w[a+12|0]<<16|w[a+13|0]<<24));v[b+4>>2]=f;g=b,h=bc(w[a+14|0]|w[a+15|0]<<8|(w[a+16|0]<<16|w[a+17|0]<<24))+f|0,v[g+8>>2]=h;if(!(d?0:c)){c=bc(w[a+46|0]|w[a+47|0]<<8|(w[a+48|0]<<16|w[a+49|0]<<24))}v[b+24>>2]=c;c=w[a+8|0]<<28>>24;a:{if((d|0)!=841887798){break a}d=Ib(w[a+42|0]|w[a+43|0]<<8);if(!d|(d|0)==48){break a}c=(c-(d<<7)|0)+6144|0}zl(b,+(c|0)*.0006510416666666666);t[e+15|0]=w[a+9|0];t[e+14|0]=64;g=b,h=w[Yb(e+15|0,e+14|0)|0]<<2,u[g+30>>1]=h;if(t[a+40|0]&1){u[b+34>>1]=x[b+34>>1]|64;v[b>>2]=v[b>>2]>>>1;v[b+4>>2]=v[b+4>>2]>>>1;v[b+8>>2]=v[b+8>>2]>>>1}b:{if(w[a+41|0]<=8){a=v[b+4>>2];c=v[b+8>>2];break b}u[b+34>>1]=x[b+34>>1]|1;v[b>>2]=v[b>>2]>>>1;a=v[b+4>>2]>>>1|0;v[b+4>>2]=a;c=v[b+8>>2]>>>1|0;v[b+8>>2]=c}c:{if(a+1>>>0<c>>>0){u[b+34>>1]=x[b+34>>1]|2;break c}v[b+4>>2]=0;v[b+8>>2]=0}kb=e+16|0}function Cha(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=du(c,d);d=b&63;if(e>>>0>d>>>0){c=TS(c,d);d=0;g=kb-16|0;kb=g;t[a+12|0]=0;Lc(a);e=kb-32|0;kb=e;a:{b:{if(Wh(a)>>>0<=14){if(th(1073741823)>>>0<=14){break b}f=Gb(a);f=Vf(e+8|0,15,uc(v[a>>2],v[a+4>>2]),f);Fd(a,f);Uf(f)}kb=e+32|0;break a}cd();L()}h=0-w[c+1|0]|0;while(1){c:{if((d|0)==15){break c}e=c+(d<<1)|0;f=w[e+1|0];if(!f){break c}t[g+7|0]=64;h=f+(h<<16>>16)|0;f=yl(g+8|0,h&65535,w[Yb(e+2|0,g+7|0)|0]);d:{if(y[a+4>>2]<y[Gb(a)>>2]){OS(a,f);break d}i=kb-32|0;kb=i;e=Gb(a);e=Vf(i+8|0,qg(a,uc(v[a>>2],v[a+4>>2])+1|0),uc(v[a>>2],v[a+4>>2]),e);Im(v[e+8>>2],x[f>>1]|x[f+2>>1]<<16);v[e+8>>2]=v[e+8>>2]+4;Fd(a,e);Uf(e);kb=i+32|0}d=d+1|0;continue}break}d=w[c+32|0];t[a+14|0]=d>>>4;t[a+13|0]=d&15;c=w[c+31|0];d=c&15;t[a+15|0]=d;t[a+16|0]=d;if(c&16){t[a+12|0]=w[a+12|0]|4}if(c&32){t[a+12|0]=w[a+12|0]|2}kb=g+16|0}e:{if(b<<24>>24>=0){c=w[a+12|0]&-2;a=a+12|0;break e}c=w[a+12|0]&-2|pc(v[a>>2],v[a+4>>2])^1;a=a+12|0}t[a|0]=c}function Uja(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;h=kb-32|0;kb=h;e=b;b=v[a>>2];b=to(e,Fb(b))+b|0;e=CU(c,d);a:{if((e|0)<=0){break a}f=v[Gb(a)>>2];g=v[a+4>>2];if((f-g|0)>=(e|0)){v[h+8>>2]=d;j=g-b|0;if((j|0)<(e|0)){v[h+8>>2]=c;hB(h+8|0,j);f=v[h+8>>2];l=kb-16|0;kb=l;i=Ok(l,a,e-j|0);k=kb-16|0;kb=k;v[k+8>>2]=f;while(1){if(Pb(f,d)){xd(v[i+4>>2],w[f|0]);f=Ke(k+8|0);v[i+4>>2]=v[i+4>>2]+1;f=v[f>>2];continue}break}kb=k+16|0;lc(i);kb=l+16|0;if((j|0)<=0){break a}}f=kb-16|0;kb=f;j=v[a+4>>2];d=(j-(b+e|0)|0)+b|0;i=Ok(f,a,g-d|0);e=v[i+4>>2];a=d;while(1){if(a>>>0>=g>>>0){lc(i);Dq(b,d,j);kb=f+16|0}else{xd(e,w[a|0]);e=e+1|0;v[i+4>>2]=e;a=a+1|0;continue}break}qh(c,v[h+8>>2],b);break a}f=Gb(a);g=Xl(h+8|0,Vl(a,fd(v[a>>2],g)+e|0),b-v[a>>2]|0,f);e=kb-32|0;kb=e;v[e+24>>2]=c;c=Wv(e+8|0,g+8|0,CU(c,d));d=v[c>>2];while(1){if(v[c+4>>2]!=(d|0)){xd(d,w[v[e+24>>2]]);d=v[c>>2]+1|0;v[c>>2]=d;Ke(e+24|0);continue}break}Ud(c);kb=e+32|0;b=BU(a,g,b);Wl(g)}Fb(b);kb=h+32|0}function up(a,b,c,d,e,f){var g=C(0),h=0,i=C(0),j=0,k=C(0),l=C(0);c=(c<<2)+b|0;d=c+(d<<2)|0;a=a>>2;b=f<<2;while(1){if((a|0)>0){f=d-4|0;i=z[f>>2];k=z[c>>2];l=z[d>>2];z[c>>2]=k+l;h=c-4|0;g=z[h>>2];z[h>>2]=g+z[f>>2];k=C(k-l);g=C(g-i);z[d>>2]=C(k*z[e>>2])-C(z[e+4>>2]*g);z[f>>2]=C(g*z[e>>2])+C(k*z[e+4>>2]);f=d-12|0;k=z[f>>2];h=c-8|0;g=z[h>>2];j=h;h=d-8|0;l=z[h>>2];z[j>>2]=g+l;j=c-12|0;i=z[j>>2];z[j>>2]=i+z[f>>2];g=C(g-l);e=b+e|0;i=C(i-k);z[h>>2]=C(g*z[e>>2])-C(z[e+4>>2]*i);z[f>>2]=C(i*z[e>>2])+C(g*z[e+4>>2]);f=d-20|0;k=z[f>>2];h=c-16|0;g=z[h>>2];j=h;h=d-16|0;l=z[h>>2];z[j>>2]=g+l;j=c-20|0;i=z[j>>2];z[j>>2]=i+z[f>>2];g=C(g-l);e=b+e|0;i=C(i-k);z[h>>2]=C(g*z[e>>2])-C(z[e+4>>2]*i);z[f>>2]=C(i*z[e>>2])+C(g*z[e+4>>2]);f=d-28|0;k=z[f>>2];h=c-24|0;g=z[h>>2];j=h;h=d-24|0;l=z[h>>2];z[j>>2]=g+l;j=c-28|0;i=z[j>>2];z[j>>2]=i+z[f>>2];g=C(g-l);e=b+e|0;i=C(i-k);z[h>>2]=C(g*z[e>>2])-C(z[e+4>>2]*i);z[f>>2]=C(i*z[e>>2])+C(g*z[e+4>>2]);e=b+e|0;a=a-1|0;d=d-32|0;c=c-32|0;continue}break}}function s3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=kb+-64|0;kb=c;f=v[a>>2];a=v[f>>2];g=v[a+4>>2];v[c+40>>2]=v[a+20>>2];d=v[a+16>>2];v[c+32>>2]=v[a+12>>2];v[c+36>>2]=d;Hf(c+48|0,c+32|0,g);a=v[f+4>>2];f=v[a+8>>2];g=v[a+4>>2];d=v[c+60>>2];v[c+24>>2]=v[c+56>>2];v[c+28>>2]=d;d=v[c+52>>2];v[c+16>>2]=v[c+48>>2];v[c+20>>2]=d;v[c+8>>2]=v[a+8>>2];d=v[a+4>>2];v[c>>2]=v[a>>2];v[c+4>>2]=d;a:{b:{c:{d:{d=v[c+4>>2];if(g>>>0<=d>>>0){if(g>>>0>y[c+20>>2]){break d}if(f>>>0>y[c+8>>2]){break c}h=v[c+28>>2];if(f>>>0>v[c+24>>2]-h>>>0){break b}i=b+12|0;j=v[c+16>>2];k=v[c>>2];b=0;e:while(1){if((b|0)==(f|0)){break a}l=b+h|0;m=B(b,d);a=0;while(1)if((a|0)==(g|0)){b=b+1|0;continue e}else{e=v[(a+m<<2)+k>>2];n=vs(i);o=v[(a<<2)+j>>2]+(l<<1)|0;e=ld((ld(n,21)+e|0)+2048|0,12);e=(e|0)<32767?e:32767;u[o>>1]=(e|0)>-32768?e:-32768;a=a+1|0;continue}}}aa(7192,9074,33,8787);L()}aa(7157,9074,34,8787);L()}aa(5900,9074,35,8787);L()}aa(5870,9074,36,8787);L()}kb=c- -64|0}function aka(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;f=kb-2608|0;kb=f;d=zB(f,a);v[d+1060>>2]=0;v[d+1064>>2]=0;e=d+2604|0;a=d+1068|0;while(1){t[a+4|0]=0;u[a>>1]=0;u[a+2>>1]=0;a=a+6|0;if((e|0)!=(a|0)){continue}break}v[23540]=0;Y(318,d|0);a=v[23540];v[23540]=0;a:{b:{if((a|0)!=1){if((u[d+1068>>1]|u[d+1070>>1])<0){break a}c:{while(1){if((c|0)==(g|0)){break a}v[23540]=0;j=Q(164,d|0,1)|0;a=v[23540];v[23540]=0;if((a|0)==1){break c}a=0;d:{while(1){v[23540]=0;k=Q(164,d|0,1)|0;e=v[23540];v[23540]=0;if((e|0)==1){break d}a=u[(d+B(a,6)|0)+(k?1070:1068)>>1];e:{if((a|0)>255){break e}e=d+B(a,6)|0;h=w[e+1072|0];if(u[e+1068>>1]<0){break e}if(u[e+1070>>1]>=0){continue}}break}h=(j?-1:0)^h;i=(i&255)+(h&255)|0;t[b+g|0]=i;g=g+1|0;continue}break}a=V(30544)|0;break b}a=V(30544)|0;break b}a=V(30544)|0}if((O()|0)==(ea(30544)|0)){_(a|0)|0;v[23540]=0;Z(18);a=v[23540];v[23540]=0;if((a|0)!=1){break a}a=P()|0;O()|0}Bb(d);T(a|0);L()}a=Gq(d);Bb(d);kb=f+2608|0;return a|0}function GX(a){a=a|0;var b=0,c=0,d=0,e=0;b=kb+-64|0;kb=b;e=Nb(a);v[23540]=0;a=ga(126)|0;c=v[23540];v[23540]=0;a:{b:{if((c|0)==1){break b}c:{d:{if(!a){break d}v[23540]=0;c=Q(1,b+32|0,8992)|0;a=v[23540];v[23540]=0;if((a|0)==1){break c}v[23540]=0;a=ga(126)|0;d=v[23540];v[23540]=0;e:{f:{g:{h:{if((d|0)==1){break h}v[23540]=0;v[b+12>>2]=a;R(132,b+16|0,b+12|0);a=v[23540];v[23540]=0;if((a|0)==1){break h}v[23540]=0;U(2,b+48|0,c|0,b+16|0);a=v[23540];v[23540]=0;if((a|0)==1){break g}d=b+48|0;a=Jb(e,d);Ab(d);Ab(b+16|0);Ab(c);v[23540]=0;c=ga(128)|0;d=v[23540];v[23540]=0;if((d|0)==1){break b}if(!c){break e}v[23540]=0;Q(133,a|0,17533)|0;c=v[23540];v[23540]=0;if((c|0)!=1){break e}break b}a=P()|0;O()|0;break f}a=P()|0;O()|0;Ab(b+16|0)}Ab(c);break a}v[23540]=0;c=ga(127)|0;d=v[23540];v[23540]=0;if((d|0)==1){break b}if(!c){break d}v[23540]=0;Q(133,a|0,16835)|0;a=v[23540];v[23540]=0;if((a|0)==1){break b}}kb=b- -64|0;return}a=P()|0;O()|0;break a}a=P()|0;O()|0}Ab(e);T(a|0);L()}function P1(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;h=kb-32|0;kb=h;f=of(h+16|0,1,0);a:{b:{while(1){j=h+8|0;d=Ac(f);m=d;n=Hb(f)+d|0;i=x[b>>1];d=0;c:{if((c|0)==10){zx(j,m,n,i);break c}e=i;k=B(c,c);l=B(k,c);o=B(k,k);d:{while(1){e=e&65535;g=d|1;if(e>>>0<c>>>0){break d}g=d|2;if(e>>>0<k>>>0){break d}g=d|3;if(e>>>0<l>>>0){break d}if(e>>>0<o>>>0){g=d+4|0}else{d=d+4|0;e=(e>>>0)/(o>>>0)|0;continue}break}}d=g;if((d|0)>(n-m|0)){v[j+4>>2]=61;v[j>>2]=n;break c}l=d+m|0;e=l;while(1){d=i&65535;i=(d|0)/(c|0)|0;e=e-1|0;t[e|0]=w[(d-B(c,i)|0)+4898|0];if(i&65535){continue}break}v[j+4>>2]=0;v[j>>2]=l}if(!v[h+12>>2]){break b}d=ch(Hb(f));v[23540]=0;R(59,f|0,d|0);d=v[23540];v[23540]=0;if((d|0)!=1){continue}break}break a}c=v[h+8>>2];b=Ac(f);v[23540]=0;R(60,f|0,c-b|0);b=v[23540];v[23540]=0;e:{if((b|0)!=1){v[23540]=0;R(72,a|0,f|0);a=v[23540];v[23540]=0;if((a|0)!=1){break e}break a}break a}zb(f);kb=h+32|0;return}a=P()|0;O()|0;zb(f);T(a|0);L()}function Nca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,w=0,x=0,y=0,z=0;e=kb-16|0;kb=e;g=v[a+40>>2];h=v[a+36>>2];i=v[a+16>>2];f=v[a+4>>2];v[e+8>>2]=v[a>>2];v[e+12>>2]=f;j=b+24|0;k=v[a+32>>2];l=v[a+28>>2];m=v[a+8>>2];n=v[a+12>>2];while(1){if(d){f=v[e+8>>2];o=(((v[e+12>>2]&2147483647)<<1|f>>>31)&-2)+i|0;b=(((f>>>16|0)+4&131064)<<1)+j|0;p=u[b+14>>1];q=u[b+12>>1];r=u[b+10>>1];s=u[b+8>>1];w=u[b+6>>1];x=u[b+4>>1];y=u[b+2>>1];z=u[b>>1];f=0;while(1){if((f|0)!=2){b=f+o|0;v[(f<<2)+e>>2]=(((((B(t[b+4|0],r)+B(t[b+2|0],s)|0)+B(t[b+6|0],q)|0)+B(t[b+8|0],p)<<8)/2|0)+((((B(t[b-4|0],y)+B(t[b-6|0],z)|0)+B(t[b-2|0],x)|0)+B(t[b|0],w)<<8)/2|0)|0)/16384;f=f+1|0;continue}break}h=h+l|0;v[c>>2]=v[c>>2]+B(v[e>>2],h>>12);g=g+k|0;v[c+4>>2]=v[c+4>>2]+B(v[e+4>>2],g>>12);Rb(e+8|0,m,n);c=c+8|0;d=d-1|0;continue}break}b=v[e+12>>2];v[a>>2]=v[e+8>>2];v[a+4>>2]=b;v[a+40>>2]=g;v[a+20>>2]=h>>12;v[a+36>>2]=h;v[a+24>>2]=g>>12;kb=e+16|0}function j3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=kb+-64|0;kb=c;e=v[a>>2];a=v[e>>2];f=v[a+4>>2];v[c+40>>2]=v[a+20>>2];d=v[a+16>>2];v[c+32>>2]=v[a+12>>2];v[c+36>>2]=d;Hf(c+48|0,c+32|0,f);a=v[e+4>>2];e=v[a+8>>2];f=v[a+4>>2];d=v[c+60>>2];v[c+24>>2]=v[c+56>>2];v[c+28>>2]=d;d=v[c+52>>2];v[c+16>>2]=v[c+48>>2];v[c+20>>2]=d;v[c+8>>2]=v[a+8>>2];d=v[a+4>>2];v[c>>2]=v[a>>2];v[c+4>>2]=d;a:{b:{c:{d:{d=v[c+4>>2];if(f>>>0<=d>>>0){h=v[c+20>>2];if(f>>>0>h>>>0){break d}if(e>>>0>y[c+8>>2]){break c}i=v[c+28>>2];if(e>>>0>v[c+24>>2]-i>>>0){break b}j=b+12|0;k=v[c+16>>2];l=v[c>>2];b=0;e:while(1){if((b|0)==(e|0)){break a}m=B(b,d);n=B(b+i|0,h);a=0;while(1)if((a|0)==(f|0)){b=b+1|0;continue e}else{g=ld((v[(a+m<<2)+l>>2]+ld(vs(j),21)|0)+2048|0,12);g=(g|0)<32767?g:32767;u[(a+n<<1)+k>>1]=(g|0)>-32768?g:-32768;a=a+1|0;continue}}}aa(7192,9074,33,8787);L()}aa(7157,9074,34,8787);L()}aa(5900,9074,35,8787);L()}aa(5870,9074,36,8787);L()}kb=c- -64|0}function PF(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;a=kb-16|0;kb=a;v[a+12>>2]=c;v[a+8>>2]=f;v[a+12>>2]=c;v[a+8>>2]=f;b=v[a+12>>2];a:{while(1){if(b>>>0>=d>>>0){c=0;break a}c=2;b=v[b>>2];if(b>>>0>1114111|(b&-2048)==55296){break a}b:{c:{if(b>>>0<=127){c=1;f=v[a+8>>2];if((g-f|0)<=0){break a}v[a+8>>2]=f+1;t[f|0]=b;break c}if(b>>>0<=2047){c=v[a+8>>2];if((g-c|0)<2){break b}v[a+8>>2]=c+1;t[c|0]=b>>>6|192;c=v[a+8>>2];v[a+8>>2]=c+1;t[c|0]=b&63|128;break c}c=v[a+8>>2];f=g-c|0;if(b>>>0<=65535){if((f|0)<3){break b}v[a+8>>2]=c+1;t[c|0]=b>>>12|224;c=v[a+8>>2];v[a+8>>2]=c+1;t[c|0]=b>>>6&63|128;c=v[a+8>>2];v[a+8>>2]=c+1;t[c|0]=b&63|128;break c}if((f|0)<4){break b}v[a+8>>2]=c+1;t[c|0]=b>>>18|240;c=v[a+8>>2];v[a+8>>2]=c+1;t[c|0]=b>>>12&63|128;c=v[a+8>>2];v[a+8>>2]=c+1;t[c|0]=b>>>6&63|128;c=v[a+8>>2];v[a+8>>2]=c+1;t[c|0]=b&63|128}b=v[a+12>>2]+4|0;v[a+12>>2]=b;continue}break}c=1}v[e>>2]=v[a+12>>2];v[h>>2]=v[a+8>>2];kb=a+16|0;return c|0}function by(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=kb-16|0;kb=d;f=w[a+2|0];if(!(!f|(f|0)==255)){v[d+12>>2]=f+1;v[d+8>>2]=10;Qg(b,v[td(d+12|0,d+8|0)>>2]);i=w[a+3|0];t[b+15|0]=i;t[b+16|0]=i;j=w[a+4|0];t[b+13|0]=j;l=w[a+5|0];t[b+14|0]=l;f=511;a:{b:{switch(c-1|0){case 1:e=4096;f=128;break a;case 0:break b;default:break a}}e=32768;f=1024}o=f>>>1|e;c=v[b>>2];k=$d(c,v[b+4>>2]);e=0;c:{while(1){if((e|0)==(k|0)){d:{c=w[b+12|0]&-2|t[a|0]&1;t[b+12|0]=c;if(w[a|0]&2){break d}c=c&251;break c}}else{m=Eb(c,e);h=(e<<2)+a|0;g=(w[h+6|0]|w[h+7|0]<<8)>>>4|0;u[m>>1]=g;e:{if(e){n=x[Eb(c,e-1|0)>>1];if(g>>>0>=n>>>0){break e}g=n+1|0}else{g=0}p=Eb(c,e),q=g,u[p>>1]=q}v[d+12>>2]=(((w[h+8|0]|w[h+9|0]<<8)<<16>>16)+o|0)/(f|0);v[d+8>>2]=0;v[d+4>>2]=64;p=m,q=v[Jj(d+12|0,d+8|0,d+4|0)>>2],t[p+2|0]=q;e=e+1|0;continue}break}c=c&-5|(k>>>0>=i>>>0)<<2}t[b+12|0]=c;if(j>>>0<=l>>>0?w[a|0]&4:0){a=c&-3|(k>>>0>=j>>>0)<<1}else{a=c&253}t[b+12|0]=a}kb=d+16|0}function Rx(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=C(0);d=kb-48|0;kb=d;a:{b=v[a+20>>2];b:{if(!b){break b}e=v[b+4>>2];b=v[b+8>>2];if(fd(e,b)>>>0<4){break b}re(d+16|0,e,b);b=ee(d+8|0);e=EU(d+24|0,v[d+16>>2],v[d+20>>2],v[b>>2],v[b+4>>2]);v[23540]=0;b=S(157,e|0)|0;f=v[23540];v[23540]=0;c:{if((f|0)!=1){if(b){break c}b=v[v[a>>2]+40>>2];v[23540]=0;f=S(b|0,a|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break a}b=v[a+20>>2];if(fd(v[b+4>>2],v[b+8>>2])-4>>>0<f<<2>>>0){break c}c=v[v[a>>2]+176>>2];b=0;v[23540]=0;R(c|0,a|0,-1);c=v[23540];v[23540]=0;if((c|0)==1){break a}while(1){if((b|0)==(f|0)){b=v[v[a>>2]+180>>2];v[23540]=0;Y(b|0,a|0);a=v[23540];v[23540]=0;if((a|0)!=1){break c}break a}v[23540]=0;g=C(Ca(461,e|0));c=v[23540];v[23540]=0;d:{if((c|0)==1){break d}c=v[v[a>>2]+44>>2];v[23540]=0;Ba(c|0,a|0,b|0,C(pm(g)?g:C(0)));c=v[23540];v[23540]=0;if((c|0)==1){break d}b=b+1|0;continue}break}break a}break a}Bb(e)}kb=d+48|0;return}a=P()|0;O()|0;Bb(e);T(a|0);L()}function e7(a,b){a=a|0;b=+b;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;d=kb-32|0;kb=d;v[23540]=0;g=Q(13,d+24|0,a|0)|0;c=v[23540];v[23540]=0;a:{b:{c:{if((c|0)!=1){d:{if(!w[g|0]){break d}c=d+16|0;gd(c,v[v[a>>2]-12>>2]+a|0);v[23540]=0;c=S(68,c|0)|0;e=v[23540];v[23540]=0;e:{f:{if((e|0)!=1){ac(d+16|0);e=Tm(d+8|0,a);f=v[v[a>>2]-12>>2];v[23540]=0;f=a+f|0;h=S(14,f|0)|0;i=v[23540];v[23540]=0;if((i|0)==1){break f}e=v[e>>2];v[23540]=0;c=Va(69,c|0,e|0,f|0,h|0,+b)|0;e=v[23540];v[23540]=0;if((e|0)==1){break f}v[d+16>>2]=c;if(!Zu(d+16|0)){break d}c=v[v[a>>2]-12>>2];v[23540]=0;R(16,a+c|0,5);c=v[23540];v[23540]=0;if((c|0)!=1){break d}c=V(0)|0;O()|0;break e}c=V(0)|0;O()|0;ac(d+16|0);break e}c=V(0)|0;O()|0}zk(g);break c}zk(g);break b}c=V(0)|0;O()|0}_(c|0)|0;c=v[v[a>>2]-12>>2];v[23540]=0;Y(17,a+c|0);c=v[23540];v[23540]=0;if((c|0)==1){break a}$()}kb=d+32|0;return a|0}a=P()|0;O()|0;v[23540]=0;Z(18);d=v[23540];v[23540]=0;if((d|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function BJ(a,b){var c=0,d=0,e=0,f=0,g=0,h=0;v[a+4>>2]=b;v[a>>2]=94200;e=(b>>>0)/48|0;d=((0-b|0)!=(B(e,-48)|0))+e|0;v[a+12>>2]=d;e=(b>>>0)/(d>>>0)|0;v[a+8>>2]=e;f=e>>>0<64;c=e&31;if((e&63)>>>0>=32){g=-1<<c}else{g=(1<<c)-1&-1>>>32-c|-1<<c}c=0;v[a+24>>2]=c;f=f?g&65536:0;v[a+28>>2]=f;g=0-c|0;h=Mka(c,f,d,0);c=65536-(f+((c|0)!=0)|0)|0;f=nb;if((c|0)==(f|0)&g>>>0>h>>>0|c>>>0>f>>>0){d=d+1|0;v[a+12>>2]=d;e=(b>>>0)/(d>>>0)|0;v[a+8>>2]=e;f=e>>>0<64;c=e&31;if((e&63)>>>0>=32){c=-1<<c}else{c=(1<<c)-1&-1>>>32-c|-1<<c}v[a+24>>2]=0;v[a+28>>2]=f?c&65536:0}v[a+16>>2]=d-((b>>>0)%(d>>>0)|0);b=e>>>0<63;d=63-e|0;c=d&31;if((d&63)>>>0>=32){d=0;c=-1>>>c|0}else{d=-1>>>c|0;c=d|(1<<c)-1<<32-c}v[a+48>>2]=b?c:-1;v[a+52>>2]=b?d:-1;d=64-e|0;c=d&31;if((d&63)>>>0>=32){d=0;c=-1>>>c|0}else{d=-1>>>c|0;c=d|(1<<c)-1<<32-c}v[a+40>>2]=e?c:0;v[a+44>>2]=e?d:0;c=e+1|0;e=c&31;if((c&63)>>>0>=32){d=-1<<e}else{d=(1<<e)-1&-1>>>32-e|-1<<e}v[a+32>>2]=0;v[a+36>>2]=b?d&65536:0;return a}function Pf(a,b,c){t[a+5|0]=c;a:{b:{switch(b|0){case 0:if(!c){break a}t[a+3|0]=1;return;case 1:t[a+3|0]=2;return;case 2:t[a+3|0]=3;return;case 3:t[a+3|0]=4;return;case 4:t[a+3|0]=5;return;case 5:t[a+3|0]=6;return;case 6:t[a+3|0]=7;return;case 7:t[a+3|0]=8;return;case 8:t[a+3|0]=9;return;case 9:t[a+3|0]=10;return;case 10:t[a+3|0]=11;return;case 11:t[a+3|0]=12;return;case 12:t[a+3|0]=13;return;case 13:t[a+3|0]=14;t[a+5|0]=B(c>>>4|0,10)+(c&15);return;case 14:t[a+3|0]=19;return;case 15:if(c>>>0<=31){t[a+3|0]=16;return}t[a+3|0]=17;return;case 16:t[a+3|0]=23;return;case 17:t[a+3|0]=24;return;case 20:t[a+3|0]=25;return;case 21:t[a+3|0]=30;return;case 25:t[a+3|0]=29;return;case 27:t[a+3|0]=15;return;case 29:t[a+3|0]=18;return;case 32:t[a+3|0]=37;return;case 33:t[a+3|0]=28;return;case 34:t[a+3|0]=27;return;case 35:t[a+3|0]=31;return;case 36:t[a+3|0]=32;return;case 37:t[a+3|0]=32;return;case 38:t[a+3|0]=34;return;default:break b}}t[a+3|0]=0}}function Qga(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;f=kb-48|0;kb=f;u[a>>1]=0;u[a+2>>1]=0;u[a+4>>1]=0;c=f+44|0;po(b,c);a:{if(!LP(c)){break a}d=w[f+46|0];g=w[f+47|0];e=w[f+45|0];t[a+4|0]=1;h=e>>>3&3;c=(h|0)!=3;e=(e>>>1^-1)&3;g=g>>>0<192;u[a+2>>1]=x[(B(c,6)+(e<<1)|0)+27432>>1]<<g;i=B(B(w[(e+B(c,3)|0)+27208|0],x[((B(c,90)+B(e,30)|0)+(d>>>3&30)|0)+27216>>1]),1e3);d=d>>>1|0;d=B(((i>>>0)/x[(B(h,6)+(d&6)|0)+27408>>1]|0)+(d&1)|0,e?1:4);u[a>>1]=d;e=w[(g|c<<1)+27444|0];if(e+8>>>0>(d&65535)>>>0){break a}c=kb-32|0;kb=c;v[c+28>>2]=e+4;v[c+8>>2]=36;g=v[b>>2];h=v[b+8>>2];d=v[Kb(c+28|0,c+8|0)>>2];if(!Qb(g,h,d)){d=cf(b)}h=c+8|0;gr(h,f);g=hc(c+16|0,v[c+8>>2],d);nc(c,v[b>>2],v[b+8>>2],v[g>>2],v[g+4>>2]);gr(h,f);Ub(v[c+8>>2]+d|0,0,36-d|0);$b(b,v[c+28>>2]);kb=c+32|0;b=2;c=e>>>0>2?e:2;while(1){if((b|0)!=(c|0)){d=b+f|0;b=b+1|0;if(!w[d|0]){continue}break a}break}b=e+f|0;if(Sb(b,9595,4)){b=Sb(b,11117,4)}else{b=0}t[a+5|0]=!b}kb=f+48|0;return a|0}function sx(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=C(0);c=kb+-64|0;kb=c;b=v[a>>2];a=v[b>>2];d=v[a+4>>2];v[c+40>>2]=v[a+20>>2];e=v[a+16>>2];v[c+32>>2]=v[a+12>>2];v[c+36>>2]=e;Hf(c+48|0,c+32|0,d);a=v[b+4>>2];d=v[a+8>>2];e=v[a+4>>2];b=v[c+60>>2];v[c+24>>2]=v[c+56>>2];v[c+28>>2]=b;b=v[c+52>>2];v[c+16>>2]=v[c+48>>2];v[c+20>>2]=b;v[c+8>>2]=v[a+8>>2];b=v[a+4>>2];v[c>>2]=v[a>>2];v[c+4>>2]=b;a:{b:{c:{d:{f=v[c+4>>2];if(f>>>0>=e>>>0){if(y[c+20>>2]<e>>>0){break d}if(d>>>0>y[c+8>>2]){break c}g=v[c+28>>2];if(d>>>0>v[c+24>>2]-g>>>0){break b}h=v[c+16>>2];i=v[c>>2];b=0;e:while(1){if((b|0)==(d|0)){break a}j=b+g|0;k=B(b,f);a=0;while(1)if((a|0)==(e|0)){b=b+1|0;continue e}else{l=ve(ng(A[(a+k<<3)+i>>3])*134217728);m=v[(a<<2)+h>>2]+(j<<2)|0,n=C(+(Jm(l)|0)*7.450580596923828e-9),z[m>>2]=n;a=a+1|0;continue}}}aa(7192,9074,77,8754);L()}aa(7157,9074,78,8754);L()}aa(5900,9074,79,8754);L()}aa(5870,9074,80,8754);L()}kb=c- -64|0}function zq(a){var b=0,c=0,d=0,e=0,f=0;e=kb-16|0;kb=e;a:{b:{c:{d:{e:{f:{g:{h:{b=v[a+480180>>2];switch(b-1|0){case 7:break e;case 0:case 1:case 3:break f;case 2:case 4:case 5:case 6:break g;default:break h}}if((b|0)==16){break b}if((b|0)==32){break f}if((b|0)==64|(b|0)==256|((b|0)==512|(b|0)==2048)|(b|0)==8192){break b}if((b|0)==65536){break d}d=1;if((b|0)==2097152){break a}if((b|0)==4194304){break c}if((b|0)==536870912|(b|0)==67108864|(b|0)==134217728){break a}d=b;if((b|0)==16777216){break a}}d=32;break a}d=b;break a}d=4;if(x[a+480192>>1]){break a}c=Fb(v[a+484344>>2]);v[e+8>>2]=c;a=Fb(v[a+484348>>2]);while(1){if(!Pb(c,a)){d=1;break a}if(!(!Pb(v[c>>2],v[c+4>>2])|v[c+12>>2]==64)){break a}c=v[NM(e+8|0)>>2];continue}}d=16777216;break a}d=32;f=x[a+480188>>1];if(f>>>0>16){break a}while(1){if((c|0)==(f|0)){break b}b=(c<<5)+a|0;if(t[b+480281|0]&1){break a}c=c+1|0;if(x[b+480286>>1]==64){continue}break}break a}d=2}kb=e+16|0;return d}function rx(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=C(0);c=kb+-64|0;kb=c;b=v[a>>2];a=v[b>>2];d=v[a+4>>2];v[c+40>>2]=v[a+20>>2];e=v[a+16>>2];v[c+32>>2]=v[a+12>>2];v[c+36>>2]=e;Hf(c+48|0,c+32|0,d);a=v[b+4>>2];d=v[a+8>>2];e=v[a+4>>2];b=v[c+60>>2];v[c+24>>2]=v[c+56>>2];v[c+28>>2]=b;b=v[c+52>>2];v[c+16>>2]=v[c+48>>2];v[c+20>>2]=b;v[c+8>>2]=v[a+8>>2];b=v[a+4>>2];v[c>>2]=v[a>>2];v[c+4>>2]=b;a:{b:{c:{d:{f=v[c+4>>2];if(f>>>0>=e>>>0){g=v[c+20>>2];if(g>>>0<e>>>0){break d}if(d>>>0>y[c+8>>2]){break c}h=v[c+28>>2];if(d>>>0>v[c+24>>2]-h>>>0){break b}i=v[c+16>>2];j=v[c>>2];b=0;e:while(1){if((b|0)==(d|0)){break a}k=B(b,f);l=B(b+h|0,g);a=0;while(1)if((a|0)==(e|0)){b=b+1|0;continue e}else{m=(a+l<<2)+i|0,n=C(+(Jm(ve(ng(A[(a+k<<3)+j>>3])*134217728))|0)*7.450580596923828e-9),z[m>>2]=n;a=a+1|0;continue}}}aa(7192,9074,77,8754);L()}aa(7157,9074,78,8754);L()}aa(5900,9074,79,8754);L()}aa(5870,9074,80,8754);L()}kb=c- -64|0}function z9(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;d=v[a>>2];c=Qj(d,v[a+4>>2]);if(c>>>0<b>>>0){g=kb-32|0;kb=g;e=b-c|0;b=v[Gb(a)>>2];c=v[a+4>>2];a:{if(e>>>0<=b-c>>11>>>0){b=kb-16|0;kb=b;v[b>>2]=a;a=v[a+4>>2];v[b+4>>2]=a;v[b+8>>2]=a+(e<<11);a=v[b+4>>2];c=v[b+8>>2];while(1){if((a|0)==(c|0)){lc(b);kb=b+16|0}else{yL(a);a=a+2048|0;v[b+4>>2]=a;continue}break}break a}h=Gb(a);i=g+8|0;b=a;f=Qj(v[a>>2],c)+e|0;c=kb-16|0;kb=c;v[c+12>>2]=f;d=kb-16|0;kb=d;v[d+12>>2]=2097151;v[d+8>>2]=2147483647;a=v[Kb(d+12|0,d+8|0)>>2];kb=d+16|0;b:{if(a>>>0>=f>>>0){d=Tx(b);if(d>>>0<a>>>1>>>0){v[c+8>>2]=d<<1;a=v[_c(c+8|0,c+12|0)>>2]}kb=c+16|0;break b}cd();L()}d=AL(i,a,Qj(v[b>>2],v[b+4>>2]),h);c=d;a=kb-16|0;kb=a;v[a>>2]=v[c+8>>2];f=v[c+8>>2];v[a+8>>2]=c+8;v[a+4>>2]=f+(e<<11);c=v[a>>2];while(1){if(v[a+4>>2]!=(c|0)){yL(c);c=v[a>>2]+2048|0;v[a>>2]=c;continue}break}Ud(a);kb=a+16|0;Fd(b,d);zL(d)}kb=g+32|0;return}if(b>>>0<c>>>0){Od(a,d+(b<<11)|0)}}function t3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=kb+-64|0;kb=c;b=v[a>>2];a=v[b>>2];d=v[a+4>>2];v[c+40>>2]=v[a+20>>2];e=v[a+16>>2];v[c+32>>2]=v[a+12>>2];v[c+36>>2]=e;Hf(c+48|0,c+32|0,d);a=v[b+4>>2];d=v[a+8>>2];e=v[a+4>>2];b=v[c+60>>2];v[c+24>>2]=v[c+56>>2];v[c+28>>2]=b;b=v[c+52>>2];v[c+16>>2]=v[c+48>>2];v[c+20>>2]=b;v[c+8>>2]=v[a+8>>2];b=v[a+4>>2];v[c>>2]=v[a>>2];v[c+4>>2]=b;a:{b:{c:{d:{g=v[c+4>>2];if(g>>>0>=e>>>0){if(y[c+20>>2]<e>>>0){break d}if(d>>>0>y[c+8>>2]){break c}h=v[c+28>>2];if(d>>>0>v[c+24>>2]-h>>>0){break b}i=v[c+16>>2];j=v[c>>2];b=0;e:while(1){if((b|0)==(d|0)){break a}k=b+h|0;l=B(b,g);a=0;while(1)if((a|0)==(e|0)){b=b+1|0;continue e}else{m=v[(a<<2)+i>>2]+(k<<1)|0;f=ld(v[(a+l<<2)+j>>2]+2048|0,12);f=(f|0)<32767?f:32767;u[m>>1]=(f|0)>-32768?f:-32768;a=a+1|0;continue}}}aa(7192,9074,33,8787);L()}aa(7157,9074,34,8787);L()}aa(5900,9074,35,8787);L()}aa(5870,9074,36,8787);L()}kb=c- -64|0}function Ds(a){var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,k=0;o(+a);e=j(1)|0;c=j(0)|0;a:{b:{d=e>>>20&2047;if(d-969>>>0<63){k=d;break b}if(d>>>0<=968){return a+1}if(d>>>0<1033){break b}b=0;if(!c&(e|0)==-1048576){break a}if((d|0)==2047){return a+1}if((e|0)<0){return Jr(1.2882297539194267e-231)}return Jr(3.105036184601418e231)}b=A[170];f=A[169]*a+b;b=f-b;b=b*A[172]+(b*A[171]+a);a=b*b;g=a*a*(b*A[176]+A[175]);a=a*(b*A[174]+A[173]);o(+f);j(1)|0;h=j(0)|0;c=h<<4&2032;b=g+(a+(A[c+1464>>3]+b));d=c+1472|0;c=h<<13;e=0;i=v[d>>2]+e|0;c=c+v[d+4>>2]|0;c=e>>>0>i>>>0?c+1|0:c;d=i;if(!k){c:{if(!(h&-2147483648)){l(0,d|0);l(1,c-1058013184|0);a=+n();a=(a*b+a)*5.486124068793689e303;break c}e=kb-16|0;l(0,d|0);l(1,c+1071644672|0);g=+n();f=g*b;a=f+g;if(a<1){v[e+8>>2]=0;v[e+12>>2]=1048576;A[e+8>>3]=A[e+8>>3]*2.2250738585072014e-308;b=a+1;a=b+(f+(g-a)+(a+(1-b)))+-1;a=a==0?0:a}a=a*2.2250738585072014e-308}return a}l(0,d|0);l(1,c|0);a=+n();b=a*b+a}return b}function Bca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=kb-16|0;kb=e;n=v[a+16>>2];o=kg(b+327720|0,v[b+20>>2],(v[a+88>>2]&16384)>>>14|0);k=v[a+128>>2];a:{if(!k){i=v[a+8>>2];j=v[a+12>>2];g=v[a>>2];b=v[a+4>>2];h=0;break a}i=v[a+8>>2];j=v[a+12>>2];l=lg(i,j,k);m=nb;h=v[a+76>>2];g=v[a>>2];b=v[a+4>>2];Qf(g,b,qf(i,j,d),nb);h=h>>>0<nb>>>0?d:0}f=a+112|0;p=v[a+24>>2];q=v[a+20>>2];v[e>>2]=g;v[e+4>>2]=b;b:while(1){if(d){b=v[e+4>>2];v[e+8>>2]=v[e>>2];v[e+12>>2]=0;h=h-1|0;l=h?l:0;m=h?m:0;d=d-1|0;g=(b<<1)+n|0;b=k;while(1)if((b|0)<=0){Rb(f,v[a+120>>2],v[a+124>>2]);b=v[a+116>>2];if(b){Sd(f,u[(v[e+12>>2]<<1)+g>>1]/4<<16>>16);Rd(f,b);v[f>>2]=v[f>>2];v[f+4>>2]=0}g=v[c>>2];b=jg(f,o);v[c>>2]=g+B(b,q);v[c+4>>2]=v[c+4>>2]+B(b,p);Rb(e,i,j);c=c+8|0;continue b}else{Sd(f,u[(v[e+12>>2]<<1)+g>>1]/4<<16>>16);Rd(f,4);Rb(e+8|0,l,m);b=b-1|0;continue}}break}b=v[e+4>>2];v[a>>2]=v[e>>2];v[a+4>>2]=b;kb=e+16|0}function Fda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,w=0,x=0;g=kb-16|0;kb=g;f=v[a+48>>2];j=v[a+24>>2];k=v[a+20>>2];e=v[a+44>>2];l=v[a+16>>2];b=v[a+4>>2];v[g+8>>2]=v[a>>2];v[g+12>>2]=b;m=v[a+72>>2];b=v[a+68>>2];n=b;o=b>>31;b=v[a+64>>2];p=b;q=b>>31;b=v[a+60>>2];r=b;s=b>>31;u=v[a+8>>2];w=v[a+12>>2];while(1){b=e;if(d){e=Zb(b,-16777216,16776704);e=Jka(p,q,e,e>>31);i=nb;f=Zb(f,-16777216,16776704);h=Jka(n,o,f,f>>31);e=h+e|0;f=nb+i|0;f=e>>>0<h>>>0?f+1|0:f;i=e;h=v[g+12>>2]+l|0;e=t[h|0];x=i;i=((B(t[h+1|0]-e|0,v[g+8>>2]>>>10&4194048)|0)/16384|0)+(e<<8)<<8;e=i;h=Jka(e,e>>31,r,s);e=x+h|0;f=nb+f|0;f=e>>>0<h>>>0?f+1|0:f;e=e+8388608|0;f=e>>>0<8388608?f+1|0:f;f=Yc(e,f,24);e=(f|0)/256|0;v[c>>2]=B(e,k)+v[c>>2];v[c+4>>2]=v[c+4>>2]+B(e,j);Rb(g+8|0,u,w);e=f-(i&m)|0;c=c+8|0;d=d-1|0;f=b;continue}break}c=v[g+12>>2];v[a>>2]=v[g+8>>2];v[a+4>>2]=c;v[a+48>>2]=f;v[a+44>>2]=b;kb=g+16|0}function k3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=kb+-64|0;kb=c;b=v[a>>2];a=v[b>>2];d=v[a+4>>2];v[c+40>>2]=v[a+20>>2];e=v[a+16>>2];v[c+32>>2]=v[a+12>>2];v[c+36>>2]=e;Hf(c+48|0,c+32|0,d);a=v[b+4>>2];d=v[a+8>>2];e=v[a+4>>2];b=v[c+60>>2];v[c+24>>2]=v[c+56>>2];v[c+28>>2]=b;b=v[c+52>>2];v[c+16>>2]=v[c+48>>2];v[c+20>>2]=b;v[c+8>>2]=v[a+8>>2];b=v[a+4>>2];v[c>>2]=v[a>>2];v[c+4>>2]=b;a:{b:{c:{d:{g=v[c+4>>2];if(g>>>0>=e>>>0){h=v[c+20>>2];if(h>>>0<e>>>0){break d}if(d>>>0>y[c+8>>2]){break c}i=v[c+28>>2];if(d>>>0>v[c+24>>2]-i>>>0){break b}j=v[c+16>>2];k=v[c>>2];b=0;e:while(1){if((b|0)==(d|0)){break a}l=B(b,g);m=B(b+i|0,h);a=0;while(1)if((a|0)==(e|0)){b=b+1|0;continue e}else{f=ld(v[(a+l<<2)+k>>2]+2048|0,12);f=(f|0)<32767?f:32767;u[(a+m<<1)+j>>1]=(f|0)>-32768?f:-32768;a=a+1|0;continue}}}aa(7192,9074,33,8787);L()}aa(7157,9074,34,8787);L()}aa(5900,9074,35,8787);L()}aa(5870,9074,36,8787);L()}kb=c- -64|0}function YP(a,b,c,d){var e=0,f=0;e=kb-16|0;kb=e;t[e+15|0]=c;f=b&15;b=w[f+27136|0];a:{b:{switch(f|0){case 0:b=c?d>>>0<51?0:b:0;break a;case 5:c:{d:{f=c&15;e:{if(!((f|0)!=2&(c&240)!=32)){c=159;t[e+15|0]=159;b=20;break e}if((f|0)==12){break d}}if(d>>>0<51){break a}if((c&240)==192){break c}break a}if(d>>>0<51){break a}}t[e+15|0]=0;b=25;break a;case 7:b=d>>>0<52?0:b;break a;case 10:c=c&240;if(!c){break a}t[e+15|0]=c;break a;case 11:t[e+15|0]=B(c&15,17);break a;case 12:t[e+15|0]=c>>>2;break a;case 13:t[e+15|0]=B(c>>>4|0,10)+(c&15);break a;case 14:f:{switch((c>>>4|0)-1|0){case 0:t[e+15|0]=c|240;b=2;break a;case 1:t[e+15|0]=c|240;b=3;break a;case 7:if(d>>>0<52){break a}t[e+15|0]=c&15|96;case 11:case 12:b=20;break a;case 8:b=15;t[e+15|0]=c&15;break a;case 9:t[e+15|0]=c<<4|15;b=11;break a;case 10:break f;default:break a}}t[e+15|0]=c|240;b=11;break a;case 15:break b;default:break a}}b=c>>>0>47?17:b}de(a,b,e+15|0);kb=e+16|0}function gja(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;nd(b,32);vo(b);f=b,g=Ib(w[a+40|0]|w[a+41|0]<<8)>>>2|0,u[f+32>>1]=g;c=x[b+34>>1];if((pe((w[a+38|0]|w[a+39|0]<<8)<<16>>16)|0)>0){c=c|32;u[b+34>>1]=c;d=pe((w[a+38|0]|w[a+39|0]<<8)<<16>>16);e=(d<<8&-256)+2047|0;d=d>>>24|0;f=b,g=Ec(Mka(e,e>>>0<2047?d+1|0:d,4095,0),nb),u[f+28>>1]=g}f=b,g=bc(w[a+58|0]|w[a+59|0]<<8|(w[a+60|0]<<16|w[a+61|0]<<24)),v[f>>2]=g;f=b,g=bc(w[a+62|0]|w[a+63|0]<<8|(w[a+64|0]<<16|w[a+65|0]<<24)),v[f+4>>2]=g;f=b,g=bc(w[a+62|0]|w[a+63|0]<<8|(w[a+64|0]<<16|w[a+65|0]<<24))+bc(w[a+66|0]|w[a+67|0]<<8|(w[a+68|0]<<16|w[a+69|0]<<24))|0,v[f+8>>2]=g;c=c&-3|((Ib(w[a+44|0]|w[a+45|0]<<8)|0)!=0)<<1;u[b+34>>1]=c;f=b,g=c&65531|Ib(w[a+44|0]|w[a+45|0]<<8)<<1&4,u[f+34>>1]=g;f=b,g=bc(w[a+54|0]|w[a+55|0]<<8|(w[a+56|0]<<16|w[a+57|0]<<24))<<1,v[f+24>>2]=g;c=pe((w[a+42|0]|w[a+43|0]<<8)<<16>>16);if(c){zl(b,+(c|0)/96);c=pe((w[a+42|0]|w[a+43|0]<<8)<<16>>16)}t[b+37|0]=c<<4}function Eda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0;g=kb-16|0;kb=g;f=v[a+48>>2];j=v[a+24>>2];k=v[a+20>>2];e=v[a+44>>2];l=v[a+16>>2];b=v[a+4>>2];v[g+8>>2]=v[a>>2];v[g+12>>2]=b;m=v[a+72>>2];b=v[a+68>>2];n=b;o=b>>31;b=v[a+64>>2];p=b;q=b>>31;b=v[a+60>>2];r=b;s=b>>31;t=v[a+8>>2];w=v[a+12>>2];while(1){b=e;if(d){e=Zb(b,-16777216,16776704);e=Jka(p,q,e,e>>31);i=nb;f=Zb(f,-16777216,16776704);h=Jka(n,o,f,f>>31);e=h+e|0;f=nb+i|0;f=e>>>0<h>>>0?f+1|0:f;i=e;h=(v[g+12>>2]<<1)+l|0;e=u[h>>1];x=i;i=e+((B(u[h+2>>1]-e|0,v[g+8>>2]>>>18|0)|0)/16384|0)<<8;e=i;h=Jka(e,e>>31,r,s);e=x+h|0;f=nb+f|0;f=e>>>0<h>>>0?f+1|0:f;e=e+8388608|0;f=e>>>0<8388608?f+1|0:f;f=Yc(e,f,24);e=(f|0)/256|0;v[c>>2]=B(e,k)+v[c>>2];v[c+4>>2]=v[c+4>>2]+B(e,j);Rb(g+8|0,t,w);e=f-(i&m)|0;c=c+8|0;d=d-1|0;f=b;continue}break}c=v[g+12>>2];v[a>>2]=v[g+8>>2];v[a+4>>2]=c;v[a+48>>2]=f;v[a+44>>2]=b;kb=g+16|0}function Y7(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=C(0),o=0,p=0,q=0,r=0,s=0,t=C(0),u=C(0),x=C(0),y=C(0),A=0,B=0,E=0,F=0,G=0,H=C(0);g=kb-16|0;kb=g;m=v[a+4240>>2];a:{if(!m){break a}if(!bi(a+44|0)){break a}n=z[a+4220>>2];e=v[a+44>>2];F=g,G=Jc(e,0),v[F+8>>2]=G;F=g,G=Jc(e,1),v[F+12>>2]=G;e=v[a+56>>2];o=Jc(e,0);v[g>>2]=o;p=Jc(e,1);v[g+4>>2]=p;y=C(C(1)-n);q=v[a+4208>>2];A=w[a+4264|0];e=d;b:while(1){if(e){k=v[a+4244>>2];B=k<<1;f=0;l=0;while(1)if((f|0)==2){f=k+1|0;v[a+4244>>2]=(f|0)==(m|0)?0:f;e=e-1|0;continue b}else{h=(A?1-l|0:f)&255;j=v[((h<<2)+a|0)+4248>>2];E=v[a+4240>>2];r=f<<2;s=r+(g+8|0)|0;i=v[s>>2];v[s>>2]=i+4;j=k-j|0;t=z[Eb(q,h+((j>>31&E)+j<<1)|0)>>2];u=z[i>>2];x=C(C(t*z[a+4224>>2])+C(u*z[a+4260>>2]));F=Eb(q,f+B|0),H=C(D(x))<C(1.0000000195414814e-24)?C(0):x,z[F>>2]=H;h=g+r|0;i=v[h>>2];v[h>>2]=i+4;z[i>>2]=C(u*y)+C(n*t);l=l+1|0;f=f+1|0;continue}}break}ti(a,b,c,o,p,d)}kb=g+16|0}function Ew(a){var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;b=a;a:{if(b&3){while(1){c=w[b|0];if(!c|(c|0)==61){break a}b=b+1|0;if(b&3){continue}break}}c=v[b>>2];d=(c^-1)&-2139062144;b:{if(d&c-16843009|d&(c^1027423549)-16843009){break b}while(1){c=v[b+4>>2];b=b+4|0;d=(c^-1)&-2139062144;if(d&c-16843009){break b}if(!(d&(c^1027423549)-16843009)){continue}break}}c=c&255;if(!c|(c|0)==61){break a}while(1){c:{c=b+1|0;d=w[b+1|0];if((d|0)==61){break c}b=c;if(d){continue}}break}b=c}if((a|0)==(b|0)){return 0}g=b-a|0;d:{if(w[g+a|0]){break d}f=v[116954];if(!f){break d}b=v[f>>2];if(!b){break d}while(1){e:{c=a;d=b;i=0;h=g;e=0;f:{if(!g){break f}e=w[c|0];g:{if(!e){break g}while(1){h:{j=w[d|0];if(!j){break h}h=h-1|0;if(!h|(e|0)!=(j|0)){break h}d=d+1|0;e=w[c+1|0];c=c+1|0;if(e){continue}break g}break}i=e}e=(i&255)-w[d|0]|0}if(!e){b=b+g|0;if(w[b|0]==61){break e}}b=v[f+4>>2];f=f+4|0;if(b){continue}break d}break}k=b+1|0}return k}function xw(a,b,c,d,e,f,g,h,i,j,k,l){var m=0;m=kb-16|0;kb=m;t[m+15|0]=a;a:{b:{if((a|0)==(f|0)){if(!w[b|0]){break b}a=0;t[b|0]=0;b=v[e>>2];v[e>>2]=b+1;t[b|0]=46;if(!Hb(h)){break a}b=v[j>>2];if((b-i|0)>159){break a}c=v[k>>2];v[j>>2]=b+4;v[b>>2]=c;break a}c:{if((a|0)!=(g|0)){break c}if(!Hb(h)){break c}if(!w[b|0]){break b}a=0;b=v[j>>2];if((b-i|0)>159){break a}a=v[k>>2];v[j>>2]=b+4;v[b>>2]=a;a=0;v[k>>2]=0;break a}a=-1;f=zi(l,l+32|0,m+15|0)-l|0;if((f|0)>31){break a}g=w[f+83808|0];d:{e:{switch((f&-2)-22|0){case 2:b=v[e>>2];if((b|0)!=(d|0)&(w[b-1|0]&95)!=(w[c|0]&127)){break a}v[e>>2]=b+1;t[b|0]=g;a=0;break a;case 0:t[c|0]=80;break d;default:break e}}a=g&95;if((a|0)!=w[c|0]){break d}t[c|0]=a|128;if(!w[b|0]){break d}t[b|0]=0;if(!Hb(h)){break d}a=v[j>>2];if((a-i|0)>159){break d}b=v[k>>2];v[j>>2]=a+4;v[a>>2]=b}a=v[e>>2];v[e>>2]=a+1;t[a|0]=g;a=0;if((f|0)>21){break a}v[k>>2]=v[k>>2]+1;break a}a=-1}kb=m+16|0;return a}function Uda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0;g=kb-16|0;kb=g;m=v[a+16>>2];j=Tf(1,2);b=nb;n=b;Rb(a,j,b);f=v[a+48>>2];o=v[a+24>>2];p=v[a+20>>2];e=v[a+44>>2];b=v[a+4>>2];v[g+8>>2]=v[a>>2];v[g+12>>2]=b;q=v[a+72>>2];b=v[a+68>>2];r=b;s=b>>31;b=v[a+64>>2];t=b;w=b>>31;b=v[a+60>>2];x=b;y=b>>31;z=v[a+8>>2];A=v[a+12>>2];while(1){b=e;if(d){k=u[(v[g+12>>2]<<1)+m>>1]<<8;e=k;e=Jka(e,e>>31,x,y);i=nb;h=e;e=Zb(b,-16777216,16776704);l=Jka(t,w,e,e>>31);h=h+l|0;e=nb+i|0;e=h>>>0<l>>>0?e+1|0:e;f=Zb(f,-16777216,16776704);i=Jka(r,s,f,f>>31);h=i+h|0;f=nb+e|0;f=h>>>0<i>>>0?f+1|0:f;e=h+8388608|0;f=e>>>0<8388608?f+1|0:f;f=Yc(e,f,24);e=(f|0)/256|0;v[c>>2]=B(e,p)+v[c>>2];v[c+4>>2]=v[c+4>>2]+B(e,o);Rb(g+8|0,z,A);e=f-(q&k)|0;c=c+8|0;d=d-1|0;f=b;continue}break}c=v[g+12>>2];v[a>>2]=v[g+8>>2];v[a+4>>2]=c;v[a+48>>2]=f;v[a+44>>2]=b;mg(a,j,n);kb=g+16|0}function N6(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=kb-80|0;kb=e;v[e+72>>2]=c;a=eg(a,e+72|0);c=Gc(a+4|0);h=Gc(a+24|0);i=Gc(a+32|0);j=Tb(a+36|0);v[a+56>>2]=3;k=Tb(a+68|0);v[23540]=0;R(941,a|0,d|0);f=v[23540];v[23540]=0;a:{b:{c:{d:{if((f|0)!=1){f=v[b>>2];g=v[b+4>>2];l=v[b+12>>2];v[e+40>>2]=v[b+8>>2];v[e+44>>2]=l;v[e+32>>2]=f;v[e+36>>2]=g;b=ee(e+24|0);f=v[b+4>>2];b=v[b>>2];g=v[e+44>>2];v[e+16>>2]=v[e+40>>2];v[e+20>>2]=g;v[23540]=0;g=v[e+36>>2];v[e+8>>2]=v[e+32>>2];v[e+12>>2]=g;X(930,e+48|0,e+8|0,b|0,f|0);b=v[23540];v[23540]=0;if((b|0)==1){break d}v[23540]=0;U(942,a|0,e+48|0,d|0);b=v[23540];v[23540]=0;if((b|0)==1){break c}Bb(e+48|0);v[23540]=0;Y(943,a|0);b=v[23540];v[23540]=0;if((b|0)==1){break b}De(e+72|0);kb=e+80|0;return a|0}d=P()|0;O()|0;break a}d=P()|0;O()|0;break a}d=P()|0;O()|0;Bb(e+48|0);break a}d=P()|0;O()|0}Xe(k);Xf(j);As(i);ij(h);hj(c);De(a);De(e+72|0);T(d|0);L()}function Vha(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;e=kb-32|0;kb=e;b=kb-32|0;kb=b;v[b+16>>2]=1073741824;u[b+22>>1]=12;c=vc(64);v[23540]=0;d=S(835,c|0)|0;f=v[23540];v[23540]=0;a:{b:{c:{if((f|0)!=1){c=Lf(b+8|0,d);d=v[c>>2];v[23540]=0;R(836,d|0,a|0);a=v[23540];v[23540]=0;if((a|0)==1){break c}a=v[c>>2];v[23540]=0;a=W(837,a|0,b+22|0,b+16|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break c}d:{if(!a){Gc(b+24|0);break d}a=v[c>>2];v[23540]=0;R(838,a|0,15);a=v[23540];v[23540]=0;if((a|0)==1){break c}eg(b+24|0,c)}sg(c);kb=b+32|0;b=v[b+24>>2];break a}a=P()|0;O()|0;Mb(c);break b}a=P()|0;O()|0;sg(c)}T(a|0);L()}v[e+24>>2]=b;a=0;e:{f:{g:{while(1){if((a|0)==12){break e}v[23540]=0;c=Q(1,e+8|0,(a<<2)+32240|0)|0;d=v[23540];v[23540]=0;if((d|0)!=1){v[23540]=0;U(486,b|0,a|0,c|0);d=v[23540];v[23540]=0;if((d|0)==1){break g}Ab(c);a=a+1|0;continue}break}a=P()|0;O()|0;break f}a=P()|0;O()|0;Ab(c)}sg(e+24|0);T(a|0);L()}kb=e+32|0;return b|0}function Ip(a){a=a|0;var b=0,c=0,d=C(0),e=C(0),f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=C(0),n=0,o=C(0);b=v[a+36>>2];if(!b){Lc(a+16|0);return}a:{b:{switch(x[a>>1]){case 3:c=a+16|0;if(b>>>0>=1001){Lc(c);return}ek(c,b);b=u[a+28>>1];d=C(qm(a,(b<<16)+65536>>16)/qm(a,b));c=v[a+36>>2]+1|0;d=te(d,C(C(1)/C(c>>>0)));a=v[a+16>>2];b=1;while(1){if((b|0)==(c|0)){break a}e=te(d,C(b>>>0));n=Eb(a,b-1|0),o=e,z[n>>2]=o;b=b+1|0;continue};case 1:c=a+16|0;f=x[a+30>>1];if(f>>>0>1e3/(b>>>0)>>>0){Lc(c);return}ek(c,B(b,f));h=x[a+30>>1];j=Qn(u[a+28>>1],h);i=v[a+36>>2];d=C(C(1)/C(i+1>>>0));c=0;c:while(1){if((c&65535)>>>0>=f>>>0){break a}b=Qn(c+j<<16>>16,h)<<16;e=qm(a,b+65536>>16);b=b>>16;e=te(C(e/qm(a,b)),d);k=B(b,v[a+36>>2]);l=v[a+16>>2];b=1;while(1){g=b&65535;if(i>>>0<g>>>0){c=c+1|0;continue c}else{m=te(e,C(g>>>0));n=Eb(l,(g+k|0)-1|0),o=m,z[n>>2]=o;b=b+1|0;continue}}};case 0:Lc(a+16|0);return;default:break b}}Lc(a+16|0);v[a+36>>2]=0}}function Vda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,w=0,x=0,y=0,z=0,A=0;g=kb-16|0;kb=g;m=v[a+16>>2];j=Tf(1,2);b=nb;n=b;Rb(a,j,b);f=v[a+48>>2];o=v[a+24>>2];p=v[a+20>>2];e=v[a+44>>2];b=v[a+4>>2];v[g+8>>2]=v[a>>2];v[g+12>>2]=b;q=v[a+72>>2];b=v[a+68>>2];r=b;s=b>>31;b=v[a+64>>2];u=b;w=b>>31;b=v[a+60>>2];x=b;y=b>>31;z=v[a+8>>2];A=v[a+12>>2];while(1){b=e;if(d){k=t[v[g+12>>2]+m|0]<<16;e=k;e=Jka(e,e>>31,x,y);i=nb;h=e;e=Zb(b,-16777216,16776704);l=Jka(u,w,e,e>>31);h=h+l|0;e=nb+i|0;e=h>>>0<l>>>0?e+1|0:e;f=Zb(f,-16777216,16776704);i=Jka(r,s,f,f>>31);h=i+h|0;f=nb+e|0;f=h>>>0<i>>>0?f+1|0:f;e=h+8388608|0;f=e>>>0<8388608?f+1|0:f;f=Yc(e,f,24);e=(f|0)/256|0;v[c>>2]=B(e,p)+v[c>>2];v[c+4>>2]=v[c+4>>2]+B(e,o);Rb(g+8|0,z,A);e=f-(q&k)|0;c=c+8|0;d=d-1|0;f=b;continue}break}c=v[g+12>>2];v[a>>2]=v[g+8>>2];v[a+4>>2]=c;v[a+48>>2]=f;v[a+44>>2]=b;mg(a,j,n);kb=g+16|0}function u9(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=C(0),j=0,k=0,l=0,m=0,n=C(0),o=C(0),p=C(0),q=C(0),r=0,s=0,t=0,u=C(0),w=C(0),x=C(0),y=C(0),A=0,B=0,E=0,F=C(0);r=v[a+4220>>2];if(r){f=v[a+44>>2];k=Jc(f,0);l=Jc(f,1);g=v[a+56>>2];s=Jc(g,0);j=v[a+4208>>2];A=v[a+4228>>2];f=d;t=Jc(g,1);m=t;g=s;while(1){if(f){h=v[a+4224>>2];e=h-A|0;e=(v[a+4220>>2]&e>>31)+e<<1;B=Eb(j,e);n=z[Eb(j,e|1)>>2];u=z[a+4244>>2];o=z[B>>2];w=z[a+4252>>2];p=z[l>>2];x=z[a+4248>>2];q=z[k>>2];y=z[a+4256>>2];i=C(C(n*u)+C(C(o*w)+C(C(p*x)+C(q*y))));e=h<<1;E=Eb(j,e),F=C(D(i))<C(1.0000000195414814e-24)?C(0):i,z[E>>2]=F;i=C(C(o*u)+C(C(n*w)+C(C(q*x)+C(p*y))));E=Eb(j,e|1),F=C(D(i))<C(1.0000000195414814e-24)?C(0):i,z[E>>2]=F;h=h+1|0;v[a+4224>>2]=(h|0)==(r|0)?0:h;z[g>>2]=C(q*z[a+4240>>2])+C(o*z[a+4236>>2]);z[m>>2]=C(p*z[a+4240>>2])+C(n*z[a+4236>>2]);f=f-1|0;m=m+4|0;g=g+4|0;l=l+4|0;k=k+4|0;continue}else{ti(a,b,c,s,t,d)}break}}}function gda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;f=kb-16|0;kb=f;a:{b:{c:{g=v[a+12>>2];i=v[a+8>>2];d:{if((g|0)<=1&i>>>0<=805306368|(g|0)<=0){if((g|0)>=-2&i>>>0>=3489660928|(g|0)>-2){break c}if((g|0)==-2&i>>>0>2147483647|g>>>0>4294967294){break d}break b}if((g|0)==1&i>>>0>2147483648|g>>>0>1){break b}}b=b+196648|0;break a}b=b+131112|0;break a}b=b+262184|0}j=v[a+16>>2];k=v[a+24>>2];l=v[a+20>>2];e=v[a+4>>2];v[f+8>>2]=v[a>>2];v[f+12>>2]=e;while(1){if(d){e=(v[f+12>>2]<<1)+j|0;h=(v[f+8>>2]>>>16&65520)+b|0;e=(((((((B(u[e-4>>1],u[h+2>>1])+B(u[e-6>>1],u[h>>1])|0)+B(u[e-2>>1],u[h+4>>1])|0)+B(u[e>>1],u[h+6>>1])|0)+B(u[e+2>>1],u[h+8>>1])|0)+B(u[e+4>>1],u[h+10>>1])|0)+B(u[e+6>>1],u[h+12>>1])|0)+B(u[e+8>>1],u[h+14>>1])|0)/32768|0;v[c>>2]=v[c>>2]+B(e,l);v[c+4>>2]=v[c+4>>2]+B(e,k);Rb(f+8|0,i,g);c=c+8|0;d=d-1|0;continue}break}b=v[f+12>>2];v[a>>2]=v[f+8>>2];v[a+4>>2]=b;kb=f+16|0}function $G(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;c=kb-32|0;kb=c;a:{if(w[a+52|0]){d=v[a+48>>2];if(!b){break a}t[a+52|0]=0;v[a+48>>2]=-1;break a}v[c+24>>2]=1;e=v[Pe(c+24|0,a+44|0)>>2];h=(e|0)>0?e:0;while(1){if((f|0)!=(h|0)){d=-1;g=ru(v[a+32>>2]);if((g|0)==-1){break a}t[(c+24|0)+f|0]=g;f=f+1|0;continue}break}b:{c:{if(w[a+53|0]){t[c+23|0]=w[c+24|0];break c}h=c+24|0;while(1){d:{d=v[a+40>>2];g=v[d>>2];j=v[d+4>>2];i=c+24|0;f=i+e|0;e:{switch(lH(v[a+36>>2],d,i,f,c+16|0,c+23|0,h,c+12|0)-1|0){case 0:break e;case 1:break b;case 2:break d;default:break c}}d=v[a+40>>2];v[d>>2]=g;v[d+4>>2]=j;if((e|0)==8){break b}d=ru(v[a+32>>2]);if((d|0)==-1){break b}t[f|0]=d;e=e+1|0;continue}break}t[c+23|0]=w[c+24|0]}f:{if(!b){while(1){if((e|0)<=0){break f}d=-1;e=e-1|0;if((Zr(Mf(t[e+(c+24|0)|0]),v[a+32>>2])|0)!=-1){continue}break a}}d=Mf(t[c+23|0]);v[a+48>>2]=d;break a}d=Mf(t[c+23|0]);break a}d=-1}kb=c+32|0;return d}function Cca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=kb-16|0;kb=e;n=v[a+16>>2];o=kg(b+327720|0,v[b+20>>2],(v[a+88>>2]&16384)>>>14|0);k=v[a+128>>2];a:{if(!k){i=v[a+8>>2];j=v[a+12>>2];g=v[a>>2];b=v[a+4>>2];h=0;break a}i=v[a+8>>2];j=v[a+12>>2];l=lg(i,j,k);m=nb;h=v[a+76>>2];g=v[a>>2];b=v[a+4>>2];Qf(g,b,qf(i,j,d),nb);h=h>>>0<nb>>>0?d:0}f=a+112|0;p=v[a+24>>2];q=v[a+20>>2];v[e>>2]=g;v[e+4>>2]=b;b:while(1){if(d){b=v[e+4>>2];v[e+8>>2]=v[e>>2];v[e+12>>2]=0;h=h-1|0;l=h?l:0;m=h?m:0;d=d-1|0;g=b+n|0;b=k;while(1)if((b|0)<=0){Rb(f,v[a+120>>2],v[a+124>>2]);b=v[a+116>>2];if(b){Sd(f,t[v[e+12>>2]+g|0]<<6);Rd(f,b);v[f>>2]=v[f>>2];v[f+4>>2]=0}g=v[c>>2];b=jg(f,o);v[c>>2]=g+B(b,q);v[c+4>>2]=v[c+4>>2]+B(b,p);Rb(e,i,j);c=c+8|0;continue b}else{Sd(f,t[v[e+12>>2]+g|0]<<6);Rd(f,4);Rb(e+8|0,l,m);b=b-1|0;continue}}break}b=v[e+4>>2];v[a>>2]=v[e>>2];v[a+4>>2]=b;kb=e+16|0}function Uu(a){var b=0,c=0,d=0,e=0;c=kb-16|0;kb=c;a:{if(w[a+3|0]!=19){break a}t[a+3|0]=20;b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{b=w[a+5|0];switch(b>>>4|0){case 4:break j;case 3:break k;case 2:break l;case 1:break m;case 0:break n;case 13:break b;case 12:break c;case 11:break d;case 10:break e;case 9:break f;case 7:break g;case 6:break h;case 5:break i;default:break a}}t[a+3|0]=0;break a}t[a+3|0]=2;t[a+5|0]=b|240;break a}t[a+3|0]=3;t[a+5|0]=b|240;break a}t[a+5|0]=b&15|16;break a}t[a+5|0]=b&3|48;break a}t[a+5|0]=b&15|32;break a}t[a+5|0]=b&15|176;break a}t[a+5|0]=b&3|64;break a}t[a+3|0]=15;t[a+5|0]=b&15;break a}if(b&15){t[a+3|0]=11;t[a+5|0]=b<<4|15;break a}t[a+3|0]=0;break a}b=b&15;if(b){t[a+3|0]=11;v[c+12>>2]=b;v[c+8>>2]=14;d=a,e=w[td(c+12|0,c+8|0)|0]|240,t[d+5|0]=e;break a}t[a+3|0]=0;break a}if((b|0)!=192){break a}t[a|0]=254;t[a+3|0]=0;break a}if((b|0)!=208){break a}t[a+3|0]=0}kb=c+16|0}function KF(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;b=0;a=c;while(1){a:{if(a>>>0>=d>>>0|b>>>0>=e>>>0){break a}g=1;f=t[a|0];b:{if((f|0)>=0){break b}if(f>>>0<4294967234){break a}if(f>>>0<=4294967263){if((d-a|0)<2){break a}g=2;if((w[a+1|0]&192)==128){break b}break a}g=f&255;c:{d:{if(f>>>0<=4294967279){if((d-a|0)<3){break a}h=w[a+2|0];f=w[a+1|0];if((g|0)==237){break d}if((g|0)==224){if((f&224)==160){break c}break a}if((f&192)!=128){break a}break c}if((d-a|0)<4|f>>>0>4294967284|e-b>>>0<2){break a}h=w[a+3|0];i=w[a+2|0];f=w[a+1|0];e:{f:{switch(g-240|0){case 0:if((f+112&255)>>>0<48){break e}break a;case 4:if((f&240)==128){break e}break a;default:break f}}if((f&192)!=128){break a}}if((i&192)!=128|(h&192)!=128|(g<<18&1835008|(f&48)<<12)>>>0>1114111){break a}b=b+1|0;g=4;break b}if((f&224)!=128){break a}}g=3;if((h&192)!=128){break a}}b=b+1|0;a=a+g|0;continue}break}return a-c|0}function aH(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;c=kb-32|0;kb=c;a:{if(w[a+52|0]){d=v[a+48>>2];if(!b){break a}t[a+52|0]=0;v[a+48>>2]=-1;break a}v[c+24>>2]=1;e=v[Pe(c+24|0,a+44|0)>>2];h=(e|0)>0?e:0;while(1){if((f|0)!=(h|0)){d=-1;g=ru(v[a+32>>2]);if((g|0)==-1){break a}t[(c+24|0)+f|0]=g;f=f+1|0;continue}break}b:{c:{if(w[a+53|0]){v[c+20>>2]=t[c+24|0];break c}h=c+24|0;while(1){d:{d=v[a+40>>2];g=v[d>>2];j=v[d+4>>2];i=c+24|0;f=i+e|0;e:{switch(lH(v[a+36>>2],d,i,f,c+16|0,c+20|0,h,c+12|0)-1|0){case 0:break e;case 1:break b;case 2:break d;default:break c}}d=v[a+40>>2];v[d>>2]=g;v[d+4>>2]=j;if((e|0)==8){break b}d=ru(v[a+32>>2]);if((d|0)==-1){break b}t[f|0]=d;e=e+1|0;continue}break}v[c+20>>2]=t[c+24|0]}f:{if(!b){while(1){if((e|0)<=0){break f}d=-1;e=e-1|0;if((Zr(t[e+(c+24|0)|0],v[a+32>>2])|0)!=-1){continue}break a}}d=v[c+20>>2];v[a+48>>2]=d;break a}d=v[c+20>>2];break a}d=-1}kb=c+32|0;return d}function hda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;f=kb-16|0;kb=f;a:{b:{c:{g=v[a+12>>2];i=v[a+8>>2];d:{if((g|0)<=1&i>>>0<=805306368|(g|0)<=0){if((g|0)>=-2&i>>>0>=3489660928|(g|0)>-2){break c}if((g|0)==-2&i>>>0>2147483647|g>>>0>4294967294){break d}break b}if((g|0)==1&i>>>0>2147483648|g>>>0>1){break b}}b=b+196648|0;break a}b=b+131112|0;break a}b=b+262184|0}j=v[a+16>>2];k=v[a+24>>2];l=v[a+20>>2];e=v[a+4>>2];v[f+8>>2]=v[a>>2];v[f+12>>2]=e;while(1){if(d){e=v[f+12>>2]+j|0;h=(v[f+8>>2]>>>16&65520)+b|0;e=(((((((B(t[e-2|0],u[h+2>>1])+B(t[e-3|0],u[h>>1])|0)+B(t[e-1|0],u[h+4>>1])|0)+B(t[e|0],u[h+6>>1])|0)+B(t[e+1|0],u[h+8>>1])|0)+B(t[e+2|0],u[h+10>>1])|0)+B(t[e+3|0],u[h+12>>1])|0)+B(t[e+4|0],u[h+14>>1])<<8)/32768|0;v[c>>2]=v[c>>2]+B(e,l);v[c+4>>2]=v[c+4>>2]+B(e,k);Rb(f+8|0,i,g);c=c+8|0;d=d-1|0;continue}break}b=v[f+12>>2];v[a>>2]=v[f+8>>2];v[a+4>>2]=b;kb=f+16|0}function Uga(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=kb-16|0;kb=e;u[e+12>>1]=0;v[e+8>>2]=0;j=8;n=B(c,d)<<1;while(1){if((d|0)!=(l|0)){h=(l<<1)+b|0;o=n+h|0;while(1){if(h>>>0<o>>>0){u[e+6>>1]=0;pS(a,e+15|0,e+12|0,j,e+6|0);g=x[e+6>>1];c=j;while(1){a:{if(!(c&255)){break a}f=x[e+12>>1]<<1;i=f&254;u[e+12>>1]=i;if(i){f=(f&65534)>>>0>255}else{if(!nf(a,e+5|0)){break a}f=w[e+5|0];u[e+12>>1]=f<<1&254|1;f=f>>>7|0}c=c-1|0;g=f|g<<1;continue}break}c=1;i=g&65535;b:{if(i>>>0<4){break b}f=15;while(1){c=f;m=f&255;if(i>>>m&1){break b}f=c-1|0;if(m>>>0>1){continue}break}}f=g&1;t[e+15|0]=f;g=f-1^(g&65534)>>>1;f=g+x[e+8>>1]|0;u[e+6>>1]=f;u[h>>1]=f;v[e+8>>2]=((g>>1)-(k<<16>>16)|0)+(f<<16>>16<<1);h=(d<<1)+h|0;j=(c+j&254)>>>1|0;c=-32768;k=v[e+8>>2];c:{if((k|0)>=-32768){c=32767;if((k|0)<32768){break c}}v[e+8>>2]=c}k=f;continue}break}l=l+1|0;continue}break}kb=e+16|0}function ts(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;c=kb+-64|0;kb=c;b=v[a>>2];a=v[b>>2];d=v[a+4>>2];v[c+40>>2]=v[a+20>>2];e=v[a+16>>2];v[c+32>>2]=v[a+12>>2];v[c+36>>2]=e;Hf(c+48|0,c+32|0,d);a=v[b+4>>2];d=v[a+8>>2];e=v[a+4>>2];b=v[c+60>>2];v[c+24>>2]=v[c+56>>2];v[c+28>>2]=b;b=v[c+52>>2];v[c+16>>2]=v[c+48>>2];v[c+20>>2]=b;v[c+8>>2]=v[a+8>>2];b=v[a+4>>2];v[c>>2]=v[a>>2];v[c+4>>2]=b;a:{b:{c:{d:{f=v[c+4>>2];if(f>>>0>=e>>>0){g=v[c+20>>2];if(g>>>0<e>>>0){break d}if(d>>>0>y[c+8>>2]){break c}h=v[c+28>>2];if(d>>>0>v[c+24>>2]-h>>>0){break b}i=v[c+16>>2];j=v[c>>2];b=0;e:while(1){if((b|0)==(d|0)){break a}k=B(b,f);l=B(b+h|0,g);a=0;while(1)if((a|0)==(e|0)){b=b+1|0;continue e}else{z[(a+l<<2)+i>>2]=C(v[(a+k<<2)+j>>2])*C(7.450580596923828e-9);a=a+1|0;continue}}}aa(7192,9074,33,8787);L()}aa(7157,9074,34,8787);L()}aa(5900,9074,35,8787);L()}aa(5870,9074,36,8787);L()}kb=c- -64|0}function pfa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;g=kb-144|0;kb=g;Fo(a);a:{b:{if(!fg(a,64)){break b}c:{d:{if(!vl(a,60)){break d}if(!_Q(a,14163)){break d}c=15;d=450;break c}Fo(a);if(!fg(a,128)){break b}b=0;if(!vl(a,124)){break a}if(!_Q(a,15426)){break a}c=31;d=930}Fo(a);b=0;e:{while(1){if((b&65535)>>>0>=c>>>0){break e}b=b+1|0;if(YQ(a)>>>0<=131072){continue}break}b=0;break a}id(a,4);if(!fg(a,2)){break b}b=0;e=kb-16|0;kb=e;c=kb-16|0;kb=c;Ym(c+8|0,e+8|0);f=v[c+12>>2];md(c,a,v[c+8>>2],v[c+12>>2]);h=v[c+4>>2];if((f|0)==(h|0)){id(a,v[c+12>>2])}kb=c+16|0;if((f|0)==(h|0)){i=Ib(x[e+8>>1])}kb=e+16|0;if(i>>>0<178){break a}b=-1;if(!fg(a,d)){break a}id(a,d);d=kb-16|0;kb=d;e=g+8|0;_R(d+8|0,e);c=v[d+12>>2];md(d,a,v[d+8>>2],v[d+12>>2]);f=v[d+4>>2];if((f|0)==(c|0)){id(a,v[d+12>>2])}kb=d+16|0;a=(c|0)==(f|0);if(!a){hA(e)}if(!a){break a}b=ZQ(w[g+8|0]);break a}b=-1}kb=g+144|0;return b|0}function NF(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;a=c;while(1){a:{if(e>>>0<=i>>>0|a>>>0>=d>>>0){break a}f=1;b=t[a|0];b:{if((b|0)>=0){break b}if(b>>>0<4294967234){break a}if(b>>>0<=4294967263){if((d-a|0)<2){break a}f=2;if((w[a+1|0]&192)==128){break b}break a}g=b&255;c:{d:{if(b>>>0<=4294967279){if((d-a|0)<3){break a}h=w[a+2|0];b=w[a+1|0];if((g|0)==237){break d}if((g|0)==224){if((b&224)==160){break c}break a}if((b&192)!=128){break a}break c}if((d-a|0)<4|b>>>0>4294967284){break a}f=w[a+3|0];h=w[a+2|0];b=w[a+1|0];e:{f:{switch(g-240|0){case 0:if((b+112&255)>>>0<48){break e}break a;case 4:if((b&240)==128){break e}break a;default:break f}}if((b&192)!=128){break a}}if((h&192)!=128|(f&192)!=128){break a}f=4;if((g<<18&1835008|(b&48)<<12)>>>0>1114111){break a}break b}if((b&224)!=128){break a}}f=3;if((h&192)!=128){break a}}i=i+1|0;a=a+f|0;continue}break}return a-c|0}function Ou(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;f=kb-560|0;kb=f;u[f+558>>1]=b;a:{if((b-256&65535)>>>0<65281){break a}e=((b<<2)+a|0)+900380|0;b=v[e>>2];b:{if(b){c=vP(f,c);d=v[c+4>>2];v[b>>2]=v[c>>2];v[b+4>>2]=d;d=w[c+11|0]|w[c+12|0]<<8|(w[c+13|0]<<16|w[c+14|0]<<24);e=w[c+7|0]|w[c+8|0]<<8|(w[c+9|0]<<16|w[c+10|0]<<24);t[b+7|0]=e;t[b+8|0]=e>>>8;t[b+9|0]=e>>>16;t[b+10|0]=e>>>24;t[b+11|0]=d;t[b+12|0]=d>>>8;t[b+13|0]=d>>>16;t[b+14|0]=d>>>24;t[b+15|0]=w[c+15|0];d=v[c+44>>2];v[b+40>>2]=v[c+40>>2];v[b+44>>2]=d;d=v[c+36>>2];v[b+32>>2]=v[c+32>>2];v[b+36>>2]=d;d=v[c+28>>2];v[b+24>>2]=v[c+24>>2];v[b+28>>2]=d;d=v[c+20>>2];v[b+16>>2]=v[c+16>>2];v[b+20>>2]=d;ty(b+48|0,c+48|0);ty(b+68|0,c+68|0);ty(b+88|0,c+88|0);sc(b+108|0,c+108|0,448);d=b;bu(c);break b}b=Zs(556);if(!b){v[e>>2]=0;break a}d=vP(b,c);v[e>>2]=d}g=a,h=x[ke(a+480192|0,f+558|0)>>1],u[g+480192>>1]=h}kb=f+560|0;return d|0}function RW(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;j=kb-32|0;kb=j;d=bn(j+8|0,a);c=kb-48|0;kb=c;k=-1;a:{if(!oD(d,c+8|0)){break a}k=0;if(!tD(c+8|0)){break a}n=v[d+12>>2];b:{if(!vl(d,w[c+24|0]|w[c+25|0]<<8|(w[c+26|0]<<16|w[c+27|0]<<24))){break b}while(1){c:{if((w[c+20|0]|w[c+21|0]<<8|(w[c+22|0]<<16|w[c+23|0]<<24))>>>0>m>>>0){if(fg(d,5)){break c}}g=l&1;break b}g=0;h=1;d:{if((w[c+12|0]|w[c+13|0]<<8)>>>0>=64){f=Pq(d);a=f&63;e:{if(!(f&64)){break e}e=6;while(1){i=Pq(d);a=(i&127)<<e|a;if(!(i&128)){break e}i=e>>>0<25;e=e+7|0;if(i){continue}break}}e=f>>>7|0;f=e?-2147483648:a;if(((e?(a|0)>=0?0-a|0:f:f)|0)<=0){break d}}while(1){e=Pq(d);if(e){f=g>>>0>4;a=f&h;if(!((h^1)&1|f)){a=(Tp(e<<24>>24)&255)==w[g+13086|0]}h=a;g=g+1|0;continue}break}id(d,4);l=(g|0)==5?h&1?1:l:l}m=m+1|0;continue}}vl(d,n);if(!g){break a}k=Ae(d,b,sD(c+8|0),0)}kb=c+48|0;kb=j+32|0;return k|0}function us(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=kb+-64|0;kb=c;b=v[a>>2];a=v[b>>2];d=v[a+4>>2];v[c+40>>2]=v[a+20>>2];e=v[a+16>>2];v[c+32>>2]=v[a+12>>2];v[c+36>>2]=e;Hf(c+48|0,c+32|0,d);a=v[b+4>>2];d=v[a+8>>2];e=v[a+4>>2];b=v[c+60>>2];v[c+24>>2]=v[c+56>>2];v[c+28>>2]=b;b=v[c+52>>2];v[c+16>>2]=v[c+48>>2];v[c+20>>2]=b;v[c+8>>2]=v[a+8>>2];b=v[a+4>>2];v[c>>2]=v[a>>2];v[c+4>>2]=b;a:{b:{c:{d:{f=v[c+4>>2];if(f>>>0>=e>>>0){if(y[c+20>>2]<e>>>0){break d}if(d>>>0>y[c+8>>2]){break c}g=v[c+28>>2];if(d>>>0>v[c+24>>2]-g>>>0){break b}h=v[c+16>>2];i=v[c>>2];b=0;e:while(1){if((b|0)==(d|0)){break a}j=b+g|0;k=B(b,f);a=0;while(1)if((a|0)==(e|0)){b=b+1|0;continue e}else{z[v[(a<<2)+h>>2]+(j<<2)>>2]=C(v[(a+k<<2)+i>>2])*C(7.450580596923828e-9);a=a+1|0;continue}}}aa(7192,9074,33,8787);L()}aa(7157,9074,34,8787);L()}aa(5900,9074,35,8787);L()}aa(5870,9074,36,8787);L()}kb=c- -64|0}function Hea(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;g=kb-16|0;kb=g;d=v[b>>2];e=mk(d,v[b+4>>2]);a:{if(e>>>0<c>>>0){i=kb-32|0;kb=i;f=c-e|0;e=v[Gb(b)>>2];d=v[b+4>>2];b:{if(f>>>0<=e-d>>4>>>0){h=kb-16|0;kb=h;d=Dt(h,b,f);e=v[d+4>>2];f=v[d+8>>2];while(1){if((e|0)==(f|0)){lc(d);kb=h+16|0}else{Cu(e);e=e+16|0;v[d+4>>2]=e;continue}break}break b}e=Gb(b);e=fQ(i+8|0,gQ(b,mk(v[b>>2],d)+f|0),mk(v[b>>2],v[b+4>>2]),e);d=kb-16|0;kb=d;v[d>>2]=v[e+8>>2];h=v[e+8>>2];v[d+8>>2]=e+8;v[d+4>>2]=h+(f<<4);f=v[d>>2];while(1){if(v[d+4>>2]!=(f|0)){Cu(f);f=v[d>>2]+16|0;v[d>>2]=f;continue}break}Ud(d);kb=d+16|0;Fd(b,e);d=v[e+4>>2];f=v[e+8>>2];while(1){if((d|0)!=(f|0)){f=f-16|0;v[e+8>>2]=f;continue}break}d=v[e>>2];if(d){bp(e);Mb(d)}}kb=i+32|0;break a}if(c>>>0<e>>>0){Od(b,d+(c<<4)|0)}}if(Qb(v[a>>2],v[a+8>>2],c<<4)){c=v[b>>2];gc(g+8|0,c,mk(c,v[b+4>>2])<<4);ud(g,a,v[g+8>>2],v[g+12>>2])}kb=g+16|0}function Nba(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;l=kb-16|0;kb=l;d=v[fc(l+8|0,Fb(v[a+4>>2]))>>2];i=kb-32|0;kb=i;e=d;d=v[a>>2];h=(Ao(e,Fb(d))<<1)+d|0;g=gz(b,c);a:{if((g|0)<=0){break a}e=v[Gb(a)>>2];d=v[a+4>>2];if((g|0)<=e-d>>1){f=d-h|0;j=f>>1;b:{if((j|0)>=(g|0)){e=c;break b}v[i+8>>2]=b;v[i+8>>2]=v[i+8>>2]+(j<<1);e=v[i+8>>2];fP(a,e,c,g-j|0);if((f|0)<=0){break a}}m=kb-16|0;kb=m;j=v[a+4>>2];f=(j-((g<<1)+h|0)|0)+h|0;g=ai(m,a,d-f>>1);k=v[g+4>>2];c=f;while(1){if(c>>>0>=d>>>0){lc(g);Dq(h,f,j);kb=m+16|0}else{Mi(k,x[c>>1]);k=k+2|0;v[g+4>>2]=k;c=c+2|0;continue}break}ao(b,e,h);break a}f=Gb(a);f=Nj(i+8|0,Oj(a,Rc(v[a>>2],d)+g|0),h-v[a>>2]>>1,f);d=kb-16|0;kb=d;e=Qo(d,f+8|0,gz(b,c));c=v[e>>2];while(1){if(v[e+4>>2]!=(c|0)){Mi(c,x[b>>1]);c=v[e>>2]+2|0;v[e>>2]=c;b=b+2|0;continue}break}Ud(e);kb=d+16|0;h=kP(a,f,h);Ni(f)}Fb(h);kb=i+32|0;kb=l+16|0;return a|0}function ica(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=kb-16|0;kb=e;v[e+12>>2]=1;a:{if(mo(a)){c=v[a>>2];j=rg(c,v[a+4>>2]);v[e+8>>2]=j;k=v[Kb(e+12|0,e+8|0)>>2];while(1){if(k){k=k-1|0;if((b|0)!=(c|0)){f=Fb(v[b>>2]);g=Fb(v[b+4>>2]);d=kb-16|0;kb=d;h=KB(f,g);b:{if(h>>>0<=Zm(c)>>>0){v[d+8>>2]=g;l=v[c>>2];i=Rc(l,v[c+4>>2]);m=i>>>0>=h>>>0;if(m){i=g}else{v[d+8>>2]=f;mP(d+8|0,i);i=v[d+8>>2]}f=Oi(f,i,l);if(!m){oP(c,v[d+8>>2],g,h-Rc(v[c>>2],v[c+4>>2])|0);break b}Od(c,f);break b}nP(c);lq(c,Oj(c,h));oP(c,f,g,h)}kb=d+16|0;$o(c+12|0,b+12|0);u[c+28>>1]=x[b+28>>1]}c=c+32|0;continue}break}if(!j){Az(a,1-j|0,b);break a}gP(a,v[a>>2]+32|0);break a}if(v[a>>2]){iP(a);c=v[a>>2];mo(a);Mb(c);n=Gb(a),o=0,v[n>>2]=o;v[a>>2]=0;v[a+4>>2]=0}c=gq(a,1);if(th(134217727)>>>0<c>>>0){cd();L()}d=aQ(c);v[a>>2]=d;v[a+4>>2]=d;n=Gb(a),o=d+(c<<5)|0,v[n>>2]=o;Az(a,1,b)}kb=e+16|0}function rF(a,b,c,d){var e=0,f=0,g=0,h=0,i=0;g=kb-32|0;kb=g;f=d&2147483647;e=f-1065418752|0;h=f-1082064896|0;a:{if((e|0)==(h|0)&0|e>>>0<h>>>0){f=(d&33554431)<<7|c>>>25;e=0;i=e;h=c&33554431;if(!(!e&(h|0)==16777216?!(a|b):!e&h>>>0<16777216)){e=f+1073741825|0;break a}e=f+1073741824|0;if(h^16777216|a|(b|i)){break a}e=(f&1)+e|0;break a}if(!(!c&(f|0)==2147418112?!(a|b):f>>>0<2147418112)){e=((d&33554431)<<7|c>>>25)&4194303|2143289344;break a}e=2139095040;if(f>>>0>1082064895){break a}e=0;f=f>>>16|0;if(f>>>0<16145){break a}e=d&65535|65536;Kf(g+16|0,a,b,c,e,f-16129|0);Em(g,a,b,c,e,16257-f|0);b=v[g+8>>2];e=(v[g+12>>2]&33554431)<<7|b>>>25;h=v[g>>2]|(v[g+16>>2]|v[g+24>>2]|(v[g+20>>2]|v[g+28>>2]))!=0;f=v[g+4>>2];a=0;b=b&33554431;if(!(!a&(b|0)==16777216?!(h|f):!a&b>>>0<16777216)){e=e+1|0;break a}if(b^16777216|h|(a|f)){break a}e=(e&1)+e|0}kb=g+32|0;return l(2,d&-2147483648|e),q()}function $l(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=kb-16|0;kb=d;v[a+4>>2]=0;if(Qd(w[fm(d+8|0,a,1)|0])){a:{b:{c:{if((b|0)==2147483647){while(1){b=v[(v[v[a>>2]-12>>2]+a|0)+24>>2];v[23540]=0;b=S(104,b|0)|0;c=v[23540];v[23540]=0;d:{if((c|0)!=1){if(!pc(b,-1)){break d}break b}break c}v[a+4>>2]=v[a+4>>2]+1;continue}}if(v[a+4>>2]>=(b|0)){break a}e:{while(1){c=v[(v[v[a>>2]-12>>2]+a|0)+24>>2];v[23540]=0;c=S(104,c|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break e}if(pc(c,-1)){break b}c=v[a+4>>2]+1|0;v[a+4>>2]=c;if((b|0)>(c|0)){continue}break}c=0;break a}}b=V(0)|0;O()|0;_(b|0)|0;c=1;dm(v[v[a>>2]-12>>2]+a|0,1);f:{g:{if(v[(v[v[a>>2]-12>>2]+a|0)+20>>2]&1){v[23540]=0;Z(105);a=v[23540];v[23540]=0;if((a|0)!=1){break f}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)==1){break g}T(a|0);L()}$();break a}V(0)|0;O()|0;Vb()}L()}c=2}Ki(v[v[a>>2]-12>>2]+a|0,c)}kb=d+16|0;return a|0}function Z9(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;e=v[a>>2];d=yk(e,v[a+4>>2]);if(d>>>0<b>>>0){h=kb-32|0;kb=h;a:{b:{e=b-d|0;b=v[Gb(a)>>2];f=v[a+4>>2];c:{if(e>>>0<=(b-f|0)/52>>>0){_x(a,e,c);break c}d=Gb(a);f=UL(a,yk(v[a>>2],f)+e|0);g=yk(v[a>>2],v[a+4>>2]);b=h+8|0;pg(b+12|0,d);if(f){d=TL(f)}else{d=0}v[b>>2]=d;g=d+B(g,52)|0;v[b+8>>2]=g;v[b+4>>2]=g;i=Cc(b),j=d+B(f,52)|0,v[i>>2]=j;v[23540]=0;U(879,b|0,e|0,c|0);c=v[23540];v[23540]=0;if((c|0)==1){break b}f=v[a>>2];c=v[a+4>>2];e=b+4|0;while(1){if((c|0)!=(f|0)){c=c-52|0;d=ul(v[e>>2]-52|0,c);v[d+20>>2]=v[c+20>>2];g=v[c+16>>2];v[d+12>>2]=v[c+12>>2];v[d+16>>2]=g;BQ(d+24|0,c+24|0);ad(d+36|0,c+36|0);v[d+48>>2]=v[c+48>>2];v[e>>2]=v[e>>2]-52;continue}break}qc(a,e);qc(a+4|0,b+8|0);qc(Gb(a),Cc(b));v[b>>2]=v[b+4>>2];SL(b)}kb=h+32|0;break a}a=P()|0;O()|0;SL(b);T(a|0);L()}return}if(b>>>0<d>>>0){VL(a,e+B(b,52)|0)}}function Rga(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=kb-16|0;kb=e;u[e+12>>1]=0;v[e+8>>2]=0;n=B(c,d);k=4;a:while(1){if((d|0)!=(l|0)){i=b+l|0;o=n+i|0;while(1){b:{c:{if(i>>>0<o>>>0){t[e+7|0]=0;oS(a,e+15|0,e+12|0,e+7|0);g=w[e+7|0];f=x[e+12>>1];c=k;while(1){if(c&255){h=f<<1;f=h&254;d:{if(f){h=(h&65534)>>>0>255;break d}if(!nf(a,e+6|0)){break c}f=w[e+6|0];h=f>>>7|0;f=f<<1&254|1}c=c-1|0;g=g<<1|h;continue}break}u[e+12>>1]=f;break b}l=l+1|0;continue a}u[e+12>>1]=0}c=1;h=g&255;e:{if(h>>>0<4){break e}f=7;while(1){c=f;m=f&255;if(h>>>m&1){break e}f=c-1|0;if(m>>>0>1){continue}break}}f=g&1;t[e+15|0]=f;g=f-1^(g&254)>>>1;f=g+w[e+8|0]|0;t[e+7|0]=f;t[i|0]=f;v[e+8>>2]=((g>>1)-(j<<24>>24)|0)+(f<<24>>24<<1);i=d+i|0;k=(c+k&254)>>>1|0;c=-128;j=v[e+8>>2];f:{if((j|0)>=-128){c=127;if((j|0)<128){break f}}v[e+8>>2]=c}j=f;continue}}break}kb=e+16|0}function Qca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0;e=kb-16|0;kb=e;g=v[a+24>>2];h=v[a+20>>2];i=v[a+16>>2];f=v[a+4>>2];v[e+8>>2]=v[a>>2];v[e+12>>2]=f;j=b+24|0;k=v[a+8>>2];l=v[a+12>>2];while(1){if(d){f=v[e+8>>2];m=((((v[e+12>>2]&2147483647)<<1|f>>>31)&2147483646)<<1)+i|0;b=(((f>>>16|0)+4&131064)<<1)+j|0;n=u[b+14>>1];o=u[b+12>>1];p=u[b+10>>1];q=u[b+8>>1];r=u[b+6>>1];s=u[b+4>>1];t=u[b+2>>1];w=u[b>>1];f=0;while(1){if((f|0)!=2){b=(f<<1)+m|0;v[(f<<2)+e>>2]=(((((B(u[b+8>>1],p)+B(u[b+4>>1],q)|0)+B(u[b+12>>1],o)|0)+B(u[b+16>>1],n)|0)/2|0)+((((B(u[b-8>>1],t)+B(u[b-12>>1],w)|0)+B(u[b-4>>1],s)|0)+B(u[b>>1],r)|0)/2|0)|0)/16384;f=f+1|0;continue}break}v[c>>2]=v[c>>2]+B(v[e>>2],h);v[c+4>>2]=v[c+4>>2]+B(v[e+4>>2],g);Rb(e+8|0,k,l);c=c+8|0;d=d-1|0;continue}break}b=v[e+12>>2];v[a>>2]=v[e+8>>2];v[a+4>>2]=b;kb=e+16|0}function GN(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;a:{g=b;c=kb-16|0;kb=c;d=Nb(a);while(1){b:{c:{d:{if(Hb(g)>>>0>f>>>0){b=v[qj(g,f)>>2];if(b>>>0>=2097152){v[23540]=0;R(51,d|0,63);a=v[23540];v[23540]=0;if((a|0)!=1){break c}break b}a=0;while(1){if((a|0)==6){b=7;a=6;break d}e=b&63;t[(c+10|0)+a|0]=e;if(b>>>0>=64){a=a+1|0;b=b>>>6|0;continue}break}if(a){b=a+1|0;if((b|0)!=2){break d}a=1;b=2;if((e|0)!=1){break d}a=w[c+10|0]|64}else{a=w[c+10|0]}v[23540]=0;R(51,d|0,a&255);a=v[23540];v[23540]=0;if((a|0)!=1){break c}break b}kb=c+16|0;break a}i=(-1<<b^-1)<<7-a;e=b-1|0;j=e+(c+10|0)|0;a=b;while(1){if(!a){break c}e:{if((a|0)==(b|0)){a=w[j|0];v[23540]=0;R(51,d|0,a|i&255);h=v[23540];v[23540]=0;a=e;break e}v[23540]=0;a=a-1|0;R(51,d|0,w[a+(c+10|0)|0]|128);h=v[23540];v[23540]=0}if((h|0)!=1){continue}break}break b}f=f+1|0;continue}break}a=P()|0;O()|0;Ab(d);T(a|0);L()}}function o7(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=C(0),m=0,n=0,o=C(0),p=C(0),q=C(0),r=C(0),s=C(0),t=C(0),u=C(0),w=C(0),x=C(0);h=kb-16|0;kb=h;if(bi(a+44|0)){f=v[a+44>>2];g=Jc(f,0);v[h+8>>2]=g;f=Jc(f,1);v[h+12>>2]=f;j=v[a+56>>2];m=Jc(j,0);v[h>>2]=m;j=Jc(j,1);v[h+4>>2]=j;a:{if(z[Eb(a+4208|0,2)>>2]!=C(.5)){f=d;b:while(1){g=0;if(!f){break a}while(1)if((g|0)==2){f=f-1|0;continue b}else{k=g<<2;e=k+(h+8|0)|0;i=v[e>>2];v[e>>2]=i+4;e=a+k|0;n=e+4248|0;q=z[n>>2];l=z[i>>2];r=z[a+4236>>2];s=z[a+4232>>2];t=z[a+4228>>2];u=z[a+4220>>2];w=z[a+4224>>2];i=e+4240|0;o=z[i>>2];z[n>>2]=o;z[i>>2]=l;i=e+4264|0;x=z[i>>2];e=e+4256|0;p=z[e>>2];z[i>>2]=p;l=C(C(C(C(t*q)+C(C(u*l)+C(w*o)))-C(s*p))-C(r*x));z[e>>2]=l;k=h+k|0;e=v[k>>2];v[k>>2]=e+4;z[e>>2]=l;g=g+1|0;continue}}}e=g;g=d<<2;sc(m,e,g);sc(j,f,g);f=v[a+56>>2];m=Jc(f,0);j=Jc(f,1)}ti(a,b,c,m,j,d)}kb=h+16|0}function ffa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=v[a>>2];c=yd(d,v[a+4>>2]);if(c>>>0<b>>>0){f=kb-32|0;kb=f;c=b-c|0;b=v[Gb(a)>>2];d=v[a+4>>2];a:{if(c>>>0<=(b-d|0)/12>>>0){d=kb-16|0;kb=d;b=Ot(d,a,c);a=v[b+4>>2];c=v[b+8>>2];while(1){if((a|0)==(c|0)){lc(b);kb=d+16|0}else{DQ(a);a=a+12|0;v[b+4>>2]=a;continue}break}break a}b=Gb(a);b=Ik(f+8|0,ln(a,yd(v[a>>2],d)+c|0),yd(v[a>>2],v[a+4>>2]),b);e=kb-16|0;kb=e;d=CQ(e,b+8|0,c);c=v[d>>2];while(1){if(v[d+4>>2]!=(c|0)){DQ(c);c=v[d>>2]+12|0;v[d>>2]=c;continue}break}Ud(d);kb=e+16|0;e=v[a>>2];c=v[a+4>>2];d=b+4|0;while(1){if((c|0)!=(e|0)){c=c-12|0;BQ(v[d>>2]-12|0,c);v[d>>2]=v[d>>2]-12;continue}break}qc(a,d);qc(a+4|0,b+8|0);qc(Gb(a),Cc(b));v[b>>2]=v[b+4>>2];a=v[b+4>>2];while(1){c=v[b+8>>2];if((c|0)!=(a|0)){c=c-12|0;v[b+8>>2]=c;EQ(c);continue}break}a=v[b>>2];if(a){bp(b);Mb(a)}}kb=f+32|0;return}if(b>>>0<c>>>0){FQ(a,d+B(b,12)|0)}}function qba(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0;f=kb-16|0;kb=f;b=v[a+4>>2];if(Qd(w[b+223884|0])){dO(b+223860|0);b=v[a+4>>2]}v[a+24>>2]=0;v[a+28>>2]=0;v[b>>2]=0;c=v[a>>2];v[b+40>>2]=v[c+480196>>2];v[b+44>>2]=v[c+480204>>2];v[b+80>>2]=v[c+480200>>2];c=x[c+480188>>1];v[f+8>>2]=0;v[f+12>>2]=0;d=f+8|0;u[d+4>>1]=65280;v[d>>2]=0;e=kb-16|0;kb=e;v[e+12>>2]=c;b=a+8|0;a:{if(jn(b)>>>0>=c>>>0){g=v[b>>2];h=Ug(g,v[b+4>>2]);v[e+8>>2]=h;i=v[Kb(e+12|0,e+8|0)>>2];while(1){if(i){v[g>>2]=v[d>>2];u[g+4>>1]=x[d+4>>1];i=i-1|0;g=g+8|0;continue}break}if(c>>>0>h>>>0){nN(b,c-h|0,d);break a}Od(b,v[b>>2]+(c<<3)|0);break a}wO(b);nz(b,or(b,c));nN(b,c,d)}kb=e+16|0;b=0;while(1){c=v[a>>2];if(x[c+480188>>1]<=b>>>0){kb=f+16|0}else{d=B(b,872);go((d+v[a+4>>2]|0)+616|0,c,b&65535,134217728);c=d+v[a+4>>2]|0;u[c+1432>>1]=0;t[c+1418|0]=0;t[c+1415|0]=0;t[c+1413|0]=0;b=b+1|0;continue}break}}function tw(a,b,c,d,e,f,g,h,i,j,k,l){a:{b:{if((a|0)==(f|0)){if(!w[b|0]){break a}f=0;t[b|0]=0;a=v[e>>2];v[e>>2]=a+1;t[a|0]=46;if(!Hb(h)){break b}a=v[j>>2];if((a-i|0)>159){break b}b=v[k>>2];v[j>>2]=a+4;v[a>>2]=b;return 0}c:{if((a|0)!=(g|0)){break c}if(!Hb(h)){break c}if(!w[b|0]){break a}f=0;a=v[j>>2];if((a-i|0)>159){break b}b=v[k>>2];v[j>>2]=a+4;v[a>>2]=b;v[k>>2]=0;return 0}f=-1;a=vw(l,l+128|0,a)-l|0;if((a|0)>124){break b}g=w[(a>>2)+83808|0];d:{e:{f=a&-5;if((f|0)!=88){if((f|0)!=96){break e}a=v[e>>2];if((a|0)!=(d|0)){f=-1;if((w[a-1|0]&95)!=(w[c|0]&127)){break b}}v[e>>2]=a+1;t[a|0]=g;return 0}t[c|0]=80;break d}d=g&95;if((d|0)!=w[c|0]){break d}t[c|0]=d|128;if(!w[b|0]){break d}t[b|0]=0;if(!Hb(h)){break d}b=v[j>>2];if((b-i|0)>159){break d}c=v[k>>2];v[j>>2]=b+4;v[b>>2]=c}b=v[e>>2];v[e>>2]=b+1;t[b|0]=g;f=0;if((a|0)>84){break b}v[k>>2]=v[k>>2]+1}return f}return-1}function g3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;c=kb+-64|0;kb=c;b=v[a>>2];a=v[b>>2];d=v[a+4>>2];v[c+40>>2]=v[a+20>>2];e=v[a+16>>2];v[c+32>>2]=v[a+12>>2];v[c+36>>2]=e;Hf(c+48|0,c+32|0,d);a=v[b+4>>2];d=v[a+8>>2];e=v[a+4>>2];b=v[c+60>>2];v[c+24>>2]=v[c+56>>2];v[c+28>>2]=b;b=v[c+52>>2];v[c+16>>2]=v[c+48>>2];v[c+20>>2]=b;v[c+8>>2]=v[a+8>>2];b=v[a+4>>2];v[c>>2]=v[a>>2];v[c+4>>2]=b;a:{b:{c:{d:{f=v[c+4>>2];if(f>>>0>=e>>>0){g=v[c+20>>2];if(g>>>0<e>>>0){break d}if(d>>>0>y[c+8>>2]){break c}h=v[c+28>>2];if(d>>>0>v[c+24>>2]-h>>>0){break b}i=v[c+16>>2];j=v[c>>2];b=0;e:while(1){if((b|0)==(d|0)){break a}k=B(b,f);l=B(b+h|0,g);a=0;while(1)if((a|0)==(e|0)){b=b+1|0;continue e}else{z[(a+l<<2)+i>>2]=A[(a+k<<3)+j>>3];a=a+1|0;continue}}}aa(7192,9074,77,8754);L()}aa(7157,9074,78,8754);L()}aa(5900,9074,79,8754);L()}aa(5870,9074,80,8754);L()}kb=c- -64|0}function mA(a,b,c,d,e){var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;i=kb-32|0;kb=i;aS(a,b);h=kb-16|0;kb=h;nd(c,1);g=Ib(w[b+22|0]|w[b+23|0]<<8)<<1;v[c>>2]=g;t[c+37|0]=w[b+24|0]<<4;t[h+15|0]=w[b+25|0];t[h+14|0]=64;l=c,m=w[Yb(h+15|0,h+14|0)|0]<<2,u[l+30>>1]=m;f=Ib(w[b+26|0]|w[b+27|0]<<8);a=f<<1;k=Ib(w[b+28|0]|w[b+29|0]<<8);j=k<<1;a=k>>>0>=2?a+j>>>0<=g>>>0?a:f+j>>>0>g>>>0?a:f:a;a:{b:{switch(g|0){case 2:v[c>>2]=0;break a;case 0:break a;default:break b}}v[c+4>>2]=a;f=a+j|0;v[c+8>>2]=f;if(a>>>0>=g>>>0){a=g-1|0;v[c+4>>2]=a}if(!(!(f>>>0<4|a>>>0>f>>>0)&f-a>>>0>3)){v[c+4>>2]=0;v[c+8>>2]=0;f=0;a=0}if(!(f>>>0>8|a|(!e|f>>>0>=g>>>0))){v[c+8>>2]=0;break a}if(a>>>0>=f>>>0){break a}u[c+34>>1]=x[c+34>>1]|2}kb=h+16|0;Fl(i,3,b);a=i+16|0;Fc(a,i);c=Dc(d,a);zb(a);a=0;while(1){if((a|0)!=32){d=a+c|0;if((w[d|0]-1&255)>>>0<=30){t[d|0]=32}a=a+1|0;continue}break}a=pA(b);kb=i+32|0;return a}function CP(a){var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0;g=kb-16|0;kb=g;b=v[a>>2];fc(g+8|0,b);a:{b:{c:{d:{e:{if(zd(v[b+16>>2])){while(1){if(c>>>0>31){break e}v[23540]=0;d=ga(43)|0;e=v[23540];v[23540]=0;if((e|0)!=1){f=d|f;c=c+32|0;continue}break}c=V(93340)|0;if((O()|0)!=(ea(93340)|0)){break c}_(c|0)|0;t[b+20|0]=0;v[23540]=0;Y(31,b|0);c=v[23540];v[23540]=0;if((c|0)==1){break d}$();break e}t[b+20|0]=0}if(!w[b+20|0]){d=v[b+24>>2];b=0;c=1;while(1){if(c){c=0;b=v[d+2496>>2];e=d+(b<<2)|0;i=v[d+((b+397>>>0)%624<<2)>>2];h=(b+1>>>0)%624|0;b=v[d+(h<<2)>>2];b=i^(b&2147483647|v[e>>2]&-2147483648)>>>1^B(b&1,-1727483681);v[e>>2]=b;v[d+2496>>2]=h;b=b^b>>>11;b=b<<7&-1658038656^b;b=b<<15&-272236544^b;b=b>>>18^b;continue}break}f=b^f}kb=g+16|0;break a}c=P()|0;O()|0;v[23540]=0;Z(18);a=v[23540];v[23540]=0;if((a|0)==1){break b}}T(c|0);L()}V(0)|0;O()|0;Vb();L()}return v[a+28>>2]&f}function $E(a,b,c,d,e,f,g,h){var i=0,j=0,k=C(0);i=kb-96|0;kb=i;ry(v[a+24>>2]);t[v[a+24>>2]+1298420|0]=v[a+52>>2]!=0;v[i+92>>2]=f;v[i+88>>2]=e;v[i+84>>2]=d;v[i+80>>2]=c;a:{d=i+80|0;c=0;while(1){b:{if((c|0)!=4){if(v[(c<<2)+d>>2]){break b}}else{c=4}break a}c=c+1|0;continue}}v[i+40>>2]=b;v[i+36>>2]=c;v[i+32>>2]=d;e=v[a+32>>2];k=z[a+48>>2];v[i+8>>2]=b;c=v[i+36>>2];v[i>>2]=v[i+32>>2];v[i+4>>2]=c;d=kb-16|0;kb=d;v[d+8>>2]=v[i+8>>2];c=v[i+4>>2];v[d>>2]=v[i>>2];v[d+4>>2]=c;c=xJ(i+48|0);v[c+8>>2]=e;v[c+4>>2]=0;v[c>>2]=h;e=v[d+4>>2];v[c+12>>2]=v[d>>2];v[c+16>>2]=e;v[c+20>>2]=v[d+8>>2];z[c+24>>2]=k;v[c>>2]=g;kb=d+16|0;while(1){if(b){d=v[a+24>>2];v[i+24>>2]=b;v[i+28>>2]=0;v[i+16>>2]=134217727;v[i+20>>2]=0;d=zJ(d,v[_q(i+24|0,i+16|0)>>2],c);j=d+j|0;b=b-d|0;if(d){continue}}break}if(!(v[a+52>>2]!=1|j)){a=v[a+24>>2];v[a+480208>>2]=v[a+480208>>2]&-513}kb=i+96|0;return j}function QX(){var a=0,b=0,c=0,d=0;c=kb-32|0;kb=c;a:{a=Kc(c+16|0,14999);if(!Hb(a)){break a}b:{if((Dg(a,14669)|0)!=-1){b=Dg(a,14669);v[23540]=0;X(130,c|0,a|0,b+1|0,-1);b=v[23540];v[23540]=0;if((b|0)==1){break b}Bc(a,c);zb(c)}if((Dg(a,16833)|0)!=-1){b=Dg(a,16833);v[23540]=0;X(130,c|0,a|0,b+1|0,-1);b=v[23540];v[23540]=0;if((b|0)==1){break b}Bc(a,c);zb(c)}if((Dg(a,13882)|0)!=-1){b=Dg(a,13882);v[23540]=0;X(130,c|0,a|0,0,b|0);b=v[23540];v[23540]=0;if((b|0)==1){break b}Bc(a,c);zb(c)}if((Dg(a,13731)|0)!=-1){b=Dg(a,13731);v[23540]=0;X(130,c|0,a|0,0,b|0);b=v[23540];v[23540]=0;if((b|0)==1){break b}Bc(a,c);zb(c)}if((Dg(a,13774)|0)!=-1){b=Dg(a,13774);v[23540]=0;X(130,c|0,a|0,0,b|0);b=v[23540];v[23540]=0;if((b|0)==1){break b}Bc(a,c);zb(c)}v[23540]=0;b=S(131,a|0)|0;d=v[23540];v[23540]=0;if((d|0)!=1){break a}}c=P()|0;O()|0;zb(a);T(c|0);L()}zb(a);kb=c+32|0;return b|0}function p3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=kb+-64|0;kb=c;b=v[a>>2];a=v[b>>2];d=v[a+4>>2];v[c+40>>2]=v[a+20>>2];e=v[a+16>>2];v[c+32>>2]=v[a+12>>2];v[c+36>>2]=e;Hf(c+48|0,c+32|0,d);a=v[b+4>>2];d=v[a+8>>2];e=v[a+4>>2];b=v[c+60>>2];v[c+24>>2]=v[c+56>>2];v[c+28>>2]=b;b=v[c+52>>2];v[c+16>>2]=v[c+48>>2];v[c+20>>2]=b;v[c+8>>2]=v[a+8>>2];b=v[a+4>>2];v[c>>2]=v[a>>2];v[c+4>>2]=b;a:{b:{c:{d:{f=v[c+4>>2];if(f>>>0>=e>>>0){if(y[c+20>>2]<e>>>0){break d}if(d>>>0>y[c+8>>2]){break c}g=v[c+28>>2];if(d>>>0>v[c+24>>2]-g>>>0){break b}h=v[c+16>>2];i=v[c>>2];b=0;e:while(1){if((b|0)==(d|0)){break a}j=b+g|0;k=B(b,f);a=0;while(1)if((a|0)==(e|0)){b=b+1|0;continue e}else{z[v[(a<<2)+h>>2]+(j<<2)>>2]=A[(a+k<<3)+i>>3];a=a+1|0;continue}}}aa(7192,9074,77,8754);L()}aa(7157,9074,78,8754);L()}aa(5900,9074,79,8754);L()}aa(5870,9074,80,8754);L()}kb=c- -64|0}function hm(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;$k(a);a:{b:{c:{f=v[b+32>>2];d:{if(!f){e=v[b+2084>>2];if(e){break d}break b}c=v[b+4>>2];if((c|0)<9){break c}e=v[b+2084>>2];if(!e){break c}}h=v[a+1392>>2];j=gm(h);d=v[b+2092>>2];c=0;while(1){if((d|0)>=2){f=d>>>1|0;i=f+c|0;g=y[(i<<2)+e>>2]>j>>>0;d=g?f:d-f|0;c=g?c:i;continue}break}d=v[a+1396>>2];c=w[b+23|0]?c:v[v[b+2088>>2]+(c<<2)>>2];b=w[c+v[b+8>>2]|0];e:{if((d|0)<(b|0)){c=-1;b=0;break e}v[a+1392>>2]=h>>>b;b=d-b|0}v[a+1396>>2]=b;return c}if(w[b+23|0]){break a}e=(c|0)>0?c:0;while(1){if((d|0)!=(e|0)){f:{c=w[v[b+8>>2]+d|0];if((c|0)==255){break f}g=v[a+1392>>2];if(v[f+(d<<2)>>2]!=(g&(-1<<c^-1))){break f}e=v[a+1396>>2];if((e|0)>=(c|0)){v[a+1392>>2]=g>>>c;v[a+1396>>2]=e-w[v[b+8>>2]+d|0];return d}v[a+1396>>2]=0;break b}d=d+1|0;continue}break}ec(a,21);v[a+1396>>2]=0}return-1}aa(11367,13179,1705,5448);L()}function LW(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=kb-96|0;kb=d;zc(b);Zo(a);a:{if(!vv(b,d+56|0)){break a}if(!nD(d+56|0)){break a}b:{if(!c){break b}if(!Qb(v[b>>2],v[b+8>>2],bc(v[d+60>>2])-28|0)){break a}Lv(a);g=d,h=Kv(),v[g+32>>2]=h;e=d+32|0;Jv(Vj(v[a+4>>2])+32|0,e);sr(e);c=v[Vj(v[a+4>>2])+32>>2];v[23540]=0;R(191,e|0,b|0);b=v[23540];v[23540]=0;c:{if((b|0)==1){break c}b=v[d+32>>2];e=v[d+60>>2];f=v[d+68>>2];v[23540]=0;b=fa(192,b|0,bc(e)-28|0,c|0,bc(f)|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break c}e=0;if(!b){break a}re(d+16|0,v[c>>2],v[c+4>>2]);_g(d+24|0,v[d+16>>2],v[d+20>>2]);b=ee(d+8|0);b=qr(d+32|0,v[d+24>>2],v[d+28>>2],v[b>>2],v[b+4>>2]);hd(Vj(v[a+4>>2])+12|0,b);Bb(b);break b}a=Ea(92756,26120)|0;b=O()|0;d:{if((ea(92756)|0)==(b|0)){break d}if((ea(26120)|0)==(b|0)){break d}T(a|0);L()}_(a|0)|0;$();e=0;break a}e=1}kb=d+96|0;return e|0}function Rca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,w=0,x=0;e=kb-16|0;kb=e;g=v[a+24>>2];h=v[a+20>>2];i=v[a+16>>2];f=v[a+4>>2];v[e+8>>2]=v[a>>2];v[e+12>>2]=f;j=b+24|0;k=v[a+8>>2];l=v[a+12>>2];while(1){if(d){f=v[e+8>>2];m=(((v[e+12>>2]&2147483647)<<1|f>>>31)&-2)+i|0;b=(((f>>>16|0)+4&131064)<<1)+j|0;n=u[b+14>>1];o=u[b+12>>1];p=u[b+10>>1];q=u[b+8>>1];r=u[b+6>>1];s=u[b+4>>1];w=u[b+2>>1];x=u[b>>1];f=0;while(1){if((f|0)!=2){b=f+m|0;v[(f<<2)+e>>2]=(((((B(t[b+4|0],p)+B(t[b+2|0],q)|0)+B(t[b+6|0],o)|0)+B(t[b+8|0],n)<<8)/2|0)+((((B(t[b-4|0],w)+B(t[b-6|0],x)|0)+B(t[b-2|0],s)|0)+B(t[b|0],r)<<8)/2|0)|0)/16384;f=f+1|0;continue}break}v[c>>2]=v[c>>2]+B(v[e>>2],h);v[c+4>>2]=v[c+4>>2]+B(v[e+4>>2],g);Rb(e+8|0,k,l);c=c+8|0;d=d-1|0;continue}break}b=v[e+12>>2];v[a>>2]=v[e+8>>2];v[a+4>>2]=b;kb=e+16|0}function pea(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;g=kb-32|0;kb=g;d=kb-16|0;kb=d;c=a+33|0;v[b>>2]=w[c+206|0]|w[c+207|0]<<8;fM(c,b+48|0,w[c+192|0],w[c+200|0],w[c+194|0],w[c+195|0],w[c+196|0],0);fM(c,b+68|0,w[c+193|0],w[c+201|0],w[c+197|0],w[c+198|0],w[c+199|0],1);f=b+236|0;while(1){if((e|0)==96){if(w[c+208|0]){t[b+31|0]=w[c+209|0]+1;f=w[b+31|0];a:{b:{if(!f){e=1;break b}e=16;if(f>>>0<17){break a}}t[b+31|0]=e}u[d+14>>1]=w[c+210|0]|w[c+211|0]<<8;u[d+12>>1]=127;i=b,j=w[Wc(d+14|0,d+12|0)|0]+1|0,t[i+30|0]=j}t[b+33|0]=w[c+212|0];kb=d+16|0}else{i=cc(f,e+12|0),j=w[c+e|0],u[i>>1]=j;e=e+1|0;continue}break}e=b+236|0;while(1){if((h|0)!=96){f=cc(e,h+12|0);d=w[c+h|0];u[f>>1]=d>>>0<(w[a+27|0]|w[a+28|0]<<8)>>>0?d:0;h=h+1|0;continue}break}Fl(g,3,a+4|0);c=g+16|0;Fc(c,g);Dc(b+492|0,c);zb(c);if(!w[a+241|0]){t[b+30|0]=w[a+26|0]}kb=g+32|0}function pQ(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,w=0;f=kb-16|0;kb=f;n=v[a+20>>2];g=x[a+34>>1]&65;v[f+8>>2]=g;v[f>>2]=g^65;g=b;i=a+24|0;o=d+1298224|0;e=d+1074992|0;j=mj(d);p=a+4|0;q=a+12|0;r=a+8|0;s=a+16|0;t=d+480180|0;while(1){if((e|0)!=(o|0)){if(v[e+104>>2]==(a|0)){if(v[e+16>>2]){v[e+16>>2]=g}if(y[e+4>>2]>c>>>0){v[e>>2]=0;v[e+4>>2]=0}b=a;if(v[e+76>>2]){xc(e+76|0,c);b=v[e+104>>2]}d=v[e+88>>2];b=jD(d,b);h=v[(b?q:p)>>2];v[e+84>>2]=v[(b?s:r)>>2];v[e+80>>2]=h;b=d|v[f+8>>2];v[e+88>>2]=b;v[e+88>>2]=b&(v[f>>2]^-1);b=e+704|0;h=v[a+24>>2];a:{if(!v[e+704>>2]|!h){break a}if(Km(v[t>>2])){break a}d=v[(j?b:i)>>2];k=Jka(v[(j?i:b)>>2],0,v[e+700>>2],0);l=k+(d>>>1|0)|0;m=nb;u=e,w=Ec(Mka(l,k>>>0>l>>>0?m+1|0:m,d,0),nb),v[u+700>>2]=w}v[b>>2]=h}e=e+872|0;continue}break}v[a>>2]=c;v[a+20>>2]=g;Ez(n);kb=f+16|0}function dD(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0;c=kb-32|0;kb=c;v[23540]=0;e=Q(13,c+24|0,467288)|0;d=v[23540];v[23540]=0;a:{b:{c:{if((d|0)!=1){d:{e:{if(!w[e|0]){break e}f=Tm(c+8|0,467288);d=v[v[116822]-12>>2]+467288|0;g=v[d+4>>2];v[23540]=0;h=S(14,d|0)|0;i=v[23540];v[23540]=0;if((i|0)==1){break d}f=v[f>>2];v[23540]=0;b=a+b|0;a=ka(15,f|0,a|0,((g&176)==32?b:a)|0,b|0,d|0,h|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break d}v[c+16>>2]=a;if(!Zu(c+16|0)){break e}a=v[v[116822]-12>>2];v[23540]=0;R(16,a+467288|0,5);a=v[23540];v[23540]=0;if((a|0)!=1){break e}break d}zk(e);break b}a=V(0)|0;O()|0;zk(e);break c}a=V(0)|0;O()|0}_(a|0)|0;a=v[v[116822]-12>>2];v[23540]=0;Y(17,a+467288|0);a=v[23540];v[23540]=0;if((a|0)==1){break a}$()}kb=c+32|0;return}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)==1){V(0)|0;O()|0;Vb();L()}T(a|0);L()}function WB(a){var b=0,c=0,d=0,e=0,f=0,g=0;if((w[a|0]-16&255)>>>0>=241){e=a+1954|0;c=a+1698|0;a:{b:{while(1){if((c|0)==(e|0)){c=0;e=0;while(1){b=32;if((c|0)==32){break a}d=B(c,13)+a|0;if(w[d+14|0]){break b}b=(c<<4)+a|0;if(w[b+418|0]|w[b+419|0]<<8|(w[b+420|0]<<16|w[b+421|0]<<24)){break b}f=w[b+422|0]|w[b+423|0]<<8|(w[b+424|0]<<16|w[b+425|0]<<24);if(w[d+942|0]|f>>>0>1048575){break b}d=B(c,11)+a|0;g=d+1346|0;if(w[g|0]>15|w[d+1351|0]>3|w[d+1356|0]>3){break b}c:{d:{if(f){d=w[b+430|0]|w[b+431|0]<<8|(w[b+432|0]<<16|w[b+433|0]<<24);if(d>>>0<=1048574&(d>>>0<(w[b+426|0]|w[b+427|0]<<8|(w[b+428|0]<<16|w[b+429|0]<<24))>>>0|d>>>0>f>>>0)){break b}b=1;if(e){break c}break d}b=1;if(e){break c}if(Sb(g,26317,11)){break d}b=0;break c}b=1}e=b;c=c+1|0;continue}}b=t[c|0];c=c+1|0;if((b|0)>=-1){continue}break}return 0}b=c}a=b>>>0>31&e}else{a=0}return a}function Jaa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=kb-32|0;kb=d;e=Nb(d+16|0);a:{b:{c:{if(c>>>0<64){break c}v[23540]=0;c=S(189,b|0)|0;f=v[23540];v[23540]=0;d:{if((f|0)!=1){v[d+12>>2]=c;if((c|0)>0){break d}v[23540]=0;Q(55,a|0,21688)|0;a=v[23540];v[23540]=0;if((a|0)!=1){break b}}break a}v[23540]=0;c=S(202,b|0)|0;f=v[23540];v[23540]=0;if((f|0)!=1){g=d,h=Fi(c),v[g+8>>2]=h;c=v[td(d+12|0,d+8|0)>>2];v[23540]=0;R(46,e|0,c|0);c=v[23540];v[23540]=0;if((c|0)!=1){break c}}break a}e:{while(1){f:{v[23540]=0;c=S(206,b|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break f}if(!c){break e}v[23540]=0;W(847,e|0,1,((c-65&255)>>>0<26?c+32|0:c)<<24>>24)|0;c=v[23540];v[23540]=0;if((c|0)!=1){continue}}break}break a}v[23540]=0;Q(188,b|0,4)|0;b=v[23540];v[23540]=0;if((b|0)==1){break a}ad(a,e)}zb(e);kb=d+32|0;return}a=P()|0;O()|0;zb(e);T(a|0);L()}function Qp(a){var b=0,c=0,d=0,e=0,f=0,g=0,h=0;c=kb-16|0;kb=c;a:{b:{switch(w[a+480224|0]-1|0){default:b=v[a+24620>>2];d=b>>31;v[c+8>>2]=1;v[c>>2]=v[a+1074420>>2]<<1;f=Jka(b,d,5e4,0);e=nb;b=v[_c(c+8|0,c)>>2];b=Hc(Kka(f,e,b,b>>31),nb);v[a+1074404>>2]=b;break a;case 1:b=v[a+24620>>2];v[c+8>>2]=1;v[c+12>>2]=0;g=c,h=Jka(v[a+1074420>>2],0,Jka(v[a+1074408>>2],0,v[a+1074416>>2],0),nb),v[g>>2]=h;v[c+4>>2]=nb;b=Jka(b,0,6e5,0);d=c+8|0;e=b;f=nb;b=lv(v[d>>2],v[d+4>>2],v[c>>2],v[c+4>>2])?c:d;b=Mka(e,f,v[b>>2],v[b+4>>2]);v[a+1074404>>2]=b;break a;case 0:break b}}b=v[a+24620>>2];d=b>>31;v[c+8>>2]=1;v[c>>2]=v[a+1074420>>2];f=Jka(b,d,1e4,0);e=nb;b=v[_c(c+8|0,c)>>2];b=Hc(Kka(f,e,b,b>>31),nb);v[a+1074404>>2]=b}e=a+1074404|0;a=v[a+480244>>2];b=Jka(a,a>>31,b,b>>31)+32768|0;a=nb;a=Hc(Kka(b,b>>>0<32768?a+1|0:a,65536,0),nb);v[e>>2]=a?a:1;kb=c+16|0}function mK(a){var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,k=0,m=0,p=0,q=0;o(+a);b=j(1)|0;c=j(0)|0;a:{b:{c:{d:{if((b|0)>0|(b|0)>=0){e=b;if(b>>>0>1048575){break d}}if(!(b&2147483647|c)){return-1/(a*a)}if((b|0)>0|(b|0)>=0){break c}return(a-a)/0}if(e>>>0>2146435071){break a}b=1072693248;k=-1023;if((e|0)!=1072693248){b=e;break b}if(c){break b}return 0}o(+(a*0x40000000000000));b=j(1)|0;c=j(0)|0;k=-1077}l(0,c|0);c=b+614242|0;l(1,(c&1048575)+1072079006|0);d=+n()+-1;f=d*(d*.5);g=d/(d+2);h=g*g;a=h*h;o(+(d-f));b=j(1)|0;j(0)|0;l(0,0);l(1,b|0);i=+n();m=i*1.4426950407214463;p=+((c>>>20|0)+k|0);q=m+p;a=g*(f+(a*(a*(a*.15313837699209373+.22222198432149784)+.3999999999940942)+h*(a*(a*(a*.14798198605116586+.1818357216161805)+.2857142874366239)+.6666666666666735)))+(d-i-f);a=q+(m+(p-q)+((a+i)*1.6751713164886512e-10+a*1.4426950407214463))}return a}function DK(a){var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=C(0),k=0,l=C(0),m=0,n=0,o=0,p=C(0);d=a+4208|0;j=C(C(z[Eb(d,2)>>2]*C(2999.9990234375))+C(.0010000000474974513));l=C(z[Eb(d,3)>>2]*C(.9980000257492065));f=-3e3/+C(j*C(y[v[a+16>>2]+24620>>2]));h=a+4272|0;c=ck(10,f*+y[Eb(h,4)>>2]);d=a+4232|0;o=Eb(d,0),p=C(c),z[o>>2]=p;c=ck(10,f*+y[Eb(h,5)>>2]);o=Eb(d,1),p=C(c),z[o>>2]=p;m=f*(1/+C(l+C(.0010000000474974513))+-1);c=0;while(1){if((e|0)==4){e=a+4208|0;f=ck(10,+BK(z[Eb(e,0)>>2])*.05);b=4/K(c)*f;c=ck(10,+BK(z[Eb(e,1)>>2])*.1);z[a+4228>>2]=b*K(c);z[a+4224>>2]=f*K(1-c)}else{g=Eb(h,e);k=e>>>1|0;n=v[Eb(h,k+4|0)>>2];g=v[g>>2];i=ck(10,m*+(n+g>>>0));b=ck(10,f*+(g>>>0));j=z[Eb(d,k)>>2];g=e<<1;i=(1-i)*.5;o=Eb(d,g+2|0),p=C(b*(1-i)),z[o>>2]=p;o=Eb(d,g+3|0),p=C(b*i),z[o>>2]=p;b=b*+j;b=b*(b*(b*(b+1)+1)+1)+1;c=b*b+c;e=e+1|0;continue}break}}function pn(a,b,c,d){var e=0,f=0;f=kb-16|0;kb=f;v[23540]=0;Y(946,a|0);e=v[23540];v[23540]=0;a:{b:{c:{d:{e:{f:{g:{h:{i:{if((e|0)!=1){e=v[a+24>>2];v[23540]=0;R(d|0,f|0,e|0);d=v[23540];v[23540]=0;if((d|0)==1){break i}d=v[f>>2];e=yd(d,v[f+4>>2]);if(e>>>0<2147483647){break h}d=ba(8)|0;v[23540]=0;b=Q(1001,d|0,7389)|0;e=v[23540];v[23540]=0;if((e|0)==1){break g}v[23540]=0;U(119,b|0,93116,168);b=v[23540];v[23540]=0;if((b|0)!=1){break b}b=V(0)|0;O()|0;break f}b=V(0)|0;O()|0;break e}b=V(0)|0;O()|0;break e}j:{if(!((b|0)<(e|0)&(b|0)>=0)){b=gg(21688);break j}b=gg(Mc(Nd(d,b)))}Xe(f);break d}b=V(0)|0;O()|0;ca(d|0)}Xe(f)}_(b|0)|0;b=0;v[23540]=0;X(933,c|0,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)==1){break c}$()}kb=f+16|0;return b}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){break a}V(0)|0;O()|0;Vb()}L()}T(a|0);L()}function qI(a,b,c,d){var e=0,f=C(0),g=0,h=C(0),i=0,j=0,k=0,l=C(0),m=C(0),n=C(0),o=0;e=kb-96|0;kb=e;o=(d|0)>0?d:0;while(1){if((j|0)!=(o|0)){z[e+48>>2]=-z[a>>2];z[e>>2]=z[a+68>>2];d=0;while(1){if((d|0)!=4){i=(e+48|0)+(d<<3)|0;g=(d<<4)+a|0;h=z[g+4>>2];f=z[g+8>>2];z[i+4>>2]=h+f;k=d<<1;z[(8-k<<2)+e>>2]=h-f;h=z[g+16>>2];f=z[g+12>>2];z[(7-k<<2)+e>>2]=h-f;z[i+8>>2]=-C(h+f);d=d+1|0;continue}break}pI(e+48|0);pI(e);z[e+4>>2]=-z[e+4>>2];z[e+12>>2]=-z[e+12>>2];z[e+20>>2]=-z[e+20>>2];z[e+28>>2]=-z[e+28>>2];g=0;while(1){if((g|0)!=9){d=g<<2;i=d+b|0;h=z[i>>2];f=z[d+(e+48|0)>>2];l=z[d+71232>>2];m=z[d+71268>>2];n=z[d+e>>2];z[i>>2]=C(f*l)-C(m*n);i=a+d|0;d=c+d|0;f=C(C(f*m)+C(n*l));z[i>>2]=C(h*z[d>>2])-C(z[d+36>>2]*f);z[(17-g<<2)+a>>2]=C(h*z[d+36>>2])+C(f*z[d>>2]);g=g+1|0;continue}break}b=b+36|0;a=a+72|0;j=j+1|0;continue}break}kb=e+96|0}function aU(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;while(1){a:{g=c;if(!c){g=0;break a}c=g-1|0;if(!w[c+b|0]){continue}}break}b:{if((d|0)!=4){break b}c=0;while(1){if((c|0)==(g|0)){if((e|0)==(f|0)){d=2;if((e|0)==(h|0)){break b}}if(e){d=0;if(!f){break b}}d=e?3:f?1:3}else{c:{d:{e:{d=b+c|0;i=w[d|0];switch(i-10|0){case 0:break d;case 3:break e;default:break c}}e=e+1|0;break c}f=f+1|0}h=c?(w[d-1|0]==13&(i|0)==10)+h|0:h;c=c+1|0;continue}break}}e=0;f=(d|0)==2;c=0;while(1){if(c>>>0<g>>>0){c=((f&w[b+c|0]==13)+c|0)+1|0;e=e+1|0;continue}break}$f(a);tt(a,e);f=(d|0)==1?32:13;h=d&-3?13:32;d=(d|0)==2;c=0;while(1){if(c>>>0<g>>>0){f:{g:{h:{i:{e=t[b+c|0];switch(e-10|0){case 1:case 2:break f;case 0:break g;case 3:break h;default:break i}}if(e){break f}e=32;break f}c=c+d|0;e=f;break f}e=h}$p(a,e);c=c+1|0;continue}break}}function A6(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=kb-32|0;kb=e;v[23540]=0;Y(946,a|0);d=v[23540];v[23540]=0;a:{b:{c:{d:{e:{f:{g:{if((d|0)==1){break g}v[23540]=0;Y(947,b|0);d=v[23540];v[23540]=0;if((d|0)==1){break g}v[23540]=0;Y(947,c|0);d=v[23540];v[23540]=0;if((d|0)==1){break g}f=v[a+24>>2];v[23540]=0;d=Q(55,e+16|0,b|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break g}v[23540]=0;c=Q(55,e|0,c|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break f}v[23540]=0;X(962,f|0,d|0,c|0,1);b=v[23540];v[23540]=0;if((b|0)==1){break e}zb(c);zb(d);b=1;break b}b=V(0)|0;O()|0;break c}b=V(0)|0;O()|0;break d}b=V(0)|0;O()|0;zb(c)}zb(d)}_(b|0)|0;b=0;v[23540]=0;X(933,6412,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)==1){break a}$()}kb=e+32|0;return b|0}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function OV(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;e=kb-16|0;kb=e;nd(b,0);v[b>>2]=w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24);c=Tq(a+4|0,a);d=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);v[b+4>>2]=d;c=Tq(a+8|0,a);f=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);v[b+8>>2]=f;c=(w[a+15|0]|w[a+16|0]<<8)<<1;v[b+24>>2]=c;c=w[a+15|0]|w[a+16|0]<<8?c:16726;v[b+24>>2]=c;g=b,h=(B(Wu(t[a+17|0],w[a+14|0]<<28>>24),c)>>>0)/8363|0,v[g+24>>2]=h;t[e+15|0]=w[a+18|0];t[e+14|0]=127;g=b,h=(((w[Yb(e+15|0,e+14|0)|0]<<8|64)&65344)>>>0)/127|0,u[g+30>>1]=h;c=w[a+14|0];if(c>>>0>=16){u[b+34>>1]=32;u[b+28>>1]=c&240}c=w[a+19|0];if(c&4){u[b+34>>1]=x[b+34>>1]|1;c=w[a+19|0]}a:{if(!(c&8)|d>>>0>=f>>>0){break a}f=x[b+34>>1];d=f|2;u[b+34>>1]=d;c=w[a+19|0];if(c&16){d=f|6;u[b+34>>1]=d;c=w[a+19|0]}if(!(c&64)){break a}u[b+34>>1]=d|128}kb=e+16|0}function k4(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;e=kb+-64|0;kb=e;a:{b:{if((b|0)>=0){d=v[a+24>>2];if(tj(Wb(v[d+484360>>2],w[d+484376|0]))>>>0>b>>>0){break b}}a=a+16|0;break a}d=0;c:{f=v[a+24>>2];g=v[f+484344>>2];i=v[f+484348>>2];h=x[cc(v[Wb(v[f+484360>>2],w[f+484376|0])>>2],b)>>1];if(!Sm(g,i,h)){break c}if((c|0)>=0){d=c;if((d|0)<v[_b(g,h)+12>>2]){break c}}a=a+16|0;break a}u[f+1074448>>1]=b;c=f;f=b&65535;FM(c,f);c=v[a+24>>2];v[c+1074392>>2]=-2;v[c+1074428>>2]=d;g=w[a+64|0];b=e+24|0;u[b+4>>1]=0;t[b+6|0]=255;v[b+16>>2]=2;v[b>>2]=0;v[b+8>>2]=d;u[b+12>>1]=f;d=v[b+20>>2];v[e+16>>2]=v[b+16>>2];v[e+20>>2]=d;d=v[b+12>>2];v[e+8>>2]=v[b+8>>2];v[e+12>>2]=d;d=v[b+4>>2];v[e>>2]=v[b>>2];v[e+4>>2]=d;b=e+48|0;Yt(b,c,g?7:1,e);j=a,k=A[yM(v[e+52>>2])>>3],A[j+16>>3]=k;Ei(b);a=a+16|0}kb=e- -64|0;return+A[a>>3]}function fM(a,b,c,d,e,f,g,h){var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;k=kb-16|0;kb=k;t[k+15|0]=c;t[k+14|0]=12;Qg(b,w[Yb(k+15|0,k+14|0)|0]);c=0;l=v[b>>2];m=v[b+4>>2];p=$d(l,m);while(1){if((c|0)==(p|0)){c=0;t[b+12|0]=0;a:{if(!(d&1)){break a}if(pc(l,m)){break a}c=1;t[b+12|0]=1}if(e>>>0<=11){if(d&2){c=c|4;t[b+12|0]=c}t[b+15|0]=e;t[b+16|0]=e}if(!(g>>>0>11|f>>>0>g>>>0)){if(d&4){t[b+12|0]=c|2}t[b+14|0]=g;t[b+13|0]=f}kb=k+16|0}else{b:{c:{d:{switch(h|0){case 0:j=Eb(l,c);i=(c<<2)+a|0;u[j>>1]=w[i+96|0]|w[i+97|0]<<8;i=i+98|0;break c;case 1:break d;default:break b}}j=Eb(l,c);i=(c<<2)+a|0;u[j>>1]=w[i+144|0]|w[i+145|0]<<8;i=i+146|0}t[j+2|0]=w[i|0]}e:{if(!c){break e}i=Eb(l,c);j=x[i>>1];n=Eb(l,c-1|0);o=x[n>>1];if(j>>>0>255|j>>>0>=o>>>0){break e}j=j|o&65280;u[i>>1]=j;if(j>>>0>=x[n>>1]){break e}u[i>>1]=j+256}c=c+1|0;continue}break}}function EN(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=kb-16|0;kb=e;h=-1;a:{if(!ny(a,b,2)){break a}f=v[b+656>>2];g=a+1074312|0;Db(e+8|0,g,31);b:{if(Cb(v[v[e+8>>2]>>2],v[e+12>>2])){d=v[b+740>>2];if(d){break b}break a}d=v[b+740>>2]}Db(e+8|0,g,31);g=d-Cb(v[v[e+8>>2]>>2],v[e+12>>2])|0;i=v[a+480180>>2];d=(i|0)==4096;j=f+88|0;f=d?64:(i|0)==16384?192:512;d=dq(j,g,f,d?255:64)-(f>>>1|0)|0;if(w[b+746|0]&16){h=Zp(a,b,!(v[b+88>>2]&32768),d);break a}if(xj(v[b+656>>2])){if((d|0)==u[b+772>>1]){break a}k=b,l=ed(d),u[k+772>>1]=l;t[b+851|0]=w[b+851|0]|64;break a}a=mj(a);v[e+8>>2]=d;c:{if((d|0)<0){v[e+8>>2]=0-d;ci(e+8|0,255);a=(v[e+8>>2]<<2)+(a?38224:37200)|0;break c}ci(e+8|0,255);a=(v[e+8>>2]<<2)+(a?37200:38224)|0}a=v[a>>2];b=a;d=a>>31;a=v[c>>2];k=c,l=Hc(Kka(Jka(b,d,a,a>>31),nb,65536,0),nb),v[k>>2]=l}kb=e+16|0;return h}function raa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;nd(c,0);u[c+28>>1]=w[a+36|0]<<2;d=w[a+37|0];u[c+32>>1]=64;u[c+30>>1]=d<<2;v[c>>2]=w[a+40|0]|w[a+41|0]<<8|(w[a+42|0]<<16|w[a+43|0]<<24);v[c+4>>2]=w[a+44|0]|w[a+45|0]<<8|(w[a+46|0]<<16|w[a+47|0]<<24);v[c+8>>2]=w[a+48|0]|w[a+49|0]<<8|(w[a+50|0]<<16|w[a+51|0]<<24);v[c+24>>2]=w[a+52|0]|w[a+53|0]<<8|(w[a+54|0]<<16|w[a+55|0]<<24);d=w[b+151|0];if(d>>>0<=4){t[c+38|0]=w[d+42778|0]}d=w[b+152|0]|w[b+153|0]<<8;t[c+39|0]=d;e=(w[b+156|0]|w[b+157|0]<<8)>>>4|0;t[c+41|0]=e;b=(w[b+154|0]|w[b+155|0]<<8)>>>2|0;t[c+40|0]=b;if((b|e)&255){t[c+39|0]=d^-1}b=w[a+38|0]|w[a+39|0]<<8;if(b&4){u[c+34>>1]=x[c+34>>1]|1;b=w[a+38|0]|w[a+39|0]<<8}if(b&8){u[c+34>>1]=x[c+34>>1]|2;b=w[a+38|0]|w[a+39|0]<<8}if(b&16){u[c+34>>1]=x[c+34>>1]|4;b=w[a+38|0]|w[a+39|0]<<8}if(b&32){u[c+34>>1]=x[c+34>>1]|32}}function qda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=kb-16|0;kb=b;g=v[a+40>>2];h=v[a+36>>2];i=v[a+16>>2];e=v[a+4>>2];v[b+8>>2]=v[a>>2];v[b+12>>2]=e;j=v[a+32>>2];k=v[a+28>>2];l=v[a+8>>2];m=v[a+12>>2];while(1){if(d){f=v[b+8>>2];n=((((v[b+12>>2]&2147483647)<<1|f>>>31)&2147483646)<<1)+i|0;e=f>>>21&2040;o=u[e+39782>>1];p=u[e+39780>>1];q=u[e+39778>>1];r=u[e+39776>>1];e=0;while(1){if((e|0)!=2){f=(e<<1)+n|0;v[(e<<2)+b>>2]=(((B(u[f>>1],q)+B(u[f-4>>1],r)|0)+B(u[f+4>>1],p)|0)+B(u[f+8>>1],o)|0)/16384;e=e+1|0;continue}break}h=h+k|0;v[c>>2]=v[c>>2]+B(v[b>>2],h>>12);g=g+j|0;v[c+4>>2]=v[c+4>>2]+B(v[b+4>>2],g>>12);Rb(b+8|0,l,m);c=c+8|0;d=d-1|0;continue}break}c=v[b+12>>2];v[a>>2]=v[b+8>>2];v[a+4>>2]=c;v[a+40>>2]=g;v[a+20>>2]=h>>12;v[a+36>>2]=h;v[a+24>>2]=g>>12;kb=b+16|0}function dba(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;b=kb-880|0;kb=b;c=Ub(a,0,76);v[c+84>>2]=0;v[c+88>>2]=0;v[c+80>>2]=256;u[c+76>>1]=65535;v[c+92>>2]=0;v[c+96>>2]=0;t[c+100|0]=1;d=c+223848|0;e=c+616|0;a=e;while(1){a=iQ(a)+872|0;if((d|0)!=(a|0)){continue}break}d=Tb(d);g=Ny(c+223860|0);f=b+8|0;Ub(f,0,108);Pz(b+120|0,48e3);Ub(b+664|0,0,72);t[b+754|0]=0;u[b+752>>1]=65535;t[b+746|0]=0;u[b+744>>1]=65535;t[b+738|0]=0;u[b+736>>1]=65535;v[b+748>>2]=0;v[b+740>>2]=0;Ub(b+756|0,0,103);v[b+868>>2]=0;v[b+872>>2]=0;t[b+875|0]=0;t[b+876|0]=0;t[b+877|0]=0;t[b+878|0]=0;v[b+860>>2]=0;v[b+864>>2]=0;t[b+859|0]=w[b+859|0]&128;a=((e+223232|0)-e|0)/872|0;while(1){if((a|0)>0){a=a-1|0;e=Vp(e,f)+872|0;continue}break}v[23540]=0;R(538,d|0,32);a=v[23540];v[23540]=0;if((a|0)!=1){kb=b+880|0;return c|0}a=P()|0;O()|0;Wp(g);ic(d);T(a|0);L()}function Iy(a,b){var c=0,d=0,e=0,f=0,g=0,h=0;d=x[a+480188>>1];h=d>>>0>256?d:256;f=v[a+1298300>>2];c=d;a:{while(1){if((c|0)!=(h|0)){e=B(c,872)+a|0;if(!v[e+1075068>>2]){if(!oj(v[e+1075648>>2])|w[e+1075081|0]&24){break a}}if(w[e+1075081|0]&2){if(!zd(f)){break a}if(!kN(f,c&65535)){break a}}c=c+1|0;continue}break}e=0;f=65535;g=8388608;if(b>>>0<=255){b=B(b,872)+a|0;if(!v[b+1075688>>2]){c=65535;if(v[b+1075068>>2]){break a}}g=v[b+1075680>>2]|v[b+1075672>>2]<<9}while(1){if((d|0)==(h|0)){c=f;break a}b=B(d,872)+a|0;if(!(v[b+1075688>>2]?0:v[b+1075068>>2])){c=(v[b+1075680>>2]|v[b+1075672>>2]<<9)>>>(v[b+1075080>>2]>>>1&1)|0;b:{c:{if(c>>>0<g>>>0){b=v[(B(d,872)+a|0)+1075716>>2];break c}if((c|0)!=(g|0)){break b}b=v[(B(d,872)+a|0)+1075716>>2];if(e>>>0>=b>>>0){break b}}g=c;f=d;e=b}d=d+1|0;continue}break}c=d}return c&65535}function D7(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;b=vi(a,b,c,d);v[b+4260>>2]=0;v[b>>2]=46812;c=b+4960|0;e=b+4504|0;d=e;while(1){d=Tb(d)+24|0;if((d|0)!=(c|0)){continue}break}t[b+5046|0]=1;u[b+5044>>1]=0;a=b+4208|0;f=Eb(a,0),g=1063675494,v[f>>2]=g;f=Eb(a,1),g=1065185444,v[f>>2]=g;f=Eb(a,2),g=0,v[f>>2]=g;f=Eb(a,3),g=1032805417,v[f>>2]=g;f=Eb(a,4),g=1053079357,v[f>>2]=g;f=Eb(a,5),g=1059859440,v[f>>2]=g;f=Eb(a,6),g=1047457519,v[f>>2]=g;f=Eb(a,7),g=1062836634,v[f>>2]=g;f=Eb(a,8),g=1038174126,v[f>>2]=g;f=Eb(a,9),g=1065353216,v[f>>2]=g;f=Eb(a,10),g=1065353216,v[f>>2]=g;f=Eb(a,11),g=1048525618,v[f>>2]=g;f=Eb(a,12),g=1059760811,v[f>>2]=g;v[23540]=0;R(897,b+44|0,2);a=v[23540];v[23540]=0;if((a|0)==1){a=P()|0;O()|0;while(1){c=wc(c-24|0);if((e|0)!=(c|0)){continue}break}If(b);T(a|0);L()}ui(b);return b|0}function mI(a){var b=0,c=0,d=0,e=0,f=0,g=0;c=v[a+32>>2];a:{b:{b=v[a+1380>>2];if((b|0)==-1){d=1;b=-1;break b}e=v[a+1116>>2];d=(b|0)>(e|0)?b:e;while(1){c:{if((b|0)!=(d|0)){f=w[(a+b|0)+1120|0];c=f+c|0;if((f|0)==255){break c}d=b}if(y[a+40>>2]<c>>>0){ec(a,1);break a}b=(d|0)==(e|0)?-1:d;d=0;break b}b=b+1|0;continue}}while(1){if((b|0)!=-1){return 1}e=v[a+40>>2];if(e>>>0<=c+26>>>0){ec(a,1);break a}if(Sb(c,93680,4)){ec(a,21);break a}if(w[c+4|0]){ec(a,21);break a}d:{if(d){if(!v[a+992>>2]|!(t[c+5|0]&1)){break d}ec(a,21);break a}if(t[c+5|0]&1){break d}ec(a,21);break a}b=0;f=c+27|0;d=w[c+26|0];c=f+d|0;if(e>>>0<c>>>0){ec(a,1);break a}while(1){e:{if((b|0)==(d|0)){b=d;break e}g=w[b+f|0];c=g+c|0;if((g|0)!=255){break e}b=b+1|0;continue}break}b=(b|0)==(d|0)?-1:b;d=0;if(c>>>0<=e>>>0){continue}break}ec(a,1)}return 0}function iF(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0;d=kb-48|0;kb=d;v[23540]=0;Y(946,a|0);e=v[23540];v[23540]=0;a:{b:{c:{if((e|0)!=1){e=Nb(d+32|0);v[23540]=0;Y(c|0,d+16|0);c=v[23540];v[23540]=0;d:{e:{if((c|0)!=1){h=d,i=Fb(v[d+16>>2]),v[h+8>>2]=i;f=1;while(1){g=Fb(v[d+20>>2]);c=v[d+8>>2];if(!Pb(c,g)){c=gg(Mc(e));Xe(d+16|0);zb(e);break b}if(!f){v[23540]=0;Q(935,e|0,14644)|0;c=v[23540];v[23540]=0;if((c|0)==1){break e}c=v[d+8>>2]}v[23540]=0;Q(800,e|0,c|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break e}oq(d+8|0);f=0;continue}}c=V(0)|0;O()|0;break d}c=V(0)|0;O()|0;Xe(d+16|0)}zb(e);break c}c=V(0)|0;O()|0}_(c|0)|0;c=0;v[23540]=0;X(933,b|0,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)==1){break a}$()}kb=d+48|0;return c}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)==1){V(0)|0;O()|0;Vb();L()}T(a|0);L()}function vG(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;h=kb-32|0;kb=h;a:{b:{c:{if((b|0)!=(c|0)){j=v[116016];v[116016]=0;g=kb-16|0;kb=g;Gd();e=kb-16|0;kb=e;f=kb-16|0;kb=f;Cw(f,b,h+28|0,2);k=v[f>>2];i=v[f+4>>2];b=v[f+12>>2];v[e+8>>2]=v[f+8>>2];v[e+12>>2]=b;v[e>>2]=k;v[e+4>>2]=i;kb=f+16|0;i=v[e>>2];f=v[e+4>>2];b=v[e+12>>2];v[g+8>>2]=v[e+8>>2];v[g+12>>2]=b;v[g>>2]=i;v[g+4>>2]=f;kb=e+16|0;f=v[g>>2];e=v[g+4>>2];b=v[g+12>>2];v[h+16>>2]=v[g+8>>2];v[h+20>>2]=b;v[h+8>>2]=f;v[h+12>>2]=e;kb=g+16|0;i=v[h+16>>2];f=v[h+20>>2];g=v[h+8>>2];e=v[h+12>>2];b=v[116016];if(!b){break c}if(v[h+28>>2]!=(c|0)){break b}l=g;m=e;n=i;o=f;if((b|0)!=68){break a}break b}v[d>>2]=4;break a}v[116016]=j;if(v[h+28>>2]==(c|0)){break a}}v[d>>2]=4;g=l;e=m;i=n;f=o}v[a>>2]=g;v[a+4>>2]=e;v[a+8>>2]=i;v[a+12>>2]=f;kb=h+32|0}function bia(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;e=kb-16|0;kb=e;c=rf(a,c);me(e,v[a+36>>2]);h=a;a:{if(!c){Sc(e,a+32|0,5);d=0;if(Cb(v[v[e>>2]>>2],v[e+4>>2])){break a}}d=kb-32|0;kb=d;f=v[a+36>>2];Wf(f,d+30|0);b:{c:{d:{e:{a=x[d+30>>1];if(a>>>0>=4001){i=v[b+12>>2];a=kb-16|0;kb=a;g=yc(a,15965);ad(d,g);Ab(g);kb=a+16|0;v[23540]=0;U(478,d+16|0,d|0,d+30|0);a=v[23540];v[23540]=0;if((a|0)==1){break e}a=v[i+1298464>>2];v[23540]=0;U(376,a|0,2,d+16|0);a=v[23540];v[23540]=0;if((a|0)==1){break d}Ab(d+16|0);dc(d);a=4e3}vg(zj(v[b>>2],0),a);b=zj(v[b>>2],0);j=d,k=Fb(v[b>>2]),v[j+16>>2]=k;b=Fb(v[b+4>>2]);break b}b=P()|0;O()|0;break c}b=P()|0;O()|0;Ab(d+16|0)}dc(d);T(b|0);L()}while(1){a=v[d+16>>2];if(Pb(a,b)){Wf(f,d);u[a>>1]=x[d>>1];Se(d+16|0);continue}break}kb=d+32|0;d=c}Ye(h,d);kb=e+16|0}function Q9(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;f=kb-16|0;kb=f;j=rf(a,c);me(f,v[a+36>>2]);k=a;a:{if(!j){Sc(f,a+32|0,5);c=0;if(Cb(v[v[f>>2]>>2],v[f+4>>2])){break a}}e=kb-48|0;kb=e;h=v[a+36>>2];Jk(h,e+40|0);c=v[e+44>>2];if(!c&y[e+40>>2]>=257|c){v[e+40>>2]=256;v[e+44>>2]=0}l=v[e+40>>2];m=v[e+44>>2];c=0;b:{c:{d:{e:{while(1){if(!m&c>>>0>=l>>>0){break b}Wf(h,e+38|0);g=Nb(e+24|0);v[23540]=0;Q(485,h|0,g|0)|0;a=v[23540];v[23540]=0;if((a|0)!=1){v[23540]=0;U(11,e+8|0,d|0,g|0);a=v[23540];v[23540]=0;if((a|0)==1){break e}v[23540]=0;a=Q(888,b|0,e+38|0)|0;i=v[23540];v[23540]=0;if((i|0)==1){break d}i=a;a=e+8|0;Jb(i,a);Ab(a);zb(g);c=c+1|0;continue}break}c=P()|0;O()|0;break c}c=P()|0;O()|0;break c}c=P()|0;O()|0;Ab(e+8|0)}zb(g);T(c|0);L()}kb=e+48|0;c=j}Ye(k,c);kb=f+16|0}function rda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=kb-16|0;kb=b;g=v[a+40>>2];h=v[a+36>>2];i=v[a+16>>2];e=v[a+4>>2];v[b+8>>2]=v[a>>2];v[b+12>>2]=e;j=v[a+32>>2];k=v[a+28>>2];l=v[a+8>>2];m=v[a+12>>2];while(1){if(d){f=v[b+8>>2];n=(((v[b+12>>2]&2147483647)<<1|f>>>31)&-2)+i|0;e=f>>>21&2040;o=u[e+39782>>1];p=u[e+39780>>1];q=u[e+39778>>1];r=u[e+39776>>1];e=0;while(1){if((e|0)!=2){f=e+n|0;v[(e<<2)+b>>2]=(((B(t[f|0],q)+B(t[f-2|0],r)|0)+B(t[f+2|0],p)|0)+B(t[f+4|0],o)<<8)/16384;e=e+1|0;continue}break}h=h+k|0;v[c>>2]=v[c>>2]+B(v[b>>2],h>>12);g=g+j|0;v[c+4>>2]=v[c+4>>2]+B(v[b+4>>2],g>>12);Rb(b+8|0,l,m);c=c+8|0;d=d-1|0;continue}break}c=v[b+12>>2];v[a>>2]=v[b+8>>2];v[a+4>>2]=c;v[a+40>>2]=g;v[a+20>>2]=h>>12;v[a+36>>2]=h;v[a+24>>2]=g>>12;kb=b+16|0}function qha(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=kb-432|0;kb=d;zc(b);AA(b,d+376|0,d+296|0,d+8|0);k=d,l=tg((m=w[d+427|0]+1|0,n=1,o=bc(v[d+408>>2]),o?m:n)),t[k+4|0]=l;i=w[Yb(26864,d+4|0)|0];t[d+7|0]=i;u[d+4>>1]=4;a:{b:{while(1){if((h&255)>>>0>=i>>>0){break b}e=Ib(x[d+8>>1])<<16>>16;if(!((e|0)<0|w[d+291|0]>63)){e=e&65535;f=0;while(1){if((f|0)==(e|0)){c:{e=g;g=bc(v[d+296>>2]);if(e>>>0<g>>>0){if(dd(b,g)){break c}}t[d+7|0]=h+1;break b}}else{d:{if(!dd(b,bc(v[d+392>>2])+(f<<2)|0)){break d}if(!dd(b,Do(b))){break d}e:{if(!c){j=Me(b);break e}j=Hj(b)}u[d+2>>1]=j;k=d,l=x[ke(d+4|0,d+2|0)>>1],u[k+4>>1]=l}f=f+1|0;continue}break}g=bc(v[d+296>>2]);AA(b,d+376|0,d+296|0,d+8|0);h=h+1|0;continue}break}pv(a);break a}u[a>>1]=x[d+4>>1];t[a+2|0]=w[d+7|0]}kb=d+432|0}
function ov(a,b,c,d){var e=0,f=0,g=0,h=0;g=kb-16|0;kb=g;a:{if(!c){break a}if(d){b=hc(g+8|0,a,b);a=kb-16|0;kb=a;v[a+12>>2]=c;d=v[b+4>>2];b:{if(!d){d=v[b>>2];break b}e=32-d|0;v[a+8>>2]=e;c=v[b>>2];h=e;e=v[Kb(a+8|0,a+12|0)>>2];v[c>>2]=-1<<d&-1>>>h-e|v[c>>2];f=v[a+12>>2];d=c+4|0;v[b>>2]=d;c=f-e|0}e=d;d=c>>>5<<2;Ub(e,255,d);e=c&31;v[a+12>>2]=e;if((c&-32)!=(c|0)){c=b;b=d+v[b>>2]|0;v[c>>2]=b;v[b>>2]=v[b>>2]|-1>>>32-e}kb=a+16|0;break a}b=hc(g,a,b);a=kb-16|0;kb=a;v[a+12>>2]=c;d=v[b+4>>2];c:{if(!d){d=v[b>>2];break c}e=32-d|0;v[a+8>>2]=e;c=v[b>>2];f=v[c>>2];h=e;e=v[Kb(a+8|0,a+12|0)>>2];v[c>>2]=(-1<<d&-1>>>h-e^-1)&f;f=v[a+12>>2];d=c+4|0;v[b>>2]=d;c=f-e|0}e=d;d=c>>>5<<2;Ub(e,0,d);e=c&31;v[a+12>>2]=e;if((c&-32)!=(c|0)){c=b;b=d+v[b>>2]|0;v[c>>2]=b;v[b>>2]=v[b>>2]&(-1>>>32-e^-1)}kb=a+16|0}kb=g+16|0}function uka(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;g=kb-48|0;kb=g;h=a+8|0;c=v[a+8>>2];j=Cc(a);a:{if((c|0)!=v[j>>2]){break a}i=a+4|0;e=v[a+4>>2];d=v[a>>2];if(e>>>0>d>>>0){a=e;d=((a-d>>1)+1|0)/-2<<1;e=a+d|0;while(1){if((a|0)!=(c|0)){e=nV(e,a)+2|0;a=a+2|0;continue}break}c=e;v[h>>2]=c;v[i>>2]=d+v[i>>2];break a}v[g+24>>2]=c-d;v[g+44>>2]=1;e=g+24|0;c=v[_c(e,g+44|0)>>2];c=Nj(e,c,c>>>2|0,v[a+16>>2]);d=fc(g+16|0,v[a+4>>2]);f=v[fc(g+8|0,v[a+8>>2])>>2];e=kb-32|0;kb=e;d=v[d>>2];v[e+24>>2]=d;d=Qo(e+8|0,c+8|0,KB(d,f));f=v[d>>2];while(1){if(v[d+4>>2]!=(f|0)){k=f;f=v[e+24>>2];Kj(k,w[f|0]|w[f+1|0]<<8);f=v[d>>2]+2|0;v[d>>2]=f;Se(e+24|0);continue}break}Ud(d);kb=e+32|0;qc(a,c);qc(i,c+4|0);qc(h,c+8|0);qc(j,Cc(c));Ni(c);c=v[a+8>>2]}Kj(c,w[b|0]|w[b+1|0]<<8);v[h>>2]=v[h>>2]+2;kb=g+48|0}function Gd(){var a=0,b=0,c=0,d=0,e=0,f=0,g=0;if(w[468100]){return v[117024]}c=kb-32|0;kb=c;a:{b:{while(1){e=(c+8|0)+(a<<2)|0;d=1<<a&2147483647;if(d|1){d=RG(a,d?14318:21688)}else{d=v[a<<2>>2]}v[e>>2]=d;if((d|0)==-1){break b}a=a+1|0;if((a|0)!=6){continue}break}if(!QG(0)){b=89768;if(!Sb(c+8|0,89768,24)){break a}b=89792;if(!Sb(c+8|0,89792,24)){break a}a=0;if(!w[467872]){while(1){f=(a<<2)+467824|0,g=RG(a,21688),v[f>>2]=g;a=a+1|0;if((a|0)!=6){continue}break}t[467872]=1;v[116962]=v[116956]}b=467824;if(!Sb(c+8|0,467824,24)){break a}b=467848;if(!Sb(c+8|0,467848,24)){break a}b=Pd(24);if(!b){break b}}a=v[c+12>>2];v[b>>2]=v[c+8>>2];v[b+4>>2]=a;a=v[c+28>>2];v[b+16>>2]=v[c+24>>2];v[b+20>>2]=a;a=v[c+20>>2];v[b+8>>2]=v[c+16>>2];v[b+12>>2]=a;break a}b=0}kb=c+32|0;t[468100]=1;v[117024]=b;return b}function Oca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;f=kb-16|0;kb=f;g=v[a+40>>2];h=v[a+36>>2];i=v[a+16>>2];e=v[a+4>>2];v[f+8>>2]=v[a>>2];v[f+12>>2]=e;j=b+24|0;k=v[a+32>>2];l=v[a+28>>2];m=v[a+8>>2];n=v[a+12>>2];while(1){if(d){b=(v[f+12>>2]<<1)+i|0;e=(((v[f+8>>2]>>>16|0)+4&131064)<<1)+j|0;b=(((((B(u[b+4>>1],u[e+10>>1])+B(u[b+2>>1],u[e+8>>1])|0)+B(u[b+6>>1],u[e+12>>1])|0)+B(u[b+8>>1],u[e+14>>1])|0)/2|0)+((((B(u[b-4>>1],u[e+2>>1])+B(u[b-6>>1],u[e>>1])|0)+B(u[b-2>>1],u[e+4>>1])|0)+B(u[b>>1],u[e+6>>1])|0)/2|0)|0)/16384|0;h=h+l|0;v[c>>2]=v[c>>2]+B(b,h>>12);g=g+k|0;v[c+4>>2]=v[c+4>>2]+B(b,g>>12);Rb(f+8|0,m,n);c=c+8|0;d=d-1|0;continue}break}b=v[f+12>>2];v[a>>2]=v[f+8>>2];v[a+4>>2]=b;v[a+40>>2]=g;v[a+20>>2]=h>>12;v[a+36>>2]=h;v[a+24>>2]=g>>12;kb=f+16|0}function yq(a,b){var c=0;c=kb-16|0;kb=c;a=ir(a);a:{b:{c:{switch(b-1|0){default:if((b|0)!=16777216){break b}Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(Ob(a,7,1),9,1),10,1),13,1),15,1),16,1),17,1),18,1),20,1),21,1),24,1),25,1),26,1),28,1),30,1),31,1),33,1),34,1),39,1),41,1),44,1),46,1),45,1),47,1),48,1),50,1),99,1),102,1),104,1),105,1),115,1);break a;case 1:wy(c,2);b=v[c+12>>2];v[a+8>>2]=v[c+8>>2];v[a+12>>2]=b;b=v[c+4>>2];v[a>>2]=v[c>>2];v[a+4>>2]=b;_f(a,107);break a;case 3:wy(c,4);b=v[c+12>>2];v[a+8>>2]=v[c+8>>2];v[a+12>>2]=b;b=v[c+4>>2];v[a>>2]=v[c>>2];v[a+4>>2]=b;_f(a,4);break a;case 2:break b;case 0:break c}}Ob(a,88,1);break a}wy(c,b);b=v[c+12>>2];v[a+8>>2]=v[c+8>>2];v[a+12>>2]=b;b=v[c+4>>2];v[a>>2]=v[c>>2];v[a+4>>2]=b}kb=c+16|0}function uK(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0;j=kb-48|0;kb=j;k=v[a+4>>2];l=v[a>>2];a=v[a+8>>2];v[j+32>>2]=b;v[j+44>>2]=a;v[j+36>>2]=l;v[j+40>>2]=k;v[23540]=0;a=Q(926,(d?d:927)|0,e|0)|0;b=v[23540];v[23540]=0;a:{b:{c:{d:{if((b|0)!=1){v[j+16>>2]=a;a=v[eg(j+24|0,j+16|0)>>2];b=v[j+44>>2];v[j+8>>2]=v[j+40>>2];v[j+12>>2]=b;v[23540]=0;b=v[j+36>>2];v[j>>2]=v[j+32>>2];v[j+4>>2]=b;c=+Aa(928,j|0,+c,a|0);a=v[23540];v[23540]=0;if((a|0)==1){break d}De(j+16|0);break b}a=V(0)|0;O()|0;break c}a=V(0)|0;O()|0;De(j+16|0)}_(a|0)|0;v[23540]=0;ia(929,15093,d|0,e|0,f|0,g|0,h|0,i|0);a=v[23540];v[23540]=0;if((a|0)==1){break a}$();c=0}kb=j+48|0;return+c}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function A9(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;a:{b:{if((Qj(v[a>>2],v[a+4>>2])|0)==2){if((Qj(v[a+12>>2],v[a+16>>2])|0)==(b|0)){break b}}v[23540]=0;R(899,a|0,2);c=v[23540];v[23540]=0;c:{if((c|0)==1){break c}v[23540]=0;R(899,a+12|0,b|0);c=v[23540];v[23540]=0;if((c|0)==1){break c}v[23540]=0;R(900,a+24|0,2);c=v[23540];v[23540]=0;if((c|0)==1){break c}v[23540]=0;R(900,a+36|0,b|0);c=v[23540];v[23540]=0;if((c|0)==1){break c}c=a;while(1)if((d|0)==2){a=0;while(1){if((a|0)==(b|0)){break b}d=fr(v[c+12>>2],a);f=Eb(v[c+36>>2],a),g=d,v[f>>2]=g;a=a+1|0;continue}}else{e=fr(v[a>>2],d);f=Eb(v[a+24>>2],d),g=e,v[f>>2]=g;d=d+1|0;continue}}b=V(92756)|0;if((O()|0)!=(ea(92756)|0)){break a}_(b|0)|0;Lc(a);CL(a);b=a+12|0;Lc(b);CL(b);b=a+24|0;Lc(b);BL(b);a=a+36|0;Lc(a);BL(a);$()}return}T(b|0);L()}function zV(a,b,c){var d=0,e=0;e=kb-16|0;kb=e;t[e+15|0]=c;a:{if(b>>>0>35){break a}b:{c:{d:{e:{f:{d=w[b+26352|0];switch(d-17|0){case 1:case 3:case 4:case 5:break a;case 0:break c;case 2:break d;case 6:break e;default:break f}}g:{if(d-6>>>0<2){break g}if((d|0)==31){break b}if((d|0)==11){break g}if((d|0)!=1){break a}d=(c|0)!=0;break a}b=c&240;if(!b|(b|0)==240|(c&15)==15){break a}t[e+15|0]=b;break a}if(c>>>0<=64){t[e+15|0]=c<<1;d=23;break a}t[e+15|0]=128;d=23;break a}d=19;h:{switch((c&240)-48>>>4|0){case 0:t[e+15|0]=159;d=20;break a;case 1:t[e+15|0]=192;d=20;break a;case 2:if(c&14){break a}t[e+15|0]=((c|0)!=80)<<6;d=21;break a;case 4:break h;default:break a}}t[e+15|0]=c&15|160;d=20;break a}d=c>>>0<32?16:17;break a}t[e+15|0]=(b<<5|c<<24>>>27)^128;d=31}de(a,d,e+15|0);kb=e+16|0}function R8(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=C(0);c=kb-4112|0;kb=c;h=ob[v[v[a>>2]+120>>2]](a)|0;if(!h){ob[v[v[a>>2]+124>>2]](a)}v[c+12>>2]=0;f=kb-16|0;kb=f;while(1){d=v[a+44>>2];if(Qj(d,v[a+48>>2])>>>0<=e>>>0){kb=f+16|0}else{v[f+12>>2]=0;d=fr(d,e);g=(d+2048|0)-d>>2;while(1){if((g|0)>0){z[d>>2]=z[f+12>>2];g=g-1|0;d=d+4|0;continue}break}e=e+1|0;continue}break}f=c+2064|0;a:while(1){if(b){v[c+8>>2]=b;xc(c+8|0,512);e=c+16|0;Ay(e);d=v[c+8>>2];ob[v[v[a>>2]+60>>2]](a,e,f,d);e=0;while(1)if((e|0)==(d|0)){b=b-d|0;continue a}else{g=(c+16|0)+(e<<2)|0;z[c+4>>2]=D(z[g>>2]);i=c,j=z[Lx(c+12|0,c+4|0)>>2],z[i+12>>2]=j;z[c+4>>2]=D(z[g+2048>>2]);i=c,j=z[Lx(c+12|0,c+4|0)>>2],z[i+12>>2]=j;e=e+1|0;continue}}break}if(!h){ob[v[v[a>>2]+128>>2]](a)}kb=c+4112|0;return C(z[c+12>>2])}function M3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;d=kb-32|0;kb=d;j=d,k=UJ(),v[j+24>>2]=k;g=a+24|0;c=d+24|0;SJ(g,ce(c));ij(c);u[a+28>>1]=0;JP();f=kb-16|0;kb=f;e=vc(144);v[23540]=0;h=Q(1059,e|0,4)|0;i=v[23540];v[23540]=0;a:{if((i|0)!=1){e=v[Lf(f+8|0,h)>>2];kb=f+16|0;break a}a=P()|0;O()|0;Mb(e);T(a|0);L()}v[d+24>>2]=e;RJ(a+32|0,ce(c));As(c);j=d,k=TJ(v[a>>2]),v[j+24>>2]=k;QJ(a+4|0,ce(c));hj(c);Jn(v[g>>2],v[a+4>>2]);t[a+64|0]=1;v[a+60>>2]=0;v[a+48>>2]=1065353216;v[a+52>>2]=0;v[a+16>>2]=0;v[a+20>>2]=0;v[a+8>>2]=0;j=d,k=Gi(v[b>>2]),v[j+24>>2]=k;e=xf(b);b:{while(1){b=v[d+24>>2];if(!Hg(b,e)){break b}c=vd(b);b=Bh(d+8|0,c);v[23540]=0;X(962,a|0,b|0,c+12|0,0);c=v[23540];v[23540]=0;if((c|0)!=1){zb(b);Kg(d+24|0);continue}break}a=P()|0;O()|0;zb(b);T(a|0);L()}kb=d+32|0}function EL(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0;e=kb-16|0;kb=e;a:{if(uc(v[a>>2],v[a+4>>2])>>>0>511){break a}if(!Yg(v[v[b>>2]-12>>2]+b|0)){break a}d=kb-16|0;kb=d;f=vc(64);v[23540]=0;g=S(835,f|0)|0;h=v[23540];v[23540]=0;b:{c:{if((h|0)!=1){f=Lf(d,g);g=v[f>>2];v[23540]=0;g=W(894,g|0,b|0,c|0)|0;h=v[23540];v[23540]=0;d:{e:{if((h|0)!=1){if((g|0)==1){break e}Gc(d+8|0);break d}a=P()|0;O()|0;sg(f);break c}eg(d+8|0,f)}sg(f);kb=d+16|0;d=v[d+8>>2];break b}a=P()|0;O()|0;Mb(f)}T(a|0);L()}v[e+8>>2]=d;f:{g:{if(!zd(d)){v[23540]=0;b=Q(893,b|0,c|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break g}v[e>>2]=b;pT(e+8|0,ce(e));sg(e);d=v[e+8>>2]}if(!zd(d)){break f}v[23540]=0;R(487,a|0,e+8|0);a=v[23540];v[23540]=0;i=d;if((a|0)!=1){break f}}a=P()|0;O()|0;sg(e+8|0);T(a|0);L()}sg(e+8|0)}kb=e+16|0;return i}function rd(a){var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;b=v[a+112>>2];d=v[a+116>>2];e=!!(b|d);c=b;a:{i=e;f=v[a+4>>2];e=v[a+44>>2];b=f-e|0;h=b;g=b+v[a+120>>2]|0;b=v[a+124>>2]+(b>>31)|0;b=g>>>0<h>>>0?b+1|0:b;if(!(i&(c>>>0<=g>>>0&(b|0)>=(d|0)|(b|0)>(d|0)))){h=Lw(a);if((h|0)>=0){break a}f=v[a+4>>2];e=v[a+44>>2]}v[a+112>>2]=-1;v[a+116>>2]=-1;v[a+104>>2]=f;c=e-f|0;d=c+g|0;b=(c>>31)+b|0;v[a+120>>2]=d;v[a+124>>2]=d>>>0<c>>>0?b+1|0:b;return-1}d=g+1|0;b=d?b:b+1|0;f=v[a+4>>2];e=v[a+8>>2];c=v[a+112>>2];g=v[a+116>>2];b:{if(!(c|g)){break b}i=c-d|0;c=g-(b+(d>>>0>c>>>0)|0)|0;j=e-f|0;g=j>>31;if((c|0)>=(g|0)&i>>>0>=j>>>0|(c|0)>(g|0)){break b}e=f+i|0}v[a+104>>2]=e;c=v[a+44>>2];e=c-f|0;d=e+d|0;b=(e>>31)+b|0;v[a+120>>2]=d;v[a+124>>2]=d>>>0<e>>>0?b+1|0:b;if(c>>>0>=f>>>0){t[f-1|0]=h}return h}function Pca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;f=kb-16|0;kb=f;g=v[a+40>>2];h=v[a+36>>2];i=v[a+16>>2];e=v[a+4>>2];v[f+8>>2]=v[a>>2];v[f+12>>2]=e;j=b+24|0;k=v[a+32>>2];l=v[a+28>>2];m=v[a+8>>2];n=v[a+12>>2];while(1){if(d){b=v[f+12>>2]+i|0;e=(((v[f+8>>2]>>>16|0)+4&131064)<<1)+j|0;b=(((((B(t[b+2|0],u[e+10>>1])+B(t[b+1|0],u[e+8>>1])|0)+B(t[b+3|0],u[e+12>>1])|0)+B(t[b+4|0],u[e+14>>1])<<8)/2|0)+((((B(t[b-2|0],u[e+2>>1])+B(t[b-3|0],u[e>>1])|0)+B(t[b-1|0],u[e+4>>1])|0)+B(t[b|0],u[e+6>>1])<<8)/2|0)|0)/16384|0;h=h+l|0;v[c>>2]=v[c>>2]+B(b,h>>12);g=g+k|0;v[c+4>>2]=v[c+4>>2]+B(b,g>>12);Rb(f+8|0,m,n);c=c+8|0;d=d-1|0;continue}break}b=v[f+12>>2];v[a>>2]=v[f+8>>2];v[a+4>>2]=b;v[a+40>>2]=g;v[a+20>>2]=h>>12;v[a+36>>2]=h;v[a+24>>2]=g>>12;kb=f+16|0}function Wn(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;c=v[b+88>>2];d=c|2048;v[b+88>>2]=d;f=v[b+656>>2];if(!(!f|t[b+730|0]&1)){d=c|6144;v[b+88>>2]=d}a:{if(!v[b+76>>2]){break a}b:{if(!(d&8)|c&2048){break b}c=v[b+104>>2];if(!c){break b}e=x[c+34>>1];if(e&2){d=(e&4?d|4:d&-135)|2;v[b+88>>2]=d;e=v[c>>2];v[b+76>>2]=e;g=v[c+4>>2];v[b+80>>2]=g;c=v[c+8>>2];v[b+84>>2]=c;if(c>>>0<e>>>0){v[b+76>>2]=c;h=c}else{h=e}e=v[b+4>>2];if(h>>>0>=e>>>0){break b}v[b>>2]=0;v[b+4>>2]=((e-g>>>0)%(c-g>>>0)|0)+g;break b}d=d&-135;v[b+88>>2]=d;v[b+76>>2]=v[c>>2]}if(!f){break a}if(!(!(v[a+480180>>2]&1064964?1:w[f+60|0]&2)|!v[f>>2])){v[b+88>>2]=d|4096}if(w[f+65|0]==255|x[b+728>>1]!=65535){break a}i=b,j=ed(dq(f+48|0,v[b+724>>2],256,64)),u[i+728>>1]=j;i=b,j=x[Eb(v[f+48>>2],w[f+65|0])>>1],v[i+724>>2]=j}}function d8(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=C(0),g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=C(0),o=C(0),p=0,q=0,r=0,s=0;h=kb-16|0;kb=h;if(bi(a+44|0)){g=v[a+44>>2];r=h,s=Jc(g,0),v[r+8>>2]=s;r=h,s=Jc(g,1),v[r+12>>2]=s;g=v[a+56>>2];l=Jc(g,0);v[h>>2]=l;m=Jc(g,1);v[h+4>>2]=m;p=w[a+4273|0];q=w[a+4272|0];g=d;while(1){k=0;if(g){while(1){if((k|0)!=2){j=k<<2;i=j+(h+8|0)|0;e=v[i>>2];v[i>>2]=e+4;f=C(z[e>>2]*z[a+4240>>2]);e=a+j|0;i=e+4228|0;f=C(f+C(z[i>>2]*z[a+4236>>2]));z[i>>2]=f;f=TK(C(f*C(1073741824)),q,p);i=e+4244|0;e=e+4252|0;n=z[e>>2];o=z[a+4264>>2];f=C(C(C(f*z[a+4260>>2])-C(z[a+4268>>2]*z[i>>2]))-C(n*o));z[e>>2]=f;z[i>>2]=n+C(f*o);e=h+j|0;j=v[e>>2];v[e>>2]=j+4;z[j>>2]=f*C(9.313225746154785e-10);k=k+1|0;continue}break}g=g-1|0;continue}else{ti(a,b,c,l,m,d)}break}}kb=h+16|0}function PW(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;g=kb-16|0;kb=g;dd(b,w[c+32|0]|w[c+33|0]<<8|(w[c+34|0]<<16|w[c+35|0]<<24));h=Tb(a);a=w[c+28|0]|w[c+29|0]<<8|(w[c+30|0]<<16|w[c+31|0]<<24);v[23540]=0;R(184,h|0,a|0);a=v[23540];v[23540]=0;if((a|0)!=1){a:{a=0;while(1){b:{if((w[c+28|0]|w[c+29|0]<<8|(w[c+30|0]<<16|w[c+31|0]<<24))>>>0<=a>>>0){break b}e=v[b+8>>2];f=v[b>>2];v[23540]=0;e=W(156,f|0,e|0,4)|0;f=v[23540];v[23540]=0;if((f|0)==1){break a}if(!e){break b}e=w[c+4|0]|w[c+5|0]<<8;v[23540]=0;e=Q(185,b|0,e|0)|0;f=v[23540];v[23540]=0;c:{if((f|0)!=1){v[g+12>>2]=e;if(yd(v[d>>2],v[d+4>>2])>>>0<=e>>>0){break c}v[23540]=0;R(186,h|0,g+12|0);e=v[23540];v[23540]=0;if((e|0)!=1){break c}}break a}a=a+1|0;continue}break}kb=g+16|0;return}}a=P()|0;O()|0;wc(h);T(a|0);L()}function Fp(a){var b=C(0),c=0,d=0,e=0,f=0;c=kb-16|0;kb=c;e=(p(a),j(2));d=e&2147483647;a:{if(d>>>0<=1061752794){b=C(1);if(d>>>0<964689920){break a}b=hi(+a);break a}if(d>>>0<=1081824209){if(d>>>0>=1075235812){b=C(-hi(((e|0)<0?3.141592653589793:-3.141592653589793)+ +a));break a}f=+a;if((e|0)<0){b=ii(f+1.5707963267948966);break a}b=ii(1.5707963267948966-f);break a}if(d>>>0<=1088565717){if(d>>>0>=1085271520){b=hi(((e|0)<0?6.283185307179586:-6.283185307179586)+ +a);break a}if((e|0)<0){b=ii(-4.71238898038469-+a);break a}b=ii(+a+-4.71238898038469);break a}b=C(a-a);if(d>>>0>=2139095040){break a}b:{switch(ax(a,c+8|0)&3){case 0:b=hi(A[c+8>>3]);break a;case 1:b=ii(-A[c+8>>3]);break a;case 2:b=C(-hi(A[c+8>>3]));break a;default:break b}}b=ii(A[c+8>>3])}a=b;kb=c+16|0;return a}function k1(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;c=kb-32|0;kb=c;v[c+28>>2]=0;if(Qd(w[fm(c+24|0,a,0)|0])){d=c+16|0;gd(d,v[v[a>>2]-12>>2]+a|0);v[23540]=0;d=S(1093,d|0)|0;e=v[23540];v[23540]=0;a:{b:{if((e|0)!=1){e=Tm(c+8|0,a);f=Gc(c);g=v[v[a>>2]-12>>2];f=v[f>>2];e=v[e>>2];v[23540]=0;ma(1096,d|0,e|0,f|0,a+g|0,c+28|0,c+20|0);d=v[23540];v[23540]=0;if((d|0)!=1){break b}}b=V(0)|0;O()|0;ac(c+16|0);_(b|0)|0;b=v[c+28>>2]|1;v[c+28>>2]=b;dm(v[v[a>>2]-12>>2]+a|0,b);c:{d:{if(v[(v[v[a>>2]-12>>2]+a|0)+20>>2]&1){v[23540]=0;Z(105);a=v[23540];v[23540]=0;if((a|0)!=1){break c}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)==1){break d}T(a|0);L()}$();break a}V(0)|0;O()|0;Vb()}L()}ac(c+16|0);v[b>>2]=v[c+20>>2]}Ki(v[v[a>>2]-12>>2]+a|0,v[c+28>>2])}kb=c+32|0;return a|0}function pL(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;c=kb-16|0;kb=c;e=v[b+4220>>2];f=v[b+4224>>2];g=v[b+4228>>2];h=v[b+4232>>2];i=v[b+4240>>2];j=v[b+4236>>2];l=w[b+4244|0];k=b+4208|0;Qi(k,33);d=v[k>>2];t[d+32|0]=l;t[d+24|0]=j;t[d+25|0]=j>>>8;t[d+26|0]=j>>>16;t[d+27|0]=j>>>24;t[d+28|0]=i;t[d+29|0]=i>>>8;t[d+30|0]=i>>>16;t[d+31|0]=i>>>24;t[d+16|0]=g;t[d+17|0]=g>>>8;t[d+18|0]=g>>>16;t[d+19|0]=g>>>24;t[d+20|0]=h;t[d+21|0]=h>>>8;t[d+22|0]=h>>>16;t[d+23|0]=h>>>24;t[d+8|0]=e;t[d+9|0]=e>>>8;t[d+10|0]=e>>>16;t[d+11|0]=e>>>24;t[d+12|0]=f;t[d+13|0]=f>>>8;t[d+14|0]=f>>>16;t[d+15|0]=f>>>24;t[d|0]=76;t[d+1|0]=70;t[d+2|0]=79;t[d+3|0]=32;t[d+4|0]=0;t[d+5|0]=0;t[d+6|0]=0;t[d+7|0]=0;re(c+8|0,v[k>>2],v[b+4212>>2]);hc(a,v[c+8>>2],v[c+12>>2]);kb=c+16|0}function XK(a){var b=0,c=0,d=0,e=0;b=kb-16|0;kb=b;e=(p(a),j(2));c=e&2147483647;a:{if(c>>>0<=1061752794){if(c>>>0<964689920){break a}a=ii(+a);break a}if(c>>>0<=1081824209){d=+a;if(c>>>0<=1075235811){if((e|0)<0){a=C(-hi(d+1.5707963267948966));break a}a=hi(d+-1.5707963267948966);break a}a=ii(-(((e|0)>=0?-3.141592653589793:3.141592653589793)+d));break a}if(c>>>0<=1088565717){if(c>>>0<=1085271519){d=+a;if((e|0)<0){a=hi(d+4.71238898038469);break a}a=C(-hi(d+-4.71238898038469));break a}a=ii(((e|0)<0?6.283185307179586:-6.283185307179586)+ +a);break a}if(c>>>0>=2139095040){a=C(a-a);break a}b:{switch(ax(a,b+8|0)&3){case 0:a=ii(A[b+8>>3]);break a;case 1:a=hi(A[b+8>>3]);break a;case 2:a=ii(-A[b+8>>3]);break a;default:break b}}a=C(-hi(A[b+8>>3]))}kb=b+16|0;return a}function pI(a){var b=C(0),c=C(0),d=C(0),e=C(0),f=C(0),g=C(0),h=C(0),i=C(0),j=C(0),k=C(0),l=C(0),m=C(0),n=C(0),o=C(0);f=z[a>>2];i=z[a+24>>2];c=C(f-i);d=z[a+16>>2];b=z[a+32>>2];g=z[a+8>>2];e=C(d+C(b-g));z[a+16>>2]=c+e;j=C(c-C(e*C(.5)));c=z[a+4>>2];e=z[a+20>>2];h=z[a+28>>2];k=C(C(C(c-e)-h)*C(.8660253882408142));z[a+4>>2]=j+k;l=C(C(d-b)*C(.1736481785774231));f=C(f+C(i*C(.5)));i=C(C(g+b)*C(.7660444378852844));m=C(l+C(f-i));n=C(C(c+e)*C(.9848077297210693));b=C(z[a+12>>2]*C(.8660253882408142));c=C(C(c+h)*C(.6427876353263855));o=C(C(n-b)-c);z[a+12>>2]=m+o;z[a+20>>2]=m-o;z[a+28>>2]=j-k;d=C(C(g+d)*C(.9396926164627075));g=C(C(f+d)-l);e=C(C(e-h)*C(.3420201539993286));h=C(C(e-b)-n);z[a+32>>2]=g+h;d=C(C(f-d)+i);b=C(C(b+e)-c);z[a+24>>2]=d+b;z[a+8>>2]=d-b;z[a>>2]=g-h}function oN(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;a:{f=kb-16|0;kb=f;e=Nb(a);d=Tj(b);v[f+8>>2]=d;g=wv(b);a=0;b:{while(1){c:{if(!Pb(d,g)){if(!a){break c}v[23540]=0;R(49,e|0,65533);a=v[23540];v[23540]=0;if((a|0)!=1){break c}break b}b=w[d|0];d:{e:{if(!a){if(!(b&128)){a=0;v[23540]=0;R(49,e|0,b|0);b=v[23540];v[23540]=0;if((b|0)!=1){break d}break b}if((b&224)==192){c=b&31;a=1;break d}if((b&240)==224){c=b&15;a=2;break d}c=65533;if((b&248)!=240){break e}c=b&7;a=3;break d}if((b&192)!=128){c=0;v[23540]=0;R(49,e|0,65533);d=v[23540];v[23540]=0;a=0;if((d|0)==1){break b}}c=b&63|c<<6;a=a-1|0;if(a){break d}}a=0;v[23540]=0;R(49,e|0,c|0);b=v[23540];v[23540]=0;c=0;if((b|0)==1){break b}}d=v[Ke(f+8|0)>>2];continue}break}kb=f+16|0;break a}a=P()|0;O()|0;Nc(e);T(a|0);L()}}function W_(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;k=kb-16|0;kb=k;a:{if(a){a=bG(c);b:{if(b){Rk(k,a);b=v[k>>2];t[d|0]=b;t[d+1|0]=b>>>8;t[d+2|0]=b>>>16;t[d+3|0]=b>>>24;Qk(k,a);break b}Mr(k,a);b=v[k>>2];t[d|0]=b;t[d+1|0]=b>>>8;t[d+2|0]=b>>>16;t[d+3|0]=b>>>24;Ph(k,a)}Ui(i,k);Nc(k);l=e,m=_i(a),v[l>>2]=m;l=f,m=$i(a),v[l>>2]=m;bh(k,a);Bc(g,k);zb(k);Qh(k,a);Ui(h,k);Nc(k);a=Pk(a);break a}a=aG(c);c:{if(b){Rk(k,a);b=v[k>>2];t[d|0]=b;t[d+1|0]=b>>>8;t[d+2|0]=b>>>16;t[d+3|0]=b>>>24;Qk(k,a);break c}Mr(k,a);b=v[k>>2];t[d|0]=b;t[d+1|0]=b>>>8;t[d+2|0]=b>>>16;t[d+3|0]=b>>>24;Ph(k,a)}Ui(i,k);Nc(k);l=e,m=_i(a),v[l>>2]=m;l=f,m=$i(a),v[l>>2]=m;bh(k,a);Bc(g,k);zb(k);Qh(k,a);Ui(h,k);Nc(k);a=Pk(a)}v[j>>2]=a;kb=k+16|0}function SX(a){a=a|0;var b=0,c=0,d=0,e=0;c=kb-192|0;kb=c;b=c+16|0;qi(b,a);v[23540]=0;R(88,c+32|0,b|0);a=v[23540];v[23540]=0;a:{b:{c:{d:{e:{if((a|0)!=1){v[23540]=0;a=Q(89,c+48|0,c+32|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break e}zb(c+32|0);zb(c+16|0);b=v[v[a>>2]-12>>2];v[23540]=0;d=ga(62)|0;e=v[23540];v[23540]=0;if((e|0)==1){break c}v[23540]=0;U(63,c+8|0,a+b|0,d|0);b=v[23540];v[23540]=0;if((b|0)==1){break c}ac(c+8|0);b=a+v[v[a>>2]-12>>2]|0;v[b+4>>2]=v[b+4>>2]&-75;v[b+4>>2]=v[b+4>>2]|8;v[23540]=0;b=Q(95,a|0,c+32|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break c}a=Yk(v[(b+v[v[b>>2]-12>>2]|0)+16>>2]);d=v[c+32>>2];sf(b);kb=c+192|0;a=a?0:d;break a}b=P()|0;O()|0;break d}b=P()|0;O()|0;zb(c+32|0)}zb(c+16|0);break b}b=P()|0;O()|0;sf(a)}T(b|0);L()}return a|0}function __(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;k=kb-16|0;kb=k;a:{if(a){a=eG(c);b:{if(b){Rk(k,a);b=v[k>>2];t[d|0]=b;t[d+1|0]=b>>>8;t[d+2|0]=b>>>16;t[d+3|0]=b>>>24;Qk(k,a);break b}Mr(k,a);b=v[k>>2];t[d|0]=b;t[d+1|0]=b>>>8;t[d+2|0]=b>>>16;t[d+3|0]=b>>>24;Ph(k,a)}Bc(i,k);zb(k);l=e,m=_i(a),t[l|0]=m;l=f,m=$i(a),t[l|0]=m;bh(k,a);Bc(g,k);zb(k);Qh(k,a);Bc(h,k);zb(k);a=Pk(a);break a}a=dG(c);c:{if(b){Rk(k,a);b=v[k>>2];t[d|0]=b;t[d+1|0]=b>>>8;t[d+2|0]=b>>>16;t[d+3|0]=b>>>24;Qk(k,a);break c}Mr(k,a);b=v[k>>2];t[d|0]=b;t[d+1|0]=b>>>8;t[d+2|0]=b>>>16;t[d+3|0]=b>>>24;Ph(k,a)}Bc(i,k);zb(k);l=e,m=_i(a),t[l|0]=m;l=f,m=$i(a),t[l|0]=m;bh(k,a);Bc(g,k);zb(k);Qh(k,a);Bc(h,k);zb(k);a=Pk(a)}v[j>>2]=a;kb=k+16|0}function fp(a,b,c){var d=0,e=0,f=0,g=0,h=0;d=kb-32|0;kb=d;v[d+28>>2]=0;a:{b:{c:{if(Qd(w[fm(d+24|0,a,0)|0])){f=d+16|0;gd(f,v[v[a>>2]-12>>2]+a|0);v[23540]=0;f=S(1093,f|0)|0;e=v[23540];v[23540]=0;d:{e:{if((e|0)==1){break e}e=Tm(d+8|0,a);g=Gc(d);h=v[v[a>>2]-12>>2];g=v[g>>2];e=v[e>>2];v[23540]=0;ma(c|0,f|0,e|0,g|0,a+h|0,d+28|0,b|0);b=v[23540];v[23540]=0;if((b|0)==1){break e}ac(d+16|0);break d}b=V(0)|0;O()|0;ac(d+16|0);_(b|0)|0;b=v[d+28>>2]|1;v[d+28>>2]=b;dm(v[v[a>>2]-12>>2]+a|0,b);if(v[(v[v[a>>2]-12>>2]+a|0)+20>>2]&1){v[23540]=0;Z(105);a=v[23540];v[23540]=0;if((a|0)!=1){break b}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)==1){break c}T(a|0);L()}$()}Ki(v[v[a>>2]-12>>2]+a|0,v[d+28>>2])}kb=d+32|0;break a}V(0)|0;O()|0;Vb()}L()}return a}function YR(a){var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;while(1){if((c|0)!=20){g=b;b=t[a+c|0];b=g+((b&255)!=0&(b|0)<32)|0;c=c+1|0;continue}break}d=b;a:{if(b>>>0>5){break a}while(1){if((h|0)!=15){e=B(h,30)+a|0;f=e+20|0;c=0;b=0;while(1){if((c|0)!=22){g=b;b=t[c+f|0];b=g+((b&255)!=0&(b|0)<32)|0;c=c+1|0;continue}break}d=b+d|0;if(d>>>0>48){break a}c=w[e+45|0];if(w[e+44|0]|c>>>0>64){break a}b=Ib(w[e+42|0]|w[e+43|0]<<8);if(b>>>0>32768){break a}h=h+1|0;i=c|i;j=b+j|0;continue}break}if(!j|!(i&255)){break a}d=w[a+470|0];if(d>>>0>128){break a}b=w[a+471|0];if(b>>>0>220){break a}a=a+472|0;f=gA(a);b:{if((a|0)==(f|0)){break b}c=a;while(1){c=c+1|0;if((f|0)==(c|0)){break b}a=Lr(w[a|0],w[c|0])?c:a;continue}}a=w[a|0];if(a>>>0>63){break a}k=(b|(a|d))!=0}return k}function Tga(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=kb-16|0;kb=e;t[e+15|0]=0;u[e+12>>1]=0;j=8;n=B(c,d)<<1;while(1){if((d|0)!=(k|0)){g=(k<<1)+b|0;o=n+g|0;while(1){if(g>>>0<o>>>0){u[e+10>>1]=0;pS(a,e+15|0,e+12|0,j,e+10|0);h=x[e+10>>1];c=j;while(1){a:{if(!(c&255)){break a}f=x[e+12>>1]<<1;i=f&254;u[e+12>>1]=i;if(i){f=(f&65534)>>>0>255}else{if(!nf(a,e+9|0)){break a}f=w[e+9|0];u[e+12>>1]=f<<1&254|1;f=f>>>7|0}c=c-1|0;h=f|h<<1;continue}break}c=1;i=h&65535;b:{if(i>>>0<4){break b}f=15;while(1){c=f;m=f&255;if(i>>>m&1){break b}f=c-1|0;if(m>>>0>1){continue}break}}f=h&1;t[e+15|0]=f;l=(f-1^(h&65534)>>>1)+l|0;u[e+10>>1]=l;u[g>>1]=l;g=(d<<1)+g|0;j=(c+j&254)>>>1|0;continue}break}k=k+1|0;continue}break}kb=e+16|0}function Fy(a,b,c,d){var e=0,f=0,g=0,h=0;e=kb-16|0;kb=e;a:{if(!d){break a}if(c){t[b+815|0]=c;break a}c=w[b+815|0]}f=v[a+480180>>2];d=f&1048580;c=d?(c&240?-16:15)&c:c;b:{c:{d:{if(!d){d=c&240;e:{f:{g:{h:{c=c&15;if((c|0)==15){a=v[a+480208>>2]&4096;if(!d){break h}if(!a){break b}a=0-(d>>>2|0)|0;break d}a=v[a+480208>>2]&4096;if(!c|(d|0)!=240){break g}if(!a){break b}c=c<<2;break c}d=0;if(!a){break f}break b}if(a){break b}if(!c){break e}}c=c<<2;if(!(f&16777248)|!d){break c}break b}a=0-(d>>>2|0)|0;break d}if(w[a+480209|0]&16){break b}Db(e+8|0,a+1074312|0,56);a=c&240;a=a?a>>>2|0:0-(c<<2&60)|0;if(!Cb(v[v[e+8>>2]>>2],v[e+12>>2])){break d}a=(a|0)/4<<24>>24}c=a;if(!c){break b}}a=v[b+692>>2];u[b+784>>1]=0;g=b,h=Zb(a+c|0,0,256),v[g+692>>2]=h}kb=e+16|0}function dq(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0,k=0;h=kb-16|0;kb=h;f=v[a>>2];e=v[a+4>>2];i=$d(f,e)-1|0;while(1){a:{b:{if($d(f,e)-1>>>0<=g>>>0){g=i;break b}if(x[Pc(f,e,g)>>1]<(b|0)){break a}e=v[a+4>>2];f=v[a>>2]}i=x[Pc(f,e,g)>>1];f=0;v[h+12>>2]=0;c:{if((b|0)>=(i|0)){j=h,k=(w[Pc(v[a>>2],v[a+4>>2],g)+2|0]<<16)/(d|0)|0,v[j+12>>2]=k;break c}e=0;if(g){e=g-1|0;f=(w[Pc(v[a>>2],v[a+4>>2],e)+2|0]<<16)/(d|0)|0;v[h+12>>2]=f;e=x[Pc(v[a>>2],v[a+4>>2],e)>>1]}if((b|0)<=(e|0)|e>>>0>=i>>>0){break c}a=((w[Pc(v[a>>2],v[a+4>>2],g)+2|0]<<16)/(d|0)|0)-f|0;d=a;g=a>>31;a=b-e|0;b=Jka(d,g,a,a>>31);a=i-e|0;j=h,k=Hc(Kka(b,nb,a,a>>31),nb)+f|0,v[j+12>>2]=k}oe(h+12|0,0,65536);kb=h+16|0;return(B(v[h+12>>2],c)+32768|0)/65536|0}g=g+1|0;e=v[a+4>>2];f=v[a>>2];continue}}function Kaa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=kb-48|0;kb=e;g=Mc(b);d=Hb(b);i=Mc(c);h=Hb(c);d=d+g|0;f=-1;a:{while(1){if((d|0)==(g|0)){break a}d=d-1|0;if(Gp(i,h,w[d|0])){continue}break}f=d-g|0}b:{c:{if((f|0)!=-1){k=e,l=he(b),v[k+16>>2]=l;k=e,l=Jp(e+16|0,f),v[k+24>>2]=l;k=e,l=Jp(e+24|0,1),v[k+32>>2]=l;c=kj(e+40|0,e+32|0);k=e,l=yh(b),v[k>>2]=l;d=kj(e+8|0,e);JL(b,v[c>>2],v[d>>2]);break c}if(!Hb(b)){break c}g=Mc(b);d=Hb(b);i=Mc(c);h=Hb(c);if(!d|!h){c=-1}else{c=g;f=d+c|0;h=h+i|0;while(1){d:{d=i;e:{if((c|0)!=(f|0)){while(1){if((d|0)==(h|0)){break e}j=t[d|0];d=d+1|0;if(!pc(t[c|0],j)){continue}break}}else{c=f}break d}c=c+1|0;continue}break}c=(c|0)==(f|0)?-1:c-g|0}if(c){break c}Nb(a);break b}ad(a,b)}kb=e+48|0}function Ep(a){var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,k=0,m=0;o(+a);b=j(1)|0;d=j(0)|0;a:{b:{c:{d:{if((b|0)>0|(b|0)>=0){f=b;if(b>>>0>1048575){break d}}if(!(b&2147483647|d)){return-1/(a*a)}if((b|0)>0|(b|0)>=0){break c}return(a-a)/0}if(f>>>0>2146435071){break a}b=1072693248;g=-1023;if((f|0)!=1072693248){b=f;break b}if(d){break b}return 0}o(+(a*0x40000000000000));b=j(1)|0;d=j(0)|0;g=-1077}b=b+614242|0;h=+((b>>>20|0)+g|0);e=h*.6931471803691238;l(0,d|0);l(1,(b&1048575)+1072079006|0);a=+n()+-1;c=a/(a+2);i=e;k=a;m=c;e=a*(a*.5);c=c*c;a=c*c;a=i+(k+(m*(e+(a*(a*(a*.15313837699209373+.22222198432149784)+.3999999999940942)+c*(a*(a*(a*.14798198605116586+.1818357216161805)+.2857142874366239)+.6666666666666735)))+h*1.9082149292705877e-10-e))}return a}function BC(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;g=kb-16|0;kb=g;e=v[b>>2];d=Rc(e,v[b+4>>2]);a:{if(d>>>0<c>>>0){i=kb-32|0;kb=i;d=c-d|0;f=v[Gb(b)>>2];e=v[b+4>>2];b:{if(d>>>0<=f-e>>1>>>0){f=kb-16|0;kb=f;e=ai(f,b,d);d=v[e+4>>2];h=v[e+8>>2];while(1){if((d|0)==(h|0)){lc(e);kb=f+16|0}else{Io(d);d=d+2|0;v[e+4>>2]=d;continue}break}break b}f=Gb(b);e=Nj(i+8|0,Oj(b,Rc(v[b>>2],e)+d|0),Rc(v[b>>2],v[b+4>>2]),f);h=kb-16|0;kb=h;d=Qo(h,e+8|0,d);f=v[d>>2];while(1){if(v[d+4>>2]!=(f|0)){Io(f);f=v[d>>2]+2|0;v[d>>2]=f;continue}break}Ud(d);kb=h+16|0;Fd(b,e);Ni(e)}kb=i+32|0;break a}if(c>>>0<d>>>0){Od(b,e+(c<<1)|0)}}c=Qb(v[a>>2],v[a+8>>2],c<<1);if(c){d=v[b>>2];gc(g+8|0,d,Rc(d,v[b+4>>2])<<1);ud(g,a,v[g+8>>2],v[g+12>>2])}kb=g+16|0;return c|0}function dl(a,b,c){var d=0,e=0,f=0,g=0;e=kb-48|0;kb=e;d=v[a+24>>2];g=v[d+24620>>2];a:{if(!((g|0)==(b|0)&v[d+24624>>2]==(c|0))){f=e+8|0;sc(f,d+24604|0,40);v[e+28>>2]=c;v[e+24>>2]=b;c=v[e+44>>2];Bs(f,v[e+40>>2]);eo(f,c);sy(d,f);if((b|0)==(g|0)){break a}c=v[a+24>>2]+906300|0;d=gk(c);while(1){if((c|0)!=(d|0)){b=v[c>>2];b:{if(!b){break b}if(!(ob[v[v[b>>2]+120>>2]](b)|0)){break b}ob[v[v[b>>2]+112>>2]](b,0);ob[v[v[b>>2]+100>>2]](b);ob[v[v[b>>2]+128>>2]](b)}c=c+160|0;continue}break}c=v[a+24>>2]+906300|0;d=gk(c);while(1){if((c|0)!=(d|0)){b=v[c>>2];c:{if(!b){break c}if(ob[v[v[b>>2]+120>>2]](b)|0){break c}ob[v[v[b>>2]+112>>2]](b,1);ob[v[v[b>>2]+124>>2]](b)}c=c+160|0;continue}break}break a}if(w[a+29|0]){break a}wM(d,1)}t[a+29|0]=1;kb=e+48|0}function mca(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;g=kb-48|0;kb=g;h=a+8|0;c=v[a+8>>2];j=Cc(a);a:{if((c|0)!=v[j>>2]){break a}i=a+4|0;d=v[a+4>>2];e=v[a>>2];if(d>>>0>e>>>0){a=((d-e>>2)+1|0)/-2<<2;c=Oi(d,c,a+d|0);v[h>>2]=c;v[i>>2]=a+v[i>>2];break a}v[g+24>>2]=c-e>>1;v[g+44>>2]=1;d=g+24|0;c=v[_c(d,g+44|0)>>2];c=Vf(d,c,c>>>2|0,v[a+16>>2]);e=fc(g+16|0,v[a+4>>2]);f=v[fc(g+8|0,v[a+8>>2])>>2];d=kb-32|0;kb=d;e=v[e>>2];v[d+24>>2]=e;e=Xm(d+8|0,c+8|0,au(f,e));f=v[e>>2];while(1){if(v[e+4>>2]!=(f|0)){k=f;f=v[d+24>>2];Im(k,x[f>>1]|x[f+2>>1]<<16);f=v[e>>2]+4|0;v[e>>2]=f;Le(d+24|0);continue}break}Ud(e);kb=d+32|0;qc(a,c);qc(i,c+4|0);qc(h,c+8|0);qc(j,Cc(c));Uf(c);c=v[a+8>>2]}Im(c,x[b>>1]|x[b+2>>1]<<16);v[h>>2]=v[h>>2]+4;kb=g+48|0}function Sga(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=kb-16|0;kb=e;t[e+15|0]=0;u[e+12>>1]=0;n=B(c,d);j=4;a:while(1){if((d|0)!=(k|0)){h=b+k|0;o=n+h|0;while(1){b:{c:{if(h>>>0<o>>>0){t[e+11|0]=0;oS(a,e+15|0,e+12|0,e+11|0);i=w[e+11|0];f=x[e+12>>1];c=j;while(1){if(c&255){g=f<<1;f=g&254;d:{if(f){g=(g&65534)>>>0>255;break d}if(!nf(a,e+10|0)){break c}f=w[e+10|0];g=f>>>7|0;f=f<<1&254|1}c=c-1|0;i=i<<1|g;continue}break}u[e+12>>1]=f;break b}k=k+1|0;continue a}u[e+12>>1]=0}c=1;g=i&255;e:{if(g>>>0<4){break e}f=7;while(1){c=f;m=f&255;if(g>>>m&1){break e}f=c-1|0;if(m>>>0>1){continue}break}}f=i&1;t[e+15|0]=f;l=(f-1^(i&254)>>>1)+l|0;t[e+11|0]=l;t[h|0]=l;h=d+h|0;j=(c+j&254)>>>1|0;continue}}break}kb=e+16|0}function D3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=kb-80|0;kb=d;a=v[a+4>>2];Vv(d+16|0,b);v[23540]=0;b=Q(1,d|0,17803)|0;e=v[23540];v[23540]=0;a:{b:{c:{d:{e:{f:{g:{h:{if((e|0)!=1){v[23540]=0;U(2,d+32|0,d+16|0,b|0);e=v[23540];v[23540]=0;if((e|0)==1){break h}v[23540]=0;U(477,d+48|0,d+32|0,c|0);c=v[23540];v[23540]=0;if((c|0)==1){break g}v[23540]=0;R(1009,d- -64|0,d+48|0);c=v[23540];v[23540]=0;if((c|0)==1){break f}c=v[v[a>>2]+8>>2];v[23540]=0;R(c|0,a|0,d- -64|0);a=v[23540];v[23540]=0;if((a|0)==1){break e}zb(d- -64|0);Ab(d+48|0);Ab(d+32|0);Ab(b);Ab(d+16|0);kb=d+80|0;return}a=P()|0;O()|0;break a}a=P()|0;O()|0;break b}a=P()|0;O()|0;break c}a=P()|0;O()|0;break d}a=P()|0;O()|0;zb(d- -64|0)}Ab(d+48|0)}Ab(d+32|0)}Ab(b)}Ab(d+16|0);T(a|0);L()}function CE(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0,k=0;h=kb-32|0;kb=h;f=of(h+16|0,1,0);a:{b:{while(1){j=h+8|0;e=Ac(f);g=e;i=Hb(f)+e|0;e=w[b|0];c:{if((c|0)==10){aK(j,g,i,e);break c}k=c>>>0>e>>>0?1:B(c,c)>>>0>e>>>0?2:3;if((k|0)>(i-g|0)){v[j+4>>2]=61;v[j>>2]=i;break c}i=g+k|0;g=i;while(1){k=e&255;e=(k|0)/(c|0)|0;g=g-1|0;t[g|0]=w[(k-B(c,e)|0)+4898|0];if(e&255){continue}break}v[j+4>>2]=0;v[j>>2]=i}if(!v[h+12>>2]){break b}e=ch(Hb(f));v[23540]=0;R(59,f|0,e|0);e=v[23540];v[23540]=0;if((e|0)!=1){continue}break}break a}b=v[h+8>>2];c=Ac(f);v[23540]=0;R(60,f|0,b-c|0);b=v[23540];v[23540]=0;d:{if((b|0)!=1){v[23540]=0;R(d|0,a|0,f|0);a=v[23540];v[23540]=0;if((a|0)!=1){break d}break a}break a}zb(f);kb=h+32|0;return}a=P()|0;O()|0;zb(f);T(a|0);L()}function MM(a,b){var c=C(0),d=C(0),e=C(0);a:{b:{c:{switch(b|0){case 0:Mp(a,C(1));fk(a,C(3.725290298461914e-9));Lp(a,C(268435456));Kp(a,0);break b;case 1:Mp(a,C(32));fk(a,C(4.656612873077393e-10));Lp(a,C(2147483648));Kp(a,0);break b;case 2:Mp(a,C(2));fk(a,C(7.450580596923828e-9));Lp(a,C(134217728));Kp(a,1);break b;default:Mp(a,C(1));fk(a,C(7.450580596923828e-9));Lp(a,C(134217728));Kp(a,1);ky(a,0);jy(a,1);iy(a,1);d=C(256);c=C(128);e=C(128);b=0;break a;case 4:case 5:break c}}Mp(a,C(.75));fk(a,C(7.450580596923828e-9));Lp(a,C(134217728));Kp(a,1);ky(a,0);b=(b|0)==4;jy(a,b?2:3);iy(a,1);d=C(256);c=b?C(256):C(192);e=c;b=1;break a}ky(a,1);jy(a,0);iy(a,0);d=C(128);e=C(100);c=C(256);b=4}z[a+16>>2]=c;z[a+20>>2]=e;z[a+24>>2]=d;v[a+28>>2]=b}function eS(a,b,c,d,e,f,g){var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;o=v[b>>2];while(1){if((i|0)==128){vg(b,c);c=v[a+8>>2];d=c+d|0;i=x[e>>1];a:{b:{c:{if(!f){break c}j=f;f=h&65535;if((c+(j+(f<<11)|0)|0)!=(Vg(v[a>>2])&-2)){break c}dd(a,c+(f<<10)|0);if(!lA(a,16,1)){break b}u[e>>1]=8;break b}if((h&65535)==(k&65535)){h=k;break a}f=k<<8&16776960;if(!g){if((Vg(v[a>>2])|0)!=(d+B(f,i)|0)){break a}}dd(a,c+B(f,x[e>>1])|0);h=lA(a,64,1)?h:k}dd(a,c)}c=l&65535;d:{if(c>>>0>(h&65535)>>>0){if((d+(B(c,x[e>>1])<<8)|0)==(Vg(v[a>>2])|0)){break d}}if(c>>>0>=255){kA(b,254,65534);kA(b,255,65535)}l=h}a=l&65535}else{j=x[cc(o,i)>>1];m=j+1|0;n=(h&65535)>>>0>j>>>0|j>>>0>127;k=n?k:c>>>0>i>>>0?m:k;l=(l&65535)>>>0>j>>>0?l:m;h=n?h:m;i=i+1|0;continue}break}return a}function Xn(a,b,c,d,e){var f=0,g=0,h=0,i=0,j=0,k=0;g=kb-16|0;kb=g;if(e){v[e>>2]=0}a:{h=v[a+484344>>2];if(!xe(h,v[a+484348>>2],b)){break a}i=_b(h,b);k=v[i+48>>2];b=jd(v[i>>2],v[k+12>>2],c,d);f=w[b+5|0];b:{c:{d:{e:{j=w[b+3|0];switch(j-10|0){case 1:case 3:case 5:case 6:break a;case 0:break c;case 2:case 4:case 7:break d;default:break e}}if(j-35>>>0>=2){break a}}v[g+12>>2]=1;h=0;if((j|0)!=17){break b}h=v[a+480180>>2]==4;break b}v[g+12>>2]=2;h=0}v[g+8>>2]=v[i+12>>2]+(c^-1);d=0;c=v[Kb(g+8|0,g+12|0)>>2];a=c;while(1){f:{if(a){b=B(Og(v[k+12>>2]),6)+b|0;if(w[b+3|0]==34){break f}c=d}f=(j-37&255)>>>0<254?f:c?f:f<<8;if(!e){break a}v[e>>2]=c;break a}i=f<<8;f=w[b+5|0]|(h?f>>>0<256?i+-8192|0:i:i);d=d+1|0;a=a-1|0;continue}}kb=g+16|0;return f}function NH(a,b,c,d){a:{switch(b-9|0){case 0:b=v[c>>2];v[c>>2]=b+4;v[a>>2]=v[b>>2];return;case 6:b=v[c>>2];v[c>>2]=b+4;b=u[b>>1];v[a>>2]=b;v[a+4>>2]=b>>31;return;case 7:b=v[c>>2];v[c>>2]=b+4;v[a>>2]=x[b>>1];v[a+4>>2]=0;return;case 8:b=v[c>>2];v[c>>2]=b+4;b=t[b|0];v[a>>2]=b;v[a+4>>2]=b>>31;return;case 9:b=v[c>>2];v[c>>2]=b+4;v[a>>2]=w[b|0];v[a+4>>2]=0;return;case 16:b=v[c>>2]+7&-8;v[c>>2]=b+8;A[a>>3]=A[b>>3];return;case 17:ob[d|0](a,c);default:return;case 1:case 4:case 14:b=v[c>>2];v[c>>2]=b+4;b=v[b>>2];v[a>>2]=b;v[a+4>>2]=b>>31;return;case 2:case 5:case 11:case 15:b=v[c>>2];v[c>>2]=b+4;v[a>>2]=v[b>>2];v[a+4>>2]=0;return;case 3:case 10:case 12:case 13:break a}}b=v[c>>2]+7&-8;v[c>>2]=b+8;c=v[b+4>>2];v[a>>2]=v[b>>2];v[a+4>>2]=c}function yea(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;c=kb+-64|0;kb=c;a:{d=v[a+4>>2];b:{if(d>>>0<b>>>0){f=ee(c+56|0);e=b-d|0;g=Bt(a);c:{if(!(e>>>0>g>>>0|d>>>0>g-e>>>0)){Cm(c+40|0,v[a>>2],d);hc(f,v[c+40>>2],v[c+44>>2]);v[a+4>>2]=v[a+4>>2]+e;break c}d=io(c+40|0);v[23540]=0;b=Q(728,a|0,b|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break a}v[23540]=0;R(729,d|0,b|0);b=v[23540];v[23540]=0;if((b|0)==1){break a}v[d+4>>2]=v[a+4>>2]+e;tl(c+24|0,v[a>>2]);Cm(c+16|0,v[a>>2],v[a+4>>2]);tl(c+8|0,v[d>>2]);nR(c+32|0,v[c+24>>2],v[c+28>>2],v[c+16>>2],v[c+20>>2],v[c+8>>2],v[c+12>>2]);hc(f,v[c+32>>2],v[c+36>>2]);Kt(a,d);We(d)}a=hc(c,v[f>>2],v[f+4>>2]);ov(v[a>>2],v[a+4>>2],e,0);break b}v[a+4>>2]=b}kb=c- -64|0;return}a=P()|0;O()|0;We(d);T(a|0);L()}function oL(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=C(0);c=kb-80|0;kb=c;d=v[b>>2];e=v[b+4>>2];b=ee(c+48|0);b=qr(c+56|0,d,e,v[b>>2],v[b+4>>2]);v[23540]=0;d=S(202,b|0)|0;e=v[23540];v[23540]=0;a:{if((e|0)==1){break a}v[23540]=0;d=W(905,b|0,c+8|0,d|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break a}b:{if(!d){break b}if(Sb(c+8|0,17657,4)|v[c+12>>2]){break b}f=a,g=Yd(z[c+16>>2],C(0)),z[f+4220>>2]=g;f=a,g=Yd(z[c+20>>2],C(0)),z[f+4224>>2]=g;f=a,g=Yd(z[c+24>>2],C(0)),z[f+4228>>2]=g;d=v[c+28>>2];if(d>>>0<=5){v[a+4232>>2]=d}v[a+4236>>2]=v[c+32>>2];t[a+4240|0]=w[c+36|0]!=0;t[a+4241|0]=w[c+37|0]!=0;t[a+4242|0]=w[c+38|0]!=0;t[a+4243|0]=w[c+39|0]!=0;t[a+4244|0]=w[c+40|0]!=0;Rs(a)}Bb(b);kb=c+80|0;return}a=P()|0;O()|0;Bb(b);T(a|0);L()}function L6(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;f=kb-48|0;kb=f;v[f+40>>2]=d;d=eg(a,f+40|0);g=Gc(d+4|0);h=Gc(d+24|0);i=Gc(d+32|0);j=Tb(d+36|0);v[d+56>>2]=3;k=Tb(d+68|0);v[23540]=0;R(941,d|0,e|0);a=v[23540];v[23540]=0;a:{b:{c:{d:{if((a|0)!=1){gc(f+8|0,b,c);a=ee(f);b=v[a+4>>2];c=v[a>>2];v[23540]=0;Ia(945,f+16|0,v[f+8>>2],v[f+12>>2],c|0,b|0);a=v[23540];v[23540]=0;if((a|0)==1){break d}v[23540]=0;U(942,d|0,f+16|0,e|0);a=v[23540];v[23540]=0;if((a|0)==1){break c}Bb(f+16|0);v[23540]=0;Y(943,d|0);a=v[23540];v[23540]=0;if((a|0)!=1){break a}}e=P()|0;O()|0;break b}e=P()|0;O()|0;break b}e=P()|0;O()|0;Bb(f+16|0)}Xe(k);Xf(j);As(i);ij(h);hj(g);De(d);De(f+40|0);T(e|0);L()}De(f+40|0);kb=f+48|0;return d|0}function Jea(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;g=kb-16|0;kb=g;e=v[b>>2];d=rg(e,v[b+4>>2]);a:{if(d>>>0<c>>>0){i=kb-32|0;kb=i;d=c-d|0;f=v[Gb(b)>>2];e=v[b+4>>2];b:{if(d>>>0<=f-e>>5>>>0){f=kb-16|0;kb=f;e=Nz(f,b,d);d=v[e+4>>2];h=v[e+8>>2];while(1){if((d|0)==(h|0)){lc(e);kb=f+16|0}else{bQ(d);d=d+32|0;v[e+4>>2]=d;continue}break}break b}f=Gb(b);e=Ct(i+8|0,gq(b,rg(v[b>>2],e)+d|0),rg(v[b>>2],v[b+4>>2]),f);h=kb-16|0;kb=h;d=cQ(h,e+8|0,d);f=v[d>>2];while(1){if(v[d+4>>2]!=(f|0)){bQ(f);f=v[d>>2]+32|0;v[d>>2]=f;continue}break}Ud(d);kb=h+16|0;Fd(b,e);dQ(e)}kb=i+32|0;break a}if(c>>>0<d>>>0){Od(b,e+(c<<5)|0)}}if(Qb(v[a>>2],v[a+8>>2],c<<5)){c=v[b>>2];gc(g+8|0,c,rg(c,v[b+4>>2])<<5);ud(g,a,v[g+8>>2],v[g+12>>2])}kb=g+16|0}function S6(){var a=0,b=0,c=0,d=0,e=0,f=0,g=0;b=kb-48|0;kb=b;c=Nb(b+32|0);v[23540]=0;Y(934,b+16|0);a=v[23540];v[23540]=0;a:{b:{c:{d:{if((a|0)!=1){f=b,g=Fb(v[b+16>>2]),v[f+8>>2]=g;d=1;while(1){e=Fb(v[b+20>>2]);a=v[b+8>>2];if(!Pb(a,e)){a=gg(Mc(c));Xe(b+16|0);zb(c);break b}if(!d){v[23540]=0;Q(935,c|0,14644)|0;a=v[23540];v[23540]=0;if((a|0)==1){break d}a=v[b+8>>2]}v[23540]=0;Q(800,c|0,a|0)|0;a=v[23540];v[23540]=0;if((a|0)==1){break d}oq(b+8|0);d=0;continue}}a=V(0)|0;O()|0;break c}a=V(0)|0;O()|0;Xe(b+16|0)}zb(c);_(a|0)|0;a=0;v[23540]=0;X(933,6988,0,0,0);c=v[23540];v[23540]=0;if((c|0)==1){break a}$()}kb=b+48|0;return a|0}b=P()|0;O()|0;v[23540]=0;Z(18);a=v[23540];v[23540]=0;if((a|0)==1){V(0)|0;O()|0;Vb();L()}T(b|0);L()}function RX(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;h=kb-16|0;kb=h;f=sd(b);d=Ad(v[b+4>>2],w[b+11|0]);i=sd(c);g=Ad(v[c+4>>2],w[c+11|0]);d=d+f|0;e=-1;a:{while(1){if((d|0)==(f|0)){break a}d=d-1|0;if(nu(i,g,w[d|0])){continue}break}e=d-f|0}b:{c:{if((e|0)!=-1){c=fc(h+8|0,Rf(Rf(Tj(b),e),1));d=fc(h,wv(b));rD(b,v[c>>2],v[d>>2]);break c}if(!Gk(v[b+4>>2],w[b+11|0])){break c}f=sd(b);d=Ad(v[b+4>>2],w[b+11|0]);i=sd(c);g=Ad(v[c+4>>2],w[c+11|0]);if(!d|!g){c=-1}else{c=f;e=d+c|0;g=g+i|0;while(1){d:{d=i;e:{if((c|0)!=(e|0)){while(1){if((d|0)==(g|0)){break e}j=w[d|0];d=d+1|0;if(!pc(w[c|0],j)){continue}break}}else{c=e}break d}c=c+1|0;continue}break}c=(c|0)==(e|0)?-1:c-f|0}if(c){break c}Nb(a);break b}ad(a,b)}kb=h+16|0}function iaa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;f=kb-32|0;kb=f;c=Og(v[v[a+48>>2]+12>>2]);a:{if(!b){break a}c=B(b,c);b:{if(v[a+12>>2]!=(b|0)){break b}if((qk(v[a>>2],v[a+4>>2])|0)!=(c|0)){break b}b=kb-16|0;kb=b;d=Fb(v[a>>2]);a=Fb(v[a+4>>2]);Fj(b+8|0);e=Ws(a,d);c=kb-16|0;kb=c;v[c+8>>2]=d;while(1){if((e|0)>0){a=v[c+8>>2];d=w[b+8|0]|w[b+9|0]<<8|(w[b+10|0]<<16|w[b+11|0]<<24);t[a|0]=d;t[a+1|0]=d>>>8;t[a+2|0]=d>>>16;t[a+3|0]=d>>>24;d=w[b+12|0]|w[b+13|0]<<8;t[a+4|0]=d;t[a+5|0]=d>>>8;e=e-1|0;Ck(c+8|0);continue}break}kb=c+16|0;kb=b+16|0;break a}e=f+8|0;Fj(e);c=wT(f+16|0,c,e);YL(a);v[a>>2]=v[c>>2];v[a+4>>2]=v[c+4>>2];e=Gb(c);g=Gb(a),h=v[e>>2],v[g>>2]=h;v[e>>2]=0;v[c>>2]=0;v[c+4>>2]=0;vk(c);v[a+12>>2]=b}kb=f+32|0}function XG(a,b,c,d,e,f){var g=0;g=kb-80|0;kb=g;a:{if((f|0)>=16384){Jd(g+32|0,b,c,d,e,0,0,0,2147352576);d=v[g+40>>2];e=v[g+44>>2];b=v[g+32>>2];c=v[g+36>>2];if(f>>>0<32767){f=f-16383|0;break a}Jd(g+16|0,b,c,d,e,0,0,0,2147352576);f=((f|0)<49149?f:49149)-32766|0;d=v[g+24>>2];e=v[g+28>>2];b=v[g+16>>2];c=v[g+20>>2];break a}if((f|0)>-16383){break a}Jd(g- -64|0,b,c,d,e,0,0,0,7471104);d=v[g+72>>2];e=v[g+76>>2];b=v[g+64>>2];c=v[g+68>>2];if(f>>>0>4294934644){f=f+16269|0;break a}Jd(g+48|0,b,c,d,e,0,0,0,7471104);f=((f|0)>-48920?f:-48920)+32538|0;d=v[g+56>>2];e=v[g+60>>2];b=v[g+48>>2];c=v[g+52>>2]}Jd(g,b,c,d,e,0,0,0,f+16383<<16);b=v[g+12>>2];v[a+8>>2]=v[g+8>>2];v[a+12>>2]=b;b=v[g+4>>2];v[a>>2]=v[g>>2];v[a+4>>2]=b;kb=g+80|0}function ax(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0;e=kb-16|0;kb=e;g=(p(a),j(2));c=g&2147483647;a:{if(c>>>0<=1305022426){h=+a;f=h*.6366197723675814+6755399441055744+-6755399441055744;d=h+f*-1.5707963109016418+f*-1.5893254773528196e-8;A[b>>3]=d;g=d<-.7853981852531433;if(D(f)<2147483648){c=~~f}else{c=-2147483648}if(g){d=f+-1;A[b>>3]=h+d*-1.5707963109016418+d*-1.5893254773528196e-8;c=c-1|0;break a}if(!(d>.7853981852531433)){break a}d=f+1;A[b>>3]=h+d*-1.5707963109016418+d*-1.5893254773528196e-8;c=c+1|0;break a}if(c>>>0>=2139095040){A[b>>3]=C(a-a);c=0;break a}i=c;c=(c>>>23|0)-150|0;A[e+8>>3]=(l(2,i-(c<<23)|0),q());c=TH(e+8|0,e,c,1,0);d=A[e>>3];if((g|0)<0){A[b>>3]=-d;c=0-c|0;break a}A[b>>3]=d}kb=e+16|0;return c}function Gda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=kb-16|0;kb=b;f=v[a+40>>2];g=v[a+36>>2];j=v[a+16>>2];e=v[a+4>>2];v[b+8>>2]=v[a>>2];v[b+12>>2]=e;k=v[a+32>>2];l=v[a+28>>2];m=v[a+8>>2];n=v[a+12>>2];while(1){if(d){e=v[b+8>>2];o=e>>>18|0;p=((((v[b+12>>2]&2147483647)<<1|e>>>31)&2147483646)<<1)+j|0;e=0;while(1){if((e|0)!=2){h=(e<<1)+p|0;i=u[h>>1];v[(e<<2)+b>>2]=i+((B(u[h+4>>1]-i|0,o)|0)/16384|0);e=e+1|0;continue}break}g=g+l|0;v[c>>2]=v[c>>2]+B(v[b>>2],g>>12);f=f+k|0;v[c+4>>2]=v[c+4>>2]+B(v[b+4>>2],f>>12);Rb(b+8|0,m,n);c=c+8|0;d=d-1|0;continue}break}c=v[b+12>>2];v[a>>2]=v[b+8>>2];v[a+4>>2]=c;v[a+40>>2]=f;v[a+20>>2]=g>>12;v[a+36>>2]=g;v[a+24>>2]=f>>12;kb=b+16|0}function b1(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;h=v[b+44>>2];i=v[b+24>>2];if(h>>>0<i>>>0){v[b+44>>2]=i;h=i}l=-1;m=-1;n=f&24;a:{if(!n|(e|0)==1&(n|0)==24){break a}if(h){g=h-Ac(b+32|0)|0;o=g;g=g>>31}b:{c:{switch(e|0){case 1:if(f&8){e=v[b+12>>2]-v[b+8>>2]|0;j=e;k=e>>31;break b}e=i-v[b+20>>2]|0;j=e;k=e>>31;break b;case 0:break b;case 2:break c;default:break a}}j=o;k=g}d=d+k|0;c=c+j|0;d=j>>>0>c>>>0?d+1|0:d;e=c;c=d;if((g|0)<=(d|0)&e>>>0>o>>>0|(d|0)>(g|0)|(d|0)<0){break a}d=f&8;d:{if(!(c|e)){break d}if(v[b+12>>2]?0:d){break a}if(!(f&16)){break d}if(!i){break a}}if(d){d=v[b+8>>2];Cn(b,d,d+e|0,h)}if(f&16){Pw(b,v[b+20>>2],v[b+28>>2]);bs(b,e)}l=e;m=c}Xg(a,l,m)}function _E(a,b,c,d,e,f){var g=0,h=0,i=C(0),j=0;g=kb-80|0;kb=g;ry(v[a+24>>2]);t[v[a+24>>2]+1298420|0]=v[a+52>>2]!=0;v[g+40>>2]=b;v[g+36>>2]=c;v[g+32>>2]=d;i=z[a+48>>2];j=v[a+32>>2];v[g+8>>2]=b;c=v[g+36>>2];v[g>>2]=v[g+32>>2];v[g+4>>2]=c;d=kb-16|0;kb=d;v[d+8>>2]=v[g+8>>2];c=v[g+4>>2];v[d>>2]=v[g>>2];v[d+4>>2]=c;c=xJ(g+48|0);v[c+8>>2]=j;v[c+4>>2]=0;v[c>>2]=f;f=v[d+4>>2];v[c+12>>2]=v[d>>2];v[c+16>>2]=f;v[c+20>>2]=v[d+8>>2];z[c+24>>2]=i;v[c>>2]=e;kb=d+16|0;while(1){if(b){d=v[a+24>>2];v[g+24>>2]=b;v[g+28>>2]=0;v[g+16>>2]=134217727;v[g+20>>2]=0;d=zJ(d,v[_q(g+24|0,g+16|0)>>2],c);h=d+h|0;b=b-d|0;if(d){continue}}break}if(!(v[a+52>>2]!=1|h)){a=v[a+24>>2];v[a+480208>>2]=v[a+480208>>2]&-513}kb=g+80|0;return h}function VR(a,b){var c=0,d=0,e=0;c=kb-32|0;kb=c;a:{if(!Qb(v[a>>2],v[a+8>>2],1024)){v[c+24>>2]=0;v[c+28>>2]=0;v[c+16>>2]=0;v[c+20>>2]=0;a=64;while(1){if(a){d=w[c+20|0]|w[c+21|0]<<8|(w[c+22|0]<<16|w[c+23|0]<<24);e=w[c+16|0]|w[c+17|0]<<8|(w[c+18|0]<<16|w[c+19|0]<<24);t[b|0]=e;t[b+1|0]=e>>>8;t[b+2|0]=e>>>16;t[b+3|0]=e>>>24;t[b+4|0]=d;t[b+5|0]=d>>>8;t[b+6|0]=d>>>16;t[b+7|0]=d>>>24;d=w[c+28|0]|w[c+29|0]<<8|(w[c+30|0]<<16|w[c+31|0]<<24);e=w[c+24|0]|w[c+25|0]<<8|(w[c+26|0]<<16|w[c+27|0]<<24);t[b+8|0]=e;t[b+9|0]=e>>>8;t[b+10|0]=e>>>16;t[b+11|0]=e>>>24;t[b+12|0]=d;t[b+13|0]=d>>>8;t[b+14|0]=d>>>16;t[b+15|0]=d>>>24;a=a-1|0;b=b+16|0;continue}break}break a}iA(c+8|0,b);ud(c+16|0,a,v[c+8>>2],v[c+12>>2])}kb=c+32|0}function An(a,b,c,d,e,f,g,h,i,j){var k=0,l=0,m=0,n=0;l=kb-16|0;kb=l;t[l+15|0]=a;a:{b:{c:{k=v[d>>2];if((k|0)!=(c|0)){break c}m=43;n=a&255;if((n|0)!=w[j+24|0]){m=45;if(w[j+25|0]!=(n|0)){break c}}v[d>>2]=c+1;t[c|0]=m;break b}if(!(!Hb(g)|(a|0)!=(f|0))){a=0;b=v[i>>2];if((b-h|0)>159){break a}a=v[e>>2];v[i>>2]=b+4;v[b>>2]=a;break b}a=-1;f=zi(j,j+26|0,l+15|0)-j|0;if((f|0)>23){break a}d:{e:{switch(b-8|0){case 0:case 2:if((b|0)>(f|0)){break d}break a;case 1:break d;default:break e}}if((b|0)!=16|(f|0)<22){break d}if((c|0)==(k|0)|(k-c|0)>2|w[k-1|0]!=48){break a}a=0;v[e>>2]=0;v[d>>2]=k+1;t[k|0]=w[f+83808|0];break a}v[d>>2]=k+1;t[k|0]=w[f+83808|0];v[e>>2]=v[e>>2]+1;a=0;break a}a=0;v[e>>2]=0}kb=l+16|0;return a}function II(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;f=kb-16|0;kb=f;a:{b:{c:{d:{e:{if((b|0)>=0){g=a;a=v[a+32>>2];if((Og(a)|0)>(b|0)){break e}}a=ba(8)|0;v[23540]=0;b=Q(55,f|0,10725)|0;c=v[23540];v[23540]=0;if((c|0)==1){break d}a=tc(a,b);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break b}c=P()|0;O()|0;zb(b);break c}d=(a+(b<<5)|0)+480280|0;c=c?134218752:0;v[d>>2]=c|v[d>>2]&-134218753;d=(a+B(b,872)|0)+1075080|0;v[d>>2]=c|v[d>>2]&-134218753;a=x[a+480188>>1];d=a>>>0>256?a:256;b=b+1|0;g=v[g+32>>2];while(1){if((a|0)==(d|0)){break a}e=g+B(a,872)|0;if((b|0)==x[e+1075778>>1]){e=e+1075080|0;v[e>>2]=c|v[e>>2]&-134218753}a=a+1|0;continue}}c=P()|0;O()|0;ca(a|0)}T(c|0)}L()}kb=f+16|0}function Hda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=kb-16|0;kb=b;f=v[a+40>>2];g=v[a+36>>2];j=v[a+16>>2];e=v[a+4>>2];v[b+8>>2]=v[a>>2];v[b+12>>2]=e;k=v[a+32>>2];l=v[a+28>>2];m=v[a+8>>2];n=v[a+12>>2];while(1){if(d){e=v[b+8>>2];o=e>>>10&4194048;p=(((v[b+12>>2]&2147483647)<<1|e>>>31)&-2)+j|0;e=0;while(1){if((e|0)!=2){h=e+p|0;i=t[h|0];v[(e<<2)+b>>2]=((B(t[h+2|0]-i|0,o)|0)/16384|0)+(i<<8);e=e+1|0;continue}break}g=g+l|0;v[c>>2]=v[c>>2]+B(v[b>>2],g>>12);f=f+k|0;v[c+4>>2]=v[c+4>>2]+B(v[b+4>>2],f>>12);Rb(b+8|0,m,n);c=c+8|0;d=d-1|0;continue}break}c=v[b+12>>2];v[a>>2]=v[b+8>>2];v[a+4>>2]=c;v[a+40>>2]=f;v[a+20>>2]=g>>12;v[a+36>>2]=g;v[a+24>>2]=f>>12;kb=b+16|0}function eca(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;e=kb-16|0;kb=e;h=rf(a,c);me(e,v[a+36>>2]);i=a;a:{if(!h){Sc(e,a+32|0,5);c=0;if(Cb(v[v[e>>2]>>2],v[e+4>>2])){break a}}f=v[a+36>>2];a=kb-16|0;kb=a;v[a+12>>2]=0;FG(f,a+12|0,1);c=v[a+12>>2];d=c>>>2&3;t[a+11|0]=d;if(d){t[a+4|0]=3;d=w[Yb(a+4|0,a+11|0)|0];t[a+4|0]=0;t[a|0]=0;t[a+10|0]=0;b:{if(!d){break b}li(f,a+4|0);if((d|0)==1){break b}li(f,a);if(d>>>0<3){break b}li(f,a+10|0);g=w[a+10|0]<<24}c=c&255|w[a+4|0]<<8|w[a|0]<<16|g;v[a+12>>2]=c}d=c>>>4|0;v[a+4>>2]=d;v[a>>2]=1e6;Hx(b,v[Kb(a+4|0,a)>>2]);c=0;while(1){g=Hb(b);if(g>>>0<=c>>>0){if((d|0)!=(g|0)){$l(f,d-g|0)}kb=a+16|0}else{Uk(f,Tc(b,c),1);c=c+1|0;continue}break}c=h}Ye(i,c);kb=e+16|0}function xh(a,b){var c=C(0),d=C(0),e=C(0),f=C(0),g=C(0),h=0;f=HK(a);h=a+4208|0;c=C(C(z[Eb(h,4)>>2]*C(1.899999976158142))+C(.10000000149011612));g=z[a+4268>>2];d=te(C(10),C(C(C(C(C(v[((b<<2)+a|0)+4292>>2])/g)*C(-60))/C(C(z[Eb(h,3)>>2]*C(19.899999618530273))+C(.10000000149011612)))/C(20)));c=C(C(te(d,C(C(2)-C(C(2)/c)))+C(-1))/C(C(1)-Fp(c>C(1)?C(3.1415927410125732):C(f*C(C(6.2831854820251465)/g)))));a:{if(c==C(0)){break a}if(!pm(c)){break a}g=C(c+c);f=C(C(-2)-g);c=C(C(f*f)+C(C(c*c)*C(-4)));if(c>C(0)){e=C(K(c))}c=C(C(e-f)/g);if(C(D(c))>C(1)){c=C(C(C(-f)-e)/g)}e=Jf(c)}b=(b<<3)+a|0;z[b+4404>>2]=e;z[b+4400>>2]=d;c=z[a+4272>>2];c=C(c*c);e=C(C(1)-c);d=C(d*d);return C(C(C(e*C(d/C(C(1)-C(c*d))))*e)+c)}function uda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=kb-16|0;kb=b;g=v[a+24>>2];h=v[a+20>>2];i=v[a+16>>2];e=v[a+4>>2];v[b+8>>2]=v[a>>2];v[b+12>>2]=e;j=v[a+8>>2];k=v[a+12>>2];while(1){if(d){f=v[b+8>>2];l=((((v[b+12>>2]&2147483647)<<1|f>>>31)&2147483646)<<1)+i|0;e=f>>>21&2040;m=u[e+39782>>1];n=u[e+39780>>1];o=u[e+39778>>1];p=u[e+39776>>1];e=0;while(1){if((e|0)!=2){f=(e<<1)+l|0;v[(e<<2)+b>>2]=(((B(u[f>>1],o)+B(u[f-4>>1],p)|0)+B(u[f+4>>1],n)|0)+B(u[f+8>>1],m)|0)/16384;e=e+1|0;continue}break}v[c>>2]=v[c>>2]+B(v[b>>2],h);v[c+4>>2]=v[c+4>>2]+B(v[b+4>>2],g);Rb(b+8|0,j,k);c=c+8|0;d=d-1|0;continue}break}c=v[b+12>>2];v[a>>2]=v[b+8>>2];v[a+4>>2]=c;kb=b+16|0}function Dfa(a){a=a|0;var b=0,c=0,d=0,e=0;c=kb-192|0;kb=c;b=c+16|0;qi(b,a);v[23540]=0;R(88,c+32|0,b|0);a=v[23540];v[23540]=0;a:{b:{c:{d:{e:{if((a|0)!=1){v[23540]=0;a=Q(89,c+48|0,c+32|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break e}zb(c+32|0);zb(c+16|0);b=v[v[a>>2]-12>>2];v[23540]=0;d=ga(62)|0;e=v[23540];v[23540]=0;if((e|0)==1){break c}v[23540]=0;U(63,c+8|0,a+b|0,d|0);b=v[23540];v[23540]=0;if((b|0)==1){break c}ac(c+8|0);v[23540]=0;b=Q(90,a|0,c+32|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break c}a=Yk(v[(b+v[v[b>>2]-12>>2]|0)+16>>2]);d=x[c+32>>1];sf(b);kb=c+192|0;a=(a?0:d)&65535;break a}b=P()|0;O()|0;break d}b=P()|0;O()|0;zb(c+32|0)}zb(c+16|0);break b}b=P()|0;O()|0;sf(a)}T(b|0);L()}return a|0}function vi(a,b,c,d){var e=0,f=0,g=0;v[a+20>>2]=d;v[a+16>>2]=c;v[a+12>>2]=b;v[a+4>>2]=0;v[a+8>>2]=0;v[a>>2]=44376;c=a+24|0;v[c>>2]=0;v[c+4>>2]=0;v[c+16>>2]=0;v[c+8>>2]=0;v[c+12>>2]=0;b=Tb(a+44|0);g=Tb(b+12|0);e=Tb(b+24|0);f=Tb(b+36|0);v[23540]=0;R(897,b|0,0);d=v[23540];v[23540]=0;if((d|0)==1){a=P()|0;O()|0;wc(f);wc(e);Ps(g);Ps(b);T(a|0);L()}u[a+4204>>1]=0;v[a+4196>>2]=1065353216;v[a+4200>>2]=0;d=v[a+16>>2];v[d+946300>>2]=v[d+946300>>2]+1;v[23540]=0;e=S(898,a+92|0)|0;d=v[23540];v[23540]=0;a:{if((d|0)!=1){f=a+4200|0;v[c>>2]=e;c=v[a+16>>2]+906300|0;d=w[a+4200|0];b=v[a+20>>2];while(1){if((Md(c,d)|0)==(b|0)|d>>>0>248){break a}d=d+1|0;t[f|0]=d;continue}}a=P()|0;O()|0;lL(b);T(a|0);L()}return a}function vfa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;d=kb-32|0;kb=d;nd(c,2);t[d+16|0]=w[b+13|0];t[d|0]=64;e=d+16|0;i=c,j=w[Yb(e,d)|0]<<2,u[i+30>>1]=j;v[c+24>>2]=(w[b+14|0]|w[b+15|0]<<8)<<1;uk(d,2,b+1|0);Fc(e,d);Be(c+43|0,e);zb(e);e=Zc(a,8,1,0,2);a:{if((w[b|0]&3)!=1){break a}g=w[b+22|0]|w[b+23|0]<<8|(w[b+24|0]<<16|w[b+25|0]<<24);v[c>>2]=g;f=w[b+26|0]|w[b+27|0]<<8|(w[b+28|0]<<16|w[b+29|0]<<24);v[c+4>>2]=f;a=w[b+30|0]|w[b+31|0]<<8|(w[b+32|0]<<16|w[b+33|0]<<24);h=a-(a>>>0>f>>>0)|0;v[c+8>>2]=h;a=w[b|0];if(a&4){u[c+34>>1]=x[c+34>>1]|2;a=w[b|0]}if(a&8){u[c+34>>1]=x[c+34>>1]|4;a=w[b|0]}if(!(a&16)){break a}xd(e,16);dg(e,9);v[c+8>>2]=h>>>1;v[c+4>>2]=f>>>1;v[c>>2]=g>>>1}kb=d+32|0}function rA(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=kb-16|0;kb=e;d=w[a|0];if(d&1){t[b+12|0]=w[b+12|0]|1;d=w[a|0]}if(d&2){t[b+12|0]=w[b+12|0]|4;d=w[a|0]}if(d&4){t[b+12|0]=w[b+12|0]|2;d=w[a|0]}if(d&16){t[b+12|0]=w[b+12|0]|16;d=w[a|0]}if(d&32){t[b+12|0]=w[b+12|0]|8}t[e+15|0]=w[a+1|0];t[e+14|0]=25;Qg(b,w[Yb(e+15|0,e+14|0)|0]);t[b+15|0]=w[a+2|0];t[b+16|0]=w[a+3|0];t[b+13|0]=w[a+4|0];t[b+14|0]=w[a+5|0];g=v[b>>2];i=$d(g,v[b+4>>2]);b=0;while(1){if((b|0)!=(i|0)){h=Eb(g,b);f=(b<<2)+a|0;d=w[f+6|0]|w[f+7|0]<<8;u[h>>1]=d;a:{if(!b){break a}j=d;d=x[Eb(g,b-1|0)>>1];if(j>>>0>=d>>>0){break a}u[h>>1]=d+1}k=h,l=Zb((w[f+8|0]|w[f+9|0]<<8)<<16>>16>>c,0,64),t[k+2|0]=l;b=b+1|0;continue}break}kb=e+16|0}function RG(a,b){var c=0,d=0,e=0;a:{if(w[b|0]){break a}b=Ew(13884);if(w[b|0]?b:0){break a}b=Ew(B(a,12)+79648|0);if(w[b|0]?b:0){break a}b=Ew(14168);if(w[b|0]?b:0){break a}b=14777}b:{while(1){d=w[b+c|0];if(!(!d|(d|0)==47)){d=23;c=c+1|0;if((c|0)!=23){continue}break b}break}d=c}e=14777;c:{d:{c=w[b|0];e:{f:{if(!(w[b+d|0]|(c|0)==46)){e=b;if((c|0)!=67){break f}}if(!w[e+1|0]){break e}}if(!yi(e,14777)){break e}if(yi(e,13501)){break d}}if(!a){c=79720;if(w[e+1|0]==46){break c}}return 0}c=v[116955];if(c){while(1){if(!yi(e,c+8|0)){break c}c=v[c+32>>2];if(c){continue}break}}c=Pd(36);if(c){v[c+4>>2]=20;v[c>>2]=79616;b=c+8|0;sc(b,e,d);t[b+d|0]=0;v[c+32>>2]=v[116955];v[116955]=c}c=a|c?c:79720}return c}function Aga(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;b=kb-528|0;kb=b;e=-1;a:{if(!fg(a,1468)){break a}vl(a,1464);c=b+524|0;lS(a,c);if(!ne(c,26953)){e=0;if(!ne(b+524|0,15566)){break a}}vl(a,20);c=1;while(1){if((c&65535)>>>0<=31){if(iS(a,b)){c=c+1|0;d=pA(b)+d|0;continue}else{e=-1;break a}}break}e=0;if(d>>>0>40){break a}d=b+520|0;c=kb-16|0;kb=c;b:{if(!fg(a,2)){t[c|0]=0;tC(d,c);break b}Ym(c+8|0,d);oA(c,a,v[c+8>>2],v[c+12>>2])}kb=c+16|0;if(w[b+520|0]>128){break a}d=Oc(b+520|0);c=kb-16|0;kb=c;c:{if(!fg(a,512)){UR(b);break c}Ku(c+8|0,b);oA(c,a,v[c+8>>2],v[c+12>>2])}kb=c+16|0;c=0;e=1;a=w[d|0];while(1){if((c|0)==512){break a}d=b+c|0;c=c+1|0;if(a>>>0>=w[d|0]){continue}break}e=0}kb=b+528|0;return e|0}function Zj(a,b){var c=0,d=0,e=0,f=0;c=kb+-64|0;kb=c;d=v[v[a>>2]-12>>2]+a|0;e=v[d+16>>2]&-3;Rl(d,e);a:{b:{if(Qd(w[fm(c+56|0,a,1)|0])){d=v[(v[v[a>>2]-12>>2]+a|0)+24>>2];v[23540]=0;f=v[b+12>>2];v[c+16>>2]=v[b+8>>2];v[c+20>>2]=f;f=v[b+4>>2];v[c+8>>2]=v[b>>2];v[c+12>>2]=f;U(108,c+40|0,d|0,c+8|0);b=v[23540];v[23540]=0;c:{if((b|0)!=1){b=mE(c+40|0,Xg(c+24|0,-1,-1))?e|4:e;break c}b=V(0)|0;O()|0;_(b|0)|0;b=e|1;dm(v[v[a>>2]-12>>2]+a|0,b);if(v[(v[v[a>>2]-12>>2]+a|0)+20>>2]&1){v[23540]=0;Z(105);a=v[23540];v[23540]=0;if((a|0)!=1){break a}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)==1){break b}T(a|0);L()}$()}Ki(v[v[a>>2]-12>>2]+a|0,b)}kb=c- -64|0;return a}V(0)|0;O()|0;Vb()}L()}function Wda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;b=kb-16|0;kb=b;i=v[a+16>>2];h=Tf(1,2);e=nb;j=e;Rb(a,h,e);f=v[a+40>>2];g=v[a+36>>2];e=v[a+4>>2];v[b+8>>2]=v[a>>2];v[b+12>>2]=e;k=v[a+32>>2];l=v[a+28>>2];m=v[a+8>>2];n=v[a+12>>2];while(1){if(d){d=d-1|0;o=((((v[b+12>>2]&2147483647)<<1|v[b+8>>2]>>>31)&2147483646)<<1)+i|0;e=0;while(1){if((e|0)!=2){v[(e<<2)+b>>2]=u[(e<<1)+o>>1];e=e+1|0;continue}break}g=g+l|0;v[c>>2]=v[c>>2]+B(v[b>>2],g>>12);f=f+k|0;v[c+4>>2]=v[c+4>>2]+B(v[b+4>>2],f>>12);Rb(b+8|0,m,n);c=c+8|0;continue}break}c=v[b+12>>2];v[a>>2]=v[b+8>>2];v[a+4>>2]=c;v[a+40>>2]=f;v[a+20>>2]=g>>12;v[a+36>>2]=g;v[a+24>>2]=f>>12;mg(a,h,j);kb=b+16|0}function OX(a){a=a|0;var b=0,c=0,d=0,e=0;c=kb-192|0;kb=c;b=c+16|0;qi(b,a);v[23540]=0;R(88,c+32|0,b|0);a=v[23540];v[23540]=0;a:{b:{c:{d:{e:{if((a|0)!=1){v[23540]=0;a=Q(89,c+48|0,c+32|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break e}zb(c+32|0);zb(c+16|0);b=v[v[a>>2]-12>>2];v[23540]=0;d=ga(62)|0;e=v[23540];v[23540]=0;if((e|0)==1){break c}v[23540]=0;U(63,c+8|0,a+b|0,d|0);b=v[23540];v[23540]=0;if((b|0)==1){break c}ac(c+8|0);v[23540]=0;b=Q(93,a|0,c+32|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break c}a=Yk(v[(b+v[v[b>>2]-12>>2]|0)+16>>2]);d=v[c+32>>2];sf(b);kb=c+192|0;a=a?0:d;break a}b=P()|0;O()|0;break d}b=P()|0;O()|0;zb(c+32|0)}zb(c+16|0);break b}b=P()|0;O()|0;sf(a)}T(b|0);L()}return a|0}function ZV(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;e=kb-16|0;kb=e;nd(b,0);v[b>>2]=w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24);c=Tq(a+4|0,a);f=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);v[b+4>>2]=f;c=Tq(a+8|0,a);c=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);v[b+8>>2]=c;t[e+15|0]=127;t[e+14|0]=w[a+15|0];g=b,h=(((w[Yb(e+15|0,e+14|0)|0]<<8|64)&65344)>>>0)/127|0,u[g+30>>1]=h;d=w[a+12|0];if(d>>>0>=16){u[b+34>>1]=32;u[b+28>>1]=d&240}d=(w[a+13|0]|w[a+14|0]<<8)<<1;v[b+24>>2]=d;d=w[a+13|0]|w[a+14|0]<<8?d:16726;v[b+24>>2]=d;g=b,h=(B(Wu(0,w[a+12|0]<<28>>24),d)>>>0)/8363|0,v[g+24>>2]=h;if(c>>>0>f>>>0){u[b+34>>1]=x[b+34>>1]|2}if(w[a+16|0]&132){u[b+34>>1]=x[b+34>>1]|1}kb=e+16|0}function sH(a){a=a|0;var b=0,c=0,d=0,e=0;d=kb-16|0;kb=d;a:{b:{if(!v[(v[v[a>>2]-12>>2]+a|0)+24>>2]){break b}v[23540]=0;c=Q(1100,d+8|0,a|0)|0;b=v[23540];v[23540]=0;c:{if((b|0)!=1){d:{if(!Qd(w[c|0])){break d}b=v[(v[v[a>>2]-12>>2]+a|0)+24>>2];v[23540]=0;b=S(1101,b|0)|0;e=v[23540];v[23540]=0;if((e|0)!=1){if((b|0)!=-1){break d}b=v[v[a>>2]-12>>2];v[23540]=0;Y(1102,a+b|0);b=v[23540];v[23540]=0;if((b|0)!=1){break d}}b=V(0)|0;O()|0;rH(c);break c}rH(c);break b}b=V(0)|0;O()|0}_(b|0)|0;c=v[v[a>>2]-12>>2];v[23540]=0;Y(17,a+c|0);c=v[23540];v[23540]=0;if((c|0)==1){break a}$()}kb=d+16|0;return a|0}a=P()|0;O()|0;v[23540]=0;Z(18);c=v[23540];v[23540]=0;if((c|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function Z4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=kb-32|0;kb=d;e=Tb(a);a=0;c=v[b+24>>2];c=rt(v[c+484344>>2],v[c+484348>>2]);v[23540]=0;R(181,e|0,c|0);c=v[23540];v[23540]=0;a:{if((c|0)!=1){b:{c:{d:{e:{while(1){c=v[b+24>>2];f=v[c+484344>>2];if(rt(f,v[c+484348>>2])>>>0<=a>>>0){break b}v[23540]=0;R(1016,d|0,_b(f,a)|0);c=v[23540];v[23540]=0;if((c|0)!=1){c=v[b+24>>2];v[23540]=0;U(1003,d+16|0,c|0,d|0);c=v[23540];v[23540]=0;if((c|0)==1){break e}v[23540]=0;R(183,e|0,d+16|0);c=v[23540];v[23540]=0;if((c|0)==1){break d}a=a+1|0;zb(d+16|0);zb(d);continue}break}a=P()|0;O()|0;break a}a=P()|0;O()|0;break c}a=P()|0;O()|0;zb(d+16|0)}zb(d);break a}kb=d+32|0;return}a=P()|0;O()|0}Xe(e);T(a|0);L()}function b3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=kb-80|0;kb=e;v[e+76>>2]=d;v[e+72>>2]=c;v[23540]=0;c=v[b+12>>2];v[e+16>>2]=v[b+8>>2];v[e+20>>2]=c;c=v[b+4>>2];v[e+8>>2]=v[b>>2];v[e+12>>2]=c;c=S(1075,e+8|0)|0;d=v[23540];v[23540]=0;if((d|0)!=1){a:{b:{if(c){v[23540]=0;R(1076,e+48|0,b|0);b=v[23540];v[23540]=0;if((b|0)!=1){d=e+56|0;Cv(d,v[e+48>>2],v[e+52>>2]);b=Cg(e- -64|0,d);c=Cg(e+40|0,e+72|0);break b}break a}v[23540]=0;R(1077,e+48|0,b|0);b=v[23540];v[23540]=0;if((b|0)==1){break a}d=e+56|0;Cv(d,v[e+48>>2],v[e+52>>2]);b=Cg(e+32|0,d);c=Cg(e+24|0,e+72|0)}LD(a,v[b>>2],v[b+4>>2],v[c>>2],v[c+4>>2]);le(d);le(e+48|0);le(e+72|0);kb=e+80|0;return}}a=P()|0;O()|0;le(e+72|0);T(a|0);L()}function Ly(a,b,c){var d=0,e=0,f=0,g=0;d=kb+-64|0;kb=d;e=v[a>>2];f=v[e-4>>2];g=v[e-8>>2];v[d+28>>2]=0;v[d+32>>2]=0;v[d+36>>2]=0;v[d+40>>2]=0;v[d+44>>2]=0;v[d+48>>2]=0;v[d+52>>2]=0;v[d+56>>2]=0;e=0;t[d+59|0]=0;t[d+60|0]=0;t[d+61|0]=0;t[d+62|0]=0;v[d+20>>2]=0;v[d+24>>2]=0;v[d+16>>2]=b;v[d+12>>2]=a;v[d+8>>2]=c;a=a+g|0;a:{if(Zg(f,c,0)){v[d+56>>2]=1;ob[v[v[f>>2]+20>>2]](f,d+8|0,a,a,1,0);e=v[d+32>>2]==1?a:0;break a}ob[v[v[f>>2]+24>>2]](f,d+8|0,a,1,0);b:{switch(v[d+44>>2]){case 0:e=v[d+48>>2]==1?v[d+36>>2]==1?v[d+40>>2]==1?v[d+28>>2]:0:0:0;break a;case 1:break b;default:break a}}if(v[d+32>>2]!=1){if(v[d+48>>2]|v[d+36>>2]!=1|v[d+40>>2]!=1){break a}}e=v[d+24>>2]}kb=d- -64|0;return e}function ph(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;f=kb+-64|0;kb=f;a:{b:{if((b|0)==65535|c-1025>>>0<4294966272){break b}d=v[a>>2];e=v[a+4>>2];if(xe(d,e,b)){break b}c:{d:{if(yk(d,e)>>>0<=b>>>0){d=$x(f+8|0,a);v[23540]=0;U(201,a|0,b+1|0,d|0);e=v[23540];v[23540]=0;if((e|0)==1){break d}gl(d);d=v[a>>2]}v[23540]=0;R(211,bg(d,b)|0,c|0);c=v[23540];v[23540]=0;e:{if((c|0)!=1){c=bg(v[a>>2],b);v[c+16>>2]=0;v[c+20>>2]=0;c=v[a>>2];v[23540]=0;Y(212,bg(c,b)|0);c=v[23540];v[23540]=0;if((c|0)!=1){break e}}b=V(92756)|0;a=O()|0;break c}a=bg(v[a>>2],b);g=Pb(v[a>>2],v[a+4>>2]);break b}b=V(92756)|0;a=O()|0;gl(d)}if((ea(92756)|0)!=(a|0)){break a}_(b|0)|0;$()}kb=f- -64|0;return g|0}T(b|0);L()}function Wfa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;c=kb+-64|0;kb=c;i=c,j=cf(a)>>>5|0,u[i+32>>1]=j;u[c+16>>1]=3999;h=b+480190|0;d=x[Wc(c+32|0,c+16|0)>>1];u[h>>1]=d;g=1;while(1){f=g&65535;if(f>>>0<=d>>>0){d=Hi(b,f);e=c+32|0;Wt(a,e);nd(d,0);Dj(c,2,e);e=c+16|0;Fc(e,c);Dc(((f<<5)+b|0)+946304|0,e);zb(e);v[d+24>>2]=8287;i=c,j=Ib(x[c+60>>1]),u[i+16>>1]=j;u[c>>1]=64;i=d,j=x[Wc(e,c)>>1]<<2,u[i+30>>1]=j;i=d,j=bc(v[c+52>>2])&-2,v[i>>2]=j;e=Ib(x[c+62>>1]);i=Eb(d+68|0,0),j=e,v[i>>2]=j;e=Ib(x[c+56>>1]);f=Ib(x[c+58>>1]);a:{if(f>>>0<2){break a}f=e+f<<1;if(f>>>0>y[d>>2]){break a}v[d+16>>2]=f;v[d+12>>2]=e<<1;u[d+34>>1]=x[d+34>>1]|8}g=g+1|0;d=x[h>>1];continue}break}kb=c- -64|0}function vda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=kb-16|0;kb=b;g=v[a+24>>2];h=v[a+20>>2];i=v[a+16>>2];e=v[a+4>>2];v[b+8>>2]=v[a>>2];v[b+12>>2]=e;j=v[a+8>>2];k=v[a+12>>2];while(1){if(d){f=v[b+8>>2];l=(((v[b+12>>2]&2147483647)<<1|f>>>31)&-2)+i|0;e=f>>>21&2040;m=u[e+39782>>1];n=u[e+39780>>1];o=u[e+39778>>1];p=u[e+39776>>1];e=0;while(1){if((e|0)!=2){f=e+l|0;v[(e<<2)+b>>2]=(((B(t[f|0],o)+B(t[f-2|0],p)|0)+B(t[f+2|0],n)|0)+B(t[f+4|0],m)<<8)/16384;e=e+1|0;continue}break}v[c>>2]=v[c>>2]+B(v[b>>2],h);v[c+4>>2]=v[c+4>>2]+B(v[b+4>>2],g);Rb(b+8|0,j,k);c=c+8|0;d=d-1|0;continue}break}c=v[b+12>>2];v[a>>2]=v[b+8>>2];v[a+4>>2]=c;kb=b+16|0}function ar(a){a=a|0;var b=0,c=0,d=0,e=0;d=kb-16|0;kb=d;a:{b:{if(!v[(v[v[a>>2]-12>>2]+a|0)+24>>2]){break b}v[23540]=0;c=Q(13,d+8|0,a|0)|0;b=v[23540];v[23540]=0;c:{if((b|0)!=1){d:{if(!w[c|0]){break d}b=v[(v[v[a>>2]-12>>2]+a|0)+24>>2];v[23540]=0;b=S(22,b|0)|0;e=v[23540];v[23540]=0;if((e|0)!=1){if((b|0)!=-1){break d}b=v[v[a>>2]-12>>2];v[23540]=0;R(16,a+b|0,1);b=v[23540];v[23540]=0;if((b|0)!=1){break d}}b=V(0)|0;O()|0;zk(c);break c}zk(c);break b}b=V(0)|0;O()|0}_(b|0)|0;c=v[v[a>>2]-12>>2];v[23540]=0;Y(17,a+c|0);c=v[23540];v[23540]=0;if((c|0)==1){break a}$()}kb=d+16|0;return a|0}a=P()|0;O()|0;v[23540]=0;Z(18);c=v[23540];v[23540]=0;if((c|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function mF(a,b,c,d){var e=0,f=0,g=0;f=kb-32|0;kb=f;v[23540]=0;Y(946,a|0);e=v[23540];v[23540]=0;a:{b:{c:{d:{e:{f:{if((e|0)==1){break f}v[23540]=0;Y(947,b|0);e=v[23540];v[23540]=0;if((e|0)==1){break f}g=v[a+24>>2];v[23540]=0;e=Q(55,f|0,b|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break e}v[23540]=0;U(d|0,f+16|0,g|0,e|0);b=v[23540];v[23540]=0;if((b|0)==1){break d}a=f+16|0;b=gg(Mc(a));zb(a);zb(e);break b}b=V(0)|0;O()|0;break c}b=V(0)|0;O()|0;break c}b=V(0)|0;O()|0;zb(e)}_(b|0)|0;b=0;v[23540]=0;X(933,c|0,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)==1){break a}$()}kb=f+32|0;return b}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function jea(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;g=kb-16|0;kb=g;nd(b,4);u[b+30>>1]=w[a+12|0]<<2;Ef(b+30|0,256);e=w[a+15|0];u[b+34>>1]=32;u[b+28>>1]=e;t[b+37|0]=w[a+13|0];t[b+36|0]=w[a+16|0];f=w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24);v[b>>2]=f;c=w[a+4|0]|w[a+5|0]<<8|(w[a+6|0]<<16|w[a+7|0]<<24);v[b+4>>2]=c;d=(w[a+8|0]|w[a+9|0]<<8|(w[a+10|0]<<16|w[a+11|0]<<24))+c|0;v[b+8>>2]=d;e=w[a+14|0];if(e&16){d=d>>>1|0;v[b+8>>2]=d;c=c>>>1|0;v[b+4>>2]=c;f=f>>>1|0;v[b>>2]=f;e=w[a+14|0]}if(e&32){d=d>>>1|0;v[b+8>>2]=d;c=c>>>1|0;v[b+4>>2]=c;v[b>>2]=f>>>1;e=w[a+14|0]}if(!(!(e&3)|c>>>0>=d>>>0)){u[b+34>>1]=34;u[b+34>>1]=w[a+14|0]&2?38:34}a=Kc(g,21688);Be(b+43|0,a);zb(a);kb=g+16|0}function J1(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;d=kb-32|0;kb=d;e=v[a+28>>2];v[d+16>>2]=e;f=v[a+20>>2];v[d+28>>2]=c;v[d+24>>2]=b;b=f-e|0;v[d+20>>2]=b;f=b+c|0;i=2;b=d+16|0;a:{while(1){b:{c:{d:{if(!bx(ib(v[a+60>>2],b|0,i|0,d+12|0)|0)){g=v[d+12>>2];if((g|0)==(f|0)){break d}if((g|0)>=0){break c}break b}if((f|0)!=-1){break b}}b=v[a+44>>2];v[a+28>>2]=b;v[a+20>>2]=b;v[a+16>>2]=b+v[a+48>>2];a=c;break a}h=v[b+4>>2];j=h>>>0<g>>>0;e=(j<<3)+b|0;h=g-(j?h:0)|0;v[e>>2]=h+v[e>>2];b=(j?12:4)+b|0;v[b>>2]=v[b>>2]-h;f=f-g|0;i=i-j|0;b=e;continue}break}v[a+28>>2]=0;v[a+16>>2]=0;v[a+20>>2]=0;v[a>>2]=v[a>>2]|32;a=0;if((i|0)==2){break a}a=c-v[b+4>>2]|0}kb=d+32|0;return a|0}function OL(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=C(0),j=C(0),k=0,l=C(0);g=kb-16|0;kb=g;e=u[d>>1];f=u[d+2>>1];if(!(!x[b>>1]|(e|0)>(f|0)|(!(z[c>>2]>C(0))|(f-e|0)>32766))){u[a>>1]=3;f=a+4|0;Lc(f);u[a+28>>1]=65472;v[g+12>>2]=1065353216;RL(f,g+12|0);v[a+32>>2]=0;u[a+30>>1]=0;Lc(a+16|0);h=u[d>>1];u[a+28>>1]=h;e=kb-16|0;kb=e;u[e+14>>1]=x[b>>1];u[e+12>>1]=32767;b=u[Wc(e+14|0,e+12|0)>>1];kb=e+16|0;u[a+30>>1]=b;i=C(D(z[c>>2]));z[a+32>>2]=i;i=te(i,C(C(1)/C(b|0)));ek(f,(u[d+2>>1]-h|0)+1|0);b=v[a+4>>2];c=u[a+28>>1];e=u[d+2>>1];d=u[d>>1];while(1){if((d|0)>(e|0)){Ip(a)}else{j=te(i,C(d|0));k=Eb(b,d-c|0),l=j,z[k>>2]=l;d=d+1|0;continue}break}h=1}kb=g+16|0;return h|0}function rX(){var a=0,b=0,c=0,d=0;a=bD(v[v[116822]-12>>2]+467288|0,10);c=kb-16|0;kb=c;v[23540]=0;b=Q(13,c+8|0,467288)|0;d=v[23540];v[23540]=0;a:{b:{c:{d:{if((d|0)!=1){e:{if(!w[b|0]){break e}d=Tm(c,467288);v[23540]=0;a=Q(21,d|0,a|0)|0;d=v[23540];v[23540]=0;if((d|0)!=1){if(!Zu(a)){break e}a=v[v[116822]-12>>2];v[23540]=0;R(16,a+467288|0,1);a=v[23540];v[23540]=0;if((a|0)!=1){break e}}a=V(0)|0;O()|0;zk(b);break d}zk(b);break c}a=V(0)|0;O()|0}_(a|0)|0;b=v[v[116822]-12>>2];v[23540]=0;Y(17,b+467288|0);b=v[23540];v[23540]=0;if((b|0)==1){break b}$()}kb=c+16|0;break a}c=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(c|0);L()}V(0)|0;O()|0;Vb();L()}ar(467288)}function _n(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0;a:{if(c){t[b+809|0]=c;break a}c=w[b+809|0]}e=v[a+480180>>2];d=e&202376205?(c&240?-16:15)&c:c;c=v[b+688>>2];b:{if(e&69206029){break b}g=d&240;f=d&15;if((f|0)==15){if(g){Zn(a,b,(d&240)>>>4|0,0);return}if(!(t[b+851|0]&1)){break b}c=w[a+480208|0]&2?c:c-60|0;break b}if((g|0)!=240){break b}if(f){Yn(a,b,f,0);return}if(!(t[b+851|0]&1)){break b}c=w[a+480208|0]&2?c:c+60|0}c:{if(!(!(t[b+851|0]&1)|w[a+480208|0]&2)&(v[a+1074416>>2]!=1|(e|0)!=524288)){break c}a=d&255;d=d&15;d:{if(d){if(a&240?e&16777248:0){break c}c=c-(d<<2)|0;break d}c=(a>>>2&60)+c|0}if((e|0)!=1){break c}v[b+88>>2]=v[b+88>>2]|2097152}h=b,i=Zb(c,0,256),v[h+688>>2]=i}function Xda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;b=kb-16|0;kb=b;i=v[a+16>>2];h=Tf(1,2);e=nb;j=e;Rb(a,h,e);f=v[a+40>>2];g=v[a+36>>2];e=v[a+4>>2];v[b+8>>2]=v[a>>2];v[b+12>>2]=e;k=v[a+32>>2];l=v[a+28>>2];m=v[a+8>>2];n=v[a+12>>2];while(1){if(d){d=d-1|0;o=(((v[b+12>>2]&2147483647)<<1|v[b+8>>2]>>>31)&-2)+i|0;e=0;while(1){if((e|0)!=2){v[(e<<2)+b>>2]=t[e+o|0]<<8;e=e+1|0;continue}break}g=g+l|0;v[c>>2]=v[c>>2]+B(v[b>>2],g>>12);f=f+k|0;v[c+4>>2]=v[c+4>>2]+B(v[b+4>>2],f>>12);Rb(b+8|0,m,n);c=c+8|0;continue}break}c=v[b+12>>2];v[a>>2]=v[b+8>>2];v[a+4>>2]=c;v[a+40>>2]=f;v[a+20>>2]=g>>12;v[a+36>>2]=g;v[a+24>>2]=f>>12;mg(a,h,j);kb=b+16|0}function Sca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;f=kb-16|0;kb=f;g=v[a+24>>2];h=v[a+20>>2];i=v[a+16>>2];e=v[a+4>>2];v[f+8>>2]=v[a>>2];v[f+12>>2]=e;j=b+24|0;k=v[a+8>>2];l=v[a+12>>2];while(1){if(d){b=(v[f+12>>2]<<1)+i|0;e=(((v[f+8>>2]>>>16|0)+4&131064)<<1)+j|0;b=(((((B(u[b+4>>1],u[e+10>>1])+B(u[b+2>>1],u[e+8>>1])|0)+B(u[b+6>>1],u[e+12>>1])|0)+B(u[b+8>>1],u[e+14>>1])|0)/2|0)+((((B(u[b-4>>1],u[e+2>>1])+B(u[b-6>>1],u[e>>1])|0)+B(u[b-2>>1],u[e+4>>1])|0)+B(u[b>>1],u[e+6>>1])|0)/2|0)|0)/16384|0;v[c>>2]=v[c>>2]+B(b,h);v[c+4>>2]=v[c+4>>2]+B(b,g);Rb(f+8|0,k,l);c=c+8|0;d=d-1|0;continue}break}b=v[f+12>>2];v[a>>2]=v[f+8>>2];v[a+4>>2]=b;kb=f+16|0}function oH(a){var b=0,c=0,d=0,e=0,f=0;c=kb-192|0;kb=c;b=c+16|0;qi(b,a);v[23540]=0;R(88,c+32|0,b|0);a=v[23540];v[23540]=0;a:{b:{c:{d:{if((a|0)!=1){v[23540]=0;a=Q(89,c+48|0,c+32|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break d}zb(c+32|0);zb(c+16|0);b=v[v[a>>2]-12>>2];v[23540]=0;d=ga(62)|0;e=v[23540];v[23540]=0;if((e|0)==1){break b}v[23540]=0;U(63,c+8|0,a+b|0,d|0);b=v[23540];v[23540]=0;if((b|0)==1){break b}ac(c+8|0);v[23540]=0;b=Q(94,a|0,c+32|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break b}a=Yk(v[(b+v[v[b>>2]-12>>2]|0)+16>>2]);f=A[c+32>>3];sf(b);kb=c+192|0;return a?0:f}b=P()|0;O()|0;break c}b=P()|0;O()|0;zb(c+32|0)}zb(c+16|0);break a}b=P()|0;O()|0;sf(a)}T(b|0);L()}function Qea(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;e=kb-16|0;kb=e;i=e,j=Aj(b),v[i>>2]=j;d=kb-16|0;kb=d;g=a;c=Td(a);a:{if(c){f=jc(g);while(1){a=c;c=a+13|0;if(Ht(b,c)){f=a;c=v[a>>2];if(c){continue}break a}if(!Ht(c,b)){break a}f=a+4|0;c=v[a+4>>2];if(c){continue}break}break a}a=jc(g);f=a}v[d+12>>2]=a;b=v[f>>2];if(!b){c=kb-16|0;kb=c;a=jc(g);h=lh(d,vc(20),mh(c+8|0,a));b=v[h>>2];a=v[e>>2];a=w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24);t[b+17|0]=0;t[b+13|0]=a;t[b+14|0]=a>>>8;t[b+15|0]=a>>>16;t[b+16|0]=a>>>24;i=jc(h),j=1,t[i+4|0]=j;kb=c+16|0;Jg(g,v[d+12>>2],f,v[d>>2]);b=ce(d);rk(d);h=1}Ig(e+8|0,v[fc(d,b)>>2],h);kb=d+16|0;kb=e+16|0;return v[e+8>>2]+17|0}function rz(a,b,c){var d=0,e=0,f=0,g=0;d=Nb(a);a=Hb(b);v[23540]=0;R(46,d|0,a|0);a=v[23540];v[23540]=0;if((a|0)!=1){a:{while(1){if(Hb(b)>>>0>e>>>0){f=v[qj(b,e)>>2];g=f&-32;a=32;b:{while(1){c:{if((a|0)==256){a=0;break c}if((g|0)==128|v[(a<<2)+c>>2]!=(f|0)){a=a+1|0;continue}else{v[23540]=0;R(47,d|0,a<<24>>24);a=v[23540];v[23540]=0;if((a|0)!=1){break b}break a}}break}d:{while(1){if((a|0)==32){break d}if(v[(a<<2)+c>>2]!=(f|0)){a=a+1|0;continue}break}v[23540]=0;R(47,d|0,a<<24>>24);a=v[23540];v[23540]=0;if((a|0)!=1){break b}break a}v[23540]=0;R(47,d|0,63);a=v[23540];v[23540]=0;if((a|0)!=1){break b}break a}e=e+1|0;continue}break}return}}a=P()|0;O()|0;zb(d);T(a|0);L()}function Yha(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;d=kb-32|0;kb=d;v[d+28>>2]=0;pk(a,d+28|0);a:{b:{i=v[d+28>>2];c:{if(i>>>0>500){break c}d:{e:{while(1){if((f|0)==(i|0)){break c}g=Nb(d+16|0);v[23540]=0;u[d+14>>1]=0;e=W(483,a|0,g|0,255)|0;h=v[23540];v[23540]=0;if((h|0)==1){break b}if(!e){break d}v[23540]=0;R(472,a|0,d+14|0);e=v[23540];v[23540]=0;if((e|0)==1){break b}v[23540]=0;U(11,d|0,c|0,g|0);e=v[23540];v[23540]=0;if((e|0)!=1){v[23540]=0;e=Q(484,b|0,d+14|0)|0;h=v[23540];v[23540]=0;if((h|0)==1){break e}Jb(e,d);Ab(d);zb(g);f=f+1|0;continue}break}f=P()|0;O()|0;break a}f=P()|0;O()|0;Ab(d);break a}zb(g)}kb=d+32|0;return}f=P()|0;O()|0}zb(g);T(f|0);L()}function Cja(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;e=kb-32|0;kb=e;v[e+24>>2]=b;j=e,k=he(a),v[j+8>>2]=k;f=Pn(e+24|0,e+8|0);a:{b:{h=Th(c,d);if(!h){break b}if(!Xs(a,c)){b=Hb(a);g=bd(a);c:{if(g-b>>>0>=h>>>0){g=Ac(a);if((b|0)==(f|0)){break c}i=f+g|0;Yh(i+h|0,i,b-f|0);break c}rm(a,g,(b+h|0)-g|0,b,f,0,h);g=v[a>>2]}b=b+h|0;Sh(a,b);t[e+8|0]=0;we(b+g|0,e+8|0);b=f+g|0;while(1){if((c|0)==(d|0)){break b}we(b,c);c=c+1|0;b=b+1|0;continue}}d=Vh(e+8|0,c,d);c=Mc(d);f=Hb(d);v[23540]=0;c=fa(356,a|0,b|0,c|0,c+f|0)|0;a=v[23540];v[23540]=0;if((a|0)!=1){zb(d);break a}a=P()|0;O()|0;zb(d);T(a|0);L()}j=e,k=he(a),v[j+8>>2]=k;c=Jp(e+8|0,f)}kb=e+32|0;return c|0}function v6(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;e=kb-16|0;kb=e;v[23540]=0;Y(946,a|0);d=v[23540];v[23540]=0;a:{b:{c:{if((d|0)==1){break c}v[23540]=0;Y(947,b|0);d=v[23540];v[23540]=0;if((d|0)==1){break c}v[23540]=0;Y(947,c|0);f=v[23540];v[23540]=0;d=1;if((f|0)==1){break c}f=v[a+24>>2];b=rc(e+8|0,b);c=rc(e,c);g=v[c+4>>2];c=v[c>>2];h=v[b+4>>2];b=v[b>>2];v[23540]=0;pF(968,f,b,h,c,g);b=v[23540];v[23540]=0;if((b|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,5510,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)==1){break a}$();d=0}kb=e+16|0;return d|0}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function Xha(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;d=kb-32|0;kb=d;u[d+30>>1]=0;Wf(a,d+30|0);a:{b:{i=x[d+30>>1];c:{if(i>>>0>500){break c}d:{e:{while(1){if((f|0)==(i|0)){break c}g=Nb(d+16|0);v[23540]=0;u[d+14>>1]=0;e=Q(485,a|0,g|0)|0;h=v[23540];v[23540]=0;if((h|0)==1){break b}if(!e){break d}v[23540]=0;R(472,a|0,d+14|0);e=v[23540];v[23540]=0;if((e|0)==1){break b}v[23540]=0;U(11,d|0,c|0,g|0);e=v[23540];v[23540]=0;if((e|0)!=1){v[23540]=0;e=Q(484,b|0,d+14|0)|0;h=v[23540];v[23540]=0;if((h|0)==1){break e}Jb(e,d);Ab(d);zb(g);f=f+1|0;continue}break}f=P()|0;O()|0;break a}f=P()|0;O()|0;Ab(d);break a}zb(g)}kb=d+32|0;return}f=P()|0;O()|0}zb(g);T(f|0);L()}function XN(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;g=kb-112|0;kb=g;v[g+108>>2]=0;e=Xn(a,e&65535,d,c,g+108|0);f=w[b+790|0];if(!v[g+108>>2]){d=(f|0)==15;c=d&!w[b+792|0];e=e<<8;a:{if(e){v[b+664>>2]=e;break a}e=0;if(d){break a}e=v[b+664>>2]}h=c?0:w[b+836|0]<<16}if((f|0)==15){c=w[b+792|0];b:{if(!c){c=v[b+76>>2];v[g>>2]=1;f=v[_c(g,g+108|0)>>2]<<3;d=Jka(c,0,e,0);e=(256<<f>>>1|0)+d|0;c=nb;c=d>>>0>e>>>0?c+1|0:c;d=f+8|0;f=d&31;if((d&63)>>>0>=32){d=0;c=c>>>f|0}else{d=c>>>f|0;c=((1<<f)-1&c)<<32-f|e>>>f}e=Ec(c,d);break b}eB(g);if(c>>>0>9){break b}c=v[b+104>>2];if(!c){break b}e=v[Eb(c+68|0,w[b+792|0]-1|0)>>2]+e|0}v[b+664>>2]=e}$n(a,b,e+h|0);kb=g+112|0}function HL(a,b,c){var d=0,e=0,f=0,g=0,h=0;a:{e=kb-48|0;kb=e;d=Nb(e+32|0);v[23540]=0;R(889,b|0,e+24|0);f=v[23540];v[23540]=0;if((f|0)!=1){b:{g=v[e+28>>2];f=v[e+24>>2];$f(d);v[23540]=0;f=!g&f>>>0<255?f:255;R(60,d|0,f|0);g=v[23540];v[23540]=0;if((g|0)==1){break b}c:{while(1){if((f|0)==(h|0)){b=pV(Mc(d),Hb(d));if((b|0)==-1){break c}v[23540]=0;R(60,d|0,b|0);b=v[23540];v[23540]=0;if((b|0)!=1){break c}break b}g=Tc(d,h);v[23540]=0;Q(890,b|0,g|0)|0;g=v[23540];v[23540]=0;if((g|0)!=1){h=h+1|0;continue}break}break b}v[23540]=0;U(11,e+8|0,a|0,d|0);a=v[23540];v[23540]=0;if((a|0)==1){break b}a=e+8|0;Jb(c,a);Ab(a);zb(d);kb=e+48|0;break a}}a=P()|0;O()|0;zb(d);T(a|0);L()}}function vy(a){var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=kb-16|0;kb=e;b=v[a>>2];if(!pc(b,v[a+4>>2])){b=Fb(b);v[e+8>>2]=b;c=Fb(v[a+4>>2]);while(1){if(Pb(b,c)){So(b,4194304,67108864);g=v[b>>2];f=g+f|0;b=d;b=f>>>0<g>>>0?b+1|0:b;d=b;b=v[Le(e+8|0)>>2];continue}else{c=v[a>>2];b=uc(c,v[a+4>>2]);l=e,m=Fb(c),v[l>>2]=m;d=Mka(f,d,b,0);h=d;g=((nb&1)<<31|d>>>1)&2147483647;f=b<<24;d=0;i=Fb(v[a+4>>2]);while(1){b=v[e>>2];if(Pb(b,i)){j=b;c=v[b>>2];b=c>>>8|0;c=g+(c<<24)|0;b=b+k|0;b=Ec(Mka(c,c>>>0<g>>>0?b+1|0:b,h,k),nb);v[j>>2]=b;c=f;f=c-b|0;d=d-(b>>>0>c>>>0)|0;Le(e);continue}else{d=v[a>>2];if(!uc(d,v[a+4>>2])){ev();L()}v[d>>2]=f+v[d>>2]}break}}break}}kb=e+16|0}function Ft(a,b){var c=0,d=0,e=0;c=kb-48|0;kb=c;d=c+24|0;jQ(d,a+8|0,a+10|0,a+12|0,a+16|0,a+14|0);jQ(c,b+8|0,b+10|0,b+12|0,b+16|0,b+14|0);a=v[d>>2];b=w[a|0]|w[a+1|0]<<8;a=v[c>>2];b=Et(b,w[a|0]|w[a+1|0]<<8);a:{if(!yj(b)){break a}a=v[d+4>>2];b=w[a|0]|w[a+1|0]<<8;a=v[c+4>>2];b=Et(b,w[a|0]|w[a+1|0]<<8);if(!yj(b)){break a}a=v[d+8>>2];b=w[a|0]|w[a+1|0]<<8;a=v[c+8>>2];b=Et(b,w[a|0]|w[a+1|0]<<8);if(!yj(b)){break a}a=v[c+12>>2];e=(w[a|0]|w[a+1|0]<<8)<<16>>16;a=v[d+12>>2];b=pe((w[a|0]|w[a+1|0]<<8)<<16>>16);a=pe(e);b=(a|0)==(b|0)?0:(b|0)<(a|0)?-1:1;if(!yj(b)){break a}a=v[d+16>>2];b=w[a|0]|w[a+1|0]<<8;a=v[c+16>>2];b=Et(b,w[a|0]|w[a+1|0]<<8)}a=kf(b);kb=c+48|0;return a}function Tca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;f=kb-16|0;kb=f;g=v[a+24>>2];h=v[a+20>>2];i=v[a+16>>2];e=v[a+4>>2];v[f+8>>2]=v[a>>2];v[f+12>>2]=e;j=b+24|0;k=v[a+8>>2];l=v[a+12>>2];while(1){if(d){b=v[f+12>>2]+i|0;e=(((v[f+8>>2]>>>16|0)+4&131064)<<1)+j|0;b=(((((B(t[b+2|0],u[e+10>>1])+B(t[b+1|0],u[e+8>>1])|0)+B(t[b+3|0],u[e+12>>1])|0)+B(t[b+4|0],u[e+14>>1])<<8)/2|0)+((((B(t[b-2|0],u[e+2>>1])+B(t[b-3|0],u[e>>1])|0)+B(t[b-1|0],u[e+4>>1])|0)+B(t[b|0],u[e+6>>1])<<8)/2|0)|0)/16384|0;v[c>>2]=v[c>>2]+B(b,h);v[c+4>>2]=v[c+4>>2]+B(b,g);Rb(f+8|0,k,l);c=c+8|0;d=d-1|0;continue}break}b=v[f+12>>2];v[a>>2]=v[f+8>>2];v[a+4>>2]=b;kb=f+16|0}function KI(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0;d=kb-16|0;kb=d;a:{b:{c:{d:{if((b|0)>=0){a=v[a+32>>2];if((Og(a)|0)>(b|0)){break d}}a=ba(8)|0;v[23540]=0;d=Q(55,d|0,10725)|0;b=v[23540];v[23540]=0;if((b|0)==1){break c}a=tc(a,d);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break a}b=P()|0;O()|0;zb(d);break b}if(c<0|c>1){a=ba(8)|0;v[23540]=0;d=Q(55,d|0,11741)|0;b=v[23540];v[23540]=0;if((b|0)!=1){a=tc(a,d);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break a}b=P()|0;O()|0;zb(d);break b}b=P()|0;O()|0;ca(a|0);break b}e=(a+B(b,872)|0)+1075740|0,f=xl(c*64),v[e>>2]=f;kb=d+16|0;return}b=P()|0;O()|0;ca(a|0)}T(b|0)}L()}function n5(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;e=kb-32|0;kb=e;f=Tb(a);a=b;b=x[v[b+24>>2]+480192>>1];v[23540]=0;R(181,f|0,b|0);c=v[23540];v[23540]=0;b=1;a:{if((c|0)!=1){b:{c:{d:{e:{while(1){d=b&65535;c=v[a+24>>2];if(d>>>0>x[c+480192>>1]){break b}c=CM(c,d);v[23540]=0;c=Q(55,e|0,c|0)|0;d=v[23540];v[23540]=0;if((d|0)!=1){d=v[a+24>>2];v[23540]=0;U(1003,e+16|0,d|0,c|0);d=v[23540];v[23540]=0;if((d|0)==1){break e}v[23540]=0;R(183,f|0,e+16|0);d=v[23540];v[23540]=0;if((d|0)==1){break d}zb(e+16|0);zb(c);b=b+1|0;continue}break}b=P()|0;O()|0;break a}b=P()|0;O()|0;break c}b=P()|0;O()|0;zb(e+16|0)}zb(c);break a}kb=e+32|0;return}b=P()|0;O()|0}Xe(f);T(b|0);L()}function Hv(a,b,c,d){var e=0,f=0,g=0;e=kb-48|0;kb=e;v[e+44>>2]=d;a:{f=v[b>>2];b:{if(!(ob[v[v[f>>2]+36>>2]](f,c,d)|0)){Kh(a);break b}Nl(e+24|0,v[b>>2],v[b+4>>2]);b=v[b>>2];d=v[v[b>>2]+24>>2];v[23540]=0;b=S(d|0,b|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break a}v[e+20>>2]=b-c;d=v[e+24>>2];f=v[e+28>>2];g=v[Kb(e+44|0,e+20|0)>>2];b=kb-16|0;kb=b;v[b+12>>2]=f;v[b+8>>2]=d;d=Nl(b,d,f);f=v[d+4>>2];d=v[d>>2];v[23540]=0;da(172,e+32|0,d|0,f|0,c|0,g|0);c=v[23540];v[23540]=0;c:{if((c|0)!=1){le(b+8|0);kb=b+16|0;break c}a=P()|0;O()|0;le(b+8|0);T(a|0);L()}b=ee(e+8|0);LD(a,v[e+32>>2],v[e+36>>2],v[b>>2],v[b+4>>2])}kb=e+48|0;return}a=P()|0;O()|0;le(e+24|0);T(a|0);L()}function sda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;b=kb-16|0;kb=b;f=v[a+40>>2];g=v[a+36>>2];i=v[a+16>>2];e=v[a+4>>2];v[b+8>>2]=v[a>>2];v[b+12>>2]=e;j=v[a+32>>2];k=v[a+28>>2];l=v[a+8>>2];m=v[a+12>>2];while(1){if(d){e=(v[b+12>>2]<<1)+i|0;h=v[b+8>>2]>>>21&2040;e=(((B(u[e>>1],u[h+39778>>1])+B(u[e-2>>1],u[h+39776>>1])|0)+B(u[e+2>>1],u[h+39780>>1])|0)+B(u[e+4>>1],u[h+39782>>1])|0)/16384|0;g=g+k|0;v[c>>2]=v[c>>2]+B(e,g>>12);f=f+j|0;v[c+4>>2]=v[c+4>>2]+B(e,f>>12);Rb(b+8|0,l,m);c=c+8|0;d=d-1|0;continue}break}c=v[b+12>>2];v[a>>2]=v[b+8>>2];v[a+4>>2]=c;v[a+40>>2]=f;v[a+20>>2]=g>>12;v[a+36>>2]=g;v[a+24>>2]=f>>12;kb=b+16|0}function zn(a,b,c,d,e,f,g,h,i,j){var k=0,l=0;a:{b:{k=v[d>>2];if((k|0)!=(c|0)){break b}l=43;if(v[j+96>>2]!=(a|0)){l=45;if(v[j+100>>2]!=(a|0)){break b}}v[d>>2]=c+1;t[c|0]=l;break a}c:{if(!(!Hb(g)|(a|0)!=(f|0))){g=0;a=v[i>>2];if((a-h|0)>159){break c}b=v[e>>2];v[i>>2]=a+4;v[a>>2]=b;break a}g=-1;f=vw(j,j+104|0,a)-j|0;if((f|0)>92){break c}a=f>>2;d:{e:{switch(b-8|0){case 0:case 2:if((a|0)<(b|0)){break d}break c;case 1:break d;default:break e}}if((b|0)!=16|(f|0)<88){break d}if((c|0)==(k|0)|(k-c|0)>2|w[k-1|0]!=48){break c}v[e>>2]=0;v[d>>2]=k+1;t[k|0]=w[a+83808|0];return 0}v[d>>2]=k+1;t[k|0]=w[a+83808|0];v[e>>2]=v[e>>2]+1;g=0}return g}v[e>>2]=0;return 0}function yia(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;g=b;c=kb-48|0;kb=c;d=a;a:{if(hu(v[d>>2],v[d+8>>2])){v[g>>2]=0;break a}cT(c+16|0,c+32|0);nc(c+24|0,v[d>>2],v[d+8>>2],v[c+16>>2],v[c+20>>2]);h=v[c+28>>2];i=w[c+32|0];f=i&127;v[g>>2]=f;a=f;b=0;while(1){if(a){b=b+1|0;a=a>>>1|0;continue}break}a=b;e=1;while(1){b=(B(h,7)+a|0)+B(e,-7)|0;b:{while(1){if(i<<24>>24>=0|e>>>0>=h>>>0){break b}i=w[(c+32|0)+e|0];f=i&127|f<<7;v[g>>2]=f;a=a+7|0;e=e+1|0;if((h|0)!=(e|0)){continue}break}$b(d,h);cT(c+8|0,c+32|0);nc(c+24|0,v[d>>2],v[d+8>>2],v[c+8>>2],v[c+12>>2]);h=v[c+28>>2];f=v[g>>2];e=0;a=b;continue}break}$b(d,e);if(a>>>0<33){break a}v[g>>2]=-1}kb=c+48|0}function FN(a,b,c,d,e){var f=0,g=0,h=0,i=0;a:{b:{c:{if(t[b+851|0]&1){f=w[b+848|0];g=c&240;if(g){f=f&15|g;t[b+848|0]=f}c=c&15;if(c){f=c|f&-16;t[b+848|0]=f}t[b+849|0]=(f&240)>>>4;if(v[a+480180>>2]!=32768){break a}break c}if(v[a+480180>>2]==32768){break c}c=w[b+849|0]-1|0;t[b+849|0]=c;if(c&255){break a}f=w[b+848|0];break b}f=w[b+848|0];if((f&240)==16){break b}if(!(w[a+480209|0]&16)){break a}}t[b+849|0]=(f&240)>>>4;c=f&15;c=d?c:0-c|0;d=v[b+656>>2];d:{if(xj(d)){v[b+852>>2]=v[b+852>>2]+B(c,v[v[d+44>>2]+36>>2]);break d}h=b,i=eh(a,et(a,v[b+700>>2],u[b+772>>1],v[b+704>>2])+c|0,u[b+772>>1],v[b+704>>2]),v[h+700>>2]=i}if(!e){break a}v[b>>2]=0;v[b+4>>2]=0}}function R4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;e=kb-32|0;kb=e;f=Tb(a);a=b;b=x[v[b+24>>2]+480190>>1];v[23540]=0;R(181,f|0,b|0);d=v[23540];v[23540]=0;b=1;a:{if((d|0)!=1){b:{c:{d:{e:{while(1){c=b&65535;d=v[a+24>>2];if(c>>>0>x[d+480190>>1]){break b}v[23540]=0;d=Q(55,e|0,DM(d,c)|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){c=v[a+24>>2];v[23540]=0;U(1003,e+16|0,c|0,d|0);c=v[23540];v[23540]=0;if((c|0)==1){break e}v[23540]=0;R(183,f|0,e+16|0);c=v[23540];v[23540]=0;if((c|0)==1){break d}zb(e+16|0);zb(d);b=b+1|0;continue}break}b=P()|0;O()|0;break a}b=P()|0;O()|0;break c}b=P()|0;O()|0;zb(e+16|0)}zb(d);break a}kb=e+32|0;return}b=P()|0;O()|0}Xe(f);T(b|0);L()}function um(a,b,c,d){var e=0,f=0;e=kb-16|0;kb=e;f=a+1074312|0;Db(e+8|0,f,84);a:{if(Cb(v[v[e+8>>2]>>2],v[e+12>>2])){break a}b:{if(v[a+480208>>2]&16384){break b}if((d|0)!=8){Db(e+8|0,f,10);if(!Cb(v[v[e+8>>2]>>2],v[e+12>>2])){break b}}v[b+88>>2]=v[b+88>>2]&-257}c:{d:{e:{switch(d-4|0){case 0:c=((c<<8|8)>>>0)/15|0;break d;case 2:c=(c>>>0<64?c:64)<<2;break d;default:break e}}if(!(v[a+480180>>2]&2107410)){break d}if(c>>>0<=128){c=c<<1;break d}if((c|0)!=164){break c}v[b+88>>2]=v[b+88>>2]|256;c=128}v[b+692>>2]=c}u[b+784>>1]=0;v[b+88>>2]=v[b+88>>2]|2097152;Db(e+8|0,f,10);if(!Cb(v[v[e+8>>2]>>2],v[e+12>>2])){break a}t[b+831|0]=0;u[b+778>>1]=0}kb=e+16|0}function tz(a,b,c,d,e){var f=0,g=0,h=0,i=0;g=kb-16|0;kb=g;i=pl(a,b);a:{if((i|0)==255){break a}if(kk(v[a>>2])){break a}b:{if(c>>>0>6208431){f=7;c=1023;break b}f=7;c:{if(c>>>0>3104215){break c}f=6;if(c>>>0>1552107){break c}f=5;if(c>>>0>776053){break c}f=4;if(c>>>0>388026){break c}f=3;if(c>>>0>194013){break c}f=2;if(c>>>0>97006){break c}f=c>>>0>48503}c=Jka(1<<20-f,0,c,0)+24858e3|0;h=nb;c=Ec(Mka(c,c>>>0<24858e3?h+1|0:h,49716e3,0),nb)}if(e){u[g+14>>1]=(b&3)+c;u[g+12>>1]=1023;c=x[Wc(g+14|0,g+12|0)>>1]}h=wt(i);e=Lb(a+8|0,i);t[e|0]=(f<<10|c)>>>8|(d?0:32);gh(v[a>>2],v[a+4>>2],b,h|160,c&255);gh(v[a>>2],v[a+4>>2],b,h|176,w[e|0]);t[a+534|0]=1}kb=g+16|0}function c1(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;g=kb-16|0;kb=g;a:{b:{if(!pc(b,-1)){i=v[a+8>>2];j=v[a+12>>2];d=v[a+24>>2];if((d|0)==v[a+28>>2]){e=-1;if(!(w[a+48|0]&16)){break a}h=v[a+20>>2];k=v[a+44>>2];v[23540]=0;c=a+32|0;R(47,c|0,0);f=v[23540];v[23540]=0;if((f|0)==1){break b}f=bd(c);v[23540]=0;R(60,c|0,f|0);f=v[23540];v[23540]=0;if((f|0)==1){break b}e=Ac(c);Pw(a,e,Hb(c)+e|0);bs(a,d-h|0);v[a+44>>2]=v[a+20>>2]+(k-h|0);d=v[a+24>>2]}v[g+12>>2]=d+1;d=v[_c(g+12|0,a+44|0)>>2];v[a+44>>2]=d;if(w[a+48|0]&8){c=Ac(a+32|0);Cn(a,c,c+(j-i|0)|0,d)}e=xH(a,sp(b));break a}e=Ow(b);break a}a=V(0)|0;O()|0;_(a|0)|0;$()}kb=g+16|0;return e|0}function Bba(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=kb-80|0;kb=d;e=zf(d+48|0);v[23540]=0;g=Q(797,b|0,e|0)|0;f=v[23540];v[23540]=0;a:{b:{c:{if((f|0)!=1){if(g){break c}v[a>>2]=0;v[a+4>>2]=0;v[a+24>>2]=0;v[a+16>>2]=0;v[a+20>>2]=0;v[a+8>>2]=0;v[a+12>>2]=0;v[23540]=0;S(798,a|0)|0;a=v[23540];v[23540]=0;if((a|0)!=1){break b}}break a}g=v[e+4>>2];v[23540]=0;U(190,d|0,b|0,g|0);f=v[23540];v[23540]=0;if((f|0)==1){break a}f=kc(d+24|0,d);hd(e+8|0,f);Bb(f);Bb(d);d:{if(c>>>0<2){break d}c=g&1;if(!c){break d}v[23540]=0;Q(188,b|0,2-c|0)|0;b=v[23540];v[23540]=0;if((b|0)!=1){break d}break a}xk(a,e)}Bd(e);kb=d+80|0;return}a=P()|0;O()|0;Bd(e);T(a|0);L()}function C1(){var a=0,b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0;e=kb-32|0;kb=e;if(_H(1,e+16|0)){is(v[116016],12700);L()}c=hs(e+8|0,v[e+16>>2]);g=hs(e,v[e+20>>2]);d=kb-32|0;kb=d;b=kb-16|0;kb=b;a=kb-16|0;kb=a;h=a,i=Jka(v[c>>2],v[c+4>>2],1e9,0),v[h>>2]=i;v[a+4>>2]=nb;c=zt(a+8|0,a);f=v[c+4>>2];c=v[c>>2];kb=a+16|0;v[b+8>>2]=c;v[b+12>>2]=f;a=v[b+12>>2];v[d+8>>2]=v[b+8>>2];v[d+12>>2]=a;kb=b+16|0;f=v[d+8>>2];c=v[d+12>>2];a=v[g+4>>2];v[d>>2]=v[g>>2];v[d+4>>2]=a;a=d;c=v[a+4>>2]+c|0;b=v[a>>2];f=f+b|0;v[a+16>>2]=f;v[a+20>>2]=b>>>0>f>>>0?c+1|0:c;a=zt(a+24|0,a+16|0);b=v[a+4>>2];a=v[a>>2];kb=d+32|0;a=cm(e+24|0,a,b);b=v[a+4>>2];a=v[a>>2];kb=e+32|0;nb=b;return a|0}function tda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;b=kb-16|0;kb=b;f=v[a+40>>2];g=v[a+36>>2];i=v[a+16>>2];e=v[a+4>>2];v[b+8>>2]=v[a>>2];v[b+12>>2]=e;j=v[a+32>>2];k=v[a+28>>2];l=v[a+8>>2];m=v[a+12>>2];while(1){if(d){e=v[b+12>>2]+i|0;h=v[b+8>>2]>>>21&2040;e=(((B(t[e|0],u[h+39778>>1])+B(t[e-1|0],u[h+39776>>1])|0)+B(t[e+1|0],u[h+39780>>1])|0)+B(t[e+2|0],u[h+39782>>1])<<8)/16384|0;g=g+k|0;v[c>>2]=v[c>>2]+B(e,g>>12);f=f+j|0;v[c+4>>2]=v[c+4>>2]+B(e,f>>12);Rb(b+8|0,l,m);c=c+8|0;d=d-1|0;continue}break}c=v[b+12>>2];v[a>>2]=v[b+8>>2];v[a+4>>2]=c;v[a+40>>2]=f;v[a+20>>2]=g>>12;v[a+36>>2]=g;v[a+24>>2]=f>>12;kb=b+16|0}function ol(a,b,c){var d=0,e=0,f=0;d=Nb(a);a=Hb(b);v[23540]=0;R(46,d|0,a|0);a=v[23540];v[23540]=0;if((a|0)!=1){a:{while(1){if(Hb(b)>>>0>e>>>0){f=v[qj(b,e)>>2];a=32;b:{while(1){c:{if((a|0)==256){a=0;break c}if(v[(a<<2)+c>>2]==(f|0)){v[23540]=0;R(47,d|0,a<<24>>24);a=v[23540];v[23540]=0;if((a|0)!=1){break b}break a}else{a=a+1|0;continue}}break}d:{while(1){if((a|0)==32){break d}if(v[(a<<2)+c>>2]!=(f|0)){a=a+1|0;continue}break}v[23540]=0;R(47,d|0,a<<24>>24);a=v[23540];v[23540]=0;if((a|0)!=1){break b}break a}v[23540]=0;R(47,d|0,63);a=v[23540];v[23540]=0;if((a|0)!=1){break b}break a}e=e+1|0;continue}break}return}}a=P()|0;O()|0;zb(d);T(a|0);L()}function NX(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;c=kb-32|0;kb=c;a:{b:{c:{d:{if(h=sh(v[b+4>>2],w[b+11|0]),i=1,j=v[b+12>>2],j?h:i){Nb(a);break d}e=Nb(c+16|0);d=Ad(v[b+4>>2],w[b+11|0]);f=pr(14339);g=sd(b);v[23540]=0;X(102,e|0,g|0,d|0,d+f|0);d=v[23540];v[23540]=0;e:{if((d|0)!=1){v[23540]=0;W(103,e|0,14339,f|0)|0;d=v[23540];v[23540]=0;if((d|0)!=1){break e}}a=P()|0;O()|0;Ab(e);T(a|0);L()}v[23540]=0;R(132,c|0,b+12|0);b=v[23540];v[23540]=0;if((b|0)==1){break c}v[23540]=0;U(2,a|0,c+16|0,c|0);a=v[23540];v[23540]=0;if((a|0)==1){break b}Ab(c);Ab(c+16|0)}kb=c+32|0;return}b=P()|0;O()|0;break a}b=P()|0;O()|0;Ab(c)}Ab(c+16|0);T(b|0);L()}function G2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;e=kb-32|0;kb=e;h=Nb(a);f=Nb(e+16|0);a=1;a:{b:{c:{while(1){d=a&65535;c=v[b+24>>2];if(d>>>0>x[c+480192>>1]){if(!(i&1)){break c}v[23540]=0;R(247,h|0,f|0);a=v[23540];v[23540]=0;if((a|0)!=1){break c}a=P()|0;O()|0;break a}c=CM(c,d);v[23540]=0;c=Q(55,e|0,c|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break b}d=Re(c);v[23540]=0;g=Q(800,f|0,c|0)|0;j=v[23540];v[23540]=0;d:{if((j|0)==1){break d}v[23540]=0;Q(935,g|0,21658)|0;g=v[23540];v[23540]=0;if((g|0)==1){break d}i=d^1|i;zb(c);a=a+1|0;continue}break}a=P()|0;O()|0;zb(c);break a}zb(f);kb=e+32|0;return}a=P()|0;O()|0}zb(f);zb(h);T(a|0);L()}function F2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;e=kb-32|0;kb=e;h=Nb(a);f=Nb(e+16|0);a=1;a:{b:{c:{while(1){d=a&65535;c=v[b+24>>2];if(d>>>0>x[c+480190>>1]){if(!(i&1)){break c}v[23540]=0;R(247,h|0,f|0);a=v[23540];v[23540]=0;if((a|0)!=1){break c}a=P()|0;O()|0;break a}v[23540]=0;c=Q(55,e|0,DM(c,d)|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break b}d=Re(c);v[23540]=0;g=Q(800,f|0,c|0)|0;j=v[23540];v[23540]=0;d:{if((j|0)==1){break d}v[23540]=0;Q(935,g|0,21658)|0;g=v[23540];v[23540]=0;if((g|0)==1){break d}i=d^1|i;zb(c);a=a+1|0;continue}break}a=P()|0;O()|0;zb(c);break a}zb(f);kb=e+32|0;return}a=P()|0;O()|0}zb(f);zb(h);T(a|0);L()}function Xr(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0;h=kb-16|0;kb=h;f=d?d:467812;d=v[f>>2];a:{b:{c:{if(!b){if(d){break c}break a}e=-2;if(!c){break a}i=a?a:h+12|0;d:{if(d){a=c;break d}a=w[b|0];d=a<<24>>24;if((d|0)>=0){v[i>>2]=a;e=(d|0)!=0;break a}if(!v[v[116042]>>2]){v[i>>2]=d&57343;e=1;break a}a=a-194|0;if(a>>>0>50){break c}d=v[(a<<2)+83600>>2];a=c-1|0;if(!a){break b}b=b+1|0}g=w[b|0];j=g>>>3|0;if((j-16|(d>>26)+j)>>>0>7){break c}while(1){a=a-1|0;d=g-128|d<<6;if((d|0)>=0){v[f>>2]=0;v[i>>2]=d;e=c-a|0;break a}if(!a){break b}b=b+1|0;g=w[b|0];if((g&192)==128){continue}break}}v[f>>2]=0;v[116016]=25;e=-1;break a}v[f>>2]=d}kb=h+16|0;return e}function xba(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;d=kb-48|0;kb=d;f=Mc(b);e=Hb(b);h=Mc(c);i=Hb(c);g=-1;a:{if(!e){break a}j=e+f|0;e=f;while(1){if((e|0)==(j|0)){break a}if(Gp(h,i,w[e|0])){e=e+1|0;continue}break}g=e-f|0}b:{c:{if((g|0)!=-1){k=d,l=he(b),v[k+32>>2]=l;f=kj(d+40|0,d+32|0);k=d,l=he(b),v[k+8>>2]=l;k=d,l=Jp(d+8|0,g),v[k+16>>2]=l;c=kj(d+24|0,d+16|0);JL(b,v[f>>2],v[c>>2]);break c}i=Hb(b);if(!i){break c}h=Mc(b);j=Hb(b);e=Mc(c);g=-1;f=Hb(c);if(f){c=h+j|0;d:{while(1){if((c|0)==(h|0)){break d}c=c-1|0;if(!Gp(e,f,w[c|0])){continue}break}g=c-h|0}}if((i-1|0)!=(g|0)){break c}Nb(a);break b}ad(a,b)}kb=d+48|0}function Dba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=kb-80|0;kb=d;e=zf(d+48|0);v[23540]=0;c=Q(793,b|0,e|0)|0;f=v[23540];v[23540]=0;a:{b:{c:{if((f|0)!=1){if(c){break c}v[a>>2]=0;v[a+4>>2]=0;v[a+24>>2]=0;v[a+16>>2]=0;v[a+20>>2]=0;v[a+8>>2]=0;v[a+12>>2]=0;v[23540]=0;S(794,a|0)|0;a=v[23540];v[23540]=0;if((a|0)!=1){break b}}break a}c=v[e+4>>2];v[23540]=0;c=bc(c);c=c?c:-1;U(190,d|0,b|0,c|0);f=v[23540];v[23540]=0;if((f|0)==1){break a}f=kc(d+24|0,d);hd(e+8|0,f);Bb(f);Bb(d);d:{c=c&1;if(!c){break d}v[23540]=0;Q(188,b|0,2-c|0)|0;b=v[23540];v[23540]=0;if((b|0)!=1){break d}break a}xk(a,e)}Bd(e);kb=d+80|0;return}a=P()|0;O()|0;Bd(e);T(a|0);L()}function Mga(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=C(0),g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=kb-16|0;kb=c;a:{b:{d=v[b+8>>2];if((d|0)==v[a+8>>2]){e=v[b+4>>2];if((e|0)!=v[a+4>>2]){break b}v[c+12>>2]=d;v[c+8>>2]=d;d=v[Kb(c+12|0,c+8|0)>>2];v[c+12>>2]=e;v[c+8>>2]=e;h=v[Kb(c+12|0,c+8|0)>>2];i=v[a>>2];j=v[b>>2];b=0;c:while(1){if((b|0)==(d|0)){break a}k=B(b,e);a=0;while(1)if((a|0)==(h|0)){b=b+1|0;continue c}else{l=(a+k<<1)+i|0;f=Xh(C(Yd(z[v[(a<<2)+j>>2]+(b<<2)>>2],C(-1))*C(32768)));d:{if(C(D(f))<C(2147483648)){g=~~f;break d}g=-2147483648}m=l,n=ed(g),u[m>>1]=n;a=a+1|0;continue}}}aa(17370,9012,27,9539);L()}aa(17320,9012,28,9539);L()}kb=c+16|0}function Dia(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=v[a>>2];d=Hq(c,v[a+4>>2]);if(d>>>0<b>>>0){f=kb-32|0;kb=f;c=b-d|0;b=v[Gb(a)>>2];e=v[a+4>>2];a:{if(c>>>0<=(b-e|0)/48>>>0){d=kb-16|0;kb=d;b=TU(d,a,c);a=v[b+4>>2];c=v[b+8>>2];while(1){if((a|0)==(c|0)){lc(b);kb=d+16|0}else{ZS(a);a=a+48|0;v[b+4>>2]=a;continue}break}break a}b=Gb(a);d=QU(f+8|0,RU(a,Hq(v[a>>2],e)+c|0),Hq(v[a>>2],v[a+4>>2]),b);b=kb-16|0;kb=b;v[b>>2]=v[d+8>>2];e=v[d+8>>2];v[b+8>>2]=d+8;v[b+4>>2]=B(c,48)+e;c=v[b>>2];while(1){if(v[b+4>>2]!=(c|0)){ZS(c);c=v[b>>2]+48|0;v[b>>2]=c;continue}break}Ud(b);kb=b+16|0;PU(a,d);OU(d)}kb=f+32|0;return}if(b>>>0<d>>>0){Od(a,c+B(b,48)|0)}}function AX(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;g=kb-16|0;kb=g;e=sd(b);d=Ad(v[b+4>>2],w[b+11|0]);i=sd(c);j=Ad(v[c+4>>2],w[c+11|0]);f=-1;a:{if(!d){break a}h=d+e|0;d=e;while(1){if((d|0)==(h|0)){break a}if(nu(i,j,w[d|0])){d=d+1|0;continue}break}f=d-e|0}b:{c:{if((f|0)!=-1){c=fc(g+8|0,Tj(b));d=fc(g,Rf(Tj(b),f));rD(b,v[c>>2],v[d>>2]);break c}f=Gk(v[b+4>>2],w[b+11|0]);if(!f){break c}e=sd(b);i=Ad(v[b+4>>2],w[b+11|0]);j=sd(c);d=-1;h=Ad(v[c+4>>2],w[c+11|0]);if(h){c=e+i|0;d:{while(1){if((c|0)==(e|0)){break d}c=c-1|0;if(!nu(j,h,w[c|0])){continue}break}d=c-e|0}}if((f-1|0)!=(d|0)){break c}Nb(a);break b}ad(a,b)}kb=g+16|0}function wN(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;d=kb-16|0;kb=d;v[d+12>>2]=b;if(b>>>0<4294967280){a:{if(wl(a)>>>0>=b>>>0){break a}i=d,j=Ad(v[a+4>>2],w[a+11|0]),v[i+8>>2]=j;e=nh(v[_c(d+12|0,d+8|0)>>2]);if((e|0)==(wl(a)|0)){break a}f=Ad(v[a+4>>2],w[a+11|0]);b:{c:{if((e|0)==10){g=v[a>>2];h=1;b=a;c=f;break c}b=e+1|0;d:{if(wl(a)>>>0<e>>>0){b=vc(b);break d}v[23540]=0;b=S(52,b|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){break d}a=V(0)|0;O()|0;_(a|0)|0;$();break b}c=w[a+11|0];h=kf(c);g=sd(a);c=Ad(v[a+4>>2],c)}b=He(b,g,c+1|0);if(h){Mb(g)}if((e|0)!=10){ff(a,e+1|0);Hd(a,f);wd(a,b);break b}ie(a,f)}}kb=d+16|0;return}hf();L()}function Lga(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=C(0),g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=kb-16|0;kb=c;a:{b:{d=v[b+8>>2];if((d|0)==v[a+8>>2]){e=v[b+4>>2];if((e|0)!=v[a+4>>2]){break b}v[c+12>>2]=d;v[c+8>>2]=d;d=v[Kb(c+12|0,c+8|0)>>2];v[c+12>>2]=e;v[c+8>>2]=e;h=v[Kb(c+12|0,c+8|0)>>2];i=v[a>>2];j=v[b>>2];b=0;c:while(1){if((b|0)==(d|0)){break a}k=B(b,e);a=0;while(1)if((a|0)==(h|0)){b=b+1|0;continue c}else{l=(a+k|0)+i|0;f=Xh(C(Yd(z[v[(a<<2)+j>>2]+(b<<2)>>2],C(-1))*C(128)));d:{if(C(D(f))<C(2147483648)){g=~~f;break d}g=-2147483648}m=l,n=nS(g),t[m|0]=n;a=a+1|0;continue}}}aa(17370,9012,27,9539);L()}aa(17320,9012,28,9539);L()}kb=c+16|0}function maa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=kb-80|0;kb=d;e=zf(d+48|0);v[23540]=0;g=Q(868,b|0,e|0)|0;f=v[23540];v[23540]=0;a:{b:{c:{if((f|0)!=1){if(g){break c}v[a>>2]=0;v[a+4>>2]=0;v[a+24>>2]=0;v[a+16>>2]=0;v[a+20>>2]=0;v[a+8>>2]=0;v[a+12>>2]=0;v[23540]=0;S(869,a|0)|0;a=v[23540];v[23540]=0;if((a|0)!=1){break b}}break a}g=v[e+4>>2];v[23540]=0;U(190,d|0,b|0,g|0);f=v[23540];v[23540]=0;if((f|0)==1){break a}f=kc(d+24|0,d);hd(e+8|0,f);Bb(f);Bb(d);d:{if(!(g&1)|c>>>0<2){break d}v[23540]=0;Q(188,b|0,1)|0;b=v[23540];v[23540]=0;if((b|0)!=1){break d}break a}xk(a,e)}Bd(e);kb=d+80|0;return}a=P()|0;O()|0;Bd(e);T(a|0);L()}function qv(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;f=kb-16|0;kb=f;t[f+15|0]=d;t[b+12|0]=w[b+12|0]&240|w[a|0]&15;i=a+1|0;e=f+15|0;Qg(b,w[Yb(i,e)|0]);g=w[Yb(a+2|0,e)|0];t[b+13|0]=g;k=b,l=Ed(w[a+3|0],g,d),t[k+14|0]=l;e=w[Yb(a+4|0,e)|0];t[b+15|0]=e;k=b,l=Ed(w[a+5|0],e,d),t[k+16|0]=l;g=v[b>>2];b=0;while(1){t[f+14|0]=25;if(b>>>0<w[Yb(f+14|0,i)|0]){e=B(b,3)+a|0;h=Zb(w[e+6|0]+c<<24>>24,0,64);d=Eb(g,b);t[d+2|0]=h;e=w[e+7|0]|w[e+8|0]<<8;u[d>>1]=e;a:{if(!b){break a}h=Eb(g,b-1|0);j=x[h>>1];if(e>>>0>255|e>>>0>=j>>>0){break a}e=e|j&65280;u[d>>1]=e;if(x[h>>1]<=(e&65535)>>>0){break a}u[d>>1]=e+256}b=b+1|0;continue}break}kb=f+16|0}function O6(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;e=kb-16|0;kb=e;i=e,j=Aj(b),v[i>>2]=j;c=kb-16|0;kb=c;g=a;d=Td(a);a:{if(d){f=jc(g);while(1){a=d;d=a+16|0;if(ot(b,d)){f=a;d=v[a>>2];if(d){continue}break a}if(!ot(d,b)){break a}f=a+4|0;d=v[a+4>>2];if(d){continue}break}break a}a=jc(g);f=a}v[c+12>>2]=a;b=v[f>>2];if(!b){a=kb-16|0;kb=a;b=jc(g);b=lh(c,vc(40),mh(a+8|0,b));Nb(ad(v[b>>2]+16|0,v[e>>2])+12|0);i=jc(b),j=1,t[i+4|0]=j;kb=a+16|0;Jg(g,v[c+12>>2],f,v[c>>2]);b=ce(c);a=v[c>>2];v[c>>2]=0;if(a){if(w[jc(c)+4|0]){wm(a+16|0)}if(a){Mb(a)}}h=1}Ig(e+8|0,v[fc(c,b)>>2],h);kb=c+16|0;a=vd(v[e+8>>2]);kb=e+16|0;return a+12|0}function tD(a){var b=0,c=0,d=0,e=0,f=0,g=0;a:{if(Sb(a,3878,4)){break a}b=w[a+16|0]|w[a+17|0]<<8|(w[a+18|0]<<16|w[a+19|0]<<24);if(b>>>0<36){break a}c=w[a+24|0]|w[a+25|0]<<8|(w[a+26|0]<<16|w[a+27|0]<<24);if(c>>>0<36){break a}d=w[a+32|0]|w[a+33|0]<<8|(w[a+34|0]<<16|w[a+35|0]<<24);if(d>>>0<36){break a}e=w[a+12|0]|w[a+13|0]<<8|(w[a+14|0]<<16|w[a+15|0]<<24);if(e-1>>>0>858993458){break a}f=w[a+20|0]|w[a+21|0]<<8|(w[a+22|0]<<16|w[a+23|0]<<24);if(f-1>>>0>536870910){break a}a=w[a+28|0]|w[a+29|0]<<8|(w[a+30|0]<<16|w[a+31|0]<<24);if(B(e,-5)-1>>>0<b>>>0|a-1>>>0>1073741822|(f<<3^-1)>>>0<c>>>0){break a}g=(a<<2^-1)>>>0>=d>>>0}return g}function XU(a,b,c,d,e){var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;a:{if(!d){break a}i=w[e|0];if(!i){break a}g=d-6|0;j=(g&255)>>>0<6&35>>>g;l=d-2|0;m=0-c|0;while(1){if(!b){break a}k=(l&255)>>>0>2;h=B(m,6);c=a;a=h+c|0;f=w[a+3|0];b:{if(!(k|(f-2&255)>>>0>2)){g=1;if(w[(c+h|0)+5|0]<224){break b}break a}g=(d|0)==(f|0);if(!(1<<f&2240)|(!j|f>>>0>11)){break b}g=1}c:{if(k){break c}f=c+h|0;if((w[f+2|0]-11&255)>>>0>2){break c}if(w[f+4|0]){break a}}d:{if(!j){break d}f=c+h|0;if((w[f+2|0]-3&255)>>>0>3){break d}if(w[f+4|0]){break a}}b=b-1|0;if(!g){continue}c=w[(c+h|0)+5|0];if(c?(c|0)!=(i|0):0){break a}if((c|0)!=(i|0)){continue}break}t[e|0]=0}}function Fba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=kb-80|0;kb=d;e=zf(d+48|0);v[23540]=0;c=Q(789,b|0,e|0)|0;f=v[23540];v[23540]=0;a:{b:{c:{if((f|0)!=1){if(c){break c}v[a>>2]=0;v[a+4>>2]=0;v[a+24>>2]=0;v[a+16>>2]=0;v[a+20>>2]=0;v[a+8>>2]=0;v[a+12>>2]=0;v[23540]=0;S(790,a|0)|0;a=v[23540];v[23540]=0;if((a|0)!=1){break b}}break a}c=v[e+4>>2];v[23540]=0;c=bc(c);U(190,d|0,b|0,c|0);f=v[23540];v[23540]=0;if((f|0)==1){break a}f=kc(d+24|0,d);hd(e+8|0,f);Bb(f);Bb(d);d:{c=c&1;if(!c){break d}v[23540]=0;Q(188,b|0,2-c|0)|0;b=v[23540];v[23540]=0;if((b|0)!=1){break d}break a}xk(a,e)}Bd(e);kb=d+80|0;return}a=P()|0;O()|0;Bd(e);T(a|0);L()}function DY(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0;if(Zg(a,v[b+8>>2],f)){nw(b,c,d,e);return}g=w[b+53|0];i=v[a+12>>2];t[b+53|0]=0;h=w[b+52|0];t[b+52|0]=0;m=a+16|0;jw(v[m>>2],v[a+20>>2],b,c,d,e,f);j=w[b+53|0];l=g|j;k=w[b+52|0];h=h|k;g=a+24|0;i=(i<<3)+m|0;a:{if(g>>>0>=i>>>0){break a}while(1){if(w[b+54|0]){break a}b:{if(k){if(v[b+24>>2]==1){break a}if(w[a+8|0]&2){break b}break a}if(!j){break b}if(!(t[a+8|0]&1)){break a}}u[b+52>>1]=0;jw(v[g>>2],v[g+4>>2],b,c,d,e,f);j=w[b+53|0];l=j|l;k=w[b+52|0];h=k|h;g=g+8|0;if(i>>>0>g>>>0){continue}break}}t[b+53|0]=(l&255)!=0;t[b+52|0]=(h&255)!=0}function JS(a){var b=0,c=0,d=0,e=0,f=0;b=kb-32|0;kb=b;e=b,f=bc(w[a+8|0]|w[a+9|0]<<8|(w[a+10|0]<<16|w[a+11|0]<<24))+788|0,v[e>>2]=f;v[b+4>>2]=0;e=b,f=bc(w[a+16|0]|w[a+17|0]<<8|(w[a+18|0]<<16|w[a+19|0]<<24)),v[e+8>>2]=f;v[b+12>>2]=0;c=bc(w[a+24|0]|w[a+25|0]<<8|(w[a+26|0]<<16|w[a+27|0]<<24));v[b+16>>2]=c?c:52;v[b+20>>2]=0;e=b,f=bc(w[a+32|0]|w[a+33|0]<<8|(w[a+34|0]<<16|w[a+35|0]<<24))+80|0,v[e+24>>2]=f;v[b+28>>2]=0;a=b;d=bf(a,4);a:{if((a|0)==(d|0)){break a}c=a;while(1){c=c+8|0;if((d|0)==(c|0)){break a}a=lv(v[a>>2],v[a+4>>2],v[c>>2],v[c+4>>2])?c:a;continue}}kb=b+32|0;c=v[a>>2];b=c-52|0;nb=v[a+4>>2]-(c>>>0<52)|0;return b}function QH(a,b,c,d,e){var f=0,g=0,h=0,i=0;f=kb-208|0;kb=f;v[f+204>>2]=c;c=f+160|0;Ub(c,0,40);v[f+200>>2]=v[f+204>>2];a:{if((PH(0,b,f+200|0,f+80|0,c,d,e)|0)<0){e=-1;break a}i=v[a+76>>2]>=0;g=v[a>>2];if(v[a+72>>2]<=0){v[a>>2]=g&-33}b:{c:{d:{if(!v[a+48>>2]){v[a+48>>2]=80;v[a+28>>2]=0;v[a+16>>2]=0;v[a+20>>2]=0;h=v[a+44>>2];v[a+44>>2]=f;break d}if(v[a+16>>2]){break c}}c=-1;if(pC(a)){break b}}c=PH(a,b,f+200|0,f+80|0,f+160|0,d,e)}if(h){ob[v[a+36>>2]](a,0,0)|0;v[a+48>>2]=0;v[a+44>>2]=h;v[a+28>>2]=0;b=v[a+20>>2];v[a+16>>2]=0;v[a+20>>2]=0;c=b?c:-1}b=a;a=v[a>>2];v[b>>2]=a|g&32;e=a&32?-1:c;if(!i){break a}}kb=f+208|0;return e}function Maa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;h=kb-16|0;kb=h;f=c;e=kb-16|0;kb=e;g=b;d=Td(b);a:{if(d){c=jc(g);while(1){b=d;d=b+16|0;if(mM(f,d)){c=b;d=v[b>>2];if(d){continue}break a}if(!mM(d,f)){break a}c=b+4|0;d=v[b+4>>2];if(d){continue}break}break a}b=jc(g);c=b}v[e+12>>2]=b;b=v[c>>2];if(!b){b=kb-16|0;kb=b;d=jc(g);d=lh(e,vc(28),mh(b+8|0,d));i=v[d>>2];v[23540]=0;R(846,i+16|0,f|0);f=v[23540];v[23540]=0;b:{if((f|0)!=1){j=jc(d),k=1,t[j+4|0]=k;kb=b+16|0;break b}a=P()|0;O()|0;lM(d);T(a|0);L()}Jg(g,v[e+12>>2],c,v[e>>2]);b=ce(e);lM(e);i=1}c=h+8|0;Ig(c,v[fc(e,b)>>2],i);kb=e+16|0;uP(a,c);kb=h+16|0}function xP(a,b,c){a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{b=b&15;switch(b-3|0){case 2:break j;case 1:break k;case 0:break l;case 10:case 11:break b;case 9:break c;case 8:break d;case 7:break e;case 6:break f;case 5:break g;case 4:break h;case 3:break i;default:break a}}t[a+798|0]=0;return}t[a+798|0]=1;return}t[a+798|0]=2;return}t[a+798|0]=3;return}t[a+730|0]=w[a+730|0]&254;return}t[a+730|0]=w[a+730|0]|1;return}t[a+738|0]=w[a+738|0]&254;return}t[a+738|0]=w[a+738|0]|1;return}t[a+746|0]=w[a+746|0]&254;return}t[a+746|0]=w[a+746|0]|1;return}if((c|0)!=16777216){break a}c=a;a=w[a+746|0];t[c+746|0]=(b|0)==13?a&238|1:a|17}}function ZA(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=kb-16|0;kb=e;d=(c<<3)+a|0;f=w[d+356|0];t[b+12|0]=w[b+12|0]&248|f&1|f<<1&4|f>>>1&2;Qg(b,Ed(w[d+352|0],2,16));t[b+13|0]=w[d+354|0];t[b+14|0]=w[d+355|0];d=w[d+353|0];t[b+15|0]=d;t[b+16|0]=d;d=0;u[e+14>>1]=0;f=((c|0)!=0)<<1;h=v[b>>2];j=$d(h,v[b+4>>2]);k=(c<<6)+a|0;c=((c|0)==2?-1:0)&255;while(1){if((d|0)==(j|0)){YA(b,32);kb=e+16|0}else{a=k+(d<<2)|0;u[e+12>>1]=w[a+160|0]|w[a+161|0]<<8;g=ke(e+14|0,e+12|0);i=Eb(h,d);g=x[g>>1];u[i>>1]=g;u[e+14>>1]=g+1;t[e+11|0]=(c^w[a+162|0])>>>f;t[e+10|0]=64;l=i,m=w[Yb(e+11|0,e+10|0)|0],t[l+2|0]=m;d=d+1|0;continue}break}}function V$(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=kb-48|0;kb=f;v[f+40>>2]=b;a:{if(!(v[c+4>>2]&1)){c=ob[v[v[a>>2]+24>>2]](a,b,c,d,e)|0;break a}a=f+24|0;gd(a,c);v[23540]=0;a=S(1115,a|0)|0;b=v[23540];v[23540]=0;b:{if((b|0)!=1){ac(f+24|0);c:{if(e){Qh(f+24|0,a);break c}Ph(f+24|0,a)}g=f,h=he(f+24|0),v[g+16>>2]=h;while(1){g=f,h=yh(f+24|0),v[g+8>>2]=h;if(!pj(f+16|0,f+8|0)){c=v[f+40>>2];zb(f+24|0);break a}a=t[v[f+16>>2]];v[23540]=0;Q(21,f+40|0,a|0)|0;a=v[23540];v[23540]=0;if((a|0)!=1){Ke(f+16|0);continue}break}c=P()|0;O()|0;zb(f+24|0);break b}c=P()|0;O()|0;ac(f+24|0)}T(c|0);L()}kb=f+48|0;return c|0}function QV(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=kb-208|0;kb=d;_B(c,a);ZB(c,d+16|0,B(w[a+4|0],3));a:{if(w[a+4|0]<2){break a}c=kb-16|0;kb=c;v[c+12>>2]=64;v[c+8>>2]=255;e=w[Kb(c+12|0,c+8|0)|0];kb=c+16|0;t[d+12|0]=e;Qg(b,w[Yb(a+4|0,d+12|0)|0]);t[b+13|0]=w[a+2|0];t[b+14|0]=w[a+3|0];a=w[a+1|0];t[b+15|0]=a;t[b+16|0]=a;e=v[b>>2];f=$d(e,v[b+4>>2]);a=0;while(1){if((a|0)==(f|0)){break a}b:{if(!a){b=w[d+18|0];c=Eb(e,0);break b}g=x[Eb(e,a-1|0)>>1];v[d+12>>2]=1;b=(d+16|0)+B(a,3)|0;v[d+8>>2]=(t[b+1|0]&1)<<8|w[b|0];h=Pe(d+12|0,d+8|0);c=Eb(e,a);u[c>>1]=x[h>>1]+g;b=w[b+2|0]}t[c+2|0]=b;a=a+1|0;continue}}kb=d+208|0}function L3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=kb+-64|0;kb=d;f=d+16|0;h=kb-16|0;kb=h;i=EP(h+8|0);while(1){if((j|0)==12){kb=h+16|0}else{g=kb+-64|0;kb=g;c=v[i+4>>2];e=v[i>>2];a:{if((c|0)==(e|0)){break a}c=(c-e|0)+1|0;if(!c){c=AJ(BJ(g+8|0,32));break a}e=E(c);e=BJ(g+8|0,(c<<e+1?32:31)-e|0);while(1){k=AJ(e);if(c>>>0<=k>>>0){continue}break}c=v[i>>2]+k|0}kb=g- -64|0;l=Eb(f,j),m=c,v[l>>2]=m;j=j+1|0;continue}break}f=GP(d,f,HP(f));FP(a,f);Fm(f);kb=d- -64|0;d=wx(a+120|0,a,b);t[d+20|0]=1;v[23540]=0;R(1064,a|0,b|0);b=v[23540];v[23540]=0;if((b|0)==1){a=P()|0;O()|0;In(d);T(a|0);L()}return a|0}function bba(a){a=a|0;var b=0,c=0,d=0;c=a+1298224|0;b=a+1074992|0;while(1){if((b|0)==(c|0)){bt(a+484344|0);$f(a+1298308|0);qA(a+1298320|0);$f(a+1298332|0);Lc(a+1298408|0);b=a+900380|0;c=a+484380|0;while(1){if((b|0)==(c|0)){a:{c=a+901404|0;while(1){if((b|0)==(c|0)){b=a+906300|0;c=gk(b);while(1){if((b|0)==(c|0)){break a}wV(b);b=b+160|0;continue}}d=v[b>>2];if(d){Mb(bu(d))}v[b>>2]=0;b=b+4|0;continue}}}else{Dm(c);c=c+104|0;continue}break}v[a+480180>>2]=0;v[a+480184>>2]=0;a=a+480186|0;u[a>>1]=0;u[a+2>>1]=0;u[a+4>>1]=0;u[a+6>>1]=0}else{v[b+104>>2]=0;v[b+656>>2]=0;v[b+76>>2]=0;v[b+16>>2]=0;b=b+872|0;continue}break}}function bM(a,b,c,d,e,f,g){var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=kb-16|0;kb=h;t[h+15|0]=b;t[h+14|0]=10;Qg(g,w[Yb(h+15|0,h+14|0)|0]);t[g+15|0]=c;t[g+16|0]=c;t[g+14|0]=e;t[g+13|0]=d;j=v[g>>2];k=$d(j,v[g+4>>2]);b=0;a:{while(1){if((b|0)==(k|0)){b:{b=w[g+12|0]&-2|a&1;if(a&2){break b}b=b&251;break a}}else{m=Eb(j,b);l=B(b,3)+f|0;i=(w[l|0]|w[l+1|0]<<8)>>>4|0;u[m>>1]=i;c:{if(b){n=x[Eb(j,b-1|0)>>1];if(i>>>0>=n>>>0){break c}i=n+1|0}else{i=0}o=Eb(j,b),p=i,u[o>>1]=p}o=m,p=Ed(w[l+2|0],0,64),t[o+2|0]=p;b=b+1|0;continue}break}b=b&-5|(c>>>0<=k>>>0)<<2}t[g+12|0]=(d>>>0<=e>>>0?a&4:0)?b&-3|(d>>>0<=k>>>0)<<1:b&253;kb=h+16|0}function vU(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;a:{e=kb-16|0;kb=e;f=kb-32|0;kb=f;c=of(f+16|0,1,0);b:{c:{d:{while(1){d=Ac(c);Gx(f+8|0,d,Hb(c)+d|0,v[b>>2]);if(!v[f+12>>2]){break d}d=ch(Hb(c));v[23540]=0;R(59,c|0,d|0);d=v[23540];v[23540]=0;if((d|0)!=1){continue}break}break c}b=v[f+8>>2];d=Ac(c);v[23540]=0;R(60,c|0,b-d|0);b=v[23540];v[23540]=0;e:{if((b|0)!=1){v[23540]=0;R(72,e|0,c|0);b=v[23540];v[23540]=0;if((b|0)!=1){break e}break c}break c}zb(c);kb=f+32|0;break b}a=P()|0;O()|0;zb(c);T(a|0);L()}v[23540]=0;R(71,a|0,e|0);a=v[23540];v[23540]=0;if((a|0)!=1){Ab(e);kb=e+16|0;break a}a=P()|0;O()|0;Ab(e);T(a|0);L()}}function ap(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;a:{e=kb-16|0;kb=e;f=kb-32|0;kb=f;c=of(f+16|0,1,0);b:{c:{d:{while(1){d=Ac(c);Kx(f+8|0,d,Hb(c)+d|0,v[b>>2]);if(!v[f+12>>2]){break d}d=ch(Hb(c));v[23540]=0;R(59,c|0,d|0);d=v[23540];v[23540]=0;if((d|0)!=1){continue}break}break c}b=v[f+8>>2];d=Ac(c);v[23540]=0;R(60,c|0,b-d|0);b=v[23540];v[23540]=0;e:{if((b|0)!=1){v[23540]=0;R(72,e|0,c|0);b=v[23540];v[23540]=0;if((b|0)!=1){break e}break c}break c}zb(c);kb=f+32|0;break b}a=P()|0;O()|0;zb(c);T(a|0);L()}v[23540]=0;R(71,a|0,e|0);a=v[23540];v[23540]=0;if((a|0)!=1){Ab(e);kb=e+16|0;break a}a=P()|0;O()|0;Ab(e);T(a|0);L()}}function ID(a,b){var c=0,d=0,e=0,f=0;c=v[a>>2];d=Ug(c,v[a+4>>2]);if(d>>>0<b>>>0){f=kb-32|0;kb=f;c=b-d|0;b=v[Gb(a)>>2];e=v[a+4>>2];a:{if(c>>>0<=b-e>>3>>>0){d=kb-16|0;kb=d;b=lr(d,a,c);a=v[b+4>>2];c=v[b+8>>2];while(1){if((a|0)==(c|0)){lc(b);kb=d+16|0}else{Uj(a);a=a+8|0;v[b+4>>2]=a;continue}break}break a}b=Gb(a);d=nr(f+8|0,or(a,Ug(v[a>>2],e)+c|0),Ug(v[a>>2],v[a+4>>2]),b);b=kb-16|0;kb=b;v[b>>2]=v[d+8>>2];e=v[d+8>>2];v[b+8>>2]=d+8;v[b+4>>2]=(c<<3)+e;c=v[b>>2];while(1){if(v[b+4>>2]!=(c|0)){Uj(c);c=v[b>>2]+8|0;v[b>>2]=c;continue}break}Ud(b);kb=b+16|0;Fd(a,d);mr(d)}kb=f+32|0;return}if(b>>>0<d>>>0){Od(a,c+(b<<3)|0)}}function tY(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;k=kb-32|0;kb=k;m=v[c>>2];l=v[c+8>>2];c=v[c+4>>2];v[k+8>>2]=c;v[k+12>>2]=l;v[k+24>>2]=c;v[k+28>>2]=l;v[k+20>>2]=m;v[k+16>>2]=d;v[23540]=0;c=v[k+20>>2];v[k>>2]=v[k+16>>2];v[k+4>>2]=c;a=Ma(1043,a|0,b|0,k|0)|0;b=v[23540];v[23540]=0;a:{b:{if((b|0)==1){a=V(0)|0;O()|0;_(a|0)|0;v[23540]=0;ia(929,10434,e|0,f|0,g|0,h|0,i|0,j|0);a=v[23540];v[23540]=0;if((a|0)==1){break b}$();a=-255}kb=k+32|0;break a}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}return a|0}function Dp(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;e=kb-16|0;kb=e;f=kb-32|0;kb=f;c=of(f+16|0,1,0);a:{b:{c:{while(1){d=Ac(c);Kx(f+8|0,d,Hb(c)+d|0,v[b>>2]);if(!v[f+12>>2]){break c}d=ch(Hb(c));v[23540]=0;R(59,c|0,d|0);d=v[23540];v[23540]=0;if((d|0)!=1){continue}break}break b}b=v[f+8>>2];d=Ac(c);v[23540]=0;R(60,c|0,b-d|0);b=v[23540];v[23540]=0;d:{if((b|0)!=1){v[23540]=0;R(61,e|0,c|0);b=v[23540];v[23540]=0;if((b|0)!=1){break d}break b}break b}zb(c);kb=f+32|0;break a}a=P()|0;O()|0;zb(c);T(a|0);L()}v[23540]=0;R(58,a|0,e|0);a=v[23540];v[23540]=0;if((a|0)!=1){zb(e);kb=e+16|0;return}a=P()|0;O()|0;zb(e);T(a|0);L()}function d9(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;e=kb-16|0;kb=e;f=kb-32|0;kb=f;c=of(f+16|0,1,0);a:{b:{c:{while(1){d=Ac(c);Kx(f+8|0,d,Hb(c)+d|0,w[b|0]);if(!v[f+12>>2]){break c}d=ch(Hb(c));v[23540]=0;R(59,c|0,d|0);d=v[23540];v[23540]=0;if((d|0)!=1){continue}break}break b}b=v[f+8>>2];d=Ac(c);v[23540]=0;R(60,c|0,b-d|0);b=v[23540];v[23540]=0;d:{if((b|0)!=1){v[23540]=0;R(61,e|0,c|0);b=v[23540];v[23540]=0;if((b|0)!=1){break d}break b}break b}zb(c);kb=f+32|0;break a}a=P()|0;O()|0;zb(c);T(a|0);L()}v[23540]=0;R(58,a|0,e|0);a=v[23540];v[23540]=0;if((a|0)!=1){zb(e);kb=e+16|0;return}a=P()|0;O()|0;zb(e);T(a|0);L()}function W1(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;g=kb-16|0;kb=g;a:{if(!(c&1024)){break a}i=g,j=Tj(b),v[i+8>>2]=j;c=Gk(v[b+4>>2],w[b+11|0]);b:{if(!c){break b}if(w[sd(b)|0]!=43){if(w[sd(b)|0]!=45){break b}}d=d+1|0;rJ(g+8|0)}if(c>>>0>=d>>>0){break a}e=v[fc(g,v[g+8>>2])>>2];c=d-Gk(v[b+4>>2],w[b+11|0])|0;c:{e=to(e,Tj(b));d=Ad(v[b+4>>2],w[b+11|0]);if(e>>>0<=d>>>0){if(c){f=wl(b);d:{if(c>>>0<=f-d>>>0){f=sd(b);if((d|0)==(e|0)){break d}h=e+f|0;Yh(c+h|0,h,d-e|0);break d}My(b,f,(c+d|0)-f|0,d,e,c);f=v[b>>2]}jI(e+f|0,c,48);c=c+d|0;vq(b,c);xd(c+f|0,0)}break c}sk();L()}Tj(b)}ad(a,b);kb=g+16|0}function me(a,b){var c=0,d=0,e=0;c=kb-32|0;kb=c;a=Xg(a,-1,-1);a:{b:{if(Qd(w[fm(c+24|0,b,1)|0])){d=v[(v[v[b>>2]-12>>2]+b|0)+24>>2];v[23540]=0;Nk(107,c+8|0,d,0,0);d=v[23540];v[23540]=0;c:{if((d|0)!=1){d=v[c+12>>2];v[a>>2]=v[c+8>>2];v[a+4>>2]=d;d=v[c+20>>2];v[a+8>>2]=v[c+16>>2];v[a+12>>2]=d;break c}a=V(0)|0;O()|0;_(a|0)|0;e=1;dm(v[v[b>>2]-12>>2]+b|0,1);if(v[(v[v[b>>2]-12>>2]+b|0)+20>>2]&1){v[23540]=0;Z(105);a=v[23540];v[23540]=0;if((a|0)!=1){break a}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)==1){break b}T(a|0);L()}$()}Ki(v[v[b>>2]-12>>2]+b|0,e)}kb=c+32|0;return}V(0)|0;O()|0;Vb()}L()}function kL(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=kb-16|0;kb=e;Lh(e+8|0,b);f=kb-16|0;kb=f;_g(f+8|0,v[e+8>>2],v[e+12>>2]);c=v[f+12>>2];b=v[f+8>>2];g=kb-16|0;kb=g;k=g,l=Fb(a),v[k+8>>2]=l;h=b;a=c;b=kb-16|0;kb=b;i=v[g+8>>2];c=i;d=v[c+12>>2];c=v[c+8>>2];a:{if((d|0)<0){break a}j=v[i+4>>2];if(!d&j>>>0<c>>>0|d){break a}v[b+8>>2]=j-c;v[b+12>>2]=0-(d+(c>>>0>j>>>0)|0);v[b>>2]=a;v[b+4>>2]=0;d=YB(b+8|0,b);if((cz(v[d>>2],v[d+4>>2])|0)!=(a|0)){break a}Oi(h,a+h|0,c+v[i>>2]|0);c=v[g+8>>2];h=c;d=a+v[c+8>>2]|0;c=v[c+12>>2];v[h+8>>2]=d;v[h+12>>2]=a>>>0>d>>>0?c+1|0:c}kb=b+16|0;kb=g+16|0;kb=f+16|0;kb=e+16|0}function zfa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;d=kb-32|0;kb=d;nd(b,0);$h(d,1,a);c=d+16|0;Fc(c,d);Be(b+43|0,c);zb(c);v[b>>2]=w[a+48|0]|w[a+49|0]<<8|(w[a+50|0]<<16|w[a+51|0]<<24);v[b+4>>2]=w[a+52|0]|w[a+53|0]<<8|(w[a+54|0]<<16|w[a+55|0]<<24);v[b+8>>2]=w[a+56|0]|w[a+57|0]<<8|(w[a+58|0]<<16|w[a+59|0]<<24);v[b+24>>2]=w[a+62|0]|w[a+63|0]<<8;zl(b,+((w[a+60|0]^8)-120|0)/192);t[d+16|0]=w[a+61|0];t[d|0]=64;f=b,g=w[Yb(c,d)|0]<<2,u[f+30>>1]=g;u[b+34>>1]=0;c=w[a+47|0];if(c&4){u[b+34>>1]=1;v[b>>2]=v[b>>2]>>>1;e=1;c=w[a+47|0]}if(c&32){e=e|4;u[b+34>>1]=e;c=w[a+47|0]}if(c<<24>>24<0){u[b+34>>1]=e|2}kb=d+32|0}function e$(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;k=kb-16|0;kb=k;a:{if(a){a=bG(b);Rk(k,a);b=v[k>>2];t[c|0]=b;t[c+1|0]=b>>>8;t[c+2|0]=b>>>16;t[c+3|0]=b>>>24;Qk(k,a);Ui(i,k);Nc(k);Ph(k,a);Ui(h,k);Nc(k);l=d,m=_i(a),v[l>>2]=m;l=e,m=$i(a),v[l>>2]=m;bh(k,a);Bc(f,k);zb(k);Qh(k,a);Ui(g,k);Nc(k);a=Pk(a);break a}a=aG(b);Rk(k,a);b=v[k>>2];t[c|0]=b;t[c+1|0]=b>>>8;t[c+2|0]=b>>>16;t[c+3|0]=b>>>24;Qk(k,a);Ui(i,k);Nc(k);Ph(k,a);Ui(h,k);Nc(k);l=d,m=_i(a),v[l>>2]=m;l=e,m=$i(a),v[l>>2]=m;bh(k,a);Bc(f,k);zb(k);Qh(k,a);Ui(g,k);Nc(k);a=Pk(a)}v[j>>2]=a;kb=k+16|0}function Sia(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;d=kb-80|0;kb=d;e=zf(d+48|0);v[23540]=0;c=Q(400,b|0,e|0)|0;f=v[23540];v[23540]=0;a:{b:{c:{d:{if((f|0)!=1){if(c){break d}v[a>>2]=0;v[a+4>>2]=0;v[a+24>>2]=0;v[a+16>>2]=0;v[a+20>>2]=0;v[a+8>>2]=0;v[a+12>>2]=0;v[23540]=0;S(401,a|0)|0;a=v[23540];v[23540]=0;if((a|0)!=1){break a}}break c}c=kb-16|0;kb=c;g=c,h=bc(v[e+4>>2]),v[g+12>>2]=h;v[c+8>>2]=8;f=v[_c(c+12|0,c+8|0)>>2];kb=c+16|0;v[23540]=0;U(190,d|0,b|0,f-8|0);b=v[23540];v[23540]=0;if((b|0)!=1){break b}}a=P()|0;O()|0;Bd(e);T(a|0);L()}b=kc(d+24|0,d);hd(e+8|0,b);Bb(b);Bb(d);xk(a,e)}Bd(e);kb=d+80|0}function Sea(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;v[a>>2]=0;v[a+4>>2]=0;Gc(a+8|0);if(b){if(th(119304647)>>>0<b>>>0){cd();L()}b=B(b,36);c=vc(b);v[a>>2]=c;v[a+4>>2]=c;f=Gb(a),g=b+c|0,v[f>>2]=g;d=kb-16|0;kb=d;v[d>>2]=a;c=v[a+4>>2];v[d+4>>2]=c;v[d+8>>2]=b+c;b=v[d+4>>2];e=v[d+8>>2];while(1){if((b|0)==(e|0)){lc(d);kb=d+16|0}else{c=Ub(b,0,36);v[c>>2]=0;v[c+4>>2]=0;u[c+22>>1]=0;u[c+24>>1]=0;u[c+26>>1]=0;u[c+28>>1]=0;t[c+21|0]=64;t[c+19|0]=64;t[c+20|0]=100;t[c+15|0]=0;t[c+16|0]=0;t[c+17|0]=0;t[c+18|0]=0;v[c+8>>2]=0;v[c+12>>2]=0;u[c+30>>1]=0;u[c+32>>1]=0;b=b+36|0;v[d+4>>2]=b;continue}break}}return a|0}function XJ(a,b){var c=0,d=0,e=0,f=0;a:{e=kb-16|0;kb=e;f=kb-32|0;kb=f;c=of(f+16|0,1,0);b:{c:{d:{while(1){d=Ac(c);zx(f+8|0,d,Hb(c)+d|0,x[b>>1]);if(!v[f+12>>2]){break d}d=ch(Hb(c));v[23540]=0;R(59,c|0,d|0);d=v[23540];v[23540]=0;if((d|0)!=1){continue}break}break c}b=v[f+8>>2];d=Ac(c);v[23540]=0;R(60,c|0,b-d|0);b=v[23540];v[23540]=0;e:{if((b|0)!=1){v[23540]=0;R(72,e|0,c|0);b=v[23540];v[23540]=0;if((b|0)!=1){break e}break c}break c}zb(c);kb=f+32|0;break b}a=P()|0;O()|0;zb(c);T(a|0);L()}v[23540]=0;R(71,a|0,e|0);a=v[23540];v[23540]=0;if((a|0)!=1){Ab(e);kb=e+16|0;break a}a=P()|0;O()|0;Ab(e);T(a|0);L()}}function qs(a,b,c){var d=0,e=0;d=a,e=gj(C(C(z[c+1792>>2]*C(75038))+C(C(C(z[c+2048>>2]-z[c+1536>>2])*C(37489))+C(C(C(z[c+1280>>2]+z[c+2304>>2])*C(6574))+C(C(C(z[c+2560>>2]-z[c+1024>>2])*C(5153))+C(C(C(z[c+768>>2]+z[c+2816>>2])*C(2037))+C(C(C(z[c+3072>>2]-z[c+512>>2])*C(459))+C(C(C(z[c+256>>2]+z[c+3328>>2])*C(213))+C(C(z[c+3584>>2]-z[c>>2])*C(29)))))))))),u[d>>1]=e;d=(b<<5)+a|0,e=gj(C(C(z[c+8>>2]*C(-5))+C(C(z[c+520>>2]*C(146))+C(C(z[c+1032>>2]*C(-45))+C(C(z[c+1544>>2]*C(-9975))+C(C(z[c+2056>>2]*C(64019))+C(C(z[c+2568>>2]*C(9727))+C(C(z[c+3080>>2]*C(1567))+C(z[c+3592>>2]*C(104)))))))))),u[d>>1]=e}function l$(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;k=kb-16|0;kb=k;a:{if(a){a=eG(b);Rk(k,a);b=v[k>>2];t[c|0]=b;t[c+1|0]=b>>>8;t[c+2|0]=b>>>16;t[c+3|0]=b>>>24;Qk(k,a);Bc(i,k);zb(k);Ph(k,a);Bc(h,k);zb(k);l=d,m=_i(a),t[l|0]=m;l=e,m=$i(a),t[l|0]=m;bh(k,a);Bc(f,k);zb(k);Qh(k,a);Bc(g,k);zb(k);a=Pk(a);break a}a=dG(b);Rk(k,a);b=v[k>>2];t[c|0]=b;t[c+1|0]=b>>>8;t[c+2|0]=b>>>16;t[c+3|0]=b>>>24;Qk(k,a);Bc(i,k);zb(k);Ph(k,a);Bc(h,k);zb(k);l=d,m=_i(a),t[l|0]=m;l=e,m=$i(a),t[l|0]=m;bh(k,a);Bc(f,k);zb(k);Qh(k,a);Bc(g,k);zb(k);a=Pk(a)}v[j>>2]=a;kb=k+16|0}function eK(a,b){var c=0,d=0,e=0,f=0;a:{e=kb-16|0;kb=e;f=kb-32|0;kb=f;c=of(f+16|0,1,0);b:{c:{d:{while(1){d=Ac(c);aK(f+8|0,d,Hb(c)+d|0,w[b|0]);if(!v[f+12>>2]){break d}d=ch(Hb(c));v[23540]=0;R(59,c|0,d|0);d=v[23540];v[23540]=0;if((d|0)!=1){continue}break}break c}b=v[f+8>>2];d=Ac(c);v[23540]=0;R(60,c|0,b-d|0);b=v[23540];v[23540]=0;e:{if((b|0)!=1){v[23540]=0;R(72,e|0,c|0);b=v[23540];v[23540]=0;if((b|0)!=1){break e}break c}break c}zb(c);kb=f+32|0;break b}a=P()|0;O()|0;zb(c);T(a|0);L()}v[23540]=0;R(71,a|0,e|0);a=v[23540];v[23540]=0;if((a|0)!=1){Ab(e);kb=e+16|0;break a}a=P()|0;O()|0;Ab(e);T(a|0);L()}}function S3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;if(y[a+4>>2]<y[Gb(a)>>2]){c=kb-16|0;kb=c;a=Dt(c,a,1);yx(v[a+4>>2],b);v[a+4>>2]=v[a+4>>2]+16;lc(a);kb=c+16|0;return}e=kb-32|0;kb=e;c=Gb(a);c=fQ(e+8|0,gQ(a,mk(v[a>>2],v[a+4>>2])+1|0),mk(v[a>>2],v[a+4>>2]),c);yx(v[c+8>>2],b);v[c+8>>2]=v[c+8>>2]+16;f=v[a>>2];d=v[a+4>>2];b=c+4|0;while(1){if((d|0)!=(f|0)){d=d-16|0;yx(v[b>>2]-16|0,d);v[b>>2]=v[b>>2]-16;continue}break}qc(a,b);qc(a+4|0,c+8|0);qc(Gb(a),Cc(c));v[c>>2]=v[c+4>>2];a=v[c+4>>2];while(1){b=v[c+8>>2];if((b|0)!=(a|0)){b=b-16|0;v[c+8>>2]=b;Cs(b);continue}break}a=v[c>>2];if(a){bp(c);Mb(a)}kb=e+32|0}function jha(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;e=kb-16|0;kb=e;i=e,j=Aj(b),v[i>>2]=j;f=x[b>>1];d=kb-16|0;kb=d;g=a;c=Td(a);a:{if(c){b=jc(g);while(1){a=c;c=x[a+14>>1];if(oo(f,c)){b=a;c=v[a>>2];if(c){continue}break a}if(!oo(c,f)){break a}b=a+4|0;c=v[a+4>>2];if(c){continue}break}break a}a=jc(g);b=a}v[d+12>>2]=a;a=v[b>>2];if(!a){a=kb-16|0;kb=a;c=jc(g);f=lh(d,vc(20),mh(a+8|0,c));c=v[f>>2];h=x[v[e>>2]>>1];u[c+16>>1]=0;u[c+14>>1]=h;i=jc(f),j=1,t[i+4|0]=j;kb=a+16|0;Jg(g,v[d+12>>2],b,v[d>>2]);a=ce(d);rk(d);h=1}Ig(e+8|0,v[fc(d,a)>>2],h);kb=d+16|0;a=so(v[e+8>>2]);kb=e+16|0;return a+2|0}function MN(a,b){var c=0,d=0,e=0,f=0,g=0,h=0;c=kb-16|0;kb=c;a:{if(w[b+791|0]!=27){a=t[b+831|0];break a}d=c+8|0;f=a+1074312|0;Db(d,f,21);e=a;a=w[b+821|0];a=py(e,w[b+828|0],Cb(v[v[c+8>>2]>>2],v[c+12>>2])?a:a+16>>>2|0);Db(d,f,45);b:{if(!(!Cb(v[v[c+8>>2]>>2],v[c+12>>2])|w[b+828|0]!=3)){d=w[b+821|0];c:{if(!(!d|d>>>0>=w[b+829|0])){a=w[b+832|0];e=d+1|0;break c}t[b+832|0]=a;e=1}t[b+821|0]=e;a=a<<24>>24;break b}t[b+821|0]=w[b+821|0]+w[b+829|0]}Db(c+8|0,f,47);if(!Cb(v[v[c+8>>2]>>2],v[c+12>>2])){break a}t[b+831|0]=a}if(a){g=b,h=Zb(v[b+684>>2]+((B(w[b+830|0],a)+2|0)/8|0)|0,0,256),v[g+684>>2]=h}kb=c+16|0}function aY(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;a:{g=kb+-64|0;kb=g;nn(g+16|0,c);v[23540]=0;c=g+28|0;R(113,c|0,d|0);d=v[23540];v[23540]=0;b:{c:{d:{if((d|0)==1){break d}v[23540]=0;c=g+40|0;R(113,c|0,e|0);d=v[23540];v[23540]=0;if((d|0)==1){break d}v[23540]=0;c=g+52|0;R(113,c|0,f|0);d=v[23540];v[23540]=0;if((d|0)==1){break d}Uv(g+8|0,g+16|0);v[23540]=0;X(114,a|0,b|0,v[g+8>>2],v[g+12>>2]);a=v[23540];v[23540]=0;if((a|0)==1){break c}kE(g+16|0);kb=g- -64|0;break a}a=P()|0;O()|0;while(1){c=Ab(c-12|0);if((c|0)!=(g+16|0)){continue}break}break b}a=P()|0;O()|0;kE(g+16|0)}T(a|0);L()}}function RT(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;e=kb-16|0;kb=e;i=e,j=Aj(b),v[i>>2]=j;f=v[b>>2];d=kb-16|0;kb=d;g=a;c=Td(a);a:{if(c){b=jc(g);while(1){a=c;c=v[a+16>>2];if(NT(f,c)){b=a;c=v[a>>2];if(c){continue}break a}if(!NT(c,f)){break a}b=a+4|0;c=v[a+4>>2];if(c){continue}break}break a}a=jc(g);b=a}v[d+12>>2]=a;a=v[b>>2];if(!a){a=kb-16|0;kb=a;c=jc(g);f=lh(d,vc(24),mh(a+8|0,c));c=v[f>>2];h=v[v[e>>2]>>2];v[c+20>>2]=0;v[c+16>>2]=h;i=jc(f),j=1,t[i+4|0]=j;kb=a+16|0;Jg(g,v[d+12>>2],b,v[d>>2]);a=ce(d);rk(d);h=1}Ig(e+8|0,v[fc(d,a)>>2],h);kb=d+16|0;a=vd(v[e+8>>2]);kb=e+16|0;return a+4|0}function Hk(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;e=kb-16|0;kb=e;f=a+36|0;c=v[a+32>>2];a:{b:{while(1){if((b|0)<=(c|0)){break b}c:{d=v[a+20>>2];if(d>>>0>=y[a+24>>2]){un(e,f,PD(f));ud(e+8|0,a,v[e>>2],v[e+4>>2]);c=v[e+12>>2];v[a+24>>2]=c;v[a+20>>2]=0;if(!c){break c}d=0;c=v[a+32>>2]}v[a+20>>2]=d+1;g=w[(a+d|0)+36|0];d=c+8|0;v[a+32>>2]=d;v[a+28>>2]=v[a+28>>2]|g<<c;c=d;continue}break}a=ba(8)|0;v[23540]=0;b=S(167,a|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){break a}b=P()|0;O()|0;ca(a|0);T(b|0);L()}v[a+32>>2]=c-b;d=a;a=v[a+28>>2];v[d+28>>2]=a>>>b;kb=e+16|0;return a&(-1<<b^-1)}ha(b|0,30544,168);L()}function i_(a){a=a|0;if(w[468240]){return v[117059]}if(!w[469344]){a=469056;while(1){a=Nb(a)+12|0;if((a|0)!=469344){continue}break}t[469344]=1}qd(469056,89040);qd(469068,89072);qd(469080,89108);qd(469092,89132);qd(469104,89156);qd(469116,89172);qd(469128,89192);qd(469140,89212);qd(469152,89240);qd(469164,89280);qd(469176,89312);qd(469188,89348);qd(469200,89384);qd(469212,89400);qd(469224,89416);qd(469236,89432);qd(469248,89156);qd(469260,89448);qd(469272,89464);qd(469284,89480);qd(469296,89496);qd(469308,89512);qd(469320,89528);qd(469332,89544);t[468240]=1;v[117059]=469056;return 469056}function d7(a,b,c){a=a|0;b=+b;c=c|0;var d=0,e=0,f=0;d=kb-80|0;kb=d;v[d+72>>2]=c;c=v[a>>2];e=v[a+4>>2];f=v[a+12>>2];v[d+40>>2]=v[a+8>>2];v[d+44>>2]=f;v[d+32>>2]=c;v[d+36>>2]=e;a=ee(d+24|0);c=v[a+4>>2];a=v[a>>2];e=v[d+44>>2];v[d+8>>2]=v[d+40>>2];v[d+12>>2]=e;v[23540]=0;e=v[d+36>>2];v[d>>2]=v[d+32>>2];v[d+4>>2]=e;X(930,d+48|0,d|0,a|0,c|0);a=v[23540];v[23540]=0;a:{b:{if((a|0)!=1){a=v[eg(d+16|0,d+72|0)>>2];v[23540]=0;b=+Aa(931,d+48|0,+b,a|0);a=v[23540];v[23540]=0;if((a|0)==1){break b}Bb(d+48|0);De(d+72|0);kb=d+80|0;return+b}a=P()|0;O()|0;break a}a=P()|0;O()|0;Bb(d+48|0)}De(d+72|0);T(a|0);L()}function Kda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;b=kb-16|0;kb=b;h=v[a+24>>2];i=v[a+20>>2];j=v[a+16>>2];e=v[a+4>>2];v[b+8>>2]=v[a>>2];v[b+12>>2]=e;k=v[a+8>>2];l=v[a+12>>2];while(1){if(d){e=v[b+8>>2];m=e>>>18|0;n=((((v[b+12>>2]&2147483647)<<1|e>>>31)&2147483646)<<1)+j|0;e=0;while(1){if((e|0)!=2){f=(e<<1)+n|0;g=u[f>>1];v[(e<<2)+b>>2]=g+((B(u[f+4>>1]-g|0,m)|0)/16384|0);e=e+1|0;continue}break}v[c>>2]=v[c>>2]+B(v[b>>2],i);v[c+4>>2]=v[c+4>>2]+B(v[b+4>>2],h);Rb(b+8|0,k,l);c=c+8|0;d=d-1|0;continue}break}c=v[b+12>>2];v[a>>2]=v[b+8>>2];v[a+4>>2]=c;kb=b+16|0}function D9(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;if(y[a+4>>2]<y[Gb(a)>>2]){c=kb-16|0;kb=c;a=Kz(c,a);Vx(v[a+4>>2],b);v[a+4>>2]=v[a+4>>2]+4;lc(a);kb=c+16|0;return}e=kb-32|0;kb=e;c=Gb(a);c=Vf(e+8|0,qg(a,uc(v[a>>2],v[a+4>>2])+1|0),uc(v[a>>2],v[a+4>>2]),c);Vx(v[c+8>>2],b);v[c+8>>2]=v[c+8>>2]+4;f=v[a>>2];d=v[a+4>>2];b=c+4|0;while(1){if((d|0)!=(f|0)){d=d-4|0;Vx(v[b>>2]-4|0,d);v[b>>2]=v[b>>2]-4;continue}break}qc(a,b);qc(a+4|0,c+8|0);qc(Gb(a),Cc(c));v[c>>2]=v[c+4>>2];a=v[c+4>>2];while(1){b=v[c+8>>2];if((b|0)!=(a|0)){b=b-4|0;v[c+8>>2]=b;sg(b);continue}break}a=v[c>>2];if(a){Lz(c);Mb(a)}kb=e+32|0}function C6(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=kb-32|0;kb=c;v[23540]=0;Y(946,a|0);d=v[23540];v[23540]=0;a:{b:{c:{if((d|0)==1){break c}v[23540]=0;Y(947,b|0);d=v[23540];v[23540]=0;if((d|0)==1){break c}d=v[a+24>>2];b=rc(c+8|0,b);e=v[b+4>>2];b=v[b>>2];v[23540]=0;da(959,c+16|0,d|0,b|0,e|0,1);b=v[23540];v[23540]=0;if((b|0)==1){break c}a=c+16|0;b=gg(Mc(a));zb(a);break b}b=V(0)|0;O()|0;_(b|0)|0;b=0;v[23540]=0;X(933,5538,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)==1){break a}$()}kb=c+32|0;return b|0}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function Jg(a,b,c,d){var e=0,f=0;v[d+8>>2]=b;v[d>>2]=0;v[d+4>>2]=0;v[c>>2]=d;b=v[v[a>>2]>>2];if(b){v[a>>2]=b;d=v[c>>2]}f=v[jc(a)>>2];t[d+12|0]=(f|0)==(d|0);while(1){a:{if((d|0)==(f|0)){break a}c=v[d+8>>2];if(w[c+12|0]){break a}b:{if(Ch(c)){b=v[c+8>>2];e=v[b+4>>2];if(!(!e|w[e+12|0])){break b}if(!Ch(d)){uq(c);c=v[c+8>>2]}t[c+12|0]=1;b=v[c+8>>2];t[b+12|0]=0;tq(b);break a}b=v[c+8>>2];e=v[b>>2];if(!(!e|w[e+12|0])){break b}if(Ch(d)){tq(c);c=v[c+8>>2]}t[c+12|0]=1;b=v[c+8>>2];t[b+12|0]=0;uq(b);break a}t[c+12|0]=1;d=b;t[d+12|0]=(d|0)==(f|0);t[e+12|0]=1;continue}break}a=Gb(a);v[a>>2]=v[a>>2]+1}function D1(){var a=0,b=0,c=0,d=0,e=0,f=0,g=0;d=kb-32|0;kb=d;if(_H(0,d+16|0)){is(v[116016],12663);L()}b=hs(d+8|0,v[d+16>>2]);e=hs(d,v[d+20>>2]/1e3|0);c=kb-32|0;kb=c;a=kb-16|0;kb=a;f=kb-16|0;kb=f;b=cm(f+8|0,Jka(v[b>>2],v[b+4>>2],1e6,0),nb);g=v[b+4>>2];b=v[b>>2];kb=f+16|0;v[a+8>>2]=b;v[a+12>>2]=g;b=v[a+12>>2];v[c+16>>2]=v[a+8>>2];v[c+20>>2]=b;kb=a+16|0;a=v[c+16>>2];f=v[c+20>>2];b=v[e+4>>2];v[c+8>>2]=v[e>>2];v[c+12>>2]=b;e=v[c+8>>2];b=a+e|0;a=v[c+12>>2]+f|0;a=cm(c+24|0,b,b>>>0<e>>>0?a+1|0:a);b=v[a+4>>2];a=v[a>>2];kb=c+32|0;c=cm(d+24|0,a,b);a=v[c+4>>2];c=v[c>>2];kb=d+32|0;nb=a;return c|0}function Hm(a,b,c,d,e,f,g,h){var i=0,j=0,k=0,l=0;i=1;j=d&2147483647;l=j;k=(j|0)==2147418112;a:{if(k&!c?a|b:k&(c|0)!=0|j>>>0>2147418112){break a}j=h&2147483647;k=(j|0)==2147418112;if(k&!g?e|f:k&(g|0)!=0|j>>>0>2147418112){break a}if(!(a|e|(c|g)|(b|f|(j|l)))){return 0}i=d&h;if((i|0)>0|(i|0)>=0){i=-1;if((c|0)==(g|0)&(d|0)==(h|0)?(b|0)==(f|0)&a>>>0<e>>>0|b>>>0<f>>>0:c>>>0<g>>>0&(d|0)<=(h|0)|(d|0)<(h|0)){break a}return(a^e|c^g|(b^f|d^h))!=0}i=-1;if((c|0)==(g|0)&(d|0)==(h|0)?(b|0)==(f|0)&a>>>0>e>>>0|b>>>0>f>>>0:c>>>0>g>>>0&(d|0)>=(h|0)|(d|0)>(h|0)){break a}i=(a^e|c^g|(b^f|d^h))!=0}return i}function fm(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0;e=kb-32|0;kb=e;t[a|0]=0;a:{d=v[v[b>>2]-12>>2]+b|0;b:{if(Yg(d)){d=v[d+72>>2];if(d){ar(d)}c:{if(c){break c}c=v[v[b>>2]-12>>2]+b|0;if(!(v[c+4>>2]&4096)){break c}d=e+24|0;gd(d,c);v[23540]=0;f=S(19,d|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break a}ac(e+24|0);c=Tm(e+16|0,b);d=Gc(e+8|0);while(1){d:{if(!rp(c,d)){break d}g=Zk(v[c>>2]);if(!vh(v[f+8>>2],8192,g)){break d}em(c);continue}break}if(!bj(c,d)){break c}Ki(v[v[b>>2]-12>>2]+b|0,6)}h=a,i=Yg(v[v[b>>2]-12>>2]+b|0),t[h|0]=i;break b}Ki(d,4)}kb=e+32|0;return a}a=P()|0;O()|0;ac(e+24|0);T(a|0);L()}function lI(a){var b=0,c=0,d=0,e=0,f=0,g=0,h=0;if($e(a)){ec(a,31);return 0}g=a,h=$e(a),t[g+1375|0]=h;d=ej(a);b=ej(a);ej(a);g=a,h=ej(a),v[g+1112>>2]=h;ej(a);c=$e(a);v[a+1116>>2]=c;if(!hx(a,a+1120|0,c)){ec(a,10);return 0}v[a+1404>>2]=-2;a:{if((b&d)==-1){break a}b=v[a+1116>>2];while(1){if((b|0)<=0){break a}b=b-1|0;if(w[(b+a|0)+1120|0]==255){continue}break}v[a+1408>>2]=d;v[a+1404>>2]=b}if(w[a+1377|0]){b=0;e=v[a+1116>>2];f=(e|0)>0?e:0;c=0;while(1){if((b|0)!=(f|0)){c=w[(a+b|0)+1120|0]+c|0;b=b+1|0;continue}break}v[a- -64>>2]=d;v[a+60>>2]=(v[a+56>>2]+(c+e|0)|0)+27}v[a+1380>>2]=0;return 1}function uw(a,b,c,d,e){var f=0,g=0;f=kb-16|0;kb=f;g=f+8|0;gd(g,b);v[23540]=0;b=S(1132,g|0)|0;g=v[23540];v[23540]=0;a:{if((g|0)==1){break a}v[23540]=0;X(1144,b|0,83808,83840,c|0);b=v[23540];v[23540]=0;if((b|0)==1){break a}v[23540]=0;b=S(1133,f+8|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break a}v[23540]=0;c=S(1145,b|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break a}v[d>>2]=c;v[23540]=0;c=S(1142,b|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break a}v[e>>2]=c;v[23540]=0;R(1143,a|0,b|0);a=v[23540];v[23540]=0;if((a|0)==1){break a}ac(f+8|0);kb=f+16|0;return}a=P()|0;O()|0;ac(f+8|0);T(a|0);L()}function Lda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;b=kb-16|0;kb=b;h=v[a+24>>2];i=v[a+20>>2];j=v[a+16>>2];e=v[a+4>>2];v[b+8>>2]=v[a>>2];v[b+12>>2]=e;k=v[a+8>>2];l=v[a+12>>2];while(1){if(d){e=v[b+8>>2];m=e>>>10&4194048;n=(((v[b+12>>2]&2147483647)<<1|e>>>31)&-2)+j|0;e=0;while(1){if((e|0)!=2){f=e+n|0;g=t[f|0];v[(e<<2)+b>>2]=((B(t[f+2|0]-g|0,m)|0)/16384|0)+(g<<8);e=e+1|0;continue}break}v[c>>2]=v[c>>2]+B(v[b>>2],i);v[c+4>>2]=v[c+4>>2]+B(v[b+4>>2],h);Rb(b+8|0,k,l);c=c+8|0;d=d-1|0;continue}break}c=v[b+12>>2];v[a>>2]=v[b+8>>2];v[a+4>>2]=c;kb=b+16|0}function rY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;f=c;c=kb-16|0;kb=c;v[23540]=0;Y(946,a|0);e=v[23540];v[23540]=0;a:{b:{c:{d:{if((e|0)==1){break d}v[23540]=0;Y(947,b|0);e=v[23540];v[23540]=0;if((e|0)==1){break d}e=v[a+24>>2];b=rc(c+8|0,b);g=v[b+4>>2];b=v[b>>2];v[23540]=0;pF(967,e,b,g,f,d);d=v[23540];v[23540]=0;b=1;if((d|0)!=1){break c}}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,8671,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)==1){break b}$();b=0}kb=c+16|0;break a}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}return b|0}function L$(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=kb-32|0;kb=f;v[f+24>>2]=b;a:{if(!(v[c+4>>2]&1)){c=ob[v[v[a>>2]+24>>2]](a,b,c,d,e)|0;break a}a=f+8|0;gd(a,c);v[23540]=0;a=S(1133,a|0)|0;b=v[23540];v[23540]=0;b:{if((b|0)!=1){ac(f+8|0);c:{if(e){Qh(f+8|0,a);break c}Ph(f+8|0,a)}g=f,h=he(f+8|0),v[g>>2]=h;while(1){a=Tk(f+8|0);b=v[f>>2];if(!Pb(b,a)){c=v[f+24>>2];Nc(f+8|0);break a}a=v[b>>2];v[23540]=0;Q(1148,f+24|0,a|0)|0;a=v[23540];v[23540]=0;if((a|0)!=1){Le(f);continue}break}c=P()|0;O()|0;Nc(f+8|0);break b}c=P()|0;O()|0;ac(f+8|0)}T(c|0);L()}kb=f+32|0;return c|0}function Eha(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;e=kb-48|0;kb=e;d=v[a+8>>2];c=v[a>>2];v[23540]=0;d=W(156,c|0,d|0,1)|0;c=v[23540];v[23540]=0;a:{if((c|0)==1){break a}b:{if(!d){break b}v[23540]=0;Y(502,b|0);d=v[23540];v[23540]=0;if((d|0)==1){break a}v[23540]=0;d=S(206,a|0)|0;c=v[23540];v[23540]=0;c:{if((c|0)!=1){while(1){if(!(d&255)){break b}v[23540]=0;c=Q(503,a|0,e+8|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break c}d:{if(!c){break d}c=w[e+8|0];if(c>>>0>63){break d}sc(TS(v[b>>2],c),e+8|0,33)}d=d-1|0;continue}}break a}break a}Bb(a);kb=e+48|0;return}b=P()|0;O()|0;Bb(a);T(b|0);L()}function yw(a,b,c,d,e){var f=0,g=0;f=kb-16|0;kb=f;g=f+8|0;gd(g,b);v[23540]=0;b=S(19,g|0)|0;g=v[23540];v[23540]=0;a:{if((g|0)==1){break a}v[23540]=0;X(1130,b|0,83808,83840,c|0);b=v[23540];v[23540]=0;if((b|0)==1){break a}v[23540]=0;b=S(1115,f+8|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break a}v[23540]=0;c=S(1131,b|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break a}t[d|0]=c;v[23540]=0;c=S(1128,b|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break a}t[e|0]=c;v[23540]=0;R(1129,a|0,b|0);a=v[23540];v[23540]=0;if((a|0)==1){break a}ac(f+8|0);kb=f+16|0;return}a=P()|0;O()|0;ac(f+8|0);T(a|0);L()}function eL(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;a=vi(a,b,c,d);t[a+4260|0]=e;v[a>>2]=46348;c=Tb(a+4264|0);d=Tb(a+4276|0);v[a+4328>>2]=0;b=a+4320|0;v[b>>2]=0;v[b+4>>2]=0;v[a+4312>>2]=0;v[a+4316>>2]=0;b=a+4208|0;f=Eb(b,0),g=1056964608,v[f>>2]=g;f=Eb(b,1),g=1036831949,v[f>>2]=g;f=Eb(b,2),g=1038174126,v[f>>2]=g;f=Eb(b,3),g=1065353216,v[f>>2]=g;f=Eb(b,4),g=1061158912,v[f>>2]=g;f=Eb(b,5),g=1059082943,v[f>>2]=g;f=Eb(b,6),g=1061997773,v[f>>2]=g;v[23540]=0;R(897,a+44|0,2);b=v[23540];v[23540]=0;if((b|0)!=1){ui(a);return a|0}b=P()|0;O()|0;wc(d);wc(c);If(a);T(b|0);L()}function Qg(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=v[a>>2];c=uc(d,v[a+4>>2]);if(c>>>0<b>>>0){e=kb-32|0;kb=e;b=b-c|0;c=v[Gb(a)>>2];d=v[a+4>>2];a:{if(b>>>0<=c-d>>2>>>0){c=kb-16|0;kb=c;b=Ah(c,a,b);a=v[b+4>>2];d=v[b+8>>2];while(1){if((a|0)==(d|0)){lc(b);kb=c+16|0}else{pv(a);a=a+4|0;v[b+4>>2]=a;continue}break}break a}c=Gb(a);c=Vf(e+8|0,qg(a,uc(v[a>>2],d)+b|0),uc(v[a>>2],v[a+4>>2]),c);f=kb-16|0;kb=f;b=Xm(f,c+8|0,b);d=v[b>>2];while(1){if(v[b+4>>2]!=(d|0)){pv(d);d=v[b>>2]+4|0;v[b>>2]=d;continue}break}Ud(b);kb=f+16|0;Fd(a,c);Uf(c)}kb=e+32|0;return}if(b>>>0<c>>>0){Od(a,d+(b<<2)|0)}}function sD(a){var b=0,c=0,d=0;b=kb-16|0;kb=b;v[b+4>>2]=B(w[a+12|0]|w[a+13|0]<<8|(w[a+14|0]<<16|w[a+15|0]<<24),5)+(w[a+16|0]|w[a+17|0]<<8|(w[a+18|0]<<16|w[a+19|0]<<24));v[b+8>>2]=(w[a+24|0]|w[a+25|0]<<8|(w[a+26|0]<<16|w[a+27|0]<<24))+((w[a+20|0]|w[a+21|0]<<8|(w[a+22|0]<<16|w[a+23|0]<<24))<<3);v[b+12>>2]=(w[a+32|0]|w[a+33|0]<<8|(w[a+34|0]<<16|w[a+35|0]<<24))+((w[a+28|0]|w[a+29|0]<<8|(w[a+30|0]<<16|w[a+31|0]<<24))<<2);a=b+4|0;d=Eb(a,3);a:{if((a|0)==(d|0)){break a}c=a;while(1){c=c+4|0;if((d|0)==(c|0)){break a}a=ro(v[a>>2],v[c>>2])?c:a;continue}}kb=b+16|0;return v[a>>2]-36|0}function WZ(a){a=a|0;if(w[468232]){return v[117057]}if(!w[469040]){a=468752;while(1){a=Nb(a)+12|0;if((a|0)!=469040){continue}break}t[469040]=1}pd(468752,5037);pd(468764,5028);pd(468776,10865);pd(468788,10609);pd(468800,5264);pd(468812,11641);pd(468824,5121);pd(468836,5612);pd(468848,8915);pd(468860,8898);pd(468872,8906);pd(468884,8925);pd(468896,10092);pd(468908,13235);pd(468920,8988);pd(468932,7674);pd(468944,5264);pd(468956,9781);pd(468968,10497);pd(468980,10877);pd(468992,9278);pd(469004,6466);pd(469016,5495);pd(469028,13153);t[468232]=1;v[117057]=468752;return 468752}function Wt(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=kb-16|0;kb=c;LR(c+8|0,b);d=v[c+12>>2];nc(c,v[a>>2],v[a+8>>2],v[c+8>>2],v[c+12>>2]);e=v[c+4>>2];if((e|0)==(d|0)){$b(a,v[c+12>>2])}kb=c+16|0;if((d|0)!=(e|0)){t[b|0]=0;t[b+1|0]=0;t[b+2|0]=0;t[b+3|0]=0;t[b+4|0]=0;t[b+5|0]=0;t[b+6|0]=0;t[b+7|0]=0;t[b+24|0]=0;t[b+25|0]=0;t[b+26|0]=0;t[b+27|0]=0;t[b+28|0]=0;t[b+29|0]=0;t[b+30|0]=0;t[b+31|0]=0;t[b+16|0]=0;t[b+17|0]=0;t[b+18|0]=0;t[b+19|0]=0;t[b+20|0]=0;t[b+21|0]=0;t[b+22|0]=0;t[b+23|0]=0;t[b+8|0]=0;t[b+9|0]=0;t[b+10|0]=0;t[b+11|0]=0;t[b+12|0]=0;t[b+13|0]=0;t[b+14|0]=0;t[b+15|0]=0}}function y6(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=kb-16|0;kb=e;v[23540]=0;Y(946,a|0);d=v[23540];v[23540]=0;a:{b:{c:{if((d|0)==1){break c}v[23540]=0;Y(947,b|0);d=v[23540];v[23540]=0;if((d|0)==1){break c}d=v[a+24>>2];b=rc(e+8|0,b);f=v[b+4>>2];b=v[b>>2];v[23540]=0;da(964,d|0,b|0,f|0,(c|0)!=0|0,1);c=v[23540];v[23540]=0;b=1;if((c|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,10024,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)==1){break a}$();b=0}kb=e+16|0;return b|0}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function sY(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=kb-16|0;kb=d;v[23540]=0;Y(946,a|0);c=v[23540];v[23540]=0;a:{b:{c:{d:{if((c|0)==1){break d}v[23540]=0;Y(947,b|0);c=v[23540];v[23540]=0;if((c|0)==1){break d}e=v[a+24>>2];b=rc(d+8|0,b);c=v[b+4>>2];b=v[b>>2];v[23540]=0;b=qF(e,b,c,1);e=v[23540];v[23540]=0;c=nb;if((e|0)!=1){break c}}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,8702,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)==1){break b}$();b=0;c=0}kb=d+16|0;a=c;break a}b=P()|0;O()|0;v[23540]=0;Z(18);a=v[23540];v[23540]=0;if((a|0)!=1){T(b|0);L()}V(0)|0;O()|0;Vb();L()}ra(a|0);return b|0}function E0(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;c=kb-32|0;kb=c;a:{b:{c:{if(pc(b,-1)){break c}i=c,j=sp(b),t[i+23|0]=j;if(w[a+44|0]){d=-1;if((wk(c+23|0,1,1,v[a+32>>2])|0)==1){break c}break a}f=c+24|0;v[c+16>>2]=f;h=c+32|0;d=c+23|0;while(1){e=$r(v[a+36>>2],v[a+40>>2],d,f,c+12|0,c+24|0,h,c+16|0);if(v[c+12>>2]==(d|0)){break b}if((e|0)==3){if((wk(d,1,1,v[a+32>>2])|0)==1){break c}break b}if(e>>>0>1){break b}g=c+24|0;d=v[c+16>>2]-g|0;if((wk(g,1,d,v[a+32>>2])|0)!=(d|0)){break b}d=v[c+12>>2];if((e|0)==1){continue}break}}d=Ow(b);break a}d=-1}kb=c+32|0;return d|0}function iN(a,b){var c=0,d=0,e=0,f=0,g=0,h=0;e=kb-16|0;kb=e;a:{if(v[a+480180>>2]!=1){break a}c=w[b+846|0];if(!c){break a}d=v[b+104>>2];if(!d){break a}if(!_d(v[d>>2],v[d+20>>2])){break a}f=x[d+34>>1];if(!(f&10)){break a}c=w[b+847|0]+w[(c&15)+33296|0]|0;t[b+847|0]=c;if(c<<24>>24>=0){break a}t[b+847|0]=0;h=f&2;c=v[(h?4:12)+d>>2];g=b;b=v[b+760>>2]+1|0;b=b>>>0<v[(h?8:16)+d>>2]-c>>>0?b:0;v[g+760>>2]=b;g=v[d+20>>2];c=b+c|0;b=Fk(f);gc(e+8|0,g+B(c,b)|0,b);b=v[e+8>>2];f=Lb(b,v[e+12>>2]);while(1){if((b|0)==(f|0)){uj(d,a)}else{t[b|0]=w[b|0]^-1;b=b+1|0;continue}break}}kb=e+16|0}
function _da(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;b=kb-16|0;kb=b;g=v[a+16>>2];f=Tf(1,2);e=nb;h=e;Rb(a,f,e);i=v[a+24>>2];j=v[a+20>>2];e=v[a+4>>2];v[b+8>>2]=v[a>>2];v[b+12>>2]=e;k=v[a+8>>2];l=v[a+12>>2];while(1){if(d){d=d-1|0;m=((((v[b+12>>2]&2147483647)<<1|v[b+8>>2]>>>31)&2147483646)<<1)+g|0;e=0;while(1){if((e|0)!=2){v[(e<<2)+b>>2]=u[(e<<1)+m>>1];e=e+1|0;continue}break}v[c>>2]=v[c>>2]+B(v[b>>2],j);v[c+4>>2]=v[c+4>>2]+B(v[b+4>>2],i);Rb(b+8|0,k,l);c=c+8|0;continue}break}c=v[b+12>>2];v[a>>2]=v[b+8>>2];v[a+4>>2]=c;mg(a,f,h);kb=b+16|0}function Jda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;b=kb-16|0;kb=b;f=v[a+40>>2];g=v[a+36>>2];i=v[a+16>>2];e=v[a+4>>2];v[b+8>>2]=v[a>>2];v[b+12>>2]=e;j=v[a+32>>2];k=v[a+28>>2];l=v[a+8>>2];m=v[a+12>>2];while(1){if(d){h=v[b+12>>2]+i|0;e=t[h|0];e=((B(t[h+1|0]-e|0,v[b+8>>2]>>>10&4194048)|0)/16384|0)+(e<<8)|0;g=g+k|0;v[c>>2]=v[c>>2]+B(e,g>>12);f=f+j|0;v[c+4>>2]=v[c+4>>2]+B(e,f>>12);Rb(b+8|0,l,m);c=c+8|0;d=d-1|0;continue}break}c=v[b+12>>2];v[a>>2]=v[b+8>>2];v[a+4>>2]=c;v[a+40>>2]=f;v[a+20>>2]=g>>12;v[a+36>>2]=g;v[a+24>>2]=f>>12;kb=b+16|0}function A0(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=kb-32|0;kb=c;d=w[a+52|0];a:{if(pc(b,-1)){if(d){break a}b=v[a+48>>2];e=a,f=pc(b,-1)^1,t[e+52|0]=f;break a}b:{if(!d){break b}e=c,f=sp(v[a+48>>2]),t[e+19|0]=f;c:{d:{e:{d=c+20|0;switch($r(v[a+36>>2],v[a+40>>2],c+19|0,d,c+12|0,c+24|0,c+32|0,d)-1|0){case 0:case 1:break c;case 2:break e;default:break d}}d=v[a+48>>2];v[c+20>>2]=c+25;t[c+24|0]=d}while(1){d=v[c+20>>2];if(d>>>0<=c+24>>>0){break b}d=d-1|0;v[c+20>>2]=d;if((Zr(t[d|0],v[a+32>>2])|0)!=-1){continue}break}}b=-1;break a}t[a+52|0]=1;v[a+48>>2]=b}kb=c+32|0;return b|0}function Y6(a){a=a|0;var b=0;b=8045;a:{b:{c:{switch(a-277|0){default:if((a|0)==357){break b}d:{if((a|0)!=257){if((a|0)==267){break d}if(a){break a}b=21688;break a}b=8078;break a}b=17588;break a;case 0:b=5014;break a;case 9:b=8101;break a;case 10:b=8115;break a;case 11:b=5391;break a;case 12:b=5411;break a;case 19:b=8127;break a;case 20:b=8059;break a;case 21:b=12819;break a;case 22:b=12142;break a;case 1:case 2:case 3:case 4:case 5:case 6:case 7:case 8:case 13:case 14:case 15:case 16:case 17:case 18:break a;case 23:break c}}b=6022;break a}b=8012}return gg(b)|0}function Ida(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;b=kb-16|0;kb=b;f=v[a+40>>2];g=v[a+36>>2];i=v[a+16>>2];e=v[a+4>>2];v[b+8>>2]=v[a>>2];v[b+12>>2]=e;j=v[a+32>>2];k=v[a+28>>2];l=v[a+8>>2];m=v[a+12>>2];while(1){if(d){h=(v[b+12>>2]<<1)+i|0;e=u[h>>1];e=e+((B(u[h+2>>1]-e|0,v[b+8>>2]>>>18|0)|0)/16384|0)|0;g=g+k|0;v[c>>2]=v[c>>2]+B(e,g>>12);f=f+j|0;v[c+4>>2]=v[c+4>>2]+B(e,f>>12);Rb(b+8|0,l,m);c=c+8|0;d=d-1|0;continue}break}c=v[b+12>>2];v[a>>2]=v[b+8>>2];v[a+4>>2]=c;v[a+40>>2]=f;v[a+20>>2]=g>>12;v[a+36>>2]=g;v[a+24>>2]=f>>12;kb=b+16|0}function Qfa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;f=kb-32|0;kb=f;a:{c=v[a+12>>2];b:{if((c|0)==(b|0)){break b}d=b>>>0>c>>>0;c=B(Og(v[v[a+48>>2]+12>>2]),d?b-c|0:c-b|0);e=Fb(v[a+4>>2]);c:{if(d){e=fc(f+24|0,e);d=f+16|0;Fj(d);e=v[e>>2];v[23540]=0;X(636,a|0,e|0,c|0,d|0);c=v[23540];v[23540]=0;if((c|0)!=1){break c}a=V(92756)|0;if((O()|0)!=(ea(92756)|0)){break a}_(a|0)|0;$();break b}c=fc(f+8|0,jB(e,c));e=v[fc(f,Fb(v[a+4>>2]))>>2];d=v[c>>2];c=v[a>>2];c=B(Ws(d,Fb(c)),6)+c|0;if(Pb(d,e)){Od(a,ZL(c+B(Ws(e,d),6)|0,v[a+4>>2],c))}Fb(c)}v[a+12>>2]=b}kb=f+32|0;return}T(a|0);L()}function w6(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0;e=kb-16|0;kb=e;v[23540]=0;Y(946,a|0);d=v[23540];v[23540]=0;a:{b:{c:{if((d|0)==1){break c}v[23540]=0;Y(947,b|0);d=v[23540];v[23540]=0;if((d|0)==1){break c}d=v[a+24>>2];b=rc(e+8|0,b);f=v[b+4>>2];b=v[b>>2];v[23540]=0;$a(966,d|0,b|0,f|0,+c,1);d=v[23540];v[23540]=0;b=1;if((d|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,5929,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)==1){break a}$();b=0}kb=e+16|0;return b|0}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function Iba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;d=kb-16|0;kb=d;v[d+12>>2]=b;if(b>>>0<1073741808){a:{if(vn(a)>>>0>=b>>>0){break a}h=d,i=Hb(a),v[h+8>>2]=i;e=am(v[_c(d+12|0,d+8|0)>>2]);if((e|0)==(vn(a)|0)){break a}f=1;c=vn(a);g=Hb(a);b:{c:{if((e|0)==1){b=a;c=v[a>>2];break c}b=e+1|0;d:{if(c>>>0<e>>>0){b=Bi(b);break d}v[23540]=0;b=S(1222,b|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){break d}a=V(0)|0;O()|0;_(a|0)|0;$();break b}f=ef(a);c=Ac(a)}ni(b,c,Hb(a)+1|0);if(f){Mb(c)}if((e|0)!=1){ff(a,e+1|0);Hd(a,g);wd(a,b);break b}ie(a,g)}}kb=d+16|0;return}hf();L()}function Co(a,b,c,d,e,f){var g=0;g=kb-16|0;kb=g;t[g+14|0]=d;t[g+15|0]=c;t[g+13|0]=e;t[g+12|0]=f;d=0;a:{b:{while(1){c=d&255;if(c>>>0>3){break b}e=w[g+15|0];Qq(g+8|0,e,w[g+14|0],c>>>0>1);if(!(w[g+8|0]|!e)){d=d+1|0;Dh(g+15|0,g+13|0);Dh(g+14|0,g+12|0);continue}break}c=x[g+8>>1];t[b+2|0]=c;t[b+4|0]=c>>>8;c=w[g+13|0];t[b+5|0]=w[g+12|0];t[b+3|0]=c;t[g+7|0]=0;de(a,0,g+7|0);break a}d=w[g+15|0];e=Ji(d);c=w[g+13|0];if(e>>>0>Ji(c)>>>0){Dh(g+15|0,g+13|0);Dh(g+14|0,g+12|0);d=w[g+15|0];c=w[g+13|0]}t[b+4|0]=0;t[b+2|0]=0;t[b+5|0]=w[g+12|0];t[b+3|0]=c;de(a,d,g+14|0)}kb=g+16|0}function tt(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;c=kb-16|0;kb=c;v[c+12>>2]=b;if(b>>>0<4294967280){a:{if(bd(a)>>>0>=b>>>0){break a}h=c,i=Hb(a),v[h+8>>2]=i;d=nh(v[_c(c+12|0,c+8|0)>>2]);if((d|0)==(bd(a)|0)){break a}f=Hb(a);b:{c:{if((d|0)==10){g=1;b=a;e=v[a>>2];break c}b=d+1|0;d:{if(bd(a)>>>0<d>>>0){b=vc(b);break d}v[23540]=0;b=S(1221,b|0)|0;e=v[23540];v[23540]=0;if((e|0)!=1){break d}a=V(0)|0;O()|0;_(a|0)|0;$();break b}g=ef(a);e=Ac(a)}b=He(b,e,Hb(a)+1|0);if(g){Mb(e)}if((d|0)!=10){ff(a,d+1|0);Hd(a,f);wd(a,b);break b}ie(a,f)}}kb=c+16|0;return}hf();L()}function v8(a){a=a|0;var b=0,c=0;c=kb-16|0;kb=c;b=v[v[a+16>>2]+24620>>2];b=Hc(Kka(Jka(b,b>>31,3840,0),nb,1e3,0),nb);v[a+4316>>2]=b;v[23540]=0;v[c+12>>2]=0;U(903,a+4264|0,b|0,c+12|0);b=v[23540];v[23540]=0;a:{b:{c:{if((b|0)!=1){d:{if(!w[a+4260|0]){break d}b=v[a+4316>>2];v[23540]=0;v[c+12>>2]=0;U(903,a+4276|0,b|0,c+12|0);b=v[23540];v[23540]=0;if((b|0)!=1){break d}b=V(92756)|0;break c}v[c+12>>2]=0;b=c+12|0;aL(a+4288|0,b);v[c+12>>2]=0;aL(a+4300|0,b);break b}b=V(92756)|0}if((O()|0)!=(ea(92756)|0)){break a}_(b|0)|0;v[a+4316>>2]=0;$()}kb=c+16|0;return}T(b|0);L()}function Uk(a,b,c){var d=0,e=0;e=kb-16|0;kb=e;v[a+4>>2]=0;d=4;a:{b:{c:{if(!Qd(w[fm(e+8|0,a,1)|0])){break c}d=v[(v[v[a>>2]-12>>2]+a|0)+24>>2];v[23540]=0;b=W(106,d|0,b|0,c|0)|0;d=v[23540];v[23540]=0;if((d|0)!=1){v[a+4>>2]=b;d=(b|0)==(c|0)?0:6;break c}b=V(0)|0;O()|0;_(b|0)|0;d=1;dm(v[v[a>>2]-12>>2]+a|0,1);if(v[(v[v[a>>2]-12>>2]+a|0)+20>>2]&1){v[23540]=0;Z(105);a=v[23540];v[23540]=0;if((a|0)!=1){break a}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)==1){break b}T(a|0);L()}$()}Ki(v[v[a>>2]-12>>2]+a|0,d);kb=e+16|0;return a}V(0)|0;O()|0;Vb()}L()}function vP(a,b){var c=0,d=0;t[a+15|0]=0;t[a+16|0]=0;t[a+17|0]=0;t[a+18|0]=0;t[a+19|0]=0;t[a+20|0]=0;t[a+21|0]=0;t[a+22|0]=0;t[a+14|0]=5;u[a+12>>1]=0;v[a+8>>2]=128;v[a>>2]=256;v[a+4>>2]=64;v[a+28>>2]=0;t[a+27|0]=60;v[a+40>>2]=0;v[a+44>>2]=0;t[a+33|0]=2;t[a+34|0]=0;t[a+35|0]=0;t[a+36|0]=2;t[a+23|0]=0;t[a+24|0]=0;t[a+25|0]=255;t[a+26|0]=0;t[a+32|0]=0;Gz(a+48|0);Gz(a+68|0);Gz(a+88|0);xt(a+492|0);xt(a+524|0);Mj(a,0,0);Lj(a,0,0);v[a+40>>2]=0;v[a+44>>2]=0;cu(a,b);b=a+108|0;d=gA(b);c=1;while(1){if((b|0)!=(d|0)){t[b|0]=c;c=c+1|0;b=b+1|0;continue}break}return a}function vr(a,b){a=a|0;b=b|0;var c=0,d=0;d=kb-16|0;kb=d;a=Nb(a);a:{b:{c:{switch(b|0){case 0:v[23540]=0;b=Q(1,d|0,15895)|0;c=v[23540];v[23540]=0;if((c|0)==1){break a}Jb(a,b);Ab(b);break b;case 1:v[23540]=0;b=Q(1,d|0,15920)|0;c=v[23540];v[23540]=0;if((c|0)!=1){Jb(a,b);Ab(b);break b}break a;case 2:v[23540]=0;b=Q(1,d|0,15868)|0;c=v[23540];v[23540]=0;if((c|0)!=1){Jb(a,b);Ab(b);break b}break a;case 3:break c;default:break b}}v[23540]=0;b=Q(1,d|0,15842)|0;c=v[23540];v[23540]=0;if((c|0)==1){break a}Jb(a,b);Ab(b)}kb=d+16|0;return}b=P()|0;O()|0;Ab(a);T(b|0);L()}function M0(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;c=kb-32|0;kb=c;a:{b:{c:{if(En(b)){break c}v[c+20>>2]=b;if(w[a+44|0]){d=-1;if((wk(c+20|0,4,1,v[a+32>>2])|0)==1){break c}break a}f=c+24|0;v[c+16>>2]=f;h=c+32|0;d=c+20|0;while(1){e=$r(v[a+36>>2],v[a+40>>2],d,f,c+12|0,c+24|0,h,c+16|0);if(v[c+12>>2]==(d|0)){break b}if((e|0)==3){if((wk(d,1,1,v[a+32>>2])|0)==1){break c}break b}if(e>>>0>1){break b}g=c+24|0;d=v[c+16>>2]-g|0;if((wk(g,1,d,v[a+32>>2])|0)!=(d|0)){break b}d=v[c+12>>2];if((e|0)==1){continue}break}}d=En(b)?0:b;break a}d=-1}kb=c+32|0;return d|0}function H6(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=kb-16|0;kb=d;v[23540]=0;Y(946,a|0);c=v[23540];v[23540]=0;a:{b:{c:{if((c|0)==1){break c}v[23540]=0;Y(947,b|0);c=v[23540];v[23540]=0;if((c|0)==1){break c}c=v[a+24>>2];b=rc(d+8|0,b);e=v[b+4>>2];b=v[b>>2];v[23540]=0;b=fa(953,c|0,b|0,e|0,1)|0;c=v[23540];v[23540]=0;if((c|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,10055,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)==1){break a}$();b=0}kb=d+16|0;return b|0}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function F6(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=kb-16|0;kb=d;v[23540]=0;Y(946,a|0);c=v[23540];v[23540]=0;a:{b:{c:{if((c|0)==1){break c}v[23540]=0;Y(947,b|0);c=v[23540];v[23540]=0;if((c|0)==1){break c}c=v[a+24>>2];b=rc(d+8|0,b);f=v[b+4>>2];b=v[b>>2];v[23540]=0;e=+za(957,c|0,b|0,f|0,1);b=v[23540];v[23540]=0;if((b|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,5966,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)==1){break a}$();e=0}kb=d+16|0;return+e}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function ms(a,b,c,d,e,f,g){var h=0,i=0,j=0,k=0,l=0;h=kb-240|0;kb=h;v[h+236>>2]=d;v[h+232>>2]=c;v[h>>2]=a;a:{b:{c:{d:{if((c|0)!=1){j=a;k=1;break d}j=a;k=1;if(d){break d}i=a;break c}while(1){i=j-v[(e<<2)+g>>2]|0;if((ob[b|0](i,a)|0)<=0){i=j;break c}e:{if(!((e|0)<2|f)){f=v[((e<<2)+g|0)-8>>2];l=j-4|0;if((ob[b|0](l,i)|0)>=0){break e}if((ob[b|0](l-f|0,i)|0)>=0){break e}}v[(k<<2)+h>>2]=i;c=YH(c,d);ns(h+232|0,c);k=k+1|0;e=c+e|0;f=0;j=i;d=v[h+236>>2];c=v[h+232>>2];if(d|(c|0)!=1){continue}break b}break}i=j;break b}if(f){break a}}XH(h,k);dx(i,b,e,g)}kb=h+240|0}function $da(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;b=kb-16|0;kb=b;g=v[a+16>>2];f=Tf(1,2);e=nb;h=e;Rb(a,f,e);i=v[a+24>>2];j=v[a+20>>2];e=v[a+4>>2];v[b+8>>2]=v[a>>2];v[b+12>>2]=e;k=v[a+8>>2];l=v[a+12>>2];while(1){if(d){d=d-1|0;m=(((v[b+12>>2]&2147483647)<<1|v[b+8>>2]>>>31)&-2)+g|0;e=0;while(1){if((e|0)!=2){v[(e<<2)+b>>2]=t[e+m|0]<<8;e=e+1|0;continue}break}v[c>>2]=v[c>>2]+B(v[b>>2],j);v[c+4>>2]=v[c+4>>2]+B(v[b+4>>2],i);Rb(b+8|0,k,l);c=c+8|0;continue}break}c=v[b+12>>2];v[a>>2]=v[b+8>>2];v[a+4>>2]=c;mg(a,f,h);kb=b+16|0}function _H(a,b){var c=0,d=0,e=0;if(!w[464068]){d=Ga()|0;t[464068]=1;t[464069]=d}a:{b:{c:{d:{switch(a|0){case 0:break b;case 1:case 4:break d;default:break c}}if(!w[464069]){break c}e=+Fa();break a}v[116016]=28;return-1}e=+Pa()}c=e/1e3;e:{if(D(c)<0x8000000000000000){d=D(c)>=1?~~(c>0?F(H(c*2.3283064365386963e-10),4294967295):I((c-+(~~c>>>0>>>0))*2.3283064365386963e-10))>>>0:0;a=~~c>>>0;break e}d=-2147483648;a=0}v[b>>2]=a;c=(e-(+(Jka(a,d,1e3,0)>>>0)+ +(nb|0)*4294967296))*1e3*1e3;f:{if(D(c)<2147483648){a=~~c;break f}a=-2147483648}v[b+4>>2]=a;return 0}function IR(a){var b=0,c=0,d=0;a:{if((w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24))!=1196314451){break a}c=w[a+4|0]|w[a+5|0]<<8|(w[a+6|0]<<16|w[a+7|0]<<24);if(c>>>0<1108){break a}b=a+1104|0;if((c-1108|0)!=(w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24))|c>>>0>262144){break a}c=a+1094|0;if(w[c|0]|w[c+1|0]<<8){break a}b=a+1096|0;if((w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24))-5>>>0<4294967292){break a}if(!Vt(a+8|0)){break a}a=a+40|0;while(1){d=(a|0)==(c|0);if(d|w[a+32|0]>15|w[a+33|0]>64){break a}b=Vt(a);a=a+34|0;if(b){continue}break}}return d}function I0(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=kb-32|0;kb=c;d=w[a+52|0];a:{if(En(b)){if(d){break a}b=v[a+48>>2];e=a,f=En(b)^1,t[e+52|0]=f;break a}b:{if(!d){break b}v[c+16>>2]=v[a+48>>2];c:{d:{e:{d=c+20|0;switch($r(v[a+36>>2],v[a+40>>2],c+16|0,d,c+12|0,c+24|0,c+32|0,d)-1|0){case 0:case 1:break c;case 2:break e;default:break d}}d=v[a+48>>2];v[c+20>>2]=c+25;t[c+24|0]=d}while(1){d=v[c+20>>2];if(d>>>0<=c+24>>>0){break b}d=d-1|0;v[c+20>>2]=d;if((Zr(t[d|0],v[a+32>>2])|0)!=-1){continue}break}}b=-1;break a}t[a+52|0]=1;v[a+48>>2]=b}kb=c+32|0;return b|0}function SA(a,b){var c=0,d=0;a:{b:{c:{d:{e:{f:{g:{h:{d=w[a+3|0];switch(d|0){case 9:break d;case 10:break e;case 16:case 17:break g;case 0:case 1:case 2:case 3:case 11:case 12:case 13:case 14:case 15:break h;default:break a}}if(!w[a|0]){break a}switch(d|0){case 9:break d;case 10:break e;case 0:case 1:case 2:case 3:case 11:case 12:case 13:case 14:case 15:break f;case 16:case 17:break g;default:break c}}c=8;break c}c=w[a|0];if(!(c&7)){break c}}c=b+1>>>1|0;b=((d|0)==10)<<4;break b}c=16}c=B(c>>>3|0,b);b=((d|0)==10)<<4}c=b+B(qq(w[a+1|0]),c)|0}return c}function $aa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;e=kb-208|0;kb=e;u[a+480212>>1]=0;v[a+480240>>2]=65536;v[a+480244>>2]=65536;WM(a+946304|0);f=a+906300|0;g=gk(f);d=e+48|0;Ub(d,0,160);d=YM(d);v[23540]=0;U(820,f|0,g|0,d|0);f=v[23540];v[23540]=0;a:{if((f|0)!=1){zy(d);d=je(e+24|0,b);v[23540]=0;f=v[d+12>>2];v[e+8>>2]=v[d+8>>2];v[e+12>>2]=f;v[e+16>>2]=v[d+16>>2];f=v[d+4>>2];v[e>>2]=v[d>>2];v[e+4>>2]=f;a=W(821,a|0,e|0,c|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){a=P()|0;O()|0;break a}Bb(b);kb=e+208|0;return a|0}a=P()|0;O()|0;zy(d)}Bb(b);T(a|0);L()}function Yda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;b=kb-16|0;kb=b;j=v[a+16>>2];h=Tf(1,2);e=nb;k=e;Rb(a,h,e);e=v[a+40>>2];f=v[a+36>>2];g=v[a+4>>2];v[b+8>>2]=v[a>>2];v[b+12>>2]=g;g=v[a+32>>2];l=v[a+28>>2];m=v[a+8>>2];n=v[a+12>>2];while(1){if(d){i=u[(v[b+12>>2]<<1)+j>>1];f=f+l|0;v[c>>2]=v[c>>2]+B(i,f>>12);e=e+g|0;v[c+4>>2]=v[c+4>>2]+B(e>>12,i);Rb(b+8|0,m,n);c=c+8|0;d=d-1|0;continue}break}c=v[b+12>>2];v[a>>2]=v[b+8>>2];v[a+4>>2]=c;v[a+40>>2]=e;v[a+20>>2]=f>>12;v[a+36>>2]=f;v[a+24>>2]=e>>12;mg(a,h,k);kb=b+16|0}function p5(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0;c=kb-32|0;kb=c;a:{f=a+36|0;b=v[f>>2];d=v[a+40>>2];b:{if(Pb(b,d)){Gc(c+24|0);break b}b=c+8|0;Kn(b,a);v[23540]=0;b=S(1006,b|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break a}v[c+24>>2]=b;Xf(c+8|0);d=v[a+40>>2];b=v[a+36>>2]}b=(g=f,h=v[c+24>>2],i=Pb(b,d),i?g:h);a=v[a+8>>2];c:{if((a|0)==-1){g=c,h=Fb(v[b>>2]),v[g+8>>2]=h;a=Fb(v[b+4>>2]);while(1){b=v[c+8>>2];if(!Pb(b,a)){break c}e=e+A[b>>3];Wx(c+8|0);continue}}e=A[lf(v[b>>2],a)>>3]}al(c+24|0);kb=c+32|0;return+e}a=P()|0;O()|0;Xf(c+8|0);T(a|0);L()}function lca(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;g=kb-16|0;kb=g;h=x[c>>1];i=c;e=kb-16|0;kb=e;f=b;d=Td(b);a:{if(d){c=jc(f);while(1){b=d;d=x[b+14>>1];if(Ek(h,d)){c=b;d=v[b>>2];if(d){continue}break a}if(!Ek(d,h)){break a}c=b+4|0;d=v[b+4>>2];if(d){continue}break}break a}b=jc(f);c=b}v[e+12>>2]=b;b=v[c>>2];if(!b){b=kb-16|0;kb=b;d=jc(f);d=lh(e,vc(16),mh(b+8|0,d));Mi(v[d>>2]+14|0,x[i>>1]);k=jc(d),l=1,t[k+4|0]=l;kb=b+16|0;Jg(f,v[e+12>>2],c,v[e>>2]);b=ce(e);rk(e);j=1}c=g+8|0;Ig(c,v[fc(e,b)>>2],j);kb=e+16|0;uP(a,c);kb=g+16|0}function wja(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;f=kb-16|0;kb=f;g=x[Gl(v[a>>2],v[a+4>>2],b)>>1];a:{b:{if(!Jq(a,b)){break b}c=v[a+24>>2];d=Fb(v[c+484360>>2]);v[f+8>>2]=d;h=Fb(v[c+484364>>2]);while(1){if(!Pb(d,h)){break b}e=0;i=Bl(v[d>>2],v[d+4>>2]);c:{while(1){if((e|0)!=(i|0)){if(!(!((a|0)!=(d|0)|(b|0)!=(e|0))|x[cc(v[d>>2],e)>>1]!=(g|0))){c=OR(v[a+24>>2]+484344|0,g);if((c|0)!=65535){break c}}e=e+1|0;continue}break}d=v[Cz(f+8|0)>>2];continue}break}j=Gl(v[a>>2],v[a+4>>2],b),k=c,u[j>>1]=k;break a}c=g}kb=f+16|0;return c&65535}function cfa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;v[a>>2]=0;v[a+4>>2]=0;Gc(a+8|0);if(b){c=kb-16|0;kb=c;v[c+12>>2]=477218588;v[c+8>>2]=2147483647;d=v[Kb(c+12|0,c+8|0)>>2];kb=c+16|0;if(b>>>0>d>>>0){cd();L()}b=B(b,9);c=vc(b);v[a>>2]=c;v[a+4>>2]=c;e=Gb(a),f=b+c|0,v[e>>2]=f;c=kb-16|0;kb=c;v[c>>2]=a;d=v[a+4>>2];v[c+4>>2]=d;v[c+8>>2]=b+d;b=v[c+4>>2];d=v[c+8>>2];while(1){if((b|0)==(d|0)){lc(c);kb=c+16|0}else{t[b|0]=0;t[b+1|0]=0;t[b+2|0]=0;t[b+3|0]=0;t[b+4|0]=0;t[b+5|0]=0;t[b+6|0]=0;t[b+7|0]=0;t[b+8|0]=0;b=b+9|0;v[c+4>>2]=b;continue}break}}return a|0}function PC(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;f=kb-16|0;kb=f;v[f+8>>2]=e;v[f+12>>2]=d;$f(a);tt(a,c);d=0;e=0;a:while(1){if(c>>>0>d>>>0){i=c-d|0;v[f+4>>2]=i;g=v[Kb(f+12|0,f+4|0)>>2];h=g+e|0;l=e>>>0>h>>>0?e:h;j=Hu(Ir(a,b+d|0,g),1,13);while(1)if((e|0)==(l|0)){v[f+4>>2]=i-g;e=h+1|0;d=v[Kb(f+8|0,f+4|0)>>2]+(d+g|0)|0;continue a}else{b:{c:{d:{k=t[Tc(j,e)|0];switch(k-10|0){case 1:case 2:break b;case 0:case 3:break c;default:break d}}if(k){break b}}m=Tc(j,e),n=32,t[m|0]=n}e=e+1|0;continue}}break}kb=f+16|0}function Zda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;b=kb-16|0;kb=b;j=v[a+16>>2];h=Tf(1,2);e=nb;k=e;Rb(a,h,e);e=v[a+40>>2];f=v[a+36>>2];g=v[a+4>>2];v[b+8>>2]=v[a>>2];v[b+12>>2]=g;g=v[a+32>>2];l=v[a+28>>2];m=v[a+8>>2];n=v[a+12>>2];while(1){if(d){i=t[v[b+12>>2]+j|0]<<8;f=f+l|0;v[c>>2]=v[c>>2]+B(i,f>>12);e=e+g|0;v[c+4>>2]=v[c+4>>2]+B(e>>12,i);Rb(b+8|0,m,n);c=c+8|0;d=d-1|0;continue}break}c=v[b+12>>2];v[a>>2]=v[b+8>>2];v[a+4>>2]=c;v[a+40>>2]=e;v[a+20>>2]=f>>12;v[a+36>>2]=f;v[a+24>>2]=e>>12;mg(a,h,k);kb=b+16|0}function w5(a){a=a|0;var b=0,c=0;v[23540]=0;Y(946,a|0);b=v[23540];v[23540]=0;if((b|0)!=1){a=v[a+24>>2];b=v[a+24>>2];c=x[b+1074448>>1];a:{if(c>>>0>=tj(Wb(v[b+484360>>2],w[b+484376|0]))>>>0){a=x[v[a+24>>2]+1074446>>1];break a}a=v[a+24>>2];b=x[cc(v[Wb(v[a+484360>>2],w[a+484376|0])>>2],c)>>1];a=Sm(v[a+484344>>2],v[a+484348>>2],b)?b:-1}return a|0}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,9785,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)!=1){$();return 0}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function Rn(a,b,c,d){var e=0,f=0;e=kb-16|0;kb=e;a:{b:{c:{if(!d){break c}d=c>>31;d=(d^c)-d|0;if(d>>>0<224){break c}Db(e+8|0,a+1074312|0,3);if(Cb(v[v[e+8>>2]>>2],v[e+12>>2])){break c}if(!(t[(B(b,872)+a|0)+1075843|0]&1)){break a}c=B((c>>31)+((c|0)>0)|0,d&15);c=d>>>0>239?c<<2:c;break b}if(t[(B(b,872)+a|0)+1075843|0]&1){Db(e+8|0,a+1074312|0,3);if(!Cb(v[v[e+8>>2]>>2],v[e+12>>2])){break a}}c=c<<2}if(!c){break a}f=B(b,872)+a|0;d=v[f+1075648>>2];a=Sp(a,v[f+1075080>>2],d);if(!a){break a}ob[v[v[a>>2]+84>>2]](a,c,(d?w[d+33|0]:13)<<24>>24,b)}kb=e+16|0}function GI(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=kb-16|0;kb=d;a:{b:{c:{a=v[a+32>>2];e=Gs(a);d:{if(!e){if(Fs(a)>>>0<=b>>>0){break d}a=Hi(a,b+1&65535);u[a+34>>1]=x[a+34>>1]&64511|(c?1024:0);break b}if(b>>>0<e>>>0){break c}}a=ba(8)|0;v[23540]=0;b=Q(55,d|0,6003)|0;c=v[23540];v[23540]=0;e:{if((c|0)!=1){a=tc(a,b);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break a}c=P()|0;O()|0;zb(b);break e}c=P()|0;O()|0;ca(a|0)}T(c|0);L()}a=v[(a+(b<<2)|0)+900384>>2];if(!a){break b}t[a+15|0]=w[a+15|0]&253|(c?2:0)}kb=d+16|0;return}L()}function kx(a,b,c){var d=0,e=0,f=C(0),g=C(0),h=C(0),i=C(0),j=0,k=C(0),l=C(0),m=C(0);e=kb-32|0;kb=e;g=z[a+24>>2];f=z[a+12>>2];h=z[a+48>>2];i=z[a+36>>2];oI(C(-z[a>>2]),C(g+f),C(h+i),e+20|0);oI(z[a+60>>2],C(h-i),C(g-f),e+8|0);z[e+12>>2]=-z[e+12>>2];a=0;while(1){if((a|0)!=3){d=a<<2;j=d+c|0;g=z[j>>2];f=z[d+(e+20|0)>>2];h=z[d+71312>>2];i=z[d+71324>>2];k=z[d+(e+8|0)>>2];z[j>>2]=C(f*h)-C(i*k);j=b+d|0;l=z[(0-a<<2)+71320>>2];d=5-a<<2;m=z[d+71312>>2];f=C(C(f*i)+C(k*h));z[j>>2]=C(g*l)-C(m*f);z[b+d>>2]=C(g*m)+C(f*l);a=a+1|0;continue}break}kb=e+32|0}function fo(a){var b=0,c=0,d=0,e=0,f=0,g=0;c=x[v[a+4>>2]+28>>1]>>>(!w[a+77|0]<<1)|0;d=x[a+24>>1];b=c+(d<<2)|0;v[a+40>>2]=((b&3)<<4)+27888;e=b>>>2|0;b=b>>>0<48;f=b?12-e|0:0;u[a+32>>1]=f;u[a+36>>1]=b?1:1<<e-12;u[a+34>>1]=-1<<f^-1;if((d|0)==15){u[a+36>>1]=4095}b=c+(x[a+26>>1]<<2)|0;v[a+52>>2]=((b&3)<<4)+27888;d=b>>>2|0;b=b>>>0<48;e=b?12-d|0:0;u[a+44>>1]=e;c=c+(x[a+30>>1]<<2)|0;v[a+64>>2]=((c&3)<<4)+27888;f=c>>>2|0;c=c>>>0<48;g=c?12-f|0:0;u[a+56>>1]=g;u[a+48>>1]=b?1:1<<d-12;u[a+60>>1]=c?1:1<<f-12;u[a+46>>1]=-1<<e^-1;u[a+58>>1]=-1<<g^-1}function Wd(a){var b=0,c=0,d=0;b=kb-16|0;kb=b;v[b+4>>2]=1126;v[b>>2]=a;v[b+8>>2]=0;d=kb-16|0;kb=d;if(v[a>>2]!=-1){a:{c=fc(d,Lf(d+8|0,b));while(1){if(v[a>>2]==1){continue}break}b:{if(!v[a>>2]){wd(a,1);c=v[v[c>>2]>>2];v[23540]=0;Y(1127,c|0);c=v[23540];v[23540]=0;if((c|0)==1){break b}v[a>>2]=-1}break a}b=V(0)|0;O()|0;_(b|0)|0;wd(a,0);v[23540]=0;Z(105);a=v[23540];v[23540]=0;c:{if((a|0)==1){a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){break c}V(0)|0;O()|0;Vb()}L()}T(a|0);L()}}kb=d+16|0;kb=b+16|0;return v[a+4>>2]-1|0}function xaa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;a:{f=kb-32|0;kb=f;a=Tb(a);b:{c:{d:{e:{while(1){e=v[b+8>>2];g=v[b>>2];v[23540]=0;e=W(156,g|0,e|0,8)|0;g=v[23540];v[23540]=0;if((g|0)==1){break c}if(e){v[23540]=0;U(866,f|0,b|0,c|0);e=v[23540];v[23540]=0;if((e|0)==1){break e}v[23540]=0;R(867,a|0,f|0);e=v[23540];v[23540]=0;if((e|0)==1){break d}Bd(f);e=$A(v[a+4>>2]);_h(f,v[e>>2],v[e+4>>2]);if(v[f>>2]!=(d|0)){continue}}break}kb=f+32|0;break a}b=P()|0;O()|0;break b}b=P()|0;O()|0;Bd(f);break b}b=P()|0;O()|0}Zd(a);T(b|0);L()}}function wda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;b=kb-16|0;kb=b;g=v[a+24>>2];h=v[a+20>>2];i=v[a+16>>2];e=v[a+4>>2];v[b+8>>2]=v[a>>2];v[b+12>>2]=e;j=v[a+8>>2];k=v[a+12>>2];while(1){if(d){e=(v[b+12>>2]<<1)+i|0;f=v[b+8>>2]>>>21&2040;e=(((B(u[e>>1],u[f+39778>>1])+B(u[e-2>>1],u[f+39776>>1])|0)+B(u[e+2>>1],u[f+39780>>1])|0)+B(u[e+4>>1],u[f+39782>>1])|0)/16384|0;v[c>>2]=v[c>>2]+B(e,h);v[c+4>>2]=v[c+4>>2]+B(e,g);Rb(b+8|0,j,k);c=c+8|0;d=d-1|0;continue}break}c=v[b+12>>2];v[a>>2]=v[b+8>>2];v[a+4>>2]=c;kb=b+16|0}function qL(a,b,c){a=a|0;b=b|0;c=C(c);var d=0,e=0,f=0;Ox(a);c=Yd(c,C(0));a:{switch(b|0){case 0:z[a+4220>>2]=c;return;case 1:z[a+4224>>2]=c;return;case 2:z[a+4228>>2]=c;Rs(a);return;case 3:t[a+4240|0]=c>=C(.5);Rs(a);return;case 4:b=kb-16|0;kb=b;e=b,f=Uh(C(c*C(32))),v[e+12>>2]=f;v[b+8>>2]=0;v[b+4>>2]=5;d=v[Jj(b+12|0,b+8|0,b+4|0)>>2];kb=b+16|0;v[a+4232>>2]=d;return;case 5:t[a+4241|0]=c>=C(.5);return;case 6:t[a+4242|0]=c>=C(.5);return;case 7:t[a+4244|0]=c>=C(.5);return;case 8:if(c==C(0)){Nx(a)}A[a+4256>>3]=c;break;default:break a}}}function Eaa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=kb-48|0;kb=d;c=d+24|0;Cj(c,b,1819307379);hd(a+40|0,c);Bb(c);Cj(c,b,1953721961);hd(a+60|0,c);Bb(c);Cj(c,b,543520099);hd(a+120|0,c);Bb(c);Cj(c,b,1414744396);v[23540]=0;c=Q(402,c|0,13788)|0;e=v[23540];v[23540]=0;a:{if((e|0)!=1){b:{if(c){v[23540]=0;U(770,d|0,d+24|0,2);c=v[23540];v[23540]=0;if((c|0)==1){break b}Tt(a+140|0,d);Zd(d)}v[23540]=0;U(771,d|0,b|0,1634890872);b=v[23540];v[23540]=0;if((b|0)!=1){break a}}}a=P()|0;O()|0;Bb(d+24|0);T(a|0);L()}hd(a+80|0,d);Bb(d);Bb(d+24|0);kb=d+48|0}function o$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;h=kb-416|0;kb=h;d=h+416|0;v[h+12>>2]=d;c=kb-144|0;kb=c;v[c+28>>2]=c+132;i=c+32|0;iG(v[a+8>>2],i,c+28|0,e,f,g);v[c+16>>2]=0;v[c+20>>2]=0;v[c+12>>2]=i;e=h+16|0;g=uc(e,v[h+12>>2]);f=kb-16|0;kb=f;i=ki(f+8|0,v[a+8>>2]);a=MG(e,c+12|0,g,c+16|0);ji(i);kb=f+16|0;if((a|0)==-1){Yr(12582);L()}v[h+12>>2]=(a<<2)+e;kb=c+144|0;c=v[h+12>>2];a=kb-16|0;kb=a;v[a+8>>2]=b;while(1){if((c|0)!=(e|0)){mH(a+8|0,v[e>>2]);e=e+4|0;continue}break}kb=a+16|0;kb=d;return v[a+8>>2]}function GW(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=kb-16|0;kb=c;v[c+12>>2]=v[v[a+1060>>2]>>2]-v[a+1064>>2];v[c+8>>2]=16384;d=v[Kb(c+12|0,c+8|0)>>2];v[a+1072>>2]=d;v[c+4>>2]=17;while(1){a:{if(!d){break a}e=v[c+4>>2];if((e|0)>17){break a}f=1<<e-1;d=Hk(a,e);b:{c:{d:{if((e|0)<=6){if((d|0)!=(f|0)){break d}er(c+4|0,Hk(a,4));break b}if(e>>>0>16){break c}e=f-8|0;if((e|0)>(d|0)|(d|0)>(f+7|0)){break d}er(c+4|0,d-e|0);break b}fD(a,d,f,b);break b}e=d&(f^-1);if(d&f){v[c+4>>2]=e+1;break b}fD(a,e,0,b)}d=v[a+1072>>2];continue}break}kb=c+16|0}function G5(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=kb-32|0;kb=c;e=Tb(a);a=b;b=0;a:{b:{c:{d:{e:{while(1){d=v[a+24>>2];if(x[d+480188>>1]<=b>>>0){break a}v[23540]=0;R(1002,c|0,(d+(b<<5)|0)+480289|0);d=v[23540];v[23540]=0;if((d|0)!=1){d=v[a+24>>2];v[23540]=0;U(1003,c+16|0,d|0,c|0);d=v[23540];v[23540]=0;if((d|0)==1){break e}v[23540]=0;R(183,e|0,c+16|0);d=v[23540];v[23540]=0;if((d|0)==1){break d}b=b+1|0;zb(c+16|0);zb(c);continue}break}b=P()|0;O()|0;break b}b=P()|0;O()|0;break c}b=P()|0;O()|0;zb(c+16|0)}zb(c)}Xe(e);T(b|0);L()}kb=c+32|0}function KM(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;e=kb-16|0;kb=e;v[e+12>>2]=16777216;h=e+12|0;d=v[a>>2];c=uc(d,v[a+4>>2]);a:{if(c>>>0<b>>>0){f=kb-32|0;kb=f;b=b-c|0;c=v[Gb(a)>>2];d=v[a+4>>2];b:{if(b>>>0<=c-d>>2>>>0){AC(a,b,h);break b}c=Gb(a);c=Vf(f+8|0,qg(a,uc(v[a>>2],d)+b|0),uc(v[a>>2],v[a+4>>2]),c);g=kb-16|0;kb=g;b=Xm(g,c+8|0,b);d=v[b>>2];while(1){if(v[b+4>>2]!=(d|0)){jq(d,v[h>>2]);d=v[b>>2]+4|0;v[b>>2]=d;continue}break}Ud(b);kb=g+16|0;Fd(a,c);Uf(c)}kb=f+32|0;break a}if(b>>>0<c>>>0){Od(a,d+(b<<2)|0)}}vy(a);kb=e+16|0}function Gy(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0;d=kb-16|0;kb=d;g=it(a,a+1074376|0,b,c);a:{if(!g){break a}h=a+1074312|0;Db(d+8|0,h,117);if(Cb(v[v[d+8>>2]>>2],v[d+12>>2])){break a}e=B(b,872)+a|0;i=e+1075648|0;c=v[i>>2];if(!c|!w[c+33|0]){break a}f=a;a=e+1074992|0;e=Sp(f,v[a+88>>2],c);if(!e){break a}Db(d+8|0,h,34);f=!Cb(v[v[d+8>>2]>>2],v[d+12>>2]);c=tg(w[a+797|0]-u[a+770>>1]|0);b:{if(f|(c<<24)-16777216>>24<0){break b}a=v[a+656>>2];if(!a){break b}c=w[Lb(a+108|0,c-1|0)|0]}ob[v[v[e>>2]+88>>2]](e,g,c&255,t[v[i>>2]+33|0],b)}kb=d+16|0}function FW(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=kb-16|0;kb=c;v[c+12>>2]=v[v[a+1060>>2]>>2]-v[a+1064>>2];v[c+8>>2]=32768;d=v[Kb(c+12|0,c+8|0)>>2];v[a+1072>>2]=d;v[c+4>>2]=9;while(1){a:{if(!d){break a}e=v[c+4>>2];if((e|0)>9){break a}f=1<<e-1;d=Hk(a,e);b:{c:{d:{if((e|0)<=6){if((d|0)!=(f|0)){break d}er(c+4|0,Hk(a,3));break b}if(e>>>0>8){break c}e=f-4|0;if((e|0)>(d|0)|(d|0)>(f+3|0)){break d}er(c+4|0,d-e|0);break b}eD(a,d,f,b);break b}e=d&(f^-1);if(d&f){v[c+4>>2]=e+1;break b}eD(a,e,0,b)}d=v[a+1072>>2];continue}break}kb=c+16|0}function kja(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;a:{d=kb-32|0;kb=d;a=Tb(a);b:{c:{d:{e:{while(1){c=v[b+8>>2];e=v[b>>2];v[23540]=0;c=W(156,e|0,c|0,8)|0;e=v[23540];v[23540]=0;if((e|0)==1){break c}if(c){v[23540]=0;R(398,d|0,b|0);c=v[23540];v[23540]=0;if((c|0)==1){break e}v[23540]=0;R(399,a|0,d|0);c=v[23540];v[23540]=0;if((c|0)==1){break d}Bd(d);c=$A(v[a+4>>2]);_h(d,v[c>>2],v[c+4>>2]);if((bc(v[d>>2])|0)!=1162757187){continue}}break}kb=d+32|0;break a}b=P()|0;O()|0;break b}b=P()|0;O()|0;Bd(d);break b}b=P()|0;O()|0}Zd(a);T(b|0);L()}}function xda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;b=kb-16|0;kb=b;g=v[a+24>>2];h=v[a+20>>2];i=v[a+16>>2];e=v[a+4>>2];v[b+8>>2]=v[a>>2];v[b+12>>2]=e;j=v[a+8>>2];k=v[a+12>>2];while(1){if(d){e=v[b+12>>2]+i|0;f=v[b+8>>2]>>>21&2040;e=(((B(t[e|0],u[f+39778>>1])+B(t[e-1|0],u[f+39776>>1])|0)+B(t[e+1|0],u[f+39780>>1])|0)+B(t[e+2|0],u[f+39782>>1])<<8)/16384|0;v[c>>2]=v[c>>2]+B(e,h);v[c+4>>2]=v[c+4>>2]+B(e,g);Rb(b+8|0,j,k);c=c+8|0;d=d-1|0;continue}break}c=v[b+12>>2];v[a>>2]=v[b+8>>2];v[a+4>>2]=c;kb=b+16|0}function cka(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;nd(b,0);g=w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24);v[b>>2]=g;e=w[a+4|0]|w[a+5|0]<<8|(w[a+6|0]<<16|w[a+7|0]<<24);v[b+12>>2]=e;f=w[a+8|0]|w[a+9|0]<<8|(w[a+10|0]<<16|w[a+11|0]<<24);v[b+16>>2]=f;c=w[a+12|0]|w[a+13|0]<<8;u[b+32>>1]=64;v[b+24>>2]=c;c=w[a+14|0];u[b+30>>1]=c?c+1|0:256;d=x[b+34>>1]&32767|!w[a+14|0]<<15;u[b+34>>1]=d;c=w[a+15|0];if(!(!(c&1)|e>>>0>=f>>>0)){d=d|8;u[b+34>>1]=d;c=w[a+15|0]}if(c&2){v[b+16>>2]=f>>>1;v[b+12>>2]=e>>>1;v[b>>2]=g>>>1;u[b+34>>1]=d|1}}function _fa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=kb-80|0;kb=c;d=zf(c+48|0);v[23540]=0;e=Q(624,b|0,d|0)|0;f=v[23540];v[23540]=0;a:{b:{c:{d:{if((f|0)!=1){if(e){break d}v[a>>2]=0;v[a+4>>2]=0;v[a+24>>2]=0;v[a+16>>2]=0;v[a+20>>2]=0;v[a+8>>2]=0;v[a+12>>2]=0;v[23540]=0;S(625,a|0)|0;a=v[23540];v[23540]=0;if((a|0)!=1){break a}}break c}e=v[d+4>>2];v[23540]=0;U(190,c|0,b|0,(e>>>0<9?0:e-8|0)|0);b=v[23540];v[23540]=0;if((b|0)!=1){break b}}a=P()|0;O()|0;Bd(d);T(a|0);L()}b=kc(c+24|0,c);hd(d+8|0,b);Bb(b);Bb(c);xk(a,d)}Bd(d);kb=c+80|0}function V4(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=C(0);v[23540]=0;Y(946,a|0);d=v[23540];v[23540]=0;a:{if((d|0)==1){break a}v[23540]=0;Y(1018,c|0);d=v[23540];v[23540]=0;if((d|0)==1){break a}d=v[a+24>>2];e=z[d+48>>2];d=v[d+24>>2];v[23540]=0;b=_a(1019,d|0,C(e),b|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break a}v[c>>2]=b;return 1}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,10372,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)!=1){$();return 0}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function Ti(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0;f=kb-16|0;kb=f;o(+b);g=j(1)|0;d=j(0)|0;c=g&2147483647;e=c+-1048576|0;a:{if((e|0)==2145386495|e>>>0<2145386495){h=d<<28;e=c>>>4|0;c=(c&15)<<28|d>>>4;d=e+1006632960|0;break a}if((c|0)==2146435072|c>>>0>2146435072){h=d<<28;c=(g&15)<<28|d>>>4;d=g>>>4|2147418112;break a}if(!(c|d)){c=0;d=0;break a}e=c;c=c?E(c):E(d)+32|0;Kf(f,d,e,0,0,c+49|0);i=v[f>>2];h=v[f+4>>2];e=15372-c<<16;c=v[f+8>>2];d=e|v[f+12>>2]^65536}v[a>>2]=i;v[a+4>>2]=h;v[a+8>>2]=c;v[a+12>>2]=g&-2147483648|d;kb=f+16|0}function vba(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=kb-16|0;kb=e;f=Nb(a);a=0;a:{b:{c:{d:{while(1){d=v[b>>2];if(yd(d,v[b+4>>2])>>>0<=a>>>0){break c}e:{if(!a){d=Nd(d,0);break e}v[23540]=0;Q(800,f|0,c|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break b}d=Nd(v[b>>2],a)}v[23540]=0;R(801,e|0,d|0);d=v[23540];v[23540]=0;if((d|0)!=1){v[23540]=0;Q(800,f|0,e|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break d}a=a+1|0;zb(e);continue}break}a=P()|0;O()|0;break a}a=P()|0;O()|0;zb(e);break a}kb=e+16|0;return}a=P()|0;O()|0}zb(f);T(a|0);L()}function uha(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=kb-80|0;kb=c;d=zf(c+48|0);v[23540]=0;e=Q(507,b|0,d|0)|0;f=v[23540];v[23540]=0;a:{b:{c:{d:{if((f|0)!=1){if(e){break d}v[a>>2]=0;v[a+4>>2]=0;v[a+24>>2]=0;v[a+16>>2]=0;v[a+20>>2]=0;v[a+8>>2]=0;v[a+12>>2]=0;v[23540]=0;S(508,a|0)|0;a=v[23540];v[23540]=0;if((a|0)!=1){break a}}break c}e=x[d+2>>1]|x[d+4>>1]<<16;v[23540]=0;U(190,c|0,b|0,e|0);b=v[23540];v[23540]=0;if((b|0)!=1){break b}}a=P()|0;O()|0;Bd(d);T(a|0);L()}b=kc(c+24|0,c);hd(d+8|0,b);Bb(b);Bb(c);LS(a,d)}Bd(d);kb=c+80|0}function lW(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;d=kb-32|0;kb=d;nd(b,0);$h(d,1,a+33|0);e=d+16|0;Fc(e,d);Be(b+43|0,e);zb(e);f=w[a+50|0]|w[a+51|0]<<8|(w[a+52|0]<<16|w[a+53|0]<<24);v[b>>2]=f;v[b+24>>2]=w[a+54|0]|w[a+55|0]<<8;t[d+16|0]=w[a+56|0];t[d|0]=64;h=b,i=w[Yb(e,d)|0]<<2,u[h+30>>1]=i;e=w[a+57|0]|w[a+58|0]<<8|(w[a+59|0]<<16|w[a+60|0]<<24);v[b+4>>2]=e;g=w[a+61|0]|w[a+62|0]<<8|(w[a+63|0]<<16|w[a+64|0]<<24);c=c?e?f:g:g;v[b+8>>2]=c;if(!(!w[a|0]|c>>>0<=e+2>>>0|c>>>0>f>>>0)){u[b+34>>1]=x[b+34>>1]|2}kb=d+32|0}function py(a,b,c){var d=0,e=0;e=kb-16|0;kb=e;Db(e+8|0,a+1074312|0,21);a:{if(Cb(v[v[e+8>>2]>>2],v[e+12>>2])){c=c&255;b:{switch((b&3)-1|0){default:d=t[c+33504|0];break a;case 0:d=64-(c+1>>>1|0)|0;break a;case 1:d=(c>>>0<128)<<6;break a;case 2:break b}}d=rM(Vn(a))+-64|0;break a}d=t[(c>>>1&31)+32192|0];if(x[a+480182>>1]&1032){break a}a=c&63;c:{switch((b&3)-1|0){default:d=t[a+33376|0];break a;case 0:d=(a>>>0<32?0:255)-(a<<2)|0;break a;case 1:d=a>>>0<32?127:-127;break a;case 2:break c}}d=t[a+33440|0]}a=d;kb=e+16|0;return a}function PQ(a,b,c,d,e,f){b=w[(b&15)+27088|0];t[a+3|0]=b;a:{b:{switch(b-11|0){case 0:b=w[a+5|0];c=b&15;if(c){t[a+5|0]=c;return}t[a+5|0]=b&240;return;case 3:b=w[a+5|0];b=B(b&240,10)|b&15;t[a+5|0]=b;d=b&255;b=x[e>>1];if(!(d|(b|0)==65535)){t[a+5|0]=b;t[a+3|0]=12;u[e>>1]=65535}xc(f,c);return;case 1:u[e>>1]=w[a+5|0];v[f>>2]=63;t[a+3|0]=0;return;case 5:b=w[a+5|0];if(d>>>0<=20){c=((b&255)>>>0)/10|0;b=c<<4|B(c,-10)+b;t[a+5|0]=b}if(b&255){break a}t[a+3|0]=0;return;case 7:break a;default:break b}}if(w[a+5|0]){break a}t[a+3|0]=0}}function Cga(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;f=kb-608|0;kb=f;b=kb-16|0;kb=b;d=f+8|0;XR(b+8|0,d);c=v[b+12>>2];md(b,a,v[b+8>>2],v[b+12>>2]);e=v[b+4>>2];if((e|0)==(c|0)){id(a,v[b+12>>2])}kb=b+16|0;c=(c|0)==(e|0);if(!c){WR(d)}b=-1;a:{if(!c){break a}b=0;if(!YR(f+8|0)){break a}b=-1;if(!fg(a,1024)){break a}b=0;d=kb-1024|0;kb=d;c=kb-16|0;kb=c;iA(c+8|0,d);e=v[c+12>>2];md(c,a,v[c+8>>2],v[c+12>>2]);g=v[c+4>>2];if((e|0)==(g|0)){id(a,v[c+12>>2])}kb=c+16|0;if((e|0)==(g|0)){b=jA(d,0)>>>0<17}kb=d+1024|0}kb=f+608|0;return b|0}function Gba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;if(v[a+4>>2]!=v[Gb(a)>>2]){c=kb-16|0;kb=c;v[c>>2]=a;a=v[a+4>>2];v[c+4>>2]=a;v[c+8>>2]=a+7;jO(v[c+4>>2],b);v[c+4>>2]=v[c+4>>2]+7;lc(c);kb=c+16|0;return}f=kb-32|0;kb=f;g=Gb(a);h=f+8|0;d=ez(v[a>>2],v[a+4>>2])+1|0;c=kb-16|0;kb=c;v[c+12>>2]=d;a:{e=th(613566756);if(d>>>0<=e>>>0){d=fz(a);if(d>>>0<e>>>1>>>0){v[c+8>>2]=d<<1;e=v[_c(c+8|0,c+12|0)>>2]}kb=c+16|0;break a}cd();L()}c=mO(h,e,ez(v[a>>2],v[a+4>>2]),g);jO(v[c+8>>2],b);v[c+8>>2]=v[c+8>>2]+7;lO(a,c);kO(c);kb=f+32|0}function V6(a){a=a|0;var b=0,c=0,d=0;b=kb-32|0;kb=b;a:{b:{if(!a){a=gg(21688);break b}v[23540]=0;c=Q(55,b|0,a|0)|0;a=v[23540];v[23540]=0;c:{d:{if((a|0)!=1){v[23540]=0;R(932,b+16|0,c|0);a=v[23540];v[23540]=0;if((a|0)==1){break d}d=b+16|0;a=gg(Mc(d));zb(d);zb(c);break b}a=V(0)|0;O()|0;break c}a=V(0)|0;O()|0;zb(c)}_(a|0)|0;a=0;v[23540]=0;X(933,11005,0,0,0);c=v[23540];v[23540]=0;if((c|0)==1){break a}$()}kb=b+32|0;return a|0}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function DX(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=kb-16|0;kb=e;f=Nb(a);a=0;a:{b:{c:{d:{while(1){d=v[b>>2];if(yd(d,v[b+4>>2])>>>0<=a>>>0){break c}e:{if(!a){d=Nd(d,0);break e}v[23540]=0;Q(98,f|0,c|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break b}d=Nd(v[b>>2],a)}v[23540]=0;R(153,e|0,d|0);d=v[23540];v[23540]=0;if((d|0)!=1){v[23540]=0;Q(98,f|0,e|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break d}a=a+1|0;Ab(e);continue}break}a=P()|0;O()|0;break a}a=P()|0;O()|0;Ab(e);break a}kb=e+16|0;return}a=P()|0;O()|0}Ab(f);T(a|0);L()}function mu(a){var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;g=kb-16|0;kb=g;v[g+12>>2]=0;v[g+8>>2]=a;i=kb-16|0;kb=i;b=hc(i+8|0,v[g+8>>2],v[g+12>>2]);e=kb-16|0;kb=e;d=118;v[e+12>>2]=118;c=v[b+4>>2];a:{if(!c){c=v[b>>2];break a}f=32-c|0;v[e+8>>2]=f;d=v[b>>2];j=v[d>>2];h=f;f=v[Kb(e+8|0,e+12|0)>>2];v[d>>2]=(-1<<c&-1>>>h-f^-1)&j;j=v[e+12>>2];c=d+4|0;v[b>>2]=c;d=j-f|0}h=c;c=d>>>5<<2;Ub(h,0,c);f=d&31;v[e+12>>2]=f;if((d&-32)!=(d|0)){h=b;b=c+v[b>>2]|0;v[h>>2]=b;v[b>>2]=v[b>>2]&(-1>>>32-f^-1)}kb=e+16|0;kb=i+16|0;kb=g+16|0;return a}function Mfa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;a:{d=kb-32|0;kb=d;a=Tb(a);b:{c:{d:{e:{while(1){c=v[b+8>>2];e=v[b>>2];v[23540]=0;c=W(156,e|0,c|0,8)|0;e=v[23540];v[23540]=0;if((e|0)==1){break c}if(c){v[23540]=0;R(653,d|0,b|0);c=v[23540];v[23540]=0;if((c|0)==1){break e}v[23540]=0;R(654,a|0,d|0);c=v[23540];v[23540]=0;if((c|0)==1){break d}Bd(d);c=$A(v[a+4>>2]);_h(d,v[c>>2],v[c+4>>2]);if(v[d>>2]!=1413891155){continue}}break}kb=d+32|0;break a}b=P()|0;O()|0;break b}b=P()|0;O()|0;Bd(d);break b}b=P()|0;O()|0}Zd(a);T(b|0);L()}}function f7(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;t[a+4202|0]=1;c=wj(C(C(y[v[a+16>>2]+24620>>2])*C(.04500000178813934)));d=wj(C(C(c>>>0)*C(1.1892070770263672)));e=wj(C(C(d>>>0)*C(1.1892070770263672)));h=wj(C(C(e>>>0)*C(1.1892070770263672)));f=wj(C(C(c+e>>>0)*C(.11546666920185089)));g=wj(C(C(d+h>>>0)*C(.11546666920185089)));b=a+4272|0;i=Eb(b,0),j=c-f|0,v[i>>2]=j;i=Eb(b,1),j=e-f|0,v[i>>2]=j;i=Eb(b,2),j=d-g|0,v[i>>2]=j;i=Eb(b,3),j=h-g|0,v[i>>2]=j;i=Eb(b,4),j=f,v[i>>2]=j;i=Eb(b,5),j=g,v[i>>2]=j;DK(a);CK(a)}function aaa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;f=kb-16|0;kb=f;v[f+12>>2]=b;a:{if(at(a)>>>0>=b>>>0){e=v[a>>2];g=yk(e,v[a+4>>2]);v[f+8>>2]=g;d=v[Kb(f+12|0,f+8|0)>>2];while(1){if(d){d=d-1|0;e=XL(e,c)+52|0;continue}break}if(b>>>0>g>>>0){_x(a,b-g|0,c);break a}VL(a,v[a>>2]+B(b,52)|0);break a}if(v[a>>2]){bt(a);d=v[a>>2];at(a);Mb(d);h=Gb(a),i=0,v[h>>2]=i;v[a>>2]=0;v[a+4>>2]=0}d=UL(a,b);if(th(82595524)>>>0<d>>>0){cd();L()}e=TL(d);v[a>>2]=e;v[a+4>>2]=e;h=Gb(a),i=e+B(d,52)|0,v[h>>2]=i;_x(a,b,c)}kb=f+16|0}function Naa(a){a=a|0;var b=0,c=0;b=32288;a=Tb(a);a:{b:{while(1){c:{if((b|0)==32688){b=32688;break c}d:{c=v[a+4>>2];if(!pc(v[a>>2],c)){if(!yi(v[b+4>>2],v[Bj(c)>>2])){break d}}v[23540]=0;R(844,a|0,b+4|0);c=v[23540];v[23540]=0;if((c|0)!=1){break d}break b}b=b+8|0;continue}break}while(1){if((b|0)==32736){break a}e:{c=v[a+4>>2];f:{if(!pc(v[a>>2],c)){if(!yi(v[b+8>>2],v[Bj(c)>>2])){break f}}v[23540]=0;R(844,a|0,b+8|0);c=v[23540];v[23540]=0;if((c|0)==1){break e}}b=b+12|0;continue}break}}b=P()|0;O()|0;wc(a);T(b|0);L()}}function SJ(a,b){var c=0,d=0;c=v[a>>2];v[a>>2]=b;if(c){v[23540]=0;Y(813,c|0);a=v[23540];v[23540]=0;a:{if((a|0)!=1){a=v[c+4>>2];if(a){if(v[a>>2]){d=v[a>>2];b=v[a+4>>2];while(1){if((b|0)!=(d|0)){b=b-4|0;sg(b);continue}break}v[a+4>>2]=d;b=v[a>>2];Wh(a);Mb(b)}Mb(a)}v[c+4>>2]=0;aN(c+1298408|0);Dy(c+1298344|0);zb(c+1298332|0);Ab(c+1298320|0);zb(c+1298308|0);Cy(c+1298304|0);By(c+1298300|0);kt(c+1298264|0);Py(c+1074376|0);$M(c+906300|0);Bz(c+484360|0);TM(c+484344|0);wc(c+480248|0);break a}V(0)|0;O()|0;Vb();L()}Mb(c)}}function Vba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;c=kb-48|0;kb=c;f=OO(a,1<<b-1);v[f+12>>2]=b;b=1<<b;h=-6.283185307179586/+(b>>>0);a=1;g=b>>>2|0;b=g;while(1){if(b){e=v[10481];d=c+16|0;v[d+8>>2]=v[10480];v[d+12>>2]=e;e=v[10479];v[d>>2]=v[10478];v[d+4>>2]=e;oz(d,h*+(b>>>0));JO(c+32|0,A[c+16>>3],A[c+24>>3]);d=Kd(v[f>>2],a);e=v[c+44>>2];v[d+8>>2]=v[c+40>>2];v[d+12>>2]=e;e=v[c+36>>2];v[d>>2]=v[c+32>>2];v[d+4>>2]=e;b=b>>>1|0;a=a<<1;continue}break}a=nl(c,1,0);ey(f,0,g,A[a>>3],A[a+8>>3]);kb=c+48|0;return f|0}function Tha(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if(v[a+4>>2]!=v[Gb(a)>>2]){c=kb-16|0;kb=c;a=Sv(c,a);d=v[a+4>>2];v[23540]=0;R(488,d|0,b|0);b=v[23540];v[23540]=0;a:{if((b|0)!=1){v[a+4>>2]=v[a+4>>2]+12;lc(a);kb=c+16|0;break a}b=P()|0;O()|0;lc(a);T(b|0);L()}return}d=kb-32|0;kb=d;c=Gb(a);c=Ik(d+8|0,ln(a,yd(v[a>>2],v[a+4>>2])+1|0),yd(v[a>>2],v[a+4>>2]),c);e=v[c+8>>2];v[23540]=0;R(488,e|0,b|0);b=v[23540];v[23540]=0;b:{if((b|0)!=1){v[c+8>>2]=v[c+8>>2]+12;zr(a,c);Rv(c);kb=d+32|0;break b}a=P()|0;O()|0;Rv(c);T(a|0);L()}}function pP(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=b?33:32;c=w[a+16|0];k=c?-1:1;l=c?1:-1;e=v[a+8>>2]-1|0;m=c?e-(w[a+17|0]!=0&(e|0)!=0)|0:0;f=v[a+12>>2];n=(f|0)>0?f:0;o=c?0:e;h=v[a>>2]+B(f,62)|0;d=b?1:-1;p=B(f,d)<<1;c=e;a:while(1){if((i|0)!=(j|0)){g=B(c,f);q=v[a+4>>2];b=0;while(1)if((b|0)==(n|0)){b:{if((c|0)==(e|0)){b=m;g=k;if((d|0)>0){break b}}b=c+d|0;c=!c&(d|0)<0;b=c?o:b;g=c?l:d}h=h+p|0;i=i+1|0;c=b;d=g;continue a}else{u[(b<<1)+h>>1]=x[q+(b+g<<1)>>1];b=b+1|0;continue}}break}}function eN(a,b,c){var d=0,e=0,f=0,g=0;d=kb-16|0;kb=d;a:{if(b){t[c|0]=b;break a}b=w[c|0]}e=v[a+480180>>2];b=e&1048580?(b&240?-16:15)&b:b;c=b&240;f=b&255;b=b&15;b:{c:{d:{if(!(!c|(b|0)!=15)){if(!(w[a+480209|0]&16)){break b}b=f>>>3&30;break d}g=v[a+480208>>2]&4096;if(!(!b|(c|0)!=240)){if(!g){break b}b=0-(b<<1)|0;break c}if(g){break b}if(c){if(b?e&59314208:0){break b}b=f>>>3&30;break d}b=0-(b<<1)|0}if(!b){break b}}a=a+1074456|0;v[d+12>>2]=v[a>>2]+(b<<!(e&59314208));oe(d+12|0,0,256);v[a>>2]=v[d+12>>2]}kb=d+16|0}function JY(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;if(Zg(a,v[b+8>>2],e)){mw(b,c,d);return}a:{if(Zg(a,v[b>>2],e)){if(!(v[b+16>>2]!=(c|0)&v[b+20>>2]!=(c|0))){if((d|0)!=1){break a}v[b+32>>2]=1;return}v[b+32>>2]=d;b:{if(v[b+44>>2]==4){break b}u[b+52>>1]=0;a=v[a+8>>2];ob[v[v[a>>2]+20>>2]](a,b,c,c,1,e);if(w[b+53|0]){v[b+44>>2]=3;if(!w[b+52|0]){break b}break a}v[b+44>>2]=4}v[b+20>>2]=c;v[b+40>>2]=v[b+40>>2]+1;if(v[b+36>>2]!=1|v[b+24>>2]!=2){break a}t[b+54|0]=1;return}a=v[a+8>>2];ob[v[v[a>>2]+24>>2]](a,b,c,d,e)}}function FI(a,b){a=a|0;b=b|0;var c=0,d=0;d=kb-16|0;kb=d;a:{b:{c:{a=v[a+32>>2];c=Gs(a);d:{if(!c){if(Fs(a)>>>0<=b>>>0){break d}c=(w[Hi(a,b+1&65535)+35|0]&4)>>>2|0;break b}if(b>>>0<c>>>0){break c}}a=ba(8)|0;v[23540]=0;b=Q(55,d|0,6003)|0;c=v[23540];v[23540]=0;e:{if((c|0)!=1){a=tc(a,b);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break a}c=P()|0;O()|0;zb(b);break e}c=P()|0;O()|0;ca(a|0)}T(c|0);L()}a=v[(a+(b<<2)|0)+900384>>2];c=1;if(!a){break b}c=(w[a+15|0]&2)>>>1|0}kb=d+16|0;return c|0}L()}function EG(a,b,c,d){var e=0,f=0,g=0;f=kb-16|0;kb=f;a:{b:{if((a|0)!=(b|0)){c:{g=v[116016];v[116016]=0;Gd();d=KG(a,f+12|0,d);e=nb;d:{a=v[116016];if(a){if(v[f+12>>2]!=(b|0)){break c}if((a|0)!=68){break d}v[c>>2]=4;a=2147483647;if(!!d&(e|0)>=0|(e|0)>0){break a}break b}v[116016]=g;if(v[f+12>>2]==(b|0)){break d}break c}if((e|0)<0&d>>>0<=2147483647|(e|0)<-1){v[c>>2]=4;break b}if((e|0)>=0&d>>>0>=2147483648|(e|0)>0){v[c>>2]=4;a=2147483647;break a}a=d;break a}}v[c>>2]=4;a=0;break a}a=-2147483648}kb=f+16|0;return a}function E5(a){a=a|0;var b=0,c=0,d=0,e=0;c=kb-32|0;kb=c;e=Tb(a);Xd(c+24|0);a=0;b=v[c+28>>2];d=v[c+24>>2];v[23540]=0;R(181,e|0,XI(d,b)|0);b=v[23540];v[23540]=0;a:{if((b|0)!=1){b:{while(1){b=v[c+24>>2];if((XI(b,v[c+28>>2])|0)<=(a|0)){kb=c+32|0;return}b=v[b+(a<<3)>>2];v[23540]=0;b=Q(55,c+8|0,b|0)|0;d=v[23540];v[23540]=0;if((d|0)!=1){v[23540]=0;R(183,e|0,b|0);d=v[23540];v[23540]=0;if((d|0)==1){break b}zb(b);a=a+1|0;continue}break}a=P()|0;O()|0;break a}a=P()|0;O()|0;zb(b);break a}a=P()|0;O()|0}Xe(e);T(a|0);L()}function Cfa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=kb-80|0;kb=c;d=zf(c+48|0);v[23540]=0;e=Q(659,b|0,d|0)|0;f=v[23540];v[23540]=0;a:{b:{c:{d:{if((f|0)!=1){if(e){break d}v[a>>2]=0;v[a+4>>2]=0;v[a+24>>2]=0;v[a+16>>2]=0;v[a+20>>2]=0;v[a+8>>2]=0;v[a+12>>2]=0;v[23540]=0;S(660,a|0)|0;a=v[23540];v[23540]=0;if((a|0)!=1){break a}}break c}e=v[d+4>>2];v[23540]=0;U(190,c|0,b|0,e|0);b=v[23540];v[23540]=0;if((b|0)!=1){break b}}a=P()|0;O()|0;Bd(d);T(a|0);L()}b=kc(c+24|0,c);hd(d+8|0,b);Bb(b);Bb(c);xk(a,d)}Bd(d);kb=c+80|0}function mga(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=kb-16|0;kb=c;gc(c+8|0,b,26);d=v[c+12>>2];nc(c,v[a>>2],v[a+8>>2],v[c+8>>2],v[c+12>>2]);e=v[c+4>>2];if((e|0)==(d|0)){$b(a,v[c+12>>2])}kb=c+16|0;if((d|0)!=(e|0)){t[b|0]=0;t[b+1|0]=0;t[b+2|0]=0;t[b+3|0]=0;t[b+4|0]=0;t[b+5|0]=0;t[b+6|0]=0;t[b+7|0]=0;t[b+24|0]=0;t[b+25|0]=0;t[b+16|0]=0;t[b+17|0]=0;t[b+18|0]=0;t[b+19|0]=0;t[b+20|0]=0;t[b+21|0]=0;t[b+22|0]=0;t[b+23|0]=0;t[b+8|0]=0;t[b+9|0]=0;t[b+10|0]=0;t[b+11|0]=0;t[b+12|0]=0;t[b+13|0]=0;t[b+14|0]=0;t[b+15|0]=0}}function AI(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0;d=kb-32|0;kb=d;A[d+24>>3]=c;a:{b:{c:{if(b>>>0>=256){b=ba(8)|0;v[23540]=0;d=Q(55,d+8|0,10725)|0;a=v[23540];v[23540]=0;if((a|0)==1){break c}a=tc(b,d);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break a}a=P()|0;O()|0;zb(d);break b}a=v[a+32>>2];v[d+8>>2]=0;v[d+12>>2]=-1074790400;v[d>>2]=0;v[d+4>>2]=1072693248;e=(a+B(b,872)|0)+1075684|0,f=xl(A[Gg(d+24|0,d+8|0,d)>>3]*128+128),v[e>>2]=f;kb=d+32|0;return}a=P()|0;O()|0;ca(b|0)}T(a|0)}L()}function aD(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0;d=w[a+8|0];h=v[a>>2];e=v[a+4>>2];f=Mc(b);a=Hb(b);b=kb-16|0;kb=b;v[b+8>>2]=a;v[b+12>>2]=e;a=h;g=v[Kb(b+12|0,b+8|0)>>2];c=g;while(1){a:{if(!c){c=0;break a}i=w[f|0];t[a|0]=i;if(!i){break a}f=f+1|0;a=a+1|0;c=c-1|0;continue}break}b:{if((d-1&255)>>>0<=1){t[b+7|0]=0;om(a,((a+e|0)-g|0)+c|0,b+7|0);break b}if((d-3&255)>>>0>1){break b}t[b+6|0]=32;om(a,((a+e|0)-g|0)+c|0,b+6|0)}c:{switch(d-1|0){case 0:case 3:t[(v[b+12>>2]+h|0)-1|0]=0;break;default:break c}}kb=b+16|0}function P9(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=C(0);e=kb-16|0;kb=e;f=rf(a,c);me(e,v[a+36>>2]);h=a;a:{if(!f){Sc(e,a+32|0,5);c=0;if(Cb(v[v[e>>2]>>2],v[e+4>>2])){break a}}c=0;d=kb-32|0;kb=d;g=v[a+36>>2];Jk(g,d+24|0);i=d,j=Ec(v[d+24>>2],v[d+28>>2]),v[i+16>>2]=j;v[d+12>>2]=256;ek(b,v[Kb(d+16|0,d+12|0)>>2]);a=v[b>>2];while(1){if(uc(a,v[b+4>>2])>>>0<=c>>>0){kb=d+32|0}else{v[d+16>>2]=0;Hp(g,d+16|0);a=v[b>>2];i=Eb(a,c),k=z[d+16>>2],z[i>>2]=k;c=c+1|0;continue}break}c=f}Ye(h,c);kb=e+16|0}function b$(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;h=kb-16|0;kb=h;d=Hb(a);e=vn(a);g=$d(b,c);a:{if(!g){break a}b:{f=Ac(a);if(f>>>0<=b>>>0){f=(Hb(a)<<2)+f>>>0>=b>>>0}else{f=0}if(!f){if(e-d>>>0<g>>>0){$F(a,e,(d+g|0)-e|0,d,d)}e=Ac(a)+(d<<2)|0;while(1){if((b|0)==(c|0)){break b}wd(e,v[b>>2]);b=b+4|0;e=e+4|0;continue}}b=JG(h,b,c);c=Ac(b);d=Hb(b);v[23540]=0;W(1168,a|0,c|0,d|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){Nc(b);break a}a=P()|0;O()|0;Nc(b);T(a|0);L()}wd(e,0);Sh(a,d+g|0)}kb=h+16|0;return a|0}function Oq(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;if((a|0)!=(b|0)){if(!ef(a)){if(!ef(b)){c=v[b+4>>2];v[a>>2]=v[b>>2];v[a+4>>2]=c;v[a+8>>2]=v[b+8>>2];return}d=Mc(b);b=Hb(b);c=kb-16|0;kb=c;a:{if(b>>>0<=10){ie(a,b);a=He(a,d,b);t[c+15|0]=0;we(a+b|0,c+15|0);break a}f=a;a=w[a+11|0];kp(f,10,b-10|0,a,0,a,b,d)}kb=c+16|0;return}d=Mc(b);b=Hb(b);c=kb-16|0;kb=c;e=Il(a);b:{if(e>>>0>b>>>0){e=v[a>>2];Hd(a,b);a=He(e,d,b);t[c+15|0]=0;we(a+b|0,c+15|0);break b}f=a;a=v[a+4>>2];kp(f,e-1|0,(b-e|0)+1|0,a,0,a,b,d)}kb=c+16|0}}function Zja(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=kb-32|0;kb=c;nd(b,0);$h(c,1,a);d=c+16|0;Fc(d,c);Be(b+43|0,d);zb(d);v[b+24>>2]=w[a+32|0]|w[a+33|0]<<8|(w[a+34|0]<<16|w[a+35|0]<<24);u[b+34>>1]=x[b+34>>1]&65533|(w[a+13|0]|w[a+14|0]<<8)<<1&2;v[b>>2]=w[a+16|0]|w[a+17|0]<<8|(w[a+18|0]<<16|w[a+19|0]<<24);v[b+4>>2]=w[a+20|0]|w[a+21|0]<<8|(w[a+22|0]<<16|w[a+23|0]<<24);v[b+8>>2]=w[a+24|0]|w[a+25|0]<<8|(w[a+26|0]<<16|w[a+27|0]<<24);t[c+16|0]=w[a+15|0];t[c|0]=64;e=b,f=w[Yb(d,c)|0]<<2,u[e+30>>1]=f;kb=c+32|0}function ME(a,b,c,d){var e=0,f=0,g=0;e=kb-80|0;kb=e;f=zf(e+48|0);v[23540]=0;d=Q(d|0,b|0,f|0)|0;g=v[23540];v[23540]=0;a:{b:{c:{d:{if((g|0)!=1){if(d){break d}v[a>>2]=0;v[a+4>>2]=0;v[a+24>>2]=0;v[a+16>>2]=0;v[a+20>>2]=0;v[a+8>>2]=0;v[a+12>>2]=0;v[23540]=0;S(c|0,a|0)|0;a=v[23540];v[23540]=0;if((a|0)!=1){break a}}break c}c=v[f+4>>2];v[23540]=0;U(190,e|0,b|0,bc(c)|0);b=v[23540];v[23540]=0;if((b|0)!=1){break b}}a=P()|0;O()|0;Bd(f);T(a|0);L()}b=kc(e+24|0,e);hd(f+8|0,b);Bb(b);Bb(e);xk(a,f)}Bd(f);kb=e+80|0}function Em(a,b,c,d,e,f){var g=0,h=0,i=0,j=0;a:{if(f&64){c=f+-64|0;b=c&31;if((c&63)>>>0>=32){c=0;b=e>>>b|0}else{c=e>>>b|0;b=((1<<b)-1&e)<<32-b|d>>>b}d=0;e=0;break a}if(!f){break a}i=d;h=64-f|0;g=h&31;if((h&63)>>>0>=32){h=i<<g;j=0}else{h=(1<<g)-1&i>>>32-g|e<<g;j=i<<g}i=b;b=f&31;if((f&63)>>>0>=32){g=0;b=c>>>b|0}else{g=c>>>b|0;b=((1<<b)-1&c)<<32-b|i>>>b}b=j|b;c=g|h;g=d;d=f&31;if((f&63)>>>0>=32){h=0;d=e>>>d|0}else{h=e>>>d|0;d=((1<<d)-1&e)<<32-d|g>>>d}e=h}v[a>>2]=b;v[a+4>>2]=c;v[a+8>>2]=d;v[a+12>>2]=e}function fka(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;v[a>>2]=0;v[a+4>>2]=0;Gc(a+8|0);if(b){if(th(715827882)>>>0<b>>>0){cd();L()}d=B(b,6);c=vc(d);v[a>>2]=c;v[a+4>>2]=c;f=Gb(a),g=c+d|0,v[f>>2]=g;d=kb-16|0;kb=d;c=Iq(d,a,b);b=v[c+4>>2];e=v[c+8>>2];while(1){if((b|0)==(e|0)){lc(c);kb=d+16|0}else{t[b|0]=0;t[b+1|0]=0;t[b+2|0]=0;t[b+3|0]=0;t[b+4|0]=0;t[b+5|0]=0;t[b+4|0]=6;t[b+5|0]=0;t[b|0]=0;t[b+1|0]=0;t[b+2|0]=8;t[b+3|0]=4;b=b+6|0;v[c+4>>2]=b;continue}break}}t[a+16|0]=6;v[a+12>>2]=2015363072;return a|0}function Dl(a,b,c){var d=0;d=512;a:{if(b){break a}d=0;if(!(w[a+35|0]&2)){break a}No(a)}d=x[a+34>>1]&-513|d;u[a+34>>1]=d;if(b){v[a>>2]=4;u[a+34>>1]=d&65470;Mg(a);b=w[c+8|0]|w[c+9|0]<<8|(w[c+10|0]<<16|w[c+11|0]<<24);t[a+76|0]=b;t[a+77|0]=b>>>8;t[a+78|0]=b>>>16;t[a+79|0]=b>>>24;b=w[c+4|0]|w[c+5|0]<<8|(w[c+6|0]<<16|w[c+7|0]<<24);c=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);t[a+68|0]=c;t[a+69|0]=c>>>8;t[a+70|0]=c>>>16;t[a+71|0]=c>>>24;t[a+72|0]=b;t[a+73|0]=b>>>8;t[a+74|0]=b>>>16;t[a+75|0]=b>>>24}}function C5(a,b){a=a|0;b=b|0;var c=C(0),d=0,e=C(0);v[23540]=0;Y(946,a|0);d=v[23540];v[23540]=0;if((d|0)!=1){a=v[v[a+24>>2]+24>>2];if(!((b|0)<0|x[a+480188>>1]<=b>>>0)){a=a+B(b,872)|0;c=C(C(w[a+1075834|0])*C(.0078125));e=C(c*c);c=C(C(w[a+1075835|0])*C(.0078125));c=C(K(C(e+C(c*c))))}return C(c)}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,9406,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)!=1){$();return C(C(0))}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function RO(a,b){a=a|0;b=+b;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;h=ut(b);v[a>>2]=0;v[a+4>>2]=0;Gc(a+8|0);nz(a,2048);g=kb-16|0;kb=g;f=lr(g,a,2048);d=v[f+4>>2];i=v[f+8>>2];while(1){if((d|0)==(i|0)){lc(f);kb=g+16|0}else{v[d>>2]=0;v[d+4>>2]=0;d=d+8|0;v[f+4>>2]=d;continue}break}while(1){a:{c=1;if((e|0)!=1024){if((e|0)==2048){break a}c=+(e-1024|0);j=ut(K(c*c*-9.5367431640625e-7+1)*b);c=c*.0372006759294457;c=j*Di(c)/(h*c)}k=bf(v[a>>2],e),l=c*.011841342921061943,A[k>>3]=l;e=e+1|0;continue}break}}function k_(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;d=v[a>>2];c=uc(d,v[a+4>>2]);if(c>>>0<b>>>0){f=kb-32|0;kb=f;d=b-c|0;c=v[Gb(a)>>2];b=v[a+4>>2];a:{if(d>>>0<=c-b>>2>>>0){At(a,d);break a}c=rw(a);g=qg(a,uc(v[a>>2],b)+d|0);e=uc(v[a>>2],v[a+4>>2]);b=f+8|0;pg(b+12|0,c);if(g){c=UF(v[b+16>>2],g)}else{c=0}v[b>>2]=c;e=c+(e<<2)|0;v[b+8>>2]=e;v[b+4>>2]=e;h=Cc(b),i=c+(g<<2)|0,v[h>>2]=i;PL(b,d);Fd(a,b);XP(b);a=v[b>>2];if(a){WF(v[b+16>>2],a,Lz(b))}}kb=f+32|0;return}if(b>>>0<c>>>0){Od(a,d+(b<<2)|0)}}function oR(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=kb-16|0;kb=c;v[a>>2]=0;v[a+4>>2]=0;ok(a+8|0,0);e=v[b+4>>2];if(e){$q(a,e);tl(c+8|0,v[b>>2]);Cm(c,v[b>>2],v[b+4>>2]);d=kb-16|0;kb=d;f=v[a+4>>2];b=v[c+8>>2];j=v[c+12>>2];e=v[c>>2];k=v[c+4>>2];g=f+mR(b,j,e,k)|0;v[a+4>>2]=g;a:{b:{if(!f){h=g-1|0;break b}h=g-1|0;if((h^f-1)>>>0>31){break b}i=v[a>>2];break a}i=v[a>>2];v[i+((g>>>0<33?0:h>>>5|0)<<2)>>2]=0}Oo(d+8|0,i,f);nR(d,b,j,e,k,v[d+8>>2],v[d+12>>2]);kb=d+16|0}kb=c+16|0;return a|0}function Eea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;a:{f=kb-48|0;kb=f;Lq(f+8|0,c);v[23540]=0;c=f+20|0;R(575,c|0,d|0);d=v[23540];v[23540]=0;b:{c:{d:{if((d|0)==1){break d}v[23540]=0;c=f+32|0;R(575,c|0,e|0);d=v[23540];v[23540]=0;if((d|0)==1){break d}Nv(f,f+8|0);v[23540]=0;X(296,a|0,b|0,v[f>>2],v[f+4>>2]);a=v[23540];v[23540]=0;if((a|0)==1){break c}lQ(f+8|0);kb=f+48|0;break a}a=P()|0;O()|0;while(1){c=zb(c-12|0);if((c|0)!=(f+8|0)){continue}break}break b}a=P()|0;O()|0;lQ(f+8|0)}T(a|0);L()}}function IX(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;a:{f=kb-48|0;kb=f;ap(f+8|0,c);v[23540]=0;c=f+20|0;R(139,c|0,d|0);d=v[23540];v[23540]=0;b:{c:{d:{if((d|0)==1){break d}v[23540]=0;c=f+32|0;R(139,c|0,e|0);d=v[23540];v[23540]=0;if((d|0)==1){break d}Nv(f,f+8|0);v[23540]=0;X(114,a|0,b|0,v[f>>2],v[f+4>>2]);a=v[23540];v[23540]=0;if((a|0)==1){break c}wr(f+8|0);kb=f+48|0;break a}a=P()|0;O()|0;while(1){c=Ab(c-12|0);if((c|0)!=(f+8|0)){continue}break}break b}a=P()|0;O()|0;wr(f+8|0)}T(a|0);L()}}function hia(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;c=kb-32|0;kb=c;e=c+8|0;f=Tb(e+8|0);v[23540]=0;d=S(202,b|0)|0;g=v[23540];v[23540]=0;a:{b:{if((g|0)==1){break b}v[23540]=0;U(244,e|0,b|0,d|0);d=v[23540];v[23540]=0;if((d|0)==1){break b}d=v[e>>2];v[23540]=0;Q(188,b|0,d|0)|0;b=v[23540];v[23540]=0;if((b|0)!=1){break a}}a=P()|0;O()|0;ic(f);T(a|0);L()}Su(c,e);v[23540]=0;U(463,a|0,v[c>>2],v[c+4>>2]);a=v[23540];v[23540]=0;if((a|0)!=1){Uc(c+8|0);kb=c+32|0;return}a=P()|0;O()|0;Uc(c+8|0);T(a|0);L()}function Gfa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=kb-32|0;kb=d;nd(b,0);kB(d,a+1|0);c=d+16|0;Fc(c,d);Be(b+43|0,c);zb(c);v[b+24>>2]=w[a+73|0]|w[a+74|0]<<8|(w[a+75|0]<<16|w[a+76|0]<<24);c=w[a+54|0]|w[a+55|0]<<8|(w[a+56|0]<<16|w[a+57|0]<<24);v[b>>2]=c;v[b+4>>2]=w[a+58|0]|w[a+59|0]<<8|(w[a+60|0]<<16|w[a+61|0]<<24);e=w[a+62|0]|w[a+63|0]<<8|(w[a+64|0]<<16|w[a+65|0]<<24);if(e){v[b+8>>2]=e+1}u[b+30>>1]=(w[a+68|0]<<1)+2;u[b+34>>1]=x[b+34>>1]&65533|w[a|0]>>>6&2;xc(b+8|0,c);xc(b+4|0,v[b+8>>2]);kb=d+32|0}function qP(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;j=b?33:32;c=v[a+8>>2]-1|0;e=v[a+12>>2];f=v[a>>2]+B(e,31)|0;g=b?1:-1;d=g;a:while(1){b:{b=0;if((h|0)==(j|0)){break b}while(1)if((b|0)>=(e|0)){b=B(e,g);i=v[a+8>>2]-1|0;c:{if(!((i|0)!=(c|0)|(d|0)<=0)){if(!w[a+16|0]){d=1;c=0;break c}d=-1;c=c-(w[a+17|0]!=0&(c|0)!=0)|0;break c}if(!((d|0)>=0|c)){c=w[a+16|0];d=c?1:-1;c=c?0:i;break c}c=c+d|0}f=b+f|0;h=h+1|0;continue a}else{t[b+f|0]=w[v[a+4>>2]+(B(c,e)+b|0)|0];b=b+1|0;e=v[a+12>>2];continue}}break}}function ly(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;a:{if((c|0)<2){break a}k=c-2>>>1|0;f=d-a|0;if((k|0)<f>>1){break a}h=f+1|0;e=(h<<1)+a|0;g=x[e>>1];i=f+2|0;if((i|0)<(c|0)){j=x[e+2>>1];f=Np(b,g&65535,j);e=f?e+2|0:e;h=f?i:h;g=f?j:g}i=x[d>>1];if(Np(b,g&65535,i)){break a}while(1){b:{f=e;u[d>>1]=g;if((h|0)>(k|0)){break b}d=h<<1;h=d|1;e=(h<<1)+a|0;g=x[e>>1];j=d+2|0;if((j|0)<(c|0)){l=x[e+2>>1];d=Np(b,g&65535,l);e=d?e+2|0:e;h=d?j:h;g=d?l:g}d=f;if(!Np(b,g&65535,i)){continue}}break}u[f>>1]=i}}function AM(a,b){var c=0,d=0,e=0,f=0,g=0;d=kb-32|0;kb=d;a:{f=b-4e3&65535;if(f>>>0<61537){break a}c=B(b,104)+a|0;e=c+484380|0;if(!_d(v[e>>2],v[c+484400>>2])){break a}g=a+1298224|0;c=a+1074992|0;while(1){if((c|0)==(g|0)){Dm(e);v[e>>2]=0;a=(B(b,104)+a|0)+484414|0;u[a>>1]=x[a>>1]&65470;v[d+24>>2]=0;v[d+8>>2]=0;v[d+16>>2]=0;v[d+20>>2]=0;v[d>>2]=0;v[d+4>>2]=0;Dl(e,0,d);break a}if(v[c+104>>2]==(e|0)){v[c+76>>2]=0;v[c>>2]=0;v[c+4>>2]=0;v[c+16>>2]=0}c=c+872|0;continue}}kb=d+32|0;return f>>>0>61536}function Pr(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;i=kb-16|0;kb=i;a:{b:{if(!a){break b}h=v[e+12>>2];g=c-b|0;if((g|0)>0){g=g>>>2|0;if((Rm(a,b,g)|0)!=(g|0)){break b}}b=d-b>>2;b=(b|0)<(h|0)?h-b|0:0;if((b|0)>0){f=rG(i,b,f);h=Ac(f);v[23540]=0;h=W(1151,a|0,h|0,b|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break a}Nc(f);if((b|0)!=(h|0)){break b}}b=d-c|0;if((b|0)>0){b=b>>>2|0;if((Rm(a,c,b)|0)!=(b|0)){break b}}Fo(e);j=a}kb=i+16|0;return j|0}a=P()|0;O()|0;Nc(f);T(a|0);L()}function $4(a,b){a=a|0;b=b|0;var c=0,d=0;v[23540]=0;Y(946,a|0);c=v[23540];v[23540]=0;if((c|0)!=1){a=v[a+24>>2];c=-1;a:{if((b|0)<0){break a}d=v[a+24>>2];if(tj(Wb(v[d+484360>>2],w[d+484376|0]))>>>0<=b>>>0){break a}a=v[a+24>>2];c=x[cc(v[Wb(v[a+484360>>2],w[a+484376|0])>>2],b)>>1]}return c|0}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,9820,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)!=1){$();return 0}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function rH(a){var b=0,c=0;a:{b=v[a+4>>2];b=v[v[b>>2]-12>>2]+b|0;b:{if(!v[b+24>>2]){break b}if(!Yg(b)|!(v[b+4>>2]&8192)){break b}if(IH()){break b}b=v[a+4>>2];b=v[(v[v[b>>2]-12>>2]+b|0)+24>>2];v[23540]=0;b=S(1101,b|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){if((b|0)!=-1){break b}a=v[a+4>>2];b=v[v[a>>2]-12>>2];v[23540]=0;Y(1102,a+b|0);a=v[23540];v[23540]=0;if((a|0)!=1){break b}}a=V(0)|0;O()|0;_(a|0)|0;v[23540]=0;Z(18);a=v[23540];v[23540]=0;if((a|0)==1){break a}}return}V(0)|0;O()|0;Vb();L()}function Hz(a,b){var c=0,d=0,e=0,f=0,g=0,h=0;d=kb-16|0;kb=d;f=a+14|0;c=v[a>>2];e=v[a+4>>2];if(pc(c,e)){b=c}else{u[c>>1]=0;wf(c+2|0,b);g=d,h=ym(Fb(v[a>>2]),1),v[g+8>>2]=h;while(1){e=Fb(v[a+4>>2]);c=v[d+8>>2];if(Pb(c,e)){g=c,h=x[ke(c,ym(c,-1))>>1],u[g>>1]=h;wf(c+2|0,b);xQ(d+8|0);continue}else{e=v[a+4>>2];b=v[a>>2]}break}}wf(f,$d(b,e)-1&255);wf(a+13|0,w[a+14|0]);wf(a+16|0,$d(v[a>>2],v[a+4>>2])-1&255);wf(a+15|0,w[a+16|0]);if(w[a+17|0]!=255){wf(a+17|0,$d(v[a>>2],v[a+4>>2])-1&255)}kb=d+16|0}function Lv(a){var b=0,c=0,d=0;if(y[a+4>>2]<y[Gb(a)>>2]){b=kb-16|0;kb=b;a=CD(b,a);c=v[a+4>>2];v[23540]=0;Y(170,c|0);c=v[23540];v[23540]=0;a:{if((c|0)!=1){v[a+4>>2]=v[a+4>>2]+36;lc(a);kb=b+16|0;break a}b=P()|0;O()|0;lc(a);T(b|0);L()}return}c=kb-32|0;kb=c;b=Gb(a);b=AD(c+8|0,BD(a,kr(v[a>>2],v[a+4>>2])+1|0),kr(v[a>>2],v[a+4>>2]),b);d=v[b+8>>2];v[23540]=0;Y(170,d|0);d=v[23540];v[23540]=0;b:{if((d|0)!=1){v[b+8>>2]=v[b+8>>2]+36;zD(a,b);Bv(b);kb=c+32|0;break b}a=P()|0;O()|0;Bv(b);T(a|0);L()}}function zk(a){var b=0,c=0;a:{b=v[a+4>>2];b=v[v[b>>2]-12>>2]+b|0;b:{if(!v[b+24>>2]){break b}if(!Yg(b)|!(v[b+4>>2]&8192)){break b}if(IH()){break b}b=v[a+4>>2];b=v[(v[v[b>>2]-12>>2]+b|0)+24>>2];v[23540]=0;b=S(22,b|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){if((b|0)!=-1){break b}a=v[a+4>>2];b=v[v[a>>2]-12>>2];v[23540]=0;R(16,a+b|0,1);a=v[23540];v[23540]=0;if((a|0)!=1){break b}}a=V(0)|0;O()|0;_(a|0)|0;v[23540]=0;Z(18);a=v[23540];v[23540]=0;if((a|0)==1){break a}}return}V(0)|0;O()|0;Vb();L()}function AJ(a){var b=0,c=0,d=0,e=0,f=0;while(1){d=v[a+16>>2];if(d>>>0<=e>>>0){while(1){if(!(y[a+12>>2]<=d>>>0)){while(1){e=yy(v[a>>2]);c=nb;f=v[a+36>>2];if((c|0)==(f|0)&y[a+32>>2]<=e>>>0|c>>>0>f>>>0){continue}break}c=b;b=v[a+8>>2];b=(e&v[a+48>>2])+(b>>>0<31?c<<b+1:0)|0;d=d+1|0;continue}break}}else{while(1){d=yy(v[a>>2]);c=nb;f=v[a+28>>2];if((c|0)==(f|0)&y[a+24>>2]<=d>>>0|c>>>0>f>>>0){continue}break}c=b;b=v[a+8>>2];b=(d&v[a+40>>2])+(b>>>0<32?c<<b:0)|0;e=e+1|0;continue}break}return b}function tha(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;if(y[a+4>>2]<y[Gb(a)>>2]){c=kb-16|0;kb=c;a=mV(c,a);DA(v[a+4>>2],b);v[a+4>>2]=v[a+4>>2]+28;lc(a);kb=c+16|0;return}e=kb-32|0;kb=e;c=Gb(a);c=kV(e+8|0,lV(a,Mq(v[a>>2],v[a+4>>2])+1|0),Mq(v[a>>2],v[a+4>>2]),c);DA(v[c+8>>2],b);v[c+8>>2]=v[c+8>>2]+28;f=v[a>>2];d=v[a+4>>2];b=c+4|0;while(1){if((d|0)!=(f|0)){d=d-28|0;DA(v[b>>2]-28|0,d);v[b>>2]=v[b>>2]-28;continue}break}qc(a,b);qc(a+4|0,c+8|0);qc(Gb(a),Cc(c));v[c>>2]=v[c+4>>2];jV(c);kb=e+32|0}function Ej(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;if(y[a+4>>2]<y[Gb(a)>>2]){c=kb-16|0;kb=c;a=mV(c,a);JB(v[a+4>>2],b);v[a+4>>2]=v[a+4>>2]+28;lc(a);kb=c+16|0;return}e=kb-32|0;kb=e;c=Gb(a);c=kV(e+8|0,lV(a,Mq(v[a>>2],v[a+4>>2])+1|0),Mq(v[a>>2],v[a+4>>2]),c);JB(v[c+8>>2],b);v[c+8>>2]=v[c+8>>2]+28;f=v[a>>2];d=v[a+4>>2];b=c+4|0;while(1){if((d|0)!=(f|0)){d=d-28|0;JB(v[b>>2]-28|0,d);v[b>>2]=v[b>>2]-28;continue}break}qc(a,b);qc(a+4|0,c+8|0);qc(Gb(a),Cc(c));v[c>>2]=v[c+4>>2];jV(c);kb=e+32|0}function cJ(a,b,c,d,e){var f=0,g=0,h=0,i=0,j=0,k=0;if((e|0)==10){Gx(a,b,c,d);return}g=d;i=B(e,e);k=B(i,e);j=B(i,i);a:{while(1){h=f|1;if(e>>>0>g>>>0){break a}h=f|2;if(g>>>0<i>>>0){break a}h=f|3;if(g>>>0<k>>>0){break a}if(g>>>0<j>>>0){h=f+4|0}else{f=f+4|0;g=(g>>>0)/(j>>>0)|0;continue}break}}f=h;if((f|0)>(c-b|0)){v[a+4>>2]=61;v[a>>2]=c;return}f=b+f|0;c=f;while(1){c=c-1|0;b=(d>>>0)/(e>>>0)|0;t[c|0]=w[(d-B(b,e)|0)+4898|0];g=d>>>0>=e>>>0;d=b;if(g){continue}break}v[a+4>>2]=0;v[a>>2]=f}function kF(a,b,c,d,e,f,g,h){var i=0,j=0;i=kb-16|0;kb=i;v[23540]=0;Y(946,a|0);j=v[23540];v[23540]=0;a:{b:{if((j|0)!=1){c:{j=v[a+24>>2];v[23540]=0;ia(h|0,i|0,j|0,b|0,c|0,d|0,e|0,(f|0)!=0|0);b=v[23540];v[23540]=0;if((b|0)==1){break c}b=gg(Mc(i));zb(i);break b}}b=V(0)|0;O()|0;_(b|0)|0;b=0;v[23540]=0;X(933,g|0,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)==1){break a}$()}kb=i+16|0;return b}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function XL(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;if((a|0)!=(b|0)){c=kb-16|0;kb=c;d=v[b>>2];f=v[b+4>>2];e=qk(d,f);a:{if(e>>>0<=Bu(a)>>>0){g=f;h=v[a>>2];i=qk(h,v[a+4>>2]);j=i>>>0>=e>>>0;if(!j){v[c+12>>2]=d;v[c+12>>2]=v[c+12>>2]+B(i,6);g=v[c+12>>2]}d=ZL(d,g,h);if(!j){ay(a,g,f,e-qk(v[a>>2],v[a+4>>2])|0);break a}Od(a,d);break a}YL(a);lu(a,JA(a,e));ay(a,d,f,e)}kb=c+16|0}v[a+12>>2]=v[b+12>>2];v[a+16>>2]=v[b+16>>2];v[a+20>>2]=v[b+20>>2];WL(a+24|0,b+24|0);Oq(a+36|0,b+36|0);return a}function OQ(a){var b=0,c=0;a:{if(Sb(a+60|0,13843,4)){break a}b=w[a+28|0]|w[a+29|0]<<8;b:{if(b>>>0<=63){if((b|0)==26){break b}break a}if(b>>>0>2112){break a}}b=w[a+42|0];if(b>>>0>64&(b|0)!=88|(w[a+48|0]|w[a+49|0]<<8)>>>0>64|(w[a+50|0]|w[a+51|0]<<8)>>>0>96){break a}b=w[a+52|0]|w[a+53|0]<<8;if(b>>>0>129&(b|0)!=257|(w[a+30|0]|w[a+31|0]<<8)|(w[a+38|0]|w[a+39|0]<<8|(w[a+40|0]<<16|w[a+41|0]<<24)|(w[a+44|0]|w[a+45|0]<<8|(w[a+46|0]<<16|w[a+47|0]<<24))!=1)){break a}c=RQ(a+20|0)}return c}function Kf(a,b,c,d,e,f){var g=0,h=0,i=0;a:{if(f&64){d=b;e=f+-64|0;b=e&31;if((e&63)>>>0>=32){e=d<<b;d=0}else{e=(1<<b)-1&d>>>32-b|c<<b;d=d<<b}b=0;c=0;break a}if(!f){break a}g=d;d=f&31;if((f&63)>>>0>=32){h=g<<d;i=0}else{h=(1<<d)-1&g>>>32-d|e<<d;i=g<<d}g=b;e=64-f|0;d=e&31;if((e&63)>>>0>=32){e=0;b=c>>>d|0}else{e=c>>>d|0;b=((1<<d)-1&c)<<32-d|g>>>d}d=i|b;e=e|h;b=f&31;if((f&63)>>>0>=32){h=g<<b;b=0}else{h=(1<<b)-1&g>>>32-b|c<<b;b=g<<b}c=h}v[a>>2]=b;v[a+4>>2]=c;v[a+8>>2]=d;v[a+12>>2]=e}function wu(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,j=0;g=kb-16|0;kb=g;h=Lb(b,0);f=(w[h|0]&15)<<8|w[Lb(b,1)|0];d=0;a:{if(!f){break a}d=0;if((f|0)==4095){break a}while(1){d=108;if((e|0)==84){break a}b:{d=x[(e<<1)+32736>>1];if(d>>>0<=f>>>0){if(!e|(f|0)==(d|0)|(x[(e<<1)+32734>>1]-f|0)>=(f-d|0)){break b}d=e+24|0;break a}e=e+1|0;continue}break}d=e+25|0}t[c|0]=d;e=Lb(b,2);d=w[e|0];f=w[h|0];t[c+3|0]=0;t[c+1|0]=f&16|d>>>4;c=w[e|0];i=g,j=w[Lb(b,3)|0],t[i+15|0]=j;de(a,c&15,g+15|0);kb=g+16|0}function K3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=kb-32|0;kb=e;d=of(e+16|0,1,0);a:{b:{while(1){f=Ac(d);uJ(e+8|0,f,Hb(d)+f|0,w[b|0],c);if(!v[e+12>>2]){break b}f=ch(Hb(d));v[23540]=0;R(59,d|0,f|0);f=v[23540];v[23540]=0;if((f|0)!=1){continue}break}break a}b=v[e+8>>2];c=Ac(d);v[23540]=0;R(60,d|0,b-c|0);b=v[23540];v[23540]=0;c:{if((b|0)!=1){v[23540]=0;R(61,a|0,d|0);a=v[23540];v[23540]=0;if((a|0)!=1){break c}break a}break a}zb(d);kb=e+32|0;return}a=P()|0;O()|0;zb(d);T(a|0);L()}function kD(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0;f=kb-16|0;kb=f;g=v[b+16>>2];v[a+4>>2]=0;v[a>>2]=g;a:{if(!g){break a}e=b+80|0;c=v[b+84>>2];if(c>>>0<=15){d=v[e>>2]}else{v[f+12>>2]=c-16;d=v[_c(e,f+12|0)>>2]}v[a+8>>2]=d;c=v[b+88>>2];if(!(c&2)){break a}d=c;c=v[b+104>>2];b:{if(!(!jD(d,c)|v[e>>2]!=v[c+12>>2])){e=1;d=v[b+84>>2];if((d|0)==v[c+16>>2]){break b}}e=0;d=v[b+84>>2];if((d|0)!=v[c+8>>2]){break a}}h=a,i=B((v[c>>2]-d|0)+(e?112:48)|0,Fk(x[c+34>>1]))+g|0,v[h+4>>2]=i}kb=f+16|0}function jF(a,b,c,d,e,f,g){var h=0,i=0;h=kb-16|0;kb=h;v[23540]=0;Y(946,a|0);i=v[23540];v[23540]=0;a:{b:{if((i|0)!=1){c:{i=v[v[a+24>>2]+24>>2];v[23540]=0;ma(g|0,h|0,i|0,b|0,c|0,d|0,e|0);b=v[23540];v[23540]=0;if((b|0)==1){break c}b=gg(Mc(h));zb(h);break b}}b=V(0)|0;O()|0;_(b|0)|0;b=0;v[23540]=0;X(933,f|0,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)==1){break a}$()}kb=h+16|0;return b}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function R2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;e=Wo(a);v[e>>2]=61276;c=Cc(e);a=kb-16|0;kb=a;d=v[b+12>>2];v[a+8>>2]=v[b+8>>2];v[a+12>>2]=d;d=v[b+4>>2];v[a>>2]=v[b>>2];v[a+4>>2]=d;d=kb-16|0;kb=d;b=v[a+12>>2];v[d+8>>2]=v[a+8>>2];v[d+12>>2]=b;b=v[a+4>>2];v[d>>2]=v[a>>2];v[d+4>>2]=b;b=$I(d);c=fn(c);t[c+8|0]=0;v[c+4>>2]=b;v[c>>2]=61676;Tb(c+12|0);v[c>>2]=61440;b=v[a+4>>2];v[c+24>>2]=v[a>>2];v[c+28>>2]=b;b=v[a+12>>2];v[c+32>>2]=v[a+8>>2];v[c+36>>2]=b;kb=d+16|0;kb=a+16|0;return e|0}function PM(a){var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;g=v[a+104>>2];e=(g<<3)+a|0;c=((g+7>>>0)%12<<3)+a|0;f=v[c>>2];c=v[c+4>>2];h=v[a+96>>2];i=v[a+100>>2];a:{if(!(h|i)){b=v[e+4>>2];d=v[e>>2];j=(b|0)==(c|0)&d>>>0>f>>>0|c>>>0<b>>>0;break a}b=v[e+4>>2];d=v[e>>2];j=!(c|f)|((b|0)==(c|0)&d>>>0>=f>>>0|c>>>0<b>>>0)}b=b+i|0;d=h+d|0;b=d>>>0<h>>>0?b+1|0:b;v[e>>2]=f-d;v[e+4>>2]=c-(b+(f>>>0<d>>>0)|0)&65535;v[a+104>>2]=(g+1>>>0)%12;v[a+96>>2]=j;v[a+100>>2]=0;nb=v[e+4>>2];return v[e>>2]}function l9(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;a=vi(a,b,c,d);v[a>>2]=44140;b=Tb(a+4208|0);v[a+4236>>2]=-1;v[a+4240>>2]=0;v[a+4228>>2]=1049926264;v[a+4232>>2]=0;v[a+4220>>2]=1056964608;v[a+4224>>2]=1056964608;t[a+4244|0]=0;Ub(a+4248|0,0,48);v[23540]=0;Z(810);c=v[23540];v[23540]=0;a:{if((c|0)==1){break a}e=a,f=XM(),v[e+4296>>2]=f;Rs(a);Qs(a);v[23540]=0;R(897,a+44|0,2);c=v[23540];v[23540]=0;if((c|0)==1){break a}ui(a);return a|0}c=P()|0;O()|0;ic(b);If(a);T(c|0);L()}function KJ(a,b,c){var d=0,e=0,f=0,g=0,h=0;d=kb-16|0;kb=d;v[d+12>>2]=c;a:{if(!b){a=a+120|0;In(a);g=FJ(a,v[d+12>>2]),h=0,t[g+20|0]=h;break a}e=kb-16|0;kb=e;v[e+12>>2]=c;b:{if((b|0)==1){b=a+120|0;In(b);g=wx(b,a,v[e+12>>2]),h=1,t[g+20|0]=h;break b}f=kb-16|0;kb=f;v[f+12>>2]=c;c:{if((b|0)==2){a=a+120|0;In(a);a=FJ(a,v[f+12>>2]);ee(a+12|0);t[a+20|0]=2;break c}b=kb-16|0;kb=b;v[b+12>>2]=c;c=a+120|0;In(c);g=wx(c,a,v[b+12>>2]),h=3,t[g+20|0]=h;kb=b+16|0}kb=f+16|0}kb=e+16|0}kb=d+16|0}function x3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=kb-16|0;kb=c;a:{d=Uh(C(z[a+24>>2]*C(65536)));if((d|0)==65536){break a}j=d>>31;k=v[b>>2];g=v[b+4>>2];l=v[b+8>>2];b:while(1){if((f|0)==(l|0)){break a}m=B(f,g);e=0;while(1)if((e|0)==(g|0)){f=f+1|0;continue b}else{h=(e+m<<2)+k|0;i=v[h>>2];n=h,o=Hc(Kka(Jka(i,i>>31,d,j),nb,65536,0),nb),v[n>>2]=o;e=e+1|0;continue}}}v[c+8>>2]=v[b+8>>2];d=v[b+4>>2];v[c>>2]=v[b>>2];v[c+4>>2]=d;wJ(a,c);kb=c+16|0}function oS(a,b,c,d){var e=0,f=0,g=0;f=kb-16|0;kb=f;while(1){a:{e=x[c>>1]<<1;u[c>>1]=e;t[b|0]=(e&65534)>>>0>255;e=w[c|0];u[c>>1]=e;if(!e){if(!nf(a,f+15|0)){break a}e=w[f+15|0];u[c>>1]=e<<1|1;t[b|0]=e>>>7;u[c>>1]=w[c|0]}t[d|0]=w[b|0]+(w[d|0]<<1);e=x[c>>1]<<1;u[c>>1]=e;t[b|0]=(e&65534)>>>0>255;e=w[c|0];u[c>>1]=e;if(!e){e=nf(a,f+14|0);if(e){g=w[f+14|0];u[c>>1]=g<<1|1;t[b|0]=g>>>7;u[c>>1]=w[c|0]}if(!e){break a}if(w[b|0]){continue}break a}if(w[b|0]){continue}}break}kb=f+16|0}function o3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=kb-16|0;kb=c;a:{d=Uh(C(z[a+24>>2]*C(65536)));if((d|0)==65536){break a}j=d>>31;k=v[b>>2];g=v[b+4>>2];l=v[b+8>>2];b:while(1){if((f|0)==(l|0)){break a}m=B(f,g);e=0;while(1)if((e|0)==(g|0)){f=f+1|0;continue b}else{h=(e+m<<2)+k|0;i=v[h>>2];n=h,o=Hc(Kka(Jka(i,i>>31,d,j),nb,65536,0),nb),v[n>>2]=o;e=e+1|0;continue}}}v[c+8>>2]=v[b+8>>2];d=v[b+4>>2];v[c>>2]=v[b>>2];v[c+4>>2]=d;oJ(a,c);kb=c+16|0}function G9(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;f=kb-48|0;kb=f;d=v[a+36>>2];Rl(v[v[d>>2]-12>>2]+d|0,0);e=v[b>>2];d=v[e+12>>2];g=v[e+8>>2];if(d|g){h=v[a+36>>2];d=v[a+20>>2]+d|0;e=v[a+16>>2];g=g+e|0;e=Xg(f+32|0,g,e>>>0>g>>>0?d+1|0:d);d=v[e+12>>2];v[f+8>>2]=v[e+8>>2];v[f+12>>2]=d;d=v[e+4>>2];v[f>>2]=v[e>>2];v[f+4>>2]=d;Zj(h,f)}d=f+16|0;me(d,v[a+36>>2]);xz(v[a+36>>2],c,v[v[b>>2]+16>>2]);c=v[b>>2];b=Lk(d,Lb(v[a+40>>2],v[c>>2]),x[c+20>>1]);Ye(a,c);Xb(b);kb=f+48|0}function Qha(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;e=kb-16|0;kb=e;i=e,j=Aj(b),v[i>>2]=j;g=x[b>>1];c=kb-16|0;kb=c;f=a;d=Td(a);a:{if(d){b=jc(f);while(1){a=d;d=x[a+16>>1];if(oo(g,d)){b=a;d=v[a>>2];if(d){continue}break a}if(!oo(d,g)){break a}b=a+4|0;d=v[a+4>>2];if(d){continue}break}break a}a=jc(f);b=a}v[c+12>>2]=a;a=v[b>>2];if(!a){nT(c,f,e);Jg(f,v[c+12>>2],b,v[c>>2]);a=ce(c);mT(c);h=1}Ig(e+8|0,v[fc(c,a)>>2],h);kb=c+16|0;a=vd(v[e+8>>2]);kb=e+16|0;return a+4|0}function $2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;d=kb-16|0;kb=d;v[d+4>>2]=1;g=d,h=vc(56),v[g+8>>2]=h;c=Wo(v[d+8>>2]);v[c>>2]=61776;e=Cc(c);c=kb-16|0;kb=c;f=v[b+12>>2];v[c+8>>2]=v[b+8>>2];v[c+12>>2]=f;f=v[b+4>>2];v[c>>2]=v[b>>2];v[c+4>>2]=f;b=fn(e);v[b>>2]=62140;Tb(b+4|0);t[b+20|0]=0;v[b+16>>2]=0;v[b>>2]=61940;e=v[c+4>>2];v[b+24>>2]=v[c>>2];v[b+28>>2]=e;e=v[c+12>>2];v[b+32>>2]=v[c+8>>2];v[b+36>>2]=e;t[b+40|0]=0;kb=c+16|0;b=a;a=Yo(d);Xo(b,Cc(a),a);gn(d);kb=d+16|0}function saa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;d=kb-32|0;kb=d;Ii(d,2,a+2|0);e=d+16|0;Fc(e,d);Dc(b+492|0,e);f=b+236|0;g=c+1|0;zb(e);c=0;while(1){if((c|0)==120){v[b>>2]=(w[a+223|0]|w[a+224|0]<<8)<<5;a=a+158|0;bM(w[a|0]&15,w[a+1|0]&15,w[a+2|0]&15,w[a+3|0]&15,w[a+4|0]&15,a+5|0,b+48|0);bM(w[a|0]>>>4|0,w[a+1|0]>>>4|0,w[a+2|0]>>>4|0,w[a+3|0]>>>4|0,w[a+4|0]>>>4|0,a+35|0,b+68|0);kb=d+32|0}else{h=cc(f,c),i=w[(a+c|0)+31|0]+g|0,u[h>>1]=i;c=c+1|0;continue}break}}function NL(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;e=kb-16|0;kb=e;i=e,j=Aj(b),v[i>>2]=j;g=x[b>>1];c=kb-16|0;kb=c;f=a;d=Td(a);a:{if(d){b=jc(f);while(1){a=d;d=x[a+16>>1];if(Vs(g,d)){b=a;d=v[a>>2];if(d){continue}break a}if(!Vs(d,g)){break a}b=a+4|0;d=v[a+4>>2];if(d){continue}break}break a}a=jc(f);b=a}v[c+12>>2]=a;a=v[b>>2];if(!a){nT(c,f,e);Jg(f,v[c+12>>2],b,v[c>>2]);a=ce(c);mT(c);h=1}Ig(e+8|0,v[fc(c,a)>>2],h);kb=c+16|0;a=vd(v[e+8>>2]);kb=e+16|0;return a+4|0}function nW(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;d=kb-32|0;kb=d;nd(b,0);$h(d,1,a+33|0);c=d+16|0;Fc(c,d);Be(b+43|0,c);zb(c);e=w[a+50|0]|w[a+51|0]<<8;v[b>>2]=e;v[b+24>>2]=w[a+52|0]|w[a+53|0]<<8;t[d+16|0]=w[a+54|0];t[d|0]=64;g=b,h=w[Yb(c,d)|0]<<2,u[g+30>>1]=h;f=w[a+55|0]|w[a+56|0]<<8;v[b+4>>2]=f;c=w[a+57|0]|w[a+58|0]<<8;v[b+8>>2]=c;a:{if((c|0)==65535){v[b+4>>2]=0;v[b+8>>2]=0;break a}if(!w[a|0]|c>>>0<=f+2>>>0|c>>>0>e>>>0){break a}u[b+34>>1]=x[b+34>>1]|2}kb=d+32|0}function vf(a,b,c,d,e,f,g,h,i){var j=0,k=0,l=0,m=0;h=Jka(b,c,h,i);i=nb;j=h;h=Jka(d,e,f,g);e=j+h|0;d=nb+i|0;i=e;h=i>>>0<h>>>0?d+1|0:d;j=i;k=g;e=0;l=c;d=0;i=Jka(g,e,c,d);g=j+i|0;c=nb+h|0;j=g;g=g>>>0<i>>>0?c+1|0:c;h=f;i=b;f=Jka(h,0,i,0);b=nb;c=0;d=Jka(h,c,l,d);b=b+d|0;c=nb+c|0;c=b>>>0<d>>>0?c+1|0:c;h=c;c=c+j|0;d=g;d=c>>>0<h>>>0?d+1|0:d;h=c;c=d;d=Jka(i,m,k,e)+b|0;e=nb;e=b>>>0>d>>>0?e+1|0:e;g=a;i=e;h=i+h|0;v[g+8>>2]=h;v[g+12>>2]=h>>>0<i>>>0?c+1|0:c;v[g>>2]=f;v[g+4>>2]=d}function Vq(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;i=kb-16|0;kb=i;a:{b:{if(!a){break b}g=v[e+12>>2];h=c-b|0;if((h|0)>0){if((Rm(a,b,h)|0)!=(h|0)){break b}}b=d-b|0;b=(b|0)<(g|0)?g-b|0:0;if((b|0)>0){f=of(i,b,f);g=Ac(f);v[23540]=0;g=W(23,a|0,g|0,b|0)|0;h=v[23540];v[23540]=0;if((h|0)==1){break a}zb(f);if((b|0)!=(g|0)){break b}}b=d-c|0;if((b|0)>0){if((Rm(a,c,b)|0)!=(b|0)){break b}}Fo(e);j=a}kb=i+16|0;return j|0}a=P()|0;O()|0;zb(f);T(a|0);L()}function Ry(a,b,c){var d=0,e=0;d=kb-16|0;kb=d;e=v[a+480180>>2];a:{if((e|0)!=1048576){if((e|0)!=4){break a}e=w[b+813|0];if(c){t[b+813|0]=e&240|c&15;break a}c=e&15;break a}if(c){t[b+813|0]=c;break a}c=w[b+813|0]}b:{if(!(t[b+851|0]&1)|!v[b+700>>2]){break b}c=c&255;if(!c){break b}hk(a,b,b+700|0,0-(c<<2)|0,0);if(v[b+700>>2]<65536){break b}Db(d+8|0,a+1074312|0,7);if(Cb(v[v[d+8>>2]>>2],v[d+12>>2])|(v[a+480180>>2]!=4?w[a+480208|0]&16:0)){break b}v[b+700>>2]=65535}kb=d+16|0}function CG(a,b,c,d){var e=0,f=0,g=0,h=0;e=kb-16|0;kb=e;a:{b:{if((a|0)!=(b|0)){c:{d:{f=w[a|0];if((f|0)!=45){break d}a=a+1|0;if((b|0)!=(a|0)){break d}break c}h=v[116016];v[116016]=0;Gd();a=Dw(a,e+12|0,d);d=nb;g=v[116016];e:{if(g){if(v[e+12>>2]!=(b|0)){break c}if(!d&a>>>0>65535|d|(g|0)==68){break e}break b}v[116016]=h;if((b|0)!=v[e+12>>2]){break c}if(!d&a>>>0<65536){break b}}v[c>>2]=4;a=65535;break a}}v[c>>2]=4;a=0;break a}a=(f|0)==45?0-a|0:a}kb=e+16|0;return a&65535}function $o(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if((a|0)!=(b|0)){if(!kf(w[a+11|0])){c=w[b+11|0];if(!kf(c)){d=v[b+4>>2];v[a>>2]=v[b>>2];v[a+4>>2]=d;v[a+8>>2]=v[b+8>>2];return}d=sd(b);b=Ad(v[b+4>>2],c);a:{if(b>>>0<=10){ie(a,b);xd(He(a,d,b)+b|0,0);break a}e=a;a=Mf(w[a+11|0]);rq(e,10,b-10|0,a,0,a,b,d)}return}d=sd(b);b=Ad(v[b+4>>2],w[b+11|0]);c=lB(v[a+8>>2]);b:{if(b>>>0<c>>>0){c=v[a>>2];Hd(a,b);xd(He(c,d,b)+b|0,0);break b}e=a;a=v[a+4>>2];rq(e,c-1|0,(b-c|0)+1|0,a,0,a,b,d)}}}function GE(a,b,c,d,e,f){var g=0;a:{g=kb-48|0;kb=g;nn(g+8|0,c);v[23540]=0;c=g+20|0;R(f|0,c|0,d|0);d=v[23540];v[23540]=0;b:{c:{d:{if((d|0)==1){break d}v[23540]=0;c=g+32|0;R(113,c|0,e|0);d=v[23540];v[23540]=0;if((d|0)==1){break d}Nv(g,g+8|0);v[23540]=0;X(114,a|0,b|0,v[g>>2],v[g+4>>2]);a=v[23540];v[23540]=0;if((a|0)==1){break c}wr(g+8|0);kb=g+48|0;break a}a=P()|0;O()|0;while(1){c=Ab(c-12|0);if((c|0)!=(g+8|0)){continue}break}break b}a=P()|0;O()|0;wr(g+8|0)}T(a|0);L()}}function H9(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;g=kb-48|0;kb=g;e=v[a+36>>2];Rl(v[v[e>>2]-12>>2]+e|0,0);f=v[b>>2];e=v[f+12>>2];h=v[f+8>>2];if(e|h){i=v[a+36>>2];e=v[a+20>>2]+e|0;f=v[a+16>>2];h=h+f|0;f=Xg(g+32|0,h,f>>>0>h>>>0?e+1|0:e);e=v[f+12>>2];v[g+8>>2]=v[f+8>>2];v[g+12>>2]=e;e=v[f+4>>2];v[g>>2]=v[f>>2];v[g+4>>2]=e;Zj(i,g)}e=g+16|0;me(e,v[a+36>>2]);HL(d,v[a+36>>2],c);c=v[b>>2];b=Lk(e,Lb(v[a+40>>2],v[c>>2]),x[c+20>>1]);Ye(a,c);Xb(b);kb=g+48|0}function F9(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;g=kb-48|0;kb=g;e=v[a+36>>2];Rl(v[v[e>>2]-12>>2]+e|0,0);f=v[b>>2];e=v[f+12>>2];h=v[f+8>>2];if(e|h){i=v[a+36>>2];e=v[a+20>>2]+e|0;f=v[a+16>>2];h=h+f|0;f=Xg(g+32|0,h,f>>>0>h>>>0?e+1|0:e);e=v[f+12>>2];v[g+8>>2]=v[f+8>>2];v[g+12>>2]=e;e=v[f+4>>2];v[g>>2]=v[f>>2];v[g+4>>2]=e;Zj(i,g)}e=g+16|0;me(e,v[a+36>>2]);EL(c,v[a+36>>2],d);c=v[b>>2];b=Lk(e,Lb(v[a+40>>2],v[c>>2]),x[c+20>>1]);Ye(a,c);Xb(b);kb=g+48|0}function BE(a,b,c,d){var e=0,f=0,g=0;f=kb-32|0;kb=f;e=of(f+16|0,1,0);a:{b:{while(1){g=Ac(e);uJ(f+8|0,g,Hb(e)+g|0,v[b>>2],c);if(!v[f+12>>2]){break b}g=ch(Hb(e));v[23540]=0;R(59,e|0,g|0);g=v[23540];v[23540]=0;if((g|0)!=1){continue}break}break a}b=v[f+8>>2];c=Ac(e);v[23540]=0;R(60,e|0,b-c|0);b=v[23540];v[23540]=0;c:{if((b|0)!=1){v[23540]=0;R(d|0,a|0,e|0);a=v[23540];v[23540]=0;if((a|0)!=1){break c}break a}break a}zb(e);kb=f+32|0;return}a=P()|0;O()|0;zb(e);T(a|0);L()}function AE(a,b,c,d){var e=0,f=0,g=0;f=kb-32|0;kb=f;e=of(f+16|0,1,0);a:{b:{while(1){g=Ac(e);cJ(f+8|0,g,Hb(e)+g|0,v[b>>2],c);if(!v[f+12>>2]){break b}g=ch(Hb(e));v[23540]=0;R(59,e|0,g|0);g=v[23540];v[23540]=0;if((g|0)!=1){continue}break}break a}b=v[f+8>>2];c=Ac(e);v[23540]=0;R(60,e|0,b-c|0);b=v[23540];v[23540]=0;c:{if((b|0)!=1){v[23540]=0;R(d|0,a|0,e|0);a=v[23540];v[23540]=0;if((a|0)!=1){break c}break a}break a}zb(e);kb=f+32|0;return}a=P()|0;O()|0;zb(e);T(a|0);L()}function Ss(a,b,c){var d=0,e=0;d=(c|0)!=0;a:{b:{c:{d:{if(!(a&3)|!c){break d}e=b&255;while(1){if((e|0)==w[a|0]){break c}c=c-1|0;d=(c|0)!=0;a=a+1|0;if(!(a&3)){break d}if(c){continue}break}}if(!d){break a}if(w[a|0]==(b&255)|c>>>0<4){break c}d=B(b&255,16843009);while(1){e=d^v[a>>2];if((e^-1)&e-16843009&-2139062144){break b}a=a+4|0;c=c-4|0;if(c>>>0>3){continue}break}}if(!c){break a}}while(1){if(w[a|0]==(b&255)){return a}a=a+1|0;c=c-1|0;if(c){continue}break}}return 0}function Qy(a,b,c){var d=0,e=0;d=kb-16|0;kb=d;e=v[a+480180>>2];a:{if((e|0)!=1048576){if((e|0)!=4){break a}e=w[b+814|0];if(c){t[b+814|0]=e&240|c&15;break a}c=e&15;break a}if(c){t[b+813|0]=c;break a}c=w[b+813|0]}b:{if(!(t[b+851|0]&1)|!v[b+700>>2]){break b}c=c&255;if(!c){break b}hk(a,b,b+700|0,0-c|0,0);if(v[b+700>>2]<65536){break b}Db(d+8|0,a+1074312|0,7);if(Cb(v[v[d+8>>2]>>2],v[d+12>>2])|(v[a+480180>>2]!=4?w[a+480208|0]&16:0)){break b}v[b+700>>2]=65535}kb=d+16|0}function vY(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0;v[23540]=0;m=a;a=b;b=0;a=Na(1042,m|b,a|0,c|0,d|0,b|e,f|0)|0;b=v[23540];v[23540]=0;a:{b:{if((b|0)==1){a=V(0)|0;O()|0;_(a|0)|0;v[23540]=0;ia(929,8872,g|0,h|0,i|0,j|0,k|0,l|0);a=v[23540];v[23540]=0;if((a|0)==1){break b}$();a=-255}break a}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}return a|0}function R1(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;d=kb-16|0;kb=d;a:{g=v[c+12>>2];if(!g){break a}e=Pl(d,c+16|0);f=Gk(v[b+4>>2],w[b+11|0]);h=f-1|0;c=0;while(1){if((c|0)==(f|0)){Ab(e);break a}b:{c:{if(!c|(c>>>0)%(g>>>0)){break c}if((c|0)==(h|0)){if(w[sd(b)|0]==43){break c}if(w[sd(b)|0]==45){break c}}v[23540]=0;W(84,b|0,f-c|0,e|0)|0;i=v[23540];v[23540]=0;if((i|0)==1){break b}}c=c+1|0;continue}break}a=P()|0;O()|0;Ab(e);T(a|0);L()}ad(a,b);kb=d+16|0}function g6(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;var f=0,g=0;v[23540]=0;Y(971,a|0);f=v[23540];v[23540]=0;a:{b:{if((f|0)!=1){f=v[a+28>>2];g=v[v[f>>2]+72>>2];v[23540]=0;b=Wa(g|0,f|0,b|0,c|0,+d,+e)|0;c=v[23540];v[23540]=0;if((c|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,11287,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)==1){break a}$();b=-1}return b|0}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function RL(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;d=v[a>>2];c=uc(d,v[a+4>>2]);if(c>>>0<=127){f=kb-32|0;kb=f;c=128-c|0;e=v[Gb(a)>>2];d=v[a+4>>2];a:{if(c>>>0<=e-d>>2>>>0){Zx(a,c,b);break a}e=Gb(a);d=Vf(f+8|0,qg(a,uc(v[a>>2],d)+c|0),uc(v[a>>2],v[a+4>>2]),e);g=kb-16|0;kb=g;c=Xm(g,d+8|0,c);e=v[c>>2];while(1){if(v[c+4>>2]!=(e|0)){fk(e,z[b>>2]);e=v[c>>2]+4|0;v[c>>2]=e;continue}break}Ud(c);kb=g+16|0;Fd(a,d);Uf(d)}kb=f+32|0;return}if((c|0)!=128){Od(a,d+512|0)}}function zG(a,b,c,d){var e=0,f=0,g=0,h=0;e=kb-16|0;kb=e;a:{if((a|0)!=(b|0)){b:{c:{f=w[a|0];if((f|0)!=45){break c}a=a+1|0;if((b|0)!=(a|0)){break c}break b}h=v[116016];v[116016]=0;Gd();a=Dw(a,e+12|0,d);d=nb;d:{g=v[116016];if(g){if(v[e+12>>2]!=(b|0)){break b}if((g|0)!=68){break d}v[c>>2]=4;b=-1;a=-1;break a}v[116016]=h;if(v[e+12>>2]==(b|0)){break d}break b}c=(f|0)==45;b=c?0-a|0:a;a=c?0-(d+((a|0)!=0)|0)|0:d;break a}}v[c>>2]=4;b=0;a=0}kb=e+16|0;nb=a;return b}function h$(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;f=kb-16|0;kb=f;d=Hb(a);e=bd(a);g=Th(b,c);a:{if(!g){break a}b:{if(!Xs(a,b)){if(e-d>>>0<g>>>0){rm(a,e,(d+g|0)-e|0,d,d,0,0)}e=Ac(a)+d|0;while(1){if((b|0)==(c|0)){break b}we(e,b);b=b+1|0;e=e+1|0;continue}}b=Vh(f,b,c);c=Mc(b);d=Hb(b);v[23540]=0;W(1061,a|0,c|0,d|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){zb(b);break a}a=P()|0;O()|0;zb(b);T(a|0);L()}t[f+15|0]=0;we(e,f+15|0);Sh(a,d+g|0)}kb=f+16|0;return a|0}function aO(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;d=kb-16|0;kb=d;j=d,k=Aj(b),v[j>>2]=k;c=kb-16|0;kb=c;g=Jy(a,c+12|0,w[b|0],v[b+4>>2]);b=v[g>>2];if(!b){e=kb-16|0;kb=e;b=jc(a);h=lh(c,vc(28),mh(e+8|0,b));b=v[h>>2];f=v[d>>2];i=v[f+4>>2];f=v[f>>2];v[b+24>>2]=0;v[b+16>>2]=f;v[b+20>>2]=i;j=jc(h),k=1,t[j+4|0]=k;kb=e+16|0;Jg(a,v[c+12>>2],g,v[c>>2]);b=ce(c);rk(c);e=1}Ig(d+8|0,v[fc(c,b)>>2],e);kb=c+16|0;a=vd(v[d+8>>2]);kb=d+16|0;return a+8|0}function Gha(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=Fb(v[b>>2]);h=Fb(v[b+4>>2]);g=kb-16|0;kb=g;v[g+8>>2]=d;while(1){a:{if(!Pb(d,h)){break a}e=kb-16|0;kb=e;f=w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24);t[e+8|0]=f;t[e+9|0]=f>>>8;t[e+10|0]=f>>>16;t[e+11|0]=f>>>24;f=w[d+4|0]|w[d+5|0]<<8;t[e+12|0]=f;t[e+13|0]=f>>>8;kb=e+16|0;if(x[e+8>>1]==(c|0)){break a}d=v[Om(g+8|0)>>2];continue}break}kb=g+16|0;if(pc(d,Fb(v[b+4>>2]))){Kh(a);return}Bo(a,d)}function zE(a,b,c,d,e){var f=0,g=0,h=0;a:{f=kb-32|0;kb=f;h=Tb(a);b:{c:{d:{e:{while(1){a=v[b+8>>2];g=v[b>>2];v[23540]=0;a=W(156,g|0,a|0,8)|0;g=v[23540];v[23540]=0;if((g|0)==1){break c}if(!a){break d}v[23540]=0;U(e|0,f|0,b|0,c|0);a=v[23540];v[23540]=0;if((a|0)!=1){v[23540]=0;R(d|0,h|0,f|0);a=v[23540];v[23540]=0;if((a|0)==1){break e}Bd(f);continue}break}a=P()|0;O()|0;break b}a=P()|0;O()|0;Bd(f);break b}kb=f+32|0;break a}a=P()|0;O()|0}Zd(h);T(a|0);L()}}function j6(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;v[23540]=0;Y(971,a|0);e=v[23540];v[23540]=0;a:{b:{if((e|0)!=1){e=v[a+28>>2];f=v[v[e>>2]+12>>2];v[23540]=0;b=fa(f|0,e|0,b|0,c|0,d|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,11432,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)==1){break a}$();b=-1}return b|0}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function Nda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;b=kb-16|0;kb=b;g=v[a+24>>2];h=v[a+20>>2];i=v[a+16>>2];e=v[a+4>>2];v[b+8>>2]=v[a>>2];v[b+12>>2]=e;j=v[a+8>>2];k=v[a+12>>2];while(1){if(d){f=v[b+12>>2]+i|0;e=t[f|0];e=((B(t[f+1|0]-e|0,v[b+8>>2]>>>10&4194048)|0)/16384|0)+(e<<8)|0;v[c>>2]=v[c>>2]+B(e,h);v[c+4>>2]=v[c+4>>2]+B(e,g);Rb(b+8|0,j,k);c=c+8|0;d=d-1|0;continue}break}c=v[b+12>>2];v[a>>2]=v[b+8>>2];v[a+4>>2]=c;kb=b+16|0}function $9(a,b){a=a|0;b=b|0;var c=0,d=0;a:{v[a>>2]=0;v[a+4>>2]=0;Gc(a+8|0);c=qk(v[b>>2],v[b+4>>2]);if(c){lu(a,c);ay(a,v[b>>2],v[b+4>>2],c)}v[a+20>>2]=v[b+20>>2];c=v[b+16>>2];v[a+12>>2]=v[b+12>>2];v[a+16>>2]=c;v[23540]=0;c=Q(878,a+24|0,b+24|0)|0;d=v[23540];v[23540]=0;b:{c:{if((d|0)!=1){v[23540]=0;Q(54,a+36|0,b+36|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break c}v[a+48>>2]=v[b+48>>2];break a}b=P()|0;O()|0;break b}b=P()|0;O()|0;wc(c)}vk(a);T(b|0);L()}}function kca(a,b,c){a=a|0;b=b|0;c=c|0;a:{switch(b|0){case 0:hh(a,0,c);return;case 1:hh(a,1,c);return;case 2:hh(a,2,c);return;case 3:hh(a,3,c);return;case 4:hh(a,4,c);return;case 5:hh(a,5,c);return;case 6:ZO(a,23760,c);return;case 7:ZO(a,24784,c);return;case 8:hh(a,6,c);return;case 9:hh(a,7,c);return;case 10:hh(a,8,c);return;case 11:hh(a,9,c);return;case 12:hh(a,10,c);return;case 13:hh(a,11,c);return;case 14:hh(a,12,c);return;default:break a}}Nb(a)}function i6(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;v[23540]=0;Y(971,a|0);e=v[23540];v[23540]=0;a:{b:{if((e|0)!=1){e=v[a+28>>2];f=v[v[e>>2]+8>>2];v[23540]=0;b=fa(f|0,e|0,b|0,c|0,d|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,11468,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)==1){break a}$();b=-1}return b|0}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function WV(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;d=kb-16|0;kb=d;a:{b:{if(!fg(a,7)){break b}c=0;if(!rC(a,17861)){break a}if(!fg(a,1)){break b}c=-1;if(!id(a,Pq(a))){break a}c=kb-16|0;kb=c;f=d+8|0;Ho(c+8|0,f);e=v[c+12>>2];md(c,a,v[c+8>>2],v[c+12>>2]);g=v[c+4>>2];if((g|0)==(e|0)){id(a,v[c+12>>2])}kb=c+16|0;e=(e|0)==(g|0);if(!e){Qu(f)}c=-1;if(!e){break a}c=0;if(!dC(w[d+8|0],w[d+9|0])){break a}c=Ae(a,b,cC(d+8|0),nb);break a}c=-1}kb=d+16|0;return c|0}function hp(a,b,c,d,e){var f=0,g=0,h=0;a:{f=kb-32|0;kb=f;h=Tb(a);b:{c:{d:{e:{while(1){a=v[b+8>>2];g=v[b>>2];v[23540]=0;a=W(156,g|0,a|0,e|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break c}if(!a){break d}v[23540]=0;R(d|0,f|0,b|0);a=v[23540];v[23540]=0;if((a|0)!=1){v[23540]=0;R(c|0,h|0,f|0);a=v[23540];v[23540]=0;if((a|0)==1){break e}Bd(f);continue}break}a=P()|0;O()|0;break b}a=P()|0;O()|0;Bd(f);break b}kb=f+32|0;break a}a=P()|0;O()|0}Zd(h);T(a|0);L()}}function MX(a,b){a=a|0;b=b|0;var c=0;a=Nb(a);a:{if(w[b+16|0]){v[23540]=0;Q(133,a|0,4948)|0;c=v[23540];v[23540]=0;if((c|0)==1){break a}}if(w[b+17|0]){v[23540]=0;Q(133,a|0,12529)|0;c=v[23540];v[23540]=0;if((c|0)==1){break a}}if(sh(v[a+4>>2],w[a+11|0])){v[23540]=0;Q(133,a|0,10086)|0;c=v[23540];v[23540]=0;if((c|0)==1){break a}}if(w[b+18|0]){v[23540]=0;Q(133,a|0,11122)|0;b=v[23540];v[23540]=0;if((b|0)==1){break a}}return}b=P()|0;O()|0;Ab(a);T(b|0);L()}function Taa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;e=kb-16|0;kb=e;d=x[a+30>>1];if(d){b=Qn(b<<16>>16,d<<16>>16)}u[e+14>>1]=b;a=a+52|0;a:{if(!sh(v[c+4>>2],w[c+11|0])){$o(NL(a,e+14|0),c);break a}b=Yx(a,e+14|0);if(!Hg(b,xf(a))){break a}c=kb-16|0;kb=c;b=v[fc(c,b)>>2];d=kb-16|0;kb=d;f=Kg(fc(d+8|0,b));if((b|0)==v[a>>2]){v[a>>2]=v[f>>2]}g=Gb(a);v[g>>2]=v[g>>2]-1;ML(v[jc(a)>>2],b);a=v[f>>2];kb=d+16|0;MA(vd(b));Mb(b);fc(c+8|0,a);kb=c+16|0}kb=e+16|0}function B1(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;e=kb-32|0;kb=e;v[e+16>>2]=b;d=v[a+48>>2];v[e+20>>2]=c-((d|0)!=0);f=v[a+44>>2];v[e+28>>2]=d;v[e+24>>2]=f;a:{b:{if(bx(gb(v[a+60>>2],e+16|0,2,e+12|0)|0)){b=32}else{d=v[e+12>>2];if((d|0)>0){break b}b=d?32:16}v[a>>2]=b|v[a>>2];break a}g=d;f=v[e+20>>2];if(f>>>0>=d>>>0){break a}d=v[a+44>>2];v[a+4>>2]=d;v[a+8>>2]=d+(g-f|0);if(v[a+48>>2]){v[a+4>>2]=d+1;t[(b+c|0)-1|0]=w[d|0]}g=c}kb=e+32|0;return g|0}function lD(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;a:{d=kb-16|0;kb=d;b:{c:{if(!b){b=Mc(c);e=b;f=Hb(c)+b|0;c=Th(b,f);if(c>>>0<4294967280){d:{if(Cl(c)){ie(a,c);break d}g=nh(c)+1|0;b=vc(g);wd(a,b);ff(a,g);Hd(a,c);a=b}while(1){if((e|0)!=(f|0)){xd(a,w[e|0]);a=a+1|0;e=e+1|0;continue}break}xd(a,0);break c}hf();L()}wP(d,b,c);v[23540]=0;R(50,a|0,d|0);a=v[23540];v[23540]=0;if((a|0)==1){break b}Nc(d)}kb=d+16|0;break a}a=P()|0;O()|0;Nc(d);T(a|0);L()}}function gF(a,b,c,d){var e=0,f=C(0);v[23540]=0;Y(946,a|0);e=v[23540];v[23540]=0;if((e|0)!=1){a=v[v[a+24>>2]+24>>2];a:{if((b|0)<0|x[a+480188>>1]<=b>>>0){break a}a=a+B(b,872)|0;if(!(t[a+1075081|0]&1)){break a}f=C(C(w[a+d|0])*C(.0078125))}return f}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,c|0,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)!=1){$();return C(0)}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function e6(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;v[23540]=0;Y(971,a|0);d=v[23540];v[23540]=0;e=1;a:{b:{if((d|0)!=1){d=v[a+28>>2];f=v[v[d>>2]+64>>2];v[23540]=0;U(f|0,d|0,b|0,(c|0)!=0|0);b=v[23540];v[23540]=0;if((b|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,6663,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)==1){break a}$();e=0}return e|0}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function c6(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;v[23540]=0;Y(971,a|0);d=v[23540];v[23540]=0;e=1;a:{b:{if((d|0)!=1){d=v[a+28>>2];f=v[v[d>>2]+56>>2];v[23540]=0;U(f|0,d|0,b|0,(c|0)!=0|0);b=v[23540];v[23540]=0;if((b|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,6717,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)==1){break a}$();e=0}return e|0}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function Yea(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=kb+-64|0;kb=c;Am(c+48|0,b);re(c+16|0,v[c+48>>2],v[c+52>>2]);b=ee(c+8|0);d=v[b+4>>2];b=v[b>>2];v[23540]=0;b=Eg(166,c+24|0,v[c+16>>2],v[c+20>>2],b,d);d=v[23540];v[23540]=0;a:{if((d|0)!=1){d=Tb(a);a=v[c+52>>2];e=v[c+48>>2];v[23540]=0;U(704,b|0,d|0,fd(e,a)>>>2|0);a=v[23540];v[23540]=0;if((a|0)==1){a=P()|0;O()|0;wc(d);Bb(b);break a}Bb(b);ic(c+48|0);kb=c- -64|0;return}a=P()|0;O()|0}ic(c+48|0);T(a|0);L()}function Xea(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=kb+-64|0;kb=c;Am(c+48|0,b);re(c+16|0,v[c+48>>2],v[c+52>>2]);b=ee(c+8|0);d=v[b+4>>2];b=v[b>>2];v[23540]=0;b=Eg(166,c+24|0,v[c+16>>2],v[c+20>>2],b,d);d=v[23540];v[23540]=0;a:{if((d|0)!=1){d=Tb(a);a=v[c+52>>2];e=v[c+48>>2];v[23540]=0;U(705,b|0,d|0,fd(e,a)>>>8|0);a=v[23540];v[23540]=0;if((a|0)==1){a=P()|0;O()|0;Nt(d);Bb(b);break a}Bb(b);ic(c+48|0);kb=c- -64|0;return}a=P()|0;O()|0}ic(c+48|0);T(a|0);L()}function Wea(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=kb+-64|0;kb=c;Am(c+48|0,b);re(c+16|0,v[c+48>>2],v[c+52>>2]);b=ee(c+8|0);d=v[b+4>>2];b=v[b>>2];v[23540]=0;b=Eg(166,c+24|0,v[c+16>>2],v[c+20>>2],b,d);d=v[23540];v[23540]=0;a:{if((d|0)!=1){d=Tb(a);a=v[c+52>>2];e=v[c+48>>2];v[23540]=0;U(706,b|0,d|0,fd(e,a)>>>4|0);a=v[23540];v[23540]=0;if((a|0)==1){a=P()|0;O()|0;Bm(d);Bb(b);break a}Bb(b);ic(c+48|0);kb=c- -64|0;return}a=P()|0;O()|0}ic(c+48|0);T(a|0);L()}function Mda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;b=kb-16|0;kb=b;g=v[a+24>>2];h=v[a+20>>2];i=v[a+16>>2];e=v[a+4>>2];v[b+8>>2]=v[a>>2];v[b+12>>2]=e;j=v[a+8>>2];k=v[a+12>>2];while(1){if(d){f=(v[b+12>>2]<<1)+i|0;e=u[f>>1];e=e+((B(u[f+2>>1]-e|0,v[b+8>>2]>>>18|0)|0)/16384|0)|0;v[c>>2]=v[c>>2]+B(e,h);v[c+4>>2]=v[c+4>>2]+B(e,g);Rb(b+8|0,j,k);c=c+8|0;d=d-1|0;continue}break}c=v[b+12>>2];v[a>>2]=v[b+8>>2];v[a+4>>2]=c;kb=b+16|0}function Ffa(a,b){a=a|0;b=b|0;var c=0,d=0;d=kb-32|0;kb=d;nd(b,0);kB(d,a+1|0);c=d+16|0;Fc(c,d);Be(b+43|0,c);zb(c);v[b+24>>2]=w[a+78|0]|w[a+79|0]<<8;c=w[a+58|0]|w[a+59|0]<<8|(w[a+60|0]<<16|w[a+61|0]<<24);v[b>>2]=c;v[b+4>>2]=w[a+62|0]|w[a+63|0]<<8|(w[a+64|0]<<16|w[a+65|0]<<24);v[b+8>>2]=w[a+66|0]|w[a+67|0]<<8|(w[a+68|0]<<16|w[a+69|0]<<24);u[b+30>>1]=(w[a+73|0]<<1)+2;u[b+34>>1]=x[b+34>>1]&65533|w[a|0]>>>6&2;xc(b+8|0,c);xc(b+4|0,v[b+8>>2]);kb=d+32|0}function $ea(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=kb+-64|0;kb=c;Am(c+48|0,b);re(c+16|0,v[c+48>>2],v[c+52>>2]);b=ee(c+8|0);d=v[b+4>>2];b=v[b>>2];v[23540]=0;b=Eg(166,c+24|0,v[c+16>>2],v[c+20>>2],b,d);d=v[23540];v[23540]=0;a:{if((d|0)!=1){d=Tb(a);a=v[c+52>>2];e=v[c+48>>2];v[23540]=0;U(703,b|0,d|0,fd(e,a)>>>5|0);a=v[23540];v[23540]=0;if((a|0)==1){a=P()|0;O()|0;Ei(d);Bb(b);break a}Bb(b);ic(c+48|0);kb=c- -64|0;return}a=P()|0;O()|0}ic(c+48|0);T(a|0);L()}function E3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;d=kb-16|0;kb=d;a:{g=v[c+12>>2];if(!g){break a}e=Bh(d,c+16|0);f=Hb(b);h=f-1|0;c=0;while(1){if((c|0)==(f|0)){zb(e);break a}b:{c:{if(!c|(c>>>0)%(g>>>0)){break c}if((c|0)==(h|0)){if(w[Tc(b,0)|0]==43){break c}if(w[Tc(b,0)|0]==45){break c}}v[23540]=0;W(77,b|0,f-c|0,e|0)|0;i=v[23540];v[23540]=0;if((i|0)==1){break b}}c=c+1|0;continue}break}a=P()|0;O()|0;zb(e);T(a|0);L()}ad(a,b);kb=d+16|0}function CC(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=v[a>>2];c=Rc(d,v[a+4>>2]);if(c>>>0<b>>>0){e=kb-32|0;kb=e;b=b-c|0;c=v[Gb(a)>>2];d=v[a+4>>2];a:{if(b>>>0<=c-d>>1>>>0){vC(a,b);break a}c=Gb(a);c=Nj(e+8|0,Oj(a,Rc(v[a>>2],d)+b|0),Rc(v[a>>2],v[a+4>>2]),c);f=kb-16|0;kb=f;b=Qo(f,c+8|0,b);d=v[b>>2];while(1){if(v[b+4>>2]!=(d|0)){uC(d);d=v[b>>2]+2|0;v[b>>2]=d;continue}break}Ud(b);kb=f+16|0;Fd(a,c);Ni(c)}kb=e+32|0;return}if(b>>>0<c>>>0){Od(a,d+(b<<1)|0)}}function hF(a,b,c,d){var e=0,f=C(0);v[23540]=0;Y(946,a|0);e=v[23540];v[23540]=0;if((e|0)!=1){a=v[v[a+24>>2]+24>>2];a:{if((b|0)<0|x[a+480188>>1]<=b>>>0){break a}a=a+B(b,872)|0;if(t[a+1075081|0]&1){break a}f=C(C(w[a+d|0])*C(.0078125))}return f}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,c|0,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)!=1){$();return C(0)}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function oc(a,b){var c=0,d=0,e=0;c=v[a+1396>>2];if((c|0)>=0){a:{b:{if((b|0)<=(c|0)){break b}if((b|0)>24){return oc(a,24)+(oc(a,b-24|0)<<24)|0}if(!c){v[a+1392>>2]=0}while(1){if((b|0)<=(c|0)){break b}c=-1;e=ps(a);d=0;if((e|0)==-1){break a}d=v[a+1396>>2];c=d+8|0;v[a+1396>>2]=c;v[a+1392>>2]=v[a+1392>>2]+(e<<d);continue}}if((b|0)>(c|0)){aa(10096,13179,1632,6833);L()}d=v[a+1392>>2];v[a+1392>>2]=d>>>b;c=c-b|0;d=d&(-1<<b^-1)}v[a+1396>>2]=c}return d}function gg(a){var b=0,c=0,d=0;d=Bp(Pg(a)+1|0,1);if(d){a:{c=d;b:{if((c^a)&3){b=w[a|0];break b}if(a&3){while(1){b=w[a|0];t[c|0]=b;if(!b){break a}c=c+1|0;a=a+1|0;if(a&3){continue}break}}b=v[a>>2];if((b^-1)&b-16843009&-2139062144){break b}while(1){v[c>>2]=b;b=v[a+4>>2];c=c+4|0;a=a+4|0;if(!(b-16843009&(b^-1)&-2139062144)){continue}break}}t[c|0]=b;if(!(b&255)){break a}while(1){b=w[a+1|0];t[c+1|0]=b;c=c+1|0;a=a+1|0;if(b){continue}break}}}return d}function Ls(a){var b=0,c=0,d=0,e=0;a:{while(1){if(!a){b=0;if(v[23536]){b=Ls(v[23536])}if(!v[23460]){break a}c=b|c;a=v[23460];continue}break}d=v[a+76>>2]>=0;b:{c:{if(v[a+20>>2]==v[a+28>>2]){break c}ob[v[a+36>>2]](a,0,0)|0;if(v[a+20>>2]){break c}b=-1;if(d){break b}break a}b=v[a+8>>2];e=v[a+4>>2];if((b|0)!=(e|0)){b=e-b|0;ob[v[a+40>>2]](a,b,b>>31,1)|0}b=0;v[a+28>>2]=0;v[a+16>>2]=0;v[a+20>>2]=0;v[a+4>>2]=0;v[a+8>>2]=0;if(!d){break a}}}return b|c}function Jk(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;e=kb-16|0;kb=e;v[b>>2]=0;v[b+4>>2]=0;t[e+15|0]=0;Oh(a,e+15|0);c=w[e+15|0];f=(c&252)>>>2|0;i=-1<<(c&3)^-1;while(1){v[b>>2]=f;v[b+4>>2]=d;if(!g&(h|0)==(i|0)){kb=e+16|0}else{t[e+15|0]=0;Oh(a,e+15|0);c=v[b>>2];j=v[b+4>>2];f=w[e+15|0];d=g;g=h+1|0;d=g?d:d+1|0;h=g;g=d;k=c;d=(h<<3)-2|0;c=d&31;if((d&63)>>>0>=32){d=f<<c;c=0}else{d=(1<<c)-1&f>>>32-c;c=f<<c}f=k|c;d=d|j;continue}break}}function kM(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;e=kb-16|0;kb=e;d=bd(a);a:{b:{c:{f=Th(b,c);if(d>>>0<f>>>0){if(Xs(a,b)){break c}g=d;h=f-d|0;d=Hb(a);rm(a,g,h,d,0,d,0)}d=Ac(a);while(1){if((b|0)==(c|0)){break b}we(d,b);b=b+1|0;d=d+1|0;continue}}b=Vh(e,b,c);c=Mc(b);d=Hb(b);v[23540]=0;U(57,a|0,c|0,d|0);c=v[23540];v[23540]=0;if((c|0)!=1){zb(b);break a}a=P()|0;O()|0;zb(b);T(a|0);L()}t[e+15|0]=0;we(d,e+15|0);Sh(a,f)}kb=e+16|0;return a|0}function gM(a,b,c,d,e,f,g,h){var i=0,j=0;i=kb-16|0;kb=i;v[i+12>>2]=d;a:{if(!(w[a+12|0]|w[a+13|0]<<8|(w[a+14|0]<<16|w[a+15|0]<<24))){break a}v[i+8>>2]=w[a+8|0]|w[a+9|0]<<8|(w[a+10|0]<<16|w[a+11|0]<<24);j=b;b=v[Kb(i+8|0,i+12|0)>>2];v[j>>2]=b;b=Ed(w[a+12|0]|w[a+13|0]<<8|(w[a+14|0]<<16|w[a+15|0]<<24),b,d);v[c>>2]=((h^1)&b>>>0<d>>>0)+b;b=x[e>>1]|f;u[e>>1]=b;if((w[a+4|0]|w[a+5|0]<<8|(w[a+6|0]<<16|w[a+7|0]<<24))!=1){break a}u[e>>1]=b|g}kb=i+16|0}function $w(a,b){a:{if(a){if(b>>>0<=127){break a}b:{if(!v[v[116042]>>2]){if((b&-128)==57216){break a}break b}if(b>>>0<=2047){t[a+1|0]=b&63|128;t[a|0]=b>>>6|192;return 2}if(!((b&-8192)!=57344&b>>>0>=55296)){t[a+2|0]=b&63|128;t[a|0]=b>>>12|224;t[a+1|0]=b>>>6&63|128;return 3}if(b-65536>>>0<=1048575){t[a+3|0]=b&63|128;t[a|0]=b>>>18|240;t[a+2|0]=b>>>6&63|128;t[a+1|0]=b>>>12&63|128;return 4}}v[116016]=25;a=-1}else{a=1}return a}t[a|0]=b;return 1}function o6(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=kb-32|0;kb=e;v[e+24>>2]=c;c=v[eg(e+16|0,e+24|0)>>2];v[23540]=0;f=v[b+12>>2];v[e+8>>2]=v[b+8>>2];v[e+12>>2]=f;f=v[b+4>>2];v[e>>2]=v[b>>2];v[e+4>>2]=f;fa(940,a+8|0,e|0,c|0,d|0)|0;b=v[23540];v[23540]=0;if((b|0)!=1){a=WI(a);b=VI(a+88|0);c=UI(a+92|0);d=TI(a+96|0);v[a>>2]=62504;v[b>>2]=62620;v[c>>2]=62700;v[d>>2]=62740;De(e+24|0);kb=e+32|0;return a|0}a=P()|0;O()|0;De(e+24|0);T(a|0);L()}function a6(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0;v[23540]=0;Y(971,a|0);d=v[23540];v[23540]=0;e=1;a:{b:{if((d|0)!=1){d=v[a+28>>2];f=v[v[d>>2]+48>>2];v[23540]=0;ta(f|0,d|0,b|0,+c);b=v[23540];v[23540]=0;if((b|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,11667,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)==1){break a}$();e=0}return e|0}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function Zea(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;c=kb-4096|0;kb=c;Am(a,b);a:while(1){if(fd(v[a>>2],v[a+4>>2])>>>12>>>0>e>>>0){f=e<<12;b=0;d=0;while(1)if((b|0)==2048){g=f|2048;b=0;while(1){if((b|0)!=2048){h=Lb(v[a>>2],b+g|0);i=Lb(c,b<<1);d=w[h|0]+d|0;t[i|0]=d;b=b+1|0;continue}break}qh(c,vQ(c),Rf(Fb(v[a>>2]),f));e=e+1|0;continue a}else{g=Lb(v[a>>2],b+f|0);h=Lb(c,b<<1|1);d=w[g|0]+d|0;t[h|0]=d;b=b+1|0;continue}}break}kb=c+4096|0}function S5(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0;v[23540]=0;Y(971,a|0);d=v[23540];v[23540]=0;e=1;a:{b:{if((d|0)!=1){d=v[a+28>>2];f=v[v[d>>2]+96>>2];v[23540]=0;ta(f|0,d|0,b|0,+c);b=v[23540];v[23540]=0;if((b|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,11605,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)==1){break a}$();e=0}return e|0}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function Q5(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0;v[23540]=0;Y(971,a|0);d=v[23540];v[23540]=0;e=1;a:{b:{if((d|0)!=1){d=v[a+28>>2];f=v[v[d>>2]+88>>2];v[23540]=0;ta(f|0,d|0,b|0,+c);b=v[23540];v[23540]=0;if((b|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,11056,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)==1){break a}$();e=0}return e|0}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function aca(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=v[a>>2];d=rg(e,v[a+4>>2]);if(d>>>0<b>>>0){e=kb-32|0;kb=e;a:{b:{d=b-d|0;b=v[Gb(a)>>2];f=v[a+4>>2];c:{if(d>>>0<=b-f>>5>>>0){Az(a,d,c);break c}b=Gb(a);b=Ct(e+8|0,gq(a,rg(v[a>>2],f)+d|0),rg(v[a>>2],v[a+4>>2]),b);v[23540]=0;U(757,b|0,d|0,c|0);c=v[23540];v[23540]=0;if((c|0)==1){break b}eP(a,b);yz(b)}kb=e+32|0;break a}a=P()|0;O()|0;yz(b);T(a|0);L()}return}if(b>>>0<d>>>0){gP(a,e+(b<<5)|0)}}function Qi(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=v[a>>2];c=fd(d,v[a+4>>2]);if(c>>>0<b>>>0){e=kb-32|0;kb=e;b=b-c|0;c=v[Gb(a)>>2];d=v[a+4>>2];a:{if(b>>>0<=c-d>>>0){vE(a,b);break a}c=Gb(a);c=Xl(e+8|0,Vl(a,fd(v[a>>2],d)+b|0),fd(v[a>>2],v[a+4>>2]),c);f=kb-16|0;kb=f;b=Wv(f,c+8|0,b);d=v[b>>2];while(1){if(v[b+4>>2]!=(d|0)){uE(d);d=v[b>>2]+1|0;v[b>>2]=d;continue}break}Ud(b);kb=f+16|0;Fd(a,c);Wl(c)}kb=e+32|0;return}if(b>>>0<c>>>0){Od(a,b+d|0)}}function Yga(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;v[a>>2]=0;v[a+4>>2]=0;Gc(a+8|0);if(b){if(th(178956970)>>>0<b>>>0){cd();L()}d=B(b,24);c=vc(d);v[a>>2]=c;v[a+4>>2]=c;g=Gb(a),h=c+d|0,v[g>>2]=h;d=kb-16|0;kb=d;b=oE(d,a,b);c=v[b+4>>2];e=v[b+8>>2];a:{while(1){if((c|0)==(e|0)){break a}v[23540]=0;Y(576,c|0);f=v[23540];v[23540]=0;if((f|0)!=1){c=c+24|0;v[b+4>>2]=c;continue}break}a=P()|0;O()|0;lc(b);T(a|0);L()}lc(b);kb=d+16|0}return a|0}function Via(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;g=kb-32|0;kb=g;a:{if(x[a+480192>>1]<b>>>0){break a}b=v[((b<<2)+a|0)+900380>>2];if(!b){break a}h=g+16|0;TT(h,b);i=g,j=Fb(v[g+16>>2]),v[i+8>>2]=j;h=Zf(h);while(1){b=v[g+8>>2];if(Pb(b,h)){b=x[so(b)>>1];if(b>>>0<=x[a+480190>>1]){b=B(b,104)+a|0;t[b+484421|0]=f;t[b+484418|0]=c;t[b+484420|0]=e;t[b+484419|0]=d}Kg(g+8|0);continue}else{qu(g+16|0)}break}}kb=g+32|0}function sO(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;e=kb-16|0;kb=e;j=e,k=Aj(b),v[j>>2]=k;c=kb-16|0;kb=c;f=kz(a,c+12|0,x[b>>1],v[b+4>>2]);b=v[f>>2];if(!b){b=kb-16|0;kb=b;d=jc(a);g=lh(c,vc(36),mh(b+8|0,d));d=v[g>>2]+16|0;h=v[e>>2];i=v[h+4>>2];v[d>>2]=v[h>>2];v[d+4>>2]=i;Tb(d+8|0);j=jc(g),k=1,t[j+4|0]=k;kb=b+16|0;Jg(a,v[c+12>>2],f,v[c>>2]);b=ce(c);xO(c);d=1}Ig(e+8|0,v[fc(c,b)>>2],d);kb=c+16|0;a=vd(v[e+8>>2]);kb=e+16|0;return a+8|0}function s4(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;h=kb-16|0;kb=h;a:{b:{c:{if(g?!f|(!d|!e):1){a=ba(8)|0;v[23540]=0;b=Q(55,h|0,8229)|0;c=v[23540];v[23540]=0;if((c|0)==1){break c}a=tc(a,b);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break a}d=P()|0;O()|0;zb(b);break b}dl(a,b,4);c=ux(a,c,d,e,f,g);A[a+16>>3]=A[a+16>>3]+ +(c>>>0)/+(b|0);kb=h+16|0;return c|0}d=P()|0;O()|0;ca(a|0)}T(d|0)}L()}function Y4(a,b){a=a|0;b=b|0;var c=0,d=0;v[23540]=0;Y(946,a|0);c=v[23540];v[23540]=0;if((c|0)!=1){a=v[v[a+24>>2]+24>>2];c=0;a:{if(!ss(b)){break a}d=v[a+484344>>2];if(!xe(d,v[a+484348>>2],b&65535)){break a}c=v[_b(d,b)+12>>2]}return c|0}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,6627,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)!=1){$();return 0}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function G4(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;h=kb-16|0;kb=h;a:{b:{c:{if(g?!f|(!d|!e):1){a=ba(8)|0;v[23540]=0;b=Q(55,h|0,8229)|0;c=v[23540];v[23540]=0;if((c|0)==1){break c}a=tc(a,b);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break a}d=P()|0;O()|0;zb(b);break b}dl(a,b,4);c=tx(a,c,d,e,f,g);A[a+16>>3]=A[a+16>>3]+ +(c>>>0)/+(b|0);kb=h+16|0;return c|0}d=P()|0;O()|0;ca(a|0)}T(d|0)}L()}function YS(a,b){var c=0,d=0,e=0,f=0;d=v[a>>2];c=uc(d,v[a+4>>2]);if(c>>>0<b>>>0){e=kb-32|0;kb=e;b=b-c|0;c=v[Gb(a)>>2];d=v[a+4>>2];a:{if(b>>>0<=c-d>>2>>>0){FA(a,b);break a}c=Gb(a);c=Vf(e+8|0,qg(a,uc(v[a>>2],d)+b|0),uc(v[a>>2],v[a+4>>2]),c);f=kb-16|0;kb=f;b=Xm(f,c+8|0,b);d=v[b>>2];while(1){if(v[b+4>>2]!=(d|0)){Pm(d);d=v[b>>2]+4|0;v[b>>2]=d;continue}break}Ud(b);kb=f+16|0;Fd(a,c);Uf(c)}kb=e+32|0;return}if(b>>>0<c>>>0){Od(a,d+(b<<2)|0)}}function Kea(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;c=kb-16|0;kb=c;d=Zc(c+8|0,16,1,1,0);v[c+4>>2]=0;nd(a,0);zc(b);a:{b:{if(Uq(b,13780)){dd(b,12);if(!Do(b)){Mo(d,2)}dd(b,24);break b}if(Hh(b,13652)){zc(b);v[c+4>>2]=4;e=1;break a}xd(d,8)}e=0}f=a,g=(cf(b)>>>0)/(B(w[d|0],qq(w[d+1|0]))>>>3>>>0)|0,v[f>>2]=g;b=wg(d,a,b);if(!(!b|!e)){d=v[a+20>>2];f=c,g=Ij(v[a>>2],x[a+34>>1]),v[f>>2]=g;Ub(d,0,v[Kb(c+4|0,c)>>2])}kb=c+16|0;return(b|0)!=0|0}function AG(a,b,c,d){var e=0,f=0,g=0,h=0;e=kb-16|0;kb=e;a:{b:{if((a|0)!=(b|0)){c:{d:{f=w[a|0];if((f|0)!=45){break d}a=a+1|0;if((b|0)!=(a|0)){break d}break c}h=v[116016];v[116016]=0;Gd();a=Dw(a,e+12|0,d);d=nb;g=v[116016];e:{if(g){if(v[e+12>>2]!=(b|0)){break c}if((g|0)==68|d){break e}break b}v[116016]=h;if((b|0)!=v[e+12>>2]){break c}if(!d){break b}}v[c>>2]=4;a=-1;break a}}v[c>>2]=4;a=0;break a}a=(f|0)==45?0-a|0:a}kb=e+16|0;return a}function wP(a,b,c){a:{switch(b|0){case 0:ih(a,0,c);return;case 1:ih(a,1,c);return;case 2:ih(a,2,c);return;case 3:ih(a,3,c);return;case 4:ih(a,4,c);return;case 5:ih(a,5,c);return;case 6:dP(a,23760,c);return;case 7:dP(a,24784,c);return;case 8:ih(a,6,c);return;case 9:ih(a,7,c);return;case 10:ih(a,8,c);return;case 11:ih(a,9,c);return;case 12:ih(a,10,c);return;case 13:ih(a,11,c);return;case 14:ih(a,12,c);return;default:break a}}Nb(a)}function gX(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=kb-16|0;kb=e;v[e+4>>2]=1;k=e,l=vc(32),v[k+8>>2]=l;f=Wo(v[e+8>>2]);v[f>>2]=43032;i=Cc(f);f=kb-16|0;kb=f;g=Nl(f+8|0,v[b>>2],v[b+4>>2]);h=v[g>>2];j=v[c>>2];d=v[d>>2];b=kb-16|0;kb=b;g=v[g+4>>2];v[b+12>>2]=g;v[b+8>>2]=h;c=fn(i);v[c>>2]=43168;Nl(c+4|0,h,g);v[c+16>>2]=d;v[c+12>>2]=j;le(b+8|0);kb=b+16|0;kb=f+16|0;b=a;a=Yo(e);Xo(b,Cc(a),a);gn(e);kb=e+16|0}function LU(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;b=v[a+1064>>2];a:{while(1){if((b|0)>255){break a}f=(B(b,6)+a|0)+1072|0,g=Hk(a,7),t[f|0]=g;d=Hk(a,1);e=Hk(a,1);c=v[a+1060>>2];if((c|0)>255){break a}b=v[a+1064>>2]+1|0;v[a+1060>>2]=b;v[a+1064>>2]=b;b:{if(d){u[(B(c,6)+a|0)+1068>>1]=b;LU(a);b=v[a+1064>>2];break b}u[(B(c,6)+a|0)+1068>>1]=65535}v[a+1060>>2]=b;if(e){u[(B(c,6)+a|0)+1070>>1]=b;continue}break}u[(B(c,6)+a|0)+1070>>1]=65535}}function Bha(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=v[a>>2];c=Bf(d,v[a+4>>2]);if(c>>>0<b>>>0){d=kb-32|0;kb=d;a:{b:{c=b-c|0;b=v[Gb(a)>>2];e=v[a+4>>2];c:{if(c>>>0<=(b-e|0)/20>>>0){zC(a,c);break c}b=Gb(a);b=oB(d+8|0,pB(a,Bf(v[a>>2],e)+c|0),Bf(v[a>>2],v[a+4>>2]),b);v[23540]=0;R(506,b|0,c|0);c=v[23540];v[23540]=0;if((c|0)==1){break b}nB(a,b);uu(b)}kb=d+32|0;break a}a=P()|0;O()|0;uu(b);T(a|0);L()}return}if(b>>>0<c>>>0){xC(a,d+B(b,20)|0)}}function h6(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;v[23540]=0;Y(971,a|0);c=v[23540];v[23540]=0;d=1;a:{b:{if((c|0)!=1){c=v[a+28>>2];e=v[v[c>>2]+76>>2];v[23540]=0;R(e|0,c|0,b|0);b=v[23540];v[23540]=0;if((b|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,11297,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)==1){break a}$();d=0}return d|0}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function U5(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;v[23540]=0;Y(971,a|0);c=v[23540];v[23540]=0;d=1;a:{b:{if((c|0)!=1){c=v[a+28>>2];e=v[v[c>>2]+16>>2];v[23540]=0;R(e|0,c|0,b|0);b=v[23540];v[23540]=0;if((b|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,12768,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)==1){break a}$();d=0}return d|0}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function P5(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;v[23540]=0;Y(971,a|0);c=v[23540];v[23540]=0;d=1;a:{b:{if((c|0)!=1){c=v[a+28>>2];e=v[v[c>>2]+84>>2];v[23540]=0;R(e|0,c|0,b|0);b=v[23540];v[23540]=0;if((b|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,12251,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)==1){break a}$();d=0}return d|0}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function O5(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;v[23540]=0;Y(971,a|0);c=v[23540];v[23540]=0;d=1;a:{b:{if((c|0)!=1){c=v[a+28>>2];e=v[v[c>>2]+80>>2];v[23540]=0;R(e|0,c|0,b|0);b=v[23540];v[23540]=0;if((b|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,11146,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)==1){break a}$();d=0}return d|0}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function N5(a,b){a=a|0;b=+b;var c=0,d=0,e=0;v[23540]=0;Y(971,a|0);c=v[23540];v[23540]=0;d=1;a:{b:{if((c|0)!=1){c=v[a+28>>2];e=v[v[c>>2]+104>>2];v[23540]=0;oa(e|0,c|0,+b);c=v[23540];v[23540]=0;if((c|0)!=1){break b}}d=V(0)|0;O()|0;_(d|0)|0;v[23540]=0;X(933,15173,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)==1){break a}$();d=0}return d|0}a=P()|0;O()|0;v[23540]=0;Z(18);d=v[23540];v[23540]=0;if((d|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function _5(a,b){a=a|0;b=+b;var c=0,d=0,e=0;v[23540]=0;Y(971,a|0);c=v[23540];v[23540]=0;d=1;a:{b:{if((c|0)!=1){c=v[a+28>>2];e=v[v[c>>2]+40>>2];v[23540]=0;oa(e|0,c|0,+b);c=v[23540];v[23540]=0;if((c|0)!=1){break b}}d=V(0)|0;O()|0;_(d|0)|0;v[23540]=0;X(933,11705,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)==1){break a}$();d=0}return d|0}a=P()|0;O()|0;v[23540]=0;Z(18);d=v[23540];v[23540]=0;if((d|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function V5(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;v[23540]=0;Y(971,a|0);c=v[23540];v[23540]=0;d=1;a:{b:{if((c|0)!=1){c=v[a+28>>2];e=v[v[c>>2]+20>>2];v[23540]=0;R(e|0,c|0,b|0);b=v[23540];v[23540]=0;if((b|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,9341,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)==1){break a}$();d=0}return d|0}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function T5(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;v[23540]=0;Y(971,a|0);c=v[23540];v[23540]=0;a:{b:{if((c|0)!=1){c=v[a+28>>2];e=v[v[c>>2]+100>>2];v[23540]=0;d=+sa(e|0,c|0,b|0);b=v[23540];v[23540]=0;if((b|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,11623,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)==1){break a}$();d=0}return+d}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function AF(a,b,c,d,e,f,g,h){var i=0,j=0,k=0,l=0;i=kb-16|0;kb=i;if(1073741806-b>>>0>=c>>>0){j=Ac(a);k=1073741807;if(b>>>0<=536870886){v[i+8>>2]=b<<1;v[i+12>>2]=b+c;k=am(v[_c(i+12|0,i+8|0)>>2])+1|0}c=Bi(k);if(e){ni(c,j,e)}if(g){ni(c+(e<<2)|0,h,g)}l=e+f|0;h=d-l|0;if((d|0)!=(l|0)){d=e<<2;ni((d+c|0)+(g<<2)|0,(d+j|0)+(f<<2)|0,h)}if((b|0)!=1){Mb(j)}wd(a,c);ff(a,k);b=a;a=h+(e+g|0)|0;Hd(b,a);wd(c+(a<<2)|0,0);kb=i+16|0;return}hf();L()}function A1(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;e=kb-16|0;kb=e;while(1){a:{if((c|0)<=(f|0)){break a}g=v[a+16>>2];d=v[a+12>>2];b:{if(g>>>0>d>>>0){v[e+12>>2]=2147483647;v[e+8>>2]=g-d;v[e+4>>2]=c-f;g=d;d=v[td(e+12|0,td(e+8|0,e+4|0))>>2];b=He(b,g,d);v[a+12>>2]=v[a+12>>2]+d;b=b+d|0;break b}d=ob[v[v[a>>2]+40>>2]](a)|0;if((d|0)==-1){break a}h=b,i=sp(d),t[h|0]=i;d=1;b=b+1|0}f=d+f|0;continue}break}kb=e+16|0;return f|0}function b6(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;v[23540]=0;Y(971,a|0);c=v[23540];v[23540]=0;a:{b:{if((c|0)!=1){c=v[a+28>>2];e=v[v[c>>2]+52>>2];v[23540]=0;d=+sa(e|0,c|0,b|0);b=v[23540];v[23540]=0;if((b|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,11686,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)==1){break a}$();d=0}return+d}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function Y5(a,b){a=a|0;b=+b;var c=0,d=0,e=0;v[23540]=0;Y(971,a|0);c=v[23540];v[23540]=0;d=1;a:{b:{if((c|0)!=1){c=v[a+28>>2];e=v[v[c>>2]+32>>2];v[23540]=0;oa(e|0,c|0,+b);c=v[23540];v[23540]=0;if((c|0)!=1){break b}}d=V(0)|0;O()|0;_(d|0)|0;v[23540]=0;X(933,7737,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)==1){break a}$();d=0}return d|0}a=P()|0;O()|0;v[23540]=0;Z(18);d=v[23540];v[23540]=0;if((d|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function XX(a){a=a|0;var b=0,c=0,d=0,e=0;c=kb-32|0;kb=c;b=yc(c,16805);v[23540]=0;U(120,c+16|0,a|0,b|0);a=v[23540];v[23540]=0;a:{if((a|0)!=1){Ab(b);a=0;b=0;while(1){d=v[c+16>>2];if(!(b>>>0<=3&yd(d,v[c+20>>2])>>>0>b>>>0)){Ql(c+16|0);kb=c+32|0;return a|0}v[23540]=0;d=S(121,Nd(d,b)|0)|0;e=v[23540];v[23540]=0;if((e|0)!=1){a=(d&255)<<24-(b<<3)|a;b=b+1|0;continue}break}a=P()|0;O()|0;Ql(c+16|0);break a}a=P()|0;O()|0;Ab(b)}T(a|0);L()}function W5(a,b){a=a|0;b=+b;var c=0,d=0,e=0;v[23540]=0;Y(971,a|0);c=v[23540];v[23540]=0;d=1;a:{b:{if((c|0)!=1){c=v[a+28>>2];e=v[v[c>>2]+24>>2];v[23540]=0;oa(e|0,c|0,+b);c=v[23540];v[23540]=0;if((c|0)!=1){break b}}d=V(0)|0;O()|0;_(d|0)|0;v[23540]=0;X(933,7685,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)==1){break a}$();d=0}return d|0}a=P()|0;O()|0;v[23540]=0;Z(18);d=v[23540];v[23540]=0;if((d|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function Uq(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=kb-32|0;kb=c;a:{if(!w[b+7|0]){while(1){if((d|0)==7){d=0;t[c+27|0]=0;t[c+28|0]=0;t[c+29|0]=0;t[c+30|0]=0;v[c+24>>2]=0;e=hc(c+8|0,c+24|0,7);nc(c+16|0,v[a>>2],v[a+8>>2],v[e>>2],v[e+4>>2]);b:{if(v[c+20>>2]!=7){break b}if(Sb(c+24|0,b,7)){break b}$b(a,7);d=1}kb=c+32|0;break a}e=b+d|0;d=d+1|0;if(w[e|0]){continue}break}aa(17499,9108,413,13143);L()}aa(17478,9108,411,13143);L()}return d|0}function R5(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;v[23540]=0;Y(971,a|0);c=v[23540];v[23540]=0;a:{b:{if((c|0)!=1){c=v[a+28>>2];e=v[v[c>>2]+92>>2];v[23540]=0;d=+sa(e|0,c|0,b|0);b=v[23540];v[23540]=0;if((b|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,11076,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)==1){break a}$();d=0}return+d}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function JL(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,j=0;d=kb-32|0;kb=d;v[d+16>>2]=c;v[d+24>>2]=b;i=d,j=he(a),v[i+8>>2]=j;c=d+24|0;b=Pn(c,d+8|0);c=Pn(d+16|0,c);a:{if(Hb(a)>>>0>=b>>>0){if((c|0)==-1){DL(a,b);break a}f=a;e=kb-16|0;kb=e;v[e+12>>2]=c;if(c){g=Hb(f);h=Ac(f);c=g-b|0;v[e+8>>2]=c;a=v[Kb(e+12|0,e+8|0)>>2];v[e+12>>2]=a;b:{if((a|0)==(c|0)){a=c;break b}b=b+h|0;Yh(b,a+b|0,c-a|0)}Ux(f,h,g-a|0)}kb=e+16|0;break a}sk();L()}kb=d+32|0}function aea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;b=kb-16|0;kb=b;i=v[a+16>>2];f=Tf(1,2);g=nb;Rb(a,f,g);j=v[a+24>>2];k=v[a+20>>2];e=v[a+4>>2];v[b+8>>2]=v[a>>2];v[b+12>>2]=e;e=v[a+8>>2];l=v[a+12>>2];while(1){if(d){h=u[(v[b+12>>2]<<1)+i>>1];v[c>>2]=v[c>>2]+B(h,k);v[c+4>>2]=v[c+4>>2]+B(j,h);Rb(b+8|0,e,l);c=c+8|0;d=d-1|0;continue}break}c=v[b+12>>2];v[a>>2]=v[b+8>>2];v[a+4>>2]=c;mg(a,f,g);kb=b+16|0}function NQ(a){var b=0,c=0,d=0;b=kb-16|0;kb=b;v[b+4>>2]=((w[a+48|0]|w[a+49|0]<<8)<<1)+((w[a+32|0]|w[a+33|0]<<8)<<4);v[b+8>>2]=((w[a+50|0]|w[a+51|0]<<8)<<1)+((w[a+34|0]|w[a+35|0]<<8)<<4);v[b+12>>2]=(B(w[a+52|0]|w[a+53|0]<<8,5)+((w[a+36|0]|w[a+37|0]<<8)<<4)|0)+32;a=b+4|0;d=Eb(a,3);a:{if((a|0)==(d|0)){break a}c=a;while(1){c=c+4|0;if((d|0)==(c|0)){break a}a=np(v[a>>2],v[c>>2])?c:a;continue}}kb=b+16|0;a=v[a>>2];nb=a>>31;return a}function Js(a,b){var c=0,d=0,e=0,f=0,g=0;e=kb-16|0;kb=e;c=Td(a);d=jc(a);f=kb-16|0;kb=f;while(1){if(c){g=ot(c+16|0,b);d=g?d:c;c=v[(g?c+4|0:c)>>2];continue}break}c=v[fc(f+8|0,d)>>2];kb=f+16|0;a:{if(Pb(c,Zf(a))){if(!ot(b,vd(c))){break a}}c=Zf(a)}if(!pc(c,Zf(a))){b=v[fc(e+8|0,c)>>2];c=kb-16|0;kb=c;d=Kg(fc(c+8|0,b));if((b|0)==v[a>>2]){v[a>>2]=v[d>>2]}d=Gb(a);v[d>>2]=v[d>>2]-1;ML(v[jc(a)>>2],b);kb=c+16|0;wm(vd(b));Mb(b)}kb=e+16|0}function f6(a,b){a=a|0;b=b|0;var c=0,d=0;v[23540]=0;Y(971,a|0);c=v[23540];v[23540]=0;a:{b:{if((c|0)!=1){c=v[a+28>>2];d=v[v[c>>2]+68>>2];v[23540]=0;b=Q(d|0,c|0,b|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,6690,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)==1){break a}$();b=-1}return b|0}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function d6(a,b){a=a|0;b=b|0;var c=0,d=0;v[23540]=0;Y(971,a|0);c=v[23540];v[23540]=0;a:{b:{if((c|0)!=1){c=v[a+28>>2];d=v[v[c>>2]+60>>2];v[23540]=0;b=Q(d|0,c|0,b|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,6741,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)==1){break a}$();b=-1}return b|0}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function nJ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;g=kb-16|0;kb=g;v[g+8>>2]=b;j=g,k=he(a),v[j>>2]=k;b=Pn(g+8|0,g);h=kb-16|0;kb=h;a:{f=Hb(a);if(b>>>0<=f>>>0){if(c){e=bd(a);b:{if(e-f>>>0>=c>>>0){e=Ac(a);if((b|0)==(f|0)){break b}i=b+e|0;Yh(i+c|0,i,f-b|0);break b}rm(a,e,(c+f|0)-e|0,f,b,0,c);e=v[a>>2]}BB(b+e|0,c,d);b=c+f|0;Sh(a,b);t[h+15|0]=0;we(b+e|0,h+15|0)}kb=h+16|0;break a}sk();L()}he(a);kb=g+16|0}function iH(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=kb-48|0;kb=e;v[e+44>>2]=c;v[e+40>>2]=b;b=Kc(e+8|0,d);v[23540]=0;U(1104,e+24|0,e+40|0,b|0);c=v[23540];v[23540]=0;a:{b:{if((c|0)!=1){v[23540]=0;a=Q(1105,a|0,e+24|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break b}zb(e+24|0);zb(b);v[a>>2]=92028;b=v[e+44>>2];v[a+8>>2]=v[e+40>>2];v[a+12>>2]=b;kb=e+48|0;return a|0}c=P()|0;O()|0;break a}c=P()|0;O()|0;zb(e+24|0)}zb(b);T(c|0);L()}function vg(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;d=kb-16|0;kb=d;u[d+12>>1]=65535;u[d+14>>1]=b;f=d+12|0;b=x[Wc(43020,d+14|0)>>1];e=v[a>>2];c=Rc(e,v[a+4>>2]);a:{if(b>>>0>c>>>0){e=kb-32|0;kb=e;b=b-c|0;c=v[Gb(a)>>2];g=v[a+4>>2];b:{if(b>>>0<=c-g>>1>>>0){Jo(a,b,f);break b}c=Gb(a);c=Nj(e+8|0,Oj(a,Rc(v[a>>2],g)+b|0),Rc(v[a>>2],v[a+4>>2]),c);NC(c,b,f);Fd(a,c);Ni(c)}kb=e+32|0;break a}if(b>>>0<c>>>0){Od(a,e+(b<<1)|0)}}kb=d+16|0}function q8(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;a=vi(a,b,c,d);v[a>>2]=45220;c=Tb(a+4256|0);b=a+4208|0;e=Eb(b,0),f=1056964608,v[e>>2]=f;e=Eb(b,1),f=1017370378,v[e>>2]=f;e=Eb(b,2),f=1028670828,v[e>>2]=f;e=Eb(b,3),f=1059760811,v[e>>2]=f;e=Eb(b,4),f=1017370378,v[e>>2]=f;e=Eb(b,5),f=1065353216,v[e>>2]=f;v[23540]=0;R(897,a+44|0,2);b=v[23540];v[23540]=0;if((b|0)!=1){ui(a);return a|0}b=P()|0;O()|0;wc(c);If(a);T(b|0);L()}function bea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;b=kb-16|0;kb=b;i=v[a+16>>2];f=Tf(1,2);g=nb;Rb(a,f,g);j=v[a+24>>2];k=v[a+20>>2];e=v[a+4>>2];v[b+8>>2]=v[a>>2];v[b+12>>2]=e;e=v[a+8>>2];l=v[a+12>>2];while(1){if(d){h=t[v[b+12>>2]+i|0]<<8;v[c>>2]=v[c>>2]+B(h,k);v[c+4>>2]=v[c+4>>2]+B(j,h);Rb(b+8|0,e,l);c=c+8|0;d=d-1|0;continue}break}c=v[b+12>>2];v[a>>2]=v[b+8>>2];v[a+4>>2]=c;mg(a,f,g);kb=b+16|0}function US(a,b,c,d,e){var f=0,g=0,h=0,i=0;h=-1;f=d&2147483647;i=f;g=(f|0)==2147418112;a:{if(g&!c?a|b:g&(c|0)!=0|f>>>0>2147418112){break a}f=e&2147483647;g=(f|0)==2147418112;if(g?0:g&0|f>>>0>2147418112){break a}if(!(a|c|(f|i|b))){return 0}f=d&e;if((f|0)>0|(f|0)>=0){if(!c&(d|0)==(e|0)?0:(d|0)<(e|0)){break a}return(a|c|(d^e|b))!=0}if(!c&(d|0)==(e|0)?a|b:(c|0)!=0&(d|0)>=(e|0)|(d|0)>(e|0)){break a}h=(a|c|(d^e|b))!=0}return h}function Q6(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;d=kb-16|0;kb=d;if(a){a=rc(d+8|0,a);e=v[a+4>>2];f=v[a>>2];b=kb-16|0;kb=b;a=0;a:{if(!e){break a}a=32288;while(1){if((a|0)==32688){c=32688;while(1){a=c;if((a|0)!=32736){c=a+12|0;if(!oM(f,e,v[rc(b,v[a+8>>2])>>2],v[b+4>>2])){continue}}break}a=(a|0)!=32736;break a}c=v[a+4>>2];a=a+8|0;if(!oM(f,e,v[rc(b+8|0,c)>>2],v[b+12>>2])){continue}break}a=1}kb=b+16|0}else{a=0}kb=d+16|0;return a|0}function j_(a){a=a|0;if(w[468224]){return v[117055]}if(!w[468744]){a=468576;while(1){a=Nb(a)+12|0;if((a|0)!=468744){continue}break}t[468744]=1}qd(468576,88700);qd(468588,88728);qd(468600,88756);qd(468612,88788);qd(468624,88828);qd(468636,88864);qd(468648,88892);qd(468660,88928);qd(468672,88944);qd(468684,88960);qd(468696,88976);qd(468708,88992);qd(468720,89008);qd(468732,89024);t[468224]=1;v[117055]=468576;return 468576}function f4(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;b=kb-32|0;kb=b;v[b+24>>2]=e;v[b+28>>2]=f;a:{e=a;a=hc(b+16|0,c,d);a=_s(e,v[a>>2],v[a+4>>2],b+24|0);if(a+1>>>0>=3){a=ba(8)|0;v[23540]=0;b=Q(55,b|0,8086)|0;c=v[23540];v[23540]=0;b:{if((c|0)!=1){a=tc(a,b);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break a}c=P()|0;O()|0;zb(b);break b}c=P()|0;O()|0;ca(a|0)}T(c|0);L()}kb=b+32|0;return a|0}L()}function eF(a,b,c,d,e,f,g,h,i){var j=0;v[23540]=0;Y(946,a|0);j=v[23540];v[23540]=0;a:{b:{if((j|0)!=1){j=v[a+24>>2];v[23540]=0;b=ua(i|0,j|0,b|0,c|0,d|0,e|0,f|0,g|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,h|0,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)==1){break a}$();b=0}return b}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function Kfa(a){a=a|0;var b=0,c=0,d=0;b=kb-16|0;kb=b;t[b+15|0]=128;a=Qm(a,127,b+15|0);v[23540]=0;t[b+14|0]=64;d=W(577,a+12|0,127,b+14|0)|0;c=v[23540];v[23540]=0;a:{b:{if((c|0)!=1){v[23540]=0;t[b+13|0]=0;Q(652,a+24|0,b+13|0)|0;c=v[23540];v[23540]=0;if((c|0)==1){break b}v[a+36>>2]=-1;v[a+40>>2]=108855296;v[a+44>>2]=0;v[a+48>>2]=0;u[a+52>>1]=0;kb=b+16|0;return a|0}b=P()|0;O()|0;break a}b=P()|0;O()|0;ic(d)}ic(a);T(b|0);L()}function gI(a){var b=0,c=C(0),d=C(0),e=C(0),f=C(0),g=C(0),h=C(0),i=0,j=0,k=0,l=C(0),m=C(0),n=C(0),o=C(0),p=0;c=z[a>>2];i=a-16|0;d=z[i>>2];e=C(c+d);b=a-8|0;f=z[b>>2];j=a-24|0;g=z[j>>2];h=C(f+g);z[a>>2]=e+h;z[b>>2]=e-h;b=a-12|0;h=z[b>>2];k=a-28|0;l=z[k>>2];e=C(h+l);p=b;b=a-4|0;m=z[b>>2];a=a-20|0;n=z[a>>2];o=C(m+n);z[p>>2]=o-e;f=C(f-g);g=C(m-n);z[k>>2]=f+g;c=C(c-d);d=C(h-l);z[i>>2]=c+d;z[j>>2]=c-d;z[b>>2]=e+o;z[a>>2]=g-f}function h4(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;v[23540]=0;Y(946,a|0);d=v[23540];v[23540]=0;e=1;a:{b:{if((d|0)!=1){d=v[a+24>>2];v[23540]=0;U(1041,d|0,b|0,c|0);b=v[23540];v[23540]=0;if((b|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,10340,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)==1){break a}$();e=0}return e|0}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function Cx(a,b,c,d,e){var f=0,g=0;a:{if(!ss(b)){break a}f=v[a+484344>>2];if(!xe(f,v[a+484348>>2],b&65535)){break a}b=_b(f,b);if(v[b+12>>2]<=(c|0)|e>>>0>5|x[a+480188>>1]<=d>>>0|(c|d)<0){break a}b=jd(v[b>>2],v[v[b+48>>2]+12>>2],c,d&65535);b:{c:{switch(e|0){case 1:b=b+1|0;break b;case 2:b=b+2|0;break b;case 3:b=b+3|0;break b;case 4:b=b+4|0;break b;case 0:break b;case 5:break c;default:break a}}b=b+5|0}g=w[b|0]}return g}function Ae(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0;e=kb-16|0;kb=e;g=Vg(a);a:{b:{if(!b){i=e,j=Vg(a),v[i+8>>2]=j;v[e+12>>2]=0;break b}f=v[b+4>>2];h=v[b>>2];v[e+8>>2]=h;v[e+12>>2]=f;a=v[a+12>>2];v[e>>2]=2048;v[e+4>>2]=0;b=a+c|0;d=a>>>0>b>>>0?d+1|0:d;a=_q(e+8|0,e);c=v[a>>2];a=v[a+4>>2];if(!a&c>>>0>g>>>0|a){a=-1;if(!d&b>>>0<=g>>>0){break b}break a}a=0;if((d|0)==(f|0)&b>>>0>h>>>0|d>>>0>f>>>0){break a}}a=1}kb=e+16|0;return a}function uY(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;v[23540]=0;a=La(1044,a|0,b|0,c|0,d|0)|0;b=v[23540];v[23540]=0;a:{b:{if((b|0)==1){a=V(0)|0;O()|0;_(a|0)|0;v[23540]=0;ia(929,11169,e|0,f|0,g|0,h|0,i|0,j|0);a=v[23540];v[23540]=0;if((a|0)==1){break b}$();a=-255}break a}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}return a|0}function m1(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;e=kb-16|0;kb=e;while(1){a:{if((c|0)<=(g|0)){break a}d=v[a+12>>2];f=v[a+16>>2];b:{if(d>>>0<f>>>0){v[e+12>>2]=2147483647;v[e+8>>2]=f-d>>2;v[e+4>>2]=c-g;f=d;d=v[td(e+12|0,td(e+8|0,e+4|0))>>2];ni(b,f,d);f=d<<2;v[a+12>>2]=f+v[a+12>>2];b=b+f|0;break b}d=ob[v[v[a>>2]+40>>2]](a)|0;if((d|0)==-1){break a}v[b>>2]=d;d=1;b=b+4|0}g=d+g|0;continue}break}kb=e+16|0;return g|0}function pia(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=v[a>>2];d=qk(e,v[a+4>>2]);if(d>>>0<b>>>0){e=kb-32|0;kb=e;d=b-d|0;b=v[Gb(a)>>2];f=v[a+4>>2];a:{if(d>>>0<=(b-f|0)/6>>>0){PA(a,d,c);break a}b=Gb(a);b=iT(e+8|0,JA(a,qk(v[a>>2],f)+d|0),qk(v[a>>2],v[a+4>>2]),b);hT(b,d,c);c=b+4|0;fT(v[a>>2],v[a+4>>2],c);qc(a,c);qc(a+4|0,b+8|0);qc(Gb(a),Cc(b));v[b>>2]=v[b+4>>2];gT(b)}kb=e+32|0;return}if(b>>>0<d>>>0){Od(a,e+B(b,6)|0)}}function l4(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;v[23540]=0;Y(946,a|0);d=v[23540];v[23540]=0;a:{b:{if((d|0)!=1){d=v[a+24>>2];v[23540]=0;e=+ya(1037,d|0,b|0,c|0);b=v[23540];v[23540]=0;if((b|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,5353,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)==1){break a}$();e=0}return+e}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function dW(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;d=kb-16|0;kb=d;v[d+12>>2]=-1;if(zg(a,d+8|0)){v[d+4>>2]=w[d+8|0];f=v[Kb(d+4|0,d+12|0)>>2];c=kb+-64|0;kb=c;e=c+40|0;Of(e,a,f);g=v[c+40>>2];a=c+8|0;cg(a,3,Ie(e),g);v[23540]=0;R(222,c+24|0,a|0);a=v[23540];v[23540]=0;a:{if((a|0)!=1){hc(c,b,11);a=c+24|0;Kl(c,a);zb(a);Uc(c+40|0);kb=c- -64|0;e=!f|(g|0)!=0;break a}a=P()|0;O()|0;Uc(c+40|0);T(a|0);L()}}kb=d+16|0;return e|0}function UE(a,b,c,d,e,f){var g=0,h=0;g=kb-256|0;kb=g;v[g+248>>2]=37;v[g+252>>2]=0;h=g+248|0;Rr(h|1,10606,f,v[b+4>>2]);f=Gd();v[g>>2]=d;v[g+4>>2]=e;d=g+224|0;e=$g(d,24,f,h,g)+d|0;f=Zi(d,e,b);h=g+16|0;gd(h,b);v[23540]=0;ia(1149,d|0,f|0,e|0,g+32|0,g+28|0,g+24|0,h|0);d=v[23540];v[23540]=0;a:{if((d|0)!=1){ac(g+16|0);a=Pr(a,g+32|0,v[g+28>>2],v[g+24>>2],b,c);kb=g+256|0;break a}a=P()|0;O()|0;ac(g+16|0);T(a|0);L()}return a}function DO(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=kb-32|0;kb=d;v[a+4>>2]=0;a:{if(b){b:{if(Bt(a)>>>0>=b>>>0){v[a+4>>2]=b;break b}e=io(d+16|0);v[23540]=0;f=Q(728,a|0,b|0)|0;g=v[23540];v[23540]=0;if((g|0)==1){break a}v[23540]=0;R(729,e|0,f|0);f=v[23540];v[23540]=0;if((f|0)==1){break a}v[e+4>>2]=b;Kt(a,e);We(e)}tl(d+8|0,v[a>>2]);ov(v[d+8>>2],v[d+12>>2],b,w[c|0])}kb=d+32|0;return}a=P()|0;O()|0;We(e);T(a|0);L()}function WE(a,b,c,d,e,f){var g=0,h=0;g=kb-112|0;kb=g;v[g+104>>2]=37;v[g+108>>2]=0;h=g+104|0;Rr(h|1,10606,f,v[b+4>>2]);f=Gd();v[g>>2]=d;v[g+4>>2]=e;d=g+80|0;e=$g(d,24,f,h,g)+d|0;f=Zi(d,e,b);h=g+16|0;gd(h,b);v[23540]=0;ia(1146,d|0,f|0,e|0,g+32|0,g+28|0,g+24|0,h|0);d=v[23540];v[23540]=0;a:{if((d|0)!=1){ac(g+16|0);a=Vq(a,g+32|0,v[g+28>>2],v[g+24>>2],b,c);kb=g+112|0;break a}a=P()|0;O()|0;ac(g+16|0);T(a|0);L()}return a}function $5(a){a=a|0;var b=0,c=0,d=0;v[23540]=0;Y(971,a|0);b=v[23540];v[23540]=0;a:{b:{if((b|0)!=1){b=v[a+28>>2];d=v[v[b>>2]+44>>2];v[23540]=0;c=+la(d|0,b|0);b=v[23540];v[23540]=0;if((b|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,11723,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)==1){break a}$();c=0}return+c}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function fI(a,b){var c=0,d=0,e=0;if(!w[b+21|0]){ec(a,21);return-1}if(v[a+1396>>2]<=9){$k(a)}d=v[a+1392>>2];c=u[(((d&1023)<<1)+b|0)+36>>1];a:{if((c|0)>=0){e=d;d=c&65535;c=w[d+v[b+8>>2]|0];v[a+1392>>2]=e>>>c;c=v[a+1396>>2]-c|0;v[a+1396>>2]=(c|0)>0?c:0;c=(c|0)>=0?d:-1;break a}c=hm(a,b)}if(!((c|0)>=v[b+2092>>2]?w[b+23|0]:0)){if(!(!(v[a+1384>>2]?w[a+1376|0]:1)|(c|0)>=0)){ec(a,21)}return c}aa(7526,13179,1793,5753);L()}function Z5(a){a=a|0;var b=0,c=0,d=0;v[23540]=0;Y(971,a|0);b=v[23540];v[23540]=0;a:{b:{if((b|0)!=1){b=v[a+28>>2];d=v[v[b>>2]+36>>2];v[23540]=0;c=+la(d|0,b|0);b=v[23540];v[23540]=0;if((b|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,7754,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)==1){break a}$();c=0}return+c}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function X5(a){a=a|0;var b=0,c=0,d=0;v[23540]=0;Y(971,a|0);b=v[23540];v[23540]=0;a:{b:{if((b|0)!=1){b=v[a+28>>2];d=v[v[b>>2]+28>>2];v[23540]=0;c=+la(d|0,b|0);b=v[23540];v[23540]=0;if((b|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,7702,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)==1){break a}$();c=0}return+c}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function p4(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;f=kb-16|0;kb=f;a:{b:{c:{if(!(e?d:0)){a=ba(8)|0;v[23540]=0;b=Q(55,f|0,8229)|0;c=v[23540];v[23540]=0;if((c|0)==1){break c}a=tc(a,b);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break a}e=P()|0;O()|0;zb(b);break b}dl(a,b,2);c=ux(a,c,d,e,0,0);A[a+16>>3]=A[a+16>>3]+ +(c>>>0)/+(b|0);kb=f+16|0;return c|0}e=P()|0;O()|0;ca(a|0)}T(e|0)}L()}function E4(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;f=kb-16|0;kb=f;a:{b:{c:{if(!(e?d:0)){a=ba(8)|0;v[23540]=0;b=Q(55,f|0,8229)|0;c=v[23540];v[23540]=0;if((c|0)==1){break c}a=tc(a,b);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break a}e=P()|0;O()|0;zb(b);break b}dl(a,b,2);c=tx(a,c,d,e,0,0);A[a+16>>3]=A[a+16>>3]+ +(c>>>0)/+(b|0);kb=f+16|0;return c|0}e=P()|0;O()|0;ca(a|0)}T(e|0)}L()}function ix(a){var b=0,c=0,d=0;a:{b:{if(!v[a+1384>>2]){b=v[a+1380>>2];if((b|0)==-1){v[a+1388>>2]=v[a+1116>>2]-1;if(!os(a)){v[a+1384>>2]=1;return 0}if(!(t[a+1375|0]&1)){break b}b=v[a+1380>>2]}d=b+1|0;v[a+1380>>2]=d;c=w[(a+b|0)+1120|0];if((c|0)!=255){v[a+1388>>2]=b;v[a+1384>>2]=1}if(v[a+1116>>2]<=(d|0)){v[a+1380>>2]=-1}if(w[a+1376|0]){break a}t[a+1376|0]=c}return c}ec(a,32);return 0}aa(15790,13179,1564,6039);L()}function XZ(a){a=a|0;if(w[468216]){return v[117053]}if(!w[468568]){a=468400;while(1){a=Nb(a)+12|0;if((a|0)!=468568){continue}break}t[468568]=1}pd(468400,5243);pd(468412,5250);pd(468424,5216);pd(468436,5224);pd(468448,5207);pd(468460,5257);pd(468472,5234);pd(468484,9777);pd(468496,9983);pd(468508,11283);pd(468520,12851);pd(468532,5506);pd(468544,10787);pd(468556,6590);t[468216]=1;v[117053]=468400;return 468400}function Tv(a,b,c){var d=0,e=0,f=0,g=0,h=0;e=sd(a);a=Ad(v[a+4>>2],w[a+11|0]);d=sd(b);b=Ad(v[b+4>>2],w[b+11|0]);a:{if(a>>>0>=c>>>0){if(!b){break a}c=c+e|0;a=a+e|0;b=b+d|0;b:{if((b|0)==(d|0)){break b}c:{b=b-d|0;if((b|0)>(a-c|0)){break c}g=1-b|0;h=w[d|0];while(1){f=a-c|0;if((f|0)<(b|0)){break c}c=nu(c,g+f|0,h);if(!c){break c}if(!Qv(c,d,b)){break b}c=c+1|0;continue}}c=a}c=(a|0)==(c|0)?-1:c-e|0}else{c=-1}}return c}function i3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;c=kb-16|0;kb=c;g=v[a+4>>2];v[c+8>>2]=v[b+8>>2];d=v[b+4>>2];v[c>>2]=v[b>>2];v[c+4>>2]=d;iJ(a,c);a:{if(z[a+24>>2]==C(1)){break a}d=v[b+4>>2];h=v[b+8>>2];b:while(1){if((e|0)==(h|0)){break a}i=B(v[a+16>>2],e+g|0);j=v[a+12>>2];b=0;while(1)if((b|0)==(d|0)){e=e+1|0;continue b}else{f=(b+i<<2)+j|0;z[f>>2]=z[a+24>>2]*z[f>>2];b=b+1|0;continue}}}kb=c+16|0}function dF(a,b,c,d,e,f,g){var h=0;v[23540]=0;Y(946,a|0);h=v[23540];v[23540]=0;a:{b:{if((h|0)!=1){h=v[a+24>>2];v[23540]=0;b=ja(g|0,h|0,b|0,c|0,d|0,e|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,f|0,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)==1){break a}$();b=0}return b}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function c3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=kb-32|0;kb=e;v[e+24>>2]=c;v[e+28>>2]=d;a:{a=hc(e+16|0,a,b);a=_s(3,v[a>>2],v[a+4>>2],e+24|0);if(a+1>>>0>=3){b=ba(8)|0;v[23540]=0;c=Q(55,e|0,8086)|0;a=v[23540];v[23540]=0;b:{if((a|0)!=1){a=tc(b,c);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break a}a=P()|0;O()|0;zb(c);break b}a=P()|0;O()|0;ca(b|0)}T(a|0);L()}kb=e+32|0;return a|0}L()}function HI(a,b){a=a|0;b=b|0;var c=0;c=kb-16|0;kb=c;a:{b:{c:{d:{if((b|0)>=0){a=v[a+32>>2];if((Og(a)|0)>(b|0)){break d}}b=ba(8)|0;v[23540]=0;c=Q(55,c|0,10725)|0;a=v[23540];v[23540]=0;if((a|0)==1){break c}a=tc(b,c);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break a}a=P()|0;O()|0;zb(c);break b}kb=c+16|0;return(v[(a+B(b,872)|0)+1075080>>2]&134218752)!=0|0}a=P()|0;O()|0;ca(b|0)}T(a|0)}L()}function wba(a){a=a|0;var b=0;a=Nb(a);v[23540]=0;R(46,a|0,4);b=v[23540];v[23540]=0;a:{b:{if((b|0)==1){break b}v[23540]=0;R(47,a|0,32);b=v[23540];v[23540]=0;if((b|0)==1){break b}v[23540]=0;R(47,a|0,10);b=v[23540];v[23540]=0;if((b|0)==1){break b}v[23540]=0;R(47,a|0,13);b=v[23540];v[23540]=0;if((b|0)==1){break b}v[23540]=0;R(47,a|0,9);b=v[23540];v[23540]=0;if((b|0)!=1){break a}}b=P()|0;O()|0;zb(a);T(b|0);L()}}function wV(a){a=a|0;var b=0,c=0,d=0;b=v[a>>2];if(b){ob[v[v[b>>2]+8>>2]](b);v[a>>2]=0}a=a+4|0;Lc(a);b=kb-32|0;kb=b;a:{b:{d=mp(a);c=fd(v[a>>2],v[a+4>>2]);c:{if(d>>>0<=c>>>0){break c}v[23540]=0;c=fa(906,b+8|0,c|0,c|0,Gb(a)|0)|0;d=v[23540];v[23540]=0;if((d|0)!=1){Fd(a,c);Wl(c);break c}a=V(0)|0;O()|0;_(a|0)|0;v[23540]=0;Z(18);a=v[23540];v[23540]=0;if((a|0)==1){break b}}kb=b+32|0;break a}V(0)|0;O()|0;Vb();L()}}function o4(a,b){a=a|0;b=b|0;var c=0,d=0;v[23540]=0;Y(946,a|0);c=v[23540];v[23540]=0;d=1;a:{b:{if((c|0)!=1){c=v[a+24>>2];v[23540]=0;R(1036,c|0,b|0);b=v[23540];v[23540]=0;if((b|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,10890,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)==1){break a}$();d=0}return d|0}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function CX(a){a=a|0;var b=0;a=Nb(a);v[23540]=0;R(73,a|0,4);b=v[23540];v[23540]=0;a:{b:{if((b|0)==1){break b}v[23540]=0;R(51,a|0,32);b=v[23540];v[23540]=0;if((b|0)==1){break b}v[23540]=0;R(51,a|0,10);b=v[23540];v[23540]=0;if((b|0)==1){break b}v[23540]=0;R(51,a|0,13);b=v[23540];v[23540]=0;if((b|0)==1){break b}v[23540]=0;R(51,a|0,9);b=v[23540];v[23540]=0;if((b|0)!=1){break a}}b=P()|0;O()|0;Ab(a);T(b|0);L()}}function r3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;c=kb-16|0;kb=c;g=v[a+4>>2];v[c+8>>2]=v[b+8>>2];d=v[b+4>>2];v[c>>2]=v[b>>2];v[c+4>>2]=d;qJ(a,c);a:{if(z[a+24>>2]==C(1)){break a}d=v[b+4>>2];h=v[b+8>>2];b:while(1){if((e|0)==(h|0)){break a}i=e+g|0;j=v[a+12>>2];b=0;while(1)if((b|0)==(d|0)){e=e+1|0;continue b}else{f=v[(b<<2)+j>>2]+(i<<2)|0;z[f>>2]=z[a+24>>2]*z[f>>2];b=b+1|0;continue}}}kb=c+16|0}function VE(a,b,c,d,e){var f=0,g=0,h=0;f=kb-160|0;kb=f;v[f+152>>2]=37;v[f+156>>2]=0;g=f+152|0;Rr(g|1,10773,e,v[b+4>>2]);e=Gd();v[f>>2]=d;d=f+139|0;e=$g(d,13,e,g,f)+d|0;g=Zi(d,e,b);h=f+16|0;gd(h,b);v[23540]=0;ia(1149,d|0,g|0,e|0,f+32|0,f+28|0,f+24|0,h|0);d=v[23540];v[23540]=0;a:{if((d|0)!=1){ac(f+16|0);a=Pr(a,f+32|0,v[f+28>>2],v[f+24>>2],b,c);kb=f+160|0;break a}a=P()|0;O()|0;ac(f+16|0);T(a|0);L()}return a}function pu(a,b){var c=0;c=kb-16|0;kb=c;v[c+12>>2]=b;a:{b:{switch(a|0){case 0:a=b;b=a>>31<<6|a>>>26;a=a<<6;a=Hc(Kka(a- -8192|0,b-((a>>>0<4294959104)-1|0)|0,16384,0),nb);break a;case 1:a=b>>31;a=a<<6|b>>>26;b=(b<<6)+2048|0;a=b>>>0<2048?a+1|0:a;a=Hc(Kka(b,a,4096,0),nb);break a;default:break b}}v[c+8>>2]=1;a=xl(mK(8192/+v[Pe(c+12|0,c+8|0)>>2])*24+8)}v[c+12>>2]=a;kb=c+16|0;a=(a|0)<64?a:64;return(a|0)>0?a:0}function kp(a,b,c,d,e,f,g,h){var i=0,j=0,k=0,l=0;i=kb-16|0;kb=i;if(-18-b>>>0>=c>>>0){j=Ac(a);k=-17;if(b>>>0<=2147483622){v[i+8>>2]=b<<1;v[i+12>>2]=b+c;k=nh(v[_c(i+12|0,i+8|0)>>2])+1|0}c=vc(k);if(e){He(c,j,e)}if(g){He(c+e|0,h,g)}l=e+f|0;h=d-l|0;if((d|0)!=(l|0)){He((c+e|0)+g|0,(e+j|0)+f|0,h)}if((b|0)!=10){Mb(j)}wd(a,c);ff(a,k);b=a;a=h+(e+g|0)|0;Hd(b,a);t[i+7|0]=0;we(a+c|0,i+7|0);kb=i+16|0;return}hf();L()}function RA(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;f=c;c=0;a:{if(!b){break a}if(!Qb(v[a>>2],v[a+8>>2],b)){break a}if(b>>>0<=3){c=kb-16|0;kb=c;if(Qb(v[a>>2],v[a+8>>2],b)){while(1){if((d|0)==4){Zl(c,v[c+12>>2]);d=v[c>>2]}else{t[c+11|0]=0;b:{if(b>>>0>d>>>0){zg(a,c+11|0);e=t[c+11|0];g=e>>>31|0;break b}e=0-g|0}t[(c+12|0)+d|0]=e;d=d+1|0;continue}break}}kb=c+16|0;c=d;break a}c=Bg(a);$b(a,b-4|0)}t[f|0]=c}function JI(a,b){a=a|0;b=b|0;var c=0;c=kb-16|0;kb=c;a:{b:{c:{d:{if((b|0)>=0){a=v[a+32>>2];if((Og(a)|0)>(b|0)){break d}}b=ba(8)|0;v[23540]=0;c=Q(55,c|0,10725)|0;a=v[23540];v[23540]=0;if((a|0)==1){break c}a=tc(b,c);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break a}a=P()|0;O()|0;zb(c);break b}kb=c+16|0;return+(+v[(a+B(b,872)|0)+1075740>>2]*.015625)}a=P()|0;O()|0;ca(b|0)}T(a|0)}L()}function on(a,b,c,d,e,f){var g=0;v[23540]=0;Y(946,a|0);g=v[23540];v[23540]=0;a:{b:{if((g|0)!=1){g=v[a+24>>2];v[23540]=0;b=fa(f|0,g|0,b|0,c|0,d|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,e|0,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)==1){break a}$();b=0}return b}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function l6(a){a=a|0;var b=0;v[23540]=0;Y(971,a|0);b=v[23540];v[23540]=0;if((b|0)!=1){v[a+24>>2]=0;b=v[a+28>>2];if(b){ob[v[v[b>>2]+4>>2]](b)}v[a+28>>2]=0;b=v[a+20>>2];if(b){Mb(b);v[a+20>>2]=0}Mb(a);return}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,5054,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)!=1){$();return}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function y1(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;e=kb-16|0;kb=e;while(1){a:{if((c|0)<=(f|0)){break a}g=v[a+28>>2];d=v[a+24>>2];if(g>>>0<=d>>>0){if(((i=a,j=Mf(t[b|0]),h=v[v[a>>2]+52>>2],ob[h](i|0,j|0)|0)|0)==-1){break a}f=f+1|0;b=b+1|0}else{v[e+12>>2]=g-d;v[e+8>>2]=c-f;g=d;d=v[td(e+12|0,e+8|0)>>2];He(g,b,d);v[a+24>>2]=d+v[a+24>>2];f=f+d|0;b=b+d|0}continue}break}kb=e+16|0;return f|0}function paa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;d=kb-32|0;kb=d;Ne(d,2,a+6|0);e=d+16|0;Fc(e,d);Dc(b+492|0,e);f=b+236|0;g=c+1|0;zb(e);c=0;while(1){if((c|0)==128){v[b>>2]=(w[a+226|0]|w[a+227|0]<<8)<<5;by(a+180|0,b+48|0,0);by(a+228|0,b+88|0,2);by(a+276|0,b+68|0,1);if(!(w[a+324|0]|w[a+325|0]<<8)){Ub(f,0,256)}kb=d+32|0}else{h=cc(f,c),i=w[(a+c|0)+38|0]+g|0,u[h>>1]=i;c=c+1|0;continue}break}}function fea(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=kb-16|0;kb=d;a:{c=v[b+4>>2];if(!c){break a}f=a+480190|0;u[d>>1]=x[f>>1];u[d+14>>1]=c-1;c=x[Wc(d,d+14|0)>>1];while(1){if(!c){break a}Db(d,v[b>>2],c);b:{if(Cb(v[v[d>>2]>>2],v[d+4>>2])){break b}if(AM(a,c&65535)){e=Kc(d,21688);Dc(((c<<5)+a|0)+946304|0,e);zb(e)}if(c>>>0<2){break b}e=x[f>>1];if((e|0)!=(c|0)){break b}u[f>>1]=e-1}c=c-1|0;continue}}kb=d+16|0}function M2(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=kb-32|0;kb=e;a:{if(w[b+8|0]){f=v[b+12>>2];h=e,i=fd(f,v[b+16>>2])-c|0,v[h+28>>2]=i;v[e+24>>2]=v[d+4>>2];g=v[Kb(e+28|0,e+24|0)>>2];f=Rf(Fb(f),c);c=Rf(Rf(Fb(v[b+12>>2]),c),g);b=v[d>>2];qh(f,c,b);gc(a,b,g);break a}g=v[d+4>>2];d=v[d>>2];v[e+16>>2]=d;v[e+20>>2]=g;f=v[v[b>>2]+40>>2];v[e+8>>2]=d;v[e+12>>2]=g;ob[f|0](a,b,c,e+8|0)}kb=e+32|0}function af(a){var b=0,c=0,d=0;b=kb-16|0;kb=b;o(+a);d=j(1)|0;j(0)|0;d=d&2147483647;a:{if(d>>>0<=1072243195){c=1;if(d>>>0<1044816030){break a}c=ip(a,0);break a}c=a-a;if(d>>>0>=2146435072){break a}b:{switch(uF(a,b)&3){case 0:c=ip(A[b>>3],A[b+8>>3]);break a;case 1:c=-jp(A[b>>3],A[b+8>>3],1);break a;case 2:c=-ip(A[b>>3],A[b+8>>3]);break a;default:break b}}c=jp(A[b>>3],A[b+8>>3],1)}a=c;kb=b+16|0;return a}function XE(a,b,c,d,e){var f=0,g=0,h=0;f=kb-80|0;kb=f;v[f+72>>2]=37;v[f+76>>2]=0;g=f+72|0;Rr(g|1,10773,e,v[b+4>>2]);e=Gd();v[f>>2]=d;d=f+59|0;e=$g(d,13,e,g,f)+d|0;g=Zi(d,e,b);h=f+16|0;gd(h,b);v[23540]=0;ia(1146,d|0,g|0,e|0,f+32|0,f+28|0,f+24|0,h|0);d=v[23540];v[23540]=0;a:{if((d|0)!=1){ac(f+16|0);a=Vq(a,f+32|0,v[f+28>>2],v[f+24>>2],b,c);kb=f+80|0;break a}a=P()|0;O()|0;ac(f+16|0);T(a|0);L()}return a}function u4(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=kb-16|0;kb=e;a:{b:{c:{if(!d){a=ba(8)|0;v[23540]=0;c=Q(55,e|0,8229)|0;b=v[23540];v[23540]=0;if((b|0)==1){break c}a=tc(a,c);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break a}b=P()|0;O()|0;zb(c);break b}dl(a,b,1);c=ux(a,c,d,0,0,0);A[a+16>>3]=A[a+16>>3]+ +(c>>>0)/+(b|0);kb=e+16|0;return c|0}b=P()|0;O()|0;ca(a|0)}T(b|0)}L()}function I4(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=kb-16|0;kb=e;a:{b:{c:{if(!d){a=ba(8)|0;v[23540]=0;c=Q(55,e|0,8229)|0;b=v[23540];v[23540]=0;if((b|0)==1){break c}a=tc(a,c);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break a}b=P()|0;O()|0;zb(c);break b}dl(a,b,1);c=tx(a,c,d,0,0,0);A[a+16>>3]=A[a+16>>3]+ +(c>>>0)/+(b|0);kb=e+16|0;return c|0}b=P()|0;O()|0;ca(a|0)}T(b|0)}L()}function C$(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;a=kb-208|0;kb=a;f=Gd();v[a>>2]=e;g=a+176|0;i=$g(g,20,f,9291,a);e=i+g|0;g=Zi(g,e,c);f=a+8|0;gd(f,c);v[23540]=0;f=S(1132,f|0)|0;h=v[23540];v[23540]=0;if((h|0)!=1){ac(a+8|0);h=f;f=a+16|0;tG(h,a+176|0,e,f);h=b;b=f+(i<<2)|0;b=Pr(h,f,(e|0)==(g|0)?b:((g-a<<2)+a|0)-688|0,b,c,d);kb=a+208|0;return b|0}b=P()|0;O()|0;ac(a+8|0);T(b|0);L()}function xy(a,b){a=a|0;b=b|0;var c=C(0),d=0,e=0,f=0;t[a+1074368|0]=b;MM(a+1074332|0,b);a=a+906300|0;f=gk(a);while(1){if((a|0)!=(f|0)){b=v[a>>2];if(b){c=C(1);d=v[b+20>>2];if(d){c=C(C(w[d+26|0])*C(.10000000149011612))}c=c<C(.10000000149011612)?C(1):c;if(ob[v[v[b>>2]+140>>2]](b)|0){d=v[b+16>>2];e=d+1074332|0;c=C(C(c/z[e+8>>2])*C(C(y[d+480232>>2])/z[e+20>>2]))}z[b+4196>>2]=c}a=a+160|0;continue}break}}function j4(a,b){a=a|0;b=+b;var c=0;v[23540]=0;Y(946,a|0);c=v[23540];v[23540]=0;a:{b:{if((c|0)!=1){c=v[a+24>>2];v[23540]=0;b=+Za(1038,c|0,+b);c=v[23540];v[23540]=0;if((c|0)!=1){break b}}c=V(0)|0;O()|0;_(c|0)|0;v[23540]=0;X(933,7566,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)==1){break a}$();b=0}return+b}a=P()|0;O()|0;v[23540]=0;Z(18);c=v[23540];v[23540]=0;if((c|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function eia(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=kb-16|0;kb=e;c=rf(a,c);me(e,v[a+36>>2]);a:{b:{if(!c){Sc(e,a+32|0,5);d=-1;if(!Cb(v[v[e>>2]>>2],v[e+4>>2])){break b}break a}d=v[c+16>>2]}f=v[a+36>>2];c:{d:{switch(d+1|0){case 0:case 2:d=kb-32|0;kb=d;t[d+24|0]=0;Yi(d+8|0,d+24|0);yn(d+16|0,f,v[d+8>>2],v[d+12>>2]);t[b|0]=w[d+24|0];kb=d+32|0;break c;default:break d}}lT(f,b,d)}f=c}Ye(a,f);kb=e+16|0}function Ts(a){var b=0,c=0,d=0;b=w[a+4266|0];z[a+4236>>2]=C(b>>>0)*C(.00390625);v[a+4228>>2]=(B(v[a+4232>>2],w[a+4264|0])+250>>>0)/500;z[a+4240>>2]=C(256-b|0)*C(.00390625);c=w[a+4267|0];b=w[a+4265|0];z[a+4244>>2]=C(B(c,b)|0)*C(152587890625e-16);d=c|-256;z[a+4256>>2]=C(B(d,b|-256)|0)*C(152587890625e-16);z[a+4252>>2]=C(B(b,d)|0)*C(152587890625e-16);z[a+4248>>2]=C(B(256-b|0,c)|0)*C(152587890625e-16)}function vt(a,b,c){var d=0,e=0,f=0,g=0,h=0;e=kb-16|0;kb=e;v[b+40>>2]=0;v[b+44>>2]=0;f=b- -64|0;v[f>>2]=0;v[f+4>>2]=0;v[b+56>>2]=0;v[b+60>>2]=0;v[b+48>>2]=0;v[b+52>>2]=0;while(1){if((d|0)==1e4){a:{d=Fb(v[c>>2]);v[e+8>>2]=d;f=Fb(v[c+4>>2]);while(1){if(!Pb(d,f)){break a}g=d,h=HO(b,A[d>>3]),A[g>>3]=h;d=v[st(e+8|0)>>2];continue}}}else{HO(b,A[bf(v[c>>2],0)>>3]);d=d+1|0;continue}break}ul(a,c);kb=e+16|0}function rC(a,b){var c=0,d=0,e=0;c=kb-32|0;kb=c;a:{if(!w[b+7|0]){while(1){if((d|0)==7){d=0;t[c+27|0]=0;t[c+28|0]=0;t[c+29|0]=0;t[c+30|0]=0;v[c+24>>2]=0;e=hc(c+8|0,c+24|0,7);md(c+16|0,a,v[e>>2],v[e+4>>2]);b:{if(v[c+20>>2]!=7){break b}if(Sb(c+24|0,b,7)){break b}id(a,7);d=1}kb=c+32|0;break a}e=b+d|0;d=d+1|0;if(w[e|0]){continue}break}aa(17499,9108,413,13143);L()}aa(17478,9108,411,13143);L()}return d}function yI(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0;d=kb-16|0;kb=d;a:{b:{c:{if(b>>>0>=256){b=ba(8)|0;v[23540]=0;d=Q(55,d|0,10725)|0;a=v[23540];v[23540]=0;if((a|0)==1){break c}a=tc(b,d);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break a}a=P()|0;O()|0;zb(d);break b}e=(v[a+32>>2]+B(b,872)|0)+1075766|0,f=Sz(c*32768),u[e>>1]=f;kb=d+16|0;return}a=P()|0;O()|0;ca(b|0)}T(a|0)}L()}function Zfa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=kb-16|0;kb=c;b=-1;a:{if(!fg(a,8)){break a}b=kb-32|0;kb=b;v[b+24>>2]=0;v[b+28>>2]=0;d=hc(b+8|0,b+24|0,8);md(b+16|0,a,v[d>>2],v[d+4>>2]);b:{if(v[b+20>>2]!=8){break b}if(Sb(b+24|0,14159,8)){break b}id(a,8);e=1}kb=b+32|0;b=0;if(!e){break a}b=-1;if(!Rj(a,c+8|0)){break a}b=0;if(!bc(v[c+12>>2])){break a}b=!(bc(v[c+8>>2])&-2139062144)}kb=c+16|0;return b|0}function yr(a){var b=0,c=0;kn(a,1,13584);v[23540]=0;b=ga(126)|0;c=v[23540];v[23540]=0;a:{if((c|0)==1){break a}v[a+12>>2]=b;v[23540]=0;b=ga(127)|0;c=v[23540];v[23540]=0;if((c|0)==1){break a}t[a+16|0]=b;v[23540]=0;b=ga(128)|0;c=v[23540];v[23540]=0;if((c|0)==1){break a}t[a+18|0]=0;t[a+17|0]=b;v[23540]=0;Y(129,a+20|0);b=v[23540];v[23540]=0;if((b|0)==1){break a}return}b=P()|0;O()|0;Ab(a);T(b|0);L()}function uo(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=kb-16|0;kb=f;v[f+12>>2]=c;a:{if(!Qb(v[b>>2],v[b+8>>2],c)){break a}xc(f+12|0,65535);vg(a,x[f+12>>1]);c=Fb(v[a>>2]);v[f>>2]=c;h=Fb(v[a+4>>2]);while(1){if(!Pb(c,h)){break a}a=f+11|0;if(!zg(b,a)){Eh(a)}a=w[f+11|0];u[c>>1]=a;g=65535;b:{if((a|0)!=(d|0)){g=65534;if((a|0)!=(e|0)){break b}}u[c>>1]=g}c=v[Se(f)>>2];continue}}kb=f+16|0}function kea(a,b){a=a|0;b=b|0;var c=0,d=0;if(y[a+4>>2]<y[Gb(a)>>2]){c=kb-16|0;kb=c;a=Kz(c,a);Zl(v[a+4>>2],w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24));v[a+4>>2]=v[a+4>>2]+4;lc(a);kb=c+16|0;return}d=kb-32|0;kb=d;c=Gb(a);c=Vf(d+8|0,qg(a,uc(v[a>>2],v[a+4>>2])+1|0),uc(v[a>>2],v[a+4>>2]),c);Zl(v[c+8>>2],w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24));v[c+8>>2]=v[c+8>>2]+4;Fd(a,c);Uf(c);kb=d+32|0}function d5(a){a=a|0;var b=0,c=0;v[23540]=0;Y(946,a|0);b=v[23540];v[23540]=0;a:{b:{if((b|0)!=1){b=v[a+24>>2];v[23540]=0;b=S(1014,b|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,7238,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)==1){break a}$();b=0}return b|0}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function VM(a,b){var c=0,d=0,e=0,f=0;c=v[a>>2];v[a>>2]=b;if(c){d=kb-16|0;kb=d;b=Fb(v[c>>2]);v[d+8>>2]=b;f=Fb(v[c+4>>2]);while(1){a:{b:{if(Pb(b,f)){while(1){a=v[b>>2];e=v[a>>2];if(!e){break b}a=v[v[e>>2]+8>>2];v[23540]=0;Y(a|0,e|0);a=v[23540];v[23540]=0;if((a|0)!=1){continue}break}V(0)|0;O()|0;Vb();L()}a=wc(c);kb=d+16|0;break a}Xb(a+20|0);Xb(a+8|0);Mb(a);b=v[Le(d+8|0)>>2];continue}break}Mb(a)}}function FE(a,b,c,d,e){var f=0,g=0;a:{f=kb-80|0;kb=f;qA(b);g=f+56|0;Of(g,a,c);a=v[f+56>>2];c=f+8|0;cg(c,e,Ie(g),a);v[23540]=0;R(222,f+24|0,c|0);a=v[23540];v[23540]=0;b:{c:{if((a|0)!=1){v[23540]=0;U(11,f+40|0,d|0,f+24|0);a=v[23540];v[23540]=0;if((a|0)==1){break c}a=f+40|0;Jb(b,a);Ab(a);zb(f+24|0);Uc(f+56|0);kb=f+80|0;break a}a=P()|0;O()|0;break b}a=P()|0;O()|0;zb(f+24|0)}Uc(f+56|0);T(a|0);L()}}function Efa(a,b){a=a|0;b=b|0;var c=0,d=0;a:{a=Yz(a,b);v[23540]=0;c=Q(657,a+12|0,b+12|0)|0;d=v[23540];v[23540]=0;b:{c:{if((d|0)!=1){v[23540]=0;Q(658,a+24|0,b+24|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break c}c=v[b+40>>2];v[a+36>>2]=v[b+36>>2];v[a+40>>2]=c;u[a+52>>1]=x[b+52>>1];c=v[b+48>>2];v[a+44>>2]=v[b+44>>2];v[a+48>>2]=c;break a}b=P()|0;O()|0;break b}b=P()|0;O()|0;ic(c)}ic(a);T(b|0);L()}}function w3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=C(0),g=0,h=0,i=0,j=0,k=0,l=0;c=kb-16|0;kb=c;a:{f=z[a+24>>2];if(f==C(1)){break a}i=v[b>>2];j=+f;g=v[b+4>>2];k=v[b+8>>2];b:while(1){if((e|0)==(k|0)){break a}l=B(e,g);d=0;while(1)if((d|0)==(g|0)){e=e+1|0;continue b}else{h=(d+l<<3)+i|0;A[h>>3]=A[h>>3]*j;d=d+1|0;continue}}}v[c+8>>2]=v[b+8>>2];d=v[b+4>>2];v[c>>2]=v[b>>2];v[c+4>>2]=d;vJ(a,c);kb=c+16|0}function sea(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;b=kb-16|0;kb=b;u[b+12>>1]=0;u[b+14>>1]=1;Ef(b+14|0,x[v[v[a+24>>2]+8>>2]+12>>1]);e=b+12|0;d=kb-16|0;kb=d;c=x[b+14>>1];v[d+12>>2]=c;a:{if(Zm(a)>>>0>=c>>>0){g=v[a>>2];f=Rc(g,v[a+4>>2]);v[d+8>>2]=f;_t(g,v[Kb(d+12|0,d+8|0)>>2],e);if(c>>>0>f>>>0){Jo(a,c-f|0,e);break a}Od(a,v[a>>2]+(c<<1)|0);break a}nP(a);lq(a,Oj(a,c));Jo(a,c,e)}kb=d+16|0;kb=b+16|0}function qd(a,b){var c=0,d=0,e=0,f=0,g=0;a:{e=OG(b);c=vn(a);if(e>>>0<=c>>>0){f=Ac(a);d=f;c=e;if(c){b:{if((b|0)==(d|0)){break b}if(d-b>>>0>=c<<2>>>0){if(!c){break b}while(1){v[d>>2]=v[b>>2];d=d+4|0;b=b+4|0;c=c-1|0;if(c){continue}break}break b}if(!c){break b}while(1){c=c-1|0;g=c<<2;v[g+d>>2]=v[b+g>>2];if(c){continue}break}}}Sh(a,e);wd((e<<2)+f|0,0);break a}d=a;a=Hb(a);AF(d,c,e-c|0,a,0,a,e,b)}}function q5(a){a=a|0;var b=0,c=0;v[23540]=0;Y(946,a|0);b=v[23540];v[23540]=0;a:{b:{if((b|0)!=1){b=v[a+24>>2];v[23540]=0;c=+la(1005,b|0);b=v[23540];v[23540]=0;if((b|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,7638,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)==1){break a}$();c=0}return+c}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function q3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=C(0),g=0,h=0,i=0,j=0,k=0,l=0;c=kb-16|0;kb=c;a:{f=z[a+24>>2];if(f==C(1)){break a}i=v[b>>2];j=+f;g=v[b+4>>2];k=v[b+8>>2];b:while(1){if((e|0)==(k|0)){break a}l=B(e,g);d=0;while(1)if((d|0)==(g|0)){e=e+1|0;continue b}else{h=(d+l<<3)+i|0;A[h>>3]=A[h>>3]*j;d=d+1|0;continue}}}v[c+8>>2]=v[b+8>>2];d=v[b+4>>2];v[c>>2]=v[b>>2];v[c+4>>2]=d;pJ(a,c);kb=c+16|0}function n3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=C(0),g=0,h=0,i=0,j=0,k=0,l=0;c=kb-16|0;kb=c;a:{f=z[a+24>>2];if(f==C(1)){break a}i=v[b>>2];j=+f;g=v[b+4>>2];k=v[b+8>>2];b:while(1){if((e|0)==(k|0)){break a}l=B(e,g);d=0;while(1)if((d|0)==(g|0)){e=e+1|0;continue b}else{h=(d+l<<3)+i|0;A[h>>3]=A[h>>3]*j;d=d+1|0;continue}}}v[c+8>>2]=v[b+8>>2];d=v[b+4>>2];v[c>>2]=v[b>>2];v[c+4>>2]=d;mJ(a,c);kb=c+16|0}function h3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=C(0),g=0,h=0,i=0,j=0,k=0,l=0;c=kb-16|0;kb=c;a:{f=z[a+24>>2];if(f==C(1)){break a}i=v[b>>2];j=+f;g=v[b+4>>2];k=v[b+8>>2];b:while(1){if((e|0)==(k|0)){break a}l=B(e,g);d=0;while(1)if((d|0)==(g|0)){e=e+1|0;continue b}else{h=(d+l<<3)+i|0;A[h>>3]=A[h>>3]*j;d=d+1|0;continue}}}v[c+8>>2]=v[b+8>>2];d=v[b+4>>2];v[c>>2]=v[b>>2];v[c+4>>2]=d;hJ(a,c);kb=c+16|0}function KS(a){var b=0;a:{if(Sb(a,14300,3)|(w[a+3|0]-52&255)>>>0<252){break a}if(bc(w[a+8|0]|w[a+9|0]<<8|(w[a+10|0]<<16|w[a+11|0]<<24))+788>>>0<840){break a}if(bc(w[a+16|0]|w[a+17|0]<<8|(w[a+18|0]<<16|w[a+19|0]<<24))>>>0<52){break a}if(bc(w[a+24|0]|w[a+25|0]<<8|(w[a+26|0]<<16|w[a+27|0]<<24))-1>>>0<51){break a}b=bc(w[a+32|0]|w[a+33|0]<<8|(w[a+34|0]<<16|w[a+35|0]<<24))>>>0<4294967216}return b}function CR(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=kb-32|0;kb=c;a:{if(!w[b+8|0]){while(1){if((d|0)==8){v[c+24>>2]=0;v[c+28>>2]=0;d=hc(c+8|0,c+24|0,8);nc(c+16|0,v[a>>2],v[a+8>>2],v[d>>2],v[d+4>>2]);d=0;b:{if(v[c+20>>2]!=8){break b}if(Sb(c+24|0,b,8)){break b}$b(a,8);d=1}kb=c+32|0;break a}e=b+d|0;d=d+1|0;if(w[e|0]){continue}break}aa(17499,9108,413,13143);L()}aa(17478,9108,411,13143);L()}return d|0}function Di(a){var b=0,c=0;b=kb-16|0;kb=b;o(+a);c=j(1)|0;j(0)|0;c=c&2147483647;a:{if(c>>>0<=1072243195){if(c>>>0<1045430272){break a}a=jp(a,0,0);break a}if(c>>>0>=2146435072){a=a-a;break a}b:{switch(uF(a,b)&3){case 0:a=jp(A[b>>3],A[b+8>>3],1);break a;case 1:a=ip(A[b>>3],A[b+8>>3]);break a;case 2:a=-jp(A[b>>3],A[b+8>>3],1);break a;default:break b}}a=-ip(A[b>>3],A[b+8>>3])}kb=b+16|0;return a}function a8(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=vi(a,b,c,d);v[a>>2]=45840;b=Tb(a+4208|0);v[a+4240>>2]=0;v[a+4244>>2]=0;c=v[c+24620>>2];v[a+4260>>2]=0;v[a+4256>>2]=c;v[a+4236>>2]=0;c=a+4228|0;v[c>>2]=1048576e3;v[c+4>>2]=1048576e3;v[a+4220>>2]=1056964608;v[a+4224>>2]=1056964608;v[23540]=0;R(897,a+44|0,2);c=v[23540];v[23540]=0;if((c|0)!=1){ui(a);return a|0}c=P()|0;O()|0;wc(b);If(a);T(c|0);L()}function XV(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=kb-16|0;kb=d;v[a>>2]=0;v[a+4>>2]=0;if(!Qb(v[b>>2],v[b+8>>2],c)){c=cf(b)}v[a>>2]=c;c=v[b>>2];a:{if(ob[v[v[c>>2]+16>>2]](c)|0){c=a;a=v[b>>2];e=c,f=(ob[v[v[a>>2]+20>>2]](a)|0)+v[b+8>>2]|0,v[e+4>>2]=f;break a}Qi(a+8|0,v[a>>2]);c=v[a+8>>2];a=v[a+12>>2];if(pc(c,a)){break a}re(d+8|0,c,a);nc(d,v[b>>2],v[b+8>>2],v[d+8>>2],v[d+12>>2])}kb=d+16|0}function M$(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;a=kb-96|0;kb=a;f=Gd();v[a>>2]=e;g=a- -64|0;i=$g(g,20,f,9291,a);e=i+g|0;g=Zi(g,e,c);f=a+8|0;gd(f,c);v[23540]=0;f=S(19,f|0)|0;h=v[23540];v[23540]=0;if((h|0)!=1){ac(a+8|0);h=f;f=a+16|0;xG(h,a- -64|0,e,f);h=b;b=f+i|0;b=Vq(h,f,(e|0)==(g|0)?b:((g-a|0)+a|0)-48|0,b,c,d);kb=a+96|0;return b|0}b=P()|0;O()|0;ac(a+8|0);T(b|0);L()}function yG(a,b,c){var d=0,e=0,f=C(0),g=0,h=C(0);e=kb-16|0;kb=e;a:{b:{c:{if((a|0)!=(b|0)){g=v[116016];v[116016]=0;Gd();d=kb-16|0;kb=d;Cw(d,a,e+12|0,0);f=rF(v[d>>2],v[d+4>>2],v[d+8>>2],v[d+12>>2]);kb=d+16|0;a=v[116016];if(!a){break c}if(v[e+12>>2]!=(b|0)){break b}h=f;if((a|0)!=68){break a}break b}v[c>>2]=4;break a}v[116016]=g;if(v[e+12>>2]==(b|0)){break a}}v[c>>2]=4;f=h}kb=e+16|0;return f}function rq(a,b,c,d,e,f,g,h){var i=0,j=0,k=0,l=0;i=kb-16|0;kb=i;if(-18-b>>>0>=c>>>0){j=sd(a);k=-17;if(b>>>0<=2147483622){v[i+8>>2]=b<<1;v[i+12>>2]=b+c;k=nh(v[_c(i+12|0,i+8|0)>>2])+1|0}c=vc(k);if(e){He(c,j,e)}if(g){He(c+e|0,h,g)}l=e+f|0;h=d-l|0;if((d|0)!=(l|0)){He((c+e|0)+g|0,(e+j|0)+f|0,h)}if((b|0)!=10){Mb(j)}wd(a,c);ff(a,k);b=a;a=h+(e+g|0)|0;Hd(b,a);xd(a+c|0,0);kb=i+16|0;return}hf();L()}function qx(a,b,c){var d=0,e=0;d=kb-32|0;kb=d;a:{if(w[a+20|0]){break a}b=b+c|0;b=b>>>0<c>>>0?-1:b;c=v[a+16>>2];if(b>>>0<=c>>>0){break a}b=bJ(b,4096);aJ(a,b-c|0);c=v[a+16>>2];b=hc(d+16|0,Lb(v[a+4>>2],c),b-c|0);c=v[v[a>>2]+44>>2];e=v[b+4>>2];v[d+8>>2]=v[b>>2];v[d+12>>2]=e;ob[c|0](d+24|0,a,d+8|0);v[a+16>>2]=v[a+16>>2]+v[d+28>>2];if(!(ob[v[v[a>>2]+40>>2]](a)|0)){break a}t[a+20|0]=1}kb=d+32|0}function QB(a,b,c){var d=0,e=0,f=0;d=v[c+16>>2];a:{if(!d){if(pC(c)){break a}d=v[c+16>>2]}f=v[c+20>>2];if(d-f>>>0<b>>>0){return ob[v[c+36>>2]](c,a,b)|0}b:{if(v[c+80>>2]<0){d=0;break b}e=b;while(1){d=e;if(!d){d=0;break b}e=d-1|0;if(w[e+a|0]!=10){continue}break}e=ob[v[c+36>>2]](c,a,d)|0;if(e>>>0<d>>>0){break a}a=a+d|0;b=b-d|0;f=v[c+20>>2]}sc(f,a,b);v[c+20>>2]=v[c+20>>2]+b;e=b+d|0}return e}function hS(a){t[a|0]=0;t[a+1|0]=0;t[a+2|0]=0;t[a+3|0]=0;t[a+4|0]=0;t[a+5|0]=0;t[a+6|0]=0;t[a+7|0]=0;t[a+22|0]=0;t[a+23|0]=0;t[a+24|0]=0;t[a+25|0]=0;t[a+26|0]=0;t[a+27|0]=0;t[a+28|0]=0;t[a+29|0]=0;t[a+16|0]=0;t[a+17|0]=0;t[a+18|0]=0;t[a+19|0]=0;t[a+20|0]=0;t[a+21|0]=0;t[a+22|0]=0;t[a+23|0]=0;t[a+8|0]=0;t[a+9|0]=0;t[a+10|0]=0;t[a+11|0]=0;t[a+12|0]=0;t[a+13|0]=0;t[a+14|0]=0;t[a+15|0]=0}function bQ(a){t[a|0]=0;t[a+1|0]=0;t[a+2|0]=0;t[a+3|0]=0;t[a+4|0]=0;t[a+5|0]=0;t[a+6|0]=0;t[a+7|0]=0;t[a+24|0]=0;t[a+25|0]=0;t[a+26|0]=0;t[a+27|0]=0;t[a+28|0]=0;t[a+29|0]=0;t[a+30|0]=0;t[a+31|0]=0;t[a+16|0]=0;t[a+17|0]=0;t[a+18|0]=0;t[a+19|0]=0;t[a+20|0]=0;t[a+21|0]=0;t[a+22|0]=0;t[a+23|0]=0;t[a+8|0]=0;t[a+9|0]=0;t[a+10|0]=0;t[a+11|0]=0;t[a+12|0]=0;t[a+13|0]=0;t[a+14|0]=0;t[a+15|0]=0}function Q1(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;f=sd(c);c=Ad(v[c+4>>2],w[c+11|0]);a:{d=Ad(v[a+4>>2],w[a+11|0]);if(d>>>0>=b>>>0){e=wl(a);if(c>>>0<=e-d>>>0){if(!c){break a}e=sd(a);h=e+b|0;if((b|0)!=(d|0)){g=b+e|0;Yh(c+g|0,g,d-b|0);f=(f>>>0>=g>>>0?d+e>>>0>f>>>0?c:0:0)+f|0}Yh(h,f,c);b=c+d|0;vq(a,b);xd(b+e|0,0);break a}rq(a,e,(c+d|0)-e|0,d,b,0,c,f);break a}sk();L()}return a|0}function Ija(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=kb-16|0;kb=c;gc(c+8|0,b,15);d=v[c+12>>2];nc(c,v[a>>2],v[a+8>>2],v[c+8>>2],v[c+12>>2]);e=v[c+4>>2];if((e|0)==(d|0)){$b(a,v[c+12>>2])}kb=c+16|0;if((d|0)!=(e|0)){t[b|0]=0;t[b+1|0]=0;t[b+2|0]=0;t[b+3|0]=0;t[b+4|0]=0;t[b+5|0]=0;t[b+6|0]=0;t[b+7|0]=0;t[b+7|0]=0;t[b+8|0]=0;t[b+9|0]=0;t[b+10|0]=0;t[b+11|0]=0;t[b+12|0]=0;t[b+13|0]=0;t[b+14|0]=0}}function c4(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;b=kb-32|0;kb=b;a:{e=a;a=hc(b+24|0,c,d);a=_s(e,v[a>>2],v[a+4>>2],0);if(a+1>>>0>=3){a=ba(8)|0;v[23540]=0;b=Q(55,b+8|0,8086)|0;c=v[23540];v[23540]=0;b:{if((c|0)!=1){a=tc(a,b);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break a}c=P()|0;O()|0;zb(b);break b}c=P()|0;O()|0;ca(a|0)}T(c|0);L()}kb=b+32|0;return a|0}L()}function Wi(a,b,c,d,e){var f=0,g=0,h=0;f=kb-16|0;kb=f;v[f+8>>2]=b;b=0;g=6;a:{b:{if(bj(a,f+8|0)){break b}h=Zk(v[a>>2]);g=4;if(!vh(v[d+8>>2],2048,h)){break b}b=xn(d,h);while(1){c:{b=b-48|0;h=em(a);if(!rp(h,f+8|0)|(e|0)<2){break c}g=Zk(v[h>>2]);if(!vh(v[d+8>>2],2048,g)){break a}e=e-1|0;b=xn(d,g)+B(b,10)|0;continue}break}g=2;if(!bj(h,f+8|0)){break a}}v[c>>2]=v[c>>2]|g}kb=f+16|0;return b}function Qja(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;v[a>>2]=0;v[a+4>>2]=0;Gc(a+8|0);if(th(1073741823)>>>0<=8191){cd();L()}b=vc(32768);v[a>>2]=b;v[a+4>>2]=b;e=Gb(a),f=b+32768|0,v[e>>2]=f;b=kb-16|0;kb=b;v[b>>2]=a;c=v[a+4>>2];v[b+4>>2]=c;v[b+8>>2]=c+32768;c=v[b+4>>2];d=v[b+8>>2];while(1){if((c|0)==(d|0)){lc(b);kb=b+16|0}else{u[c>>1]=0;u[c+2>>1]=0;c=c+4|0;v[b+4>>2]=c;continue}break}return a|0}function Dha(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=kb-16|0;kb=c;gc(c+8|0,b,14);d=v[c+12>>2];nc(c,v[a>>2],v[a+8>>2],v[c+8>>2],v[c+12>>2]);e=v[c+4>>2];if((e|0)==(d|0)){$b(a,v[c+12>>2])}kb=c+16|0;if((d|0)!=(e|0)){t[b|0]=0;t[b+1|0]=0;t[b+2|0]=0;t[b+3|0]=0;t[b+4|0]=0;t[b+5|0]=0;t[b+6|0]=0;t[b+7|0]=0;t[b+6|0]=0;t[b+7|0]=0;t[b+8|0]=0;t[b+9|0]=0;t[b+10|0]=0;t[b+11|0]=0;t[b+12|0]=0;t[b+13|0]=0}}function wG(a,b,c){var d=0,e=0,f=0,g=0,h=0;e=kb-16|0;kb=e;a:{b:{c:{if((a|0)!=(b|0)){g=v[116016];v[116016]=0;Gd();d=kb-16|0;kb=d;Cw(d,a,e+12|0,1);f=Gw(v[d>>2],v[d+4>>2],v[d+8>>2],v[d+12>>2]);kb=d+16|0;a=v[116016];if(!a){break c}if(v[e+12>>2]!=(b|0)){break b}h=f;if((a|0)!=68){break a}break b}v[c>>2]=4;break a}v[116016]=g;if(v[e+12>>2]==(b|0)){break a}}v[c>>2]=4;f=h}kb=e+16|0;return f}function cF(a,b,c,d,e){var f=0;f=kb-16|0;kb=f;a:{b:{c:{if(!d){a=ba(8)|0;v[23540]=0;c=Q(55,f|0,8229)|0;b=v[23540];v[23540]=0;if((b|0)==1){break c}a=tc(a,c);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break a}b=P()|0;O()|0;zb(c);break b}dl(a,b,e);c=_E(a,c,e,d,60448,61220);A[a+16>>3]=A[a+16>>3]+ +(c>>>0)/+(b|0);kb=f+16|0;return c}b=P()|0;O()|0;ca(a|0)}T(b|0)}L()}function bF(a,b,c,d,e){var f=0;f=kb-16|0;kb=f;a:{b:{c:{if(!d){a=ba(8)|0;v[23540]=0;c=Q(55,f|0,8229)|0;b=v[23540];v[23540]=0;if((b|0)==1){break c}a=tc(a,c);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break a}b=P()|0;O()|0;zb(c);break b}dl(a,b,e);c=_E(a,c,e,d,59620,60392);A[a+16>>3]=A[a+16>>3]+ +(c>>>0)/+(b|0);kb=f+16|0;return c}b=P()|0;O()|0;ca(a|0)}T(b|0)}L()}function QI(a,b){a=a|0;b=+b;var c=0,d=0,e=0,f=0;c=kb-16|0;kb=c;a:{b:{c:{if(b<=0|b>4){a=ba(8)|0;v[23540]=0;c=Q(55,c|0,7814)|0;d=v[23540];v[23540]=0;if((d|0)==1){break c}a=tc(a,c);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break a}d=P()|0;O()|0;zb(c);break b}a=v[a+32>>2];e=a,f=Qe(65536/b),v[e+480244>>2]=f;Qp(a);kb=c+16|0;return}d=P()|0;O()|0;ca(a|0)}T(d|0)}L()}function OI(a,b){a=a|0;b=+b;var c=0,d=0,e=0,f=0;c=kb-16|0;kb=c;a:{b:{c:{if(b<=0|b>4){a=ba(8)|0;v[23540]=0;c=Q(55,c|0,7835)|0;d=v[23540];v[23540]=0;if((d|0)==1){break c}a=tc(a,c);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break a}d=P()|0;O()|0;zb(c);break b}a=v[a+32>>2];e=a,f=Qe(b*65536),v[e+480240>>2]=f;Qp(a);kb=c+16|0;return}d=P()|0;O()|0;ca(a|0)}T(d|0)}L()}function w9(a){a=a|0;var b=0,c=0;b=v[a+20>>2];v[b+148>>2]=-1;v[23540]=0;R(285,b+4|0,8);b=v[23540];v[23540]=0;if((b|0)!=1){b=v[a+4264>>2];c=v[v[a+20>>2]+4>>2];a=v[a+4260>>2];t[c|0]=a;t[c+1|0]=a>>>8;t[c+2|0]=a>>>16;t[c+3|0]=a>>>24;t[c+4|0]=b;t[c+5|0]=b>>>8;t[c+6|0]=b>>>16;t[c+7|0]=b>>>24;return}b=V(92756)|0;if((O()|0)==(ea(92756)|0)){_(b|0)|0;Lc(v[a+20>>2]+4|0);$();return}T(b|0);L()}function DI(a,b){a=a|0;b=b|0;var c=0;c=kb-16|0;kb=c;a:{b:{c:{if(b>>>0>=256){b=ba(8)|0;v[23540]=0;c=Q(55,c|0,10725)|0;a=v[23540];v[23540]=0;if((a|0)==1){break c}a=tc(b,c);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break a}a=P()|0;O()|0;zb(c);break b}a=v[a+32>>2]+B(b,872)|0;v[a+1075008>>2]=0;v[a+1075068>>2]=0;kb=c+16|0;return}a=P()|0;O()|0;ca(b|0)}T(a|0)}L()}function Wja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=kb-16|0;kb=d;a:{e=Me(a);b:{if(e>>>0>1){break b}c:{if(e){v[23540]=0;U(329,d|0,a|0,c|0);a=v[23540];v[23540]=0;if((a|0)!=1){Lm(b,d);ic(d);break c}a=V(30544)|0;if((O()|0)!=(ea(30544)|0)){break a}_(a|0)|0;$();break b}if(!Qb(v[a>>2],v[a+8>>2],c)){break b}Xu(a,b,c)}f=fd(v[b>>2],v[b+4>>2])>>>0>=c>>>0}kb=d+16|0;return f|0}T(a|0);L()}function zI(a,b){a=a|0;b=b|0;var c=0;c=kb-16|0;kb=c;a:{b:{c:{if(b>>>0>=256){b=ba(8)|0;v[23540]=0;c=Q(55,c|0,10725)|0;a=v[23540];v[23540]=0;if((a|0)==1){break c}a=tc(b,c);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break a}a=P()|0;O()|0;zb(c);break b}kb=c+16|0;return+(+(v[(v[a+32>>2]+B(b,872)|0)+1075684>>2]-128|0)*.0078125)}a=P()|0;O()|0;ca(b|0)}T(a|0)}L()}function p1(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=a+32|0;Oq(c,b);v[a+44>>2]=0;b=v[a+48>>2];if(b&8){b=Ac(c)+Hb(c)|0;v[a+44>>2]=b;d=Ac(c);Cn(a,d,d,b);b=v[a+48>>2]}a:{if(!(b&16)){break a}b=Hb(c);e=a,f=b+Ac(c)|0,v[e+44>>2]=f;Hx(c,bd(c));d=Ac(c);Pw(a,d,Hb(c)+d|0);if(!(w[a+48|0]&3)){break a}while(1){if((b|0)<0){bs(a,2147483647);b=b-2147483647|0;continue}break}if(!b){break a}bs(a,b)}}function c5(a){a=a|0;var b=0,c=0,d=0,e=0;c=kb-32|0;kb=c;a:{e=a+36|0;b=v[e>>2];d=v[a+40>>2];b:{if(Pb(b,d)){Gc(c+24|0);break b}b=c+8|0;Kn(b,a);v[23540]=0;b=S(1006,b|0)|0;d=v[23540];v[23540]=0;if((d|0)==1){break a}v[c+24>>2]=b;Xf(c+8|0);d=v[a+40>>2];b=v[a+36>>2]}if(!Pb(b,d)){e=v[c+24>>2];b=v[e>>2]}a=Pi(b,v[e+4>>2]);al(c+24|0);kb=c+32|0;return a|0}a=P()|0;O()|0;Xf(c+8|0);T(a|0);L()}function Hh(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=kb-32|0;kb=c;a:{if(!w[b+4|0]){while(1){if((d|0)==4){d=0;v[c+28>>2]=0;e=hc(c+8|0,c+28|0,4);nc(c+16|0,v[a>>2],v[a+8>>2],v[e>>2],v[e+4>>2]);b:{if(v[c+20>>2]!=4){break b}if(Sb(c+28|0,b,4)){break b}$b(a,4);d=1}kb=c+32|0;break a}e=b+d|0;d=d+1|0;if(w[e|0]){continue}break}aa(17499,9108,413,13143);L()}aa(17478,9108,411,13143);L()}return d|0}function xI(a,b){a=a|0;b=b|0;var c=0;c=kb-16|0;kb=c;a:{b:{c:{if(b>>>0>=256){b=ba(8)|0;v[23540]=0;c=Q(55,c|0,10725)|0;a=v[23540];v[23540]=0;if((a|0)==1){break c}a=tc(b,c);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break a}a=P()|0;O()|0;zb(c);break b}kb=c+16|0;return+(+u[(v[a+32>>2]+B(b,872)|0)+1075766>>1]*30517578125e-15)}a=P()|0;O()|0;ca(b|0)}T(a|0)}L()}function u6(a){a=a|0;var b=0;v[23540]=0;Y(946,a|0);b=v[23540];v[23540]=0;if((b|0)!=1){b=v[a+24>>2];if(b){Mb(Is(b))}v[a+24>>2]=0;b=v[a+20>>2];if(b){Mb(b);v[a+20>>2]=0}Mb(a);return}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,5081,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)!=1){$();return}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function j1(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;f=kb-16|0;kb=f;while(1){a:{if((c|0)<=(g|0)){break a}d=v[a+24>>2];e=v[a+28>>2];if(d>>>0>=e>>>0){if((ob[v[v[a>>2]+52>>2]](a,v[b>>2])|0)==-1){break a}g=g+1|0;b=b+4|0}else{v[f+12>>2]=e-d>>2;v[f+8>>2]=c-g;e=d;d=v[td(f+12|0,f+8|0)>>2];ni(e,b,d);e=d<<2;v[a+24>>2]=e+v[a+24>>2];g=g+d|0;b=b+e|0}continue}break}kb=f+16|0;return g|0}function dS(a,b){var c=0,d=0,e=0;c=kb-32|0;kb=c;a:{if(!w[b+5|0]){while(1){if((d|0)==5){d=0;t[c+28|0]=0;v[c+24>>2]=0;e=hc(c+8|0,c+24|0,5);nc(c+16|0,v[a>>2],v[a+8>>2],v[e>>2],v[e+4>>2]);b:{if(v[c+20>>2]!=5){break b}if(Sb(c+24|0,b,5)){break b}$b(a,5);d=1}kb=c+32|0;break a}e=b+d|0;d=d+1|0;if(w[e|0]){continue}break}aa(17499,9108,413,13143);L()}aa(17478,9108,411,13143);L()}return d}function Nga(a){a=a|0;var b=0,c=0,d=0,e=0;e=kb-16|0;kb=e;b=vc(2500);c=kb-2496|0;kb=c;uR(a,c,c+2496|0);a=0;while(1){if((a|0)==624){v[b+2496>>2]=0;a:{if(v[b>>2]<0){break a}a=1;while(1){if((a|0)!=624){d=a<<2;a=a+1|0;if(!v[b+d>>2]){continue}break a}break}v[b>>2]=-2147483648}kb=c+2496|0}else{d=a<<2;v[d+b>>2]=v[c+d>>2];a=a+1|0;continue}break}a=v[Lf(e+8|0,b)>>2];kb=e+16|0;return a|0}function q6(a,b){a=a|0;b=b|0;var c=0;v[23540]=0;Y(946,a|0);c=v[23540];v[23540]=0;a:{b:{if((c|0)!=1){v[a+16>>2]=b;b=v[a+20>>2];if(!b){break b}Mb(b);v[a+20>>2]=0;return}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,5663,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)==1){break a}$()}return}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function E9(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=kb-16|0;kb=d;c=vc(64);v[23540]=0;e=S(835,c|0)|0;f=v[23540];v[23540]=0;a:{if((f|0)!=1){c=Lf(d,e);e=v[c>>2];v[23540]=0;a=W(895,e|0,a|0,b|0)|0;b=v[23540];v[23540]=0;b:{c:{if((b|0)!=1){if((a|0)==1){break c}Gc(d+8|0);break b}a=P()|0;O()|0;sg(c);break a}eg(d+8|0,c)}sg(c);kb=d+16|0;return v[d+8>>2]}a=P()|0;O()|0;Mb(c)}T(a|0);L()}function h9(a,b){a=a|0;b=b|0;var c=C(0);a:{switch(b|0){case 0:return C(z[a+4220>>2]);case 1:return C(z[a+4224>>2]);case 2:return C(z[a+4228>>2]);case 3:return C(w[a+4240|0]?C(1):C(0));case 4:return C(C(C(v[a+4232>>2])*C(.03125)));case 5:return C(w[a+4241|0]?C(1):C(0));case 6:return C(w[a+4242|0]?C(1):C(0));case 7:c=w[a+4244|0]?C(1):C(0);break;default:break a}}return C(c)}function KP(a,b){var c=0,d=0,e=0,f=0;c=kb-16|0;kb=c;a=Nb(a);d=Hb(b);v[23540]=0;R(46,a|0,d|0);d=v[23540];v[23540]=0;a:{if((d|0)!=1){e=c,f=nt(b),v[e+8>>2]=f;e=c,f=mt(b),v[e>>2]=f;while(1){if(!pj(c+8|0,c)){break a}b=w[v[c+8>>2]];v[23540]=0;R(47,a|0,((b|0)==13?10:b)<<24>>24);b=v[23540];v[23540]=0;if((b|0)!=1){Ke(c+8|0);continue}break}}b=P()|0;O()|0;zb(a);T(b|0);L()}kb=c+16|0}function _T(a){var b=0,c=0;a:{if(Sb(a,15262,3)){break a}c=w[a+3|0];if(c>>>0>9){break a}if((Ib(w[a+202|0]|w[a+203|0]<<8)-1e4&65535)>>>0<57516){break a}b=1;b:{if(c>>>0>5){break b}if(!Ib(w[a+228|0]|w[a+229|0]<<8)){break a}if(!Ib(w[a+230|0]|w[a+231|0]<<8)){break a}b=0;if(Ib(w[a+232|0]|w[a+233|0]<<8)>>>0>4095){break b}b=Ib(w[a+234|0]|w[a+235|0]<<8)>>>0<100}return b}return 0}function rD(a,b,c){var d=0,e=0,f=0,g=0;a:{d=to(b,Tj(a));c=to(c,b);if(Ad(v[a+4>>2],w[a+11|0])>>>0>=d>>>0){if((c|0)==-1){dB(a,sd(a),d);break a}b=a;e=kb-16|0;kb=e;v[e+12>>2]=c;if(c){f=Ad(v[b+4>>2],w[b+11|0]);g=sd(b);c=f-d|0;v[e+8>>2]=c;a=v[Kb(e+12|0,e+8|0)>>2];v[e+12>>2]=a;b:{if((a|0)==(c|0)){a=c;break b}d=d+g|0;Yh(d,a+d|0,c-a|0)}dB(b,g,f-a|0)}kb=e+16|0;break a}sk();L()}}function pja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;v[a>>2]=0;v[a+4>>2]=0;Gc(a+8|0);if(b){if(th(2147483647)>>>0<b>>>0){cd();L()}e=b<<1;d=vc(e);v[a>>2]=d;v[a+4>>2]=d;g=Gb(a),h=d+e|0,v[g>>2]=h;e=kb-16|0;kb=e;d=ai(e,a,b);b=v[d+4>>2];f=v[d+8>>2];while(1){if((b|0)==(f|0)){lc(d);kb=e+16|0}else{Kj(b,w[c|0]|w[c+1|0]<<8);b=b+2|0;v[d+4>>2]=b;continue}break}}return a|0}function h8(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;a=vi(a,b,c,d);v[a>>2]=45460;b=a+4208|0;e=Eb(b,0),f=1060320051,v[e>>2]=f;e=Eb(b,1),f=1041865114,v[e>>2]=f;e=Eb(b,2),f=1065353216,v[e>>2]=f;e=Eb(b,3),f=1049951732,v[e>>2]=f;e=Eb(b,4),f=1049951732,v[e>>2]=f;v[23540]=0;R(897,a+44|0,2);b=v[23540];v[23540]=0;if((b|0)!=1){ui(a);return a|0}b=P()|0;O()|0;If(a);T(b|0);L()}function wx(a,b,c){var d=0,e=0,f=0;v[a>>2]=0;v[a+4>>2]=0;Gc(a+8|0);if(c){Bk(a,c);d=kb-16|0;kb=d;e=Ah(d,a,c);c=v[e+4>>2];f=v[e+8>>2];while(1){if((c|0)==(f|0)){lc(e);kb=d+16|0}else{v[c>>2]=0;Gc(c);c=c+4|0;v[e+4>>2]=c;continue}break}}c=0;e=0;d=kb-16|0;kb=d;f=d+8|0;while(1){if(c>>>0<32){c=c+48|0;e=QM(b);continue}break}v[f>>2]=e;Un(f);kb=d+16|0;v[a+12>>2]=v[f>>2];return a}function Vi(a,b,c,d,e){var f=0,g=0,h=0;f=kb-16|0;kb=f;v[f+8>>2]=b;b=0;g=6;a:{b:{if(ak(a,f+8|0)){break b}g=4;h=Xk(v[a>>2]);if(!Wk(d,2048,h)){break b}b=wn(d,h);while(1){c:{b=b-48|0;h=Dn(a);if(!cs(h,f+8|0)|(e|0)<2){break c}g=Xk(v[h>>2]);if(!Wk(d,2048,g)){break a}e=e-1|0;b=wn(d,g)+B(b,10)|0;continue}break}g=2;if(!ak(h,f+8|0)){break a}}v[c>>2]=v[c>>2]|g}kb=f+16|0;return b}function Ix(a){var b=C(0),c=C(0),d=0,e=C(0),f=0;b=C(y[v[a+16>>2]+24620>>2]);c=C(C(C(ob[v[v[a>>2]+208>>2]](a))*b)/C(1e3));d=a,e=C(C(c*C(ob[v[v[a>>2]+200>>2]](a)))*C(2048)),z[d+4248>>2]=e;d=a,f=Uh(C(C(c+C(2))*C(4096))),v[d+4256>>2]=f;c=C(ob[v[v[a>>2]+212>>2]](a));z[a+4252>>2]=c;b=C(c/b);if(!(ob[v[v[a>>2]+196>>2]](a)|0)){b=XK(C(b*C(3.1415927410125732)))}z[a+4244>>2]=b+b}function I2(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;v[a>>2]=0;v[a+4>>2]=0;Gc(a+8|0);if(c){if(th(357913941)>>>0<c>>>0){cd();L()}d=gE(c);v[a>>2]=d;v[a+4>>2]=d;f=Gb(a),g=d+B(c,12)|0,v[f>>2]=g;e=Nd(b,c);d=kb-16|0;kb=d;c=Ot(d,a,c);v[23540]=0;U(1079,b|0,e|0,c+4|0);b=v[23540];v[23540]=0;a:{if((b|0)!=1){lc(c);kb=d+16|0;break a}a=P()|0;O()|0;lc(c);T(a|0);L()}}return a|0}function Hy(a,b,c,d){a:{if(v[a+1074392>>2]!=(c|0)){break a}b:{if(d){c=B(b,872)+a|0;v[c+1075688>>2]=0;d=c+1075e3|0;v[d>>2]=0;v[d+4>>2]=0;d=c+1075080|0;c=v[d>>2]|4096;v[d>>2]=c;break b}c=B(b,872)+a|0;v[c+1075680>>2]=0;c=v[c+1075080>>2]}d=B(b,872)+a|0;v[d+1075080>>2]=c|2097152;sm(a,b,255,0);if(!(w[d+1075081|0]&2)){break a}a=v[a+1298300>>2];if(!zd(a)){break a}rj(a,b,0)}}function im(a){if((a|0)>=0){if(a>>>0<=16383){if(a>>>0<=15){return t[a+72752|0]}if(a>>>0<=511){return t[(a>>>5|0)+72752|0]+5|0}return t[(a>>>10|0)+72752|0]+10|0}if(a>>>0<=16777215){if(a>>>0<=524287){return t[(a>>>15|0)+72752|0]+15|0}return t[(a>>>20|0)+72752|0]+20|0}if(a>>>0<=536870911){return t[(a>>>25|0)+72752|0]+25|0}a=t[(a>>>30|0)+72752|0]+30|0}else{a=0}return a}function t6(a){a=a|0;var b=0;v[23540]=0;Y(946,a|0);b=v[23540];v[23540]=0;a:{b:{if((b|0)!=1){v[a+16>>2]=0;b=v[a+20>>2];if(!b){break b}Mb(b);v[a+20>>2]=0;return}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,8945,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)==1){break a}$()}return}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function YE(a,b,c){var d=0;d=kb-16|0;kb=d;a:{b:{c:{if(b>>>0>=256){b=ba(8)|0;v[23540]=0;c=Q(55,d|0,10725)|0;a=v[23540];v[23540]=0;if((a|0)==1){break c}a=tc(b,c);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break a}a=P()|0;O()|0;zb(c);break b}a=(v[a+32>>2]+B(b,872)|0)+1075080|0;v[a>>2]=v[a>>2]|c;kb=d+16|0;return}a=P()|0;O()|0;ca(b|0)}T(a|0)}L()}function RI(a,b){a=a|0;b=b|0;var c=0;c=kb-16|0;kb=c;a:{b:{c:{if(b-513>>>0<=4294966814){b=ba(8)|0;v[23540]=0;c=Q(55,c|0,9392)|0;a=v[23540];v[23540]=0;if((a|0)==1){break c}a=tc(b,c);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break a}a=P()|0;O()|0;zb(c);break b}v[v[a+32>>2]+1074420>>2]=B(b,1e4);kb=c+16|0;return}a=P()|0;O()|0;ca(b|0)}T(a|0)}L()}function CV(a,b){var c=0,d=0;b=!v[a+24>>2]|b;v[a+16>>2]=b;if(b&v[a+20>>2]){a=kb-16|0;kb=a;c=ba(16)|0;b=kb-16|0;kb=b;if(!w[464688]){t[464688]=1}hc(b+8|0,1,93848);d=v[b+12>>2];v[a+8>>2]=v[b+8>>2];v[a+12>>2]=d;kb=b+16|0;b=v[a+12>>2];a=v[a+8>>2];v[23540]=0;a=oF(1106,c,8972,a,b);b=v[23540];v[23540]=0;if((b|0)!=1){ha(a|0,78436,1107);L()}a=P()|0;O()|0;ca(c|0);T(a|0);L()}}function C3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=kb-16|0;kb=c;a:{b:{if((dk(w[a+140|0])|0)!=1){break b}if((LJ(a)|0)!=(b|0)){break b}d=a+120|0;zs(w[d+20|0]);b=kb-16|0;kb=b;v[b+8>>2]=c+8;a=kb-16|0;kb=a;e=v[14459];v[a+8>>2]=v[14458];v[a+12>>2]=e;e=v[14457];v[a>>2]=v[14456];v[a+4>>2]=e;ob[v[yp(a,dk(w[d+20|0]))>>2]](b+8|0,d);kb=a+16|0;kb=b+16|0;break a}KJ(a,1,b)}kb=c+16|0}function dia(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;f=kb-16|0;kb=f;c=rf(a,c);me(f,v[a+36>>2]);a:{if(!c){Sc(f,a+32|0,5);e=0;if(Cb(v[v[f>>2]>>2],v[f+4>>2])){break a}}h=v[a+36>>2];g=kb-16|0;kb=g;e=Nb(g);v[23540]=0;fa(457,b|0,h|0,e|0,d|0)|0;b=v[23540];v[23540]=0;b:{if((b|0)!=1){Ab(e);kb=g+16|0;break b}a=P()|0;O()|0;Ab(e);T(a|0);L()}e=c}Ye(a,e);kb=f+16|0}function TC(a){var b=0,c=0,d=0,e=0,f=0;a:{b:{if(Sb(a,11143,2)){if(Sb(a,13797,2)){break a}if(w[a+110|0]<=64){break b}break a}if(w[a+110|0]>64){break a}}if(t[a+112|0]<0|w[a+111|0]>128){break a}while(1){d=(b|0)==128;if(d){break a}c=a+b|0;e=t[c+113|0];if((e|0)<-2){break a}f=w[c+241|0];if(!f&(e|0)>=0|f>>>0>15){break a}b=b+1|0;if(w[c+369|0]<64){continue}break}}return d}function Qr(a,b,c){var d=0,e=0;if(c&2048){t[a|0]=43;a=a+1|0}if(c&1024){t[a|0]=35;a=a+1|0}d=c&260;if((d|0)!=260){t[a|0]=46;t[a+1|0]=42;a=a+2|0}c=c&16384;while(1){e=w[b|0];if(e){t[a|0]=e;a=a+1|0;b=b+1|0;continue}break}a:{b:{if((d|0)!=256){if((d|0)!=4){break b}b=c?70:102;break a}b=c?69:101;break a}b=c?65:97;if((d|0)==260){break a}b=c?71:103}t[a|0]=b;return(d|0)!=260}function r6(a){a=a|0;var b=0;v[23540]=0;Y(946,a|0);b=v[23540];v[23540]=0;a:{b:{if((b|0)!=1){a=v[a+20>>2];if(!a){break b}return gg(a)|0}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,12164,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)==1){break a}$();return 0}return gg(21688)|0}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function kka(a,b){a=a|0;b=b|0;var c=0,d=0;d=kb-16|0;kb=d;c=d+8|0;Gu(c,a,b);Pf(b,w[d+8|0],w[Oc(c)|0]);a=w[b+3|0];a:{if((a|0)!=9){if((a|0)!=19){break a}a=w[b+5|0];c=a&240;if((c|0)!=128){if((c|0)!=64){if((c|0)!=48){break a}t[b+3|0]=45;t[b+5|0]=a&15;break a}if((a|0)!=64){break a}t[b+3|0]=0;t[b|0]=254;break a}t[b+3|0]=20;t[b+5|0]=a&15|160;break a}t[b+3|0]=0}kb=d+16|0}function hW(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=kb-16|0;kb=d;c=-1;a:{if(!fg(a,7)){break a}c=0;if(!rC(a,11763)){break a}c=kb-16|0;kb=c;nC(c+8|0,d);e=v[c+12>>2];md(c,a,v[c+8>>2],v[c+12>>2]);f=v[c+4>>2];if((f|0)==(e|0)){id(a,v[c+12>>2])}kb=c+16|0;e=(e|0)==(f|0);if(!e){mC(d)}c=-1;if(!e){break a}c=0;if(!qC(w[d+1|0])){break a}c=Ae(a,b,oC(d),nb)}kb=d+16|0;return c|0}function vN(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0;d=(B(b,872)+a|0)+1429|0;e=v[a+16>>2];if(e){d=w[d|0]}else{t[d|0]=0;d=0}f=v[a+40>>2];b=B(b,872)+a|0;a=b+1467|0;t[a|0]=w[a|0]|64;a=b+1468|0;h=a;i=v[a>>2];g=(+(e>>>0)+1)*+(c|0)/+(f>>>0);a:{if(D(g)<2147483648){a=~~g;break a}a=-2147483648}v[h>>2]=i+(a+((c|0)<0?d:0-d|0)|0);c=(f|0)==(e+1|0)?c:a;a=c>>31;t[b+1429|0]=(a^c)-a}function uM(a,b){var c=0,d=0,e=0,f=0;a:{if(x[a+480188>>1]<=b>>>0){break a}b:{c:{c=B(b,872)+a|0;d=w[c+1075783|0];switch(d-31|0){case 1:break b;case 0:break c;default:break a}}if(!(w[a+480209|0]&16)){break a}}e=a+1074376|0;f=(d|0)==32;c=t[c+1075785|0];d:{if((c|0)>=0){d=ye(a+901692|0,w[(B(b,872)+a|0)+1075836|0]);break d}d=ye(a+902204|0,c&127)}NN(a,e,b,f,d,c&255)}}function sba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;v[a>>2]=b;c=kb-16|0;kb=c;d=vc(223888);v[23540]=0;b=Q(802,d|0,b+1074376|0)|0;e=v[23540];v[23540]=0;a:{if((e|0)!=1){b=v[Lf(c+8|0,b)>>2];kb=c+16|0;break a}a=P()|0;O()|0;Mb(d);T(a|0);L()}v[a+4>>2]=b;b=Tb(a+8|0);v[23540]=0;Y(585,a|0);c=v[23540];v[23540]=0;if((c|0)!=1){return a|0}c=P()|0;O()|0;qe(b);BN(a+4|0);T(c|0);L()}function X4(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;v[23540]=0;Y(946,a|0);f=v[23540];v[23540]=0;if((f|0)!=1){return Cx(v[v[a+24>>2]+24>>2],b,c,d,e)|0}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,12407,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)!=1){$();return 0}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function SI(a,b){a=a|0;b=b|0;var c=0;c=kb-16|0;kb=c;a:{b:{c:{if(b-65536>>>0<=4294901760){b=ba(8)|0;v[23540]=0;c=Q(55,c|0,5851)|0;a=v[23540];v[23540]=0;if((a|0)==1){break c}a=tc(b,c);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break a}a=P()|0;O()|0;zb(c);break b}v[v[a+32>>2]+1074416>>2]=b;kb=c+16|0;return}a=P()|0;O()|0;ca(b|0)}T(a|0)}L()}function wU(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=kb-32|0;kb=d;e=Tb(a);a=Fb(v[b>>2]);v[d+24>>2]=a;b=Fb(v[b+4>>2]);a:{while(1){if(Pb(a,b)){_h(d,v[a>>2],v[a+4>>2]);if((bc(v[d>>2])|0)==(c|0)){Bo(d,a);v[23540]=0;R(352,e|0,d|0);a=v[23540];v[23540]=0;if((a|0)==1){break a}Bb(d)}a=v[Om(d+24|0)>>2];continue}break}kb=d+32|0;return}a=P()|0;O()|0;Bb(d);Vc(e);T(a|0);L()}function Zn(a,b,c,d){a:{if(v[a+480180>>2]==4){if(c){t[b+810|0]=w[b+810|0]&15|c<<4;break a}c=w[b+810|0]>>>4|0;break a}if(d){if(c){t[b+834|0]=c;break a}c=w[b+834|0];break a}if(c){t[b+810|0]=c;break a}c=w[b+810|0]}b:{if(!(t[b+851|0]&1)){break b}c=v[b+688>>2]+((c&255)<<2)|0;v[b+688>>2]=(c|0)<256?c:256;if(!(t[a+480180|0]&1)){break b}v[b+88>>2]=v[b+88>>2]|2097152}}function ZE(a,b,c,d,e,f,g){var h=0,i=0,j=0;h=kb-16|0;kb=h;a:{b:{c:{if(b<g|b>f){a=ba(8)|0;v[23540]=0;d=Q(55,h|0,e|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break c}a=tc(a,d);v[23540]=0;U(119,a|0,62752,950);a=v[23540];v[23540]=0;if((a|0)!=1){break a}e=P()|0;O()|0;zb(d);break b}i=v[a+32>>2]+d|0,j=Qe(b*c),v[i>>2]=j;kb=h+16|0;return}e=P()|0;O()|0;ca(a|0)}T(e|0)}L()}function DG(a,b,c,d){var e=0,f=0,g=0;e=kb-16|0;kb=e;a:{if((a|0)!=(b|0)){g=v[116016];v[116016]=0;Gd();d=KG(a,e+12|0,d);a=nb;f=v[116016];b:{if(f){if(v[e+12>>2]!=(b|0)){break b}if((f|0)!=68){break a}v[c>>2]=4;a=!!d&(a|0)>=0|(a|0)>0;d=a?-1:0;a=a?2147483647:-2147483648;break a}v[116016]=g;if(v[e+12>>2]==(b|0)){break a}}}v[c>>2]=4;d=0;a=0}kb=e+16|0;nb=a;return d}function Ht(a,b){var c=0,d=0;c=kb-32|0;kb=c;d=c+16|0;kQ(d,a,a+1|0,a+2|0,a+3|0);kQ(c,b,b+1|0,b+2|0,b+3|0);b=Gt(w[v[d>>2]],w[v[c>>2]]);a:{if(!yj(b)){break a}b=w[v[d+4>>2]];a=w[v[c+4>>2]];b=(a|0)==(b|0)?0:b<<24>>24<a<<24>>24?-1:1;if(!yj(b)){break a}b=Gt(w[v[d+8>>2]],w[v[c+8>>2]]);if(!yj(b)){break a}b=Gt(w[v[d+12>>2]],w[v[c+12>>2]])}a=kf(b);kb=c+32|0;return a}function fW(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;a:{e=kb-32|0;kb=e;_u(e+8|0,c);c=w[d|0];v[23540]=0;R(243,e+20|0,c|0);c=v[23540];v[23540]=0;b:{c:{if((c|0)!=1){Yj(e,e+8|0);v[23540]=0;X(114,a|0,b|0,v[e>>2],v[e+4>>2]);a=v[23540];v[23540]=0;if((a|0)==1){break c}Wg(e+8|0);kb=e+32|0;break a}a=P()|0;O()|0;Ab(e+8|0);break b}a=P()|0;O()|0;Wg(e+8|0)}T(a|0);L()}}function g5(a){a=a|0;var b=0;v[23540]=0;Y(946,a|0);b=v[23540];v[23540]=0;if((b|0)!=1){a=v[v[a+24>>2]+24>>2];return tj(Wb(v[a+484360>>2],w[a+484376|0]))|0}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,6888,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)!=1){$();return 0}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function m6(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;f=kb-16|0;kb=f;v[f+8>>2]=d;d=v[eg(f,f+8|0)>>2];v[23540]=0;ja(944,a+8|0,b|0,c|0,d|0,e|0)|0;b=v[23540];v[23540]=0;if((b|0)!=1){a=WI(a);b=VI(a+88|0);c=UI(a+92|0);d=TI(a+96|0);v[a>>2]=62504;v[b>>2]=62620;v[c>>2]=62700;v[d>>2]=62740;De(f+8|0);kb=f+16|0;return a|0}a=P()|0;O()|0;De(f+8|0);T(a|0);L()}function It(a,b){var c=0,d=0;if(a-268435457>>>0>=4026531840){a=a+208|0;Jka(b,0,a,0);a=nb?0:B(a,b)}else{a=0}a:{if(!a){break a}v[23540]=0;b=S(751,a|0)|0;c=v[23540];v[23540]=0;b:{c:{if((c|0)==1){b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;Z(18);c=v[23540];v[23540]=0;b=0;if((c|0)==1){break c}}break b}V(0)|0;O()|0;Vb();L()}if(!b){break a}d=Ub(b,0,a)- -64|0}return d}function f5(a){a=a|0;var b=0;v[23540]=0;Y(946,a|0);b=v[23540];v[23540]=0;if((b|0)!=1){a=v[v[a+24>>2]+24>>2];return rt(v[a+484344>>2],v[a+484348>>2])|0}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,6956,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)!=1){$();return 0}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function aA(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=kb-32|0;kb=d;e=Tb(a);a=Fb(v[b>>2]);v[d+24>>2]=a;b=Fb(v[b+4>>2]);a:{while(1){if(Pb(a,b)){_h(d,v[a>>2],v[a+4>>2]);if(v[d>>2]==(c|0)){Bo(d,a);v[23540]=0;R(352,e|0,d|0);a=v[23540];v[23540]=0;if((a|0)==1){break a}Bb(d)}a=v[Om(d+24|0)>>2];continue}break}kb=d+32|0;return}a=P()|0;O()|0;Bb(d);Vc(e);T(a|0);L()}function x0(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;e=v[a+84>>2];f=v[e>>2];d=v[e+4>>2];h=v[a+28>>2];g=v[a+20>>2]-h|0;g=d>>>0<g>>>0?d:g;if(g){sc(f,h,g);f=g+v[e>>2]|0;v[e>>2]=f;d=v[e+4>>2]-g|0;v[e+4>>2]=d}d=c>>>0>d>>>0?d:c;if(d){sc(f,b,d);f=d+v[e>>2]|0;v[e>>2]=f;v[e+4>>2]=v[e+4>>2]-d}t[f|0]=0;b=v[a+44>>2];v[a+28>>2]=b;v[a+20>>2]=b;return c|0}function op(a,b,c){var d=0,e=0,f=0;e=kb-16|0;kb=e;d=e+8|0;gd(d,b);v[23540]=0;b=S(1133,d|0)|0;d=v[23540];v[23540]=0;a:{if((d|0)==1){break a}v[23540]=0;d=S(1142,b|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break a}v[c>>2]=d;v[23540]=0;R(1143,a|0,b|0);a=v[23540];v[23540]=0;if((a|0)==1){break a}ac(e+8|0);kb=e+16|0;return}a=P()|0;O()|0;ac(e+8|0);T(a|0);L()}function gJ(a,b,c,d){var e=0,f=0,g=0,h=0,i=0;g=kb-16|0;kb=g;e=Hb(a);if(e>>>0>=b>>>0){f=bd(a);a:{if(f-e>>>0>=d>>>0){if(!d){break a}f=Ac(a);i=f+b|0;if((b|0)!=(e|0)){h=b+f|0;Yh(h+d|0,h,e-b|0);c=(c>>>0>=h>>>0?e+f>>>0>c>>>0?d:0:0)+c|0}Yh(i,c,d);b=d+e|0;Sh(a,b);t[g+15|0]=0;we(b+f|0,g+15|0);break a}kp(a,f,(d+e|0)-f|0,e,b,0,d,c)}kb=g+16|0;return a}sk();L()}function _Q(a,b){var c=0,d=0,e=0;c=kb-32|0;kb=c;a:{if(!w[b+4|0]){while(1){if((d|0)==4){d=0;v[c+28>>2]=0;e=hc(c+8|0,c+28|0,4);md(c+16|0,a,v[e>>2],v[e+4>>2]);b:{if(v[c+20>>2]!=4){break b}if(Sb(c+28|0,b,4)){break b}id(a,4);d=1}kb=c+32|0;break a}e=b+d|0;d=d+1|0;if(w[e|0]){continue}break}aa(17499,9108,413,13143);L()}aa(17478,9108,411,13143);L()}return d}function qp(a,b,c){var d=0,e=0,f=0;e=kb-16|0;kb=e;d=e+8|0;gd(d,b);v[23540]=0;b=S(1115,d|0)|0;d=v[23540];v[23540]=0;a:{if((d|0)==1){break a}v[23540]=0;d=S(1128,b|0)|0;f=v[23540];v[23540]=0;if((f|0)==1){break a}t[c|0]=d;v[23540]=0;R(1129,a|0,b|0);a=v[23540];v[23540]=0;if((a|0)==1){break a}ac(e+8|0);kb=e+16|0;return}a=P()|0;O()|0;ac(e+8|0);T(a|0);L()}function V7(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;b=eL(a,b,c,d,e^1);v[b>>2]=46072;a=b+4208|0;f=Eb(a,0),g=1056964608,v[f>>2]=g;f=Eb(a,1),g=1065353216,v[f>>2]=g;f=Eb(a,2),g=1020054733,v[f>>2]=g;f=Eb(a,3),g=1065353216,v[f>>2]=g;f=Eb(a,4),g=1056964608,v[f>>2]=g;f=Eb(a,5),g=1048406533,v[f>>2]=g;f=Eb(a,6),g=1056964608,v[f>>2]=g;return b|0}function Saa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;b=kb-16|0;kb=b;u[a>>1]=0;c=Tb(a+4|0);d=Tb(a+16|0);v[a+36>>2]=0;e=Nb(a+40|0);f=Yf(a+52|0);Lc(c);u[a+28>>1]=65472;v[23540]=0;v[b+12>>2]=1065353216;R(839,c|0,b+12|0);g=v[23540];v[23540]=0;if((g|0)!=1){v[a+32>>2]=0;u[a+30>>1]=0;Lc(d);kb=b+16|0;return a|0}a=P()|0;O()|0;oT(f);Ab(e);wc(d);wc(c);T(a|0);L()}function GL(a,b){var c=0,d=0,e=0,f=0,g=0,h=C(0);c=kb-16|0;kb=c;d=0;a:{if(!Yg(v[v[a>>2]-12>>2]+a|0)){break a}v[c+12>>2]=0;pk(a,c+12|0);e=v[c+12>>2];d=0;if(e>>>0>65535){break a}ek(b,e);while(1){if((f|0)==(e|0)){d=Yg(v[v[a>>2]-12>>2]+a|0)}else{v[c+8>>2]=0;Hp(a,c+8|0);g=Eb(v[b>>2],f),h=z[c+8>>2],z[g>>2]=h;f=f+1|0;continue}break}}a=d;kb=c+16|0;return a}function rba(a,b){a=a|0;b=b|0;var c=0,d=0;if(v[a+4>>2]!=v[Gb(a)>>2]){c=kb-16|0;kb=c;v[c>>2]=a;a=v[a+4>>2];v[c+4>>2]=a;v[c+8>>2]=a+32;lN(v[c+4>>2],b);v[c+4>>2]=v[c+4>>2]+32;lc(c);kb=c+16|0;return}d=kb-32|0;kb=d;c=Gb(a);c=Ct(d+8|0,gq(a,rg(v[a>>2],v[a+4>>2])+1|0),rg(v[a>>2],v[a+4>>2]),c);lN(v[c+8>>2],b);v[c+8>>2]=v[c+8>>2]+32;Fd(a,c);dQ(c);kb=d+32|0}function fja(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;a:{e=kb-32|0;kb=e;HT(e+8|0,c);v[23540]=0;R(113,e+20|0,d|0);c=v[23540];v[23540]=0;b:{c:{if((c|0)!=1){Yj(e,e+8|0);v[23540]=0;X(114,a|0,b|0,v[e>>2],v[e+4>>2]);a=v[23540];v[23540]=0;if((a|0)==1){break c}Wg(e+8|0);kb=e+32|0;break a}a=P()|0;O()|0;Ab(e+8|0);break b}a=P()|0;O()|0;Wg(e+8|0)}T(a|0);L()}}function bha(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;a:{e=kb-32|0;kb=e;Lq(e+8|0,c);v[23540]=0;R(575,e+20|0,d|0);c=v[23540];v[23540]=0;b:{c:{if((c|0)!=1){Yj(e,e+8|0);v[23540]=0;X(296,a|0,b|0,v[e>>2],v[e+4>>2]);a=v[23540];v[23540]=0;if((a|0)==1){break c}mS(e+8|0);kb=e+32|0;break a}a=P()|0;O()|0;zb(e+8|0);break b}a=P()|0;O()|0;mS(e+8|0)}T(a|0);L()}}function R6(a){a=a|0;var b=0,c=0,d=0,e=0;b=kb-32|0;kb=b;a=Tb(a);v[23540]=0;Y(936,b+16|0);c=v[23540];v[23540]=0;a:{b:{if((c|0)!=1){c=Fb(v[b+16>>2]);d=Fb(v[b+20>>2]);e=v[fc(b+8|0,a)>>2];v[23540]=0;U(937,c|0,d|0,e|0);c=v[23540];v[23540]=0;if((c|0)==1){break b}wc(b+16|0);kb=b+32|0;return}c=P()|0;O()|0;break a}c=P()|0;O()|0;wc(b+16|0)}Xe(a);T(c|0);L()}function FT(a){var b=0,c=0,d=0;a:{if(Sb(a+60|0,15576,4)|(w[a+32|0]|w[a+33|0]<<8)>>>0>256|(w[a+49|0]<32|(w[a+36|0]|w[a+37|0]<<8)>>>0>255)){break a}if(t[a+51|0]<4|w[a+50|0]>64){break a}b=a+576|0;a=a- -64|0;while(1){if((a|0)==(b|0)){d=c;break a}b:{switch(w[a+15|0]){case 0:case 1:c=1;break;case 2:break b;default:break a}}a=a+16|0;continue}}return d&1}function n4(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;v[23540]=0;Y(946,a|0);d=v[23540];v[23540]=0;if((d|0)!=1){v[a+16>>2]=0;v[a+12>>2]=c;v[a+8>>2]=b;return}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,13028,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)!=1){$();return}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function eU(a){var b=0,c=0;a:{if(Sb(a,13901,3)|(w[a+3|0]-1&255)>>>0>3){break a}if(Ib(w[a+196|0]|w[a+197|0]<<8)>>>0>255){break a}if((Ib(w[a+198|0]|w[a+199|0]<<8)-1&65535)>>>0>255){break a}if((Ib(w[a+200|0]|w[a+201|0]<<8)-1&65535)>>>0>31){break a}b=Ib(w[a+202|0]|w[a+203|0]<<8);if(b>>>0>256){break a}c=Ib(w[a+204|0]|w[a+205|0]<<8)>>>0<b>>>0}return c}function bY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;a:{e=kb-32|0;kb=e;nn(e+8|0,c);v[23540]=0;R(113,e+20|0,d|0);c=v[23540];v[23540]=0;b:{c:{if((c|0)!=1){Yj(e,e+8|0);v[23540]=0;X(114,a|0,b|0,v[e>>2],v[e+4>>2]);a=v[23540];v[23540]=0;if((a|0)==1){break c}Wg(e+8|0);kb=e+32|0;break a}a=P()|0;O()|0;Ab(e+8|0);break b}a=P()|0;O()|0;Wg(e+8|0)}T(a|0);L()}}function Pu(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;a:{e=kb-32|0;kb=e;XB(e+8|0,c);v[23540]=0;R(113,e+20|0,d|0);c=v[23540];v[23540]=0;b:{c:{if((c|0)!=1){Yj(e,e+8|0);v[23540]=0;X(114,a|0,b|0,v[e>>2],v[e+4>>2]);a=v[23540];v[23540]=0;if((a|0)==1){break c}Wg(e+8|0);kb=e+32|0;break a}a=P()|0;O()|0;Ab(e+8|0);break b}a=P()|0;O()|0;Wg(e+8|0)}T(a|0);L()}}function et(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=kb-16|0;kb=e;a:{if(!b){break a}Db(e+8|0,a+1074312|0,73);j=Cb(v[v[e+8>>2]>>2],v[e+12>>2])?c- -64|0:c;c=120;h=mj(a);k=h^-1;f=1;while(1){if(!c){break a}l=c;c=c>>>1|0;i=f+c|0;g=eh(a,i,j,d);if(!(g>>>0>b>>>0&k)&(!(!g|h)|b>>>0<=g>>>0)){continue}f=i+1|0;c=(c^-1)+l|0;continue}}kb=e+16|0;return f}function Yn(a,b,c,d){a:{if(v[a+480180>>2]==4){d=w[b+810|0];if(c){t[b+810|0]=d&240|c;break a}c=d&15;break a}if(d){if(c){t[b+834|0]=c;break a}c=w[b+834|0];break a}if(c){t[b+810|0]=c;break a}c=w[b+810|0]}b:{if(!(t[b+851|0]&1)){break b}c=v[b+688>>2]-((c&255)<<2)|0;v[b+688>>2]=(c|0)>0?c:0;if(!(t[a+480180|0]&1)){break b}v[b+88>>2]=v[b+88>>2]|2097152}}function O3(a,b){a=a|0;b=b|0;var c=0,d=0;if(y[a+4>>2]<y[Gb(a)>>2]){c=kb-16|0;kb=c;v[c>>2]=a;a=v[a+4>>2];v[c+4>>2]=a;v[c+8>>2]=a+24;VJ(v[c+4>>2],b);v[c+4>>2]=v[c+4>>2]+24;lc(c);kb=c+16|0;return}d=kb-32|0;kb=d;c=Gb(a);c=sE(d+8|0,tE(a,Pi(v[a>>2],v[a+4>>2])+1|0),Pi(v[a>>2],v[a+4>>2]),c);VJ(v[c+8>>2],b);v[c+8>>2]=v[c+8>>2]+24;rE(a,c);pE(c);kb=d+32|0}function nw(a,b,c,d){t[a+53|0]=1;a:{if(v[a+4>>2]!=(c|0)){break a}t[a+52|0]=1;c=v[a+16>>2];b:{if(!c){v[a+36>>2]=1;v[a+24>>2]=d;v[a+16>>2]=b;if((d|0)!=1){break a}if(v[a+48>>2]==1){break b}break a}if((b|0)==(c|0)){c=v[a+24>>2];if((c|0)==2){v[a+24>>2]=d;c=d}if(v[a+48>>2]!=1){break a}if((c|0)==1){break b}break a}v[a+36>>2]=v[a+36>>2]+1}t[a+54|0]=1}}function Tu(a,b,c,d){var e=0,f=0;a:{e=w[a|0];f=w[c|0];b:{if(!(w[d|0]|((e|0)!=11|(f-5&255)>>>0>1))){t[a|0]=(f|0)==5?7:6;break b}if(!(w[b|0]|((f|0)!=11|(e-5&255)>>>0>1))){t[a|0]=(e|0)==5?7:6;t[b|0]=w[d|0];break b}if(!((e|0)!=10|(f|0)!=20|w[d|0]!=159)){t[a|0]=42;break b}if(w[b|0]!=159|(f|0)!=10|(e|0)!=20){break a}t[a|0]=42;t[b|0]=w[d|0]}t[c|0]=0}}function $I(a){var b=0,c=0,d=0,e=0,f=0,g=0;a:{b=v[a>>2];b:{if(!b){break b}c=v[a+8>>2];if(!c){break b}a=v[a+12>>2];if(!a){break b}e=ob[a|0](b)|0;d=nb;if((d|0)<0){break b}if((ob[c|0](b,0,0,0)|0)<0){break a}if((ob[c|0](b,0,0,2)|0)<0){break a}f=ob[a|0](b)|0;a=nb;ob[c|0](b,e,d,0)|0;if((a|0)<0){break b}g=cz(f,a)}return g}ob[c|0](b,e,d,0)|0;return 0}function UC(a,b){var c=0,d=0,e=0,f=0;c=kb-16|0;kb=c;a:{if(b>>>0<3){if(!b){break a}if(!Qb(v[a>>2],v[a+8>>2],b)){break a}while(1)if((d|0)==2){Kj(c+8|0,x[c+14>>1]);d=x[c+8>>1];break a}else{t[c+13|0]=0;f=(c+14|0)+d|0;if(b>>>0>d>>>0){zg(a,c+13|0);e=w[c+13|0]}else{e=0}t[f|0]=e;d=d+1|0;continue}}aa(11212,9108,136,14225);L()}kb=c+16|0;return d&65535}function Hfa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=kb-16|0;kb=d;c=d+11|0;rR(a,c);if(Sb(c,13559,4)){a=1}else{rR(a,d+11|0);t[b|0]=1;a=0}c=kb-16|0;kb=c;a:{b:{a=(d+11|0)+a|0;c:{if(!a){a=0;break c}b=Kc(c,a);v[23540]=0;a=S(655,b|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break b}zb(b)}kb=c+16|0;break a}a=P()|0;O()|0;zb(b);T(a|0);L()}kb=d+16|0;return a|0}function fca(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a:{d=kb-32|0;kb=d;IA(d+8|0,c);v[23540]=0;R(462,d+20|0,43276);c=v[23540];v[23540]=0;b:{c:{if((c|0)!=1){Yj(d,d+8|0);v[23540]=0;X(114,a|0,b|0,v[d>>2],v[d+4>>2]);a=v[23540];v[23540]=0;if((a|0)==1){break c}Wg(d+8|0);kb=d+32|0;break a}a=P()|0;O()|0;Ab(d+8|0);break b}a=P()|0;O()|0;Wg(d+8|0)}T(a|0);L()}}function Tia(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;if(y[a+4>>2]<y[Gb(a)>>2]){d=kb-16|0;kb=d;a=Ah(d,a,1);LT(v[a+4>>2],x[b>>1],w[c|0]);v[a+4>>2]=v[a+4>>2]+4;lc(a);kb=d+16|0;return}e=kb-32|0;kb=e;d=Gb(a);d=Vf(e+8|0,qg(a,uc(v[a>>2],v[a+4>>2])+1|0),uc(v[a>>2],v[a+4>>2]),d);LT(v[d+8>>2],x[b>>1],w[c|0]);v[d+8>>2]=v[d+8>>2]+4;Fd(a,d);Uf(d);kb=e+32|0}function Mk(a,b,c,d){var e=0,f=0,g=0,h=0,i=0;f=kb-16|0;kb=f;v[f+8>>2]=a;v[f+12>>2]=b;h=v[a+8>>2]+120|0;zs(w[h+20|0]);g=kb-16|0;kb=g;v[g+8>>2]=f+8;e=kb-16|0;kb=e;i=v[d+4>>2];v[e+8>>2]=v[d>>2];v[e+12>>2]=i;d=v[c+4>>2];v[e>>2]=v[c>>2];v[e+4>>2]=d;ob[v[yp(e,dk(w[h+20|0]))>>2]](g+8|0,h);kb=e+16|0;kb=g+16|0;v[a+4>>2]=v[a+4>>2]+v[b+8>>2];kb=f+16|0}function Dg(a,b){var c=0,d=0,e=0,f=0,g=0,h=0;e=Mc(a);d=Hb(a);c=Pg(b);a=0;a:{if(!c){break a}a=e;d=d+a|0;c=b+c|0;b:{if((c|0)==(b|0)){break b}c:{c=c-b|0;if((c|0)>(d-a|0)){break c}g=1-c|0;h=w[b|0];while(1){f=d-a|0;if((c|0)>(f|0)){break c}a=Gp(a,g+f|0,h);if(!a){break c}if(!Op(a,b,c)){break b}a=a+1|0;continue}}a=d}a=(a|0)==(d|0)?-1:a-e|0}return a}function Aja(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;d=kb-112|0;kb=d;c=kb-16|0;kb=c;f=d+8|0;sU(c+8|0,f);e=v[c+12>>2];md(c,a,v[c+8>>2],v[c+12>>2]);g=v[c+4>>2];if((g|0)==(e|0)){id(a,v[c+12>>2])}kb=c+16|0;e=(e|0)==(g|0);if(!e){rU(f)}c=-1;a:{if(!e){break a}c=0;if(!uU(d+8|0)){break a}c=Ae(a,b,tU(w[d+55|0]|w[d+56|0]<<8),nb)}kb=d+112|0;return c|0}function Wj(a,b){a:{if((b|0)>=1024){a=a*8.98846567431158e307;if(b>>>0<2047){b=b-1023|0;break a}a=a*8.98846567431158e307;b=((b|0)<3069?b:3069)-2046|0;break a}if((b|0)>-1023){break a}a=a*2.004168360008973e-292;if(b>>>0>4294965304){b=b+969|0;break a}a=a*2.004168360008973e-292;b=((b|0)>-2960?b:-2960)+1938|0}l(0,0);l(1,b+1023<<20);return a*+n()}function P0(a){a=a|0;a:{v[23540]=0;S(1109,466952)|0;a=v[23540];v[23540]=0;b:{if((a|0)==1){break b}v[23540]=0;S(1109,467288)|0;a=v[23540];v[23540]=0;if((a|0)==1){break b}v[23540]=0;S(1110,467036)|0;a=v[23540];v[23540]=0;if((a|0)==1){break b}v[23540]=0;S(1110,467372)|0;a=v[23540];v[23540]=0;if((a|0)==1){break b}break a}V(0)|0;O()|0;Vb();L()}}function yW(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;d=kb-512|0;kb=d;c=kb-16|0;kb=c;f=d+8|0;RC(c+8|0,f);e=v[c+12>>2];md(c,a,v[c+8>>2],v[c+12>>2]);g=v[c+4>>2];if((g|0)==(e|0)){id(a,v[c+12>>2])}kb=c+16|0;e=(e|0)==(g|0);if(!e){QC(f)}c=-1;a:{if(!e){break a}c=0;if(!TC(d+8|0)){break a}c=Ae(a,b,SC(w[d+118|0],w[d+119|0]),nb)}kb=d+512|0;return c|0}function K8(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=vi(a,b,c,d);v[a>>2]=44960;c=Tb(a+4208|0);v[a+4220>>2]=0;v[a+4224>>2]=1056964608;b=a+4228|0;t[b+4|0]=0;t[b+5|0]=4;t[b|0]=69;t[b+1|0]=99;t[b+2|0]=104;t[b+3|0]=111;t[b+6|0]=1;v[23540]=0;R(897,a+44|0,2);b=v[23540];v[23540]=0;if((b|0)!=1){ui(a);Os(a);return a|0}b=P()|0;O()|0;wc(c);If(a);T(b|0);L()}function g4(a,b){a=a|0;b=b|0;var c=0;v[23540]=0;Y(946,a|0);c=v[23540];v[23540]=0;if((c|0)!=1){v[v[v[a+24>>2]+24>>2]+480272>>2]=b;return 1}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,5787,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)!=1){$();return 0}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function cO(a,b,c,d,e){var f=0,g=0,h=0,i=0;f=kb-16|0;kb=f;i=v[d+20>>2];h=v[d+52>>2];g=!h|e;t[f+15|0]=g;a:{if(!g|(b|0)!=2){break a}g=c&65535;c=0;while(1){if((c|0)==(g|0)){break a}v[(B(c,872)+d|0)+1380>>2]=0;c=c+1|0;continue}}v[d+24>>2]=0;v[d+16>>2]=0;v[d+20>>2]=0;v[d+48>>2]=h;u[d+72>>1]=x[d+74>>1];de(a,i>>>0>1&e&(b|0)==1,f+15|0);kb=f+16|0}function LY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;e=kb+-64|0;kb=e;d=1;a:{if(Zg(a,b,0)){break a}d=0;if(!b){break a}b=Ly(b,92364,92412);d=0;if(!b){break a}d=e+8|0;Ub(d|4,0,52);v[e+56>>2]=1;v[e+20>>2]=-1;v[e+16>>2]=a;v[e+8>>2]=b;ob[v[v[b>>2]+28>>2]](b,d,v[c>>2],1);a=v[e+32>>2];if((a|0)==1){v[c>>2]=v[e+24>>2]}d=(a|0)==1}kb=e- -64|0;return d|0}function uy(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;d=kb-16|0;kb=d;e=Th(b,c);a:{if(e>>>0<=mp(a)>>>0){f=c;g=v[a>>2];h=fd(g,v[a+4>>2]);i=h>>>0>=e>>>0;if(!i){v[d+12>>2]=b;v[d+12>>2]=v[d+12>>2]+h;f=v[d+12>>2]}b=Oi(b,f,g);if(!i){ku(a,f,c,e-fd(v[a>>2],v[a+4>>2])|0);break a}Od(a,b);break a}uB(a);Ll(a,Vl(a,e));ku(a,b,c,e)}kb=d+16|0}function pz(a){t[a|0]=0;t[a+1|0]=0;t[a+2|0]=0;t[a+3|0]=0;t[a+4|0]=0;t[a+5|0]=0;t[a+6|0]=0;t[a+7|0]=0;t[a+23|0]=0;t[a+24|0]=0;t[a+25|0]=0;t[a+26|0]=0;t[a+16|0]=0;t[a+17|0]=0;t[a+18|0]=0;t[a+19|0]=0;t[a+20|0]=0;t[a+21|0]=0;t[a+22|0]=0;t[a+23|0]=0;t[a+8|0]=0;t[a+9|0]=0;t[a+10|0]=0;t[a+11|0]=0;t[a+12|0]=0;t[a+13|0]=0;t[a+14|0]=0;t[a+15|0]=0}function uZ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;while(1){a:{if((c|0)==(d|0)|e>>>0<=h>>>0){break a}f=1;g=kb-16|0;kb=g;k=ki(g+8|0,v[a+8>>2]);i=Xr(0,c,d-c|0,b?b:467932);ji(k);kb=g+16|0;b:{switch(i+2|0){default:f=i;break;case 0:case 1:break a;case 2:break b}}h=h+1|0;j=f+j|0;c=c+f|0;continue}break}return j|0}function m4(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;v[23540]=0;Y(946,a|0);d=v[23540];v[23540]=0;if((d|0)!=1){v[a+4>>2]=c;v[a>>2]=b?b:927;return}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,13058,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)!=1){$();return}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function bH(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;b=kb-16|0;kb=b;e=b+16|0;a:{while(1){d=v[a+36>>2];c=b+8|0;f=ob[v[v[d>>2]+20>>2]](d,v[a+40>>2],c,e,b+4|0)|0;d=-1;g=c;c=v[b+4>>2]-c|0;if((wk(g,1,c,v[a+32>>2])|0)!=(c|0)){break a}b:{switch(f-1|0){case 1:break a;case 0:continue;default:break b}}break}d=Ls(v[a+32>>2])?-1:0}kb=b+16|0;return d|0}function $W(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=kb-32|0;kb=e;f=v[b+16>>2];a:{if(f>>>0<=c>>>0){gc(a,v[d>>2],0);break a}g=v[b+12>>2];b=v[b+4>>2];v[e+20>>2]=v[d+4>>2];v[e+16>>2]=f-c;gc(e+24|0,v[d>>2],v[Kb(e+20|0,e+16|0)>>2]);d=v[v[b>>2]+28>>2];f=v[e+28>>2];v[e+8>>2]=v[e+24>>2];v[e+12>>2]=f;ob[d|0](a,b,c+g|0,e+8|0)}kb=e+32|0}function r5(a){a=a|0;var b=0;v[23540]=0;Y(946,a|0);b=v[23540];v[23540]=0;if((b|0)!=1){return+(+y[v[v[a+24>>2]+24>>2]+1074420>>2]/1e4)}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,15192,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)!=1){$();return 0}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function be(a,b,c){var d=0,e=0,f=0,g=0,h=0;e=kb-16|0;kb=e;dn(b);f=Lf(e+8|0,b);a:{d=a+8|0;b=v[d>>2];if(uc(b,v[a+12>>2])>>>0<=c>>>0){v[23540]=0;R(1206,d|0,c+1|0);a=v[23540];v[23540]=0;if((a|0)==1){break a}b=v[d>>2]}a=Eb(b,c);b=v[a>>2];if(b){hn(b);a=Eb(v[d>>2],c)}g=a,h=ce(f),v[g>>2]=h;VF(f);kb=e+16|0;return}a=P()|0;O()|0;VF(f);T(a|0);L()}function X2(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=kb-16|0;kb=e;g=v[d+4>>2];qx(b,c,g);f=v[b+16>>2];a:{if(f>>>0<=c>>>0){gc(a,v[d>>2],0);break a}v[e+12>>2]=f-c;v[e+8>>2]=g;d=v[d>>2];f=v[Kb(e+12|0,e+8|0)>>2];Eq(e,d,g,0,f);h=v[e>>2];i=v[e+4>>2];qh(Rf(Fb(v[b+4>>2]),c),Rf(Rf(Fb(v[b+4>>2]),c),i),h);Eq(a,d,g,0,f)}kb=e+16|0}function s5(a){a=a|0;var b=0;v[23540]=0;Y(946,a|0);b=v[23540];v[23540]=0;if((b|0)!=1){return y[v[v[a+24>>2]+24>>2]+1074420>>2]/1e4|0}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,9359,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)!=1){$();return 0}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function oC(a){var b=0,c=0,d=0,e=0,f=0;d=w[a+9|0]|w[a+10|0]<<8;c=Jka(w[a+3|0],0,18,0);d=d+c|0;b=nb;b=c>>>0>d>>>0?b+1|0:b;c=d;d=b;f=c;c=w[a+6|0]|w[a+7|0]<<8;b=c>>>31|0;e=c<<1;c=f+e|0;b=b+d|0;b=c>>>0<e>>>0?b+1|0:b;d=b;a=w[a+4|0]|w[a+5|0]<<8;b=a>>>30|0;e=a<<2;c=e+c|0;a=b+d|0;a=c>>>0<e>>>0?a+1|0:a;b=c+3|0;a=b>>>0<3?a+1|0:a;nb=a;return b}function Ega(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=kb+-64|0;kb=c;b=-1;a:{if(!(ob[v[v[a>>2]+32>>2]](a,0,1084)|0)){break a}vl(a,1080);d=c+60|0;lS(a,d);e=d;d=kS(c+40|0);b=0;if(!jS(e,d)){break a}vl(a,20);b=1;while(1){if((b&65535)>>>0>=32){b=y[d+4>>2]>=f>>>0}else{e=c+8|0;iS(a,e);b=b+1|0;f=pA(e)+f|0;continue}break}}kb=c- -64|0;return b|0}function CL(a){var b=0,c=0,d=0;c=kb-32|0;kb=c;a:{d=Tx(a);b=Qj(v[a>>2],v[a+4>>2]);b:{if(d>>>0<=b>>>0){break b}v[23540]=0;b=fa(901,c+8|0,b|0,b|0,Gb(a)|0)|0;d=v[23540];v[23540]=0;if((d|0)!=1){Fd(a,b);zL(b);break b}a=V(0)|0;O()|0;_(a|0)|0;v[23540]=0;Z(18);a=v[23540];v[23540]=0;if((a|0)==1){break a}}kb=c+32|0;return}V(0)|0;O()|0;Vb();L()}function BL(a){var b=0,c=0,d=0;c=kb-32|0;kb=c;a:{d=Wh(a);b=uc(v[a>>2],v[a+4>>2]);b:{if(d>>>0<=b>>>0){break b}v[23540]=0;b=fa(902,c+8|0,b|0,b|0,Gb(a)|0)|0;d=v[23540];v[23540]=0;if((d|0)!=1){Fd(a,b);Uf(b);break b}a=V(0)|0;O()|0;_(a|0)|0;v[23540]=0;Z(18);a=v[23540];v[23540]=0;if((a|0)==1){break a}}kb=c+32|0;return}V(0)|0;O()|0;Vb();L()}function iz(a,b,c){var d=0,e=0,f=0;d=Nb(a);a=Hb(b);v[23540]=0;R(48,d|0,a|0);a=v[23540];v[23540]=0;if((a|0)!=1){a:{while(1){if(Hb(b)>>>0>e>>>0){a=65533;f=t[hg(b,e)|0];if((f|0)>=-96){a=v[((f&255)<<2)+c>>2]}v[23540]=0;R(49,d|0,a|0);a=v[23540];v[23540]=0;if((a|0)==1){break a}e=e+1|0;continue}break}return}}a=P()|0;O()|0;Nc(d);T(a|0);L()}function Caa(a){a=a|0;var b=0,c=0;b=kb-32|0;kb=b;t[b+23|0]=0;t[b+24|0]=0;t[b+25|0]=0;t[b+26|0]=0;t[b+27|0]=0;t[b+28|0]=0;t[b+29|0]=0;t[b+30|0]=0;v[b+16>>2]=0;v[b+20>>2]=0;c=hc(b,b+16|0,15);nc(b+8|0,v[a>>2],v[a+8>>2],v[c>>2],v[c+4>>2]);c=0;a:{if(v[b+12>>2]!=15){break a}if(Sb(b+16|0,8554,15)){break a}$b(a,15);c=1}kb=b+32|0;return c|0}function Eo(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=Fb(v[b>>2]);g=Fb(v[b+4>>2]);e=kb-16|0;kb=e;v[e+8>>2]=d;while(1){a:{if(!Pb(d,g)){break a}f=kb-16|0;kb=f;_h(f+8|0,v[d>>2],v[d+4>>2]);h=bc(v[f+8>>2]);kb=f+16|0;if((c|0)==(h|0)){break a}d=v[Om(e+8|0)>>2];continue}break}kb=e+16|0;if(pc(d,Fb(v[b+4>>2]))){Kh(a);return}Bo(a,d)}function VC(a,b){var c=0,d=0,e=0,f=0;c=kb-16|0;kb=c;a:{if(b>>>0<5){if(!b){break a}if(!Qb(v[a>>2],v[a+8>>2],b)){break a}while(1)if((d|0)==4){Zl(c,v[c+12>>2]);d=v[c>>2];break a}else{t[c+11|0]=0;f=(c+12|0)+d|0;if(b>>>0>d>>>0){zg(a,c+11|0);e=w[c+11|0]}else{e=0}t[f|0]=e;d=d+1|0;continue}}aa(11212,9108,136,14225);L()}kb=c+16|0;return d}function JR(a){var b=0,c=0,d=0,e=0,f=0;e=w[a+28|0]|w[a+29|0]<<8;b=Jka(w[a+30|0],0,37,0);c=nb;d=b;b=Jka(w[a+24|0]|w[a+25|0]<<8,0,192,0);d=d+b|0;c=nb+c|0;c=b>>>0>d>>>0?c+1|0:c;b=c;f=e;a=w[a+26|0];c=a>>>26|0;e=d;d=a<<6;e=e+d|0;a=b+c|0;a=d>>>0>e>>>0?a+1|0:a;b=e;c=f+b|0;a=b>>>0>c>>>0?a+1|0:a;b=c+192|0;a=b>>>0<192?a+1|0:a;nb=a;return b}function Uia(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=kb-16|0;kb=c;v[c+12>>2]=1;a:{if(Wh(a)){d=v[a>>2];e=uc(d,v[a+4>>2]);v[c+8>>2]=e;f=v[Kb(c+12|0,c+8|0)>>2];while(1){if(f){u[d>>1]=x[b>>1];t[d+2|0]=w[b+2|0];f=f-1|0;d=d+4|0;continue}break}if(!e){PT(a,1-e|0,b);break a}Od(a,v[a>>2]+4|0);break a}ou(a);Bk(a,qg(a,1));PT(a,1,b)}kb=c+16|0}function L2(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=0;a:{if(!v[b+28>>2]){break a}e=0;if((ob[v[b+32>>2]](v[b+24>>2],c,0,0)|0)<0){break a}f=v[d+4>>2];c=v[d>>2];while(1){b:{if(!f){break b}e=ob[v[b+28>>2]](v[b+24>>2],c,f)|0;if(!e){break b}f=f-e|0;c=c+e|0;g=e+g|0;h=g>>>0<e>>>0?h+1|0:h;continue}break}e=g}gc(a,v[d>>2],e)}function bq(a){var b=0,c=0,d=0,e=0,f=0;c=kb-16|0;kb=c;d=Fb(v[a>>2]);e=a;f=Fb(v[a+4>>2]);a=kb-16|0;kb=a;v[a+8>>2]=d;while(1){if(Pb(d,f)){b=b+A[d>>3];d=v[st(a+8|0)>>2];continue}break}kb=a+16|0;a=Fb(v[e>>2]);v[c+8>>2]=a;b=-b;e=Fb(v[e+4>>2]);while(1){if(Pb(a,e)){b=b+A[a>>3];A[a>>3]=b;a=v[st(c+8|0)>>2];continue}else{kb=c+16|0}break}}function SK(a){a=a|0;var b=0,c=0;c=kb-16|0;kb=c;b=v[v[a+16>>2]+24620>>2]/5|0;b=Hc(b,b>>31);v[a+4272>>2]=b;v[23540]=0;v[c+12>>2]=0;U(903,a+4256|0,b<<1,c+12|0);b=v[23540];v[23540]=0;a:{if((b|0)==1){b=V(92756)|0;if((O()|0)!=(ea(92756)|0)){break a}_(b|0)|0;v[a+4272>>2]=0;$()}v[a+4276>>2]=0;v[a+4268>>2]=0;kb=c+16|0;return}T(b|0);L()}function GV(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=kb-16|0;kb=c;gc(c+8|0,b,10);d=v[c+12>>2];nc(c,v[a>>2],v[a+8>>2],v[c+8>>2],v[c+12>>2]);e=v[c+4>>2];if((e|0)==(d|0)){$b(a,v[c+12>>2])}kb=c+16|0;a=(d|0)==(e|0);if(!a){t[b|0]=0;t[b+1|0]=0;t[b+2|0]=0;t[b+3|0]=0;t[b+4|0]=0;t[b+5|0]=0;t[b+6|0]=0;t[b+7|0]=0;t[b+8|0]=0;t[b+9|0]=0}return a|0}function s7(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;a=vi(a,b,c,d);v[a+4272>>2]=1065353216;v[a>>2]=47104;b=a+4208|0;e=Eb(b,0),f=1056880300,v[e>>2]=f;e=Eb(b,1),f=1050733080,v[e>>2]=f;e=Eb(b,2),f=1056964608,v[e>>2]=f;v[23540]=0;R(897,a+44|0,2);b=v[23540];v[23540]=0;if((b|0)!=1){ui(a);return a|0}b=P()|0;O()|0;If(a);T(b|0);L()}function nd(a,b){a=a|0;b=b|0;var c=0,d=0;c=kb-16|0;kb=c;Dm(a);v[a+16>>2]=0;v[a+8>>2]=0;v[a+12>>2]=0;v[a>>2]=0;v[a+4>>2]=0;u[a+32>>1]=64;v[a+24>>2]=8363;v[a+28>>2]=16777344;v[a+36>>2]=0;t[a+39|0]=0;t[a+40|0]=0;t[a+41|0]=0;t[a+42|0]=0;d=x[a+34>>1]&-25151;u[a+34>>1]=(b|0)==4?d|32:d;b=Kc(c,21688);Be(a+43|0,b);zb(b);oQ(a);kb=c+16|0}function l7(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;a=vi(a,b,c,d);v[a>>2]=47340;b=a+4208|0;e=Eb(b,0),f=1065353216,v[e>>2]=f;e=Eb(b,1),f=1065353216,v[e>>2]=f;e=Eb(b,2),f=1051372203,v[e>>2]=f;e=Eb(b,3),f=0,v[e>>2]=f;v[23540]=0;R(897,a+44|0,2);b=v[23540];v[23540]=0;if((b|0)!=1){ui(a);return a|0}b=P()|0;O()|0;If(a);T(b|0);L()}function fJ(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;b=v[a>>2];a:{if(!b){break a}c=v[a+8>>2];if(!c){break a}d=v[a+12>>2];if(!d){break a}e=ob[d|0](b)|0;a=nb;f=a;if((a|0)<0){break a}a=0;b:{if((ob[c|0](b,0,0,0)|0)<0){break b}a=0;if((ob[c|0](b,0,0,2)|0)<0){break b}ob[d|0](b)|0;a=nb;a=(a|0)>0|(a|0)>=0}g=a;ob[c|0](b,e,f,0)|0}return g|0}function RM(a,b,c,d){var e=0,f=0,g=0,h=0;e=kb-16|0;kb=e;a:{b:{while(1){v[e+12>>2]=b;v[e+8>>2]=d;if(y[Kb(e+12|0,e+8|0)>>2]<=f>>>0){break b}g=Tp(t[Lb(a,f)|0]);h=Tp(t[Lb(c,f)|0]);if((g|0)!=(h|0)){a=g>>>0<h>>>0?-1:1;break a}f=f+1|0;if(g){continue}break}a=0;break a}a=0;if((b|0)==(d|0)){break a}a=b>>>0<d>>>0?-1:1}kb=e+16|0;return a}function wW(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;d=kb-48|0;kb=d;c=kb-16|0;kb=c;f=d+8|0;KC(c+8|0,f);e=v[c+12>>2];md(c,a,v[c+8>>2],v[c+12>>2]);g=v[c+4>>2];if((g|0)==(e|0)){id(a,v[c+12>>2])}kb=c+16|0;e=(e|0)==(g|0);if(!e){JC(f)}c=-1;a:{if(!e){break a}c=0;if(!MC(d+8|0)){break a}c=Ae(a,b,LC(w[d+43|0]),nb)}kb=d+48|0;return c|0}function sha(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;d=kb+-64|0;kb=d;c=kb-16|0;kb=c;f=d+8|0;IS(c+8|0,f);e=v[c+12>>2];md(c,a,v[c+8>>2],v[c+12>>2]);g=v[c+4>>2];if((g|0)==(e|0)){id(a,v[c+12>>2])}kb=c+16|0;e=(e|0)==(g|0);if(!e){HS(f)}c=-1;a:{if(!e){break a}c=0;if(!KS(d+8|0)){break a}c=Ae(a,b,JS(d+8|0),nb)}kb=d- -64|0;return c|0}function rm(a,b,c,d,e,f,g){var h=0,i=0,j=0,k=0;h=kb-16|0;kb=h;i=-17;if(-17-b>>>0>=c>>>0){j=Ac(a);if(b>>>0<=2147483622){v[h+8>>2]=b<<1;v[h+12>>2]=b+c;i=nh(v[_c(h+12|0,h+8|0)>>2])+1|0}c=vc(i);if(e){He(c,j,e)}k=e+f|0;if((k|0)!=(d|0)){He((c+e|0)+g|0,(e+j|0)+f|0,d-k|0)}if((b|0)!=10){Mb(j)}wd(a,c);ff(a,i);kb=h+16|0;return}hf();L()}function dx(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0;g=kb-240|0;kb=g;v[g>>2]=a;h=1;a:{if((c|0)<2){break a}e=a;while(1){e=e-4|0;i=c-2|0;f=e-v[(i<<2)+d>>2]|0;if((ob[b|0](a,f)|0)>=0){if((ob[b|0](a,e)|0)>=0){break a}}j=f;f=(ob[b|0](f,e)|0)>=0;e=f?j:e;v[(h<<2)+g>>2]=e;h=h+1|0;c=f?c-1|0:i;if((c|0)>1){continue}break}}XH(g,h);kb=g+240|0}function cca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=kb-32|0;kb=e;v[e+24>>2]=d;c=rf(a,c);me(e+8|0,v[a+36>>2]);f=a;a:{if(!c){Sc(e+8|0,a+32|0,5);d=0;if(Cb(v[v[e+8>>2]>>2],v[e+12>>2])){break a}}d=v[a+36>>2];a=0;CC(b,v[e+24>>2]);while(1){if(y[e+24>>2]>a>>>0){cP(d,cc(v[b>>2],a));a=a+1|0;continue}break}d=c}Ye(f,d);kb=e+32|0}function X9(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=kb-16|0;kb=d;v[d>>2]=v[a+8>>2];e=v[a+8>>2];v[d+8>>2]=a+8;v[d+4>>2]=B(b,52)+e;b=v[d>>2];a:{while(1){if(v[d+4>>2]==(b|0)){break a}v[23540]=0;R(877,b|0,c|0);a=v[23540];v[23540]=0;if((a|0)!=1){b=v[d>>2]+52|0;v[d>>2]=b;continue}break}a=P()|0;O()|0;Ud(d);T(a|0);L()}Ud(d);kb=d+16|0}function zS(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0;d=kb-16|0;kb=d;e=$d(b,c);a:{if(e>>>0<=Wh(a)>>>0){f=c;g=v[a>>2];h=uc(g,v[a+4>>2]);i=h>>>0>=e>>>0;if(!i){v[d+12>>2]=b;v[d+12>>2]=v[d+12>>2]+(h<<2);f=v[d+12>>2]}b=Oi(b,f,g);if(!i){wA(a,f,c,e-uc(v[a>>2],v[a+4>>2])|0);break a}Od(a,b);break a}ou(a);Bk(a,qg(a,e));wA(a,b,c,e)}kb=d+16|0}function fG(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;d=kb-16|0;kb=d;i=v[b>>2];h=v[a>>2];e=v[jc(a)>>2]==1154;f=v[c>>2]-h|0;g=f<<1;f=f>>>0<2147483647?g?g:4:-1;g=ks(e?0:h,f);if(g){if(!e){ce(a)}v[d+4>>2]=1119;e=se(d+8|0,g,d+4|0);a=cG(a,e);Xc(e);v[b>>2]=v[a>>2]+(i-h|0);v[c>>2]=v[a>>2]+(f&-4);kb=d+16|0;return}Aw();L()}function Uaa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;c=kb-16|0;kb=c;if(!zd(v[a+1298300>>2])){d=v[a+24620>>2];e=kb-16|0;kb=e;b=vc(536);v[23540]=0;d=Q(834,b|0,d|0)|0;f=v[23540];v[23540]=0;a:{if((f|0)!=1){b=v[Lf(e+8|0,d)>>2];kb=e+16|0;break a}a=P()|0;O()|0;Mb(b);T(a|0);L()}v[c+8>>2]=b;b=a+1298300|0;a=c+8|0;UM(b,ce(a));By(a)}kb=c+16|0}function Ria(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=kb-576|0;kb=d;c=kb-16|0;kb=c;DT(c+8|0,d);e=v[c+12>>2];md(c,a,v[c+8>>2],v[c+12>>2]);f=v[c+4>>2];if((f|0)==(e|0)){id(a,v[c+12>>2])}kb=c+16|0;e=(e|0)==(f|0);if(!e){CT(d)}c=-1;a:{if(!e){break a}c=0;if(!FT(d)){break a}c=Ae(a,b,ET(x[d+34>>1],x[d+36>>1]),nb)}kb=d+576|0;return c|0}function LE(a,b,c,d,e){var f=0;a:{f=kb-32|0;kb=f;ap(f+8|0,c);v[23540]=0;R(e|0,f+20|0,d|0);c=v[23540];v[23540]=0;b:{c:{if((c|0)!=1){Yj(f,f+8|0);v[23540]=0;X(114,a|0,b|0,v[f>>2],v[f+4>>2]);a=v[23540];v[23540]=0;if((a|0)==1){break c}Wg(f+8|0);kb=f+32|0;break a}a=P()|0;O()|0;Ab(f+8|0);break b}a=P()|0;O()|0;Wg(f+8|0)}T(a|0);L()}}function IE(a,b,c,d,e){var f=0;a:{f=kb-32|0;kb=f;vU(f+8|0,c);v[23540]=0;R(e|0,f+20|0,d|0);c=v[23540];v[23540]=0;b:{c:{if((c|0)!=1){Yj(f,f+8|0);v[23540]=0;X(114,a|0,b|0,v[f>>2],v[f+4>>2]);a=v[23540];v[23540]=0;if((a|0)==1){break c}Wg(f+8|0);kb=f+32|0;break a}a=P()|0;O()|0;Ab(f+8|0);break b}a=P()|0;O()|0;Wg(f+8|0)}T(a|0);L()}}function qia(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=v[a>>2];d=fd(e,v[a+4>>2]);if(d>>>0<b>>>0){e=kb-32|0;kb=e;b=b-d|0;d=v[Gb(a)>>2];f=v[a+4>>2];a:{if(b>>>0<=d-f>>>0){Po(a,b,c);break a}d=Gb(a);d=Xl(e+8|0,Vl(a,fd(v[a>>2],f)+b|0),fd(v[a>>2],v[a+4>>2]),d);dT(d,b,c);Fd(a,d);Wl(d)}kb=e+32|0;return}if(b>>>0<d>>>0){Od(a,b+e|0)}}function mM(a,b){var c=0,d=0,e=0,f=0,g=0;d=kb-16|0;kb=d;hc(d+8|0,sd(b),Ad(v[b+4>>2],w[b+11|0]));b=v[d+8>>2];e=v[d+12>>2];c=kb-16|0;kb=c;f=Ad(v[a+4>>2],w[a+11|0]);v[c+12>>2]=f;v[c+8>>2]=e;g=Kb(c+12|0,c+8|0);a=Qv(sd(a),b,v[g>>2]);a:{if(a){break a}a=-1;if(e>>>0>f>>>0){break a}a=e>>>0<f>>>0}kb=c+16|0;kb=d+16|0;return a>>>31|0}function d1(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;e=v[a+44>>2];c=v[a+24>>2];if(e>>>0<c>>>0){v[a+44>>2]=c;e=c}f=v[a+8>>2];c=v[a+12>>2];d=-1;a:{if(f>>>0>=c>>>0){break a}if(pc(b,-1)){Cn(a,f,c-1|0,e);return Ow(b)|0}g=sp(b);if(!(v[a+48>>2]&16)){d=-1;if(!pc(g,t[c-1|0])){break a}}Cn(a,f,c-1|0,e);t[v[a+12>>2]]=g;d=b}return d|0}function Fia(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=kb-16|0;kb=d;v[d+12>>2]=c;a:{e=Qb(v[b>>2],v[b+8>>2],c<<2);if(!e){break a}xc(d+12|0,65535);vg(a,x[d+12>>1]);c=Fb(v[a>>2]);v[d>>2]=c;a=Fb(v[a+4>>2]);while(1){if(!Pb(c,a)){break a}f=d+8|0;if(!Uo(b,f)){Pm(f)}u[c>>1]=v[d+8>>2];c=v[Se(d)>>2];continue}}kb=d+16|0;return e|0}function yba(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=kb-32|0;kb=d;b=Bh(d,b);v[23540]=0;U(799,d+16|0,b|0,c|0);e=v[23540];v[23540]=0;a:{b:{if((e|0)!=1){v[23540]=0;U(56,a|0,d+16|0,c|0);a=v[23540];v[23540]=0;if((a|0)==1){break b}zb(d+16|0);zb(b);kb=d+32|0;return}c=P()|0;O()|0;break a}c=P()|0;O()|0;zb(d+16|0)}zb(b);T(c|0);L()}function hX(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;f=kb-32|0;kb=f;v[f+28>>2]=c;v[f+24>>2]=b;v[f+20>>2]=d;v[f+16>>2]=e;v[23540]=0;X(173,f|0,f+24|0,f+20|0,f+16|0);b=v[23540];v[23540]=0;if((b|0)!=1){b=f+8|0;Cv(b,v[f>>2],v[f+4>>2]);Cg(a,b);le(b);le(f);le(f+24|0);kb=f+32|0;return}a=P()|0;O()|0;le(f+24|0);T(a|0);L()}function $F(a,b,c,d,e){var f=0,g=0,h=0,i=0;f=kb-16|0;kb=f;g=1073741807;if(1073741807-b>>>0>=c>>>0){h=Ac(a);if(b>>>0<=536870886){v[f+8>>2]=b<<1;v[f+12>>2]=b+c;g=am(v[_c(f+12|0,f+8|0)>>2])+1|0}c=Bi(g);if(e){ni(c,h,e)}if((d|0)!=(e|0)){i=e<<2;ni(c+i|0,h+i|0,d-e|0)}if((b|0)!=1){Mb(h)}wd(a,c);ff(a,g);kb=f+16|0;return}hf();L()}function j$(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;d=kb-16|0;kb=d;i=v[b>>2];h=v[a>>2];e=v[jc(a)>>2]==1154;f=v[c>>2]-h|0;g=f<<1;f=f>>>0<2147483647?g?g:1:-1;g=ks(e?0:h,f);if(g){if(!e){ce(a)}v[d+4>>2]=1119;e=se(d+8|0,g,d+4|0);a=cG(a,e);Xc(e);v[b>>2]=v[a>>2]+(i-h|0);v[c>>2]=f+v[a>>2];kb=d+16|0;return}Aw();L()}function i5(a){a=a|0;var b=0;v[23540]=0;Y(946,a|0);b=v[23540];v[23540]=0;if((b|0)!=1){return Og(v[v[a+24>>2]+24>>2])|0}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,7081,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)!=1){$();return 0}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function h5(a){a=a|0;var b=0;v[23540]=0;Y(946,a|0);b=v[23540];v[23540]=0;if((b|0)!=1){return Gs(v[v[a+24>>2]+24>>2])|0}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,6790,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)!=1){$();return 0}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function e5(a){a=a|0;var b=0;v[23540]=0;Y(946,a|0);b=v[23540];v[23540]=0;if((b|0)!=1){return Fs(v[v[a+24>>2]+24>>2])|0}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,7440,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)!=1){$();return 0}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function OK(a){var b=C(0),c=0,d=C(0);b=z[a+4224>>2];z[a+4260>>2]=K(C(C(1)-C(b*b)));t[a+4264|0]=z[a+4236>>2]>C(.5);d=C(v[a+4256>>2]<<1>>>0);b=C(z[a+4228>>2]*d);a:{if(b<C(4294967296)&b>=C(0)){c=~~b>>>0;break a}c=0}v[a+4248>>2]=c;c=a+4252|0;b=C(z[a+4232>>2]*d);b:{if(b<C(4294967296)&b>=C(0)){a=~~b>>>0;break b}a=0}v[c>>2]=a}function LV(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;e=kb-1968|0;kb=e;c=kb-16|0;kb=c;f=e+8|0;VB(c+8|0,f);d=v[c+12>>2];md(c,a,v[c+8>>2],v[c+12>>2]);g=v[c+4>>2];if((g|0)==(d|0)){id(a,v[c+12>>2])}kb=c+16|0;d=(d|0)==(g|0);if(!d){UB(f)}c=-1;a:{if(!d){break a}c=0;if(!WB(e+8|0)){break a}c=Ae(a,b,1024,0)}kb=e+1968|0;return c|0}function L9(a,b){a=a|0;b=b|0;var c=0,d=0;if(v[a+4>>2]!=v[Gb(a)>>2]){c=kb-16|0;kb=c;a=Ah(c,a,1);fk(v[a+4>>2],z[b>>2]);v[a+4>>2]=v[a+4>>2]+4;lc(a);kb=c+16|0;return}d=kb-32|0;kb=d;c=Gb(a);c=Vf(d+8|0,qg(a,uc(v[a>>2],v[a+4>>2])+1|0),uc(v[a>>2],v[a+4>>2]),c);fk(v[c+8>>2],z[b>>2]);v[c+8>>2]=v[c+8>>2]+4;Fd(a,c);Uf(c);kb=d+32|0}function H8(a){a=a|0;var b=0,c=0,d=0,e=0;c=kb-16|0;kb=c;v[v[a+20>>2]+148>>2]=-1;Ho(c+8|0,a+4228|0);d=v[a+20>>2];e=v[c+12>>2];b=v[c+8>>2];v[23540]=0;U(915,d+4|0,b|0,Lb(b,e)|0);b=v[23540];v[23540]=0;a:{if((b|0)==1){b=V(92756)|0;if((O()|0)!=(ea(92756)|0)){break a}_(b|0)|0;Lc(v[a+20>>2]+4|0);$()}kb=c+16|0;return}T(b|0);L()}function $B(a,b){a=a|0;b=b|0;var c=0,d=0;if(v[a+4>>2]!=v[Gb(a)>>2]){c=kb-16|0;kb=c;a=ai(c,a,1);Mi(v[a+4>>2],x[b>>1]);v[a+4>>2]=v[a+4>>2]+2;lc(a);kb=c+16|0;return}d=kb-32|0;kb=d;c=Gb(a);c=Nj(d+8|0,Oj(a,Rc(v[a>>2],v[a+4>>2])+1|0),Rc(v[a>>2],v[a+4>>2]),c);Mi(v[c+8>>2],x[b>>1]);v[c+8>>2]=v[c+8>>2]+2;Fd(a,c);Ni(c);kb=d+32|0}function y5(a){a=a|0;var b=0;v[23540]=0;Y(946,a|0);b=v[23540];v[23540]=0;if((b|0)!=1){return+GM(v[v[a+24>>2]+24>>2])}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,10168,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)!=1){$();return 0}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function tj(a){var b=0,c=0,d=0,e=0,f=0;b=v[a+4>>2];if(pc(v[a>>2],b)){a=0}else{b=Gi(b);e=Gi(v[a>>2]);c=kb-16|0;kb=c;v[c+8>>2]=b;while(1){a:{if(!Hg(b,e)){break a}d=kb-16|0;kb=d;v[d+8>>2]=b;f=lP(d+8|0);kb=d+16|0;if(x[v[f>>2]>>1]!=65535){break a}b=v[lP(c+8|0)>>2];continue}break}kb=c+16|0;a=KB(Fb(v[a>>2]),b)}return a&65535}function hw(a,b,c){var d=0;v[23540]=0;Y(946,a|0);d=v[23540];v[23540]=0;if((d|0)!=1){return v[v[v[a+24>>2]+24>>2]+c>>2]}c=V(0)|0;O()|0;_(c|0)|0;v[23540]=0;X(933,b|0,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)!=1){$();return 0}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function fF(a,b,c){var d=0;v[23540]=0;Y(946,a|0);d=v[23540];v[23540]=0;if((d|0)!=1){return x[v[v[a+24>>2]+24>>2]+c>>1]}c=V(0)|0;O()|0;_(c|0)|0;v[23540]=0;X(933,b|0,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)!=1){$();return 0}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function ek(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=v[a>>2];c=uc(d,v[a+4>>2]);if(c>>>0<b>>>0){d=kb-32|0;kb=d;b=b-c|0;c=v[Gb(a)>>2];e=v[a+4>>2];a:{if(b>>>0<=c-e>>2>>>0){At(a,b);break a}c=Gb(a);c=Vf(d+8|0,qg(a,uc(v[a>>2],e)+b|0),uc(v[a>>2],v[a+4>>2]),c);PL(c,b);Fd(a,c);Uf(c)}kb=d+32|0;return}if(b>>>0<c>>>0){Od(a,d+(b<<2)|0)}}function U8(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=kb-32|0;kb=d;v[d+28>>2]=c;v[d+8>>2]=33;e=v[a>>2];f=v[a+8>>2];c=v[Kb(d+28|0,d+8|0)>>2];if(!Qb(e,f,c)){c=cf(a)}e=d+8|0;EA(e,b);f=hc(d+16|0,v[d+8>>2],c);nc(d,v[a>>2],v[a+8>>2],v[f>>2],v[f+4>>2]);EA(e,b);Ub(v[d+8>>2]+c|0,0,33-c|0);$b(a,v[d+28>>2]);kb=d+32|0;return c|0}function BX(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=kb-32|0;kb=d;b=Pl(d,b);v[23540]=0;U(154,d+16|0,b|0,c|0);e=v[23540];v[23540]=0;a:{b:{if((e|0)!=1){v[23540]=0;U(4,a|0,d+16|0,c|0);a=v[23540];v[23540]=0;if((a|0)==1){break b}Ab(d+16|0);Ab(b);kb=d+32|0;return}c=P()|0;O()|0;break a}c=P()|0;O()|0;Ab(d+16|0)}Ab(b);T(c|0);L()}function dJ(a){var b=0,c=0,d=0,e=0;b=kb-32|0;kb=b;if(!w[a+20|0]){while(1){if(!(ob[v[v[a>>2]+40>>2]](a)|0)){aJ(a,65536);c=hc(b+16|0,Lb(v[a+4>>2],v[a+16>>2]),65536);d=v[v[a>>2]+44>>2];e=v[c+4>>2];v[b+8>>2]=v[c>>2];v[b+12>>2]=e;ob[d|0](b+24|0,a,b+8|0);v[a+16>>2]=v[a+16>>2]+v[b+28>>2];continue}break}t[a+20|0]=1}kb=b+32|0}function XO(a){a=a|0;var b=0,c=0,d=0;b=kb-16|0;kb=b;if(w[a+534|0]){while(1){d=c&65535;if(d>>>0>=256){t[a+534|0]=0}else{rj(a,d,1);c=c+1|0;continue}break}}t[b+15|0]=0;di(a+8|0,18,b+15|0);_t(a+26|0,18,29258);t[b+14|0]=255;di(a+62|0,256,b+14|0);gh(v[a>>2],v[a+4>>2],65535,261,1);gh(v[a>>2],v[a+4>>2],65535,260,0);kb=b+16|0}function Vh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=a;f=kb-16|0;kb=f;a:{e=Th(b,c);if(e>>>0<4294967280){b:{if(Cl(e)){ie(d,e);break b}g=nh(e)+1|0;h=vc(g);wd(d,h);ff(d,g);Hd(d,e);d=h}while(1){if((b|0)!=(c|0)){we(d,b);d=d+1|0;b=b+1|0;continue}break}t[f+15|0]=0;we(d,f+15|0);kb=f+16|0;break a}hf();L()}return a|0}function EY(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;if(Zg(a,v[b+8>>2],e)){mw(b,c,d);return}a:{if(!Zg(a,v[b>>2],e)){break a}if(!(v[b+16>>2]!=(c|0)&v[b+20>>2]!=(c|0))){if((d|0)!=1){break a}v[b+32>>2]=1;return}v[b+20>>2]=c;v[b+32>>2]=d;v[b+40>>2]=v[b+40>>2]+1;if(!(v[b+36>>2]!=1|v[b+24>>2]!=2)){t[b+54|0]=1}v[b+44>>2]=4}}function wha(a,b){a=a|0;b=b|0;var c=0,d=0;c=kb-16|0;kb=c;v[c>>2]=v[a+8>>2];d=v[a+8>>2];v[c+8>>2]=a+8;v[c+4>>2]=B(b,20)+d;b=v[c>>2];a:{while(1){if(v[c+4>>2]==(b|0)){break a}v[23540]=0;Y(228,b|0);a=v[23540];v[23540]=0;if((a|0)!=1){b=v[c>>2]+20|0;v[c>>2]=b;continue}break}a=P()|0;O()|0;Ud(c);T(a|0);L()}Ud(c);kb=c+16|0}function Yja(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;e=kb-32|0;kb=e;c=kb-16|0;kb=c;f=e+8|0;fC(c+8|0,f);d=v[c+12>>2];md(c,a,v[c+8>>2],v[c+12>>2]);g=v[c+4>>2];if((g|0)==(d|0)){id(a,v[c+12>>2])}kb=c+16|0;d=(d|0)==(g|0);if(!d){Ru(f)}c=-1;a:{if(!d){break a}c=0;if(!FU(e+8|0)){break a}c=Ae(a,b,72,0)}kb=e+32|0;return c|0}function IN(a,b,c,d){var e=0,f=0;e=kb-16|0;kb=e;f=-2147483648;f=!c|!(t[c+15|0]&1)?f:v[c+8>>2];a:{b:{if(!(!d|!(w[d+34|0]&32))){f=x[d+28>>1];break b}if((f|0)==-2147483648){break a}}eq(b,f,a);Db(e+8|0,a+1074312|0,10);if(!Cb(v[v[e+8>>2]>>2],v[e+12>>2])|v[a+480208>>2]&16384){break a}v[b+88>>2]=v[b+88>>2]&-257}kb=e+16|0}function yfa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=kb-608|0;kb=d;c=kb-16|0;kb=c;gR(c+8|0,d);e=v[c+12>>2];md(c,a,v[c+8>>2],v[c+12>>2]);f=v[c+4>>2];if((f|0)==(e|0)){id(a,v[c+12>>2])}kb=c+16|0;e=(e|0)==(f|0);if(!e){fR(d)}c=-1;a:{if(!e){break a}c=0;if(!iR(d)){break a}c=Ae(a,b,hR(x[d+34>>1]),nb)}kb=d+608|0;return c|0}function lR(a){var b=0,c=0;a:{if(Sb(a,3868,4)|w[a+63|0]!=26){break a}b=w[a+65|0];if(w[a+66|0]|(b|0)!=16&(b|0)!=1|(w[a+64|0]&3|(w[a+78|0]|w[a+79|0]<<8)>>>0>127)){break a}if((w[a+80|0]|w[a+81|0]<<8)>>>0>127){break a}b=a+80|0;a=a+78|0;a=Ek(w[a|0]|w[a+1|0]<<8,w[b|0]|w[b+1|0]<<8)?b:a;c=(w[a|0]|w[a+1|0]<<8)!=0}return c}function fy(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=F(c,.999);h=c*3.141592653589793;i=ut(b);while(1){if((e|0)!=32768){f=((e<<12^-1)&28672)+(e>>>3|0)|0;if((f|0)!=16384){d=+(f-16384|0)*.000244140625;g=h*d;d=Di(g)*ut(K(d*d*-.0625+1)*b)/(i*g)}else{d=1}j=a,k=Sz(c*d*32768),u[j>>1]=k;e=e+1|0;a=a+2|0;continue}break}}function W4(a){a=a|0;var b=0;v[23540]=0;Y(946,a|0);b=v[23540];v[23540]=0;if((b|0)!=1){return+A[v[a+24>>2]+16>>3]}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,7602,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)!=1){$();return 0}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function Q4(a){a=a|0;var b=0;v[23540]=0;Y(946,a|0);b=v[23540];v[23540]=0;if((b|0)!=1){return v[v[a+24>>2]+8>>2]}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,10920,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)!=1){$();return-1}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function r4(a,b){a=a|0;b=b|0;var c=0,d=0;a=Nb(a);c=Hb(b);v[23540]=0;R(73,a|0,c|0);c=v[23540];v[23540]=0;if((c|0)!=1){a:{b:{while(1){if(Hb(b)>>>0<=d>>>0){break b}c=t[hg(b,d)|0];v[23540]=0;R(51,a|0,Mf(Mf(c))|0);c=v[23540];v[23540]=0;if((c|0)!=1){d=d+1|0;continue}break}break a}return}}b=P()|0;O()|0;Ab(a);T(b|0);L()}function mja(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=kb-240|0;kb=d;c=kb-16|0;kb=c;YT(c+8|0,d);e=v[c+12>>2];md(c,a,v[c+8>>2],v[c+12>>2]);f=v[c+4>>2];if((f|0)==(e|0)){id(a,v[c+12>>2])}kb=c+16|0;e=(e|0)==(f|0);if(!e){XT(d)}c=-1;a:{if(!e){break a}c=0;if(!_T(d)){break a}c=Ae(a,b,ZT(v[d+4>>2]),nb)}kb=d+240|0;return c|0}function iea(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=kb-32|0;kb=d;v[d+28>>2]=c;v[d+8>>2]=4896;e=v[a>>2];f=v[a+8>>2];c=v[Kb(d+28|0,d+8|0)>>2];if(!Qb(e,f,c)){c=cf(a)}e=d+8|0;GA(e,b);f=hc(d+16|0,v[d+8>>2],c);nc(d,v[a>>2],v[a+8>>2],v[f>>2],v[f+4>>2]);GA(e,b);Ub(v[d+8>>2]+c|0,0,4896-c|0);$b(a,v[d+28>>2]);kb=d+32|0}function iR(a){var b=0;a:{if(Sb(a+44|0,14182,4)|w[a+28|0]!=26|(w[a+40|0]|w[a+41|0]<<8|w[a+30|0]>2)){break a}if(((w[a+38|0]|w[a+39|0]<<8)-33&65535)>>>0<65504|((w[a+32|0]|w[a+33|0]<<8)-257&65535)>>>0<65280|((w[a+34|0]|w[a+35|0]<<8)-256&65535)>>>0<65281){break a}b=((w[a+36|0]|w[a+37|0]<<8)-1&65535)>>>0<128}return b}function qea(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=kb-32|0;kb=d;v[d+28>>2]=c;v[d+8>>2]=263;e=v[a>>2];f=v[a+8>>2];c=v[Kb(d+28|0,d+8|0)>>2];if(!Qb(e,f,c)){c=cf(a)}e=d+8|0;NP(e,b);f=hc(d+16|0,v[d+8>>2],c);nc(d,v[a>>2],v[a+8>>2],v[f>>2],v[f+4>>2]);NP(e,b);Ub(v[d+8>>2]+c|0,0,263-c|0);$b(a,v[d+28>>2]);kb=d+32|0}function Yx(a,b){var c=0,d=0,e=0,f=0,g=0,h=0;d=kb-16|0;kb=d;h=x[b>>1];c=Td(a);e=jc(a);f=kb-16|0;kb=f;while(1){if(c){g=Vs(x[c+16>>1],h);e=g?e:c;c=v[(g?c+4|0:c)>>2];continue}break}c=v[fc(f+8|0,e)>>2];kb=f+16|0;a:{if(Pb(c,Zf(a))){if(!Vs(x[b>>1],x[vd(c)>>1])){break a}}c=Zf(a)}a=v[fc(d+8|0,c)>>2];kb=d+16|0;return a}function Vfa(a,b){a=a|0;b=b|0;var c=0,d=0;if(v[a+4>>2]!=v[Gb(a)>>2]){c=kb-16|0;kb=c;a=bv(c,a,1);BR(v[a+4>>2],b);v[a+4>>2]=v[a+4>>2]+20;lc(a);kb=c+16|0;return}d=kb-32|0;kb=d;c=Gb(a);c=oB(d+8|0,pB(a,Bf(v[a>>2],v[a+4>>2])+1|0),Bf(v[a>>2],v[a+4>>2]),c);BR(v[c+8>>2],b);v[c+8>>2]=v[c+8>>2]+20;nB(a,c);uu(c);kb=d+32|0}function $ia(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=kb-32|0;kb=d;v[d+28>>2]=c;v[d+8>>2]=102;e=v[a>>2];f=v[a+8>>2];c=v[Kb(d+28|0,d+8|0)>>2];if(!Qb(e,f,c)){c=cf(a)}e=d+8|0;QT(e,b);f=hc(d+16|0,v[d+8>>2],c);nc(d,v[a>>2],v[a+8>>2],v[f>>2],v[f+4>>2]);QT(e,b);Ub(v[d+8>>2]+c|0,0,102-c|0);$b(a,v[d+28>>2]);kb=d+32|0}function ny(a,b,c){var d=0,e=0,f=0;d=kb-16|0;kb=d;f=v[b+656>>2];e=0;a:{if(!f){break a}f=hv(f,c);e=a+1074312|0;Db(d+8|0,e,31);a=0;if(!Cb(v[v[d+8>>2]>>2],v[d+12>>2])){Db(d,e,93);a=Cb(v[v[d>>2]>>2],v[d+4>>2])^1}if(!(t[qM(b,c)+6|0]&1)){e=0;if(!(t[f+12|0]&1)|a){break a}}e=pc(v[f>>2],v[f+4>>2])^1}kb=d+16|0;return e}function gca(a,b){a=a|0;b=b|0;var c=0,d=0;if(y[a+4>>2]<y[Gb(a)>>2]){c=kb-16|0;kb=c;a=Nz(c,a,1);zz(v[a+4>>2],b);v[a+4>>2]=v[a+4>>2]+32;lc(a);kb=c+16|0;return}d=kb-32|0;kb=d;c=Gb(a);c=Ct(d+8|0,gq(a,rg(v[a>>2],v[a+4>>2])+1|0),rg(v[a>>2],v[a+4>>2]),c);zz(v[c+8>>2],b);v[c+8>>2]=v[c+8>>2]+32;eP(a,c);yz(c);kb=d+32|0}function S_(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;a:{if(!ef(f)){b=v[f+4>>2];v[a>>2]=v[f>>2];v[a+4>>2]=b;v[a+8>>2]=v[f+8>>2];break a}d=v[f>>2];b:{c:{c=v[f+4>>2];d:{if(Vr(c)){ie(a,c);break d}if(c>>>0>=1073741808){break c}e=am(c)+1|0;b=Bi(e);wd(a,b);ff(a,e);Hd(a,c);a=b}ni(a,d,c+1|0);break b}hf();L()}}}function GB(a,b){a=a|0;b=b|0;var c=0,d=0;if(v[a+4>>2]!=v[Gb(a)>>2]){c=kb-16|0;kb=c;a=TU(c,a,1);SU(v[a+4>>2],b);v[a+4>>2]=v[a+4>>2]+48;lc(a);kb=c+16|0;return}d=kb-32|0;kb=d;c=Gb(a);c=QU(d+8|0,RU(a,Hq(v[a>>2],v[a+4>>2])+1|0),Hq(v[a>>2],v[a+4>>2]),c);SU(v[c+8>>2],b);v[c+8>>2]=v[c+8>>2]+48;PU(a,c);OU(c);kb=d+32|0}function Dja(a,b){a=a|0;b=b|0;var c=0,d=0;if(y[a+4>>2]<y[Gb(a)>>2]){c=kb-16|0;kb=c;a=bv(c,a,1);qB(v[a+4>>2],b);v[a+4>>2]=v[a+4>>2]+20;lc(a);kb=c+16|0;return}d=kb-32|0;kb=d;c=Gb(a);c=oB(d+8|0,pB(a,Bf(v[a>>2],v[a+4>>2])+1|0),Bf(v[a>>2],v[a+4>>2]),c);qB(v[c+8>>2],b);v[c+8>>2]=v[c+8>>2]+20;nB(a,c);uu(c);kb=d+32|0}function v$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=kb-32|0;kb=g;h=v[21011];v[g+24>>2]=v[21010];v[g+28>>2]=h;h=v[21009];v[g+16>>2]=v[21008];v[g+20>>2]=h;h=v[21007];v[g+8>>2]=v[21006];v[g+12>>2]=h;h=v[21005];v[g>>2]=v[21004];v[g+4>>2]=h;h=a;a=g+32|0;b=_j(h,b,c,d,e,f,g,a);kb=a;return b|0}function oha(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=kb-32|0;kb=d;v[d+28>>2]=c;v[d+8>>2]=22;e=v[a>>2];f=v[a+8>>2];c=v[Kb(d+28|0,d+8|0)>>2];if(!Qb(e,f,c)){c=cf(a)}e=d+8|0;yu(e,b);f=hc(d+16|0,v[d+8>>2],c);nc(d,v[a>>2],v[a+8>>2],v[f>>2],v[f+4>>2]);yu(e,b);Ub(v[d+8>>2]+c|0,0,22-c|0);$b(a,v[d+28>>2]);kb=d+32|0}function mha(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=kb-32|0;kb=d;v[d+28>>2]=c;v[d+8>>2]=40;e=v[a>>2];f=v[a+8>>2];c=v[Kb(d+28|0,d+8|0)>>2];if(!Qb(e,f,c)){c=cf(a)}e=d+8|0;xA(e,b);f=hc(d+16|0,v[d+8>>2],c);nc(d,v[a>>2],v[a+8>>2],v[f>>2],v[f+4>>2]);xA(e,b);Ub(v[d+8>>2]+c|0,0,40-c|0);$b(a,v[d+28>>2]);kb=d+32|0}function hO(a,b){a=a|0;b=b|0;var c=0,d=0;if(y[a+4>>2]<y[Gb(a)>>2]){c=kb-16|0;kb=c;a=Ot(c,a,1);cp(v[a+4>>2],b);v[a+4>>2]=v[a+4>>2]+12;lc(a);kb=c+16|0;return}d=kb-32|0;kb=d;c=Gb(a);c=Ik(d+8|0,ln(a,yd(v[a>>2],v[a+4>>2])+1|0),yd(v[a>>2],v[a+4>>2]),c);cp(v[c+8>>2],b);v[c+8>>2]=v[c+8>>2]+12;zr(a,c);gO(c);kb=d+32|0}function dfa(a,b){a=a|0;b=b|0;var c=0,d=0;if(v[a+4>>2]!=v[Gb(a)>>2]){c=kb-16|0;kb=c;a=Sv(c,a);Vz(v[a+4>>2],b);v[a+4>>2]=v[a+4>>2]+12;lc(a);kb=c+16|0;return}d=kb-32|0;kb=d;c=Gb(a);c=Ik(d+8|0,ln(a,yd(v[a>>2],v[a+4>>2])+1|0),yd(v[a>>2],v[a+4>>2]),c);Vz(v[c+8>>2],b);v[c+8>>2]=v[c+8>>2]+12;HQ(a,c);GQ(c);kb=d+32|0}function mW(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=kb-32|0;kb=d;v[d+28>>2]=c;v[d+8>>2]=65;e=v[a>>2];f=v[a+8>>2];c=v[Kb(d+28|0,d+8|0)>>2];if(!Qb(e,f,c)){c=cf(a)}e=d+8|0;av(e,b);f=hc(d+16|0,v[d+8>>2],c);nc(d,v[a>>2],v[a+8>>2],v[f>>2],v[f+4>>2]);av(e,b);Ub(v[d+8>>2]+c|0,0,65-c|0);$b(a,v[d+28>>2]);kb=d+32|0}function dga(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=kb-1120|0;kb=d;c=kb-16|0;kb=c;GR(c+8|0,d+8|0);e=v[c+12>>2];md(c,a,v[c+8>>2],v[c+12>>2]);f=v[c+4>>2];if((f|0)==(e|0)){id(a,v[c+12>>2])}kb=c+16|0;c=-1;a:{if((e|0)!=(f|0)){break a}c=0;if(!IR(d+8|0)){break a}c=Ae(a,b,HR(v[d+1112>>2]),nb)}kb=d+1120|0;return c|0}function Ff(a,b,c,d){var e=0,f=0,g=0;a:{if(!Hb(a)|(c-b|0)<5){break a}Tr(b,c);e=c-4|0;c=Mc(a);g=c+Hb(a)|0;b:{while(1){c:{a=t[c|0];f=a-127|0;if(b>>>0>=e>>>0){break c}if((a|0)!=v[b>>2]&(f&255)>>>0>=130){break b}b=b+4|0;c=((g-c|0)>1)+c|0;continue}break}if((f&255)>>>0<130|a>>>0>v[e>>2]-1>>>0){break a}}v[d>>2]=4}}function $p(a,b){a=a|0;b=b|0;var c=0,d=0;d=kb-16|0;kb=d;t[d+15|0]=b;a:{b:{c:{if(!ef(a)){c=10;b=w[a+11|0];if((b|0)==10){break c}ie(a,b+1|0);c=a;break a}c=Il(a);b=v[a+4>>2];c=c-1|0;if((b|0)!=(c|0)){break b}}rm(a,c,1,c,c,0,0);b=c}c=v[a>>2];Hd(a,b+1|0)}a=b+c|0;we(a,d+15|0);t[d+14|0]=0;we(a+1|0,d+14|0);kb=d+16|0}function yja(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=kb-224|0;kb=d;c=kb-16|0;kb=c;kU(c+8|0,d);e=v[c+12>>2];md(c,a,v[c+8>>2],v[c+12>>2]);f=v[c+4>>2];if((f|0)==(e|0)){id(a,v[c+12>>2])}kb=c+16|0;c=-1;a:{if((e|0)!=(f|0)){break a}c=0;if(!mU(d)){break a}c=Ae(a,b,lU(w[d+216|0],w[d+217|0]),nb)}kb=d+224|0;return c|0}function oja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=kb-32|0;kb=d;v[d+28>>2]=c;v[d+8>>2]=5;e=v[a>>2];f=v[a+8>>2];c=v[Kb(d+28|0,d+8|0)>>2];if(!Qb(e,f,c)){c=cf(a)}e=d+8|0;Go(e,b);f=hc(d+16|0,v[d+8>>2],c);nc(d,v[a>>2],v[a+8>>2],v[f>>2],v[f+4>>2]);Go(e,b);Ub(v[d+8>>2]+c|0,0,5-c|0);$b(a,v[d+28>>2]);kb=d+32|0}function TX(a,b){a=a|0;b=b|0;var c=0,d=0;if(y[a+4>>2]<y[Gb(a)>>2]){c=kb-16|0;kb=c;a=Sv(c,a);cp(v[a+4>>2],b);v[a+4>>2]=v[a+4>>2]+12;lc(a);kb=c+16|0;return}d=kb-32|0;kb=d;c=Gb(a);c=Ik(d+8|0,ln(a,yd(v[a>>2],v[a+4>>2])+1|0),yd(v[a>>2],v[a+4>>2]),c);cp(v[c+8>>2],b);v[c+8>>2]=v[c+8>>2]+12;zr(a,c);Rv(c);kb=d+32|0}function NW(a,b){a=a|0;b=b|0;var c=0,d=0;if(y[a+4>>2]<y[Gb(a)>>2]){c=kb-16|0;kb=c;a=CD(c,a);zv(v[a+4>>2],b);v[a+4>>2]=v[a+4>>2]+36;lc(a);kb=c+16|0;return}d=kb-32|0;kb=d;c=Gb(a);c=AD(d+8|0,BD(a,kr(v[a>>2],v[a+4>>2])+1|0),kr(v[a>>2],v[a+4>>2]),c);zv(v[c+8>>2],b);v[c+8>>2]=v[c+8>>2]+36;zD(a,c);Bv(c);kb=d+32|0}function w0(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a=Nb(a);d=Ad(v[b+4>>2],w[b+11|0]);e=Ad(v[c+4>>2],w[c+11|0]);b=sd(b);v[23540]=0;X(102,a|0,b|0,d|0,d+e|0);b=v[23540];v[23540]=0;a:{if((b|0)!=1){b=sd(c);v[23540]=0;W(103,a|0,b|0,e|0)|0;b=v[23540];v[23540]=0;if((b|0)!=1){break a}}b=P()|0;O()|0;Ab(a);T(b|0);L()}}function tL(a){a=a|0;var b=0,c=0;c=kb-16|0;kb=c;b=v[a+4232>>2];b=(b>>>1)+(b>>>6)|0;v[a+4220>>2]=b;v[23540]=0;v[c+12>>2]=0;U(903,a+4208|0,b<<1,c+12|0);b=v[23540];v[23540]=0;a:{if((b|0)==1){b=V(92756)|0;if((O()|0)!=(ea(92756)|0)){break a}_(b|0)|0;v[a+4220>>2]=0;$()}v[a+4224>>2]=0;kb=c+16|0;return}T(b|0);L()}function lfa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=kb+-64|0;kb=d;c=kb-16|0;kb=c;Fu(c+8|0,d);e=v[c+12>>2];md(c,a,v[c+8>>2],v[c+12>>2]);f=v[c+4>>2];if((f|0)==(e|0)){id(a,v[c+12>>2])}kb=c+16|0;e=(e|0)==(f|0);if(!e){Au(d)}c=-1;a:{if(!e){break a}c=0;if(!OQ(d)){break a}c=Ae(a,b,NQ(d),nb)}kb=d- -64|0;return c|0}function T2(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;a:{if(w[b+40|0]){break a}if(!v[b+28>>2]){t[b+40|0]=1;break a}d=v[c+4>>2];f=v[c>>2];while(1){b:{if(d){e=ob[v[b+28>>2]](v[b+24>>2],f,d)|0;if(e){break b}t[b+40|0]=1}d=g;break a}d=d-e|0;f=e+f|0;g=e+g|0;h=g>>>0<e>>>0?h+1|0:h;continue}}gc(a,v[c>>2],d)}function My(a,b,c,d,e,f){var g=0,h=0,i=0;g=kb-16|0;kb=g;h=-17;if(-17-b>>>0>=c>>>0){i=sd(a);if(b>>>0<=2147483622){v[g+8>>2]=b<<1;v[g+12>>2]=b+c;h=nh(v[_c(g+12|0,g+8|0)>>2])+1|0}c=vc(h);if(e){He(c,i,e)}if((d|0)!=(e|0)){He((c+e|0)+f|0,e+i|0,d-e|0)}if((b|0)!=10){Mb(i)}wd(a,c);ff(a,h);kb=g+16|0;return}hf();L()}function sja(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=kb-208|0;kb=d;c=kb-16|0;kb=c;cU(c+8|0,d);e=v[c+12>>2];md(c,a,v[c+8>>2],v[c+12>>2]);f=v[c+4>>2];if((f|0)==(e|0)){id(a,v[c+12>>2])}kb=c+16|0;e=(e|0)==(f|0);if(!e){bU(d)}c=-1;a:{if(!e){break a}c=0;if(!eU(d)){break a}c=Ae(a,b,dU(d),nb)}kb=d+208|0;return c|0}function s6(a){a=a|0;var b=0;v[23540]=0;Y(946,a|0);b=v[23540];v[23540]=0;if((b|0)!=1){return v[a+16>>2]}b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,5693,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)!=1){$();return-1}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function Rs(a){var b=0,c=0,d=0;b=oi(+z[a+4228>>2]*8)*.25+-.25;A[a+4248>>3]=b;if(w[a+4240|0]){if(b>45e-5){c=Ep(b)/.6931471805599453;b=c-H(c);d=c-b;c=0;a:{if(b<.2075187496394219){break a}c=.4150374992788438;if(b<.5){break a}c=b<.792481250360578?.5849625007211562:1}b=oi(d+c)*.5}else{b=0}A[a+4248>>3]=b}Qs(a)}function Ml(a,b,c,d,e){var f=0;a:{if(c>>>0>255){break a}b:{switch(d-2|0){case 0:d=B(c,872)+b|0;f=qN(v[d+720>>2],v[d+1272>>2],e);if((f+5&255)>>>0>5){break a}return pN(a,b,c,e);case 1:break b;default:break a}}f=pN(a,b,c,e);if((f+5&255)>>>0>5){break a}a=B(c,872)+b|0;f=qN(v[a+720>>2],v[a+1272>>2],e)}return f}function M5(a){a=a|0;var b=0;v[23540]=0;Y(971,a|0);b=v[23540];v[23540]=0;a:{if((b|0)==1){b=V(0)|0;O()|0;_(b|0)|0;v[23540]=0;X(933,11963,a|0,0,0);a=v[23540];v[23540]=0;if((a|0)==1){break a}$();a=0}return a|0}a=P()|0;O()|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;if((b|0)!=1){T(a|0);L()}V(0)|0;O()|0;Vb();L()}function Jia(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=kb-192|0;kb=d;c=kb-16|0;kb=c;Nq(c+8|0,d);e=v[c+12>>2];md(c,a,v[c+8>>2],v[c+12>>2]);f=v[c+4>>2];if((f|0)==(e|0)){id(a,v[c+12>>2])}kb=c+16|0;e=(e|0)==(f|0);if(!e){xT(d)}c=-1;a:{if(!e){break a}c=0;if(!zT(d)){break a}c=Ae(a,b,yT(d),nb)}kb=d+192|0;return c|0}function Eka(a){a=a|0;var b=0,c=0,d=0;c=kb-32|0;kb=c;b=255;a:{if(sj(v[a>>2],v[a+4>>2])>>>0<=49){b=Dz(c,v[a+12>>2]);v[23540]=0;R(289,a|0,b|0);d=v[23540];v[23540]=0;if((d|0)==1){break a}ql(b);Gj(a,sj(v[a>>2],v[a+4>>2])-1&255);b=sj(v[a>>2],v[a+4>>2])-1|0}kb=c+32|0;return b&255}a=P()|0;O()|0;ql(b);T(a|0);L()}function EB(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=kb-32|0;kb=f;v[f+8>>2]=c;g=f,h=cf(b),v[g+28>>2]=h;c=f+8|0;Of(c,b,v[Kb(c,f+28|0)>>2]);b=Ie(c);v[23540]=0;da(236,a|0,b|0,v[f+8>>2],d|0,e|0);a=v[23540];v[23540]=0;if((a|0)!=1){Uc(f+8|0);kb=f+32|0;return}a=P()|0;O()|0;Uc(f+8|0);T(a|0);L()}function an(a,b,c,d){var e=0,f=0,g=0,h=0,i=0;a:{if(v[c>>2]|v[d>>2]){while(1){if((b|0)==(f|0)){break a}e=v[d>>2];g=v[c>>2];h=c,i=g-ld((ld(0-g|0,31)&255)+g|0,8)|0,v[h>>2]=i;h=d,i=v[d>>2]-ld(e+(ld(0-e|0,31)&255)|0,8)|0,v[h>>2]=i;e=(f<<3)+a|0;v[e>>2]=v[c>>2];v[e+4>>2]=v[d>>2];f=f+1|0;continue}}Ub(a,0,b<<3)}}function _x(a,b,c){var d=0,e=0;d=kb-16|0;kb=d;v[d>>2]=a;a=v[a+4>>2];v[d+4>>2]=a;v[d+8>>2]=a+B(b,52);b=v[d+4>>2];a=v[d+8>>2];a:{while(1){if((a|0)==(b|0)){break a}v[23540]=0;R(877,b|0,c|0);e=v[23540];v[23540]=0;if((e|0)!=1){b=b+52|0;v[d+4>>2]=b;continue}break}a=P()|0;O()|0;lc(d);T(a|0);L()}lc(d);kb=d+16|0}function Cka(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=kb-16|0;kb=d;v[d+12>>2]=c;a:{if(!Qb(v[b>>2],v[b+8>>2],c<<1)){break a}xc(d+12|0,65535);vg(a,x[d+12>>1]);c=Fb(v[a>>2]);v[d>>2]=c;a=Fb(v[a+4>>2]);while(1){if(!Pb(c,a)){break a}Vu(b,d+8|0);e=c,f=Ib(x[d+8>>1]),u[e>>1]=f;c=v[Se(d)>>2];continue}}kb=d+16|0}function wZ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;f=kb-16|0;kb=f;v[e>>2]=c;a=pw(f+12|0,0,v[a+8>>2]);b=2;a:{if(a+1>>>0<2){break a}c=a-1|0;b=1;if(c>>>0>d-v[e>>2]>>>0){break a}b=f+12|0;while(1){if(c){a=w[b|0];d=v[e>>2];v[e>>2]=d+1;t[d|0]=a;c=c-1|0;b=b+1|0;continue}break}b=0}kb=f+16|0;return b|0}function uea(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=kb-80|0;kb=d;c=kb-16|0;kb=c;aT(c+8|0,d);e=v[c+12>>2];md(c,a,v[c+8>>2],v[c+12>>2]);f=v[c+4>>2];if((f|0)==(e|0)){id(a,v[c+12>>2])}kb=c+16|0;e=(e|0)==(f|0);if(!e){HA(d)}c=-1;a:{if(!e){break a}c=0;if(!SP(d)){break a}c=Ae(a,b,RP(d),nb)}kb=d+80|0;return c|0}function ru(a){var b=0,c=0;b=v[a+76>>2];if(!((b|0)>=0&(!b|v[116024]!=(b&-1073741825)))){b=v[a+4>>2];if((b|0)!=v[a+8>>2]){v[a+4>>2]=b+1;return w[b|0]}return Lw(a)}b=v[a+76>>2];v[a+76>>2]=b?b:1073741823;c=a+76|0;b=v[a+4>>2];a:{if((b|0)!=v[a+8>>2]){v[a+4>>2]=b+1;a=w[b|0];break a}a=Lw(a)}v[c>>2]=0;return a}function h7(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=kb-16|0;kb=d;gd(a,b);v[23540]=0;U(66,d+8|0,b|0,c|0);e=v[23540];v[23540]=0;a:{if((e|0)==1){break a}ac(d+8|0);b=v[b+24>>2];if(b){v[23540]=0;U(67,d|0,b|0,c|0);b=v[23540];v[23540]=0;if((b|0)==1){break a}ac(d)}kb=d+16|0;return}b=P()|0;O()|0;ac(a);T(b|0);L()}function el(a,b){a=a|0;b=b|0;var c=0;c=kb-32|0;kb=c;zp(c,b);v[23540]=0;R(1051,c+16|0,c|0);b=v[23540];v[23540]=0;a:{b:{if((b|0)!=1){v[23540]=0;U(1052,a|0,0,c+16|0);a=v[23540];v[23540]=0;if((a|0)==1){break b}Nc(c+16|0);Ab(c);kb=c+32|0;return}b=P()|0;O()|0;break a}b=P()|0;O()|0;Nc(c+16|0)}Ab(c);T(b|0);L()}function Rr(a,b,c,d){var e=0;a:{if(!(d&2048)){break a}e=d&74;if(!c|((e|0)==8|(e|0)==64)){break a}t[a|0]=43;a=a+1|0}if(d&512){t[a|0]=35;a=a+1|0}while(1){e=w[b|0];if(e){t[a|0]=e;a=a+1|0;b=b+1|0;continue}break}e=d&74;b=111;b:{if((e|0)==64){break b}b=d&16384?88:120;if((e|0)==8){break b}b=c?100:117}t[a|0]=b}function J2(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;f=kb-32|0;kb=f;v[f+28>>2]=e;v[f+24>>2]=d;_g(f+16|0,b,c);b=Cg(f+8|0,f+24|0);c=v[b+4>>2];b=v[b>>2];v[23540]=0;Eg(169,a,v[f+16>>2],v[f+20>>2],b,c);a=v[23540];v[23540]=0;if((a|0)!=1){le(f+24|0);kb=f+32|0;return}a=P()|0;O()|0;le(f+24|0);T(a|0);L()}function uga(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=kb-128|0;kb=d;c=kb-16|0;kb=c;RR(c+8|0,d);e=v[c+12>>2];md(c,a,v[c+8>>2],v[c+12>>2]);f=v[c+4>>2];if((f|0)==(e|0)){id(a,v[c+12>>2])}kb=c+16|0;e=(e|0)==(f|0);if(!e){QR(d)}c=-1;a:{if(!e){break a}c=0;if(!SR(d)){break a}c=Ae(a,b,256,0)}kb=d+128|0;return c|0}function kba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=sc(a,b,614);e=c+616|0;a=0;while(1){d=B(a,872);Vp(d+e|0,(b+d|0)+616|0);a=a+1|0;if((a|0)!=256){continue}break}a=Yz(c+223848|0,b+223848|0);v[23540]=0;Q(803,c+223860|0,b+223860|0)|0;b=v[23540];v[23540]=0;if((b|0)!=1){return c|0}b=P()|0;O()|0;ic(a);T(b|0);L()}function bca(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=kb-16|0;kb=d;c=rf(a,c);me(d,v[a+36>>2]);a:{b:{if(!c){Sc(d,a+32|0,5);e=-1;if(!Cb(v[v[d>>2]>>2],v[d+4>>2])){break b}break a}e=v[c+16>>2]}f=v[a+36>>2];c:{d:{switch(e+1|0){case 0:case 2:li(f,b);break c;default:break d}}lT(f,b,e)}f=c}Ye(a,f);kb=d+16|0}function B9(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=vi(a,b,c,d);v[a>>2]=43900;b=Tb(a+4208|0);v[a+4228>>2]=0;v[a+4220>>2]=0;v[a+4224>>2]=0;v[a+4232>>2]=v[c+24620>>2];uV(a+4260|0,80,150,80,255);v[23540]=0;R(897,a+44|0,2);c=v[23540];v[23540]=0;if((c|0)!=1){ui(a);return a|0}c=P()|0;O()|0;wc(b);If(a);T(c|0);L()}function aM(a){var b=0,c=0;a:{if(Sb(a,14216,4)){break a}b=w[a+4|0]|w[a+5|0]<<8|(w[a+6|0]<<16|w[a+7|0]<<24);if((b|0)!=-1095062050&(b|0)!=-1346458146){break a}b=w[a+16|0]|w[a+17|0]<<8|(w[a+18|0]<<16|w[a+19|0]<<24);if(!b){break a}c=(b+24|0)==(w[a+8|0]|w[a+9|0]<<8|(w[a+10|0]<<16|w[a+11|0]<<24))}return c}function sq(a){var b=0,c=0;b=kb-32|0;kb=b;v[b+24>>2]=0;v[b+28>>2]=0;v[b+16>>2]=0;v[b+20>>2]=0;v[b+8>>2]=0;v[b+12>>2]=0;v[b>>2]=0;v[b+4>>2]=0;c=a+288|0;Iz(c,c+512|0,b);v[b+24>>2]=0;v[b+28>>2]=0;v[b+16>>2]=0;v[b+20>>2]=0;v[b+8>>2]=0;v[b+12>>2]=0;v[b>>2]=0;v[b+4>>2]=0;a=a+800|0;Iz(a,vQ(a),b);kb=b+32|0}function aw(a,b,c,d,e){var f=0,g=0;g=c-b|0;a:{if((e|0)>=(g|0)){e=B(32-E(d|1)|0,1233)>>12;f=61;if((g|0)<(e+(y[(e<<2)+25808>>2]<=d>>>0)|0)){break a}}b:{if(d>>>0<=99999999){c=Zw(b,d);break b}c=d;d=(d>>>0)/1e8|0;e=c+B(d,-1e8)|0;c=(e>>>0)/1e4|0;c=cj(cj(KH(b,d),c),e+B(c,-1e4)|0)}f=0}v[a+4>>2]=f;v[a>>2]=c}function F3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=kb-16|0;kb=e;a:{if(!(c&1024)){break a}f=e,g=he(b),v[f+8>>2]=g;b:{if(!Hb(b)){break b}if(w[Tc(b,0)|0]!=43){if(w[Tc(b,0)|0]!=45){break b}}d=d+1|0;rJ(e+8|0)}c=Hb(b);if(c>>>0>=d>>>0){break a}nJ(b,v[kj(e,e+8|0)>>2],d-c|0,48)}ad(a,b);kb=e+16|0}function z8(a,b,c){a=a|0;b=b|0;c=C(c);var d=0,e=C(0);if(b>>>0<=6){c=Yd(c,C(0));a:{b:{switch(b-3|0){case 0:c=Xh(c);if(c==z[Eb(a+4208|0,3)>>2]){break a}v[a+4236>>2]=0;z[a+4240>>2]=C(c*C(.5))+C(.5);break a;case 1:break b;default:break a}}c=C(Xh(C(c*C(4)))*C(.25))}d=Eb(a+4208|0,b),e=c,z[d>>2]=e;Ix(a)}}function T7(a,b,c){a=a|0;b=b|0;c=C(c);var d=0,e=C(0);if(b>>>0<=6){c=Yd(c,C(0));a:{b:{switch(b-1|0){case 0:c=Xh(c);if(c==z[Eb(a+4208|0,1)>>2]){break a}v[a+4236>>2]=0;z[a+4240>>2]=C(c*C(.5))+C(.5);break a;case 3:break b;default:break a}}c=C(Xh(C(c*C(4)))*C(.25))}d=Eb(a+4208|0,b),e=c,z[d>>2]=e;Ix(a)}}function bO(a,b,c){var d=0,e=0;d=kb-16|0;kb=d;e=v[b+48>>2]+1|0;v[b+52>>2]=e;a:{if(y[_b(v[a+484344>>2],x[b+70>>1])+12>>2]>e>>>0){break a}if(!c){u[b+74>>1]=x[b+72>>1]+1}v[b+52>>2]=0;Db(d+8|0,a+1074312|0,63);if(!Cb(v[v[d+8>>2]>>2],v[d+12>>2])){break a}a=v[b+56>>2];v[b+56>>2]=0;v[b+52>>2]=a}kb=d+16|0}function If(a){a=a|0;var b=0,c=0;v[a>>2]=44376;b=v[a+12>>2];if(v[b>>2]==(a|0)){v[b>>2]=v[a+4>>2]}b=v[a+20>>2];if(b){v[b>>2]=0;v[a+20>>2]=0}b=v[a+4>>2];if(b){v[b+8>>2]=v[a+8>>2]}c=v[a+8>>2];if(c){v[c+4>>2]=b}v[a+4>>2]=0;v[a+8>>2]=0;b=v[a+16>>2];v[b+946300>>2]=v[b+946300>>2]-1;lL(a+44|0);return a|0}function mL(a){a=a|0;var b=0,c=0,d=0;b=A[a+4264>>3]*+y[v[a+16>>2]+1074376>>2];a:{if(D(b)<0x8000000000000000){d=~~b>>>0;c=D(b)>=1?~~(b>0?F(H(b*2.3283064365386963e-10),4294967295):I((b-+(~~b>>>0>>>0))*2.3283064365386963e-10))>>>0:0;break a}c=-2147483648}A[a+4256>>3]=b-(+(d>>>0)+ +(c|0)*4294967296)}function ll(a,b,c){var d=0,e=0;a=Nb(a);d=Hb(b);v[23540]=0;R(48,a|0,d|0);d=v[23540];v[23540]=0;if((d|0)!=1){a:{while(1){if(Hb(b)>>>0>e>>>0){d=v[(w[hg(b,e)|0]<<2)+c>>2];v[23540]=0;R(49,a|0,d|0);d=v[23540];v[23540]=0;if((d|0)==1){break a}e=e+1|0;continue}break}return}}b=P()|0;O()|0;Nc(a);T(b|0);L()}function GY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;if(Zg(a,v[b+8>>2],0)){lw(b,c,d);return}e=v[a+12>>2];f=a+16|0;xF(v[f>>2],v[a+20>>2],b,c,d);a=a+24|0;e=(e<<3)+f|0;a:{if(a>>>0>=e>>>0){break a}while(1){xF(v[a>>2],v[a+4>>2],b,c,d);if(w[b+54|0]){break a}a=a+8|0;if(e>>>0>a>>>0){continue}break}}}function V3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;v[a>>2]=0;v[a+4>>2]=0;Gc(a+8|0);c=mk(v[b+4>>2],v[b+8>>2]);if(c){GO(a,c);d=v[b+4>>2];e=v[b+8>>2];b=kb-16|0;kb=b;a=Dt(b,a,c);v[23540]=0;U(1053,d|0,e|0,a+4|0);c=v[23540];v[23540]=0;a:{if((c|0)!=1){lc(a);kb=b+16|0;break a}b=P()|0;O()|0;lc(a);T(b|0);L()}}}function tja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=kb-16|0;kb=d;v[d+8>>2]=c;v[d+12>>2]=-1;if((c|0)!=-1){f=d,g=Hb(a),v[f>>2]=g;e=v[Kb(d+12|0,d)>>2];v[d+4>>2]=e;a=Op(Mc(a),b,v[Kb(d+4|0,d+8|0)>>2]);a:{if(a){break a}a=-1;if(c>>>0>e>>>0){break a}a=c>>>0<e>>>0}kb=d+16|0;return a|0}sk();L()}function ah(a,b){var c=0,d=0,e=0,f=0;d=kb-16|0;kb=d;a:{if(!b){b=0;break a}c=b>>31;e=(c^b)-c|0;c=E(e);Kf(d,e,0,0,0,c+81|0);e=0+v[d+8>>2]|0;c=(v[d+12>>2]^65536)+(16414-c<<16)|0;c=e>>>0<f>>>0?c+1|0:c;f=b&-2147483648|c;c=v[d+4>>2];b=v[d>>2]}v[a>>2]=b;v[a+4>>2]=c;v[a+8>>2]=e;v[a+12>>2]=f;kb=d+16|0}function JO(a,b,c){var d=0,e=0,f=0,g=0;if(c==0){e=a;b=Ds(b);o(0);a=j(1)|0;f=j(0)|0;o(+c);d=j(1)|0;j(0)|0;l(0,f|0);l(1,a&2147483647|d&-2147483648);nl(e,b,+n());return}a:{if(!mf(b)){break a}d=D(c)<N;if(b<0){c=d?c:1;break a}if(d){break a}nl(a,b,mf(c)?M:c);return}b=Ds(b);g=Di(c);nl(a,b*af(c),g*b)}function xB(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=kb-32|0;kb=e;v[e+8>>2]=c;f=e,g=cf(b),v[f+28>>2]=g;c=e+8|0;Of(c,b,v[Kb(c,e+28|0)>>2]);b=Ie(c);v[23540]=0;X(337,a|0,b|0,v[e+8>>2],d|0);a=v[23540];v[23540]=0;if((a|0)!=1){Uc(e+8|0);kb=e+32|0;return}a=P()|0;O()|0;Uc(e+8|0);T(a|0);L()}function iba(a,b){a=a|0;b=b|0;var c=0,d=0;a:{if(Qd(w[b+24|0])){a=Yf(a);c=Gi(v[b>>2]);d=xf(b);v[23540]=0;U(806,a|0,c|0,d|0);c=v[23540];v[23540]=0;if((c|0)==1){break a}v[23540]=0;Q(805,a+12|0,b+12|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break a}t[a+24|0]=1}return}b=P()|0;O()|0;zN(a);T(b|0);L()}function ZB(a,b,c){var d=0,e=0,f=0;d=kb-32|0;kb=d;v[d+28>>2]=c;v[d+8>>2]=192;e=v[a>>2];f=v[a+8>>2];c=v[Kb(d+28|0,d+8|0)>>2];if(!Qb(e,f,c)){c=cf(a)}e=d+8|0;Nq(e,b);f=hc(d+16|0,v[d+8>>2],c);nc(d,v[a>>2],v[a+8>>2],v[f>>2],v[f+4>>2]);Nq(e,b);Ub(v[d+8>>2]+c|0,0,192-c|0);$b(a,v[d+28>>2]);kb=d+32|0}function OY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=kb-16|0;kb=d;a:{e=v[b>>2];if(zd(e)){if(!Re(c)){rK(c,17803);e=v[b>>2]}b=v[b+4>>2];ob[v[v[b>>2]+24>>2]](d,b,e);v[23540]=0;Q(800,c|0,d|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break a}zb(d)}ad(a,c);kb=d+16|0;return}a=P()|0;O()|0;zb(d);T(a|0);L()}function qQ(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0;e=kb-16|0;kb=e;v[e+12>>2]=6553600;i=e,j=bc(b),v[i+8>>2]=j;f=+(d>>>0)/6553600;g=e+12|0;b=e+8|0;h=Cq(f*+y[Kb(g,b)>>2]);v[e+8>>2]=6553600;i=e,j=bc(c),v[i+4>>2]=j;i=e,j=Cq(f*+y[Kb(b,e+4|0)>>2]),v[i+12>>2]=j;v[e+8>>2]=d-h;jo(a,h,Kb(b,g));kb=e+16|0}function WJ(a,b){var c=0;c=kb-32|0;kb=c;qi(c,b);v[23540]=0;U(1055,c+16|0,0,c|0);b=v[23540];v[23540]=0;a:{b:{if((b|0)!=1){v[23540]=0;R(1056,a|0,c+16|0);a=v[23540];v[23540]=0;if((a|0)==1){break b}Nc(c+16|0);zb(c);kb=c+32|0;return}b=P()|0;O()|0;break a}b=P()|0;O()|0;Nc(c+16|0)}zb(c);T(b|0);L()}function TT(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=kb-16|0;kb=c;a=Yf(a);b=b+236|0;e=Bq(b);a:{while(1){if((b|0)!=(e|0)){d=x[b>>1];u[c+14>>1]=d;if(d){v[23540]=0;U(392,c|0,a|0,c+14|0);d=v[23540];v[23540]=0;if((d|0)==1){break a}}b=b+2|0;continue}break}kb=c+16|0;return}b=P()|0;O()|0;qu(a);T(b|0);L()}function FL(a,b){var c=0,d=0,e=0,f=0,g=C(0);c=kb-16|0;kb=c;if(Yg(v[v[a>>2]-12>>2]+a|0)){u[c+14>>1]=0;Wf(a,c+14|0);e=x[c+14>>1];ek(b,e);while(1){if((d|0)!=(e|0)){v[c+8>>2]=0;Hp(a,c+8|0);f=Eb(v[b>>2],d),g=z[c+8>>2],z[f>>2]=g;d=d+1|0;continue}break}d=Yg(v[v[a>>2]-12>>2]+a|0)}kb=c+16|0;return d}function yU(a){t[a|0]=0;t[a+1|0]=0;t[a+2|0]=0;t[a+3|0]=0;t[a+4|0]=0;t[a+5|0]=0;t[a+6|0]=0;t[a+7|0]=0;t[a+14|0]=0;t[a+15|0]=0;t[a+16|0]=0;t[a+17|0]=0;t[a+18|0]=0;t[a+19|0]=0;t[a+20|0]=0;t[a+21|0]=0;t[a+8|0]=0;t[a+9|0]=0;t[a+10|0]=0;t[a+11|0]=0;t[a+12|0]=0;t[a+13|0]=0;t[a+14|0]=0;t[a+15|0]=0}function Mv(a){t[a|0]=0;t[a+1|0]=0;t[a+2|0]=0;t[a+3|0]=0;t[a+4|0]=0;t[a+5|0]=0;t[a+6|0]=0;t[a+7|0]=0;t[a+16|0]=0;t[a+17|0]=0;t[a+18|0]=0;t[a+19|0]=0;t[a+20|0]=0;t[a+21|0]=0;t[a+22|0]=0;t[a+23|0]=0;t[a+8|0]=0;t[a+9|0]=0;t[a+10|0]=0;t[a+11|0]=0;t[a+12|0]=0;t[a+13|0]=0;t[a+14|0]=0;t[a+15|0]=0}function Cw(a,b,c,d){var e=0,f=0,g=0,h=0;e=kb-160|0;kb=e;v[e+60>>2]=b;v[e+20>>2]=b;v[e+24>>2]=-1;f=e+16|0;mi(f,0,0);WG(e,f,d,1);d=v[e+8>>2];f=v[e+12>>2];g=v[e>>2];h=v[e+4>>2];if(c){v[c>>2]=((v[e+20>>2]+v[e+136>>2]|0)-v[e+60>>2]|0)+b}v[a+8>>2]=d;v[a+12>>2]=f;v[a>>2]=g;v[a+4>>2]=h;kb=e+160|0}function pp(a,b){var c=0,d=0;c=kb-16|0;kb=c;d=c+8|0;gd(d,a);v[23540]=0;a=S(1132,d|0)|0;d=v[23540];v[23540]=0;a:{b:{if((d|0)==1){break b}v[23540]=0;X(1144,a|0,83808,83834,b|0);a=v[23540];v[23540]=0;if((a|0)==1){break b}ac(c+8|0);kb=c+16|0;break a}a=P()|0;O()|0;ac(c+8|0);T(a|0);L()}return b}function mD(a,b,c){var d=0,e=0,f=0,g=0,h=0;d=v[a+92>>2];e=v[a+96>>2];if(d|e){while(1){if((c|0)==(g|0)){v[a+96>>2]=e;v[a+92>>2]=d}else{f=(g<<3)+b|0;h=v[f>>2];d=d-ld((ld(0-d|0,31)&255)+d|0,8)|0;v[f>>2]=h+d;h=v[f+4>>2];e=e-ld((ld(0-e|0,31)&255)+e|0,8)|0;v[f+4>>2]=h+e;g=g+1|0;continue}break}}}function Sy(a,b,c){var d=0;d=v[a+480180>>2];a:{if((d|0)!=1048576){if((d|0)!=4){break a}d=w[b+813|0];if(c){t[b+813|0]=d&15|c<<4;break a}c=(d&240)>>>4|0;break a}if(c){t[b+813|0]=c;break a}c=w[b+813|0]}b:{if(!(t[b+851|0]&1)|!v[b+700>>2]){break b}c=c&255;if(!c){break b}hk(a,b,b+700|0,c<<2,0)}}function NK(a){a=a|0;var b=0,c=0;c=kb-16|0;kb=c;b=v[a+4256>>2];v[a+4240>>2]=b<<1;v[23540]=0;v[c+12>>2]=0;U(903,a+4208|0,b<<2,c+12|0);b=v[23540];v[23540]=0;a:{if((b|0)==1){b=V(92756)|0;if((O()|0)!=(ea(92756)|0)){break a}_(b|0)|0;v[a+4240>>2]=0;$()}v[a+4244>>2]=0;kb=c+16|0;return}T(b|0);L()}function Rha(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=kb-16|0;kb=d;$f(b);v[d+12>>2]=0;a:{if(!pk(a,d+12|0)){break a}f=c;c=v[d+12>>2];if(f>>>0<c>>>0){break a}while(1){if((c|0)==(e|0)){e=1;break a}t[d+11|0]=0;if(Oh(a,d+11|0)){$p(b,t[d+11|0]);e=e+1|0;continue}break}e=0}kb=d+16|0;return e|0}function p$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;c=kb-128|0;kb=c;v[c+12>>2]=c+116;d=v[a+8>>2];a=c+16|0;iG(d,a,c+12|0,e,f,g);e=v[c+12>>2];d=kb-16|0;kb=d;v[d+8>>2]=b;while(1){if((a|0)!=(e|0)){uH(d+8|0,t[a|0]);a=a+1|0;continue}break}kb=d+16|0;kb=c+128|0;return v[d+8>>2]}function hca(a,b){a=a|0;b=b|0;var c=0;a:{v[a>>2]=0;v[a+4>>2]=0;Gc(a+8|0);c=Rc(v[b>>2],v[b+4>>2]);if(c){lq(a,c);fP(a,v[b>>2],v[b+4>>2],c)}v[23540]=0;Q(3,a+12|0,b+12|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){v[a+24>>2]=v[b+24>>2];u[a+28>>1]=x[b+28>>1];break a}b=P()|0;O()|0;od(a);T(b|0);L()}}function _y(a,b,c,d,e){var f=0,g=0,h=0,i=0,j=0,k=0;f=kb-16|0;kb=f;g=v[b+480180>>2];a:{if(g&64671904){b=w[(d&15)+43808|0];t[a+2|0]=0;u[a>>1]=b;break a}Db(f+8|0,b+1074312|0,66);h=a;a=(c&255)==4&(g|0)==4;b=(d&255)<<a<<4;yl(h,(i=Cb(v[v[f+8>>2]>>2],v[f+12>>2])?0:b,j=b,k=e,k?i:j),a)}kb=f+16|0}function Ty(a,b,c){var d=0;d=v[a+480180>>2];a:{if((d|0)!=1048576){if((d|0)!=4){break a}d=w[b+814|0];if(c){t[b+814|0]=d&15|c<<4;break a}c=(d&240)>>>4|0;break a}if(c){t[b+813|0]=c;break a}c=w[b+813|0]}b:{if(!(t[b+851|0]&1)|!v[b+700>>2]){break b}c=c&255;if(!c){break b}hk(a,b,b+700|0,c,0)}}function Wz(a,b,c,d,e){var f=0;a:{f=v[a>>2];if(!_d(f,v[a+20>>2])|c>>>0>=f>>>0|f-c>>>0<d>>>0){break a}Dm(b);b=lo(b,a);v[b+20>>2]=0;v[b>>2]=d;if(!Mg(b)){break a}if(v[a>>2]!=(d|0)){hr(b+68|0)}sc(v[b+20>>2],v[a+20>>2]+c|0,d);v[b+8>>2]=e?d:0;v[b+4>>2]=0;u[b+34>>1]=x[b+34>>1]&65533|(e?2:0)}}function Daa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a:{d=kb+-64|0;kb=d;$f(b);e=d+40|0;Of(e,a,c);a=v[d+40>>2];c=d+8|0;cg(c,1,Ie(e),a);v[23540]=0;R(222,d+24|0,c|0);a=v[23540];v[23540]=0;if((a|0)!=1){a=d+24|0;Bc(b,a);zb(a);Uc(d+40|0);kb=d- -64|0;break a}a=P()|0;O()|0;Uc(d+40|0);T(a|0);L()}}function gH(a,b,c){var d=0,e=0,f=0,g=0;d=kb-16|0;kb=d;a=Es(a);v[a+32>>2]=b;v[a>>2]=78724;b=d+8|0;as(b,a);v[23540]=0;b=S(1111,b|0)|0;e=v[23540];v[23540]=0;if((e|0)!=1){ac(d+8|0);v[a+40>>2]=c;v[a+36>>2]=b;f=a,g=Bn(b),t[f+44|0]=g;kb=d+16|0;return}b=P()|0;O()|0;ac(d+8|0);Mn(a);T(b|0);L()}function fD(a,b,c,d){var e=0,f=0,g=0;b=v[a+1076>>2]+((b&c?0-(c<<1)|0:0)+b|0)|0;v[a+1076>>2]=b;c=b+v[a+1080>>2]|0;v[a+1080>>2]=c;e=d;d=v[a+1068>>2];u[e+(d<<1)>>1]=w[a+1084|0]?c:b;v[a+1064>>2]=v[a+1064>>2]+1;f=a,g=Ld(x[v[a+1060>>2]+34>>1])+d|0,v[f+1068>>2]=g;v[a+1072>>2]=v[a+1072>>2]-1}function eH(a,b,c){var d=0,e=0,f=0,g=0;d=kb-16|0;kb=d;a=tH(a);v[a+32>>2]=b;v[a>>2]=79092;b=d+8|0;as(b,a);v[23540]=0;b=S(1112,b|0)|0;e=v[23540];v[23540]=0;if((e|0)!=1){ac(d+8|0);v[a+40>>2]=c;v[a+36>>2]=b;f=a,g=Bn(b),t[f+44|0]=g;kb=d+16|0;return}b=P()|0;O()|0;ac(d+8|0);ds(a);T(b|0);L()}function LL(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=kb-16|0;kb=d;v[d+12>>2]=b;a:{if(Wh(a)>>>0>=b>>>0){f=v[a>>2];e=uc(f,v[a+4>>2]);v[d+8>>2]=e;KL(f,v[Kb(d+12|0,d+8|0)>>2],c);if(b>>>0>e>>>0){Zx(a,b-e|0,c);break a}Od(a,v[a>>2]+(b<<2)|0);break a}ou(a);Bk(a,qg(a,b));Zx(a,b,c)}kb=d+16|0}function H1(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=a+60|0;d=Ks(c);v[a>>2]=78184;v[d>>2]=78204;v[a+60>>2]=78244;v[a>>2]=78224;v[a+4>>2]=0;e=c;c=a+8|0;Ln(e,c);v[a>>2]=78184;v[d>>2]=78204;v[23540]=0;Q(91,c|0,b|0)|0;b=v[23540];v[23540]=0;if((b|0)!=1){return a|0}a=P()|0;O()|0;_k(d);T(a|0);L()}function tT(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;a:{c=kb+-64|0;kb=c;d=c+40|0;Of(d,a,32);a=v[c+40>>2];e=c+8|0;cg(e,2,Ie(d),a);v[23540]=0;R(222,c+24|0,e|0);a=v[23540];v[23540]=0;if((a|0)!=1){Wm(c,b);a=c+24|0;Kl(c,a);zb(a);Uc(c+40|0);kb=c- -64|0;break a}a=P()|0;O()|0;Uc(c+40|0);T(a|0);L()}}function cq(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0;a:{e=pl(a,b);if((e|0)==255){break a}g=v[a>>2];if(kk(g)){break a}f=Nd(a+318|0,e);e=WO(e);if(h=1,i=t[Lb(f,10)|0]&1,j=d,j?h:i){gh(g,v[a+4>>2],b,e- -64|0,VO(c,w[Lb(f,2)|0]))}if(d){break a}gh(v[a>>2],v[a+4>>2],b,e+67|0,VO(c,w[Lb(f,3)|0]))}}function bW(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=kb-16|0;kb=d;v[d+12>>2]=c;a:{if(!Qb(v[b>>2],v[b+8>>2],c<<1)){break a}xc(d+12|0,65535);vg(a,x[d+12>>1]);c=Fb(v[a>>2]);v[d>>2]=c;a=Fb(v[a+4>>2]);while(1){if(!Pb(c,a)){break a}Vu(b,d+8|0);u[c>>1]=x[d+8>>1];c=v[Se(d)>>2];continue}}kb=d+16|0}function sm(a,b,c,d){var e=0,f=0;a:{f=v[(B(b,872)+a|0)+1075648>>2];if(!f){break a}if(!vj(w[f+31|0])){break a}e=w[f+34|0]-1|0;if((e&255)>>>0>249){break a}e=v[Md(a+906300|0,e)>>2];if(!e){break a}ob[v[v[e>>2]+96>>2]](e,f,c,d,b);if(c>>>0>250){break a}u[(B(b,872)+a|0)+1075834>>1]=65535}}function Wr(a,b,c,d){var e=0,f=0;e=kb-160|0;kb=e;f=-1;v[e+148>>2]=b?b-1|0:0;a=b?a:e+158|0;v[e+144>>2]=a;e=Ub(e,0,144);v[e+76>>2]=-1;v[e+36>>2]=1114;v[e+80>>2]=-1;v[e+44>>2]=e+159;v[e+84>>2]=e+144;a:{if((b|0)<0){v[116016]=61;break a}t[a|0]=0;f=QH(e,c,d,1088,1089)}kb=e+160|0;return f}function Pg(a){var b=0,c=0,d=0;b=a;a:{if(b&3){while(1){if(!w[b|0]){break a}b=b+1|0;if(b&3){continue}break}}while(1){c=b;b=b+4|0;d=v[c>>2];if(!((d^-1)&d-16843009&-2139062144)){continue}break}if(!(d&255)){return c-a|0}while(1){d=w[c+1|0];b=c+1|0;c=b;if(d){continue}break}}return b-a|0}function LJ(a){var b=0,c=0,d=0,e=0;d=kb-16|0;kb=d;b=a+120|0;zs(w[b+20|0]);c=kb-16|0;kb=c;v[c+8>>2]=d+8;a=kb-16|0;kb=a;e=v[14455];v[a+8>>2]=v[14454];v[a+12>>2]=e;e=v[14453];v[a>>2]=v[14452];v[a+4>>2]=e;b=ob[v[yp(a,dk(w[b+20|0]))>>2]](c+8|0,b)|0;kb=a+16|0;kb=c+16|0;kb=d+16|0;return b}function Fv(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;f=kb-16|0;kb=f;v[f+12>>2]=e;v[f+8>>2]=d;_g(f,b,c);v[23540]=0;Ra(171,a|0,v[f>>2],v[f+4>>2]);b=v[23540];v[23540]=0;if((b|0)!=1){v[a+8>>2]=0;b=f+8|0;Cg(a+12|0,b);le(b);kb=f+16|0;return a|0}a=P()|0;O()|0;le(f+8|0);T(a|0);L()}function AK(a,b,c){t[a+12|0]=0;v[c>>2]=0;v[b>>2]=0;v[a+28>>2]=0;v[a+32>>2]=0;u[a+24>>1]=0;v[a+36>>2]=0;v[a+40>>2]=0;v[a+44>>2]=0;v[a+48>>2]=0;zK(a+60|0);zK(a+52|0);Rp(a+49956|0);Rp(a+58148|0);Rp(a+66340|0);Rp(a+74532|0);Ub(a+228|0,0,32768);Ub(a+32996|0,0,512);Ub(a+33508|0,0,16384)}function eC(a,b,c){var d=0,e=0,f=0;d=kb+-64|0;kb=d;$f(b);e=d+40|0;Of(e,a,c);a=v[d+40>>2];f=d+8|0;cg(f,3,Ie(e),a);v[23540]=0;R(222,d+24|0,f|0);e=v[23540];v[23540]=0;if((e|0)!=1){e=b;b=d+24|0;Bc(e,b);zb(b);Uc(d+40|0);kb=d- -64|0;return!c|(a|0)!=0}a=P()|0;O()|0;Uc(d+40|0);T(a|0);L()}function daa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=kb-16|0;kb=d;c=rf(a,c);me(d,v[a+36>>2]);a:{b:{if(!c){Sc(d,a+32|0,5);e=-1;if(!Cb(v[v[d>>2]>>2],v[d+4>>2])){break b}break a}e=v[c+16>>2]}f=v[a+36>>2];c:{if(!((e|0)!=4&(e|0)!=-1)){pk(f,b);break c}FG(f,b,e)}f=c}Ye(a,f);kb=d+16|0}function Xi(a,b,c,d){var e=0,f=0,g=0,h=0;e=kb-16|0;kb=e;v[e+12>>2]=d;g=ki(e+8|0,b);b=kb-16|0;kb=b;d=v[e+12>>2];v[b+12>>2]=d;v[b+8>>2]=d;f=-1;d=Wr(0,0,c,d);a:{if((d|0)<0){break a}h=a;d=d+1|0;a=Pd(d);v[h>>2]=a;if(!a){break a}f=Wr(a,d,c,v[b+12>>2])}kb=b+16|0;ji(g);kb=e+16|0;return f}function Oba(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=kb-16|0;kb=d;v[d+12>>2]=b;a:{if(mp(a)>>>0>=b>>>0){f=v[a>>2];e=fd(f,v[a+4>>2]);v[d+8>>2]=e;di(f,v[Kb(d+12|0,d+8|0)>>2],c);if(b>>>0>e>>>0){Po(a,b-e|0,c);break a}Od(a,v[a>>2]+b|0);break a}uB(a);Ll(a,Vl(a,b));Po(a,b,c)}kb=d+16|0}function Xh(a){var b=C(0),c=0,d=0;c=(p(a),j(2));d=c>>>23&255;if(d>>>0<=149){if(d>>>0<=125){return C(a*C(0))}a=(c|0)>=0?a:C(-a);b=C(C(C(a+C(8388608))+C(-8388608))-a);a:{if(b>C(.5)){a=C(C(a+b)+C(-1));break a}a=C(a+b);if(!(b<=C(-.5))){break a}a=C(a+C(1))}a=(c|0)>=0?a:C(-a)}return a}function Bia(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a:{d=kb+-64|0;kb=d;e=d+40|0;Of(e,a,c);a=v[d+40>>2];c=d+8|0;cg(c,2,Ie(e),a);v[23540]=0;R(222,d+24|0,c|0);a=v[23540];v[23540]=0;if((a|0)!=1){a=d+24|0;El(b,a);zb(a);Uc(d+40|0);kb=d- -64|0;break a}a=P()|0;O()|0;Uc(d+40|0);T(a|0);L()}}function Aaa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a:{d=kb+-64|0;kb=d;e=d+40|0;Of(e,a,c);a=v[d+40>>2];c=d+8|0;cg(c,1,Ie(e),a);v[23540]=0;R(222,d+24|0,c|0);a=v[23540];v[23540]=0;if((a|0)!=1){a=d+24|0;Be(b,a);zb(a);Uc(d+40|0);kb=d- -64|0;break a}a=P()|0;O()|0;Uc(d+40|0);T(a|0);L()}}function fV(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a:{d=kb+-64|0;kb=d;e=d+40|0;Of(e,a,c);a=v[d+40>>2];c=d+8|0;cg(c,2,Ie(e),a);v[23540]=0;R(222,d+24|0,c|0);a=v[23540];v[23540]=0;if((a|0)!=1){a=d+24|0;Dc(b,a);zb(a);Uc(d+40|0);kb=d- -64|0;break a}a=P()|0;O()|0;Uc(d+40|0);T(a|0);L()}}function Xq(a,b,c,d,e){var f=0,g=0,h=0,i=0,j=0;f=kb-16|0;kb=f;v[f+12>>2]=c;c=f+12|0;xc(c,256);xc(c,65535);h=x[f+12>>1];vg(a,h);c=0;while(1){if((c|0)==(h|0)){kb=f+16|0}else{g=w[b+c|0];i=Gl(v[a>>2],v[a+4>>2],c),j=(d|0)==(g|0)?-1:(e|0)==(g|0)?-2:g,u[i>>1]=j;c=c+1|0;continue}break}}function FP(a,b){var c=0,d=0,e=0,f=0;c=kb-96|0;kb=c;uR(b,c,c+96|0);b=0;while(1){if((b|0)==12){v[a+104>>2]=0;v[a+96>>2]=!(v[a+88>>2]|v[a+92>>2]);v[a+100>>2]=0;kb=c+96|0}else{d=b<<3;e=d+a|0;f=c+d|0;d=v[f+4>>2];v[e>>2]=v[f>>2];v[e+4>>2]=d&65535;b=b+1|0;continue}break}v[a+112>>2]=0}function ot(a,b){var c=0,d=0,e=0,f=0,g=0;d=kb-16|0;kb=d;Fe(d+8|0,b);b=v[d+8>>2];e=v[d+12>>2];c=kb-16|0;kb=c;f=Hb(a);v[c+12>>2]=f;v[c+8>>2]=e;g=Kb(c+12|0,c+8|0);a=Op(Mc(a),b,v[g>>2]);a:{if(a){break a}a=-1;if(e>>>0>f>>>0){break a}a=e>>>0<f>>>0}kb=c+16|0;kb=d+16|0;return a>>>31|0}function eD(a,b,c,d){var e=0,f=0;b=v[a+1076>>2]+((b&c?0-(c<<1)|0:0)+b|0)|0;v[a+1076>>2]=b;c=b+v[a+1080>>2]|0;v[a+1080>>2]=c;t[v[a+1068>>2]+d|0]=w[a+1084|0]?c:b;v[a+1064>>2]=v[a+1064>>2]+1;e=a,f=v[a+1068>>2]+Ld(x[v[a+1060>>2]+34>>1])|0,v[e+1068>>2]=f;v[a+1072>>2]=v[a+1072>>2]-1}function OJ(a,b,c){var d=0,e=0;while(1){a:{if((a|0)!=(b|0)){e=v[a>>2];d=Pg(e);b:{c:{if((Hb(c)|0)==(d|0)){v[23540]=0;d=W(361,c|0,e|0,d|0)|0;e=v[23540];v[23540]=0;if((e|0)==1){break c}d=!d}else{d=0}break b}V(0)|0;O()|0;Vb();L()}if(!d){break a}}else{a=b}return a}a=a+8|0;continue}}function BS(a,b,c,d){var e=0,f=0;e=kb-16|0;kb=e;v[e+12>>2]=a;a:{if(!(!c|b)){a=Qe(+(B(a,d)>>>0)*.25*1e4);break a}if(!(!a|!b)){xc(e+12|0,10);a=B(w[v[e+12>>2]+26864|0],1e4);break a}f=+(a>>>0);if(a-1>>>0<=9){a=Qe(733.8401379310345/f*1e4);break a}a=Qe(f/.264*1e4)}kb=e+16|0;return a}function df(a){var b=0,c=0;b=kb-32|0;kb=b;t[b+8|0]=0;v[b>>2]=0;v[b+4>>2]=4194432;OC(b+9|0);v[a>>2]=v[b>>2];c=v[b+8>>2];v[a+4>>2]=v[b+4>>2];v[a+8>>2]=c;c=v[b+16>>2];v[a+12>>2]=v[b+12>>2];v[a+16>>2]=c;c=v[b+24>>2];v[a+20>>2]=v[b+20>>2];v[a+24>>2]=c;t[a+28|0]=w[b+28|0];kb=b+32|0}function Aba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;a:{c=kb+-64|0;kb=c;d=c+40|0;Of(d,a,32);a=v[c+40>>2];e=c+8|0;cg(e,1,Ie(d),a);v[23540]=0;R(222,c+24|0,e|0);a=v[23540];v[23540]=0;if((a|0)!=1){a=c+24|0;Dc(b,a);zb(a);Uc(c+40|0);kb=c- -64|0;break a}a=P()|0;O()|0;Uc(c+40|0);T(a|0);L()}}function v9(a,b){a=a|0;b=b|0;var c=0;a:{b:{c=v[a+20>>2];b=v[c+4>>2];if((fd(b,v[c+8>>2])|0)!=8){break b}if(Sb(b,9585,4)){break b}c=w[b+4|0]|w[b+5|0]<<8|(w[b+6|0]<<16|w[b+7|0]<<24);v[a+4260>>2]=w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24);v[a+4264>>2]=c;break a}Rx(a,a)}Ts(a)}function oka(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;b=kb-624|0;kb=b;d=-1;c=kb-16|0;kb=c;e=b+8|0;hV(c+8|0,e);f=v[c+12>>2];md(c,a,v[c+8>>2],v[c+12>>2]);g=v[c+4>>2];if((g|0)==(f|0)){id(a,v[c+12>>2])}kb=c+16|0;a=(f|0)==(g|0);if(!a){gV(e)}if(a){d=iV(b+8|0)}kb=b+624|0;return d|0}function Zba(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=kb-16|0;kb=d;a=cQ(d,a+8|0,b);b=v[a>>2];a:{while(1){if(v[a+4>>2]==(b|0)){break a}v[23540]=0;R(754,b|0,c|0);b=v[23540];v[23540]=0;if((b|0)!=1){b=v[a>>2]+32|0;v[a>>2]=b;continue}break}b=P()|0;O()|0;Ud(a);T(b|0);L()}Ud(a);kb=d+16|0}function Bfa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;b=kb-160|0;kb=b;d=-1;c=kb-16|0;kb=c;e=b+8|0;kR(c+8|0,e);f=v[c+12>>2];md(c,a,v[c+8>>2],v[c+12>>2]);g=v[c+4>>2];if((g|0)==(f|0)){id(a,v[c+12>>2])}kb=c+16|0;a=(f|0)==(g|0);if(!a){jR(e)}if(a){d=lR(b+8|0)}kb=b+160|0;return d|0}function hC(a,b,c){var d=0,e=0,f=0;d=kb+-64|0;kb=d;e=d+40|0;Of(e,a,c);a=v[d+40>>2];f=d+8|0;cg(f,3,Ie(e),a);v[23540]=0;R(222,d+24|0,f|0);e=v[23540];v[23540]=0;if((e|0)!=1){e=b;b=d+24|0;Dc(e,b);zb(b);Uc(d+40|0);kb=d- -64|0;return!c|(a|0)!=0}a=P()|0;O()|0;Uc(d+40|0);T(a|0);L()}function gL(a){a=a|0;var b=0,c=0;c=kb-16|0;kb=c;b=v[v[a+16>>2]+1074404>>2];v[23540]=0;v[c+12>>2]=0;U(903,a+4208|0,B(b,254)|0,c+12|0);b=v[23540];v[23540]=0;a:{if((b|0)==1){b=V(92756)|0;if((O()|0)!=(ea(92756)|0)){break a}_(b|0)|0;$()}v[a+4220>>2]=0;kb=c+16|0;return}T(b|0);L()}function bw(a,b,c,d,e){var f=0,g=0;a:{f=kb+-64|0;kb=f;g=f+40|0;Of(g,a,e);a=v[f+40>>2];e=f+8|0;cg(e,d,Ie(g),a);v[23540]=0;R(222,f+24|0,e|0);a=v[23540];v[23540]=0;if((a|0)!=1){hc(f,b,c);a=f+24|0;Kl(f,a);zb(a);Uc(f+40|0);kb=f- -64|0;break a}a=P()|0;O()|0;Uc(f+40|0);T(a|0);L()}}function SR(a){var b=0;a:{if(Sb(a,15546,4)|((w[a+8|0]|w[a+9|0]<<8)-768&65535)>>>0<65280|(((w[a+112|0]|w[a+113|0]<<8)-65&65535)>>>0<65472|(w[a+106|0]|w[a+107|0]<<8)>>>0>256)){break a}if((w[a+122|0]|w[a+123|0]<<8)>>>0>255){break a}b=(w[a+124|0]|w[a+125|0]<<8)>>>0<4e3}return b}function lV(a,b){var c=0,d=0,e=0;d=kb-16|0;kb=d;v[d+12>>2]=b;c=kb-16|0;kb=c;v[c+12>>2]=153391689;v[c+8>>2]=2147483647;e=Kb(c+12|0,c+8|0);kb=c+16|0;c=b;b=v[e>>2];if(c>>>0<=b>>>0){a=LB(a);if(a>>>0<b>>>1>>>0){v[d+8>>2]=a<<1;b=v[_c(d+8|0,d+12|0)>>2]}kb=d+16|0;return b}cd();L()}function Uha(a,b){a=a|0;b=b|0;var c=0,d=0;c=kb-16|0;kb=c;v[c+8>>2]=b;a:{if(uc(v[a>>2],v[a+4>>2])>>>0>511){break a}if(!zd(b)){break a}v[23540]=0;R(487,a|0,c+8|0);a=v[23540];v[23540]=0;d=b;if((a|0)!=1){break a}a=P()|0;O()|0;sg(c+8|0);T(a|0);L()}sg(c+8|0);kb=c+16|0;return d|0}function Oja(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;b=kb-32|0;kb=b;d=-1;c=kb-16|0;kb=c;e=b+8|0;yu(c+8|0,e);f=v[c+12>>2];md(c,a,v[c+8>>2],v[c+12>>2]);g=v[c+4>>2];if((g|0)==(f|0)){id(a,v[c+12>>2])}kb=c+16|0;a=(f|0)==(g|0);if(!a){yU(e)}if(a){d=zU(b+8|0)}kb=b+32|0;return d|0}function Jha(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;b=kb-16|0;kb=b;d=-1;c=kb-16|0;kb=c;e=b+8|0;Go(c+8|0,e);f=v[c+12>>2];md(c,a,v[c+8>>2],v[c+12>>2]);g=v[c+4>>2];if((g|0)==(f|0)){id(a,v[c+12>>2])}kb=c+16|0;a=(f|0)==(g|0);if(!a){VS(e)}if(a){d=WS(b+8|0)}kb=b+16|0;return d|0}function yV(a,b){var c=0,d=0;a:{b:{a=a-12|0;c:{if(a>>>0>31){break c}d=1<<a;c=1;if(d&-2145904587){break a}if(d&65792){break b}if((a|0)!=7){break c}b=b&240;c=1;if(!b|(b|0)==96|(b|0)==224){break a}}return 0}b=(b&240)-96|0;c=0;if(b>>>0>=144){break a}c=297>>>(b>>>4)&1}return c}function xS(a,b){var c=0,d=0;a:{c=v[b>>2];d=v[b+20>>2];if(!_d(c,d)){break a}if(v[a+20>>2]==(d|0)){v[a+20>>2]=0;c=v[b>>2]}xc(a,c);c=x[a+34>>1]&-2|u[b+34>>1]&1;u[a+34>>1]=c;u[a+34>>1]=c&65471|x[b+34>>1]&64;if(!Mg(a)){break a}sc(v[a+20>>2],v[b+20>>2],Ij(v[a>>2],x[a+34>>1]))}}function YD(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=kb-32|0;kb=e;g=v[b+8>>2];f=v[b>>2];_g(e+16|0,c,d);c=v[v[f>>2]+28>>2];d=v[e+20>>2];v[e+8>>2]=v[e+16>>2];v[e+12>>2]=d;ob[c|0](e+24|0,f,g,e+8|0);_g(a,v[e+24>>2],v[e+28>>2]);v[b+8>>2]=v[b+8>>2]+v[a+4>>2];kb=e+32|0}function RU(a,b){var c=0,d=0,e=0;d=kb-16|0;kb=d;v[d+12>>2]=b;c=kb-16|0;kb=c;v[c+12>>2]=89478485;v[c+8>>2]=2147483647;e=Kb(c+12|0,c+8|0);kb=c+16|0;c=b;b=v[e>>2];if(c>>>0<=b>>>0){a=NU(a);if(a>>>0<b>>>1>>>0){v[d+8>>2]=a<<1;b=v[_c(d+8|0,d+12|0)>>2]}kb=d+16|0;return b}cd();L()}function v0(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;h=(e-d|0)+b|0;a:{while(1){if((d|0)!=(e|0)){a=-1;if((b|0)==(c|0)){break a}f=t[b|0];g=t[d|0];if((f|0)<(g|0)){break a}if((f|0)>(g|0)){return 1}else{d=d+1|0;b=b+1|0;continue}}break}a=(c|0)!=(h|0)}return a|0}function N3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=kb-16|0;kb=c;Kn(c,a);if(v[b>>2]){Lc(b);a=v[b>>2];Br(b);Mb(a);d=Gb(b),e=0,v[d>>2]=e;v[b>>2]=0;v[b+4>>2]=0}v[b>>2]=v[c>>2];v[b+4>>2]=v[c+4>>2];a=Gb(c);d=Gb(b),e=v[a>>2],v[d>>2]=e;v[a>>2]=0;v[c>>2]=0;v[c+4>>2]=0;Xf(c);kb=c+16|0}function Kh(a){var b=0,c=0,d=0,e=0,f=0,g=0;d=kb-16|0;kb=d;b=kb-16|0;kb=b;v[b+4>>2]=1;f=b,g=vc(16),v[f+8>>2]=g;c=Wo(v[b+8>>2]);v[c>>2]=42792;f=fn(Cc(c)),g=42924,v[f>>2]=g;c=d+8|0;e=Yo(b);Xo(c,Cc(e),e);gn(b);kb=b+16|0;Cg(a,c);le(c);kb=d+16|0;v[a+8>>2]=0;ee(a+12|0);return a}function Fn(a,b,c){var d=0,e=0,f=0;a:{if(!b){d=a;break a}while(1){d=Mka(a,b,10,0);f=nb;e=Jka(d,f,246,0)+a|0;c=c-1|0;t[c|0]=e|48;e=b>>>0>9;a=d;b=f;if(e){continue}break}}if(d){while(1){c=c-1|0;a=(d>>>0)/10|0;t[c|0]=B(a,246)+d|48;b=d>>>0>9;d=a;if(b){continue}break}}return c}function ve(a){var b=0,c=0,d=0;o(+a);b=j(1)|0;j(0)|0;d=b>>>20&2047;if(d>>>0<=1074){if(d>>>0<=1021){return a*0}a=(b|0)>0|(b|0)>=0?a:-a;c=a+4503599627370496+-4503599627370496-a;a:{if(c>.5){a=a+c+-1;break a}a=a+c;if(!(c<=-.5)){break a}a=a+1}a=(b|0)>0|(b|0)>=0?a:-a}return a}function f3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=kb-32|0;kb=d;v[d+24>>2]=c;a:{while(1){if((a|0)==(b|0)){break a}c=Kc(d+8|0,v[a>>2]);v[23540]=0;Q(1071,d+24|0,c|0)|0;e=v[23540];v[23540]=0;if((e|0)!=1){zb(c);a=a+4|0;continue}break}a=P()|0;O()|0;zb(c);T(a|0);L()}kb=d+32|0}function qn(a,b){var c=0,d=0,e=0,f=0;c=kb-16|0;kb=c;a:{if(!b){b=0;break a}d=b;b=E(b);Kf(c,d,0,0,0,b+81|0);e=16414-b<<16;b=0;d=b+v[c+8>>2]|0;e=e+(v[c+12>>2]^65536)|0;e=b>>>0>d>>>0?e+1|0:e;f=d;d=v[c>>2];b=v[c+4>>2]}v[a>>2]=d;v[a+4>>2]=b;v[a+8>>2]=f;v[a+12>>2]=e;kb=c+16|0}function T8(a){a=a|0;var b=0,c=0,d=0,e=0;b=kb-16|0;kb=b;v[b+12>>2]=a;v[b+8>>2]=4104;a=0;d=v[b+8>>2];a:{if(d>>>0<4096){break a}c=v[b+12>>2];e=c+7&-8;c=e-c|0;if(c>>>0>d-4096>>>0){break a}v[b+12>>2]=e;v[b+8>>2]=d-c;a=e}if(!a){aa(6056,9043,88,7360);L()}kb=b+16|0;return a|0}function BP(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;a:{e=kb-16|0;kb=e;b:{c:{if((b|0)==(c|0)){b=a;a=Mc(d);Vh(b,a,Hb(d)+a|0);break c}wP(e,c,d);v[23540]=0;U(44,a|0,b|0,e|0);a=v[23540];v[23540]=0;if((a|0)==1){break b}Nc(e)}kb=e+16|0;break a}a=P()|0;O()|0;Nc(e);T(a|0);L()}}function rV(a){var b=0,c=0,d=0,e=0,f=0,g=0;b=kb-16|0;kb=b;f=Lb(a,31),g=0,t[f|0]=g;t[b+15|0]=0;c=zi(a,ho(a),b+15|0);t[b+14|0]=0;c=Th(a,c);om(c+a|0,ho(a),b+14|0);while(1){if((c|0)!=(d|0)){e=Lb(a,d);if((w[e|0]-127&255)>>>0<=160){t[e|0]=32}d=d+1|0;continue}break}kb=b+16|0}function Os(a){var b=0,c=0,d=C(0);b=a+4232|0;c=w[b|0];if(c>>>0>=5){t[b|0]=0;c=0}if(t[a+4233|0]<0){t[a+4233|0]=127}b=t[a+4234|0];if((b|0)<0){t[a+4234|0]=127;b=127}a:{if((c|0)==3){d=C(C(1)-te(C(2),C(-C((b&255)+1|0))));break a}d=te(C(2),C(-C((b&255)>>>0)))}z[a+4224>>2]=d}function pX(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=kb-16|0;kb=d;v[d+12>>2]=c;v[d+8>>2]=b;c=kb-16|0;kb=c;v[c+4>>2]=1;e=c,f=vc(24),v[e+8>>2]=f;b=Wo(v[c+8>>2]);v[b>>2]=62196;TD(Cc(b),v[d+8>>2],v[d+12>>2]);b=Yo(c);Xo(d,Cc(b),b);gn(c);kb=c+16|0;Cg(a,d);le(d);kb=d+16|0}function ZD(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a:{d=kb-16|0;kb=d;b:{c:{if(!b){b=a;a=sd(c);Vh(b,a,Ad(v[c+4>>2],w[c+11|0])+a|0);break c}oN(d,c);v[23540]=0;U(44,a|0,b|0,d|0);a=v[23540];v[23540]=0;if((a|0)==1){break b}Nc(d)}kb=d+16|0;break a}a=P()|0;O()|0;Nc(d);T(a|0);L()}}function QQ(a){var b=0,c=0,d=0,e=0;c=kb-16|0;kb=c;b=Fb(v[a>>2]);v[c+8>>2]=b;e=Fb(v[a+4>>2]);while(1){a:{d=Pb(b,e);if(!d){break a}a=x[b>>1];b:{if(!((a|0)!=255&(a|0)!=99)){u[b>>1]=65535;break b}if(a>>>0>63){break a}}b=v[Se(c+8|0)>>2];continue}break}kb=c+16|0;return d^1}function oh(a,b){var c=0,d=0,e=0;a:{if(!(b?1:t[a+480180|0]&1)){break a}e=v[a+24616>>2]&524288;b=0;while(1){if((b|0)==127){break a}c=(b<<5)+a|0;u[c+480286>>1]=64;d=c+480280|0;v[d>>2]=v[d>>2]&-257;d=c+480284|0;c=(b&3)-1>>>0<2;u[d>>1]=e?c<<8:c?192:64;b=b+1|0;continue}}}function jp(a,b,c){var d=0,e=0,f=0;d=a*a;f=d*(d*d)*(d*1.58969099521155e-10+-2.5050760253406863e-8)+(d*(d*27557313707070068e-22+-.0001984126982985795)+.00833333333332249);e=d*a;if(!c){return e*(d*f+-.16666666666666632)+a}return a-(d*(b*.5-f*e)-b+e*.16666666666666632)}function bD(a,b){var c=0,d=0;c=kb-16|0;kb=c;d=c+8|0;gd(d,a);v[23540]=0;a=S(19,d|0)|0;d=v[23540];v[23540]=0;a:{if((d|0)==1){break a}v[23540]=0;a=Q(20,a|0,b|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break a}ac(c+8|0);kb=c+16|0;return a}a=P()|0;O()|0;ac(c+8|0);T(a|0);L()}function YU(a,b,c){var d=0,e=0;d=kb-16|0;kb=d;t[d+15|0]=1;t[d+14|0]=a>>>2;a=w[jf(d+15|0,d+14|0)|0];e=b>>>0<2|a>>>0<15;if(!e){t[d+13|0]=1;t[d+12|0]=(((a+b|0)-2&65535)>>>0)/((b-1&65535)>>>0);a=w[jf(d+13|0,d+12|0)|0]}kb=d+16|0;return(c?a<<4|(e?15:0):a&15|(e?-16:0))&255}function PE(a,b,c,d){var e=0,f=0,g=0,h=0;e=kb-16|0;kb=e;v[e+12>>2]=c;c=e+12|0;xc(c,d);xc(c,65535);f=x[e+12>>1];vg(a,f);c=0;while(1){if((c|0)==(f|0)){kb=e+16|0}else{d=w[b+c|0];g=Gl(v[a>>2],v[a+4>>2],c),h=(d|0)==255?-1:(d|0)==254?-2:d,u[g>>1]=h;c=c+1|0;continue}break}}function F0(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;a:{if(!w[a+44|0]){c=(c|0)>0?c:0;while(1){if((c|0)==(d|0)){break a}if(((f=a,g=Mf(t[b|0]),e=v[v[a>>2]+52>>2],ob[e](f|0,g|0)|0)|0)==-1){return d|0}else{b=b+1|0;d=d+1|0;continue}}}c=wk(b,1,c,v[a+32>>2])}return c|0}function Cj(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=Fb(v[b>>2]);f=Fb(v[b+4>>2]);e=kb-16|0;kb=e;v[e+8>>2]=d;while(1){a:{if(!Pb(d,f)){break a}if(UU(c,v[d>>2],v[d+4>>2])){break a}d=v[Om(e+8|0)>>2];continue}break}kb=e+16|0;if(pc(d,Fb(v[b+4>>2]))){Kh(a);return}Bo(a,d)}function Az(a,b,c){var d=0,e=0,f=0;d=kb-16|0;kb=d;a=Nz(d,a,b);b=v[a+4>>2];e=v[a+8>>2];a:{while(1){if((b|0)==(e|0)){break a}v[23540]=0;R(754,b|0,c|0);f=v[23540];v[23540]=0;if((f|0)!=1){b=b+32|0;v[a+4>>2]=b;continue}break}b=P()|0;O()|0;lc(a);T(b|0);L()}lc(a);kb=d+16|0}function $C(a,b,c){var d=0,e=0,f=0,g=0;d=kb-16|0;kb=d;e=v[a+4>>2];f=e+b|0;v[a+4>>2]=f;a:{b:{if(!e){g=f-1|0;break b}g=f-1|0;if((g^e-1)>>>0>31){break b}a=v[a>>2];break a}a=v[a>>2];v[a+((f>>>0<33?0:g>>>5|0)<<2)>>2]=0}Oo(d+8|0,a,e);ov(v[d+8>>2],v[d+12>>2],b,c);kb=d+16|0}function M8(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;v[a+4>>2]=b;v[a>>2]=0;b=Jx(a+8|0,d);v[23540]=0;Q(913,a+20|0,c|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){v[a+32>>2]=0;v[a+36>>2]=0;t[a+42|0]=0;t[a+40|0]=0;t[a+41|0]=w[a+41|0]&224|25;return a|0}a=P()|0;O()|0;Xb(b);T(a|0);L()}function NJ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a=Nb(a);d=Pg(b);e=Hb(c);v[23540]=0;X(1060,a|0,b|0,d|0,d+e|0);b=v[23540];v[23540]=0;a:{if((b|0)!=1){b=Mc(c);v[23540]=0;W(1061,a|0,b|0,e|0)|0;b=v[23540];v[23540]=0;if((b|0)!=1){break a}}b=P()|0;O()|0;zb(a);T(b|0);L()}}function e1(a){a=a|0;var b=0,c=0,d=0;c=v[a+44>>2];b=v[a+24>>2];if(c>>>0<b>>>0){v[a+44>>2]=b;c=b}d=-1;a:{if(!(w[a+48|0]&8)){break a}b=v[a+16>>2];if(b>>>0<c>>>0){Cn(a,v[a+8>>2],v[a+12>>2],c);b=v[a+16>>2]}a=v[a+12>>2];if(a>>>0>=b>>>0){break a}d=Mf(t[a|0])}return d|0}function Zr(a,b){var c=0,d=0,e=0;d=-1;a:{if((a|0)==-1){break a}e=v[b+76>>2]>=0;b:{c=v[b+4>>2];c:{if(!c){Xw(b);c=v[b+4>>2];if(!c){break c}}if(v[b+44>>2]-8>>>0<c>>>0){break b}}if(!e){break a}return-1}c=c-1|0;v[b+4>>2]=c;t[c|0]=a;v[b>>2]=v[b>>2]&-17;d=a&255}return d}function N7(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;a=vi(a,b,c,d);v[a>>2]=46576;b=a+4208|0;e=Eb(b,0),f=1017370378,v[e>>2]=f;e=Eb(b,1),f=0,v[e>>2]=f;v[23540]=0;R(897,a+44|0,2);b=v[23540];v[23540]=0;if((b|0)!=1){ui(a);return a|0}b=P()|0;O()|0;If(a);T(b|0);L()}function JE(a,b,c,d){var e=0,f=0;a:{e=kb+-64|0;kb=e;f=e+40|0;Of(f,a,d);a=v[e+40>>2];d=e+8|0;cg(d,c,Ie(f),a);v[23540]=0;R(222,e+24|0,d|0);a=v[23540];v[23540]=0;if((a|0)!=1){a=e+24|0;Be(b,a);zb(a);Uc(e+40|0);kb=e- -64|0;break a}a=P()|0;O()|0;Uc(e+40|0);T(a|0);L()}}function yT(a){var b=0,c=0,d=0,e=0;d=w[a+32|0]|w[a+33|0]<<8;e=w[a+38|0]|w[a+39|0]<<8;c=w[a+34|0]|w[a+35|0]<<8;b=c+(w[a+36|0]|w[a+37|0]<<8)|0;a=0;a=b>>>0<c>>>0?1:a;c=b;b=e+b|0;a=b>>>0<c>>>0?a+1|0:a;a=a<<2|b>>>30;c=b<<2;b=d+c|0;a=b>>>0<c>>>0?a+1|0:a;nb=a;return b}function tV(a,b,c){var d=0,e=0;d=kb+-64|0;kb=d;$f(b);e=d+40|0;Of(e,a,c);a=v[d+40>>2];c=d+8|0;cg(c,2,Ie(e),a);v[23540]=0;R(222,d+24|0,c|0);a=v[23540];v[23540]=0;if((a|0)!=1){a=d+24|0;Bc(b,a);zb(a);Uc(d+40|0);kb=d- -64|0;return}a=P()|0;O()|0;Uc(d+40|0);T(a|0);L()}function a3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;a:{c=kb-16|0;kb=c;v[c+4>>2]=1;e=c,f=vc(52),v[e+8>>2]=f;d=v[c+8>>2];v[23540]=0;Q(1078,d|0,b|0)|0;b=v[23540];v[23540]=0;if((b|0)!=1){b=a;a=Yo(c);Xo(b,Cc(a),a);gn(c);kb=c+16|0;break a}a=P()|0;O()|0;gn(c);T(a|0);L()}}function Kl(a,b){var c=0,d=0,e=0,f=0;c=kb-16|0;kb=c;d=Mc(b);e=c,f=Hb(b),v[e+12>>2]=f;v[c+8>>2]=v[a+4>>2]-1;qh(d,d+v[Kb(c+12|0,c+8|0)>>2]|0,v[a>>2]);d=v[a>>2];e=c,f=Hb(b),v[e+12>>2]=f;a=v[a+4>>2];v[c+8>>2]=a-1;om(d+v[Kb(c+12|0,c+8|0)>>2]|0,a+d|0,62428);kb=c+16|0}function zC(a,b){var c=0,d=0,e=0;c=kb-16|0;kb=c;a=bv(c,a,b);b=v[a+4>>2];d=v[a+8>>2];a:{while(1){if((b|0)==(d|0)){break a}v[23540]=0;Y(228,b|0);e=v[23540];v[23540]=0;if((e|0)!=1){b=b+20|0;v[a+4>>2]=b;continue}break}b=P()|0;O()|0;lc(a);T(b|0);L()}lc(a);kb=c+16|0}function lba(a,b){a=a|0;b=b|0;var c=0,d=0;c=w[a+11|0];a:{b:{c:{if(!kf(c)){d=10;c=Mf(c);if((c|0)==10){break c}ie(a,c+1|0);d=a;break a}c=v[a+4>>2];d=lB(v[a+8>>2])-1|0;if((c|0)!=(d|0)){break b}}My(a,d,1,d,d,0);c=d}d=v[a>>2];Hd(a,c+1|0)}a=c+d|0;xd(a,b);xd(a+1|0,0)}function Sj(a,b){var c=0,d=0,e=0,f=0,g=0;g=v[a+8>>2];while(1){if((b|0)!=(e|0)){d=v[a>>2];if(d){c=v[a+4>>2]}else{v[a>>2]=8;c=g;d=v[a+12>>2];if((c|0)!=(d|0)){c=d-1|0;v[a+12>>2]=c}d=8;c=w[c|0]}v[a>>2]=d-1;v[a+4>>2]=c>>>1;f=c&1|f<<1;e=e+1|0;continue}break}return f}function $k(a){var b=0,c=0;a:{b=v[a+1396>>2];if((b|0)>24){break a}if(!b){v[a+1392>>2]=0}while(1){if(w[a+1376|0]?0:v[a+1384>>2]){break a}c=ps(a);if((c|0)==-1){break a}b=v[a+1396>>2];v[a+1396>>2]=b+8;v[a+1392>>2]=v[a+1392>>2]+(c<<b);if((b|0)<17){continue}break}}}function vja(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;b=kb-160|0;kb=b;d=-1;c=kb-16|0;kb=c;hU(c+8|0,b);e=v[c+12>>2];md(c,a,v[c+8>>2],v[c+12>>2]);f=v[c+4>>2];if((f|0)==(e|0)){id(a,v[c+12>>2])}kb=c+16|0;a=(e|0)==(f|0);if(!a){gU(b)}if(a){d=iU(b)}kb=b+160|0;return d|0}function lA(a,b,c){var d=0,e=0,f=0,g=0,h=0;e=kb-1024|0;kb=e;d=kb-16|0;kb=d;iA(d+8|0,e);f=v[d+12>>2];nc(d,v[a>>2],v[a+8>>2],v[d+8>>2],v[d+12>>2]);g=v[d+4>>2];if((g|0)==(f|0)){$b(a,v[d+12>>2])}kb=d+16|0;if((f|0)==(g|0)){h=jA(e,c)>>>0<=b>>>0}kb=e+1024|0;return h}function jfa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;b=kb-208|0;kb=b;d=-1;c=kb-16|0;kb=c;LQ(c+8|0,b);e=v[c+12>>2];md(c,a,v[c+8>>2],v[c+12>>2]);f=v[c+4>>2];if((f|0)==(e|0)){id(a,v[c+12>>2])}kb=c+16|0;a=(e|0)==(f|0);if(!a){KQ(b)}if(a){d=MQ(b)}kb=b+208|0;return d|0}function Vb(){var a=0;a=v[23539];v[23540]=0;Z(a|0);a=v[23540];v[23540]=0;a:{if((a|0)!=1){v[23540]=0;Z(1223);a=v[23540];v[23540]=0;if((a|0)!=1){break a}}a=V(0)|0;O()|0;_(a|0)|0;v[23540]=0;Z(1223);a=v[23540];v[23540]=0;if((a|0)!=1){break a}V(0)|0;O()|0;Vb()}L()}function t9(a,b,c){a=a|0;b=b|0;c=C(c);var d=0,e=C(0),f=0,g=C(0);d=kb-16|0;kb=d;f=d,g=C(C(ob[v[v[a>>2]+48>>2]](a,b))+c),z[f+12>>2]=g;c=C(0);e=z[d+12>>2];a:{if(!(e<C(0))){c=C(1);if(!(e>C(1))){break a}}z[d+12>>2]=c}ob[v[v[a>>2]+44>>2]](a,b,z[d+12>>2]);kb=d+16|0}function kz(a,b,c,d){var e=0,f=0,g=0;e=Td(a);a:{if(e){f=jc(a);while(1){a=e;e=x[a+16>>1];g=v[a+20>>2];if(ml(c,d,e,g)){f=a;e=v[a>>2];if(e){continue}break a}if(!ml(e,g,c,d)){break a}f=a+4|0;e=v[a+4>>2];if(e){continue}break}break a}a=jc(a);f=a}v[b>>2]=a;return f}function JG(a,b,c){var d=0,e=0,f=0,g=0;d=a;a:{e=$d(b,c);if(e>>>0<1073741808){b:{if(Vr(e)){ie(d,e);break b}f=am(e)+1|0;g=Bi(f);wd(d,g);ff(d,f);Hd(d,e);d=g}while(1){if((b|0)!=(c|0)){wd(d,v[b>>2]);d=d+4|0;b=b+4|0;continue}break}wd(d,0);break a}hf();L()}return a}function DP(a,b){var c=0,d=0;v[a+4>>2]=b;v[a>>2]=94168;v[a+20>>2]=0;v[a+24>>2]=0;c=(b>>>5|0)+((b&31)!=0)|0;v[a+12>>2]=c;d=(b>>>0)/(c>>>0)|0;v[a+8>>2]=d;v[a+32>>2]=d>>>0<31?-1>>>31-d|0:-1;v[a+28>>2]=b>>>0<c>>>0?0:-1>>>32-d|0;v[a+16>>2]=(B(c,d)-b|0)+c;return a}function nX(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=kb-16|0;kb=e;f=v[b+8>>2];a:{if(f>>>0<=c>>>0){c=v[d>>2];b=0;break a}v[e+12>>2]=f-c;v[e+8>>2]=v[d+4>>2];c=v[b+4>>2]+c|0;f=c;b=v[Kb(e+12|0,e+8|0)>>2];g=c+b|0;c=v[d>>2];Oi(f,g,c)}gc(a,c,b);kb=e+16|0}function bl(a,b,c){var d=0,e=0,f=0,g=0;e=kb-16|0;kb=e;v[e+8>>2]=c;while(1){a:{if((a|0)!=(b|0)){c=kb-16|0;kb=c;d=rc(c+8|0,v[a>>2]);f=v[d>>2];g=v[d+4>>2];d=v[e+8>>2];d=Qc(f,g,v[d>>2],v[d+4>>2]);kb=c+16|0;if(!d){break a}b=a}kb=e+16|0;return b}a=a+8|0;continue}}function Jy(a,b,c,d){var e=0,f=0,g=0;e=Td(a);a:{if(e){f=jc(a);while(1){a=e;e=w[a+16|0];g=v[a+20>>2];if(Sn(c,d,e,g)){f=a;e=v[a>>2];if(e){continue}break a}if(!Sn(e,g,c,d)){break a}f=a+4|0;e=v[a+4>>2];if(e){continue}break}break a}a=jc(a);f=a}v[b>>2]=a;return f}function uW(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;b=kb-48|0;kb=b;d=-1;c=kb-16|0;kb=c;GC(c+8|0,b);e=v[c+12>>2];md(c,a,v[c+8>>2],v[c+12>>2]);f=v[c+4>>2];if((f|0)==(e|0)){id(a,v[c+12>>2])}kb=c+16|0;a=(e|0)==(f|0);if(!a){FC(b)}if(a){d=HC(b)}kb=b+48|0;return d|0}function T9(a,b){a=a|0;b=b|0;var c=0;c=kb-32|0;kb=c;v[c+8>>2]=-1;v[c+12>>2]=0;v[c>>2]=0;Nb(c+16|0);v[23540]=0;v[c>>2]=v[c>>2]&-1332|1058;v[c+4>>2]=1;U(101,a|0,b|0,c|0);a=v[23540];v[23540]=0;if((a|0)!=1){Pj(c);kb=c+32|0;return}a=P()|0;O()|0;Pj(c);T(a|0);L()}function Pha(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=kb-16|0;kb=c;$f(b);t[c+15|0]=0;a:{if(!Oh(a,c+15|0)){break a}f=w[c+15|0];d=1;while(1){if((e&255)==(f|0)){break a}t[c+14|0]=0;if(Oh(a,c+14|0)){$p(b,t[c+14|0]);e=e+1|0;continue}break}d=0}kb=c+16|0;return d|0}function s0(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;a:{while(1){if((d|0)!=(e|0)){a=-1;if((b|0)==(c|0)){break a}f=v[b>>2];g=v[d>>2];if((f|0)<(g|0)){break a}if((f|0)>(g|0)){return 1}else{d=d+4|0;b=b+4|0;continue}}break}a=(b|0)!=(c|0)}return a|0}function of(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=a;e=kb-16|0;kb=e;a:{if(b>>>0<4294967280){b:{if(Cl(b)){ie(d,b);break b}f=nh(b)+1|0;g=vc(f);wd(d,g);ff(d,f);Hd(d,b);d=g}c=BB(d,b,c);t[e+15|0]=0;we(b+c|0,e+15|0);kb=e+16|0;break a}hf();L()}return a|0}function jC(a,b,c){var d=0,e=0;d=kb+-64|0;kb=d;e=d+40|0;Of(e,a,c);a=v[d+40>>2];c=d+8|0;cg(c,3,Ie(e),a);v[23540]=0;R(222,d+24|0,c|0);a=v[23540];v[23540]=0;if((a|0)!=1){a=d+24|0;El(b,a);zb(a);Uc(d+40|0);kb=d- -64|0;return}a=P()|0;O()|0;Uc(d+40|0);T(a|0);L()}function t$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;g=kb-16|0;kb=g;v[g+8>>2]=b;gd(g,d);v[23540]=0;b=S(1132,g|0)|0;d=v[23540];v[23540]=0;if((d|0)!=1){ac(g);mG(a,f+24|0,g+8|0,c,e,b);kb=g+16|0;return v[g+8>>2]}a=P()|0;O()|0;ac(g);T(a|0);L()}function s$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;g=kb-16|0;kb=g;v[g+8>>2]=b;gd(g,d);v[23540]=0;b=S(1132,g|0)|0;d=v[23540];v[23540]=0;if((d|0)!=1){ac(g);lG(a,f+16|0,g+8|0,c,e,b);kb=g+16|0;return v[g+8>>2]}a=P()|0;O()|0;ac(g);T(a|0);L()}function dca(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;e=b;d=kb-16|0;kb=d;b=rf(a,c);me(d,v[a+36>>2]);a:{b:{if(!b){Sc(d,a+32|0,5);c=-1;if(!Cb(v[v[d>>2]>>2],v[d+4>>2])){break b}break a}c=v[b+16>>2]}xz(v[a+36>>2],e,c);f=1;g=b}Ye(a,g);kb=d+16|0;return f|0}function Xw(a){var b=0,c=0;b=v[a+72>>2];v[a+72>>2]=b-1|b;if(v[a+20>>2]!=v[a+28>>2]){ob[v[a+36>>2]](a,0,0)|0}v[a+28>>2]=0;v[a+16>>2]=0;v[a+20>>2]=0;b=v[a>>2];if(b&4){v[a>>2]=b|32;return-1}c=v[a+44>>2]+v[a+48>>2]|0;v[a+8>>2]=c;v[a+4>>2]=c;return b<<27>>31}function z$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;g=kb-16|0;kb=g;v[g+8>>2]=b;gd(g,d);v[23540]=0;b=S(19,g|0)|0;d=v[23540];v[23540]=0;if((d|0)!=1){ac(g);qG(a,f+24|0,g+8|0,c,e,b);kb=g+16|0;return v[g+8>>2]}a=P()|0;O()|0;ac(g);T(a|0);L()}function y$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;g=kb-16|0;kb=g;v[g+8>>2]=b;gd(g,d);v[23540]=0;b=S(19,g|0)|0;d=v[23540];v[23540]=0;if((d|0)!=1){ac(g);pG(a,f+16|0,g+8|0,c,e,b);kb=g+16|0;return v[g+8>>2]}a=P()|0;O()|0;ac(g);T(a|0);L()}function _U(a,b,c){var d=0,e=0;d=kb-16|0;kb=d;e=0;a:{if(!a){break a}b:{c:{if(a>>>0<=15){if(b>>>0<2|c){break c}break b}if(b>>>0>1){break b}}e=a|-16;break a}t[d+15|0]=1;t[d+14|0]=(a>>>0)/((b-1&255)>>>0);e=w[jf(d+15|0,d+14|0)|0]}a=e;kb=d+16|0;return a&255}function eba(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a:{b:{if((b|0)!=437){if((b|0)==1252){break b}d=0;if((b|0)==65001){break a}c:{if((b|0)!=28591){if((b|0)==28605){break c}if((b|0)!=20127){break b}d=1;break a}d=2;break a}d=3;break a}d=5;break a}d=8}lD(a,d,c)}function AA(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;GS(a,b);dd(a,bc(w[b+8|0]|w[b+9|0]<<8|(w[b+10|0]<<16|w[b+11|0]<<24))+504|0);FS(a,d);a:{b=bc(w[b+32|0]|w[b+33|0]<<8|(w[b+34|0]<<16|w[b+35|0]<<24));if(!b){break a}if(!dd(a,b)){break a}CA(a,c);return}Ub(c,0,80)}function y3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;d=v[b>>2];e=v[b+8>>2];f=v[b+4>>2];a=0;a:while(1){if((a|0)!=(f|0)){g=(a<<2)+d|0;b=0;while(1)if((b|0)==(e|0)){a=a+1|0;continue a}else{c=v[g>>2]+(b<<3)|0;v[c>>2]=0;v[c+4>>2]=0;b=b+1|0;continue}}break}}function N2(a){a=a|0;var b=0,c=0,d=0;b=kb-32|0;kb=b;if(!w[a+8|0]){Qi(a+12|0,v[a+4>>2]);re(b+24|0,v[a+12>>2],v[a+16>>2]);c=v[v[a>>2]+40>>2];d=v[b+28>>2];v[b+8>>2]=v[b+24>>2];v[b+12>>2]=d;ob[c|0](b+16|0,a,0,b+8|0);t[a+8|0]=1}kb=b+32|0;return v[a+12>>2]}function yE(a,b){var c=0,d=0,e=0,f=0;c=kb-16|0;kb=c;v[b>>2]=0;t[c+15|0]=0;Oh(a,c+15|0);d=w[c+15|0];e=d>>>2|0;f=d&3;d=0;while(1){v[b>>2]=e;if((d|0)==(f|0)){kb=c+16|0}else{t[c+15|0]=0;Oh(a,c+15|0);d=d+1|0;e=v[b>>2]|w[c+15|0]<<(d<<3)-2;continue}break}}function Gr(a,b,c,d){var e=0;e=kb-32|0;kb=e;v[e+8>>2]=-1;v[e+12>>2]=0;v[e>>2]=0;Nb(e+16|0);v[e+4>>2]=d;v[23540]=0;v[e>>2]=v[e>>2]&-1332|1058;U(c|0,a|0,b|0,e|0);a=v[23540];v[23540]=0;if((a|0)!=1){jm(e);kb=e+32|0;return}a=P()|0;O()|0;jm(e);T(a|0);L()}function G8(a,b){a=a|0;b=b|0;var c=0,d=0;b=kb-16|0;kb=b;a:{b:{d=v[a+20>>2];c=v[d+4>>2];if((fd(c,v[d+8>>2])|0)!=7){break b}if(Sb(c,9585,4)){break b}c=Fb(c);d=Fb(v[v[a+20>>2]+8>>2]);Ho(b+8|0,a+4228|0);qh(c,d,v[b+8>>2]);break a}Rx(a,a)}Os(a);kb=b+16|0}function MQ(a){var b=0;a:{if(Sb(a,15040,4)){break a}if(Ib(w[a+4|0]|w[a+5|0]<<8)>>>0>2|w[a+6|0]>128){break a}if(Ib(w[a+200|0]|w[a+201|0]<<8)>>>0>3999){break a}if(!Ib(w[a+140|0]|w[a+141|0]<<8)){break a}b=(Ib(w[a+148|0]|w[a+149|0]<<8)|0)==50}return b}function rG(a,b,c){var d=0,e=0,f=0;d=a;a:{if(b>>>0<1073741808){b:{if(Vr(b)){ie(d,b);break b}e=am(b)+1|0;f=Bi(e);wd(d,f);ff(d,e);Hd(d,b);d=f}e=b;f=d;while(1){v[f>>2]=c;f=f+4|0;e=e-1|0;if(e){continue}break}wd((b<<2)+d|0,0);break a}hf();L()}return a}function RH(a,b){var c=0,d=0,e=0;o(+a);d=j(1)|0;e=j(0)|0;c=d>>>20&2047;if((c|0)!=2047){if(!c){if(a==0){c=0}else{a=RH(a*0x10000000000000000,b);c=v[b>>2]+-64|0}v[b>>2]=c;return a}v[b>>2]=c-1022;l(0,e|0);l(1,d&-2146435073|1071644672);a=+n()}return a}function Ir(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;f=kb-16|0;kb=f;d=bd(a);e=Hb(a);a:{if(d-e>>>0>=c>>>0){if(!c){break a}d=Ac(a);He(d+e|0,b,c);b=c+e|0;Sh(a,b);t[f+15|0]=0;we(b+d|0,f+15|0);break a}kp(a,d,(c+e|0)-d|0,e,e,0,c,b)}kb=f+16|0;return a|0}function zba(a,b){a=a|0;b=b|0;var c=0,d=0;a:{b:{c:{if(!ef(a)){c=1;d=w[a+11|0];if((d|0)==1){break c}ie(a,d+1|0);c=a;break a}c=Il(a)-1|0;d=v[a+4>>2];if((c|0)!=(d|0)){break b}}$F(a,c,1,c,c);d=c}c=v[a>>2];Hd(a,d+1|0)}a=(d<<2)+c|0;wd(a,b);wd(a+4|0,0)}function Tl(a,b,c,d,e,f){var g=0;g=kb-32|0;kb=g;v[g+8>>2]=-1;v[g+12>>2]=0;v[g>>2]=0;Nb(g+16|0);v[g+4>>2]=f;v[23540]=0;v[g>>2]=v[g>>2]&e|d;U(c|0,a|0,b|0,g|0);a=v[23540];v[23540]=0;if((a|0)!=1){Pj(g);kb=g+32|0;return}a=P()|0;O()|0;Pj(g);T(a|0);L()}function wka(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a:{d=kb-32|0;kb=d;e=d+16|0;Lq(e,c);Yi(d+8|0,e);v[23540]=0;X(296,a|0,b|0,v[d+8>>2],v[d+12>>2]);a=v[23540];v[23540]=0;if((a|0)!=1){Xb(d+16|0);kb=d+32|0;break a}a=P()|0;O()|0;Xb(d+16|0);T(a|0);L()}}function sia(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a:{d=kb-32|0;kb=d;e=d+16|0;IA(e,c);Yi(d+8|0,e);v[23540]=0;X(114,a|0,b|0,v[d+8>>2],v[d+12>>2]);a=v[23540];v[23540]=0;if((a|0)!=1){dc(d+16|0);kb=d+32|0;break a}a=P()|0;O()|0;dc(d+16|0);T(a|0);L()}}function r$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;a=kb-16|0;kb=a;v[a+8>>2]=b;gd(a,d);v[23540]=0;b=S(1132,a|0)|0;d=v[23540];v[23540]=0;if((d|0)!=1){ac(a);jG(f+20|0,a+8|0,c,e,b);kb=a+16|0;return v[a+8>>2]}b=P()|0;O()|0;ac(a);T(b|0);L()}function oia(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a:{d=kb-32|0;kb=d;e=d+16|0;ap(e,c);Yi(d+8|0,e);v[23540]=0;X(114,a|0,b|0,v[d+8>>2],v[d+12>>2]);a=v[23540];v[23540]=0;if((a|0)!=1){dc(d+16|0);kb=d+32|0;break a}a=P()|0;O()|0;dc(d+16|0);T(a|0);L()}}function oga(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a:{d=kb-32|0;kb=d;e=d+16|0;Dp(e,c);Yi(d+8|0,e);v[23540]=0;X(296,a|0,b|0,v[d+8>>2],v[d+12>>2]);a=v[23540];v[23540]=0;if((a|0)!=1){Xb(d+16|0);kb=d+32|0;break a}a=P()|0;O()|0;Xb(d+16|0);T(a|0);L()}}function kP(a,b,c){var d=0,e=0,f=0,g=0;f=v[b+4>>2];e=b+4|0;hq(v[a>>2],c,e);g=v[a+4>>2];d=b+8|0;while(1){if((c|0)!=(g|0)){Mi(v[d>>2],x[c>>1]);v[d>>2]=v[d>>2]+2;c=c+2|0;continue}break}qc(a,e);qc(a+4|0,d);qc(Gb(a),Cc(b));v[b>>2]=v[b+4>>2];return f}function is(a,b){a=a|0;b=b|0;var c=0,d=0;c=kb-16|0;kb=c;d=ba(16)|0;zF();a=hc(c+8|0,a,94152);c=v[a+4>>2];a=v[a>>2];v[23540]=0;a=fa(1090,d|0,a|0,c|0,b|0)|0;b=v[23540];v[23540]=0;if((b|0)!=1){ha(a|0,92064,1091);L()}a=P()|0;O()|0;ca(d|0);T(a|0);L()}function hfa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a:{d=kb-32|0;kb=d;e=d+16|0;HT(e,c);Yi(d+8|0,e);v[23540]=0;X(114,a|0,b|0,v[d+8>>2],v[d+12>>2]);a=v[23540];v[23540]=0;if((a|0)!=1){dc(d+16|0);kb=d+32|0;break a}a=P()|0;O()|0;dc(d+16|0);T(a|0);L()}}function gaa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=kb-16|0;kb=e;c=rf(a,c);me(e,v[a+36>>2]);a:{b:{if(!c){Sc(e,a+32|0,5);f=-1;if(!Cb(v[v[e>>2]>>2],v[e+4>>2])){break b}break a}f=v[c+16>>2]}ob[d|0](v[a+36>>2],b,f);g=c}Ye(a,g);kb=e+16|0}function OA(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;a:{c=Tb(a+8|0);v[23540]=0;d=S(202,b|0)|0;e=v[23540];v[23540]=0;b:{if((e|0)==1){break b}v[23540]=0;U(244,a|0,b|0,d|0);a=v[23540];v[23540]=0;if((a|0)==1){break b}break a}a=P()|0;O()|0;ic(c);T(a|0);L()}}function bV(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a:{d=kb-32|0;kb=d;e=d+16|0;XB(e,c);Yi(d+8|0,e);v[23540]=0;X(114,a|0,b|0,v[d+8>>2],v[d+12>>2]);a=v[23540];v[23540]=0;if((a|0)!=1){dc(d+16|0);kb=d+32|0;break a}a=P()|0;O()|0;dc(d+16|0);T(a|0);L()}}function bE(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a:{d=kb-32|0;kb=d;e=d+16|0;nn(e,c);Yi(d+8|0,e);v[23540]=0;X(114,a|0,b|0,v[d+8>>2],v[d+12>>2]);a=v[23540];v[23540]=0;if((a|0)!=1){dc(d+16|0);kb=d+32|0;break a}a=P()|0;O()|0;dc(d+16|0);T(a|0);L()}}function DC(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a:{d=kb-32|0;kb=d;e=d+16|0;_u(e,c);Yi(d+8|0,e);v[23540]=0;X(114,a|0,b|0,v[d+8>>2],v[d+12>>2]);a=v[23540];v[23540]=0;if((a|0)!=1){dc(d+16|0);kb=d+32|0;break a}a=P()|0;O()|0;dc(d+16|0);T(a|0);L()}}function BU(a,b,c){var d=0,e=0,f=0,g=0;f=v[b+4>>2];e=b+4|0;hq(v[a>>2],c,e);g=v[a+4>>2];d=b+8|0;while(1){if((c|0)!=(g|0)){xd(v[d>>2],w[c|0]);v[d>>2]=v[d>>2]+1;c=c+1|0;continue}break}qc(a,e);qc(a+4|0,d);qc(Gb(a),Cc(b));v[b>>2]=v[b+4>>2];return f}function $v(a,b,c,d,e){var f=0;f=kb-32|0;kb=f;v[f+8>>2]=-1;v[f+12>>2]=0;v[f>>2]=0;v[f+4>>2]=0;Nb(f+16|0);v[23540]=0;v[f>>2]=v[f>>2]&e|d;U(c|0,a|0,b|0,f|0);a=v[23540];v[23540]=0;if((a|0)!=1){Pj(f);kb=f+32|0;return}a=P()|0;O()|0;Pj(f);T(a|0);L()}function x$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;a=kb-16|0;kb=a;v[a+8>>2]=b;gd(a,d);v[23540]=0;b=S(19,a|0)|0;d=v[23540];v[23540]=0;if((d|0)!=1){ac(a);oG(f+20|0,a+8|0,c,e,b);kb=a+16|0;return v[a+8>>2]}b=P()|0;O()|0;ac(a);T(b|0);L()}function ip(a,b){var c=0,d=0,e=0,f=0;c=a*a;d=c*.5;e=1-d;f=1-e-d;d=c*c;return e+(f+(c*(c*(c*(c*2480158728947673e-20+-.001388888888887411)+.0416666666666666)+d*d*(c*(c*-1.1359647557788195e-11+2.087572321298175e-9)+-2.7557314351390663e-7))-a*b))}function cC(a){var b=0,c=0,d=0,e=0;b=w[a+2|0];c=b+(w[a+5|0]|w[a+6|0]<<8)|0;d=b>>>0>c>>>0?1:d;b=c;c=b<<1;b=d<<1|b>>>31;a=w[a+3|0]|w[a+4|0]<<8;d=a>>>30|0;e=c;c=a<<2;e=e+c|0;a=b+d|0;a=c>>>0>e>>>0?a+1|0:a;b=e+47|0;a=b>>>0<47?a+1|0:a;nb=a;return b}function KO(a){var b=0,c=0,d=0,e=0,f=0;b=kb-16|0;kb=b;c=a;d=v[a>>2];f=mk(d,v[a+4>>2]);a=Fb(d);v[b+8>>2]=a;e=+(f>>>0);c=Fb(v[c+4>>2]);while(1){if(Pb(a,c)){A[a>>3]=A[a>>3]/e;A[a+8>>3]=A[a+8>>3]/e;a=v[iq(b+8|0)>>2];continue}else{kb=b+16|0}break}}function DD(a){t[a|0]=0;t[a+1|0]=0;t[a+2|0]=0;t[a+3|0]=0;t[a+4|0]=0;t[a+5|0]=0;t[a+6|0]=0;t[a+7|0]=0;t[a+16|0]=0;t[a+17|0]=0;t[a+18|0]=0;t[a+19|0]=0;t[a+8|0]=0;t[a+9|0]=0;t[a+10|0]=0;t[a+11|0]=0;t[a+12|0]=0;t[a+13|0]=0;t[a+14|0]=0;t[a+15|0]=0}function kA(a,b,c){var d=0;d=kb-16|0;kb=d;u[d+12>>1]=c;u[d+14>>1]=b;b=Fb(v[a>>2]);c=Fb(v[a+4>>2]);a=kb-16|0;kb=a;v[a+8>>2]=b;while(1){if(Pb(b,c)){if(x[b>>1]==x[d+14>>1]){u[b>>1]=x[d+12>>1]}b=v[Se(a+8|0)>>2];continue}break}kb=a+16|0;kb=d+16|0}function WN(a,b){var c=0,d=0;d=kb-16|0;kb=d;c=v[a+104>>2];a:{if(!c){break a}c=v[c>>2];if(!c){break a}v[a+76>>2]=c;v[a+88>>2]=v[a+88>>2]&-131|128;v[d+12>>2]=b<<8;v[d+8>>2]=c-1;b=c+(v[Kb(d+12|0,d+8|0)>>2]^-1)|0;v[a>>2]=0;v[a+4>>2]=b}kb=d+16|0}function nD(a){var b=0,c=0;a:{if(Sb(a,14201,4)){break a}if(Sb(a+8|0,14122,4)){break a}b=bc(w[a+4|0]|w[a+5|0]<<8|(w[a+6|0]<<16|w[a+7|0]<<24));if(!b){break a}c=(bc(w[a+12|0]|w[a+13|0]<<8|(w[a+14|0]<<16|w[a+15|0]<<24))|0)!=0&b>>>0>27}return c}function TK(a,b,c){var d=0,e=0;if(C(D(a))<C(0x8000000000000000)){d=~~a>>>0}else{d=0}e=d&-2147483648;d=e?0-d|0:d;while(1){if(!((d|0)<0|(b|0)<=0)){b=b-1|0;d=d<<1;continue}break}b=(d>>>31|0)+b<<31-c|(d&2147483647)>>>c;return C((e?b^-1|e:b)|0)}function jO(a,b){var c=0;c=w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24);t[a|0]=c;t[a+1|0]=c>>>8;t[a+2|0]=c>>>16;t[a+3|0]=c>>>24;b=w[b+3|0]|w[b+4|0]<<8|(w[b+5|0]<<16|w[b+6|0]<<24);t[a+3|0]=b;t[a+4|0]=b>>>8;t[a+5|0]=b>>>16;t[a+6|0]=b>>>24}function ge(a,b){var c=0,d=0;c=v[a+4>>2];d=c+b|0;v[a+4>>2]=d;if(v[a+8>>2]>=(d|0)){d=v[a>>2]+(c>>3)|0;a=c&7;c=w[d|0]&255>>>a;a=a+b|0;b=0;while(1){if((a|0)>=9){a=a-8|0;b=c<<a|b;c=w[d+1|0];d=d+1|0;continue}break}a=c>>>8-a|b}else{a=0}return a}function cN(a,b){a=_M(a);_M(a+368680|0);if(b){ZM(a,1);return}if(!w[463032]){cN(94328,1);t[463032]=1}ao(225440,290976,a+131112|0);ao(290976,356512,a+196648|0);ao(356512,422048,a+262184|0);ao(94352,225440,a+24|0);sc(a+327720|0,422048,40960)}function TQ(a){var b=0,c=0;a:{if(w[a+29|0]!=2){break a}b=w[a+28|0];if((b|0)!=26&(b|0)!=2|w[a+30|0]!=2){break a}b=w[a+31|0];if(b>>>0>21|!(1<<b&3146753)|w[a+33|0]>64){break a}b=w[a+34|0];if(b>>>0>=65&(b|0)!=88){break a}c=RQ(a+20|0)}return c}function T3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=kb-32|0;kb=d;el(d,c);c=d+16|0;v[c>>2]=b;ad(c+4|0,d);v[23540]=0;R(1054,a+4|0,c|0);a=v[23540];v[23540]=0;if((a|0)!=1){Cs(d+16|0);zb(d);kb=d+32|0;return}a=P()|0;O()|0;Cs(d+16|0);zb(d);T(a|0);L()}function Of(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Tb(a+8|0);v[23540]=0;U(244,a|0,b|0,c|0);c=v[23540];v[23540]=0;a:{if((c|0)!=1){a=v[a>>2];v[23540]=0;Q(188,b|0,a|0)|0;a=v[23540];v[23540]=0;if((a|0)!=1){break a}}a=P()|0;O()|0;ic(d);T(a|0);L()}}function KE(a,b,c,d){var e=0,f=0,g=0,h=0;e=kb-16|0;kb=e;v[e+12>>2]=c;c=e+12|0;xc(c,d);xc(c,65535);d=x[e+12>>1];vg(a,d);c=0;while(1){if((c|0)==(d|0)){kb=e+16|0}else{f=w[b+c|0];g=Gl(v[a>>2],v[a+4>>2],c),h=f,u[g>>1]=h;c=c+1|0;continue}break}}function Gia(a){a=a|0;var b=0,c=0,d=0;b=kb-32|0;kb=b;t[b+30|0]=0;u[b+28>>1]=0;c=hc(b+8|0,b+28|0,3);nc(b+16|0,v[a>>2],v[a+8>>2],v[c>>2],v[c+4>>2]);a:{if(v[b+20>>2]!=3){break a}if(Sb(b+28|0,14773,3)){break a}$b(a,3);d=1}kb=b+32|0;return d|0}function Gea(a){a=a|0;var b=0,c=0,d=0;b=kb-32|0;kb=b;u[b+28>>1]=0;v[b+24>>2]=0;c=hc(b+8|0,b+24|0,6);nc(b+16|0,v[a>>2],v[a+8>>2],v[c>>2],v[c+4>>2]);a:{if(v[b+20>>2]!=6){break a}if(Sb(b+24|0,3856,6)){break a}$b(a,6);d=1}kb=b+32|0;return d|0}function Zv(a,b){var c=0,d=0,e=0,f=0;c=kb-16|0;kb=c;u[b>>1]=0;t[c+15|0]=0;Oh(a,c+15|0);d=w[c+15|0];e=d>>>1|0;f=d&1;d=0;while(1){u[b>>1]=e;if(d>>>0>=f>>>0){kb=c+16|0}else{t[c+15|0]=0;Oh(a,c+15|0);e=x[b>>1]|w[c+15|0]<<7;d=1;continue}break}}function Hf(a,b,c){var d=0;a:{if(y[b+8>>2]<c>>>0){v[23540]=0;X(1070,17416,9139,393,6384);a=v[23540];v[23540]=0;if((a|0)==1){break a}L()}d=v[b+4>>2];v[a>>2]=v[b>>2];v[a+4>>2]=d;v[a+8>>2]=v[b+8>>2];v[a+12>>2]=c;return}V(0)|0;O()|0;Vb();L()}function $ja(a,b){a=a|0;b=b|0;var c=0;b=kb-32|0;kb=b;c=-1;a:{if(!yB(a,b+16|0)){break a}c=0;if(!KU(b+16|0)){break a}if(!Sb(b+16|0,14187,4)){c=-1;if(!id(a,4)){break a}}c=-1;if(!Rj(a,b+8|0)){break a}c=!Sb(b+8|0,14163,4)}kb=b+32|0;return c|0}function gw(a,b,c,d,e,f){var g=0;g=kb-16|0;kb=g;v[g+12>>2]=e;v[g+8>>2]=d;d=Cg(g,g+8|0);e=v[d+4>>2];d=v[d>>2];v[23540]=0;a=Eg(f,a,b,c,d,e);b=v[23540];v[23540]=0;if((b|0)!=1){le(g+8|0);kb=g+16|0;return a}a=P()|0;O()|0;le(g+8|0);T(a|0);L()}function XY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=kb-16|0;kb=e;if(d>>>0<4294967280){a:{if(Cl(d)){ie(a,c);break a}f=nh(d)+1|0;d=vc(f);wd(a,d);ff(a,f);Hd(a,c);a=d}a=He(a,b,c);t[e+15|0]=0;we(a+c|0,e+15|0);kb=e+16|0;return}hf();L()}function DN(a,b){var c=0,d=0;a:{if(!(w[a+89|0]&16)){break a}c=v[a+656>>2];if(!c){break a}c=v[c>>2];b:{if(c){d=a;a=v[a+696>>2]-(c<<1)|0;a=(a|0)>0?a:0;v[d+696>>2]=a;a=(B(a,v[b>>2])|0)/65536|0;break b}if(v[a+696>>2]){break a}a=0}v[b>>2]=a}}function mi(a,b,c){var d=0,e=0,f=0,g=0;v[a+112>>2]=b;v[a+116>>2]=c;e=v[a+4>>2];d=v[a+44>>2]-e|0;v[a+120>>2]=d;v[a+124>>2]=d>>31;d=a;a=v[a+8>>2];f=a-e|0;g=f>>31;if(!(!(b|c)|((c|0)>=(g|0)&b>>>0>=f>>>0|(c|0)>(g|0)))){a=b+e|0}v[d+104>>2]=a}function gka(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=kb-16|0;kb=c;xv(c+8|0,b);d=v[c+12>>2];nc(c,v[a>>2],v[a+8>>2],v[c+8>>2],v[c+12>>2]);e=v[c+4>>2];if((e|0)==(d|0)){$b(a,v[c+12>>2])}kb=c+16|0;if((d|0)!=(e|0)){t[b+2|0]=0;t[b|0]=0;t[b+1|0]=0}}function dU(a){var b=0,c=0,d=0,e=0;b=w[a+3|0];c=Jka(b>>>0<3?48:64,0,Ib(w[a+196|0]|w[a+197|0]<<8),0);d=nb;e=c;c=Jka(Jka(Ib(w[a+198|0]|w[a+199|0]<<8),0,b>>>0<4?4:5,0),nb,Ib(w[a+200|0]|w[a+201|0]<<8),0);b=e+c|0;b=b+512|0;a=b;nb=0;return a}function VN(a,b){var c=0,d=0;a:{if(!(t[a+851|0]&1)){break a}c=v[a+104>>2];if(!c){break a}d=v[c>>2];if(!d){break a}v[a+76>>2]=d;v[a>>2]=0;v[a+4>>2]=d-1;c=v[a+88>>2];v[a+88>>2]=b?c|134:c&-135|128;if(!b){break a}v[a+84>>2]=d;v[a+80>>2]=0}}function O9(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=b;d=kb-16|0;kb=d;b=rf(a,c);me(d,v[a+36>>2]);a:{b:{if(!b){Sc(d,a+32|0,5);c=-1;if(!Cb(v[v[d>>2]>>2],v[d+4>>2])){break b}break a}c=v[b+16>>2]}xz(v[a+36>>2],e,c);f=b}Ye(a,f);kb=d+16|0}function Wha(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=kb-16|0;kb=c;while(1){a:{d=v[a>>2];if(uc(d,v[a+4>>2])>>>0>e>>>0){Pl(c,v[Eb(d,e)>>2]+40|0);d=pq(c,b);Ab(c);if(!d){break a}f=v[Eb(v[a>>2],e)>>2]}kb=c+16|0;return f|0}e=e+1|0;continue}}function QN(a,b,c){var d=0,e=0;d=kb-16|0;kb=d;e=c&15;if(e){t[b+824|0]=e}c=c&240;if(c){t[b+823|0]=c>>>4}v[b+88>>2]=v[b+88>>2]|131072;Db(d+8|0,a+1074312|0,80);if(!(!e|!Cb(v[v[d+8>>2]>>2],v[d+12>>2]))){t[b+824|0]=w[b+824|0]<<2}kb=d+16|0}function n9(a,b,c){a=a|0;b=b|0;c=c|0;a:{if(v[b+4>>2]!=8){break a}b=v[b>>2];if(Sb(b,9585,4)){break a}c=w[b+4|0]|w[b+5|0]<<8|(w[b+6|0]<<16|w[b+7|0]<<24);v[a+4260>>2]=w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24);v[a+4264>>2]=c;Ts(a)}}function Zi(a,b,c){c=v[c+4>>2]&176;if((c|0)==32){return b}a:{if((c|0)!=16){break a}b:{c:{c=w[a|0];switch(c-43|0){case 0:case 2:break c;default:break b}}return a+1|0}if((c|0)!=48|(b-a|0)<2|(w[a+1|0]|32)!=120){break a}a=a+2|0}return a}function OO(a,b){var c=0,d=0,e=0;v[a>>2]=0;v[a+4>>2]=0;Gc(a+8|0);if(b){GO(a,b);d=kb-16|0;kb=d;c=Dt(d,a,b);b=v[c+4>>2];e=v[c+8>>2];while(1){if((b|0)==(e|0)){lc(c);kb=d+16|0}else{nl(b,0,0);b=b+16|0;v[c+4>>2]=b;continue}break}}return a}function Cia(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=kb-16|0;kb=c;GA(c+8|0,b);d=v[c+12>>2];nc(c,v[a>>2],v[a+8>>2],v[c+8>>2],v[c+12>>2]);e=v[c+4>>2];if((e|0)==(d|0)){$b(a,v[c+12>>2])}kb=c+16|0;a=(d|0)==(e|0);if(!a){Ub(b,0,4896)}return a|0}function C8(a,b,c){a=a|0;b=b|0;c=c|0;a:{if(v[b+4>>2]!=8){break a}b=v[b>>2];if(Sb(b,9585,4)){break a}c=w[b+4|0]|w[b+5|0]<<8|(w[b+6|0]<<16|w[b+7|0]<<24);v[a+4228>>2]=w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24);v[a+4232>>2]=c;Os(a)}}function zea(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=kb-32|0;kb=d;e=Af(v[b>>2],v[b+4>>2]);c=ZP(d+8|0,c);v[23540]=0;X(727,a|0,b|0,e-1&65535,c|0);a=v[23540];v[23540]=0;if((a|0)!=1){We(c);kb=d+32|0;return}a=P()|0;O()|0;We(c);T(a|0);L()}function N0(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a:{if(!w[a+44|0]){c=(c|0)>0?c:0;while(1){if((c|0)==(d|0)){break a}if((ob[v[v[a>>2]+52>>2]](a,v[b>>2])|0)==-1){return d|0}else{b=b+4|0;d=d+1|0;continue}}}c=wk(b,4,c,v[a+32>>2])}return c|0}function xha(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=kb-16|0;kb=c;EA(c+8|0,b);d=v[c+12>>2];nc(c,v[a>>2],v[a+8>>2],v[c+8>>2],v[c+12>>2]);e=v[c+4>>2];if((e|0)==(d|0)){$b(a,v[c+12>>2])}kb=c+16|0;a=(d|0)==(e|0);if(!a){Ub(b,0,33)}return a|0}function Pz(a,b){var c=0,d=0,e=0,f=0;u[a+24>>1]=0;v[a+20>>2]=0;c=3546895/+(b>>>0);d=c*.25;a:{if(D(d)<2147483648){b=~~d;break a}b=-2147483648}v[a+16>>2]=b;v[a>>2]=0;v[a+4>>2]=0;e=a,f=sQ(c-+(b<<2)),v[e+8>>2]=f;v[a+12>>2]=nb;return a}function Ky(a,b,c){var d=0,e=0;d=Td(a);a:{if(d){e=jc(a);while(1){a=d;d=w[a+16|0];if(Tn(c,d)){e=a;d=v[a>>2];if(d){continue}break a}if(!Tn(d,c)){break a}e=a+4|0;d=v[a+4>>2];if(d){continue}break}break a}a=jc(a);e=a}v[b>>2]=a;return e}function BM(a){var b=0,c=0,d=0;c=kb-544|0;kb=c;a:{if(!(w[a+480210|0]&128)|!v[a+24668>>2]){break a}d=a+1298224|0;b=a+1074992|0;a=Pz(c,v[a+24620>>2]);while(1){if((b|0)==(d|0)){break a}sc(b+112|0,a,538);b=b+872|0;continue}}kb=c+544|0}function rW(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=kb-16|0;kb=c;av(c+8|0,b);d=v[c+12>>2];nc(c,v[a>>2],v[a+8>>2],v[c+8>>2],v[c+12>>2]);e=v[c+4>>2];if((e|0)==(d|0)){$b(a,v[c+12>>2])}kb=c+16|0;a=(d|0)==(e|0);if(!a){Ub(b,0,65)}return a|0}function dE(){var a=0,b=0,c=0;b=kb-16|0;kb=b;a=Kc(b,14999);a:{if(!Hb(a)){break a}c=1;if((Dg(a,14669)|0)!=-1){break a}if((Dg(a,16833)|0)!=-1){break a}if((Dg(a,13731)|0)!=-1){break a}c=(Dg(a,13774)|0)!=-1}zb(a);kb=b+16|0;return c|0}function Ofa(a,b){a=a|0;b=b|0;var c=0;b=kb-32|0;kb=b;c=-1;a:{if(!yB(a,b+16|0)){break a}c=0;if(!vR(b+16|0)){break a}c=-1;if(!Rj(a,b+8|0)){break a}c=0;if(!v[b+12>>2]){break a}a=v[b+8>>2];c=(a&2139062143)==(a|0)}kb=b+32|0;return c|0}function $D(a){var b=0;if(!(Sb(a,13330,8)|(w[a+8|0]|w[a+9|0]<<8)!=14|(!(w[a+12|0]|w[a+13|0]<<8)|(w[a+14|0]|w[a+15|0]<<8|(w[a+16|0]<<16|w[a+17|0]<<24))<=0))){b=(w[a+18|0]|w[a+19|0]<<8|(w[a+20|0]<<16|w[a+21|0]<<24))>>>0>23}return b}function z3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=v[b>>2];d=v[b+8>>2];e=v[b+4>>2];a=0;a:while(1){if((a|0)!=(e|0)){f=(a<<2)+c|0;b=0;while(1)if((b|0)==(d|0)){a=a+1|0;continue a}else{v[v[f>>2]+(b<<2)>>2]=0;b=b+1|0;continue}}break}}function jg(a,b){var c=0,d=0,e=0,f=0;d=x[a+22>>1];e=d+x[a+20>>1]|0;c=x[a+24>>1]<<17;while(1){if((d|0)==(e|0)){a=(c|0)/32768|0}else{f=c;c=((d&127)<<2)+a|0;c=f-B(v[Eb(b,x[c+28>>1])>>2],u[c+26>>1])|0;d=d+1|0;continue}break}return a}function ZR(a,b,c){var d=0,e=0,f=0,g=0;while(1){if((b|0)!=(c|0)){e=v[a+4>>2];f=e>>>8|0;d=v[a>>2];e=(e&255)<<24|d>>>8;d=(((d^w[b|0])&255)<<3)+21712|0;g=v[d>>2];d=v[d+4>>2]^f;v[a>>2]=e^g;v[a+4>>2]=d;b=b+1|0;continue}break}return a}function RV(a,b){a=a|0;b=b|0;var c=0,d=0;c=kb-16|0;kb=c;d=Qb(v[a>>2],v[a+8>>2],120);a:{if(!d){a=0;while(1){if((a|0)!=120){Eh(a+b|0);a=a+1|0;continue}break}break a}gc(c+8|0,b,120);ud(c,a,v[c+8>>2],v[c+12>>2])}kb=c+16|0;return d|0}function Lja(a,b){a=a|0;b=b|0;var c=0,d=0;c=kb-16|0;kb=c;d=Qb(v[a>>2],v[a+8>>2],64);a:{if(!d){a=0;while(1){if((a|0)!=32){Io((a<<1)+b|0);a=a+1|0;continue}break}break a}Fu(c+8|0,b);ud(c,a,v[c+8>>2],v[c+12>>2])}kb=c+16|0;return d|0}function wi(a){var b=0,c=0,d=0,e=0;e=Me(a);c=e&63;a:{if(!(e&64)){break a}b=6;while(1){d=Me(a);c=(d&127)<<b|c;if(!(d&128)){break a}d=b>>>0<25;b=b+7|0;if(d){continue}break}}a=e>>>7|0;b=a?-2147483648:c;return a?(c|0)>=0?0-c|0:b:b}function wga(a){a=a|0;var b=0,c=0,d=0;b=kb-32|0;kb=b;u[b+30>>1]=0;c=hc(b+8|0,b+30|0,2);nc(b+16|0,v[a>>2],v[a+8>>2],v[c>>2],v[c+4>>2]);a:{if(v[b+20>>2]!=2){break a}if(Sb(b+30|0,13639,2)){break a}$b(a,2);d=1}kb=b+32|0;return d|0}function pM(a,b,c){var d=0,e=0,f=0,g=0,h=0;g=c;h=c>>31;c=0;while(1){if((b|0)!=(c|0)){d=v[a>>2];e=v[a+4>>2];f=(d+e|0)/2|0;d=d-e|0;d=Hc(Kka(Jka(d,d>>31,g,h),nb,256,0),nb);v[a+4>>2]=f-d;v[a>>2]=d+f;c=c+1|0;a=a+8|0;continue}break}}function Pq(a){var b=0,c=0,d=0,e=0;c=kb-16|0;kb=c;b=kb-16|0;kb=b;Zq(b+8|0,c+15|0);d=v[b+12>>2];md(b,a,v[b+8>>2],v[b+12>>2]);e=v[b+4>>2];if((e|0)==(d|0)){id(a,v[b+12>>2])}kb=b+16|0;kb=c+16|0;return((d|0)==(e|0)?w[c+15|0]:0)&255}function DB(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;e=v[a>>2];f=yk(e,v[a+4>>2]);while(1){a:{c=d&65535;if(c>>>0>=f>>>0){break a}c=bg(e,c);if(!Pb(v[c>>2],v[c+4>>2])){break a}d=d+1|0;continue}break}return(ph(a,d&65535,b)?d:-1)&65535}function Xba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=kb-16|0;kb=c;SO(c+8|0,b);d=v[c+12>>2];nc(c,v[a>>2],v[a+8>>2],v[c+8>>2],v[c+12>>2]);e=v[c+4>>2];if((e|0)==(d|0)){$b(a,v[c+12>>2])}kb=c+16|0;a=(d|0)==(e|0);if(!a){pz(b)}return a|0}function Kka(a,b,c,d){var e=0,f=0,g=0,h=0;f=b^d;g=f>>31;e=b>>31;a=a^e;h=a-e|0;e=(b^e)-((a>>>0<e>>>0)+e|0)|0;a=d>>31;b=c^a;f=f>>31;a=Mka(h,e,b-a|0,(a^d)-((a>>>0>b>>>0)+a|0)|0)^f;b=a-f|0;nb=(g^nb)-((a>>>0<f>>>0)+g|0)|0;return b}function Hu(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;f=kb-16|0;kb=f;if(b){e=bd(a);d=Hb(a);g=d+b|0;if(e-d>>>0<b>>>0){rm(a,e,g-e|0,d,d,0,0)}e=d;d=Ac(a);BB(e+d|0,b,c);Sh(a,g);t[f+15|0]=0;we(d+g|0,f+15|0)}kb=f+16|0;return a|0}function $N(a,b,c){var d=0,e=0,f=0;d=kb-16|0;kb=d;a:{if(!c){break a}v[b+40>>2]=c;if(!c|v[a+480180>>2]!=256){break a}v[d+12>>2]=c>>>4;v[d+8>>2]=1;e=b,f=v[_c(d+12|0,d+8|0)>>2],v[e+40>>2]=f;e=b,f=Xz(c&255),v[e+44>>2]=f}kb=d+16|0}function ud(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=kb-16|0;kb=e;g=v[b+8>>2];f=v[b>>2];v[e+8>>2]=c;v[e+12>>2]=d;h=v[v[f>>2]+28>>2];v[e>>2]=c;v[e+4>>2]=d;ob[h|0](a,f,g,e);v[b+8>>2]=v[b+8>>2]+v[a+4>>2];kb=e+16|0}function Yu(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=kb-16|0;kb=c;nC(c+8|0,b);d=v[c+12>>2];nc(c,v[a>>2],v[a+8>>2],v[c+8>>2],v[c+12>>2]);e=v[c+4>>2];if((e|0)==(d|0)){$b(a,v[c+12>>2])}kb=c+16|0;a=(d|0)==(e|0);if(!a){mC(b)}return a|0}function Ut(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=kb-16|0;kb=c;wR(c+8|0,b);d=v[c+12>>2];nc(c,v[a>>2],v[a+8>>2],v[c+8>>2],v[c+12>>2]);e=v[c+4>>2];if((e|0)==(d|0)){$b(a,v[c+12>>2])}kb=c+16|0;a=(d|0)==(e|0);if(!a){xR(b)}return a|0}function EC(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=kb-16|0;kb=c;GC(c+8|0,b);d=v[c+12>>2];nc(c,v[a>>2],v[a+8>>2],v[c+8>>2],v[c+12>>2]);e=v[c+4>>2];if((e|0)==(d|0)){$b(a,v[c+12>>2])}kb=c+16|0;a=(d|0)==(e|0);if(!a){FC(b)}return a|0}function nA(a,b){var c=0,d=0,e=0,f=0;c=a<<8;d=c&16711680;c=e;e=a<<24|d;f=c;d=b<<24|a>>>8;c=b<<8|a>>>24;a=f|(((b&255)<<24|a>>>8)&-16777216|((b&16777215)<<8|a>>>24)&16711680|(b>>>8&65280|b>>>24));nb=e|(d&65280|c&255);return a}function Rd(a,b){var c=0,d=0,e=0,f=0,g=0;d=x[a+22>>1];g=d+x[a+20>>1]|0;c=d;while(1){a:{if((c|0)!=(g|0)){e=((c&127)<<2)+a|0;f=x[e+28>>1]+b|0;u[e+28>>1]=f;if((f&65535)>>>0<2048){break a}u[a+20>>1]=c-d}return}c=c+1|0;continue}}function $s(a,b){var c=0;a:{b:{c:{switch(b-2|0){default:c=43884;if((b|0)==16777216){break a}if((b|0)!=32){break b}c=43736;break a;case 2:c=43732;break a;case 1:break b;case 0:break c}}c=43728;break a}c=43724}v[a>>2]=v[c>>2]}function aq(a,b,c){var d=0,e=0,f=0,g=0,h=0;f=131072/(A[b-8>>3]-A[a>>3]);b=0;while(1){if((b|0)!=2048){d=-ve(f*A[bf(a,b)>>3]);a:{if(D(d)<2147483648){e=~~d;break a}e=-2147483648}g=Eb(c,b),h=e,v[g>>2]=h;b=b+1|0;continue}break}}function Hia(a,b){a=a|0;b=b|0;var c=0,d=0;c=kb-16|0;kb=c;v[a+480180>>2]=b;yq(c,zq(a));d=v[c+12>>2];b=a+1074320|0;v[b>>2]=v[c+8>>2];v[b+4>>2]=d;b=v[c+4>>2];v[a+1074312>>2]=v[c>>2];v[a+1074316>>2]=b;$s(a+8|0,zq(a));kb=c+16|0}function gga(a,b){a=a|0;b=b|0;var c=0,d=0;c=kb-16|0;kb=c;d=Qb(v[a>>2],v[a+8>>2],6);a:{if(!d){a=0;while(1){if((a|0)!=6){Eh(a+b|0);a=a+1|0;continue}break}break a}rB(c+8|0,b);ud(c,a,v[c+8>>2],v[c+12>>2])}kb=c+16|0;return d|0}function VA(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=wl(a);e=Ad(v[a+4>>2],w[a+11|0]);a:{if(d-e>>>0>=c>>>0){if(!c){break a}d=sd(a);He(d+e|0,b,c);b=c+e|0;vq(a,b);xd(b+d|0,0);return a|0}rq(a,d,(c+e|0)-d|0,e,e,0,c,b)}return a|0}function UN(a,b,c,d){var e=0;a=ed(Xn(a,x[c+70>>1],v[c+48>>2],b,0)-32768|0);a:{if(!d){break a}d=il(c)-v[c+16>>2]|0;if((d|0)<2){break a}e=a;a=u[(B(b,872)+c|0)+1390>>1];a=ed(((e-a|0)/(d|0)|0)+a|0)}u[(B(b,872)+c|0)+1390>>1]=a}function OE(a,b,c,d,e){var f=0;f=kb-32|0;kb=f;v[f+24>>2]=a;v[f+28>>2]=b;v[f+16>>2]=d;v[f+20>>2]=e;v[f+8>>2]=c;v[f+12>>2]=0;a=YB(f+24|0,f+8|0);b=f+16|0;a=Ar(v[b>>2],v[b+4>>2],v[a>>2],v[a+4>>2])?a:b;kb=f+32|0;return v[a>>2]}function FJ(a,b){var c=0,d=0,e=0;v[a>>2]=0;v[a+4>>2]=0;Gc(a+8|0);if(b){Ll(a,b);d=kb-16|0;kb=d;b=Ok(d,a,b);c=v[b+4>>2];e=v[b+8>>2];while(1){if((c|0)==(e|0)){lc(b);kb=d+16|0}else{c=c+1|0;v[b+4>>2]=c;continue}break}}return a}function Tt(a,b){var c=0,d=0,e=0;if(v[a>>2]){qV(a);c=v[a>>2];LB(a);Mb(c);d=Gb(a),e=0,v[d>>2]=e;v[a>>2]=0;v[a+4>>2]=0}v[a>>2]=v[b>>2];v[a+4>>2]=v[b+4>>2];c=Gb(b);d=Gb(a),e=v[c>>2],v[d>>2]=e;v[c>>2]=0;v[b>>2]=0;v[b+4>>2]=0}function xN(a,b){var c=0,d=0,e=0,f=0;v[a>>2]=v[b>>2];v[a+4>>2]=v[b+4>>2];v[a+8>>2]=v[b+8>>2];d=Gb(a);c=jc(a);a:{if(!v[d>>2]){v[a>>2]=c;break a}v[v[c>>2]+8>>2]=c;c=jc(b);v[b>>2]=c;v[c>>2]=0;e=Gb(b),f=0,v[e>>2]=f}return a}function ps(a){var b=0;a:{b=w[a+1376|0];b:{if(!b){b=-1;if(v[a+1384>>2]){break b}if(!ix(a)){break b}b=w[a+1376|0];if(!b){break a}}t[a+1376|0]=b-1;v[a+1400>>2]=v[a+1400>>2]+1;b=$e(a)}return b}aa(15747,13179,1578,5432);L()}function h_(a){a=a|0;if(w[468256]){return v[117063]}if(!w[469416]){a=469392;while(1){a=Nb(a)+12|0;if((a|0)!=469416){continue}break}t[469416]=1}qd(469392,89560);qd(469404,89572);t[468256]=1;v[117063]=469392;return 469392}function VZ(a){a=a|0;if(w[468248]){return v[117061]}if(!w[469384]){a=469360;while(1){a=Nb(a)+12|0;if((a|0)!=469384){continue}break}t[469384]=1}pd(469360,13881);pd(469372,13860);t[468248]=1;v[117061]=469360;return 469360}function VQ(a,b,c){var d=0;d=kb-16|0;kb=d;t[d+15|0]=a;a=0;if(!(c>>>0<25|b>>>0<25|(b>>>0>108|b>>>0>=c>>>0)|c>>>0>108)){t[d+14|0]=(x[(b<<1)+32686>>1]-x[(c<<1)+32686>>1]|0)/5;a=w[Yb(d+15|0,d+14|0)|0]}kb=d+16|0;return a&255}function ys(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;c=kb-16|0;kb=c;d=v[b>>2];b=uc(d,v[b+4>>2]);a=0;while(1){if((a|0)==(b|0)){kb=c+16|0}else{v[c+8>>2]=0;e=Gc(c+8|0);f=Eb(d,a),g=v[e>>2],v[f>>2]=g;a=a+1|0;continue}break}}function w8(a){a=a|0;var b=0;ob[v[v[a>>2]+132>>2]](a);Ix(a);v[a+4236>>2]=0;t[a+4202|0]=1;b=ob[v[v[a>>2]+196>>2]](a)|0;v[a+4328>>2]=0;v[a+4312>>2]=0;z[a+4240>>2]=b?C(.5):C(1);b=v[a+4256>>2];v[a+4324>>2]=b;v[a+4320>>2]=b}function pN(a,b,c,d){var e=0,f=0;e=v[(B(c,872)+b|0)+704>>2];a:{if(!(!(e&134218752)|(d|0)!=1)|e&67108864){break a}b=x[(B(c,872)+b|0)+1402>>1];b=(b?b-1|0:c)&65535;if(b>>>0>126){break a}f=w[((b<<5)+a|0)+480288|0]}return f}function fi(a,b,c){var d=0,e=0,f=0;d=kb-16|0;kb=d;gc(d+8|0,b,c);e=v[d+12>>2];nc(d,v[a>>2],v[a+8>>2],v[d+8>>2],v[d+12>>2]);f=v[d+4>>2];if((f|0)==(e|0)){$b(a,v[d+12>>2])}kb=d+16|0;a=(e|0)==(f|0);if(!a){Ub(b,0,c)}return a}function PS(a){t[a|0]=0;t[a+1|0]=0;t[a+2|0]=0;t[a+3|0]=0;t[a+4|0]=0;t[a+5|0]=0;t[a+6|0]=0;t[a+7|0]=0;t[a+16|0]=0;t[a+17|0]=0;t[a+8|0]=0;t[a+9|0]=0;t[a+10|0]=0;t[a+11|0]=0;t[a+12|0]=0;t[a+13|0]=0;t[a+14|0]=0;t[a+15|0]=0}function Kha(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=kb-16|0;kb=d;c=-1;a:{if(!Rj(a,d+8|0)){break a}e=v[d+12>>2];c=0;if(!(v[d+8>>2]==(Vm(9007)|0)&e>>>0>255&e>>>0<260)){break a}c=Ae(a,b,e>>>0<259?80:76,0)}kb=d+16|0;return c|0}function ey(a,b,c,d,e){var f=0,g=0,h=0;f=kb-16|0;kb=f;a:{if(!c){a=Kd(v[a>>2],b);A[a+8>>3]=e;A[a>>3]=d;break a}g=c>>>1|0;ey(a,b,g,d,e);h=Kd(v[a>>2],c);xi(f,d,e,A[h>>3],A[h+8>>3]);ey(a,b|c,g,A[f>>3],A[f+8>>3])}kb=f+16|0}function eq(a,b,c){var d=0;d=kb-16|0;kb=d;Db(d+8|0,c+1074312|0,102);a:{if(!Cb(v[v[d+8>>2]>>2],v[d+12>>2])){break a}c=x[a+692>>1]+1|0;u[a+784>>1]=c;if(!(t[a+89|0]&1)){break a}u[a+784>>1]=c|32768}v[a+692>>2]=b;kb=d+16|0}function _O(a,b){a:{if(w[a+76|0]==(b|0)){break a}t[a+76|0]=b;if(b){b=0;if(x[a+24>>1]==15){u[a+20>>1]=0;b=1}v[a+8>>2]=0;v[a+16>>2]=b;return}b:{switch(v[a+16>>2]+1|0){case 0:case 4:break a;default:break b}}v[a+16>>2]=3}}function zT(a){var b=0;a:{b:{if(Sb(a,13858,4)){if(Sb(a,16314,4)){break a}if((w[a+34|0]|w[a+35|0]<<8)>>>0<=255){break b}break a}if((w[a+34|0]|w[a+35|0]<<8)>>>0>255){break a}}b=(w[a+36|0]|w[a+37|0]<<8)>>>0<4e3}return b}function Jka(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0;e=c>>>16|0;f=a>>>16|0;j=B(e,f);g=c&65535;h=a&65535;i=B(g,h);f=(i>>>16|0)+B(f,g)|0;e=(f&65535)+B(e,h)|0;nb=(B(b,c)+j|0)+B(a,d)+(f>>>16)+(e>>>16)|0;return i&65535|e<<16}function xq(a,b,c){var d=0,e=0;e=x[a+480192>>1];a:{if(e){if(!$c(b)|c>>>0>e>>>0){break a}c=v[((c<<2)+a|0)+900380>>2];if(!c){break a}d=x[cc(c+236|0,b-1|0)>>1];break a}d=c}return(x[a+480190>>1]<(d&65535)>>>0?0:d)&65535}function gx(a){var b=0;a:{b:{while(1){if(v[a+1380>>2]!=-1){break b}b=0;if(!os(a)){break a}if(!(t[a+1375|0]&1)){continue}break}ec(a,32);return 0}v[a+1396>>2]=0;v[a+1400>>2]=0;v[a+1384>>2]=0;t[a+1376|0]=0;b=1}return b}function XH(a,b){var c=0,d=0,e=0;c=kb-256|0;kb=c;if((b|0)>=2){v[(b<<2)+a>>2]=c;sc(c,v[a>>2],4);while(1){e=(d<<2)+a|0;d=d+1|0;sc(v[e>>2],v[(d<<2)+a>>2],4);v[e>>2]=v[e>>2]+4;if((b|0)!=(d|0)){continue}break}}kb=c+256|0}function AL(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;pg(a+12|0,d);if(b){if(b>>>0>=2097152){Lg();L()}d=vc(b<<11)}else{d=0}v[a>>2]=d;c=d+(c<<11)|0;v[a+8>>2]=c;v[a+4>>2]=c;e=Cc(a),f=d+(b<<11)|0,v[e>>2]=f;return a|0}function xz(a,b,c){var d=0;a:{switch(c+1|0){case 0:case 3:cP(a,b);return;default:break a}}d=kb-32|0;kb=d;v[d+28>>2]=c;u[d+24>>1]=0;v[d+12>>2]=2;sw(d+16|0,a,d+24|0,v[Kb(d+28|0,d+12|0)>>2]);Kj(b,x[d+24>>1]);kb=d+32|0}function vu(a,b,c){var d=0,e=0,f=0;d=kb-16|0;kb=d;if(c>>>0<4294967280){a:{if(Cl(c)){ie(a,c);break a}e=nh(c)+1|0;f=vc(e);wd(a,f);ff(a,e);Hd(a,c);a=f}a=He(a,b,c);t[d+15|0]=0;we(a+c|0,d+15|0);kb=d+16|0;return}hf();L()}function HO(a,b){var c=0,d=0,e=0,f=0;e=A[a+48>>3];c=A[a+40>>3];A[a+48>>3]=c;f=A[a+64>>3];d=A[a+56>>3];A[a+64>>3]=d;A[a+40>>3]=b;b=e*A[a+16>>3]+(A[a>>3]*b+c*A[a+8>>3])-d*A[a+24>>3]-f*A[a+32>>3];A[a+56>>3]=b;return b}function zP(a){var b=0;b=u[a+784>>1];if(b){v[a+692>>2]=(b&32767)-1;if((b|0)<0){v[a+88>>2]=v[a+88>>2]|256}u[a+784>>1]=0}b=w[a+795|0];if(b){t[a+795|0]=0;t[a+838|0]=b-1}b=w[a+796|0];if(b){t[a+796|0]=0;t[a+837|0]=b-1}}function qm(a,b){var c=C(0),d=0,e=0;c=C(1);d=u[a+28>>1];a:{if((d|0)>(b|0)){break a}e=v[a+4>>2];if((uc(e,v[a+8>>2])+d<<16)-65536>>16<(b|0)){break a}c=z[Eb(e,b-d|0)>>2];c=c<=C(1.0000000036274937e-15)?C(1):c}return c}function a$(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=vn(a);e=Hb(a);a:{if(d-e>>>0>=c>>>0){if(!c){break a}d=Ac(a);ni(d+(e<<2)|0,b,c);b=c+e|0;Sh(a,b);wd(d+(b<<2)|0,0);return a|0}AF(a,d,(c+e|0)-d|0,e,e,0,c,b)}return a|0}function Vp(a,b){a=sc(a,b,88);v[a+88>>2]=v[b+88>>2];sc(a+92|0,b+92|0,576);v[a+668>>2]=v[b+668>>2];sc(a+672|0,b+672|0,52);Oy(a+724|0,b+724|0);Oy(a+732|0,b+732|0);Oy(a+740|0,b+740|0);sc(a+748|0,b+748|0,123);return a}function Gn(a,b){var c=0,d=0,e=0;c=a*a;d=c*a;e=c*c;a=d*e*(e*(c*.009465647849436732+.002974357433599673)+(c*.024528318116654728+.05338123784456704))+(d*(c*.13339200271297674+.3333313950307914)+a);return C(b?-1/a:a)}function cia(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=kb-16|0;kb=e;c=rf(a,c);me(e,v[a+36>>2]);a:{if(!c){Sc(e,a+32|0,5);f=0;if(Cb(v[v[e>>2]>>2],v[e+4>>2])){break a}}rT(v[a+36>>2],b,d,0);f=c}Ye(a,f);kb=e+16|0}function hT(a,b,c){var d=0,e=0;d=kb-16|0;kb=d;v[d>>2]=v[a+8>>2];e=v[a+8>>2];v[d+8>>2]=a+8;v[d+4>>2]=B(b,6)+e;b=v[d>>2];while(1){if(v[d+4>>2]!=(b|0)){iu(b,c);b=v[d>>2]+6|0;v[d>>2]=b;continue}break}Ud(d);kb=d+16|0}function Sba(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=Tb(a);d=Yf(a+12|0);t[a+32|0]=c;v[a+28>>2]=0;v[a+24>>2]=b;v[23540]=0;R(765,a|0,1);b=v[23540];v[23540]=0;if((b|0)!=1){return a|0}b=P()|0;O()|0;BO(d);FO(a);T(b|0);L()}function oP(a,b,c,d){var e=0;e=kb-16|0;kb=e;a=ai(e,a,d);d=kb-16|0;kb=d;v[d+8>>2]=b;while(1){if(Pb(b,c)){Mi(v[a+4>>2],x[b>>1]);b=Se(d+8|0);v[a+4>>2]=v[a+4>>2]+2;b=v[b>>2];continue}break}kb=d+16|0;lc(a);kb=e+16|0}function mB(a,b){var c=0,d=0,e=0;c=kb-16|0;kb=c;nU(c+8|0,b);d=v[c+12>>2];nc(c,v[a>>2],v[a+8>>2],v[c+8>>2],v[c+12>>2]);e=v[c+4>>2];if((e|0)==(d|0)){$b(a,v[c+12>>2])}kb=c+16|0;a=(d|0)==(e|0);if(!a){oU(b)}return a}function WC(a,b){var c=0,d=0;c=kb-16|0;kb=c;a:{if(b>>>0<2){b:{if(!b){break b}if(!Qb(v[a>>2],v[a+8>>2],1)){break b}t[c+15|0]=0;zg(a,c+15|0);d=t[c+15|0]}kb=c+16|0;a=d;break a}aa(11212,9108,136,14225);L()}return a}function Gaa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=kb-32|0;kb=c;a:{if(Wh(a)>>>0<b>>>0){if(th(1073741823)>>>0<b>>>0){break a}d=Gb(a);e=a;a=Vf(c+8|0,b,uc(v[a>>2],v[a+4>>2]),d);Fd(e,a);Uf(a)}kb=c+32|0;return}cd();L()}function GS(a,b){var c=0,d=0,e=0;c=kb-16|0;kb=c;IS(c+8|0,b);d=v[c+12>>2];nc(c,v[a>>2],v[a+8>>2],v[c+8>>2],v[c+12>>2]);e=v[c+4>>2];if((e|0)==(d|0)){$b(a,v[c+12>>2])}kb=c+16|0;a=(d|0)==(e|0);if(!a){HS(b)}return a}function Dk(a){xc(a+16|0,v[a>>2]);xc(a+8|0,v[a>>2]);if(y[a+12>>2]>=y[a+16>>2]){v[a+12>>2]=0;v[a+16>>2]=0;u[a+34>>1]=x[a+34>>1]&65511}if(y[a+4>>2]>=y[a+8>>2]){v[a+4>>2]=0;v[a+8>>2]=0;u[a+34>>1]=x[a+34>>1]&65529}}function zaa(a,b){a=a|0;b=b|0;var c=0;b=kb-16|0;kb=b;c=-1;a:{if(!Rj(a,b+8|0)){break a}c=0;if(!eM(v[b+8>>2],v[b+12>>2])){break a}a=XQ(a,b);if(!a){Pm(b)}c=-1;if(!a){break a}c=dM(v[b>>2])}a=c;kb=b+16|0;return a|0}function qy(a,b){var c=0,d=0;c=v[b+4>>2];v[a+24648>>2]=v[b>>2];v[a+24652>>2]=c;d=v[b+20>>2];c=a+24664|0;v[c>>2]=v[b+16>>2];v[c+4>>2]=d;d=v[b+12>>2];c=a+24656|0;v[c>>2]=v[b+8>>2];v[c+4>>2]=d;vM(a+24648|0);BM(a)}function mH(a,b){a=a|0;b=b|0;var c=0,d=0;c=v[a>>2];a:{if(!c){break a}d=v[c+24>>2];b:{if((d|0)==v[c+28>>2]){b=ob[v[v[c>>2]+52>>2]](c,b)|0;break b}v[c+24>>2]=d+4;v[d>>2]=b}if(!En(b)){break a}v[a>>2]=0}return a|0}function efa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=kb-32|0;kb=c;a:{if(Xj(a)>>>0<b>>>0){if(th(357913941)>>>0<b>>>0){break a}d=Gb(a);e=a;a=Ik(c+8|0,b,yd(v[a>>2],v[a+4>>2]),d);HQ(e,a);GQ(a)}kb=c+32|0;return}cd();L()}function Tba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;v[a>>2]=0;v[a+4>>2]=0;Gc(a+8|0);c=Ug(v[b>>2],v[b+4>>2]);if(c){nz(a,c);d=kb-16|0;kb=d;e=v[b>>2];f=v[b+4>>2];b=lr(d,a,c);ju(e,f,b+4|0);lc(b);kb=d+16|0}return a|0}function R9(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=kb-16|0;kb=e;c=rf(a,c);me(e,v[a+36>>2]);a:{if(!c){Sc(e,a+32|0,5);f=0;if(Cb(v[v[e>>2]>>2],v[e+4>>2])){break a}}HL(d,v[a+36>>2],b);f=c}Ye(a,f);kb=e+16|0}function Qba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=kb-32|0;kb=c;a:{if(jn(a)>>>0<b>>>0){if(th(536870911)>>>0<b>>>0){break a}d=Gb(a);e=a;a=nr(c+8|0,b,Ug(v[a>>2],v[a+4>>2]),d);Fd(e,a);mr(a)}kb=c+32|0;return}cd();L()}function Jba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=kb-32|0;kb=c;a:{if(fz(a)>>>0<b>>>0){if(th(613566756)>>>0<b>>>0){break a}d=Gb(a);e=a;a=mO(c+8|0,b,ez(v[a>>2],v[a+4>>2]),d);lO(e,a);kO(a)}kb=c+32|0;return}cd();L()}function Iaa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=kb-32|0;kb=c;a:{if(Xj(a)>>>0<b>>>0){if(th(357913941)>>>0<b>>>0){break a}d=Gb(a);e=a;a=Ik(c+8|0,b,yd(v[a>>2],v[a+4>>2]),d);zr(e,a);gO(a)}kb=c+32|0;return}cd();L()}function CS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=kb-32|0;kb=c;a:{if(Zm(a)>>>0<b>>>0){if(th(2147483647)>>>0<b>>>0){break a}d=Gb(a);e=a;a=Nj(c+8|0,b,Rc(v[a>>2],v[a+4>>2]),d);Fd(e,a);Ni(a)}kb=c+32|0;return}cd();L()}function zr(a,b){var c=0,d=0,e=0;e=v[a>>2];c=v[a+4>>2];d=b+4|0;while(1){if((c|0)!=(e|0)){c=c-12|0;cp(v[d>>2]-12|0,c);v[d>>2]=v[d>>2]-12;continue}break}qc(a,d);qc(a+4|0,b+8|0);qc(Gb(a),Cc(b));v[b>>2]=v[b+4>>2]}function zD(a,b){var c=0,d=0,e=0;e=v[a>>2];c=v[a+4>>2];d=b+4|0;while(1){if((c|0)!=(e|0)){c=c-36|0;zv(v[d>>2]-36|0,c);v[d>>2]=v[d>>2]-36;continue}break}qc(a,d);qc(a+4|0,b+8|0);qc(Gb(a),Cc(b));v[b>>2]=v[b+4>>2]}function nB(a,b){var c=0,d=0,e=0;e=v[a>>2];c=v[a+4>>2];d=b+4|0;while(1){if((c|0)!=(e|0)){c=c-20|0;qB(v[d>>2]-20|0,c);v[d>>2]=v[d>>2]-20;continue}break}qc(a,d);qc(a+4|0,b+8|0);qc(Gb(a),Cc(b));v[b>>2]=v[b+4>>2]}function lw(a,b,c){var d=0;d=v[a+16>>2];if(!d){v[a+36>>2]=1;v[a+24>>2]=c;v[a+16>>2]=b;return}a:{if((b|0)==(d|0)){if(v[a+24>>2]!=2){break a}v[a+24>>2]=c;return}t[a+54|0]=1;v[a+24>>2]=2;v[a+36>>2]=v[a+36>>2]+1}}function kn(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=kb-16|0;kb=d;a:{if(c){Kc(d,c);break a}Nb(d)}v[23540]=0;U(11,a|0,b|0,d|0);a=v[23540];v[23540]=0;if((a|0)!=1){zb(d);kb=d+16|0;return}a=P()|0;O()|0;zb(d);T(a|0);L()}function eP(a,b){var c=0,d=0,e=0;e=v[a>>2];c=v[a+4>>2];d=b+4|0;while(1){if((c|0)!=(e|0)){c=c-32|0;zz(v[d>>2]-32|0,c);v[d>>2]=v[d>>2]-32;continue}break}qc(a,d);qc(a+4|0,b+8|0);qc(Gb(a),Cc(b));v[b>>2]=v[b+4>>2]}function b9(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=kb-16|0;kb=c;a=jj(a);if(a){d=v[b+4>>2];b=v[b>>2];v[c+8>>2]=b;v[c+12>>2]=d;e=v[v[a>>2]+72>>2];v[c>>2]=b;v[c+4>>2]=d;a=ob[e|0](a,c)|0}else{a=1}kb=c+16|0;return a|0}function sy(a,b){var c=0;c=v[b+24>>2];v[a+24628>>2]=c?c>>>0<512?c:512:1;a:{if(!(v[b+16>>2]!=v[a+24620>>2]|v[b+20>>2]!=v[a+24624>>2])){c=0;if(v[b+12>>2]==v[a+24616>>2]){break a}}c=1}sc(a+24604|0,b,40);wM(a,c)}function sQ(a){a=a*4294967296;if(D(a)<0x8000000000000000){nb=D(a)>=1?~~(a>0?F(H(a*2.3283064365386963e-10),4294967295):I((a-+(~~a>>>0>>>0))*2.3283064365386963e-10))>>>0:0;return~~a>>>0}nb=-2147483648;return 0}function jA(a,b){var c=0,d=0,e=0,f=0;d=b?224:240;e=PD(a);a:while(1){if((a|0)!=(e|0)){f=vd(a);b=a;while(1)if((b|0)==(f|0)){a=a+16|0;continue a}else{c=((w[Lb(b,0)|0]&d)!=0)+c|0;b=b+4|0;continue}}break}return c}function _aa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;b=(b-a|0)/160|0;while(1){if((b|0)>0){b=b-1|0;v[a>>2]=v[c>>2];d=a+4|0;if((d|0)!=(c+4|0)){uy(d,v[c+4>>2],v[c+8>>2])}sc(a+16|0,c+16|0,144);a=a+160|0;continue}break}}function MW(a,b){a=a|0;b=b|0;var c=0,d=0;c=kb-48|0;kb=c;d=-1;a:{if(!oD(a,c+8|0)){break a}d=0;if(!nD(c+8|0)){break a}if(b){a=v[b>>2];if(!v[b+4>>2]&a>>>0<bc(v[c+12>>2])-8>>>0){break a}}d=1}kb=c+48|0;return d|0}function lN(a,b){var c=0;c=v[b+4>>2];v[a>>2]=v[b>>2];v[a+4>>2]=c;c=v[b+28>>2];v[a+24>>2]=v[b+24>>2];v[a+28>>2]=c;c=v[b+20>>2];v[a+16>>2]=v[b+16>>2];v[a+20>>2]=c;c=v[b+12>>2];v[a+8>>2]=v[b+8>>2];v[a+12>>2]=c}function Zs(a){var b=0;v[23540]=0;a=S(812,a|0)|0;b=v[23540];v[23540]=0;a:{if((b|0)==1){a=V(0)|0;O()|0;_(a|0)|0;v[23540]=0;Z(18);b=v[23540];v[23540]=0;a=0;if((b|0)==1){break a}}return a}V(0)|0;O()|0;Vb();L()}function Ru(a){t[a|0]=0;t[a+1|0]=0;t[a+2|0]=0;t[a+3|0]=0;t[a+4|0]=0;t[a+5|0]=0;t[a+6|0]=0;t[a+7|0]=0;t[a+16|0]=0;t[a+8|0]=0;t[a+9|0]=0;t[a+10|0]=0;t[a+11|0]=0;t[a+12|0]=0;t[a+13|0]=0;t[a+14|0]=0;t[a+15|0]=0}function Dd(a,b){var c=0,d=0;c=kb-16|0;kb=c;a:{if(b>>>0<2){b:{if(!b){break b}if(!Qb(v[a>>2],v[a+8>>2],1)){break b}t[c+15|0]=0;zg(a,c+15|0);d=w[c+15|0]}kb=c+16|0;break a}aa(11212,9108,136,14225);L()}return d}function x1(a,b){a=a|0;b=b|0;var c=0;a=Es(a);v[a>>2]=77504;c=Nb(a+32|0);v[a+44>>2]=0;v[a+48>>2]=8;v[23540]=0;R(92,a|0,b|0);b=v[23540];v[23540]=0;if((b|0)!=1){return a|0}b=P()|0;O()|0;zb(c);Mn(a);T(b|0);L()}function gi(a,b,c){var d=0,e=0,f=0;d=kb-16|0;kb=d;gc(d+8|0,b,c);e=v[d+12>>2];nc(d,v[a>>2],v[a+8>>2],v[d+8>>2],v[d+12>>2]);f=v[d+4>>2];if((f|0)==(e|0)){$b(a,v[d+12>>2])}kb=d+16|0;if((e|0)!=(f|0)){Ub(b,0,c)}}function wz(a){var b=0,c=0,d=0;b=x[a+20>>1];u[a+28>>1]=x[a+22>>1]<<1|(w[v[a+16>>2]+3842|0]?b>>>9|0:b>>>8&1);b=0;while(1){if((b|0)!=4){c=(b<<2)+a|0;d=v[c>>2];if(d){fo(d);$O(v[c>>2])}b=b+1|0;continue}break}}function lka(a,b){a=a|0;b=b|0;var c=0;c=kb-16|0;kb=c;a:{if(!Qb(v[a>>2],v[a+8>>2],64)){a=0;while(1){if((a|0)!=64){Eh(a+b|0);a=a+1|0;continue}break}break a}Fu(c+8|0,b);ud(c,a,v[c+8>>2],v[c+12>>2])}kb=c+16|0}function cea(a){a=a|0;var b=0;b=kb-16|0;kb=b;a:{if(Aq(a,10284)){NJ(b,17607,a);a=Mc(b);v[23540]=0;R(41,44,a|0);a=v[23540];v[23540]=0;if((a|0)!=1){break a}a=P()|0;O()|0;zb(b);T(a|0);L()}kb=b+16|0;return}L()}function _k(a){a=a|0;var b=0;v[a>>2]=78700;v[23540]=0;R(70,a|0,0);b=v[23540];v[23540]=0;if((b|0)!=1){ac(a+28|0);Mb(v[a+32>>2]);Mb(v[a+36>>2]);Mb(v[a+48>>2]);Mb(v[a+60>>2]);return a|0}V(0)|0;O()|0;Vb();L()}function _ea(a,b){a=a|0;b=b|0;var c=0,d=0;c=kb-16|0;kb=c;Am(a,b);b=Fb(v[a>>2]);v[c+8>>2]=b;a=Fb(v[a+4>>2]);while(1){if(Pb(b,a)){d=w[b|0]+(d&255)|0;t[b|0]=d;b=v[Ke(c+8|0)>>2];continue}else{kb=c+16|0}break}}function Wba(a,b){a=a|0;b=b|0;var c=0;c=kb-16|0;kb=c;a:{if(!Qb(v[a>>2],v[a+8>>2],27)){a=0;while(1){if((a|0)!=27){Eh(a+b|0);a=a+1|0;continue}break}break a}SO(c+8|0,b);ud(c,a,v[c+8>>2],v[c+12>>2])}kb=c+16|0}function R3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=kb-16|0;kb=d;WJ(d,c);a=v[a+1298464>>2];v[23540]=0;U(376,a|0,b|0,d|0);a=v[23540];v[23540]=0;if((a|0)!=1){Ab(d);kb=d+16|0;return}a=P()|0;O()|0;Ab(d);T(a|0);L()}function NR(a,b){a=a|0;b=b|0;var c=0;c=kb-16|0;kb=c;a:{if(!Qb(v[a>>2],v[a+8>>2],32)){a=0;while(1){if((a|0)!=32){Eh(a+b|0);a=a+1|0;continue}break}break a}LR(c+8|0,b);ud(c,a,v[c+8>>2],v[c+12>>2])}kb=c+16|0}function Gf(a,b,c,d,e){var f=0;f=kb-256|0;kb=f;if(!(e&73728|(c|0)<=(d|0))){d=c-d|0;c=d>>>0<256;Ub(f,b&255,c?d:256);if(!c){while(1){tf(a,f,256);d=d-256|0;if(d>>>0>255){continue}break}}tf(a,f,d)}kb=f+256|0}function wea(a,b){a=a|0;b=b|0;var c=0,d=0;c=kb-16|0;kb=c;if((b|0)>=0){d=2147483647;a=Bt(a);if(a>>>0<=1073741822){v[c+12>>2]=a<<1;v[c+8>>2]=b+31&-32;d=v[_c(c+12|0,c+8|0)>>2]}kb=c+16|0;return d|0}cd();L()}function iU(a){var b=0;a:{if(Sb(a,3873,4)|w[a+68|0]!=13|(w[a+69|0]!=10|w[a+70|0]!=26)){break a}if(Sb(a+71|0,13719,4)|w[a+75|0]!=1|w[a+76|0]){break a}b=((w[a+116|0]|w[a+117|0]<<8)-1&65535)>>>0<9}return b}function fe(a,b){var c=0,d=0,e=0;b=b+7&-8;v[a+8>>2]=b+v[a+8>>2];d=v[a+80>>2];a:{if(d){c=b;b=v[a+88>>2];e=c+b|0;c=0;if((e|0)>v[a+92>>2]){break a}v[a+88>>2]=e;return b+d|0}if(!b){return 0}c=Pd(b)}return c}function caa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=kb-16|0;kb=d;c=rf(a,c);me(d,v[a+36>>2]);a:{if(!c){Sc(d,a+32|0,5);e=0;if(Cb(v[v[d>>2]>>2],v[d+4>>2])){break a}}uT(v[a+36>>2],b,a);e=c}Ye(a,e);kb=d+16|0}function MS(a,b){a=a|0;b=b|0;var c=0,d=0;c=kb-16|0;kb=c;rB(c+8|0,b);b=v[c+12>>2];nc(c,v[a>>2],v[a+8>>2],v[c+8>>2],v[c+12>>2]);d=v[c+4>>2];if((b|0)==(d|0)){$b(a,v[c+12>>2])}kb=c+16|0;return(b|0)==(d|0)|0}function Jh(a,b){a=a|0;b=b|0;var c=0,d=0;c=kb-16|0;kb=c;cn(c+8|0,b);b=v[c+12>>2];nc(c,v[a>>2],v[a+8>>2],v[c+8>>2],v[c+12>>2]);d=v[c+4>>2];if((b|0)==(d|0)){$b(a,v[c+12>>2])}kb=c+16|0;return(b|0)==(d|0)|0}function G7(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;f=kb-16|0;kb=f;b=Hc(Kka(Jka(d,d>>31,b,0),nb,1e3,0),nb);v[a+16>>2]=0;v[a+12>>2]=b+c;LK(a,e);b=v[a+12>>2];v[f+12>>2]=0;LL(a,b,f+12|0);kb=f+16|0}function $6(a,b){a=a|0;b=b|0;var c=0,d=0;a:{c=v[b+52>>2];if(c&16){d=v[b+48>>2];c=v[b+28>>2];if(d>>>0<c>>>0){v[b+48>>2]=c;d=c}Vh(a,v[b+24>>2],d);break a}if(c&8){Vh(a,v[b+12>>2],v[b+20>>2]);break a}Nb(a)}}function xV(a,b){a=a|0;b=b|0;var c=0;c=kb-16|0;kb=c;a:{if(!Qb(v[a>>2],v[a+8>>2],8)){a=0;while(1){if((a|0)!=8){Eh(a+b|0);a=a+1|0;continue}break}break a}cn(c+8|0,b);ud(c,a,v[c+8>>2],v[c+12>>2])}kb=c+16|0}function tn(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=kb-32|0;kb=c;a:{if(mp(a)>>>0<b>>>0){if(th(-1)>>>0<b>>>0){break a}d=Gb(a);e=a;a=Xl(c+8|0,b,fd(v[a>>2],v[a+4>>2]),d);Fd(e,a);Wl(a)}kb=c+32|0;return}cd();L()}function iG(a,b,c,d,e,f){var g=0,h=0,i=0;g=kb-16|0;kb=g;t[g+15|0]=0;t[g+14|0]=f;t[g+13|0]=e;t[g+12|0]=37;if(f){Dh(g+13|0,g+14|0)}h=c,i=(db(b|0,fd(b,v[c>>2])|0,g+12|0,d|0,a|0)|0)+b|0,v[h>>2]=i;kb=g+16|0}function ch(a){var b=0,c=0,d=0,e=0;b=kb-16|0;kb=b;c=2;if(a>>>0>=2){v[b+12>>2]=a>>>1;v[b+8>>2]=a^-1;d=b,e=v[Kb(b+12|0,b+8|0)>>2]+a|0,v[d+12>>2]=e;v[b+8>>2]=-1;c=v[Kb(b+12|0,b+8|0)>>2]}kb=b+16|0;return c}function $ga(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;v[a>>2]=0;v[a+4>>2]=0;Gc(a+8|0);if(b){if(th(1073741823)>>>0<b>>>0){cd();L()}c=_C(b);v[a>>2]=c;v[a+4>>2]=c;d=Gb(a),e=(b<<2)+c|0,v[d>>2]=e;FA(a,b)}return a|0}function pW(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;v[a>>2]=0;v[a+4>>2]=0;Gc(a+8|0);if(b){if(th(214748364)>>>0<b>>>0){cd();L()}c=wC(b);v[a>>2]=c;v[a+4>>2]=c;d=Gb(a),e=B(b,20)+c|0,v[d>>2]=e;zC(a,b)}return a|0}function eY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=kb-16|0;kb=d;f=v[v[b>>2]+20>>2];e=v[c+12>>2];v[d+8>>2]=v[c+8>>2];v[d+12>>2]=e;e=v[c+4>>2];v[d>>2]=v[c>>2];v[d+4>>2]=e;ob[f|0](a,b,d,8);kb=d+16|0}function dh(a,b){var c=0,d=0,e=0;c=Hb(a);a:{if((c|0)!=(Hb(b)|0)){break a}d=Mc(a);b=Mc(b);if(!ef(a)){while(1){e=!c;if(!c|w[d|0]!=w[b|0]){break a}b=b+1|0;d=d+1|0;c=c-1|0;continue}}e=!Op(d,b,c)}return e}function OR(a,b){a=a|0;b=b|0;var c=0,d=0;d=v[a>>2];c=65535;a:{if(!xe(d,v[a+4>>2],b)){break a}d=DB(a,v[bg(d,b)+12>>2]);c=65535;if((d|0)==65535){break a}c=v[a>>2];a=bg(c,b);XL(bg(c,d),a);c=d}return c|0}function yK(a){var b=0,c=0,d=C(0);if(!a){return C(1)}if((a|0)>=-99999){b=+(a|0)*3.321928094887362/2e3;c=b+.5;a:{if(D(c)<2147483648){a=~~c;break a}a=-2147483648}d=C(oi(b-+(a|0)))}else{d=C(0)}return d}function dR(a){var b=0,c=0,d=0;d=w[a+32|0]|w[a+33|0]<<8;b=w[a+34|0]|w[a+35|0]<<8;a=b+(w[a+36|0]|w[a+37|0]<<8)|0;c=a>>>0<b>>>0?1:c;b=a;a=c<<1|a>>>31;b=b<<1;c=d+b|0;a=c>>>0<b>>>0?a+1|0:a;nb=a;return c}function UX(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=kb-16|0;kb=e;v[e+12>>2]=d;d=Ad(v[b+4>>2],w[b+11|0]);if(d>>>0<c>>>0){sk();L()}b=sd(b);v[e+8>>2]=d-c;RD(a,b+c|0,v[Kb(e+12|0,e+8|0)>>2]);kb=e+16|0}function TB(a,b){var c=0;c=kb-16|0;kb=c;a:{if(!Qb(v[a>>2],v[a+8>>2],512)){a=0;while(1){if((a|0)!=128){Pm((a<<2)+b|0);a=a+1|0;continue}break}break a}Ku(c+8|0,b);ud(c,a,v[c+8>>2],v[c+12>>2])}kb=c+16|0}function RP(a){var b=0,c=0,d=0;d=w[a+64|0]|w[a+65|0]<<8;b=w[a+70|0]|w[a+71|0]<<8;a=b+(w[a+72|0]|w[a+73|0]<<8)|0;c=a>>>0<b>>>0?1:c;b=a;a=c<<2|a>>>30;b=b<<2;c=d+b|0;a=c>>>0<b>>>0?a+1|0:a;nb=a;return c}function N8(a){a=a|0;var b=0,c=0,d=0;b=kb-32|0;kb=b;a:{if(Wh(a)>>>0<=12){if(th(1073741823)>>>0<=12){break a}c=Gb(a);d=a;a=Vf(b+8|0,13,uc(v[a>>2],v[a+4>>2]),c);Fd(d,a);Uf(a)}kb=b+32|0;return}cd();L()}function dv(a,b){var c=0;c=kb-16|0;kb=c;a:{if(!Qb(v[a>>2],v[a+8>>2],256)){a=0;while(1){if((a|0)!=256){Eh(a+b|0);a=a+1|0;continue}break}break a}gc(c+8|0,b,256);ud(c,a,v[c+8>>2],v[c+12>>2])}kb=c+16|0}function aS(a,b){var c=0,d=0,e=0;c=kb-16|0;kb=c;gS(c+8|0,b);d=v[c+12>>2];nc(c,v[a>>2],v[a+8>>2],v[c+8>>2],v[c+12>>2]);e=v[c+4>>2];if((e|0)==(d|0)){$b(a,v[c+12>>2])}kb=c+16|0;if((d|0)!=(e|0)){hS(b)}}function mU(a){var b=0,c=0,d=0;a:{if(Sb(a,21677,11)){break a}c=a+215|0;a=a+63|0;while(1){b=(a|0)==(c|0);if(b|w[a+16|0]>3|w[a+17|0]>3){break a}d=a;a=a+19|0;if(w[d+18|0]<16){continue}break}}return b}function UJ(){var a=0,b=0,c=0,d=0;a=kb-16|0;kb=a;b=vc(1298472);v[23540]=0;c=S(1058,b|0)|0;d=v[23540];v[23540]=0;if((d|0)!=1){b=v[Lf(a+8|0,c)>>2];kb=a+16|0;return b|0}a=P()|0;O()|0;Mb(b);T(a|0);L()}function Sd(a,b){var c=0,d=0,e=0;d=x[a+24>>1];if((d|0)!=(b&65535)){c=x[a+22>>1]-1&127;u[a+22>>1]=c;e=x[a+20>>1];if(e>>>0<=127){u[a+20>>1]=e+1}c=(c<<2)+a|0;u[c+26>>1]=b-d;u[c+28>>1]=0;u[a+24>>1]=b}}function IO(a,b,c,d,e,f){v[a+40>>2]=0;v[a+44>>2]=0;A[a+32>>3]=f;A[a+24>>3]=e;A[a+16>>3]=d;A[a+8>>3]=c;A[a>>3]=b;v[a+48>>2]=0;v[a+52>>2]=0;v[a+56>>2]=0;v[a+60>>2]=0;a=a- -64|0;v[a>>2]=0;v[a+4>>2]=0}function gj(a){var b=0;b=32767;a:{if(a>=C(32766.5)){break a}b=32768;if(a<=C(-32767.5)){break a}a=C(a+C(.5));b:{if(C(D(a))<C(2147483648)){b=~~a;break b}b=-2147483648}b=b+(b>>15)|0}return b<<16>>16}function Er(a,b,c,d){var e=0,f=0,g=0;e=b+4|0;g=c;f=v[a>>2];c=v[a+4>>2]-f|0;d=v[e>>2]+B(g,(c|0)/(d|0)|0)|0;v[e>>2]=d;if((c|0)>0){sc(d,f,c)}qc(a,e);qc(a+4|0,b+8|0);qc(Gb(a),Cc(b));v[b>>2]=v[b+4>>2]}function yB(a,b){var c=0,d=0,e=0;c=kb-16|0;kb=c;Fq(c+8|0,b);d=v[c+12>>2];md(c,a,v[c+8>>2],v[c+12>>2]);e=v[c+4>>2];if((e|0)==(d|0)){id(a,v[c+12>>2])}kb=c+16|0;a=(d|0)==(e|0);if(!a){JU(b)}return a}function oD(a,b){var c=0,d=0,e=0;c=kb-16|0;kb=c;gr(c+8|0,b);d=v[c+12>>2];md(c,a,v[c+8>>2],v[c+12>>2]);e=v[c+4>>2];if((e|0)==(d|0)){id(a,v[c+12>>2])}kb=c+16|0;a=(d|0)==(e|0);if(!a){hr(b)}return a}function nG(a,b,c,d){var e=0,f=0;e=kb-16|0;kb=e;kG(e+8|0,b);f=c;Uk(v[e+12>>2],c,d);b=kb-16|0;kb=b;v[b+12>>2]=v[v[e+12>>2]+4>>2];v[b+8>>2]=0;c=v[Pe(b+8|0,b+12|0)>>2];kb=b+16|0;gc(a,f,c);kb=e+16|0}function iS(a,b){var c=0,d=0,e=0;c=kb-16|0;kb=c;gS(c+8|0,b);d=v[c+12>>2];md(c,a,v[c+8>>2],v[c+12>>2]);e=v[c+4>>2];if((e|0)==(d|0)){id(a,v[c+12>>2])}kb=c+16|0;a=(d|0)==(e|0);if(!a){hS(b)}return a}function eV(a,b){var c=0,d=0,e=0;c=kb-16|0;kb=c;Eu(c+8|0,b);d=v[c+12>>2];md(c,a,v[c+8>>2],v[c+12>>2]);e=v[c+4>>2];if((e|0)==(d|0)){id(a,v[c+12>>2])}kb=c+16|0;a=(d|0)==(e|0);if(!a){HB(b)}return a}function aE(a,b){var c=0,d=0,e=0;c=kb-16|0;kb=c;_D(c+8|0,b);d=v[c+12>>2];md(c,a,v[c+8>>2],v[c+12>>2]);e=v[c+4>>2];if((e|0)==(d|0)){id(a,v[c+12>>2])}kb=c+16|0;a=(d|0)==(e|0);if(!a){Mv(b)}return a}function a4(a,b){a=a|0;b=b|0;var c=0;c=kb-16|0;kb=c;WJ(c,b);a=v[a+1298464>>2];v[23540]=0;U(376,a|0,1,c|0);a=v[23540];v[23540]=0;if((a|0)!=1){Ab(c);kb=c+16|0;return}a=P()|0;O()|0;Ab(c);T(a|0);L()}function UQ(a,b){var c=0,d=0,e=0;c=kb-16|0;kb=c;nU(c+8|0,b);d=v[c+12>>2];md(c,a,v[c+8>>2],v[c+12>>2]);e=v[c+4>>2];if((e|0)==(d|0)){id(a,v[c+12>>2])}kb=c+16|0;a=(d|0)==(e|0);if(!a){oU(b)}return a}function Rj(a,b){var c=0,d=0,e=0;c=kb-16|0;kb=c;cn(c+8|0,b);d=v[c+12>>2];md(c,a,v[c+8>>2],v[c+12>>2]);e=v[c+4>>2];if((e|0)==(d|0)){id(a,v[c+12>>2])}kb=c+16|0;a=(d|0)==(e|0);if(!a){Uj(b)}return a}function OH(a){var b=0,c=0,d=0;d=v[a>>2];while(1){c=t[d|0];if(bk(c)){d=d+1|0;v[a>>2]=d;if(b>>>0<=214748364){c=c-48|0;b=B(b,10);b=(c|0)>(2147483647-b|0)?-1:c+b|0}else{b=-1}continue}break}return b}function EM(a){var b=0,c=0;a=a+906300|0;c=gk(a);while(1){if((a|0)!=(c|0)){b=v[a>>2];a:{if(!b){break a}if(!(ob[v[v[b>>2]+120>>2]](b)|0)){break a}ob[v[v[b>>2]+100>>2]](b)}a=a+160|0;continue}break}}function Cu(a){t[a|0]=0;t[a+1|0]=0;t[a+2|0]=0;t[a+3|0]=0;t[a+4|0]=0;t[a+5|0]=0;t[a+6|0]=0;t[a+7|0]=0;t[a+8|0]=0;t[a+9|0]=0;t[a+10|0]=0;t[a+11|0]=0;t[a+12|0]=0;t[a+13|0]=0;t[a+14|0]=0;t[a+15|0]=0}function AR(a,b){var c=0,d=0,e=0;c=kb-16|0;kb=c;wR(c+8|0,b);d=v[c+12>>2];md(c,a,v[c+8>>2],v[c+12>>2]);e=v[c+4>>2];if((e|0)==(d|0)){id(a,v[c+12>>2])}kb=c+16|0;a=(d|0)==(e|0);if(!a){xR(b)}return a}function jP(a){a=a|0;var b=0,c=0;b=kb-32|0;kb=b;t[a+16|0]=0;c=Dz(b,v[a+12>>2]);v[23540]=0;R(753,a|0,c|0);a=v[23540];v[23540]=0;if((a|0)!=1){ql(c);kb=b+32|0;return}a=P()|0;O()|0;ql(c);T(a|0);L()}function Nu(a,b,c){var d=0;a=(a&65535)>>>B(c,3)|0;d=a>>>2&1|w[b+12|0]&-8;t[b+12|0]=d|a<<1&6;if(!(!(a>>>9-(c<<1)&1)|(a&3)!=1)){a=w[b+13|0]|w[b+14|0]<<8;t[b+15|0]=a;t[b+16|0]=a>>>8;t[b+12|0]=d|4}}function AB(a,b){var c=0;c=kb-16|0;kb=c;v[c+12>>2]=1;v[c+8>>2]=a>>>4;b=Zb(128/(B(v[Pe(c+12|0,c+8|0)>>2],b)|0)|0,1,15);t[c+7|0]=1;t[c+6|0]=a&15;a=w[jf(c+7|0,c+6|0)|0];kb=c+16|0;return a|b<<4&240}function yR(a){var b=0,c=0,d=0,e=0;nb=0;d=w[a+4|0];e=w[a+92|0];c=w[a+94|0]|w[a+95|0]<<8;b=c+w[a+93|0]|0;a=0;a=b>>>0<c>>>0?1:a;c=b;b=e+b|0;a=b>>>0<c>>>0?a+1|0:a;c=b<<2;b=d+c|0;b=b-96|0;return b}function xK(a,b){var c=0,d=0,e=0,f=0;if(a>C(.9999989867210388)){d=0}else{a=C(a*a);c=+a;e=32768/(1-c);f=c;c=af(31415.926535897932/+b);d=xl(e*(1-(f*c+K(+C(a+a)*(1-c)-+C(a*a)*(1-c*c)))))}return d}function uT(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=kb-16|0;kb=d;Wf(a,d+14|0);e=x[d+14>>1];KM(b,e);c=0;while(1){if((c|0)==(e|0)){vy(b);kb=d+16|0}else{pk(a,Eb(v[b>>2],c));c=c+1|0;continue}break}}function rI(a,b){var c=0,d=0,e=0,f=C(0),g=C(0),h=0;b=(b|0)>0?b:0;h=a+2304|0;while(1){if((b|0)!=(d|0)){c=d<<2;e=c+a|0;f=z[e>>2];c=c+h|0;g=z[c>>2];z[e>>2]=f+g;z[c>>2]=f-g;d=d+1|0;continue}break}}function PT(a,b,c){var d=0,e=0;d=kb-16|0;kb=d;a=Ah(d,a,b);b=v[a+4>>2];e=v[a+8>>2];while(1){if((b|0)==(e|0)){lc(a);kb=d+16|0}else{Im(b,x[c>>1]|x[c+2>>1]<<16);b=b+4|0;v[a+4>>2]=b;continue}break}}function Fh(a,b){var c=0;c=v[a>>2];a=Wd(b);b=v[c+8>>2];if(uc(b,v[c+12>>2])>>>0>a>>>0){c=v[Eb(b,a)>>2]!=0}else{c=0}if(!c){a=km(ba(4)|0);v[a>>2]=93212;ha(a|0,93348,1103);L()}return v[Eb(b,a)>>2]}function xg(a,b){a=a|0;b=b|0;var c=0,d=0;c=kb+-64|0;kb=c;d=$x(c+8|0,a);v[23540]=0;U(201,a|0,b|0,d|0);a=v[23540];v[23540]=0;if((a|0)!=1){gl(d);kb=c- -64|0;return}a=P()|0;O()|0;gl(d);T(a|0);L()}function ty(a,b){var c=0;a=zQ(a,b);t[a+12|0]=w[b+12|0];c=w[b+13|0]|w[b+14|0]<<8|(w[b+15|0]<<16|w[b+16|0]<<24);t[a+13|0]=c;t[a+14|0]=c>>>8;t[a+15|0]=c>>>16;t[a+16|0]=c>>>24;t[a+17|0]=w[b+17|0]}function ep(a,b,c,d,e,f){var g=0,h=0;pg(a+12|0,d);if(b){if(b>>>0>=f>>>0){Lg();L()}d=vc(B(b,e))}else{d=0}v[a>>2]=d;c=d+B(c,e)|0;v[a+8>>2]=c;v[a+4>>2]=c;g=Cc(a),h=d+B(b,e)|0,v[g>>2]=h;return a}
function rj(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;a:{d=pl(a,b);if((d|0)==255){break a}jk(a,b);cq(a,b,0,0);if(!c){break a}e=cc(a+26|0,d),f=65535,u[e>>1]=f;a=Lb(a+62|0,b);t[a|0]=w[a|0]|128}}function qg(a,b){var c=0,d=0;c=kb-16|0;kb=c;v[c+12>>2]=b;d=b;b=th(1073741823);if(d>>>0<=b>>>0){a=Wh(a);if(a>>>0<b>>>1>>>0){v[c+8>>2]=a<<1;b=v[_c(c+8|0,c+12|0)>>2]}kb=c+16|0;return b}cd();L()}function Oj(a,b){var c=0,d=0;c=kb-16|0;kb=c;v[c+12>>2]=b;d=b;b=th(2147483647);if(d>>>0<=b>>>0){a=Zm(a);if(a>>>0<b>>>1>>>0){v[c+8>>2]=a<<1;b=v[_c(c+8|0,c+12|0)>>2]}kb=c+16|0;return b}cd();L()}function BF(a){a=a|0;var b=0,c=0,d=0;v[a>>2]=84056;d=a+8|0;while(1){b=v[a+8>>2];if(uc(b,v[a+12>>2])>>>0>c>>>0){b=v[Eb(b,c)>>2];if(b){hn(b)}c=c+1|0;continue}break}zb(a+152|0);XF(d);return a|0}function tE(a,b){var c=0,d=0;c=kb-16|0;kb=c;v[c+12>>2]=b;d=b;b=th(178956970);if(d>>>0<=b>>>0){a=Br(a);if(a>>>0<b>>>1>>>0){v[c+8>>2]=a<<1;b=v[_c(c+8|0,c+12|0)>>2]}kb=c+16|0;return b}cd();L()}function pB(a,b){var c=0,d=0;c=kb-16|0;kb=c;v[c+12>>2]=b;d=b;b=th(214748364);if(d>>>0<=b>>>0){a=yC(a);if(a>>>0<b>>>1>>>0){v[c+8>>2]=a<<1;b=v[_c(c+8|0,c+12|0)>>2]}kb=c+16|0;return b}cd();L()}function or(a,b){var c=0,d=0;c=kb-16|0;kb=c;v[c+12>>2]=b;d=b;b=th(536870911);if(d>>>0<=b>>>0){a=jn(a);if(a>>>0<b>>>1>>>0){v[c+8>>2]=a<<1;b=v[_c(c+8|0,c+12|0)>>2]}kb=c+16|0;return b}cd();L()}function oA(a,b,c,d){var e=0,f=0,g=0;e=kb-16|0;kb=e;f=v[b+12>>2];v[e+8>>2]=c;v[e+12>>2]=d;g=v[v[b>>2]+28>>2];v[e>>2]=c;v[e+4>>2]=d;ob[g|0](a,b,f,e);v[b+12>>2]=v[b+12>>2]+v[a+4>>2];kb=e+16|0}function ln(a,b){var c=0,d=0;c=kb-16|0;kb=c;v[c+12>>2]=b;d=b;b=th(357913941);if(d>>>0<=b>>>0){a=Xj(a);if(a>>>0<b>>>1>>>0){v[c+8>>2]=a<<1;b=v[_c(c+8|0,c+12|0)>>2]}kb=c+16|0;return b}cd();L()}function gq(a,b){var c=0,d=0;c=kb-16|0;kb=c;v[c+12>>2]=b;d=b;b=th(134217727);if(d>>>0<=b>>>0){a=mo(a);if(a>>>0<b>>>1>>>0){v[c+8>>2]=a<<1;b=v[_c(c+8|0,c+12|0)>>2]}kb=c+16|0;return b}cd();L()}function gQ(a,b){var c=0,d=0;c=kb-16|0;kb=c;v[c+12>>2]=b;d=b;b=th(268435455);if(d>>>0<=b>>>0){a=Lt(a);if(a>>>0<b>>>1>>>0){v[c+8>>2]=a<<1;b=v[_c(c+8|0,c+12|0)>>2]}kb=c+16|0;return b}cd();L()}function cB(a,b){var c=0,d=0,e=0;c=kb-16|0;kb=c;d=c,e=(Ep(b)+-4.8737671609324025)*(a&32768?28.85390081777927:34.624680981335125),A[d+8>>3]=e;fO(c+8|0,127);a=tk(A[c+8>>3]);kb=c+16|0;return a}function Qaa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=kb-16|0;kb=d;e=x[a+28>>1];u[d+8>>1]=e;f=d,g=(uc(v[a+4>>2],v[a+8>>2])+e|0)-1|0,u[f+10>>1]=g;a=OL(a,b,c,d+8|0);kb=d+16|0;return a|0}function JA(a,b){var c=0,d=0;c=kb-16|0;kb=c;v[c+12>>2]=b;d=b;b=th(715827882);if(d>>>0<=b>>>0){a=Bu(a);if(a>>>0<b>>>1>>>0){v[c+8>>2]=a<<1;b=v[_c(c+8|0,c+12|0)>>2]}kb=c+16|0;return b}cd();L()}function In(a){var b=0,c=0;b=kb-16|0;kb=b;a:{if(!JJ(w[a+20|0])){v[23540]=0;R(1063,b+8|0,a|0);c=v[23540];v[23540]=0;if((c|0)==1){break a}}t[a+20|0]=255;kb=b+16|0;return}V(0)|0;O()|0;Vb();L()}function BD(a,b){var c=0,d=0;c=kb-16|0;kb=c;v[c+12>>2]=b;d=b;b=th(119304647);if(d>>>0<=b>>>0){a=Av(a);if(a>>>0<b>>>1>>>0){v[c+8>>2]=a<<1;b=v[_c(c+8|0,c+12|0)>>2]}kb=c+16|0;return b}cd();L()}function zg(a,b){var c=0,d=0;c=kb-16|0;kb=c;Zq(c+8|0,b);b=v[c+12>>2];nc(c,v[a>>2],v[a+8>>2],v[c+8>>2],v[c+12>>2]);d=v[c+4>>2];if((b|0)==(d|0)){$b(a,v[c+12>>2])}kb=c+16|0;return(b|0)==(d|0)}function xD(a,b){var c=0,d=0;c=kb-16|0;kb=c;_D(c+8|0,b);b=v[c+12>>2];nc(c,v[a>>2],v[a+8>>2],v[c+8>>2],v[c+12>>2]);d=v[c+4>>2];if((b|0)==(d|0)){$b(a,v[c+12>>2])}kb=c+16|0;return(b|0)==(d|0)}function rh(a,b,c){a:{if(b>>>0<=c>>>0){a=ba(8)|0;v[23540]=0;b=S(193,a|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){break a}b=P()|0;O()|0;ca(a|0);T(b|0);L()}return w[a+c|0]}ha(b|0,26120,168);L()}function pD(a,b){var c=0,d=0;c=kb-16|0;kb=c;gr(c+8|0,b);b=v[c+12>>2];nc(c,v[a>>2],v[a+8>>2],v[c+8>>2],v[c+12>>2]);d=v[c+4>>2];if((b|0)==(d|0)){$b(a,v[c+12>>2])}kb=c+16|0;return(b|0)==(d|0)}function pC(a){var b=0;b=v[a+72>>2];v[a+72>>2]=b-1|b;b=v[a>>2];if(b&8){v[a>>2]=b|32;return-1}v[a+4>>2]=0;v[a+8>>2]=0;b=v[a+44>>2];v[a+28>>2]=b;v[a+20>>2]=b;v[a+16>>2]=b+v[a+48>>2];return 0}function nN(a,b,c){var d=0,e=0;d=kb-16|0;kb=d;a=lr(d,a,b);b=v[a+4>>2];e=v[a+8>>2];while(1){if((b|0)==(e|0)){lc(a);kb=d+16|0}else{mN(b,v[c>>2],v[c+4>>2]);b=b+8|0;v[a+4>>2]=b;continue}break}}function gC(a,b){var c=0,d=0;c=kb-16|0;kb=c;fC(c+8|0,b);b=v[c+12>>2];nc(c,v[a>>2],v[a+8>>2],v[c+8>>2],v[c+12>>2]);d=v[c+4>>2];if((b|0)==(d|0)){$b(a,v[c+12>>2])}kb=c+16|0;return(b|0)==(d|0)}function bT(a,b){var c=0,d=0;c=kb-16|0;kb=c;aT(c+8|0,b);b=v[c+12>>2];nc(c,v[a>>2],v[a+8>>2],v[c+8>>2],v[c+12>>2]);d=v[c+4>>2];if((b|0)==(d|0)){$b(a,v[c+12>>2])}kb=c+16|0;return(b|0)==(d|0)}function WU(a,b){var c=0,d=0;c=kb-16|0;kb=c;$u(c+8|0,b);b=v[c+12>>2];nc(c,v[a>>2],v[a+8>>2],v[c+8>>2],v[c+12>>2]);d=v[c+4>>2];if((b|0)==(d|0)){$b(a,v[c+12>>2])}kb=c+16|0;return(b|0)==(d|0)}function Uo(a,b){var c=0,d=0;c=kb-16|0;kb=c;Lh(c+8|0,b);b=v[c+12>>2];nc(c,v[a>>2],v[a+8>>2],v[c+8>>2],v[c+12>>2]);d=v[c+4>>2];if((b|0)==(d|0)){$b(a,v[c+12>>2])}kb=c+16|0;return(b|0)==(d|0)}function UL(a,b){var c=0,d=0;c=kb-16|0;kb=c;v[c+12>>2]=b;d=b;b=th(82595524);if(d>>>0<=b>>>0){a=at(a);if(a>>>0<b>>>1>>>0){v[c+8>>2]=a<<1;b=v[_c(c+8|0,c+12|0)>>2]}kb=c+16|0;return b}cd();L()}function UG(a,b,c,d){a:{if(!a){break a}b:{switch(b+2|0){case 0:t[a|0]=c;return;case 1:u[a>>1]=c;return;case 2:case 3:v[a>>2]=c;return;case 5:break b;default:break a}}v[a>>2]=c;v[a+4>>2]=d}}function Ro(a,b){var c=0,d=0;c=kb-16|0;kb=c;Ym(c+8|0,b);b=v[c+12>>2];nc(c,v[a>>2],v[a+8>>2],v[c+8>>2],v[c+12>>2]);d=v[c+4>>2];if((b|0)==(d|0)){$b(a,v[c+12>>2])}kb=c+16|0;return(b|0)==(d|0)}function Mu(a,b){var c=0,d=0;c=kb-16|0;kb=c;Go(c+8|0,b);b=v[c+12>>2];nc(c,v[a>>2],v[a+8>>2],v[c+8>>2],v[c+12>>2]);d=v[c+4>>2];if((b|0)==(d|0)){$b(a,v[c+12>>2])}kb=c+16|0;return(b|0)==(d|0)}function MU(a,b){var c=0,d=0;c=kb-16|0;kb=c;Eu(c+8|0,b);b=v[c+12>>2];nc(c,v[a>>2],v[a+8>>2],v[c+8>>2],v[c+12>>2]);d=v[c+4>>2];if((b|0)==(d|0)){$b(a,v[c+12>>2])}kb=c+16|0;return(b|0)==(d|0)}function Lu(a,b){var c=0,d=0;c=kb-16|0;kb=c;Ho(c+8|0,b);b=v[c+12>>2];nc(c,v[a>>2],v[a+8>>2],v[c+8>>2],v[c+12>>2]);d=v[c+4>>2];if((b|0)==(d|0)){$b(a,v[c+12>>2])}kb=c+16|0;return(b|0)==(d|0)}function Jt(a){var b=0;a:{if(Sb(a,13574,4)|w[a+4|0]){break a}if(Ib(w[a+6|0]|w[a+7|0]<<8)>>>0>1){break a}if(Ib(w[a+12|0]|w[a+13|0]<<8)){break a}b=(Ib(w[a+16|0]|w[a+17|0]<<8)|0)==20}return b}function Hr(a,b,c){var d=0;d=kb-16|0;kb=d;gc(d+8|0,b,c);b=v[d+12>>2];nc(d,v[a>>2],v[a+8>>2],v[d+8>>2],v[d+12>>2]);c=v[d+4>>2];if((b|0)==(c|0)){$b(a,v[d+12>>2])}kb=d+16|0;return(b|0)==(c|0)}function HU(a,b){var c=0,d=0;c=kb-16|0;kb=c;Fu(c+8|0,b);b=v[c+12>>2];nc(c,v[a>>2],v[a+8>>2],v[c+8>>2],v[c+12>>2]);d=v[c+4>>2];if((b|0)==(d|0)){$b(a,v[c+12>>2])}kb=c+16|0;return(b|0)==(d|0)}function GU(a,b){var c=0,d=0;c=kb-16|0;kb=c;Fq(c+8|0,b);b=v[c+12>>2];nc(c,v[a>>2],v[a+8>>2],v[c+8>>2],v[c+12>>2]);d=v[c+4>>2];if((b|0)==(d|0)){$b(a,v[c+12>>2])}kb=c+16|0;return(b|0)==(d|0)}function ER(a,b){var c=0,d=0;c=kb-16|0;kb=c;xA(c+8|0,b);b=v[c+12>>2];nc(c,v[a>>2],v[a+8>>2],v[c+8>>2],v[c+12>>2]);d=v[c+4>>2];if((b|0)==(d|0)){$b(a,v[c+12>>2])}kb=c+16|0;return(b|0)==(d|0)}function $R(a,b){var c=0,d=0;c=kb-16|0;kb=c;_R(c+8|0,b);b=v[c+12>>2];nc(c,v[a>>2],v[a+8>>2],v[c+8>>2],v[c+12>>2]);d=v[c+4>>2];if((b|0)==(d|0)){$b(a,v[c+12>>2])}kb=c+16|0;return(b|0)==(d|0)}function eA(a,b){var c=0,d=0;d=kb-32|0;kb=d;c=Gb(a);c=Vf(d+8|0,qg(a,uc(v[a>>2],v[a+4>>2])+1|0),uc(v[a>>2],v[a+4>>2]),c);jq(v[c+8>>2],v[b>>2]);v[c+8>>2]=v[c+8>>2]+4;Fd(a,c);Uf(c);kb=d+32|0}function Mx(a,b,c,d,e,f,g,h,i){var j=0;j=kb-16|0;kb=j;Fg(j,b,c,d,e,f,g,h,i^-2147483648);d=v[j>>2];c=v[j+4>>2];b=v[j+12>>2];v[a+8>>2]=v[j+8>>2];v[a+12>>2]=b;v[a>>2]=d;v[a+4>>2]=c;kb=j+16|0}function Hw(a,b,c){b=(b+9|0)%12|0;a=((b<<24>>24)/-10<<24>>24)+a|0;return(((((((a|0)/4|0)+c|0)+B(a,365)|0)+((a|0)/-100|0)|0)+((a|0)/400|0)|0)+((B(b,20054016)+327680>>16)/10<<16>>16)|0)-1|0}function sn(a,b){var c=0,d=0,e=0;a:{c=OG(b);if(c>>>0<1073741808){b:{if(Vr(c)){ie(a,c);break b}d=am(c)+1|0;e=Bi(d);wd(a,e);ff(a,d);Hd(a,c);a=e}ni(a,b,c);wd((c<<2)+a|0,0);break a}hf();L()}}function n0(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;if(d>>>0<4294967280){a:{if(Cl(d)){ie(a,c);break a}e=nh(d)+1|0;d=vc(e);wd(a,d);ff(a,e);Hd(a,c);a=d}xd(He(a,b,c)+c|0,0);return}hf();L()}function MP(a){var b=0,c=0;a:{b:{c=a&240;if((c|0)!=192){if((c|0)==240){break b}b=3;if((c|0)!=208){break a}}b=2;break a}a=a+15&255;b=1;if(a>>>0>2){break a}b=131842>>>(a<<3)|0}return b&255}function DF(a,b){var c=0,d=0;d=kb-32|0;kb=d;c=Gb(a);c=Xl(d+8|0,Vl(a,fd(v[a>>2],v[a+4>>2])+1|0),fd(v[a>>2],v[a+4>>2]),c);xd(v[c+8>>2],w[b|0]);v[c+8>>2]=v[c+8>>2]+1;Fd(a,c);Wl(c);kb=d+32|0}function z0(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=v[a+84>>2];d=c+256|0;f=Ss(e,0,d);d=f?f-e|0:d;c=c>>>0>d>>>0?d:c;sc(b,e,c);b=e+d|0;v[a+84>>2]=b;v[a+8>>2]=b;v[a+4>>2]=c+e;return c|0}function yi(a,b){var c=0,d=0;c=w[a|0];d=w[b|0];a:{if(!c|(d|0)!=(c|0)){break a}while(1){d=w[b+1|0];c=w[a+1|0];if(!c){break a}b=b+1|0;a=a+1|0;if((c|0)==(d|0)){continue}break}}return c-d|0}function jT(a,b,c,d){var e=0;e=kb-16|0;kb=e;v[e+12>>2]=b;v[e+8>>2]=d;c=Op(a,c,v[Kb(e+12|0,e+8|0)>>2]);a:{if(c){break a}c=0;if((b|0)==(d|0)){break a}c=b>>>0<d>>>0?-1:1}kb=e+16|0;return c}function P6(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;f=kb-16|0;kb=f;v[f+8>>2]=v[a+8>>2];g=v[a+4>>2];v[f>>2]=v[a>>2];v[f+4>>2]=g;a=pK(f,b,c,d,0,0,0,0,e);kb=f+16|0;return a|0}function Nx(a){var b=0,c=0,d=0;A[a+4272>>3]=A[a+4280>>3];c=a;d=a+4296|0;a=0;while(1){if(a>>>0<32){a=a+15|0;b=Un(d)|b<<15;continue}break}A[c+4280>>3]=C(C(b|0)*C(-4.656612873077393e-10))}function B$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=kb-16|0;kb=g;v[g+8>>2]=624576549;v[g+12>>2]=1394948685;h=a;a=g+16|0;b=$j(h,b,c,d,e,f,g+8|0,a);kb=a;return b|0}function zia(a,b){a=a|0;b=b|0;var c=0,d=0;c=kb-16|0;kb=c;d=Qb(v[a>>2],v[a+8>>2],12);a:{if(!d){t[c|0]=0;di(b,12,c);break a}Fq(c+8|0,b);ud(c,a,v[c+8>>2],v[c+12>>2])}kb=c+16|0;return d|0}function vs(a){var b=0,c=0,d=0;c=1;while(1){if(c){c=0;b=v[a+4>>2];d=((b<<2)+(mv(v[a>>2],1)^270549120)|0)+2019860093|0;v[a>>2]=d;b=b+B(mv(d,16),5)|0;v[a+4>>2]=b;continue}break}return b}function G3(a,b){a=a|0;b=b|0;var c=0,d=0;c=kb-16|0;kb=c;d=v[14463];v[c+8>>2]=v[14462];v[c+12>>2]=d;d=v[14461];v[c>>2]=v[14460];v[c+4>>2]=d;ob[v[yp(c,dk(w[b+20|0]))>>2]](a,b);kb=c+16|0}function Vl(a,b){var c=0,d=0;c=kb-16|0;kb=c;v[c+12>>2]=b;d=b;b=th(-1);if(d>>>0<=b>>>0){a=mp(a);if(a>>>0<b>>>1>>>0){v[c+8>>2]=a<<1;b=v[_c(c+8|0,c+12|0)>>2]}kb=c+16|0;return b}cd();L()}function Uh(a){var b=0;a=Xh(a);b=2147483647;a:{if(a>=C(2147483648)){break a}b=-2147483648;if(a<=C(-2147483648)){break a}b=~~a;if(C(D(a))<C(2147483648)){break a}b=-2147483648}return b}function vK(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;var f=0,g=0;f=kb-16|0;kb=f;v[f+8>>2]=v[a+8>>2];g=v[a+4>>2];v[f>>2]=v[a>>2];v[f+4>>2]=g;c=uK(f,b,c,d,e,0,0,0,0);kb=f+16|0;return+c}function Yl(a,b){v[a+28>>2]=0;u[a+24>>1]=65535;v[a+16>>2]=0;v[a+20>>2]=0;v[a+4>>2]=0;v[a+8>>2]=0;t[a|0]=0;v[a+32>>2]=11;v[a+36>>2]=b;Tb(a+40|0);Tb(a+52|0);Ub(a- -64|0,0,48);return a}function Vf(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;pg(a+12|0,d);if(b){d=Bi(b)}else{d=0}v[a>>2]=d;c=d+(c<<2)|0;v[a+8>>2]=c;v[a+4>>2]=c;e=Cc(a),f=d+(b<<2)|0,v[e>>2]=f;return a|0}function Is(a){var b=0;b=v[a+24>>2];v[23540]=0;Y(813,b|0);b=v[23540];v[23540]=0;if((b|0)!=1){Xe(a+68|0);Xf(a+36|0);As(a+32|0);ij(a+24|0);hj(a+4|0);return De(a)}V(0)|0;O()|0;Vb();L()}function Fea(a,b){a=a|0;b=b|0;var c=0,d=0;c=kb-16|0;kb=c;d=Qb(v[a>>2],v[a+8>>2],4);a:{if(!d){t[c|0]=0;uD(b,4,c);break a}Lh(c+8|0,b);ud(c,a,v[c+8>>2],v[c+12>>2])}kb=c+16|0;return d|0}function Eia(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=kb-16|0;kb=d;YS(b,c);c=Qb(v[a>>2],v[a+8>>2],c<<2);if(c){XS(d+8|0,v[b>>2],v[b+4>>2]);ud(d,a,v[d+8>>2],v[d+12>>2])}kb=d+16|0;return c|0}function uX(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=kb-16|0;kb=d;ID(b,c);c=Qb(v[a>>2],v[a+8>>2],c<<3);if(c){HD(d+8|0,v[b>>2],v[b+4>>2]);ud(d,a,v[d+8>>2],v[d+12>>2])}kb=d+16|0;return c|0}function lz(a){var b=0,c=0;b=v[a>>2];c=v[b>>2];a:{if(!c){while(1){c=Ch(b);b=v[b+8>>2];if(c){continue}break}break a}while(1){b=c;c=v[b+4>>2];if(c){continue}break}}v[a>>2]=b;return a}function jX(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=kb-16|0;kb=d;v[d+12>>2]=c;c=0;a=ob[v[v[a>>2]+24>>2]](a)|0;if(a>>>0>b>>>0){v[d+8>>2]=a-b;c=v[Kb(d+12|0,d+8|0)>>2]}kb=d+16|0;return c|0}function Pv(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=kb-16|0;kb=e;v[e+12>>2]=d;d=Hb(b);if(d>>>0<c>>>0){sk();L()}b=Mc(b);v[e+8>>2]=d-c;vu(a,b+c|0,v[Kb(e+12|0,e+8|0)>>2]);kb=e+16|0}function JM(a,b){a=a|0;b=b|0;var c=0;c=kb-16|0;kb=c;HM(c,b+80|0);v[23540]=0;U(11,a|0,0,c|0);a=v[23540];v[23540]=0;if((a|0)!=1){zb(c);kb=c+16|0;return}a=P()|0;O()|0;zb(c);T(a|0);L()}function tX(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=!b|(b>>>0>d>>>0|a>>>0>=d>>>0|d-a>>>0<b>>>0);a:{if(d){break a}a=a+b|0;if(fd(v[c>>2],v[c+4>>2])>>>0>=a>>>0){break a}Qi(c,a)}return!d|0}function YN(a,b,c,d){a:{if((a|0)!=67108864){break a}a=B(d,872)+c|0;v[a+704>>2]=v[a+704>>2]&-129;a=d^1;if(a>>>0>=(b&65535)>>>0){break a}a=B(a,872)+c|0;v[a+704>>2]=v[a+704>>2]&-129}}function Iea(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=kb-16|0;kb=d;yQ(b,c);if(Qb(v[a>>2],v[a+8>>2],c<<8)){c=v[b>>2];gc(d+8|0,c,zh(c,v[b+4>>2])<<8);ud(d,a,v[d+8>>2],v[d+12>>2])}kb=d+16|0}function ue(a,b){var c=0;a:{c=Pg(b);if((c|0)==(Hb(a)|0)){v[23540]=0;a=W(361,a|0,b|0,c|0)|0;b=v[23540];v[23540]=0;if((b|0)==1){break a}a=!a}else{a=0}return a}V(0)|0;O()|0;Vb();L()}function iu(a,b){var c=0;c=w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24);t[a|0]=c;t[a+1|0]=c>>>8;t[a+2|0]=c>>>16;t[a+3|0]=c>>>24;b=w[b+4|0]|w[b+5|0]<<8;t[a+4|0]=b;t[a+5|0]=b>>>8}function Zx(a,b,c){var d=0,e=0;d=kb-16|0;kb=d;a=Ah(d,a,b);b=v[a+4>>2];e=v[a+8>>2];while(1){if((b|0)==(e|0)){lc(a);kb=d+16|0}else{fk(b,z[c>>2]);b=b+4|0;v[a+4>>2]=b;continue}break}}function Jo(a,b,c){var d=0,e=0;d=kb-16|0;kb=d;a=ai(d,a,b);b=v[a+4>>2];e=v[a+8>>2];while(1){if((b|0)==(e|0)){lc(a);kb=d+16|0}else{Mi(b,x[c>>1]);b=b+2|0;v[a+4>>2]=b;continue}break}}function AC(a,b,c){var d=0,e=0;d=kb-16|0;kb=d;a=Ah(d,a,b);b=v[a+4>>2];e=v[a+8>>2];while(1){if((b|0)==(e|0)){lc(a);kb=d+16|0}else{jq(b,v[c>>2]);b=b+4|0;v[a+4>>2]=b;continue}break}}function ul(a,b){var c=0,d=0,e=0;v[a>>2]=0;v[a+4>>2]=0;Gc(a+8|0);v[a>>2]=v[b>>2];v[a+4>>2]=v[b+4>>2];c=Gb(b);d=Gb(a),e=v[c>>2],v[d>>2]=e;v[c>>2]=0;v[b>>2]=0;v[b+4>>2]=0;return a}function ria(a,b){a=a|0;b=b|0;var c=0;c=kb-32|0;kb=c;v[c+24>>2]=0;v[c+28>>2]=0;v[c+16>>2]=0;v[c+20>>2]=0;v[c+8>>2]=0;v[c+12>>2]=0;v[c>>2]=0;v[c+4>>2]=0;tT(b,c);sT(a,c);kb=c+32|0}function qZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;while(1){if((b|0)!=(c|0)){a=v[b>>2];if(a>>>0<=127){a=x[(a<<1)+80016>>1]}else{a=0}u[d>>1]=a;d=d+2|0;b=b+4|0;continue}break}return c|0}function laa(a,b){a=a|0;b=b|0;var c=0,d=0;d=kb-32|0;kb=d;c=-1;a:{if(!aE(a,d+8|0)){break a}c=0;if(!aM(d+8|0)|(v[d+16>>2]!=v[b>>2]|v[b+4>>2]?b:0)){break a}c=1}kb=d+32|0;return c|0}function Po(a,b,c){var d=0,e=0;d=kb-16|0;kb=d;a=Ok(d,a,b);b=v[a+4>>2];e=v[a+8>>2];while(1){if((b|0)==(e|0)){lc(a);kb=d+16|0}else{xd(b,w[c|0]);b=b+1|0;v[a+4>>2]=b;continue}break}}function Oha(){var a=0,b=0,c=0;a=kb-16|0;kb=a;b=vc(1);v[23540]=0;Z(32);c=v[23540];v[23540]=0;if((c|0)!=1){b=v[Lf(a+8|0,b)>>2];kb=a+16|0;return b|0}a=P()|0;O()|0;Mb(b);T(a|0);L()}function HC(a){var b=0,c=0;a:{if(Sb(a,14197,3)){break a}b=w[a+3|0];b:{if(b>>>0<=7){if((b|0)==1){break b}break a}if(b>>>0>14){break a}}c=(w[a+40|0]-1&255)>>>0<32|b>>>0<9}return c}function Bc(a,b){var c=0,d=0;c=kb-16|0;kb=c;if(ef(a)){Mb(v[a>>2])}d=v[b+4>>2];v[a>>2]=v[b>>2];v[a+4>>2]=d;v[a+8>>2]=v[b+8>>2];ie(b,0);t[c+15|0]=0;we(b,c+15|0);kb=c+16|0;return a}function y7(a,b,c){a=a|0;b=b|0;c=C(c);var d=0,e=0,f=C(0);if(b>>>0<=12){c=Yd(c,C(0));d=a+4208|0;if((b|0)==12){c=C(Xh(C(c*C(3)))/C(3));b=12}e=Eb(d,b),f=c,z[e>>2]=f;t[a+5046|0]=1}}function ws(a){var b=0,c=0,d=0;b=kb-16|0;kb=b;v[b+12>>2]=12;while(1){v[b+8>>2]=32;if(y[Kb(b+12|0,b+8|0)>>2]<=c>>>0){kb=b+16|0}else{c=c+15|0;d=Un(a)&4095;continue}break}return d}function uO(a,b,c,d){var e=0,f=0;e=kb-16|0;kb=e;while(1){if(c){f=ml(x[c+16>>1],v[c+20>>2],a,b);d=f?d:c;c=v[(f?c+4|0:c)>>2];continue}break}a=v[fc(e+8|0,d)>>2];kb=e+16|0;return a}function jE(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=wl(a);d=Ad(v[a+4>>2],w[a+11|0]);e=d+1|0;if((c|0)==(d|0)){My(a,c,e-c|0,c,c,0)}c=sd(a);jI(c+d|0,1,b);vq(a,e);xd(c+e|0,0);return a|0}function fE(a){var b=0;a:{b:{if(a>>>0>=18285141){if(a>>>0>18350591){break b}b=1;if((a|0)!=18350080){break a}}return 0}b=0;if((a|0)==18350592){break a}b=(a&-256)!=(a|0)}return b}function VX(a){a=a|0;var b=0,c=0;b=kb-16|0;kb=b;ZD(b,0,a);v[23540]=0;a=S(125,b|0)|0;c=v[23540];v[23540]=0;if((c|0)!=1){zb(b);kb=b+16|0;return a|0}a=P()|0;O()|0;zb(b);T(a|0);L()}function lF(a,b,c){var d=0;a:{if(!a){a=ba(8)|0;v[23540]=0;c=S(c|0,a|0)|0;d=v[23540];v[23540]=0;if((d|0)!=1){break a}b=P()|0;O()|0;ca(a|0);T(b|0);L()}return}ha(c|0,b|0,950);L()}function iw(a,b,c,d,e){var f=0;a:{f=Zs(4332);if(f){v[23540]=0;ja(e|0,f|0,a|0,b|0,c|0,d|0)|0;a=v[23540];v[23540]=0;if((a|0)==1){break a}}return f}a=P()|0;O()|0;Mb(f);T(a|0);L()}function V2(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=kb-16|0;kb=d;v[d+12>>2]=c;qx(a,b,c);c=0;a=v[a+16>>2];if(a>>>0>b>>>0){v[d+8>>2]=a-b;c=v[Kb(d+8|0,d+12|0)>>2]}kb=d+16|0;return c|0}function Kja(a,b){a=a|0;b=b|0;if(!GU(a,b)){t[b|0]=0;t[b+1|0]=0;t[b+2|0]=0;t[b+3|0]=0;t[b+4|0]=0;t[b+5|0]=0;t[b+6|0]=0;t[b+7|0]=0;t[b+8|0]=0;t[b+9|0]=0;t[b+10|0]=0;t[b+11|0]=0}}function rM(a){var b=0,c=0,d=0;b=kb-16|0;kb=b;while(1){v[b+12>>2]=7;v[b+8>>2]=32;if(y[Kb(b+12|0,b+8|0)>>2]<=c>>>0){kb=b+16|0}else{c=c+15|0;d=Un(a)&127;continue}break}return d}function hba(a,b){a=a|0;b=b|0;var c=0;a=Yf(a);c=Gi(v[b>>2]);b=xf(b);v[23540]=0;U(807,a|0,c|0,b|0);b=v[23540];v[23540]=0;if((b|0)!=1){return a|0}b=P()|0;O()|0;AN(a);T(b|0);L()}function bfa(a,b){a=a|0;b=b|0;var c=0;c=kb-16|0;kb=c;b=-1;a:{if(!Rj(a,c+8|0)){break a}b=0;if(!AQ(c+8|0)){break a}b=-1;if(!fg(a,4)){break a}b=YQ(a)>>>31|0}kb=c+16|0;return b|0}function VY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=kb-16|0;kb=d;ob[v[v[a>>2]+12>>2]](d+8|0,a,b);a=v[d+8>>2];b=v[c>>2];a=pc(v[d+12>>2],v[c+4>>2])&(a|0)==(b|0);kb=d+16|0;return a|0}function tp(a){var b=0,c=0;b=v[23461];c=a+3&-4;a=b+c|0;a:{if(a>>>0<=b>>>0?c:0){break a}if(_w()>>>0<a>>>0){if(!(xa(a|0)|0)){break a}}v[23461]=a;return b}v[116016]=48;return-1}function Jq(a,b){a=a|0;b=b|0;var c=0,d=0;c=v[a>>2];d=v[a+4>>2];if(Rc(c,d)>>>0>b>>>0){a=v[a+24>>2];b=Gl(c,d,b);a=xe(v[a+484344>>2],v[a+484348>>2],x[b>>1])}else{a=0}return a|0}function zU(a){var b=0;a:{if(Sb(a,16751,4)){break a}if(bc(w[a+4|0]|w[a+5|0]<<8|(w[a+6|0]<<16|w[a+7|0]<<24))-257>>>0<4294967053){break a}b=!Ib(w[a+8|0]|w[a+9|0]<<8)}return b}function pga(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=kb-16|0;kb=d;v[d+8>>2]=b;while(1){if(Pb(b,c)){v[d+4>>2]=v[b>>2];vA(a,d+4|0);b=v[Le(d+8|0)>>2];continue}else{kb=d+16|0}break}}function Xu(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=kb-16|0;kb=d;Qi(b,c);if(Qb(v[a>>2],v[a+8>>2],c)){c=v[b>>2];gc(d+8|0,c,fd(c,v[b+4>>2]));ud(d,a,v[d+8>>2],v[d+12>>2])}kb=d+16|0}function XQ(a,b){var c=0,d=0;c=kb-16|0;kb=c;Lh(c+8|0,b);b=v[c+12>>2];md(c,a,v[c+8>>2],v[c+12>>2]);d=v[c+4>>2];if((b|0)==(d|0)){id(a,v[c+12>>2])}kb=c+16|0;return(b|0)==(d|0)}function PA(a,b,c){var d=0,e=0;d=kb-16|0;kb=d;a=Iq(d,a,b);b=v[a+4>>2];e=v[a+8>>2];while(1){if((b|0)==(e|0)){lc(a);kb=d+16|0}else{iu(b,c);b=b+6|0;v[a+4>>2]=b;continue}break}}function Ag(a,b,c,d){var e=0;a=((b|0)/8|0)+a|0;e=rh(v[d>>2],v[d+4>>2],a);return((rh(v[d>>2],v[d+4>>2],a+1|0)<<8|e<<16|rh(v[d>>2],v[d+4>>2],a+2|0))<<(b&7)&16777215)>>>24-c|0}function Xl(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;pg(a+12|0,d);if(b){d=vc(b)}else{d=0}v[a>>2]=d;c=c+d|0;v[a+8>>2]=c;v[a+4>>2]=c;e=Cc(a),f=b+d|0,v[e>>2]=f;return a|0}function Oh(a,b){a=a|0;b=b|0;var c=0;c=kb-32|0;kb=c;t[c+24|0]=0;Yi(c+8|0,c+24|0);yn(c+16|0,a,v[c+8>>2],v[c+12>>2]);a=v[c+20>>2];t[b|0]=w[c+24|0];kb=c+32|0;return(a|0)==1|0}function I9(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=kb-16|0;kb=e;f=v[c>>2];if(f>>>0<fd(a,b)>>>0){a=Lk(e,Lb(a,f),x[c+20>>1]);g=dw(d,a);Xb(a)}kb=e+16|0;return g|0}function oZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a:{while(1){if((c|0)==(d|0)){break a}a=v[c>>2];if(!(a>>>0>127|!(x[(a<<1)+80016>>1]&b))){c=c+4|0;continue}break}d=c}return d|0}function hka(a,b){a=a|0;b=b|0;var c=0;c=kb-16|0;kb=c;cn(c+8|0,b);b=v[c+12>>2];nc(c,v[a>>2],v[a+8>>2],v[c+8>>2],v[c+12>>2]);if((b|0)==v[c+4>>2]){$b(a,v[c+12>>2])}kb=c+16|0}function gf(a,b,c){var d=0,e=0,f=0;d=kb-16|0;kb=d;v[d+8>>2]=c;v[d+4>>2]=31;e=d,f=pV(b,c),v[e+12>>2]=f;c=b;b=MB(d+4|0);qh(c,c+b|0,a);e=Lb(a,b),f=0,t[e|0]=f;rV(a);kb=d+16|0}function GD(a,b,c){var d=0,e=0;a:{b:{if(Cl(c)){ie(a,c);break b}if(c>>>0>=4294967280){break a}d=nh(c)+1|0;e=vc(d);wd(a,e);ff(a,d);Hd(a,c);a=e}He(a,b,c+1|0);return}hf();L()}function vha(){var a=0,b=0,c=0;a=kb-16|0;kb=a;b=Kc(a,10284);v[23540]=0;Y(36,b|0);c=v[23540];v[23540]=0;if((c|0)!=1){zb(b);kb=a+16|0;return}a=P()|0;O()|0;zb(b);T(a|0);L()}function uba(a,b){a=a|0;b=b|0;var c=0,d=0;c=kb-16|0;kb=c;d=Qb(v[a>>2],v[a+8>>2],16);a:{if(!d){sC(b);break a}$u(c+8|0,b);ud(c,a,v[c+8>>2],v[c+12>>2])}kb=c+16|0;return d|0}function kX(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=ob[v[v[a>>2]+24>>2]](a)|0;a:{if(!c){d=1;if((a|0)==(b|0)){break a}}d=0;if(a>>>0<=b>>>0){break a}d=a-b>>>0>=c>>>0}return d|0}function gm(a){a=a<<8&16711680|a<<24|(a>>>8&65280|a>>>24);a=a>>>4&252645135|(a&252645135)<<4;a=a>>>2&858993459|(a&858993459)<<2;return a>>>1&1431655765|(a&1431655765)<<1}function eja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=kb-16|0;kb=d;a:{if(a){ob[v[v[a>>2]+8>>2]](a,b,c);break a}if((b|0)>=6){break a}OM(d,9182,10881,140,42);qE(d,b,c)}kb=d+16|0}function vE(a,b){var c=0,d=0;c=kb-16|0;kb=c;a=Ok(c,a,b);b=v[a+4>>2];d=v[a+8>>2];while(1){if((b|0)==(d|0)){lc(a);kb=c+16|0}else{uE(b);b=b+1|0;v[a+4>>2]=b;continue}break}}function vC(a,b){var c=0,d=0;c=kb-16|0;kb=c;a=ai(c,a,b);b=v[a+4>>2];d=v[a+8>>2];while(1){if((b|0)==(d|0)){lc(a);kb=c+16|0}else{uC(b);b=b+2|0;v[a+4>>2]=b;continue}break}}function pZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;while(1){a:{if((c|0)!=(d|0)){a=v[c>>2];if(a>>>0>127|!(x[(a<<1)+80016>>1]&b)){break a}}else{c=d}return c|0}c=c+4|0;continue}}function FA(a,b){var c=0,d=0;c=kb-16|0;kb=c;a=Ah(c,a,b);b=v[a+4>>2];d=v[a+8>>2];while(1){if((b|0)==(d|0)){lc(a);kb=c+16|0}else{Pm(b);b=b+4|0;v[a+4>>2]=b;continue}break}}function At(a,b){var c=0,d=0;c=kb-16|0;kb=c;a=Ah(c,a,b);b=v[a+4>>2];d=v[a+8>>2];while(1){if((b|0)==(d|0)){lc(a);kb=c+16|0}else{PP(b);b=b+4|0;v[a+4>>2]=b;continue}break}}function sI(a){var b=0,c=0;a:{if(w[a|0]!=255){break a}b=w[a+1|0];if((b&240)!=240&(b&254)!=226|!(b&6)){break a}a=w[a+2|0];if((a&240)==240){break a}c=(a&12)!=12}return c}function po(a,b){a=a|0;b=b|0;var c=0,d=0;c=kb-16|0;kb=c;d=Qb(v[a>>2],v[a+8>>2],4);a:{if(!d){_S(b);break a}Lh(c+8|0,b);ud(c,a,v[c+8>>2],v[c+12>>2])}kb=c+16|0;return d|0}function Vt(a){var b=0,c=0,d=0,e=0;while(1){a:{if((b|0)==32){e=c;break a}d=w[a+b|0];if((d-1&255)>>>0<31|((c^1)&1?0:d)){break a}b=b+1|0;c=!d|c;continue}break}return e&1}function nfa(a,b){a=a|0;b=b|0;var c=0,d=0;c=kb-48|0;kb=c;d=-1;a:{if(!UQ(a,c)){break a}d=0;if(!TQ(c)){break a}d=Ae(a,b,SQ(w[c+31|0],w[c+33|0]),nb)}kb=c+48|0;return d|0}function kga(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=kb-16|0;kb=d;ID(b,c);if(Qb(v[a>>2],v[a+8>>2],c<<3)){HD(d+8|0,v[b>>2],v[b+4>>2]);ud(d,a,v[d+8>>2],v[d+12>>2])}kb=d+16|0}function Sb(a,b,c){var d=0,e=0,f=0;a:{if(!c){break a}while(1){d=w[a|0];e=w[b|0];if((d|0)==(e|0)){b=b+1|0;a=a+1|0;c=c-1|0;if(c){continue}break a}break}f=d-e|0}return f}function NC(a,b,c){var d=0;d=kb-16|0;kb=d;a=Qo(d,a+8|0,b);b=v[a>>2];while(1){if((b|0)!=v[a+4>>2]){Mi(b,x[c>>1]);b=v[a>>2]+2|0;v[a>>2]=b;continue}break}Ud(a);kb=d+16|0}function jk(a,b){var c=0,d=0,e=0;a:{c=pl(a,b);if((c|0)==255){break a}if(kk(v[a>>2])){break a}d=Lb(a+8|0,c);e=w[d|0]&223;t[d|0]=e;gh(v[a>>2],v[a+4>>2],b,wt(c)|176,e)}}function dT(a,b,c){var d=0;d=kb-16|0;kb=d;a=Wv(d,a+8|0,b);b=v[a>>2];while(1){if((b|0)!=v[a+4>>2]){xd(b,w[c|0]);b=v[a>>2]+1|0;v[a>>2]=b;continue}break}Ud(a);kb=d+16|0}function ZW(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=kb-16|0;kb=d;v[d+12>>2]=c;c=0;a=v[a+16>>2];if(a>>>0>b>>>0){v[d+8>>2]=a-b;c=v[Kb(d+12|0,d+8|0)>>2]}kb=d+16|0;return c|0}function Yba(a,b){a=a|0;b=b|0;a=Gc(a);t[a+534|0]=0;v[a+4>>2]=0;v[23540]=0;R(758,a|0,b|0);b=v[23540];v[23540]=0;if((b|0)!=1){return a|0}b=P()|0;O()|0;Gm(a);T(b|0);L()}function Ol(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;a:{c=pr(b);d=wl(a);if(c>>>0<=d>>>0){dB(a,Yh(sd(a),b,c),c);break a}e=a;a=Ad(v[a+4>>2],w[a+11|0]);rq(e,d,c-d|0,a,0,a,c,b)}}function Oga(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a:{d=Tb(a+8|0);v[23540]=0;U(244,a|0,b|0,c|0);a=v[23540];v[23540]=0;if((a|0)!=1){break a}a=P()|0;O()|0;ic(d);T(a|0);L()}}function I6(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=a;a=b+28|0;d=Ap(d,a);gK(a,c);v[23540]=0;R(70,b|0,1);a=v[23540];v[23540]=0;if((a|0)==1){a=P()|0;O()|0;ac(d);T(a|0);L()}}function BA(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=kb-16|0;kb=d;YS(b,c);if(Qb(v[a>>2],v[a+8>>2],c<<2)){XS(d+8|0,v[b>>2],v[b+4>>2]);ud(d,a,v[d+8>>2],v[d+12>>2])}kb=d+16|0}function vA(a,b){a=a|0;b=b|0;var c=0;if(y[a+4>>2]<y[Gb(a)>>2]){c=kb-16|0;kb=c;a=Ah(c,a,1);jq(v[a+4>>2],v[b>>2]);v[a+4>>2]=v[a+4>>2]+4;lc(a);kb=c+16|0;return}eA(a,b)}function u$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=a;h=b;a=ob[v[v[a+8>>2]+20>>2]](a+8|0)|0;b=Ac(a);return _j(g,h,c,d,e,f,b,b+(Hb(a)<<2)|0)|0}function nT(a,b,c){var d=0,e=0,f=0;d=kb-16|0;kb=d;b=jc(b);a=lh(a,vc(32),mh(d+8|0,b));b=v[a>>2]+16|0;u[b>>1]=x[v[c>>2]>>1];Nb(b+4|0);e=jc(a),f=1,t[e+4|0]=f;kb=d+16|0}function lX(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=kb-16|0;kb=d;v[d+12>>2]=c;c=0;a=v[a+8>>2];if(a>>>0>b>>>0){v[d+8>>2]=a-b;c=v[Kb(d+12|0,d+8|0)>>2]}kb=d+16|0;return c|0}function jja(a,b){a=a|0;b=b|0;var c=0;c=kb-16|0;kb=c;a:{if(!Qb(v[b>>2],v[b+8>>2],12)){u[c>>1]=0;GT(a,6,c);break a}Fq(c+8|0,a);ud(c,b,v[c+8>>2],v[c+12>>2])}kb=c+16|0}function W2(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;qx(a,b,c);a=v[a+16>>2];a:{if(!c){d=1;if((a|0)==(b|0)){break a}}d=0;if(a>>>0<=b>>>0){break a}d=a-b>>>0>=c>>>0}return d|0}function RD(a,b,c){var d=0,e=0;if(c>>>0<4294967280){a:{if(Cl(c)){ie(a,c);break a}d=nh(c)+1|0;e=vc(d);wd(a,e);ff(a,d);Hd(a,c);a=e}xd(He(a,b,c)+c|0,0);return}hf();L()}function LP(a){var b=0,c=0;a:{if(w[a|0]!=255){break a}b=w[a+1|0];if((b&224)!=224|(b&24)==8|!(b&6)){break a}a=w[a+2|0];if((a&12)==12){break a}c=(a&240)!=240}return c}function I1(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=kb-16|0;kb=e;a=bx(Ua(v[a+60>>2],b|0,c|0,d&255,e+8|0)|0);kb=e+16|0;nb=a?-1:v[e+12>>2];return(a?-1:v[e+8>>2])|0}function xH(a,b){var c=0,d=0,e=0,f=0;c=v[a+24>>2];if((c|0)==v[a+28>>2]){return e=a,f=Mf(b),d=v[v[a>>2]+52>>2],ob[d](e|0,f|0)|0}v[a+24>>2]=c+1;t[c|0]=b;return Mf(b)}function Xfa(a,b){a=a|0;b=b|0;var c=0;c=kb-16|0;kb=c;a:{if(!Qb(v[b>>2],v[b+8>>2],8)){u[c>>1]=0;GT(a,4,c);break a}cn(c+8|0,a);ud(c,b,v[c+8>>2],v[c+12>>2])}kb=c+16|0}function iQ(a){v[a>>2]=0;v[a+4>>2]=0;v[a+88>>2]=0;v[a+8>>2]=0;v[a+12>>2]=0;Pz(a+112|0,48e3);v[a+668>>2]=0;Oz(a+724|0);Oz(a+732|0);Oz(a+740|0);ug(a+788|0);return a}function _e(a,b){var c=0;c=v[a>>2];v[a>>2]=b;a:{if(c){a=v[jc(a)>>2];v[23540]=0;Y(a|0,c|0);a=v[23540];v[23540]=0;if((a|0)==1){break a}}return}V(0)|0;O()|0;Vb();L()}function Pfa(a,b){a=a|0;b=b|0;var c=0;c=kb-16|0;kb=c;a:{if(!Qb(v[b>>2],v[b+8>>2],5)){t[c|0]=0;di(a,5,c);break a}Go(c+8|0,a);ud(c,b,v[c+8>>2],v[c+12>>2])}kb=c+16|0}function Gja(a,b){a=a|0;b=b|0;var c=0;c=kb-16|0;kb=c;a:{if(!Qb(v[b>>2],v[b+8>>2],6)){t[c|0]=0;di(a,6,c);break a}rB(c+8|0,a);ud(c,b,v[c+8>>2],v[c+12>>2])}kb=c+16|0}function jca(a,b){a=a|0;b=b|0;a=Tb(a);t[a+16|0]=0;v[a+12>>2]=b;v[23540]=0;Y(752,a|0);b=v[23540];v[23540]=0;if((b|0)!=1){return a|0}b=P()|0;O()|0;Bz(a);T(b|0);L()}function fq(a){v[a+8>>2]=0;v[a+12>>2]=0;v[a>>2]=128;v[a+4>>2]=256;v[a+32>>2]=363;v[a+36>>2]=952;v[a+16>>2]=48e3;v[a+20>>2]=2;v[a+24>>2]=128;v[a+28>>2]=0;return a}function Um(a,b){a=a|0;b=b|0;var c=0;c=kb-16|0;kb=c;a:{if(!Qb(v[b>>2],v[b+8>>2],4)){t[c|0]=0;di(a,4,c);break a}Lh(c+8|0,a);ud(c,b,v[c+8>>2],v[c+12>>2])}kb=c+16|0}function Pl(a,b){a=a|0;b=b|0;var c=0;if(!kf(w[b+11|0])){c=v[b+4>>2];v[a>>2]=v[b>>2];v[a+4>>2]=c;v[a+8>>2]=v[b+8>>2];return a|0}GD(a,v[b>>2],v[b+4>>2]);return a|0}function Paa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=kb-16|0;kb=c;d=c,e=Fi(b),v[d+12>>2]=e;v[c+8>>2]=0;d=a,e=v[Jj(c+12|0,c+8|0,43888)>>2],v[d+36>>2]=e;Ip(a);kb=c+16|0}function MB(a){var b=0,c=0;a:{c=Eb(a,3);if((c|0)==(a|0)){break a}b=a;while(1){b=b+4|0;if((c|0)==(b|0)){break a}a=ro(v[b>>2],v[a>>2])?b:a;continue}}return v[a>>2]}function LD(a,b,c,d,e){var f=0;f=kb-16|0;kb=f;v[f+12>>2]=e;v[f+8>>2]=d;v[f+4>>2]=c;v[f>>2]=b;a=Cg(a,f);v[a+8>>2]=0;b=a+12|0;a=f+8|0;Cg(b,a);le(a);le(f);kb=f+16|0}function BY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=kb-16|0;kb=d;v[d+12>>2]=v[c>>2];a=ob[v[v[a>>2]+16>>2]](a,b,d+12|0)|0;if(a){v[c>>2]=v[d+12>>2]}kb=d+16|0;return a|0}function uq(a){var b=0,c=0,d=0,e=0;b=v[a+4>>2];c=v[b>>2];v[a+4>>2]=c;if(c){lm(c,a)}v[b+8>>2]=v[a+8>>2];d=v[a+8>>2]+(Ch(a)?0:4)|0,e=b,v[d>>2]=e;v[b>>2]=a;lm(a,b)}function tq(a){var b=0,c=0,d=0,e=0;b=v[a>>2];c=v[b+4>>2];v[a>>2]=c;if(c){lm(c,a)}v[b+8>>2]=v[a+8>>2];d=v[a+8>>2]+(Ch(a)?0:4)|0,e=b,v[d>>2]=e;v[b+4>>2]=a;lm(a,b)}function fga(a,b){a=a|0;b=b|0;var c=0,d=0;d=kb-80|0;kb=d;c=-1;a:{if(!eV(a,d+8|0)){break a}c=0;if(!KR(d+8|0)){break a}c=Ae(a,b,JR(d+8|0),nb)}kb=d+80|0;return c|0}function fB(a){var b=0,c=0;b=kb-16|0;kb=b;u[b+14>>1]=a;Ef(b+14|0,4095);a=x[b+14>>1];c=$T(oi(+((a&255)>>>0)*.00390625)*32768);kb=b+16|0;return c>>>15-(a>>>8|0)|0}function Ri(a,b,c,d,e){a:{e=Zs(e);if(e){v[23540]=0;fa(d|0,e|0,a|0,b|0,c|0)|0;a=v[23540];v[23540]=0;if((a|0)==1){break a}}return e}a=P()|0;O()|0;Mb(e);T(a|0);L()}function QM(a){var b=0,c=0,d=0;b=v[a+112>>2];if((b|0)>=11){c=378;while(1){if(c|d){PM(a);b=c;c=b-1|0;d=d-!b|0;continue}break}b=0}v[a+112>>2]=b+1;a=PM(a);return a}function OP(a,b){var c=0;c=v[a+4>>2];a:{if((b|0)>=0){b=b+c|0;c=v[a>>2]+(b>>>3&536870908)|0;break a}b=b+c|0;c=v[a>>2]+((b-31|0)/32<<2)|0}v[a>>2]=c;v[a+4>>2]=b&31}function os(a){var b=0;a:{if(($e(a)|0)!=79){break a}if(($e(a)|0)!=103){break a}if(($e(a)|0)!=103){break a}b=($e(a)|0)==83}if(!b){ec(a,30);return 0}return lI(a)}function cv(a,b){a=a|0;b=b|0;var c=0;c=kb-16|0;kb=c;a:{if(!Qb(v[b>>2],v[b+8>>2],2)){t[c|0]=0;tC(a,c);break a}Ym(c+8|0,a);ud(c,b,v[c+8>>2],v[c+12>>2])}kb=c+16|0}function aJ(a,b){var c=0,d=0;d=a+4|0;c=fd(v[d>>2],v[a+8>>2]);a=v[a+16>>2]+b|0;if(c>>>0<a>>>0){a:{if(c){b=ch(c);if(a>>>0<=b>>>0){break a}}b=bJ(a,65536)}Qi(d,b)}}function A$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=a;h=b;a=ob[v[v[a+8>>2]+20>>2]](a+8|0)|0;b=Mc(a);return $j(g,h,c,d,e,f,b,Hb(a)+b|0)|0}function pk(a,b){var c=0;c=kb-32|0;kb=c;v[c+24>>2]=0;Uv(c+8|0,c+24|0);yn(c+16|0,a,v[c+8>>2],v[c+12>>2]);a=v[c+20>>2];Zl(b,v[c+24>>2]);kb=c+32|0;return(a|0)==4}function lC(a,b){a=a|0;b=b|0;var c=0,d=0;c=kb-16|0;kb=c;v[c+12>>2]=-1;if(zg(a,c+8|0)){v[c+4>>2]=w[c+8|0];d=eC(a,b,v[Kb(c+4|0,c+12|0)>>2])}kb=c+16|0;return d|0}function g9(a){a=a|0;var b=0,c=0,d=0;b=kb-16|0;kb=b;pL(b+8|0,a,0);c=v[b+12>>2];if(c){a=v[a+20>>2];v[a+148>>2]=-1;d=a+4|0;a=v[b+8>>2];uy(d,a,Lb(a,c))}kb=b+16|0}function Yd(a,b){var c=0,d=0,e=C(0);c=kb-16|0;kb=c;v[c+8>>2]=1065353216;z[c+12>>2]=b;d=c,e=Jf(a),z[d+4>>2]=e;a=z[gu(c+4|0,c+12|0,c+8|0)>>2];kb=c+16|0;return a}function VJ(a,b){var c=0;c=v[b+4>>2];v[a>>2]=v[b>>2];v[a+4>>2]=c;c=v[b+20>>2];v[a+16>>2]=v[b+16>>2];v[a+20>>2]=c;c=v[b+12>>2];v[a+8>>2]=v[b+8>>2];v[a+12>>2]=c}function Jm(a){var b=0;b=2147483647;a:{if(a>=2147483647){break a}b=-2147483648;if(a<=-2147483648){break a}if(D(a)<2147483648){return~~a}b=-2147483648}return b}function FU(a){var b=0;if(!(Sb(a,17882,8)|w[a+8|0]>1|((w[a+9|0]-1&255)>>>0>7|(w[a+10|0]|w[a+11|0]<<8)>>>0>4096))){b=(w[a+12|0]|w[a+13|0]<<8)>>>0<4097}return b}function ET(a,b){var c=0;c=Jka(b&65535,0,384,0);b=a&65535;a=b>>>30|0;b=b<<2;c=c+b|0;a=a+nb|0;a=b>>>0>c>>>0?a+1|0:a;b=c+256|0;a=b>>>0<256?a+1|0:a;nb=a;return b}function $V(a,b){a=a|0;b=b|0;var c=0,d=0;c=kb-16|0;kb=c;v[c+12>>2]=-1;if(zg(a,c+8|0)){v[c+4>>2]=w[c+8|0];d=hC(a,b,v[Kb(c+4|0,c+12|0)>>2])}kb=c+16|0;return d|0}function wD(a){var b=0;if(!(Sb(a,15561,4)|(w[a+4|0]-16&255)>>>0<249|((w[a+5|0]-16&255)>>>0<249|(w[a+6|0]-16&255)>>>0<249))){b=(w[a+7|0]-9&255)>>>0<7}return b}function p0(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=0;while(1){if((b|0)!=(c|0)){a=v[b>>2]+(a<<4)|0;d=a&-268435456;a=(d|d>>>24)^a;b=b+4|0;continue}break}return a|0}function oB(a,b,c,d){var e=0,f=0;pg(a+12|0,d);if(b){d=wC(b)}else{d=0}v[a>>2]=d;c=d+B(c,20)|0;v[a+8>>2]=c;v[a+4>>2]=c;e=Cc(a),f=d+B(b,20)|0,v[e>>2]=f;return a}function md(a,b,c,d){var e=0,f=0,g=0;e=kb-16|0;kb=e;f=v[b+12>>2];v[e+8>>2]=c;v[e+12>>2]=d;g=v[v[b>>2]+28>>2];v[e>>2]=c;v[e+4>>2]=d;ob[g|0](a,b,f,e);kb=e+16|0}function Sz(a){var b=0;a=ve(a);b=32767;a:{if(a>=32767){break a}b=32768;if(a<=-32768){break a}b=~~a;if(D(a)<2147483648){break a}b=-2147483648}return b<<16>>16}function Ik(a,b,c,d){var e=0,f=0;pg(a+12|0,d);if(b){d=gE(b)}else{d=0}v[a>>2]=d;c=d+B(c,12)|0;v[a+8>>2]=c;v[a+4>>2]=c;e=Cc(a),f=d+B(b,12)|0,v[e>>2]=f;return a}function EK(a){a=a|0;var b=0;v[a+4240>>2]=0;v[a+4244>>2]=0;b=a+4264|0;v[b>>2]=0;v[b+4>>2]=0;b=a+4256|0;v[b>>2]=0;v[b+4>>2]=0;a=a+4248|0;v[a>>2]=0;v[a+4>>2]=0}function t0(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=0;while(1){if((b|0)!=(c|0)){a=t[b|0]+(a<<4)|0;d=a&-268435456;a=(d|d>>>24)^a;b=b+1|0;continue}break}return a|0}function fw(a,b,c,d){var e=0;e=ba(8)|0;v[23540]=0;a=Q(d|0,e|0,a|0)|0;d=v[23540];v[23540]=0;if((d|0)!=1){ha(a|0,c|0,b|0);L()}a=P()|0;O()|0;ca(e|0);T(a|0);L()}function U3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;while(1){if((a|0)!=(b|0)){d=v[c>>2];v[d>>2]=v[a>>2];Bh(d+4|0,a+4|0);v[c>>2]=v[c>>2]+16;a=a+16|0;continue}break}}function PL(a,b){var c=0;c=kb-16|0;kb=c;a=Xm(c,a+8|0,b);b=v[a>>2];while(1){if((b|0)!=v[a+4>>2]){PP(b);b=v[a>>2]+4|0;v[a>>2]=b;continue}break}Ud(a);kb=c+16|0}function FR(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=kb-16|0;kb=d;while(1){if((b|0)==(c|0)){kb=d+16|0}else{v[d+12>>2]=v[b>>2];vA(a,d+12|0);b=b+4|0;continue}break}}function Cea(a,b){a=a|0;b=b|0;var c=0,d=0;d=kb-48|0;kb=d;c=-1;a:{if(!UQ(a,d)){break a}c=0;if(!$P(d)){break a}c=Ae(a,b,_P(w[d+47|0]),nb)}kb=d+48|0;return c|0}function $b(a,b){a=a|0;b=b|0;var c=0;c=Qb(v[a>>2],v[a+8>>2],b);a:{if(c){b=v[a+8>>2]+b|0;break a}b=v[a>>2];b=ob[v[v[b>>2]+24>>2]](b)|0}v[a+8>>2]=b;return c|0}function vc(a){a=a|0;var b=0;a=a?a:1;a:{while(1){b=Pd(a);if(b){break a}b=v[117481];if(b){ob[b|0]();continue}break}ha(mm(ba(4)|0)|0,92756,26);L()}return b|0}function nr(a,b,c,d){var e=0,f=0;pg(a+12|0,d);if(b){d=FD(b)}else{d=0}v[a>>2]=d;c=d+(c<<3)|0;v[a+8>>2]=c;v[a+4>>2]=c;e=Cc(a),f=d+(b<<3)|0,v[e>>2]=f;return a}function iT(a,b,c,d){var e=0,f=0;pg(a+12|0,d);if(b){d=eT(b)}else{d=0}v[a>>2]=d;c=d+B(c,6)|0;v[a+8>>2]=c;v[a+4>>2]=c;e=Cc(a),f=d+B(b,6)|0,v[e>>2]=f;return a}function fQ(a,b,c,d){var e=0,f=0;pg(a+12|0,d);if(b){d=eQ(b)}else{d=0}v[a>>2]=d;c=d+(c<<4)|0;v[a+8>>2]=c;v[a+4>>2]=c;e=Cc(a),f=d+(b<<4)|0,v[e>>2]=f;return a}function fA(a,b,c){var d=0;d=kb-16|0;kb=d;v[d+8>>2]=a;c=c&65535;while(1){if(!(!Pb(a,b)|(c|0)==x[a>>1])){a=v[Se(d+8|0)>>2];continue}break}kb=d+16|0;return a}function ct(a,b){var c=0,d=0,e=C(0);c=kb-16|0;kb=c;z[c+12>>2]=b;v[c+8>>2]=0;v[c+4>>2]=1065353216;d=a,e=z[gu(c+12|0,c+8|0,c+4|0)>>2],z[d+144>>2]=e;kb=c+16|0}function XM(){var a=0,b=0,c=0,d=0;a=kb-16|0;kb=a;b=a+8|0;while(1){if(c>>>0<32){c=c+48|0;d=yy(94200);continue}break}v[b>>2]=d;Un(b);kb=a+16|0;return v[b>>2]}function Nj(a,b,c,d){var e=0,f=0;pg(a+12|0,d);if(b){d=cD(b)}else{d=0}v[a>>2]=d;c=d+(c<<1)|0;v[a+8>>2]=c;v[a+4>>2]=c;e=Cc(a),f=d+(b<<1)|0,v[e>>2]=f;return a}function Ct(a,b,c,d){var e=0,f=0;pg(a+12|0,d);if(b){d=aQ(b)}else{d=0}v[a>>2]=d;c=d+(c<<5)|0;v[a+8>>2]=c;v[a+4>>2]=c;e=Cc(a),f=d+(b<<5)|0,v[e>>2]=f;return a}function vV(a,b,c){var d=0;b=b-a>>2;while(1){if((b|0)>0){d=v[c>>2];t[a|0]=d;t[a+1|0]=d>>>8;t[a+2|0]=d>>>16;t[a+3|0]=d>>>24;b=b-1|0;a=a+4|0;continue}break}}function vD(a,b){a=a|0;b=b|0;var c=0,d=0;c=a;a=v[b>>2];d=(ob[v[v[a>>2]+20>>2]](a)|0)+v[b+8>>2]|0;a=v[b>>2];hc(c,d,(ob[v[v[a>>2]+24>>2]](a)|0)-v[b+8>>2]|0)}function lj(a,b,c,d){var e=0;e=v[b+4>>2];v[a>>2]=v[b>>2];v[a+4>>2]=e;e=v[b+12>>2];v[a+8>>2]=v[b+8>>2];v[a+12>>2]=e;A[a>>3]=A[a>>3]-c;A[a+8>>3]=A[a+8>>3]-d}function ii(a){var b=0,c=0;b=a*a;c=b*a;return C(c*(b*b)*(b*2718311493989822e-21+-.00019839334836096632)+(c*(b*.008333329385889463+-.16666666641626524)+a))}function _W(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=v[a+16>>2];a:{if(!c){d=1;if((a|0)==(b|0)){break a}}d=0;if(a>>>0<=b>>>0){break a}d=a-b>>>0>=c>>>0}return d|0}function Bp(a,b){var c=0,d=0;a:{if(!a){break a}c=Jka(a,0,b,0);d=nb;if((a|b)>>>0<65536){break a}c=d?-1:c}a=Pd(c);if(!(!a|!(w[a-4|0]&3))){Ub(a,0,c)}return a}function A2(a,b,c){a=a|0;b=b|0;c=c|0;a:{a=Bh(a,b);v[23540]=0;Q(54,a+12|0,c|0)|0;b=v[23540];v[23540]=0;if((b|0)!=1){break a}b=P()|0;O()|0;zb(a);T(b|0);L()}}function mX(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=v[a+8>>2];a:{if(!c){d=1;if((a|0)==(b|0)){break a}}d=0;if(a>>>0<=b>>>0){break a}d=a-b>>>0>=c>>>0}return d|0}function lx(a,b){var c=0;while(1){c=(b|0)<120?b:120;a=C(a*C(z[((c&3)<<2)+65872>>2]*C(1073741824>>>(c>>2)|0)));b=b-c|0;if((b|0)>0){continue}break}return a}function Bh(a,b){a=a|0;b=b|0;var c=0;if(!ef(b)){c=v[b+4>>2];v[a>>2]=v[b>>2];v[a+4>>2]=c;v[a+8>>2]=v[b+8>>2];return a|0}GD(a,v[b>>2],v[b+4>>2]);return a|0}function n7(a){a=a|0;var b=0,c=C(0);t[a+4202|0]=1;b=a,c=bz(C(C(C(C(y[v[a+16>>2]+24620>>2])/C(3))+C(-80))/C(15920)),C(0),C(1)),z[b+4272>>2]=c;GK(a);EK(a)}function Kg(a){var b=0,c=0;b=v[a>>2];c=v[b+4>>2];a:{if(!c){while(1){if(!Ch(b)){b=v[b+8>>2];continue}break}b=v[b+8>>2];break a}b=KT(c)}v[a>>2]=b;return a}function Hn(a,b){var c=0,d=0;b=b+7&-8;d=v[a+80>>2];a:{if(d){b=v[a+92>>2]-b|0;c=0;if((b|0)<v[a+88>>2]){break a}v[a+92>>2]=b;return b+d|0}c=Pd(b)}return c}function zQ(a,b){var c=0,d=0,e=0;ou(a);v[a>>2]=v[b>>2];v[a+4>>2]=v[b+4>>2];c=Gb(b);d=Gb(a),e=v[c>>2],v[d>>2]=e;v[c>>2]=0;v[b>>2]=0;v[b+4>>2]=0;return a}function yD(a){a=a|0;var b=0;a=Nb(a);v[23540]=0;S(174,a+12|0)|0;b=v[23540];v[23540]=0;if((b|0)!=1){Gc(a+32|0);return a|0}b=P()|0;O()|0;Ab(a);T(b|0);L()}function vx(a){var b=0,c=0;if(v[a>>2]){c=v[a>>2];b=v[a+4>>2];while(1){if((b|0)!=(c|0)){b=b-16|0;Cs(b);continue}break}v[a+4>>2]=c;b=v[a>>2];Lt(a);Mb(b)}}function sS(a){var b=0,c=0;if(v[a>>2]){c=v[a>>2];b=v[a+4>>2];while(1){if((b|0)!=(c|0)){b=b-24|0;Bb(b);continue}break}v[a+4>>2]=c;b=v[a>>2];Br(a);Mb(b)}}function sR(a){var b=0,c=0;if(v[a>>2]){c=v[a>>2];b=v[a+4>>2];while(1){if((b|0)!=(c|0)){b=b-56|0;St(b);continue}break}v[a+4>>2]=c;b=v[a>>2];qR(a);Mb(b)}}function hZ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;while(1){if((b|0)!=(c|0)){a=v[b>>2];t[e|0]=a>>>0<128?a:d;e=e+1|0;b=b+4|0;continue}break}return c|0}function dd(a,b){a=a|0;b=b|0;var c=0,d=0;a:{if(y[a+8>>2]<b>>>0){d=v[a>>2];c=0;if(ob[v[v[d>>2]+24>>2]](d)>>>0<b>>>0){break a}}v[a+8>>2]=b;c=1}return c|0}function Xe(a){var b=0,c=0;if(v[a>>2]){c=v[a>>2];b=v[a+4>>2];while(1){if((b|0)!=(c|0)){b=b-12|0;Xb(b);continue}break}v[a+4>>2]=c;b=v[a>>2];Xj(a);Mb(b)}}function Ql(a){var b=0,c=0;if(v[a>>2]){c=v[a>>2];b=v[a+4>>2];while(1){if((b|0)!=(c|0)){b=b-12|0;dc(b);continue}break}v[a+4>>2]=c;b=v[a>>2];Xj(a);Mb(b)}}function Lm(a,b){var c=0,d=0,e=0;uB(a);v[a>>2]=v[b>>2];v[a+4>>2]=v[b+4>>2];c=Gb(b);d=Gb(a),e=v[c>>2],v[d>>2]=e;v[c>>2]=0;v[b>>2]=0;v[b+4>>2]=0;return a}function L0(a,b){a=a|0;b=b|0;var c=0,d=0;b=Iw(b);v[a+36>>2]=b;c=a,d=Vg(b),v[c+44>>2]=d;c=a,d=Bn(v[a+36>>2]),t[c+53|0]=d;if(v[a+44>>2]>=9){Yr(5566);L()}}function K9(a){a=a|0;var b=0;b=kb-16|0;kb=b;Sc(b,a+32|0,4);if(!Cb(v[v[b>>2]>>2],v[b+4>>2])){Xv(a)}a=v[fc(b+8|0,Fb(v[a+52>>2]))>>2];kb=b+16|0;return a|0}function J9(a){a=a|0;var b=0;b=kb-16|0;kb=b;Sc(b,a+32|0,4);if(!Cb(v[v[b>>2]>>2],v[b+4>>2])){Xv(a)}a=v[fc(b+8|0,Fb(v[a+56>>2]))>>2];kb=b+16|0;return a|0}function FG(a,b,c){var d=0;d=kb-32|0;kb=d;v[d+28>>2]=c;v[d+24>>2]=0;v[d+12>>2]=4;sw(d+16|0,a,d+24|0,v[Kb(d+28|0,d+12|0)>>2]);Zl(b,v[d+24>>2]);kb=d+32|0}function D0(a,b){a=a|0;b=b|0;var c=0,d=0;b=Nw(b);v[a+36>>2]=b;c=a,d=Vg(b),v[c+44>>2]=d;c=a,d=Bn(v[a+36>>2]),t[c+53|0]=d;if(v[a+44>>2]>=9){Yr(5566);L()}}function lU(a,b){var c=0;c=Jka(b&255,0,9,0);b=a&255;a=b>>>31|0;b=b<<1;c=c+b|0;a=a+nb|0;a=b>>>0>c>>>0?a+1|0:a;b=c+11|0;a=b>>>0<11?a+1|0:a;nb=a;return b}function lT(a,b,c){var d=0;d=kb-32|0;kb=d;v[d+28>>2]=c;t[d+24|0]=0;v[d+12>>2]=1;sw(d+16|0,a,d+24|0,v[Kb(d+28|0,d+12|0)>>2]);t[b|0]=w[d+24|0];kb=d+32|0}function Sp(a,b,c){var d=0;a:{if(b&134218752){break a}if(!oj(c)){break a}b=w[c+34|0];if((b+5&255)>>>0<6){break a}d=v[Md(a+906300|0,b-1|0)>>2]}return d}function M4(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;h=kb-32|0;kb=h;i=h+8|0;YI(i,b,c,d,e,f,g);ad(a,h+20|0);wm(i);kb=h+32|0}function Ln(a,b){v[a+20>>2]=0;v[a+24>>2]=b;v[a+12>>2]=0;v[a+4>>2]=4098;v[a+8>>2]=6;v[a+16>>2]=!b;Ub(a+32|0,0,40);DH(a+28|0);v[a+72>>2]=0;v[a+76>>2]=-1}function yv(a,b){var c=0;c=kb-16|0;kb=c;a:{if(!Qb(v[b>>2],v[b+8>>2],3)){t[c|0]=0;di(a,3,c);break a}xv(c+8|0,a);ud(c,b,v[c+8>>2],v[c+12>>2])}kb=c+16|0}function nE(a){v[a>>2]=0;v[a+4>>2]=0;v[a+16>>2]=0;v[a+20>>2]=0;v[a+8>>2]=0;v[a+12>>2]=0;u[a+20>>1]=0;v[a+16>>2]=-1;v[a+8>>2]=0;v[a+12>>2]=0;v[a>>2]=0}function SN(a,b,c){var d=0,e=0;v[b+56>>2]=0;d=b,e=Xn(a,x[b+70>>1],v[b+48>>2],c,0),u[d+68>>1]=e;if(!(!(w[a+480180|0]&5)|v[b+60>>2]==-1)){v[b+60>>2]=0}}function ufa(a,b){a=a|0;b=b|0;var c=0,d=0;d=kb-96|0;kb=d;c=-1;a:{if(!AR(a,d)){break a}c=0;if(!eR(d)){break a}c=Ae(a,b,dR(d),nb)}kb=d+96|0;return c|0}function sv(a,b,c,d,e){var f=0;while(1){if((d|0)!=(f|0)){z[b>>2]=C(v[a>>2])*e;z[c>>2]=C(v[a+4>>2])*e;f=f+1|0;c=c+4|0;a=a+8|0;b=b+4|0;continue}break}}function Tfa(a,b){a=a|0;b=b|0;var c=0,d=0;d=kb-96|0;kb=d;c=-1;a:{if(!AR(a,d)){break a}c=0;if(!zR(d)){break a}c=Ae(a,b,yR(d),nb)}kb=d+96|0;return c|0}function $f(a){var b=0,c=0;b=kb-16|0;kb=b;a:{if(ef(a)){c=v[a>>2];t[b+15|0]=0;we(c,b+15|0);Hd(a,0);break a}t[b+14|0]=0;we(a,b+14|0);ie(a,0)}kb=b+16|0}function $Y(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;while(1){if((b|0)!=(c|0)){a=t[b|0];t[e|0]=(a|0)<0?d:a;e=e+1|0;b=b+1|0;continue}break}return c|0}function yz(a){var b=0,c=0;c=v[a+4>>2];while(1){b=v[a+8>>2];if((b|0)!=(c|0)){b=b-32|0;v[a+8>>2]=b;ql(b);continue}break}c=v[a>>2];if(c){bp(a);Mb(c)}}function uu(a){var b=0,c=0;c=v[a+4>>2];while(1){b=v[a+8>>2];if((b|0)!=(c|0)){b=b-20|0;v[a+8>>2]=b;Bb(b);continue}break}c=v[a>>2];if(c){Cc(a);Mb(c)}}function tK(a,b){a=a|0;b=b|0;var c=0,d=0;d=kb-16|0;kb=d;c=YJ(vc(12));v[c+8>>2]=b;v[c+4>>2]=a;v[c>>2]=49084;a=v[Lf(d+8|0,c)>>2];kb=d+16|0;return a|0}function pR(a){var b=0,c=0;c=v[a+4>>2];while(1){b=v[a+8>>2];if((b|0)!=(c|0)){b=b-56|0;v[a+8>>2]=b;St(b);continue}break}c=v[a>>2];if(c){Cc(a);Mb(c)}}function jV(a){var b=0,c=0;c=v[a+4>>2];while(1){b=v[a+8>>2];if((b|0)!=(c|0)){b=b-28|0;v[a+8>>2]=b;Bd(b);continue}break}c=v[a>>2];if(c){Cc(a);Mb(c)}}function gO(a){var b=0,c=0;c=v[a+4>>2];while(1){b=v[a+8>>2];if((b|0)!=(c|0)){b=b-12|0;v[a+8>>2]=b;Xb(b);continue}break}c=v[a>>2];if(c){bp(a);Mb(c)}}function SL(a){var b=0,c=0;c=v[a+4>>2];while(1){b=v[a+8>>2];if((b|0)!=(c|0)){b=b-52|0;v[a+8>>2]=b;gl(b);continue}break}c=v[a>>2];if(c){Cc(a);Mb(c)}}function Rv(a){var b=0,c=0;c=v[a+4>>2];while(1){b=v[a+8>>2];if((b|0)!=(c|0)){b=b-12|0;v[a+8>>2]=b;dc(b);continue}break}c=v[a>>2];if(c){bp(a);Mb(c)}}function MK(a){var b=0;b=y[v[a+16>>2]+24620>>2]/(wj(C(z[a+4208>>2]*C(999)))+1>>>0)|0;b=b>>>0>2?b:2;v[a+4216>>2]=b;v[a+4220>>2]=b>>>1;xc(a+4224|0,b)}function KY(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;if(Zg(a,v[b+8>>2],f)){nw(b,c,d,e);return}a=v[a+8>>2];ob[v[v[a>>2]+20>>2]](a,b,c,d,e,f)}function GM(a){if(w[a+480224|0]==2){return+y[a+1074420>>2]/1e4}return+y[a+24620>>2]/(+y[a+1074404>>2]*+(B(v[a+1074408>>2],v[a+1074416>>2])>>>0))*60}function Bv(a){var b=0,c=0;c=v[a+4>>2];while(1){b=v[a+8>>2];if((b|0)!=(c|0)){b=b-36|0;v[a+8>>2]=b;jr(b);continue}break}c=v[a>>2];if(c){Cc(a);Mb(c)}}function wp(a,b){var c=0;a:{if(!sI(b)|(w[b+1|0]^w[a+1|0])>>>0>1){break a}b=w[b+2|0];a=w[a+2|0];if((b^a)&12){break a}c=!(b&240)^(a&240)!=0}return c}function uz(a,b,c){var d=0,e=0,f=0;d=pl(a,b);if((d|0)!=255){e=cc(a+26|0,d),f=c,u[e>>1]=f;a=a+62|0;e=Lb(a,b),f=255,t[e|0]=f;e=Lb(a,c),f=d,t[e|0]=f}}function sF(a){var b=0,c=0;c=a>>>23&255;b=0;a:{if(c>>>0<127){break a}b=2;if(c>>>0>150){break a}c=1<<150-c;b=0;if(c-1&a){break a}b=a&c?1:2}return b}function ay(a,b,c,d){var e=0;e=kb-16|0;kb=e;a=Iq(e,a,d);c=c-b|0;if((c|0)>0){sc(v[a+4>>2],b,c);v[a+4>>2]=v[a+4>>2]+B((c>>>0)/6|0,6)}lc(a);kb=e+16|0}function Ye(a,b){var c=0;c=kb-16|0;kb=c;a:{if(!b){Sc(c+8|0,a+32|0,5);if(Cb(v[v[c+8>>2]>>2],v[c+12>>2])){break a}}v[a+28>>2]=v[a+28>>2]+1}kb=c+16|0}function UO(a){var b=0,c=0,d=0;d=w[a+26|0];b=d+27|0;while(1){if((c|0)==(d|0)){a=b&65535}else{b=w[(a+c|0)+27|0]+b|0;c=c+1|0;continue}break}return a}function R0(a,b){a=a|0;b=b|0;var c=0,d=0;c=v[a+40>>2];while(1){if(c){c=c-1|0;d=c<<2;ob[v[v[a+32>>2]+d>>2]](b,a,v[d+v[a+36>>2]>>2]);continue}break}}function Lka(a,b,c){var d=0;d=b>>31;a=a^d;Hka(a-d|0,(b^d)-((a>>>0<d>>>0)+d|0)|0,c,0);nb=mb;a=d^lb;b=a-d|0;nb=(d^nb)-((a>>>0<d>>>0)+d|0)|0;return b}function JU(a){t[a+8|0]=0;t[a+9|0]=0;t[a+10|0]=0;t[a+11|0]=0;t[a|0]=0;t[a+1|0]=0;t[a+2|0]=0;t[a+3|0]=0;t[a+4|0]=0;t[a+5|0]=0;t[a+6|0]=0;t[a+7|0]=0}function mC(a){t[a|0]=0;t[a+1|0]=0;t[a+2|0]=0;t[a+3|0]=0;t[a+4|0]=0;t[a+5|0]=0;t[a+6|0]=0;t[a+7|0]=0;t[a+7|0]=0;t[a+8|0]=0;t[a+9|0]=0;t[a+10|0]=0}function L7(a,b,c){a=a|0;b=b|0;c=C(c);var d=0,e=0,f=C(0);if(b>>>0<=1){c=Yd(c,C(0));if((b|0)==1){d=1;c=Xh(c)}e=Eb(a+4208|0,d),f=c,z[e>>2]=f;MK(a)}}function K5(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;h=kb-32|0;kb=h;i=h+8|0;YI(i,b,c,d,e,f,g);ad(a,i);wm(i);kb=h+32|0}function V9(a,b){a=a|0;b=b|0;var c=0,d=0;c=kb-32|0;kb=c;u[c+24>>1]=b;b=c+24|0;Ym(c+16|0,b);d=v[c+16>>2];Ym(c+8|0,b);Lk(a,d,v[c+12>>2]);kb=c+32|0}function Lw(a){var b=0,c=0;b=kb-16|0;kb=b;c=-1;a:{if(Xw(a)){break a}if((ob[v[a+32>>2]](a,b+15|0,1)|0)!=1){break a}c=w[b+15|0]}kb=b+16|0;return c}function IL(a){var b=0;b=kb-16|0;kb=b;z[b+12>>2]=D(a);v[b+8>>2]=646978941;v[b+4>>2]=1259902592;a=z[gu(b+12|0,b+8|0,b+4|0)>>2];kb=b+16|0;return a}function DH(a){var b=0,c=0;v[23540]=0;c=ga(1092)|0;b=v[23540];v[23540]=0;if((b|0)!=1){b=a;a=v[c>>2];v[b>>2]=a;dn(a);return}V(0)|0;O()|0;Vb();L()}function $ba(a,b){a=a|0;b=b|0;var c=0,d=0;c=kb-32|0;kb=c;t[c+24|0]=b;b=c+24|0;Zq(c+16|0,b);d=v[c+16>>2];Zq(c+8|0,b);Lk(a,d,v[c+12>>2]);kb=c+32|0}function wk(a,b,c,d){var e=0;e=B(b,c);a:{if(v[d+76>>2]<0){a=QB(a,e,d);break a}a=QB(a,e,d)}if((e|0)==(a|0)){return b?c:0}return(a>>>0)/(b>>>0)|0}function fj(a,b,c){if(a>>>0<b>>>0){sc(a,b,c);return}if(c){a=a+c|0;b=b+c|0;while(1){a=a-1|0;b=b-1|0;t[a|0]=w[b|0];c=c-1|0;if(c){continue}break}}}function _9(a,b){a=a|0;b=b|0;var c=0;v[a>>2]=0;v[a+4>>2]=0;Gc(a+8|0);c=uc(v[b>>2],v[b+4>>2]);if(c){Bk(a,c);wA(a,v[b>>2],v[b+4>>2],c)}return a|0}function Yz(a,b){a=a|0;b=b|0;var c=0;v[a>>2]=0;v[a+4>>2]=0;Gc(a+8|0);c=fd(v[b>>2],v[b+4>>2]);if(c){Ll(a,c);ku(a,v[b>>2],v[b+4>>2],c)}return a|0}function T6(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;if(!b){Bx(a,0,0,0,0,0,0,c,d);return}Bx(a,v[b>>2],v[b+4>>2],v[b+8>>2],v[b+12>>2],v[b+24>>2],b,c,d)}
function LN(a,b){t[a+840|0]=b;t[a+812|0]=b;t[a+811|0]=b;t[a+809|0]=b;t[a+807|0]=b;t[a+806|0]=b;t[a+833|0]=b;t[a+826|0]=b>>>4;t[a+827|0]=b<<2&60}function yS(a){var b=0;if(!(Sb(a,15059,3)|(w[a+4|0]|w[a+5|0]<<8|(w[a+6|0]<<16|w[a+7|0]<<24))-2147483647>>>0<2147484072)){b=w[a+3|0]<6}return b}function nga(a,b){a=a|0;b=b|0;a:{if(a>>>0>=515){a=Bg(b);Bg(b);break a}a=Rg(b);Rg(b)}while(1){if(a){if(a&1){$b(b,260)}a=a>>>1|0;continue}break}}function nc(a,b,c,d,e){var f=0,g=0;f=kb-16|0;kb=f;v[f+8>>2]=d;v[f+12>>2]=e;g=v[v[b>>2]+28>>2];v[f>>2]=d;v[f+4>>2]=e;ob[g|0](a,b,c,f);kb=f+16|0}function mj(a){var b=0,c=0;b=kb-16|0;kb=b;Db(b+8|0,a+1074312|0,7);if(Cb(v[v[b+8>>2]>>2],v[b+12>>2])){c=Km(v[a+480180>>2])^1}kb=b+16|0;return c}function jz(a){var b=0,c=0;b=kb-16|0;kb=b;v[b+8>>2]=a;c=b+8|0;a=1;while(1){if((a|0)>0){Kg(c);a=a-1|0;continue}break}kb=b+16|0;return v[b+8>>2]}function aR(a,b,c,d){var e=0;e=c&4;a:{b:{if(!(e|(b&255)!=4)){if(c&2){break b}Zc(a,8,1,0,10);return}b=16;if(e){break a}}b=8}Zc(a,b,c&2|1,0,d^1)}function aI(a,b,c,d,e,f){var g=0,h=0;g=v[a+32>>2];if(!w[a+23|0]){v[(c<<2)+g>>2]=b;return}h=g;g=d<<2;v[h+g>>2]=b;t[v[a+8>>2]+d|0]=e;v[f+g>>2]=c}function Wf(a,b){a=a|0;b=b|0;var c=0;c=kb-32|0;kb=c;u[c+24>>1]=0;Yj(c+8|0,c+24|0);yn(c+16|0,a,v[c+8>>2],v[c+12>>2]);Kj(b,x[c+24>>1]);kb=c+32|0}function Sl(a,b){var c=0,d=0;d=v[a+4>>2];c=v[a+8>>2];while(1){if((c|0)!=(d|0)){c=c-b|0;v[a+8>>2]=c;continue}break}b=v[a>>2];if(b){Cc(a);Mb(b)}}function Aka(a,b){a=a|0;b=b|0;var c=0;c=kb-16|0;kb=c;v[c+12>>2]=-1;if(zg(a,c+8|0)){v[c+4>>2]=w[c+8|0];tV(a,b,v[Kb(c+4|0,c+12|0)>>2])}kb=c+16|0}function rt(a,b){var c=0,d=0;d=Af(a,b);while(1){a:{c=d;if(!(c&65535)){c=0;break a}d=c-1|0;if(!xe(a,b,d&65535)){continue}}break}return c&65535}function hi(a){var b=0;a=a*a;b=a*a;return C(a*b*(a*2439044879627741e-20+-.001388676377460993)+(b*.04166662332373906+(a*-.499999997251031+1)))}function eW(a,b){a=a|0;b=b|0;var c=0;c=kb-16|0;kb=c;v[c+12>>2]=-1;if(zg(a,c+8|0)){v[c+4>>2]=w[c+8|0];jC(a,b,v[Kb(c+4|0,c+12|0)>>2])}kb=c+16|0}function dQ(a){var b=0,c=0;c=v[a+4>>2];b=v[a+8>>2];while(1){if((b|0)!=(c|0)){b=b-32|0;v[a+8>>2]=b;continue}break}b=v[a>>2];if(b){bp(a);Mb(b)}}function bn(a,b){var c=0;a=fn(a);v[a>>2]=62332;c=v[b+8>>2];v[a+4>>2]=v[b+4>>2];v[a+8>>2]=c;t[a+16|0]=w[b+16|0];v[a+12>>2]=v[b+12>>2];return a}function GQ(a){var b=0,c=0;c=v[a+4>>2];b=v[a+8>>2];while(1){if((b|0)!=(c|0)){b=b-12|0;v[a+8>>2]=b;continue}break}b=v[a>>2];if(b){bp(a);Mb(b)}}function qz(a,b,c){var d=0;while(1){if((b|0)!=(c|0)){d=v[a>>2];v[a>>2]=d<<8^v[((w[b|0]^d>>>24)<<2)+29260>>2];b=b+1|0;continue}break}return a}function jba(a,b){a=a|0;b=b|0;a=Ny(a);v[23540]=0;R(804,a|0,b|0);b=v[23540];v[23540]=0;if((b|0)==1){b=P()|0;O()|0;Wp(a);T(b|0);L()}return a|0}function K4(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=kb-32|0;kb=g;h=g+8|0;ZI(h,b,c,d,e,f);ad(a,g+20|0);wm(h);kb=g+32|0}function FB(a,b){var c=0,d=0,e=0;c=kb-16|0;kb=c;u[c+14>>1]=1;d=c,e=Bl(a,b),u[d+12>>1]=e;a=x[ke(c+14|0,c+12|0)>>1];kb=c+16|0;return a-1&65535}function iv(a,b){var c=0;a:{if(!b){break a}if(!Qb(v[a>>2],v[a+8>>2],b)){break a}if(b>>>0<=1){c=UC(a,1);break a}c=Rg(a);$b(a,b-2|0)}return c}function ZT(a){var b=0,c=0,d=0;b=kb-16|0;kb=b;c=b,d=bc(a),v[c+12>>2]=d;v[b+8>>2]=236;a=v[_c(b+12|0,b+8|0)>>2];kb=b+16|0;nb=0;return a-216|0}function Oe(a,b,c){t[a+11|0]=c;t[a+10|0]=b;t[a+12|0]=w[a+12|0]&251;u[a+8>>1]=65535;v[a>>2]=0;v[a+4>>2]=0;t[a+12|0]=w[a+12|0]&252|1;return a}function Ob(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=kb-16|0;kb=d;if(b>>>0>=118){wq(12131);L()}e=d+8|0;Db(e,a,b);Ze(e,c);kb=d+16|0;return a|0}function Lo(a,b){var c=0;a:{if(!b){break a}if(!Qb(v[a>>2],v[a+8>>2],b)){break a}if(b>>>0<=3){c=VC(a,b);break a}c=Bg(a);$b(a,b-4|0)}return c}function Jb(a,b){var c=0;if(kf(w[a+11|0])){Mb(v[a>>2])}c=v[b+4>>2];v[a>>2]=v[b>>2];v[a+4>>2]=c;v[a+8>>2]=v[b+8>>2];ie(b,0);xd(b,0);return a}function xF(a,b,c,d,e){var f=0;f=c;c=0;a:{if(!d){break a}c=b>>8;if(!(b&1)){break a}c=kw(v[d>>2],c)}ob[v[v[a>>2]+28>>2]](a,f,c+d|0,b&2?e:2)}function sZ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;a=kb-16|0;kb=a;v[a+12>>2]=e;v[a+8>>2]=d-c;b=Kb(a+12|0,a+8|0);kb=a+16|0;return v[b>>2]}function il(a){var b=0,c=0,d=0;b=kb-16|0;kb=b;c=v[a+24>>2];d=v[a+40>>2];v[b+12>>2]=1;a=v[_c(a+20|0,b+12|0)>>2];kb=b+16|0;return B(a,c+d|0)}function Eba(a){a=a|0;var b=0;b=v[a>>2];if(ob[v[v[b>>2]+32>>2]](b,0,32)|0){a=v[a>>2];a=ob[v[v[a>>2]+32>>2]](a,32,1)^1}else{a=0}return a|0}
function ed(a){var b=0;b=kb-16|0;kb=b;v[b+12>>2]=a;v[b+8>>2]=-32768;v[b+4>>2]=32767;a=u[Pe(b+8|0,td(b+12|0,b+4|0))>>1];kb=b+16|0;return a}function Zz(a,b){var c=0,d=0;v[a>>2]=v[b>>2];v[a+4>>2]=v[b+4>>2];v[a+8>>2]=v[b+8>>2];v[b>>2]=0;v[b+4>>2]=0;c=Gb(b),d=0,v[c>>2]=d;return a}function Xz(a){a=50-(B(w[(a>>>4|0)+31600|0],a&15)>>>4|0)|0;a=a>>>0>23863?65536:23863/(a>>>0)|0;return Hc((a+119315e4>>>0)/(a<<1>>>0)|0,0)}function Mj(a,b,c){var d=0,e=0,f=0;d=kb-16|0;kb=d;t[d+15|0]=b;t[d+14|0]=127;e=a,f=w[Yb(d+15|0,d+14|0)|0]|(c?-128:0),t[e+21|0]=f;kb=d+16|0}function Lj(a,b,c){var d=0,e=0,f=0;d=kb-16|0;kb=d;t[d+15|0]=b;t[d+14|0]=127;e=a,f=w[Yb(d+15|0,d+14|0)|0]|(c?-128:0),t[e+22|0]=f;kb=d+16|0}function f9(a,b){a=a|0;b=b|0;var c=0;b=kb-16|0;kb=b;c=v[a+20>>2];re(b,v[c+4>>2],v[c+8>>2]);oL(a,hc(b+8|0,v[b>>2],v[b+4>>2]),0);kb=b+16|0}function Yw(a,b){var c=0;if(b>>>0<=99){return KH(a,b)}if(b>>>0<=999){c=a;a=(b>>>0)/100|0;return js(JH(c,a),B(a,-100)+b|0)}return cj(a,b)}function TE(a,b,c){var d=0;while(1){if((a|0)!=(b|0)){d=v[a>>2];if(d>>>0<=127){d=v[(d<<2)+c>>2]}v[a>>2]=d;a=a+4|0;continue}break}return b}function DU(a){var b=0,c=0,d=0;c=kb-16|0;kb=c;b=c+8|0;yv(b,a);a=w[Lb(b,0)|0];d=w[Lb(b,1)|0];b=w[Lb(b,2)|0];kb=c+16|0;return a|d<<8|b<<16}function pA(a){var b=0;b=Ib(w[a+26|0]|w[a+27|0]<<8);return((w[a+24|0]>15)+(w[a+25|0]>64)|0)+(Ib(w[a+22|0]|w[a+23|0]<<8)<<1>>>0<b>>>0)|0}function id(a,b){var c=0,d=0,e=0;c=fg(a,b);if(c){v[a+12>>2]=v[a+12>>2]+b;return c}d=a,e=ob[v[v[a>>2]+24>>2]](a)|0,v[d+12>>2]=e;return c}function fN(a,b,c,d){var e=0;e=a+1074376|0;Uy(a,e,b,c,d);e=0-w[(B(b,872)+e|0)+1428|0]|0;if(d){c=0}else{c=dt(v[a+480180>>2])}Rn(a,b,e,c)}function I5(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=kb-32|0;kb=g;h=g+8|0;ZI(h,b,c,d,e,f);ad(a,h);wm(h);kb=g+32|0}function F1(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=b;b=v[b>>2]+7&-8;v[c>>2]=b+16;d=a,e=Gw(v[b>>2],v[b+4>>2],v[b+8>>2],v[b+12>>2]),A[d>>3]=e}function $q(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if((b|0)<0){cd();L()}b=(b-1>>>5|0)+1|0;c=_C(b);v[a+4>>2]=0;v[a>>2]=c;d=Gb(a),e=b,v[d>>2]=e}function ns(a,b){var c=0,d=0;a:{if(b>>>0<=31){d=v[a+4>>2];c=a;break a}b=b-32|0;c=a+4|0}c=v[c>>2];v[a+4>>2]=d>>>b;v[a>>2]=d<<32-b|c>>>b}function Wl(a){var b=0,c=0;c=v[a+4>>2];b=v[a+8>>2];while(1){if((b|0)!=(c|0)){b=b-1|0;v[a+8>>2]=b;continue}break}a=v[a>>2];if(a){Mb(a)}}function z2(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=Cx(v[a+32>>2],b,c,d,2);if(a>>>0<=15){a=w[a+43792|0]}else{a=0}return(a>>>0<5?a+1|0:0)|0}function Y8(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;if(!(!d|!$c(c&255))){qL(a,8,C(0))}a=jj(a);if(a){ob[v[v[a>>2]+96>>2]](a,b,c,d,e)}}function NE(a,b,c,d){a=Tb(a);v[23540]=0;U(d|0,a|0,b|0,c|0);b=v[23540];v[23540]=0;if((b|0)!=1){return a}b=P()|0;O()|0;wc(a);T(b|0);L()}function nS(a){var b=0;b=kb-16|0;kb=b;v[b+12>>2]=a;v[b+8>>2]=-128;v[b+4>>2]=127;a=t[Pe(b+8|0,td(b+12|0,b+4|0))|0];kb=b+16|0;return a}function _h(a,b,c){t[a|0]=b;t[a+1|0]=b>>>8;t[a+2|0]=b>>>16;t[a+3|0]=b>>>24;t[a+4|0]=c;t[a+5|0]=c>>>8;t[a+6|0]=c>>>16;t[a+7|0]=c>>>24}function Ui(a,b){var c=0;if(ef(a)){c=v[a>>2];Il(a);Mb(c)}c=v[b+4>>2];v[a>>2]=v[b>>2];v[a+4>>2]=c;v[a+8>>2]=v[b+8>>2];ie(b,0);wd(b,0)}function SE(a,b,c){var d=0;while(1){if((a|0)!=(b|0)){d=t[a|0];if((d|0)>=0){d=v[(d<<2)+c>>2]}t[a|0]=d;a=a+1|0;continue}break}return b}function Hba(a,b){a=a|0;b=b|0;a=Lu(a,b);if(!a){t[b+6|0]=0;t[b+2|0]=0;t[b+3|0]=0;t[b+4|0]=0;t[b+5|0]=0;t[b|0]=0;t[b+1|0]=0}return a|0}function ls(a,b){var c=0,d=0;a:{if(b>>>0<=31){d=v[a>>2];c=a+4|0;break a}b=b-32|0;c=a}c=v[c>>2];v[a>>2]=d<<b;v[a+4>>2]=c<<b|d>>>32-b}function lq(a,b){var c=0,d=0,e=0;if(th(2147483647)>>>0<b>>>0){cd();L()}c=cD(b);v[a>>2]=c;v[a+4>>2]=c;d=Gb(a),e=(b<<1)+c|0,v[d>>2]=e}function jj(a){var b=0,c=0;b=_m(v[v[a+20>>2]+28>>2]);if(!(b>>>0>249|w[a+4200|0]>=b>>>0)){c=v[Md(v[a+16>>2]+906300|0,b)>>2]}return c}function gN(a,b,c,d){var e=0;e=a+1074376|0;Vy(a,e,b,c,d);e=w[(B(b,872)+e|0)+1427|0];if(d){c=0}else{c=dt(v[a+480180>>2])}Rn(a,b,e,c)}function cE(a){a=a|0;var b=0;a=Nb(a);v[23540]=0;R(136,a|0,13677);b=v[23540];v[23540]=0;if((b|0)==1){b=P()|0;O()|0;Ab(a);T(b|0);L()}}function _f(a,b){a=a|0;b=b|0;var c=0,d=0;c=kb-16|0;kb=c;if(b>>>0>=118){wq(12096);L()}d=c+8|0;Db(d,a,b);Ze(d,0);kb=c+16|0;return a|0}function _7(a,b,c){a=a|0;b=b|0;c=C(c);var d=0;if(b>>>0<=4){c=Yd(c,C(0));d=((b<<2)+a|0)+4220|0;if((b|0)==4){c=Xh(c)}z[d>>2]=c;OK(a)}}function Tw(a){a=a|0;var b=0;b=v[a+12>>2];if((b|0)==v[a+16>>2]){return ob[v[v[a>>2]+40>>2]](a)|0}v[a+12>>2]=b+1;return Mf(t[b|0])|0}function Rh(a,b){var c=0,d=0;c=v[a>>2];d=v[a+4>>2];b=v[a+16>>2]+b|0;a=v[a+12>>2];b=(b|0)%(a|0)|0;return z[Pc(c,d,(b>>31&a)+b|0)>>2]}function Bk(a,b){var c=0,d=0,e=0;if(th(1073741823)>>>0<b>>>0){cd();L()}c=Bi(b);v[a>>2]=c;v[a+4>>2]=c;d=Gb(a),e=(b<<2)+c|0,v[d>>2]=e}function z1(a){a=a|0;var b=0;if((ob[v[v[a>>2]+36>>2]](a)|0)!=-1){b=a;a=v[a+12>>2];v[b+12>>2]=a+1;a=Mf(t[a|0])}else{a=-1}return a|0}function nz(a,b){var c=0,d=0,e=0;if(th(536870911)>>>0<b>>>0){cd();L()}c=FD(b);v[a>>2]=c;v[a+4>>2]=c;d=Gb(a),e=(b<<3)+c|0,v[d>>2]=e}function nba(a,b){a=a|0;b=b|0;var c=0,d=0;c=kb-16|0;kb=c;if(b>>>0>=250){wq(12131);L()}d=c+8|0;Db(d,a,b);qo(d);kb=c+16|0;return a|0}function lu(a,b){var c=0,d=0,e=0;if(th(715827882)>>>0<b>>>0){cd();L()}c=eT(b);v[a>>2]=c;v[a+4>>2]=c;d=Gb(a),e=B(b,6)+c|0,v[d>>2]=e}function GO(a,b){var c=0,d=0,e=0;if(th(268435455)>>>0<b>>>0){cd();L()}c=eQ(b);v[a>>2]=c;v[a+4>>2]=c;d=Gb(a),e=(b<<4)+c|0,v[d>>2]=e}function $H(a,b){a:{if(a&255){a=1;if((b|0)!=255){break a}aa(14249,13179,1180,5737);L()}if((b|0)==255){return 0}a=b>>>0>10}return a}function tg(a){var b=0;b=kb-16|0;kb=b;v[b+12>>2]=a;v[b+8>>2]=0;v[b+4>>2]=255;a=w[Pe(b+8|0,td(b+12|0,b+4|0))|0];kb=b+16|0;return a}function SC(a,b){var c=0;c=Jka(b&255,0,1536,0);b=nb;a=Jka(a&255,0,25,0);c=a+c|0;b=nb+b|0;b=a>>>0>c>>>0?b+1|0:b;a=c;nb=b;return a}function sW(a,b){a=a|0;b=b|0;v[a+4>>2]=b;t[a|0]=0;b=v[v[b>>2]-12>>2]+b|0;if(Yg(b)){b=v[b+72>>2];if(b){ar(b)}t[a|0]=1}return a|0}function pq(a,b){var c=0;c=Ad(v[a+4>>2],w[a+11|0]);if((c|0)==(Ad(v[b+4>>2],w[b+11|0])|0)){a=Qv(sd(a),sd(b),c)}else{a=1}return!a}function pG(a,b,c,d,e,f){a=ob[v[v[a+8>>2]+4>>2]](a+8|0)|0;a=Ur(c,d,a,a+288|0,f,e,0)-a|0;if((a|0)<=287){v[b>>2]=((a|0)/12|0)%12}}function mz(a,b){var c=0;c=v[a+484360>>2];b=b&255;if(sj(c,v[a+484364>>2])>>>0<=b>>>0){return Wb(c,w[a+484376|0])}return zj(c,b)}function le(a){var b=0;a=v[a+4>>2];if(a){if(hn(a)){a:{b=a+8|0;if(v[b>>2]){if((Ev(b)|0)!=-1){break a}}ob[v[v[a>>2]+16>>2]](a)}}}}function lG(a,b,c,d,e,f){a=ob[v[v[a+8>>2]+4>>2]](a+8|0)|0;a=Sr(c,d,a,a+288|0,f,e,0)-a|0;if((a|0)<=287){v[b>>2]=((a|0)/12|0)%12}}function l1(a){a=a|0;var b=0;if((ob[v[v[a>>2]+36>>2]](a)|0)!=-1){b=a;a=v[a+12>>2];v[b+12>>2]=a+4;a=v[a>>2]}else{a=-1}return a|0}function jZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;while(1){if((b|0)!=(c|0)){v[d>>2]=t[b|0];d=d+4|0;b=b+1|0;continue}break}return c|0}function i1(a,b){a=a|0;b=b|0;v[a+4>>2]=b;t[a|0]=0;b=v[v[b>>2]-12>>2]+b|0;if(Yg(b)){b=v[b+72>>2];if(b){sH(b)}t[a|0]=1}return a|0}function hx(a,b,c){var d=0;d=v[a+32>>2];if(y[a+40>>2]<d+c>>>0){v[a+96>>2]=1;return 0}sc(b,d,c);v[a+32>>2]=v[a+32>>2]+c;return 1}function RN(a,b,c,d){a:{if(d>>>0>=64){d=-1;if(w[a+480180|0]&2){break a}}v[b+56>>2]=0;d=Xn(a,x[b+70>>1],v[b+48>>2],c,0)}return d}function QE(a,b,c){var d=0;d=kb-16|0;kb=d;v[d+8>>2]=a;v[d+12>>2]=b;v[d>>2]=c;v[d+4>>2]=0;a=_q(d+8|0,d);kb=d+16|0;return v[a>>2]}function vZ(a){a=a|0;var b=0;b=kb-16|0;kb=b;ji(ki(b+8|0,v[a+8>>2]));kb=b+16|0;a=v[a+8>>2];if(!a){return 1}return(HF(a)|0)==1|0}function kC(a,b){var c=0;c=v[b+4>>2];if(c){gc(a,c,v[b>>2]);return}c=v[b+8>>2];b=v[b+12>>2];if(!pc(c,b)){re(a,c,b);return}ee(a)}function eE(){var a=0,b=0,c=0;a=kb-16|0;kb=a;b=Kc(a,14999);if(Hb(b)){c=(Dg(b,13882)|0)!=-1}else{c=0}zb(b);kb=a+16|0;return c|0}function bZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;while(1){if((b|0)!=(c|0)){t[d|0]=w[b|0];d=d+1|0;b=b+1|0;continue}break}return c|0}function bP(a,b,c,d,e){v[a+12>>2]=e;v[a+8>>2]=d;v[a+4>>2]=c;v[a>>2]=b;if(b){Hd(b,a)}if(c){Hd(c,a)}if(d){Hd(d,a)}if(e){Hd(e,a)}}function TJ(a){a=a|0;var b=0,c=0;b=kb-16|0;kb=b;c=CJ(vc(8));v[c+4>>2]=a;v[c>>2]=57864;a=v[Lf(b+8|0,c)>>2];kb=b+16|0;return a|0}function Qs(a){var b=0;b=A[a+4248>>3]/+y[v[a+16>>2]+24620>>2];A[a+4264>>3]=b;if(w[a+4240|0]){A[a+4264>>3]=b*(A[a+4288>>3]/60)}}function DE(a,b,c){a=Xh(a);a:{if(a>=b){break a}c=0;if(a<=C(0)){break a}if(a<C(4294967296)&a>=C(0)){c=~~a>>>0;break a}}return c}function Cq(a){var b=0;b=-1;a:{if(a>=4294967295){break a}b=0;if(a<=0){break a}if(a<4294967296&a>=0){return~~a>>>0}b=0}return b}function vl(a,b){var c=0;a:{if(y[a+12>>2]<b>>>0){c=0;if(ob[v[v[a>>2]+24>>2]](a)>>>0<b>>>0){break a}}v[a+12>>2]=b;c=1}return c}function ow(a,b){var c=0,d=0,e=0,f=0;c=Pg(b);d=vc(c+13|0);v[d+8>>2]=0;v[d+4>>2]=c;v[d>>2]=c;e=a,f=sc(Cc(d),b,c+1|0),v[e>>2]=f}function Tq(a,b){return ro(w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24),w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24))?b:a}function OS(a,b){var c=0;c=kb-16|0;kb=c;a=Ah(c,a,1);Im(v[a+4>>2],x[b>>1]|x[b+2>>1]<<16);v[a+4>>2]=v[a+4>>2]+4;lc(a);kb=c+16|0}function IY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;if(Zg(a,v[b+8>>2],0)){lw(b,c,d);return}a=v[a+8>>2];ob[v[v[a>>2]+28>>2]](a,b,c,d)}function uU(a){var b=0;a:{if(Sb(a,3863,4)){break a}if(Sb(a+44|0,17874,3)){break a}b=(w[a+47|0]|w[a+48|0]<<8)>>>0>97}return b}function qG(a,b,c,d,e,f){a=ob[v[v[a+8>>2]>>2]](a+8|0)|0;a=Ur(c,d,a,a+168|0,f,e,0)-a|0;if((a|0)<=167){v[b>>2]=((a|0)/12|0)%7}}function mG(a,b,c,d,e,f){a=ob[v[v[a+8>>2]>>2]](a+8|0)|0;a=Sr(c,d,a,a+168|0,f,e,0)-a|0;if((a|0)<=167){v[b>>2]=((a|0)/12|0)%7}}function kg(a,b,c){var d=0;d=4;a:{b:{switch(b-1|0){case 0:d=c;break a;case 1:break b;default:break a}}d=c?3:2}return co(a,d)}function fl(a,b,c,d){var e=0;e=v[b+4>>2];v[a>>2]=v[b>>2];v[a+4>>2]=e;e=v[b+12>>2];v[a+8>>2]=v[b+8>>2];v[a+12>>2]=e;dy(a,c,d)}function dO(a){Yy(a);v[a>>2]=0;v[a+4>>2]=0;v[a+16>>2]=0;v[a+20>>2]=0;v[a+8>>2]=0;v[a+12>>2]=0;a=Yf(a);Yf(a+12|0);t[a+24|0]=1}function Yc(a,b,c){var d=0;d=a;a=c&31;if((c&63)>>>0>=32){c=b>>31;a=b>>a}else{c=b>>a;a=((1<<a)-1&b)<<32-a|d>>>a}nb=c;return a}function DS(a,b){a=a|0;b=b|0;var c=0;c=kb-16|0;kb=c;u[c+14>>1]=b;if((Bl(v[a>>2],v[a+4>>2])|0)!=65535){$B(a,c+14|0)}kb=c+16|0}function tc(a,b){var c=0;a=km(a);v[a+4>>2]=0;v[a>>2]=49184;c=Pd(Hb(b)+1|0);v[a+4>>2]=c;if(c){sc(c,Mc(b),Hb(b)+1|0)}return a}function WQ(a,b){var c=0;c=kb-16|0;kb=c;DR(c+8|0,a);Fe(c,b);a=Qc(v[c+8>>2],v[c+12>>2],v[c>>2],v[c+4>>2]);kb=c+16|0;return a}function KK(a){a=a|0;var b=0,c=0;b=a+4960|0;c=a+4504|0;while(1){b=wc(b-24|0);if((c|0)!=(b|0)){continue}break}return If(a)|0}function y9(a,b,c){a=a|0;b=b|0;c=C(c);var d=0,e=0;if(b>>>0<=3){d=(a+b|0)+4264|0,e=jh(C(Yd(c,C(0))*C(255))),t[d|0]=e;Ts(a)}}function nu(a,b,c){c=c&255;while(1){a:{if(!b){a=0;break a}if(pc(w[a|0],c)){break a}b=b-1|0;a=a+1|0;continue}break}return a}function jM(a,b){var c=0;if(!(w[a|0]!=w[b|0]|A[a+8>>3]!=A[b+8>>3]|w[a+16|0]!=w[b+16|0])){c=v[a+20>>2]==v[b+20>>2]}return c}function bA(a){v[a>>2]=0;v[a+4>>2]=0;v[a+24>>2]=0;v[a+28>>2]=0;v[a+16>>2]=0;v[a+20>>2]=0;v[a+8>>2]=0;v[a+12>>2]=0;return a}function Zha(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;v[a>>2]=0;v[a+4>>2]=0;Gc(a+8|0);d=b+c|0;c=Th(b,d);if(c){Ll(a,c);ku(a,b,d,c)}}function RQ(a){var b=0,c=0;while(1){b=c;if((b|0)!=8){c=b+1|0;if((w[a+b|0]-127&255)>>>0>160){continue}}break}return(b|0)==8}function J8(a,b,c){a=a|0;b=b|0;c=C(c);var d=0,e=0;if(b>>>0<=2){d=(a+b|0)+4232|0,e=jh(C(Yd(c,C(0))*C(127))),t[d|0]=e;Os(a)}}function EE(a,b){v[a>>2]=b;DH(a+4|0);v[a+24>>2]=0;v[a+28>>2]=0;v[a+16>>2]=0;v[a+20>>2]=0;v[a+8>>2]=0;v[a+12>>2]=0;return a}function oe(a,b,c){var d=0;a:{if((b|0)>(c|0)){break a}d=v[a>>2];if((d|0)>=(b|0)){b=c;if((d|0)<=(b|0)){break a}}v[a>>2]=b}}function So(a,b,c){var d=0;a:{if(b>>>0>c>>>0){break a}d=v[a>>2];if(d>>>0>=b>>>0){b=c;if(d>>>0<=b>>>0){break a}}v[a>>2]=b}}function sP(a,b,c,d,e,f,g){t[a+17|0]=g;t[a+16|0]=f;v[a+12>>2]=e;v[a+8>>2]=d;v[a+4>>2]=c;v[a>>2]=b;if(d){pP(a,1);pP(a,0)}}function sL(a,b,c){var d=0,e=0;d=bd(a);if(d>>>0>=c>>>0){Ux(a,Yh(Ac(a),b,c),c);return}e=a;a=Hb(a);kp(e,d,c-d|0,a,0,a,c,b)}function rP(a,b,c,d,e,f,g){t[a+17|0]=g;t[a+16|0]=f;v[a+12>>2]=e;v[a+8>>2]=d;v[a+4>>2]=c;v[a>>2]=b;if(d){qP(a,1);qP(a,0)}}function oQ(a){var b=0;if(!(w[a+35|0]&2)){a=a+68|0;b=9;while(1){if(b){v[a>>2]=268435456;b=b-1|0;a=a+4|0;continue}break}}}function nH(a){var b=0;b=v[a+12>>2];if((b|0)==v[a+16>>2]){return ob[v[v[a>>2]+40>>2]](a)|0}v[a+12>>2]=b+4;return v[b>>2]}function lS(a,b){var c=0;c=kb-16|0;kb=c;a:{if(!fg(a,4)){_S(b);break a}Lh(c+8|0,b);oA(c,a,v[c+8>>2],v[c+12>>2])}kb=c+16|0}function PY(a,b,c){a=a|0;b=b|0;c=c|0;a:{if((c|0)>=257){zF();b=94152;break a}if(!w[469920]){t[469920]=1}b=94148}hc(a,c,b)}function H2(a,b,c){a=a|0;b=b|0;c=c|0;while(1){if((a|0)!=(b|0)){iL(v[c>>2],a);v[c>>2]=v[c>>2]+12;a=a+12|0;continue}break}}function $g(a,b,c,d,e){var f=0;f=kb-16|0;kb=f;v[f+12>>2]=e;c=ki(f+8|0,c);a=Wr(a,b,d,v[f+12>>2]);ji(c);kb=f+16|0;return a}function zi(a,b,c){c=w[c|0];while(1){a:{if((a|0)!=(b|0)){if((c|0)!=w[a|0]){break a}}else{a=b}return a}a=a+1|0;continue}}function ut(a){var b=0,c=0,d=0;d=a*a;a=0;b=1;c=1;while(1){a=a+2;c=d*c/(a*a);b=b+c;if(b*1e-7<c){continue}break}return b}function jY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;h=b;b=0;return ob[a|0](h|b,c,d,e,b|f,g)|0}function Ll(a,b){var c=0,d=0,e=0;if(th(-1)>>>0<b>>>0){cd();L()}c=vc(b);v[a>>2]=c;v[a+4>>2]=c;d=Gb(a),e=b+c|0,v[d>>2]=e}function KR(a){var b=0;if(!(Sb(a,13834,3)|w[a+3|0]>31|(t[a+27|0]<0|w[a+32|0]>64))){b=(w[a+33|0]-1&255)>>>0<32}return b}function HN(a,b,c,d){var e=0,f=0;if(c&255){e=a,f=Zb(v[a>>2]+((B((d^-1|-256)+b|0,c<<24>>24)|0)/2|0)|0,0,256),v[e>>2]=f}}function GT(a,b,c){var d=0;while(1){if(b){d=w[c|0]|w[c+1|0]<<8;t[a|0]=d;t[a+1|0]=d>>>8;b=b-1|0;a=a+2|0;continue}break}}function $e(a){var b=0;b=v[a+32>>2];a:{if(b>>>0>=y[a+40>>2]){v[a+96>>2]=1;a=0;break a}v[a+32>>2]=b+1;a=w[b|0]}return a}function uG(a,b,c){var d=0;d=kb-16|0;kb=d;v[d+12>>2]=c;b=ki(d+8|0,b);a=TG(a,9291,v[d+12>>2]);ji(b);kb=d+16|0;return a}function Ji(a){var b=0;while(1){a:{if((b|0)!=46){if(w[b+43824|0]!=(a|0)){break a}}else{b=0}return b}b=b+1|0;continue}}function HE(a,b,c){a=ve(a);a:{if(a>=b){break a}c=0;if(a<=0){break a}if(a<4294967296&a>=0){c=~~a>>>0;break a}}return c}function qV(a){var b=0,c=0;c=v[a>>2];b=v[a+4>>2];while(1){if((b|0)!=(c|0)){b=b-28|0;Bd(b);continue}break}v[a+4>>2]=c}function q7(a,b,c){a=a|0;b=b|0;c=C(c);var d=0,e=C(0);if(b>>>0<=2){c=Yd(c,C(0));d=Eb(a+4208|0,b),e=c,z[d>>2]=e;GK(a)}}function m8(a,b,c){a=a|0;b=b|0;c=C(c);var d=0,e=C(0);if(b>>>0<=5){c=Yd(c,C(0));d=Eb(a+4208|0,b),e=c,z[d>>2]=e;UK(a)}}function l0(a){a=a|0;var b=0,c=0;c=v[a+4>>2];b=v[a>>2];a=v[a+8>>2];b=b+(a>>1)|0;if(a&1){c=v[c+v[b>>2]>>2]}ob[c|0](b)}function j7(a,b,c){a=a|0;b=b|0;c=C(c);var d=0,e=C(0);if(b>>>0<=3){c=Yd(c,C(0));d=Eb(a+4208|0,b),e=c,z[d>>2]=e;DK(a)}}function f8(a,b,c){a=a|0;b=b|0;c=C(c);var d=0,e=C(0);if(b>>>0<=4){c=Yd(c,C(0));d=Eb(a+4208|0,b),e=c,z[d>>2]=e;QK(a)}}function Zo(a){var b=0,c=0;c=v[a>>2];b=v[a+4>>2];while(1){if((b|0)!=(c|0)){b=b-36|0;jr(b);continue}break}v[a+4>>2]=c}function Mg(a){var b=0;Dm(a);b=It(v[a>>2],Fk(x[a+34>>1]));v[a+20>>2]=b;if(!b){return 0}return Ij(v[a>>2],x[a+34>>1])}function AP(a){v[a+700>>2]=0;u[a+842>>1]=0;v[a+688>>2]=0;v[a>>2]=0;v[a+4>>2]=0;v[a+8>>2]=0;v[a+12>>2]=0;v[a+16>>2]=0}function wO(a){var b=0,c=0,d=0;if(v[a>>2]){Lc(a);b=v[a>>2];jn(a);Mb(b);c=Gb(a),d=0,v[c>>2]=d;v[a>>2]=0;v[a+4>>2]=0}}function th(a){var b=0;b=kb-16|0;kb=b;v[b+12>>2]=a;v[b+8>>2]=2147483647;a=Kb(b+12|0,b+8|0);kb=b+16|0;return v[a>>2]}function ou(a){var b=0,c=0,d=0;if(v[a>>2]){Lc(a);b=v[a>>2];Wh(a);Mb(b);c=Gb(a),d=0,v[c>>2]=d;v[a>>2]=0;v[a+4>>2]=0}}function nP(a){var b=0,c=0,d=0;if(v[a>>2]){Lc(a);b=v[a>>2];Zm(a);Mb(b);c=Gb(a),d=0,v[c>>2]=d;v[a>>2]=0;v[a+4>>2]=0}}function YL(a){var b=0,c=0,d=0;if(v[a>>2]){Lc(a);b=v[a>>2];Bu(a);Mb(b);c=Gb(a),d=0,v[c>>2]=d;v[a>>2]=0;v[a+4>>2]=0}}function YG(a,b,c,d,e,f,g,h,i){v[a>>2]=b;v[a+4>>2]=c;v[a+8>>2]=d;v[a+12>>2]=e&65535|(i>>>16&32768|e>>>16&32767)<<16}function Gu(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=kb-16|0;kb=d;Um(d+8|0,b);v[d+4>>2]=v[d+8>>2];wu(a,d+4|0,c);kb=d+16|0}function Fi(a){var b=0;b=kb-16|0;kb=b;v[b+12>>2]=a;v[b+8>>2]=2147483647;a=v[Kb(b+12|0,b+8|0)>>2];kb=b+16|0;return a}function uV(a,b,c,d,e){t[a+4|0]=b;t[a|0]=69;t[a+1|0]=99;t[a+2|0]=104;t[a+3|0]=111;t[a+7|0]=e;t[a+6|0]=d;t[a+5|0]=c}function sc(a,b,c){var d=0;if(c){d=a;while(1){t[d|0]=w[b|0];d=d+1|0;b=b+1|0;c=c-1|0;if(c){continue}break}}return a}function eR(a){var b=0;if(!(Sb(a+44|0,13843,4)|w[a+29|0]!=16)){b=((w[a+42|0]|w[a+43|0]<<8)-1&65535)>>>0<2}return b}function ZH(a,b,c){var d=0,e=0,f=0;e=c*c;A[a>>3]=e;f=c;d=c*134217729;c=d+(c-d);d=f-c;A[b>>3]=d*d+((c+c)*d+(c*c-e))}function Fd(a,b){var c=0;c=b+4|0;hq(v[a>>2],v[a+4>>2],c);qc(a,c);qc(a+4|0,b+8|0);qc(Gb(a),Cc(b));v[b>>2]=v[b+4>>2]}function uH(a,b){a=a|0;b=b|0;var c=0;c=v[a>>2];a:{if(!c){break a}if(!pc(xH(c,b),-1)){break a}v[a>>2]=0}return a|0}function hl(a,b){var c=0;c=b&15;if(c){t[a+824|0]=c<<2}b=b&240;if(b){t[a+823|0]=b>>>4}v[a+88>>2]=v[a+88>>2]|131072}function _l(a,b){a:{if((a|0)==(b|0)){break a}while(1){b=b-1|0;if(b>>>0<=a>>>0){break a}Dh(a,b);a=a+1|0;continue}}}function Tr(a,b){a:{if((a|0)==(b|0)){break a}while(1){b=b-4|0;if(b>>>0<=a>>>0){break a}qc(a,b);a=a+4|0;continue}}}function PN(a,b){var c=0;c=b&15;if(c){t[a+827|0]=c<<2}b=b&240;if(b){t[a+826|0]=b>>>4}v[a+88>>2]=v[a+88>>2]|262144}function PK(a){a=a|0;v[a+4244>>2]=0;v[a+4248>>2]=0;v[a+4228>>2]=0;v[a+4232>>2]=0;a=a+4252|0;v[a>>2]=0;v[a+4>>2]=0}function XP(a){var b=0,c=0;c=v[a+4>>2];b=v[a+8>>2];while(1){if((b|0)!=(c|0)){b=b-4|0;v[a+8>>2]=b;continue}break}}function AQ(a){if(Sb(a,13816,4)){a=0}else{a=(bc(w[a+4|0]|w[a+5|0]<<8|(w[a+6|0]<<16|w[a+7|0]<<24))|0)==1}return a}function $3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if(a){c=a;a=ob[v[v[b>>2]+8>>2]](b)|0;d=c,e=gg(a?a:21688),v[d>>2]=e}}function vw(a,b,c){while(1){a:{if((a|0)!=(b|0)){if(v[a>>2]!=(c|0)){break a}}else{a=b}return a}a=a+4|0;continue}}function vm(a,b){var c=0;c=1;a:{switch((b&255)-4|0){default:c=(a&255)==11;break;case 0:case 2:break a}}return c}function aj(a){a:{a=v[a+4>>2]&74;if(a){if((a|0)==64){return 8}if((a|0)!=8){break a}return 16}return 0}return 10}function Vm(a){a=w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24);return a<<24|a<<8&16711680|(a>>>8&65280|a>>>24)}function O0(a,b){a=a|0;b=b|0;var c=0,d=0;ob[v[v[a>>2]+24>>2]](a)|0;b=Iw(b);v[a+36>>2]=b;c=a,d=Bn(b),t[c+44|0]=d}function H0(a,b){a=a|0;b=b|0;var c=0,d=0;ob[v[v[a>>2]+24>>2]](a)|0;b=Nw(b);v[a+36>>2]=b;c=a,d=Bn(b),t[c+44|0]=d}function Zg(a,b,c){if(!c){return v[a+4>>2]==v[b+4>>2]}if((a|0)==(b|0)){return 1}return!yi(v[a+4>>2],v[b+4>>2])}function Ze(a,b){var c=0;c=v[a+4>>2];if(b){a=v[a>>2];v[a>>2]=v[a>>2]|c;return}a=v[a>>2];v[a>>2]=v[a>>2]&(c^-1)}function SQ(a,b){var c=0;c=b&255;b=c>>>24|0;a=a&255?1120:1056;c=a+(c<<8)|0;b=a>>>0>c>>>0?b+1|0:b;nb=b;return c}function RE(a,b){var c=0,d=0;c=a+68|0;a=0;while(1){if((a|0)!=9){d=Eb(c,a);a=a+1|0;v[d>>2]=a<<b;continue}break}}function QL(a){var b=0;b=kb-16|0;kb=b;v[b+12>>2]=a;v[b+8>>2]=32767;a=u[Kb(b+12|0,b+8|0)>>1];kb=b+16|0;return a}function FF(a,b){var c=0;c=kb-16|0;kb=c;a=Ok(c,a,1);xd(v[a+4>>2],w[b|0]);v[a+4>>2]=v[a+4>>2]+1;lc(a);kb=c+16|0}function Du(a,b){var c=0;c=kb-16|0;kb=c;v[c+12>>2]=(B(a,b)>>>0)/255;oe(c+12|0,0,15);kb=c+16|0;return w[c+12|0]}function Al(a){var b=0;b=kb-16|0;kb=b;v[b+12>>2]=a;v[b+8>>2]=65535;a=x[Kb(b+12|0,b+8|0)>>1];kb=b+16|0;return a}function zu(a){var b=0;b=kb-16|0;kb=b;u[b+14>>1]=a;u[b+12>>1]=255;a=w[Wc(b+14|0,b+12|0)|0];kb=b+16|0;return a}function qM(a,b){a:{switch(b-1|0){default:return a+724|0;case 0:return a+732|0;case 1:break a}}return a+740|0}function jw(a,b,c,d,e,f,g){var h=0;h=b>>8;if(b&1){h=kw(v[e>>2],h)}ob[v[v[a>>2]+20>>2]](a,c,d,e+h|0,b&2?f:2,g)}function jl(a,b,c,d){var e=0;e=kb-16|0;kb=e;v[e+12>>2]=d;v[e+8>>2]=c;hc(a,b,v[Kb(e+12|0,e+8|0)>>2]);kb=e+16|0}function IM(a,b){var c=0;c=kb-16|0;kb=c;a=Kz(c,a);jq(v[a+4>>2],v[b>>2]);v[a+4>>2]=v[a+4>>2]+4;lc(a);kb=c+16|0}function Hp(a,b){var c=0;c=kb-32|0;kb=c;Lh(c+16|0,b);yn(c+24|0,a,v[c+16>>2],v[c+20>>2]);Lh(c+8|0,b);kb=c+32|0}function zH(a){var b=0;b=v[a+12>>2];if((b|0)==v[a+16>>2]){return ob[v[v[a>>2]+36>>2]](a)|0}return Mf(t[b|0])}function ui(a){var b=0,c=0;v[v[a+20>>2]>>2]=a;c=v[a+12>>2];b=v[c>>2];v[a+4>>2]=b;if(b){v[b+8>>2]=a}v[c>>2]=a}function oG(a,b,c,d,e){b=Wi(b,c,d,e,4);if(!(w[d|0]&4)){v[a>>2]=((b|0)<69?b+2e3|0:(b|0)<100?b+1900|0:b)-1900}}function jG(a,b,c,d,e){b=Vi(b,c,d,e,4);if(!(w[d|0]&4)){v[a>>2]=((b|0)<69?b+2e3|0:(b|0)<100?b+1900|0:b)-1900}}function Zw(a,b){var c=0;if(b>>>0<=9999){return Yw(a,b)}c=a;a=(b>>>0)/1e4|0;return cj(Yw(c,a),B(a,-1e4)+b|0)}function Dca(){var a=0;a=kb-16|0;kb=a;if(cb(a+12|0,4)|0){is(v[116016],12631);L()}kb=a+16|0;return v[a+12>>2]}function $O(a){var b=0;b=v[a+4>>2];u[a+70>>1]=w[((x[b+20>>1]>>>6|x[b+22>>1]<<4)&65535)+29120|0]>>>x[a+68>>1]}function ym(a,b){var c=0;c=kb-16|0;kb=c;v[c+8>>2]=a;a=c+8|0;v[a>>2]=v[a>>2]+(b<<2);kb=c+16|0;return v[a>>2]}function pha(a,b){a=a|0;b=b|0;if(!MS(a,b)){t[b+4|0]=0;t[b+5|0]=0;t[b|0]=0;t[b+1|0]=0;t[b+2|0]=0;t[b+3|0]=0}}function oI(a,b,c,d){z[d+4>>2]=a+c;a=C(a+C(c*C(-.5)));b=C(b*C(.8660253882408142));z[d+8>>2]=a-b;z[d>>2]=b+a}function ml(a,b,c,d){a=a&65535;c=c&65535;a=(a|0)==(c|0)?0:a>>>0<c>>>0?-1:1;if(yj(a)){a=vO(b,d)}return kf(a)}function bS(a,b){t[a+6|0]=255;v[a+16>>2]=0;u[a+4>>1]=0;v[a>>2]=0;if(b>=0){A[a+8>>3]=b;v[a+16>>2]=3}return a}function Jl(a){var b=0;b=kb-16|0;kb=b;v[b+12>>2]=a;v[b+8>>2]=255;a=w[Kb(b+12|0,b+8|0)|0];kb=b+16|0;return a}function $x(a,b){a=Tb(a);v[a+20>>2]=0;v[a+12>>2]=0;v[a+16>>2]=0;Tb(a+24|0);Nb(a+36|0);v[a+48>>2]=b;return a}function zR(a){var b=0;if(!(Sb(a,17869,4)|w[a+5|0]!=16|(w[a+54|0]-33&255)>>>0<224)){b=w[a+4|0]>95}return b}function wv(a){var b=0;b=kb-16|0;kb=b;a=v[fc(b+8|0,sd(a)+Ad(v[a+4>>2],w[a+11|0])|0)>>2];kb=b+16|0;return a}function t4(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return eF(a,b,c,d,e,f,g,12966,1034)|0}function jt(a){var b=0,c=0;while(1){if(b>>>0>=8){a=c<<24>>24}else{b=b+15|0;c=Un(a);continue}break}return a}function jka(a,b){a=a|0;b=b|0;var c=0;b=kb-80|0;kb=b;c=-1;if(eV(a,b+8|0)){c=dV(b+8|0)}kb=b+80|0;return c|0}function hv(a,b){a:{switch(b-1|0){default:return a+48|0;case 0:return a+68|0;case 1:break a}}return a+88|0}function hha(a,b){a=a|0;b=b|0;var c=0;b=kb-16|0;kb=b;c=-1;if(Rj(a,b+8|0)){c=yS(b+8|0)}kb=b+16|0;return c|0}function H4(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return eF(a,b,c,d,e,f,g,12898,1027)|0}function Xk(a){var b=0;b=v[a+12>>2];if((b|0)==v[a+16>>2]){return ob[v[v[a>>2]+36>>2]](a)|0}return v[b>>2]}function Kr(a,b,c,d,e,f){var g=0;g=b>>8;if(b&1){g=kw(v[d>>2],g)}ob[v[v[a>>2]+24>>2]](a,c,d+g|0,b&2?e:2,f)}function JV(a,b){a=a|0;b=b|0;var c=0;b=kb-16|0;kb=b;c=-1;if(Rj(a,b+8|0)){c=RB(b+8|0)}kb=b+16|0;return c|0}function GF(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;v[e>>2]=c;v[h>>2]=f;return 3}function EO(a,b){var c=0;c=v[a+484344>>2];if(xe(c,v[a+484348>>2],b)){a=v[_b(c,b)+12>>2]}else{a=1}return a}function zO(a,b){var c=0;c=v[a+4>>2];while(1){if((b|0)!=(c|0)){c=c-12|0;We(c);continue}break}v[a+4>>2]=b}function xC(a,b){var c=0;c=v[a+4>>2];while(1){if((b|0)!=(c|0)){c=c-20|0;Bb(c);continue}break}v[a+4>>2]=b}function qga(a,b,c){a=a|0;b=b|0;c=c|0;v[a>>2]=0;v[a+4>>2]=0;Gc(a+8|0);if(b){lq(a,b);Jo(a,b,c)}return a|0}function je(a,b){a=Nl(a,v[b>>2],v[b+4>>2]);v[a+8>>2]=v[b+8>>2];Nl(a+12|0,v[b+12>>2],v[b+16>>2]);return a}function hP(a,b){var c=0;c=v[a+4>>2];while(1){if((b|0)!=(c|0)){c=c-32|0;ql(c);continue}break}v[a+4>>2]=b}function SM(a,b){var c=0;c=v[a+4>>2];while(1){if((b|0)!=(c|0)){c=c-52|0;gl(c);continue}break}v[a+4>>2]=b}function Rb(a,b,c){var d=0;c=v[a+4>>2]+c|0;d=b;b=v[a>>2]+b|0;c=d>>>0>b>>>0?c+1|0:c;v[a>>2]=b;v[a+4>>2]=c}function FQ(a,b){var c=0;c=v[a+4>>2];while(1){if((b|0)!=(c|0)){c=c-12|0;EQ(c);continue}break}v[a+4>>2]=b}function wT(a,b,c){a=a|0;b=b|0;c=c|0;v[a>>2]=0;v[a+4>>2]=0;Gc(a+8|0);if(b){lu(a,b);PA(a,b,c)}return a|0}function qW(a,b,c){a=a|0;b=b|0;c=c|0;v[a>>2]=0;v[a+4>>2]=0;Gc(a+8|0);if(b){Bk(a,b);AC(a,b,c)}return a|0}function fO(a,b){var c=0,d=0;a:{if(b<0){break a}c=A[a>>3];if(!(c<0)){d=b;if(!(b<c)){break a}}A[a>>3]=d}}function ZY(){if(w[468124]){return v[117030]}Ap(468116,FK());t[468124]=1;v[117030]=468116;return 468116}function Qm(a,b,c){a=a|0;b=b|0;c=c|0;v[a>>2]=0;v[a+4>>2]=0;Gc(a+8|0);if(b){Ll(a,b);Po(a,b,c)}return a|0}function KU(a){a:{if(Sb(a,14206,4)){break a}if(Sb(a+8|0,14187,4)){break a}return 1}return!Sb(a,14187,4)}function HF(a){var b=0,c=0;b=kb-16|0;kb=b;a=ki(b+8|0,a);c=v[v[116042]>>2];ji(a);kb=b+16|0;return c?4:1}function yX(a){a=a|0;var b=0,c=0;b=kb-32|0;kb=b;c=-1;if(aE(a,b+8|0)){c=$D(b+8|0)}kb=b+32|0;return c|0}function wB(a,b){if(b>>>0<=126){df(((b<<5)+a|0)+480280|0);go((B(b,872)+a|0)+1074992|0,a,b,134217728)}}function uB(a){var b=0,c=0;if(v[a>>2]){Lc(a);Mb(v[a>>2]);b=Gb(a),c=0,v[b>>2]=c;v[a>>2]=0;v[a+4>>2]=0}}function eB(a){a=a|0;var b=0;u[a+34>>1]=0;b=a+43|0;om(b,b+22|0,62428);v[a+20>>2]=0;nd(a,0);return a|0}function Ub(a,b,c){var d=0;if(c){d=a;while(1){t[d|0]=b;d=d+1|0;c=c-1|0;if(c){continue}break}}return a}function TW(a){a=a|0;var b=0,c=0;b=kb-16|0;kb=b;c=-1;if(Rj(a,b+8|0)){c=wD(b+8|0)}kb=b+16|0;return c|0}function Sq(a,b,c){var d=0;d=kb-16|0;kb=d;if(b){t[d+15|0]=0;kM(a+36|0,b,zi(b,b+c|0,d+15|0))}kb=d+16|0}function SP(a){if(((w[a+68|0]|w[a+69|0]<<8)-128&65535)>>>0>=65409){a=Sb(a,17717,17)}else{a=1}return!a}function HT(a,b){var c=0,d=0,e=0;c=kb-16|0;kb=c;d=c,e=Ib(b&65535),u[d+14>>1]=e;XJ(a,c+14|0);kb=c+16|0}function pT(a,b){var c=0;c=v[a>>2];v[a>>2]=b;if(c){oT(c+52|0);Ab(c+40|0);wc(c+16|0);wc(c+4|0);Mb(c)}}function kS(a){u[a+10>>1]=0;u[a+12>>1]=0;u[a+8>>1]=1084;v[a>>2]=0;v[a+4>>2]=40;u[a+14>>1]=0;return a}function _M(a){v[a+20>>2]=0;t[a+16|0]=7;v[a+8>>2]=1889785610;v[a+12>>2]=1072630333;t[a|0]=3;return a}function Uj(a){t[a|0]=0;t[a+1|0]=0;t[a+2|0]=0;t[a+3|0]=0;t[a+4|0]=0;t[a+5|0]=0;t[a+6|0]=0;t[a+7|0]=0}function UP(a){Zd(a+140|0);Bb(a+120|0);Bb(a+100|0);Bb(a+80|0);Bb(a+60|0);Bb(a+40|0);Bb(a+20|0);Bb(a)}function Qu(a){t[a|0]=0;t[a+1|0]=0;t[a+2|0]=0;t[a+3|0]=0;t[a+3|0]=0;t[a+4|0]=0;t[a+5|0]=0;t[a+6|0]=0}function Hj(a){a=a|0;var b=0,c=0;b=kb-16|0;kb=b;if(Ro(a,b+8|0)){c=Ib(x[b+8>>1])}kb=b+16|0;return c|0}function EW(a,b){a=a|0;b=b|0;var c=0;c=kb-16|0;kb=c;Wm(c+8|0,b);cr(a,v[c+8>>2],v[c+12>>2]);kb=c+16|0}function Do(a){a=a|0;var b=0,c=0;b=kb-16|0;kb=b;if(Uo(a,b+8|0)){c=bc(v[b+8>>2])}kb=b+16|0;return c|0}function DW(a,b){a=a|0;b=b|0;v[a>>2]=0;v[a+4>>2]=0;ok(a+8|0,0);$q(a,127);$C(a,127,w[b|0]);return a|0}function D2(a,b){a=a|0;b=b|0;var c=0;c=kb-16|0;kb=c;iC(c+8|0,b);cr(a,v[c+8>>2],v[c+12>>2]);kb=c+16|0}function y2(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=Mz(Cx(v[a+32>>2],b,c,d,3));return(a>>>0<5?a+1|0:0)|0}function fT(a,b,c){var d=0;d=c;b=b-a|0;c=v[c>>2]+B((b|0)/-6|0,6)|0;v[d>>2]=c;if((b|0)>0){sc(c,a,b)}}function ad(a,b){var c=0;c=v[b+4>>2];v[a>>2]=v[b>>2];v[a+4>>2]=c;v[a+8>>2]=v[b+8>>2];wE(b);return a}function _8(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;a=jj(a);if(a){ob[v[v[a>>2]+88>>2]](a,b,c,d,e)}}function CM(a,b){if(b>>>0<=255){a=v[((b<<2)+a|0)+900380>>2];a=a?a+492|0:21688}else{a=21688}return a}function yga(a,b){a=a|0;b=b|0;var c=0;b=kb-16|0;kb=b;c=-1;if(yB(a,b)){c=TR(b)}kb=b+16|0;return c|0}function mg(a,b,c){var d=0;d=c;c=v[a>>2];d=v[a+4>>2]-(d+(c>>>0<b>>>0)|0)|0;v[a>>2]=c-b;v[a+4>>2]=d}function jv(a){a=a|0;var b=0;b=kb-16|0;kb=b;a=zg(a,b+15|0);kb=b+16|0;return(a?w[b+15|0]:0)<<24>>24}function Y3(a,b){a=a|0;b=b|0;var c=0;b=Mc(b);c=v[a+4>>2];if(c){ob[c|0](b,v[a+8>>2]);return}Ms(b,a)}function W8(a,b,c){a=a|0;b=b|0;c=c|0;a=jj(a);if(!a){return 0}return ob[v[v[a>>2]+104>>2]](a,b,c)|0}function Vga(a){a=a|0;var b=0;b=kb-16|0;kb=b;a=Ro(a,b+8|0);kb=b+16|0;return(a?x[b+8>>1]:0)<<16>>16}function IF(a,b,c,d,e){var f=0;f=kb-16|0;kb=f;e=ki(f+8|0,e);a=Xr(a,b,c,d);ji(e);kb=f+16|0;return a}function CO(a,b,c){var d=0;d=kb-16|0;kb=d;a=v[fc(d+8|0,uO(b,c,Td(a),jc(a)))>>2];kb=d+16|0;return a}function x6(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;ob[v[v[b>>2]+8>>2]](b,c);d=a;a=b+4|0;Ap(d,a);gK(a,c)}function ox(a,b,c){b=(B(B(mx(a),nx(a,b)),125)>>>0)/(vI(a,b)>>>0)|0;a=(a&6)==6?b&-4:b;return a?a:c}function yn(a,b,c,d){var e=0;e=kb-16|0;kb=e;_g(e+8|0,c,d);nG(a,b,v[e+8>>2],v[e+12>>2]);kb=e+16|0}function v1(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ob[v[v[a>>2]+12>>2]](a,b,c,d,e,f)|0}function u1(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ob[v[v[a>>2]+24>>2]](a,b,c,d,e,f)|0}function t1(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ob[v[v[a>>2]+16>>2]](a,b,c,d,e,f)|0}function sw(a,b,c,d){var e=0;e=kb-16|0;kb=e;gc(e+8|0,c,d);nG(a,b,v[e+8>>2],v[e+12>>2]);kb=e+16|0}function s1(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ob[v[v[a>>2]+28>>2]](a,b,c,d,e,f)|0}function r1(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ob[v[v[a>>2]+20>>2]](a,b,c,d,e,f)|0}function q1(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ob[v[v[a>>2]+44>>2]](a,b,c,d,e,f)|0}function ni(a,b,c){if(c){while(1){v[a>>2]=v[b>>2];a=a+4|0;b=b+4|0;c=c-1|0;if(c){continue}break}}}function aF(a,b,c){var d=0;d=kb-16|0;kb=d;c=Kc(d,c);a=tc(a,c);zb(c);v[a>>2]=b;kb=d+16|0;return a}function N4(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return kF(a,b,c,d,e,f,10638,1024)|0}function Jp(a,b){var c=0;c=kb-16|0;kb=c;v[c+8>>2]=v[a>>2];a=v[hB(c+8|0,b)>>2];kb=c+16|0;return a}function $z(a,b,c){b=b-a>>2;while(1){if((b|0)>0){v[a>>2]=v[c>>2];b=b-1|0;a=a+4|0;continue}break}}function yt(a,b){b=Jka(a,a>>31,b,b>>31)+5e5|0;a=nb;return Hc(Kka(b,b>>>0<5e5?a+1|0:a,1e6,0),nb)}function tv(a,b){a=qD(a,v[b>>2],v[b+4>>2]);v[a+8>>2]=v[b+8>>2];qD(a+12|0,v[b+12>>2],v[b+16>>2])}function jW(a){a=a|0;var b=0;b=v[a+76>>2];if(pc(-1,b)){b=bD(a,32);v[a+76>>2]=b}return b<<24>>24}function _B(a,b){a=a|0;b=b|0;if(!Mu(a,b)){t[b|0]=0;t[b+1|0]=0;t[b+2|0]=0;t[b+3|0]=0;t[b+4|0]=0}}function _0(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ob[v[v[b>>2]+16>>2]](a,b,v[c+8>>2],v[c+12>>2],0,d)}function PV(a,b){a=a|0;b=b|0;if(!Mu(a,b)){t[b+1|0]=0;t[b+2|0]=0;t[b+3|0]=0;t[b+4|0]=0;t[b|0]=0}}function Mha(a){a=a|0;var b=0;b=kb-16|0;kb=b;a=Uo(a,b+8|0);kb=b+16|0;return C(a?z[b+8>>2]:C(0))}function MR(a){var b=0,c=0;b=1;c=v[a>>2];a:{if((c|0)>0){b=120;if(c>>>0<121){break a}}v[a>>2]=b}}function L5(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return kF(a,b,c,d,e,f,10683,998)|0}function Haa(a,b){a=a|0;b=b|0;wi(a);wi(a);a:{if(b>>>0>=60){$b(a,4);break a}wi(a)}return wi(a)|0}function H3(a){a=a|0;var b=0;b=kb-16|0;kb=b;a=v[Lf(b+8|0,ul(vc(12),a))>>2];kb=b+16|0;return a|0}function CY(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;if(Zg(a,v[b+8>>2],f)){nw(b,c,d,e)}}function nea(a,b){a=a|0;b=b|0;v[a>>2]=0;v[a+4>>2]=0;Gc(a+8|0);if(b){Bk(a,b);At(a,b)}return a|0}function jB(a,b){var c=0;c=kb-16|0;kb=c;v[c+8>>2]=a;a=v[jU(c+8|0,0-b|0)>>2];kb=c+16|0;return a}function iV(a){var b=0;if(!(Sb(a,26388,20)|(w[a+25|0]-9&255)>>>0<248)){b=t[a+47|0]>=0}return b}function ew(a,b,c,d){var e=0;v[a>>2]=v[b>>2];e=v[b>>2];v[a+8>>2]=b;v[a+4>>2]=(c<<d)+e;return a}function bI(a){var b=0;b=+((a&2097151)>>>0);return C(Wj(+C((a|0)<0?-b:b),(a>>>21&1023)-788|0))}function ZU(a,b){return(Zb((B(a>>>4|0,b)>>>0)/15|0,1,15)<<4|Zb((B(a&15,b)>>>0)/15|0,1,15))&255}function NG(a){var b=0;b=v[116042];if(a){v[116042]=(a|0)==-1?467908:a}return(b|0)==467908?-1:b}function vB(a,b){a=a|0;b=b|0;v[a>>2]=0;v[a+4>>2]=0;Gc(a+8|0);if(b){Ll(a,b);vE(a,b)}return a|0}function om(a,b,c){b=b-a|0;while(1){if((b|0)>0){t[a|0]=w[c|0];b=b-1|0;a=a+1|0;continue}break}}function lY(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;a=ob[a|0](b,c,d,e)|0;ra(nb|0);return a|0}function Tk(a){var b=0;b=kb-16|0;kb=b;a=v[fc(b+8|0,Ac(a)+(Hb(a)<<2)|0)>>2];kb=b+16|0;return a}function Sf(a,b){a=a|0;b=b|0;var c=0,d=0;c=kb-16|0;kb=c;d=a;a=yc(c,b);ad(d,a);Ab(a);kb=c+16|0}function LC(a){var b=0;b=a&255;a=b>>>21|0;b=(b<<11)+2624|0;a=b>>>0<2624?a+1|0:a;nb=a;return b}function Iu(a,b){a=a|0;b=b|0;var c=0,d=0;c=kb-16|0;kb=c;d=a;a=Kc(c,b);ad(d,a);zb(a);kb=c+16|0}function CQ(a,b,c){var d=0;v[a>>2]=v[b>>2];d=v[b>>2];v[a+8>>2]=b;v[a+4>>2]=B(c,12)+d;return a}function n1(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;return ob[v[v[a>>2]+32>>2]](a,b,c,d,e)|0}function gB(a){var b=0,c=0;b=kb-16|0;kb=b;if(Ro(a,b+8|0)){c=pe(u[b+8>>1])}kb=b+16|0;return c}function YQ(a){var b=0,c=0;b=kb-16|0;kb=b;if(XQ(a,b+8|0)){c=bc(v[b+8>>2])}kb=b+16|0;return c}function OG(a){var b=0,c=0;c=a;while(1){b=c;c=b+4|0;if(v[b>>2]){continue}break}return b-a>>2}function Fga(a){a=a|0;var b=0,c=0;b=kb-32|0;kb=b;c=a;a=Kh(b+8|0);wS(c,a,0,0);Bb(a);kb=b+32|0}function CF(a){a=a|0;var b=0;v[a>>2]=84076;b=v[a+8>>2];if(!(!b|!w[a+12|0])){Mb(b)}return a|0}function BW(a){a=a|0;var b=0;b=kb-16|0;kb=b;a=zg(a,b+8|0);kb=b+16|0;return(a?w[b+8|0]:0)&255}function vR(a){a:{if(Sb(a,17662,4)){break a}if(Sb(a+8|0,14244,4)){break a}return 1}return 0}function uJ(a,b,c,d,e){if(!((b|0)==(c|0)|(d|0)>=0)){t[b|0]=45;d=VK(d);b=b+1|0}cJ(a,b,c,d,e)}function nx(a,b){a=a&255;return w[(B(a>>>1&3,15)+B(a>>>3&1,45)+((b&240)>>>4)|0)+64769|0]<<1}function hga(a){a=a|0;var b=0;b=kb-16|0;kb=b;a=Jh(a,b+8|0);kb=b+16|0;return+(a?A[b+8>>3]:0)}function ag(a){var b=0,c=0;while(1){c=b&65535;if(c>>>0<127){wB(a,c);b=b+1|0;continue}break}}function ZC(a,b){if((a&4088)>>>0>=520){b=mv(0-Nka(b^1230262859,25)|0,4)^1247037516}return b}function Xy(a){var b=0;v[a+84>>2]=0;v[a+88>>2]=0;b=v[a+80>>2];v[a+92>>2]=b;v[a+96>>2]=b<<12}function yH(a){var b=0;b=v[a>>2];if(b){if(!pc(zH(b),-1)){return!v[a>>2]}v[a>>2]=0}return 1}function xO(a){var b=0;b=v[a>>2];v[a>>2]=0;if(b){if(w[jc(a)+4|0]){yO(b+16|0)}if(b){Mb(b)}}}function qD(a,b,c){var d=0;d=kb-16|0;kb=d;b=Nl(d+8|0,b,c);VD(b,a);le(b);kb=d+16|0;return a}function pw(a,b,c){var d=0;d=kb-16|0;kb=d;c=ki(d+8|0,c);a=$w(a,b);ji(c);kb=d+16|0;return a}function nh(a){var b=0;if(a>>>0>=11){b=a+16&-16;a=b-1|0;a=(a|0)==11?b:a}else{a=10}return a}function mT(a){var b=0;b=v[a>>2];v[a>>2]=0;if(b){if(w[jc(a)+4|0]){MA(b+16|0)}if(b){Mb(b)}}}function lM(a){var b=0;b=v[a>>2];v[a>>2]=0;if(b){if(w[jc(a)+4|0]){dc(b+16|0)}if(b){Mb(b)}}}function c7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Bx(a,b,c,d,e,0,0,f,g)}function _P(a){var b=0;b=a&255;a=b>>>27|0;b=(b<<5)+259|0;a=b>>>0<259?a+1|0:a;nb=a;return b}function Vv(a,b){a=a|0;b=b|0;b=b-1|0;if(b>>>0<=4){b=v[(b<<2)+21692>>2]}else{b=9761}yc(a,b)}function Ul(a,b,c){var d=C(0);if(b>>>0<=c>>>0){d=z[Eb(a+4208|0,b)>>2]}else{d=C(0)}return d}function Rf(a,b){var c=0;c=kb-16|0;kb=c;v[c+8>>2]=a;a=v[hB(c+8|0,b)>>2];kb=c+16|0;return a}function LK(a,b){var c=0;c=v[a+12>>2];if((c|0)>0){v[a+20>>2]=(v[a+16>>2]+(b+c|0)|0)%(c|0)}}function pr(a){var b=0;while(1){if(!pc(w[a|0],0)){a=a+1|0;b=b+1|0;continue}break}return b}function kY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ob[a|0](b,c,d,e,f,g)}function fL(a,b){a=a|0;b=b|0;var c=0;c=Hb(a);if(c>>>0<b>>>0){Hu(a,b-c|0,0);return}DL(a,b)}function a9(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=jj(a);if(a){ob[v[v[a>>2]+76>>2]](a,b,c,d)}}function _J(a){a=a|0;var b=0;v[a>>2]=49184;b=v[a+4>>2];if(b){Mb(b);v[a+4>>2]=0}return a|0}function Z8(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=jj(a);if(a){ob[v[v[a>>2]+92>>2]](a,b,c,d)}}function UU(a,b,c){var d=0;d=kb-16|0;kb=d;_h(d+8|0,b,c);kb=d+16|0;return v[d+8>>2]==(a|0)}function Rg(a){var b=0;b=kb-16|0;kb=b;a=Ro(a,b+8|0);kb=b+16|0;return(a?x[b+8>>1]:0)&65535}function Np(a,b,c){a=a+1074992|0;return v[(a+B(b,872)|0)+680>>2]>v[(a+B(c,872)|0)+680>>2]}function Nka(a,b){var c=0,d=0;c=b&31;d=(-1>>>c&a)<<c;c=a;a=0-b&31;return d|(c&-1<<a)>>>a}
function Fw(a,b,c,d){var e=0;e=kb-16|0;kb=e;v[e+12>>2]=d;a=Wr(a,b,c,d);kb=e+16|0;return a}function $8(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=jj(a);if(a){ob[v[v[a>>2]+84>>2]](a,b,c,d)}}function zz(a,b){a=ul(a,b);ad(a+12|0,b+12|0);u[a+28>>1]=x[b+28>>1];v[a+24>>2]=v[b+24>>2]}function zs(a){if(JJ(a)){a=ba(4)|0;v[a>>2]=0;a=km(a);v[a>>2]=92280;ha(a|0,92316,26);L()}}function yh(a){var b=0;b=kb-16|0;kb=b;a=v[fc(b+8|0,Ac(a)+Hb(a)|0)>>2];kb=b+16|0;return a}function uN(a,b){var c=0;c=w[a+851|0];if(c&1){t[a+851|0]=c|64;v[a+852>>2]=v[a+852>>2]+b}}function oY(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return ob[a|0](b,c,d,e,f)|0}function mt(a){var b=0;b=kb-16|0;kb=b;a=v[fc(b+8|0,Mc(a)+Hb(a)|0)>>2];kb=b+16|0;return a}function bN(a){a=Nb(a);Nb(a+12|0);Nb(a+24|0);Nb(a+36|0);Nb(a+48|0);v[a+60>>2]=0;return a}function Xs(a,b){var c=0;c=Mc(a);if(c>>>0<=b>>>0){a=Hb(a)+c>>>0>=b>>>0}else{a=0}return a}function Ux(a,b,c){var d=0;d=kb-16|0;kb=d;Sh(a,c);t[d+15|0]=0;we(b+c|0,d+15|0);kb=d+16|0}function T0(a,b,c){a=a|0;b=b|0;c=c|0;if(!((c|0)==1|(c|0)>256)){Mw(a,c);return}Kc(a,7914)}function Me(a){var b=0;b=kb-16|0;kb=b;a=zg(a,b+15|0);kb=b+16|0;return(a?w[b+15|0]:0)&255}function Kv(){var a=0,b=0;a=kb-16|0;kb=a;b=Lf(a+8|0,Tb(vc(12)));kb=a+16|0;return v[b>>2]}function DR(a,b){var c=0;c=kb-16|0;kb=c;Wm(c+8|0,b);kT(a,v[c+8>>2],v[c+12>>2]);kb=c+16|0}function $M(a){var b=0;b=a+4e4|0;while(1){b=zy(b-160|0);if((b|0)!=(a|0)){continue}break}}function ug(a){t[a|0]=0;t[a+1|0]=0;t[a+2|0]=0;t[a+3|0]=0;t[a+4|0]=0;t[a+5|0]=0;return a}function pH(a){var b=0;b=v[a>>2];if(b){if(!En(Xk(b))){return!v[a>>2]}v[a>>2]=0}return 1}function hn(a){var b=0;b=Ev(a+4|0);if((b|0)==-1){ob[v[v[a>>2]+8>>2]](a)}return(b|0)==-1}function gu(a,b,c){var d=C(0);d=z[a>>2];if(!fu(d,z[b>>2])){b=fu(z[c>>2],d)?c:a}return b}function c9(a,b){a=a|0;b=b|0;a=jj(a);if(!a){return 1}return ob[v[v[a>>2]+68>>2]](a,b)|0}function bX(a){a=a|0;var b=0;b=v[a+4>>2];return(ob[v[v[b>>2]+20>>2]](b)|0)+v[a+12>>2]|0}function ZL(a,b,c){var d=0;d=b-a|0;if((a|0)!=(b|0)){fj(c,a,d)}return B((d|0)/6|0,6)+c|0}function Wv(a,b,c){var d=0;v[a>>2]=v[b>>2];d=v[b>>2];v[a+8>>2]=b;v[a+4>>2]=c+d;return a}function WA(a){var b=0;b=Jz(a);while(1){if((a|0)!=(b|0)){rV(a);a=a+32|0;continue}break}}function Up(a,b,c){a=il(a)-v[a+16>>2]|0;if(a>>>0>=2){c=C(C(C(c-b)/C(a>>>0))+b)}return c}function SG(a,b){var c=0;c=kb-16|0;kb=c;v[c+12>>2]=b;a=TG(a,11165,b);kb=c+16|0;return a}function Kx(a,b,c,d){if(!((b|0)==(c|0)|(d|0)>=0)){t[b|0]=45;d=VK(d);b=b+1|0}Gx(a,b,c,d)}function vI(a,b){a=a&255;return v[(b&12)+64772>>2]>>>((a>>>3^-1)&1)>>>((a>>>4^-1)&1)|0}function mS(a){var b=0;b=a+24|0;while(1){b=zb(b-12|0);if((b|0)!=(a|0)){continue}break}}function lQ(a){var b=0;b=a+36|0;while(1){b=zb(b-12|0);if((b|0)!=(a|0)){continue}break}}function _u(a,b){a=a|0;b=b|0;var c=0;c=kb-16|0;kb=c;t[c+15|0]=b;eK(a,c+15|0);kb=c+16|0}function WD(a,b){var c=0;c=kb-16|0;kb=c;b=Cg(c+8|0,b);VD(b,a);le(b);kb=c+16|0;return a}function VO(a,b){return(a>>>0<=62?63-(B((b^-1)&63,(a?a+1|0:0)&255)>>>6|0)|b&192:b)&255}function SB(a,b,c){t[a+2|0]=1;b=b&15;if(c){b=w[b+26336|0]}else{b=(b<<2)+4|0}t[a+4|0]=b}function L4(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return jF(a,b,c,d,e,12354,1025)|0}function JX(){var a=0;a:{if(fE(19988497)){break a}if(eE()){break a}a=dE()^1}return a|0}function G$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return UE(b,c,d,e,f,0)|0}
function Dc(a,b){var c=0,d=0;c=kb-16|0;kb=c;d=c+8|0;Wm(d,a);Kl(d,b);kb=c+16|0;return a}function wE(a){var b=0;while(1){if((b|0)!=3){v[(b<<2)+a>>2]=0;b=b+1|0;continue}break}}function wA(a,b,c,d){var e=0;e=kb-16|0;kb=e;a=Ah(e,a,d);ju(b,c,a+4|0);lc(a);kb=e+16|0}function q4(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return dF(a,b,c,d,e,9717,1035)|0}function ku(a,b,c,d){var e=0;e=kb-16|0;kb=e;a=Ok(e,a,d);ju(b,c,a+4|0);lc(a);kb=e+16|0}function ht(a,b){if(!(t[b+851|0]&1&v[a+480180>>2]==8)){oy(a,b,0);oy(a,b,1);oy(a,b,2)}}function hq(a,b,c){var d=0;d=c;b=b-a|0;c=v[c>>2]-b|0;v[d>>2]=c;if((b|0)>0){sc(c,a,b)}}function fZ(a,b){a=a|0;b=b|0;if((b|0)>=0){b=v[((b&255)<<2)+82576>>2]}return b<<24>>24}function fP(a,b,c,d){var e=0;e=kb-16|0;kb=e;a=ai(e,a,d);ju(b,c,a+4|0);lc(a);kb=e+16|0}function dZ(a,b){a=a|0;b=b|0;if((b|0)>=0){b=v[((b&255)<<2)+81040>>2]}return b<<24>>24}function cu(a,b){var c=0;c=kb-16|0;kb=c;u[c+14>>1]=b;_t(a+236|0,128,c+14|0);kb=c+16|0}function cG(a,b){var c=0,d=0;_e(a,ce(b));b=jc(b);c=jc(a),d=v[b>>2],v[c>>2]=d;return a}function am(a){var b=0;if(a>>>0>=2){b=a+4&-4;a=b-1|0;a=(a|0)==2?b:a}else{a=1}return a}function _Z(a){a=a|0;a=469416;while(1){a=Nc(a-12|0);if((a|0)!=469392){continue}break}}function ZZ(a){a=a|0;a=469344;while(1){a=Nc(a-12|0);if((a|0)!=469056){continue}break}}function YZ(a){a=a|0;a=468744;while(1){a=Nc(a-12|0);if((a|0)!=468576){continue}break}}function S$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return WE(b,c,d,e,f,1)|0}function Rt(a,b){a:{if(b){break a}if(a>>>0<=3){a=a|-16;break a}a=a>>>2|0}return a&255}function Q$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return WE(b,c,d,e,f,0)|0}function O1(a,b){a=a|0;b=b|0;a=x[a>>1];b=x[b>>1];return(a>>>0<b>>>0?-1:a>>>0>b>>>0)|0}function N1(a,b){a=a|0;b=b|0;a=v[a>>2];b=v[b>>2];return(a>>>0<b>>>0?-1:a>>>0>b>>>0)|0}function Ms(a,b){a=a|0;b=b|0;b=kb-16|0;kb=b;v[b>>2]=a;qK(17891,b);Ls(93696);kb=b+16|0}function MZ(a){a=a|0;a=469384;while(1){a=zb(a-12|0);if((a|0)!=469360){continue}break}}function LZ(a){a=a|0;a=469040;while(1){a=zb(a-12|0);if((a|0)!=468752){continue}break}}function KZ(a){a=a|0;a=468568;while(1){a=zb(a-12|0);if((a|0)!=468400){continue}break}}function J5(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return jF(a,b,c,d,e,12454,999)|0}function I$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return UE(b,c,d,e,f,1)|0}function Gl(a,b,c){a=a|0;b=b|0;c=c|0;if(Rc(a,b)>>>0<=c>>>0){ev();L()}return(c<<1)+a|0}function F4(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return dF(a,b,c,d,e,9645,1028)|0}function xe(a,b,c){if(Sm(a,b,c)){a=bg(a,c);a=Pb(v[a>>2],v[a+4>>2])}else{a=0}return a}function jQ(a,b,c,d,e,f){a=fc(a,b);fc(a+4|0,c);fc(a+8|0,d);fc(a+12|0,e);fc(a+16|0,f)}function cw(a,b){var c=0;while(1){if((b|0)!=(c|0)){Eh(a+c|0);c=c+1|0;continue}break}}function cf(a){a=a|0;var b=0;b=v[a>>2];return(ob[v[v[b>>2]+24>>2]](b)|0)-v[a+8>>2]|0}function Vz(a,b){var c=0;c=v[b+4>>2];v[a>>2]=v[b>>2];v[a+4>>2]=c;v[a+8>>2]=v[b+8>>2]}function Un(a){var b=0;b=a;a=v[a>>2];v[b>>2]=B(a,214013)+2531011;return a>>>16&32767}function UF(a,b){a:{if(!(w[a+120|0]|b>>>0>30)){t[a+120|0]=1;break a}a=Bi(b)}return a}function Jj(a,b,c){var d=0;d=v[a>>2];if(!np(d,v[b>>2])){b=np(v[c>>2],d)?c:a}return b}function Gg(a,b,c){var d=0;d=A[a>>3];if(!TP(d,A[b>>3])){b=TP(A[c>>3],d)?c:a}return b}function Fj(a){t[a|0]=0;t[a+1|0]=0;t[a+2|0]=0;t[a+3|0]=0;t[a+4|0]=0;t[a+5|0]=0;ug(a)}function zl(a,b){var c=0,d=0,e=0;c=v[a+24>>2];d=a,e=Qe(oi(b)*+(c>>>0)),v[d+24>>2]=e}function x9(a,b){a=a|0;b=b|0;return C(b>>>0<=3?C(C(w[(a+b|0)+4264|0])/C(255)):C(0))}function sf(a){a=a|0;v[a+60>>2]=78204;v[a>>2]=78184;Hs(a+8|0);_k(a+60|0);return a|0}function Xd(a){var b=0;b=kb-16|0;kb=b;v[b+12>>2]=49352;jo(a,49248,b+12|0);kb=b+16|0}function S0(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=iH(a,c,d,b);v[a>>2]=78380;return a|0}function QG(a){return(a|0)!=0&(a|0)!=89768&(a|0)!=89792&(a|0)!=467824&(a|0)!=467848}function M6(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return oK(a,b,c,d,0,0,0,0,e)|0}function JF(a){a=a|0;v[a>>2]=84128;if(v[a+8>>2]!=(Gd()|0)){PG(v[a+8>>2])}return a|0}function I8(a,b){a=a|0;b=b|0;return C(b>>>0<=2?C(C(w[(a+b|0)+4232|0])/C(127)):C(0))}function Cp(a){a=a|0;v[a+56>>2]=78040;v[a>>2]=78020;Hs(a+4|0);_k(a+56|0);return a|0}function Cg(a,b){v[a>>2]=v[b>>2];v[a+4>>2]=v[b+4>>2];v[b>>2]=0;v[b+4>>2]=0;return a}function yy(a){var b=0;b=kb-16|0;kb=b;fc(b+8|0,a+116|0);a=QM(a);kb=b+16|0;return a}function p9(a){a=a|0;t[a+4202|0]=1;v[a+4232>>2]=v[v[a+16>>2]+24620>>2];Ts(a);tL(a)}function gp(a,b,c,d){v[a>>2]=b;b=v[b+4>>2];v[a+4>>2]=b;v[a+8>>2]=b+(c<<d);return a}function eI(a,b){b=v[a+32>>2]+b|0;v[a+32>>2]=b;if(b>>>0>=y[a+40>>2]){v[a+96>>2]=1}}function dp(a,b,c,d){v[a>>2]=b;b=v[b+4>>2];v[a+4>>2]=b;v[a+8>>2]=b+B(c,d);return a}function X7(a){a=a|0;t[a+4202|0]=1;v[a+4256>>2]=v[v[a+16>>2]+24620>>2];OK(a);NK(a)}function ON(a,b){var c=0;c=b&15;if(c){t[a+830|0]=c}b=b&240;if(b){t[a+829|0]=b>>>4}}function Et(a,b){a=Ib(a&65535);b=Ib(b&65535);return(a|0)==(b|0)?0:a>>>0<b>>>0?-1:1}function Bg(a){var b=0;b=kb-16|0;kb=b;a=Uo(a,b+8|0);kb=b+16|0;return a?v[b+8>>2]:0}function lo(a,b){a=sc(a,b,34);u[a+34>>1]=x[b+34>>1];sc(a+36|0,b+36|0,68);return a}function _t(a,b,c){while(1){if(b){u[a>>1]=x[c>>1];b=b-1|0;a=a+2|0;continue}break}}function KL(a,b,c){while(1){if(b){z[a>>2]=z[c>>2];b=b-1|0;a=a+4|0;continue}break}}function $P(a){if((w[a+14|0]-53&255)>>>0>=252){a=Sb(a,15608,14)}else{a=1}return!a}function xk(a,b){var c=0;c=v[b+4>>2];v[a>>2]=v[b>>2];v[a+4>>2]=c;kc(a+8|0,b+8|0)}function xf(a){var b=0;b=kb-16|0;kb=b;a=v[fc(b+8|0,Zf(a))>>2];kb=b+16|0;return a}function qK(a,b){var c=0;c=kb-16|0;kb=c;v[c+12>>2]=b;QH(93696,a,b,0,0);kb=c+16|0}function nt(a){var b=0;b=kb-16|0;kb=b;a=v[fc(b+8|0,Mc(a))>>2];kb=b+16|0;return a}function he(a){var b=0;b=kb-16|0;kb=b;a=v[fc(b+8|0,Ac(a))>>2];kb=b+16|0;return a}function eha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return gw(a,b,c,d,e,571)|0}function Zf(a){var b=0;b=kb-16|0;kb=b;a=v[fc(b+8|0,jc(a))>>2];kb=b+16|0;return a}function Tj(a){var b=0;b=kb-16|0;kb=b;a=v[fc(b+8|0,sd(a))>>2];kb=b+16|0;return a}function Gi(a){var b=0;b=kb-16|0;kb=b;a=v[fc(b+8|0,Fb(a))>>2];kb=b+16|0;return a}function uD(a,b,c){while(1){if(b){t[a|0]=w[c|0];b=b-1|0;a=a+1|0;continue}break}}function rZ(a,b,c){a=a|0;b=b|0;c=c|0;return(x[(c<<1)+80016>>1]&b)!=0&c>>>0<=127}function qr(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return gw(a,b,c,d,e,169)|0}function mY(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ob[a|0](b,c,d,e,f)}function bi(a){return(Qj(v[a>>2],v[a+4>>2])|0)!=(0-Qj(v[a+12>>2],v[a+16>>2])|0)}function _v(a,b){b=a+b|0;while(1){b=Ab(b-12|0);if((b|0)!=(a|0)){continue}break}}function Yf(a){var b=0,c=0;Gc(a+4|0);ok(a+8|0,0);b=a,c=jc(a),v[b>>2]=c;return a}function M_(){var a=0,b=0,c=0;a=Vd(469472);v[a>>2]=84128;b=a,c=Gd(),v[b+8>>2]=c}function EU(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return gw(a,b,c,d,e,333)|0}function ko(a){t[a|0]=0;t[a+1|0]=0;t[a+2|0]=0;t[a+3|0]=0;t[a+4|0]=0;t[a+5|0]=0}function hy(a,b){a=a|0;b=b|0;if(v[a+4>>2]!=v[Gb(a)>>2]){IM(a,b);return}eA(a,b)}function hY(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return ob[a|0](b,c,d,e)|0}function g_(a){a=a|0;if(!w[468352]){sn(468340,84364);t[468352]=1}return 468340}function fY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ob[v[v[b>>2]+16>>2]](a,b,c,d,1,8)}function f2(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;return EI(a-88|0,b,c,d,e)|0}function e_(a){a=a|0;if(!w[468384]){sn(468372,84448);t[468384]=1}return 468372}function c_(a){a=a|0;if(!w[468288]){sn(468276,84292);t[468288]=1}return 468276}function a_(a){a=a|0;if(!w[468320]){sn(468308,84328);t[468320]=1}return 468308}function Wu(a,b){return Qe(oi((+(a|0)*128+ +(b|0))*.0006510416666666666)*8363)}function Waa(a,b){a=a|0;b=b|0;if(y[a+4>>2]<y[Gb(a)>>2]){IM(a,b);return}eA(a,b)}function UZ(a){a=a|0;if(!w[468336]){Kc(468324,13470);t[468336]=1}return 468324}function OZ(a){a=a|0;if(!w[468304]){Kc(468292,13724);t[468304]=1}return 468292}function AU(a,b){a=a|0;b=b|0;if(v[a+4>>2]!=v[Gb(a)>>2]){FF(a,b);return}DF(a,b)}function qA(a){if(kf(w[a+11|0])){xd(v[a>>2],0);Hd(a,0);return}xd(a,0);ie(a,0)}function pO(a){v[a>>2]=0;v[a+4>>2]=0;v[a>>2]=-2078137563;v[a+4>>2]=-873292572}function dj(a,b,c){if(v[a+80>>2]){v[a+92>>2]=v[a+92>>2]+(c+7&-8);return}Mb(b)}function cj(a,b){var c=0;c=a;a=(b>>>0)/100|0;return js(js(c,a),B(a,-100)+b|0)}function az(a){var b=0;if(!(w[a+2|0]|(w[a|0]|w[a+1|0]))){b=!w[a+3|0]}return b}function ZP(a,b){a=oR(a,b);t[a+16|0]=w[b+16|0];v[a+12>>2]=v[b+12>>2];return a}function YY(a,b){a=a|0;b=b|0;a=km(a);v[a>>2]=92808;ow(a+4|0,Mc(b));return a|0}function Xx(a,b){if((a|0)>=0){return(a|0)/(b|0)|0}return((a+1|0)/(b|0)|0)-1|0}function SZ(a){a=a|0;if(!w[468368]){Kc(468356,9282);t[468368]=1}return 468356}function SY(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)>=257){Kc(a,7950);return}Mw(a,c)}function Qn(a,b){if((a|0)>=0){return(a|0)%(b|0)|0}return((a^-1)%(b|0)^-1)+b|0}function QZ(a){a=a|0;if(!w[468272]){Kc(468260,5268);t[468272]=1}return 468260}function QY(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)>=257){Kc(a,7880);return}Mw(a,c)}function HY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;if(Zg(a,v[b+8>>2],0)){lw(b,c,d)}}function El(a,b){var c=0,d=0;c=kb-16|0;kb=c;d=c+8|0;iC(d,a);Kl(d,b);kb=c+16|0}function Be(a,b){var c=0,d=0;c=kb-16|0;kb=c;d=c+8|0;nv(d,a);Kl(d,b);kb=c+16|0}function z4(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return on(a,b,c,d,12929,1031)|0}function xG(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ob[v[v[a>>2]+32>>2]](a,b,c,d)|0}function tG(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ob[v[v[a>>2]+48>>2]](a,b,c,d)|0}function qN(a,b,c){var d=0;return!b|!(w[a+35|0]&4?!a|(c|0)!=1:1)?d:w[b+34|0]}function ae(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=v[b+8>>2];$b(b,c);Hv(a,b,d,c)}function ZF(a){var b=0;b=kb-16|0;kb=b;v[b+8>>2]=a;kb=b+16|0;return v[b+8>>2]}function Z7(a,b){a=a|0;b=b|0;return C(b>>>0<=4?z[((b<<2)+a|0)+4220>>2]:C(0))}function Ie(a){var b=0;b=kb-16|0;kb=b;Su(b+8|0,a);kb=b+16|0;return v[b+8>>2]}function Fb(a){var b=0;b=kb-16|0;kb=b;a=v[fc(b+8|0,a)>>2];kb=b+16|0;return a}function D4(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return on(a,b,c,d,12855,1029)|0}function Aj(a){var b=0;b=kb-16|0;kb=b;a=v[Lf(b+8|0,a)>>2];kb=b+16|0;return a}function x4(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return on(a,b,c,d,9678,1032)|0}function v4(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return on(a,b,c,d,9480,1033)|0}function nZ(a,b){a=a|0;b=b|0;if(b>>>0<=127){b=v[(b<<2)+82576>>2]}return b|0}function lZ(a,b){a=a|0;b=b|0;if(b>>>0<=127){b=v[(b<<2)+81040>>2]}return b|0}function lH(a,b,c,d,e,f,g,h){return ob[v[v[a>>2]+16>>2]](a,b,c,d,e,f,g,h)|0}function dL(a){a=a|0;v[a>>2]=46348;wc(a+4276|0);wc(a+4264|0);return If(a)|0}function U$(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return XE(b,c,d,e,1)|0}function Tz(a,b){return(+(a>>>0)+ +(b|0)*4294967296)*2.3283064365386963e-10}function R$(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return XE(b,c,d,e,0)|0}function QO(a,b){b=1/(1/(b*6.283185307179586/3546895)+1);IO(a,b,0,0,b+-1,0)}function Ok(a,b,c){v[a>>2]=b;b=v[b+4>>2];v[a+4>>2]=b;v[a+8>>2]=b+c;return a}function KT(a){var b=0;while(1){b=a;a=v[a>>2];if(a){continue}break}return b}function K$(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return VE(b,c,d,e,1)|0}function J4(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return on(a,b,c,d,9449,1026)|0}function H$(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return VE(b,c,d,e,0)|0}function B4(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return on(a,b,c,d,9600,1030)|0}function $r(a,b,c,d,e,f,g,h){return ob[v[v[a>>2]+12>>2]](a,b,c,d,e,f,g,h)|0}function yg(a,b){var c=0;c=a;a=v[a+8>>2];b=a-b|0;v[c+8>>2]=a>>>0<b>>>0?0:b}function lk(a){var b=0;b=x[a+172>>1];a=x[a+156>>1];return(VP(a)?b:a)&65535}function js(a,b){b=x[(b<<1)+77168>>1];t[a|0]=b;t[a+1|0]=b>>>8;return a+2|0}function Xg(a,b,c){v[a+8>>2]=b;v[a+12>>2]=c;v[a>>2]=0;v[a+4>>2]=0;return a}function UY(a,b,c){a=a|0;b=b|0;c=c|0;return pc(a,v[b+4>>2])&v[b>>2]==(c|0)}function Dv(a,b,c){var d=0;d=b-a|0;if((a|0)!=(b|0)){fj(c,a,d)}return c+d|0}function zt(a,b){var c=0;c=v[b+4>>2];v[a>>2]=v[b>>2];v[a+4>>2]=c;return a}function sd(a){var b=0,c=0,d=0;return b=v[a>>2],c=a,d=kf(w[a+11|0]),d?b:c}function kG(a,b){var c=0,d=0;c=fc(a,v[v[b>>2]-12>>2]+b|0),d=b,v[c+4>>2]=d}function ju(a,b,c){b=b-a|0;if((b|0)>0){sc(v[c>>2],a,b);v[c>>2]=b+v[c>>2]}}function jia(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=c,e=Lo(a,b),v[d>>2]=e}function iia(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=c,e=iv(a,b),u[d>>1]=e}function hd(a,b){a=WD(a,b);v[a+8>>2]=v[b+8>>2];WD(a+12|0,b+12|0);return a}function cS(a,b){t[a+6|0]=255;v[a+16>>2]=b;u[a+4>>1]=0;v[a>>2]=0;return a}function Zc(a,b,c,d,e){t[a+3|0]=e;t[a+2|0]=d;t[a+1|0]=c;t[a|0]=b;return a}function Wk(a,b,c){a=a|0;b=b|0;c=c|0;return ob[v[v[a>>2]+12>>2]](a,b,c)|0}function Rm(a,b,c){a=a|0;b=b|0;c=c|0;return ob[v[v[a>>2]+48>>2]](a,b,c)|0}function Qb(a,b,c){a=a|0;b=b|0;c=c|0;return ob[v[v[a>>2]+32>>2]](a,b,c)|0}function Q8(a,b){a=a|0;b=b|0;a=v[a+20>>2];t[a+24|0]=w[a+24|0]&253|(b?2:0)}function ND(a,b){a=a|0;b=b|0;a=km(a);v[a>>2]=92808;ow(a+4|0,b);return a|0}function MD(a,b){a=Cg(a,b);v[a+8>>2]=v[b+8>>2];Cg(a+12|0,b+12|0);return a}function Zl(a,b){t[a|0]=b;t[a+1|0]=b>>>8;t[a+2|0]=b>>>16;t[a+3|0]=b>>>24}function Kw(a,b){var c=0;c=Ks(a+4|0);v[a>>2]=78832;v[c>>2]=78852;Ln(c,b)}function Jw(a,b){var c=0;c=cH(a+4|0);v[a>>2]=79200;v[c>>2]=79220;Ln(c,b)}function GH(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Xg(a,-1,-1)}function wl(a){if(kf(w[a+11|0])){a=lB(v[a+8>>2])-1|0}else{a=10}return a}function wc(a){var b=0;if(v[a>>2]){Lc(a);b=v[a>>2];Wh(a);Mb(b)}return a}function rfa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;GE(a,b,c,d,e,139)}function rc(a,b){var c=0,d=0;v[a>>2]=b;c=a,d=Pg(b),v[c+4>>2]=d;return a}function lp(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;v[e>>2]=c;return 3}function ex(a){return((wh(a)+(wh(a)<<8)|0)+(wh(a)<<16)|0)+(wh(a)<<24)|0}function aP(a,b){v[a+4>>2]=0;v[a+8>>2]=0;v[a>>2]=b?b:49716;v[a+12>>2]=0}function _K(a){a=a|0;return C(C(C(z[Eb(a+4208|0,5)>>2]*C(198))+C(-99)))}function Xf(a){var b=0;if(v[a>>2]){Lc(a);b=v[a>>2];Br(a);Mb(b)}return a}function WO(a){if(a>>>0<=8){return w[a+29248|0]}return w[a+29239|0]|256}function Vc(a){var b=0;if(v[a>>2]){xC(a,v[a>>2]);b=v[a>>2];yC(a);Mb(b)}}function VU(a,b,c){a=a&255;return a>>>0>=(b&255)>>>0&a>>>0<=(c&255)>>>0}function NI(a){a=a|0;return+(+y[v[a+32>>2]+480240>>2]*152587890625e-16)}function Mia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;GE(a,b,c,d,e,113)}function IQ(a){var b=0;if(v[a>>2]){FQ(a,v[a>>2]);b=v[a>>2];Xj(a);Mb(b)}}function CB(a,b,c){var d=0;d=(b|0)/(c|0)|0;v[a>>2]=d;v[a+4>>2]=b-B(c,d)}function pl(a,b){a=w[Lb(a+62|0,b)|0];return(a<<24>>24>=0?a&127:-1)&255}function mw(a,b,c){if(!(v[a+28>>2]==1|v[a+4>>2]!=(b|0))){v[a+28>>2]=c}}function ir(a){v[a>>2]=0;v[a+4>>2]=0;v[a+8>>2]=0;v[a+12>>2]=0;return a}function gy(a,b){if(b){gy(a,v[b>>2]);gy(a,v[b+4>>2]);dc(b+16|0);Mb(b)}}function dz(a,b){if(b){dz(a,v[b>>2]);dz(a,v[b+4>>2]);wm(b+16|0);Mb(b)}}function _p(a,b){if(b){_p(a,v[b>>2]);_p(a,v[b+4>>2]);yO(b+16|0);Mb(b)}}function YV(a){a=a|0;v[a+16>>2]=v[a+16>>2]|1;if(t[a+20|0]&1){va();L()}}function TR(a){if(Sb(a,13838,4)){a=1}else{a=Sb(a+8|0,13891,4)}return!a}function Sk(a,b){a=a|0;b=b|0;t[a|0]=2;t[a+1|0]=3;t[a+2|0]=0;t[a+3|0]=4}function Oy(a,b){v[a>>2]=v[b>>2];u[a+4>>1]=x[b+4>>1];t[a+6|0]=w[b+6|0]}function NA(a,b){if(b){NA(a,v[b>>2]);NA(a,v[b+4>>2]);MA(b+16|0);Mb(b)}}function Lg(){var a=0;a=mm(ba(4)|0);v[a>>2]=92692;ha(a|0,92768,26);L()}function LA(a,b){if(b){LA(a,v[b>>2]);LA(a,v[b+4>>2]);MA(b+16|0);Mb(b)}}function Gt(a,b){a=a&255;b=b&255;return(a|0)==(b|0)?0:a>>>0<b>>>0?-1:1}function Dz(a,b){a=Tb(a);Nb(a+12|0);u[a+28>>1]=0;v[a+24>>2]=b;return a}function qw(a){a=a|0;if(v[a+8>>2]!=(Gd()|0)){PG(v[a+8>>2])}return a|0}function pY(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ob[a|0](b,c,d,e)}function oM(a,b,c,d){if((b|0)==(d|0)){a=RM(a,b,c,d)}else{a=1}return!a}function kQ(a,b,c,d,e){a=fc(a,b);fc(a+4|0,c);fc(a+8|0,d);fc(a+12|0,e)}function RJ(a,b){var c=0;c=v[a>>2];v[a>>2]=b;if(c){In(c+120|0);Mb(c)}}function Qc(a,b,c,d){if((b|0)==(d|0)){a=jT(a,b,c,d)}else{a=1}return!a}function OM(a,b,c,d,e){v[a+12>>2]=e;v[a+8>>2]=d;v[a+4>>2]=c;v[a>>2]=b}function AY(a){a=a|0;if(!a){return 0}return(Ly(a,92364,92508)|0)!=0|0}function rk(a){var b=0;b=v[a>>2];v[a>>2]=0;if(b){jc(a);if(b){Mb(b)}}}function m0(a){a=a|0;var b=0;b=v[117032]+1|0;v[117032]=b;v[a+4>>2]=b}function iY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return ob[a|0](b,c,d)|0}function bm(a,b){return b?a<<8&16711680|a<<24|(a>>>8&65280|a>>>24):a}function WP(a,b){a=Zz(a,b);t[a+16|0]=w[b+16|0];v[a+12>>2]=v[b+12>>2]}function T_(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Bh(a,f)}function NB(a,b){var c=0;c=kb-16|0;kb=c;YC(c,a,32);aD(c,b);kb=c+16|0}function LS(a,b){v[a>>2]=v[b>>2];u[a+4>>1]=x[b+4>>1];kc(a+8|0,b+8|0)}function Ju(a,b){var c=0;c=kb-16|0;kb=c;YC(c,a,64);aD(c,b);kb=c+16|0}function y4(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return bF(a,b,c,d,4)|0}function w4(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return bF(a,b,c,d,2)|0}function tN(a,b){v[a+852>>2]=v[a+852>>2]+b;t[a+851|0]=w[a+851|0]|64}function mE(a,b){return v[b+8>>2]==v[a+8>>2]&v[a+12>>2]==v[b+12>>2]}function _q(a,b){return lv(v[b>>2],v[b+4>>2],v[a>>2],v[a+4>>2])?b:a}function YB(a,b){return Ar(v[b>>2],v[b+4>>2],v[a>>2],v[a+4>>2])?b:a}function VS(a){t[a+4|0]=0;t[a|0]=0;t[a+1|0]=0;t[a+2|0]=0;t[a+3|0]=0}function Pc(a,b,c){if(uc(a,b)>>>0<=c>>>0){ev();L()}return(c<<2)+a|0}function HM(a,b){var c=0;c=kb-16|0;kb=c;cA(c,1,b);Fc(a,c);kb=c+16|0}function C4(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return cF(a,b,c,d,4)|0}function A4(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return cF(a,b,c,d,2)|0}function uP(a,b){var c=0,d=0;c=fc(a,v[b>>2]),d=w[b+4|0],t[c+4|0]=d}function qF(a,b,c,d){b=Qa(955,a|0,b|0,c|0,d|0)|0;nb=O()|0;return b}function iZ(a,b,c){a=a|0;b=b|0;c=c|0;return(b>>>0<128?b:c)<<24>>24}function WL(a,b){if((a|0)!=(b|0)){zS(a,v[b>>2],v[b+4>>2])}return a}function WF(a,b,c){a:{if((a|0)==(b|0)){t[b+120|0]=0;break a}Mb(b)}}function Oaa(a,b){a=a|0;b=b|0;if(!v[23540]){v[23541]=b;v[23540]=a}}function wS(a,b,c,d){a=je(a,b);u[a+22>>1]=d;u[a+20>>1]=c;return a}function tr(a,b){a=a|0;b=b|0;return ob[v[v[a>>2]+32>>2]](a,0,b)|0}function rn(a,b){if(y[a+4>>2]<y[Gb(a)>>2]){FF(a,b);return}DF(a,b)}function m7(a,b,c){a=a|0;b=b|0;c=c|0;return Ri(a,b,c,925,86224)|0}function lh(a,b,c){a=fc(a,b);MT(a+4|0,v[c>>2],v[c+4>>2]);return a}function jJ(a,b,c){a=a|0;b=b|0;c=c|0;return gJ(a,b,Mc(c),Hb(c))|0}function dX(a){a=a|0;a=v[a+4>>2];return ob[v[v[a>>2]+12>>2]](a)|0}function cX(a){a=a|0;a=v[a+4>>2];return ob[v[v[a>>2]+16>>2]](a)|0}function YH(a,b){a=WH(a-1|0);if(!a){a=WH(b);a=a?a+32|0:0}return a}function Tm(a,b){v[a>>2]=v[(v[v[b>>2]-12>>2]+b|0)+24>>2];return a}function Mc(a){var b=0,c=0,d=0;return b=v[a>>2],c=a,d=ef(a),d?b:c}function LI(a){a=a|0;return+(+v[v[a+32>>2]+1074456>>2]*.00390625)}function Gj(a,b){if(rg(v[a>>2],v[a+4>>2])>>>0>b>>>0){t[a+16|0]=b}}function t7(a,b,c){a=a|0;b=b|0;c=c|0;return Ri(a,b,c,924,4276)|0}function r8(a,b,c){a=a|0;b=b|0;c=c|0;return Ri(a,b,c,917,4280)|0}function mq(a,b,c){a=Ib(a&65535);return(a|0)>=(b|0)&(a|0)<=(c|0)}function m9(a,b,c){a=a|0;b=b|0;c=c|0;return Ri(a,b,c,904,4304)|0}function kd(a){a=(a|0)<32767?a:32767;return(a|0)>-32768?a:-32768}function i8(a,b,c){a=a|0;b=b|0;c=c|0;return Ri(a,b,c,918,4276)|0}function eX(a){a=a|0;a=v[a+4>>2];return ob[v[v[a>>2]+8>>2]](a)|0}function b8(a,b,c){a=a|0;b=b|0;c=c|0;return Ri(a,b,c,919,4268)|0}function TD(a,b,c){a=fn(a);v[a+8>>2]=c;v[a+4>>2]=b;v[a>>2]=62332}function Pja(a,b){a=a|0;b=b|0;a=xu(a,b);v[a>>2]=92964;return a|0}function Oia(a,b){a=a|0;b=b|0;a=xu(a,b);v[a>>2]=93016;return a|0}function O7(a,b,c){a=a|0;b=b|0;c=c|0;return Ri(a,b,c,921,4228)|0}function L8(a,b,c){a=a|0;b=b|0;c=c|0;return Ri(a,b,c,914,4236)|0}function HK(a){return C(C(z[Eb(a+4208|0,11)>>2]*C(19980))+C(20))}function F7(a,b,c){a=a|0;b=b|0;c=c|0;return Ri(a,b,c,922,5048)|0}function Dy(a){Ab(a+48|0);Ab(a+36|0);Ab(a+24|0);Ab(a+12|0);Ab(a)}function C9(a,b,c){a=a|0;b=b|0;c=c|0;return Ri(a,b,c,896,4268)|0}function Ar(a,b,c,d){return a>>>0<c>>>0&(b|0)<=(d|0)|(b|0)<(d|0)}function zw(a,b){a=a|0;b=b|0;return ob[v[v[a>>2]+12>>2]](a,b)|0}function wQ(a){var b=0;if(v[a>>2]){Lc(a);b=v[a>>2];Av(a);Mb(b)}}function wC(a){if(a>>>0>=214748365){Lg();L()}return vc(B(a,20))}function vk(a){var b=0;if(v[a>>2]){Lc(a);b=v[a>>2];Bu(a);Mb(b)}}function tZ(a){a=a|0;a=v[a+8>>2];if(!a){return 1}return HF(a)|0}function qe(a){var b=0;if(v[a>>2]){Lc(a);b=v[a>>2];jn(a);Mb(b)}}function od(a){var b=0;if(v[a>>2]){Lc(a);b=v[a>>2];Zm(a);Mb(b)}}function no(a){var b=0;if(v[a>>2]){Lc(a);b=v[a>>2];SS(a);Mb(b)}}function nO(a){var b=0;if(v[a>>2]){Lc(a);b=v[a>>2];fz(a);Mb(b)}}function lv(a,b,c,d){return(b|0)==(d|0)&a>>>0<c>>>0|b>>>0<d>>>0}function gE(a){if(a>>>0>=357913942){Lg();L()}return vc(B(a,12))}function dja(a,b){a=a|0;b=b|0;a=JT(a,b);if(!a){IT(b)}return a|0}function aN(a){var b=0;if(v[a>>2]){Lc(a);b=v[a>>2];NU(a);Mb(b)}}function a7(a,b){a=a|0;b=b|0;if(!b){return 3}v[b>>2]=a;return 0}function _r(a,b){a=a|0;b=b|0;return ob[v[v[a>>2]+44>>2]](a,b)|0}function Zd(a){var b=0;if(v[a>>2]){qV(a);b=v[a>>2];LB(a);Mb(b)}}function UH(a){var b=0;b=kb-16|0;z[b+12>>2]=a;return z[b+12>>2]}function TM(a){var b=0;if(v[a>>2]){bt(a);b=v[a>>2];at(a);Mb(b)}}function Sn(a,b,c,d){a=Gt(a,c);if(yj(a)){a=vO(b,d)}return kf(a)}function Pt(a){var b=0;if(v[a>>2]){Lc(a);b=v[a>>2];Gb(a);Mb(b)}}function Ps(a){var b=0;if(v[a>>2]){Lc(a);b=v[a>>2];Tx(a);Mb(b)}}function PO(a,b){a=a|0;b=b|0;a=xu(a,b);v[a>>2]=92828;return a|0}function Nt(a){var b=0;if(v[a>>2]){Lc(a);b=v[a>>2];Uz(a);Mb(b)}}function Nc(a){var b=0;if(ef(a)){b=v[a>>2];Il(a);Mb(b)}return a}function LM(a){var b=0;if(v[a>>2]){Zo(a);b=v[a>>2];Av(a);Mb(b)}}function Kba(a,b){a=a|0;b=b|0;a=QS(a,b);if(!a){PS(b)}return a|0}function Jr(a){var b=0;b=kb-16|0;A[b+8>>3]=a;return A[b+8>>3]*a}function IK(a){return C(C(z[Eb(a+4208|0,0)>>2]*C(1e4))+C(-1e4))}function Hl(a,b){a=a|0;b=b|0;return ob[v[v[a>>2]+28>>2]](a,b)|0}function Gp(a,b,c){if(!b){return 0}return Ss(a,Mf(c<<24>>24),b)}function FO(a){var b=0;if(v[a>>2]){AO(a);b=v[a>>2];Xj(a);Mb(b)}}function Ei(a){var b=0;if(v[a>>2]){Lc(a);b=v[a>>2];mo(a);Mb(b)}}function EQ(a){var b=0;if(v[a>>2]){Lc(a);b=v[a>>2];Xj(a);Mb(b)}}function De(a){var b=0;b=v[a>>2];v[a>>2]=0;if(b){ZJ(b)}return a}function Bz(a){var b=0;if(v[a>>2]){iP(a);b=v[a>>2];mo(a);Mb(b)}}function Bm(a){var b=0;if(v[a>>2]){Lc(a);b=v[a>>2];Lt(a);Mb(b)}}function zv(a,b){a=ad(a,b);kc(a+12|0,b+12|0);eg(a+32|0,b+32|0)}function zA(a,b){a=a|0;b=b|0;a=Uo(a,b);if(!a){Pm(b)}return a|0}function xM(a,b,c,d){u[a+4>>1]=c;t[a+6|0]=b;v[a>>2]=d;return a}function wo(a,b){a=a|0;b=b|0;a=GU(a,b);if(!a){JU(b)}return a|0}function vv(a,b){a=a|0;b=b|0;a=pD(a,b);if(!a){hr(b)}return a|0}function ur(a,b){a=a|0;b=b|0;a=xD(a,b);if(!a){Mv(b)}return a|0}function pV(a,b){if(!b){return-1}b=Gp(a,b,0);return b?b-a|0:-1}function k$(a,b){a=a|0;b=b|0;rN(a,Tw(v[b>>2])<<24>>24,v[b>>2])}function iO(a,b){a=a|0;b=b|0;a=WU(a,b);if(!a){Cu(b)}return a|0}function fg(a,b){return ob[v[v[a>>2]+32>>2]](a,v[a+12>>2],b)|0}function er(a,b){var c=0;c=b+1|0;v[a>>2]=v[a>>2]>(c|0)?c:b+2|0}function ei(a,b){a=a|0;b=b|0;a=Jh(a,b);if(!a){Uj(b)}return a|0}function eT(a){if(a>>>0>=715827883){Lg();L()}return vc(B(a,6))}function cr(a,b,c){a=a|0;b=b|0;c=c|0;Vh(a,b,zi(b,b+c|0,62428))}function bc(a){return a<<8&16711680|a<<24|(a>>>8&65280|a>>>24)}function bR(a){return w[a+15|0]<<12|w[a+14|0]<<4|w[a+13|0]<<20}function bC(a,b){a=a|0;b=b|0;a=Lu(a,b);if(!a){Qu(b)}return a|0}function YK(a){a=a|0;return wj(C(z[Eb(a+4208|0,4)>>2]*C(4)))|0}function Xt(a,b){a=a|0;b=b|0;a=HU(a,b);if(!a){Au(b)}return a|0}function UA(a,b){a=a|0;b=b|0;a=bT(a,b);if(!a){HA(b)}return a|0}function TL(a){if(a>>>0>=82595525){Lg();L()}return vc(B(a,52))}function Q3(a,b,c){a=a|0;b=b|0;c=c|0;BP(a,0,v[b+1298404>>2],c)}function Iv(a,b){a=a|0;b=b|0;a=ED(a,b);if(!a){DD(b)}return a|0}function xia(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;LE(a,b,c,d,113)}function via(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;IE(a,b,c,d,462)}function vh(a,b,c){return(x[((c&255)<<1)+a>>1]&b)!=0&(c|0)>=0}function mka(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;LE(a,b,c,d,139)}function bJ(a,b){a=(a+b|0)-1|0;return a-((a>>>0)%(b>>>0)|0)|0}function XD(a,b){var c=0;c=v[a>>2];v[a>>2]=b;if(c){Mb(ic(c))}}function W7(a,b,c){a=a|0;b=b|0;c=c|0;return iw(a,b,c,0,920)|0}function UM(a,b){var c=0;c=v[a>>2];v[a>>2]=b;if(c){Mb(Gm(c))}}function P7(a,b,c){a=a|0;b=b|0;c=c|0;return iw(a,b,c,1,920)|0}function Nl(a,b,c){v[a+4>>2]=c;v[a>>2]=b;if(c){dn(c)}return a}function Eja(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;IE(a,b,c,d,355)}function Eg(a,b,c,d,e,f){return Sa(a|0,b|0,c|0,d|0,e|0,f|0)|0}function DM(a,b){return b>>>0<4e3?((b<<5)+a|0)+946304|0:21688}function Bi(a){if(a>>>0>=1073741824){Lg();L()}return vc(a<<2)}function B8(a,b,c){a=a|0;b=b|0;c=c|0;return iw(a,b,c,0,916)|0}function s8(a){a=a|0;return C(C(z[Eb(a+4208|0,6)>>2]*C(20)))}function qc(a,b){var c=0;c=v[a>>2];v[a>>2]=v[b>>2];v[b>>2]=c}function my(a,b){var c=0;c=x[a>>1];u[a>>1]=x[b>>1];u[b>>1]=c}function eQ(a){if(a>>>0>=268435456){Lg();L()}return vc(a<<4)}function aba(a){a=a|0;a=xu(a,21688);v[a>>2]=92908;return a|0}function aQ(a){if(a>>>0>=134217728){Lg();L()}return vc(a<<5)}function ZK(a){a=a|0;return C(C(z[Eb(a+4208|0,2)>>2]*C(10)))}function YM(a){v[a>>2]=0;Tb(a+4|0);Ub(a+16|0,0,144);return a}function XW(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;gc(a,v[d>>2],0)}function X8(a){a=a|0;a=jj(a);if(a){ob[v[v[a>>2]+100>>2]](a)}}function WH(a){return t[(B(0-a&a,124511785)>>>27|0)+73808|0]}function Sg(a,b,c,d){nb=b-((a>>>0<c>>>0)+d|0)|0;return a-c|0}function PI(a){a=a|0;return+(65536/+y[v[a+32>>2]+480244>>2])}function Ox(a){a=a|0;v[a+32>>2]=0;v[a+28>>2]=v[a+28>>2]&-7|2}function Hs(a){a=a|0;v[a>>2]=77504;zb(a+32|0);return Mn(a)|0}function FD(a){if(a>>>0>=536870912){Lg();L()}return vc(a<<3)}function z5(a,b){a=a|0;b=b|0;return C(hF(a,b,6133,1075835))}function yA(a,b){if(b){yA(a,v[b>>2]);yA(a,v[b+4>>2]);Mb(b)}}function xu(a,b){a=km(a);v[a>>2]=92788;ow(a+4|0,b);return a}function wI(a,b){a=a|0;b=+b;ZE(a,b,1e4,1074420,9392,512,32)}function ux(a,b,c,d,e,f){return $E(a,b,c,d,e,f,57924,58720)}function uS(a){var b=0;b=v[a+100>>2];v[a+100>>2]=0;return b}function tx(a,b,c,d,e,f){return $E(a,b,c,d,e,f,58800,59564)}function nY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ob[a|0](b,c,d)}function mZ(a,b,c){a=a|0;b=b|0;c=c|0;return TE(b,c,82576)|0}function ki(a,b){var c=0,d=0;c=a,d=NG(b),v[c>>2]=d;return a}function kZ(a,b,c){a=a|0;b=b|0;c=c|0;return TE(b,c,81040)|0}function gt(a,b){if(b){gt(a,v[b>>2]);gt(a,v[b+4>>2]);Mb(b)}}function ft(a,b){if(b){ft(a,v[b>>2]);ft(a,v[b+4>>2]);Mb(b)}}function eZ(a,b,c){a=a|0;b=b|0;c=c|0;return SE(b,c,82576)|0}function dV(a){return!Sb(a,14192,4)&(w[a+4|0]-1&255)>>>0<10}function cZ(a,b,c){a=a|0;b=b|0;c=c|0;return SE(b,c,81040)|0}function bB(a,b){if(b){bB(a,v[b>>2]);bB(a,v[b+4>>2]);Mb(b)}}function al(a){var b=0;b=v[a>>2];v[a>>2]=0;if(b){Mb(Xf(b))}}function aB(a,b){if(b){aB(a,v[b>>2]);aB(a,v[b+4>>2]);Mb(b)}}function Wga(a,b,c){a=a|0;b=b|0;c=c|0;return NE(a,b,c,37)|0}function Rz(a,b){if(b){Rz(a,v[b>>2]);Rz(a,v[b+4>>2]);Mb(b)}}function Qz(a,b){if(b){Qz(a,v[b>>2]);Qz(a,v[b+4>>2]);Mb(b)}}function QD(a,b){return VA(a,sd(b),Ad(v[b+4>>2],w[b+11|0]))}function Q7(a){a=a|0;return C(C(z[Eb(a+4208|0,6)>>2]*C(4)))}function Nn(a,b){return(((a<<12&b>>31)+b|0)/4096|0)%(a|0)|0}function KH(a,b){if(b>>>0<=9){return JH(a,b)}return js(a,b)}function JW(a){a=a|0;a=OD(a,13307);v[a>>2]=26140;return a|0}function Gq(a){return v[a+20>>2]+(v[a+8>>2]-v[a+24>>2]|0)|0}function Ev(a){var b=0;b=a;a=v[a>>2]-1|0;v[b>>2]=a;return a}function EJ(a,b){a=a|0;b=b|0;return Th(v[b>>2],v[b+4>>2])|0}function DJ(a,b){a=a|0;b=b|0;return $d(v[b>>2],v[b+4>>2])|0}function D5(a,b){a=a|0;b=b|0;return C(hF(a,b,6232,1075834))}function BN(a){var b=0;b=v[a>>2];v[a>>2]=0;if(b){Mb(Py(b))}}function B5(a,b){a=a|0;b=b|0;return C(gF(a,b,6275,1075834))}function A5(a,b){a=a|0;b=b|0;return C(gF(a,b,6177,1075835))}function qo(a){var b=0;b=v[a>>2];v[b>>2]=v[b>>2]|v[a+4>>2]}function qX(a){a=a|0;a=OD(a,8733);v[a>>2]=30564;return a|0}function dy(a,b,c){A[a>>3]=A[a>>3]+b;A[a+8>>3]=A[a+8>>3]+c}function aZ(a,b,c){a=a|0;b=b|0;c=c|0;return((b|0)<0?c:b)|0}function YX(a){a=a|0;a=PO(a,7985);v[a>>2]=41896;return a|0}function W3(a,b,c){a=a|0;b=b|0;c=c|0;ad(a,gJ(c,0,b,Pg(b)))}function Q0(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;nb=0;return 0}function P3(a){a=a|0;bK(a,2,100);Gj(v[a+24>>2]+484360|0,0)}function Hb(a){if(ef(a)){return v[a+4>>2]}return w[a+11|0]}function HR(a){var b=0;a=a+8|0;b=a>>>0<8?1:b;nb=b;return a}function Dq(a,b,c){if((a|0)!=(b|0)){b=b-a|0;fj(c-b|0,a,b)}}function Cn(a,b,c,d){v[a+16>>2]=d;v[a+12>>2]=c;v[a+8>>2]=b}function xE(a,b,c){a=a|0;b=b|0;c=c|0;vu(a,b,c);return a|0}function vq(a,b){if(kf(w[a+11|0])){Hd(a,b);return}ie(a,b)}function nV(a,b){t[a|0]=w[b|0];t[a+1|0]=w[b+1|0];return a}function kI(a){while(1){if((ps(a)|0)!=-1){continue}break}}function jx(a,b){return v[((a>>>24^b)<<2)+463040>>2]^a<<8}function io(a){v[a>>2]=0;v[a+4>>2]=0;ok(a+8|0,0);return a}function gia(a,b,c){a=a|0;b=b|0;c=c|0;Vh(a,b,fd(b,c)+b|0)}function eu(a,b){var c=0;c=v[a>>2];v[a>>2]=b;if(c){Mb(c)}}function XF(a){if(v[a>>2]){Lc(a);WF(rw(a),v[a>>2],Wh(a))}}function Wo(a){a=UD(a);v[a+8>>2]=0;v[a>>2]=89692;return a}function Uf(a){var b=0;XP(a);b=v[a>>2];if(b){Lz(a);Mb(b)}}function Tp(a){return((a-65&255)>>>0<26?a+32|0:a)<<24>>24}function QJ(a,b){var c=0;c=v[a>>2];v[a>>2]=b;if(c){ZJ(c)}}function Pw(a,b,c){v[a+28>>2]=c;v[a+20>>2]=b;v[a+24>>2]=b}function MI(a,b){a=a|0;b=+b;ZE(a,b,256,1074456,11741,1,0)}function Hc(a,b){return OE(a,b,2147483647,-2147483648,-1)}function yN(a,b){a=xN(a,b);xN(a+12|0,b+12|0);t[a+24|0]=1}function uh(a,b,c){t[a|0]=w[a|0]|b;v[a+4>>2]=v[a+4>>2]|c}function sX(a,b,c){a=a|0;b=b|0;c=c|0;Hv(a,b,v[b+8>>2],c)}function sB(a,b){t[v[a>>2]]=w[b|0];t[v[a+4>>2]]=w[b+1|0]}function oz(a,b){A[a>>3]=A[a>>3]*b;A[a+8>>3]=A[a+8>>3]*b}function o5(a,b){a=a|0;b=b|0;return pn(a,b,11771,1007)|0}function m5(a,b){a=a|0;b=b|0;return mF(a,b,13279,1008)|0}function gK(a,b){dn(v[b>>2]);hn(v[a>>2]);v[a>>2]=v[b>>2]}function ej(a){return $e(a)|$e(a)<<8|$e(a)<<16|$e(a)<<24}function bu(a){wc(a+88|0);wc(a+68|0);wc(a+48|0);return a}function b5(a,b){a=a|0;b=b|0;return pn(a,b,11806,1015)|0}function _I(a){a=a|0;v[a>>2]=61676;ic(a+12|0);return a|0}function _4(a,b){a=a|0;b=b|0;return pn(a,b,11836,1017)|0}function T1(a,b,c){a=a|0;b=b|0;c=c|0;return Pd(B(b,c))|0}function S4(a,b){a=a|0;b=b|0;return pn(a,b,11932,1020)|0}function RF(a){a=a|0;v[a>>2]=84216;zb(a+16|0);return a|0}function QF(a){a=a|0;v[a>>2]=84176;zb(a+12|0);return a|0}function Pm(a){t[a|0]=0;t[a+1|0]=0;t[a+2|0]=0;t[a+3|0]=0}function P4(a,b){a=a|0;b=b|0;return pn(a,b,11900,1021)|0}function Kt(a,b){qc(a,b);qc(a+4|0,b+4|0);qc(Gb(a),Gb(b))}function FH(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Xg(a,-1,-1)}function Dh(a,b){var c=0;c=w[a|0];t[a|0]=w[b|0];t[b|0]=c}function xs(a){a=a|0;v[a>>2]=49396;vx(a+4|0);return a|0}function xU(a){a=a|0;v[a>>2]=92788;vF(a+4|0);return a|0}function waa(a,b,c){a=a|0;b=b|0;c=c|0;zE(a,b,c,867,866)}function vF(a){a=px(v[a>>2]);if((Ev(a+8|0)|0)<0){Mb(a)}}function uI(a,b,c){v[a+4>>2]=0;v[a>>2]=b;v[a+8>>2]=c<<3}function u8(a){a=a|0;return z[Eb(a+4208|0,3)>>2]<C(1)|0}function oF(a,b,c,d,e){return Ja(a|0,b|0,c|0,d|0,e|0)|0}function jo(a,b,c){v[a>>2]=b;v[a+4>>2]=v[c>>2];return a}function iB(a){a=a&255;return $c(a)^1|(a-49&255)>>>0<36}function eJ(a){a=a|0;v[a>>2]=62140;ic(a+4|0);return a|0}function ds(a){a=a|0;v[a>>2]=77440;ac(a+4|0);return a|0}function dM(a){return(a|0)==1179012417|(a|0)==538987841}function bd(a){if(ef(a)){a=Il(a)-1|0}else{a=10}return a}function Yo(a){var b=0;b=v[a+8>>2];v[a+8>>2]=0;return b}function VF(a){var b=0;b=v[a>>2];v[a>>2]=0;if(b){hn(b)}}function Tb(a){v[a>>2]=0;v[a+4>>2]=0;Gc(a+8|0);return a}function S7(a){a=a|0;return z[Eb(a+4208|0,1)>>2]<C(1)|0}function Mn(a){a=a|0;v[a>>2]=77376;ac(a+4|0);return a|0}function KD(a){a=a|0;v[a>>2]=43168;le(a+4|0);return a|0}function I7(a){a=a|0;MK(a);t[a+4202|0]=1;v[a+4224>>2]=0}function H5(a,b){a=a|0;b=b|0;return pn(a,b,11868,1e3)|0}function Gv(a){a=a|0;v[a>>2]=92808;vF(a+4|0);return a|0}function GG(a,b,c){a=fc(a,b);fc(a+4|0,v[c>>2]);return a}function Ed(a,b,c){return a>>>0<b>>>0?b:a>>>0<c>>>0?a:c}function Cba(a,b,c){a=a|0;b=b|0;c=c|0;zE(a,b,c,796,795)}function wh(a){var b=0;b=ps(a);v[a+1396>>2]=0;return b}function wfa(a,b){a=a|0;b=b|0;Tl(a,b,259,1042,-1332,2)}function wH(a){a=a|0;return es(v[v[a>>2]-12>>2]+a|0)|0}function vp(a){return w[a+2|0]&2?(w[a+1|0]&6)==6?4:1:0}function vn(a){if(ef(a)){a=Il(a)-1|0}else{a=1}return a}function vO(a,b){return(a|0)==(b|0)?0:a>>>0<b>>>0?-1:1}function u0(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Vh(a,c,d)}function r0(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;JG(a,c,d)}function qY(a){a=a|0;a=ob[a|0]()|0;ra(nb|0);return a|0}function pF(a,b,c,d,e,f){Oa(a|0,b|0,c|0,d|0,e|0,f|0,1)}function nia(a,b){a=a|0;b=b|0;Tl(a,b,101,1042,-1332,2)}function mx(a){return(a&6)==6?384:1152>>>((a&14)==2)|0}function lea(a,b){a=a|0;b=b|0;if(!ER(a,b)){Ub(b,0,40)}}function hM(a,b){return B(b&65535,a&65535)+7>>>3&65535}function fia(a,b){a=a|0;b=b|0;return Kc(a,b?b:21688)|0}function dm(a,b){v[a+16>>2]=!v[a+24>>2]|(v[a+16>>2]|b)}function d$(a,b){a=a|0;b=b|0;hc(a,nH(v[b>>2]),v[b>>2])}function bh(a,b){a=a|0;b=b|0;ob[v[v[b>>2]+20>>2]](a,b)}function _L(a,b){return(b>>>0<=45?t[a+b|0]:63)<<24>>24}function Zb(a,b,c){return(a|0)<(b|0)?b:(a|0)<(c|0)?a:c}function Z0(a){a=a|0;return Cp(v[v[a>>2]-12>>2]+a|0)|0}function X0(a){a=a|0;return sf(v[v[a>>2]-12>>2]+a|0)|0}function Qh(a,b){a=a|0;b=b|0;ob[v[v[b>>2]+24>>2]](a,b)}function Ph(a,b){a=a|0;b=b|0;ob[v[v[b>>2]+28>>2]](a,b)}function Lia(a,b){a=a|0;b=b|0;Tl(a,b,405,1042,-1332,2)}function K6(a,b){a=a|0;b=b|0;return mF(a,b,6435,948)|0}function CH(a){a=a|0;return fs(v[v[a>>2]-12>>2]+a|0)|0}function $L(a,b){return(b>>>0<=15?t[a+b|0]:63)<<24>>24}function zB(a,b){a=je(a,b);Ub(a+20|0,0,1040);return a}function yc(a,b){a=a|0;b=b|0;RD(a,b,pr(b));return a|0}function y0(a,b){a=a|0;b=b|0;Tl(a,b,101,1025,-1284,2)}function xn(a,b){return ob[v[v[a>>2]+36>>2]](a,b,0)|0}function wn(a,b){return ob[v[v[a>>2]+52>>2]](a,b,0)|0}function rr(a,b){a=kc(a,b);Ub(a+20|0,0,1040);return a}function pf(a,b,c,d){t[a+8|0]=d;v[a+4>>2]=c;v[a>>2]=b}function o9(a,b,c){a=a|0;b=b|0;c=c|0;hc(a,b+4260|0,8)}function nha(a,b,c){a=a|0;b=b|0;c=c|0;zS(a,b,Eb(b,c))}function lL(a){wc(a+36|0);wc(a+24|0);Ps(a+12|0);Ps(a)}function iha(a,b,c){a=a|0;b=b|0;c=c|0;ad(a,jJ(c,0,b))}function ic(a){if(v[a>>2]){Lc(a);Mb(v[a>>2])}return a}function e3(a,b){a=a|0;b=b|0;hO(v[a>>2],b);return a|0}function _i(a){a=a|0;return ob[v[v[a>>2]+12>>2]](a)|0}function Vg(a){a=a|0;return ob[v[v[a>>2]+24>>2]](a)|0}function TV(a,b){a=a|0;b=b|0;Tl(a,b,259,1025,-1284,2)}function Qf(a,b,c,d){b=b+d|0;nb=a+c>>>0<c>>>0?b+1|0:b}function Py(a){Wp(a+223860|0);ic(a+223848|0);return a}function Kc(a,b){a=a|0;b=b|0;vu(a,b,Pg(b));return a|0}function KG(a,b,c){a=LG(a,b,c,0,-2147483648);return a}function G0(a,b){a=a|0;b=b|0;Tl(a,b,101,1025,-1284,4)}function D8(a,b,c){a=a|0;b=b|0;c=c|0;hc(a,b+4228|0,7)}function Cv(a,b,c){v[a+4>>2]=c;v[a>>2]=b;if(c){dn(c)}}function Ab(a){if(kf(w[a+11|0])){Mb(v[a>>2])}return a}function $i(a){a=a|0;return ob[v[v[a>>2]+16>>2]](a)|0}function vga(a,b,c){a=a|0;b=b|0;c=c|0;FE(a,b,c,14,2)}function uv(a){a=a|0;return ob[v[v[a>>2]+8>>2]](a)|0}function uL(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0}function sE(a,b,c,d){return ep(a,b,c,d,24,178956971)}function kV(a,b,c,d){return ep(a,b,c,d,28,153391690)}function jD(a,b){return(w[b+34|0]&8)>>>3&(a&2050)==2}function iD(a){return VH(a,C(2.524354896707238e-29))}function de(a,b,c){t[a|0]=b;t[a+1|0]=w[c|0];return a}function cY(a,b){a=a|0;b=b|0;Tl(a,b,12,1058,-1332,2)}function Ys(a){a=a|0;a=Kh(a);v[a+20>>2]=0;return a|0}function V8(a){a=a|0;t[a+4202|0]=1;Qs(a);Nx(a);mL(a)}function JD(a){return VH(a,C(1.5845632502852868e29))}function Ika(a){if(a){return 31-E(a-1^a)|0}return 32}function Gz(a){a=Tb(a);v[a+12>>2]=0;u[a+16>>1]=65280}function Eq(a,b,c,d,e){hc(a,b+d|0,(e|0)==-1?c-d|0:e)}function AD(a,b,c,d){return ep(a,b,c,d,36,119304648)}function xj(a){if(!a){return 0}return v[a+44>>2]!=0}function un(a,b,c){v[a>>2]=b;v[a+4>>2]=c-b;return a}function t8(a){a=a|0;return C(z[Eb(a+4208|0,1)>>2])}function q_(){Vd(469704);TF(469712);v[117426]=87064}function oj(a){if(!a){return 0}return vj(w[a+31|0])}function o_(){Vd(469720);TF(469728);v[117430]=87220}function mO(a,b,c,d){return ep(a,b,c,d,7,613566757)}function lha(a,b,c){a=a|0;b=b|0;c=c|0;KE(a,b,c,256)}function j2(a,b,c){a=a|0;b=b|0;c=c|0;II(a-88|0,b,c)}function iga(a,b){a=a|0;b=b|0;return fi(a,b,1030)|0}function hs(a,b){v[a>>2]=b;v[a+4>>2]=b>>31;return a}function h2(a,b,c){a=a|0;b=b|0;c=c|0;GI(a-88|0,b,c)}function ce(a){var b=0;b=v[a>>2];v[a>>2]=0;return b}function cD(a){if((a|0)<0){Lg();L()}return vc(a<<1)}function bx(a){if(!a){return 0}v[116016]=a;return-1}function YC(a,b,c){t[a+8|0]=1;v[a+4>>2]=c;v[a>>2]=b}function X3(a){a=a|0;a=v[a+4>>2];return(a?a:5014)|0}function We(a){var b=0;b=v[a>>2];if(b){Gb(a);Mb(b)}}function Vo(a){a=a|0;a=Cc(a);ob[v[v[a>>2]>>2]](a)|0}function Sha(a){a=a|0;Gm(94192);KA(94184);zb(94172)}function R7(a){a=a|0;return C(z[Eb(a+4208|0,3)>>2])}function QU(a,b,c,d){return ep(a,b,c,d,48,89478486)}function Oz(a){t[a+6|0]=0;u[a+4>>1]=65535;v[a>>2]=0}function Ov(a,b){a=a|0;b=b|0;return VA(a,b,pr(b))|0}function Op(a,b,c){if(!c){return 0}return Sb(a,b,c)}function Oo(a,b,c){hc(a,(c>>>3&536870908)+b|0,c&31)}function NO(a,b){v[a+8>>2]=0;v[a+12>>2]=0;A[a>>3]=b}function Kga(a,b,c){a=a|0;b=b|0;c=c|0;FE(a,b,c,5,3)}function Gka(a,b){a=a|0;b=b|0;$v(a,b,259,274,-1332)}function Db(a,b,c){hc(a,(c>>>3&536870908)+b|0,1<<c)}function Ap(a,b){b=v[b>>2];v[a>>2]=b;dn(b);return a}function Aea(a,b,c){a=a|0;b=b|0;c=c|0;ad(a,Ov(b,c))}function $fa(a,b){a=a|0;b=b|0;return Hr(a,b,1100)|0}function $K(a){a=a|0;return C(z[Eb(a+4208|0,0)>>2])}function tm(a){nj(a+724|0);nj(a+732|0);nj(a+740|0)}function tka(a,b,c){a=a|0;b=b|0;c=c|0;Fr(a,b,c,80)}function taa(a,b){a=a|0;b=b|0;return fi(a,b,225)|0}function qaa(a,b){a=a|0;b=b|0;return fi(a,b,326)|0}function l2(a,b,c){a=a|0;b=b|0;c=+c;KI(a-88|0,b,c)}function iE(a,b,c){a=a|0;b=b|0;c=c|0;ad(a,QD(b,c))}function i2(a,b){a=a|0;b=b|0;return HI(a-88|0,b)|0}function g2(a,b){a=a|0;b=b|0;return FI(a-88|0,b)|0}function f1(a,b){a=a|0;b=b|0;return fp(a,b,1099)|0}function dha(a,b){a=a|0;b=b|0;return fi(a,b,422)|0}function bja(a,b){a=a|0;b=b|0;return fi(a,b,308)|0}function ao(a,b,c){if((a|0)!=(b|0)){fj(c,a,b-a|0)}}function a1(a,b){a=a|0;b=b|0;return fp(a,b,1097)|0}function _ga(a,b){a=a|0;b=b|0;return fi(a,b,826)|0}function Z1(a,b,c){a=a|0;b=b|0;c=+c;yI(a-92|0,b,c)}function V0(a,b){a=a|0;b=b|0;return fp(a,b,1098)|0}function Mm(a){a=(a|0)<120?a:120;return(a|0)>1?a:1}function Kia(a,b,c){a=a|0;b=b|0;c=c|0;Dr(a,b,c,85)}function I3(a,b){a=a|0;b=b|0;return fp(a,b,1094)|0}function Hga(a,b,c){a=a|0;b=b|0;c=c|0;Fr(a,b,c,79)}function Gga(a,b,c){a=a|0;b=b|0;c=c|0;Fr(a,b,c,78)}function Ek(a,b){return(a&65535)>>>0<(b&65535)>>>0}function E1(a,b){a=a|0;b=b|0;return fp(a,b,1095)|0}function AS(a,b,c){a=a|0;b=b|0;c=c|0;ad(a,wF(b,c))}function $1(a,b,c){a=a|0;b=b|0;c=+c;AI(a-92|0,b,c)}function yC(a){return(v[Gb(a)>>2]-v[a>>2]|0)/20|0}function xm(a,b,c){v[a+4>>2]=c;u[a>>1]=b;return a}function x7(a,b){a=a|0;b=b|0;return C(Ul(a,b,12))}function x2(a,b,c){a=a|0;b=b|0;c=c|0;AE(a,b,c,61)}function vaa(a,b){a=a|0;b=b|0;return fi(a,b,73)|0}function tF(a){return(a<<1)+16777216>>>0<16777217}function t5(a){a=a|0;return hw(a,12786,1074416)|0}function sga(a,b){a=a|0;b=b|0;if(!Lu(a,b)){Qu(b)}}function qR(a){return(v[Gb(a)>>2]-v[a>>2]|0)/56|0}function q0(a,b,c){a=a|0;b=b|0;c=c|0;Dr(a,b,c,86)}function p2(a,b,c){a=a|0;b=b|0;c=c|0;CE(a,b,c,72)}function oaa(a,b){a=a|0;b=b|0;return fi(a,b,60)|0}function nl(a,b,c){A[a+8>>3]=c;A[a>>3]=b;return a}function ija(a,b){a=a|0;b=b|0;if(!JT(a,b)){IT(b)}}function hja(a,b){a=a|0;b=b|0;return fi(a,b,78)|0}function hc(a,b,c){v[a+4>>2]=c;v[a>>2]=b;return a}function eM(a,b){return(a|0)==1179011410&b>>>0>80}function dka(a,b){a=a|0;b=b|0;if(!WU(a,b)){Cu(b)}}function dY(a,b){a=a|0;b=b|0;$v(a,b,12,290,-1332)}function cm(a,b,c){v[a>>2]=b;v[a+4>>2]=c;return a}function at(a){return(v[Gb(a)>>2]-v[a>>2]|0)/52|0}function _G(a){return(bk(a)|0)!=0|(a|32)-97>>>0<6}function Yp(a,b){v[a+4>>2]=256;v[a>>2]=b;return a}function Xj(a){return(v[Gb(a)>>2]-v[a>>2]|0)/12|0}function UD(a){v[a+4>>2]=0;v[a>>2]=92260;return a}function Sh(a,b){if(ef(a)){Hd(a,b);return}ie(a,b)}function SS(a){return(v[Gb(a)>>2]-v[a>>2]|0)/33|0}function Rfa(a,b){a=a|0;b=b|0;return fi(a,b,71)|0}function Q2(a,b,c){a=a|0;b=b|0;c=c|0;CE(a,b,c,61)}function OD(a,b){a=ND(a,b);v[a>>2]=93068;return a}function NV(a,b,c){a=a|0;b=b|0;c=c|0;Dr(a,b,c,81)}function NU(a){return(v[Gb(a)>>2]-v[a>>2]|0)/48|0}function MC(a){return!Sb(a,26224,25)&w[a+34|0]<65}function M1(a,b,c){a=a|0;b=b|0;c=c|0;BE(a,b,c,72)}function LB(a){return(v[Gb(a)>>2]-v[a>>2]|0)/28|0}function L1(a,b,c){a=a|0;b=b|0;c=c|0;AE(a,b,c,72)}function IW(a,b,c){a=a|0;b=b|0;c=c|0;Dr(a,b,c,87)}function HX(a,b){a=a|0;b=b|0;$v(a,b,12,257,-1284)}function Fha(a,b){a=a|0;b=b|0;return fi(a,b,91)|0}function C2(a,b,c){a=a|0;b=b|0;c=c|0;Fr(a,b,c,74)}function Br(a){return(v[Gb(a)>>2]-v[a>>2]|0)/24|0}function Baa(a,b){a=a|0;b=b|0;if(!xD(a,b)){Mv(b)}}function BT(a){if(!(a&255)){return 1}return $c(a)}function B2(a,b,c){a=a|0;b=b|0;c=c|0;BE(a,b,c,61)}function Av(a){return(v[Gb(a)>>2]-v[a>>2]|0)/36|0}function Aha(a,b){a=a|0;b=b|0;if(!QS(a,b)){PS(b)}}function yx(a,b){v[a>>2]=v[b>>2];ad(a+4|0,b+4|0)}function yo(a,b){a=a|0;b=b|0;if(!Jh(a,b)){Uj(b)}}function yl(a,b,c){t[a+2|0]=c;u[a>>1]=b;return a}function y8(a,b){a=a|0;b=b|0;return C(Ul(a,b,6))}function x5(a){a=a|0;return fF(a,8825,1074448)|0}function wJ(a,b){a=a|0;b=b|0;Mk(a,b,58760,58768)}function vz(a){v[a+24>>2]=x[a+20>>1]<<x[a+22>>1]}function vJ(a,b){a=a|0;b=b|0;Mk(a,b,58776,58784)}function u5(a){a=a|0;return hw(a,5322,1074424)|0}function rN(a,b,c){v[a+4>>2]=c;t[a|0]=b;return a}function rL(a){a=a|0;ic(a+4208|0);return If(a)|0}function qka(a,b){a=a|0;b=b|0;return Hu(a,1,b)|0}function qJ(a,b){a=a|0;b=b|0;Mk(a,b,59580,59588)}function pJ(a,b){a=a|0;b=b|0;Mk(a,b,59596,59604)}function p7(a,b){a=a|0;b=b|0;return C(Ul(a,b,2))}function oJ(a,b){a=a|0;b=b|0;Mk(a,b,60408,60416)}function mP(a,b){v[a>>2]=v[a>>2]+(b<<1);return a}function mJ(a,b){a=a|0;b=b|0;Mk(a,b,60424,60432)}function l8(a,b){a=a|0;b=b|0;return C(Ul(a,b,5))}function kT(a,b,c){hc(a,b,zi(b,b+c|0,62428)-b|0)}function k2(a,b){a=a|0;b=b|0;return+JI(a-88|0,b)}function jd(a,b,c,d){return Id(a,B(Og(b),c)+d|0)}function jU(a,b){v[a>>2]=v[a>>2]+B(b,6);return a}function iJ(a,b){a=a|0;b=b|0;Mk(a,b,61236,61244)}function i7(a,b){a=a|0;b=b|0;return C(Ul(a,b,3))}function hJ(a,b){a=a|0;b=b|0;Mk(a,b,61252,61260)}function fz(a){return(v[Gb(a)>>2]-v[a>>2]|0)/7|0}function e8(a,b){a=a|0;b=b|0;return C(Ul(a,b,4))}function cV(a,b){a=MU(a,b);if(!a){HB(b)}return a}function bga(a,b){a=a|0;b=b|0;hp(a,b,623,622,8)}
function aC(a,b){a=a|0;b=b|0;if(!ED(a,b)){DD(b)}}function _g(a,b,c){var d=0;d=a;a=b;un(d,a,a+c|0)}function _V(a,b){a=a|0;b=b|0;if(!gC(a,b)){Ru(b)}}function _1(a,b){a=a|0;b=b|0;return+zI(a-92|0,b)}function Y1(a,b){a=a|0;b=b|0;return+xI(a-92|0,b)}function Xo(a,b,c){a=ee(a);v[a+4>>2]=c;v[a>>2]=b}function WK(a){a=a|0;wc(a+4256|0);return If(a)|0}function Vu(a,b){a=a|0;b=b|0;if(!Ro(a,b)){Io(b)}}function Us(a){a=a|0;wc(a+4208|0);return If(a)|0}function ST(a,b){a=a|0;b=b|0;if(!pD(a,b)){hr(b)}}function K7(a,b){a=a|0;b=b|0;return C(Ul(a,b,1))}function IU(a,b){a=a|0;b=b|0;if(!HU(a,b)){Au(b)}}function CA(a,b){a=a|0;b=b|0;if(!bT(a,b)){HA(b)}}function Bu(a){return(v[Gb(a)>>2]-v[a>>2]|0)/6|0}function v5(a){a=a|0;return fF(a,7113,480214)|0}function td(a,b){return np(v[b>>2],v[a>>2])?b:a}function qS(a){var b=0;b=v[a>>2];Ke(a);return b}function nm(a,b){return fu(z[b>>2],z[a>>2])?b:a}function ke(a,b){return Ek(x[a>>1],x[b>>1])?b:a}function hu(a,b){a=a|0;b=b|0;return Qb(a,b,1)^1}function eaa(a,b,c){a=a|0;b=b|0;c=c|0;sL(a,b,c)}function dC(a,b){return(b&255)==2&(a&255)>>>0<3}function _c(a,b){return ro(v[a>>2],v[b>>2])?b:a}function _3(a){a=a|0;return aF(a,49144,12510)|0}function Yy(a){if(w[a+24|0]){CN(a);t[a+24|0]=0}}function Wc(a,b){return Ek(x[b>>1],x[a>>1])?b:a}function WS(a){return!Sb(a,13896,4)&w[a+4|0]<32}function TF(a){var b=0,c=0;b=a,c=Gd(),v[b>>2]=c}function T4(a){a=a|0;return hw(a,5819,480272)|0}function Pk(a){return ob[v[v[a>>2]+36>>2]](a)|0}function Pe(a,b){return np(v[a>>2],v[b>>2])?b:a}function Mja(a,b){a=a|0;b=b|0;hp(a,b,354,353,8)}function Mh(a,b,c){return Ka(960,a|0,b|0,c|0)|0}function MH(a,b){if(!a){return 0}return $w(a,b)}function Lx(a,b){return fu(z[a>>2],z[b>>2])?b:a}function Lfa(a,b){a=a|0;b=b|0;hp(a,b,654,653,8)}function Kb(a,b){return ro(v[b>>2],v[a>>2])?b:a}function Hha(a,b){a=a|0;b=b|0;hp(a,b,505,504,6)}function HH(a,b,c){a=a|0;b=b|0;c=c|0;return a|0}function Bn(a){return ob[v[v[a>>2]+28>>2]](a)|0}function BB(a,b,c){if(b){Ub(a,Mf(c),b)}return a}function AW(a,b){a=a|0;b=b|0;$p(a,b);return a|0}function wt(a){return(a>>>0<9?a:a-9|256)&65535}function u7(a){a=a|0;JK(a);Ex(a);t[a+4202|0]=1}function tf(a,b,c){if(!(w[a|0]&32)){QB(b,c,a)}}function mh(a,b){t[a+4|0]=0;v[a>>2]=b;return a}function lg(a,b,c){a=Kka(a,b,c,c>>31);return a}function j8(a){a=a|0;t[a+4202|0]=1;SK(a);UK(a)}function c8(a){a=a|0;t[a+4202|0]=1;QK(a);PK(a)}function baa(a,b){a=a|0;b=b|0;vy(WL(a+24|0,b))}function aga(a,b){a=a|0;b=b|0;return ER(a,b)|0}function aV(a,b,c){a=a|0;b=b|0;c=c|0;hC(a,b,c)}function Z3(a){a=a|0;return aF(a,49164,8220)|0}function WY(a,b,c){a=a|0;b=b|0;c=c|0;hc(a,c,b)}function TO(a){pz(a);Ub(a+27|0,0,255);return a}function RB(a){return!Sb(a,15512,4)&w[a+4|0]<4}function QA(a,b,c){a=a|0;b=b|0;c=c|0;eC(a,b,c)}function PB(a,b,c){a=a|0;b=b|0;c=c|0;tV(a,b,c)}function Nk(a,b,c,d,e){Ta(a|0,b|0,c|0,d|0,e|0)}function Mz(a){return a>>>0<=45?w[a+43744|0]:0}function Lr(a,b){return(a&255)>>>0<(b&255)>>>0}function J3(a,b){a=a|0;b=b|0;ad(a,$J(b,17677))}function Hi(a,b){return(B(b,104)+a|0)+484380|0}function HV(a,b){a=a|0;b=b|0;hp(a,b,295,294,8)}function EP(a){v[a>>2]=0;v[a+4>>2]=-1;return a}function zb(a){if(ef(a)){Mb(v[a>>2])}return a}function xc(a,b){if(y[a>>2]>b>>>0){v[a>>2]=b}}function vH(a){a=a|0;Sw(v[v[a>>2]-12>>2]+a|0)}function tU(a){nb=0;a=(a&65535)-98|0;return a}function sl(a,b,c,d){return(b-d|0)+(a-c<<3)|0}function rp(a,b){a=a|0;b=b|0;return AH(a,b)^1}function rK(a,b){a=a|0;b=b|0;return $J(a,b)|0}function pka(a,b){a=a|0;b=b|0;ME(a,b,301,300)}function oV(a,b){a=a|0;b=b|0;return wF(a,b)|0}function mm(a){a=km(a);v[a>>2]=92672;return a}function k5(a){a=a|0;return iF(a,6594,1012)|0}function jf(a,b){return Lr(w[a|0],w[b|0])?b:a}function iX(a){a=a|0;v[a>>2]=62196;return a|0}function hR(a){a=Jka(a&65535,0,80,0);return a}function ee(a){v[a>>2]=0;v[a+4>>2]=0;return a}function cs(a,b){a=a|0;b=b|0;return qH(a,b)^1}function ci(a,b){if(v[a>>2]>(b|0)){v[a>>2]=b}}function cH(a){a=fK(a);v[a>>2]=79064;return a}function bj(a,b){a=a|0;b=b|0;return AH(a,b)|0}function ak(a,b){a=a|0;b=b|0;return qH(a,b)|0}function _m(a){return(a>>>0>127?a^128:-1)&255}function Zia(a,b){a=a|0;b=b|0;bw(a,b,17,3,16)}function ZX(a,b){a=a|0;b=b|0;return jE(a,b)|0}function ZG(a,b){a=a|0;b=b|0;return QD(a,b)|0}function Yb(a,b){return Lr(w[b|0],w[a|0])?b:a}function YW(a){a=a|0;v[a>>2]=43032;return a|0}function YJ(a){a=a|0;v[a>>2]=49228;return a|0}function YF(a,b,c){a=a|0;b=b|0;c=c|0;return-1}function Y0(a){a=a|0;kH(v[v[a>>2]-12>>2]+a|0)}function WW(a){a=a|0;v[a>>2]=42792;return a|0}function W0(a){a=a|0;jH(v[v[a>>2]-12>>2]+a|0)}function Vd(a){a=UD(a);v[a>>2]=84504;return a}function Tx(a){return v[Gb(a)>>2]-v[a>>2]>>11}function S2(a){a=a|0;v[a>>2]=61776;return a|0}function Mka(a,b,c,d){a=Hka(a,b,c,d);return a}function LX(a,b){a=a|0;b=b|0;return Ov(a,b)|0}function Ks(a){a=fK(a);v[a>>2]=78672;return a}function K2(a){a=a|0;v[a>>2]=61276;return a|0}function Jx(a,b){a=a|0;b=b|0;return Bh(a,b)|0}function JQ(a){return Qe(443250/+(a>>>0)*1e4)}function Fka(a,b){a=a|0;b=b|0;bw(a,b,44,2,44)}function F5(a){a=a|0;return iF(a,7057,1004)|0}function Ef(a,b){if(x[a>>1]>b>>>0){u[a>>1]=b}}function EV(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function Dw(a,b,c){a=LG(a,b,c,-1,-1);return a}function Bja(a,b){a=a|0;b=b|0;ME(a,b,358,357)}function BH(a){a=a|0;Uw(v[v[a>>2]-12>>2]+a|0)}function $U(a){t[a+12|0]=w[a+12|0]|2;return a}function z_(a){a=a|0;be(a,469616,Wd(468024))}function y_(a){a=a|0;be(a,469624,Wd(468032))}function x_(a){a=a|0;be(a,469632,Wd(468040))}function wj(a){return DE(a,C(4294967296),-1)}function w_(a){a=a|0;be(a,469640,Wd(468048))}function v_(a){a=a|0;be(a,469648,Wd(468056))}function u_(a){a=a|0;be(a,469656,Wd(468064))}function t_(a){a=a|0;be(a,469664,Wd(468072))}function tS(a){if(a){nI(a);Ce(v[a+80>>2],a)}}function s_(a){a=a|0;be(a,469672,Wd(467984))}function r_(a){a=a|0;be(a,469688,Wd(467992))}function n_(a){a=a|0;be(a,469720,Wd(468008))}function nF(a){a=Ha(a|0)|0;nb=O()|0;return a}function mo(a){return v[Gb(a)>>2]-v[a>>2]>>5}function m_(a){a=a|0;be(a,469736,Wd(468080))}function l_(a){a=a|0;be(a,469744,Wd(468088))}function jn(a){return v[Gb(a)>>2]-v[a>>2]>>3}function dk(a){a=a&255;return(a|0)==255?-1:a}function Zm(a){return v[Gb(a)>>2]-v[a>>2]>>1}function ZJ(a){if(a){ob[v[v[a>>2]+4>>2]](a)}}function Y2(a){a=a|0;dJ(a);return v[a+16>>2]}function Wh(a){return v[Gb(a)>>2]-v[a>>2]>>2}function Uz(a){return v[Gb(a)>>2]-v[a>>2]>>8}function To(a,b,c,d){a=Kka(a,b,c,d);return a}function R_(a){a=a|0;be(a,469424,Wd(467936))}function Q_(a){a=a|0;be(a,469432,Wd(467944))}function Px(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0}function P_(a){a=a|0;be(a,469440,Wd(468140))}function O_(a){a=a|0;be(a,469456,Wd(468132))}function Ny(a){t[a+24|0]=0;t[a|0]=0;return a}function N_(a){a=a|0;be(a,469464,Wd(468148))}function Lz(a){return v[Cc(a)>>2]-v[a>>2]>>2}function Lt(a){return v[Gb(a)>>2]-v[a>>2]>>4}function L_(a){a=a|0;be(a,469472,Wd(468156))}function K_(a){a=a|0;be(a,469488,Wd(468164))}function K1(a){a=a|0;return jb(v[a+60>>2])|0}function J_(a){a=a|0;be(a,469496,Wd(468180))}function I_(a){a=a|0;be(a,469504,Wd(468172))}function H_(a){a=a|0;be(a,469512,Wd(468188))}function G_(a){a=a|0;be(a,469520,Wd(468196))}function Fx(a){return C(C(a*C(7900))+C(100))}function F_(a){a=a|0;be(a,469544,Wd(468204))}function E_(a){a=a|0;be(a,469576,Wd(467952))}function D_(a){a=a|0;be(a,469584,Wd(467960))}function Ch(a){return v[v[a+8>>2]>>2]==(a|0)}function C_(a){a=a|0;be(a,469592,Wd(467968))}function B_(a){a=a|0;be(a,469600,Wd(467976))}function Aw(){ha(mm(ba(4)|0)|0,92756,26);L()}function Ad(a,b){if(!kf(b)){a=Mf(b)}return a}function A_(a){a=a|0;be(a,469608,Wd(468016))}function yJ(a){t[a+4|0]=0;t[a|0]=0;return a}function xka(a,b){a=a|0;b=b|0;Gr(a,b,293,2)}function xL(a){a=a|0;ob[v[v[a>>2]+4>>2]](a)}function wf(a,b){if(w[a|0]>b>>>0){t[a|0]=b}}function wK(a){return Uh(C(yK(a)*C(32768)))}function si(a,b){a=a|0;b=b|0;return C(C(0))}function rl(a,b){return a<<24>>24<b<<24>>24}function p_(a){a=a|0;be(a,469704,Wd(468e3))}function nk(a,b){return a<<16>>16<b<<16>>16}function mp(a){return v[Gb(a)>>2]-v[a>>2]|0}function hB(a,b){v[a>>2]=v[a>>2]+b;return a}function em(a){a=a|0;Tw(v[a>>2]);return a|0}function eea(a,b){a=a|0;b=b|0;Gr(a,b,572,3)}function _F(a,b,c){return Dv(ZF(a),ZF(b),c)}function Z2(a){a=a|0;dJ(a);return v[a+4>>2]}function Yh(a,b,c){if(c){fj(a,b,c)}return a}function Sm(a,b,c){return Af(a,b)>>>0>c>>>0}function Im(a,b){u[a>>1]=b;u[a+2>>1]=b>>>16}function He(a,b,c){if(c){sc(a,b,c)}return a}function Dn(a){a=a|0;nH(v[a>>2]);return a|0}function Ac(a){if(ef(a)){a=v[a>>2]}return a}function zka(a,b){a=a|0;b=b|0;Oq(a+36|0,b)}function ww(a){a=a|0;return Fh(a,468204)|0}function w1(a){a=a|0;return Fh(a,467952)|0}function uQ(a,b,c,d){hc(a,b,(d|0)==-1?c:d)}function uA(a,b){a=a|0;b=b|0;Gr(a,b,572,2)}function ss(a){return(a|0)<=65535&(a|0)>=0}function sN(a,b){return QE(a,b,2147483647)}function s9(a,b){a=a|0;b=b|0;t[a+4201|0]=b}function qf(a,b,c){a=Jka(c,0,a,b);return a}function pd(a,b){a=a|0;b=b|0;sL(a,b,Pg(b))}function oq(a){v[a>>2]=v[a>>2]+12;return a}function oX(a){a=a|0;return v[a+4>>2]!=0|0}function o1(a){a=a|0;return Fh(a,467968)|0}function jr(a){sr(a+32|0);Bb(a+12|0);Ab(a)}function iq(a){v[a>>2]=v[a>>2]+16;return a}function gv(a){a=a|0;return Fh(a,468140)|0}function gl(a){zb(a+36|0);wc(a+24|0);vk(a)}function gfa(a,b){a=a|0;b=b|0;JE(a,b,2,31)}function Zt(a,b){a=a|0;b=b|0;Gr(a,b,573,2)}function VH(a,b){return C(UH(a?C(-b):b)*b)}function St(a){We(a+24|0);ic(a+12|0);ic(a)}function Rk(a,b){ob[v[v[b>>2]+44>>2]](a,b)}function Raa(a,b){a=a|0;b=b|0;$o(a+40|0,b)}function Qw(a){a=a|0;return Fh(a,468132)|0}function Qk(a,b){ob[v[v[b>>2]+32>>2]](a,b)}function P8(a,b,c){a=a|0;b=b|0;c=c|0;ee(a)}function Om(a){v[a>>2]=v[a>>2]+28;return a}function Nw(a){a=a|0;return Fh(a,468148)|0}function Nf(a){v[a>>2]=v[a>>2]+20;return a}function NM(a){v[a>>2]=v[a>>2]+52;return a}function Mr(a,b){ob[v[v[b>>2]+40>>2]](a,b)}function Iw(a){a=a|0;return Fh(a,468156)|0}function Il(a){return v[a+8>>2]&2147483647}function Dm(a){Ez(v[a+20>>2]);v[a+20>>2]=0}function Dka(a,b){a=a|0;b=b|0;$o(a+12|0,b)}function Cz(a){v[a>>2]=v[a>>2]+32;return a}function Bw(a){a=a|0;return Fh(a,468196)|0}function BK(a){return C(C(a*C(96))+C(-96))}function zf(a){a=a|0;Kh(a+8|0);return a|0}function zF(){if(!w[469921]){t[469921]=1}}function xt(a){om(a,ho(a),62428);return a}function xp(a){a=a|0;Is(a+8|0);return a|0}function wF(a,b){return Ir(a,Mc(b),Hb(b))}function vka(a,b){a=a|0;b=b|0;gi(a,b,136)}function u2(a,b){a=a|0;b=b|0;SI(a-88|0,b)}function t2(a,b){a=a|0;b=b|0;RI(a-88|0,b)}function st(a){v[a>>2]=v[a>>2]+8;return a}function rga(a,b){a=a|0;b=b|0;gi(a,b,274)}function pe(a){return Ib(a&65535)<<16>>16}function lga(a,b){a=a|0;b=b|0;gi(a,b,106)}function lP(a){v[a>>2]=v[a>>2]-2;return a}function kj(a,b){v[a>>2]=v[b>>2];return a}function fs(a){a=a|0;_k(a+8|0);return a|0}function es(a){a=a|0;_k(a+4|0);return a|0}function eO(a,b){if(z[a>>2]>b){z[a>>2]=b}}function e2(a,b){a=a|0;b=b|0;DI(a-88|0,b)}function bka(a,b){a=a|0;b=b|0;JE(a,b,3,8)}function b2(a,b){a=a|0;b=b|0;CI(a-92|0,b)}function a2(a,b){a=a|0;b=b|0;BI(a-92|0,b)}function Zk(a){a=a|0;return zH(a)<<24>>24}function Yr(a){a=a|0;fw(a,168,93116,1001)}function Xia(a,b){a=a|0;b=b|0;gi(a,b,282)}function W9(a,b){a=a|0;b=b|0;Bh(a,b+36|0)}function Se(a){v[a>>2]=v[a>>2]+2;return a}function Pn(a,b){return v[a>>2]-v[b>>2]|0}function Le(a){v[a>>2]=v[a>>2]+4;return a}function Ke(a){v[a>>2]=v[a>>2]+1;return a}function JH(a,b){t[a|0]=b+48;return a+1|0}function IZ(a,b){a=a|0;b=b|0;Bh(a,b+16|0)}function E2(a,b){a=a|0;b=b|0;Pl(a,b+12|0)}function Ck(a){v[a>>2]=v[a>>2]+6;return a}function CZ(a,b){a=a|0;b=b|0;Bh(a,b+12|0)}function CK(a){a=a|0;Ub(a+4296|0,0,81928)}function CI(a,b){a=a|0;b=b|0;YE(a,b,2048)}function BI(a,b){a=a|0;b=b|0;YE(a,b,4096)}function w2(a){a=a|0;return xp(a-88|0)|0}function s2(a,b){a=a|0;b=+b;QI(a-88|0,b)}function q2(a,b){a=a|0;b=+b;OI(a-88|0,b)}function pj(a,b){return v[a>>2]!=v[b>>2]}function nj(a){u[a+4>>1]=65535;v[a>>2]=0}function n2(a,b){a=a|0;b=+b;MI(a-88|0,b)}function lc(a){v[v[a>>2]+4>>2]=v[a+4>>2]}function kha(a,b){a=a|0;b=b|0;gi(a,b,42)}function jga(a,b){a=a|0;b=b|0;gi(a,b,72)}function ff(a,b){v[a+8>>2]=b|-2147483648}function d2(a){a=a|0;return xp(a-92|0)|0}function bs(a,b){v[a+24>>2]=v[a+24>>2]+b}function _d(a,b){return(b|0)!=0&(a|0)!=0}function Yia(a,b){a=a|0;b=b|0;Sq(a,b,17)}function X1(a){a=a|0;return xp(a-96|0)|0}function Vk(a){return(a|0)==32|a-9>>>0<5}function VD(a,b){qc(a,b);qc(a+4|0,b+4|0)}function U1(a,b){a=a|0;b=+b;wI(a-96|0,b)}function Tf(a,b){a=Kka(0,a,b,0);return a}function PJ(a){return(Ac(a)+Hb(a)|0)-1|0}function MT(a,b,c){v[a>>2]=b;v[a+4>>2]=c}function Kj(a,b){t[a|0]=b;t[a+1|0]=b>>>8}function Hja(a,b){a=a|0;b=b|0;gi(a,b,34)}function HZ(a,b){a=a|0;b=b|0;sn(a,84248)}function GZ(a,b){a=a|0;b=b|0;sn(a,84268)}function Fk(a){return B($m(a),Ld(a))&255}function FS(a,b){a=a|0;b=b|0;gi(a,b,284)}function E8(a){a=a|0;t[a+4202|0]=1;gL(a)}function BZ(a,b){a=a|0;b=b|0;Kc(a,11269)}function AZ(a,b){a=a|0;b=b|0;Kc(a,11386)}function A7(a){a=a|0;return v[a+4260>>2]}function zha(a,b){a=a|0;b=b|0;jC(a,b,8)}function su(a,b,c){return a<b?b:a>c?c:a}function sT(a,b){a=a|0;b=b|0;Sq(a,b,32)}function r9(a){a=a|0;return w[a+4201|0]}function q9(a){a=a|0;return w[a+4202|0]}function oW(a,b){a=a|0;b=b|0;gi(a,b,59)}function mR(a,b,c,d){return sl(c,d,a,b)}function kN(a,b){return(pl(a,b)|0)!=255}function ik(a,b){return Wy(a&255,b&255)}function hG(a,b){a=a|0;b=b|0;of(a,1,45)}function gn(a){a=v[a+8>>2];if(a){Mb(a)}}function gG(a,b){a=a|0;b=b|0;rG(a,1,45)}function cx(a){return(p(a),j(2))>>>20|0}function cW(a,b){a=a|0;b=b|0;Sq(a,b,11)}function bz(a,b,c){return a<b?b:a>c?c:a}function Zh(a){return(a&65535)>>>0<3999}function Z6(a){a=a|0;return(a|0)==277|0}function SH(a){v[a+4>>2]=v[a+4>>2]|8192}function Ig(a,b,c){t[a+4|0]=c;v[a>>2]=b}function Ib(a){return(a<<8|a>>>8)&65535}function EF(a,b){a=a|0;b=b|0;return b|0}function AV(a,b){a=a|0;b=b|0;gi(a,b,50)}function $T(a){return HE(a,65535,65535)}function wL(a){a=a|0;return 1869112133}function re(a,b,c){un(a,b,fd(b,c)+b|0)}function r2(a){a=a|0;return+PI(a-88|0)}function qj(a,b){return Ac(a)+(b<<2)|0}function oE(a,b,c){return dp(a,b,c,24)}function o2(a){a=a|0;return+NI(a-88|0)}function m2(a){a=a|0;return+LI(a-88|0)}function k7(a){a=a|0;return-2013527448}function jh(a){return DE(a,C(255),255)}function dea(a){a=a|0;cR(a);return a|0}function dB(a,b,c){vq(a,c);xd(b+c|0,0)}function cz(a,b){return OE(a,b,-1,0,0)}function bv(a,b,c){return dp(a,b,c,20)}function aX(a){a=a|0;return v[a+16>>2]}function Yj(a,b){v[a+4>>2]=2;v[a>>2]=b}function Yi(a,b){v[a+4>>2]=1;v[a>>2]=b}function Uv(a,b){v[a+4>>2]=4;v[a>>2]=b}function Ud(a){v[v[a+8>>2]>>2]=v[a>>2]}function TU(a,b,c){return dp(a,b,c,48)}function SV(a){a=a|0;return v[a+12>>2]}function Ot(a,b,c){return dp(a,b,c,12)}function Nv(a,b){v[a+4>>2]=3;v[a>>2]=b}function Nr(a){a=a|0;return 2147483647}function MJ(a){return a?(a|0)==2?3:2:1}function LT(a,b,c){yl(a,b&65535,c&255)}function GP(a,b,c){return NE(a,b,c,42)}function xo(a,b){u[a+8>>1]=b;return a}function xJ(a){v[a>>2]=58744;return a}function vj(a){return(a-1&255)>>>0<17}function sK(a,b){a=a|0;b=b|0;return 0}function rka(a,b){a=a|0;b=b|0;tt(a,b)}function r7(a){a=a|0;return 302837129}function qH(a,b){return pH(a)^pH(b)^1}function pi(a,b,c){ad(ad(a,b)+12|0,c)}function o8(a){a=a|0;return-285139079}function mba(a,b){a=a|0;b=b|0;GN(a,b)}function lr(a,b,c){return gp(a,b,c,3)}function km(a){v[a>>2]=93368;return a}function ji(a){a=v[a>>2];if(a){NG(a)}}function j9(a){a=a|0;return 542066252}function gs(a,b){a=a|0;b=b|0;return-1}function g8(a){a=a|0;return-284078960}function fn(a){v[a>>2]=61728;return a}function fK(a){v[a>>2]=78700;return a}function ef(a){return w[a+11|0]>>>7|0}function cQ(a,b,c){return ew(a,b,c,5)}function cM(a,b){Zc(a,b&4?16:8,1,0,0)}function b7(a,b){a=a|0;b=b|0;return 3}function ai(a,b,c){return gp(a,b,c,1)}function _N(a,b){return(0-b|0)!=(a|0)}function _6(a,b){a=a|0;b=b|0;return 2}function Xm(a,b,c){return ew(a,b,c,2)}function XS(a,b,c){gc(a,b,uc(b,c)<<2)}function Wq(a){a=a|0;return v[a+4>>2]}function WI(a){v[a>>2]=63040;return a}function VP(a){return(a&65535)==65534}function VI(a){v[a>>2]=63064;return a}function Ue(a,b){v[a+4>>2]=b;return a}function UI(a){v[a>>2]=63144;return a}function U7(a){a=a|0;return-271958638}function U2(a){a=a|0;return w[a+40|0]}function TI(a){v[a>>2]=63184;return a}function SD(a){a=a|0;return v[a+8>>2]}function Qx(a,b){a=a|0;b=b|0;return 1}function Qo(a,b,c){return ew(a,b,c,1)}function Nz(a,b,c){return gp(a,b,c,5)}function M7(a){a=a|0;return-620920304}function Km(a){return(a&740327453)!=0}function K0(a){a=a|0;return aH(a,0)|0}function J0(a){a=a|0;return aH(a,1)|0}function Iq(a,b,c){return dp(a,b,c,6)}function IJ(a){a=C(a-a);return C(a/a)}function HD(a,b,c){gc(a,b,Ug(b,c)<<3)}function Dt(a,b,c){return gp(a,b,c,4)}function Cf(a,b,c){return jd(a,b,c,0)}function CJ(a){v[a>>2]=49476;return a}function C0(a){a=a|0;return $G(a,0)|0}function B7(a){a=a|0;return-275227023}function B0(a){a=a|0;return $G(a,1)|0}function Ah(a,b,c){return gp(a,b,c,2)}function Af(a,b){return yk(a,b)&65535}function AH(a,b){return yH(a)^yH(b)^1}function A8(a){a=a|0;return-270114148}function $J(a,b){return Ir(a,b,Pg(b))}function $7(a){a=a|0;return-281111764}function zp(a,b){a=a|0;b=b|0;Pl(a,b)}function zK(a){v[a>>2]=0;v[a+4>>2]=0}function wX(a){a=a|0;dD(Mc(a),Hb(a))}function vL(a,b,c){a=a|0;b=b|0;c=c|0}function tu(a,b){return w[a+b|0]!=63}function tba(a){a=a|0;return Vg(a)|0}function tQ(a,b){return B(b,872)+a|0}function tB(a,b,c){fc(fc(a,b)+4|0,c)}function qja(a){a=a|0;return gB(a)|0}function qi(a,b){a=a|0;b=b|0;Bh(a,b)}function nn(a,b){a=a|0;b=b|0;dK(a,b)}function nL(a,b){a=a|0;b=b|0;qi(a,b)}function nK(a){a=a|0;lF(a,49008,949)}function kh(a){Xf(a+52|0);ic(a+40|0)}function iL(a,b){a=a|0;b=b|0;Jx(a,b)}function fS(a,b){if(!$R(a,b)){hA(b)}}function dn(a){v[a+4>>2]=v[a+4>>2]+1}function dK(a,b){a=a|0;b=b|0;zp(a,b)}function _X(a,b){a=a|0;b=b|0;wN(a,b)}function ZQ(a){return(a&255)>>>0<129}function Yq(a,b){a=a|0;b=b|0;yv(a,b)}function Vja(a){a=a|0;return DU(a)|0}function QP(a,b,c,d){OP(hc(a,b,c),d)}function Og(a){return x[a+480188>>1]}function O2(a){a=a|0;return w[a+8|0]}function Md(a,b){return B(b,160)+a|0}function Lq(a,b){a=a|0;b=b|0;nL(a,b)}function Laa(a){a=a|0;return wi(a)|0}function Ki(a,b){a=a|0;b=b|0;DV(a,b)}function KX(a,b){a=a|0;b=b|0;lE(a,b)}function JN(a){return(a+5&255)>>>0<2}function IA(a,b){a=a|0;b=b|0;XJ(a,b)}function Hx(a,b){a=a|0;b=b|0;fL(a,b)}function Gs(a){return x[a+480192>>1]}function Fs(a){return x[a+480190>>1]}function EZ(a){a=a|0;return t[a+8|0]}function Dx(a){a=a|0;lF(a,49064,951)}function Dea(a){a=a|0;return Bi(a)|0}function DZ(a){a=a|0;return t[a+9|0]}function Bt(a){return v[Gb(a)>>2]<<5}function $Q(a){return(a|0)<120?a:120}function yk(a,b){return(b-a|0)/52|0}function yd(a,b){return(b-a|0)/12|0}function vX(a){a=a|0;return Bg(a)|0}function tk(a){return HE(a,255,255)}function sj(a,b){return rg(a,b)&255}function se(a,b,c){return GG(a,b,c)}function ro(a,b){return a>>>0<b>>>0}function rS(a,b){return Rf(a,0-b|0)}function qq(a){return(a&255)==1?1:2}function pv(a){t[a+2|0]=0;u[a>>1]=0}function pc(a,b){return(a|0)==(b|0)}function og(a){return C(D(a))==C(N)}function lf(a,b){return B(b,24)+a|0}function kr(a,b){return(b-a|0)/36|0}function kq(a,b){return(b-a|0)/56|0}function hK(a){a=a|0;return _k(a)|0}function hH(a){a=a|0;return Gv(a)|0}function gD(a){a=a|0;return Rg(a)|0}function g1(a){a=a|0;return Xk(a)|0}function fx(a){return!Sb(a,93684,6)}function fc(a,b){v[a>>2]=b;return a}function eg(a,b){return ok(a,ce(b))}function du(a,b){return(b-a|0)/33|0}function dt(a){return!(a&204473357)}function cy(a,b){return B(b,28)+a|0}function bg(a,b){return B(b,52)+a|0}function _z(a,b){return B(b,56)+a|0}function XA(a,b,c){return Ss(a,b,c)}function Wp(a){if(w[a+24|0]){CN(a)}}function Wb(a,b){return ye(a,b&255)}function VW(a){a=a|0;yD(Ub(a,0,36))}function UW(a){a=a|0;return Kh(a)|0}function TS(a,b){return B(b,33)+a|0}function Rq(a){a=a|0;return Me(a)|0}function Qv(a,b,c){return Sb(a,b,c)}function Pp(a){return VU(a,251,255)}function Pi(a,b){return(b-a|0)/24|0}function Oi(a,b,c){return Dv(a,b,c)}function Ng(a,b){return B(b,20)+a|0}function Nd(a,b){return B(b,12)+a|0}function Mt(a,b){return B(b,36)+a|0}function Mq(a,b){return(b-a|0)/28|0}function Lk(a,b,c){return xE(a,b,c)}function IB(a){a=a|0;return vc(a)|0}function Hq(a,b){return(b-a|0)/48|0}function H7(a){a=a|0;v[a+4224>>2]=0}function DV(a,b){CV(a,v[a+16>>2]|b)}function Bl(a,b){return Al(Rc(a,b))}function Bf(a,b){return(b-a|0)/20|0}function BV(a){a=a|0;return uv(a)|0}function zx(a,b,c,d){aw(a,b,c,d,4)}function ri(a){a=a|0;t[a+4202|0]=0}function qk(a,b){return(b-a|0)/6|0}function pm(a){return C(D(a))<C(N)}function np(a,b){return(a|0)<(b|0)}function mV(a,b){return Ok(a,b,28)}function lB(a){return a&2147483647}function kf(a){return(a&128)>>>7|0}function fr(a,b){return(b<<11)+a|0}function fU(a){return w[a+1|0]!=63}function ez(a,b){return(b-a|0)/7|0}function eG(a){return Fh(a,468024)}function dG(a){return Fh(a,468016)}function co(a,b){return(b<<13)+a|0}function cl(a,b){return(a+b|0)-1|0}function bG(a){return Fh(a,468040)}function aK(a,b,c,d){aw(a,b,c,d,2)}function aG(a){return Fh(a,468032)}function _ia(a){a=a|0;return+oH(a)}function Yv(a,b){return!(b>>>31|0)}function Y9(a){a=a|0;Sq(a,21688,1)}function Ws(a,b){return(a-b|0)/6|0}function Sv(a,b){return Ok(a,b,12)}function S1(a,b){a=a|0;b=b|0;Mb(b)}function QS(a,b){return Hr(a,b,18)}function PX(a){a=a|0;kn(a,1,13429)}function Ow(a){return pc(a,-1)?0:a}function Nh(a,b){a=a|0;b=b|0;Nb(a)}function Kk(a){return(a&255)>>>0>1}function KN(a){qe(a+8|0);BN(a+4|0)}function Jn(a,b){v[a+1298464>>2]=b}function JT(a,b){return Hr(a,b,56)}function JJ(a){return(dk(a)|0)==-1}function Io(a){t[a|0]=0;t[a+1|0]=0}function Ij(a,b){return B(Fk(b),a)}function Id(a,b){return B(b,6)+a|0}function HJ(a,b){a=a|0;b=b|0;ic(b)}function Gx(a,b,c,d){aw(a,b,c,d,9)}function GJ(a,b){a=a|0;b=b|0;Fm(b)}function Fe(a,b){hc(a,Mc(b),Hb(b))}function Ec(a,b){return QE(a,b,-1)}function ED(a,b){return Hr(a,b,20)}function CD(a,b){return Ok(a,b,36)}function zy(a){ic(a+4|0);return a}function zm(a,b){return(b<<8)+a|0}function ye(a,b){return(b<<5)+a|0}function yY(a){a=a|0;return 13013}function xx(a,b){return jM(a,b)^1}function xY(a){a=a|0;return 10799}function wia(a){a=a|0;Sf(a,16222)}function tH(a){return EE(a,77440)}function rO(a,b){return Ok(a,b,8)}function ne(a,b){return!Sb(a,b,4)}function kw(a,b){return v[a+b>>2]}function hg(a,b){return Mc(a)+b|0}function hD(a){return(a&16)>>>4|0}function cc(a,b){return(b<<1)+a|0}function bk(a){return a-48>>>0<10}function bf(a,b){return(b<<3)+a|0}function Wx(a){v[a>>2]=v[a>>2]+24}function Vn(a){return a+1074328|0}function Vaa(a){a=a|0;vg(a,tj(a))}function U0(a){a=a|0;return 10425}function Td(a){return v[jc(a)>>2]}function Tc(a,b){return Ac(a)+b|0}function TY(a){a=a|0;return 13127}function RY(a){a=a|0;return 10305}function Pb(a,b){return pc(a,b)^1}function Nm(a){v[a>>2]=2;return a}function Kz(a,b){return Ok(a,b,4)}function Kd(a,b){return(b<<4)+a|0}function Jfa(a){a=a|0;DS(a,65535)}function Jf(a){return a!=a?C(0):a}function Iga(a){a=a|0;Sf(a,16853)}function HG(a,b){return GG(a,0,b)}function Gh(a){v[a>>2]=1;return a}function Gc(a){v[a>>2]=0;return a}function Ez(a){if(a){Mb(a+-64|0)}}function Es(a){return EE(a,77376)}function Eb(a,b){return(b<<2)+a|0}function Aq(a,b){return ue(a,b)^1}function Ak(a){u[a>>1]=0;return a}function $c(a){return VU(a,1,120)}function zo(a){return Ub(a,0,48)}function zY(a){a=a|0;return 9864}function zX(a){a=a|0;dD(a,Pg(a))}function wq(a){fw(a,25,93048,27)}function wY(a){a=a|0;return 5723}function tia(a){a=a|0;Sf(a,4487)}function sfa(a){a=a|0;Sf(a,4168)}function sV(a){fw(a,25,92996,24)}function pg(a,b){fc(Gc(a)+4|0,b)}function pU(a,b,c){PE(a,b,c,256)}function mv(a,b){return Nka(a,b)}function mia(a){a=a|0;Sf(a,4381)}function jL(a){return(a&8)>>>3|0}function fv(a,b,c){PE(a,b,c,128)}function fH(a){v[a+72>>2]=466952}function dH(a){v[a+72>>2]=467036}function cha(a){a=a|0;Iu(a,3883)}function cg(a,b,c,d){pf(a,c,d,b)}function aha(a){a=a|0;Iu(a,4890)}function Yg(a){return!v[a+16>>2]}function XI(a,b){return Ug(a,b)}
function UV(a){a=a|0;Sf(a,4361)}
function Rja(a){a=a|0;Sf(a,3892)}function OC(a){om(a,_o(a),62428)}function NY(a){a=a|0;return 6869}function Kq(a,b,c){KE(a,b,c,128)}function Jga(a){a=a|0;Sf(a,3988)}function EX(a){a=a|0;Sf(a,16880)}function ES(a,b){sc(a,b+4|0,256)}function Cr(a){t[a|0]=0;return a}function zj(a,b){return ye(a,b)}function yp(a,b){return Eb(a,b)}function yf(a){a=a|0;return a|0}function xl(a){return Jm(ve(a))}function wm(a){zb(a+12|0);zb(a)}function v2(a){a=a|0;rs(a-88|0)}function uk(a,b,c){pf(a,c,12,b)}function sp(a){return a<<24>>24}function sh(a,b){return!Ad(a,b)}function sM(a,b){return qM(a,b)}function ry(a){u[a+480214>>1]=0}function rw(a){return Gb(a+8|0)}function rE(a,b){Er(a,b,24,-24)}function ql(a){Ab(a+12|0);od(a)}function qC(a){return(a&255)==1}function oo(a,b){return Ek(a,b)}function ok(a,b){return fc(a,b)}function ng(a){return Ci(a)?0:a}function nf(a,b){return zg(a,b)}function kv(a,b){return VC(a,b)}function kt(a){BO(a+12|0);FO(a)}function kc(a,b){return MD(a,b)}function hE(a,b){return ad(a,b)}function gz(a,b){return Rc(a,b)}function fh(a){return JN(a&255)}function f_(a){a=a|0;Nc(468340)}function dw(a,b){return dh(a,b)}function d_(a){a=a|0;Nc(468372)}function cA(a,b,c){pf(a,c,64,b)}function c2(a){a=a|0;rs(a-92|0)}function b_(a){a=a|0;Nc(468276)}function _b(a,b){return bg(a,b)}function XC(a,b){return UC(a,b)}function WT(a,b,c){pf(a,c,24,b)}function Vs(a,b){return nk(a,b)}function V1(a){a=a|0;rs(a-96|0)}function Tn(a,b){return Lr(a,b)}function Th(a,b){return fd(a,b)}function TZ(a){a=a|0;zb(468324)}function Si(a,b){return a>>>b&1}function Sc(a,b,c){hc(a,b,1<<c)}function RZ(a){a=a|0;zb(468356)}function Qj(a,b){return b-a>>11}function Qe(a){return Cq(ve(a))}function Qd(a){return(a&255)!=0}function PZ(a){a=a|0;zb(468260)}function PU(a,b){Er(a,b,48,-48)}function PG(a){if(QG(a)){Mb(a)}}function Or(a){a=a|0;return 127}function OB(a,b,c){pf(a,c,30,b)}function Ne(a,b,c){pf(a,c,32,b)}function NZ(a){a=a|0;zb(468292)}function NT(a,b){return ro(a,b)}function Lf(a,b){return ok(a,b)}function KB(a,b){return Ao(b,a)}function Jc(a,b){return fr(a,b)}function Ii(a,b,c){pf(a,c,28,b)}function Ih(a,b){return hv(a,b)}function IG(a,b){return yd(a,b)}function Hg(a,b){return Pb(a,b)}function HQ(a,b){Er(a,b,12,-12)}function Gm(a){eu(a,0);return a}function Gk(a,b){return Ad(a,b)}function Fl(a,b,c){pf(a,c,22,b)}function FX(a){a=a|0;Sf(a,4535)}function Dj(a,b,c){pf(a,c,20,b)}function Df(a){Ab(a+20|0);Ab(a)}function Cb(a,b){return(a&b)!=0}function CU(a,b){return to(b,a)}function CN(a){AN(a+12|0);zN(a)}function Bb(a){le(a+12|0);le(a)}function Ai(a,b){return(a|b)!=0}function $h(a,b,c){pf(a,c,13,b)}function $d(a,b){return uc(a,b)}function $Z(a){a=a|0;Nc(468308)}function zh(a,b){return b-a>>8}function zZ(a){a=a|0;Mb(JF(a))}function z7(a){a=a|0;return 13}function we(a,b){t[a|0]=w[b|0]}function vQ(a){return a+4096|0}function uc(a,b){return b-a>>2}function rs(a){a=a|0;Mb(xp(a))}function rg(a,b){return b-a>>5}function rR(a,b){bw(a,b,5,3,4)}function p8(a){a=a|0;Mb(WK(a))}function mn(a){a=a|0;Mb(xU(a))}function mk(a,b){return b-a>>4}function kH(a){a=a|0;Mb(Cp(a))}function k9(a){a=a|0;Mb(rL(a))}function jH(a){a=a|0;Mb(sf(a))}function gZ(a){a=a|0;Mb(CF(a))}function fX(a){a=a|0;Mb(KD(a))}function en(a){a=a|0;Mb(Gv(a))}function ec(a,b){v[a+100>>2]=b}function cT(a,b){un(a,b,vd(b))}function cL(a){a=a|0;Mb(dL(a))}function au(a,b){return a-b>>2}function _Y(a){a=a|0;Mb(BF(a))}function _C(a){return vc(a<<2)}function _2(a){a=a|0;Mb(eJ(a))}function Wy(a,b){return a<<8|b}function Ww(a){a=a|0;Mb(_k(a))}function Vw(a){a=a|0;Mb(Mn(a))}function Uw(a){a=a|0;Mb(fs(a))}function Ug(a,b){return b-a>>3}function Sx(a){a=a|0;Mb(Us(a))}function Sw(a){a=a|0;Mb(es(a))}function SF(a){a=a|0;Mb(qw(a))}function Rw(a){a=a|0;Mb(ds(a))}function Rc(a,b){return b-a>>1}function Qt(a){return a>>>27^a}function PD(a){return a+1024|0}function P2(a){a=a|0;Mb(_I(a))}function Ns(a){a=a|0;Mb(If(a))}function Ld(a){return a&64?2:1}function Jz(a){return a+4896|0}function JZ(a){a=a|0;Mb(RF(a))}function IH(){return(hb()|0)>0}function FZ(a){a=a|0;Mb(QF(a))}function En(a){return(a|0)==-1}function DL(a,b){Ux(a,Ac(a),b)}function Cl(a){return a>>>0<11}function Ce(a,b){if(!a){Mb(b)}}function C7(a){a=a|0;Mb(KK(a))}function Ax(a){a=a|0;Mb(_J(a))}function Ao(a,b){return a-b>>1}function A3(a){a=a|0;Mb(xs(a))}function $0(a){a=a|0;Mb(Hs(a))}function zd(a){return(a|0)!=0}function yj(a){return!(a&255)}function to(a,b){return a-b|0}function tR(a,b){pf(a,b,33,1)}function sA(a,b){eu(a,ce(b))}
function qU(a,b){pf(a,b,40,2)}function n8(a){a=a|0;return 6}function mf(a){return D(a)==N}function mc(a){a=a|0;return 0}function lO(a,b){Er(a,b,7,-7)}function kk(a){return zd(a)^1}function iM(a,b,c){nl(a,b,-c)}function iA(a,b){gc(a,b,1024)}function i9(a){a=a|0;return 9}function hL(a){a=a|0;return 3}function gk(a){return a+4e4|0}function gd(a,b){Ap(a,b+28|0)}function gA(a){return a+128|0}function fd(a,b){return b-a|0}function eo(a,b){v[a+36>>2]=b}function dr(a,b){pf(a,b,26,3)}function bL(a){a=a|0;return 7}function _w(){return pb()<<16}function Zu(a){return!v[a>>2]}function ZS(a){zo(Ub(a,0,48))}function Yk(a){return(a&5)!=0}function X6(){return 19988497}function Vr(a){return a>>>0<2}function Ve(a,b){u[a+28>>1]=b}function VB(a,b){gc(a,b,1954)}function RK(a){a=a|0;return 5}function On(a){a=a|0;return 4}function Nb(a){wE(a);return a}function Lb(a,b){return a+b|0}function Ko(a){return a>>>0<5}function Ge(a){a=a|0;return 1}function GR(a,b){gc(a,b,1108)}function GA(a,b){gc(a,b,4896)}function Ee(a){a=a|0;return 2}function EH(a){a=a|0;return-1}function Bs(a,b){v[a+32>>2]=b}function Bq(a){return a+256|0}function $m(a){return a&1?2:1}function yM(a){return a-32|0}function vd(a){return a+16|0}function vT(a){return a+36|0}function so(a){return a+14|0}function rQ(a,b){sc(a,b,128)}function qh(a,b,c){Dv(a,b,c)}function qO(a,b,c){cm(a,b,c)}function px(a){return a-12|0}function nq(a,b){return a<<b}function mN(a,b,c){MT(a,b,c)}function lm(a,b){v[a+8>>2]=b}function ld(a,b){return a>>b}function ky(a,b){t[a+34|0]=b}function kU(a,b){gc(a,b,218)}function kR(a,b){gc(a,b,146)}function kB(a,b){pf(a,b,8,2)}function jy(a,b){t[a+32|0]=b}function jI(a,b,c){Ub(a,c,b)}function iy(a,b){t[a+35|0]=b}function ie(a,b){t[a+11|0]=b}function iP(a){hP(a,v[a>>2])}function hz(a){t[a+6152|0]=0}function ho(a){return a+32|0}function hV(a,b){gc(a,b,610)}function hU(a,b){gc(a,b,157)}function h1(a){a=a|0;DV(a,1)}function gc(a,b,c){hc(a,b,c)}function gR(a,b){gc(a,b,608)}function di(a,b,c){uD(a,b,c)}function dP(a,b,c){ll(a,c,b)}function cU(a,b){gc(a,b,206)}function bt(a){SM(a,v[a>>2])}function as(a,b){Ap(a,b+4|0)}function _o(a){return a+20|0}function _R(a,b){gc(a,b,130)}function ZO(a,b,c){ol(a,c,b)}function YT(a,b){gc(a,b,236)}function XR(a,b){gc(a,b,600)}function Vj(a){return a-36|0}function UT(a){return a+10|0}function RR(a,b){gc(a,b,126)}function RC(a,b){gc(a,b,497)}function QT(a,b){gc(a,b,102)}function Nq(a,b){gc(a,b,192)}function NP(a,b){gc(a,b,263)}function Mp(a,b){z[a+8>>2]=b}function Lp(a,b){z[a+4>>2]=b}function Lc(a){Hd(a,v[a>>2])}function LQ(a,b){gc(a,b,204)}function Ku(a,b){gc(a,b,512)}function Kp(a,b){t[a+33|0]=b}function Jv(a,b){XD(a,ce(b))}function Je(a,b){a=a|0;b=b|0}function Hd(a,b){v[a+4>>2]=b}function HP(a){return a+48|0}function DT(a,b){gc(a,b,576)}function Cm(a,b,c){Oo(a,b,c)}function Cc(a){return a+12|0}function Bo(a,b){je(a,b+8|0)}function AT(a,b){gc(a,b,674)}function AO(a){zO(a,v[a>>2])}function $S(a,b){gc(a,b,128)}function $A(a){return a-28|0}function yu(a,b){gc(a,b,22)}function yL(a){Ub(a,0,2048)}function xA(a,b){gc(a,b,40)}function wR(a,b){gc(a,b,96)}function sk(){wq(11024);L()}function sU(a,b){gc(a,b,98)}function nv(a,b){hc(a,b,22)}function nU(a,b){gc(a,b,48)}function nC(a,b){gc(a,b,11)}function jc(a){return a+4|0}function iC(a,b){hc(a,b,20)}function hf(){sV(11024);L()}function gr(a,b){gc(a,b,36)}function gS(a,b){gc(a,b,30)}function fu(a,b){return a<b}function fC(a,b){gc(a,b,17)}function dg(a,b){t[a+3|0]=b}function br(a){return a&127}function av(a,b){gc(a,b,65)}function aT(a,b){gc(a,b,80)}function _D(a,b){gc(a,b,24)}function Wm(a,b){hc(a,b,32)}function W6(){return 458752}function VT(a){return a+6|0}function VK(a){return 0-a|0}function UB(a){Ub(a,0,1954)}function Te(a){return a+2|0}function TP(a,b){return a<b}function SU(a,b){sc(a,b,48)}function SO(a,b){gc(a,b,27)}function Rp(a){Ub(a,0,8192)}function Re(a){return!Hb(a)}function Oc(a){return a+1|0}function Mo(a,b){t[a+1|0]=b}function Mf(a){return a&255}function Li(a){return a+3|0}function LR(a,b){gc(a,b,32)}function KC(a,b){gc(a,b,38)}function IS(a,b){gc(a,b,52)}function IC(a,b){gi(a,b,37)}function Gb(a){return a+8|0}function GC(a,b){gc(a,b,41)}function Fu(a,b){gc(a,b,64)}function Fq(a,b){gc(a,b,12)}function Fo(a){v[a+12>>2]=0}function Eu(a,b){gc(a,b,66)}function EA(a,b){gc(a,b,33)}function Bj(a){return a-4|0}function Ay(a){Ub(a,0,4096)}function $u(a,b){gc(a,b,16)}function zc(a){v[a+8>>2]=0}function zN(a){gt(a,Td(a))}function xv(a,b){gc(a,b,3)}function xr(a){a=a|0;yr(a)}function xT(a){Ub(a,0,192)}function wd(a,b){v[a>>2]=b}function tl(a,b){Oo(a,b,0)}function tC(a,b){di(a,2,b)}function rB(a,b){gc(a,b,6)}function qu(a){aB(a,Td(a))}function qT(a){LA(a,Td(a))}function oba(a){a=a|0;kb=a}function oT(a){NA(a,Td(a))}function nQ(a){Qz(a,Td(a))}function nM(a){gy(a,Td(a))}function mQ(a){Rz(a,Td(a))}function kl(a){dz(a,Td(a))}function jR(a){Ub(a,0,146)}function iW(a){a=a|0;Kh(a)}function hQ(a){Ub(a,0,256)}function hA(a){Ub(a,0,130)}function gV(a){Ub(a,0,610)}function gU(a){Ub(a,0,157)}function fk(a,b){z[a>>2]=b}function fR(a){Ub(a,0,608)}function ev(){wq(7678);L()}function cn(a,b){gc(a,b,8)}function cd(){sV(7678);L()}function bU(a){Ub(a,0,206)}function ac(a){hn(v[a>>2])}function aL(a,b){KL(a,3,b)}function Zq(a,b){gc(a,b,1)}function Ym(a,b){gc(a,b,2)}function XT(a){Ub(a,0,236)}function WR(a){Ub(a,0,600)}function Rba(){return kb|0}function QR(a){Ub(a,0,126)}function QC(a){Ub(a,0,497)}function OT(a){bB(a,Td(a))}function Mi(a,b){u[a>>1]=b}function Lh(a,b){gc(a,b,4)}function KQ(a){Ub(a,0,204)}function Ic(a){a=a|0;Mb(a)}function Ho(a,b){gc(a,b,7)}function Go(a,b){gc(a,b,5)}function Ci(a){return a!=a}function CT(a){Ub(a,0,576)}function BO(a){_p(a,Td(a))}function AN(a){ft(a,Td(a))}function $t(a){yA(a,Td(a))}function zL(a){Sl(a,2048)}function xd(a,b){t[a|0]=b}function xR(a){Ub(a,0,96)}function rv(a){return a&1}function rU(a){Ub(a,0,98)}function oU(a){Ub(a,0,48)}function jm(a){zb(a+16|0)}function hr(a){Ub(a,0,36)}function d4(){return 2048}function Pj(a){Ab(a+16|0)}function NS(a){Ub(a,0,33)}function JC(a){Ub(a,0,38)}function IT(a){Ub(a,0,56)}function HS(a){Ub(a,0,52)}function HB(a){Ub(a,0,66)}function HA(a){Ub(a,0,80)}function FC(a){Ub(a,0,41)}function Au(a){Ub(a,0,64)}function yO(a){qe(a+8|0)}function qB(a,b){kc(a,b)}function pt(a,b){AM(a,b)}function li(a,b){Oh(a,b)}function jq(a,b){fc(a,b)}function gP(a,b){hP(a,b)}function cp(a,b){hE(a,b)}function cP(a,b){Wf(a,b)}function XB(a,b){eK(a,b)}function Vx(a,b){eg(a,b)}function VL(a,b){SM(a,b)}function Uc(a){ic(a+8|0)}function UR(a){cw(a,512)}function Tg(a){a=a|0;L()}function Su(a,b){kC(a,b)}function Rl(a,b){CV(a,b)}function Od(a,b){Hd(a,b)}function MA(a){Ab(a+4|0)}function JB(a,b){xk(a,b)}function DA(a,b){LS(a,b)}function Cs(a){zb(a+4|0)}function Bd(a){Bb(a+8|0)}function BR(a,b){je(a,b)}function BQ(a,b){ul(a,b)}function wr(a){_v(a,36)}function vo(a){RE(a,16)}function sC(a){cw(a,16)}function pE(a){Sl(a,24)}function kE(a){_v(a,48)}function Wg(a){_v(a,24)}function OU(a){Sl(a,48)}function No(a){RE(a,11)}function Nha(){va();L()}function Eh(a){t[a|0]=0}function yF(){wa();L()}function vM(a){ZM(a,0)}function sr(a){XD(a,0)}function sg(a){pT(a,0)}function mr(a){Sl(a,8)}function kO(a){Sl(a,7)}function ij(a){SJ(a,0)}function hj(a){QJ(a,0)}function gT(a){Sl(a,6)}function _S(a){cw(a,4)}function Xc(a){_e(a,0)}function Ni(a){Sl(a,2)}function MY(){yF();L()}function KA(a){eu(a,0)}function Cy(a){VM(a,0)}function By(a){UM(a,0)}function As(a){RJ(a,0)}function xQ(a){Le(a)}function uf(a){a=a|0}function uE(a){Cr(a)}function uC(a){Ak(a)}function tO(a){io(a)}function rJ(a){Ke(a)}function dc(a){Ab(a)}function dA(a){Ck(a)}function bp(a){Cc(a)}function Xb(a){zb(a)}function PP(a){Gc(a)}function Fm(a){wc(a)}function DQ(a){Tb(a)}
// EMSCRIPTEN_END_FUNCS
e=w;var ob=c([null,yc,iE,Pl,RX,kn,HX,zX,ZD,wX,rX,lD,IW,sW,jW,Vq,Ki,YV,$,gv,Hl,uH,Vg,Rm,Pja,xU,yf,Oia,Sha,Oha,Nha,Lha,vha,vA,Wga,Nga,cea,pga,FR,D1,C1,is,FR,Dca,kca,PO,tt,$p,Iba,zba,mba,lba,IB,kM,Bh,Kc,Kaa,eaa,nL,fL,Hx,qi,FK,h7,e7,$6,I6,x6,o1,n1,R0,dK,r4,wN,K3,F3,E3,jJ,Q2,B2,x2,p2,W1,R1,Q1,P1,M1,L1,qi,H1,E1,x1,p1,k1,f1,a1,V0,G0,ZG,y0,w0,q0,n0,VA,Tw,va,Qb,fY,eY,dY,cY,bY,aY,nn,$X,_X,ZG,ZX,YX,ha,WX,VX,UX,zp,TX,SX,QX,eE,dE,PX,Pv,OX,ap,LX,xr,$o,Ol,Sf,IX,ap,KX,JX,GX,NX,FX,bE,EX,bE,MX,cE,DX,CX,BX,nn,AX,dd,Qb,vX,Iv,uX,Vg,tX,YD,sX,Hk,YD,qr,qX,Gv,Fv,VW,pX,hX,gX,UW,Qi,PW,OW,uv,yD,NW,Iaa,Jaa,hO,Gaa,Haa,hy,Ys,$b,Laa,ae,vD,KW,JW,gD,GW,FW,gD,BW,jv,AW,Z9,cf,Oga,uba,HW,Rq,Of,MV,tba,aka,iaa,Y9,DC,CC,rW,qW,BC,pW,wg,oW,nW,Fc,mW,lW,xg,ph,kW,iW,fW,lC,eW,dW,cW,Xu,BP,PC,nJ,bW,aW,$V,_V,ZV,_u,XV,bC,Cd,Oq,UV,TV,Pu,Ou,RV,QV,PV,aC,OV,$B,Yu,NV,cv,HV,Eo,GV,Ob,_f,Sf,Gka,PB,Fka,pd,Hj,Eka,Dka,Cka,BV,AV,nd,Bka,Do,Aka,zka,yka,xV,wV,Qi,Iu,xka,wka,gca,vka,Qg,uka,tka,pka,Ej,ska,rka,oV,qka,Jh,zf,mka,lka,kka,bV,hka,Ej,Cj,gka,fka,Jq,eka,EB,aV,dka,cka,bka,LU,IU,Zja,Wja,tn,Uja,vg,fV,Vja,Xu,EU,Tja,Sja,xB,Rja,Fv,Qja,vB,AU,aU,Mja,Eo,uo,Lja,Kja,AV,Jja,Ija,Hja,wU,Gja,Um,Fja,Eja,Dja,Bja,Ej,vU,Cja,Jh,zf,DB,wja,tja,DC,pja,oja,nja,kja,Eo,jja,ija,yo,wU,hja,gja,Sf,fja,eja,dja,cja,bja,TT,aja,$ia,xE,_ia,Zia,Yia,_B,ST,Xia,Wia,Via,lca,Uia,RT,Tia,RT,qja,Sia,Ej,Jh,zf,Hh,Mia,Lia,Kia,Hia,Gia,Fia,Eia,Dia,yo,Cia,Bia,Aia,UA,CW,zia,yia,xia,wia,via,zW,uia,tia,sia,ria,vB,wT,qia,pia,Sf,oia,nia,GB,Nia,mia,lia,Pia,kia,jia,iia,RA,RA,QA,hia,gia,uT,RA,fia,gY,eia,dia,cia,bia,aia,$ha,_ha,rT,ud,po,Mha,IA,Zha,K9,J9,I9,H9,G9,F9,Yha,Xha,Wf,Wha,Vha,Uha,Tha,iE,fca,dca,V9,gaa,haa,Rha,Qha,Pha,Taa,D9,zp,bca,aca,$ba,_ba,Hha,Gha,Fha,Eha,Dha,Cha,Bha,Aha,zha,yha,xha,uha,tha,wha,MS,zf,FS,CA,qha,BA,pha,oha,nha,mha,AA,lha,jv,BC,kha,DS,CS,cr,zA,jha,of,iha,AS,yo,Vu,yo,ST,Yq,Sf,bV,yo,tn,fha,eha,dha,cha,uA,Zt,bha,aha,$ga,_ga,Zga,Yga,EC,Xga,Vga,Uga,Tga,Sga,Rga,Qga,Pga,OA,Mga,Lga,Kga,Sf,tT,sT,YA,Jga,Iga,Pu,Fv,Hga,Gga,Nba,Lq,Fga,Qm,Gu,Vh,sba,Sba,qt,oO,rba,qba,aO,lt,XN,pba,NN,XO,nba,sz,rj,ei,wga,vga,Xt,Dga,hu,sga,Qm,rga,qga,OR,po,oga,nga,NR,mga,lga,kga,Wt,jga,iga,hga,gga,bga,aA,aga,$fa,_fa,Ej,Jh,zf,ei,Xfa,Wfa,Vfa,Ufa,BA,Rfa,Qfa,Wt,Pfa,jaa,Mfa,Lfa,Cj,CR,aA,Yu,Kfa,Jfa,Ifa,Hfa,Ut,Gfa,Ut,Ffa,tr,DW,Cfa,Ej,Dfa,Efa,Yz,oR,Jh,zf,Xt,zfa,wfa,CA,vfa,sfa,rfa,cR,NR,UA,qfa,Pu,Sf,hfa,gfa,aC,ffa,efa,dfa,cfa,eB,Do,$ea,_ea,Zea,Yea,Xea,Wea,Am,yQ,Vea,Uea,Tea,Sea,Rea,Qea,Pea,Oea,Nea,Mea,Lea,Kea,Jea,BA,Iea,Hea,Gea,hu,Fea,Eea,Eo,Eba,Iv,BV,Mba,Lba,Eo,Kba,ei,Iv,Jba,Hba,Gba,Aea,zea,yea,xea,wea,vea,$q,sea,rea,qea,pea,oea,nea,mea,lea,kea,jea,iea,XX,lE,hea,Sf,gea,fea,Gl,Oba,mca,IB,jP,ica,hca,eca,cca,Zba,YO,Xba,Wba,RO,Vba,Uba,Tba,bo,DO,Qba,Pba,wo,Cba,Cj,iO,ur,Faa,Eaa,Daa,eba,EW,Caa,vv,ur,bC,Baa,iO,Aba,Aaa,Fba,Ej,Jh,zf,Dba,Ej,Jh,zf,Bba,Ej,Jh,zf,xba,oV,Lq,kba,jba,iba,hba,gba,fba,jca,dea,JP,dba,vc,bba,aaa,aba,yX,TW,MW,RW,_aa,Zaa,LW,SW,xX,QW,KM,Yaa,Xaa,Waa,JM,xy,Vaa,Uaa,Yba,Saa,Raa,Qaa,Paa,RL,T9,Ov,jE,qE,hy,Maa,zp,Hu,Uq,wba,yba,xaa,waa,Cj,vaa,aA,uaa,taa,saa,Xt,raa,ei,qaa,paa,oaa,naa,maa,Ej,Jh,zf,yaa,faa,daa,caa,baa,Oh,$l,$9,_9,X9,R9,Q9,P9,O9,N9,OL,U9,Ip,NL,Jk,Oh,Wf,L9,E9,M9,S9,B9,A9,T8,z9,ek,AL,Vf,LL,l9,U8,Xl,O8,qi,N8,iL,M8,hy,Jx,K8,uy,eL,q8,h8,a8,V7,N7,D7,G7,s7,l7,tK,Ms,d7,c7,b3,d3,U6,T6,R6,rK,Naa,f3,O6,tK,N6,M3,B3,P3,L6,J2,nK,Dx,J6,_3,_J,Z3,NJ,G6,d9,D6,E7,E6,v7,B6,xE,W3,z6,J3,lK,AS,kK,jK,iK,o6,m6,nK,Dx,j6,i6,h6,g6,f6,e6,d6,c6,b6,a6,$5,_5,Z5,Y5,X5,W5,V5,U5,T5,S5,R5,Q5,P5,O5,N5,K5,I5,G5,ND,D2,Q3,E5,p5,H3,n5,l5,el,F2,G2,j5,I2,c5,a5,W9,Z4,Dx,U4,R4,O4,Kn,E2,M4,K4,I4,G4,E4,C4,A4,y4,w4,u4,s4,p4,cK,k4,i4,FM,Yt,bK,f4,e4,c4,b4,a4,$3,Dp,vba,vr,oN,hh,U3,S3,ih,GN,O3,cba,L3,XY,Ir,I3,G3,C3,$aa,N3,V3,R3,Vv,aa,e3,UJ,TJ,c3,fJ,a3,$2,R2,H2,C2,A2,zM,eea,T1,S1,O1,N1,G1,F1,iH,hH,ZY,w1,v1,u1,t1,s1,r1,q1,i1,Vg,h1,yf,OY,YY,S0,hH,P0,ar,sH,Nw,Iw,z0,x0,Bw,Qh,Ph,Ur,Mb,Aw,rp,bj,Zk,zw,em,m0,l0,$i,bh,xG,_i,Qw,ww,Qh,Ph,Sr,cs,ak,g1,Hl,Dn,$i,bh,tG,_i,T$,O$,mH,J$,_r,Rm,E$,Pr,uf,m$,Yr,l$,k$,j$,fG,h$,f$,e$,Wk,d$,fG,b$,a$,__,Z_,W_,V_,R_,Q_,P_,O_,N_,M_,L_,K_,J_,I_,H_,G_,F_,E_,D_,C_,B_,A_,z_,y_,x_,w_,v_,u_,t_,s_,r_,q_,p_,o_,n_,m_,l_,k_,YZ,ZZ,_Z,f_,d_,b_,$Z,KZ,LZ,MZ,TZ,RZ,PZ,NZ,IB,Dea,yF,en,Wq,bea,aea,$da,_da,Zda,Yda,Xda,Wda,Vda,Uda,Tda,Sda,Rda,Qda,Pda,Oda,Nda,Mda,Lda,Kda,Jda,Ida,Hda,Gda,Fda,Eda,Dda,Cda,Bda,Ada,zda,yda,xda,wda,vda,uda,tda,sda,rda,qda,pda,oda,nda,mda,lda,kda,jda,ida,hda,gda,fda,eda,dda,cda,bda,ada,$ca,_ca,Zca,Yca,Xca,Wca,Vca,Uca,Tca,Sca,Rca,Qca,Pca,Oca,Nca,Mca,Lca,Kca,Jca,Ica,Hca,Gca,Fca,Eca,Cca,Bca,Aca,zca,yca,xca,wca,vca,uca,tca,sca,rca,qca,pca,oca,nca,en,uea,tea,Jia,Iia,ufa,tfa,nfa,mfa,sha,rha,fga,ega,Jha,Iha,JV,IV,Aja,zja,hW,gW,WV,VV,Zfa,Yfa,yfa,xfa,Cea,Bea,jka,ika,$ja,_ja,wW,vW,uW,tW,Ofa,Nfa,Bfa,Afa,uga,tga,Kha,EV,vja,uja,Ria,Qia,oka,nka,Oja,Nja,Tfa,Sfa,zaa,laa,kaa,mja,lja,sja,rja,yga,xga,bfa,afa,dga,cga,yja,xja,pfa,ofa,jfa,ifa,Yja,Xja,lfa,kfa,Ega,Aga,zga,yW,xW,LV,KV,hha,gha,Cga,Bga,mn,Wq,WW,Ic,Vo,sK,Ic,yf,Ic,mc,Ge,Ge,mc,mc,XW,kX,jX,YW,Ic,Vo,Ic,KD,fX,eX,dX,cX,bX,aX,$W,_W,ZW,Us,Sx,xL,wL,mc,uf,mc,mc,mc,Je,On,y9,x9,w9,v9,u9,si,Qx,Qx,Px,vL,Px,uL,Px,uL,uf,EV,t9,s9,r9,q9,p9,ri,tL,Q8,mc,mc,Ge,Ox,Ee,Ee,Ge,o9,n9,Je,uf,Je,uf,rL,k9,j9,mc,uf,mc,mc,mc,Je,i9,qL,h9,g9,f9,e9,si,c9,b9,a9,$8,_8,Z8,Y8,X8,W8,V8,ri,mL,mc,mc,Ge,Ee,Ee,Ge,pL,oL,If,Tg,MY,S8,Rx,R8,mc,P8,vL,B8,r8,i8,b8,W7,O7,F7,t7,m7,P7,C9,m9,L8,Us,Sx,wL,mc,uf,mc,mc,mc,Je,hL,J8,I8,H8,G8,F8,si,E8,ri,gL,mc,mc,Ge,Ee,Ee,Ge,D8,C8,WK,p8,o8,mc,uf,mc,mc,mc,Je,n8,m8,l8,k8,si,j8,ri,SK,mc,mc,Ge,Ee,Ee,Ns,g8,mc,uf,mc,mc,mc,Je,RK,f8,e8,d8,si,c8,ri,PK,mc,mc,Ge,Ee,Ee,Us,Sx,$7,mc,uf,mc,mc,mc,Je,RK,_7,Z7,Y7,si,X7,ri,NK,mc,mc,Ge,Ee,Ee,dL,cL,U7,mc,uf,mc,mc,mc,Je,bL,T7,y8,x8,si,w8,ri,v8,mc,mc,Ge,Ee,Ee,Je,uf,$K,S7,R7,_K,Q7,ZK,YK,cL,A8,bL,z8,$K,u8,t8,_K,s8,ZK,YK,Ns,M7,mc,uf,mc,mc,mc,Je,Ee,L7,K7,J7,si,I7,ri,H7,mc,mc,Ge,Ee,Ee,KK,C7,B7,mc,uf,mc,mc,A7,Je,z7,y7,x7,w7,si,u7,ri,Ex,mc,mc,Ge,Ee,Ee,Je,uf,Ns,r7,mc,uf,mc,mc,mc,Je,hL,q7,p7,o7,si,n7,ri,EK,mc,mc,Ge,Ee,Ee,Ns,k7,mc,uf,mc,mc,mc,Je,On,j7,i7,g7,si,f7,ri,CK,mc,mc,Ge,Ee,Ee,YJ,Ic,Y3,Ax,X3,Ax,Ax,Tg,xs,A3,T3,yf,Tg,yf,Ic,z3,y3,Tg,EJ,DJ,EJ,DJ,Je,ys,Je,ys,HJ,GJ,HJ,GJ,Ic,D3,yf,Ic,x3,w3,Ic,wJ,vJ,Tg,t3,sJ,s3,sJ,v3,tJ,u3,tJ,Ic,r3,q3,Ic,qJ,pJ,us,us,us,us,p3,sx,sx,sx,Ic,o3,n3,Ic,oJ,mJ,k3,kJ,j3,kJ,m3,lJ,l3,lJ,Ic,i3,h3,Ic,iJ,hJ,ts,ts,ts,ts,g3,rx,rx,rx,K2,Ic,Vo,Ic,_I,P2,Ge,Ge,O2,N2,Wq,M2,L2,Tg,Tg,S2,Ic,Vo,Ic,eJ,_2,Ge,mc,Ge,Z2,Y2,X2,W2,V2,U2,T2,Tg,iX,Ic,Vo,Ic,Ic,oX,Ge,Ge,Wq,SD,nX,mX,lX,Je,ys,Je,ys,xp,rs,z2,y2,SI,RI,QI,PI,OI,NI,MI,LI,KI,JI,II,HI,GI,FI,EI,DI,CI,BI,AI,zI,yI,xI,wI,w2,v2,u2,t2,s2,r2,q2,o2,n2,m2,l2,k2,j2,i2,h2,g2,f2,e2,d2,c2,b2,a2,$1,_1,Z1,Y1,X1,V1,U1,yf,Tg,yf,Tg,yf,Tg,yf,Tg,K1,J1,I1,Mn,Vw,Je,HH,GH,FH,mc,mc,A1,EH,z1,gs,y1,gs,ds,Rw,Je,HH,GH,FH,mc,mc,m1,EH,l1,gs,j1,gs,Hs,$0,b1,_0,e1,d1,c1,Cp,kH,Z0,Y0,es,Sw,wH,vH,sf,jH,X0,W0,fs,Uw,CH,BH,yf,Ic,U0,WY,VY,UY,T0,en,B1,mc,Q0,Vw,D0,C0,B0,A0,hK,Ww,_k,Ww,Vw,H0,bH,F0,E0,Rw,L0,K0,J0,I0,fs,Uw,CH,BH,hK,Ww,Rw,O0,bH,N0,M0,es,Sw,wH,vH,BF,_Y,xL,CF,gZ,fZ,eZ,dZ,cZ,EF,bZ,aZ,$Y,JF,zZ,yZ,xZ,wZ,vZ,mc,uZ,tZ,QF,FZ,EZ,DZ,CZ,BZ,AZ,RF,JZ,SD,SV,IZ,HZ,GZ,yf,Ic,Ic,rZ,qZ,pZ,oZ,nZ,mZ,lZ,kZ,EF,jZ,iZ,hZ,Ic,GF,GF,lp,Ge,Ge,sZ,Ge,Ic,MF,LF,lp,mc,mc,KF,On,Ic,MF,LF,lp,mc,mc,KF,On,Ic,PF,OF,lp,mc,mc,NF,On,Ic,PF,OF,lp,mc,mc,NF,On,yf,Ic,v0,u0,t0,yf,Ic,s0,r0,p0,Ic,o0,k0,j0,i0,BG,BG,h0,g0,f0,e0,d0,Ic,c0,b0,a0,$$,sG,sG,_$,Z$,Y$,X$,W$,Ic,V$,U$,S$,R$,Q$,P$,N$,M$,Ic,L$,K$,I$,H$,G$,F$,D$,C$,yf,Ic,Ee,B$,A$,z$,y$,x$,w$,XZ,WZ,VZ,UZ,SZ,QZ,OZ,yf,Ic,Ee,v$,u$,t$,s$,r$,q$,j_,i_,h_,g_,e_,c_,a_,qw,SF,p$,qw,SF,o$,Ic,Or,Or,Nh,Nh,Nh,hG,mc,Sk,Sk,Ic,Or,Or,Nh,Nh,Nh,hG,mc,Sk,Sk,Ic,Nr,Nr,Nh,Nh,Nh,gG,mc,Sk,Sk,Ic,Nr,Nr,Nh,Nh,Nh,gG,mc,Sk,Sk,Ic,n$,i$,Ic,g$,c$,Ic,$_,Y_,Ic,X_,U_,Ic,YF,T_,Je,Ic,YF,S_,Je,yf,Tg,Ic,TY,SY,Ic,RY,PY,QY,en,Tg,Ic,NY,wa,yf,Ic,uf,uf,LY,DY,FY,GY,Ic,yY,Ic,xY,mn,en,mn,mn,mn,mn,en,Ic,wY,Ic,CY,EY,HY,Ic,KY,JY,IY,Ic,zY]);function pb(){return s.byteLength/65536|0}function ub(vb){vb=vb|0;var qb=pb()|0;var rb=qb+vb|0;if(qb<rb&&rb<65536){var sb=new ArrayBuffer(B(rb,65536));var tb=new Int8Array(sb);tb.set(t);t=new Int8Array(sb);u=new Int16Array(sb);v=new Int32Array(sb);w=new Uint8Array(sb);x=new Uint16Array(sb);y=new Uint32Array(sb);z=new Float32Array(sb);A=new Float64Array(sb);s=sb;r.buffer=s;e=w}return qb}return{"za":FV,"Aa":W6,"Ba":X6,"Ca":Ic,"Da":Mb,"Ea":V6,"Fa":S6,"Ga":Q6,"Ha":Ms,"Ia":Je,"Ja":Z6,"Ka":Y6,"La":b7,"Ma":Qx,"Na":_6,"Oa":sK,"Pa":a7,"Qa":yf,"Ra":vK,"Sa":uK,"Ta":vK,"Ua":d4,"Va":vY,"Wa":uY,"Xa":tY,"Ya":P6,"Za":pK,"_a":M6,"$a":oK,"ab":u6,"bb":m4,"cb":n4,"db":s6,"eb":r6,"fb":q6,"gb":t6,"hb":o4,"ib":Q4,"jb":g4,"kb":T4,"lb":q5,"mb":j4,"nb":W4,"ob":l4,"pb":V4,"qb":h4,"rb":v4,"sb":q4,"tb":t4,"ub":J4,"vb":F4,"wb":H4,"xb":x4,"yb":z4,"zb":B4,"Ab":D4,"Bb":k5,"Cb":m5,"Db":y5,"Eb":t5,"Fb":s5,"Gb":r5,"Hb":x5,"Ib":w5,"Jb":u5,"Kb":v5,"Lb":C5,"Mb":D5,"Nb":z5,"Ob":B5,"Pb":A5,"Qb":d5,"Rb":i5,"Sb":g5,"Tb":f5,"Ub":h5,"Vb":e5,"Wb":P4,"Xb":H5,"Yb":b5,"Zb":_4,"_b":o5,"$b":S4,"ac":$4,"bc":Y4,"cc":X4,"dc":J5,"ec":L4,"fc":L5,"gc":N4,"hc":F5,"ic":K6,"jc":H6,"kc":sY,"lc":F6,"mc":C6,"nc":A6,"oc":y6,"pc":rY,"qc":w6,"rc":v6,"sc":p6,"tc":n6,"uc":l6,"vc":M5,"wc":k6,"xc":Pd,"yc":ob,"zc":Oaa,"Ac":Rba,"Bc":oba,"Cc":BY,"Dc":AY,"Ec":qY,"Fc":pY,"Gc":oY,"Hc":nY,"Ic":mY,"Jc":lY,"Kc":iY,"Lc":kY,"Mc":jY,"Nc":iY,"Oc":hY,"Pc":hY}}return wb(yb)}
// EMSCRIPTEN_END_ASM




)(asmLibraryArg);
  },

  instantiate: /** @suppress{checkTypes} */ function(binary, info) {
    return {
      then: function(ok) {
        var module = new WebAssembly.Module(binary);
        ok({
          'instance': new WebAssembly.Instance(module)
        });
        // Emulate a simple WebAssembly.instantiate(..).then(()=>{}).catch(()=>{}) syntax.
        return { catch: function() {} };
      }
    };
  },

  RuntimeError: Error
};

// We don't need to actually download a wasm binary, mark it as present but empty.
wasmBinary = [];


